/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * @lightSyntaxTransform
 * @noflow
 * @nolint
 * @preventMunge
 * @preserve-invariant-messages
 */

"use no memo";
'use strict';
Object.defineProperty(exports, '__esModule', {value: true});
var require$$0$2 = require('tty');
var require$$1$1 = require('util');
var t$d = require('@babel/types');
var require$$0$3 = require('os');
var require$$0$5 = require('path');
var require$$0$4 = require('fs');
var require$$0$6 = require('buffer');
var crypto$2 = require('crypto');
function _interopNamespaceDefault(e) {
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(
          n,
          k,
          d.get
            ? d
            : {
                enumerable: true,
                get: function () {
                  return e[k];
                },
              }
        );
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}
var t__namespace = _interopNamespaceDefault(t$d);
var commonjsGlobal =
  typeof globalThis !== 'undefined'
    ? globalThis
    : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
        ? global
        : typeof self !== 'undefined'
          ? self
          : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default')
    ? x['default']
    : x;
}
function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var f = n.default;
  if (typeof f == 'function') {
    var a = function a() {
      if (this instanceof a) {
        return Reflect.construct(f, arguments, this.constructor);
      }
      return f.apply(this, arguments);
    };
    a.prototype = f.prototype;
  } else a = {};
  Object.defineProperty(a, '__esModule', {value: true});
  Object.keys(n).forEach(function (k) {
    var d = Object.getOwnPropertyDescriptor(n, k);
    Object.defineProperty(
      a,
      k,
      d.get
        ? d
        : {
            enumerable: true,
            get: function () {
              return n[k];
            },
          }
    );
  });
  return a;
}
var lib$p = {};
var file = {};
var lib$o = {};
var lib$n = {};
var context$3 = {};
var traverseNode = {};
var context$2 = {};
var path$3 = {};
var virtualTypes$1 = {};
var hasRequiredVirtualTypes$1;
function requireVirtualTypes$1() {
  if (hasRequiredVirtualTypes$1) return virtualTypes$1;
  hasRequiredVirtualTypes$1 = 1;
  Object.defineProperty(virtualTypes$1, '__esModule', {value: true});
  virtualTypes$1.Var =
    virtualTypes$1.User =
    virtualTypes$1.Statement =
    virtualTypes$1.SpreadProperty =
    virtualTypes$1.Scope =
    virtualTypes$1.RestProperty =
    virtualTypes$1.ReferencedMemberExpression =
    virtualTypes$1.ReferencedIdentifier =
    virtualTypes$1.Referenced =
    virtualTypes$1.Pure =
    virtualTypes$1.NumericLiteralTypeAnnotation =
    virtualTypes$1.Generated =
    virtualTypes$1.ForAwaitStatement =
    virtualTypes$1.Flow =
    virtualTypes$1.Expression =
    virtualTypes$1.ExistentialTypeParam =
    virtualTypes$1.BlockScoped =
    virtualTypes$1.BindingIdentifier =
      void 0;
  virtualTypes$1.ReferencedIdentifier = ['Identifier', 'JSXIdentifier'];
  virtualTypes$1.ReferencedMemberExpression = ['MemberExpression'];
  virtualTypes$1.BindingIdentifier = ['Identifier'];
  virtualTypes$1.Statement = ['Statement'];
  virtualTypes$1.Expression = ['Expression'];
  virtualTypes$1.Scope = ['Scopable', 'Pattern'];
  virtualTypes$1.Referenced = null;
  virtualTypes$1.BlockScoped = null;
  virtualTypes$1.Var = ['VariableDeclaration'];
  virtualTypes$1.User = null;
  virtualTypes$1.Generated = null;
  virtualTypes$1.Pure = null;
  virtualTypes$1.Flow = [
    'Flow',
    'ImportDeclaration',
    'ExportDeclaration',
    'ImportSpecifier',
  ];
  virtualTypes$1.RestProperty = ['RestElement'];
  virtualTypes$1.SpreadProperty = ['RestElement'];
  virtualTypes$1.ExistentialTypeParam = ['ExistsTypeAnnotation'];
  virtualTypes$1.NumericLiteralTypeAnnotation = ['NumberLiteralTypeAnnotation'];
  virtualTypes$1.ForAwaitStatement = ['ForOfStatement'];
  return virtualTypes$1;
}
var src$1 = {exports: {}};
var browser$3 = {exports: {}};
var ms;
var hasRequiredMs;
function requireMs() {
  if (hasRequiredMs) return ms;
  hasRequiredMs = 1;
  var s = 1e3;
  var m = s * 60;
  var h = m * 60;
  var d = h * 24;
  var w = d * 7;
  var y = d * 365.25;
  ms = function (val, options) {
    options = options || {};
    var type = typeof val;
    if (type === 'string' && val.length > 0) {
      return parse(val);
    } else if (type === 'number' && isFinite(val)) {
      return options.long ? fmtLong(val) : fmtShort(val);
    }
    throw new Error(
      'val is not a non-empty string or a valid number. val=' +
        JSON.stringify(val)
    );
  };
  function parse(str) {
    str = String(str);
    if (str.length > 100) {
      return;
    }
    var match =
      /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
        str
      );
    if (!match) {
      return;
    }
    var n = parseFloat(match[1]);
    var type = (match[2] || 'ms').toLowerCase();
    switch (type) {
      case 'years':
      case 'year':
      case 'yrs':
      case 'yr':
      case 'y':
        return n * y;
      case 'weeks':
      case 'week':
      case 'w':
        return n * w;
      case 'days':
      case 'day':
      case 'd':
        return n * d;
      case 'hours':
      case 'hour':
      case 'hrs':
      case 'hr':
      case 'h':
        return n * h;
      case 'minutes':
      case 'minute':
      case 'mins':
      case 'min':
      case 'm':
        return n * m;
      case 'seconds':
      case 'second':
      case 'secs':
      case 'sec':
      case 's':
        return n * s;
      case 'milliseconds':
      case 'millisecond':
      case 'msecs':
      case 'msec':
      case 'ms':
        return n;
      default:
        return undefined;
    }
  }
  function fmtShort(ms) {
    var msAbs = Math.abs(ms);
    if (msAbs >= d) {
      return Math.round(ms / d) + 'd';
    }
    if (msAbs >= h) {
      return Math.round(ms / h) + 'h';
    }
    if (msAbs >= m) {
      return Math.round(ms / m) + 'm';
    }
    if (msAbs >= s) {
      return Math.round(ms / s) + 's';
    }
    return ms + 'ms';
  }
  function fmtLong(ms) {
    var msAbs = Math.abs(ms);
    if (msAbs >= d) {
      return plural(ms, msAbs, d, 'day');
    }
    if (msAbs >= h) {
      return plural(ms, msAbs, h, 'hour');
    }
    if (msAbs >= m) {
      return plural(ms, msAbs, m, 'minute');
    }
    if (msAbs >= s) {
      return plural(ms, msAbs, s, 'second');
    }
    return ms + ' ms';
  }
  function plural(ms, msAbs, n, name) {
    var isPlural = msAbs >= n * 1.5;
    return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
  }
  return ms;
}
var common;
var hasRequiredCommon;
function requireCommon() {
  if (hasRequiredCommon) return common;
  hasRequiredCommon = 1;
  function setup(env) {
    createDebug.debug = createDebug;
    createDebug.default = createDebug;
    createDebug.coerce = coerce;
    createDebug.disable = disable;
    createDebug.enable = enable;
    createDebug.enabled = enabled;
    createDebug.humanize = requireMs();
    createDebug.destroy = destroy;
    Object.keys(env).forEach(key => {
      createDebug[key] = env[key];
    });
    createDebug.names = [];
    createDebug.skips = [];
    createDebug.formatters = {};
    function selectColor(namespace) {
      let hash = 0;
      for (let i = 0; i < namespace.length; i++) {
        hash = (hash << 5) - hash + namespace.charCodeAt(i);
        hash |= 0;
      }
      return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
    }
    createDebug.selectColor = selectColor;
    function createDebug(namespace) {
      let prevTime;
      let enableOverride = null;
      let namespacesCache;
      let enabledCache;
      function debug(...args) {
        if (!debug.enabled) {
          return;
        }
        const self = debug;
        const curr = Number(new Date());
        const ms = curr - (prevTime || curr);
        self.diff = ms;
        self.prev = prevTime;
        self.curr = curr;
        prevTime = curr;
        args[0] = createDebug.coerce(args[0]);
        if (typeof args[0] !== 'string') {
          args.unshift('%O');
        }
        let index = 0;
        args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
          if (match === '%%') {
            return '%';
          }
          index++;
          const formatter = createDebug.formatters[format];
          if (typeof formatter === 'function') {
            const val = args[index];
            match = formatter.call(self, val);
            args.splice(index, 1);
            index--;
          }
          return match;
        });
        createDebug.formatArgs.call(self, args);
        const logFn = self.log || createDebug.log;
        logFn.apply(self, args);
      }
      debug.namespace = namespace;
      debug.useColors = createDebug.useColors();
      debug.color = createDebug.selectColor(namespace);
      debug.extend = extend;
      debug.destroy = createDebug.destroy;
      Object.defineProperty(debug, 'enabled', {
        enumerable: true,
        configurable: false,
        get: () => {
          if (enableOverride !== null) {
            return enableOverride;
          }
          if (namespacesCache !== createDebug.namespaces) {
            namespacesCache = createDebug.namespaces;
            enabledCache = createDebug.enabled(namespace);
          }
          return enabledCache;
        },
        set: v => {
          enableOverride = v;
        },
      });
      if (typeof createDebug.init === 'function') {
        createDebug.init(debug);
      }
      return debug;
    }
    function extend(namespace, delimiter) {
      const newDebug = createDebug(
        this.namespace +
          (typeof delimiter === 'undefined' ? ':' : delimiter) +
          namespace
      );
      newDebug.log = this.log;
      return newDebug;
    }
    function enable(namespaces) {
      createDebug.save(namespaces);
      createDebug.namespaces = namespaces;
      createDebug.names = [];
      createDebug.skips = [];
      let i;
      const split = (typeof namespaces === 'string' ? namespaces : '').split(
        /[\s,]+/
      );
      const len = split.length;
      for (i = 0; i < len; i++) {
        if (!split[i]) {
          continue;
        }
        namespaces = split[i].replace(/\*/g, '.*?');
        if (namespaces[0] === '-') {
          createDebug.skips.push(new RegExp('^' + namespaces.slice(1) + '$'));
        } else {
          createDebug.names.push(new RegExp('^' + namespaces + '$'));
        }
      }
    }
    function disable() {
      const namespaces = [
        ...createDebug.names.map(toNamespace),
        ...createDebug.skips.map(toNamespace).map(namespace => '-' + namespace),
      ].join(',');
      createDebug.enable('');
      return namespaces;
    }
    function enabled(name) {
      if (name[name.length - 1] === '*') {
        return true;
      }
      let i;
      let len;
      for (i = 0, len = createDebug.skips.length; i < len; i++) {
        if (createDebug.skips[i].test(name)) {
          return false;
        }
      }
      for (i = 0, len = createDebug.names.length; i < len; i++) {
        if (createDebug.names[i].test(name)) {
          return true;
        }
      }
      return false;
    }
    function toNamespace(regexp) {
      return regexp
        .toString()
        .substring(2, regexp.toString().length - 2)
        .replace(/\.\*\?$/, '*');
    }
    function coerce(val) {
      if (val instanceof Error) {
        return val.stack || val.message;
      }
      return val;
    }
    function destroy() {
      console.warn(
        'Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.'
      );
    }
    createDebug.enable(createDebug.load());
    return createDebug;
  }
  common = setup;
  return common;
}
var hasRequiredBrowser$1;
function requireBrowser$1() {
  if (hasRequiredBrowser$1) return browser$3.exports;
  hasRequiredBrowser$1 = 1;
  (function (module, exports) {
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = localstorage();
    exports.destroy = (() => {
      let warned = false;
      return () => {
        if (!warned) {
          warned = true;
          console.warn(
            'Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.'
          );
        }
      };
    })();
    exports.colors = [
      '#0000CC',
      '#0000FF',
      '#0033CC',
      '#0033FF',
      '#0066CC',
      '#0066FF',
      '#0099CC',
      '#0099FF',
      '#00CC00',
      '#00CC33',
      '#00CC66',
      '#00CC99',
      '#00CCCC',
      '#00CCFF',
      '#3300CC',
      '#3300FF',
      '#3333CC',
      '#3333FF',
      '#3366CC',
      '#3366FF',
      '#3399CC',
      '#3399FF',
      '#33CC00',
      '#33CC33',
      '#33CC66',
      '#33CC99',
      '#33CCCC',
      '#33CCFF',
      '#6600CC',
      '#6600FF',
      '#6633CC',
      '#6633FF',
      '#66CC00',
      '#66CC33',
      '#9900CC',
      '#9900FF',
      '#9933CC',
      '#9933FF',
      '#99CC00',
      '#99CC33',
      '#CC0000',
      '#CC0033',
      '#CC0066',
      '#CC0099',
      '#CC00CC',
      '#CC00FF',
      '#CC3300',
      '#CC3333',
      '#CC3366',
      '#CC3399',
      '#CC33CC',
      '#CC33FF',
      '#CC6600',
      '#CC6633',
      '#CC9900',
      '#CC9933',
      '#CCCC00',
      '#CCCC33',
      '#FF0000',
      '#FF0033',
      '#FF0066',
      '#FF0099',
      '#FF00CC',
      '#FF00FF',
      '#FF3300',
      '#FF3333',
      '#FF3366',
      '#FF3399',
      '#FF33CC',
      '#FF33FF',
      '#FF6600',
      '#FF6633',
      '#FF9900',
      '#FF9933',
      '#FFCC00',
      '#FFCC33',
    ];
    function useColors() {
      if (
        typeof window !== 'undefined' &&
        window.process &&
        (window.process.type === 'renderer' || window.process.__nwjs)
      ) {
        return true;
      }
      if (
        typeof navigator !== 'undefined' &&
        navigator.userAgent &&
        navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)
      ) {
        return false;
      }
      return (
        (typeof document !== 'undefined' &&
          document.documentElement &&
          document.documentElement.style &&
          document.documentElement.style.WebkitAppearance) ||
        (typeof window !== 'undefined' &&
          window.console &&
          (window.console.firebug ||
            (window.console.exception && window.console.table))) ||
        (typeof navigator !== 'undefined' &&
          navigator.userAgent &&
          navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) &&
          parseInt(RegExp.$1, 10) >= 31) ||
        (typeof navigator !== 'undefined' &&
          navigator.userAgent &&
          navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/))
      );
    }
    function formatArgs(args) {
      args[0] =
        (this.useColors ? '%c' : '') +
        this.namespace +
        (this.useColors ? ' %c' : ' ') +
        args[0] +
        (this.useColors ? '%c ' : ' ') +
        '+' +
        module.exports.humanize(this.diff);
      if (!this.useColors) {
        return;
      }
      const c = 'color: ' + this.color;
      args.splice(1, 0, c, 'color: inherit');
      let index = 0;
      let lastC = 0;
      args[0].replace(/%[a-zA-Z%]/g, match => {
        if (match === '%%') {
          return;
        }
        index++;
        if (match === '%c') {
          lastC = index;
        }
      });
      args.splice(lastC, 0, c);
    }
    exports.log = console.debug || console.log || (() => {});
    function save(namespaces) {
      try {
        if (namespaces) {
          exports.storage.setItem('debug', namespaces);
        } else {
          exports.storage.removeItem('debug');
        }
      } catch (error) {}
    }
    function load() {
      let r;
      try {
        r = exports.storage.getItem('debug');
      } catch (error) {}
      if (!r && typeof process !== 'undefined' && 'env' in process) {
        r = process.env.DEBUG;
      }
      return r;
    }
    function localstorage() {
      try {
        return localStorage;
      } catch (error) {}
    }
    module.exports = requireCommon()(exports);
    const {formatters: formatters} = module.exports;
    formatters.j = function (v) {
      try {
        return JSON.stringify(v);
      } catch (error) {
        return '[UnexpectedJSONParseError]: ' + error.message;
      }
    };
  })(browser$3, browser$3.exports);
  return browser$3.exports;
}
var node$4 = {exports: {}};
var browser$2;
var hasRequiredBrowser;
function requireBrowser() {
  if (hasRequiredBrowser) return browser$2;
  hasRequiredBrowser = 1;
  function getChromeVersion() {
    const matches = /(Chrome|Chromium)\/(?<chromeVersion>\d+)\./.exec(
      navigator.userAgent
    );
    if (!matches) {
      return;
    }
    return Number.parseInt(matches.groups.chromeVersion, 10);
  }
  const colorSupport =
    getChromeVersion() >= 69
      ? {level: 1, hasBasic: true, has256: false, has16m: false}
      : false;
  browser$2 = {stdout: colorSupport, stderr: colorSupport};
  return browser$2;
}
var hasRequiredNode$2;
function requireNode$2() {
  if (hasRequiredNode$2) return node$4.exports;
  hasRequiredNode$2 = 1;
  (function (module, exports) {
    const tty = require$$0$2;
    const util = require$$1$1;
    exports.init = init;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.destroy = util.deprecate(
      () => {},
      'Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.'
    );
    exports.colors = [6, 2, 3, 4, 5, 1];
    try {
      const supportsColor = requireBrowser();
      if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
        exports.colors = [
          20, 21, 26, 27, 32, 33, 38, 39, 40, 41, 42, 43, 44, 45, 56, 57, 62,
          63, 68, 69, 74, 75, 76, 77, 78, 79, 80, 81, 92, 93, 98, 99, 112, 113,
          128, 129, 134, 135, 148, 149, 160, 161, 162, 163, 164, 165, 166, 167,
          168, 169, 170, 171, 172, 173, 178, 179, 184, 185, 196, 197, 198, 199,
          200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 214, 215, 220, 221,
        ];
      }
    } catch (error) {}
    exports.inspectOpts = Object.keys(process.env)
      .filter(key => /^debug_/i.test(key))
      .reduce((obj, key) => {
        const prop = key
          .substring(6)
          .toLowerCase()
          .replace(/_([a-z])/g, (_, k) => k.toUpperCase());
        let val = process.env[key];
        if (/^(yes|on|true|enabled)$/i.test(val)) {
          val = true;
        } else if (/^(no|off|false|disabled)$/i.test(val)) {
          val = false;
        } else if (val === 'null') {
          val = null;
        } else {
          val = Number(val);
        }
        obj[prop] = val;
        return obj;
      }, {});
    function useColors() {
      return 'colors' in exports.inspectOpts
        ? Boolean(exports.inspectOpts.colors)
        : tty.isatty(process.stderr.fd);
    }
    function formatArgs(args) {
      const {namespace: name, useColors: useColors} = this;
      if (useColors) {
        const c = this.color;
        const colorCode = '[3' + (c < 8 ? c : '8;5;' + c);
        const prefix = `  ${colorCode};1m${name} [0m`;
        args[0] = prefix + args[0].split('\n').join('\n' + prefix);
        args.push(
          colorCode + 'm+' + module.exports.humanize(this.diff) + '[0m'
        );
      } else {
        args[0] = getDate() + name + ' ' + args[0];
      }
    }
    function getDate() {
      if (exports.inspectOpts.hideDate) {
        return '';
      }
      return new Date().toISOString() + ' ';
    }
    function log(...args) {
      return process.stderr.write(util.format(...args) + '\n');
    }
    function save(namespaces) {
      if (namespaces) {
        process.env.DEBUG = namespaces;
      } else {
        delete process.env.DEBUG;
      }
    }
    function load() {
      return process.env.DEBUG;
    }
    function init(debug) {
      debug.inspectOpts = {};
      const keys = Object.keys(exports.inspectOpts);
      for (let i = 0; i < keys.length; i++) {
        debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
      }
    }
    module.exports = requireCommon()(exports);
    const {formatters: formatters} = module.exports;
    formatters.o = function (v) {
      this.inspectOpts.colors = this.useColors;
      return util
        .inspect(v, this.inspectOpts)
        .split('\n')
        .map(str => str.trim())
        .join(' ');
    };
    formatters.O = function (v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts);
    };
  })(node$4, node$4.exports);
  return node$4.exports;
}
var hasRequiredSrc$1;
function requireSrc$1() {
  if (hasRequiredSrc$1) return src$1.exports;
  hasRequiredSrc$1 = 1;
  if (
    typeof process === 'undefined' ||
    process.type === 'renderer' ||
    process.browser === true ||
    process.__nwjs
  ) {
    src$1.exports = requireBrowser$1();
  } else {
    src$1.exports = requireNode$2();
  }
  return src$1.exports;
}
var scope$1 = {};
var renamer$1 = {};
var visitors$1 = {};
var virtualTypesValidator = {};
var hasRequiredVirtualTypesValidator;
function requireVirtualTypesValidator() {
  if (hasRequiredVirtualTypesValidator) return virtualTypesValidator;
  hasRequiredVirtualTypesValidator = 1;
  Object.defineProperty(virtualTypesValidator, '__esModule', {value: true});
  virtualTypesValidator.isBindingIdentifier = isBindingIdentifier;
  virtualTypesValidator.isBlockScoped = isBlockScoped;
  virtualTypesValidator.isExpression = isExpression;
  virtualTypesValidator.isFlow = isFlow;
  virtualTypesValidator.isForAwaitStatement = isForAwaitStatement;
  virtualTypesValidator.isGenerated = isGenerated;
  virtualTypesValidator.isPure = isPure;
  virtualTypesValidator.isReferenced = isReferenced;
  virtualTypesValidator.isReferencedIdentifier = isReferencedIdentifier;
  virtualTypesValidator.isReferencedMemberExpression =
    isReferencedMemberExpression;
  virtualTypesValidator.isRestProperty = isRestProperty;
  virtualTypesValidator.isScope = isScope;
  virtualTypesValidator.isSpreadProperty = isSpreadProperty;
  virtualTypesValidator.isStatement = isStatement;
  virtualTypesValidator.isUser = isUser;
  virtualTypesValidator.isVar = isVar;
  var _t = t$d;
  const {
    isBinding: isBinding,
    isBlockScoped: nodeIsBlockScoped,
    isExportDeclaration: isExportDeclaration,
    isExpression: nodeIsExpression,
    isFlow: nodeIsFlow,
    isForStatement: isForStatement,
    isForXStatement: isForXStatement,
    isIdentifier: isIdentifier,
    isImportDeclaration: isImportDeclaration,
    isImportSpecifier: isImportSpecifier,
    isJSXIdentifier: isJSXIdentifier,
    isJSXMemberExpression: isJSXMemberExpression,
    isMemberExpression: isMemberExpression,
    isRestElement: nodeIsRestElement,
    isReferenced: nodeIsReferenced,
    isScope: nodeIsScope,
    isStatement: nodeIsStatement,
    isVar: nodeIsVar,
    isVariableDeclaration: isVariableDeclaration,
    react: react,
    isForOfStatement: isForOfStatement,
  } = _t;
  const {isCompatTag: isCompatTag} = react;
  function isReferencedIdentifier(opts) {
    const {node: node, parent: parent} = this;
    if (!isIdentifier(node, opts) && !isJSXMemberExpression(parent, opts)) {
      if (isJSXIdentifier(node, opts)) {
        if (isCompatTag(node.name)) return false;
      } else {
        return false;
      }
    }
    return nodeIsReferenced(node, parent, this.parentPath.parent);
  }
  function isReferencedMemberExpression() {
    const {node: node, parent: parent} = this;
    return isMemberExpression(node) && nodeIsReferenced(node, parent);
  }
  function isBindingIdentifier() {
    const {node: node, parent: parent} = this;
    const grandparent = this.parentPath.parent;
    return isIdentifier(node) && isBinding(node, parent, grandparent);
  }
  function isStatement() {
    const {node: node, parent: parent} = this;
    if (nodeIsStatement(node)) {
      if (isVariableDeclaration(node)) {
        if (isForXStatement(parent, {left: node})) return false;
        if (isForStatement(parent, {init: node})) return false;
      }
      return true;
    } else {
      return false;
    }
  }
  function isExpression() {
    if (this.isIdentifier()) {
      return this.isReferencedIdentifier();
    } else {
      return nodeIsExpression(this.node);
    }
  }
  function isScope() {
    return nodeIsScope(this.node, this.parent);
  }
  function isReferenced() {
    return nodeIsReferenced(this.node, this.parent);
  }
  function isBlockScoped() {
    return nodeIsBlockScoped(this.node);
  }
  function isVar() {
    return nodeIsVar(this.node);
  }
  function isUser() {
    return this.node && !!this.node.loc;
  }
  function isGenerated() {
    return !this.isUser();
  }
  function isPure(constantsOnly) {
    return this.scope.isPure(this.node, constantsOnly);
  }
  function isFlow() {
    const {node: node} = this;
    if (nodeIsFlow(node)) {
      return true;
    } else if (isImportDeclaration(node)) {
      return node.importKind === 'type' || node.importKind === 'typeof';
    } else if (isExportDeclaration(node)) {
      return node.exportKind === 'type';
    } else if (isImportSpecifier(node)) {
      return node.importKind === 'type' || node.importKind === 'typeof';
    } else {
      return false;
    }
  }
  function isRestProperty() {
    var _this$parentPath;
    return (
      nodeIsRestElement(this.node) &&
      ((_this$parentPath = this.parentPath) == null
        ? void 0
        : _this$parentPath.isObjectPattern())
    );
  }
  function isSpreadProperty() {
    var _this$parentPath2;
    return (
      nodeIsRestElement(this.node) &&
      ((_this$parentPath2 = this.parentPath) == null
        ? void 0
        : _this$parentPath2.isObjectExpression())
    );
  }
  function isForAwaitStatement() {
    return isForOfStatement(this.node, {await: true});
  }
  {
    virtualTypesValidator.isExistentialTypeParam =
      function isExistentialTypeParam() {
        throw new Error(
          '`path.isExistentialTypeParam` has been renamed to `path.isExistsTypeAnnotation()` in Babel 7.'
        );
      };
    virtualTypesValidator.isNumericLiteralTypeAnnotation =
      function isNumericLiteralTypeAnnotation() {
        throw new Error(
          '`path.isNumericLiteralTypeAnnotation()` has been renamed to `path.isNumberLiteralTypeAnnotation()` in Babel 7.'
        );
      };
  }
  return virtualTypesValidator;
}
var hasRequiredVisitors$1;
function requireVisitors$1() {
  if (hasRequiredVisitors$1) return visitors$1;
  hasRequiredVisitors$1 = 1;
  Object.defineProperty(visitors$1, '__esModule', {value: true});
  visitors$1.environmentVisitor = environmentVisitor;
  visitors$1.explode = explode$1;
  visitors$1.isExplodedVisitor = isExplodedVisitor;
  visitors$1.merge = merge;
  visitors$1.verify = verify$1;
  var virtualTypes = requireVirtualTypes$1();
  var virtualTypesValidators = requireVirtualTypesValidator();
  var _t = t$d;
  var _context = requireContext$2();
  const {
    DEPRECATED_KEYS: DEPRECATED_KEYS,
    DEPRECATED_ALIASES: DEPRECATED_ALIASES,
    FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS,
    TYPES: TYPES,
    __internal__deprecationWarning: deprecationWarning,
  } = _t;
  function isVirtualType(type) {
    return type in virtualTypes;
  }
  function isExplodedVisitor(visitor) {
    return visitor == null ? void 0 : visitor._exploded;
  }
  function explode$1(visitor) {
    if (isExplodedVisitor(visitor)) return visitor;
    visitor._exploded = true;
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      const parts = nodeType.split('|');
      if (parts.length === 1) continue;
      const fns = visitor[nodeType];
      delete visitor[nodeType];
      for (const part of parts) {
        visitor[part] = fns;
      }
    }
    verify$1(visitor);
    delete visitor.__esModule;
    ensureEntranceObjects(visitor);
    ensureCallbackArrays(visitor);
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      if (!isVirtualType(nodeType)) continue;
      const fns = visitor[nodeType];
      for (const type of Object.keys(fns)) {
        fns[type] = wrapCheck(nodeType, fns[type]);
      }
      delete visitor[nodeType];
      const types = virtualTypes[nodeType];
      if (types !== null) {
        for (const type of types) {
          if (visitor[type]) {
            mergePair(visitor[type], fns);
          } else {
            visitor[type] = fns;
          }
        }
      } else {
        mergePair(visitor, fns);
      }
    }
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      let aliases = FLIPPED_ALIAS_KEYS[nodeType];
      if (nodeType in DEPRECATED_KEYS) {
        const deprecatedKey = DEPRECATED_KEYS[nodeType];
        deprecationWarning(nodeType, deprecatedKey, 'Visitor ');
        aliases = [deprecatedKey];
      } else if (nodeType in DEPRECATED_ALIASES) {
        const deprecatedAlias = DEPRECATED_ALIASES[nodeType];
        deprecationWarning(nodeType, deprecatedAlias, 'Visitor ');
        aliases = FLIPPED_ALIAS_KEYS[deprecatedAlias];
      }
      if (!aliases) continue;
      const fns = visitor[nodeType];
      delete visitor[nodeType];
      for (const alias of aliases) {
        const existing = visitor[alias];
        if (existing) {
          mergePair(existing, fns);
        } else {
          visitor[alias] = Object.assign({}, fns);
        }
      }
    }
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      ensureCallbackArrays(visitor[nodeType]);
    }
    return visitor;
  }
  function verify$1(visitor) {
    if (visitor._verified) return;
    if (typeof visitor === 'function') {
      throw new Error(
        'You passed `traverse()` a function when it expected a visitor object, ' +
          "are you sure you didn't mean `{ enter: Function }`?"
      );
    }
    for (const nodeType of Object.keys(visitor)) {
      if (nodeType === 'enter' || nodeType === 'exit') {
        validateVisitorMethods(nodeType, visitor[nodeType]);
      }
      if (shouldIgnoreKey(nodeType)) continue;
      if (!TYPES.includes(nodeType)) {
        throw new Error(
          `You gave us a visitor for the node type ${nodeType} but it's not a valid type in @babel/traverse ${'7.25.9'}`
        );
      }
      const visitors = visitor[nodeType];
      if (typeof visitors === 'object') {
        for (const visitorKey of Object.keys(visitors)) {
          if (visitorKey === 'enter' || visitorKey === 'exit') {
            validateVisitorMethods(
              `${nodeType}.${visitorKey}`,
              visitors[visitorKey]
            );
          } else {
            throw new Error(
              'You passed `traverse()` a visitor object with the property ' +
                `${nodeType} that has the invalid property ${visitorKey}`
            );
          }
        }
      }
    }
    visitor._verified = true;
  }
  function validateVisitorMethods(path, val) {
    const fns = [].concat(val);
    for (const fn of fns) {
      if (typeof fn !== 'function') {
        throw new TypeError(
          `Non-function found defined in ${path} with type ${typeof fn}`
        );
      }
    }
  }
  function merge(visitors, states = [], wrapper) {
    const mergedVisitor = {_verified: true, _exploded: true};
    {
      Object.defineProperty(mergedVisitor, '_exploded', {enumerable: false});
      Object.defineProperty(mergedVisitor, '_verified', {enumerable: false});
    }
    for (let i = 0; i < visitors.length; i++) {
      const visitor = explode$1(visitors[i]);
      const state = states[i];
      let topVisitor = visitor;
      if (state || wrapper) {
        topVisitor = wrapWithStateOrWrapper(topVisitor, state, wrapper);
      }
      mergePair(mergedVisitor, topVisitor);
      for (const key of Object.keys(visitor)) {
        if (shouldIgnoreKey(key)) continue;
        let typeVisitor = visitor[key];
        if (state || wrapper) {
          typeVisitor = wrapWithStateOrWrapper(typeVisitor, state, wrapper);
        }
        const nodeVisitor = mergedVisitor[key] || (mergedVisitor[key] = {});
        mergePair(nodeVisitor, typeVisitor);
      }
    }
    return mergedVisitor;
  }
  function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
    const newVisitor = {};
    for (const phase of ['enter', 'exit']) {
      let fns = oldVisitor[phase];
      if (!Array.isArray(fns)) continue;
      fns = fns.map(function (fn) {
        let newFn = fn;
        if (state) {
          newFn = function (path) {
            fn.call(state, path, state);
          };
        }
        if (wrapper) {
          newFn = wrapper(state == null ? void 0 : state.key, phase, newFn);
        }
        if (newFn !== fn) {
          newFn.toString = () => fn.toString();
        }
        return newFn;
      });
      newVisitor[phase] = fns;
    }
    return newVisitor;
  }
  function ensureEntranceObjects(obj) {
    for (const key of Object.keys(obj)) {
      if (shouldIgnoreKey(key)) continue;
      const fns = obj[key];
      if (typeof fns === 'function') {
        obj[key] = {enter: fns};
      }
    }
  }
  function ensureCallbackArrays(obj) {
    if (obj.enter && !Array.isArray(obj.enter)) obj.enter = [obj.enter];
    if (obj.exit && !Array.isArray(obj.exit)) obj.exit = [obj.exit];
  }
  function wrapCheck(nodeType, fn) {
    const fnKey = `is${nodeType}`;
    const validator = virtualTypesValidators[fnKey];
    const newFn = function (path) {
      if (validator.call(path)) {
        return fn.apply(this, arguments);
      }
    };
    newFn.toString = () => fn.toString();
    return newFn;
  }
  function shouldIgnoreKey(key) {
    if (key[0] === '_') return true;
    if (key === 'enter' || key === 'exit' || key === 'shouldSkip') return true;
    if (key === 'denylist' || key === 'noScope' || key === 'skipKeys') {
      return true;
    }
    {
      if (key === 'blacklist') {
        return true;
      }
    }
    return false;
  }
  function mergePair(dest, src) {
    for (const phase of ['enter', 'exit']) {
      if (!src[phase]) continue;
      dest[phase] = [].concat(dest[phase] || [], src[phase]);
    }
  }
  const _environmentVisitor = {
    FunctionParent(path) {
      if (path.isArrowFunctionExpression()) return;
      path.skip();
      if (path.isMethod()) {
        if (!path.requeueComputedKeyAndDecorators) {
          _context.requeueComputedKeyAndDecorators.call(path);
        } else {
          path.requeueComputedKeyAndDecorators();
        }
      }
    },
    Property(path) {
      if (path.isObjectProperty()) return;
      path.skip();
      if (!path.requeueComputedKeyAndDecorators) {
        _context.requeueComputedKeyAndDecorators.call(path);
      } else {
        path.requeueComputedKeyAndDecorators();
      }
    },
  };
  function environmentVisitor(visitor) {
    return merge([_environmentVisitor, visitor]);
  }
  return visitors$1;
}
var hasRequiredRenamer$1;
function requireRenamer$1() {
  if (hasRequiredRenamer$1) return renamer$1;
  hasRequiredRenamer$1 = 1;
  Object.defineProperty(renamer$1, '__esModule', {value: true});
  renamer$1.default = void 0;
  var t = t$d;
  var _t = t;
  var _traverseNode = requireTraverseNode();
  var _visitors = requireVisitors$1();
  var _context = requireContext$2();
  const {getAssignmentIdentifiers: getAssignmentIdentifiers} = _t;
  const renameVisitor = {
    ReferencedIdentifier({node: node}, state) {
      if (node.name === state.oldName) {
        node.name = state.newName;
      }
    },
    Scope(path, state) {
      if (
        !path.scope.bindingIdentifierEquals(
          state.oldName,
          state.binding.identifier
        )
      ) {
        path.skip();
        if (path.isMethod()) {
          if (!path.requeueComputedKeyAndDecorators) {
            _context.requeueComputedKeyAndDecorators.call(path);
          } else {
            path.requeueComputedKeyAndDecorators();
          }
        }
      }
    },
    ObjectProperty({node: node, scope: scope}, state) {
      const {name: name} = node.key;
      if (
        node.shorthand &&
        (name === state.oldName || name === state.newName) &&
        scope.getBindingIdentifier(name) === state.binding.identifier
      ) {
        node.shorthand = false;
        {
          var _node$extra;
          if ((_node$extra = node.extra) != null && _node$extra.shorthand)
            node.extra.shorthand = false;
        }
      }
    },
    'AssignmentExpression|Declaration|VariableDeclarator'(path, state) {
      if (path.isVariableDeclaration()) return;
      const ids = path.isAssignmentExpression()
        ? getAssignmentIdentifiers(path.node)
        : path.getOuterBindingIdentifiers();
      for (const name in ids) {
        if (name === state.oldName) ids[name].name = state.newName;
      }
    },
  };
  class Renamer {
    constructor(binding, oldName, newName) {
      this.newName = newName;
      this.oldName = oldName;
      this.binding = binding;
    }
    maybeConvertFromExportDeclaration(parentDeclar) {
      const maybeExportDeclar = parentDeclar.parentPath;
      if (!maybeExportDeclar.isExportDeclaration()) {
        return;
      }
      if (maybeExportDeclar.isExportDefaultDeclaration()) {
        const {declaration: declaration} = maybeExportDeclar.node;
        if (t.isDeclaration(declaration) && !declaration.id) {
          return;
        }
      }
      if (maybeExportDeclar.isExportAllDeclaration()) {
        return;
      }
      maybeExportDeclar.splitExportDeclaration();
    }
    maybeConvertFromClassFunctionDeclaration(path) {
      return path;
    }
    maybeConvertFromClassFunctionExpression(path) {
      return path;
    }
    rename() {
      const {binding: binding, oldName: oldName, newName: newName} = this;
      const {scope: scope, path: path} = binding;
      const parentDeclar = path.find(
        path =>
          path.isDeclaration() ||
          path.isFunctionExpression() ||
          path.isClassExpression()
      );
      if (parentDeclar) {
        const bindingIds = parentDeclar.getOuterBindingIdentifiers();
        if (bindingIds[oldName] === binding.identifier) {
          this.maybeConvertFromExportDeclaration(parentDeclar);
        }
      }
      const blockToTraverse = arguments[0] || scope.block;
      const skipKeys = {discriminant: true};
      if (t.isMethod(blockToTraverse)) {
        if (blockToTraverse.computed) {
          skipKeys.key = true;
        }
        if (!t.isObjectMethod(blockToTraverse)) {
          skipKeys.decorators = true;
        }
      }
      (0, _traverseNode.traverseNode)(
        blockToTraverse,
        (0, _visitors.explode)(renameVisitor),
        scope,
        this,
        scope.path,
        skipKeys
      );
      if (!arguments[0]) {
        scope.removeOwnBinding(oldName);
        scope.bindings[newName] = binding;
        this.binding.identifier.name = newName;
      }
      if (parentDeclar) {
        this.maybeConvertFromClassFunctionDeclaration(path);
        this.maybeConvertFromClassFunctionExpression(path);
      }
    }
  }
  renamer$1.default = Renamer;
  return renamer$1;
}
var binding$1 = {};
var hasRequiredBinding$1;
function requireBinding$1() {
  if (hasRequiredBinding$1) return binding$1;
  hasRequiredBinding$1 = 1;
  Object.defineProperty(binding$1, '__esModule', {value: true});
  binding$1.default = void 0;
  class Binding {
    constructor({
      identifier: identifier,
      scope: scope,
      path: path,
      kind: kind,
    }) {
      this.identifier = void 0;
      this.scope = void 0;
      this.path = void 0;
      this.kind = void 0;
      this.constantViolations = [];
      this.constant = true;
      this.referencePaths = [];
      this.referenced = false;
      this.references = 0;
      this.identifier = identifier;
      this.scope = scope;
      this.path = path;
      this.kind = kind;
      if ((kind === 'var' || kind === 'hoisted') && isDeclaredInLoop(path)) {
        this.reassign(path);
      }
      this.clearValue();
    }
    deoptValue() {
      this.clearValue();
      this.hasDeoptedValue = true;
    }
    setValue(value) {
      if (this.hasDeoptedValue) return;
      this.hasValue = true;
      this.value = value;
    }
    clearValue() {
      this.hasDeoptedValue = false;
      this.hasValue = false;
      this.value = null;
    }
    reassign(path) {
      this.constant = false;
      if (this.constantViolations.includes(path)) {
        return;
      }
      this.constantViolations.push(path);
    }
    reference(path) {
      if (this.referencePaths.includes(path)) {
        return;
      }
      this.referenced = true;
      this.references++;
      this.referencePaths.push(path);
    }
    dereference() {
      this.references--;
      this.referenced = !!this.references;
    }
  }
  binding$1.default = Binding;
  function isDeclaredInLoop(path) {
    for (
      let {parentPath: parentPath, key: key} = path;
      parentPath;
      {parentPath: parentPath, key: key} = parentPath
    ) {
      if (parentPath.isFunctionParent()) return false;
      if (
        parentPath.isWhile() ||
        parentPath.isForXStatement() ||
        (parentPath.isForStatement() && key === 'body')
      ) {
        return true;
      }
    }
    return false;
  }
  return binding$1;
}
var builtin = {
  Array: false,
  ArrayBuffer: false,
  Atomics: false,
  BigInt: false,
  BigInt64Array: false,
  BigUint64Array: false,
  Boolean: false,
  constructor: false,
  DataView: false,
  Date: false,
  decodeURI: false,
  decodeURIComponent: false,
  encodeURI: false,
  encodeURIComponent: false,
  Error: false,
  escape: false,
  eval: false,
  EvalError: false,
  Float32Array: false,
  Float64Array: false,
  Function: false,
  globalThis: false,
  hasOwnProperty: false,
  Infinity: false,
  Int16Array: false,
  Int32Array: false,
  Int8Array: false,
  isFinite: false,
  isNaN: false,
  isPrototypeOf: false,
  JSON: false,
  Map: false,
  Math: false,
  NaN: false,
  Number: false,
  Object: false,
  parseFloat: false,
  parseInt: false,
  Promise: false,
  propertyIsEnumerable: false,
  Proxy: false,
  RangeError: false,
  ReferenceError: false,
  Reflect: false,
  RegExp: false,
  Set: false,
  SharedArrayBuffer: false,
  String: false,
  Symbol: false,
  SyntaxError: false,
  toLocaleString: false,
  toString: false,
  TypeError: false,
  Uint16Array: false,
  Uint32Array: false,
  Uint8Array: false,
  Uint8ClampedArray: false,
  undefined: false,
  unescape: false,
  URIError: false,
  valueOf: false,
  WeakMap: false,
  WeakSet: false,
};
var es5 = {
  Array: false,
  Boolean: false,
  constructor: false,
  Date: false,
  decodeURI: false,
  decodeURIComponent: false,
  encodeURI: false,
  encodeURIComponent: false,
  Error: false,
  escape: false,
  eval: false,
  EvalError: false,
  Function: false,
  hasOwnProperty: false,
  Infinity: false,
  isFinite: false,
  isNaN: false,
  isPrototypeOf: false,
  JSON: false,
  Math: false,
  NaN: false,
  Number: false,
  Object: false,
  parseFloat: false,
  parseInt: false,
  propertyIsEnumerable: false,
  RangeError: false,
  ReferenceError: false,
  RegExp: false,
  String: false,
  SyntaxError: false,
  toLocaleString: false,
  toString: false,
  TypeError: false,
  undefined: false,
  unescape: false,
  URIError: false,
  valueOf: false,
};
var es2015 = {
  Array: false,
  ArrayBuffer: false,
  Boolean: false,
  constructor: false,
  DataView: false,
  Date: false,
  decodeURI: false,
  decodeURIComponent: false,
  encodeURI: false,
  encodeURIComponent: false,
  Error: false,
  escape: false,
  eval: false,
  EvalError: false,
  Float32Array: false,
  Float64Array: false,
  Function: false,
  hasOwnProperty: false,
  Infinity: false,
  Int16Array: false,
  Int32Array: false,
  Int8Array: false,
  isFinite: false,
  isNaN: false,
  isPrototypeOf: false,
  JSON: false,
  Map: false,
  Math: false,
  NaN: false,
  Number: false,
  Object: false,
  parseFloat: false,
  parseInt: false,
  Promise: false,
  propertyIsEnumerable: false,
  Proxy: false,
  RangeError: false,
  ReferenceError: false,
  Reflect: false,
  RegExp: false,
  Set: false,
  String: false,
  Symbol: false,
  SyntaxError: false,
  toLocaleString: false,
  toString: false,
  TypeError: false,
  Uint16Array: false,
  Uint32Array: false,
  Uint8Array: false,
  Uint8ClampedArray: false,
  undefined: false,
  unescape: false,
  URIError: false,
  valueOf: false,
  WeakMap: false,
  WeakSet: false,
};
var es2017 = {
  Array: false,
  ArrayBuffer: false,
  Atomics: false,
  Boolean: false,
  constructor: false,
  DataView: false,
  Date: false,
  decodeURI: false,
  decodeURIComponent: false,
  encodeURI: false,
  encodeURIComponent: false,
  Error: false,
  escape: false,
  eval: false,
  EvalError: false,
  Float32Array: false,
  Float64Array: false,
  Function: false,
  hasOwnProperty: false,
  Infinity: false,
  Int16Array: false,
  Int32Array: false,
  Int8Array: false,
  isFinite: false,
  isNaN: false,
  isPrototypeOf: false,
  JSON: false,
  Map: false,
  Math: false,
  NaN: false,
  Number: false,
  Object: false,
  parseFloat: false,
  parseInt: false,
  Promise: false,
  propertyIsEnumerable: false,
  Proxy: false,
  RangeError: false,
  ReferenceError: false,
  Reflect: false,
  RegExp: false,
  Set: false,
  SharedArrayBuffer: false,
  String: false,
  Symbol: false,
  SyntaxError: false,
  toLocaleString: false,
  toString: false,
  TypeError: false,
  Uint16Array: false,
  Uint32Array: false,
  Uint8Array: false,
  Uint8ClampedArray: false,
  undefined: false,
  unescape: false,
  URIError: false,
  valueOf: false,
  WeakMap: false,
  WeakSet: false,
};
var browser$1 = {
  AbortController: false,
  AbortSignal: false,
  addEventListener: false,
  alert: false,
  AnalyserNode: false,
  Animation: false,
  AnimationEffectReadOnly: false,
  AnimationEffectTiming: false,
  AnimationEffectTimingReadOnly: false,
  AnimationEvent: false,
  AnimationPlaybackEvent: false,
  AnimationTimeline: false,
  applicationCache: false,
  ApplicationCache: false,
  ApplicationCacheErrorEvent: false,
  atob: false,
  Attr: false,
  Audio: false,
  AudioBuffer: false,
  AudioBufferSourceNode: false,
  AudioContext: false,
  AudioDestinationNode: false,
  AudioListener: false,
  AudioNode: false,
  AudioParam: false,
  AudioProcessingEvent: false,
  AudioScheduledSourceNode: false,
  'AudioWorkletGlobalScope ': false,
  AudioWorkletNode: false,
  AudioWorkletProcessor: false,
  BarProp: false,
  BaseAudioContext: false,
  BatteryManager: false,
  BeforeUnloadEvent: false,
  BiquadFilterNode: false,
  Blob: false,
  BlobEvent: false,
  blur: false,
  BroadcastChannel: false,
  btoa: false,
  BudgetService: false,
  ByteLengthQueuingStrategy: false,
  Cache: false,
  caches: false,
  CacheStorage: false,
  cancelAnimationFrame: false,
  cancelIdleCallback: false,
  CanvasCaptureMediaStreamTrack: false,
  CanvasGradient: false,
  CanvasPattern: false,
  CanvasRenderingContext2D: false,
  ChannelMergerNode: false,
  ChannelSplitterNode: false,
  CharacterData: false,
  clearInterval: false,
  clearTimeout: false,
  clientInformation: false,
  ClipboardEvent: false,
  close: false,
  closed: false,
  CloseEvent: false,
  Comment: false,
  CompositionEvent: false,
  confirm: false,
  console: false,
  ConstantSourceNode: false,
  ConvolverNode: false,
  CountQueuingStrategy: false,
  createImageBitmap: false,
  Credential: false,
  CredentialsContainer: false,
  crypto: false,
  Crypto: false,
  CryptoKey: false,
  CSS: false,
  CSSConditionRule: false,
  CSSFontFaceRule: false,
  CSSGroupingRule: false,
  CSSImportRule: false,
  CSSKeyframeRule: false,
  CSSKeyframesRule: false,
  CSSMediaRule: false,
  CSSNamespaceRule: false,
  CSSPageRule: false,
  CSSRule: false,
  CSSRuleList: false,
  CSSStyleDeclaration: false,
  CSSStyleRule: false,
  CSSStyleSheet: false,
  CSSSupportsRule: false,
  CustomElementRegistry: false,
  customElements: false,
  CustomEvent: false,
  DataTransfer: false,
  DataTransferItem: false,
  DataTransferItemList: false,
  defaultstatus: false,
  defaultStatus: false,
  DelayNode: false,
  DeviceMotionEvent: false,
  DeviceOrientationEvent: false,
  devicePixelRatio: false,
  dispatchEvent: false,
  document: false,
  Document: false,
  DocumentFragment: false,
  DocumentType: false,
  DOMError: false,
  DOMException: false,
  DOMImplementation: false,
  DOMMatrix: false,
  DOMMatrixReadOnly: false,
  DOMParser: false,
  DOMPoint: false,
  DOMPointReadOnly: false,
  DOMQuad: false,
  DOMRect: false,
  DOMRectReadOnly: false,
  DOMStringList: false,
  DOMStringMap: false,
  DOMTokenList: false,
  DragEvent: false,
  DynamicsCompressorNode: false,
  Element: false,
  ErrorEvent: false,
  event: false,
  Event: false,
  EventSource: false,
  EventTarget: false,
  external: false,
  fetch: false,
  File: false,
  FileList: false,
  FileReader: false,
  find: false,
  focus: false,
  FocusEvent: false,
  FontFace: false,
  FontFaceSetLoadEvent: false,
  FormData: false,
  frameElement: false,
  frames: false,
  GainNode: false,
  Gamepad: false,
  GamepadButton: false,
  GamepadEvent: false,
  getComputedStyle: false,
  getSelection: false,
  HashChangeEvent: false,
  Headers: false,
  history: false,
  History: false,
  HTMLAllCollection: false,
  HTMLAnchorElement: false,
  HTMLAreaElement: false,
  HTMLAudioElement: false,
  HTMLBaseElement: false,
  HTMLBodyElement: false,
  HTMLBRElement: false,
  HTMLButtonElement: false,
  HTMLCanvasElement: false,
  HTMLCollection: false,
  HTMLContentElement: false,
  HTMLDataElement: false,
  HTMLDataListElement: false,
  HTMLDetailsElement: false,
  HTMLDialogElement: false,
  HTMLDirectoryElement: false,
  HTMLDivElement: false,
  HTMLDListElement: false,
  HTMLDocument: false,
  HTMLElement: false,
  HTMLEmbedElement: false,
  HTMLFieldSetElement: false,
  HTMLFontElement: false,
  HTMLFormControlsCollection: false,
  HTMLFormElement: false,
  HTMLFrameElement: false,
  HTMLFrameSetElement: false,
  HTMLHeadElement: false,
  HTMLHeadingElement: false,
  HTMLHRElement: false,
  HTMLHtmlElement: false,
  HTMLIFrameElement: false,
  HTMLImageElement: false,
  HTMLInputElement: false,
  HTMLLabelElement: false,
  HTMLLegendElement: false,
  HTMLLIElement: false,
  HTMLLinkElement: false,
  HTMLMapElement: false,
  HTMLMarqueeElement: false,
  HTMLMediaElement: false,
  HTMLMenuElement: false,
  HTMLMetaElement: false,
  HTMLMeterElement: false,
  HTMLModElement: false,
  HTMLObjectElement: false,
  HTMLOListElement: false,
  HTMLOptGroupElement: false,
  HTMLOptionElement: false,
  HTMLOptionsCollection: false,
  HTMLOutputElement: false,
  HTMLParagraphElement: false,
  HTMLParamElement: false,
  HTMLPictureElement: false,
  HTMLPreElement: false,
  HTMLProgressElement: false,
  HTMLQuoteElement: false,
  HTMLScriptElement: false,
  HTMLSelectElement: false,
  HTMLShadowElement: false,
  HTMLSlotElement: false,
  HTMLSourceElement: false,
  HTMLSpanElement: false,
  HTMLStyleElement: false,
  HTMLTableCaptionElement: false,
  HTMLTableCellElement: false,
  HTMLTableColElement: false,
  HTMLTableElement: false,
  HTMLTableRowElement: false,
  HTMLTableSectionElement: false,
  HTMLTemplateElement: false,
  HTMLTextAreaElement: false,
  HTMLTimeElement: false,
  HTMLTitleElement: false,
  HTMLTrackElement: false,
  HTMLUListElement: false,
  HTMLUnknownElement: false,
  HTMLVideoElement: false,
  IDBCursor: false,
  IDBCursorWithValue: false,
  IDBDatabase: false,
  IDBFactory: false,
  IDBIndex: false,
  IDBKeyRange: false,
  IDBObjectStore: false,
  IDBOpenDBRequest: false,
  IDBRequest: false,
  IDBTransaction: false,
  IDBVersionChangeEvent: false,
  IdleDeadline: false,
  IIRFilterNode: false,
  Image: false,
  ImageBitmap: false,
  ImageBitmapRenderingContext: false,
  ImageCapture: false,
  ImageData: false,
  indexedDB: false,
  innerHeight: false,
  innerWidth: false,
  InputEvent: false,
  IntersectionObserver: false,
  IntersectionObserverEntry: false,
  Intl: false,
  isSecureContext: false,
  KeyboardEvent: false,
  KeyframeEffect: false,
  KeyframeEffectReadOnly: false,
  length: false,
  localStorage: false,
  location: true,
  Location: false,
  locationbar: false,
  matchMedia: false,
  MediaDeviceInfo: false,
  MediaDevices: false,
  MediaElementAudioSourceNode: false,
  MediaEncryptedEvent: false,
  MediaError: false,
  MediaKeyMessageEvent: false,
  MediaKeySession: false,
  MediaKeyStatusMap: false,
  MediaKeySystemAccess: false,
  MediaList: false,
  MediaQueryList: false,
  MediaQueryListEvent: false,
  MediaRecorder: false,
  MediaSettingsRange: false,
  MediaSource: false,
  MediaStream: false,
  MediaStreamAudioDestinationNode: false,
  MediaStreamAudioSourceNode: false,
  MediaStreamEvent: false,
  MediaStreamTrack: false,
  MediaStreamTrackEvent: false,
  menubar: false,
  MessageChannel: false,
  MessageEvent: false,
  MessagePort: false,
  MIDIAccess: false,
  MIDIConnectionEvent: false,
  MIDIInput: false,
  MIDIInputMap: false,
  MIDIMessageEvent: false,
  MIDIOutput: false,
  MIDIOutputMap: false,
  MIDIPort: false,
  MimeType: false,
  MimeTypeArray: false,
  MouseEvent: false,
  moveBy: false,
  moveTo: false,
  MutationEvent: false,
  MutationObserver: false,
  MutationRecord: false,
  name: false,
  NamedNodeMap: false,
  NavigationPreloadManager: false,
  navigator: false,
  Navigator: false,
  NetworkInformation: false,
  Node: false,
  NodeFilter: false,
  NodeIterator: false,
  NodeList: false,
  Notification: false,
  OfflineAudioCompletionEvent: false,
  OfflineAudioContext: false,
  offscreenBuffering: false,
  OffscreenCanvas: true,
  onabort: true,
  onafterprint: true,
  onanimationend: true,
  onanimationiteration: true,
  onanimationstart: true,
  onappinstalled: true,
  onauxclick: true,
  onbeforeinstallprompt: true,
  onbeforeprint: true,
  onbeforeunload: true,
  onblur: true,
  oncancel: true,
  oncanplay: true,
  oncanplaythrough: true,
  onchange: true,
  onclick: true,
  onclose: true,
  oncontextmenu: true,
  oncuechange: true,
  ondblclick: true,
  ondevicemotion: true,
  ondeviceorientation: true,
  ondeviceorientationabsolute: true,
  ondrag: true,
  ondragend: true,
  ondragenter: true,
  ondragleave: true,
  ondragover: true,
  ondragstart: true,
  ondrop: true,
  ondurationchange: true,
  onemptied: true,
  onended: true,
  onerror: true,
  onfocus: true,
  ongotpointercapture: true,
  onhashchange: true,
  oninput: true,
  oninvalid: true,
  onkeydown: true,
  onkeypress: true,
  onkeyup: true,
  onlanguagechange: true,
  onload: true,
  onloadeddata: true,
  onloadedmetadata: true,
  onloadstart: true,
  onlostpointercapture: true,
  onmessage: true,
  onmessageerror: true,
  onmousedown: true,
  onmouseenter: true,
  onmouseleave: true,
  onmousemove: true,
  onmouseout: true,
  onmouseover: true,
  onmouseup: true,
  onmousewheel: true,
  onoffline: true,
  ononline: true,
  onpagehide: true,
  onpageshow: true,
  onpause: true,
  onplay: true,
  onplaying: true,
  onpointercancel: true,
  onpointerdown: true,
  onpointerenter: true,
  onpointerleave: true,
  onpointermove: true,
  onpointerout: true,
  onpointerover: true,
  onpointerup: true,
  onpopstate: true,
  onprogress: true,
  onratechange: true,
  onrejectionhandled: true,
  onreset: true,
  onresize: true,
  onscroll: true,
  onsearch: true,
  onseeked: true,
  onseeking: true,
  onselect: true,
  onstalled: true,
  onstorage: true,
  onsubmit: true,
  onsuspend: true,
  ontimeupdate: true,
  ontoggle: true,
  ontransitionend: true,
  onunhandledrejection: true,
  onunload: true,
  onvolumechange: true,
  onwaiting: true,
  onwheel: true,
  open: false,
  openDatabase: false,
  opener: false,
  Option: false,
  origin: false,
  OscillatorNode: false,
  outerHeight: false,
  outerWidth: false,
  PageTransitionEvent: false,
  pageXOffset: false,
  pageYOffset: false,
  PannerNode: false,
  parent: false,
  Path2D: false,
  PaymentAddress: false,
  PaymentRequest: false,
  PaymentRequestUpdateEvent: false,
  PaymentResponse: false,
  performance: false,
  Performance: false,
  PerformanceEntry: false,
  PerformanceLongTaskTiming: false,
  PerformanceMark: false,
  PerformanceMeasure: false,
  PerformanceNavigation: false,
  PerformanceNavigationTiming: false,
  PerformanceObserver: false,
  PerformanceObserverEntryList: false,
  PerformancePaintTiming: false,
  PerformanceResourceTiming: false,
  PerformanceTiming: false,
  PeriodicWave: false,
  Permissions: false,
  PermissionStatus: false,
  personalbar: false,
  PhotoCapabilities: false,
  Plugin: false,
  PluginArray: false,
  PointerEvent: false,
  PopStateEvent: false,
  postMessage: false,
  Presentation: false,
  PresentationAvailability: false,
  PresentationConnection: false,
  PresentationConnectionAvailableEvent: false,
  PresentationConnectionCloseEvent: false,
  PresentationConnectionList: false,
  PresentationReceiver: false,
  PresentationRequest: false,
  print: false,
  ProcessingInstruction: false,
  ProgressEvent: false,
  PromiseRejectionEvent: false,
  prompt: false,
  PushManager: false,
  PushSubscription: false,
  PushSubscriptionOptions: false,
  queueMicrotask: false,
  RadioNodeList: false,
  Range: false,
  ReadableStream: false,
  registerProcessor: false,
  RemotePlayback: false,
  removeEventListener: false,
  Request: false,
  requestAnimationFrame: false,
  requestIdleCallback: false,
  resizeBy: false,
  ResizeObserver: false,
  ResizeObserverEntry: false,
  resizeTo: false,
  Response: false,
  RTCCertificate: false,
  RTCDataChannel: false,
  RTCDataChannelEvent: false,
  RTCDtlsTransport: false,
  RTCIceCandidate: false,
  RTCIceGatherer: false,
  RTCIceTransport: false,
  RTCPeerConnection: false,
  RTCPeerConnectionIceEvent: false,
  RTCRtpContributingSource: false,
  RTCRtpReceiver: false,
  RTCRtpSender: false,
  RTCSctpTransport: false,
  RTCSessionDescription: false,
  RTCStatsReport: false,
  RTCTrackEvent: false,
  screen: false,
  Screen: false,
  screenLeft: false,
  ScreenOrientation: false,
  screenTop: false,
  screenX: false,
  screenY: false,
  ScriptProcessorNode: false,
  scroll: false,
  scrollbars: false,
  scrollBy: false,
  scrollTo: false,
  scrollX: false,
  scrollY: false,
  SecurityPolicyViolationEvent: false,
  Selection: false,
  self: false,
  ServiceWorker: false,
  ServiceWorkerContainer: false,
  ServiceWorkerRegistration: false,
  sessionStorage: false,
  setInterval: false,
  setTimeout: false,
  ShadowRoot: false,
  SharedWorker: false,
  SourceBuffer: false,
  SourceBufferList: false,
  speechSynthesis: false,
  SpeechSynthesisEvent: false,
  SpeechSynthesisUtterance: false,
  StaticRange: false,
  status: false,
  statusbar: false,
  StereoPannerNode: false,
  stop: false,
  Storage: false,
  StorageEvent: false,
  StorageManager: false,
  styleMedia: false,
  StyleSheet: false,
  StyleSheetList: false,
  SubtleCrypto: false,
  SVGAElement: false,
  SVGAngle: false,
  SVGAnimatedAngle: false,
  SVGAnimatedBoolean: false,
  SVGAnimatedEnumeration: false,
  SVGAnimatedInteger: false,
  SVGAnimatedLength: false,
  SVGAnimatedLengthList: false,
  SVGAnimatedNumber: false,
  SVGAnimatedNumberList: false,
  SVGAnimatedPreserveAspectRatio: false,
  SVGAnimatedRect: false,
  SVGAnimatedString: false,
  SVGAnimatedTransformList: false,
  SVGAnimateElement: false,
  SVGAnimateMotionElement: false,
  SVGAnimateTransformElement: false,
  SVGAnimationElement: false,
  SVGCircleElement: false,
  SVGClipPathElement: false,
  SVGComponentTransferFunctionElement: false,
  SVGDefsElement: false,
  SVGDescElement: false,
  SVGDiscardElement: false,
  SVGElement: false,
  SVGEllipseElement: false,
  SVGFEBlendElement: false,
  SVGFEColorMatrixElement: false,
  SVGFEComponentTransferElement: false,
  SVGFECompositeElement: false,
  SVGFEConvolveMatrixElement: false,
  SVGFEDiffuseLightingElement: false,
  SVGFEDisplacementMapElement: false,
  SVGFEDistantLightElement: false,
  SVGFEDropShadowElement: false,
  SVGFEFloodElement: false,
  SVGFEFuncAElement: false,
  SVGFEFuncBElement: false,
  SVGFEFuncGElement: false,
  SVGFEFuncRElement: false,
  SVGFEGaussianBlurElement: false,
  SVGFEImageElement: false,
  SVGFEMergeElement: false,
  SVGFEMergeNodeElement: false,
  SVGFEMorphologyElement: false,
  SVGFEOffsetElement: false,
  SVGFEPointLightElement: false,
  SVGFESpecularLightingElement: false,
  SVGFESpotLightElement: false,
  SVGFETileElement: false,
  SVGFETurbulenceElement: false,
  SVGFilterElement: false,
  SVGForeignObjectElement: false,
  SVGGElement: false,
  SVGGeometryElement: false,
  SVGGradientElement: false,
  SVGGraphicsElement: false,
  SVGImageElement: false,
  SVGLength: false,
  SVGLengthList: false,
  SVGLinearGradientElement: false,
  SVGLineElement: false,
  SVGMarkerElement: false,
  SVGMaskElement: false,
  SVGMatrix: false,
  SVGMetadataElement: false,
  SVGMPathElement: false,
  SVGNumber: false,
  SVGNumberList: false,
  SVGPathElement: false,
  SVGPatternElement: false,
  SVGPoint: false,
  SVGPointList: false,
  SVGPolygonElement: false,
  SVGPolylineElement: false,
  SVGPreserveAspectRatio: false,
  SVGRadialGradientElement: false,
  SVGRect: false,
  SVGRectElement: false,
  SVGScriptElement: false,
  SVGSetElement: false,
  SVGStopElement: false,
  SVGStringList: false,
  SVGStyleElement: false,
  SVGSVGElement: false,
  SVGSwitchElement: false,
  SVGSymbolElement: false,
  SVGTextContentElement: false,
  SVGTextElement: false,
  SVGTextPathElement: false,
  SVGTextPositioningElement: false,
  SVGTitleElement: false,
  SVGTransform: false,
  SVGTransformList: false,
  SVGTSpanElement: false,
  SVGUnitTypes: false,
  SVGUseElement: false,
  SVGViewElement: false,
  TaskAttributionTiming: false,
  Text: false,
  TextDecoder: false,
  TextEncoder: false,
  TextEvent: false,
  TextMetrics: false,
  TextTrack: false,
  TextTrackCue: false,
  TextTrackCueList: false,
  TextTrackList: false,
  TimeRanges: false,
  toolbar: false,
  top: false,
  Touch: false,
  TouchEvent: false,
  TouchList: false,
  TrackEvent: false,
  TransitionEvent: false,
  TreeWalker: false,
  UIEvent: false,
  URL: false,
  URLSearchParams: false,
  ValidityState: false,
  visualViewport: false,
  VisualViewport: false,
  VTTCue: false,
  WaveShaperNode: false,
  WebAssembly: false,
  WebGL2RenderingContext: false,
  WebGLActiveInfo: false,
  WebGLBuffer: false,
  WebGLContextEvent: false,
  WebGLFramebuffer: false,
  WebGLProgram: false,
  WebGLQuery: false,
  WebGLRenderbuffer: false,
  WebGLRenderingContext: false,
  WebGLSampler: false,
  WebGLShader: false,
  WebGLShaderPrecisionFormat: false,
  WebGLSync: false,
  WebGLTexture: false,
  WebGLTransformFeedback: false,
  WebGLUniformLocation: false,
  WebGLVertexArrayObject: false,
  WebSocket: false,
  WheelEvent: false,
  window: false,
  Window: false,
  Worker: false,
  WritableStream: false,
  XMLDocument: false,
  XMLHttpRequest: false,
  XMLHttpRequestEventTarget: false,
  XMLHttpRequestUpload: false,
  XMLSerializer: false,
  XPathEvaluator: false,
  XPathExpression: false,
  XPathResult: false,
  XSLTProcessor: false,
};
var worker = {
  addEventListener: false,
  applicationCache: false,
  atob: false,
  Blob: false,
  BroadcastChannel: false,
  btoa: false,
  Cache: false,
  caches: false,
  clearInterval: false,
  clearTimeout: false,
  close: true,
  console: false,
  fetch: false,
  FileReaderSync: false,
  FormData: false,
  Headers: false,
  IDBCursor: false,
  IDBCursorWithValue: false,
  IDBDatabase: false,
  IDBFactory: false,
  IDBIndex: false,
  IDBKeyRange: false,
  IDBObjectStore: false,
  IDBOpenDBRequest: false,
  IDBRequest: false,
  IDBTransaction: false,
  IDBVersionChangeEvent: false,
  ImageData: false,
  importScripts: true,
  indexedDB: false,
  location: false,
  MessageChannel: false,
  MessagePort: false,
  name: false,
  navigator: false,
  Notification: false,
  onclose: true,
  onconnect: true,
  onerror: true,
  onlanguagechange: true,
  onmessage: true,
  onoffline: true,
  ononline: true,
  onrejectionhandled: true,
  onunhandledrejection: true,
  performance: false,
  Performance: false,
  PerformanceEntry: false,
  PerformanceMark: false,
  PerformanceMeasure: false,
  PerformanceNavigation: false,
  PerformanceResourceTiming: false,
  PerformanceTiming: false,
  postMessage: true,
  Promise: false,
  queueMicrotask: false,
  removeEventListener: false,
  Request: false,
  Response: false,
  self: true,
  ServiceWorkerRegistration: false,
  setInterval: false,
  setTimeout: false,
  TextDecoder: false,
  TextEncoder: false,
  URL: false,
  URLSearchParams: false,
  WebSocket: false,
  Worker: false,
  WorkerGlobalScope: false,
  XMLHttpRequest: false,
};
var node$3 = {
  __dirname: false,
  __filename: false,
  Buffer: false,
  clearImmediate: false,
  clearInterval: false,
  clearTimeout: false,
  console: false,
  exports: true,
  global: false,
  Intl: false,
  module: false,
  process: false,
  queueMicrotask: false,
  require: false,
  setImmediate: false,
  setInterval: false,
  setTimeout: false,
  TextDecoder: false,
  TextEncoder: false,
  URL: false,
  URLSearchParams: false,
};
var commonjs = {exports: true, global: false, module: false, require: false};
var amd = {define: false, require: false};
var mocha = {
  after: false,
  afterEach: false,
  before: false,
  beforeEach: false,
  context: false,
  describe: false,
  it: false,
  mocha: false,
  run: false,
  setup: false,
  specify: false,
  suite: false,
  suiteSetup: false,
  suiteTeardown: false,
  teardown: false,
  test: false,
  xcontext: false,
  xdescribe: false,
  xit: false,
  xspecify: false,
};
var jasmine = {
  afterAll: false,
  afterEach: false,
  beforeAll: false,
  beforeEach: false,
  describe: false,
  expect: false,
  fail: false,
  fdescribe: false,
  fit: false,
  it: false,
  jasmine: false,
  pending: false,
  runs: false,
  spyOn: false,
  spyOnProperty: false,
  waits: false,
  waitsFor: false,
  xdescribe: false,
  xit: false,
};
var jest = {
  afterAll: false,
  afterEach: false,
  beforeAll: false,
  beforeEach: false,
  describe: false,
  expect: false,
  fdescribe: false,
  fit: false,
  it: false,
  jest: false,
  pit: false,
  require: false,
  test: false,
  xdescribe: false,
  xit: false,
  xtest: false,
};
var qunit = {
  asyncTest: false,
  deepEqual: false,
  equal: false,
  expect: false,
  module: false,
  notDeepEqual: false,
  notEqual: false,
  notOk: false,
  notPropEqual: false,
  notStrictEqual: false,
  ok: false,
  propEqual: false,
  QUnit: false,
  raises: false,
  start: false,
  stop: false,
  strictEqual: false,
  test: false,
  throws: false,
};
var phantomjs = {
  console: true,
  exports: true,
  phantom: true,
  require: true,
  WebPage: true,
};
var couch = {
  emit: false,
  exports: false,
  getRow: false,
  log: false,
  module: false,
  provides: false,
  require: false,
  respond: false,
  send: false,
  start: false,
  sum: false,
};
var rhino = {
  defineClass: false,
  deserialize: false,
  gc: false,
  help: false,
  importClass: false,
  importPackage: false,
  java: false,
  load: false,
  loadClass: false,
  Packages: false,
  print: false,
  quit: false,
  readFile: false,
  readUrl: false,
  runCommand: false,
  seal: false,
  serialize: false,
  spawn: false,
  sync: false,
  toint32: false,
  version: false,
};
var nashorn = {
  __DIR__: false,
  __FILE__: false,
  __LINE__: false,
  com: false,
  edu: false,
  exit: false,
  java: false,
  Java: false,
  javafx: false,
  JavaImporter: false,
  javax: false,
  JSAdapter: false,
  load: false,
  loadWithNewGlobal: false,
  org: false,
  Packages: false,
  print: false,
  quit: false,
};
var wsh = {
  ActiveXObject: true,
  Enumerator: true,
  GetObject: true,
  ScriptEngine: true,
  ScriptEngineBuildVersion: true,
  ScriptEngineMajorVersion: true,
  ScriptEngineMinorVersion: true,
  VBArray: true,
  WScript: true,
  WSH: true,
  XDomainRequest: true,
};
var jquery = {$: false, jQuery: false};
var yui = {YAHOO: false, YAHOO_config: false, YUI: false, YUI_config: false};
var shelljs = {
  cat: false,
  cd: false,
  chmod: false,
  config: false,
  cp: false,
  dirs: false,
  echo: false,
  env: false,
  error: false,
  exec: false,
  exit: false,
  find: false,
  grep: false,
  ln: false,
  ls: false,
  mkdir: false,
  mv: false,
  popd: false,
  pushd: false,
  pwd: false,
  rm: false,
  sed: false,
  set: false,
  target: false,
  tempdir: false,
  test: false,
  touch: false,
  which: false,
};
var prototypejs = {
  $: false,
  $$: false,
  $A: false,
  $break: false,
  $continue: false,
  $F: false,
  $H: false,
  $R: false,
  $w: false,
  Abstract: false,
  Ajax: false,
  Autocompleter: false,
  Builder: false,
  Class: false,
  Control: false,
  Draggable: false,
  Draggables: false,
  Droppables: false,
  Effect: false,
  Element: false,
  Enumerable: false,
  Event: false,
  Field: false,
  Form: false,
  Hash: false,
  Insertion: false,
  ObjectRange: false,
  PeriodicalExecuter: false,
  Position: false,
  Prototype: false,
  Scriptaculous: false,
  Selector: false,
  Sortable: false,
  SortableObserver: false,
  Sound: false,
  Template: false,
  Toggle: false,
  Try: false,
};
var meteor = {
  _: false,
  $: false,
  Accounts: false,
  AccountsClient: false,
  AccountsCommon: false,
  AccountsServer: false,
  App: false,
  Assets: false,
  Blaze: false,
  check: false,
  Cordova: false,
  DDP: false,
  DDPRateLimiter: false,
  DDPServer: false,
  Deps: false,
  EJSON: false,
  Email: false,
  HTTP: false,
  Log: false,
  Match: false,
  Meteor: false,
  Mongo: false,
  MongoInternals: false,
  Npm: false,
  Package: false,
  Plugin: false,
  process: false,
  Random: false,
  ReactiveDict: false,
  ReactiveVar: false,
  Router: false,
  ServiceConfiguration: false,
  Session: false,
  share: false,
  Spacebars: false,
  Template: false,
  Tinytest: false,
  Tracker: false,
  UI: false,
  Utils: false,
  WebApp: false,
  WebAppInternals: false,
};
var mongo = {
  _isWindows: false,
  _rand: false,
  BulkWriteResult: false,
  cat: false,
  cd: false,
  connect: false,
  db: false,
  getHostName: false,
  getMemInfo: false,
  hostname: false,
  ISODate: false,
  listFiles: false,
  load: false,
  ls: false,
  md5sumFile: false,
  mkdir: false,
  Mongo: false,
  NumberInt: false,
  NumberLong: false,
  ObjectId: false,
  PlanCache: false,
  print: false,
  printjson: false,
  pwd: false,
  quit: false,
  removeFile: false,
  rs: false,
  sh: false,
  UUID: false,
  version: false,
  WriteResult: false,
};
var applescript = {
  $: false,
  Application: false,
  Automation: false,
  console: false,
  delay: false,
  Library: false,
  ObjC: false,
  ObjectSpecifier: false,
  Path: false,
  Progress: false,
  Ref: false,
};
var serviceworker = {
  addEventListener: false,
  applicationCache: false,
  atob: false,
  Blob: false,
  BroadcastChannel: false,
  btoa: false,
  Cache: false,
  caches: false,
  CacheStorage: false,
  clearInterval: false,
  clearTimeout: false,
  Client: false,
  clients: false,
  Clients: false,
  close: true,
  console: false,
  ExtendableEvent: false,
  ExtendableMessageEvent: false,
  fetch: false,
  FetchEvent: false,
  FileReaderSync: false,
  FormData: false,
  Headers: false,
  IDBCursor: false,
  IDBCursorWithValue: false,
  IDBDatabase: false,
  IDBFactory: false,
  IDBIndex: false,
  IDBKeyRange: false,
  IDBObjectStore: false,
  IDBOpenDBRequest: false,
  IDBRequest: false,
  IDBTransaction: false,
  IDBVersionChangeEvent: false,
  ImageData: false,
  importScripts: false,
  indexedDB: false,
  location: false,
  MessageChannel: false,
  MessagePort: false,
  name: false,
  navigator: false,
  Notification: false,
  onclose: true,
  onconnect: true,
  onerror: true,
  onfetch: true,
  oninstall: true,
  onlanguagechange: true,
  onmessage: true,
  onmessageerror: true,
  onnotificationclick: true,
  onnotificationclose: true,
  onoffline: true,
  ononline: true,
  onpush: true,
  onpushsubscriptionchange: true,
  onrejectionhandled: true,
  onsync: true,
  onunhandledrejection: true,
  performance: false,
  Performance: false,
  PerformanceEntry: false,
  PerformanceMark: false,
  PerformanceMeasure: false,
  PerformanceNavigation: false,
  PerformanceResourceTiming: false,
  PerformanceTiming: false,
  postMessage: true,
  Promise: false,
  queueMicrotask: false,
  registration: false,
  removeEventListener: false,
  Request: false,
  Response: false,
  self: false,
  ServiceWorker: false,
  ServiceWorkerContainer: false,
  ServiceWorkerGlobalScope: false,
  ServiceWorkerMessageEvent: false,
  ServiceWorkerRegistration: false,
  setInterval: false,
  setTimeout: false,
  skipWaiting: false,
  TextDecoder: false,
  TextEncoder: false,
  URL: false,
  URLSearchParams: false,
  WebSocket: false,
  WindowClient: false,
  Worker: false,
  WorkerGlobalScope: false,
  XMLHttpRequest: false,
};
var atomtest = {
  advanceClock: false,
  fakeClearInterval: false,
  fakeClearTimeout: false,
  fakeSetInterval: false,
  fakeSetTimeout: false,
  resetTimeouts: false,
  waitsForPromise: false,
};
var embertest = {
  andThen: false,
  click: false,
  currentPath: false,
  currentRouteName: false,
  currentURL: false,
  fillIn: false,
  find: false,
  findAll: false,
  findWithAssert: false,
  keyEvent: false,
  pauseTest: false,
  resumeTest: false,
  triggerEvent: false,
  visit: false,
  wait: false,
};
var protractor = {
  $: false,
  $$: false,
  browser: false,
  by: false,
  By: false,
  DartObject: false,
  element: false,
  protractor: false,
};
var webextensions = {browser: false, chrome: false, opr: false};
var greasemonkey = {
  cloneInto: false,
  createObjectIn: false,
  exportFunction: false,
  GM: false,
  GM_addStyle: false,
  GM_deleteValue: false,
  GM_getResourceText: false,
  GM_getResourceURL: false,
  GM_getValue: false,
  GM_info: false,
  GM_listValues: false,
  GM_log: false,
  GM_openInTab: false,
  GM_registerMenuCommand: false,
  GM_setClipboard: false,
  GM_setValue: false,
  GM_xmlhttpRequest: false,
  unsafeWindow: false,
};
var devtools = {
  $: false,
  $_: false,
  $$: false,
  $0: false,
  $1: false,
  $2: false,
  $3: false,
  $4: false,
  $x: false,
  chrome: false,
  clear: false,
  copy: false,
  debug: false,
  dir: false,
  dirxml: false,
  getEventListeners: false,
  inspect: false,
  keys: false,
  monitor: false,
  monitorEvents: false,
  profile: false,
  profileEnd: false,
  queryObjects: false,
  table: false,
  undebug: false,
  unmonitor: false,
  unmonitorEvents: false,
  values: false,
};
var require$$0$1 = {
  builtin: builtin,
  es5: es5,
  es2015: es2015,
  es2017: es2017,
  browser: browser$1,
  worker: worker,
  node: node$3,
  commonjs: commonjs,
  amd: amd,
  mocha: mocha,
  jasmine: jasmine,
  jest: jest,
  qunit: qunit,
  phantomjs: phantomjs,
  couch: couch,
  rhino: rhino,
  nashorn: nashorn,
  wsh: wsh,
  jquery: jquery,
  yui: yui,
  shelljs: shelljs,
  prototypejs: prototypejs,
  meteor: meteor,
  mongo: mongo,
  applescript: applescript,
  serviceworker: serviceworker,
  atomtest: atomtest,
  embertest: embertest,
  protractor: protractor,
  'shared-node-browser': {
    clearInterval: false,
    clearTimeout: false,
    console: false,
    setInterval: false,
    setTimeout: false,
    URL: false,
    URLSearchParams: false,
  },
  webextensions: webextensions,
  greasemonkey: greasemonkey,
  devtools: devtools,
};
var globals;
var hasRequiredGlobals;
function requireGlobals() {
  if (hasRequiredGlobals) return globals;
  hasRequiredGlobals = 1;
  globals = require$$0$1;
  return globals;
}
var cache$1 = {};
var hasRequiredCache$1;
function requireCache$1() {
  if (hasRequiredCache$1) return cache$1;
  hasRequiredCache$1 = 1;
  Object.defineProperty(cache$1, '__esModule', {value: true});
  cache$1.clear = clear;
  cache$1.clearPath = clearPath;
  cache$1.clearScope = clearScope;
  cache$1.getCachedPaths = getCachedPaths;
  cache$1.getOrCreateCachedPaths = getOrCreateCachedPaths;
  cache$1.scope = cache$1.path = void 0;
  let pathsCache = (cache$1.path = new WeakMap());
  cache$1.scope = new WeakMap();
  function clear() {
    clearPath();
    clearScope();
  }
  function clearPath() {
    cache$1.path = pathsCache = new WeakMap();
  }
  function clearScope() {
    cache$1.scope = new WeakMap();
  }
  const nullHub = Object.freeze({});
  function getCachedPaths(hub, parent) {
    var _pathsCache$get, _hub;
    {
      hub = null;
    }
    return (_pathsCache$get = pathsCache.get(
      (_hub = hub) != null ? _hub : nullHub
    )) == null
      ? void 0
      : _pathsCache$get.get(parent);
  }
  function getOrCreateCachedPaths(hub, parent) {
    var _hub2, _hub3;
    {
      hub = null;
    }
    let parents = pathsCache.get((_hub2 = hub) != null ? _hub2 : nullHub);
    if (!parents)
      pathsCache.set(
        (_hub3 = hub) != null ? _hub3 : nullHub,
        (parents = new WeakMap())
      );
    let paths = parents.get(parent);
    if (!paths) parents.set(parent, (paths = new Map()));
    return paths;
  }
  return cache$1;
}
var hasRequiredScope$1;
function requireScope$1() {
  if (hasRequiredScope$1) return scope$1;
  hasRequiredScope$1 = 1;
  Object.defineProperty(scope$1, '__esModule', {value: true});
  scope$1.default = void 0;
  var _renamer = requireRenamer$1();
  var _index = requireLib$h();
  var _binding = requireBinding$1();
  var _globals = requireGlobals();
  var _t = t$d;
  var t = _t;
  var _cache = requireCache$1();
  var _visitors = requireVisitors$1();
  const {
    NOT_LOCAL_BINDING: NOT_LOCAL_BINDING,
    assignmentExpression: assignmentExpression,
    callExpression: callExpression,
    cloneNode: cloneNode,
    getBindingIdentifiers: getBindingIdentifiers,
    identifier: identifier,
    isArrayExpression: isArrayExpression,
    isBinary: isBinary,
    isCallExpression: isCallExpression,
    isClass: isClass,
    isClassBody: isClassBody,
    isClassDeclaration: isClassDeclaration,
    isExportAllDeclaration: isExportAllDeclaration,
    isExportDefaultDeclaration: isExportDefaultDeclaration,
    isExportNamedDeclaration: isExportNamedDeclaration,
    isFunctionDeclaration: isFunctionDeclaration,
    isIdentifier: isIdentifier,
    isImportDeclaration: isImportDeclaration,
    isLiteral: isLiteral,
    isMemberExpression: isMemberExpression,
    isMethod: isMethod,
    isModuleSpecifier: isModuleSpecifier,
    isNullLiteral: isNullLiteral,
    isObjectExpression: isObjectExpression,
    isProperty: isProperty,
    isPureish: isPureish,
    isRegExpLiteral: isRegExpLiteral,
    isSuper: isSuper,
    isTaggedTemplateExpression: isTaggedTemplateExpression,
    isTemplateLiteral: isTemplateLiteral,
    isThisExpression: isThisExpression,
    isUnaryExpression: isUnaryExpression,
    isVariableDeclaration: isVariableDeclaration,
    expressionStatement: expressionStatement,
    matchesPattern: matchesPattern,
    memberExpression: memberExpression,
    numericLiteral: numericLiteral,
    toIdentifier: toIdentifier,
    variableDeclaration: variableDeclaration,
    variableDeclarator: variableDeclarator,
    isRecordExpression: isRecordExpression,
    isTupleExpression: isTupleExpression,
    isObjectProperty: isObjectProperty,
    isTopicReference: isTopicReference,
    isMetaProperty: isMetaProperty,
    isPrivateName: isPrivateName,
    isExportDeclaration: isExportDeclaration,
    buildUndefinedNode: buildUndefinedNode,
    sequenceExpression: sequenceExpression,
  } = _t;
  function gatherNodeParts(node, parts) {
    switch (node == null ? void 0 : node.type) {
      default:
        if (isImportDeclaration(node) || isExportDeclaration(node)) {
          var _node$specifiers;
          if (
            (isExportAllDeclaration(node) ||
              isExportNamedDeclaration(node) ||
              isImportDeclaration(node)) &&
            node.source
          ) {
            gatherNodeParts(node.source, parts);
          } else if (
            (isExportNamedDeclaration(node) || isImportDeclaration(node)) &&
            (_node$specifiers = node.specifiers) != null &&
            _node$specifiers.length
          ) {
            for (const e of node.specifiers) gatherNodeParts(e, parts);
          } else if (
            (isExportDefaultDeclaration(node) ||
              isExportNamedDeclaration(node)) &&
            node.declaration
          ) {
            gatherNodeParts(node.declaration, parts);
          }
        } else if (isModuleSpecifier(node)) {
          gatherNodeParts(node.local, parts);
        } else if (
          isLiteral(node) &&
          !isNullLiteral(node) &&
          !isRegExpLiteral(node) &&
          !isTemplateLiteral(node)
        ) {
          parts.push(node.value);
        }
        break;
      case 'MemberExpression':
      case 'OptionalMemberExpression':
      case 'JSXMemberExpression':
        gatherNodeParts(node.object, parts);
        gatherNodeParts(node.property, parts);
        break;
      case 'Identifier':
      case 'JSXIdentifier':
        parts.push(node.name);
        break;
      case 'CallExpression':
      case 'OptionalCallExpression':
      case 'NewExpression':
        gatherNodeParts(node.callee, parts);
        break;
      case 'ObjectExpression':
      case 'ObjectPattern':
        for (const e of node.properties) {
          gatherNodeParts(e, parts);
        }
        break;
      case 'SpreadElement':
      case 'RestElement':
        gatherNodeParts(node.argument, parts);
        break;
      case 'ObjectProperty':
      case 'ObjectMethod':
      case 'ClassProperty':
      case 'ClassMethod':
      case 'ClassPrivateProperty':
      case 'ClassPrivateMethod':
        gatherNodeParts(node.key, parts);
        break;
      case 'ThisExpression':
        parts.push('this');
        break;
      case 'Super':
        parts.push('super');
        break;
      case 'Import':
        parts.push('import');
        break;
      case 'DoExpression':
        parts.push('do');
        break;
      case 'YieldExpression':
        parts.push('yield');
        gatherNodeParts(node.argument, parts);
        break;
      case 'AwaitExpression':
        parts.push('await');
        gatherNodeParts(node.argument, parts);
        break;
      case 'AssignmentExpression':
        gatherNodeParts(node.left, parts);
        break;
      case 'VariableDeclarator':
        gatherNodeParts(node.id, parts);
        break;
      case 'FunctionExpression':
      case 'FunctionDeclaration':
      case 'ClassExpression':
      case 'ClassDeclaration':
        gatherNodeParts(node.id, parts);
        break;
      case 'PrivateName':
        gatherNodeParts(node.id, parts);
        break;
      case 'ParenthesizedExpression':
        gatherNodeParts(node.expression, parts);
        break;
      case 'UnaryExpression':
      case 'UpdateExpression':
        gatherNodeParts(node.argument, parts);
        break;
      case 'MetaProperty':
        gatherNodeParts(node.meta, parts);
        gatherNodeParts(node.property, parts);
        break;
      case 'JSXElement':
        gatherNodeParts(node.openingElement, parts);
        break;
      case 'JSXOpeningElement':
        gatherNodeParts(node.name, parts);
        break;
      case 'JSXFragment':
        gatherNodeParts(node.openingFragment, parts);
        break;
      case 'JSXOpeningFragment':
        parts.push('Fragment');
        break;
      case 'JSXNamespacedName':
        gatherNodeParts(node.namespace, parts);
        gatherNodeParts(node.name, parts);
        break;
    }
  }
  const collectorVisitor = {
    ForStatement(path) {
      const declar = path.get('init');
      if (declar.isVar()) {
        const {scope: scope} = path;
        const parentScope =
          scope.getFunctionParent() || scope.getProgramParent();
        parentScope.registerBinding('var', declar);
      }
    },
    Declaration(path) {
      if (path.isBlockScoped()) return;
      if (path.isImportDeclaration()) return;
      if (path.isExportDeclaration()) return;
      const parent =
        path.scope.getFunctionParent() || path.scope.getProgramParent();
      parent.registerDeclaration(path);
    },
    ImportDeclaration(path) {
      const parent = path.scope.getBlockParent();
      parent.registerDeclaration(path);
    },
    ReferencedIdentifier(path, state) {
      state.references.push(path);
    },
    ForXStatement(path, state) {
      const left = path.get('left');
      if (left.isPattern() || left.isIdentifier()) {
        state.constantViolations.push(path);
      } else if (left.isVar()) {
        const {scope: scope} = path;
        const parentScope =
          scope.getFunctionParent() || scope.getProgramParent();
        parentScope.registerBinding('var', left);
      }
    },
    ExportDeclaration: {
      exit(path) {
        const {node: node, scope: scope} = path;
        if (isExportAllDeclaration(node)) return;
        const declar = node.declaration;
        if (isClassDeclaration(declar) || isFunctionDeclaration(declar)) {
          const id = declar.id;
          if (!id) return;
          const binding = scope.getBinding(id.name);
          binding == null || binding.reference(path);
        } else if (isVariableDeclaration(declar)) {
          for (const decl of declar.declarations) {
            for (const name of Object.keys(getBindingIdentifiers(decl))) {
              const binding = scope.getBinding(name);
              binding == null || binding.reference(path);
            }
          }
        }
      },
    },
    LabeledStatement(path) {
      path.scope.getBlockParent().registerDeclaration(path);
    },
    AssignmentExpression(path, state) {
      state.assignments.push(path);
    },
    UpdateExpression(path, state) {
      state.constantViolations.push(path);
    },
    UnaryExpression(path, state) {
      if (path.node.operator === 'delete') {
        state.constantViolations.push(path);
      }
    },
    BlockScoped(path) {
      let scope = path.scope;
      if (scope.path === path) scope = scope.parent;
      const parent = scope.getBlockParent();
      parent.registerDeclaration(path);
      if (path.isClassDeclaration() && path.node.id) {
        const id = path.node.id;
        const name = id.name;
        path.scope.bindings[name] = path.scope.parent.getBinding(name);
      }
    },
    CatchClause(path) {
      path.scope.registerBinding('let', path);
    },
    Function(path) {
      const params = path.get('params');
      for (const param of params) {
        path.scope.registerBinding('param', param);
      }
      if (
        path.isFunctionExpression() &&
        path.node.id &&
        !path.node.id[NOT_LOCAL_BINDING]
      ) {
        path.scope.registerBinding('local', path.get('id'), path);
      }
    },
    ClassExpression(path) {
      if (path.node.id && !path.node.id[NOT_LOCAL_BINDING]) {
        path.scope.registerBinding('local', path.get('id'), path);
      }
    },
    TSTypeAnnotation(path) {
      path.skip();
    },
  };
  let uid = 0;
  class Scope {
    constructor(path) {
      this.uid = void 0;
      this.path = void 0;
      this.block = void 0;
      this.inited = void 0;
      this.labels = void 0;
      this.bindings = void 0;
      this.references = void 0;
      this.globals = void 0;
      this.uids = void 0;
      this.data = void 0;
      this.crawling = void 0;
      const {node: node} = path;
      const cached = _cache.scope.get(node);
      if ((cached == null ? void 0 : cached.path) === path) {
        return cached;
      }
      _cache.scope.set(node, this);
      this.uid = uid++;
      this.block = node;
      this.path = path;
      this.labels = new Map();
      this.inited = false;
    }
    get parent() {
      var _parent;
      let parent,
        path = this.path;
      do {
        var _path;
        const shouldSkip = path.key === 'key' || path.listKey === 'decorators';
        path = path.parentPath;
        if (shouldSkip && path.isMethod()) path = path.parentPath;
        if ((_path = path) != null && _path.isScope()) parent = path;
      } while (path && !parent);
      return (_parent = parent) == null ? void 0 : _parent.scope;
    }
    generateDeclaredUidIdentifier(name) {
      const id = this.generateUidIdentifier(name);
      this.push({id: id});
      return cloneNode(id);
    }
    generateUidIdentifier(name) {
      return identifier(this.generateUid(name));
    }
    generateUid(name = 'temp') {
      name = toIdentifier(name).replace(/^_+/, '').replace(/\d+$/g, '');
      let uid;
      let i = 1;
      do {
        uid = `_${name}`;
        if (i > 1) uid += i;
        i++;
      } while (
        this.hasLabel(uid) ||
        this.hasBinding(uid) ||
        this.hasGlobal(uid) ||
        this.hasReference(uid)
      );
      const program = this.getProgramParent();
      program.references[uid] = true;
      program.uids[uid] = true;
      return uid;
    }
    generateUidBasedOnNode(node, defaultName) {
      const parts = [];
      gatherNodeParts(node, parts);
      let id = parts.join('$');
      id = id.replace(/^_/, '') || defaultName || 'ref';
      return this.generateUid(id.slice(0, 20));
    }
    generateUidIdentifierBasedOnNode(node, defaultName) {
      return identifier(this.generateUidBasedOnNode(node, defaultName));
    }
    isStatic(node) {
      if (isThisExpression(node) || isSuper(node) || isTopicReference(node)) {
        return true;
      }
      if (isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (binding) {
          return binding.constant;
        } else {
          return this.hasBinding(node.name);
        }
      }
      return false;
    }
    maybeGenerateMemoised(node, dontPush) {
      if (this.isStatic(node)) {
        return null;
      } else {
        const id = this.generateUidIdentifierBasedOnNode(node);
        if (!dontPush) {
          this.push({id: id});
          return cloneNode(id);
        }
        return id;
      }
    }
    checkBlockScopedCollisions(local, kind, name, id) {
      if (kind === 'param') return;
      if (local.kind === 'local') return;
      const duplicate =
        kind === 'let' ||
        local.kind === 'let' ||
        local.kind === 'const' ||
        local.kind === 'module' ||
        (local.kind === 'param' && kind === 'const');
      if (duplicate) {
        throw this.path.hub.buildError(
          id,
          `Duplicate declaration "${name}"`,
          TypeError
        );
      }
    }
    rename(oldName, newName) {
      const binding = this.getBinding(oldName);
      if (binding) {
        newName || (newName = this.generateUidIdentifier(oldName).name);
        const renamer = new _renamer.default(binding, oldName, newName);
        {
          renamer.rename(arguments[2]);
        }
      }
    }
    dump() {
      const sep = '-'.repeat(60);
      console.log(sep);
      let scope = this;
      do {
        console.log('#', scope.block.type);
        for (const name of Object.keys(scope.bindings)) {
          const binding = scope.bindings[name];
          console.log(' -', name, {
            constant: binding.constant,
            references: binding.references,
            violations: binding.constantViolations.length,
            kind: binding.kind,
          });
        }
      } while ((scope = scope.parent));
      console.log(sep);
    }
    hasLabel(name) {
      return !!this.getLabel(name);
    }
    getLabel(name) {
      return this.labels.get(name);
    }
    registerLabel(path) {
      this.labels.set(path.node.label.name, path);
    }
    registerDeclaration(path) {
      if (path.isLabeledStatement()) {
        this.registerLabel(path);
      } else if (path.isFunctionDeclaration()) {
        this.registerBinding('hoisted', path.get('id'), path);
      } else if (path.isVariableDeclaration()) {
        const declarations = path.get('declarations');
        const {kind: kind} = path.node;
        for (const declar of declarations) {
          this.registerBinding(
            kind === 'using' || kind === 'await using' ? 'const' : kind,
            declar
          );
        }
      } else if (path.isClassDeclaration()) {
        if (path.node.declare) return;
        this.registerBinding('let', path);
      } else if (path.isImportDeclaration()) {
        const isTypeDeclaration =
          path.node.importKind === 'type' || path.node.importKind === 'typeof';
        const specifiers = path.get('specifiers');
        for (const specifier of specifiers) {
          const isTypeSpecifier =
            isTypeDeclaration ||
            (specifier.isImportSpecifier() &&
              (specifier.node.importKind === 'type' ||
                specifier.node.importKind === 'typeof'));
          this.registerBinding(
            isTypeSpecifier ? 'unknown' : 'module',
            specifier
          );
        }
      } else if (path.isExportDeclaration()) {
        const declar = path.get('declaration');
        if (
          declar.isClassDeclaration() ||
          declar.isFunctionDeclaration() ||
          declar.isVariableDeclaration()
        ) {
          this.registerDeclaration(declar);
        }
      } else {
        this.registerBinding('unknown', path);
      }
    }
    buildUndefinedNode() {
      return buildUndefinedNode();
    }
    registerConstantViolation(path) {
      const ids = path.getAssignmentIdentifiers();
      for (const name of Object.keys(ids)) {
        var _this$getBinding;
        (_this$getBinding = this.getBinding(name)) == null ||
          _this$getBinding.reassign(path);
      }
    }
    registerBinding(kind, path, bindingPath = path) {
      if (!kind) throw new ReferenceError('no `kind`');
      if (path.isVariableDeclaration()) {
        const declarators = path.get('declarations');
        for (const declar of declarators) {
          this.registerBinding(kind, declar);
        }
        return;
      }
      const parent = this.getProgramParent();
      const ids = path.getOuterBindingIdentifiers(true);
      for (const name of Object.keys(ids)) {
        parent.references[name] = true;
        for (const id of ids[name]) {
          const local = this.getOwnBinding(name);
          if (local) {
            if (local.identifier === id) continue;
            this.checkBlockScopedCollisions(local, kind, name, id);
          }
          if (local) {
            local.reassign(bindingPath);
          } else {
            this.bindings[name] = new _binding.default({
              identifier: id,
              scope: this,
              path: bindingPath,
              kind: kind,
            });
          }
        }
      }
    }
    addGlobal(node) {
      this.globals[node.name] = node;
    }
    hasUid(name) {
      let scope = this;
      do {
        if (scope.uids[name]) return true;
      } while ((scope = scope.parent));
      return false;
    }
    hasGlobal(name) {
      let scope = this;
      do {
        if (scope.globals[name]) return true;
      } while ((scope = scope.parent));
      return false;
    }
    hasReference(name) {
      return !!this.getProgramParent().references[name];
    }
    isPure(node, constantsOnly) {
      if (isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (!binding) return false;
        if (constantsOnly) return binding.constant;
        return true;
      } else if (
        isThisExpression(node) ||
        isMetaProperty(node) ||
        isTopicReference(node) ||
        isPrivateName(node)
      ) {
        return true;
      } else if (isClass(node)) {
        var _node$decorators;
        if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
          return false;
        }
        if (
          ((_node$decorators = node.decorators) == null
            ? void 0
            : _node$decorators.length) > 0
        ) {
          return false;
        }
        return this.isPure(node.body, constantsOnly);
      } else if (isClassBody(node)) {
        for (const method of node.body) {
          if (!this.isPure(method, constantsOnly)) return false;
        }
        return true;
      } else if (isBinary(node)) {
        return (
          this.isPure(node.left, constantsOnly) &&
          this.isPure(node.right, constantsOnly)
        );
      } else if (isArrayExpression(node) || isTupleExpression(node)) {
        for (const elem of node.elements) {
          if (elem !== null && !this.isPure(elem, constantsOnly)) return false;
        }
        return true;
      } else if (isObjectExpression(node) || isRecordExpression(node)) {
        for (const prop of node.properties) {
          if (!this.isPure(prop, constantsOnly)) return false;
        }
        return true;
      } else if (isMethod(node)) {
        var _node$decorators2;
        if (node.computed && !this.isPure(node.key, constantsOnly))
          return false;
        if (
          ((_node$decorators2 = node.decorators) == null
            ? void 0
            : _node$decorators2.length) > 0
        ) {
          return false;
        }
        return true;
      } else if (isProperty(node)) {
        var _node$decorators3;
        if (node.computed && !this.isPure(node.key, constantsOnly))
          return false;
        if (
          ((_node$decorators3 = node.decorators) == null
            ? void 0
            : _node$decorators3.length) > 0
        ) {
          return false;
        }
        if (isObjectProperty(node) || node.static) {
          if (node.value !== null && !this.isPure(node.value, constantsOnly)) {
            return false;
          }
        }
        return true;
      } else if (isUnaryExpression(node)) {
        return this.isPure(node.argument, constantsOnly);
      } else if (isTemplateLiteral(node)) {
        for (const expression of node.expressions) {
          if (!this.isPure(expression, constantsOnly)) return false;
        }
        return true;
      } else if (isTaggedTemplateExpression(node)) {
        return (
          matchesPattern(node.tag, 'String.raw') &&
          !this.hasBinding('String', {noGlobals: true}) &&
          this.isPure(node.quasi, constantsOnly)
        );
      } else if (isMemberExpression(node)) {
        return (
          !node.computed &&
          isIdentifier(node.object) &&
          node.object.name === 'Symbol' &&
          isIdentifier(node.property) &&
          node.property.name !== 'for' &&
          !this.hasBinding('Symbol', {noGlobals: true})
        );
      } else if (isCallExpression(node)) {
        return (
          matchesPattern(node.callee, 'Symbol.for') &&
          !this.hasBinding('Symbol', {noGlobals: true}) &&
          node.arguments.length === 1 &&
          t.isStringLiteral(node.arguments[0])
        );
      } else {
        return isPureish(node);
      }
    }
    setData(key, val) {
      return (this.data[key] = val);
    }
    getData(key) {
      let scope = this;
      do {
        const data = scope.data[key];
        if (data != null) return data;
      } while ((scope = scope.parent));
    }
    removeData(key) {
      let scope = this;
      do {
        const data = scope.data[key];
        if (data != null) scope.data[key] = null;
      } while ((scope = scope.parent));
    }
    init() {
      if (!this.inited) {
        this.inited = true;
        this.crawl();
      }
    }
    crawl() {
      const path = this.path;
      this.references = Object.create(null);
      this.bindings = Object.create(null);
      this.globals = Object.create(null);
      this.uids = Object.create(null);
      this.data = Object.create(null);
      const programParent = this.getProgramParent();
      if (programParent.crawling) return;
      const state = {references: [], constantViolations: [], assignments: []};
      this.crawling = true;
      if (
        path.type !== 'Program' &&
        (0, _visitors.isExplodedVisitor)(collectorVisitor)
      ) {
        for (const visit of collectorVisitor.enter) {
          visit.call(state, path, state);
        }
        const typeVisitors = collectorVisitor[path.type];
        if (typeVisitors) {
          for (const visit of typeVisitors.enter) {
            visit.call(state, path, state);
          }
        }
      }
      path.traverse(collectorVisitor, state);
      this.crawling = false;
      for (const path of state.assignments) {
        const ids = path.getAssignmentIdentifiers();
        for (const name of Object.keys(ids)) {
          if (path.scope.getBinding(name)) continue;
          programParent.addGlobal(ids[name]);
        }
        path.scope.registerConstantViolation(path);
      }
      for (const ref of state.references) {
        const binding = ref.scope.getBinding(ref.node.name);
        if (binding) {
          binding.reference(ref);
        } else {
          programParent.addGlobal(ref.node);
        }
      }
      for (const path of state.constantViolations) {
        path.scope.registerConstantViolation(path);
      }
    }
    push(opts) {
      let path = this.path;
      if (path.isPattern()) {
        path = this.getPatternParent().path;
      } else if (!path.isBlockStatement() && !path.isProgram()) {
        path = this.getBlockParent().path;
      }
      if (path.isSwitchStatement()) {
        path = (this.getFunctionParent() || this.getProgramParent()).path;
      }
      const {init: init, unique: unique, kind: kind = 'var', id: id} = opts;
      if (
        !init &&
        !unique &&
        (kind === 'var' || kind === 'let') &&
        path.isFunction() &&
        !path.node.name &&
        isCallExpression(path.parent, {callee: path.node}) &&
        path.parent.arguments.length <= path.node.params.length &&
        isIdentifier(id)
      ) {
        path.pushContainer('params', id);
        path.scope.registerBinding(
          'param',
          path.get('params')[path.node.params.length - 1]
        );
        return;
      }
      if (path.isLoop() || path.isCatchClause() || path.isFunction()) {
        path.ensureBlock();
        path = path.get('body');
      }
      const blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
      const dataKey = `declaration:${kind}:${blockHoist}`;
      let declarPath = !unique && path.getData(dataKey);
      if (!declarPath) {
        const declar = variableDeclaration(kind, []);
        declar._blockHoist = blockHoist;
        [declarPath] = path.unshiftContainer('body', [declar]);
        if (!unique) path.setData(dataKey, declarPath);
      }
      const declarator = variableDeclarator(id, init);
      const len = declarPath.node.declarations.push(declarator);
      path.scope.registerBinding(kind, declarPath.get('declarations')[len - 1]);
    }
    getProgramParent() {
      let scope = this;
      do {
        if (scope.path.isProgram()) {
          return scope;
        }
      } while ((scope = scope.parent));
      throw new Error("Couldn't find a Program");
    }
    getFunctionParent() {
      let scope = this;
      do {
        if (scope.path.isFunctionParent()) {
          return scope;
        }
      } while ((scope = scope.parent));
      return null;
    }
    getBlockParent() {
      let scope = this;
      do {
        if (scope.path.isBlockParent()) {
          return scope;
        }
      } while ((scope = scope.parent));
      throw new Error(
        "We couldn't find a BlockStatement, For, Switch, Function, Loop or Program..."
      );
    }
    getPatternParent() {
      let scope = this;
      do {
        if (!scope.path.isPattern()) {
          return scope.getBlockParent();
        }
      } while ((scope = scope.parent.parent));
      throw new Error(
        "We couldn't find a BlockStatement, For, Switch, Function, Loop or Program..."
      );
    }
    getAllBindings() {
      const ids = Object.create(null);
      let scope = this;
      do {
        for (const key of Object.keys(scope.bindings)) {
          if (key in ids === false) {
            ids[key] = scope.bindings[key];
          }
        }
        scope = scope.parent;
      } while (scope);
      return ids;
    }
    bindingIdentifierEquals(name, node) {
      return this.getBindingIdentifier(name) === node;
    }
    getBinding(name) {
      let scope = this;
      let previousPath;
      do {
        const binding = scope.getOwnBinding(name);
        if (binding) {
          var _previousPath;
          if (
            (_previousPath = previousPath) != null &&
            _previousPath.isPattern() &&
            binding.kind !== 'param' &&
            binding.kind !== 'local'
          );
          else {
            return binding;
          }
        } else if (
          !binding &&
          name === 'arguments' &&
          scope.path.isFunction() &&
          !scope.path.isArrowFunctionExpression()
        ) {
          break;
        }
        previousPath = scope.path;
      } while ((scope = scope.parent));
    }
    getOwnBinding(name) {
      return this.bindings[name];
    }
    getBindingIdentifier(name) {
      var _this$getBinding2;
      return (_this$getBinding2 = this.getBinding(name)) == null
        ? void 0
        : _this$getBinding2.identifier;
    }
    getOwnBindingIdentifier(name) {
      const binding = this.bindings[name];
      return binding == null ? void 0 : binding.identifier;
    }
    hasOwnBinding(name) {
      return !!this.getOwnBinding(name);
    }
    hasBinding(name, opts) {
      if (!name) return false;
      let scope = this;
      do {
        if (scope.hasOwnBinding(name)) {
          return true;
        }
      } while ((scope = scope.parent));
      let noGlobals;
      let noUids;
      if (typeof opts === 'object') {
        noGlobals = opts.noGlobals;
        noUids = opts.noUids;
      } else if (typeof opts === 'boolean') {
        noGlobals = opts;
      }
      if (!noUids && this.hasUid(name)) return true;
      if (!noGlobals && Scope.globals.includes(name)) return true;
      if (!noGlobals && Scope.contextVariables.includes(name)) return true;
      return false;
    }
    parentHasBinding(name, opts) {
      var _this$parent;
      return (_this$parent = this.parent) == null
        ? void 0
        : _this$parent.hasBinding(name, opts);
    }
    moveBindingTo(name, scope) {
      const info = this.getBinding(name);
      if (info) {
        info.scope.removeOwnBinding(name);
        info.scope = scope;
        scope.bindings[name] = info;
      }
    }
    removeOwnBinding(name) {
      delete this.bindings[name];
    }
    removeBinding(name) {
      var _this$getBinding3;
      (_this$getBinding3 = this.getBinding(name)) == null ||
        _this$getBinding3.scope.removeOwnBinding(name);
      let scope = this;
      do {
        if (scope.uids[name]) {
          scope.uids[name] = false;
        }
      } while ((scope = scope.parent));
    }
    hoistVariables(emit = id => this.push({id: id})) {
      this.crawl();
      const seen = new Set();
      for (const name of Object.keys(this.bindings)) {
        const binding = this.bindings[name];
        if (!binding) continue;
        const {path: path} = binding;
        if (!path.isVariableDeclarator()) continue;
        const {parent: parent, parentPath: parentPath} = path;
        if (parent.kind !== 'var' || seen.has(parent)) continue;
        seen.add(path.parent);
        let firstId;
        const init = [];
        for (const decl of parent.declarations) {
          var _firstId;
          (_firstId = firstId) != null ? _firstId : (firstId = decl.id);
          if (decl.init) {
            init.push(assignmentExpression('=', decl.id, decl.init));
          }
          const ids = Object.keys(
            getBindingIdentifiers(decl, false, true, true)
          );
          for (const name of ids) {
            emit(identifier(name), decl.init != null);
          }
        }
        if (parentPath.parentPath.isFor({left: parent})) {
          parentPath.replaceWith(firstId);
        } else if (init.length === 0) {
          parentPath.remove();
        } else {
          const expr = init.length === 1 ? init[0] : sequenceExpression(init);
          if (parentPath.parentPath.isForStatement({init: parent})) {
            parentPath.replaceWith(expr);
          } else {
            parentPath.replaceWith(expressionStatement(expr));
          }
        }
      }
    }
  }
  scope$1.default = Scope;
  Scope.globals = Object.keys(_globals.builtin);
  Scope.contextVariables = ['arguments', 'undefined', 'Infinity', 'NaN'];
  {
    Scope.prototype._renameFromMap = function _renameFromMap(
      map,
      oldName,
      newName,
      value
    ) {
      if (map[oldName]) {
        map[newName] = value;
        map[oldName] = null;
      }
    };
    Scope.prototype.traverse = function (node, opts, state) {
      (0, _index.default)(node, opts, this, state, this.path);
    };
    Scope.prototype._generateUid = function _generateUid(name, i) {
      let id = name;
      if (i > 1) id += i;
      return `_${id}`;
    };
    Scope.prototype.toArray = function toArray(node, i, arrayLikeIsIterable) {
      if (isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (
          binding != null &&
          binding.constant &&
          binding.path.isGenericType('Array')
        ) {
          return node;
        }
      }
      if (isArrayExpression(node)) {
        return node;
      }
      if (isIdentifier(node, {name: 'arguments'})) {
        return callExpression(
          memberExpression(
            memberExpression(
              memberExpression(identifier('Array'), identifier('prototype')),
              identifier('slice')
            ),
            identifier('call')
          ),
          [node]
        );
      }
      let helperName;
      const args = [node];
      if (i === true) {
        helperName = 'toConsumableArray';
      } else if (typeof i === 'number') {
        args.push(numericLiteral(i));
        helperName = 'slicedToArray';
      } else {
        helperName = 'toArray';
      }
      if (arrayLikeIsIterable) {
        args.unshift(this.path.hub.addHelper(helperName));
        helperName = 'maybeArrayLike';
      }
      return callExpression(this.path.hub.addHelper(helperName), args);
    };
    Scope.prototype.getAllBindingsOfKind = function getAllBindingsOfKind(
      ...kinds
    ) {
      const ids = Object.create(null);
      for (const kind of kinds) {
        let scope = this;
        do {
          for (const name of Object.keys(scope.bindings)) {
            const binding = scope.bindings[name];
            if (binding.kind === kind) ids[name] = binding;
          }
          scope = scope.parent;
        } while (scope);
      }
      return ids;
    };
    Object.defineProperties(Scope.prototype, {
      parentBlock: {
        configurable: true,
        enumerable: true,
        get() {
          return this.path.parent;
        },
      },
      hub: {
        configurable: true,
        enumerable: true,
        get() {
          return this.path.hub;
        },
      },
    });
  }
  return scope$1;
}
var lib$m = {};
var sourceMap$3 = {};
var genMapping_umd = {exports: {}};
var setArray_umd = {exports: {}};
var hasRequiredSetArray_umd;
function requireSetArray_umd() {
  if (hasRequiredSetArray_umd) return setArray_umd.exports;
  hasRequiredSetArray_umd = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(exports);
    })(commonjsGlobal, function (exports) {
      class SetArray {
        constructor() {
          this._indexes = {__proto__: null};
          this.array = [];
        }
      }
      function cast(set) {
        return set;
      }
      function get(setarr, key) {
        return cast(setarr)._indexes[key];
      }
      function put(setarr, key) {
        const index = get(setarr, key);
        if (index !== undefined) return index;
        const {array: array, _indexes: indexes} = cast(setarr);
        const length = array.push(key);
        return (indexes[key] = length - 1);
      }
      function pop(setarr) {
        const {array: array, _indexes: indexes} = cast(setarr);
        if (array.length === 0) return;
        const last = array.pop();
        indexes[last] = undefined;
      }
      function remove(setarr, key) {
        const index = get(setarr, key);
        if (index === undefined) return;
        const {array: array, _indexes: indexes} = cast(setarr);
        for (let i = index + 1; i < array.length; i++) {
          const k = array[i];
          array[i - 1] = k;
          indexes[k]--;
        }
        indexes[key] = undefined;
        array.pop();
      }
      exports.SetArray = SetArray;
      exports.get = get;
      exports.pop = pop;
      exports.put = put;
      exports.remove = remove;
      Object.defineProperty(exports, '__esModule', {value: true});
    });
  })(setArray_umd, setArray_umd.exports);
  return setArray_umd.exports;
}
var sourcemapCodec_umd$2 = {exports: {}};
var hasRequiredSourcemapCodec_umd$2;
function requireSourcemapCodec_umd$2() {
  if (hasRequiredSourcemapCodec_umd$2) return sourcemapCodec_umd$2.exports;
  hasRequiredSourcemapCodec_umd$2 = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(exports);
    })(commonjsGlobal, function (exports) {
      const comma = ','.charCodeAt(0);
      const semicolon = ';'.charCodeAt(0);
      const chars =
        'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
      const intToChar = new Uint8Array(64);
      const charToInt = new Uint8Array(128);
      for (let i = 0; i < chars.length; i++) {
        const c = chars.charCodeAt(i);
        intToChar[i] = c;
        charToInt[c] = i;
      }
      const td =
        typeof TextDecoder !== 'undefined'
          ? new TextDecoder()
          : typeof Buffer !== 'undefined'
            ? {
                decode(buf) {
                  const out = Buffer.from(
                    buf.buffer,
                    buf.byteOffset,
                    buf.byteLength
                  );
                  return out.toString();
                },
              }
            : {
                decode(buf) {
                  let out = '';
                  for (let i = 0; i < buf.length; i++) {
                    out += String.fromCharCode(buf[i]);
                  }
                  return out;
                },
              };
      function decode(mappings) {
        const state = new Int32Array(5);
        const decoded = [];
        let index = 0;
        do {
          const semi = indexOf(mappings, index);
          const line = [];
          let sorted = true;
          let lastCol = 0;
          state[0] = 0;
          for (let i = index; i < semi; i++) {
            let seg;
            i = decodeInteger(mappings, i, state, 0);
            const col = state[0];
            if (col < lastCol) sorted = false;
            lastCol = col;
            if (hasMoreVlq(mappings, i, semi)) {
              i = decodeInteger(mappings, i, state, 1);
              i = decodeInteger(mappings, i, state, 2);
              i = decodeInteger(mappings, i, state, 3);
              if (hasMoreVlq(mappings, i, semi)) {
                i = decodeInteger(mappings, i, state, 4);
                seg = [col, state[1], state[2], state[3], state[4]];
              } else {
                seg = [col, state[1], state[2], state[3]];
              }
            } else {
              seg = [col];
            }
            line.push(seg);
          }
          if (!sorted) sort(line);
          decoded.push(line);
          index = semi + 1;
        } while (index <= mappings.length);
        return decoded;
      }
      function indexOf(mappings, index) {
        const idx = mappings.indexOf(';', index);
        return idx === -1 ? mappings.length : idx;
      }
      function decodeInteger(mappings, pos, state, j) {
        let value = 0;
        let shift = 0;
        let integer = 0;
        do {
          const c = mappings.charCodeAt(pos++);
          integer = charToInt[c];
          value |= (integer & 31) << shift;
          shift += 5;
        } while (integer & 32);
        const shouldNegate = value & 1;
        value >>>= 1;
        if (shouldNegate) {
          value = -2147483648 | -value;
        }
        state[j] += value;
        return pos;
      }
      function hasMoreVlq(mappings, i, length) {
        if (i >= length) return false;
        return mappings.charCodeAt(i) !== comma;
      }
      function sort(line) {
        line.sort(sortComparator);
      }
      function sortComparator(a, b) {
        return a[0] - b[0];
      }
      function encode(decoded) {
        const state = new Int32Array(5);
        const bufLength = 1024 * 16;
        const subLength = bufLength - 36;
        const buf = new Uint8Array(bufLength);
        const sub = buf.subarray(0, subLength);
        let pos = 0;
        let out = '';
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          if (i > 0) {
            if (pos === bufLength) {
              out += td.decode(buf);
              pos = 0;
            }
            buf[pos++] = semicolon;
          }
          if (line.length === 0) continue;
          state[0] = 0;
          for (let j = 0; j < line.length; j++) {
            const segment = line[j];
            if (pos > subLength) {
              out += td.decode(sub);
              buf.copyWithin(0, subLength, pos);
              pos -= subLength;
            }
            if (j > 0) buf[pos++] = comma;
            pos = encodeInteger(buf, pos, state, segment, 0);
            if (segment.length === 1) continue;
            pos = encodeInteger(buf, pos, state, segment, 1);
            pos = encodeInteger(buf, pos, state, segment, 2);
            pos = encodeInteger(buf, pos, state, segment, 3);
            if (segment.length === 4) continue;
            pos = encodeInteger(buf, pos, state, segment, 4);
          }
        }
        return out + td.decode(buf.subarray(0, pos));
      }
      function encodeInteger(buf, pos, state, segment, j) {
        const next = segment[j];
        let num = next - state[j];
        state[j] = next;
        num = num < 0 ? (-num << 1) | 1 : num << 1;
        do {
          let clamped = num & 31;
          num >>>= 5;
          if (num > 0) clamped |= 32;
          buf[pos++] = intToChar[clamped];
        } while (num > 0);
        return pos;
      }
      exports.decode = decode;
      exports.encode = encode;
      Object.defineProperty(exports, '__esModule', {value: true});
    });
  })(sourcemapCodec_umd$2, sourcemapCodec_umd$2.exports);
  return sourcemapCodec_umd$2.exports;
}
var traceMapping_umd$1 = {exports: {}};
var sourcemapCodec_umd$1 = {exports: {}};
var hasRequiredSourcemapCodec_umd$1;
function requireSourcemapCodec_umd$1() {
  if (hasRequiredSourcemapCodec_umd$1) return sourcemapCodec_umd$1.exports;
  hasRequiredSourcemapCodec_umd$1 = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(exports);
    })(commonjsGlobal, function (exports) {
      const comma = ','.charCodeAt(0);
      const semicolon = ';'.charCodeAt(0);
      const chars =
        'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
      const intToChar = new Uint8Array(64);
      const charToInt = new Uint8Array(128);
      for (let i = 0; i < chars.length; i++) {
        const c = chars.charCodeAt(i);
        intToChar[i] = c;
        charToInt[c] = i;
      }
      const td =
        typeof TextDecoder !== 'undefined'
          ? new TextDecoder()
          : typeof Buffer !== 'undefined'
            ? {
                decode(buf) {
                  const out = Buffer.from(
                    buf.buffer,
                    buf.byteOffset,
                    buf.byteLength
                  );
                  return out.toString();
                },
              }
            : {
                decode(buf) {
                  let out = '';
                  for (let i = 0; i < buf.length; i++) {
                    out += String.fromCharCode(buf[i]);
                  }
                  return out;
                },
              };
      function decode(mappings) {
        const state = new Int32Array(5);
        const decoded = [];
        let index = 0;
        do {
          const semi = indexOf(mappings, index);
          const line = [];
          let sorted = true;
          let lastCol = 0;
          state[0] = 0;
          for (let i = index; i < semi; i++) {
            let seg;
            i = decodeInteger(mappings, i, state, 0);
            const col = state[0];
            if (col < lastCol) sorted = false;
            lastCol = col;
            if (hasMoreVlq(mappings, i, semi)) {
              i = decodeInteger(mappings, i, state, 1);
              i = decodeInteger(mappings, i, state, 2);
              i = decodeInteger(mappings, i, state, 3);
              if (hasMoreVlq(mappings, i, semi)) {
                i = decodeInteger(mappings, i, state, 4);
                seg = [col, state[1], state[2], state[3], state[4]];
              } else {
                seg = [col, state[1], state[2], state[3]];
              }
            } else {
              seg = [col];
            }
            line.push(seg);
          }
          if (!sorted) sort(line);
          decoded.push(line);
          index = semi + 1;
        } while (index <= mappings.length);
        return decoded;
      }
      function indexOf(mappings, index) {
        const idx = mappings.indexOf(';', index);
        return idx === -1 ? mappings.length : idx;
      }
      function decodeInteger(mappings, pos, state, j) {
        let value = 0;
        let shift = 0;
        let integer = 0;
        do {
          const c = mappings.charCodeAt(pos++);
          integer = charToInt[c];
          value |= (integer & 31) << shift;
          shift += 5;
        } while (integer & 32);
        const shouldNegate = value & 1;
        value >>>= 1;
        if (shouldNegate) {
          value = -2147483648 | -value;
        }
        state[j] += value;
        return pos;
      }
      function hasMoreVlq(mappings, i, length) {
        if (i >= length) return false;
        return mappings.charCodeAt(i) !== comma;
      }
      function sort(line) {
        line.sort(sortComparator);
      }
      function sortComparator(a, b) {
        return a[0] - b[0];
      }
      function encode(decoded) {
        const state = new Int32Array(5);
        const bufLength = 1024 * 16;
        const subLength = bufLength - 36;
        const buf = new Uint8Array(bufLength);
        const sub = buf.subarray(0, subLength);
        let pos = 0;
        let out = '';
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          if (i > 0) {
            if (pos === bufLength) {
              out += td.decode(buf);
              pos = 0;
            }
            buf[pos++] = semicolon;
          }
          if (line.length === 0) continue;
          state[0] = 0;
          for (let j = 0; j < line.length; j++) {
            const segment = line[j];
            if (pos > subLength) {
              out += td.decode(sub);
              buf.copyWithin(0, subLength, pos);
              pos -= subLength;
            }
            if (j > 0) buf[pos++] = comma;
            pos = encodeInteger(buf, pos, state, segment, 0);
            if (segment.length === 1) continue;
            pos = encodeInteger(buf, pos, state, segment, 1);
            pos = encodeInteger(buf, pos, state, segment, 2);
            pos = encodeInteger(buf, pos, state, segment, 3);
            if (segment.length === 4) continue;
            pos = encodeInteger(buf, pos, state, segment, 4);
          }
        }
        return out + td.decode(buf.subarray(0, pos));
      }
      function encodeInteger(buf, pos, state, segment, j) {
        const next = segment[j];
        let num = next - state[j];
        state[j] = next;
        num = num < 0 ? (-num << 1) | 1 : num << 1;
        do {
          let clamped = num & 31;
          num >>>= 5;
          if (num > 0) clamped |= 32;
          buf[pos++] = intToChar[clamped];
        } while (num > 0);
        return pos;
      }
      exports.decode = decode;
      exports.encode = encode;
      Object.defineProperty(exports, '__esModule', {value: true});
    });
  })(sourcemapCodec_umd$1, sourcemapCodec_umd$1.exports);
  return sourcemapCodec_umd$1.exports;
}
var resolveUri_umd$1 = {exports: {}};
var hasRequiredResolveUri_umd$1;
function requireResolveUri_umd$1() {
  if (hasRequiredResolveUri_umd$1) return resolveUri_umd$1.exports;
  hasRequiredResolveUri_umd$1 = 1;
  (function (module, exports) {
    (function (global, factory) {
      module.exports = factory();
    })(commonjsGlobal, function () {
      const schemeRegex = /^[\w+.-]+:\/\//;
      const urlRegex =
        /^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/;
      const fileRegex =
        /^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;
      function isAbsoluteUrl(input) {
        return schemeRegex.test(input);
      }
      function isSchemeRelativeUrl(input) {
        return input.startsWith('//');
      }
      function isAbsolutePath(input) {
        return input.startsWith('/');
      }
      function isFileUrl(input) {
        return input.startsWith('file:');
      }
      function isRelative(input) {
        return /^[.?#]/.test(input);
      }
      function parseAbsoluteUrl(input) {
        const match = urlRegex.exec(input);
        return makeUrl(
          match[1],
          match[2] || '',
          match[3],
          match[4] || '',
          match[5] || '/',
          match[6] || '',
          match[7] || ''
        );
      }
      function parseFileUrl(input) {
        const match = fileRegex.exec(input);
        const path = match[2];
        return makeUrl(
          'file:',
          '',
          match[1] || '',
          '',
          isAbsolutePath(path) ? path : '/' + path,
          match[3] || '',
          match[4] || ''
        );
      }
      function makeUrl(scheme, user, host, port, path, query, hash) {
        return {
          scheme: scheme,
          user: user,
          host: host,
          port: port,
          path: path,
          query: query,
          hash: hash,
          type: 7,
        };
      }
      function parseUrl(input) {
        if (isSchemeRelativeUrl(input)) {
          const url = parseAbsoluteUrl('http:' + input);
          url.scheme = '';
          url.type = 6;
          return url;
        }
        if (isAbsolutePath(input)) {
          const url = parseAbsoluteUrl('http://foo.com' + input);
          url.scheme = '';
          url.host = '';
          url.type = 5;
          return url;
        }
        if (isFileUrl(input)) return parseFileUrl(input);
        if (isAbsoluteUrl(input)) return parseAbsoluteUrl(input);
        const url = parseAbsoluteUrl('http://foo.com/' + input);
        url.scheme = '';
        url.host = '';
        url.type = input
          ? input.startsWith('?')
            ? 3
            : input.startsWith('#')
              ? 2
              : 4
          : 1;
        return url;
      }
      function stripPathFilename(path) {
        if (path.endsWith('/..')) return path;
        const index = path.lastIndexOf('/');
        return path.slice(0, index + 1);
      }
      function mergePaths(url, base) {
        normalizePath(base, base.type);
        if (url.path === '/') {
          url.path = base.path;
        } else {
          url.path = stripPathFilename(base.path) + url.path;
        }
      }
      function normalizePath(url, type) {
        const rel = type <= 4;
        const pieces = url.path.split('/');
        let pointer = 1;
        let positive = 0;
        let addTrailingSlash = false;
        for (let i = 1; i < pieces.length; i++) {
          const piece = pieces[i];
          if (!piece) {
            addTrailingSlash = true;
            continue;
          }
          addTrailingSlash = false;
          if (piece === '.') continue;
          if (piece === '..') {
            if (positive) {
              addTrailingSlash = true;
              positive--;
              pointer--;
            } else if (rel) {
              pieces[pointer++] = piece;
            }
            continue;
          }
          pieces[pointer++] = piece;
          positive++;
        }
        let path = '';
        for (let i = 1; i < pointer; i++) {
          path += '/' + pieces[i];
        }
        if (!path || (addTrailingSlash && !path.endsWith('/..'))) {
          path += '/';
        }
        url.path = path;
      }
      function resolve(input, base) {
        if (!input && !base) return '';
        const url = parseUrl(input);
        let inputType = url.type;
        if (base && inputType !== 7) {
          const baseUrl = parseUrl(base);
          const baseType = baseUrl.type;
          switch (inputType) {
            case 1:
              url.hash = baseUrl.hash;
            case 2:
              url.query = baseUrl.query;
            case 3:
            case 4:
              mergePaths(url, baseUrl);
            case 5:
              url.user = baseUrl.user;
              url.host = baseUrl.host;
              url.port = baseUrl.port;
            case 6:
              url.scheme = baseUrl.scheme;
          }
          if (baseType > inputType) inputType = baseType;
        }
        normalizePath(url, inputType);
        const queryHash = url.query + url.hash;
        switch (inputType) {
          case 2:
          case 3:
            return queryHash;
          case 4: {
            const path = url.path.slice(1);
            if (!path) return queryHash || '.';
            if (isRelative(base || input) && !isRelative(path)) {
              return './' + path + queryHash;
            }
            return path + queryHash;
          }
          case 5:
            return url.path + queryHash;
          default:
            return (
              url.scheme +
              '//' +
              url.user +
              url.host +
              url.port +
              url.path +
              queryHash
            );
        }
      }
      return resolve;
    });
  })(resolveUri_umd$1);
  return resolveUri_umd$1.exports;
}
var hasRequiredTraceMapping_umd$1;
function requireTraceMapping_umd$1() {
  if (hasRequiredTraceMapping_umd$1) return traceMapping_umd$1.exports;
  hasRequiredTraceMapping_umd$1 = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(
        exports,
        requireSourcemapCodec_umd$1(),
        requireResolveUri_umd$1()
      );
    })(commonjsGlobal, function (exports, sourcemapCodec, resolveUri) {
      function resolve(input, base) {
        if (base && !base.endsWith('/')) base += '/';
        return resolveUri(input, base);
      }
      function stripFilename(path) {
        if (!path) return '';
        const index = path.lastIndexOf('/');
        return path.slice(0, index + 1);
      }
      const COLUMN = 0;
      const SOURCES_INDEX = 1;
      const SOURCE_LINE = 2;
      const SOURCE_COLUMN = 3;
      const NAMES_INDEX = 4;
      const REV_GENERATED_LINE = 1;
      const REV_GENERATED_COLUMN = 2;
      function maybeSort(mappings, owned) {
        const unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
        if (unsortedIndex === mappings.length) return mappings;
        if (!owned) mappings = mappings.slice();
        for (
          let i = unsortedIndex;
          i < mappings.length;
          i = nextUnsortedSegmentLine(mappings, i + 1)
        ) {
          mappings[i] = sortSegments(mappings[i], owned);
        }
        return mappings;
      }
      function nextUnsortedSegmentLine(mappings, start) {
        for (let i = start; i < mappings.length; i++) {
          if (!isSorted(mappings[i])) return i;
        }
        return mappings.length;
      }
      function isSorted(line) {
        for (let j = 1; j < line.length; j++) {
          if (line[j][COLUMN] < line[j - 1][COLUMN]) {
            return false;
          }
        }
        return true;
      }
      function sortSegments(line, owned) {
        if (!owned) line = line.slice();
        return line.sort(sortComparator);
      }
      function sortComparator(a, b) {
        return a[COLUMN] - b[COLUMN];
      }
      let found = false;
      function binarySearch(haystack, needle, low, high) {
        while (low <= high) {
          const mid = low + ((high - low) >> 1);
          const cmp = haystack[mid][COLUMN] - needle;
          if (cmp === 0) {
            found = true;
            return mid;
          }
          if (cmp < 0) {
            low = mid + 1;
          } else {
            high = mid - 1;
          }
        }
        found = false;
        return low - 1;
      }
      function upperBound(haystack, needle, index) {
        for (let i = index + 1; i < haystack.length; index = i++) {
          if (haystack[i][COLUMN] !== needle) break;
        }
        return index;
      }
      function lowerBound(haystack, needle, index) {
        for (let i = index - 1; i >= 0; index = i--) {
          if (haystack[i][COLUMN] !== needle) break;
        }
        return index;
      }
      function memoizedState() {
        return {lastKey: -1, lastNeedle: -1, lastIndex: -1};
      }
      function memoizedBinarySearch(haystack, needle, state, key) {
        const {
          lastKey: lastKey,
          lastNeedle: lastNeedle,
          lastIndex: lastIndex,
        } = state;
        let low = 0;
        let high = haystack.length - 1;
        if (key === lastKey) {
          if (needle === lastNeedle) {
            found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
            return lastIndex;
          }
          if (needle >= lastNeedle) {
            low = lastIndex === -1 ? 0 : lastIndex;
          } else {
            high = lastIndex;
          }
        }
        state.lastKey = key;
        state.lastNeedle = needle;
        return (state.lastIndex = binarySearch(haystack, needle, low, high));
      }
      function buildBySources(decoded, memos) {
        const sources = memos.map(buildNullArray);
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          for (let j = 0; j < line.length; j++) {
            const seg = line[j];
            if (seg.length === 1) continue;
            const sourceIndex = seg[SOURCES_INDEX];
            const sourceLine = seg[SOURCE_LINE];
            const sourceColumn = seg[SOURCE_COLUMN];
            const originalSource = sources[sourceIndex];
            const originalLine =
              originalSource[sourceLine] || (originalSource[sourceLine] = []);
            const memo = memos[sourceIndex];
            let index = upperBound(
              originalLine,
              sourceColumn,
              memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine)
            );
            memo.lastIndex = ++index;
            insert(originalLine, index, [sourceColumn, i, seg[COLUMN]]);
          }
        }
        return sources;
      }
      function insert(array, index, value) {
        for (let i = array.length; i > index; i--) {
          array[i] = array[i - 1];
        }
        array[index] = value;
      }
      function buildNullArray() {
        return {__proto__: null};
      }
      const AnyMap = function (map, mapUrl) {
        const parsed = parse(map);
        if (!('sections' in parsed)) {
          return new TraceMap(parsed, mapUrl);
        }
        const mappings = [];
        const sources = [];
        const sourcesContent = [];
        const names = [];
        const ignoreList = [];
        recurse(
          parsed,
          mapUrl,
          mappings,
          sources,
          sourcesContent,
          names,
          ignoreList,
          0,
          0,
          Infinity,
          Infinity
        );
        const joined = {
          version: 3,
          file: parsed.file,
          names: names,
          sources: sources,
          sourcesContent: sourcesContent,
          mappings: mappings,
          ignoreList: ignoreList,
        };
        return presortedDecodedMap(joined);
      };
      function parse(map) {
        return typeof map === 'string' ? JSON.parse(map) : map;
      }
      function recurse(
        input,
        mapUrl,
        mappings,
        sources,
        sourcesContent,
        names,
        ignoreList,
        lineOffset,
        columnOffset,
        stopLine,
        stopColumn
      ) {
        const {sections: sections} = input;
        for (let i = 0; i < sections.length; i++) {
          const {map: map, offset: offset} = sections[i];
          let sl = stopLine;
          let sc = stopColumn;
          if (i + 1 < sections.length) {
            const nextOffset = sections[i + 1].offset;
            sl = Math.min(stopLine, lineOffset + nextOffset.line);
            if (sl === stopLine) {
              sc = Math.min(stopColumn, columnOffset + nextOffset.column);
            } else if (sl < stopLine) {
              sc = columnOffset + nextOffset.column;
            }
          }
          addSection(
            map,
            mapUrl,
            mappings,
            sources,
            sourcesContent,
            names,
            ignoreList,
            lineOffset + offset.line,
            columnOffset + offset.column,
            sl,
            sc
          );
        }
      }
      function addSection(
        input,
        mapUrl,
        mappings,
        sources,
        sourcesContent,
        names,
        ignoreList,
        lineOffset,
        columnOffset,
        stopLine,
        stopColumn
      ) {
        const parsed = parse(input);
        if ('sections' in parsed) return recurse(...arguments);
        const map = new TraceMap(parsed, mapUrl);
        const sourcesOffset = sources.length;
        const namesOffset = names.length;
        const decoded = decodedMappings(map);
        const {
          resolvedSources: resolvedSources,
          sourcesContent: contents,
          ignoreList: ignores,
        } = map;
        append(sources, resolvedSources);
        append(names, map.names);
        if (contents) append(sourcesContent, contents);
        else
          for (let i = 0; i < resolvedSources.length; i++)
            sourcesContent.push(null);
        if (ignores)
          for (let i = 0; i < ignores.length; i++)
            ignoreList.push(ignores[i] + sourcesOffset);
        for (let i = 0; i < decoded.length; i++) {
          const lineI = lineOffset + i;
          if (lineI > stopLine) return;
          const out = getLine(mappings, lineI);
          const cOffset = i === 0 ? columnOffset : 0;
          const line = decoded[i];
          for (let j = 0; j < line.length; j++) {
            const seg = line[j];
            const column = cOffset + seg[COLUMN];
            if (lineI === stopLine && column >= stopColumn) return;
            if (seg.length === 1) {
              out.push([column]);
              continue;
            }
            const sourcesIndex = sourcesOffset + seg[SOURCES_INDEX];
            const sourceLine = seg[SOURCE_LINE];
            const sourceColumn = seg[SOURCE_COLUMN];
            out.push(
              seg.length === 4
                ? [column, sourcesIndex, sourceLine, sourceColumn]
                : [
                    column,
                    sourcesIndex,
                    sourceLine,
                    sourceColumn,
                    namesOffset + seg[NAMES_INDEX],
                  ]
            );
          }
        }
      }
      function append(arr, other) {
        for (let i = 0; i < other.length; i++) arr.push(other[i]);
      }
      function getLine(arr, index) {
        for (let i = arr.length; i <= index; i++) arr[i] = [];
        return arr[index];
      }
      const LINE_GTR_ZERO =
        '`line` must be greater than 0 (lines start at line 1)';
      const COL_GTR_EQ_ZERO =
        '`column` must be greater than or equal to 0 (columns start at column 0)';
      const LEAST_UPPER_BOUND = -1;
      const GREATEST_LOWER_BOUND = 1;
      class TraceMap {
        constructor(map, mapUrl) {
          const isString = typeof map === 'string';
          if (!isString && map._decodedMemo) return map;
          const parsed = isString ? JSON.parse(map) : map;
          const {
            version: version,
            file: file,
            names: names,
            sourceRoot: sourceRoot,
            sources: sources,
            sourcesContent: sourcesContent,
          } = parsed;
          this.version = version;
          this.file = file;
          this.names = names || [];
          this.sourceRoot = sourceRoot;
          this.sources = sources;
          this.sourcesContent = sourcesContent;
          this.ignoreList =
            parsed.ignoreList || parsed.x_google_ignoreList || undefined;
          const from = resolve(sourceRoot || '', stripFilename(mapUrl));
          this.resolvedSources = sources.map(s => resolve(s || '', from));
          const {mappings: mappings} = parsed;
          if (typeof mappings === 'string') {
            this._encoded = mappings;
            this._decoded = undefined;
          } else {
            this._encoded = undefined;
            this._decoded = maybeSort(mappings, isString);
          }
          this._decodedMemo = memoizedState();
          this._bySources = undefined;
          this._bySourceMemos = undefined;
        }
      }
      function cast(map) {
        return map;
      }
      function encodedMappings(map) {
        var _a;
        var _b;
        return (_a = (_b = cast(map))._encoded) !== null && _a !== void 0
          ? _a
          : (_b._encoded = sourcemapCodec.encode(cast(map)._decoded));
      }
      function decodedMappings(map) {
        var _a;
        return (
          (_a = cast(map))._decoded ||
          (_a._decoded = sourcemapCodec.decode(cast(map)._encoded))
        );
      }
      function traceSegment(map, line, column) {
        const decoded = decodedMappings(map);
        if (line >= decoded.length) return null;
        const segments = decoded[line];
        const index = traceSegmentInternal(
          segments,
          cast(map)._decodedMemo,
          line,
          column,
          GREATEST_LOWER_BOUND
        );
        return index === -1 ? null : segments[index];
      }
      function originalPositionFor(map, needle) {
        let {line: line, column: column, bias: bias} = needle;
        line--;
        if (line < 0) throw new Error(LINE_GTR_ZERO);
        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
        const decoded = decodedMappings(map);
        if (line >= decoded.length) return OMapping(null, null, null, null);
        const segments = decoded[line];
        const index = traceSegmentInternal(
          segments,
          cast(map)._decodedMemo,
          line,
          column,
          bias || GREATEST_LOWER_BOUND
        );
        if (index === -1) return OMapping(null, null, null, null);
        const segment = segments[index];
        if (segment.length === 1) return OMapping(null, null, null, null);
        const {names: names, resolvedSources: resolvedSources} = map;
        return OMapping(
          resolvedSources[segment[SOURCES_INDEX]],
          segment[SOURCE_LINE] + 1,
          segment[SOURCE_COLUMN],
          segment.length === 5 ? names[segment[NAMES_INDEX]] : null
        );
      }
      function generatedPositionFor(map, needle) {
        const {source: source, line: line, column: column, bias: bias} = needle;
        return generatedPosition(
          map,
          source,
          line,
          column,
          bias || GREATEST_LOWER_BOUND,
          false
        );
      }
      function allGeneratedPositionsFor(map, needle) {
        const {source: source, line: line, column: column, bias: bias} = needle;
        return generatedPosition(
          map,
          source,
          line,
          column,
          bias || LEAST_UPPER_BOUND,
          true
        );
      }
      function eachMapping(map, cb) {
        const decoded = decodedMappings(map);
        const {names: names, resolvedSources: resolvedSources} = map;
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          for (let j = 0; j < line.length; j++) {
            const seg = line[j];
            const generatedLine = i + 1;
            const generatedColumn = seg[0];
            let source = null;
            let originalLine = null;
            let originalColumn = null;
            let name = null;
            if (seg.length !== 1) {
              source = resolvedSources[seg[1]];
              originalLine = seg[2] + 1;
              originalColumn = seg[3];
            }
            if (seg.length === 5) name = names[seg[4]];
            cb({
              generatedLine: generatedLine,
              generatedColumn: generatedColumn,
              source: source,
              originalLine: originalLine,
              originalColumn: originalColumn,
              name: name,
            });
          }
        }
      }
      function sourceIndex(map, source) {
        const {sources: sources, resolvedSources: resolvedSources} = map;
        let index = sources.indexOf(source);
        if (index === -1) index = resolvedSources.indexOf(source);
        return index;
      }
      function sourceContentFor(map, source) {
        const {sourcesContent: sourcesContent} = map;
        if (sourcesContent == null) return null;
        const index = sourceIndex(map, source);
        return index === -1 ? null : sourcesContent[index];
      }
      function isIgnored(map, source) {
        const {ignoreList: ignoreList} = map;
        if (ignoreList == null) return false;
        const index = sourceIndex(map, source);
        return index === -1 ? false : ignoreList.includes(index);
      }
      function presortedDecodedMap(map, mapUrl) {
        const tracer = new TraceMap(clone(map, []), mapUrl);
        cast(tracer)._decoded = map.mappings;
        return tracer;
      }
      function decodedMap(map) {
        return clone(map, decodedMappings(map));
      }
      function encodedMap(map) {
        return clone(map, encodedMappings(map));
      }
      function clone(map, mappings) {
        return {
          version: map.version,
          file: map.file,
          names: map.names,
          sourceRoot: map.sourceRoot,
          sources: map.sources,
          sourcesContent: map.sourcesContent,
          mappings: mappings,
          ignoreList: map.ignoreList || map.x_google_ignoreList,
        };
      }
      function OMapping(source, line, column, name) {
        return {source: source, line: line, column: column, name: name};
      }
      function GMapping(line, column) {
        return {line: line, column: column};
      }
      function traceSegmentInternal(segments, memo, line, column, bias) {
        let index = memoizedBinarySearch(segments, column, memo, line);
        if (found) {
          index = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(
            segments,
            column,
            index
          );
        } else if (bias === LEAST_UPPER_BOUND) index++;
        if (index === -1 || index === segments.length) return -1;
        return index;
      }
      function sliceGeneratedPositions(segments, memo, line, column, bias) {
        let min = traceSegmentInternal(
          segments,
          memo,
          line,
          column,
          GREATEST_LOWER_BOUND
        );
        if (!found && bias === LEAST_UPPER_BOUND) min++;
        if (min === -1 || min === segments.length) return [];
        const matchedColumn = found ? column : segments[min][COLUMN];
        if (!found) min = lowerBound(segments, matchedColumn, min);
        const max = upperBound(segments, matchedColumn, min);
        const result = [];
        for (; min <= max; min++) {
          const segment = segments[min];
          result.push(
            GMapping(
              segment[REV_GENERATED_LINE] + 1,
              segment[REV_GENERATED_COLUMN]
            )
          );
        }
        return result;
      }
      function generatedPosition(map, source, line, column, bias, all) {
        var _a;
        line--;
        if (line < 0) throw new Error(LINE_GTR_ZERO);
        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
        const {sources: sources, resolvedSources: resolvedSources} = map;
        let sourceIndex = sources.indexOf(source);
        if (sourceIndex === -1) sourceIndex = resolvedSources.indexOf(source);
        if (sourceIndex === -1) return all ? [] : GMapping(null, null);
        const generated =
          (_a = cast(map))._bySources ||
          (_a._bySources = buildBySources(
            decodedMappings(map),
            (cast(map)._bySourceMemos = sources.map(memoizedState))
          ));
        const segments = generated[sourceIndex][line];
        if (segments == null) return all ? [] : GMapping(null, null);
        const memo = cast(map)._bySourceMemos[sourceIndex];
        if (all)
          return sliceGeneratedPositions(segments, memo, line, column, bias);
        const index = traceSegmentInternal(segments, memo, line, column, bias);
        if (index === -1) return GMapping(null, null);
        const segment = segments[index];
        return GMapping(
          segment[REV_GENERATED_LINE] + 1,
          segment[REV_GENERATED_COLUMN]
        );
      }
      exports.AnyMap = AnyMap;
      exports.GREATEST_LOWER_BOUND = GREATEST_LOWER_BOUND;
      exports.LEAST_UPPER_BOUND = LEAST_UPPER_BOUND;
      exports.TraceMap = TraceMap;
      exports.allGeneratedPositionsFor = allGeneratedPositionsFor;
      exports.decodedMap = decodedMap;
      exports.decodedMappings = decodedMappings;
      exports.eachMapping = eachMapping;
      exports.encodedMap = encodedMap;
      exports.encodedMappings = encodedMappings;
      exports.generatedPositionFor = generatedPositionFor;
      exports.isIgnored = isIgnored;
      exports.originalPositionFor = originalPositionFor;
      exports.presortedDecodedMap = presortedDecodedMap;
      exports.sourceContentFor = sourceContentFor;
      exports.traceSegment = traceSegment;
    });
  })(traceMapping_umd$1, traceMapping_umd$1.exports);
  return traceMapping_umd$1.exports;
}
var hasRequiredGenMapping_umd;
function requireGenMapping_umd() {
  if (hasRequiredGenMapping_umd) return genMapping_umd.exports;
  hasRequiredGenMapping_umd = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(
        exports,
        requireSetArray_umd(),
        requireSourcemapCodec_umd$2(),
        requireTraceMapping_umd$1()
      );
    })(
      commonjsGlobal,
      function (exports, setArray, sourcemapCodec, traceMapping) {
        const COLUMN = 0;
        const SOURCES_INDEX = 1;
        const SOURCE_LINE = 2;
        const SOURCE_COLUMN = 3;
        const NAMES_INDEX = 4;
        const NO_NAME = -1;
        class GenMapping {
          constructor({file: file, sourceRoot: sourceRoot} = {}) {
            this._names = new setArray.SetArray();
            this._sources = new setArray.SetArray();
            this._sourcesContent = [];
            this._mappings = [];
            this.file = file;
            this.sourceRoot = sourceRoot;
            this._ignoreList = new setArray.SetArray();
          }
        }
        function cast(map) {
          return map;
        }
        function addSegment(
          map,
          genLine,
          genColumn,
          source,
          sourceLine,
          sourceColumn,
          name,
          content
        ) {
          return addSegmentInternal(
            false,
            map,
            genLine,
            genColumn,
            source,
            sourceLine,
            sourceColumn,
            name,
            content
          );
        }
        function addMapping(map, mapping) {
          return addMappingInternal(false, map, mapping);
        }
        const maybeAddSegment = (
          map,
          genLine,
          genColumn,
          source,
          sourceLine,
          sourceColumn,
          name,
          content
        ) =>
          addSegmentInternal(
            true,
            map,
            genLine,
            genColumn,
            source,
            sourceLine,
            sourceColumn,
            name,
            content
          );
        const maybeAddMapping = (map, mapping) =>
          addMappingInternal(true, map, mapping);
        function setSourceContent(map, source, content) {
          const {_sources: sources, _sourcesContent: sourcesContent} =
            cast(map);
          const index = setArray.put(sources, source);
          sourcesContent[index] = content;
        }
        function setIgnore(map, source, ignore = true) {
          const {
            _sources: sources,
            _sourcesContent: sourcesContent,
            _ignoreList: ignoreList,
          } = cast(map);
          const index = setArray.put(sources, source);
          if (index === sourcesContent.length) sourcesContent[index] = null;
          if (ignore) setArray.put(ignoreList, index);
          else setArray.remove(ignoreList, index);
        }
        function toDecodedMap(map) {
          const {
            _mappings: mappings,
            _sources: sources,
            _sourcesContent: sourcesContent,
            _names: names,
            _ignoreList: ignoreList,
          } = cast(map);
          removeEmptyFinalLines(mappings);
          return {
            version: 3,
            file: map.file || undefined,
            names: names.array,
            sourceRoot: map.sourceRoot || undefined,
            sources: sources.array,
            sourcesContent: sourcesContent,
            mappings: mappings,
            ignoreList: ignoreList.array,
          };
        }
        function toEncodedMap(map) {
          const decoded = toDecodedMap(map);
          return Object.assign(Object.assign({}, decoded), {
            mappings: sourcemapCodec.encode(decoded.mappings),
          });
        }
        function fromMap(input) {
          const map = new traceMapping.TraceMap(input);
          const gen = new GenMapping({
            file: map.file,
            sourceRoot: map.sourceRoot,
          });
          putAll(cast(gen)._names, map.names);
          putAll(cast(gen)._sources, map.sources);
          cast(gen)._sourcesContent =
            map.sourcesContent || map.sources.map(() => null);
          cast(gen)._mappings = traceMapping.decodedMappings(map);
          if (map.ignoreList) putAll(cast(gen)._ignoreList, map.ignoreList);
          return gen;
        }
        function allMappings(map) {
          const out = [];
          const {
            _mappings: mappings,
            _sources: sources,
            _names: names,
          } = cast(map);
          for (let i = 0; i < mappings.length; i++) {
            const line = mappings[i];
            for (let j = 0; j < line.length; j++) {
              const seg = line[j];
              const generated = {line: i + 1, column: seg[COLUMN]};
              let source = undefined;
              let original = undefined;
              let name = undefined;
              if (seg.length !== 1) {
                source = sources.array[seg[SOURCES_INDEX]];
                original = {
                  line: seg[SOURCE_LINE] + 1,
                  column: seg[SOURCE_COLUMN],
                };
                if (seg.length === 5) name = names.array[seg[NAMES_INDEX]];
              }
              out.push({
                generated: generated,
                source: source,
                original: original,
                name: name,
              });
            }
          }
          return out;
        }
        function addSegmentInternal(
          skipable,
          map,
          genLine,
          genColumn,
          source,
          sourceLine,
          sourceColumn,
          name,
          content
        ) {
          const {
            _mappings: mappings,
            _sources: sources,
            _sourcesContent: sourcesContent,
            _names: names,
          } = cast(map);
          const line = getLine(mappings, genLine);
          const index = getColumnIndex(line, genColumn);
          if (!source) {
            if (skipable && skipSourceless(line, index)) return;
            return insert(line, index, [genColumn]);
          }
          const sourcesIndex = setArray.put(sources, source);
          const namesIndex = name ? setArray.put(names, name) : NO_NAME;
          if (sourcesIndex === sourcesContent.length)
            sourcesContent[sourcesIndex] =
              content !== null && content !== void 0 ? content : null;
          if (
            skipable &&
            skipSource(
              line,
              index,
              sourcesIndex,
              sourceLine,
              sourceColumn,
              namesIndex
            )
          ) {
            return;
          }
          return insert(
            line,
            index,
            name
              ? [genColumn, sourcesIndex, sourceLine, sourceColumn, namesIndex]
              : [genColumn, sourcesIndex, sourceLine, sourceColumn]
          );
        }
        function getLine(mappings, index) {
          for (let i = mappings.length; i <= index; i++) {
            mappings[i] = [];
          }
          return mappings[index];
        }
        function getColumnIndex(line, genColumn) {
          let index = line.length;
          for (let i = index - 1; i >= 0; index = i--) {
            const current = line[i];
            if (genColumn >= current[COLUMN]) break;
          }
          return index;
        }
        function insert(array, index, value) {
          for (let i = array.length; i > index; i--) {
            array[i] = array[i - 1];
          }
          array[index] = value;
        }
        function removeEmptyFinalLines(mappings) {
          const {length: length} = mappings;
          let len = length;
          for (let i = len - 1; i >= 0; len = i, i--) {
            if (mappings[i].length > 0) break;
          }
          if (len < length) mappings.length = len;
        }
        function putAll(setarr, array) {
          for (let i = 0; i < array.length; i++) setArray.put(setarr, array[i]);
        }
        function skipSourceless(line, index) {
          if (index === 0) return true;
          const prev = line[index - 1];
          return prev.length === 1;
        }
        function skipSource(
          line,
          index,
          sourcesIndex,
          sourceLine,
          sourceColumn,
          namesIndex
        ) {
          if (index === 0) return false;
          const prev = line[index - 1];
          if (prev.length === 1) return false;
          return (
            sourcesIndex === prev[SOURCES_INDEX] &&
            sourceLine === prev[SOURCE_LINE] &&
            sourceColumn === prev[SOURCE_COLUMN] &&
            namesIndex === (prev.length === 5 ? prev[NAMES_INDEX] : NO_NAME)
          );
        }
        function addMappingInternal(skipable, map, mapping) {
          const {
            generated: generated,
            source: source,
            original: original,
            name: name,
            content: content,
          } = mapping;
          if (!source) {
            return addSegmentInternal(
              skipable,
              map,
              generated.line - 1,
              generated.column,
              null,
              null,
              null,
              null,
              null
            );
          }
          return addSegmentInternal(
            skipable,
            map,
            generated.line - 1,
            generated.column,
            source,
            original.line - 1,
            original.column,
            name,
            content
          );
        }
        exports.GenMapping = GenMapping;
        exports.addMapping = addMapping;
        exports.addSegment = addSegment;
        exports.allMappings = allMappings;
        exports.fromMap = fromMap;
        exports.maybeAddMapping = maybeAddMapping;
        exports.maybeAddSegment = maybeAddSegment;
        exports.setIgnore = setIgnore;
        exports.setSourceContent = setSourceContent;
        exports.toDecodedMap = toDecodedMap;
        exports.toEncodedMap = toEncodedMap;
        Object.defineProperty(exports, '__esModule', {value: true});
      }
    );
  })(genMapping_umd, genMapping_umd.exports);
  return genMapping_umd.exports;
}
var traceMapping_umd = {exports: {}};
var sourcemapCodec_umd = {exports: {}};
var hasRequiredSourcemapCodec_umd;
function requireSourcemapCodec_umd() {
  if (hasRequiredSourcemapCodec_umd) return sourcemapCodec_umd.exports;
  hasRequiredSourcemapCodec_umd = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(exports);
    })(commonjsGlobal, function (exports) {
      const comma = ','.charCodeAt(0);
      const semicolon = ';'.charCodeAt(0);
      const chars =
        'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
      const intToChar = new Uint8Array(64);
      const charToInt = new Uint8Array(128);
      for (let i = 0; i < chars.length; i++) {
        const c = chars.charCodeAt(i);
        intToChar[i] = c;
        charToInt[c] = i;
      }
      const td =
        typeof TextDecoder !== 'undefined'
          ? new TextDecoder()
          : typeof Buffer !== 'undefined'
            ? {
                decode(buf) {
                  const out = Buffer.from(
                    buf.buffer,
                    buf.byteOffset,
                    buf.byteLength
                  );
                  return out.toString();
                },
              }
            : {
                decode(buf) {
                  let out = '';
                  for (let i = 0; i < buf.length; i++) {
                    out += String.fromCharCode(buf[i]);
                  }
                  return out;
                },
              };
      function decode(mappings) {
        const state = new Int32Array(5);
        const decoded = [];
        let index = 0;
        do {
          const semi = indexOf(mappings, index);
          const line = [];
          let sorted = true;
          let lastCol = 0;
          state[0] = 0;
          for (let i = index; i < semi; i++) {
            let seg;
            i = decodeInteger(mappings, i, state, 0);
            const col = state[0];
            if (col < lastCol) sorted = false;
            lastCol = col;
            if (hasMoreVlq(mappings, i, semi)) {
              i = decodeInteger(mappings, i, state, 1);
              i = decodeInteger(mappings, i, state, 2);
              i = decodeInteger(mappings, i, state, 3);
              if (hasMoreVlq(mappings, i, semi)) {
                i = decodeInteger(mappings, i, state, 4);
                seg = [col, state[1], state[2], state[3], state[4]];
              } else {
                seg = [col, state[1], state[2], state[3]];
              }
            } else {
              seg = [col];
            }
            line.push(seg);
          }
          if (!sorted) sort(line);
          decoded.push(line);
          index = semi + 1;
        } while (index <= mappings.length);
        return decoded;
      }
      function indexOf(mappings, index) {
        const idx = mappings.indexOf(';', index);
        return idx === -1 ? mappings.length : idx;
      }
      function decodeInteger(mappings, pos, state, j) {
        let value = 0;
        let shift = 0;
        let integer = 0;
        do {
          const c = mappings.charCodeAt(pos++);
          integer = charToInt[c];
          value |= (integer & 31) << shift;
          shift += 5;
        } while (integer & 32);
        const shouldNegate = value & 1;
        value >>>= 1;
        if (shouldNegate) {
          value = -2147483648 | -value;
        }
        state[j] += value;
        return pos;
      }
      function hasMoreVlq(mappings, i, length) {
        if (i >= length) return false;
        return mappings.charCodeAt(i) !== comma;
      }
      function sort(line) {
        line.sort(sortComparator);
      }
      function sortComparator(a, b) {
        return a[0] - b[0];
      }
      function encode(decoded) {
        const state = new Int32Array(5);
        const bufLength = 1024 * 16;
        const subLength = bufLength - 36;
        const buf = new Uint8Array(bufLength);
        const sub = buf.subarray(0, subLength);
        let pos = 0;
        let out = '';
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          if (i > 0) {
            if (pos === bufLength) {
              out += td.decode(buf);
              pos = 0;
            }
            buf[pos++] = semicolon;
          }
          if (line.length === 0) continue;
          state[0] = 0;
          for (let j = 0; j < line.length; j++) {
            const segment = line[j];
            if (pos > subLength) {
              out += td.decode(sub);
              buf.copyWithin(0, subLength, pos);
              pos -= subLength;
            }
            if (j > 0) buf[pos++] = comma;
            pos = encodeInteger(buf, pos, state, segment, 0);
            if (segment.length === 1) continue;
            pos = encodeInteger(buf, pos, state, segment, 1);
            pos = encodeInteger(buf, pos, state, segment, 2);
            pos = encodeInteger(buf, pos, state, segment, 3);
            if (segment.length === 4) continue;
            pos = encodeInteger(buf, pos, state, segment, 4);
          }
        }
        return out + td.decode(buf.subarray(0, pos));
      }
      function encodeInteger(buf, pos, state, segment, j) {
        const next = segment[j];
        let num = next - state[j];
        state[j] = next;
        num = num < 0 ? (-num << 1) | 1 : num << 1;
        do {
          let clamped = num & 31;
          num >>>= 5;
          if (num > 0) clamped |= 32;
          buf[pos++] = intToChar[clamped];
        } while (num > 0);
        return pos;
      }
      exports.decode = decode;
      exports.encode = encode;
      Object.defineProperty(exports, '__esModule', {value: true});
    });
  })(sourcemapCodec_umd, sourcemapCodec_umd.exports);
  return sourcemapCodec_umd.exports;
}
var resolveUri_umd = {exports: {}};
var hasRequiredResolveUri_umd;
function requireResolveUri_umd() {
  if (hasRequiredResolveUri_umd) return resolveUri_umd.exports;
  hasRequiredResolveUri_umd = 1;
  (function (module, exports) {
    (function (global, factory) {
      module.exports = factory();
    })(commonjsGlobal, function () {
      const schemeRegex = /^[\w+.-]+:\/\//;
      const urlRegex =
        /^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/;
      const fileRegex =
        /^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;
      function isAbsoluteUrl(input) {
        return schemeRegex.test(input);
      }
      function isSchemeRelativeUrl(input) {
        return input.startsWith('//');
      }
      function isAbsolutePath(input) {
        return input.startsWith('/');
      }
      function isFileUrl(input) {
        return input.startsWith('file:');
      }
      function isRelative(input) {
        return /^[.?#]/.test(input);
      }
      function parseAbsoluteUrl(input) {
        const match = urlRegex.exec(input);
        return makeUrl(
          match[1],
          match[2] || '',
          match[3],
          match[4] || '',
          match[5] || '/',
          match[6] || '',
          match[7] || ''
        );
      }
      function parseFileUrl(input) {
        const match = fileRegex.exec(input);
        const path = match[2];
        return makeUrl(
          'file:',
          '',
          match[1] || '',
          '',
          isAbsolutePath(path) ? path : '/' + path,
          match[3] || '',
          match[4] || ''
        );
      }
      function makeUrl(scheme, user, host, port, path, query, hash) {
        return {
          scheme: scheme,
          user: user,
          host: host,
          port: port,
          path: path,
          query: query,
          hash: hash,
          type: 7,
        };
      }
      function parseUrl(input) {
        if (isSchemeRelativeUrl(input)) {
          const url = parseAbsoluteUrl('http:' + input);
          url.scheme = '';
          url.type = 6;
          return url;
        }
        if (isAbsolutePath(input)) {
          const url = parseAbsoluteUrl('http://foo.com' + input);
          url.scheme = '';
          url.host = '';
          url.type = 5;
          return url;
        }
        if (isFileUrl(input)) return parseFileUrl(input);
        if (isAbsoluteUrl(input)) return parseAbsoluteUrl(input);
        const url = parseAbsoluteUrl('http://foo.com/' + input);
        url.scheme = '';
        url.host = '';
        url.type = input
          ? input.startsWith('?')
            ? 3
            : input.startsWith('#')
              ? 2
              : 4
          : 1;
        return url;
      }
      function stripPathFilename(path) {
        if (path.endsWith('/..')) return path;
        const index = path.lastIndexOf('/');
        return path.slice(0, index + 1);
      }
      function mergePaths(url, base) {
        normalizePath(base, base.type);
        if (url.path === '/') {
          url.path = base.path;
        } else {
          url.path = stripPathFilename(base.path) + url.path;
        }
      }
      function normalizePath(url, type) {
        const rel = type <= 4;
        const pieces = url.path.split('/');
        let pointer = 1;
        let positive = 0;
        let addTrailingSlash = false;
        for (let i = 1; i < pieces.length; i++) {
          const piece = pieces[i];
          if (!piece) {
            addTrailingSlash = true;
            continue;
          }
          addTrailingSlash = false;
          if (piece === '.') continue;
          if (piece === '..') {
            if (positive) {
              addTrailingSlash = true;
              positive--;
              pointer--;
            } else if (rel) {
              pieces[pointer++] = piece;
            }
            continue;
          }
          pieces[pointer++] = piece;
          positive++;
        }
        let path = '';
        for (let i = 1; i < pointer; i++) {
          path += '/' + pieces[i];
        }
        if (!path || (addTrailingSlash && !path.endsWith('/..'))) {
          path += '/';
        }
        url.path = path;
      }
      function resolve(input, base) {
        if (!input && !base) return '';
        const url = parseUrl(input);
        let inputType = url.type;
        if (base && inputType !== 7) {
          const baseUrl = parseUrl(base);
          const baseType = baseUrl.type;
          switch (inputType) {
            case 1:
              url.hash = baseUrl.hash;
            case 2:
              url.query = baseUrl.query;
            case 3:
            case 4:
              mergePaths(url, baseUrl);
            case 5:
              url.user = baseUrl.user;
              url.host = baseUrl.host;
              url.port = baseUrl.port;
            case 6:
              url.scheme = baseUrl.scheme;
          }
          if (baseType > inputType) inputType = baseType;
        }
        normalizePath(url, inputType);
        const queryHash = url.query + url.hash;
        switch (inputType) {
          case 2:
          case 3:
            return queryHash;
          case 4: {
            const path = url.path.slice(1);
            if (!path) return queryHash || '.';
            if (isRelative(base || input) && !isRelative(path)) {
              return './' + path + queryHash;
            }
            return path + queryHash;
          }
          case 5:
            return url.path + queryHash;
          default:
            return (
              url.scheme +
              '//' +
              url.user +
              url.host +
              url.port +
              url.path +
              queryHash
            );
        }
      }
      return resolve;
    });
  })(resolveUri_umd);
  return resolveUri_umd.exports;
}
var hasRequiredTraceMapping_umd;
function requireTraceMapping_umd() {
  if (hasRequiredTraceMapping_umd) return traceMapping_umd.exports;
  hasRequiredTraceMapping_umd = 1;
  (function (module, exports) {
    (function (global, factory) {
      factory(exports, requireSourcemapCodec_umd(), requireResolveUri_umd());
    })(commonjsGlobal, function (exports, sourcemapCodec, resolveUri) {
      function resolve(input, base) {
        if (base && !base.endsWith('/')) base += '/';
        return resolveUri(input, base);
      }
      function stripFilename(path) {
        if (!path) return '';
        const index = path.lastIndexOf('/');
        return path.slice(0, index + 1);
      }
      const COLUMN = 0;
      const SOURCES_INDEX = 1;
      const SOURCE_LINE = 2;
      const SOURCE_COLUMN = 3;
      const NAMES_INDEX = 4;
      const REV_GENERATED_LINE = 1;
      const REV_GENERATED_COLUMN = 2;
      function maybeSort(mappings, owned) {
        const unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
        if (unsortedIndex === mappings.length) return mappings;
        if (!owned) mappings = mappings.slice();
        for (
          let i = unsortedIndex;
          i < mappings.length;
          i = nextUnsortedSegmentLine(mappings, i + 1)
        ) {
          mappings[i] = sortSegments(mappings[i], owned);
        }
        return mappings;
      }
      function nextUnsortedSegmentLine(mappings, start) {
        for (let i = start; i < mappings.length; i++) {
          if (!isSorted(mappings[i])) return i;
        }
        return mappings.length;
      }
      function isSorted(line) {
        for (let j = 1; j < line.length; j++) {
          if (line[j][COLUMN] < line[j - 1][COLUMN]) {
            return false;
          }
        }
        return true;
      }
      function sortSegments(line, owned) {
        if (!owned) line = line.slice();
        return line.sort(sortComparator);
      }
      function sortComparator(a, b) {
        return a[COLUMN] - b[COLUMN];
      }
      let found = false;
      function binarySearch(haystack, needle, low, high) {
        while (low <= high) {
          const mid = low + ((high - low) >> 1);
          const cmp = haystack[mid][COLUMN] - needle;
          if (cmp === 0) {
            found = true;
            return mid;
          }
          if (cmp < 0) {
            low = mid + 1;
          } else {
            high = mid - 1;
          }
        }
        found = false;
        return low - 1;
      }
      function upperBound(haystack, needle, index) {
        for (let i = index + 1; i < haystack.length; index = i++) {
          if (haystack[i][COLUMN] !== needle) break;
        }
        return index;
      }
      function lowerBound(haystack, needle, index) {
        for (let i = index - 1; i >= 0; index = i--) {
          if (haystack[i][COLUMN] !== needle) break;
        }
        return index;
      }
      function memoizedState() {
        return {lastKey: -1, lastNeedle: -1, lastIndex: -1};
      }
      function memoizedBinarySearch(haystack, needle, state, key) {
        const {
          lastKey: lastKey,
          lastNeedle: lastNeedle,
          lastIndex: lastIndex,
        } = state;
        let low = 0;
        let high = haystack.length - 1;
        if (key === lastKey) {
          if (needle === lastNeedle) {
            found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
            return lastIndex;
          }
          if (needle >= lastNeedle) {
            low = lastIndex === -1 ? 0 : lastIndex;
          } else {
            high = lastIndex;
          }
        }
        state.lastKey = key;
        state.lastNeedle = needle;
        return (state.lastIndex = binarySearch(haystack, needle, low, high));
      }
      function buildBySources(decoded, memos) {
        const sources = memos.map(buildNullArray);
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          for (let j = 0; j < line.length; j++) {
            const seg = line[j];
            if (seg.length === 1) continue;
            const sourceIndex = seg[SOURCES_INDEX];
            const sourceLine = seg[SOURCE_LINE];
            const sourceColumn = seg[SOURCE_COLUMN];
            const originalSource = sources[sourceIndex];
            const originalLine =
              originalSource[sourceLine] || (originalSource[sourceLine] = []);
            const memo = memos[sourceIndex];
            let index = upperBound(
              originalLine,
              sourceColumn,
              memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine)
            );
            memo.lastIndex = ++index;
            insert(originalLine, index, [sourceColumn, i, seg[COLUMN]]);
          }
        }
        return sources;
      }
      function insert(array, index, value) {
        for (let i = array.length; i > index; i--) {
          array[i] = array[i - 1];
        }
        array[index] = value;
      }
      function buildNullArray() {
        return {__proto__: null};
      }
      const AnyMap = function (map, mapUrl) {
        const parsed = parse(map);
        if (!('sections' in parsed)) {
          return new TraceMap(parsed, mapUrl);
        }
        const mappings = [];
        const sources = [];
        const sourcesContent = [];
        const names = [];
        const ignoreList = [];
        recurse(
          parsed,
          mapUrl,
          mappings,
          sources,
          sourcesContent,
          names,
          ignoreList,
          0,
          0,
          Infinity,
          Infinity
        );
        const joined = {
          version: 3,
          file: parsed.file,
          names: names,
          sources: sources,
          sourcesContent: sourcesContent,
          mappings: mappings,
          ignoreList: ignoreList,
        };
        return presortedDecodedMap(joined);
      };
      function parse(map) {
        return typeof map === 'string' ? JSON.parse(map) : map;
      }
      function recurse(
        input,
        mapUrl,
        mappings,
        sources,
        sourcesContent,
        names,
        ignoreList,
        lineOffset,
        columnOffset,
        stopLine,
        stopColumn
      ) {
        const {sections: sections} = input;
        for (let i = 0; i < sections.length; i++) {
          const {map: map, offset: offset} = sections[i];
          let sl = stopLine;
          let sc = stopColumn;
          if (i + 1 < sections.length) {
            const nextOffset = sections[i + 1].offset;
            sl = Math.min(stopLine, lineOffset + nextOffset.line);
            if (sl === stopLine) {
              sc = Math.min(stopColumn, columnOffset + nextOffset.column);
            } else if (sl < stopLine) {
              sc = columnOffset + nextOffset.column;
            }
          }
          addSection(
            map,
            mapUrl,
            mappings,
            sources,
            sourcesContent,
            names,
            ignoreList,
            lineOffset + offset.line,
            columnOffset + offset.column,
            sl,
            sc
          );
        }
      }
      function addSection(
        input,
        mapUrl,
        mappings,
        sources,
        sourcesContent,
        names,
        ignoreList,
        lineOffset,
        columnOffset,
        stopLine,
        stopColumn
      ) {
        const parsed = parse(input);
        if ('sections' in parsed) return recurse(...arguments);
        const map = new TraceMap(parsed, mapUrl);
        const sourcesOffset = sources.length;
        const namesOffset = names.length;
        const decoded = decodedMappings(map);
        const {
          resolvedSources: resolvedSources,
          sourcesContent: contents,
          ignoreList: ignores,
        } = map;
        append(sources, resolvedSources);
        append(names, map.names);
        if (contents) append(sourcesContent, contents);
        else
          for (let i = 0; i < resolvedSources.length; i++)
            sourcesContent.push(null);
        if (ignores)
          for (let i = 0; i < ignores.length; i++)
            ignoreList.push(ignores[i] + sourcesOffset);
        for (let i = 0; i < decoded.length; i++) {
          const lineI = lineOffset + i;
          if (lineI > stopLine) return;
          const out = getLine(mappings, lineI);
          const cOffset = i === 0 ? columnOffset : 0;
          const line = decoded[i];
          for (let j = 0; j < line.length; j++) {
            const seg = line[j];
            const column = cOffset + seg[COLUMN];
            if (lineI === stopLine && column >= stopColumn) return;
            if (seg.length === 1) {
              out.push([column]);
              continue;
            }
            const sourcesIndex = sourcesOffset + seg[SOURCES_INDEX];
            const sourceLine = seg[SOURCE_LINE];
            const sourceColumn = seg[SOURCE_COLUMN];
            out.push(
              seg.length === 4
                ? [column, sourcesIndex, sourceLine, sourceColumn]
                : [
                    column,
                    sourcesIndex,
                    sourceLine,
                    sourceColumn,
                    namesOffset + seg[NAMES_INDEX],
                  ]
            );
          }
        }
      }
      function append(arr, other) {
        for (let i = 0; i < other.length; i++) arr.push(other[i]);
      }
      function getLine(arr, index) {
        for (let i = arr.length; i <= index; i++) arr[i] = [];
        return arr[index];
      }
      const LINE_GTR_ZERO =
        '`line` must be greater than 0 (lines start at line 1)';
      const COL_GTR_EQ_ZERO =
        '`column` must be greater than or equal to 0 (columns start at column 0)';
      const LEAST_UPPER_BOUND = -1;
      const GREATEST_LOWER_BOUND = 1;
      class TraceMap {
        constructor(map, mapUrl) {
          const isString = typeof map === 'string';
          if (!isString && map._decodedMemo) return map;
          const parsed = isString ? JSON.parse(map) : map;
          const {
            version: version,
            file: file,
            names: names,
            sourceRoot: sourceRoot,
            sources: sources,
            sourcesContent: sourcesContent,
          } = parsed;
          this.version = version;
          this.file = file;
          this.names = names || [];
          this.sourceRoot = sourceRoot;
          this.sources = sources;
          this.sourcesContent = sourcesContent;
          this.ignoreList =
            parsed.ignoreList || parsed.x_google_ignoreList || undefined;
          const from = resolve(sourceRoot || '', stripFilename(mapUrl));
          this.resolvedSources = sources.map(s => resolve(s || '', from));
          const {mappings: mappings} = parsed;
          if (typeof mappings === 'string') {
            this._encoded = mappings;
            this._decoded = undefined;
          } else {
            this._encoded = undefined;
            this._decoded = maybeSort(mappings, isString);
          }
          this._decodedMemo = memoizedState();
          this._bySources = undefined;
          this._bySourceMemos = undefined;
        }
      }
      function cast(map) {
        return map;
      }
      function encodedMappings(map) {
        var _a;
        var _b;
        return (_a = (_b = cast(map))._encoded) !== null && _a !== void 0
          ? _a
          : (_b._encoded = sourcemapCodec.encode(cast(map)._decoded));
      }
      function decodedMappings(map) {
        var _a;
        return (
          (_a = cast(map))._decoded ||
          (_a._decoded = sourcemapCodec.decode(cast(map)._encoded))
        );
      }
      function traceSegment(map, line, column) {
        const decoded = decodedMappings(map);
        if (line >= decoded.length) return null;
        const segments = decoded[line];
        const index = traceSegmentInternal(
          segments,
          cast(map)._decodedMemo,
          line,
          column,
          GREATEST_LOWER_BOUND
        );
        return index === -1 ? null : segments[index];
      }
      function originalPositionFor(map, needle) {
        let {line: line, column: column, bias: bias} = needle;
        line--;
        if (line < 0) throw new Error(LINE_GTR_ZERO);
        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
        const decoded = decodedMappings(map);
        if (line >= decoded.length) return OMapping(null, null, null, null);
        const segments = decoded[line];
        const index = traceSegmentInternal(
          segments,
          cast(map)._decodedMemo,
          line,
          column,
          bias || GREATEST_LOWER_BOUND
        );
        if (index === -1) return OMapping(null, null, null, null);
        const segment = segments[index];
        if (segment.length === 1) return OMapping(null, null, null, null);
        const {names: names, resolvedSources: resolvedSources} = map;
        return OMapping(
          resolvedSources[segment[SOURCES_INDEX]],
          segment[SOURCE_LINE] + 1,
          segment[SOURCE_COLUMN],
          segment.length === 5 ? names[segment[NAMES_INDEX]] : null
        );
      }
      function generatedPositionFor(map, needle) {
        const {source: source, line: line, column: column, bias: bias} = needle;
        return generatedPosition(
          map,
          source,
          line,
          column,
          bias || GREATEST_LOWER_BOUND,
          false
        );
      }
      function allGeneratedPositionsFor(map, needle) {
        const {source: source, line: line, column: column, bias: bias} = needle;
        return generatedPosition(
          map,
          source,
          line,
          column,
          bias || LEAST_UPPER_BOUND,
          true
        );
      }
      function eachMapping(map, cb) {
        const decoded = decodedMappings(map);
        const {names: names, resolvedSources: resolvedSources} = map;
        for (let i = 0; i < decoded.length; i++) {
          const line = decoded[i];
          for (let j = 0; j < line.length; j++) {
            const seg = line[j];
            const generatedLine = i + 1;
            const generatedColumn = seg[0];
            let source = null;
            let originalLine = null;
            let originalColumn = null;
            let name = null;
            if (seg.length !== 1) {
              source = resolvedSources[seg[1]];
              originalLine = seg[2] + 1;
              originalColumn = seg[3];
            }
            if (seg.length === 5) name = names[seg[4]];
            cb({
              generatedLine: generatedLine,
              generatedColumn: generatedColumn,
              source: source,
              originalLine: originalLine,
              originalColumn: originalColumn,
              name: name,
            });
          }
        }
      }
      function sourceIndex(map, source) {
        const {sources: sources, resolvedSources: resolvedSources} = map;
        let index = sources.indexOf(source);
        if (index === -1) index = resolvedSources.indexOf(source);
        return index;
      }
      function sourceContentFor(map, source) {
        const {sourcesContent: sourcesContent} = map;
        if (sourcesContent == null) return null;
        const index = sourceIndex(map, source);
        return index === -1 ? null : sourcesContent[index];
      }
      function isIgnored(map, source) {
        const {ignoreList: ignoreList} = map;
        if (ignoreList == null) return false;
        const index = sourceIndex(map, source);
        return index === -1 ? false : ignoreList.includes(index);
      }
      function presortedDecodedMap(map, mapUrl) {
        const tracer = new TraceMap(clone(map, []), mapUrl);
        cast(tracer)._decoded = map.mappings;
        return tracer;
      }
      function decodedMap(map) {
        return clone(map, decodedMappings(map));
      }
      function encodedMap(map) {
        return clone(map, encodedMappings(map));
      }
      function clone(map, mappings) {
        return {
          version: map.version,
          file: map.file,
          names: map.names,
          sourceRoot: map.sourceRoot,
          sources: map.sources,
          sourcesContent: map.sourcesContent,
          mappings: mappings,
          ignoreList: map.ignoreList || map.x_google_ignoreList,
        };
      }
      function OMapping(source, line, column, name) {
        return {source: source, line: line, column: column, name: name};
      }
      function GMapping(line, column) {
        return {line: line, column: column};
      }
      function traceSegmentInternal(segments, memo, line, column, bias) {
        let index = memoizedBinarySearch(segments, column, memo, line);
        if (found) {
          index = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(
            segments,
            column,
            index
          );
        } else if (bias === LEAST_UPPER_BOUND) index++;
        if (index === -1 || index === segments.length) return -1;
        return index;
      }
      function sliceGeneratedPositions(segments, memo, line, column, bias) {
        let min = traceSegmentInternal(
          segments,
          memo,
          line,
          column,
          GREATEST_LOWER_BOUND
        );
        if (!found && bias === LEAST_UPPER_BOUND) min++;
        if (min === -1 || min === segments.length) return [];
        const matchedColumn = found ? column : segments[min][COLUMN];
        if (!found) min = lowerBound(segments, matchedColumn, min);
        const max = upperBound(segments, matchedColumn, min);
        const result = [];
        for (; min <= max; min++) {
          const segment = segments[min];
          result.push(
            GMapping(
              segment[REV_GENERATED_LINE] + 1,
              segment[REV_GENERATED_COLUMN]
            )
          );
        }
        return result;
      }
      function generatedPosition(map, source, line, column, bias, all) {
        var _a;
        line--;
        if (line < 0) throw new Error(LINE_GTR_ZERO);
        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
        const {sources: sources, resolvedSources: resolvedSources} = map;
        let sourceIndex = sources.indexOf(source);
        if (sourceIndex === -1) sourceIndex = resolvedSources.indexOf(source);
        if (sourceIndex === -1) return all ? [] : GMapping(null, null);
        const generated =
          (_a = cast(map))._bySources ||
          (_a._bySources = buildBySources(
            decodedMappings(map),
            (cast(map)._bySourceMemos = sources.map(memoizedState))
          ));
        const segments = generated[sourceIndex][line];
        if (segments == null) return all ? [] : GMapping(null, null);
        const memo = cast(map)._bySourceMemos[sourceIndex];
        if (all)
          return sliceGeneratedPositions(segments, memo, line, column, bias);
        const index = traceSegmentInternal(segments, memo, line, column, bias);
        if (index === -1) return GMapping(null, null);
        const segment = segments[index];
        return GMapping(
          segment[REV_GENERATED_LINE] + 1,
          segment[REV_GENERATED_COLUMN]
        );
      }
      exports.AnyMap = AnyMap;
      exports.GREATEST_LOWER_BOUND = GREATEST_LOWER_BOUND;
      exports.LEAST_UPPER_BOUND = LEAST_UPPER_BOUND;
      exports.TraceMap = TraceMap;
      exports.allGeneratedPositionsFor = allGeneratedPositionsFor;
      exports.decodedMap = decodedMap;
      exports.decodedMappings = decodedMappings;
      exports.eachMapping = eachMapping;
      exports.encodedMap = encodedMap;
      exports.encodedMappings = encodedMappings;
      exports.generatedPositionFor = generatedPositionFor;
      exports.isIgnored = isIgnored;
      exports.originalPositionFor = originalPositionFor;
      exports.presortedDecodedMap = presortedDecodedMap;
      exports.sourceContentFor = sourceContentFor;
      exports.traceSegment = traceSegment;
    });
  })(traceMapping_umd, traceMapping_umd.exports);
  return traceMapping_umd.exports;
}
var hasRequiredSourceMap$2;
function requireSourceMap$2() {
  if (hasRequiredSourceMap$2) return sourceMap$3;
  hasRequiredSourceMap$2 = 1;
  Object.defineProperty(sourceMap$3, '__esModule', {value: true});
  sourceMap$3.default = void 0;
  var _genMapping = requireGenMapping_umd();
  var _traceMapping = requireTraceMapping_umd();
  class SourceMap {
    constructor(opts, code) {
      var _opts$sourceFileName;
      this._map = void 0;
      this._rawMappings = void 0;
      this._sourceFileName = void 0;
      this._lastGenLine = 0;
      this._lastSourceLine = 0;
      this._lastSourceColumn = 0;
      this._inputMap = void 0;
      const map = (this._map = new _genMapping.GenMapping({
        sourceRoot: opts.sourceRoot,
      }));
      this._sourceFileName =
        (_opts$sourceFileName = opts.sourceFileName) == null
          ? void 0
          : _opts$sourceFileName.replace(/\\/g, '/');
      this._rawMappings = undefined;
      if (opts.inputSourceMap) {
        this._inputMap = new _traceMapping.TraceMap(opts.inputSourceMap);
        const resolvedSources = this._inputMap.resolvedSources;
        if (resolvedSources.length) {
          for (let i = 0; i < resolvedSources.length; i++) {
            var _this$_inputMap$sourc;
            (0, _genMapping.setSourceContent)(
              map,
              resolvedSources[i],
              (_this$_inputMap$sourc = this._inputMap.sourcesContent) == null
                ? void 0
                : _this$_inputMap$sourc[i]
            );
          }
        }
      }
      if (typeof code === 'string' && !opts.inputSourceMap) {
        (0, _genMapping.setSourceContent)(map, this._sourceFileName, code);
      } else if (typeof code === 'object') {
        for (const sourceFileName of Object.keys(code)) {
          (0, _genMapping.setSourceContent)(
            map,
            sourceFileName.replace(/\\/g, '/'),
            code[sourceFileName]
          );
        }
      }
    }
    get() {
      return (0, _genMapping.toEncodedMap)(this._map);
    }
    getDecoded() {
      return (0, _genMapping.toDecodedMap)(this._map);
    }
    getRawMappings() {
      return (
        this._rawMappings ||
        (this._rawMappings = (0, _genMapping.allMappings)(this._map))
      );
    }
    mark(generated, line, column, identifierName, identifierNamePos, filename) {
      var _originalMapping;
      this._rawMappings = undefined;
      let originalMapping;
      if (line != null) {
        if (this._inputMap) {
          originalMapping = (0, _traceMapping.originalPositionFor)(
            this._inputMap,
            {line: line, column: column}
          );
          if (!originalMapping.name && identifierNamePos) {
            const originalIdentifierMapping = (0,
            _traceMapping.originalPositionFor)(
              this._inputMap,
              identifierNamePos
            );
            if (originalIdentifierMapping.name) {
              identifierName = originalIdentifierMapping.name;
            }
          }
        } else {
          originalMapping = {
            source:
              (filename == null ? void 0 : filename.replace(/\\/g, '/')) ||
              this._sourceFileName,
            line: line,
            column: column,
          };
        }
      }
      (0, _genMapping.maybeAddMapping)(this._map, {
        name: identifierName,
        generated: generated,
        source:
          (_originalMapping = originalMapping) == null
            ? void 0
            : _originalMapping.source,
        original: originalMapping,
      });
    }
  }
  sourceMap$3.default = SourceMap;
  return sourceMap$3;
}
var printer$3 = {};
var buffer$5 = {};
var hasRequiredBuffer$1;
function requireBuffer$1() {
  if (hasRequiredBuffer$1) return buffer$5;
  hasRequiredBuffer$1 = 1;
  Object.defineProperty(buffer$5, '__esModule', {value: true});
  buffer$5.default = void 0;
  class Buffer {
    constructor(map, indentChar) {
      this._map = null;
      this._buf = '';
      this._str = '';
      this._appendCount = 0;
      this._last = 0;
      this._queue = [];
      this._queueCursor = 0;
      this._canMarkIdName = true;
      this._indentChar = '';
      this._fastIndentations = [];
      this._position = {line: 1, column: 0};
      this._sourcePosition = {
        identifierName: undefined,
        identifierNamePos: undefined,
        line: undefined,
        column: undefined,
        filename: undefined,
      };
      this._map = map;
      this._indentChar = indentChar;
      for (let i = 0; i < 64; i++) {
        this._fastIndentations.push(indentChar.repeat(i));
      }
      this._allocQueue();
    }
    _allocQueue() {
      const queue = this._queue;
      for (let i = 0; i < 16; i++) {
        queue.push({
          char: 0,
          repeat: 1,
          line: undefined,
          column: undefined,
          identifierName: undefined,
          identifierNamePos: undefined,
          filename: '',
        });
      }
    }
    _pushQueue(char, repeat, line, column, filename) {
      const cursor = this._queueCursor;
      if (cursor === this._queue.length) {
        this._allocQueue();
      }
      const item = this._queue[cursor];
      item.char = char;
      item.repeat = repeat;
      item.line = line;
      item.column = column;
      item.filename = filename;
      this._queueCursor++;
    }
    _popQueue() {
      if (this._queueCursor === 0) {
        throw new Error('Cannot pop from empty queue');
      }
      return this._queue[--this._queueCursor];
    }
    get() {
      this._flush();
      const map = this._map;
      const result = {
        code: (this._buf + this._str).trimRight(),
        decodedMap: map == null ? void 0 : map.getDecoded(),
        get __mergedMap() {
          return this.map;
        },
        get map() {
          const resultMap = map ? map.get() : null;
          result.map = resultMap;
          return resultMap;
        },
        set map(value) {
          Object.defineProperty(result, 'map', {value: value, writable: true});
        },
        get rawMappings() {
          const mappings = map == null ? void 0 : map.getRawMappings();
          result.rawMappings = mappings;
          return mappings;
        },
        set rawMappings(value) {
          Object.defineProperty(result, 'rawMappings', {
            value: value,
            writable: true,
          });
        },
      };
      return result;
    }
    append(str, maybeNewline) {
      this._flush();
      this._append(str, this._sourcePosition, maybeNewline);
    }
    appendChar(char) {
      this._flush();
      this._appendChar(char, 1, this._sourcePosition);
    }
    queue(char) {
      if (char === 10) {
        while (this._queueCursor !== 0) {
          const char = this._queue[this._queueCursor - 1].char;
          if (char !== 32 && char !== 9) {
            break;
          }
          this._queueCursor--;
        }
      }
      const sourcePosition = this._sourcePosition;
      this._pushQueue(
        char,
        1,
        sourcePosition.line,
        sourcePosition.column,
        sourcePosition.filename
      );
    }
    queueIndentation(repeat) {
      if (repeat === 0) return;
      this._pushQueue(-1, repeat, undefined, undefined, undefined);
    }
    _flush() {
      const queueCursor = this._queueCursor;
      const queue = this._queue;
      for (let i = 0; i < queueCursor; i++) {
        const item = queue[i];
        this._appendChar(item.char, item.repeat, item);
      }
      this._queueCursor = 0;
    }
    _appendChar(char, repeat, sourcePos) {
      this._last = char;
      if (char === -1) {
        const fastIndentation = this._fastIndentations[repeat];
        if (fastIndentation !== undefined) {
          this._str += fastIndentation;
        } else {
          this._str +=
            repeat > 1 ? this._indentChar.repeat(repeat) : this._indentChar;
        }
      } else {
        this._str +=
          repeat > 1
            ? String.fromCharCode(char).repeat(repeat)
            : String.fromCharCode(char);
      }
      if (char !== 10) {
        this._mark(
          sourcePos.line,
          sourcePos.column,
          sourcePos.identifierName,
          sourcePos.identifierNamePos,
          sourcePos.filename
        );
        this._position.column += repeat;
      } else {
        this._position.line++;
        this._position.column = 0;
      }
      if (this._canMarkIdName) {
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
    }
    _append(str, sourcePos, maybeNewline) {
      const len = str.length;
      const position = this._position;
      this._last = str.charCodeAt(len - 1);
      if (++this._appendCount > 4096) {
        +this._str;
        this._buf += this._str;
        this._str = str;
        this._appendCount = 0;
      } else {
        this._str += str;
      }
      if (!maybeNewline && !this._map) {
        position.column += len;
        return;
      }
      const {
        column: column,
        identifierName: identifierName,
        identifierNamePos: identifierNamePos,
        filename: filename,
      } = sourcePos;
      let line = sourcePos.line;
      if (
        (identifierName != null || identifierNamePos != null) &&
        this._canMarkIdName
      ) {
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
      let i = str.indexOf('\n');
      let last = 0;
      if (i !== 0) {
        this._mark(line, column, identifierName, identifierNamePos, filename);
      }
      while (i !== -1) {
        position.line++;
        position.column = 0;
        last = i + 1;
        if (last < len && line !== undefined) {
          this._mark(++line, 0, null, null, filename);
        }
        i = str.indexOf('\n', last);
      }
      position.column += len - last;
    }
    _mark(line, column, identifierName, identifierNamePos, filename) {
      var _this$_map;
      (_this$_map = this._map) == null ||
        _this$_map.mark(
          this._position,
          line,
          column,
          identifierName,
          identifierNamePos,
          filename
        );
    }
    removeTrailingNewline() {
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 10) {
        this._queueCursor--;
      }
    }
    removeLastSemicolon() {
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 59) {
        this._queueCursor--;
      }
    }
    getLastChar() {
      const queueCursor = this._queueCursor;
      return queueCursor !== 0 ? this._queue[queueCursor - 1].char : this._last;
    }
    getNewlineCount() {
      const queueCursor = this._queueCursor;
      let count = 0;
      if (queueCursor === 0) return this._last === 10 ? 1 : 0;
      for (let i = queueCursor - 1; i >= 0; i--) {
        if (this._queue[i].char !== 10) {
          break;
        }
        count++;
      }
      return count === queueCursor && this._last === 10 ? count + 1 : count;
    }
    endsWithCharAndNewline() {
      const queue = this._queue;
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0) {
        const lastCp = queue[queueCursor - 1].char;
        if (lastCp !== 10) return;
        if (queueCursor > 1) {
          return queue[queueCursor - 2].char;
        } else {
          return this._last;
        }
      }
    }
    hasContent() {
      return this._queueCursor !== 0 || !!this._last;
    }
    exactSource(loc, cb) {
      if (!this._map) {
        cb();
        return;
      }
      this.source('start', loc);
      const identifierName = loc.identifierName;
      const sourcePos = this._sourcePosition;
      if (identifierName) {
        this._canMarkIdName = false;
        sourcePos.identifierName = identifierName;
      }
      cb();
      if (identifierName) {
        this._canMarkIdName = true;
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
      this.source('end', loc);
    }
    source(prop, loc) {
      if (!this._map) return;
      this._normalizePosition(prop, loc, 0);
    }
    sourceWithOffset(prop, loc, columnOffset) {
      if (!this._map) return;
      this._normalizePosition(prop, loc, columnOffset);
    }
    _normalizePosition(prop, loc, columnOffset) {
      const pos = loc[prop];
      const target = this._sourcePosition;
      if (pos) {
        target.line = pos.line;
        target.column = Math.max(pos.column + columnOffset, 0);
        target.filename = loc.filename;
      }
    }
    getCurrentColumn() {
      const queue = this._queue;
      const queueCursor = this._queueCursor;
      let lastIndex = -1;
      let len = 0;
      for (let i = 0; i < queueCursor; i++) {
        const item = queue[i];
        if (item.char === 10) {
          lastIndex = len;
        }
        len += item.repeat;
      }
      return lastIndex === -1
        ? this._position.column + len
        : len - 1 - lastIndex;
    }
    getCurrentLine() {
      let count = 0;
      const queue = this._queue;
      for (let i = 0; i < this._queueCursor; i++) {
        if (queue[i].char === 10) {
          count++;
        }
      }
      return this._position.line + count;
    }
  }
  buffer$5.default = Buffer;
  return buffer$5;
}
var node$2 = {};
var whitespace$3 = {};
var hasRequiredWhitespace$1;
function requireWhitespace$1() {
  if (hasRequiredWhitespace$1) return whitespace$3;
  hasRequiredWhitespace$1 = 1;
  Object.defineProperty(whitespace$3, '__esModule', {value: true});
  whitespace$3.nodes = void 0;
  var _t = t$d;
  const {
    FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS,
    isArrayExpression: isArrayExpression,
    isAssignmentExpression: isAssignmentExpression,
    isBinary: isBinary,
    isBlockStatement: isBlockStatement,
    isCallExpression: isCallExpression,
    isFunction: isFunction,
    isIdentifier: isIdentifier,
    isLiteral: isLiteral,
    isMemberExpression: isMemberExpression,
    isObjectExpression: isObjectExpression,
    isOptionalCallExpression: isOptionalCallExpression,
    isOptionalMemberExpression: isOptionalMemberExpression,
    isStringLiteral: isStringLiteral,
  } = _t;
  function crawlInternal(node, state) {
    if (!node) return state;
    if (isMemberExpression(node) || isOptionalMemberExpression(node)) {
      crawlInternal(node.object, state);
      if (node.computed) crawlInternal(node.property, state);
    } else if (isBinary(node) || isAssignmentExpression(node)) {
      crawlInternal(node.left, state);
      crawlInternal(node.right, state);
    } else if (isCallExpression(node) || isOptionalCallExpression(node)) {
      state.hasCall = true;
      crawlInternal(node.callee, state);
    } else if (isFunction(node)) {
      state.hasFunction = true;
    } else if (isIdentifier(node)) {
      state.hasHelper =
        state.hasHelper || (node.callee && isHelper(node.callee));
    }
    return state;
  }
  function crawl(node) {
    return crawlInternal(node, {
      hasCall: false,
      hasFunction: false,
      hasHelper: false,
    });
  }
  function isHelper(node) {
    if (!node) return false;
    if (isMemberExpression(node)) {
      return isHelper(node.object) || isHelper(node.property);
    } else if (isIdentifier(node)) {
      return node.name === 'require' || node.name.charCodeAt(0) === 95;
    } else if (isCallExpression(node)) {
      return isHelper(node.callee);
    } else if (isBinary(node) || isAssignmentExpression(node)) {
      return (
        (isIdentifier(node.left) && isHelper(node.left)) || isHelper(node.right)
      );
    } else {
      return false;
    }
  }
  function isType(node) {
    return (
      isLiteral(node) ||
      isObjectExpression(node) ||
      isArrayExpression(node) ||
      isIdentifier(node) ||
      isMemberExpression(node)
    );
  }
  const nodes = (whitespace$3.nodes = {
    AssignmentExpression(node) {
      const state = crawl(node.right);
      if ((state.hasCall && state.hasHelper) || state.hasFunction) {
        return state.hasFunction ? 1 | 2 : 2;
      }
    },
    SwitchCase(node, parent) {
      return (
        (!!node.consequent.length || parent.cases[0] === node ? 1 : 0) |
        (!node.consequent.length &&
        parent.cases[parent.cases.length - 1] === node
          ? 2
          : 0)
      );
    },
    LogicalExpression(node) {
      if (isFunction(node.left) || isFunction(node.right)) {
        return 2;
      }
    },
    Literal(node) {
      if (isStringLiteral(node) && node.value === 'use strict') {
        return 2;
      }
    },
    CallExpression(node) {
      if (isFunction(node.callee) || isHelper(node)) {
        return 1 | 2;
      }
    },
    OptionalCallExpression(node) {
      if (isFunction(node.callee)) {
        return 1 | 2;
      }
    },
    VariableDeclaration(node) {
      for (let i = 0; i < node.declarations.length; i++) {
        const declar = node.declarations[i];
        let enabled = isHelper(declar.id) && !isType(declar.init);
        if (!enabled && declar.init) {
          const state = crawl(declar.init);
          enabled =
            (isHelper(declar.init) && state.hasCall) || state.hasFunction;
        }
        if (enabled) {
          return 1 | 2;
        }
      }
    },
    IfStatement(node) {
      if (isBlockStatement(node.consequent)) {
        return 1 | 2;
      }
    },
  });
  nodes.ObjectProperty =
    nodes.ObjectTypeProperty =
    nodes.ObjectMethod =
      function (node, parent) {
        if (parent.properties[0] === node) {
          return 1;
        }
      };
  nodes.ObjectTypeCallProperty = function (node, parent) {
    var _parent$properties;
    if (
      parent.callProperties[0] === node &&
      !(
        (_parent$properties = parent.properties) != null &&
        _parent$properties.length
      )
    ) {
      return 1;
    }
  };
  nodes.ObjectTypeIndexer = function (node, parent) {
    var _parent$properties2, _parent$callPropertie;
    if (
      parent.indexers[0] === node &&
      !(
        (_parent$properties2 = parent.properties) != null &&
        _parent$properties2.length
      ) &&
      !(
        (_parent$callPropertie = parent.callProperties) != null &&
        _parent$callPropertie.length
      )
    ) {
      return 1;
    }
  };
  nodes.ObjectTypeInternalSlot = function (node, parent) {
    var _parent$properties3, _parent$callPropertie2, _parent$indexers;
    if (
      parent.internalSlots[0] === node &&
      !(
        (_parent$properties3 = parent.properties) != null &&
        _parent$properties3.length
      ) &&
      !(
        (_parent$callPropertie2 = parent.callProperties) != null &&
        _parent$callPropertie2.length
      ) &&
      !((_parent$indexers = parent.indexers) != null && _parent$indexers.length)
    ) {
      return 1;
    }
  };
  [
    ['Function', true],
    ['Class', true],
    ['Loop', true],
    ['LabeledStatement', true],
    ['SwitchStatement', true],
    ['TryStatement', true],
  ].forEach(function ([type, amounts]) {
    [type].concat(FLIPPED_ALIAS_KEYS[type] || []).forEach(function (type) {
      const ret = amounts ? 1 | 2 : 0;
      nodes[type] = () => ret;
    });
  });
  return whitespace$3;
}
var parentheses$2 = {};
var hasRequiredParentheses$1;
function requireParentheses$1() {
  if (hasRequiredParentheses$1) return parentheses$2;
  hasRequiredParentheses$1 = 1;
  Object.defineProperty(parentheses$2, '__esModule', {value: true});
  parentheses$2.AssignmentExpression = AssignmentExpression;
  parentheses$2.Binary = Binary;
  parentheses$2.BinaryExpression = BinaryExpression;
  parentheses$2.ClassExpression = ClassExpression;
  parentheses$2.ArrowFunctionExpression = parentheses$2.ConditionalExpression =
    ConditionalExpression;
  parentheses$2.DoExpression = DoExpression;
  parentheses$2.FunctionExpression = FunctionExpression;
  parentheses$2.FunctionTypeAnnotation = FunctionTypeAnnotation;
  parentheses$2.Identifier = Identifier;
  parentheses$2.LogicalExpression = LogicalExpression;
  parentheses$2.NullableTypeAnnotation = NullableTypeAnnotation;
  parentheses$2.ObjectExpression = ObjectExpression;
  parentheses$2.OptionalIndexedAccessType = OptionalIndexedAccessType;
  parentheses$2.OptionalCallExpression =
    parentheses$2.OptionalMemberExpression = OptionalMemberExpression;
  parentheses$2.SequenceExpression = SequenceExpression;
  parentheses$2.TSSatisfiesExpression = parentheses$2.TSAsExpression =
    TSAsExpression;
  parentheses$2.TSInferType = TSInferType;
  parentheses$2.TSInstantiationExpression = TSInstantiationExpression;
  parentheses$2.UnaryLike = parentheses$2.TSTypeAssertion = UnaryLike;
  parentheses$2.TSIntersectionType = parentheses$2.TSUnionType = TSUnionType;
  parentheses$2.IntersectionTypeAnnotation = parentheses$2.UnionTypeAnnotation =
    UnionTypeAnnotation;
  parentheses$2.UpdateExpression = UpdateExpression;
  parentheses$2.AwaitExpression = parentheses$2.YieldExpression =
    YieldExpression;
  var _t = t$d;
  var _index = requireNode$1();
  const {
    isArrayTypeAnnotation: isArrayTypeAnnotation,
    isBinaryExpression: isBinaryExpression,
    isCallExpression: isCallExpression,
    isForOfStatement: isForOfStatement,
    isIndexedAccessType: isIndexedAccessType,
    isMemberExpression: isMemberExpression,
    isObjectPattern: isObjectPattern,
    isOptionalMemberExpression: isOptionalMemberExpression,
    isYieldExpression: isYieldExpression,
    isStatement: isStatement,
  } = _t;
  const PRECEDENCE = new Map([
    ['||', 0],
    ['??', 0],
    ['|>', 0],
    ['&&', 1],
    ['|', 2],
    ['^', 3],
    ['&', 4],
    ['==', 5],
    ['===', 5],
    ['!=', 5],
    ['!==', 5],
    ['<', 6],
    ['>', 6],
    ['<=', 6],
    ['>=', 6],
    ['in', 6],
    ['instanceof', 6],
    ['>>', 7],
    ['<<', 7],
    ['>>>', 7],
    ['+', 8],
    ['-', 8],
    ['*', 9],
    ['/', 9],
    ['%', 9],
    ['**', 10],
  ]);
  function getBinaryPrecedence(node, nodeType) {
    if (nodeType === 'BinaryExpression' || nodeType === 'LogicalExpression') {
      return PRECEDENCE.get(node.operator);
    }
    if (nodeType === 'TSAsExpression' || nodeType === 'TSSatisfiesExpression') {
      return PRECEDENCE.get('in');
    }
  }
  function isTSTypeExpression(nodeType) {
    return (
      nodeType === 'TSAsExpression' ||
      nodeType === 'TSSatisfiesExpression' ||
      nodeType === 'TSTypeAssertion'
    );
  }
  const isClassExtendsClause = (node, parent) => {
    const parentType = parent.type;
    return (
      (parentType === 'ClassDeclaration' || parentType === 'ClassExpression') &&
      parent.superClass === node
    );
  };
  const hasPostfixPart = (node, parent) => {
    const parentType = parent.type;
    return (
      ((parentType === 'MemberExpression' ||
        parentType === 'OptionalMemberExpression') &&
        parent.object === node) ||
      ((parentType === 'CallExpression' ||
        parentType === 'OptionalCallExpression' ||
        parentType === 'NewExpression') &&
        parent.callee === node) ||
      (parentType === 'TaggedTemplateExpression' && parent.tag === node) ||
      parentType === 'TSNonNullExpression'
    );
  };
  function NullableTypeAnnotation(node, parent) {
    return isArrayTypeAnnotation(parent);
  }
  function FunctionTypeAnnotation(node, parent, tokenContext) {
    const parentType = parent.type;
    return (
      parentType === 'UnionTypeAnnotation' ||
      parentType === 'IntersectionTypeAnnotation' ||
      parentType === 'ArrayTypeAnnotation' ||
      Boolean(tokenContext & _index.TokenContext.arrowFlowReturnType)
    );
  }
  function UpdateExpression(node, parent) {
    return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
  }
  function needsParenBeforeExpressionBrace(tokenContext) {
    return Boolean(
      tokenContext &
        (_index.TokenContext.expressionStatement |
          _index.TokenContext.arrowBody)
    );
  }
  function ObjectExpression(node, parent, tokenContext) {
    return needsParenBeforeExpressionBrace(tokenContext);
  }
  function DoExpression(node, parent, tokenContext) {
    return (
      !node.async &&
      Boolean(tokenContext & _index.TokenContext.expressionStatement)
    );
  }
  function Binary(node, parent) {
    const parentType = parent.type;
    if (
      node.type === 'BinaryExpression' &&
      node.operator === '**' &&
      parentType === 'BinaryExpression' &&
      parent.operator === '**'
    ) {
      return parent.left === node;
    }
    if (isClassExtendsClause(node, parent)) {
      return true;
    }
    if (
      hasPostfixPart(node, parent) ||
      parentType === 'UnaryExpression' ||
      parentType === 'SpreadElement' ||
      parentType === 'AwaitExpression'
    ) {
      return true;
    }
    const parentPos = getBinaryPrecedence(parent, parentType);
    if (parentPos != null) {
      const nodePos = getBinaryPrecedence(node, node.type);
      if (
        (parentPos === nodePos &&
          parentType === 'BinaryExpression' &&
          parent.right === node) ||
        parentPos > nodePos
      ) {
        return true;
      }
    }
    return undefined;
  }
  function UnionTypeAnnotation(node, parent) {
    const parentType = parent.type;
    return (
      parentType === 'ArrayTypeAnnotation' ||
      parentType === 'NullableTypeAnnotation' ||
      parentType === 'IntersectionTypeAnnotation' ||
      parentType === 'UnionTypeAnnotation'
    );
  }
  function OptionalIndexedAccessType(node, parent) {
    return isIndexedAccessType(parent) && parent.objectType === node;
  }
  function TSAsExpression(node, parent) {
    if (
      (parent.type === 'AssignmentExpression' ||
        parent.type === 'AssignmentPattern') &&
      parent.left === node
    ) {
      return true;
    }
    if (
      parent.type === 'BinaryExpression' &&
      (parent.operator === '|' || parent.operator === '&') &&
      node === parent.left
    ) {
      return true;
    }
    return Binary(node, parent);
  }
  function TSUnionType(node, parent) {
    const parentType = parent.type;
    return (
      parentType === 'TSArrayType' ||
      parentType === 'TSOptionalType' ||
      parentType === 'TSIntersectionType' ||
      parentType === 'TSRestType'
    );
  }
  function TSInferType(node, parent) {
    const parentType = parent.type;
    return parentType === 'TSArrayType' || parentType === 'TSOptionalType';
  }
  function TSInstantiationExpression(node, parent) {
    const parentType = parent.type;
    return (
      (parentType === 'CallExpression' ||
        parentType === 'OptionalCallExpression' ||
        parentType === 'NewExpression' ||
        parentType === 'TSInstantiationExpression') &&
      !!parent.typeParameters
    );
  }
  function BinaryExpression(node, parent, tokenContext, inForStatementInit) {
    return node.operator === 'in' && inForStatementInit;
  }
  function SequenceExpression(node, parent) {
    const parentType = parent.type;
    if (
      parentType === 'SequenceExpression' ||
      parentType === 'ParenthesizedExpression' ||
      (parentType === 'MemberExpression' && parent.property === node) ||
      (parentType === 'OptionalMemberExpression' && parent.property === node) ||
      parentType === 'TemplateLiteral'
    ) {
      return false;
    }
    if (parentType === 'ClassDeclaration') {
      return true;
    }
    if (parentType === 'ForOfStatement') {
      return parent.right === node;
    }
    if (parentType === 'ExportDefaultDeclaration') {
      return true;
    }
    return !isStatement(parent);
  }
  function YieldExpression(node, parent) {
    const parentType = parent.type;
    return (
      parentType === 'BinaryExpression' ||
      parentType === 'LogicalExpression' ||
      parentType === 'UnaryExpression' ||
      parentType === 'SpreadElement' ||
      hasPostfixPart(node, parent) ||
      (parentType === 'AwaitExpression' && isYieldExpression(node)) ||
      (parentType === 'ConditionalExpression' && node === parent.test) ||
      isClassExtendsClause(node, parent) ||
      isTSTypeExpression(parentType)
    );
  }
  function ClassExpression(node, parent, tokenContext) {
    return Boolean(
      tokenContext &
        (_index.TokenContext.expressionStatement |
          _index.TokenContext.exportDefault)
    );
  }
  function UnaryLike(node, parent) {
    return (
      hasPostfixPart(node, parent) ||
      (isBinaryExpression(parent) &&
        parent.operator === '**' &&
        parent.left === node) ||
      isClassExtendsClause(node, parent)
    );
  }
  function FunctionExpression(node, parent, tokenContext) {
    return Boolean(
      tokenContext &
        (_index.TokenContext.expressionStatement |
          _index.TokenContext.exportDefault)
    );
  }
  function ConditionalExpression(node, parent) {
    const parentType = parent.type;
    if (
      parentType === 'UnaryExpression' ||
      parentType === 'SpreadElement' ||
      parentType === 'BinaryExpression' ||
      parentType === 'LogicalExpression' ||
      (parentType === 'ConditionalExpression' && parent.test === node) ||
      parentType === 'AwaitExpression' ||
      isTSTypeExpression(parentType)
    ) {
      return true;
    }
    return UnaryLike(node, parent);
  }
  function OptionalMemberExpression(node, parent) {
    return (
      (isCallExpression(parent) && parent.callee === node) ||
      (isMemberExpression(parent) && parent.object === node)
    );
  }
  function AssignmentExpression(node, parent, tokenContext) {
    if (
      needsParenBeforeExpressionBrace(tokenContext) &&
      isObjectPattern(node.left)
    ) {
      return true;
    } else {
      return ConditionalExpression(node, parent);
    }
  }
  function LogicalExpression(node, parent) {
    const parentType = parent.type;
    if (isTSTypeExpression(parentType)) return true;
    if (parentType !== 'LogicalExpression') return false;
    switch (node.operator) {
      case '||':
        return parent.operator === '??' || parent.operator === '&&';
      case '&&':
        return parent.operator === '??';
      case '??':
        return parent.operator !== '??';
    }
  }
  function Identifier(
    node,
    parent,
    tokenContext,
    _inForInit,
    getRawIdentifier
  ) {
    var _node$extra;
    const parentType = parent.type;
    if (
      (_node$extra = node.extra) != null &&
      _node$extra.parenthesized &&
      parentType === 'AssignmentExpression' &&
      parent.left === node
    ) {
      const rightType = parent.right.type;
      if (
        (rightType === 'FunctionExpression' ||
          rightType === 'ClassExpression') &&
        parent.right.id == null
      ) {
        return true;
      }
    }
    if (getRawIdentifier && getRawIdentifier(node) !== node.name) {
      return false;
    }
    if (node.name === 'let') {
      const isFollowedByBracket =
        isMemberExpression(parent, {object: node, computed: true}) ||
        isOptionalMemberExpression(parent, {
          object: node,
          computed: true,
          optional: false,
        });
      if (
        isFollowedByBracket &&
        tokenContext &
          (_index.TokenContext.expressionStatement |
            _index.TokenContext.forHead |
            _index.TokenContext.forInHead)
      ) {
        return true;
      }
      return Boolean(tokenContext & _index.TokenContext.forOfHead);
    }
    return (
      node.name === 'async' &&
      isForOfStatement(parent, {left: node, await: false})
    );
  }
  return parentheses$2;
}
var hasRequiredNode$1;
function requireNode$1() {
  if (hasRequiredNode$1) return node$2;
  hasRequiredNode$1 = 1;
  Object.defineProperty(node$2, '__esModule', {value: true});
  node$2.TokenContext = void 0;
  node$2.isLastChild = isLastChild;
  node$2.needsParens = needsParens;
  node$2.needsWhitespace = needsWhitespace;
  node$2.needsWhitespaceAfter = needsWhitespaceAfter;
  node$2.needsWhitespaceBefore = needsWhitespaceBefore;
  var whitespace = requireWhitespace$1();
  var parens = requireParentheses$1();
  var _t = t$d;
  const {
    FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS,
    VISITOR_KEYS: VISITOR_KEYS,
    isCallExpression: isCallExpression,
    isDecorator: isDecorator,
    isExpressionStatement: isExpressionStatement,
    isMemberExpression: isMemberExpression,
    isNewExpression: isNewExpression,
    isParenthesizedExpression: isParenthesizedExpression,
  } = _t;
  node$2.TokenContext = {
    expressionStatement: 1,
    arrowBody: 2,
    exportDefault: 4,
    forHead: 8,
    forInHead: 16,
    forOfHead: 32,
    arrowFlowReturnType: 64,
  };
  function expandAliases(obj) {
    const map = new Map();
    function add(type, func) {
      const fn = map.get(type);
      map.set(
        type,
        fn
          ? function (node, parent, stack, inForInit, getRawIdentifier) {
              var _fn;
              return (_fn = fn(
                node,
                parent,
                stack,
                inForInit,
                getRawIdentifier
              )) != null
                ? _fn
                : func(node, parent, stack, inForInit, getRawIdentifier);
            }
          : func
      );
    }
    for (const type of Object.keys(obj)) {
      const aliases = FLIPPED_ALIAS_KEYS[type];
      if (aliases) {
        for (const alias of aliases) {
          add(alias, obj[type]);
        }
      } else {
        add(type, obj[type]);
      }
    }
    return map;
  }
  const expandedParens = expandAliases(parens);
  const expandedWhitespaceNodes = expandAliases(whitespace.nodes);
  function isOrHasCallExpression(node) {
    if (isCallExpression(node)) {
      return true;
    }
    return isMemberExpression(node) && isOrHasCallExpression(node.object);
  }
  function needsWhitespace(node, parent, type) {
    var _expandedWhitespaceNo;
    if (!node) return false;
    if (isExpressionStatement(node)) {
      node = node.expression;
    }
    const flag =
      (_expandedWhitespaceNo = expandedWhitespaceNodes.get(node.type)) == null
        ? void 0
        : _expandedWhitespaceNo(node, parent);
    if (typeof flag === 'number') {
      return (flag & type) !== 0;
    }
    return false;
  }
  function needsWhitespaceBefore(node, parent) {
    return needsWhitespace(node, parent, 1);
  }
  function needsWhitespaceAfter(node, parent) {
    return needsWhitespace(node, parent, 2);
  }
  function needsParens(
    node,
    parent,
    tokenContext,
    inForInit,
    getRawIdentifier
  ) {
    var _expandedParens$get;
    if (!parent) return false;
    if (isNewExpression(parent) && parent.callee === node) {
      if (isOrHasCallExpression(node)) return true;
    }
    if (isDecorator(parent)) {
      return (
        !isDecoratorMemberExpression(node) &&
        !(isCallExpression(node) && isDecoratorMemberExpression(node.callee)) &&
        !isParenthesizedExpression(node)
      );
    }
    return (_expandedParens$get = expandedParens.get(node.type)) == null
      ? void 0
      : _expandedParens$get(
          node,
          parent,
          tokenContext,
          inForInit,
          getRawIdentifier
        );
  }
  function isDecoratorMemberExpression(node) {
    switch (node.type) {
      case 'Identifier':
        return true;
      case 'MemberExpression':
        return (
          !node.computed &&
          node.property.type === 'Identifier' &&
          isDecoratorMemberExpression(node.object)
        );
      default:
        return false;
    }
  }
  function isLastChild(parent, child) {
    const visitorKeys = VISITOR_KEYS[parent.type];
    for (let i = visitorKeys.length - 1; i >= 0; i--) {
      const val = parent[visitorKeys[i]];
      if (val === child) {
        return true;
      } else if (Array.isArray(val)) {
        let j = val.length - 1;
        while (j >= 0 && val[j] === null) j--;
        return j >= 0 && val[j] === child;
      } else if (val) {
        return false;
      }
    }
    return false;
  }
  return node$2;
}
var tokenMap$1 = {};
var hasRequiredTokenMap$1;
function requireTokenMap$1() {
  if (hasRequiredTokenMap$1) return tokenMap$1;
  hasRequiredTokenMap$1 = 1;
  Object.defineProperty(tokenMap$1, '__esModule', {value: true});
  tokenMap$1.TokenMap = void 0;
  var _t = t$d;
  const {traverseFast: traverseFast, VISITOR_KEYS: VISITOR_KEYS} = _t;
  class TokenMap {
    constructor(ast, tokens, source) {
      this._tokens = void 0;
      this._source = void 0;
      this._nodesToTokenIndexes = new Map();
      this._nodesOccurrencesCountCache = new Map();
      this._tokensCache = new Map();
      this._tokens = tokens;
      this._source = source;
      traverseFast(ast, node => {
        const indexes = this._getTokensIndexesOfNode(node);
        if (indexes.length > 0) this._nodesToTokenIndexes.set(node, indexes);
      });
      this._tokensCache = null;
    }
    has(node) {
      return this._nodesToTokenIndexes.has(node);
    }
    getIndexes(node) {
      return this._nodesToTokenIndexes.get(node);
    }
    find(node, condition) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (indexes) {
        for (let k = 0; k < indexes.length; k++) {
          const index = indexes[k];
          const tok = this._tokens[index];
          if (condition(tok, index)) return tok;
        }
      }
      return null;
    }
    findLastIndex(node, condition) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (indexes) {
        for (let k = indexes.length - 1; k >= 0; k--) {
          const index = indexes[k];
          const tok = this._tokens[index];
          if (condition(tok, index)) return index;
        }
      }
      return -1;
    }
    findMatching(node, test, occurrenceCount = 0) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (indexes) {
        let i = 0;
        const count = occurrenceCount;
        if (count > 1) {
          const cache = this._nodesOccurrencesCountCache.get(node);
          if (cache && cache.test === test && cache.count < count) {
            i = cache.i + 1;
            occurrenceCount -= cache.count + 1;
          }
        }
        for (; i < indexes.length; i++) {
          const tok = this._tokens[indexes[i]];
          if (this.matchesOriginal(tok, test)) {
            if (occurrenceCount === 0) {
              if (count > 0) {
                this._nodesOccurrencesCountCache.set(node, {
                  test: test,
                  count: count,
                  i: i,
                });
              }
              return tok;
            }
            occurrenceCount--;
          }
        }
      }
      return null;
    }
    matchesOriginal(token, test) {
      if (token.end - token.start !== test.length) return false;
      if (token.value != null) return token.value === test;
      return this._source.startsWith(test, token.start);
    }
    startMatches(node, test) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (!indexes) return false;
      const tok = this._tokens[indexes[0]];
      if (tok.start !== node.start) return false;
      return this.matchesOriginal(tok, test);
    }
    endMatches(node, test) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (!indexes) return false;
      const tok = this._tokens[indexes[indexes.length - 1]];
      if (tok.end !== node.end) return false;
      return this.matchesOriginal(tok, test);
    }
    _getTokensIndexesOfNode(node) {
      if (node.start == null || node.end == null) return [];
      const {first: first, last: last} = this._findTokensOfNode(
        node,
        0,
        this._tokens.length - 1
      );
      let low = first;
      const children = childrenIterator(node);
      if (
        (node.type === 'ExportNamedDeclaration' ||
          node.type === 'ExportDefaultDeclaration') &&
        node.declaration &&
        node.declaration.type === 'ClassDeclaration'
      ) {
        children.next();
      }
      const indexes = [];
      for (const child of children) {
        if (child == null) continue;
        if (child.start == null || child.end == null) continue;
        const childTok = this._findTokensOfNode(child, low, last);
        const high = childTok.first;
        for (let k = low; k < high; k++) indexes.push(k);
        low = childTok.last + 1;
      }
      for (let k = low; k <= last; k++) indexes.push(k);
      return indexes;
    }
    _findTokensOfNode(node, low, high) {
      const cached = this._tokensCache.get(node);
      if (cached) return cached;
      const first = this._findFirstTokenOfNode(node.start, low, high);
      const last = this._findLastTokenOfNode(node.end, first, high);
      this._tokensCache.set(node, {first: first, last: last});
      return {first: first, last: last};
    }
    _findFirstTokenOfNode(start, low, high) {
      while (low <= high) {
        const mid = (high + low) >> 1;
        if (start < this._tokens[mid].start) {
          high = mid - 1;
        } else if (start > this._tokens[mid].start) {
          low = mid + 1;
        } else {
          return mid;
        }
      }
      return low;
    }
    _findLastTokenOfNode(end, low, high) {
      while (low <= high) {
        const mid = (high + low) >> 1;
        if (end < this._tokens[mid].end) {
          high = mid - 1;
        } else if (end > this._tokens[mid].end) {
          low = mid + 1;
        } else {
          return mid;
        }
      }
      return high;
    }
  }
  tokenMap$1.TokenMap = TokenMap;
  function* childrenIterator(node) {
    if (node.type === 'TemplateLiteral') {
      yield node.quasis[0];
      for (let i = 1; i < node.quasis.length; i++) {
        yield node.expressions[i - 1];
        yield node.quasis[i];
      }
      return;
    }
    const keys = VISITOR_KEYS[node.type];
    for (const key of keys) {
      const child = node[key];
      if (!child) continue;
      if (Array.isArray(child)) {
        yield* child;
      } else {
        yield child;
      }
    }
  }
  return tokenMap$1;
}
var generators$2 = {};
var templateLiterals$2 = {};
var hasRequiredTemplateLiterals$1;
function requireTemplateLiterals$1() {
  if (hasRequiredTemplateLiterals$1) return templateLiterals$2;
  hasRequiredTemplateLiterals$1 = 1;
  Object.defineProperty(templateLiterals$2, '__esModule', {value: true});
  templateLiterals$2.TaggedTemplateExpression = TaggedTemplateExpression;
  templateLiterals$2.TemplateElement = TemplateElement;
  templateLiterals$2.TemplateLiteral = TemplateLiteral;
  function TaggedTemplateExpression(node) {
    this.print(node.tag);
    this.print(node.typeParameters);
    this.print(node.quasi);
  }
  function TemplateElement() {
    throw new Error('TemplateElement printing is handled in TemplateLiteral');
  }
  function TemplateLiteral(node) {
    const quasis = node.quasis;
    let partRaw = '`';
    for (let i = 0; i < quasis.length; i++) {
      partRaw += quasis[i].value.raw;
      if (i + 1 < quasis.length) {
        this.token(partRaw + '${', true);
        this.print(node.expressions[i]);
        partRaw = '}';
        if (this.tokenMap) {
          const token = this.tokenMap.findMatching(node, '}', i);
          if (token) this._catchUpTo(token.loc.start);
        }
      }
    }
    this.token(partRaw + '`', true);
  }
  return templateLiterals$2;
}
var expressions$2 = {};
var hasRequiredExpressions$1;
function requireExpressions$1() {
  if (hasRequiredExpressions$1) return expressions$2;
  hasRequiredExpressions$1 = 1;
  Object.defineProperty(expressions$2, '__esModule', {value: true});
  expressions$2.LogicalExpression =
    expressions$2.BinaryExpression =
    expressions$2.AssignmentExpression =
      AssignmentExpression;
  expressions$2.AssignmentPattern = AssignmentPattern;
  expressions$2.AwaitExpression = AwaitExpression;
  expressions$2.BindExpression = BindExpression;
  expressions$2.CallExpression = CallExpression;
  expressions$2.ConditionalExpression = ConditionalExpression;
  expressions$2.Decorator = Decorator;
  expressions$2.DoExpression = DoExpression;
  expressions$2.EmptyStatement = EmptyStatement;
  expressions$2.ExpressionStatement = ExpressionStatement;
  expressions$2.Import = Import;
  expressions$2.MemberExpression = MemberExpression;
  expressions$2.MetaProperty = MetaProperty;
  expressions$2.ModuleExpression = ModuleExpression;
  expressions$2.NewExpression = NewExpression;
  expressions$2.OptionalCallExpression = OptionalCallExpression;
  expressions$2.OptionalMemberExpression = OptionalMemberExpression;
  expressions$2.ParenthesizedExpression = ParenthesizedExpression;
  expressions$2.PrivateName = PrivateName;
  expressions$2.SequenceExpression = SequenceExpression;
  expressions$2.Super = Super;
  expressions$2.ThisExpression = ThisExpression;
  expressions$2.UnaryExpression = UnaryExpression;
  expressions$2.UpdateExpression = UpdateExpression;
  expressions$2.V8IntrinsicIdentifier = V8IntrinsicIdentifier;
  expressions$2.YieldExpression = YieldExpression;
  expressions$2._shouldPrintDecoratorsBeforeExport =
    _shouldPrintDecoratorsBeforeExport;
  var _t = t$d;
  var _index = requireNode$1();
  const {
    isCallExpression: isCallExpression,
    isLiteral: isLiteral,
    isMemberExpression: isMemberExpression,
    isNewExpression: isNewExpression,
    isPattern: isPattern,
  } = _t;
  function UnaryExpression(node) {
    const {operator: operator} = node;
    if (
      operator === 'void' ||
      operator === 'delete' ||
      operator === 'typeof' ||
      operator === 'throw'
    ) {
      this.word(operator);
      this.space();
    } else {
      this.token(operator);
    }
    this.print(node.argument);
  }
  function DoExpression(node) {
    if (node.async) {
      this.word('async', true);
      this.space();
    }
    this.word('do');
    this.space();
    this.print(node.body);
  }
  function ParenthesizedExpression(node) {
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.print(node.expression);
    exit();
    this.rightParens(node);
  }
  function UpdateExpression(node) {
    if (node.prefix) {
      this.token(node.operator);
      this.print(node.argument);
    } else {
      this.print(node.argument, true);
      this.token(node.operator);
    }
  }
  function ConditionalExpression(node) {
    this.print(node.test);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.consequent);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.alternate);
  }
  function NewExpression(node, parent) {
    this.word('new');
    this.space();
    this.print(node.callee);
    if (
      this.format.minified &&
      node.arguments.length === 0 &&
      !node.optional &&
      !isCallExpression(parent, {callee: node}) &&
      !isMemberExpression(parent) &&
      !isNewExpression(parent)
    ) {
      return;
    }
    this.print(node.typeArguments);
    this.print(node.typeParameters);
    if (node.optional) {
      this.token('?.');
    }
    if (
      node.arguments.length === 0 &&
      this.tokenMap &&
      !this.tokenMap.endMatches(node, ')')
    ) {
      return;
    }
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments, {
      printTrailingSeparator: this.shouldPrintTrailingComma(')'),
    });
    exit();
    this.rightParens(node);
  }
  function SequenceExpression(node) {
    this.printList(node.expressions);
  }
  function ThisExpression() {
    this.word('this');
  }
  function Super() {
    this.word('super');
  }
  function _shouldPrintDecoratorsBeforeExport(node) {
    if (typeof this.format.decoratorsBeforeExport === 'boolean') {
      return this.format.decoratorsBeforeExport;
    }
    return (
      typeof node.start === 'number' && node.start === node.declaration.start
    );
  }
  function Decorator(node) {
    this.tokenChar(64);
    this.print(node.expression);
    this.newline();
  }
  function OptionalMemberExpression(node) {
    let {computed: computed} = node;
    const {optional: optional, property: property} = node;
    this.print(node.object);
    if (!computed && isMemberExpression(property)) {
      throw new TypeError(
        'Got a MemberExpression for MemberExpression property'
      );
    }
    if (isLiteral(property) && typeof property.value === 'number') {
      computed = true;
    }
    if (optional) {
      this.token('?.');
    }
    if (computed) {
      this.tokenChar(91);
      this.print(property);
      this.tokenChar(93);
    } else {
      if (!optional) {
        this.tokenChar(46);
      }
      this.print(property);
    }
  }
  function OptionalCallExpression(node) {
    this.print(node.callee);
    this.print(node.typeParameters);
    if (node.optional) {
      this.token('?.');
    }
    this.print(node.typeArguments);
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments);
    exit();
    this.rightParens(node);
  }
  function CallExpression(node) {
    this.print(node.callee);
    this.print(node.typeArguments);
    this.print(node.typeParameters);
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments, {
      printTrailingSeparator: this.shouldPrintTrailingComma(')'),
    });
    exit();
    this.rightParens(node);
  }
  function Import() {
    this.word('import');
  }
  function AwaitExpression(node) {
    this.word('await');
    if (node.argument) {
      this.space();
      this.printTerminatorless(node.argument);
    }
  }
  function YieldExpression(node) {
    this.word('yield', true);
    if (node.delegate) {
      this.tokenChar(42);
      if (node.argument) {
        this.space();
        this.print(node.argument);
      }
    } else {
      if (node.argument) {
        this.space();
        this.printTerminatorless(node.argument);
      }
    }
  }
  function EmptyStatement() {
    this.semicolon(true);
  }
  function ExpressionStatement(node) {
    this.tokenContext |= _index.TokenContext.expressionStatement;
    this.print(node.expression);
    this.semicolon();
  }
  function AssignmentPattern(node) {
    this.print(node.left);
    if (node.left.type === 'Identifier' || isPattern(node.left)) {
      if (node.left.optional) this.tokenChar(63);
      this.print(node.left.typeAnnotation);
    }
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.right);
  }
  function AssignmentExpression(node) {
    this.print(node.left);
    this.space();
    if (node.operator === 'in' || node.operator === 'instanceof') {
      this.word(node.operator);
    } else {
      this.token(node.operator);
      this._endsWithDiv = node.operator === '/';
    }
    this.space();
    this.print(node.right);
  }
  function BindExpression(node) {
    this.print(node.object);
    this.token('::');
    this.print(node.callee);
  }
  function MemberExpression(node) {
    this.print(node.object);
    if (!node.computed && isMemberExpression(node.property)) {
      throw new TypeError(
        'Got a MemberExpression for MemberExpression property'
      );
    }
    let computed = node.computed;
    if (isLiteral(node.property) && typeof node.property.value === 'number') {
      computed = true;
    }
    if (computed) {
      const exit = this.enterDelimited();
      this.tokenChar(91);
      this.print(node.property);
      this.tokenChar(93);
      exit();
    } else {
      this.tokenChar(46);
      this.print(node.property);
    }
  }
  function MetaProperty(node) {
    this.print(node.meta);
    this.tokenChar(46);
    this.print(node.property);
  }
  function PrivateName(node) {
    this.tokenChar(35);
    this.print(node.id);
  }
  function V8IntrinsicIdentifier(node) {
    this.tokenChar(37);
    this.word(node.name);
  }
  function ModuleExpression(node) {
    this.word('module', true);
    this.space();
    this.tokenChar(123);
    this.indent();
    const {body: body} = node;
    if (body.body.length || body.directives.length) {
      this.newline();
    }
    this.print(body);
    this.dedent();
    this.rightBrace(node);
  }
  return expressions$2;
}
var statements$2 = {};
var hasRequiredStatements$1;
function requireStatements$1() {
  if (hasRequiredStatements$1) return statements$2;
  hasRequiredStatements$1 = 1;
  Object.defineProperty(statements$2, '__esModule', {value: true});
  statements$2.BreakStatement = BreakStatement;
  statements$2.CatchClause = CatchClause;
  statements$2.ContinueStatement = ContinueStatement;
  statements$2.DebuggerStatement = DebuggerStatement;
  statements$2.DoWhileStatement = DoWhileStatement;
  statements$2.ForOfStatement = statements$2.ForInStatement = void 0;
  statements$2.ForStatement = ForStatement;
  statements$2.IfStatement = IfStatement;
  statements$2.LabeledStatement = LabeledStatement;
  statements$2.ReturnStatement = ReturnStatement;
  statements$2.SwitchCase = SwitchCase;
  statements$2.SwitchStatement = SwitchStatement;
  statements$2.ThrowStatement = ThrowStatement;
  statements$2.TryStatement = TryStatement;
  statements$2.VariableDeclaration = VariableDeclaration;
  statements$2.VariableDeclarator = VariableDeclarator;
  statements$2.WhileStatement = WhileStatement;
  statements$2.WithStatement = WithStatement;
  var _t = t$d;
  var _index = requireNode$1();
  const {
    isFor: isFor,
    isForStatement: isForStatement,
    isIfStatement: isIfStatement,
    isStatement: isStatement,
  } = _t;
  function WithStatement(node) {
    this.word('with');
    this.space();
    this.tokenChar(40);
    this.print(node.object);
    this.tokenChar(41);
    this.printBlock(node);
  }
  function IfStatement(node) {
    this.word('if');
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.space();
    const needsBlock =
      node.alternate && isIfStatement(getLastStatement(node.consequent));
    if (needsBlock) {
      this.tokenChar(123);
      this.newline();
      this.indent();
    }
    this.printAndIndentOnComments(node.consequent);
    if (needsBlock) {
      this.dedent();
      this.newline();
      this.tokenChar(125);
    }
    if (node.alternate) {
      if (this.endsWith(125)) this.space();
      this.word('else');
      this.space();
      this.printAndIndentOnComments(node.alternate);
    }
  }
  function getLastStatement(statement) {
    const {body: body} = statement;
    if (isStatement(body) === false) {
      return statement;
    }
    return getLastStatement(body);
  }
  function ForStatement(node) {
    this.word('for');
    this.space();
    this.tokenChar(40);
    {
      const exit = this.enterForStatementInit();
      this.tokenContext |= _index.TokenContext.forHead;
      this.print(node.init);
      exit();
    }
    this.tokenChar(59);
    if (node.test) {
      this.space();
      this.print(node.test);
    }
    this.token(';', false, 1);
    if (node.update) {
      this.space();
      this.print(node.update);
    }
    this.tokenChar(41);
    this.printBlock(node);
  }
  function WhileStatement(node) {
    this.word('while');
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.printBlock(node);
  }
  function ForXStatement(node) {
    this.word('for');
    this.space();
    const isForOf = node.type === 'ForOfStatement';
    if (isForOf && node.await) {
      this.word('await');
      this.space();
    }
    this.noIndentInnerCommentsHere();
    this.tokenChar(40);
    {
      const exit = isForOf ? null : this.enterForStatementInit();
      this.tokenContext |= isForOf
        ? _index.TokenContext.forOfHead
        : _index.TokenContext.forInHead;
      this.print(node.left);
      exit == null || exit();
    }
    this.space();
    this.word(isForOf ? 'of' : 'in');
    this.space();
    this.print(node.right);
    this.tokenChar(41);
    this.printBlock(node);
  }
  statements$2.ForInStatement = ForXStatement;
  statements$2.ForOfStatement = ForXStatement;
  function DoWhileStatement(node) {
    this.word('do');
    this.space();
    this.print(node.body);
    this.space();
    this.word('while');
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.semicolon();
  }
  function printStatementAfterKeyword(printer, node) {
    if (node) {
      printer.space();
      printer.printTerminatorless(node);
    }
    printer.semicolon();
  }
  function BreakStatement(node) {
    this.word('break');
    printStatementAfterKeyword(this, node.label);
  }
  function ContinueStatement(node) {
    this.word('continue');
    printStatementAfterKeyword(this, node.label);
  }
  function ReturnStatement(node) {
    this.word('return');
    printStatementAfterKeyword(this, node.argument);
  }
  function ThrowStatement(node) {
    this.word('throw');
    printStatementAfterKeyword(this, node.argument);
  }
  function LabeledStatement(node) {
    this.print(node.label);
    this.tokenChar(58);
    this.space();
    this.print(node.body);
  }
  function TryStatement(node) {
    this.word('try');
    this.space();
    this.print(node.block);
    this.space();
    if (node.handlers) {
      this.print(node.handlers[0]);
    } else {
      this.print(node.handler);
    }
    if (node.finalizer) {
      this.space();
      this.word('finally');
      this.space();
      this.print(node.finalizer);
    }
  }
  function CatchClause(node) {
    this.word('catch');
    this.space();
    if (node.param) {
      this.tokenChar(40);
      this.print(node.param);
      this.print(node.param.typeAnnotation);
      this.tokenChar(41);
      this.space();
    }
    this.print(node.body);
  }
  function SwitchStatement(node) {
    this.word('switch');
    this.space();
    this.tokenChar(40);
    this.print(node.discriminant);
    this.tokenChar(41);
    this.space();
    this.tokenChar(123);
    this.printSequence(node.cases, {
      indent: true,
      addNewlines(leading, cas) {
        if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
      },
    });
    this.rightBrace(node);
  }
  function SwitchCase(node) {
    if (node.test) {
      this.word('case');
      this.space();
      this.print(node.test);
      this.tokenChar(58);
    } else {
      this.word('default');
      this.tokenChar(58);
    }
    if (node.consequent.length) {
      this.newline();
      this.printSequence(node.consequent, {indent: true});
    }
  }
  function DebuggerStatement() {
    this.word('debugger');
    this.semicolon();
  }
  function VariableDeclaration(node, parent) {
    if (node.declare) {
      this.word('declare');
      this.space();
    }
    const {kind: kind} = node;
    if (kind === 'await using') {
      this.word('await');
      this.space();
      this.word('using', true);
    } else {
      this.word(kind, kind === 'using');
    }
    this.space();
    let hasInits = false;
    if (!isFor(parent)) {
      for (const declar of node.declarations) {
        if (declar.init) {
          hasInits = true;
        }
      }
    }
    this.printList(node.declarations, {
      separator: hasInits
        ? function (occurrenceCount) {
            this.token(',', false, occurrenceCount);
            this.newline();
          }
        : undefined,
      indent: node.declarations.length > 1 ? true : false,
    });
    if (isFor(parent)) {
      if (isForStatement(parent)) {
        if (parent.init === node) return;
      } else {
        if (parent.left === node) return;
      }
    }
    this.semicolon();
  }
  function VariableDeclarator(node) {
    this.print(node.id);
    if (node.definite) this.tokenChar(33);
    this.print(node.id.typeAnnotation);
    if (node.init) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.init);
    }
  }
  return statements$2;
}
var classes$2 = {};
var hasRequiredClasses$1;
function requireClasses$1() {
  if (hasRequiredClasses$1) return classes$2;
  hasRequiredClasses$1 = 1;
  Object.defineProperty(classes$2, '__esModule', {value: true});
  classes$2.ClassAccessorProperty = ClassAccessorProperty;
  classes$2.ClassBody = ClassBody;
  classes$2.ClassExpression = classes$2.ClassDeclaration = ClassDeclaration;
  classes$2.ClassMethod = ClassMethod;
  classes$2.ClassPrivateMethod = ClassPrivateMethod;
  classes$2.ClassPrivateProperty = ClassPrivateProperty;
  classes$2.ClassProperty = ClassProperty;
  classes$2.StaticBlock = StaticBlock;
  classes$2._classMethodHead = _classMethodHead;
  var _t = t$d;
  const {
    isExportDefaultDeclaration: isExportDefaultDeclaration,
    isExportNamedDeclaration: isExportNamedDeclaration,
  } = _t;
  function ClassDeclaration(node, parent) {
    const inExport =
      isExportDefaultDeclaration(parent) || isExportNamedDeclaration(parent);
    if (!inExport || !this._shouldPrintDecoratorsBeforeExport(parent)) {
      this.printJoin(node.decorators);
    }
    if (node.declare) {
      this.word('declare');
      this.space();
    }
    if (node.abstract) {
      this.word('abstract');
      this.space();
    }
    this.word('class');
    if (node.id) {
      this.space();
      this.print(node.id);
    }
    this.print(node.typeParameters);
    if (node.superClass) {
      this.space();
      this.word('extends');
      this.space();
      this.print(node.superClass);
      this.print(node.superTypeParameters);
    }
    if (node.implements) {
      this.space();
      this.word('implements');
      this.space();
      this.printList(node.implements);
    }
    this.space();
    this.print(node.body);
  }
  function ClassBody(node) {
    this.tokenChar(123);
    if (node.body.length === 0) {
      this.tokenChar(125);
    } else {
      this.newline();
      const separator = classBodyEmptySemicolonsPrinter(this, node);
      separator == null || separator(-1);
      const exit = this.enterDelimited();
      this.printJoin(node.body, {
        statement: true,
        indent: true,
        separator: separator,
        printTrailingSeparator: true,
      });
      exit();
      if (!this.endsWith(10)) this.newline();
      this.rightBrace(node);
    }
  }
  function classBodyEmptySemicolonsPrinter(printer, node) {
    if (!printer.tokenMap || node.start == null || node.end == null) {
      return null;
    }
    const indexes = printer.tokenMap.getIndexes(node);
    if (!indexes) return null;
    let k = 1;
    let occurrenceCount = 0;
    let nextLocIndex = 0;
    const advanceNextLocIndex = () => {
      while (
        nextLocIndex < node.body.length &&
        node.body[nextLocIndex].start == null
      ) {
        nextLocIndex++;
      }
    };
    advanceNextLocIndex();
    return i => {
      if (nextLocIndex <= i) {
        nextLocIndex = i + 1;
        advanceNextLocIndex();
      }
      const end =
        nextLocIndex === node.body.length
          ? node.end
          : node.body[nextLocIndex].start;
      let tok;
      while (
        k < indexes.length &&
        printer.tokenMap.matchesOriginal(
          (tok = printer._tokens[indexes[k]]),
          ';'
        ) &&
        tok.start < end
      ) {
        printer.token(';', undefined, occurrenceCount++);
        k++;
      }
    };
  }
  function ClassProperty(node) {
    this.printJoin(node.decorators);
    if (!node.static && !this.format.preserveFormat) {
      var _node$key$loc;
      const endLine =
        (_node$key$loc = node.key.loc) == null ||
        (_node$key$loc = _node$key$loc.end) == null
          ? void 0
          : _node$key$loc.line;
      if (endLine) this.catchUp(endLine);
    }
    this.tsPrintClassMemberModifiers(node);
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      this._variance(node);
      this.print(node.key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    if (node.definite) {
      this.tokenChar(33);
    }
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassAccessorProperty(node) {
    var _node$key$loc2;
    this.printJoin(node.decorators);
    const endLine =
      (_node$key$loc2 = node.key.loc) == null ||
      (_node$key$loc2 = _node$key$loc2.end) == null
        ? void 0
        : _node$key$loc2.line;
    if (endLine) this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    this.word('accessor', true);
    this.space();
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      this._variance(node);
      this.print(node.key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    if (node.definite) {
      this.tokenChar(33);
    }
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassPrivateProperty(node) {
    this.printJoin(node.decorators);
    if (node.static) {
      this.word('static');
      this.space();
    }
    this.print(node.key);
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body);
  }
  function ClassPrivateMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body);
  }
  function _classMethodHead(node) {
    this.printJoin(node.decorators);
    if (!this.format.preserveFormat) {
      var _node$key$loc3;
      const endLine =
        (_node$key$loc3 = node.key.loc) == null ||
        (_node$key$loc3 = _node$key$loc3.end) == null
          ? void 0
          : _node$key$loc3.line;
      if (endLine) this.catchUp(endLine);
    }
    this.tsPrintClassMemberModifiers(node);
    this._methodHead(node);
  }
  function StaticBlock(node) {
    this.word('static');
    this.space();
    this.tokenChar(123);
    if (node.body.length === 0) {
      this.tokenChar(125);
    } else {
      this.newline();
      this.printSequence(node.body, {indent: true});
      this.rightBrace(node);
    }
  }
  return classes$2;
}
var methods$2 = {};
var hasRequiredMethods$1;
function requireMethods$1() {
  if (hasRequiredMethods$1) return methods$2;
  hasRequiredMethods$1 = 1;
  Object.defineProperty(methods$2, '__esModule', {value: true});
  methods$2.ArrowFunctionExpression = ArrowFunctionExpression;
  methods$2.FunctionDeclaration = methods$2.FunctionExpression =
    FunctionExpression;
  methods$2._functionHead = _functionHead;
  methods$2._methodHead = _methodHead;
  methods$2._param = _param;
  methods$2._parameters = _parameters;
  methods$2._params = _params;
  methods$2._predicate = _predicate;
  methods$2._shouldPrintArrowParamsParens = _shouldPrintArrowParamsParens;
  var _t = t$d;
  var _index = requireNode$1();
  const {isIdentifier: isIdentifier} = _t;
  function _params(node, idNode, parentNode) {
    this.print(node.typeParameters);
    const nameInfo = _getFuncIdName.call(this, idNode, parentNode);
    if (nameInfo) {
      this.sourceIdentifierName(nameInfo.name, nameInfo.pos);
    }
    this.tokenChar(40);
    this._parameters(node.params, ')');
    const noLineTerminator = node.type === 'ArrowFunctionExpression';
    this.print(node.returnType, noLineTerminator);
    this._noLineTerminator = noLineTerminator;
  }
  function _parameters(parameters, endToken) {
    const exit = this.enterDelimited();
    const trailingComma = this.shouldPrintTrailingComma(endToken);
    const paramLength = parameters.length;
    for (let i = 0; i < paramLength; i++) {
      this._param(parameters[i]);
      if (trailingComma || i < paramLength - 1) {
        this.token(',', null, i);
        this.space();
      }
    }
    this.token(endToken);
    exit();
  }
  function _param(parameter) {
    this.printJoin(parameter.decorators);
    this.print(parameter);
    if (parameter.optional) {
      this.tokenChar(63);
    }
    this.print(parameter.typeAnnotation);
  }
  function _methodHead(node) {
    const kind = node.kind;
    const key = node.key;
    if (kind === 'get' || kind === 'set') {
      this.word(kind);
      this.space();
    }
    if (node.async) {
      this.word('async', true);
      this.space();
    }
    if (kind === 'method' || kind === 'init') {
      if (node.generator) {
        this.tokenChar(42);
      }
    }
    if (node.computed) {
      this.tokenChar(91);
      this.print(key);
      this.tokenChar(93);
    } else {
      this.print(key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    this._params(
      node,
      node.computed && node.key.type !== 'StringLiteral' ? undefined : node.key,
      undefined
    );
  }
  function _predicate(node, noLineTerminatorAfter) {
    if (node.predicate) {
      if (!node.returnType) {
        this.tokenChar(58);
      }
      this.space();
      this.print(node.predicate, noLineTerminatorAfter);
    }
  }
  function _functionHead(node, parent) {
    if (node.async) {
      this.word('async');
      if (!this.format.preserveFormat) {
        this._endsWithInnerRaw = false;
      }
      this.space();
    }
    this.word('function');
    if (node.generator) {
      if (!this.format.preserveFormat) {
        this._endsWithInnerRaw = false;
      }
      this.tokenChar(42);
    }
    this.space();
    if (node.id) {
      this.print(node.id);
    }
    this._params(node, node.id, parent);
    if (node.type !== 'TSDeclareFunction') {
      this._predicate(node);
    }
  }
  function FunctionExpression(node, parent) {
    this._functionHead(node, parent);
    this.space();
    this.print(node.body);
  }
  function ArrowFunctionExpression(node, parent) {
    if (node.async) {
      this.word('async', true);
      this.space();
    }
    if (this._shouldPrintArrowParamsParens(node)) {
      this._params(node, undefined, parent);
    } else {
      this.print(node.params[0], true);
    }
    this._predicate(node, true);
    this.space();
    this.printInnerComments();
    this.token('=>');
    this.space();
    this.tokenContext |= _index.TokenContext.arrowBody;
    this.print(node.body);
  }
  function _shouldPrintArrowParamsParens(node) {
    var _firstParam$leadingCo, _firstParam$trailingC;
    if (node.params.length !== 1) return true;
    if (node.typeParameters || node.returnType || node.predicate) {
      return true;
    }
    const firstParam = node.params[0];
    if (
      !isIdentifier(firstParam) ||
      firstParam.typeAnnotation ||
      firstParam.optional ||
      ((_firstParam$leadingCo = firstParam.leadingComments) != null &&
        _firstParam$leadingCo.length) ||
      ((_firstParam$trailingC = firstParam.trailingComments) != null &&
        _firstParam$trailingC.length)
    ) {
      return true;
    }
    if (this.tokenMap) {
      if (node.loc == null) return true;
      if (this.tokenMap.findMatching(node, '(') !== null) return true;
      const arrowToken = this.tokenMap.findMatching(node, '=>');
      if ((arrowToken == null ? void 0 : arrowToken.loc) == null) return true;
      return arrowToken.loc.start.line !== node.loc.start.line;
    }
    if (this.format.retainLines) return true;
    return false;
  }
  function _getFuncIdName(idNode, parent) {
    let id = idNode;
    if (!id && parent) {
      const parentType = parent.type;
      if (parentType === 'VariableDeclarator') {
        id = parent.id;
      } else if (
        parentType === 'AssignmentExpression' ||
        parentType === 'AssignmentPattern'
      ) {
        id = parent.left;
      } else if (
        parentType === 'ObjectProperty' ||
        parentType === 'ClassProperty'
      ) {
        if (!parent.computed || parent.key.type === 'StringLiteral') {
          id = parent.key;
        }
      } else if (
        parentType === 'ClassPrivateProperty' ||
        parentType === 'ClassAccessorProperty'
      ) {
        id = parent.key;
      }
    }
    if (!id) return;
    let nameInfo;
    if (id.type === 'Identifier') {
      var _id$loc, _id$loc2;
      nameInfo = {
        pos: (_id$loc = id.loc) == null ? void 0 : _id$loc.start,
        name:
          ((_id$loc2 = id.loc) == null ? void 0 : _id$loc2.identifierName) ||
          id.name,
      };
    } else if (id.type === 'PrivateName') {
      var _id$loc3;
      nameInfo = {
        pos: (_id$loc3 = id.loc) == null ? void 0 : _id$loc3.start,
        name: '#' + id.id.name,
      };
    } else if (id.type === 'StringLiteral') {
      var _id$loc4;
      nameInfo = {
        pos: (_id$loc4 = id.loc) == null ? void 0 : _id$loc4.start,
        name: id.value,
      };
    }
    return nameInfo;
  }
  return methods$2;
}
var modules$2 = {};
var hasRequiredModules$1;
function requireModules$1() {
  if (hasRequiredModules$1) return modules$2;
  hasRequiredModules$1 = 1;
  Object.defineProperty(modules$2, '__esModule', {value: true});
  modules$2.ExportAllDeclaration = ExportAllDeclaration;
  modules$2.ExportDefaultDeclaration = ExportDefaultDeclaration;
  modules$2.ExportDefaultSpecifier = ExportDefaultSpecifier;
  modules$2.ExportNamedDeclaration = ExportNamedDeclaration;
  modules$2.ExportNamespaceSpecifier = ExportNamespaceSpecifier;
  modules$2.ExportSpecifier = ExportSpecifier;
  modules$2.ImportAttribute = ImportAttribute;
  modules$2.ImportDeclaration = ImportDeclaration;
  modules$2.ImportDefaultSpecifier = ImportDefaultSpecifier;
  modules$2.ImportExpression = ImportExpression;
  modules$2.ImportNamespaceSpecifier = ImportNamespaceSpecifier;
  modules$2.ImportSpecifier = ImportSpecifier;
  modules$2._printAttributes = _printAttributes;
  var _t = t$d;
  var _index = requireNode$1();
  const {
    isClassDeclaration: isClassDeclaration,
    isExportDefaultSpecifier: isExportDefaultSpecifier,
    isExportNamespaceSpecifier: isExportNamespaceSpecifier,
    isImportDefaultSpecifier: isImportDefaultSpecifier,
    isImportNamespaceSpecifier: isImportNamespaceSpecifier,
    isStatement: isStatement,
  } = _t;
  function ImportSpecifier(node) {
    if (node.importKind === 'type' || node.importKind === 'typeof') {
      this.word(node.importKind);
      this.space();
    }
    this.print(node.imported);
    if (node.local && node.local.name !== node.imported.name) {
      this.space();
      this.word('as');
      this.space();
      this.print(node.local);
    }
  }
  function ImportDefaultSpecifier(node) {
    this.print(node.local);
  }
  function ExportDefaultSpecifier(node) {
    this.print(node.exported);
  }
  function ExportSpecifier(node) {
    if (node.exportKind === 'type') {
      this.word('type');
      this.space();
    }
    this.print(node.local);
    if (node.exported && node.local.name !== node.exported.name) {
      this.space();
      this.word('as');
      this.space();
      this.print(node.exported);
    }
  }
  function ExportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word('as');
    this.space();
    this.print(node.exported);
  }
  let warningShown = false;
  function _printAttributes(node, hasPreviousBrace) {
    const {importAttributesKeyword: importAttributesKeyword} = this.format;
    const {attributes: attributes, assertions: assertions} = node;
    if (attributes && !importAttributesKeyword && !warningShown) {
      warningShown = true;
      console.warn(
        `You are using import attributes, without specifying the desired output syntax.\nPlease specify the "importAttributesKeyword" generator option, whose value can be one of:\n - "with"        : \`import { a } from "b" with { type: "json" };\`\n - "assert"      : \`import { a } from "b" assert { type: "json" };\`\n - "with-legacy" : \`import { a } from "b" with type: "json";\`\n`
      );
    }
    const useAssertKeyword =
      importAttributesKeyword === 'assert' ||
      (!importAttributesKeyword && assertions);
    this.word(useAssertKeyword ? 'assert' : 'with');
    this.space();
    if (!useAssertKeyword && importAttributesKeyword !== 'with') {
      this.printList(attributes || assertions);
      return;
    }
    const occurrenceCount = hasPreviousBrace ? 1 : 0;
    this.token('{', null, occurrenceCount);
    this.space();
    this.printList(attributes || assertions, {
      printTrailingSeparator: this.shouldPrintTrailingComma('}'),
    });
    this.space();
    this.token('}', null, occurrenceCount);
  }
  function ExportAllDeclaration(node) {
    var _node$attributes, _node$assertions;
    this.word('export');
    this.space();
    if (node.exportKind === 'type') {
      this.word('type');
      this.space();
    }
    this.tokenChar(42);
    this.space();
    this.word('from');
    this.space();
    if (
      ((_node$attributes = node.attributes) != null &&
        _node$attributes.length) ||
      ((_node$assertions = node.assertions) != null && _node$assertions.length)
    ) {
      this.print(node.source, true);
      this.space();
      this._printAttributes(node, false);
    } else {
      this.print(node.source);
    }
    this.semicolon();
  }
  function maybePrintDecoratorsBeforeExport(printer, node) {
    if (
      isClassDeclaration(node.declaration) &&
      printer._shouldPrintDecoratorsBeforeExport(node)
    ) {
      printer.printJoin(node.declaration.decorators);
    }
  }
  function ExportNamedDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word('export');
    this.space();
    if (node.declaration) {
      const declar = node.declaration;
      this.print(declar);
      if (!isStatement(declar)) this.semicolon();
    } else {
      if (node.exportKind === 'type') {
        this.word('type');
        this.space();
      }
      const specifiers = node.specifiers.slice(0);
      let hasSpecial = false;
      for (;;) {
        const first = specifiers[0];
        if (
          isExportDefaultSpecifier(first) ||
          isExportNamespaceSpecifier(first)
        ) {
          hasSpecial = true;
          this.print(specifiers.shift());
          if (specifiers.length) {
            this.tokenChar(44);
            this.space();
          }
        } else {
          break;
        }
      }
      let hasBrace = false;
      if (specifiers.length || (!specifiers.length && !hasSpecial)) {
        hasBrace = true;
        this.tokenChar(123);
        if (specifiers.length) {
          this.space();
          this.printList(specifiers, {
            printTrailingSeparator: this.shouldPrintTrailingComma('}'),
          });
          this.space();
        }
        this.tokenChar(125);
      }
      if (node.source) {
        var _node$attributes2, _node$assertions2;
        this.space();
        this.word('from');
        this.space();
        if (
          ((_node$attributes2 = node.attributes) != null &&
            _node$attributes2.length) ||
          ((_node$assertions2 = node.assertions) != null &&
            _node$assertions2.length)
        ) {
          this.print(node.source, true);
          this.space();
          this._printAttributes(node, hasBrace);
        } else {
          this.print(node.source);
        }
      }
      this.semicolon();
    }
  }
  function ExportDefaultDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word('export');
    this.noIndentInnerCommentsHere();
    this.space();
    this.word('default');
    this.space();
    this.tokenContext |= _index.TokenContext.exportDefault;
    const declar = node.declaration;
    this.print(declar);
    if (!isStatement(declar)) this.semicolon();
  }
  function ImportDeclaration(node) {
    var _node$attributes3, _node$assertions3;
    this.word('import');
    this.space();
    const isTypeKind =
      node.importKind === 'type' || node.importKind === 'typeof';
    if (isTypeKind) {
      this.noIndentInnerCommentsHere();
      this.word(node.importKind);
      this.space();
    } else if (node.module) {
      this.noIndentInnerCommentsHere();
      this.word('module');
      this.space();
    } else if (node.phase) {
      this.noIndentInnerCommentsHere();
      this.word(node.phase);
      this.space();
    }
    const specifiers = node.specifiers.slice(0);
    const hasSpecifiers = !!specifiers.length;
    while (hasSpecifiers) {
      const first = specifiers[0];
      if (
        isImportDefaultSpecifier(first) ||
        isImportNamespaceSpecifier(first)
      ) {
        this.print(specifiers.shift());
        if (specifiers.length) {
          this.tokenChar(44);
          this.space();
        }
      } else {
        break;
      }
    }
    let hasBrace = false;
    if (specifiers.length) {
      hasBrace = true;
      this.tokenChar(123);
      this.space();
      this.printList(specifiers, {
        printTrailingSeparator: this.shouldPrintTrailingComma('}'),
      });
      this.space();
      this.tokenChar(125);
    } else if (isTypeKind && !hasSpecifiers) {
      hasBrace = true;
      this.tokenChar(123);
      this.tokenChar(125);
    }
    if (hasSpecifiers || isTypeKind) {
      this.space();
      this.word('from');
      this.space();
    }
    if (
      ((_node$attributes3 = node.attributes) != null &&
        _node$attributes3.length) ||
      ((_node$assertions3 = node.assertions) != null &&
        _node$assertions3.length)
    ) {
      this.print(node.source, true);
      this.space();
      this._printAttributes(node, hasBrace);
    } else {
      this.print(node.source);
    }
    this.semicolon();
  }
  function ImportAttribute(node) {
    this.print(node.key);
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ImportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word('as');
    this.space();
    this.print(node.local);
  }
  function ImportExpression(node) {
    this.word('import');
    if (node.phase) {
      this.tokenChar(46);
      this.word(node.phase);
    }
    this.tokenChar(40);
    this.print(node.source);
    if (node.options != null) {
      this.tokenChar(44);
      this.space();
      this.print(node.options);
    }
    this.tokenChar(41);
  }
  return modules$2;
}
var types$3 = {};
var jsesc_1$2;
var hasRequiredJsesc$2;
function requireJsesc$2() {
  if (hasRequiredJsesc$2) return jsesc_1$2;
  hasRequiredJsesc$2 = 1;
  const object = {};
  const hasOwnProperty = object.hasOwnProperty;
  const forOwn = (object, callback) => {
    for (const key in object) {
      if (hasOwnProperty.call(object, key)) {
        callback(key, object[key]);
      }
    }
  };
  const extend = (destination, source) => {
    if (!source) {
      return destination;
    }
    forOwn(source, (key, value) => {
      destination[key] = value;
    });
    return destination;
  };
  const forEach = (array, callback) => {
    const length = array.length;
    let index = -1;
    while (++index < length) {
      callback(array[index]);
    }
  };
  const fourHexEscape = hex => '\\u' + ('0000' + hex).slice(-4);
  const hexadecimal = (code, lowercase) => {
    let hexadecimal = code.toString(16);
    if (lowercase) return hexadecimal;
    return hexadecimal.toUpperCase();
  };
  const toString = object.toString;
  const isArray = Array.isArray;
  const isBuffer = value =>
    typeof Buffer === 'function' && Buffer.isBuffer(value);
  const isObject = value => toString.call(value) == '[object Object]';
  const isString = value =>
    typeof value == 'string' || toString.call(value) == '[object String]';
  const isNumber = value =>
    typeof value == 'number' || toString.call(value) == '[object Number]';
  const isFunction = value => typeof value == 'function';
  const isMap = value => toString.call(value) == '[object Map]';
  const isSet = value => toString.call(value) == '[object Set]';
  const singleEscapes = {
    '\\': '\\\\',
    '\b': '\\b',
    '\f': '\\f',
    '\n': '\\n',
    '\r': '\\r',
    '\t': '\\t',
  };
  const regexSingleEscape = /[\\\b\f\n\r\t]/;
  const regexDigit = /[0-9]/;
  const regexWhitespace =
    /[\xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]/;
  const escapeEverythingRegex =
    /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^]/g;
  const escapeNonAsciiRegex =
    /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^ !#-&\(-\[\]-_a-~]/g;
  const jsesc = (argument, options) => {
    const increaseIndentation = () => {
      oldIndent = indent;
      ++options.indentLevel;
      indent = options.indent.repeat(options.indentLevel);
    };
    const defaults = {
      escapeEverything: false,
      minimal: false,
      isScriptContext: false,
      quotes: 'single',
      wrap: false,
      es6: false,
      json: false,
      compact: true,
      lowercaseHex: false,
      numbers: 'decimal',
      indent: '\t',
      indentLevel: 0,
      __inline1__: false,
      __inline2__: false,
    };
    const json = options && options.json;
    if (json) {
      defaults.quotes = 'double';
      defaults.wrap = true;
    }
    options = extend(defaults, options);
    if (
      options.quotes != 'single' &&
      options.quotes != 'double' &&
      options.quotes != 'backtick'
    ) {
      options.quotes = 'single';
    }
    const quote =
      options.quotes == 'double'
        ? '"'
        : options.quotes == 'backtick'
          ? '`'
          : "'";
    const compact = options.compact;
    const lowercaseHex = options.lowercaseHex;
    let indent = options.indent.repeat(options.indentLevel);
    let oldIndent = '';
    const inline1 = options.__inline1__;
    const inline2 = options.__inline2__;
    const newLine = compact ? '' : '\n';
    let result;
    let isEmpty = true;
    const useBinNumbers = options.numbers == 'binary';
    const useOctNumbers = options.numbers == 'octal';
    const useDecNumbers = options.numbers == 'decimal';
    const useHexNumbers = options.numbers == 'hexadecimal';
    if (json && argument && isFunction(argument.toJSON)) {
      argument = argument.toJSON();
    }
    if (!isString(argument)) {
      if (isMap(argument)) {
        if (argument.size == 0) {
          return 'new Map()';
        }
        if (!compact) {
          options.__inline1__ = true;
          options.__inline2__ = false;
        }
        return 'new Map(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isSet(argument)) {
        if (argument.size == 0) {
          return 'new Set()';
        }
        return 'new Set(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isBuffer(argument)) {
        if (argument.length == 0) {
          return 'Buffer.from([])';
        }
        return 'Buffer.from(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isArray(argument)) {
        result = [];
        options.wrap = true;
        if (inline1) {
          options.__inline1__ = false;
          options.__inline2__ = true;
        }
        if (!inline2) {
          increaseIndentation();
        }
        forEach(argument, value => {
          isEmpty = false;
          if (inline2) {
            options.__inline2__ = false;
          }
          result.push(
            (compact || inline2 ? '' : indent) + jsesc(value, options)
          );
        });
        if (isEmpty) {
          return '[]';
        }
        if (inline2) {
          return '[' + result.join(', ') + ']';
        }
        return (
          '[' +
          newLine +
          result.join(',' + newLine) +
          newLine +
          (compact ? '' : oldIndent) +
          ']'
        );
      } else if (isNumber(argument)) {
        if (json) {
          return JSON.stringify(argument);
        }
        if (useDecNumbers) {
          return String(argument);
        }
        if (useHexNumbers) {
          let hexadecimal = argument.toString(16);
          if (!lowercaseHex) {
            hexadecimal = hexadecimal.toUpperCase();
          }
          return '0x' + hexadecimal;
        }
        if (useBinNumbers) {
          return '0b' + argument.toString(2);
        }
        if (useOctNumbers) {
          return '0o' + argument.toString(8);
        }
      } else if (!isObject(argument)) {
        if (json) {
          return JSON.stringify(argument) || 'null';
        }
        return String(argument);
      } else {
        result = [];
        options.wrap = true;
        increaseIndentation();
        forOwn(argument, (key, value) => {
          isEmpty = false;
          result.push(
            (compact ? '' : indent) +
              jsesc(key, options) +
              ':' +
              (compact ? '' : ' ') +
              jsesc(value, options)
          );
        });
        if (isEmpty) {
          return '{}';
        }
        return (
          '{' +
          newLine +
          result.join(',' + newLine) +
          newLine +
          (compact ? '' : oldIndent) +
          '}'
        );
      }
    }
    const regex = options.escapeEverything
      ? escapeEverythingRegex
      : escapeNonAsciiRegex;
    result = argument.replace(
      regex,
      (char, pair, lone, quoteChar, index, string) => {
        if (pair) {
          if (options.minimal) return pair;
          const first = pair.charCodeAt(0);
          const second = pair.charCodeAt(1);
          if (options.es6) {
            const codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
            const hex = hexadecimal(codePoint, lowercaseHex);
            return '\\u{' + hex + '}';
          }
          return (
            fourHexEscape(hexadecimal(first, lowercaseHex)) +
            fourHexEscape(hexadecimal(second, lowercaseHex))
          );
        }
        if (lone) {
          return fourHexEscape(hexadecimal(lone.charCodeAt(0), lowercaseHex));
        }
        if (
          char == '\0' &&
          !json &&
          !regexDigit.test(string.charAt(index + 1))
        ) {
          return '\\0';
        }
        if (quoteChar) {
          if (quoteChar == quote || options.escapeEverything) {
            return '\\' + quoteChar;
          }
          return quoteChar;
        }
        if (regexSingleEscape.test(char)) {
          return singleEscapes[char];
        }
        if (options.minimal && !regexWhitespace.test(char)) {
          return char;
        }
        const hex = hexadecimal(char.charCodeAt(0), lowercaseHex);
        if (json || hex.length > 2) {
          return fourHexEscape(hex);
        }
        return '\\x' + ('00' + hex).slice(-2);
      }
    );
    if (quote == '`') {
      result = result.replace(/\$\{/g, '\\${');
    }
    if (options.isScriptContext) {
      result = result
        .replace(/<\/(script|style)/gi, '<\\/$1')
        .replace(/<!--/g, json ? '\\u003C!--' : '\\x3C!--');
    }
    if (options.wrap) {
      result = quote + result + quote;
    }
    return result;
  };
  jsesc.version = '3.0.2';
  jsesc_1$2 = jsesc;
  return jsesc_1$2;
}
var hasRequiredTypes$1;
function requireTypes$1() {
  if (hasRequiredTypes$1) return types$3;
  hasRequiredTypes$1 = 1;
  Object.defineProperty(types$3, '__esModule', {value: true});
  types$3.ArgumentPlaceholder = ArgumentPlaceholder;
  types$3.ArrayPattern = types$3.ArrayExpression = ArrayExpression;
  types$3.BigIntLiteral = BigIntLiteral;
  types$3.BooleanLiteral = BooleanLiteral;
  types$3.DecimalLiteral = DecimalLiteral;
  types$3.Identifier = Identifier;
  types$3.NullLiteral = NullLiteral;
  types$3.NumericLiteral = NumericLiteral;
  types$3.ObjectPattern = types$3.ObjectExpression = ObjectExpression;
  types$3.ObjectMethod = ObjectMethod;
  types$3.ObjectProperty = ObjectProperty;
  types$3.PipelineBareFunction = PipelineBareFunction;
  types$3.PipelinePrimaryTopicReference = PipelinePrimaryTopicReference;
  types$3.PipelineTopicExpression = PipelineTopicExpression;
  types$3.RecordExpression = RecordExpression;
  types$3.RegExpLiteral = RegExpLiteral;
  types$3.SpreadElement = types$3.RestElement = RestElement;
  types$3.StringLiteral = StringLiteral;
  types$3.TopicReference = TopicReference;
  types$3.TupleExpression = TupleExpression;
  types$3._getRawIdentifier = _getRawIdentifier;
  var _t = t$d;
  var _jsesc = requireJsesc$2();
  const {isAssignmentPattern: isAssignmentPattern, isIdentifier: isIdentifier} =
    _t;
  let lastRawIdentNode = null;
  let lastRawIdentResult = '';
  function _getRawIdentifier(node) {
    if (node === lastRawIdentNode) return lastRawIdentResult;
    lastRawIdentNode = node;
    const {name: name} = node;
    const token = this.tokenMap.find(node, tok => tok.value === name);
    if (token) {
      lastRawIdentResult = this._originalCode.slice(token.start, token.end);
      return lastRawIdentResult;
    }
    return (lastRawIdentResult = node.name);
  }
  function Identifier(node) {
    var _node$loc;
    this.sourceIdentifierName(
      ((_node$loc = node.loc) == null ? void 0 : _node$loc.identifierName) ||
        node.name
    );
    this.word(this.tokenMap ? this._getRawIdentifier(node) : node.name);
  }
  function ArgumentPlaceholder() {
    this.tokenChar(63);
  }
  function RestElement(node) {
    this.token('...');
    this.print(node.argument);
  }
  function ObjectExpression(node) {
    const props = node.properties;
    this.tokenChar(123);
    if (props.length) {
      const exit = this.enterDelimited();
      this.space();
      this.printList(props, {
        indent: true,
        statement: true,
        printTrailingSeparator: this.shouldPrintTrailingComma('}'),
      });
      this.space();
      exit();
    }
    this.sourceWithOffset('end', node.loc, -1);
    this.tokenChar(125);
  }
  function ObjectMethod(node) {
    this.printJoin(node.decorators);
    this._methodHead(node);
    this.space();
    this.print(node.body);
  }
  function ObjectProperty(node) {
    this.printJoin(node.decorators);
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      if (
        isAssignmentPattern(node.value) &&
        isIdentifier(node.key) &&
        node.key.name === node.value.left.name
      ) {
        this.print(node.value);
        return;
      }
      this.print(node.key);
      if (
        node.shorthand &&
        isIdentifier(node.key) &&
        isIdentifier(node.value) &&
        node.key.name === node.value.name
      ) {
        return;
      }
    }
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ArrayExpression(node) {
    const elems = node.elements;
    const len = elems.length;
    this.tokenChar(91);
    const exit = this.enterDelimited();
    for (let i = 0; i < elems.length; i++) {
      const elem = elems[i];
      if (elem) {
        if (i > 0) this.space();
        this.print(elem);
        if (i < len - 1 || this.shouldPrintTrailingComma(']')) {
          this.token(',', false, i);
        }
      } else {
        this.token(',', false, i);
      }
    }
    exit();
    this.tokenChar(93);
  }
  function RecordExpression(node) {
    const props = node.properties;
    let startToken;
    let endToken;
    {
      if (this.format.recordAndTupleSyntaxType === 'bar') {
        startToken = '{|';
        endToken = '|}';
      } else if (
        this.format.recordAndTupleSyntaxType !== 'hash' &&
        this.format.recordAndTupleSyntaxType != null
      ) {
        throw new Error(
          `The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" (${JSON.stringify(this.format.recordAndTupleSyntaxType)} received).`
        );
      } else {
        startToken = '#{';
        endToken = '}';
      }
    }
    this.token(startToken);
    if (props.length) {
      this.space();
      this.printList(props, {
        indent: true,
        statement: true,
        printTrailingSeparator: this.shouldPrintTrailingComma(endToken),
      });
      this.space();
    }
    this.token(endToken);
  }
  function TupleExpression(node) {
    const elems = node.elements;
    const len = elems.length;
    let startToken;
    let endToken;
    {
      if (this.format.recordAndTupleSyntaxType === 'bar') {
        startToken = '[|';
        endToken = '|]';
      } else if (this.format.recordAndTupleSyntaxType === 'hash') {
        startToken = '#[';
        endToken = ']';
      } else {
        throw new Error(
          `${this.format.recordAndTupleSyntaxType} is not a valid recordAndTuple syntax type`
        );
      }
    }
    this.token(startToken);
    for (let i = 0; i < elems.length; i++) {
      const elem = elems[i];
      if (elem) {
        if (i > 0) this.space();
        this.print(elem);
        if (i < len - 1 || this.shouldPrintTrailingComma(endToken)) {
          this.token(',', false, i);
        }
      }
    }
    this.token(endToken);
  }
  function RegExpLiteral(node) {
    this.word(`/${node.pattern}/${node.flags}`);
  }
  function BooleanLiteral(node) {
    this.word(node.value ? 'true' : 'false');
  }
  function NullLiteral() {
    this.word('null');
  }
  function NumericLiteral(node) {
    const raw = this.getPossibleRaw(node);
    const opts = this.format.jsescOption;
    const value = node.value;
    const str = value + '';
    if (opts.numbers) {
      this.number(_jsesc(value, opts), value);
    } else if (raw == null) {
      this.number(str, value);
    } else if (this.format.minified) {
      this.number(raw.length < str.length ? raw : str, value);
    } else {
      this.number(raw, value);
    }
  }
  function StringLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.token(raw);
      return;
    }
    const val = _jsesc(node.value, this.format.jsescOption);
    this.token(val);
  }
  function BigIntLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.word(raw);
      return;
    }
    this.word(node.value + 'n');
  }
  function DecimalLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.word(raw);
      return;
    }
    this.word(node.value + 'm');
  }
  const validTopicTokenSet = new Set(['^^', '@@', '^', '%', '#']);
  function TopicReference() {
    const {topicToken: topicToken} = this.format;
    if (validTopicTokenSet.has(topicToken)) {
      this.token(topicToken);
    } else {
      const givenTopicTokenJSON = JSON.stringify(topicToken);
      const validTopics = Array.from(validTopicTokenSet, v =>
        JSON.stringify(v)
      );
      throw new Error(
        `The "topicToken" generator option must be one of ` +
          `${validTopics.join(', ')} (${givenTopicTokenJSON} received instead).`
      );
    }
  }
  function PipelineTopicExpression(node) {
    this.print(node.expression);
  }
  function PipelineBareFunction(node) {
    this.print(node.callee);
  }
  function PipelinePrimaryTopicReference() {
    this.tokenChar(35);
  }
  return types$3;
}
var flow$3 = {};
var hasRequiredFlow$1;
function requireFlow$1() {
  if (hasRequiredFlow$1) return flow$3;
  hasRequiredFlow$1 = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.AnyTypeAnnotation = AnyTypeAnnotation;
    exports.ArrayTypeAnnotation = ArrayTypeAnnotation;
    exports.BooleanLiteralTypeAnnotation = BooleanLiteralTypeAnnotation;
    exports.BooleanTypeAnnotation = BooleanTypeAnnotation;
    exports.DeclareClass = DeclareClass;
    exports.DeclareExportAllDeclaration = DeclareExportAllDeclaration;
    exports.DeclareExportDeclaration = DeclareExportDeclaration;
    exports.DeclareFunction = DeclareFunction;
    exports.DeclareInterface = DeclareInterface;
    exports.DeclareModule = DeclareModule;
    exports.DeclareModuleExports = DeclareModuleExports;
    exports.DeclareOpaqueType = DeclareOpaqueType;
    exports.DeclareTypeAlias = DeclareTypeAlias;
    exports.DeclareVariable = DeclareVariable;
    exports.DeclaredPredicate = DeclaredPredicate;
    exports.EmptyTypeAnnotation = EmptyTypeAnnotation;
    exports.EnumBooleanBody = EnumBooleanBody;
    exports.EnumBooleanMember = EnumBooleanMember;
    exports.EnumDeclaration = EnumDeclaration;
    exports.EnumDefaultedMember = EnumDefaultedMember;
    exports.EnumNumberBody = EnumNumberBody;
    exports.EnumNumberMember = EnumNumberMember;
    exports.EnumStringBody = EnumStringBody;
    exports.EnumStringMember = EnumStringMember;
    exports.EnumSymbolBody = EnumSymbolBody;
    exports.ExistsTypeAnnotation = ExistsTypeAnnotation;
    exports.FunctionTypeAnnotation = FunctionTypeAnnotation;
    exports.FunctionTypeParam = FunctionTypeParam;
    exports.IndexedAccessType = IndexedAccessType;
    exports.InferredPredicate = InferredPredicate;
    exports.InterfaceDeclaration = InterfaceDeclaration;
    exports.GenericTypeAnnotation =
      exports.ClassImplements =
      exports.InterfaceExtends =
        InterfaceExtends;
    exports.InterfaceTypeAnnotation = InterfaceTypeAnnotation;
    exports.IntersectionTypeAnnotation = IntersectionTypeAnnotation;
    exports.MixedTypeAnnotation = MixedTypeAnnotation;
    exports.NullLiteralTypeAnnotation = NullLiteralTypeAnnotation;
    exports.NullableTypeAnnotation = NullableTypeAnnotation;
    Object.defineProperty(exports, 'NumberLiteralTypeAnnotation', {
      enumerable: true,
      get: function () {
        return _types2.NumericLiteral;
      },
    });
    exports.NumberTypeAnnotation = NumberTypeAnnotation;
    exports.ObjectTypeAnnotation = ObjectTypeAnnotation;
    exports.ObjectTypeCallProperty = ObjectTypeCallProperty;
    exports.ObjectTypeIndexer = ObjectTypeIndexer;
    exports.ObjectTypeInternalSlot = ObjectTypeInternalSlot;
    exports.ObjectTypeProperty = ObjectTypeProperty;
    exports.ObjectTypeSpreadProperty = ObjectTypeSpreadProperty;
    exports.OpaqueType = OpaqueType;
    exports.OptionalIndexedAccessType = OptionalIndexedAccessType;
    exports.QualifiedTypeIdentifier = QualifiedTypeIdentifier;
    Object.defineProperty(exports, 'StringLiteralTypeAnnotation', {
      enumerable: true,
      get: function () {
        return _types2.StringLiteral;
      },
    });
    exports.StringTypeAnnotation = StringTypeAnnotation;
    exports.SymbolTypeAnnotation = SymbolTypeAnnotation;
    exports.ThisTypeAnnotation = ThisTypeAnnotation;
    exports.TupleTypeAnnotation = TupleTypeAnnotation;
    exports.TypeAlias = TypeAlias;
    exports.TypeAnnotation = TypeAnnotation;
    exports.TypeCastExpression = TypeCastExpression;
    exports.TypeParameter = TypeParameter;
    exports.TypeParameterDeclaration = exports.TypeParameterInstantiation =
      TypeParameterInstantiation;
    exports.TypeofTypeAnnotation = TypeofTypeAnnotation;
    exports.UnionTypeAnnotation = UnionTypeAnnotation;
    exports.Variance = Variance;
    exports.VoidTypeAnnotation = VoidTypeAnnotation;
    exports._interfaceish = _interfaceish;
    exports._variance = _variance;
    var _t = t$d;
    var _modules = requireModules$1();
    var _index = requireNode$1();
    var _types2 = requireTypes$1();
    const {
      isDeclareExportDeclaration: isDeclareExportDeclaration,
      isStatement: isStatement,
    } = _t;
    function AnyTypeAnnotation() {
      this.word('any');
    }
    function ArrayTypeAnnotation(node) {
      this.print(node.elementType, true);
      this.tokenChar(91);
      this.tokenChar(93);
    }
    function BooleanTypeAnnotation() {
      this.word('boolean');
    }
    function BooleanLiteralTypeAnnotation(node) {
      this.word(node.value ? 'true' : 'false');
    }
    function NullLiteralTypeAnnotation() {
      this.word('null');
    }
    function DeclareClass(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.word('class');
      this.space();
      this._interfaceish(node);
    }
    function DeclareFunction(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.word('function');
      this.space();
      this.print(node.id);
      this.print(node.id.typeAnnotation.typeAnnotation);
      if (node.predicate) {
        this.space();
        this.print(node.predicate);
      }
      this.semicolon();
    }
    function InferredPredicate() {
      this.tokenChar(37);
      this.word('checks');
    }
    function DeclaredPredicate(node) {
      this.tokenChar(37);
      this.word('checks');
      this.tokenChar(40);
      this.print(node.value);
      this.tokenChar(41);
    }
    function DeclareInterface(node) {
      this.word('declare');
      this.space();
      this.InterfaceDeclaration(node);
    }
    function DeclareModule(node) {
      this.word('declare');
      this.space();
      this.word('module');
      this.space();
      this.print(node.id);
      this.space();
      this.print(node.body);
    }
    function DeclareModuleExports(node) {
      this.word('declare');
      this.space();
      this.word('module');
      this.tokenChar(46);
      this.word('exports');
      this.print(node.typeAnnotation);
    }
    function DeclareTypeAlias(node) {
      this.word('declare');
      this.space();
      this.TypeAlias(node);
    }
    function DeclareOpaqueType(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.OpaqueType(node);
    }
    function DeclareVariable(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.word('var');
      this.space();
      this.print(node.id);
      this.print(node.id.typeAnnotation);
      this.semicolon();
    }
    function DeclareExportDeclaration(node) {
      this.word('declare');
      this.space();
      this.word('export');
      this.space();
      if (node.default) {
        this.word('default');
        this.space();
      }
      FlowExportDeclaration.call(this, node);
    }
    function DeclareExportAllDeclaration(node) {
      this.word('declare');
      this.space();
      _modules.ExportAllDeclaration.call(this, node);
    }
    function EnumDeclaration(node) {
      const {id: id, body: body} = node;
      this.word('enum');
      this.space();
      this.print(id);
      this.print(body);
    }
    function enumExplicitType(context, name, hasExplicitType) {
      if (hasExplicitType) {
        context.space();
        context.word('of');
        context.space();
        context.word(name);
      }
      context.space();
    }
    function enumBody(context, node) {
      const {members: members} = node;
      context.token('{');
      context.indent();
      context.newline();
      for (const member of members) {
        context.print(member);
        context.newline();
      }
      if (node.hasUnknownMembers) {
        context.token('...');
        context.newline();
      }
      context.dedent();
      context.token('}');
    }
    function EnumBooleanBody(node) {
      const {explicitType: explicitType} = node;
      enumExplicitType(this, 'boolean', explicitType);
      enumBody(this, node);
    }
    function EnumNumberBody(node) {
      const {explicitType: explicitType} = node;
      enumExplicitType(this, 'number', explicitType);
      enumBody(this, node);
    }
    function EnumStringBody(node) {
      const {explicitType: explicitType} = node;
      enumExplicitType(this, 'string', explicitType);
      enumBody(this, node);
    }
    function EnumSymbolBody(node) {
      enumExplicitType(this, 'symbol', true);
      enumBody(this, node);
    }
    function EnumDefaultedMember(node) {
      const {id: id} = node;
      this.print(id);
      this.tokenChar(44);
    }
    function enumInitializedMember(context, node) {
      context.print(node.id);
      context.space();
      context.token('=');
      context.space();
      context.print(node.init);
      context.token(',');
    }
    function EnumBooleanMember(node) {
      enumInitializedMember(this, node);
    }
    function EnumNumberMember(node) {
      enumInitializedMember(this, node);
    }
    function EnumStringMember(node) {
      enumInitializedMember(this, node);
    }
    function FlowExportDeclaration(node) {
      if (node.declaration) {
        const declar = node.declaration;
        this.print(declar);
        if (!isStatement(declar)) this.semicolon();
      } else {
        this.tokenChar(123);
        if (node.specifiers.length) {
          this.space();
          this.printList(node.specifiers);
          this.space();
        }
        this.tokenChar(125);
        if (node.source) {
          this.space();
          this.word('from');
          this.space();
          this.print(node.source);
        }
        this.semicolon();
      }
    }
    function ExistsTypeAnnotation() {
      this.tokenChar(42);
    }
    function FunctionTypeAnnotation(node, parent) {
      this.print(node.typeParameters);
      this.tokenChar(40);
      if (node.this) {
        this.word('this');
        this.tokenChar(58);
        this.space();
        this.print(node.this.typeAnnotation);
        if (node.params.length || node.rest) {
          this.tokenChar(44);
          this.space();
        }
      }
      this.printList(node.params);
      if (node.rest) {
        if (node.params.length) {
          this.tokenChar(44);
          this.space();
        }
        this.token('...');
        this.print(node.rest);
      }
      this.tokenChar(41);
      const type = parent == null ? void 0 : parent.type;
      if (
        type != null &&
        (type === 'ObjectTypeCallProperty' ||
          type === 'ObjectTypeInternalSlot' ||
          type === 'DeclareFunction' ||
          (type === 'ObjectTypeProperty' && parent.method))
      ) {
        this.tokenChar(58);
      } else {
        this.space();
        this.token('=>');
      }
      this.space();
      this.print(node.returnType);
    }
    function FunctionTypeParam(node) {
      this.print(node.name);
      if (node.optional) this.tokenChar(63);
      if (node.name) {
        this.tokenChar(58);
        this.space();
      }
      this.print(node.typeAnnotation);
    }
    function InterfaceExtends(node) {
      this.print(node.id);
      this.print(node.typeParameters, true);
    }
    function _interfaceish(node) {
      var _node$extends;
      this.print(node.id);
      this.print(node.typeParameters);
      if ((_node$extends = node.extends) != null && _node$extends.length) {
        this.space();
        this.word('extends');
        this.space();
        this.printList(node.extends);
      }
      if (node.type === 'DeclareClass') {
        var _node$mixins, _node$implements;
        if ((_node$mixins = node.mixins) != null && _node$mixins.length) {
          this.space();
          this.word('mixins');
          this.space();
          this.printList(node.mixins);
        }
        if (
          (_node$implements = node.implements) != null &&
          _node$implements.length
        ) {
          this.space();
          this.word('implements');
          this.space();
          this.printList(node.implements);
        }
      }
      this.space();
      this.print(node.body);
    }
    function _variance(node) {
      var _node$variance;
      const kind =
        (_node$variance = node.variance) == null ? void 0 : _node$variance.kind;
      if (kind != null) {
        if (kind === 'plus') {
          this.tokenChar(43);
        } else if (kind === 'minus') {
          this.tokenChar(45);
        }
      }
    }
    function InterfaceDeclaration(node) {
      this.word('interface');
      this.space();
      this._interfaceish(node);
    }
    function andSeparator(occurrenceCount) {
      this.space();
      this.token('&', false, occurrenceCount);
      this.space();
    }
    function InterfaceTypeAnnotation(node) {
      var _node$extends2;
      this.word('interface');
      if ((_node$extends2 = node.extends) != null && _node$extends2.length) {
        this.space();
        this.word('extends');
        this.space();
        this.printList(node.extends);
      }
      this.space();
      this.print(node.body);
    }
    function IntersectionTypeAnnotation(node) {
      this.printJoin(node.types, {separator: andSeparator});
    }
    function MixedTypeAnnotation() {
      this.word('mixed');
    }
    function EmptyTypeAnnotation() {
      this.word('empty');
    }
    function NullableTypeAnnotation(node) {
      this.tokenChar(63);
      this.print(node.typeAnnotation);
    }
    function NumberTypeAnnotation() {
      this.word('number');
    }
    function StringTypeAnnotation() {
      this.word('string');
    }
    function ThisTypeAnnotation() {
      this.word('this');
    }
    function TupleTypeAnnotation(node) {
      this.tokenChar(91);
      this.printList(node.types);
      this.tokenChar(93);
    }
    function TypeofTypeAnnotation(node) {
      this.word('typeof');
      this.space();
      this.print(node.argument);
    }
    function TypeAlias(node) {
      this.word('type');
      this.space();
      this.print(node.id);
      this.print(node.typeParameters);
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.right);
      this.semicolon();
    }
    function TypeAnnotation(node, parent) {
      this.tokenChar(58);
      this.space();
      if (parent.type === 'ArrowFunctionExpression') {
        this.tokenContext |= _index.TokenContext.arrowFlowReturnType;
      } else if (node.optional) {
        this.tokenChar(63);
      }
      this.print(node.typeAnnotation);
    }
    function TypeParameterInstantiation(node) {
      this.tokenChar(60);
      this.printList(node.params, {});
      this.tokenChar(62);
    }
    function TypeParameter(node) {
      this._variance(node);
      this.word(node.name);
      if (node.bound) {
        this.print(node.bound);
      }
      if (node.default) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.default);
      }
    }
    function OpaqueType(node) {
      this.word('opaque');
      this.space();
      this.word('type');
      this.space();
      this.print(node.id);
      this.print(node.typeParameters);
      if (node.supertype) {
        this.tokenChar(58);
        this.space();
        this.print(node.supertype);
      }
      if (node.impltype) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.impltype);
      }
      this.semicolon();
    }
    function ObjectTypeAnnotation(node) {
      if (node.exact) {
        this.token('{|');
      } else {
        this.tokenChar(123);
      }
      const props = [
        ...node.properties,
        ...(node.callProperties || []),
        ...(node.indexers || []),
        ...(node.internalSlots || []),
      ];
      if (props.length) {
        this.newline();
        this.space();
        this.printJoin(props, {
          addNewlines(leading) {
            if (leading && !props[0]) return 1;
          },
          indent: true,
          statement: true,
          iterator: () => {
            if (props.length !== 1 || node.inexact) {
              this.tokenChar(44);
              this.space();
            }
          },
        });
        this.space();
      }
      if (node.inexact) {
        this.indent();
        this.token('...');
        if (props.length) {
          this.newline();
        }
        this.dedent();
      }
      if (node.exact) {
        this.token('|}');
      } else {
        this.tokenChar(125);
      }
    }
    function ObjectTypeInternalSlot(node) {
      if (node.static) {
        this.word('static');
        this.space();
      }
      this.tokenChar(91);
      this.tokenChar(91);
      this.print(node.id);
      this.tokenChar(93);
      this.tokenChar(93);
      if (node.optional) this.tokenChar(63);
      if (!node.method) {
        this.tokenChar(58);
        this.space();
      }
      this.print(node.value);
    }
    function ObjectTypeCallProperty(node) {
      if (node.static) {
        this.word('static');
        this.space();
      }
      this.print(node.value);
    }
    function ObjectTypeIndexer(node) {
      if (node.static) {
        this.word('static');
        this.space();
      }
      this._variance(node);
      this.tokenChar(91);
      if (node.id) {
        this.print(node.id);
        this.tokenChar(58);
        this.space();
      }
      this.print(node.key);
      this.tokenChar(93);
      this.tokenChar(58);
      this.space();
      this.print(node.value);
    }
    function ObjectTypeProperty(node) {
      if (node.proto) {
        this.word('proto');
        this.space();
      }
      if (node.static) {
        this.word('static');
        this.space();
      }
      if (node.kind === 'get' || node.kind === 'set') {
        this.word(node.kind);
        this.space();
      }
      this._variance(node);
      this.print(node.key);
      if (node.optional) this.tokenChar(63);
      if (!node.method) {
        this.tokenChar(58);
        this.space();
      }
      this.print(node.value);
    }
    function ObjectTypeSpreadProperty(node) {
      this.token('...');
      this.print(node.argument);
    }
    function QualifiedTypeIdentifier(node) {
      this.print(node.qualification);
      this.tokenChar(46);
      this.print(node.id);
    }
    function SymbolTypeAnnotation() {
      this.word('symbol');
    }
    function orSeparator(occurrenceCount) {
      this.space();
      this.token('|', false, occurrenceCount);
      this.space();
    }
    function UnionTypeAnnotation(node) {
      this.printJoin(node.types, {separator: orSeparator});
    }
    function TypeCastExpression(node) {
      this.tokenChar(40);
      this.print(node.expression);
      this.print(node.typeAnnotation);
      this.tokenChar(41);
    }
    function Variance(node) {
      if (node.kind === 'plus') {
        this.tokenChar(43);
      } else {
        this.tokenChar(45);
      }
    }
    function VoidTypeAnnotation() {
      this.word('void');
    }
    function IndexedAccessType(node) {
      this.print(node.objectType, true);
      this.tokenChar(91);
      this.print(node.indexType);
      this.tokenChar(93);
    }
    function OptionalIndexedAccessType(node) {
      this.print(node.objectType);
      if (node.optional) {
        this.token('?.');
      }
      this.tokenChar(91);
      this.print(node.indexType);
      this.tokenChar(93);
    }
  })(flow$3);
  return flow$3;
}
var base$2 = {};
var hasRequiredBase$1;
function requireBase$1() {
  if (hasRequiredBase$1) return base$2;
  hasRequiredBase$1 = 1;
  Object.defineProperty(base$2, '__esModule', {value: true});
  base$2.BlockStatement = BlockStatement;
  base$2.Directive = Directive;
  base$2.DirectiveLiteral = DirectiveLiteral;
  base$2.File = File;
  base$2.InterpreterDirective = InterpreterDirective;
  base$2.Placeholder = Placeholder;
  base$2.Program = Program;
  function File(node) {
    if (node.program) {
      this.print(node.program.interpreter);
    }
    this.print(node.program);
  }
  function Program(node) {
    var _node$directives;
    this.noIndentInnerCommentsHere();
    this.printInnerComments();
    const directivesLen =
      (_node$directives = node.directives) == null
        ? void 0
        : _node$directives.length;
    if (directivesLen) {
      var _node$directives$trai;
      const newline = node.body.length ? 2 : 1;
      this.printSequence(node.directives, {
        trailingCommentsLineOffset: newline,
      });
      if (
        !(
          (_node$directives$trai =
            node.directives[directivesLen - 1].trailingComments) != null &&
          _node$directives$trai.length
        )
      ) {
        this.newline(newline);
      }
    }
    this.printSequence(node.body);
  }
  function BlockStatement(node) {
    var _node$directives2;
    this.tokenChar(123);
    const exit = this.enterDelimited();
    const directivesLen =
      (_node$directives2 = node.directives) == null
        ? void 0
        : _node$directives2.length;
    if (directivesLen) {
      var _node$directives$trai2;
      const newline = node.body.length ? 2 : 1;
      this.printSequence(node.directives, {
        indent: true,
        trailingCommentsLineOffset: newline,
      });
      if (
        !(
          (_node$directives$trai2 =
            node.directives[directivesLen - 1].trailingComments) != null &&
          _node$directives$trai2.length
        )
      ) {
        this.newline(newline);
      }
    }
    this.printSequence(node.body, {indent: true});
    exit();
    this.rightBrace(node);
  }
  function Directive(node) {
    this.print(node.value);
    this.semicolon();
  }
  const unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
  const unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
  function DirectiveLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.token(raw);
      return;
    }
    const {value: value} = node;
    if (!unescapedDoubleQuoteRE.test(value)) {
      this.token(`"${value}"`);
    } else if (!unescapedSingleQuoteRE.test(value)) {
      this.token(`'${value}'`);
    } else {
      throw new Error(
        'Malformed AST: it is not possible to print a directive containing' +
          ' both unescaped single and double quotes.'
      );
    }
  }
  function InterpreterDirective(node) {
    this.token(`#!${node.value}`);
    this.newline(1, true);
  }
  function Placeholder(node) {
    this.token('%%');
    this.print(node.name);
    this.token('%%');
    if (node.expectedNode === 'Statement') {
      this.semicolon();
    }
  }
  return base$2;
}
var jsx$3 = {};
var hasRequiredJsx$1;
function requireJsx$1() {
  if (hasRequiredJsx$1) return jsx$3;
  hasRequiredJsx$1 = 1;
  Object.defineProperty(jsx$3, '__esModule', {value: true});
  jsx$3.JSXAttribute = JSXAttribute;
  jsx$3.JSXClosingElement = JSXClosingElement;
  jsx$3.JSXClosingFragment = JSXClosingFragment;
  jsx$3.JSXElement = JSXElement;
  jsx$3.JSXEmptyExpression = JSXEmptyExpression;
  jsx$3.JSXExpressionContainer = JSXExpressionContainer;
  jsx$3.JSXFragment = JSXFragment;
  jsx$3.JSXIdentifier = JSXIdentifier;
  jsx$3.JSXMemberExpression = JSXMemberExpression;
  jsx$3.JSXNamespacedName = JSXNamespacedName;
  jsx$3.JSXOpeningElement = JSXOpeningElement;
  jsx$3.JSXOpeningFragment = JSXOpeningFragment;
  jsx$3.JSXSpreadAttribute = JSXSpreadAttribute;
  jsx$3.JSXSpreadChild = JSXSpreadChild;
  jsx$3.JSXText = JSXText;
  function JSXAttribute(node) {
    this.print(node.name);
    if (node.value) {
      this.tokenChar(61);
      this.print(node.value);
    }
  }
  function JSXIdentifier(node) {
    this.word(node.name);
  }
  function JSXNamespacedName(node) {
    this.print(node.namespace);
    this.tokenChar(58);
    this.print(node.name);
  }
  function JSXMemberExpression(node) {
    this.print(node.object);
    this.tokenChar(46);
    this.print(node.property);
  }
  function JSXSpreadAttribute(node) {
    this.tokenChar(123);
    this.token('...');
    this.print(node.argument);
    this.rightBrace(node);
  }
  function JSXExpressionContainer(node) {
    this.tokenChar(123);
    this.print(node.expression);
    this.rightBrace(node);
  }
  function JSXSpreadChild(node) {
    this.tokenChar(123);
    this.token('...');
    this.print(node.expression);
    this.rightBrace(node);
  }
  function JSXText(node) {
    const raw = this.getPossibleRaw(node);
    if (raw !== undefined) {
      this.token(raw, true);
    } else {
      this.token(node.value, true);
    }
  }
  function JSXElement(node) {
    const open = node.openingElement;
    this.print(open);
    if (open.selfClosing) return;
    this.indent();
    for (const child of node.children) {
      this.print(child);
    }
    this.dedent();
    this.print(node.closingElement);
  }
  function spaceSeparator() {
    this.space();
  }
  function JSXOpeningElement(node) {
    this.tokenChar(60);
    this.print(node.name);
    this.print(node.typeParameters);
    if (node.attributes.length > 0) {
      this.space();
      this.printJoin(node.attributes, {separator: spaceSeparator});
    }
    if (node.selfClosing) {
      this.space();
      this.tokenChar(47);
    }
    this.tokenChar(62);
  }
  function JSXClosingElement(node) {
    this.tokenChar(60);
    this.tokenChar(47);
    this.print(node.name);
    this.tokenChar(62);
  }
  function JSXEmptyExpression() {
    this.printInnerComments();
  }
  function JSXFragment(node) {
    this.print(node.openingFragment);
    this.indent();
    for (const child of node.children) {
      this.print(child);
    }
    this.dedent();
    this.print(node.closingFragment);
  }
  function JSXOpeningFragment() {
    this.tokenChar(60);
    this.tokenChar(62);
  }
  function JSXClosingFragment() {
    this.token('</');
    this.tokenChar(62);
  }
  return jsx$3;
}
var typescript$3 = {};
var hasRequiredTypescript$1;
function requireTypescript$1() {
  if (hasRequiredTypescript$1) return typescript$3;
  hasRequiredTypescript$1 = 1;
  Object.defineProperty(typescript$3, '__esModule', {value: true});
  typescript$3.TSAnyKeyword = TSAnyKeyword;
  typescript$3.TSArrayType = TSArrayType;
  typescript$3.TSSatisfiesExpression = typescript$3.TSAsExpression =
    TSTypeExpression;
  typescript$3.TSBigIntKeyword = TSBigIntKeyword;
  typescript$3.TSBooleanKeyword = TSBooleanKeyword;
  typescript$3.TSCallSignatureDeclaration = TSCallSignatureDeclaration;
  typescript$3.TSInterfaceHeritage =
    typescript$3.TSExpressionWithTypeArguments =
    typescript$3.TSClassImplements =
      TSClassImplements;
  typescript$3.TSConditionalType = TSConditionalType;
  typescript$3.TSConstructSignatureDeclaration =
    TSConstructSignatureDeclaration;
  typescript$3.TSConstructorType = TSConstructorType;
  typescript$3.TSDeclareFunction = TSDeclareFunction;
  typescript$3.TSDeclareMethod = TSDeclareMethod;
  typescript$3.TSEnumDeclaration = TSEnumDeclaration;
  typescript$3.TSEnumMember = TSEnumMember;
  typescript$3.TSExportAssignment = TSExportAssignment;
  typescript$3.TSExternalModuleReference = TSExternalModuleReference;
  typescript$3.TSFunctionType = TSFunctionType;
  typescript$3.TSImportEqualsDeclaration = TSImportEqualsDeclaration;
  typescript$3.TSImportType = TSImportType;
  typescript$3.TSIndexSignature = TSIndexSignature;
  typescript$3.TSIndexedAccessType = TSIndexedAccessType;
  typescript$3.TSInferType = TSInferType;
  typescript$3.TSInstantiationExpression = TSInstantiationExpression;
  typescript$3.TSInterfaceBody = TSInterfaceBody;
  typescript$3.TSInterfaceDeclaration = TSInterfaceDeclaration;
  typescript$3.TSIntersectionType = TSIntersectionType;
  typescript$3.TSIntrinsicKeyword = TSIntrinsicKeyword;
  typescript$3.TSLiteralType = TSLiteralType;
  typescript$3.TSMappedType = TSMappedType;
  typescript$3.TSMethodSignature = TSMethodSignature;
  typescript$3.TSModuleBlock = TSModuleBlock;
  typescript$3.TSModuleDeclaration = TSModuleDeclaration;
  typescript$3.TSNamedTupleMember = TSNamedTupleMember;
  typescript$3.TSNamespaceExportDeclaration = TSNamespaceExportDeclaration;
  typescript$3.TSNeverKeyword = TSNeverKeyword;
  typescript$3.TSNonNullExpression = TSNonNullExpression;
  typescript$3.TSNullKeyword = TSNullKeyword;
  typescript$3.TSNumberKeyword = TSNumberKeyword;
  typescript$3.TSObjectKeyword = TSObjectKeyword;
  typescript$3.TSOptionalType = TSOptionalType;
  typescript$3.TSParameterProperty = TSParameterProperty;
  typescript$3.TSParenthesizedType = TSParenthesizedType;
  typescript$3.TSPropertySignature = TSPropertySignature;
  typescript$3.TSQualifiedName = TSQualifiedName;
  typescript$3.TSRestType = TSRestType;
  typescript$3.TSStringKeyword = TSStringKeyword;
  typescript$3.TSSymbolKeyword = TSSymbolKeyword;
  typescript$3.TSThisType = TSThisType;
  typescript$3.TSTupleType = TSTupleType;
  typescript$3.TSTypeAliasDeclaration = TSTypeAliasDeclaration;
  typescript$3.TSTypeAnnotation = TSTypeAnnotation;
  typescript$3.TSTypeAssertion = TSTypeAssertion;
  typescript$3.TSTypeLiteral = TSTypeLiteral;
  typescript$3.TSTypeOperator = TSTypeOperator;
  typescript$3.TSTypeParameter = TSTypeParameter;
  typescript$3.TSTypeParameterDeclaration =
    typescript$3.TSTypeParameterInstantiation = TSTypeParameterInstantiation;
  typescript$3.TSTypePredicate = TSTypePredicate;
  typescript$3.TSTypeQuery = TSTypeQuery;
  typescript$3.TSTypeReference = TSTypeReference;
  typescript$3.TSUndefinedKeyword = TSUndefinedKeyword;
  typescript$3.TSUnionType = TSUnionType;
  typescript$3.TSUnknownKeyword = TSUnknownKeyword;
  typescript$3.TSVoidKeyword = TSVoidKeyword;
  typescript$3.tsPrintClassMemberModifiers = tsPrintClassMemberModifiers;
  typescript$3.tsPrintFunctionOrConstructorType =
    tsPrintFunctionOrConstructorType;
  typescript$3.tsPrintPropertyOrMethodName = tsPrintPropertyOrMethodName;
  typescript$3.tsPrintSignatureDeclarationBase =
    tsPrintSignatureDeclarationBase;
  function TSTypeAnnotation(node, parent) {
    this.token(
      (parent.type === 'TSFunctionType' ||
        parent.type === 'TSConstructorType') &&
        parent.typeAnnotation === node
        ? '=>'
        : ':'
    );
    this.space();
    if (node.optional) this.tokenChar(63);
    this.print(node.typeAnnotation);
  }
  function TSTypeParameterInstantiation(node, parent) {
    this.tokenChar(60);
    let printTrailingSeparator =
      parent.type === 'ArrowFunctionExpression' && node.params.length === 1;
    if (this.tokenMap && node.start != null && node.end != null) {
      printTrailingSeparator &&
        (printTrailingSeparator = !!this.tokenMap.find(node, t =>
          this.tokenMap.matchesOriginal(t, ',')
        ));
      printTrailingSeparator ||
        (printTrailingSeparator = this.shouldPrintTrailingComma('>'));
    }
    this.printList(node.params, {
      printTrailingSeparator: printTrailingSeparator,
    });
    this.tokenChar(62);
  }
  function TSTypeParameter(node) {
    if (node.in) {
      this.word('in');
      this.space();
    }
    if (node.out) {
      this.word('out');
      this.space();
    }
    this.word(node.name);
    if (node.constraint) {
      this.space();
      this.word('extends');
      this.space();
      this.print(node.constraint);
    }
    if (node.default) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.default);
    }
  }
  function TSParameterProperty(node) {
    if (node.accessibility) {
      this.word(node.accessibility);
      this.space();
    }
    if (node.readonly) {
      this.word('readonly');
      this.space();
    }
    this._param(node.parameter);
  }
  function TSDeclareFunction(node, parent) {
    if (node.declare) {
      this.word('declare');
      this.space();
    }
    this._functionHead(node, parent);
    this.semicolon();
  }
  function TSDeclareMethod(node) {
    this._classMethodHead(node);
    this.semicolon();
  }
  function TSQualifiedName(node) {
    this.print(node.left);
    this.tokenChar(46);
    this.print(node.right);
  }
  function TSCallSignatureDeclaration(node) {
    this.tsPrintSignatureDeclarationBase(node);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function maybePrintTrailingCommaOrSemicolon(printer, node) {
    if (!printer.tokenMap || !node.start || !node.end) {
      printer.semicolon();
      return;
    }
    if (printer.tokenMap.endMatches(node, ',')) {
      printer.token(',');
    } else if (printer.tokenMap.endMatches(node, ';')) {
      printer.semicolon();
    }
  }
  function TSConstructSignatureDeclaration(node) {
    this.word('new');
    this.space();
    this.tsPrintSignatureDeclarationBase(node);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function TSPropertySignature(node) {
    const {readonly: readonly} = node;
    if (readonly) {
      this.word('readonly');
      this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.print(node.typeAnnotation);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function tsPrintPropertyOrMethodName(node) {
    if (node.computed) {
      this.tokenChar(91);
    }
    this.print(node.key);
    if (node.computed) {
      this.tokenChar(93);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
  }
  function TSMethodSignature(node) {
    const {kind: kind} = node;
    if (kind === 'set' || kind === 'get') {
      this.word(kind);
      this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.tsPrintSignatureDeclarationBase(node);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function TSIndexSignature(node) {
    const {readonly: readonly, static: isStatic} = node;
    if (isStatic) {
      this.word('static');
      this.space();
    }
    if (readonly) {
      this.word('readonly');
      this.space();
    }
    this.tokenChar(91);
    this._parameters(node.parameters, ']');
    this.print(node.typeAnnotation);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function TSAnyKeyword() {
    this.word('any');
  }
  function TSBigIntKeyword() {
    this.word('bigint');
  }
  function TSUnknownKeyword() {
    this.word('unknown');
  }
  function TSNumberKeyword() {
    this.word('number');
  }
  function TSObjectKeyword() {
    this.word('object');
  }
  function TSBooleanKeyword() {
    this.word('boolean');
  }
  function TSStringKeyword() {
    this.word('string');
  }
  function TSSymbolKeyword() {
    this.word('symbol');
  }
  function TSVoidKeyword() {
    this.word('void');
  }
  function TSUndefinedKeyword() {
    this.word('undefined');
  }
  function TSNullKeyword() {
    this.word('null');
  }
  function TSNeverKeyword() {
    this.word('never');
  }
  function TSIntrinsicKeyword() {
    this.word('intrinsic');
  }
  function TSThisType() {
    this.word('this');
  }
  function TSFunctionType(node) {
    this.tsPrintFunctionOrConstructorType(node);
  }
  function TSConstructorType(node) {
    if (node.abstract) {
      this.word('abstract');
      this.space();
    }
    this.word('new');
    this.space();
    this.tsPrintFunctionOrConstructorType(node);
  }
  function tsPrintFunctionOrConstructorType(node) {
    const {typeParameters: typeParameters} = node;
    const parameters = node.parameters;
    this.print(typeParameters);
    this.tokenChar(40);
    this._parameters(parameters, ')');
    this.space();
    const returnType = node.typeAnnotation;
    this.print(returnType);
  }
  function TSTypeReference(node) {
    this.print(node.typeName, !!node.typeParameters);
    this.print(node.typeParameters);
  }
  function TSTypePredicate(node) {
    if (node.asserts) {
      this.word('asserts');
      this.space();
    }
    this.print(node.parameterName);
    if (node.typeAnnotation) {
      this.space();
      this.word('is');
      this.space();
      this.print(node.typeAnnotation.typeAnnotation);
    }
  }
  function TSTypeQuery(node) {
    this.word('typeof');
    this.space();
    this.print(node.exprName);
    if (node.typeParameters) {
      this.print(node.typeParameters);
    }
  }
  function TSTypeLiteral(node) {
    printBraced(this, node, () =>
      this.printJoin(node.members, {indent: true, statement: true})
    );
  }
  function TSArrayType(node) {
    this.print(node.elementType, true);
    this.tokenChar(91);
    this.tokenChar(93);
  }
  function TSTupleType(node) {
    this.tokenChar(91);
    this.printList(node.elementTypes, {
      printTrailingSeparator: this.shouldPrintTrailingComma(']'),
    });
    this.tokenChar(93);
  }
  function TSOptionalType(node) {
    this.print(node.typeAnnotation);
    this.tokenChar(63);
  }
  function TSRestType(node) {
    this.token('...');
    this.print(node.typeAnnotation);
  }
  function TSNamedTupleMember(node) {
    this.print(node.label);
    if (node.optional) this.tokenChar(63);
    this.tokenChar(58);
    this.space();
    this.print(node.elementType);
  }
  function TSUnionType(node) {
    tsPrintUnionOrIntersectionType(this, node, '|');
  }
  function TSIntersectionType(node) {
    tsPrintUnionOrIntersectionType(this, node, '&');
  }
  function tsPrintUnionOrIntersectionType(printer, node, sep) {
    var _printer$tokenMap;
    let hasLeadingToken = 0;
    if (
      (_printer$tokenMap = printer.tokenMap) != null &&
      _printer$tokenMap.startMatches(node, sep)
    ) {
      hasLeadingToken = 1;
      printer.token(sep);
    }
    printer.printJoin(node.types, {
      separator(i) {
        this.space();
        this.token(sep, null, i + hasLeadingToken);
        this.space();
      },
    });
  }
  function TSConditionalType(node) {
    this.print(node.checkType);
    this.space();
    this.word('extends');
    this.space();
    this.print(node.extendsType);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.trueType);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.falseType);
  }
  function TSInferType(node) {
    this.word('infer');
    this.print(node.typeParameter);
  }
  function TSParenthesizedType(node) {
    this.tokenChar(40);
    this.print(node.typeAnnotation);
    this.tokenChar(41);
  }
  function TSTypeOperator(node) {
    this.word(node.operator);
    this.space();
    this.print(node.typeAnnotation);
  }
  function TSIndexedAccessType(node) {
    this.print(node.objectType, true);
    this.tokenChar(91);
    this.print(node.indexType);
    this.tokenChar(93);
  }
  function TSMappedType(node) {
    const {
      nameType: nameType,
      optional: optional,
      readonly: readonly,
      typeAnnotation: typeAnnotation,
    } = node;
    this.tokenChar(123);
    const exit = this.enterDelimited();
    this.space();
    if (readonly) {
      tokenIfPlusMinus(this, readonly);
      this.word('readonly');
      this.space();
    }
    this.tokenChar(91);
    {
      this.word(node.typeParameter.name);
    }
    this.space();
    this.word('in');
    this.space();
    {
      this.print(node.typeParameter.constraint);
    }
    if (nameType) {
      this.space();
      this.word('as');
      this.space();
      this.print(nameType);
    }
    this.tokenChar(93);
    if (optional) {
      tokenIfPlusMinus(this, optional);
      this.tokenChar(63);
    }
    if (typeAnnotation) {
      this.tokenChar(58);
      this.space();
      this.print(typeAnnotation);
    }
    this.space();
    exit();
    this.tokenChar(125);
  }
  function tokenIfPlusMinus(self, tok) {
    if (tok !== true) {
      self.token(tok);
    }
  }
  function TSLiteralType(node) {
    this.print(node.literal);
  }
  function TSClassImplements(node) {
    this.print(node.expression);
    this.print(node.typeParameters);
  }
  function TSInterfaceDeclaration(node) {
    const {
      declare: declare,
      id: id,
      typeParameters: typeParameters,
      extends: extendz,
      body: body,
    } = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    this.word('interface');
    this.space();
    this.print(id);
    this.print(typeParameters);
    if (extendz != null && extendz.length) {
      this.space();
      this.word('extends');
      this.space();
      this.printList(extendz);
    }
    this.space();
    this.print(body);
  }
  function TSInterfaceBody(node) {
    printBraced(this, node, () =>
      this.printJoin(node.body, {indent: true, statement: true})
    );
  }
  function TSTypeAliasDeclaration(node) {
    const {
      declare: declare,
      id: id,
      typeParameters: typeParameters,
      typeAnnotation: typeAnnotation,
    } = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    this.word('type');
    this.space();
    this.print(id);
    this.print(typeParameters);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(typeAnnotation);
    this.semicolon();
  }
  function TSTypeExpression(node) {
    const {
      type: type,
      expression: expression,
      typeAnnotation: typeAnnotation,
    } = node;
    this.print(expression, true);
    this.space();
    this.word(type === 'TSAsExpression' ? 'as' : 'satisfies');
    this.space();
    this.print(typeAnnotation);
  }
  function TSTypeAssertion(node) {
    const {typeAnnotation: typeAnnotation, expression: expression} = node;
    this.tokenChar(60);
    this.print(typeAnnotation);
    this.tokenChar(62);
    this.space();
    this.print(expression);
  }
  function TSInstantiationExpression(node) {
    this.print(node.expression);
    this.print(node.typeParameters);
  }
  function TSEnumDeclaration(node) {
    const {declare: declare, const: isConst, id: id, members: members} = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    if (isConst) {
      this.word('const');
      this.space();
    }
    this.word('enum');
    this.space();
    this.print(id);
    this.space();
    printBraced(this, node, () => {
      var _this$shouldPrintTrai;
      return this.printList(members, {
        indent: true,
        statement: true,
        printTrailingSeparator:
          (_this$shouldPrintTrai = this.shouldPrintTrailingComma('}')) != null
            ? _this$shouldPrintTrai
            : true,
      });
    });
  }
  function TSEnumMember(node) {
    const {id: id, initializer: initializer} = node;
    this.print(id);
    if (initializer) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(initializer);
    }
  }
  function TSModuleDeclaration(node) {
    const {declare: declare, id: id, kind: kind} = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    if (!node.global) {
      this.word(
        kind != null ? kind : id.type === 'Identifier' ? 'namespace' : 'module'
      );
      this.space();
    }
    this.print(id);
    if (!node.body) {
      this.semicolon();
      return;
    }
    let body = node.body;
    while (body.type === 'TSModuleDeclaration') {
      this.tokenChar(46);
      this.print(body.id);
      body = body.body;
    }
    this.space();
    this.print(body);
  }
  function TSModuleBlock(node) {
    printBraced(this, node, () =>
      this.printSequence(node.body, {indent: true})
    );
  }
  function TSImportType(node) {
    const {
      argument: argument,
      qualifier: qualifier,
      typeParameters: typeParameters,
    } = node;
    this.word('import');
    this.tokenChar(40);
    this.print(argument);
    this.tokenChar(41);
    if (qualifier) {
      this.tokenChar(46);
      this.print(qualifier);
    }
    if (typeParameters) {
      this.print(typeParameters);
    }
  }
  function TSImportEqualsDeclaration(node) {
    const {isExport: isExport, id: id, moduleReference: moduleReference} = node;
    if (isExport) {
      this.word('export');
      this.space();
    }
    this.word('import');
    this.space();
    this.print(id);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(moduleReference);
    this.semicolon();
  }
  function TSExternalModuleReference(node) {
    this.token('require(');
    this.print(node.expression);
    this.tokenChar(41);
  }
  function TSNonNullExpression(node) {
    this.print(node.expression);
    this.tokenChar(33);
  }
  function TSExportAssignment(node) {
    this.word('export');
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.expression);
    this.semicolon();
  }
  function TSNamespaceExportDeclaration(node) {
    this.word('export');
    this.space();
    this.word('as');
    this.space();
    this.word('namespace');
    this.space();
    this.print(node.id);
    this.semicolon();
  }
  function tsPrintSignatureDeclarationBase(node) {
    const {typeParameters: typeParameters} = node;
    const parameters = node.parameters;
    this.print(typeParameters);
    this.tokenChar(40);
    this._parameters(parameters, ')');
    const returnType = node.typeAnnotation;
    this.print(returnType);
  }
  function tsPrintClassMemberModifiers(node) {
    const isField =
      node.type === 'ClassAccessorProperty' || node.type === 'ClassProperty';
    printModifiersList(this, node, [
      isField && node.declare && 'declare',
      node.accessibility,
    ]);
    if (node.static) {
      this.word('static');
      this.space();
    }
    printModifiersList(this, node, [
      node.override && 'override',
      node.abstract && 'abstract',
      isField && node.readonly && 'readonly',
    ]);
  }
  function printBraced(printer, node, cb) {
    printer.token('{');
    const exit = printer.enterDelimited();
    cb();
    exit();
    printer.rightBrace(node);
  }
  function printModifiersList(printer, node, modifiers) {
    var _printer$tokenMap2;
    const modifiersSet = new Set();
    for (const modifier of modifiers) {
      if (modifier) modifiersSet.add(modifier);
    }
    (_printer$tokenMap2 = printer.tokenMap) == null ||
      _printer$tokenMap2.find(node, tok => {
        if (modifiersSet.has(tok.value)) {
          printer.token(tok.value);
          printer.space();
          modifiersSet.delete(tok.value);
          return modifiersSet.size === 0;
        }
      });
    for (const modifier of modifiersSet) {
      printer.word(modifier);
      printer.space();
    }
  }
  return typescript$3;
}
var hasRequiredGenerators$1;
function requireGenerators$1() {
  if (hasRequiredGenerators$1) return generators$2;
  hasRequiredGenerators$1 = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    var _templateLiterals = requireTemplateLiterals$1();
    Object.keys(_templateLiterals).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _templateLiterals[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _templateLiterals[key];
        },
      });
    });
    var _expressions = requireExpressions$1();
    Object.keys(_expressions).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _expressions[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _expressions[key];
        },
      });
    });
    var _statements = requireStatements$1();
    Object.keys(_statements).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _statements[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _statements[key];
        },
      });
    });
    var _classes = requireClasses$1();
    Object.keys(_classes).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _classes[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _classes[key];
        },
      });
    });
    var _methods = requireMethods$1();
    Object.keys(_methods).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _methods[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _methods[key];
        },
      });
    });
    var _modules = requireModules$1();
    Object.keys(_modules).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _modules[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _modules[key];
        },
      });
    });
    var _types = requireTypes$1();
    Object.keys(_types).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _types[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _types[key];
        },
      });
    });
    var _flow = requireFlow$1();
    Object.keys(_flow).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _flow[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _flow[key];
        },
      });
    });
    var _base = requireBase$1();
    Object.keys(_base).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _base[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _base[key];
        },
      });
    });
    var _jsx = requireJsx$1();
    Object.keys(_jsx).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _jsx[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _jsx[key];
        },
      });
    });
    var _typescript = requireTypescript$1();
    Object.keys(_typescript).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _typescript[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _typescript[key];
        },
      });
    });
  })(generators$2);
  return generators$2;
}
var hasRequiredPrinter$1;
function requirePrinter$1() {
  if (hasRequiredPrinter$1) return printer$3;
  hasRequiredPrinter$1 = 1;
  Object.defineProperty(printer$3, '__esModule', {value: true});
  printer$3.default = void 0;
  var _buffer = requireBuffer$1();
  var n = requireNode$1();
  var _t = t$d;
  var _tokenMap = requireTokenMap$1();
  var generatorFunctions = requireGenerators$1();
  const {
    isExpression: isExpression,
    isFunction: isFunction,
    isStatement: isStatement,
    isClassBody: isClassBody,
    isTSInterfaceBody: isTSInterfaceBody,
    isTSEnumDeclaration: isTSEnumDeclaration,
  } = _t;
  const SCIENTIFIC_NOTATION = /e/i;
  const ZERO_DECIMAL_INTEGER = /\.0+$/;
  const HAS_NEWLINE = /[\n\r\u2028\u2029]/;
  const HAS_NEWLINE_OR_BlOCK_COMMENT_END = /[\n\r\u2028\u2029]|\*\//;
  function commentIsNewline(c) {
    return c.type === 'CommentLine' || HAS_NEWLINE.test(c.value);
  }
  const {needsParens: needsParens} = n;
  class Printer {
    constructor(format, map, tokens, originalCode) {
      this.inForStatementInit = false;
      this.tokenContext = 0;
      this._tokens = null;
      this._originalCode = null;
      this._currentNode = null;
      this._indent = 0;
      this._indentRepeat = 0;
      this._insideAux = false;
      this._noLineTerminator = false;
      this._noLineTerminatorAfterNode = null;
      this._printAuxAfterOnNextUserNode = false;
      this._printedComments = new Set();
      this._endsWithInteger = false;
      this._endsWithWord = false;
      this._endsWithDiv = false;
      this._lastCommentLine = 0;
      this._endsWithInnerRaw = false;
      this._indentInnerComments = true;
      this.tokenMap = null;
      this._boundGetRawIdentifier = this._getRawIdentifier.bind(this);
      this.format = format;
      this._tokens = tokens;
      this._originalCode = originalCode;
      this._indentRepeat = format.indent.style.length;
      this._inputMap = map == null ? void 0 : map._inputMap;
      this._buf = new _buffer.default(map, format.indent.style[0]);
    }
    enterForStatementInit() {
      if (this.inForStatementInit) return () => {};
      this.inForStatementInit = true;
      return () => {
        this.inForStatementInit = false;
      };
    }
    enterDelimited() {
      const oldInForStatementInit = this.inForStatementInit;
      const oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
      if (
        oldInForStatementInit === false &&
        oldNoLineTerminatorAfterNode === null
      ) {
        return () => {};
      }
      this.inForStatementInit = false;
      this._noLineTerminatorAfterNode = null;
      return () => {
        this.inForStatementInit = oldInForStatementInit;
        this._noLineTerminatorAfterNode = oldNoLineTerminatorAfterNode;
      };
    }
    generate(ast) {
      if (this.format.preserveFormat) {
        this.tokenMap = new _tokenMap.TokenMap(
          ast,
          this._tokens,
          this._originalCode
        );
      }
      this.print(ast);
      this._maybeAddAuxComment();
      return this._buf.get();
    }
    indent() {
      const {format: format} = this;
      if (format.preserveFormat || format.compact || format.concise) {
        return;
      }
      this._indent++;
    }
    dedent() {
      const {format: format} = this;
      if (format.preserveFormat || format.compact || format.concise) {
        return;
      }
      this._indent--;
    }
    semicolon(force = false) {
      this._maybeAddAuxComment();
      if (force) {
        this._appendChar(59);
        this._noLineTerminator = false;
        return;
      }
      if (this.tokenMap) {
        const node = this._currentNode;
        if (node.start != null && node.end != null) {
          if (!this.tokenMap.endMatches(node, ';')) {
            return;
          }
          const indexes = this.tokenMap.getIndexes(this._currentNode);
          this._catchUpTo(this._tokens[indexes[indexes.length - 1]].loc.start);
        }
      }
      this._queue(59);
      this._noLineTerminator = false;
    }
    rightBrace(node) {
      if (this.format.minified) {
        this._buf.removeLastSemicolon();
      }
      this.sourceWithOffset('end', node.loc, -1);
      this.tokenChar(125);
    }
    rightParens(node) {
      this.sourceWithOffset('end', node.loc, -1);
      this.tokenChar(41);
    }
    space(force = false) {
      const {format: format} = this;
      if (format.compact || format.preserveFormat) return;
      if (force) {
        this._space();
      } else if (this._buf.hasContent()) {
        const lastCp = this.getLastChar();
        if (lastCp !== 32 && lastCp !== 10) {
          this._space();
        }
      }
    }
    word(str, noLineTerminatorAfter = false) {
      this.tokenContext = 0;
      this._maybePrintInnerComments(str);
      if (
        this._endsWithWord ||
        (this._endsWithDiv && str.charCodeAt(0) === 47)
      ) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._append(str, false);
      this._endsWithWord = true;
      this._noLineTerminator = noLineTerminatorAfter;
    }
    number(str, number) {
      function isNonDecimalLiteral(str) {
        if (str.length > 2 && str.charCodeAt(0) === 48) {
          const secondChar = str.charCodeAt(1);
          return secondChar === 98 || secondChar === 111 || secondChar === 120;
        }
        return false;
      }
      this.word(str);
      this._endsWithInteger =
        Number.isInteger(number) &&
        !isNonDecimalLiteral(str) &&
        !SCIENTIFIC_NOTATION.test(str) &&
        !ZERO_DECIMAL_INTEGER.test(str) &&
        str.charCodeAt(str.length - 1) !== 46;
    }
    token(str, maybeNewline = false, occurrenceCount = 0) {
      this.tokenContext = 0;
      this._maybePrintInnerComments(str, occurrenceCount);
      const lastChar = this.getLastChar();
      const strFirst = str.charCodeAt(0);
      if (
        (lastChar === 33 && (str === '--' || strFirst === 61)) ||
        (strFirst === 43 && lastChar === 43) ||
        (strFirst === 45 && lastChar === 45) ||
        (strFirst === 46 && this._endsWithInteger)
      ) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._append(str, maybeNewline, occurrenceCount);
      this._noLineTerminator = false;
    }
    tokenChar(char) {
      this.tokenContext = 0;
      this._maybePrintInnerComments(String.fromCharCode(char));
      const lastChar = this.getLastChar();
      if (
        (char === 43 && lastChar === 43) ||
        (char === 45 && lastChar === 45) ||
        (char === 46 && this._endsWithInteger)
      ) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._appendChar(char);
      this._noLineTerminator = false;
    }
    newline(i = 1, force) {
      if (i <= 0) return;
      if (!force) {
        if (this.format.retainLines || this.format.compact) return;
        if (this.format.concise) {
          this.space();
          return;
        }
      }
      if (i > 2) i = 2;
      i -= this._buf.getNewlineCount();
      for (let j = 0; j < i; j++) {
        this._newline();
      }
      return;
    }
    endsWith(char) {
      return this.getLastChar() === char;
    }
    getLastChar() {
      return this._buf.getLastChar();
    }
    endsWithCharAndNewline() {
      return this._buf.endsWithCharAndNewline();
    }
    removeTrailingNewline() {
      this._buf.removeTrailingNewline();
    }
    exactSource(loc, cb) {
      if (!loc) {
        cb();
        return;
      }
      this._catchUp('start', loc);
      this._buf.exactSource(loc, cb);
    }
    source(prop, loc) {
      if (!loc) return;
      this._catchUp(prop, loc);
      this._buf.source(prop, loc);
    }
    sourceWithOffset(prop, loc, columnOffset) {
      if (!loc || this.format.preserveFormat) return;
      this._catchUp(prop, loc);
      this._buf.sourceWithOffset(prop, loc, columnOffset);
    }
    sourceIdentifierName(identifierName, pos) {
      if (!this._buf._canMarkIdName) return;
      const sourcePosition = this._buf._sourcePosition;
      sourcePosition.identifierNamePos = pos;
      sourcePosition.identifierName = identifierName;
    }
    _space() {
      this._queue(32);
    }
    _newline() {
      this._queue(10);
    }
    _append(str, maybeNewline, occurrenceCount = 0) {
      if (this.tokenMap) {
        const token = this.tokenMap.findMatching(
          this._currentNode,
          str,
          occurrenceCount
        );
        if (token) this._catchUpTo(token.loc.start);
      }
      this._maybeIndent(str.charCodeAt(0));
      this._buf.append(str, maybeNewline);
      this._endsWithWord = false;
      this._endsWithInteger = false;
      this._endsWithDiv = false;
    }
    _appendChar(char) {
      if (this.tokenMap) {
        const token = this.tokenMap.findMatching(
          this._currentNode,
          String.fromCharCode(char)
        );
        if (token) this._catchUpTo(token.loc.start);
      }
      this._maybeIndent(char);
      this._buf.appendChar(char);
      this._endsWithWord = false;
      this._endsWithInteger = false;
      this._endsWithDiv = false;
    }
    _queue(char) {
      this._maybeIndent(char);
      this._buf.queue(char);
      this._endsWithWord = false;
      this._endsWithInteger = false;
    }
    _maybeIndent(firstChar) {
      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
        this._buf.queueIndentation(this._getIndent());
      }
    }
    _shouldIndent(firstChar) {
      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
        return true;
      }
    }
    catchUp(line) {
      if (!this.format.retainLines) return;
      const count = line - this._buf.getCurrentLine();
      for (let i = 0; i < count; i++) {
        this._newline();
      }
    }
    _catchUp(prop, loc) {
      const {format: format} = this;
      if (!format.preserveFormat) {
        if (format.retainLines && loc != null && loc[prop]) {
          this.catchUp(loc[prop].line);
        }
        return;
      }
      const pos = loc == null ? void 0 : loc[prop];
      if (pos != null) this._catchUpTo(pos);
    }
    _catchUpTo({line: line, column: column, index: index}) {
      const count = line - this._buf.getCurrentLine();
      if (count > 0 && this._noLineTerminator) {
        return;
      }
      for (let i = 0; i < count; i++) {
        this._newline();
      }
      const spacesCount =
        count > 0 ? column : column - this._buf.getCurrentColumn();
      if (spacesCount > 0) {
        const spaces = this._originalCode
          ? this._originalCode
              .slice(index - spacesCount, index)
              .replace(
                /[^\t\x0B\f \xA0\u1680\u2000-\u200A\u202F\u205F\u3000\uFEFF]/gu,
                ' '
              )
          : ' '.repeat(spacesCount);
        this._append(spaces, false);
      }
    }
    _getIndent() {
      return this._indentRepeat * this._indent;
    }
    printTerminatorless(node) {
      this._noLineTerminator = true;
      this.print(node);
    }
    print(node, noLineTerminatorAfter, trailingCommentsLineOffset) {
      var _node$extra, _node$leadingComments, _node$leadingComments2;
      if (!node) return;
      this._endsWithInnerRaw = false;
      const nodeType = node.type;
      const format = this.format;
      const oldConcise = format.concise;
      if (node._compact) {
        format.concise = true;
      }
      const printMethod = this[nodeType];
      if (printMethod === undefined) {
        throw new ReferenceError(
          `unknown node of type ${JSON.stringify(nodeType)} with constructor ${JSON.stringify(node.constructor.name)}`
        );
      }
      const parent = this._currentNode;
      this._currentNode = node;
      const oldInAux = this._insideAux;
      this._insideAux = node.loc == null;
      this._maybeAddAuxComment(this._insideAux && !oldInAux);
      const parenthesized =
        (_node$extra = node.extra) == null ? void 0 : _node$extra.parenthesized;
      let shouldPrintParens =
        (parenthesized && format.preserveFormat) ||
        (parenthesized &&
          format.retainFunctionParens &&
          nodeType === 'FunctionExpression') ||
        needsParens(
          node,
          parent,
          this.tokenContext,
          this.inForStatementInit,
          format.preserveFormat ? this._boundGetRawIdentifier : undefined
        );
      if (
        !shouldPrintParens &&
        parenthesized &&
        (_node$leadingComments = node.leadingComments) != null &&
        _node$leadingComments.length &&
        node.leadingComments[0].type === 'CommentBlock'
      ) {
        const parentType = parent == null ? void 0 : parent.type;
        switch (parentType) {
          case 'ExpressionStatement':
          case 'VariableDeclarator':
          case 'AssignmentExpression':
          case 'ReturnStatement':
            break;
          case 'CallExpression':
          case 'OptionalCallExpression':
          case 'NewExpression':
            if (parent.callee !== node) break;
          default:
            shouldPrintParens = true;
        }
      }
      let indentParenthesized = false;
      if (
        !shouldPrintParens &&
        this._noLineTerminator &&
        (((_node$leadingComments2 = node.leadingComments) != null &&
          _node$leadingComments2.some(commentIsNewline)) ||
          (this.format.retainLines &&
            node.loc &&
            node.loc.start.line > this._buf.getCurrentLine()))
      ) {
        shouldPrintParens = true;
        indentParenthesized = true;
      }
      let oldNoLineTerminatorAfterNode;
      let oldInForStatementInitWasTrue;
      if (!shouldPrintParens) {
        noLineTerminatorAfter ||
          (noLineTerminatorAfter =
            parent &&
            this._noLineTerminatorAfterNode === parent &&
            n.isLastChild(parent, node));
        if (noLineTerminatorAfter) {
          var _node$trailingComment;
          if (
            (_node$trailingComment = node.trailingComments) != null &&
            _node$trailingComment.some(commentIsNewline)
          ) {
            if (isExpression(node)) shouldPrintParens = true;
          } else {
            oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
            this._noLineTerminatorAfterNode = node;
          }
        }
      }
      if (shouldPrintParens) {
        this.tokenChar(40);
        if (indentParenthesized) this.indent();
        this._endsWithInnerRaw = false;
        if (this.inForStatementInit) {
          oldInForStatementInitWasTrue = true;
          this.inForStatementInit = false;
        }
        oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
        this._noLineTerminatorAfterNode = null;
      }
      this._lastCommentLine = 0;
      this._printLeadingComments(node, parent);
      const loc =
        nodeType === 'Program' || nodeType === 'File' ? null : node.loc;
      this.exactSource(loc, printMethod.bind(this, node, parent));
      if (shouldPrintParens) {
        this._printTrailingComments(node, parent);
        if (indentParenthesized) {
          this.dedent();
          this.newline();
        }
        this.tokenChar(41);
        this._noLineTerminator = noLineTerminatorAfter;
        if (oldInForStatementInitWasTrue) this.inForStatementInit = true;
      } else if (noLineTerminatorAfter && !this._noLineTerminator) {
        this._noLineTerminator = true;
        this._printTrailingComments(node, parent);
      } else {
        this._printTrailingComments(node, parent, trailingCommentsLineOffset);
      }
      this._currentNode = parent;
      format.concise = oldConcise;
      this._insideAux = oldInAux;
      if (oldNoLineTerminatorAfterNode !== undefined) {
        this._noLineTerminatorAfterNode = oldNoLineTerminatorAfterNode;
      }
      this._endsWithInnerRaw = false;
    }
    _maybeAddAuxComment(enteredPositionlessNode) {
      if (enteredPositionlessNode) this._printAuxBeforeComment();
      if (!this._insideAux) this._printAuxAfterComment();
    }
    _printAuxBeforeComment() {
      if (this._printAuxAfterOnNextUserNode) return;
      this._printAuxAfterOnNextUserNode = true;
      const comment = this.format.auxiliaryCommentBefore;
      if (comment) {
        this._printComment({type: 'CommentBlock', value: comment}, 0);
      }
    }
    _printAuxAfterComment() {
      if (!this._printAuxAfterOnNextUserNode) return;
      this._printAuxAfterOnNextUserNode = false;
      const comment = this.format.auxiliaryCommentAfter;
      if (comment) {
        this._printComment({type: 'CommentBlock', value: comment}, 0);
      }
    }
    getPossibleRaw(node) {
      const extra = node.extra;
      if (
        (extra == null ? void 0 : extra.raw) != null &&
        extra.rawValue != null &&
        node.value === extra.rawValue
      ) {
        return extra.raw;
      }
    }
    printJoin(nodes, opts = {}) {
      if (!(nodes != null && nodes.length)) return;
      let {indent: indent} = opts;
      if (indent == null && this.format.retainLines) {
        var _nodes$0$loc;
        const startLine =
          (_nodes$0$loc = nodes[0].loc) == null
            ? void 0
            : _nodes$0$loc.start.line;
        if (startLine != null && startLine !== this._buf.getCurrentLine()) {
          indent = true;
        }
      }
      if (indent) this.indent();
      const newlineOpts = {addNewlines: opts.addNewlines, nextNodeStartLine: 0};
      const separator = opts.separator ? opts.separator.bind(this) : null;
      const len = nodes.length;
      for (let i = 0; i < len; i++) {
        const node = nodes[i];
        if (!node) continue;
        if (opts.statement) this._printNewline(i === 0, newlineOpts);
        this.print(node, undefined, opts.trailingCommentsLineOffset || 0);
        opts.iterator == null || opts.iterator(node, i);
        if (separator != null) {
          if (i < len - 1) separator(i, false);
          else if (opts.printTrailingSeparator) separator(i, true);
        }
        if (opts.statement) {
          var _node$trailingComment2;
          if (
            !(
              (_node$trailingComment2 = node.trailingComments) != null &&
              _node$trailingComment2.length
            )
          ) {
            this._lastCommentLine = 0;
          }
          if (i + 1 === len) {
            this.newline(1);
          } else {
            var _nextNode$loc;
            const nextNode = nodes[i + 1];
            newlineOpts.nextNodeStartLine =
              ((_nextNode$loc = nextNode.loc) == null
                ? void 0
                : _nextNode$loc.start.line) || 0;
            this._printNewline(true, newlineOpts);
          }
        }
      }
      if (indent) this.dedent();
    }
    printAndIndentOnComments(node) {
      const indent = node.leadingComments && node.leadingComments.length > 0;
      if (indent) this.indent();
      this.print(node);
      if (indent) this.dedent();
    }
    printBlock(parent) {
      const node = parent.body;
      if (node.type !== 'EmptyStatement') {
        this.space();
      }
      this.print(node);
    }
    _printTrailingComments(node, parent, lineOffset) {
      const {innerComments: innerComments, trailingComments: trailingComments} =
        node;
      if (innerComments != null && innerComments.length) {
        this._printComments(2, innerComments, node, parent, lineOffset);
      }
      if (trailingComments != null && trailingComments.length) {
        this._printComments(2, trailingComments, node, parent, lineOffset);
      }
    }
    _printLeadingComments(node, parent) {
      const comments = node.leadingComments;
      if (!(comments != null && comments.length)) return;
      this._printComments(0, comments, node, parent);
    }
    _maybePrintInnerComments(nextTokenStr, nextTokenOccurrenceCount) {
      if (this._endsWithInnerRaw) {
        var _this$tokenMap;
        this.printInnerComments(
          (_this$tokenMap = this.tokenMap) == null
            ? void 0
            : _this$tokenMap.findMatching(
                this._currentNode,
                nextTokenStr,
                nextTokenOccurrenceCount
              )
        );
      }
      this._endsWithInnerRaw = true;
      this._indentInnerComments = true;
    }
    printInnerComments(nextToken) {
      const node = this._currentNode;
      const comments = node.innerComments;
      if (!(comments != null && comments.length)) return;
      const hasSpace = this.endsWith(32);
      const indent = this._indentInnerComments;
      const printedCommentsCount = this._printedComments.size;
      if (indent) this.indent();
      this._printComments(1, comments, node, undefined, undefined, nextToken);
      if (hasSpace && printedCommentsCount !== this._printedComments.size) {
        this.space();
      }
      if (indent) this.dedent();
    }
    noIndentInnerCommentsHere() {
      this._indentInnerComments = false;
    }
    printSequence(nodes, opts = {}) {
      var _opts$indent;
      opts.statement = true;
      (_opts$indent = opts.indent) != null
        ? _opts$indent
        : (opts.indent = false);
      this.printJoin(nodes, opts);
    }
    printList(items, opts = {}) {
      if (opts.separator == null) {
        opts.separator = commaSeparator;
      }
      this.printJoin(items, opts);
    }
    shouldPrintTrailingComma(listEnd) {
      if (!this.tokenMap) return null;
      const listEndIndex = this.tokenMap.findLastIndex(
        this._currentNode,
        token => this.tokenMap.matchesOriginal(token, listEnd)
      );
      if (listEndIndex <= 0) return null;
      return this.tokenMap.matchesOriginal(this._tokens[listEndIndex - 1], ',');
    }
    _printNewline(newLine, opts) {
      const format = this.format;
      if (format.retainLines || format.compact) return;
      if (format.concise) {
        this.space();
        return;
      }
      if (!newLine) {
        return;
      }
      const startLine = opts.nextNodeStartLine;
      const lastCommentLine = this._lastCommentLine;
      if (startLine > 0 && lastCommentLine > 0) {
        const offset = startLine - lastCommentLine;
        if (offset >= 0) {
          this.newline(offset || 1);
          return;
        }
      }
      if (this._buf.hasContent()) {
        this.newline(1);
      }
    }
    _shouldPrintComment(comment, nextToken) {
      if (comment.ignore) return 0;
      if (this._printedComments.has(comment)) return 0;
      if (
        this._noLineTerminator &&
        HAS_NEWLINE_OR_BlOCK_COMMENT_END.test(comment.value)
      ) {
        return 2;
      }
      if (nextToken && this.tokenMap) {
        const commentTok = this.tokenMap.find(
          this._currentNode,
          token => token.value === comment.value
        );
        if (commentTok && commentTok.start > nextToken.start) {
          return 2;
        }
      }
      this._printedComments.add(comment);
      if (!this.format.shouldPrintComment(comment.value)) {
        return 0;
      }
      return 1;
    }
    _printComment(comment, skipNewLines) {
      const noLineTerminator = this._noLineTerminator;
      const isBlockComment = comment.type === 'CommentBlock';
      const printNewLines =
        isBlockComment && skipNewLines !== 1 && !this._noLineTerminator;
      if (printNewLines && this._buf.hasContent() && skipNewLines !== 2) {
        this.newline(1);
      }
      const lastCharCode = this.getLastChar();
      if (lastCharCode !== 91 && lastCharCode !== 123 && lastCharCode !== 40) {
        this.space();
      }
      let val;
      if (isBlockComment) {
        val = `/*${comment.value}*/`;
        if (this.format.indent.adjustMultilineComment) {
          var _comment$loc;
          const offset =
            (_comment$loc = comment.loc) == null
              ? void 0
              : _comment$loc.start.column;
          if (offset) {
            const newlineRegex = new RegExp('\\n\\s{1,' + offset + '}', 'g');
            val = val.replace(newlineRegex, '\n');
          }
          if (this.format.concise) {
            val = val.replace(/\n(?!$)/g, `\n`);
          } else {
            let indentSize = this.format.retainLines
              ? 0
              : this._buf.getCurrentColumn();
            if (this._shouldIndent(47) || this.format.retainLines) {
              indentSize += this._getIndent();
            }
            val = val.replace(/\n(?!$)/g, `\n${' '.repeat(indentSize)}`);
          }
        }
      } else if (!noLineTerminator) {
        val = `//${comment.value}`;
      } else {
        val = `/*${comment.value}*/`;
      }
      if (this._endsWithDiv) this._space();
      this.source('start', comment.loc);
      this._append(val, isBlockComment);
      if (!isBlockComment && !noLineTerminator) {
        this.newline(1, true);
      }
      if (printNewLines && skipNewLines !== 3) {
        this.newline(1);
      }
    }
    _printComments(type, comments, node, parent, lineOffset = 0, nextToken) {
      const nodeLoc = node.loc;
      const len = comments.length;
      let hasLoc = !!nodeLoc;
      const nodeStartLine = hasLoc ? nodeLoc.start.line : 0;
      const nodeEndLine = hasLoc ? nodeLoc.end.line : 0;
      let lastLine = 0;
      let leadingCommentNewline = 0;
      const maybeNewline = this._noLineTerminator
        ? function () {}
        : this.newline.bind(this);
      for (let i = 0; i < len; i++) {
        const comment = comments[i];
        const shouldPrint = this._shouldPrintComment(comment, nextToken);
        if (shouldPrint === 2) {
          hasLoc = false;
          break;
        }
        if (hasLoc && comment.loc && shouldPrint === 1) {
          const commentStartLine = comment.loc.start.line;
          const commentEndLine = comment.loc.end.line;
          if (type === 0) {
            let offset = 0;
            if (i === 0) {
              if (
                this._buf.hasContent() &&
                (comment.type === 'CommentLine' ||
                  commentStartLine !== commentEndLine)
              ) {
                offset = leadingCommentNewline = 1;
              }
            } else {
              offset = commentStartLine - lastLine;
            }
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
            if (i + 1 === len) {
              maybeNewline(
                Math.max(nodeStartLine - lastLine, leadingCommentNewline)
              );
              lastLine = nodeStartLine;
            }
          } else if (type === 1) {
            const offset =
              commentStartLine - (i === 0 ? nodeStartLine : lastLine);
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
            if (i + 1 === len) {
              maybeNewline(Math.min(1, nodeEndLine - lastLine));
              lastLine = nodeEndLine;
            }
          } else {
            const offset =
              commentStartLine -
              (i === 0 ? nodeEndLine - lineOffset : lastLine);
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
          }
        } else {
          hasLoc = false;
          if (shouldPrint !== 1) {
            continue;
          }
          if (len === 1) {
            const singleLine = comment.loc
              ? comment.loc.start.line === comment.loc.end.line
              : !HAS_NEWLINE.test(comment.value);
            const shouldSkipNewline =
              singleLine &&
              !isStatement(node) &&
              !isClassBody(parent) &&
              !isTSInterfaceBody(parent) &&
              !isTSEnumDeclaration(parent);
            if (type === 0) {
              this._printComment(
                comment,
                (shouldSkipNewline && node.type !== 'ObjectExpression') ||
                  (singleLine && isFunction(parent, {body: node}))
                  ? 1
                  : 0
              );
            } else if (shouldSkipNewline && type === 2) {
              this._printComment(comment, 1);
            } else {
              this._printComment(comment, 0);
            }
          } else if (
            type === 1 &&
            !(node.type === 'ObjectExpression' && node.properties.length > 1) &&
            node.type !== 'ClassBody' &&
            node.type !== 'TSInterfaceBody'
          ) {
            this._printComment(comment, i === 0 ? 2 : i === len - 1 ? 3 : 0);
          } else {
            this._printComment(comment, 0);
          }
        }
      }
      if (type === 2 && hasLoc && lastLine) {
        this._lastCommentLine = lastLine;
      }
    }
  }
  Object.assign(Printer.prototype, generatorFunctions);
  {
    Printer.prototype.Noop = function Noop() {};
  }
  printer$3.default = Printer;
  function commaSeparator(occurrenceCount, last) {
    this.token(',', false, occurrenceCount);
    if (!last) this.space();
  }
  return printer$3;
}
var hasRequiredLib$m;
function requireLib$m() {
  if (hasRequiredLib$m) return lib$m;
  hasRequiredLib$m = 1;
  Object.defineProperty(lib$m, '__esModule', {value: true});
  lib$m.default = generate;
  var _sourceMap = requireSourceMap$2();
  var _printer = requirePrinter$1();
  function normalizeOptions(code, opts, ast) {
    if (opts.experimental_preserveFormat) {
      if (typeof code !== 'string') {
        throw new Error(
          '`experimental_preserveFormat` requires the original `code` to be passed to @babel/generator as a string'
        );
      }
      if (!opts.retainLines) {
        throw new Error(
          '`experimental_preserveFormat` requires `retainLines` to be set to `true`'
        );
      }
      if (opts.compact && opts.compact !== 'auto') {
        throw new Error(
          '`experimental_preserveFormat` is not compatible with the `compact` option'
        );
      }
      if (opts.minified) {
        throw new Error(
          '`experimental_preserveFormat` is not compatible with the `minified` option'
        );
      }
      if (opts.jsescOption) {
        throw new Error(
          '`experimental_preserveFormat` is not compatible with the `jsescOption` option'
        );
      }
      if (!Array.isArray(ast.tokens)) {
        throw new Error(
          '`experimental_preserveFormat` requires the AST to have attatched the token of the input code. Make sure to enable the `tokens: true` parser option.'
        );
      }
    }
    const format = {
      auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
      auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
      shouldPrintComment: opts.shouldPrintComment,
      preserveFormat: opts.experimental_preserveFormat,
      retainLines: opts.retainLines,
      retainFunctionParens: opts.retainFunctionParens,
      comments: opts.comments == null || opts.comments,
      compact: opts.compact,
      minified: opts.minified,
      concise: opts.concise,
      indent: {adjustMultilineComment: true, style: '  '},
      jsescOption: Object.assign(
        {quotes: 'double', wrap: true, minimal: false},
        opts.jsescOption
      ),
      topicToken: opts.topicToken,
      importAttributesKeyword: opts.importAttributesKeyword,
    };
    {
      var _opts$recordAndTupleS;
      format.decoratorsBeforeExport = opts.decoratorsBeforeExport;
      format.jsescOption.json = opts.jsonCompatibleStrings;
      format.recordAndTupleSyntaxType =
        (_opts$recordAndTupleS = opts.recordAndTupleSyntaxType) != null
          ? _opts$recordAndTupleS
          : 'hash';
    }
    if (format.minified) {
      format.compact = true;
      format.shouldPrintComment =
        format.shouldPrintComment || (() => format.comments);
    } else {
      format.shouldPrintComment =
        format.shouldPrintComment ||
        (value =>
          format.comments ||
          value.includes('@license') ||
          value.includes('@preserve'));
    }
    if (format.compact === 'auto') {
      format.compact = typeof code === 'string' && code.length > 5e5;
      if (format.compact) {
        console.error(
          '[BABEL] Note: The code generator has deoptimised the styling of ' +
            `${opts.filename} as it exceeds the max of ${'500KB'}.`
        );
      }
    }
    if (format.compact || format.preserveFormat) {
      format.indent.adjustMultilineComment = false;
    }
    const {
      auxiliaryCommentBefore: auxiliaryCommentBefore,
      auxiliaryCommentAfter: auxiliaryCommentAfter,
      shouldPrintComment: shouldPrintComment,
    } = format;
    if (auxiliaryCommentBefore && !shouldPrintComment(auxiliaryCommentBefore)) {
      format.auxiliaryCommentBefore = undefined;
    }
    if (auxiliaryCommentAfter && !shouldPrintComment(auxiliaryCommentAfter)) {
      format.auxiliaryCommentAfter = undefined;
    }
    return format;
  }
  {
    lib$m.CodeGenerator = class CodeGenerator {
      constructor(ast, opts = {}, code) {
        this._ast = void 0;
        this._format = void 0;
        this._map = void 0;
        this._ast = ast;
        this._format = normalizeOptions(code, opts, ast);
        this._map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
      }
      generate() {
        const printer = new _printer.default(this._format, this._map);
        return printer.generate(this._ast);
      }
    };
  }
  function generate(ast, opts = {}, code) {
    const format = normalizeOptions(code, opts, ast);
    const map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
    const printer = new _printer.default(
      format,
      map,
      ast.tokens,
      typeof code === 'string' ? code : null
    );
    return printer.generate(ast);
  }
  return lib$m;
}
var ancestry$1 = {};
var hasRequiredAncestry$1;
function requireAncestry$1() {
  if (hasRequiredAncestry$1) return ancestry$1;
  hasRequiredAncestry$1 = 1;
  Object.defineProperty(ancestry$1, '__esModule', {value: true});
  ancestry$1.find = find;
  ancestry$1.findParent = findParent;
  ancestry$1.getAncestry = getAncestry;
  ancestry$1.getDeepestCommonAncestorFrom = getDeepestCommonAncestorFrom;
  ancestry$1.getEarliestCommonAncestorFrom = getEarliestCommonAncestorFrom;
  ancestry$1.getFunctionParent = getFunctionParent;
  ancestry$1.getStatementParent = getStatementParent;
  ancestry$1.inType = inType;
  ancestry$1.isAncestor = isAncestor;
  ancestry$1.isDescendant = isDescendant;
  var _t = t$d;
  const {VISITOR_KEYS: VISITOR_KEYS} = _t;
  function findParent(callback) {
    let path = this;
    while ((path = path.parentPath)) {
      if (callback(path)) return path;
    }
    return null;
  }
  function find(callback) {
    let path = this;
    do {
      if (callback(path)) return path;
    } while ((path = path.parentPath));
    return null;
  }
  function getFunctionParent() {
    return this.findParent(p => p.isFunction());
  }
  function getStatementParent() {
    let path = this;
    do {
      if (
        !path.parentPath ||
        (Array.isArray(path.container) && path.isStatement())
      ) {
        break;
      } else {
        path = path.parentPath;
      }
    } while (path);
    if (path && (path.isProgram() || path.isFile())) {
      throw new Error(
        "File/Program node, we can't possibly find a statement parent to this"
      );
    }
    return path;
  }
  function getEarliestCommonAncestorFrom(paths) {
    return this.getDeepestCommonAncestorFrom(
      paths,
      function (deepest, i, ancestries) {
        let earliest;
        const keys = VISITOR_KEYS[deepest.type];
        for (const ancestry of ancestries) {
          const path = ancestry[i + 1];
          if (!earliest) {
            earliest = path;
            continue;
          }
          if (path.listKey && earliest.listKey === path.listKey) {
            if (path.key < earliest.key) {
              earliest = path;
              continue;
            }
          }
          const earliestKeyIndex = keys.indexOf(earliest.parentKey);
          const currentKeyIndex = keys.indexOf(path.parentKey);
          if (earliestKeyIndex > currentKeyIndex) {
            earliest = path;
          }
        }
        return earliest;
      }
    );
  }
  function getDeepestCommonAncestorFrom(paths, filter) {
    if (!paths.length) {
      return this;
    }
    if (paths.length === 1) {
      return paths[0];
    }
    let minDepth = Infinity;
    let lastCommonIndex, lastCommon;
    const ancestries = paths.map(path => {
      const ancestry = [];
      do {
        ancestry.unshift(path);
      } while ((path = path.parentPath) && path !== this);
      if (ancestry.length < minDepth) {
        minDepth = ancestry.length;
      }
      return ancestry;
    });
    const first = ancestries[0];
    depthLoop: for (let i = 0; i < minDepth; i++) {
      const shouldMatch = first[i];
      for (const ancestry of ancestries) {
        if (ancestry[i] !== shouldMatch) {
          break depthLoop;
        }
      }
      lastCommonIndex = i;
      lastCommon = shouldMatch;
    }
    if (lastCommon) {
      if (filter) {
        return filter(lastCommon, lastCommonIndex, ancestries);
      } else {
        return lastCommon;
      }
    } else {
      throw new Error("Couldn't find intersection");
    }
  }
  function getAncestry() {
    let path = this;
    const paths = [];
    do {
      paths.push(path);
    } while ((path = path.parentPath));
    return paths;
  }
  function isAncestor(maybeDescendant) {
    return maybeDescendant.isDescendant(this);
  }
  function isDescendant(maybeAncestor) {
    return !!this.findParent(parent => parent === maybeAncestor);
  }
  function inType(...candidateTypes) {
    let path = this;
    while (path) {
      for (const type of candidateTypes) {
        if (path.node.type === type) return true;
      }
      path = path.parentPath;
    }
    return false;
  }
  return ancestry$1;
}
var inference$1 = {};
var inferers$1 = {};
var infererReference$1 = {};
var util$7 = {};
var hasRequiredUtil$1;
function requireUtil$1() {
  if (hasRequiredUtil$1) return util$7;
  hasRequiredUtil$1 = 1;
  Object.defineProperty(util$7, '__esModule', {value: true});
  util$7.createUnionType = createUnionType;
  var _t = t$d;
  const {
    createFlowUnionType: createFlowUnionType,
    createTSUnionType: createTSUnionType,
    createUnionTypeAnnotation: createUnionTypeAnnotation,
    isFlowType: isFlowType,
    isTSType: isTSType,
  } = _t;
  function createUnionType(types) {
    {
      if (types.every(v => isFlowType(v))) {
        if (createFlowUnionType) {
          return createFlowUnionType(types);
        }
        return createUnionTypeAnnotation(types);
      } else if (types.every(v => isTSType(v))) {
        if (createTSUnionType) {
          return createTSUnionType(types);
        }
      }
    }
  }
  return util$7;
}
var hasRequiredInfererReference$1;
function requireInfererReference$1() {
  if (hasRequiredInfererReference$1) return infererReference$1;
  hasRequiredInfererReference$1 = 1;
  Object.defineProperty(infererReference$1, '__esModule', {value: true});
  infererReference$1.default = _default;
  var _t = t$d;
  var _util = requireUtil$1();
  const {
    BOOLEAN_NUMBER_BINARY_OPERATORS: BOOLEAN_NUMBER_BINARY_OPERATORS,
    createTypeAnnotationBasedOnTypeof: createTypeAnnotationBasedOnTypeof,
    numberTypeAnnotation: numberTypeAnnotation,
    voidTypeAnnotation: voidTypeAnnotation,
  } = _t;
  function _default(node) {
    if (!this.isReferenced()) return;
    const binding = this.scope.getBinding(node.name);
    if (binding) {
      if (binding.identifier.typeAnnotation) {
        return binding.identifier.typeAnnotation;
      } else {
        return getTypeAnnotationBindingConstantViolations(
          binding,
          this,
          node.name
        );
      }
    }
    if (node.name === 'undefined') {
      return voidTypeAnnotation();
    } else if (node.name === 'NaN' || node.name === 'Infinity') {
      return numberTypeAnnotation();
    } else if (node.name === 'arguments');
  }
  function getTypeAnnotationBindingConstantViolations(binding, path, name) {
    const types = [];
    const functionConstantViolations = [];
    let constantViolations = getConstantViolationsBefore(
      binding,
      path,
      functionConstantViolations
    );
    const testType = getConditionalAnnotation(binding, path, name);
    if (testType) {
      const testConstantViolations = getConstantViolationsBefore(
        binding,
        testType.ifStatement
      );
      constantViolations = constantViolations.filter(
        path => !testConstantViolations.includes(path)
      );
      types.push(testType.typeAnnotation);
    }
    if (constantViolations.length) {
      constantViolations.push(...functionConstantViolations);
      for (const violation of constantViolations) {
        types.push(violation.getTypeAnnotation());
      }
    }
    if (!types.length) {
      return;
    }
    return (0, _util.createUnionType)(types);
  }
  function getConstantViolationsBefore(binding, path, functions) {
    const violations = binding.constantViolations.slice();
    violations.unshift(binding.path);
    return violations.filter(violation => {
      violation = violation.resolve();
      const status = violation._guessExecutionStatusRelativeTo(path);
      if (functions && status === 'unknown') functions.push(violation);
      return status === 'before';
    });
  }
  function inferAnnotationFromBinaryExpression(name, path) {
    const operator = path.node.operator;
    const right = path.get('right').resolve();
    const left = path.get('left').resolve();
    let target;
    if (left.isIdentifier({name: name})) {
      target = right;
    } else if (right.isIdentifier({name: name})) {
      target = left;
    }
    if (target) {
      if (operator === '===') {
        return target.getTypeAnnotation();
      }
      if (BOOLEAN_NUMBER_BINARY_OPERATORS.includes(operator)) {
        return numberTypeAnnotation();
      }
      return;
    }
    if (operator !== '===' && operator !== '==') return;
    let typeofPath;
    let typePath;
    if (left.isUnaryExpression({operator: 'typeof'})) {
      typeofPath = left;
      typePath = right;
    } else if (right.isUnaryExpression({operator: 'typeof'})) {
      typeofPath = right;
      typePath = left;
    }
    if (!typeofPath) return;
    if (!typeofPath.get('argument').isIdentifier({name: name})) return;
    typePath = typePath.resolve();
    if (!typePath.isLiteral()) return;
    const typeValue = typePath.node.value;
    if (typeof typeValue !== 'string') return;
    return createTypeAnnotationBasedOnTypeof(typeValue);
  }
  function getParentConditionalPath(binding, path, name) {
    let parentPath;
    while ((parentPath = path.parentPath)) {
      if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
        if (path.key === 'test') {
          return;
        }
        return parentPath;
      }
      if (parentPath.isFunction()) {
        if (parentPath.parentPath.scope.getBinding(name) !== binding) return;
      }
      path = parentPath;
    }
  }
  function getConditionalAnnotation(binding, path, name) {
    const ifStatement = getParentConditionalPath(binding, path, name);
    if (!ifStatement) return;
    const test = ifStatement.get('test');
    const paths = [test];
    const types = [];
    for (let i = 0; i < paths.length; i++) {
      const path = paths[i];
      if (path.isLogicalExpression()) {
        if (path.node.operator === '&&') {
          paths.push(path.get('left'));
          paths.push(path.get('right'));
        }
      } else if (path.isBinaryExpression()) {
        const type = inferAnnotationFromBinaryExpression(name, path);
        if (type) types.push(type);
      }
    }
    if (types.length) {
      return {
        typeAnnotation: (0, _util.createUnionType)(types),
        ifStatement: ifStatement,
      };
    }
    return getConditionalAnnotation(binding, ifStatement, name);
  }
  return infererReference$1;
}
var hasRequiredInferers$1;
function requireInferers$1() {
  if (hasRequiredInferers$1) return inferers$1;
  hasRequiredInferers$1 = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.ArrayExpression = ArrayExpression;
    exports.AssignmentExpression = AssignmentExpression;
    exports.BinaryExpression = BinaryExpression;
    exports.BooleanLiteral = BooleanLiteral;
    exports.CallExpression = CallExpression;
    exports.ConditionalExpression = ConditionalExpression;
    exports.ClassDeclaration =
      exports.ClassExpression =
      exports.FunctionDeclaration =
      exports.ArrowFunctionExpression =
      exports.FunctionExpression =
        Func;
    Object.defineProperty(exports, 'Identifier', {
      enumerable: true,
      get: function () {
        return _infererReference.default;
      },
    });
    exports.LogicalExpression = LogicalExpression;
    exports.NewExpression = NewExpression;
    exports.NullLiteral = NullLiteral;
    exports.NumericLiteral = NumericLiteral;
    exports.ObjectExpression = ObjectExpression;
    exports.ParenthesizedExpression = ParenthesizedExpression;
    exports.RegExpLiteral = RegExpLiteral;
    exports.RestElement = RestElement;
    exports.SequenceExpression = SequenceExpression;
    exports.StringLiteral = StringLiteral;
    exports.TSAsExpression = TSAsExpression;
    exports.TSNonNullExpression = TSNonNullExpression;
    exports.TaggedTemplateExpression = TaggedTemplateExpression;
    exports.TemplateLiteral = TemplateLiteral;
    exports.TypeCastExpression = TypeCastExpression;
    exports.UnaryExpression = UnaryExpression;
    exports.UpdateExpression = UpdateExpression;
    exports.VariableDeclarator = VariableDeclarator;
    var _t = t$d;
    var _infererReference = requireInfererReference$1();
    var _util = requireUtil$1();
    const {
      BOOLEAN_BINARY_OPERATORS: BOOLEAN_BINARY_OPERATORS,
      BOOLEAN_UNARY_OPERATORS: BOOLEAN_UNARY_OPERATORS,
      NUMBER_BINARY_OPERATORS: NUMBER_BINARY_OPERATORS,
      NUMBER_UNARY_OPERATORS: NUMBER_UNARY_OPERATORS,
      STRING_UNARY_OPERATORS: STRING_UNARY_OPERATORS,
      anyTypeAnnotation: anyTypeAnnotation,
      arrayTypeAnnotation: arrayTypeAnnotation,
      booleanTypeAnnotation: booleanTypeAnnotation,
      buildMatchMemberExpression: buildMatchMemberExpression,
      genericTypeAnnotation: genericTypeAnnotation,
      identifier: identifier,
      nullLiteralTypeAnnotation: nullLiteralTypeAnnotation,
      numberTypeAnnotation: numberTypeAnnotation,
      stringTypeAnnotation: stringTypeAnnotation,
      tupleTypeAnnotation: tupleTypeAnnotation,
      unionTypeAnnotation: unionTypeAnnotation,
      voidTypeAnnotation: voidTypeAnnotation,
      isIdentifier: isIdentifier,
    } = _t;
    function VariableDeclarator() {
      if (!this.get('id').isIdentifier()) return;
      return this.get('init').getTypeAnnotation();
    }
    function TypeCastExpression(node) {
      return node.typeAnnotation;
    }
    TypeCastExpression.validParent = true;
    function TSAsExpression(node) {
      return node.typeAnnotation;
    }
    TSAsExpression.validParent = true;
    function TSNonNullExpression() {
      return this.get('expression').getTypeAnnotation();
    }
    function NewExpression(node) {
      if (node.callee.type === 'Identifier') {
        return genericTypeAnnotation(node.callee);
      }
    }
    function TemplateLiteral() {
      return stringTypeAnnotation();
    }
    function UnaryExpression(node) {
      const operator = node.operator;
      if (operator === 'void') {
        return voidTypeAnnotation();
      } else if (NUMBER_UNARY_OPERATORS.includes(operator)) {
        return numberTypeAnnotation();
      } else if (STRING_UNARY_OPERATORS.includes(operator)) {
        return stringTypeAnnotation();
      } else if (BOOLEAN_UNARY_OPERATORS.includes(operator)) {
        return booleanTypeAnnotation();
      }
    }
    function BinaryExpression(node) {
      const operator = node.operator;
      if (NUMBER_BINARY_OPERATORS.includes(operator)) {
        return numberTypeAnnotation();
      } else if (BOOLEAN_BINARY_OPERATORS.includes(operator)) {
        return booleanTypeAnnotation();
      } else if (operator === '+') {
        const right = this.get('right');
        const left = this.get('left');
        if (left.isBaseType('number') && right.isBaseType('number')) {
          return numberTypeAnnotation();
        } else if (left.isBaseType('string') || right.isBaseType('string')) {
          return stringTypeAnnotation();
        }
        return unionTypeAnnotation([
          stringTypeAnnotation(),
          numberTypeAnnotation(),
        ]);
      }
    }
    function LogicalExpression() {
      const argumentTypes = [
        this.get('left').getTypeAnnotation(),
        this.get('right').getTypeAnnotation(),
      ];
      return (0, _util.createUnionType)(argumentTypes);
    }
    function ConditionalExpression() {
      const argumentTypes = [
        this.get('consequent').getTypeAnnotation(),
        this.get('alternate').getTypeAnnotation(),
      ];
      return (0, _util.createUnionType)(argumentTypes);
    }
    function SequenceExpression() {
      return this.get('expressions').pop().getTypeAnnotation();
    }
    function ParenthesizedExpression() {
      return this.get('expression').getTypeAnnotation();
    }
    function AssignmentExpression() {
      return this.get('right').getTypeAnnotation();
    }
    function UpdateExpression(node) {
      const operator = node.operator;
      if (operator === '++' || operator === '--') {
        return numberTypeAnnotation();
      }
    }
    function StringLiteral() {
      return stringTypeAnnotation();
    }
    function NumericLiteral() {
      return numberTypeAnnotation();
    }
    function BooleanLiteral() {
      return booleanTypeAnnotation();
    }
    function NullLiteral() {
      return nullLiteralTypeAnnotation();
    }
    function RegExpLiteral() {
      return genericTypeAnnotation(identifier('RegExp'));
    }
    function ObjectExpression() {
      return genericTypeAnnotation(identifier('Object'));
    }
    function ArrayExpression() {
      return genericTypeAnnotation(identifier('Array'));
    }
    function RestElement() {
      return ArrayExpression();
    }
    RestElement.validParent = true;
    function Func() {
      return genericTypeAnnotation(identifier('Function'));
    }
    const isArrayFrom = buildMatchMemberExpression('Array.from');
    const isObjectKeys = buildMatchMemberExpression('Object.keys');
    const isObjectValues = buildMatchMemberExpression('Object.values');
    const isObjectEntries = buildMatchMemberExpression('Object.entries');
    function CallExpression() {
      const {callee: callee} = this.node;
      if (isObjectKeys(callee)) {
        return arrayTypeAnnotation(stringTypeAnnotation());
      } else if (
        isArrayFrom(callee) ||
        isObjectValues(callee) ||
        isIdentifier(callee, {name: 'Array'})
      ) {
        return arrayTypeAnnotation(anyTypeAnnotation());
      } else if (isObjectEntries(callee)) {
        return arrayTypeAnnotation(
          tupleTypeAnnotation([stringTypeAnnotation(), anyTypeAnnotation()])
        );
      }
      return resolveCall(this.get('callee'));
    }
    function TaggedTemplateExpression() {
      return resolveCall(this.get('tag'));
    }
    function resolveCall(callee) {
      callee = callee.resolve();
      if (callee.isFunction()) {
        const {node: node} = callee;
        if (node.async) {
          if (node.generator) {
            return genericTypeAnnotation(identifier('AsyncIterator'));
          } else {
            return genericTypeAnnotation(identifier('Promise'));
          }
        } else {
          if (node.generator) {
            return genericTypeAnnotation(identifier('Iterator'));
          } else if (callee.node.returnType) {
            return callee.node.returnType;
          } else;
        }
      }
    }
  })(inferers$1);
  return inferers$1;
}
var hasRequiredInference$1;
function requireInference$1() {
  if (hasRequiredInference$1) return inference$1;
  hasRequiredInference$1 = 1;
  Object.defineProperty(inference$1, '__esModule', {value: true});
  inference$1._getTypeAnnotation = _getTypeAnnotation;
  inference$1.baseTypeStrictlyMatches = baseTypeStrictlyMatches;
  inference$1.couldBeBaseType = couldBeBaseType;
  inference$1.getTypeAnnotation = getTypeAnnotation;
  inference$1.isBaseType = isBaseType;
  inference$1.isGenericType = isGenericType;
  var inferers = requireInferers$1();
  var _t = t$d;
  const {
    anyTypeAnnotation: anyTypeAnnotation,
    isAnyTypeAnnotation: isAnyTypeAnnotation,
    isArrayTypeAnnotation: isArrayTypeAnnotation,
    isBooleanTypeAnnotation: isBooleanTypeAnnotation,
    isEmptyTypeAnnotation: isEmptyTypeAnnotation,
    isFlowBaseAnnotation: isFlowBaseAnnotation,
    isGenericTypeAnnotation: isGenericTypeAnnotation,
    isIdentifier: isIdentifier,
    isMixedTypeAnnotation: isMixedTypeAnnotation,
    isNumberTypeAnnotation: isNumberTypeAnnotation,
    isStringTypeAnnotation: isStringTypeAnnotation,
    isTSArrayType: isTSArrayType,
    isTSTypeAnnotation: isTSTypeAnnotation,
    isTSTypeReference: isTSTypeReference,
    isTupleTypeAnnotation: isTupleTypeAnnotation,
    isTypeAnnotation: isTypeAnnotation,
    isUnionTypeAnnotation: isUnionTypeAnnotation,
    isVoidTypeAnnotation: isVoidTypeAnnotation,
    stringTypeAnnotation: stringTypeAnnotation,
    voidTypeAnnotation: voidTypeAnnotation,
  } = _t;
  function getTypeAnnotation() {
    let type = this.getData('typeAnnotation');
    if (type != null) {
      return type;
    }
    type = _getTypeAnnotation.call(this) || anyTypeAnnotation();
    if (isTypeAnnotation(type) || isTSTypeAnnotation(type)) {
      type = type.typeAnnotation;
    }
    this.setData('typeAnnotation', type);
    return type;
  }
  const typeAnnotationInferringNodes = new WeakSet();
  function _getTypeAnnotation() {
    const node = this.node;
    if (!node) {
      if (this.key === 'init' && this.parentPath.isVariableDeclarator()) {
        const declar = this.parentPath.parentPath;
        const declarParent = declar.parentPath;
        if (declar.key === 'left' && declarParent.isForInStatement()) {
          return stringTypeAnnotation();
        }
        if (declar.key === 'left' && declarParent.isForOfStatement()) {
          return anyTypeAnnotation();
        }
        return voidTypeAnnotation();
      } else {
        return;
      }
    }
    if (node.typeAnnotation) {
      return node.typeAnnotation;
    }
    if (typeAnnotationInferringNodes.has(node)) {
      return;
    }
    typeAnnotationInferringNodes.add(node);
    try {
      var _inferer;
      let inferer = inferers[node.type];
      if (inferer) {
        return inferer.call(this, node);
      }
      inferer = inferers[this.parentPath.type];
      if ((_inferer = inferer) != null && _inferer.validParent) {
        return this.parentPath.getTypeAnnotation();
      }
    } finally {
      typeAnnotationInferringNodes.delete(node);
    }
  }
  function isBaseType(baseName, soft) {
    return _isBaseType(baseName, this.getTypeAnnotation(), soft);
  }
  function _isBaseType(baseName, type, soft) {
    if (baseName === 'string') {
      return isStringTypeAnnotation(type);
    } else if (baseName === 'number') {
      return isNumberTypeAnnotation(type);
    } else if (baseName === 'boolean') {
      return isBooleanTypeAnnotation(type);
    } else if (baseName === 'any') {
      return isAnyTypeAnnotation(type);
    } else if (baseName === 'mixed') {
      return isMixedTypeAnnotation(type);
    } else if (baseName === 'empty') {
      return isEmptyTypeAnnotation(type);
    } else if (baseName === 'void') {
      return isVoidTypeAnnotation(type);
    } else {
      if (soft) {
        return false;
      } else {
        throw new Error(`Unknown base type ${baseName}`);
      }
    }
  }
  function couldBeBaseType(name) {
    const type = this.getTypeAnnotation();
    if (isAnyTypeAnnotation(type)) return true;
    if (isUnionTypeAnnotation(type)) {
      for (const type2 of type.types) {
        if (isAnyTypeAnnotation(type2) || _isBaseType(name, type2, true)) {
          return true;
        }
      }
      return false;
    } else {
      return _isBaseType(name, type, true);
    }
  }
  function baseTypeStrictlyMatches(rightArg) {
    const left = this.getTypeAnnotation();
    const right = rightArg.getTypeAnnotation();
    if (!isAnyTypeAnnotation(left) && isFlowBaseAnnotation(left)) {
      return right.type === left.type;
    }
    return false;
  }
  function isGenericType(genericName) {
    const type = this.getTypeAnnotation();
    if (genericName === 'Array') {
      if (
        isTSArrayType(type) ||
        isArrayTypeAnnotation(type) ||
        isTupleTypeAnnotation(type)
      ) {
        return true;
      }
    }
    return (
      (isGenericTypeAnnotation(type) &&
        isIdentifier(type.id, {name: genericName})) ||
      (isTSTypeReference(type) &&
        isIdentifier(type.typeName, {name: genericName}))
    );
  }
  return inference$1;
}
var replacement$1 = {};
var lib$l = {};
var picocolors = {exports: {}};
var hasRequiredPicocolors;
function requirePicocolors() {
  if (hasRequiredPicocolors) return picocolors.exports;
  hasRequiredPicocolors = 1;
  let tty = require$$0$2;
  let isColorSupported =
    !('NO_COLOR' in process.env || process.argv.includes('--no-color')) &&
    ('FORCE_COLOR' in process.env ||
      process.argv.includes('--color') ||
      process.platform === 'win32' ||
      (tty.isatty(1) && process.env.TERM !== 'dumb') ||
      'CI' in process.env);
  let formatter =
    (open, close, replace = open) =>
    input => {
      let string = '' + input;
      let index = string.indexOf(close, open.length);
      return ~index
        ? open + replaceClose(string, close, replace, index) + close
        : open + string + close;
    };
  let replaceClose = (string, close, replace, index) => {
    let start = string.substring(0, index) + replace;
    let end = string.substring(index + close.length);
    let nextIndex = end.indexOf(close);
    return ~nextIndex
      ? start + replaceClose(end, close, replace, nextIndex)
      : start + end;
  };
  let createColors = (enabled = isColorSupported) => ({
    isColorSupported: enabled,
    reset: enabled ? s => `[0m${s}[0m` : String,
    bold: enabled ? formatter('[1m', '[22m', '[22m[1m') : String,
    dim: enabled ? formatter('[2m', '[22m', '[22m[2m') : String,
    italic: enabled ? formatter('[3m', '[23m') : String,
    underline: enabled ? formatter('[4m', '[24m') : String,
    inverse: enabled ? formatter('[7m', '[27m') : String,
    hidden: enabled ? formatter('[8m', '[28m') : String,
    strikethrough: enabled ? formatter('[9m', '[29m') : String,
    black: enabled ? formatter('[30m', '[39m') : String,
    red: enabled ? formatter('[31m', '[39m') : String,
    green: enabled ? formatter('[32m', '[39m') : String,
    yellow: enabled ? formatter('[33m', '[39m') : String,
    blue: enabled ? formatter('[34m', '[39m') : String,
    magenta: enabled ? formatter('[35m', '[39m') : String,
    cyan: enabled ? formatter('[36m', '[39m') : String,
    white: enabled ? formatter('[37m', '[39m') : String,
    gray: enabled ? formatter('[90m', '[39m') : String,
    bgBlack: enabled ? formatter('[40m', '[49m') : String,
    bgRed: enabled ? formatter('[41m', '[49m') : String,
    bgGreen: enabled ? formatter('[42m', '[49m') : String,
    bgYellow: enabled ? formatter('[43m', '[49m') : String,
    bgBlue: enabled ? formatter('[44m', '[49m') : String,
    bgMagenta: enabled ? formatter('[45m', '[49m') : String,
    bgCyan: enabled ? formatter('[46m', '[49m') : String,
    bgWhite: enabled ? formatter('[47m', '[49m') : String,
  });
  picocolors.exports = createColors();
  picocolors.exports.createColors = createColors;
  return picocolors.exports;
}
var jsTokens = {};
var hasRequiredJsTokens;
function requireJsTokens() {
  if (hasRequiredJsTokens) return jsTokens;
  hasRequiredJsTokens = 1;
  Object.defineProperty(jsTokens, '__esModule', {value: true});
  jsTokens.default =
    /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
  jsTokens.matchToToken = function (match) {
    var token = {type: 'invalid', value: match[0], closed: undefined};
    if (match[1])
      (token.type = 'string'), (token.closed = !!(match[3] || match[4]));
    else if (match[5]) token.type = 'comment';
    else if (match[6]) (token.type = 'comment'), (token.closed = !!match[7]);
    else if (match[8]) token.type = 'regex';
    else if (match[9]) token.type = 'number';
    else if (match[10]) token.type = 'name';
    else if (match[11]) token.type = 'punctuator';
    else if (match[12]) token.type = 'whitespace';
    return token;
  };
  return jsTokens;
}
var lib$k = {};
var identifier$2 = {};
var hasRequiredIdentifier$2;
function requireIdentifier$2() {
  if (hasRequiredIdentifier$2) return identifier$2;
  hasRequiredIdentifier$2 = 1;
  Object.defineProperty(identifier$2, '__esModule', {value: true});
  identifier$2.isIdentifierChar = isIdentifierChar;
  identifier$2.isIdentifierName = isIdentifierName;
  identifier$2.isIdentifierStart = isIdentifierStart;
  let nonASCIIidentifierStartChars =
    'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲊᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟍꟐꟑꟓꟕ-Ƛꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
  let nonASCIIidentifierChars =
    '·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛ࢗ-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･';
  const nonASCIIidentifierStart = new RegExp(
    '[' + nonASCIIidentifierStartChars + ']'
  );
  const nonASCIIidentifier = new RegExp(
    '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
  );
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  const astralIdentifierStartCodes = [
    0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48,
    48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5,
    39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 4, 51, 13,
    310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3,
    22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16,
    3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17,
    111, 72, 56, 50, 14, 50, 14, 35, 39, 27, 10, 22, 251, 41, 7, 1, 17, 2, 60,
    28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33,
    24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2,
    24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6,
    2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 31, 9, 2, 0, 3, 0, 2, 37, 2, 0, 26, 0, 2, 0,
    45, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0,
    60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2,
    23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12,
    45, 20, 0, 19, 72, 200, 32, 32, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2,
    37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0,
    80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 26, 3994, 6, 582,
    6842, 29, 1763, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18,
    433, 44, 212, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 42,
    9, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309,
    106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2,
    0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3,
    24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7,
    1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27,
    229, 29, 3, 0, 496, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2,
    26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2,
    2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2,
    3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3,
    5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191,
  ];
  const astralIdentifierCodes = [
    509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1,
    574, 3, 9, 9, 7, 9, 32, 4, 318, 1, 80, 3, 71, 10, 50, 3, 123, 2, 54, 14, 32,
    10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13,
    2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2,
    6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 68, 8, 2, 0, 3, 0, 2, 3, 2, 4, 2,
    0, 15, 1, 83, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16,
    16, 9, 82, 12, 9, 9, 7, 19, 58, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3,
    3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10,
    47, 15, 343, 9, 54, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6,
    2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14,
    10, 5350, 0, 7, 14, 11465, 27, 2343, 9, 87, 9, 39, 4, 60, 6, 26, 9, 535, 9,
    470, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4178, 9, 519, 45, 3, 22, 543,
    4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0,
    23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357,
    0, 62, 13, 499, 13, 245, 1, 2, 9, 726, 6, 110, 6, 6, 9, 4759, 9, 787719,
    239,
  ];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length; i < length; i += 2) {
      pos += set[i];
      if (pos > code) return false;
      pos += set[i + 1];
      if (pos >= code) return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65) return code === 36;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return (
        code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
      );
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48) return code === 36;
    if (code < 58) return true;
    if (code < 65) return false;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return (
      isInAstralSet(code, astralIdentifierStartCodes) ||
      isInAstralSet(code, astralIdentifierCodes)
    );
  }
  function isIdentifierName(name) {
    let isFirst = true;
    for (let i = 0; i < name.length; i++) {
      let cp = name.charCodeAt(i);
      if ((cp & 64512) === 55296 && i + 1 < name.length) {
        const trail = name.charCodeAt(++i);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      if (isFirst) {
        isFirst = false;
        if (!isIdentifierStart(cp)) {
          return false;
        }
      } else if (!isIdentifierChar(cp)) {
        return false;
      }
    }
    return !isFirst;
  }
  return identifier$2;
}
var keyword$2 = {};
var hasRequiredKeyword$2;
function requireKeyword$2() {
  if (hasRequiredKeyword$2) return keyword$2;
  hasRequiredKeyword$2 = 1;
  Object.defineProperty(keyword$2, '__esModule', {value: true});
  keyword$2.isKeyword = isKeyword;
  keyword$2.isReservedWord = isReservedWord;
  keyword$2.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
  keyword$2.isStrictBindReservedWord = isStrictBindReservedWord;
  keyword$2.isStrictReservedWord = isStrictReservedWord;
  const reservedWords = {
    keyword: [
      'break',
      'case',
      'catch',
      'continue',
      'debugger',
      'default',
      'do',
      'else',
      'finally',
      'for',
      'function',
      'if',
      'return',
      'switch',
      'throw',
      'try',
      'var',
      'const',
      'while',
      'with',
      'new',
      'this',
      'super',
      'class',
      'extends',
      'export',
      'import',
      'null',
      'true',
      'false',
      'in',
      'instanceof',
      'typeof',
      'void',
      'delete',
    ],
    strict: [
      'implements',
      'interface',
      'let',
      'package',
      'private',
      'protected',
      'public',
      'static',
      'yield',
    ],
    strictBind: ['eval', 'arguments'],
  };
  const keywords = new Set(reservedWords.keyword);
  const reservedWordsStrictSet = new Set(reservedWords.strict);
  const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return (inModule && word === 'await') || word === 'enum';
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return (
      isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
    );
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  return keyword$2;
}
var hasRequiredLib$l;
function requireLib$l() {
  if (hasRequiredLib$l) return lib$k;
  hasRequiredLib$l = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    Object.defineProperty(exports, 'isIdentifierChar', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierChar;
      },
    });
    Object.defineProperty(exports, 'isIdentifierName', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierName;
      },
    });
    Object.defineProperty(exports, 'isIdentifierStart', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierStart;
      },
    });
    Object.defineProperty(exports, 'isKeyword', {
      enumerable: true,
      get: function () {
        return _keyword.isKeyword;
      },
    });
    Object.defineProperty(exports, 'isReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictBindOnlyReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictBindOnlyReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictBindReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictBindReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictReservedWord;
      },
    });
    var _identifier = requireIdentifier$2();
    var _keyword = requireKeyword$2();
  })(lib$k);
  return lib$k;
}
var hasRequiredLib$k;
function requireLib$k() {
  if (hasRequiredLib$k) return lib$l;
  hasRequiredLib$k = 1;
  Object.defineProperty(lib$l, '__esModule', {value: true});
  var picocolors = requirePicocolors();
  var jsTokens = requireJsTokens();
  var helperValidatorIdentifier = requireLib$l();
  function isColorSupported() {
    return typeof process === 'object' &&
      (process.env.FORCE_COLOR === '0' || process.env.FORCE_COLOR === 'false')
      ? false
      : picocolors.isColorSupported;
  }
  const compose = (f, g) => v => f(g(v));
  function buildDefs(colors) {
    return {
      keyword: colors.cyan,
      capitalized: colors.yellow,
      jsxIdentifier: colors.yellow,
      punctuator: colors.yellow,
      number: colors.magenta,
      string: colors.green,
      regex: colors.magenta,
      comment: colors.gray,
      invalid: compose(compose(colors.white, colors.bgRed), colors.bold),
      gutter: colors.gray,
      marker: compose(colors.red, colors.bold),
      message: compose(colors.red, colors.bold),
      reset: colors.reset,
    };
  }
  const defsOn = buildDefs(picocolors.createColors(true));
  const defsOff = buildDefs(picocolors.createColors(false));
  function getDefs(enabled) {
    return enabled ? defsOn : defsOff;
  }
  const sometimesKeywords = new Set([
    'as',
    'async',
    'from',
    'get',
    'of',
    'set',
  ]);
  const NEWLINE$1 = /\r\n|[\n\r\u2028\u2029]/;
  const BRACKET = /^[()[\]{}]$/;
  let tokenize;
  {
    const JSX_TAG = /^[a-z][\w-]*$/i;
    const getTokenType = function (token, offset, text) {
      if (token.type === 'name') {
        if (
          helperValidatorIdentifier.isKeyword(token.value) ||
          helperValidatorIdentifier.isStrictReservedWord(token.value, true) ||
          sometimesKeywords.has(token.value)
        ) {
          return 'keyword';
        }
        if (
          JSX_TAG.test(token.value) &&
          (text[offset - 1] === '<' || text.slice(offset - 2, offset) === '</')
        ) {
          return 'jsxIdentifier';
        }
        if (token.value[0] !== token.value[0].toLowerCase()) {
          return 'capitalized';
        }
      }
      if (token.type === 'punctuator' && BRACKET.test(token.value)) {
        return 'bracket';
      }
      if (
        token.type === 'invalid' &&
        (token.value === '@' || token.value === '#')
      ) {
        return 'punctuator';
      }
      return token.type;
    };
    tokenize = function* (text) {
      let match;
      while ((match = jsTokens.default.exec(text))) {
        const token = jsTokens.matchToToken(match);
        yield {
          type: getTokenType(token, match.index, text),
          value: token.value,
        };
      }
    };
  }
  function highlight(text) {
    if (text === '') return '';
    const defs = getDefs(true);
    let highlighted = '';
    for (const {type: type, value: value} of tokenize(text)) {
      if (type in defs) {
        highlighted += value
          .split(NEWLINE$1)
          .map(str => defs[type](str))
          .join('\n');
      } else {
        highlighted += value;
      }
    }
    return highlighted;
  }
  let deprecationWarningShown = false;
  const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  function getMarkerLines(loc, source, opts) {
    const startLoc = Object.assign({column: 0, line: -1}, loc.start);
    const endLoc = Object.assign({}, startLoc, loc.end);
    const {linesAbove: linesAbove = 2, linesBelow: linesBelow = 3} = opts || {};
    const startLine = startLoc.line;
    const startColumn = startLoc.column;
    const endLine = endLoc.line;
    const endColumn = endLoc.column;
    let start = Math.max(startLine - (linesAbove + 1), 0);
    let end = Math.min(source.length, endLine + linesBelow);
    if (startLine === -1) {
      start = 0;
    }
    if (endLine === -1) {
      end = source.length;
    }
    const lineDiff = endLine - startLine;
    const markerLines = {};
    if (lineDiff) {
      for (let i = 0; i <= lineDiff; i++) {
        const lineNumber = i + startLine;
        if (!startColumn) {
          markerLines[lineNumber] = true;
        } else if (i === 0) {
          const sourceLength = source[lineNumber - 1].length;
          markerLines[lineNumber] = [
            startColumn,
            sourceLength - startColumn + 1,
          ];
        } else if (i === lineDiff) {
          markerLines[lineNumber] = [0, endColumn];
        } else {
          const sourceLength = source[lineNumber - i].length;
          markerLines[lineNumber] = [0, sourceLength];
        }
      }
    } else {
      if (startColumn === endColumn) {
        if (startColumn) {
          markerLines[startLine] = [startColumn, 0];
        } else {
          markerLines[startLine] = true;
        }
      } else {
        markerLines[startLine] = [startColumn, endColumn - startColumn];
      }
    }
    return {start: start, end: end, markerLines: markerLines};
  }
  function codeFrameColumns(rawLines, loc, opts = {}) {
    const shouldHighlight =
      opts.forceColor || (isColorSupported() && opts.highlightCode);
    const defs = getDefs(shouldHighlight);
    const lines = rawLines.split(NEWLINE);
    const {
      start: start,
      end: end,
      markerLines: markerLines,
    } = getMarkerLines(loc, lines, opts);
    const hasColumns = loc.start && typeof loc.start.column === 'number';
    const numberMaxWidth = String(end).length;
    const highlightedLines = shouldHighlight ? highlight(rawLines) : rawLines;
    let frame = highlightedLines
      .split(NEWLINE, end)
      .slice(start, end)
      .map((line, index) => {
        const number = start + 1 + index;
        const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
        const gutter = ` ${paddedNumber} |`;
        const hasMarker = markerLines[number];
        const lastMarkerLine = !markerLines[number + 1];
        if (hasMarker) {
          let markerLine = '';
          if (Array.isArray(hasMarker)) {
            const markerSpacing = line
              .slice(0, Math.max(hasMarker[0] - 1, 0))
              .replace(/[^\t]/g, ' ');
            const numberOfMarkers = hasMarker[1] || 1;
            markerLine = [
              '\n ',
              defs.gutter(gutter.replace(/\d/g, ' ')),
              ' ',
              markerSpacing,
              defs.marker('^').repeat(numberOfMarkers),
            ].join('');
            if (lastMarkerLine && opts.message) {
              markerLine += ' ' + defs.message(opts.message);
            }
          }
          return [
            defs.marker('>'),
            defs.gutter(gutter),
            line.length > 0 ? ` ${line}` : '',
            markerLine,
          ].join('');
        } else {
          return ` ${defs.gutter(gutter)}${line.length > 0 ? ` ${line}` : ''}`;
        }
      })
      .join('\n');
    if (opts.message && !hasColumns) {
      frame = `${' '.repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
    }
    if (shouldHighlight) {
      return defs.reset(frame);
    } else {
      return frame;
    }
  }
  function index(rawLines, lineNumber, colNumber, opts = {}) {
    if (!deprecationWarningShown) {
      deprecationWarningShown = true;
      const message =
        'Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.';
      if (process.emitWarning) {
        process.emitWarning(message, 'DeprecationWarning');
      } else {
        const deprecationError = new Error(message);
        deprecationError.name = 'DeprecationWarning';
        console.warn(new Error(message));
      }
    }
    colNumber = Math.max(colNumber, 0);
    const location = {start: {column: colNumber, line: lineNumber}};
    return codeFrameColumns(rawLines, location, opts);
  }
  lib$l.codeFrameColumns = codeFrameColumns;
  lib$l.default = index;
  lib$l.highlight = highlight;
  return lib$l;
}
var modification$1 = {};
var hoister$1 = {};
var hasRequiredHoister$1;
function requireHoister$1() {
  if (hasRequiredHoister$1) return hoister$1;
  hasRequiredHoister$1 = 1;
  Object.defineProperty(hoister$1, '__esModule', {value: true});
  hoister$1.default = void 0;
  var _t = t$d;
  var _t2 = _t;
  const {react: react} = _t;
  const {
    cloneNode: cloneNode,
    jsxExpressionContainer: jsxExpressionContainer,
    variableDeclaration: variableDeclaration,
    variableDeclarator: variableDeclarator,
  } = _t2;
  const referenceVisitor = {
    ReferencedIdentifier(path, state) {
      if (
        path.isJSXIdentifier() &&
        react.isCompatTag(path.node.name) &&
        !path.parentPath.isJSXMemberExpression()
      ) {
        return;
      }
      if (path.node.name === 'this') {
        let scope = path.scope;
        do {
          if (
            scope.path.isFunction() &&
            !scope.path.isArrowFunctionExpression()
          ) {
            break;
          }
        } while ((scope = scope.parent));
        if (scope) state.breakOnScopePaths.push(scope.path);
      }
      const binding = path.scope.getBinding(path.node.name);
      if (!binding) return;
      for (const violation of binding.constantViolations) {
        if (violation.scope !== binding.path.scope) {
          state.mutableBinding = true;
          path.stop();
          return;
        }
      }
      if (binding !== state.scope.getBinding(path.node.name)) return;
      state.bindings[path.node.name] = binding;
    },
  };
  class PathHoister {
    constructor(path, scope) {
      this.breakOnScopePaths = void 0;
      this.bindings = void 0;
      this.mutableBinding = void 0;
      this.scopes = void 0;
      this.scope = void 0;
      this.path = void 0;
      this.attachAfter = void 0;
      this.breakOnScopePaths = [];
      this.bindings = {};
      this.mutableBinding = false;
      this.scopes = [];
      this.scope = scope;
      this.path = path;
      this.attachAfter = false;
    }
    isCompatibleScope(scope) {
      for (const key of Object.keys(this.bindings)) {
        const binding = this.bindings[key];
        if (!scope.bindingIdentifierEquals(key, binding.identifier)) {
          return false;
        }
      }
      return true;
    }
    getCompatibleScopes() {
      let scope = this.path.scope;
      do {
        if (this.isCompatibleScope(scope)) {
          this.scopes.push(scope);
        } else {
          break;
        }
        if (this.breakOnScopePaths.includes(scope.path)) {
          break;
        }
      } while ((scope = scope.parent));
    }
    getAttachmentPath() {
      let path = this._getAttachmentPath();
      if (!path) return;
      let targetScope = path.scope;
      if (targetScope.path === path) {
        targetScope = path.scope.parent;
      }
      if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
        for (const name of Object.keys(this.bindings)) {
          if (!targetScope.hasOwnBinding(name)) continue;
          const binding = this.bindings[name];
          if (binding.kind === 'param' || binding.path.parentKey === 'params') {
            continue;
          }
          const bindingParentPath = this.getAttachmentParentForPath(
            binding.path
          );
          if (bindingParentPath.key >= path.key) {
            this.attachAfter = true;
            path = binding.path;
            for (const violationPath of binding.constantViolations) {
              if (
                this.getAttachmentParentForPath(violationPath).key > path.key
              ) {
                path = violationPath;
              }
            }
          }
        }
      }
      return path;
    }
    _getAttachmentPath() {
      const scopes = this.scopes;
      const scope = scopes.pop();
      if (!scope) return;
      if (scope.path.isFunction()) {
        if (this.hasOwnParamBindings(scope)) {
          if (this.scope === scope) return;
          const bodies = scope.path.get('body').get('body');
          for (let i = 0; i < bodies.length; i++) {
            if (bodies[i].node._blockHoist) continue;
            return bodies[i];
          }
        } else {
          return this.getNextScopeAttachmentParent();
        }
      } else if (scope.path.isProgram()) {
        return this.getNextScopeAttachmentParent();
      }
    }
    getNextScopeAttachmentParent() {
      const scope = this.scopes.pop();
      if (scope) return this.getAttachmentParentForPath(scope.path);
    }
    getAttachmentParentForPath(path) {
      do {
        if (
          !path.parentPath ||
          (Array.isArray(path.container) && path.isStatement())
        ) {
          return path;
        }
      } while ((path = path.parentPath));
    }
    hasOwnParamBindings(scope) {
      for (const name of Object.keys(this.bindings)) {
        if (!scope.hasOwnBinding(name)) continue;
        const binding = this.bindings[name];
        if (binding.kind === 'param' && binding.constant) return true;
      }
      return false;
    }
    run() {
      this.path.traverse(referenceVisitor, this);
      if (this.mutableBinding) return;
      this.getCompatibleScopes();
      const attachTo = this.getAttachmentPath();
      if (!attachTo) return;
      if (attachTo.getFunctionParent() === this.path.getFunctionParent())
        return;
      let uid = attachTo.scope.generateUidIdentifier('ref');
      const declarator = variableDeclarator(uid, this.path.node);
      const insertFn = this.attachAfter ? 'insertAfter' : 'insertBefore';
      const [attached] = attachTo[insertFn]([
        attachTo.isVariableDeclarator()
          ? declarator
          : variableDeclaration('var', [declarator]),
      ]);
      const parent = this.path.parentPath;
      if (
        parent.isJSXElement() &&
        this.path.container === parent.node.children
      ) {
        uid = jsxExpressionContainer(uid);
      }
      this.path.replaceWith(cloneNode(uid));
      return attachTo.isVariableDeclarator()
        ? attached.get('init')
        : attached.get('declarations.0.init');
    }
  }
  hoister$1.default = PathHoister;
  return hoister$1;
}
var removal$1 = {};
var removalHooks$1 = {};
var hasRequiredRemovalHooks$1;
function requireRemovalHooks$1() {
  if (hasRequiredRemovalHooks$1) return removalHooks$1;
  hasRequiredRemovalHooks$1 = 1;
  Object.defineProperty(removalHooks$1, '__esModule', {value: true});
  removalHooks$1.hooks = void 0;
  removalHooks$1.hooks = [
    function (self, parent) {
      const removeParent =
        (self.key === 'test' && (parent.isWhile() || parent.isSwitchCase())) ||
        (self.key === 'declaration' && parent.isExportDeclaration()) ||
        (self.key === 'body' && parent.isLabeledStatement()) ||
        (self.listKey === 'declarations' &&
          parent.isVariableDeclaration() &&
          parent.node.declarations.length === 1) ||
        (self.key === 'expression' && parent.isExpressionStatement());
      if (removeParent) {
        parent.remove();
        return true;
      }
    },
    function (self, parent) {
      if (
        parent.isSequenceExpression() &&
        parent.node.expressions.length === 1
      ) {
        parent.replaceWith(parent.node.expressions[0]);
        return true;
      }
    },
    function (self, parent) {
      if (parent.isBinary()) {
        if (self.key === 'left') {
          parent.replaceWith(parent.node.right);
        } else {
          parent.replaceWith(parent.node.left);
        }
        return true;
      }
    },
    function (self, parent) {
      if (
        (parent.isIfStatement() && self.key === 'consequent') ||
        (self.key === 'body' &&
          (parent.isLoop() || parent.isArrowFunctionExpression()))
      ) {
        self.replaceWith({type: 'BlockStatement', body: []});
        return true;
      }
    },
  ];
  return removalHooks$1;
}
var hasRequiredRemoval$1;
function requireRemoval$1() {
  if (hasRequiredRemoval$1) return removal$1;
  hasRequiredRemoval$1 = 1;
  Object.defineProperty(removal$1, '__esModule', {value: true});
  removal$1._assertUnremoved = _assertUnremoved;
  removal$1._callRemovalHooks = _callRemovalHooks;
  removal$1._markRemoved = _markRemoved;
  removal$1._remove = _remove;
  removal$1._removeFromScope = _removeFromScope;
  removal$1.remove = remove;
  var _removalHooks = requireRemovalHooks$1();
  var _cache = requireCache$1();
  var _replacement = requireReplacement$1();
  var _index = requirePath$1();
  var _t = t$d;
  var _modification = requireModification$1();
  var _context = requireContext$2();
  const {getBindingIdentifiers: getBindingIdentifiers} = _t;
  function remove() {
    var _this$opts;
    _assertUnremoved.call(this);
    _context.resync.call(this);
    if (_callRemovalHooks.call(this)) {
      _markRemoved.call(this);
      return;
    }
    if (!((_this$opts = this.opts) != null && _this$opts.noScope)) {
      _removeFromScope.call(this);
    }
    this.shareCommentsWithSiblings();
    _remove.call(this);
    _markRemoved.call(this);
  }
  function _removeFromScope() {
    const bindings = getBindingIdentifiers(this.node, false, false, true);
    Object.keys(bindings).forEach(name => this.scope.removeBinding(name));
  }
  function _callRemovalHooks() {
    if (this.parentPath) {
      for (const fn of _removalHooks.hooks) {
        if (fn(this, this.parentPath)) return true;
      }
    }
  }
  function _remove() {
    if (Array.isArray(this.container)) {
      this.container.splice(this.key, 1);
      _modification.updateSiblingKeys.call(this, this.key, -1);
    } else {
      _replacement._replaceWith.call(this, null);
    }
  }
  function _markRemoved() {
    this._traverseFlags |= _index.SHOULD_SKIP | _index.REMOVED;
    if (this.parent) {
      (0, _cache.getCachedPaths)(this.hub, this.parent).delete(this.node);
    }
    this.node = null;
  }
  function _assertUnremoved() {
    if (this.removed) {
      throw this.buildCodeFrameError(
        'NodePath has been removed so is read-only.'
      );
    }
  }
  return removal$1;
}
var hasRequiredModification$1;
function requireModification$1() {
  if (hasRequiredModification$1) return modification$1;
  hasRequiredModification$1 = 1;
  Object.defineProperty(modification$1, '__esModule', {value: true});
  modification$1._containerInsert = _containerInsert;
  modification$1._containerInsertAfter = _containerInsertAfter;
  modification$1._containerInsertBefore = _containerInsertBefore;
  modification$1._verifyNodeList = _verifyNodeList;
  modification$1.insertAfter = insertAfter;
  modification$1.insertBefore = insertBefore;
  modification$1.pushContainer = pushContainer;
  modification$1.unshiftContainer = unshiftContainer;
  modification$1.updateSiblingKeys = updateSiblingKeys;
  var _cache = requireCache$1();
  var _hoister = requireHoister$1();
  var _index = requirePath$1();
  var _context = requireContext$2();
  var _removal = requireRemoval$1();
  var _t = t$d;
  const {
    arrowFunctionExpression: arrowFunctionExpression,
    assertExpression: assertExpression,
    assignmentExpression: assignmentExpression,
    blockStatement: blockStatement,
    callExpression: callExpression,
    cloneNode: cloneNode,
    expressionStatement: expressionStatement,
    isAssignmentExpression: isAssignmentExpression,
    isCallExpression: isCallExpression,
    isExportNamedDeclaration: isExportNamedDeclaration,
    isExpression: isExpression,
    isIdentifier: isIdentifier,
    isSequenceExpression: isSequenceExpression,
    isSuper: isSuper,
    thisExpression: thisExpression,
  } = _t;
  function insertBefore(nodes_) {
    _removal._assertUnremoved.call(this);
    const nodes = _verifyNodeList.call(this, nodes_);
    const {parentPath: parentPath, parent: parent} = this;
    if (
      parentPath.isExpressionStatement() ||
      parentPath.isLabeledStatement() ||
      isExportNamedDeclaration(parent) ||
      (parentPath.isExportDefaultDeclaration() && this.isDeclaration())
    ) {
      return parentPath.insertBefore(nodes);
    } else if (
      (this.isNodeType('Expression') && !this.isJSXElement()) ||
      (parentPath.isForStatement() && this.key === 'init')
    ) {
      if (this.node) nodes.push(this.node);
      return this.replaceExpressionWithStatements(nodes);
    } else if (Array.isArray(this.container)) {
      return _containerInsertBefore.call(this, nodes);
    } else if (this.isStatementOrBlock()) {
      const node = this.node;
      const shouldInsertCurrentNode =
        node && (!this.isExpressionStatement() || node.expression != null);
      this.replaceWith(blockStatement(shouldInsertCurrentNode ? [node] : []));
      return this.unshiftContainer('body', nodes);
    } else {
      throw new Error(
        "We don't know what to do with this node type. " +
          "We were previously a Statement but we can't fit in here?"
      );
    }
  }
  function _containerInsert(from, nodes) {
    updateSiblingKeys.call(this, from, nodes.length);
    const paths = [];
    this.container.splice(from, 0, ...nodes);
    for (let i = 0; i < nodes.length; i++) {
      var _this$context;
      const to = from + i;
      const path = this.getSibling(to);
      paths.push(path);
      if ((_this$context = this.context) != null && _this$context.queue) {
        _context.pushContext.call(path, this.context);
      }
    }
    const contexts = _context._getQueueContexts.call(this);
    for (const path of paths) {
      _context.setScope.call(path);
      path.debug('Inserted.');
      for (const context of contexts) {
        context.maybeQueue(path, true);
      }
    }
    return paths;
  }
  function _containerInsertBefore(nodes) {
    return _containerInsert.call(this, this.key, nodes);
  }
  function _containerInsertAfter(nodes) {
    return _containerInsert.call(this, this.key + 1, nodes);
  }
  const last = arr => arr[arr.length - 1];
  function isHiddenInSequenceExpression(path) {
    return (
      isSequenceExpression(path.parent) &&
      (last(path.parent.expressions) !== path.node ||
        isHiddenInSequenceExpression(path.parentPath))
    );
  }
  function isAlmostConstantAssignment(node, scope) {
    if (!isAssignmentExpression(node) || !isIdentifier(node.left)) {
      return false;
    }
    const blockScope = scope.getBlockParent();
    return (
      blockScope.hasOwnBinding(node.left.name) &&
      blockScope.getOwnBinding(node.left.name).constantViolations.length <= 1
    );
  }
  function insertAfter(nodes_) {
    _removal._assertUnremoved.call(this);
    if (this.isSequenceExpression()) {
      return last(this.get('expressions')).insertAfter(nodes_);
    }
    const nodes = _verifyNodeList.call(this, nodes_);
    const {parentPath: parentPath, parent: parent} = this;
    if (
      parentPath.isExpressionStatement() ||
      parentPath.isLabeledStatement() ||
      isExportNamedDeclaration(parent) ||
      (parentPath.isExportDefaultDeclaration() && this.isDeclaration())
    ) {
      return parentPath.insertAfter(
        nodes.map(node =>
          isExpression(node) ? expressionStatement(node) : node
        )
      );
    } else if (
      (this.isNodeType('Expression') &&
        !this.isJSXElement() &&
        !parentPath.isJSXElement()) ||
      (parentPath.isForStatement() && this.key === 'init')
    ) {
      const self = this;
      if (self.node) {
        const node = self.node;
        let {scope: scope} = this;
        if (scope.path.isPattern()) {
          assertExpression(node);
          self.replaceWith(
            callExpression(arrowFunctionExpression([], node), [])
          );
          self.get('callee.body').insertAfter(nodes);
          return [self];
        }
        if (isHiddenInSequenceExpression(self)) {
          nodes.unshift(node);
        } else if (isCallExpression(node) && isSuper(node.callee)) {
          nodes.unshift(node);
          nodes.push(thisExpression());
        } else if (isAlmostConstantAssignment(node, scope)) {
          nodes.unshift(node);
          nodes.push(cloneNode(node.left));
        } else if (scope.isPure(node, true)) {
          nodes.push(node);
        } else {
          if (parentPath.isMethod({computed: true, key: node})) {
            scope = scope.parent;
          }
          const temp = scope.generateDeclaredUidIdentifier();
          nodes.unshift(
            expressionStatement(
              assignmentExpression('=', cloneNode(temp), node)
            )
          );
          nodes.push(expressionStatement(cloneNode(temp)));
        }
      }
      return this.replaceExpressionWithStatements(nodes);
    } else if (Array.isArray(this.container)) {
      return _containerInsertAfter.call(this, nodes);
    } else if (this.isStatementOrBlock()) {
      const node = this.node;
      const shouldInsertCurrentNode =
        node && (!this.isExpressionStatement() || node.expression != null);
      this.replaceWith(blockStatement(shouldInsertCurrentNode ? [node] : []));
      return this.pushContainer('body', nodes);
    } else {
      throw new Error(
        "We don't know what to do with this node type. " +
          "We were previously a Statement but we can't fit in here?"
      );
    }
  }
  function updateSiblingKeys(fromIndex, incrementBy) {
    if (!this.parent) return;
    const paths = (0, _cache.getCachedPaths)(this.hub, this.parent) || [];
    for (const [, path] of paths) {
      if (
        typeof path.key === 'number' &&
        path.container === this.container &&
        path.key >= fromIndex
      ) {
        path.key += incrementBy;
      }
    }
  }
  function _verifyNodeList(nodes) {
    if (!nodes) {
      return [];
    }
    if (!Array.isArray(nodes)) {
      nodes = [nodes];
    }
    for (let i = 0; i < nodes.length; i++) {
      const node = nodes[i];
      let msg;
      if (!node) {
        msg = 'has falsy node';
      } else if (typeof node !== 'object') {
        msg = 'contains a non-object node';
      } else if (!node.type) {
        msg = 'without a type';
      } else if (node instanceof _index.default) {
        msg = 'has a NodePath when it expected a raw object';
      }
      if (msg) {
        const type = Array.isArray(node) ? 'array' : typeof node;
        throw new Error(
          `Node list ${msg} with the index of ${i} and type of ${type}`
        );
      }
    }
    return nodes;
  }
  function unshiftContainer(listKey, nodes) {
    _removal._assertUnremoved.call(this);
    nodes = _verifyNodeList.call(this, nodes);
    const path = _index.default
      .get({
        parentPath: this,
        parent: this.node,
        container: this.node[listKey],
        listKey: listKey,
        key: 0,
      })
      .setContext(this.context);
    return _containerInsertBefore.call(path, nodes);
  }
  function pushContainer(listKey, nodes) {
    _removal._assertUnremoved.call(this);
    const verifiedNodes = _verifyNodeList.call(this, nodes);
    const container = this.node[listKey];
    const path = _index.default
      .get({
        parentPath: this,
        parent: this.node,
        container: container,
        listKey: listKey,
        key: container.length,
      })
      .setContext(this.context);
    return path.replaceWithMultiple(verifiedNodes);
  }
  {
    modification$1.hoist = function hoist(scope = this.scope) {
      const hoister = new _hoister.default(this, scope);
      return hoister.run();
    };
  }
  return modification$1;
}
var lib$j = {};
var hasRequiredLib$j;
function requireLib$j() {
  if (hasRequiredLib$j) return lib$j;
  hasRequiredLib$j = 1;
  Object.defineProperty(lib$j, '__esModule', {value: true});
  function _objectWithoutPropertiesLoose(r, e) {
    if (null == r) return {};
    var t = {};
    for (var n in r)
      if ({}.hasOwnProperty.call(r, n)) {
        if (e.includes(n)) continue;
        t[n] = r[n];
      }
    return t;
  }
  class Position {
    constructor(line, col, index) {
      this.line = void 0;
      this.column = void 0;
      this.index = void 0;
      this.line = line;
      this.column = col;
      this.index = index;
    }
  }
  class SourceLocation {
    constructor(start, end) {
      this.start = void 0;
      this.end = void 0;
      this.filename = void 0;
      this.identifierName = void 0;
      this.start = start;
      this.end = end;
    }
  }
  function createPositionWithColumnOffset(position, columnOffset) {
    const {line: line, column: column, index: index} = position;
    return new Position(line, column + columnOffset, index + columnOffset);
  }
  const code = 'BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED';
  var ModuleErrors = {
    ImportMetaOutsideModule: {
      message: `import.meta may appear only with 'sourceType: "module"'`,
      code: code,
    },
    ImportOutsideModule: {
      message: `'import' and 'export' may appear only with 'sourceType: "module"'`,
      code: code,
    },
  };
  const NodeDescriptions = {
    ArrayPattern: 'array destructuring pattern',
    AssignmentExpression: 'assignment expression',
    AssignmentPattern: 'assignment expression',
    ArrowFunctionExpression: 'arrow function expression',
    ConditionalExpression: 'conditional expression',
    CatchClause: 'catch clause',
    ForOfStatement: 'for-of statement',
    ForInStatement: 'for-in statement',
    ForStatement: 'for-loop',
    FormalParameters: 'function parameter list',
    Identifier: 'identifier',
    ImportSpecifier: 'import specifier',
    ImportDefaultSpecifier: 'import default specifier',
    ImportNamespaceSpecifier: 'import namespace specifier',
    ObjectPattern: 'object destructuring pattern',
    ParenthesizedExpression: 'parenthesized expression',
    RestElement: 'rest element',
    UpdateExpression: {true: 'prefix operation', false: 'postfix operation'},
    VariableDeclarator: 'variable declaration',
    YieldExpression: 'yield expression',
  };
  const toNodeDescription = node =>
    node.type === 'UpdateExpression'
      ? NodeDescriptions.UpdateExpression[`${node.prefix}`]
      : NodeDescriptions[node.type];
  var StandardErrors = {
    AccessorIsGenerator: ({kind: kind}) =>
      `A ${kind}ter cannot be a generator.`,
    ArgumentsInClass:
      "'arguments' is only allowed in functions and class methods.",
    AsyncFunctionInSingleStatementContext:
      'Async functions can only be declared at the top level or inside a block.',
    AwaitBindingIdentifier:
      "Can not use 'await' as identifier inside an async function.",
    AwaitBindingIdentifierInStaticBlock:
      "Can not use 'await' as identifier inside a static block.",
    AwaitExpressionFormalParameter:
      "'await' is not allowed in async function parameters.",
    AwaitUsingNotInAsyncContext:
      "'await using' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncContext:
      "'await' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
    BadGetterArity: "A 'get' accessor must not have any formal parameters.",
    BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
    BadSetterRestParameter:
      "A 'set' accessor function argument must not be a rest parameter.",
    ConstructorClassField: "Classes may not have a field named 'constructor'.",
    ConstructorClassPrivateField:
      "Classes may not have a private field named '#constructor'.",
    ConstructorIsAccessor: 'Class constructor may not be an accessor.',
    ConstructorIsAsync: "Constructor can't be an async function.",
    ConstructorIsGenerator: "Constructor can't be a generator.",
    DeclarationMissingInitializer: ({kind: kind}) =>
      `Missing initializer in ${kind} declaration.`,
    DecoratorArgumentsOutsideParentheses:
      "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
    DecoratorBeforeExport:
      "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
    DecoratorsBeforeAfterExport:
      "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
    DecoratorConstructor:
      "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
    DecoratorExportClass:
      "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
    DecoratorSemicolon: 'Decorators must not be followed by a semicolon.',
    DecoratorStaticBlock: "Decorators can't be used with a static block.",
    DeferImportRequiresNamespace:
      'Only `import defer * as x from "./module"` is valid.',
    DeletePrivateField: 'Deleting a private field is not allowed.',
    DestructureNamedImport:
      'ES2015 named imports do not destructure. Use another statement for destructuring after the import.',
    DuplicateConstructor: 'Duplicate constructor in the same class.',
    DuplicateDefaultExport: 'Only one default export allowed per module.',
    DuplicateExport: ({exportName: exportName}) =>
      `\`${exportName}\` has already been exported. Exported identifiers must be unique.`,
    DuplicateProto: 'Redefinition of __proto__ property.',
    DuplicateRegExpFlags: 'Duplicate regular expression flag.',
    DynamicImportPhaseRequiresImportExpressions: ({phase: phase}) =>
      `'import.${phase}(...)' can only be parsed when using the 'createImportExpressions' option.`,
    ElementAfterRest: 'Rest element must be last element.',
    EscapedCharNotAnIdentifier: 'Invalid Unicode escape.',
    ExportBindingIsString: ({localName: localName, exportName: exportName}) =>
      `A string literal cannot be used as an exported binding without \`from\`.\n- Did you mean \`export { '${localName}' as '${exportName}' } from 'some-module'\`?`,
    ExportDefaultFromAsIdentifier:
      "'from' is not allowed as an identifier after 'export default'.",
    ForInOfLoopInitializer: ({type: type}) =>
      `'${type === 'ForInStatement' ? 'for-in' : 'for-of'}' loop variable declaration may not have an initializer.`,
    ForInUsing: "For-in loop may not start with 'using' declaration.",
    ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
    ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
    GeneratorInSingleStatementContext:
      'Generators can only be declared at the top level or inside a block.',
    IllegalBreakContinue: ({type: type}) =>
      `Unsyntactic ${type === 'BreakStatement' ? 'break' : 'continue'}.`,
    IllegalLanguageModeDirective:
      "Illegal 'use strict' directive in function with non-simple parameter list.",
    IllegalReturn: "'return' outside of function.",
    ImportAttributesUseAssert:
      'The `assert` keyword in import attributes is deprecated and it has been replaced by the `with` keyword. You can enable the `deprecatedImportAssert` parser plugin to suppress this error.',
    ImportBindingIsString: ({importName: importName}) =>
      `A string literal cannot be used as an imported binding.\n- Did you mean \`import { "${importName}" as foo }\`?`,
    ImportCallArity: `\`import()\` requires exactly one or two arguments.`,
    ImportCallNotNewExpression: 'Cannot use new with import(...).',
    ImportCallSpreadArgument: '`...` is not allowed in `import()`.',
    ImportJSONBindingNotDefault:
      'A JSON module can only be imported with `default`.',
    ImportReflectionHasAssertion: '`import module x` cannot have assertions.',
    ImportReflectionNotBinding:
      'Only `import module x from "./module"` is valid.',
    IncompatibleRegExpUVFlags:
      "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
    InvalidBigIntLiteral: 'Invalid BigIntLiteral.',
    InvalidCodePoint: 'Code point out of bounds.',
    InvalidCoverInitializedName: 'Invalid shorthand property initializer.',
    InvalidDecimal: 'Invalid decimal.',
    InvalidDigit: ({radix: radix}) => `Expected number in radix ${radix}.`,
    InvalidEscapeSequence: 'Bad character escape sequence.',
    InvalidEscapeSequenceTemplate: 'Invalid escape sequence in template.',
    InvalidEscapedReservedWord: ({reservedWord: reservedWord}) =>
      `Escape sequence in keyword ${reservedWord}.`,
    InvalidIdentifier: ({identifierName: identifierName}) =>
      `Invalid identifier ${identifierName}.`,
    InvalidLhs: ({ancestor: ancestor}) =>
      `Invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsBinding: ({ancestor: ancestor}) =>
      `Binding invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsOptionalChaining: ({ancestor: ancestor}) =>
      `Invalid optional chaining in the left-hand side of ${toNodeDescription(ancestor)}.`,
    InvalidNumber: 'Invalid number.',
    InvalidOrMissingExponent:
      "Floating-point numbers require a valid exponent after the 'e'.",
    InvalidOrUnexpectedToken: ({unexpected: unexpected}) =>
      `Unexpected character '${unexpected}'.`,
    InvalidParenthesizedAssignment: 'Invalid parenthesized assignment pattern.',
    InvalidPrivateFieldResolution: ({identifierName: identifierName}) =>
      `Private name #${identifierName} is not defined.`,
    InvalidPropertyBindingPattern: 'Binding member expression.',
    InvalidRecordProperty:
      'Only properties and spread elements are allowed in record definitions.',
    InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
    LabelRedeclaration: ({labelName: labelName}) =>
      `Label '${labelName}' is already declared.`,
    LetInLexicalBinding: "'let' is disallowed as a lexically bound name.",
    LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
    MalformedRegExpFlags: 'Invalid regular expression flag.',
    MissingClassName: 'A class name is required.',
    MissingEqInAssignment:
      "Only '=' operator can be used for specifying default value.",
    MissingSemicolon: 'Missing semicolon.',
    MissingPlugin: ({missingPlugin: missingPlugin}) =>
      `This experimental syntax requires enabling the parser plugin: ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
    MissingOneOfPlugins: ({missingPlugin: missingPlugin}) =>
      `This experimental syntax requires enabling one of the following parser plugin(s): ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
    MissingUnicodeEscape: 'Expecting Unicode escape sequence \\uXXXX.',
    MixingCoalesceWithLogical:
      'Nullish coalescing operator(??) requires parens when mixing with logical operators.',
    ModuleAttributeDifferentFromType:
      'The only accepted module attribute is `type`.',
    ModuleAttributeInvalidValue:
      'Only string literals are allowed as module attribute values.',
    ModuleAttributesWithDuplicateKeys: ({key: key}) =>
      `Duplicate key "${key}" is not allowed in module attributes.`,
    ModuleExportNameHasLoneSurrogate: ({
      surrogateCharCode: surrogateCharCode,
    }) =>
      `An export name cannot include a lone surrogate, found '\\u${surrogateCharCode.toString(16)}'.`,
    ModuleExportUndefined: ({localName: localName}) =>
      `Export '${localName}' is not defined.`,
    MultipleDefaultsInSwitch: 'Multiple default clauses.',
    NewlineAfterThrow: 'Illegal newline after throw.',
    NoCatchOrFinally: 'Missing catch or finally clause.',
    NumberIdentifier: 'Identifier directly after number.',
    NumericSeparatorInEscapeSequence:
      'Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.',
    ObsoleteAwaitStar:
      "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
    OptionalChainingNoNew:
      'Constructors in/after an Optional Chain are not allowed.',
    OptionalChainingNoTemplate:
      'Tagged Template Literals are not allowed in optionalChain.',
    OverrideOnConstructor:
      "'override' modifier cannot appear on a constructor declaration.",
    ParamDupe: 'Argument name clash.',
    PatternHasAccessor: "Object pattern can't contain getter or setter.",
    PatternHasMethod: "Object pattern can't contain methods.",
    PrivateInExpectedIn: ({identifierName: identifierName}) =>
      `Private names are only allowed in property accesses (\`obj.#${identifierName}\`) or in \`in\` expressions (\`#${identifierName} in obj\`).`,
    PrivateNameRedeclaration: ({identifierName: identifierName}) =>
      `Duplicate private name #${identifierName}.`,
    RecordExpressionBarIncorrectEndSyntaxType:
      "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionBarIncorrectStartSyntaxType:
      "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionHashIncorrectStartSyntaxType:
      "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    RecordNoProto: "'__proto__' is not allowed in Record expressions.",
    RestTrailingComma: 'Unexpected trailing comma after rest element.',
    SloppyFunction:
      'In non-strict mode code, functions can only be declared at top level or inside a block.',
    SloppyFunctionAnnexB:
      'In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.',
    SourcePhaseImportRequiresDefault:
      'Only `import source x from "./module"` is valid.',
    StaticPrototype: 'Classes may not have static property named prototype.',
    SuperNotAllowed:
      "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
    SuperPrivateField: "Private fields can't be accessed on super.",
    TrailingDecorator: 'Decorators must be attached to a class element.',
    TupleExpressionBarIncorrectEndSyntaxType:
      "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionBarIncorrectStartSyntaxType:
      "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionHashIncorrectStartSyntaxType:
      "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    UnexpectedArgumentPlaceholder: 'Unexpected argument placeholder.',
    UnexpectedAwaitAfterPipelineBody:
      'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
    UnexpectedDigitAfterHash: 'Unexpected digit after hash token.',
    UnexpectedImportExport:
      "'import' and 'export' may only appear at the top level.",
    UnexpectedKeyword: ({keyword: keyword}) =>
      `Unexpected keyword '${keyword}'.`,
    UnexpectedLeadingDecorator:
      'Leading decorators must be attached to a class declaration.',
    UnexpectedLexicalDeclaration:
      'Lexical declaration cannot appear in a single-statement context.',
    UnexpectedNewTarget:
      '`new.target` can only be used in functions or class properties.',
    UnexpectedNumericSeparator:
      'A numeric separator is only allowed between two digits.',
    UnexpectedPrivateField: 'Unexpected private name.',
    UnexpectedReservedWord: ({reservedWord: reservedWord}) =>
      `Unexpected reserved word '${reservedWord}'.`,
    UnexpectedSuper: "'super' is only allowed in object methods and classes.",
    UnexpectedToken: ({expected: expected, unexpected: unexpected}) =>
      `Unexpected token${unexpected ? ` '${unexpected}'.` : ''}${expected ? `, expected "${expected}"` : ''}`,
    UnexpectedTokenUnaryExponentiation:
      'Illegal expression. Wrap left hand side or entire exponentiation in parentheses.',
    UnexpectedUsingDeclaration:
      'Using declaration cannot appear in the top level when source type is `script`.',
    UnsupportedBind: 'Binding should be performed on object property.',
    UnsupportedDecoratorExport:
      'A decorated export must export a class declaration.',
    UnsupportedDefaultExport:
      'Only expressions, functions or classes are allowed as the `default` export.',
    UnsupportedImport:
      '`import` can only be used in `import()` or `import.meta`.',
    UnsupportedMetaProperty: ({
      target: target,
      onlyValidPropertyName: onlyValidPropertyName,
    }) =>
      `The only valid meta property for ${target} is ${target}.${onlyValidPropertyName}.`,
    UnsupportedParameterDecorator:
      'Decorators cannot be used to decorate parameters.',
    UnsupportedPropertyDecorator:
      'Decorators cannot be used to decorate object literal properties.',
    UnsupportedSuper:
      "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
    UnterminatedComment: 'Unterminated comment.',
    UnterminatedRegExp: 'Unterminated regular expression.',
    UnterminatedString: 'Unterminated string constant.',
    UnterminatedTemplate: 'Unterminated template.',
    UsingDeclarationExport: 'Using declaration cannot be exported.',
    UsingDeclarationHasBindingPattern:
      'Using declaration cannot have destructuring patterns.',
    VarRedeclaration: ({identifierName: identifierName}) =>
      `Identifier '${identifierName}' has already been declared.`,
    YieldBindingIdentifier:
      "Can not use 'yield' as identifier inside a generator.",
    YieldInParameter: 'Yield expression is not allowed in formal parameters.',
    ZeroDigitNumericSeparator:
      'Numeric separator can not be used after leading 0.',
  };
  var StrictModeErrors = {
    StrictDelete: 'Deleting local variable in strict mode.',
    StrictEvalArguments: ({referenceName: referenceName}) =>
      `Assigning to '${referenceName}' in strict mode.`,
    StrictEvalArgumentsBinding: ({bindingName: bindingName}) =>
      `Binding '${bindingName}' in strict mode.`,
    StrictFunction:
      'In strict mode code, functions can only be declared at top level or inside a block.',
    StrictNumericEscape:
      "The only valid numeric escape in strict mode is '\\0'.",
    StrictOctalLiteral: 'Legacy octal literals are not allowed in strict mode.',
    StrictWith: "'with' in strict mode.",
  };
  const UnparenthesizedPipeBodyDescriptions = new Set([
    'ArrowFunctionExpression',
    'AssignmentExpression',
    'ConditionalExpression',
    'YieldExpression',
  ]);
  var PipelineOperatorErrors = {
    PipeBodyIsTighter:
      'Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.',
    PipeTopicRequiresHackPipes:
      'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
    PipeTopicUnbound:
      'Topic reference is unbound; it must be inside a pipe body.',
    PipeTopicUnconfiguredToken: ({token: token}) =>
      `Invalid topic token ${token}. In order to use ${token} as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "${token}" }.`,
    PipeTopicUnused:
      'Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.',
    PipeUnparenthesizedBody: ({type: type}) =>
      `Hack-style pipe body cannot be an unparenthesized ${toNodeDescription({type: type})}; please wrap it in parentheses.`,
    PipelineBodyNoArrow:
      'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
    PipelineBodySequenceExpression:
      'Pipeline body may not be a comma-separated sequence expression.',
    PipelineHeadSequenceExpression:
      'Pipeline head should not be a comma-separated sequence expression.',
    PipelineTopicUnused:
      'Pipeline is in topic style but does not use topic reference.',
    PrimaryTopicNotAllowed:
      'Topic reference was used in a lexical context without topic binding.',
    PrimaryTopicRequiresSmartPipeline:
      'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
  };
  const _excluded = ['message'];
  function defineHidden(obj, key, value) {
    Object.defineProperty(obj, key, {
      enumerable: false,
      configurable: true,
      value: value,
    });
  }
  function toParseErrorConstructor({
    toMessage: toMessage,
    code: code,
    reasonCode: reasonCode,
    syntaxPlugin: syntaxPlugin,
  }) {
    const hasMissingPlugin =
      reasonCode === 'MissingPlugin' || reasonCode === 'MissingOneOfPlugins';
    {
      const oldReasonCodes = {
        AccessorCannotDeclareThisParameter: 'AccesorCannotDeclareThisParameter',
        AccessorCannotHaveTypeParameters: 'AccesorCannotHaveTypeParameters',
        ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference:
          'ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference',
        SetAccessorCannotHaveOptionalParameter:
          'SetAccesorCannotHaveOptionalParameter',
        SetAccessorCannotHaveRestParameter: 'SetAccesorCannotHaveRestParameter',
        SetAccessorCannotHaveReturnType: 'SetAccesorCannotHaveReturnType',
      };
      if (oldReasonCodes[reasonCode]) {
        reasonCode = oldReasonCodes[reasonCode];
      }
    }
    return function constructor(loc, details) {
      const error = new SyntaxError();
      error.code = code;
      error.reasonCode = reasonCode;
      error.loc = loc;
      error.pos = loc.index;
      error.syntaxPlugin = syntaxPlugin;
      if (hasMissingPlugin) {
        error.missingPlugin = details.missingPlugin;
      }
      defineHidden(error, 'clone', function clone(overrides = {}) {
        var _overrides$loc;
        const {
          line: line,
          column: column,
          index: index,
        } = (_overrides$loc = overrides.loc) != null ? _overrides$loc : loc;
        return constructor(
          new Position(line, column, index),
          Object.assign({}, details, overrides.details)
        );
      });
      defineHidden(error, 'details', details);
      Object.defineProperty(error, 'message', {
        configurable: true,
        get() {
          const message = `${toMessage(details)} (${loc.line}:${loc.column})`;
          this.message = message;
          return message;
        },
        set(value) {
          Object.defineProperty(this, 'message', {
            value: value,
            writable: true,
          });
        },
      });
      return error;
    };
  }
  function ParseErrorEnum(argument, syntaxPlugin) {
    if (Array.isArray(argument)) {
      return parseErrorTemplates =>
        ParseErrorEnum(parseErrorTemplates, argument[0]);
    }
    const ParseErrorConstructors = {};
    for (const reasonCode of Object.keys(argument)) {
      const template = argument[reasonCode];
      const _ref =
          typeof template === 'string'
            ? {message: () => template}
            : typeof template === 'function'
              ? {message: template}
              : template,
        {message: message} = _ref,
        rest = _objectWithoutPropertiesLoose(_ref, _excluded);
      const toMessage = typeof message === 'string' ? () => message : message;
      ParseErrorConstructors[reasonCode] = toParseErrorConstructor(
        Object.assign(
          {
            code: 'BABEL_PARSER_SYNTAX_ERROR',
            reasonCode: reasonCode,
            toMessage: toMessage,
          },
          syntaxPlugin ? {syntaxPlugin: syntaxPlugin} : {},
          rest
        )
      );
    }
    return ParseErrorConstructors;
  }
  const Errors = Object.assign(
    {},
    ParseErrorEnum(ModuleErrors),
    ParseErrorEnum(StandardErrors),
    ParseErrorEnum(StrictModeErrors),
    ParseErrorEnum`pipelineOperator`(PipelineOperatorErrors)
  );
  const {defineProperty: defineProperty} = Object;
  const toUnenumerable = (object, key) => {
    if (object) {
      defineProperty(object, key, {enumerable: false, value: object[key]});
    }
  };
  function toESTreeLocation(node) {
    toUnenumerable(node.loc.start, 'index');
    toUnenumerable(node.loc.end, 'index');
    return node;
  }
  var estree = superClass =>
    class ESTreeParserMixin extends superClass {
      parse() {
        const file = toESTreeLocation(super.parse());
        if (this.options.tokens) {
          file.tokens = file.tokens.map(toESTreeLocation);
        }
        return file;
      }
      parseRegExpLiteral({pattern: pattern, flags: flags}) {
        let regex = null;
        try {
          regex = new RegExp(pattern, flags);
        } catch (_) {}
        const node = this.estreeParseLiteral(regex);
        node.regex = {pattern: pattern, flags: flags};
        return node;
      }
      parseBigIntLiteral(value) {
        let bigInt;
        try {
          bigInt = BigInt(value);
        } catch (_unused) {
          bigInt = null;
        }
        const node = this.estreeParseLiteral(bigInt);
        node.bigint = String(node.value || value);
        return node;
      }
      parseDecimalLiteral(value) {
        const decimal = null;
        const node = this.estreeParseLiteral(decimal);
        node.decimal = String(node.value || value);
        return node;
      }
      estreeParseLiteral(value) {
        return this.parseLiteral(value, 'Literal');
      }
      parseStringLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      parseNumericLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      parseNullLiteral() {
        return this.estreeParseLiteral(null);
      }
      parseBooleanLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      directiveToStmt(directive) {
        const expression = directive.value;
        delete directive.value;
        expression.type = 'Literal';
        expression.raw = expression.extra.raw;
        expression.value = expression.extra.expressionValue;
        const stmt = directive;
        stmt.type = 'ExpressionStatement';
        stmt.expression = expression;
        stmt.directive = expression.extra.rawValue;
        delete expression.extra;
        return stmt;
      }
      initFunction(node, isAsync) {
        super.initFunction(node, isAsync);
        node.expression = false;
      }
      checkDeclaration(node) {
        if (node != null && this.isObjectProperty(node)) {
          this.checkDeclaration(node.value);
        } else {
          super.checkDeclaration(node);
        }
      }
      getObjectOrClassMethodParams(method) {
        return method.value.params;
      }
      isValidDirective(stmt) {
        var _stmt$expression$extr;
        return (
          stmt.type === 'ExpressionStatement' &&
          stmt.expression.type === 'Literal' &&
          typeof stmt.expression.value === 'string' &&
          !(
            (_stmt$expression$extr = stmt.expression.extra) != null &&
            _stmt$expression$extr.parenthesized
          )
        );
      }
      parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
        super.parseBlockBody(
          node,
          allowDirectives,
          topLevel,
          end,
          afterBlockParse
        );
        const directiveStatements = node.directives.map(d =>
          this.directiveToStmt(d)
        );
        node.body = directiveStatements.concat(node.body);
        delete node.directives;
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        this.parseMethod(
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper,
          'ClassMethod',
          true
        );
        if (method.typeParameters) {
          method.value.typeParameters = method.typeParameters;
          delete method.typeParameters;
        }
        classBody.body.push(method);
      }
      parsePrivateName() {
        const node = super.parsePrivateName();
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return node;
          }
        }
        return this.convertPrivateNameToPrivateIdentifier(node);
      }
      convertPrivateNameToPrivateIdentifier(node) {
        const name = super.getPrivateNameSV(node);
        node = node;
        delete node.id;
        node.name = name;
        node.type = 'PrivateIdentifier';
        return node;
      }
      isPrivateName(node) {
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return super.isPrivateName(node);
          }
        }
        return node.type === 'PrivateIdentifier';
      }
      getPrivateNameSV(node) {
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return super.getPrivateNameSV(node);
          }
        }
        return node.name;
      }
      parseLiteral(value, type) {
        const node = super.parseLiteral(value, type);
        node.raw = node.extra.raw;
        delete node.extra;
        return node;
      }
      parseFunctionBody(node, allowExpression, isMethod = false) {
        super.parseFunctionBody(node, allowExpression, isMethod);
        node.expression = node.body.type !== 'BlockStatement';
      }
      parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope = false
      ) {
        let funcNode = this.startNode();
        funcNode.kind = node.kind;
        funcNode = super.parseMethod(
          funcNode,
          isGenerator,
          isAsync,
          isConstructor,
          allowDirectSuper,
          type,
          inClassScope
        );
        funcNode.type = 'FunctionExpression';
        delete funcNode.kind;
        node.value = funcNode;
        if (type === 'ClassPrivateMethod') {
          node.computed = false;
        }
        return this.finishNode(node, 'MethodDefinition');
      }
      nameIsConstructor(key) {
        if (key.type === 'Literal') return key.value === 'constructor';
        return super.nameIsConstructor(key);
      }
      parseClassProperty(...args) {
        const propertyNode = super.parseClassProperty(...args);
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return propertyNode;
          }
        }
        propertyNode.type = 'PropertyDefinition';
        return propertyNode;
      }
      parseClassPrivateProperty(...args) {
        const propertyNode = super.parseClassPrivateProperty(...args);
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return propertyNode;
          }
        }
        propertyNode.type = 'PropertyDefinition';
        propertyNode.computed = false;
        return propertyNode;
      }
      parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
        const node = super.parseObjectMethod(
          prop,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor
        );
        if (node) {
          node.type = 'Property';
          if (node.kind === 'method') {
            node.kind = 'init';
          }
          node.shorthand = false;
        }
        return node;
      }
      parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
        const node = super.parseObjectProperty(
          prop,
          startLoc,
          isPattern,
          refExpressionErrors
        );
        if (node) {
          node.kind = 'init';
          node.type = 'Property';
        }
        return node;
      }
      isValidLVal(type, isUnparenthesizedInAssign, binding) {
        return type === 'Property'
          ? 'value'
          : super.isValidLVal(type, isUnparenthesizedInAssign, binding);
      }
      isAssignable(node, isBinding) {
        if (node != null && this.isObjectProperty(node)) {
          return this.isAssignable(node.value, isBinding);
        }
        return super.isAssignable(node, isBinding);
      }
      toAssignable(node, isLHS = false) {
        if (node != null && this.isObjectProperty(node)) {
          const {key: key, value: value} = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(
              this.getPrivateNameSV(key),
              key.loc.start
            );
          }
          this.toAssignable(value, isLHS);
        } else {
          super.toAssignable(node, isLHS);
        }
      }
      toAssignableObjectExpressionProp(prop, isLast, isLHS) {
        if (
          prop.type === 'Property' &&
          (prop.kind === 'get' || prop.kind === 'set')
        ) {
          this.raise(Errors.PatternHasAccessor, prop.key);
        } else if (prop.type === 'Property' && prop.method) {
          this.raise(Errors.PatternHasMethod, prop.key);
        } else {
          super.toAssignableObjectExpressionProp(prop, isLast, isLHS);
        }
      }
      finishCallExpression(unfinished, optional) {
        const node = super.finishCallExpression(unfinished, optional);
        if (node.callee.type === 'Import') {
          var _ref, _ref2;
          node.type = 'ImportExpression';
          node.source = node.arguments[0];
          node.options = (_ref = node.arguments[1]) != null ? _ref : null;
          node.attributes = (_ref2 = node.arguments[1]) != null ? _ref2 : null;
          delete node.arguments;
          delete node.callee;
        }
        return node;
      }
      toReferencedArguments(node) {
        if (node.type === 'ImportExpression') {
          return;
        }
        super.toReferencedArguments(node);
      }
      parseExport(unfinished, decorators) {
        const exportStartLoc = this.state.lastTokStartLoc;
        const node = super.parseExport(unfinished, decorators);
        switch (node.type) {
          case 'ExportAllDeclaration':
            node.exported = null;
            break;
          case 'ExportNamedDeclaration':
            if (
              node.specifiers.length === 1 &&
              node.specifiers[0].type === 'ExportNamespaceSpecifier'
            ) {
              node.type = 'ExportAllDeclaration';
              node.exported = node.specifiers[0].exported;
              delete node.specifiers;
            }
          case 'ExportDefaultDeclaration':
            {
              var _declaration$decorato;
              const {declaration: declaration} = node;
              if (
                (declaration == null ? void 0 : declaration.type) ===
                  'ClassDeclaration' &&
                ((_declaration$decorato = declaration.decorators) == null
                  ? void 0
                  : _declaration$decorato.length) > 0 &&
                declaration.start === node.start
              ) {
                this.resetStartLocation(node, exportStartLoc);
              }
            }
            break;
        }
        return node;
      }
      parseSubscript(base, startLoc, noCalls, state) {
        const node = super.parseSubscript(base, startLoc, noCalls, state);
        if (state.optionalChainMember) {
          if (
            node.type === 'OptionalMemberExpression' ||
            node.type === 'OptionalCallExpression'
          ) {
            node.type = node.type.substring(8);
          }
          if (state.stop) {
            const chain = this.startNodeAtNode(node);
            chain.expression = node;
            return this.finishNode(chain, 'ChainExpression');
          }
        } else if (
          node.type === 'MemberExpression' ||
          node.type === 'CallExpression'
        ) {
          node.optional = false;
        }
        return node;
      }
      isOptionalMemberExpression(node) {
        if (node.type === 'ChainExpression') {
          return node.expression.type === 'MemberExpression';
        }
        return super.isOptionalMemberExpression(node);
      }
      hasPropertyAsPrivateName(node) {
        if (node.type === 'ChainExpression') {
          node = node.expression;
        }
        return super.hasPropertyAsPrivateName(node);
      }
      isObjectProperty(node) {
        return node.type === 'Property' && node.kind === 'init' && !node.method;
      }
      isObjectMethod(node) {
        return (
          node.type === 'Property' &&
          (node.method || node.kind === 'get' || node.kind === 'set')
        );
      }
      finishNodeAt(node, type, endLoc) {
        return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
      }
      resetStartLocation(node, startLoc) {
        super.resetStartLocation(node, startLoc);
        toESTreeLocation(node);
      }
      resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
        super.resetEndLocation(node, endLoc);
        toESTreeLocation(node);
      }
    };
  class TokContext {
    constructor(token, preserveSpace) {
      this.token = void 0;
      this.preserveSpace = void 0;
      this.token = token;
      this.preserveSpace = !!preserveSpace;
    }
  }
  const types = {
    brace: new TokContext('{'),
    j_oTag: new TokContext('<tag'),
    j_cTag: new TokContext('</tag'),
    j_expr: new TokContext('<tag>...</tag>', true),
  };
  {
    types.template = new TokContext('`', true);
  }
  const beforeExpr = true;
  const startsExpr = true;
  const isLoop = true;
  const isAssign = true;
  const prefix = true;
  const postfix = true;
  class ExportedTokenType {
    constructor(label, conf = {}) {
      this.label = void 0;
      this.keyword = void 0;
      this.beforeExpr = void 0;
      this.startsExpr = void 0;
      this.rightAssociative = void 0;
      this.isLoop = void 0;
      this.isAssign = void 0;
      this.prefix = void 0;
      this.postfix = void 0;
      this.binop = void 0;
      this.label = label;
      this.keyword = conf.keyword;
      this.beforeExpr = !!conf.beforeExpr;
      this.startsExpr = !!conf.startsExpr;
      this.rightAssociative = !!conf.rightAssociative;
      this.isLoop = !!conf.isLoop;
      this.isAssign = !!conf.isAssign;
      this.prefix = !!conf.prefix;
      this.postfix = !!conf.postfix;
      this.binop = conf.binop != null ? conf.binop : null;
      {
        this.updateContext = null;
      }
    }
  }
  const keywords$1 = new Map();
  function createKeyword(name, options = {}) {
    options.keyword = name;
    const token = createToken(name, options);
    keywords$1.set(name, token);
    return token;
  }
  function createBinop(name, binop) {
    return createToken(name, {beforeExpr: beforeExpr, binop: binop});
  }
  let tokenTypeCounter = -1;
  const tokenTypes = [];
  const tokenLabels = [];
  const tokenBinops = [];
  const tokenBeforeExprs = [];
  const tokenStartsExprs = [];
  const tokenPrefixes = [];
  function createToken(name, options = {}) {
    var _options$binop,
      _options$beforeExpr,
      _options$startsExpr,
      _options$prefix;
    ++tokenTypeCounter;
    tokenLabels.push(name);
    tokenBinops.push(
      (_options$binop = options.binop) != null ? _options$binop : -1
    );
    tokenBeforeExprs.push(
      (_options$beforeExpr = options.beforeExpr) != null
        ? _options$beforeExpr
        : false
    );
    tokenStartsExprs.push(
      (_options$startsExpr = options.startsExpr) != null
        ? _options$startsExpr
        : false
    );
    tokenPrefixes.push(
      (_options$prefix = options.prefix) != null ? _options$prefix : false
    );
    tokenTypes.push(new ExportedTokenType(name, options));
    return tokenTypeCounter;
  }
  function createKeywordLike(name, options = {}) {
    var _options$binop2,
      _options$beforeExpr2,
      _options$startsExpr2,
      _options$prefix2;
    ++tokenTypeCounter;
    keywords$1.set(name, tokenTypeCounter);
    tokenLabels.push(name);
    tokenBinops.push(
      (_options$binop2 = options.binop) != null ? _options$binop2 : -1
    );
    tokenBeforeExprs.push(
      (_options$beforeExpr2 = options.beforeExpr) != null
        ? _options$beforeExpr2
        : false
    );
    tokenStartsExprs.push(
      (_options$startsExpr2 = options.startsExpr) != null
        ? _options$startsExpr2
        : false
    );
    tokenPrefixes.push(
      (_options$prefix2 = options.prefix) != null ? _options$prefix2 : false
    );
    tokenTypes.push(new ExportedTokenType('name', options));
    return tokenTypeCounter;
  }
  const tt = {
    bracketL: createToken('[', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketHashL: createToken('#[', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketBarL: createToken('[|', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketR: createToken(']'),
    bracketBarR: createToken('|]'),
    braceL: createToken('{', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
    braceBarL: createToken('{|', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    braceHashL: createToken('#{', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    braceR: createToken('}'),
    braceBarR: createToken('|}'),
    parenL: createToken('(', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
    parenR: createToken(')'),
    comma: createToken(',', {beforeExpr: beforeExpr}),
    semi: createToken(';', {beforeExpr: beforeExpr}),
    colon: createToken(':', {beforeExpr: beforeExpr}),
    doubleColon: createToken('::', {beforeExpr: beforeExpr}),
    dot: createToken('.'),
    question: createToken('?', {beforeExpr: beforeExpr}),
    questionDot: createToken('?.'),
    arrow: createToken('=>', {beforeExpr: beforeExpr}),
    template: createToken('template'),
    ellipsis: createToken('...', {beforeExpr: beforeExpr}),
    backQuote: createToken('`', {startsExpr: startsExpr}),
    dollarBraceL: createToken('${', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    templateTail: createToken('...`', {startsExpr: startsExpr}),
    templateNonTail: createToken('...${', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    at: createToken('@'),
    hash: createToken('#', {startsExpr: startsExpr}),
    interpreterDirective: createToken('#!...'),
    eq: createToken('=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    assign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    slashAssign: createToken('_=', {
      beforeExpr: beforeExpr,
      isAssign: isAssign,
    }),
    xorAssign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    moduloAssign: createToken('_=', {
      beforeExpr: beforeExpr,
      isAssign: isAssign,
    }),
    incDec: createToken('++/--', {
      prefix: prefix,
      postfix: postfix,
      startsExpr: startsExpr,
    }),
    bang: createToken('!', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    tilde: createToken('~', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    doubleCaret: createToken('^^', {startsExpr: startsExpr}),
    doubleAt: createToken('@@', {startsExpr: startsExpr}),
    pipeline: createBinop('|>', 0),
    nullishCoalescing: createBinop('??', 1),
    logicalOR: createBinop('||', 1),
    logicalAND: createBinop('&&', 2),
    bitwiseOR: createBinop('|', 3),
    bitwiseXOR: createBinop('^', 4),
    bitwiseAND: createBinop('&', 5),
    equality: createBinop('==/!=/===/!==', 6),
    lt: createBinop('</>/<=/>=', 7),
    gt: createBinop('</>/<=/>=', 7),
    relational: createBinop('</>/<=/>=', 7),
    bitShift: createBinop('<</>>/>>>', 8),
    bitShiftL: createBinop('<</>>/>>>', 8),
    bitShiftR: createBinop('<</>>/>>>', 8),
    plusMin: createToken('+/-', {
      beforeExpr: beforeExpr,
      binop: 9,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    modulo: createToken('%', {binop: 10, startsExpr: startsExpr}),
    star: createToken('*', {binop: 10}),
    slash: createBinop('/', 10),
    exponent: createToken('**', {
      beforeExpr: beforeExpr,
      binop: 11,
      rightAssociative: true,
    }),
    _in: createKeyword('in', {beforeExpr: beforeExpr, binop: 7}),
    _instanceof: createKeyword('instanceof', {
      beforeExpr: beforeExpr,
      binop: 7,
    }),
    _break: createKeyword('break'),
    _case: createKeyword('case', {beforeExpr: beforeExpr}),
    _catch: createKeyword('catch'),
    _continue: createKeyword('continue'),
    _debugger: createKeyword('debugger'),
    _default: createKeyword('default', {beforeExpr: beforeExpr}),
    _else: createKeyword('else', {beforeExpr: beforeExpr}),
    _finally: createKeyword('finally'),
    _function: createKeyword('function', {startsExpr: startsExpr}),
    _if: createKeyword('if'),
    _return: createKeyword('return', {beforeExpr: beforeExpr}),
    _switch: createKeyword('switch'),
    _throw: createKeyword('throw', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _try: createKeyword('try'),
    _var: createKeyword('var'),
    _const: createKeyword('const'),
    _with: createKeyword('with'),
    _new: createKeyword('new', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    _this: createKeyword('this', {startsExpr: startsExpr}),
    _super: createKeyword('super', {startsExpr: startsExpr}),
    _class: createKeyword('class', {startsExpr: startsExpr}),
    _extends: createKeyword('extends', {beforeExpr: beforeExpr}),
    _export: createKeyword('export'),
    _import: createKeyword('import', {startsExpr: startsExpr}),
    _null: createKeyword('null', {startsExpr: startsExpr}),
    _true: createKeyword('true', {startsExpr: startsExpr}),
    _false: createKeyword('false', {startsExpr: startsExpr}),
    _typeof: createKeyword('typeof', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _void: createKeyword('void', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _delete: createKeyword('delete', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _do: createKeyword('do', {isLoop: isLoop, beforeExpr: beforeExpr}),
    _for: createKeyword('for', {isLoop: isLoop}),
    _while: createKeyword('while', {isLoop: isLoop}),
    _as: createKeywordLike('as', {startsExpr: startsExpr}),
    _assert: createKeywordLike('assert', {startsExpr: startsExpr}),
    _async: createKeywordLike('async', {startsExpr: startsExpr}),
    _await: createKeywordLike('await', {startsExpr: startsExpr}),
    _defer: createKeywordLike('defer', {startsExpr: startsExpr}),
    _from: createKeywordLike('from', {startsExpr: startsExpr}),
    _get: createKeywordLike('get', {startsExpr: startsExpr}),
    _let: createKeywordLike('let', {startsExpr: startsExpr}),
    _meta: createKeywordLike('meta', {startsExpr: startsExpr}),
    _of: createKeywordLike('of', {startsExpr: startsExpr}),
    _sent: createKeywordLike('sent', {startsExpr: startsExpr}),
    _set: createKeywordLike('set', {startsExpr: startsExpr}),
    _source: createKeywordLike('source', {startsExpr: startsExpr}),
    _static: createKeywordLike('static', {startsExpr: startsExpr}),
    _using: createKeywordLike('using', {startsExpr: startsExpr}),
    _yield: createKeywordLike('yield', {startsExpr: startsExpr}),
    _asserts: createKeywordLike('asserts', {startsExpr: startsExpr}),
    _checks: createKeywordLike('checks', {startsExpr: startsExpr}),
    _exports: createKeywordLike('exports', {startsExpr: startsExpr}),
    _global: createKeywordLike('global', {startsExpr: startsExpr}),
    _implements: createKeywordLike('implements', {startsExpr: startsExpr}),
    _intrinsic: createKeywordLike('intrinsic', {startsExpr: startsExpr}),
    _infer: createKeywordLike('infer', {startsExpr: startsExpr}),
    _is: createKeywordLike('is', {startsExpr: startsExpr}),
    _mixins: createKeywordLike('mixins', {startsExpr: startsExpr}),
    _proto: createKeywordLike('proto', {startsExpr: startsExpr}),
    _require: createKeywordLike('require', {startsExpr: startsExpr}),
    _satisfies: createKeywordLike('satisfies', {startsExpr: startsExpr}),
    _keyof: createKeywordLike('keyof', {startsExpr: startsExpr}),
    _readonly: createKeywordLike('readonly', {startsExpr: startsExpr}),
    _unique: createKeywordLike('unique', {startsExpr: startsExpr}),
    _abstract: createKeywordLike('abstract', {startsExpr: startsExpr}),
    _declare: createKeywordLike('declare', {startsExpr: startsExpr}),
    _enum: createKeywordLike('enum', {startsExpr: startsExpr}),
    _module: createKeywordLike('module', {startsExpr: startsExpr}),
    _namespace: createKeywordLike('namespace', {startsExpr: startsExpr}),
    _interface: createKeywordLike('interface', {startsExpr: startsExpr}),
    _type: createKeywordLike('type', {startsExpr: startsExpr}),
    _opaque: createKeywordLike('opaque', {startsExpr: startsExpr}),
    name: createToken('name', {startsExpr: startsExpr}),
    placeholder: createToken('%%', {startsExpr: true}),
    string: createToken('string', {startsExpr: startsExpr}),
    num: createToken('num', {startsExpr: startsExpr}),
    bigint: createToken('bigint', {startsExpr: startsExpr}),
    decimal: createToken('decimal', {startsExpr: startsExpr}),
    regexp: createToken('regexp', {startsExpr: startsExpr}),
    privateName: createToken('#name', {startsExpr: startsExpr}),
    eof: createToken('eof'),
    jsxName: createToken('jsxName'),
    jsxText: createToken('jsxText', {beforeExpr: true}),
    jsxTagStart: createToken('jsxTagStart', {startsExpr: true}),
    jsxTagEnd: createToken('jsxTagEnd'),
  };
  function tokenIsIdentifier(token) {
    return token >= 93 && token <= 133;
  }
  function tokenKeywordOrIdentifierIsKeyword(token) {
    return token <= 92;
  }
  function tokenIsKeywordOrIdentifier(token) {
    return token >= 58 && token <= 133;
  }
  function tokenIsLiteralPropertyName(token) {
    return token >= 58 && token <= 137;
  }
  function tokenComesBeforeExpression(token) {
    return tokenBeforeExprs[token];
  }
  function tokenCanStartExpression(token) {
    return tokenStartsExprs[token];
  }
  function tokenIsAssignment(token) {
    return token >= 29 && token <= 33;
  }
  function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
    return token >= 129 && token <= 131;
  }
  function tokenIsLoop(token) {
    return token >= 90 && token <= 92;
  }
  function tokenIsKeyword(token) {
    return token >= 58 && token <= 92;
  }
  function tokenIsOperator(token) {
    return token >= 39 && token <= 59;
  }
  function tokenIsPostfix(token) {
    return token === 34;
  }
  function tokenIsPrefix(token) {
    return tokenPrefixes[token];
  }
  function tokenIsTSTypeOperator(token) {
    return token >= 121 && token <= 123;
  }
  function tokenIsTSDeclarationStart(token) {
    return token >= 124 && token <= 130;
  }
  function tokenLabelName(token) {
    return tokenLabels[token];
  }
  function tokenOperatorPrecedence(token) {
    return tokenBinops[token];
  }
  function tokenIsRightAssociative(token) {
    return token === 57;
  }
  function tokenIsTemplate(token) {
    return token >= 24 && token <= 25;
  }
  function getExportedToken(token) {
    return tokenTypes[token];
  }
  {
    tokenTypes[8].updateContext = context => {
      context.pop();
    };
    tokenTypes[5].updateContext =
      tokenTypes[7].updateContext =
      tokenTypes[23].updateContext =
        context => {
          context.push(types.brace);
        };
    tokenTypes[22].updateContext = context => {
      if (context[context.length - 1] === types.template) {
        context.pop();
      } else {
        context.push(types.template);
      }
    };
    tokenTypes[143].updateContext = context => {
      context.push(types.j_expr, types.j_oTag);
    };
  }
  let nonASCIIidentifierStartChars =
    'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲊᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟍꟐꟑꟓꟕ-Ƛꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
  let nonASCIIidentifierChars =
    '·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛ࢗ-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･';
  const nonASCIIidentifierStart = new RegExp(
    '[' + nonASCIIidentifierStartChars + ']'
  );
  const nonASCIIidentifier = new RegExp(
    '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
  );
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  const astralIdentifierStartCodes = [
    0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48,
    48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5,
    39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 4, 51, 13,
    310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3,
    22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16,
    3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17,
    111, 72, 56, 50, 14, 50, 14, 35, 39, 27, 10, 22, 251, 41, 7, 1, 17, 2, 60,
    28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33,
    24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2,
    24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6,
    2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 31, 9, 2, 0, 3, 0, 2, 37, 2, 0, 26, 0, 2, 0,
    45, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0,
    60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2,
    23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12,
    45, 20, 0, 19, 72, 200, 32, 32, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2,
    37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0,
    80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 26, 3994, 6, 582,
    6842, 29, 1763, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18,
    433, 44, 212, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 42,
    9, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309,
    106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2,
    0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3,
    24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7,
    1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27,
    229, 29, 3, 0, 496, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2,
    26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2,
    2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2,
    3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3,
    5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191,
  ];
  const astralIdentifierCodes = [
    509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1,
    574, 3, 9, 9, 7, 9, 32, 4, 318, 1, 80, 3, 71, 10, 50, 3, 123, 2, 54, 14, 32,
    10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13,
    2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2,
    6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 68, 8, 2, 0, 3, 0, 2, 3, 2, 4, 2,
    0, 15, 1, 83, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16,
    16, 9, 82, 12, 9, 9, 7, 19, 58, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3,
    3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10,
    47, 15, 343, 9, 54, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6,
    2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14,
    10, 5350, 0, 7, 14, 11465, 27, 2343, 9, 87, 9, 39, 4, 60, 6, 26, 9, 535, 9,
    470, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4178, 9, 519, 45, 3, 22, 543,
    4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0,
    23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357,
    0, 62, 13, 499, 13, 245, 1, 2, 9, 726, 6, 110, 6, 6, 9, 4759, 9, 787719,
    239,
  ];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length; i < length; i += 2) {
      pos += set[i];
      if (pos > code) return false;
      pos += set[i + 1];
      if (pos >= code) return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65) return code === 36;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return (
        code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
      );
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48) return code === 36;
    if (code < 58) return true;
    if (code < 65) return false;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return (
      isInAstralSet(code, astralIdentifierStartCodes) ||
      isInAstralSet(code, astralIdentifierCodes)
    );
  }
  const reservedWords = {
    keyword: [
      'break',
      'case',
      'catch',
      'continue',
      'debugger',
      'default',
      'do',
      'else',
      'finally',
      'for',
      'function',
      'if',
      'return',
      'switch',
      'throw',
      'try',
      'var',
      'const',
      'while',
      'with',
      'new',
      'this',
      'super',
      'class',
      'extends',
      'export',
      'import',
      'null',
      'true',
      'false',
      'in',
      'instanceof',
      'typeof',
      'void',
      'delete',
    ],
    strict: [
      'implements',
      'interface',
      'let',
      'package',
      'private',
      'protected',
      'public',
      'static',
      'yield',
    ],
    strictBind: ['eval', 'arguments'],
  };
  const keywords = new Set(reservedWords.keyword);
  const reservedWordsStrictSet = new Set(reservedWords.strict);
  const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return (inModule && word === 'await') || word === 'enum';
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return (
      isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
    );
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  function isIteratorStart(current, next, next2) {
    return current === 64 && next === 64 && isIdentifierStart(next2);
  }
  const reservedWordLikeSet = new Set([
    'break',
    'case',
    'catch',
    'continue',
    'debugger',
    'default',
    'do',
    'else',
    'finally',
    'for',
    'function',
    'if',
    'return',
    'switch',
    'throw',
    'try',
    'var',
    'const',
    'while',
    'with',
    'new',
    'this',
    'super',
    'class',
    'extends',
    'export',
    'import',
    'null',
    'true',
    'false',
    'in',
    'instanceof',
    'typeof',
    'void',
    'delete',
    'implements',
    'interface',
    'let',
    'package',
    'private',
    'protected',
    'public',
    'static',
    'yield',
    'eval',
    'arguments',
    'enum',
    'await',
  ]);
  function canBeReservedWord(word) {
    return reservedWordLikeSet.has(word);
  }
  class Scope {
    constructor(flags) {
      this.flags = 0;
      this.names = new Map();
      this.firstLexicalName = '';
      this.flags = flags;
    }
  }
  class ScopeHandler {
    constructor(parser, inModule) {
      this.parser = void 0;
      this.scopeStack = [];
      this.inModule = void 0;
      this.undefinedExports = new Map();
      this.parser = parser;
      this.inModule = inModule;
    }
    get inTopLevel() {
      return (this.currentScope().flags & 1) > 0;
    }
    get inFunction() {
      return (this.currentVarScopeFlags() & 2) > 0;
    }
    get allowSuper() {
      return (this.currentThisScopeFlags() & 16) > 0;
    }
    get allowDirectSuper() {
      return (this.currentThisScopeFlags() & 32) > 0;
    }
    get inClass() {
      return (this.currentThisScopeFlags() & 64) > 0;
    }
    get inClassAndNotInNonArrowFunction() {
      const flags = this.currentThisScopeFlags();
      return (flags & 64) > 0 && (flags & 2) === 0;
    }
    get inStaticBlock() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & 128) {
          return true;
        }
        if (flags & (387 | 64)) {
          return false;
        }
      }
    }
    get inNonArrowFunction() {
      return (this.currentThisScopeFlags() & 2) > 0;
    }
    get treatFunctionsAsVar() {
      return this.treatFunctionsAsVarInScope(this.currentScope());
    }
    createScope(flags) {
      return new Scope(flags);
    }
    enter(flags) {
      this.scopeStack.push(this.createScope(flags));
    }
    exit() {
      const scope = this.scopeStack.pop();
      return scope.flags;
    }
    treatFunctionsAsVarInScope(scope) {
      return !!(
        scope.flags & (2 | 128) ||
        (!this.parser.inModule && scope.flags & 1)
      );
    }
    declareName(name, bindingType, loc) {
      let scope = this.currentScope();
      if (bindingType & 8 || bindingType & 16) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        let type = scope.names.get(name) || 0;
        if (bindingType & 16) {
          type = type | 4;
        } else {
          if (!scope.firstLexicalName) {
            scope.firstLexicalName = name;
          }
          type = type | 2;
        }
        scope.names.set(name, type);
        if (bindingType & 8) {
          this.maybeExportDefined(scope, name);
        }
      } else if (bindingType & 4) {
        for (let i = this.scopeStack.length - 1; i >= 0; --i) {
          scope = this.scopeStack[i];
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          scope.names.set(name, (scope.names.get(name) || 0) | 1);
          this.maybeExportDefined(scope, name);
          if (scope.flags & 387) break;
        }
      }
      if (this.parser.inModule && scope.flags & 1) {
        this.undefinedExports.delete(name);
      }
    }
    maybeExportDefined(scope, name) {
      if (this.parser.inModule && scope.flags & 1) {
        this.undefinedExports.delete(name);
      }
    }
    checkRedeclarationInScope(scope, name, bindingType, loc) {
      if (this.isRedeclaredInScope(scope, name, bindingType)) {
        this.parser.raise(Errors.VarRedeclaration, loc, {identifierName: name});
      }
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (!(bindingType & 1)) return false;
      if (bindingType & 8) {
        return scope.names.has(name);
      }
      const type = scope.names.get(name);
      if (bindingType & 16) {
        return (
          (type & 2) > 0 ||
          (!this.treatFunctionsAsVarInScope(scope) && (type & 1) > 0)
        );
      }
      return (
        ((type & 2) > 0 &&
          !(scope.flags & 8 && scope.firstLexicalName === name)) ||
        (!this.treatFunctionsAsVarInScope(scope) && (type & 4) > 0)
      );
    }
    checkLocalExport(id) {
      const {name: name} = id;
      const topLevelScope = this.scopeStack[0];
      if (!topLevelScope.names.has(name)) {
        this.undefinedExports.set(name, id.loc.start);
      }
    }
    currentScope() {
      return this.scopeStack[this.scopeStack.length - 1];
    }
    currentVarScopeFlags() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & 387) {
          return flags;
        }
      }
    }
    currentThisScopeFlags() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & (387 | 64) && !(flags & 4)) {
          return flags;
        }
      }
    }
  }
  class FlowScope extends Scope {
    constructor(...args) {
      super(...args);
      this.declareFunctions = new Set();
    }
  }
  class FlowScopeHandler extends ScopeHandler {
    createScope(flags) {
      return new FlowScope(flags);
    }
    declareName(name, bindingType, loc) {
      const scope = this.currentScope();
      if (bindingType & 2048) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        this.maybeExportDefined(scope, name);
        scope.declareFunctions.add(name);
        return;
      }
      super.declareName(name, bindingType, loc);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (super.isRedeclaredInScope(scope, name, bindingType)) return true;
      if (bindingType & 2048 && !scope.declareFunctions.has(name)) {
        const type = scope.names.get(name);
        return (type & 4) > 0 || (type & 2) > 0;
      }
      return false;
    }
    checkLocalExport(id) {
      if (!this.scopeStack[0].declareFunctions.has(id.name)) {
        super.checkLocalExport(id);
      }
    }
  }
  class BaseParser {
    constructor() {
      this.sawUnambiguousESM = false;
      this.ambiguousScriptDifferentAst = false;
    }
    sourceToOffsetPos(sourcePos) {
      return sourcePos + this.startIndex;
    }
    offsetToSourcePos(offsetPos) {
      return offsetPos - this.startIndex;
    }
    hasPlugin(pluginConfig) {
      if (typeof pluginConfig === 'string') {
        return this.plugins.has(pluginConfig);
      } else {
        const [pluginName, pluginOptions] = pluginConfig;
        if (!this.hasPlugin(pluginName)) {
          return false;
        }
        const actualOptions = this.plugins.get(pluginName);
        for (const key of Object.keys(pluginOptions)) {
          if (
            (actualOptions == null ? void 0 : actualOptions[key]) !==
            pluginOptions[key]
          ) {
            return false;
          }
        }
        return true;
      }
    }
    getPluginOption(plugin, name) {
      var _this$plugins$get;
      return (_this$plugins$get = this.plugins.get(plugin)) == null
        ? void 0
        : _this$plugins$get[name];
    }
  }
  function setTrailingComments(node, comments) {
    if (node.trailingComments === undefined) {
      node.trailingComments = comments;
    } else {
      node.trailingComments.unshift(...comments);
    }
  }
  function setLeadingComments(node, comments) {
    if (node.leadingComments === undefined) {
      node.leadingComments = comments;
    } else {
      node.leadingComments.unshift(...comments);
    }
  }
  function setInnerComments(node, comments) {
    if (node.innerComments === undefined) {
      node.innerComments = comments;
    } else {
      node.innerComments.unshift(...comments);
    }
  }
  function adjustInnerComments(node, elements, commentWS) {
    let lastElement = null;
    let i = elements.length;
    while (lastElement === null && i > 0) {
      lastElement = elements[--i];
    }
    if (lastElement === null || lastElement.start > commentWS.start) {
      setInnerComments(node, commentWS.comments);
    } else {
      setTrailingComments(lastElement, commentWS.comments);
    }
  }
  class CommentsParser extends BaseParser {
    addComment(comment) {
      if (this.filename) comment.loc.filename = this.filename;
      const {commentsLen: commentsLen} = this.state;
      if (this.comments.length !== commentsLen) {
        this.comments.length = commentsLen;
      }
      this.comments.push(comment);
      this.state.commentsLen++;
    }
    processComment(node) {
      const {commentStack: commentStack} = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0) return;
      let i = commentStackLength - 1;
      const lastCommentWS = commentStack[i];
      if (lastCommentWS.start === node.end) {
        lastCommentWS.leadingNode = node;
        i--;
      }
      const {start: nodeStart} = node;
      for (; i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        if (commentEnd > nodeStart) {
          commentWS.containingNode = node;
          this.finalizeComment(commentWS);
          commentStack.splice(i, 1);
        } else {
          if (commentEnd === nodeStart) {
            commentWS.trailingNode = node;
          }
          break;
        }
      }
    }
    finalizeComment(commentWS) {
      const {comments: comments} = commentWS;
      if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
        if (commentWS.leadingNode !== null) {
          setTrailingComments(commentWS.leadingNode, comments);
        }
        if (commentWS.trailingNode !== null) {
          setLeadingComments(commentWS.trailingNode, comments);
        }
      } else {
        const {containingNode: node, start: commentStart} = commentWS;
        if (
          this.input.charCodeAt(this.offsetToSourcePos(commentStart) - 1) === 44
        ) {
          switch (node.type) {
            case 'ObjectExpression':
            case 'ObjectPattern':
            case 'RecordExpression':
              adjustInnerComments(node, node.properties, commentWS);
              break;
            case 'CallExpression':
            case 'OptionalCallExpression':
              adjustInnerComments(node, node.arguments, commentWS);
              break;
            case 'FunctionDeclaration':
            case 'FunctionExpression':
            case 'ArrowFunctionExpression':
            case 'ObjectMethod':
            case 'ClassMethod':
            case 'ClassPrivateMethod':
              adjustInnerComments(node, node.params, commentWS);
              break;
            case 'ArrayExpression':
            case 'ArrayPattern':
            case 'TupleExpression':
              adjustInnerComments(node, node.elements, commentWS);
              break;
            case 'ExportNamedDeclaration':
            case 'ImportDeclaration':
              adjustInnerComments(node, node.specifiers, commentWS);
              break;
            default: {
              setInnerComments(node, comments);
            }
          }
        } else {
          setInnerComments(node, comments);
        }
      }
    }
    finalizeRemainingComments() {
      const {commentStack: commentStack} = this.state;
      for (let i = commentStack.length - 1; i >= 0; i--) {
        this.finalizeComment(commentStack[i]);
      }
      this.state.commentStack = [];
    }
    resetPreviousNodeTrailingComments(node) {
      const {commentStack: commentStack} = this.state;
      const {length: length} = commentStack;
      if (length === 0) return;
      const commentWS = commentStack[length - 1];
      if (commentWS.leadingNode === node) {
        commentWS.leadingNode = null;
      }
    }
    resetPreviousIdentifierLeadingComments(node) {
      const {commentStack: commentStack} = this.state;
      const {length: length} = commentStack;
      if (length === 0) return;
      if (commentStack[length - 1].trailingNode === node) {
        commentStack[length - 1].trailingNode = null;
      } else if (
        length >= 2 &&
        commentStack[length - 2].trailingNode === node
      ) {
        commentStack[length - 2].trailingNode = null;
      }
    }
    takeSurroundingComments(node, start, end) {
      const {commentStack: commentStack} = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0) return;
      let i = commentStackLength - 1;
      for (; i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        const commentStart = commentWS.start;
        if (commentStart === end) {
          commentWS.leadingNode = node;
        } else if (commentEnd === start) {
          commentWS.trailingNode = node;
        } else if (commentEnd < start) {
          break;
        }
      }
    }
  }
  const lineBreak = /\r\n|[\r\n\u2028\u2029]/;
  const lineBreakG = new RegExp(lineBreak.source, 'g');
  function isNewLine(code) {
    switch (code) {
      case 10:
      case 13:
      case 8232:
      case 8233:
        return true;
      default:
        return false;
    }
  }
  function hasNewLine(input, start, end) {
    for (let i = start; i < end; i++) {
      if (isNewLine(input.charCodeAt(i))) {
        return true;
      }
    }
    return false;
  }
  const skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
  const skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
  function isWhitespace(code) {
    switch (code) {
      case 9:
      case 11:
      case 12:
      case 32:
      case 160:
      case 5760:
      case 8192:
      case 8193:
      case 8194:
      case 8195:
      case 8196:
      case 8197:
      case 8198:
      case 8199:
      case 8200:
      case 8201:
      case 8202:
      case 8239:
      case 8287:
      case 12288:
      case 65279:
        return true;
      default:
        return false;
    }
  }
  class State {
    constructor() {
      this.flags = 1024;
      this.startIndex = void 0;
      this.curLine = void 0;
      this.lineStart = void 0;
      this.startLoc = void 0;
      this.endLoc = void 0;
      this.errors = [];
      this.potentialArrowAt = -1;
      this.noArrowAt = [];
      this.noArrowParamsConversionAt = [];
      this.topicContext = {maxNumOfResolvableTopics: 0, maxTopicIndex: null};
      this.labels = [];
      this.commentsLen = 0;
      this.commentStack = [];
      this.pos = 0;
      this.type = 140;
      this.value = null;
      this.start = 0;
      this.end = 0;
      this.lastTokEndLoc = null;
      this.lastTokStartLoc = null;
      this.context = [types.brace];
      this.firstInvalidTemplateEscapePos = null;
      this.strictErrors = new Map();
      this.tokensLength = 0;
    }
    get strict() {
      return (this.flags & 1) > 0;
    }
    set strict(v) {
      if (v) this.flags |= 1;
      else this.flags &= -2;
    }
    init({
      strictMode: strictMode,
      sourceType: sourceType,
      startIndex: startIndex,
      startLine: startLine,
      startColumn: startColumn,
    }) {
      this.strict =
        strictMode === false
          ? false
          : strictMode === true
            ? true
            : sourceType === 'module';
      this.startIndex = startIndex;
      this.curLine = startLine;
      this.lineStart = -startColumn;
      this.startLoc = this.endLoc = new Position(
        startLine,
        startColumn,
        startIndex
      );
    }
    get maybeInArrowParameters() {
      return (this.flags & 2) > 0;
    }
    set maybeInArrowParameters(v) {
      if (v) this.flags |= 2;
      else this.flags &= -3;
    }
    get inType() {
      return (this.flags & 4) > 0;
    }
    set inType(v) {
      if (v) this.flags |= 4;
      else this.flags &= -5;
    }
    get noAnonFunctionType() {
      return (this.flags & 8) > 0;
    }
    set noAnonFunctionType(v) {
      if (v) this.flags |= 8;
      else this.flags &= -9;
    }
    get hasFlowComment() {
      return (this.flags & 16) > 0;
    }
    set hasFlowComment(v) {
      if (v) this.flags |= 16;
      else this.flags &= -17;
    }
    get isAmbientContext() {
      return (this.flags & 32) > 0;
    }
    set isAmbientContext(v) {
      if (v) this.flags |= 32;
      else this.flags &= -33;
    }
    get inAbstractClass() {
      return (this.flags & 64) > 0;
    }
    set inAbstractClass(v) {
      if (v) this.flags |= 64;
      else this.flags &= -65;
    }
    get inDisallowConditionalTypesContext() {
      return (this.flags & 128) > 0;
    }
    set inDisallowConditionalTypesContext(v) {
      if (v) this.flags |= 128;
      else this.flags &= -129;
    }
    get soloAwait() {
      return (this.flags & 256) > 0;
    }
    set soloAwait(v) {
      if (v) this.flags |= 256;
      else this.flags &= -257;
    }
    get inFSharpPipelineDirectBody() {
      return (this.flags & 512) > 0;
    }
    set inFSharpPipelineDirectBody(v) {
      if (v) this.flags |= 512;
      else this.flags &= -513;
    }
    get canStartJSXElement() {
      return (this.flags & 1024) > 0;
    }
    set canStartJSXElement(v) {
      if (v) this.flags |= 1024;
      else this.flags &= -1025;
    }
    get containsEsc() {
      return (this.flags & 2048) > 0;
    }
    set containsEsc(v) {
      if (v) this.flags |= 2048;
      else this.flags &= -2049;
    }
    get hasTopLevelAwait() {
      return (this.flags & 4096) > 0;
    }
    set hasTopLevelAwait(v) {
      if (v) this.flags |= 4096;
      else this.flags &= -4097;
    }
    curPosition() {
      return new Position(
        this.curLine,
        this.pos - this.lineStart,
        this.pos + this.startIndex
      );
    }
    clone() {
      const state = new State();
      state.flags = this.flags;
      state.startIndex = this.startIndex;
      state.curLine = this.curLine;
      state.lineStart = this.lineStart;
      state.startLoc = this.startLoc;
      state.endLoc = this.endLoc;
      state.errors = this.errors.slice();
      state.potentialArrowAt = this.potentialArrowAt;
      state.noArrowAt = this.noArrowAt.slice();
      state.noArrowParamsConversionAt = this.noArrowParamsConversionAt.slice();
      state.topicContext = this.topicContext;
      state.labels = this.labels.slice();
      state.commentsLen = this.commentsLen;
      state.commentStack = this.commentStack.slice();
      state.pos = this.pos;
      state.type = this.type;
      state.value = this.value;
      state.start = this.start;
      state.end = this.end;
      state.lastTokEndLoc = this.lastTokEndLoc;
      state.lastTokStartLoc = this.lastTokStartLoc;
      state.context = this.context.slice();
      state.firstInvalidTemplateEscapePos = this.firstInvalidTemplateEscapePos;
      state.strictErrors = this.strictErrors;
      state.tokensLength = this.tokensLength;
      return state;
    }
  }
  var _isDigit = function isDigit(code) {
    return code >= 48 && code <= 57;
  };
  const forbiddenNumericSeparatorSiblings = {
    decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
    hex: new Set([46, 88, 95, 120]),
  };
  const isAllowedNumericSeparatorSibling = {
    bin: ch => ch === 48 || ch === 49,
    oct: ch => ch >= 48 && ch <= 55,
    dec: ch => ch >= 48 && ch <= 57,
    hex: ch =>
      (ch >= 48 && ch <= 57) ||
      (ch >= 65 && ch <= 70) ||
      (ch >= 97 && ch <= 102),
  };
  function readStringContents(type, input, pos, lineStart, curLine, errors) {
    const initialPos = pos;
    const initialLineStart = lineStart;
    const initialCurLine = curLine;
    let out = '';
    let firstInvalidLoc = null;
    let chunkStart = pos;
    const {length: length} = input;
    for (;;) {
      if (pos >= length) {
        errors.unterminated(initialPos, initialLineStart, initialCurLine);
        out += input.slice(chunkStart, pos);
        break;
      }
      const ch = input.charCodeAt(pos);
      if (isStringEnd(type, ch, input, pos)) {
        out += input.slice(chunkStart, pos);
        break;
      }
      if (ch === 92) {
        out += input.slice(chunkStart, pos);
        const res = readEscapedChar(
          input,
          pos,
          lineStart,
          curLine,
          type === 'template',
          errors
        );
        if (res.ch === null && !firstInvalidLoc) {
          firstInvalidLoc = {pos: pos, lineStart: lineStart, curLine: curLine};
        } else {
          out += res.ch;
        }
        ({pos: pos, lineStart: lineStart, curLine: curLine} = res);
        chunkStart = pos;
      } else if (ch === 8232 || ch === 8233) {
        ++pos;
        ++curLine;
        lineStart = pos;
      } else if (ch === 10 || ch === 13) {
        if (type === 'template') {
          out += input.slice(chunkStart, pos) + '\n';
          ++pos;
          if (ch === 13 && input.charCodeAt(pos) === 10) {
            ++pos;
          }
          ++curLine;
          chunkStart = lineStart = pos;
        } else {
          errors.unterminated(initialPos, initialLineStart, initialCurLine);
        }
      } else {
        ++pos;
      }
    }
    return {
      pos: pos,
      str: out,
      firstInvalidLoc: firstInvalidLoc,
      lineStart: lineStart,
      curLine: curLine,
      containsInvalid: !!firstInvalidLoc,
    };
  }
  function isStringEnd(type, ch, input, pos) {
    if (type === 'template') {
      return ch === 96 || (ch === 36 && input.charCodeAt(pos + 1) === 123);
    }
    return ch === (type === 'double' ? 34 : 39);
  }
  function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
    const throwOnInvalid = !inTemplate;
    pos++;
    const res = ch => ({
      pos: pos,
      ch: ch,
      lineStart: lineStart,
      curLine: curLine,
    });
    const ch = input.charCodeAt(pos++);
    switch (ch) {
      case 110:
        return res('\n');
      case 114:
        return res('\r');
      case 120: {
        let code;
        ({code: code, pos: pos} = readHexChar(
          input,
          pos,
          lineStart,
          curLine,
          2,
          false,
          throwOnInvalid,
          errors
        ));
        return res(code === null ? null : String.fromCharCode(code));
      }
      case 117: {
        let code;
        ({code: code, pos: pos} = readCodePoint(
          input,
          pos,
          lineStart,
          curLine,
          throwOnInvalid,
          errors
        ));
        return res(code === null ? null : String.fromCodePoint(code));
      }
      case 116:
        return res('\t');
      case 98:
        return res('\b');
      case 118:
        return res('\v');
      case 102:
        return res('\f');
      case 13:
        if (input.charCodeAt(pos) === 10) {
          ++pos;
        }
      case 10:
        lineStart = pos;
        ++curLine;
      case 8232:
      case 8233:
        return res('');
      case 56:
      case 57:
        if (inTemplate) {
          return res(null);
        } else {
          errors.strictNumericEscape(pos - 1, lineStart, curLine);
        }
      default:
        if (ch >= 48 && ch <= 55) {
          const startPos = pos - 1;
          const match = /^[0-7]+/.exec(input.slice(startPos, pos + 2));
          let octalStr = match[0];
          let octal = parseInt(octalStr, 8);
          if (octal > 255) {
            octalStr = octalStr.slice(0, -1);
            octal = parseInt(octalStr, 8);
          }
          pos += octalStr.length - 1;
          const next = input.charCodeAt(pos);
          if (octalStr !== '0' || next === 56 || next === 57) {
            if (inTemplate) {
              return res(null);
            } else {
              errors.strictNumericEscape(startPos, lineStart, curLine);
            }
          }
          return res(String.fromCharCode(octal));
        }
        return res(String.fromCharCode(ch));
    }
  }
  function readHexChar(
    input,
    pos,
    lineStart,
    curLine,
    len,
    forceLen,
    throwOnInvalid,
    errors
  ) {
    const initialPos = pos;
    let n;
    ({n: n, pos: pos} = readInt(
      input,
      pos,
      lineStart,
      curLine,
      16,
      len,
      forceLen,
      false,
      errors,
      !throwOnInvalid
    ));
    if (n === null) {
      if (throwOnInvalid) {
        errors.invalidEscapeSequence(initialPos, lineStart, curLine);
      } else {
        pos = initialPos - 1;
      }
    }
    return {code: n, pos: pos};
  }
  function readInt(
    input,
    pos,
    lineStart,
    curLine,
    radix,
    len,
    forceLen,
    allowNumSeparator,
    errors,
    bailOnError
  ) {
    const start = pos;
    const forbiddenSiblings =
      radix === 16
        ? forbiddenNumericSeparatorSiblings.hex
        : forbiddenNumericSeparatorSiblings.decBinOct;
    const isAllowedSibling =
      radix === 16
        ? isAllowedNumericSeparatorSibling.hex
        : radix === 10
          ? isAllowedNumericSeparatorSibling.dec
          : radix === 8
            ? isAllowedNumericSeparatorSibling.oct
            : isAllowedNumericSeparatorSibling.bin;
    let invalid = false;
    let total = 0;
    for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
      const code = input.charCodeAt(pos);
      let val;
      if (code === 95 && allowNumSeparator !== 'bail') {
        const prev = input.charCodeAt(pos - 1);
        const next = input.charCodeAt(pos + 1);
        if (!allowNumSeparator) {
          if (bailOnError) return {n: null, pos: pos};
          errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
        } else if (
          Number.isNaN(next) ||
          !isAllowedSibling(next) ||
          forbiddenSiblings.has(prev) ||
          forbiddenSiblings.has(next)
        ) {
          if (bailOnError) return {n: null, pos: pos};
          errors.unexpectedNumericSeparator(pos, lineStart, curLine);
        }
        ++pos;
        continue;
      }
      if (code >= 97) {
        val = code - 97 + 10;
      } else if (code >= 65) {
        val = code - 65 + 10;
      } else if (_isDigit(code)) {
        val = code - 48;
      } else {
        val = Infinity;
      }
      if (val >= radix) {
        if (val <= 9 && bailOnError) {
          return {n: null, pos: pos};
        } else if (
          val <= 9 &&
          errors.invalidDigit(pos, lineStart, curLine, radix)
        ) {
          val = 0;
        } else if (forceLen) {
          val = 0;
          invalid = true;
        } else {
          break;
        }
      }
      ++pos;
      total = total * radix + val;
    }
    if (pos === start || (len != null && pos - start !== len) || invalid) {
      return {n: null, pos: pos};
    }
    return {n: total, pos: pos};
  }
  function readCodePoint(
    input,
    pos,
    lineStart,
    curLine,
    throwOnInvalid,
    errors
  ) {
    const ch = input.charCodeAt(pos);
    let code;
    if (ch === 123) {
      ++pos;
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        input.indexOf('}', pos) - pos,
        true,
        throwOnInvalid,
        errors
      ));
      ++pos;
      if (code !== null && code > 1114111) {
        if (throwOnInvalid) {
          errors.invalidCodePoint(pos, lineStart, curLine);
        } else {
          return {code: null, pos: pos};
        }
      }
    } else {
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        4,
        false,
        throwOnInvalid,
        errors
      ));
    }
    return {code: code, pos: pos};
  }
  function buildPosition(pos, lineStart, curLine) {
    return new Position(curLine, pos - lineStart, pos);
  }
  const VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
  class Token {
    constructor(state) {
      const startIndex = state.startIndex || 0;
      this.type = state.type;
      this.value = state.value;
      this.start = startIndex + state.start;
      this.end = startIndex + state.end;
      this.loc = new SourceLocation(state.startLoc, state.endLoc);
    }
  }
  class Tokenizer extends CommentsParser {
    constructor(options, input) {
      super();
      this.isLookahead = void 0;
      this.tokens = [];
      this.errorHandlers_readInt = {
        invalidDigit: (pos, lineStart, curLine, radix) => {
          if (!this.options.errorRecovery) return false;
          this.raise(
            Errors.InvalidDigit,
            buildPosition(pos, lineStart, curLine),
            {radix: radix}
          );
          return true;
        },
        numericSeparatorInEscapeSequence: this.errorBuilder(
          Errors.NumericSeparatorInEscapeSequence
        ),
        unexpectedNumericSeparator: this.errorBuilder(
          Errors.UnexpectedNumericSeparator
        ),
      };
      this.errorHandlers_readCodePoint = Object.assign(
        {},
        this.errorHandlers_readInt,
        {
          invalidEscapeSequence: this.errorBuilder(
            Errors.InvalidEscapeSequence
          ),
          invalidCodePoint: this.errorBuilder(Errors.InvalidCodePoint),
        }
      );
      this.errorHandlers_readStringContents_string = Object.assign(
        {},
        this.errorHandlers_readCodePoint,
        {
          strictNumericEscape: (pos, lineStart, curLine) => {
            this.recordStrictModeErrors(
              Errors.StrictNumericEscape,
              buildPosition(pos, lineStart, curLine)
            );
          },
          unterminated: (pos, lineStart, curLine) => {
            throw this.raise(
              Errors.UnterminatedString,
              buildPosition(pos - 1, lineStart, curLine)
            );
          },
        }
      );
      this.errorHandlers_readStringContents_template = Object.assign(
        {},
        this.errorHandlers_readCodePoint,
        {
          strictNumericEscape: this.errorBuilder(Errors.StrictNumericEscape),
          unterminated: (pos, lineStart, curLine) => {
            throw this.raise(
              Errors.UnterminatedTemplate,
              buildPosition(pos, lineStart, curLine)
            );
          },
        }
      );
      this.state = new State();
      this.state.init(options);
      this.input = input;
      this.length = input.length;
      this.comments = [];
      this.isLookahead = false;
    }
    pushToken(token) {
      this.tokens.length = this.state.tokensLength;
      this.tokens.push(token);
      ++this.state.tokensLength;
    }
    next() {
      this.checkKeywordEscapes();
      if (this.options.tokens) {
        this.pushToken(new Token(this.state));
      }
      this.state.lastTokEndLoc = this.state.endLoc;
      this.state.lastTokStartLoc = this.state.startLoc;
      this.nextToken();
    }
    eat(type) {
      if (this.match(type)) {
        this.next();
        return true;
      } else {
        return false;
      }
    }
    match(type) {
      return this.state.type === type;
    }
    createLookaheadState(state) {
      return {
        pos: state.pos,
        value: null,
        type: state.type,
        start: state.start,
        end: state.end,
        context: [this.curContext()],
        inType: state.inType,
        startLoc: state.startLoc,
        lastTokEndLoc: state.lastTokEndLoc,
        curLine: state.curLine,
        lineStart: state.lineStart,
        curPosition: state.curPosition,
      };
    }
    lookahead() {
      const old = this.state;
      this.state = this.createLookaheadState(old);
      this.isLookahead = true;
      this.nextToken();
      this.isLookahead = false;
      const curr = this.state;
      this.state = old;
      return curr;
    }
    nextTokenStart() {
      return this.nextTokenStartSince(this.state.pos);
    }
    nextTokenStartSince(pos) {
      skipWhiteSpace.lastIndex = pos;
      return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
    }
    lookaheadCharCode() {
      return this.input.charCodeAt(this.nextTokenStart());
    }
    nextTokenInLineStart() {
      return this.nextTokenInLineStartSince(this.state.pos);
    }
    nextTokenInLineStartSince(pos) {
      skipWhiteSpaceInLine.lastIndex = pos;
      return skipWhiteSpaceInLine.test(this.input)
        ? skipWhiteSpaceInLine.lastIndex
        : pos;
    }
    lookaheadInLineCharCode() {
      return this.input.charCodeAt(this.nextTokenInLineStart());
    }
    codePointAtPos(pos) {
      let cp = this.input.charCodeAt(pos);
      if ((cp & 64512) === 55296 && ++pos < this.input.length) {
        const trail = this.input.charCodeAt(pos);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      return cp;
    }
    setStrict(strict) {
      this.state.strict = strict;
      if (strict) {
        this.state.strictErrors.forEach(([toParseError, at]) =>
          this.raise(toParseError, at)
        );
        this.state.strictErrors.clear();
      }
    }
    curContext() {
      return this.state.context[this.state.context.length - 1];
    }
    nextToken() {
      this.skipSpace();
      this.state.start = this.state.pos;
      if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
      if (this.state.pos >= this.length) {
        this.finishToken(140);
        return;
      }
      this.getTokenFromCode(this.codePointAtPos(this.state.pos));
    }
    skipBlockComment(commentEnd) {
      let startLoc;
      if (!this.isLookahead) startLoc = this.state.curPosition();
      const start = this.state.pos;
      const end = this.input.indexOf(commentEnd, start + 2);
      if (end === -1) {
        throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
      }
      this.state.pos = end + commentEnd.length;
      lineBreakG.lastIndex = start + 2;
      while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
        ++this.state.curLine;
        this.state.lineStart = lineBreakG.lastIndex;
      }
      if (this.isLookahead) return;
      const comment = {
        type: 'CommentBlock',
        value: this.input.slice(start + 2, end),
        start: this.sourceToOffsetPos(start),
        end: this.sourceToOffsetPos(end + commentEnd.length),
        loc: new SourceLocation(startLoc, this.state.curPosition()),
      };
      if (this.options.tokens) this.pushToken(comment);
      return comment;
    }
    skipLineComment(startSkip) {
      const start = this.state.pos;
      let startLoc;
      if (!this.isLookahead) startLoc = this.state.curPosition();
      let ch = this.input.charCodeAt((this.state.pos += startSkip));
      if (this.state.pos < this.length) {
        while (!isNewLine(ch) && ++this.state.pos < this.length) {
          ch = this.input.charCodeAt(this.state.pos);
        }
      }
      if (this.isLookahead) return;
      const end = this.state.pos;
      const value = this.input.slice(start + startSkip, end);
      const comment = {
        type: 'CommentLine',
        value: value,
        start: this.sourceToOffsetPos(start),
        end: this.sourceToOffsetPos(end),
        loc: new SourceLocation(startLoc, this.state.curPosition()),
      };
      if (this.options.tokens) this.pushToken(comment);
      return comment;
    }
    skipSpace() {
      const spaceStart = this.state.pos;
      const comments = [];
      loop: while (this.state.pos < this.length) {
        const ch = this.input.charCodeAt(this.state.pos);
        switch (ch) {
          case 32:
          case 160:
          case 9:
            ++this.state.pos;
            break;
          case 13:
            if (this.input.charCodeAt(this.state.pos + 1) === 10) {
              ++this.state.pos;
            }
          case 10:
          case 8232:
          case 8233:
            ++this.state.pos;
            ++this.state.curLine;
            this.state.lineStart = this.state.pos;
            break;
          case 47:
            switch (this.input.charCodeAt(this.state.pos + 1)) {
              case 42: {
                const comment = this.skipBlockComment('*/');
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
                break;
              }
              case 47: {
                const comment = this.skipLineComment(2);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
                break;
              }
              default:
                break loop;
            }
            break;
          default:
            if (isWhitespace(ch)) {
              ++this.state.pos;
            } else if (ch === 45 && !this.inModule && this.options.annexB) {
              const pos = this.state.pos;
              if (
                this.input.charCodeAt(pos + 1) === 45 &&
                this.input.charCodeAt(pos + 2) === 62 &&
                (spaceStart === 0 || this.state.lineStart > spaceStart)
              ) {
                const comment = this.skipLineComment(3);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
              } else {
                break loop;
              }
            } else if (ch === 60 && !this.inModule && this.options.annexB) {
              const pos = this.state.pos;
              if (
                this.input.charCodeAt(pos + 1) === 33 &&
                this.input.charCodeAt(pos + 2) === 45 &&
                this.input.charCodeAt(pos + 3) === 45
              ) {
                const comment = this.skipLineComment(4);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
              } else {
                break loop;
              }
            } else {
              break loop;
            }
        }
      }
      if (comments.length > 0) {
        const end = this.state.pos;
        const commentWhitespace = {
          start: this.sourceToOffsetPos(spaceStart),
          end: this.sourceToOffsetPos(end),
          comments: comments,
          leadingNode: null,
          trailingNode: null,
          containingNode: null,
        };
        this.state.commentStack.push(commentWhitespace);
      }
    }
    finishToken(type, val) {
      this.state.end = this.state.pos;
      this.state.endLoc = this.state.curPosition();
      const prevType = this.state.type;
      this.state.type = type;
      this.state.value = val;
      if (!this.isLookahead) {
        this.updateContext(prevType);
      }
    }
    replaceToken(type) {
      this.state.type = type;
      this.updateContext();
    }
    readToken_numberSign() {
      if (this.state.pos === 0 && this.readToken_interpreter()) {
        return;
      }
      const nextPos = this.state.pos + 1;
      const next = this.codePointAtPos(nextPos);
      if (next >= 48 && next <= 57) {
        throw this.raise(
          Errors.UnexpectedDigitAfterHash,
          this.state.curPosition()
        );
      }
      if (next === 123 || (next === 91 && this.hasPlugin('recordAndTuple'))) {
        this.expectPlugin('recordAndTuple');
        if (this.getPluginOption('recordAndTuple', 'syntaxType') === 'bar') {
          throw this.raise(
            next === 123
              ? Errors.RecordExpressionHashIncorrectStartSyntaxType
              : Errors.TupleExpressionHashIncorrectStartSyntaxType,
            this.state.curPosition()
          );
        }
        this.state.pos += 2;
        if (next === 123) {
          this.finishToken(7);
        } else {
          this.finishToken(1);
        }
      } else if (isIdentifierStart(next)) {
        ++this.state.pos;
        this.finishToken(139, this.readWord1(next));
      } else if (next === 92) {
        ++this.state.pos;
        this.finishToken(139, this.readWord1());
      } else {
        this.finishOp(27, 1);
      }
    }
    readToken_dot() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next >= 48 && next <= 57) {
        this.readNumber(true);
        return;
      }
      if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
        this.state.pos += 3;
        this.finishToken(21);
      } else {
        ++this.state.pos;
        this.finishToken(16);
      }
    }
    readToken_slash() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(31, 2);
      } else {
        this.finishOp(56, 1);
      }
    }
    readToken_interpreter() {
      if (this.state.pos !== 0 || this.length < 2) return false;
      let ch = this.input.charCodeAt(this.state.pos + 1);
      if (ch !== 33) return false;
      const start = this.state.pos;
      this.state.pos += 1;
      while (!isNewLine(ch) && ++this.state.pos < this.length) {
        ch = this.input.charCodeAt(this.state.pos);
      }
      const value = this.input.slice(start + 2, this.state.pos);
      this.finishToken(28, value);
      return true;
    }
    readToken_mult_modulo(code) {
      let type = code === 42 ? 55 : 54;
      let width = 1;
      let next = this.input.charCodeAt(this.state.pos + 1);
      if (code === 42 && next === 42) {
        width++;
        next = this.input.charCodeAt(this.state.pos + 2);
        type = 57;
      }
      if (next === 61 && !this.state.inType) {
        width++;
        type = code === 37 ? 33 : 30;
      }
      this.finishOp(type, width);
    }
    readToken_pipe_amp(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code) {
        if (this.input.charCodeAt(this.state.pos + 2) === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(code === 124 ? 41 : 42, 2);
        }
        return;
      }
      if (code === 124) {
        if (next === 62) {
          this.finishOp(39, 2);
          return;
        }
        if (this.hasPlugin('recordAndTuple') && next === 125) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(
              Errors.RecordExpressionBarIncorrectEndSyntaxType,
              this.state.curPosition()
            );
          }
          this.state.pos += 2;
          this.finishToken(9);
          return;
        }
        if (this.hasPlugin('recordAndTuple') && next === 93) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(
              Errors.TupleExpressionBarIncorrectEndSyntaxType,
              this.state.curPosition()
            );
          }
          this.state.pos += 2;
          this.finishToken(4);
          return;
        }
      }
      if (next === 61) {
        this.finishOp(30, 2);
        return;
      }
      this.finishOp(code === 124 ? 43 : 45, 1);
    }
    readToken_caret() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61 && !this.state.inType) {
        this.finishOp(32, 2);
      } else if (
        next === 94 &&
        this.hasPlugin([
          'pipelineOperator',
          {proposal: 'hack', topicToken: '^^'},
        ])
      ) {
        this.finishOp(37, 2);
        const lookaheadCh = this.input.codePointAt(this.state.pos);
        if (lookaheadCh === 94) {
          this.unexpected();
        }
      } else {
        this.finishOp(44, 1);
      }
    }
    readToken_atSign() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (
        next === 64 &&
        this.hasPlugin([
          'pipelineOperator',
          {proposal: 'hack', topicToken: '@@'},
        ])
      ) {
        this.finishOp(38, 2);
      } else {
        this.finishOp(26, 1);
      }
    }
    readToken_plus_min(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code) {
        this.finishOp(34, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(30, 2);
      } else {
        this.finishOp(53, 1);
      }
    }
    readToken_lt() {
      const {pos: pos} = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 60) {
        if (this.input.charCodeAt(pos + 2) === 61) {
          this.finishOp(30, 3);
          return;
        }
        this.finishOp(51, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(47, 1);
    }
    readToken_gt() {
      const {pos: pos} = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 62) {
        const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
        if (this.input.charCodeAt(pos + size) === 61) {
          this.finishOp(30, size + 1);
          return;
        }
        this.finishOp(52, size);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(48, 1);
    }
    readToken_eq_excl(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(
          46,
          this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2
        );
        return;
      }
      if (code === 61 && next === 62) {
        this.state.pos += 2;
        this.finishToken(19);
        return;
      }
      this.finishOp(code === 61 ? 29 : 35, 1);
    }
    readToken_question() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      const next2 = this.input.charCodeAt(this.state.pos + 2);
      if (next === 63) {
        if (next2 === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(40, 2);
        }
      } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
        this.state.pos += 2;
        this.finishToken(18);
      } else {
        ++this.state.pos;
        this.finishToken(17);
      }
    }
    getTokenFromCode(code) {
      switch (code) {
        case 46:
          this.readToken_dot();
          return;
        case 40:
          ++this.state.pos;
          this.finishToken(10);
          return;
        case 41:
          ++this.state.pos;
          this.finishToken(11);
          return;
        case 59:
          ++this.state.pos;
          this.finishToken(13);
          return;
        case 44:
          ++this.state.pos;
          this.finishToken(12);
          return;
        case 91:
          if (
            this.hasPlugin('recordAndTuple') &&
            this.input.charCodeAt(this.state.pos + 1) === 124
          ) {
            if (
              this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar'
            ) {
              throw this.raise(
                Errors.TupleExpressionBarIncorrectStartSyntaxType,
                this.state.curPosition()
              );
            }
            this.state.pos += 2;
            this.finishToken(2);
          } else {
            ++this.state.pos;
            this.finishToken(0);
          }
          return;
        case 93:
          ++this.state.pos;
          this.finishToken(3);
          return;
        case 123:
          if (
            this.hasPlugin('recordAndTuple') &&
            this.input.charCodeAt(this.state.pos + 1) === 124
          ) {
            if (
              this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar'
            ) {
              throw this.raise(
                Errors.RecordExpressionBarIncorrectStartSyntaxType,
                this.state.curPosition()
              );
            }
            this.state.pos += 2;
            this.finishToken(6);
          } else {
            ++this.state.pos;
            this.finishToken(5);
          }
          return;
        case 125:
          ++this.state.pos;
          this.finishToken(8);
          return;
        case 58:
          if (
            this.hasPlugin('functionBind') &&
            this.input.charCodeAt(this.state.pos + 1) === 58
          ) {
            this.finishOp(15, 2);
          } else {
            ++this.state.pos;
            this.finishToken(14);
          }
          return;
        case 63:
          this.readToken_question();
          return;
        case 96:
          this.readTemplateToken();
          return;
        case 48: {
          const next = this.input.charCodeAt(this.state.pos + 1);
          if (next === 120 || next === 88) {
            this.readRadixNumber(16);
            return;
          }
          if (next === 111 || next === 79) {
            this.readRadixNumber(8);
            return;
          }
          if (next === 98 || next === 66) {
            this.readRadixNumber(2);
            return;
          }
        }
        case 49:
        case 50:
        case 51:
        case 52:
        case 53:
        case 54:
        case 55:
        case 56:
        case 57:
          this.readNumber(false);
          return;
        case 34:
        case 39:
          this.readString(code);
          return;
        case 47:
          this.readToken_slash();
          return;
        case 37:
        case 42:
          this.readToken_mult_modulo(code);
          return;
        case 124:
        case 38:
          this.readToken_pipe_amp(code);
          return;
        case 94:
          this.readToken_caret();
          return;
        case 43:
        case 45:
          this.readToken_plus_min(code);
          return;
        case 60:
          this.readToken_lt();
          return;
        case 62:
          this.readToken_gt();
          return;
        case 61:
        case 33:
          this.readToken_eq_excl(code);
          return;
        case 126:
          this.finishOp(36, 1);
          return;
        case 64:
          this.readToken_atSign();
          return;
        case 35:
          this.readToken_numberSign();
          return;
        case 92:
          this.readWord();
          return;
        default:
          if (isIdentifierStart(code)) {
            this.readWord(code);
            return;
          }
      }
      throw this.raise(
        Errors.InvalidOrUnexpectedToken,
        this.state.curPosition(),
        {unexpected: String.fromCodePoint(code)}
      );
    }
    finishOp(type, size) {
      const str = this.input.slice(this.state.pos, this.state.pos + size);
      this.state.pos += size;
      this.finishToken(type, str);
    }
    readRegexp() {
      const startLoc = this.state.startLoc;
      const start = this.state.start + 1;
      let escaped, inClass;
      let {pos: pos} = this.state;
      for (; ; ++pos) {
        if (pos >= this.length) {
          throw this.raise(
            Errors.UnterminatedRegExp,
            createPositionWithColumnOffset(startLoc, 1)
          );
        }
        const ch = this.input.charCodeAt(pos);
        if (isNewLine(ch)) {
          throw this.raise(
            Errors.UnterminatedRegExp,
            createPositionWithColumnOffset(startLoc, 1)
          );
        }
        if (escaped) {
          escaped = false;
        } else {
          if (ch === 91) {
            inClass = true;
          } else if (ch === 93 && inClass) {
            inClass = false;
          } else if (ch === 47 && !inClass) {
            break;
          }
          escaped = ch === 92;
        }
      }
      const content = this.input.slice(start, pos);
      ++pos;
      let mods = '';
      const nextPos = () =>
        createPositionWithColumnOffset(startLoc, pos + 2 - start);
      while (pos < this.length) {
        const cp = this.codePointAtPos(pos);
        const char = String.fromCharCode(cp);
        if (VALID_REGEX_FLAGS.has(cp)) {
          if (cp === 118) {
            if (mods.includes('u')) {
              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
            }
          } else if (cp === 117) {
            if (mods.includes('v')) {
              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
            }
          }
          if (mods.includes(char)) {
            this.raise(Errors.DuplicateRegExpFlags, nextPos());
          }
        } else if (isIdentifierChar(cp) || cp === 92) {
          this.raise(Errors.MalformedRegExpFlags, nextPos());
        } else {
          break;
        }
        ++pos;
        mods += char;
      }
      this.state.pos = pos;
      this.finishToken(138, {pattern: content, flags: mods});
    }
    readInt(radix, len, forceLen = false, allowNumSeparator = true) {
      const {n: n, pos: pos} = readInt(
        this.input,
        this.state.pos,
        this.state.lineStart,
        this.state.curLine,
        radix,
        len,
        forceLen,
        allowNumSeparator,
        this.errorHandlers_readInt,
        false
      );
      this.state.pos = pos;
      return n;
    }
    readRadixNumber(radix) {
      const start = this.state.pos;
      const startLoc = this.state.curPosition();
      let isBigInt = false;
      this.state.pos += 2;
      const val = this.readInt(radix);
      if (val == null) {
        this.raise(
          Errors.InvalidDigit,
          createPositionWithColumnOffset(startLoc, 2),
          {radix: radix}
        );
      }
      const next = this.input.charCodeAt(this.state.pos);
      if (next === 110) {
        ++this.state.pos;
        isBigInt = true;
      } else if (next === 109) {
        throw this.raise(Errors.InvalidDecimal, startLoc);
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
      }
      if (isBigInt) {
        const str = this.input
          .slice(start, this.state.pos)
          .replace(/[_n]/g, '');
        this.finishToken(136, str);
        return;
      }
      this.finishToken(135, val);
    }
    readNumber(startsWithDot) {
      const start = this.state.pos;
      const startLoc = this.state.curPosition();
      let isFloat = false;
      let isBigInt = false;
      let hasExponent = false;
      let isOctal = false;
      if (!startsWithDot && this.readInt(10) === null) {
        this.raise(Errors.InvalidNumber, this.state.curPosition());
      }
      const hasLeadingZero =
        this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
      if (hasLeadingZero) {
        const integer = this.input.slice(start, this.state.pos);
        this.recordStrictModeErrors(Errors.StrictOctalLiteral, startLoc);
        if (!this.state.strict) {
          const underscorePos = integer.indexOf('_');
          if (underscorePos > 0) {
            this.raise(
              Errors.ZeroDigitNumericSeparator,
              createPositionWithColumnOffset(startLoc, underscorePos)
            );
          }
        }
        isOctal = hasLeadingZero && !/[89]/.test(integer);
      }
      let next = this.input.charCodeAt(this.state.pos);
      if (next === 46 && !isOctal) {
        ++this.state.pos;
        this.readInt(10);
        isFloat = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if ((next === 69 || next === 101) && !isOctal) {
        next = this.input.charCodeAt(++this.state.pos);
        if (next === 43 || next === 45) {
          ++this.state.pos;
        }
        if (this.readInt(10) === null) {
          this.raise(Errors.InvalidOrMissingExponent, startLoc);
        }
        isFloat = true;
        hasExponent = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if (next === 110) {
        if (isFloat || hasLeadingZero) {
          this.raise(Errors.InvalidBigIntLiteral, startLoc);
        }
        ++this.state.pos;
        isBigInt = true;
      }
      if (next === 109) {
        this.expectPlugin('decimal', this.state.curPosition());
        if (hasExponent || hasLeadingZero) {
          this.raise(Errors.InvalidDecimal, startLoc);
        }
        ++this.state.pos;
        var isDecimal = true;
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
      }
      const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, '');
      if (isBigInt) {
        this.finishToken(136, str);
        return;
      }
      if (isDecimal) {
        this.finishToken(137, str);
        return;
      }
      const val = isOctal ? parseInt(str, 8) : parseFloat(str);
      this.finishToken(135, val);
    }
    readCodePoint(throwOnInvalid) {
      const {code: code, pos: pos} = readCodePoint(
        this.input,
        this.state.pos,
        this.state.lineStart,
        this.state.curLine,
        throwOnInvalid,
        this.errorHandlers_readCodePoint
      );
      this.state.pos = pos;
      return code;
    }
    readString(quote) {
      const {
        str: str,
        pos: pos,
        curLine: curLine,
        lineStart: lineStart,
      } = readStringContents(
        quote === 34 ? 'double' : 'single',
        this.input,
        this.state.pos + 1,
        this.state.lineStart,
        this.state.curLine,
        this.errorHandlers_readStringContents_string
      );
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      this.finishToken(134, str);
    }
    readTemplateContinuation() {
      if (!this.match(8)) {
        this.unexpected(null, 8);
      }
      this.state.pos--;
      this.readTemplateToken();
    }
    readTemplateToken() {
      const opening = this.input[this.state.pos];
      const {
        str: str,
        firstInvalidLoc: firstInvalidLoc,
        pos: pos,
        curLine: curLine,
        lineStart: lineStart,
      } = readStringContents(
        'template',
        this.input,
        this.state.pos + 1,
        this.state.lineStart,
        this.state.curLine,
        this.errorHandlers_readStringContents_template
      );
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      if (firstInvalidLoc) {
        this.state.firstInvalidTemplateEscapePos = new Position(
          firstInvalidLoc.curLine,
          firstInvalidLoc.pos - firstInvalidLoc.lineStart,
          this.sourceToOffsetPos(firstInvalidLoc.pos)
        );
      }
      if (this.input.codePointAt(pos) === 96) {
        this.finishToken(24, firstInvalidLoc ? null : opening + str + '`');
      } else {
        this.state.pos++;
        this.finishToken(25, firstInvalidLoc ? null : opening + str + '${');
      }
    }
    recordStrictModeErrors(toParseError, at) {
      const index = at.index;
      if (this.state.strict && !this.state.strictErrors.has(index)) {
        this.raise(toParseError, at);
      } else {
        this.state.strictErrors.set(index, [toParseError, at]);
      }
    }
    readWord1(firstCode) {
      this.state.containsEsc = false;
      let word = '';
      const start = this.state.pos;
      let chunkStart = this.state.pos;
      if (firstCode !== undefined) {
        this.state.pos += firstCode <= 65535 ? 1 : 2;
      }
      while (this.state.pos < this.length) {
        const ch = this.codePointAtPos(this.state.pos);
        if (isIdentifierChar(ch)) {
          this.state.pos += ch <= 65535 ? 1 : 2;
        } else if (ch === 92) {
          this.state.containsEsc = true;
          word += this.input.slice(chunkStart, this.state.pos);
          const escStart = this.state.curPosition();
          const identifierCheck =
            this.state.pos === start ? isIdentifierStart : isIdentifierChar;
          if (this.input.charCodeAt(++this.state.pos) !== 117) {
            this.raise(Errors.MissingUnicodeEscape, this.state.curPosition());
            chunkStart = this.state.pos - 1;
            continue;
          }
          ++this.state.pos;
          const esc = this.readCodePoint(true);
          if (esc !== null) {
            if (!identifierCheck(esc)) {
              this.raise(Errors.EscapedCharNotAnIdentifier, escStart);
            }
            word += String.fromCodePoint(esc);
          }
          chunkStart = this.state.pos;
        } else {
          break;
        }
      }
      return word + this.input.slice(chunkStart, this.state.pos);
    }
    readWord(firstCode) {
      const word = this.readWord1(firstCode);
      const type = keywords$1.get(word);
      if (type !== undefined) {
        this.finishToken(type, tokenLabelName(type));
      } else {
        this.finishToken(132, word);
      }
    }
    checkKeywordEscapes() {
      const {type: type} = this.state;
      if (tokenIsKeyword(type) && this.state.containsEsc) {
        this.raise(Errors.InvalidEscapedReservedWord, this.state.startLoc, {
          reservedWord: tokenLabelName(type),
        });
      }
    }
    raise(toParseError, at, details = {}) {
      const loc = at instanceof Position ? at : at.loc.start;
      const error = toParseError(loc, details);
      if (!this.options.errorRecovery) throw error;
      if (!this.isLookahead) this.state.errors.push(error);
      return error;
    }
    raiseOverwrite(toParseError, at, details = {}) {
      const loc = at instanceof Position ? at : at.loc.start;
      const pos = loc.index;
      const errors = this.state.errors;
      for (let i = errors.length - 1; i >= 0; i--) {
        const error = errors[i];
        if (error.loc.index === pos) {
          return (errors[i] = toParseError(loc, details));
        }
        if (error.loc.index < pos) break;
      }
      return this.raise(toParseError, at, details);
    }
    updateContext(prevType) {}
    unexpected(loc, type) {
      throw this.raise(
        Errors.UnexpectedToken,
        loc != null ? loc : this.state.startLoc,
        {expected: type ? tokenLabelName(type) : null}
      );
    }
    expectPlugin(pluginName, loc) {
      if (this.hasPlugin(pluginName)) {
        return true;
      }
      throw this.raise(
        Errors.MissingPlugin,
        loc != null ? loc : this.state.startLoc,
        {missingPlugin: [pluginName]}
      );
    }
    expectOnePlugin(pluginNames) {
      if (!pluginNames.some(name => this.hasPlugin(name))) {
        throw this.raise(Errors.MissingOneOfPlugins, this.state.startLoc, {
          missingPlugin: pluginNames,
        });
      }
    }
    errorBuilder(error) {
      return (pos, lineStart, curLine) => {
        this.raise(error, buildPosition(pos, lineStart, curLine));
      };
    }
  }
  class ClassScope {
    constructor() {
      this.privateNames = new Set();
      this.loneAccessors = new Map();
      this.undefinedPrivateNames = new Map();
    }
  }
  class ClassScopeHandler {
    constructor(parser) {
      this.parser = void 0;
      this.stack = [];
      this.undefinedPrivateNames = new Map();
      this.parser = parser;
    }
    current() {
      return this.stack[this.stack.length - 1];
    }
    enter() {
      this.stack.push(new ClassScope());
    }
    exit() {
      const oldClassScope = this.stack.pop();
      const current = this.current();
      for (const [name, loc] of Array.from(
        oldClassScope.undefinedPrivateNames
      )) {
        if (current) {
          if (!current.undefinedPrivateNames.has(name)) {
            current.undefinedPrivateNames.set(name, loc);
          }
        } else {
          this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
            identifierName: name,
          });
        }
      }
    }
    declarePrivateName(name, elementType, loc) {
      const {
        privateNames: privateNames,
        loneAccessors: loneAccessors,
        undefinedPrivateNames: undefinedPrivateNames,
      } = this.current();
      let redefined = privateNames.has(name);
      if (elementType & 3) {
        const accessor = redefined && loneAccessors.get(name);
        if (accessor) {
          const oldStatic = accessor & 4;
          const newStatic = elementType & 4;
          const oldKind = accessor & 3;
          const newKind = elementType & 3;
          redefined = oldKind === newKind || oldStatic !== newStatic;
          if (!redefined) loneAccessors.delete(name);
        } else if (!redefined) {
          loneAccessors.set(name, elementType);
        }
      }
      if (redefined) {
        this.parser.raise(Errors.PrivateNameRedeclaration, loc, {
          identifierName: name,
        });
      }
      privateNames.add(name);
      undefinedPrivateNames.delete(name);
    }
    usePrivateName(name, loc) {
      let classScope;
      for (classScope of this.stack) {
        if (classScope.privateNames.has(name)) return;
      }
      if (classScope) {
        classScope.undefinedPrivateNames.set(name, loc);
      } else {
        this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
          identifierName: name,
        });
      }
    }
  }
  class ExpressionScope {
    constructor(type = 0) {
      this.type = type;
    }
    canBeArrowParameterDeclaration() {
      return this.type === 2 || this.type === 1;
    }
    isCertainlyParameterDeclaration() {
      return this.type === 3;
    }
  }
  class ArrowHeadParsingScope extends ExpressionScope {
    constructor(type) {
      super(type);
      this.declarationErrors = new Map();
    }
    recordDeclarationError(ParsingErrorClass, at) {
      const index = at.index;
      this.declarationErrors.set(index, [ParsingErrorClass, at]);
    }
    clearDeclarationError(index) {
      this.declarationErrors.delete(index);
    }
    iterateErrors(iterator) {
      this.declarationErrors.forEach(iterator);
    }
  }
  class ExpressionScopeHandler {
    constructor(parser) {
      this.parser = void 0;
      this.stack = [new ExpressionScope()];
      this.parser = parser;
    }
    enter(scope) {
      this.stack.push(scope);
    }
    exit() {
      this.stack.pop();
    }
    recordParameterInitializerError(toParseError, node) {
      const origin = node.loc.start;
      const {stack: stack} = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (!scope.isCertainlyParameterDeclaration()) {
        if (scope.canBeArrowParameterDeclaration()) {
          scope.recordDeclarationError(toParseError, origin);
        } else {
          return;
        }
        scope = stack[--i];
      }
      this.parser.raise(toParseError, origin);
    }
    recordArrowParameterBindingError(error, node) {
      const {stack: stack} = this;
      const scope = stack[stack.length - 1];
      const origin = node.loc.start;
      if (scope.isCertainlyParameterDeclaration()) {
        this.parser.raise(error, origin);
      } else if (scope.canBeArrowParameterDeclaration()) {
        scope.recordDeclarationError(error, origin);
      } else {
        return;
      }
    }
    recordAsyncArrowParametersError(at) {
      const {stack: stack} = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (scope.canBeArrowParameterDeclaration()) {
        if (scope.type === 2) {
          scope.recordDeclarationError(Errors.AwaitBindingIdentifier, at);
        }
        scope = stack[--i];
      }
    }
    validateAsPattern() {
      const {stack: stack} = this;
      const currentScope = stack[stack.length - 1];
      if (!currentScope.canBeArrowParameterDeclaration()) return;
      currentScope.iterateErrors(([toParseError, loc]) => {
        this.parser.raise(toParseError, loc);
        let i = stack.length - 2;
        let scope = stack[i];
        while (scope.canBeArrowParameterDeclaration()) {
          scope.clearDeclarationError(loc.index);
          scope = stack[--i];
        }
      });
    }
  }
  function newParameterDeclarationScope() {
    return new ExpressionScope(3);
  }
  function newArrowHeadScope() {
    return new ArrowHeadParsingScope(1);
  }
  function newAsyncArrowScope() {
    return new ArrowHeadParsingScope(2);
  }
  function newExpressionScope() {
    return new ExpressionScope();
  }
  class ProductionParameterHandler {
    constructor() {
      this.stacks = [];
    }
    enter(flags) {
      this.stacks.push(flags);
    }
    exit() {
      this.stacks.pop();
    }
    currentFlags() {
      return this.stacks[this.stacks.length - 1];
    }
    get hasAwait() {
      return (this.currentFlags() & 2) > 0;
    }
    get hasYield() {
      return (this.currentFlags() & 1) > 0;
    }
    get hasReturn() {
      return (this.currentFlags() & 4) > 0;
    }
    get hasIn() {
      return (this.currentFlags() & 8) > 0;
    }
  }
  function functionFlags(isAsync, isGenerator) {
    return (isAsync ? 2 : 0) | (isGenerator ? 1 : 0);
  }
  class UtilParser extends Tokenizer {
    addExtra(node, key, value, enumerable = true) {
      if (!node) return;
      let {extra: extra} = node;
      if (extra == null) {
        extra = {};
        node.extra = extra;
      }
      if (enumerable) {
        extra[key] = value;
      } else {
        Object.defineProperty(extra, key, {
          enumerable: enumerable,
          value: value,
        });
      }
    }
    isContextual(token) {
      return this.state.type === token && !this.state.containsEsc;
    }
    isUnparsedContextual(nameStart, name) {
      const nameEnd = nameStart + name.length;
      if (this.input.slice(nameStart, nameEnd) === name) {
        const nextCh = this.input.charCodeAt(nameEnd);
        return !(isIdentifierChar(nextCh) || (nextCh & 64512) === 55296);
      }
      return false;
    }
    isLookaheadContextual(name) {
      const next = this.nextTokenStart();
      return this.isUnparsedContextual(next, name);
    }
    eatContextual(token) {
      if (this.isContextual(token)) {
        this.next();
        return true;
      }
      return false;
    }
    expectContextual(token, toParseError) {
      if (!this.eatContextual(token)) {
        if (toParseError != null) {
          throw this.raise(toParseError, this.state.startLoc);
        }
        this.unexpected(null, token);
      }
    }
    canInsertSemicolon() {
      return this.match(140) || this.match(8) || this.hasPrecedingLineBreak();
    }
    hasPrecedingLineBreak() {
      return hasNewLine(
        this.input,
        this.offsetToSourcePos(this.state.lastTokEndLoc.index),
        this.state.start
      );
    }
    hasFollowingLineBreak() {
      return hasNewLine(this.input, this.state.end, this.nextTokenStart());
    }
    isLineTerminator() {
      return this.eat(13) || this.canInsertSemicolon();
    }
    semicolon(allowAsi = true) {
      if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
      this.raise(Errors.MissingSemicolon, this.state.lastTokEndLoc);
    }
    expect(type, loc) {
      if (!this.eat(type)) {
        this.unexpected(loc, type);
      }
    }
    tryParse(fn, oldState = this.state.clone()) {
      const abortSignal = {node: null};
      try {
        const node = fn((node = null) => {
          abortSignal.node = node;
          throw abortSignal;
        });
        if (this.state.errors.length > oldState.errors.length) {
          const failState = this.state;
          this.state = oldState;
          this.state.tokensLength = failState.tokensLength;
          return {
            node: node,
            error: failState.errors[oldState.errors.length],
            thrown: false,
            aborted: false,
            failState: failState,
          };
        }
        return {
          node: node,
          error: null,
          thrown: false,
          aborted: false,
          failState: null,
        };
      } catch (error) {
        const failState = this.state;
        this.state = oldState;
        if (error instanceof SyntaxError) {
          return {
            node: null,
            error: error,
            thrown: true,
            aborted: false,
            failState: failState,
          };
        }
        if (error === abortSignal) {
          return {
            node: abortSignal.node,
            error: null,
            thrown: false,
            aborted: true,
            failState: failState,
          };
        }
        throw error;
      }
    }
    checkExpressionErrors(refExpressionErrors, andThrow) {
      if (!refExpressionErrors) return false;
      const {
        shorthandAssignLoc: shorthandAssignLoc,
        doubleProtoLoc: doubleProtoLoc,
        privateKeyLoc: privateKeyLoc,
        optionalParametersLoc: optionalParametersLoc,
      } = refExpressionErrors;
      const hasErrors =
        !!shorthandAssignLoc ||
        !!doubleProtoLoc ||
        !!optionalParametersLoc ||
        !!privateKeyLoc;
      if (!andThrow) {
        return hasErrors;
      }
      if (shorthandAssignLoc != null) {
        this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
      }
      if (doubleProtoLoc != null) {
        this.raise(Errors.DuplicateProto, doubleProtoLoc);
      }
      if (privateKeyLoc != null) {
        this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
      }
      if (optionalParametersLoc != null) {
        this.unexpected(optionalParametersLoc);
      }
    }
    isLiteralPropertyName() {
      return tokenIsLiteralPropertyName(this.state.type);
    }
    isPrivateName(node) {
      return node.type === 'PrivateName';
    }
    getPrivateNameSV(node) {
      return node.id.name;
    }
    hasPropertyAsPrivateName(node) {
      return (
        (node.type === 'MemberExpression' ||
          node.type === 'OptionalMemberExpression') &&
        this.isPrivateName(node.property)
      );
    }
    isObjectProperty(node) {
      return node.type === 'ObjectProperty';
    }
    isObjectMethod(node) {
      return node.type === 'ObjectMethod';
    }
    initializeScopes(inModule = this.options.sourceType === 'module') {
      const oldLabels = this.state.labels;
      this.state.labels = [];
      const oldExportedIdentifiers = this.exportedIdentifiers;
      this.exportedIdentifiers = new Set();
      const oldInModule = this.inModule;
      this.inModule = inModule;
      const oldScope = this.scope;
      const ScopeHandler = this.getScopeHandler();
      this.scope = new ScopeHandler(this, inModule);
      const oldProdParam = this.prodParam;
      this.prodParam = new ProductionParameterHandler();
      const oldClassScope = this.classScope;
      this.classScope = new ClassScopeHandler(this);
      const oldExpressionScope = this.expressionScope;
      this.expressionScope = new ExpressionScopeHandler(this);
      return () => {
        this.state.labels = oldLabels;
        this.exportedIdentifiers = oldExportedIdentifiers;
        this.inModule = oldInModule;
        this.scope = oldScope;
        this.prodParam = oldProdParam;
        this.classScope = oldClassScope;
        this.expressionScope = oldExpressionScope;
      };
    }
    enterInitialScopes() {
      let paramFlags = 0;
      if (this.inModule) {
        paramFlags |= 2;
      }
      this.scope.enter(1);
      this.prodParam.enter(paramFlags);
    }
    checkDestructuringPrivate(refExpressionErrors) {
      const {privateKeyLoc: privateKeyLoc} = refExpressionErrors;
      if (privateKeyLoc !== null) {
        this.expectPlugin('destructuringPrivate', privateKeyLoc);
      }
    }
  }
  class ExpressionErrors {
    constructor() {
      this.shorthandAssignLoc = null;
      this.doubleProtoLoc = null;
      this.privateKeyLoc = null;
      this.optionalParametersLoc = null;
    }
  }
  class Node {
    constructor(parser, pos, loc) {
      this.type = '';
      this.start = pos;
      this.end = 0;
      this.loc = new SourceLocation(loc);
      if (parser != null && parser.options.ranges) this.range = [pos, 0];
      if (parser != null && parser.filename)
        this.loc.filename = parser.filename;
    }
  }
  const NodePrototype = Node.prototype;
  {
    NodePrototype.__clone = function () {
      const newNode = new Node(undefined, this.start, this.loc.start);
      const keys = Object.keys(this);
      for (let i = 0, length = keys.length; i < length; i++) {
        const key = keys[i];
        if (
          key !== 'leadingComments' &&
          key !== 'trailingComments' &&
          key !== 'innerComments'
        ) {
          newNode[key] = this[key];
        }
      }
      return newNode;
    };
  }
  function clonePlaceholder(node) {
    return cloneIdentifier(node);
  }
  function cloneIdentifier(node) {
    const {
      type: type,
      start: start,
      end: end,
      loc: loc,
      range: range,
      extra: extra,
      name: name,
    } = node;
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    cloned.extra = extra;
    cloned.name = name;
    if (type === 'Placeholder') {
      cloned.expectedNode = node.expectedNode;
    }
    return cloned;
  }
  function cloneStringLiteral(node) {
    const {
      type: type,
      start: start,
      end: end,
      loc: loc,
      range: range,
      extra: extra,
    } = node;
    if (type === 'Placeholder') {
      return clonePlaceholder(node);
    }
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    if (node.raw !== undefined) {
      cloned.raw = node.raw;
    } else {
      cloned.extra = extra;
    }
    cloned.value = node.value;
    return cloned;
  }
  class NodeUtils extends UtilParser {
    startNode() {
      const loc = this.state.startLoc;
      return new Node(this, loc.index, loc);
    }
    startNodeAt(loc) {
      return new Node(this, loc.index, loc);
    }
    startNodeAtNode(type) {
      return this.startNodeAt(type.loc.start);
    }
    finishNode(node, type) {
      return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
    }
    finishNodeAt(node, type, endLoc) {
      node.type = type;
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges) node.range[1] = endLoc.index;
      if (this.options.attachComment) this.processComment(node);
      return node;
    }
    resetStartLocation(node, startLoc) {
      node.start = startLoc.index;
      node.loc.start = startLoc;
      if (this.options.ranges) node.range[0] = startLoc.index;
    }
    resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges) node.range[1] = endLoc.index;
    }
    resetStartLocationFromNode(node, locationNode) {
      this.resetStartLocation(node, locationNode.loc.start);
    }
  }
  const reservedTypes = new Set([
    '_',
    'any',
    'bool',
    'boolean',
    'empty',
    'extends',
    'false',
    'interface',
    'mixed',
    'null',
    'number',
    'static',
    'string',
    'true',
    'typeof',
    'void',
  ]);
  const FlowErrors = ParseErrorEnum`flow`({
    AmbiguousConditionalArrow:
      'Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.',
    AmbiguousDeclareModuleKind:
      'Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.',
    AssignReservedType: ({reservedType: reservedType}) =>
      `Cannot overwrite reserved type ${reservedType}.`,
    DeclareClassElement:
      'The `declare` modifier can only appear on class fields.',
    DeclareClassFieldInitializer:
      'Initializers are not allowed in fields with the `declare` modifier.',
    DuplicateDeclareModuleExports:
      'Duplicate `declare module.exports` statement.',
    EnumBooleanMemberNotInitialized: ({
      memberName: memberName,
      enumName: enumName,
    }) =>
      `Boolean enum members need to be initialized. Use either \`${memberName} = true,\` or \`${memberName} = false,\` in enum \`${enumName}\`.`,
    EnumDuplicateMemberName: ({memberName: memberName, enumName: enumName}) =>
      `Enum member names need to be unique, but the name \`${memberName}\` has already been used before in enum \`${enumName}\`.`,
    EnumInconsistentMemberValues: ({enumName: enumName}) =>
      `Enum \`${enumName}\` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.`,
    EnumInvalidExplicitType: ({
      invalidEnumType: invalidEnumType,
      enumName: enumName,
    }) =>
      `Enum type \`${invalidEnumType}\` is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidExplicitTypeUnknownSupplied: ({enumName: enumName}) =>
      `Supplied enum type is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerPrimaryType: ({
      enumName: enumName,
      memberName: memberName,
      explicitType: explicitType,
    }) =>
      `Enum \`${enumName}\` has type \`${explicitType}\`, so the initializer of \`${memberName}\` needs to be a ${explicitType} literal.`,
    EnumInvalidMemberInitializerSymbolType: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `Symbol enum members cannot be initialized. Use \`${memberName},\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerUnknownType: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `The enum member initializer for \`${memberName}\` needs to be a literal (either a boolean, number, or string) in enum \`${enumName}\`.`,
    EnumInvalidMemberName: ({
      enumName: enumName,
      memberName: memberName,
      suggestion: suggestion,
    }) =>
      `Enum member names cannot start with lowercase 'a' through 'z'. Instead of using \`${memberName}\`, consider using \`${suggestion}\`, in enum \`${enumName}\`.`,
    EnumNumberMemberNotInitialized: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `Number enum members need to be initialized, e.g. \`${memberName} = 1\` in enum \`${enumName}\`.`,
    EnumStringMemberInconsistentlyInitialized: ({enumName: enumName}) =>
      `String enum members need to consistently either all use initializers, or use no initializers, in enum \`${enumName}\`.`,
    GetterMayNotHaveThisParam: 'A getter cannot have a `this` parameter.',
    ImportReflectionHasImportType:
      'An `import module` declaration can not use `type` or `typeof` keyword.',
    ImportTypeShorthandOnlyInPureImport:
      'The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.',
    InexactInsideExact:
      'Explicit inexact syntax cannot appear inside an explicit exact object type.',
    InexactInsideNonObject:
      'Explicit inexact syntax cannot appear in class or interface definitions.',
    InexactVariance: 'Explicit inexact syntax cannot have variance.',
    InvalidNonTypeImportInDeclareModule:
      'Imports within a `declare module` body must always be `import type` or `import typeof`.',
    MissingTypeParamDefault:
      'Type parameter declaration needs a default, since a preceding type parameter declaration has a default.',
    NestedDeclareModule:
      '`declare module` cannot be used inside another `declare module`.',
    NestedFlowComment:
      'Cannot have a flow comment inside another flow comment.',
    PatternIsOptional: Object.assign(
      {
        message:
          'A binding pattern parameter cannot be optional in an implementation signature.',
      },
      {reasonCode: 'OptionalBindingPattern'}
    ),
    SetterMayNotHaveThisParam: 'A setter cannot have a `this` parameter.',
    SpreadVariance: 'Spread properties cannot have variance.',
    ThisParamAnnotationRequired:
      'A type annotation is required for the `this` parameter.',
    ThisParamBannedInConstructor:
      "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
    ThisParamMayNotBeOptional: 'The `this` parameter cannot be optional.',
    ThisParamMustBeFirst:
      'The `this` parameter must be the first function parameter.',
    ThisParamNoDefault: 'The `this` parameter may not have a default value.',
    TypeBeforeInitializer:
      'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
    TypeCastInPattern:
      'The type cast expression is expected to be wrapped with parenthesis.',
    UnexpectedExplicitInexactInObject:
      'Explicit inexact syntax must appear at the end of an inexact object.',
    UnexpectedReservedType: ({reservedType: reservedType}) =>
      `Unexpected reserved type ${reservedType}.`,
    UnexpectedReservedUnderscore:
      '`_` is only allowed as a type argument to call or new.',
    UnexpectedSpaceBetweenModuloChecks:
      'Spaces between `%` and `checks` are not allowed here.',
    UnexpectedSpreadType:
      'Spread operator cannot appear in class or interface definitions.',
    UnexpectedSubtractionOperand:
      'Unexpected token, expected "number" or "bigint".',
    UnexpectedTokenAfterTypeParameter:
      'Expected an arrow function after this type parameter declaration.',
    UnexpectedTypeParameterBeforeAsyncArrowFunction:
      'Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.',
    UnsupportedDeclareExportKind: ({
      unsupportedExportKind: unsupportedExportKind,
      suggestion: suggestion,
    }) =>
      `\`declare export ${unsupportedExportKind}\` is not supported. Use \`${suggestion}\` instead.`,
    UnsupportedStatementInDeclareModule:
      'Only declares and type imports are allowed inside declare module.',
    UnterminatedFlowComment: 'Unterminated flow-comment.',
  });
  function isEsModuleType(bodyElement) {
    return (
      bodyElement.type === 'DeclareExportAllDeclaration' ||
      (bodyElement.type === 'DeclareExportDeclaration' &&
        (!bodyElement.declaration ||
          (bodyElement.declaration.type !== 'TypeAlias' &&
            bodyElement.declaration.type !== 'InterfaceDeclaration')))
    );
  }
  function hasTypeImportKind(node) {
    return node.importKind === 'type' || node.importKind === 'typeof';
  }
  const exportSuggestions = {
    const: 'declare export var',
    let: 'declare export var',
    type: 'export type',
    interface: 'export interface',
  };
  function partition(list, test) {
    const list1 = [];
    const list2 = [];
    for (let i = 0; i < list.length; i++) {
      (test(list[i], i, list) ? list1 : list2).push(list[i]);
    }
    return [list1, list2];
  }
  const FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
  var flow = superClass =>
    class FlowParserMixin extends superClass {
      constructor(...args) {
        super(...args);
        this.flowPragma = undefined;
      }
      getScopeHandler() {
        return FlowScopeHandler;
      }
      shouldParseTypes() {
        return (
          this.getPluginOption('flow', 'all') || this.flowPragma === 'flow'
        );
      }
      finishToken(type, val) {
        if (type !== 134 && type !== 13 && type !== 28) {
          if (this.flowPragma === undefined) {
            this.flowPragma = null;
          }
        }
        super.finishToken(type, val);
      }
      addComment(comment) {
        if (this.flowPragma === undefined) {
          const matches = FLOW_PRAGMA_REGEX.exec(comment.value);
          if (!matches);
          else if (matches[1] === 'flow') {
            this.flowPragma = 'flow';
          } else if (matches[1] === 'noflow') {
            this.flowPragma = 'noflow';
          } else {
            throw new Error('Unexpected flow pragma');
          }
        }
        super.addComment(comment);
      }
      flowParseTypeInitialiser(tok) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        this.expect(tok || 14);
        const type = this.flowParseType();
        this.state.inType = oldInType;
        return type;
      }
      flowParsePredicate() {
        const node = this.startNode();
        const moduloLoc = this.state.startLoc;
        this.next();
        this.expectContextual(110);
        if (this.state.lastTokStartLoc.index > moduloLoc.index + 1) {
          this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, moduloLoc);
        }
        if (this.eat(10)) {
          node.value = super.parseExpression();
          this.expect(11);
          return this.finishNode(node, 'DeclaredPredicate');
        } else {
          return this.finishNode(node, 'InferredPredicate');
        }
      }
      flowParseTypeAndPredicateInitialiser() {
        const oldInType = this.state.inType;
        this.state.inType = true;
        this.expect(14);
        let type = null;
        let predicate = null;
        if (this.match(54)) {
          this.state.inType = oldInType;
          predicate = this.flowParsePredicate();
        } else {
          type = this.flowParseType();
          this.state.inType = oldInType;
          if (this.match(54)) {
            predicate = this.flowParsePredicate();
          }
        }
        return [type, predicate];
      }
      flowParseDeclareClass(node) {
        this.next();
        this.flowParseInterfaceish(node, true);
        return this.finishNode(node, 'DeclareClass');
      }
      flowParseDeclareFunction(node) {
        this.next();
        const id = (node.id = this.parseIdentifier());
        const typeNode = this.startNode();
        const typeContainer = this.startNode();
        if (this.match(47)) {
          typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          typeNode.typeParameters = null;
        }
        this.expect(10);
        const tmp = this.flowParseFunctionTypeParams();
        typeNode.params = tmp.params;
        typeNode.rest = tmp.rest;
        typeNode.this = tmp._this;
        this.expect(11);
        [typeNode.returnType, node.predicate] =
          this.flowParseTypeAndPredicateInitialiser();
        typeContainer.typeAnnotation = this.finishNode(
          typeNode,
          'FunctionTypeAnnotation'
        );
        id.typeAnnotation = this.finishNode(typeContainer, 'TypeAnnotation');
        this.resetEndLocation(id);
        this.semicolon();
        this.scope.declareName(node.id.name, 2048, node.id.loc.start);
        return this.finishNode(node, 'DeclareFunction');
      }
      flowParseDeclare(node, insideModule) {
        if (this.match(80)) {
          return this.flowParseDeclareClass(node);
        } else if (this.match(68)) {
          return this.flowParseDeclareFunction(node);
        } else if (this.match(74)) {
          return this.flowParseDeclareVariable(node);
        } else if (this.eatContextual(127)) {
          if (this.match(16)) {
            return this.flowParseDeclareModuleExports(node);
          } else {
            if (insideModule) {
              this.raise(
                FlowErrors.NestedDeclareModule,
                this.state.lastTokStartLoc
              );
            }
            return this.flowParseDeclareModule(node);
          }
        } else if (this.isContextual(130)) {
          return this.flowParseDeclareTypeAlias(node);
        } else if (this.isContextual(131)) {
          return this.flowParseDeclareOpaqueType(node);
        } else if (this.isContextual(129)) {
          return this.flowParseDeclareInterface(node);
        } else if (this.match(82)) {
          return this.flowParseDeclareExportDeclaration(node, insideModule);
        } else {
          this.unexpected();
        }
      }
      flowParseDeclareVariable(node) {
        this.next();
        node.id = this.flowParseTypeAnnotatableIdentifier(true);
        this.scope.declareName(node.id.name, 5, node.id.loc.start);
        this.semicolon();
        return this.finishNode(node, 'DeclareVariable');
      }
      flowParseDeclareModule(node) {
        this.scope.enter(0);
        if (this.match(134)) {
          node.id = super.parseExprAtom();
        } else {
          node.id = this.parseIdentifier();
        }
        const bodyNode = (node.body = this.startNode());
        const body = (bodyNode.body = []);
        this.expect(5);
        while (!this.match(8)) {
          let bodyNode = this.startNode();
          if (this.match(83)) {
            this.next();
            if (!this.isContextual(130) && !this.match(87)) {
              this.raise(
                FlowErrors.InvalidNonTypeImportInDeclareModule,
                this.state.lastTokStartLoc
              );
            }
            super.parseImport(bodyNode);
          } else {
            this.expectContextual(
              125,
              FlowErrors.UnsupportedStatementInDeclareModule
            );
            bodyNode = this.flowParseDeclare(bodyNode, true);
          }
          body.push(bodyNode);
        }
        this.scope.exit();
        this.expect(8);
        this.finishNode(bodyNode, 'BlockStatement');
        let kind = null;
        let hasModuleExport = false;
        body.forEach(bodyElement => {
          if (isEsModuleType(bodyElement)) {
            if (kind === 'CommonJS') {
              this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
            }
            kind = 'ES';
          } else if (bodyElement.type === 'DeclareModuleExports') {
            if (hasModuleExport) {
              this.raise(FlowErrors.DuplicateDeclareModuleExports, bodyElement);
            }
            if (kind === 'ES') {
              this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
            }
            kind = 'CommonJS';
            hasModuleExport = true;
          }
        });
        node.kind = kind || 'CommonJS';
        return this.finishNode(node, 'DeclareModule');
      }
      flowParseDeclareExportDeclaration(node, insideModule) {
        this.expect(82);
        if (this.eat(65)) {
          if (this.match(68) || this.match(80)) {
            node.declaration = this.flowParseDeclare(this.startNode());
          } else {
            node.declaration = this.flowParseType();
            this.semicolon();
          }
          node.default = true;
          return this.finishNode(node, 'DeclareExportDeclaration');
        } else {
          if (
            this.match(75) ||
            this.isLet() ||
            ((this.isContextual(130) || this.isContextual(129)) &&
              !insideModule)
          ) {
            const label = this.state.value;
            throw this.raise(
              FlowErrors.UnsupportedDeclareExportKind,
              this.state.startLoc,
              {
                unsupportedExportKind: label,
                suggestion: exportSuggestions[label],
              }
            );
          }
          if (
            this.match(74) ||
            this.match(68) ||
            this.match(80) ||
            this.isContextual(131)
          ) {
            node.declaration = this.flowParseDeclare(this.startNode());
            node.default = false;
            return this.finishNode(node, 'DeclareExportDeclaration');
          } else if (
            this.match(55) ||
            this.match(5) ||
            this.isContextual(129) ||
            this.isContextual(130) ||
            this.isContextual(131)
          ) {
            node = this.parseExport(node, null);
            if (node.type === 'ExportNamedDeclaration') {
              node.type = 'ExportDeclaration';
              node.default = false;
              delete node.exportKind;
            }
            node.type = 'Declare' + node.type;
            return node;
          }
        }
        this.unexpected();
      }
      flowParseDeclareModuleExports(node) {
        this.next();
        this.expectContextual(111);
        node.typeAnnotation = this.flowParseTypeAnnotation();
        this.semicolon();
        return this.finishNode(node, 'DeclareModuleExports');
      }
      flowParseDeclareTypeAlias(node) {
        this.next();
        const finished = this.flowParseTypeAlias(node);
        finished.type = 'DeclareTypeAlias';
        return finished;
      }
      flowParseDeclareOpaqueType(node) {
        this.next();
        const finished = this.flowParseOpaqueType(node, true);
        finished.type = 'DeclareOpaqueType';
        return finished;
      }
      flowParseDeclareInterface(node) {
        this.next();
        this.flowParseInterfaceish(node, false);
        return this.finishNode(node, 'DeclareInterface');
      }
      flowParseInterfaceish(node, isClass) {
        node.id = this.flowParseRestrictedIdentifier(!isClass, true);
        this.scope.declareName(
          node.id.name,
          isClass ? 17 : 8201,
          node.id.loc.start
        );
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.extends = [];
        if (this.eat(81)) {
          do {
            node.extends.push(this.flowParseInterfaceExtends());
          } while (!isClass && this.eat(12));
        }
        if (isClass) {
          node.implements = [];
          node.mixins = [];
          if (this.eatContextual(117)) {
            do {
              node.mixins.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
          if (this.eatContextual(113)) {
            do {
              node.implements.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
        }
        node.body = this.flowParseObjectType({
          allowStatic: isClass,
          allowExact: false,
          allowSpread: false,
          allowProto: isClass,
          allowInexact: false,
        });
      }
      flowParseInterfaceExtends() {
        const node = this.startNode();
        node.id = this.flowParseQualifiedTypeIdentifier();
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterInstantiation();
        } else {
          node.typeParameters = null;
        }
        return this.finishNode(node, 'InterfaceExtends');
      }
      flowParseInterface(node) {
        this.flowParseInterfaceish(node, false);
        return this.finishNode(node, 'InterfaceDeclaration');
      }
      checkNotUnderscore(word) {
        if (word === '_') {
          this.raise(
            FlowErrors.UnexpectedReservedUnderscore,
            this.state.startLoc
          );
        }
      }
      checkReservedType(word, startLoc, declaration) {
        if (!reservedTypes.has(word)) return;
        this.raise(
          declaration
            ? FlowErrors.AssignReservedType
            : FlowErrors.UnexpectedReservedType,
          startLoc,
          {reservedType: word}
        );
      }
      flowParseRestrictedIdentifier(liberal, declaration) {
        this.checkReservedType(
          this.state.value,
          this.state.startLoc,
          declaration
        );
        return this.parseIdentifier(liberal);
      }
      flowParseTypeAlias(node) {
        node.id = this.flowParseRestrictedIdentifier(false, true);
        this.scope.declareName(node.id.name, 8201, node.id.loc.start);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.right = this.flowParseTypeInitialiser(29);
        this.semicolon();
        return this.finishNode(node, 'TypeAlias');
      }
      flowParseOpaqueType(node, declare) {
        this.expectContextual(130);
        node.id = this.flowParseRestrictedIdentifier(true, true);
        this.scope.declareName(node.id.name, 8201, node.id.loc.start);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.supertype = null;
        if (this.match(14)) {
          node.supertype = this.flowParseTypeInitialiser(14);
        }
        node.impltype = null;
        if (!declare) {
          node.impltype = this.flowParseTypeInitialiser(29);
        }
        this.semicolon();
        return this.finishNode(node, 'OpaqueType');
      }
      flowParseTypeParameter(requireDefault = false) {
        const nodeStartLoc = this.state.startLoc;
        const node = this.startNode();
        const variance = this.flowParseVariance();
        const ident = this.flowParseTypeAnnotatableIdentifier();
        node.name = ident.name;
        node.variance = variance;
        node.bound = ident.typeAnnotation;
        if (this.match(29)) {
          this.eat(29);
          node.default = this.flowParseType();
        } else {
          if (requireDefault) {
            this.raise(FlowErrors.MissingTypeParamDefault, nodeStartLoc);
          }
        }
        return this.finishNode(node, 'TypeParameter');
      }
      flowParseTypeParameterDeclaration() {
        const oldInType = this.state.inType;
        const node = this.startNode();
        node.params = [];
        this.state.inType = true;
        if (this.match(47) || this.match(143)) {
          this.next();
        } else {
          this.unexpected();
        }
        let defaultRequired = false;
        do {
          const typeParameter = this.flowParseTypeParameter(defaultRequired);
          node.params.push(typeParameter);
          if (typeParameter.default) {
            defaultRequired = true;
          }
          if (!this.match(48)) {
            this.expect(12);
          }
        } while (!this.match(48));
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterDeclaration');
      }
      flowParseTypeParameterInstantiation() {
        const node = this.startNode();
        const oldInType = this.state.inType;
        node.params = [];
        this.state.inType = true;
        this.expect(47);
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        this.state.noAnonFunctionType = false;
        while (!this.match(48)) {
          node.params.push(this.flowParseType());
          if (!this.match(48)) {
            this.expect(12);
          }
        }
        this.state.noAnonFunctionType = oldNoAnonFunctionType;
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterInstantiation');
      }
      flowParseTypeParameterInstantiationCallOrNew() {
        const node = this.startNode();
        const oldInType = this.state.inType;
        node.params = [];
        this.state.inType = true;
        this.expect(47);
        while (!this.match(48)) {
          node.params.push(this.flowParseTypeOrImplicitInstantiation());
          if (!this.match(48)) {
            this.expect(12);
          }
        }
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterInstantiation');
      }
      flowParseInterfaceType() {
        const node = this.startNode();
        this.expectContextual(129);
        node.extends = [];
        if (this.eat(81)) {
          do {
            node.extends.push(this.flowParseInterfaceExtends());
          } while (this.eat(12));
        }
        node.body = this.flowParseObjectType({
          allowStatic: false,
          allowExact: false,
          allowSpread: false,
          allowProto: false,
          allowInexact: false,
        });
        return this.finishNode(node, 'InterfaceTypeAnnotation');
      }
      flowParseObjectPropertyKey() {
        return this.match(135) || this.match(134)
          ? super.parseExprAtom()
          : this.parseIdentifier(true);
      }
      flowParseObjectTypeIndexer(node, isStatic, variance) {
        node.static = isStatic;
        if (this.lookahead().type === 14) {
          node.id = this.flowParseObjectPropertyKey();
          node.key = this.flowParseTypeInitialiser();
        } else {
          node.id = null;
          node.key = this.flowParseType();
        }
        this.expect(3);
        node.value = this.flowParseTypeInitialiser();
        node.variance = variance;
        return this.finishNode(node, 'ObjectTypeIndexer');
      }
      flowParseObjectTypeInternalSlot(node, isStatic) {
        node.static = isStatic;
        node.id = this.flowParseObjectPropertyKey();
        this.expect(3);
        this.expect(3);
        if (this.match(47) || this.match(10)) {
          node.method = true;
          node.optional = false;
          node.value = this.flowParseObjectTypeMethodish(
            this.startNodeAt(node.loc.start)
          );
        } else {
          node.method = false;
          if (this.eat(17)) {
            node.optional = true;
          }
          node.value = this.flowParseTypeInitialiser();
        }
        return this.finishNode(node, 'ObjectTypeInternalSlot');
      }
      flowParseObjectTypeMethodish(node) {
        node.params = [];
        node.rest = null;
        node.typeParameters = null;
        node.this = null;
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        this.expect(10);
        if (this.match(78)) {
          node.this = this.flowParseFunctionTypeParam(true);
          node.this.name = null;
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        while (!this.match(11) && !this.match(21)) {
          node.params.push(this.flowParseFunctionTypeParam(false));
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        if (this.eat(21)) {
          node.rest = this.flowParseFunctionTypeParam(false);
        }
        this.expect(11);
        node.returnType = this.flowParseTypeInitialiser();
        return this.finishNode(node, 'FunctionTypeAnnotation');
      }
      flowParseObjectTypeCallProperty(node, isStatic) {
        const valueNode = this.startNode();
        node.static = isStatic;
        node.value = this.flowParseObjectTypeMethodish(valueNode);
        return this.finishNode(node, 'ObjectTypeCallProperty');
      }
      flowParseObjectType({
        allowStatic: allowStatic,
        allowExact: allowExact,
        allowSpread: allowSpread,
        allowProto: allowProto,
        allowInexact: allowInexact,
      }) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        const nodeStart = this.startNode();
        nodeStart.callProperties = [];
        nodeStart.properties = [];
        nodeStart.indexers = [];
        nodeStart.internalSlots = [];
        let endDelim;
        let exact;
        let inexact = false;
        if (allowExact && this.match(6)) {
          this.expect(6);
          endDelim = 9;
          exact = true;
        } else {
          this.expect(5);
          endDelim = 8;
          exact = false;
        }
        nodeStart.exact = exact;
        while (!this.match(endDelim)) {
          let isStatic = false;
          let protoStartLoc = null;
          let inexactStartLoc = null;
          const node = this.startNode();
          if (allowProto && this.isContextual(118)) {
            const lookahead = this.lookahead();
            if (lookahead.type !== 14 && lookahead.type !== 17) {
              this.next();
              protoStartLoc = this.state.startLoc;
              allowStatic = false;
            }
          }
          if (allowStatic && this.isContextual(106)) {
            const lookahead = this.lookahead();
            if (lookahead.type !== 14 && lookahead.type !== 17) {
              this.next();
              isStatic = true;
            }
          }
          const variance = this.flowParseVariance();
          if (this.eat(0)) {
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (this.eat(0)) {
              if (variance) {
                this.unexpected(variance.loc.start);
              }
              nodeStart.internalSlots.push(
                this.flowParseObjectTypeInternalSlot(node, isStatic)
              );
            } else {
              nodeStart.indexers.push(
                this.flowParseObjectTypeIndexer(node, isStatic, variance)
              );
            }
          } else if (this.match(10) || this.match(47)) {
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            nodeStart.callProperties.push(
              this.flowParseObjectTypeCallProperty(node, isStatic)
            );
          } else {
            let kind = 'init';
            if (this.isContextual(99) || this.isContextual(104)) {
              const lookahead = this.lookahead();
              if (tokenIsLiteralPropertyName(lookahead.type)) {
                kind = this.state.value;
                this.next();
              }
            }
            const propOrInexact = this.flowParseObjectTypeProperty(
              node,
              isStatic,
              protoStartLoc,
              variance,
              kind,
              allowSpread,
              allowInexact != null ? allowInexact : !exact
            );
            if (propOrInexact === null) {
              inexact = true;
              inexactStartLoc = this.state.lastTokStartLoc;
            } else {
              nodeStart.properties.push(propOrInexact);
            }
          }
          this.flowObjectTypeSemicolon();
          if (inexactStartLoc && !this.match(8) && !this.match(9)) {
            this.raise(
              FlowErrors.UnexpectedExplicitInexactInObject,
              inexactStartLoc
            );
          }
        }
        this.expect(endDelim);
        if (allowSpread) {
          nodeStart.inexact = inexact;
        }
        const out = this.finishNode(nodeStart, 'ObjectTypeAnnotation');
        this.state.inType = oldInType;
        return out;
      }
      flowParseObjectTypeProperty(
        node,
        isStatic,
        protoStartLoc,
        variance,
        kind,
        allowSpread,
        allowInexact
      ) {
        if (this.eat(21)) {
          const isInexactToken =
            this.match(12) || this.match(13) || this.match(8) || this.match(9);
          if (isInexactToken) {
            if (!allowSpread) {
              this.raise(
                FlowErrors.InexactInsideNonObject,
                this.state.lastTokStartLoc
              );
            } else if (!allowInexact) {
              this.raise(
                FlowErrors.InexactInsideExact,
                this.state.lastTokStartLoc
              );
            }
            if (variance) {
              this.raise(FlowErrors.InexactVariance, variance);
            }
            return null;
          }
          if (!allowSpread) {
            this.raise(
              FlowErrors.UnexpectedSpreadType,
              this.state.lastTokStartLoc
            );
          }
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.raise(FlowErrors.SpreadVariance, variance);
          }
          node.argument = this.flowParseType();
          return this.finishNode(node, 'ObjectTypeSpreadProperty');
        } else {
          node.key = this.flowParseObjectPropertyKey();
          node.static = isStatic;
          node.proto = protoStartLoc != null;
          node.kind = kind;
          let optional = false;
          if (this.match(47) || this.match(10)) {
            node.method = true;
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            node.value = this.flowParseObjectTypeMethodish(
              this.startNodeAt(node.loc.start)
            );
            if (kind === 'get' || kind === 'set') {
              this.flowCheckGetterSetterParams(node);
            }
            if (
              !allowSpread &&
              node.key.name === 'constructor' &&
              node.value.this
            ) {
              this.raise(
                FlowErrors.ThisParamBannedInConstructor,
                node.value.this
              );
            }
          } else {
            if (kind !== 'init') this.unexpected();
            node.method = false;
            if (this.eat(17)) {
              optional = true;
            }
            node.value = this.flowParseTypeInitialiser();
            node.variance = variance;
          }
          node.optional = optional;
          return this.finishNode(node, 'ObjectTypeProperty');
        }
      }
      flowCheckGetterSetterParams(property) {
        const paramCount = property.kind === 'get' ? 0 : 1;
        const length =
          property.value.params.length + (property.value.rest ? 1 : 0);
        if (property.value.this) {
          this.raise(
            property.kind === 'get'
              ? FlowErrors.GetterMayNotHaveThisParam
              : FlowErrors.SetterMayNotHaveThisParam,
            property.value.this
          );
        }
        if (length !== paramCount) {
          this.raise(
            property.kind === 'get'
              ? Errors.BadGetterArity
              : Errors.BadSetterArity,
            property
          );
        }
        if (property.kind === 'set' && property.value.rest) {
          this.raise(Errors.BadSetterRestParameter, property);
        }
      }
      flowObjectTypeSemicolon() {
        if (
          !this.eat(13) &&
          !this.eat(12) &&
          !this.match(8) &&
          !this.match(9)
        ) {
          this.unexpected();
        }
      }
      flowParseQualifiedTypeIdentifier(startLoc, id) {
        var _startLoc;
        (_startLoc = startLoc) != null
          ? _startLoc
          : (startLoc = this.state.startLoc);
        let node = id || this.flowParseRestrictedIdentifier(true);
        while (this.eat(16)) {
          const node2 = this.startNodeAt(startLoc);
          node2.qualification = node;
          node2.id = this.flowParseRestrictedIdentifier(true);
          node = this.finishNode(node2, 'QualifiedTypeIdentifier');
        }
        return node;
      }
      flowParseGenericType(startLoc, id) {
        const node = this.startNodeAt(startLoc);
        node.typeParameters = null;
        node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterInstantiation();
        }
        return this.finishNode(node, 'GenericTypeAnnotation');
      }
      flowParseTypeofType() {
        const node = this.startNode();
        this.expect(87);
        node.argument = this.flowParsePrimaryType();
        return this.finishNode(node, 'TypeofTypeAnnotation');
      }
      flowParseTupleType() {
        const node = this.startNode();
        node.types = [];
        this.expect(0);
        while (this.state.pos < this.length && !this.match(3)) {
          node.types.push(this.flowParseType());
          if (this.match(3)) break;
          this.expect(12);
        }
        this.expect(3);
        return this.finishNode(node, 'TupleTypeAnnotation');
      }
      flowParseFunctionTypeParam(first) {
        let name = null;
        let optional = false;
        let typeAnnotation = null;
        const node = this.startNode();
        const lh = this.lookahead();
        const isThis = this.state.type === 78;
        if (lh.type === 14 || lh.type === 17) {
          if (isThis && !first) {
            this.raise(FlowErrors.ThisParamMustBeFirst, node);
          }
          name = this.parseIdentifier(isThis);
          if (this.eat(17)) {
            optional = true;
            if (isThis) {
              this.raise(FlowErrors.ThisParamMayNotBeOptional, node);
            }
          }
          typeAnnotation = this.flowParseTypeInitialiser();
        } else {
          typeAnnotation = this.flowParseType();
        }
        node.name = name;
        node.optional = optional;
        node.typeAnnotation = typeAnnotation;
        return this.finishNode(node, 'FunctionTypeParam');
      }
      reinterpretTypeAsFunctionTypeParam(type) {
        const node = this.startNodeAt(type.loc.start);
        node.name = null;
        node.optional = false;
        node.typeAnnotation = type;
        return this.finishNode(node, 'FunctionTypeParam');
      }
      flowParseFunctionTypeParams(params = []) {
        let rest = null;
        let _this = null;
        if (this.match(78)) {
          _this = this.flowParseFunctionTypeParam(true);
          _this.name = null;
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        while (!this.match(11) && !this.match(21)) {
          params.push(this.flowParseFunctionTypeParam(false));
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        if (this.eat(21)) {
          rest = this.flowParseFunctionTypeParam(false);
        }
        return {params: params, rest: rest, _this: _this};
      }
      flowIdentToTypeAnnotation(startLoc, node, id) {
        switch (id.name) {
          case 'any':
            return this.finishNode(node, 'AnyTypeAnnotation');
          case 'bool':
          case 'boolean':
            return this.finishNode(node, 'BooleanTypeAnnotation');
          case 'mixed':
            return this.finishNode(node, 'MixedTypeAnnotation');
          case 'empty':
            return this.finishNode(node, 'EmptyTypeAnnotation');
          case 'number':
            return this.finishNode(node, 'NumberTypeAnnotation');
          case 'string':
            return this.finishNode(node, 'StringTypeAnnotation');
          case 'symbol':
            return this.finishNode(node, 'SymbolTypeAnnotation');
          default:
            this.checkNotUnderscore(id.name);
            return this.flowParseGenericType(startLoc, id);
        }
      }
      flowParsePrimaryType() {
        const startLoc = this.state.startLoc;
        const node = this.startNode();
        let tmp;
        let type;
        let isGroupedType = false;
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        switch (this.state.type) {
          case 5:
            return this.flowParseObjectType({
              allowStatic: false,
              allowExact: false,
              allowSpread: true,
              allowProto: false,
              allowInexact: true,
            });
          case 6:
            return this.flowParseObjectType({
              allowStatic: false,
              allowExact: true,
              allowSpread: true,
              allowProto: false,
              allowInexact: false,
            });
          case 0:
            this.state.noAnonFunctionType = false;
            type = this.flowParseTupleType();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            return type;
          case 47: {
            const node = this.startNode();
            node.typeParameters = this.flowParseTypeParameterDeclaration();
            this.expect(10);
            tmp = this.flowParseFunctionTypeParams();
            node.params = tmp.params;
            node.rest = tmp.rest;
            node.this = tmp._this;
            this.expect(11);
            this.expect(19);
            node.returnType = this.flowParseType();
            return this.finishNode(node, 'FunctionTypeAnnotation');
          }
          case 10: {
            const node = this.startNode();
            this.next();
            if (!this.match(11) && !this.match(21)) {
              if (tokenIsIdentifier(this.state.type) || this.match(78)) {
                const token = this.lookahead().type;
                isGroupedType = token !== 17 && token !== 14;
              } else {
                isGroupedType = true;
              }
            }
            if (isGroupedType) {
              this.state.noAnonFunctionType = false;
              type = this.flowParseType();
              this.state.noAnonFunctionType = oldNoAnonFunctionType;
              if (
                this.state.noAnonFunctionType ||
                !(
                  this.match(12) ||
                  (this.match(11) && this.lookahead().type === 19)
                )
              ) {
                this.expect(11);
                return type;
              } else {
                this.eat(12);
              }
            }
            if (type) {
              tmp = this.flowParseFunctionTypeParams([
                this.reinterpretTypeAsFunctionTypeParam(type),
              ]);
            } else {
              tmp = this.flowParseFunctionTypeParams();
            }
            node.params = tmp.params;
            node.rest = tmp.rest;
            node.this = tmp._this;
            this.expect(11);
            this.expect(19);
            node.returnType = this.flowParseType();
            node.typeParameters = null;
            return this.finishNode(node, 'FunctionTypeAnnotation');
          }
          case 134:
            return this.parseLiteral(
              this.state.value,
              'StringLiteralTypeAnnotation'
            );
          case 85:
          case 86:
            node.value = this.match(85);
            this.next();
            return this.finishNode(node, 'BooleanLiteralTypeAnnotation');
          case 53:
            if (this.state.value === '-') {
              this.next();
              if (this.match(135)) {
                return this.parseLiteralAtNode(
                  -this.state.value,
                  'NumberLiteralTypeAnnotation',
                  node
                );
              }
              if (this.match(136)) {
                return this.parseLiteralAtNode(
                  -this.state.value,
                  'BigIntLiteralTypeAnnotation',
                  node
                );
              }
              throw this.raise(
                FlowErrors.UnexpectedSubtractionOperand,
                this.state.startLoc
              );
            }
            this.unexpected();
            return;
          case 135:
            return this.parseLiteral(
              this.state.value,
              'NumberLiteralTypeAnnotation'
            );
          case 136:
            return this.parseLiteral(
              this.state.value,
              'BigIntLiteralTypeAnnotation'
            );
          case 88:
            this.next();
            return this.finishNode(node, 'VoidTypeAnnotation');
          case 84:
            this.next();
            return this.finishNode(node, 'NullLiteralTypeAnnotation');
          case 78:
            this.next();
            return this.finishNode(node, 'ThisTypeAnnotation');
          case 55:
            this.next();
            return this.finishNode(node, 'ExistsTypeAnnotation');
          case 87:
            return this.flowParseTypeofType();
          default:
            if (tokenIsKeyword(this.state.type)) {
              const label = tokenLabelName(this.state.type);
              this.next();
              return super.createIdentifier(node, label);
            } else if (tokenIsIdentifier(this.state.type)) {
              if (this.isContextual(129)) {
                return this.flowParseInterfaceType();
              }
              return this.flowIdentToTypeAnnotation(
                startLoc,
                node,
                this.parseIdentifier()
              );
            }
        }
        this.unexpected();
      }
      flowParsePostfixType() {
        const startLoc = this.state.startLoc;
        let type = this.flowParsePrimaryType();
        let seenOptionalIndexedAccess = false;
        while (
          (this.match(0) || this.match(18)) &&
          !this.canInsertSemicolon()
        ) {
          const node = this.startNodeAt(startLoc);
          const optional = this.eat(18);
          seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
          this.expect(0);
          if (!optional && this.match(3)) {
            node.elementType = type;
            this.next();
            type = this.finishNode(node, 'ArrayTypeAnnotation');
          } else {
            node.objectType = type;
            node.indexType = this.flowParseType();
            this.expect(3);
            if (seenOptionalIndexedAccess) {
              node.optional = optional;
              type = this.finishNode(node, 'OptionalIndexedAccessType');
            } else {
              type = this.finishNode(node, 'IndexedAccessType');
            }
          }
        }
        return type;
      }
      flowParsePrefixType() {
        const node = this.startNode();
        if (this.eat(17)) {
          node.typeAnnotation = this.flowParsePrefixType();
          return this.finishNode(node, 'NullableTypeAnnotation');
        } else {
          return this.flowParsePostfixType();
        }
      }
      flowParseAnonFunctionWithoutParens() {
        const param = this.flowParsePrefixType();
        if (!this.state.noAnonFunctionType && this.eat(19)) {
          const node = this.startNodeAt(param.loc.start);
          node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
          node.rest = null;
          node.this = null;
          node.returnType = this.flowParseType();
          node.typeParameters = null;
          return this.finishNode(node, 'FunctionTypeAnnotation');
        }
        return param;
      }
      flowParseIntersectionType() {
        const node = this.startNode();
        this.eat(45);
        const type = this.flowParseAnonFunctionWithoutParens();
        node.types = [type];
        while (this.eat(45)) {
          node.types.push(this.flowParseAnonFunctionWithoutParens());
        }
        return node.types.length === 1
          ? type
          : this.finishNode(node, 'IntersectionTypeAnnotation');
      }
      flowParseUnionType() {
        const node = this.startNode();
        this.eat(43);
        const type = this.flowParseIntersectionType();
        node.types = [type];
        while (this.eat(43)) {
          node.types.push(this.flowParseIntersectionType());
        }
        return node.types.length === 1
          ? type
          : this.finishNode(node, 'UnionTypeAnnotation');
      }
      flowParseType() {
        const oldInType = this.state.inType;
        this.state.inType = true;
        const type = this.flowParseUnionType();
        this.state.inType = oldInType;
        return type;
      }
      flowParseTypeOrImplicitInstantiation() {
        if (this.state.type === 132 && this.state.value === '_') {
          const startLoc = this.state.startLoc;
          const node = this.parseIdentifier();
          return this.flowParseGenericType(startLoc, node);
        } else {
          return this.flowParseType();
        }
      }
      flowParseTypeAnnotation() {
        const node = this.startNode();
        node.typeAnnotation = this.flowParseTypeInitialiser();
        return this.finishNode(node, 'TypeAnnotation');
      }
      flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
        const ident = allowPrimitiveOverride
          ? this.parseIdentifier()
          : this.flowParseRestrictedIdentifier();
        if (this.match(14)) {
          ident.typeAnnotation = this.flowParseTypeAnnotation();
          this.resetEndLocation(ident);
        }
        return ident;
      }
      typeCastToParameter(node) {
        node.expression.typeAnnotation = node.typeAnnotation;
        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
        return node.expression;
      }
      flowParseVariance() {
        let variance = null;
        if (this.match(53)) {
          variance = this.startNode();
          if (this.state.value === '+') {
            variance.kind = 'plus';
          } else {
            variance.kind = 'minus';
          }
          this.next();
          return this.finishNode(variance, 'Variance');
        }
        return variance;
      }
      parseFunctionBody(node, allowExpressionBody, isMethod = false) {
        if (allowExpressionBody) {
          this.forwardNoArrowParamsConversionAt(node, () =>
            super.parseFunctionBody(node, true, isMethod)
          );
          return;
        }
        super.parseFunctionBody(node, false, isMethod);
      }
      parseFunctionBodyAndFinish(node, type, isMethod = false) {
        if (this.match(14)) {
          const typeNode = this.startNode();
          [typeNode.typeAnnotation, node.predicate] =
            this.flowParseTypeAndPredicateInitialiser();
          node.returnType = typeNode.typeAnnotation
            ? this.finishNode(typeNode, 'TypeAnnotation')
            : null;
        }
        return super.parseFunctionBodyAndFinish(node, type, isMethod);
      }
      parseStatementLike(flags) {
        if (this.state.strict && this.isContextual(129)) {
          const lookahead = this.lookahead();
          if (tokenIsKeywordOrIdentifier(lookahead.type)) {
            const node = this.startNode();
            this.next();
            return this.flowParseInterface(node);
          }
        } else if (this.isContextual(126)) {
          const node = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(node);
        }
        const stmt = super.parseStatementLike(flags);
        if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
          this.flowPragma = null;
        }
        return stmt;
      }
      parseExpressionStatement(node, expr, decorators) {
        if (expr.type === 'Identifier') {
          if (expr.name === 'declare') {
            if (
              this.match(80) ||
              tokenIsIdentifier(this.state.type) ||
              this.match(68) ||
              this.match(74) ||
              this.match(82)
            ) {
              return this.flowParseDeclare(node);
            }
          } else if (tokenIsIdentifier(this.state.type)) {
            if (expr.name === 'interface') {
              return this.flowParseInterface(node);
            } else if (expr.name === 'type') {
              return this.flowParseTypeAlias(node);
            } else if (expr.name === 'opaque') {
              return this.flowParseOpaqueType(node, false);
            }
          }
        }
        return super.parseExpressionStatement(node, expr, decorators);
      }
      shouldParseExportDeclaration() {
        const {type: type} = this.state;
        if (type === 126 || tokenIsFlowInterfaceOrTypeOrOpaque(type)) {
          return !this.state.containsEsc;
        }
        return super.shouldParseExportDeclaration();
      }
      isExportDefaultSpecifier() {
        const {type: type} = this.state;
        if (type === 126 || tokenIsFlowInterfaceOrTypeOrOpaque(type)) {
          return this.state.containsEsc;
        }
        return super.isExportDefaultSpecifier();
      }
      parseExportDefaultExpression() {
        if (this.isContextual(126)) {
          const node = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(node);
        }
        return super.parseExportDefaultExpression();
      }
      parseConditional(expr, startLoc, refExpressionErrors) {
        if (!this.match(17)) return expr;
        if (this.state.maybeInArrowParameters) {
          const nextCh = this.lookaheadCharCode();
          if (
            nextCh === 44 ||
            nextCh === 61 ||
            nextCh === 58 ||
            nextCh === 41
          ) {
            this.setOptionalParametersError(refExpressionErrors);
            return expr;
          }
        }
        this.expect(17);
        const state = this.state.clone();
        const originalNoArrowAt = this.state.noArrowAt;
        const node = this.startNodeAt(startLoc);
        let {consequent: consequent, failed: failed} =
          this.tryParseConditionalConsequent();
        let [valid, invalid] = this.getArrowLikeExpressions(consequent);
        if (failed || invalid.length > 0) {
          const noArrowAt = [...originalNoArrowAt];
          if (invalid.length > 0) {
            this.state = state;
            this.state.noArrowAt = noArrowAt;
            for (let i = 0; i < invalid.length; i++) {
              noArrowAt.push(invalid[i].start);
            }
            ({consequent: consequent, failed: failed} =
              this.tryParseConditionalConsequent());
            [valid, invalid] = this.getArrowLikeExpressions(consequent);
          }
          if (failed && valid.length > 1) {
            this.raise(FlowErrors.AmbiguousConditionalArrow, state.startLoc);
          }
          if (failed && valid.length === 1) {
            this.state = state;
            noArrowAt.push(valid[0].start);
            this.state.noArrowAt = noArrowAt;
            ({consequent: consequent, failed: failed} =
              this.tryParseConditionalConsequent());
          }
        }
        this.getArrowLikeExpressions(consequent, true);
        this.state.noArrowAt = originalNoArrowAt;
        this.expect(14);
        node.test = expr;
        node.consequent = consequent;
        node.alternate = this.forwardNoArrowParamsConversionAt(node, () =>
          this.parseMaybeAssign(undefined, undefined)
        );
        return this.finishNode(node, 'ConditionalExpression');
      }
      tryParseConditionalConsequent() {
        this.state.noArrowParamsConversionAt.push(this.state.start);
        const consequent = this.parseMaybeAssignAllowIn();
        const failed = !this.match(14);
        this.state.noArrowParamsConversionAt.pop();
        return {consequent: consequent, failed: failed};
      }
      getArrowLikeExpressions(node, disallowInvalid) {
        const stack = [node];
        const arrows = [];
        while (stack.length !== 0) {
          const node = stack.pop();
          if (
            node.type === 'ArrowFunctionExpression' &&
            node.body.type !== 'BlockStatement'
          ) {
            if (node.typeParameters || !node.returnType) {
              this.finishArrowValidation(node);
            } else {
              arrows.push(node);
            }
            stack.push(node.body);
          } else if (node.type === 'ConditionalExpression') {
            stack.push(node.consequent);
            stack.push(node.alternate);
          }
        }
        if (disallowInvalid) {
          arrows.forEach(node => this.finishArrowValidation(node));
          return [arrows, []];
        }
        return partition(arrows, node =>
          node.params.every(param => this.isAssignable(param, true))
        );
      }
      finishArrowValidation(node) {
        var _node$extra;
        this.toAssignableList(
          node.params,
          (_node$extra = node.extra) == null
            ? void 0
            : _node$extra.trailingCommaLoc,
          false
        );
        this.scope.enter(2 | 4);
        super.checkParams(node, false, true);
        this.scope.exit();
      }
      forwardNoArrowParamsConversionAt(node, parse) {
        let result;
        if (
          this.state.noArrowParamsConversionAt.includes(
            this.offsetToSourcePos(node.start)
          )
        ) {
          this.state.noArrowParamsConversionAt.push(this.state.start);
          result = parse();
          this.state.noArrowParamsConversionAt.pop();
        } else {
          result = parse();
        }
        return result;
      }
      parseParenItem(node, startLoc) {
        const newNode = super.parseParenItem(node, startLoc);
        if (this.eat(17)) {
          newNode.optional = true;
          this.resetEndLocation(node);
        }
        if (this.match(14)) {
          const typeCastNode = this.startNodeAt(startLoc);
          typeCastNode.expression = newNode;
          typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
          return this.finishNode(typeCastNode, 'TypeCastExpression');
        }
        return newNode;
      }
      assertModuleNodeAllowed(node) {
        if (
          (node.type === 'ImportDeclaration' &&
            (node.importKind === 'type' || node.importKind === 'typeof')) ||
          (node.type === 'ExportNamedDeclaration' &&
            node.exportKind === 'type') ||
          (node.type === 'ExportAllDeclaration' && node.exportKind === 'type')
        ) {
          return;
        }
        super.assertModuleNodeAllowed(node);
      }
      parseExportDeclaration(node) {
        if (this.isContextual(130)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          if (this.match(5)) {
            node.specifiers = this.parseExportSpecifiers(true);
            super.parseExportFrom(node);
            return null;
          } else {
            return this.flowParseTypeAlias(declarationNode);
          }
        } else if (this.isContextual(131)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseOpaqueType(declarationNode, false);
        } else if (this.isContextual(129)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseInterface(declarationNode);
        } else if (this.isContextual(126)) {
          node.exportKind = 'value';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(declarationNode);
        } else {
          return super.parseExportDeclaration(node);
        }
      }
      eatExportStar(node) {
        if (super.eatExportStar(node)) return true;
        if (this.isContextual(130) && this.lookahead().type === 55) {
          node.exportKind = 'type';
          this.next();
          this.next();
          return true;
        }
        return false;
      }
      maybeParseExportNamespaceSpecifier(node) {
        const {startLoc: startLoc} = this.state;
        const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);
        if (hasNamespace && node.exportKind === 'type') {
          this.unexpected(startLoc);
        }
        return hasNamespace;
      }
      parseClassId(node, isStatement, optionalId) {
        super.parseClassId(node, isStatement, optionalId);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
      }
      parseClassMember(classBody, member, state) {
        const {startLoc: startLoc} = this.state;
        if (this.isContextual(125)) {
          if (super.parseClassMemberFromModifier(classBody, member)) {
            return;
          }
          member.declare = true;
        }
        super.parseClassMember(classBody, member, state);
        if (member.declare) {
          if (
            member.type !== 'ClassProperty' &&
            member.type !== 'ClassPrivateProperty' &&
            member.type !== 'PropertyDefinition'
          ) {
            this.raise(FlowErrors.DeclareClassElement, startLoc);
          } else if (member.value) {
            this.raise(FlowErrors.DeclareClassFieldInitializer, member.value);
          }
        }
      }
      isIterator(word) {
        return word === 'iterator' || word === 'asyncIterator';
      }
      readIterator() {
        const word = super.readWord1();
        const fullWord = '@@' + word;
        if (!this.isIterator(word) || !this.state.inType) {
          this.raise(Errors.InvalidIdentifier, this.state.curPosition(), {
            identifierName: fullWord,
          });
        }
        this.finishToken(132, fullWord);
      }
      getTokenFromCode(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 123 && next === 124) {
          this.finishOp(6, 2);
        } else if (this.state.inType && (code === 62 || code === 60)) {
          this.finishOp(code === 62 ? 48 : 47, 1);
        } else if (this.state.inType && code === 63) {
          if (next === 46) {
            this.finishOp(18, 2);
          } else {
            this.finishOp(17, 1);
          }
        } else if (
          isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))
        ) {
          this.state.pos += 2;
          this.readIterator();
        } else {
          super.getTokenFromCode(code);
        }
      }
      isAssignable(node, isBinding) {
        if (node.type === 'TypeCastExpression') {
          return this.isAssignable(node.expression, isBinding);
        } else {
          return super.isAssignable(node, isBinding);
        }
      }
      toAssignable(node, isLHS = false) {
        if (
          !isLHS &&
          node.type === 'AssignmentExpression' &&
          node.left.type === 'TypeCastExpression'
        ) {
          node.left = this.typeCastToParameter(node.left);
        }
        super.toAssignable(node, isLHS);
      }
      toAssignableList(exprList, trailingCommaLoc, isLHS) {
        for (let i = 0; i < exprList.length; i++) {
          const expr = exprList[i];
          if ((expr == null ? void 0 : expr.type) === 'TypeCastExpression') {
            exprList[i] = this.typeCastToParameter(expr);
          }
        }
        super.toAssignableList(exprList, trailingCommaLoc, isLHS);
      }
      toReferencedList(exprList, isParenthesizedExpr) {
        for (let i = 0; i < exprList.length; i++) {
          var _expr$extra;
          const expr = exprList[i];
          if (
            expr &&
            expr.type === 'TypeCastExpression' &&
            !(
              (_expr$extra = expr.extra) != null && _expr$extra.parenthesized
            ) &&
            (exprList.length > 1 || !isParenthesizedExpr)
          ) {
            this.raise(FlowErrors.TypeCastInPattern, expr.typeAnnotation);
          }
        }
        return exprList;
      }
      parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        const node = super.parseArrayLike(
          close,
          canBePattern,
          isTuple,
          refExpressionErrors
        );
        if (canBePattern && !this.state.maybeInArrowParameters) {
          this.toReferencedList(node.elements);
        }
        return node;
      }
      isValidLVal(type, isParenthesized, binding) {
        return (
          type === 'TypeCastExpression' ||
          super.isValidLVal(type, isParenthesized, binding)
        );
      }
      parseClassProperty(node) {
        if (this.match(14)) {
          node.typeAnnotation = this.flowParseTypeAnnotation();
        }
        return super.parseClassProperty(node);
      }
      parseClassPrivateProperty(node) {
        if (this.match(14)) {
          node.typeAnnotation = this.flowParseTypeAnnotation();
        }
        return super.parseClassPrivateProperty(node);
      }
      isClassMethod() {
        return this.match(47) || super.isClassMethod();
      }
      isClassProperty() {
        return this.match(14) || super.isClassProperty();
      }
      isNonstaticConstructor(method) {
        return !this.match(14) && super.isNonstaticConstructor(method);
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        if (method.variance) {
          this.unexpected(method.variance.loc.start);
        }
        delete method.variance;
        if (this.match(47)) {
          method.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.pushClassMethod(
          classBody,
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper
        );
        if (method.params && isConstructor) {
          const params = method.params;
          if (params.length > 0 && this.isThisParam(params[0])) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
          }
        } else if (
          method.type === 'MethodDefinition' &&
          isConstructor &&
          method.value.params
        ) {
          const params = method.value.params;
          if (params.length > 0 && this.isThisParam(params[0])) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
          }
        }
      }
      pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
        if (method.variance) {
          this.unexpected(method.variance.loc.start);
        }
        delete method.variance;
        if (this.match(47)) {
          method.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
      }
      parseClassSuper(node) {
        super.parseClassSuper(node);
        if (node.superClass && this.match(47)) {
          node.superTypeParameters = this.flowParseTypeParameterInstantiation();
        }
        if (this.isContextual(113)) {
          this.next();
          const implemented = (node.implements = []);
          do {
            const node = this.startNode();
            node.id = this.flowParseRestrictedIdentifier(true);
            if (this.match(47)) {
              node.typeParameters = this.flowParseTypeParameterInstantiation();
            } else {
              node.typeParameters = null;
            }
            implemented.push(this.finishNode(node, 'ClassImplements'));
          } while (this.eat(12));
        }
      }
      checkGetterSetterParams(method) {
        super.checkGetterSetterParams(method);
        const params = this.getObjectOrClassMethodParams(method);
        if (params.length > 0) {
          const param = params[0];
          if (this.isThisParam(param) && method.kind === 'get') {
            this.raise(FlowErrors.GetterMayNotHaveThisParam, param);
          } else if (this.isThisParam(param)) {
            this.raise(FlowErrors.SetterMayNotHaveThisParam, param);
          }
        }
      }
      parsePropertyNamePrefixOperator(node) {
        node.variance = this.flowParseVariance();
      }
      parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      ) {
        if (prop.variance) {
          this.unexpected(prop.variance.loc.start);
        }
        delete prop.variance;
        let typeParameters;
        if (this.match(47) && !isAccessor) {
          typeParameters = this.flowParseTypeParameterDeclaration();
          if (!this.match(10)) this.unexpected();
        }
        const result = super.parseObjPropValue(
          prop,
          startLoc,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor,
          refExpressionErrors
        );
        if (typeParameters) {
          (result.value || result).typeParameters = typeParameters;
        }
        return result;
      }
      parseFunctionParamType(param) {
        if (this.eat(17)) {
          if (param.type !== 'Identifier') {
            this.raise(FlowErrors.PatternIsOptional, param);
          }
          if (this.isThisParam(param)) {
            this.raise(FlowErrors.ThisParamMayNotBeOptional, param);
          }
          param.optional = true;
        }
        if (this.match(14)) {
          param.typeAnnotation = this.flowParseTypeAnnotation();
        } else if (this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamAnnotationRequired, param);
        }
        if (this.match(29) && this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamNoDefault, param);
        }
        this.resetEndLocation(param);
        return param;
      }
      parseMaybeDefault(startLoc, left) {
        const node = super.parseMaybeDefault(startLoc, left);
        if (
          node.type === 'AssignmentPattern' &&
          node.typeAnnotation &&
          node.right.start < node.typeAnnotation.start
        ) {
          this.raise(FlowErrors.TypeBeforeInitializer, node.typeAnnotation);
        }
        return node;
      }
      checkImportReflection(node) {
        super.checkImportReflection(node);
        if (node.module && node.importKind !== 'value') {
          this.raise(
            FlowErrors.ImportReflectionHasImportType,
            node.specifiers[0].loc.start
          );
        }
      }
      parseImportSpecifierLocal(node, specifier, type) {
        specifier.local = hasTypeImportKind(node)
          ? this.flowParseRestrictedIdentifier(true, true)
          : this.parseIdentifier();
        node.specifiers.push(this.finishImportSpecifier(specifier, type));
      }
      isPotentialImportPhase(isExport) {
        if (super.isPotentialImportPhase(isExport)) return true;
        if (this.isContextual(130)) {
          if (!isExport) return true;
          const ch = this.lookaheadCharCode();
          return ch === 123 || ch === 42;
        }
        return !isExport && this.isContextual(87);
      }
      applyImportPhase(node, isExport, phase, loc) {
        super.applyImportPhase(node, isExport, phase, loc);
        if (isExport) {
          if (!phase && this.match(65)) {
            return;
          }
          node.exportKind = phase === 'type' ? phase : 'value';
        } else {
          if (phase === 'type' && this.match(55)) this.unexpected();
          node.importKind =
            phase === 'type' || phase === 'typeof' ? phase : 'value';
        }
      }
      parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        bindingType
      ) {
        const firstIdent = specifier.imported;
        let specifierTypeKind = null;
        if (firstIdent.type === 'Identifier') {
          if (firstIdent.name === 'type') {
            specifierTypeKind = 'type';
          } else if (firstIdent.name === 'typeof') {
            specifierTypeKind = 'typeof';
          }
        }
        let isBinding = false;
        if (this.isContextual(93) && !this.isLookaheadContextual('as')) {
          const as_ident = this.parseIdentifier(true);
          if (
            specifierTypeKind !== null &&
            !tokenIsKeywordOrIdentifier(this.state.type)
          ) {
            specifier.imported = as_ident;
            specifier.importKind = specifierTypeKind;
            specifier.local = cloneIdentifier(as_ident);
          } else {
            specifier.imported = firstIdent;
            specifier.importKind = null;
            specifier.local = this.parseIdentifier();
          }
        } else {
          if (
            specifierTypeKind !== null &&
            tokenIsKeywordOrIdentifier(this.state.type)
          ) {
            specifier.imported = this.parseIdentifier(true);
            specifier.importKind = specifierTypeKind;
          } else {
            if (importedIsString) {
              throw this.raise(Errors.ImportBindingIsString, specifier, {
                importName: firstIdent.value,
              });
            }
            specifier.imported = firstIdent;
            specifier.importKind = null;
          }
          if (this.eatContextual(93)) {
            specifier.local = this.parseIdentifier();
          } else {
            isBinding = true;
            specifier.local = cloneIdentifier(specifier.imported);
          }
        }
        const specifierIsTypeImport = hasTypeImportKind(specifier);
        if (isInTypeOnlyImport && specifierIsTypeImport) {
          this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, specifier);
        }
        if (isInTypeOnlyImport || specifierIsTypeImport) {
          this.checkReservedType(
            specifier.local.name,
            specifier.local.loc.start,
            true
          );
        }
        if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
          this.checkReservedWord(
            specifier.local.name,
            specifier.loc.start,
            true,
            true
          );
        }
        return this.finishImportSpecifier(specifier, 'ImportSpecifier');
      }
      parseBindingAtom() {
        switch (this.state.type) {
          case 78:
            return this.parseIdentifier(true);
          default:
            return super.parseBindingAtom();
        }
      }
      parseFunctionParams(node, isConstructor) {
        const kind = node.kind;
        if (kind !== 'get' && kind !== 'set' && this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.parseFunctionParams(node, isConstructor);
      }
      parseVarId(decl, kind) {
        super.parseVarId(decl, kind);
        if (this.match(14)) {
          decl.id.typeAnnotation = this.flowParseTypeAnnotation();
          this.resetEndLocation(decl.id);
        }
      }
      parseAsyncArrowFromCallExpression(node, call) {
        if (this.match(14)) {
          const oldNoAnonFunctionType = this.state.noAnonFunctionType;
          this.state.noAnonFunctionType = true;
          node.returnType = this.flowParseTypeAnnotation();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
        }
        return super.parseAsyncArrowFromCallExpression(node, call);
      }
      shouldParseAsyncArrow() {
        return this.match(14) || super.shouldParseAsyncArrow();
      }
      parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var _jsx;
        let state = null;
        let jsx;
        if (this.hasPlugin('jsx') && (this.match(143) || this.match(47))) {
          state = this.state.clone();
          jsx = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!jsx.error) return jsx.node;
          const {context: context} = this.state;
          const currentContext = context[context.length - 1];
          if (
            currentContext === types.j_oTag ||
            currentContext === types.j_expr
          ) {
            context.pop();
          }
        }
        if (((_jsx = jsx) != null && _jsx.error) || this.match(47)) {
          var _jsx2, _jsx3;
          state = state || this.state.clone();
          let typeParameters;
          const arrow = this.tryParse(abort => {
            var _arrowExpression$extr;
            typeParameters = this.flowParseTypeParameterDeclaration();
            const arrowExpression = this.forwardNoArrowParamsConversionAt(
              typeParameters,
              () => {
                const result = super.parseMaybeAssign(
                  refExpressionErrors,
                  afterLeftParse
                );
                this.resetStartLocationFromNode(result, typeParameters);
                return result;
              }
            );
            if (
              (_arrowExpression$extr = arrowExpression.extra) != null &&
              _arrowExpression$extr.parenthesized
            )
              abort();
            const expr = this.maybeUnwrapTypeCastExpression(arrowExpression);
            if (expr.type !== 'ArrowFunctionExpression') abort();
            expr.typeParameters = typeParameters;
            this.resetStartLocationFromNode(expr, typeParameters);
            return arrowExpression;
          }, state);
          let arrowExpression = null;
          if (
            arrow.node &&
            this.maybeUnwrapTypeCastExpression(arrow.node).type ===
              'ArrowFunctionExpression'
          ) {
            if (!arrow.error && !arrow.aborted) {
              if (arrow.node.async) {
                this.raise(
                  FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction,
                  typeParameters
                );
              }
              return arrow.node;
            }
            arrowExpression = arrow.node;
          }
          if ((_jsx2 = jsx) != null && _jsx2.node) {
            this.state = jsx.failState;
            return jsx.node;
          }
          if (arrowExpression) {
            this.state = arrow.failState;
            return arrowExpression;
          }
          if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
          if (arrow.thrown) throw arrow.error;
          throw this.raise(
            FlowErrors.UnexpectedTokenAfterTypeParameter,
            typeParameters
          );
        }
        return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
      }
      parseArrow(node) {
        if (this.match(14)) {
          const result = this.tryParse(() => {
            const oldNoAnonFunctionType = this.state.noAnonFunctionType;
            this.state.noAnonFunctionType = true;
            const typeNode = this.startNode();
            [typeNode.typeAnnotation, node.predicate] =
              this.flowParseTypeAndPredicateInitialiser();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            if (this.canInsertSemicolon()) this.unexpected();
            if (!this.match(19)) this.unexpected();
            return typeNode;
          });
          if (result.thrown) return null;
          if (result.error) this.state = result.failState;
          node.returnType = result.node.typeAnnotation
            ? this.finishNode(result.node, 'TypeAnnotation')
            : null;
        }
        return super.parseArrow(node);
      }
      shouldParseArrow(params) {
        return this.match(14) || super.shouldParseArrow(params);
      }
      setArrowFunctionParameters(node, params) {
        if (
          this.state.noArrowParamsConversionAt.includes(
            this.offsetToSourcePos(node.start)
          )
        ) {
          node.params = params;
        } else {
          super.setArrowFunctionParameters(node, params);
        }
      }
      checkParams(
        node,
        allowDuplicates,
        isArrowFunction,
        strictModeChanged = true
      ) {
        if (
          isArrowFunction &&
          this.state.noArrowParamsConversionAt.includes(
            this.offsetToSourcePos(node.start)
          )
        ) {
          return;
        }
        for (let i = 0; i < node.params.length; i++) {
          if (this.isThisParam(node.params[i]) && i > 0) {
            this.raise(FlowErrors.ThisParamMustBeFirst, node.params[i]);
          }
        }
        super.checkParams(
          node,
          allowDuplicates,
          isArrowFunction,
          strictModeChanged
        );
      }
      parseParenAndDistinguishExpression(canBeArrow) {
        return super.parseParenAndDistinguishExpression(
          canBeArrow &&
            !this.state.noArrowAt.includes(
              this.sourceToOffsetPos(this.state.start)
            )
        );
      }
      parseSubscripts(base, startLoc, noCalls) {
        if (
          base.type === 'Identifier' &&
          base.name === 'async' &&
          this.state.noArrowAt.includes(startLoc.index)
        ) {
          this.next();
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          node.arguments = super.parseCallExpressionArguments(11);
          base = this.finishNode(node, 'CallExpression');
        } else if (
          base.type === 'Identifier' &&
          base.name === 'async' &&
          this.match(47)
        ) {
          const state = this.state.clone();
          const arrow = this.tryParse(
            abort =>
              this.parseAsyncArrowWithTypeParameters(startLoc) || abort(),
            state
          );
          if (!arrow.error && !arrow.aborted) return arrow.node;
          const result = this.tryParse(
            () => super.parseSubscripts(base, startLoc, noCalls),
            state
          );
          if (result.node && !result.error) return result.node;
          if (arrow.node) {
            this.state = arrow.failState;
            return arrow.node;
          }
          if (result.node) {
            this.state = result.failState;
            return result.node;
          }
          throw arrow.error || result.error;
        }
        return super.parseSubscripts(base, startLoc, noCalls);
      }
      parseSubscript(base, startLoc, noCalls, subscriptState) {
        if (this.match(18) && this.isLookaheadToken_lt()) {
          subscriptState.optionalChainMember = true;
          if (noCalls) {
            subscriptState.stop = true;
            return base;
          }
          this.next();
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          node.typeArguments = this.flowParseTypeParameterInstantiation();
          this.expect(10);
          node.arguments = this.parseCallExpressionArguments(11);
          node.optional = true;
          return this.finishCallExpression(node, true);
        } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          const result = this.tryParse(() => {
            node.typeArguments =
              this.flowParseTypeParameterInstantiationCallOrNew();
            this.expect(10);
            node.arguments = super.parseCallExpressionArguments(11);
            if (subscriptState.optionalChainMember) {
              node.optional = false;
            }
            return this.finishCallExpression(
              node,
              subscriptState.optionalChainMember
            );
          });
          if (result.node) {
            if (result.error) this.state = result.failState;
            return result.node;
          }
        }
        return super.parseSubscript(base, startLoc, noCalls, subscriptState);
      }
      parseNewCallee(node) {
        super.parseNewCallee(node);
        let targs = null;
        if (this.shouldParseTypes() && this.match(47)) {
          targs = this.tryParse(() =>
            this.flowParseTypeParameterInstantiationCallOrNew()
          ).node;
        }
        node.typeArguments = targs;
      }
      parseAsyncArrowWithTypeParameters(startLoc) {
        const node = this.startNodeAt(startLoc);
        this.parseFunctionParams(node, false);
        if (!this.parseArrow(node)) return;
        return super.parseArrowExpression(node, undefined, true);
      }
      readToken_mult_modulo(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 42 && next === 47 && this.state.hasFlowComment) {
          this.state.hasFlowComment = false;
          this.state.pos += 2;
          this.nextToken();
          return;
        }
        super.readToken_mult_modulo(code);
      }
      readToken_pipe_amp(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 124 && next === 125) {
          this.finishOp(9, 2);
          return;
        }
        super.readToken_pipe_amp(code);
      }
      parseTopLevel(file, program) {
        const fileNode = super.parseTopLevel(file, program);
        if (this.state.hasFlowComment) {
          this.raise(
            FlowErrors.UnterminatedFlowComment,
            this.state.curPosition()
          );
        }
        return fileNode;
      }
      skipBlockComment() {
        if (this.hasPlugin('flowComments') && this.skipFlowComment()) {
          if (this.state.hasFlowComment) {
            throw this.raise(FlowErrors.NestedFlowComment, this.state.startLoc);
          }
          this.hasFlowCommentCompletion();
          const commentSkip = this.skipFlowComment();
          if (commentSkip) {
            this.state.pos += commentSkip;
            this.state.hasFlowComment = true;
          }
          return;
        }
        return super.skipBlockComment(this.state.hasFlowComment ? '*-/' : '*/');
      }
      skipFlowComment() {
        const {pos: pos} = this.state;
        let shiftToFirstNonWhiteSpace = 2;
        while (
          [32, 9].includes(
            this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace)
          )
        ) {
          shiftToFirstNonWhiteSpace++;
        }
        const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
        const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
        if (ch2 === 58 && ch3 === 58) {
          return shiftToFirstNonWhiteSpace + 2;
        }
        if (
          this.input.slice(
            shiftToFirstNonWhiteSpace + pos,
            shiftToFirstNonWhiteSpace + pos + 12
          ) === 'flow-include'
        ) {
          return shiftToFirstNonWhiteSpace + 12;
        }
        if (ch2 === 58 && ch3 !== 58) {
          return shiftToFirstNonWhiteSpace;
        }
        return false;
      }
      hasFlowCommentCompletion() {
        const end = this.input.indexOf('*/', this.state.pos);
        if (end === -1) {
          throw this.raise(
            Errors.UnterminatedComment,
            this.state.curPosition()
          );
        }
      }
      flowEnumErrorBooleanMemberNotInitialized(
        loc,
        {enumName: enumName, memberName: memberName}
      ) {
        this.raise(FlowErrors.EnumBooleanMemberNotInitialized, loc, {
          memberName: memberName,
          enumName: enumName,
        });
      }
      flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
        return this.raise(
          !enumContext.explicitType
            ? FlowErrors.EnumInvalidMemberInitializerUnknownType
            : enumContext.explicitType === 'symbol'
              ? FlowErrors.EnumInvalidMemberInitializerSymbolType
              : FlowErrors.EnumInvalidMemberInitializerPrimaryType,
          loc,
          enumContext
        );
      }
      flowEnumErrorNumberMemberNotInitialized(loc, details) {
        this.raise(FlowErrors.EnumNumberMemberNotInitialized, loc, details);
      }
      flowEnumErrorStringMemberInconsistentlyInitialized(node, details) {
        this.raise(
          FlowErrors.EnumStringMemberInconsistentlyInitialized,
          node,
          details
        );
      }
      flowEnumMemberInit() {
        const startLoc = this.state.startLoc;
        const endOfInit = () => this.match(12) || this.match(8);
        switch (this.state.type) {
          case 135: {
            const literal = this.parseNumericLiteral(this.state.value);
            if (endOfInit()) {
              return {type: 'number', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          case 134: {
            const literal = this.parseStringLiteral(this.state.value);
            if (endOfInit()) {
              return {type: 'string', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          case 85:
          case 86: {
            const literal = this.parseBooleanLiteral(this.match(85));
            if (endOfInit()) {
              return {type: 'boolean', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          default:
            return {type: 'invalid', loc: startLoc};
        }
      }
      flowEnumMemberRaw() {
        const loc = this.state.startLoc;
        const id = this.parseIdentifier(true);
        const init = this.eat(29)
          ? this.flowEnumMemberInit()
          : {type: 'none', loc: loc};
        return {id: id, init: init};
      }
      flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
        const {explicitType: explicitType} = context;
        if (explicitType === null) {
          return;
        }
        if (explicitType !== expectedType) {
          this.flowEnumErrorInvalidMemberInitializer(loc, context);
        }
      }
      flowEnumMembers({enumName: enumName, explicitType: explicitType}) {
        const seenNames = new Set();
        const members = {
          booleanMembers: [],
          numberMembers: [],
          stringMembers: [],
          defaultedMembers: [],
        };
        let hasUnknownMembers = false;
        while (!this.match(8)) {
          if (this.eat(21)) {
            hasUnknownMembers = true;
            break;
          }
          const memberNode = this.startNode();
          const {id: id, init: init} = this.flowEnumMemberRaw();
          const memberName = id.name;
          if (memberName === '') {
            continue;
          }
          if (/^[a-z]/.test(memberName)) {
            this.raise(FlowErrors.EnumInvalidMemberName, id, {
              memberName: memberName,
              suggestion: memberName[0].toUpperCase() + memberName.slice(1),
              enumName: enumName,
            });
          }
          if (seenNames.has(memberName)) {
            this.raise(FlowErrors.EnumDuplicateMemberName, id, {
              memberName: memberName,
              enumName: enumName,
            });
          }
          seenNames.add(memberName);
          const context = {
            enumName: enumName,
            explicitType: explicitType,
            memberName: memberName,
          };
          memberNode.id = id;
          switch (init.type) {
            case 'boolean': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'boolean'
              );
              memberNode.init = init.value;
              members.booleanMembers.push(
                this.finishNode(memberNode, 'EnumBooleanMember')
              );
              break;
            }
            case 'number': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'number'
              );
              memberNode.init = init.value;
              members.numberMembers.push(
                this.finishNode(memberNode, 'EnumNumberMember')
              );
              break;
            }
            case 'string': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'string'
              );
              memberNode.init = init.value;
              members.stringMembers.push(
                this.finishNode(memberNode, 'EnumStringMember')
              );
              break;
            }
            case 'invalid': {
              throw this.flowEnumErrorInvalidMemberInitializer(
                init.loc,
                context
              );
            }
            case 'none': {
              switch (explicitType) {
                case 'boolean':
                  this.flowEnumErrorBooleanMemberNotInitialized(
                    init.loc,
                    context
                  );
                  break;
                case 'number':
                  this.flowEnumErrorNumberMemberNotInitialized(
                    init.loc,
                    context
                  );
                  break;
                default:
                  members.defaultedMembers.push(
                    this.finishNode(memberNode, 'EnumDefaultedMember')
                  );
              }
            }
          }
          if (!this.match(8)) {
            this.expect(12);
          }
        }
        return {members: members, hasUnknownMembers: hasUnknownMembers};
      }
      flowEnumStringMembers(
        initializedMembers,
        defaultedMembers,
        {enumName: enumName}
      ) {
        if (initializedMembers.length === 0) {
          return defaultedMembers;
        } else if (defaultedMembers.length === 0) {
          return initializedMembers;
        } else if (defaultedMembers.length > initializedMembers.length) {
          for (const member of initializedMembers) {
            this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
              enumName: enumName,
            });
          }
          return defaultedMembers;
        } else {
          for (const member of defaultedMembers) {
            this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
              enumName: enumName,
            });
          }
          return initializedMembers;
        }
      }
      flowEnumParseExplicitType({enumName: enumName}) {
        if (!this.eatContextual(102)) return null;
        if (!tokenIsIdentifier(this.state.type)) {
          throw this.raise(
            FlowErrors.EnumInvalidExplicitTypeUnknownSupplied,
            this.state.startLoc,
            {enumName: enumName}
          );
        }
        const {value: value} = this.state;
        this.next();
        if (
          value !== 'boolean' &&
          value !== 'number' &&
          value !== 'string' &&
          value !== 'symbol'
        ) {
          this.raise(FlowErrors.EnumInvalidExplicitType, this.state.startLoc, {
            enumName: enumName,
            invalidEnumType: value,
          });
        }
        return value;
      }
      flowEnumBody(node, id) {
        const enumName = id.name;
        const nameLoc = id.loc.start;
        const explicitType = this.flowEnumParseExplicitType({
          enumName: enumName,
        });
        this.expect(5);
        const {members: members, hasUnknownMembers: hasUnknownMembers} =
          this.flowEnumMembers({
            enumName: enumName,
            explicitType: explicitType,
          });
        node.hasUnknownMembers = hasUnknownMembers;
        switch (explicitType) {
          case 'boolean':
            node.explicitType = true;
            node.members = members.booleanMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumBooleanBody');
          case 'number':
            node.explicitType = true;
            node.members = members.numberMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumNumberBody');
          case 'string':
            node.explicitType = true;
            node.members = this.flowEnumStringMembers(
              members.stringMembers,
              members.defaultedMembers,
              {enumName: enumName}
            );
            this.expect(8);
            return this.finishNode(node, 'EnumStringBody');
          case 'symbol':
            node.members = members.defaultedMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumSymbolBody');
          default: {
            const empty = () => {
              node.members = [];
              this.expect(8);
              return this.finishNode(node, 'EnumStringBody');
            };
            node.explicitType = false;
            const boolsLen = members.booleanMembers.length;
            const numsLen = members.numberMembers.length;
            const strsLen = members.stringMembers.length;
            const defaultedLen = members.defaultedMembers.length;
            if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
              return empty();
            } else if (!boolsLen && !numsLen) {
              node.members = this.flowEnumStringMembers(
                members.stringMembers,
                members.defaultedMembers,
                {enumName: enumName}
              );
              this.expect(8);
              return this.finishNode(node, 'EnumStringBody');
            } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
              for (const member of members.defaultedMembers) {
                this.flowEnumErrorBooleanMemberNotInitialized(
                  member.loc.start,
                  {enumName: enumName, memberName: member.id.name}
                );
              }
              node.members = members.booleanMembers;
              this.expect(8);
              return this.finishNode(node, 'EnumBooleanBody');
            } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
              for (const member of members.defaultedMembers) {
                this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
                  enumName: enumName,
                  memberName: member.id.name,
                });
              }
              node.members = members.numberMembers;
              this.expect(8);
              return this.finishNode(node, 'EnumNumberBody');
            } else {
              this.raise(FlowErrors.EnumInconsistentMemberValues, nameLoc, {
                enumName: enumName,
              });
              return empty();
            }
          }
        }
      }
      flowParseEnumDeclaration(node) {
        const id = this.parseIdentifier();
        node.id = id;
        node.body = this.flowEnumBody(this.startNode(), id);
        return this.finishNode(node, 'EnumDeclaration');
      }
      isLookaheadToken_lt() {
        const next = this.nextTokenStart();
        if (this.input.charCodeAt(next) === 60) {
          const afterNext = this.input.charCodeAt(next + 1);
          return afterNext !== 60 && afterNext !== 61;
        }
        return false;
      }
      maybeUnwrapTypeCastExpression(node) {
        return node.type === 'TypeCastExpression' ? node.expression : node;
      }
    };
  const entities = {
    __proto__: null,
    quot: '"',
    amp: '&',
    apos: "'",
    lt: '<',
    gt: '>',
    nbsp: ' ',
    iexcl: '¡',
    cent: '¢',
    pound: '£',
    curren: '¤',
    yen: '¥',
    brvbar: '¦',
    sect: '§',
    uml: '¨',
    copy: '©',
    ordf: 'ª',
    laquo: '«',
    not: '¬',
    shy: '­',
    reg: '®',
    macr: '¯',
    deg: '°',
    plusmn: '±',
    sup2: '²',
    sup3: '³',
    acute: '´',
    micro: 'µ',
    para: '¶',
    middot: '·',
    cedil: '¸',
    sup1: '¹',
    ordm: 'º',
    raquo: '»',
    frac14: '¼',
    frac12: '½',
    frac34: '¾',
    iquest: '¿',
    Agrave: 'À',
    Aacute: 'Á',
    Acirc: 'Â',
    Atilde: 'Ã',
    Auml: 'Ä',
    Aring: 'Å',
    AElig: 'Æ',
    Ccedil: 'Ç',
    Egrave: 'È',
    Eacute: 'É',
    Ecirc: 'Ê',
    Euml: 'Ë',
    Igrave: 'Ì',
    Iacute: 'Í',
    Icirc: 'Î',
    Iuml: 'Ï',
    ETH: 'Ð',
    Ntilde: 'Ñ',
    Ograve: 'Ò',
    Oacute: 'Ó',
    Ocirc: 'Ô',
    Otilde: 'Õ',
    Ouml: 'Ö',
    times: '×',
    Oslash: 'Ø',
    Ugrave: 'Ù',
    Uacute: 'Ú',
    Ucirc: 'Û',
    Uuml: 'Ü',
    Yacute: 'Ý',
    THORN: 'Þ',
    szlig: 'ß',
    agrave: 'à',
    aacute: 'á',
    acirc: 'â',
    atilde: 'ã',
    auml: 'ä',
    aring: 'å',
    aelig: 'æ',
    ccedil: 'ç',
    egrave: 'è',
    eacute: 'é',
    ecirc: 'ê',
    euml: 'ë',
    igrave: 'ì',
    iacute: 'í',
    icirc: 'î',
    iuml: 'ï',
    eth: 'ð',
    ntilde: 'ñ',
    ograve: 'ò',
    oacute: 'ó',
    ocirc: 'ô',
    otilde: 'õ',
    ouml: 'ö',
    divide: '÷',
    oslash: 'ø',
    ugrave: 'ù',
    uacute: 'ú',
    ucirc: 'û',
    uuml: 'ü',
    yacute: 'ý',
    thorn: 'þ',
    yuml: 'ÿ',
    OElig: 'Œ',
    oelig: 'œ',
    Scaron: 'Š',
    scaron: 'š',
    Yuml: 'Ÿ',
    fnof: 'ƒ',
    circ: 'ˆ',
    tilde: '˜',
    Alpha: 'Α',
    Beta: 'Β',
    Gamma: 'Γ',
    Delta: 'Δ',
    Epsilon: 'Ε',
    Zeta: 'Ζ',
    Eta: 'Η',
    Theta: 'Θ',
    Iota: 'Ι',
    Kappa: 'Κ',
    Lambda: 'Λ',
    Mu: 'Μ',
    Nu: 'Ν',
    Xi: 'Ξ',
    Omicron: 'Ο',
    Pi: 'Π',
    Rho: 'Ρ',
    Sigma: 'Σ',
    Tau: 'Τ',
    Upsilon: 'Υ',
    Phi: 'Φ',
    Chi: 'Χ',
    Psi: 'Ψ',
    Omega: 'Ω',
    alpha: 'α',
    beta: 'β',
    gamma: 'γ',
    delta: 'δ',
    epsilon: 'ε',
    zeta: 'ζ',
    eta: 'η',
    theta: 'θ',
    iota: 'ι',
    kappa: 'κ',
    lambda: 'λ',
    mu: 'μ',
    nu: 'ν',
    xi: 'ξ',
    omicron: 'ο',
    pi: 'π',
    rho: 'ρ',
    sigmaf: 'ς',
    sigma: 'σ',
    tau: 'τ',
    upsilon: 'υ',
    phi: 'φ',
    chi: 'χ',
    psi: 'ψ',
    omega: 'ω',
    thetasym: 'ϑ',
    upsih: 'ϒ',
    piv: 'ϖ',
    ensp: ' ',
    emsp: ' ',
    thinsp: ' ',
    zwnj: '‌',
    zwj: '‍',
    lrm: '‎',
    rlm: '‏',
    ndash: '–',
    mdash: '—',
    lsquo: '‘',
    rsquo: '’',
    sbquo: '‚',
    ldquo: '“',
    rdquo: '”',
    bdquo: '„',
    dagger: '†',
    Dagger: '‡',
    bull: '•',
    hellip: '…',
    permil: '‰',
    prime: '′',
    Prime: '″',
    lsaquo: '‹',
    rsaquo: '›',
    oline: '‾',
    frasl: '⁄',
    euro: '€',
    image: 'ℑ',
    weierp: '℘',
    real: 'ℜ',
    trade: '™',
    alefsym: 'ℵ',
    larr: '←',
    uarr: '↑',
    rarr: '→',
    darr: '↓',
    harr: '↔',
    crarr: '↵',
    lArr: '⇐',
    uArr: '⇑',
    rArr: '⇒',
    dArr: '⇓',
    hArr: '⇔',
    forall: '∀',
    part: '∂',
    exist: '∃',
    empty: '∅',
    nabla: '∇',
    isin: '∈',
    notin: '∉',
    ni: '∋',
    prod: '∏',
    sum: '∑',
    minus: '−',
    lowast: '∗',
    radic: '√',
    prop: '∝',
    infin: '∞',
    ang: '∠',
    and: '∧',
    or: '∨',
    cap: '∩',
    cup: '∪',
    int: '∫',
    there4: '∴',
    sim: '∼',
    cong: '≅',
    asymp: '≈',
    ne: '≠',
    equiv: '≡',
    le: '≤',
    ge: '≥',
    sub: '⊂',
    sup: '⊃',
    nsub: '⊄',
    sube: '⊆',
    supe: '⊇',
    oplus: '⊕',
    otimes: '⊗',
    perp: '⊥',
    sdot: '⋅',
    lceil: '⌈',
    rceil: '⌉',
    lfloor: '⌊',
    rfloor: '⌋',
    lang: '〈',
    rang: '〉',
    loz: '◊',
    spades: '♠',
    clubs: '♣',
    hearts: '♥',
    diams: '♦',
  };
  const JsxErrors = ParseErrorEnum`jsx`({
    AttributeIsEmpty:
      'JSX attributes must only be assigned a non-empty expression.',
    MissingClosingTagElement: ({openingTagName: openingTagName}) =>
      `Expected corresponding JSX closing tag for <${openingTagName}>.`,
    MissingClosingTagFragment: 'Expected corresponding JSX closing tag for <>.',
    UnexpectedSequenceExpression:
      'Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?',
    UnexpectedToken: ({unexpected: unexpected, HTMLEntity: HTMLEntity}) =>
      `Unexpected token \`${unexpected}\`. Did you mean \`${HTMLEntity}\` or \`{'${unexpected}'}\`?`,
    UnsupportedJsxValue:
      'JSX value should be either an expression or a quoted JSX text.',
    UnterminatedJsxContent: 'Unterminated JSX contents.',
    UnwrappedAdjacentJSXElements:
      'Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?',
  });
  function isFragment(object) {
    return object
      ? object.type === 'JSXOpeningFragment' ||
          object.type === 'JSXClosingFragment'
      : false;
  }
  function getQualifiedJSXName(object) {
    if (object.type === 'JSXIdentifier') {
      return object.name;
    }
    if (object.type === 'JSXNamespacedName') {
      return object.namespace.name + ':' + object.name.name;
    }
    if (object.type === 'JSXMemberExpression') {
      return (
        getQualifiedJSXName(object.object) +
        '.' +
        getQualifiedJSXName(object.property)
      );
    }
    throw new Error('Node had unexpected type: ' + object.type);
  }
  var jsx = superClass =>
    class JSXParserMixin extends superClass {
      jsxReadToken() {
        let out = '';
        let chunkStart = this.state.pos;
        for (;;) {
          if (this.state.pos >= this.length) {
            throw this.raise(
              JsxErrors.UnterminatedJsxContent,
              this.state.startLoc
            );
          }
          const ch = this.input.charCodeAt(this.state.pos);
          switch (ch) {
            case 60:
            case 123:
              if (this.state.pos === this.state.start) {
                if (ch === 60 && this.state.canStartJSXElement) {
                  ++this.state.pos;
                  this.finishToken(143);
                } else {
                  super.getTokenFromCode(ch);
                }
                return;
              }
              out += this.input.slice(chunkStart, this.state.pos);
              this.finishToken(142, out);
              return;
            case 38:
              out += this.input.slice(chunkStart, this.state.pos);
              out += this.jsxReadEntity();
              chunkStart = this.state.pos;
              break;
            case 62:
            case 125:
            default:
              if (isNewLine(ch)) {
                out += this.input.slice(chunkStart, this.state.pos);
                out += this.jsxReadNewLine(true);
                chunkStart = this.state.pos;
              } else {
                ++this.state.pos;
              }
          }
        }
      }
      jsxReadNewLine(normalizeCRLF) {
        const ch = this.input.charCodeAt(this.state.pos);
        let out;
        ++this.state.pos;
        if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
          ++this.state.pos;
          out = normalizeCRLF ? '\n' : '\r\n';
        } else {
          out = String.fromCharCode(ch);
        }
        ++this.state.curLine;
        this.state.lineStart = this.state.pos;
        return out;
      }
      jsxReadString(quote) {
        let out = '';
        let chunkStart = ++this.state.pos;
        for (;;) {
          if (this.state.pos >= this.length) {
            throw this.raise(Errors.UnterminatedString, this.state.startLoc);
          }
          const ch = this.input.charCodeAt(this.state.pos);
          if (ch === quote) break;
          if (ch === 38) {
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadEntity();
            chunkStart = this.state.pos;
          } else if (isNewLine(ch)) {
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadNewLine(false);
            chunkStart = this.state.pos;
          } else {
            ++this.state.pos;
          }
        }
        out += this.input.slice(chunkStart, this.state.pos++);
        this.finishToken(134, out);
      }
      jsxReadEntity() {
        const startPos = ++this.state.pos;
        if (this.codePointAtPos(this.state.pos) === 35) {
          ++this.state.pos;
          let radix = 10;
          if (this.codePointAtPos(this.state.pos) === 120) {
            radix = 16;
            ++this.state.pos;
          }
          const codePoint = this.readInt(radix, undefined, false, 'bail');
          if (
            codePoint !== null &&
            this.codePointAtPos(this.state.pos) === 59
          ) {
            ++this.state.pos;
            return String.fromCodePoint(codePoint);
          }
        } else {
          let count = 0;
          let semi = false;
          while (
            count++ < 10 &&
            this.state.pos < this.length &&
            !(semi = this.codePointAtPos(this.state.pos) === 59)
          ) {
            ++this.state.pos;
          }
          if (semi) {
            const desc = this.input.slice(startPos, this.state.pos);
            const entity = entities[desc];
            ++this.state.pos;
            if (entity) {
              return entity;
            }
          }
        }
        this.state.pos = startPos;
        return '&';
      }
      jsxReadWord() {
        let ch;
        const start = this.state.pos;
        do {
          ch = this.input.charCodeAt(++this.state.pos);
        } while (isIdentifierChar(ch) || ch === 45);
        this.finishToken(141, this.input.slice(start, this.state.pos));
      }
      jsxParseIdentifier() {
        const node = this.startNode();
        if (this.match(141)) {
          node.name = this.state.value;
        } else if (tokenIsKeyword(this.state.type)) {
          node.name = tokenLabelName(this.state.type);
        } else {
          this.unexpected();
        }
        this.next();
        return this.finishNode(node, 'JSXIdentifier');
      }
      jsxParseNamespacedName() {
        const startLoc = this.state.startLoc;
        const name = this.jsxParseIdentifier();
        if (!this.eat(14)) return name;
        const node = this.startNodeAt(startLoc);
        node.namespace = name;
        node.name = this.jsxParseIdentifier();
        return this.finishNode(node, 'JSXNamespacedName');
      }
      jsxParseElementName() {
        const startLoc = this.state.startLoc;
        let node = this.jsxParseNamespacedName();
        if (node.type === 'JSXNamespacedName') {
          return node;
        }
        while (this.eat(16)) {
          const newNode = this.startNodeAt(startLoc);
          newNode.object = node;
          newNode.property = this.jsxParseIdentifier();
          node = this.finishNode(newNode, 'JSXMemberExpression');
        }
        return node;
      }
      jsxParseAttributeValue() {
        let node;
        switch (this.state.type) {
          case 5:
            node = this.startNode();
            this.setContext(types.brace);
            this.next();
            node = this.jsxParseExpressionContainer(node, types.j_oTag);
            if (node.expression.type === 'JSXEmptyExpression') {
              this.raise(JsxErrors.AttributeIsEmpty, node);
            }
            return node;
          case 143:
          case 134:
            return this.parseExprAtom();
          default:
            throw this.raise(
              JsxErrors.UnsupportedJsxValue,
              this.state.startLoc
            );
        }
      }
      jsxParseEmptyExpression() {
        const node = this.startNodeAt(this.state.lastTokEndLoc);
        return this.finishNodeAt(
          node,
          'JSXEmptyExpression',
          this.state.startLoc
        );
      }
      jsxParseSpreadChild(node) {
        this.next();
        node.expression = this.parseExpression();
        this.setContext(types.j_expr);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXSpreadChild');
      }
      jsxParseExpressionContainer(node, previousContext) {
        if (this.match(8)) {
          node.expression = this.jsxParseEmptyExpression();
        } else {
          const expression = this.parseExpression();
          node.expression = expression;
        }
        this.setContext(previousContext);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXExpressionContainer');
      }
      jsxParseAttribute() {
        const node = this.startNode();
        if (this.match(5)) {
          this.setContext(types.brace);
          this.next();
          this.expect(21);
          node.argument = this.parseMaybeAssignAllowIn();
          this.setContext(types.j_oTag);
          this.state.canStartJSXElement = true;
          this.expect(8);
          return this.finishNode(node, 'JSXSpreadAttribute');
        }
        node.name = this.jsxParseNamespacedName();
        node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
        return this.finishNode(node, 'JSXAttribute');
      }
      jsxParseOpeningElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        if (this.eat(144)) {
          return this.finishNode(node, 'JSXOpeningFragment');
        }
        node.name = this.jsxParseElementName();
        return this.jsxParseOpeningElementAfterName(node);
      }
      jsxParseOpeningElementAfterName(node) {
        const attributes = [];
        while (!this.match(56) && !this.match(144)) {
          attributes.push(this.jsxParseAttribute());
        }
        node.attributes = attributes;
        node.selfClosing = this.eat(56);
        this.expect(144);
        return this.finishNode(node, 'JSXOpeningElement');
      }
      jsxParseClosingElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        if (this.eat(144)) {
          return this.finishNode(node, 'JSXClosingFragment');
        }
        node.name = this.jsxParseElementName();
        this.expect(144);
        return this.finishNode(node, 'JSXClosingElement');
      }
      jsxParseElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        const children = [];
        const openingElement = this.jsxParseOpeningElementAt(startLoc);
        let closingElement = null;
        if (!openingElement.selfClosing) {
          contents: for (;;) {
            switch (this.state.type) {
              case 143:
                startLoc = this.state.startLoc;
                this.next();
                if (this.eat(56)) {
                  closingElement = this.jsxParseClosingElementAt(startLoc);
                  break contents;
                }
                children.push(this.jsxParseElementAt(startLoc));
                break;
              case 142:
                children.push(this.parseLiteral(this.state.value, 'JSXText'));
                break;
              case 5: {
                const node = this.startNode();
                this.setContext(types.brace);
                this.next();
                if (this.match(21)) {
                  children.push(this.jsxParseSpreadChild(node));
                } else {
                  children.push(
                    this.jsxParseExpressionContainer(node, types.j_expr)
                  );
                }
                break;
              }
              default:
                this.unexpected();
            }
          }
          if (
            isFragment(openingElement) &&
            !isFragment(closingElement) &&
            closingElement !== null
          ) {
            this.raise(JsxErrors.MissingClosingTagFragment, closingElement);
          } else if (
            !isFragment(openingElement) &&
            isFragment(closingElement)
          ) {
            this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
              openingTagName: getQualifiedJSXName(openingElement.name),
            });
          } else if (
            !isFragment(openingElement) &&
            !isFragment(closingElement)
          ) {
            if (
              getQualifiedJSXName(closingElement.name) !==
              getQualifiedJSXName(openingElement.name)
            ) {
              this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
                openingTagName: getQualifiedJSXName(openingElement.name),
              });
            }
          }
        }
        if (isFragment(openingElement)) {
          node.openingFragment = openingElement;
          node.closingFragment = closingElement;
        } else {
          node.openingElement = openingElement;
          node.closingElement = closingElement;
        }
        node.children = children;
        if (this.match(47)) {
          throw this.raise(
            JsxErrors.UnwrappedAdjacentJSXElements,
            this.state.startLoc
          );
        }
        return isFragment(openingElement)
          ? this.finishNode(node, 'JSXFragment')
          : this.finishNode(node, 'JSXElement');
      }
      jsxParseElement() {
        const startLoc = this.state.startLoc;
        this.next();
        return this.jsxParseElementAt(startLoc);
      }
      setContext(newContext) {
        const {context: context} = this.state;
        context[context.length - 1] = newContext;
      }
      parseExprAtom(refExpressionErrors) {
        if (this.match(143)) {
          return this.jsxParseElement();
        } else if (
          this.match(47) &&
          this.input.charCodeAt(this.state.pos) !== 33
        ) {
          this.replaceToken(143);
          return this.jsxParseElement();
        } else {
          return super.parseExprAtom(refExpressionErrors);
        }
      }
      skipSpace() {
        const curContext = this.curContext();
        if (!curContext.preserveSpace) super.skipSpace();
      }
      getTokenFromCode(code) {
        const context = this.curContext();
        if (context === types.j_expr) {
          this.jsxReadToken();
          return;
        }
        if (context === types.j_oTag || context === types.j_cTag) {
          if (isIdentifierStart(code)) {
            this.jsxReadWord();
            return;
          }
          if (code === 62) {
            ++this.state.pos;
            this.finishToken(144);
            return;
          }
          if ((code === 34 || code === 39) && context === types.j_oTag) {
            this.jsxReadString(code);
            return;
          }
        }
        if (
          code === 60 &&
          this.state.canStartJSXElement &&
          this.input.charCodeAt(this.state.pos + 1) !== 33
        ) {
          ++this.state.pos;
          this.finishToken(143);
          return;
        }
        super.getTokenFromCode(code);
      }
      updateContext(prevType) {
        const {context: context, type: type} = this.state;
        if (type === 56 && prevType === 143) {
          context.splice(-2, 2, types.j_cTag);
          this.state.canStartJSXElement = false;
        } else if (type === 143) {
          context.push(types.j_oTag);
        } else if (type === 144) {
          const out = context[context.length - 1];
          if (
            (out === types.j_oTag && prevType === 56) ||
            out === types.j_cTag
          ) {
            context.pop();
            this.state.canStartJSXElement =
              context[context.length - 1] === types.j_expr;
          } else {
            this.setContext(types.j_expr);
            this.state.canStartJSXElement = true;
          }
        } else {
          this.state.canStartJSXElement = tokenComesBeforeExpression(type);
        }
      }
    };
  class TypeScriptScope extends Scope {
    constructor(...args) {
      super(...args);
      this.tsNames = new Map();
    }
  }
  class TypeScriptScopeHandler extends ScopeHandler {
    constructor(...args) {
      super(...args);
      this.importsStack = [];
    }
    createScope(flags) {
      this.importsStack.push(new Set());
      return new TypeScriptScope(flags);
    }
    enter(flags) {
      if (flags === 256) {
        this.importsStack.push(new Set());
      }
      super.enter(flags);
    }
    exit() {
      const flags = super.exit();
      if (flags === 256) {
        this.importsStack.pop();
      }
      return flags;
    }
    hasImport(name, allowShadow) {
      const len = this.importsStack.length;
      if (this.importsStack[len - 1].has(name)) {
        return true;
      }
      if (!allowShadow && len > 1) {
        for (let i = 0; i < len - 1; i++) {
          if (this.importsStack[i].has(name)) return true;
        }
      }
      return false;
    }
    declareName(name, bindingType, loc) {
      if (bindingType & 4096) {
        if (this.hasImport(name, true)) {
          this.parser.raise(Errors.VarRedeclaration, loc, {
            identifierName: name,
          });
        }
        this.importsStack[this.importsStack.length - 1].add(name);
        return;
      }
      const scope = this.currentScope();
      let type = scope.tsNames.get(name) || 0;
      if (bindingType & 1024) {
        this.maybeExportDefined(scope, name);
        scope.tsNames.set(name, type | 16);
        return;
      }
      super.declareName(name, bindingType, loc);
      if (bindingType & 2) {
        if (!(bindingType & 1)) {
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          this.maybeExportDefined(scope, name);
        }
        type = type | 1;
      }
      if (bindingType & 256) {
        type = type | 2;
      }
      if (bindingType & 512) {
        type = type | 4;
      }
      if (bindingType & 128) {
        type = type | 8;
      }
      if (type) scope.tsNames.set(name, type);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      const type = scope.tsNames.get(name);
      if ((type & 2) > 0) {
        if (bindingType & 256) {
          const isConst = !!(bindingType & 512);
          const wasConst = (type & 4) > 0;
          return isConst !== wasConst;
        }
        return true;
      }
      if (bindingType & 128 && (type & 8) > 0) {
        if (scope.names.get(name) & 2) {
          return !!(bindingType & 1);
        } else {
          return false;
        }
      }
      if (bindingType & 2 && (type & 1) > 0) {
        return true;
      }
      return super.isRedeclaredInScope(scope, name, bindingType);
    }
    checkLocalExport(id) {
      const {name: name} = id;
      if (this.hasImport(name)) return;
      const len = this.scopeStack.length;
      for (let i = len - 1; i >= 0; i--) {
        const scope = this.scopeStack[i];
        const type = scope.tsNames.get(name);
        if ((type & 1) > 0 || (type & 16) > 0) {
          return;
        }
      }
      super.checkLocalExport(id);
    }
  }
  const unwrapParenthesizedExpression = node =>
    node.type === 'ParenthesizedExpression'
      ? unwrapParenthesizedExpression(node.expression)
      : node;
  class LValParser extends NodeUtils {
    toAssignable(node, isLHS = false) {
      var _node$extra, _node$extra3;
      let parenthesized = undefined;
      if (
        node.type === 'ParenthesizedExpression' ||
        ((_node$extra = node.extra) != null && _node$extra.parenthesized)
      ) {
        parenthesized = unwrapParenthesizedExpression(node);
        if (isLHS) {
          if (parenthesized.type === 'Identifier') {
            this.expressionScope.recordArrowParameterBindingError(
              Errors.InvalidParenthesizedAssignment,
              node
            );
          } else if (
            parenthesized.type !== 'MemberExpression' &&
            !this.isOptionalMemberExpression(parenthesized)
          ) {
            this.raise(Errors.InvalidParenthesizedAssignment, node);
          }
        } else {
          this.raise(Errors.InvalidParenthesizedAssignment, node);
        }
      }
      switch (node.type) {
        case 'Identifier':
        case 'ObjectPattern':
        case 'ArrayPattern':
        case 'AssignmentPattern':
        case 'RestElement':
          break;
        case 'ObjectExpression':
          node.type = 'ObjectPattern';
          for (
            let i = 0, length = node.properties.length, last = length - 1;
            i < length;
            i++
          ) {
            var _node$extra2;
            const prop = node.properties[i];
            const isLast = i === last;
            this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
            if (
              isLast &&
              prop.type === 'RestElement' &&
              (_node$extra2 = node.extra) != null &&
              _node$extra2.trailingCommaLoc
            ) {
              this.raise(Errors.RestTrailingComma, node.extra.trailingCommaLoc);
            }
          }
          break;
        case 'ObjectProperty': {
          const {key: key, value: value} = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(
              this.getPrivateNameSV(key),
              key.loc.start
            );
          }
          this.toAssignable(value, isLHS);
          break;
        }
        case 'SpreadElement': {
          throw new Error(
            'Internal @babel/parser error (this is a bug, please report it).' +
              " SpreadElement should be converted by .toAssignable's caller."
          );
        }
        case 'ArrayExpression':
          node.type = 'ArrayPattern';
          this.toAssignableList(
            node.elements,
            (_node$extra3 = node.extra) == null
              ? void 0
              : _node$extra3.trailingCommaLoc,
            isLHS
          );
          break;
        case 'AssignmentExpression':
          if (node.operator !== '=') {
            this.raise(Errors.MissingEqInAssignment, node.left.loc.end);
          }
          node.type = 'AssignmentPattern';
          delete node.operator;
          this.toAssignable(node.left, isLHS);
          break;
        case 'ParenthesizedExpression':
          this.toAssignable(parenthesized, isLHS);
          break;
      }
    }
    toAssignableObjectExpressionProp(prop, isLast, isLHS) {
      if (prop.type === 'ObjectMethod') {
        this.raise(
          prop.kind === 'get' || prop.kind === 'set'
            ? Errors.PatternHasAccessor
            : Errors.PatternHasMethod,
          prop.key
        );
      } else if (prop.type === 'SpreadElement') {
        prop.type = 'RestElement';
        const arg = prop.argument;
        this.checkToRestConversion(arg, false);
        this.toAssignable(arg, isLHS);
        if (!isLast) {
          this.raise(Errors.RestTrailingComma, prop);
        }
      } else {
        this.toAssignable(prop, isLHS);
      }
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      const end = exprList.length - 1;
      for (let i = 0; i <= end; i++) {
        const elt = exprList[i];
        if (!elt) continue;
        if (elt.type === 'SpreadElement') {
          elt.type = 'RestElement';
          const arg = elt.argument;
          this.checkToRestConversion(arg, true);
          this.toAssignable(arg, isLHS);
        } else {
          this.toAssignable(elt, isLHS);
        }
        if (elt.type === 'RestElement') {
          if (i < end) {
            this.raise(Errors.RestTrailingComma, elt);
          } else if (trailingCommaLoc) {
            this.raise(Errors.RestTrailingComma, trailingCommaLoc);
          }
        }
      }
    }
    isAssignable(node, isBinding) {
      switch (node.type) {
        case 'Identifier':
        case 'ObjectPattern':
        case 'ArrayPattern':
        case 'AssignmentPattern':
        case 'RestElement':
          return true;
        case 'ObjectExpression': {
          const last = node.properties.length - 1;
          return node.properties.every(
            (prop, i) =>
              prop.type !== 'ObjectMethod' &&
              (i === last || prop.type !== 'SpreadElement') &&
              this.isAssignable(prop)
          );
        }
        case 'ObjectProperty':
          return this.isAssignable(node.value);
        case 'SpreadElement':
          return this.isAssignable(node.argument);
        case 'ArrayExpression':
          return node.elements.every(
            element => element === null || this.isAssignable(element)
          );
        case 'AssignmentExpression':
          return node.operator === '=';
        case 'ParenthesizedExpression':
          return this.isAssignable(node.expression);
        case 'MemberExpression':
        case 'OptionalMemberExpression':
          return !isBinding;
        default:
          return false;
      }
    }
    toReferencedList(exprList, isParenthesizedExpr) {
      return exprList;
    }
    toReferencedListDeep(exprList, isParenthesizedExpr) {
      this.toReferencedList(exprList, isParenthesizedExpr);
      for (const expr of exprList) {
        if ((expr == null ? void 0 : expr.type) === 'ArrayExpression') {
          this.toReferencedListDeep(expr.elements);
        }
      }
    }
    parseSpread(refExpressionErrors) {
      const node = this.startNode();
      this.next();
      node.argument = this.parseMaybeAssignAllowIn(
        refExpressionErrors,
        undefined
      );
      return this.finishNode(node, 'SpreadElement');
    }
    parseRestBinding() {
      const node = this.startNode();
      this.next();
      node.argument = this.parseBindingAtom();
      return this.finishNode(node, 'RestElement');
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 0: {
          const node = this.startNode();
          this.next();
          node.elements = this.parseBindingList(3, 93, 1);
          return this.finishNode(node, 'ArrayPattern');
        }
        case 5:
          return this.parseObjectLike(8, true);
      }
      return this.parseIdentifier();
    }
    parseBindingList(close, closeCharCode, flags) {
      const allowEmpty = flags & 1;
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
        }
        if (allowEmpty && this.match(12)) {
          elts.push(null);
        } else if (this.eat(close)) {
          break;
        } else if (this.match(21)) {
          let rest = this.parseRestBinding();
          if (this.hasPlugin('flow') || flags & 2) {
            rest = this.parseFunctionParamType(rest);
          }
          elts.push(rest);
          if (!this.checkCommaAfterRest(closeCharCode)) {
            this.expect(close);
            break;
          }
        } else {
          const decorators = [];
          if (this.match(26) && this.hasPlugin('decorators')) {
            this.raise(
              Errors.UnsupportedParameterDecorator,
              this.state.startLoc
            );
          }
          while (this.match(26)) {
            decorators.push(this.parseDecorator());
          }
          elts.push(this.parseAssignableListItem(flags, decorators));
        }
      }
      return elts;
    }
    parseBindingRestProperty(prop) {
      this.next();
      prop.argument = this.parseIdentifier();
      this.checkCommaAfterRest(125);
      return this.finishNode(prop, 'RestElement');
    }
    parseBindingProperty() {
      const {type: type, startLoc: startLoc} = this.state;
      if (type === 21) {
        return this.parseBindingRestProperty(this.startNode());
      }
      const prop = this.startNode();
      if (type === 139) {
        this.expectPlugin('destructuringPrivate', startLoc);
        this.classScope.usePrivateName(this.state.value, startLoc);
        prop.key = this.parsePrivateName();
      } else {
        this.parsePropertyName(prop);
      }
      prop.method = false;
      return this.parseObjPropValue(prop, startLoc, false, false, true, false);
    }
    parseAssignableListItem(flags, decorators) {
      const left = this.parseMaybeDefault();
      if (this.hasPlugin('flow') || flags & 2) {
        this.parseFunctionParamType(left);
      }
      const elt = this.parseMaybeDefault(left.loc.start, left);
      if (decorators.length) {
        left.decorators = decorators;
      }
      return elt;
    }
    parseFunctionParamType(param) {
      return param;
    }
    parseMaybeDefault(startLoc, left) {
      var _startLoc, _left;
      (_startLoc = startLoc) != null
        ? _startLoc
        : (startLoc = this.state.startLoc);
      left = (_left = left) != null ? _left : this.parseBindingAtom();
      if (!this.eat(29)) return left;
      const node = this.startNodeAt(startLoc);
      node.left = left;
      node.right = this.parseMaybeAssignAllowIn();
      return this.finishNode(node, 'AssignmentPattern');
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      switch (type) {
        case 'AssignmentPattern':
          return 'left';
        case 'RestElement':
          return 'argument';
        case 'ObjectProperty':
          return 'value';
        case 'ParenthesizedExpression':
          return 'expression';
        case 'ArrayPattern':
          return 'elements';
        case 'ObjectPattern':
          return 'properties';
      }
      return false;
    }
    isOptionalMemberExpression(expression) {
      return expression.type === 'OptionalMemberExpression';
    }
    checkLVal(
      expression,
      ancestor,
      binding = 64,
      checkClashes = false,
      strictModeChanged = false,
      hasParenthesizedAncestor = false
    ) {
      var _expression$extra;
      const type = expression.type;
      if (this.isObjectMethod(expression)) return;
      const isOptionalMemberExpression =
        this.isOptionalMemberExpression(expression);
      if (isOptionalMemberExpression || type === 'MemberExpression') {
        if (isOptionalMemberExpression) {
          this.expectPlugin('optionalChainingAssign', expression.loc.start);
          if (ancestor.type !== 'AssignmentExpression') {
            this.raise(Errors.InvalidLhsOptionalChaining, expression, {
              ancestor: ancestor,
            });
          }
        }
        if (binding !== 64) {
          this.raise(Errors.InvalidPropertyBindingPattern, expression);
        }
        return;
      }
      if (type === 'Identifier') {
        this.checkIdentifier(expression, binding, strictModeChanged);
        const {name: name} = expression;
        if (checkClashes) {
          if (checkClashes.has(name)) {
            this.raise(Errors.ParamDupe, expression);
          } else {
            checkClashes.add(name);
          }
        }
        return;
      }
      const validity = this.isValidLVal(
        type,
        !(
          hasParenthesizedAncestor ||
          ((_expression$extra = expression.extra) != null &&
            _expression$extra.parenthesized)
        ) && ancestor.type === 'AssignmentExpression',
        binding
      );
      if (validity === true) return;
      if (validity === false) {
        const ParseErrorClass =
          binding === 64 ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
        this.raise(ParseErrorClass, expression, {ancestor: ancestor});
        return;
      }
      let key, isParenthesizedExpression;
      if (typeof validity === 'string') {
        key = validity;
        isParenthesizedExpression = type === 'ParenthesizedExpression';
      } else {
        [key, isParenthesizedExpression] = validity;
      }
      const nextAncestor =
        type === 'ArrayPattern' || type === 'ObjectPattern'
          ? {type: type}
          : ancestor;
      const val = expression[key];
      if (Array.isArray(val)) {
        for (const child of val) {
          if (child) {
            this.checkLVal(
              child,
              nextAncestor,
              binding,
              checkClashes,
              strictModeChanged,
              isParenthesizedExpression
            );
          }
        }
      } else if (val) {
        this.checkLVal(
          val,
          nextAncestor,
          binding,
          checkClashes,
          strictModeChanged,
          isParenthesizedExpression
        );
      }
    }
    checkIdentifier(at, bindingType, strictModeChanged = false) {
      if (
        this.state.strict &&
        (strictModeChanged
          ? isStrictBindReservedWord(at.name, this.inModule)
          : isStrictBindOnlyReservedWord(at.name))
      ) {
        if (bindingType === 64) {
          this.raise(Errors.StrictEvalArguments, at, {referenceName: at.name});
        } else {
          this.raise(Errors.StrictEvalArgumentsBinding, at, {
            bindingName: at.name,
          });
        }
      }
      if (bindingType & 8192 && at.name === 'let') {
        this.raise(Errors.LetInLexicalBinding, at);
      }
      if (!(bindingType & 64)) {
        this.declareNameFromIdentifier(at, bindingType);
      }
    }
    declareNameFromIdentifier(identifier, binding) {
      this.scope.declareName(identifier.name, binding, identifier.loc.start);
    }
    checkToRestConversion(node, allowPattern) {
      switch (node.type) {
        case 'ParenthesizedExpression':
          this.checkToRestConversion(node.expression, allowPattern);
          break;
        case 'Identifier':
        case 'MemberExpression':
          break;
        case 'ArrayExpression':
        case 'ObjectExpression':
          if (allowPattern) break;
        default:
          this.raise(Errors.InvalidRestAssignmentPattern, node);
      }
    }
    checkCommaAfterRest(close) {
      if (!this.match(12)) {
        return false;
      }
      this.raise(
        this.lookaheadCharCode() === close
          ? Errors.RestTrailingComma
          : Errors.ElementAfterRest,
        this.state.startLoc
      );
      return true;
    }
  }
  function nonNull(x) {
    if (x == null) {
      throw new Error(`Unexpected ${x} value.`);
    }
    return x;
  }
  function assert(x) {
    if (!x) {
      throw new Error('Assert fail');
    }
  }
  const TSErrors = ParseErrorEnum`typescript`({
    AbstractMethodHasImplementation: ({methodName: methodName}) =>
      `Method '${methodName}' cannot have an implementation because it is marked abstract.`,
    AbstractPropertyHasInitializer: ({propertyName: propertyName}) =>
      `Property '${propertyName}' cannot have an initializer because it is marked abstract.`,
    AccessorCannotBeOptional:
      "An 'accessor' property cannot be declared optional.",
    AccessorCannotDeclareThisParameter:
      "'get' and 'set' accessors cannot declare 'this' parameters.",
    AccessorCannotHaveTypeParameters:
      'An accessor cannot have type parameters.',
    ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
    ClassMethodHasReadonly:
      "Class methods cannot have the 'readonly' modifier.",
    ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference:
      "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
    ConstructorHasTypeParameters:
      'Type parameters cannot appear on a constructor declaration.',
    DeclareAccessor: ({kind: kind}) =>
      `'declare' is not allowed in ${kind}ters.`,
    DeclareClassFieldHasInitializer:
      'Initializers are not allowed in ambient contexts.',
    DeclareFunctionHasImplementation:
      'An implementation cannot be declared in ambient contexts.',
    DuplicateAccessibilityModifier: ({modifier: modifier}) =>
      `Accessibility modifier already seen.`,
    DuplicateModifier: ({modifier: modifier}) =>
      `Duplicate modifier: '${modifier}'.`,
    EmptyHeritageClauseType: ({token: token}) =>
      `'${token}' list cannot be empty.`,
    EmptyTypeArguments: 'Type argument list cannot be empty.',
    EmptyTypeParameters: 'Type parameter list cannot be empty.',
    ExpectedAmbientAfterExportDeclare:
      "'export declare' must be followed by an ambient declaration.",
    ImportAliasHasImportType: "An import alias can not use 'import type'.",
    ImportReflectionHasImportType:
      'An `import module` declaration can not use `type` modifier',
    IncompatibleModifiers: ({modifiers: modifiers}) =>
      `'${modifiers[0]}' modifier cannot be used with '${modifiers[1]}' modifier.`,
    IndexSignatureHasAbstract:
      "Index signatures cannot have the 'abstract' modifier.",
    IndexSignatureHasAccessibility: ({modifier: modifier}) =>
      `Index signatures cannot have an accessibility modifier ('${modifier}').`,
    IndexSignatureHasDeclare:
      "Index signatures cannot have the 'declare' modifier.",
    IndexSignatureHasOverride:
      "'override' modifier cannot appear on an index signature.",
    IndexSignatureHasStatic:
      "Index signatures cannot have the 'static' modifier.",
    InitializerNotAllowedInAmbientContext:
      'Initializers are not allowed in ambient contexts.',
    InvalidModifierOnTypeMember: ({modifier: modifier}) =>
      `'${modifier}' modifier cannot appear on a type member.`,
    InvalidModifierOnTypeParameter: ({modifier: modifier}) =>
      `'${modifier}' modifier cannot appear on a type parameter.`,
    InvalidModifierOnTypeParameterPositions: ({modifier: modifier}) =>
      `'${modifier}' modifier can only appear on a type parameter of a class, interface or type alias.`,
    InvalidModifiersOrder: ({orderedModifiers: orderedModifiers}) =>
      `'${orderedModifiers[0]}' modifier must precede '${orderedModifiers[1]}' modifier.`,
    InvalidPropertyAccessAfterInstantiationExpression:
      'Invalid property access after an instantiation expression. ' +
      'You can either wrap the instantiation expression in parentheses, or delete the type arguments.',
    InvalidTupleMemberLabel:
      'Tuple members must be labeled with a simple identifier.',
    MissingInterfaceName:
      "'interface' declarations must be followed by an identifier.",
    NonAbstractClassHasAbstractMethod:
      'Abstract methods can only appear within an abstract class.',
    NonClassMethodPropertyHasAbstractModifer:
      "'abstract' modifier can only appear on a class, method, or property declaration.",
    OptionalTypeBeforeRequired:
      'A required element cannot follow an optional element.',
    OverrideNotInSubClass:
      "This member cannot have an 'override' modifier because its containing class does not extend another class.",
    PatternIsOptional:
      'A binding pattern parameter cannot be optional in an implementation signature.',
    PrivateElementHasAbstract:
      "Private elements cannot have the 'abstract' modifier.",
    PrivateElementHasAccessibility: ({modifier: modifier}) =>
      `Private elements cannot have an accessibility modifier ('${modifier}').`,
    ReadonlyForMethodSignature:
      "'readonly' modifier can only appear on a property declaration or index signature.",
    ReservedArrowTypeParam:
      'This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.',
    ReservedTypeAssertion:
      'This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.',
    SetAccessorCannotHaveOptionalParameter:
      "A 'set' accessor cannot have an optional parameter.",
    SetAccessorCannotHaveRestParameter:
      "A 'set' accessor cannot have rest parameter.",
    SetAccessorCannotHaveReturnType:
      "A 'set' accessor cannot have a return type annotation.",
    SingleTypeParameterWithoutTrailingComma: ({
      typeParameterName: typeParameterName,
    }) =>
      `Single type parameter ${typeParameterName} should have a trailing comma. Example usage: <${typeParameterName},>.`,
    StaticBlockCannotHaveModifier:
      'Static class blocks cannot have any modifier.',
    TupleOptionalAfterType:
      'A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).',
    TypeAnnotationAfterAssign:
      'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
    TypeImportCannotSpecifyDefaultAndNamed:
      'A type-only import can specify a default import or named bindings, but not both.',
    TypeModifierIsUsedInTypeExports:
      "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
    TypeModifierIsUsedInTypeImports:
      "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
    UnexpectedParameterModifier:
      'A parameter property is only allowed in a constructor implementation.',
    UnexpectedReadonly:
      "'readonly' type modifier is only permitted on array and tuple literal types.",
    UnexpectedTypeAnnotation: 'Did not expect a type annotation here.',
    UnexpectedTypeCastInParameter:
      'Unexpected type cast in parameter position.',
    UnsupportedImportTypeArgument:
      'Argument in a type import must be a string literal.',
    UnsupportedParameterPropertyKind:
      'A parameter property may not be declared using a binding pattern.',
    UnsupportedSignatureParameterKind: ({type: type}) =>
      `Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ${type}.`,
  });
  function keywordTypeFromName(value) {
    switch (value) {
      case 'any':
        return 'TSAnyKeyword';
      case 'boolean':
        return 'TSBooleanKeyword';
      case 'bigint':
        return 'TSBigIntKeyword';
      case 'never':
        return 'TSNeverKeyword';
      case 'number':
        return 'TSNumberKeyword';
      case 'object':
        return 'TSObjectKeyword';
      case 'string':
        return 'TSStringKeyword';
      case 'symbol':
        return 'TSSymbolKeyword';
      case 'undefined':
        return 'TSUndefinedKeyword';
      case 'unknown':
        return 'TSUnknownKeyword';
      default:
        return undefined;
    }
  }
  function tsIsAccessModifier(modifier) {
    return (
      modifier === 'private' ||
      modifier === 'public' ||
      modifier === 'protected'
    );
  }
  function tsIsVarianceAnnotations(modifier) {
    return modifier === 'in' || modifier === 'out';
  }
  var typescript = superClass =>
    class TypeScriptParserMixin extends superClass {
      constructor(...args) {
        super(...args);
        this.tsParseInOutModifiers = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['in', 'out'],
          disallowedModifiers: [
            'const',
            'public',
            'private',
            'protected',
            'readonly',
            'declare',
            'abstract',
            'override',
          ],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
        });
        this.tsParseConstModifier = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['const'],
          disallowedModifiers: ['in', 'out'],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
        });
        this.tsParseInOutConstModifiers = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['in', 'out', 'const'],
          disallowedModifiers: [
            'public',
            'private',
            'protected',
            'readonly',
            'declare',
            'abstract',
            'override',
          ],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
        });
      }
      getScopeHandler() {
        return TypeScriptScopeHandler;
      }
      tsIsIdentifier() {
        return tokenIsIdentifier(this.state.type);
      }
      tsTokenCanFollowModifier() {
        return (
          this.match(0) ||
          this.match(5) ||
          this.match(55) ||
          this.match(21) ||
          this.match(139) ||
          this.isLiteralPropertyName()
        );
      }
      tsNextTokenOnSameLineAndCanFollowModifier() {
        this.next();
        if (this.hasPrecedingLineBreak()) {
          return false;
        }
        return this.tsTokenCanFollowModifier();
      }
      tsNextTokenCanFollowModifier() {
        if (this.match(106)) {
          this.next();
          return this.tsTokenCanFollowModifier();
        }
        return this.tsNextTokenOnSameLineAndCanFollowModifier();
      }
      tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
        if (
          !tokenIsIdentifier(this.state.type) &&
          this.state.type !== 58 &&
          this.state.type !== 75
        ) {
          return undefined;
        }
        const modifier = this.state.value;
        if (allowedModifiers.includes(modifier)) {
          if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
            return undefined;
          }
          if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
            return modifier;
          }
        }
        return undefined;
      }
      tsParseModifiers(
        {
          allowedModifiers: allowedModifiers,
          disallowedModifiers: disallowedModifiers,
          stopOnStartOfClassStaticBlock: stopOnStartOfClassStaticBlock,
          errorTemplate: errorTemplate = TSErrors.InvalidModifierOnTypeMember,
        },
        modified
      ) {
        const enforceOrder = (loc, modifier, before, after) => {
          if (modifier === before && modified[after]) {
            this.raise(TSErrors.InvalidModifiersOrder, loc, {
              orderedModifiers: [before, after],
            });
          }
        };
        const incompatible = (loc, modifier, mod1, mod2) => {
          if (
            (modified[mod1] && modifier === mod2) ||
            (modified[mod2] && modifier === mod1)
          ) {
            this.raise(TSErrors.IncompatibleModifiers, loc, {
              modifiers: [mod1, mod2],
            });
          }
        };
        for (;;) {
          const {startLoc: startLoc} = this.state;
          const modifier = this.tsParseModifier(
            allowedModifiers.concat(
              disallowedModifiers != null ? disallowedModifiers : []
            ),
            stopOnStartOfClassStaticBlock
          );
          if (!modifier) break;
          if (tsIsAccessModifier(modifier)) {
            if (modified.accessibility) {
              this.raise(TSErrors.DuplicateAccessibilityModifier, startLoc, {
                modifier: modifier,
              });
            } else {
              enforceOrder(startLoc, modifier, modifier, 'override');
              enforceOrder(startLoc, modifier, modifier, 'static');
              enforceOrder(startLoc, modifier, modifier, 'readonly');
              modified.accessibility = modifier;
            }
          } else if (tsIsVarianceAnnotations(modifier)) {
            if (modified[modifier]) {
              this.raise(TSErrors.DuplicateModifier, startLoc, {
                modifier: modifier,
              });
            }
            modified[modifier] = true;
            enforceOrder(startLoc, modifier, 'in', 'out');
          } else {
            if (hasOwnProperty.call(modified, modifier)) {
              this.raise(TSErrors.DuplicateModifier, startLoc, {
                modifier: modifier,
              });
            } else {
              enforceOrder(startLoc, modifier, 'static', 'readonly');
              enforceOrder(startLoc, modifier, 'static', 'override');
              enforceOrder(startLoc, modifier, 'override', 'readonly');
              enforceOrder(startLoc, modifier, 'abstract', 'override');
              incompatible(startLoc, modifier, 'declare', 'override');
              incompatible(startLoc, modifier, 'static', 'abstract');
            }
            modified[modifier] = true;
          }
          if (
            disallowedModifiers != null &&
            disallowedModifiers.includes(modifier)
          ) {
            this.raise(errorTemplate, startLoc, {modifier: modifier});
          }
        }
      }
      tsIsListTerminator(kind) {
        switch (kind) {
          case 'EnumMembers':
          case 'TypeMembers':
            return this.match(8);
          case 'HeritageClauseElement':
            return this.match(5);
          case 'TupleElementTypes':
            return this.match(3);
          case 'TypeParametersOrArguments':
            return this.match(48);
        }
      }
      tsParseList(kind, parseElement) {
        const result = [];
        while (!this.tsIsListTerminator(kind)) {
          result.push(parseElement());
        }
        return result;
      }
      tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
        return nonNull(
          this.tsParseDelimitedListWorker(
            kind,
            parseElement,
            true,
            refTrailingCommaPos
          )
        );
      }
      tsParseDelimitedListWorker(
        kind,
        parseElement,
        expectSuccess,
        refTrailingCommaPos
      ) {
        const result = [];
        let trailingCommaPos = -1;
        for (;;) {
          if (this.tsIsListTerminator(kind)) {
            break;
          }
          trailingCommaPos = -1;
          const element = parseElement();
          if (element == null) {
            return undefined;
          }
          result.push(element);
          if (this.eat(12)) {
            trailingCommaPos = this.state.lastTokStartLoc.index;
            continue;
          }
          if (this.tsIsListTerminator(kind)) {
            break;
          }
          if (expectSuccess) {
            this.expect(12);
          }
          return undefined;
        }
        if (refTrailingCommaPos) {
          refTrailingCommaPos.value = trailingCommaPos;
        }
        return result;
      }
      tsParseBracketedList(
        kind,
        parseElement,
        bracket,
        skipFirstToken,
        refTrailingCommaPos
      ) {
        if (!skipFirstToken) {
          if (bracket) {
            this.expect(0);
          } else {
            this.expect(47);
          }
        }
        const result = this.tsParseDelimitedList(
          kind,
          parseElement,
          refTrailingCommaPos
        );
        if (bracket) {
          this.expect(3);
        } else {
          this.expect(48);
        }
        return result;
      }
      tsParseImportType() {
        const node = this.startNode();
        this.expect(83);
        this.expect(10);
        if (!this.match(134)) {
          this.raise(
            TSErrors.UnsupportedImportTypeArgument,
            this.state.startLoc
          );
        }
        node.argument = super.parseExprAtom();
        if (this.eat(12) && !this.match(11)) {
          node.options = super.parseMaybeAssignAllowIn();
          this.eat(12);
        } else {
          node.options = null;
        }
        this.expect(11);
        if (this.eat(16)) {
          node.qualifier = this.tsParseEntityName();
        }
        if (this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSImportType');
      }
      tsParseEntityName(allowReservedWords = true) {
        let entity = this.parseIdentifier(allowReservedWords);
        while (this.eat(16)) {
          const node = this.startNodeAtNode(entity);
          node.left = entity;
          node.right = this.parseIdentifier(allowReservedWords);
          entity = this.finishNode(node, 'TSQualifiedName');
        }
        return entity;
      }
      tsParseTypeReference() {
        const node = this.startNode();
        node.typeName = this.tsParseEntityName();
        if (!this.hasPrecedingLineBreak() && this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSTypeReference');
      }
      tsParseThisTypePredicate(lhs) {
        this.next();
        const node = this.startNodeAtNode(lhs);
        node.parameterName = lhs;
        node.typeAnnotation = this.tsParseTypeAnnotation(false);
        node.asserts = false;
        return this.finishNode(node, 'TSTypePredicate');
      }
      tsParseThisTypeNode() {
        const node = this.startNode();
        this.next();
        return this.finishNode(node, 'TSThisType');
      }
      tsParseTypeQuery() {
        const node = this.startNode();
        this.expect(87);
        if (this.match(83)) {
          node.exprName = this.tsParseImportType();
        } else {
          node.exprName = this.tsParseEntityName();
        }
        if (!this.hasPrecedingLineBreak() && this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSTypeQuery');
      }
      tsParseTypeParameter(parseModifiers) {
        const node = this.startNode();
        parseModifiers(node);
        node.name = this.tsParseTypeParameterName();
        node.constraint = this.tsEatThenParseType(81);
        node.default = this.tsEatThenParseType(29);
        return this.finishNode(node, 'TSTypeParameter');
      }
      tsTryParseTypeParameters(parseModifiers) {
        if (this.match(47)) {
          return this.tsParseTypeParameters(parseModifiers);
        }
      }
      tsParseTypeParameters(parseModifiers) {
        const node = this.startNode();
        if (this.match(47) || this.match(143)) {
          this.next();
        } else {
          this.unexpected();
        }
        const refTrailingCommaPos = {value: -1};
        node.params = this.tsParseBracketedList(
          'TypeParametersOrArguments',
          this.tsParseTypeParameter.bind(this, parseModifiers),
          false,
          true,
          refTrailingCommaPos
        );
        if (node.params.length === 0) {
          this.raise(TSErrors.EmptyTypeParameters, node);
        }
        if (refTrailingCommaPos.value !== -1) {
          this.addExtra(node, 'trailingComma', refTrailingCommaPos.value);
        }
        return this.finishNode(node, 'TSTypeParameterDeclaration');
      }
      tsFillSignature(returnToken, signature) {
        const returnTokenRequired = returnToken === 19;
        const paramsKey = 'parameters';
        const returnTypeKey = 'typeAnnotation';
        signature.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        this.expect(10);
        signature[paramsKey] = this.tsParseBindingListForSignature();
        if (returnTokenRequired) {
          signature[returnTypeKey] =
            this.tsParseTypeOrTypePredicateAnnotation(returnToken);
        } else if (this.match(returnToken)) {
          signature[returnTypeKey] =
            this.tsParseTypeOrTypePredicateAnnotation(returnToken);
        }
      }
      tsParseBindingListForSignature() {
        const list = super.parseBindingList(11, 41, 2);
        for (const pattern of list) {
          const {type: type} = pattern;
          if (type === 'AssignmentPattern' || type === 'TSParameterProperty') {
            this.raise(TSErrors.UnsupportedSignatureParameterKind, pattern, {
              type: type,
            });
          }
        }
        return list;
      }
      tsParseTypeMemberSemicolon() {
        if (!this.eat(12) && !this.isLineTerminator()) {
          this.expect(13);
        }
      }
      tsParseSignatureMember(kind, node) {
        this.tsFillSignature(14, node);
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(node, kind);
      }
      tsIsUnambiguouslyIndexSignature() {
        this.next();
        if (tokenIsIdentifier(this.state.type)) {
          this.next();
          return this.match(14);
        }
        return false;
      }
      tsTryParseIndexSignature(node) {
        if (
          !(
            this.match(0) &&
            this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this))
          )
        ) {
          return;
        }
        this.expect(0);
        const id = this.parseIdentifier();
        id.typeAnnotation = this.tsParseTypeAnnotation();
        this.resetEndLocation(id);
        this.expect(3);
        node.parameters = [id];
        const type = this.tsTryParseTypeAnnotation();
        if (type) node.typeAnnotation = type;
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(node, 'TSIndexSignature');
      }
      tsParsePropertyOrMethodSignature(node, readonly) {
        if (this.eat(17)) node.optional = true;
        const nodeAny = node;
        if (this.match(10) || this.match(47)) {
          if (readonly) {
            this.raise(TSErrors.ReadonlyForMethodSignature, node);
          }
          const method = nodeAny;
          if (method.kind && this.match(47)) {
            this.raise(
              TSErrors.AccessorCannotHaveTypeParameters,
              this.state.curPosition()
            );
          }
          this.tsFillSignature(14, method);
          this.tsParseTypeMemberSemicolon();
          const paramsKey = 'parameters';
          const returnTypeKey = 'typeAnnotation';
          if (method.kind === 'get') {
            if (method[paramsKey].length > 0) {
              this.raise(Errors.BadGetterArity, this.state.curPosition());
              if (this.isThisParam(method[paramsKey][0])) {
                this.raise(
                  TSErrors.AccessorCannotDeclareThisParameter,
                  this.state.curPosition()
                );
              }
            }
          } else if (method.kind === 'set') {
            if (method[paramsKey].length !== 1) {
              this.raise(Errors.BadSetterArity, this.state.curPosition());
            } else {
              const firstParameter = method[paramsKey][0];
              if (this.isThisParam(firstParameter)) {
                this.raise(
                  TSErrors.AccessorCannotDeclareThisParameter,
                  this.state.curPosition()
                );
              }
              if (
                firstParameter.type === 'Identifier' &&
                firstParameter.optional
              ) {
                this.raise(
                  TSErrors.SetAccessorCannotHaveOptionalParameter,
                  this.state.curPosition()
                );
              }
              if (firstParameter.type === 'RestElement') {
                this.raise(
                  TSErrors.SetAccessorCannotHaveRestParameter,
                  this.state.curPosition()
                );
              }
            }
            if (method[returnTypeKey]) {
              this.raise(
                TSErrors.SetAccessorCannotHaveReturnType,
                method[returnTypeKey]
              );
            }
          } else {
            method.kind = 'method';
          }
          return this.finishNode(method, 'TSMethodSignature');
        } else {
          const property = nodeAny;
          if (readonly) property.readonly = true;
          const type = this.tsTryParseTypeAnnotation();
          if (type) property.typeAnnotation = type;
          this.tsParseTypeMemberSemicolon();
          return this.finishNode(property, 'TSPropertySignature');
        }
      }
      tsParseTypeMember() {
        const node = this.startNode();
        if (this.match(10) || this.match(47)) {
          return this.tsParseSignatureMember(
            'TSCallSignatureDeclaration',
            node
          );
        }
        if (this.match(77)) {
          const id = this.startNode();
          this.next();
          if (this.match(10) || this.match(47)) {
            return this.tsParseSignatureMember(
              'TSConstructSignatureDeclaration',
              node
            );
          } else {
            node.key = this.createIdentifier(id, 'new');
            return this.tsParsePropertyOrMethodSignature(node, false);
          }
        }
        this.tsParseModifiers(
          {
            allowedModifiers: ['readonly'],
            disallowedModifiers: [
              'declare',
              'abstract',
              'private',
              'protected',
              'public',
              'static',
              'override',
            ],
          },
          node
        );
        const idx = this.tsTryParseIndexSignature(node);
        if (idx) {
          return idx;
        }
        super.parsePropertyName(node);
        if (
          !node.computed &&
          node.key.type === 'Identifier' &&
          (node.key.name === 'get' || node.key.name === 'set') &&
          this.tsTokenCanFollowModifier()
        ) {
          node.kind = node.key.name;
          super.parsePropertyName(node);
        }
        return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
      }
      tsParseTypeLiteral() {
        const node = this.startNode();
        node.members = this.tsParseObjectTypeMembers();
        return this.finishNode(node, 'TSTypeLiteral');
      }
      tsParseObjectTypeMembers() {
        this.expect(5);
        const members = this.tsParseList(
          'TypeMembers',
          this.tsParseTypeMember.bind(this)
        );
        this.expect(8);
        return members;
      }
      tsIsStartOfMappedType() {
        this.next();
        if (this.eat(53)) {
          return this.isContextual(122);
        }
        if (this.isContextual(122)) {
          this.next();
        }
        if (!this.match(0)) {
          return false;
        }
        this.next();
        if (!this.tsIsIdentifier()) {
          return false;
        }
        this.next();
        return this.match(58);
      }
      tsParseMappedType() {
        const node = this.startNode();
        this.expect(5);
        if (this.match(53)) {
          node.readonly = this.state.value;
          this.next();
          this.expectContextual(122);
        } else if (this.eatContextual(122)) {
          node.readonly = true;
        }
        this.expect(0);
        {
          const typeParameter = this.startNode();
          typeParameter.name = this.tsParseTypeParameterName();
          typeParameter.constraint = this.tsExpectThenParseType(58);
          node.typeParameter = this.finishNode(
            typeParameter,
            'TSTypeParameter'
          );
        }
        node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
        this.expect(3);
        if (this.match(53)) {
          node.optional = this.state.value;
          this.next();
          this.expect(17);
        } else if (this.eat(17)) {
          node.optional = true;
        }
        node.typeAnnotation = this.tsTryParseType();
        this.semicolon();
        this.expect(8);
        return this.finishNode(node, 'TSMappedType');
      }
      tsParseTupleType() {
        const node = this.startNode();
        node.elementTypes = this.tsParseBracketedList(
          'TupleElementTypes',
          this.tsParseTupleElementType.bind(this),
          true,
          false
        );
        let seenOptionalElement = false;
        node.elementTypes.forEach(elementNode => {
          const {type: type} = elementNode;
          if (
            seenOptionalElement &&
            type !== 'TSRestType' &&
            type !== 'TSOptionalType' &&
            !(type === 'TSNamedTupleMember' && elementNode.optional)
          ) {
            this.raise(TSErrors.OptionalTypeBeforeRequired, elementNode);
          }
          seenOptionalElement ||
            (seenOptionalElement =
              (type === 'TSNamedTupleMember' && elementNode.optional) ||
              type === 'TSOptionalType');
        });
        return this.finishNode(node, 'TSTupleType');
      }
      tsParseTupleElementType() {
        const {startLoc: startLoc} = this.state;
        const rest = this.eat(21);
        let labeled;
        let label;
        let optional;
        let type;
        const isWord = tokenIsKeywordOrIdentifier(this.state.type);
        const chAfterWord = isWord ? this.lookaheadCharCode() : null;
        if (chAfterWord === 58) {
          labeled = true;
          optional = false;
          label = this.parseIdentifier(true);
          this.expect(14);
          type = this.tsParseType();
        } else if (chAfterWord === 63) {
          optional = true;
          const startLoc = this.state.startLoc;
          const wordName = this.state.value;
          const typeOrLabel = this.tsParseNonArrayType();
          if (this.lookaheadCharCode() === 58) {
            labeled = true;
            label = this.createIdentifier(this.startNodeAt(startLoc), wordName);
            this.expect(17);
            this.expect(14);
            type = this.tsParseType();
          } else {
            labeled = false;
            type = typeOrLabel;
            this.expect(17);
          }
        } else {
          type = this.tsParseType();
          optional = this.eat(17);
          labeled = this.eat(14);
        }
        if (labeled) {
          let labeledNode;
          if (label) {
            labeledNode = this.startNodeAtNode(label);
            labeledNode.optional = optional;
            labeledNode.label = label;
            labeledNode.elementType = type;
            if (this.eat(17)) {
              labeledNode.optional = true;
              this.raise(
                TSErrors.TupleOptionalAfterType,
                this.state.lastTokStartLoc
              );
            }
          } else {
            labeledNode = this.startNodeAtNode(type);
            labeledNode.optional = optional;
            this.raise(TSErrors.InvalidTupleMemberLabel, type);
            labeledNode.label = type;
            labeledNode.elementType = this.tsParseType();
          }
          type = this.finishNode(labeledNode, 'TSNamedTupleMember');
        } else if (optional) {
          const optionalTypeNode = this.startNodeAtNode(type);
          optionalTypeNode.typeAnnotation = type;
          type = this.finishNode(optionalTypeNode, 'TSOptionalType');
        }
        if (rest) {
          const restNode = this.startNodeAt(startLoc);
          restNode.typeAnnotation = type;
          type = this.finishNode(restNode, 'TSRestType');
        }
        return type;
      }
      tsParseParenthesizedType() {
        const node = this.startNode();
        this.expect(10);
        node.typeAnnotation = this.tsParseType();
        this.expect(11);
        return this.finishNode(node, 'TSParenthesizedType');
      }
      tsParseFunctionOrConstructorType(type, abstract) {
        const node = this.startNode();
        if (type === 'TSConstructorType') {
          node.abstract = !!abstract;
          if (abstract) this.next();
          this.next();
        }
        this.tsInAllowConditionalTypesContext(() =>
          this.tsFillSignature(19, node)
        );
        return this.finishNode(node, type);
      }
      tsParseLiteralTypeNode() {
        const node = this.startNode();
        switch (this.state.type) {
          case 135:
          case 136:
          case 134:
          case 85:
          case 86:
            node.literal = super.parseExprAtom();
            break;
          default:
            this.unexpected();
        }
        return this.finishNode(node, 'TSLiteralType');
      }
      tsParseTemplateLiteralType() {
        const node = this.startNode();
        node.literal = super.parseTemplate(false);
        return this.finishNode(node, 'TSLiteralType');
      }
      parseTemplateSubstitution() {
        if (this.state.inType) return this.tsParseType();
        return super.parseTemplateSubstitution();
      }
      tsParseThisTypeOrThisTypePredicate() {
        const thisKeyword = this.tsParseThisTypeNode();
        if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
          return this.tsParseThisTypePredicate(thisKeyword);
        } else {
          return thisKeyword;
        }
      }
      tsParseNonArrayType() {
        switch (this.state.type) {
          case 134:
          case 135:
          case 136:
          case 85:
          case 86:
            return this.tsParseLiteralTypeNode();
          case 53:
            if (this.state.value === '-') {
              const node = this.startNode();
              const nextToken = this.lookahead();
              if (nextToken.type !== 135 && nextToken.type !== 136) {
                this.unexpected();
              }
              node.literal = this.parseMaybeUnary();
              return this.finishNode(node, 'TSLiteralType');
            }
            break;
          case 78:
            return this.tsParseThisTypeOrThisTypePredicate();
          case 87:
            return this.tsParseTypeQuery();
          case 83:
            return this.tsParseImportType();
          case 5:
            return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this))
              ? this.tsParseMappedType()
              : this.tsParseTypeLiteral();
          case 0:
            return this.tsParseTupleType();
          case 10:
            return this.tsParseParenthesizedType();
          case 25:
          case 24:
            return this.tsParseTemplateLiteralType();
          default: {
            const {type: type} = this.state;
            if (tokenIsIdentifier(type) || type === 88 || type === 84) {
              const nodeType =
                type === 88
                  ? 'TSVoidKeyword'
                  : type === 84
                    ? 'TSNullKeyword'
                    : keywordTypeFromName(this.state.value);
              if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
                const node = this.startNode();
                this.next();
                return this.finishNode(node, nodeType);
              }
              return this.tsParseTypeReference();
            }
          }
        }
        this.unexpected();
      }
      tsParseArrayTypeOrHigher() {
        let type = this.tsParseNonArrayType();
        while (!this.hasPrecedingLineBreak() && this.eat(0)) {
          if (this.match(3)) {
            const node = this.startNodeAtNode(type);
            node.elementType = type;
            this.expect(3);
            type = this.finishNode(node, 'TSArrayType');
          } else {
            const node = this.startNodeAtNode(type);
            node.objectType = type;
            node.indexType = this.tsParseType();
            this.expect(3);
            type = this.finishNode(node, 'TSIndexedAccessType');
          }
        }
        return type;
      }
      tsParseTypeOperator() {
        const node = this.startNode();
        const operator = this.state.value;
        this.next();
        node.operator = operator;
        node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
        if (operator === 'readonly') {
          this.tsCheckTypeAnnotationForReadOnly(node);
        }
        return this.finishNode(node, 'TSTypeOperator');
      }
      tsCheckTypeAnnotationForReadOnly(node) {
        switch (node.typeAnnotation.type) {
          case 'TSTupleType':
          case 'TSArrayType':
            return;
          default:
            this.raise(TSErrors.UnexpectedReadonly, node);
        }
      }
      tsParseInferType() {
        const node = this.startNode();
        this.expectContextual(115);
        const typeParameter = this.startNode();
        typeParameter.name = this.tsParseTypeParameterName();
        typeParameter.constraint = this.tsTryParse(() =>
          this.tsParseConstraintForInferType()
        );
        node.typeParameter = this.finishNode(typeParameter, 'TSTypeParameter');
        return this.finishNode(node, 'TSInferType');
      }
      tsParseConstraintForInferType() {
        if (this.eat(81)) {
          const constraint = this.tsInDisallowConditionalTypesContext(() =>
            this.tsParseType()
          );
          if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
            return constraint;
          }
        }
      }
      tsParseTypeOperatorOrHigher() {
        const isTypeOperator =
          tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
        return isTypeOperator
          ? this.tsParseTypeOperator()
          : this.isContextual(115)
            ? this.tsParseInferType()
            : this.tsInAllowConditionalTypesContext(() =>
                this.tsParseArrayTypeOrHigher()
              );
      }
      tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
        const node = this.startNode();
        const hasLeadingOperator = this.eat(operator);
        const types = [];
        do {
          types.push(parseConstituentType());
        } while (this.eat(operator));
        if (types.length === 1 && !hasLeadingOperator) {
          return types[0];
        }
        node.types = types;
        return this.finishNode(node, kind);
      }
      tsParseIntersectionTypeOrHigher() {
        return this.tsParseUnionOrIntersectionType(
          'TSIntersectionType',
          this.tsParseTypeOperatorOrHigher.bind(this),
          45
        );
      }
      tsParseUnionTypeOrHigher() {
        return this.tsParseUnionOrIntersectionType(
          'TSUnionType',
          this.tsParseIntersectionTypeOrHigher.bind(this),
          43
        );
      }
      tsIsStartOfFunctionType() {
        if (this.match(47)) {
          return true;
        }
        return (
          this.match(10) &&
          this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this))
        );
      }
      tsSkipParameterStart() {
        if (tokenIsIdentifier(this.state.type) || this.match(78)) {
          this.next();
          return true;
        }
        if (this.match(5)) {
          const {errors: errors} = this.state;
          const previousErrorCount = errors.length;
          try {
            this.parseObjectLike(8, true);
            return errors.length === previousErrorCount;
          } catch (_unused) {
            return false;
          }
        }
        if (this.match(0)) {
          this.next();
          const {errors: errors} = this.state;
          const previousErrorCount = errors.length;
          try {
            super.parseBindingList(3, 93, 1);
            return errors.length === previousErrorCount;
          } catch (_unused2) {
            return false;
          }
        }
        return false;
      }
      tsIsUnambiguouslyStartOfFunctionType() {
        this.next();
        if (this.match(11) || this.match(21)) {
          return true;
        }
        if (this.tsSkipParameterStart()) {
          if (
            this.match(14) ||
            this.match(12) ||
            this.match(17) ||
            this.match(29)
          ) {
            return true;
          }
          if (this.match(11)) {
            this.next();
            if (this.match(19)) {
              return true;
            }
          }
        }
        return false;
      }
      tsParseTypeOrTypePredicateAnnotation(returnToken) {
        return this.tsInType(() => {
          const t = this.startNode();
          this.expect(returnToken);
          const node = this.startNode();
          const asserts = !!this.tsTryParse(
            this.tsParseTypePredicateAsserts.bind(this)
          );
          if (asserts && this.match(78)) {
            let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();
            if (thisTypePredicate.type === 'TSThisType') {
              node.parameterName = thisTypePredicate;
              node.asserts = true;
              node.typeAnnotation = null;
              thisTypePredicate = this.finishNode(node, 'TSTypePredicate');
            } else {
              this.resetStartLocationFromNode(thisTypePredicate, node);
              thisTypePredicate.asserts = true;
            }
            t.typeAnnotation = thisTypePredicate;
            return this.finishNode(t, 'TSTypeAnnotation');
          }
          const typePredicateVariable =
            this.tsIsIdentifier() &&
            this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
          if (!typePredicateVariable) {
            if (!asserts) {
              return this.tsParseTypeAnnotation(false, t);
            }
            node.parameterName = this.parseIdentifier();
            node.asserts = asserts;
            node.typeAnnotation = null;
            t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
            return this.finishNode(t, 'TSTypeAnnotation');
          }
          const type = this.tsParseTypeAnnotation(false);
          node.parameterName = typePredicateVariable;
          node.typeAnnotation = type;
          node.asserts = asserts;
          t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
          return this.finishNode(t, 'TSTypeAnnotation');
        });
      }
      tsTryParseTypeOrTypePredicateAnnotation() {
        if (this.match(14)) {
          return this.tsParseTypeOrTypePredicateAnnotation(14);
        }
      }
      tsTryParseTypeAnnotation() {
        if (this.match(14)) {
          return this.tsParseTypeAnnotation();
        }
      }
      tsTryParseType() {
        return this.tsEatThenParseType(14);
      }
      tsParseTypePredicatePrefix() {
        const id = this.parseIdentifier();
        if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
          this.next();
          return id;
        }
      }
      tsParseTypePredicateAsserts() {
        if (this.state.type !== 109) {
          return false;
        }
        const containsEsc = this.state.containsEsc;
        this.next();
        if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
          return false;
        }
        if (containsEsc) {
          this.raise(
            Errors.InvalidEscapedReservedWord,
            this.state.lastTokStartLoc,
            {reservedWord: 'asserts'}
          );
        }
        return true;
      }
      tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
        this.tsInType(() => {
          if (eatColon) this.expect(14);
          t.typeAnnotation = this.tsParseType();
        });
        return this.finishNode(t, 'TSTypeAnnotation');
      }
      tsParseType() {
        assert(this.state.inType);
        const type = this.tsParseNonConditionalType();
        if (
          this.state.inDisallowConditionalTypesContext ||
          this.hasPrecedingLineBreak() ||
          !this.eat(81)
        ) {
          return type;
        }
        const node = this.startNodeAtNode(type);
        node.checkType = type;
        node.extendsType = this.tsInDisallowConditionalTypesContext(() =>
          this.tsParseNonConditionalType()
        );
        this.expect(17);
        node.trueType = this.tsInAllowConditionalTypesContext(() =>
          this.tsParseType()
        );
        this.expect(14);
        node.falseType = this.tsInAllowConditionalTypesContext(() =>
          this.tsParseType()
        );
        return this.finishNode(node, 'TSConditionalType');
      }
      isAbstractConstructorSignature() {
        return this.isContextual(124) && this.lookahead().type === 77;
      }
      tsParseNonConditionalType() {
        if (this.tsIsStartOfFunctionType()) {
          return this.tsParseFunctionOrConstructorType('TSFunctionType');
        }
        if (this.match(77)) {
          return this.tsParseFunctionOrConstructorType('TSConstructorType');
        } else if (this.isAbstractConstructorSignature()) {
          return this.tsParseFunctionOrConstructorType(
            'TSConstructorType',
            true
          );
        }
        return this.tsParseUnionTypeOrHigher();
      }
      tsParseTypeAssertion() {
        if (this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')) {
          this.raise(TSErrors.ReservedTypeAssertion, this.state.startLoc);
        }
        const node = this.startNode();
        node.typeAnnotation = this.tsInType(() => {
          this.next();
          return this.match(75)
            ? this.tsParseTypeReference()
            : this.tsParseType();
        });
        this.expect(48);
        node.expression = this.parseMaybeUnary();
        return this.finishNode(node, 'TSTypeAssertion');
      }
      tsParseHeritageClause(token) {
        const originalStartLoc = this.state.startLoc;
        const delimitedList = this.tsParseDelimitedList(
          'HeritageClauseElement',
          () => {
            const node = this.startNode();
            node.expression = this.tsParseEntityName();
            if (this.match(47)) {
              node.typeParameters = this.tsParseTypeArguments();
            }
            return this.finishNode(node, 'TSExpressionWithTypeArguments');
          }
        );
        if (!delimitedList.length) {
          this.raise(TSErrors.EmptyHeritageClauseType, originalStartLoc, {
            token: token,
          });
        }
        return delimitedList;
      }
      tsParseInterfaceDeclaration(node, properties = {}) {
        if (this.hasFollowingLineBreak()) return null;
        this.expectContextual(129);
        if (properties.declare) node.declare = true;
        if (tokenIsIdentifier(this.state.type)) {
          node.id = this.parseIdentifier();
          this.checkIdentifier(node.id, 130);
        } else {
          node.id = null;
          this.raise(TSErrors.MissingInterfaceName, this.state.startLoc);
        }
        node.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutConstModifiers
        );
        if (this.eat(81)) {
          node.extends = this.tsParseHeritageClause('extends');
        }
        const body = this.startNode();
        body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
        node.body = this.finishNode(body, 'TSInterfaceBody');
        return this.finishNode(node, 'TSInterfaceDeclaration');
      }
      tsParseTypeAliasDeclaration(node) {
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, 2);
        node.typeAnnotation = this.tsInType(() => {
          node.typeParameters = this.tsTryParseTypeParameters(
            this.tsParseInOutModifiers
          );
          this.expect(29);
          if (this.isContextual(114) && this.lookahead().type !== 16) {
            const node = this.startNode();
            this.next();
            return this.finishNode(node, 'TSIntrinsicKeyword');
          }
          return this.tsParseType();
        });
        this.semicolon();
        return this.finishNode(node, 'TSTypeAliasDeclaration');
      }
      tsInNoContext(cb) {
        const oldContext = this.state.context;
        this.state.context = [oldContext[0]];
        try {
          return cb();
        } finally {
          this.state.context = oldContext;
        }
      }
      tsInType(cb) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        try {
          return cb();
        } finally {
          this.state.inType = oldInType;
        }
      }
      tsInDisallowConditionalTypesContext(cb) {
        const oldInDisallowConditionalTypesContext =
          this.state.inDisallowConditionalTypesContext;
        this.state.inDisallowConditionalTypesContext = true;
        try {
          return cb();
        } finally {
          this.state.inDisallowConditionalTypesContext =
            oldInDisallowConditionalTypesContext;
        }
      }
      tsInAllowConditionalTypesContext(cb) {
        const oldInDisallowConditionalTypesContext =
          this.state.inDisallowConditionalTypesContext;
        this.state.inDisallowConditionalTypesContext = false;
        try {
          return cb();
        } finally {
          this.state.inDisallowConditionalTypesContext =
            oldInDisallowConditionalTypesContext;
        }
      }
      tsEatThenParseType(token) {
        if (this.match(token)) {
          return this.tsNextThenParseType();
        }
      }
      tsExpectThenParseType(token) {
        return this.tsInType(() => {
          this.expect(token);
          return this.tsParseType();
        });
      }
      tsNextThenParseType() {
        return this.tsInType(() => {
          this.next();
          return this.tsParseType();
        });
      }
      tsParseEnumMember() {
        const node = this.startNode();
        node.id = this.match(134)
          ? super.parseStringLiteral(this.state.value)
          : this.parseIdentifier(true);
        if (this.eat(29)) {
          node.initializer = super.parseMaybeAssignAllowIn();
        }
        return this.finishNode(node, 'TSEnumMember');
      }
      tsParseEnumDeclaration(node, properties = {}) {
        if (properties.const) node.const = true;
        if (properties.declare) node.declare = true;
        this.expectContextual(126);
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, node.const ? 8971 : 8459);
        this.expect(5);
        node.members = this.tsParseDelimitedList(
          'EnumMembers',
          this.tsParseEnumMember.bind(this)
        );
        this.expect(8);
        return this.finishNode(node, 'TSEnumDeclaration');
      }
      tsParseModuleBlock() {
        const node = this.startNode();
        this.scope.enter(0);
        this.expect(5);
        super.parseBlockOrModuleBlockBody((node.body = []), undefined, true, 8);
        this.scope.exit();
        return this.finishNode(node, 'TSModuleBlock');
      }
      tsParseModuleOrNamespaceDeclaration(node, nested = false) {
        node.id = this.parseIdentifier();
        if (!nested) {
          this.checkIdentifier(node.id, 1024);
        }
        if (this.eat(16)) {
          const inner = this.startNode();
          this.tsParseModuleOrNamespaceDeclaration(inner, true);
          node.body = inner;
        } else {
          this.scope.enter(256);
          this.prodParam.enter(0);
          node.body = this.tsParseModuleBlock();
          this.prodParam.exit();
          this.scope.exit();
        }
        return this.finishNode(node, 'TSModuleDeclaration');
      }
      tsParseAmbientExternalModuleDeclaration(node) {
        if (this.isContextual(112)) {
          node.kind = 'global';
          node.global = true;
          node.id = this.parseIdentifier();
        } else if (this.match(134)) {
          node.kind = 'module';
          node.id = super.parseStringLiteral(this.state.value);
        } else {
          this.unexpected();
        }
        if (this.match(5)) {
          this.scope.enter(256);
          this.prodParam.enter(0);
          node.body = this.tsParseModuleBlock();
          this.prodParam.exit();
          this.scope.exit();
        } else {
          this.semicolon();
        }
        return this.finishNode(node, 'TSModuleDeclaration');
      }
      tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, isExport) {
        node.isExport = isExport || false;
        node.id = maybeDefaultIdentifier || this.parseIdentifier();
        this.checkIdentifier(node.id, 4096);
        this.expect(29);
        const moduleReference = this.tsParseModuleReference();
        if (
          node.importKind === 'type' &&
          moduleReference.type !== 'TSExternalModuleReference'
        ) {
          this.raise(TSErrors.ImportAliasHasImportType, moduleReference);
        }
        node.moduleReference = moduleReference;
        this.semicolon();
        return this.finishNode(node, 'TSImportEqualsDeclaration');
      }
      tsIsExternalModuleReference() {
        return this.isContextual(119) && this.lookaheadCharCode() === 40;
      }
      tsParseModuleReference() {
        return this.tsIsExternalModuleReference()
          ? this.tsParseExternalModuleReference()
          : this.tsParseEntityName(false);
      }
      tsParseExternalModuleReference() {
        const node = this.startNode();
        this.expectContextual(119);
        this.expect(10);
        if (!this.match(134)) {
          this.unexpected();
        }
        node.expression = super.parseExprAtom();
        this.expect(11);
        this.sawUnambiguousESM = true;
        return this.finishNode(node, 'TSExternalModuleReference');
      }
      tsLookAhead(f) {
        const state = this.state.clone();
        const res = f();
        this.state = state;
        return res;
      }
      tsTryParseAndCatch(f) {
        const result = this.tryParse(abort => f() || abort());
        if (result.aborted || !result.node) return;
        if (result.error) this.state = result.failState;
        return result.node;
      }
      tsTryParse(f) {
        const state = this.state.clone();
        const result = f();
        if (result !== undefined && result !== false) {
          return result;
        }
        this.state = state;
      }
      tsTryParseDeclare(nany) {
        if (this.isLineTerminator()) {
          return;
        }
        let startType = this.state.type;
        let kind;
        if (this.isContextual(100)) {
          startType = 74;
          kind = 'let';
        }
        return this.tsInAmbientContext(() => {
          switch (startType) {
            case 68:
              nany.declare = true;
              return super.parseFunctionStatement(nany, false, false);
            case 80:
              nany.declare = true;
              return this.parseClass(nany, true, false);
            case 126:
              return this.tsParseEnumDeclaration(nany, {declare: true});
            case 112:
              return this.tsParseAmbientExternalModuleDeclaration(nany);
            case 75:
            case 74:
              if (!this.match(75) || !this.isLookaheadContextual('enum')) {
                nany.declare = true;
                return this.parseVarStatement(
                  nany,
                  kind || this.state.value,
                  true
                );
              }
              this.expect(75);
              return this.tsParseEnumDeclaration(nany, {
                const: true,
                declare: true,
              });
            case 129: {
              const result = this.tsParseInterfaceDeclaration(nany, {
                declare: true,
              });
              if (result) return result;
            }
            default:
              if (tokenIsIdentifier(startType)) {
                return this.tsParseDeclaration(
                  nany,
                  this.state.value,
                  true,
                  null
                );
              }
          }
        });
      }
      tsTryParseExportDeclaration() {
        return this.tsParseDeclaration(
          this.startNode(),
          this.state.value,
          true,
          null
        );
      }
      tsParseExpressionStatement(node, expr, decorators) {
        switch (expr.name) {
          case 'declare': {
            const declaration = this.tsTryParseDeclare(node);
            if (declaration) {
              declaration.declare = true;
            }
            return declaration;
          }
          case 'global':
            if (this.match(5)) {
              this.scope.enter(256);
              this.prodParam.enter(0);
              const mod = node;
              mod.kind = 'global';
              mod.global = true;
              mod.id = expr;
              mod.body = this.tsParseModuleBlock();
              this.scope.exit();
              this.prodParam.exit();
              return this.finishNode(mod, 'TSModuleDeclaration');
            }
            break;
          default:
            return this.tsParseDeclaration(node, expr.name, false, decorators);
        }
      }
      tsParseDeclaration(node, value, next, decorators) {
        switch (value) {
          case 'abstract':
            if (
              this.tsCheckLineTerminator(next) &&
              (this.match(80) || tokenIsIdentifier(this.state.type))
            ) {
              return this.tsParseAbstractDeclaration(node, decorators);
            }
            break;
          case 'module':
            if (this.tsCheckLineTerminator(next)) {
              if (this.match(134)) {
                return this.tsParseAmbientExternalModuleDeclaration(node);
              } else if (tokenIsIdentifier(this.state.type)) {
                node.kind = 'module';
                return this.tsParseModuleOrNamespaceDeclaration(node);
              }
            }
            break;
          case 'namespace':
            if (
              this.tsCheckLineTerminator(next) &&
              tokenIsIdentifier(this.state.type)
            ) {
              node.kind = 'namespace';
              return this.tsParseModuleOrNamespaceDeclaration(node);
            }
            break;
          case 'type':
            if (
              this.tsCheckLineTerminator(next) &&
              tokenIsIdentifier(this.state.type)
            ) {
              return this.tsParseTypeAliasDeclaration(node);
            }
            break;
        }
      }
      tsCheckLineTerminator(next) {
        if (next) {
          if (this.hasFollowingLineBreak()) return false;
          this.next();
          return true;
        }
        return !this.isLineTerminator();
      }
      tsTryParseGenericAsyncArrowFunction(startLoc) {
        if (!this.match(47)) return;
        const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        this.state.maybeInArrowParameters = true;
        const res = this.tsTryParseAndCatch(() => {
          const node = this.startNodeAt(startLoc);
          node.typeParameters = this.tsParseTypeParameters(
            this.tsParseConstModifier
          );
          super.parseFunctionParams(node);
          node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
          this.expect(19);
          return node;
        });
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        if (!res) return;
        return super.parseArrowExpression(res, null, true);
      }
      tsParseTypeArgumentsInExpression() {
        if (this.reScan_lt() !== 47) return;
        return this.tsParseTypeArguments();
      }
      tsParseTypeArguments() {
        const node = this.startNode();
        node.params = this.tsInType(() =>
          this.tsInNoContext(() => {
            this.expect(47);
            return this.tsParseDelimitedList(
              'TypeParametersOrArguments',
              this.tsParseType.bind(this)
            );
          })
        );
        if (node.params.length === 0) {
          this.raise(TSErrors.EmptyTypeArguments, node);
        } else if (!this.state.inType && this.curContext() === types.brace) {
          this.reScan_lt_gt();
        }
        this.expect(48);
        return this.finishNode(node, 'TSTypeParameterInstantiation');
      }
      tsIsDeclarationStart() {
        return tokenIsTSDeclarationStart(this.state.type);
      }
      isExportDefaultSpecifier() {
        if (this.tsIsDeclarationStart()) return false;
        return super.isExportDefaultSpecifier();
      }
      parseAssignableListItem(flags, decorators) {
        const startLoc = this.state.startLoc;
        const modified = {};
        this.tsParseModifiers(
          {
            allowedModifiers: [
              'public',
              'private',
              'protected',
              'override',
              'readonly',
            ],
          },
          modified
        );
        const accessibility = modified.accessibility;
        const override = modified.override;
        const readonly = modified.readonly;
        if (!(flags & 4) && (accessibility || readonly || override)) {
          this.raise(TSErrors.UnexpectedParameterModifier, startLoc);
        }
        const left = this.parseMaybeDefault();
        if (flags & 2) {
          this.parseFunctionParamType(left);
        }
        const elt = this.parseMaybeDefault(left.loc.start, left);
        if (accessibility || readonly || override) {
          const pp = this.startNodeAt(startLoc);
          if (decorators.length) {
            pp.decorators = decorators;
          }
          if (accessibility) pp.accessibility = accessibility;
          if (readonly) pp.readonly = readonly;
          if (override) pp.override = override;
          if (elt.type !== 'Identifier' && elt.type !== 'AssignmentPattern') {
            this.raise(TSErrors.UnsupportedParameterPropertyKind, pp);
          }
          pp.parameter = elt;
          return this.finishNode(pp, 'TSParameterProperty');
        }
        if (decorators.length) {
          left.decorators = decorators;
        }
        return elt;
      }
      isSimpleParameter(node) {
        return (
          (node.type === 'TSParameterProperty' &&
            super.isSimpleParameter(node.parameter)) ||
          super.isSimpleParameter(node)
        );
      }
      tsDisallowOptionalPattern(node) {
        for (const param of node.params) {
          if (
            param.type !== 'Identifier' &&
            param.optional &&
            !this.state.isAmbientContext
          ) {
            this.raise(TSErrors.PatternIsOptional, param);
          }
        }
      }
      setArrowFunctionParameters(node, params, trailingCommaLoc) {
        super.setArrowFunctionParameters(node, params, trailingCommaLoc);
        this.tsDisallowOptionalPattern(node);
      }
      parseFunctionBodyAndFinish(node, type, isMethod = false) {
        if (this.match(14)) {
          node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
        }
        const bodilessType =
          type === 'FunctionDeclaration'
            ? 'TSDeclareFunction'
            : type === 'ClassMethod' || type === 'ClassPrivateMethod'
              ? 'TSDeclareMethod'
              : undefined;
        if (bodilessType && !this.match(5) && this.isLineTerminator()) {
          return this.finishNode(node, bodilessType);
        }
        if (
          bodilessType === 'TSDeclareFunction' &&
          this.state.isAmbientContext
        ) {
          this.raise(TSErrors.DeclareFunctionHasImplementation, node);
          if (node.declare) {
            return super.parseFunctionBodyAndFinish(
              node,
              bodilessType,
              isMethod
            );
          }
        }
        this.tsDisallowOptionalPattern(node);
        return super.parseFunctionBodyAndFinish(node, type, isMethod);
      }
      registerFunctionStatementId(node) {
        if (!node.body && node.id) {
          this.checkIdentifier(node.id, 1024);
        } else {
          super.registerFunctionStatementId(node);
        }
      }
      tsCheckForInvalidTypeCasts(items) {
        items.forEach(node => {
          if ((node == null ? void 0 : node.type) === 'TSTypeCastExpression') {
            this.raise(TSErrors.UnexpectedTypeAnnotation, node.typeAnnotation);
          }
        });
      }
      toReferencedList(exprList, isInParens) {
        this.tsCheckForInvalidTypeCasts(exprList);
        return exprList;
      }
      parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        const node = super.parseArrayLike(
          close,
          canBePattern,
          isTuple,
          refExpressionErrors
        );
        if (node.type === 'ArrayExpression') {
          this.tsCheckForInvalidTypeCasts(node.elements);
        }
        return node;
      }
      parseSubscript(base, startLoc, noCalls, state) {
        if (!this.hasPrecedingLineBreak() && this.match(35)) {
          this.state.canStartJSXElement = false;
          this.next();
          const nonNullExpression = this.startNodeAt(startLoc);
          nonNullExpression.expression = base;
          return this.finishNode(nonNullExpression, 'TSNonNullExpression');
        }
        let isOptionalCall = false;
        if (this.match(18) && this.lookaheadCharCode() === 60) {
          if (noCalls) {
            state.stop = true;
            return base;
          }
          state.optionalChainMember = isOptionalCall = true;
          this.next();
        }
        if (this.match(47) || this.match(51)) {
          let missingParenErrorLoc;
          const result = this.tsTryParseAndCatch(() => {
            if (!noCalls && this.atPossibleAsyncArrow(base)) {
              const asyncArrowFn =
                this.tsTryParseGenericAsyncArrowFunction(startLoc);
              if (asyncArrowFn) {
                return asyncArrowFn;
              }
            }
            const typeArguments = this.tsParseTypeArgumentsInExpression();
            if (!typeArguments) return;
            if (isOptionalCall && !this.match(10)) {
              missingParenErrorLoc = this.state.curPosition();
              return;
            }
            if (tokenIsTemplate(this.state.type)) {
              const result = super.parseTaggedTemplateExpression(
                base,
                startLoc,
                state
              );
              result.typeParameters = typeArguments;
              return result;
            }
            if (!noCalls && this.eat(10)) {
              const node = this.startNodeAt(startLoc);
              node.callee = base;
              node.arguments = this.parseCallExpressionArguments(11);
              this.tsCheckForInvalidTypeCasts(node.arguments);
              node.typeParameters = typeArguments;
              if (state.optionalChainMember) {
                node.optional = isOptionalCall;
              }
              return this.finishCallExpression(node, state.optionalChainMember);
            }
            const tokenType = this.state.type;
            if (
              tokenType === 48 ||
              tokenType === 52 ||
              (tokenType !== 10 &&
                tokenCanStartExpression(tokenType) &&
                !this.hasPrecedingLineBreak())
            ) {
              return;
            }
            const node = this.startNodeAt(startLoc);
            node.expression = base;
            node.typeParameters = typeArguments;
            return this.finishNode(node, 'TSInstantiationExpression');
          });
          if (missingParenErrorLoc) {
            this.unexpected(missingParenErrorLoc, 10);
          }
          if (result) {
            if (
              result.type === 'TSInstantiationExpression' &&
              (this.match(16) ||
                (this.match(18) && this.lookaheadCharCode() !== 40))
            ) {
              this.raise(
                TSErrors.InvalidPropertyAccessAfterInstantiationExpression,
                this.state.startLoc
              );
            }
            return result;
          }
        }
        return super.parseSubscript(base, startLoc, noCalls, state);
      }
      parseNewCallee(node) {
        var _callee$extra;
        super.parseNewCallee(node);
        const {callee: callee} = node;
        if (
          callee.type === 'TSInstantiationExpression' &&
          !(
            (_callee$extra = callee.extra) != null &&
            _callee$extra.parenthesized
          )
        ) {
          node.typeParameters = callee.typeParameters;
          node.callee = callee.expression;
        }
      }
      parseExprOp(left, leftStartLoc, minPrec) {
        let isSatisfies;
        if (
          tokenOperatorPrecedence(58) > minPrec &&
          !this.hasPrecedingLineBreak() &&
          (this.isContextual(93) || (isSatisfies = this.isContextual(120)))
        ) {
          const node = this.startNodeAt(leftStartLoc);
          node.expression = left;
          node.typeAnnotation = this.tsInType(() => {
            this.next();
            if (this.match(75)) {
              if (isSatisfies) {
                this.raise(Errors.UnexpectedKeyword, this.state.startLoc, {
                  keyword: 'const',
                });
              }
              return this.tsParseTypeReference();
            }
            return this.tsParseType();
          });
          this.finishNode(
            node,
            isSatisfies ? 'TSSatisfiesExpression' : 'TSAsExpression'
          );
          this.reScan_lt_gt();
          return this.parseExprOp(node, leftStartLoc, minPrec);
        }
        return super.parseExprOp(left, leftStartLoc, minPrec);
      }
      checkReservedWord(word, startLoc, checkKeywords, isBinding) {
        if (!this.state.isAmbientContext) {
          super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
        }
      }
      checkImportReflection(node) {
        super.checkImportReflection(node);
        if (node.module && node.importKind !== 'value') {
          this.raise(
            TSErrors.ImportReflectionHasImportType,
            node.specifiers[0].loc.start
          );
        }
      }
      checkDuplicateExports() {}
      isPotentialImportPhase(isExport) {
        if (super.isPotentialImportPhase(isExport)) return true;
        if (this.isContextual(130)) {
          const ch = this.lookaheadCharCode();
          return isExport ? ch === 123 || ch === 42 : ch !== 61;
        }
        return !isExport && this.isContextual(87);
      }
      applyImportPhase(node, isExport, phase, loc) {
        super.applyImportPhase(node, isExport, phase, loc);
        if (isExport) {
          node.exportKind = phase === 'type' ? 'type' : 'value';
        } else {
          node.importKind =
            phase === 'type' || phase === 'typeof' ? phase : 'value';
        }
      }
      parseImport(node) {
        if (this.match(134)) {
          node.importKind = 'value';
          return super.parseImport(node);
        }
        let importNode;
        if (
          tokenIsIdentifier(this.state.type) &&
          this.lookaheadCharCode() === 61
        ) {
          node.importKind = 'value';
          return this.tsParseImportEqualsDeclaration(node);
        } else if (this.isContextual(130)) {
          const maybeDefaultIdentifier = this.parseMaybeImportPhase(
            node,
            false
          );
          if (this.lookaheadCharCode() === 61) {
            return this.tsParseImportEqualsDeclaration(
              node,
              maybeDefaultIdentifier
            );
          } else {
            importNode = super.parseImportSpecifiersAndAfter(
              node,
              maybeDefaultIdentifier
            );
          }
        } else {
          importNode = super.parseImport(node);
        }
        if (
          importNode.importKind === 'type' &&
          importNode.specifiers.length > 1 &&
          importNode.specifiers[0].type === 'ImportDefaultSpecifier'
        ) {
          this.raise(
            TSErrors.TypeImportCannotSpecifyDefaultAndNamed,
            importNode
          );
        }
        return importNode;
      }
      parseExport(node, decorators) {
        if (this.match(83)) {
          this.next();
          const nodeImportEquals = node;
          let maybeDefaultIdentifier = null;
          if (this.isContextual(130) && this.isPotentialImportPhase(false)) {
            maybeDefaultIdentifier = this.parseMaybeImportPhase(
              nodeImportEquals,
              false
            );
          } else {
            nodeImportEquals.importKind = 'value';
          }
          return this.tsParseImportEqualsDeclaration(
            nodeImportEquals,
            maybeDefaultIdentifier,
            true
          );
        } else if (this.eat(29)) {
          const assign = node;
          assign.expression = super.parseExpression();
          this.semicolon();
          this.sawUnambiguousESM = true;
          return this.finishNode(assign, 'TSExportAssignment');
        } else if (this.eatContextual(93)) {
          const decl = node;
          this.expectContextual(128);
          decl.id = this.parseIdentifier();
          this.semicolon();
          return this.finishNode(decl, 'TSNamespaceExportDeclaration');
        } else {
          return super.parseExport(node, decorators);
        }
      }
      isAbstractClass() {
        return this.isContextual(124) && this.lookahead().type === 80;
      }
      parseExportDefaultExpression() {
        if (this.isAbstractClass()) {
          const cls = this.startNode();
          this.next();
          cls.abstract = true;
          return this.parseClass(cls, true, true);
        }
        if (this.match(129)) {
          const result = this.tsParseInterfaceDeclaration(this.startNode());
          if (result) return result;
        }
        return super.parseExportDefaultExpression();
      }
      parseVarStatement(node, kind, allowMissingInitializer = false) {
        const {isAmbientContext: isAmbientContext} = this.state;
        const declaration = super.parseVarStatement(
          node,
          kind,
          allowMissingInitializer || isAmbientContext
        );
        if (!isAmbientContext) return declaration;
        for (const {id: id, init: init} of declaration.declarations) {
          if (!init) continue;
          if (kind !== 'const' || !!id.typeAnnotation) {
            this.raise(TSErrors.InitializerNotAllowedInAmbientContext, init);
          } else if (
            !isValidAmbientConstInitializer(init, this.hasPlugin('estree'))
          ) {
            this.raise(
              TSErrors.ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference,
              init
            );
          }
        }
        return declaration;
      }
      parseStatementContent(flags, decorators) {
        if (this.match(75) && this.isLookaheadContextual('enum')) {
          const node = this.startNode();
          this.expect(75);
          return this.tsParseEnumDeclaration(node, {const: true});
        }
        if (this.isContextual(126)) {
          return this.tsParseEnumDeclaration(this.startNode());
        }
        if (this.isContextual(129)) {
          const result = this.tsParseInterfaceDeclaration(this.startNode());
          if (result) return result;
        }
        return super.parseStatementContent(flags, decorators);
      }
      parseAccessModifier() {
        return this.tsParseModifier(['public', 'protected', 'private']);
      }
      tsHasSomeModifiers(member, modifiers) {
        return modifiers.some(modifier => {
          if (tsIsAccessModifier(modifier)) {
            return member.accessibility === modifier;
          }
          return !!member[modifier];
        });
      }
      tsIsStartOfStaticBlocks() {
        return this.isContextual(106) && this.lookaheadCharCode() === 123;
      }
      parseClassMember(classBody, member, state) {
        const modifiers = [
          'declare',
          'private',
          'public',
          'protected',
          'override',
          'abstract',
          'readonly',
          'static',
        ];
        this.tsParseModifiers(
          {
            allowedModifiers: modifiers,
            disallowedModifiers: ['in', 'out'],
            stopOnStartOfClassStaticBlock: true,
            errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
          },
          member
        );
        const callParseClassMemberWithIsStatic = () => {
          if (this.tsIsStartOfStaticBlocks()) {
            this.next();
            this.next();
            if (this.tsHasSomeModifiers(member, modifiers)) {
              this.raise(
                TSErrors.StaticBlockCannotHaveModifier,
                this.state.curPosition()
              );
            }
            super.parseClassStaticBlock(classBody, member);
          } else {
            this.parseClassMemberWithIsStatic(
              classBody,
              member,
              state,
              !!member.static
            );
          }
        };
        if (member.declare) {
          this.tsInAmbientContext(callParseClassMemberWithIsStatic);
        } else {
          callParseClassMemberWithIsStatic();
        }
      }
      parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
        const idx = this.tsTryParseIndexSignature(member);
        if (idx) {
          classBody.body.push(idx);
          if (member.abstract) {
            this.raise(TSErrors.IndexSignatureHasAbstract, member);
          }
          if (member.accessibility) {
            this.raise(TSErrors.IndexSignatureHasAccessibility, member, {
              modifier: member.accessibility,
            });
          }
          if (member.declare) {
            this.raise(TSErrors.IndexSignatureHasDeclare, member);
          }
          if (member.override) {
            this.raise(TSErrors.IndexSignatureHasOverride, member);
          }
          return;
        }
        if (!this.state.inAbstractClass && member.abstract) {
          this.raise(TSErrors.NonAbstractClassHasAbstractMethod, member);
        }
        if (member.override) {
          if (!state.hadSuperClass) {
            this.raise(TSErrors.OverrideNotInSubClass, member);
          }
        }
        super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
      }
      parsePostMemberNameModifiers(methodOrProp) {
        const optional = this.eat(17);
        if (optional) methodOrProp.optional = true;
        if (methodOrProp.readonly && this.match(10)) {
          this.raise(TSErrors.ClassMethodHasReadonly, methodOrProp);
        }
        if (methodOrProp.declare && this.match(10)) {
          this.raise(TSErrors.ClassMethodHasDeclare, methodOrProp);
        }
      }
      parseExpressionStatement(node, expr, decorators) {
        const decl =
          expr.type === 'Identifier'
            ? this.tsParseExpressionStatement(node, expr, decorators)
            : undefined;
        return decl || super.parseExpressionStatement(node, expr, decorators);
      }
      shouldParseExportDeclaration() {
        if (this.tsIsDeclarationStart()) return true;
        return super.shouldParseExportDeclaration();
      }
      parseConditional(expr, startLoc, refExpressionErrors) {
        if (!this.state.maybeInArrowParameters || !this.match(17)) {
          return super.parseConditional(expr, startLoc, refExpressionErrors);
        }
        const result = this.tryParse(() =>
          super.parseConditional(expr, startLoc)
        );
        if (!result.node) {
          if (result.error) {
            super.setOptionalParametersError(refExpressionErrors, result.error);
          }
          return expr;
        }
        if (result.error) this.state = result.failState;
        return result.node;
      }
      parseParenItem(node, startLoc) {
        const newNode = super.parseParenItem(node, startLoc);
        if (this.eat(17)) {
          newNode.optional = true;
          this.resetEndLocation(node);
        }
        if (this.match(14)) {
          const typeCastNode = this.startNodeAt(startLoc);
          typeCastNode.expression = node;
          typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
          return this.finishNode(typeCastNode, 'TSTypeCastExpression');
        }
        return node;
      }
      parseExportDeclaration(node) {
        if (!this.state.isAmbientContext && this.isContextual(125)) {
          return this.tsInAmbientContext(() =>
            this.parseExportDeclaration(node)
          );
        }
        const startLoc = this.state.startLoc;
        const isDeclare = this.eatContextual(125);
        if (
          isDeclare &&
          (this.isContextual(125) || !this.shouldParseExportDeclaration())
        ) {
          throw this.raise(
            TSErrors.ExpectedAmbientAfterExportDeclare,
            this.state.startLoc
          );
        }
        const isIdentifier = tokenIsIdentifier(this.state.type);
        const declaration =
          (isIdentifier && this.tsTryParseExportDeclaration()) ||
          super.parseExportDeclaration(node);
        if (!declaration) return null;
        if (
          declaration.type === 'TSInterfaceDeclaration' ||
          declaration.type === 'TSTypeAliasDeclaration' ||
          isDeclare
        ) {
          node.exportKind = 'type';
        }
        if (isDeclare) {
          this.resetStartLocation(declaration, startLoc);
          declaration.declare = true;
        }
        return declaration;
      }
      parseClassId(node, isStatement, optionalId, bindingType) {
        if ((!isStatement || optionalId) && this.isContextual(113)) {
          return;
        }
        super.parseClassId(
          node,
          isStatement,
          optionalId,
          node.declare ? 1024 : 8331
        );
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutConstModifiers
        );
        if (typeParameters) node.typeParameters = typeParameters;
      }
      parseClassPropertyAnnotation(node) {
        if (!node.optional) {
          if (this.eat(35)) {
            node.definite = true;
          } else if (this.eat(17)) {
            node.optional = true;
          }
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) node.typeAnnotation = type;
      }
      parseClassProperty(node) {
        this.parseClassPropertyAnnotation(node);
        if (
          this.state.isAmbientContext &&
          !(node.readonly && !node.typeAnnotation) &&
          this.match(29)
        ) {
          this.raise(
            TSErrors.DeclareClassFieldHasInitializer,
            this.state.startLoc
          );
        }
        if (node.abstract && this.match(29)) {
          const {key: key} = node;
          this.raise(
            TSErrors.AbstractPropertyHasInitializer,
            this.state.startLoc,
            {
              propertyName:
                key.type === 'Identifier' && !node.computed
                  ? key.name
                  : `[${this.input.slice(this.offsetToSourcePos(key.start), this.offsetToSourcePos(key.end))}]`,
            }
          );
        }
        return super.parseClassProperty(node);
      }
      parseClassPrivateProperty(node) {
        if (node.abstract) {
          this.raise(TSErrors.PrivateElementHasAbstract, node);
        }
        if (node.accessibility) {
          this.raise(TSErrors.PrivateElementHasAccessibility, node, {
            modifier: node.accessibility,
          });
        }
        this.parseClassPropertyAnnotation(node);
        return super.parseClassPrivateProperty(node);
      }
      parseClassAccessorProperty(node) {
        this.parseClassPropertyAnnotation(node);
        if (node.optional) {
          this.raise(TSErrors.AccessorCannotBeOptional, node);
        }
        return super.parseClassAccessorProperty(node);
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters && isConstructor) {
          this.raise(TSErrors.ConstructorHasTypeParameters, typeParameters);
        }
        const {declare: declare = false, kind: kind} = method;
        if (declare && (kind === 'get' || kind === 'set')) {
          this.raise(TSErrors.DeclareAccessor, method, {kind: kind});
        }
        if (typeParameters) method.typeParameters = typeParameters;
        super.pushClassMethod(
          classBody,
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper
        );
      }
      pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) method.typeParameters = typeParameters;
        super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
      }
      declareClassPrivateMethodInScope(node, kind) {
        if (node.type === 'TSDeclareMethod') return;
        if (
          node.type === 'MethodDefinition' &&
          !hasOwnProperty.call(node.value, 'body')
        ) {
          return;
        }
        super.declareClassPrivateMethodInScope(node, kind);
      }
      parseClassSuper(node) {
        super.parseClassSuper(node);
        if (node.superClass && (this.match(47) || this.match(51))) {
          node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
        }
        if (this.eatContextual(113)) {
          node.implements = this.tsParseHeritageClause('implements');
        }
      }
      parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      ) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) prop.typeParameters = typeParameters;
        return super.parseObjPropValue(
          prop,
          startLoc,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor,
          refExpressionErrors
        );
      }
      parseFunctionParams(node, isConstructor) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) node.typeParameters = typeParameters;
        super.parseFunctionParams(node, isConstructor);
      }
      parseVarId(decl, kind) {
        super.parseVarId(decl, kind);
        if (
          decl.id.type === 'Identifier' &&
          !this.hasPrecedingLineBreak() &&
          this.eat(35)
        ) {
          decl.definite = true;
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) {
          decl.id.typeAnnotation = type;
          this.resetEndLocation(decl.id);
        }
      }
      parseAsyncArrowFromCallExpression(node, call) {
        if (this.match(14)) {
          node.returnType = this.tsParseTypeAnnotation();
        }
        return super.parseAsyncArrowFromCallExpression(node, call);
      }
      parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var _jsx, _jsx2, _typeCast, _jsx3, _typeCast2;
        let state;
        let jsx;
        let typeCast;
        if (this.hasPlugin('jsx') && (this.match(143) || this.match(47))) {
          state = this.state.clone();
          jsx = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!jsx.error) return jsx.node;
          const {context: context} = this.state;
          const currentContext = context[context.length - 1];
          if (
            currentContext === types.j_oTag ||
            currentContext === types.j_expr
          ) {
            context.pop();
          }
        }
        if (!((_jsx = jsx) != null && _jsx.error) && !this.match(47)) {
          return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
        }
        if (!state || state === this.state) state = this.state.clone();
        let typeParameters;
        const arrow = this.tryParse(abort => {
          var _expr$extra, _typeParameters;
          typeParameters = this.tsParseTypeParameters(
            this.tsParseConstModifier
          );
          const expr = super.parseMaybeAssign(
            refExpressionErrors,
            afterLeftParse
          );
          if (
            expr.type !== 'ArrowFunctionExpression' ||
            ((_expr$extra = expr.extra) != null && _expr$extra.parenthesized)
          ) {
            abort();
          }
          if (
            ((_typeParameters = typeParameters) == null
              ? void 0
              : _typeParameters.params.length) !== 0
          ) {
            this.resetStartLocationFromNode(expr, typeParameters);
          }
          expr.typeParameters = typeParameters;
          return expr;
        }, state);
        if (!arrow.error && !arrow.aborted) {
          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
          return arrow.node;
        }
        if (!jsx) {
          assert(!this.hasPlugin('jsx'));
          typeCast = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!typeCast.error) return typeCast.node;
        }
        if ((_jsx2 = jsx) != null && _jsx2.node) {
          this.state = jsx.failState;
          return jsx.node;
        }
        if (arrow.node) {
          this.state = arrow.failState;
          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
          return arrow.node;
        }
        if ((_typeCast = typeCast) != null && _typeCast.node) {
          this.state = typeCast.failState;
          return typeCast.node;
        }
        throw (
          ((_jsx3 = jsx) == null ? void 0 : _jsx3.error) ||
          arrow.error ||
          ((_typeCast2 = typeCast) == null ? void 0 : _typeCast2.error)
        );
      }
      reportReservedArrowTypeParam(node) {
        var _node$extra;
        if (
          node.params.length === 1 &&
          !node.params[0].constraint &&
          !((_node$extra = node.extra) != null && _node$extra.trailingComma) &&
          this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')
        ) {
          this.raise(TSErrors.ReservedArrowTypeParam, node);
        }
      }
      parseMaybeUnary(refExpressionErrors, sawUnary) {
        if (!this.hasPlugin('jsx') && this.match(47)) {
          return this.tsParseTypeAssertion();
        }
        return super.parseMaybeUnary(refExpressionErrors, sawUnary);
      }
      parseArrow(node) {
        if (this.match(14)) {
          const result = this.tryParse(abort => {
            const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
            if (this.canInsertSemicolon() || !this.match(19)) abort();
            return returnType;
          });
          if (result.aborted) return;
          if (!result.thrown) {
            if (result.error) this.state = result.failState;
            node.returnType = result.node;
          }
        }
        return super.parseArrow(node);
      }
      parseFunctionParamType(param) {
        if (this.eat(17)) {
          param.optional = true;
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) param.typeAnnotation = type;
        this.resetEndLocation(param);
        return param;
      }
      isAssignable(node, isBinding) {
        switch (node.type) {
          case 'TSTypeCastExpression':
            return this.isAssignable(node.expression, isBinding);
          case 'TSParameterProperty':
            return true;
          default:
            return super.isAssignable(node, isBinding);
        }
      }
      toAssignable(node, isLHS = false) {
        switch (node.type) {
          case 'ParenthesizedExpression':
            this.toAssignableParenthesizedExpression(node, isLHS);
            break;
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSNonNullExpression':
          case 'TSTypeAssertion':
            if (isLHS) {
              this.expressionScope.recordArrowParameterBindingError(
                TSErrors.UnexpectedTypeCastInParameter,
                node
              );
            } else {
              this.raise(TSErrors.UnexpectedTypeCastInParameter, node);
            }
            this.toAssignable(node.expression, isLHS);
            break;
          case 'AssignmentExpression':
            if (!isLHS && node.left.type === 'TSTypeCastExpression') {
              node.left = this.typeCastToParameter(node.left);
            }
          default:
            super.toAssignable(node, isLHS);
        }
      }
      toAssignableParenthesizedExpression(node, isLHS) {
        switch (node.expression.type) {
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSNonNullExpression':
          case 'TSTypeAssertion':
          case 'ParenthesizedExpression':
            this.toAssignable(node.expression, isLHS);
            break;
          default:
            super.toAssignable(node, isLHS);
        }
      }
      checkToRestConversion(node, allowPattern) {
        switch (node.type) {
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSTypeAssertion':
          case 'TSNonNullExpression':
            this.checkToRestConversion(node.expression, false);
            break;
          default:
            super.checkToRestConversion(node, allowPattern);
        }
      }
      isValidLVal(type, isUnparenthesizedInAssign, binding) {
        switch (type) {
          case 'TSTypeCastExpression':
            return true;
          case 'TSParameterProperty':
            return 'parameter';
          case 'TSNonNullExpression':
          case 'TSInstantiationExpression':
            return 'expression';
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSTypeAssertion':
            return (
              (binding !== 64 || !isUnparenthesizedInAssign) && [
                'expression',
                true,
              ]
            );
          default:
            return super.isValidLVal(type, isUnparenthesizedInAssign, binding);
        }
      }
      parseBindingAtom() {
        if (this.state.type === 78) {
          return this.parseIdentifier(true);
        }
        return super.parseBindingAtom();
      }
      parseMaybeDecoratorArguments(expr) {
        if (this.match(47) || this.match(51)) {
          const typeArguments = this.tsParseTypeArgumentsInExpression();
          if (this.match(10)) {
            const call = super.parseMaybeDecoratorArguments(expr);
            call.typeParameters = typeArguments;
            return call;
          }
          this.unexpected(null, 10);
        }
        return super.parseMaybeDecoratorArguments(expr);
      }
      checkCommaAfterRest(close) {
        if (
          this.state.isAmbientContext &&
          this.match(12) &&
          this.lookaheadCharCode() === close
        ) {
          this.next();
          return false;
        }
        return super.checkCommaAfterRest(close);
      }
      isClassMethod() {
        return this.match(47) || super.isClassMethod();
      }
      isClassProperty() {
        return this.match(35) || this.match(14) || super.isClassProperty();
      }
      parseMaybeDefault(startLoc, left) {
        const node = super.parseMaybeDefault(startLoc, left);
        if (
          node.type === 'AssignmentPattern' &&
          node.typeAnnotation &&
          node.right.start < node.typeAnnotation.start
        ) {
          this.raise(TSErrors.TypeAnnotationAfterAssign, node.typeAnnotation);
        }
        return node;
      }
      getTokenFromCode(code) {
        if (this.state.inType) {
          if (code === 62) {
            this.finishOp(48, 1);
            return;
          }
          if (code === 60) {
            this.finishOp(47, 1);
            return;
          }
        }
        super.getTokenFromCode(code);
      }
      reScan_lt_gt() {
        const {type: type} = this.state;
        if (type === 47) {
          this.state.pos -= 1;
          this.readToken_lt();
        } else if (type === 48) {
          this.state.pos -= 1;
          this.readToken_gt();
        }
      }
      reScan_lt() {
        const {type: type} = this.state;
        if (type === 51) {
          this.state.pos -= 2;
          this.finishOp(47, 1);
          return 47;
        }
        return type;
      }
      toAssignableList(exprList, trailingCommaLoc, isLHS) {
        for (let i = 0; i < exprList.length; i++) {
          const expr = exprList[i];
          if ((expr == null ? void 0 : expr.type) === 'TSTypeCastExpression') {
            exprList[i] = this.typeCastToParameter(expr);
          }
        }
        super.toAssignableList(exprList, trailingCommaLoc, isLHS);
      }
      typeCastToParameter(node) {
        node.expression.typeAnnotation = node.typeAnnotation;
        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
        return node.expression;
      }
      shouldParseArrow(params) {
        if (this.match(14)) {
          return params.every(expr => this.isAssignable(expr, true));
        }
        return super.shouldParseArrow(params);
      }
      shouldParseAsyncArrow() {
        return this.match(14) || super.shouldParseAsyncArrow();
      }
      canHaveLeadingDecorator() {
        return super.canHaveLeadingDecorator() || this.isAbstractClass();
      }
      jsxParseOpeningElementAfterName(node) {
        if (this.match(47) || this.match(51)) {
          const typeArguments = this.tsTryParseAndCatch(() =>
            this.tsParseTypeArgumentsInExpression()
          );
          if (typeArguments) node.typeParameters = typeArguments;
        }
        return super.jsxParseOpeningElementAfterName(node);
      }
      getGetterSetterExpectedParamCount(method) {
        const baseCount = super.getGetterSetterExpectedParamCount(method);
        const params = this.getObjectOrClassMethodParams(method);
        const firstParam = params[0];
        const hasContextParam = firstParam && this.isThisParam(firstParam);
        return hasContextParam ? baseCount + 1 : baseCount;
      }
      parseCatchClauseParam() {
        const param = super.parseCatchClauseParam();
        const type = this.tsTryParseTypeAnnotation();
        if (type) {
          param.typeAnnotation = type;
          this.resetEndLocation(param);
        }
        return param;
      }
      tsInAmbientContext(cb) {
        const {isAmbientContext: oldIsAmbientContext, strict: oldStrict} =
          this.state;
        this.state.isAmbientContext = true;
        this.state.strict = false;
        try {
          return cb();
        } finally {
          this.state.isAmbientContext = oldIsAmbientContext;
          this.state.strict = oldStrict;
        }
      }
      parseClass(node, isStatement, optionalId) {
        const oldInAbstractClass = this.state.inAbstractClass;
        this.state.inAbstractClass = !!node.abstract;
        try {
          return super.parseClass(node, isStatement, optionalId);
        } finally {
          this.state.inAbstractClass = oldInAbstractClass;
        }
      }
      tsParseAbstractDeclaration(node, decorators) {
        if (this.match(80)) {
          node.abstract = true;
          return this.maybeTakeDecorators(
            decorators,
            this.parseClass(node, true, false)
          );
        } else if (this.isContextual(129)) {
          if (!this.hasFollowingLineBreak()) {
            node.abstract = true;
            this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, node);
            return this.tsParseInterfaceDeclaration(node);
          }
        } else {
          this.unexpected(null, 80);
        }
      }
      parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope
      ) {
        const method = super.parseMethod(
          node,
          isGenerator,
          isAsync,
          isConstructor,
          allowDirectSuper,
          type,
          inClassScope
        );
        if (method.abstract) {
          const hasBody = this.hasPlugin('estree')
            ? !!method.value.body
            : !!method.body;
          if (hasBody) {
            const {key: key} = method;
            this.raise(TSErrors.AbstractMethodHasImplementation, method, {
              methodName:
                key.type === 'Identifier' && !method.computed
                  ? key.name
                  : `[${this.input.slice(this.offsetToSourcePos(key.start), this.offsetToSourcePos(key.end))}]`,
            });
          }
        }
        return method;
      }
      tsParseTypeParameterName() {
        const typeName = this.parseIdentifier();
        return typeName.name;
      }
      shouldParseAsAmbientContext() {
        return !!this.getPluginOption('typescript', 'dts');
      }
      parse() {
        if (this.shouldParseAsAmbientContext()) {
          this.state.isAmbientContext = true;
        }
        return super.parse();
      }
      getExpression() {
        if (this.shouldParseAsAmbientContext()) {
          this.state.isAmbientContext = true;
        }
        return super.getExpression();
      }
      parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
        if (!isString && isMaybeTypeOnly) {
          this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
          return this.finishNode(node, 'ExportSpecifier');
        }
        node.exportKind = 'value';
        return super.parseExportSpecifier(
          node,
          isString,
          isInTypeExport,
          isMaybeTypeOnly
        );
      }
      parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        bindingType
      ) {
        if (!importedIsString && isMaybeTypeOnly) {
          this.parseTypeOnlyImportExportSpecifier(
            specifier,
            true,
            isInTypeOnlyImport
          );
          return this.finishNode(specifier, 'ImportSpecifier');
        }
        specifier.importKind = 'value';
        return super.parseImportSpecifier(
          specifier,
          importedIsString,
          isInTypeOnlyImport,
          isMaybeTypeOnly,
          isInTypeOnlyImport ? 4098 : 4096
        );
      }
      parseTypeOnlyImportExportSpecifier(
        node,
        isImport,
        isInTypeOnlyImportExport
      ) {
        const leftOfAsKey = isImport ? 'imported' : 'local';
        const rightOfAsKey = isImport ? 'local' : 'exported';
        let leftOfAs = node[leftOfAsKey];
        let rightOfAs;
        let hasTypeSpecifier = false;
        let canParseAsKeyword = true;
        const loc = leftOfAs.loc.start;
        if (this.isContextual(93)) {
          const firstAs = this.parseIdentifier();
          if (this.isContextual(93)) {
            const secondAs = this.parseIdentifier();
            if (tokenIsKeywordOrIdentifier(this.state.type)) {
              hasTypeSpecifier = true;
              leftOfAs = firstAs;
              rightOfAs = isImport
                ? this.parseIdentifier()
                : this.parseModuleExportName();
              canParseAsKeyword = false;
            } else {
              rightOfAs = secondAs;
              canParseAsKeyword = false;
            }
          } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
            canParseAsKeyword = false;
            rightOfAs = isImport
              ? this.parseIdentifier()
              : this.parseModuleExportName();
          } else {
            hasTypeSpecifier = true;
            leftOfAs = firstAs;
          }
        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
          hasTypeSpecifier = true;
          if (isImport) {
            leftOfAs = this.parseIdentifier(true);
            if (!this.isContextual(93)) {
              this.checkReservedWord(
                leftOfAs.name,
                leftOfAs.loc.start,
                true,
                true
              );
            }
          } else {
            leftOfAs = this.parseModuleExportName();
          }
        }
        if (hasTypeSpecifier && isInTypeOnlyImportExport) {
          this.raise(
            isImport
              ? TSErrors.TypeModifierIsUsedInTypeImports
              : TSErrors.TypeModifierIsUsedInTypeExports,
            loc
          );
        }
        node[leftOfAsKey] = leftOfAs;
        node[rightOfAsKey] = rightOfAs;
        const kindKey = isImport ? 'importKind' : 'exportKind';
        node[kindKey] = hasTypeSpecifier ? 'type' : 'value';
        if (canParseAsKeyword && this.eatContextual(93)) {
          node[rightOfAsKey] = isImport
            ? this.parseIdentifier()
            : this.parseModuleExportName();
        }
        if (!node[rightOfAsKey]) {
          node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
        }
        if (isImport) {
          this.checkIdentifier(
            node[rightOfAsKey],
            hasTypeSpecifier ? 4098 : 4096
          );
        }
      }
    };
  function isPossiblyLiteralEnum(expression) {
    if (expression.type !== 'MemberExpression') return false;
    const {computed: computed, property: property} = expression;
    if (
      computed &&
      property.type !== 'StringLiteral' &&
      (property.type !== 'TemplateLiteral' || property.expressions.length > 0)
    ) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  function isValidAmbientConstInitializer(expression, estree) {
    var _expression$extra;
    const {type: type} = expression;
    if (
      (_expression$extra = expression.extra) != null &&
      _expression$extra.parenthesized
    ) {
      return false;
    }
    if (estree) {
      if (type === 'Literal') {
        const {value: value} = expression;
        if (typeof value === 'string' || typeof value === 'boolean') {
          return true;
        }
      }
    } else {
      if (type === 'StringLiteral' || type === 'BooleanLiteral') {
        return true;
      }
    }
    if (isNumber(expression, estree) || isNegativeNumber(expression, estree)) {
      return true;
    }
    if (type === 'TemplateLiteral' && expression.expressions.length === 0) {
      return true;
    }
    if (isPossiblyLiteralEnum(expression)) {
      return true;
    }
    return false;
  }
  function isNumber(expression, estree) {
    if (estree) {
      return (
        expression.type === 'Literal' &&
        (typeof expression.value === 'number' || 'bigint' in expression)
      );
    }
    return (
      expression.type === 'NumericLiteral' ||
      expression.type === 'BigIntLiteral'
    );
  }
  function isNegativeNumber(expression, estree) {
    if (expression.type === 'UnaryExpression') {
      const {operator: operator, argument: argument} = expression;
      if (operator === '-' && isNumber(argument, estree)) {
        return true;
      }
    }
    return false;
  }
  function isUncomputedMemberExpressionChain(expression) {
    if (expression.type === 'Identifier') return true;
    if (expression.type !== 'MemberExpression' || expression.computed) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  const PlaceholderErrors = ParseErrorEnum`placeholders`({
    ClassNameIsRequired: 'A class name is required.',
    UnexpectedSpace: 'Unexpected space in placeholder.',
  });
  var placeholders = superClass =>
    class PlaceholdersParserMixin extends superClass {
      parsePlaceholder(expectedNode) {
        if (this.match(133)) {
          const node = this.startNode();
          this.next();
          this.assertNoSpace();
          node.name = super.parseIdentifier(true);
          this.assertNoSpace();
          this.expect(133);
          return this.finishPlaceholder(node, expectedNode);
        }
      }
      finishPlaceholder(node, expectedNode) {
        let placeholder = node;
        if (!placeholder.expectedNode || !placeholder.type) {
          placeholder = this.finishNode(placeholder, 'Placeholder');
        }
        placeholder.expectedNode = expectedNode;
        return placeholder;
      }
      getTokenFromCode(code) {
        if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
          this.finishOp(133, 2);
        } else {
          super.getTokenFromCode(code);
        }
      }
      parseExprAtom(refExpressionErrors) {
        return (
          this.parsePlaceholder('Expression') ||
          super.parseExprAtom(refExpressionErrors)
        );
      }
      parseIdentifier(liberal) {
        return (
          this.parsePlaceholder('Identifier') || super.parseIdentifier(liberal)
        );
      }
      checkReservedWord(word, startLoc, checkKeywords, isBinding) {
        if (word !== undefined) {
          super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
        }
      }
      parseBindingAtom() {
        return this.parsePlaceholder('Pattern') || super.parseBindingAtom();
      }
      isValidLVal(type, isParenthesized, binding) {
        return (
          type === 'Placeholder' ||
          super.isValidLVal(type, isParenthesized, binding)
        );
      }
      toAssignable(node, isLHS) {
        if (
          node &&
          node.type === 'Placeholder' &&
          node.expectedNode === 'Expression'
        ) {
          node.expectedNode = 'Pattern';
        } else {
          super.toAssignable(node, isLHS);
        }
      }
      chStartsBindingIdentifier(ch, pos) {
        if (super.chStartsBindingIdentifier(ch, pos)) {
          return true;
        }
        const nextToken = this.lookahead();
        if (nextToken.type === 133) {
          return true;
        }
        return false;
      }
      verifyBreakContinue(node, isBreak) {
        if (node.label && node.label.type === 'Placeholder') return;
        super.verifyBreakContinue(node, isBreak);
      }
      parseExpressionStatement(node, expr) {
        var _expr$extra;
        if (
          expr.type !== 'Placeholder' ||
          ((_expr$extra = expr.extra) != null && _expr$extra.parenthesized)
        ) {
          return super.parseExpressionStatement(node, expr);
        }
        if (this.match(14)) {
          const stmt = node;
          stmt.label = this.finishPlaceholder(expr, 'Identifier');
          this.next();
          stmt.body = super.parseStatementOrSloppyAnnexBFunctionDeclaration();
          return this.finishNode(stmt, 'LabeledStatement');
        }
        this.semicolon();
        const stmtPlaceholder = node;
        stmtPlaceholder.name = expr.name;
        return this.finishPlaceholder(stmtPlaceholder, 'Statement');
      }
      parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
        return (
          this.parsePlaceholder('BlockStatement') ||
          super.parseBlock(
            allowDirectives,
            createNewLexicalScope,
            afterBlockParse
          )
        );
      }
      parseFunctionId(requireId) {
        return (
          this.parsePlaceholder('Identifier') ||
          super.parseFunctionId(requireId)
        );
      }
      parseClass(node, isStatement, optionalId) {
        const type = isStatement ? 'ClassDeclaration' : 'ClassExpression';
        this.next();
        const oldStrict = this.state.strict;
        const placeholder = this.parsePlaceholder('Identifier');
        if (placeholder) {
          if (this.match(81) || this.match(133) || this.match(5)) {
            node.id = placeholder;
          } else if (optionalId || !isStatement) {
            node.id = null;
            node.body = this.finishPlaceholder(placeholder, 'ClassBody');
            return this.finishNode(node, type);
          } else {
            throw this.raise(
              PlaceholderErrors.ClassNameIsRequired,
              this.state.startLoc
            );
          }
        } else {
          this.parseClassId(node, isStatement, optionalId);
        }
        super.parseClassSuper(node);
        node.body =
          this.parsePlaceholder('ClassBody') ||
          super.parseClassBody(!!node.superClass, oldStrict);
        return this.finishNode(node, type);
      }
      parseExport(node, decorators) {
        const placeholder = this.parsePlaceholder('Identifier');
        if (!placeholder) return super.parseExport(node, decorators);
        const node2 = node;
        if (!this.isContextual(98) && !this.match(12)) {
          node2.specifiers = [];
          node2.source = null;
          node2.declaration = this.finishPlaceholder(
            placeholder,
            'Declaration'
          );
          return this.finishNode(node2, 'ExportNamedDeclaration');
        }
        this.expectPlugin('exportDefaultFrom');
        const specifier = this.startNode();
        specifier.exported = placeholder;
        node2.specifiers = [
          this.finishNode(specifier, 'ExportDefaultSpecifier'),
        ];
        return super.parseExport(node2, decorators);
      }
      isExportDefaultSpecifier() {
        if (this.match(65)) {
          const next = this.nextTokenStart();
          if (this.isUnparsedContextual(next, 'from')) {
            if (
              this.input.startsWith(
                tokenLabelName(133),
                this.nextTokenStartSince(next + 4)
              )
            ) {
              return true;
            }
          }
        }
        return super.isExportDefaultSpecifier();
      }
      maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
        var _specifiers;
        if ((_specifiers = node.specifiers) != null && _specifiers.length) {
          return true;
        }
        return super.maybeParseExportDefaultSpecifier(
          node,
          maybeDefaultIdentifier
        );
      }
      checkExport(node) {
        const {specifiers: specifiers} = node;
        if (specifiers != null && specifiers.length) {
          node.specifiers = specifiers.filter(
            node => node.exported.type === 'Placeholder'
          );
        }
        super.checkExport(node);
        node.specifiers = specifiers;
      }
      parseImport(node) {
        const placeholder = this.parsePlaceholder('Identifier');
        if (!placeholder) return super.parseImport(node);
        node.specifiers = [];
        if (!this.isContextual(98) && !this.match(12)) {
          node.source = this.finishPlaceholder(placeholder, 'StringLiteral');
          this.semicolon();
          return this.finishNode(node, 'ImportDeclaration');
        }
        const specifier = this.startNodeAtNode(placeholder);
        specifier.local = placeholder;
        node.specifiers.push(
          this.finishNode(specifier, 'ImportDefaultSpecifier')
        );
        if (this.eat(12)) {
          const hasStarImport = this.maybeParseStarImportSpecifier(node);
          if (!hasStarImport) this.parseNamedImportSpecifiers(node);
        }
        this.expectContextual(98);
        node.source = this.parseImportSource();
        this.semicolon();
        return this.finishNode(node, 'ImportDeclaration');
      }
      parseImportSource() {
        return (
          this.parsePlaceholder('StringLiteral') || super.parseImportSource()
        );
      }
      assertNoSpace() {
        if (
          this.state.start >
          this.offsetToSourcePos(this.state.lastTokEndLoc.index)
        ) {
          this.raise(
            PlaceholderErrors.UnexpectedSpace,
            this.state.lastTokEndLoc
          );
        }
      }
    };
  var v8intrinsic = superClass =>
    class V8IntrinsicMixin extends superClass {
      parseV8Intrinsic() {
        if (this.match(54)) {
          const v8IntrinsicStartLoc = this.state.startLoc;
          const node = this.startNode();
          this.next();
          if (tokenIsIdentifier(this.state.type)) {
            const name = this.parseIdentifierName();
            const identifier = this.createIdentifier(node, name);
            identifier.type = 'V8IntrinsicIdentifier';
            if (this.match(10)) {
              return identifier;
            }
          }
          this.unexpected(v8IntrinsicStartLoc);
        }
      }
      parseExprAtom(refExpressionErrors) {
        return (
          this.parseV8Intrinsic() || super.parseExprAtom(refExpressionErrors)
        );
      }
    };
  const PIPELINE_PROPOSALS = ['minimal', 'fsharp', 'hack', 'smart'];
  const TOPIC_TOKENS = ['^^', '@@', '^', '%', '#'];
  function validatePlugins(pluginsMap) {
    if (pluginsMap.has('decorators')) {
      if (pluginsMap.has('decorators-legacy')) {
        throw new Error(
          'Cannot use the decorators and decorators-legacy plugin together'
        );
      }
      const decoratorsBeforeExport =
        pluginsMap.get('decorators').decoratorsBeforeExport;
      if (
        decoratorsBeforeExport != null &&
        typeof decoratorsBeforeExport !== 'boolean'
      ) {
        throw new Error(
          "'decoratorsBeforeExport' must be a boolean, if specified."
        );
      }
      const allowCallParenthesized =
        pluginsMap.get('decorators').allowCallParenthesized;
      if (
        allowCallParenthesized != null &&
        typeof allowCallParenthesized !== 'boolean'
      ) {
        throw new Error("'allowCallParenthesized' must be a boolean.");
      }
    }
    if (pluginsMap.has('flow') && pluginsMap.has('typescript')) {
      throw new Error('Cannot combine flow and typescript plugins.');
    }
    if (pluginsMap.has('placeholders') && pluginsMap.has('v8intrinsic')) {
      throw new Error('Cannot combine placeholders and v8intrinsic plugins.');
    }
    if (pluginsMap.has('pipelineOperator')) {
      var _pluginsMap$get;
      const proposal = pluginsMap.get('pipelineOperator').proposal;
      if (!PIPELINE_PROPOSALS.includes(proposal)) {
        const proposalList = PIPELINE_PROPOSALS.map(p => `"${p}"`).join(', ');
        throw new Error(
          `"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`
        );
      }
      const tupleSyntaxIsHash =
        ((_pluginsMap$get = pluginsMap.get('recordAndTuple')) == null
          ? void 0
          : _pluginsMap$get.syntaxType) === 'hash';
      if (proposal === 'hack') {
        if (pluginsMap.has('placeholders')) {
          throw new Error(
            'Cannot combine placeholders plugin and Hack-style pipes.'
          );
        }
        if (pluginsMap.has('v8intrinsic')) {
          throw new Error(
            'Cannot combine v8intrinsic plugin and Hack-style pipes.'
          );
        }
        const topicToken = pluginsMap.get('pipelineOperator').topicToken;
        if (!TOPIC_TOKENS.includes(topicToken)) {
          const tokenList = TOPIC_TOKENS.map(t => `"${t}"`).join(', ');
          throw new Error(
            `"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`
          );
        }
        if (topicToken === '#' && tupleSyntaxIsHash) {
          throw new Error(
            `Plugin conflict between \`["pipelineOperator", { proposal: "hack", topicToken: "#" }]\` and \`${JSON.stringify(['recordAndTuple', pluginsMap.get('recordAndTuple')])}\`.`
          );
        }
      } else if (proposal === 'smart' && tupleSyntaxIsHash) {
        throw new Error(
          `Plugin conflict between \`["pipelineOperator", { proposal: "smart" }]\` and \`${JSON.stringify(['recordAndTuple', pluginsMap.get('recordAndTuple')])}\`.`
        );
      }
    }
    if (pluginsMap.has('moduleAttributes')) {
      {
        if (
          pluginsMap.has('deprecatedImportAssert') ||
          pluginsMap.has('importAssertions')
        ) {
          throw new Error(
            'Cannot combine importAssertions, deprecatedImportAssert and moduleAttributes plugins.'
          );
        }
        const moduleAttributesVersionPluginOption =
          pluginsMap.get('moduleAttributes').version;
        if (moduleAttributesVersionPluginOption !== 'may-2020') {
          throw new Error(
            "The 'moduleAttributes' plugin requires a 'version' option," +
              ' representing the last proposal update. Currently, the' +
              " only supported value is 'may-2020'."
          );
        }
      }
    }
    if (pluginsMap.has('importAssertions')) {
      if (pluginsMap.has('deprecatedImportAssert')) {
        throw new Error(
          'Cannot combine importAssertions and deprecatedImportAssert plugins.'
        );
      }
    }
    if (
      !pluginsMap.has('deprecatedImportAssert') &&
      pluginsMap.has('importAttributes') &&
      pluginsMap.get('importAttributes').deprecatedAssertSyntax
    ) {
      {
        pluginsMap.set('deprecatedImportAssert', {});
      }
    }
    if (pluginsMap.has('recordAndTuple')) {
      const syntaxType = pluginsMap.get('recordAndTuple').syntaxType;
      if (syntaxType != null) {
        {
          const RECORD_AND_TUPLE_SYNTAX_TYPES = ['hash', 'bar'];
          if (!RECORD_AND_TUPLE_SYNTAX_TYPES.includes(syntaxType)) {
            throw new Error(
              "The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " +
                RECORD_AND_TUPLE_SYNTAX_TYPES.map(p => `'${p}'`).join(', ')
            );
          }
        }
      }
    }
    if (
      pluginsMap.has('asyncDoExpressions') &&
      !pluginsMap.has('doExpressions')
    ) {
      const error = new Error(
        "'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins."
      );
      error.missingPlugins = 'doExpressions';
      throw error;
    }
    if (
      pluginsMap.has('optionalChainingAssign') &&
      pluginsMap.get('optionalChainingAssign').version !== '2023-07'
    ) {
      throw new Error(
        "The 'optionalChainingAssign' plugin requires a 'version' option," +
          ' representing the last proposal update. Currently, the' +
          " only supported value is '2023-07'."
      );
    }
  }
  const mixinPlugins = {
    estree: estree,
    jsx: jsx,
    flow: flow,
    typescript: typescript,
    v8intrinsic: v8intrinsic,
    placeholders: placeholders,
  };
  const mixinPluginNames = Object.keys(mixinPlugins);
  function createDefaultOptions() {
    return {
      sourceType: 'script',
      sourceFilename: undefined,
      startIndex: 0,
      startColumn: 0,
      startLine: 1,
      allowAwaitOutsideFunction: false,
      allowReturnOutsideFunction: false,
      allowNewTargetOutsideFunction: false,
      allowImportExportEverywhere: false,
      allowSuperOutsideMethod: false,
      allowUndeclaredExports: false,
      plugins: [],
      strictMode: null,
      ranges: false,
      tokens: false,
      createImportExpressions: false,
      createParenthesizedExpressions: false,
      errorRecovery: false,
      attachComment: true,
      annexB: true,
    };
  }
  function getOptions(opts) {
    const options = createDefaultOptions();
    if (opts == null) {
      return options;
    }
    if (opts.annexB != null && opts.annexB !== false) {
      throw new Error('The `annexB` option can only be set to `false`.');
    }
    for (const key of Object.keys(options)) {
      if (opts[key] != null) options[key] = opts[key];
    }
    if (options.startLine === 1) {
      if (opts.startIndex == null && options.startColumn > 0) {
        options.startIndex = options.startColumn;
      } else if (opts.startColumn == null && options.startIndex > 0) {
        options.startColumn = options.startIndex;
      }
    } else if (opts.startColumn == null || opts.startIndex == null) {
      if (opts.startIndex != null) {
        throw new Error(
          'With a `startLine > 1` you must also specify `startIndex` and `startColumn`.'
        );
      }
    }
    return options;
  }
  class ExpressionParser extends LValParser {
    checkProto(prop, isRecord, protoRef, refExpressionErrors) {
      if (
        prop.type === 'SpreadElement' ||
        this.isObjectMethod(prop) ||
        prop.computed ||
        prop.shorthand
      ) {
        return;
      }
      const key = prop.key;
      const name = key.type === 'Identifier' ? key.name : key.value;
      if (name === '__proto__') {
        if (isRecord) {
          this.raise(Errors.RecordNoProto, key);
          return;
        }
        if (protoRef.used) {
          if (refExpressionErrors) {
            if (refExpressionErrors.doubleProtoLoc === null) {
              refExpressionErrors.doubleProtoLoc = key.loc.start;
            }
          } else {
            this.raise(Errors.DuplicateProto, key);
          }
        }
        protoRef.used = true;
      }
    }
    shouldExitDescending(expr, potentialArrowAt) {
      return (
        expr.type === 'ArrowFunctionExpression' &&
        this.offsetToSourcePos(expr.start) === potentialArrowAt
      );
    }
    getExpression() {
      this.enterInitialScopes();
      this.nextToken();
      const expr = this.parseExpression();
      if (!this.match(140)) {
        this.unexpected();
      }
      this.finalizeRemainingComments();
      expr.comments = this.comments;
      expr.errors = this.state.errors;
      if (this.options.tokens) {
        expr.tokens = this.tokens;
      }
      return expr;
    }
    parseExpression(disallowIn, refExpressionErrors) {
      if (disallowIn) {
        return this.disallowInAnd(() =>
          this.parseExpressionBase(refExpressionErrors)
        );
      }
      return this.allowInAnd(() =>
        this.parseExpressionBase(refExpressionErrors)
      );
    }
    parseExpressionBase(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const expr = this.parseMaybeAssign(refExpressionErrors);
      if (this.match(12)) {
        const node = this.startNodeAt(startLoc);
        node.expressions = [expr];
        while (this.eat(12)) {
          node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
        }
        this.toReferencedList(node.expressions);
        return this.finishNode(node, 'SequenceExpression');
      }
      return expr;
    }
    parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
      return this.disallowInAnd(() =>
        this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
      );
    }
    parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
      return this.allowInAnd(() =>
        this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
      );
    }
    setOptionalParametersError(refExpressionErrors, resultError) {
      var _resultError$loc;
      refExpressionErrors.optionalParametersLoc =
        (_resultError$loc = resultError == null ? void 0 : resultError.loc) !=
        null
          ? _resultError$loc
          : this.state.startLoc;
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      const startLoc = this.state.startLoc;
      if (this.isContextual(108)) {
        if (this.prodParam.hasYield) {
          let left = this.parseYield();
          if (afterLeftParse) {
            left = afterLeftParse.call(this, left, startLoc);
          }
          return left;
        }
      }
      let ownExpressionErrors;
      if (refExpressionErrors) {
        ownExpressionErrors = false;
      } else {
        refExpressionErrors = new ExpressionErrors();
        ownExpressionErrors = true;
      }
      const {type: type} = this.state;
      if (type === 10 || tokenIsIdentifier(type)) {
        this.state.potentialArrowAt = this.state.start;
      }
      let left = this.parseMaybeConditional(refExpressionErrors);
      if (afterLeftParse) {
        left = afterLeftParse.call(this, left, startLoc);
      }
      if (tokenIsAssignment(this.state.type)) {
        const node = this.startNodeAt(startLoc);
        const operator = this.state.value;
        node.operator = operator;
        if (this.match(29)) {
          this.toAssignable(left, true);
          node.left = left;
          const startIndex = startLoc.index;
          if (
            refExpressionErrors.doubleProtoLoc != null &&
            refExpressionErrors.doubleProtoLoc.index >= startIndex
          ) {
            refExpressionErrors.doubleProtoLoc = null;
          }
          if (
            refExpressionErrors.shorthandAssignLoc != null &&
            refExpressionErrors.shorthandAssignLoc.index >= startIndex
          ) {
            refExpressionErrors.shorthandAssignLoc = null;
          }
          if (
            refExpressionErrors.privateKeyLoc != null &&
            refExpressionErrors.privateKeyLoc.index >= startIndex
          ) {
            this.checkDestructuringPrivate(refExpressionErrors);
            refExpressionErrors.privateKeyLoc = null;
          }
        } else {
          node.left = left;
        }
        this.next();
        node.right = this.parseMaybeAssign();
        this.checkLVal(left, this.finishNode(node, 'AssignmentExpression'));
        return node;
      } else if (ownExpressionErrors) {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      return left;
    }
    parseMaybeConditional(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprOps(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseConditional(expr, startLoc, refExpressionErrors);
    }
    parseConditional(expr, startLoc, refExpressionErrors) {
      if (this.eat(17)) {
        const node = this.startNodeAt(startLoc);
        node.test = expr;
        node.consequent = this.parseMaybeAssignAllowIn();
        this.expect(14);
        node.alternate = this.parseMaybeAssign();
        return this.finishNode(node, 'ConditionalExpression');
      }
      return expr;
    }
    parseMaybeUnaryOrPrivate(refExpressionErrors) {
      return this.match(139)
        ? this.parsePrivateName()
        : this.parseMaybeUnary(refExpressionErrors);
    }
    parseExprOps(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseExprOp(expr, startLoc, -1);
    }
    parseExprOp(left, leftStartLoc, minPrec) {
      if (this.isPrivateName(left)) {
        const value = this.getPrivateNameSV(left);
        if (
          minPrec >= tokenOperatorPrecedence(58) ||
          !this.prodParam.hasIn ||
          !this.match(58)
        ) {
          this.raise(Errors.PrivateInExpectedIn, left, {identifierName: value});
        }
        this.classScope.usePrivateName(value, left.loc.start);
      }
      const op = this.state.type;
      if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
        let prec = tokenOperatorPrecedence(op);
        if (prec > minPrec) {
          if (op === 39) {
            this.expectPlugin('pipelineOperator');
            if (this.state.inFSharpPipelineDirectBody) {
              return left;
            }
            this.checkPipelineAtInfixOperator(left, leftStartLoc);
          }
          const node = this.startNodeAt(leftStartLoc);
          node.left = left;
          node.operator = this.state.value;
          const logical = op === 41 || op === 42;
          const coalesce = op === 40;
          if (coalesce) {
            prec = tokenOperatorPrecedence(42);
          }
          this.next();
          if (
            op === 39 &&
            this.hasPlugin(['pipelineOperator', {proposal: 'minimal'}])
          ) {
            if (this.state.type === 96 && this.prodParam.hasAwait) {
              throw this.raise(
                Errors.UnexpectedAwaitAfterPipelineBody,
                this.state.startLoc
              );
            }
          }
          node.right = this.parseExprOpRightExpr(op, prec);
          const finishedNode = this.finishNode(
            node,
            logical || coalesce ? 'LogicalExpression' : 'BinaryExpression'
          );
          const nextOp = this.state.type;
          if (
            (coalesce && (nextOp === 41 || nextOp === 42)) ||
            (logical && nextOp === 40)
          ) {
            throw this.raise(
              Errors.MixingCoalesceWithLogical,
              this.state.startLoc
            );
          }
          return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
        }
      }
      return left;
    }
    parseExprOpRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      switch (op) {
        case 39:
          switch (this.getPluginOption('pipelineOperator', 'proposal')) {
            case 'hack':
              return this.withTopicBindingContext(() =>
                this.parseHackPipeBody()
              );
            case 'smart':
              return this.withTopicBindingContext(() => {
                if (this.prodParam.hasYield && this.isContextual(108)) {
                  throw this.raise(
                    Errors.PipeBodyIsTighter,
                    this.state.startLoc
                  );
                }
                return this.parseSmartPipelineBodyInStyle(
                  this.parseExprOpBaseRightExpr(op, prec),
                  startLoc
                );
              });
            case 'fsharp':
              return this.withSoloAwaitPermittingContext(() =>
                this.parseFSharpPipelineBody(prec)
              );
          }
        default:
          return this.parseExprOpBaseRightExpr(op, prec);
      }
    }
    parseExprOpBaseRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      return this.parseExprOp(
        this.parseMaybeUnaryOrPrivate(),
        startLoc,
        tokenIsRightAssociative(op) ? prec - 1 : prec
      );
    }
    parseHackPipeBody() {
      var _body$extra;
      const {startLoc: startLoc} = this.state;
      const body = this.parseMaybeAssign();
      const requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(
        body.type
      );
      if (
        requiredParentheses &&
        !((_body$extra = body.extra) != null && _body$extra.parenthesized)
      ) {
        this.raise(Errors.PipeUnparenthesizedBody, startLoc, {type: body.type});
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipeTopicUnused, startLoc);
      }
      return body;
    }
    checkExponentialAfterUnary(node) {
      if (this.match(57)) {
        this.raise(Errors.UnexpectedTokenUnaryExponentiation, node.argument);
      }
    }
    parseMaybeUnary(refExpressionErrors, sawUnary) {
      const startLoc = this.state.startLoc;
      const isAwait = this.isContextual(96);
      if (isAwait && this.recordAwaitIfAllowed()) {
        this.next();
        const expr = this.parseAwait(startLoc);
        if (!sawUnary) this.checkExponentialAfterUnary(expr);
        return expr;
      }
      const update = this.match(34);
      const node = this.startNode();
      if (tokenIsPrefix(this.state.type)) {
        node.operator = this.state.value;
        node.prefix = true;
        if (this.match(72)) {
          this.expectPlugin('throwExpressions');
        }
        const isDelete = this.match(89);
        this.next();
        node.argument = this.parseMaybeUnary(null, true);
        this.checkExpressionErrors(refExpressionErrors, true);
        if (this.state.strict && isDelete) {
          const arg = node.argument;
          if (arg.type === 'Identifier') {
            this.raise(Errors.StrictDelete, node);
          } else if (this.hasPropertyAsPrivateName(arg)) {
            this.raise(Errors.DeletePrivateField, node);
          }
        }
        if (!update) {
          if (!sawUnary) {
            this.checkExponentialAfterUnary(node);
          }
          return this.finishNode(node, 'UnaryExpression');
        }
      }
      const expr = this.parseUpdate(node, update, refExpressionErrors);
      if (isAwait) {
        const {type: type} = this.state;
        const startsExpr = this.hasPlugin('v8intrinsic')
          ? tokenCanStartExpression(type)
          : tokenCanStartExpression(type) && !this.match(54);
        if (startsExpr && !this.isAmbiguousAwait()) {
          this.raiseOverwrite(Errors.AwaitNotInAsyncContext, startLoc);
          return this.parseAwait(startLoc);
        }
      }
      return expr;
    }
    parseUpdate(node, update, refExpressionErrors) {
      if (update) {
        const updateExpressionNode = node;
        this.checkLVal(
          updateExpressionNode.argument,
          this.finishNode(updateExpressionNode, 'UpdateExpression')
        );
        return node;
      }
      const startLoc = this.state.startLoc;
      let expr = this.parseExprSubscripts(refExpressionErrors);
      if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
      while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
        const node = this.startNodeAt(startLoc);
        node.operator = this.state.value;
        node.prefix = false;
        node.argument = expr;
        this.next();
        this.checkLVal(
          expr,
          (expr = this.finishNode(node, 'UpdateExpression'))
        );
      }
      return expr;
    }
    parseExprSubscripts(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprAtom(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseSubscripts(expr, startLoc);
    }
    parseSubscripts(base, startLoc, noCalls) {
      const state = {
        optionalChainMember: false,
        maybeAsyncArrow: this.atPossibleAsyncArrow(base),
        stop: false,
      };
      do {
        base = this.parseSubscript(base, startLoc, noCalls, state);
        state.maybeAsyncArrow = false;
      } while (!state.stop);
      return base;
    }
    parseSubscript(base, startLoc, noCalls, state) {
      const {type: type} = this.state;
      if (!noCalls && type === 15) {
        return this.parseBind(base, startLoc, noCalls, state);
      } else if (tokenIsTemplate(type)) {
        return this.parseTaggedTemplateExpression(base, startLoc, state);
      }
      let optional = false;
      if (type === 18) {
        if (noCalls) {
          this.raise(Errors.OptionalChainingNoNew, this.state.startLoc);
          if (this.lookaheadCharCode() === 40) {
            state.stop = true;
            return base;
          }
        }
        state.optionalChainMember = optional = true;
        this.next();
      }
      if (!noCalls && this.match(10)) {
        return this.parseCoverCallAndAsyncArrowHead(
          base,
          startLoc,
          state,
          optional
        );
      } else {
        const computed = this.eat(0);
        if (computed || optional || this.eat(16)) {
          return this.parseMember(base, startLoc, state, computed, optional);
        } else {
          state.stop = true;
          return base;
        }
      }
    }
    parseMember(base, startLoc, state, computed, optional) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      node.computed = computed;
      if (computed) {
        node.property = this.parseExpression();
        this.expect(3);
      } else if (this.match(139)) {
        if (base.type === 'Super') {
          this.raise(Errors.SuperPrivateField, startLoc);
        }
        this.classScope.usePrivateName(this.state.value, this.state.startLoc);
        node.property = this.parsePrivateName();
      } else {
        node.property = this.parseIdentifier(true);
      }
      if (state.optionalChainMember) {
        node.optional = optional;
        return this.finishNode(node, 'OptionalMemberExpression');
      } else {
        return this.finishNode(node, 'MemberExpression');
      }
    }
    parseBind(base, startLoc, noCalls, state) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      this.next();
      node.callee = this.parseNoCallExpr();
      state.stop = true;
      return this.parseSubscripts(
        this.finishNode(node, 'BindExpression'),
        startLoc,
        noCalls
      );
    }
    parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      let refExpressionErrors = null;
      this.state.maybeInArrowParameters = true;
      this.next();
      const node = this.startNodeAt(startLoc);
      node.callee = base;
      const {
        maybeAsyncArrow: maybeAsyncArrow,
        optionalChainMember: optionalChainMember,
      } = state;
      if (maybeAsyncArrow) {
        this.expressionScope.enter(newAsyncArrowScope());
        refExpressionErrors = new ExpressionErrors();
      }
      if (optionalChainMember) {
        node.optional = optional;
      }
      if (optional) {
        node.arguments = this.parseCallExpressionArguments(11);
      } else {
        node.arguments = this.parseCallExpressionArguments(
          11,
          base.type !== 'Super',
          node,
          refExpressionErrors
        );
      }
      let finishedNode = this.finishCallExpression(node, optionalChainMember);
      if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
        state.stop = true;
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        finishedNode = this.parseAsyncArrowFromCallExpression(
          this.startNodeAt(startLoc),
          finishedNode
        );
      } else {
        if (maybeAsyncArrow) {
          this.checkExpressionErrors(refExpressionErrors, true);
          this.expressionScope.exit();
        }
        this.toReferencedArguments(finishedNode);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return finishedNode;
    }
    toReferencedArguments(node, isParenthesizedExpr) {
      this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
    }
    parseTaggedTemplateExpression(base, startLoc, state) {
      const node = this.startNodeAt(startLoc);
      node.tag = base;
      node.quasi = this.parseTemplate(true);
      if (state.optionalChainMember) {
        this.raise(Errors.OptionalChainingNoTemplate, startLoc);
      }
      return this.finishNode(node, 'TaggedTemplateExpression');
    }
    atPossibleAsyncArrow(base) {
      return (
        base.type === 'Identifier' &&
        base.name === 'async' &&
        this.state.lastTokEndLoc.index === base.end &&
        !this.canInsertSemicolon() &&
        base.end - base.start === 5 &&
        this.offsetToSourcePos(base.start) === this.state.potentialArrowAt
      );
    }
    finishCallExpression(node, optional) {
      if (node.callee.type === 'Import') {
        if (node.arguments.length === 0 || node.arguments.length > 2) {
          this.raise(Errors.ImportCallArity, node);
        } else {
          for (const arg of node.arguments) {
            if (arg.type === 'SpreadElement') {
              this.raise(Errors.ImportCallSpreadArgument, arg);
            }
          }
        }
      }
      return this.finishNode(
        node,
        optional ? 'OptionalCallExpression' : 'CallExpression'
      );
    }
    parseCallExpressionArguments(
      close,
      allowPlaceholder,
      nodeForExtra,
      refExpressionErrors
    ) {
      const elts = [];
      let first = true;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(
          this.parseExprListItem(false, refExpressionErrors, allowPlaceholder)
        );
      }
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return elts;
    }
    shouldParseAsyncArrow() {
      return this.match(19) && !this.canInsertSemicolon();
    }
    parseAsyncArrowFromCallExpression(node, call) {
      var _call$extra;
      this.resetPreviousNodeTrailingComments(call);
      this.expect(19);
      this.parseArrowExpression(
        node,
        call.arguments,
        true,
        (_call$extra = call.extra) == null
          ? void 0
          : _call$extra.trailingCommaLoc
      );
      if (call.innerComments) {
        setInnerComments(node, call.innerComments);
      }
      if (call.callee.trailingComments) {
        setInnerComments(node, call.callee.trailingComments);
      }
      return node;
    }
    parseNoCallExpr() {
      const startLoc = this.state.startLoc;
      return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
    }
    parseExprAtom(refExpressionErrors) {
      let node;
      let decorators = null;
      const {type: type} = this.state;
      switch (type) {
        case 79:
          return this.parseSuper();
        case 83:
          node = this.startNode();
          this.next();
          if (this.match(16)) {
            return this.parseImportMetaProperty(node);
          }
          if (this.match(10)) {
            if (this.options.createImportExpressions) {
              return this.parseImportCall(node);
            } else {
              return this.finishNode(node, 'Import');
            }
          } else {
            this.raise(Errors.UnsupportedImport, this.state.lastTokStartLoc);
            return this.finishNode(node, 'Import');
          }
        case 78:
          node = this.startNode();
          this.next();
          return this.finishNode(node, 'ThisExpression');
        case 90: {
          return this.parseDo(this.startNode(), false);
        }
        case 56:
        case 31: {
          this.readRegexp();
          return this.parseRegExpLiteral(this.state.value);
        }
        case 135:
          return this.parseNumericLiteral(this.state.value);
        case 136:
          return this.parseBigIntLiteral(this.state.value);
        case 134:
          return this.parseStringLiteral(this.state.value);
        case 84:
          return this.parseNullLiteral();
        case 85:
          return this.parseBooleanLiteral(true);
        case 86:
          return this.parseBooleanLiteral(false);
        case 10: {
          const canBeArrow = this.state.potentialArrowAt === this.state.start;
          return this.parseParenAndDistinguishExpression(canBeArrow);
        }
        case 2:
        case 1: {
          return this.parseArrayLike(
            this.state.type === 2 ? 4 : 3,
            false,
            true
          );
        }
        case 0: {
          return this.parseArrayLike(3, true, false, refExpressionErrors);
        }
        case 6:
        case 7: {
          return this.parseObjectLike(
            this.state.type === 6 ? 9 : 8,
            false,
            true
          );
        }
        case 5: {
          return this.parseObjectLike(8, false, false, refExpressionErrors);
        }
        case 68:
          return this.parseFunctionOrFunctionSent();
        case 26:
          decorators = this.parseDecorators();
        case 80:
          return this.parseClass(
            this.maybeTakeDecorators(decorators, this.startNode()),
            false
          );
        case 77:
          return this.parseNewOrNewTarget();
        case 25:
        case 24:
          return this.parseTemplate(false);
        case 15: {
          node = this.startNode();
          this.next();
          node.object = null;
          const callee = (node.callee = this.parseNoCallExpr());
          if (callee.type === 'MemberExpression') {
            return this.finishNode(node, 'BindExpression');
          } else {
            throw this.raise(Errors.UnsupportedBind, callee);
          }
        }
        case 139: {
          this.raise(Errors.PrivateInExpectedIn, this.state.startLoc, {
            identifierName: this.state.value,
          });
          return this.parsePrivateName();
        }
        case 33: {
          return this.parseTopicReferenceThenEqualsSign(54, '%');
        }
        case 32: {
          return this.parseTopicReferenceThenEqualsSign(44, '^');
        }
        case 37:
        case 38: {
          return this.parseTopicReference('hack');
        }
        case 44:
        case 54:
        case 27: {
          const pipeProposal = this.getPluginOption(
            'pipelineOperator',
            'proposal'
          );
          if (pipeProposal) {
            return this.parseTopicReference(pipeProposal);
          }
          this.unexpected();
          break;
        }
        case 47: {
          const lookaheadCh = this.input.codePointAt(this.nextTokenStart());
          if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
            this.expectOnePlugin(['jsx', 'flow', 'typescript']);
          } else {
            this.unexpected();
          }
          break;
        }
        default:
          if (type === 137) {
            return this.parseDecimalLiteral(this.state.value);
          }
          if (tokenIsIdentifier(type)) {
            if (
              this.isContextual(127) &&
              this.lookaheadInLineCharCode() === 123
            ) {
              return this.parseModuleExpression();
            }
            const canBeArrow = this.state.potentialArrowAt === this.state.start;
            const containsEsc = this.state.containsEsc;
            const id = this.parseIdentifier();
            if (
              !containsEsc &&
              id.name === 'async' &&
              !this.canInsertSemicolon()
            ) {
              const {type: type} = this.state;
              if (type === 68) {
                this.resetPreviousNodeTrailingComments(id);
                this.next();
                return this.parseAsyncFunctionExpression(
                  this.startNodeAtNode(id)
                );
              } else if (tokenIsIdentifier(type)) {
                if (this.lookaheadCharCode() === 61) {
                  return this.parseAsyncArrowUnaryFunction(
                    this.startNodeAtNode(id)
                  );
                } else {
                  return id;
                }
              } else if (type === 90) {
                this.resetPreviousNodeTrailingComments(id);
                return this.parseDo(this.startNodeAtNode(id), true);
              }
            }
            if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
              this.next();
              return this.parseArrowExpression(
                this.startNodeAtNode(id),
                [id],
                false
              );
            }
            return id;
          } else {
            this.unexpected();
          }
      }
    }
    parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
      const pipeProposal = this.getPluginOption('pipelineOperator', 'proposal');
      if (pipeProposal) {
        this.state.type = topicTokenType;
        this.state.value = topicTokenValue;
        this.state.pos--;
        this.state.end--;
        this.state.endLoc = createPositionWithColumnOffset(
          this.state.endLoc,
          -1
        );
        return this.parseTopicReference(pipeProposal);
      } else {
        this.unexpected();
      }
    }
    parseTopicReference(pipeProposal) {
      const node = this.startNode();
      const startLoc = this.state.startLoc;
      const tokenType = this.state.type;
      this.next();
      return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
    }
    finishTopicReference(node, startLoc, pipeProposal, tokenType) {
      if (
        this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)
      ) {
        const nodeType =
          pipeProposal === 'smart'
            ? 'PipelinePrimaryTopicReference'
            : 'TopicReference';
        if (!this.topicReferenceIsAllowedInCurrentContext()) {
          this.raise(
            pipeProposal === 'smart'
              ? Errors.PrimaryTopicNotAllowed
              : Errors.PipeTopicUnbound,
            startLoc
          );
        }
        this.registerTopicReference();
        return this.finishNode(node, nodeType);
      } else {
        throw this.raise(Errors.PipeTopicUnconfiguredToken, startLoc, {
          token: tokenLabelName(tokenType),
        });
      }
    }
    testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
      switch (pipeProposal) {
        case 'hack': {
          return this.hasPlugin([
            'pipelineOperator',
            {topicToken: tokenLabelName(tokenType)},
          ]);
        }
        case 'smart':
          return tokenType === 27;
        default:
          throw this.raise(Errors.PipeTopicRequiresHackPipes, startLoc);
      }
    }
    parseAsyncArrowUnaryFunction(node) {
      this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
      const params = [this.parseIdentifier()];
      this.prodParam.exit();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.LineTerminatorBeforeArrow, this.state.curPosition());
      }
      this.expect(19);
      return this.parseArrowExpression(node, params, true);
    }
    parseDo(node, isAsync) {
      this.expectPlugin('doExpressions');
      if (isAsync) {
        this.expectPlugin('asyncDoExpressions');
      }
      node.async = isAsync;
      this.next();
      const oldLabels = this.state.labels;
      this.state.labels = [];
      if (isAsync) {
        this.prodParam.enter(2);
        node.body = this.parseBlock();
        this.prodParam.exit();
      } else {
        node.body = this.parseBlock();
      }
      this.state.labels = oldLabels;
      return this.finishNode(node, 'DoExpression');
    }
    parseSuper() {
      const node = this.startNode();
      this.next();
      if (
        this.match(10) &&
        !this.scope.allowDirectSuper &&
        !this.options.allowSuperOutsideMethod
      ) {
        this.raise(Errors.SuperNotAllowed, node);
      } else if (
        !this.scope.allowSuper &&
        !this.options.allowSuperOutsideMethod
      ) {
        this.raise(Errors.UnexpectedSuper, node);
      }
      if (!this.match(10) && !this.match(0) && !this.match(16)) {
        this.raise(Errors.UnsupportedSuper, node);
      }
      return this.finishNode(node, 'Super');
    }
    parsePrivateName() {
      const node = this.startNode();
      const id = this.startNodeAt(
        createPositionWithColumnOffset(this.state.startLoc, 1)
      );
      const name = this.state.value;
      this.next();
      node.id = this.createIdentifier(id, name);
      return this.finishNode(node, 'PrivateName');
    }
    parseFunctionOrFunctionSent() {
      const node = this.startNode();
      this.next();
      if (this.prodParam.hasYield && this.match(16)) {
        const meta = this.createIdentifier(
          this.startNodeAtNode(node),
          'function'
        );
        this.next();
        if (this.match(103)) {
          this.expectPlugin('functionSent');
        } else if (!this.hasPlugin('functionSent')) {
          this.unexpected();
        }
        return this.parseMetaProperty(node, meta, 'sent');
      }
      return this.parseFunction(node);
    }
    parseMetaProperty(node, meta, propertyName) {
      node.meta = meta;
      const containsEsc = this.state.containsEsc;
      node.property = this.parseIdentifier(true);
      if (node.property.name !== propertyName || containsEsc) {
        this.raise(Errors.UnsupportedMetaProperty, node.property, {
          target: meta.name,
          onlyValidPropertyName: propertyName,
        });
      }
      return this.finishNode(node, 'MetaProperty');
    }
    parseImportMetaProperty(node) {
      const id = this.createIdentifier(this.startNodeAtNode(node), 'import');
      this.next();
      if (this.isContextual(101)) {
        if (!this.inModule) {
          this.raise(Errors.ImportMetaOutsideModule, id);
        }
        this.sawUnambiguousESM = true;
      } else if (this.isContextual(105) || this.isContextual(97)) {
        const isSource = this.isContextual(105);
        if (!isSource) this.unexpected();
        this.expectPlugin(
          isSource ? 'sourcePhaseImports' : 'deferredImportEvaluation'
        );
        if (!this.options.createImportExpressions) {
          throw this.raise(
            Errors.DynamicImportPhaseRequiresImportExpressions,
            this.state.startLoc,
            {phase: this.state.value}
          );
        }
        this.next();
        node.phase = isSource ? 'source' : 'defer';
        return this.parseImportCall(node);
      }
      return this.parseMetaProperty(node, id, 'meta');
    }
    parseLiteralAtNode(value, type, node) {
      this.addExtra(node, 'rawValue', value);
      this.addExtra(
        node,
        'raw',
        this.input.slice(this.offsetToSourcePos(node.start), this.state.end)
      );
      node.value = value;
      this.next();
      return this.finishNode(node, type);
    }
    parseLiteral(value, type) {
      const node = this.startNode();
      return this.parseLiteralAtNode(value, type, node);
    }
    parseStringLiteral(value) {
      return this.parseLiteral(value, 'StringLiteral');
    }
    parseNumericLiteral(value) {
      return this.parseLiteral(value, 'NumericLiteral');
    }
    parseBigIntLiteral(value) {
      return this.parseLiteral(value, 'BigIntLiteral');
    }
    parseDecimalLiteral(value) {
      return this.parseLiteral(value, 'DecimalLiteral');
    }
    parseRegExpLiteral(value) {
      const node = this.startNode();
      this.addExtra(
        node,
        'raw',
        this.input.slice(this.offsetToSourcePos(node.start), this.state.end)
      );
      node.pattern = value.pattern;
      node.flags = value.flags;
      this.next();
      return this.finishNode(node, 'RegExpLiteral');
    }
    parseBooleanLiteral(value) {
      const node = this.startNode();
      node.value = value;
      this.next();
      return this.finishNode(node, 'BooleanLiteral');
    }
    parseNullLiteral() {
      const node = this.startNode();
      this.next();
      return this.finishNode(node, 'NullLiteral');
    }
    parseParenAndDistinguishExpression(canBeArrow) {
      const startLoc = this.state.startLoc;
      let val;
      this.next();
      this.expressionScope.enter(newArrowHeadScope());
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.maybeInArrowParameters = true;
      this.state.inFSharpPipelineDirectBody = false;
      const innerStartLoc = this.state.startLoc;
      const exprList = [];
      const refExpressionErrors = new ExpressionErrors();
      let first = true;
      let spreadStartLoc;
      let optionalCommaStartLoc;
      while (!this.match(11)) {
        if (first) {
          first = false;
        } else {
          this.expect(
            12,
            refExpressionErrors.optionalParametersLoc === null
              ? null
              : refExpressionErrors.optionalParametersLoc
          );
          if (this.match(11)) {
            optionalCommaStartLoc = this.state.startLoc;
            break;
          }
        }
        if (this.match(21)) {
          const spreadNodeStartLoc = this.state.startLoc;
          spreadStartLoc = this.state.startLoc;
          exprList.push(
            this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc)
          );
          if (!this.checkCommaAfterRest(41)) {
            break;
          }
        } else {
          exprList.push(
            this.parseMaybeAssignAllowIn(
              refExpressionErrors,
              this.parseParenItem
            )
          );
        }
      }
      const innerEndLoc = this.state.lastTokEndLoc;
      this.expect(11);
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let arrowNode = this.startNodeAt(startLoc);
      if (
        canBeArrow &&
        this.shouldParseArrow(exprList) &&
        (arrowNode = this.parseArrow(arrowNode))
      ) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        this.parseArrowExpression(arrowNode, exprList, false);
        return arrowNode;
      }
      this.expressionScope.exit();
      if (!exprList.length) {
        this.unexpected(this.state.lastTokStartLoc);
      }
      if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
      if (spreadStartLoc) this.unexpected(spreadStartLoc);
      this.checkExpressionErrors(refExpressionErrors, true);
      this.toReferencedListDeep(exprList, true);
      if (exprList.length > 1) {
        val = this.startNodeAt(innerStartLoc);
        val.expressions = exprList;
        this.finishNode(val, 'SequenceExpression');
        this.resetEndLocation(val, innerEndLoc);
      } else {
        val = exprList[0];
      }
      return this.wrapParenthesis(startLoc, val);
    }
    wrapParenthesis(startLoc, expression) {
      if (!this.options.createParenthesizedExpressions) {
        this.addExtra(expression, 'parenthesized', true);
        this.addExtra(expression, 'parenStart', startLoc.index);
        this.takeSurroundingComments(
          expression,
          startLoc.index,
          this.state.lastTokEndLoc.index
        );
        return expression;
      }
      const parenExpression = this.startNodeAt(startLoc);
      parenExpression.expression = expression;
      return this.finishNode(parenExpression, 'ParenthesizedExpression');
    }
    shouldParseArrow(params) {
      return !this.canInsertSemicolon();
    }
    parseArrow(node) {
      if (this.eat(19)) {
        return node;
      }
    }
    parseParenItem(node, startLoc) {
      return node;
    }
    parseNewOrNewTarget() {
      const node = this.startNode();
      this.next();
      if (this.match(16)) {
        const meta = this.createIdentifier(this.startNodeAtNode(node), 'new');
        this.next();
        const metaProp = this.parseMetaProperty(node, meta, 'target');
        if (
          !this.scope.inNonArrowFunction &&
          !this.scope.inClass &&
          !this.options.allowNewTargetOutsideFunction
        ) {
          this.raise(Errors.UnexpectedNewTarget, metaProp);
        }
        return metaProp;
      }
      return this.parseNew(node);
    }
    parseNew(node) {
      this.parseNewCallee(node);
      if (this.eat(10)) {
        const args = this.parseExprList(11);
        this.toReferencedList(args);
        node.arguments = args;
      } else {
        node.arguments = [];
      }
      return this.finishNode(node, 'NewExpression');
    }
    parseNewCallee(node) {
      const isImport = this.match(83);
      const callee = this.parseNoCallExpr();
      node.callee = callee;
      if (
        isImport &&
        (callee.type === 'Import' || callee.type === 'ImportExpression')
      ) {
        this.raise(Errors.ImportCallNotNewExpression, callee);
      }
    }
    parseTemplateElement(isTagged) {
      const {
        start: start,
        startLoc: startLoc,
        end: end,
        value: value,
      } = this.state;
      const elemStart = start + 1;
      const elem = this.startNodeAt(
        createPositionWithColumnOffset(startLoc, 1)
      );
      if (value === null) {
        if (!isTagged) {
          this.raise(
            Errors.InvalidEscapeSequenceTemplate,
            createPositionWithColumnOffset(
              this.state.firstInvalidTemplateEscapePos,
              1
            )
          );
        }
      }
      const isTail = this.match(24);
      const endOffset = isTail ? -1 : -2;
      const elemEnd = end + endOffset;
      elem.value = {
        raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, '\n'),
        cooked: value === null ? null : value.slice(1, endOffset),
      };
      elem.tail = isTail;
      this.next();
      const finishedNode = this.finishNode(elem, 'TemplateElement');
      this.resetEndLocation(
        finishedNode,
        createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset)
      );
      return finishedNode;
    }
    parseTemplate(isTagged) {
      const node = this.startNode();
      let curElt = this.parseTemplateElement(isTagged);
      const quasis = [curElt];
      const substitutions = [];
      while (!curElt.tail) {
        substitutions.push(this.parseTemplateSubstitution());
        this.readTemplateContinuation();
        quasis.push((curElt = this.parseTemplateElement(isTagged)));
      }
      node.expressions = substitutions;
      node.quasis = quasis;
      return this.finishNode(node, 'TemplateLiteral');
    }
    parseTemplateSubstitution() {
      return this.parseExpression();
    }
    parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
      if (isRecord) {
        this.expectPlugin('recordAndTuple');
      }
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const propHash = Object.create(null);
      let first = true;
      const node = this.startNode();
      node.properties = [];
      this.next();
      while (!this.match(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            this.addTrailingCommaExtraToNode(node);
            break;
          }
        }
        let prop;
        if (isPattern) {
          prop = this.parseBindingProperty();
        } else {
          prop = this.parsePropertyDefinition(refExpressionErrors);
          this.checkProto(prop, isRecord, propHash, refExpressionErrors);
        }
        if (
          isRecord &&
          !this.isObjectProperty(prop) &&
          prop.type !== 'SpreadElement'
        ) {
          this.raise(Errors.InvalidRecordProperty, prop);
        }
        {
          if (prop.shorthand) {
            this.addExtra(prop, 'shorthand', true);
          }
        }
        node.properties.push(prop);
      }
      this.next();
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let type = 'ObjectExpression';
      if (isPattern) {
        type = 'ObjectPattern';
      } else if (isRecord) {
        type = 'RecordExpression';
      }
      return this.finishNode(node, type);
    }
    addTrailingCommaExtraToNode(node) {
      this.addExtra(node, 'trailingComma', this.state.lastTokStartLoc.index);
      this.addExtra(
        node,
        'trailingCommaLoc',
        this.state.lastTokStartLoc,
        false
      );
    }
    maybeAsyncOrAccessorProp(prop) {
      return (
        !prop.computed &&
        prop.key.type === 'Identifier' &&
        (this.isLiteralPropertyName() || this.match(0) || this.match(55))
      );
    }
    parsePropertyDefinition(refExpressionErrors) {
      let decorators = [];
      if (this.match(26)) {
        if (this.hasPlugin('decorators')) {
          this.raise(Errors.UnsupportedPropertyDecorator, this.state.startLoc);
        }
        while (this.match(26)) {
          decorators.push(this.parseDecorator());
        }
      }
      const prop = this.startNode();
      let isAsync = false;
      let isAccessor = false;
      let startLoc;
      if (this.match(21)) {
        if (decorators.length) this.unexpected();
        return this.parseSpread();
      }
      if (decorators.length) {
        prop.decorators = decorators;
        decorators = [];
      }
      prop.method = false;
      if (refExpressionErrors) {
        startLoc = this.state.startLoc;
      }
      let isGenerator = this.eat(55);
      this.parsePropertyNamePrefixOperator(prop);
      const containsEsc = this.state.containsEsc;
      this.parsePropertyName(prop, refExpressionErrors);
      if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
        const {key: key} = prop;
        const keyName = key.name;
        if (keyName === 'async' && !this.hasPrecedingLineBreak()) {
          isAsync = true;
          this.resetPreviousNodeTrailingComments(key);
          isGenerator = this.eat(55);
          this.parsePropertyName(prop);
        }
        if (keyName === 'get' || keyName === 'set') {
          isAccessor = true;
          this.resetPreviousNodeTrailingComments(key);
          prop.kind = keyName;
          if (this.match(55)) {
            isGenerator = true;
            this.raise(Errors.AccessorIsGenerator, this.state.curPosition(), {
              kind: keyName,
            });
            this.next();
          }
          this.parsePropertyName(prop);
        }
      }
      return this.parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        false,
        isAccessor,
        refExpressionErrors
      );
    }
    getGetterSetterExpectedParamCount(method) {
      return method.kind === 'get' ? 0 : 1;
    }
    getObjectOrClassMethodParams(method) {
      return method.params;
    }
    checkGetterSetterParams(method) {
      var _params;
      const paramCount = this.getGetterSetterExpectedParamCount(method);
      const params = this.getObjectOrClassMethodParams(method);
      if (params.length !== paramCount) {
        this.raise(
          method.kind === 'get' ? Errors.BadGetterArity : Errors.BadSetterArity,
          method
        );
      }
      if (
        method.kind === 'set' &&
        ((_params = params[params.length - 1]) == null
          ? void 0
          : _params.type) === 'RestElement'
      ) {
        this.raise(Errors.BadSetterRestParameter, method);
      }
    }
    parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
      if (isAccessor) {
        const finishedProp = this.parseMethod(
          prop,
          isGenerator,
          false,
          false,
          false,
          'ObjectMethod'
        );
        this.checkGetterSetterParams(finishedProp);
        return finishedProp;
      }
      if (isAsync || isGenerator || this.match(10)) {
        if (isPattern) this.unexpected();
        prop.kind = 'method';
        prop.method = true;
        return this.parseMethod(
          prop,
          isGenerator,
          isAsync,
          false,
          false,
          'ObjectMethod'
        );
      }
    }
    parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
      prop.shorthand = false;
      if (this.eat(14)) {
        prop.value = isPattern
          ? this.parseMaybeDefault(this.state.startLoc)
          : this.parseMaybeAssignAllowIn(refExpressionErrors);
        return this.finishNode(prop, 'ObjectProperty');
      }
      if (!prop.computed && prop.key.type === 'Identifier') {
        this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
        if (isPattern) {
          prop.value = this.parseMaybeDefault(
            startLoc,
            cloneIdentifier(prop.key)
          );
        } else if (this.match(29)) {
          const shorthandAssignLoc = this.state.startLoc;
          if (refExpressionErrors != null) {
            if (refExpressionErrors.shorthandAssignLoc === null) {
              refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
            }
          } else {
            this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
          }
          prop.value = this.parseMaybeDefault(
            startLoc,
            cloneIdentifier(prop.key)
          );
        } else {
          prop.value = cloneIdentifier(prop.key);
        }
        prop.shorthand = true;
        return this.finishNode(prop, 'ObjectProperty');
      }
    }
    parseObjPropValue(
      prop,
      startLoc,
      isGenerator,
      isAsync,
      isPattern,
      isAccessor,
      refExpressionErrors
    ) {
      const node =
        this.parseObjectMethod(
          prop,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor
        ) ||
        this.parseObjectProperty(
          prop,
          startLoc,
          isPattern,
          refExpressionErrors
        );
      if (!node) this.unexpected();
      return node;
    }
    parsePropertyName(prop, refExpressionErrors) {
      if (this.eat(0)) {
        prop.computed = true;
        prop.key = this.parseMaybeAssignAllowIn();
        this.expect(3);
      } else {
        const {type: type, value: value} = this.state;
        let key;
        if (tokenIsKeywordOrIdentifier(type)) {
          key = this.parseIdentifier(true);
        } else {
          switch (type) {
            case 135:
              key = this.parseNumericLiteral(value);
              break;
            case 134:
              key = this.parseStringLiteral(value);
              break;
            case 136:
              key = this.parseBigIntLiteral(value);
              break;
            case 139: {
              const privateKeyLoc = this.state.startLoc;
              if (refExpressionErrors != null) {
                if (refExpressionErrors.privateKeyLoc === null) {
                  refExpressionErrors.privateKeyLoc = privateKeyLoc;
                }
              } else {
                this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
              }
              key = this.parsePrivateName();
              break;
            }
            default:
              if (type === 137) {
                key = this.parseDecimalLiteral(value);
                break;
              }
              this.unexpected();
          }
        }
        prop.key = key;
        if (type !== 139) {
          prop.computed = false;
        }
      }
    }
    initFunction(node, isAsync) {
      node.id = null;
      node.generator = false;
      node.async = isAsync;
    }
    parseMethod(
      node,
      isGenerator,
      isAsync,
      isConstructor,
      allowDirectSuper,
      type,
      inClassScope = false
    ) {
      this.initFunction(node, isAsync);
      node.generator = isGenerator;
      this.scope.enter(
        2 | 16 | (inClassScope ? 64 : 0) | (allowDirectSuper ? 32 : 0)
      );
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      this.parseFunctionParams(node, isConstructor);
      const finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
      this.prodParam.exit();
      this.scope.exit();
      return finishedNode;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      if (isTuple) {
        this.expectPlugin('recordAndTuple');
      }
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const node = this.startNode();
      this.next();
      node.elements = this.parseExprList(
        close,
        !isTuple,
        refExpressionErrors,
        node
      );
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return this.finishNode(
        node,
        isTuple ? 'TupleExpression' : 'ArrayExpression'
      );
    }
    parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
      this.scope.enter(2 | 4);
      let flags = functionFlags(isAsync, false);
      if (!this.match(5) && this.prodParam.hasIn) {
        flags |= 8;
      }
      this.prodParam.enter(flags);
      this.initFunction(node, isAsync);
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      if (params) {
        this.state.maybeInArrowParameters = true;
        this.setArrowFunctionParameters(node, params, trailingCommaLoc);
      }
      this.state.maybeInArrowParameters = false;
      this.parseFunctionBody(node, true);
      this.prodParam.exit();
      this.scope.exit();
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return this.finishNode(node, 'ArrowFunctionExpression');
    }
    setArrowFunctionParameters(node, params, trailingCommaLoc) {
      this.toAssignableList(params, trailingCommaLoc, false);
      node.params = params;
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      this.parseFunctionBody(node, false, isMethod);
      return this.finishNode(node, type);
    }
    parseFunctionBody(node, allowExpression, isMethod = false) {
      const isExpression = allowExpression && !this.match(5);
      this.expressionScope.enter(newExpressionScope());
      if (isExpression) {
        node.body = this.parseMaybeAssign();
        this.checkParams(node, false, allowExpression, false);
      } else {
        const oldStrict = this.state.strict;
        const oldLabels = this.state.labels;
        this.state.labels = [];
        this.prodParam.enter(this.prodParam.currentFlags() | 4);
        node.body = this.parseBlock(true, false, hasStrictModeDirective => {
          const nonSimple = !this.isSimpleParamList(node.params);
          if (hasStrictModeDirective && nonSimple) {
            this.raise(
              Errors.IllegalLanguageModeDirective,
              (node.kind === 'method' || node.kind === 'constructor') &&
                !!node.key
                ? node.key.loc.end
                : node
            );
          }
          const strictModeChanged = !oldStrict && this.state.strict;
          this.checkParams(
            node,
            !this.state.strict && !allowExpression && !isMethod && !nonSimple,
            allowExpression,
            strictModeChanged
          );
          if (this.state.strict && node.id) {
            this.checkIdentifier(node.id, 65, strictModeChanged);
          }
        });
        this.prodParam.exit();
        this.state.labels = oldLabels;
      }
      this.expressionScope.exit();
    }
    isSimpleParameter(node) {
      return node.type === 'Identifier';
    }
    isSimpleParamList(params) {
      for (let i = 0, len = params.length; i < len; i++) {
        if (!this.isSimpleParameter(params[i])) return false;
      }
      return true;
    }
    checkParams(
      node,
      allowDuplicates,
      isArrowFunction,
      strictModeChanged = true
    ) {
      const checkClashes = !allowDuplicates && new Set();
      const formalParameters = {type: 'FormalParameters'};
      for (const param of node.params) {
        this.checkLVal(
          param,
          formalParameters,
          5,
          checkClashes,
          strictModeChanged
        );
      }
    }
    parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
      }
      return elts;
    }
    parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
      let elt;
      if (this.match(12)) {
        if (!allowEmpty) {
          this.raise(Errors.UnexpectedToken, this.state.curPosition(), {
            unexpected: ',',
          });
        }
        elt = null;
      } else if (this.match(21)) {
        const spreadNodeStartLoc = this.state.startLoc;
        elt = this.parseParenItem(
          this.parseSpread(refExpressionErrors),
          spreadNodeStartLoc
        );
      } else if (this.match(17)) {
        this.expectPlugin('partialApplication');
        if (!allowPlaceholder) {
          this.raise(Errors.UnexpectedArgumentPlaceholder, this.state.startLoc);
        }
        const node = this.startNode();
        this.next();
        elt = this.finishNode(node, 'ArgumentPlaceholder');
      } else {
        elt = this.parseMaybeAssignAllowIn(
          refExpressionErrors,
          this.parseParenItem
        );
      }
      return elt;
    }
    parseIdentifier(liberal) {
      const node = this.startNode();
      const name = this.parseIdentifierName(liberal);
      return this.createIdentifier(node, name);
    }
    createIdentifier(node, name) {
      node.name = name;
      node.loc.identifierName = name;
      return this.finishNode(node, 'Identifier');
    }
    parseIdentifierName(liberal) {
      let name;
      const {startLoc: startLoc, type: type} = this.state;
      if (tokenIsKeywordOrIdentifier(type)) {
        name = this.state.value;
      } else {
        this.unexpected();
      }
      const tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);
      if (liberal) {
        if (tokenIsKeyword) {
          this.replaceToken(132);
        }
      } else {
        this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
      }
      this.next();
      return name;
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (word.length > 10) {
        return;
      }
      if (!canBeReservedWord(word)) {
        return;
      }
      if (checkKeywords && isKeyword(word)) {
        this.raise(Errors.UnexpectedKeyword, startLoc, {keyword: word});
        return;
      }
      const reservedTest = !this.state.strict
        ? isReservedWord
        : isBinding
          ? isStrictBindReservedWord
          : isStrictReservedWord;
      if (reservedTest(word, this.inModule)) {
        this.raise(Errors.UnexpectedReservedWord, startLoc, {
          reservedWord: word,
        });
        return;
      } else if (word === 'yield') {
        if (this.prodParam.hasYield) {
          this.raise(Errors.YieldBindingIdentifier, startLoc);
          return;
        }
      } else if (word === 'await') {
        if (this.prodParam.hasAwait) {
          this.raise(Errors.AwaitBindingIdentifier, startLoc);
          return;
        }
        if (this.scope.inStaticBlock) {
          this.raise(Errors.AwaitBindingIdentifierInStaticBlock, startLoc);
          return;
        }
        this.expressionScope.recordAsyncArrowParametersError(startLoc);
      } else if (word === 'arguments') {
        if (this.scope.inClassAndNotInNonArrowFunction) {
          this.raise(Errors.ArgumentsInClass, startLoc);
          return;
        }
      }
    }
    recordAwaitIfAllowed() {
      const isAwaitAllowed =
        this.prodParam.hasAwait ||
        (this.options.allowAwaitOutsideFunction && !this.scope.inFunction);
      if (isAwaitAllowed && !this.scope.inFunction) {
        this.state.hasTopLevelAwait = true;
      }
      return isAwaitAllowed;
    }
    parseAwait(startLoc) {
      const node = this.startNodeAt(startLoc);
      this.expressionScope.recordParameterInitializerError(
        Errors.AwaitExpressionFormalParameter,
        node
      );
      if (this.eat(55)) {
        this.raise(Errors.ObsoleteAwaitStar, node);
      }
      if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
        if (this.isAmbiguousAwait()) {
          this.ambiguousScriptDifferentAst = true;
        } else {
          this.sawUnambiguousESM = true;
        }
      }
      if (!this.state.soloAwait) {
        node.argument = this.parseMaybeUnary(null, true);
      }
      return this.finishNode(node, 'AwaitExpression');
    }
    isAmbiguousAwait() {
      if (this.hasPrecedingLineBreak()) return true;
      const {type: type} = this.state;
      return (
        type === 53 ||
        type === 10 ||
        type === 0 ||
        tokenIsTemplate(type) ||
        (type === 102 && !this.state.containsEsc) ||
        type === 138 ||
        type === 56 ||
        (this.hasPlugin('v8intrinsic') && type === 54)
      );
    }
    parseYield() {
      const node = this.startNode();
      this.expressionScope.recordParameterInitializerError(
        Errors.YieldInParameter,
        node
      );
      this.next();
      let delegating = false;
      let argument = null;
      if (!this.hasPrecedingLineBreak()) {
        delegating = this.eat(55);
        switch (this.state.type) {
          case 13:
          case 140:
          case 8:
          case 11:
          case 3:
          case 9:
          case 14:
          case 12:
            if (!delegating) break;
          default:
            argument = this.parseMaybeAssign();
        }
      }
      node.delegate = delegating;
      node.argument = argument;
      return this.finishNode(node, 'YieldExpression');
    }
    parseImportCall(node) {
      this.next();
      node.source = this.parseMaybeAssignAllowIn();
      node.options = null;
      if (this.eat(12)) {
        if (!this.match(11)) {
          node.options = this.parseMaybeAssignAllowIn();
          if (this.eat(12) && !this.match(11)) {
            do {
              this.parseMaybeAssignAllowIn();
            } while (this.eat(12) && !this.match(11));
            this.raise(Errors.ImportCallArity, node);
          }
        }
      }
      this.expect(11);
      return this.finishNode(node, 'ImportExpression');
    }
    checkPipelineAtInfixOperator(left, leftStartLoc) {
      if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
        if (left.type === 'SequenceExpression') {
          this.raise(Errors.PipelineHeadSequenceExpression, leftStartLoc);
        }
      }
    }
    parseSmartPipelineBodyInStyle(childExpr, startLoc) {
      if (this.isSimpleReference(childExpr)) {
        const bodyNode = this.startNodeAt(startLoc);
        bodyNode.callee = childExpr;
        return this.finishNode(bodyNode, 'PipelineBareFunction');
      } else {
        const bodyNode = this.startNodeAt(startLoc);
        this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
        bodyNode.expression = childExpr;
        return this.finishNode(bodyNode, 'PipelineTopicExpression');
      }
    }
    isSimpleReference(expression) {
      switch (expression.type) {
        case 'MemberExpression':
          return (
            !expression.computed && this.isSimpleReference(expression.object)
          );
        case 'Identifier':
          return true;
        default:
          return false;
      }
    }
    checkSmartPipeTopicBodyEarlyErrors(startLoc) {
      if (this.match(19)) {
        throw this.raise(Errors.PipelineBodyNoArrow, this.state.startLoc);
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipelineTopicUnused, startLoc);
      }
    }
    withTopicBindingContext(callback) {
      const outerContextTopicState = this.state.topicContext;
      this.state.topicContext = {
        maxNumOfResolvableTopics: 1,
        maxTopicIndex: null,
      };
      try {
        return callback();
      } finally {
        this.state.topicContext = outerContextTopicState;
      }
    }
    withSmartMixTopicForbiddingContext(callback) {
      if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
        const outerContextTopicState = this.state.topicContext;
        this.state.topicContext = {
          maxNumOfResolvableTopics: 0,
          maxTopicIndex: null,
        };
        try {
          return callback();
        } finally {
          this.state.topicContext = outerContextTopicState;
        }
      } else {
        return callback();
      }
    }
    withSoloAwaitPermittingContext(callback) {
      const outerContextSoloAwaitState = this.state.soloAwait;
      this.state.soloAwait = true;
      try {
        return callback();
      } finally {
        this.state.soloAwait = outerContextSoloAwaitState;
      }
    }
    allowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToSet = 8 & ~flags;
      if (prodParamToSet) {
        this.prodParam.enter(flags | 8);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    disallowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToClear = 8 & flags;
      if (prodParamToClear) {
        this.prodParam.enter(flags & ~8);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    registerTopicReference() {
      this.state.topicContext.maxTopicIndex = 0;
    }
    topicReferenceIsAllowedInCurrentContext() {
      return this.state.topicContext.maxNumOfResolvableTopics >= 1;
    }
    topicReferenceWasUsedInCurrentContext() {
      return (
        this.state.topicContext.maxTopicIndex != null &&
        this.state.topicContext.maxTopicIndex >= 0
      );
    }
    parseFSharpPipelineBody(prec) {
      const startLoc = this.state.startLoc;
      this.state.potentialArrowAt = this.state.start;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = true;
      const ret = this.parseExprOp(
        this.parseMaybeUnaryOrPrivate(),
        startLoc,
        prec
      );
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return ret;
    }
    parseModuleExpression() {
      this.expectPlugin('moduleBlocks');
      const node = this.startNode();
      this.next();
      if (!this.match(5)) {
        this.unexpected(null, 5);
      }
      const program = this.startNodeAt(this.state.endLoc);
      this.next();
      const revertScopes = this.initializeScopes(true);
      this.enterInitialScopes();
      try {
        node.body = this.parseProgram(program, 8, 'module');
      } finally {
        revertScopes();
      }
      return this.finishNode(node, 'ModuleExpression');
    }
    parsePropertyNamePrefixOperator(prop) {}
  }
  const loopLabel = {kind: 1},
    switchLabel = {kind: 2};
  const loneSurrogate = /[\uD800-\uDFFF]/u;
  const keywordRelationalOperator = /in(?:stanceof)?/y;
  function babel7CompatTokens(tokens, input, startIndex) {
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      const {type: type} = token;
      if (typeof type === 'number') {
        {
          if (type === 139) {
            const {loc: loc, start: start, value: value, end: end} = token;
            const hashEndPos = start + 1;
            const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
            tokens.splice(
              i,
              1,
              new Token({
                type: getExportedToken(27),
                value: '#',
                start: start,
                end: hashEndPos,
                startLoc: loc.start,
                endLoc: hashEndLoc,
              }),
              new Token({
                type: getExportedToken(132),
                value: value,
                start: hashEndPos,
                end: end,
                startLoc: hashEndLoc,
                endLoc: loc.end,
              })
            );
            i++;
            continue;
          }
          if (tokenIsTemplate(type)) {
            const {loc: loc, start: start, value: value, end: end} = token;
            const backquoteEnd = start + 1;
            const backquoteEndLoc = createPositionWithColumnOffset(
              loc.start,
              1
            );
            let startToken;
            if (input.charCodeAt(start - startIndex) === 96) {
              startToken = new Token({
                type: getExportedToken(22),
                value: '`',
                start: start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc,
              });
            } else {
              startToken = new Token({
                type: getExportedToken(8),
                value: '}',
                start: start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc,
              });
            }
            let templateValue,
              templateElementEnd,
              templateElementEndLoc,
              endToken;
            if (type === 24) {
              templateElementEnd = end - 1;
              templateElementEndLoc = createPositionWithColumnOffset(
                loc.end,
                -1
              );
              templateValue = value === null ? null : value.slice(1, -1);
              endToken = new Token({
                type: getExportedToken(22),
                value: '`',
                start: templateElementEnd,
                end: end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end,
              });
            } else {
              templateElementEnd = end - 2;
              templateElementEndLoc = createPositionWithColumnOffset(
                loc.end,
                -2
              );
              templateValue = value === null ? null : value.slice(1, -2);
              endToken = new Token({
                type: getExportedToken(23),
                value: '${',
                start: templateElementEnd,
                end: end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end,
              });
            }
            tokens.splice(
              i,
              1,
              startToken,
              new Token({
                type: getExportedToken(20),
                value: templateValue,
                start: backquoteEnd,
                end: templateElementEnd,
                startLoc: backquoteEndLoc,
                endLoc: templateElementEndLoc,
              }),
              endToken
            );
            i += 2;
            continue;
          }
        }
        token.type = getExportedToken(type);
      }
    }
    return tokens;
  }
  class StatementParser extends ExpressionParser {
    parseTopLevel(file, program) {
      file.program = this.parseProgram(program);
      file.comments = this.comments;
      if (this.options.tokens) {
        file.tokens = babel7CompatTokens(
          this.tokens,
          this.input,
          this.startIndex
        );
      }
      return this.finishNode(file, 'File');
    }
    parseProgram(program, end = 140, sourceType = this.options.sourceType) {
      program.sourceType = sourceType;
      program.interpreter = this.parseInterpreterDirective();
      this.parseBlockBody(program, true, true, end);
      if (this.inModule) {
        if (
          !this.options.allowUndeclaredExports &&
          this.scope.undefinedExports.size > 0
        ) {
          for (const [localName, at] of Array.from(
            this.scope.undefinedExports
          )) {
            this.raise(Errors.ModuleExportUndefined, at, {
              localName: localName,
            });
          }
        }
        this.addExtra(program, 'topLevelAwait', this.state.hasTopLevelAwait);
      }
      let finishedProgram;
      if (end === 140) {
        finishedProgram = this.finishNode(program, 'Program');
      } else {
        finishedProgram = this.finishNodeAt(
          program,
          'Program',
          createPositionWithColumnOffset(this.state.startLoc, -1)
        );
      }
      return finishedProgram;
    }
    stmtToDirective(stmt) {
      const directive = stmt;
      directive.type = 'Directive';
      directive.value = directive.expression;
      delete directive.expression;
      const directiveLiteral = directive.value;
      const expressionValue = directiveLiteral.value;
      const raw = this.input.slice(
        this.offsetToSourcePos(directiveLiteral.start),
        this.offsetToSourcePos(directiveLiteral.end)
      );
      const val = (directiveLiteral.value = raw.slice(1, -1));
      this.addExtra(directiveLiteral, 'raw', raw);
      this.addExtra(directiveLiteral, 'rawValue', val);
      this.addExtra(directiveLiteral, 'expressionValue', expressionValue);
      directiveLiteral.type = 'DirectiveLiteral';
      return directive;
    }
    parseInterpreterDirective() {
      if (!this.match(28)) {
        return null;
      }
      const node = this.startNode();
      node.value = this.state.value;
      this.next();
      return this.finishNode(node, 'InterpreterDirective');
    }
    isLet() {
      if (!this.isContextual(100)) {
        return false;
      }
      return this.hasFollowingBindingAtom();
    }
    chStartsBindingIdentifier(ch, pos) {
      if (isIdentifierStart(ch)) {
        keywordRelationalOperator.lastIndex = pos;
        if (keywordRelationalOperator.test(this.input)) {
          const endCh = this.codePointAtPos(
            keywordRelationalOperator.lastIndex
          );
          if (!isIdentifierChar(endCh) && endCh !== 92) {
            return false;
          }
        }
        return true;
      } else if (ch === 92) {
        return true;
      } else {
        return false;
      }
    }
    chStartsBindingPattern(ch) {
      return ch === 91 || ch === 123;
    }
    hasFollowingBindingAtom() {
      const next = this.nextTokenStart();
      const nextCh = this.codePointAtPos(next);
      return (
        this.chStartsBindingPattern(nextCh) ||
        this.chStartsBindingIdentifier(nextCh, next)
      );
    }
    hasInLineFollowingBindingIdentifierOrBrace() {
      const next = this.nextTokenInLineStart();
      const nextCh = this.codePointAtPos(next);
      return nextCh === 123 || this.chStartsBindingIdentifier(nextCh, next);
    }
    startsUsingForOf() {
      const {type: type, containsEsc: containsEsc} = this.lookahead();
      if (type === 102 && !containsEsc) {
        return false;
      } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
        this.expectPlugin('explicitResourceManagement');
        return true;
      }
    }
    startsAwaitUsing() {
      let next = this.nextTokenInLineStart();
      if (this.isUnparsedContextual(next, 'using')) {
        next = this.nextTokenInLineStartSince(next + 5);
        const nextCh = this.codePointAtPos(next);
        if (this.chStartsBindingIdentifier(nextCh, next)) {
          this.expectPlugin('explicitResourceManagement');
          return true;
        }
      }
      return false;
    }
    parseModuleItem() {
      return this.parseStatementLike(1 | 2 | 4 | 8);
    }
    parseStatementListItem() {
      return this.parseStatementLike(
        2 | 4 | (!this.options.annexB || this.state.strict ? 0 : 8)
      );
    }
    parseStatementOrSloppyAnnexBFunctionDeclaration(
      allowLabeledFunction = false
    ) {
      let flags = 0;
      if (this.options.annexB && !this.state.strict) {
        flags |= 4;
        if (allowLabeledFunction) {
          flags |= 8;
        }
      }
      return this.parseStatementLike(flags);
    }
    parseStatement() {
      return this.parseStatementLike(0);
    }
    parseStatementLike(flags) {
      let decorators = null;
      if (this.match(26)) {
        decorators = this.parseDecorators(true);
      }
      return this.parseStatementContent(flags, decorators);
    }
    parseStatementContent(flags, decorators) {
      const startType = this.state.type;
      const node = this.startNode();
      const allowDeclaration = !!(flags & 2);
      const allowFunctionDeclaration = !!(flags & 4);
      const topLevel = flags & 1;
      switch (startType) {
        case 60:
          return this.parseBreakContinueStatement(node, true);
        case 63:
          return this.parseBreakContinueStatement(node, false);
        case 64:
          return this.parseDebuggerStatement(node);
        case 90:
          return this.parseDoWhileStatement(node);
        case 91:
          return this.parseForStatement(node);
        case 68:
          if (this.lookaheadCharCode() === 46) break;
          if (!allowFunctionDeclaration) {
            this.raise(
              this.state.strict
                ? Errors.StrictFunction
                : this.options.annexB
                  ? Errors.SloppyFunctionAnnexB
                  : Errors.SloppyFunction,
              this.state.startLoc
            );
          }
          return this.parseFunctionStatement(
            node,
            false,
            !allowDeclaration && allowFunctionDeclaration
          );
        case 80:
          if (!allowDeclaration) this.unexpected();
          return this.parseClass(
            this.maybeTakeDecorators(decorators, node),
            true
          );
        case 69:
          return this.parseIfStatement(node);
        case 70:
          return this.parseReturnStatement(node);
        case 71:
          return this.parseSwitchStatement(node);
        case 72:
          return this.parseThrowStatement(node);
        case 73:
          return this.parseTryStatement(node);
        case 96:
          if (!this.state.containsEsc && this.startsAwaitUsing()) {
            if (!this.recordAwaitIfAllowed()) {
              this.raise(Errors.AwaitUsingNotInAsyncContext, node);
            } else if (!allowDeclaration) {
              this.raise(Errors.UnexpectedLexicalDeclaration, node);
            }
            this.next();
            return this.parseVarStatement(node, 'await using');
          }
          break;
        case 107:
          if (
            this.state.containsEsc ||
            !this.hasInLineFollowingBindingIdentifierOrBrace()
          ) {
            break;
          }
          this.expectPlugin('explicitResourceManagement');
          if (!this.scope.inModule && this.scope.inTopLevel) {
            this.raise(Errors.UnexpectedUsingDeclaration, this.state.startLoc);
          } else if (!allowDeclaration) {
            this.raise(
              Errors.UnexpectedLexicalDeclaration,
              this.state.startLoc
            );
          }
          return this.parseVarStatement(node, 'using');
        case 100: {
          if (this.state.containsEsc) {
            break;
          }
          const next = this.nextTokenStart();
          const nextCh = this.codePointAtPos(next);
          if (nextCh !== 91) {
            if (!allowDeclaration && this.hasFollowingLineBreak()) break;
            if (
              !this.chStartsBindingIdentifier(nextCh, next) &&
              nextCh !== 123
            ) {
              break;
            }
          }
        }
        case 75: {
          if (!allowDeclaration) {
            this.raise(
              Errors.UnexpectedLexicalDeclaration,
              this.state.startLoc
            );
          }
        }
        case 74: {
          const kind = this.state.value;
          return this.parseVarStatement(node, kind);
        }
        case 92:
          return this.parseWhileStatement(node);
        case 76:
          return this.parseWithStatement(node);
        case 5:
          return this.parseBlock();
        case 13:
          return this.parseEmptyStatement(node);
        case 83: {
          const nextTokenCharCode = this.lookaheadCharCode();
          if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
            break;
          }
        }
        case 82: {
          if (!this.options.allowImportExportEverywhere && !topLevel) {
            this.raise(Errors.UnexpectedImportExport, this.state.startLoc);
          }
          this.next();
          let result;
          if (startType === 83) {
            result = this.parseImport(node);
            if (
              result.type === 'ImportDeclaration' &&
              (!result.importKind || result.importKind === 'value')
            ) {
              this.sawUnambiguousESM = true;
            }
          } else {
            result = this.parseExport(node, decorators);
            if (
              (result.type === 'ExportNamedDeclaration' &&
                (!result.exportKind || result.exportKind === 'value')) ||
              (result.type === 'ExportAllDeclaration' &&
                (!result.exportKind || result.exportKind === 'value')) ||
              result.type === 'ExportDefaultDeclaration'
            ) {
              this.sawUnambiguousESM = true;
            }
          }
          this.assertModuleNodeAllowed(result);
          return result;
        }
        default: {
          if (this.isAsyncFunction()) {
            if (!allowDeclaration) {
              this.raise(
                Errors.AsyncFunctionInSingleStatementContext,
                this.state.startLoc
              );
            }
            this.next();
            return this.parseFunctionStatement(
              node,
              true,
              !allowDeclaration && allowFunctionDeclaration
            );
          }
        }
      }
      const maybeName = this.state.value;
      const expr = this.parseExpression();
      if (
        tokenIsIdentifier(startType) &&
        expr.type === 'Identifier' &&
        this.eat(14)
      ) {
        return this.parseLabeledStatement(node, maybeName, expr, flags);
      } else {
        return this.parseExpressionStatement(node, expr, decorators);
      }
    }
    assertModuleNodeAllowed(node) {
      if (!this.options.allowImportExportEverywhere && !this.inModule) {
        this.raise(Errors.ImportOutsideModule, node);
      }
    }
    decoratorsEnabledBeforeExport() {
      if (this.hasPlugin('decorators-legacy')) return true;
      return (
        this.hasPlugin('decorators') &&
        this.getPluginOption('decorators', 'decoratorsBeforeExport') !== false
      );
    }
    maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
      if (maybeDecorators) {
        if (classNode.decorators && classNode.decorators.length > 0) {
          if (
            typeof this.getPluginOption(
              'decorators',
              'decoratorsBeforeExport'
            ) !== 'boolean'
          ) {
            this.raise(
              Errors.DecoratorsBeforeAfterExport,
              classNode.decorators[0]
            );
          }
          classNode.decorators.unshift(...maybeDecorators);
        } else {
          classNode.decorators = maybeDecorators;
        }
        this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
        if (exportNode) this.resetStartLocationFromNode(exportNode, classNode);
      }
      return classNode;
    }
    canHaveLeadingDecorator() {
      return this.match(80);
    }
    parseDecorators(allowExport) {
      const decorators = [];
      do {
        decorators.push(this.parseDecorator());
      } while (this.match(26));
      if (this.match(82)) {
        if (!allowExport) {
          this.unexpected();
        }
        if (!this.decoratorsEnabledBeforeExport()) {
          this.raise(Errors.DecoratorExportClass, this.state.startLoc);
        }
      } else if (!this.canHaveLeadingDecorator()) {
        throw this.raise(
          Errors.UnexpectedLeadingDecorator,
          this.state.startLoc
        );
      }
      return decorators;
    }
    parseDecorator() {
      this.expectOnePlugin(['decorators', 'decorators-legacy']);
      const node = this.startNode();
      this.next();
      if (this.hasPlugin('decorators')) {
        const startLoc = this.state.startLoc;
        let expr;
        if (this.match(10)) {
          const startLoc = this.state.startLoc;
          this.next();
          expr = this.parseExpression();
          this.expect(11);
          expr = this.wrapParenthesis(startLoc, expr);
          const paramsStartLoc = this.state.startLoc;
          node.expression = this.parseMaybeDecoratorArguments(expr);
          if (
            this.getPluginOption('decorators', 'allowCallParenthesized') ===
              false &&
            node.expression !== expr
          ) {
            this.raise(
              Errors.DecoratorArgumentsOutsideParentheses,
              paramsStartLoc
            );
          }
        } else {
          expr = this.parseIdentifier(false);
          while (this.eat(16)) {
            const node = this.startNodeAt(startLoc);
            node.object = expr;
            if (this.match(139)) {
              this.classScope.usePrivateName(
                this.state.value,
                this.state.startLoc
              );
              node.property = this.parsePrivateName();
            } else {
              node.property = this.parseIdentifier(true);
            }
            node.computed = false;
            expr = this.finishNode(node, 'MemberExpression');
          }
          node.expression = this.parseMaybeDecoratorArguments(expr);
        }
      } else {
        node.expression = this.parseExprSubscripts();
      }
      return this.finishNode(node, 'Decorator');
    }
    parseMaybeDecoratorArguments(expr) {
      if (this.eat(10)) {
        const node = this.startNodeAtNode(expr);
        node.callee = expr;
        node.arguments = this.parseCallExpressionArguments(11);
        this.toReferencedList(node.arguments);
        return this.finishNode(node, 'CallExpression');
      }
      return expr;
    }
    parseBreakContinueStatement(node, isBreak) {
      this.next();
      if (this.isLineTerminator()) {
        node.label = null;
      } else {
        node.label = this.parseIdentifier();
        this.semicolon();
      }
      this.verifyBreakContinue(node, isBreak);
      return this.finishNode(
        node,
        isBreak ? 'BreakStatement' : 'ContinueStatement'
      );
    }
    verifyBreakContinue(node, isBreak) {
      let i;
      for (i = 0; i < this.state.labels.length; ++i) {
        const lab = this.state.labels[i];
        if (node.label == null || lab.name === node.label.name) {
          if (lab.kind != null && (isBreak || lab.kind === 1)) {
            break;
          }
          if (node.label && isBreak) break;
        }
      }
      if (i === this.state.labels.length) {
        const type = isBreak ? 'BreakStatement' : 'ContinueStatement';
        this.raise(Errors.IllegalBreakContinue, node, {type: type});
      }
    }
    parseDebuggerStatement(node) {
      this.next();
      this.semicolon();
      return this.finishNode(node, 'DebuggerStatement');
    }
    parseHeaderExpression() {
      this.expect(10);
      const val = this.parseExpression();
      this.expect(11);
      return val;
    }
    parseDoWhileStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.state.labels.pop();
      this.expect(92);
      node.test = this.parseHeaderExpression();
      this.eat(13);
      return this.finishNode(node, 'DoWhileStatement');
    }
    parseForStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      let awaitAt = null;
      if (this.isContextual(96) && this.recordAwaitIfAllowed()) {
        awaitAt = this.state.startLoc;
        this.next();
      }
      this.scope.enter(0);
      this.expect(10);
      if (this.match(13)) {
        if (awaitAt !== null) {
          this.unexpected(awaitAt);
        }
        return this.parseFor(node, null);
      }
      const startsWithLet = this.isContextual(100);
      {
        const startsWithAwaitUsing =
          this.isContextual(96) && this.startsAwaitUsing();
        const starsWithUsingDeclaration =
          startsWithAwaitUsing ||
          (this.isContextual(107) && this.startsUsingForOf());
        const isLetOrUsing =
          (startsWithLet && this.hasFollowingBindingAtom()) ||
          starsWithUsingDeclaration;
        if (this.match(74) || this.match(75) || isLetOrUsing) {
          const initNode = this.startNode();
          let kind;
          if (startsWithAwaitUsing) {
            kind = 'await using';
            if (!this.recordAwaitIfAllowed()) {
              this.raise(
                Errors.AwaitUsingNotInAsyncContext,
                this.state.startLoc
              );
            }
            this.next();
          } else {
            kind = this.state.value;
          }
          this.next();
          this.parseVar(initNode, true, kind);
          const init = this.finishNode(initNode, 'VariableDeclaration');
          const isForIn = this.match(58);
          if (isForIn && starsWithUsingDeclaration) {
            this.raise(Errors.ForInUsing, init);
          }
          if (
            (isForIn || this.isContextual(102)) &&
            init.declarations.length === 1
          ) {
            return this.parseForIn(node, init, awaitAt);
          }
          if (awaitAt !== null) {
            this.unexpected(awaitAt);
          }
          return this.parseFor(node, init);
        }
      }
      const startsWithAsync = this.isContextual(95);
      const refExpressionErrors = new ExpressionErrors();
      const init = this.parseExpression(true, refExpressionErrors);
      const isForOf = this.isContextual(102);
      if (isForOf) {
        if (startsWithLet) {
          this.raise(Errors.ForOfLet, init);
        }
        if (awaitAt === null && startsWithAsync && init.type === 'Identifier') {
          this.raise(Errors.ForOfAsync, init);
        }
      }
      if (isForOf || this.match(58)) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.toAssignable(init, true);
        const type = isForOf ? 'ForOfStatement' : 'ForInStatement';
        this.checkLVal(init, {type: type});
        return this.parseForIn(node, init, awaitAt);
      } else {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      if (awaitAt !== null) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, init);
    }
    parseFunctionStatement(node, isAsync, isHangingDeclaration) {
      this.next();
      return this.parseFunction(
        node,
        1 | (isHangingDeclaration ? 2 : 0) | (isAsync ? 8 : 0)
      );
    }
    parseIfStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
      node.alternate = this.eat(66)
        ? this.parseStatementOrSloppyAnnexBFunctionDeclaration()
        : null;
      return this.finishNode(node, 'IfStatement');
    }
    parseReturnStatement(node) {
      if (
        !this.prodParam.hasReturn &&
        !this.options.allowReturnOutsideFunction
      ) {
        this.raise(Errors.IllegalReturn, this.state.startLoc);
      }
      this.next();
      if (this.isLineTerminator()) {
        node.argument = null;
      } else {
        node.argument = this.parseExpression();
        this.semicolon();
      }
      return this.finishNode(node, 'ReturnStatement');
    }
    parseSwitchStatement(node) {
      this.next();
      node.discriminant = this.parseHeaderExpression();
      const cases = (node.cases = []);
      this.expect(5);
      this.state.labels.push(switchLabel);
      this.scope.enter(0);
      let cur;
      for (let sawDefault; !this.match(8); ) {
        if (this.match(61) || this.match(65)) {
          const isCase = this.match(61);
          if (cur) this.finishNode(cur, 'SwitchCase');
          cases.push((cur = this.startNode()));
          cur.consequent = [];
          this.next();
          if (isCase) {
            cur.test = this.parseExpression();
          } else {
            if (sawDefault) {
              this.raise(
                Errors.MultipleDefaultsInSwitch,
                this.state.lastTokStartLoc
              );
            }
            sawDefault = true;
            cur.test = null;
          }
          this.expect(14);
        } else {
          if (cur) {
            cur.consequent.push(this.parseStatementListItem());
          } else {
            this.unexpected();
          }
        }
      }
      this.scope.exit();
      if (cur) this.finishNode(cur, 'SwitchCase');
      this.next();
      this.state.labels.pop();
      return this.finishNode(node, 'SwitchStatement');
    }
    parseThrowStatement(node) {
      this.next();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.NewlineAfterThrow, this.state.lastTokEndLoc);
      }
      node.argument = this.parseExpression();
      this.semicolon();
      return this.finishNode(node, 'ThrowStatement');
    }
    parseCatchClauseParam() {
      const param = this.parseBindingAtom();
      this.scope.enter(
        this.options.annexB && param.type === 'Identifier' ? 8 : 0
      );
      this.checkLVal(param, {type: 'CatchClause'}, 9);
      return param;
    }
    parseTryStatement(node) {
      this.next();
      node.block = this.parseBlock();
      node.handler = null;
      if (this.match(62)) {
        const clause = this.startNode();
        this.next();
        if (this.match(10)) {
          this.expect(10);
          clause.param = this.parseCatchClauseParam();
          this.expect(11);
        } else {
          clause.param = null;
          this.scope.enter(0);
        }
        clause.body = this.withSmartMixTopicForbiddingContext(() =>
          this.parseBlock(false, false)
        );
        this.scope.exit();
        node.handler = this.finishNode(clause, 'CatchClause');
      }
      node.finalizer = this.eat(67) ? this.parseBlock() : null;
      if (!node.handler && !node.finalizer) {
        this.raise(Errors.NoCatchOrFinally, node);
      }
      return this.finishNode(node, 'TryStatement');
    }
    parseVarStatement(node, kind, allowMissingInitializer = false) {
      this.next();
      this.parseVar(node, false, kind, allowMissingInitializer);
      this.semicolon();
      return this.finishNode(node, 'VariableDeclaration');
    }
    parseWhileStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.state.labels.pop();
      return this.finishNode(node, 'WhileStatement');
    }
    parseWithStatement(node) {
      if (this.state.strict) {
        this.raise(Errors.StrictWith, this.state.startLoc);
      }
      this.next();
      node.object = this.parseHeaderExpression();
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      return this.finishNode(node, 'WithStatement');
    }
    parseEmptyStatement(node) {
      this.next();
      return this.finishNode(node, 'EmptyStatement');
    }
    parseLabeledStatement(node, maybeName, expr, flags) {
      for (const label of this.state.labels) {
        if (label.name === maybeName) {
          this.raise(Errors.LabelRedeclaration, expr, {labelName: maybeName});
        }
      }
      const kind = tokenIsLoop(this.state.type) ? 1 : this.match(71) ? 2 : null;
      for (let i = this.state.labels.length - 1; i >= 0; i--) {
        const label = this.state.labels[i];
        if (label.statementStart === node.start) {
          label.statementStart = this.sourceToOffsetPos(this.state.start);
          label.kind = kind;
        } else {
          break;
        }
      }
      this.state.labels.push({
        name: maybeName,
        kind: kind,
        statementStart: this.sourceToOffsetPos(this.state.start),
      });
      node.body =
        flags & 8
          ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true)
          : this.parseStatement();
      this.state.labels.pop();
      node.label = expr;
      return this.finishNode(node, 'LabeledStatement');
    }
    parseExpressionStatement(node, expr, decorators) {
      node.expression = expr;
      this.semicolon();
      return this.finishNode(node, 'ExpressionStatement');
    }
    parseBlock(
      allowDirectives = false,
      createNewLexicalScope = true,
      afterBlockParse
    ) {
      const node = this.startNode();
      if (allowDirectives) {
        this.state.strictErrors.clear();
      }
      this.expect(5);
      if (createNewLexicalScope) {
        this.scope.enter(0);
      }
      this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
      if (createNewLexicalScope) {
        this.scope.exit();
      }
      return this.finishNode(node, 'BlockStatement');
    }
    isValidDirective(stmt) {
      return (
        stmt.type === 'ExpressionStatement' &&
        stmt.expression.type === 'StringLiteral' &&
        !stmt.expression.extra.parenthesized
      );
    }
    parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
      const body = (node.body = []);
      const directives = (node.directives = []);
      this.parseBlockOrModuleBlockBody(
        body,
        allowDirectives ? directives : undefined,
        topLevel,
        end,
        afterBlockParse
      );
    }
    parseBlockOrModuleBlockBody(
      body,
      directives,
      topLevel,
      end,
      afterBlockParse
    ) {
      const oldStrict = this.state.strict;
      let hasStrictModeDirective = false;
      let parsedNonDirective = false;
      while (!this.match(end)) {
        const stmt = topLevel
          ? this.parseModuleItem()
          : this.parseStatementListItem();
        if (directives && !parsedNonDirective) {
          if (this.isValidDirective(stmt)) {
            const directive = this.stmtToDirective(stmt);
            directives.push(directive);
            if (
              !hasStrictModeDirective &&
              directive.value.value === 'use strict'
            ) {
              hasStrictModeDirective = true;
              this.setStrict(true);
            }
            continue;
          }
          parsedNonDirective = true;
          this.state.strictErrors.clear();
        }
        body.push(stmt);
      }
      afterBlockParse == null ||
        afterBlockParse.call(this, hasStrictModeDirective);
      if (!oldStrict) {
        this.setStrict(false);
      }
      this.next();
    }
    parseFor(node, init) {
      node.init = init;
      this.semicolon(false);
      node.test = this.match(13) ? null : this.parseExpression();
      this.semicolon(false);
      node.update = this.match(11) ? null : this.parseExpression();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(node, 'ForStatement');
    }
    parseForIn(node, init, awaitAt) {
      const isForIn = this.match(58);
      this.next();
      if (isForIn) {
        if (awaitAt !== null) this.unexpected(awaitAt);
      } else {
        node.await = awaitAt !== null;
      }
      if (
        init.type === 'VariableDeclaration' &&
        init.declarations[0].init != null &&
        (!isForIn ||
          !this.options.annexB ||
          this.state.strict ||
          init.kind !== 'var' ||
          init.declarations[0].id.type !== 'Identifier')
      ) {
        this.raise(Errors.ForInOfLoopInitializer, init, {
          type: isForIn ? 'ForInStatement' : 'ForOfStatement',
        });
      }
      if (init.type === 'AssignmentPattern') {
        this.raise(Errors.InvalidLhs, init, {ancestor: {type: 'ForStatement'}});
      }
      node.left = init;
      node.right = isForIn
        ? this.parseExpression()
        : this.parseMaybeAssignAllowIn();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(
        node,
        isForIn ? 'ForInStatement' : 'ForOfStatement'
      );
    }
    parseVar(node, isFor, kind, allowMissingInitializer = false) {
      const declarations = (node.declarations = []);
      node.kind = kind;
      for (;;) {
        const decl = this.startNode();
        this.parseVarId(decl, kind);
        decl.init = !this.eat(29)
          ? null
          : isFor
            ? this.parseMaybeAssignDisallowIn()
            : this.parseMaybeAssignAllowIn();
        if (decl.init === null && !allowMissingInitializer) {
          if (
            decl.id.type !== 'Identifier' &&
            !(isFor && (this.match(58) || this.isContextual(102)))
          ) {
            this.raise(
              Errors.DeclarationMissingInitializer,
              this.state.lastTokEndLoc,
              {kind: 'destructuring'}
            );
          } else if (
            (kind === 'const' || kind === 'using' || kind === 'await using') &&
            !(this.match(58) || this.isContextual(102))
          ) {
            this.raise(
              Errors.DeclarationMissingInitializer,
              this.state.lastTokEndLoc,
              {kind: kind}
            );
          }
        }
        declarations.push(this.finishNode(decl, 'VariableDeclarator'));
        if (!this.eat(12)) break;
      }
      return node;
    }
    parseVarId(decl, kind) {
      const id = this.parseBindingAtom();
      if (kind === 'using' || kind === 'await using') {
        if (id.type === 'ArrayPattern' || id.type === 'ObjectPattern') {
          this.raise(Errors.UsingDeclarationHasBindingPattern, id.loc.start);
        }
      }
      this.checkLVal(
        id,
        {type: 'VariableDeclarator'},
        kind === 'var' ? 5 : 8201
      );
      decl.id = id;
    }
    parseAsyncFunctionExpression(node) {
      return this.parseFunction(node, 8);
    }
    parseFunction(node, flags = 0) {
      const hangingDeclaration = flags & 2;
      const isDeclaration = !!(flags & 1);
      const requireId = isDeclaration && !(flags & 4);
      const isAsync = !!(flags & 8);
      this.initFunction(node, isAsync);
      if (this.match(55)) {
        if (hangingDeclaration) {
          this.raise(
            Errors.GeneratorInSingleStatementContext,
            this.state.startLoc
          );
        }
        this.next();
        node.generator = true;
      }
      if (isDeclaration) {
        node.id = this.parseFunctionId(requireId);
      }
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      this.state.maybeInArrowParameters = false;
      this.scope.enter(2);
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      if (!isDeclaration) {
        node.id = this.parseFunctionId();
      }
      this.parseFunctionParams(node, false);
      this.withSmartMixTopicForbiddingContext(() => {
        this.parseFunctionBodyAndFinish(
          node,
          isDeclaration ? 'FunctionDeclaration' : 'FunctionExpression'
        );
      });
      this.prodParam.exit();
      this.scope.exit();
      if (isDeclaration && !hangingDeclaration) {
        this.registerFunctionStatementId(node);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return node;
    }
    parseFunctionId(requireId) {
      return requireId || tokenIsIdentifier(this.state.type)
        ? this.parseIdentifier()
        : null;
    }
    parseFunctionParams(node, isConstructor) {
      this.expect(10);
      this.expressionScope.enter(newParameterDeclarationScope());
      node.params = this.parseBindingList(11, 41, 2 | (isConstructor ? 4 : 0));
      this.expressionScope.exit();
    }
    registerFunctionStatementId(node) {
      if (!node.id) return;
      this.scope.declareName(
        node.id.name,
        !this.options.annexB ||
          this.state.strict ||
          node.generator ||
          node.async
          ? this.scope.treatFunctionsAsVar
            ? 5
            : 8201
          : 17,
        node.id.loc.start
      );
    }
    parseClass(node, isStatement, optionalId) {
      this.next();
      const oldStrict = this.state.strict;
      this.state.strict = true;
      this.parseClassId(node, isStatement, optionalId);
      this.parseClassSuper(node);
      node.body = this.parseClassBody(!!node.superClass, oldStrict);
      return this.finishNode(
        node,
        isStatement ? 'ClassDeclaration' : 'ClassExpression'
      );
    }
    isClassProperty() {
      return this.match(29) || this.match(13) || this.match(8);
    }
    isClassMethod() {
      return this.match(10);
    }
    nameIsConstructor(key) {
      return (
        (key.type === 'Identifier' && key.name === 'constructor') ||
        (key.type === 'StringLiteral' && key.value === 'constructor')
      );
    }
    isNonstaticConstructor(method) {
      return (
        !method.computed && !method.static && this.nameIsConstructor(method.key)
      );
    }
    parseClassBody(hadSuperClass, oldStrict) {
      this.classScope.enter();
      const state = {hadConstructor: false, hadSuperClass: hadSuperClass};
      let decorators = [];
      const classBody = this.startNode();
      classBody.body = [];
      this.expect(5);
      this.withSmartMixTopicForbiddingContext(() => {
        while (!this.match(8)) {
          if (this.eat(13)) {
            if (decorators.length > 0) {
              throw this.raise(
                Errors.DecoratorSemicolon,
                this.state.lastTokEndLoc
              );
            }
            continue;
          }
          if (this.match(26)) {
            decorators.push(this.parseDecorator());
            continue;
          }
          const member = this.startNode();
          if (decorators.length) {
            member.decorators = decorators;
            this.resetStartLocationFromNode(member, decorators[0]);
            decorators = [];
          }
          this.parseClassMember(classBody, member, state);
          if (
            member.kind === 'constructor' &&
            member.decorators &&
            member.decorators.length > 0
          ) {
            this.raise(Errors.DecoratorConstructor, member);
          }
        }
      });
      this.state.strict = oldStrict;
      this.next();
      if (decorators.length) {
        throw this.raise(Errors.TrailingDecorator, this.state.startLoc);
      }
      this.classScope.exit();
      return this.finishNode(classBody, 'ClassBody');
    }
    parseClassMemberFromModifier(classBody, member) {
      const key = this.parseIdentifier(true);
      if (this.isClassMethod()) {
        const method = member;
        method.kind = 'method';
        method.computed = false;
        method.key = key;
        method.static = false;
        this.pushClassMethod(classBody, method, false, false, false, false);
        return true;
      } else if (this.isClassProperty()) {
        const prop = member;
        prop.computed = false;
        prop.key = key;
        prop.static = false;
        classBody.body.push(this.parseClassProperty(prop));
        return true;
      }
      this.resetPreviousNodeTrailingComments(key);
      return false;
    }
    parseClassMember(classBody, member, state) {
      const isStatic = this.isContextual(106);
      if (isStatic) {
        if (this.parseClassMemberFromModifier(classBody, member)) {
          return;
        }
        if (this.eat(5)) {
          this.parseClassStaticBlock(classBody, member);
          return;
        }
      }
      this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
    }
    parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
      const publicMethod = member;
      const privateMethod = member;
      const publicProp = member;
      const privateProp = member;
      const accessorProp = member;
      const method = publicMethod;
      const publicMember = publicMethod;
      member.static = isStatic;
      this.parsePropertyNamePrefixOperator(member);
      if (this.eat(55)) {
        method.kind = 'method';
        const isPrivateName = this.match(139);
        this.parseClassElementName(method);
        if (isPrivateName) {
          this.pushClassPrivateMethod(classBody, privateMethod, true, false);
          return;
        }
        if (this.isNonstaticConstructor(publicMethod)) {
          this.raise(Errors.ConstructorIsGenerator, publicMethod.key);
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          true,
          false,
          false,
          false
        );
        return;
      }
      const isContextual =
        !this.state.containsEsc && tokenIsIdentifier(this.state.type);
      const key = this.parseClassElementName(member);
      const maybeContextualKw = isContextual ? key.name : null;
      const isPrivate = this.isPrivateName(key);
      const maybeQuestionTokenStartLoc = this.state.startLoc;
      this.parsePostMemberNameModifiers(publicMember);
      if (this.isClassMethod()) {
        method.kind = 'method';
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
          return;
        }
        const isConstructor = this.isNonstaticConstructor(publicMethod);
        let allowsDirectSuper = false;
        if (isConstructor) {
          publicMethod.kind = 'constructor';
          if (state.hadConstructor && !this.hasPlugin('typescript')) {
            this.raise(Errors.DuplicateConstructor, key);
          }
          if (
            isConstructor &&
            this.hasPlugin('typescript') &&
            member.override
          ) {
            this.raise(Errors.OverrideOnConstructor, key);
          }
          state.hadConstructor = true;
          allowsDirectSuper = state.hadSuperClass;
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          false,
          false,
          isConstructor,
          allowsDirectSuper
        );
      } else if (this.isClassProperty()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else if (maybeContextualKw === 'async' && !this.isLineTerminator()) {
        this.resetPreviousNodeTrailingComments(key);
        const isGenerator = this.eat(55);
        if (publicMember.optional) {
          this.unexpected(maybeQuestionTokenStartLoc);
        }
        method.kind = 'method';
        const isPrivate = this.match(139);
        this.parseClassElementName(method);
        this.parsePostMemberNameModifiers(publicMember);
        if (isPrivate) {
          this.pushClassPrivateMethod(
            classBody,
            privateMethod,
            isGenerator,
            true
          );
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAsync, publicMethod.key);
          }
          this.pushClassMethod(
            classBody,
            publicMethod,
            isGenerator,
            true,
            false,
            false
          );
        }
      } else if (
        (maybeContextualKw === 'get' || maybeContextualKw === 'set') &&
        !(this.match(55) && this.isLineTerminator())
      ) {
        this.resetPreviousNodeTrailingComments(key);
        method.kind = maybeContextualKw;
        const isPrivate = this.match(139);
        this.parseClassElementName(publicMethod);
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAccessor, publicMethod.key);
          }
          this.pushClassMethod(
            classBody,
            publicMethod,
            false,
            false,
            false,
            false
          );
        }
        this.checkGetterSetterParams(publicMethod);
      } else if (maybeContextualKw === 'accessor' && !this.isLineTerminator()) {
        this.expectPlugin('decoratorAutoAccessors');
        this.resetPreviousNodeTrailingComments(key);
        const isPrivate = this.match(139);
        this.parseClassElementName(publicProp);
        this.pushClassAccessorProperty(classBody, accessorProp, isPrivate);
      } else if (this.isLineTerminator()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else {
        this.unexpected();
      }
    }
    parseClassElementName(member) {
      const {type: type, value: value} = this.state;
      if (
        (type === 132 || type === 134) &&
        member.static &&
        value === 'prototype'
      ) {
        this.raise(Errors.StaticPrototype, this.state.startLoc);
      }
      if (type === 139) {
        if (value === 'constructor') {
          this.raise(Errors.ConstructorClassPrivateField, this.state.startLoc);
        }
        const key = this.parsePrivateName();
        member.key = key;
        return key;
      }
      this.parsePropertyName(member);
      return member.key;
    }
    parseClassStaticBlock(classBody, member) {
      var _member$decorators;
      this.scope.enter(64 | 128 | 16);
      const oldLabels = this.state.labels;
      this.state.labels = [];
      this.prodParam.enter(0);
      const body = (member.body = []);
      this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
      this.prodParam.exit();
      this.scope.exit();
      this.state.labels = oldLabels;
      classBody.body.push(this.finishNode(member, 'StaticBlock'));
      if (
        (_member$decorators = member.decorators) != null &&
        _member$decorators.length
      ) {
        this.raise(Errors.DecoratorStaticBlock, member);
      }
    }
    pushClassProperty(classBody, prop) {
      if (!prop.computed && this.nameIsConstructor(prop.key)) {
        this.raise(Errors.ConstructorClassField, prop.key);
      }
      classBody.body.push(this.parseClassProperty(prop));
    }
    pushClassPrivateProperty(classBody, prop) {
      const node = this.parseClassPrivateProperty(prop);
      classBody.body.push(node);
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        0,
        node.key.loc.start
      );
    }
    pushClassAccessorProperty(classBody, prop, isPrivate) {
      if (!isPrivate && !prop.computed && this.nameIsConstructor(prop.key)) {
        this.raise(Errors.ConstructorClassField, prop.key);
      }
      const node = this.parseClassAccessorProperty(prop);
      classBody.body.push(node);
      if (isPrivate) {
        this.classScope.declarePrivateName(
          this.getPrivateNameSV(node.key),
          0,
          node.key.loc.start
        );
      }
    }
    pushClassMethod(
      classBody,
      method,
      isGenerator,
      isAsync,
      isConstructor,
      allowsDirectSuper
    ) {
      classBody.body.push(
        this.parseMethod(
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper,
          'ClassMethod',
          true
        )
      );
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      const node = this.parseMethod(
        method,
        isGenerator,
        isAsync,
        false,
        false,
        'ClassPrivateMethod',
        true
      );
      classBody.body.push(node);
      const kind =
        node.kind === 'get'
          ? node.static
            ? 6
            : 2
          : node.kind === 'set'
            ? node.static
              ? 5
              : 1
            : 0;
      this.declareClassPrivateMethodInScope(node, kind);
    }
    declareClassPrivateMethodInScope(node, kind) {
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        kind,
        node.key.loc.start
      );
    }
    parsePostMemberNameModifiers(methodOrProp) {}
    parseClassPrivateProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassPrivateProperty');
    }
    parseClassProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassProperty');
    }
    parseClassAccessorProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassAccessorProperty');
    }
    parseInitializer(node) {
      this.scope.enter(64 | 16);
      this.expressionScope.enter(newExpressionScope());
      this.prodParam.enter(0);
      node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
      this.expressionScope.exit();
      this.prodParam.exit();
      this.scope.exit();
    }
    parseClassId(node, isStatement, optionalId, bindingType = 8331) {
      if (tokenIsIdentifier(this.state.type)) {
        node.id = this.parseIdentifier();
        if (isStatement) {
          this.declareNameFromIdentifier(node.id, bindingType);
        }
      } else {
        if (optionalId || !isStatement) {
          node.id = null;
        } else {
          throw this.raise(Errors.MissingClassName, this.state.startLoc);
        }
      }
    }
    parseClassSuper(node) {
      node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
    }
    parseExport(node, decorators) {
      const maybeDefaultIdentifier = this.parseMaybeImportPhase(node, true);
      const hasDefault = this.maybeParseExportDefaultSpecifier(
        node,
        maybeDefaultIdentifier
      );
      const parseAfterDefault = !hasDefault || this.eat(12);
      const hasStar = parseAfterDefault && this.eatExportStar(node);
      const hasNamespace =
        hasStar && this.maybeParseExportNamespaceSpecifier(node);
      const parseAfterNamespace =
        parseAfterDefault && (!hasNamespace || this.eat(12));
      const isFromRequired = hasDefault || hasStar;
      if (hasStar && !hasNamespace) {
        if (hasDefault) this.unexpected();
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.parseExportFrom(node, true);
        return this.finishNode(node, 'ExportAllDeclaration');
      }
      const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
      if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
        this.unexpected(null, 5);
      }
      if (hasNamespace && parseAfterNamespace) {
        this.unexpected(null, 98);
      }
      let hasDeclaration;
      if (isFromRequired || hasSpecifiers) {
        hasDeclaration = false;
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.parseExportFrom(node, isFromRequired);
      } else {
        hasDeclaration = this.maybeParseExportDeclaration(node);
      }
      if (isFromRequired || hasSpecifiers || hasDeclaration) {
        var _node2$declaration;
        const node2 = node;
        this.checkExport(node2, true, false, !!node2.source);
        if (
          ((_node2$declaration = node2.declaration) == null
            ? void 0
            : _node2$declaration.type) === 'ClassDeclaration'
        ) {
          this.maybeTakeDecorators(decorators, node2.declaration, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        return this.finishNode(node2, 'ExportNamedDeclaration');
      }
      if (this.eat(65)) {
        const node2 = node;
        const decl = this.parseExportDefaultExpression();
        node2.declaration = decl;
        if (decl.type === 'ClassDeclaration') {
          this.maybeTakeDecorators(decorators, decl, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.checkExport(node2, true, true);
        return this.finishNode(node2, 'ExportDefaultDeclaration');
      }
      this.unexpected(null, 5);
    }
    eatExportStar(node) {
      return this.eat(55);
    }
    maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
      if (maybeDefaultIdentifier || this.isExportDefaultSpecifier()) {
        this.expectPlugin(
          'exportDefaultFrom',
          maybeDefaultIdentifier == null
            ? void 0
            : maybeDefaultIdentifier.loc.start
        );
        const id = maybeDefaultIdentifier || this.parseIdentifier(true);
        const specifier = this.startNodeAtNode(id);
        specifier.exported = id;
        node.specifiers = [
          this.finishNode(specifier, 'ExportDefaultSpecifier'),
        ];
        return true;
      }
      return false;
    }
    maybeParseExportNamespaceSpecifier(node) {
      if (this.isContextual(93)) {
        var _ref, _ref$specifiers;
        (_ref$specifiers = (_ref = node).specifiers) != null
          ? _ref$specifiers
          : (_ref.specifiers = []);
        const specifier = this.startNodeAt(this.state.lastTokStartLoc);
        this.next();
        specifier.exported = this.parseModuleExportName();
        node.specifiers.push(
          this.finishNode(specifier, 'ExportNamespaceSpecifier')
        );
        return true;
      }
      return false;
    }
    maybeParseExportNamedSpecifiers(node) {
      if (this.match(5)) {
        const node2 = node;
        if (!node2.specifiers) node2.specifiers = [];
        const isTypeExport = node2.exportKind === 'type';
        node2.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
        node2.source = null;
        node2.declaration = null;
        if (this.hasPlugin('importAssertions')) {
          node2.assertions = [];
        }
        return true;
      }
      return false;
    }
    maybeParseExportDeclaration(node) {
      if (this.shouldParseExportDeclaration()) {
        node.specifiers = [];
        node.source = null;
        if (this.hasPlugin('importAssertions')) {
          node.assertions = [];
        }
        node.declaration = this.parseExportDeclaration(node);
        return true;
      }
      return false;
    }
    isAsyncFunction() {
      if (!this.isContextual(95)) return false;
      const next = this.nextTokenInLineStart();
      return this.isUnparsedContextual(next, 'function');
    }
    parseExportDefaultExpression() {
      const expr = this.startNode();
      if (this.match(68)) {
        this.next();
        return this.parseFunction(expr, 1 | 4);
      } else if (this.isAsyncFunction()) {
        this.next();
        this.next();
        return this.parseFunction(expr, 1 | 4 | 8);
      }
      if (this.match(80)) {
        return this.parseClass(expr, true, true);
      }
      if (this.match(26)) {
        if (
          this.hasPlugin('decorators') &&
          this.getPluginOption('decorators', 'decoratorsBeforeExport') === true
        ) {
          this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
        }
        return this.parseClass(
          this.maybeTakeDecorators(
            this.parseDecorators(false),
            this.startNode()
          ),
          true,
          true
        );
      }
      if (this.match(75) || this.match(74) || this.isLet()) {
        throw this.raise(Errors.UnsupportedDefaultExport, this.state.startLoc);
      }
      const res = this.parseMaybeAssignAllowIn();
      this.semicolon();
      return res;
    }
    parseExportDeclaration(node) {
      if (this.match(80)) {
        const node = this.parseClass(this.startNode(), true, false);
        return node;
      }
      return this.parseStatementListItem();
    }
    isExportDefaultSpecifier() {
      const {type: type} = this.state;
      if (tokenIsIdentifier(type)) {
        if ((type === 95 && !this.state.containsEsc) || type === 100) {
          return false;
        }
        if ((type === 130 || type === 129) && !this.state.containsEsc) {
          const {type: nextType} = this.lookahead();
          if (
            (tokenIsIdentifier(nextType) && nextType !== 98) ||
            nextType === 5
          ) {
            this.expectOnePlugin(['flow', 'typescript']);
            return false;
          }
        }
      } else if (!this.match(65)) {
        return false;
      }
      const next = this.nextTokenStart();
      const hasFrom = this.isUnparsedContextual(next, 'from');
      if (
        this.input.charCodeAt(next) === 44 ||
        (tokenIsIdentifier(this.state.type) && hasFrom)
      ) {
        return true;
      }
      if (this.match(65) && hasFrom) {
        const nextAfterFrom = this.input.charCodeAt(
          this.nextTokenStartSince(next + 4)
        );
        return nextAfterFrom === 34 || nextAfterFrom === 39;
      }
      return false;
    }
    parseExportFrom(node, expect) {
      if (this.eatContextual(98)) {
        node.source = this.parseImportSource();
        this.checkExport(node);
        this.maybeParseImportAttributes(node);
        this.checkJSONModuleImport(node);
      } else if (expect) {
        this.unexpected();
      }
      this.semicolon();
    }
    shouldParseExportDeclaration() {
      const {type: type} = this.state;
      if (type === 26) {
        this.expectOnePlugin(['decorators', 'decorators-legacy']);
        if (this.hasPlugin('decorators')) {
          if (
            this.getPluginOption('decorators', 'decoratorsBeforeExport') ===
            true
          ) {
            this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
          }
          return true;
        }
      }
      if (this.isContextual(107)) {
        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
        return true;
      }
      if (this.isContextual(96) && this.startsAwaitUsing()) {
        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
        return true;
      }
      return (
        type === 74 ||
        type === 75 ||
        type === 68 ||
        type === 80 ||
        this.isLet() ||
        this.isAsyncFunction()
      );
    }
    checkExport(node, checkNames, isDefault, isFrom) {
      if (checkNames) {
        var _node$specifiers;
        if (isDefault) {
          this.checkDuplicateExports(node, 'default');
          if (this.hasPlugin('exportDefaultFrom')) {
            var _declaration$extra;
            const declaration = node.declaration;
            if (
              declaration.type === 'Identifier' &&
              declaration.name === 'from' &&
              declaration.end - declaration.start === 4 &&
              !(
                (_declaration$extra = declaration.extra) != null &&
                _declaration$extra.parenthesized
              )
            ) {
              this.raise(Errors.ExportDefaultFromAsIdentifier, declaration);
            }
          }
        } else if (
          (_node$specifiers = node.specifiers) != null &&
          _node$specifiers.length
        ) {
          for (const specifier of node.specifiers) {
            const {exported: exported} = specifier;
            const exportName =
              exported.type === 'Identifier' ? exported.name : exported.value;
            this.checkDuplicateExports(specifier, exportName);
            if (!isFrom && specifier.local) {
              const {local: local} = specifier;
              if (local.type !== 'Identifier') {
                this.raise(Errors.ExportBindingIsString, specifier, {
                  localName: local.value,
                  exportName: exportName,
                });
              } else {
                this.checkReservedWord(
                  local.name,
                  local.loc.start,
                  true,
                  false
                );
                this.scope.checkLocalExport(local);
              }
            }
          }
        } else if (node.declaration) {
          const decl = node.declaration;
          if (
            decl.type === 'FunctionDeclaration' ||
            decl.type === 'ClassDeclaration'
          ) {
            const {id: id} = decl;
            if (!id) throw new Error('Assertion failure');
            this.checkDuplicateExports(node, id.name);
          } else if (decl.type === 'VariableDeclaration') {
            for (const declaration of decl.declarations) {
              this.checkDeclaration(declaration.id);
            }
          }
        }
      }
    }
    checkDeclaration(node) {
      if (node.type === 'Identifier') {
        this.checkDuplicateExports(node, node.name);
      } else if (node.type === 'ObjectPattern') {
        for (const prop of node.properties) {
          this.checkDeclaration(prop);
        }
      } else if (node.type === 'ArrayPattern') {
        for (const elem of node.elements) {
          if (elem) {
            this.checkDeclaration(elem);
          }
        }
      } else if (node.type === 'ObjectProperty') {
        this.checkDeclaration(node.value);
      } else if (node.type === 'RestElement') {
        this.checkDeclaration(node.argument);
      } else if (node.type === 'AssignmentPattern') {
        this.checkDeclaration(node.left);
      }
    }
    checkDuplicateExports(node, exportName) {
      if (this.exportedIdentifiers.has(exportName)) {
        if (exportName === 'default') {
          this.raise(Errors.DuplicateDefaultExport, node);
        } else {
          this.raise(Errors.DuplicateExport, node, {exportName: exportName});
        }
      }
      this.exportedIdentifiers.add(exportName);
    }
    parseExportSpecifiers(isInTypeExport) {
      const nodes = [];
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.eat(8)) break;
        }
        const isMaybeTypeOnly = this.isContextual(130);
        const isString = this.match(134);
        const node = this.startNode();
        node.local = this.parseModuleExportName();
        nodes.push(
          this.parseExportSpecifier(
            node,
            isString,
            isInTypeExport,
            isMaybeTypeOnly
          )
        );
      }
      return nodes;
    }
    parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
      if (this.eatContextual(93)) {
        node.exported = this.parseModuleExportName();
      } else if (isString) {
        node.exported = cloneStringLiteral(node.local);
      } else if (!node.exported) {
        node.exported = cloneIdentifier(node.local);
      }
      return this.finishNode(node, 'ExportSpecifier');
    }
    parseModuleExportName() {
      if (this.match(134)) {
        const result = this.parseStringLiteral(this.state.value);
        const surrogate = loneSurrogate.exec(result.value);
        if (surrogate) {
          this.raise(Errors.ModuleExportNameHasLoneSurrogate, result, {
            surrogateCharCode: surrogate[0].charCodeAt(0),
          });
        }
        return result;
      }
      return this.parseIdentifier(true);
    }
    isJSONModuleImport(node) {
      if (node.assertions != null) {
        return node.assertions.some(
          ({key: key, value: value}) =>
            value.value === 'json' &&
            (key.type === 'Identifier'
              ? key.name === 'type'
              : key.value === 'type')
        );
      }
      return false;
    }
    checkImportReflection(node) {
      const {specifiers: specifiers} = node;
      const singleBindingType =
        specifiers.length === 1 ? specifiers[0].type : null;
      if (node.phase === 'source') {
        if (singleBindingType !== 'ImportDefaultSpecifier') {
          this.raise(
            Errors.SourcePhaseImportRequiresDefault,
            specifiers[0].loc.start
          );
        }
      } else if (node.phase === 'defer') {
        if (singleBindingType !== 'ImportNamespaceSpecifier') {
          this.raise(
            Errors.DeferImportRequiresNamespace,
            specifiers[0].loc.start
          );
        }
      } else if (node.module) {
        var _node$assertions;
        if (singleBindingType !== 'ImportDefaultSpecifier') {
          this.raise(
            Errors.ImportReflectionNotBinding,
            specifiers[0].loc.start
          );
        }
        if (
          ((_node$assertions = node.assertions) == null
            ? void 0
            : _node$assertions.length) > 0
        ) {
          this.raise(
            Errors.ImportReflectionHasAssertion,
            specifiers[0].loc.start
          );
        }
      }
    }
    checkJSONModuleImport(node) {
      if (
        this.isJSONModuleImport(node) &&
        node.type !== 'ExportAllDeclaration'
      ) {
        const {specifiers: specifiers} = node;
        if (specifiers != null) {
          const nonDefaultNamedSpecifier = specifiers.find(specifier => {
            let imported;
            if (specifier.type === 'ExportSpecifier') {
              imported = specifier.local;
            } else if (specifier.type === 'ImportSpecifier') {
              imported = specifier.imported;
            }
            if (imported !== undefined) {
              return imported.type === 'Identifier'
                ? imported.name !== 'default'
                : imported.value !== 'default';
            }
          });
          if (nonDefaultNamedSpecifier !== undefined) {
            this.raise(
              Errors.ImportJSONBindingNotDefault,
              nonDefaultNamedSpecifier.loc.start
            );
          }
        }
      }
    }
    isPotentialImportPhase(isExport) {
      if (isExport) return false;
      return (
        this.isContextual(105) ||
        this.isContextual(97) ||
        this.isContextual(127)
      );
    }
    applyImportPhase(node, isExport, phase, loc) {
      if (isExport) {
        return;
      }
      if (phase === 'module') {
        this.expectPlugin('importReflection', loc);
        node.module = true;
      } else if (this.hasPlugin('importReflection')) {
        node.module = false;
      }
      if (phase === 'source') {
        this.expectPlugin('sourcePhaseImports', loc);
        node.phase = 'source';
      } else if (phase === 'defer') {
        this.expectPlugin('deferredImportEvaluation', loc);
        node.phase = 'defer';
      } else if (this.hasPlugin('sourcePhaseImports')) {
        node.phase = null;
      }
    }
    parseMaybeImportPhase(node, isExport) {
      if (!this.isPotentialImportPhase(isExport)) {
        this.applyImportPhase(node, isExport, null);
        return null;
      }
      const phaseIdentifier = this.parseIdentifier(true);
      const {type: type} = this.state;
      const isImportPhase = tokenIsKeywordOrIdentifier(type)
        ? type !== 98 || this.lookaheadCharCode() === 102
        : type !== 12;
      if (isImportPhase) {
        this.resetPreviousIdentifierLeadingComments(phaseIdentifier);
        this.applyImportPhase(
          node,
          isExport,
          phaseIdentifier.name,
          phaseIdentifier.loc.start
        );
        return null;
      } else {
        this.applyImportPhase(node, isExport, null);
        return phaseIdentifier;
      }
    }
    isPrecedingIdImportPhase(phase) {
      const {type: type} = this.state;
      return tokenIsIdentifier(type)
        ? type !== 98 || this.lookaheadCharCode() === 102
        : type !== 12;
    }
    parseImport(node) {
      if (this.match(134)) {
        return this.parseImportSourceAndAttributes(node);
      }
      return this.parseImportSpecifiersAndAfter(
        node,
        this.parseMaybeImportPhase(node, false)
      );
    }
    parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier) {
      node.specifiers = [];
      const hasDefault = this.maybeParseDefaultImportSpecifier(
        node,
        maybeDefaultIdentifier
      );
      const parseNext = !hasDefault || this.eat(12);
      const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
      if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
      this.expectContextual(98);
      return this.parseImportSourceAndAttributes(node);
    }
    parseImportSourceAndAttributes(node) {
      var _node$specifiers2;
      (_node$specifiers2 = node.specifiers) != null
        ? _node$specifiers2
        : (node.specifiers = []);
      node.source = this.parseImportSource();
      this.maybeParseImportAttributes(node);
      this.checkImportReflection(node);
      this.checkJSONModuleImport(node);
      this.semicolon();
      return this.finishNode(node, 'ImportDeclaration');
    }
    parseImportSource() {
      if (!this.match(134)) this.unexpected();
      return this.parseExprAtom();
    }
    parseImportSpecifierLocal(node, specifier, type) {
      specifier.local = this.parseIdentifier();
      node.specifiers.push(this.finishImportSpecifier(specifier, type));
    }
    finishImportSpecifier(specifier, type, bindingType = 8201) {
      this.checkLVal(specifier.local, {type: type}, bindingType);
      return this.finishNode(specifier, type);
    }
    parseImportAttributes() {
      this.expect(5);
      const attrs = [];
      const attrNames = new Set();
      do {
        if (this.match(8)) {
          break;
        }
        const node = this.startNode();
        const keyName = this.state.value;
        if (attrNames.has(keyName)) {
          this.raise(
            Errors.ModuleAttributesWithDuplicateKeys,
            this.state.startLoc,
            {key: keyName}
          );
        }
        attrNames.add(keyName);
        if (this.match(134)) {
          node.key = this.parseStringLiteral(keyName);
        } else {
          node.key = this.parseIdentifier(true);
        }
        this.expect(14);
        if (!this.match(134)) {
          throw this.raise(
            Errors.ModuleAttributeInvalidValue,
            this.state.startLoc
          );
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, 'ImportAttribute'));
      } while (this.eat(12));
      this.expect(8);
      return attrs;
    }
    parseModuleAttributes() {
      const attrs = [];
      const attributes = new Set();
      do {
        const node = this.startNode();
        node.key = this.parseIdentifier(true);
        if (node.key.name !== 'type') {
          this.raise(Errors.ModuleAttributeDifferentFromType, node.key);
        }
        if (attributes.has(node.key.name)) {
          this.raise(Errors.ModuleAttributesWithDuplicateKeys, node.key, {
            key: node.key.name,
          });
        }
        attributes.add(node.key.name);
        this.expect(14);
        if (!this.match(134)) {
          throw this.raise(
            Errors.ModuleAttributeInvalidValue,
            this.state.startLoc
          );
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, 'ImportAttribute'));
      } while (this.eat(12));
      return attrs;
    }
    maybeParseImportAttributes(node) {
      let attributes;
      {
        var useWith = false;
      }
      if (this.match(76)) {
        if (this.hasPrecedingLineBreak() && this.lookaheadCharCode() === 40) {
          return;
        }
        this.next();
        if (this.hasPlugin('moduleAttributes')) {
          attributes = this.parseModuleAttributes();
        } else {
          attributes = this.parseImportAttributes();
        }
        {
          useWith = true;
        }
      } else if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
        if (
          !this.hasPlugin('deprecatedImportAssert') &&
          !this.hasPlugin('importAssertions')
        ) {
          this.raise(Errors.ImportAttributesUseAssert, this.state.startLoc);
        }
        if (!this.hasPlugin('importAssertions')) {
          this.addExtra(node, 'deprecatedAssertSyntax', true);
        }
        this.next();
        attributes = this.parseImportAttributes();
      } else {
        attributes = [];
      }
      if (!useWith && this.hasPlugin('importAssertions')) {
        node.assertions = attributes;
      } else {
        node.attributes = attributes;
      }
    }
    maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier) {
      if (maybeDefaultIdentifier) {
        const specifier = this.startNodeAtNode(maybeDefaultIdentifier);
        specifier.local = maybeDefaultIdentifier;
        node.specifiers.push(
          this.finishImportSpecifier(specifier, 'ImportDefaultSpecifier')
        );
        return true;
      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
        this.parseImportSpecifierLocal(
          node,
          this.startNode(),
          'ImportDefaultSpecifier'
        );
        return true;
      }
      return false;
    }
    maybeParseStarImportSpecifier(node) {
      if (this.match(55)) {
        const specifier = this.startNode();
        this.next();
        this.expectContextual(93);
        this.parseImportSpecifierLocal(
          node,
          specifier,
          'ImportNamespaceSpecifier'
        );
        return true;
      }
      return false;
    }
    parseNamedImportSpecifiers(node) {
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          if (this.eat(14)) {
            throw this.raise(
              Errors.DestructureNamedImport,
              this.state.startLoc
            );
          }
          this.expect(12);
          if (this.eat(8)) break;
        }
        const specifier = this.startNode();
        const importedIsString = this.match(134);
        const isMaybeTypeOnly = this.isContextual(130);
        specifier.imported = this.parseModuleExportName();
        const importSpecifier = this.parseImportSpecifier(
          specifier,
          importedIsString,
          node.importKind === 'type' || node.importKind === 'typeof',
          isMaybeTypeOnly,
          undefined
        );
        node.specifiers.push(importSpecifier);
      }
    }
    parseImportSpecifier(
      specifier,
      importedIsString,
      isInTypeOnlyImport,
      isMaybeTypeOnly,
      bindingType
    ) {
      if (this.eatContextual(93)) {
        specifier.local = this.parseIdentifier();
      } else {
        const {imported: imported} = specifier;
        if (importedIsString) {
          throw this.raise(Errors.ImportBindingIsString, specifier, {
            importName: imported.value,
          });
        }
        this.checkReservedWord(imported.name, specifier.loc.start, true, true);
        if (!specifier.local) {
          specifier.local = cloneIdentifier(imported);
        }
      }
      return this.finishImportSpecifier(
        specifier,
        'ImportSpecifier',
        bindingType
      );
    }
    isThisParam(param) {
      return param.type === 'Identifier' && param.name === 'this';
    }
  }
  class Parser extends StatementParser {
    constructor(options, input, pluginsMap) {
      options = getOptions(options);
      super(options, input);
      this.options = options;
      this.initializeScopes();
      this.plugins = pluginsMap;
      this.filename = options.sourceFilename;
      this.startIndex = options.startIndex;
    }
    getScopeHandler() {
      return ScopeHandler;
    }
    parse() {
      this.enterInitialScopes();
      const file = this.startNode();
      const program = this.startNode();
      this.nextToken();
      file.errors = null;
      this.parseTopLevel(file, program);
      file.errors = this.state.errors;
      file.comments.length = this.state.commentsLen;
      return file;
    }
  }
  function parse(input, options) {
    var _options;
    if (
      ((_options = options) == null ? void 0 : _options.sourceType) ===
      'unambiguous'
    ) {
      options = Object.assign({}, options);
      try {
        options.sourceType = 'module';
        const parser = getParser(options, input);
        const ast = parser.parse();
        if (parser.sawUnambiguousESM) {
          return ast;
        }
        if (parser.ambiguousScriptDifferentAst) {
          try {
            options.sourceType = 'script';
            return getParser(options, input).parse();
          } catch (_unused) {}
        } else {
          ast.program.sourceType = 'script';
        }
        return ast;
      } catch (moduleError) {
        try {
          options.sourceType = 'script';
          return getParser(options, input).parse();
        } catch (_unused2) {}
        throw moduleError;
      }
    } else {
      return getParser(options, input).parse();
    }
  }
  function parseExpression(input, options) {
    const parser = getParser(options, input);
    if (parser.options.strictMode) {
      parser.state.strict = true;
    }
    return parser.getExpression();
  }
  function generateExportedTokenTypes(internalTokenTypes) {
    const tokenTypes = {};
    for (const typeName of Object.keys(internalTokenTypes)) {
      tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
    }
    return tokenTypes;
  }
  const tokTypes = generateExportedTokenTypes(tt);
  function getParser(options, input) {
    let cls = Parser;
    const pluginsMap = new Map();
    if (options != null && options.plugins) {
      for (const plugin of options.plugins) {
        let name, opts;
        if (typeof plugin === 'string') {
          name = plugin;
        } else {
          [name, opts] = plugin;
        }
        if (!pluginsMap.has(name)) {
          pluginsMap.set(name, opts || {});
        }
      }
      validatePlugins(pluginsMap);
      cls = getParserClass(pluginsMap);
    }
    return new cls(options, input, pluginsMap);
  }
  const parserClassCache = new Map();
  function getParserClass(pluginsMap) {
    const pluginList = [];
    for (const name of mixinPluginNames) {
      if (pluginsMap.has(name)) {
        pluginList.push(name);
      }
    }
    const key = pluginList.join('|');
    let cls = parserClassCache.get(key);
    if (!cls) {
      cls = Parser;
      for (const plugin of pluginList) {
        cls = mixinPlugins[plugin](cls);
      }
      parserClassCache.set(key, cls);
    }
    return cls;
  }
  lib$j.parse = parse;
  lib$j.parseExpression = parseExpression;
  lib$j.tokTypes = tokTypes;
  return lib$j;
}
var hasRequiredReplacement$1;
function requireReplacement$1() {
  if (hasRequiredReplacement$1) return replacement$1;
  hasRequiredReplacement$1 = 1;
  Object.defineProperty(replacement$1, '__esModule', {value: true});
  replacement$1._replaceWith = _replaceWith;
  replacement$1.replaceExpressionWithStatements =
    replaceExpressionWithStatements;
  replacement$1.replaceInline = replaceInline;
  replacement$1.replaceWith = replaceWith;
  replacement$1.replaceWithMultiple = replaceWithMultiple;
  replacement$1.replaceWithSourceString = replaceWithSourceString;
  var _codeFrame = requireLib$k();
  var _index = requireLib$h();
  var _index2 = requirePath$1();
  var _cache = requireCache$1();
  var _modification = requireModification$1();
  var _parser = requireLib$j();
  var _t = t$d;
  var _context = requireContext$2();
  const {
    FUNCTION_TYPES: FUNCTION_TYPES,
    arrowFunctionExpression: arrowFunctionExpression,
    assignmentExpression: assignmentExpression,
    awaitExpression: awaitExpression,
    blockStatement: blockStatement,
    buildUndefinedNode: buildUndefinedNode,
    callExpression: callExpression,
    cloneNode: cloneNode,
    conditionalExpression: conditionalExpression,
    expressionStatement: expressionStatement,
    getBindingIdentifiers: getBindingIdentifiers,
    identifier: identifier,
    inheritLeadingComments: inheritLeadingComments,
    inheritTrailingComments: inheritTrailingComments,
    inheritsComments: inheritsComments,
    isBlockStatement: isBlockStatement,
    isEmptyStatement: isEmptyStatement,
    isExpression: isExpression,
    isExpressionStatement: isExpressionStatement,
    isIfStatement: isIfStatement,
    isProgram: isProgram,
    isStatement: isStatement,
    isVariableDeclaration: isVariableDeclaration,
    removeComments: removeComments,
    returnStatement: returnStatement,
    sequenceExpression: sequenceExpression,
    validate: validate,
    yieldExpression: yieldExpression,
  } = _t;
  function replaceWithMultiple(nodes) {
    var _getCachedPaths;
    _context.resync.call(this);
    nodes = _modification._verifyNodeList.call(this, nodes);
    inheritLeadingComments(nodes[0], this.node);
    inheritTrailingComments(nodes[nodes.length - 1], this.node);
    (_getCachedPaths = (0, _cache.getCachedPaths)(this.hub, this.parent)) ==
      null || _getCachedPaths.delete(this.node);
    this.node = this.container[this.key] = null;
    const paths = this.insertAfter(nodes);
    if (this.node) {
      this.requeue();
    } else {
      this.remove();
    }
    return paths;
  }
  function replaceWithSourceString(replacement) {
    _context.resync.call(this);
    let ast;
    try {
      replacement = `(${replacement})`;
      ast = (0, _parser.parse)(replacement);
    } catch (err) {
      const loc = err.loc;
      if (loc) {
        err.message +=
          ' - make sure this is an expression.\n' +
          (0, _codeFrame.codeFrameColumns)(replacement, {
            start: {line: loc.line, column: loc.column + 1},
          });
        err.code = 'BABEL_REPLACE_SOURCE_ERROR';
      }
      throw err;
    }
    const expressionAST = ast.program.body[0].expression;
    _index.default.removeProperties(expressionAST);
    return this.replaceWith(expressionAST);
  }
  function replaceWith(replacementPath) {
    _context.resync.call(this);
    if (this.removed) {
      throw new Error("You can't replace this node, we've already removed it");
    }
    let replacement =
      replacementPath instanceof _index2.default
        ? replacementPath.node
        : replacementPath;
    if (!replacement) {
      throw new Error(
        'You passed `path.replaceWith()` a falsy node, use `path.remove()` instead'
      );
    }
    if (this.node === replacement) {
      return [this];
    }
    if (this.isProgram() && !isProgram(replacement)) {
      throw new Error(
        'You can only replace a Program root node with another Program node'
      );
    }
    if (Array.isArray(replacement)) {
      throw new Error(
        "Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`"
      );
    }
    if (typeof replacement === 'string') {
      throw new Error(
        "Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`"
      );
    }
    let nodePath = '';
    if (this.isNodeType('Statement') && isExpression(replacement)) {
      if (
        !this.canHaveVariableDeclarationOrExpression() &&
        !this.canSwapBetweenExpressionAndStatement(replacement) &&
        !this.parentPath.isExportDefaultDeclaration()
      ) {
        replacement = expressionStatement(replacement);
        nodePath = 'expression';
      }
    }
    if (this.isNodeType('Expression') && isStatement(replacement)) {
      if (
        !this.canHaveVariableDeclarationOrExpression() &&
        !this.canSwapBetweenExpressionAndStatement(replacement)
      ) {
        return this.replaceExpressionWithStatements([replacement]);
      }
    }
    const oldNode = this.node;
    if (oldNode) {
      inheritsComments(replacement, oldNode);
      removeComments(oldNode);
    }
    _replaceWith.call(this, replacement);
    this.type = replacement.type;
    _context.setScope.call(this);
    this.requeue();
    return [nodePath ? this.get(nodePath) : this];
  }
  function _replaceWith(node) {
    var _getCachedPaths2;
    if (!this.container) {
      throw new ReferenceError('Container is falsy');
    }
    if (this.inList) {
      validate(this.parent, this.key, [node]);
    } else {
      validate(this.parent, this.key, node);
    }
    this.debug(`Replace with ${node == null ? void 0 : node.type}`);
    (_getCachedPaths2 = (0, _cache.getCachedPaths)(this.hub, this.parent)) ==
      null || _getCachedPaths2.set(node, this).delete(this.node);
    this.node = this.container[this.key] = node;
  }
  function replaceExpressionWithStatements(nodes) {
    _context.resync.call(this);
    const declars = [];
    const nodesAsSingleExpression = gatherSequenceExpressions(nodes, declars);
    if (nodesAsSingleExpression) {
      for (const id of declars) this.scope.push({id: id});
      return this.replaceWith(nodesAsSingleExpression)[0].get('expressions');
    }
    const functionParent = this.getFunctionParent();
    const isParentAsync =
      functionParent == null ? void 0 : functionParent.node.async;
    const isParentGenerator =
      functionParent == null ? void 0 : functionParent.node.generator;
    const container = arrowFunctionExpression([], blockStatement(nodes));
    this.replaceWith(callExpression(container, []));
    const callee = this.get('callee');
    callee.get('body').scope.hoistVariables(id => this.scope.push({id: id}));
    const completionRecords = callee.getCompletionRecords();
    for (const path of completionRecords) {
      if (!path.isExpressionStatement()) continue;
      const loop = path.findParent(path => path.isLoop());
      if (loop) {
        let uid = loop.getData('expressionReplacementReturnUid');
        if (!uid) {
          uid = callee.scope.generateDeclaredUidIdentifier('ret');
          callee
            .get('body')
            .pushContainer('body', returnStatement(cloneNode(uid)));
          loop.setData('expressionReplacementReturnUid', uid);
        } else {
          uid = identifier(uid.name);
        }
        path
          .get('expression')
          .replaceWith(
            assignmentExpression('=', cloneNode(uid), path.node.expression)
          );
      } else {
        path.replaceWith(returnStatement(path.node.expression));
      }
    }
    callee.arrowFunctionToExpression();
    const newCallee = callee;
    const needToAwaitFunction =
      isParentAsync &&
      _index.default.hasType(
        this.get('callee.body').node,
        'AwaitExpression',
        FUNCTION_TYPES
      );
    const needToYieldFunction =
      isParentGenerator &&
      _index.default.hasType(
        this.get('callee.body').node,
        'YieldExpression',
        FUNCTION_TYPES
      );
    if (needToAwaitFunction) {
      newCallee.set('async', true);
      if (!needToYieldFunction) {
        this.replaceWith(awaitExpression(this.node));
      }
    }
    if (needToYieldFunction) {
      newCallee.set('generator', true);
      this.replaceWith(yieldExpression(this.node, true));
    }
    return newCallee.get('body.body');
  }
  function gatherSequenceExpressions(nodes, declars) {
    const exprs = [];
    let ensureLastUndefined = true;
    for (const node of nodes) {
      if (!isEmptyStatement(node)) {
        ensureLastUndefined = false;
      }
      if (isExpression(node)) {
        exprs.push(node);
      } else if (isExpressionStatement(node)) {
        exprs.push(node.expression);
      } else if (isVariableDeclaration(node)) {
        if (node.kind !== 'var') return;
        for (const declar of node.declarations) {
          const bindings = getBindingIdentifiers(declar);
          for (const key of Object.keys(bindings)) {
            declars.push(cloneNode(bindings[key]));
          }
          if (declar.init) {
            exprs.push(assignmentExpression('=', declar.id, declar.init));
          }
        }
        ensureLastUndefined = true;
      } else if (isIfStatement(node)) {
        const consequent = node.consequent
          ? gatherSequenceExpressions([node.consequent], declars)
          : buildUndefinedNode();
        const alternate = node.alternate
          ? gatherSequenceExpressions([node.alternate], declars)
          : buildUndefinedNode();
        if (!consequent || !alternate) return;
        exprs.push(conditionalExpression(node.test, consequent, alternate));
      } else if (isBlockStatement(node)) {
        const body = gatherSequenceExpressions(node.body, declars);
        if (!body) return;
        exprs.push(body);
      } else if (isEmptyStatement(node)) {
        if (nodes.indexOf(node) === 0) {
          ensureLastUndefined = true;
        }
      } else {
        return;
      }
    }
    if (ensureLastUndefined) exprs.push(buildUndefinedNode());
    if (exprs.length === 1) {
      return exprs[0];
    } else {
      return sequenceExpression(exprs);
    }
  }
  function replaceInline(nodes) {
    _context.resync.call(this);
    if (Array.isArray(nodes)) {
      if (Array.isArray(this.container)) {
        nodes = _modification._verifyNodeList.call(this, nodes);
        const paths = _modification._containerInsertAfter.call(this, nodes);
        this.remove();
        return paths;
      } else {
        return this.replaceWithMultiple(nodes);
      }
    } else {
      return this.replaceWith(nodes);
    }
  }
  return replacement$1;
}
var evaluation$1 = {};
var hasRequiredEvaluation$1;
function requireEvaluation$1() {
  if (hasRequiredEvaluation$1) return evaluation$1;
  hasRequiredEvaluation$1 = 1;
  Object.defineProperty(evaluation$1, '__esModule', {value: true});
  evaluation$1.evaluate = evaluate;
  evaluation$1.evaluateTruthy = evaluateTruthy;
  const VALID_OBJECT_CALLEES = ['Number', 'String', 'Math'];
  const VALID_IDENTIFIER_CALLEES = [
    'isFinite',
    'isNaN',
    'parseFloat',
    'parseInt',
    'decodeURI',
    'decodeURIComponent',
    'encodeURI',
    'encodeURIComponent',
    null,
    null,
  ];
  const INVALID_METHODS = ['random'];
  function isValidObjectCallee(val) {
    return VALID_OBJECT_CALLEES.includes(val);
  }
  function isValidIdentifierCallee(val) {
    return VALID_IDENTIFIER_CALLEES.includes(val);
  }
  function isInvalidMethod(val) {
    return INVALID_METHODS.includes(val);
  }
  function evaluateTruthy() {
    const res = this.evaluate();
    if (res.confident) return !!res.value;
  }
  function deopt(path, state) {
    if (!state.confident) return;
    state.deoptPath = path;
    state.confident = false;
  }
  const Globals = new Map([
    ['undefined', undefined],
    ['Infinity', Infinity],
    ['NaN', NaN],
  ]);
  function evaluateCached(path, state) {
    const {node: node} = path;
    const {seen: seen} = state;
    if (seen.has(node)) {
      const existing = seen.get(node);
      if (existing.resolved) {
        return existing.value;
      } else {
        deopt(path, state);
        return;
      }
    } else {
      const item = {resolved: false};
      seen.set(node, item);
      const val = _evaluate(path, state);
      if (state.confident) {
        item.resolved = true;
        item.value = val;
      }
      return val;
    }
  }
  function _evaluate(path, state) {
    if (!state.confident) return;
    if (path.isSequenceExpression()) {
      const exprs = path.get('expressions');
      return evaluateCached(exprs[exprs.length - 1], state);
    }
    if (
      path.isStringLiteral() ||
      path.isNumericLiteral() ||
      path.isBooleanLiteral()
    ) {
      return path.node.value;
    }
    if (path.isNullLiteral()) {
      return null;
    }
    if (path.isTemplateLiteral()) {
      return evaluateQuasis(path, path.node.quasis, state);
    }
    if (
      path.isTaggedTemplateExpression() &&
      path.get('tag').isMemberExpression()
    ) {
      const object = path.get('tag.object');
      const {
        node: {name: name},
      } = object;
      const property = path.get('tag.property');
      if (
        object.isIdentifier() &&
        name === 'String' &&
        !path.scope.getBinding(name) &&
        property.isIdentifier() &&
        property.node.name === 'raw'
      ) {
        return evaluateQuasis(path, path.node.quasi.quasis, state, true);
      }
    }
    if (path.isConditionalExpression()) {
      const testResult = evaluateCached(path.get('test'), state);
      if (!state.confident) return;
      if (testResult) {
        return evaluateCached(path.get('consequent'), state);
      } else {
        return evaluateCached(path.get('alternate'), state);
      }
    }
    if (path.isExpressionWrapper()) {
      return evaluateCached(path.get('expression'), state);
    }
    if (
      path.isMemberExpression() &&
      !path.parentPath.isCallExpression({callee: path.node})
    ) {
      const property = path.get('property');
      const object = path.get('object');
      if (object.isLiteral()) {
        const value = object.node.value;
        const type = typeof value;
        let key = null;
        if (path.node.computed) {
          key = evaluateCached(property, state);
          if (!state.confident) return;
        } else if (property.isIdentifier()) {
          key = property.node.name;
        }
        if (
          (type === 'number' || type === 'string') &&
          key != null &&
          (typeof key === 'number' || typeof key === 'string')
        ) {
          return value[key];
        }
      }
    }
    if (path.isReferencedIdentifier()) {
      const binding = path.scope.getBinding(path.node.name);
      if (binding) {
        if (
          binding.constantViolations.length > 0 ||
          path.node.start < binding.path.node.end
        ) {
          deopt(binding.path, state);
          return;
        }
        if (binding.hasValue) {
          return binding.value;
        }
      }
      const name = path.node.name;
      if (Globals.has(name)) {
        if (!binding) {
          return Globals.get(name);
        }
        deopt(binding.path, state);
        return;
      }
      const resolved = path.resolve();
      if (resolved === path) {
        deopt(path, state);
        return;
      } else {
        return evaluateCached(resolved, state);
      }
    }
    if (path.isUnaryExpression({prefix: true})) {
      if (path.node.operator === 'void') {
        return undefined;
      }
      const argument = path.get('argument');
      if (
        path.node.operator === 'typeof' &&
        (argument.isFunction() || argument.isClass())
      ) {
        return 'function';
      }
      const arg = evaluateCached(argument, state);
      if (!state.confident) return;
      switch (path.node.operator) {
        case '!':
          return !arg;
        case '+':
          return +arg;
        case '-':
          return -arg;
        case '~':
          return ~arg;
        case 'typeof':
          return typeof arg;
      }
    }
    if (path.isArrayExpression()) {
      const arr = [];
      const elems = path.get('elements');
      for (const elem of elems) {
        const elemValue = elem.evaluate();
        if (elemValue.confident) {
          arr.push(elemValue.value);
        } else {
          deopt(elemValue.deopt, state);
          return;
        }
      }
      return arr;
    }
    if (path.isObjectExpression()) {
      const obj = {};
      const props = path.get('properties');
      for (const prop of props) {
        if (prop.isObjectMethod() || prop.isSpreadElement()) {
          deopt(prop, state);
          return;
        }
        const keyPath = prop.get('key');
        let key;
        if (prop.node.computed) {
          key = keyPath.evaluate();
          if (!key.confident) {
            deopt(key.deopt, state);
            return;
          }
          key = key.value;
        } else if (keyPath.isIdentifier()) {
          key = keyPath.node.name;
        } else {
          key = keyPath.node.value;
        }
        const valuePath = prop.get('value');
        let value = valuePath.evaluate();
        if (!value.confident) {
          deopt(value.deopt, state);
          return;
        }
        value = value.value;
        obj[key] = value;
      }
      return obj;
    }
    if (path.isLogicalExpression()) {
      const wasConfident = state.confident;
      const left = evaluateCached(path.get('left'), state);
      const leftConfident = state.confident;
      state.confident = wasConfident;
      const right = evaluateCached(path.get('right'), state);
      const rightConfident = state.confident;
      switch (path.node.operator) {
        case '||':
          state.confident = leftConfident && (!!left || rightConfident);
          if (!state.confident) return;
          return left || right;
        case '&&':
          state.confident = leftConfident && (!left || rightConfident);
          if (!state.confident) return;
          return left && right;
        case '??':
          state.confident = leftConfident && (left != null || rightConfident);
          if (!state.confident) return;
          return left != null ? left : right;
      }
    }
    if (path.isBinaryExpression()) {
      const left = evaluateCached(path.get('left'), state);
      if (!state.confident) return;
      const right = evaluateCached(path.get('right'), state);
      if (!state.confident) return;
      switch (path.node.operator) {
        case '-':
          return left - right;
        case '+':
          return left + right;
        case '/':
          return left / right;
        case '*':
          return left * right;
        case '%':
          return left % right;
        case '**':
          return Math.pow(left, right);
        case '<':
          return left < right;
        case '>':
          return left > right;
        case '<=':
          return left <= right;
        case '>=':
          return left >= right;
        case '==':
          return left == right;
        case '!=':
          return left != right;
        case '===':
          return left === right;
        case '!==':
          return left !== right;
        case '|':
          return left | right;
        case '&':
          return left & right;
        case '^':
          return left ^ right;
        case '<<':
          return left << right;
        case '>>':
          return left >> right;
        case '>>>':
          return left >>> right;
      }
    }
    if (path.isCallExpression()) {
      const callee = path.get('callee');
      let context;
      let func;
      if (
        callee.isIdentifier() &&
        !path.scope.getBinding(callee.node.name) &&
        (isValidObjectCallee(callee.node.name) ||
          isValidIdentifierCallee(callee.node.name))
      ) {
        func = commonjsGlobal[callee.node.name];
      }
      if (callee.isMemberExpression()) {
        const object = callee.get('object');
        const property = callee.get('property');
        if (
          object.isIdentifier() &&
          property.isIdentifier() &&
          isValidObjectCallee(object.node.name) &&
          !isInvalidMethod(property.node.name)
        ) {
          context = commonjsGlobal[object.node.name];
          const key = property.node.name;
          if (hasOwnProperty.call(context, key)) {
            func = context[key];
          }
        }
        if (object.isLiteral() && property.isIdentifier()) {
          const type = typeof object.node.value;
          if (type === 'string' || type === 'number') {
            context = object.node.value;
            func = context[property.node.name];
          }
        }
      }
      if (func) {
        const args = path
          .get('arguments')
          .map(arg => evaluateCached(arg, state));
        if (!state.confident) return;
        return func.apply(context, args);
      }
    }
    deopt(path, state);
  }
  function evaluateQuasis(path, quasis, state, raw = false) {
    let str = '';
    let i = 0;
    const exprs = path.isTemplateLiteral()
      ? path.get('expressions')
      : path.get('quasi.expressions');
    for (const elem of quasis) {
      if (!state.confident) break;
      str += raw ? elem.value.raw : elem.value.cooked;
      const expr = exprs[i++];
      if (expr) str += String(evaluateCached(expr, state));
    }
    if (!state.confident) return;
    return str;
  }
  function evaluate() {
    const state = {confident: true, deoptPath: null, seen: new Map()};
    let value = evaluateCached(this, state);
    if (!state.confident) value = undefined;
    return {confident: state.confident, deopt: state.deoptPath, value: value};
  }
  return evaluation$1;
}
var conversion$1 = {};
var lib$i = {};
var formatters$2 = {};
var hasRequiredFormatters$2;
function requireFormatters$2() {
  if (hasRequiredFormatters$2) return formatters$2;
  hasRequiredFormatters$2 = 1;
  Object.defineProperty(formatters$2, '__esModule', {value: true});
  formatters$2.statements =
    formatters$2.statement =
    formatters$2.smart =
    formatters$2.program =
    formatters$2.expression =
      void 0;
  var _t = t$d;
  const {assertExpressionStatement: assertExpressionStatement} = _t;
  function makeStatementFormatter(fn) {
    return {
      code: str => `/* @babel/template */;\n${str}`,
      validate: () => {},
      unwrap: ast => fn(ast.program.body.slice(1)),
    };
  }
  formatters$2.smart = makeStatementFormatter(body => {
    if (body.length > 1) {
      return body;
    } else {
      return body[0];
    }
  });
  formatters$2.statements = makeStatementFormatter(body => body);
  formatters$2.statement = makeStatementFormatter(body => {
    if (body.length === 0) {
      throw new Error('Found nothing to return.');
    }
    if (body.length > 1) {
      throw new Error('Found multiple statements but wanted one');
    }
    return body[0];
  });
  const expression = (formatters$2.expression = {
    code: str => `(\n${str}\n)`,
    validate: ast => {
      if (ast.program.body.length > 1) {
        throw new Error('Found multiple statements but wanted one');
      }
      if (expression.unwrap(ast).start === 0) {
        throw new Error('Parse result included parens.');
      }
    },
    unwrap: ({program: program}) => {
      const [stmt] = program.body;
      assertExpressionStatement(stmt);
      return stmt.expression;
    },
  });
  formatters$2.program = {
    code: str => str,
    validate: () => {},
    unwrap: ast => ast.program,
  };
  return formatters$2;
}
var builder$2 = {};
var options$3 = {};
var hasRequiredOptions$2;
function requireOptions$2() {
  if (hasRequiredOptions$2) return options$3;
  hasRequiredOptions$2 = 1;
  Object.defineProperty(options$3, '__esModule', {value: true});
  options$3.merge = merge;
  options$3.normalizeReplacements = normalizeReplacements;
  options$3.validate = validate;
  const _excluded = [
    'placeholderWhitelist',
    'placeholderPattern',
    'preserveComments',
    'syntacticPlaceholders',
  ];
  function _objectWithoutPropertiesLoose(r, e) {
    if (null == r) return {};
    var t = {};
    for (var n in r)
      if ({}.hasOwnProperty.call(r, n)) {
        if (e.includes(n)) continue;
        t[n] = r[n];
      }
    return t;
  }
  function merge(a, b) {
    const {
      placeholderWhitelist: placeholderWhitelist = a.placeholderWhitelist,
      placeholderPattern: placeholderPattern = a.placeholderPattern,
      preserveComments: preserveComments = a.preserveComments,
      syntacticPlaceholders: syntacticPlaceholders = a.syntacticPlaceholders,
    } = b;
    return {
      parser: Object.assign({}, a.parser, b.parser),
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      preserveComments: preserveComments,
      syntacticPlaceholders: syntacticPlaceholders,
    };
  }
  function validate(opts) {
    if (opts != null && typeof opts !== 'object') {
      throw new Error('Unknown template options.');
    }
    const _ref = opts || {},
      {
        placeholderWhitelist: placeholderWhitelist,
        placeholderPattern: placeholderPattern,
        preserveComments: preserveComments,
        syntacticPlaceholders: syntacticPlaceholders,
      } = _ref,
      parser = _objectWithoutPropertiesLoose(_ref, _excluded);
    if (
      placeholderWhitelist != null &&
      !(placeholderWhitelist instanceof Set)
    ) {
      throw new Error(
        "'.placeholderWhitelist' must be a Set, null, or undefined"
      );
    }
    if (
      placeholderPattern != null &&
      !(placeholderPattern instanceof RegExp) &&
      placeholderPattern !== false
    ) {
      throw new Error(
        "'.placeholderPattern' must be a RegExp, false, null, or undefined"
      );
    }
    if (preserveComments != null && typeof preserveComments !== 'boolean') {
      throw new Error(
        "'.preserveComments' must be a boolean, null, or undefined"
      );
    }
    if (
      syntacticPlaceholders != null &&
      typeof syntacticPlaceholders !== 'boolean'
    ) {
      throw new Error(
        "'.syntacticPlaceholders' must be a boolean, null, or undefined"
      );
    }
    if (
      syntacticPlaceholders === true &&
      (placeholderWhitelist != null || placeholderPattern != null)
    ) {
      throw new Error(
        "'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" +
          " with '.syntacticPlaceholders: true'"
      );
    }
    return {
      parser: parser,
      placeholderWhitelist: placeholderWhitelist || undefined,
      placeholderPattern:
        placeholderPattern == null ? undefined : placeholderPattern,
      preserveComments: preserveComments == null ? undefined : preserveComments,
      syntacticPlaceholders:
        syntacticPlaceholders == null ? undefined : syntacticPlaceholders,
    };
  }
  function normalizeReplacements(replacements) {
    if (Array.isArray(replacements)) {
      return replacements.reduce((acc, replacement, i) => {
        acc['$' + i] = replacement;
        return acc;
      }, {});
    } else if (typeof replacements === 'object' || replacements == null) {
      return replacements || undefined;
    }
    throw new Error(
      'Template replacements must be an array, object, null, or undefined'
    );
  }
  return options$3;
}
var string$2 = {};
var parse$5 = {};
var hasRequiredParse$3;
function requireParse$3() {
  if (hasRequiredParse$3) return parse$5;
  hasRequiredParse$3 = 1;
  Object.defineProperty(parse$5, '__esModule', {value: true});
  parse$5.default = parseAndBuildMetadata;
  var _t = t$d;
  var _parser = requireLib$j();
  var _codeFrame = requireLib$k();
  const {
    isCallExpression: isCallExpression,
    isExpressionStatement: isExpressionStatement,
    isFunction: isFunction,
    isIdentifier: isIdentifier,
    isJSXIdentifier: isJSXIdentifier,
    isNewExpression: isNewExpression,
    isPlaceholder: isPlaceholder,
    isStatement: isStatement,
    isStringLiteral: isStringLiteral,
    removePropertiesDeep: removePropertiesDeep,
    traverse: traverse,
  } = _t;
  const PATTERN = /^[_$A-Z0-9]+$/;
  function parseAndBuildMetadata(formatter, code, opts) {
    const {
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      preserveComments: preserveComments,
      syntacticPlaceholders: syntacticPlaceholders,
    } = opts;
    const ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
    removePropertiesDeep(ast, {preserveComments: preserveComments});
    formatter.validate(ast);
    const state = {
      syntactic: {placeholders: [], placeholderNames: new Set()},
      legacy: {placeholders: [], placeholderNames: new Set()},
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      syntacticPlaceholders: syntacticPlaceholders,
    };
    traverse(ast, placeholderVisitorHandler, state);
    return Object.assign(
      {ast: ast},
      state.syntactic.placeholders.length ? state.syntactic : state.legacy
    );
  }
  function placeholderVisitorHandler(node, ancestors, state) {
    var _state$placeholderWhi;
    let name;
    let hasSyntacticPlaceholders = state.syntactic.placeholders.length > 0;
    if (isPlaceholder(node)) {
      if (state.syntacticPlaceholders === false) {
        throw new Error(
          "%%foo%%-style placeholders can't be used when " +
            "'.syntacticPlaceholders' is false."
        );
      }
      name = node.name.name;
      hasSyntacticPlaceholders = true;
    } else if (hasSyntacticPlaceholders || state.syntacticPlaceholders) {
      return;
    } else if (isIdentifier(node) || isJSXIdentifier(node)) {
      name = node.name;
    } else if (isStringLiteral(node)) {
      name = node.value;
    } else {
      return;
    }
    if (
      hasSyntacticPlaceholders &&
      (state.placeholderPattern != null || state.placeholderWhitelist != null)
    ) {
      throw new Error(
        "'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" +
          " with '.syntacticPlaceholders: true'"
      );
    }
    if (
      !hasSyntacticPlaceholders &&
      (state.placeholderPattern === false ||
        !(state.placeholderPattern || PATTERN).test(name)) &&
      !(
        (_state$placeholderWhi = state.placeholderWhitelist) != null &&
        _state$placeholderWhi.has(name)
      )
    ) {
      return;
    }
    ancestors = ancestors.slice();
    const {node: parent, key: key} = ancestors[ancestors.length - 1];
    let type;
    if (
      isStringLiteral(node) ||
      isPlaceholder(node, {expectedNode: 'StringLiteral'})
    ) {
      type = 'string';
    } else if (
      (isNewExpression(parent) && key === 'arguments') ||
      (isCallExpression(parent) && key === 'arguments') ||
      (isFunction(parent) && key === 'params')
    ) {
      type = 'param';
    } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
      type = 'statement';
      ancestors = ancestors.slice(0, -1);
    } else if (isStatement(node) && isPlaceholder(node)) {
      type = 'statement';
    } else {
      type = 'other';
    }
    const {placeholders: placeholders, placeholderNames: placeholderNames} =
      !hasSyntacticPlaceholders ? state.legacy : state.syntactic;
    placeholders.push({
      name: name,
      type: type,
      resolve: ast => resolveAncestors(ast, ancestors),
      isDuplicate: placeholderNames.has(name),
    });
    placeholderNames.add(name);
  }
  function resolveAncestors(ast, ancestors) {
    let parent = ast;
    for (let i = 0; i < ancestors.length - 1; i++) {
      const {key: key, index: index} = ancestors[i];
      if (index === undefined) {
        parent = parent[key];
      } else {
        parent = parent[key][index];
      }
    }
    const {key: key, index: index} = ancestors[ancestors.length - 1];
    return {parent: parent, key: key, index: index};
  }
  function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
    const plugins = (parserOpts.plugins || []).slice();
    if (syntacticPlaceholders !== false) {
      plugins.push('placeholders');
    }
    parserOpts = Object.assign(
      {
        allowReturnOutsideFunction: true,
        allowSuperOutsideMethod: true,
        sourceType: 'module',
      },
      parserOpts,
      {plugins: plugins}
    );
    try {
      return (0, _parser.parse)(code, parserOpts);
    } catch (err) {
      const loc = err.loc;
      if (loc) {
        err.message +=
          '\n' + (0, _codeFrame.codeFrameColumns)(code, {start: loc});
        err.code = 'BABEL_TEMPLATE_PARSE_ERROR';
      }
      throw err;
    }
  }
  return parse$5;
}
var populate$2 = {};
var hasRequiredPopulate$2;
function requirePopulate$2() {
  if (hasRequiredPopulate$2) return populate$2;
  hasRequiredPopulate$2 = 1;
  Object.defineProperty(populate$2, '__esModule', {value: true});
  populate$2.default = populatePlaceholders;
  var _t = t$d;
  const {
    blockStatement: blockStatement,
    cloneNode: cloneNode,
    emptyStatement: emptyStatement,
    expressionStatement: expressionStatement,
    identifier: identifier,
    isStatement: isStatement,
    isStringLiteral: isStringLiteral,
    stringLiteral: stringLiteral,
    validate: validate,
  } = _t;
  function populatePlaceholders(metadata, replacements) {
    const ast = cloneNode(metadata.ast);
    if (replacements) {
      metadata.placeholders.forEach(placeholder => {
        if (!hasOwnProperty.call(replacements, placeholder.name)) {
          const placeholderName = placeholder.name;
          throw new Error(
            `Error: No substitution given for "${placeholderName}". If this is not meant to be a\n            placeholder you may want to consider passing one of the following options to @babel/template:\n            - { placeholderPattern: false, placeholderWhitelist: new Set(['${placeholderName}'])}\n            - { placeholderPattern: /^${placeholderName}$/ }`
          );
        }
      });
      Object.keys(replacements).forEach(key => {
        if (!metadata.placeholderNames.has(key)) {
          throw new Error(`Unknown substitution "${key}" given`);
        }
      });
    }
    metadata.placeholders
      .slice()
      .reverse()
      .forEach(placeholder => {
        try {
          applyReplacement(
            placeholder,
            ast,
            (replacements && replacements[placeholder.name]) || null
          );
        } catch (e) {
          e.message = `@babel/template placeholder "${placeholder.name}": ${e.message}`;
          throw e;
        }
      });
    return ast;
  }
  function applyReplacement(placeholder, ast, replacement) {
    if (placeholder.isDuplicate) {
      if (Array.isArray(replacement)) {
        replacement = replacement.map(node => cloneNode(node));
      } else if (typeof replacement === 'object') {
        replacement = cloneNode(replacement);
      }
    }
    const {parent: parent, key: key, index: index} = placeholder.resolve(ast);
    if (placeholder.type === 'string') {
      if (typeof replacement === 'string') {
        replacement = stringLiteral(replacement);
      }
      if (!replacement || !isStringLiteral(replacement)) {
        throw new Error('Expected string substitution');
      }
    } else if (placeholder.type === 'statement') {
      if (index === undefined) {
        if (!replacement) {
          replacement = emptyStatement();
        } else if (Array.isArray(replacement)) {
          replacement = blockStatement(replacement);
        } else if (typeof replacement === 'string') {
          replacement = expressionStatement(identifier(replacement));
        } else if (!isStatement(replacement)) {
          replacement = expressionStatement(replacement);
        }
      } else {
        if (replacement && !Array.isArray(replacement)) {
          if (typeof replacement === 'string') {
            replacement = identifier(replacement);
          }
          if (!isStatement(replacement)) {
            replacement = expressionStatement(replacement);
          }
        }
      }
    } else if (placeholder.type === 'param') {
      if (typeof replacement === 'string') {
        replacement = identifier(replacement);
      }
      if (index === undefined) throw new Error('Assertion failure.');
    } else {
      if (typeof replacement === 'string') {
        replacement = identifier(replacement);
      }
      if (Array.isArray(replacement)) {
        throw new Error('Cannot replace single expression with an array.');
      }
    }
    function set(parent, key, value) {
      const node = parent[key];
      parent[key] = value;
      if (node.type === 'Identifier' || node.type === 'Placeholder') {
        if (node.typeAnnotation) {
          value.typeAnnotation = node.typeAnnotation;
        }
        if (node.optional) {
          value.optional = node.optional;
        }
        if (node.decorators) {
          value.decorators = node.decorators;
        }
      }
    }
    if (index === undefined) {
      validate(parent, key, replacement);
      set(parent, key, replacement);
    } else {
      const items = parent[key].slice();
      if (placeholder.type === 'statement' || placeholder.type === 'param') {
        if (replacement == null) {
          items.splice(index, 1);
        } else if (Array.isArray(replacement)) {
          items.splice(index, 1, ...replacement);
        } else {
          set(items, index, replacement);
        }
      } else {
        set(items, index, replacement);
      }
      validate(parent, key, items);
      parent[key] = items;
    }
  }
  return populate$2;
}
var hasRequiredString$2;
function requireString$2() {
  if (hasRequiredString$2) return string$2;
  hasRequiredString$2 = 1;
  Object.defineProperty(string$2, '__esModule', {value: true});
  string$2.default = stringTemplate;
  var _options = requireOptions$2();
  var _parse = requireParse$3();
  var _populate = requirePopulate$2();
  function stringTemplate(formatter, code, opts) {
    code = formatter.code(code);
    let metadata;
    return arg => {
      const replacements = (0, _options.normalizeReplacements)(arg);
      if (!metadata) metadata = (0, _parse.default)(formatter, code, opts);
      return formatter.unwrap((0, _populate.default)(metadata, replacements));
    };
  }
  return string$2;
}
var literal$3 = {};
var hasRequiredLiteral$2;
function requireLiteral$2() {
  if (hasRequiredLiteral$2) return literal$3;
  hasRequiredLiteral$2 = 1;
  Object.defineProperty(literal$3, '__esModule', {value: true});
  literal$3.default = literalTemplate;
  var _options = requireOptions$2();
  var _parse = requireParse$3();
  var _populate = requirePopulate$2();
  function literalTemplate(formatter, tpl, opts) {
    const {metadata: metadata, names: names} = buildLiteralData(
      formatter,
      tpl,
      opts
    );
    return arg => {
      const defaultReplacements = {};
      arg.forEach((replacement, i) => {
        defaultReplacements[names[i]] = replacement;
      });
      return arg => {
        const replacements = (0, _options.normalizeReplacements)(arg);
        if (replacements) {
          Object.keys(replacements).forEach(key => {
            if (hasOwnProperty.call(defaultReplacements, key)) {
              throw new Error('Unexpected replacement overlap.');
            }
          });
        }
        return formatter.unwrap(
          (0, _populate.default)(
            metadata,
            replacements
              ? Object.assign(replacements, defaultReplacements)
              : defaultReplacements
          )
        );
      };
    };
  }
  function buildLiteralData(formatter, tpl, opts) {
    let prefix = 'BABEL_TPL$';
    const raw = tpl.join('');
    do {
      prefix = '$$' + prefix;
    } while (raw.includes(prefix));
    const {names: names, code: code} = buildTemplateCode(tpl, prefix);
    const metadata = (0, _parse.default)(formatter, formatter.code(code), {
      parser: opts.parser,
      placeholderWhitelist: new Set(
        names.concat(
          opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : []
        )
      ),
      placeholderPattern: opts.placeholderPattern,
      preserveComments: opts.preserveComments,
      syntacticPlaceholders: opts.syntacticPlaceholders,
    });
    return {metadata: metadata, names: names};
  }
  function buildTemplateCode(tpl, prefix) {
    const names = [];
    let code = tpl[0];
    for (let i = 1; i < tpl.length; i++) {
      const value = `${prefix}${i - 1}`;
      names.push(value);
      code += value + tpl[i];
    }
    return {names: names, code: code};
  }
  return literal$3;
}
var hasRequiredBuilder$2;
function requireBuilder$2() {
  if (hasRequiredBuilder$2) return builder$2;
  hasRequiredBuilder$2 = 1;
  Object.defineProperty(builder$2, '__esModule', {value: true});
  builder$2.default = createTemplateBuilder;
  var _options = requireOptions$2();
  var _string = requireString$2();
  var _literal = requireLiteral$2();
  const NO_PLACEHOLDER = (0, _options.validate)({placeholderPattern: false});
  function createTemplateBuilder(formatter, defaultOpts) {
    const templateFnCache = new WeakMap();
    const templateAstCache = new WeakMap();
    const cachedOpts = defaultOpts || (0, _options.validate)(null);
    return Object.assign(
      (tpl, ...args) => {
        if (typeof tpl === 'string') {
          if (args.length > 1) throw new Error('Unexpected extra params.');
          return extendedTrace(
            (0, _string.default)(
              formatter,
              tpl,
              (0, _options.merge)(cachedOpts, (0, _options.validate)(args[0]))
            )
          );
        } else if (Array.isArray(tpl)) {
          let builder = templateFnCache.get(tpl);
          if (!builder) {
            builder = (0, _literal.default)(formatter, tpl, cachedOpts);
            templateFnCache.set(tpl, builder);
          }
          return extendedTrace(builder(args));
        } else if (typeof tpl === 'object' && tpl) {
          if (args.length > 0) throw new Error('Unexpected extra params.');
          return createTemplateBuilder(
            formatter,
            (0, _options.merge)(cachedOpts, (0, _options.validate)(tpl))
          );
        }
        throw new Error(`Unexpected template param ${typeof tpl}`);
      },
      {
        ast: (tpl, ...args) => {
          if (typeof tpl === 'string') {
            if (args.length > 1) throw new Error('Unexpected extra params.');
            return (0, _string.default)(
              formatter,
              tpl,
              (0, _options.merge)(
                (0, _options.merge)(
                  cachedOpts,
                  (0, _options.validate)(args[0])
                ),
                NO_PLACEHOLDER
              )
            )();
          } else if (Array.isArray(tpl)) {
            let builder = templateAstCache.get(tpl);
            if (!builder) {
              builder = (0, _literal.default)(
                formatter,
                tpl,
                (0, _options.merge)(cachedOpts, NO_PLACEHOLDER)
              );
              templateAstCache.set(tpl, builder);
            }
            return builder(args)();
          }
          throw new Error(`Unexpected template param ${typeof tpl}`);
        },
      }
    );
  }
  function extendedTrace(fn) {
    let rootStack = '';
    try {
      throw new Error();
    } catch (error) {
      if (error.stack) {
        rootStack = error.stack.split('\n').slice(3).join('\n');
      }
    }
    return arg => {
      try {
        return fn(arg);
      } catch (err) {
        err.stack += `\n    =============\n${rootStack}`;
        throw err;
      }
    };
  }
  return builder$2;
}
var hasRequiredLib$i;
function requireLib$i() {
  if (hasRequiredLib$i) return lib$i;
  hasRequiredLib$i = 1;
  Object.defineProperty(lib$i, '__esModule', {value: true});
  lib$i.statements =
    lib$i.statement =
    lib$i.smart =
    lib$i.program =
    lib$i.expression =
    lib$i.default =
      void 0;
  var formatters = requireFormatters$2();
  var _builder = requireBuilder$2();
  const smart = (lib$i.smart = (0, _builder.default)(formatters.smart));
  const statement = (lib$i.statement = (0, _builder.default)(
    formatters.statement
  ));
  const statements = (lib$i.statements = (0, _builder.default)(
    formatters.statements
  ));
  const expression = (lib$i.expression = (0, _builder.default)(
    formatters.expression
  ));
  const program = (lib$i.program = (0, _builder.default)(formatters.program));
  lib$i.default = Object.assign(smart.bind(undefined), {
    smart: smart,
    statement: statement,
    statements: statements,
    expression: expression,
    program: program,
    ast: smart.ast,
  });
  return lib$i;
}
var hasRequiredConversion$1;
function requireConversion$1() {
  if (hasRequiredConversion$1) return conversion$1;
  hasRequiredConversion$1 = 1;
  Object.defineProperty(conversion$1, '__esModule', {value: true});
  conversion$1.arrowFunctionToExpression = arrowFunctionToExpression;
  conversion$1.ensureBlock = ensureBlock;
  conversion$1.ensureFunctionName = ensureFunctionName;
  conversion$1.splitExportDeclaration = splitExportDeclaration;
  conversion$1.toComputedKey = toComputedKey;
  conversion$1.unwrapFunctionEnvironment = unwrapFunctionEnvironment;
  var _t = t$d;
  var _template = requireLib$i();
  var _visitors = requireVisitors$1();
  var _context = requireContext$2();
  const {
    arrowFunctionExpression: arrowFunctionExpression,
    assignmentExpression: assignmentExpression,
    binaryExpression: binaryExpression,
    blockStatement: blockStatement,
    callExpression: callExpression,
    conditionalExpression: conditionalExpression,
    expressionStatement: expressionStatement,
    identifier: identifier,
    isIdentifier: isIdentifier,
    jsxIdentifier: jsxIdentifier,
    logicalExpression: logicalExpression,
    LOGICAL_OPERATORS: LOGICAL_OPERATORS,
    memberExpression: memberExpression,
    metaProperty: metaProperty,
    numericLiteral: numericLiteral,
    objectExpression: objectExpression,
    restElement: restElement,
    returnStatement: returnStatement,
    sequenceExpression: sequenceExpression,
    spreadElement: spreadElement,
    stringLiteral: stringLiteral,
    super: _super,
    thisExpression: thisExpression,
    toExpression: toExpression,
    unaryExpression: unaryExpression,
    toBindingIdentifierName: toBindingIdentifierName,
    isFunction: isFunction,
    isAssignmentPattern: isAssignmentPattern,
    isRestElement: isRestElement,
    getFunctionName: getFunctionName,
    cloneNode: cloneNode,
    variableDeclaration: variableDeclaration,
    variableDeclarator: variableDeclarator,
    exportNamedDeclaration: exportNamedDeclaration,
    exportSpecifier: exportSpecifier,
    inherits: inherits,
  } = _t;
  function toComputedKey() {
    let key;
    if (this.isMemberExpression()) {
      key = this.node.property;
    } else if (this.isProperty() || this.isMethod()) {
      key = this.node.key;
    } else {
      throw new ReferenceError('todo');
    }
    if (!this.node.computed) {
      if (isIdentifier(key)) key = stringLiteral(key.name);
    }
    return key;
  }
  function ensureBlock() {
    const body = this.get('body');
    const bodyNode = body.node;
    if (Array.isArray(body)) {
      throw new Error("Can't convert array path to a block statement");
    }
    if (!bodyNode) {
      throw new Error("Can't convert node without a body");
    }
    if (body.isBlockStatement()) {
      return bodyNode;
    }
    const statements = [];
    let stringPath = 'body';
    let key;
    let listKey;
    if (body.isStatement()) {
      listKey = 'body';
      key = 0;
      statements.push(body.node);
    } else {
      stringPath += '.body.0';
      if (this.isFunction()) {
        key = 'argument';
        statements.push(returnStatement(body.node));
      } else {
        key = 'expression';
        statements.push(expressionStatement(body.node));
      }
    }
    this.node.body = blockStatement(statements);
    const parentPath = this.get(stringPath);
    _context.setup.call(
      body,
      parentPath,
      listKey ? parentPath.node[listKey] : parentPath.node,
      listKey,
      key
    );
    return this.node;
  }
  {
    conversion$1.arrowFunctionToShadowed = function () {
      if (!this.isArrowFunctionExpression()) return;
      this.arrowFunctionToExpression();
    };
  }
  function unwrapFunctionEnvironment() {
    if (
      !this.isArrowFunctionExpression() &&
      !this.isFunctionExpression() &&
      !this.isFunctionDeclaration()
    ) {
      throw this.buildCodeFrameError(
        'Can only unwrap the environment of a function.'
      );
    }
    hoistFunctionEnvironment(this);
  }
  function setType(path, type) {
    path.node.type = type;
  }
  function arrowFunctionToExpression({
    allowInsertArrow: allowInsertArrow = true,
    allowInsertArrowWithRest: allowInsertArrowWithRest = allowInsertArrow,
    noNewArrows: noNewArrows = !(_arguments$ =>
      (_arguments$ = arguments[0]) == null
        ? void 0
        : _arguments$.specCompliant)(),
  } = {}) {
    if (!this.isArrowFunctionExpression()) {
      throw this.buildCodeFrameError(
        'Cannot convert non-arrow function to a function expression.'
      );
    }
    let self = this;
    if (!noNewArrows) {
      var _self$ensureFunctionN;
      self =
        (_self$ensureFunctionN = self.ensureFunctionName(false)) != null
          ? _self$ensureFunctionN
          : self;
    }
    const {thisBinding: thisBinding, fnPath: fn} = hoistFunctionEnvironment(
      self,
      noNewArrows,
      allowInsertArrow,
      allowInsertArrowWithRest
    );
    fn.ensureBlock();
    setType(fn, 'FunctionExpression');
    if (!noNewArrows) {
      const checkBinding = thisBinding
        ? null
        : fn.scope.generateUidIdentifier('arrowCheckId');
      if (checkBinding) {
        fn.parentPath.scope.push({
          id: checkBinding,
          init: objectExpression([]),
        });
      }
      fn.get('body').unshiftContainer(
        'body',
        expressionStatement(
          callExpression(this.hub.addHelper('newArrowCheck'), [
            thisExpression(),
            checkBinding
              ? identifier(checkBinding.name)
              : identifier(thisBinding),
          ])
        )
      );
      fn.replaceWith(
        callExpression(memberExpression(fn.node, identifier('bind')), [
          checkBinding ? identifier(checkBinding.name) : thisExpression(),
        ])
      );
      return fn.get('callee.object');
    }
    return fn;
  }
  const getSuperCallsVisitor = (0, _visitors.environmentVisitor)({
    CallExpression(child, {allSuperCalls: allSuperCalls}) {
      if (!child.get('callee').isSuper()) return;
      allSuperCalls.push(child);
    },
  });
  function hoistFunctionEnvironment(
    fnPath,
    noNewArrows = true,
    allowInsertArrow = true,
    allowInsertArrowWithRest = true
  ) {
    let arrowParent;
    let thisEnvFn = fnPath.findParent(p => {
      if (p.isArrowFunctionExpression()) {
        var _arrowParent;
        (_arrowParent = arrowParent) != null ? _arrowParent : (arrowParent = p);
        return false;
      }
      return (
        p.isFunction() ||
        p.isProgram() ||
        p.isClassProperty({static: false}) ||
        p.isClassPrivateProperty({static: false})
      );
    });
    const inConstructor = thisEnvFn.isClassMethod({kind: 'constructor'});
    if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
      if (arrowParent) {
        thisEnvFn = arrowParent;
      } else if (allowInsertArrow) {
        fnPath.replaceWith(
          callExpression(
            arrowFunctionExpression([], toExpression(fnPath.node)),
            []
          )
        );
        thisEnvFn = fnPath.get('callee');
        fnPath = thisEnvFn.get('body');
      } else {
        throw fnPath.buildCodeFrameError(
          'Unable to transform arrow inside class property'
        );
      }
    }
    const {
      thisPaths: thisPaths,
      argumentsPaths: argumentsPaths,
      newTargetPaths: newTargetPaths,
      superProps: superProps,
      superCalls: superCalls,
    } = getScopeInformation(fnPath);
    if (inConstructor && superCalls.length > 0) {
      if (!allowInsertArrow) {
        throw superCalls[0].buildCodeFrameError(
          "When using '@babel/plugin-transform-arrow-functions', " +
            "it's not possible to compile `super()` in an arrow function without compiling classes.\n" +
            "Please add '@babel/plugin-transform-classes' to your Babel configuration."
        );
      }
      if (!allowInsertArrowWithRest) {
        throw superCalls[0].buildCodeFrameError(
          "When using '@babel/plugin-transform-parameters', " +
            "it's not possible to compile `super()` in an arrow function with default or rest parameters without compiling classes.\n" +
            "Please add '@babel/plugin-transform-classes' to your Babel configuration."
        );
      }
      const allSuperCalls = [];
      thisEnvFn.traverse(getSuperCallsVisitor, {allSuperCalls: allSuperCalls});
      const superBinding = getSuperBinding(thisEnvFn);
      allSuperCalls.forEach(superCall => {
        const callee = identifier(superBinding);
        callee.loc = superCall.node.callee.loc;
        superCall.get('callee').replaceWith(callee);
      });
    }
    if (argumentsPaths.length > 0) {
      const argumentsBinding = getBinding(thisEnvFn, 'arguments', () => {
        const args = () => identifier('arguments');
        if (thisEnvFn.scope.path.isProgram()) {
          return conditionalExpression(
            binaryExpression(
              '===',
              unaryExpression('typeof', args()),
              stringLiteral('undefined')
            ),
            thisEnvFn.scope.buildUndefinedNode(),
            args()
          );
        } else {
          return args();
        }
      });
      argumentsPaths.forEach(argumentsChild => {
        const argsRef = identifier(argumentsBinding);
        argsRef.loc = argumentsChild.node.loc;
        argumentsChild.replaceWith(argsRef);
      });
    }
    if (newTargetPaths.length > 0) {
      const newTargetBinding = getBinding(thisEnvFn, 'newtarget', () =>
        metaProperty(identifier('new'), identifier('target'))
      );
      newTargetPaths.forEach(targetChild => {
        const targetRef = identifier(newTargetBinding);
        targetRef.loc = targetChild.node.loc;
        targetChild.replaceWith(targetRef);
      });
    }
    if (superProps.length > 0) {
      if (!allowInsertArrow) {
        throw superProps[0].buildCodeFrameError(
          "When using '@babel/plugin-transform-arrow-functions', " +
            "it's not possible to compile `super.prop` in an arrow function without compiling classes.\n" +
            "Please add '@babel/plugin-transform-classes' to your Babel configuration."
        );
      }
      const flatSuperProps = superProps.reduce(
        (acc, superProp) => acc.concat(standardizeSuperProperty(superProp)),
        []
      );
      flatSuperProps.forEach(superProp => {
        const key = superProp.node.computed
          ? ''
          : superProp.get('property').node.name;
        const superParentPath = superProp.parentPath;
        const isAssignment = superParentPath.isAssignmentExpression({
          left: superProp.node,
        });
        const isCall = superParentPath.isCallExpression({
          callee: superProp.node,
        });
        const isTaggedTemplate = superParentPath.isTaggedTemplateExpression({
          tag: superProp.node,
        });
        const superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
        const args = [];
        if (superProp.node.computed) {
          args.push(superProp.get('property').node);
        }
        if (isAssignment) {
          const value = superParentPath.node.right;
          args.push(value);
        }
        const call = callExpression(identifier(superBinding), args);
        if (isCall) {
          superParentPath.unshiftContainer('arguments', thisExpression());
          superProp.replaceWith(memberExpression(call, identifier('call')));
          thisPaths.push(superParentPath.get('arguments.0'));
        } else if (isAssignment) {
          superParentPath.replaceWith(call);
        } else if (isTaggedTemplate) {
          superProp.replaceWith(
            callExpression(memberExpression(call, identifier('bind'), false), [
              thisExpression(),
            ])
          );
          thisPaths.push(superProp.get('arguments.0'));
        } else {
          superProp.replaceWith(call);
        }
      });
    }
    let thisBinding;
    if (thisPaths.length > 0 || !noNewArrows) {
      thisBinding = getThisBinding(thisEnvFn, inConstructor);
      if (noNewArrows || (inConstructor && hasSuperClass(thisEnvFn))) {
        thisPaths.forEach(thisChild => {
          const thisRef = thisChild.isJSX()
            ? jsxIdentifier(thisBinding)
            : identifier(thisBinding);
          thisRef.loc = thisChild.node.loc;
          thisChild.replaceWith(thisRef);
        });
        if (!noNewArrows) thisBinding = null;
      }
    }
    return {thisBinding: thisBinding, fnPath: fnPath};
  }
  function isLogicalOp(op) {
    return LOGICAL_OPERATORS.includes(op);
  }
  function standardizeSuperProperty(superProp) {
    if (
      superProp.parentPath.isAssignmentExpression() &&
      superProp.parentPath.node.operator !== '='
    ) {
      const assignmentPath = superProp.parentPath;
      const op = assignmentPath.node.operator.slice(0, -1);
      const value = assignmentPath.node.right;
      const isLogicalAssignment = isLogicalOp(op);
      if (superProp.node.computed) {
        const tmp = superProp.scope.generateDeclaredUidIdentifier('tmp');
        const object = superProp.node.object;
        const property = superProp.node.property;
        assignmentPath
          .get('left')
          .replaceWith(
            memberExpression(
              object,
              assignmentExpression('=', tmp, property),
              true
            )
          );
        assignmentPath
          .get('right')
          .replaceWith(
            rightExpression(
              isLogicalAssignment ? '=' : op,
              memberExpression(object, identifier(tmp.name), true),
              value
            )
          );
      } else {
        const object = superProp.node.object;
        const property = superProp.node.property;
        assignmentPath
          .get('left')
          .replaceWith(memberExpression(object, property));
        assignmentPath
          .get('right')
          .replaceWith(
            rightExpression(
              isLogicalAssignment ? '=' : op,
              memberExpression(object, identifier(property.name)),
              value
            )
          );
      }
      if (isLogicalAssignment) {
        assignmentPath.replaceWith(
          logicalExpression(
            op,
            assignmentPath.node.left,
            assignmentPath.node.right
          )
        );
      } else {
        assignmentPath.node.operator = '=';
      }
      return [
        assignmentPath.get('left'),
        assignmentPath.get('right').get('left'),
      ];
    } else if (superProp.parentPath.isUpdateExpression()) {
      const updateExpr = superProp.parentPath;
      const tmp = superProp.scope.generateDeclaredUidIdentifier('tmp');
      const computedKey = superProp.node.computed
        ? superProp.scope.generateDeclaredUidIdentifier('prop')
        : null;
      const parts = [
        assignmentExpression(
          '=',
          tmp,
          memberExpression(
            superProp.node.object,
            computedKey
              ? assignmentExpression('=', computedKey, superProp.node.property)
              : superProp.node.property,
            superProp.node.computed
          )
        ),
        assignmentExpression(
          '=',
          memberExpression(
            superProp.node.object,
            computedKey
              ? identifier(computedKey.name)
              : superProp.node.property,
            superProp.node.computed
          ),
          binaryExpression(
            superProp.parentPath.node.operator[0],
            identifier(tmp.name),
            numericLiteral(1)
          )
        ),
      ];
      if (!superProp.parentPath.node.prefix) {
        parts.push(identifier(tmp.name));
      }
      updateExpr.replaceWith(sequenceExpression(parts));
      const left = updateExpr.get('expressions.0.right');
      const right = updateExpr.get('expressions.1.left');
      return [left, right];
    }
    return [superProp];
    function rightExpression(op, left, right) {
      if (op === '=') {
        return assignmentExpression('=', left, right);
      } else {
        return binaryExpression(op, left, right);
      }
    }
  }
  function hasSuperClass(thisEnvFn) {
    return (
      thisEnvFn.isClassMethod() &&
      !!thisEnvFn.parentPath.parentPath.node.superClass
    );
  }
  const assignSuperThisVisitor = (0, _visitors.environmentVisitor)({
    CallExpression(child, {supers: supers, thisBinding: thisBinding}) {
      if (!child.get('callee').isSuper()) return;
      if (supers.has(child.node)) return;
      supers.add(child.node);
      child.replaceWithMultiple([
        child.node,
        assignmentExpression('=', identifier(thisBinding), identifier('this')),
      ]);
    },
  });
  function getThisBinding(thisEnvFn, inConstructor) {
    return getBinding(thisEnvFn, 'this', thisBinding => {
      if (!inConstructor || !hasSuperClass(thisEnvFn)) return thisExpression();
      thisEnvFn.traverse(assignSuperThisVisitor, {
        supers: new WeakSet(),
        thisBinding: thisBinding,
      });
    });
  }
  function getSuperBinding(thisEnvFn) {
    return getBinding(thisEnvFn, 'supercall', () => {
      const argsBinding = thisEnvFn.scope.generateUidIdentifier('args');
      return arrowFunctionExpression(
        [restElement(argsBinding)],
        callExpression(_super(), [spreadElement(identifier(argsBinding.name))])
      );
    });
  }
  function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
    const op = isAssignment ? 'set' : 'get';
    return getBinding(thisEnvFn, `superprop_${op}:${propName || ''}`, () => {
      const argsList = [];
      let fnBody;
      if (propName) {
        fnBody = memberExpression(_super(), identifier(propName));
      } else {
        const method = thisEnvFn.scope.generateUidIdentifier('prop');
        argsList.unshift(method);
        fnBody = memberExpression(_super(), identifier(method.name), true);
      }
      if (isAssignment) {
        const valueIdent = thisEnvFn.scope.generateUidIdentifier('value');
        argsList.push(valueIdent);
        fnBody = assignmentExpression('=', fnBody, identifier(valueIdent.name));
      }
      return arrowFunctionExpression(argsList, fnBody);
    });
  }
  function getBinding(thisEnvFn, key, init) {
    const cacheKey = 'binding:' + key;
    let data = thisEnvFn.getData(cacheKey);
    if (!data) {
      const id = thisEnvFn.scope.generateUidIdentifier(key);
      data = id.name;
      thisEnvFn.setData(cacheKey, data);
      thisEnvFn.scope.push({id: id, init: init(data)});
    }
    return data;
  }
  const getScopeInformationVisitor = (0, _visitors.environmentVisitor)({
    ThisExpression(child, {thisPaths: thisPaths}) {
      thisPaths.push(child);
    },
    JSXIdentifier(child, {thisPaths: thisPaths}) {
      if (child.node.name !== 'this') return;
      if (
        !child.parentPath.isJSXMemberExpression({object: child.node}) &&
        !child.parentPath.isJSXOpeningElement({name: child.node})
      ) {
        return;
      }
      thisPaths.push(child);
    },
    CallExpression(child, {superCalls: superCalls}) {
      if (child.get('callee').isSuper()) superCalls.push(child);
    },
    MemberExpression(child, {superProps: superProps}) {
      if (child.get('object').isSuper()) superProps.push(child);
    },
    Identifier(child, {argumentsPaths: argumentsPaths}) {
      if (!child.isReferencedIdentifier({name: 'arguments'})) return;
      let curr = child.scope;
      do {
        if (curr.hasOwnBinding('arguments')) {
          curr.rename('arguments');
          return;
        }
        if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
          break;
        }
      } while ((curr = curr.parent));
      argumentsPaths.push(child);
    },
    MetaProperty(child, {newTargetPaths: newTargetPaths}) {
      if (!child.get('meta').isIdentifier({name: 'new'})) return;
      if (!child.get('property').isIdentifier({name: 'target'})) return;
      newTargetPaths.push(child);
    },
  });
  function getScopeInformation(fnPath) {
    const thisPaths = [];
    const argumentsPaths = [];
    const newTargetPaths = [];
    const superProps = [];
    const superCalls = [];
    fnPath.traverse(getScopeInformationVisitor, {
      thisPaths: thisPaths,
      argumentsPaths: argumentsPaths,
      newTargetPaths: newTargetPaths,
      superProps: superProps,
      superCalls: superCalls,
    });
    return {
      thisPaths: thisPaths,
      argumentsPaths: argumentsPaths,
      newTargetPaths: newTargetPaths,
      superProps: superProps,
      superCalls: superCalls,
    };
  }
  function splitExportDeclaration() {
    if (!this.isExportDeclaration() || this.isExportAllDeclaration()) {
      throw new Error(
        'Only default and named export declarations can be split.'
      );
    }
    if (this.isExportNamedDeclaration() && this.get('specifiers').length > 0) {
      throw new Error("It doesn't make sense to split exported specifiers.");
    }
    const declaration = this.get('declaration');
    if (this.isExportDefaultDeclaration()) {
      const standaloneDeclaration =
        declaration.isFunctionDeclaration() || declaration.isClassDeclaration();
      const exportExpr =
        declaration.isFunctionExpression() || declaration.isClassExpression();
      const scope = declaration.isScope()
        ? declaration.scope.parent
        : declaration.scope;
      let id = declaration.node.id;
      let needBindingRegistration = false;
      if (!id) {
        needBindingRegistration = true;
        id = scope.generateUidIdentifier('default');
        if (standaloneDeclaration || exportExpr) {
          declaration.node.id = cloneNode(id);
        }
      } else if (exportExpr && scope.hasBinding(id.name)) {
        needBindingRegistration = true;
        id = scope.generateUidIdentifier(id.name);
      }
      const updatedDeclaration = standaloneDeclaration
        ? declaration.node
        : variableDeclaration('var', [
            variableDeclarator(cloneNode(id), declaration.node),
          ]);
      const updatedExportDeclaration = exportNamedDeclaration(null, [
        exportSpecifier(cloneNode(id), identifier('default')),
      ]);
      this.insertAfter(updatedExportDeclaration);
      this.replaceWith(updatedDeclaration);
      if (needBindingRegistration) {
        scope.registerDeclaration(this);
      }
      return this;
    } else if (this.get('specifiers').length > 0) {
      throw new Error("It doesn't make sense to split exported specifiers.");
    }
    const bindingIdentifiers = declaration.getOuterBindingIdentifiers();
    const specifiers = Object.keys(bindingIdentifiers).map(name =>
      exportSpecifier(identifier(name), identifier(name))
    );
    const aliasDeclar = exportNamedDeclaration(null, specifiers);
    this.insertAfter(aliasDeclar);
    this.replaceWith(declaration.node);
    return this;
  }
  const refersOuterBindingVisitor = {
    'ReferencedIdentifier|BindingIdentifier'(path, state) {
      if (path.node.name !== state.name) return;
      state.needsRename = true;
      path.stop();
    },
    Scope(path, state) {
      if (path.scope.hasOwnBinding(state.name)) {
        path.skip();
      }
    },
  };
  function ensureFunctionName(supportUnicodeId) {
    if (this.node.id) return this;
    const res = getFunctionName(this.node, this.parent);
    if (res == null) return this;
    let {name: name} = res;
    if (!supportUnicodeId && /[\uD800-\uDFFF]/.test(name)) {
      return null;
    }
    if (name.startsWith('get ') || name.startsWith('set ')) {
      return null;
    }
    name = toBindingIdentifierName(name.replace(/[/ ]/g, '_'));
    const id = identifier(name);
    inherits(id, res.originalNode);
    const state = {needsRename: false, name: name};
    const {scope: scope} = this;
    const binding = scope.getOwnBinding(name);
    if (binding) {
      if (binding.kind === 'param') {
        state.needsRename = true;
      }
    } else if (scope.parent.hasBinding(name) || scope.hasGlobal(name)) {
      this.traverse(refersOuterBindingVisitor, state);
    }
    if (!state.needsRename) {
      this.node.id = id;
      scope.getProgramParent().references[id.name] = true;
      return this;
    }
    if (scope.hasBinding(id.name) && !scope.hasGlobal(id.name)) {
      scope.rename(id.name);
      this.node.id = id;
      scope.getProgramParent().references[id.name] = true;
      return this;
    }
    if (!isFunction(this.node)) return null;
    const key = scope.generateUidIdentifier(id.name);
    const params = [];
    for (let i = 0, len = getFunctionArity(this.node); i < len; i++) {
      params.push(scope.generateUidIdentifier('x'));
    }
    const call = _template.default.expression.ast`
    (function (${key}) {
      function ${id}(${params}) {
        return ${cloneNode(key)}.apply(this, arguments);
      }

      ${cloneNode(id)}.toString = function () {
        return ${cloneNode(key)}.toString();
      }

      return ${cloneNode(id)};
    })(${toExpression(this.node)})
  `;
    return this.replaceWith(call)[0].get('arguments.0');
  }
  function getFunctionArity(node) {
    const count = node.params.findIndex(
      param => isAssignmentPattern(param) || isRestElement(param)
    );
    return count === -1 ? node.params.length : count;
  }
  return conversion$1;
}
var introspection$1 = {};
var hasRequiredIntrospection$1;
function requireIntrospection$1() {
  if (hasRequiredIntrospection$1) return introspection$1;
  hasRequiredIntrospection$1 = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports._guessExecutionStatusRelativeTo = _guessExecutionStatusRelativeTo;
    exports._resolve = _resolve;
    exports.canHaveVariableDeclarationOrExpression =
      canHaveVariableDeclarationOrExpression;
    exports.canSwapBetweenExpressionAndStatement =
      canSwapBetweenExpressionAndStatement;
    exports.getSource = getSource;
    exports.isCompletionRecord = isCompletionRecord;
    exports.isConstantExpression = isConstantExpression;
    exports.isInStrictMode = isInStrictMode;
    exports.isNodeType = isNodeType;
    exports.isStatementOrBlock = isStatementOrBlock;
    exports.isStatic = isStatic;
    exports.matchesPattern = matchesPattern;
    exports.referencesImport = referencesImport;
    exports.resolve = resolve;
    exports.willIMaybeExecuteBefore = willIMaybeExecuteBefore;
    var _t = t$d;
    const {
      STATEMENT_OR_BLOCK_KEYS: STATEMENT_OR_BLOCK_KEYS,
      VISITOR_KEYS: VISITOR_KEYS,
      isBlockStatement: isBlockStatement,
      isExpression: isExpression,
      isIdentifier: isIdentifier,
      isLiteral: isLiteral,
      isStringLiteral: isStringLiteral,
      isType: isType,
      matchesPattern: _matchesPattern,
    } = _t;
    function matchesPattern(pattern, allowPartial) {
      return _matchesPattern(this.node, pattern, allowPartial);
    }
    {
      exports.has = function has(key) {
        var _this$node;
        const val = (_this$node = this.node) == null ? void 0 : _this$node[key];
        if (val && Array.isArray(val)) {
          return !!val.length;
        } else {
          return !!val;
        }
      };
    }
    function isStatic() {
      return this.scope.isStatic(this.node);
    }
    {
      exports.is = exports.has;
      exports.isnt = function isnt(key) {
        return !this.has(key);
      };
      exports.equals = function equals(key, value) {
        return this.node[key] === value;
      };
    }
    function isNodeType(type) {
      return isType(this.type, type);
    }
    function canHaveVariableDeclarationOrExpression() {
      return (
        (this.key === 'init' || this.key === 'left') && this.parentPath.isFor()
      );
    }
    function canSwapBetweenExpressionAndStatement(replacement) {
      if (this.key !== 'body' || !this.parentPath.isArrowFunctionExpression()) {
        return false;
      }
      if (this.isExpression()) {
        return isBlockStatement(replacement);
      } else if (this.isBlockStatement()) {
        return isExpression(replacement);
      }
      return false;
    }
    function isCompletionRecord(allowInsideFunction) {
      let path = this;
      let first = true;
      do {
        const {type: type, container: container} = path;
        if (!first && (path.isFunction() || type === 'StaticBlock')) {
          return !!allowInsideFunction;
        }
        first = false;
        if (Array.isArray(container) && path.key !== container.length - 1) {
          return false;
        }
      } while (
        (path = path.parentPath) &&
        !path.isProgram() &&
        !path.isDoExpression()
      );
      return true;
    }
    function isStatementOrBlock() {
      if (
        this.parentPath.isLabeledStatement() ||
        isBlockStatement(this.container)
      ) {
        return false;
      } else {
        return STATEMENT_OR_BLOCK_KEYS.includes(this.key);
      }
    }
    function referencesImport(moduleSource, importName) {
      if (!this.isReferencedIdentifier()) {
        if (
          (this.isJSXMemberExpression() &&
            this.node.property.name === importName) ||
          ((this.isMemberExpression() || this.isOptionalMemberExpression()) &&
            (this.node.computed
              ? isStringLiteral(this.node.property, {value: importName})
              : this.node.property.name === importName))
        ) {
          const object = this.get('object');
          return (
            object.isReferencedIdentifier() &&
            object.referencesImport(moduleSource, '*')
          );
        }
        return false;
      }
      const binding = this.scope.getBinding(this.node.name);
      if (!binding || binding.kind !== 'module') return false;
      const path = binding.path;
      const parent = path.parentPath;
      if (!parent.isImportDeclaration()) return false;
      if (parent.node.source.value === moduleSource) {
        if (!importName) return true;
      } else {
        return false;
      }
      if (path.isImportDefaultSpecifier() && importName === 'default') {
        return true;
      }
      if (path.isImportNamespaceSpecifier() && importName === '*') {
        return true;
      }
      if (
        path.isImportSpecifier() &&
        isIdentifier(path.node.imported, {name: importName})
      ) {
        return true;
      }
      return false;
    }
    function getSource() {
      const node = this.node;
      if (node.end) {
        const code = this.hub.getCode();
        if (code) return code.slice(node.start, node.end);
      }
      return '';
    }
    function willIMaybeExecuteBefore(target) {
      return this._guessExecutionStatusRelativeTo(target) !== 'after';
    }
    function getOuterFunction(path) {
      return path.isProgram()
        ? path
        : (
            path.parentPath.scope.getFunctionParent() ||
            path.parentPath.scope.getProgramParent()
          ).path;
    }
    function isExecutionUncertain(type, key) {
      switch (type) {
        case 'LogicalExpression':
          return key === 'right';
        case 'ConditionalExpression':
        case 'IfStatement':
          return key === 'consequent' || key === 'alternate';
        case 'WhileStatement':
        case 'DoWhileStatement':
        case 'ForInStatement':
        case 'ForOfStatement':
          return key === 'body';
        case 'ForStatement':
          return key === 'body' || key === 'update';
        case 'SwitchStatement':
          return key === 'cases';
        case 'TryStatement':
          return key === 'handler';
        case 'AssignmentPattern':
          return key === 'right';
        case 'OptionalMemberExpression':
          return key === 'property';
        case 'OptionalCallExpression':
          return key === 'arguments';
        default:
          return false;
      }
    }
    function isExecutionUncertainInList(paths, maxIndex) {
      for (let i = 0; i < maxIndex; i++) {
        const path = paths[i];
        if (isExecutionUncertain(path.parent.type, path.parentKey)) {
          return true;
        }
      }
      return false;
    }
    const SYMBOL_CHECKING = Symbol();
    function _guessExecutionStatusRelativeTo(target) {
      return _guessExecutionStatusRelativeToCached(this, target, new Map());
    }
    function _guessExecutionStatusRelativeToCached(base, target, cache) {
      const funcParent = {
        this: getOuterFunction(base),
        target: getOuterFunction(target),
      };
      if (funcParent.target.node !== funcParent.this.node) {
        return _guessExecutionStatusRelativeToDifferentFunctionsCached(
          base,
          funcParent.target,
          cache
        );
      }
      const paths = {target: target.getAncestry(), this: base.getAncestry()};
      if (paths.target.includes(base)) return 'after';
      if (paths.this.includes(target)) return 'before';
      let commonPath;
      const commonIndex = {target: 0, this: 0};
      while (!commonPath && commonIndex.this < paths.this.length) {
        const path = paths.this[commonIndex.this];
        commonIndex.target = paths.target.indexOf(path);
        if (commonIndex.target >= 0) {
          commonPath = path;
        } else {
          commonIndex.this++;
        }
      }
      if (!commonPath) {
        throw new Error(
          'Internal Babel error - The two compared nodes' +
            " don't appear to belong to the same program."
        );
      }
      if (
        isExecutionUncertainInList(paths.this, commonIndex.this - 1) ||
        isExecutionUncertainInList(paths.target, commonIndex.target - 1)
      ) {
        return 'unknown';
      }
      const divergence = {
        this: paths.this[commonIndex.this - 1],
        target: paths.target[commonIndex.target - 1],
      };
      if (
        divergence.target.listKey &&
        divergence.this.listKey &&
        divergence.target.container === divergence.this.container
      ) {
        return divergence.target.key > divergence.this.key ? 'before' : 'after';
      }
      const keys = VISITOR_KEYS[commonPath.type];
      const keyPosition = {
        this: keys.indexOf(divergence.this.parentKey),
        target: keys.indexOf(divergence.target.parentKey),
      };
      return keyPosition.target > keyPosition.this ? 'before' : 'after';
    }
    function _guessExecutionStatusRelativeToDifferentFunctionsInternal(
      base,
      target,
      cache
    ) {
      if (!target.isFunctionDeclaration()) {
        if (
          _guessExecutionStatusRelativeToCached(base, target, cache) ===
          'before'
        ) {
          return 'before';
        }
        return 'unknown';
      } else if (target.parentPath.isExportDeclaration()) {
        return 'unknown';
      }
      const binding = target.scope.getBinding(target.node.id.name);
      if (!binding.references) return 'before';
      const referencePaths = binding.referencePaths;
      let allStatus;
      for (const path of referencePaths) {
        const childOfFunction = !!path.find(path => path.node === target.node);
        if (childOfFunction) continue;
        if (path.key !== 'callee' || !path.parentPath.isCallExpression()) {
          return 'unknown';
        }
        const status = _guessExecutionStatusRelativeToCached(base, path, cache);
        if (allStatus && allStatus !== status) {
          return 'unknown';
        } else {
          allStatus = status;
        }
      }
      return allStatus;
    }
    function _guessExecutionStatusRelativeToDifferentFunctionsCached(
      base,
      target,
      cache
    ) {
      let nodeMap = cache.get(base.node);
      let cached;
      if (!nodeMap) {
        cache.set(base.node, (nodeMap = new Map()));
      } else if ((cached = nodeMap.get(target.node))) {
        if (cached === SYMBOL_CHECKING) {
          return 'unknown';
        }
        return cached;
      }
      nodeMap.set(target.node, SYMBOL_CHECKING);
      const result = _guessExecutionStatusRelativeToDifferentFunctionsInternal(
        base,
        target,
        cache
      );
      nodeMap.set(target.node, result);
      return result;
    }
    function resolve(dangerous, resolved) {
      return _resolve.call(this, dangerous, resolved) || this;
    }
    function _resolve(dangerous, resolved) {
      var _resolved;
      if ((_resolved = resolved) != null && _resolved.includes(this)) return;
      resolved = resolved || [];
      resolved.push(this);
      if (this.isVariableDeclarator()) {
        if (this.get('id').isIdentifier()) {
          return this.get('init').resolve(dangerous, resolved);
        }
      } else if (this.isReferencedIdentifier()) {
        const binding = this.scope.getBinding(this.node.name);
        if (!binding) return;
        if (!binding.constant) return;
        if (binding.kind === 'module') return;
        if (binding.path !== this) {
          const ret = binding.path.resolve(dangerous, resolved);
          if (this.find(parent => parent.node === ret.node)) return;
          return ret;
        }
      } else if (this.isTypeCastExpression()) {
        return this.get('expression').resolve(dangerous, resolved);
      } else if (dangerous && this.isMemberExpression()) {
        const targetKey = this.toComputedKey();
        if (!isLiteral(targetKey)) return;
        const targetName = targetKey.value;
        const target = this.get('object').resolve(dangerous, resolved);
        if (target.isObjectExpression()) {
          const props = target.get('properties');
          for (const prop of props) {
            if (!prop.isProperty()) continue;
            const key = prop.get('key');
            let match =
              prop.isnt('computed') && key.isIdentifier({name: targetName});
            match = match || key.isLiteral({value: targetName});
            if (match) return prop.get('value').resolve(dangerous, resolved);
          }
        } else if (target.isArrayExpression() && !isNaN(+targetName)) {
          const elems = target.get('elements');
          const elem = elems[targetName];
          if (elem) return elem.resolve(dangerous, resolved);
        }
      }
    }
    function isConstantExpression() {
      if (this.isIdentifier()) {
        const binding = this.scope.getBinding(this.node.name);
        if (!binding) return false;
        return binding.constant;
      }
      if (this.isLiteral()) {
        if (this.isRegExpLiteral()) {
          return false;
        }
        if (this.isTemplateLiteral()) {
          return this.get('expressions').every(expression =>
            expression.isConstantExpression()
          );
        }
        return true;
      }
      if (this.isUnaryExpression()) {
        if (this.node.operator !== 'void') {
          return false;
        }
        return this.get('argument').isConstantExpression();
      }
      if (this.isBinaryExpression()) {
        const {operator: operator} = this.node;
        return (
          operator !== 'in' &&
          operator !== 'instanceof' &&
          this.get('left').isConstantExpression() &&
          this.get('right').isConstantExpression()
        );
      }
      if (this.isMemberExpression()) {
        return (
          !this.node.computed &&
          this.get('object').isIdentifier({name: 'Symbol'}) &&
          !this.scope.hasBinding('Symbol', {noGlobals: true})
        );
      }
      if (this.isCallExpression()) {
        return (
          this.node.arguments.length === 1 &&
          this.get('callee').matchesPattern('Symbol.for') &&
          !this.scope.hasBinding('Symbol', {noGlobals: true}) &&
          this.get('arguments')[0].isStringLiteral()
        );
      }
      return false;
    }
    function isInStrictMode() {
      const start = this.isProgram() ? this : this.parentPath;
      const strictParent = start.find(path => {
        if (path.isProgram({sourceType: 'module'})) return true;
        if (path.isClass()) return true;
        if (
          path.isArrowFunctionExpression() &&
          !path.get('body').isBlockStatement()
        ) {
          return false;
        }
        let body;
        if (path.isFunction()) {
          body = path.node.body;
        } else if (path.isProgram()) {
          body = path.node;
        } else {
          return false;
        }
        for (const directive of body.directives) {
          if (directive.value.value === 'use strict') {
            return true;
          }
        }
      });
      return !!strictParent;
    }
  })(introspection$1);
  return introspection$1;
}
var family$1 = {};
var hasRequiredFamily$1;
function requireFamily$1() {
  if (hasRequiredFamily$1) return family$1;
  hasRequiredFamily$1 = 1;
  Object.defineProperty(family$1, '__esModule', {value: true});
  family$1._getKey = _getKey;
  family$1._getPattern = _getPattern;
  family$1.get = get;
  family$1.getAllNextSiblings = getAllNextSiblings;
  family$1.getAllPrevSiblings = getAllPrevSiblings;
  family$1.getAssignmentIdentifiers = getAssignmentIdentifiers;
  family$1.getBindingIdentifierPaths = getBindingIdentifierPaths;
  family$1.getBindingIdentifiers = getBindingIdentifiers;
  family$1.getCompletionRecords = getCompletionRecords;
  family$1.getNextSibling = getNextSibling;
  family$1.getOpposite = getOpposite;
  family$1.getOuterBindingIdentifierPaths = getOuterBindingIdentifierPaths;
  family$1.getOuterBindingIdentifiers = getOuterBindingIdentifiers;
  family$1.getPrevSibling = getPrevSibling;
  family$1.getSibling = getSibling;
  var _index = requirePath$1();
  var _t = t$d;
  const {
    getAssignmentIdentifiers: _getAssignmentIdentifiers,
    getBindingIdentifiers: _getBindingIdentifiers,
    getOuterBindingIdentifiers: _getOuterBindingIdentifiers,
    numericLiteral: numericLiteral,
    unaryExpression: unaryExpression,
  } = _t;
  const NORMAL_COMPLETION = 0;
  const BREAK_COMPLETION = 1;
  function NormalCompletion(path) {
    return {type: NORMAL_COMPLETION, path: path};
  }
  function BreakCompletion(path) {
    return {type: BREAK_COMPLETION, path: path};
  }
  function getOpposite() {
    if (this.key === 'left') {
      return this.getSibling('right');
    } else if (this.key === 'right') {
      return this.getSibling('left');
    }
    return null;
  }
  function addCompletionRecords(path, records, context) {
    if (path) {
      records.push(..._getCompletionRecords(path, context));
    }
    return records;
  }
  function completionRecordForSwitch(cases, records, context) {
    let lastNormalCompletions = [];
    for (let i = 0; i < cases.length; i++) {
      const casePath = cases[i];
      const caseCompletions = _getCompletionRecords(casePath, context);
      const normalCompletions = [];
      const breakCompletions = [];
      for (const c of caseCompletions) {
        if (c.type === NORMAL_COMPLETION) {
          normalCompletions.push(c);
        }
        if (c.type === BREAK_COMPLETION) {
          breakCompletions.push(c);
        }
      }
      if (normalCompletions.length) {
        lastNormalCompletions = normalCompletions;
      }
      records.push(...breakCompletions);
    }
    records.push(...lastNormalCompletions);
    return records;
  }
  function normalCompletionToBreak(completions) {
    completions.forEach(c => {
      c.type = BREAK_COMPLETION;
    });
  }
  function replaceBreakStatementInBreakCompletion(completions, reachable) {
    completions.forEach(c => {
      if (c.path.isBreakStatement({label: null})) {
        if (reachable) {
          c.path.replaceWith(unaryExpression('void', numericLiteral(0)));
        } else {
          c.path.remove();
        }
      }
    });
  }
  function getStatementListCompletion(paths, context) {
    const completions = [];
    if (context.canHaveBreak) {
      let lastNormalCompletions = [];
      for (let i = 0; i < paths.length; i++) {
        const path = paths[i];
        const newContext = Object.assign({}, context, {inCaseClause: false});
        if (
          path.isBlockStatement() &&
          (context.inCaseClause || context.shouldPopulateBreak)
        ) {
          newContext.shouldPopulateBreak = true;
        } else {
          newContext.shouldPopulateBreak = false;
        }
        const statementCompletions = _getCompletionRecords(path, newContext);
        if (
          statementCompletions.length > 0 &&
          statementCompletions.every(c => c.type === BREAK_COMPLETION)
        ) {
          if (
            lastNormalCompletions.length > 0 &&
            statementCompletions.every(c =>
              c.path.isBreakStatement({label: null})
            )
          ) {
            normalCompletionToBreak(lastNormalCompletions);
            completions.push(...lastNormalCompletions);
            if (lastNormalCompletions.some(c => c.path.isDeclaration())) {
              completions.push(...statementCompletions);
              replaceBreakStatementInBreakCompletion(
                statementCompletions,
                true
              );
            }
            replaceBreakStatementInBreakCompletion(statementCompletions, false);
          } else {
            completions.push(...statementCompletions);
            if (!context.shouldPopulateBreak) {
              replaceBreakStatementInBreakCompletion(
                statementCompletions,
                true
              );
            }
          }
          break;
        }
        if (i === paths.length - 1) {
          completions.push(...statementCompletions);
        } else {
          lastNormalCompletions = [];
          for (let i = 0; i < statementCompletions.length; i++) {
            const c = statementCompletions[i];
            if (c.type === BREAK_COMPLETION) {
              completions.push(c);
            }
            if (c.type === NORMAL_COMPLETION) {
              lastNormalCompletions.push(c);
            }
          }
        }
      }
    } else if (paths.length) {
      for (let i = paths.length - 1; i >= 0; i--) {
        const pathCompletions = _getCompletionRecords(paths[i], context);
        if (
          pathCompletions.length > 1 ||
          (pathCompletions.length === 1 &&
            !pathCompletions[0].path.isVariableDeclaration())
        ) {
          completions.push(...pathCompletions);
          break;
        }
      }
    }
    return completions;
  }
  function _getCompletionRecords(path, context) {
    let records = [];
    if (path.isIfStatement()) {
      records = addCompletionRecords(path.get('consequent'), records, context);
      records = addCompletionRecords(path.get('alternate'), records, context);
    } else if (
      path.isDoExpression() ||
      path.isFor() ||
      path.isWhile() ||
      path.isLabeledStatement()
    ) {
      return addCompletionRecords(path.get('body'), records, context);
    } else if (path.isProgram() || path.isBlockStatement()) {
      return getStatementListCompletion(path.get('body'), context);
    } else if (path.isFunction()) {
      return _getCompletionRecords(path.get('body'), context);
    } else if (path.isTryStatement()) {
      records = addCompletionRecords(path.get('block'), records, context);
      records = addCompletionRecords(path.get('handler'), records, context);
    } else if (path.isCatchClause()) {
      return addCompletionRecords(path.get('body'), records, context);
    } else if (path.isSwitchStatement()) {
      return completionRecordForSwitch(path.get('cases'), records, context);
    } else if (path.isSwitchCase()) {
      return getStatementListCompletion(path.get('consequent'), {
        canHaveBreak: true,
        shouldPopulateBreak: false,
        inCaseClause: true,
      });
    } else if (path.isBreakStatement()) {
      records.push(BreakCompletion(path));
    } else {
      records.push(NormalCompletion(path));
    }
    return records;
  }
  function getCompletionRecords() {
    const records = _getCompletionRecords(this, {
      canHaveBreak: false,
      shouldPopulateBreak: false,
      inCaseClause: false,
    });
    return records.map(r => r.path);
  }
  function getSibling(key) {
    return _index.default
      .get({
        parentPath: this.parentPath,
        parent: this.parent,
        container: this.container,
        listKey: this.listKey,
        key: key,
      })
      .setContext(this.context);
  }
  function getPrevSibling() {
    return this.getSibling(this.key - 1);
  }
  function getNextSibling() {
    return this.getSibling(this.key + 1);
  }
  function getAllNextSiblings() {
    let _key = this.key;
    let sibling = this.getSibling(++_key);
    const siblings = [];
    while (sibling.node) {
      siblings.push(sibling);
      sibling = this.getSibling(++_key);
    }
    return siblings;
  }
  function getAllPrevSiblings() {
    let _key = this.key;
    let sibling = this.getSibling(--_key);
    const siblings = [];
    while (sibling.node) {
      siblings.push(sibling);
      sibling = this.getSibling(--_key);
    }
    return siblings;
  }
  function get(key, context = true) {
    if (context === true) context = this.context;
    const parts = key.split('.');
    if (parts.length === 1) {
      return _getKey.call(this, key, context);
    } else {
      return _getPattern.call(this, parts, context);
    }
  }
  function _getKey(key, context) {
    const node = this.node;
    const container = node[key];
    if (Array.isArray(container)) {
      return container.map((_, i) =>
        _index.default
          .get({
            listKey: key,
            parentPath: this,
            parent: node,
            container: container,
            key: i,
          })
          .setContext(context)
      );
    } else {
      return _index.default
        .get({parentPath: this, parent: node, container: node, key: key})
        .setContext(context);
    }
  }
  function _getPattern(parts, context) {
    let path = this;
    for (const part of parts) {
      if (part === '.') {
        path = path.parentPath;
      } else {
        if (Array.isArray(path)) {
          path = path[part];
        } else {
          path = path.get(part, context);
        }
      }
    }
    return path;
  }
  function getAssignmentIdentifiers() {
    return _getAssignmentIdentifiers(this.node);
  }
  function getBindingIdentifiers(duplicates) {
    return _getBindingIdentifiers(this.node, duplicates);
  }
  function getOuterBindingIdentifiers(duplicates) {
    return _getOuterBindingIdentifiers(this.node, duplicates);
  }
  function getBindingIdentifierPaths(duplicates = false, outerOnly = false) {
    const path = this;
    const search = [path];
    const ids = Object.create(null);
    while (search.length) {
      const id = search.shift();
      if (!id) continue;
      if (!id.node) continue;
      const keys = _getBindingIdentifiers.keys[id.node.type];
      if (id.isIdentifier()) {
        if (duplicates) {
          const _ids = (ids[id.node.name] = ids[id.node.name] || []);
          _ids.push(id);
        } else {
          ids[id.node.name] = id;
        }
        continue;
      }
      if (id.isExportDeclaration()) {
        const declaration = id.get('declaration');
        if (declaration.isDeclaration()) {
          search.push(declaration);
        }
        continue;
      }
      if (outerOnly) {
        if (id.isFunctionDeclaration()) {
          search.push(id.get('id'));
          continue;
        }
        if (id.isFunctionExpression()) {
          continue;
        }
      }
      if (keys) {
        for (let i = 0; i < keys.length; i++) {
          const key = keys[i];
          const child = id.get(key);
          if (Array.isArray(child)) {
            search.push(...child);
          } else if (child.node) {
            search.push(child);
          }
        }
      }
    }
    return ids;
  }
  function getOuterBindingIdentifierPaths(duplicates = false) {
    return this.getBindingIdentifierPaths(duplicates, true);
  }
  return family$1;
}
var comments$1 = {};
var hasRequiredComments$1;
function requireComments$1() {
  if (hasRequiredComments$1) return comments$1;
  hasRequiredComments$1 = 1;
  Object.defineProperty(comments$1, '__esModule', {value: true});
  comments$1.addComment = addComment;
  comments$1.addComments = addComments;
  comments$1.shareCommentsWithSiblings = shareCommentsWithSiblings;
  var _t = t$d;
  const {addComment: _addComment, addComments: _addComments} = _t;
  function shareCommentsWithSiblings() {
    if (typeof this.key === 'string') return;
    const node = this.node;
    if (!node) return;
    const trailing = node.trailingComments;
    const leading = node.leadingComments;
    if (!trailing && !leading) return;
    const prev = this.getSibling(this.key - 1);
    const next = this.getSibling(this.key + 1);
    const hasPrev = Boolean(prev.node);
    const hasNext = Boolean(next.node);
    if (hasPrev) {
      if (leading) {
        prev.addComments(
          'trailing',
          removeIfExisting(leading, prev.node.trailingComments)
        );
      }
      if (trailing && !hasNext) prev.addComments('trailing', trailing);
    }
    if (hasNext) {
      if (trailing) {
        next.addComments(
          'leading',
          removeIfExisting(trailing, next.node.leadingComments)
        );
      }
      if (leading && !hasPrev) next.addComments('leading', leading);
    }
  }
  function removeIfExisting(list, toRemove) {
    if (!(toRemove != null && toRemove.length)) return list;
    const set = new Set(toRemove);
    return list.filter(el => !set.has(el));
  }
  function addComment(type, content, line) {
    _addComment(this.node, type, content, line);
  }
  function addComments(type, comments) {
    _addComments(this.node, type, comments);
  }
  return comments$1;
}
var hasRequiredPath$1;
function requirePath$1() {
  if (hasRequiredPath$1) return path$3;
  hasRequiredPath$1 = 1;
  Object.defineProperty(path$3, '__esModule', {value: true});
  path$3.default =
    path$3.SHOULD_STOP =
    path$3.SHOULD_SKIP =
    path$3.REMOVED =
      void 0;
  var virtualTypes = requireVirtualTypes$1();
  var _debug = requireSrc$1();
  var _index = requireLib$h();
  var _index2 = requireScope$1();
  var _t = t$d;
  var t = _t;
  var cache = requireCache$1();
  var _generator = requireLib$m();
  var NodePath_ancestry = requireAncestry$1();
  var NodePath_inference = requireInference$1();
  var NodePath_replacement = requireReplacement$1();
  var NodePath_evaluation = requireEvaluation$1();
  var NodePath_conversion = requireConversion$1();
  var NodePath_introspection = requireIntrospection$1();
  var _context = requireContext$2();
  var NodePath_context = _context;
  var NodePath_removal = requireRemoval$1();
  var NodePath_modification = requireModification$1();
  var NodePath_family = requireFamily$1();
  var NodePath_comments = requireComments$1();
  var NodePath_virtual_types_validator = requireVirtualTypesValidator();
  const {validate: validate} = _t;
  const debug = _debug('babel');
  path$3.REMOVED = 1 << 0;
  path$3.SHOULD_STOP = 1 << 1;
  path$3.SHOULD_SKIP = 1 << 2;
  const NodePath_Final = (path$3.default = class NodePath {
    constructor(hub, parent) {
      this.contexts = [];
      this.state = null;
      this.opts = null;
      this._traverseFlags = 0;
      this.skipKeys = null;
      this.parentPath = null;
      this.container = null;
      this.listKey = null;
      this.key = null;
      this.node = null;
      this.type = null;
      this.parent = parent;
      this.hub = hub;
      this.data = null;
      this.context = null;
      this.scope = null;
    }
    get removed() {
      return (this._traverseFlags & 1) > 0;
    }
    set removed(v) {
      if (v) this._traverseFlags |= 1;
      else this._traverseFlags &= -2;
    }
    get shouldStop() {
      return (this._traverseFlags & 2) > 0;
    }
    set shouldStop(v) {
      if (v) this._traverseFlags |= 2;
      else this._traverseFlags &= -3;
    }
    get shouldSkip() {
      return (this._traverseFlags & 4) > 0;
    }
    set shouldSkip(v) {
      if (v) this._traverseFlags |= 4;
      else this._traverseFlags &= -5;
    }
    static get({
      hub: hub,
      parentPath: parentPath,
      parent: parent,
      container: container,
      listKey: listKey,
      key: key,
    }) {
      if (!hub && parentPath) {
        hub = parentPath.hub;
      }
      if (!parent) {
        throw new Error('To get a node path the parent needs to exist');
      }
      const targetNode = container[key];
      const paths = cache.getOrCreateCachedPaths(hub, parent);
      let path = paths.get(targetNode);
      if (!path) {
        path = new NodePath(hub, parent);
        if (targetNode) paths.set(targetNode, path);
      }
      _context.setup.call(path, parentPath, container, listKey, key);
      return path;
    }
    getScope(scope) {
      return this.isScope() ? new _index2.default(this) : scope;
    }
    setData(key, val) {
      if (this.data == null) {
        this.data = Object.create(null);
      }
      return (this.data[key] = val);
    }
    getData(key, def) {
      if (this.data == null) {
        this.data = Object.create(null);
      }
      let val = this.data[key];
      if (val === undefined && def !== undefined) val = this.data[key] = def;
      return val;
    }
    hasNode() {
      return this.node != null;
    }
    buildCodeFrameError(msg, Error = SyntaxError) {
      return this.hub.buildError(this.node, msg, Error);
    }
    traverse(visitor, state) {
      (0, _index.default)(this.node, visitor, this.scope, state, this);
    }
    set(key, node) {
      validate(this.node, key, node);
      this.node[key] = node;
    }
    getPathLocation() {
      const parts = [];
      let path = this;
      do {
        let key = path.key;
        if (path.inList) key = `${path.listKey}[${key}]`;
        parts.unshift(key);
      } while ((path = path.parentPath));
      return parts.join('.');
    }
    debug(message) {
      if (!debug.enabled) return;
      debug(`${this.getPathLocation()} ${this.type}: ${message}`);
    }
    toString() {
      return (0, _generator.default)(this.node).code;
    }
    get inList() {
      return !!this.listKey;
    }
    set inList(inList) {
      if (!inList) {
        this.listKey = null;
      }
    }
    get parentKey() {
      return this.listKey || this.key;
    }
  });
  const methods = {
    findParent: NodePath_ancestry.findParent,
    find: NodePath_ancestry.find,
    getFunctionParent: NodePath_ancestry.getFunctionParent,
    getStatementParent: NodePath_ancestry.getStatementParent,
    getEarliestCommonAncestorFrom:
      NodePath_ancestry.getEarliestCommonAncestorFrom,
    getDeepestCommonAncestorFrom:
      NodePath_ancestry.getDeepestCommonAncestorFrom,
    getAncestry: NodePath_ancestry.getAncestry,
    isAncestor: NodePath_ancestry.isAncestor,
    isDescendant: NodePath_ancestry.isDescendant,
    inType: NodePath_ancestry.inType,
    getTypeAnnotation: NodePath_inference.getTypeAnnotation,
    isBaseType: NodePath_inference.isBaseType,
    couldBeBaseType: NodePath_inference.couldBeBaseType,
    baseTypeStrictlyMatches: NodePath_inference.baseTypeStrictlyMatches,
    isGenericType: NodePath_inference.isGenericType,
    replaceWithMultiple: NodePath_replacement.replaceWithMultiple,
    replaceWithSourceString: NodePath_replacement.replaceWithSourceString,
    replaceWith: NodePath_replacement.replaceWith,
    replaceExpressionWithStatements:
      NodePath_replacement.replaceExpressionWithStatements,
    replaceInline: NodePath_replacement.replaceInline,
    evaluateTruthy: NodePath_evaluation.evaluateTruthy,
    evaluate: NodePath_evaluation.evaluate,
    toComputedKey: NodePath_conversion.toComputedKey,
    ensureBlock: NodePath_conversion.ensureBlock,
    unwrapFunctionEnvironment: NodePath_conversion.unwrapFunctionEnvironment,
    arrowFunctionToExpression: NodePath_conversion.arrowFunctionToExpression,
    splitExportDeclaration: NodePath_conversion.splitExportDeclaration,
    ensureFunctionName: NodePath_conversion.ensureFunctionName,
    matchesPattern: NodePath_introspection.matchesPattern,
    isStatic: NodePath_introspection.isStatic,
    isNodeType: NodePath_introspection.isNodeType,
    canHaveVariableDeclarationOrExpression:
      NodePath_introspection.canHaveVariableDeclarationOrExpression,
    canSwapBetweenExpressionAndStatement:
      NodePath_introspection.canSwapBetweenExpressionAndStatement,
    isCompletionRecord: NodePath_introspection.isCompletionRecord,
    isStatementOrBlock: NodePath_introspection.isStatementOrBlock,
    referencesImport: NodePath_introspection.referencesImport,
    getSource: NodePath_introspection.getSource,
    willIMaybeExecuteBefore: NodePath_introspection.willIMaybeExecuteBefore,
    _guessExecutionStatusRelativeTo:
      NodePath_introspection._guessExecutionStatusRelativeTo,
    resolve: NodePath_introspection.resolve,
    isConstantExpression: NodePath_introspection.isConstantExpression,
    isInStrictMode: NodePath_introspection.isInStrictMode,
    isDenylisted: NodePath_context.isDenylisted,
    visit: NodePath_context.visit,
    skip: NodePath_context.skip,
    skipKey: NodePath_context.skipKey,
    stop: NodePath_context.stop,
    setContext: NodePath_context.setContext,
    requeue: NodePath_context.requeue,
    requeueComputedKeyAndDecorators:
      NodePath_context.requeueComputedKeyAndDecorators,
    remove: NodePath_removal.remove,
    insertBefore: NodePath_modification.insertBefore,
    insertAfter: NodePath_modification.insertAfter,
    unshiftContainer: NodePath_modification.unshiftContainer,
    pushContainer: NodePath_modification.pushContainer,
    getOpposite: NodePath_family.getOpposite,
    getCompletionRecords: NodePath_family.getCompletionRecords,
    getSibling: NodePath_family.getSibling,
    getPrevSibling: NodePath_family.getPrevSibling,
    getNextSibling: NodePath_family.getNextSibling,
    getAllNextSiblings: NodePath_family.getAllNextSiblings,
    getAllPrevSiblings: NodePath_family.getAllPrevSiblings,
    get: NodePath_family.get,
    getAssignmentIdentifiers: NodePath_family.getAssignmentIdentifiers,
    getBindingIdentifiers: NodePath_family.getBindingIdentifiers,
    getOuterBindingIdentifiers: NodePath_family.getOuterBindingIdentifiers,
    getBindingIdentifierPaths: NodePath_family.getBindingIdentifierPaths,
    getOuterBindingIdentifierPaths:
      NodePath_family.getOuterBindingIdentifierPaths,
    shareCommentsWithSiblings: NodePath_comments.shareCommentsWithSiblings,
    addComment: NodePath_comments.addComment,
    addComments: NodePath_comments.addComments,
  };
  Object.assign(NodePath_Final.prototype, methods);
  {
    NodePath_Final.prototype.arrowFunctionToShadowed =
      NodePath_conversion[String('arrowFunctionToShadowed')];
    Object.assign(NodePath_Final.prototype, {
      has: NodePath_introspection[String('has')],
      is: NodePath_introspection[String('is')],
      isnt: NodePath_introspection[String('isnt')],
      equals: NodePath_introspection[String('equals')],
      hoist: NodePath_modification[String('hoist')],
      updateSiblingKeys: NodePath_modification.updateSiblingKeys,
      call: NodePath_context.call,
      isBlacklisted: NodePath_context[String('isBlacklisted')],
      setScope: NodePath_context.setScope,
      resync: NodePath_context.resync,
      popContext: NodePath_context.popContext,
      pushContext: NodePath_context.pushContext,
      setup: NodePath_context.setup,
      setKey: NodePath_context.setKey,
    });
  }
  {
    NodePath_Final.prototype._guessExecutionStatusRelativeToDifferentFunctions =
      NodePath_introspection._guessExecutionStatusRelativeTo;
    NodePath_Final.prototype._guessExecutionStatusRelativeToDifferentFunctions =
      NodePath_introspection._guessExecutionStatusRelativeTo;
    Object.assign(NodePath_Final.prototype, {
      _getTypeAnnotation: NodePath_inference._getTypeAnnotation,
      _replaceWith: NodePath_replacement._replaceWith,
      _resolve: NodePath_introspection._resolve,
      _call: NodePath_context._call,
      _resyncParent: NodePath_context._resyncParent,
      _resyncKey: NodePath_context._resyncKey,
      _resyncList: NodePath_context._resyncList,
      _resyncRemoved: NodePath_context._resyncRemoved,
      _getQueueContexts: NodePath_context._getQueueContexts,
      _removeFromScope: NodePath_removal._removeFromScope,
      _callRemovalHooks: NodePath_removal._callRemovalHooks,
      _remove: NodePath_removal._remove,
      _markRemoved: NodePath_removal._markRemoved,
      _assertUnremoved: NodePath_removal._assertUnremoved,
      _containerInsert: NodePath_modification._containerInsert,
      _containerInsertBefore: NodePath_modification._containerInsertBefore,
      _containerInsertAfter: NodePath_modification._containerInsertAfter,
      _verifyNodeList: NodePath_modification._verifyNodeList,
      _getKey: NodePath_family._getKey,
      _getPattern: NodePath_family._getPattern,
    });
  }
  for (const type of t.TYPES) {
    const typeKey = `is${type}`;
    const fn = t[typeKey];
    NodePath_Final.prototype[typeKey] = function (opts) {
      return fn(this.node, opts);
    };
    NodePath_Final.prototype[`assert${type}`] = function (opts) {
      if (!fn(this.node, opts)) {
        throw new TypeError(`Expected node path of type ${type}`);
      }
    };
  }
  Object.assign(NodePath_Final.prototype, NodePath_virtual_types_validator);
  for (const type of Object.keys(virtualTypes)) {
    if (type[0] === '_') continue;
    if (!t.TYPES.includes(type)) t.TYPES.push(type);
  }
  return path$3;
}
var hasRequiredContext$3;
function requireContext$3() {
  if (hasRequiredContext$3) return context$2;
  hasRequiredContext$3 = 1;
  Object.defineProperty(context$2, '__esModule', {value: true});
  context$2.default = void 0;
  var _index = requirePath$1();
  var _t = t$d;
  var _context = requireContext$2();
  const {VISITOR_KEYS: VISITOR_KEYS} = _t;
  class TraversalContext {
    constructor(scope, opts, state, parentPath) {
      this.queue = null;
      this.priorityQueue = null;
      this.parentPath = parentPath;
      this.scope = scope;
      this.state = state;
      this.opts = opts;
    }
    shouldVisit(node) {
      const opts = this.opts;
      if (opts.enter || opts.exit) return true;
      if (opts[node.type]) return true;
      const keys = VISITOR_KEYS[node.type];
      if (!(keys != null && keys.length)) return false;
      for (const key of keys) {
        if (node[key]) {
          return true;
        }
      }
      return false;
    }
    create(node, container, key, listKey) {
      return _index.default.get({
        parentPath: this.parentPath,
        parent: node,
        container: container,
        key: key,
        listKey: listKey,
      });
    }
    maybeQueue(path, notPriority) {
      if (this.queue) {
        if (notPriority) {
          this.queue.push(path);
        } else {
          this.priorityQueue.push(path);
        }
      }
    }
    visitMultiple(container, parent, listKey) {
      if (container.length === 0) return false;
      const queue = [];
      for (let key = 0; key < container.length; key++) {
        const node = container[key];
        if (node && this.shouldVisit(node)) {
          queue.push(this.create(parent, container, key, listKey));
        }
      }
      return this.visitQueue(queue);
    }
    visitSingle(node, key) {
      if (this.shouldVisit(node[key])) {
        return this.visitQueue([this.create(node, node, key)]);
      } else {
        return false;
      }
    }
    visitQueue(queue) {
      this.queue = queue;
      this.priorityQueue = [];
      const visited = new WeakSet();
      let stop = false;
      let visitIndex = 0;
      for (; visitIndex < queue.length; ) {
        const path = queue[visitIndex];
        visitIndex++;
        _context.resync.call(path);
        if (
          path.contexts.length === 0 ||
          path.contexts[path.contexts.length - 1] !== this
        ) {
          _context.pushContext.call(path, this);
        }
        if (path.key === null) continue;
        const {node: node} = path;
        if (visited.has(node)) continue;
        if (node) visited.add(node);
        if (path.visit()) {
          stop = true;
          break;
        }
        if (this.priorityQueue.length) {
          stop = this.visitQueue(this.priorityQueue);
          this.priorityQueue = [];
          this.queue = queue;
          if (stop) break;
        }
      }
      for (let i = 0; i < visitIndex; i++) {
        _context.popContext.call(queue[i]);
      }
      this.queue = null;
      return stop;
    }
    visit(node, key) {
      const nodes = node[key];
      if (!nodes) return false;
      if (Array.isArray(nodes)) {
        return this.visitMultiple(nodes, node, key);
      } else {
        return this.visitSingle(node, key);
      }
    }
  }
  context$2.default = TraversalContext;
  return context$2;
}
var hasRequiredTraverseNode;
function requireTraverseNode() {
  if (hasRequiredTraverseNode) return traverseNode;
  hasRequiredTraverseNode = 1;
  Object.defineProperty(traverseNode, '__esModule', {value: true});
  traverseNode.traverseNode = traverseNode$1;
  var _context = requireContext$3();
  var _t = t$d;
  const {VISITOR_KEYS: VISITOR_KEYS} = _t;
  function traverseNode$1(node, opts, scope, state, path, skipKeys, visitSelf) {
    const keys = VISITOR_KEYS[node.type];
    if (!keys) return false;
    const context = new _context.default(scope, opts, state, path);
    if (visitSelf) {
      if (skipKeys != null && skipKeys[path.parentKey]) return false;
      return context.visitQueue([path]);
    }
    for (const key of keys) {
      if (skipKeys != null && skipKeys[key]) continue;
      if (context.visit(node, key)) {
        return true;
      }
    }
    return false;
  }
  return traverseNode;
}
var hasRequiredContext$2;
function requireContext$2() {
  if (hasRequiredContext$2) return context$3;
  hasRequiredContext$2 = 1;
  Object.defineProperty(context$3, '__esModule', {value: true});
  context$3._call = _call;
  context$3._getQueueContexts = _getQueueContexts;
  context$3._resyncKey = _resyncKey;
  context$3._resyncList = _resyncList;
  context$3._resyncParent = _resyncParent;
  context$3._resyncRemoved = _resyncRemoved;
  context$3.call = call;
  context$3.isDenylisted = isDenylisted;
  context$3.popContext = popContext;
  context$3.pushContext = pushContext;
  context$3.requeue = requeue;
  context$3.requeueComputedKeyAndDecorators = requeueComputedKeyAndDecorators;
  context$3.resync = resync;
  context$3.setContext = setContext;
  context$3.setKey = setKey;
  context$3.setScope = setScope;
  context$3.setup = setup;
  context$3.skip = skip;
  context$3.skipKey = skipKey;
  context$3.stop = stop;
  context$3.visit = visit;
  var _traverseNode = requireTraverseNode();
  var _index = requirePath$1();
  var _removal = requireRemoval$1();
  var t = t$d;
  function call(key) {
    const opts = this.opts;
    this.debug(key);
    if (this.node) {
      if (_call.call(this, opts[key])) return true;
    }
    if (this.node) {
      var _opts$this$node$type;
      return _call.call(
        this,
        (_opts$this$node$type = opts[this.node.type]) == null
          ? void 0
          : _opts$this$node$type[key]
      );
    }
    return false;
  }
  function _call(fns) {
    if (!fns) return false;
    for (const fn of fns) {
      if (!fn) continue;
      const node = this.node;
      if (!node) return true;
      const ret = fn.call(this.state, this, this.state);
      if (ret && typeof ret === 'object' && typeof ret.then === 'function') {
        throw new Error(
          `You appear to be using a plugin with an async traversal visitor, ` +
            `which your current version of Babel does not support. ` +
            `If you're using a published plugin, you may need to upgrade ` +
            `your @babel/core version.`
        );
      }
      if (ret) {
        throw new Error(`Unexpected return value from visitor method ${fn}`);
      }
      if (this.node !== node) return true;
      if (this._traverseFlags > 0) return true;
    }
    return false;
  }
  function isDenylisted() {
    var _this$opts$denylist;
    const denylist =
      (_this$opts$denylist = this.opts.denylist) != null
        ? _this$opts$denylist
        : this.opts.blacklist;
    return denylist == null ? void 0 : denylist.includes(this.node.type);
  }
  {
    context$3.isBlacklisted = isDenylisted;
  }
  function restoreContext(path, context) {
    if (path.context !== context) {
      path.context = context;
      path.state = context.state;
      path.opts = context.opts;
    }
  }
  function visit() {
    var _this$opts$shouldSkip, _this$opts;
    if (!this.node) {
      return false;
    }
    if (this.isDenylisted()) {
      return false;
    }
    if (
      (_this$opts$shouldSkip = (_this$opts = this.opts).shouldSkip) != null &&
      _this$opts$shouldSkip.call(_this$opts, this)
    ) {
      return false;
    }
    const currentContext = this.context;
    if (this.shouldSkip || call.call(this, 'enter')) {
      this.debug('Skip...');
      return this.shouldStop;
    }
    restoreContext(this, currentContext);
    this.debug('Recursing into...');
    this.shouldStop = (0, _traverseNode.traverseNode)(
      this.node,
      this.opts,
      this.scope,
      this.state,
      this,
      this.skipKeys
    );
    restoreContext(this, currentContext);
    call.call(this, 'exit');
    return this.shouldStop;
  }
  function skip() {
    this.shouldSkip = true;
  }
  function skipKey(key) {
    if (this.skipKeys == null) {
      this.skipKeys = {};
    }
    this.skipKeys[key] = true;
  }
  function stop() {
    this._traverseFlags |= _index.SHOULD_SKIP | _index.SHOULD_STOP;
  }
  function setScope() {
    var _this$opts2, _this$scope;
    if ((_this$opts2 = this.opts) != null && _this$opts2.noScope) return;
    let path = this.parentPath;
    if (
      ((this.key === 'key' || this.listKey === 'decorators') &&
        path.isMethod()) ||
      (this.key === 'discriminant' && path.isSwitchStatement())
    ) {
      path = path.parentPath;
    }
    let target;
    while (path && !target) {
      var _path$opts;
      if ((_path$opts = path.opts) != null && _path$opts.noScope) return;
      target = path.scope;
      path = path.parentPath;
    }
    this.scope = this.getScope(target);
    (_this$scope = this.scope) == null || _this$scope.init();
  }
  function setContext(context) {
    if (this.skipKeys != null) {
      this.skipKeys = {};
    }
    this._traverseFlags = 0;
    if (context) {
      this.context = context;
      this.state = context.state;
      this.opts = context.opts;
    }
    setScope.call(this);
    return this;
  }
  function resync() {
    if (this.removed) return;
    _resyncParent.call(this);
    _resyncList.call(this);
    _resyncKey.call(this);
  }
  function _resyncParent() {
    if (this.parentPath) {
      this.parent = this.parentPath.node;
    }
  }
  function _resyncKey() {
    if (!this.container) return;
    if (this.node === this.container[this.key]) {
      return;
    }
    if (Array.isArray(this.container)) {
      for (let i = 0; i < this.container.length; i++) {
        if (this.container[i] === this.node) {
          setKey.call(this, i);
          return;
        }
      }
    } else {
      for (const key of Object.keys(this.container)) {
        if (this.container[key] === this.node) {
          setKey.call(this, key);
          return;
        }
      }
    }
    this.key = null;
  }
  function _resyncList() {
    if (!this.parent || !this.inList) return;
    const newContainer = this.parent[this.listKey];
    if (this.container === newContainer) return;
    this.container = newContainer || null;
  }
  function _resyncRemoved() {
    if (
      this.key == null ||
      !this.container ||
      this.container[this.key] !== this.node
    ) {
      _removal._markRemoved.call(this);
    }
  }
  function popContext() {
    this.contexts.pop();
    if (this.contexts.length > 0) {
      this.setContext(this.contexts[this.contexts.length - 1]);
    } else {
      this.setContext(undefined);
    }
  }
  function pushContext(context) {
    this.contexts.push(context);
    this.setContext(context);
  }
  function setup(parentPath, container, listKey, key) {
    this.listKey = listKey;
    this.container = container;
    this.parentPath = parentPath || this.parentPath;
    setKey.call(this, key);
  }
  function setKey(key) {
    var _this$node;
    this.key = key;
    this.node = this.container[this.key];
    this.type = (_this$node = this.node) == null ? void 0 : _this$node.type;
  }
  function requeue(pathToQueue = this) {
    if (pathToQueue.removed) return;
    const contexts = this.contexts;
    for (const context of contexts) {
      context.maybeQueue(pathToQueue);
    }
  }
  function requeueComputedKeyAndDecorators() {
    const {context: context, node: node} = this;
    if (!t.isPrivate(node) && node.computed) {
      context.maybeQueue(this.get('key'));
    }
    if (node.decorators) {
      for (const decorator of this.get('decorators')) {
        context.maybeQueue(decorator);
      }
    }
  }
  function _getQueueContexts() {
    let path = this;
    let contexts = this.contexts;
    while (!contexts.length) {
      path = path.parentPath;
      if (!path) break;
      contexts = path.contexts;
    }
    return contexts;
  }
  return context$3;
}
var hub$1 = {};
var hasRequiredHub$1;
function requireHub$1() {
  if (hasRequiredHub$1) return hub$1;
  hasRequiredHub$1 = 1;
  Object.defineProperty(hub$1, '__esModule', {value: true});
  hub$1.default = void 0;
  class Hub {
    getCode() {}
    getScope() {}
    addHelper() {
      throw new Error('Helpers are not supported by the default hub.');
    }
    buildError(node, msg, Error = TypeError) {
      return new Error(msg);
    }
  }
  hub$1.default = Hub;
  return hub$1;
}
var hasRequiredLib$h;
function requireLib$h() {
  if (hasRequiredLib$h) return lib$n;
  hasRequiredLib$h = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    Object.defineProperty(exports, 'Hub', {
      enumerable: true,
      get: function () {
        return _hub.default;
      },
    });
    Object.defineProperty(exports, 'NodePath', {
      enumerable: true,
      get: function () {
        return _index.default;
      },
    });
    Object.defineProperty(exports, 'Scope', {
      enumerable: true,
      get: function () {
        return _index2.default;
      },
    });
    exports.visitors = exports.default = void 0;
    requireContext$2();
    var visitors = requireVisitors$1();
    exports.visitors = visitors;
    var _t = t$d;
    var cache = requireCache$1();
    var _traverseNode = requireTraverseNode();
    var _index = requirePath$1();
    var _index2 = requireScope$1();
    var _hub = requireHub$1();
    const {
      VISITOR_KEYS: VISITOR_KEYS,
      removeProperties: removeProperties,
      traverseFast: traverseFast,
    } = _t;
    function traverse(parent, opts = {}, scope, state, parentPath, visitSelf) {
      if (!parent) return;
      if (!opts.noScope && !scope) {
        if (parent.type !== 'Program' && parent.type !== 'File') {
          throw new Error(
            'You must pass a scope and parentPath unless traversing a Program/File. ' +
              `Instead of that you tried to traverse a ${parent.type} node without ` +
              'passing scope and parentPath.'
          );
        }
      }
      if (!parentPath && visitSelf) {
        throw new Error(
          'visitSelf can only be used when providing a NodePath.'
        );
      }
      if (!VISITOR_KEYS[parent.type]) {
        return;
      }
      visitors.explode(opts);
      (0, _traverseNode.traverseNode)(
        parent,
        opts,
        scope,
        state,
        parentPath,
        null,
        visitSelf
      );
    }
    exports.default = traverse;
    traverse.visitors = visitors;
    traverse.verify = visitors.verify;
    traverse.explode = visitors.explode;
    traverse.cheap = function (node, enter) {
      traverseFast(node, enter);
      return;
    };
    traverse.node = function (node, opts, scope, state, path, skipKeys) {
      (0, _traverseNode.traverseNode)(node, opts, scope, state, path, skipKeys);
    };
    traverse.clearNode = function (node, opts) {
      removeProperties(node, opts);
    };
    traverse.removeProperties = function (tree, opts) {
      traverseFast(tree, traverse.clearNode, opts);
      return tree;
    };
    function hasDenylistedType(path, state) {
      if (path.node.type === state.type) {
        state.has = true;
        path.stop();
      }
    }
    traverse.hasType = function (tree, type, denylistTypes) {
      if (denylistTypes != null && denylistTypes.includes(tree.type))
        return false;
      if (tree.type === type) return true;
      const state = {has: false, type: type};
      traverse(
        tree,
        {noScope: true, denylist: denylistTypes, enter: hasDenylistedType},
        null,
        state
      );
      return state.has;
    };
    traverse.cache = cache;
  })(lib$n);
  return lib$n;
}
var helpers$2 = {};
var lib$h = {};
var formatters$1 = {};
var hasRequiredFormatters$1;
function requireFormatters$1() {
  if (hasRequiredFormatters$1) return formatters$1;
  hasRequiredFormatters$1 = 1;
  Object.defineProperty(formatters$1, '__esModule', {value: true});
  formatters$1.statements =
    formatters$1.statement =
    formatters$1.smart =
    formatters$1.program =
    formatters$1.expression =
      void 0;
  var _t = t$d;
  const {assertExpressionStatement: assertExpressionStatement} = _t;
  function makeStatementFormatter(fn) {
    return {
      code: str => `/* @babel/template */;\n${str}`,
      validate: () => {},
      unwrap: ast => fn(ast.program.body.slice(1)),
    };
  }
  const smart = makeStatementFormatter(body => {
    if (body.length > 1) {
      return body;
    } else {
      return body[0];
    }
  });
  formatters$1.smart = smart;
  const statements = makeStatementFormatter(body => body);
  formatters$1.statements = statements;
  const statement = makeStatementFormatter(body => {
    if (body.length === 0) {
      throw new Error('Found nothing to return.');
    }
    if (body.length > 1) {
      throw new Error('Found multiple statements but wanted one');
    }
    return body[0];
  });
  formatters$1.statement = statement;
  const expression = {
    code: str => `(\n${str}\n)`,
    validate: ast => {
      if (ast.program.body.length > 1) {
        throw new Error('Found multiple statements but wanted one');
      }
      if (expression.unwrap(ast).start === 0) {
        throw new Error('Parse result included parens.');
      }
    },
    unwrap: ({program: program}) => {
      const [stmt] = program.body;
      assertExpressionStatement(stmt);
      return stmt.expression;
    },
  };
  formatters$1.expression = expression;
  const program = {
    code: str => str,
    validate: () => {},
    unwrap: ast => ast.program,
  };
  formatters$1.program = program;
  return formatters$1;
}
var builder$1 = {};
var options$2 = {};
var hasRequiredOptions$1;
function requireOptions$1() {
  if (hasRequiredOptions$1) return options$2;
  hasRequiredOptions$1 = 1;
  Object.defineProperty(options$2, '__esModule', {value: true});
  options$2.merge = merge;
  options$2.normalizeReplacements = normalizeReplacements;
  options$2.validate = validate;
  const _excluded = [
    'placeholderWhitelist',
    'placeholderPattern',
    'preserveComments',
    'syntacticPlaceholders',
  ];
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }
  function merge(a, b) {
    const {
      placeholderWhitelist: placeholderWhitelist = a.placeholderWhitelist,
      placeholderPattern: placeholderPattern = a.placeholderPattern,
      preserveComments: preserveComments = a.preserveComments,
      syntacticPlaceholders: syntacticPlaceholders = a.syntacticPlaceholders,
    } = b;
    return {
      parser: Object.assign({}, a.parser, b.parser),
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      preserveComments: preserveComments,
      syntacticPlaceholders: syntacticPlaceholders,
    };
  }
  function validate(opts) {
    if (opts != null && typeof opts !== 'object') {
      throw new Error('Unknown template options.');
    }
    const _ref = opts || {},
      {
        placeholderWhitelist: placeholderWhitelist,
        placeholderPattern: placeholderPattern,
        preserveComments: preserveComments,
        syntacticPlaceholders: syntacticPlaceholders,
      } = _ref,
      parser = _objectWithoutPropertiesLoose(_ref, _excluded);
    if (
      placeholderWhitelist != null &&
      !(placeholderWhitelist instanceof Set)
    ) {
      throw new Error(
        "'.placeholderWhitelist' must be a Set, null, or undefined"
      );
    }
    if (
      placeholderPattern != null &&
      !(placeholderPattern instanceof RegExp) &&
      placeholderPattern !== false
    ) {
      throw new Error(
        "'.placeholderPattern' must be a RegExp, false, null, or undefined"
      );
    }
    if (preserveComments != null && typeof preserveComments !== 'boolean') {
      throw new Error(
        "'.preserveComments' must be a boolean, null, or undefined"
      );
    }
    if (
      syntacticPlaceholders != null &&
      typeof syntacticPlaceholders !== 'boolean'
    ) {
      throw new Error(
        "'.syntacticPlaceholders' must be a boolean, null, or undefined"
      );
    }
    if (
      syntacticPlaceholders === true &&
      (placeholderWhitelist != null || placeholderPattern != null)
    ) {
      throw new Error(
        "'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" +
          " with '.syntacticPlaceholders: true'"
      );
    }
    return {
      parser: parser,
      placeholderWhitelist: placeholderWhitelist || undefined,
      placeholderPattern:
        placeholderPattern == null ? undefined : placeholderPattern,
      preserveComments: preserveComments == null ? undefined : preserveComments,
      syntacticPlaceholders:
        syntacticPlaceholders == null ? undefined : syntacticPlaceholders,
    };
  }
  function normalizeReplacements(replacements) {
    if (Array.isArray(replacements)) {
      return replacements.reduce((acc, replacement, i) => {
        acc['$' + i] = replacement;
        return acc;
      }, {});
    } else if (typeof replacements === 'object' || replacements == null) {
      return replacements || undefined;
    }
    throw new Error(
      'Template replacements must be an array, object, null, or undefined'
    );
  }
  return options$2;
}
var string$1 = {};
var parse$4 = {};
var lib$g = {};
Object.defineProperty(lib$g, '__esModule', {value: true});
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
class Position {
  constructor(line, col, index) {
    this.line = void 0;
    this.column = void 0;
    this.index = void 0;
    this.line = line;
    this.column = col;
    this.index = index;
  }
}
class SourceLocation {
  constructor(start, end) {
    this.start = void 0;
    this.end = void 0;
    this.filename = void 0;
    this.identifierName = void 0;
    this.start = start;
    this.end = end;
  }
}
function createPositionWithColumnOffset(position, columnOffset) {
  const {line: line, column: column, index: index} = position;
  return new Position(line, column + columnOffset, index + columnOffset);
}
var ParseErrorCode = {
  SyntaxError: 'BABEL_PARSER_SYNTAX_ERROR',
  SourceTypeModuleError: 'BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED',
};
const reflect = (keys, last = keys.length - 1) => ({
  get() {
    return keys.reduce((object, key) => object[key], this);
  },
  set(value) {
    keys.reduce(
      (item, key, i) => (i === last ? (item[key] = value) : item[key]),
      this
    );
  },
});
const instantiate = (constructor, properties, descriptors) =>
  Object.keys(descriptors)
    .map(key => [key, descriptors[key]])
    .filter(([, descriptor]) => !!descriptor)
    .map(([key, descriptor]) => [
      key,
      typeof descriptor === 'function'
        ? {value: descriptor, enumerable: false}
        : typeof descriptor.reflect === 'string'
          ? Object.assign(
              {},
              descriptor,
              reflect(descriptor.reflect.split('.'))
            )
          : descriptor,
    ])
    .reduce(
      (instance, [key, descriptor]) =>
        Object.defineProperty(
          instance,
          key,
          Object.assign({configurable: true}, descriptor)
        ),
      Object.assign(new constructor(), properties)
    );
var ModuleErrors = {
  ImportMetaOutsideModule: {
    message: `import.meta may appear only with 'sourceType: "module"'`,
    code: ParseErrorCode.SourceTypeModuleError,
  },
  ImportOutsideModule: {
    message: `'import' and 'export' may appear only with 'sourceType: "module"'`,
    code: ParseErrorCode.SourceTypeModuleError,
  },
};
const NodeDescriptions = {
  ArrayPattern: 'array destructuring pattern',
  AssignmentExpression: 'assignment expression',
  AssignmentPattern: 'assignment expression',
  ArrowFunctionExpression: 'arrow function expression',
  ConditionalExpression: 'conditional expression',
  CatchClause: 'catch clause',
  ForOfStatement: 'for-of statement',
  ForInStatement: 'for-in statement',
  ForStatement: 'for-loop',
  FormalParameters: 'function parameter list',
  Identifier: 'identifier',
  ImportSpecifier: 'import specifier',
  ImportDefaultSpecifier: 'import default specifier',
  ImportNamespaceSpecifier: 'import namespace specifier',
  ObjectPattern: 'object destructuring pattern',
  ParenthesizedExpression: 'parenthesized expression',
  RestElement: 'rest element',
  UpdateExpression: {true: 'prefix operation', false: 'postfix operation'},
  VariableDeclarator: 'variable declaration',
  YieldExpression: 'yield expression',
};
const toNodeDescription = ({type: type, prefix: prefix}) =>
  type === 'UpdateExpression'
    ? NodeDescriptions.UpdateExpression[String(prefix)]
    : NodeDescriptions[type];
var StandardErrors = {
  AccessorIsGenerator: ({kind: kind}) => `A ${kind}ter cannot be a generator.`,
  ArgumentsInClass:
    "'arguments' is only allowed in functions and class methods.",
  AsyncFunctionInSingleStatementContext:
    'Async functions can only be declared at the top level or inside a block.',
  AwaitBindingIdentifier:
    "Can not use 'await' as identifier inside an async function.",
  AwaitBindingIdentifierInStaticBlock:
    "Can not use 'await' as identifier inside a static block.",
  AwaitExpressionFormalParameter:
    "'await' is not allowed in async function parameters.",
  AwaitNotInAsyncContext:
    "'await' is only allowed within async functions and at the top levels of modules.",
  AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
  BadGetterArity: "A 'get' accesor must not have any formal parameters.",
  BadSetterArity: "A 'set' accesor must have exactly one formal parameter.",
  BadSetterRestParameter:
    "A 'set' accesor function argument must not be a rest parameter.",
  ConstructorClassField: "Classes may not have a field named 'constructor'.",
  ConstructorClassPrivateField:
    "Classes may not have a private field named '#constructor'.",
  ConstructorIsAccessor: 'Class constructor may not be an accessor.',
  ConstructorIsAsync: "Constructor can't be an async function.",
  ConstructorIsGenerator: "Constructor can't be a generator.",
  DeclarationMissingInitializer: ({kind: kind}) =>
    `Missing initializer in ${kind} declaration.`,
  DecoratorArgumentsOutsideParentheses:
    "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
  DecoratorBeforeExport:
    "Decorators must be placed *before* the 'export' keyword. You can set the 'decoratorsBeforeExport' option to false to use the 'export @decorator class {}' syntax.",
  DecoratorConstructor:
    "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
  DecoratorExportClass:
    'Using the export keyword between a decorator and a class is not allowed. Please use `export @dec class` instead.',
  DecoratorSemicolon: 'Decorators must not be followed by a semicolon.',
  DecoratorStaticBlock: "Decorators can't be used with a static block.",
  DeletePrivateField: 'Deleting a private field is not allowed.',
  DestructureNamedImport:
    'ES2015 named imports do not destructure. Use another statement for destructuring after the import.',
  DuplicateConstructor: 'Duplicate constructor in the same class.',
  DuplicateDefaultExport: 'Only one default export allowed per module.',
  DuplicateExport: ({exportName: exportName}) =>
    `\`${exportName}\` has already been exported. Exported identifiers must be unique.`,
  DuplicateProto: 'Redefinition of __proto__ property.',
  DuplicateRegExpFlags: 'Duplicate regular expression flag.',
  ElementAfterRest: 'Rest element must be last element.',
  EscapedCharNotAnIdentifier: 'Invalid Unicode escape.',
  ExportBindingIsString: ({localName: localName, exportName: exportName}) =>
    `A string literal cannot be used as an exported binding without \`from\`.\n- Did you mean \`export { '${localName}' as '${exportName}' } from 'some-module'\`?`,
  ExportDefaultFromAsIdentifier:
    "'from' is not allowed as an identifier after 'export default'.",
  ForInOfLoopInitializer: ({type: type}) =>
    `'${type === 'ForInStatement' ? 'for-in' : 'for-of'}' loop variable declaration may not have an initializer.`,
  ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
  ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
  GeneratorInSingleStatementContext:
    'Generators can only be declared at the top level or inside a block.',
  IllegalBreakContinue: ({type: type}) =>
    `Unsyntactic ${type === 'BreakStatement' ? 'break' : 'continue'}.`,
  IllegalLanguageModeDirective:
    "Illegal 'use strict' directive in function with non-simple parameter list.",
  IllegalReturn: "'return' outside of function.",
  ImportBindingIsString: ({importName: importName}) =>
    `A string literal cannot be used as an imported binding.\n- Did you mean \`import { "${importName}" as foo }\`?`,
  ImportCallArgumentTrailingComma:
    'Trailing comma is disallowed inside import(...) arguments.',
  ImportCallArity: ({maxArgumentCount: maxArgumentCount}) =>
    `\`import()\` requires exactly ${maxArgumentCount === 1 ? 'one argument' : 'one or two arguments'}.`,
  ImportCallNotNewExpression: 'Cannot use new with import(...).',
  ImportCallSpreadArgument: '`...` is not allowed in `import()`.',
  ImportJSONBindingNotDefault:
    'A JSON module can only be imported with `default`.',
  IncompatibleRegExpUVFlags:
    "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
  InvalidBigIntLiteral: 'Invalid BigIntLiteral.',
  InvalidCodePoint: 'Code point out of bounds.',
  InvalidCoverInitializedName: 'Invalid shorthand property initializer.',
  InvalidDecimal: 'Invalid decimal.',
  InvalidDigit: ({radix: radix}) => `Expected number in radix ${radix}.`,
  InvalidEscapeSequence: 'Bad character escape sequence.',
  InvalidEscapeSequenceTemplate: 'Invalid escape sequence in template.',
  InvalidEscapedReservedWord: ({reservedWord: reservedWord}) =>
    `Escape sequence in keyword ${reservedWord}.`,
  InvalidIdentifier: ({identifierName: identifierName}) =>
    `Invalid identifier ${identifierName}.`,
  InvalidLhs: ({ancestor: ancestor}) =>
    `Invalid left-hand side in ${toNodeDescription(ancestor)}.`,
  InvalidLhsBinding: ({ancestor: ancestor}) =>
    `Binding invalid left-hand side in ${toNodeDescription(ancestor)}.`,
  InvalidNumber: 'Invalid number.',
  InvalidOrMissingExponent:
    "Floating-point numbers require a valid exponent after the 'e'.",
  InvalidOrUnexpectedToken: ({unexpected: unexpected}) =>
    `Unexpected character '${unexpected}'.`,
  InvalidParenthesizedAssignment: 'Invalid parenthesized assignment pattern.',
  InvalidPrivateFieldResolution: ({identifierName: identifierName}) =>
    `Private name #${identifierName} is not defined.`,
  InvalidPropertyBindingPattern: 'Binding member expression.',
  InvalidRecordProperty:
    'Only properties and spread elements are allowed in record definitions.',
  InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
  LabelRedeclaration: ({labelName: labelName}) =>
    `Label '${labelName}' is already declared.`,
  LetInLexicalBinding:
    "'let' is not allowed to be used as a name in 'let' or 'const' declarations.",
  LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
  MalformedRegExpFlags: 'Invalid regular expression flag.',
  MissingClassName: 'A class name is required.',
  MissingEqInAssignment:
    "Only '=' operator can be used for specifying default value.",
  MissingSemicolon: 'Missing semicolon.',
  MissingPlugin: ({missingPlugin: missingPlugin}) =>
    `This experimental syntax requires enabling the parser plugin: ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
  MissingOneOfPlugins: ({missingPlugin: missingPlugin}) =>
    `This experimental syntax requires enabling one of the following parser plugin(s): ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
  MissingUnicodeEscape: 'Expecting Unicode escape sequence \\uXXXX.',
  MixingCoalesceWithLogical:
    'Nullish coalescing operator(??) requires parens when mixing with logical operators.',
  ModuleAttributeDifferentFromType:
    'The only accepted module attribute is `type`.',
  ModuleAttributeInvalidValue:
    'Only string literals are allowed as module attribute values.',
  ModuleAttributesWithDuplicateKeys: ({key: key}) =>
    `Duplicate key "${key}" is not allowed in module attributes.`,
  ModuleExportNameHasLoneSurrogate: ({surrogateCharCode: surrogateCharCode}) =>
    `An export name cannot include a lone surrogate, found '\\u${surrogateCharCode.toString(16)}'.`,
  ModuleExportUndefined: ({localName: localName}) =>
    `Export '${localName}' is not defined.`,
  MultipleDefaultsInSwitch: 'Multiple default clauses.',
  NewlineAfterThrow: 'Illegal newline after throw.',
  NoCatchOrFinally: 'Missing catch or finally clause.',
  NumberIdentifier: 'Identifier directly after number.',
  NumericSeparatorInEscapeSequence:
    'Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.',
  ObsoleteAwaitStar:
    "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
  OptionalChainingNoNew:
    'Constructors in/after an Optional Chain are not allowed.',
  OptionalChainingNoTemplate:
    'Tagged Template Literals are not allowed in optionalChain.',
  OverrideOnConstructor:
    "'override' modifier cannot appear on a constructor declaration.",
  ParamDupe: 'Argument name clash.',
  PatternHasAccessor: "Object pattern can't contain getter or setter.",
  PatternHasMethod: "Object pattern can't contain methods.",
  PrivateInExpectedIn: ({identifierName: identifierName}) =>
    `Private names are only allowed in property accesses (\`obj.#${identifierName}\`) or in \`in\` expressions (\`#${identifierName} in obj\`).`,
  PrivateNameRedeclaration: ({identifierName: identifierName}) =>
    `Duplicate private name #${identifierName}.`,
  RecordExpressionBarIncorrectEndSyntaxType:
    "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
  RecordExpressionBarIncorrectStartSyntaxType:
    "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
  RecordExpressionHashIncorrectStartSyntaxType:
    "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
  RecordNoProto: "'__proto__' is not allowed in Record expressions.",
  RestTrailingComma: 'Unexpected trailing comma after rest element.',
  SloppyFunction:
    'In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.',
  StaticPrototype: 'Classes may not have static property named prototype.',
  SuperNotAllowed:
    "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
  SuperPrivateField: "Private fields can't be accessed on super.",
  TrailingDecorator: 'Decorators must be attached to a class element.',
  TupleExpressionBarIncorrectEndSyntaxType:
    "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
  TupleExpressionBarIncorrectStartSyntaxType:
    "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
  TupleExpressionHashIncorrectStartSyntaxType:
    "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
  UnexpectedArgumentPlaceholder: 'Unexpected argument placeholder.',
  UnexpectedAwaitAfterPipelineBody:
    'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
  UnexpectedDigitAfterHash: 'Unexpected digit after hash token.',
  UnexpectedImportExport:
    "'import' and 'export' may only appear at the top level.",
  UnexpectedKeyword: ({keyword: keyword}) => `Unexpected keyword '${keyword}'.`,
  UnexpectedLeadingDecorator:
    'Leading decorators must be attached to a class declaration.',
  UnexpectedLexicalDeclaration:
    'Lexical declaration cannot appear in a single-statement context.',
  UnexpectedNewTarget:
    '`new.target` can only be used in functions or class properties.',
  UnexpectedNumericSeparator:
    'A numeric separator is only allowed between two digits.',
  UnexpectedPrivateField: 'Unexpected private name.',
  UnexpectedReservedWord: ({reservedWord: reservedWord}) =>
    `Unexpected reserved word '${reservedWord}'.`,
  UnexpectedSuper: "'super' is only allowed in object methods and classes.",
  UnexpectedToken: ({expected: expected, unexpected: unexpected}) =>
    `Unexpected token${unexpected ? ` '${unexpected}'.` : ''}${expected ? `, expected "${expected}"` : ''}`,
  UnexpectedTokenUnaryExponentiation:
    'Illegal expression. Wrap left hand side or entire exponentiation in parentheses.',
  UnsupportedBind: 'Binding should be performed on object property.',
  UnsupportedDecoratorExport:
    'A decorated export must export a class declaration.',
  UnsupportedDefaultExport:
    'Only expressions, functions or classes are allowed as the `default` export.',
  UnsupportedImport:
    '`import` can only be used in `import()` or `import.meta`.',
  UnsupportedMetaProperty: ({
    target: target,
    onlyValidPropertyName: onlyValidPropertyName,
  }) =>
    `The only valid meta property for ${target} is ${target}.${onlyValidPropertyName}.`,
  UnsupportedParameterDecorator:
    'Decorators cannot be used to decorate parameters.',
  UnsupportedPropertyDecorator:
    'Decorators cannot be used to decorate object literal properties.',
  UnsupportedSuper:
    "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
  UnterminatedComment: 'Unterminated comment.',
  UnterminatedRegExp: 'Unterminated regular expression.',
  UnterminatedString: 'Unterminated string constant.',
  UnterminatedTemplate: 'Unterminated template.',
  VarRedeclaration: ({identifierName: identifierName}) =>
    `Identifier '${identifierName}' has already been declared.`,
  YieldBindingIdentifier:
    "Can not use 'yield' as identifier inside a generator.",
  YieldInParameter: 'Yield expression is not allowed in formal parameters.',
  ZeroDigitNumericSeparator:
    'Numeric separator can not be used after leading 0.',
};
var StrictModeErrors = {
  StrictDelete: 'Deleting local variable in strict mode.',
  StrictEvalArguments: ({referenceName: referenceName}) =>
    `Assigning to '${referenceName}' in strict mode.`,
  StrictEvalArgumentsBinding: ({bindingName: bindingName}) =>
    `Binding '${bindingName}' in strict mode.`,
  StrictFunction:
    'In strict mode code, functions can only be declared at top level or inside a block.',
  StrictNumericEscape: "The only valid numeric escape in strict mode is '\\0'.",
  StrictOctalLiteral: 'Legacy octal literals are not allowed in strict mode.',
  StrictWith: "'with' in strict mode.",
};
const UnparenthesizedPipeBodyDescriptions = new Set([
  'ArrowFunctionExpression',
  'AssignmentExpression',
  'ConditionalExpression',
  'YieldExpression',
]);
var PipelineOperatorErrors = {
  PipeBodyIsTighter:
    'Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.',
  PipeTopicRequiresHackPipes:
    'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
  PipeTopicUnbound:
    'Topic reference is unbound; it must be inside a pipe body.',
  PipeTopicUnconfiguredToken: ({token: token}) =>
    `Invalid topic token ${token}. In order to use ${token} as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "${token}" }.`,
  PipeTopicUnused:
    'Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.',
  PipeUnparenthesizedBody: ({type: type}) =>
    `Hack-style pipe body cannot be an unparenthesized ${toNodeDescription({type: type})}; please wrap it in parentheses.`,
  PipelineBodyNoArrow:
    'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
  PipelineBodySequenceExpression:
    'Pipeline body may not be a comma-separated sequence expression.',
  PipelineHeadSequenceExpression:
    'Pipeline head should not be a comma-separated sequence expression.',
  PipelineTopicUnused:
    'Pipeline is in topic style but does not use topic reference.',
  PrimaryTopicNotAllowed:
    'Topic reference was used in a lexical context without topic binding.',
  PrimaryTopicRequiresSmartPipeline:
    'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
};
const _excluded$1 = ['toMessage'],
  _excluded2$1 = ['message'];
function toParseErrorConstructor(_ref) {
  let {toMessage: toMessage} = _ref,
    properties = _objectWithoutPropertiesLoose(_ref, _excluded$1);
  return function constructor({loc: loc, details: details}) {
    return instantiate(SyntaxError, Object.assign({}, properties, {loc: loc}), {
      clone(overrides = {}) {
        const loc = overrides.loc || {};
        return constructor({
          loc: new Position(
            'line' in loc ? loc.line : this.loc.line,
            'column' in loc ? loc.column : this.loc.column,
            'index' in loc ? loc.index : this.loc.index
          ),
          details: Object.assign({}, this.details, overrides.details),
        });
      },
      details: {value: details, enumerable: false},
      message: {
        get() {
          return `${toMessage(this.details)} (${this.loc.line}:${this.loc.column})`;
        },
        set(value) {
          Object.defineProperty(this, 'message', {value: value});
        },
      },
      pos: {reflect: 'loc.index', enumerable: true},
      missingPlugin: 'missingPlugin' in details && {
        reflect: 'details.missingPlugin',
        enumerable: true,
      },
    });
  };
}
function ParseErrorEnum(argument, syntaxPlugin) {
  if (Array.isArray(argument)) {
    return parseErrorTemplates =>
      ParseErrorEnum(parseErrorTemplates, argument[0]);
  }
  const ParseErrorConstructors = {};
  for (const reasonCode of Object.keys(argument)) {
    const template = argument[reasonCode];
    const _ref2 =
        typeof template === 'string'
          ? {message: () => template}
          : typeof template === 'function'
            ? {message: template}
            : template,
      {message: message} = _ref2,
      rest = _objectWithoutPropertiesLoose(_ref2, _excluded2$1);
    const toMessage = typeof message === 'string' ? () => message : message;
    ParseErrorConstructors[reasonCode] = toParseErrorConstructor(
      Object.assign(
        {
          code: ParseErrorCode.SyntaxError,
          reasonCode: reasonCode,
          toMessage: toMessage,
        },
        syntaxPlugin ? {syntaxPlugin: syntaxPlugin} : {},
        rest
      )
    );
  }
  return ParseErrorConstructors;
}
const Errors = Object.assign(
  {},
  ParseErrorEnum(ModuleErrors),
  ParseErrorEnum(StandardErrors),
  ParseErrorEnum(StrictModeErrors),
  ParseErrorEnum`pipelineOperator`(PipelineOperatorErrors)
);
const {defineProperty: defineProperty} = Object;
const toUnenumerable = (object, key) =>
  defineProperty(object, key, {enumerable: false, value: object[key]});
function toESTreeLocation(node) {
  node.loc.start && toUnenumerable(node.loc.start, 'index');
  node.loc.end && toUnenumerable(node.loc.end, 'index');
  return node;
}
var estree = superClass =>
  class ESTreeParserMixin extends superClass {
    parse() {
      const file = toESTreeLocation(super.parse());
      if (this.options.tokens) {
        file.tokens = file.tokens.map(toESTreeLocation);
      }
      return file;
    }
    parseRegExpLiteral({pattern: pattern, flags: flags}) {
      let regex = null;
      try {
        regex = new RegExp(pattern, flags);
      } catch (e) {}
      const node = this.estreeParseLiteral(regex);
      node.regex = {pattern: pattern, flags: flags};
      return node;
    }
    parseBigIntLiteral(value) {
      let bigInt;
      try {
        bigInt = BigInt(value);
      } catch (_unused) {
        bigInt = null;
      }
      const node = this.estreeParseLiteral(bigInt);
      node.bigint = String(node.value || value);
      return node;
    }
    parseDecimalLiteral(value) {
      const decimal = null;
      const node = this.estreeParseLiteral(decimal);
      node.decimal = String(node.value || value);
      return node;
    }
    estreeParseLiteral(value) {
      return this.parseLiteral(value, 'Literal');
    }
    parseStringLiteral(value) {
      return this.estreeParseLiteral(value);
    }
    parseNumericLiteral(value) {
      return this.estreeParseLiteral(value);
    }
    parseNullLiteral() {
      return this.estreeParseLiteral(null);
    }
    parseBooleanLiteral(value) {
      return this.estreeParseLiteral(value);
    }
    directiveToStmt(directive) {
      const expression = directive.value;
      delete directive.value;
      expression.type = 'Literal';
      expression.raw = expression.extra.raw;
      expression.value = expression.extra.expressionValue;
      const stmt = directive;
      stmt.type = 'ExpressionStatement';
      stmt.expression = expression;
      stmt.directive = expression.extra.rawValue;
      delete expression.extra;
      return stmt;
    }
    initFunction(node, isAsync) {
      super.initFunction(node, isAsync);
      node.expression = false;
    }
    checkDeclaration(node) {
      if (node != null && this.isObjectProperty(node)) {
        this.checkDeclaration(node.value);
      } else {
        super.checkDeclaration(node);
      }
    }
    getObjectOrClassMethodParams(method) {
      return method.value.params;
    }
    isValidDirective(stmt) {
      var _stmt$expression$extr;
      return (
        stmt.type === 'ExpressionStatement' &&
        stmt.expression.type === 'Literal' &&
        typeof stmt.expression.value === 'string' &&
        !(
          (_stmt$expression$extr = stmt.expression.extra) != null &&
          _stmt$expression$extr.parenthesized
        )
      );
    }
    parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
      super.parseBlockBody(
        node,
        allowDirectives,
        topLevel,
        end,
        afterBlockParse
      );
      const directiveStatements = node.directives.map(d =>
        this.directiveToStmt(d)
      );
      node.body = directiveStatements.concat(node.body);
      delete node.directives;
    }
    pushClassMethod(
      classBody,
      method,
      isGenerator,
      isAsync,
      isConstructor,
      allowsDirectSuper
    ) {
      this.parseMethod(
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper,
        'ClassMethod',
        true
      );
      if (method.typeParameters) {
        method.value.typeParameters = method.typeParameters;
        delete method.typeParameters;
      }
      classBody.body.push(method);
    }
    parsePrivateName() {
      const node = super.parsePrivateName();
      {
        if (!this.getPluginOption('estree', 'classFeatures')) {
          return node;
        }
      }
      return this.convertPrivateNameToPrivateIdentifier(node);
    }
    convertPrivateNameToPrivateIdentifier(node) {
      const name = super.getPrivateNameSV(node);
      node = node;
      delete node.id;
      node.name = name;
      node.type = 'PrivateIdentifier';
      return node;
    }
    isPrivateName(node) {
      {
        if (!this.getPluginOption('estree', 'classFeatures')) {
          return super.isPrivateName(node);
        }
      }
      return node.type === 'PrivateIdentifier';
    }
    getPrivateNameSV(node) {
      {
        if (!this.getPluginOption('estree', 'classFeatures')) {
          return super.getPrivateNameSV(node);
        }
      }
      return node.name;
    }
    parseLiteral(value, type) {
      const node = super.parseLiteral(value, type);
      node.raw = node.extra.raw;
      delete node.extra;
      return node;
    }
    parseFunctionBody(node, allowExpression, isMethod = false) {
      super.parseFunctionBody(node, allowExpression, isMethod);
      node.expression = node.body.type !== 'BlockStatement';
    }
    parseMethod(
      node,
      isGenerator,
      isAsync,
      isConstructor,
      allowDirectSuper,
      type,
      inClassScope = false
    ) {
      let funcNode = this.startNode();
      funcNode.kind = node.kind;
      funcNode = super.parseMethod(
        funcNode,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope
      );
      funcNode.type = 'FunctionExpression';
      delete funcNode.kind;
      node.value = funcNode;
      if (type === 'ClassPrivateMethod') {
        node.computed = false;
      }
      return this.finishNode(node, 'MethodDefinition');
    }
    parseClassProperty(...args) {
      const propertyNode = super.parseClassProperty(...args);
      {
        if (!this.getPluginOption('estree', 'classFeatures')) {
          return propertyNode;
        }
      }
      propertyNode.type = 'PropertyDefinition';
      return propertyNode;
    }
    parseClassPrivateProperty(...args) {
      const propertyNode = super.parseClassPrivateProperty(...args);
      {
        if (!this.getPluginOption('estree', 'classFeatures')) {
          return propertyNode;
        }
      }
      propertyNode.type = 'PropertyDefinition';
      propertyNode.computed = false;
      return propertyNode;
    }
    parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
      const node = super.parseObjectMethod(
        prop,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor
      );
      if (node) {
        node.type = 'Property';
        if (node.kind === 'method') {
          node.kind = 'init';
        }
        node.shorthand = false;
      }
      return node;
    }
    parseObjectProperty(
      prop,
      startPos,
      startLoc,
      isPattern,
      refExpressionErrors
    ) {
      const node = super.parseObjectProperty(
        prop,
        startPos,
        startLoc,
        isPattern,
        refExpressionErrors
      );
      if (node) {
        node.kind = 'init';
        node.type = 'Property';
      }
      return node;
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      return type === 'Property'
        ? 'value'
        : super.isValidLVal(type, isUnparenthesizedInAssign, binding);
    }
    isAssignable(node, isBinding) {
      if (node != null && this.isObjectProperty(node)) {
        return this.isAssignable(node.value, isBinding);
      }
      return super.isAssignable(node, isBinding);
    }
    toAssignable(node, isLHS = false) {
      if (node != null && this.isObjectProperty(node)) {
        const {key: key, value: value} = node;
        if (this.isPrivateName(key)) {
          this.classScope.usePrivateName(
            this.getPrivateNameSV(key),
            key.loc.start
          );
        }
        this.toAssignable(value, isLHS);
      } else {
        super.toAssignable(node, isLHS);
      }
    }
    toAssignableObjectExpressionProp(prop, isLast, isLHS) {
      if (prop.kind === 'get' || prop.kind === 'set') {
        this.raise(Errors.PatternHasAccessor, {at: prop.key});
      } else if (prop.method) {
        this.raise(Errors.PatternHasMethod, {at: prop.key});
      } else {
        super.toAssignableObjectExpressionProp(prop, isLast, isLHS);
      }
    }
    finishCallExpression(unfinished, optional) {
      const node = super.finishCallExpression(unfinished, optional);
      if (node.callee.type === 'Import') {
        node.type = 'ImportExpression';
        node.source = node.arguments[0];
        if (this.hasPlugin('importAssertions')) {
          var _node$arguments$;
          node.attributes =
            (_node$arguments$ = node.arguments[1]) != null
              ? _node$arguments$
              : null;
        }
        delete node.arguments;
        delete node.callee;
      }
      return node;
    }
    toReferencedArguments(node) {
      if (node.type === 'ImportExpression') {
        return;
      }
      super.toReferencedArguments(node);
    }
    parseExport(unfinished) {
      const node = super.parseExport(unfinished);
      switch (node.type) {
        case 'ExportAllDeclaration':
          node.exported = null;
          break;
        case 'ExportNamedDeclaration':
          if (
            node.specifiers.length === 1 &&
            node.specifiers[0].type === 'ExportNamespaceSpecifier'
          ) {
            node.type = 'ExportAllDeclaration';
            node.exported = node.specifiers[0].exported;
            delete node.specifiers;
          }
          break;
      }
      return node;
    }
    parseSubscript(base, startPos, startLoc, noCalls, state) {
      const node = super.parseSubscript(
        base,
        startPos,
        startLoc,
        noCalls,
        state
      );
      if (state.optionalChainMember) {
        if (
          node.type === 'OptionalMemberExpression' ||
          node.type === 'OptionalCallExpression'
        ) {
          node.type = node.type.substring(8);
        }
        if (state.stop) {
          const chain = this.startNodeAtNode(node);
          chain.expression = node;
          return this.finishNode(chain, 'ChainExpression');
        }
      } else if (
        node.type === 'MemberExpression' ||
        node.type === 'CallExpression'
      ) {
        node.optional = false;
      }
      return node;
    }
    hasPropertyAsPrivateName(node) {
      if (node.type === 'ChainExpression') {
        node = node.expression;
      }
      return super.hasPropertyAsPrivateName(node);
    }
    isOptionalChain(node) {
      return node.type === 'ChainExpression';
    }
    isObjectProperty(node) {
      return node.type === 'Property' && node.kind === 'init' && !node.method;
    }
    isObjectMethod(node) {
      return node.method || node.kind === 'get' || node.kind === 'set';
    }
    finishNodeAt(node, type, endLoc) {
      return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
    }
    resetStartLocation(node, start, startLoc) {
      super.resetStartLocation(node, start, startLoc);
      toESTreeLocation(node);
    }
    resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
      super.resetEndLocation(node, endLoc);
      toESTreeLocation(node);
    }
  };
class TokContext {
  constructor(token, preserveSpace) {
    this.token = void 0;
    this.preserveSpace = void 0;
    this.token = token;
    this.preserveSpace = !!preserveSpace;
  }
}
const types$2 = {
  brace: new TokContext('{'),
  j_oTag: new TokContext('<tag'),
  j_cTag: new TokContext('</tag'),
  j_expr: new TokContext('<tag>...</tag>', true),
};
{
  types$2.template = new TokContext('`', true);
}
const beforeExpr = true;
const startsExpr = true;
const isLoop = true;
const isAssign = true;
const prefix = true;
const postfix = true;
class ExportedTokenType {
  constructor(label, conf = {}) {
    this.label = void 0;
    this.keyword = void 0;
    this.beforeExpr = void 0;
    this.startsExpr = void 0;
    this.rightAssociative = void 0;
    this.isLoop = void 0;
    this.isAssign = void 0;
    this.prefix = void 0;
    this.postfix = void 0;
    this.binop = void 0;
    this.label = label;
    this.keyword = conf.keyword;
    this.beforeExpr = !!conf.beforeExpr;
    this.startsExpr = !!conf.startsExpr;
    this.rightAssociative = !!conf.rightAssociative;
    this.isLoop = !!conf.isLoop;
    this.isAssign = !!conf.isAssign;
    this.prefix = !!conf.prefix;
    this.postfix = !!conf.postfix;
    this.binop = conf.binop != null ? conf.binop : null;
    {
      this.updateContext = null;
    }
  }
}
const keywords$1 = new Map();
function createKeyword(name, options = {}) {
  options.keyword = name;
  const token = createToken(name, options);
  keywords$1.set(name, token);
  return token;
}
function createBinop(name, binop) {
  return createToken(name, {beforeExpr: beforeExpr, binop: binop});
}
let tokenTypeCounter = -1;
const tokenTypes = [];
const tokenLabels = [];
const tokenBinops = [];
const tokenBeforeExprs = [];
const tokenStartsExprs = [];
const tokenPrefixes = [];
function createToken(name, options = {}) {
  var _options$binop, _options$beforeExpr, _options$startsExpr, _options$prefix;
  ++tokenTypeCounter;
  tokenLabels.push(name);
  tokenBinops.push(
    (_options$binop = options.binop) != null ? _options$binop : -1
  );
  tokenBeforeExprs.push(
    (_options$beforeExpr = options.beforeExpr) != null
      ? _options$beforeExpr
      : false
  );
  tokenStartsExprs.push(
    (_options$startsExpr = options.startsExpr) != null
      ? _options$startsExpr
      : false
  );
  tokenPrefixes.push(
    (_options$prefix = options.prefix) != null ? _options$prefix : false
  );
  tokenTypes.push(new ExportedTokenType(name, options));
  return tokenTypeCounter;
}
function createKeywordLike(name, options = {}) {
  var _options$binop2,
    _options$beforeExpr2,
    _options$startsExpr2,
    _options$prefix2;
  ++tokenTypeCounter;
  keywords$1.set(name, tokenTypeCounter);
  tokenLabels.push(name);
  tokenBinops.push(
    (_options$binop2 = options.binop) != null ? _options$binop2 : -1
  );
  tokenBeforeExprs.push(
    (_options$beforeExpr2 = options.beforeExpr) != null
      ? _options$beforeExpr2
      : false
  );
  tokenStartsExprs.push(
    (_options$startsExpr2 = options.startsExpr) != null
      ? _options$startsExpr2
      : false
  );
  tokenPrefixes.push(
    (_options$prefix2 = options.prefix) != null ? _options$prefix2 : false
  );
  tokenTypes.push(new ExportedTokenType('name', options));
  return tokenTypeCounter;
}
const tt = {
  bracketL: createToken('[', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
  bracketHashL: createToken('#[', {
    beforeExpr: beforeExpr,
    startsExpr: startsExpr,
  }),
  bracketBarL: createToken('[|', {
    beforeExpr: beforeExpr,
    startsExpr: startsExpr,
  }),
  bracketR: createToken(']'),
  bracketBarR: createToken('|]'),
  braceL: createToken('{', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
  braceBarL: createToken('{|', {
    beforeExpr: beforeExpr,
    startsExpr: startsExpr,
  }),
  braceHashL: createToken('#{', {
    beforeExpr: beforeExpr,
    startsExpr: startsExpr,
  }),
  braceR: createToken('}'),
  braceBarR: createToken('|}'),
  parenL: createToken('(', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
  parenR: createToken(')'),
  comma: createToken(',', {beforeExpr: beforeExpr}),
  semi: createToken(';', {beforeExpr: beforeExpr}),
  colon: createToken(':', {beforeExpr: beforeExpr}),
  doubleColon: createToken('::', {beforeExpr: beforeExpr}),
  dot: createToken('.'),
  question: createToken('?', {beforeExpr: beforeExpr}),
  questionDot: createToken('?.'),
  arrow: createToken('=>', {beforeExpr: beforeExpr}),
  template: createToken('template'),
  ellipsis: createToken('...', {beforeExpr: beforeExpr}),
  backQuote: createToken('`', {startsExpr: startsExpr}),
  dollarBraceL: createToken('${', {
    beforeExpr: beforeExpr,
    startsExpr: startsExpr,
  }),
  templateTail: createToken('...`', {startsExpr: startsExpr}),
  templateNonTail: createToken('...${', {
    beforeExpr: beforeExpr,
    startsExpr: startsExpr,
  }),
  at: createToken('@'),
  hash: createToken('#', {startsExpr: startsExpr}),
  interpreterDirective: createToken('#!...'),
  eq: createToken('=', {beforeExpr: beforeExpr, isAssign: isAssign}),
  assign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
  slashAssign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
  xorAssign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
  moduloAssign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
  incDec: createToken('++/--', {
    prefix: prefix,
    postfix: postfix,
    startsExpr: startsExpr,
  }),
  bang: createToken('!', {
    beforeExpr: beforeExpr,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  tilde: createToken('~', {
    beforeExpr: beforeExpr,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  doubleCaret: createToken('^^', {startsExpr: startsExpr}),
  doubleAt: createToken('@@', {startsExpr: startsExpr}),
  pipeline: createBinop('|>', 0),
  nullishCoalescing: createBinop('??', 1),
  logicalOR: createBinop('||', 1),
  logicalAND: createBinop('&&', 2),
  bitwiseOR: createBinop('|', 3),
  bitwiseXOR: createBinop('^', 4),
  bitwiseAND: createBinop('&', 5),
  equality: createBinop('==/!=/===/!==', 6),
  lt: createBinop('</>/<=/>=', 7),
  gt: createBinop('</>/<=/>=', 7),
  relational: createBinop('</>/<=/>=', 7),
  bitShift: createBinop('<</>>/>>>', 8),
  bitShiftL: createBinop('<</>>/>>>', 8),
  bitShiftR: createBinop('<</>>/>>>', 8),
  plusMin: createToken('+/-', {
    beforeExpr: beforeExpr,
    binop: 9,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  modulo: createToken('%', {binop: 10, startsExpr: startsExpr}),
  star: createToken('*', {binop: 10}),
  slash: createBinop('/', 10),
  exponent: createToken('**', {
    beforeExpr: beforeExpr,
    binop: 11,
    rightAssociative: true,
  }),
  _in: createKeyword('in', {beforeExpr: beforeExpr, binop: 7}),
  _instanceof: createKeyword('instanceof', {beforeExpr: beforeExpr, binop: 7}),
  _break: createKeyword('break'),
  _case: createKeyword('case', {beforeExpr: beforeExpr}),
  _catch: createKeyword('catch'),
  _continue: createKeyword('continue'),
  _debugger: createKeyword('debugger'),
  _default: createKeyword('default', {beforeExpr: beforeExpr}),
  _else: createKeyword('else', {beforeExpr: beforeExpr}),
  _finally: createKeyword('finally'),
  _function: createKeyword('function', {startsExpr: startsExpr}),
  _if: createKeyword('if'),
  _return: createKeyword('return', {beforeExpr: beforeExpr}),
  _switch: createKeyword('switch'),
  _throw: createKeyword('throw', {
    beforeExpr: beforeExpr,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  _try: createKeyword('try'),
  _var: createKeyword('var'),
  _const: createKeyword('const'),
  _with: createKeyword('with'),
  _new: createKeyword('new', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
  _this: createKeyword('this', {startsExpr: startsExpr}),
  _super: createKeyword('super', {startsExpr: startsExpr}),
  _class: createKeyword('class', {startsExpr: startsExpr}),
  _extends: createKeyword('extends', {beforeExpr: beforeExpr}),
  _export: createKeyword('export'),
  _import: createKeyword('import', {startsExpr: startsExpr}),
  _null: createKeyword('null', {startsExpr: startsExpr}),
  _true: createKeyword('true', {startsExpr: startsExpr}),
  _false: createKeyword('false', {startsExpr: startsExpr}),
  _typeof: createKeyword('typeof', {
    beforeExpr: beforeExpr,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  _void: createKeyword('void', {
    beforeExpr: beforeExpr,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  _delete: createKeyword('delete', {
    beforeExpr: beforeExpr,
    prefix: prefix,
    startsExpr: startsExpr,
  }),
  _do: createKeyword('do', {isLoop: isLoop, beforeExpr: beforeExpr}),
  _for: createKeyword('for', {isLoop: isLoop}),
  _while: createKeyword('while', {isLoop: isLoop}),
  _as: createKeywordLike('as', {startsExpr: startsExpr}),
  _assert: createKeywordLike('assert', {startsExpr: startsExpr}),
  _async: createKeywordLike('async', {startsExpr: startsExpr}),
  _await: createKeywordLike('await', {startsExpr: startsExpr}),
  _from: createKeywordLike('from', {startsExpr: startsExpr}),
  _get: createKeywordLike('get', {startsExpr: startsExpr}),
  _let: createKeywordLike('let', {startsExpr: startsExpr}),
  _meta: createKeywordLike('meta', {startsExpr: startsExpr}),
  _of: createKeywordLike('of', {startsExpr: startsExpr}),
  _sent: createKeywordLike('sent', {startsExpr: startsExpr}),
  _set: createKeywordLike('set', {startsExpr: startsExpr}),
  _static: createKeywordLike('static', {startsExpr: startsExpr}),
  _yield: createKeywordLike('yield', {startsExpr: startsExpr}),
  _asserts: createKeywordLike('asserts', {startsExpr: startsExpr}),
  _checks: createKeywordLike('checks', {startsExpr: startsExpr}),
  _exports: createKeywordLike('exports', {startsExpr: startsExpr}),
  _global: createKeywordLike('global', {startsExpr: startsExpr}),
  _implements: createKeywordLike('implements', {startsExpr: startsExpr}),
  _intrinsic: createKeywordLike('intrinsic', {startsExpr: startsExpr}),
  _infer: createKeywordLike('infer', {startsExpr: startsExpr}),
  _is: createKeywordLike('is', {startsExpr: startsExpr}),
  _mixins: createKeywordLike('mixins', {startsExpr: startsExpr}),
  _proto: createKeywordLike('proto', {startsExpr: startsExpr}),
  _require: createKeywordLike('require', {startsExpr: startsExpr}),
  _keyof: createKeywordLike('keyof', {startsExpr: startsExpr}),
  _readonly: createKeywordLike('readonly', {startsExpr: startsExpr}),
  _unique: createKeywordLike('unique', {startsExpr: startsExpr}),
  _abstract: createKeywordLike('abstract', {startsExpr: startsExpr}),
  _declare: createKeywordLike('declare', {startsExpr: startsExpr}),
  _enum: createKeywordLike('enum', {startsExpr: startsExpr}),
  _module: createKeywordLike('module', {startsExpr: startsExpr}),
  _namespace: createKeywordLike('namespace', {startsExpr: startsExpr}),
  _interface: createKeywordLike('interface', {startsExpr: startsExpr}),
  _type: createKeywordLike('type', {startsExpr: startsExpr}),
  _opaque: createKeywordLike('opaque', {startsExpr: startsExpr}),
  name: createToken('name', {startsExpr: startsExpr}),
  string: createToken('string', {startsExpr: startsExpr}),
  num: createToken('num', {startsExpr: startsExpr}),
  bigint: createToken('bigint', {startsExpr: startsExpr}),
  decimal: createToken('decimal', {startsExpr: startsExpr}),
  regexp: createToken('regexp', {startsExpr: startsExpr}),
  privateName: createToken('#name', {startsExpr: startsExpr}),
  eof: createToken('eof'),
  jsxName: createToken('jsxName'),
  jsxText: createToken('jsxText', {beforeExpr: true}),
  jsxTagStart: createToken('jsxTagStart', {startsExpr: true}),
  jsxTagEnd: createToken('jsxTagEnd'),
  placeholder: createToken('%%', {startsExpr: true}),
};
function tokenIsIdentifier(token) {
  return token >= 93 && token <= 128;
}
function tokenKeywordOrIdentifierIsKeyword(token) {
  return token <= 92;
}
function tokenIsKeywordOrIdentifier(token) {
  return token >= 58 && token <= 128;
}
function tokenIsLiteralPropertyName(token) {
  return token >= 58 && token <= 132;
}
function tokenComesBeforeExpression(token) {
  return tokenBeforeExprs[token];
}
function tokenCanStartExpression(token) {
  return tokenStartsExprs[token];
}
function tokenIsAssignment(token) {
  return token >= 29 && token <= 33;
}
function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
  return token >= 125 && token <= 127;
}
function tokenIsLoop(token) {
  return token >= 90 && token <= 92;
}
function tokenIsKeyword(token) {
  return token >= 58 && token <= 92;
}
function tokenIsOperator(token) {
  return token >= 39 && token <= 59;
}
function tokenIsPostfix(token) {
  return token === 34;
}
function tokenIsPrefix(token) {
  return tokenPrefixes[token];
}
function tokenIsTSTypeOperator(token) {
  return token >= 117 && token <= 119;
}
function tokenIsTSDeclarationStart(token) {
  return token >= 120 && token <= 126;
}
function tokenLabelName(token) {
  return tokenLabels[token];
}
function tokenOperatorPrecedence(token) {
  return tokenBinops[token];
}
function tokenIsRightAssociative(token) {
  return token === 57;
}
function tokenIsTemplate(token) {
  return token >= 24 && token <= 25;
}
function getExportedToken(token) {
  return tokenTypes[token];
}
{
  tokenTypes[8].updateContext = context => {
    context.pop();
  };
  tokenTypes[5].updateContext =
    tokenTypes[7].updateContext =
    tokenTypes[23].updateContext =
      context => {
        context.push(types$2.brace);
      };
  tokenTypes[22].updateContext = context => {
    if (context[context.length - 1] === types$2.template) {
      context.pop();
    } else {
      context.push(types$2.template);
    }
  };
  tokenTypes[138].updateContext = context => {
    context.push(types$2.j_expr, types$2.j_oTag);
  };
}
let nonASCIIidentifierStartChars =
  'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
let nonASCIIidentifierChars =
  '‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿';
const nonASCIIidentifierStart = new RegExp(
  '[' + nonASCIIidentifierStartChars + ']'
);
const nonASCIIidentifier = new RegExp(
  '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
);
nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
const astralIdentifierStartCodes = [
  0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48,
  31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39,
  9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21,
  11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10,
  30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43,
  28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14,
  50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13,
  52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15,
  3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46,
  39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21,
  2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26,
  38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7,
  3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8,
  2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0,
  328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96,
  16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3,
  32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237,
  43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309,
  106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0,
  2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24,
  2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30,
  7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3,
  2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2,
  3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2,
  0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2,
  16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938,
  6, 4191,
];
const astralIdentifierCodes = [
  509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574,
  3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3,
  46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2,
  11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0,
  11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1,
  83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3,
  2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47,
  15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9,
  49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 9, 5351, 0, 7,
  14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1,
  19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49,
  513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4,
  101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983, 6, 110, 6, 6, 9, 4759, 9,
  787719, 239,
];
function isInAstralSet(code, set) {
  let pos = 65536;
  for (let i = 0, length = set.length; i < length; i += 2) {
    pos += set[i];
    if (pos > code) return false;
    pos += set[i + 1];
    if (pos >= code) return true;
  }
  return false;
}
function isIdentifierStart(code) {
  if (code < 65) return code === 36;
  if (code <= 90) return true;
  if (code < 97) return code === 95;
  if (code <= 122) return true;
  if (code <= 65535) {
    return (
      code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
    );
  }
  return isInAstralSet(code, astralIdentifierStartCodes);
}
function isIdentifierChar(code) {
  if (code < 48) return code === 36;
  if (code < 58) return true;
  if (code < 65) return false;
  if (code <= 90) return true;
  if (code < 97) return code === 95;
  if (code <= 122) return true;
  if (code <= 65535) {
    return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
  }
  return (
    isInAstralSet(code, astralIdentifierStartCodes) ||
    isInAstralSet(code, astralIdentifierCodes)
  );
}
const reservedWords = {
  keyword: [
    'break',
    'case',
    'catch',
    'continue',
    'debugger',
    'default',
    'do',
    'else',
    'finally',
    'for',
    'function',
    'if',
    'return',
    'switch',
    'throw',
    'try',
    'var',
    'const',
    'while',
    'with',
    'new',
    'this',
    'super',
    'class',
    'extends',
    'export',
    'import',
    'null',
    'true',
    'false',
    'in',
    'instanceof',
    'typeof',
    'void',
    'delete',
  ],
  strict: [
    'implements',
    'interface',
    'let',
    'package',
    'private',
    'protected',
    'public',
    'static',
    'yield',
  ],
  strictBind: ['eval', 'arguments'],
};
const keywords$2 = new Set(reservedWords.keyword);
const reservedWordsStrictSet = new Set(reservedWords.strict);
const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
function isReservedWord(word, inModule) {
  return (inModule && word === 'await') || word === 'enum';
}
function isStrictReservedWord(word, inModule) {
  return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
}
function isStrictBindOnlyReservedWord(word) {
  return reservedWordsStrictBindSet.has(word);
}
function isStrictBindReservedWord(word, inModule) {
  return (
    isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
  );
}
function isKeyword(word) {
  return keywords$2.has(word);
}
function isIteratorStart(current, next, next2) {
  return current === 64 && next === 64 && isIdentifierStart(next2);
}
const reservedWordLikeSet = new Set([
  'break',
  'case',
  'catch',
  'continue',
  'debugger',
  'default',
  'do',
  'else',
  'finally',
  'for',
  'function',
  'if',
  'return',
  'switch',
  'throw',
  'try',
  'var',
  'const',
  'while',
  'with',
  'new',
  'this',
  'super',
  'class',
  'extends',
  'export',
  'import',
  'null',
  'true',
  'false',
  'in',
  'instanceof',
  'typeof',
  'void',
  'delete',
  'implements',
  'interface',
  'let',
  'package',
  'private',
  'protected',
  'public',
  'static',
  'yield',
  'eval',
  'arguments',
  'enum',
  'await',
]);
function canBeReservedWord(word) {
  return reservedWordLikeSet.has(word);
}
const SCOPE_OTHER = 0,
  SCOPE_PROGRAM = 1,
  SCOPE_FUNCTION = 2,
  SCOPE_ARROW = 4,
  SCOPE_SIMPLE_CATCH = 8,
  SCOPE_SUPER = 16,
  SCOPE_DIRECT_SUPER = 32,
  SCOPE_CLASS = 64,
  SCOPE_STATIC_BLOCK = 128,
  SCOPE_TS_MODULE = 256,
  SCOPE_VAR = SCOPE_PROGRAM | SCOPE_FUNCTION | SCOPE_TS_MODULE;
const BIND_KIND_VALUE = 1,
  BIND_KIND_TYPE = 2,
  BIND_SCOPE_VAR = 4,
  BIND_SCOPE_LEXICAL = 8,
  BIND_SCOPE_FUNCTION = 16,
  BIND_FLAGS_NONE = 64,
  BIND_FLAGS_CLASS = 128,
  BIND_FLAGS_TS_ENUM = 256,
  BIND_FLAGS_TS_CONST_ENUM = 512,
  BIND_FLAGS_TS_EXPORT_ONLY = 1024,
  BIND_FLAGS_FLOW_DECLARE_FN = 2048,
  BIND_FLAGS_TS_IMPORT = 4096;
const BIND_CLASS =
    BIND_KIND_VALUE | BIND_KIND_TYPE | BIND_SCOPE_LEXICAL | BIND_FLAGS_CLASS,
  BIND_LEXICAL = BIND_KIND_VALUE | 0 | BIND_SCOPE_LEXICAL | 0,
  BIND_VAR = BIND_KIND_VALUE | 0 | BIND_SCOPE_VAR | 0,
  BIND_FUNCTION = BIND_KIND_VALUE | 0 | BIND_SCOPE_FUNCTION | 0,
  BIND_TS_INTERFACE = 0 | BIND_KIND_TYPE | 0 | BIND_FLAGS_CLASS,
  BIND_TS_TYPE = 0 | BIND_KIND_TYPE | 0 | 0,
  BIND_TS_ENUM =
    BIND_KIND_VALUE | BIND_KIND_TYPE | BIND_SCOPE_LEXICAL | BIND_FLAGS_TS_ENUM,
  BIND_TS_AMBIENT = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY,
  BIND_NONE = 0 | 0 | 0 | BIND_FLAGS_NONE,
  BIND_OUTSIDE = BIND_KIND_VALUE | 0 | 0 | BIND_FLAGS_NONE,
  BIND_TS_CONST_ENUM = BIND_TS_ENUM | BIND_FLAGS_TS_CONST_ENUM,
  BIND_TS_NAMESPACE = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY,
  BIND_TS_TYPE_IMPORT = 0 | BIND_KIND_TYPE | 0 | BIND_FLAGS_TS_IMPORT,
  BIND_FLOW_DECLARE_FN = BIND_FLAGS_FLOW_DECLARE_FN;
const CLASS_ELEMENT_FLAG_STATIC = 4,
  CLASS_ELEMENT_KIND_GETTER = 2,
  CLASS_ELEMENT_KIND_SETTER = 1,
  CLASS_ELEMENT_KIND_ACCESSOR =
    CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_KIND_SETTER;
const CLASS_ELEMENT_STATIC_GETTER =
    CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_FLAG_STATIC,
  CLASS_ELEMENT_STATIC_SETTER =
    CLASS_ELEMENT_KIND_SETTER | CLASS_ELEMENT_FLAG_STATIC,
  CLASS_ELEMENT_INSTANCE_GETTER = CLASS_ELEMENT_KIND_GETTER,
  CLASS_ELEMENT_INSTANCE_SETTER = CLASS_ELEMENT_KIND_SETTER,
  CLASS_ELEMENT_OTHER = 0;
class Scope {
  constructor(flags) {
    this.var = new Set();
    this.lexical = new Set();
    this.functions = new Set();
    this.flags = flags;
  }
}
class ScopeHandler {
  constructor(parser, inModule) {
    this.parser = void 0;
    this.scopeStack = [];
    this.inModule = void 0;
    this.undefinedExports = new Map();
    this.parser = parser;
    this.inModule = inModule;
  }
  get inFunction() {
    return (this.currentVarScopeFlags() & SCOPE_FUNCTION) > 0;
  }
  get allowSuper() {
    return (this.currentThisScopeFlags() & SCOPE_SUPER) > 0;
  }
  get allowDirectSuper() {
    return (this.currentThisScopeFlags() & SCOPE_DIRECT_SUPER) > 0;
  }
  get inClass() {
    return (this.currentThisScopeFlags() & SCOPE_CLASS) > 0;
  }
  get inClassAndNotInNonArrowFunction() {
    const flags = this.currentThisScopeFlags();
    return (flags & SCOPE_CLASS) > 0 && (flags & SCOPE_FUNCTION) === 0;
  }
  get inStaticBlock() {
    for (let i = this.scopeStack.length - 1; ; i--) {
      const {flags: flags} = this.scopeStack[i];
      if (flags & SCOPE_STATIC_BLOCK) {
        return true;
      }
      if (flags & (SCOPE_VAR | SCOPE_CLASS)) {
        return false;
      }
    }
  }
  get inNonArrowFunction() {
    return (this.currentThisScopeFlags() & SCOPE_FUNCTION) > 0;
  }
  get treatFunctionsAsVar() {
    return this.treatFunctionsAsVarInScope(this.currentScope());
  }
  createScope(flags) {
    return new Scope(flags);
  }
  enter(flags) {
    this.scopeStack.push(this.createScope(flags));
  }
  exit() {
    const scope = this.scopeStack.pop();
    return scope.flags;
  }
  treatFunctionsAsVarInScope(scope) {
    return !!(
      scope.flags & (SCOPE_FUNCTION | SCOPE_STATIC_BLOCK) ||
      (!this.parser.inModule && scope.flags & SCOPE_PROGRAM)
    );
  }
  declareName(name, bindingType, loc) {
    let scope = this.currentScope();
    if (bindingType & BIND_SCOPE_LEXICAL || bindingType & BIND_SCOPE_FUNCTION) {
      this.checkRedeclarationInScope(scope, name, bindingType, loc);
      if (bindingType & BIND_SCOPE_FUNCTION) {
        scope.functions.add(name);
      } else {
        scope.lexical.add(name);
      }
      if (bindingType & BIND_SCOPE_LEXICAL) {
        this.maybeExportDefined(scope, name);
      }
    } else if (bindingType & BIND_SCOPE_VAR) {
      for (let i = this.scopeStack.length - 1; i >= 0; --i) {
        scope = this.scopeStack[i];
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        scope.var.add(name);
        this.maybeExportDefined(scope, name);
        if (scope.flags & SCOPE_VAR) break;
      }
    }
    if (this.parser.inModule && scope.flags & SCOPE_PROGRAM) {
      this.undefinedExports.delete(name);
    }
  }
  maybeExportDefined(scope, name) {
    if (this.parser.inModule && scope.flags & SCOPE_PROGRAM) {
      this.undefinedExports.delete(name);
    }
  }
  checkRedeclarationInScope(scope, name, bindingType, loc) {
    if (this.isRedeclaredInScope(scope, name, bindingType)) {
      this.parser.raise(Errors.VarRedeclaration, {
        at: loc,
        identifierName: name,
      });
    }
  }
  isRedeclaredInScope(scope, name, bindingType) {
    if (!(bindingType & BIND_KIND_VALUE)) return false;
    if (bindingType & BIND_SCOPE_LEXICAL) {
      return (
        scope.lexical.has(name) ||
        scope.functions.has(name) ||
        scope.var.has(name)
      );
    }
    if (bindingType & BIND_SCOPE_FUNCTION) {
      return (
        scope.lexical.has(name) ||
        (!this.treatFunctionsAsVarInScope(scope) && scope.var.has(name))
      );
    }
    return (
      (scope.lexical.has(name) &&
        !(
          scope.flags & SCOPE_SIMPLE_CATCH &&
          scope.lexical.values().next().value === name
        )) ||
      (!this.treatFunctionsAsVarInScope(scope) && scope.functions.has(name))
    );
  }
  checkLocalExport(id) {
    const {name: name} = id;
    const topLevelScope = this.scopeStack[0];
    if (
      !topLevelScope.lexical.has(name) &&
      !topLevelScope.var.has(name) &&
      !topLevelScope.functions.has(name)
    ) {
      this.undefinedExports.set(name, id.loc.start);
    }
  }
  currentScope() {
    return this.scopeStack[this.scopeStack.length - 1];
  }
  currentVarScopeFlags() {
    for (let i = this.scopeStack.length - 1; ; i--) {
      const {flags: flags} = this.scopeStack[i];
      if (flags & SCOPE_VAR) {
        return flags;
      }
    }
  }
  currentThisScopeFlags() {
    for (let i = this.scopeStack.length - 1; ; i--) {
      const {flags: flags} = this.scopeStack[i];
      if (flags & (SCOPE_VAR | SCOPE_CLASS) && !(flags & SCOPE_ARROW)) {
        return flags;
      }
    }
  }
}
class FlowScope extends Scope {
  constructor(...args) {
    super(...args);
    this.declareFunctions = new Set();
  }
}
class FlowScopeHandler extends ScopeHandler {
  createScope(flags) {
    return new FlowScope(flags);
  }
  declareName(name, bindingType, loc) {
    const scope = this.currentScope();
    if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
      this.checkRedeclarationInScope(scope, name, bindingType, loc);
      this.maybeExportDefined(scope, name);
      scope.declareFunctions.add(name);
      return;
    }
    super.declareName(name, bindingType, loc);
  }
  isRedeclaredInScope(scope, name, bindingType) {
    if (super.isRedeclaredInScope(scope, name, bindingType)) return true;
    if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
      return (
        !scope.declareFunctions.has(name) &&
        (scope.lexical.has(name) || scope.functions.has(name))
      );
    }
    return false;
  }
  checkLocalExport(id) {
    if (!this.scopeStack[0].declareFunctions.has(id.name)) {
      super.checkLocalExport(id);
    }
  }
}
class BaseParser {
  constructor() {
    this.sawUnambiguousESM = false;
    this.ambiguousScriptDifferentAst = false;
  }
  hasPlugin(pluginConfig) {
    if (typeof pluginConfig === 'string') {
      return this.plugins.has(pluginConfig);
    } else {
      const [pluginName, pluginOptions] = pluginConfig;
      if (!this.hasPlugin(pluginName)) {
        return false;
      }
      const actualOptions = this.plugins.get(pluginName);
      for (const key of Object.keys(pluginOptions)) {
        if (
          (actualOptions == null ? void 0 : actualOptions[key]) !==
          pluginOptions[key]
        ) {
          return false;
        }
      }
      return true;
    }
  }
  getPluginOption(plugin, name) {
    var _this$plugins$get;
    return (_this$plugins$get = this.plugins.get(plugin)) == null
      ? void 0
      : _this$plugins$get[name];
  }
}
function setTrailingComments(node, comments) {
  if (node.trailingComments === undefined) {
    node.trailingComments = comments;
  } else {
    node.trailingComments.unshift(...comments);
  }
}
function setLeadingComments(node, comments) {
  if (node.leadingComments === undefined) {
    node.leadingComments = comments;
  } else {
    node.leadingComments.unshift(...comments);
  }
}
function setInnerComments(node, comments) {
  if (node.innerComments === undefined) {
    node.innerComments = comments;
  } else {
    node.innerComments.unshift(...comments);
  }
}
function adjustInnerComments(node, elements, commentWS) {
  let lastElement = null;
  let i = elements.length;
  while (lastElement === null && i > 0) {
    lastElement = elements[--i];
  }
  if (lastElement === null || lastElement.start > commentWS.start) {
    setInnerComments(node, commentWS.comments);
  } else {
    setTrailingComments(lastElement, commentWS.comments);
  }
}
class CommentsParser extends BaseParser {
  addComment(comment) {
    if (this.filename) comment.loc.filename = this.filename;
    this.state.comments.push(comment);
  }
  processComment(node) {
    const {commentStack: commentStack} = this.state;
    const commentStackLength = commentStack.length;
    if (commentStackLength === 0) return;
    let i = commentStackLength - 1;
    const lastCommentWS = commentStack[i];
    if (lastCommentWS.start === node.end) {
      lastCommentWS.leadingNode = node;
      i--;
    }
    const {start: nodeStart} = node;
    for (; i >= 0; i--) {
      const commentWS = commentStack[i];
      const commentEnd = commentWS.end;
      if (commentEnd > nodeStart) {
        commentWS.containingNode = node;
        this.finalizeComment(commentWS);
        commentStack.splice(i, 1);
      } else {
        if (commentEnd === nodeStart) {
          commentWS.trailingNode = node;
        }
        break;
      }
    }
  }
  finalizeComment(commentWS) {
    const {comments: comments} = commentWS;
    if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
      if (commentWS.leadingNode !== null) {
        setTrailingComments(commentWS.leadingNode, comments);
      }
      if (commentWS.trailingNode !== null) {
        setLeadingComments(commentWS.trailingNode, comments);
      }
    } else {
      const {containingNode: node, start: commentStart} = commentWS;
      if (this.input.charCodeAt(commentStart - 1) === 44) {
        switch (node.type) {
          case 'ObjectExpression':
          case 'ObjectPattern':
          case 'RecordExpression':
            adjustInnerComments(node, node.properties, commentWS);
            break;
          case 'CallExpression':
          case 'OptionalCallExpression':
            adjustInnerComments(node, node.arguments, commentWS);
            break;
          case 'FunctionDeclaration':
          case 'FunctionExpression':
          case 'ArrowFunctionExpression':
          case 'ObjectMethod':
          case 'ClassMethod':
          case 'ClassPrivateMethod':
            adjustInnerComments(node, node.params, commentWS);
            break;
          case 'ArrayExpression':
          case 'ArrayPattern':
          case 'TupleExpression':
            adjustInnerComments(node, node.elements, commentWS);
            break;
          case 'ExportNamedDeclaration':
          case 'ImportDeclaration':
            adjustInnerComments(node, node.specifiers, commentWS);
            break;
          default: {
            setInnerComments(node, comments);
          }
        }
      } else {
        setInnerComments(node, comments);
      }
    }
  }
  finalizeRemainingComments() {
    const {commentStack: commentStack} = this.state;
    for (let i = commentStack.length - 1; i >= 0; i--) {
      this.finalizeComment(commentStack[i]);
    }
    this.state.commentStack = [];
  }
  resetPreviousNodeTrailingComments(node) {
    const {commentStack: commentStack} = this.state;
    const {length: length} = commentStack;
    if (length === 0) return;
    const commentWS = commentStack[length - 1];
    if (commentWS.leadingNode === node) {
      commentWS.leadingNode = null;
    }
  }
  takeSurroundingComments(node, start, end) {
    const {commentStack: commentStack} = this.state;
    const commentStackLength = commentStack.length;
    if (commentStackLength === 0) return;
    let i = commentStackLength - 1;
    for (; i >= 0; i--) {
      const commentWS = commentStack[i];
      const commentEnd = commentWS.end;
      const commentStart = commentWS.start;
      if (commentStart === end) {
        commentWS.leadingNode = node;
      } else if (commentEnd === start) {
        commentWS.trailingNode = node;
      } else if (commentEnd < start) {
        break;
      }
    }
  }
}
const lineBreak = /\r\n?|[\n\u2028\u2029]/;
const lineBreakG = new RegExp(lineBreak.source, 'g');
function isNewLine(code) {
  switch (code) {
    case 10:
    case 13:
    case 8232:
    case 8233:
      return true;
    default:
      return false;
  }
}
const skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
const skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/y;
const skipWhiteSpaceToLineBreak = new RegExp(
  '(?=(' +
    skipWhiteSpaceInLine.source +
    '))\\1' +
    /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source,
  'y'
);
function isWhitespace(code) {
  switch (code) {
    case 9:
    case 11:
    case 12:
    case 32:
    case 160:
    case 5760:
    case 8192:
    case 8193:
    case 8194:
    case 8195:
    case 8196:
    case 8197:
    case 8198:
    case 8199:
    case 8200:
    case 8201:
    case 8202:
    case 8239:
    case 8287:
    case 12288:
    case 65279:
      return true;
    default:
      return false;
  }
}
let State$3 = class State {
  constructor() {
    this.strict = void 0;
    this.curLine = void 0;
    this.lineStart = void 0;
    this.startLoc = void 0;
    this.endLoc = void 0;
    this.errors = [];
    this.potentialArrowAt = -1;
    this.noArrowAt = [];
    this.noArrowParamsConversionAt = [];
    this.maybeInArrowParameters = false;
    this.inType = false;
    this.noAnonFunctionType = false;
    this.hasFlowComment = false;
    this.isAmbientContext = false;
    this.inAbstractClass = false;
    this.inDisallowConditionalTypesContext = false;
    this.topicContext = {maxNumOfResolvableTopics: 0, maxTopicIndex: null};
    this.soloAwait = false;
    this.inFSharpPipelineDirectBody = false;
    this.labels = [];
    this.decoratorStack = [[]];
    this.comments = [];
    this.commentStack = [];
    this.pos = 0;
    this.type = 135;
    this.value = null;
    this.start = 0;
    this.end = 0;
    this.lastTokEndLoc = null;
    this.lastTokStartLoc = null;
    this.lastTokStart = 0;
    this.context = [types$2.brace];
    this.canStartJSXElement = true;
    this.containsEsc = false;
    this.strictErrors = new Map();
    this.tokensLength = 0;
  }
  init({
    strictMode: strictMode,
    sourceType: sourceType,
    startLine: startLine,
    startColumn: startColumn,
  }) {
    this.strict =
      strictMode === false
        ? false
        : strictMode === true
          ? true
          : sourceType === 'module';
    this.curLine = startLine;
    this.lineStart = -startColumn;
    this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
  }
  curPosition() {
    return new Position(this.curLine, this.pos - this.lineStart, this.pos);
  }
  clone(skipArrays) {
    const state = new State();
    const keys = Object.keys(this);
    for (let i = 0, length = keys.length; i < length; i++) {
      const key = keys[i];
      let val = this[key];
      if (!skipArrays && Array.isArray(val)) {
        val = val.slice();
      }
      state[key] = val;
    }
    return state;
  }
};
var _isDigit = function isDigit(code) {
  return code >= 48 && code <= 57;
};
const forbiddenNumericSeparatorSiblings = {
  decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
  hex: new Set([46, 88, 95, 120]),
};
const isAllowedNumericSeparatorSibling = {
  bin: ch => ch === 48 || ch === 49,
  oct: ch => ch >= 48 && ch <= 55,
  dec: ch => ch >= 48 && ch <= 57,
  hex: ch =>
    (ch >= 48 && ch <= 57) || (ch >= 65 && ch <= 70) || (ch >= 97 && ch <= 102),
};
function readStringContents(type, input, pos, lineStart, curLine, errors) {
  const initialPos = pos;
  const initialLineStart = lineStart;
  const initialCurLine = curLine;
  let out = '';
  let containsInvalid = false;
  let chunkStart = pos;
  const {length: length} = input;
  for (;;) {
    if (pos >= length) {
      errors.unterminated(initialPos, initialLineStart, initialCurLine);
      out += input.slice(chunkStart, pos);
      break;
    }
    const ch = input.charCodeAt(pos);
    if (isStringEnd(type, ch, input, pos)) {
      out += input.slice(chunkStart, pos);
      break;
    }
    if (ch === 92) {
      out += input.slice(chunkStart, pos);
      let escaped;
      ({
        ch: escaped,
        pos: pos,
        lineStart: lineStart,
        curLine: curLine,
      } = readEscapedChar(
        input,
        pos,
        lineStart,
        curLine,
        type === 'template',
        errors
      ));
      if (escaped === null) {
        containsInvalid = true;
      } else {
        out += escaped;
      }
      chunkStart = pos;
    } else if (ch === 8232 || ch === 8233) {
      ++pos;
      ++curLine;
      lineStart = pos;
    } else if (ch === 10 || ch === 13) {
      if (type === 'template') {
        out += input.slice(chunkStart, pos) + '\n';
        ++pos;
        if (ch === 13 && input.charCodeAt(pos) === 10) {
          ++pos;
        }
        ++curLine;
        chunkStart = lineStart = pos;
      } else {
        errors.unterminated(initialPos, initialLineStart, initialCurLine);
      }
    } else {
      ++pos;
    }
  }
  return {
    pos: pos,
    str: out,
    containsInvalid: containsInvalid,
    lineStart: lineStart,
    curLine: curLine,
  };
}
function isStringEnd(type, ch, input, pos) {
  if (type === 'template') {
    return ch === 96 || (ch === 36 && input.charCodeAt(pos + 1) === 123);
  }
  return ch === (type === 'double' ? 34 : 39);
}
function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
  const throwOnInvalid = !inTemplate;
  pos++;
  const res = ch => ({
    pos: pos,
    ch: ch,
    lineStart: lineStart,
    curLine: curLine,
  });
  const ch = input.charCodeAt(pos++);
  switch (ch) {
    case 110:
      return res('\n');
    case 114:
      return res('\r');
    case 120: {
      let code;
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        2,
        false,
        throwOnInvalid,
        errors
      ));
      return res(code === null ? null : String.fromCharCode(code));
    }
    case 117: {
      let code;
      ({code: code, pos: pos} = readCodePoint(
        input,
        pos,
        lineStart,
        curLine,
        throwOnInvalid,
        errors
      ));
      return res(code === null ? null : String.fromCodePoint(code));
    }
    case 116:
      return res('\t');
    case 98:
      return res('\b');
    case 118:
      return res('\v');
    case 102:
      return res('\f');
    case 13:
      if (input.charCodeAt(pos) === 10) {
        ++pos;
      }
    case 10:
      lineStart = pos;
      ++curLine;
    case 8232:
    case 8233:
      return res('');
    case 56:
    case 57:
      if (inTemplate) {
        return res(null);
      } else {
        errors.strictNumericEscape(pos - 1, lineStart, curLine);
      }
    default:
      if (ch >= 48 && ch <= 55) {
        const startPos = pos - 1;
        const match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
        let octalStr = match[0];
        let octal = parseInt(octalStr, 8);
        if (octal > 255) {
          octalStr = octalStr.slice(0, -1);
          octal = parseInt(octalStr, 8);
        }
        pos += octalStr.length - 1;
        const next = input.charCodeAt(pos);
        if (octalStr !== '0' || next === 56 || next === 57) {
          if (inTemplate) {
            return res(null);
          } else {
            errors.strictNumericEscape(startPos, lineStart, curLine);
          }
        }
        return res(String.fromCharCode(octal));
      }
      return res(String.fromCharCode(ch));
  }
}
function readHexChar(
  input,
  pos,
  lineStart,
  curLine,
  len,
  forceLen,
  throwOnInvalid,
  errors
) {
  const initialPos = pos;
  let n;
  ({n: n, pos: pos} = readInt(
    input,
    pos,
    lineStart,
    curLine,
    16,
    len,
    forceLen,
    false,
    errors
  ));
  if (n === null) {
    if (throwOnInvalid) {
      errors.invalidEscapeSequence(initialPos, lineStart, curLine);
    } else {
      pos = initialPos - 1;
    }
  }
  return {code: n, pos: pos};
}
function readInt(
  input,
  pos,
  lineStart,
  curLine,
  radix,
  len,
  forceLen,
  allowNumSeparator,
  errors
) {
  const start = pos;
  const forbiddenSiblings =
    radix === 16
      ? forbiddenNumericSeparatorSiblings.hex
      : forbiddenNumericSeparatorSiblings.decBinOct;
  const isAllowedSibling =
    radix === 16
      ? isAllowedNumericSeparatorSibling.hex
      : radix === 10
        ? isAllowedNumericSeparatorSibling.dec
        : radix === 8
          ? isAllowedNumericSeparatorSibling.oct
          : isAllowedNumericSeparatorSibling.bin;
  let invalid = false;
  let total = 0;
  for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
    const code = input.charCodeAt(pos);
    let val;
    if (code === 95 && allowNumSeparator !== 'bail') {
      const prev = input.charCodeAt(pos - 1);
      const next = input.charCodeAt(pos + 1);
      if (!allowNumSeparator) {
        errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
      } else if (
        Number.isNaN(next) ||
        !isAllowedSibling(next) ||
        forbiddenSiblings.has(prev) ||
        forbiddenSiblings.has(next)
      ) {
        errors.unexpectedNumericSeparator(pos, lineStart, curLine);
      }
      ++pos;
      continue;
    }
    if (code >= 97) {
      val = code - 97 + 10;
    } else if (code >= 65) {
      val = code - 65 + 10;
    } else if (_isDigit(code)) {
      val = code - 48;
    } else {
      val = Infinity;
    }
    if (val >= radix) {
      if (val <= 9 && errors.invalidDigit(pos, lineStart, curLine, radix)) {
        val = 0;
      } else if (forceLen) {
        val = 0;
        invalid = true;
      } else {
        break;
      }
    }
    ++pos;
    total = total * radix + val;
  }
  if (pos === start || (len != null && pos - start !== len) || invalid) {
    return {n: null, pos: pos};
  }
  return {n: total, pos: pos};
}
function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors) {
  const ch = input.charCodeAt(pos);
  let code;
  if (ch === 123) {
    ++pos;
    ({code: code, pos: pos} = readHexChar(
      input,
      pos,
      lineStart,
      curLine,
      input.indexOf('}', pos) - pos,
      true,
      throwOnInvalid,
      errors
    ));
    ++pos;
    if (code !== null && code > 1114111) {
      if (throwOnInvalid) {
        errors.invalidCodePoint(pos, lineStart, curLine);
      } else {
        return {code: null, pos: pos};
      }
    }
  } else {
    ({code: code, pos: pos} = readHexChar(
      input,
      pos,
      lineStart,
      curLine,
      4,
      false,
      throwOnInvalid,
      errors
    ));
  }
  return {code: code, pos: pos};
}
const _excluded = ['at'],
  _excluded2 = ['at'];
function buildPosition(pos, lineStart, curLine) {
  return new Position(curLine, pos - lineStart, pos);
}
const VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
class Token {
  constructor(state) {
    this.type = state.type;
    this.value = state.value;
    this.start = state.start;
    this.end = state.end;
    this.loc = new SourceLocation(state.startLoc, state.endLoc);
  }
}
class Tokenizer extends CommentsParser {
  constructor(options, input) {
    super();
    this.isLookahead = void 0;
    this.tokens = [];
    this.errorHandlers_readInt = {
      invalidDigit: (pos, lineStart, curLine, radix) => {
        if (!this.options.errorRecovery) return false;
        this.raise(Errors.InvalidDigit, {
          at: buildPosition(pos, lineStart, curLine),
          radix: radix,
        });
        return true;
      },
      numericSeparatorInEscapeSequence: this.errorBuilder(
        Errors.NumericSeparatorInEscapeSequence
      ),
      unexpectedNumericSeparator: this.errorBuilder(
        Errors.UnexpectedNumericSeparator
      ),
    };
    this.errorHandlers_readCodePoint = Object.assign(
      {},
      this.errorHandlers_readInt,
      {
        invalidEscapeSequence: this.errorBuilder(Errors.InvalidEscapeSequence),
        invalidCodePoint: this.errorBuilder(Errors.InvalidCodePoint),
      }
    );
    this.errorHandlers_readStringContents_string = Object.assign(
      {},
      this.errorHandlers_readCodePoint,
      {
        strictNumericEscape: (pos, lineStart, curLine) => {
          this.recordStrictModeErrors(Errors.StrictNumericEscape, {
            at: buildPosition(pos, lineStart, curLine),
          });
        },
        unterminated: (pos, lineStart, curLine) => {
          throw this.raise(Errors.UnterminatedString, {
            at: buildPosition(pos - 1, lineStart, curLine),
          });
        },
      }
    );
    this.errorHandlers_readStringContents_template = Object.assign(
      {},
      this.errorHandlers_readCodePoint,
      {
        strictNumericEscape: this.errorBuilder(Errors.StrictNumericEscape),
        unterminated: (pos, lineStart, curLine) => {
          throw this.raise(Errors.UnterminatedTemplate, {
            at: buildPosition(pos, lineStart, curLine),
          });
        },
      }
    );
    this.state = new State$3();
    this.state.init(options);
    this.input = input;
    this.length = input.length;
    this.isLookahead = false;
  }
  pushToken(token) {
    this.tokens.length = this.state.tokensLength;
    this.tokens.push(token);
    ++this.state.tokensLength;
  }
  next() {
    this.checkKeywordEscapes();
    if (this.options.tokens) {
      this.pushToken(new Token(this.state));
    }
    this.state.lastTokStart = this.state.start;
    this.state.lastTokEndLoc = this.state.endLoc;
    this.state.lastTokStartLoc = this.state.startLoc;
    this.nextToken();
  }
  eat(type) {
    if (this.match(type)) {
      this.next();
      return true;
    } else {
      return false;
    }
  }
  match(type) {
    return this.state.type === type;
  }
  createLookaheadState(state) {
    return {
      pos: state.pos,
      value: null,
      type: state.type,
      start: state.start,
      end: state.end,
      context: [this.curContext()],
      inType: state.inType,
      startLoc: state.startLoc,
      lastTokEndLoc: state.lastTokEndLoc,
      curLine: state.curLine,
      lineStart: state.lineStart,
      curPosition: state.curPosition,
    };
  }
  lookahead() {
    const old = this.state;
    this.state = this.createLookaheadState(old);
    this.isLookahead = true;
    this.nextToken();
    this.isLookahead = false;
    const curr = this.state;
    this.state = old;
    return curr;
  }
  nextTokenStart() {
    return this.nextTokenStartSince(this.state.pos);
  }
  nextTokenStartSince(pos) {
    skipWhiteSpace.lastIndex = pos;
    return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
  }
  lookaheadCharCode() {
    return this.input.charCodeAt(this.nextTokenStart());
  }
  codePointAtPos(pos) {
    let cp = this.input.charCodeAt(pos);
    if ((cp & 64512) === 55296 && ++pos < this.input.length) {
      const trail = this.input.charCodeAt(pos);
      if ((trail & 64512) === 56320) {
        cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
      }
    }
    return cp;
  }
  setStrict(strict) {
    this.state.strict = strict;
    if (strict) {
      this.state.strictErrors.forEach(([toParseError, at]) =>
        this.raise(toParseError, {at: at})
      );
      this.state.strictErrors.clear();
    }
  }
  curContext() {
    return this.state.context[this.state.context.length - 1];
  }
  nextToken() {
    this.skipSpace();
    this.state.start = this.state.pos;
    if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
    if (this.state.pos >= this.length) {
      this.finishToken(135);
      return;
    }
    this.getTokenFromCode(this.codePointAtPos(this.state.pos));
  }
  skipBlockComment() {
    let startLoc;
    if (!this.isLookahead) startLoc = this.state.curPosition();
    const start = this.state.pos;
    const end = this.input.indexOf('*/', start + 2);
    if (end === -1) {
      throw this.raise(Errors.UnterminatedComment, {
        at: this.state.curPosition(),
      });
    }
    this.state.pos = end + 2;
    lineBreakG.lastIndex = start + 2;
    while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
      ++this.state.curLine;
      this.state.lineStart = lineBreakG.lastIndex;
    }
    if (this.isLookahead) return;
    const comment = {
      type: 'CommentBlock',
      value: this.input.slice(start + 2, end),
      start: start,
      end: end + 2,
      loc: new SourceLocation(startLoc, this.state.curPosition()),
    };
    if (this.options.tokens) this.pushToken(comment);
    return comment;
  }
  skipLineComment(startSkip) {
    const start = this.state.pos;
    let startLoc;
    if (!this.isLookahead) startLoc = this.state.curPosition();
    let ch = this.input.charCodeAt((this.state.pos += startSkip));
    if (this.state.pos < this.length) {
      while (!isNewLine(ch) && ++this.state.pos < this.length) {
        ch = this.input.charCodeAt(this.state.pos);
      }
    }
    if (this.isLookahead) return;
    const end = this.state.pos;
    const value = this.input.slice(start + startSkip, end);
    const comment = {
      type: 'CommentLine',
      value: value,
      start: start,
      end: end,
      loc: new SourceLocation(startLoc, this.state.curPosition()),
    };
    if (this.options.tokens) this.pushToken(comment);
    return comment;
  }
  skipSpace() {
    const spaceStart = this.state.pos;
    const comments = [];
    loop: while (this.state.pos < this.length) {
      const ch = this.input.charCodeAt(this.state.pos);
      switch (ch) {
        case 32:
        case 160:
        case 9:
          ++this.state.pos;
          break;
        case 13:
          if (this.input.charCodeAt(this.state.pos + 1) === 10) {
            ++this.state.pos;
          }
        case 10:
        case 8232:
        case 8233:
          ++this.state.pos;
          ++this.state.curLine;
          this.state.lineStart = this.state.pos;
          break;
        case 47:
          switch (this.input.charCodeAt(this.state.pos + 1)) {
            case 42: {
              const comment = this.skipBlockComment();
              if (comment !== undefined) {
                this.addComment(comment);
                if (this.options.attachComment) comments.push(comment);
              }
              break;
            }
            case 47: {
              const comment = this.skipLineComment(2);
              if (comment !== undefined) {
                this.addComment(comment);
                if (this.options.attachComment) comments.push(comment);
              }
              break;
            }
            default:
              break loop;
          }
          break;
        default:
          if (isWhitespace(ch)) {
            ++this.state.pos;
          } else if (ch === 45 && !this.inModule) {
            const pos = this.state.pos;
            if (
              this.input.charCodeAt(pos + 1) === 45 &&
              this.input.charCodeAt(pos + 2) === 62 &&
              (spaceStart === 0 || this.state.lineStart > spaceStart)
            ) {
              const comment = this.skipLineComment(3);
              if (comment !== undefined) {
                this.addComment(comment);
                if (this.options.attachComment) comments.push(comment);
              }
            } else {
              break loop;
            }
          } else if (ch === 60 && !this.inModule) {
            const pos = this.state.pos;
            if (
              this.input.charCodeAt(pos + 1) === 33 &&
              this.input.charCodeAt(pos + 2) === 45 &&
              this.input.charCodeAt(pos + 3) === 45
            ) {
              const comment = this.skipLineComment(4);
              if (comment !== undefined) {
                this.addComment(comment);
                if (this.options.attachComment) comments.push(comment);
              }
            } else {
              break loop;
            }
          } else {
            break loop;
          }
      }
    }
    if (comments.length > 0) {
      const end = this.state.pos;
      const commentWhitespace = {
        start: spaceStart,
        end: end,
        comments: comments,
        leadingNode: null,
        trailingNode: null,
        containingNode: null,
      };
      this.state.commentStack.push(commentWhitespace);
    }
  }
  finishToken(type, val) {
    this.state.end = this.state.pos;
    this.state.endLoc = this.state.curPosition();
    const prevType = this.state.type;
    this.state.type = type;
    this.state.value = val;
    if (!this.isLookahead) {
      this.updateContext(prevType);
    }
  }
  replaceToken(type) {
    this.state.type = type;
    this.updateContext();
  }
  readToken_numberSign() {
    if (this.state.pos === 0 && this.readToken_interpreter()) {
      return;
    }
    const nextPos = this.state.pos + 1;
    const next = this.codePointAtPos(nextPos);
    if (next >= 48 && next <= 57) {
      throw this.raise(Errors.UnexpectedDigitAfterHash, {
        at: this.state.curPosition(),
      });
    }
    if (next === 123 || (next === 91 && this.hasPlugin('recordAndTuple'))) {
      this.expectPlugin('recordAndTuple');
      if (this.getPluginOption('recordAndTuple', 'syntaxType') === 'bar') {
        throw this.raise(
          next === 123
            ? Errors.RecordExpressionHashIncorrectStartSyntaxType
            : Errors.TupleExpressionHashIncorrectStartSyntaxType,
          {at: this.state.curPosition()}
        );
      }
      this.state.pos += 2;
      if (next === 123) {
        this.finishToken(7);
      } else {
        this.finishToken(1);
      }
    } else if (isIdentifierStart(next)) {
      ++this.state.pos;
      this.finishToken(134, this.readWord1(next));
    } else if (next === 92) {
      ++this.state.pos;
      this.finishToken(134, this.readWord1());
    } else {
      this.finishOp(27, 1);
    }
  }
  readToken_dot() {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (next >= 48 && next <= 57) {
      this.readNumber(true);
      return;
    }
    if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
      this.state.pos += 3;
      this.finishToken(21);
    } else {
      ++this.state.pos;
      this.finishToken(16);
    }
  }
  readToken_slash() {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (next === 61) {
      this.finishOp(31, 2);
    } else {
      this.finishOp(56, 1);
    }
  }
  readToken_interpreter() {
    if (this.state.pos !== 0 || this.length < 2) return false;
    let ch = this.input.charCodeAt(this.state.pos + 1);
    if (ch !== 33) return false;
    const start = this.state.pos;
    this.state.pos += 1;
    while (!isNewLine(ch) && ++this.state.pos < this.length) {
      ch = this.input.charCodeAt(this.state.pos);
    }
    const value = this.input.slice(start + 2, this.state.pos);
    this.finishToken(28, value);
    return true;
  }
  readToken_mult_modulo(code) {
    let type = code === 42 ? 55 : 54;
    let width = 1;
    let next = this.input.charCodeAt(this.state.pos + 1);
    if (code === 42 && next === 42) {
      width++;
      next = this.input.charCodeAt(this.state.pos + 2);
      type = 57;
    }
    if (next === 61 && !this.state.inType) {
      width++;
      type = code === 37 ? 33 : 30;
    }
    this.finishOp(type, width);
  }
  readToken_pipe_amp(code) {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (next === code) {
      if (this.input.charCodeAt(this.state.pos + 2) === 61) {
        this.finishOp(30, 3);
      } else {
        this.finishOp(code === 124 ? 41 : 42, 2);
      }
      return;
    }
    if (code === 124) {
      if (next === 62) {
        this.finishOp(39, 2);
        return;
      }
      if (this.hasPlugin('recordAndTuple') && next === 125) {
        if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
          throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, {
            at: this.state.curPosition(),
          });
        }
        this.state.pos += 2;
        this.finishToken(9);
        return;
      }
      if (this.hasPlugin('recordAndTuple') && next === 93) {
        if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
          throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, {
            at: this.state.curPosition(),
          });
        }
        this.state.pos += 2;
        this.finishToken(4);
        return;
      }
    }
    if (next === 61) {
      this.finishOp(30, 2);
      return;
    }
    this.finishOp(code === 124 ? 43 : 45, 1);
  }
  readToken_caret() {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (next === 61 && !this.state.inType) {
      this.finishOp(32, 2);
    } else if (
      next === 94 &&
      this.hasPlugin(['pipelineOperator', {proposal: 'hack', topicToken: '^^'}])
    ) {
      this.finishOp(37, 2);
      const lookaheadCh = this.input.codePointAt(this.state.pos);
      if (lookaheadCh === 94) {
        throw this.unexpected();
      }
    } else {
      this.finishOp(44, 1);
    }
  }
  readToken_atSign() {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (
      next === 64 &&
      this.hasPlugin(['pipelineOperator', {proposal: 'hack', topicToken: '@@'}])
    ) {
      this.finishOp(38, 2);
    } else {
      this.finishOp(26, 1);
    }
  }
  readToken_plus_min(code) {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (next === code) {
      this.finishOp(34, 2);
      return;
    }
    if (next === 61) {
      this.finishOp(30, 2);
    } else {
      this.finishOp(53, 1);
    }
  }
  readToken_lt() {
    const {pos: pos} = this.state;
    const next = this.input.charCodeAt(pos + 1);
    if (next === 60) {
      if (this.input.charCodeAt(pos + 2) === 61) {
        this.finishOp(30, 3);
        return;
      }
      this.finishOp(51, 2);
      return;
    }
    if (next === 61) {
      this.finishOp(49, 2);
      return;
    }
    this.finishOp(47, 1);
  }
  readToken_gt() {
    const {pos: pos} = this.state;
    const next = this.input.charCodeAt(pos + 1);
    if (next === 62) {
      const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
      if (this.input.charCodeAt(pos + size) === 61) {
        this.finishOp(30, size + 1);
        return;
      }
      this.finishOp(52, size);
      return;
    }
    if (next === 61) {
      this.finishOp(49, 2);
      return;
    }
    this.finishOp(48, 1);
  }
  readToken_eq_excl(code) {
    const next = this.input.charCodeAt(this.state.pos + 1);
    if (next === 61) {
      this.finishOp(
        46,
        this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2
      );
      return;
    }
    if (code === 61 && next === 62) {
      this.state.pos += 2;
      this.finishToken(19);
      return;
    }
    this.finishOp(code === 61 ? 29 : 35, 1);
  }
  readToken_question() {
    const next = this.input.charCodeAt(this.state.pos + 1);
    const next2 = this.input.charCodeAt(this.state.pos + 2);
    if (next === 63) {
      if (next2 === 61) {
        this.finishOp(30, 3);
      } else {
        this.finishOp(40, 2);
      }
    } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
      this.state.pos += 2;
      this.finishToken(18);
    } else {
      ++this.state.pos;
      this.finishToken(17);
    }
  }
  getTokenFromCode(code) {
    switch (code) {
      case 46:
        this.readToken_dot();
        return;
      case 40:
        ++this.state.pos;
        this.finishToken(10);
        return;
      case 41:
        ++this.state.pos;
        this.finishToken(11);
        return;
      case 59:
        ++this.state.pos;
        this.finishToken(13);
        return;
      case 44:
        ++this.state.pos;
        this.finishToken(12);
        return;
      case 91:
        if (
          this.hasPlugin('recordAndTuple') &&
          this.input.charCodeAt(this.state.pos + 1) === 124
        ) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(
              Errors.TupleExpressionBarIncorrectStartSyntaxType,
              {at: this.state.curPosition()}
            );
          }
          this.state.pos += 2;
          this.finishToken(2);
        } else {
          ++this.state.pos;
          this.finishToken(0);
        }
        return;
      case 93:
        ++this.state.pos;
        this.finishToken(3);
        return;
      case 123:
        if (
          this.hasPlugin('recordAndTuple') &&
          this.input.charCodeAt(this.state.pos + 1) === 124
        ) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(
              Errors.RecordExpressionBarIncorrectStartSyntaxType,
              {at: this.state.curPosition()}
            );
          }
          this.state.pos += 2;
          this.finishToken(6);
        } else {
          ++this.state.pos;
          this.finishToken(5);
        }
        return;
      case 125:
        ++this.state.pos;
        this.finishToken(8);
        return;
      case 58:
        if (
          this.hasPlugin('functionBind') &&
          this.input.charCodeAt(this.state.pos + 1) === 58
        ) {
          this.finishOp(15, 2);
        } else {
          ++this.state.pos;
          this.finishToken(14);
        }
        return;
      case 63:
        this.readToken_question();
        return;
      case 96:
        this.readTemplateToken();
        return;
      case 48: {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (next === 120 || next === 88) {
          this.readRadixNumber(16);
          return;
        }
        if (next === 111 || next === 79) {
          this.readRadixNumber(8);
          return;
        }
        if (next === 98 || next === 66) {
          this.readRadixNumber(2);
          return;
        }
      }
      case 49:
      case 50:
      case 51:
      case 52:
      case 53:
      case 54:
      case 55:
      case 56:
      case 57:
        this.readNumber(false);
        return;
      case 34:
      case 39:
        this.readString(code);
        return;
      case 47:
        this.readToken_slash();
        return;
      case 37:
      case 42:
        this.readToken_mult_modulo(code);
        return;
      case 124:
      case 38:
        this.readToken_pipe_amp(code);
        return;
      case 94:
        this.readToken_caret();
        return;
      case 43:
      case 45:
        this.readToken_plus_min(code);
        return;
      case 60:
        this.readToken_lt();
        return;
      case 62:
        this.readToken_gt();
        return;
      case 61:
      case 33:
        this.readToken_eq_excl(code);
        return;
      case 126:
        this.finishOp(36, 1);
        return;
      case 64:
        this.readToken_atSign();
        return;
      case 35:
        this.readToken_numberSign();
        return;
      case 92:
        this.readWord();
        return;
      default:
        if (isIdentifierStart(code)) {
          this.readWord(code);
          return;
        }
    }
    throw this.raise(Errors.InvalidOrUnexpectedToken, {
      at: this.state.curPosition(),
      unexpected: String.fromCodePoint(code),
    });
  }
  finishOp(type, size) {
    const str = this.input.slice(this.state.pos, this.state.pos + size);
    this.state.pos += size;
    this.finishToken(type, str);
  }
  readRegexp() {
    const startLoc = this.state.startLoc;
    const start = this.state.start + 1;
    let escaped, inClass;
    let {pos: pos} = this.state;
    for (; ; ++pos) {
      if (pos >= this.length) {
        throw this.raise(Errors.UnterminatedRegExp, {
          at: createPositionWithColumnOffset(startLoc, 1),
        });
      }
      const ch = this.input.charCodeAt(pos);
      if (isNewLine(ch)) {
        throw this.raise(Errors.UnterminatedRegExp, {
          at: createPositionWithColumnOffset(startLoc, 1),
        });
      }
      if (escaped) {
        escaped = false;
      } else {
        if (ch === 91) {
          inClass = true;
        } else if (ch === 93 && inClass) {
          inClass = false;
        } else if (ch === 47 && !inClass) {
          break;
        }
        escaped = ch === 92;
      }
    }
    const content = this.input.slice(start, pos);
    ++pos;
    let mods = '';
    const nextPos = () =>
      createPositionWithColumnOffset(startLoc, pos + 2 - start);
    while (pos < this.length) {
      const cp = this.codePointAtPos(pos);
      const char = String.fromCharCode(cp);
      if (VALID_REGEX_FLAGS.has(cp)) {
        if (cp === 118) {
          this.expectPlugin('regexpUnicodeSets', nextPos());
          if (mods.includes('u')) {
            this.raise(Errors.IncompatibleRegExpUVFlags, {at: nextPos()});
          }
        } else if (cp === 117) {
          if (mods.includes('v')) {
            this.raise(Errors.IncompatibleRegExpUVFlags, {at: nextPos()});
          }
        }
        if (mods.includes(char)) {
          this.raise(Errors.DuplicateRegExpFlags, {at: nextPos()});
        }
      } else if (isIdentifierChar(cp) || cp === 92) {
        this.raise(Errors.MalformedRegExpFlags, {at: nextPos()});
      } else {
        break;
      }
      ++pos;
      mods += char;
    }
    this.state.pos = pos;
    this.finishToken(133, {pattern: content, flags: mods});
  }
  readInt(radix, len, forceLen = false, allowNumSeparator = true) {
    const {n: n, pos: pos} = readInt(
      this.input,
      this.state.pos,
      this.state.lineStart,
      this.state.curLine,
      radix,
      len,
      forceLen,
      allowNumSeparator,
      this.errorHandlers_readInt
    );
    this.state.pos = pos;
    return n;
  }
  readRadixNumber(radix) {
    const startLoc = this.state.curPosition();
    let isBigInt = false;
    this.state.pos += 2;
    const val = this.readInt(radix);
    if (val == null) {
      this.raise(Errors.InvalidDigit, {
        at: createPositionWithColumnOffset(startLoc, 2),
        radix: radix,
      });
    }
    const next = this.input.charCodeAt(this.state.pos);
    if (next === 110) {
      ++this.state.pos;
      isBigInt = true;
    } else if (next === 109) {
      throw this.raise(Errors.InvalidDecimal, {at: startLoc});
    }
    if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
      throw this.raise(Errors.NumberIdentifier, {at: this.state.curPosition()});
    }
    if (isBigInt) {
      const str = this.input
        .slice(startLoc.index, this.state.pos)
        .replace(/[_n]/g, '');
      this.finishToken(131, str);
      return;
    }
    this.finishToken(130, val);
  }
  readNumber(startsWithDot) {
    const start = this.state.pos;
    const startLoc = this.state.curPosition();
    let isFloat = false;
    let isBigInt = false;
    let isDecimal = false;
    let hasExponent = false;
    let isOctal = false;
    if (!startsWithDot && this.readInt(10) === null) {
      this.raise(Errors.InvalidNumber, {at: this.state.curPosition()});
    }
    const hasLeadingZero =
      this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
    if (hasLeadingZero) {
      const integer = this.input.slice(start, this.state.pos);
      this.recordStrictModeErrors(Errors.StrictOctalLiteral, {at: startLoc});
      if (!this.state.strict) {
        const underscorePos = integer.indexOf('_');
        if (underscorePos > 0) {
          this.raise(Errors.ZeroDigitNumericSeparator, {
            at: createPositionWithColumnOffset(startLoc, underscorePos),
          });
        }
      }
      isOctal = hasLeadingZero && !/[89]/.test(integer);
    }
    let next = this.input.charCodeAt(this.state.pos);
    if (next === 46 && !isOctal) {
      ++this.state.pos;
      this.readInt(10);
      isFloat = true;
      next = this.input.charCodeAt(this.state.pos);
    }
    if ((next === 69 || next === 101) && !isOctal) {
      next = this.input.charCodeAt(++this.state.pos);
      if (next === 43 || next === 45) {
        ++this.state.pos;
      }
      if (this.readInt(10) === null) {
        this.raise(Errors.InvalidOrMissingExponent, {at: startLoc});
      }
      isFloat = true;
      hasExponent = true;
      next = this.input.charCodeAt(this.state.pos);
    }
    if (next === 110) {
      if (isFloat || hasLeadingZero) {
        this.raise(Errors.InvalidBigIntLiteral, {at: startLoc});
      }
      ++this.state.pos;
      isBigInt = true;
    }
    if (next === 109) {
      this.expectPlugin('decimal', this.state.curPosition());
      if (hasExponent || hasLeadingZero) {
        this.raise(Errors.InvalidDecimal, {at: startLoc});
      }
      ++this.state.pos;
      isDecimal = true;
    }
    if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
      throw this.raise(Errors.NumberIdentifier, {at: this.state.curPosition()});
    }
    const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, '');
    if (isBigInt) {
      this.finishToken(131, str);
      return;
    }
    if (isDecimal) {
      this.finishToken(132, str);
      return;
    }
    const val = isOctal ? parseInt(str, 8) : parseFloat(str);
    this.finishToken(130, val);
  }
  readCodePoint(throwOnInvalid) {
    const {code: code, pos: pos} = readCodePoint(
      this.input,
      this.state.pos,
      this.state.lineStart,
      this.state.curLine,
      throwOnInvalid,
      this.errorHandlers_readCodePoint
    );
    this.state.pos = pos;
    return code;
  }
  readString(quote) {
    const {
      str: str,
      pos: pos,
      curLine: curLine,
      lineStart: lineStart,
    } = readStringContents(
      quote === 34 ? 'double' : 'single',
      this.input,
      this.state.pos + 1,
      this.state.lineStart,
      this.state.curLine,
      this.errorHandlers_readStringContents_string
    );
    this.state.pos = pos + 1;
    this.state.lineStart = lineStart;
    this.state.curLine = curLine;
    this.finishToken(129, str);
  }
  readTemplateContinuation() {
    if (!this.match(8)) {
      this.unexpected(null, 8);
    }
    this.state.pos--;
    this.readTemplateToken();
  }
  readTemplateToken() {
    const opening = this.input[this.state.pos];
    const {
      str: str,
      containsInvalid: containsInvalid,
      pos: pos,
      curLine: curLine,
      lineStart: lineStart,
    } = readStringContents(
      'template',
      this.input,
      this.state.pos + 1,
      this.state.lineStart,
      this.state.curLine,
      this.errorHandlers_readStringContents_template
    );
    this.state.pos = pos + 1;
    this.state.lineStart = lineStart;
    this.state.curLine = curLine;
    if (this.input.codePointAt(pos) === 96) {
      this.finishToken(24, containsInvalid ? null : opening + str + '`');
    } else {
      this.state.pos++;
      this.finishToken(25, containsInvalid ? null : opening + str + '${');
    }
  }
  recordStrictModeErrors(toParseError, {at: at}) {
    const index = at.index;
    if (this.state.strict && !this.state.strictErrors.has(index)) {
      this.raise(toParseError, {at: at});
    } else {
      this.state.strictErrors.set(index, [toParseError, at]);
    }
  }
  readWord1(firstCode) {
    this.state.containsEsc = false;
    let word = '';
    const start = this.state.pos;
    let chunkStart = this.state.pos;
    if (firstCode !== undefined) {
      this.state.pos += firstCode <= 65535 ? 1 : 2;
    }
    while (this.state.pos < this.length) {
      const ch = this.codePointAtPos(this.state.pos);
      if (isIdentifierChar(ch)) {
        this.state.pos += ch <= 65535 ? 1 : 2;
      } else if (ch === 92) {
        this.state.containsEsc = true;
        word += this.input.slice(chunkStart, this.state.pos);
        const escStart = this.state.curPosition();
        const identifierCheck =
          this.state.pos === start ? isIdentifierStart : isIdentifierChar;
        if (this.input.charCodeAt(++this.state.pos) !== 117) {
          this.raise(Errors.MissingUnicodeEscape, {
            at: this.state.curPosition(),
          });
          chunkStart = this.state.pos - 1;
          continue;
        }
        ++this.state.pos;
        const esc = this.readCodePoint(true);
        if (esc !== null) {
          if (!identifierCheck(esc)) {
            this.raise(Errors.EscapedCharNotAnIdentifier, {at: escStart});
          }
          word += String.fromCodePoint(esc);
        }
        chunkStart = this.state.pos;
      } else {
        break;
      }
    }
    return word + this.input.slice(chunkStart, this.state.pos);
  }
  readWord(firstCode) {
    const word = this.readWord1(firstCode);
    const type = keywords$1.get(word);
    if (type !== undefined) {
      this.finishToken(type, tokenLabelName(type));
    } else {
      this.finishToken(128, word);
    }
  }
  checkKeywordEscapes() {
    const {type: type} = this.state;
    if (tokenIsKeyword(type) && this.state.containsEsc) {
      this.raise(Errors.InvalidEscapedReservedWord, {
        at: this.state.startLoc,
        reservedWord: tokenLabelName(type),
      });
    }
  }
  raise(toParseError, raiseProperties) {
    const {at: at} = raiseProperties,
      details = _objectWithoutPropertiesLoose(raiseProperties, _excluded);
    const loc = at instanceof Position ? at : at.loc.start;
    const error = toParseError({loc: loc, details: details});
    if (!this.options.errorRecovery) throw error;
    if (!this.isLookahead) this.state.errors.push(error);
    return error;
  }
  raiseOverwrite(toParseError, raiseProperties) {
    const {at: at} = raiseProperties,
      details = _objectWithoutPropertiesLoose(raiseProperties, _excluded2);
    const loc = at instanceof Position ? at : at.loc.start;
    const pos = loc.index;
    const errors = this.state.errors;
    for (let i = errors.length - 1; i >= 0; i--) {
      const error = errors[i];
      if (error.loc.index === pos) {
        return (errors[i] = toParseError({loc: loc, details: details}));
      }
      if (error.loc.index < pos) break;
    }
    return this.raise(toParseError, raiseProperties);
  }
  updateContext(prevType) {}
  unexpected(loc, type) {
    throw this.raise(Errors.UnexpectedToken, {
      expected: type ? tokenLabelName(type) : null,
      at: loc != null ? loc : this.state.startLoc,
    });
  }
  expectPlugin(pluginName, loc) {
    if (this.hasPlugin(pluginName)) {
      return true;
    }
    throw this.raise(Errors.MissingPlugin, {
      at: loc != null ? loc : this.state.startLoc,
      missingPlugin: [pluginName],
    });
  }
  expectOnePlugin(pluginNames) {
    if (!pluginNames.some(name => this.hasPlugin(name))) {
      throw this.raise(Errors.MissingOneOfPlugins, {
        at: this.state.startLoc,
        missingPlugin: pluginNames,
      });
    }
  }
  errorBuilder(error) {
    return (pos, lineStart, curLine) => {
      this.raise(error, {at: buildPosition(pos, lineStart, curLine)});
    };
  }
}
class ClassScope {
  constructor() {
    this.privateNames = new Set();
    this.loneAccessors = new Map();
    this.undefinedPrivateNames = new Map();
  }
}
class ClassScopeHandler {
  constructor(parser) {
    this.parser = void 0;
    this.stack = [];
    this.undefinedPrivateNames = new Map();
    this.parser = parser;
  }
  current() {
    return this.stack[this.stack.length - 1];
  }
  enter() {
    this.stack.push(new ClassScope());
  }
  exit() {
    const oldClassScope = this.stack.pop();
    const current = this.current();
    for (const [name, loc] of Array.from(oldClassScope.undefinedPrivateNames)) {
      if (current) {
        if (!current.undefinedPrivateNames.has(name)) {
          current.undefinedPrivateNames.set(name, loc);
        }
      } else {
        this.parser.raise(Errors.InvalidPrivateFieldResolution, {
          at: loc,
          identifierName: name,
        });
      }
    }
  }
  declarePrivateName(name, elementType, loc) {
    const {
      privateNames: privateNames,
      loneAccessors: loneAccessors,
      undefinedPrivateNames: undefinedPrivateNames,
    } = this.current();
    let redefined = privateNames.has(name);
    if (elementType & CLASS_ELEMENT_KIND_ACCESSOR) {
      const accessor = redefined && loneAccessors.get(name);
      if (accessor) {
        const oldStatic = accessor & CLASS_ELEMENT_FLAG_STATIC;
        const newStatic = elementType & CLASS_ELEMENT_FLAG_STATIC;
        const oldKind = accessor & CLASS_ELEMENT_KIND_ACCESSOR;
        const newKind = elementType & CLASS_ELEMENT_KIND_ACCESSOR;
        redefined = oldKind === newKind || oldStatic !== newStatic;
        if (!redefined) loneAccessors.delete(name);
      } else if (!redefined) {
        loneAccessors.set(name, elementType);
      }
    }
    if (redefined) {
      this.parser.raise(Errors.PrivateNameRedeclaration, {
        at: loc,
        identifierName: name,
      });
    }
    privateNames.add(name);
    undefinedPrivateNames.delete(name);
  }
  usePrivateName(name, loc) {
    let classScope;
    for (classScope of this.stack) {
      if (classScope.privateNames.has(name)) return;
    }
    if (classScope) {
      classScope.undefinedPrivateNames.set(name, loc);
    } else {
      this.parser.raise(Errors.InvalidPrivateFieldResolution, {
        at: loc,
        identifierName: name,
      });
    }
  }
}
const kExpression = 0,
  kMaybeArrowParameterDeclaration = 1,
  kMaybeAsyncArrowParameterDeclaration = 2,
  kParameterDeclaration = 3;
class ExpressionScope {
  constructor(type = kExpression) {
    this.type = void 0;
    this.type = type;
  }
  canBeArrowParameterDeclaration() {
    return (
      this.type === kMaybeAsyncArrowParameterDeclaration ||
      this.type === kMaybeArrowParameterDeclaration
    );
  }
  isCertainlyParameterDeclaration() {
    return this.type === kParameterDeclaration;
  }
}
class ArrowHeadParsingScope extends ExpressionScope {
  constructor(type) {
    super(type);
    this.declarationErrors = new Map();
  }
  recordDeclarationError(ParsingErrorClass, {at: at}) {
    const index = at.index;
    this.declarationErrors.set(index, [ParsingErrorClass, at]);
  }
  clearDeclarationError(index) {
    this.declarationErrors.delete(index);
  }
  iterateErrors(iterator) {
    this.declarationErrors.forEach(iterator);
  }
}
class ExpressionScopeHandler {
  constructor(parser) {
    this.parser = void 0;
    this.stack = [new ExpressionScope()];
    this.parser = parser;
  }
  enter(scope) {
    this.stack.push(scope);
  }
  exit() {
    this.stack.pop();
  }
  recordParameterInitializerError(toParseError, {at: node}) {
    const origin = {at: node.loc.start};
    const {stack: stack} = this;
    let i = stack.length - 1;
    let scope = stack[i];
    while (!scope.isCertainlyParameterDeclaration()) {
      if (scope.canBeArrowParameterDeclaration()) {
        scope.recordDeclarationError(toParseError, origin);
      } else {
        return;
      }
      scope = stack[--i];
    }
    this.parser.raise(toParseError, origin);
  }
  recordArrowParemeterBindingError(error, {at: node}) {
    const {stack: stack} = this;
    const scope = stack[stack.length - 1];
    const origin = {at: node.loc.start};
    if (scope.isCertainlyParameterDeclaration()) {
      this.parser.raise(error, origin);
    } else if (scope.canBeArrowParameterDeclaration()) {
      scope.recordDeclarationError(error, origin);
    } else {
      return;
    }
  }
  recordAsyncArrowParametersError({at: at}) {
    const {stack: stack} = this;
    let i = stack.length - 1;
    let scope = stack[i];
    while (scope.canBeArrowParameterDeclaration()) {
      if (scope.type === kMaybeAsyncArrowParameterDeclaration) {
        scope.recordDeclarationError(Errors.AwaitBindingIdentifier, {at: at});
      }
      scope = stack[--i];
    }
  }
  validateAsPattern() {
    const {stack: stack} = this;
    const currentScope = stack[stack.length - 1];
    if (!currentScope.canBeArrowParameterDeclaration()) return;
    currentScope.iterateErrors(([toParseError, loc]) => {
      this.parser.raise(toParseError, {at: loc});
      let i = stack.length - 2;
      let scope = stack[i];
      while (scope.canBeArrowParameterDeclaration()) {
        scope.clearDeclarationError(loc.index);
        scope = stack[--i];
      }
    });
  }
}
function newParameterDeclarationScope() {
  return new ExpressionScope(kParameterDeclaration);
}
function newArrowHeadScope() {
  return new ArrowHeadParsingScope(kMaybeArrowParameterDeclaration);
}
function newAsyncArrowScope() {
  return new ArrowHeadParsingScope(kMaybeAsyncArrowParameterDeclaration);
}
function newExpressionScope() {
  return new ExpressionScope();
}
const PARAM = 0,
  PARAM_YIELD = 1,
  PARAM_AWAIT = 2,
  PARAM_RETURN = 4,
  PARAM_IN = 8;
class ProductionParameterHandler {
  constructor() {
    this.stacks = [];
  }
  enter(flags) {
    this.stacks.push(flags);
  }
  exit() {
    this.stacks.pop();
  }
  currentFlags() {
    return this.stacks[this.stacks.length - 1];
  }
  get hasAwait() {
    return (this.currentFlags() & PARAM_AWAIT) > 0;
  }
  get hasYield() {
    return (this.currentFlags() & PARAM_YIELD) > 0;
  }
  get hasReturn() {
    return (this.currentFlags() & PARAM_RETURN) > 0;
  }
  get hasIn() {
    return (this.currentFlags() & PARAM_IN) > 0;
  }
}
function functionFlags(isAsync, isGenerator) {
  return (isAsync ? PARAM_AWAIT : 0) | (isGenerator ? PARAM_YIELD : 0);
}
class UtilParser extends Tokenizer {
  addExtra(node, key, value, enumerable = true) {
    if (!node) return;
    const extra = (node.extra = node.extra || {});
    if (enumerable) {
      extra[key] = value;
    } else {
      Object.defineProperty(extra, key, {enumerable: enumerable, value: value});
    }
  }
  isContextual(token) {
    return this.state.type === token && !this.state.containsEsc;
  }
  isUnparsedContextual(nameStart, name) {
    const nameEnd = nameStart + name.length;
    if (this.input.slice(nameStart, nameEnd) === name) {
      const nextCh = this.input.charCodeAt(nameEnd);
      return !(isIdentifierChar(nextCh) || (nextCh & 64512) === 55296);
    }
    return false;
  }
  isLookaheadContextual(name) {
    const next = this.nextTokenStart();
    return this.isUnparsedContextual(next, name);
  }
  eatContextual(token) {
    if (this.isContextual(token)) {
      this.next();
      return true;
    }
    return false;
  }
  expectContextual(token, toParseError) {
    if (!this.eatContextual(token)) {
      if (toParseError != null) {
        throw this.raise(toParseError, {at: this.state.startLoc});
      }
      throw this.unexpected(null, token);
    }
  }
  canInsertSemicolon() {
    return this.match(135) || this.match(8) || this.hasPrecedingLineBreak();
  }
  hasPrecedingLineBreak() {
    return lineBreak.test(
      this.input.slice(this.state.lastTokEndLoc.index, this.state.start)
    );
  }
  hasFollowingLineBreak() {
    skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
    return skipWhiteSpaceToLineBreak.test(this.input);
  }
  isLineTerminator() {
    return this.eat(13) || this.canInsertSemicolon();
  }
  semicolon(allowAsi = true) {
    if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
    this.raise(Errors.MissingSemicolon, {at: this.state.lastTokEndLoc});
  }
  expect(type, loc) {
    this.eat(type) || this.unexpected(loc, type);
  }
  tryParse(fn, oldState = this.state.clone()) {
    const abortSignal = {node: null};
    try {
      const node = fn((node = null) => {
        abortSignal.node = node;
        throw abortSignal;
      });
      if (this.state.errors.length > oldState.errors.length) {
        const failState = this.state;
        this.state = oldState;
        this.state.tokensLength = failState.tokensLength;
        return {
          node: node,
          error: failState.errors[oldState.errors.length],
          thrown: false,
          aborted: false,
          failState: failState,
        };
      }
      return {
        node: node,
        error: null,
        thrown: false,
        aborted: false,
        failState: null,
      };
    } catch (error) {
      const failState = this.state;
      this.state = oldState;
      if (error instanceof SyntaxError) {
        return {
          node: null,
          error: error,
          thrown: true,
          aborted: false,
          failState: failState,
        };
      }
      if (error === abortSignal) {
        return {
          node: abortSignal.node,
          error: null,
          thrown: false,
          aborted: true,
          failState: failState,
        };
      }
      throw error;
    }
  }
  checkExpressionErrors(refExpressionErrors, andThrow) {
    if (!refExpressionErrors) return false;
    const {
      shorthandAssignLoc: shorthandAssignLoc,
      doubleProtoLoc: doubleProtoLoc,
      privateKeyLoc: privateKeyLoc,
      optionalParametersLoc: optionalParametersLoc,
    } = refExpressionErrors;
    const hasErrors =
      !!shorthandAssignLoc ||
      !!doubleProtoLoc ||
      !!optionalParametersLoc ||
      !!privateKeyLoc;
    if (!andThrow) {
      return hasErrors;
    }
    if (shorthandAssignLoc != null) {
      this.raise(Errors.InvalidCoverInitializedName, {at: shorthandAssignLoc});
    }
    if (doubleProtoLoc != null) {
      this.raise(Errors.DuplicateProto, {at: doubleProtoLoc});
    }
    if (privateKeyLoc != null) {
      this.raise(Errors.UnexpectedPrivateField, {at: privateKeyLoc});
    }
    if (optionalParametersLoc != null) {
      this.unexpected(optionalParametersLoc);
    }
  }
  isLiteralPropertyName() {
    return tokenIsLiteralPropertyName(this.state.type);
  }
  isPrivateName(node) {
    return node.type === 'PrivateName';
  }
  getPrivateNameSV(node) {
    return node.id.name;
  }
  hasPropertyAsPrivateName(node) {
    return (
      (node.type === 'MemberExpression' ||
        node.type === 'OptionalMemberExpression') &&
      this.isPrivateName(node.property)
    );
  }
  isOptionalChain(node) {
    return (
      node.type === 'OptionalMemberExpression' ||
      node.type === 'OptionalCallExpression'
    );
  }
  isObjectProperty(node) {
    return node.type === 'ObjectProperty';
  }
  isObjectMethod(node) {
    return node.type === 'ObjectMethod';
  }
  initializeScopes(inModule = this.options.sourceType === 'module') {
    const oldLabels = this.state.labels;
    this.state.labels = [];
    const oldExportedIdentifiers = this.exportedIdentifiers;
    this.exportedIdentifiers = new Set();
    const oldInModule = this.inModule;
    this.inModule = inModule;
    const oldScope = this.scope;
    const ScopeHandler = this.getScopeHandler();
    this.scope = new ScopeHandler(this, inModule);
    const oldProdParam = this.prodParam;
    this.prodParam = new ProductionParameterHandler();
    const oldClassScope = this.classScope;
    this.classScope = new ClassScopeHandler(this);
    const oldExpressionScope = this.expressionScope;
    this.expressionScope = new ExpressionScopeHandler(this);
    return () => {
      this.state.labels = oldLabels;
      this.exportedIdentifiers = oldExportedIdentifiers;
      this.inModule = oldInModule;
      this.scope = oldScope;
      this.prodParam = oldProdParam;
      this.classScope = oldClassScope;
      this.expressionScope = oldExpressionScope;
    };
  }
  enterInitialScopes() {
    let paramFlags = PARAM;
    if (this.inModule) {
      paramFlags |= PARAM_AWAIT;
    }
    this.scope.enter(SCOPE_PROGRAM);
    this.prodParam.enter(paramFlags);
  }
  checkDestructuringPrivate(refExpressionErrors) {
    const {privateKeyLoc: privateKeyLoc} = refExpressionErrors;
    if (privateKeyLoc !== null) {
      this.expectPlugin('destructuringPrivate', privateKeyLoc);
    }
  }
}
class ExpressionErrors {
  constructor() {
    this.shorthandAssignLoc = null;
    this.doubleProtoLoc = null;
    this.privateKeyLoc = null;
    this.optionalParametersLoc = null;
  }
}
let Node$1 = class Node {
  constructor(parser, pos, loc) {
    this.type = '';
    this.start = pos;
    this.end = 0;
    this.loc = new SourceLocation(loc);
    if (parser != null && parser.options.ranges) this.range = [pos, 0];
    if (parser != null && parser.filename) this.loc.filename = parser.filename;
  }
};
const NodePrototype = Node$1.prototype;
{
  NodePrototype.__clone = function () {
    const newNode = new Node$1(undefined, this.start, this.loc.start);
    const keys = Object.keys(this);
    for (let i = 0, length = keys.length; i < length; i++) {
      const key = keys[i];
      if (
        key !== 'leadingComments' &&
        key !== 'trailingComments' &&
        key !== 'innerComments'
      ) {
        newNode[key] = this[key];
      }
    }
    return newNode;
  };
}
function clonePlaceholder(node) {
  return cloneIdentifier(node);
}
function cloneIdentifier(node) {
  const {
    type: type,
    start: start,
    end: end,
    loc: loc,
    range: range,
    extra: extra,
    name: name,
  } = node;
  const cloned = Object.create(NodePrototype);
  cloned.type = type;
  cloned.start = start;
  cloned.end = end;
  cloned.loc = loc;
  cloned.range = range;
  cloned.extra = extra;
  cloned.name = name;
  if (type === 'Placeholder') {
    cloned.expectedNode = node.expectedNode;
  }
  return cloned;
}
function cloneStringLiteral(node) {
  const {
    type: type,
    start: start,
    end: end,
    loc: loc,
    range: range,
    extra: extra,
  } = node;
  if (type === 'Placeholder') {
    return clonePlaceholder(node);
  }
  const cloned = Object.create(NodePrototype);
  cloned.type = type;
  cloned.start = start;
  cloned.end = end;
  cloned.loc = loc;
  cloned.range = range;
  if (node.raw !== undefined) {
    cloned.raw = node.raw;
  } else {
    cloned.extra = extra;
  }
  cloned.value = node.value;
  return cloned;
}
class NodeUtils extends UtilParser {
  startNode() {
    return new Node$1(this, this.state.start, this.state.startLoc);
  }
  startNodeAt(pos, loc) {
    return new Node$1(this, pos, loc);
  }
  startNodeAtNode(type) {
    return this.startNodeAt(type.start, type.loc.start);
  }
  finishNode(node, type) {
    return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
  }
  finishNodeAt(node, type, endLoc) {
    node.type = type;
    node.end = endLoc.index;
    node.loc.end = endLoc;
    if (this.options.ranges) node.range[1] = endLoc.index;
    if (this.options.attachComment) this.processComment(node);
    return node;
  }
  resetStartLocation(node, start, startLoc) {
    node.start = start;
    node.loc.start = startLoc;
    if (this.options.ranges) node.range[0] = start;
  }
  resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
    node.end = endLoc.index;
    node.loc.end = endLoc;
    if (this.options.ranges) node.range[1] = endLoc.index;
  }
  resetStartLocationFromNode(node, locationNode) {
    this.resetStartLocation(node, locationNode.start, locationNode.loc.start);
  }
}
const reservedTypes = new Set([
  '_',
  'any',
  'bool',
  'boolean',
  'empty',
  'extends',
  'false',
  'interface',
  'mixed',
  'null',
  'number',
  'static',
  'string',
  'true',
  'typeof',
  'void',
]);
const FlowErrors = ParseErrorEnum`flow`({
  AmbiguousConditionalArrow:
    'Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.',
  AmbiguousDeclareModuleKind:
    'Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.',
  AssignReservedType: ({reservedType: reservedType}) =>
    `Cannot overwrite reserved type ${reservedType}.`,
  DeclareClassElement:
    'The `declare` modifier can only appear on class fields.',
  DeclareClassFieldInitializer:
    'Initializers are not allowed in fields with the `declare` modifier.',
  DuplicateDeclareModuleExports:
    'Duplicate `declare module.exports` statement.',
  EnumBooleanMemberNotInitialized: ({
    memberName: memberName,
    enumName: enumName,
  }) =>
    `Boolean enum members need to be initialized. Use either \`${memberName} = true,\` or \`${memberName} = false,\` in enum \`${enumName}\`.`,
  EnumDuplicateMemberName: ({memberName: memberName, enumName: enumName}) =>
    `Enum member names need to be unique, but the name \`${memberName}\` has already been used before in enum \`${enumName}\`.`,
  EnumInconsistentMemberValues: ({enumName: enumName}) =>
    `Enum \`${enumName}\` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.`,
  EnumInvalidExplicitType: ({
    invalidEnumType: invalidEnumType,
    enumName: enumName,
  }) =>
    `Enum type \`${invalidEnumType}\` is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
  EnumInvalidExplicitTypeUnknownSupplied: ({enumName: enumName}) =>
    `Supplied enum type is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
  EnumInvalidMemberInitializerPrimaryType: ({
    enumName: enumName,
    memberName: memberName,
    explicitType: explicitType,
  }) =>
    `Enum \`${enumName}\` has type \`${explicitType}\`, so the initializer of \`${memberName}\` needs to be a ${explicitType} literal.`,
  EnumInvalidMemberInitializerSymbolType: ({
    enumName: enumName,
    memberName: memberName,
  }) =>
    `Symbol enum members cannot be initialized. Use \`${memberName},\` in enum \`${enumName}\`.`,
  EnumInvalidMemberInitializerUnknownType: ({
    enumName: enumName,
    memberName: memberName,
  }) =>
    `The enum member initializer for \`${memberName}\` needs to be a literal (either a boolean, number, or string) in enum \`${enumName}\`.`,
  EnumInvalidMemberName: ({
    enumName: enumName,
    memberName: memberName,
    suggestion: suggestion,
  }) =>
    `Enum member names cannot start with lowercase 'a' through 'z'. Instead of using \`${memberName}\`, consider using \`${suggestion}\`, in enum \`${enumName}\`.`,
  EnumNumberMemberNotInitialized: ({
    enumName: enumName,
    memberName: memberName,
  }) =>
    `Number enum members need to be initialized, e.g. \`${memberName} = 1\` in enum \`${enumName}\`.`,
  EnumStringMemberInconsistentlyInitailized: ({enumName: enumName}) =>
    `String enum members need to consistently either all use initializers, or use no initializers, in enum \`${enumName}\`.`,
  GetterMayNotHaveThisParam: 'A getter cannot have a `this` parameter.',
  ImportTypeShorthandOnlyInPureImport:
    'The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.',
  InexactInsideExact:
    'Explicit inexact syntax cannot appear inside an explicit exact object type.',
  InexactInsideNonObject:
    'Explicit inexact syntax cannot appear in class or interface definitions.',
  InexactVariance: 'Explicit inexact syntax cannot have variance.',
  InvalidNonTypeImportInDeclareModule:
    'Imports within a `declare module` body must always be `import type` or `import typeof`.',
  MissingTypeParamDefault:
    'Type parameter declaration needs a default, since a preceding type parameter declaration has a default.',
  NestedDeclareModule:
    '`declare module` cannot be used inside another `declare module`.',
  NestedFlowComment: 'Cannot have a flow comment inside another flow comment.',
  PatternIsOptional: Object.assign(
    {
      message:
        'A binding pattern parameter cannot be optional in an implementation signature.',
    },
    {reasonCode: 'OptionalBindingPattern'}
  ),
  SetterMayNotHaveThisParam: 'A setter cannot have a `this` parameter.',
  SpreadVariance: 'Spread properties cannot have variance.',
  ThisParamAnnotationRequired:
    'A type annotation is required for the `this` parameter.',
  ThisParamBannedInConstructor:
    "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
  ThisParamMayNotBeOptional: 'The `this` parameter cannot be optional.',
  ThisParamMustBeFirst:
    'The `this` parameter must be the first function parameter.',
  ThisParamNoDefault: 'The `this` parameter may not have a default value.',
  TypeBeforeInitializer:
    'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
  TypeCastInPattern:
    'The type cast expression is expected to be wrapped with parenthesis.',
  UnexpectedExplicitInexactInObject:
    'Explicit inexact syntax must appear at the end of an inexact object.',
  UnexpectedReservedType: ({reservedType: reservedType}) =>
    `Unexpected reserved type ${reservedType}.`,
  UnexpectedReservedUnderscore:
    '`_` is only allowed as a type argument to call or new.',
  UnexpectedSpaceBetweenModuloChecks:
    'Spaces between `%` and `checks` are not allowed here.',
  UnexpectedSpreadType:
    'Spread operator cannot appear in class or interface definitions.',
  UnexpectedSubtractionOperand:
    'Unexpected token, expected "number" or "bigint".',
  UnexpectedTokenAfterTypeParameter:
    'Expected an arrow function after this type parameter declaration.',
  UnexpectedTypeParameterBeforeAsyncArrowFunction:
    'Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.',
  UnsupportedDeclareExportKind: ({
    unsupportedExportKind: unsupportedExportKind,
    suggestion: suggestion,
  }) =>
    `\`declare export ${unsupportedExportKind}\` is not supported. Use \`${suggestion}\` instead.`,
  UnsupportedStatementInDeclareModule:
    'Only declares and type imports are allowed inside declare module.',
  UnterminatedFlowComment: 'Unterminated flow-comment.',
});
function isEsModuleType(bodyElement) {
  return (
    bodyElement.type === 'DeclareExportAllDeclaration' ||
    (bodyElement.type === 'DeclareExportDeclaration' &&
      (!bodyElement.declaration ||
        (bodyElement.declaration.type !== 'TypeAlias' &&
          bodyElement.declaration.type !== 'InterfaceDeclaration')))
  );
}
function hasTypeImportKind(node) {
  return node.importKind === 'type' || node.importKind === 'typeof';
}
function isMaybeDefaultImport(type) {
  return tokenIsKeywordOrIdentifier(type) && type !== 97;
}
const exportSuggestions = {
  const: 'declare export var',
  let: 'declare export var',
  type: 'export type',
  interface: 'export interface',
};
function partition(list, test) {
  const list1 = [];
  const list2 = [];
  for (let i = 0; i < list.length; i++) {
    (test(list[i], i, list) ? list1 : list2).push(list[i]);
  }
  return [list1, list2];
}
const FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
var flow$2 = superClass =>
  class FlowParserMixin extends superClass {
    constructor(...args) {
      super(...args);
      this.flowPragma = undefined;
    }
    getScopeHandler() {
      return FlowScopeHandler;
    }
    shouldParseTypes() {
      return this.getPluginOption('flow', 'all') || this.flowPragma === 'flow';
    }
    shouldParseEnums() {
      return !!this.getPluginOption('flow', 'enums');
    }
    finishToken(type, val) {
      if (type !== 129 && type !== 13 && type !== 28) {
        if (this.flowPragma === undefined) {
          this.flowPragma = null;
        }
      }
      return super.finishToken(type, val);
    }
    addComment(comment) {
      if (this.flowPragma === undefined) {
        const matches = FLOW_PRAGMA_REGEX.exec(comment.value);
        if (!matches);
        else if (matches[1] === 'flow') {
          this.flowPragma = 'flow';
        } else if (matches[1] === 'noflow') {
          this.flowPragma = 'noflow';
        } else {
          throw new Error('Unexpected flow pragma');
        }
      }
      return super.addComment(comment);
    }
    flowParseTypeInitialiser(tok) {
      const oldInType = this.state.inType;
      this.state.inType = true;
      this.expect(tok || 14);
      const type = this.flowParseType();
      this.state.inType = oldInType;
      return type;
    }
    flowParsePredicate() {
      const node = this.startNode();
      const moduloLoc = this.state.startLoc;
      this.next();
      this.expectContextual(107);
      if (this.state.lastTokStart > moduloLoc.index + 1) {
        this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, {
          at: moduloLoc,
        });
      }
      if (this.eat(10)) {
        node.value = super.parseExpression();
        this.expect(11);
        return this.finishNode(node, 'DeclaredPredicate');
      } else {
        return this.finishNode(node, 'InferredPredicate');
      }
    }
    flowParseTypeAndPredicateInitialiser() {
      const oldInType = this.state.inType;
      this.state.inType = true;
      this.expect(14);
      let type = null;
      let predicate = null;
      if (this.match(54)) {
        this.state.inType = oldInType;
        predicate = this.flowParsePredicate();
      } else {
        type = this.flowParseType();
        this.state.inType = oldInType;
        if (this.match(54)) {
          predicate = this.flowParsePredicate();
        }
      }
      return [type, predicate];
    }
    flowParseDeclareClass(node) {
      this.next();
      this.flowParseInterfaceish(node, true);
      return this.finishNode(node, 'DeclareClass');
    }
    flowParseDeclareFunction(node) {
      this.next();
      const id = (node.id = this.parseIdentifier());
      const typeNode = this.startNode();
      const typeContainer = this.startNode();
      if (this.match(47)) {
        typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        typeNode.typeParameters = null;
      }
      this.expect(10);
      const tmp = this.flowParseFunctionTypeParams();
      typeNode.params = tmp.params;
      typeNode.rest = tmp.rest;
      typeNode.this = tmp._this;
      this.expect(11);
      [typeNode.returnType, node.predicate] =
        this.flowParseTypeAndPredicateInitialiser();
      typeContainer.typeAnnotation = this.finishNode(
        typeNode,
        'FunctionTypeAnnotation'
      );
      id.typeAnnotation = this.finishNode(typeContainer, 'TypeAnnotation');
      this.resetEndLocation(id);
      this.semicolon();
      this.scope.declareName(
        node.id.name,
        BIND_FLOW_DECLARE_FN,
        node.id.loc.start
      );
      return this.finishNode(node, 'DeclareFunction');
    }
    flowParseDeclare(node, insideModule) {
      if (this.match(80)) {
        return this.flowParseDeclareClass(node);
      } else if (this.match(68)) {
        return this.flowParseDeclareFunction(node);
      } else if (this.match(74)) {
        return this.flowParseDeclareVariable(node);
      } else if (this.eatContextual(123)) {
        if (this.match(16)) {
          return this.flowParseDeclareModuleExports(node);
        } else {
          if (insideModule) {
            this.raise(FlowErrors.NestedDeclareModule, {
              at: this.state.lastTokStartLoc,
            });
          }
          return this.flowParseDeclareModule(node);
        }
      } else if (this.isContextual(126)) {
        return this.flowParseDeclareTypeAlias(node);
      } else if (this.isContextual(127)) {
        return this.flowParseDeclareOpaqueType(node);
      } else if (this.isContextual(125)) {
        return this.flowParseDeclareInterface(node);
      } else if (this.match(82)) {
        return this.flowParseDeclareExportDeclaration(node, insideModule);
      } else {
        throw this.unexpected();
      }
    }
    flowParseDeclareVariable(node) {
      this.next();
      node.id = this.flowParseTypeAnnotatableIdentifier(true);
      this.scope.declareName(node.id.name, BIND_VAR, node.id.loc.start);
      this.semicolon();
      return this.finishNode(node, 'DeclareVariable');
    }
    flowParseDeclareModule(node) {
      this.scope.enter(SCOPE_OTHER);
      if (this.match(129)) {
        node.id = super.parseExprAtom();
      } else {
        node.id = this.parseIdentifier();
      }
      const bodyNode = (node.body = this.startNode());
      const body = (bodyNode.body = []);
      this.expect(5);
      while (!this.match(8)) {
        let bodyNode = this.startNode();
        if (this.match(83)) {
          this.next();
          if (!this.isContextual(126) && !this.match(87)) {
            this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, {
              at: this.state.lastTokStartLoc,
            });
          }
          super.parseImport(bodyNode);
        } else {
          this.expectContextual(
            121,
            FlowErrors.UnsupportedStatementInDeclareModule
          );
          bodyNode = this.flowParseDeclare(bodyNode, true);
        }
        body.push(bodyNode);
      }
      this.scope.exit();
      this.expect(8);
      this.finishNode(bodyNode, 'BlockStatement');
      let kind = null;
      let hasModuleExport = false;
      body.forEach(bodyElement => {
        if (isEsModuleType(bodyElement)) {
          if (kind === 'CommonJS') {
            this.raise(FlowErrors.AmbiguousDeclareModuleKind, {
              at: bodyElement,
            });
          }
          kind = 'ES';
        } else if (bodyElement.type === 'DeclareModuleExports') {
          if (hasModuleExport) {
            this.raise(FlowErrors.DuplicateDeclareModuleExports, {
              at: bodyElement,
            });
          }
          if (kind === 'ES') {
            this.raise(FlowErrors.AmbiguousDeclareModuleKind, {
              at: bodyElement,
            });
          }
          kind = 'CommonJS';
          hasModuleExport = true;
        }
      });
      node.kind = kind || 'CommonJS';
      return this.finishNode(node, 'DeclareModule');
    }
    flowParseDeclareExportDeclaration(node, insideModule) {
      this.expect(82);
      if (this.eat(65)) {
        if (this.match(68) || this.match(80)) {
          node.declaration = this.flowParseDeclare(this.startNode());
        } else {
          node.declaration = this.flowParseType();
          this.semicolon();
        }
        node.default = true;
        return this.finishNode(node, 'DeclareExportDeclaration');
      } else {
        if (
          this.match(75) ||
          this.isLet() ||
          ((this.isContextual(126) || this.isContextual(125)) && !insideModule)
        ) {
          const label = this.state.value;
          throw this.raise(FlowErrors.UnsupportedDeclareExportKind, {
            at: this.state.startLoc,
            unsupportedExportKind: label,
            suggestion: exportSuggestions[label],
          });
        }
        if (
          this.match(74) ||
          this.match(68) ||
          this.match(80) ||
          this.isContextual(127)
        ) {
          node.declaration = this.flowParseDeclare(this.startNode());
          node.default = false;
          return this.finishNode(node, 'DeclareExportDeclaration');
        } else if (
          this.match(55) ||
          this.match(5) ||
          this.isContextual(125) ||
          this.isContextual(126) ||
          this.isContextual(127)
        ) {
          node = this.parseExport(node);
          if (node.type === 'ExportNamedDeclaration') {
            node.type = 'ExportDeclaration';
            node.default = false;
            delete node.exportKind;
          }
          node.type = 'Declare' + node.type;
          return node;
        }
      }
      throw this.unexpected();
    }
    flowParseDeclareModuleExports(node) {
      this.next();
      this.expectContextual(108);
      node.typeAnnotation = this.flowParseTypeAnnotation();
      this.semicolon();
      return this.finishNode(node, 'DeclareModuleExports');
    }
    flowParseDeclareTypeAlias(node) {
      this.next();
      const finished = this.flowParseTypeAlias(node);
      finished.type = 'DeclareTypeAlias';
      return finished;
    }
    flowParseDeclareOpaqueType(node) {
      this.next();
      const finished = this.flowParseOpaqueType(node, true);
      finished.type = 'DeclareOpaqueType';
      return finished;
    }
    flowParseDeclareInterface(node) {
      this.next();
      this.flowParseInterfaceish(node);
      return this.finishNode(node, 'DeclareInterface');
    }
    flowParseInterfaceish(node, isClass = false) {
      node.id = this.flowParseRestrictedIdentifier(!isClass, true);
      this.scope.declareName(
        node.id.name,
        isClass ? BIND_FUNCTION : BIND_LEXICAL,
        node.id.loc.start
      );
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        node.typeParameters = null;
      }
      node.extends = [];
      node.implements = [];
      node.mixins = [];
      if (this.eat(81)) {
        do {
          node.extends.push(this.flowParseInterfaceExtends());
        } while (!isClass && this.eat(12));
      }
      if (this.isContextual(114)) {
        this.next();
        do {
          node.mixins.push(this.flowParseInterfaceExtends());
        } while (this.eat(12));
      }
      if (this.isContextual(110)) {
        this.next();
        do {
          node.implements.push(this.flowParseInterfaceExtends());
        } while (this.eat(12));
      }
      node.body = this.flowParseObjectType({
        allowStatic: isClass,
        allowExact: false,
        allowSpread: false,
        allowProto: isClass,
        allowInexact: false,
      });
    }
    flowParseInterfaceExtends() {
      const node = this.startNode();
      node.id = this.flowParseQualifiedTypeIdentifier();
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterInstantiation();
      } else {
        node.typeParameters = null;
      }
      return this.finishNode(node, 'InterfaceExtends');
    }
    flowParseInterface(node) {
      this.flowParseInterfaceish(node);
      return this.finishNode(node, 'InterfaceDeclaration');
    }
    checkNotUnderscore(word) {
      if (word === '_') {
        this.raise(FlowErrors.UnexpectedReservedUnderscore, {
          at: this.state.startLoc,
        });
      }
    }
    checkReservedType(word, startLoc, declaration) {
      if (!reservedTypes.has(word)) return;
      this.raise(
        declaration
          ? FlowErrors.AssignReservedType
          : FlowErrors.UnexpectedReservedType,
        {at: startLoc, reservedType: word}
      );
    }
    flowParseRestrictedIdentifier(liberal, declaration) {
      this.checkReservedType(
        this.state.value,
        this.state.startLoc,
        declaration
      );
      return this.parseIdentifier(liberal);
    }
    flowParseTypeAlias(node) {
      node.id = this.flowParseRestrictedIdentifier(false, true);
      this.scope.declareName(node.id.name, BIND_LEXICAL, node.id.loc.start);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        node.typeParameters = null;
      }
      node.right = this.flowParseTypeInitialiser(29);
      this.semicolon();
      return this.finishNode(node, 'TypeAlias');
    }
    flowParseOpaqueType(node, declare) {
      this.expectContextual(126);
      node.id = this.flowParseRestrictedIdentifier(true, true);
      this.scope.declareName(node.id.name, BIND_LEXICAL, node.id.loc.start);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      } else {
        node.typeParameters = null;
      }
      node.supertype = null;
      if (this.match(14)) {
        node.supertype = this.flowParseTypeInitialiser(14);
      }
      node.impltype = null;
      if (!declare) {
        node.impltype = this.flowParseTypeInitialiser(29);
      }
      this.semicolon();
      return this.finishNode(node, 'OpaqueType');
    }
    flowParseTypeParameter(requireDefault = false) {
      const nodeStartLoc = this.state.startLoc;
      const node = this.startNode();
      const variance = this.flowParseVariance();
      const ident = this.flowParseTypeAnnotatableIdentifier();
      node.name = ident.name;
      node.variance = variance;
      node.bound = ident.typeAnnotation;
      if (this.match(29)) {
        this.eat(29);
        node.default = this.flowParseType();
      } else {
        if (requireDefault) {
          this.raise(FlowErrors.MissingTypeParamDefault, {at: nodeStartLoc});
        }
      }
      return this.finishNode(node, 'TypeParameter');
    }
    flowParseTypeParameterDeclaration() {
      const oldInType = this.state.inType;
      const node = this.startNode();
      node.params = [];
      this.state.inType = true;
      if (this.match(47) || this.match(138)) {
        this.next();
      } else {
        this.unexpected();
      }
      let defaultRequired = false;
      do {
        const typeParameter = this.flowParseTypeParameter(defaultRequired);
        node.params.push(typeParameter);
        if (typeParameter.default) {
          defaultRequired = true;
        }
        if (!this.match(48)) {
          this.expect(12);
        }
      } while (!this.match(48));
      this.expect(48);
      this.state.inType = oldInType;
      return this.finishNode(node, 'TypeParameterDeclaration');
    }
    flowParseTypeParameterInstantiation() {
      const node = this.startNode();
      const oldInType = this.state.inType;
      node.params = [];
      this.state.inType = true;
      this.expect(47);
      const oldNoAnonFunctionType = this.state.noAnonFunctionType;
      this.state.noAnonFunctionType = false;
      while (!this.match(48)) {
        node.params.push(this.flowParseType());
        if (!this.match(48)) {
          this.expect(12);
        }
      }
      this.state.noAnonFunctionType = oldNoAnonFunctionType;
      this.expect(48);
      this.state.inType = oldInType;
      return this.finishNode(node, 'TypeParameterInstantiation');
    }
    flowParseTypeParameterInstantiationCallOrNew() {
      const node = this.startNode();
      const oldInType = this.state.inType;
      node.params = [];
      this.state.inType = true;
      this.expect(47);
      while (!this.match(48)) {
        node.params.push(this.flowParseTypeOrImplicitInstantiation());
        if (!this.match(48)) {
          this.expect(12);
        }
      }
      this.expect(48);
      this.state.inType = oldInType;
      return this.finishNode(node, 'TypeParameterInstantiation');
    }
    flowParseInterfaceType() {
      const node = this.startNode();
      this.expectContextual(125);
      node.extends = [];
      if (this.eat(81)) {
        do {
          node.extends.push(this.flowParseInterfaceExtends());
        } while (this.eat(12));
      }
      node.body = this.flowParseObjectType({
        allowStatic: false,
        allowExact: false,
        allowSpread: false,
        allowProto: false,
        allowInexact: false,
      });
      return this.finishNode(node, 'InterfaceTypeAnnotation');
    }
    flowParseObjectPropertyKey() {
      return this.match(130) || this.match(129)
        ? super.parseExprAtom()
        : this.parseIdentifier(true);
    }
    flowParseObjectTypeIndexer(node, isStatic, variance) {
      node.static = isStatic;
      if (this.lookahead().type === 14) {
        node.id = this.flowParseObjectPropertyKey();
        node.key = this.flowParseTypeInitialiser();
      } else {
        node.id = null;
        node.key = this.flowParseType();
      }
      this.expect(3);
      node.value = this.flowParseTypeInitialiser();
      node.variance = variance;
      return this.finishNode(node, 'ObjectTypeIndexer');
    }
    flowParseObjectTypeInternalSlot(node, isStatic) {
      node.static = isStatic;
      node.id = this.flowParseObjectPropertyKey();
      this.expect(3);
      this.expect(3);
      if (this.match(47) || this.match(10)) {
        node.method = true;
        node.optional = false;
        node.value = this.flowParseObjectTypeMethodish(
          this.startNodeAt(node.start, node.loc.start)
        );
      } else {
        node.method = false;
        if (this.eat(17)) {
          node.optional = true;
        }
        node.value = this.flowParseTypeInitialiser();
      }
      return this.finishNode(node, 'ObjectTypeInternalSlot');
    }
    flowParseObjectTypeMethodish(node) {
      node.params = [];
      node.rest = null;
      node.typeParameters = null;
      node.this = null;
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      this.expect(10);
      if (this.match(78)) {
        node.this = this.flowParseFunctionTypeParam(true);
        node.this.name = null;
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      while (!this.match(11) && !this.match(21)) {
        node.params.push(this.flowParseFunctionTypeParam(false));
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      if (this.eat(21)) {
        node.rest = this.flowParseFunctionTypeParam(false);
      }
      this.expect(11);
      node.returnType = this.flowParseTypeInitialiser();
      return this.finishNode(node, 'FunctionTypeAnnotation');
    }
    flowParseObjectTypeCallProperty(node, isStatic) {
      const valueNode = this.startNode();
      node.static = isStatic;
      node.value = this.flowParseObjectTypeMethodish(valueNode);
      return this.finishNode(node, 'ObjectTypeCallProperty');
    }
    flowParseObjectType({
      allowStatic: allowStatic,
      allowExact: allowExact,
      allowSpread: allowSpread,
      allowProto: allowProto,
      allowInexact: allowInexact,
    }) {
      const oldInType = this.state.inType;
      this.state.inType = true;
      const nodeStart = this.startNode();
      nodeStart.callProperties = [];
      nodeStart.properties = [];
      nodeStart.indexers = [];
      nodeStart.internalSlots = [];
      let endDelim;
      let exact;
      let inexact = false;
      if (allowExact && this.match(6)) {
        this.expect(6);
        endDelim = 9;
        exact = true;
      } else {
        this.expect(5);
        endDelim = 8;
        exact = false;
      }
      nodeStart.exact = exact;
      while (!this.match(endDelim)) {
        let isStatic = false;
        let protoStartLoc = null;
        let inexactStartLoc = null;
        const node = this.startNode();
        if (allowProto && this.isContextual(115)) {
          const lookahead = this.lookahead();
          if (lookahead.type !== 14 && lookahead.type !== 17) {
            this.next();
            protoStartLoc = this.state.startLoc;
            allowStatic = false;
          }
        }
        if (allowStatic && this.isContextual(104)) {
          const lookahead = this.lookahead();
          if (lookahead.type !== 14 && lookahead.type !== 17) {
            this.next();
            isStatic = true;
          }
        }
        const variance = this.flowParseVariance();
        if (this.eat(0)) {
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (this.eat(0)) {
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            nodeStart.internalSlots.push(
              this.flowParseObjectTypeInternalSlot(node, isStatic)
            );
          } else {
            nodeStart.indexers.push(
              this.flowParseObjectTypeIndexer(node, isStatic, variance)
            );
          }
        } else if (this.match(10) || this.match(47)) {
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.unexpected(variance.loc.start);
          }
          nodeStart.callProperties.push(
            this.flowParseObjectTypeCallProperty(node, isStatic)
          );
        } else {
          let kind = 'init';
          if (this.isContextual(98) || this.isContextual(103)) {
            const lookahead = this.lookahead();
            if (tokenIsLiteralPropertyName(lookahead.type)) {
              kind = this.state.value;
              this.next();
            }
          }
          const propOrInexact = this.flowParseObjectTypeProperty(
            node,
            isStatic,
            protoStartLoc,
            variance,
            kind,
            allowSpread,
            allowInexact != null ? allowInexact : !exact
          );
          if (propOrInexact === null) {
            inexact = true;
            inexactStartLoc = this.state.lastTokStartLoc;
          } else {
            nodeStart.properties.push(propOrInexact);
          }
        }
        this.flowObjectTypeSemicolon();
        if (inexactStartLoc && !this.match(8) && !this.match(9)) {
          this.raise(FlowErrors.UnexpectedExplicitInexactInObject, {
            at: inexactStartLoc,
          });
        }
      }
      this.expect(endDelim);
      if (allowSpread) {
        nodeStart.inexact = inexact;
      }
      const out = this.finishNode(nodeStart, 'ObjectTypeAnnotation');
      this.state.inType = oldInType;
      return out;
    }
    flowParseObjectTypeProperty(
      node,
      isStatic,
      protoStartLoc,
      variance,
      kind,
      allowSpread,
      allowInexact
    ) {
      if (this.eat(21)) {
        const isInexactToken =
          this.match(12) || this.match(13) || this.match(8) || this.match(9);
        if (isInexactToken) {
          if (!allowSpread) {
            this.raise(FlowErrors.InexactInsideNonObject, {
              at: this.state.lastTokStartLoc,
            });
          } else if (!allowInexact) {
            this.raise(FlowErrors.InexactInsideExact, {
              at: this.state.lastTokStartLoc,
            });
          }
          if (variance) {
            this.raise(FlowErrors.InexactVariance, {at: variance});
          }
          return null;
        }
        if (!allowSpread) {
          this.raise(FlowErrors.UnexpectedSpreadType, {
            at: this.state.lastTokStartLoc,
          });
        }
        if (protoStartLoc != null) {
          this.unexpected(protoStartLoc);
        }
        if (variance) {
          this.raise(FlowErrors.SpreadVariance, {at: variance});
        }
        node.argument = this.flowParseType();
        return this.finishNode(node, 'ObjectTypeSpreadProperty');
      } else {
        node.key = this.flowParseObjectPropertyKey();
        node.static = isStatic;
        node.proto = protoStartLoc != null;
        node.kind = kind;
        let optional = false;
        if (this.match(47) || this.match(10)) {
          node.method = true;
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.unexpected(variance.loc.start);
          }
          node.value = this.flowParseObjectTypeMethodish(
            this.startNodeAt(node.start, node.loc.start)
          );
          if (kind === 'get' || kind === 'set') {
            this.flowCheckGetterSetterParams(node);
          }
          if (
            !allowSpread &&
            node.key.name === 'constructor' &&
            node.value.this
          ) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, {
              at: node.value.this,
            });
          }
        } else {
          if (kind !== 'init') this.unexpected();
          node.method = false;
          if (this.eat(17)) {
            optional = true;
          }
          node.value = this.flowParseTypeInitialiser();
          node.variance = variance;
        }
        node.optional = optional;
        return this.finishNode(node, 'ObjectTypeProperty');
      }
    }
    flowCheckGetterSetterParams(property) {
      const paramCount = property.kind === 'get' ? 0 : 1;
      const length =
        property.value.params.length + (property.value.rest ? 1 : 0);
      if (property.value.this) {
        this.raise(
          property.kind === 'get'
            ? FlowErrors.GetterMayNotHaveThisParam
            : FlowErrors.SetterMayNotHaveThisParam,
          {at: property.value.this}
        );
      }
      if (length !== paramCount) {
        this.raise(
          property.kind === 'get'
            ? Errors.BadGetterArity
            : Errors.BadSetterArity,
          {at: property}
        );
      }
      if (property.kind === 'set' && property.value.rest) {
        this.raise(Errors.BadSetterRestParameter, {at: property});
      }
    }
    flowObjectTypeSemicolon() {
      if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
        this.unexpected();
      }
    }
    flowParseQualifiedTypeIdentifier(startPos, startLoc, id) {
      startPos = startPos || this.state.start;
      startLoc = startLoc || this.state.startLoc;
      let node = id || this.flowParseRestrictedIdentifier(true);
      while (this.eat(16)) {
        const node2 = this.startNodeAt(startPos, startLoc);
        node2.qualification = node;
        node2.id = this.flowParseRestrictedIdentifier(true);
        node = this.finishNode(node2, 'QualifiedTypeIdentifier');
      }
      return node;
    }
    flowParseGenericType(startPos, startLoc, id) {
      const node = this.startNodeAt(startPos, startLoc);
      node.typeParameters = null;
      node.id = this.flowParseQualifiedTypeIdentifier(startPos, startLoc, id);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterInstantiation();
      }
      return this.finishNode(node, 'GenericTypeAnnotation');
    }
    flowParseTypeofType() {
      const node = this.startNode();
      this.expect(87);
      node.argument = this.flowParsePrimaryType();
      return this.finishNode(node, 'TypeofTypeAnnotation');
    }
    flowParseTupleType() {
      const node = this.startNode();
      node.types = [];
      this.expect(0);
      while (this.state.pos < this.length && !this.match(3)) {
        node.types.push(this.flowParseType());
        if (this.match(3)) break;
        this.expect(12);
      }
      this.expect(3);
      return this.finishNode(node, 'TupleTypeAnnotation');
    }
    flowParseFunctionTypeParam(first) {
      let name = null;
      let optional = false;
      let typeAnnotation = null;
      const node = this.startNode();
      const lh = this.lookahead();
      const isThis = this.state.type === 78;
      if (lh.type === 14 || lh.type === 17) {
        if (isThis && !first) {
          this.raise(FlowErrors.ThisParamMustBeFirst, {at: node});
        }
        name = this.parseIdentifier(isThis);
        if (this.eat(17)) {
          optional = true;
          if (isThis) {
            this.raise(FlowErrors.ThisParamMayNotBeOptional, {at: node});
          }
        }
        typeAnnotation = this.flowParseTypeInitialiser();
      } else {
        typeAnnotation = this.flowParseType();
      }
      node.name = name;
      node.optional = optional;
      node.typeAnnotation = typeAnnotation;
      return this.finishNode(node, 'FunctionTypeParam');
    }
    reinterpretTypeAsFunctionTypeParam(type) {
      const node = this.startNodeAt(type.start, type.loc.start);
      node.name = null;
      node.optional = false;
      node.typeAnnotation = type;
      return this.finishNode(node, 'FunctionTypeParam');
    }
    flowParseFunctionTypeParams(params = []) {
      let rest = null;
      let _this = null;
      if (this.match(78)) {
        _this = this.flowParseFunctionTypeParam(true);
        _this.name = null;
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      while (!this.match(11) && !this.match(21)) {
        params.push(this.flowParseFunctionTypeParam(false));
        if (!this.match(11)) {
          this.expect(12);
        }
      }
      if (this.eat(21)) {
        rest = this.flowParseFunctionTypeParam(false);
      }
      return {params: params, rest: rest, _this: _this};
    }
    flowIdentToTypeAnnotation(startPos, startLoc, node, id) {
      switch (id.name) {
        case 'any':
          return this.finishNode(node, 'AnyTypeAnnotation');
        case 'bool':
        case 'boolean':
          return this.finishNode(node, 'BooleanTypeAnnotation');
        case 'mixed':
          return this.finishNode(node, 'MixedTypeAnnotation');
        case 'empty':
          return this.finishNode(node, 'EmptyTypeAnnotation');
        case 'number':
          return this.finishNode(node, 'NumberTypeAnnotation');
        case 'string':
          return this.finishNode(node, 'StringTypeAnnotation');
        case 'symbol':
          return this.finishNode(node, 'SymbolTypeAnnotation');
        default:
          this.checkNotUnderscore(id.name);
          return this.flowParseGenericType(startPos, startLoc, id);
      }
    }
    flowParsePrimaryType() {
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      const node = this.startNode();
      let tmp;
      let type;
      let isGroupedType = false;
      const oldNoAnonFunctionType = this.state.noAnonFunctionType;
      switch (this.state.type) {
        case 5:
          return this.flowParseObjectType({
            allowStatic: false,
            allowExact: false,
            allowSpread: true,
            allowProto: false,
            allowInexact: true,
          });
        case 6:
          return this.flowParseObjectType({
            allowStatic: false,
            allowExact: true,
            allowSpread: true,
            allowProto: false,
            allowInexact: false,
          });
        case 0:
          this.state.noAnonFunctionType = false;
          type = this.flowParseTupleType();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
          return type;
        case 47:
          node.typeParameters = this.flowParseTypeParameterDeclaration();
          this.expect(10);
          tmp = this.flowParseFunctionTypeParams();
          node.params = tmp.params;
          node.rest = tmp.rest;
          node.this = tmp._this;
          this.expect(11);
          this.expect(19);
          node.returnType = this.flowParseType();
          return this.finishNode(node, 'FunctionTypeAnnotation');
        case 10:
          this.next();
          if (!this.match(11) && !this.match(21)) {
            if (tokenIsIdentifier(this.state.type) || this.match(78)) {
              const token = this.lookahead().type;
              isGroupedType = token !== 17 && token !== 14;
            } else {
              isGroupedType = true;
            }
          }
          if (isGroupedType) {
            this.state.noAnonFunctionType = false;
            type = this.flowParseType();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            if (
              this.state.noAnonFunctionType ||
              !(
                this.match(12) ||
                (this.match(11) && this.lookahead().type === 19)
              )
            ) {
              this.expect(11);
              return type;
            } else {
              this.eat(12);
            }
          }
          if (type) {
            tmp = this.flowParseFunctionTypeParams([
              this.reinterpretTypeAsFunctionTypeParam(type),
            ]);
          } else {
            tmp = this.flowParseFunctionTypeParams();
          }
          node.params = tmp.params;
          node.rest = tmp.rest;
          node.this = tmp._this;
          this.expect(11);
          this.expect(19);
          node.returnType = this.flowParseType();
          node.typeParameters = null;
          return this.finishNode(node, 'FunctionTypeAnnotation');
        case 129:
          return this.parseLiteral(
            this.state.value,
            'StringLiteralTypeAnnotation'
          );
        case 85:
        case 86:
          node.value = this.match(85);
          this.next();
          return this.finishNode(node, 'BooleanLiteralTypeAnnotation');
        case 53:
          if (this.state.value === '-') {
            this.next();
            if (this.match(130)) {
              return this.parseLiteralAtNode(
                -this.state.value,
                'NumberLiteralTypeAnnotation',
                node
              );
            }
            if (this.match(131)) {
              return this.parseLiteralAtNode(
                -this.state.value,
                'BigIntLiteralTypeAnnotation',
                node
              );
            }
            throw this.raise(FlowErrors.UnexpectedSubtractionOperand, {
              at: this.state.startLoc,
            });
          }
          throw this.unexpected();
        case 130:
          return this.parseLiteral(
            this.state.value,
            'NumberLiteralTypeAnnotation'
          );
        case 131:
          return this.parseLiteral(
            this.state.value,
            'BigIntLiteralTypeAnnotation'
          );
        case 88:
          this.next();
          return this.finishNode(node, 'VoidTypeAnnotation');
        case 84:
          this.next();
          return this.finishNode(node, 'NullLiteralTypeAnnotation');
        case 78:
          this.next();
          return this.finishNode(node, 'ThisTypeAnnotation');
        case 55:
          this.next();
          return this.finishNode(node, 'ExistsTypeAnnotation');
        case 87:
          return this.flowParseTypeofType();
        default:
          if (tokenIsKeyword(this.state.type)) {
            const label = tokenLabelName(this.state.type);
            this.next();
            return super.createIdentifier(node, label);
          } else if (tokenIsIdentifier(this.state.type)) {
            if (this.isContextual(125)) {
              return this.flowParseInterfaceType();
            }
            return this.flowIdentToTypeAnnotation(
              startPos,
              startLoc,
              node,
              this.parseIdentifier()
            );
          }
      }
      throw this.unexpected();
    }
    flowParsePostfixType() {
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      let type = this.flowParsePrimaryType();
      let seenOptionalIndexedAccess = false;
      while ((this.match(0) || this.match(18)) && !this.canInsertSemicolon()) {
        const node = this.startNodeAt(startPos, startLoc);
        const optional = this.eat(18);
        seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
        this.expect(0);
        if (!optional && this.match(3)) {
          node.elementType = type;
          this.next();
          type = this.finishNode(node, 'ArrayTypeAnnotation');
        } else {
          node.objectType = type;
          node.indexType = this.flowParseType();
          this.expect(3);
          if (seenOptionalIndexedAccess) {
            node.optional = optional;
            type = this.finishNode(node, 'OptionalIndexedAccessType');
          } else {
            type = this.finishNode(node, 'IndexedAccessType');
          }
        }
      }
      return type;
    }
    flowParsePrefixType() {
      const node = this.startNode();
      if (this.eat(17)) {
        node.typeAnnotation = this.flowParsePrefixType();
        return this.finishNode(node, 'NullableTypeAnnotation');
      } else {
        return this.flowParsePostfixType();
      }
    }
    flowParseAnonFunctionWithoutParens() {
      const param = this.flowParsePrefixType();
      if (!this.state.noAnonFunctionType && this.eat(19)) {
        const node = this.startNodeAt(param.start, param.loc.start);
        node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
        node.rest = null;
        node.this = null;
        node.returnType = this.flowParseType();
        node.typeParameters = null;
        return this.finishNode(node, 'FunctionTypeAnnotation');
      }
      return param;
    }
    flowParseIntersectionType() {
      const node = this.startNode();
      this.eat(45);
      const type = this.flowParseAnonFunctionWithoutParens();
      node.types = [type];
      while (this.eat(45)) {
        node.types.push(this.flowParseAnonFunctionWithoutParens());
      }
      return node.types.length === 1
        ? type
        : this.finishNode(node, 'IntersectionTypeAnnotation');
    }
    flowParseUnionType() {
      const node = this.startNode();
      this.eat(43);
      const type = this.flowParseIntersectionType();
      node.types = [type];
      while (this.eat(43)) {
        node.types.push(this.flowParseIntersectionType());
      }
      return node.types.length === 1
        ? type
        : this.finishNode(node, 'UnionTypeAnnotation');
    }
    flowParseType() {
      const oldInType = this.state.inType;
      this.state.inType = true;
      const type = this.flowParseUnionType();
      this.state.inType = oldInType;
      return type;
    }
    flowParseTypeOrImplicitInstantiation() {
      if (this.state.type === 128 && this.state.value === '_') {
        const startPos = this.state.start;
        const startLoc = this.state.startLoc;
        const node = this.parseIdentifier();
        return this.flowParseGenericType(startPos, startLoc, node);
      } else {
        return this.flowParseType();
      }
    }
    flowParseTypeAnnotation() {
      const node = this.startNode();
      node.typeAnnotation = this.flowParseTypeInitialiser();
      return this.finishNode(node, 'TypeAnnotation');
    }
    flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
      const ident = allowPrimitiveOverride
        ? this.parseIdentifier()
        : this.flowParseRestrictedIdentifier();
      if (this.match(14)) {
        ident.typeAnnotation = this.flowParseTypeAnnotation();
        this.resetEndLocation(ident);
      }
      return ident;
    }
    typeCastToParameter(node) {
      node.expression.typeAnnotation = node.typeAnnotation;
      this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
      return node.expression;
    }
    flowParseVariance() {
      let variance = null;
      if (this.match(53)) {
        variance = this.startNode();
        if (this.state.value === '+') {
          variance.kind = 'plus';
        } else {
          variance.kind = 'minus';
        }
        this.next();
        return this.finishNode(variance, 'Variance');
      }
      return variance;
    }
    parseFunctionBody(node, allowExpressionBody, isMethod = false) {
      if (allowExpressionBody) {
        return this.forwardNoArrowParamsConversionAt(node, () =>
          super.parseFunctionBody(node, true, isMethod)
        );
      }
      return super.parseFunctionBody(node, false, isMethod);
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      if (this.match(14)) {
        const typeNode = this.startNode();
        [typeNode.typeAnnotation, node.predicate] =
          this.flowParseTypeAndPredicateInitialiser();
        node.returnType = typeNode.typeAnnotation
          ? this.finishNode(typeNode, 'TypeAnnotation')
          : null;
      }
      return super.parseFunctionBodyAndFinish(node, type, isMethod);
    }
    parseStatement(context, topLevel) {
      if (this.state.strict && this.isContextual(125)) {
        const lookahead = this.lookahead();
        if (tokenIsKeywordOrIdentifier(lookahead.type)) {
          const node = this.startNode();
          this.next();
          return this.flowParseInterface(node);
        }
      } else if (this.shouldParseEnums() && this.isContextual(122)) {
        const node = this.startNode();
        this.next();
        return this.flowParseEnumDeclaration(node);
      }
      const stmt = super.parseStatement(context, topLevel);
      if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
        this.flowPragma = null;
      }
      return stmt;
    }
    parseExpressionStatement(node, expr) {
      if (expr.type === 'Identifier') {
        if (expr.name === 'declare') {
          if (
            this.match(80) ||
            tokenIsIdentifier(this.state.type) ||
            this.match(68) ||
            this.match(74) ||
            this.match(82)
          ) {
            return this.flowParseDeclare(node);
          }
        } else if (tokenIsIdentifier(this.state.type)) {
          if (expr.name === 'interface') {
            return this.flowParseInterface(node);
          } else if (expr.name === 'type') {
            return this.flowParseTypeAlias(node);
          } else if (expr.name === 'opaque') {
            return this.flowParseOpaqueType(node, false);
          }
        }
      }
      return super.parseExpressionStatement(node, expr);
    }
    shouldParseExportDeclaration() {
      const {type: type} = this.state;
      if (
        tokenIsFlowInterfaceOrTypeOrOpaque(type) ||
        (this.shouldParseEnums() && type === 122)
      ) {
        return !this.state.containsEsc;
      }
      return super.shouldParseExportDeclaration();
    }
    isExportDefaultSpecifier() {
      const {type: type} = this.state;
      if (
        tokenIsFlowInterfaceOrTypeOrOpaque(type) ||
        (this.shouldParseEnums() && type === 122)
      ) {
        return this.state.containsEsc;
      }
      return super.isExportDefaultSpecifier();
    }
    parseExportDefaultExpression() {
      if (this.shouldParseEnums() && this.isContextual(122)) {
        const node = this.startNode();
        this.next();
        return this.flowParseEnumDeclaration(node);
      }
      return super.parseExportDefaultExpression();
    }
    parseConditional(expr, startPos, startLoc, refExpressionErrors) {
      if (!this.match(17)) return expr;
      if (this.state.maybeInArrowParameters) {
        const nextCh = this.lookaheadCharCode();
        if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
          this.setOptionalParametersError(refExpressionErrors);
          return expr;
        }
      }
      this.expect(17);
      const state = this.state.clone();
      const originalNoArrowAt = this.state.noArrowAt;
      const node = this.startNodeAt(startPos, startLoc);
      let {consequent: consequent, failed: failed} =
        this.tryParseConditionalConsequent();
      let [valid, invalid] = this.getArrowLikeExpressions(consequent);
      if (failed || invalid.length > 0) {
        const noArrowAt = [...originalNoArrowAt];
        if (invalid.length > 0) {
          this.state = state;
          this.state.noArrowAt = noArrowAt;
          for (let i = 0; i < invalid.length; i++) {
            noArrowAt.push(invalid[i].start);
          }
          ({consequent: consequent, failed: failed} =
            this.tryParseConditionalConsequent());
          [valid, invalid] = this.getArrowLikeExpressions(consequent);
        }
        if (failed && valid.length > 1) {
          this.raise(FlowErrors.AmbiguousConditionalArrow, {
            at: state.startLoc,
          });
        }
        if (failed && valid.length === 1) {
          this.state = state;
          noArrowAt.push(valid[0].start);
          this.state.noArrowAt = noArrowAt;
          ({consequent: consequent, failed: failed} =
            this.tryParseConditionalConsequent());
        }
      }
      this.getArrowLikeExpressions(consequent, true);
      this.state.noArrowAt = originalNoArrowAt;
      this.expect(14);
      node.test = expr;
      node.consequent = consequent;
      node.alternate = this.forwardNoArrowParamsConversionAt(node, () =>
        this.parseMaybeAssign(undefined, undefined)
      );
      return this.finishNode(node, 'ConditionalExpression');
    }
    tryParseConditionalConsequent() {
      this.state.noArrowParamsConversionAt.push(this.state.start);
      const consequent = this.parseMaybeAssignAllowIn();
      const failed = !this.match(14);
      this.state.noArrowParamsConversionAt.pop();
      return {consequent: consequent, failed: failed};
    }
    getArrowLikeExpressions(node, disallowInvalid) {
      const stack = [node];
      const arrows = [];
      while (stack.length !== 0) {
        const node = stack.pop();
        if (node.type === 'ArrowFunctionExpression') {
          if (node.typeParameters || !node.returnType) {
            this.finishArrowValidation(node);
          } else {
            arrows.push(node);
          }
          stack.push(node.body);
        } else if (node.type === 'ConditionalExpression') {
          stack.push(node.consequent);
          stack.push(node.alternate);
        }
      }
      if (disallowInvalid) {
        arrows.forEach(node => this.finishArrowValidation(node));
        return [arrows, []];
      }
      return partition(arrows, node =>
        node.params.every(param => this.isAssignable(param, true))
      );
    }
    finishArrowValidation(node) {
      var _node$extra;
      this.toAssignableList(
        node.params,
        (_node$extra = node.extra) == null
          ? void 0
          : _node$extra.trailingCommaLoc,
        false
      );
      this.scope.enter(SCOPE_FUNCTION | SCOPE_ARROW);
      super.checkParams(node, false, true);
      this.scope.exit();
    }
    forwardNoArrowParamsConversionAt(node, parse) {
      let result;
      if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
        this.state.noArrowParamsConversionAt.push(this.state.start);
        result = parse();
        this.state.noArrowParamsConversionAt.pop();
      } else {
        result = parse();
      }
      return result;
    }
    parseParenItem(node, startPos, startLoc) {
      node = super.parseParenItem(node, startPos, startLoc);
      if (this.eat(17)) {
        node.optional = true;
        this.resetEndLocation(node);
      }
      if (this.match(14)) {
        const typeCastNode = this.startNodeAt(startPos, startLoc);
        typeCastNode.expression = node;
        typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
        return this.finishNode(typeCastNode, 'TypeCastExpression');
      }
      return node;
    }
    assertModuleNodeAllowed(node) {
      if (
        (node.type === 'ImportDeclaration' &&
          (node.importKind === 'type' || node.importKind === 'typeof')) ||
        (node.type === 'ExportNamedDeclaration' &&
          node.exportKind === 'type') ||
        (node.type === 'ExportAllDeclaration' && node.exportKind === 'type')
      ) {
        return;
      }
      super.assertModuleNodeAllowed(node);
    }
    parseExport(node) {
      const decl = super.parseExport(node);
      if (
        decl.type === 'ExportNamedDeclaration' ||
        decl.type === 'ExportAllDeclaration'
      ) {
        decl.exportKind = decl.exportKind || 'value';
      }
      return decl;
    }
    parseExportDeclaration(node) {
      if (this.isContextual(126)) {
        node.exportKind = 'type';
        const declarationNode = this.startNode();
        this.next();
        if (this.match(5)) {
          node.specifiers = this.parseExportSpecifiers(true);
          super.parseExportFrom(node);
          return null;
        } else {
          return this.flowParseTypeAlias(declarationNode);
        }
      } else if (this.isContextual(127)) {
        node.exportKind = 'type';
        const declarationNode = this.startNode();
        this.next();
        return this.flowParseOpaqueType(declarationNode, false);
      } else if (this.isContextual(125)) {
        node.exportKind = 'type';
        const declarationNode = this.startNode();
        this.next();
        return this.flowParseInterface(declarationNode);
      } else if (this.shouldParseEnums() && this.isContextual(122)) {
        node.exportKind = 'value';
        const declarationNode = this.startNode();
        this.next();
        return this.flowParseEnumDeclaration(declarationNode);
      } else {
        return super.parseExportDeclaration(node);
      }
    }
    eatExportStar(node) {
      if (super.eatExportStar(node)) return true;
      if (this.isContextual(126) && this.lookahead().type === 55) {
        node.exportKind = 'type';
        this.next();
        this.next();
        return true;
      }
      return false;
    }
    maybeParseExportNamespaceSpecifier(node) {
      const {startLoc: startLoc} = this.state;
      const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);
      if (hasNamespace && node.exportKind === 'type') {
        this.unexpected(startLoc);
      }
      return hasNamespace;
    }
    parseClassId(node, isStatement, optionalId) {
      super.parseClassId(node, isStatement, optionalId);
      if (this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      }
    }
    parseClassMember(classBody, member, state) {
      const {startLoc: startLoc} = this.state;
      if (this.isContextual(121)) {
        if (super.parseClassMemberFromModifier(classBody, member)) {
          return;
        }
        member.declare = true;
      }
      super.parseClassMember(classBody, member, state);
      if (member.declare) {
        if (
          member.type !== 'ClassProperty' &&
          member.type !== 'ClassPrivateProperty' &&
          member.type !== 'PropertyDefinition'
        ) {
          this.raise(FlowErrors.DeclareClassElement, {at: startLoc});
        } else if (member.value) {
          this.raise(FlowErrors.DeclareClassFieldInitializer, {
            at: member.value,
          });
        }
      }
    }
    isIterator(word) {
      return word === 'iterator' || word === 'asyncIterator';
    }
    readIterator() {
      const word = super.readWord1();
      const fullWord = '@@' + word;
      if (!this.isIterator(word) || !this.state.inType) {
        this.raise(Errors.InvalidIdentifier, {
          at: this.state.curPosition(),
          identifierName: fullWord,
        });
      }
      this.finishToken(128, fullWord);
    }
    getTokenFromCode(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (code === 123 && next === 124) {
        return this.finishOp(6, 2);
      } else if (this.state.inType && (code === 62 || code === 60)) {
        return this.finishOp(code === 62 ? 48 : 47, 1);
      } else if (this.state.inType && code === 63) {
        if (next === 46) {
          return this.finishOp(18, 2);
        }
        return this.finishOp(17, 1);
      } else if (
        isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))
      ) {
        this.state.pos += 2;
        return this.readIterator();
      } else {
        return super.getTokenFromCode(code);
      }
    }
    isAssignable(node, isBinding) {
      if (node.type === 'TypeCastExpression') {
        return this.isAssignable(node.expression, isBinding);
      } else {
        return super.isAssignable(node, isBinding);
      }
    }
    toAssignable(node, isLHS = false) {
      if (
        !isLHS &&
        node.type === 'AssignmentExpression' &&
        node.left.type === 'TypeCastExpression'
      ) {
        node.left = this.typeCastToParameter(node.left);
      }
      super.toAssignable(node, isLHS);
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      for (let i = 0; i < exprList.length; i++) {
        const expr = exprList[i];
        if ((expr == null ? void 0 : expr.type) === 'TypeCastExpression') {
          exprList[i] = this.typeCastToParameter(expr);
        }
      }
      super.toAssignableList(exprList, trailingCommaLoc, isLHS);
    }
    toReferencedList(exprList, isParenthesizedExpr) {
      for (let i = 0; i < exprList.length; i++) {
        var _expr$extra;
        const expr = exprList[i];
        if (
          expr &&
          expr.type === 'TypeCastExpression' &&
          !((_expr$extra = expr.extra) != null && _expr$extra.parenthesized) &&
          (exprList.length > 1 || !isParenthesizedExpr)
        ) {
          this.raise(FlowErrors.TypeCastInPattern, {at: expr.typeAnnotation});
        }
      }
      return exprList;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      const node = super.parseArrayLike(
        close,
        canBePattern,
        isTuple,
        refExpressionErrors
      );
      if (canBePattern && !this.state.maybeInArrowParameters) {
        this.toReferencedList(node.elements);
      }
      return node;
    }
    isValidLVal(type, isParenthesized, binding) {
      return (
        type === 'TypeCastExpression' ||
        super.isValidLVal(type, isParenthesized, binding)
      );
    }
    parseClassProperty(node) {
      if (this.match(14)) {
        node.typeAnnotation = this.flowParseTypeAnnotation();
      }
      return super.parseClassProperty(node);
    }
    parseClassPrivateProperty(node) {
      if (this.match(14)) {
        node.typeAnnotation = this.flowParseTypeAnnotation();
      }
      return super.parseClassPrivateProperty(node);
    }
    isClassMethod() {
      return this.match(47) || super.isClassMethod();
    }
    isClassProperty() {
      return this.match(14) || super.isClassProperty();
    }
    isNonstaticConstructor(method) {
      return !this.match(14) && super.isNonstaticConstructor(method);
    }
    pushClassMethod(
      classBody,
      method,
      isGenerator,
      isAsync,
      isConstructor,
      allowsDirectSuper
    ) {
      if (method.variance) {
        this.unexpected(method.variance.loc.start);
      }
      delete method.variance;
      if (this.match(47)) {
        method.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      super.pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      );
      if (method.params && isConstructor) {
        const params = method.params;
        if (params.length > 0 && this.isThisParam(params[0])) {
          this.raise(FlowErrors.ThisParamBannedInConstructor, {at: method});
        }
      } else if (
        method.type === 'MethodDefinition' &&
        isConstructor &&
        method.value.params
      ) {
        const params = method.value.params;
        if (params.length > 0 && this.isThisParam(params[0])) {
          this.raise(FlowErrors.ThisParamBannedInConstructor, {at: method});
        }
      }
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      if (method.variance) {
        this.unexpected(method.variance.loc.start);
      }
      delete method.variance;
      if (this.match(47)) {
        method.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
    }
    parseClassSuper(node) {
      super.parseClassSuper(node);
      if (node.superClass && this.match(47)) {
        node.superTypeParameters = this.flowParseTypeParameterInstantiation();
      }
      if (this.isContextual(110)) {
        this.next();
        const implemented = (node.implements = []);
        do {
          const node = this.startNode();
          node.id = this.flowParseRestrictedIdentifier(true);
          if (this.match(47)) {
            node.typeParameters = this.flowParseTypeParameterInstantiation();
          } else {
            node.typeParameters = null;
          }
          implemented.push(this.finishNode(node, 'ClassImplements'));
        } while (this.eat(12));
      }
    }
    checkGetterSetterParams(method) {
      super.checkGetterSetterParams(method);
      const params = this.getObjectOrClassMethodParams(method);
      if (params.length > 0) {
        const param = params[0];
        if (this.isThisParam(param) && method.kind === 'get') {
          this.raise(FlowErrors.GetterMayNotHaveThisParam, {at: param});
        } else if (this.isThisParam(param)) {
          this.raise(FlowErrors.SetterMayNotHaveThisParam, {at: param});
        }
      }
    }
    parsePropertyNamePrefixOperator(node) {
      node.variance = this.flowParseVariance();
    }
    parseObjPropValue(
      prop,
      startPos,
      startLoc,
      isGenerator,
      isAsync,
      isPattern,
      isAccessor,
      refExpressionErrors
    ) {
      if (prop.variance) {
        this.unexpected(prop.variance.loc.start);
      }
      delete prop.variance;
      let typeParameters;
      if (this.match(47) && !isAccessor) {
        typeParameters = this.flowParseTypeParameterDeclaration();
        if (!this.match(10)) this.unexpected();
      }
      const result = super.parseObjPropValue(
        prop,
        startPos,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      );
      if (typeParameters) {
        (result.value || result).typeParameters = typeParameters;
      }
      return result;
    }
    parseAssignableListItemTypes(param) {
      if (this.eat(17)) {
        if (param.type !== 'Identifier') {
          this.raise(FlowErrors.PatternIsOptional, {at: param});
        }
        if (this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamMayNotBeOptional, {at: param});
        }
        param.optional = true;
      }
      if (this.match(14)) {
        param.typeAnnotation = this.flowParseTypeAnnotation();
      } else if (this.isThisParam(param)) {
        this.raise(FlowErrors.ThisParamAnnotationRequired, {at: param});
      }
      if (this.match(29) && this.isThisParam(param)) {
        this.raise(FlowErrors.ThisParamNoDefault, {at: param});
      }
      this.resetEndLocation(param);
      return param;
    }
    parseMaybeDefault(startPos, startLoc, left) {
      const node = super.parseMaybeDefault(startPos, startLoc, left);
      if (
        node.type === 'AssignmentPattern' &&
        node.typeAnnotation &&
        node.right.start < node.typeAnnotation.start
      ) {
        this.raise(FlowErrors.TypeBeforeInitializer, {at: node.typeAnnotation});
      }
      return node;
    }
    shouldParseDefaultImport(node) {
      if (!hasTypeImportKind(node)) {
        return super.shouldParseDefaultImport(node);
      }
      return isMaybeDefaultImport(this.state.type);
    }
    parseImportSpecifierLocal(node, specifier, type) {
      specifier.local = hasTypeImportKind(node)
        ? this.flowParseRestrictedIdentifier(true, true)
        : this.parseIdentifier();
      node.specifiers.push(this.finishImportSpecifier(specifier, type));
    }
    maybeParseDefaultImportSpecifier(node) {
      node.importKind = 'value';
      let kind = null;
      if (this.match(87)) {
        kind = 'typeof';
      } else if (this.isContextual(126)) {
        kind = 'type';
      }
      if (kind) {
        const lh = this.lookahead();
        const {type: type} = lh;
        if (kind === 'type' && type === 55) {
          this.unexpected(null, lh.type);
        }
        if (isMaybeDefaultImport(type) || type === 5 || type === 55) {
          this.next();
          node.importKind = kind;
        }
      }
      return super.maybeParseDefaultImportSpecifier(node);
    }
    parseImportSpecifier(
      specifier,
      importedIsString,
      isInTypeOnlyImport,
      isMaybeTypeOnly,
      bindingType
    ) {
      const firstIdent = specifier.imported;
      let specifierTypeKind = null;
      if (firstIdent.type === 'Identifier') {
        if (firstIdent.name === 'type') {
          specifierTypeKind = 'type';
        } else if (firstIdent.name === 'typeof') {
          specifierTypeKind = 'typeof';
        }
      }
      let isBinding = false;
      if (this.isContextual(93) && !this.isLookaheadContextual('as')) {
        const as_ident = this.parseIdentifier(true);
        if (
          specifierTypeKind !== null &&
          !tokenIsKeywordOrIdentifier(this.state.type)
        ) {
          specifier.imported = as_ident;
          specifier.importKind = specifierTypeKind;
          specifier.local = cloneIdentifier(as_ident);
        } else {
          specifier.imported = firstIdent;
          specifier.importKind = null;
          specifier.local = this.parseIdentifier();
        }
      } else {
        if (
          specifierTypeKind !== null &&
          tokenIsKeywordOrIdentifier(this.state.type)
        ) {
          specifier.imported = this.parseIdentifier(true);
          specifier.importKind = specifierTypeKind;
        } else {
          if (importedIsString) {
            throw this.raise(Errors.ImportBindingIsString, {
              at: specifier,
              importName: firstIdent.value,
            });
          }
          specifier.imported = firstIdent;
          specifier.importKind = null;
        }
        if (this.eatContextual(93)) {
          specifier.local = this.parseIdentifier();
        } else {
          isBinding = true;
          specifier.local = cloneIdentifier(specifier.imported);
        }
      }
      const specifierIsTypeImport = hasTypeImportKind(specifier);
      if (isInTypeOnlyImport && specifierIsTypeImport) {
        this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, {
          at: specifier,
        });
      }
      if (isInTypeOnlyImport || specifierIsTypeImport) {
        this.checkReservedType(
          specifier.local.name,
          specifier.local.loc.start,
          true
        );
      }
      if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
        this.checkReservedWord(
          specifier.local.name,
          specifier.loc.start,
          true,
          true
        );
      }
      return this.finishImportSpecifier(specifier, 'ImportSpecifier');
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 78:
          return this.parseIdentifier(true);
        default:
          return super.parseBindingAtom();
      }
    }
    parseFunctionParams(node, allowModifiers) {
      const kind = node.kind;
      if (kind !== 'get' && kind !== 'set' && this.match(47)) {
        node.typeParameters = this.flowParseTypeParameterDeclaration();
      }
      super.parseFunctionParams(node, allowModifiers);
    }
    parseVarId(decl, kind) {
      super.parseVarId(decl, kind);
      if (this.match(14)) {
        decl.id.typeAnnotation = this.flowParseTypeAnnotation();
        this.resetEndLocation(decl.id);
      }
    }
    parseAsyncArrowFromCallExpression(node, call) {
      if (this.match(14)) {
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        this.state.noAnonFunctionType = true;
        node.returnType = this.flowParseTypeAnnotation();
        this.state.noAnonFunctionType = oldNoAnonFunctionType;
      }
      return super.parseAsyncArrowFromCallExpression(node, call);
    }
    shouldParseAsyncArrow() {
      return this.match(14) || super.shouldParseAsyncArrow();
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      var _jsx;
      let state = null;
      let jsx;
      if (this.hasPlugin('jsx') && (this.match(138) || this.match(47))) {
        state = this.state.clone();
        jsx = this.tryParse(
          () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
          state
        );
        if (!jsx.error) return jsx.node;
        const {context: context} = this.state;
        const currentContext = context[context.length - 1];
        if (
          currentContext === types$2.j_oTag ||
          currentContext === types$2.j_expr
        ) {
          context.pop();
        }
      }
      if (((_jsx = jsx) != null && _jsx.error) || this.match(47)) {
        var _jsx2, _jsx3;
        state = state || this.state.clone();
        let typeParameters;
        const arrow = this.tryParse(abort => {
          var _arrowExpression$extr;
          typeParameters = this.flowParseTypeParameterDeclaration();
          const arrowExpression = this.forwardNoArrowParamsConversionAt(
            typeParameters,
            () => {
              const result = super.parseMaybeAssign(
                refExpressionErrors,
                afterLeftParse
              );
              this.resetStartLocationFromNode(result, typeParameters);
              return result;
            }
          );
          if (
            (_arrowExpression$extr = arrowExpression.extra) != null &&
            _arrowExpression$extr.parenthesized
          )
            abort();
          const expr = this.maybeUnwrapTypeCastExpression(arrowExpression);
          if (expr.type !== 'ArrowFunctionExpression') abort();
          expr.typeParameters = typeParameters;
          this.resetStartLocationFromNode(expr, typeParameters);
          return arrowExpression;
        }, state);
        let arrowExpression = null;
        if (
          arrow.node &&
          this.maybeUnwrapTypeCastExpression(arrow.node).type ===
            'ArrowFunctionExpression'
        ) {
          if (!arrow.error && !arrow.aborted) {
            if (arrow.node.async) {
              this.raise(
                FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction,
                {at: typeParameters}
              );
            }
            return arrow.node;
          }
          arrowExpression = arrow.node;
        }
        if ((_jsx2 = jsx) != null && _jsx2.node) {
          this.state = jsx.failState;
          return jsx.node;
        }
        if (arrowExpression) {
          this.state = arrow.failState;
          return arrowExpression;
        }
        if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
        if (arrow.thrown) throw arrow.error;
        throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, {
          at: typeParameters,
        });
      }
      return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
    }
    parseArrow(node) {
      if (this.match(14)) {
        const result = this.tryParse(() => {
          const oldNoAnonFunctionType = this.state.noAnonFunctionType;
          this.state.noAnonFunctionType = true;
          const typeNode = this.startNode();
          [typeNode.typeAnnotation, node.predicate] =
            this.flowParseTypeAndPredicateInitialiser();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
          if (this.canInsertSemicolon()) this.unexpected();
          if (!this.match(19)) this.unexpected();
          return typeNode;
        });
        if (result.thrown) return null;
        if (result.error) this.state = result.failState;
        node.returnType = result.node.typeAnnotation
          ? this.finishNode(result.node, 'TypeAnnotation')
          : null;
      }
      return super.parseArrow(node);
    }
    shouldParseArrow(params) {
      return this.match(14) || super.shouldParseArrow(params);
    }
    setArrowFunctionParameters(node, params) {
      if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
        node.params = params;
      } else {
        super.setArrowFunctionParameters(node, params);
      }
    }
    checkParams(
      node,
      allowDuplicates,
      isArrowFunction,
      strictModeChanged = true
    ) {
      if (
        isArrowFunction &&
        this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1
      ) {
        return;
      }
      for (let i = 0; i < node.params.length; i++) {
        if (this.isThisParam(node.params[i]) && i > 0) {
          this.raise(FlowErrors.ThisParamMustBeFirst, {at: node.params[i]});
        }
      }
      return super.checkParams(
        node,
        allowDuplicates,
        isArrowFunction,
        strictModeChanged
      );
    }
    parseParenAndDistinguishExpression(canBeArrow) {
      return super.parseParenAndDistinguishExpression(
        canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1
      );
    }
    parseSubscripts(base, startPos, startLoc, noCalls) {
      if (
        base.type === 'Identifier' &&
        base.name === 'async' &&
        this.state.noArrowAt.indexOf(startPos) !== -1
      ) {
        this.next();
        const node = this.startNodeAt(startPos, startLoc);
        node.callee = base;
        node.arguments = super.parseCallExpressionArguments(11, false);
        base = this.finishNode(node, 'CallExpression');
      } else if (
        base.type === 'Identifier' &&
        base.name === 'async' &&
        this.match(47)
      ) {
        const state = this.state.clone();
        const arrow = this.tryParse(
          abort =>
            this.parseAsyncArrowWithTypeParameters(startPos, startLoc) ||
            abort(),
          state
        );
        if (!arrow.error && !arrow.aborted) return arrow.node;
        const result = this.tryParse(
          () => super.parseSubscripts(base, startPos, startLoc, noCalls),
          state
        );
        if (result.node && !result.error) return result.node;
        if (arrow.node) {
          this.state = arrow.failState;
          return arrow.node;
        }
        if (result.node) {
          this.state = result.failState;
          return result.node;
        }
        throw arrow.error || result.error;
      }
      return super.parseSubscripts(base, startPos, startLoc, noCalls);
    }
    parseSubscript(base, startPos, startLoc, noCalls, subscriptState) {
      if (this.match(18) && this.isLookaheadToken_lt()) {
        subscriptState.optionalChainMember = true;
        if (noCalls) {
          subscriptState.stop = true;
          return base;
        }
        this.next();
        const node = this.startNodeAt(startPos, startLoc);
        node.callee = base;
        node.typeArguments = this.flowParseTypeParameterInstantiation();
        this.expect(10);
        node.arguments = this.parseCallExpressionArguments(11, false);
        node.optional = true;
        return this.finishCallExpression(node, true);
      } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
        const node = this.startNodeAt(startPos, startLoc);
        node.callee = base;
        const result = this.tryParse(() => {
          node.typeArguments =
            this.flowParseTypeParameterInstantiationCallOrNew();
          this.expect(10);
          node.arguments = super.parseCallExpressionArguments(11, false);
          if (subscriptState.optionalChainMember) {
            node.optional = false;
          }
          return this.finishCallExpression(
            node,
            subscriptState.optionalChainMember
          );
        });
        if (result.node) {
          if (result.error) this.state = result.failState;
          return result.node;
        }
      }
      return super.parseSubscript(
        base,
        startPos,
        startLoc,
        noCalls,
        subscriptState
      );
    }
    parseNewCallee(node) {
      super.parseNewCallee(node);
      let targs = null;
      if (this.shouldParseTypes() && this.match(47)) {
        targs = this.tryParse(() =>
          this.flowParseTypeParameterInstantiationCallOrNew()
        ).node;
      }
      node.typeArguments = targs;
    }
    parseAsyncArrowWithTypeParameters(startPos, startLoc) {
      const node = this.startNodeAt(startPos, startLoc);
      this.parseFunctionParams(node);
      if (!this.parseArrow(node)) return;
      return super.parseArrowExpression(node, undefined, true);
    }
    readToken_mult_modulo(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (code === 42 && next === 47 && this.state.hasFlowComment) {
        this.state.hasFlowComment = false;
        this.state.pos += 2;
        this.nextToken();
        return;
      }
      super.readToken_mult_modulo(code);
    }
    readToken_pipe_amp(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (code === 124 && next === 125) {
        this.finishOp(9, 2);
        return;
      }
      super.readToken_pipe_amp(code);
    }
    parseTopLevel(file, program) {
      const fileNode = super.parseTopLevel(file, program);
      if (this.state.hasFlowComment) {
        this.raise(FlowErrors.UnterminatedFlowComment, {
          at: this.state.curPosition(),
        });
      }
      return fileNode;
    }
    skipBlockComment() {
      if (this.hasPlugin('flowComments') && this.skipFlowComment()) {
        if (this.state.hasFlowComment) {
          throw this.raise(FlowErrors.NestedFlowComment, {
            at: this.state.startLoc,
          });
        }
        this.hasFlowCommentCompletion();
        const commentSkip = this.skipFlowComment();
        if (commentSkip) {
          this.state.pos += commentSkip;
          this.state.hasFlowComment = true;
        }
        return;
      }
      if (this.state.hasFlowComment) {
        const end = this.input.indexOf('*-/', this.state.pos + 2);
        if (end === -1) {
          throw this.raise(Errors.UnterminatedComment, {
            at: this.state.curPosition(),
          });
        }
        this.state.pos = end + 2 + 3;
        return;
      }
      return super.skipBlockComment();
    }
    skipFlowComment() {
      const {pos: pos} = this.state;
      let shiftToFirstNonWhiteSpace = 2;
      while (
        [32, 9].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))
      ) {
        shiftToFirstNonWhiteSpace++;
      }
      const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
      const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
      if (ch2 === 58 && ch3 === 58) {
        return shiftToFirstNonWhiteSpace + 2;
      }
      if (
        this.input.slice(
          shiftToFirstNonWhiteSpace + pos,
          shiftToFirstNonWhiteSpace + pos + 12
        ) === 'flow-include'
      ) {
        return shiftToFirstNonWhiteSpace + 12;
      }
      if (ch2 === 58 && ch3 !== 58) {
        return shiftToFirstNonWhiteSpace;
      }
      return false;
    }
    hasFlowCommentCompletion() {
      const end = this.input.indexOf('*/', this.state.pos);
      if (end === -1) {
        throw this.raise(Errors.UnterminatedComment, {
          at: this.state.curPosition(),
        });
      }
    }
    flowEnumErrorBooleanMemberNotInitialized(
      loc,
      {enumName: enumName, memberName: memberName}
    ) {
      this.raise(FlowErrors.EnumBooleanMemberNotInitialized, {
        at: loc,
        memberName: memberName,
        enumName: enumName,
      });
    }
    flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
      return this.raise(
        !enumContext.explicitType
          ? FlowErrors.EnumInvalidMemberInitializerUnknownType
          : enumContext.explicitType === 'symbol'
            ? FlowErrors.EnumInvalidMemberInitializerSymbolType
            : FlowErrors.EnumInvalidMemberInitializerPrimaryType,
        Object.assign({at: loc}, enumContext)
      );
    }
    flowEnumErrorNumberMemberNotInitialized(
      loc,
      {enumName: enumName, memberName: memberName}
    ) {
      this.raise(FlowErrors.EnumNumberMemberNotInitialized, {
        at: loc,
        enumName: enumName,
        memberName: memberName,
      });
    }
    flowEnumErrorStringMemberInconsistentlyInitailized(
      node,
      {enumName: enumName}
    ) {
      this.raise(FlowErrors.EnumStringMemberInconsistentlyInitailized, {
        at: node,
        enumName: enumName,
      });
    }
    flowEnumMemberInit() {
      const startLoc = this.state.startLoc;
      const endOfInit = () => this.match(12) || this.match(8);
      switch (this.state.type) {
        case 130: {
          const literal = this.parseNumericLiteral(this.state.value);
          if (endOfInit()) {
            return {type: 'number', loc: literal.loc.start, value: literal};
          }
          return {type: 'invalid', loc: startLoc};
        }
        case 129: {
          const literal = this.parseStringLiteral(this.state.value);
          if (endOfInit()) {
            return {type: 'string', loc: literal.loc.start, value: literal};
          }
          return {type: 'invalid', loc: startLoc};
        }
        case 85:
        case 86: {
          const literal = this.parseBooleanLiteral(this.match(85));
          if (endOfInit()) {
            return {type: 'boolean', loc: literal.loc.start, value: literal};
          }
          return {type: 'invalid', loc: startLoc};
        }
        default:
          return {type: 'invalid', loc: startLoc};
      }
    }
    flowEnumMemberRaw() {
      const loc = this.state.startLoc;
      const id = this.parseIdentifier(true);
      const init = this.eat(29)
        ? this.flowEnumMemberInit()
        : {type: 'none', loc: loc};
      return {id: id, init: init};
    }
    flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
      const {explicitType: explicitType} = context;
      if (explicitType === null) {
        return;
      }
      if (explicitType !== expectedType) {
        this.flowEnumErrorInvalidMemberInitializer(loc, context);
      }
    }
    flowEnumMembers({enumName: enumName, explicitType: explicitType}) {
      const seenNames = new Set();
      const members = {
        booleanMembers: [],
        numberMembers: [],
        stringMembers: [],
        defaultedMembers: [],
      };
      let hasUnknownMembers = false;
      while (!this.match(8)) {
        if (this.eat(21)) {
          hasUnknownMembers = true;
          break;
        }
        const memberNode = this.startNode();
        const {id: id, init: init} = this.flowEnumMemberRaw();
        const memberName = id.name;
        if (memberName === '') {
          continue;
        }
        if (/^[a-z]/.test(memberName)) {
          this.raise(FlowErrors.EnumInvalidMemberName, {
            at: id,
            memberName: memberName,
            suggestion: memberName[0].toUpperCase() + memberName.slice(1),
            enumName: enumName,
          });
        }
        if (seenNames.has(memberName)) {
          this.raise(FlowErrors.EnumDuplicateMemberName, {
            at: id,
            memberName: memberName,
            enumName: enumName,
          });
        }
        seenNames.add(memberName);
        const context = {
          enumName: enumName,
          explicitType: explicitType,
          memberName: memberName,
        };
        memberNode.id = id;
        switch (init.type) {
          case 'boolean': {
            this.flowEnumCheckExplicitTypeMismatch(
              init.loc,
              context,
              'boolean'
            );
            memberNode.init = init.value;
            members.booleanMembers.push(
              this.finishNode(memberNode, 'EnumBooleanMember')
            );
            break;
          }
          case 'number': {
            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, 'number');
            memberNode.init = init.value;
            members.numberMembers.push(
              this.finishNode(memberNode, 'EnumNumberMember')
            );
            break;
          }
          case 'string': {
            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, 'string');
            memberNode.init = init.value;
            members.stringMembers.push(
              this.finishNode(memberNode, 'EnumStringMember')
            );
            break;
          }
          case 'invalid': {
            throw this.flowEnumErrorInvalidMemberInitializer(init.loc, context);
          }
          case 'none': {
            switch (explicitType) {
              case 'boolean':
                this.flowEnumErrorBooleanMemberNotInitialized(
                  init.loc,
                  context
                );
                break;
              case 'number':
                this.flowEnumErrorNumberMemberNotInitialized(init.loc, context);
                break;
              default:
                members.defaultedMembers.push(
                  this.finishNode(memberNode, 'EnumDefaultedMember')
                );
            }
          }
        }
        if (!this.match(8)) {
          this.expect(12);
        }
      }
      return {members: members, hasUnknownMembers: hasUnknownMembers};
    }
    flowEnumStringMembers(
      initializedMembers,
      defaultedMembers,
      {enumName: enumName}
    ) {
      if (initializedMembers.length === 0) {
        return defaultedMembers;
      } else if (defaultedMembers.length === 0) {
        return initializedMembers;
      } else if (defaultedMembers.length > initializedMembers.length) {
        for (const member of initializedMembers) {
          this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
            enumName: enumName,
          });
        }
        return defaultedMembers;
      } else {
        for (const member of defaultedMembers) {
          this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
            enumName: enumName,
          });
        }
        return initializedMembers;
      }
    }
    flowEnumParseExplicitType({enumName: enumName}) {
      if (!this.eatContextual(101)) return null;
      if (!tokenIsIdentifier(this.state.type)) {
        throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, {
          at: this.state.startLoc,
          enumName: enumName,
        });
      }
      const {value: value} = this.state;
      this.next();
      if (
        value !== 'boolean' &&
        value !== 'number' &&
        value !== 'string' &&
        value !== 'symbol'
      ) {
        this.raise(FlowErrors.EnumInvalidExplicitType, {
          at: this.state.startLoc,
          enumName: enumName,
          invalidEnumType: value,
        });
      }
      return value;
    }
    flowEnumBody(node, id) {
      const enumName = id.name;
      const nameLoc = id.loc.start;
      const explicitType = this.flowEnumParseExplicitType({enumName: enumName});
      this.expect(5);
      const {members: members, hasUnknownMembers: hasUnknownMembers} =
        this.flowEnumMembers({enumName: enumName, explicitType: explicitType});
      node.hasUnknownMembers = hasUnknownMembers;
      switch (explicitType) {
        case 'boolean':
          node.explicitType = true;
          node.members = members.booleanMembers;
          this.expect(8);
          return this.finishNode(node, 'EnumBooleanBody');
        case 'number':
          node.explicitType = true;
          node.members = members.numberMembers;
          this.expect(8);
          return this.finishNode(node, 'EnumNumberBody');
        case 'string':
          node.explicitType = true;
          node.members = this.flowEnumStringMembers(
            members.stringMembers,
            members.defaultedMembers,
            {enumName: enumName}
          );
          this.expect(8);
          return this.finishNode(node, 'EnumStringBody');
        case 'symbol':
          node.members = members.defaultedMembers;
          this.expect(8);
          return this.finishNode(node, 'EnumSymbolBody');
        default: {
          const empty = () => {
            node.members = [];
            this.expect(8);
            return this.finishNode(node, 'EnumStringBody');
          };
          node.explicitType = false;
          const boolsLen = members.booleanMembers.length;
          const numsLen = members.numberMembers.length;
          const strsLen = members.stringMembers.length;
          const defaultedLen = members.defaultedMembers.length;
          if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
            return empty();
          } else if (!boolsLen && !numsLen) {
            node.members = this.flowEnumStringMembers(
              members.stringMembers,
              members.defaultedMembers,
              {enumName: enumName}
            );
            this.expect(8);
            return this.finishNode(node, 'EnumStringBody');
          } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
            for (const member of members.defaultedMembers) {
              this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
                enumName: enumName,
                memberName: member.id.name,
              });
            }
            node.members = members.booleanMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumBooleanBody');
          } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
            for (const member of members.defaultedMembers) {
              this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
                enumName: enumName,
                memberName: member.id.name,
              });
            }
            node.members = members.numberMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumNumberBody');
          } else {
            this.raise(FlowErrors.EnumInconsistentMemberValues, {
              at: nameLoc,
              enumName: enumName,
            });
            return empty();
          }
        }
      }
    }
    flowParseEnumDeclaration(node) {
      const id = this.parseIdentifier();
      node.id = id;
      node.body = this.flowEnumBody(this.startNode(), id);
      return this.finishNode(node, 'EnumDeclaration');
    }
    isLookaheadToken_lt() {
      const next = this.nextTokenStart();
      if (this.input.charCodeAt(next) === 60) {
        const afterNext = this.input.charCodeAt(next + 1);
        return afterNext !== 60 && afterNext !== 61;
      }
      return false;
    }
    maybeUnwrapTypeCastExpression(node) {
      return node.type === 'TypeCastExpression' ? node.expression : node;
    }
  };
const entities = {
  __proto__: null,
  quot: '"',
  amp: '&',
  apos: "'",
  lt: '<',
  gt: '>',
  nbsp: ' ',
  iexcl: '¡',
  cent: '¢',
  pound: '£',
  curren: '¤',
  yen: '¥',
  brvbar: '¦',
  sect: '§',
  uml: '¨',
  copy: '©',
  ordf: 'ª',
  laquo: '«',
  not: '¬',
  shy: '­',
  reg: '®',
  macr: '¯',
  deg: '°',
  plusmn: '±',
  sup2: '²',
  sup3: '³',
  acute: '´',
  micro: 'µ',
  para: '¶',
  middot: '·',
  cedil: '¸',
  sup1: '¹',
  ordm: 'º',
  raquo: '»',
  frac14: '¼',
  frac12: '½',
  frac34: '¾',
  iquest: '¿',
  Agrave: 'À',
  Aacute: 'Á',
  Acirc: 'Â',
  Atilde: 'Ã',
  Auml: 'Ä',
  Aring: 'Å',
  AElig: 'Æ',
  Ccedil: 'Ç',
  Egrave: 'È',
  Eacute: 'É',
  Ecirc: 'Ê',
  Euml: 'Ë',
  Igrave: 'Ì',
  Iacute: 'Í',
  Icirc: 'Î',
  Iuml: 'Ï',
  ETH: 'Ð',
  Ntilde: 'Ñ',
  Ograve: 'Ò',
  Oacute: 'Ó',
  Ocirc: 'Ô',
  Otilde: 'Õ',
  Ouml: 'Ö',
  times: '×',
  Oslash: 'Ø',
  Ugrave: 'Ù',
  Uacute: 'Ú',
  Ucirc: 'Û',
  Uuml: 'Ü',
  Yacute: 'Ý',
  THORN: 'Þ',
  szlig: 'ß',
  agrave: 'à',
  aacute: 'á',
  acirc: 'â',
  atilde: 'ã',
  auml: 'ä',
  aring: 'å',
  aelig: 'æ',
  ccedil: 'ç',
  egrave: 'è',
  eacute: 'é',
  ecirc: 'ê',
  euml: 'ë',
  igrave: 'ì',
  iacute: 'í',
  icirc: 'î',
  iuml: 'ï',
  eth: 'ð',
  ntilde: 'ñ',
  ograve: 'ò',
  oacute: 'ó',
  ocirc: 'ô',
  otilde: 'õ',
  ouml: 'ö',
  divide: '÷',
  oslash: 'ø',
  ugrave: 'ù',
  uacute: 'ú',
  ucirc: 'û',
  uuml: 'ü',
  yacute: 'ý',
  thorn: 'þ',
  yuml: 'ÿ',
  OElig: 'Œ',
  oelig: 'œ',
  Scaron: 'Š',
  scaron: 'š',
  Yuml: 'Ÿ',
  fnof: 'ƒ',
  circ: 'ˆ',
  tilde: '˜',
  Alpha: 'Α',
  Beta: 'Β',
  Gamma: 'Γ',
  Delta: 'Δ',
  Epsilon: 'Ε',
  Zeta: 'Ζ',
  Eta: 'Η',
  Theta: 'Θ',
  Iota: 'Ι',
  Kappa: 'Κ',
  Lambda: 'Λ',
  Mu: 'Μ',
  Nu: 'Ν',
  Xi: 'Ξ',
  Omicron: 'Ο',
  Pi: 'Π',
  Rho: 'Ρ',
  Sigma: 'Σ',
  Tau: 'Τ',
  Upsilon: 'Υ',
  Phi: 'Φ',
  Chi: 'Χ',
  Psi: 'Ψ',
  Omega: 'Ω',
  alpha: 'α',
  beta: 'β',
  gamma: 'γ',
  delta: 'δ',
  epsilon: 'ε',
  zeta: 'ζ',
  eta: 'η',
  theta: 'θ',
  iota: 'ι',
  kappa: 'κ',
  lambda: 'λ',
  mu: 'μ',
  nu: 'ν',
  xi: 'ξ',
  omicron: 'ο',
  pi: 'π',
  rho: 'ρ',
  sigmaf: 'ς',
  sigma: 'σ',
  tau: 'τ',
  upsilon: 'υ',
  phi: 'φ',
  chi: 'χ',
  psi: 'ψ',
  omega: 'ω',
  thetasym: 'ϑ',
  upsih: 'ϒ',
  piv: 'ϖ',
  ensp: ' ',
  emsp: ' ',
  thinsp: ' ',
  zwnj: '‌',
  zwj: '‍',
  lrm: '‎',
  rlm: '‏',
  ndash: '–',
  mdash: '—',
  lsquo: '‘',
  rsquo: '’',
  sbquo: '‚',
  ldquo: '“',
  rdquo: '”',
  bdquo: '„',
  dagger: '†',
  Dagger: '‡',
  bull: '•',
  hellip: '…',
  permil: '‰',
  prime: '′',
  Prime: '″',
  lsaquo: '‹',
  rsaquo: '›',
  oline: '‾',
  frasl: '⁄',
  euro: '€',
  image: 'ℑ',
  weierp: '℘',
  real: 'ℜ',
  trade: '™',
  alefsym: 'ℵ',
  larr: '←',
  uarr: '↑',
  rarr: '→',
  darr: '↓',
  harr: '↔',
  crarr: '↵',
  lArr: '⇐',
  uArr: '⇑',
  rArr: '⇒',
  dArr: '⇓',
  hArr: '⇔',
  forall: '∀',
  part: '∂',
  exist: '∃',
  empty: '∅',
  nabla: '∇',
  isin: '∈',
  notin: '∉',
  ni: '∋',
  prod: '∏',
  sum: '∑',
  minus: '−',
  lowast: '∗',
  radic: '√',
  prop: '∝',
  infin: '∞',
  ang: '∠',
  and: '∧',
  or: '∨',
  cap: '∩',
  cup: '∪',
  int: '∫',
  there4: '∴',
  sim: '∼',
  cong: '≅',
  asymp: '≈',
  ne: '≠',
  equiv: '≡',
  le: '≤',
  ge: '≥',
  sub: '⊂',
  sup: '⊃',
  nsub: '⊄',
  sube: '⊆',
  supe: '⊇',
  oplus: '⊕',
  otimes: '⊗',
  perp: '⊥',
  sdot: '⋅',
  lceil: '⌈',
  rceil: '⌉',
  lfloor: '⌊',
  rfloor: '⌋',
  lang: '〈',
  rang: '〉',
  loz: '◊',
  spades: '♠',
  clubs: '♣',
  hearts: '♥',
  diams: '♦',
};
const JsxErrors = ParseErrorEnum`jsx`({
  AttributeIsEmpty:
    'JSX attributes must only be assigned a non-empty expression.',
  MissingClosingTagElement: ({openingTagName: openingTagName}) =>
    `Expected corresponding JSX closing tag for <${openingTagName}>.`,
  MissingClosingTagFragment: 'Expected corresponding JSX closing tag for <>.',
  UnexpectedSequenceExpression:
    'Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?',
  UnexpectedToken: ({unexpected: unexpected, HTMLEntity: HTMLEntity}) =>
    `Unexpected token \`${unexpected}\`. Did you mean \`${HTMLEntity}\` or \`{'${unexpected}'}\`?`,
  UnsupportedJsxValue:
    'JSX value should be either an expression or a quoted JSX text.',
  UnterminatedJsxContent: 'Unterminated JSX contents.',
  UnwrappedAdjacentJSXElements:
    'Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?',
});
function isFragment(object) {
  return object
    ? object.type === 'JSXOpeningFragment' ||
        object.type === 'JSXClosingFragment'
    : false;
}
function getQualifiedJSXName(object) {
  if (object.type === 'JSXIdentifier') {
    return object.name;
  }
  if (object.type === 'JSXNamespacedName') {
    return object.namespace.name + ':' + object.name.name;
  }
  if (object.type === 'JSXMemberExpression') {
    return (
      getQualifiedJSXName(object.object) +
      '.' +
      getQualifiedJSXName(object.property)
    );
  }
  throw new Error('Node had unexpected type: ' + object.type);
}
var jsx$2 = superClass =>
  class JSXParserMixin extends superClass {
    jsxReadToken() {
      let out = '';
      let chunkStart = this.state.pos;
      for (;;) {
        if (this.state.pos >= this.length) {
          throw this.raise(JsxErrors.UnterminatedJsxContent, {
            at: this.state.startLoc,
          });
        }
        const ch = this.input.charCodeAt(this.state.pos);
        switch (ch) {
          case 60:
          case 123:
            if (this.state.pos === this.state.start) {
              if (ch === 60 && this.state.canStartJSXElement) {
                ++this.state.pos;
                return this.finishToken(138);
              }
              return super.getTokenFromCode(ch);
            }
            out += this.input.slice(chunkStart, this.state.pos);
            return this.finishToken(137, out);
          case 38:
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadEntity();
            chunkStart = this.state.pos;
            break;
          case 62:
          case 125:
          default:
            if (isNewLine(ch)) {
              out += this.input.slice(chunkStart, this.state.pos);
              out += this.jsxReadNewLine(true);
              chunkStart = this.state.pos;
            } else {
              ++this.state.pos;
            }
        }
      }
    }
    jsxReadNewLine(normalizeCRLF) {
      const ch = this.input.charCodeAt(this.state.pos);
      let out;
      ++this.state.pos;
      if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
        ++this.state.pos;
        out = normalizeCRLF ? '\n' : '\r\n';
      } else {
        out = String.fromCharCode(ch);
      }
      ++this.state.curLine;
      this.state.lineStart = this.state.pos;
      return out;
    }
    jsxReadString(quote) {
      let out = '';
      let chunkStart = ++this.state.pos;
      for (;;) {
        if (this.state.pos >= this.length) {
          throw this.raise(Errors.UnterminatedString, {
            at: this.state.startLoc,
          });
        }
        const ch = this.input.charCodeAt(this.state.pos);
        if (ch === quote) break;
        if (ch === 38) {
          out += this.input.slice(chunkStart, this.state.pos);
          out += this.jsxReadEntity();
          chunkStart = this.state.pos;
        } else if (isNewLine(ch)) {
          out += this.input.slice(chunkStart, this.state.pos);
          out += this.jsxReadNewLine(false);
          chunkStart = this.state.pos;
        } else {
          ++this.state.pos;
        }
      }
      out += this.input.slice(chunkStart, this.state.pos++);
      return this.finishToken(129, out);
    }
    jsxReadEntity() {
      const startPos = ++this.state.pos;
      if (this.codePointAtPos(this.state.pos) === 35) {
        ++this.state.pos;
        let radix = 10;
        if (this.codePointAtPos(this.state.pos) === 120) {
          radix = 16;
          ++this.state.pos;
        }
        const codePoint = this.readInt(radix, undefined, false, 'bail');
        if (codePoint !== null && this.codePointAtPos(this.state.pos) === 59) {
          ++this.state.pos;
          return String.fromCodePoint(codePoint);
        }
      } else {
        let count = 0;
        let semi = false;
        while (
          count++ < 10 &&
          this.state.pos < this.length &&
          !(semi = this.codePointAtPos(this.state.pos) == 59)
        ) {
          ++this.state.pos;
        }
        if (semi) {
          const desc = this.input.slice(startPos, this.state.pos);
          const entity = entities[desc];
          ++this.state.pos;
          if (entity) {
            return entity;
          }
        }
      }
      this.state.pos = startPos;
      return '&';
    }
    jsxReadWord() {
      let ch;
      const start = this.state.pos;
      do {
        ch = this.input.charCodeAt(++this.state.pos);
      } while (isIdentifierChar(ch) || ch === 45);
      return this.finishToken(136, this.input.slice(start, this.state.pos));
    }
    jsxParseIdentifier() {
      const node = this.startNode();
      if (this.match(136)) {
        node.name = this.state.value;
      } else if (tokenIsKeyword(this.state.type)) {
        node.name = tokenLabelName(this.state.type);
      } else {
        this.unexpected();
      }
      this.next();
      return this.finishNode(node, 'JSXIdentifier');
    }
    jsxParseNamespacedName() {
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      const name = this.jsxParseIdentifier();
      if (!this.eat(14)) return name;
      const node = this.startNodeAt(startPos, startLoc);
      node.namespace = name;
      node.name = this.jsxParseIdentifier();
      return this.finishNode(node, 'JSXNamespacedName');
    }
    jsxParseElementName() {
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      let node = this.jsxParseNamespacedName();
      if (node.type === 'JSXNamespacedName') {
        return node;
      }
      while (this.eat(16)) {
        const newNode = this.startNodeAt(startPos, startLoc);
        newNode.object = node;
        newNode.property = this.jsxParseIdentifier();
        node = this.finishNode(newNode, 'JSXMemberExpression');
      }
      return node;
    }
    jsxParseAttributeValue() {
      let node;
      switch (this.state.type) {
        case 5:
          node = this.startNode();
          this.setContext(types$2.brace);
          this.next();
          node = this.jsxParseExpressionContainer(node, types$2.j_oTag);
          if (node.expression.type === 'JSXEmptyExpression') {
            this.raise(JsxErrors.AttributeIsEmpty, {at: node});
          }
          return node;
        case 138:
        case 129:
          return this.parseExprAtom();
        default:
          throw this.raise(JsxErrors.UnsupportedJsxValue, {
            at: this.state.startLoc,
          });
      }
    }
    jsxParseEmptyExpression() {
      const node = this.startNodeAt(
        this.state.lastTokEndLoc.index,
        this.state.lastTokEndLoc
      );
      return this.finishNodeAt(node, 'JSXEmptyExpression', this.state.startLoc);
    }
    jsxParseSpreadChild(node) {
      this.next();
      node.expression = this.parseExpression();
      this.setContext(types$2.j_oTag);
      this.state.canStartJSXElement = true;
      this.expect(8);
      return this.finishNode(node, 'JSXSpreadChild');
    }
    jsxParseExpressionContainer(node, previousContext) {
      if (this.match(8)) {
        node.expression = this.jsxParseEmptyExpression();
      } else {
        const expression = this.parseExpression();
        node.expression = expression;
      }
      this.setContext(previousContext);
      this.state.canStartJSXElement = true;
      this.expect(8);
      return this.finishNode(node, 'JSXExpressionContainer');
    }
    jsxParseAttribute() {
      const node = this.startNode();
      if (this.match(5)) {
        this.setContext(types$2.brace);
        this.next();
        this.expect(21);
        node.argument = this.parseMaybeAssignAllowIn();
        this.setContext(types$2.j_oTag);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXSpreadAttribute');
      }
      node.name = this.jsxParseNamespacedName();
      node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
      return this.finishNode(node, 'JSXAttribute');
    }
    jsxParseOpeningElementAt(startPos, startLoc) {
      const node = this.startNodeAt(startPos, startLoc);
      if (this.eat(139)) {
        return this.finishNode(node, 'JSXOpeningFragment');
      }
      node.name = this.jsxParseElementName();
      return this.jsxParseOpeningElementAfterName(node);
    }
    jsxParseOpeningElementAfterName(node) {
      const attributes = [];
      while (!this.match(56) && !this.match(139)) {
        attributes.push(this.jsxParseAttribute());
      }
      node.attributes = attributes;
      node.selfClosing = this.eat(56);
      this.expect(139);
      return this.finishNode(node, 'JSXOpeningElement');
    }
    jsxParseClosingElementAt(startPos, startLoc) {
      const node = this.startNodeAt(startPos, startLoc);
      if (this.eat(139)) {
        return this.finishNode(node, 'JSXClosingFragment');
      }
      node.name = this.jsxParseElementName();
      this.expect(139);
      return this.finishNode(node, 'JSXClosingElement');
    }
    jsxParseElementAt(startPos, startLoc) {
      const node = this.startNodeAt(startPos, startLoc);
      const children = [];
      const openingElement = this.jsxParseOpeningElementAt(startPos, startLoc);
      let closingElement = null;
      if (!openingElement.selfClosing) {
        contents: for (;;) {
          switch (this.state.type) {
            case 138:
              startPos = this.state.start;
              startLoc = this.state.startLoc;
              this.next();
              if (this.eat(56)) {
                closingElement = this.jsxParseClosingElementAt(
                  startPos,
                  startLoc
                );
                break contents;
              }
              children.push(this.jsxParseElementAt(startPos, startLoc));
              break;
            case 137:
              children.push(this.parseExprAtom());
              break;
            case 5: {
              const node = this.startNode();
              this.setContext(types$2.brace);
              this.next();
              if (this.match(21)) {
                children.push(this.jsxParseSpreadChild(node));
              } else {
                children.push(
                  this.jsxParseExpressionContainer(node, types$2.j_expr)
                );
              }
              break;
            }
            default:
              throw this.unexpected();
          }
        }
        if (
          isFragment(openingElement) &&
          !isFragment(closingElement) &&
          closingElement !== null
        ) {
          this.raise(JsxErrors.MissingClosingTagFragment, {at: closingElement});
        } else if (!isFragment(openingElement) && isFragment(closingElement)) {
          this.raise(JsxErrors.MissingClosingTagElement, {
            at: closingElement,
            openingTagName: getQualifiedJSXName(openingElement.name),
          });
        } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
          if (
            getQualifiedJSXName(closingElement.name) !==
            getQualifiedJSXName(openingElement.name)
          ) {
            this.raise(JsxErrors.MissingClosingTagElement, {
              at: closingElement,
              openingTagName: getQualifiedJSXName(openingElement.name),
            });
          }
        }
      }
      if (isFragment(openingElement)) {
        node.openingFragment = openingElement;
        node.closingFragment = closingElement;
      } else {
        node.openingElement = openingElement;
        node.closingElement = closingElement;
      }
      node.children = children;
      if (this.match(47)) {
        throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, {
          at: this.state.startLoc,
        });
      }
      return isFragment(openingElement)
        ? this.finishNode(node, 'JSXFragment')
        : this.finishNode(node, 'JSXElement');
    }
    jsxParseElement() {
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      this.next();
      return this.jsxParseElementAt(startPos, startLoc);
    }
    setContext(newContext) {
      const {context: context} = this.state;
      context[context.length - 1] = newContext;
    }
    parseExprAtom(refExpressionErrors) {
      if (this.match(137)) {
        return this.parseLiteral(this.state.value, 'JSXText');
      } else if (this.match(138)) {
        return this.jsxParseElement();
      } else if (
        this.match(47) &&
        this.input.charCodeAt(this.state.pos) !== 33
      ) {
        this.replaceToken(138);
        return this.jsxParseElement();
      } else {
        return super.parseExprAtom(refExpressionErrors);
      }
    }
    skipSpace() {
      const curContext = this.curContext();
      if (!curContext.preserveSpace) super.skipSpace();
    }
    getTokenFromCode(code) {
      const context = this.curContext();
      if (context === types$2.j_expr) {
        return this.jsxReadToken();
      }
      if (context === types$2.j_oTag || context === types$2.j_cTag) {
        if (isIdentifierStart(code)) {
          return this.jsxReadWord();
        }
        if (code === 62) {
          ++this.state.pos;
          return this.finishToken(139);
        }
        if ((code === 34 || code === 39) && context === types$2.j_oTag) {
          return this.jsxReadString(code);
        }
      }
      if (
        code === 60 &&
        this.state.canStartJSXElement &&
        this.input.charCodeAt(this.state.pos + 1) !== 33
      ) {
        ++this.state.pos;
        return this.finishToken(138);
      }
      return super.getTokenFromCode(code);
    }
    updateContext(prevType) {
      const {context: context, type: type} = this.state;
      if (type === 56 && prevType === 138) {
        context.splice(-2, 2, types$2.j_cTag);
        this.state.canStartJSXElement = false;
      } else if (type === 138) {
        context.push(types$2.j_oTag);
      } else if (type === 139) {
        const out = context[context.length - 1];
        if (
          (out === types$2.j_oTag && prevType === 56) ||
          out === types$2.j_cTag
        ) {
          context.pop();
          this.state.canStartJSXElement =
            context[context.length - 1] === types$2.j_expr;
        } else {
          this.setContext(types$2.j_expr);
          this.state.canStartJSXElement = true;
        }
      } else {
        this.state.canStartJSXElement = tokenComesBeforeExpression(type);
      }
    }
  };
class TypeScriptScope extends Scope {
  constructor(...args) {
    super(...args);
    this.types = new Set();
    this.enums = new Set();
    this.constEnums = new Set();
    this.classes = new Set();
    this.exportOnlyBindings = new Set();
  }
}
class TypeScriptScopeHandler extends ScopeHandler {
  constructor(...args) {
    super(...args);
    this.importsStack = [];
  }
  createScope(flags) {
    this.importsStack.push(new Set());
    return new TypeScriptScope(flags);
  }
  enter(flags) {
    if (flags == SCOPE_TS_MODULE) {
      this.importsStack.push(new Set());
    }
    super.enter(flags);
  }
  exit() {
    const flags = super.exit();
    if (flags == SCOPE_TS_MODULE) {
      this.importsStack.pop();
    }
    return flags;
  }
  hasImport(name, allowShadow) {
    const len = this.importsStack.length;
    if (this.importsStack[len - 1].has(name)) {
      return true;
    }
    if (!allowShadow && len > 1) {
      for (let i = 0; i < len - 1; i++) {
        if (this.importsStack[i].has(name)) return true;
      }
    }
    return false;
  }
  declareName(name, bindingType, loc) {
    if (bindingType & BIND_FLAGS_TS_IMPORT) {
      if (this.hasImport(name, true)) {
        this.parser.raise(Errors.VarRedeclaration, {
          at: loc,
          identifierName: name,
        });
      }
      this.importsStack[this.importsStack.length - 1].add(name);
      return;
    }
    const scope = this.currentScope();
    if (bindingType & BIND_FLAGS_TS_EXPORT_ONLY) {
      this.maybeExportDefined(scope, name);
      scope.exportOnlyBindings.add(name);
      return;
    }
    super.declareName(name, bindingType, loc);
    if (bindingType & BIND_KIND_TYPE) {
      if (!(bindingType & BIND_KIND_VALUE)) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        this.maybeExportDefined(scope, name);
      }
      scope.types.add(name);
    }
    if (bindingType & BIND_FLAGS_TS_ENUM) scope.enums.add(name);
    if (bindingType & BIND_FLAGS_TS_CONST_ENUM) scope.constEnums.add(name);
    if (bindingType & BIND_FLAGS_CLASS) scope.classes.add(name);
  }
  isRedeclaredInScope(scope, name, bindingType) {
    if (scope.enums.has(name)) {
      if (bindingType & BIND_FLAGS_TS_ENUM) {
        const isConst = !!(bindingType & BIND_FLAGS_TS_CONST_ENUM);
        const wasConst = scope.constEnums.has(name);
        return isConst !== wasConst;
      }
      return true;
    }
    if (bindingType & BIND_FLAGS_CLASS && scope.classes.has(name)) {
      if (scope.lexical.has(name)) {
        return !!(bindingType & BIND_KIND_VALUE);
      } else {
        return false;
      }
    }
    if (bindingType & BIND_KIND_TYPE && scope.types.has(name)) {
      return true;
    }
    return super.isRedeclaredInScope(scope, name, bindingType);
  }
  checkLocalExport(id) {
    const topLevelScope = this.scopeStack[0];
    const {name: name} = id;
    if (
      !topLevelScope.types.has(name) &&
      !topLevelScope.exportOnlyBindings.has(name) &&
      !this.hasImport(name)
    ) {
      super.checkLocalExport(id);
    }
  }
}
const getOwn$1 = (object, key) =>
  Object.hasOwnProperty.call(object, key) && object[key];
function nonNull$1(x) {
  if (x == null) {
    throw new Error(`Unexpected ${x} value.`);
  }
  return x;
}
function assert$2(x) {
  if (!x) {
    throw new Error('Assert fail');
  }
}
const TSErrors = ParseErrorEnum`typescript`({
  AbstractMethodHasImplementation: ({methodName: methodName}) =>
    `Method '${methodName}' cannot have an implementation because it is marked abstract.`,
  AbstractPropertyHasInitializer: ({propertyName: propertyName}) =>
    `Property '${propertyName}' cannot have an initializer because it is marked abstract.`,
  AccesorCannotDeclareThisParameter:
    "'get' and 'set' accessors cannot declare 'this' parameters.",
  AccesorCannotHaveTypeParameters: 'An accessor cannot have type parameters.',
  CannotFindName: ({name: name}) => `Cannot find name '${name}'.`,
  ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
  ClassMethodHasReadonly: "Class methods cannot have the 'readonly' modifier.",
  ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference:
    "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
  ConstructorHasTypeParameters:
    'Type parameters cannot appear on a constructor declaration.',
  DeclareAccessor: ({kind: kind}) => `'declare' is not allowed in ${kind}ters.`,
  DeclareClassFieldHasInitializer:
    'Initializers are not allowed in ambient contexts.',
  DeclareFunctionHasImplementation:
    'An implementation cannot be declared in ambient contexts.',
  DuplicateAccessibilityModifier: ({modifier: modifier}) =>
    `Accessibility modifier already seen.`,
  DuplicateModifier: ({modifier: modifier}) =>
    `Duplicate modifier: '${modifier}'.`,
  EmptyHeritageClauseType: ({token: token}) =>
    `'${token}' list cannot be empty.`,
  EmptyTypeArguments: 'Type argument list cannot be empty.',
  EmptyTypeParameters: 'Type parameter list cannot be empty.',
  ExpectedAmbientAfterExportDeclare:
    "'export declare' must be followed by an ambient declaration.",
  ImportAliasHasImportType: "An import alias can not use 'import type'.",
  IncompatibleModifiers: ({modifiers: modifiers}) =>
    `'${modifiers[0]}' modifier cannot be used with '${modifiers[1]}' modifier.`,
  IndexSignatureHasAbstract:
    "Index signatures cannot have the 'abstract' modifier.",
  IndexSignatureHasAccessibility: ({modifier: modifier}) =>
    `Index signatures cannot have an accessibility modifier ('${modifier}').`,
  IndexSignatureHasDeclare:
    "Index signatures cannot have the 'declare' modifier.",
  IndexSignatureHasOverride:
    "'override' modifier cannot appear on an index signature.",
  IndexSignatureHasStatic:
    "Index signatures cannot have the 'static' modifier.",
  InitializerNotAllowedInAmbientContext:
    'Initializers are not allowed in ambient contexts.',
  InvalidModifierOnTypeMember: ({modifier: modifier}) =>
    `'${modifier}' modifier cannot appear on a type member.`,
  InvalidModifierOnTypeParameter: ({modifier: modifier}) =>
    `'${modifier}' modifier cannot appear on a type parameter.`,
  InvalidModifierOnTypeParameterPositions: ({modifier: modifier}) =>
    `'${modifier}' modifier can only appear on a type parameter of a class, interface or type alias.`,
  InvalidModifiersOrder: ({orderedModifiers: orderedModifiers}) =>
    `'${orderedModifiers[0]}' modifier must precede '${orderedModifiers[1]}' modifier.`,
  InvalidPropertyAccessAfterInstantiationExpression:
    'Invalid property access after an instantiation expression. ' +
    'You can either wrap the instantiation expression in parentheses, or delete the type arguments.',
  InvalidTupleMemberLabel:
    'Tuple members must be labeled with a simple identifier.',
  MissingInterfaceName:
    "'interface' declarations must be followed by an identifier.",
  MixedLabeledAndUnlabeledElements:
    'Tuple members must all have names or all not have names.',
  NonAbstractClassHasAbstractMethod:
    'Abstract methods can only appear within an abstract class.',
  NonClassMethodPropertyHasAbstractModifer:
    "'abstract' modifier can only appear on a class, method, or property declaration.",
  OptionalTypeBeforeRequired:
    'A required element cannot follow an optional element.',
  OverrideNotInSubClass:
    "This member cannot have an 'override' modifier because its containing class does not extend another class.",
  PatternIsOptional:
    'A binding pattern parameter cannot be optional in an implementation signature.',
  PrivateElementHasAbstract:
    "Private elements cannot have the 'abstract' modifier.",
  PrivateElementHasAccessibility: ({modifier: modifier}) =>
    `Private elements cannot have an accessibility modifier ('${modifier}').`,
  ReadonlyForMethodSignature:
    "'readonly' modifier can only appear on a property declaration or index signature.",
  ReservedArrowTypeParam:
    'This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.',
  ReservedTypeAssertion:
    'This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.',
  SetAccesorCannotHaveOptionalParameter:
    "A 'set' accessor cannot have an optional parameter.",
  SetAccesorCannotHaveRestParameter:
    "A 'set' accessor cannot have rest parameter.",
  SetAccesorCannotHaveReturnType:
    "A 'set' accessor cannot have a return type annotation.",
  SingleTypeParameterWithoutTrailingComma: ({
    typeParameterName: typeParameterName,
  }) =>
    `Single type parameter ${typeParameterName} should have a trailing comma. Example usage: <${typeParameterName},>.`,
  StaticBlockCannotHaveModifier:
    'Static class blocks cannot have any modifier.',
  TypeAnnotationAfterAssign:
    'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
  TypeImportCannotSpecifyDefaultAndNamed:
    'A type-only import can specify a default import or named bindings, but not both.',
  TypeModifierIsUsedInTypeExports:
    "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
  TypeModifierIsUsedInTypeImports:
    "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
  UnexpectedParameterModifier:
    'A parameter property is only allowed in a constructor implementation.',
  UnexpectedReadonly:
    "'readonly' type modifier is only permitted on array and tuple literal types.",
  UnexpectedTypeAnnotation: 'Did not expect a type annotation here.',
  UnexpectedTypeCastInParameter: 'Unexpected type cast in parameter position.',
  UnsupportedImportTypeArgument:
    'Argument in a type import must be a string literal.',
  UnsupportedParameterPropertyKind:
    'A parameter property may not be declared using a binding pattern.',
  UnsupportedSignatureParameterKind: ({type: type}) =>
    `Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ${type}.`,
});
function keywordTypeFromName(value) {
  switch (value) {
    case 'any':
      return 'TSAnyKeyword';
    case 'boolean':
      return 'TSBooleanKeyword';
    case 'bigint':
      return 'TSBigIntKeyword';
    case 'never':
      return 'TSNeverKeyword';
    case 'number':
      return 'TSNumberKeyword';
    case 'object':
      return 'TSObjectKeyword';
    case 'string':
      return 'TSStringKeyword';
    case 'symbol':
      return 'TSSymbolKeyword';
    case 'undefined':
      return 'TSUndefinedKeyword';
    case 'unknown':
      return 'TSUnknownKeyword';
    default:
      return undefined;
  }
}
function tsIsAccessModifier(modifier) {
  return (
    modifier === 'private' || modifier === 'public' || modifier === 'protected'
  );
}
function tsIsVarianceAnnotations(modifier) {
  return modifier === 'in' || modifier === 'out';
}
var typescript$2 = superClass =>
  class TypeScriptParserMixin extends superClass {
    getScopeHandler() {
      return TypeScriptScopeHandler;
    }
    tsIsIdentifier() {
      return tokenIsIdentifier(this.state.type);
    }
    tsTokenCanFollowModifier() {
      return (
        (this.match(0) ||
          this.match(5) ||
          this.match(55) ||
          this.match(21) ||
          this.match(134) ||
          this.isLiteralPropertyName()) &&
        !this.hasPrecedingLineBreak()
      );
    }
    tsNextTokenCanFollowModifier() {
      this.next();
      return this.tsTokenCanFollowModifier();
    }
    tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
      if (!tokenIsIdentifier(this.state.type) && this.state.type !== 58) {
        return undefined;
      }
      const modifier = this.state.value;
      if (allowedModifiers.indexOf(modifier) !== -1) {
        if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
          return undefined;
        }
        if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
          return modifier;
        }
      }
      return undefined;
    }
    tsParseModifiers({
      modified: modified,
      allowedModifiers: allowedModifiers,
      disallowedModifiers: disallowedModifiers,
      stopOnStartOfClassStaticBlock: stopOnStartOfClassStaticBlock,
      errorTemplate: errorTemplate = TSErrors.InvalidModifierOnTypeMember,
    }) {
      const enforceOrder = (loc, modifier, before, after) => {
        if (modifier === before && modified[after]) {
          this.raise(TSErrors.InvalidModifiersOrder, {
            at: loc,
            orderedModifiers: [before, after],
          });
        }
      };
      const incompatible = (loc, modifier, mod1, mod2) => {
        if (
          (modified[mod1] && modifier === mod2) ||
          (modified[mod2] && modifier === mod1)
        ) {
          this.raise(TSErrors.IncompatibleModifiers, {
            at: loc,
            modifiers: [mod1, mod2],
          });
        }
      };
      for (;;) {
        const {startLoc: startLoc} = this.state;
        const modifier = this.tsParseModifier(
          allowedModifiers.concat(
            disallowedModifiers != null ? disallowedModifiers : []
          ),
          stopOnStartOfClassStaticBlock
        );
        if (!modifier) break;
        if (tsIsAccessModifier(modifier)) {
          if (modified.accessibility) {
            this.raise(TSErrors.DuplicateAccessibilityModifier, {
              at: startLoc,
              modifier: modifier,
            });
          } else {
            enforceOrder(startLoc, modifier, modifier, 'override');
            enforceOrder(startLoc, modifier, modifier, 'static');
            enforceOrder(startLoc, modifier, modifier, 'readonly');
            modified.accessibility = modifier;
          }
        } else if (tsIsVarianceAnnotations(modifier)) {
          if (modified[modifier]) {
            this.raise(TSErrors.DuplicateModifier, {
              at: startLoc,
              modifier: modifier,
            });
          }
          modified[modifier] = true;
          enforceOrder(startLoc, modifier, 'in', 'out');
        } else {
          if (Object.hasOwnProperty.call(modified, modifier)) {
            this.raise(TSErrors.DuplicateModifier, {
              at: startLoc,
              modifier: modifier,
            });
          } else {
            enforceOrder(startLoc, modifier, 'static', 'readonly');
            enforceOrder(startLoc, modifier, 'static', 'override');
            enforceOrder(startLoc, modifier, 'override', 'readonly');
            enforceOrder(startLoc, modifier, 'abstract', 'override');
            incompatible(startLoc, modifier, 'declare', 'override');
            incompatible(startLoc, modifier, 'static', 'abstract');
          }
          modified[modifier] = true;
        }
        if (
          disallowedModifiers != null &&
          disallowedModifiers.includes(modifier)
        ) {
          this.raise(errorTemplate, {at: startLoc, modifier: modifier});
        }
      }
    }
    tsIsListTerminator(kind) {
      switch (kind) {
        case 'EnumMembers':
        case 'TypeMembers':
          return this.match(8);
        case 'HeritageClauseElement':
          return this.match(5);
        case 'TupleElementTypes':
          return this.match(3);
        case 'TypeParametersOrArguments':
          return this.match(48);
      }
      throw new Error('Unreachable');
    }
    tsParseList(kind, parseElement) {
      const result = [];
      while (!this.tsIsListTerminator(kind)) {
        result.push(parseElement());
      }
      return result;
    }
    tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
      return nonNull$1(
        this.tsParseDelimitedListWorker(
          kind,
          parseElement,
          true,
          refTrailingCommaPos
        )
      );
    }
    tsParseDelimitedListWorker(
      kind,
      parseElement,
      expectSuccess,
      refTrailingCommaPos
    ) {
      const result = [];
      let trailingCommaPos = -1;
      for (;;) {
        if (this.tsIsListTerminator(kind)) {
          break;
        }
        trailingCommaPos = -1;
        const element = parseElement();
        if (element == null) {
          return undefined;
        }
        result.push(element);
        if (this.eat(12)) {
          trailingCommaPos = this.state.lastTokStart;
          continue;
        }
        if (this.tsIsListTerminator(kind)) {
          break;
        }
        if (expectSuccess) {
          this.expect(12);
        }
        return undefined;
      }
      if (refTrailingCommaPos) {
        refTrailingCommaPos.value = trailingCommaPos;
      }
      return result;
    }
    tsParseBracketedList(
      kind,
      parseElement,
      bracket,
      skipFirstToken,
      refTrailingCommaPos
    ) {
      if (!skipFirstToken) {
        if (bracket) {
          this.expect(0);
        } else {
          this.expect(47);
        }
      }
      const result = this.tsParseDelimitedList(
        kind,
        parseElement,
        refTrailingCommaPos
      );
      if (bracket) {
        this.expect(3);
      } else {
        this.expect(48);
      }
      return result;
    }
    tsParseImportType() {
      const node = this.startNode();
      this.expect(83);
      this.expect(10);
      if (!this.match(129)) {
        this.raise(TSErrors.UnsupportedImportTypeArgument, {
          at: this.state.startLoc,
        });
      }
      node.argument = super.parseExprAtom();
      this.expect(11);
      if (this.eat(16)) {
        node.qualifier = this.tsParseEntityName();
      }
      if (this.match(47)) {
        node.typeParameters = this.tsParseTypeArguments();
      }
      return this.finishNode(node, 'TSImportType');
    }
    tsParseEntityName(allowReservedWords = true) {
      let entity = this.parseIdentifier(allowReservedWords);
      while (this.eat(16)) {
        const node = this.startNodeAtNode(entity);
        node.left = entity;
        node.right = this.parseIdentifier(allowReservedWords);
        entity = this.finishNode(node, 'TSQualifiedName');
      }
      return entity;
    }
    tsParseTypeReference() {
      const node = this.startNode();
      node.typeName = this.tsParseEntityName();
      if (!this.hasPrecedingLineBreak() && this.match(47)) {
        node.typeParameters = this.tsParseTypeArguments();
      }
      return this.finishNode(node, 'TSTypeReference');
    }
    tsParseThisTypePredicate(lhs) {
      this.next();
      const node = this.startNodeAtNode(lhs);
      node.parameterName = lhs;
      node.typeAnnotation = this.tsParseTypeAnnotation(false);
      node.asserts = false;
      return this.finishNode(node, 'TSTypePredicate');
    }
    tsParseThisTypeNode() {
      const node = this.startNode();
      this.next();
      return this.finishNode(node, 'TSThisType');
    }
    tsParseTypeQuery() {
      const node = this.startNode();
      this.expect(87);
      if (this.match(83)) {
        node.exprName = this.tsParseImportType();
      } else {
        node.exprName = this.tsParseEntityName();
      }
      if (!this.hasPrecedingLineBreak() && this.match(47)) {
        node.typeParameters = this.tsParseTypeArguments();
      }
      return this.finishNode(node, 'TSTypeQuery');
    }
    tsParseInOutModifiers(node) {
      this.tsParseModifiers({
        modified: node,
        allowedModifiers: ['in', 'out'],
        disallowedModifiers: [
          'public',
          'private',
          'protected',
          'readonly',
          'declare',
          'abstract',
          'override',
        ],
        errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
      });
    }
    tsParseNoneModifiers(node) {
      this.tsParseModifiers({
        modified: node,
        allowedModifiers: [],
        disallowedModifiers: ['in', 'out'],
        errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
      });
    }
    tsParseTypeParameter(
      parseModifiers = this.tsParseNoneModifiers.bind(this)
    ) {
      const node = this.startNode();
      parseModifiers(node);
      node.name = this.tsParseTypeParameterName();
      node.constraint = this.tsEatThenParseType(81);
      node.default = this.tsEatThenParseType(29);
      return this.finishNode(node, 'TSTypeParameter');
    }
    tsTryParseTypeParameters(parseModifiers) {
      if (this.match(47)) {
        return this.tsParseTypeParameters(parseModifiers);
      }
    }
    tsParseTypeParameters(parseModifiers) {
      const node = this.startNode();
      if (this.match(47) || this.match(138)) {
        this.next();
      } else {
        this.unexpected();
      }
      const refTrailingCommaPos = {value: -1};
      node.params = this.tsParseBracketedList(
        'TypeParametersOrArguments',
        this.tsParseTypeParameter.bind(this, parseModifiers),
        false,
        true,
        refTrailingCommaPos
      );
      if (node.params.length === 0) {
        this.raise(TSErrors.EmptyTypeParameters, {at: node});
      }
      if (refTrailingCommaPos.value !== -1) {
        this.addExtra(node, 'trailingComma', refTrailingCommaPos.value);
      }
      return this.finishNode(node, 'TSTypeParameterDeclaration');
    }
    tsTryNextParseConstantContext() {
      if (this.lookahead().type !== 75) return null;
      this.next();
      const typeReference = this.tsParseTypeReference();
      if (typeReference.typeParameters) {
        this.raise(TSErrors.CannotFindName, {
          at: typeReference.typeName,
          name: 'const',
        });
      }
      return typeReference;
    }
    tsFillSignature(returnToken, signature) {
      const returnTokenRequired = returnToken === 19;
      const paramsKey = 'parameters';
      const returnTypeKey = 'typeAnnotation';
      signature.typeParameters = this.tsTryParseTypeParameters();
      this.expect(10);
      signature[paramsKey] = this.tsParseBindingListForSignature();
      if (returnTokenRequired) {
        signature[returnTypeKey] =
          this.tsParseTypeOrTypePredicateAnnotation(returnToken);
      } else if (this.match(returnToken)) {
        signature[returnTypeKey] =
          this.tsParseTypeOrTypePredicateAnnotation(returnToken);
      }
    }
    tsParseBindingListForSignature() {
      return super.parseBindingList(11, 41).map(pattern => {
        if (
          pattern.type !== 'Identifier' &&
          pattern.type !== 'RestElement' &&
          pattern.type !== 'ObjectPattern' &&
          pattern.type !== 'ArrayPattern'
        ) {
          this.raise(TSErrors.UnsupportedSignatureParameterKind, {
            at: pattern,
            type: pattern.type,
          });
        }
        return pattern;
      });
    }
    tsParseTypeMemberSemicolon() {
      if (!this.eat(12) && !this.isLineTerminator()) {
        this.expect(13);
      }
    }
    tsParseSignatureMember(kind, node) {
      this.tsFillSignature(14, node);
      this.tsParseTypeMemberSemicolon();
      return this.finishNode(node, kind);
    }
    tsIsUnambiguouslyIndexSignature() {
      this.next();
      if (tokenIsIdentifier(this.state.type)) {
        this.next();
        return this.match(14);
      }
      return false;
    }
    tsTryParseIndexSignature(node) {
      if (
        !(
          this.match(0) &&
          this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this))
        )
      ) {
        return undefined;
      }
      this.expect(0);
      const id = this.parseIdentifier();
      id.typeAnnotation = this.tsParseTypeAnnotation();
      this.resetEndLocation(id);
      this.expect(3);
      node.parameters = [id];
      const type = this.tsTryParseTypeAnnotation();
      if (type) node.typeAnnotation = type;
      this.tsParseTypeMemberSemicolon();
      return this.finishNode(node, 'TSIndexSignature');
    }
    tsParsePropertyOrMethodSignature(node, readonly) {
      if (this.eat(17)) node.optional = true;
      const nodeAny = node;
      if (this.match(10) || this.match(47)) {
        if (readonly) {
          this.raise(TSErrors.ReadonlyForMethodSignature, {at: node});
        }
        const method = nodeAny;
        if (method.kind && this.match(47)) {
          this.raise(TSErrors.AccesorCannotHaveTypeParameters, {
            at: this.state.curPosition(),
          });
        }
        this.tsFillSignature(14, method);
        this.tsParseTypeMemberSemicolon();
        const paramsKey = 'parameters';
        const returnTypeKey = 'typeAnnotation';
        if (method.kind === 'get') {
          if (method[paramsKey].length > 0) {
            this.raise(Errors.BadGetterArity, {at: this.state.curPosition()});
            if (this.isThisParam(method[paramsKey][0])) {
              this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
                at: this.state.curPosition(),
              });
            }
          }
        } else if (method.kind === 'set') {
          if (method[paramsKey].length !== 1) {
            this.raise(Errors.BadSetterArity, {at: this.state.curPosition()});
          } else {
            const firstParameter = method[paramsKey][0];
            if (this.isThisParam(firstParameter)) {
              this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
                at: this.state.curPosition(),
              });
            }
            if (
              firstParameter.type === 'Identifier' &&
              firstParameter.optional
            ) {
              this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, {
                at: this.state.curPosition(),
              });
            }
            if (firstParameter.type === 'RestElement') {
              this.raise(TSErrors.SetAccesorCannotHaveRestParameter, {
                at: this.state.curPosition(),
              });
            }
          }
          if (method[returnTypeKey]) {
            this.raise(TSErrors.SetAccesorCannotHaveReturnType, {
              at: method[returnTypeKey],
            });
          }
        } else {
          method.kind = 'method';
        }
        return this.finishNode(method, 'TSMethodSignature');
      } else {
        const property = nodeAny;
        if (readonly) property.readonly = true;
        const type = this.tsTryParseTypeAnnotation();
        if (type) property.typeAnnotation = type;
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(property, 'TSPropertySignature');
      }
    }
    tsParseTypeMember() {
      const node = this.startNode();
      if (this.match(10) || this.match(47)) {
        return this.tsParseSignatureMember('TSCallSignatureDeclaration', node);
      }
      if (this.match(77)) {
        const id = this.startNode();
        this.next();
        if (this.match(10) || this.match(47)) {
          return this.tsParseSignatureMember(
            'TSConstructSignatureDeclaration',
            node
          );
        } else {
          node.key = this.createIdentifier(id, 'new');
          return this.tsParsePropertyOrMethodSignature(node, false);
        }
      }
      this.tsParseModifiers({
        modified: node,
        allowedModifiers: ['readonly'],
        disallowedModifiers: [
          'declare',
          'abstract',
          'private',
          'protected',
          'public',
          'static',
          'override',
        ],
      });
      const idx = this.tsTryParseIndexSignature(node);
      if (idx) {
        return idx;
      }
      super.parsePropertyName(node);
      if (
        !node.computed &&
        node.key.type === 'Identifier' &&
        (node.key.name === 'get' || node.key.name === 'set') &&
        this.tsTokenCanFollowModifier()
      ) {
        node.kind = node.key.name;
        super.parsePropertyName(node);
      }
      return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
    }
    tsParseTypeLiteral() {
      const node = this.startNode();
      node.members = this.tsParseObjectTypeMembers();
      return this.finishNode(node, 'TSTypeLiteral');
    }
    tsParseObjectTypeMembers() {
      this.expect(5);
      const members = this.tsParseList(
        'TypeMembers',
        this.tsParseTypeMember.bind(this)
      );
      this.expect(8);
      return members;
    }
    tsIsStartOfMappedType() {
      this.next();
      if (this.eat(53)) {
        return this.isContextual(118);
      }
      if (this.isContextual(118)) {
        this.next();
      }
      if (!this.match(0)) {
        return false;
      }
      this.next();
      if (!this.tsIsIdentifier()) {
        return false;
      }
      this.next();
      return this.match(58);
    }
    tsParseMappedTypeParameter() {
      const node = this.startNode();
      node.name = this.tsParseTypeParameterName();
      node.constraint = this.tsExpectThenParseType(58);
      return this.finishNode(node, 'TSTypeParameter');
    }
    tsParseMappedType() {
      const node = this.startNode();
      this.expect(5);
      if (this.match(53)) {
        node.readonly = this.state.value;
        this.next();
        this.expectContextual(118);
      } else if (this.eatContextual(118)) {
        node.readonly = true;
      }
      this.expect(0);
      node.typeParameter = this.tsParseMappedTypeParameter();
      node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
      this.expect(3);
      if (this.match(53)) {
        node.optional = this.state.value;
        this.next();
        this.expect(17);
      } else if (this.eat(17)) {
        node.optional = true;
      }
      node.typeAnnotation = this.tsTryParseType();
      this.semicolon();
      this.expect(8);
      return this.finishNode(node, 'TSMappedType');
    }
    tsParseTupleType() {
      const node = this.startNode();
      node.elementTypes = this.tsParseBracketedList(
        'TupleElementTypes',
        this.tsParseTupleElementType.bind(this),
        true,
        false
      );
      let seenOptionalElement = false;
      let labeledElements = null;
      node.elementTypes.forEach(elementNode => {
        var _labeledElements;
        const {type: type} = elementNode;
        if (
          seenOptionalElement &&
          type !== 'TSRestType' &&
          type !== 'TSOptionalType' &&
          !(type === 'TSNamedTupleMember' && elementNode.optional)
        ) {
          this.raise(TSErrors.OptionalTypeBeforeRequired, {at: elementNode});
        }
        seenOptionalElement ||
          (seenOptionalElement =
            (type === 'TSNamedTupleMember' && elementNode.optional) ||
            type === 'TSOptionalType');
        let checkType = type;
        if (type === 'TSRestType') {
          elementNode = elementNode.typeAnnotation;
          checkType = elementNode.type;
        }
        const isLabeled = checkType === 'TSNamedTupleMember';
        (_labeledElements = labeledElements) != null
          ? _labeledElements
          : (labeledElements = isLabeled);
        if (labeledElements !== isLabeled) {
          this.raise(TSErrors.MixedLabeledAndUnlabeledElements, {
            at: elementNode,
          });
        }
      });
      return this.finishNode(node, 'TSTupleType');
    }
    tsParseTupleElementType() {
      const {start: startPos, startLoc: startLoc} = this.state;
      const rest = this.eat(21);
      let type = this.tsParseType();
      const optional = this.eat(17);
      const labeled = this.eat(14);
      if (labeled) {
        const labeledNode = this.startNodeAtNode(type);
        labeledNode.optional = optional;
        if (
          type.type === 'TSTypeReference' &&
          !type.typeParameters &&
          type.typeName.type === 'Identifier'
        ) {
          labeledNode.label = type.typeName;
        } else {
          this.raise(TSErrors.InvalidTupleMemberLabel, {at: type});
          labeledNode.label = type;
        }
        labeledNode.elementType = this.tsParseType();
        type = this.finishNode(labeledNode, 'TSNamedTupleMember');
      } else if (optional) {
        const optionalTypeNode = this.startNodeAtNode(type);
        optionalTypeNode.typeAnnotation = type;
        type = this.finishNode(optionalTypeNode, 'TSOptionalType');
      }
      if (rest) {
        const restNode = this.startNodeAt(startPos, startLoc);
        restNode.typeAnnotation = type;
        type = this.finishNode(restNode, 'TSRestType');
      }
      return type;
    }
    tsParseParenthesizedType() {
      const node = this.startNode();
      this.expect(10);
      node.typeAnnotation = this.tsParseType();
      this.expect(11);
      return this.finishNode(node, 'TSParenthesizedType');
    }
    tsParseFunctionOrConstructorType(type, abstract) {
      const node = this.startNode();
      if (type === 'TSConstructorType') {
        node.abstract = !!abstract;
        if (abstract) this.next();
        this.next();
      }
      this.tsInAllowConditionalTypesContext(() =>
        this.tsFillSignature(19, node)
      );
      return this.finishNode(node, type);
    }
    tsParseLiteralTypeNode() {
      const node = this.startNode();
      node.literal = (() => {
        switch (this.state.type) {
          case 130:
          case 131:
          case 129:
          case 85:
          case 86:
            return super.parseExprAtom();
          default:
            throw this.unexpected();
        }
      })();
      return this.finishNode(node, 'TSLiteralType');
    }
    tsParseTemplateLiteralType() {
      const node = this.startNode();
      node.literal = super.parseTemplate(false);
      return this.finishNode(node, 'TSLiteralType');
    }
    parseTemplateSubstitution() {
      if (this.state.inType) return this.tsParseType();
      return super.parseTemplateSubstitution();
    }
    tsParseThisTypeOrThisTypePredicate() {
      const thisKeyword = this.tsParseThisTypeNode();
      if (this.isContextual(113) && !this.hasPrecedingLineBreak()) {
        return this.tsParseThisTypePredicate(thisKeyword);
      } else {
        return thisKeyword;
      }
    }
    tsParseNonArrayType() {
      switch (this.state.type) {
        case 129:
        case 130:
        case 131:
        case 85:
        case 86:
          return this.tsParseLiteralTypeNode();
        case 53:
          if (this.state.value === '-') {
            const node = this.startNode();
            const nextToken = this.lookahead();
            if (nextToken.type !== 130 && nextToken.type !== 131) {
              throw this.unexpected();
            }
            node.literal = this.parseMaybeUnary();
            return this.finishNode(node, 'TSLiteralType');
          }
          break;
        case 78:
          return this.tsParseThisTypeOrThisTypePredicate();
        case 87:
          return this.tsParseTypeQuery();
        case 83:
          return this.tsParseImportType();
        case 5:
          return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this))
            ? this.tsParseMappedType()
            : this.tsParseTypeLiteral();
        case 0:
          return this.tsParseTupleType();
        case 10:
          return this.tsParseParenthesizedType();
        case 25:
        case 24:
          return this.tsParseTemplateLiteralType();
        default: {
          const {type: type} = this.state;
          if (tokenIsIdentifier(type) || type === 88 || type === 84) {
            const nodeType =
              type === 88
                ? 'TSVoidKeyword'
                : type === 84
                  ? 'TSNullKeyword'
                  : keywordTypeFromName(this.state.value);
            if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
              const node = this.startNode();
              this.next();
              return this.finishNode(node, nodeType);
            }
            return this.tsParseTypeReference();
          }
        }
      }
      throw this.unexpected();
    }
    tsParseArrayTypeOrHigher() {
      let type = this.tsParseNonArrayType();
      while (!this.hasPrecedingLineBreak() && this.eat(0)) {
        if (this.match(3)) {
          const node = this.startNodeAtNode(type);
          node.elementType = type;
          this.expect(3);
          type = this.finishNode(node, 'TSArrayType');
        } else {
          const node = this.startNodeAtNode(type);
          node.objectType = type;
          node.indexType = this.tsParseType();
          this.expect(3);
          type = this.finishNode(node, 'TSIndexedAccessType');
        }
      }
      return type;
    }
    tsParseTypeOperator() {
      const node = this.startNode();
      const operator = this.state.value;
      this.next();
      node.operator = operator;
      node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
      if (operator === 'readonly') {
        this.tsCheckTypeAnnotationForReadOnly(node);
      }
      return this.finishNode(node, 'TSTypeOperator');
    }
    tsCheckTypeAnnotationForReadOnly(node) {
      switch (node.typeAnnotation.type) {
        case 'TSTupleType':
        case 'TSArrayType':
          return;
        default:
          this.raise(TSErrors.UnexpectedReadonly, {at: node});
      }
    }
    tsParseInferType() {
      const node = this.startNode();
      this.expectContextual(112);
      const typeParameter = this.startNode();
      typeParameter.name = this.tsParseTypeParameterName();
      typeParameter.constraint = this.tsTryParse(() =>
        this.tsParseConstraintForInferType()
      );
      node.typeParameter = this.finishNode(typeParameter, 'TSTypeParameter');
      return this.finishNode(node, 'TSInferType');
    }
    tsParseConstraintForInferType() {
      if (this.eat(81)) {
        const constraint = this.tsInDisallowConditionalTypesContext(() =>
          this.tsParseType()
        );
        if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
          return constraint;
        }
      }
    }
    tsParseTypeOperatorOrHigher() {
      const isTypeOperator =
        tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
      return isTypeOperator
        ? this.tsParseTypeOperator()
        : this.isContextual(112)
          ? this.tsParseInferType()
          : this.tsInAllowConditionalTypesContext(() =>
              this.tsParseArrayTypeOrHigher()
            );
    }
    tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
      const node = this.startNode();
      const hasLeadingOperator = this.eat(operator);
      const types = [];
      do {
        types.push(parseConstituentType());
      } while (this.eat(operator));
      if (types.length === 1 && !hasLeadingOperator) {
        return types[0];
      }
      node.types = types;
      return this.finishNode(node, kind);
    }
    tsParseIntersectionTypeOrHigher() {
      return this.tsParseUnionOrIntersectionType(
        'TSIntersectionType',
        this.tsParseTypeOperatorOrHigher.bind(this),
        45
      );
    }
    tsParseUnionTypeOrHigher() {
      return this.tsParseUnionOrIntersectionType(
        'TSUnionType',
        this.tsParseIntersectionTypeOrHigher.bind(this),
        43
      );
    }
    tsIsStartOfFunctionType() {
      if (this.match(47)) {
        return true;
      }
      return (
        this.match(10) &&
        this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this))
      );
    }
    tsSkipParameterStart() {
      if (tokenIsIdentifier(this.state.type) || this.match(78)) {
        this.next();
        return true;
      }
      if (this.match(5)) {
        const {errors: errors} = this.state;
        const previousErrorCount = errors.length;
        try {
          this.parseObjectLike(8, true);
          return errors.length === previousErrorCount;
        } catch (_unused) {
          return false;
        }
      }
      if (this.match(0)) {
        this.next();
        const {errors: errors} = this.state;
        const previousErrorCount = errors.length;
        try {
          super.parseBindingList(3, 93, true);
          return errors.length === previousErrorCount;
        } catch (_unused2) {
          return false;
        }
      }
      return false;
    }
    tsIsUnambiguouslyStartOfFunctionType() {
      this.next();
      if (this.match(11) || this.match(21)) {
        return true;
      }
      if (this.tsSkipParameterStart()) {
        if (
          this.match(14) ||
          this.match(12) ||
          this.match(17) ||
          this.match(29)
        ) {
          return true;
        }
        if (this.match(11)) {
          this.next();
          if (this.match(19)) {
            return true;
          }
        }
      }
      return false;
    }
    tsParseTypeOrTypePredicateAnnotation(returnToken) {
      return this.tsInType(() => {
        const t = this.startNode();
        this.expect(returnToken);
        const node = this.startNode();
        const asserts = !!this.tsTryParse(
          this.tsParseTypePredicateAsserts.bind(this)
        );
        if (asserts && this.match(78)) {
          let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();
          if (thisTypePredicate.type === 'TSThisType') {
            node.parameterName = thisTypePredicate;
            node.asserts = true;
            node.typeAnnotation = null;
            thisTypePredicate = this.finishNode(node, 'TSTypePredicate');
          } else {
            this.resetStartLocationFromNode(thisTypePredicate, node);
            thisTypePredicate.asserts = true;
          }
          t.typeAnnotation = thisTypePredicate;
          return this.finishNode(t, 'TSTypeAnnotation');
        }
        const typePredicateVariable =
          this.tsIsIdentifier() &&
          this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
        if (!typePredicateVariable) {
          if (!asserts) {
            return this.tsParseTypeAnnotation(false, t);
          }
          node.parameterName = this.parseIdentifier();
          node.asserts = asserts;
          node.typeAnnotation = null;
          t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
          return this.finishNode(t, 'TSTypeAnnotation');
        }
        const type = this.tsParseTypeAnnotation(false);
        node.parameterName = typePredicateVariable;
        node.typeAnnotation = type;
        node.asserts = asserts;
        t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
        return this.finishNode(t, 'TSTypeAnnotation');
      });
    }
    tsTryParseTypeOrTypePredicateAnnotation() {
      return this.match(14)
        ? this.tsParseTypeOrTypePredicateAnnotation(14)
        : undefined;
    }
    tsTryParseTypeAnnotation() {
      return this.match(14) ? this.tsParseTypeAnnotation() : undefined;
    }
    tsTryParseType() {
      return this.tsEatThenParseType(14);
    }
    tsParseTypePredicatePrefix() {
      const id = this.parseIdentifier();
      if (this.isContextual(113) && !this.hasPrecedingLineBreak()) {
        this.next();
        return id;
      }
    }
    tsParseTypePredicateAsserts() {
      if (this.state.type !== 106) {
        return false;
      }
      const containsEsc = this.state.containsEsc;
      this.next();
      if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
        return false;
      }
      if (containsEsc) {
        this.raise(Errors.InvalidEscapedReservedWord, {
          at: this.state.lastTokStartLoc,
          reservedWord: 'asserts',
        });
      }
      return true;
    }
    tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
      this.tsInType(() => {
        if (eatColon) this.expect(14);
        t.typeAnnotation = this.tsParseType();
      });
      return this.finishNode(t, 'TSTypeAnnotation');
    }
    tsParseType() {
      assert$2(this.state.inType);
      const type = this.tsParseNonConditionalType();
      if (
        this.state.inDisallowConditionalTypesContext ||
        this.hasPrecedingLineBreak() ||
        !this.eat(81)
      ) {
        return type;
      }
      const node = this.startNodeAtNode(type);
      node.checkType = type;
      node.extendsType = this.tsInDisallowConditionalTypesContext(() =>
        this.tsParseNonConditionalType()
      );
      this.expect(17);
      node.trueType = this.tsInAllowConditionalTypesContext(() =>
        this.tsParseType()
      );
      this.expect(14);
      node.falseType = this.tsInAllowConditionalTypesContext(() =>
        this.tsParseType()
      );
      return this.finishNode(node, 'TSConditionalType');
    }
    isAbstractConstructorSignature() {
      return this.isContextual(120) && this.lookahead().type === 77;
    }
    tsParseNonConditionalType() {
      if (this.tsIsStartOfFunctionType()) {
        return this.tsParseFunctionOrConstructorType('TSFunctionType');
      }
      if (this.match(77)) {
        return this.tsParseFunctionOrConstructorType('TSConstructorType');
      } else if (this.isAbstractConstructorSignature()) {
        return this.tsParseFunctionOrConstructorType('TSConstructorType', true);
      }
      return this.tsParseUnionTypeOrHigher();
    }
    tsParseTypeAssertion() {
      if (this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')) {
        this.raise(TSErrors.ReservedTypeAssertion, {at: this.state.startLoc});
      }
      const node = this.startNode();
      const _const = this.tsTryNextParseConstantContext();
      node.typeAnnotation = _const || this.tsNextThenParseType();
      this.expect(48);
      node.expression = this.parseMaybeUnary();
      return this.finishNode(node, 'TSTypeAssertion');
    }
    tsParseHeritageClause(token) {
      const originalStartLoc = this.state.startLoc;
      const delimitedList = this.tsParseDelimitedList(
        'HeritageClauseElement',
        () => {
          const node = this.startNode();
          node.expression = this.tsParseEntityName();
          if (this.match(47)) {
            node.typeParameters = this.tsParseTypeArguments();
          }
          return this.finishNode(node, 'TSExpressionWithTypeArguments');
        }
      );
      if (!delimitedList.length) {
        this.raise(TSErrors.EmptyHeritageClauseType, {
          at: originalStartLoc,
          token: token,
        });
      }
      return delimitedList;
    }
    tsParseInterfaceDeclaration(node, properties = {}) {
      if (this.hasFollowingLineBreak()) return null;
      this.expectContextual(125);
      if (properties.declare) node.declare = true;
      if (tokenIsIdentifier(this.state.type)) {
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, BIND_TS_INTERFACE);
      } else {
        node.id = null;
        this.raise(TSErrors.MissingInterfaceName, {at: this.state.startLoc});
      }
      node.typeParameters = this.tsTryParseTypeParameters(
        this.tsParseInOutModifiers.bind(this)
      );
      if (this.eat(81)) {
        node.extends = this.tsParseHeritageClause('extends');
      }
      const body = this.startNode();
      body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
      node.body = this.finishNode(body, 'TSInterfaceBody');
      return this.finishNode(node, 'TSInterfaceDeclaration');
    }
    tsParseTypeAliasDeclaration(node) {
      node.id = this.parseIdentifier();
      this.checkIdentifier(node.id, BIND_TS_TYPE);
      node.typeAnnotation = this.tsInType(() => {
        node.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutModifiers.bind(this)
        );
        this.expect(29);
        if (this.isContextual(111) && this.lookahead().type !== 16) {
          const node = this.startNode();
          this.next();
          return this.finishNode(node, 'TSIntrinsicKeyword');
        }
        return this.tsParseType();
      });
      this.semicolon();
      return this.finishNode(node, 'TSTypeAliasDeclaration');
    }
    tsInNoContext(cb) {
      const oldContext = this.state.context;
      this.state.context = [oldContext[0]];
      try {
        return cb();
      } finally {
        this.state.context = oldContext;
      }
    }
    tsInType(cb) {
      const oldInType = this.state.inType;
      this.state.inType = true;
      try {
        return cb();
      } finally {
        this.state.inType = oldInType;
      }
    }
    tsInDisallowConditionalTypesContext(cb) {
      const oldInDisallowConditionalTypesContext =
        this.state.inDisallowConditionalTypesContext;
      this.state.inDisallowConditionalTypesContext = true;
      try {
        return cb();
      } finally {
        this.state.inDisallowConditionalTypesContext =
          oldInDisallowConditionalTypesContext;
      }
    }
    tsInAllowConditionalTypesContext(cb) {
      const oldInDisallowConditionalTypesContext =
        this.state.inDisallowConditionalTypesContext;
      this.state.inDisallowConditionalTypesContext = false;
      try {
        return cb();
      } finally {
        this.state.inDisallowConditionalTypesContext =
          oldInDisallowConditionalTypesContext;
      }
    }
    tsEatThenParseType(token) {
      return !this.match(token) ? undefined : this.tsNextThenParseType();
    }
    tsExpectThenParseType(token) {
      return this.tsDoThenParseType(() => this.expect(token));
    }
    tsNextThenParseType() {
      return this.tsDoThenParseType(() => this.next());
    }
    tsDoThenParseType(cb) {
      return this.tsInType(() => {
        cb();
        return this.tsParseType();
      });
    }
    tsParseEnumMember() {
      const node = this.startNode();
      node.id = this.match(129)
        ? super.parseStringLiteral(this.state.value)
        : this.parseIdentifier(true);
      if (this.eat(29)) {
        node.initializer = super.parseMaybeAssignAllowIn();
      }
      return this.finishNode(node, 'TSEnumMember');
    }
    tsParseEnumDeclaration(node, properties = {}) {
      if (properties.const) node.const = true;
      if (properties.declare) node.declare = true;
      this.expectContextual(122);
      node.id = this.parseIdentifier();
      this.checkIdentifier(
        node.id,
        node.const ? BIND_TS_CONST_ENUM : BIND_TS_ENUM
      );
      this.expect(5);
      node.members = this.tsParseDelimitedList(
        'EnumMembers',
        this.tsParseEnumMember.bind(this)
      );
      this.expect(8);
      return this.finishNode(node, 'TSEnumDeclaration');
    }
    tsParseModuleBlock() {
      const node = this.startNode();
      this.scope.enter(SCOPE_OTHER);
      this.expect(5);
      super.parseBlockOrModuleBlockBody((node.body = []), undefined, true, 8);
      this.scope.exit();
      return this.finishNode(node, 'TSModuleBlock');
    }
    tsParseModuleOrNamespaceDeclaration(node, nested = false) {
      node.id = this.parseIdentifier();
      if (!nested) {
        this.checkIdentifier(node.id, BIND_TS_NAMESPACE);
      }
      if (this.eat(16)) {
        const inner = this.startNode();
        this.tsParseModuleOrNamespaceDeclaration(inner, true);
        node.body = inner;
      } else {
        this.scope.enter(SCOPE_TS_MODULE);
        this.prodParam.enter(PARAM);
        node.body = this.tsParseModuleBlock();
        this.prodParam.exit();
        this.scope.exit();
      }
      return this.finishNode(node, 'TSModuleDeclaration');
    }
    tsParseAmbientExternalModuleDeclaration(node) {
      if (this.isContextual(109)) {
        node.global = true;
        node.id = this.parseIdentifier();
      } else if (this.match(129)) {
        node.id = super.parseStringLiteral(this.state.value);
      } else {
        this.unexpected();
      }
      if (this.match(5)) {
        this.scope.enter(SCOPE_TS_MODULE);
        this.prodParam.enter(PARAM);
        node.body = this.tsParseModuleBlock();
        this.prodParam.exit();
        this.scope.exit();
      } else {
        this.semicolon();
      }
      return this.finishNode(node, 'TSModuleDeclaration');
    }
    tsParseImportEqualsDeclaration(node, isExport) {
      node.isExport = isExport || false;
      node.id = this.parseIdentifier();
      this.checkIdentifier(node.id, BIND_LEXICAL);
      this.expect(29);
      const moduleReference = this.tsParseModuleReference();
      if (
        node.importKind === 'type' &&
        moduleReference.type !== 'TSExternalModuleReference'
      ) {
        this.raise(TSErrors.ImportAliasHasImportType, {at: moduleReference});
      }
      node.moduleReference = moduleReference;
      this.semicolon();
      return this.finishNode(node, 'TSImportEqualsDeclaration');
    }
    tsIsExternalModuleReference() {
      return this.isContextual(116) && this.lookaheadCharCode() === 40;
    }
    tsParseModuleReference() {
      return this.tsIsExternalModuleReference()
        ? this.tsParseExternalModuleReference()
        : this.tsParseEntityName(false);
    }
    tsParseExternalModuleReference() {
      const node = this.startNode();
      this.expectContextual(116);
      this.expect(10);
      if (!this.match(129)) {
        throw this.unexpected();
      }
      node.expression = super.parseExprAtom();
      this.expect(11);
      return this.finishNode(node, 'TSExternalModuleReference');
    }
    tsLookAhead(f) {
      const state = this.state.clone();
      const res = f();
      this.state = state;
      return res;
    }
    tsTryParseAndCatch(f) {
      const result = this.tryParse(abort => f() || abort());
      if (result.aborted || !result.node) return undefined;
      if (result.error) this.state = result.failState;
      return result.node;
    }
    tsTryParse(f) {
      const state = this.state.clone();
      const result = f();
      if (result !== undefined && result !== false) {
        return result;
      } else {
        this.state = state;
        return undefined;
      }
    }
    tsTryParseDeclare(nany) {
      if (this.isLineTerminator()) {
        return;
      }
      let starttype = this.state.type;
      let kind;
      if (this.isContextual(99)) {
        starttype = 74;
        kind = 'let';
      }
      return this.tsInAmbientContext(() => {
        if (starttype === 68) {
          nany.declare = true;
          return super.parseFunctionStatement(nany, false, true);
        }
        if (starttype === 80) {
          nany.declare = true;
          return this.parseClass(nany, true, false);
        }
        if (starttype === 122) {
          return this.tsParseEnumDeclaration(nany, {declare: true});
        }
        if (starttype === 109) {
          return this.tsParseAmbientExternalModuleDeclaration(nany);
        }
        if (starttype === 75 || starttype === 74) {
          if (!this.match(75) || !this.isLookaheadContextual('enum')) {
            nany.declare = true;
            return this.parseVarStatement(nany, kind || this.state.value, true);
          }
          this.expect(75);
          return this.tsParseEnumDeclaration(nany, {
            const: true,
            declare: true,
          });
        }
        if (starttype === 125) {
          const result = this.tsParseInterfaceDeclaration(nany, {
            declare: true,
          });
          if (result) return result;
        }
        if (tokenIsIdentifier(starttype)) {
          return this.tsParseDeclaration(nany, this.state.value, true);
        }
      });
    }
    tsTryParseExportDeclaration() {
      return this.tsParseDeclaration(this.startNode(), this.state.value, true);
    }
    tsParseExpressionStatement(node, expr) {
      switch (expr.name) {
        case 'declare': {
          const declaration = this.tsTryParseDeclare(node);
          if (declaration) {
            declaration.declare = true;
            return declaration;
          }
          break;
        }
        case 'global':
          if (this.match(5)) {
            this.scope.enter(SCOPE_TS_MODULE);
            this.prodParam.enter(PARAM);
            const mod = node;
            mod.global = true;
            mod.id = expr;
            mod.body = this.tsParseModuleBlock();
            this.scope.exit();
            this.prodParam.exit();
            return this.finishNode(mod, 'TSModuleDeclaration');
          }
          break;
        default:
          return this.tsParseDeclaration(node, expr.name, false);
      }
    }
    tsParseDeclaration(node, value, next) {
      switch (value) {
        case 'abstract':
          if (
            this.tsCheckLineTerminator(next) &&
            (this.match(80) || tokenIsIdentifier(this.state.type))
          ) {
            return this.tsParseAbstractDeclaration(node);
          }
          break;
        case 'module':
          if (this.tsCheckLineTerminator(next)) {
            if (this.match(129)) {
              return this.tsParseAmbientExternalModuleDeclaration(node);
            } else if (tokenIsIdentifier(this.state.type)) {
              return this.tsParseModuleOrNamespaceDeclaration(node);
            }
          }
          break;
        case 'namespace':
          if (
            this.tsCheckLineTerminator(next) &&
            tokenIsIdentifier(this.state.type)
          ) {
            return this.tsParseModuleOrNamespaceDeclaration(node);
          }
          break;
        case 'type':
          if (
            this.tsCheckLineTerminator(next) &&
            tokenIsIdentifier(this.state.type)
          ) {
            return this.tsParseTypeAliasDeclaration(node);
          }
          break;
      }
    }
    tsCheckLineTerminator(next) {
      if (next) {
        if (this.hasFollowingLineBreak()) return false;
        this.next();
        return true;
      }
      return !this.isLineTerminator();
    }
    tsTryParseGenericAsyncArrowFunction(startPos, startLoc) {
      if (!this.match(47)) {
        return undefined;
      }
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      this.state.maybeInArrowParameters = true;
      const res = this.tsTryParseAndCatch(() => {
        const node = this.startNodeAt(startPos, startLoc);
        node.typeParameters = this.tsParseTypeParameters();
        super.parseFunctionParams(node);
        node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
        this.expect(19);
        return node;
      });
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      if (!res) {
        return undefined;
      }
      return super.parseArrowExpression(res, null, true);
    }
    tsParseTypeArgumentsInExpression() {
      if (this.reScan_lt() !== 47) {
        return undefined;
      }
      return this.tsParseTypeArguments();
    }
    tsParseTypeArguments() {
      const node = this.startNode();
      node.params = this.tsInType(() =>
        this.tsInNoContext(() => {
          this.expect(47);
          return this.tsParseDelimitedList(
            'TypeParametersOrArguments',
            this.tsParseType.bind(this)
          );
        })
      );
      if (node.params.length === 0) {
        this.raise(TSErrors.EmptyTypeArguments, {at: node});
      }
      this.expect(48);
      return this.finishNode(node, 'TSTypeParameterInstantiation');
    }
    tsIsDeclarationStart() {
      return tokenIsTSDeclarationStart(this.state.type);
    }
    isExportDefaultSpecifier() {
      if (this.tsIsDeclarationStart()) return false;
      return super.isExportDefaultSpecifier();
    }
    parseAssignableListItem(allowModifiers, decorators) {
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      let accessibility;
      let readonly = false;
      let override = false;
      if (allowModifiers !== undefined) {
        const modified = {};
        this.tsParseModifiers({
          modified: modified,
          allowedModifiers: [
            'public',
            'private',
            'protected',
            'override',
            'readonly',
          ],
        });
        accessibility = modified.accessibility;
        override = modified.override;
        readonly = modified.readonly;
        if (
          allowModifiers === false &&
          (accessibility || readonly || override)
        ) {
          this.raise(TSErrors.UnexpectedParameterModifier, {at: startLoc});
        }
      }
      const left = this.parseMaybeDefault();
      this.parseAssignableListItemTypes(left);
      const elt = this.parseMaybeDefault(left.start, left.loc.start, left);
      if (accessibility || readonly || override) {
        const pp = this.startNodeAt(startPos, startLoc);
        if (decorators.length) {
          pp.decorators = decorators;
        }
        if (accessibility) pp.accessibility = accessibility;
        if (readonly) pp.readonly = readonly;
        if (override) pp.override = override;
        if (elt.type !== 'Identifier' && elt.type !== 'AssignmentPattern') {
          this.raise(TSErrors.UnsupportedParameterPropertyKind, {at: pp});
        }
        pp.parameter = elt;
        return this.finishNode(pp, 'TSParameterProperty');
      }
      if (decorators.length) {
        left.decorators = decorators;
      }
      return elt;
    }
    isSimpleParameter(node) {
      return (
        (node.type === 'TSParameterProperty' &&
          super.isSimpleParameter(node.parameter)) ||
        super.isSimpleParameter(node)
      );
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      if (this.match(14)) {
        node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
      }
      const bodilessType =
        type === 'FunctionDeclaration'
          ? 'TSDeclareFunction'
          : type === 'ClassMethod' || type === 'ClassPrivateMethod'
            ? 'TSDeclareMethod'
            : undefined;
      if (bodilessType && !this.match(5) && this.isLineTerminator()) {
        return this.finishNode(node, bodilessType);
      }
      if (bodilessType === 'TSDeclareFunction' && this.state.isAmbientContext) {
        this.raise(TSErrors.DeclareFunctionHasImplementation, {at: node});
        if (node.declare) {
          return super.parseFunctionBodyAndFinish(node, bodilessType, isMethod);
        }
      }
      return super.parseFunctionBodyAndFinish(node, type, isMethod);
    }
    registerFunctionStatementId(node) {
      if (!node.body && node.id) {
        this.checkIdentifier(node.id, BIND_TS_AMBIENT);
      } else {
        super.registerFunctionStatementId(node);
      }
    }
    tsCheckForInvalidTypeCasts(items) {
      items.forEach(node => {
        if ((node == null ? void 0 : node.type) === 'TSTypeCastExpression') {
          this.raise(TSErrors.UnexpectedTypeAnnotation, {
            at: node.typeAnnotation,
          });
        }
      });
    }
    toReferencedList(exprList, isInParens) {
      this.tsCheckForInvalidTypeCasts(exprList);
      return exprList;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      const node = super.parseArrayLike(
        close,
        canBePattern,
        isTuple,
        refExpressionErrors
      );
      if (node.type === 'ArrayExpression') {
        this.tsCheckForInvalidTypeCasts(node.elements);
      }
      return node;
    }
    parseSubscript(base, startPos, startLoc, noCalls, state) {
      if (!this.hasPrecedingLineBreak() && this.match(35)) {
        this.state.canStartJSXElement = false;
        this.next();
        const nonNullExpression = this.startNodeAt(startPos, startLoc);
        nonNullExpression.expression = base;
        return this.finishNode(nonNullExpression, 'TSNonNullExpression');
      }
      let isOptionalCall = false;
      if (this.match(18) && this.lookaheadCharCode() === 60) {
        if (noCalls) {
          state.stop = true;
          return base;
        }
        state.optionalChainMember = isOptionalCall = true;
        this.next();
      }
      if (this.match(47) || this.match(51)) {
        let missingParenErrorLoc;
        const result = this.tsTryParseAndCatch(() => {
          if (!noCalls && this.atPossibleAsyncArrow(base)) {
            const asyncArrowFn = this.tsTryParseGenericAsyncArrowFunction(
              startPos,
              startLoc
            );
            if (asyncArrowFn) {
              return asyncArrowFn;
            }
          }
          const typeArguments = this.tsParseTypeArgumentsInExpression();
          if (!typeArguments) return;
          if (isOptionalCall && !this.match(10)) {
            missingParenErrorLoc = this.state.curPosition();
            return;
          }
          if (tokenIsTemplate(this.state.type)) {
            const result = super.parseTaggedTemplateExpression(
              base,
              startPos,
              startLoc,
              state
            );
            result.typeParameters = typeArguments;
            return result;
          }
          if (!noCalls && this.eat(10)) {
            const node = this.startNodeAt(startPos, startLoc);
            node.callee = base;
            node.arguments = this.parseCallExpressionArguments(11, false);
            this.tsCheckForInvalidTypeCasts(node.arguments);
            node.typeParameters = typeArguments;
            if (state.optionalChainMember) {
              node.optional = isOptionalCall;
            }
            return this.finishCallExpression(node, state.optionalChainMember);
          }
          const tokenType = this.state.type;
          if (
            tokenType === 48 ||
            tokenType === 52 ||
            (tokenType !== 10 &&
              tokenCanStartExpression(tokenType) &&
              !this.hasPrecedingLineBreak())
          ) {
            return;
          }
          const node = this.startNodeAt(startPos, startLoc);
          node.expression = base;
          node.typeParameters = typeArguments;
          return this.finishNode(node, 'TSInstantiationExpression');
        });
        if (missingParenErrorLoc) {
          this.unexpected(missingParenErrorLoc, 10);
        }
        if (result) {
          if (
            result.type === 'TSInstantiationExpression' &&
            (this.match(16) ||
              (this.match(18) && this.lookaheadCharCode() !== 40))
          ) {
            this.raise(
              TSErrors.InvalidPropertyAccessAfterInstantiationExpression,
              {at: this.state.startLoc}
            );
          }
          return result;
        }
      }
      return super.parseSubscript(base, startPos, startLoc, noCalls, state);
    }
    parseNewCallee(node) {
      var _callee$extra;
      super.parseNewCallee(node);
      const {callee: callee} = node;
      if (
        callee.type === 'TSInstantiationExpression' &&
        !((_callee$extra = callee.extra) != null && _callee$extra.parenthesized)
      ) {
        node.typeParameters = callee.typeParameters;
        node.callee = callee.expression;
      }
    }
    parseExprOp(left, leftStartPos, leftStartLoc, minPrec) {
      if (
        tokenOperatorPrecedence(58) > minPrec &&
        !this.hasPrecedingLineBreak() &&
        this.isContextual(93)
      ) {
        const node = this.startNodeAt(leftStartPos, leftStartLoc);
        node.expression = left;
        const _const = this.tsTryNextParseConstantContext();
        if (_const) {
          node.typeAnnotation = _const;
        } else {
          node.typeAnnotation = this.tsNextThenParseType();
        }
        this.finishNode(node, 'TSAsExpression');
        this.reScan_lt_gt();
        return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec);
      }
      return super.parseExprOp(left, leftStartPos, leftStartLoc, minPrec);
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (!this.state.isAmbientContext) {
        super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
      }
    }
    checkDuplicateExports() {}
    parseImport(node) {
      node.importKind = 'value';
      if (
        tokenIsIdentifier(this.state.type) ||
        this.match(55) ||
        this.match(5)
      ) {
        let ahead = this.lookahead();
        if (
          this.isContextual(126) &&
          ahead.type !== 12 &&
          ahead.type !== 97 &&
          ahead.type !== 29
        ) {
          node.importKind = 'type';
          this.next();
          ahead = this.lookahead();
        }
        if (tokenIsIdentifier(this.state.type) && ahead.type === 29) {
          return this.tsParseImportEqualsDeclaration(node);
        }
      }
      const importNode = super.parseImport(node);
      if (
        importNode.importKind === 'type' &&
        importNode.specifiers.length > 1 &&
        importNode.specifiers[0].type === 'ImportDefaultSpecifier'
      ) {
        this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, {
          at: importNode,
        });
      }
      return importNode;
    }
    parseExport(node) {
      if (this.match(83)) {
        this.next();
        if (this.isContextual(126) && this.lookaheadCharCode() !== 61) {
          node.importKind = 'type';
          this.next();
        } else {
          node.importKind = 'value';
        }
        return this.tsParseImportEqualsDeclaration(node, true);
      } else if (this.eat(29)) {
        const assign = node;
        assign.expression = super.parseExpression();
        this.semicolon();
        return this.finishNode(assign, 'TSExportAssignment');
      } else if (this.eatContextual(93)) {
        const decl = node;
        this.expectContextual(124);
        decl.id = this.parseIdentifier();
        this.semicolon();
        return this.finishNode(decl, 'TSNamespaceExportDeclaration');
      } else {
        if (this.isContextual(126) && this.lookahead().type === 5) {
          this.next();
          node.exportKind = 'type';
        } else {
          node.exportKind = 'value';
        }
        return super.parseExport(node);
      }
    }
    isAbstractClass() {
      return this.isContextual(120) && this.lookahead().type === 80;
    }
    parseExportDefaultExpression() {
      if (this.isAbstractClass()) {
        const cls = this.startNode();
        this.next();
        cls.abstract = true;
        return this.parseClass(cls, true, true);
      }
      if (this.match(125)) {
        const result = this.tsParseInterfaceDeclaration(this.startNode());
        if (result) return result;
      }
      return super.parseExportDefaultExpression();
    }
    parseVarStatement(node, kind, allowMissingInitializer = false) {
      const {isAmbientContext: isAmbientContext} = this.state;
      const declaration = super.parseVarStatement(
        node,
        kind,
        allowMissingInitializer || isAmbientContext
      );
      if (!isAmbientContext) return declaration;
      for (const {id: id, init: init} of declaration.declarations) {
        if (!init) continue;
        if (kind !== 'const' || !!id.typeAnnotation) {
          this.raise(TSErrors.InitializerNotAllowedInAmbientContext, {
            at: init,
          });
        } else if (
          init.type !== 'StringLiteral' &&
          init.type !== 'BooleanLiteral' &&
          init.type !== 'NumericLiteral' &&
          init.type !== 'BigIntLiteral' &&
          (init.type !== 'TemplateLiteral' || init.expressions.length > 0) &&
          !isPossiblyLiteralEnum(init)
        ) {
          this.raise(
            TSErrors.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference,
            {at: init}
          );
        }
      }
      return declaration;
    }
    parseStatementContent(context, topLevel) {
      if (this.match(75) && this.isLookaheadContextual('enum')) {
        const node = this.startNode();
        this.expect(75);
        return this.tsParseEnumDeclaration(node, {const: true});
      }
      if (this.isContextual(122)) {
        return this.tsParseEnumDeclaration(this.startNode());
      }
      if (this.isContextual(125)) {
        const result = this.tsParseInterfaceDeclaration(this.startNode());
        if (result) return result;
      }
      return super.parseStatementContent(context, topLevel);
    }
    parseAccessModifier() {
      return this.tsParseModifier(['public', 'protected', 'private']);
    }
    tsHasSomeModifiers(member, modifiers) {
      return modifiers.some(modifier => {
        if (tsIsAccessModifier(modifier)) {
          return member.accessibility === modifier;
        }
        return !!member[modifier];
      });
    }
    tsIsStartOfStaticBlocks() {
      return this.isContextual(104) && this.lookaheadCharCode() === 123;
    }
    parseClassMember(classBody, member, state) {
      const modifiers = [
        'declare',
        'private',
        'public',
        'protected',
        'override',
        'abstract',
        'readonly',
        'static',
      ];
      this.tsParseModifiers({
        modified: member,
        allowedModifiers: modifiers,
        disallowedModifiers: ['in', 'out'],
        stopOnStartOfClassStaticBlock: true,
        errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
      });
      const callParseClassMemberWithIsStatic = () => {
        if (this.tsIsStartOfStaticBlocks()) {
          this.next();
          this.next();
          if (this.tsHasSomeModifiers(member, modifiers)) {
            this.raise(TSErrors.StaticBlockCannotHaveModifier, {
              at: this.state.curPosition(),
            });
          }
          super.parseClassStaticBlock(classBody, member);
        } else {
          this.parseClassMemberWithIsStatic(
            classBody,
            member,
            state,
            !!member.static
          );
        }
      };
      if (member.declare) {
        this.tsInAmbientContext(callParseClassMemberWithIsStatic);
      } else {
        callParseClassMemberWithIsStatic();
      }
    }
    parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
      const idx = this.tsTryParseIndexSignature(member);
      if (idx) {
        classBody.body.push(idx);
        if (member.abstract) {
          this.raise(TSErrors.IndexSignatureHasAbstract, {at: member});
        }
        if (member.accessibility) {
          this.raise(TSErrors.IndexSignatureHasAccessibility, {
            at: member,
            modifier: member.accessibility,
          });
        }
        if (member.declare) {
          this.raise(TSErrors.IndexSignatureHasDeclare, {at: member});
        }
        if (member.override) {
          this.raise(TSErrors.IndexSignatureHasOverride, {at: member});
        }
        return;
      }
      if (!this.state.inAbstractClass && member.abstract) {
        this.raise(TSErrors.NonAbstractClassHasAbstractMethod, {at: member});
      }
      if (member.override) {
        if (!state.hadSuperClass) {
          this.raise(TSErrors.OverrideNotInSubClass, {at: member});
        }
      }
      super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
    }
    parsePostMemberNameModifiers(methodOrProp) {
      const optional = this.eat(17);
      if (optional) methodOrProp.optional = true;
      if (methodOrProp.readonly && this.match(10)) {
        this.raise(TSErrors.ClassMethodHasReadonly, {at: methodOrProp});
      }
      if (methodOrProp.declare && this.match(10)) {
        this.raise(TSErrors.ClassMethodHasDeclare, {at: methodOrProp});
      }
    }
    parseExpressionStatement(node, expr) {
      const decl =
        expr.type === 'Identifier'
          ? this.tsParseExpressionStatement(node, expr)
          : undefined;
      return decl || super.parseExpressionStatement(node, expr);
    }
    shouldParseExportDeclaration() {
      if (this.tsIsDeclarationStart()) return true;
      return super.shouldParseExportDeclaration();
    }
    parseConditional(expr, startPos, startLoc, refExpressionErrors) {
      if (!this.state.maybeInArrowParameters || !this.match(17)) {
        return super.parseConditional(
          expr,
          startPos,
          startLoc,
          refExpressionErrors
        );
      }
      const result = this.tryParse(() =>
        super.parseConditional(expr, startPos, startLoc)
      );
      if (!result.node) {
        if (result.error) {
          super.setOptionalParametersError(refExpressionErrors, result.error);
        }
        return expr;
      }
      if (result.error) this.state = result.failState;
      return result.node;
    }
    parseParenItem(node, startPos, startLoc) {
      node = super.parseParenItem(node, startPos, startLoc);
      if (this.eat(17)) {
        node.optional = true;
        this.resetEndLocation(node);
      }
      if (this.match(14)) {
        const typeCastNode = this.startNodeAt(startPos, startLoc);
        typeCastNode.expression = node;
        typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
        return this.finishNode(typeCastNode, 'TSTypeCastExpression');
      }
      return node;
    }
    parseExportDeclaration(node) {
      if (!this.state.isAmbientContext && this.isContextual(121)) {
        return this.tsInAmbientContext(() => this.parseExportDeclaration(node));
      }
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      const isDeclare = this.eatContextual(121);
      if (
        isDeclare &&
        (this.isContextual(121) || !this.shouldParseExportDeclaration())
      ) {
        throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, {
          at: this.state.startLoc,
        });
      }
      const isIdentifier = tokenIsIdentifier(this.state.type);
      const declaration =
        (isIdentifier && this.tsTryParseExportDeclaration()) ||
        super.parseExportDeclaration(node);
      if (!declaration) return null;
      if (
        declaration.type === 'TSInterfaceDeclaration' ||
        declaration.type === 'TSTypeAliasDeclaration' ||
        isDeclare
      ) {
        node.exportKind = 'type';
      }
      if (isDeclare) {
        this.resetStartLocation(declaration, startPos, startLoc);
        declaration.declare = true;
      }
      return declaration;
    }
    parseClassId(node, isStatement, optionalId, bindingType) {
      if ((!isStatement || optionalId) && this.isContextual(110)) {
        return;
      }
      super.parseClassId(
        node,
        isStatement,
        optionalId,
        node.declare ? BIND_TS_AMBIENT : BIND_CLASS
      );
      const typeParameters = this.tsTryParseTypeParameters(
        this.tsParseInOutModifiers.bind(this)
      );
      if (typeParameters) node.typeParameters = typeParameters;
    }
    parseClassPropertyAnnotation(node) {
      if (!node.optional && this.eat(35)) {
        node.definite = true;
      }
      const type = this.tsTryParseTypeAnnotation();
      if (type) node.typeAnnotation = type;
    }
    parseClassProperty(node) {
      this.parseClassPropertyAnnotation(node);
      if (
        this.state.isAmbientContext &&
        !(node.readonly && !node.typeAnnotation) &&
        this.match(29)
      ) {
        this.raise(TSErrors.DeclareClassFieldHasInitializer, {
          at: this.state.startLoc,
        });
      }
      if (node.abstract && this.match(29)) {
        const {key: key} = node;
        this.raise(TSErrors.AbstractPropertyHasInitializer, {
          at: this.state.startLoc,
          propertyName:
            key.type === 'Identifier' && !node.computed
              ? key.name
              : `[${this.input.slice(key.start, key.end)}]`,
        });
      }
      return super.parseClassProperty(node);
    }
    parseClassPrivateProperty(node) {
      if (node.abstract) {
        this.raise(TSErrors.PrivateElementHasAbstract, {at: node});
      }
      if (node.accessibility) {
        this.raise(TSErrors.PrivateElementHasAccessibility, {
          at: node,
          modifier: node.accessibility,
        });
      }
      this.parseClassPropertyAnnotation(node);
      return super.parseClassPrivateProperty(node);
    }
    pushClassMethod(
      classBody,
      method,
      isGenerator,
      isAsync,
      isConstructor,
      allowsDirectSuper
    ) {
      const typeParameters = this.tsTryParseTypeParameters();
      if (typeParameters && isConstructor) {
        this.raise(TSErrors.ConstructorHasTypeParameters, {at: typeParameters});
      }
      const {declare: declare = false, kind: kind} = method;
      if (declare && (kind === 'get' || kind === 'set')) {
        this.raise(TSErrors.DeclareAccessor, {at: method, kind: kind});
      }
      if (typeParameters) method.typeParameters = typeParameters;
      super.pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      );
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      const typeParameters = this.tsTryParseTypeParameters();
      if (typeParameters) method.typeParameters = typeParameters;
      super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
    }
    declareClassPrivateMethodInScope(node, kind) {
      if (node.type === 'TSDeclareMethod') return;
      if (node.type === 'MethodDefinition' && !node.value.body) return;
      super.declareClassPrivateMethodInScope(node, kind);
    }
    parseClassSuper(node) {
      super.parseClassSuper(node);
      if (node.superClass && (this.match(47) || this.match(51))) {
        node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
      }
      if (this.eatContextual(110)) {
        node.implements = this.tsParseHeritageClause('implements');
      }
    }
    parseObjPropValue(
      prop,
      startPos,
      startLoc,
      isGenerator,
      isAsync,
      isPattern,
      isAccessor,
      refExpressionErrors
    ) {
      const typeParameters = this.tsTryParseTypeParameters();
      if (typeParameters) prop.typeParameters = typeParameters;
      return super.parseObjPropValue(
        prop,
        startPos,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      );
    }
    parseFunctionParams(node, allowModifiers) {
      const typeParameters = this.tsTryParseTypeParameters();
      if (typeParameters) node.typeParameters = typeParameters;
      super.parseFunctionParams(node, allowModifiers);
    }
    parseVarId(decl, kind) {
      super.parseVarId(decl, kind);
      if (
        decl.id.type === 'Identifier' &&
        !this.hasPrecedingLineBreak() &&
        this.eat(35)
      ) {
        decl.definite = true;
      }
      const type = this.tsTryParseTypeAnnotation();
      if (type) {
        decl.id.typeAnnotation = type;
        this.resetEndLocation(decl.id);
      }
    }
    parseAsyncArrowFromCallExpression(node, call) {
      if (this.match(14)) {
        node.returnType = this.tsParseTypeAnnotation();
      }
      return super.parseAsyncArrowFromCallExpression(node, call);
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      var _jsx, _jsx2, _typeCast, _jsx3, _typeCast2, _jsx4, _typeCast3;
      let state;
      let jsx;
      let typeCast;
      if (this.hasPlugin('jsx') && (this.match(138) || this.match(47))) {
        state = this.state.clone();
        jsx = this.tryParse(
          () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
          state
        );
        if (!jsx.error) return jsx.node;
        const {context: context} = this.state;
        const currentContext = context[context.length - 1];
        if (
          currentContext === types$2.j_oTag ||
          currentContext === types$2.j_expr
        ) {
          context.pop();
        }
      }
      if (!((_jsx = jsx) != null && _jsx.error) && !this.match(47)) {
        return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
      }
      if (!state || state === this.state) state = this.state.clone();
      let typeParameters;
      const arrow = this.tryParse(abort => {
        var _expr$extra, _typeParameters;
        typeParameters = this.tsParseTypeParameters();
        const expr = super.parseMaybeAssign(
          refExpressionErrors,
          afterLeftParse
        );
        if (
          expr.type !== 'ArrowFunctionExpression' ||
          ((_expr$extra = expr.extra) != null && _expr$extra.parenthesized)
        ) {
          abort();
        }
        if (
          ((_typeParameters = typeParameters) == null
            ? void 0
            : _typeParameters.params.length) !== 0
        ) {
          this.resetStartLocationFromNode(expr, typeParameters);
        }
        expr.typeParameters = typeParameters;
        return expr;
      }, state);
      if (!arrow.error && !arrow.aborted) {
        if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
        return arrow.node;
      }
      if (!jsx) {
        assert$2(!this.hasPlugin('jsx'));
        typeCast = this.tryParse(
          () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
          state
        );
        if (!typeCast.error) return typeCast.node;
      }
      if ((_jsx2 = jsx) != null && _jsx2.node) {
        this.state = jsx.failState;
        return jsx.node;
      }
      if (arrow.node) {
        this.state = arrow.failState;
        if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
        return arrow.node;
      }
      if ((_typeCast = typeCast) != null && _typeCast.node) {
        this.state = typeCast.failState;
        return typeCast.node;
      }
      if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
      if (arrow.thrown) throw arrow.error;
      if ((_typeCast2 = typeCast) != null && _typeCast2.thrown)
        throw typeCast.error;
      throw (
        ((_jsx4 = jsx) == null ? void 0 : _jsx4.error) ||
        arrow.error ||
        ((_typeCast3 = typeCast) == null ? void 0 : _typeCast3.error)
      );
    }
    reportReservedArrowTypeParam(node) {
      var _node$extra;
      if (
        node.params.length === 1 &&
        !((_node$extra = node.extra) != null && _node$extra.trailingComma) &&
        this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')
      ) {
        this.raise(TSErrors.ReservedArrowTypeParam, {at: node});
      }
    }
    parseMaybeUnary(refExpressionErrors, sawUnary) {
      if (!this.hasPlugin('jsx') && this.match(47)) {
        return this.tsParseTypeAssertion();
      } else {
        return super.parseMaybeUnary(refExpressionErrors, sawUnary);
      }
    }
    parseArrow(node) {
      if (this.match(14)) {
        const result = this.tryParse(abort => {
          const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
          if (this.canInsertSemicolon() || !this.match(19)) abort();
          return returnType;
        });
        if (result.aborted) return;
        if (!result.thrown) {
          if (result.error) this.state = result.failState;
          node.returnType = result.node;
        }
      }
      return super.parseArrow(node);
    }
    parseAssignableListItemTypes(param) {
      if (this.eat(17)) {
        if (
          param.type !== 'Identifier' &&
          !this.state.isAmbientContext &&
          !this.state.inType
        ) {
          this.raise(TSErrors.PatternIsOptional, {at: param});
        }
        param.optional = true;
      }
      const type = this.tsTryParseTypeAnnotation();
      if (type) param.typeAnnotation = type;
      this.resetEndLocation(param);
      return param;
    }
    isAssignable(node, isBinding) {
      switch (node.type) {
        case 'TSTypeCastExpression':
          return this.isAssignable(node.expression, isBinding);
        case 'TSParameterProperty':
          return true;
        default:
          return super.isAssignable(node, isBinding);
      }
    }
    toAssignable(node, isLHS = false) {
      switch (node.type) {
        case 'ParenthesizedExpression':
          this.toAssignableParenthesizedExpression(node, isLHS);
          break;
        case 'TSAsExpression':
        case 'TSNonNullExpression':
        case 'TSTypeAssertion':
          if (isLHS) {
            this.expressionScope.recordArrowParemeterBindingError(
              TSErrors.UnexpectedTypeCastInParameter,
              {at: node}
            );
          } else {
            this.raise(TSErrors.UnexpectedTypeCastInParameter, {at: node});
          }
          this.toAssignable(node.expression, isLHS);
          break;
        case 'AssignmentExpression':
          if (!isLHS && node.left.type === 'TSTypeCastExpression') {
            node.left = this.typeCastToParameter(node.left);
          }
        default:
          super.toAssignable(node, isLHS);
      }
    }
    toAssignableParenthesizedExpression(node, isLHS) {
      switch (node.expression.type) {
        case 'TSAsExpression':
        case 'TSNonNullExpression':
        case 'TSTypeAssertion':
        case 'ParenthesizedExpression':
          this.toAssignable(node.expression, isLHS);
          break;
        default:
          super.toAssignable(node, isLHS);
      }
    }
    checkToRestConversion(node, allowPattern) {
      switch (node.type) {
        case 'TSAsExpression':
        case 'TSTypeAssertion':
        case 'TSNonNullExpression':
          this.checkToRestConversion(node.expression, false);
          break;
        default:
          super.checkToRestConversion(node, allowPattern);
      }
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      return (
        getOwn$1(
          {
            TSTypeCastExpression: true,
            TSParameterProperty: 'parameter',
            TSNonNullExpression: 'expression',
            TSAsExpression: (binding !== BIND_NONE ||
              !isUnparenthesizedInAssign) && ['expression', true],
            TSTypeAssertion: (binding !== BIND_NONE ||
              !isUnparenthesizedInAssign) && ['expression', true],
          },
          type
        ) || super.isValidLVal(type, isUnparenthesizedInAssign, binding)
      );
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 78:
          return this.parseIdentifier(true);
        default:
          return super.parseBindingAtom();
      }
    }
    parseMaybeDecoratorArguments(expr) {
      if (this.match(47) || this.match(51)) {
        const typeArguments = this.tsParseTypeArgumentsInExpression();
        if (this.match(10)) {
          const call = super.parseMaybeDecoratorArguments(expr);
          call.typeParameters = typeArguments;
          return call;
        }
        this.unexpected(null, 10);
      }
      return super.parseMaybeDecoratorArguments(expr);
    }
    checkCommaAfterRest(close) {
      if (
        this.state.isAmbientContext &&
        this.match(12) &&
        this.lookaheadCharCode() === close
      ) {
        this.next();
        return false;
      } else {
        return super.checkCommaAfterRest(close);
      }
    }
    isClassMethod() {
      return this.match(47) || super.isClassMethod();
    }
    isClassProperty() {
      return this.match(35) || this.match(14) || super.isClassProperty();
    }
    parseMaybeDefault(startPos, startLoc, left) {
      const node = super.parseMaybeDefault(startPos, startLoc, left);
      if (
        node.type === 'AssignmentPattern' &&
        node.typeAnnotation &&
        node.right.start < node.typeAnnotation.start
      ) {
        this.raise(TSErrors.TypeAnnotationAfterAssign, {
          at: node.typeAnnotation,
        });
      }
      return node;
    }
    getTokenFromCode(code) {
      if (this.state.inType) {
        if (code === 62) {
          return this.finishOp(48, 1);
        }
        if (code === 60) {
          return this.finishOp(47, 1);
        }
      }
      return super.getTokenFromCode(code);
    }
    reScan_lt_gt() {
      const {type: type} = this.state;
      if (type === 47) {
        this.state.pos -= 1;
        this.readToken_lt();
      } else if (type === 48) {
        this.state.pos -= 1;
        this.readToken_gt();
      }
    }
    reScan_lt() {
      const {type: type} = this.state;
      if (type === 51) {
        this.state.pos -= 2;
        this.finishOp(47, 1);
        return 47;
      }
      return type;
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      for (let i = 0; i < exprList.length; i++) {
        const expr = exprList[i];
        if ((expr == null ? void 0 : expr.type) === 'TSTypeCastExpression') {
          exprList[i] = this.typeCastToParameter(expr);
        }
      }
      super.toAssignableList(exprList, trailingCommaLoc, isLHS);
    }
    typeCastToParameter(node) {
      node.expression.typeAnnotation = node.typeAnnotation;
      this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
      return node.expression;
    }
    shouldParseArrow(params) {
      if (this.match(14)) {
        return params.every(expr => this.isAssignable(expr, true));
      }
      return super.shouldParseArrow(params);
    }
    shouldParseAsyncArrow() {
      return this.match(14) || super.shouldParseAsyncArrow();
    }
    canHaveLeadingDecorator() {
      return super.canHaveLeadingDecorator() || this.isAbstractClass();
    }
    jsxParseOpeningElementAfterName(node) {
      if (this.match(47) || this.match(51)) {
        const typeArguments = this.tsTryParseAndCatch(() =>
          this.tsParseTypeArgumentsInExpression()
        );
        if (typeArguments) node.typeParameters = typeArguments;
      }
      return super.jsxParseOpeningElementAfterName(node);
    }
    getGetterSetterExpectedParamCount(method) {
      const baseCount = super.getGetterSetterExpectedParamCount(method);
      const params = this.getObjectOrClassMethodParams(method);
      const firstParam = params[0];
      const hasContextParam = firstParam && this.isThisParam(firstParam);
      return hasContextParam ? baseCount + 1 : baseCount;
    }
    parseCatchClauseParam() {
      const param = super.parseCatchClauseParam();
      const type = this.tsTryParseTypeAnnotation();
      if (type) {
        param.typeAnnotation = type;
        this.resetEndLocation(param);
      }
      return param;
    }
    tsInAmbientContext(cb) {
      const oldIsAmbientContext = this.state.isAmbientContext;
      this.state.isAmbientContext = true;
      try {
        return cb();
      } finally {
        this.state.isAmbientContext = oldIsAmbientContext;
      }
    }
    parseClass(node, isStatement, optionalId) {
      const oldInAbstractClass = this.state.inAbstractClass;
      this.state.inAbstractClass = !!node.abstract;
      try {
        return super.parseClass(node, isStatement, optionalId);
      } finally {
        this.state.inAbstractClass = oldInAbstractClass;
      }
    }
    tsParseAbstractDeclaration(node) {
      if (this.match(80)) {
        node.abstract = true;
        return this.parseClass(node, true, false);
      } else if (this.isContextual(125)) {
        if (!this.hasFollowingLineBreak()) {
          node.abstract = true;
          this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, {
            at: node,
          });
          return this.tsParseInterfaceDeclaration(node);
        }
      } else {
        this.unexpected(null, 80);
      }
    }
    parseMethod(
      node,
      isGenerator,
      isAsync,
      isConstructor,
      allowDirectSuper,
      type,
      inClassScope
    ) {
      const method = super.parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope
      );
      if (method.abstract) {
        const hasBody = this.hasPlugin('estree')
          ? !!method.value.body
          : !!method.body;
        if (hasBody) {
          const {key: key} = method;
          this.raise(TSErrors.AbstractMethodHasImplementation, {
            at: method,
            methodName:
              key.type === 'Identifier' && !method.computed
                ? key.name
                : `[${this.input.slice(key.start, key.end)}]`,
          });
        }
      }
      return method;
    }
    tsParseTypeParameterName() {
      const typeName = this.parseIdentifier();
      return typeName.name;
    }
    shouldParseAsAmbientContext() {
      return !!this.getPluginOption('typescript', 'dts');
    }
    parse() {
      if (this.shouldParseAsAmbientContext()) {
        this.state.isAmbientContext = true;
      }
      return super.parse();
    }
    getExpression() {
      if (this.shouldParseAsAmbientContext()) {
        this.state.isAmbientContext = true;
      }
      return super.getExpression();
    }
    parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
      if (!isString && isMaybeTypeOnly) {
        this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
        return this.finishNode(node, 'ExportSpecifier');
      }
      node.exportKind = 'value';
      return super.parseExportSpecifier(
        node,
        isString,
        isInTypeExport,
        isMaybeTypeOnly
      );
    }
    parseImportSpecifier(
      specifier,
      importedIsString,
      isInTypeOnlyImport,
      isMaybeTypeOnly,
      bindingType
    ) {
      if (!importedIsString && isMaybeTypeOnly) {
        this.parseTypeOnlyImportExportSpecifier(
          specifier,
          true,
          isInTypeOnlyImport
        );
        return this.finishNode(specifier, 'ImportSpecifier');
      }
      specifier.importKind = 'value';
      return super.parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        isInTypeOnlyImport ? BIND_TS_TYPE_IMPORT : BIND_FLAGS_TS_IMPORT
      );
    }
    parseTypeOnlyImportExportSpecifier(
      node,
      isImport,
      isInTypeOnlyImportExport
    ) {
      const leftOfAsKey = isImport ? 'imported' : 'local';
      const rightOfAsKey = isImport ? 'local' : 'exported';
      let leftOfAs = node[leftOfAsKey];
      let rightOfAs;
      let hasTypeSpecifier = false;
      let canParseAsKeyword = true;
      const loc = leftOfAs.loc.start;
      if (this.isContextual(93)) {
        const firstAs = this.parseIdentifier();
        if (this.isContextual(93)) {
          const secondAs = this.parseIdentifier();
          if (tokenIsKeywordOrIdentifier(this.state.type)) {
            hasTypeSpecifier = true;
            leftOfAs = firstAs;
            rightOfAs = isImport
              ? this.parseIdentifier()
              : this.parseModuleExportName();
            canParseAsKeyword = false;
          } else {
            rightOfAs = secondAs;
            canParseAsKeyword = false;
          }
        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
          canParseAsKeyword = false;
          rightOfAs = isImport
            ? this.parseIdentifier()
            : this.parseModuleExportName();
        } else {
          hasTypeSpecifier = true;
          leftOfAs = firstAs;
        }
      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
        hasTypeSpecifier = true;
        if (isImport) {
          leftOfAs = this.parseIdentifier(true);
          if (!this.isContextual(93)) {
            this.checkReservedWord(
              leftOfAs.name,
              leftOfAs.loc.start,
              true,
              true
            );
          }
        } else {
          leftOfAs = this.parseModuleExportName();
        }
      }
      if (hasTypeSpecifier && isInTypeOnlyImportExport) {
        this.raise(
          isImport
            ? TSErrors.TypeModifierIsUsedInTypeImports
            : TSErrors.TypeModifierIsUsedInTypeExports,
          {at: loc}
        );
      }
      node[leftOfAsKey] = leftOfAs;
      node[rightOfAsKey] = rightOfAs;
      const kindKey = isImport ? 'importKind' : 'exportKind';
      node[kindKey] = hasTypeSpecifier ? 'type' : 'value';
      if (canParseAsKeyword && this.eatContextual(93)) {
        node[rightOfAsKey] = isImport
          ? this.parseIdentifier()
          : this.parseModuleExportName();
      }
      if (!node[rightOfAsKey]) {
        node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
      }
      if (isImport) {
        this.checkIdentifier(
          node[rightOfAsKey],
          hasTypeSpecifier ? BIND_TS_TYPE_IMPORT : BIND_FLAGS_TS_IMPORT
        );
      }
    }
  };
function isPossiblyLiteralEnum(expression) {
  if (expression.type !== 'MemberExpression') return false;
  const {computed: computed, property: property} = expression;
  if (
    computed &&
    property.type !== 'StringLiteral' &&
    (property.type !== 'TemplateLiteral' || property.expressions.length > 0)
  ) {
    return false;
  }
  return isUncomputedMemberExpressionChain(expression.object);
}
function isUncomputedMemberExpressionChain(expression) {
  if (expression.type === 'Identifier') return true;
  if (expression.type !== 'MemberExpression') return false;
  if (expression.computed) return false;
  return isUncomputedMemberExpressionChain(expression.object);
}
const PlaceholderErrors = ParseErrorEnum`placeholders`({
  ClassNameIsRequired: 'A class name is required.',
  UnexpectedSpace: 'Unexpected space in placeholder.',
});
var placeholders = superClass =>
  class PlaceholdersParserMixin extends superClass {
    parsePlaceholder(expectedNode) {
      if (this.match(140)) {
        const node = this.startNode();
        this.next();
        this.assertNoSpace();
        node.name = super.parseIdentifier(true);
        this.assertNoSpace();
        this.expect(140);
        return this.finishPlaceholder(node, expectedNode);
      }
    }
    finishPlaceholder(node, expectedNode) {
      const isFinished = !!(node.expectedNode && node.type === 'Placeholder');
      node.expectedNode = expectedNode;
      return isFinished ? node : this.finishNode(node, 'Placeholder');
    }
    getTokenFromCode(code) {
      if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
        return this.finishOp(140, 2);
      }
      return super.getTokenFromCode(code);
    }
    parseExprAtom(refExpressionErrors) {
      return (
        this.parsePlaceholder('Expression') ||
        super.parseExprAtom(refExpressionErrors)
      );
    }
    parseIdentifier(liberal) {
      return (
        this.parsePlaceholder('Identifier') || super.parseIdentifier(liberal)
      );
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (word !== undefined) {
        super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
      }
    }
    parseBindingAtom() {
      return this.parsePlaceholder('Pattern') || super.parseBindingAtom();
    }
    isValidLVal(type, isParenthesized, binding) {
      return (
        type === 'Placeholder' ||
        super.isValidLVal(type, isParenthesized, binding)
      );
    }
    toAssignable(node, isLHS) {
      if (
        node &&
        node.type === 'Placeholder' &&
        node.expectedNode === 'Expression'
      ) {
        node.expectedNode = 'Pattern';
      } else {
        super.toAssignable(node, isLHS);
      }
    }
    isLet(context) {
      if (super.isLet(context)) {
        return true;
      }
      if (!this.isContextual(99)) {
        return false;
      }
      if (context) return false;
      const nextToken = this.lookahead();
      if (nextToken.type === 140) {
        return true;
      }
      return false;
    }
    verifyBreakContinue(node, isBreak) {
      if (node.label && node.label.type === 'Placeholder') return;
      super.verifyBreakContinue(node, isBreak);
    }
    parseExpressionStatement(node, expr) {
      if (
        expr.type !== 'Placeholder' ||
        (expr.extra && expr.extra.parenthesized)
      ) {
        return super.parseExpressionStatement(node, expr);
      }
      if (this.match(14)) {
        const stmt = node;
        stmt.label = this.finishPlaceholder(expr, 'Identifier');
        this.next();
        stmt.body = super.parseStatement('label');
        return this.finishNode(stmt, 'LabeledStatement');
      }
      this.semicolon();
      node.name = expr.name;
      return this.finishPlaceholder(node, 'Statement');
    }
    parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
      return (
        this.parsePlaceholder('BlockStatement') ||
        super.parseBlock(
          allowDirectives,
          createNewLexicalScope,
          afterBlockParse
        )
      );
    }
    parseFunctionId(requireId) {
      return (
        this.parsePlaceholder('Identifier') || super.parseFunctionId(requireId)
      );
    }
    parseClass(node, isStatement, optionalId) {
      const type = isStatement ? 'ClassDeclaration' : 'ClassExpression';
      this.next();
      this.takeDecorators(node);
      const oldStrict = this.state.strict;
      const placeholder = this.parsePlaceholder('Identifier');
      if (placeholder) {
        if (this.match(81) || this.match(140) || this.match(5)) {
          node.id = placeholder;
        } else if (optionalId || !isStatement) {
          node.id = null;
          node.body = this.finishPlaceholder(placeholder, 'ClassBody');
          return this.finishNode(node, type);
        } else {
          throw this.raise(PlaceholderErrors.ClassNameIsRequired, {
            at: this.state.startLoc,
          });
        }
      } else {
        this.parseClassId(node, isStatement, optionalId);
      }
      super.parseClassSuper(node);
      node.body =
        this.parsePlaceholder('ClassBody') ||
        super.parseClassBody(!!node.superClass, oldStrict);
      return this.finishNode(node, type);
    }
    parseExport(node) {
      const placeholder = this.parsePlaceholder('Identifier');
      if (!placeholder) return super.parseExport(node);
      if (!this.isContextual(97) && !this.match(12)) {
        node.specifiers = [];
        node.source = null;
        node.declaration = this.finishPlaceholder(placeholder, 'Declaration');
        return this.finishNode(node, 'ExportNamedDeclaration');
      }
      this.expectPlugin('exportDefaultFrom');
      const specifier = this.startNode();
      specifier.exported = placeholder;
      node.specifiers = [this.finishNode(specifier, 'ExportDefaultSpecifier')];
      return super.parseExport(node);
    }
    isExportDefaultSpecifier() {
      if (this.match(65)) {
        const next = this.nextTokenStart();
        if (this.isUnparsedContextual(next, 'from')) {
          if (
            this.input.startsWith(
              tokenLabelName(140),
              this.nextTokenStartSince(next + 4)
            )
          ) {
            return true;
          }
        }
      }
      return super.isExportDefaultSpecifier();
    }
    maybeParseExportDefaultSpecifier(node) {
      if (node.specifiers && node.specifiers.length > 0) {
        return true;
      }
      return super.maybeParseExportDefaultSpecifier(node);
    }
    checkExport(node) {
      const {specifiers: specifiers} = node;
      if (specifiers != null && specifiers.length) {
        node.specifiers = specifiers.filter(
          node => node.exported.type === 'Placeholder'
        );
      }
      super.checkExport(node);
      node.specifiers = specifiers;
    }
    parseImport(node) {
      const placeholder = this.parsePlaceholder('Identifier');
      if (!placeholder) return super.parseImport(node);
      node.specifiers = [];
      if (!this.isContextual(97) && !this.match(12)) {
        node.source = this.finishPlaceholder(placeholder, 'StringLiteral');
        this.semicolon();
        return this.finishNode(node, 'ImportDeclaration');
      }
      const specifier = this.startNodeAtNode(placeholder);
      specifier.local = placeholder;
      node.specifiers.push(
        this.finishNode(specifier, 'ImportDefaultSpecifier')
      );
      if (this.eat(12)) {
        const hasStarImport = this.maybeParseStarImportSpecifier(node);
        if (!hasStarImport) this.parseNamedImportSpecifiers(node);
      }
      this.expectContextual(97);
      node.source = this.parseImportSource();
      this.semicolon();
      return this.finishNode(node, 'ImportDeclaration');
    }
    parseImportSource() {
      return (
        this.parsePlaceholder('StringLiteral') || super.parseImportSource()
      );
    }
    assertNoSpace() {
      if (this.state.start > this.state.lastTokEndLoc.index) {
        this.raise(PlaceholderErrors.UnexpectedSpace, {
          at: this.state.lastTokEndLoc,
        });
      }
    }
  };
var v8intrinsic = superClass =>
  class V8IntrinsicMixin extends superClass {
    parseV8Intrinsic() {
      if (this.match(54)) {
        const v8IntrinsicStartLoc = this.state.startLoc;
        const node = this.startNode();
        this.next();
        if (tokenIsIdentifier(this.state.type)) {
          const name = this.parseIdentifierName(this.state.start);
          const identifier = this.createIdentifier(node, name);
          identifier.type = 'V8IntrinsicIdentifier';
          if (this.match(10)) {
            return identifier;
          }
        }
        this.unexpected(v8IntrinsicStartLoc);
      }
    }
    parseExprAtom(refExpressionErrors) {
      return (
        this.parseV8Intrinsic() || super.parseExprAtom(refExpressionErrors)
      );
    }
  };
function hasPlugin(plugins, expectedConfig) {
  const [expectedName, expectedOptions] =
    typeof expectedConfig === 'string' ? [expectedConfig, {}] : expectedConfig;
  const expectedKeys = Object.keys(expectedOptions);
  const expectedOptionsIsEmpty = expectedKeys.length === 0;
  return plugins.some(p => {
    if (typeof p === 'string') {
      return expectedOptionsIsEmpty && p === expectedName;
    } else {
      const [pluginName, pluginOptions] = p;
      if (pluginName !== expectedName) {
        return false;
      }
      for (const key of expectedKeys) {
        if (pluginOptions[key] !== expectedOptions[key]) {
          return false;
        }
      }
      return true;
    }
  });
}
function getPluginOption(plugins, name, option) {
  const plugin = plugins.find(plugin => {
    if (Array.isArray(plugin)) {
      return plugin[0] === name;
    } else {
      return plugin === name;
    }
  });
  if (plugin && Array.isArray(plugin) && plugin.length > 1) {
    return plugin[1][option];
  }
  return null;
}
const PIPELINE_PROPOSALS = ['minimal', 'fsharp', 'hack', 'smart'];
const TOPIC_TOKENS = ['^^', '@@', '^', '%', '#'];
const RECORD_AND_TUPLE_SYNTAX_TYPES = ['hash', 'bar'];
function validatePlugins(plugins) {
  if (hasPlugin(plugins, 'decorators')) {
    if (hasPlugin(plugins, 'decorators-legacy')) {
      throw new Error(
        'Cannot use the decorators and decorators-legacy plugin together'
      );
    }
    const decoratorsBeforeExport = getPluginOption(
      plugins,
      'decorators',
      'decoratorsBeforeExport'
    );
    if (
      decoratorsBeforeExport != null &&
      typeof decoratorsBeforeExport !== 'boolean'
    ) {
      throw new Error("'decoratorsBeforeExport' must be a boolean.");
    }
    const allowCallParenthesized = getPluginOption(
      plugins,
      'decorators',
      'allowCallParenthesized'
    );
    if (
      allowCallParenthesized != null &&
      typeof allowCallParenthesized !== 'boolean'
    ) {
      throw new Error("'allowCallParenthesized' must be a boolean.");
    }
  }
  if (hasPlugin(plugins, 'flow') && hasPlugin(plugins, 'typescript')) {
    throw new Error('Cannot combine flow and typescript plugins.');
  }
  if (hasPlugin(plugins, 'placeholders') && hasPlugin(plugins, 'v8intrinsic')) {
    throw new Error('Cannot combine placeholders and v8intrinsic plugins.');
  }
  if (hasPlugin(plugins, 'pipelineOperator')) {
    const proposal = getPluginOption(plugins, 'pipelineOperator', 'proposal');
    if (!PIPELINE_PROPOSALS.includes(proposal)) {
      const proposalList = PIPELINE_PROPOSALS.map(p => `"${p}"`).join(', ');
      throw new Error(
        `"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`
      );
    }
    const tupleSyntaxIsHash = hasPlugin(plugins, [
      'recordAndTuple',
      {syntaxType: 'hash'},
    ]);
    if (proposal === 'hack') {
      if (hasPlugin(plugins, 'placeholders')) {
        throw new Error(
          'Cannot combine placeholders plugin and Hack-style pipes.'
        );
      }
      if (hasPlugin(plugins, 'v8intrinsic')) {
        throw new Error(
          'Cannot combine v8intrinsic plugin and Hack-style pipes.'
        );
      }
      const topicToken = getPluginOption(
        plugins,
        'pipelineOperator',
        'topicToken'
      );
      if (!TOPIC_TOKENS.includes(topicToken)) {
        const tokenList = TOPIC_TOKENS.map(t => `"${t}"`).join(', ');
        throw new Error(
          `"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`
        );
      }
      if (topicToken === '#' && tupleSyntaxIsHash) {
        throw new Error(
          'Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.'
        );
      }
    } else if (proposal === 'smart' && tupleSyntaxIsHash) {
      throw new Error(
        'Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.'
      );
    }
  }
  if (hasPlugin(plugins, 'moduleAttributes')) {
    {
      if (hasPlugin(plugins, 'importAssertions')) {
        throw new Error(
          'Cannot combine importAssertions and moduleAttributes plugins.'
        );
      }
      const moduleAttributesVersionPluginOption = getPluginOption(
        plugins,
        'moduleAttributes',
        'version'
      );
      if (moduleAttributesVersionPluginOption !== 'may-2020') {
        throw new Error(
          "The 'moduleAttributes' plugin requires a 'version' option," +
            ' representing the last proposal update. Currently, the' +
            " only supported value is 'may-2020'."
        );
      }
    }
  }
  if (
    hasPlugin(plugins, 'recordAndTuple') &&
    getPluginOption(plugins, 'recordAndTuple', 'syntaxType') != null &&
    !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(
      getPluginOption(plugins, 'recordAndTuple', 'syntaxType')
    )
  ) {
    throw new Error(
      "The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " +
        RECORD_AND_TUPLE_SYNTAX_TYPES.map(p => `'${p}'`).join(', ')
    );
  }
  if (
    hasPlugin(plugins, 'asyncDoExpressions') &&
    !hasPlugin(plugins, 'doExpressions')
  ) {
    const error = new Error(
      "'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins."
    );
    error.missingPlugins = 'doExpressions';
    throw error;
  }
}
const mixinPlugins = {
  estree: estree,
  jsx: jsx$2,
  flow: flow$2,
  typescript: typescript$2,
  v8intrinsic: v8intrinsic,
  placeholders: placeholders,
};
const mixinPluginNames = Object.keys(mixinPlugins);
const defaultOptions$1 = {
  sourceType: 'script',
  sourceFilename: undefined,
  startColumn: 0,
  startLine: 1,
  allowAwaitOutsideFunction: false,
  allowReturnOutsideFunction: false,
  allowImportExportEverywhere: false,
  allowSuperOutsideMethod: false,
  allowUndeclaredExports: false,
  plugins: [],
  strictMode: null,
  ranges: false,
  tokens: false,
  createParenthesizedExpressions: false,
  errorRecovery: false,
  attachComment: true,
};
function getOptions(opts) {
  const options = {};
  for (const key of Object.keys(defaultOptions$1)) {
    options[key] =
      opts && opts[key] != null ? opts[key] : defaultOptions$1[key];
  }
  return options;
}
const getOwn = (object, key) =>
  Object.hasOwnProperty.call(object, key) && object[key];
const unwrapParenthesizedExpression = node =>
  node.type === 'ParenthesizedExpression'
    ? unwrapParenthesizedExpression(node.expression)
    : node;
class LValParser extends NodeUtils {
  toAssignable(node, isLHS = false) {
    var _node$extra, _node$extra3;
    let parenthesized = undefined;
    if (
      node.type === 'ParenthesizedExpression' ||
      ((_node$extra = node.extra) != null && _node$extra.parenthesized)
    ) {
      parenthesized = unwrapParenthesizedExpression(node);
      if (isLHS) {
        if (parenthesized.type === 'Identifier') {
          this.expressionScope.recordArrowParemeterBindingError(
            Errors.InvalidParenthesizedAssignment,
            {at: node}
          );
        } else if (parenthesized.type !== 'MemberExpression') {
          this.raise(Errors.InvalidParenthesizedAssignment, {at: node});
        }
      } else {
        this.raise(Errors.InvalidParenthesizedAssignment, {at: node});
      }
    }
    switch (node.type) {
      case 'Identifier':
      case 'ObjectPattern':
      case 'ArrayPattern':
      case 'AssignmentPattern':
      case 'RestElement':
        break;
      case 'ObjectExpression':
        node.type = 'ObjectPattern';
        for (
          let i = 0, length = node.properties.length, last = length - 1;
          i < length;
          i++
        ) {
          var _node$extra2;
          const prop = node.properties[i];
          const isLast = i === last;
          this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
          if (
            isLast &&
            prop.type === 'RestElement' &&
            (_node$extra2 = node.extra) != null &&
            _node$extra2.trailingCommaLoc
          ) {
            this.raise(Errors.RestTrailingComma, {
              at: node.extra.trailingCommaLoc,
            });
          }
        }
        break;
      case 'ObjectProperty': {
        const {key: key, value: value} = node;
        if (this.isPrivateName(key)) {
          this.classScope.usePrivateName(
            this.getPrivateNameSV(key),
            key.loc.start
          );
        }
        this.toAssignable(value, isLHS);
        break;
      }
      case 'SpreadElement': {
        throw new Error(
          'Internal @babel/parser error (this is a bug, please report it).' +
            " SpreadElement should be converted by .toAssignable's caller."
        );
      }
      case 'ArrayExpression':
        node.type = 'ArrayPattern';
        this.toAssignableList(
          node.elements,
          (_node$extra3 = node.extra) == null
            ? void 0
            : _node$extra3.trailingCommaLoc,
          isLHS
        );
        break;
      case 'AssignmentExpression':
        if (node.operator !== '=') {
          this.raise(Errors.MissingEqInAssignment, {at: node.left.loc.end});
        }
        node.type = 'AssignmentPattern';
        delete node.operator;
        this.toAssignable(node.left, isLHS);
        break;
      case 'ParenthesizedExpression':
        this.toAssignable(parenthesized, isLHS);
        break;
    }
  }
  toAssignableObjectExpressionProp(prop, isLast, isLHS) {
    if (prop.type === 'ObjectMethod') {
      this.raise(
        prop.kind === 'get' || prop.kind === 'set'
          ? Errors.PatternHasAccessor
          : Errors.PatternHasMethod,
        {at: prop.key}
      );
    } else if (prop.type === 'SpreadElement') {
      prop.type = 'RestElement';
      const arg = prop.argument;
      this.checkToRestConversion(arg, false);
      this.toAssignable(arg, isLHS);
      if (!isLast) {
        this.raise(Errors.RestTrailingComma, {at: prop});
      }
    } else {
      this.toAssignable(prop, isLHS);
    }
  }
  toAssignableList(exprList, trailingCommaLoc, isLHS) {
    const end = exprList.length - 1;
    for (let i = 0; i <= end; i++) {
      const elt = exprList[i];
      if (!elt) continue;
      if (elt.type === 'SpreadElement') {
        elt.type = 'RestElement';
        const arg = elt.argument;
        this.checkToRestConversion(arg, true);
        this.toAssignable(arg, isLHS);
      } else {
        this.toAssignable(elt, isLHS);
      }
      if (elt.type === 'RestElement') {
        if (i < end) {
          this.raise(Errors.RestTrailingComma, {at: elt});
        } else if (trailingCommaLoc) {
          this.raise(Errors.RestTrailingComma, {at: trailingCommaLoc});
        }
      }
    }
  }
  isAssignable(node, isBinding) {
    switch (node.type) {
      case 'Identifier':
      case 'ObjectPattern':
      case 'ArrayPattern':
      case 'AssignmentPattern':
      case 'RestElement':
        return true;
      case 'ObjectExpression': {
        const last = node.properties.length - 1;
        return node.properties.every(
          (prop, i) =>
            prop.type !== 'ObjectMethod' &&
            (i === last || prop.type !== 'SpreadElement') &&
            this.isAssignable(prop)
        );
      }
      case 'ObjectProperty':
        return this.isAssignable(node.value);
      case 'SpreadElement':
        return this.isAssignable(node.argument);
      case 'ArrayExpression':
        return node.elements.every(
          element => element === null || this.isAssignable(element)
        );
      case 'AssignmentExpression':
        return node.operator === '=';
      case 'ParenthesizedExpression':
        return this.isAssignable(node.expression);
      case 'MemberExpression':
      case 'OptionalMemberExpression':
        return !isBinding;
      default:
        return false;
    }
  }
  toReferencedList(exprList, isParenthesizedExpr) {
    return exprList;
  }
  toReferencedListDeep(exprList, isParenthesizedExpr) {
    this.toReferencedList(exprList, isParenthesizedExpr);
    for (const expr of exprList) {
      if ((expr == null ? void 0 : expr.type) === 'ArrayExpression') {
        this.toReferencedListDeep(expr.elements);
      }
    }
  }
  parseSpread(refExpressionErrors) {
    const node = this.startNode();
    this.next();
    node.argument = this.parseMaybeAssignAllowIn(
      refExpressionErrors,
      undefined
    );
    return this.finishNode(node, 'SpreadElement');
  }
  parseRestBinding() {
    const node = this.startNode();
    this.next();
    node.argument = this.parseBindingAtom();
    return this.finishNode(node, 'RestElement');
  }
  parseBindingAtom() {
    switch (this.state.type) {
      case 0: {
        const node = this.startNode();
        this.next();
        node.elements = this.parseBindingList(3, 93, true);
        return this.finishNode(node, 'ArrayPattern');
      }
      case 5:
        return this.parseObjectLike(8, true);
    }
    return this.parseIdentifier();
  }
  parseBindingList(close, closeCharCode, allowEmpty, allowModifiers) {
    const elts = [];
    let first = true;
    while (!this.eat(close)) {
      if (first) {
        first = false;
      } else {
        this.expect(12);
      }
      if (allowEmpty && this.match(12)) {
        elts.push(null);
      } else if (this.eat(close)) {
        break;
      } else if (this.match(21)) {
        elts.push(this.parseAssignableListItemTypes(this.parseRestBinding()));
        if (!this.checkCommaAfterRest(closeCharCode)) {
          this.expect(close);
          break;
        }
      } else {
        const decorators = [];
        if (this.match(26) && this.hasPlugin('decorators')) {
          this.raise(Errors.UnsupportedParameterDecorator, {
            at: this.state.startLoc,
          });
        }
        while (this.match(26)) {
          decorators.push(this.parseDecorator());
        }
        elts.push(this.parseAssignableListItem(allowModifiers, decorators));
      }
    }
    return elts;
  }
  parseBindingRestProperty(prop) {
    this.next();
    prop.argument = this.parseIdentifier();
    this.checkCommaAfterRest(125);
    return this.finishNode(prop, 'RestElement');
  }
  parseBindingProperty() {
    const prop = this.startNode();
    const {type: type, start: startPos, startLoc: startLoc} = this.state;
    if (type === 21) {
      return this.parseBindingRestProperty(prop);
    } else if (type === 134) {
      this.expectPlugin('destructuringPrivate', startLoc);
      this.classScope.usePrivateName(this.state.value, startLoc);
      prop.key = this.parsePrivateName();
    } else {
      this.parsePropertyName(prop);
    }
    prop.method = false;
    return this.parseObjPropValue(
      prop,
      startPos,
      startLoc,
      false,
      false,
      true,
      false
    );
  }
  parseAssignableListItem(allowModifiers, decorators) {
    const left = this.parseMaybeDefault();
    this.parseAssignableListItemTypes(left);
    const elt = this.parseMaybeDefault(left.start, left.loc.start, left);
    if (decorators.length) {
      left.decorators = decorators;
    }
    return elt;
  }
  parseAssignableListItemTypes(param) {
    return param;
  }
  parseMaybeDefault(startPos, startLoc, left) {
    var _startLoc, _startPos, _left;
    startLoc = (_startLoc = startLoc) != null ? _startLoc : this.state.startLoc;
    startPos = (_startPos = startPos) != null ? _startPos : this.state.start;
    left = (_left = left) != null ? _left : this.parseBindingAtom();
    if (!this.eat(29)) return left;
    const node = this.startNodeAt(startPos, startLoc);
    node.left = left;
    node.right = this.parseMaybeAssignAllowIn();
    return this.finishNode(node, 'AssignmentPattern');
  }
  isValidLVal(type, isUnparenthesizedInAssign, binding) {
    return getOwn(
      {
        AssignmentPattern: 'left',
        RestElement: 'argument',
        ObjectProperty: 'value',
        ParenthesizedExpression: 'expression',
        ArrayPattern: 'elements',
        ObjectPattern: 'properties',
      },
      type
    );
  }
  checkLVal(
    expression,
    {
      in: ancestor,
      binding: binding = BIND_NONE,
      checkClashes: checkClashes = false,
      strictModeChanged: strictModeChanged = false,
      allowingSloppyLetBinding: allowingSloppyLetBinding = !(
        binding & BIND_SCOPE_LEXICAL
      ),
      hasParenthesizedAncestor: hasParenthesizedAncestor = false,
    }
  ) {
    var _expression$extra;
    const type = expression.type;
    if (this.isObjectMethod(expression)) return;
    if (type === 'MemberExpression') {
      if (binding !== BIND_NONE) {
        this.raise(Errors.InvalidPropertyBindingPattern, {at: expression});
      }
      return;
    }
    if (expression.type === 'Identifier') {
      this.checkIdentifier(
        expression,
        binding,
        strictModeChanged,
        allowingSloppyLetBinding
      );
      const {name: name} = expression;
      if (checkClashes) {
        if (checkClashes.has(name)) {
          this.raise(Errors.ParamDupe, {at: expression});
        } else {
          checkClashes.add(name);
        }
      }
      return;
    }
    const validity = this.isValidLVal(
      expression.type,
      !(
        hasParenthesizedAncestor ||
        ((_expression$extra = expression.extra) != null &&
          _expression$extra.parenthesized)
      ) && ancestor.type === 'AssignmentExpression',
      binding
    );
    if (validity === true) return;
    if (validity === false) {
      const ParseErrorClass =
        binding === BIND_NONE ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
      this.raise(ParseErrorClass, {
        at: expression,
        ancestor:
          ancestor.type === 'UpdateExpression'
            ? {type: 'UpdateExpression', prefix: ancestor.prefix}
            : {type: ancestor.type},
      });
      return;
    }
    const [key, isParenthesizedExpression] = Array.isArray(validity)
      ? validity
      : [validity, type === 'ParenthesizedExpression'];
    const nextAncestor =
      expression.type === 'ArrayPattern' ||
      expression.type === 'ObjectPattern' ||
      expression.type === 'ParenthesizedExpression'
        ? expression
        : ancestor;
    for (const child of [].concat(expression[key])) {
      if (child) {
        this.checkLVal(child, {
          in: nextAncestor,
          binding: binding,
          checkClashes: checkClashes,
          allowingSloppyLetBinding: allowingSloppyLetBinding,
          strictModeChanged: strictModeChanged,
          hasParenthesizedAncestor: isParenthesizedExpression,
        });
      }
    }
  }
  checkIdentifier(
    at,
    bindingType,
    strictModeChanged = false,
    allowLetBinding = !(bindingType & BIND_SCOPE_LEXICAL)
  ) {
    if (
      this.state.strict &&
      (strictModeChanged
        ? isStrictBindReservedWord(at.name, this.inModule)
        : isStrictBindOnlyReservedWord(at.name))
    ) {
      if (bindingType === BIND_NONE) {
        this.raise(Errors.StrictEvalArguments, {
          at: at,
          referenceName: at.name,
        });
      } else {
        this.raise(Errors.StrictEvalArgumentsBinding, {
          at: at,
          bindingName: at.name,
        });
      }
    }
    if (!allowLetBinding && at.name === 'let') {
      this.raise(Errors.LetInLexicalBinding, {at: at});
    }
    if (!(bindingType & BIND_NONE)) {
      this.declareNameFromIdentifier(at, bindingType);
    }
  }
  declareNameFromIdentifier(identifier, binding) {
    this.scope.declareName(identifier.name, binding, identifier.loc.start);
  }
  checkToRestConversion(node, allowPattern) {
    switch (node.type) {
      case 'ParenthesizedExpression':
        this.checkToRestConversion(node.expression, allowPattern);
        break;
      case 'Identifier':
      case 'MemberExpression':
        break;
      case 'ArrayExpression':
      case 'ObjectExpression':
        if (allowPattern) break;
      default:
        this.raise(Errors.InvalidRestAssignmentPattern, {at: node});
    }
  }
  checkCommaAfterRest(close) {
    if (!this.match(12)) {
      return false;
    }
    this.raise(
      this.lookaheadCharCode() === close
        ? Errors.RestTrailingComma
        : Errors.ElementAfterRest,
      {at: this.state.startLoc}
    );
    return true;
  }
}
class ExpressionParser extends LValParser {
  checkProto(prop, isRecord, protoRef, refExpressionErrors) {
    if (
      prop.type === 'SpreadElement' ||
      this.isObjectMethod(prop) ||
      prop.computed ||
      prop.shorthand
    ) {
      return;
    }
    const key = prop.key;
    const name = key.type === 'Identifier' ? key.name : key.value;
    if (name === '__proto__') {
      if (isRecord) {
        this.raise(Errors.RecordNoProto, {at: key});
        return;
      }
      if (protoRef.used) {
        if (refExpressionErrors) {
          if (refExpressionErrors.doubleProtoLoc === null) {
            refExpressionErrors.doubleProtoLoc = key.loc.start;
          }
        } else {
          this.raise(Errors.DuplicateProto, {at: key});
        }
      }
      protoRef.used = true;
    }
  }
  shouldExitDescending(expr, potentialArrowAt) {
    return (
      expr.type === 'ArrowFunctionExpression' && expr.start === potentialArrowAt
    );
  }
  getExpression() {
    this.enterInitialScopes();
    this.nextToken();
    const expr = this.parseExpression();
    if (!this.match(135)) {
      this.unexpected();
    }
    this.finalizeRemainingComments();
    expr.comments = this.state.comments;
    expr.errors = this.state.errors;
    if (this.options.tokens) {
      expr.tokens = this.tokens;
    }
    return expr;
  }
  parseExpression(disallowIn, refExpressionErrors) {
    if (disallowIn) {
      return this.disallowInAnd(() =>
        this.parseExpressionBase(refExpressionErrors)
      );
    }
    return this.allowInAnd(() => this.parseExpressionBase(refExpressionErrors));
  }
  parseExpressionBase(refExpressionErrors) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    const expr = this.parseMaybeAssign(refExpressionErrors);
    if (this.match(12)) {
      const node = this.startNodeAt(startPos, startLoc);
      node.expressions = [expr];
      while (this.eat(12)) {
        node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
      }
      this.toReferencedList(node.expressions);
      return this.finishNode(node, 'SequenceExpression');
    }
    return expr;
  }
  parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
    return this.disallowInAnd(() =>
      this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
    );
  }
  parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
    return this.allowInAnd(() =>
      this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
    );
  }
  setOptionalParametersError(refExpressionErrors, resultError) {
    var _resultError$loc;
    refExpressionErrors.optionalParametersLoc =
      (_resultError$loc = resultError == null ? void 0 : resultError.loc) !=
      null
        ? _resultError$loc
        : this.state.startLoc;
  }
  parseMaybeAssign(refExpressionErrors, afterLeftParse) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    if (this.isContextual(105)) {
      if (this.prodParam.hasYield) {
        let left = this.parseYield();
        if (afterLeftParse) {
          left = afterLeftParse.call(this, left, startPos, startLoc);
        }
        return left;
      }
    }
    let ownExpressionErrors;
    if (refExpressionErrors) {
      ownExpressionErrors = false;
    } else {
      refExpressionErrors = new ExpressionErrors();
      ownExpressionErrors = true;
    }
    const {type: type} = this.state;
    if (type === 10 || tokenIsIdentifier(type)) {
      this.state.potentialArrowAt = this.state.start;
    }
    let left = this.parseMaybeConditional(refExpressionErrors);
    if (afterLeftParse) {
      left = afterLeftParse.call(this, left, startPos, startLoc);
    }
    if (tokenIsAssignment(this.state.type)) {
      const node = this.startNodeAt(startPos, startLoc);
      const operator = this.state.value;
      node.operator = operator;
      if (this.match(29)) {
        this.toAssignable(left, true);
        node.left = left;
        if (
          refExpressionErrors.doubleProtoLoc != null &&
          refExpressionErrors.doubleProtoLoc.index >= startPos
        ) {
          refExpressionErrors.doubleProtoLoc = null;
        }
        if (
          refExpressionErrors.shorthandAssignLoc != null &&
          refExpressionErrors.shorthandAssignLoc.index >= startPos
        ) {
          refExpressionErrors.shorthandAssignLoc = null;
        }
        if (
          refExpressionErrors.privateKeyLoc != null &&
          refExpressionErrors.privateKeyLoc.index >= startPos
        ) {
          this.checkDestructuringPrivate(refExpressionErrors);
          refExpressionErrors.privateKeyLoc = null;
        }
      } else {
        node.left = left;
      }
      this.next();
      node.right = this.parseMaybeAssign();
      this.checkLVal(left, {in: this.finishNode(node, 'AssignmentExpression')});
      return node;
    } else if (ownExpressionErrors) {
      this.checkExpressionErrors(refExpressionErrors, true);
    }
    return left;
  }
  parseMaybeConditional(refExpressionErrors) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    const potentialArrowAt = this.state.potentialArrowAt;
    const expr = this.parseExprOps(refExpressionErrors);
    if (this.shouldExitDescending(expr, potentialArrowAt)) {
      return expr;
    }
    return this.parseConditional(expr, startPos, startLoc, refExpressionErrors);
  }
  parseConditional(expr, startPos, startLoc, refExpressionErrors) {
    if (this.eat(17)) {
      const node = this.startNodeAt(startPos, startLoc);
      node.test = expr;
      node.consequent = this.parseMaybeAssignAllowIn();
      this.expect(14);
      node.alternate = this.parseMaybeAssign();
      return this.finishNode(node, 'ConditionalExpression');
    }
    return expr;
  }
  parseMaybeUnaryOrPrivate(refExpressionErrors) {
    return this.match(134)
      ? this.parsePrivateName()
      : this.parseMaybeUnary(refExpressionErrors);
  }
  parseExprOps(refExpressionErrors) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    const potentialArrowAt = this.state.potentialArrowAt;
    const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
    if (this.shouldExitDescending(expr, potentialArrowAt)) {
      return expr;
    }
    return this.parseExprOp(expr, startPos, startLoc, -1);
  }
  parseExprOp(left, leftStartPos, leftStartLoc, minPrec) {
    if (this.isPrivateName(left)) {
      const value = this.getPrivateNameSV(left);
      if (
        minPrec >= tokenOperatorPrecedence(58) ||
        !this.prodParam.hasIn ||
        !this.match(58)
      ) {
        this.raise(Errors.PrivateInExpectedIn, {
          at: left,
          identifierName: value,
        });
      }
      this.classScope.usePrivateName(value, left.loc.start);
    }
    const op = this.state.type;
    if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
      let prec = tokenOperatorPrecedence(op);
      if (prec > minPrec) {
        if (op === 39) {
          this.expectPlugin('pipelineOperator');
          if (this.state.inFSharpPipelineDirectBody) {
            return left;
          }
          this.checkPipelineAtInfixOperator(left, leftStartLoc);
        }
        const node = this.startNodeAt(leftStartPos, leftStartLoc);
        node.left = left;
        node.operator = this.state.value;
        const logical = op === 41 || op === 42;
        const coalesce = op === 40;
        if (coalesce) {
          prec = tokenOperatorPrecedence(42);
        }
        this.next();
        if (
          op === 39 &&
          this.hasPlugin(['pipelineOperator', {proposal: 'minimal'}])
        ) {
          if (this.state.type === 96 && this.prodParam.hasAwait) {
            throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, {
              at: this.state.startLoc,
            });
          }
        }
        node.right = this.parseExprOpRightExpr(op, prec);
        const finishedNode = this.finishNode(
          node,
          logical || coalesce ? 'LogicalExpression' : 'BinaryExpression'
        );
        const nextOp = this.state.type;
        if (
          (coalesce && (nextOp === 41 || nextOp === 42)) ||
          (logical && nextOp === 40)
        ) {
          throw this.raise(Errors.MixingCoalesceWithLogical, {
            at: this.state.startLoc,
          });
        }
        return this.parseExprOp(
          finishedNode,
          leftStartPos,
          leftStartLoc,
          minPrec
        );
      }
    }
    return left;
  }
  parseExprOpRightExpr(op, prec) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    switch (op) {
      case 39:
        switch (this.getPluginOption('pipelineOperator', 'proposal')) {
          case 'hack':
            return this.withTopicBindingContext(() => this.parseHackPipeBody());
          case 'smart':
            return this.withTopicBindingContext(() => {
              if (this.prodParam.hasYield && this.isContextual(105)) {
                throw this.raise(Errors.PipeBodyIsTighter, {
                  at: this.state.startLoc,
                });
              }
              return this.parseSmartPipelineBodyInStyle(
                this.parseExprOpBaseRightExpr(op, prec),
                startPos,
                startLoc
              );
            });
          case 'fsharp':
            return this.withSoloAwaitPermittingContext(() =>
              this.parseFSharpPipelineBody(prec)
            );
        }
      default:
        return this.parseExprOpBaseRightExpr(op, prec);
    }
  }
  parseExprOpBaseRightExpr(op, prec) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    return this.parseExprOp(
      this.parseMaybeUnaryOrPrivate(),
      startPos,
      startLoc,
      tokenIsRightAssociative(op) ? prec - 1 : prec
    );
  }
  parseHackPipeBody() {
    var _body$extra;
    const {startLoc: startLoc} = this.state;
    const body = this.parseMaybeAssign();
    const requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(
      body.type
    );
    if (
      requiredParentheses &&
      !((_body$extra = body.extra) != null && _body$extra.parenthesized)
    ) {
      this.raise(Errors.PipeUnparenthesizedBody, {
        at: startLoc,
        type: body.type,
      });
    }
    if (!this.topicReferenceWasUsedInCurrentContext()) {
      this.raise(Errors.PipeTopicUnused, {at: startLoc});
    }
    return body;
  }
  checkExponentialAfterUnary(node) {
    if (this.match(57)) {
      this.raise(Errors.UnexpectedTokenUnaryExponentiation, {
        at: node.argument,
      });
    }
  }
  parseMaybeUnary(refExpressionErrors, sawUnary) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    const isAwait = this.isContextual(96);
    if (isAwait && this.isAwaitAllowed()) {
      this.next();
      const expr = this.parseAwait(startPos, startLoc);
      if (!sawUnary) this.checkExponentialAfterUnary(expr);
      return expr;
    }
    const update = this.match(34);
    const node = this.startNode();
    if (tokenIsPrefix(this.state.type)) {
      node.operator = this.state.value;
      node.prefix = true;
      if (this.match(72)) {
        this.expectPlugin('throwExpressions');
      }
      const isDelete = this.match(89);
      this.next();
      node.argument = this.parseMaybeUnary(null, true);
      this.checkExpressionErrors(refExpressionErrors, true);
      if (this.state.strict && isDelete) {
        const arg = node.argument;
        if (arg.type === 'Identifier') {
          this.raise(Errors.StrictDelete, {at: node});
        } else if (this.hasPropertyAsPrivateName(arg)) {
          this.raise(Errors.DeletePrivateField, {at: node});
        }
      }
      if (!update) {
        if (!sawUnary) {
          this.checkExponentialAfterUnary(node);
        }
        return this.finishNode(node, 'UnaryExpression');
      }
    }
    const expr = this.parseUpdate(node, update, refExpressionErrors);
    if (isAwait) {
      const {type: type} = this.state;
      const startsExpr = this.hasPlugin('v8intrinsic')
        ? tokenCanStartExpression(type)
        : tokenCanStartExpression(type) && !this.match(54);
      if (startsExpr && !this.isAmbiguousAwait()) {
        this.raiseOverwrite(Errors.AwaitNotInAsyncContext, {at: startLoc});
        return this.parseAwait(startPos, startLoc);
      }
    }
    return expr;
  }
  parseUpdate(node, update, refExpressionErrors) {
    if (update) {
      const updateExpressionNode = node;
      this.checkLVal(updateExpressionNode.argument, {
        in: this.finishNode(updateExpressionNode, 'UpdateExpression'),
      });
      return node;
    }
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    let expr = this.parseExprSubscripts(refExpressionErrors);
    if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
    while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
      const node = this.startNodeAt(startPos, startLoc);
      node.operator = this.state.value;
      node.prefix = false;
      node.argument = expr;
      this.next();
      this.checkLVal(expr, {
        in: (expr = this.finishNode(node, 'UpdateExpression')),
      });
    }
    return expr;
  }
  parseExprSubscripts(refExpressionErrors) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    const potentialArrowAt = this.state.potentialArrowAt;
    const expr = this.parseExprAtom(refExpressionErrors);
    if (this.shouldExitDescending(expr, potentialArrowAt)) {
      return expr;
    }
    return this.parseSubscripts(expr, startPos, startLoc);
  }
  parseSubscripts(base, startPos, startLoc, noCalls) {
    const state = {
      optionalChainMember: false,
      maybeAsyncArrow: this.atPossibleAsyncArrow(base),
      stop: false,
    };
    do {
      base = this.parseSubscript(base, startPos, startLoc, noCalls, state);
      state.maybeAsyncArrow = false;
    } while (!state.stop);
    return base;
  }
  parseSubscript(base, startPos, startLoc, noCalls, state) {
    const {type: type} = this.state;
    if (!noCalls && type === 15) {
      return this.parseBind(base, startPos, startLoc, noCalls, state);
    } else if (tokenIsTemplate(type)) {
      return this.parseTaggedTemplateExpression(
        base,
        startPos,
        startLoc,
        state
      );
    }
    let optional = false;
    if (type === 18) {
      if (noCalls && this.lookaheadCharCode() === 40) {
        state.stop = true;
        return base;
      }
      state.optionalChainMember = optional = true;
      this.next();
    }
    if (!noCalls && this.match(10)) {
      return this.parseCoverCallAndAsyncArrowHead(
        base,
        startPos,
        startLoc,
        state,
        optional
      );
    } else {
      const computed = this.eat(0);
      if (computed || optional || this.eat(16)) {
        return this.parseMember(
          base,
          startPos,
          startLoc,
          state,
          computed,
          optional
        );
      } else {
        state.stop = true;
        return base;
      }
    }
  }
  parseMember(base, startPos, startLoc, state, computed, optional) {
    const node = this.startNodeAt(startPos, startLoc);
    node.object = base;
    node.computed = computed;
    if (computed) {
      node.property = this.parseExpression();
      this.expect(3);
    } else if (this.match(134)) {
      if (base.type === 'Super') {
        this.raise(Errors.SuperPrivateField, {at: startLoc});
      }
      this.classScope.usePrivateName(this.state.value, this.state.startLoc);
      node.property = this.parsePrivateName();
    } else {
      node.property = this.parseIdentifier(true);
    }
    if (state.optionalChainMember) {
      node.optional = optional;
      return this.finishNode(node, 'OptionalMemberExpression');
    } else {
      return this.finishNode(node, 'MemberExpression');
    }
  }
  parseBind(base, startPos, startLoc, noCalls, state) {
    const node = this.startNodeAt(startPos, startLoc);
    node.object = base;
    this.next();
    node.callee = this.parseNoCallExpr();
    state.stop = true;
    return this.parseSubscripts(
      this.finishNode(node, 'BindExpression'),
      startPos,
      startLoc,
      noCalls
    );
  }
  parseCoverCallAndAsyncArrowHead(base, startPos, startLoc, state, optional) {
    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
    let refExpressionErrors = null;
    this.state.maybeInArrowParameters = true;
    this.next();
    const node = this.startNodeAt(startPos, startLoc);
    node.callee = base;
    const {
      maybeAsyncArrow: maybeAsyncArrow,
      optionalChainMember: optionalChainMember,
    } = state;
    if (maybeAsyncArrow) {
      this.expressionScope.enter(newAsyncArrowScope());
      refExpressionErrors = new ExpressionErrors();
    }
    if (optionalChainMember) {
      node.optional = optional;
    }
    if (optional) {
      node.arguments = this.parseCallExpressionArguments(11);
    } else {
      node.arguments = this.parseCallExpressionArguments(
        11,
        base.type === 'Import',
        base.type !== 'Super',
        node,
        refExpressionErrors
      );
    }
    let finishedNode = this.finishCallExpression(node, optionalChainMember);
    if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
      state.stop = true;
      this.checkDestructuringPrivate(refExpressionErrors);
      this.expressionScope.validateAsPattern();
      this.expressionScope.exit();
      finishedNode = this.parseAsyncArrowFromCallExpression(
        this.startNodeAt(startPos, startLoc),
        finishedNode
      );
    } else {
      if (maybeAsyncArrow) {
        this.checkExpressionErrors(refExpressionErrors, true);
        this.expressionScope.exit();
      }
      this.toReferencedArguments(finishedNode);
    }
    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
    return finishedNode;
  }
  toReferencedArguments(node, isParenthesizedExpr) {
    this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
  }
  parseTaggedTemplateExpression(base, startPos, startLoc, state) {
    const node = this.startNodeAt(startPos, startLoc);
    node.tag = base;
    node.quasi = this.parseTemplate(true);
    if (state.optionalChainMember) {
      this.raise(Errors.OptionalChainingNoTemplate, {at: startLoc});
    }
    return this.finishNode(node, 'TaggedTemplateExpression');
  }
  atPossibleAsyncArrow(base) {
    return (
      base.type === 'Identifier' &&
      base.name === 'async' &&
      this.state.lastTokEndLoc.index === base.end &&
      !this.canInsertSemicolon() &&
      base.end - base.start === 5 &&
      base.start === this.state.potentialArrowAt
    );
  }
  finishCallExpression(node, optional) {
    if (node.callee.type === 'Import') {
      if (node.arguments.length === 2) {
        {
          if (!this.hasPlugin('moduleAttributes')) {
            this.expectPlugin('importAssertions');
          }
        }
      }
      if (node.arguments.length === 0 || node.arguments.length > 2) {
        this.raise(Errors.ImportCallArity, {
          at: node,
          maxArgumentCount:
            this.hasPlugin('importAssertions') ||
            this.hasPlugin('moduleAttributes')
              ? 2
              : 1,
        });
      } else {
        for (const arg of node.arguments) {
          if (arg.type === 'SpreadElement') {
            this.raise(Errors.ImportCallSpreadArgument, {at: arg});
          }
        }
      }
    }
    return this.finishNode(
      node,
      optional ? 'OptionalCallExpression' : 'CallExpression'
    );
  }
  parseCallExpressionArguments(
    close,
    dynamicImport,
    allowPlaceholder,
    nodeForExtra,
    refExpressionErrors
  ) {
    const elts = [];
    let first = true;
    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
    this.state.inFSharpPipelineDirectBody = false;
    while (!this.eat(close)) {
      if (first) {
        first = false;
      } else {
        this.expect(12);
        if (this.match(close)) {
          if (
            dynamicImport &&
            !this.hasPlugin('importAssertions') &&
            !this.hasPlugin('moduleAttributes')
          ) {
            this.raise(Errors.ImportCallArgumentTrailingComma, {
              at: this.state.lastTokStartLoc,
            });
          }
          if (nodeForExtra) {
            this.addTrailingCommaExtraToNode(nodeForExtra);
          }
          this.next();
          break;
        }
      }
      elts.push(
        this.parseExprListItem(false, refExpressionErrors, allowPlaceholder)
      );
    }
    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
    return elts;
  }
  shouldParseAsyncArrow() {
    return this.match(19) && !this.canInsertSemicolon();
  }
  parseAsyncArrowFromCallExpression(node, call) {
    var _call$extra;
    this.resetPreviousNodeTrailingComments(call);
    this.expect(19);
    this.parseArrowExpression(
      node,
      call.arguments,
      true,
      (_call$extra = call.extra) == null ? void 0 : _call$extra.trailingCommaLoc
    );
    if (call.innerComments) {
      setInnerComments(node, call.innerComments);
    }
    if (call.callee.trailingComments) {
      setInnerComments(node, call.callee.trailingComments);
    }
    return node;
  }
  parseNoCallExpr() {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    return this.parseSubscripts(this.parseExprAtom(), startPos, startLoc, true);
  }
  parseExprAtom(refExpressionErrors) {
    let node;
    const {type: type} = this.state;
    switch (type) {
      case 79:
        return this.parseSuper();
      case 83:
        node = this.startNode();
        this.next();
        if (this.match(16)) {
          return this.parseImportMetaProperty(node);
        }
        if (!this.match(10)) {
          this.raise(Errors.UnsupportedImport, {
            at: this.state.lastTokStartLoc,
          });
        }
        return this.finishNode(node, 'Import');
      case 78:
        node = this.startNode();
        this.next();
        return this.finishNode(node, 'ThisExpression');
      case 90: {
        return this.parseDo(this.startNode(), false);
      }
      case 56:
      case 31: {
        this.readRegexp();
        return this.parseRegExpLiteral(this.state.value);
      }
      case 130:
        return this.parseNumericLiteral(this.state.value);
      case 131:
        return this.parseBigIntLiteral(this.state.value);
      case 132:
        return this.parseDecimalLiteral(this.state.value);
      case 129:
        return this.parseStringLiteral(this.state.value);
      case 84:
        return this.parseNullLiteral();
      case 85:
        return this.parseBooleanLiteral(true);
      case 86:
        return this.parseBooleanLiteral(false);
      case 10: {
        const canBeArrow = this.state.potentialArrowAt === this.state.start;
        return this.parseParenAndDistinguishExpression(canBeArrow);
      }
      case 2:
      case 1: {
        return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
      }
      case 0: {
        return this.parseArrayLike(3, true, false, refExpressionErrors);
      }
      case 6:
      case 7: {
        return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
      }
      case 5: {
        return this.parseObjectLike(8, false, false, refExpressionErrors);
      }
      case 68:
        return this.parseFunctionOrFunctionSent();
      case 26:
        this.parseDecorators();
      case 80:
        node = this.startNode();
        this.takeDecorators(node);
        return this.parseClass(node, false);
      case 77:
        return this.parseNewOrNewTarget();
      case 25:
      case 24:
        return this.parseTemplate(false);
      case 15: {
        node = this.startNode();
        this.next();
        node.object = null;
        const callee = (node.callee = this.parseNoCallExpr());
        if (callee.type === 'MemberExpression') {
          return this.finishNode(node, 'BindExpression');
        } else {
          throw this.raise(Errors.UnsupportedBind, {at: callee});
        }
      }
      case 134: {
        this.raise(Errors.PrivateInExpectedIn, {
          at: this.state.startLoc,
          identifierName: this.state.value,
        });
        return this.parsePrivateName();
      }
      case 33: {
        return this.parseTopicReferenceThenEqualsSign(54, '%');
      }
      case 32: {
        return this.parseTopicReferenceThenEqualsSign(44, '^');
      }
      case 37:
      case 38: {
        return this.parseTopicReference('hack');
      }
      case 44:
      case 54:
      case 27: {
        const pipeProposal = this.getPluginOption(
          'pipelineOperator',
          'proposal'
        );
        if (pipeProposal) {
          return this.parseTopicReference(pipeProposal);
        } else {
          throw this.unexpected();
        }
      }
      case 47: {
        const lookaheadCh = this.input.codePointAt(this.nextTokenStart());
        if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
          this.expectOnePlugin(['jsx', 'flow', 'typescript']);
          break;
        } else {
          throw this.unexpected();
        }
      }
      default:
        if (tokenIsIdentifier(type)) {
          if (
            this.isContextual(123) &&
            this.lookaheadCharCode() === 123 &&
            !this.hasFollowingLineBreak()
          ) {
            return this.parseModuleExpression();
          }
          const canBeArrow = this.state.potentialArrowAt === this.state.start;
          const containsEsc = this.state.containsEsc;
          const id = this.parseIdentifier();
          if (
            !containsEsc &&
            id.name === 'async' &&
            !this.canInsertSemicolon()
          ) {
            const {type: type} = this.state;
            if (type === 68) {
              this.resetPreviousNodeTrailingComments(id);
              this.next();
              return this.parseFunction(
                this.startNodeAtNode(id),
                undefined,
                true
              );
            } else if (tokenIsIdentifier(type)) {
              if (this.lookaheadCharCode() === 61) {
                return this.parseAsyncArrowUnaryFunction(
                  this.startNodeAtNode(id)
                );
              } else {
                return id;
              }
            } else if (type === 90) {
              this.resetPreviousNodeTrailingComments(id);
              return this.parseDo(this.startNodeAtNode(id), true);
            }
          }
          if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
            this.next();
            return this.parseArrowExpression(
              this.startNodeAtNode(id),
              [id],
              false
            );
          }
          return id;
        } else {
          throw this.unexpected();
        }
    }
  }
  parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
    const pipeProposal = this.getPluginOption('pipelineOperator', 'proposal');
    if (pipeProposal) {
      this.state.type = topicTokenType;
      this.state.value = topicTokenValue;
      this.state.pos--;
      this.state.end--;
      this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
      return this.parseTopicReference(pipeProposal);
    } else {
      throw this.unexpected();
    }
  }
  parseTopicReference(pipeProposal) {
    const node = this.startNode();
    const startLoc = this.state.startLoc;
    const tokenType = this.state.type;
    this.next();
    return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
  }
  finishTopicReference(node, startLoc, pipeProposal, tokenType) {
    if (
      this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)
    ) {
      const nodeType =
        pipeProposal === 'smart'
          ? 'PipelinePrimaryTopicReference'
          : 'TopicReference';
      if (!this.topicReferenceIsAllowedInCurrentContext()) {
        this.raise(
          pipeProposal === 'smart'
            ? Errors.PrimaryTopicNotAllowed
            : Errors.PipeTopicUnbound,
          {at: startLoc}
        );
      }
      this.registerTopicReference();
      return this.finishNode(node, nodeType);
    } else {
      throw this.raise(Errors.PipeTopicUnconfiguredToken, {
        at: startLoc,
        token: tokenLabelName(tokenType),
      });
    }
  }
  testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
    switch (pipeProposal) {
      case 'hack': {
        return this.hasPlugin([
          'pipelineOperator',
          {topicToken: tokenLabelName(tokenType)},
        ]);
      }
      case 'smart':
        return tokenType === 27;
      default:
        throw this.raise(Errors.PipeTopicRequiresHackPipes, {at: startLoc});
    }
  }
  parseAsyncArrowUnaryFunction(node) {
    this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
    const params = [this.parseIdentifier()];
    this.prodParam.exit();
    if (this.hasPrecedingLineBreak()) {
      this.raise(Errors.LineTerminatorBeforeArrow, {
        at: this.state.curPosition(),
      });
    }
    this.expect(19);
    return this.parseArrowExpression(node, params, true);
  }
  parseDo(node, isAsync) {
    this.expectPlugin('doExpressions');
    if (isAsync) {
      this.expectPlugin('asyncDoExpressions');
    }
    node.async = isAsync;
    this.next();
    const oldLabels = this.state.labels;
    this.state.labels = [];
    if (isAsync) {
      this.prodParam.enter(PARAM_AWAIT);
      node.body = this.parseBlock();
      this.prodParam.exit();
    } else {
      node.body = this.parseBlock();
    }
    this.state.labels = oldLabels;
    return this.finishNode(node, 'DoExpression');
  }
  parseSuper() {
    const node = this.startNode();
    this.next();
    if (
      this.match(10) &&
      !this.scope.allowDirectSuper &&
      !this.options.allowSuperOutsideMethod
    ) {
      this.raise(Errors.SuperNotAllowed, {at: node});
    } else if (
      !this.scope.allowSuper &&
      !this.options.allowSuperOutsideMethod
    ) {
      this.raise(Errors.UnexpectedSuper, {at: node});
    }
    if (!this.match(10) && !this.match(0) && !this.match(16)) {
      this.raise(Errors.UnsupportedSuper, {at: node});
    }
    return this.finishNode(node, 'Super');
  }
  parsePrivateName() {
    const node = this.startNode();
    const id = this.startNodeAt(
      this.state.start + 1,
      new Position(
        this.state.curLine,
        this.state.start + 1 - this.state.lineStart,
        this.state.start + 1
      )
    );
    const name = this.state.value;
    this.next();
    node.id = this.createIdentifier(id, name);
    return this.finishNode(node, 'PrivateName');
  }
  parseFunctionOrFunctionSent() {
    const node = this.startNode();
    this.next();
    if (this.prodParam.hasYield && this.match(16)) {
      const meta = this.createIdentifier(
        this.startNodeAtNode(node),
        'function'
      );
      this.next();
      if (this.match(102)) {
        this.expectPlugin('functionSent');
      } else if (!this.hasPlugin('functionSent')) {
        this.unexpected();
      }
      return this.parseMetaProperty(node, meta, 'sent');
    }
    return this.parseFunction(node);
  }
  parseMetaProperty(node, meta, propertyName) {
    node.meta = meta;
    const containsEsc = this.state.containsEsc;
    node.property = this.parseIdentifier(true);
    if (node.property.name !== propertyName || containsEsc) {
      this.raise(Errors.UnsupportedMetaProperty, {
        at: node.property,
        target: meta.name,
        onlyValidPropertyName: propertyName,
      });
    }
    return this.finishNode(node, 'MetaProperty');
  }
  parseImportMetaProperty(node) {
    const id = this.createIdentifier(this.startNodeAtNode(node), 'import');
    this.next();
    if (this.isContextual(100)) {
      if (!this.inModule) {
        this.raise(Errors.ImportMetaOutsideModule, {at: id});
      }
      this.sawUnambiguousESM = true;
    }
    return this.parseMetaProperty(node, id, 'meta');
  }
  parseLiteralAtNode(value, type, node) {
    this.addExtra(node, 'rawValue', value);
    this.addExtra(node, 'raw', this.input.slice(node.start, this.state.end));
    node.value = value;
    this.next();
    return this.finishNode(node, type);
  }
  parseLiteral(value, type) {
    const node = this.startNode();
    return this.parseLiteralAtNode(value, type, node);
  }
  parseStringLiteral(value) {
    return this.parseLiteral(value, 'StringLiteral');
  }
  parseNumericLiteral(value) {
    return this.parseLiteral(value, 'NumericLiteral');
  }
  parseBigIntLiteral(value) {
    return this.parseLiteral(value, 'BigIntLiteral');
  }
  parseDecimalLiteral(value) {
    return this.parseLiteral(value, 'DecimalLiteral');
  }
  parseRegExpLiteral(value) {
    const node = this.parseLiteral(value.value, 'RegExpLiteral');
    node.pattern = value.pattern;
    node.flags = value.flags;
    return node;
  }
  parseBooleanLiteral(value) {
    const node = this.startNode();
    node.value = value;
    this.next();
    return this.finishNode(node, 'BooleanLiteral');
  }
  parseNullLiteral() {
    const node = this.startNode();
    this.next();
    return this.finishNode(node, 'NullLiteral');
  }
  parseParenAndDistinguishExpression(canBeArrow) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    let val;
    this.next();
    this.expressionScope.enter(newArrowHeadScope());
    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
    this.state.maybeInArrowParameters = true;
    this.state.inFSharpPipelineDirectBody = false;
    const innerStartPos = this.state.start;
    const innerStartLoc = this.state.startLoc;
    const exprList = [];
    const refExpressionErrors = new ExpressionErrors();
    let first = true;
    let spreadStartLoc;
    let optionalCommaStartLoc;
    while (!this.match(11)) {
      if (first) {
        first = false;
      } else {
        this.expect(
          12,
          refExpressionErrors.optionalParametersLoc === null
            ? null
            : refExpressionErrors.optionalParametersLoc
        );
        if (this.match(11)) {
          optionalCommaStartLoc = this.state.startLoc;
          break;
        }
      }
      if (this.match(21)) {
        const spreadNodeStartPos = this.state.start;
        const spreadNodeStartLoc = this.state.startLoc;
        spreadStartLoc = this.state.startLoc;
        exprList.push(
          this.parseParenItem(
            this.parseRestBinding(),
            spreadNodeStartPos,
            spreadNodeStartLoc
          )
        );
        if (!this.checkCommaAfterRest(41)) {
          break;
        }
      } else {
        exprList.push(
          this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem)
        );
      }
    }
    const innerEndLoc = this.state.lastTokEndLoc;
    this.expect(11);
    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
    let arrowNode = this.startNodeAt(startPos, startLoc);
    if (
      canBeArrow &&
      this.shouldParseArrow(exprList) &&
      (arrowNode = this.parseArrow(arrowNode))
    ) {
      this.checkDestructuringPrivate(refExpressionErrors);
      this.expressionScope.validateAsPattern();
      this.expressionScope.exit();
      this.parseArrowExpression(arrowNode, exprList, false);
      return arrowNode;
    }
    this.expressionScope.exit();
    if (!exprList.length) {
      this.unexpected(this.state.lastTokStartLoc);
    }
    if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
    if (spreadStartLoc) this.unexpected(spreadStartLoc);
    this.checkExpressionErrors(refExpressionErrors, true);
    this.toReferencedListDeep(exprList, true);
    if (exprList.length > 1) {
      val = this.startNodeAt(innerStartPos, innerStartLoc);
      val.expressions = exprList;
      this.finishNode(val, 'SequenceExpression');
      this.resetEndLocation(val, innerEndLoc);
    } else {
      val = exprList[0];
    }
    return this.wrapParenthesis(startPos, startLoc, val);
  }
  wrapParenthesis(startPos, startLoc, expression) {
    if (!this.options.createParenthesizedExpressions) {
      this.addExtra(expression, 'parenthesized', true);
      this.addExtra(expression, 'parenStart', startPos);
      this.takeSurroundingComments(
        expression,
        startPos,
        this.state.lastTokEndLoc.index
      );
      return expression;
    }
    const parenExpression = this.startNodeAt(startPos, startLoc);
    parenExpression.expression = expression;
    return this.finishNode(parenExpression, 'ParenthesizedExpression');
  }
  shouldParseArrow(params) {
    return !this.canInsertSemicolon();
  }
  parseArrow(node) {
    if (this.eat(19)) {
      return node;
    }
  }
  parseParenItem(node, startPos, startLoc) {
    return node;
  }
  parseNewOrNewTarget() {
    const node = this.startNode();
    this.next();
    if (this.match(16)) {
      const meta = this.createIdentifier(this.startNodeAtNode(node), 'new');
      this.next();
      const metaProp = this.parseMetaProperty(node, meta, 'target');
      if (!this.scope.inNonArrowFunction && !this.scope.inClass) {
        this.raise(Errors.UnexpectedNewTarget, {at: metaProp});
      }
      return metaProp;
    }
    return this.parseNew(node);
  }
  parseNew(node) {
    this.parseNewCallee(node);
    if (this.eat(10)) {
      const args = this.parseExprList(11);
      this.toReferencedList(args);
      node.arguments = args;
    } else {
      node.arguments = [];
    }
    return this.finishNode(node, 'NewExpression');
  }
  parseNewCallee(node) {
    node.callee = this.parseNoCallExpr();
    if (node.callee.type === 'Import') {
      this.raise(Errors.ImportCallNotNewExpression, {at: node.callee});
    } else if (this.isOptionalChain(node.callee)) {
      this.raise(Errors.OptionalChainingNoNew, {at: this.state.lastTokEndLoc});
    } else if (this.eat(18)) {
      this.raise(Errors.OptionalChainingNoNew, {at: this.state.startLoc});
    }
  }
  parseTemplateElement(isTagged) {
    const {
      start: start,
      startLoc: startLoc,
      end: end,
      value: value,
    } = this.state;
    const elemStart = start + 1;
    const elem = this.startNodeAt(
      elemStart,
      createPositionWithColumnOffset(startLoc, 1)
    );
    if (value === null) {
      if (!isTagged) {
        this.raise(Errors.InvalidEscapeSequenceTemplate, {
          at: createPositionWithColumnOffset(startLoc, 2),
        });
      }
    }
    const isTail = this.match(24);
    const endOffset = isTail ? -1 : -2;
    const elemEnd = end + endOffset;
    elem.value = {
      raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, '\n'),
      cooked: value === null ? null : value.slice(1, endOffset),
    };
    elem.tail = isTail;
    this.next();
    const finishedNode = this.finishNode(elem, 'TemplateElement');
    this.resetEndLocation(
      finishedNode,
      createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset)
    );
    return finishedNode;
  }
  parseTemplate(isTagged) {
    const node = this.startNode();
    node.expressions = [];
    let curElt = this.parseTemplateElement(isTagged);
    node.quasis = [curElt];
    while (!curElt.tail) {
      node.expressions.push(this.parseTemplateSubstitution());
      this.readTemplateContinuation();
      node.quasis.push((curElt = this.parseTemplateElement(isTagged)));
    }
    return this.finishNode(node, 'TemplateLiteral');
  }
  parseTemplateSubstitution() {
    return this.parseExpression();
  }
  parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
    if (isRecord) {
      this.expectPlugin('recordAndTuple');
    }
    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
    this.state.inFSharpPipelineDirectBody = false;
    const propHash = Object.create(null);
    let first = true;
    const node = this.startNode();
    node.properties = [];
    this.next();
    while (!this.match(close)) {
      if (first) {
        first = false;
      } else {
        this.expect(12);
        if (this.match(close)) {
          this.addTrailingCommaExtraToNode(node);
          break;
        }
      }
      let prop;
      if (isPattern) {
        prop = this.parseBindingProperty();
      } else {
        prop = this.parsePropertyDefinition(refExpressionErrors);
        this.checkProto(prop, isRecord, propHash, refExpressionErrors);
      }
      if (
        isRecord &&
        !this.isObjectProperty(prop) &&
        prop.type !== 'SpreadElement'
      ) {
        this.raise(Errors.InvalidRecordProperty, {at: prop});
      }
      if (prop.shorthand) {
        this.addExtra(prop, 'shorthand', true);
      }
      node.properties.push(prop);
    }
    this.next();
    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
    let type = 'ObjectExpression';
    if (isPattern) {
      type = 'ObjectPattern';
    } else if (isRecord) {
      type = 'RecordExpression';
    }
    return this.finishNode(node, type);
  }
  addTrailingCommaExtraToNode(node) {
    this.addExtra(node, 'trailingComma', this.state.lastTokStart);
    this.addExtra(node, 'trailingCommaLoc', this.state.lastTokStartLoc, false);
  }
  maybeAsyncOrAccessorProp(prop) {
    return (
      !prop.computed &&
      prop.key.type === 'Identifier' &&
      (this.isLiteralPropertyName() || this.match(0) || this.match(55))
    );
  }
  parsePropertyDefinition(refExpressionErrors) {
    let decorators = [];
    if (this.match(26)) {
      if (this.hasPlugin('decorators')) {
        this.raise(Errors.UnsupportedPropertyDecorator, {
          at: this.state.startLoc,
        });
      }
      while (this.match(26)) {
        decorators.push(this.parseDecorator());
      }
    }
    const prop = this.startNode();
    let isAsync = false;
    let isAccessor = false;
    let startPos;
    let startLoc;
    if (this.match(21)) {
      if (decorators.length) this.unexpected();
      return this.parseSpread();
    }
    if (decorators.length) {
      prop.decorators = decorators;
      decorators = [];
    }
    prop.method = false;
    if (refExpressionErrors) {
      startPos = this.state.start;
      startLoc = this.state.startLoc;
    }
    let isGenerator = this.eat(55);
    this.parsePropertyNamePrefixOperator(prop);
    const containsEsc = this.state.containsEsc;
    const key = this.parsePropertyName(prop, refExpressionErrors);
    if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
      const keyName = key.name;
      if (keyName === 'async' && !this.hasPrecedingLineBreak()) {
        isAsync = true;
        this.resetPreviousNodeTrailingComments(key);
        isGenerator = this.eat(55);
        this.parsePropertyName(prop);
      }
      if (keyName === 'get' || keyName === 'set') {
        isAccessor = true;
        this.resetPreviousNodeTrailingComments(key);
        prop.kind = keyName;
        if (this.match(55)) {
          isGenerator = true;
          this.raise(Errors.AccessorIsGenerator, {
            at: this.state.curPosition(),
            kind: keyName,
          });
          this.next();
        }
        this.parsePropertyName(prop);
      }
    }
    return this.parseObjPropValue(
      prop,
      startPos,
      startLoc,
      isGenerator,
      isAsync,
      false,
      isAccessor,
      refExpressionErrors
    );
  }
  getGetterSetterExpectedParamCount(method) {
    return method.kind === 'get' ? 0 : 1;
  }
  getObjectOrClassMethodParams(method) {
    return method.params;
  }
  checkGetterSetterParams(method) {
    var _params;
    const paramCount = this.getGetterSetterExpectedParamCount(method);
    const params = this.getObjectOrClassMethodParams(method);
    if (params.length !== paramCount) {
      this.raise(
        method.kind === 'get' ? Errors.BadGetterArity : Errors.BadSetterArity,
        {at: method}
      );
    }
    if (
      method.kind === 'set' &&
      ((_params = params[params.length - 1]) == null
        ? void 0
        : _params.type) === 'RestElement'
    ) {
      this.raise(Errors.BadSetterRestParameter, {at: method});
    }
  }
  parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
    if (isAccessor) {
      const finishedProp = this.parseMethod(
        prop,
        isGenerator,
        false,
        false,
        false,
        'ObjectMethod'
      );
      this.checkGetterSetterParams(finishedProp);
      return finishedProp;
    }
    if (isAsync || isGenerator || this.match(10)) {
      if (isPattern) this.unexpected();
      prop.kind = 'method';
      prop.method = true;
      return this.parseMethod(
        prop,
        isGenerator,
        isAsync,
        false,
        false,
        'ObjectMethod'
      );
    }
  }
  parseObjectProperty(
    prop,
    startPos,
    startLoc,
    isPattern,
    refExpressionErrors
  ) {
    prop.shorthand = false;
    if (this.eat(14)) {
      prop.value = isPattern
        ? this.parseMaybeDefault(this.state.start, this.state.startLoc)
        : this.parseMaybeAssignAllowIn(refExpressionErrors);
      return this.finishNode(prop, 'ObjectProperty');
    }
    if (!prop.computed && prop.key.type === 'Identifier') {
      this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
      if (isPattern) {
        prop.value = this.parseMaybeDefault(
          startPos,
          startLoc,
          cloneIdentifier(prop.key)
        );
      } else if (this.match(29)) {
        const shorthandAssignLoc = this.state.startLoc;
        if (refExpressionErrors != null) {
          if (refExpressionErrors.shorthandAssignLoc === null) {
            refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
          }
        } else {
          this.raise(Errors.InvalidCoverInitializedName, {
            at: shorthandAssignLoc,
          });
        }
        prop.value = this.parseMaybeDefault(
          startPos,
          startLoc,
          cloneIdentifier(prop.key)
        );
      } else {
        prop.value = cloneIdentifier(prop.key);
      }
      prop.shorthand = true;
      return this.finishNode(prop, 'ObjectProperty');
    }
  }
  parseObjPropValue(
    prop,
    startPos,
    startLoc,
    isGenerator,
    isAsync,
    isPattern,
    isAccessor,
    refExpressionErrors
  ) {
    const node =
      this.parseObjectMethod(
        prop,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor
      ) ||
      this.parseObjectProperty(
        prop,
        startPos,
        startLoc,
        isPattern,
        refExpressionErrors
      );
    if (!node) this.unexpected();
    return node;
  }
  parsePropertyName(prop, refExpressionErrors) {
    if (this.eat(0)) {
      prop.computed = true;
      prop.key = this.parseMaybeAssignAllowIn();
      this.expect(3);
    } else {
      const {type: type, value: value} = this.state;
      let key;
      if (tokenIsKeywordOrIdentifier(type)) {
        key = this.parseIdentifier(true);
      } else {
        switch (type) {
          case 130:
            key = this.parseNumericLiteral(value);
            break;
          case 129:
            key = this.parseStringLiteral(value);
            break;
          case 131:
            key = this.parseBigIntLiteral(value);
            break;
          case 132:
            key = this.parseDecimalLiteral(value);
            break;
          case 134: {
            const privateKeyLoc = this.state.startLoc;
            if (refExpressionErrors != null) {
              if (refExpressionErrors.privateKeyLoc === null) {
                refExpressionErrors.privateKeyLoc = privateKeyLoc;
              }
            } else {
              this.raise(Errors.UnexpectedPrivateField, {at: privateKeyLoc});
            }
            key = this.parsePrivateName();
            break;
          }
          default:
            throw this.unexpected();
        }
      }
      prop.key = key;
      if (type !== 134) {
        prop.computed = false;
      }
    }
    return prop.key;
  }
  initFunction(node, isAsync) {
    node.id = null;
    node.generator = false;
    node.async = !!isAsync;
  }
  parseMethod(
    node,
    isGenerator,
    isAsync,
    isConstructor,
    allowDirectSuper,
    type,
    inClassScope = false
  ) {
    this.initFunction(node, isAsync);
    node.generator = !!isGenerator;
    const allowModifiers = isConstructor;
    this.scope.enter(
      SCOPE_FUNCTION |
        SCOPE_SUPER |
        (inClassScope ? SCOPE_CLASS : 0) |
        (allowDirectSuper ? SCOPE_DIRECT_SUPER : 0)
    );
    this.prodParam.enter(functionFlags(isAsync, node.generator));
    this.parseFunctionParams(node, allowModifiers);
    const finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
    this.prodParam.exit();
    this.scope.exit();
    return finishedNode;
  }
  parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
    if (isTuple) {
      this.expectPlugin('recordAndTuple');
    }
    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
    this.state.inFSharpPipelineDirectBody = false;
    const node = this.startNode();
    this.next();
    node.elements = this.parseExprList(
      close,
      !isTuple,
      refExpressionErrors,
      node
    );
    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
    return this.finishNode(
      node,
      isTuple ? 'TupleExpression' : 'ArrayExpression'
    );
  }
  parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
    this.scope.enter(SCOPE_FUNCTION | SCOPE_ARROW);
    let flags = functionFlags(isAsync, false);
    if (!this.match(5) && this.prodParam.hasIn) {
      flags |= PARAM_IN;
    }
    this.prodParam.enter(flags);
    this.initFunction(node, isAsync);
    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
    if (params) {
      this.state.maybeInArrowParameters = true;
      this.setArrowFunctionParameters(node, params, trailingCommaLoc);
    }
    this.state.maybeInArrowParameters = false;
    this.parseFunctionBody(node, true);
    this.prodParam.exit();
    this.scope.exit();
    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
    return this.finishNode(node, 'ArrowFunctionExpression');
  }
  setArrowFunctionParameters(node, params, trailingCommaLoc) {
    this.toAssignableList(params, trailingCommaLoc, false);
    node.params = params;
  }
  parseFunctionBodyAndFinish(node, type, isMethod = false) {
    this.parseFunctionBody(node, false, isMethod);
    return this.finishNode(node, type);
  }
  parseFunctionBody(node, allowExpression, isMethod = false) {
    const isExpression = allowExpression && !this.match(5);
    this.expressionScope.enter(newExpressionScope());
    if (isExpression) {
      node.body = this.parseMaybeAssign();
      this.checkParams(node, false, allowExpression, false);
    } else {
      const oldStrict = this.state.strict;
      const oldLabels = this.state.labels;
      this.state.labels = [];
      this.prodParam.enter(this.prodParam.currentFlags() | PARAM_RETURN);
      node.body = this.parseBlock(true, false, hasStrictModeDirective => {
        const nonSimple = !this.isSimpleParamList(node.params);
        if (hasStrictModeDirective && nonSimple) {
          this.raise(Errors.IllegalLanguageModeDirective, {
            at:
              (node.kind === 'method' || node.kind === 'constructor') &&
              !!node.key
                ? node.key.loc.end
                : node,
          });
        }
        const strictModeChanged = !oldStrict && this.state.strict;
        this.checkParams(
          node,
          !this.state.strict && !allowExpression && !isMethod && !nonSimple,
          allowExpression,
          strictModeChanged
        );
        if (this.state.strict && node.id) {
          this.checkIdentifier(node.id, BIND_OUTSIDE, strictModeChanged);
        }
      });
      this.prodParam.exit();
      this.state.labels = oldLabels;
    }
    this.expressionScope.exit();
  }
  isSimpleParameter(node) {
    return node.type === 'Identifier';
  }
  isSimpleParamList(params) {
    for (let i = 0, len = params.length; i < len; i++) {
      if (!this.isSimpleParameter(params[i])) return false;
    }
    return true;
  }
  checkParams(
    node,
    allowDuplicates,
    isArrowFunction,
    strictModeChanged = true
  ) {
    const checkClashes = !allowDuplicates && new Set();
    const formalParameters = {type: 'FormalParameters'};
    for (const param of node.params) {
      this.checkLVal(param, {
        in: formalParameters,
        binding: BIND_VAR,
        checkClashes: checkClashes,
        strictModeChanged: strictModeChanged,
      });
    }
  }
  parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
    const elts = [];
    let first = true;
    while (!this.eat(close)) {
      if (first) {
        first = false;
      } else {
        this.expect(12);
        if (this.match(close)) {
          if (nodeForExtra) {
            this.addTrailingCommaExtraToNode(nodeForExtra);
          }
          this.next();
          break;
        }
      }
      elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
    }
    return elts;
  }
  parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
    let elt;
    if (this.match(12)) {
      if (!allowEmpty) {
        this.raise(Errors.UnexpectedToken, {
          at: this.state.curPosition(),
          unexpected: ',',
        });
      }
      elt = null;
    } else if (this.match(21)) {
      const spreadNodeStartPos = this.state.start;
      const spreadNodeStartLoc = this.state.startLoc;
      elt = this.parseParenItem(
        this.parseSpread(refExpressionErrors),
        spreadNodeStartPos,
        spreadNodeStartLoc
      );
    } else if (this.match(17)) {
      this.expectPlugin('partialApplication');
      if (!allowPlaceholder) {
        this.raise(Errors.UnexpectedArgumentPlaceholder, {
          at: this.state.startLoc,
        });
      }
      const node = this.startNode();
      this.next();
      elt = this.finishNode(node, 'ArgumentPlaceholder');
    } else {
      elt = this.parseMaybeAssignAllowIn(
        refExpressionErrors,
        this.parseParenItem
      );
    }
    return elt;
  }
  parseIdentifier(liberal) {
    const node = this.startNode();
    const name = this.parseIdentifierName(node.start, liberal);
    return this.createIdentifier(node, name);
  }
  createIdentifier(node, name) {
    node.name = name;
    node.loc.identifierName = name;
    return this.finishNode(node, 'Identifier');
  }
  parseIdentifierName(pos, liberal) {
    let name;
    const {startLoc: startLoc, type: type} = this.state;
    if (tokenIsKeywordOrIdentifier(type)) {
      name = this.state.value;
    } else {
      throw this.unexpected();
    }
    const tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);
    if (liberal) {
      if (tokenIsKeyword) {
        this.replaceToken(128);
      }
    } else {
      this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
    }
    this.next();
    return name;
  }
  checkReservedWord(word, startLoc, checkKeywords, isBinding) {
    if (word.length > 10) {
      return;
    }
    if (!canBeReservedWord(word)) {
      return;
    }
    if (word === 'yield') {
      if (this.prodParam.hasYield) {
        this.raise(Errors.YieldBindingIdentifier, {at: startLoc});
        return;
      }
    } else if (word === 'await') {
      if (this.prodParam.hasAwait) {
        this.raise(Errors.AwaitBindingIdentifier, {at: startLoc});
        return;
      }
      if (this.scope.inStaticBlock) {
        this.raise(Errors.AwaitBindingIdentifierInStaticBlock, {at: startLoc});
        return;
      }
      this.expressionScope.recordAsyncArrowParametersError({at: startLoc});
    } else if (word === 'arguments') {
      if (this.scope.inClassAndNotInNonArrowFunction) {
        this.raise(Errors.ArgumentsInClass, {at: startLoc});
        return;
      }
    }
    if (checkKeywords && isKeyword(word)) {
      this.raise(Errors.UnexpectedKeyword, {at: startLoc, keyword: word});
      return;
    }
    const reservedTest = !this.state.strict
      ? isReservedWord
      : isBinding
        ? isStrictBindReservedWord
        : isStrictReservedWord;
    if (reservedTest(word, this.inModule)) {
      this.raise(Errors.UnexpectedReservedWord, {
        at: startLoc,
        reservedWord: word,
      });
    }
  }
  isAwaitAllowed() {
    if (this.prodParam.hasAwait) return true;
    if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
      return true;
    }
    return false;
  }
  parseAwait(startPos, startLoc) {
    const node = this.startNodeAt(startPos, startLoc);
    this.expressionScope.recordParameterInitializerError(
      Errors.AwaitExpressionFormalParameter,
      {at: node}
    );
    if (this.eat(55)) {
      this.raise(Errors.ObsoleteAwaitStar, {at: node});
    }
    if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
      if (this.isAmbiguousAwait()) {
        this.ambiguousScriptDifferentAst = true;
      } else {
        this.sawUnambiguousESM = true;
      }
    }
    if (!this.state.soloAwait) {
      node.argument = this.parseMaybeUnary(null, true);
    }
    return this.finishNode(node, 'AwaitExpression');
  }
  isAmbiguousAwait() {
    if (this.hasPrecedingLineBreak()) return true;
    const {type: type} = this.state;
    return (
      type === 53 ||
      type === 10 ||
      type === 0 ||
      tokenIsTemplate(type) ||
      type === 133 ||
      type === 56 ||
      (this.hasPlugin('v8intrinsic') && type === 54)
    );
  }
  parseYield() {
    const node = this.startNode();
    this.expressionScope.recordParameterInitializerError(
      Errors.YieldInParameter,
      {at: node}
    );
    this.next();
    let delegating = false;
    let argument = null;
    if (!this.hasPrecedingLineBreak()) {
      delegating = this.eat(55);
      switch (this.state.type) {
        case 13:
        case 135:
        case 8:
        case 11:
        case 3:
        case 9:
        case 14:
        case 12:
          if (!delegating) break;
        default:
          argument = this.parseMaybeAssign();
      }
    }
    node.delegate = delegating;
    node.argument = argument;
    return this.finishNode(node, 'YieldExpression');
  }
  checkPipelineAtInfixOperator(left, leftStartLoc) {
    if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
      if (left.type === 'SequenceExpression') {
        this.raise(Errors.PipelineHeadSequenceExpression, {at: leftStartLoc});
      }
    }
  }
  parseSmartPipelineBodyInStyle(childExpr, startPos, startLoc) {
    if (this.isSimpleReference(childExpr)) {
      const bodyNode = this.startNodeAt(startPos, startLoc);
      bodyNode.callee = childExpr;
      return this.finishNode(bodyNode, 'PipelineBareFunction');
    } else {
      const bodyNode = this.startNodeAt(startPos, startLoc);
      this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
      bodyNode.expression = childExpr;
      return this.finishNode(bodyNode, 'PipelineTopicExpression');
    }
  }
  isSimpleReference(expression) {
    switch (expression.type) {
      case 'MemberExpression':
        return (
          !expression.computed && this.isSimpleReference(expression.object)
        );
      case 'Identifier':
        return true;
      default:
        return false;
    }
  }
  checkSmartPipeTopicBodyEarlyErrors(startLoc) {
    if (this.match(19)) {
      throw this.raise(Errors.PipelineBodyNoArrow, {at: this.state.startLoc});
    }
    if (!this.topicReferenceWasUsedInCurrentContext()) {
      this.raise(Errors.PipelineTopicUnused, {at: startLoc});
    }
  }
  withTopicBindingContext(callback) {
    const outerContextTopicState = this.state.topicContext;
    this.state.topicContext = {
      maxNumOfResolvableTopics: 1,
      maxTopicIndex: null,
    };
    try {
      return callback();
    } finally {
      this.state.topicContext = outerContextTopicState;
    }
  }
  withSmartMixTopicForbiddingContext(callback) {
    if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
      const outerContextTopicState = this.state.topicContext;
      this.state.topicContext = {
        maxNumOfResolvableTopics: 0,
        maxTopicIndex: null,
      };
      try {
        return callback();
      } finally {
        this.state.topicContext = outerContextTopicState;
      }
    } else {
      return callback();
    }
  }
  withSoloAwaitPermittingContext(callback) {
    const outerContextSoloAwaitState = this.state.soloAwait;
    this.state.soloAwait = true;
    try {
      return callback();
    } finally {
      this.state.soloAwait = outerContextSoloAwaitState;
    }
  }
  allowInAnd(callback) {
    const flags = this.prodParam.currentFlags();
    const prodParamToSet = PARAM_IN & ~flags;
    if (prodParamToSet) {
      this.prodParam.enter(flags | PARAM_IN);
      try {
        return callback();
      } finally {
        this.prodParam.exit();
      }
    }
    return callback();
  }
  disallowInAnd(callback) {
    const flags = this.prodParam.currentFlags();
    const prodParamToClear = PARAM_IN & flags;
    if (prodParamToClear) {
      this.prodParam.enter(flags & ~PARAM_IN);
      try {
        return callback();
      } finally {
        this.prodParam.exit();
      }
    }
    return callback();
  }
  registerTopicReference() {
    this.state.topicContext.maxTopicIndex = 0;
  }
  topicReferenceIsAllowedInCurrentContext() {
    return this.state.topicContext.maxNumOfResolvableTopics >= 1;
  }
  topicReferenceWasUsedInCurrentContext() {
    return (
      this.state.topicContext.maxTopicIndex != null &&
      this.state.topicContext.maxTopicIndex >= 0
    );
  }
  parseFSharpPipelineBody(prec) {
    const startPos = this.state.start;
    const startLoc = this.state.startLoc;
    this.state.potentialArrowAt = this.state.start;
    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
    this.state.inFSharpPipelineDirectBody = true;
    const ret = this.parseExprOp(
      this.parseMaybeUnaryOrPrivate(),
      startPos,
      startLoc,
      prec
    );
    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
    return ret;
  }
  parseModuleExpression() {
    this.expectPlugin('moduleBlocks');
    const node = this.startNode();
    this.next();
    this.eat(5);
    const revertScopes = this.initializeScopes(true);
    this.enterInitialScopes();
    const program = this.startNode();
    try {
      node.body = this.parseProgram(program, 8, 'module');
    } finally {
      revertScopes();
    }
    this.eat(8);
    return this.finishNode(node, 'ModuleExpression');
  }
  parsePropertyNamePrefixOperator(prop) {}
}
const loopLabel = {kind: 'loop'},
  switchLabel = {kind: 'switch'};
const FUNC_NO_FLAGS = 0,
  FUNC_STATEMENT = 1,
  FUNC_HANGING_STATEMENT = 2,
  FUNC_NULLABLE_ID = 4;
const loneSurrogate = /[\uD800-\uDFFF]/u;
const keywordRelationalOperator = /in(?:stanceof)?/y;
function babel7CompatTokens(tokens, input) {
  for (let i = 0; i < tokens.length; i++) {
    const token = tokens[i];
    const {type: type} = token;
    if (typeof type === 'number') {
      {
        if (type === 134) {
          const {loc: loc, start: start, value: value, end: end} = token;
          const hashEndPos = start + 1;
          const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
          tokens.splice(
            i,
            1,
            new Token({
              type: getExportedToken(27),
              value: '#',
              start: start,
              end: hashEndPos,
              startLoc: loc.start,
              endLoc: hashEndLoc,
            }),
            new Token({
              type: getExportedToken(128),
              value: value,
              start: hashEndPos,
              end: end,
              startLoc: hashEndLoc,
              endLoc: loc.end,
            })
          );
          i++;
          continue;
        }
        if (tokenIsTemplate(type)) {
          const {loc: loc, start: start, value: value, end: end} = token;
          const backquoteEnd = start + 1;
          const backquoteEndLoc = createPositionWithColumnOffset(loc.start, 1);
          let startToken;
          if (input.charCodeAt(start) === 96) {
            startToken = new Token({
              type: getExportedToken(22),
              value: '`',
              start: start,
              end: backquoteEnd,
              startLoc: loc.start,
              endLoc: backquoteEndLoc,
            });
          } else {
            startToken = new Token({
              type: getExportedToken(8),
              value: '}',
              start: start,
              end: backquoteEnd,
              startLoc: loc.start,
              endLoc: backquoteEndLoc,
            });
          }
          let templateValue,
            templateElementEnd,
            templateElementEndLoc,
            endToken;
          if (type === 24) {
            templateElementEnd = end - 1;
            templateElementEndLoc = createPositionWithColumnOffset(loc.end, -1);
            templateValue = value === null ? null : value.slice(1, -1);
            endToken = new Token({
              type: getExportedToken(22),
              value: '`',
              start: templateElementEnd,
              end: end,
              startLoc: templateElementEndLoc,
              endLoc: loc.end,
            });
          } else {
            templateElementEnd = end - 2;
            templateElementEndLoc = createPositionWithColumnOffset(loc.end, -2);
            templateValue = value === null ? null : value.slice(1, -2);
            endToken = new Token({
              type: getExportedToken(23),
              value: '${',
              start: templateElementEnd,
              end: end,
              startLoc: templateElementEndLoc,
              endLoc: loc.end,
            });
          }
          tokens.splice(
            i,
            1,
            startToken,
            new Token({
              type: getExportedToken(20),
              value: templateValue,
              start: backquoteEnd,
              end: templateElementEnd,
              startLoc: backquoteEndLoc,
              endLoc: templateElementEndLoc,
            }),
            endToken
          );
          i += 2;
          continue;
        }
      }
      token.type = getExportedToken(type);
    }
  }
  return tokens;
}
class StatementParser extends ExpressionParser {
  parseTopLevel(file, program) {
    file.program = this.parseProgram(program);
    file.comments = this.state.comments;
    if (this.options.tokens) {
      file.tokens = babel7CompatTokens(this.tokens, this.input);
    }
    return this.finishNode(file, 'File');
  }
  parseProgram(program, end = 135, sourceType = this.options.sourceType) {
    program.sourceType = sourceType;
    program.interpreter = this.parseInterpreterDirective();
    this.parseBlockBody(program, true, true, end);
    if (
      this.inModule &&
      !this.options.allowUndeclaredExports &&
      this.scope.undefinedExports.size > 0
    ) {
      for (const [localName, at] of Array.from(this.scope.undefinedExports)) {
        this.raise(Errors.ModuleExportUndefined, {
          at: at,
          localName: localName,
        });
      }
    }
    return this.finishNode(program, 'Program');
  }
  stmtToDirective(stmt) {
    const directive = stmt;
    directive.type = 'Directive';
    directive.value = directive.expression;
    delete directive.expression;
    const directiveLiteral = directive.value;
    const expressionValue = directiveLiteral.value;
    const raw = this.input.slice(directiveLiteral.start, directiveLiteral.end);
    const val = (directiveLiteral.value = raw.slice(1, -1));
    this.addExtra(directiveLiteral, 'raw', raw);
    this.addExtra(directiveLiteral, 'rawValue', val);
    this.addExtra(directiveLiteral, 'expressionValue', expressionValue);
    directiveLiteral.type = 'DirectiveLiteral';
    return directive;
  }
  parseInterpreterDirective() {
    if (!this.match(28)) {
      return null;
    }
    const node = this.startNode();
    node.value = this.state.value;
    this.next();
    return this.finishNode(node, 'InterpreterDirective');
  }
  isLet(context) {
    if (!this.isContextual(99)) {
      return false;
    }
    return this.isLetKeyword(context);
  }
  isLetKeyword(context) {
    const next = this.nextTokenStart();
    const nextCh = this.codePointAtPos(next);
    if (nextCh === 92 || nextCh === 91) {
      return true;
    }
    if (context) return false;
    if (nextCh === 123) return true;
    if (isIdentifierStart(nextCh)) {
      keywordRelationalOperator.lastIndex = next;
      if (keywordRelationalOperator.test(this.input)) {
        const endCh = this.codePointAtPos(keywordRelationalOperator.lastIndex);
        if (!isIdentifierChar(endCh) && endCh !== 92) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  parseStatement(context, topLevel) {
    if (this.match(26)) {
      this.parseDecorators(true);
    }
    return this.parseStatementContent(context, topLevel);
  }
  parseStatementContent(context, topLevel) {
    let starttype = this.state.type;
    const node = this.startNode();
    let kind;
    if (this.isLet(context)) {
      starttype = 74;
      kind = 'let';
    }
    switch (starttype) {
      case 60:
        return this.parseBreakContinueStatement(node, true);
      case 63:
        return this.parseBreakContinueStatement(node, false);
      case 64:
        return this.parseDebuggerStatement(node);
      case 90:
        return this.parseDoStatement(node);
      case 91:
        return this.parseForStatement(node);
      case 68:
        if (this.lookaheadCharCode() === 46) break;
        if (context) {
          if (this.state.strict) {
            this.raise(Errors.StrictFunction, {at: this.state.startLoc});
          } else if (context !== 'if' && context !== 'label') {
            this.raise(Errors.SloppyFunction, {at: this.state.startLoc});
          }
        }
        return this.parseFunctionStatement(node, false, !context);
      case 80:
        if (context) this.unexpected();
        return this.parseClass(node, true);
      case 69:
        return this.parseIfStatement(node);
      case 70:
        return this.parseReturnStatement(node);
      case 71:
        return this.parseSwitchStatement(node);
      case 72:
        return this.parseThrowStatement(node);
      case 73:
        return this.parseTryStatement(node);
      case 75:
      case 74:
        kind = kind || this.state.value;
        if (context && kind !== 'var') {
          this.raise(Errors.UnexpectedLexicalDeclaration, {
            at: this.state.startLoc,
          });
        }
        return this.parseVarStatement(node, kind);
      case 92:
        return this.parseWhileStatement(node);
      case 76:
        return this.parseWithStatement(node);
      case 5:
        return this.parseBlock();
      case 13:
        return this.parseEmptyStatement(node);
      case 83: {
        const nextTokenCharCode = this.lookaheadCharCode();
        if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
          break;
        }
      }
      case 82: {
        if (!this.options.allowImportExportEverywhere && !topLevel) {
          this.raise(Errors.UnexpectedImportExport, {at: this.state.startLoc});
        }
        this.next();
        let result;
        if (starttype === 83) {
          result = this.parseImport(node);
          if (
            result.type === 'ImportDeclaration' &&
            (!result.importKind || result.importKind === 'value')
          ) {
            this.sawUnambiguousESM = true;
          }
        } else {
          result = this.parseExport(node);
          if (
            (result.type === 'ExportNamedDeclaration' &&
              (!result.exportKind || result.exportKind === 'value')) ||
            (result.type === 'ExportAllDeclaration' &&
              (!result.exportKind || result.exportKind === 'value')) ||
            result.type === 'ExportDefaultDeclaration'
          ) {
            this.sawUnambiguousESM = true;
          }
        }
        this.assertModuleNodeAllowed(result);
        return result;
      }
      default: {
        if (this.isAsyncFunction()) {
          if (context) {
            this.raise(Errors.AsyncFunctionInSingleStatementContext, {
              at: this.state.startLoc,
            });
          }
          this.next();
          return this.parseFunctionStatement(node, true, !context);
        }
      }
    }
    const maybeName = this.state.value;
    const expr = this.parseExpression();
    if (
      tokenIsIdentifier(starttype) &&
      expr.type === 'Identifier' &&
      this.eat(14)
    ) {
      return this.parseLabeledStatement(node, maybeName, expr, context);
    } else {
      return this.parseExpressionStatement(node, expr);
    }
  }
  assertModuleNodeAllowed(node) {
    if (!this.options.allowImportExportEverywhere && !this.inModule) {
      this.raise(Errors.ImportOutsideModule, {at: node});
    }
  }
  takeDecorators(node) {
    const decorators =
      this.state.decoratorStack[this.state.decoratorStack.length - 1];
    if (decorators.length) {
      node.decorators = decorators;
      this.resetStartLocationFromNode(node, decorators[0]);
      this.state.decoratorStack[this.state.decoratorStack.length - 1] = [];
    }
  }
  canHaveLeadingDecorator() {
    return this.match(80);
  }
  parseDecorators(allowExport) {
    const currentContextDecorators =
      this.state.decoratorStack[this.state.decoratorStack.length - 1];
    while (this.match(26)) {
      const decorator = this.parseDecorator();
      currentContextDecorators.push(decorator);
    }
    if (this.match(82)) {
      if (!allowExport) {
        this.unexpected();
      }
      if (
        this.hasPlugin('decorators') &&
        !this.getPluginOption('decorators', 'decoratorsBeforeExport')
      ) {
        this.raise(Errors.DecoratorExportClass, {at: this.state.startLoc});
      }
    } else if (!this.canHaveLeadingDecorator()) {
      throw this.raise(Errors.UnexpectedLeadingDecorator, {
        at: this.state.startLoc,
      });
    }
  }
  parseDecorator() {
    this.expectOnePlugin(['decorators', 'decorators-legacy']);
    const node = this.startNode();
    this.next();
    if (this.hasPlugin('decorators')) {
      this.state.decoratorStack.push([]);
      const startPos = this.state.start;
      const startLoc = this.state.startLoc;
      let expr;
      if (this.match(10)) {
        const startPos = this.state.start;
        const startLoc = this.state.startLoc;
        this.next();
        expr = this.parseExpression();
        this.expect(11);
        expr = this.wrapParenthesis(startPos, startLoc, expr);
        const paramsStartLoc = this.state.startLoc;
        node.expression = this.parseMaybeDecoratorArguments(expr);
        if (
          this.getPluginOption('decorators', 'allowCallParenthesized') ===
            false &&
          node.expression !== expr
        ) {
          this.raise(Errors.DecoratorArgumentsOutsideParentheses, {
            at: paramsStartLoc,
          });
        }
      } else {
        expr = this.parseIdentifier(false);
        while (this.eat(16)) {
          const node = this.startNodeAt(startPos, startLoc);
          node.object = expr;
          if (this.match(134)) {
            this.classScope.usePrivateName(
              this.state.value,
              this.state.startLoc
            );
            node.property = this.parsePrivateName();
          } else {
            node.property = this.parseIdentifier(true);
          }
          node.computed = false;
          expr = this.finishNode(node, 'MemberExpression');
        }
        node.expression = this.parseMaybeDecoratorArguments(expr);
      }
      this.state.decoratorStack.pop();
    } else {
      node.expression = this.parseExprSubscripts();
    }
    return this.finishNode(node, 'Decorator');
  }
  parseMaybeDecoratorArguments(expr) {
    if (this.eat(10)) {
      const node = this.startNodeAtNode(expr);
      node.callee = expr;
      node.arguments = this.parseCallExpressionArguments(11, false);
      this.toReferencedList(node.arguments);
      return this.finishNode(node, 'CallExpression');
    }
    return expr;
  }
  parseBreakContinueStatement(node, isBreak) {
    this.next();
    if (this.isLineTerminator()) {
      node.label = null;
    } else {
      node.label = this.parseIdentifier();
      this.semicolon();
    }
    this.verifyBreakContinue(node, isBreak);
    return this.finishNode(
      node,
      isBreak ? 'BreakStatement' : 'ContinueStatement'
    );
  }
  verifyBreakContinue(node, isBreak) {
    let i;
    for (i = 0; i < this.state.labels.length; ++i) {
      const lab = this.state.labels[i];
      if (node.label == null || lab.name === node.label.name) {
        if (lab.kind != null && (isBreak || lab.kind === 'loop')) break;
        if (node.label && isBreak) break;
      }
    }
    if (i === this.state.labels.length) {
      const type = isBreak ? 'BreakStatement' : 'ContinueStatement';
      this.raise(Errors.IllegalBreakContinue, {at: node, type: type});
    }
  }
  parseDebuggerStatement(node) {
    this.next();
    this.semicolon();
    return this.finishNode(node, 'DebuggerStatement');
  }
  parseHeaderExpression() {
    this.expect(10);
    const val = this.parseExpression();
    this.expect(11);
    return val;
  }
  parseDoStatement(node) {
    this.next();
    this.state.labels.push(loopLabel);
    node.body = this.withSmartMixTopicForbiddingContext(() =>
      this.parseStatement('do')
    );
    this.state.labels.pop();
    this.expect(92);
    node.test = this.parseHeaderExpression();
    this.eat(13);
    return this.finishNode(node, 'DoWhileStatement');
  }
  parseForStatement(node) {
    this.next();
    this.state.labels.push(loopLabel);
    let awaitAt = null;
    if (this.isAwaitAllowed() && this.eatContextual(96)) {
      awaitAt = this.state.lastTokStartLoc;
    }
    this.scope.enter(SCOPE_OTHER);
    this.expect(10);
    if (this.match(13)) {
      if (awaitAt !== null) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, null);
    }
    const startsWithLet = this.isContextual(99);
    const isLet = startsWithLet && this.isLetKeyword();
    if (this.match(74) || this.match(75) || isLet) {
      const initNode = this.startNode();
      const kind = isLet ? 'let' : this.state.value;
      this.next();
      this.parseVar(initNode, true, kind);
      const init = this.finishNode(initNode, 'VariableDeclaration');
      if (
        (this.match(58) || this.isContextual(101)) &&
        init.declarations.length === 1
      ) {
        return this.parseForIn(node, init, awaitAt);
      }
      if (awaitAt !== null) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, init);
    }
    const startsWithAsync = this.isContextual(95);
    const refExpressionErrors = new ExpressionErrors();
    const init = this.parseExpression(true, refExpressionErrors);
    const isForOf = this.isContextual(101);
    if (isForOf) {
      if (startsWithLet) {
        this.raise(Errors.ForOfLet, {at: init});
      }
      if (awaitAt === null && startsWithAsync && init.type === 'Identifier') {
        this.raise(Errors.ForOfAsync, {at: init});
      }
    }
    if (isForOf || this.match(58)) {
      this.checkDestructuringPrivate(refExpressionErrors);
      this.toAssignable(init, true);
      const type = isForOf ? 'ForOfStatement' : 'ForInStatement';
      this.checkLVal(init, {in: {type: type}});
      return this.parseForIn(node, init, awaitAt);
    } else {
      this.checkExpressionErrors(refExpressionErrors, true);
    }
    if (awaitAt !== null) {
      this.unexpected(awaitAt);
    }
    return this.parseFor(node, init);
  }
  parseFunctionStatement(node, isAsync, declarationPosition) {
    this.next();
    return this.parseFunction(
      node,
      FUNC_STATEMENT | (declarationPosition ? 0 : FUNC_HANGING_STATEMENT),
      isAsync
    );
  }
  parseIfStatement(node) {
    this.next();
    node.test = this.parseHeaderExpression();
    node.consequent = this.parseStatement('if');
    node.alternate = this.eat(66) ? this.parseStatement('if') : null;
    return this.finishNode(node, 'IfStatement');
  }
  parseReturnStatement(node) {
    if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
      this.raise(Errors.IllegalReturn, {at: this.state.startLoc});
    }
    this.next();
    if (this.isLineTerminator()) {
      node.argument = null;
    } else {
      node.argument = this.parseExpression();
      this.semicolon();
    }
    return this.finishNode(node, 'ReturnStatement');
  }
  parseSwitchStatement(node) {
    this.next();
    node.discriminant = this.parseHeaderExpression();
    const cases = (node.cases = []);
    this.expect(5);
    this.state.labels.push(switchLabel);
    this.scope.enter(SCOPE_OTHER);
    let cur;
    for (let sawDefault; !this.match(8); ) {
      if (this.match(61) || this.match(65)) {
        const isCase = this.match(61);
        if (cur) this.finishNode(cur, 'SwitchCase');
        cases.push((cur = this.startNode()));
        cur.consequent = [];
        this.next();
        if (isCase) {
          cur.test = this.parseExpression();
        } else {
          if (sawDefault) {
            this.raise(Errors.MultipleDefaultsInSwitch, {
              at: this.state.lastTokStartLoc,
            });
          }
          sawDefault = true;
          cur.test = null;
        }
        this.expect(14);
      } else {
        if (cur) {
          cur.consequent.push(this.parseStatement(null));
        } else {
          this.unexpected();
        }
      }
    }
    this.scope.exit();
    if (cur) this.finishNode(cur, 'SwitchCase');
    this.next();
    this.state.labels.pop();
    return this.finishNode(node, 'SwitchStatement');
  }
  parseThrowStatement(node) {
    this.next();
    if (this.hasPrecedingLineBreak()) {
      this.raise(Errors.NewlineAfterThrow, {at: this.state.lastTokEndLoc});
    }
    node.argument = this.parseExpression();
    this.semicolon();
    return this.finishNode(node, 'ThrowStatement');
  }
  parseCatchClauseParam() {
    const param = this.parseBindingAtom();
    const simple = param.type === 'Identifier';
    this.scope.enter(simple ? SCOPE_SIMPLE_CATCH : 0);
    this.checkLVal(param, {
      in: {type: 'CatchClause'},
      binding: BIND_LEXICAL,
      allowingSloppyLetBinding: true,
    });
    return param;
  }
  parseTryStatement(node) {
    this.next();
    node.block = this.parseBlock();
    node.handler = null;
    if (this.match(62)) {
      const clause = this.startNode();
      this.next();
      if (this.match(10)) {
        this.expect(10);
        clause.param = this.parseCatchClauseParam();
        this.expect(11);
      } else {
        clause.param = null;
        this.scope.enter(SCOPE_OTHER);
      }
      clause.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseBlock(false, false)
      );
      this.scope.exit();
      node.handler = this.finishNode(clause, 'CatchClause');
    }
    node.finalizer = this.eat(67) ? this.parseBlock() : null;
    if (!node.handler && !node.finalizer) {
      this.raise(Errors.NoCatchOrFinally, {at: node});
    }
    return this.finishNode(node, 'TryStatement');
  }
  parseVarStatement(node, kind, allowMissingInitializer = false) {
    this.next();
    this.parseVar(node, false, kind, allowMissingInitializer);
    this.semicolon();
    return this.finishNode(node, 'VariableDeclaration');
  }
  parseWhileStatement(node) {
    this.next();
    node.test = this.parseHeaderExpression();
    this.state.labels.push(loopLabel);
    node.body = this.withSmartMixTopicForbiddingContext(() =>
      this.parseStatement('while')
    );
    this.state.labels.pop();
    return this.finishNode(node, 'WhileStatement');
  }
  parseWithStatement(node) {
    if (this.state.strict) {
      this.raise(Errors.StrictWith, {at: this.state.startLoc});
    }
    this.next();
    node.object = this.parseHeaderExpression();
    node.body = this.withSmartMixTopicForbiddingContext(() =>
      this.parseStatement('with')
    );
    return this.finishNode(node, 'WithStatement');
  }
  parseEmptyStatement(node) {
    this.next();
    return this.finishNode(node, 'EmptyStatement');
  }
  parseLabeledStatement(node, maybeName, expr, context) {
    for (const label of this.state.labels) {
      if (label.name === maybeName) {
        this.raise(Errors.LabelRedeclaration, {at: expr, labelName: maybeName});
      }
    }
    const kind = tokenIsLoop(this.state.type)
      ? 'loop'
      : this.match(71)
        ? 'switch'
        : null;
    for (let i = this.state.labels.length - 1; i >= 0; i--) {
      const label = this.state.labels[i];
      if (label.statementStart === node.start) {
        label.statementStart = this.state.start;
        label.kind = kind;
      } else {
        break;
      }
    }
    this.state.labels.push({
      name: maybeName,
      kind: kind,
      statementStart: this.state.start,
    });
    node.body = this.parseStatement(
      context
        ? context.indexOf('label') === -1
          ? context + 'label'
          : context
        : 'label'
    );
    this.state.labels.pop();
    node.label = expr;
    return this.finishNode(node, 'LabeledStatement');
  }
  parseExpressionStatement(node, expr) {
    node.expression = expr;
    this.semicolon();
    return this.finishNode(node, 'ExpressionStatement');
  }
  parseBlock(
    allowDirectives = false,
    createNewLexicalScope = true,
    afterBlockParse
  ) {
    const node = this.startNode();
    if (allowDirectives) {
      this.state.strictErrors.clear();
    }
    this.expect(5);
    if (createNewLexicalScope) {
      this.scope.enter(SCOPE_OTHER);
    }
    this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
    if (createNewLexicalScope) {
      this.scope.exit();
    }
    return this.finishNode(node, 'BlockStatement');
  }
  isValidDirective(stmt) {
    return (
      stmt.type === 'ExpressionStatement' &&
      stmt.expression.type === 'StringLiteral' &&
      !stmt.expression.extra.parenthesized
    );
  }
  parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
    const body = (node.body = []);
    const directives = (node.directives = []);
    this.parseBlockOrModuleBlockBody(
      body,
      allowDirectives ? directives : undefined,
      topLevel,
      end,
      afterBlockParse
    );
  }
  parseBlockOrModuleBlockBody(
    body,
    directives,
    topLevel,
    end,
    afterBlockParse
  ) {
    const oldStrict = this.state.strict;
    let hasStrictModeDirective = false;
    let parsedNonDirective = false;
    while (!this.match(end)) {
      const stmt = this.parseStatement(null, topLevel);
      if (directives && !parsedNonDirective) {
        if (this.isValidDirective(stmt)) {
          const directive = this.stmtToDirective(stmt);
          directives.push(directive);
          if (
            !hasStrictModeDirective &&
            directive.value.value === 'use strict'
          ) {
            hasStrictModeDirective = true;
            this.setStrict(true);
          }
          continue;
        }
        parsedNonDirective = true;
        this.state.strictErrors.clear();
      }
      body.push(stmt);
    }
    if (afterBlockParse) {
      afterBlockParse.call(this, hasStrictModeDirective);
    }
    if (!oldStrict) {
      this.setStrict(false);
    }
    this.next();
  }
  parseFor(node, init) {
    node.init = init;
    this.semicolon(false);
    node.test = this.match(13) ? null : this.parseExpression();
    this.semicolon(false);
    node.update = this.match(11) ? null : this.parseExpression();
    this.expect(11);
    node.body = this.withSmartMixTopicForbiddingContext(() =>
      this.parseStatement('for')
    );
    this.scope.exit();
    this.state.labels.pop();
    return this.finishNode(node, 'ForStatement');
  }
  parseForIn(node, init, awaitAt) {
    const isForIn = this.match(58);
    this.next();
    if (isForIn) {
      if (awaitAt !== null) this.unexpected(awaitAt);
    } else {
      node.await = awaitAt !== null;
    }
    if (
      init.type === 'VariableDeclaration' &&
      init.declarations[0].init != null &&
      (!isForIn ||
        this.state.strict ||
        init.kind !== 'var' ||
        init.declarations[0].id.type !== 'Identifier')
    ) {
      this.raise(Errors.ForInOfLoopInitializer, {
        at: init,
        type: isForIn ? 'ForInStatement' : 'ForOfStatement',
      });
    }
    if (init.type === 'AssignmentPattern') {
      this.raise(Errors.InvalidLhs, {
        at: init,
        ancestor: {type: 'ForStatement'},
      });
    }
    node.left = init;
    node.right = isForIn
      ? this.parseExpression()
      : this.parseMaybeAssignAllowIn();
    this.expect(11);
    node.body = this.withSmartMixTopicForbiddingContext(() =>
      this.parseStatement('for')
    );
    this.scope.exit();
    this.state.labels.pop();
    return this.finishNode(node, isForIn ? 'ForInStatement' : 'ForOfStatement');
  }
  parseVar(node, isFor, kind, allowMissingInitializer = false) {
    const declarations = (node.declarations = []);
    node.kind = kind;
    for (;;) {
      const decl = this.startNode();
      this.parseVarId(decl, kind);
      decl.init = !this.eat(29)
        ? null
        : isFor
          ? this.parseMaybeAssignDisallowIn()
          : this.parseMaybeAssignAllowIn();
      if (decl.init === null && !allowMissingInitializer) {
        if (
          decl.id.type !== 'Identifier' &&
          !(isFor && (this.match(58) || this.isContextual(101)))
        ) {
          this.raise(Errors.DeclarationMissingInitializer, {
            at: this.state.lastTokEndLoc,
            kind: 'destructuring',
          });
        } else if (
          kind === 'const' &&
          !(this.match(58) || this.isContextual(101))
        ) {
          this.raise(Errors.DeclarationMissingInitializer, {
            at: this.state.lastTokEndLoc,
            kind: 'const',
          });
        }
      }
      declarations.push(this.finishNode(decl, 'VariableDeclarator'));
      if (!this.eat(12)) break;
    }
    return node;
  }
  parseVarId(decl, kind) {
    decl.id = this.parseBindingAtom();
    this.checkLVal(decl.id, {
      in: {type: 'VariableDeclarator'},
      binding: kind === 'var' ? BIND_VAR : BIND_LEXICAL,
    });
  }
  parseFunction(node, statement = FUNC_NO_FLAGS, isAsync = false) {
    const isStatement = statement & FUNC_STATEMENT;
    const isHangingStatement = statement & FUNC_HANGING_STATEMENT;
    const requireId = !!isStatement && !(statement & FUNC_NULLABLE_ID);
    this.initFunction(node, isAsync);
    if (this.match(55) && isHangingStatement) {
      this.raise(Errors.GeneratorInSingleStatementContext, {
        at: this.state.startLoc,
      });
    }
    node.generator = this.eat(55);
    if (isStatement) {
      node.id = this.parseFunctionId(requireId);
    }
    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
    this.state.maybeInArrowParameters = false;
    this.scope.enter(SCOPE_FUNCTION);
    this.prodParam.enter(functionFlags(isAsync, node.generator));
    if (!isStatement) {
      node.id = this.parseFunctionId();
    }
    this.parseFunctionParams(node, false);
    this.withSmartMixTopicForbiddingContext(() => {
      this.parseFunctionBodyAndFinish(
        node,
        isStatement ? 'FunctionDeclaration' : 'FunctionExpression'
      );
    });
    this.prodParam.exit();
    this.scope.exit();
    if (isStatement && !isHangingStatement) {
      this.registerFunctionStatementId(node);
    }
    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
    return node;
  }
  parseFunctionId(requireId) {
    return requireId || tokenIsIdentifier(this.state.type)
      ? this.parseIdentifier()
      : null;
  }
  parseFunctionParams(node, allowModifiers) {
    this.expect(10);
    this.expressionScope.enter(newParameterDeclarationScope());
    node.params = this.parseBindingList(11, 41, false, allowModifiers);
    this.expressionScope.exit();
  }
  registerFunctionStatementId(node) {
    if (!node.id) return;
    this.scope.declareName(
      node.id.name,
      this.state.strict || node.generator || node.async
        ? this.scope.treatFunctionsAsVar
          ? BIND_VAR
          : BIND_LEXICAL
        : BIND_FUNCTION,
      node.id.loc.start
    );
  }
  parseClass(node, isStatement, optionalId) {
    this.next();
    this.takeDecorators(node);
    const oldStrict = this.state.strict;
    this.state.strict = true;
    this.parseClassId(node, isStatement, optionalId);
    this.parseClassSuper(node);
    node.body = this.parseClassBody(!!node.superClass, oldStrict);
    return this.finishNode(
      node,
      isStatement ? 'ClassDeclaration' : 'ClassExpression'
    );
  }
  isClassProperty() {
    return this.match(29) || this.match(13) || this.match(8);
  }
  isClassMethod() {
    return this.match(10);
  }
  isNonstaticConstructor(method) {
    return (
      !method.computed &&
      !method.static &&
      (method.key.name === 'constructor' || method.key.value === 'constructor')
    );
  }
  parseClassBody(hadSuperClass, oldStrict) {
    this.classScope.enter();
    const state = {hadConstructor: false, hadSuperClass: hadSuperClass};
    let decorators = [];
    const classBody = this.startNode();
    classBody.body = [];
    this.expect(5);
    this.withSmartMixTopicForbiddingContext(() => {
      while (!this.match(8)) {
        if (this.eat(13)) {
          if (decorators.length > 0) {
            throw this.raise(Errors.DecoratorSemicolon, {
              at: this.state.lastTokEndLoc,
            });
          }
          continue;
        }
        if (this.match(26)) {
          decorators.push(this.parseDecorator());
          continue;
        }
        const member = this.startNode();
        if (decorators.length) {
          member.decorators = decorators;
          this.resetStartLocationFromNode(member, decorators[0]);
          decorators = [];
        }
        this.parseClassMember(classBody, member, state);
        if (
          member.kind === 'constructor' &&
          member.decorators &&
          member.decorators.length > 0
        ) {
          this.raise(Errors.DecoratorConstructor, {at: member});
        }
      }
    });
    this.state.strict = oldStrict;
    this.next();
    if (decorators.length) {
      throw this.raise(Errors.TrailingDecorator, {at: this.state.startLoc});
    }
    this.classScope.exit();
    return this.finishNode(classBody, 'ClassBody');
  }
  parseClassMemberFromModifier(classBody, member) {
    const key = this.parseIdentifier(true);
    if (this.isClassMethod()) {
      const method = member;
      method.kind = 'method';
      method.computed = false;
      method.key = key;
      method.static = false;
      this.pushClassMethod(classBody, method, false, false, false, false);
      return true;
    } else if (this.isClassProperty()) {
      const prop = member;
      prop.computed = false;
      prop.key = key;
      prop.static = false;
      classBody.body.push(this.parseClassProperty(prop));
      return true;
    }
    this.resetPreviousNodeTrailingComments(key);
    return false;
  }
  parseClassMember(classBody, member, state) {
    const isStatic = this.isContextual(104);
    if (isStatic) {
      if (this.parseClassMemberFromModifier(classBody, member)) {
        return;
      }
      if (this.eat(5)) {
        this.parseClassStaticBlock(classBody, member);
        return;
      }
    }
    this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
  }
  parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
    const publicMethod = member;
    const privateMethod = member;
    const publicProp = member;
    const privateProp = member;
    const accessorProp = member;
    const method = publicMethod;
    const publicMember = publicMethod;
    member.static = isStatic;
    this.parsePropertyNamePrefixOperator(member);
    if (this.eat(55)) {
      method.kind = 'method';
      const isPrivateName = this.match(134);
      this.parseClassElementName(method);
      if (isPrivateName) {
        this.pushClassPrivateMethod(classBody, privateMethod, true, false);
        return;
      }
      if (this.isNonstaticConstructor(publicMethod)) {
        this.raise(Errors.ConstructorIsGenerator, {at: publicMethod.key});
      }
      this.pushClassMethod(classBody, publicMethod, true, false, false, false);
      return;
    }
    const isContextual =
      tokenIsIdentifier(this.state.type) && !this.state.containsEsc;
    const isPrivate = this.match(134);
    const key = this.parseClassElementName(member);
    const maybeQuestionTokenStartLoc = this.state.startLoc;
    this.parsePostMemberNameModifiers(publicMember);
    if (this.isClassMethod()) {
      method.kind = 'method';
      if (isPrivate) {
        this.pushClassPrivateMethod(classBody, privateMethod, false, false);
        return;
      }
      const isConstructor = this.isNonstaticConstructor(publicMethod);
      let allowsDirectSuper = false;
      if (isConstructor) {
        publicMethod.kind = 'constructor';
        if (state.hadConstructor && !this.hasPlugin('typescript')) {
          this.raise(Errors.DuplicateConstructor, {at: key});
        }
        if (isConstructor && this.hasPlugin('typescript') && member.override) {
          this.raise(Errors.OverrideOnConstructor, {at: key});
        }
        state.hadConstructor = true;
        allowsDirectSuper = state.hadSuperClass;
      }
      this.pushClassMethod(
        classBody,
        publicMethod,
        false,
        false,
        isConstructor,
        allowsDirectSuper
      );
    } else if (this.isClassProperty()) {
      if (isPrivate) {
        this.pushClassPrivateProperty(classBody, privateProp);
      } else {
        this.pushClassProperty(classBody, publicProp);
      }
    } else if (
      isContextual &&
      key.name === 'async' &&
      !this.isLineTerminator()
    ) {
      this.resetPreviousNodeTrailingComments(key);
      const isGenerator = this.eat(55);
      if (publicMember.optional) {
        this.unexpected(maybeQuestionTokenStartLoc);
      }
      method.kind = 'method';
      const isPrivate = this.match(134);
      this.parseClassElementName(method);
      this.parsePostMemberNameModifiers(publicMember);
      if (isPrivate) {
        this.pushClassPrivateMethod(
          classBody,
          privateMethod,
          isGenerator,
          true
        );
      } else {
        if (this.isNonstaticConstructor(publicMethod)) {
          this.raise(Errors.ConstructorIsAsync, {at: publicMethod.key});
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          isGenerator,
          true,
          false,
          false
        );
      }
    } else if (
      isContextual &&
      (key.name === 'get' || key.name === 'set') &&
      !(this.match(55) && this.isLineTerminator())
    ) {
      this.resetPreviousNodeTrailingComments(key);
      method.kind = key.name;
      const isPrivate = this.match(134);
      this.parseClassElementName(publicMethod);
      if (isPrivate) {
        this.pushClassPrivateMethod(classBody, privateMethod, false, false);
      } else {
        if (this.isNonstaticConstructor(publicMethod)) {
          this.raise(Errors.ConstructorIsAccessor, {at: publicMethod.key});
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          false,
          false,
          false,
          false
        );
      }
      this.checkGetterSetterParams(publicMethod);
    } else if (
      isContextual &&
      key.name === 'accessor' &&
      !this.isLineTerminator()
    ) {
      this.expectPlugin('decoratorAutoAccessors');
      this.resetPreviousNodeTrailingComments(key);
      const isPrivate = this.match(134);
      this.parseClassElementName(publicProp);
      this.pushClassAccessorProperty(classBody, accessorProp, isPrivate);
    } else if (this.isLineTerminator()) {
      if (isPrivate) {
        this.pushClassPrivateProperty(classBody, privateProp);
      } else {
        this.pushClassProperty(classBody, publicProp);
      }
    } else {
      this.unexpected();
    }
  }
  parseClassElementName(member) {
    const {type: type, value: value} = this.state;
    if (
      (type === 128 || type === 129) &&
      member.static &&
      value === 'prototype'
    ) {
      this.raise(Errors.StaticPrototype, {at: this.state.startLoc});
    }
    if (type === 134) {
      if (value === 'constructor') {
        this.raise(Errors.ConstructorClassPrivateField, {
          at: this.state.startLoc,
        });
      }
      const key = this.parsePrivateName();
      member.key = key;
      return key;
    }
    return this.parsePropertyName(member);
  }
  parseClassStaticBlock(classBody, member) {
    var _member$decorators;
    this.scope.enter(SCOPE_CLASS | SCOPE_STATIC_BLOCK | SCOPE_SUPER);
    const oldLabels = this.state.labels;
    this.state.labels = [];
    this.prodParam.enter(PARAM);
    const body = (member.body = []);
    this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
    this.prodParam.exit();
    this.scope.exit();
    this.state.labels = oldLabels;
    classBody.body.push(this.finishNode(member, 'StaticBlock'));
    if (
      (_member$decorators = member.decorators) != null &&
      _member$decorators.length
    ) {
      this.raise(Errors.DecoratorStaticBlock, {at: member});
    }
  }
  pushClassProperty(classBody, prop) {
    if (
      !prop.computed &&
      (prop.key.name === 'constructor' || prop.key.value === 'constructor')
    ) {
      this.raise(Errors.ConstructorClassField, {at: prop.key});
    }
    classBody.body.push(this.parseClassProperty(prop));
  }
  pushClassPrivateProperty(classBody, prop) {
    const node = this.parseClassPrivateProperty(prop);
    classBody.body.push(node);
    this.classScope.declarePrivateName(
      this.getPrivateNameSV(node.key),
      CLASS_ELEMENT_OTHER,
      node.key.loc.start
    );
  }
  pushClassAccessorProperty(classBody, prop, isPrivate) {
    if (!isPrivate && !prop.computed) {
      const key = prop.key;
      if (key.name === 'constructor' || key.value === 'constructor') {
        this.raise(Errors.ConstructorClassField, {at: key});
      }
    }
    const node = this.parseClassAccessorProperty(prop);
    classBody.body.push(node);
    if (isPrivate) {
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        CLASS_ELEMENT_OTHER,
        node.key.loc.start
      );
    }
  }
  pushClassMethod(
    classBody,
    method,
    isGenerator,
    isAsync,
    isConstructor,
    allowsDirectSuper
  ) {
    classBody.body.push(
      this.parseMethod(
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper,
        'ClassMethod',
        true
      )
    );
  }
  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
    const node = this.parseMethod(
      method,
      isGenerator,
      isAsync,
      false,
      false,
      'ClassPrivateMethod',
      true
    );
    classBody.body.push(node);
    const kind =
      node.kind === 'get'
        ? node.static
          ? CLASS_ELEMENT_STATIC_GETTER
          : CLASS_ELEMENT_INSTANCE_GETTER
        : node.kind === 'set'
          ? node.static
            ? CLASS_ELEMENT_STATIC_SETTER
            : CLASS_ELEMENT_INSTANCE_SETTER
          : CLASS_ELEMENT_OTHER;
    this.declareClassPrivateMethodInScope(node, kind);
  }
  declareClassPrivateMethodInScope(node, kind) {
    this.classScope.declarePrivateName(
      this.getPrivateNameSV(node.key),
      kind,
      node.key.loc.start
    );
  }
  parsePostMemberNameModifiers(methodOrProp) {}
  parseClassPrivateProperty(node) {
    this.parseInitializer(node);
    this.semicolon();
    return this.finishNode(node, 'ClassPrivateProperty');
  }
  parseClassProperty(node) {
    this.parseInitializer(node);
    this.semicolon();
    return this.finishNode(node, 'ClassProperty');
  }
  parseClassAccessorProperty(node) {
    this.parseInitializer(node);
    this.semicolon();
    return this.finishNode(node, 'ClassAccessorProperty');
  }
  parseInitializer(node) {
    this.scope.enter(SCOPE_CLASS | SCOPE_SUPER);
    this.expressionScope.enter(newExpressionScope());
    this.prodParam.enter(PARAM);
    node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
    this.expressionScope.exit();
    this.prodParam.exit();
    this.scope.exit();
  }
  parseClassId(node, isStatement, optionalId, bindingType = BIND_CLASS) {
    if (tokenIsIdentifier(this.state.type)) {
      node.id = this.parseIdentifier();
      if (isStatement) {
        this.declareNameFromIdentifier(node.id, bindingType);
      }
    } else {
      if (optionalId || !isStatement) {
        node.id = null;
      } else {
        throw this.raise(Errors.MissingClassName, {at: this.state.startLoc});
      }
    }
  }
  parseClassSuper(node) {
    node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
  }
  parseExport(node) {
    const hasDefault = this.maybeParseExportDefaultSpecifier(node);
    const parseAfterDefault = !hasDefault || this.eat(12);
    const hasStar = parseAfterDefault && this.eatExportStar(node);
    const hasNamespace =
      hasStar && this.maybeParseExportNamespaceSpecifier(node);
    const parseAfterNamespace =
      parseAfterDefault && (!hasNamespace || this.eat(12));
    const isFromRequired = hasDefault || hasStar;
    if (hasStar && !hasNamespace) {
      if (hasDefault) this.unexpected();
      this.parseExportFrom(node, true);
      return this.finishNode(node, 'ExportAllDeclaration');
    }
    const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
    if (
      (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) ||
      (hasNamespace && parseAfterNamespace && !hasSpecifiers)
    ) {
      throw this.unexpected(null, 5);
    }
    let hasDeclaration;
    if (isFromRequired || hasSpecifiers) {
      hasDeclaration = false;
      this.parseExportFrom(node, isFromRequired);
    } else {
      hasDeclaration = this.maybeParseExportDeclaration(node);
    }
    if (isFromRequired || hasSpecifiers || hasDeclaration) {
      this.checkExport(node, true, false, !!node.source);
      return this.finishNode(node, 'ExportNamedDeclaration');
    }
    if (this.eat(65)) {
      node.declaration = this.parseExportDefaultExpression();
      this.checkExport(node, true, true);
      return this.finishNode(node, 'ExportDefaultDeclaration');
    }
    throw this.unexpected(null, 5);
  }
  eatExportStar(node) {
    return this.eat(55);
  }
  maybeParseExportDefaultSpecifier(node) {
    if (this.isExportDefaultSpecifier()) {
      this.expectPlugin('exportDefaultFrom');
      const specifier = this.startNode();
      specifier.exported = this.parseIdentifier(true);
      node.specifiers = [this.finishNode(specifier, 'ExportDefaultSpecifier')];
      return true;
    }
    return false;
  }
  maybeParseExportNamespaceSpecifier(node) {
    if (this.isContextual(93)) {
      if (!node.specifiers) node.specifiers = [];
      const specifier = this.startNodeAt(
        this.state.lastTokStart,
        this.state.lastTokStartLoc
      );
      this.next();
      specifier.exported = this.parseModuleExportName();
      node.specifiers.push(
        this.finishNode(specifier, 'ExportNamespaceSpecifier')
      );
      return true;
    }
    return false;
  }
  maybeParseExportNamedSpecifiers(node) {
    if (this.match(5)) {
      if (!node.specifiers) node.specifiers = [];
      const isTypeExport = node.exportKind === 'type';
      node.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
      node.source = null;
      node.declaration = null;
      if (this.hasPlugin('importAssertions')) {
        node.assertions = [];
      }
      return true;
    }
    return false;
  }
  maybeParseExportDeclaration(node) {
    if (this.shouldParseExportDeclaration()) {
      node.specifiers = [];
      node.source = null;
      if (this.hasPlugin('importAssertions')) {
        node.assertions = [];
      }
      node.declaration = this.parseExportDeclaration(node);
      return true;
    }
    return false;
  }
  isAsyncFunction() {
    if (!this.isContextual(95)) return false;
    const next = this.nextTokenStart();
    return (
      !lineBreak.test(this.input.slice(this.state.pos, next)) &&
      this.isUnparsedContextual(next, 'function')
    );
  }
  parseExportDefaultExpression() {
    const expr = this.startNode();
    const isAsync = this.isAsyncFunction();
    if (this.match(68) || isAsync) {
      this.next();
      if (isAsync) {
        this.next();
      }
      return this.parseFunction(
        expr,
        FUNC_STATEMENT | FUNC_NULLABLE_ID,
        isAsync
      );
    }
    if (this.match(80)) {
      return this.parseClass(expr, true, true);
    }
    if (this.match(26)) {
      if (
        this.hasPlugin('decorators') &&
        this.getPluginOption('decorators', 'decoratorsBeforeExport')
      ) {
        this.raise(Errors.DecoratorBeforeExport, {at: this.state.startLoc});
      }
      this.parseDecorators(false);
      return this.parseClass(expr, true, true);
    }
    if (this.match(75) || this.match(74) || this.isLet()) {
      throw this.raise(Errors.UnsupportedDefaultExport, {
        at: this.state.startLoc,
      });
    }
    const res = this.parseMaybeAssignAllowIn();
    this.semicolon();
    return res;
  }
  parseExportDeclaration(node) {
    return this.parseStatement(null);
  }
  isExportDefaultSpecifier() {
    const {type: type} = this.state;
    if (tokenIsIdentifier(type)) {
      if ((type === 95 && !this.state.containsEsc) || type === 99) {
        return false;
      }
      if ((type === 126 || type === 125) && !this.state.containsEsc) {
        const {type: nextType} = this.lookahead();
        if (
          (tokenIsIdentifier(nextType) && nextType !== 97) ||
          nextType === 5
        ) {
          this.expectOnePlugin(['flow', 'typescript']);
          return false;
        }
      }
    } else if (!this.match(65)) {
      return false;
    }
    const next = this.nextTokenStart();
    const hasFrom = this.isUnparsedContextual(next, 'from');
    if (
      this.input.charCodeAt(next) === 44 ||
      (tokenIsIdentifier(this.state.type) && hasFrom)
    ) {
      return true;
    }
    if (this.match(65) && hasFrom) {
      const nextAfterFrom = this.input.charCodeAt(
        this.nextTokenStartSince(next + 4)
      );
      return nextAfterFrom === 34 || nextAfterFrom === 39;
    }
    return false;
  }
  parseExportFrom(node, expect) {
    if (this.eatContextual(97)) {
      node.source = this.parseImportSource();
      this.checkExport(node);
      const assertions = this.maybeParseImportAssertions();
      if (assertions) {
        node.assertions = assertions;
        this.checkJSONModuleImport(node);
      }
    } else if (expect) {
      this.unexpected();
    }
    this.semicolon();
  }
  shouldParseExportDeclaration() {
    const {type: type} = this.state;
    if (type === 26) {
      this.expectOnePlugin(['decorators', 'decorators-legacy']);
      if (this.hasPlugin('decorators')) {
        if (this.getPluginOption('decorators', 'decoratorsBeforeExport')) {
          throw this.raise(Errors.DecoratorBeforeExport, {
            at: this.state.startLoc,
          });
        }
        return true;
      }
    }
    return (
      type === 74 ||
      type === 75 ||
      type === 68 ||
      type === 80 ||
      this.isLet() ||
      this.isAsyncFunction()
    );
  }
  checkExport(node, checkNames, isDefault, isFrom) {
    if (checkNames) {
      if (isDefault) {
        this.checkDuplicateExports(node, 'default');
        if (this.hasPlugin('exportDefaultFrom')) {
          var _declaration$extra;
          const declaration = node.declaration;
          if (
            declaration.type === 'Identifier' &&
            declaration.name === 'from' &&
            declaration.end - declaration.start === 4 &&
            !(
              (_declaration$extra = declaration.extra) != null &&
              _declaration$extra.parenthesized
            )
          ) {
            this.raise(Errors.ExportDefaultFromAsIdentifier, {at: declaration});
          }
        }
      } else if (node.specifiers && node.specifiers.length) {
        for (const specifier of node.specifiers) {
          const {exported: exported} = specifier;
          const exportName =
            exported.type === 'Identifier' ? exported.name : exported.value;
          this.checkDuplicateExports(specifier, exportName);
          if (!isFrom && specifier.local) {
            const {local: local} = specifier;
            if (local.type !== 'Identifier') {
              this.raise(Errors.ExportBindingIsString, {
                at: specifier,
                localName: local.value,
                exportName: exportName,
              });
            } else {
              this.checkReservedWord(local.name, local.loc.start, true, false);
              this.scope.checkLocalExport(local);
            }
          }
        }
      } else if (node.declaration) {
        if (
          node.declaration.type === 'FunctionDeclaration' ||
          node.declaration.type === 'ClassDeclaration'
        ) {
          const id = node.declaration.id;
          if (!id) throw new Error('Assertion failure');
          this.checkDuplicateExports(node, id.name);
        } else if (node.declaration.type === 'VariableDeclaration') {
          for (const declaration of node.declaration.declarations) {
            this.checkDeclaration(declaration.id);
          }
        }
      }
    }
    const currentContextDecorators =
      this.state.decoratorStack[this.state.decoratorStack.length - 1];
    if (currentContextDecorators.length) {
      throw this.raise(Errors.UnsupportedDecoratorExport, {at: node});
    }
  }
  checkDeclaration(node) {
    if (node.type === 'Identifier') {
      this.checkDuplicateExports(node, node.name);
    } else if (node.type === 'ObjectPattern') {
      for (const prop of node.properties) {
        this.checkDeclaration(prop);
      }
    } else if (node.type === 'ArrayPattern') {
      for (const elem of node.elements) {
        if (elem) {
          this.checkDeclaration(elem);
        }
      }
    } else if (node.type === 'ObjectProperty') {
      this.checkDeclaration(node.value);
    } else if (node.type === 'RestElement') {
      this.checkDeclaration(node.argument);
    } else if (node.type === 'AssignmentPattern') {
      this.checkDeclaration(node.left);
    }
  }
  checkDuplicateExports(node, exportName) {
    if (this.exportedIdentifiers.has(exportName)) {
      if (exportName === 'default') {
        this.raise(Errors.DuplicateDefaultExport, {at: node});
      } else {
        this.raise(Errors.DuplicateExport, {at: node, exportName: exportName});
      }
    }
    this.exportedIdentifiers.add(exportName);
  }
  parseExportSpecifiers(isInTypeExport) {
    const nodes = [];
    let first = true;
    this.expect(5);
    while (!this.eat(8)) {
      if (first) {
        first = false;
      } else {
        this.expect(12);
        if (this.eat(8)) break;
      }
      const isMaybeTypeOnly = this.isContextual(126);
      const isString = this.match(129);
      const node = this.startNode();
      node.local = this.parseModuleExportName();
      nodes.push(
        this.parseExportSpecifier(
          node,
          isString,
          isInTypeExport,
          isMaybeTypeOnly
        )
      );
    }
    return nodes;
  }
  parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
    if (this.eatContextual(93)) {
      node.exported = this.parseModuleExportName();
    } else if (isString) {
      node.exported = cloneStringLiteral(node.local);
    } else if (!node.exported) {
      node.exported = cloneIdentifier(node.local);
    }
    return this.finishNode(node, 'ExportSpecifier');
  }
  parseModuleExportName() {
    if (this.match(129)) {
      const result = this.parseStringLiteral(this.state.value);
      const surrogate = result.value.match(loneSurrogate);
      if (surrogate) {
        this.raise(Errors.ModuleExportNameHasLoneSurrogate, {
          at: result,
          surrogateCharCode: surrogate[0].charCodeAt(0),
        });
      }
      return result;
    }
    return this.parseIdentifier(true);
  }
  isJSONModuleImport(node) {
    if (node.assertions != null) {
      return node.assertions.some(
        ({key: key, value: value}) =>
          value.value === 'json' &&
          (key.type === 'Identifier'
            ? key.name === 'type'
            : key.value === 'type')
      );
    }
    return false;
  }
  checkJSONModuleImport(node) {
    if (this.isJSONModuleImport(node) && node.type !== 'ExportAllDeclaration') {
      const {specifiers: specifiers} = node;
      if (specifiers != null) {
        const nonDefaultNamedSpecifier = specifiers.find(specifier => {
          let imported;
          if (specifier.type === 'ExportSpecifier') {
            imported = specifier.local;
          } else if (specifier.type === 'ImportSpecifier') {
            imported = specifier.imported;
          }
          if (imported !== undefined) {
            return imported.type === 'Identifier'
              ? imported.name !== 'default'
              : imported.value !== 'default';
          }
        });
        if (nonDefaultNamedSpecifier !== undefined) {
          this.raise(Errors.ImportJSONBindingNotDefault, {
            at: nonDefaultNamedSpecifier.loc.start,
          });
        }
      }
    }
  }
  parseImport(node) {
    node.specifiers = [];
    if (!this.match(129)) {
      const hasDefault = this.maybeParseDefaultImportSpecifier(node);
      const parseNext = !hasDefault || this.eat(12);
      const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
      if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
      this.expectContextual(97);
    }
    node.source = this.parseImportSource();
    const assertions = this.maybeParseImportAssertions();
    if (assertions) {
      node.assertions = assertions;
    } else {
      const attributes = this.maybeParseModuleAttributes();
      if (attributes) {
        node.attributes = attributes;
      }
    }
    this.checkJSONModuleImport(node);
    this.semicolon();
    return this.finishNode(node, 'ImportDeclaration');
  }
  parseImportSource() {
    if (!this.match(129)) this.unexpected();
    return this.parseExprAtom();
  }
  shouldParseDefaultImport(node) {
    return tokenIsIdentifier(this.state.type);
  }
  parseImportSpecifierLocal(node, specifier, type) {
    specifier.local = this.parseIdentifier();
    node.specifiers.push(this.finishImportSpecifier(specifier, type));
  }
  finishImportSpecifier(specifier, type, bindingType = BIND_LEXICAL) {
    this.checkLVal(specifier.local, {in: specifier, binding: bindingType});
    return this.finishNode(specifier, type);
  }
  parseAssertEntries() {
    const attrs = [];
    const attrNames = new Set();
    do {
      if (this.match(8)) {
        break;
      }
      const node = this.startNode();
      const keyName = this.state.value;
      if (attrNames.has(keyName)) {
        this.raise(Errors.ModuleAttributesWithDuplicateKeys, {
          at: this.state.startLoc,
          key: keyName,
        });
      }
      attrNames.add(keyName);
      if (this.match(129)) {
        node.key = this.parseStringLiteral(keyName);
      } else {
        node.key = this.parseIdentifier(true);
      }
      this.expect(14);
      if (!this.match(129)) {
        throw this.raise(Errors.ModuleAttributeInvalidValue, {
          at: this.state.startLoc,
        });
      }
      node.value = this.parseStringLiteral(this.state.value);
      attrs.push(this.finishNode(node, 'ImportAttribute'));
    } while (this.eat(12));
    return attrs;
  }
  maybeParseModuleAttributes() {
    if (this.match(76) && !this.hasPrecedingLineBreak()) {
      this.expectPlugin('moduleAttributes');
      this.next();
    } else {
      if (this.hasPlugin('moduleAttributes')) return [];
      return null;
    }
    const attrs = [];
    const attributes = new Set();
    do {
      const node = this.startNode();
      node.key = this.parseIdentifier(true);
      if (node.key.name !== 'type') {
        this.raise(Errors.ModuleAttributeDifferentFromType, {at: node.key});
      }
      if (attributes.has(node.key.name)) {
        this.raise(Errors.ModuleAttributesWithDuplicateKeys, {
          at: node.key,
          key: node.key.name,
        });
      }
      attributes.add(node.key.name);
      this.expect(14);
      if (!this.match(129)) {
        throw this.raise(Errors.ModuleAttributeInvalidValue, {
          at: this.state.startLoc,
        });
      }
      node.value = this.parseStringLiteral(this.state.value);
      this.finishNode(node, 'ImportAttribute');
      attrs.push(node);
    } while (this.eat(12));
    return attrs;
  }
  maybeParseImportAssertions() {
    if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
      this.expectPlugin('importAssertions');
      this.next();
    } else {
      if (this.hasPlugin('importAssertions')) return [];
      return null;
    }
    this.eat(5);
    const attrs = this.parseAssertEntries();
    this.eat(8);
    return attrs;
  }
  maybeParseDefaultImportSpecifier(node) {
    if (this.shouldParseDefaultImport(node)) {
      this.parseImportSpecifierLocal(
        node,
        this.startNode(),
        'ImportDefaultSpecifier'
      );
      return true;
    }
    return false;
  }
  maybeParseStarImportSpecifier(node) {
    if (this.match(55)) {
      const specifier = this.startNode();
      this.next();
      this.expectContextual(93);
      this.parseImportSpecifierLocal(
        node,
        specifier,
        'ImportNamespaceSpecifier'
      );
      return true;
    }
    return false;
  }
  parseNamedImportSpecifiers(node) {
    let first = true;
    this.expect(5);
    while (!this.eat(8)) {
      if (first) {
        first = false;
      } else {
        if (this.eat(14)) {
          throw this.raise(Errors.DestructureNamedImport, {
            at: this.state.startLoc,
          });
        }
        this.expect(12);
        if (this.eat(8)) break;
      }
      const specifier = this.startNode();
      const importedIsString = this.match(129);
      const isMaybeTypeOnly = this.isContextual(126);
      specifier.imported = this.parseModuleExportName();
      const importSpecifier = this.parseImportSpecifier(
        specifier,
        importedIsString,
        node.importKind === 'type' || node.importKind === 'typeof',
        isMaybeTypeOnly,
        undefined
      );
      node.specifiers.push(importSpecifier);
    }
  }
  parseImportSpecifier(
    specifier,
    importedIsString,
    isInTypeOnlyImport,
    isMaybeTypeOnly,
    bindingType
  ) {
    if (this.eatContextual(93)) {
      specifier.local = this.parseIdentifier();
    } else {
      const {imported: imported} = specifier;
      if (importedIsString) {
        throw this.raise(Errors.ImportBindingIsString, {
          at: specifier,
          importName: imported.value,
        });
      }
      this.checkReservedWord(imported.name, specifier.loc.start, true, true);
      if (!specifier.local) {
        specifier.local = cloneIdentifier(imported);
      }
    }
    return this.finishImportSpecifier(
      specifier,
      'ImportSpecifier',
      bindingType
    );
  }
  isThisParam(param) {
    return param.type === 'Identifier' && param.name === 'this';
  }
}
class Parser extends StatementParser {
  constructor(options, input) {
    options = getOptions(options);
    super(options, input);
    this.options = options;
    this.initializeScopes();
    this.plugins = pluginsMap(this.options.plugins);
    this.filename = options.sourceFilename;
  }
  getScopeHandler() {
    return ScopeHandler;
  }
  parse() {
    this.enterInitialScopes();
    const file = this.startNode();
    const program = this.startNode();
    this.nextToken();
    file.errors = null;
    this.parseTopLevel(file, program);
    file.errors = this.state.errors;
    return file;
  }
}
function pluginsMap(plugins) {
  const pluginMap = new Map();
  for (const plugin of plugins) {
    const [name, options] = Array.isArray(plugin) ? plugin : [plugin, {}];
    if (!pluginMap.has(name)) pluginMap.set(name, options || {});
  }
  return pluginMap;
}
function parse$3(input, options) {
  var _options;
  if (
    ((_options = options) == null ? void 0 : _options.sourceType) ===
    'unambiguous'
  ) {
    options = Object.assign({}, options);
    try {
      options.sourceType = 'module';
      const parser = getParser(options, input);
      const ast = parser.parse();
      if (parser.sawUnambiguousESM) {
        return ast;
      }
      if (parser.ambiguousScriptDifferentAst) {
        try {
          options.sourceType = 'script';
          return getParser(options, input).parse();
        } catch (_unused) {}
      } else {
        ast.program.sourceType = 'script';
      }
      return ast;
    } catch (moduleError) {
      try {
        options.sourceType = 'script';
        return getParser(options, input).parse();
      } catch (_unused2) {}
      throw moduleError;
    }
  } else {
    return getParser(options, input).parse();
  }
}
function parseExpression(input, options) {
  const parser = getParser(options, input);
  if (parser.options.strictMode) {
    parser.state.strict = true;
  }
  return parser.getExpression();
}
function generateExportedTokenTypes(internalTokenTypes) {
  const tokenTypes = {};
  for (const typeName of Object.keys(internalTokenTypes)) {
    tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
  }
  return tokenTypes;
}
const tokTypes = generateExportedTokenTypes(tt);
function getParser(options, input) {
  let cls = Parser;
  if (options != null && options.plugins) {
    validatePlugins(options.plugins);
    cls = getParserClass(options.plugins);
  }
  return new cls(options, input);
}
const parserClassCache = {};
function getParserClass(pluginsFromOptions) {
  const pluginList = mixinPluginNames.filter(name =>
    hasPlugin(pluginsFromOptions, name)
  );
  const key = pluginList.join('/');
  let cls = parserClassCache[key];
  if (!cls) {
    cls = Parser;
    for (const plugin of pluginList) {
      cls = mixinPlugins[plugin](cls);
    }
    parserClassCache[key] = cls;
  }
  return cls;
}
var parse_1 = (lib$g.parse = parse$3);
lib$g.parseExpression = parseExpression;
lib$g.tokTypes = tokTypes;
var lib$f = {};
var lib$e = {};
var lib$d = {};
var identifier$1 = {};
var hasRequiredIdentifier$1;
function requireIdentifier$1() {
  if (hasRequiredIdentifier$1) return identifier$1;
  hasRequiredIdentifier$1 = 1;
  Object.defineProperty(identifier$1, '__esModule', {value: true});
  identifier$1.isIdentifierChar = isIdentifierChar;
  identifier$1.isIdentifierName = isIdentifierName;
  identifier$1.isIdentifierStart = isIdentifierStart;
  let nonASCIIidentifierStartChars =
    'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
  let nonASCIIidentifierChars =
    '‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿';
  const nonASCIIidentifierStart = new RegExp(
    '[' + nonASCIIidentifierStartChars + ']'
  );
  const nonASCIIidentifier = new RegExp(
    '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
  );
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  const astralIdentifierStartCodes = [
    0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48,
    48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5,
    39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10,
    21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11,
    22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2,
    2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72,
    56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20,
    28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4,
    0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2,
    14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4,
    159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0,
    60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2,
    23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12,
    45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0,
    26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921,
    103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30,
    18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67,
    12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16,
    0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2,
    70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2,
    27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2,
    24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11,
    6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60,
    67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5,
    0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0,
    3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719,
    33, 4153, 7, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938, 6, 4191,
  ];
  const astralIdentifierCodes = [
    509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1,
    574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1,
    11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13,
    9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3,
    2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3,
    8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5,
    2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0,
    10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2,
    6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4,
    14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54,
    8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31,
    3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2,
    16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983,
    6, 110, 6, 6, 9, 4759, 9, 787719, 239,
  ];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length; i < length; i += 2) {
      pos += set[i];
      if (pos > code) return false;
      pos += set[i + 1];
      if (pos >= code) return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65) return code === 36;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return (
        code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
      );
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48) return code === 36;
    if (code < 58) return true;
    if (code < 65) return false;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return (
      isInAstralSet(code, astralIdentifierStartCodes) ||
      isInAstralSet(code, astralIdentifierCodes)
    );
  }
  function isIdentifierName(name) {
    let isFirst = true;
    for (let i = 0; i < name.length; i++) {
      let cp = name.charCodeAt(i);
      if ((cp & 64512) === 55296 && i + 1 < name.length) {
        const trail = name.charCodeAt(++i);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      if (isFirst) {
        isFirst = false;
        if (!isIdentifierStart(cp)) {
          return false;
        }
      } else if (!isIdentifierChar(cp)) {
        return false;
      }
    }
    return !isFirst;
  }
  return identifier$1;
}
var keyword$1 = {};
var hasRequiredKeyword$1;
function requireKeyword$1() {
  if (hasRequiredKeyword$1) return keyword$1;
  hasRequiredKeyword$1 = 1;
  Object.defineProperty(keyword$1, '__esModule', {value: true});
  keyword$1.isKeyword = isKeyword;
  keyword$1.isReservedWord = isReservedWord;
  keyword$1.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
  keyword$1.isStrictBindReservedWord = isStrictBindReservedWord;
  keyword$1.isStrictReservedWord = isStrictReservedWord;
  const reservedWords = {
    keyword: [
      'break',
      'case',
      'catch',
      'continue',
      'debugger',
      'default',
      'do',
      'else',
      'finally',
      'for',
      'function',
      'if',
      'return',
      'switch',
      'throw',
      'try',
      'var',
      'const',
      'while',
      'with',
      'new',
      'this',
      'super',
      'class',
      'extends',
      'export',
      'import',
      'null',
      'true',
      'false',
      'in',
      'instanceof',
      'typeof',
      'void',
      'delete',
    ],
    strict: [
      'implements',
      'interface',
      'let',
      'package',
      'private',
      'protected',
      'public',
      'static',
      'yield',
    ],
    strictBind: ['eval', 'arguments'],
  };
  const keywords = new Set(reservedWords.keyword);
  const reservedWordsStrictSet = new Set(reservedWords.strict);
  const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return (inModule && word === 'await') || word === 'enum';
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return (
      isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
    );
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  return keyword$1;
}
var hasRequiredLib$g;
function requireLib$g() {
  if (hasRequiredLib$g) return lib$d;
  hasRequiredLib$g = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    Object.defineProperty(exports, 'isIdentifierChar', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierChar;
      },
    });
    Object.defineProperty(exports, 'isIdentifierName', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierName;
      },
    });
    Object.defineProperty(exports, 'isIdentifierStart', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierStart;
      },
    });
    Object.defineProperty(exports, 'isKeyword', {
      enumerable: true,
      get: function () {
        return _keyword.isKeyword;
      },
    });
    Object.defineProperty(exports, 'isReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictBindOnlyReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictBindOnlyReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictBindReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictBindReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictReservedWord;
      },
    });
    var _identifier = requireIdentifier$1();
    var _keyword = requireKeyword$1();
  })(lib$d);
  return lib$d;
}
var chalk$2 = {exports: {}};
var escapeStringRegexp$1;
var hasRequiredEscapeStringRegexp$1;
function requireEscapeStringRegexp$1() {
  if (hasRequiredEscapeStringRegexp$1) return escapeStringRegexp$1;
  hasRequiredEscapeStringRegexp$1 = 1;
  var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
  escapeStringRegexp$1 = function (str) {
    if (typeof str !== 'string') {
      throw new TypeError('Expected a string');
    }
    return str.replace(matchOperatorsRe, '\\$&');
  };
  return escapeStringRegexp$1;
}
var ansiStyles$3 = {exports: {}};
var conversions$4 = {exports: {}};
var colorName$2;
var hasRequiredColorName$1;
function requireColorName$1() {
  if (hasRequiredColorName$1) return colorName$2;
  hasRequiredColorName$1 = 1;
  colorName$2 = {
    aliceblue: [240, 248, 255],
    antiquewhite: [250, 235, 215],
    aqua: [0, 255, 255],
    aquamarine: [127, 255, 212],
    azure: [240, 255, 255],
    beige: [245, 245, 220],
    bisque: [255, 228, 196],
    black: [0, 0, 0],
    blanchedalmond: [255, 235, 205],
    blue: [0, 0, 255],
    blueviolet: [138, 43, 226],
    brown: [165, 42, 42],
    burlywood: [222, 184, 135],
    cadetblue: [95, 158, 160],
    chartreuse: [127, 255, 0],
    chocolate: [210, 105, 30],
    coral: [255, 127, 80],
    cornflowerblue: [100, 149, 237],
    cornsilk: [255, 248, 220],
    crimson: [220, 20, 60],
    cyan: [0, 255, 255],
    darkblue: [0, 0, 139],
    darkcyan: [0, 139, 139],
    darkgoldenrod: [184, 134, 11],
    darkgray: [169, 169, 169],
    darkgreen: [0, 100, 0],
    darkgrey: [169, 169, 169],
    darkkhaki: [189, 183, 107],
    darkmagenta: [139, 0, 139],
    darkolivegreen: [85, 107, 47],
    darkorange: [255, 140, 0],
    darkorchid: [153, 50, 204],
    darkred: [139, 0, 0],
    darksalmon: [233, 150, 122],
    darkseagreen: [143, 188, 143],
    darkslateblue: [72, 61, 139],
    darkslategray: [47, 79, 79],
    darkslategrey: [47, 79, 79],
    darkturquoise: [0, 206, 209],
    darkviolet: [148, 0, 211],
    deeppink: [255, 20, 147],
    deepskyblue: [0, 191, 255],
    dimgray: [105, 105, 105],
    dimgrey: [105, 105, 105],
    dodgerblue: [30, 144, 255],
    firebrick: [178, 34, 34],
    floralwhite: [255, 250, 240],
    forestgreen: [34, 139, 34],
    fuchsia: [255, 0, 255],
    gainsboro: [220, 220, 220],
    ghostwhite: [248, 248, 255],
    gold: [255, 215, 0],
    goldenrod: [218, 165, 32],
    gray: [128, 128, 128],
    green: [0, 128, 0],
    greenyellow: [173, 255, 47],
    grey: [128, 128, 128],
    honeydew: [240, 255, 240],
    hotpink: [255, 105, 180],
    indianred: [205, 92, 92],
    indigo: [75, 0, 130],
    ivory: [255, 255, 240],
    khaki: [240, 230, 140],
    lavender: [230, 230, 250],
    lavenderblush: [255, 240, 245],
    lawngreen: [124, 252, 0],
    lemonchiffon: [255, 250, 205],
    lightblue: [173, 216, 230],
    lightcoral: [240, 128, 128],
    lightcyan: [224, 255, 255],
    lightgoldenrodyellow: [250, 250, 210],
    lightgray: [211, 211, 211],
    lightgreen: [144, 238, 144],
    lightgrey: [211, 211, 211],
    lightpink: [255, 182, 193],
    lightsalmon: [255, 160, 122],
    lightseagreen: [32, 178, 170],
    lightskyblue: [135, 206, 250],
    lightslategray: [119, 136, 153],
    lightslategrey: [119, 136, 153],
    lightsteelblue: [176, 196, 222],
    lightyellow: [255, 255, 224],
    lime: [0, 255, 0],
    limegreen: [50, 205, 50],
    linen: [250, 240, 230],
    magenta: [255, 0, 255],
    maroon: [128, 0, 0],
    mediumaquamarine: [102, 205, 170],
    mediumblue: [0, 0, 205],
    mediumorchid: [186, 85, 211],
    mediumpurple: [147, 112, 219],
    mediumseagreen: [60, 179, 113],
    mediumslateblue: [123, 104, 238],
    mediumspringgreen: [0, 250, 154],
    mediumturquoise: [72, 209, 204],
    mediumvioletred: [199, 21, 133],
    midnightblue: [25, 25, 112],
    mintcream: [245, 255, 250],
    mistyrose: [255, 228, 225],
    moccasin: [255, 228, 181],
    navajowhite: [255, 222, 173],
    navy: [0, 0, 128],
    oldlace: [253, 245, 230],
    olive: [128, 128, 0],
    olivedrab: [107, 142, 35],
    orange: [255, 165, 0],
    orangered: [255, 69, 0],
    orchid: [218, 112, 214],
    palegoldenrod: [238, 232, 170],
    palegreen: [152, 251, 152],
    paleturquoise: [175, 238, 238],
    palevioletred: [219, 112, 147],
    papayawhip: [255, 239, 213],
    peachpuff: [255, 218, 185],
    peru: [205, 133, 63],
    pink: [255, 192, 203],
    plum: [221, 160, 221],
    powderblue: [176, 224, 230],
    purple: [128, 0, 128],
    rebeccapurple: [102, 51, 153],
    red: [255, 0, 0],
    rosybrown: [188, 143, 143],
    royalblue: [65, 105, 225],
    saddlebrown: [139, 69, 19],
    salmon: [250, 128, 114],
    sandybrown: [244, 164, 96],
    seagreen: [46, 139, 87],
    seashell: [255, 245, 238],
    sienna: [160, 82, 45],
    silver: [192, 192, 192],
    skyblue: [135, 206, 235],
    slateblue: [106, 90, 205],
    slategray: [112, 128, 144],
    slategrey: [112, 128, 144],
    snow: [255, 250, 250],
    springgreen: [0, 255, 127],
    steelblue: [70, 130, 180],
    tan: [210, 180, 140],
    teal: [0, 128, 128],
    thistle: [216, 191, 216],
    tomato: [255, 99, 71],
    turquoise: [64, 224, 208],
    violet: [238, 130, 238],
    wheat: [245, 222, 179],
    white: [255, 255, 255],
    whitesmoke: [245, 245, 245],
    yellow: [255, 255, 0],
    yellowgreen: [154, 205, 50],
  };
  return colorName$2;
}
var hasRequiredConversions$1;
function requireConversions$1() {
  if (hasRequiredConversions$1) return conversions$4.exports;
  hasRequiredConversions$1 = 1;
  var cssKeywords = requireColorName$1();
  var reverseKeywords = {};
  for (var key in cssKeywords) {
    if (cssKeywords.hasOwnProperty(key)) {
      reverseKeywords[cssKeywords[key]] = key;
    }
  }
  var convert = (conversions$4.exports = {
    rgb: {channels: 3, labels: 'rgb'},
    hsl: {channels: 3, labels: 'hsl'},
    hsv: {channels: 3, labels: 'hsv'},
    hwb: {channels: 3, labels: 'hwb'},
    cmyk: {channels: 4, labels: 'cmyk'},
    xyz: {channels: 3, labels: 'xyz'},
    lab: {channels: 3, labels: 'lab'},
    lch: {channels: 3, labels: 'lch'},
    hex: {channels: 1, labels: ['hex']},
    keyword: {channels: 1, labels: ['keyword']},
    ansi16: {channels: 1, labels: ['ansi16']},
    ansi256: {channels: 1, labels: ['ansi256']},
    hcg: {channels: 3, labels: ['h', 'c', 'g']},
    apple: {channels: 3, labels: ['r16', 'g16', 'b16']},
    gray: {channels: 1, labels: ['gray']},
  });
  for (var model in convert) {
    if (convert.hasOwnProperty(model)) {
      if (!('channels' in convert[model])) {
        throw new Error('missing channels property: ' + model);
      }
      if (!('labels' in convert[model])) {
        throw new Error('missing channel labels property: ' + model);
      }
      if (convert[model].labels.length !== convert[model].channels) {
        throw new Error('channel and label counts mismatch: ' + model);
      }
      var channels = convert[model].channels;
      var labels = convert[model].labels;
      delete convert[model].channels;
      delete convert[model].labels;
      Object.defineProperty(convert[model], 'channels', {value: channels});
      Object.defineProperty(convert[model], 'labels', {value: labels});
    }
  }
  convert.rgb.hsl = function (rgb) {
    var r = rgb[0] / 255;
    var g = rgb[1] / 255;
    var b = rgb[2] / 255;
    var min = Math.min(r, g, b);
    var max = Math.max(r, g, b);
    var delta = max - min;
    var h;
    var s;
    var l;
    if (max === min) {
      h = 0;
    } else if (r === max) {
      h = (g - b) / delta;
    } else if (g === max) {
      h = 2 + (b - r) / delta;
    } else if (b === max) {
      h = 4 + (r - g) / delta;
    }
    h = Math.min(h * 60, 360);
    if (h < 0) {
      h += 360;
    }
    l = (min + max) / 2;
    if (max === min) {
      s = 0;
    } else if (l <= 0.5) {
      s = delta / (max + min);
    } else {
      s = delta / (2 - max - min);
    }
    return [h, s * 100, l * 100];
  };
  convert.rgb.hsv = function (rgb) {
    var rdif;
    var gdif;
    var bdif;
    var h;
    var s;
    var r = rgb[0] / 255;
    var g = rgb[1] / 255;
    var b = rgb[2] / 255;
    var v = Math.max(r, g, b);
    var diff = v - Math.min(r, g, b);
    var diffc = function (c) {
      return (v - c) / 6 / diff + 1 / 2;
    };
    if (diff === 0) {
      h = s = 0;
    } else {
      s = diff / v;
      rdif = diffc(r);
      gdif = diffc(g);
      bdif = diffc(b);
      if (r === v) {
        h = bdif - gdif;
      } else if (g === v) {
        h = 1 / 3 + rdif - bdif;
      } else if (b === v) {
        h = 2 / 3 + gdif - rdif;
      }
      if (h < 0) {
        h += 1;
      } else if (h > 1) {
        h -= 1;
      }
    }
    return [h * 360, s * 100, v * 100];
  };
  convert.rgb.hwb = function (rgb) {
    var r = rgb[0];
    var g = rgb[1];
    var b = rgb[2];
    var h = convert.rgb.hsl(rgb)[0];
    var w = (1 / 255) * Math.min(r, Math.min(g, b));
    b = 1 - (1 / 255) * Math.max(r, Math.max(g, b));
    return [h, w * 100, b * 100];
  };
  convert.rgb.cmyk = function (rgb) {
    var r = rgb[0] / 255;
    var g = rgb[1] / 255;
    var b = rgb[2] / 255;
    var c;
    var m;
    var y;
    var k;
    k = Math.min(1 - r, 1 - g, 1 - b);
    c = (1 - r - k) / (1 - k) || 0;
    m = (1 - g - k) / (1 - k) || 0;
    y = (1 - b - k) / (1 - k) || 0;
    return [c * 100, m * 100, y * 100, k * 100];
  };
  function comparativeDistance(x, y) {
    return (
      Math.pow(x[0] - y[0], 2) +
      Math.pow(x[1] - y[1], 2) +
      Math.pow(x[2] - y[2], 2)
    );
  }
  convert.rgb.keyword = function (rgb) {
    var reversed = reverseKeywords[rgb];
    if (reversed) {
      return reversed;
    }
    var currentClosestDistance = Infinity;
    var currentClosestKeyword;
    for (var keyword in cssKeywords) {
      if (cssKeywords.hasOwnProperty(keyword)) {
        var value = cssKeywords[keyword];
        var distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
    }
    return currentClosestKeyword;
  };
  convert.keyword.rgb = function (keyword) {
    return cssKeywords[keyword];
  };
  convert.rgb.xyz = function (rgb) {
    var r = rgb[0] / 255;
    var g = rgb[1] / 255;
    var b = rgb[2] / 255;
    r = r > 0.04045 ? Math.pow((r + 0.055) / 1.055, 2.4) : r / 12.92;
    g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
    b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
    var x = r * 0.4124 + g * 0.3576 + b * 0.1805;
    var y = r * 0.2126 + g * 0.7152 + b * 0.0722;
    var z = r * 0.0193 + g * 0.1192 + b * 0.9505;
    return [x * 100, y * 100, z * 100];
  };
  convert.rgb.lab = function (rgb) {
    var xyz = convert.rgb.xyz(rgb);
    var x = xyz[0];
    var y = xyz[1];
    var z = xyz[2];
    var l;
    var a;
    var b;
    x /= 95.047;
    y /= 100;
    z /= 108.883;
    x = x > 0.008856 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
    y = y > 0.008856 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
    z = z > 0.008856 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
    l = 116 * y - 16;
    a = 500 * (x - y);
    b = 200 * (y - z);
    return [l, a, b];
  };
  convert.hsl.rgb = function (hsl) {
    var h = hsl[0] / 360;
    var s = hsl[1] / 100;
    var l = hsl[2] / 100;
    var t1;
    var t2;
    var t3;
    var rgb;
    var val;
    if (s === 0) {
      val = l * 255;
      return [val, val, val];
    }
    if (l < 0.5) {
      t2 = l * (1 + s);
    } else {
      t2 = l + s - l * s;
    }
    t1 = 2 * l - t2;
    rgb = [0, 0, 0];
    for (var i = 0; i < 3; i++) {
      t3 = h + (1 / 3) * -(i - 1);
      if (t3 < 0) {
        t3++;
      }
      if (t3 > 1) {
        t3--;
      }
      if (6 * t3 < 1) {
        val = t1 + (t2 - t1) * 6 * t3;
      } else if (2 * t3 < 1) {
        val = t2;
      } else if (3 * t3 < 2) {
        val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
      } else {
        val = t1;
      }
      rgb[i] = val * 255;
    }
    return rgb;
  };
  convert.hsl.hsv = function (hsl) {
    var h = hsl[0];
    var s = hsl[1] / 100;
    var l = hsl[2] / 100;
    var smin = s;
    var lmin = Math.max(l, 0.01);
    var sv;
    var v;
    l *= 2;
    s *= l <= 1 ? l : 2 - l;
    smin *= lmin <= 1 ? lmin : 2 - lmin;
    v = (l + s) / 2;
    sv = l === 0 ? (2 * smin) / (lmin + smin) : (2 * s) / (l + s);
    return [h, sv * 100, v * 100];
  };
  convert.hsv.rgb = function (hsv) {
    var h = hsv[0] / 60;
    var s = hsv[1] / 100;
    var v = hsv[2] / 100;
    var hi = Math.floor(h) % 6;
    var f = h - Math.floor(h);
    var p = 255 * v * (1 - s);
    var q = 255 * v * (1 - s * f);
    var t = 255 * v * (1 - s * (1 - f));
    v *= 255;
    switch (hi) {
      case 0:
        return [v, t, p];
      case 1:
        return [q, v, p];
      case 2:
        return [p, v, t];
      case 3:
        return [p, q, v];
      case 4:
        return [t, p, v];
      case 5:
        return [v, p, q];
    }
  };
  convert.hsv.hsl = function (hsv) {
    var h = hsv[0];
    var s = hsv[1] / 100;
    var v = hsv[2] / 100;
    var vmin = Math.max(v, 0.01);
    var lmin;
    var sl;
    var l;
    l = (2 - s) * v;
    lmin = (2 - s) * vmin;
    sl = s * vmin;
    sl /= lmin <= 1 ? lmin : 2 - lmin;
    sl = sl || 0;
    l /= 2;
    return [h, sl * 100, l * 100];
  };
  convert.hwb.rgb = function (hwb) {
    var h = hwb[0] / 360;
    var wh = hwb[1] / 100;
    var bl = hwb[2] / 100;
    var ratio = wh + bl;
    var i;
    var v;
    var f;
    var n;
    if (ratio > 1) {
      wh /= ratio;
      bl /= ratio;
    }
    i = Math.floor(6 * h);
    v = 1 - bl;
    f = 6 * h - i;
    if ((i & 1) !== 0) {
      f = 1 - f;
    }
    n = wh + f * (v - wh);
    var r;
    var g;
    var b;
    switch (i) {
      default:
      case 6:
      case 0:
        r = v;
        g = n;
        b = wh;
        break;
      case 1:
        r = n;
        g = v;
        b = wh;
        break;
      case 2:
        r = wh;
        g = v;
        b = n;
        break;
      case 3:
        r = wh;
        g = n;
        b = v;
        break;
      case 4:
        r = n;
        g = wh;
        b = v;
        break;
      case 5:
        r = v;
        g = wh;
        b = n;
        break;
    }
    return [r * 255, g * 255, b * 255];
  };
  convert.cmyk.rgb = function (cmyk) {
    var c = cmyk[0] / 100;
    var m = cmyk[1] / 100;
    var y = cmyk[2] / 100;
    var k = cmyk[3] / 100;
    var r;
    var g;
    var b;
    r = 1 - Math.min(1, c * (1 - k) + k);
    g = 1 - Math.min(1, m * (1 - k) + k);
    b = 1 - Math.min(1, y * (1 - k) + k);
    return [r * 255, g * 255, b * 255];
  };
  convert.xyz.rgb = function (xyz) {
    var x = xyz[0] / 100;
    var y = xyz[1] / 100;
    var z = xyz[2] / 100;
    var r;
    var g;
    var b;
    r = x * 3.2406 + y * -1.5372 + z * -0.4986;
    g = x * -0.9689 + y * 1.8758 + z * 0.0415;
    b = x * 0.0557 + y * -0.204 + z * 1.057;
    r = r > 0.0031308 ? 1.055 * Math.pow(r, 1 / 2.4) - 0.055 : r * 12.92;
    g = g > 0.0031308 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
    b = b > 0.0031308 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
    r = Math.min(Math.max(0, r), 1);
    g = Math.min(Math.max(0, g), 1);
    b = Math.min(Math.max(0, b), 1);
    return [r * 255, g * 255, b * 255];
  };
  convert.xyz.lab = function (xyz) {
    var x = xyz[0];
    var y = xyz[1];
    var z = xyz[2];
    var l;
    var a;
    var b;
    x /= 95.047;
    y /= 100;
    z /= 108.883;
    x = x > 0.008856 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
    y = y > 0.008856 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
    z = z > 0.008856 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
    l = 116 * y - 16;
    a = 500 * (x - y);
    b = 200 * (y - z);
    return [l, a, b];
  };
  convert.lab.xyz = function (lab) {
    var l = lab[0];
    var a = lab[1];
    var b = lab[2];
    var x;
    var y;
    var z;
    y = (l + 16) / 116;
    x = a / 500 + y;
    z = y - b / 200;
    var y2 = Math.pow(y, 3);
    var x2 = Math.pow(x, 3);
    var z2 = Math.pow(z, 3);
    y = y2 > 0.008856 ? y2 : (y - 16 / 116) / 7.787;
    x = x2 > 0.008856 ? x2 : (x - 16 / 116) / 7.787;
    z = z2 > 0.008856 ? z2 : (z - 16 / 116) / 7.787;
    x *= 95.047;
    y *= 100;
    z *= 108.883;
    return [x, y, z];
  };
  convert.lab.lch = function (lab) {
    var l = lab[0];
    var a = lab[1];
    var b = lab[2];
    var hr;
    var h;
    var c;
    hr = Math.atan2(b, a);
    h = (hr * 360) / 2 / Math.PI;
    if (h < 0) {
      h += 360;
    }
    c = Math.sqrt(a * a + b * b);
    return [l, c, h];
  };
  convert.lch.lab = function (lch) {
    var l = lch[0];
    var c = lch[1];
    var h = lch[2];
    var a;
    var b;
    var hr;
    hr = (h / 360) * 2 * Math.PI;
    a = c * Math.cos(hr);
    b = c * Math.sin(hr);
    return [l, a, b];
  };
  convert.rgb.ansi16 = function (args) {
    var r = args[0];
    var g = args[1];
    var b = args[2];
    var value = 1 in arguments ? arguments[1] : convert.rgb.hsv(args)[2];
    value = Math.round(value / 50);
    if (value === 0) {
      return 30;
    }
    var ansi =
      30 +
      ((Math.round(b / 255) << 2) |
        (Math.round(g / 255) << 1) |
        Math.round(r / 255));
    if (value === 2) {
      ansi += 60;
    }
    return ansi;
  };
  convert.hsv.ansi16 = function (args) {
    return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
  };
  convert.rgb.ansi256 = function (args) {
    var r = args[0];
    var g = args[1];
    var b = args[2];
    if (r === g && g === b) {
      if (r < 8) {
        return 16;
      }
      if (r > 248) {
        return 231;
      }
      return Math.round(((r - 8) / 247) * 24) + 232;
    }
    var ansi =
      16 +
      36 * Math.round((r / 255) * 5) +
      6 * Math.round((g / 255) * 5) +
      Math.round((b / 255) * 5);
    return ansi;
  };
  convert.ansi16.rgb = function (args) {
    var color = args % 10;
    if (color === 0 || color === 7) {
      if (args > 50) {
        color += 3.5;
      }
      color = (color / 10.5) * 255;
      return [color, color, color];
    }
    var mult = (~~(args > 50) + 1) * 0.5;
    var r = (color & 1) * mult * 255;
    var g = ((color >> 1) & 1) * mult * 255;
    var b = ((color >> 2) & 1) * mult * 255;
    return [r, g, b];
  };
  convert.ansi256.rgb = function (args) {
    if (args >= 232) {
      var c = (args - 232) * 10 + 8;
      return [c, c, c];
    }
    args -= 16;
    var rem;
    var r = (Math.floor(args / 36) / 5) * 255;
    var g = (Math.floor((rem = args % 36) / 6) / 5) * 255;
    var b = ((rem % 6) / 5) * 255;
    return [r, g, b];
  };
  convert.rgb.hex = function (args) {
    var integer =
      ((Math.round(args[0]) & 255) << 16) +
      ((Math.round(args[1]) & 255) << 8) +
      (Math.round(args[2]) & 255);
    var string = integer.toString(16).toUpperCase();
    return '000000'.substring(string.length) + string;
  };
  convert.hex.rgb = function (args) {
    var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
    if (!match) {
      return [0, 0, 0];
    }
    var colorString = match[0];
    if (match[0].length === 3) {
      colorString = colorString
        .split('')
        .map(function (char) {
          return char + char;
        })
        .join('');
    }
    var integer = parseInt(colorString, 16);
    var r = (integer >> 16) & 255;
    var g = (integer >> 8) & 255;
    var b = integer & 255;
    return [r, g, b];
  };
  convert.rgb.hcg = function (rgb) {
    var r = rgb[0] / 255;
    var g = rgb[1] / 255;
    var b = rgb[2] / 255;
    var max = Math.max(Math.max(r, g), b);
    var min = Math.min(Math.min(r, g), b);
    var chroma = max - min;
    var grayscale;
    var hue;
    if (chroma < 1) {
      grayscale = min / (1 - chroma);
    } else {
      grayscale = 0;
    }
    if (chroma <= 0) {
      hue = 0;
    } else if (max === r) {
      hue = ((g - b) / chroma) % 6;
    } else if (max === g) {
      hue = 2 + (b - r) / chroma;
    } else {
      hue = 4 + (r - g) / chroma + 4;
    }
    hue /= 6;
    hue %= 1;
    return [hue * 360, chroma * 100, grayscale * 100];
  };
  convert.hsl.hcg = function (hsl) {
    var s = hsl[1] / 100;
    var l = hsl[2] / 100;
    var c = 1;
    var f = 0;
    if (l < 0.5) {
      c = 2 * s * l;
    } else {
      c = 2 * s * (1 - l);
    }
    if (c < 1) {
      f = (l - 0.5 * c) / (1 - c);
    }
    return [hsl[0], c * 100, f * 100];
  };
  convert.hsv.hcg = function (hsv) {
    var s = hsv[1] / 100;
    var v = hsv[2] / 100;
    var c = s * v;
    var f = 0;
    if (c < 1) {
      f = (v - c) / (1 - c);
    }
    return [hsv[0], c * 100, f * 100];
  };
  convert.hcg.rgb = function (hcg) {
    var h = hcg[0] / 360;
    var c = hcg[1] / 100;
    var g = hcg[2] / 100;
    if (c === 0) {
      return [g * 255, g * 255, g * 255];
    }
    var pure = [0, 0, 0];
    var hi = (h % 1) * 6;
    var v = hi % 1;
    var w = 1 - v;
    var mg = 0;
    switch (Math.floor(hi)) {
      case 0:
        pure[0] = 1;
        pure[1] = v;
        pure[2] = 0;
        break;
      case 1:
        pure[0] = w;
        pure[1] = 1;
        pure[2] = 0;
        break;
      case 2:
        pure[0] = 0;
        pure[1] = 1;
        pure[2] = v;
        break;
      case 3:
        pure[0] = 0;
        pure[1] = w;
        pure[2] = 1;
        break;
      case 4:
        pure[0] = v;
        pure[1] = 0;
        pure[2] = 1;
        break;
      default:
        pure[0] = 1;
        pure[1] = 0;
        pure[2] = w;
    }
    mg = (1 - c) * g;
    return [
      (c * pure[0] + mg) * 255,
      (c * pure[1] + mg) * 255,
      (c * pure[2] + mg) * 255,
    ];
  };
  convert.hcg.hsv = function (hcg) {
    var c = hcg[1] / 100;
    var g = hcg[2] / 100;
    var v = c + g * (1 - c);
    var f = 0;
    if (v > 0) {
      f = c / v;
    }
    return [hcg[0], f * 100, v * 100];
  };
  convert.hcg.hsl = function (hcg) {
    var c = hcg[1] / 100;
    var g = hcg[2] / 100;
    var l = g * (1 - c) + 0.5 * c;
    var s = 0;
    if (l > 0 && l < 0.5) {
      s = c / (2 * l);
    } else if (l >= 0.5 && l < 1) {
      s = c / (2 * (1 - l));
    }
    return [hcg[0], s * 100, l * 100];
  };
  convert.hcg.hwb = function (hcg) {
    var c = hcg[1] / 100;
    var g = hcg[2] / 100;
    var v = c + g * (1 - c);
    return [hcg[0], (v - c) * 100, (1 - v) * 100];
  };
  convert.hwb.hcg = function (hwb) {
    var w = hwb[1] / 100;
    var b = hwb[2] / 100;
    var v = 1 - b;
    var c = v - w;
    var g = 0;
    if (c < 1) {
      g = (v - c) / (1 - c);
    }
    return [hwb[0], c * 100, g * 100];
  };
  convert.apple.rgb = function (apple) {
    return [
      (apple[0] / 65535) * 255,
      (apple[1] / 65535) * 255,
      (apple[2] / 65535) * 255,
    ];
  };
  convert.rgb.apple = function (rgb) {
    return [
      (rgb[0] / 255) * 65535,
      (rgb[1] / 255) * 65535,
      (rgb[2] / 255) * 65535,
    ];
  };
  convert.gray.rgb = function (args) {
    return [
      (args[0] / 100) * 255,
      (args[0] / 100) * 255,
      (args[0] / 100) * 255,
    ];
  };
  convert.gray.hsl = convert.gray.hsv = function (args) {
    return [0, 0, args[0]];
  };
  convert.gray.hwb = function (gray) {
    return [0, 100, gray[0]];
  };
  convert.gray.cmyk = function (gray) {
    return [0, 0, 0, gray[0]];
  };
  convert.gray.lab = function (gray) {
    return [gray[0], 0, 0];
  };
  convert.gray.hex = function (gray) {
    var val = Math.round((gray[0] / 100) * 255) & 255;
    var integer = (val << 16) + (val << 8) + val;
    var string = integer.toString(16).toUpperCase();
    return '000000'.substring(string.length) + string;
  };
  convert.rgb.gray = function (rgb) {
    var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
    return [(val / 255) * 100];
  };
  return conversions$4.exports;
}
var route$3;
var hasRequiredRoute$1;
function requireRoute$1() {
  if (hasRequiredRoute$1) return route$3;
  hasRequiredRoute$1 = 1;
  var conversions = requireConversions$1();
  function buildGraph() {
    var graph = {};
    var models = Object.keys(conversions);
    for (var len = models.length, i = 0; i < len; i++) {
      graph[models[i]] = {distance: -1, parent: null};
    }
    return graph;
  }
  function deriveBFS(fromModel) {
    var graph = buildGraph();
    var queue = [fromModel];
    graph[fromModel].distance = 0;
    while (queue.length) {
      var current = queue.pop();
      var adjacents = Object.keys(conversions[current]);
      for (var len = adjacents.length, i = 0; i < len; i++) {
        var adjacent = adjacents[i];
        var node = graph[adjacent];
        if (node.distance === -1) {
          node.distance = graph[current].distance + 1;
          node.parent = current;
          queue.unshift(adjacent);
        }
      }
    }
    return graph;
  }
  function link(from, to) {
    return function (args) {
      return to(from(args));
    };
  }
  function wrapConversion(toModel, graph) {
    var path = [graph[toModel].parent, toModel];
    var fn = conversions[graph[toModel].parent][toModel];
    var cur = graph[toModel].parent;
    while (graph[cur].parent) {
      path.unshift(graph[cur].parent);
      fn = link(conversions[graph[cur].parent][cur], fn);
      cur = graph[cur].parent;
    }
    fn.conversion = path;
    return fn;
  }
  route$3 = function (fromModel) {
    var graph = deriveBFS(fromModel);
    var conversion = {};
    var models = Object.keys(graph);
    for (var len = models.length, i = 0; i < len; i++) {
      var toModel = models[i];
      var node = graph[toModel];
      if (node.parent === null) {
        continue;
      }
      conversion[toModel] = wrapConversion(toModel, graph);
    }
    return conversion;
  };
  return route$3;
}
var colorConvert$2;
var hasRequiredColorConvert$1;
function requireColorConvert$1() {
  if (hasRequiredColorConvert$1) return colorConvert$2;
  hasRequiredColorConvert$1 = 1;
  var conversions = requireConversions$1();
  var route = requireRoute$1();
  var convert = {};
  var models = Object.keys(conversions);
  function wrapRaw(fn) {
    var wrappedFn = function (args) {
      if (args === undefined || args === null) {
        return args;
      }
      if (arguments.length > 1) {
        args = Array.prototype.slice.call(arguments);
      }
      return fn(args);
    };
    if ('conversion' in fn) {
      wrappedFn.conversion = fn.conversion;
    }
    return wrappedFn;
  }
  function wrapRounded(fn) {
    var wrappedFn = function (args) {
      if (args === undefined || args === null) {
        return args;
      }
      if (arguments.length > 1) {
        args = Array.prototype.slice.call(arguments);
      }
      var result = fn(args);
      if (typeof result === 'object') {
        for (var len = result.length, i = 0; i < len; i++) {
          result[i] = Math.round(result[i]);
        }
      }
      return result;
    };
    if ('conversion' in fn) {
      wrappedFn.conversion = fn.conversion;
    }
    return wrappedFn;
  }
  models.forEach(function (fromModel) {
    convert[fromModel] = {};
    Object.defineProperty(convert[fromModel], 'channels', {
      value: conversions[fromModel].channels,
    });
    Object.defineProperty(convert[fromModel], 'labels', {
      value: conversions[fromModel].labels,
    });
    var routes = route(fromModel);
    var routeModels = Object.keys(routes);
    routeModels.forEach(function (toModel) {
      var fn = routes[toModel];
      convert[fromModel][toModel] = wrapRounded(fn);
      convert[fromModel][toModel].raw = wrapRaw(fn);
    });
  });
  colorConvert$2 = convert;
  return colorConvert$2;
}
ansiStyles$3.exports;
var hasRequiredAnsiStyles;
function requireAnsiStyles() {
  if (hasRequiredAnsiStyles) return ansiStyles$3.exports;
  hasRequiredAnsiStyles = 1;
  (function (module) {
    const colorConvert = requireColorConvert$1();
    const wrapAnsi16 = (fn, offset) =>
      function () {
        const code = fn.apply(colorConvert, arguments);
        return `[${code + offset}m`;
      };
    const wrapAnsi256 = (fn, offset) =>
      function () {
        const code = fn.apply(colorConvert, arguments);
        return `[${38 + offset};5;${code}m`;
      };
    const wrapAnsi16m = (fn, offset) =>
      function () {
        const rgb = fn.apply(colorConvert, arguments);
        return `[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
      };
    function assembleStyles() {
      const codes = new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29],
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          gray: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39],
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49],
        },
      };
      styles.color.grey = styles.color.gray;
      for (const groupName of Object.keys(styles)) {
        const group = styles[groupName];
        for (const styleName of Object.keys(group)) {
          const style = group[styleName];
          styles[styleName] = {open: `[${style[0]}m`, close: `[${style[1]}m`};
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false,
        });
        Object.defineProperty(styles, 'codes', {
          value: codes,
          enumerable: false,
        });
      }
      const ansi2ansi = n => n;
      const rgb2rgb = (r, g, b) => [r, g, b];
      styles.color.close = '[39m';
      styles.bgColor.close = '[49m';
      styles.color.ansi = {ansi: wrapAnsi16(ansi2ansi, 0)};
      styles.color.ansi256 = {ansi256: wrapAnsi256(ansi2ansi, 0)};
      styles.color.ansi16m = {rgb: wrapAnsi16m(rgb2rgb, 0)};
      styles.bgColor.ansi = {ansi: wrapAnsi16(ansi2ansi, 10)};
      styles.bgColor.ansi256 = {ansi256: wrapAnsi256(ansi2ansi, 10)};
      styles.bgColor.ansi16m = {rgb: wrapAnsi16m(rgb2rgb, 10)};
      for (let key of Object.keys(colorConvert)) {
        if (typeof colorConvert[key] !== 'object') {
          continue;
        }
        const suite = colorConvert[key];
        if (key === 'ansi16') {
          key = 'ansi';
        }
        if ('ansi16' in suite) {
          styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
          styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
        }
        if ('ansi256' in suite) {
          styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
          styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
        }
        if ('rgb' in suite) {
          styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
          styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
        }
      }
      return styles;
    }
    Object.defineProperty(module, 'exports', {
      enumerable: true,
      get: assembleStyles,
    });
  })(ansiStyles$3);
  return ansiStyles$3.exports;
}
var hasFlag$3;
var hasRequiredHasFlag$1;
function requireHasFlag$1() {
  if (hasRequiredHasFlag$1) return hasFlag$3;
  hasRequiredHasFlag$1 = 1;
  hasFlag$3 = (flag, argv) => {
    argv = argv || process.argv;
    const prefix = flag.startsWith('-') ? '' : flag.length === 1 ? '-' : '--';
    const pos = argv.indexOf(prefix + flag);
    const terminatorPos = argv.indexOf('--');
    return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
  };
  return hasFlag$3;
}
var supportsColor_1$2;
var hasRequiredSupportsColor$1;
function requireSupportsColor$1() {
  if (hasRequiredSupportsColor$1) return supportsColor_1$2;
  hasRequiredSupportsColor$1 = 1;
  const os = require$$0$3;
  const hasFlag = requireHasFlag$1();
  const env = process.env;
  let forceColor;
  if (hasFlag('no-color') || hasFlag('no-colors') || hasFlag('color=false')) {
    forceColor = false;
  } else if (
    hasFlag('color') ||
    hasFlag('colors') ||
    hasFlag('color=true') ||
    hasFlag('color=always')
  ) {
    forceColor = true;
  }
  if ('FORCE_COLOR' in env) {
    forceColor =
      env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
  }
  function translateLevel(level) {
    if (level === 0) {
      return false;
    }
    return {
      level: level,
      hasBasic: true,
      has256: level >= 2,
      has16m: level >= 3,
    };
  }
  function supportsColor(stream) {
    if (forceColor === false) {
      return 0;
    }
    if (
      hasFlag('color=16m') ||
      hasFlag('color=full') ||
      hasFlag('color=truecolor')
    ) {
      return 3;
    }
    if (hasFlag('color=256')) {
      return 2;
    }
    if (stream && !stream.isTTY && forceColor !== true) {
      return 0;
    }
    const min = forceColor ? 1 : 0;
    if (process.platform === 'win32') {
      const osRelease = os.release().split('.');
      if (
        Number(process.versions.node.split('.')[0]) >= 8 &&
        Number(osRelease[0]) >= 10 &&
        Number(osRelease[2]) >= 10586
      ) {
        return Number(osRelease[2]) >= 14931 ? 3 : 2;
      }
      return 1;
    }
    if ('CI' in env) {
      if (
        ['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI'].some(
          sign => sign in env
        ) ||
        env.CI_NAME === 'codeship'
      ) {
        return 1;
      }
      return min;
    }
    if ('TEAMCITY_VERSION' in env) {
      return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
    }
    if (env.COLORTERM === 'truecolor') {
      return 3;
    }
    if ('TERM_PROGRAM' in env) {
      const version = parseInt(
        (env.TERM_PROGRAM_VERSION || '').split('.')[0],
        10
      );
      switch (env.TERM_PROGRAM) {
        case 'iTerm.app':
          return version >= 3 ? 3 : 2;
        case 'Apple_Terminal':
          return 2;
      }
    }
    if (/-256(color)?$/i.test(env.TERM)) {
      return 2;
    }
    if (
      /^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(
        env.TERM
      )
    ) {
      return 1;
    }
    if ('COLORTERM' in env) {
      return 1;
    }
    if (env.TERM === 'dumb') {
      return min;
    }
    return min;
  }
  function getSupportLevel(stream) {
    const level = supportsColor(stream);
    return translateLevel(level);
  }
  supportsColor_1$2 = {
    supportsColor: getSupportLevel,
    stdout: getSupportLevel(process.stdout),
    stderr: getSupportLevel(process.stderr),
  };
  return supportsColor_1$2;
}
var templates$2;
var hasRequiredTemplates$2;
function requireTemplates$2() {
  if (hasRequiredTemplates$2) return templates$2;
  hasRequiredTemplates$2 = 1;
  const TEMPLATE_REGEX =
    /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
  const STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
  const STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
  const ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
  const ESCAPES = new Map([
    ['n', '\n'],
    ['r', '\r'],
    ['t', '\t'],
    ['b', '\b'],
    ['f', '\f'],
    ['v', '\v'],
    ['0', '\0'],
    ['\\', '\\'],
    ['e', ''],
    ['a', ''],
  ]);
  function unescape(c) {
    if ((c[0] === 'u' && c.length === 5) || (c[0] === 'x' && c.length === 3)) {
      return String.fromCharCode(parseInt(c.slice(1), 16));
    }
    return ESCAPES.get(c) || c;
  }
  function parseArguments(name, args) {
    const results = [];
    const chunks = args.trim().split(/\s*,\s*/g);
    let matches;
    for (const chunk of chunks) {
      if (!isNaN(chunk)) {
        results.push(Number(chunk));
      } else if ((matches = chunk.match(STRING_REGEX))) {
        results.push(
          matches[2].replace(ESCAPE_REGEX, (m, escape, chr) =>
            escape ? unescape(escape) : chr
          )
        );
      } else {
        throw new Error(
          `Invalid Chalk template style argument: ${chunk} (in style '${name}')`
        );
      }
    }
    return results;
  }
  function parseStyle(style) {
    STYLE_REGEX.lastIndex = 0;
    const results = [];
    let matches;
    while ((matches = STYLE_REGEX.exec(style)) !== null) {
      const name = matches[1];
      if (matches[2]) {
        const args = parseArguments(name, matches[2]);
        results.push([name].concat(args));
      } else {
        results.push([name]);
      }
    }
    return results;
  }
  function buildStyle(chalk, styles) {
    const enabled = {};
    for (const layer of styles) {
      for (const style of layer.styles) {
        enabled[style[0]] = layer.inverse ? null : style.slice(1);
      }
    }
    let current = chalk;
    for (const styleName of Object.keys(enabled)) {
      if (Array.isArray(enabled[styleName])) {
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        if (enabled[styleName].length > 0) {
          current = current[styleName].apply(current, enabled[styleName]);
        } else {
          current = current[styleName];
        }
      }
    }
    return current;
  }
  templates$2 = (chalk, tmp) => {
    const styles = [];
    const chunks = [];
    let chunk = [];
    tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
      if (escapeChar) {
        chunk.push(unescape(escapeChar));
      } else if (style) {
        const str = chunk.join('');
        chunk = [];
        chunks.push(styles.length === 0 ? str : buildStyle(chalk, styles)(str));
        styles.push({inverse: inverse, styles: parseStyle(style)});
      } else if (close) {
        if (styles.length === 0) {
          throw new Error('Found extraneous } in Chalk template literal');
        }
        chunks.push(buildStyle(chalk, styles)(chunk.join('')));
        chunk = [];
        styles.pop();
      } else {
        chunk.push(chr);
      }
    });
    chunks.push(chunk.join(''));
    if (styles.length > 0) {
      const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? '' : 's'} (\`}\`)`;
      throw new Error(errMsg);
    }
    return chunks.join('');
  };
  return templates$2;
}
var hasRequiredChalk$1;
function requireChalk$1() {
  if (hasRequiredChalk$1) return chalk$2.exports;
  hasRequiredChalk$1 = 1;
  (function (module) {
    const escapeStringRegexp = requireEscapeStringRegexp$1();
    const ansiStyles = requireAnsiStyles();
    const stdoutColor = requireSupportsColor$1().stdout;
    const template = requireTemplates$2();
    const isSimpleWindowsTerm =
      process.platform === 'win32' &&
      !(process.env.TERM || '').toLowerCase().startsWith('xterm');
    const levelMapping = ['ansi', 'ansi', 'ansi256', 'ansi16m'];
    const skipModels = new Set(['gray']);
    const styles = Object.create(null);
    function applyOptions(obj, options) {
      options = options || {};
      const scLevel = stdoutColor ? stdoutColor.level : 0;
      obj.level = options.level === undefined ? scLevel : options.level;
      obj.enabled = 'enabled' in options ? options.enabled : obj.level > 0;
    }
    function Chalk(options) {
      if (!this || !(this instanceof Chalk) || this.template) {
        const chalk = {};
        applyOptions(chalk, options);
        chalk.template = function () {
          const args = [].slice.call(arguments);
          return chalkTag.apply(null, [chalk.template].concat(args));
        };
        Object.setPrototypeOf(chalk, Chalk.prototype);
        Object.setPrototypeOf(chalk.template, chalk);
        chalk.template.constructor = Chalk;
        return chalk.template;
      }
      applyOptions(this, options);
    }
    if (isSimpleWindowsTerm) {
      ansiStyles.blue.open = '[94m';
    }
    for (const key of Object.keys(ansiStyles)) {
      ansiStyles[key].closeRe = new RegExp(
        escapeStringRegexp(ansiStyles[key].close),
        'g'
      );
      styles[key] = {
        get() {
          const codes = ansiStyles[key];
          return build.call(
            this,
            this._styles ? this._styles.concat(codes) : [codes],
            this._empty,
            key
          );
        },
      };
    }
    styles.visible = {
      get() {
        return build.call(this, this._styles || [], true, 'visible');
      },
    };
    ansiStyles.color.closeRe = new RegExp(
      escapeStringRegexp(ansiStyles.color.close),
      'g'
    );
    for (const model of Object.keys(ansiStyles.color.ansi)) {
      if (skipModels.has(model)) {
        continue;
      }
      styles[model] = {
        get() {
          const level = this.level;
          return function () {
            const open = ansiStyles.color[levelMapping[level]][model].apply(
              null,
              arguments
            );
            const codes = {
              open: open,
              close: ansiStyles.color.close,
              closeRe: ansiStyles.color.closeRe,
            };
            return build.call(
              this,
              this._styles ? this._styles.concat(codes) : [codes],
              this._empty,
              model
            );
          };
        },
      };
    }
    ansiStyles.bgColor.closeRe = new RegExp(
      escapeStringRegexp(ansiStyles.bgColor.close),
      'g'
    );
    for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
      if (skipModels.has(model)) {
        continue;
      }
      const bgModel = 'bg' + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const level = this.level;
          return function () {
            const open = ansiStyles.bgColor[levelMapping[level]][model].apply(
              null,
              arguments
            );
            const codes = {
              open: open,
              close: ansiStyles.bgColor.close,
              closeRe: ansiStyles.bgColor.closeRe,
            };
            return build.call(
              this,
              this._styles ? this._styles.concat(codes) : [codes],
              this._empty,
              model
            );
          };
        },
      };
    }
    const proto = Object.defineProperties(() => {}, styles);
    function build(_styles, _empty, key) {
      const builder = function () {
        return applyStyle.apply(builder, arguments);
      };
      builder._styles = _styles;
      builder._empty = _empty;
      const self = this;
      Object.defineProperty(builder, 'level', {
        enumerable: true,
        get() {
          return self.level;
        },
        set(level) {
          self.level = level;
        },
      });
      Object.defineProperty(builder, 'enabled', {
        enumerable: true,
        get() {
          return self.enabled;
        },
        set(enabled) {
          self.enabled = enabled;
        },
      });
      builder.hasGrey = this.hasGrey || key === 'gray' || key === 'grey';
      builder.__proto__ = proto;
      return builder;
    }
    function applyStyle() {
      const args = arguments;
      const argsLen = args.length;
      let str = String(arguments[0]);
      if (argsLen === 0) {
        return '';
      }
      if (argsLen > 1) {
        for (let a = 1; a < argsLen; a++) {
          str += ' ' + args[a];
        }
      }
      if (!this.enabled || this.level <= 0 || !str) {
        return this._empty ? '' : str;
      }
      const originalDim = ansiStyles.dim.open;
      if (isSimpleWindowsTerm && this.hasGrey) {
        ansiStyles.dim.open = '';
      }
      for (const code of this._styles.slice().reverse()) {
        str = code.open + str.replace(code.closeRe, code.open) + code.close;
        str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
      }
      ansiStyles.dim.open = originalDim;
      return str;
    }
    function chalkTag(chalk, strings) {
      if (!Array.isArray(strings)) {
        return [].slice.call(arguments, 1).join(' ');
      }
      const args = [].slice.call(arguments, 2);
      const parts = [strings.raw[0]];
      for (let i = 1; i < strings.length; i++) {
        parts.push(String(args[i - 1]).replace(/[{}\\]/g, '\\$&'));
        parts.push(String(strings.raw[i]));
      }
      return template(chalk, parts.join(''));
    }
    Object.defineProperties(Chalk.prototype, styles);
    module.exports = Chalk();
    module.exports.supportsColor = stdoutColor;
    module.exports.default = module.exports;
  })(chalk$2);
  return chalk$2.exports;
}
var hasRequiredLib$f;
function requireLib$f() {
  if (hasRequiredLib$f) return lib$e;
  hasRequiredLib$f = 1;
  Object.defineProperty(lib$e, '__esModule', {value: true});
  lib$e.default = highlight;
  lib$e.getChalk = getChalk;
  lib$e.shouldHighlight = shouldHighlight;
  var _jsTokens = requireJsTokens();
  var _helperValidatorIdentifier = requireLib$g();
  var _chalk = requireChalk$1();
  const sometimesKeywords = new Set([
    'as',
    'async',
    'from',
    'get',
    'of',
    'set',
  ]);
  function getDefs(chalk) {
    return {
      keyword: chalk.cyan,
      capitalized: chalk.yellow,
      jsxIdentifier: chalk.yellow,
      punctuator: chalk.yellow,
      number: chalk.magenta,
      string: chalk.green,
      regex: chalk.magenta,
      comment: chalk.grey,
      invalid: chalk.white.bgRed.bold,
    };
  }
  const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  const BRACKET = /^[()[\]{}]$/;
  let tokenize;
  {
    const JSX_TAG = /^[a-z][\w-]*$/i;
    const getTokenType = function (token, offset, text) {
      if (token.type === 'name') {
        if (
          (0, _helperValidatorIdentifier.isKeyword)(token.value) ||
          (0, _helperValidatorIdentifier.isStrictReservedWord)(
            token.value,
            true
          ) ||
          sometimesKeywords.has(token.value)
        ) {
          return 'keyword';
        }
        if (
          JSX_TAG.test(token.value) &&
          (text[offset - 1] === '<' || text.slice(offset - 2, offset) == '</')
        ) {
          return 'jsxIdentifier';
        }
        if (token.value[0] !== token.value[0].toLowerCase()) {
          return 'capitalized';
        }
      }
      if (token.type === 'punctuator' && BRACKET.test(token.value)) {
        return 'bracket';
      }
      if (
        token.type === 'invalid' &&
        (token.value === '@' || token.value === '#')
      ) {
        return 'punctuator';
      }
      return token.type;
    };
    tokenize = function* (text) {
      let match;
      while ((match = _jsTokens.default.exec(text))) {
        const token = _jsTokens.matchToToken(match);
        yield {
          type: getTokenType(token, match.index, text),
          value: token.value,
        };
      }
    };
  }
  function highlightTokens(defs, text) {
    let highlighted = '';
    for (const {type: type, value: value} of tokenize(text)) {
      const colorize = defs[type];
      if (colorize) {
        highlighted += value
          .split(NEWLINE)
          .map(str => colorize(str))
          .join('\n');
      } else {
        highlighted += value;
      }
    }
    return highlighted;
  }
  function shouldHighlight(options) {
    return !!_chalk.supportsColor || options.forceColor;
  }
  function getChalk(options) {
    return options.forceColor
      ? new _chalk.constructor({enabled: true, level: 1})
      : _chalk;
  }
  function highlight(code, options = {}) {
    if (code !== '' && shouldHighlight(options)) {
      const chalk = getChalk(options);
      const defs = getDefs(chalk);
      return highlightTokens(defs, code);
    } else {
      return code;
    }
  }
  return lib$e;
}
var hasRequiredLib$e;
function requireLib$e() {
  if (hasRequiredLib$e) return lib$f;
  hasRequiredLib$e = 1;
  Object.defineProperty(lib$f, '__esModule', {value: true});
  lib$f.codeFrameColumns = codeFrameColumns;
  lib$f.default = _default;
  var _highlight = requireLib$f();
  let deprecationWarningShown = false;
  function getDefs(chalk) {
    return {
      gutter: chalk.grey,
      marker: chalk.red.bold,
      message: chalk.red.bold,
    };
  }
  const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  function getMarkerLines(loc, source, opts) {
    const startLoc = Object.assign({column: 0, line: -1}, loc.start);
    const endLoc = Object.assign({}, startLoc, loc.end);
    const {linesAbove: linesAbove = 2, linesBelow: linesBelow = 3} = opts || {};
    const startLine = startLoc.line;
    const startColumn = startLoc.column;
    const endLine = endLoc.line;
    const endColumn = endLoc.column;
    let start = Math.max(startLine - (linesAbove + 1), 0);
    let end = Math.min(source.length, endLine + linesBelow);
    if (startLine === -1) {
      start = 0;
    }
    if (endLine === -1) {
      end = source.length;
    }
    const lineDiff = endLine - startLine;
    const markerLines = {};
    if (lineDiff) {
      for (let i = 0; i <= lineDiff; i++) {
        const lineNumber = i + startLine;
        if (!startColumn) {
          markerLines[lineNumber] = true;
        } else if (i === 0) {
          const sourceLength = source[lineNumber - 1].length;
          markerLines[lineNumber] = [
            startColumn,
            sourceLength - startColumn + 1,
          ];
        } else if (i === lineDiff) {
          markerLines[lineNumber] = [0, endColumn];
        } else {
          const sourceLength = source[lineNumber - i].length;
          markerLines[lineNumber] = [0, sourceLength];
        }
      }
    } else {
      if (startColumn === endColumn) {
        if (startColumn) {
          markerLines[startLine] = [startColumn, 0];
        } else {
          markerLines[startLine] = true;
        }
      } else {
        markerLines[startLine] = [startColumn, endColumn - startColumn];
      }
    }
    return {start: start, end: end, markerLines: markerLines};
  }
  function codeFrameColumns(rawLines, loc, opts = {}) {
    const highlighted =
      (opts.highlightCode || opts.forceColor) &&
      (0, _highlight.shouldHighlight)(opts);
    const chalk = (0, _highlight.getChalk)(opts);
    const defs = getDefs(chalk);
    const maybeHighlight = (chalkFn, string) =>
      highlighted ? chalkFn(string) : string;
    const lines = rawLines.split(NEWLINE);
    const {
      start: start,
      end: end,
      markerLines: markerLines,
    } = getMarkerLines(loc, lines, opts);
    const hasColumns = loc.start && typeof loc.start.column === 'number';
    const numberMaxWidth = String(end).length;
    const highlightedLines = highlighted
      ? (0, _highlight.default)(rawLines, opts)
      : rawLines;
    let frame = highlightedLines
      .split(NEWLINE, end)
      .slice(start, end)
      .map((line, index) => {
        const number = start + 1 + index;
        const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
        const gutter = ` ${paddedNumber} |`;
        const hasMarker = markerLines[number];
        const lastMarkerLine = !markerLines[number + 1];
        if (hasMarker) {
          let markerLine = '';
          if (Array.isArray(hasMarker)) {
            const markerSpacing = line
              .slice(0, Math.max(hasMarker[0] - 1, 0))
              .replace(/[^\t]/g, ' ');
            const numberOfMarkers = hasMarker[1] || 1;
            markerLine = [
              '\n ',
              maybeHighlight(defs.gutter, gutter.replace(/\d/g, ' ')),
              ' ',
              markerSpacing,
              maybeHighlight(defs.marker, '^').repeat(numberOfMarkers),
            ].join('');
            if (lastMarkerLine && opts.message) {
              markerLine += ' ' + maybeHighlight(defs.message, opts.message);
            }
          }
          return [
            maybeHighlight(defs.marker, '>'),
            maybeHighlight(defs.gutter, gutter),
            line.length > 0 ? ` ${line}` : '',
            markerLine,
          ].join('');
        } else {
          return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ''}`;
        }
      })
      .join('\n');
    if (opts.message && !hasColumns) {
      frame = `${' '.repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
    }
    if (highlighted) {
      return chalk.reset(frame);
    } else {
      return frame;
    }
  }
  function _default(rawLines, lineNumber, colNumber, opts = {}) {
    if (!deprecationWarningShown) {
      deprecationWarningShown = true;
      const message =
        'Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.';
      if (process.emitWarning) {
        process.emitWarning(message, 'DeprecationWarning');
      } else {
        const deprecationError = new Error(message);
        deprecationError.name = 'DeprecationWarning';
        console.warn(new Error(message));
      }
    }
    colNumber = Math.max(colNumber, 0);
    const location = {start: {column: colNumber, line: lineNumber}};
    return codeFrameColumns(rawLines, location, opts);
  }
  return lib$f;
}
var hasRequiredParse$2;
function requireParse$2() {
  if (hasRequiredParse$2) return parse$4;
  hasRequiredParse$2 = 1;
  Object.defineProperty(parse$4, '__esModule', {value: true});
  parse$4.default = parseAndBuildMetadata;
  var _t = t$d;
  var _parser = lib$g;
  var _codeFrame = requireLib$e();
  const {
    isCallExpression: isCallExpression,
    isExpressionStatement: isExpressionStatement,
    isFunction: isFunction,
    isIdentifier: isIdentifier,
    isJSXIdentifier: isJSXIdentifier,
    isNewExpression: isNewExpression,
    isPlaceholder: isPlaceholder,
    isStatement: isStatement,
    isStringLiteral: isStringLiteral,
    removePropertiesDeep: removePropertiesDeep,
    traverse: traverse,
  } = _t;
  const PATTERN = /^[_$A-Z0-9]+$/;
  function parseAndBuildMetadata(formatter, code, opts) {
    const {
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      preserveComments: preserveComments,
      syntacticPlaceholders: syntacticPlaceholders,
    } = opts;
    const ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
    removePropertiesDeep(ast, {preserveComments: preserveComments});
    formatter.validate(ast);
    const syntactic = {placeholders: [], placeholderNames: new Set()};
    const legacy = {placeholders: [], placeholderNames: new Set()};
    const isLegacyRef = {value: undefined};
    traverse(ast, placeholderVisitorHandler, {
      syntactic: syntactic,
      legacy: legacy,
      isLegacyRef: isLegacyRef,
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      syntacticPlaceholders: syntacticPlaceholders,
    });
    return Object.assign({ast: ast}, isLegacyRef.value ? legacy : syntactic);
  }
  function placeholderVisitorHandler(node, ancestors, state) {
    var _state$placeholderWhi;
    let name;
    if (isPlaceholder(node)) {
      if (state.syntacticPlaceholders === false) {
        throw new Error(
          "%%foo%%-style placeholders can't be used when " +
            "'.syntacticPlaceholders' is false."
        );
      } else {
        name = node.name.name;
        state.isLegacyRef.value = false;
      }
    } else if (
      state.isLegacyRef.value === false ||
      state.syntacticPlaceholders
    ) {
      return;
    } else if (isIdentifier(node) || isJSXIdentifier(node)) {
      name = node.name;
      state.isLegacyRef.value = true;
    } else if (isStringLiteral(node)) {
      name = node.value;
      state.isLegacyRef.value = true;
    } else {
      return;
    }
    if (
      !state.isLegacyRef.value &&
      (state.placeholderPattern != null || state.placeholderWhitelist != null)
    ) {
      throw new Error(
        "'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" +
          " with '.syntacticPlaceholders: true'"
      );
    }
    if (
      state.isLegacyRef.value &&
      (state.placeholderPattern === false ||
        !(state.placeholderPattern || PATTERN).test(name)) &&
      !(
        (_state$placeholderWhi = state.placeholderWhitelist) != null &&
        _state$placeholderWhi.has(name)
      )
    ) {
      return;
    }
    ancestors = ancestors.slice();
    const {node: parent, key: key} = ancestors[ancestors.length - 1];
    let type;
    if (
      isStringLiteral(node) ||
      isPlaceholder(node, {expectedNode: 'StringLiteral'})
    ) {
      type = 'string';
    } else if (
      (isNewExpression(parent) && key === 'arguments') ||
      (isCallExpression(parent) && key === 'arguments') ||
      (isFunction(parent) && key === 'params')
    ) {
      type = 'param';
    } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
      type = 'statement';
      ancestors = ancestors.slice(0, -1);
    } else if (isStatement(node) && isPlaceholder(node)) {
      type = 'statement';
    } else {
      type = 'other';
    }
    const {placeholders: placeholders, placeholderNames: placeholderNames} =
      state.isLegacyRef.value ? state.legacy : state.syntactic;
    placeholders.push({
      name: name,
      type: type,
      resolve: ast => resolveAncestors(ast, ancestors),
      isDuplicate: placeholderNames.has(name),
    });
    placeholderNames.add(name);
  }
  function resolveAncestors(ast, ancestors) {
    let parent = ast;
    for (let i = 0; i < ancestors.length - 1; i++) {
      const {key: key, index: index} = ancestors[i];
      if (index === undefined) {
        parent = parent[key];
      } else {
        parent = parent[key][index];
      }
    }
    const {key: key, index: index} = ancestors[ancestors.length - 1];
    return {parent: parent, key: key, index: index};
  }
  function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
    const plugins = (parserOpts.plugins || []).slice();
    if (syntacticPlaceholders !== false) {
      plugins.push('placeholders');
    }
    parserOpts = Object.assign(
      {
        allowReturnOutsideFunction: true,
        allowSuperOutsideMethod: true,
        sourceType: 'module',
      },
      parserOpts,
      {plugins: plugins}
    );
    try {
      return (0, _parser.parse)(code, parserOpts);
    } catch (err) {
      const loc = err.loc;
      if (loc) {
        err.message +=
          '\n' + (0, _codeFrame.codeFrameColumns)(code, {start: loc});
        err.code = 'BABEL_TEMPLATE_PARSE_ERROR';
      }
      throw err;
    }
  }
  return parse$4;
}
var populate$1 = {};
var hasRequiredPopulate$1;
function requirePopulate$1() {
  if (hasRequiredPopulate$1) return populate$1;
  hasRequiredPopulate$1 = 1;
  Object.defineProperty(populate$1, '__esModule', {value: true});
  populate$1.default = populatePlaceholders;
  var _t = t$d;
  const {
    blockStatement: blockStatement,
    cloneNode: cloneNode,
    emptyStatement: emptyStatement,
    expressionStatement: expressionStatement,
    identifier: identifier,
    isStatement: isStatement,
    isStringLiteral: isStringLiteral,
    stringLiteral: stringLiteral,
    validate: validate,
  } = _t;
  function populatePlaceholders(metadata, replacements) {
    const ast = cloneNode(metadata.ast);
    if (replacements) {
      metadata.placeholders.forEach(placeholder => {
        if (
          !Object.prototype.hasOwnProperty.call(replacements, placeholder.name)
        ) {
          const placeholderName = placeholder.name;
          throw new Error(
            `Error: No substitution given for "${placeholderName}". If this is not meant to be a\n            placeholder you may want to consider passing one of the following options to @babel/template:\n            - { placeholderPattern: false, placeholderWhitelist: new Set(['${placeholderName}'])}\n            - { placeholderPattern: /^${placeholderName}$/ }`
          );
        }
      });
      Object.keys(replacements).forEach(key => {
        if (!metadata.placeholderNames.has(key)) {
          throw new Error(`Unknown substitution "${key}" given`);
        }
      });
    }
    metadata.placeholders
      .slice()
      .reverse()
      .forEach(placeholder => {
        try {
          applyReplacement(
            placeholder,
            ast,
            (replacements && replacements[placeholder.name]) || null
          );
        } catch (e) {
          e.message = `@babel/template placeholder "${placeholder.name}": ${e.message}`;
          throw e;
        }
      });
    return ast;
  }
  function applyReplacement(placeholder, ast, replacement) {
    if (placeholder.isDuplicate) {
      if (Array.isArray(replacement)) {
        replacement = replacement.map(node => cloneNode(node));
      } else if (typeof replacement === 'object') {
        replacement = cloneNode(replacement);
      }
    }
    const {parent: parent, key: key, index: index} = placeholder.resolve(ast);
    if (placeholder.type === 'string') {
      if (typeof replacement === 'string') {
        replacement = stringLiteral(replacement);
      }
      if (!replacement || !isStringLiteral(replacement)) {
        throw new Error('Expected string substitution');
      }
    } else if (placeholder.type === 'statement') {
      if (index === undefined) {
        if (!replacement) {
          replacement = emptyStatement();
        } else if (Array.isArray(replacement)) {
          replacement = blockStatement(replacement);
        } else if (typeof replacement === 'string') {
          replacement = expressionStatement(identifier(replacement));
        } else if (!isStatement(replacement)) {
          replacement = expressionStatement(replacement);
        }
      } else {
        if (replacement && !Array.isArray(replacement)) {
          if (typeof replacement === 'string') {
            replacement = identifier(replacement);
          }
          if (!isStatement(replacement)) {
            replacement = expressionStatement(replacement);
          }
        }
      }
    } else if (placeholder.type === 'param') {
      if (typeof replacement === 'string') {
        replacement = identifier(replacement);
      }
      if (index === undefined) throw new Error('Assertion failure.');
    } else {
      if (typeof replacement === 'string') {
        replacement = identifier(replacement);
      }
      if (Array.isArray(replacement)) {
        throw new Error('Cannot replace single expression with an array.');
      }
    }
    if (index === undefined) {
      validate(parent, key, replacement);
      parent[key] = replacement;
    } else {
      const items = parent[key].slice();
      if (placeholder.type === 'statement' || placeholder.type === 'param') {
        if (replacement == null) {
          items.splice(index, 1);
        } else if (Array.isArray(replacement)) {
          items.splice(index, 1, ...replacement);
        } else {
          items[index] = replacement;
        }
      } else {
        items[index] = replacement;
      }
      validate(parent, key, items);
      parent[key] = items;
    }
  }
  return populate$1;
}
var hasRequiredString$1;
function requireString$1() {
  if (hasRequiredString$1) return string$1;
  hasRequiredString$1 = 1;
  Object.defineProperty(string$1, '__esModule', {value: true});
  string$1.default = stringTemplate;
  var _options = requireOptions$1();
  var _parse = requireParse$2();
  var _populate = requirePopulate$1();
  function stringTemplate(formatter, code, opts) {
    code = formatter.code(code);
    let metadata;
    return arg => {
      const replacements = (0, _options.normalizeReplacements)(arg);
      if (!metadata) metadata = (0, _parse.default)(formatter, code, opts);
      return formatter.unwrap((0, _populate.default)(metadata, replacements));
    };
  }
  return string$1;
}
var literal$2 = {};
var hasRequiredLiteral$1;
function requireLiteral$1() {
  if (hasRequiredLiteral$1) return literal$2;
  hasRequiredLiteral$1 = 1;
  Object.defineProperty(literal$2, '__esModule', {value: true});
  literal$2.default = literalTemplate;
  var _options = requireOptions$1();
  var _parse = requireParse$2();
  var _populate = requirePopulate$1();
  function literalTemplate(formatter, tpl, opts) {
    const {metadata: metadata, names: names} = buildLiteralData(
      formatter,
      tpl,
      opts
    );
    return arg => {
      const defaultReplacements = {};
      arg.forEach((replacement, i) => {
        defaultReplacements[names[i]] = replacement;
      });
      return arg => {
        const replacements = (0, _options.normalizeReplacements)(arg);
        if (replacements) {
          Object.keys(replacements).forEach(key => {
            if (
              Object.prototype.hasOwnProperty.call(defaultReplacements, key)
            ) {
              throw new Error('Unexpected replacement overlap.');
            }
          });
        }
        return formatter.unwrap(
          (0, _populate.default)(
            metadata,
            replacements
              ? Object.assign(replacements, defaultReplacements)
              : defaultReplacements
          )
        );
      };
    };
  }
  function buildLiteralData(formatter, tpl, opts) {
    let names;
    let nameSet;
    let metadata;
    let prefix = '';
    do {
      prefix += '$';
      const result = buildTemplateCode(tpl, prefix);
      names = result.names;
      nameSet = new Set(names);
      metadata = (0, _parse.default)(formatter, formatter.code(result.code), {
        parser: opts.parser,
        placeholderWhitelist: new Set(
          result.names.concat(
            opts.placeholderWhitelist
              ? Array.from(opts.placeholderWhitelist)
              : []
          )
        ),
        placeholderPattern: opts.placeholderPattern,
        preserveComments: opts.preserveComments,
        syntacticPlaceholders: opts.syntacticPlaceholders,
      });
    } while (
      metadata.placeholders.some(
        placeholder => placeholder.isDuplicate && nameSet.has(placeholder.name)
      )
    );
    return {metadata: metadata, names: names};
  }
  function buildTemplateCode(tpl, prefix) {
    const names = [];
    let code = tpl[0];
    for (let i = 1; i < tpl.length; i++) {
      const value = `${prefix}${i - 1}`;
      names.push(value);
      code += value + tpl[i];
    }
    return {names: names, code: code};
  }
  return literal$2;
}
var hasRequiredBuilder$1;
function requireBuilder$1() {
  if (hasRequiredBuilder$1) return builder$1;
  hasRequiredBuilder$1 = 1;
  Object.defineProperty(builder$1, '__esModule', {value: true});
  builder$1.default = createTemplateBuilder;
  var _options = requireOptions$1();
  var _string = requireString$1();
  var _literal = requireLiteral$1();
  const NO_PLACEHOLDER = (0, _options.validate)({placeholderPattern: false});
  function createTemplateBuilder(formatter, defaultOpts) {
    const templateFnCache = new WeakMap();
    const templateAstCache = new WeakMap();
    const cachedOpts = defaultOpts || (0, _options.validate)(null);
    return Object.assign(
      (tpl, ...args) => {
        if (typeof tpl === 'string') {
          if (args.length > 1) throw new Error('Unexpected extra params.');
          return extendedTrace(
            (0, _string.default)(
              formatter,
              tpl,
              (0, _options.merge)(cachedOpts, (0, _options.validate)(args[0]))
            )
          );
        } else if (Array.isArray(tpl)) {
          let builder = templateFnCache.get(tpl);
          if (!builder) {
            builder = (0, _literal.default)(formatter, tpl, cachedOpts);
            templateFnCache.set(tpl, builder);
          }
          return extendedTrace(builder(args));
        } else if (typeof tpl === 'object' && tpl) {
          if (args.length > 0) throw new Error('Unexpected extra params.');
          return createTemplateBuilder(
            formatter,
            (0, _options.merge)(cachedOpts, (0, _options.validate)(tpl))
          );
        }
        throw new Error(`Unexpected template param ${typeof tpl}`);
      },
      {
        ast: (tpl, ...args) => {
          if (typeof tpl === 'string') {
            if (args.length > 1) throw new Error('Unexpected extra params.');
            return (0, _string.default)(
              formatter,
              tpl,
              (0, _options.merge)(
                (0, _options.merge)(
                  cachedOpts,
                  (0, _options.validate)(args[0])
                ),
                NO_PLACEHOLDER
              )
            )();
          } else if (Array.isArray(tpl)) {
            let builder = templateAstCache.get(tpl);
            if (!builder) {
              builder = (0, _literal.default)(
                formatter,
                tpl,
                (0, _options.merge)(cachedOpts, NO_PLACEHOLDER)
              );
              templateAstCache.set(tpl, builder);
            }
            return builder(args)();
          }
          throw new Error(`Unexpected template param ${typeof tpl}`);
        },
      }
    );
  }
  function extendedTrace(fn) {
    let rootStack = '';
    try {
      throw new Error();
    } catch (error) {
      if (error.stack) {
        rootStack = error.stack.split('\n').slice(3).join('\n');
      }
    }
    return arg => {
      try {
        return fn(arg);
      } catch (err) {
        err.stack += `\n    =============\n${rootStack}`;
        throw err;
      }
    };
  }
  return builder$1;
}
var hasRequiredLib$d;
function requireLib$d() {
  if (hasRequiredLib$d) return lib$h;
  hasRequiredLib$d = 1;
  Object.defineProperty(lib$h, '__esModule', {value: true});
  lib$h.statements =
    lib$h.statement =
    lib$h.smart =
    lib$h.program =
    lib$h.expression =
    lib$h.default =
      void 0;
  var formatters = requireFormatters$1();
  var _builder = requireBuilder$1();
  const smart = (0, _builder.default)(formatters.smart);
  lib$h.smart = smart;
  const statement = (0, _builder.default)(formatters.statement);
  lib$h.statement = statement;
  const statements = (0, _builder.default)(formatters.statements);
  lib$h.statements = statements;
  const expression = (0, _builder.default)(formatters.expression);
  lib$h.expression = expression;
  const program = (0, _builder.default)(formatters.program);
  lib$h.program = program;
  var _default = Object.assign(smart.bind(undefined), {
    smart: smart,
    statement: statement,
    statements: statements,
    expression: expression,
    program: program,
    ast: smart.ast,
  });
  lib$h.default = _default;
  return lib$h;
}
var helpersGenerated = {};
var hasRequiredHelpersGenerated;
function requireHelpersGenerated() {
  if (hasRequiredHelpersGenerated) return helpersGenerated;
  hasRequiredHelpersGenerated = 1;
  Object.defineProperty(helpersGenerated, '__esModule', {value: true});
  helpersGenerated.default = void 0;
  var _template = requireLib$d();
  function helper(minVersion, source) {
    return Object.freeze({
      minVersion: minVersion,
      ast: () =>
        _template.default.program.ast(source, {preserveComments: true}),
    });
  }
  var _default = Object.freeze({
    AsyncGenerator: helper(
      '7.0.0-beta.0',
      'import OverloadYield from"OverloadYield";export default function AsyncGenerator(gen){var front,back;function resume(key,arg){try{var result=gen[key](arg),value=result.value,overloaded=value instanceof OverloadYield;Promise.resolve(overloaded?value.v:value).then((function(arg){if(overloaded){var nextKey="return"===key?"return":"next";if(!value.k||arg.done)return resume(nextKey,arg);arg=gen[nextKey](arg).value}settle(result.done?"return":"normal",arg)}),(function(err){resume("throw",err)}))}catch(err){settle("throw",err)}}function settle(type,value){switch(type){case"return":front.resolve({value:value,done:!0});break;case"throw":front.reject(value);break;default:front.resolve({value:value,done:!1})}(front=front.next)?resume(front.key,front.arg):back=null}this._invoke=function(key,arg){return new Promise((function(resolve,reject){var request={key:key,arg:arg,resolve:resolve,reject:reject,next:null};back?back=back.next=request:(front=back=request,resume(key,arg))}))},"function"!=typeof gen.return&&(this.return=void 0)}AsyncGenerator.prototype["function"==typeof Symbol&&Symbol.asyncIterator||"@@asyncIterator"]=function(){return this},AsyncGenerator.prototype.next=function(arg){return this._invoke("next",arg)},AsyncGenerator.prototype.throw=function(arg){return this._invoke("throw",arg)},AsyncGenerator.prototype.return=function(arg){return this._invoke("return",arg)};'
    ),
    OverloadYield: helper(
      '7.18.14',
      'export default function _OverloadYield(value,kind){this.v=value,this.k=kind}'
    ),
    applyDecs: helper(
      '7.17.8',
      'function old_createMetadataMethodsForProperty(metadataMap,kind,property,decoratorFinishedRef){return{getMetadata:function(key){old_assertNotFinished(decoratorFinishedRef,"getMetadata"),old_assertMetadataKey(key);var metadataForKey=metadataMap[key];if(void 0!==metadataForKey)if(1===kind){var pub=metadataForKey.public;if(void 0!==pub)return pub[property]}else if(2===kind){var priv=metadataForKey.private;if(void 0!==priv)return priv.get(property)}else if(Object.hasOwnProperty.call(metadataForKey,"constructor"))return metadataForKey.constructor},setMetadata:function(key,value){old_assertNotFinished(decoratorFinishedRef,"setMetadata"),old_assertMetadataKey(key);var metadataForKey=metadataMap[key];if(void 0===metadataForKey&&(metadataForKey=metadataMap[key]={}),1===kind){var pub=metadataForKey.public;void 0===pub&&(pub=metadataForKey.public={}),pub[property]=value}else if(2===kind){var priv=metadataForKey.priv;void 0===priv&&(priv=metadataForKey.private=new Map),priv.set(property,value)}else metadataForKey.constructor=value}}}function old_convertMetadataMapToFinal(obj,metadataMap){var parentMetadataMap=obj[Symbol.metadata||Symbol.for("Symbol.metadata")],metadataKeys=Object.getOwnPropertySymbols(metadataMap);if(0!==metadataKeys.length){for(var i=0;i<metadataKeys.length;i++){var key=metadataKeys[i],metaForKey=metadataMap[key],parentMetaForKey=parentMetadataMap?parentMetadataMap[key]:null,pub=metaForKey.public,parentPub=parentMetaForKey?parentMetaForKey.public:null;pub&&parentPub&&Object.setPrototypeOf(pub,parentPub);var priv=metaForKey.private;if(priv){var privArr=Array.from(priv.values()),parentPriv=parentMetaForKey?parentMetaForKey.private:null;parentPriv&&(privArr=privArr.concat(parentPriv)),metaForKey.private=privArr}parentMetaForKey&&Object.setPrototypeOf(metaForKey,parentMetaForKey)}parentMetadataMap&&Object.setPrototypeOf(metadataMap,parentMetadataMap),obj[Symbol.metadata||Symbol.for("Symbol.metadata")]=metadataMap}}function old_createAddInitializerMethod(initializers,decoratorFinishedRef){return function(initializer){old_assertNotFinished(decoratorFinishedRef,"addInitializer"),old_assertCallable(initializer,"An initializer"),initializers.push(initializer)}}function old_memberDec(dec,name,desc,metadataMap,initializers,kind,isStatic,isPrivate,value){var kindStr;switch(kind){case 1:kindStr="accessor";break;case 2:kindStr="method";break;case 3:kindStr="getter";break;case 4:kindStr="setter";break;default:kindStr="field"}var metadataKind,metadataName,ctx={kind:kindStr,name:isPrivate?"#"+name:name,isStatic:isStatic,isPrivate:isPrivate},decoratorFinishedRef={v:!1};if(0!==kind&&(ctx.addInitializer=old_createAddInitializerMethod(initializers,decoratorFinishedRef)),isPrivate){metadataKind=2,metadataName=Symbol(name);var access={};0===kind?(access.get=desc.get,access.set=desc.set):2===kind?access.get=function(){return desc.value}:(1!==kind&&3!==kind||(access.get=function(){return desc.get.call(this)}),1!==kind&&4!==kind||(access.set=function(v){desc.set.call(this,v)})),ctx.access=access}else metadataKind=1,metadataName=name;try{return dec(value,Object.assign(ctx,old_createMetadataMethodsForProperty(metadataMap,metadataKind,metadataName,decoratorFinishedRef)))}finally{decoratorFinishedRef.v=!0}}function old_assertNotFinished(decoratorFinishedRef,fnName){if(decoratorFinishedRef.v)throw new Error("attempted to call "+fnName+" after decoration was finished")}function old_assertMetadataKey(key){if("symbol"!=typeof key)throw new TypeError("Metadata keys must be symbols, received: "+key)}function old_assertCallable(fn,hint){if("function"!=typeof fn)throw new TypeError(hint+" must be a function")}function old_assertValidReturnValue(kind,value){var type=typeof value;if(1===kind){if("object"!==type||null===value)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==value.get&&old_assertCallable(value.get,"accessor.get"),void 0!==value.set&&old_assertCallable(value.set,"accessor.set"),void 0!==value.init&&old_assertCallable(value.init,"accessor.init"),void 0!==value.initializer&&old_assertCallable(value.initializer,"accessor.initializer")}else if("function"!==type){var hint;throw hint=0===kind?"field":10===kind?"class":"method",new TypeError(hint+" decorators must return a function or void 0")}}function old_getInit(desc){var initializer;return null==(initializer=desc.init)&&(initializer=desc.initializer)&&"undefined"!=typeof console&&console.warn(".initializer has been renamed to .init as of March 2022"),initializer}function old_applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,metadataMap,initializers){var desc,initializer,value,newValue,get,set,decs=decInfo[0];if(isPrivate?desc=0===kind||1===kind?{get:decInfo[3],set:decInfo[4]}:3===kind?{get:decInfo[3]}:4===kind?{set:decInfo[3]}:{value:decInfo[3]}:0!==kind&&(desc=Object.getOwnPropertyDescriptor(base,name)),1===kind?value={get:desc.get,set:desc.set}:2===kind?value=desc.value:3===kind?value=desc.get:4===kind&&(value=desc.set),"function"==typeof decs)void 0!==(newValue=old_memberDec(decs,name,desc,metadataMap,initializers,kind,isStatic,isPrivate,value))&&(old_assertValidReturnValue(kind,newValue),0===kind?initializer=newValue:1===kind?(initializer=old_getInit(newValue),get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue);else for(var i=decs.length-1;i>=0;i--){var newInit;if(void 0!==(newValue=old_memberDec(decs[i],name,desc,metadataMap,initializers,kind,isStatic,isPrivate,value)))old_assertValidReturnValue(kind,newValue),0===kind?newInit=newValue:1===kind?(newInit=old_getInit(newValue),get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue,void 0!==newInit&&(void 0===initializer?initializer=newInit:"function"==typeof initializer?initializer=[initializer,newInit]:initializer.push(newInit))}if(0===kind||1===kind){if(void 0===initializer)initializer=function(instance,init){return init};else if("function"!=typeof initializer){var ownInitializers=initializer;initializer=function(instance,init){for(var value=init,i=0;i<ownInitializers.length;i++)value=ownInitializers[i].call(instance,value);return value}}else{var originalInitializer=initializer;initializer=function(instance,init){return originalInitializer.call(instance,init)}}ret.push(initializer)}0!==kind&&(1===kind?(desc.get=value.get,desc.set=value.set):2===kind?desc.value=value:3===kind?desc.get=value:4===kind&&(desc.set=value),isPrivate?1===kind?(ret.push((function(instance,args){return value.get.call(instance,args)})),ret.push((function(instance,args){return value.set.call(instance,args)}))):2===kind?ret.push(value):ret.push((function(instance,args){return value.call(instance,args)})):Object.defineProperty(base,name,desc))}function old_applyMemberDecs(ret,Class,protoMetadataMap,staticMetadataMap,decInfos){for(var protoInitializers,staticInitializers,existingProtoNonFields=new Map,existingStaticNonFields=new Map,i=0;i<decInfos.length;i++){var decInfo=decInfos[i];if(Array.isArray(decInfo)){var base,metadataMap,initializers,kind=decInfo[1],name=decInfo[2],isPrivate=decInfo.length>3,isStatic=kind>=5;if(isStatic?(base=Class,metadataMap=staticMetadataMap,0!==(kind-=5)&&(initializers=staticInitializers=staticInitializers||[])):(base=Class.prototype,metadataMap=protoMetadataMap,0!==kind&&(initializers=protoInitializers=protoInitializers||[])),0!==kind&&!isPrivate){var existingNonFields=isStatic?existingStaticNonFields:existingProtoNonFields,existingKind=existingNonFields.get(name)||0;if(!0===existingKind||3===existingKind&&4!==kind||4===existingKind&&3!==kind)throw new Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+name);!existingKind&&kind>2?existingNonFields.set(name,kind):existingNonFields.set(name,!0)}old_applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,metadataMap,initializers)}}old_pushInitializers(ret,protoInitializers),old_pushInitializers(ret,staticInitializers)}function old_pushInitializers(ret,initializers){initializers&&ret.push((function(instance){for(var i=0;i<initializers.length;i++)initializers[i].call(instance);return instance}))}function old_applyClassDecs(ret,targetClass,metadataMap,classDecs){if(classDecs.length>0){for(var initializers=[],newClass=targetClass,name=targetClass.name,i=classDecs.length-1;i>=0;i--){var decoratorFinishedRef={v:!1};try{var ctx=Object.assign({kind:"class",name:name,addInitializer:old_createAddInitializerMethod(initializers,decoratorFinishedRef)},old_createMetadataMethodsForProperty(metadataMap,0,name,decoratorFinishedRef)),nextNewClass=classDecs[i](newClass,ctx)}finally{decoratorFinishedRef.v=!0}void 0!==nextNewClass&&(old_assertValidReturnValue(10,nextNewClass),newClass=nextNewClass)}ret.push(newClass,(function(){for(var i=0;i<initializers.length;i++)initializers[i].call(newClass)}))}}export default function applyDecs(targetClass,memberDecs,classDecs){var ret=[],staticMetadataMap={},protoMetadataMap={};return old_applyMemberDecs(ret,targetClass,protoMetadataMap,staticMetadataMap,memberDecs),old_convertMetadataMapToFinal(targetClass.prototype,protoMetadataMap),old_applyClassDecs(ret,targetClass,staticMetadataMap,classDecs),old_convertMetadataMapToFinal(targetClass,staticMetadataMap),ret}'
    ),
    applyDecs2203: helper(
      '7.19.0',
      'function createAddInitializerMethod(initializers,decoratorFinishedRef){return function(initializer){assertNotFinished(decoratorFinishedRef,"addInitializer"),assertCallable(initializer,"An initializer"),initializers.push(initializer)}}function memberDec(dec,name,desc,initializers,kind,isStatic,isPrivate,value){var kindStr;switch(kind){case 1:kindStr="accessor";break;case 2:kindStr="method";break;case 3:kindStr="getter";break;case 4:kindStr="setter";break;default:kindStr="field"}var get,set,ctx={kind:kindStr,name:isPrivate?"#"+name:name,static:isStatic,private:isPrivate},decoratorFinishedRef={v:!1};0!==kind&&(ctx.addInitializer=createAddInitializerMethod(initializers,decoratorFinishedRef)),0===kind?isPrivate?(get=desc.get,set=desc.set):(get=function(){return this[name]},set=function(v){this[name]=v}):2===kind?get=function(){return desc.value}:(1!==kind&&3!==kind||(get=function(){return desc.get.call(this)}),1!==kind&&4!==kind||(set=function(v){desc.set.call(this,v)})),ctx.access=get&&set?{get:get,set:set}:get?{get:get}:{set:set};try{return dec(value,ctx)}finally{decoratorFinishedRef.v=!0}}function assertNotFinished(decoratorFinishedRef,fnName){if(decoratorFinishedRef.v)throw new Error("attempted to call "+fnName+" after decoration was finished")}function assertCallable(fn,hint){if("function"!=typeof fn)throw new TypeError(hint+" must be a function")}function assertValidReturnValue(kind,value){var type=typeof value;if(1===kind){if("object"!==type||null===value)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==value.get&&assertCallable(value.get,"accessor.get"),void 0!==value.set&&assertCallable(value.set,"accessor.set"),void 0!==value.init&&assertCallable(value.init,"accessor.init")}else if("function"!==type){var hint;throw hint=0===kind?"field":10===kind?"class":"method",new TypeError(hint+" decorators must return a function or void 0")}}function applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,initializers){var desc,init,value,newValue,get,set,decs=decInfo[0];if(isPrivate?desc=0===kind||1===kind?{get:decInfo[3],set:decInfo[4]}:3===kind?{get:decInfo[3]}:4===kind?{set:decInfo[3]}:{value:decInfo[3]}:0!==kind&&(desc=Object.getOwnPropertyDescriptor(base,name)),1===kind?value={get:desc.get,set:desc.set}:2===kind?value=desc.value:3===kind?value=desc.get:4===kind&&(value=desc.set),"function"==typeof decs)void 0!==(newValue=memberDec(decs,name,desc,initializers,kind,isStatic,isPrivate,value))&&(assertValidReturnValue(kind,newValue),0===kind?init=newValue:1===kind?(init=newValue.init,get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue);else for(var i=decs.length-1;i>=0;i--){var newInit;if(void 0!==(newValue=memberDec(decs[i],name,desc,initializers,kind,isStatic,isPrivate,value)))assertValidReturnValue(kind,newValue),0===kind?newInit=newValue:1===kind?(newInit=newValue.init,get=newValue.get||value.get,set=newValue.set||value.set,value={get:get,set:set}):value=newValue,void 0!==newInit&&(void 0===init?init=newInit:"function"==typeof init?init=[init,newInit]:init.push(newInit))}if(0===kind||1===kind){if(void 0===init)init=function(instance,init){return init};else if("function"!=typeof init){var ownInitializers=init;init=function(instance,init){for(var value=init,i=0;i<ownInitializers.length;i++)value=ownInitializers[i].call(instance,value);return value}}else{var originalInitializer=init;init=function(instance,init){return originalInitializer.call(instance,init)}}ret.push(init)}0!==kind&&(1===kind?(desc.get=value.get,desc.set=value.set):2===kind?desc.value=value:3===kind?desc.get=value:4===kind&&(desc.set=value),isPrivate?1===kind?(ret.push((function(instance,args){return value.get.call(instance,args)})),ret.push((function(instance,args){return value.set.call(instance,args)}))):2===kind?ret.push(value):ret.push((function(instance,args){return value.call(instance,args)})):Object.defineProperty(base,name,desc))}function applyMemberDecs(ret,Class,decInfos){for(var protoInitializers,staticInitializers,existingProtoNonFields=new Map,existingStaticNonFields=new Map,i=0;i<decInfos.length;i++){var decInfo=decInfos[i];if(Array.isArray(decInfo)){var base,initializers,kind=decInfo[1],name=decInfo[2],isPrivate=decInfo.length>3,isStatic=kind>=5;if(isStatic?(base=Class,0!==(kind-=5)&&(initializers=staticInitializers=staticInitializers||[])):(base=Class.prototype,0!==kind&&(initializers=protoInitializers=protoInitializers||[])),0!==kind&&!isPrivate){var existingNonFields=isStatic?existingStaticNonFields:existingProtoNonFields,existingKind=existingNonFields.get(name)||0;if(!0===existingKind||3===existingKind&&4!==kind||4===existingKind&&3!==kind)throw new Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+name);!existingKind&&kind>2?existingNonFields.set(name,kind):existingNonFields.set(name,!0)}applyMemberDec(ret,base,decInfo,name,kind,isStatic,isPrivate,initializers)}}pushInitializers(ret,protoInitializers),pushInitializers(ret,staticInitializers)}function pushInitializers(ret,initializers){initializers&&ret.push((function(instance){for(var i=0;i<initializers.length;i++)initializers[i].call(instance);return instance}))}function applyClassDecs(ret,targetClass,classDecs){if(classDecs.length>0){for(var initializers=[],newClass=targetClass,name=targetClass.name,i=classDecs.length-1;i>=0;i--){var decoratorFinishedRef={v:!1};try{var nextNewClass=classDecs[i](newClass,{kind:"class",name:name,addInitializer:createAddInitializerMethod(initializers,decoratorFinishedRef)})}finally{decoratorFinishedRef.v=!0}void 0!==nextNewClass&&(assertValidReturnValue(10,nextNewClass),newClass=nextNewClass)}ret.push(newClass,(function(){for(var i=0;i<initializers.length;i++)initializers[i].call(newClass)}))}}export default function applyDecs2203(targetClass,memberDecs,classDecs){var ret=[];return applyMemberDecs(ret,targetClass,memberDecs),applyClassDecs(ret,targetClass,classDecs),ret}'
    ),
    asyncGeneratorDelegate: helper(
      '7.0.0-beta.0',
      'import OverloadYield from"OverloadYield";export default function _asyncGeneratorDelegate(inner){var iter={},waiting=!1;function pump(key,value){return waiting=!0,value=new Promise((function(resolve){resolve(inner[key](value))})),{done:!1,value:new OverloadYield(value,1)}}return iter["undefined"!=typeof Symbol&&Symbol.iterator||"@@iterator"]=function(){return this},iter.next=function(value){return waiting?(waiting=!1,value):pump("next",value)},"function"==typeof inner.throw&&(iter.throw=function(value){if(waiting)throw waiting=!1,value;return pump("throw",value)}),"function"==typeof inner.return&&(iter.return=function(value){return waiting?(waiting=!1,value):pump("return",value)}),iter}'
    ),
    asyncIterator: helper(
      '7.15.9',
      'export default function _asyncIterator(iterable){var method,async,sync,retry=2;for("undefined"!=typeof Symbol&&(async=Symbol.asyncIterator,sync=Symbol.iterator);retry--;){if(async&&null!=(method=iterable[async]))return method.call(iterable);if(sync&&null!=(method=iterable[sync]))return new AsyncFromSyncIterator(method.call(iterable));async="@@asyncIterator",sync="@@iterator"}throw new TypeError("Object is not async iterable")}function AsyncFromSyncIterator(s){function AsyncFromSyncIteratorContinuation(r){if(Object(r)!==r)return Promise.reject(new TypeError(r+" is not an object."));var done=r.done;return Promise.resolve(r.value).then((function(value){return{value:value,done:done}}))}return AsyncFromSyncIterator=function(s){this.s=s,this.n=s.next},AsyncFromSyncIterator.prototype={s:null,n:null,next:function(){return AsyncFromSyncIteratorContinuation(this.n.apply(this.s,arguments))},return:function(value){var ret=this.s.return;return void 0===ret?Promise.resolve({value:value,done:!0}):AsyncFromSyncIteratorContinuation(ret.apply(this.s,arguments))},throw:function(value){var thr=this.s.return;return void 0===thr?Promise.reject(value):AsyncFromSyncIteratorContinuation(thr.apply(this.s,arguments))}},new AsyncFromSyncIterator(s)}'
    ),
    awaitAsyncGenerator: helper(
      '7.0.0-beta.0',
      'import OverloadYield from"OverloadYield";export default function _awaitAsyncGenerator(value){return new OverloadYield(value,0)}'
    ),
    jsx: helper(
      '7.0.0-beta.0',
      'var REACT_ELEMENT_TYPE;export default function _createRawReactElement(type,props,key,children){REACT_ELEMENT_TYPE||(REACT_ELEMENT_TYPE="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103);var defaultProps=type&&type.defaultProps,childrenLength=arguments.length-3;if(props||0===childrenLength||(props={children:void 0}),1===childrenLength)props.children=children;else if(childrenLength>1){for(var childArray=new Array(childrenLength),i=0;i<childrenLength;i++)childArray[i]=arguments[i+3];props.children=childArray}if(props&&defaultProps)for(var propName in defaultProps)void 0===props[propName]&&(props[propName]=defaultProps[propName]);else props||(props=defaultProps||{});return{$$typeof:REACT_ELEMENT_TYPE,type:type,key:void 0===key?null:""+key,ref:null,props:props,_owner:null}}'
    ),
    objectSpread2: helper(
      '7.5.0',
      'import defineProperty from"defineProperty";function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter((function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable}))),keys.push.apply(keys,symbols)}return keys}export default function _objectSpread2(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach((function(key){defineProperty(target,key,source[key])})):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach((function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))}))}return target}'
    ),
    regeneratorRuntime: helper(
      '7.18.0',
      'export default function _regeneratorRuntime(){"use strict";\n/*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */_regeneratorRuntime=function(){return exports};var exports={},Op=Object.prototype,hasOwn=Op.hasOwnProperty,$Symbol="function"==typeof Symbol?Symbol:{},iteratorSymbol=$Symbol.iterator||"@@iterator",asyncIteratorSymbol=$Symbol.asyncIterator||"@@asyncIterator",toStringTagSymbol=$Symbol.toStringTag||"@@toStringTag";function define(obj,key,value){return Object.defineProperty(obj,key,{value:value,enumerable:!0,configurable:!0,writable:!0}),obj[key]}try{define({},"")}catch(err){define=function(obj,key,value){return obj[key]=value}}function wrap(innerFn,outerFn,self,tryLocsList){var protoGenerator=outerFn&&outerFn.prototype instanceof Generator?outerFn:Generator,generator=Object.create(protoGenerator.prototype),context=new Context(tryLocsList||[]);return generator._invoke=function(innerFn,self,context){var state="suspendedStart";return function(method,arg){if("executing"===state)throw new Error("Generator is already running");if("completed"===state){if("throw"===method)throw arg;return doneResult()}for(context.method=method,context.arg=arg;;){var delegate=context.delegate;if(delegate){var delegateResult=maybeInvokeDelegate(delegate,context);if(delegateResult){if(delegateResult===ContinueSentinel)continue;return delegateResult}}if("next"===context.method)context.sent=context._sent=context.arg;else if("throw"===context.method){if("suspendedStart"===state)throw state="completed",context.arg;context.dispatchException(context.arg)}else"return"===context.method&&context.abrupt("return",context.arg);state="executing";var record=tryCatch(innerFn,self,context);if("normal"===record.type){if(state=context.done?"completed":"suspendedYield",record.arg===ContinueSentinel)continue;return{value:record.arg,done:context.done}}"throw"===record.type&&(state="completed",context.method="throw",context.arg=record.arg)}}}(innerFn,self,context),generator}function tryCatch(fn,obj,arg){try{return{type:"normal",arg:fn.call(obj,arg)}}catch(err){return{type:"throw",arg:err}}}exports.wrap=wrap;var ContinueSentinel={};function Generator(){}function GeneratorFunction(){}function GeneratorFunctionPrototype(){}var IteratorPrototype={};define(IteratorPrototype,iteratorSymbol,(function(){return this}));var getProto=Object.getPrototypeOf,NativeIteratorPrototype=getProto&&getProto(getProto(values([])));NativeIteratorPrototype&&NativeIteratorPrototype!==Op&&hasOwn.call(NativeIteratorPrototype,iteratorSymbol)&&(IteratorPrototype=NativeIteratorPrototype);var Gp=GeneratorFunctionPrototype.prototype=Generator.prototype=Object.create(IteratorPrototype);function defineIteratorMethods(prototype){["next","throw","return"].forEach((function(method){define(prototype,method,(function(arg){return this._invoke(method,arg)}))}))}function AsyncIterator(generator,PromiseImpl){function invoke(method,arg,resolve,reject){var record=tryCatch(generator[method],generator,arg);if("throw"!==record.type){var result=record.arg,value=result.value;return value&&"object"==typeof value&&hasOwn.call(value,"__await")?PromiseImpl.resolve(value.__await).then((function(value){invoke("next",value,resolve,reject)}),(function(err){invoke("throw",err,resolve,reject)})):PromiseImpl.resolve(value).then((function(unwrapped){result.value=unwrapped,resolve(result)}),(function(error){return invoke("throw",error,resolve,reject)}))}reject(record.arg)}var previousPromise;this._invoke=function(method,arg){function callInvokeWithMethodAndArg(){return new PromiseImpl((function(resolve,reject){invoke(method,arg,resolve,reject)}))}return previousPromise=previousPromise?previousPromise.then(callInvokeWithMethodAndArg,callInvokeWithMethodAndArg):callInvokeWithMethodAndArg()}}function maybeInvokeDelegate(delegate,context){var method=delegate.iterator[context.method];if(undefined===method){if(context.delegate=null,"throw"===context.method){if(delegate.iterator.return&&(context.method="return",context.arg=undefined,maybeInvokeDelegate(delegate,context),"throw"===context.method))return ContinueSentinel;context.method="throw",context.arg=new TypeError("The iterator does not provide a \'throw\' method")}return ContinueSentinel}var record=tryCatch(method,delegate.iterator,context.arg);if("throw"===record.type)return context.method="throw",context.arg=record.arg,context.delegate=null,ContinueSentinel;var info=record.arg;return info?info.done?(context[delegate.resultName]=info.value,context.next=delegate.nextLoc,"return"!==context.method&&(context.method="next",context.arg=undefined),context.delegate=null,ContinueSentinel):info:(context.method="throw",context.arg=new TypeError("iterator result is not an object"),context.delegate=null,ContinueSentinel)}function pushTryEntry(locs){var entry={tryLoc:locs[0]};1 in locs&&(entry.catchLoc=locs[1]),2 in locs&&(entry.finallyLoc=locs[2],entry.afterLoc=locs[3]),this.tryEntries.push(entry)}function resetTryEntry(entry){var record=entry.completion||{};record.type="normal",delete record.arg,entry.completion=record}function Context(tryLocsList){this.tryEntries=[{tryLoc:"root"}],tryLocsList.forEach(pushTryEntry,this),this.reset(!0)}function values(iterable){if(iterable){var iteratorMethod=iterable[iteratorSymbol];if(iteratorMethod)return iteratorMethod.call(iterable);if("function"==typeof iterable.next)return iterable;if(!isNaN(iterable.length)){var i=-1,next=function next(){for(;++i<iterable.length;)if(hasOwn.call(iterable,i))return next.value=iterable[i],next.done=!1,next;return next.value=undefined,next.done=!0,next};return next.next=next}}return{next:doneResult}}function doneResult(){return{value:undefined,done:!0}}return GeneratorFunction.prototype=GeneratorFunctionPrototype,define(Gp,"constructor",GeneratorFunctionPrototype),define(GeneratorFunctionPrototype,"constructor",GeneratorFunction),GeneratorFunction.displayName=define(GeneratorFunctionPrototype,toStringTagSymbol,"GeneratorFunction"),exports.isGeneratorFunction=function(genFun){var ctor="function"==typeof genFun&&genFun.constructor;return!!ctor&&(ctor===GeneratorFunction||"GeneratorFunction"===(ctor.displayName||ctor.name))},exports.mark=function(genFun){return Object.setPrototypeOf?Object.setPrototypeOf(genFun,GeneratorFunctionPrototype):(genFun.__proto__=GeneratorFunctionPrototype,define(genFun,toStringTagSymbol,"GeneratorFunction")),genFun.prototype=Object.create(Gp),genFun},exports.awrap=function(arg){return{__await:arg}},defineIteratorMethods(AsyncIterator.prototype),define(AsyncIterator.prototype,asyncIteratorSymbol,(function(){return this})),exports.AsyncIterator=AsyncIterator,exports.async=function(innerFn,outerFn,self,tryLocsList,PromiseImpl){void 0===PromiseImpl&&(PromiseImpl=Promise);var iter=new AsyncIterator(wrap(innerFn,outerFn,self,tryLocsList),PromiseImpl);return exports.isGeneratorFunction(outerFn)?iter:iter.next().then((function(result){return result.done?result.value:iter.next()}))},defineIteratorMethods(Gp),define(Gp,toStringTagSymbol,"Generator"),define(Gp,iteratorSymbol,(function(){return this})),define(Gp,"toString",(function(){return"[object Generator]"})),exports.keys=function(object){var keys=[];for(var key in object)keys.push(key);return keys.reverse(),function next(){for(;keys.length;){var key=keys.pop();if(key in object)return next.value=key,next.done=!1,next}return next.done=!0,next}},exports.values=values,Context.prototype={constructor:Context,reset:function(skipTempReset){if(this.prev=0,this.next=0,this.sent=this._sent=undefined,this.done=!1,this.delegate=null,this.method="next",this.arg=undefined,this.tryEntries.forEach(resetTryEntry),!skipTempReset)for(var name in this)"t"===name.charAt(0)&&hasOwn.call(this,name)&&!isNaN(+name.slice(1))&&(this[name]=undefined)},stop:function(){this.done=!0;var rootRecord=this.tryEntries[0].completion;if("throw"===rootRecord.type)throw rootRecord.arg;return this.rval},dispatchException:function(exception){if(this.done)throw exception;var context=this;function handle(loc,caught){return record.type="throw",record.arg=exception,context.next=loc,caught&&(context.method="next",context.arg=undefined),!!caught}for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i],record=entry.completion;if("root"===entry.tryLoc)return handle("end");if(entry.tryLoc<=this.prev){var hasCatch=hasOwn.call(entry,"catchLoc"),hasFinally=hasOwn.call(entry,"finallyLoc");if(hasCatch&&hasFinally){if(this.prev<entry.catchLoc)return handle(entry.catchLoc,!0);if(this.prev<entry.finallyLoc)return handle(entry.finallyLoc)}else if(hasCatch){if(this.prev<entry.catchLoc)return handle(entry.catchLoc,!0)}else{if(!hasFinally)throw new Error("try statement without catch or finally");if(this.prev<entry.finallyLoc)return handle(entry.finallyLoc)}}}},abrupt:function(type,arg){for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i];if(entry.tryLoc<=this.prev&&hasOwn.call(entry,"finallyLoc")&&this.prev<entry.finallyLoc){var finallyEntry=entry;break}}finallyEntry&&("break"===type||"continue"===type)&&finallyEntry.tryLoc<=arg&&arg<=finallyEntry.finallyLoc&&(finallyEntry=null);var record=finallyEntry?finallyEntry.completion:{};return record.type=type,record.arg=arg,finallyEntry?(this.method="next",this.next=finallyEntry.finallyLoc,ContinueSentinel):this.complete(record)},complete:function(record,afterLoc){if("throw"===record.type)throw record.arg;return"break"===record.type||"continue"===record.type?this.next=record.arg:"return"===record.type?(this.rval=this.arg=record.arg,this.method="return",this.next="end"):"normal"===record.type&&afterLoc&&(this.next=afterLoc),ContinueSentinel},finish:function(finallyLoc){for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i];if(entry.finallyLoc===finallyLoc)return this.complete(entry.completion,entry.afterLoc),resetTryEntry(entry),ContinueSentinel}},catch:function(tryLoc){for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i];if(entry.tryLoc===tryLoc){var record=entry.completion;if("throw"===record.type){var thrown=record.arg;resetTryEntry(entry)}return thrown}}throw new Error("illegal catch attempt")},delegateYield:function(iterable,resultName,nextLoc){return this.delegate={iterator:values(iterable),resultName:resultName,nextLoc:nextLoc},"next"===this.method&&(this.arg=undefined),ContinueSentinel}},exports}'
    ),
    typeof: helper(
      '7.0.0-beta.0',
      'export default function _typeof(obj){"@babel/helpers - typeof";return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj},_typeof(obj)}'
    ),
    wrapRegExp: helper(
      '7.19.0',
      'import setPrototypeOf from"setPrototypeOf";import inherits from"inherits";export default function _wrapRegExp(){_wrapRegExp=function(re,groups){return new BabelRegExp(re,void 0,groups)};var _super=RegExp.prototype,_groups=new WeakMap;function BabelRegExp(re,flags,groups){var _this=new RegExp(re,flags);return _groups.set(_this,groups||_groups.get(re)),setPrototypeOf(_this,BabelRegExp.prototype)}function buildGroups(result,re){var g=_groups.get(re);return Object.keys(g).reduce((function(groups,name){var i=g[name];if("number"==typeof i)groups[name]=result[i];else{for(var k=0;void 0===result[i[k]]&&k+1<i.length;)k++;groups[name]=result[i[k]]}return groups}),Object.create(null))}return inherits(BabelRegExp,RegExp),BabelRegExp.prototype.exec=function(str){var result=_super.exec.call(this,str);return result&&(result.groups=buildGroups(result,this)),result},BabelRegExp.prototype[Symbol.replace]=function(str,substitution){if("string"==typeof substitution){var groups=_groups.get(this);return _super[Symbol.replace].call(this,str,substitution.replace(/\\$<([^>]+)>/g,(function(_,name){return"$"+groups[name]})))}if("function"==typeof substitution){var _this=this;return _super[Symbol.replace].call(this,str,(function(){var args=arguments;return"object"!=typeof args[args.length-1]&&(args=[].slice.call(args)).push(buildGroups(args,_this)),substitution.apply(this,args)}))}return _super[Symbol.replace].call(this,str,substitution)},_wrapRegExp.apply(this,arguments)}'
    ),
  });
  helpersGenerated.default = _default;
  return helpersGenerated;
}
var hasRequiredHelpers;
function requireHelpers() {
  if (hasRequiredHelpers) return helpers$2;
  hasRequiredHelpers = 1;
  Object.defineProperty(helpers$2, '__esModule', {value: true});
  helpers$2.default = void 0;
  var _template = requireLib$d();
  var _helpersGenerated = requireHelpersGenerated();
  const helpers = Object.assign({__proto__: null}, _helpersGenerated.default);
  var _default = helpers;
  helpers$2.default = _default;
  const helper = minVersion => tpl => ({
    minVersion: minVersion,
    ast: () => _template.default.program.ast(tpl),
  });
  {
    helpers.AwaitValue = helper('7.0.0-beta.0')`
    export default function _AwaitValue(value) {
      this.wrapped = value;
    }
  `;
  }
  helpers.wrapAsyncGenerator = helper('7.0.0-beta.0')`
  import AsyncGenerator from "AsyncGenerator";

  export default function _wrapAsyncGenerator(fn) {
    return function () {
      return new AsyncGenerator(fn.apply(this, arguments));
    };
  }
`;
  helpers.asyncToGenerator = helper('7.0.0-beta.0')`
  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  export default function _asyncToGenerator(fn) {
    return function () {
      var self = this, args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }
        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }
`;
  helpers.classCallCheck = helper('7.0.0-beta.0')`
  export default function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
`;
  helpers.createClass = helper('7.0.0-beta.0')`
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i ++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  export default function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", { writable: false });
    return Constructor;
  }
`;
  helpers.defineEnumerableProperties = helper('7.0.0-beta.0')`
  export default function _defineEnumerableProperties(obj, descs) {
    for (var key in descs) {
      var desc = descs[key];
      desc.configurable = desc.enumerable = true;
      if ("value" in desc) desc.writable = true;
      Object.defineProperty(obj, key, desc);
    }

    // Symbols are not enumerated over by for-in loops. If native
    // Symbols are available, fetch all of the descs object's own
    // symbol properties and define them on our target object too.
    if (Object.getOwnPropertySymbols) {
      var objectSymbols = Object.getOwnPropertySymbols(descs);
      for (var i = 0; i < objectSymbols.length; i++) {
        var sym = objectSymbols[i];
        var desc = descs[sym];
        desc.configurable = desc.enumerable = true;
        if ("value" in desc) desc.writable = true;
        Object.defineProperty(obj, sym, desc);
      }
    }
    return obj;
  }
`;
  helpers.defaults = helper('7.0.0-beta.0')`
  export default function _defaults(obj, defaults) {
    var keys = Object.getOwnPropertyNames(defaults);
    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      var value = Object.getOwnPropertyDescriptor(defaults, key);
      if (value && value.configurable && obj[key] === undefined) {
        Object.defineProperty(obj, key, value);
      }
    }
    return obj;
  }
`;
  helpers.defineProperty = helper('7.0.0-beta.0')`
  export default function _defineProperty(obj, key, value) {
    // Shortcircuit the slow defineProperty path when possible.
    // We are trying to avoid issues where setters defined on the
    // prototype cause side effects under the fast path of simple
    // assignment. By checking for existence of the property with
    // the in operator, we can optimize most of this overhead away.
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }
    return obj;
  }
`;
  helpers.extends = helper('7.0.0-beta.0')`
  export default function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };

    return _extends.apply(this, arguments);
  }
`;
  helpers.objectSpread = helper('7.0.0-beta.0')`
  import defineProperty from "defineProperty";

  export default function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = (arguments[i] != null) ? Object(arguments[i]) : {};
      var ownKeys = Object.keys(source);
      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function(sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }
      ownKeys.forEach(function(key) {
        defineProperty(target, key, source[key]);
      });
    }
    return target;
  }
`;
  helpers.inherits = helper('7.0.0-beta.0')`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    // We can't use defineProperty to set the prototype in a single step because it
    // doesn't work in Chrome <= 36. https://github.com/babel/babel/issues/14056
    // V8 bug: https://bugs.chromium.org/p/v8/issues/detail?id=3334
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", { writable: false });
    if (superClass) setPrototypeOf(subClass, superClass);
  }
`;
  helpers.inheritsLoose = helper('7.0.0-beta.0')`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    setPrototypeOf(subClass, superClass);
  }
`;
  helpers.getPrototypeOf = helper('7.0.0-beta.0')`
  export default function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf
      ? Object.getPrototypeOf.bind()
      : function _getPrototypeOf(o) {
          return o.__proto__ || Object.getPrototypeOf(o);
        };
    return _getPrototypeOf(o);
  }
`;
  helpers.setPrototypeOf = helper('7.0.0-beta.0')`
  export default function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf
      ? Object.setPrototypeOf.bind()
      : function _setPrototypeOf(o, p) {
          o.__proto__ = p;
          return o;
        };
    return _setPrototypeOf(o, p);
  }
`;
  helpers.isNativeReflectConstruct = helper('7.9.0')`
  export default function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;

    // core-js@3
    if (Reflect.construct.sham) return false;

    // Proxy can't be polyfilled. Every browser implemented
    // proxies before or at the same time as Reflect.construct,
    // so if they support Proxy they also support Reflect.construct.
    if (typeof Proxy === "function") return true;

    // Since Reflect.construct can't be properly polyfilled, some
    // implementations (e.g. core-js@2) don't set the correct internal slots.
    // Those polyfills don't allow us to subclass built-ins, so we need to
    // use our fallback implementation.
    try {
      // If the internal slots aren't set, this throws an error similar to
      //   TypeError: this is not a Boolean object.

      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
      return true;
    } catch (e) {
      return false;
    }
  }
`;
  helpers.construct = helper('7.0.0-beta.0')`
  import setPrototypeOf from "setPrototypeOf";
  import isNativeReflectConstruct from "isNativeReflectConstruct";

  export default function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct.bind();
    } else {
      // NOTE: If Parent !== Class, the correct __proto__ is set *after*
      //       calling the constructor.
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }
    // Avoid issues with Class being present but undefined when it wasn't
    // present in the original call.
    return _construct.apply(null, arguments);
  }
`;
  helpers.isNativeFunction = helper('7.0.0-beta.0')`
  export default function _isNativeFunction(fn) {
    // Note: This function returns "true" for core-js functions.
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }
`;
  helpers.wrapNativeSuper = helper('7.0.0-beta.0')`
  import getPrototypeOf from "getPrototypeOf";
  import setPrototypeOf from "setPrototypeOf";
  import isNativeFunction from "isNativeFunction";
  import construct from "construct";

  export default function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !isNativeFunction(Class)) return Class;
      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }
      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);
        _cache.set(Class, Wrapper);
      }
      function Wrapper() {
        return construct(Class, arguments, getPrototypeOf(this).constructor)
      }
      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true,
        }
      });

      return setPrototypeOf(Wrapper, Class);
    }

    return _wrapNativeSuper(Class)
  }
`;
  helpers.instanceof = helper('7.0.0-beta.0')`
  export default function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
      return !!right[Symbol.hasInstance](left);
    } else {
      return left instanceof right;
    }
  }
`;
  helpers.interopRequireDefault = helper('7.0.0-beta.0')`
  export default function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
`;
  helpers.interopRequireWildcard = helper('7.14.0')`
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;

    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function (nodeInterop) {
      return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
  }

  export default function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
      return obj;
    }

    if (obj === null || (typeof obj !== "object" && typeof obj !== "function")) {
      return { default: obj }
    }

    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }

    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
`;
  helpers.newArrowCheck = helper('7.0.0-beta.0')`
  export default function _newArrowCheck(innerThis, boundThis) {
    if (innerThis !== boundThis) {
      throw new TypeError("Cannot instantiate an arrow function");
    }
  }
`;
  helpers.objectDestructuringEmpty = helper('7.0.0-beta.0')`
  export default function _objectDestructuringEmpty(obj) {
    if (obj == null) throw new TypeError("Cannot destructure undefined");
  }
`;
  helpers.objectWithoutPropertiesLoose = helper('7.0.0-beta.0')`
  export default function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};

    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }
`;
  helpers.objectWithoutProperties = helper('7.0.0-beta.0')`
  import objectWithoutPropertiesLoose from "objectWithoutPropertiesLoose";

  export default function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = objectWithoutPropertiesLoose(source, excluded);
    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }
`;
  helpers.assertThisInitialized = helper('7.0.0-beta.0')`
  export default function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
`;
  helpers.possibleConstructorReturn = helper('7.0.0-beta.0')`
  import assertThisInitialized from "assertThisInitialized";

  export default function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }

    return assertThisInitialized(self);
  }
`;
  helpers.createSuper = helper('7.9.0')`
  import getPrototypeOf from "getPrototypeOf";
  import isNativeReflectConstruct from "isNativeReflectConstruct";
  import possibleConstructorReturn from "possibleConstructorReturn";

  export default function _createSuper(Derived) {
    var hasNativeReflectConstruct = isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = getPrototypeOf(Derived), result;
      if (hasNativeReflectConstruct) {
        // NOTE: This doesn't work if this.__proto__.constructor has been modified.
        var NewTarget = getPrototypeOf(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return possibleConstructorReturn(this, result);
    }
  }
 `;
  helpers.superPropBase = helper('7.0.0-beta.0')`
  import getPrototypeOf from "getPrototypeOf";

  export default function _superPropBase(object, property) {
    // Yes, this throws if object is null to being with, that's on purpose.
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = getPrototypeOf(object);
      if (object === null) break;
    }
    return object;
  }
`;
  helpers.get = helper('7.0.0-beta.0')`
  import superPropBase from "superPropBase";

  export default function _get() {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get.bind();
    } else {
      _get = function _get(target, property, receiver) {
        var base = superPropBase(target, property);

        if (!base) return;

        var desc = Object.getOwnPropertyDescriptor(base, property);
        if (desc.get) {
          // STEP 3. If receiver is not present, then set receiver to target.
          return desc.get.call(arguments.length < 3 ? target : receiver);
        }

        return desc.value;
      };
    }
    return _get.apply(this, arguments);
  }
`;
  helpers.set = helper('7.0.0-beta.0')`
  import superPropBase from "superPropBase";
  import defineProperty from "defineProperty";

  function set(target, property, value, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.set) {
      set = Reflect.set;
    } else {
      set = function set(target, property, value, receiver) {
        var base = superPropBase(target, property);
        var desc;

        if (base) {
          desc = Object.getOwnPropertyDescriptor(base, property);
          if (desc.set) {
            desc.set.call(receiver, value);
            return true;
          } else if (!desc.writable) {
            // Both getter and non-writable fall into this.
            return false;
          }
        }

        // Without a super that defines the property, spec boils down to
        // "define on receiver" for some reason.
        desc = Object.getOwnPropertyDescriptor(receiver, property);
        if (desc) {
          if (!desc.writable) {
            // Setter, getter, and non-writable fall into this.
            return false;
          }

          desc.value = value;
          Object.defineProperty(receiver, property, desc);
        } else {
          // Avoid setters that may be defined on Sub's prototype, but not on
          // the instance.
          defineProperty(receiver, property, value);
        }

        return true;
      };
    }

    return set(target, property, value, receiver);
  }

  export default function _set(target, property, value, receiver, isStrict) {
    var s = set(target, property, value, receiver || target);
    if (!s && isStrict) {
      throw new Error('failed to set property');
    }

    return value;
  }
`;
  helpers.taggedTemplateLiteral = helper('7.0.0-beta.0')`
  export default function _taggedTemplateLiteral(strings, raw) {
    if (!raw) { raw = strings.slice(0); }
    return Object.freeze(Object.defineProperties(strings, {
        raw: { value: Object.freeze(raw) }
    }));
  }
`;
  helpers.taggedTemplateLiteralLoose = helper('7.0.0-beta.0')`
  export default function _taggedTemplateLiteralLoose(strings, raw) {
    if (!raw) { raw = strings.slice(0); }
    strings.raw = raw;
    return strings;
  }
`;
  helpers.readOnlyError = helper('7.0.0-beta.0')`
  export default function _readOnlyError(name) {
    throw new TypeError("\\"" + name + "\\" is read-only");
  }
`;
  helpers.writeOnlyError = helper('7.12.13')`
  export default function _writeOnlyError(name) {
    throw new TypeError("\\"" + name + "\\" is write-only");
  }
`;
  helpers.classNameTDZError = helper('7.0.0-beta.0')`
  export default function _classNameTDZError(name) {
    throw new Error("Class \\"" + name + "\\" cannot be referenced in computed property keys.");
  }
`;
  helpers.temporalUndefined = helper('7.0.0-beta.0')`
  // This function isn't mean to be called, but to be used as a reference.
  // We can't use a normal object because it isn't hoisted.
  export default function _temporalUndefined() {}
`;
  helpers.tdz = helper('7.5.5')`
  export default function _tdzError(name) {
    throw new ReferenceError(name + " is not defined - temporal dead zone");
  }
`;
  helpers.temporalRef = helper('7.0.0-beta.0')`
  import undef from "temporalUndefined";
  import err from "tdz";

  export default function _temporalRef(val, name) {
    return val === undef ? err(name) : val;
  }
`;
  helpers.slicedToArray = helper('7.0.0-beta.0')`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArrayLimit from "iterableToArrayLimit";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _slicedToArray(arr, i) {
    return (
      arrayWithHoles(arr) ||
      iterableToArrayLimit(arr, i) ||
      unsupportedIterableToArray(arr, i) ||
      nonIterableRest()
    );
  }
`;
  helpers.slicedToArrayLoose = helper('7.0.0-beta.0')`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArrayLimitLoose from "iterableToArrayLimitLoose";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _slicedToArrayLoose(arr, i) {
    return (
      arrayWithHoles(arr) ||
      iterableToArrayLimitLoose(arr, i) ||
      unsupportedIterableToArray(arr, i) ||
      nonIterableRest()
    );
  }
`;
  helpers.toArray = helper('7.0.0-beta.0')`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArray from "iterableToArray";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _toArray(arr) {
    return (
      arrayWithHoles(arr) ||
      iterableToArray(arr) ||
      unsupportedIterableToArray(arr) ||
      nonIterableRest()
    );
  }
`;
  helpers.toConsumableArray = helper('7.0.0-beta.0')`
  import arrayWithoutHoles from "arrayWithoutHoles";
  import iterableToArray from "iterableToArray";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableSpread from "nonIterableSpread";

  export default function _toConsumableArray(arr) {
    return (
      arrayWithoutHoles(arr) ||
      iterableToArray(arr) ||
      unsupportedIterableToArray(arr) ||
      nonIterableSpread()
    );
  }
`;
  helpers.arrayWithoutHoles = helper('7.0.0-beta.0')`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return arrayLikeToArray(arr);
  }
`;
  helpers.arrayWithHoles = helper('7.0.0-beta.0')`
  export default function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }
`;
  helpers.maybeArrayLike = helper('7.9.0')`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _maybeArrayLike(next, arr, i) {
    if (arr && !Array.isArray(arr) && typeof arr.length === "number") {
      var len = arr.length;
      return arrayLikeToArray(arr, i !== void 0 && i < len ? i : len);
    }
    return next(arr, i);
  }
`;
  helpers.iterableToArray = helper('7.0.0-beta.0')`
  export default function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }
`;
  helpers.iterableToArrayLimit = helper('7.0.0-beta.0')`
  export default function _iterableToArrayLimit(arr, i) {
    // this is an expanded form of \`for...of\` that properly supports abrupt completions of
    // iterators etc. variable names have been minimised to reduce the size of this massive
    // helper. sometimes spec compliance is annoying :(
    //
    // _n = _iteratorNormalCompletion
    // _d = _didIteratorError
    // _e = _iteratorError
    // _i = _iterator
    // _s = _step

    var _i = arr == null ? null : (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);
    if (_i == null) return;

    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
      for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);
        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
`;
  helpers.iterableToArrayLimitLoose = helper('7.0.0-beta.0')`
  export default function _iterableToArrayLimitLoose(arr, i) {
    var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]);
    if (_i == null) return;

    var _arr = [];
    for (_i = _i.call(arr), _step; !(_step = _i.next()).done;) {
      _arr.push(_step.value);
      if (i && _arr.length === i) break;
    }
    return _arr;
  }
`;
  helpers.unsupportedIterableToArray = helper('7.9.0')`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return arrayLikeToArray(o, minLen);
  }
`;
  helpers.arrayLikeToArray = helper('7.9.0')`
  export default function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
    return arr2;
  }
`;
  helpers.nonIterableSpread = helper('7.0.0-beta.0')`
  export default function _nonIterableSpread() {
    throw new TypeError(
      "Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }
`;
  helpers.nonIterableRest = helper('7.0.0-beta.0')`
  export default function _nonIterableRest() {
    throw new TypeError(
      "Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }
`;
  helpers.createForOfIteratorHelper = helper('7.9.0')`
  import unsupportedIterableToArray from "unsupportedIterableToArray";

  // s: start (create the iterator)
  // n: next
  // e: error (called whenever something throws)
  // f: finish (always called at the end)

  export default function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (!it) {
      // Fallback for engines without symbol support
      if (
        Array.isArray(o) ||
        (it = unsupportedIterableToArray(o)) ||
        (allowArrayLike && o && typeof o.length === "number")
      ) {
        if (it) o = it;
        var i = 0;
        var F = function(){};
        return {
          s: F,
          n: function() {
            if (i >= o.length) return { done: true };
            return { done: false, value: o[i++] };
          },
          e: function(e) { throw e; },
          f: F,
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true, didErr = false, err;

    return {
      s: function() {
        it = it.call(o);
      },
      n: function() {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function(e) {
        didErr = true;
        err = e;
      },
      f: function() {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }
`;
  helpers.createForOfIteratorHelperLoose = helper('7.9.0')`
  import unsupportedIterableToArray from "unsupportedIterableToArray";

  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (it) return (it = it.call(o)).next.bind(it);

    // Fallback for engines without symbol support
    if (
      Array.isArray(o) ||
      (it = unsupportedIterableToArray(o)) ||
      (allowArrayLike && o && typeof o.length === "number")
    ) {
      if (it) o = it;
      var i = 0;
      return function() {
        if (i >= o.length) return { done: true };
        return { done: false, value: o[i++] };
      }
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
`;
  helpers.skipFirstGeneratorNext = helper('7.0.0-beta.0')`
  export default function _skipFirstGeneratorNext(fn) {
    return function () {
      var it = fn.apply(this, arguments);
      it.next();
      return it;
    }
  }
`;
  helpers.toPrimitive = helper('7.1.5')`
  export default function _toPrimitive(
    input,
    hint /*: "default" | "string" | "number" | void */
  ) {
    if (typeof input !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
      var res = prim.call(input, hint || "default");
      if (typeof res !== "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
`;
  helpers.toPropertyKey = helper('7.1.5')`
  import toPrimitive from "toPrimitive";

  export default function _toPropertyKey(arg) {
    var key = toPrimitive(arg, "string");
    return typeof key === "symbol" ? key : String(key);
  }
`;
  helpers.initializerWarningHelper = helper('7.0.0-beta.0')`
    export default function _initializerWarningHelper(descriptor, context){
        throw new Error(
          'Decorating class property failed. Please ensure that ' +
          'proposal-class-properties is enabled and runs after the decorators transform.'
        );
    }
`;
  helpers.initializerDefineProperty = helper('7.0.0-beta.0')`
    export default function _initializerDefineProperty(target, property, descriptor, context){
        if (!descriptor) return;

        Object.defineProperty(target, property, {
            enumerable: descriptor.enumerable,
            configurable: descriptor.configurable,
            writable: descriptor.writable,
            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0,
        });
    }
`;
  helpers.applyDecoratedDescriptor = helper('7.0.0-beta.0')`
    export default function _applyDecoratedDescriptor(target, property, decorators, descriptor, context){
        var desc = {};
        Object.keys(descriptor).forEach(function(key){
            desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;
        if ('value' in desc || desc.initializer){
            desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function(desc, decorator){
            return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0){
            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
            desc.initializer = undefined;
        }

        if (desc.initializer === void 0){
            Object.defineProperty(target, property, desc);
            desc = null;
        }

        return desc;
    }
`;
  helpers.classPrivateFieldLooseKey = helper('7.0.0-beta.0')`
  var id = 0;
  export default function _classPrivateFieldKey(name) {
    return "__private_" + (id++) + "_" + name;
  }
`;
  helpers.classPrivateFieldLooseBase = helper('7.0.0-beta.0')`
  export default function _classPrivateFieldBase(receiver, privateKey) {
    if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {
      throw new TypeError("attempted to use private field on non-instance");
    }
    return receiver;
  }
`;
  helpers.classPrivateFieldGet = helper('7.0.0-beta.0')`
  import classApplyDescriptorGet from "classApplyDescriptorGet";
  import classExtractFieldDescriptor from "classExtractFieldDescriptor";
  export default function _classPrivateFieldGet(receiver, privateMap) {
    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "get");
    return classApplyDescriptorGet(receiver, descriptor);
  }
`;
  helpers.classPrivateFieldSet = helper('7.0.0-beta.0')`
  import classApplyDescriptorSet from "classApplyDescriptorSet";
  import classExtractFieldDescriptor from "classExtractFieldDescriptor";
  export default function _classPrivateFieldSet(receiver, privateMap, value) {
    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "set");
    classApplyDescriptorSet(receiver, descriptor, value);
    return value;
  }
`;
  helpers.classPrivateFieldDestructureSet = helper('7.4.4')`
  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";
  import classExtractFieldDescriptor from "classExtractFieldDescriptor";
  export default function _classPrivateFieldDestructureSet(receiver, privateMap) {
    var descriptor = classExtractFieldDescriptor(receiver, privateMap, "set");
    return classApplyDescriptorDestructureSet(receiver, descriptor);
  }
`;
  helpers.classExtractFieldDescriptor = helper('7.13.10')`
  export default function _classExtractFieldDescriptor(receiver, privateMap, action) {
    if (!privateMap.has(receiver)) {
      throw new TypeError("attempted to " + action + " private field on non-instance");
    }
    return privateMap.get(receiver);
  }
`;
  helpers.classStaticPrivateFieldSpecGet = helper('7.0.2')`
  import classApplyDescriptorGet from "classApplyDescriptorGet";
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldSpecGet(receiver, classConstructor, descriptor) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    classCheckPrivateStaticFieldDescriptor(descriptor, "get");
    return classApplyDescriptorGet(receiver, descriptor);
  }
`;
  helpers.classStaticPrivateFieldSpecSet = helper('7.0.2')`
  import classApplyDescriptorSet from "classApplyDescriptorSet";
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldSpecSet(receiver, classConstructor, descriptor, value) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    classCheckPrivateStaticFieldDescriptor(descriptor, "set");
    classApplyDescriptorSet(receiver, descriptor, value);
    return value;
  }
`;
  helpers.classStaticPrivateMethodGet = helper('7.3.2')`
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  export default function _classStaticPrivateMethodGet(receiver, classConstructor, method) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    return method;
  }
`;
  helpers.classStaticPrivateMethodSet = helper('7.3.2')`
  export default function _classStaticPrivateMethodSet() {
    throw new TypeError("attempted to set read only static private field");
  }
`;
  helpers.classApplyDescriptorGet = helper('7.13.10')`
  export default function _classApplyDescriptorGet(receiver, descriptor) {
    if (descriptor.get) {
      return descriptor.get.call(receiver);
    }
    return descriptor.value;
  }
`;
  helpers.classApplyDescriptorSet = helper('7.13.10')`
  export default function _classApplyDescriptorSet(receiver, descriptor, value) {
    if (descriptor.set) {
      descriptor.set.call(receiver, value);
    } else {
      if (!descriptor.writable) {
        // This should only throw in strict mode, but class bodies are
        // always strict and private fields can only be used inside
        // class bodies.
        throw new TypeError("attempted to set read only private field");
      }
      descriptor.value = value;
    }
  }
`;
  helpers.classApplyDescriptorDestructureSet = helper('7.13.10')`
  export default function _classApplyDescriptorDestructureSet(receiver, descriptor) {
    if (descriptor.set) {
      if (!("__destrObj" in descriptor)) {
        descriptor.__destrObj = {
          set value(v) {
            descriptor.set.call(receiver, v)
          },
        };
      }
      return descriptor.__destrObj;
    } else {
      if (!descriptor.writable) {
        // This should only throw in strict mode, but class bodies are
        // always strict and private fields can only be used inside
        // class bodies.
        throw new TypeError("attempted to set read only private field");
      }

      return descriptor;
    }
  }
`;
  helpers.classStaticPrivateFieldDestructureSet = helper('7.13.10')`
  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";
  import classCheckPrivateStaticAccess from "classCheckPrivateStaticAccess";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldDestructureSet(receiver, classConstructor, descriptor) {
    classCheckPrivateStaticAccess(receiver, classConstructor);
    classCheckPrivateStaticFieldDescriptor(descriptor, "set");
    return classApplyDescriptorDestructureSet(receiver, descriptor);
  }
`;
  helpers.classCheckPrivateStaticAccess = helper('7.13.10')`
  export default function _classCheckPrivateStaticAccess(receiver, classConstructor) {
    if (receiver !== classConstructor) {
      throw new TypeError("Private static access of wrong provenance");
    }
  }
`;
  helpers.classCheckPrivateStaticFieldDescriptor = helper('7.13.10')`
  export default function _classCheckPrivateStaticFieldDescriptor(descriptor, action) {
    if (descriptor === undefined) {
      throw new TypeError("attempted to " + action + " private static field before its declaration");
    }
  }
`;
  helpers.decorate = helper('7.1.5')`
  import toArray from "toArray";
  import toPropertyKey from "toPropertyKey";

  // These comments are stripped by @babel/template
  /*::
  type PropertyDescriptor =
    | {
        value: any,
        writable: boolean,
        configurable: boolean,
        enumerable: boolean,
      }
    | {
        get?: () => any,
        set?: (v: any) => void,
        configurable: boolean,
        enumerable: boolean,
      };

  type FieldDescriptor ={
    writable: boolean,
    configurable: boolean,
    enumerable: boolean,
  };

  type Placement = "static" | "prototype" | "own";
  type Key = string | symbol; // PrivateName is not supported yet.

  type ElementDescriptor =
    | {
        kind: "method",
        key: Key,
        placement: Placement,
        descriptor: PropertyDescriptor
      }
    | {
        kind: "field",
        key: Key,
        placement: Placement,
        descriptor: FieldDescriptor,
        initializer?: () => any,
      };

  // This is exposed to the user code
  type ElementObjectInput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
  };

  // This is exposed to the user code
  type ElementObjectOutput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
    extras?: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  // This is exposed to the user code
  type ClassObject = {
    [@@toStringTag]?: "Descriptor",
    kind: "class",
    elements: ElementDescriptor[],
  };

  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;
  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;
  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;

  // Only used by Babel in the transform output, not part of the spec.
  type ElementDefinition =
    | {
        kind: "method",
        value: any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
      }
    | {
        kind: "field",
        value: () => any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
    };

  declare function ClassFactory<C>(initialize: (instance: C) => void): {
    F: Class<C>,
    d: ElementDefinition[]
  }

  */

  /*::
  // Various combinations with/without extras and with one or many finishers

  type ElementFinisherExtras = {
    element: ElementDescriptor,
    finisher?: ClassFinisher,
    extras?: ElementDescriptor[],
  };

  type ElementFinishersExtras = {
    element: ElementDescriptor,
    finishers: ClassFinisher[],
    extras: ElementDescriptor[],
  };

  type ElementsFinisher = {
    elements: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  type ElementsFinishers = {
    elements: ElementDescriptor[],
    finishers: ClassFinisher[],
  };

  */

  /*::

  type Placements = {
    static: Key[],
    prototype: Key[],
    own: Key[],
  };

  */

  // ClassDefinitionEvaluation (Steps 26-*)
  export default function _decorate(
    decorators /*: ClassDecorator[] */,
    factory /*: ClassFactory */,
    superClass /*: ?Class<*> */,
    mixins /*: ?Array<Function> */,
  ) /*: Class<*> */ {
    var api = _getDecoratorsApi();
    if (mixins) {
      for (var i = 0; i < mixins.length; i++) {
        api = mixins[i](api);
      }
    }

    var r = factory(function initialize(O) {
      api.initializeInstanceElements(O, decorated.elements);
    }, superClass);
    var decorated = api.decorateClass(
      _coalesceClassElements(r.d.map(_createElementDescriptor)),
      decorators,
    );

    api.initializeClassElements(r.F, decorated.elements);

    return api.runClassFinishers(r.F, decorated.finishers);
  }

  function _getDecoratorsApi() {
    _getDecoratorsApi = function() {
      return api;
    };

    var api = {
      elementsDefinitionOrder: [["method"], ["field"]],

      // InitializeInstanceElements
      initializeInstanceElements: function(
        /*::<C>*/ O /*: C */,
        elements /*: ElementDescriptor[] */,
      ) {
        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            if (element.kind === kind && element.placement === "own") {
              this.defineClassElement(O, element);
            }
          }, this);
        }, this);
      },

      // InitializeClassElements
      initializeClassElements: function(
        /*::<C>*/ F /*: Class<C> */,
        elements /*: ElementDescriptor[] */,
      ) {
        var proto = F.prototype;

        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            var placement = element.placement;
            if (
              element.kind === kind &&
              (placement === "static" || placement === "prototype")
            ) {
              var receiver = placement === "static" ? F : proto;
              this.defineClassElement(receiver, element);
            }
          }, this);
        }, this);
      },

      // DefineClassElement
      defineClassElement: function(
        /*::<C>*/ receiver /*: C | Class<C> */,
        element /*: ElementDescriptor */,
      ) {
        var descriptor /*: PropertyDescriptor */ = element.descriptor;
        if (element.kind === "field") {
          var initializer = element.initializer;
          descriptor = {
            enumerable: descriptor.enumerable,
            writable: descriptor.writable,
            configurable: descriptor.configurable,
            value: initializer === void 0 ? void 0 : initializer.call(receiver),
          };
        }
        Object.defineProperty(receiver, element.key, descriptor);
      },

      // DecorateClass
      decorateClass: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var newElements /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];
        var placements /*: Placements */ = {
          static: [],
          prototype: [],
          own: [],
        };

        elements.forEach(function(element /*: ElementDescriptor */) {
          this.addElementPlacement(element, placements);
        }, this);

        elements.forEach(function(element /*: ElementDescriptor */) {
          if (!_hasDecorators(element)) return newElements.push(element);

          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(
            element,
            placements,
          );
          newElements.push(elementFinishersExtras.element);
          newElements.push.apply(newElements, elementFinishersExtras.extras);
          finishers.push.apply(finishers, elementFinishersExtras.finishers);
        }, this);

        if (!decorators) {
          return { elements: newElements, finishers: finishers };
        }

        var result /*: ElementsFinishers */ = this.decorateConstructor(
          newElements,
          decorators,
        );
        finishers.push.apply(finishers, result.finishers);
        result.finishers = finishers;

        return result;
      },

      // AddElementPlacement
      addElementPlacement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
        silent /*: boolean */,
      ) {
        var keys = placements[element.placement];
        if (!silent && keys.indexOf(element.key) !== -1) {
          throw new TypeError("Duplicated element (" + element.key + ")");
        }
        keys.push(element.key);
      },

      // DecorateElement
      decorateElement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
      ) /*: ElementFinishersExtras */ {
        var extras /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];

        for (
          var decorators = element.decorators, i = decorators.length - 1;
          i >= 0;
          i--
        ) {
          // (inlined) RemoveElementPlacement
          var keys = placements[element.placement];
          keys.splice(keys.indexOf(element.key), 1);

          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(
            element,
          );
          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(
            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||
              elementObject,
          );

          element = elementFinisherExtras.element;
          this.addElementPlacement(element, placements);

          if (elementFinisherExtras.finisher) {
            finishers.push(elementFinisherExtras.finisher);
          }

          var newExtras /*: ElementDescriptor[] | void */ =
            elementFinisherExtras.extras;
          if (newExtras) {
            for (var j = 0; j < newExtras.length; j++) {
              this.addElementPlacement(newExtras[j], placements);
            }
            extras.push.apply(extras, newExtras);
          }
        }

        return { element: element, finishers: finishers, extras: extras };
      },

      // DecorateConstructor
      decorateConstructor: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var finishers /*: ClassFinisher[] */ = [];

        for (var i = decorators.length - 1; i >= 0; i--) {
          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);
          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(
            (0, decorators[i])(obj) /*: ClassObject */ || obj,
          );

          if (elementsAndFinisher.finisher !== undefined) {
            finishers.push(elementsAndFinisher.finisher);
          }

          if (elementsAndFinisher.elements !== undefined) {
            elements = elementsAndFinisher.elements;

            for (var j = 0; j < elements.length - 1; j++) {
              for (var k = j + 1; k < elements.length; k++) {
                if (
                  elements[j].key === elements[k].key &&
                  elements[j].placement === elements[k].placement
                ) {
                  throw new TypeError(
                    "Duplicated element (" + elements[j].key + ")",
                  );
                }
              }
            }
          }
        }

        return { elements: elements, finishers: finishers };
      },

      // FromElementDescriptor
      fromElementDescriptor: function(
        element /*: ElementDescriptor */,
      ) /*: ElementObject */ {
        var obj /*: ElementObject */ = {
          kind: element.kind,
          key: element.key,
          placement: element.placement,
          descriptor: element.descriptor,
        };

        var desc = {
          value: "Descriptor",
          configurable: true,
        };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        if (element.kind === "field") obj.initializer = element.initializer;

        return obj;
      },

      // ToElementDescriptors
      toElementDescriptors: function(
        elementObjects /*: ElementObject[] */,
      ) /*: ElementDescriptor[] */ {
        if (elementObjects === undefined) return;
        return toArray(elementObjects).map(function(elementObject) {
          var element = this.toElementDescriptor(elementObject);
          this.disallowProperty(elementObject, "finisher", "An element descriptor");
          this.disallowProperty(elementObject, "extras", "An element descriptor");
          return element;
        }, this);
      },

      // ToElementDescriptor
      toElementDescriptor: function(
        elementObject /*: ElementObject */,
      ) /*: ElementDescriptor */ {
        var kind = String(elementObject.kind);
        if (kind !== "method" && kind !== "field") {
          throw new TypeError(
            'An element descriptor\\'s .kind property must be either "method" or' +
              ' "field", but a decorator created an element descriptor with' +
              ' .kind "' +
              kind +
              '"',
          );
        }

        var key = toPropertyKey(elementObject.key);

        var placement = String(elementObject.placement);
        if (
          placement !== "static" &&
          placement !== "prototype" &&
          placement !== "own"
        ) {
          throw new TypeError(
            'An element descriptor\\'s .placement property must be one of "static",' +
              ' "prototype" or "own", but a decorator created an element descriptor' +
              ' with .placement "' +
              placement +
              '"',
          );
        }

        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;

        this.disallowProperty(elementObject, "elements", "An element descriptor");

        var element /*: ElementDescriptor */ = {
          kind: kind,
          key: key,
          placement: placement,
          descriptor: Object.assign({}, descriptor),
        };

        if (kind !== "field") {
          this.disallowProperty(elementObject, "initializer", "A method descriptor");
        } else {
          this.disallowProperty(
            descriptor,
            "get",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "set",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "value",
            "The property descriptor of a field descriptor",
          );

          element.initializer = elementObject.initializer;
        }

        return element;
      },

      toElementFinisherExtras: function(
        elementObject /*: ElementObject */,
      ) /*: ElementFinisherExtras */ {
        var element /*: ElementDescriptor */ = this.toElementDescriptor(
          elementObject,
        );
        var finisher /*: ClassFinisher */ = _optionalCallableProperty(
          elementObject,
          "finisher",
        );
        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(
          elementObject.extras,
        );

        return { element: element, finisher: finisher, extras: extras };
      },

      // FromClassDescriptor
      fromClassDescriptor: function(
        elements /*: ElementDescriptor[] */,
      ) /*: ClassObject */ {
        var obj = {
          kind: "class",
          elements: elements.map(this.fromElementDescriptor, this),
        };

        var desc = { value: "Descriptor", configurable: true };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        return obj;
      },

      // ToClassDescriptor
      toClassDescriptor: function(
        obj /*: ClassObject */,
      ) /*: ElementsFinisher */ {
        var kind = String(obj.kind);
        if (kind !== "class") {
          throw new TypeError(
            'A class descriptor\\'s .kind property must be "class", but a decorator' +
              ' created a class descriptor with .kind "' +
              kind +
              '"',
          );
        }

        this.disallowProperty(obj, "key", "A class descriptor");
        this.disallowProperty(obj, "placement", "A class descriptor");
        this.disallowProperty(obj, "descriptor", "A class descriptor");
        this.disallowProperty(obj, "initializer", "A class descriptor");
        this.disallowProperty(obj, "extras", "A class descriptor");

        var finisher = _optionalCallableProperty(obj, "finisher");
        var elements = this.toElementDescriptors(obj.elements);

        return { elements: elements, finisher: finisher };
      },

      // RunClassFinishers
      runClassFinishers: function(
        constructor /*: Class<*> */,
        finishers /*: ClassFinisher[] */,
      ) /*: Class<*> */ {
        for (var i = 0; i < finishers.length; i++) {
          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);
          if (newConstructor !== undefined) {
            // NOTE: This should check if IsConstructor(newConstructor) is false.
            if (typeof newConstructor !== "function") {
              throw new TypeError("Finishers must return a constructor.");
            }
            constructor = newConstructor;
          }
        }
        return constructor;
      },

      disallowProperty: function(obj, name, objectType) {
        if (obj[name] !== undefined) {
          throw new TypeError(objectType + " can't have a ." + name + " property.");
        }
      }
    };

    return api;
  }

  // ClassElementEvaluation
  function _createElementDescriptor(
    def /*: ElementDefinition */,
  ) /*: ElementDescriptor */ {
    var key = toPropertyKey(def.key);

    var descriptor /*: PropertyDescriptor */;
    if (def.kind === "method") {
      descriptor = {
        value: def.value,
        writable: true,
        configurable: true,
        enumerable: false,
      };
    } else if (def.kind === "get") {
      descriptor = { get: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "set") {
      descriptor = { set: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "field") {
      descriptor = { configurable: true, writable: true, enumerable: true };
    }

    var element /*: ElementDescriptor */ = {
      kind: def.kind === "field" ? "field" : "method",
      key: key,
      placement: def.static
        ? "static"
        : def.kind === "field"
        ? "own"
        : "prototype",
      descriptor: descriptor,
    };
    if (def.decorators) element.decorators = def.decorators;
    if (def.kind === "field") element.initializer = def.value;

    return element;
  }

  // CoalesceGetterSetter
  function _coalesceGetterSetter(
    element /*: ElementDescriptor */,
    other /*: ElementDescriptor */,
  ) {
    if (element.descriptor.get !== undefined) {
      other.descriptor.get = element.descriptor.get;
    } else {
      other.descriptor.set = element.descriptor.set;
    }
  }

  // CoalesceClassElements
  function _coalesceClassElements(
    elements /*: ElementDescriptor[] */,
  ) /*: ElementDescriptor[] */ {
    var newElements /*: ElementDescriptor[] */ = [];

    var isSameElement = function(
      other /*: ElementDescriptor */,
    ) /*: boolean */ {
      return (
        other.kind === "method" &&
        other.key === element.key &&
        other.placement === element.placement
      );
    };

    for (var i = 0; i < elements.length; i++) {
      var element /*: ElementDescriptor */ = elements[i];
      var other /*: ElementDescriptor */;

      if (
        element.kind === "method" &&
        (other = newElements.find(isSameElement))
      ) {
        if (
          _isDataDescriptor(element.descriptor) ||
          _isDataDescriptor(other.descriptor)
        ) {
          if (_hasDecorators(element) || _hasDecorators(other)) {
            throw new ReferenceError(
              "Duplicated methods (" + element.key + ") can't be decorated.",
            );
          }
          other.descriptor = element.descriptor;
        } else {
          if (_hasDecorators(element)) {
            if (_hasDecorators(other)) {
              throw new ReferenceError(
                "Decorators can't be placed on different accessors with for " +
                  "the same property (" +
                  element.key +
                  ").",
              );
            }
            other.decorators = element.decorators;
          }
          _coalesceGetterSetter(element, other);
        }
      } else {
        newElements.push(element);
      }
    }

    return newElements;
  }

  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {
    return element.decorators && element.decorators.length;
  }

  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {
    return (
      desc !== undefined &&
      !(desc.value === undefined && desc.writable === undefined)
    );
  }

  function _optionalCallableProperty /*::<T>*/(
    obj /*: T */,
    name /*: $Keys<T> */,
  ) /*: ?Function */ {
    var value = obj[name];
    if (value !== undefined && typeof value !== "function") {
      throw new TypeError("Expected '" + name + "' to be a function");
    }
    return value;
  }

`;
  helpers.classPrivateMethodGet = helper('7.1.6')`
  export default function _classPrivateMethodGet(receiver, privateSet, fn) {
    if (!privateSet.has(receiver)) {
      throw new TypeError("attempted to get private field on non-instance");
    }
    return fn;
  }
`;
  helpers.checkPrivateRedeclaration = helper('7.14.1')`
  export default function _checkPrivateRedeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
      throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
  }
`;
  helpers.classPrivateFieldInitSpec = helper('7.14.1')`
  import checkPrivateRedeclaration from "checkPrivateRedeclaration";

  export default function _classPrivateFieldInitSpec(obj, privateMap, value) {
    checkPrivateRedeclaration(obj, privateMap);
    privateMap.set(obj, value);
  }
`;
  helpers.classPrivateMethodInitSpec = helper('7.14.1')`
  import checkPrivateRedeclaration from "checkPrivateRedeclaration";

  export default function _classPrivateMethodInitSpec(obj, privateSet) {
    checkPrivateRedeclaration(obj, privateSet);
    privateSet.add(obj);
  }
`;
  {
    helpers.classPrivateMethodSet = helper('7.1.6')`
    export default function _classPrivateMethodSet() {
      throw new TypeError("attempted to reassign private method");
    }
  `;
  }
  helpers.identity = helper('7.17.0')`
  export default function _identity(x) {
    return x;
  }
`;
  return helpers$2;
}
var hasRequiredLib$c;
function requireLib$c() {
  if (hasRequiredLib$c) return lib$o;
  hasRequiredLib$c = 1;
  Object.defineProperty(lib$o, '__esModule', {value: true});
  lib$o.default = void 0;
  lib$o.ensure = ensure;
  lib$o.get = get;
  lib$o.getDependencies = getDependencies;
  lib$o.list = void 0;
  lib$o.minVersion = minVersion;
  var _traverse = requireLib$h();
  var _t = t$d;
  var _helpers = requireHelpers();
  const {
    assignmentExpression: assignmentExpression,
    cloneNode: cloneNode,
    expressionStatement: expressionStatement,
    file: file,
    identifier: identifier,
  } = _t;
  function makePath(path) {
    const parts = [];
    for (; path.parentPath; path = path.parentPath) {
      parts.push(path.key);
      if (path.inList) parts.push(path.listKey);
    }
    return parts.reverse().join('.');
  }
  let FileClass = undefined;
  function getHelperMetadata(file) {
    const globals = new Set();
    const localBindingNames = new Set();
    const dependencies = new Map();
    let exportName;
    let exportPath;
    const exportBindingAssignments = [];
    const importPaths = [];
    const importBindingsReferences = [];
    const dependencyVisitor = {
      ImportDeclaration(child) {
        const name = child.node.source.value;
        if (!_helpers.default[name]) {
          throw child.buildCodeFrameError(`Unknown helper ${name}`);
        }
        if (
          child.get('specifiers').length !== 1 ||
          !child.get('specifiers.0').isImportDefaultSpecifier()
        ) {
          throw child.buildCodeFrameError(
            'Helpers can only import a default value'
          );
        }
        const bindingIdentifier = child.node.specifiers[0].local;
        dependencies.set(bindingIdentifier, name);
        importPaths.push(makePath(child));
      },
      ExportDefaultDeclaration(child) {
        const decl = child.get('declaration');
        if (!decl.isFunctionDeclaration() || !decl.node.id) {
          throw decl.buildCodeFrameError(
            'Helpers can only export named function declarations'
          );
        }
        exportName = decl.node.id.name;
        exportPath = makePath(child);
      },
      ExportAllDeclaration(child) {
        throw child.buildCodeFrameError('Helpers can only export default');
      },
      ExportNamedDeclaration(child) {
        throw child.buildCodeFrameError('Helpers can only export default');
      },
      Statement(child) {
        if (child.isModuleDeclaration()) return;
        child.skip();
      },
    };
    const referenceVisitor = {
      Program(path) {
        const bindings = path.scope.getAllBindings();
        Object.keys(bindings).forEach(name => {
          if (name === exportName) return;
          if (dependencies.has(bindings[name].identifier)) return;
          localBindingNames.add(name);
        });
      },
      ReferencedIdentifier(child) {
        const name = child.node.name;
        const binding = child.scope.getBinding(name);
        if (!binding) {
          globals.add(name);
        } else if (dependencies.has(binding.identifier)) {
          importBindingsReferences.push(makePath(child));
        }
      },
      AssignmentExpression(child) {
        const left = child.get('left');
        if (!(exportName in left.getBindingIdentifiers())) return;
        if (!left.isIdentifier()) {
          throw left.buildCodeFrameError(
            'Only simple assignments to exports are allowed in helpers'
          );
        }
        const binding = child.scope.getBinding(exportName);
        if (binding != null && binding.scope.path.isProgram()) {
          exportBindingAssignments.push(makePath(child));
        }
      },
    };
    (0, _traverse.default)(file.ast, dependencyVisitor, file.scope);
    (0, _traverse.default)(file.ast, referenceVisitor, file.scope);
    if (!exportPath) throw new Error('Helpers must have a default export.');
    exportBindingAssignments.reverse();
    return {
      globals: Array.from(globals),
      localBindingNames: Array.from(localBindingNames),
      dependencies: dependencies,
      exportBindingAssignments: exportBindingAssignments,
      exportPath: exportPath,
      exportName: exportName,
      importBindingsReferences: importBindingsReferences,
      importPaths: importPaths,
    };
  }
  function permuteHelperAST(file, metadata, id, localBindings, getDependency) {
    if (localBindings && !id) {
      throw new Error('Unexpected local bindings for module-based helpers.');
    }
    if (!id) return;
    const {
      localBindingNames: localBindingNames,
      dependencies: dependencies,
      exportBindingAssignments: exportBindingAssignments,
      exportPath: exportPath,
      exportName: exportName,
      importBindingsReferences: importBindingsReferences,
      importPaths: importPaths,
    } = metadata;
    const dependenciesRefs = {};
    dependencies.forEach((name, id) => {
      dependenciesRefs[id.name] =
        (typeof getDependency === 'function' && getDependency(name)) || id;
    });
    const toRename = {};
    const bindings = new Set(localBindings || []);
    localBindingNames.forEach(name => {
      let newName = name;
      while (bindings.has(newName)) newName = '_' + newName;
      if (newName !== name) toRename[name] = newName;
    });
    if (id.type === 'Identifier' && exportName !== id.name) {
      toRename[exportName] = id.name;
    }
    const {path: path} = file;
    const exp = path.get(exportPath);
    const imps = importPaths.map(p => path.get(p));
    const impsBindingRefs = importBindingsReferences.map(p => path.get(p));
    const decl = exp.get('declaration');
    if (id.type === 'Identifier') {
      exp.replaceWith(decl);
    } else if (id.type === 'MemberExpression') {
      exportBindingAssignments.forEach(assignPath => {
        const assign = path.get(assignPath);
        assign.replaceWith(assignmentExpression('=', id, assign.node));
      });
      exp.replaceWith(decl);
      path.pushContainer(
        'body',
        expressionStatement(
          assignmentExpression('=', id, identifier(exportName))
        )
      );
    } else {
      throw new Error('Unexpected helper format.');
    }
    Object.keys(toRename).forEach(name => {
      path.scope.rename(name, toRename[name]);
    });
    for (const path of imps) path.remove();
    for (const path of impsBindingRefs) {
      const node = cloneNode(dependenciesRefs[path.node.name]);
      path.replaceWith(node);
    }
  }
  const helperData = Object.create(null);
  function loadHelper(name) {
    if (!helperData[name]) {
      const helper = _helpers.default[name];
      if (!helper) {
        throw Object.assign(new ReferenceError(`Unknown helper ${name}`), {
          code: 'BABEL_HELPER_UNKNOWN',
          helper: name,
        });
      }
      const fn = () => {
        {
          if (!FileClass) {
            const fakeFile = {ast: file(helper.ast()), path: null};
            (0, _traverse.default)(fakeFile.ast, {
              Program: path => (fakeFile.path = path).stop(),
            });
            return fakeFile;
          }
        }
        return new FileClass(
          {filename: `babel-helper://${name}`},
          {
            ast: file(helper.ast()),
            code: '[internal Babel helper code]',
            inputMap: null,
          }
        );
      };
      let metadata = null;
      helperData[name] = {
        minVersion: helper.minVersion,
        build(getDependency, id, localBindings) {
          const file = fn();
          metadata || (metadata = getHelperMetadata(file));
          permuteHelperAST(file, metadata, id, localBindings, getDependency);
          return {nodes: file.ast.program.body, globals: metadata.globals};
        },
        getDependencies() {
          metadata || (metadata = getHelperMetadata(fn()));
          return Array.from(metadata.dependencies.values());
        },
      };
    }
    return helperData[name];
  }
  function get(name, getDependency, id, localBindings) {
    return loadHelper(name).build(getDependency, id, localBindings);
  }
  function minVersion(name) {
    return loadHelper(name).minVersion;
  }
  function getDependencies(name) {
    return loadHelper(name).getDependencies();
  }
  function ensure(name, newFileClass) {
    FileClass || (FileClass = newFileClass);
    loadHelper(name);
  }
  const list = Object.keys(_helpers.default).map(name =>
    name.replace(/^_/, '')
  );
  lib$o.list = list;
  var _default = get;
  lib$o.default = _default;
  return lib$o;
}
var lib$c = {};
var context$1 = {};
var path$2 = {};
var virtualTypes = {};
var hasRequiredVirtualTypes;
function requireVirtualTypes() {
  if (hasRequiredVirtualTypes) return virtualTypes;
  hasRequiredVirtualTypes = 1;
  Object.defineProperty(virtualTypes, '__esModule', {value: true});
  virtualTypes.ForAwaitStatement =
    virtualTypes.NumericLiteralTypeAnnotation =
    virtualTypes.ExistentialTypeParam =
    virtualTypes.SpreadProperty =
    virtualTypes.RestProperty =
    virtualTypes.Flow =
    virtualTypes.Pure =
    virtualTypes.Generated =
    virtualTypes.User =
    virtualTypes.Var =
    virtualTypes.BlockScoped =
    virtualTypes.Referenced =
    virtualTypes.Scope =
    virtualTypes.Expression =
    virtualTypes.Statement =
    virtualTypes.BindingIdentifier =
    virtualTypes.ReferencedMemberExpression =
    virtualTypes.ReferencedIdentifier =
      void 0;
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  const ReferencedIdentifier = {
    types: ['Identifier', 'JSXIdentifier'],
    checkPath(path, opts) {
      const {node: node, parent: parent} = path;
      if (
        !t.isIdentifier(node, opts) &&
        !t.isJSXMemberExpression(parent, opts)
      ) {
        if (t.isJSXIdentifier(node, opts)) {
          if (t.react.isCompatTag(node.name)) return false;
        } else {
          return false;
        }
      }
      return t.isReferenced(node, parent, path.parentPath.parent);
    },
  };
  virtualTypes.ReferencedIdentifier = ReferencedIdentifier;
  const ReferencedMemberExpression = {
    types: ['MemberExpression'],
    checkPath({node: node, parent: parent}) {
      return t.isMemberExpression(node) && t.isReferenced(node, parent);
    },
  };
  virtualTypes.ReferencedMemberExpression = ReferencedMemberExpression;
  const BindingIdentifier = {
    types: ['Identifier'],
    checkPath(path) {
      const {node: node, parent: parent} = path;
      const grandparent = path.parentPath.parent;
      return t.isIdentifier(node) && t.isBinding(node, parent, grandparent);
    },
  };
  virtualTypes.BindingIdentifier = BindingIdentifier;
  const Statement = {
    types: ['Statement'],
    checkPath({node: node, parent: parent}) {
      if (t.isStatement(node)) {
        if (t.isVariableDeclaration(node)) {
          if (t.isForXStatement(parent, {left: node})) return false;
          if (t.isForStatement(parent, {init: node})) return false;
        }
        return true;
      } else {
        return false;
      }
    },
  };
  virtualTypes.Statement = Statement;
  const Expression = {
    types: ['Expression'],
    checkPath(path) {
      if (path.isIdentifier()) {
        return path.isReferencedIdentifier();
      } else {
        return t.isExpression(path.node);
      }
    },
  };
  virtualTypes.Expression = Expression;
  const Scope = {
    types: ['Scopable'],
    checkPath(path) {
      return t.isScope(path.node, path.parent);
    },
  };
  virtualTypes.Scope = Scope;
  const Referenced = {
    checkPath(path) {
      return t.isReferenced(path.node, path.parent);
    },
  };
  virtualTypes.Referenced = Referenced;
  const BlockScoped = {
    checkPath(path) {
      return t.isBlockScoped(path.node);
    },
  };
  virtualTypes.BlockScoped = BlockScoped;
  const Var = {
    types: ['VariableDeclaration'],
    checkPath(path) {
      return t.isVar(path.node);
    },
  };
  virtualTypes.Var = Var;
  const User = {
    checkPath(path) {
      return path.node && !!path.node.loc;
    },
  };
  virtualTypes.User = User;
  const Generated = {
    checkPath(path) {
      return !path.isUser();
    },
  };
  virtualTypes.Generated = Generated;
  const Pure = {
    checkPath(path, opts) {
      return path.scope.isPure(path.node, opts);
    },
  };
  virtualTypes.Pure = Pure;
  const Flow = {
    types: [
      'Flow',
      'ImportDeclaration',
      'ExportDeclaration',
      'ImportSpecifier',
    ],
    checkPath({node: node}) {
      if (t.isFlow(node)) {
        return true;
      } else if (t.isImportDeclaration(node)) {
        return node.importKind === 'type' || node.importKind === 'typeof';
      } else if (t.isExportDeclaration(node)) {
        return node.exportKind === 'type';
      } else if (t.isImportSpecifier(node)) {
        return node.importKind === 'type' || node.importKind === 'typeof';
      } else {
        return false;
      }
    },
  };
  virtualTypes.Flow = Flow;
  const RestProperty = {
    types: ['RestElement'],
    checkPath(path) {
      return path.parentPath && path.parentPath.isObjectPattern();
    },
  };
  virtualTypes.RestProperty = RestProperty;
  const SpreadProperty = {
    types: ['RestElement'],
    checkPath(path) {
      return path.parentPath && path.parentPath.isObjectExpression();
    },
  };
  virtualTypes.SpreadProperty = SpreadProperty;
  const ExistentialTypeParam = {types: ['ExistsTypeAnnotation']};
  virtualTypes.ExistentialTypeParam = ExistentialTypeParam;
  const NumericLiteralTypeAnnotation = {types: ['NumberLiteralTypeAnnotation']};
  virtualTypes.NumericLiteralTypeAnnotation = NumericLiteralTypeAnnotation;
  const ForAwaitStatement = {
    types: ['ForOfStatement'],
    checkPath({node: node}) {
      return node.await === true;
    },
  };
  virtualTypes.ForAwaitStatement = ForAwaitStatement;
  return virtualTypes;
}
var scope = {};
var _baseFindIndex;
var hasRequired_baseFindIndex;
function require_baseFindIndex() {
  if (hasRequired_baseFindIndex) return _baseFindIndex;
  hasRequired_baseFindIndex = 1;
  function baseFindIndex(array, predicate, fromIndex, fromRight) {
    var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);
    while (fromRight ? index-- : ++index < length) {
      if (predicate(array[index], index, array)) {
        return index;
      }
    }
    return -1;
  }
  _baseFindIndex = baseFindIndex;
  return _baseFindIndex;
}
var _baseIsNaN;
var hasRequired_baseIsNaN;
function require_baseIsNaN() {
  if (hasRequired_baseIsNaN) return _baseIsNaN;
  hasRequired_baseIsNaN = 1;
  function baseIsNaN(value) {
    return value !== value;
  }
  _baseIsNaN = baseIsNaN;
  return _baseIsNaN;
}
var _strictIndexOf;
var hasRequired_strictIndexOf;
function require_strictIndexOf() {
  if (hasRequired_strictIndexOf) return _strictIndexOf;
  hasRequired_strictIndexOf = 1;
  function strictIndexOf(array, value, fromIndex) {
    var index = fromIndex - 1,
      length = array.length;
    while (++index < length) {
      if (array[index] === value) {
        return index;
      }
    }
    return -1;
  }
  _strictIndexOf = strictIndexOf;
  return _strictIndexOf;
}
var _baseIndexOf;
var hasRequired_baseIndexOf;
function require_baseIndexOf() {
  if (hasRequired_baseIndexOf) return _baseIndexOf;
  hasRequired_baseIndexOf = 1;
  var baseFindIndex = require_baseFindIndex(),
    baseIsNaN = require_baseIsNaN(),
    strictIndexOf = require_strictIndexOf();
  function baseIndexOf(array, value, fromIndex) {
    return value === value
      ? strictIndexOf(array, value, fromIndex)
      : baseFindIndex(array, baseIsNaN, fromIndex);
  }
  _baseIndexOf = baseIndexOf;
  return _baseIndexOf;
}
var _freeGlobal;
var hasRequired_freeGlobal;
function require_freeGlobal() {
  if (hasRequired_freeGlobal) return _freeGlobal;
  hasRequired_freeGlobal = 1;
  var freeGlobal =
    typeof commonjsGlobal == 'object' &&
    commonjsGlobal &&
    commonjsGlobal.Object === Object &&
    commonjsGlobal;
  _freeGlobal = freeGlobal;
  return _freeGlobal;
}
var _root;
var hasRequired_root;
function require_root() {
  if (hasRequired_root) return _root;
  hasRequired_root = 1;
  var freeGlobal = require_freeGlobal();
  var freeSelf =
    typeof self == 'object' && self && self.Object === Object && self;
  var root = freeGlobal || freeSelf || Function('return this')();
  _root = root;
  return _root;
}
var _Symbol;
var hasRequired_Symbol;
function require_Symbol() {
  if (hasRequired_Symbol) return _Symbol;
  hasRequired_Symbol = 1;
  var root = require_root();
  var Symbol = root.Symbol;
  _Symbol = Symbol;
  return _Symbol;
}
var _getRawTag;
var hasRequired_getRawTag;
function require_getRawTag() {
  if (hasRequired_getRawTag) return _getRawTag;
  hasRequired_getRawTag = 1;
  var Symbol = require_Symbol();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  var nativeObjectToString = objectProto.toString;
  var symToStringTag = Symbol ? Symbol.toStringTag : undefined;
  function getRawTag(value) {
    var isOwn = hasOwnProperty.call(value, symToStringTag),
      tag = value[symToStringTag];
    try {
      value[symToStringTag] = undefined;
      var unmasked = true;
    } catch (e) {}
    var result = nativeObjectToString.call(value);
    if (unmasked) {
      if (isOwn) {
        value[symToStringTag] = tag;
      } else {
        delete value[symToStringTag];
      }
    }
    return result;
  }
  _getRawTag = getRawTag;
  return _getRawTag;
}
var _objectToString;
var hasRequired_objectToString;
function require_objectToString() {
  if (hasRequired_objectToString) return _objectToString;
  hasRequired_objectToString = 1;
  var objectProto = Object.prototype;
  var nativeObjectToString = objectProto.toString;
  function objectToString(value) {
    return nativeObjectToString.call(value);
  }
  _objectToString = objectToString;
  return _objectToString;
}
var _baseGetTag;
var hasRequired_baseGetTag;
function require_baseGetTag() {
  if (hasRequired_baseGetTag) return _baseGetTag;
  hasRequired_baseGetTag = 1;
  var Symbol = require_Symbol(),
    getRawTag = require_getRawTag(),
    objectToString = require_objectToString();
  var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';
  var symToStringTag = Symbol ? Symbol.toStringTag : undefined;
  function baseGetTag(value) {
    if (value == null) {
      return value === undefined ? undefinedTag : nullTag;
    }
    return symToStringTag && symToStringTag in Object(value)
      ? getRawTag(value)
      : objectToString(value);
  }
  _baseGetTag = baseGetTag;
  return _baseGetTag;
}
var isObject_1;
var hasRequiredIsObject;
function requireIsObject() {
  if (hasRequiredIsObject) return isObject_1;
  hasRequiredIsObject = 1;
  function isObject(value) {
    var type = typeof value;
    return value != null && (type == 'object' || type == 'function');
  }
  isObject_1 = isObject;
  return isObject_1;
}
var isFunction_1;
var hasRequiredIsFunction;
function requireIsFunction() {
  if (hasRequiredIsFunction) return isFunction_1;
  hasRequiredIsFunction = 1;
  var baseGetTag = require_baseGetTag(),
    isObject = requireIsObject();
  var asyncTag = '[object AsyncFunction]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';
  function isFunction(value) {
    if (!isObject(value)) {
      return false;
    }
    var tag = baseGetTag(value);
    return (
      tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag
    );
  }
  isFunction_1 = isFunction;
  return isFunction_1;
}
var isLength_1;
var hasRequiredIsLength;
function requireIsLength() {
  if (hasRequiredIsLength) return isLength_1;
  hasRequiredIsLength = 1;
  var MAX_SAFE_INTEGER = 9007199254740991;
  function isLength(value) {
    return (
      typeof value == 'number' &&
      value > -1 &&
      value % 1 == 0 &&
      value <= MAX_SAFE_INTEGER
    );
  }
  isLength_1 = isLength;
  return isLength_1;
}
var isArrayLike_1;
var hasRequiredIsArrayLike;
function requireIsArrayLike() {
  if (hasRequiredIsArrayLike) return isArrayLike_1;
  hasRequiredIsArrayLike = 1;
  var isFunction = requireIsFunction(),
    isLength = requireIsLength();
  function isArrayLike(value) {
    return value != null && isLength(value.length) && !isFunction(value);
  }
  isArrayLike_1 = isArrayLike;
  return isArrayLike_1;
}
var isArray_1;
var hasRequiredIsArray;
function requireIsArray() {
  if (hasRequiredIsArray) return isArray_1;
  hasRequiredIsArray = 1;
  var isArray = Array.isArray;
  isArray_1 = isArray;
  return isArray_1;
}
var isObjectLike_1;
var hasRequiredIsObjectLike;
function requireIsObjectLike() {
  if (hasRequiredIsObjectLike) return isObjectLike_1;
  hasRequiredIsObjectLike = 1;
  function isObjectLike(value) {
    return value != null && typeof value == 'object';
  }
  isObjectLike_1 = isObjectLike;
  return isObjectLike_1;
}
var isString_1;
var hasRequiredIsString;
function requireIsString() {
  if (hasRequiredIsString) return isString_1;
  hasRequiredIsString = 1;
  var baseGetTag = require_baseGetTag(),
    isArray = requireIsArray(),
    isObjectLike = requireIsObjectLike();
  var stringTag = '[object String]';
  function isString(value) {
    return (
      typeof value == 'string' ||
      (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag)
    );
  }
  isString_1 = isString;
  return isString_1;
}
var _trimmedEndIndex;
var hasRequired_trimmedEndIndex;
function require_trimmedEndIndex() {
  if (hasRequired_trimmedEndIndex) return _trimmedEndIndex;
  hasRequired_trimmedEndIndex = 1;
  var reWhitespace = /\s/;
  function trimmedEndIndex(string) {
    var index = string.length;
    while (index-- && reWhitespace.test(string.charAt(index))) {}
    return index;
  }
  _trimmedEndIndex = trimmedEndIndex;
  return _trimmedEndIndex;
}
var _baseTrim;
var hasRequired_baseTrim;
function require_baseTrim() {
  if (hasRequired_baseTrim) return _baseTrim;
  hasRequired_baseTrim = 1;
  var trimmedEndIndex = require_trimmedEndIndex();
  var reTrimStart = /^\s+/;
  function baseTrim(string) {
    return string
      ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
      : string;
  }
  _baseTrim = baseTrim;
  return _baseTrim;
}
var isSymbol_1;
var hasRequiredIsSymbol;
function requireIsSymbol() {
  if (hasRequiredIsSymbol) return isSymbol_1;
  hasRequiredIsSymbol = 1;
  var baseGetTag = require_baseGetTag(),
    isObjectLike = requireIsObjectLike();
  var symbolTag = '[object Symbol]';
  function isSymbol(value) {
    return (
      typeof value == 'symbol' ||
      (isObjectLike(value) && baseGetTag(value) == symbolTag)
    );
  }
  isSymbol_1 = isSymbol;
  return isSymbol_1;
}
var toNumber_1;
var hasRequiredToNumber;
function requireToNumber() {
  if (hasRequiredToNumber) return toNumber_1;
  hasRequiredToNumber = 1;
  var baseTrim = require_baseTrim(),
    isObject = requireIsObject(),
    isSymbol = requireIsSymbol();
  var NAN = 0 / 0;
  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
  var reIsBinary = /^0b[01]+$/i;
  var reIsOctal = /^0o[0-7]+$/i;
  var freeParseInt = parseInt;
  function toNumber(value) {
    if (typeof value == 'number') {
      return value;
    }
    if (isSymbol(value)) {
      return NAN;
    }
    if (isObject(value)) {
      var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
      value = isObject(other) ? other + '' : other;
    }
    if (typeof value != 'string') {
      return value === 0 ? value : +value;
    }
    value = baseTrim(value);
    var isBinary = reIsBinary.test(value);
    return isBinary || reIsOctal.test(value)
      ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
      : reIsBadHex.test(value)
        ? NAN
        : +value;
  }
  toNumber_1 = toNumber;
  return toNumber_1;
}
var toFinite_1;
var hasRequiredToFinite;
function requireToFinite() {
  if (hasRequiredToFinite) return toFinite_1;
  hasRequiredToFinite = 1;
  var toNumber = requireToNumber();
  var INFINITY = 1 / 0,
    MAX_INTEGER = 17976931348623157e292;
  function toFinite(value) {
    if (!value) {
      return value === 0 ? value : 0;
    }
    value = toNumber(value);
    if (value === INFINITY || value === -INFINITY) {
      var sign = value < 0 ? -1 : 1;
      return sign * MAX_INTEGER;
    }
    return value === value ? value : 0;
  }
  toFinite_1 = toFinite;
  return toFinite_1;
}
var toInteger_1;
var hasRequiredToInteger;
function requireToInteger() {
  if (hasRequiredToInteger) return toInteger_1;
  hasRequiredToInteger = 1;
  var toFinite = requireToFinite();
  function toInteger(value) {
    var result = toFinite(value),
      remainder = result % 1;
    return result === result ? (remainder ? result - remainder : result) : 0;
  }
  toInteger_1 = toInteger;
  return toInteger_1;
}
var _arrayMap;
var hasRequired_arrayMap;
function require_arrayMap() {
  if (hasRequired_arrayMap) return _arrayMap;
  hasRequired_arrayMap = 1;
  function arrayMap(array, iteratee) {
    var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);
    while (++index < length) {
      result[index] = iteratee(array[index], index, array);
    }
    return result;
  }
  _arrayMap = arrayMap;
  return _arrayMap;
}
var _baseValues;
var hasRequired_baseValues;
function require_baseValues() {
  if (hasRequired_baseValues) return _baseValues;
  hasRequired_baseValues = 1;
  var arrayMap = require_arrayMap();
  function baseValues(object, props) {
    return arrayMap(props, function (key) {
      return object[key];
    });
  }
  _baseValues = baseValues;
  return _baseValues;
}
var _baseTimes;
var hasRequired_baseTimes;
function require_baseTimes() {
  if (hasRequired_baseTimes) return _baseTimes;
  hasRequired_baseTimes = 1;
  function baseTimes(n, iteratee) {
    var index = -1,
      result = Array(n);
    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }
  _baseTimes = baseTimes;
  return _baseTimes;
}
var _baseIsArguments;
var hasRequired_baseIsArguments;
function require_baseIsArguments() {
  if (hasRequired_baseIsArguments) return _baseIsArguments;
  hasRequired_baseIsArguments = 1;
  var baseGetTag = require_baseGetTag(),
    isObjectLike = requireIsObjectLike();
  var argsTag = '[object Arguments]';
  function baseIsArguments(value) {
    return isObjectLike(value) && baseGetTag(value) == argsTag;
  }
  _baseIsArguments = baseIsArguments;
  return _baseIsArguments;
}
var isArguments_1;
var hasRequiredIsArguments;
function requireIsArguments() {
  if (hasRequiredIsArguments) return isArguments_1;
  hasRequiredIsArguments = 1;
  var baseIsArguments = require_baseIsArguments(),
    isObjectLike = requireIsObjectLike();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  var propertyIsEnumerable = objectProto.propertyIsEnumerable;
  var isArguments = baseIsArguments(
    (function () {
      return arguments;
    })()
  )
    ? baseIsArguments
    : function (value) {
        return (
          isObjectLike(value) &&
          hasOwnProperty.call(value, 'callee') &&
          !propertyIsEnumerable.call(value, 'callee')
        );
      };
  isArguments_1 = isArguments;
  return isArguments_1;
}
var isBuffer = {exports: {}};
var stubFalse_1;
var hasRequiredStubFalse;
function requireStubFalse() {
  if (hasRequiredStubFalse) return stubFalse_1;
  hasRequiredStubFalse = 1;
  function stubFalse() {
    return false;
  }
  stubFalse_1 = stubFalse;
  return stubFalse_1;
}
isBuffer.exports;
var hasRequiredIsBuffer;
function requireIsBuffer() {
  if (hasRequiredIsBuffer) return isBuffer.exports;
  hasRequiredIsBuffer = 1;
  (function (module, exports) {
    var root = require_root(),
      stubFalse = requireStubFalse();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule =
      freeExports &&
      'object' == 'object' &&
      module &&
      !module.nodeType &&
      module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var Buffer = moduleExports ? root.Buffer : undefined;
    var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;
    var isBuffer = nativeIsBuffer || stubFalse;
    module.exports = isBuffer;
  })(isBuffer, isBuffer.exports);
  return isBuffer.exports;
}
var _isIndex;
var hasRequired_isIndex;
function require_isIndex() {
  if (hasRequired_isIndex) return _isIndex;
  hasRequired_isIndex = 1;
  var MAX_SAFE_INTEGER = 9007199254740991;
  var reIsUint = /^(?:0|[1-9]\d*)$/;
  function isIndex(value, length) {
    var type = typeof value;
    length = length == null ? MAX_SAFE_INTEGER : length;
    return (
      !!length &&
      (type == 'number' || (type != 'symbol' && reIsUint.test(value))) &&
      value > -1 && value % 1 == 0 && value < length
    );
  }
  _isIndex = isIndex;
  return _isIndex;
}
var _baseIsTypedArray;
var hasRequired_baseIsTypedArray;
function require_baseIsTypedArray() {
  if (hasRequired_baseIsTypedArray) return _baseIsTypedArray;
  hasRequired_baseIsTypedArray = 1;
  var baseGetTag = require_baseGetTag(),
    isLength = requireIsLength(),
    isObjectLike = requireIsObjectLike();
  var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';
  var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';
  var typedArrayTags = {};
  typedArrayTags[float32Tag] =
    typedArrayTags[float64Tag] =
    typedArrayTags[int8Tag] =
    typedArrayTags[int16Tag] =
    typedArrayTags[int32Tag] =
    typedArrayTags[uint8Tag] =
    typedArrayTags[uint8ClampedTag] =
    typedArrayTags[uint16Tag] =
    typedArrayTags[uint32Tag] =
      true;
  typedArrayTags[argsTag] =
    typedArrayTags[arrayTag] =
    typedArrayTags[arrayBufferTag] =
    typedArrayTags[boolTag] =
    typedArrayTags[dataViewTag] =
    typedArrayTags[dateTag] =
    typedArrayTags[errorTag] =
    typedArrayTags[funcTag] =
    typedArrayTags[mapTag] =
    typedArrayTags[numberTag] =
    typedArrayTags[objectTag] =
    typedArrayTags[regexpTag] =
    typedArrayTags[setTag] =
    typedArrayTags[stringTag] =
    typedArrayTags[weakMapTag] =
      false;
  function baseIsTypedArray(value) {
    return (
      isObjectLike(value) &&
      isLength(value.length) &&
      !!typedArrayTags[baseGetTag(value)]
    );
  }
  _baseIsTypedArray = baseIsTypedArray;
  return _baseIsTypedArray;
}
var _baseUnary;
var hasRequired_baseUnary;
function require_baseUnary() {
  if (hasRequired_baseUnary) return _baseUnary;
  hasRequired_baseUnary = 1;
  function baseUnary(func) {
    return function (value) {
      return func(value);
    };
  }
  _baseUnary = baseUnary;
  return _baseUnary;
}
var _nodeUtil = {exports: {}};
_nodeUtil.exports;
var hasRequired_nodeUtil;
function require_nodeUtil() {
  if (hasRequired_nodeUtil) return _nodeUtil.exports;
  hasRequired_nodeUtil = 1;
  (function (module, exports) {
    var freeGlobal = require_freeGlobal();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule =
      freeExports &&
      'object' == 'object' &&
      module &&
      !module.nodeType &&
      module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal.process;
    var nodeUtil = (function () {
      try {
        var types =
          freeModule && freeModule.require && freeModule.require('util').types;
        if (types) {
          return types;
        }
        return (
          freeProcess && freeProcess.binding && freeProcess.binding('util')
        );
      } catch (e) {}
    })();
    module.exports = nodeUtil;
  })(_nodeUtil, _nodeUtil.exports);
  return _nodeUtil.exports;
}
var isTypedArray_1;
var hasRequiredIsTypedArray;
function requireIsTypedArray() {
  if (hasRequiredIsTypedArray) return isTypedArray_1;
  hasRequiredIsTypedArray = 1;
  var baseIsTypedArray = require_baseIsTypedArray(),
    baseUnary = require_baseUnary(),
    nodeUtil = require_nodeUtil();
  var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
  var isTypedArray = nodeIsTypedArray
    ? baseUnary(nodeIsTypedArray)
    : baseIsTypedArray;
  isTypedArray_1 = isTypedArray;
  return isTypedArray_1;
}
var _arrayLikeKeys;
var hasRequired_arrayLikeKeys;
function require_arrayLikeKeys() {
  if (hasRequired_arrayLikeKeys) return _arrayLikeKeys;
  hasRequired_arrayLikeKeys = 1;
  var baseTimes = require_baseTimes(),
    isArguments = requireIsArguments(),
    isArray = requireIsArray(),
    isBuffer = requireIsBuffer(),
    isIndex = require_isIndex(),
    isTypedArray = requireIsTypedArray();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function arrayLikeKeys(value, inherited) {
    var isArr = isArray(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;
    for (var key in value) {
      if (
        (inherited || hasOwnProperty.call(value, key)) &&
        !(
          skipIndexes &&
          (key == 'length' ||
            (isBuff && (key == 'offset' || key == 'parent')) ||
            (isType &&
              (key == 'buffer' ||
                key == 'byteLength' ||
                key == 'byteOffset')) ||
            isIndex(key, length))
        )
      ) {
        result.push(key);
      }
    }
    return result;
  }
  _arrayLikeKeys = arrayLikeKeys;
  return _arrayLikeKeys;
}
var _isPrototype;
var hasRequired_isPrototype;
function require_isPrototype() {
  if (hasRequired_isPrototype) return _isPrototype;
  hasRequired_isPrototype = 1;
  var objectProto = Object.prototype;
  function isPrototype(value) {
    var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;
    return value === proto;
  }
  _isPrototype = isPrototype;
  return _isPrototype;
}
var _overArg;
var hasRequired_overArg;
function require_overArg() {
  if (hasRequired_overArg) return _overArg;
  hasRequired_overArg = 1;
  function overArg(func, transform) {
    return function (arg) {
      return func(transform(arg));
    };
  }
  _overArg = overArg;
  return _overArg;
}
var _nativeKeys;
var hasRequired_nativeKeys;
function require_nativeKeys() {
  if (hasRequired_nativeKeys) return _nativeKeys;
  hasRequired_nativeKeys = 1;
  var overArg = require_overArg();
  var nativeKeys = overArg(Object.keys, Object);
  _nativeKeys = nativeKeys;
  return _nativeKeys;
}
var _baseKeys;
var hasRequired_baseKeys;
function require_baseKeys() {
  if (hasRequired_baseKeys) return _baseKeys;
  hasRequired_baseKeys = 1;
  var isPrototype = require_isPrototype(),
    nativeKeys = require_nativeKeys();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function baseKeys(object) {
    if (!isPrototype(object)) {
      return nativeKeys(object);
    }
    var result = [];
    for (var key in Object(object)) {
      if (hasOwnProperty.call(object, key) && key != 'constructor') {
        result.push(key);
      }
    }
    return result;
  }
  _baseKeys = baseKeys;
  return _baseKeys;
}
var keys_1;
var hasRequiredKeys;
function requireKeys() {
  if (hasRequiredKeys) return keys_1;
  hasRequiredKeys = 1;
  var arrayLikeKeys = require_arrayLikeKeys(),
    baseKeys = require_baseKeys(),
    isArrayLike = requireIsArrayLike();
  function keys(object) {
    return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
  }
  keys_1 = keys;
  return keys_1;
}
var values_1;
var hasRequiredValues;
function requireValues() {
  if (hasRequiredValues) return values_1;
  hasRequiredValues = 1;
  var baseValues = require_baseValues(),
    keys = requireKeys();
  function values(object) {
    return object == null ? [] : baseValues(object, keys(object));
  }
  values_1 = values;
  return values_1;
}
var includes_1;
var hasRequiredIncludes;
function requireIncludes() {
  if (hasRequiredIncludes) return includes_1;
  hasRequiredIncludes = 1;
  var baseIndexOf = require_baseIndexOf(),
    isArrayLike = requireIsArrayLike(),
    isString = requireIsString(),
    toInteger = requireToInteger(),
    values = requireValues();
  var nativeMax = Math.max;
  function includes(collection, value, fromIndex, guard) {
    collection = isArrayLike(collection) ? collection : values(collection);
    fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
    var length = collection.length;
    if (fromIndex < 0) {
      fromIndex = nativeMax(length + fromIndex, 0);
    }
    return isString(collection)
      ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1
      : !!length && baseIndexOf(collection, value, fromIndex) > -1;
  }
  includes_1 = includes;
  return includes_1;
}
var _baseRepeat;
var hasRequired_baseRepeat;
function require_baseRepeat() {
  if (hasRequired_baseRepeat) return _baseRepeat;
  hasRequired_baseRepeat = 1;
  var MAX_SAFE_INTEGER = 9007199254740991;
  var nativeFloor = Math.floor;
  function baseRepeat(string, n) {
    var result = '';
    if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
      return result;
    }
    do {
      if (n % 2) {
        result += string;
      }
      n = nativeFloor(n / 2);
      if (n) {
        string += string;
      }
    } while (n);
    return result;
  }
  _baseRepeat = baseRepeat;
  return _baseRepeat;
}
var eq_1;
var hasRequiredEq;
function requireEq() {
  if (hasRequiredEq) return eq_1;
  hasRequiredEq = 1;
  function eq(value, other) {
    return value === other || (value !== value && other !== other);
  }
  eq_1 = eq;
  return eq_1;
}
var _isIterateeCall;
var hasRequired_isIterateeCall;
function require_isIterateeCall() {
  if (hasRequired_isIterateeCall) return _isIterateeCall;
  hasRequired_isIterateeCall = 1;
  var eq = requireEq(),
    isArrayLike = requireIsArrayLike(),
    isIndex = require_isIndex(),
    isObject = requireIsObject();
  function isIterateeCall(value, index, object) {
    if (!isObject(object)) {
      return false;
    }
    var type = typeof index;
    if (
      type == 'number'
        ? isArrayLike(object) && isIndex(index, object.length)
        : type == 'string' && index in object
    ) {
      return eq(object[index], value);
    }
    return false;
  }
  _isIterateeCall = isIterateeCall;
  return _isIterateeCall;
}
var _baseToString;
var hasRequired_baseToString;
function require_baseToString() {
  if (hasRequired_baseToString) return _baseToString;
  hasRequired_baseToString = 1;
  var Symbol = require_Symbol(),
    arrayMap = require_arrayMap(),
    isArray = requireIsArray(),
    isSymbol = requireIsSymbol();
  var INFINITY = 1 / 0;
  var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;
  function baseToString(value) {
    if (typeof value == 'string') {
      return value;
    }
    if (isArray(value)) {
      return arrayMap(value, baseToString) + '';
    }
    if (isSymbol(value)) {
      return symbolToString ? symbolToString.call(value) : '';
    }
    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
  }
  _baseToString = baseToString;
  return _baseToString;
}
var toString_1;
var hasRequiredToString;
function requireToString() {
  if (hasRequiredToString) return toString_1;
  hasRequiredToString = 1;
  var baseToString = require_baseToString();
  function toString(value) {
    return value == null ? '' : baseToString(value);
  }
  toString_1 = toString;
  return toString_1;
}
var repeat_1;
var hasRequiredRepeat;
function requireRepeat() {
  if (hasRequiredRepeat) return repeat_1;
  hasRequiredRepeat = 1;
  var baseRepeat = require_baseRepeat(),
    isIterateeCall = require_isIterateeCall(),
    toInteger = requireToInteger(),
    toString = requireToString();
  function repeat(string, n, guard) {
    if (guard ? isIterateeCall(string, n, guard) : n === undefined) {
      n = 1;
    } else {
      n = toInteger(n);
    }
    return baseRepeat(toString(string), n);
  }
  repeat_1 = repeat;
  return repeat_1;
}
var renamer = {};
var binding = {};
var hasRequiredBinding;
function requireBinding() {
  if (hasRequiredBinding) return binding;
  hasRequiredBinding = 1;
  Object.defineProperty(binding, '__esModule', {value: true});
  binding.default = void 0;
  class Binding {
    constructor({
      identifier: identifier,
      scope: scope,
      path: path,
      kind: kind,
    }) {
      this.identifier = identifier;
      this.scope = scope;
      this.path = path;
      this.kind = kind;
      this.constantViolations = [];
      this.constant = true;
      this.referencePaths = [];
      this.referenced = false;
      this.references = 0;
      this.clearValue();
    }
    deoptValue() {
      this.clearValue();
      this.hasDeoptedValue = true;
    }
    setValue(value) {
      if (this.hasDeoptedValue) return;
      this.hasValue = true;
      this.value = value;
    }
    clearValue() {
      this.hasDeoptedValue = false;
      this.hasValue = false;
      this.value = null;
    }
    reassign(path) {
      this.constant = false;
      if (this.constantViolations.indexOf(path) !== -1) {
        return;
      }
      this.constantViolations.push(path);
    }
    reference(path) {
      if (this.referencePaths.indexOf(path) !== -1) {
        return;
      }
      this.referenced = true;
      this.references++;
      this.referencePaths.push(path);
    }
    dereference() {
      this.references--;
      this.referenced = !!this.references;
    }
  }
  binding.default = Binding;
  return binding;
}
var lib$b = {};
var hasRequiredLib$b;
function requireLib$b() {
  if (hasRequiredLib$b) return lib$b;
  hasRequiredLib$b = 1;
  Object.defineProperty(lib$b, '__esModule', {value: true});
  lib$b.default = splitExportDeclaration;
  var _t = t$d;
  const {
    cloneNode: cloneNode,
    exportNamedDeclaration: exportNamedDeclaration,
    exportSpecifier: exportSpecifier,
    identifier: identifier,
    variableDeclaration: variableDeclaration,
    variableDeclarator: variableDeclarator,
  } = _t;
  function splitExportDeclaration(exportDeclaration) {
    if (
      !exportDeclaration.isExportDeclaration() ||
      exportDeclaration.isExportAllDeclaration()
    ) {
      throw new Error(
        'Only default and named export declarations can be split.'
      );
    }
    if (exportDeclaration.isExportDefaultDeclaration()) {
      const declaration = exportDeclaration.get('declaration');
      const standaloneDeclaration =
        declaration.isFunctionDeclaration() || declaration.isClassDeclaration();
      const exportExpr =
        declaration.isFunctionExpression() || declaration.isClassExpression();
      const scope = declaration.isScope()
        ? declaration.scope.parent
        : declaration.scope;
      let id = declaration.node.id;
      let needBindingRegistration = false;
      if (!id) {
        needBindingRegistration = true;
        id = scope.generateUidIdentifier('default');
        if (standaloneDeclaration || exportExpr) {
          declaration.node.id = cloneNode(id);
        }
      } else if (exportExpr && scope.hasBinding(id.name)) {
        needBindingRegistration = true;
        id = scope.generateUidIdentifier(id.name);
      }
      const updatedDeclaration = standaloneDeclaration
        ? declaration.node
        : variableDeclaration('var', [
            variableDeclarator(cloneNode(id), declaration.node),
          ]);
      const updatedExportDeclaration = exportNamedDeclaration(null, [
        exportSpecifier(cloneNode(id), identifier('default')),
      ]);
      exportDeclaration.insertAfter(updatedExportDeclaration);
      exportDeclaration.replaceWith(updatedDeclaration);
      if (needBindingRegistration) {
        scope.registerDeclaration(exportDeclaration);
      }
      return exportDeclaration;
    } else if (exportDeclaration.get('specifiers').length > 0) {
      throw new Error("It doesn't make sense to split exported specifiers.");
    }
    const declaration = exportDeclaration.get('declaration');
    const bindingIdentifiers = declaration.getOuterBindingIdentifiers();
    const specifiers = Object.keys(bindingIdentifiers).map(name =>
      exportSpecifier(identifier(name), identifier(name))
    );
    const aliasDeclar = exportNamedDeclaration(null, specifiers);
    exportDeclaration.insertAfter(aliasDeclar);
    exportDeclaration.replaceWith(declaration.node);
    return exportDeclaration;
  }
  return lib$b;
}
var hasRequiredRenamer;
function requireRenamer() {
  if (hasRequiredRenamer) return renamer;
  hasRequiredRenamer = 1;
  Object.defineProperty(renamer, '__esModule', {value: true});
  renamer.default = void 0;
  _interopRequireDefault(requireBinding());
  var _helperSplitExportDeclaration = _interopRequireDefault(requireLib$b());
  _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const renameVisitor = {
    ReferencedIdentifier({node: node}, state) {
      if (node.name === state.oldName) {
        node.name = state.newName;
      }
    },
    Scope(path, state) {
      if (
        !path.scope.bindingIdentifierEquals(
          state.oldName,
          state.binding.identifier
        )
      ) {
        path.skip();
      }
    },
    'AssignmentExpression|Declaration'(path, state) {
      const ids = path.getOuterBindingIdentifiers();
      for (const name in ids) {
        if (name === state.oldName) ids[name].name = state.newName;
      }
    },
  };
  class Renamer {
    constructor(binding, oldName, newName) {
      this.newName = newName;
      this.oldName = oldName;
      this.binding = binding;
    }
    maybeConvertFromExportDeclaration(parentDeclar) {
      const maybeExportDeclar = parentDeclar.parentPath;
      if (!maybeExportDeclar.isExportDeclaration()) {
        return;
      }
      if (
        maybeExportDeclar.isExportDefaultDeclaration() &&
        !maybeExportDeclar.get('declaration').node.id
      ) {
        return;
      }
      (0, _helperSplitExportDeclaration.default)(maybeExportDeclar);
    }
    maybeConvertFromClassFunctionDeclaration(path) {
      return;
    }
    maybeConvertFromClassFunctionExpression(path) {
      return;
    }
    rename(block) {
      const {binding: binding, oldName: oldName, newName: newName} = this;
      const {scope: scope, path: path} = binding;
      const parentDeclar = path.find(
        path =>
          path.isDeclaration() ||
          path.isFunctionExpression() ||
          path.isClassExpression()
      );
      if (parentDeclar) {
        const bindingIds = parentDeclar.getOuterBindingIdentifiers();
        if (bindingIds[oldName] === binding.identifier) {
          this.maybeConvertFromExportDeclaration(parentDeclar);
        }
      }
      scope.traverse(block || scope.block, renameVisitor, this);
      if (!block) {
        scope.removeOwnBinding(oldName);
        scope.bindings[newName] = binding;
        this.binding.identifier.name = newName;
      }
      if (binding.type === 'hoisted');
      if (parentDeclar) {
        this.maybeConvertFromClassFunctionDeclaration(parentDeclar);
        this.maybeConvertFromClassFunctionExpression(parentDeclar);
      }
    }
  }
  renamer.default = Renamer;
  return renamer;
}
var identity_1;
var hasRequiredIdentity;
function requireIdentity() {
  if (hasRequiredIdentity) return identity_1;
  hasRequiredIdentity = 1;
  function identity(value) {
    return value;
  }
  identity_1 = identity;
  return identity_1;
}
var _apply;
var hasRequired_apply;
function require_apply() {
  if (hasRequired_apply) return _apply;
  hasRequired_apply = 1;
  function apply(func, thisArg, args) {
    switch (args.length) {
      case 0:
        return func.call(thisArg);
      case 1:
        return func.call(thisArg, args[0]);
      case 2:
        return func.call(thisArg, args[0], args[1]);
      case 3:
        return func.call(thisArg, args[0], args[1], args[2]);
    }
    return func.apply(thisArg, args);
  }
  _apply = apply;
  return _apply;
}
var _overRest;
var hasRequired_overRest;
function require_overRest() {
  if (hasRequired_overRest) return _overRest;
  hasRequired_overRest = 1;
  var apply = require_apply();
  var nativeMax = Math.max;
  function overRest(func, start, transform) {
    start = nativeMax(start === undefined ? func.length - 1 : start, 0);
    return function () {
      var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);
      while (++index < length) {
        array[index] = args[start + index];
      }
      index = -1;
      var otherArgs = Array(start + 1);
      while (++index < start) {
        otherArgs[index] = args[index];
      }
      otherArgs[start] = transform(array);
      return apply(func, this, otherArgs);
    };
  }
  _overRest = overRest;
  return _overRest;
}
var constant_1;
var hasRequiredConstant;
function requireConstant() {
  if (hasRequiredConstant) return constant_1;
  hasRequiredConstant = 1;
  function constant(value) {
    return function () {
      return value;
    };
  }
  constant_1 = constant;
  return constant_1;
}
var _coreJsData;
var hasRequired_coreJsData;
function require_coreJsData() {
  if (hasRequired_coreJsData) return _coreJsData;
  hasRequired_coreJsData = 1;
  var root = require_root();
  var coreJsData = root['__core-js_shared__'];
  _coreJsData = coreJsData;
  return _coreJsData;
}
var _isMasked;
var hasRequired_isMasked;
function require_isMasked() {
  if (hasRequired_isMasked) return _isMasked;
  hasRequired_isMasked = 1;
  var coreJsData = require_coreJsData();
  var maskSrcKey = (function () {
    var uid = /[^.]+$/.exec(
      (coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO) || ''
    );
    return uid ? 'Symbol(src)_1.' + uid : '';
  })();
  function isMasked(func) {
    return !!maskSrcKey && maskSrcKey in func;
  }
  _isMasked = isMasked;
  return _isMasked;
}
var _toSource;
var hasRequired_toSource;
function require_toSource() {
  if (hasRequired_toSource) return _toSource;
  hasRequired_toSource = 1;
  var funcProto = Function.prototype;
  var funcToString = funcProto.toString;
  function toSource(func) {
    if (func != null) {
      try {
        return funcToString.call(func);
      } catch (e) {}
      try {
        return func + '';
      } catch (e) {}
    }
    return '';
  }
  _toSource = toSource;
  return _toSource;
}
var _baseIsNative;
var hasRequired_baseIsNative;
function require_baseIsNative() {
  if (hasRequired_baseIsNative) return _baseIsNative;
  hasRequired_baseIsNative = 1;
  var isFunction = requireIsFunction(),
    isMasked = require_isMasked(),
    isObject = requireIsObject(),
    toSource = require_toSource();
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
  var reIsHostCtor = /^\[object .+?Constructor\]$/;
  var funcProto = Function.prototype,
    objectProto = Object.prototype;
  var funcToString = funcProto.toString;
  var hasOwnProperty = objectProto.hasOwnProperty;
  var reIsNative = RegExp(
    '^' +
      funcToString
        .call(hasOwnProperty)
        .replace(reRegExpChar, '\\$&')
        .replace(
          /hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,
          '$1.*?'
        ) +
      '$'
  );
  function baseIsNative(value) {
    if (!isObject(value) || isMasked(value)) {
      return false;
    }
    var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
    return pattern.test(toSource(value));
  }
  _baseIsNative = baseIsNative;
  return _baseIsNative;
}
var _getValue;
var hasRequired_getValue;
function require_getValue() {
  if (hasRequired_getValue) return _getValue;
  hasRequired_getValue = 1;
  function getValue(object, key) {
    return object == null ? undefined : object[key];
  }
  _getValue = getValue;
  return _getValue;
}
var _getNative;
var hasRequired_getNative;
function require_getNative() {
  if (hasRequired_getNative) return _getNative;
  hasRequired_getNative = 1;
  var baseIsNative = require_baseIsNative(),
    getValue = require_getValue();
  function getNative(object, key) {
    var value = getValue(object, key);
    return baseIsNative(value) ? value : undefined;
  }
  _getNative = getNative;
  return _getNative;
}
var _defineProperty$1;
var hasRequired_defineProperty;
function require_defineProperty() {
  if (hasRequired_defineProperty) return _defineProperty$1;
  hasRequired_defineProperty = 1;
  var getNative = require_getNative();
  var defineProperty = (function () {
    try {
      var func = getNative(Object, 'defineProperty');
      func({}, '', {});
      return func;
    } catch (e) {}
  })();
  _defineProperty$1 = defineProperty;
  return _defineProperty$1;
}
var _baseSetToString;
var hasRequired_baseSetToString;
function require_baseSetToString() {
  if (hasRequired_baseSetToString) return _baseSetToString;
  hasRequired_baseSetToString = 1;
  var constant = requireConstant(),
    defineProperty = require_defineProperty(),
    identity = requireIdentity();
  var baseSetToString = !defineProperty
    ? identity
    : function (func, string) {
        return defineProperty(func, 'toString', {
          configurable: true,
          enumerable: false,
          value: constant(string),
          writable: true,
        });
      };
  _baseSetToString = baseSetToString;
  return _baseSetToString;
}
var _shortOut;
var hasRequired_shortOut;
function require_shortOut() {
  if (hasRequired_shortOut) return _shortOut;
  hasRequired_shortOut = 1;
  var HOT_COUNT = 800,
    HOT_SPAN = 16;
  var nativeNow = Date.now;
  function shortOut(func) {
    var count = 0,
      lastCalled = 0;
    return function () {
      var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);
      lastCalled = stamp;
      if (remaining > 0) {
        if (++count >= HOT_COUNT) {
          return arguments[0];
        }
      } else {
        count = 0;
      }
      return func.apply(undefined, arguments);
    };
  }
  _shortOut = shortOut;
  return _shortOut;
}
var _setToString;
var hasRequired_setToString;
function require_setToString() {
  if (hasRequired_setToString) return _setToString;
  hasRequired_setToString = 1;
  var baseSetToString = require_baseSetToString(),
    shortOut = require_shortOut();
  var setToString = shortOut(baseSetToString);
  _setToString = setToString;
  return _setToString;
}
var _baseRest;
var hasRequired_baseRest;
function require_baseRest() {
  if (hasRequired_baseRest) return _baseRest;
  hasRequired_baseRest = 1;
  var identity = requireIdentity(),
    overRest = require_overRest(),
    setToString = require_setToString();
  function baseRest(func, start) {
    return setToString(overRest(func, start, identity), func + '');
  }
  _baseRest = baseRest;
  return _baseRest;
}
var _nativeKeysIn;
var hasRequired_nativeKeysIn;
function require_nativeKeysIn() {
  if (hasRequired_nativeKeysIn) return _nativeKeysIn;
  hasRequired_nativeKeysIn = 1;
  function nativeKeysIn(object) {
    var result = [];
    if (object != null) {
      for (var key in Object(object)) {
        result.push(key);
      }
    }
    return result;
  }
  _nativeKeysIn = nativeKeysIn;
  return _nativeKeysIn;
}
var _baseKeysIn;
var hasRequired_baseKeysIn;
function require_baseKeysIn() {
  if (hasRequired_baseKeysIn) return _baseKeysIn;
  hasRequired_baseKeysIn = 1;
  var isObject = requireIsObject(),
    isPrototype = require_isPrototype(),
    nativeKeysIn = require_nativeKeysIn();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function baseKeysIn(object) {
    if (!isObject(object)) {
      return nativeKeysIn(object);
    }
    var isProto = isPrototype(object),
      result = [];
    for (var key in object) {
      if (
        !(
          key == 'constructor' &&
          (isProto || !hasOwnProperty.call(object, key))
        )
      ) {
        result.push(key);
      }
    }
    return result;
  }
  _baseKeysIn = baseKeysIn;
  return _baseKeysIn;
}
var keysIn_1;
var hasRequiredKeysIn;
function requireKeysIn() {
  if (hasRequiredKeysIn) return keysIn_1;
  hasRequiredKeysIn = 1;
  var arrayLikeKeys = require_arrayLikeKeys(),
    baseKeysIn = require_baseKeysIn(),
    isArrayLike = requireIsArrayLike();
  function keysIn(object) {
    return isArrayLike(object)
      ? arrayLikeKeys(object, true)
      : baseKeysIn(object);
  }
  keysIn_1 = keysIn;
  return keysIn_1;
}
var defaults_1;
var hasRequiredDefaults;
function requireDefaults() {
  if (hasRequiredDefaults) return defaults_1;
  hasRequiredDefaults = 1;
  var baseRest = require_baseRest(),
    eq = requireEq(),
    isIterateeCall = require_isIterateeCall(),
    keysIn = requireKeysIn();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  var defaults = baseRest(function (object, sources) {
    object = Object(object);
    var index = -1;
    var length = sources.length;
    var guard = length > 2 ? sources[2] : undefined;
    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      length = 1;
    }
    while (++index < length) {
      var source = sources[index];
      var props = keysIn(source);
      var propsIndex = -1;
      var propsLength = props.length;
      while (++propsIndex < propsLength) {
        var key = props[propsIndex];
        var value = object[key];
        if (
          value === undefined ||
          (eq(value, objectProto[key]) && !hasOwnProperty.call(object, key))
        ) {
          object[key] = source[key];
        }
      }
    }
    return object;
  });
  defaults_1 = defaults;
  return defaults_1;
}
var cache = {};
var hasRequiredCache;
function requireCache() {
  if (hasRequiredCache) return cache;
  hasRequiredCache = 1;
  Object.defineProperty(cache, '__esModule', {value: true});
  cache.clear = clear;
  cache.clearPath = clearPath;
  cache.clearScope = clearScope;
  cache.scope = cache.path = void 0;
  let path = new WeakMap();
  cache.path = path;
  let scope = new WeakMap();
  cache.scope = scope;
  function clear() {
    clearPath();
    clearScope();
  }
  function clearPath() {
    cache.path = path = new WeakMap();
  }
  function clearScope() {
    cache.scope = scope = new WeakMap();
  }
  return cache;
}
var hasRequiredScope;
function requireScope() {
  if (hasRequiredScope) return scope;
  hasRequiredScope = 1;
  Object.defineProperty(scope, '__esModule', {value: true});
  scope.default = void 0;
  var _includes = _interopRequireDefault(requireIncludes());
  var _repeat = _interopRequireDefault(requireRepeat());
  var _renamer = _interopRequireDefault(requireRenamer());
  var _index = _interopRequireDefault(requireLib$1());
  var _defaults = _interopRequireDefault(requireDefaults());
  var _binding = _interopRequireDefault(requireBinding());
  var _globals = _interopRequireDefault(requireGlobals());
  var t = _interopRequireWildcard(t$d);
  var _cache = requireCache();
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function gatherNodeParts(node, parts) {
    if (t.isModuleDeclaration(node)) {
      if (node.source) {
        gatherNodeParts(node.source, parts);
      } else if (node.specifiers && node.specifiers.length) {
        for (const specifier of node.specifiers) {
          gatherNodeParts(specifier, parts);
        }
      } else if (node.declaration) {
        gatherNodeParts(node.declaration, parts);
      }
    } else if (t.isModuleSpecifier(node)) {
      gatherNodeParts(node.local, parts);
    } else if (t.isMemberExpression(node)) {
      gatherNodeParts(node.object, parts);
      gatherNodeParts(node.property, parts);
    } else if (t.isIdentifier(node)) {
      parts.push(node.name);
    } else if (t.isLiteral(node)) {
      parts.push(node.value);
    } else if (t.isCallExpression(node)) {
      gatherNodeParts(node.callee, parts);
    } else if (t.isObjectExpression(node) || t.isObjectPattern(node)) {
      for (const prop of node.properties) {
        gatherNodeParts(prop.key || prop.argument, parts);
      }
    } else if (t.isPrivateName(node)) {
      gatherNodeParts(node.id, parts);
    } else if (t.isThisExpression(node)) {
      parts.push('this');
    } else if (t.isSuper(node)) {
      parts.push('super');
    }
  }
  const collectorVisitor = {
    For(path) {
      for (const key of t.FOR_INIT_KEYS) {
        const declar = path.get(key);
        if (declar.isVar()) {
          const parentScope =
            path.scope.getFunctionParent() || path.scope.getProgramParent();
          parentScope.registerBinding('var', declar);
        }
      }
    },
    Declaration(path) {
      if (path.isBlockScoped()) return;
      if (
        path.isExportDeclaration() &&
        path.get('declaration').isDeclaration()
      ) {
        return;
      }
      const parent =
        path.scope.getFunctionParent() || path.scope.getProgramParent();
      parent.registerDeclaration(path);
    },
    ReferencedIdentifier(path, state) {
      state.references.push(path);
    },
    ForXStatement(path, state) {
      const left = path.get('left');
      if (left.isPattern() || left.isIdentifier()) {
        state.constantViolations.push(path);
      }
    },
    ExportDeclaration: {
      exit(path) {
        const {node: node, scope: scope} = path;
        const declar = node.declaration;
        if (t.isClassDeclaration(declar) || t.isFunctionDeclaration(declar)) {
          const id = declar.id;
          if (!id) return;
          const binding = scope.getBinding(id.name);
          if (binding) binding.reference(path);
        } else if (t.isVariableDeclaration(declar)) {
          for (const decl of declar.declarations) {
            for (const name of Object.keys(t.getBindingIdentifiers(decl))) {
              const binding = scope.getBinding(name);
              if (binding) binding.reference(path);
            }
          }
        }
      },
    },
    LabeledStatement(path) {
      path.scope.getProgramParent().addGlobal(path.node);
      path.scope.getBlockParent().registerDeclaration(path);
    },
    AssignmentExpression(path, state) {
      state.assignments.push(path);
    },
    UpdateExpression(path, state) {
      state.constantViolations.push(path);
    },
    UnaryExpression(path, state) {
      if (path.node.operator === 'delete') {
        state.constantViolations.push(path);
      }
    },
    BlockScoped(path) {
      let scope = path.scope;
      if (scope.path === path) scope = scope.parent;
      scope.getBlockParent().registerDeclaration(path);
    },
    ClassDeclaration(path) {
      const id = path.node.id;
      if (!id) return;
      const name = id.name;
      path.scope.bindings[name] = path.scope.getBinding(name);
    },
    Block(path) {
      const paths = path.get('body');
      for (const bodyPath of paths) {
        if (bodyPath.isFunctionDeclaration()) {
          path.scope.getBlockParent().registerDeclaration(bodyPath);
        }
      }
    },
  };
  let uid = 0;
  class Scope {
    constructor(path) {
      const {node: node} = path;
      const cached = _cache.scope.get(node);
      if (cached && cached.path === path) {
        return cached;
      }
      _cache.scope.set(node, this);
      this.uid = uid++;
      this.block = node;
      this.path = path;
      this.labels = new Map();
    }
    get parent() {
      const parent = this.path.findParent(p => p.isScope());
      return parent && parent.scope;
    }
    get parentBlock() {
      return this.path.parent;
    }
    get hub() {
      return this.path.hub;
    }
    traverse(node, opts, state) {
      (0, _index.default)(node, opts, this, state, this.path);
    }
    generateDeclaredUidIdentifier(name) {
      const id = this.generateUidIdentifier(name);
      this.push({id: id});
      return t.cloneNode(id);
    }
    generateUidIdentifier(name) {
      return t.identifier(this.generateUid(name));
    }
    generateUid(name = 'temp') {
      name = t
        .toIdentifier(name)
        .replace(/^_+/, '')
        .replace(/[0-9]+$/g, '');
      let uid;
      let i = 0;
      do {
        uid = this._generateUid(name, i);
        i++;
      } while (
        this.hasLabel(uid) ||
        this.hasBinding(uid) ||
        this.hasGlobal(uid) ||
        this.hasReference(uid)
      );
      const program = this.getProgramParent();
      program.references[uid] = true;
      program.uids[uid] = true;
      return uid;
    }
    _generateUid(name, i) {
      let id = name;
      if (i > 1) id += i;
      return `_${id}`;
    }
    generateUidBasedOnNode(parent, defaultName) {
      let node = parent;
      if (t.isAssignmentExpression(parent)) {
        node = parent.left;
      } else if (t.isVariableDeclarator(parent)) {
        node = parent.id;
      } else if (t.isObjectProperty(node) || t.isObjectMethod(node)) {
        node = node.key;
      }
      const parts = [];
      gatherNodeParts(node, parts);
      let id = parts.join('$');
      id = id.replace(/^_/, '') || defaultName || 'ref';
      return this.generateUid(id.slice(0, 20));
    }
    generateUidIdentifierBasedOnNode(parent, defaultName) {
      return t.identifier(this.generateUidBasedOnNode(parent, defaultName));
    }
    isStatic(node) {
      if (t.isThisExpression(node) || t.isSuper(node)) {
        return true;
      }
      if (t.isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (binding) {
          return binding.constant;
        } else {
          return this.hasBinding(node.name);
        }
      }
      return false;
    }
    maybeGenerateMemoised(node, dontPush) {
      if (this.isStatic(node)) {
        return null;
      } else {
        const id = this.generateUidIdentifierBasedOnNode(node);
        if (!dontPush) {
          this.push({id: id});
          return t.cloneNode(id);
        }
        return id;
      }
    }
    checkBlockScopedCollisions(local, kind, name, id) {
      if (kind === 'param') return;
      if (local.kind === 'local') return;
      const duplicate =
        kind === 'let' ||
        local.kind === 'let' ||
        local.kind === 'const' ||
        local.kind === 'module' ||
        (local.kind === 'param' && (kind === 'let' || kind === 'const'));
      if (duplicate) {
        throw this.hub.buildError(
          id,
          `Duplicate declaration "${name}"`,
          TypeError
        );
      }
    }
    rename(oldName, newName, block) {
      const binding = this.getBinding(oldName);
      if (binding) {
        newName = newName || this.generateUidIdentifier(oldName).name;
        return new _renamer.default(binding, oldName, newName).rename(block);
      }
    }
    _renameFromMap(map, oldName, newName, value) {
      if (map[oldName]) {
        map[newName] = value;
        map[oldName] = null;
      }
    }
    dump() {
      const sep = (0, _repeat.default)('-', 60);
      console.log(sep);
      let scope = this;
      do {
        console.log('#', scope.block.type);
        for (const name of Object.keys(scope.bindings)) {
          const binding = scope.bindings[name];
          console.log(' -', name, {
            constant: binding.constant,
            references: binding.references,
            violations: binding.constantViolations.length,
            kind: binding.kind,
          });
        }
      } while ((scope = scope.parent));
      console.log(sep);
    }
    toArray(node, i) {
      if (t.isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (
          binding &&
          binding.constant &&
          binding.path.isGenericType('Array')
        ) {
          return node;
        }
      }
      if (t.isArrayExpression(node)) {
        return node;
      }
      if (t.isIdentifier(node, {name: 'arguments'})) {
        return t.callExpression(
          t.memberExpression(
            t.memberExpression(
              t.memberExpression(
                t.identifier('Array'),
                t.identifier('prototype')
              ),
              t.identifier('slice')
            ),
            t.identifier('call')
          ),
          [node]
        );
      }
      let helperName;
      const args = [node];
      if (i === true) {
        helperName = 'toConsumableArray';
      } else if (i) {
        args.push(t.numericLiteral(i));
        helperName = 'slicedToArray';
      } else {
        helperName = 'toArray';
      }
      return t.callExpression(this.hub.addHelper(helperName), args);
    }
    hasLabel(name) {
      return !!this.getLabel(name);
    }
    getLabel(name) {
      return this.labels.get(name);
    }
    registerLabel(path) {
      this.labels.set(path.node.label.name, path);
    }
    registerDeclaration(path) {
      if (path.isLabeledStatement()) {
        this.registerLabel(path);
      } else if (path.isFunctionDeclaration()) {
        this.registerBinding('hoisted', path.get('id'), path);
      } else if (path.isVariableDeclaration()) {
        const declarations = path.get('declarations');
        for (const declar of declarations) {
          this.registerBinding(path.node.kind, declar);
        }
      } else if (path.isClassDeclaration()) {
        this.registerBinding('let', path);
      } else if (path.isImportDeclaration()) {
        const specifiers = path.get('specifiers');
        for (const specifier of specifiers) {
          this.registerBinding('module', specifier);
        }
      } else if (path.isExportDeclaration()) {
        const declar = path.get('declaration');
        if (
          declar.isClassDeclaration() ||
          declar.isFunctionDeclaration() ||
          declar.isVariableDeclaration()
        ) {
          this.registerDeclaration(declar);
        }
      } else {
        this.registerBinding('unknown', path);
      }
    }
    buildUndefinedNode() {
      return t.unaryExpression('void', t.numericLiteral(0), true);
    }
    registerConstantViolation(path) {
      const ids = path.getBindingIdentifiers();
      for (const name of Object.keys(ids)) {
        const binding = this.getBinding(name);
        if (binding) binding.reassign(path);
      }
    }
    registerBinding(kind, path, bindingPath = path) {
      if (!kind) throw new ReferenceError('no `kind`');
      if (path.isVariableDeclaration()) {
        const declarators = path.get('declarations');
        for (const declar of declarators) {
          this.registerBinding(kind, declar);
        }
        return;
      }
      const parent = this.getProgramParent();
      const ids = path.getOuterBindingIdentifiers(true);
      for (const name of Object.keys(ids)) {
        for (const id of ids[name]) {
          const local = this.getOwnBinding(name);
          if (local) {
            if (local.identifier === id) continue;
            this.checkBlockScopedCollisions(local, kind, name, id);
          }
          parent.references[name] = true;
          if (local) {
            this.registerConstantViolation(bindingPath);
          } else {
            this.bindings[name] = new _binding.default({
              identifier: id,
              scope: this,
              path: bindingPath,
              kind: kind,
            });
          }
        }
      }
    }
    addGlobal(node) {
      this.globals[node.name] = node;
    }
    hasUid(name) {
      let scope = this;
      do {
        if (scope.uids[name]) return true;
      } while ((scope = scope.parent));
      return false;
    }
    hasGlobal(name) {
      let scope = this;
      do {
        if (scope.globals[name]) return true;
      } while ((scope = scope.parent));
      return false;
    }
    hasReference(name) {
      let scope = this;
      do {
        if (scope.references[name]) return true;
      } while ((scope = scope.parent));
      return false;
    }
    isPure(node, constantsOnly) {
      if (t.isIdentifier(node)) {
        const binding = this.getBinding(node.name);
        if (!binding) return false;
        if (constantsOnly) return binding.constant;
        return true;
      } else if (t.isClass(node)) {
        if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
          return false;
        }
        return this.isPure(node.body, constantsOnly);
      } else if (t.isClassBody(node)) {
        for (const method of node.body) {
          if (!this.isPure(method, constantsOnly)) return false;
        }
        return true;
      } else if (t.isBinary(node)) {
        return (
          this.isPure(node.left, constantsOnly) &&
          this.isPure(node.right, constantsOnly)
        );
      } else if (t.isArrayExpression(node)) {
        for (const elem of node.elements) {
          if (!this.isPure(elem, constantsOnly)) return false;
        }
        return true;
      } else if (t.isObjectExpression(node)) {
        for (const prop of node.properties) {
          if (!this.isPure(prop, constantsOnly)) return false;
        }
        return true;
      } else if (t.isClassMethod(node)) {
        if (node.computed && !this.isPure(node.key, constantsOnly))
          return false;
        if (node.kind === 'get' || node.kind === 'set') return false;
        return true;
      } else if (t.isProperty(node)) {
        if (node.computed && !this.isPure(node.key, constantsOnly))
          return false;
        return this.isPure(node.value, constantsOnly);
      } else if (t.isUnaryExpression(node)) {
        return this.isPure(node.argument, constantsOnly);
      } else if (t.isTaggedTemplateExpression(node)) {
        return (
          t.matchesPattern(node.tag, 'String.raw') &&
          !this.hasBinding('String', true) &&
          this.isPure(node.quasi, constantsOnly)
        );
      } else if (t.isTemplateLiteral(node)) {
        for (const expression of node.expressions) {
          if (!this.isPure(expression, constantsOnly)) return false;
        }
        return true;
      } else {
        return t.isPureish(node);
      }
    }
    setData(key, val) {
      return (this.data[key] = val);
    }
    getData(key) {
      let scope = this;
      do {
        const data = scope.data[key];
        if (data != null) return data;
      } while ((scope = scope.parent));
    }
    removeData(key) {
      let scope = this;
      do {
        const data = scope.data[key];
        if (data != null) scope.data[key] = null;
      } while ((scope = scope.parent));
    }
    init() {
      if (!this.references) this.crawl();
    }
    crawl() {
      const path = this.path;
      this.references = Object.create(null);
      this.bindings = Object.create(null);
      this.globals = Object.create(null);
      this.uids = Object.create(null);
      this.data = Object.create(null);
      if (path.isLoop()) {
        for (const key of t.FOR_INIT_KEYS) {
          const node = path.get(key);
          if (node.isBlockScoped()) this.registerBinding(node.node.kind, node);
        }
      }
      if (path.isFunctionExpression() && path.has('id')) {
        if (!path.get('id').node[t.NOT_LOCAL_BINDING]) {
          this.registerBinding('local', path.get('id'), path);
        }
      }
      if (path.isClassExpression() && path.has('id')) {
        if (!path.get('id').node[t.NOT_LOCAL_BINDING]) {
          this.registerBinding('local', path);
        }
      }
      if (path.isFunction()) {
        const params = path.get('params');
        for (const param of params) {
          this.registerBinding('param', param);
        }
      }
      if (path.isCatchClause()) {
        this.registerBinding('let', path);
      }
      const parent = this.getProgramParent();
      if (parent.crawling) return;
      const state = {references: [], constantViolations: [], assignments: []};
      this.crawling = true;
      path.traverse(collectorVisitor, state);
      this.crawling = false;
      for (const path of state.assignments) {
        const ids = path.getBindingIdentifiers();
        let programParent;
        for (const name of Object.keys(ids)) {
          if (path.scope.getBinding(name)) continue;
          programParent = programParent || path.scope.getProgramParent();
          programParent.addGlobal(ids[name]);
        }
        path.scope.registerConstantViolation(path);
      }
      for (const ref of state.references) {
        const binding = ref.scope.getBinding(ref.node.name);
        if (binding) {
          binding.reference(ref);
        } else {
          ref.scope.getProgramParent().addGlobal(ref.node);
        }
      }
      for (const path of state.constantViolations) {
        path.scope.registerConstantViolation(path);
      }
    }
    push(opts) {
      let path = this.path;
      if (!path.isBlockStatement() && !path.isProgram()) {
        path = this.getBlockParent().path;
      }
      if (path.isSwitchStatement()) {
        path = (this.getFunctionParent() || this.getProgramParent()).path;
      }
      if (path.isLoop() || path.isCatchClause() || path.isFunction()) {
        path.ensureBlock();
        path = path.get('body');
      }
      const unique = opts.unique;
      const kind = opts.kind || 'var';
      const blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
      const dataKey = `declaration:${kind}:${blockHoist}`;
      let declarPath = !unique && path.getData(dataKey);
      if (!declarPath) {
        const declar = t.variableDeclaration(kind, []);
        declar._blockHoist = blockHoist;
        [declarPath] = path.unshiftContainer('body', [declar]);
        if (!unique) path.setData(dataKey, declarPath);
      }
      const declarator = t.variableDeclarator(opts.id, opts.init);
      declarPath.node.declarations.push(declarator);
      this.registerBinding(kind, declarPath.get('declarations').pop());
    }
    getProgramParent() {
      let scope = this;
      do {
        if (scope.path.isProgram()) {
          return scope;
        }
      } while ((scope = scope.parent));
      throw new Error("Couldn't find a Program");
    }
    getFunctionParent() {
      let scope = this;
      do {
        if (scope.path.isFunctionParent()) {
          return scope;
        }
      } while ((scope = scope.parent));
      return null;
    }
    getBlockParent() {
      let scope = this;
      do {
        if (scope.path.isBlockParent()) {
          return scope;
        }
      } while ((scope = scope.parent));
      throw new Error(
        "We couldn't find a BlockStatement, For, Switch, Function, Loop or Program..."
      );
    }
    getAllBindings() {
      const ids = Object.create(null);
      let scope = this;
      do {
        (0, _defaults.default)(ids, scope.bindings);
        scope = scope.parent;
      } while (scope);
      return ids;
    }
    getAllBindingsOfKind() {
      const ids = Object.create(null);
      for (const kind of arguments) {
        let scope = this;
        do {
          for (const name of Object.keys(scope.bindings)) {
            const binding = scope.bindings[name];
            if (binding.kind === kind) ids[name] = binding;
          }
          scope = scope.parent;
        } while (scope);
      }
      return ids;
    }
    bindingIdentifierEquals(name, node) {
      return this.getBindingIdentifier(name) === node;
    }
    getBinding(name) {
      let scope = this;
      do {
        const binding = scope.getOwnBinding(name);
        if (binding) return binding;
      } while ((scope = scope.parent));
    }
    getOwnBinding(name) {
      return this.bindings[name];
    }
    getBindingIdentifier(name) {
      const info = this.getBinding(name);
      return info && info.identifier;
    }
    getOwnBindingIdentifier(name) {
      const binding = this.bindings[name];
      return binding && binding.identifier;
    }
    hasOwnBinding(name) {
      return !!this.getOwnBinding(name);
    }
    hasBinding(name, noGlobals) {
      if (!name) return false;
      if (this.hasOwnBinding(name)) return true;
      if (this.parentHasBinding(name, noGlobals)) return true;
      if (this.hasUid(name)) return true;
      if (!noGlobals && (0, _includes.default)(Scope.globals, name))
        return true;
      if (!noGlobals && (0, _includes.default)(Scope.contextVariables, name))
        return true;
      return false;
    }
    parentHasBinding(name, noGlobals) {
      return this.parent && this.parent.hasBinding(name, noGlobals);
    }
    moveBindingTo(name, scope) {
      const info = this.getBinding(name);
      if (info) {
        info.scope.removeOwnBinding(name);
        info.scope = scope;
        scope.bindings[name] = info;
      }
    }
    removeOwnBinding(name) {
      delete this.bindings[name];
    }
    removeBinding(name) {
      const info = this.getBinding(name);
      if (info) {
        info.scope.removeOwnBinding(name);
      }
      let scope = this;
      do {
        if (scope.uids[name]) {
          scope.uids[name] = false;
        }
      } while ((scope = scope.parent));
    }
  }
  scope.default = Scope;
  Scope.globals = Object.keys(_globals.default.builtin);
  Scope.contextVariables = ['arguments', 'undefined', 'Infinity', 'NaN'];
  return scope;
}
var lib$a = {};
var sourceMap$2 = {};
var hasRequiredSourceMap$1;
function requireSourceMap$1() {
  if (hasRequiredSourceMap$1) return sourceMap$2;
  hasRequiredSourceMap$1 = 1;
  Object.defineProperty(sourceMap$2, '__esModule', {value: true});
  sourceMap$2.default = void 0;
  var _genMapping = requireGenMapping_umd();
  var _traceMapping = requireTraceMapping_umd();
  class SourceMap {
    constructor(opts, code) {
      var _opts$sourceFileName;
      this._map = void 0;
      this._rawMappings = void 0;
      this._sourceFileName = void 0;
      this._lastGenLine = 0;
      this._lastSourceLine = 0;
      this._lastSourceColumn = 0;
      this._inputMap = void 0;
      const map = (this._map = new _genMapping.GenMapping({
        sourceRoot: opts.sourceRoot,
      }));
      this._sourceFileName =
        (_opts$sourceFileName = opts.sourceFileName) == null
          ? void 0
          : _opts$sourceFileName.replace(/\\/g, '/');
      this._rawMappings = undefined;
      if (opts.inputSourceMap) {
        this._inputMap = new _traceMapping.TraceMap(opts.inputSourceMap);
        const resolvedSources = this._inputMap.resolvedSources;
        if (resolvedSources.length) {
          for (let i = 0; i < resolvedSources.length; i++) {
            var _this$_inputMap$sourc;
            (0, _genMapping.setSourceContent)(
              map,
              resolvedSources[i],
              (_this$_inputMap$sourc = this._inputMap.sourcesContent) == null
                ? void 0
                : _this$_inputMap$sourc[i]
            );
          }
        }
      }
      if (typeof code === 'string' && !opts.inputSourceMap) {
        (0, _genMapping.setSourceContent)(map, this._sourceFileName, code);
      } else if (typeof code === 'object') {
        for (const sourceFileName of Object.keys(code)) {
          (0, _genMapping.setSourceContent)(
            map,
            sourceFileName.replace(/\\/g, '/'),
            code[sourceFileName]
          );
        }
      }
    }
    get() {
      return (0, _genMapping.toEncodedMap)(this._map);
    }
    getDecoded() {
      return (0, _genMapping.toDecodedMap)(this._map);
    }
    getRawMappings() {
      return (
        this._rawMappings ||
        (this._rawMappings = (0, _genMapping.allMappings)(this._map))
      );
    }
    mark(generated, line, column, identifierName, identifierNamePos, filename) {
      var _originalMapping;
      this._rawMappings = undefined;
      let originalMapping;
      if (line != null) {
        if (this._inputMap) {
          originalMapping = (0, _traceMapping.originalPositionFor)(
            this._inputMap,
            {line: line, column: column}
          );
          if (!originalMapping.name && identifierNamePos) {
            const originalIdentifierMapping = (0,
            _traceMapping.originalPositionFor)(
              this._inputMap,
              identifierNamePos
            );
            if (originalIdentifierMapping.name) {
              identifierName = originalIdentifierMapping.name;
            }
          }
        } else {
          originalMapping = {
            source:
              (filename == null ? void 0 : filename.replace(/\\/g, '/')) ||
              this._sourceFileName,
            line: line,
            column: column,
          };
        }
      }
      (0, _genMapping.maybeAddMapping)(this._map, {
        name: identifierName,
        generated: generated,
        source:
          (_originalMapping = originalMapping) == null
            ? void 0
            : _originalMapping.source,
        original: originalMapping,
      });
    }
  }
  sourceMap$2.default = SourceMap;
  return sourceMap$2;
}
var printer$2 = {};
var buffer$4 = {};
var hasRequiredBuffer;
function requireBuffer() {
  if (hasRequiredBuffer) return buffer$4;
  hasRequiredBuffer = 1;
  Object.defineProperty(buffer$4, '__esModule', {value: true});
  buffer$4.default = void 0;
  class Buffer {
    constructor(map, indentChar) {
      this._map = null;
      this._buf = '';
      this._str = '';
      this._appendCount = 0;
      this._last = 0;
      this._queue = [];
      this._queueCursor = 0;
      this._canMarkIdName = true;
      this._indentChar = '';
      this._fastIndentations = [];
      this._position = {line: 1, column: 0};
      this._sourcePosition = {
        identifierName: undefined,
        identifierNamePos: undefined,
        line: undefined,
        column: undefined,
        filename: undefined,
      };
      this._map = map;
      this._indentChar = indentChar;
      for (let i = 0; i < 64; i++) {
        this._fastIndentations.push(indentChar.repeat(i));
      }
      this._allocQueue();
    }
    _allocQueue() {
      const queue = this._queue;
      for (let i = 0; i < 16; i++) {
        queue.push({
          char: 0,
          repeat: 1,
          line: undefined,
          column: undefined,
          identifierName: undefined,
          identifierNamePos: undefined,
          filename: '',
        });
      }
    }
    _pushQueue(char, repeat, line, column, filename) {
      const cursor = this._queueCursor;
      if (cursor === this._queue.length) {
        this._allocQueue();
      }
      const item = this._queue[cursor];
      item.char = char;
      item.repeat = repeat;
      item.line = line;
      item.column = column;
      item.filename = filename;
      this._queueCursor++;
    }
    _popQueue() {
      if (this._queueCursor === 0) {
        throw new Error('Cannot pop from empty queue');
      }
      return this._queue[--this._queueCursor];
    }
    get() {
      this._flush();
      const map = this._map;
      const result = {
        code: (this._buf + this._str).trimRight(),
        decodedMap: map == null ? void 0 : map.getDecoded(),
        get __mergedMap() {
          return this.map;
        },
        get map() {
          const resultMap = map ? map.get() : null;
          result.map = resultMap;
          return resultMap;
        },
        set map(value) {
          Object.defineProperty(result, 'map', {value: value, writable: true});
        },
        get rawMappings() {
          const mappings = map == null ? void 0 : map.getRawMappings();
          result.rawMappings = mappings;
          return mappings;
        },
        set rawMappings(value) {
          Object.defineProperty(result, 'rawMappings', {
            value: value,
            writable: true,
          });
        },
      };
      return result;
    }
    append(str, maybeNewline) {
      this._flush();
      this._append(str, this._sourcePosition, maybeNewline);
    }
    appendChar(char) {
      this._flush();
      this._appendChar(char, 1, this._sourcePosition);
    }
    queue(char) {
      if (char === 10) {
        while (this._queueCursor !== 0) {
          const char = this._queue[this._queueCursor - 1].char;
          if (char !== 32 && char !== 9) {
            break;
          }
          this._queueCursor--;
        }
      }
      const sourcePosition = this._sourcePosition;
      this._pushQueue(
        char,
        1,
        sourcePosition.line,
        sourcePosition.column,
        sourcePosition.filename
      );
    }
    queueIndentation(repeat) {
      if (repeat === 0) return;
      this._pushQueue(-1, repeat, undefined, undefined, undefined);
    }
    _flush() {
      const queueCursor = this._queueCursor;
      const queue = this._queue;
      for (let i = 0; i < queueCursor; i++) {
        const item = queue[i];
        this._appendChar(item.char, item.repeat, item);
      }
      this._queueCursor = 0;
    }
    _appendChar(char, repeat, sourcePos) {
      this._last = char;
      if (char === -1) {
        const fastIndentation = this._fastIndentations[repeat];
        if (fastIndentation !== undefined) {
          this._str += fastIndentation;
        } else {
          this._str +=
            repeat > 1 ? this._indentChar.repeat(repeat) : this._indentChar;
        }
      } else {
        this._str +=
          repeat > 1
            ? String.fromCharCode(char).repeat(repeat)
            : String.fromCharCode(char);
      }
      if (char !== 10) {
        this._mark(
          sourcePos.line,
          sourcePos.column,
          sourcePos.identifierName,
          sourcePos.identifierNamePos,
          sourcePos.filename
        );
        this._position.column += repeat;
      } else {
        this._position.line++;
        this._position.column = 0;
      }
      if (this._canMarkIdName) {
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
    }
    _append(str, sourcePos, maybeNewline) {
      const len = str.length;
      const position = this._position;
      this._last = str.charCodeAt(len - 1);
      if (++this._appendCount > 4096) {
        +this._str;
        this._buf += this._str;
        this._str = str;
        this._appendCount = 0;
      } else {
        this._str += str;
      }
      if (!maybeNewline && !this._map) {
        position.column += len;
        return;
      }
      const {
        column: column,
        identifierName: identifierName,
        identifierNamePos: identifierNamePos,
        filename: filename,
      } = sourcePos;
      let line = sourcePos.line;
      if (
        (identifierName != null || identifierNamePos != null) &&
        this._canMarkIdName
      ) {
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
      let i = str.indexOf('\n');
      let last = 0;
      if (i !== 0) {
        this._mark(line, column, identifierName, identifierNamePos, filename);
      }
      while (i !== -1) {
        position.line++;
        position.column = 0;
        last = i + 1;
        if (last < len && line !== undefined) {
          this._mark(++line, 0, null, null, filename);
        }
        i = str.indexOf('\n', last);
      }
      position.column += len - last;
    }
    _mark(line, column, identifierName, identifierNamePos, filename) {
      var _this$_map;
      (_this$_map = this._map) == null ||
        _this$_map.mark(
          this._position,
          line,
          column,
          identifierName,
          identifierNamePos,
          filename
        );
    }
    removeTrailingNewline() {
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 10) {
        this._queueCursor--;
      }
    }
    removeLastSemicolon() {
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 59) {
        this._queueCursor--;
      }
    }
    getLastChar() {
      const queueCursor = this._queueCursor;
      return queueCursor !== 0 ? this._queue[queueCursor - 1].char : this._last;
    }
    getNewlineCount() {
      const queueCursor = this._queueCursor;
      let count = 0;
      if (queueCursor === 0) return this._last === 10 ? 1 : 0;
      for (let i = queueCursor - 1; i >= 0; i--) {
        if (this._queue[i].char !== 10) {
          break;
        }
        count++;
      }
      return count === queueCursor && this._last === 10 ? count + 1 : count;
    }
    endsWithCharAndNewline() {
      const queue = this._queue;
      const queueCursor = this._queueCursor;
      if (queueCursor !== 0) {
        const lastCp = queue[queueCursor - 1].char;
        if (lastCp !== 10) return;
        if (queueCursor > 1) {
          return queue[queueCursor - 2].char;
        } else {
          return this._last;
        }
      }
    }
    hasContent() {
      return this._queueCursor !== 0 || !!this._last;
    }
    exactSource(loc, cb) {
      if (!this._map) {
        cb();
        return;
      }
      this.source('start', loc);
      const identifierName = loc.identifierName;
      const sourcePos = this._sourcePosition;
      if (identifierName) {
        this._canMarkIdName = false;
        sourcePos.identifierName = identifierName;
      }
      cb();
      if (identifierName) {
        this._canMarkIdName = true;
        sourcePos.identifierName = undefined;
        sourcePos.identifierNamePos = undefined;
      }
      this.source('end', loc);
    }
    source(prop, loc) {
      if (!this._map) return;
      this._normalizePosition(prop, loc, 0);
    }
    sourceWithOffset(prop, loc, columnOffset) {
      if (!this._map) return;
      this._normalizePosition(prop, loc, columnOffset);
    }
    _normalizePosition(prop, loc, columnOffset) {
      const pos = loc[prop];
      const target = this._sourcePosition;
      if (pos) {
        target.line = pos.line;
        target.column = Math.max(pos.column + columnOffset, 0);
        target.filename = loc.filename;
      }
    }
    getCurrentColumn() {
      const queue = this._queue;
      const queueCursor = this._queueCursor;
      let lastIndex = -1;
      let len = 0;
      for (let i = 0; i < queueCursor; i++) {
        const item = queue[i];
        if (item.char === 10) {
          lastIndex = len;
        }
        len += item.repeat;
      }
      return lastIndex === -1
        ? this._position.column + len
        : len - 1 - lastIndex;
    }
    getCurrentLine() {
      let count = 0;
      const queue = this._queue;
      for (let i = 0; i < this._queueCursor; i++) {
        if (queue[i].char === 10) {
          count++;
        }
      }
      return this._position.line + count;
    }
  }
  buffer$4.default = Buffer;
  return buffer$4;
}
var node$1 = {};
var whitespace$2 = {};
var hasRequiredWhitespace;
function requireWhitespace() {
  if (hasRequiredWhitespace) return whitespace$2;
  hasRequiredWhitespace = 1;
  Object.defineProperty(whitespace$2, '__esModule', {value: true});
  whitespace$2.nodes = void 0;
  var _t = t$d;
  const {
    FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS,
    isArrayExpression: isArrayExpression,
    isAssignmentExpression: isAssignmentExpression,
    isBinary: isBinary,
    isBlockStatement: isBlockStatement,
    isCallExpression: isCallExpression,
    isFunction: isFunction,
    isIdentifier: isIdentifier,
    isLiteral: isLiteral,
    isMemberExpression: isMemberExpression,
    isObjectExpression: isObjectExpression,
    isOptionalCallExpression: isOptionalCallExpression,
    isOptionalMemberExpression: isOptionalMemberExpression,
    isStringLiteral: isStringLiteral,
  } = _t;
  function crawlInternal(node, state) {
    if (!node) return state;
    if (isMemberExpression(node) || isOptionalMemberExpression(node)) {
      crawlInternal(node.object, state);
      if (node.computed) crawlInternal(node.property, state);
    } else if (isBinary(node) || isAssignmentExpression(node)) {
      crawlInternal(node.left, state);
      crawlInternal(node.right, state);
    } else if (isCallExpression(node) || isOptionalCallExpression(node)) {
      state.hasCall = true;
      crawlInternal(node.callee, state);
    } else if (isFunction(node)) {
      state.hasFunction = true;
    } else if (isIdentifier(node)) {
      state.hasHelper =
        state.hasHelper || (node.callee && isHelper(node.callee));
    }
    return state;
  }
  function crawl(node) {
    return crawlInternal(node, {
      hasCall: false,
      hasFunction: false,
      hasHelper: false,
    });
  }
  function isHelper(node) {
    if (!node) return false;
    if (isMemberExpression(node)) {
      return isHelper(node.object) || isHelper(node.property);
    } else if (isIdentifier(node)) {
      return node.name === 'require' || node.name.charCodeAt(0) === 95;
    } else if (isCallExpression(node)) {
      return isHelper(node.callee);
    } else if (isBinary(node) || isAssignmentExpression(node)) {
      return (
        (isIdentifier(node.left) && isHelper(node.left)) || isHelper(node.right)
      );
    } else {
      return false;
    }
  }
  function isType(node) {
    return (
      isLiteral(node) ||
      isObjectExpression(node) ||
      isArrayExpression(node) ||
      isIdentifier(node) ||
      isMemberExpression(node)
    );
  }
  const nodes = (whitespace$2.nodes = {
    AssignmentExpression(node) {
      const state = crawl(node.right);
      if ((state.hasCall && state.hasHelper) || state.hasFunction) {
        return state.hasFunction ? 1 | 2 : 2;
      }
    },
    SwitchCase(node, parent) {
      return (
        (!!node.consequent.length || parent.cases[0] === node ? 1 : 0) |
        (!node.consequent.length &&
        parent.cases[parent.cases.length - 1] === node
          ? 2
          : 0)
      );
    },
    LogicalExpression(node) {
      if (isFunction(node.left) || isFunction(node.right)) {
        return 2;
      }
    },
    Literal(node) {
      if (isStringLiteral(node) && node.value === 'use strict') {
        return 2;
      }
    },
    CallExpression(node) {
      if (isFunction(node.callee) || isHelper(node)) {
        return 1 | 2;
      }
    },
    OptionalCallExpression(node) {
      if (isFunction(node.callee)) {
        return 1 | 2;
      }
    },
    VariableDeclaration(node) {
      for (let i = 0; i < node.declarations.length; i++) {
        const declar = node.declarations[i];
        let enabled = isHelper(declar.id) && !isType(declar.init);
        if (!enabled && declar.init) {
          const state = crawl(declar.init);
          enabled =
            (isHelper(declar.init) && state.hasCall) || state.hasFunction;
        }
        if (enabled) {
          return 1 | 2;
        }
      }
    },
    IfStatement(node) {
      if (isBlockStatement(node.consequent)) {
        return 1 | 2;
      }
    },
  });
  nodes.ObjectProperty =
    nodes.ObjectTypeProperty =
    nodes.ObjectMethod =
      function (node, parent) {
        if (parent.properties[0] === node) {
          return 1;
        }
      };
  nodes.ObjectTypeCallProperty = function (node, parent) {
    var _parent$properties;
    if (
      parent.callProperties[0] === node &&
      !(
        (_parent$properties = parent.properties) != null &&
        _parent$properties.length
      )
    ) {
      return 1;
    }
  };
  nodes.ObjectTypeIndexer = function (node, parent) {
    var _parent$properties2, _parent$callPropertie;
    if (
      parent.indexers[0] === node &&
      !(
        (_parent$properties2 = parent.properties) != null &&
        _parent$properties2.length
      ) &&
      !(
        (_parent$callPropertie = parent.callProperties) != null &&
        _parent$callPropertie.length
      )
    ) {
      return 1;
    }
  };
  nodes.ObjectTypeInternalSlot = function (node, parent) {
    var _parent$properties3, _parent$callPropertie2, _parent$indexers;
    if (
      parent.internalSlots[0] === node &&
      !(
        (_parent$properties3 = parent.properties) != null &&
        _parent$properties3.length
      ) &&
      !(
        (_parent$callPropertie2 = parent.callProperties) != null &&
        _parent$callPropertie2.length
      ) &&
      !((_parent$indexers = parent.indexers) != null && _parent$indexers.length)
    ) {
      return 1;
    }
  };
  [
    ['Function', true],
    ['Class', true],
    ['Loop', true],
    ['LabeledStatement', true],
    ['SwitchStatement', true],
    ['TryStatement', true],
  ].forEach(function ([type, amounts]) {
    [type].concat(FLIPPED_ALIAS_KEYS[type] || []).forEach(function (type) {
      const ret = amounts ? 1 | 2 : 0;
      nodes[type] = () => ret;
    });
  });
  return whitespace$2;
}
var parentheses$1 = {};
var hasRequiredParentheses;
function requireParentheses() {
  if (hasRequiredParentheses) return parentheses$1;
  hasRequiredParentheses = 1;
  Object.defineProperty(parentheses$1, '__esModule', {value: true});
  parentheses$1.AssignmentExpression = AssignmentExpression;
  parentheses$1.Binary = Binary;
  parentheses$1.BinaryExpression = BinaryExpression;
  parentheses$1.ClassExpression = ClassExpression;
  parentheses$1.ArrowFunctionExpression = parentheses$1.ConditionalExpression =
    ConditionalExpression;
  parentheses$1.DoExpression = DoExpression;
  parentheses$1.FunctionExpression = FunctionExpression;
  parentheses$1.FunctionTypeAnnotation = FunctionTypeAnnotation;
  parentheses$1.Identifier = Identifier;
  parentheses$1.LogicalExpression = LogicalExpression;
  parentheses$1.NullableTypeAnnotation = NullableTypeAnnotation;
  parentheses$1.ObjectExpression = ObjectExpression;
  parentheses$1.OptionalIndexedAccessType = OptionalIndexedAccessType;
  parentheses$1.OptionalCallExpression =
    parentheses$1.OptionalMemberExpression = OptionalMemberExpression;
  parentheses$1.SequenceExpression = SequenceExpression;
  parentheses$1.TSSatisfiesExpression = parentheses$1.TSAsExpression =
    TSAsExpression;
  parentheses$1.TSInferType = TSInferType;
  parentheses$1.TSInstantiationExpression = TSInstantiationExpression;
  parentheses$1.UnaryLike = parentheses$1.TSTypeAssertion = UnaryLike;
  parentheses$1.TSIntersectionType = parentheses$1.TSUnionType = TSUnionType;
  parentheses$1.IntersectionTypeAnnotation = parentheses$1.UnionTypeAnnotation =
    UnionTypeAnnotation;
  parentheses$1.UpdateExpression = UpdateExpression;
  parentheses$1.AwaitExpression = parentheses$1.YieldExpression =
    YieldExpression;
  var _t = t$d;
  var _index = requireNode();
  const {
    isArrayTypeAnnotation: isArrayTypeAnnotation,
    isBinaryExpression: isBinaryExpression,
    isCallExpression: isCallExpression,
    isForOfStatement: isForOfStatement,
    isIndexedAccessType: isIndexedAccessType,
    isMemberExpression: isMemberExpression,
    isObjectPattern: isObjectPattern,
    isOptionalMemberExpression: isOptionalMemberExpression,
    isYieldExpression: isYieldExpression,
    isStatement: isStatement,
  } = _t;
  const PRECEDENCE = new Map([
    ['||', 0],
    ['??', 0],
    ['|>', 0],
    ['&&', 1],
    ['|', 2],
    ['^', 3],
    ['&', 4],
    ['==', 5],
    ['===', 5],
    ['!=', 5],
    ['!==', 5],
    ['<', 6],
    ['>', 6],
    ['<=', 6],
    ['>=', 6],
    ['in', 6],
    ['instanceof', 6],
    ['>>', 7],
    ['<<', 7],
    ['>>>', 7],
    ['+', 8],
    ['-', 8],
    ['*', 9],
    ['/', 9],
    ['%', 9],
    ['**', 10],
  ]);
  function getBinaryPrecedence(node, nodeType) {
    if (nodeType === 'BinaryExpression' || nodeType === 'LogicalExpression') {
      return PRECEDENCE.get(node.operator);
    }
    if (nodeType === 'TSAsExpression' || nodeType === 'TSSatisfiesExpression') {
      return PRECEDENCE.get('in');
    }
  }
  function isTSTypeExpression(nodeType) {
    return (
      nodeType === 'TSAsExpression' ||
      nodeType === 'TSSatisfiesExpression' ||
      nodeType === 'TSTypeAssertion'
    );
  }
  const isClassExtendsClause = (node, parent) => {
    const parentType = parent.type;
    return (
      (parentType === 'ClassDeclaration' || parentType === 'ClassExpression') &&
      parent.superClass === node
    );
  };
  const hasPostfixPart = (node, parent) => {
    const parentType = parent.type;
    return (
      ((parentType === 'MemberExpression' ||
        parentType === 'OptionalMemberExpression') &&
        parent.object === node) ||
      ((parentType === 'CallExpression' ||
        parentType === 'OptionalCallExpression' ||
        parentType === 'NewExpression') &&
        parent.callee === node) ||
      (parentType === 'TaggedTemplateExpression' && parent.tag === node) ||
      parentType === 'TSNonNullExpression'
    );
  };
  function NullableTypeAnnotation(node, parent) {
    return isArrayTypeAnnotation(parent);
  }
  function FunctionTypeAnnotation(node, parent, tokenContext) {
    const parentType = parent.type;
    return (
      parentType === 'UnionTypeAnnotation' ||
      parentType === 'IntersectionTypeAnnotation' ||
      parentType === 'ArrayTypeAnnotation' ||
      Boolean(tokenContext & _index.TokenContext.arrowFlowReturnType)
    );
  }
  function UpdateExpression(node, parent) {
    return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
  }
  function needsParenBeforeExpressionBrace(tokenContext) {
    return Boolean(
      tokenContext &
        (_index.TokenContext.expressionStatement |
          _index.TokenContext.arrowBody)
    );
  }
  function ObjectExpression(node, parent, tokenContext) {
    return needsParenBeforeExpressionBrace(tokenContext);
  }
  function DoExpression(node, parent, tokenContext) {
    return (
      !node.async &&
      Boolean(tokenContext & _index.TokenContext.expressionStatement)
    );
  }
  function Binary(node, parent) {
    const parentType = parent.type;
    if (
      node.type === 'BinaryExpression' &&
      node.operator === '**' &&
      parentType === 'BinaryExpression' &&
      parent.operator === '**'
    ) {
      return parent.left === node;
    }
    if (isClassExtendsClause(node, parent)) {
      return true;
    }
    if (
      hasPostfixPart(node, parent) ||
      parentType === 'UnaryExpression' ||
      parentType === 'SpreadElement' ||
      parentType === 'AwaitExpression'
    ) {
      return true;
    }
    const parentPos = getBinaryPrecedence(parent, parentType);
    if (parentPos != null) {
      const nodePos = getBinaryPrecedence(node, node.type);
      if (
        (parentPos === nodePos &&
          parentType === 'BinaryExpression' &&
          parent.right === node) ||
        parentPos > nodePos
      ) {
        return true;
      }
    }
    return undefined;
  }
  function UnionTypeAnnotation(node, parent) {
    const parentType = parent.type;
    return (
      parentType === 'ArrayTypeAnnotation' ||
      parentType === 'NullableTypeAnnotation' ||
      parentType === 'IntersectionTypeAnnotation' ||
      parentType === 'UnionTypeAnnotation'
    );
  }
  function OptionalIndexedAccessType(node, parent) {
    return isIndexedAccessType(parent) && parent.objectType === node;
  }
  function TSAsExpression(node, parent) {
    if (
      (parent.type === 'AssignmentExpression' ||
        parent.type === 'AssignmentPattern') &&
      parent.left === node
    ) {
      return true;
    }
    if (
      parent.type === 'BinaryExpression' &&
      (parent.operator === '|' || parent.operator === '&') &&
      node === parent.left
    ) {
      return true;
    }
    return Binary(node, parent);
  }
  function TSUnionType(node, parent) {
    const parentType = parent.type;
    return (
      parentType === 'TSArrayType' ||
      parentType === 'TSOptionalType' ||
      parentType === 'TSIntersectionType' ||
      parentType === 'TSRestType'
    );
  }
  function TSInferType(node, parent) {
    const parentType = parent.type;
    return parentType === 'TSArrayType' || parentType === 'TSOptionalType';
  }
  function TSInstantiationExpression(node, parent) {
    const parentType = parent.type;
    return (
      (parentType === 'CallExpression' ||
        parentType === 'OptionalCallExpression' ||
        parentType === 'NewExpression' ||
        parentType === 'TSInstantiationExpression') &&
      !!parent.typeParameters
    );
  }
  function BinaryExpression(node, parent, tokenContext, inForStatementInit) {
    return node.operator === 'in' && inForStatementInit;
  }
  function SequenceExpression(node, parent) {
    const parentType = parent.type;
    if (
      parentType === 'SequenceExpression' ||
      parentType === 'ParenthesizedExpression' ||
      (parentType === 'MemberExpression' && parent.property === node) ||
      (parentType === 'OptionalMemberExpression' && parent.property === node) ||
      parentType === 'TemplateLiteral'
    ) {
      return false;
    }
    if (parentType === 'ClassDeclaration') {
      return true;
    }
    if (parentType === 'ForOfStatement') {
      return parent.right === node;
    }
    if (parentType === 'ExportDefaultDeclaration') {
      return true;
    }
    return !isStatement(parent);
  }
  function YieldExpression(node, parent) {
    const parentType = parent.type;
    return (
      parentType === 'BinaryExpression' ||
      parentType === 'LogicalExpression' ||
      parentType === 'UnaryExpression' ||
      parentType === 'SpreadElement' ||
      hasPostfixPart(node, parent) ||
      (parentType === 'AwaitExpression' && isYieldExpression(node)) ||
      (parentType === 'ConditionalExpression' && node === parent.test) ||
      isClassExtendsClause(node, parent) ||
      isTSTypeExpression(parentType)
    );
  }
  function ClassExpression(node, parent, tokenContext) {
    return Boolean(
      tokenContext &
        (_index.TokenContext.expressionStatement |
          _index.TokenContext.exportDefault)
    );
  }
  function UnaryLike(node, parent) {
    return (
      hasPostfixPart(node, parent) ||
      (isBinaryExpression(parent) &&
        parent.operator === '**' &&
        parent.left === node) ||
      isClassExtendsClause(node, parent)
    );
  }
  function FunctionExpression(node, parent, tokenContext) {
    return Boolean(
      tokenContext &
        (_index.TokenContext.expressionStatement |
          _index.TokenContext.exportDefault)
    );
  }
  function ConditionalExpression(node, parent) {
    const parentType = parent.type;
    if (
      parentType === 'UnaryExpression' ||
      parentType === 'SpreadElement' ||
      parentType === 'BinaryExpression' ||
      parentType === 'LogicalExpression' ||
      (parentType === 'ConditionalExpression' && parent.test === node) ||
      parentType === 'AwaitExpression' ||
      isTSTypeExpression(parentType)
    ) {
      return true;
    }
    return UnaryLike(node, parent);
  }
  function OptionalMemberExpression(node, parent) {
    return (
      (isCallExpression(parent) && parent.callee === node) ||
      (isMemberExpression(parent) && parent.object === node)
    );
  }
  function AssignmentExpression(node, parent, tokenContext) {
    if (
      needsParenBeforeExpressionBrace(tokenContext) &&
      isObjectPattern(node.left)
    ) {
      return true;
    } else {
      return ConditionalExpression(node, parent);
    }
  }
  function LogicalExpression(node, parent) {
    const parentType = parent.type;
    if (isTSTypeExpression(parentType)) return true;
    if (parentType !== 'LogicalExpression') return false;
    switch (node.operator) {
      case '||':
        return parent.operator === '??' || parent.operator === '&&';
      case '&&':
        return parent.operator === '??';
      case '??':
        return parent.operator !== '??';
    }
  }
  function Identifier(
    node,
    parent,
    tokenContext,
    _inForInit,
    getRawIdentifier
  ) {
    var _node$extra;
    const parentType = parent.type;
    if (
      (_node$extra = node.extra) != null &&
      _node$extra.parenthesized &&
      parentType === 'AssignmentExpression' &&
      parent.left === node
    ) {
      const rightType = parent.right.type;
      if (
        (rightType === 'FunctionExpression' ||
          rightType === 'ClassExpression') &&
        parent.right.id == null
      ) {
        return true;
      }
    }
    if (getRawIdentifier && getRawIdentifier(node) !== node.name) {
      return false;
    }
    if (node.name === 'let') {
      const isFollowedByBracket =
        isMemberExpression(parent, {object: node, computed: true}) ||
        isOptionalMemberExpression(parent, {
          object: node,
          computed: true,
          optional: false,
        });
      if (
        isFollowedByBracket &&
        tokenContext &
          (_index.TokenContext.expressionStatement |
            _index.TokenContext.forHead |
            _index.TokenContext.forInHead)
      ) {
        return true;
      }
      return Boolean(tokenContext & _index.TokenContext.forOfHead);
    }
    return (
      node.name === 'async' &&
      isForOfStatement(parent, {left: node, await: false})
    );
  }
  return parentheses$1;
}
var hasRequiredNode;
function requireNode() {
  if (hasRequiredNode) return node$1;
  hasRequiredNode = 1;
  Object.defineProperty(node$1, '__esModule', {value: true});
  node$1.TokenContext = void 0;
  node$1.isLastChild = isLastChild;
  node$1.needsParens = needsParens;
  node$1.needsWhitespace = needsWhitespace;
  node$1.needsWhitespaceAfter = needsWhitespaceAfter;
  node$1.needsWhitespaceBefore = needsWhitespaceBefore;
  var whitespace = requireWhitespace();
  var parens = requireParentheses();
  var _t = t$d;
  const {
    FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS,
    VISITOR_KEYS: VISITOR_KEYS,
    isCallExpression: isCallExpression,
    isDecorator: isDecorator,
    isExpressionStatement: isExpressionStatement,
    isMemberExpression: isMemberExpression,
    isNewExpression: isNewExpression,
    isParenthesizedExpression: isParenthesizedExpression,
  } = _t;
  node$1.TokenContext = {
    expressionStatement: 1,
    arrowBody: 2,
    exportDefault: 4,
    forHead: 8,
    forInHead: 16,
    forOfHead: 32,
    arrowFlowReturnType: 64,
  };
  function expandAliases(obj) {
    const map = new Map();
    function add(type, func) {
      const fn = map.get(type);
      map.set(
        type,
        fn
          ? function (node, parent, stack, inForInit, getRawIdentifier) {
              var _fn;
              return (_fn = fn(
                node,
                parent,
                stack,
                inForInit,
                getRawIdentifier
              )) != null
                ? _fn
                : func(node, parent, stack, inForInit, getRawIdentifier);
            }
          : func
      );
    }
    for (const type of Object.keys(obj)) {
      const aliases = FLIPPED_ALIAS_KEYS[type];
      if (aliases) {
        for (const alias of aliases) {
          add(alias, obj[type]);
        }
      } else {
        add(type, obj[type]);
      }
    }
    return map;
  }
  const expandedParens = expandAliases(parens);
  const expandedWhitespaceNodes = expandAliases(whitespace.nodes);
  function isOrHasCallExpression(node) {
    if (isCallExpression(node)) {
      return true;
    }
    return isMemberExpression(node) && isOrHasCallExpression(node.object);
  }
  function needsWhitespace(node, parent, type) {
    var _expandedWhitespaceNo;
    if (!node) return false;
    if (isExpressionStatement(node)) {
      node = node.expression;
    }
    const flag =
      (_expandedWhitespaceNo = expandedWhitespaceNodes.get(node.type)) == null
        ? void 0
        : _expandedWhitespaceNo(node, parent);
    if (typeof flag === 'number') {
      return (flag & type) !== 0;
    }
    return false;
  }
  function needsWhitespaceBefore(node, parent) {
    return needsWhitespace(node, parent, 1);
  }
  function needsWhitespaceAfter(node, parent) {
    return needsWhitespace(node, parent, 2);
  }
  function needsParens(
    node,
    parent,
    tokenContext,
    inForInit,
    getRawIdentifier
  ) {
    var _expandedParens$get;
    if (!parent) return false;
    if (isNewExpression(parent) && parent.callee === node) {
      if (isOrHasCallExpression(node)) return true;
    }
    if (isDecorator(parent)) {
      return (
        !isDecoratorMemberExpression(node) &&
        !(isCallExpression(node) && isDecoratorMemberExpression(node.callee)) &&
        !isParenthesizedExpression(node)
      );
    }
    return (_expandedParens$get = expandedParens.get(node.type)) == null
      ? void 0
      : _expandedParens$get(
          node,
          parent,
          tokenContext,
          inForInit,
          getRawIdentifier
        );
  }
  function isDecoratorMemberExpression(node) {
    switch (node.type) {
      case 'Identifier':
        return true;
      case 'MemberExpression':
        return (
          !node.computed &&
          node.property.type === 'Identifier' &&
          isDecoratorMemberExpression(node.object)
        );
      default:
        return false;
    }
  }
  function isLastChild(parent, child) {
    const visitorKeys = VISITOR_KEYS[parent.type];
    for (let i = visitorKeys.length - 1; i >= 0; i--) {
      const val = parent[visitorKeys[i]];
      if (val === child) {
        return true;
      } else if (Array.isArray(val)) {
        let j = val.length - 1;
        while (j >= 0 && val[j] === null) j--;
        return j >= 0 && val[j] === child;
      } else if (val) {
        return false;
      }
    }
    return false;
  }
  return node$1;
}
var tokenMap = {};
var hasRequiredTokenMap;
function requireTokenMap() {
  if (hasRequiredTokenMap) return tokenMap;
  hasRequiredTokenMap = 1;
  Object.defineProperty(tokenMap, '__esModule', {value: true});
  tokenMap.TokenMap = void 0;
  var _t = t$d;
  const {traverseFast: traverseFast, VISITOR_KEYS: VISITOR_KEYS} = _t;
  class TokenMap {
    constructor(ast, tokens, source) {
      this._tokens = void 0;
      this._source = void 0;
      this._nodesToTokenIndexes = new Map();
      this._nodesOccurrencesCountCache = new Map();
      this._tokensCache = new Map();
      this._tokens = tokens;
      this._source = source;
      traverseFast(ast, node => {
        const indexes = this._getTokensIndexesOfNode(node);
        if (indexes.length > 0) this._nodesToTokenIndexes.set(node, indexes);
      });
      this._tokensCache = null;
    }
    has(node) {
      return this._nodesToTokenIndexes.has(node);
    }
    getIndexes(node) {
      return this._nodesToTokenIndexes.get(node);
    }
    find(node, condition) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (indexes) {
        for (let k = 0; k < indexes.length; k++) {
          const index = indexes[k];
          const tok = this._tokens[index];
          if (condition(tok, index)) return tok;
        }
      }
      return null;
    }
    findLastIndex(node, condition) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (indexes) {
        for (let k = indexes.length - 1; k >= 0; k--) {
          const index = indexes[k];
          const tok = this._tokens[index];
          if (condition(tok, index)) return index;
        }
      }
      return -1;
    }
    findMatching(node, test, occurrenceCount = 0) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (indexes) {
        let i = 0;
        const count = occurrenceCount;
        if (count > 1) {
          const cache = this._nodesOccurrencesCountCache.get(node);
          if (cache && cache.test === test && cache.count < count) {
            i = cache.i + 1;
            occurrenceCount -= cache.count + 1;
          }
        }
        for (; i < indexes.length; i++) {
          const tok = this._tokens[indexes[i]];
          if (this.matchesOriginal(tok, test)) {
            if (occurrenceCount === 0) {
              if (count > 0) {
                this._nodesOccurrencesCountCache.set(node, {
                  test: test,
                  count: count,
                  i: i,
                });
              }
              return tok;
            }
            occurrenceCount--;
          }
        }
      }
      return null;
    }
    matchesOriginal(token, test) {
      if (token.end - token.start !== test.length) return false;
      if (token.value != null) return token.value === test;
      return this._source.startsWith(test, token.start);
    }
    startMatches(node, test) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (!indexes) return false;
      const tok = this._tokens[indexes[0]];
      if (tok.start !== node.start) return false;
      return this.matchesOriginal(tok, test);
    }
    endMatches(node, test) {
      const indexes = this._nodesToTokenIndexes.get(node);
      if (!indexes) return false;
      const tok = this._tokens[indexes[indexes.length - 1]];
      if (tok.end !== node.end) return false;
      return this.matchesOriginal(tok, test);
    }
    _getTokensIndexesOfNode(node) {
      if (node.start == null || node.end == null) return [];
      const {first: first, last: last} = this._findTokensOfNode(
        node,
        0,
        this._tokens.length - 1
      );
      let low = first;
      const children = childrenIterator(node);
      if (
        (node.type === 'ExportNamedDeclaration' ||
          node.type === 'ExportDefaultDeclaration') &&
        node.declaration &&
        node.declaration.type === 'ClassDeclaration'
      ) {
        children.next();
      }
      const indexes = [];
      for (const child of children) {
        if (child == null) continue;
        if (child.start == null || child.end == null) continue;
        const childTok = this._findTokensOfNode(child, low, last);
        const high = childTok.first;
        for (let k = low; k < high; k++) indexes.push(k);
        low = childTok.last + 1;
      }
      for (let k = low; k <= last; k++) indexes.push(k);
      return indexes;
    }
    _findTokensOfNode(node, low, high) {
      const cached = this._tokensCache.get(node);
      if (cached) return cached;
      const first = this._findFirstTokenOfNode(node.start, low, high);
      const last = this._findLastTokenOfNode(node.end, first, high);
      this._tokensCache.set(node, {first: first, last: last});
      return {first: first, last: last};
    }
    _findFirstTokenOfNode(start, low, high) {
      while (low <= high) {
        const mid = (high + low) >> 1;
        if (start < this._tokens[mid].start) {
          high = mid - 1;
        } else if (start > this._tokens[mid].start) {
          low = mid + 1;
        } else {
          return mid;
        }
      }
      return low;
    }
    _findLastTokenOfNode(end, low, high) {
      while (low <= high) {
        const mid = (high + low) >> 1;
        if (end < this._tokens[mid].end) {
          high = mid - 1;
        } else if (end > this._tokens[mid].end) {
          low = mid + 1;
        } else {
          return mid;
        }
      }
      return high;
    }
  }
  tokenMap.TokenMap = TokenMap;
  function* childrenIterator(node) {
    if (node.type === 'TemplateLiteral') {
      yield node.quasis[0];
      for (let i = 1; i < node.quasis.length; i++) {
        yield node.expressions[i - 1];
        yield node.quasis[i];
      }
      return;
    }
    const keys = VISITOR_KEYS[node.type];
    for (const key of keys) {
      const child = node[key];
      if (!child) continue;
      if (Array.isArray(child)) {
        yield* child;
      } else {
        yield child;
      }
    }
  }
  return tokenMap;
}
var generators$1 = {};
var templateLiterals$1 = {};
var hasRequiredTemplateLiterals;
function requireTemplateLiterals() {
  if (hasRequiredTemplateLiterals) return templateLiterals$1;
  hasRequiredTemplateLiterals = 1;
  Object.defineProperty(templateLiterals$1, '__esModule', {value: true});
  templateLiterals$1.TaggedTemplateExpression = TaggedTemplateExpression;
  templateLiterals$1.TemplateElement = TemplateElement;
  templateLiterals$1.TemplateLiteral = TemplateLiteral;
  function TaggedTemplateExpression(node) {
    this.print(node.tag);
    this.print(node.typeParameters);
    this.print(node.quasi);
  }
  function TemplateElement() {
    throw new Error('TemplateElement printing is handled in TemplateLiteral');
  }
  function TemplateLiteral(node) {
    const quasis = node.quasis;
    let partRaw = '`';
    for (let i = 0; i < quasis.length; i++) {
      partRaw += quasis[i].value.raw;
      if (i + 1 < quasis.length) {
        this.token(partRaw + '${', true);
        this.print(node.expressions[i]);
        partRaw = '}';
        if (this.tokenMap) {
          const token = this.tokenMap.findMatching(node, '}', i);
          if (token) this._catchUpTo(token.loc.start);
        }
      }
    }
    this.token(partRaw + '`', true);
  }
  return templateLiterals$1;
}
var expressions$1 = {};
var hasRequiredExpressions;
function requireExpressions() {
  if (hasRequiredExpressions) return expressions$1;
  hasRequiredExpressions = 1;
  Object.defineProperty(expressions$1, '__esModule', {value: true});
  expressions$1.LogicalExpression =
    expressions$1.BinaryExpression =
    expressions$1.AssignmentExpression =
      AssignmentExpression;
  expressions$1.AssignmentPattern = AssignmentPattern;
  expressions$1.AwaitExpression = AwaitExpression;
  expressions$1.BindExpression = BindExpression;
  expressions$1.CallExpression = CallExpression;
  expressions$1.ConditionalExpression = ConditionalExpression;
  expressions$1.Decorator = Decorator;
  expressions$1.DoExpression = DoExpression;
  expressions$1.EmptyStatement = EmptyStatement;
  expressions$1.ExpressionStatement = ExpressionStatement;
  expressions$1.Import = Import;
  expressions$1.MemberExpression = MemberExpression;
  expressions$1.MetaProperty = MetaProperty;
  expressions$1.ModuleExpression = ModuleExpression;
  expressions$1.NewExpression = NewExpression;
  expressions$1.OptionalCallExpression = OptionalCallExpression;
  expressions$1.OptionalMemberExpression = OptionalMemberExpression;
  expressions$1.ParenthesizedExpression = ParenthesizedExpression;
  expressions$1.PrivateName = PrivateName;
  expressions$1.SequenceExpression = SequenceExpression;
  expressions$1.Super = Super;
  expressions$1.ThisExpression = ThisExpression;
  expressions$1.UnaryExpression = UnaryExpression;
  expressions$1.UpdateExpression = UpdateExpression;
  expressions$1.V8IntrinsicIdentifier = V8IntrinsicIdentifier;
  expressions$1.YieldExpression = YieldExpression;
  expressions$1._shouldPrintDecoratorsBeforeExport =
    _shouldPrintDecoratorsBeforeExport;
  var _t = t$d;
  var _index = requireNode();
  const {
    isCallExpression: isCallExpression,
    isLiteral: isLiteral,
    isMemberExpression: isMemberExpression,
    isNewExpression: isNewExpression,
    isPattern: isPattern,
  } = _t;
  function UnaryExpression(node) {
    const {operator: operator} = node;
    if (
      operator === 'void' ||
      operator === 'delete' ||
      operator === 'typeof' ||
      operator === 'throw'
    ) {
      this.word(operator);
      this.space();
    } else {
      this.token(operator);
    }
    this.print(node.argument);
  }
  function DoExpression(node) {
    if (node.async) {
      this.word('async', true);
      this.space();
    }
    this.word('do');
    this.space();
    this.print(node.body);
  }
  function ParenthesizedExpression(node) {
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.print(node.expression);
    exit();
    this.rightParens(node);
  }
  function UpdateExpression(node) {
    if (node.prefix) {
      this.token(node.operator);
      this.print(node.argument);
    } else {
      this.print(node.argument, true);
      this.token(node.operator);
    }
  }
  function ConditionalExpression(node) {
    this.print(node.test);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.consequent);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.alternate);
  }
  function NewExpression(node, parent) {
    this.word('new');
    this.space();
    this.print(node.callee);
    if (
      this.format.minified &&
      node.arguments.length === 0 &&
      !node.optional &&
      !isCallExpression(parent, {callee: node}) &&
      !isMemberExpression(parent) &&
      !isNewExpression(parent)
    ) {
      return;
    }
    this.print(node.typeArguments);
    this.print(node.typeParameters);
    if (node.optional) {
      this.token('?.');
    }
    if (
      node.arguments.length === 0 &&
      this.tokenMap &&
      !this.tokenMap.endMatches(node, ')')
    ) {
      return;
    }
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments, {
      printTrailingSeparator: this.shouldPrintTrailingComma(')'),
    });
    exit();
    this.rightParens(node);
  }
  function SequenceExpression(node) {
    this.printList(node.expressions);
  }
  function ThisExpression() {
    this.word('this');
  }
  function Super() {
    this.word('super');
  }
  function _shouldPrintDecoratorsBeforeExport(node) {
    if (typeof this.format.decoratorsBeforeExport === 'boolean') {
      return this.format.decoratorsBeforeExport;
    }
    return (
      typeof node.start === 'number' && node.start === node.declaration.start
    );
  }
  function Decorator(node) {
    this.tokenChar(64);
    this.print(node.expression);
    this.newline();
  }
  function OptionalMemberExpression(node) {
    let {computed: computed} = node;
    const {optional: optional, property: property} = node;
    this.print(node.object);
    if (!computed && isMemberExpression(property)) {
      throw new TypeError(
        'Got a MemberExpression for MemberExpression property'
      );
    }
    if (isLiteral(property) && typeof property.value === 'number') {
      computed = true;
    }
    if (optional) {
      this.token('?.');
    }
    if (computed) {
      this.tokenChar(91);
      this.print(property);
      this.tokenChar(93);
    } else {
      if (!optional) {
        this.tokenChar(46);
      }
      this.print(property);
    }
  }
  function OptionalCallExpression(node) {
    this.print(node.callee);
    this.print(node.typeParameters);
    if (node.optional) {
      this.token('?.');
    }
    this.print(node.typeArguments);
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments);
    exit();
    this.rightParens(node);
  }
  function CallExpression(node) {
    this.print(node.callee);
    this.print(node.typeArguments);
    this.print(node.typeParameters);
    this.tokenChar(40);
    const exit = this.enterDelimited();
    this.printList(node.arguments, {
      printTrailingSeparator: this.shouldPrintTrailingComma(')'),
    });
    exit();
    this.rightParens(node);
  }
  function Import() {
    this.word('import');
  }
  function AwaitExpression(node) {
    this.word('await');
    if (node.argument) {
      this.space();
      this.printTerminatorless(node.argument);
    }
  }
  function YieldExpression(node) {
    this.word('yield', true);
    if (node.delegate) {
      this.tokenChar(42);
      if (node.argument) {
        this.space();
        this.print(node.argument);
      }
    } else {
      if (node.argument) {
        this.space();
        this.printTerminatorless(node.argument);
      }
    }
  }
  function EmptyStatement() {
    this.semicolon(true);
  }
  function ExpressionStatement(node) {
    this.tokenContext |= _index.TokenContext.expressionStatement;
    this.print(node.expression);
    this.semicolon();
  }
  function AssignmentPattern(node) {
    this.print(node.left);
    if (node.left.type === 'Identifier' || isPattern(node.left)) {
      if (node.left.optional) this.tokenChar(63);
      this.print(node.left.typeAnnotation);
    }
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.right);
  }
  function AssignmentExpression(node) {
    this.print(node.left);
    this.space();
    if (node.operator === 'in' || node.operator === 'instanceof') {
      this.word(node.operator);
    } else {
      this.token(node.operator);
      this._endsWithDiv = node.operator === '/';
    }
    this.space();
    this.print(node.right);
  }
  function BindExpression(node) {
    this.print(node.object);
    this.token('::');
    this.print(node.callee);
  }
  function MemberExpression(node) {
    this.print(node.object);
    if (!node.computed && isMemberExpression(node.property)) {
      throw new TypeError(
        'Got a MemberExpression for MemberExpression property'
      );
    }
    let computed = node.computed;
    if (isLiteral(node.property) && typeof node.property.value === 'number') {
      computed = true;
    }
    if (computed) {
      const exit = this.enterDelimited();
      this.tokenChar(91);
      this.print(node.property);
      this.tokenChar(93);
      exit();
    } else {
      this.tokenChar(46);
      this.print(node.property);
    }
  }
  function MetaProperty(node) {
    this.print(node.meta);
    this.tokenChar(46);
    this.print(node.property);
  }
  function PrivateName(node) {
    this.tokenChar(35);
    this.print(node.id);
  }
  function V8IntrinsicIdentifier(node) {
    this.tokenChar(37);
    this.word(node.name);
  }
  function ModuleExpression(node) {
    this.word('module', true);
    this.space();
    this.tokenChar(123);
    this.indent();
    const {body: body} = node;
    if (body.body.length || body.directives.length) {
      this.newline();
    }
    this.print(body);
    this.dedent();
    this.rightBrace(node);
  }
  return expressions$1;
}
var statements$1 = {};
var hasRequiredStatements;
function requireStatements() {
  if (hasRequiredStatements) return statements$1;
  hasRequiredStatements = 1;
  Object.defineProperty(statements$1, '__esModule', {value: true});
  statements$1.BreakStatement = BreakStatement;
  statements$1.CatchClause = CatchClause;
  statements$1.ContinueStatement = ContinueStatement;
  statements$1.DebuggerStatement = DebuggerStatement;
  statements$1.DoWhileStatement = DoWhileStatement;
  statements$1.ForOfStatement = statements$1.ForInStatement = void 0;
  statements$1.ForStatement = ForStatement;
  statements$1.IfStatement = IfStatement;
  statements$1.LabeledStatement = LabeledStatement;
  statements$1.ReturnStatement = ReturnStatement;
  statements$1.SwitchCase = SwitchCase;
  statements$1.SwitchStatement = SwitchStatement;
  statements$1.ThrowStatement = ThrowStatement;
  statements$1.TryStatement = TryStatement;
  statements$1.VariableDeclaration = VariableDeclaration;
  statements$1.VariableDeclarator = VariableDeclarator;
  statements$1.WhileStatement = WhileStatement;
  statements$1.WithStatement = WithStatement;
  var _t = t$d;
  var _index = requireNode();
  const {
    isFor: isFor,
    isForStatement: isForStatement,
    isIfStatement: isIfStatement,
    isStatement: isStatement,
  } = _t;
  function WithStatement(node) {
    this.word('with');
    this.space();
    this.tokenChar(40);
    this.print(node.object);
    this.tokenChar(41);
    this.printBlock(node);
  }
  function IfStatement(node) {
    this.word('if');
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.space();
    const needsBlock =
      node.alternate && isIfStatement(getLastStatement(node.consequent));
    if (needsBlock) {
      this.tokenChar(123);
      this.newline();
      this.indent();
    }
    this.printAndIndentOnComments(node.consequent);
    if (needsBlock) {
      this.dedent();
      this.newline();
      this.tokenChar(125);
    }
    if (node.alternate) {
      if (this.endsWith(125)) this.space();
      this.word('else');
      this.space();
      this.printAndIndentOnComments(node.alternate);
    }
  }
  function getLastStatement(statement) {
    const {body: body} = statement;
    if (isStatement(body) === false) {
      return statement;
    }
    return getLastStatement(body);
  }
  function ForStatement(node) {
    this.word('for');
    this.space();
    this.tokenChar(40);
    {
      const exit = this.enterForStatementInit();
      this.tokenContext |= _index.TokenContext.forHead;
      this.print(node.init);
      exit();
    }
    this.tokenChar(59);
    if (node.test) {
      this.space();
      this.print(node.test);
    }
    this.token(';', false, 1);
    if (node.update) {
      this.space();
      this.print(node.update);
    }
    this.tokenChar(41);
    this.printBlock(node);
  }
  function WhileStatement(node) {
    this.word('while');
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.printBlock(node);
  }
  function ForXStatement(node) {
    this.word('for');
    this.space();
    const isForOf = node.type === 'ForOfStatement';
    if (isForOf && node.await) {
      this.word('await');
      this.space();
    }
    this.noIndentInnerCommentsHere();
    this.tokenChar(40);
    {
      const exit = isForOf ? null : this.enterForStatementInit();
      this.tokenContext |= isForOf
        ? _index.TokenContext.forOfHead
        : _index.TokenContext.forInHead;
      this.print(node.left);
      exit == null || exit();
    }
    this.space();
    this.word(isForOf ? 'of' : 'in');
    this.space();
    this.print(node.right);
    this.tokenChar(41);
    this.printBlock(node);
  }
  statements$1.ForInStatement = ForXStatement;
  statements$1.ForOfStatement = ForXStatement;
  function DoWhileStatement(node) {
    this.word('do');
    this.space();
    this.print(node.body);
    this.space();
    this.word('while');
    this.space();
    this.tokenChar(40);
    this.print(node.test);
    this.tokenChar(41);
    this.semicolon();
  }
  function printStatementAfterKeyword(printer, node) {
    if (node) {
      printer.space();
      printer.printTerminatorless(node);
    }
    printer.semicolon();
  }
  function BreakStatement(node) {
    this.word('break');
    printStatementAfterKeyword(this, node.label);
  }
  function ContinueStatement(node) {
    this.word('continue');
    printStatementAfterKeyword(this, node.label);
  }
  function ReturnStatement(node) {
    this.word('return');
    printStatementAfterKeyword(this, node.argument);
  }
  function ThrowStatement(node) {
    this.word('throw');
    printStatementAfterKeyword(this, node.argument);
  }
  function LabeledStatement(node) {
    this.print(node.label);
    this.tokenChar(58);
    this.space();
    this.print(node.body);
  }
  function TryStatement(node) {
    this.word('try');
    this.space();
    this.print(node.block);
    this.space();
    if (node.handlers) {
      this.print(node.handlers[0]);
    } else {
      this.print(node.handler);
    }
    if (node.finalizer) {
      this.space();
      this.word('finally');
      this.space();
      this.print(node.finalizer);
    }
  }
  function CatchClause(node) {
    this.word('catch');
    this.space();
    if (node.param) {
      this.tokenChar(40);
      this.print(node.param);
      this.print(node.param.typeAnnotation);
      this.tokenChar(41);
      this.space();
    }
    this.print(node.body);
  }
  function SwitchStatement(node) {
    this.word('switch');
    this.space();
    this.tokenChar(40);
    this.print(node.discriminant);
    this.tokenChar(41);
    this.space();
    this.tokenChar(123);
    this.printSequence(node.cases, {
      indent: true,
      addNewlines(leading, cas) {
        if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
      },
    });
    this.rightBrace(node);
  }
  function SwitchCase(node) {
    if (node.test) {
      this.word('case');
      this.space();
      this.print(node.test);
      this.tokenChar(58);
    } else {
      this.word('default');
      this.tokenChar(58);
    }
    if (node.consequent.length) {
      this.newline();
      this.printSequence(node.consequent, {indent: true});
    }
  }
  function DebuggerStatement() {
    this.word('debugger');
    this.semicolon();
  }
  function VariableDeclaration(node, parent) {
    if (node.declare) {
      this.word('declare');
      this.space();
    }
    const {kind: kind} = node;
    if (kind === 'await using') {
      this.word('await');
      this.space();
      this.word('using', true);
    } else {
      this.word(kind, kind === 'using');
    }
    this.space();
    let hasInits = false;
    if (!isFor(parent)) {
      for (const declar of node.declarations) {
        if (declar.init) {
          hasInits = true;
        }
      }
    }
    this.printList(node.declarations, {
      separator: hasInits
        ? function (occurrenceCount) {
            this.token(',', false, occurrenceCount);
            this.newline();
          }
        : undefined,
      indent: node.declarations.length > 1 ? true : false,
    });
    if (isFor(parent)) {
      if (isForStatement(parent)) {
        if (parent.init === node) return;
      } else {
        if (parent.left === node) return;
      }
    }
    this.semicolon();
  }
  function VariableDeclarator(node) {
    this.print(node.id);
    if (node.definite) this.tokenChar(33);
    this.print(node.id.typeAnnotation);
    if (node.init) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.init);
    }
  }
  return statements$1;
}
var classes$1 = {};
var hasRequiredClasses;
function requireClasses() {
  if (hasRequiredClasses) return classes$1;
  hasRequiredClasses = 1;
  Object.defineProperty(classes$1, '__esModule', {value: true});
  classes$1.ClassAccessorProperty = ClassAccessorProperty;
  classes$1.ClassBody = ClassBody;
  classes$1.ClassExpression = classes$1.ClassDeclaration = ClassDeclaration;
  classes$1.ClassMethod = ClassMethod;
  classes$1.ClassPrivateMethod = ClassPrivateMethod;
  classes$1.ClassPrivateProperty = ClassPrivateProperty;
  classes$1.ClassProperty = ClassProperty;
  classes$1.StaticBlock = StaticBlock;
  classes$1._classMethodHead = _classMethodHead;
  var _t = t$d;
  const {
    isExportDefaultDeclaration: isExportDefaultDeclaration,
    isExportNamedDeclaration: isExportNamedDeclaration,
  } = _t;
  function ClassDeclaration(node, parent) {
    const inExport =
      isExportDefaultDeclaration(parent) || isExportNamedDeclaration(parent);
    if (!inExport || !this._shouldPrintDecoratorsBeforeExport(parent)) {
      this.printJoin(node.decorators);
    }
    if (node.declare) {
      this.word('declare');
      this.space();
    }
    if (node.abstract) {
      this.word('abstract');
      this.space();
    }
    this.word('class');
    if (node.id) {
      this.space();
      this.print(node.id);
    }
    this.print(node.typeParameters);
    if (node.superClass) {
      this.space();
      this.word('extends');
      this.space();
      this.print(node.superClass);
      this.print(node.superTypeParameters);
    }
    if (node.implements) {
      this.space();
      this.word('implements');
      this.space();
      this.printList(node.implements);
    }
    this.space();
    this.print(node.body);
  }
  function ClassBody(node) {
    this.tokenChar(123);
    if (node.body.length === 0) {
      this.tokenChar(125);
    } else {
      this.newline();
      const separator = classBodyEmptySemicolonsPrinter(this, node);
      separator == null || separator(-1);
      const exit = this.enterDelimited();
      this.printJoin(node.body, {
        statement: true,
        indent: true,
        separator: separator,
        printTrailingSeparator: true,
      });
      exit();
      if (!this.endsWith(10)) this.newline();
      this.rightBrace(node);
    }
  }
  function classBodyEmptySemicolonsPrinter(printer, node) {
    if (!printer.tokenMap || node.start == null || node.end == null) {
      return null;
    }
    const indexes = printer.tokenMap.getIndexes(node);
    if (!indexes) return null;
    let k = 1;
    let occurrenceCount = 0;
    let nextLocIndex = 0;
    const advanceNextLocIndex = () => {
      while (
        nextLocIndex < node.body.length &&
        node.body[nextLocIndex].start == null
      ) {
        nextLocIndex++;
      }
    };
    advanceNextLocIndex();
    return i => {
      if (nextLocIndex <= i) {
        nextLocIndex = i + 1;
        advanceNextLocIndex();
      }
      const end =
        nextLocIndex === node.body.length
          ? node.end
          : node.body[nextLocIndex].start;
      let tok;
      while (
        k < indexes.length &&
        printer.tokenMap.matchesOriginal(
          (tok = printer._tokens[indexes[k]]),
          ';'
        ) &&
        tok.start < end
      ) {
        printer.token(';', undefined, occurrenceCount++);
        k++;
      }
    };
  }
  function ClassProperty(node) {
    this.printJoin(node.decorators);
    if (!node.static && !this.format.preserveFormat) {
      var _node$key$loc;
      const endLine =
        (_node$key$loc = node.key.loc) == null ||
        (_node$key$loc = _node$key$loc.end) == null
          ? void 0
          : _node$key$loc.line;
      if (endLine) this.catchUp(endLine);
    }
    this.tsPrintClassMemberModifiers(node);
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      this._variance(node);
      this.print(node.key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    if (node.definite) {
      this.tokenChar(33);
    }
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassAccessorProperty(node) {
    var _node$key$loc2;
    this.printJoin(node.decorators);
    const endLine =
      (_node$key$loc2 = node.key.loc) == null ||
      (_node$key$loc2 = _node$key$loc2.end) == null
        ? void 0
        : _node$key$loc2.line;
    if (endLine) this.catchUp(endLine);
    this.tsPrintClassMemberModifiers(node);
    this.word('accessor', true);
    this.space();
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      this._variance(node);
      this.print(node.key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    if (node.definite) {
      this.tokenChar(33);
    }
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassPrivateProperty(node) {
    this.printJoin(node.decorators);
    if (node.static) {
      this.word('static');
      this.space();
    }
    this.print(node.key);
    this.print(node.typeAnnotation);
    if (node.value) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.value);
    }
    this.semicolon();
  }
  function ClassMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body);
  }
  function ClassPrivateMethod(node) {
    this._classMethodHead(node);
    this.space();
    this.print(node.body);
  }
  function _classMethodHead(node) {
    this.printJoin(node.decorators);
    if (!this.format.preserveFormat) {
      var _node$key$loc3;
      const endLine =
        (_node$key$loc3 = node.key.loc) == null ||
        (_node$key$loc3 = _node$key$loc3.end) == null
          ? void 0
          : _node$key$loc3.line;
      if (endLine) this.catchUp(endLine);
    }
    this.tsPrintClassMemberModifiers(node);
    this._methodHead(node);
  }
  function StaticBlock(node) {
    this.word('static');
    this.space();
    this.tokenChar(123);
    if (node.body.length === 0) {
      this.tokenChar(125);
    } else {
      this.newline();
      this.printSequence(node.body, {indent: true});
      this.rightBrace(node);
    }
  }
  return classes$1;
}
var methods$1 = {};
var hasRequiredMethods;
function requireMethods() {
  if (hasRequiredMethods) return methods$1;
  hasRequiredMethods = 1;
  Object.defineProperty(methods$1, '__esModule', {value: true});
  methods$1.ArrowFunctionExpression = ArrowFunctionExpression;
  methods$1.FunctionDeclaration = methods$1.FunctionExpression =
    FunctionExpression;
  methods$1._functionHead = _functionHead;
  methods$1._methodHead = _methodHead;
  methods$1._param = _param;
  methods$1._parameters = _parameters;
  methods$1._params = _params;
  methods$1._predicate = _predicate;
  methods$1._shouldPrintArrowParamsParens = _shouldPrintArrowParamsParens;
  var _t = t$d;
  var _index = requireNode();
  const {isIdentifier: isIdentifier} = _t;
  function _params(node, idNode, parentNode) {
    this.print(node.typeParameters);
    const nameInfo = _getFuncIdName.call(this, idNode, parentNode);
    if (nameInfo) {
      this.sourceIdentifierName(nameInfo.name, nameInfo.pos);
    }
    this.tokenChar(40);
    this._parameters(node.params, ')');
    const noLineTerminator = node.type === 'ArrowFunctionExpression';
    this.print(node.returnType, noLineTerminator);
    this._noLineTerminator = noLineTerminator;
  }
  function _parameters(parameters, endToken) {
    const exit = this.enterDelimited();
    const trailingComma = this.shouldPrintTrailingComma(endToken);
    const paramLength = parameters.length;
    for (let i = 0; i < paramLength; i++) {
      this._param(parameters[i]);
      if (trailingComma || i < paramLength - 1) {
        this.token(',', null, i);
        this.space();
      }
    }
    this.token(endToken);
    exit();
  }
  function _param(parameter) {
    this.printJoin(parameter.decorators);
    this.print(parameter);
    if (parameter.optional) {
      this.tokenChar(63);
    }
    this.print(parameter.typeAnnotation);
  }
  function _methodHead(node) {
    const kind = node.kind;
    const key = node.key;
    if (kind === 'get' || kind === 'set') {
      this.word(kind);
      this.space();
    }
    if (node.async) {
      this.word('async', true);
      this.space();
    }
    if (kind === 'method' || kind === 'init') {
      if (node.generator) {
        this.tokenChar(42);
      }
    }
    if (node.computed) {
      this.tokenChar(91);
      this.print(key);
      this.tokenChar(93);
    } else {
      this.print(key);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
    this._params(
      node,
      node.computed && node.key.type !== 'StringLiteral' ? undefined : node.key,
      undefined
    );
  }
  function _predicate(node, noLineTerminatorAfter) {
    if (node.predicate) {
      if (!node.returnType) {
        this.tokenChar(58);
      }
      this.space();
      this.print(node.predicate, noLineTerminatorAfter);
    }
  }
  function _functionHead(node, parent) {
    if (node.async) {
      this.word('async');
      if (!this.format.preserveFormat) {
        this._endsWithInnerRaw = false;
      }
      this.space();
    }
    this.word('function');
    if (node.generator) {
      if (!this.format.preserveFormat) {
        this._endsWithInnerRaw = false;
      }
      this.tokenChar(42);
    }
    this.space();
    if (node.id) {
      this.print(node.id);
    }
    this._params(node, node.id, parent);
    if (node.type !== 'TSDeclareFunction') {
      this._predicate(node);
    }
  }
  function FunctionExpression(node, parent) {
    this._functionHead(node, parent);
    this.space();
    this.print(node.body);
  }
  function ArrowFunctionExpression(node, parent) {
    if (node.async) {
      this.word('async', true);
      this.space();
    }
    if (this._shouldPrintArrowParamsParens(node)) {
      this._params(node, undefined, parent);
    } else {
      this.print(node.params[0], true);
    }
    this._predicate(node, true);
    this.space();
    this.printInnerComments();
    this.token('=>');
    this.space();
    this.tokenContext |= _index.TokenContext.arrowBody;
    this.print(node.body);
  }
  function _shouldPrintArrowParamsParens(node) {
    var _firstParam$leadingCo, _firstParam$trailingC;
    if (node.params.length !== 1) return true;
    if (node.typeParameters || node.returnType || node.predicate) {
      return true;
    }
    const firstParam = node.params[0];
    if (
      !isIdentifier(firstParam) ||
      firstParam.typeAnnotation ||
      firstParam.optional ||
      ((_firstParam$leadingCo = firstParam.leadingComments) != null &&
        _firstParam$leadingCo.length) ||
      ((_firstParam$trailingC = firstParam.trailingComments) != null &&
        _firstParam$trailingC.length)
    ) {
      return true;
    }
    if (this.tokenMap) {
      if (node.loc == null) return true;
      if (this.tokenMap.findMatching(node, '(') !== null) return true;
      const arrowToken = this.tokenMap.findMatching(node, '=>');
      if ((arrowToken == null ? void 0 : arrowToken.loc) == null) return true;
      return arrowToken.loc.start.line !== node.loc.start.line;
    }
    if (this.format.retainLines) return true;
    return false;
  }
  function _getFuncIdName(idNode, parent) {
    let id = idNode;
    if (!id && parent) {
      const parentType = parent.type;
      if (parentType === 'VariableDeclarator') {
        id = parent.id;
      } else if (
        parentType === 'AssignmentExpression' ||
        parentType === 'AssignmentPattern'
      ) {
        id = parent.left;
      } else if (
        parentType === 'ObjectProperty' ||
        parentType === 'ClassProperty'
      ) {
        if (!parent.computed || parent.key.type === 'StringLiteral') {
          id = parent.key;
        }
      } else if (
        parentType === 'ClassPrivateProperty' ||
        parentType === 'ClassAccessorProperty'
      ) {
        id = parent.key;
      }
    }
    if (!id) return;
    let nameInfo;
    if (id.type === 'Identifier') {
      var _id$loc, _id$loc2;
      nameInfo = {
        pos: (_id$loc = id.loc) == null ? void 0 : _id$loc.start,
        name:
          ((_id$loc2 = id.loc) == null ? void 0 : _id$loc2.identifierName) ||
          id.name,
      };
    } else if (id.type === 'PrivateName') {
      var _id$loc3;
      nameInfo = {
        pos: (_id$loc3 = id.loc) == null ? void 0 : _id$loc3.start,
        name: '#' + id.id.name,
      };
    } else if (id.type === 'StringLiteral') {
      var _id$loc4;
      nameInfo = {
        pos: (_id$loc4 = id.loc) == null ? void 0 : _id$loc4.start,
        name: id.value,
      };
    }
    return nameInfo;
  }
  return methods$1;
}
var modules$1 = {};
var hasRequiredModules;
function requireModules() {
  if (hasRequiredModules) return modules$1;
  hasRequiredModules = 1;
  Object.defineProperty(modules$1, '__esModule', {value: true});
  modules$1.ExportAllDeclaration = ExportAllDeclaration;
  modules$1.ExportDefaultDeclaration = ExportDefaultDeclaration;
  modules$1.ExportDefaultSpecifier = ExportDefaultSpecifier;
  modules$1.ExportNamedDeclaration = ExportNamedDeclaration;
  modules$1.ExportNamespaceSpecifier = ExportNamespaceSpecifier;
  modules$1.ExportSpecifier = ExportSpecifier;
  modules$1.ImportAttribute = ImportAttribute;
  modules$1.ImportDeclaration = ImportDeclaration;
  modules$1.ImportDefaultSpecifier = ImportDefaultSpecifier;
  modules$1.ImportExpression = ImportExpression;
  modules$1.ImportNamespaceSpecifier = ImportNamespaceSpecifier;
  modules$1.ImportSpecifier = ImportSpecifier;
  modules$1._printAttributes = _printAttributes;
  var _t = t$d;
  var _index = requireNode();
  const {
    isClassDeclaration: isClassDeclaration,
    isExportDefaultSpecifier: isExportDefaultSpecifier,
    isExportNamespaceSpecifier: isExportNamespaceSpecifier,
    isImportDefaultSpecifier: isImportDefaultSpecifier,
    isImportNamespaceSpecifier: isImportNamespaceSpecifier,
    isStatement: isStatement,
  } = _t;
  function ImportSpecifier(node) {
    if (node.importKind === 'type' || node.importKind === 'typeof') {
      this.word(node.importKind);
      this.space();
    }
    this.print(node.imported);
    if (node.local && node.local.name !== node.imported.name) {
      this.space();
      this.word('as');
      this.space();
      this.print(node.local);
    }
  }
  function ImportDefaultSpecifier(node) {
    this.print(node.local);
  }
  function ExportDefaultSpecifier(node) {
    this.print(node.exported);
  }
  function ExportSpecifier(node) {
    if (node.exportKind === 'type') {
      this.word('type');
      this.space();
    }
    this.print(node.local);
    if (node.exported && node.local.name !== node.exported.name) {
      this.space();
      this.word('as');
      this.space();
      this.print(node.exported);
    }
  }
  function ExportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word('as');
    this.space();
    this.print(node.exported);
  }
  let warningShown = false;
  function _printAttributes(node, hasPreviousBrace) {
    const {importAttributesKeyword: importAttributesKeyword} = this.format;
    const {attributes: attributes, assertions: assertions} = node;
    if (attributes && !importAttributesKeyword && !warningShown) {
      warningShown = true;
      console.warn(
        `You are using import attributes, without specifying the desired output syntax.\nPlease specify the "importAttributesKeyword" generator option, whose value can be one of:\n - "with"        : \`import { a } from "b" with { type: "json" };\`\n - "assert"      : \`import { a } from "b" assert { type: "json" };\`\n - "with-legacy" : \`import { a } from "b" with type: "json";\`\n`
      );
    }
    const useAssertKeyword =
      importAttributesKeyword === 'assert' ||
      (!importAttributesKeyword && assertions);
    this.word(useAssertKeyword ? 'assert' : 'with');
    this.space();
    if (!useAssertKeyword && importAttributesKeyword !== 'with') {
      this.printList(attributes || assertions);
      return;
    }
    const occurrenceCount = hasPreviousBrace ? 1 : 0;
    this.token('{', null, occurrenceCount);
    this.space();
    this.printList(attributes || assertions, {
      printTrailingSeparator: this.shouldPrintTrailingComma('}'),
    });
    this.space();
    this.token('}', null, occurrenceCount);
  }
  function ExportAllDeclaration(node) {
    var _node$attributes, _node$assertions;
    this.word('export');
    this.space();
    if (node.exportKind === 'type') {
      this.word('type');
      this.space();
    }
    this.tokenChar(42);
    this.space();
    this.word('from');
    this.space();
    if (
      ((_node$attributes = node.attributes) != null &&
        _node$attributes.length) ||
      ((_node$assertions = node.assertions) != null && _node$assertions.length)
    ) {
      this.print(node.source, true);
      this.space();
      this._printAttributes(node, false);
    } else {
      this.print(node.source);
    }
    this.semicolon();
  }
  function maybePrintDecoratorsBeforeExport(printer, node) {
    if (
      isClassDeclaration(node.declaration) &&
      printer._shouldPrintDecoratorsBeforeExport(node)
    ) {
      printer.printJoin(node.declaration.decorators);
    }
  }
  function ExportNamedDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word('export');
    this.space();
    if (node.declaration) {
      const declar = node.declaration;
      this.print(declar);
      if (!isStatement(declar)) this.semicolon();
    } else {
      if (node.exportKind === 'type') {
        this.word('type');
        this.space();
      }
      const specifiers = node.specifiers.slice(0);
      let hasSpecial = false;
      for (;;) {
        const first = specifiers[0];
        if (
          isExportDefaultSpecifier(first) ||
          isExportNamespaceSpecifier(first)
        ) {
          hasSpecial = true;
          this.print(specifiers.shift());
          if (specifiers.length) {
            this.tokenChar(44);
            this.space();
          }
        } else {
          break;
        }
      }
      let hasBrace = false;
      if (specifiers.length || (!specifiers.length && !hasSpecial)) {
        hasBrace = true;
        this.tokenChar(123);
        if (specifiers.length) {
          this.space();
          this.printList(specifiers, {
            printTrailingSeparator: this.shouldPrintTrailingComma('}'),
          });
          this.space();
        }
        this.tokenChar(125);
      }
      if (node.source) {
        var _node$attributes2, _node$assertions2;
        this.space();
        this.word('from');
        this.space();
        if (
          ((_node$attributes2 = node.attributes) != null &&
            _node$attributes2.length) ||
          ((_node$assertions2 = node.assertions) != null &&
            _node$assertions2.length)
        ) {
          this.print(node.source, true);
          this.space();
          this._printAttributes(node, hasBrace);
        } else {
          this.print(node.source);
        }
      }
      this.semicolon();
    }
  }
  function ExportDefaultDeclaration(node) {
    maybePrintDecoratorsBeforeExport(this, node);
    this.word('export');
    this.noIndentInnerCommentsHere();
    this.space();
    this.word('default');
    this.space();
    this.tokenContext |= _index.TokenContext.exportDefault;
    const declar = node.declaration;
    this.print(declar);
    if (!isStatement(declar)) this.semicolon();
  }
  function ImportDeclaration(node) {
    var _node$attributes3, _node$assertions3;
    this.word('import');
    this.space();
    const isTypeKind =
      node.importKind === 'type' || node.importKind === 'typeof';
    if (isTypeKind) {
      this.noIndentInnerCommentsHere();
      this.word(node.importKind);
      this.space();
    } else if (node.module) {
      this.noIndentInnerCommentsHere();
      this.word('module');
      this.space();
    } else if (node.phase) {
      this.noIndentInnerCommentsHere();
      this.word(node.phase);
      this.space();
    }
    const specifiers = node.specifiers.slice(0);
    const hasSpecifiers = !!specifiers.length;
    while (hasSpecifiers) {
      const first = specifiers[0];
      if (
        isImportDefaultSpecifier(first) ||
        isImportNamespaceSpecifier(first)
      ) {
        this.print(specifiers.shift());
        if (specifiers.length) {
          this.tokenChar(44);
          this.space();
        }
      } else {
        break;
      }
    }
    let hasBrace = false;
    if (specifiers.length) {
      hasBrace = true;
      this.tokenChar(123);
      this.space();
      this.printList(specifiers, {
        printTrailingSeparator: this.shouldPrintTrailingComma('}'),
      });
      this.space();
      this.tokenChar(125);
    } else if (isTypeKind && !hasSpecifiers) {
      hasBrace = true;
      this.tokenChar(123);
      this.tokenChar(125);
    }
    if (hasSpecifiers || isTypeKind) {
      this.space();
      this.word('from');
      this.space();
    }
    if (
      ((_node$attributes3 = node.attributes) != null &&
        _node$attributes3.length) ||
      ((_node$assertions3 = node.assertions) != null &&
        _node$assertions3.length)
    ) {
      this.print(node.source, true);
      this.space();
      this._printAttributes(node, hasBrace);
    } else {
      this.print(node.source);
    }
    this.semicolon();
  }
  function ImportAttribute(node) {
    this.print(node.key);
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ImportNamespaceSpecifier(node) {
    this.tokenChar(42);
    this.space();
    this.word('as');
    this.space();
    this.print(node.local);
  }
  function ImportExpression(node) {
    this.word('import');
    if (node.phase) {
      this.tokenChar(46);
      this.word(node.phase);
    }
    this.tokenChar(40);
    this.print(node.source);
    if (node.options != null) {
      this.tokenChar(44);
      this.space();
      this.print(node.options);
    }
    this.tokenChar(41);
  }
  return modules$1;
}
var types$1 = {};
var jsesc_1$1;
var hasRequiredJsesc$1;
function requireJsesc$1() {
  if (hasRequiredJsesc$1) return jsesc_1$1;
  hasRequiredJsesc$1 = 1;
  const object = {};
  const hasOwnProperty = object.hasOwnProperty;
  const forOwn = (object, callback) => {
    for (const key in object) {
      if (hasOwnProperty.call(object, key)) {
        callback(key, object[key]);
      }
    }
  };
  const extend = (destination, source) => {
    if (!source) {
      return destination;
    }
    forOwn(source, (key, value) => {
      destination[key] = value;
    });
    return destination;
  };
  const forEach = (array, callback) => {
    const length = array.length;
    let index = -1;
    while (++index < length) {
      callback(array[index]);
    }
  };
  const fourHexEscape = hex => '\\u' + ('0000' + hex).slice(-4);
  const hexadecimal = (code, lowercase) => {
    let hexadecimal = code.toString(16);
    if (lowercase) return hexadecimal;
    return hexadecimal.toUpperCase();
  };
  const toString = object.toString;
  const isArray = Array.isArray;
  const isBuffer = value =>
    typeof Buffer === 'function' && Buffer.isBuffer(value);
  const isObject = value => toString.call(value) == '[object Object]';
  const isString = value =>
    typeof value == 'string' || toString.call(value) == '[object String]';
  const isNumber = value =>
    typeof value == 'number' || toString.call(value) == '[object Number]';
  const isFunction = value => typeof value == 'function';
  const isMap = value => toString.call(value) == '[object Map]';
  const isSet = value => toString.call(value) == '[object Set]';
  const singleEscapes = {
    '\\': '\\\\',
    '\b': '\\b',
    '\f': '\\f',
    '\n': '\\n',
    '\r': '\\r',
    '\t': '\\t',
  };
  const regexSingleEscape = /[\\\b\f\n\r\t]/;
  const regexDigit = /[0-9]/;
  const regexWhitespace =
    /[\xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]/;
  const escapeEverythingRegex =
    /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^]/g;
  const escapeNonAsciiRegex =
    /([\uD800-\uDBFF][\uDC00-\uDFFF])|([\uD800-\uDFFF])|(['"`])|[^ !#-&\(-\[\]-_a-~]/g;
  const jsesc = (argument, options) => {
    const increaseIndentation = () => {
      oldIndent = indent;
      ++options.indentLevel;
      indent = options.indent.repeat(options.indentLevel);
    };
    const defaults = {
      escapeEverything: false,
      minimal: false,
      isScriptContext: false,
      quotes: 'single',
      wrap: false,
      es6: false,
      json: false,
      compact: true,
      lowercaseHex: false,
      numbers: 'decimal',
      indent: '\t',
      indentLevel: 0,
      __inline1__: false,
      __inline2__: false,
    };
    const json = options && options.json;
    if (json) {
      defaults.quotes = 'double';
      defaults.wrap = true;
    }
    options = extend(defaults, options);
    if (
      options.quotes != 'single' &&
      options.quotes != 'double' &&
      options.quotes != 'backtick'
    ) {
      options.quotes = 'single';
    }
    const quote =
      options.quotes == 'double'
        ? '"'
        : options.quotes == 'backtick'
          ? '`'
          : "'";
    const compact = options.compact;
    const lowercaseHex = options.lowercaseHex;
    let indent = options.indent.repeat(options.indentLevel);
    let oldIndent = '';
    const inline1 = options.__inline1__;
    const inline2 = options.__inline2__;
    const newLine = compact ? '' : '\n';
    let result;
    let isEmpty = true;
    const useBinNumbers = options.numbers == 'binary';
    const useOctNumbers = options.numbers == 'octal';
    const useDecNumbers = options.numbers == 'decimal';
    const useHexNumbers = options.numbers == 'hexadecimal';
    if (json && argument && isFunction(argument.toJSON)) {
      argument = argument.toJSON();
    }
    if (!isString(argument)) {
      if (isMap(argument)) {
        if (argument.size == 0) {
          return 'new Map()';
        }
        if (!compact) {
          options.__inline1__ = true;
          options.__inline2__ = false;
        }
        return 'new Map(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isSet(argument)) {
        if (argument.size == 0) {
          return 'new Set()';
        }
        return 'new Set(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isBuffer(argument)) {
        if (argument.length == 0) {
          return 'Buffer.from([])';
        }
        return 'Buffer.from(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isArray(argument)) {
        result = [];
        options.wrap = true;
        if (inline1) {
          options.__inline1__ = false;
          options.__inline2__ = true;
        }
        if (!inline2) {
          increaseIndentation();
        }
        forEach(argument, value => {
          isEmpty = false;
          if (inline2) {
            options.__inline2__ = false;
          }
          result.push(
            (compact || inline2 ? '' : indent) + jsesc(value, options)
          );
        });
        if (isEmpty) {
          return '[]';
        }
        if (inline2) {
          return '[' + result.join(', ') + ']';
        }
        return (
          '[' +
          newLine +
          result.join(',' + newLine) +
          newLine +
          (compact ? '' : oldIndent) +
          ']'
        );
      } else if (isNumber(argument)) {
        if (json) {
          return JSON.stringify(argument);
        }
        if (useDecNumbers) {
          return String(argument);
        }
        if (useHexNumbers) {
          let hexadecimal = argument.toString(16);
          if (!lowercaseHex) {
            hexadecimal = hexadecimal.toUpperCase();
          }
          return '0x' + hexadecimal;
        }
        if (useBinNumbers) {
          return '0b' + argument.toString(2);
        }
        if (useOctNumbers) {
          return '0o' + argument.toString(8);
        }
      } else if (!isObject(argument)) {
        if (json) {
          return JSON.stringify(argument) || 'null';
        }
        return String(argument);
      } else {
        result = [];
        options.wrap = true;
        increaseIndentation();
        forOwn(argument, (key, value) => {
          isEmpty = false;
          result.push(
            (compact ? '' : indent) +
              jsesc(key, options) +
              ':' +
              (compact ? '' : ' ') +
              jsesc(value, options)
          );
        });
        if (isEmpty) {
          return '{}';
        }
        return (
          '{' +
          newLine +
          result.join(',' + newLine) +
          newLine +
          (compact ? '' : oldIndent) +
          '}'
        );
      }
    }
    const regex = options.escapeEverything
      ? escapeEverythingRegex
      : escapeNonAsciiRegex;
    result = argument.replace(
      regex,
      (char, pair, lone, quoteChar, index, string) => {
        if (pair) {
          if (options.minimal) return pair;
          const first = pair.charCodeAt(0);
          const second = pair.charCodeAt(1);
          if (options.es6) {
            const codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
            const hex = hexadecimal(codePoint, lowercaseHex);
            return '\\u{' + hex + '}';
          }
          return (
            fourHexEscape(hexadecimal(first, lowercaseHex)) +
            fourHexEscape(hexadecimal(second, lowercaseHex))
          );
        }
        if (lone) {
          return fourHexEscape(hexadecimal(lone.charCodeAt(0), lowercaseHex));
        }
        if (
          char == '\0' &&
          !json &&
          !regexDigit.test(string.charAt(index + 1))
        ) {
          return '\\0';
        }
        if (quoteChar) {
          if (quoteChar == quote || options.escapeEverything) {
            return '\\' + quoteChar;
          }
          return quoteChar;
        }
        if (regexSingleEscape.test(char)) {
          return singleEscapes[char];
        }
        if (options.minimal && !regexWhitespace.test(char)) {
          return char;
        }
        const hex = hexadecimal(char.charCodeAt(0), lowercaseHex);
        if (json || hex.length > 2) {
          return fourHexEscape(hex);
        }
        return '\\x' + ('00' + hex).slice(-2);
      }
    );
    if (quote == '`') {
      result = result.replace(/\$\{/g, '\\${');
    }
    if (options.isScriptContext) {
      result = result
        .replace(/<\/(script|style)/gi, '<\\/$1')
        .replace(/<!--/g, json ? '\\u003C!--' : '\\x3C!--');
    }
    if (options.wrap) {
      result = quote + result + quote;
    }
    return result;
  };
  jsesc.version = '3.0.2';
  jsesc_1$1 = jsesc;
  return jsesc_1$1;
}
var hasRequiredTypes;
function requireTypes() {
  if (hasRequiredTypes) return types$1;
  hasRequiredTypes = 1;
  Object.defineProperty(types$1, '__esModule', {value: true});
  types$1.ArgumentPlaceholder = ArgumentPlaceholder;
  types$1.ArrayPattern = types$1.ArrayExpression = ArrayExpression;
  types$1.BigIntLiteral = BigIntLiteral;
  types$1.BooleanLiteral = BooleanLiteral;
  types$1.DecimalLiteral = DecimalLiteral;
  types$1.Identifier = Identifier;
  types$1.NullLiteral = NullLiteral;
  types$1.NumericLiteral = NumericLiteral;
  types$1.ObjectPattern = types$1.ObjectExpression = ObjectExpression;
  types$1.ObjectMethod = ObjectMethod;
  types$1.ObjectProperty = ObjectProperty;
  types$1.PipelineBareFunction = PipelineBareFunction;
  types$1.PipelinePrimaryTopicReference = PipelinePrimaryTopicReference;
  types$1.PipelineTopicExpression = PipelineTopicExpression;
  types$1.RecordExpression = RecordExpression;
  types$1.RegExpLiteral = RegExpLiteral;
  types$1.SpreadElement = types$1.RestElement = RestElement;
  types$1.StringLiteral = StringLiteral;
  types$1.TopicReference = TopicReference;
  types$1.TupleExpression = TupleExpression;
  types$1._getRawIdentifier = _getRawIdentifier;
  var _t = t$d;
  var _jsesc = requireJsesc$1();
  const {isAssignmentPattern: isAssignmentPattern, isIdentifier: isIdentifier} =
    _t;
  let lastRawIdentNode = null;
  let lastRawIdentResult = '';
  function _getRawIdentifier(node) {
    if (node === lastRawIdentNode) return lastRawIdentResult;
    lastRawIdentNode = node;
    const {name: name} = node;
    const token = this.tokenMap.find(node, tok => tok.value === name);
    if (token) {
      lastRawIdentResult = this._originalCode.slice(token.start, token.end);
      return lastRawIdentResult;
    }
    return (lastRawIdentResult = node.name);
  }
  function Identifier(node) {
    var _node$loc;
    this.sourceIdentifierName(
      ((_node$loc = node.loc) == null ? void 0 : _node$loc.identifierName) ||
        node.name
    );
    this.word(this.tokenMap ? this._getRawIdentifier(node) : node.name);
  }
  function ArgumentPlaceholder() {
    this.tokenChar(63);
  }
  function RestElement(node) {
    this.token('...');
    this.print(node.argument);
  }
  function ObjectExpression(node) {
    const props = node.properties;
    this.tokenChar(123);
    if (props.length) {
      const exit = this.enterDelimited();
      this.space();
      this.printList(props, {
        indent: true,
        statement: true,
        printTrailingSeparator: this.shouldPrintTrailingComma('}'),
      });
      this.space();
      exit();
    }
    this.sourceWithOffset('end', node.loc, -1);
    this.tokenChar(125);
  }
  function ObjectMethod(node) {
    this.printJoin(node.decorators);
    this._methodHead(node);
    this.space();
    this.print(node.body);
  }
  function ObjectProperty(node) {
    this.printJoin(node.decorators);
    if (node.computed) {
      this.tokenChar(91);
      this.print(node.key);
      this.tokenChar(93);
    } else {
      if (
        isAssignmentPattern(node.value) &&
        isIdentifier(node.key) &&
        node.key.name === node.value.left.name
      ) {
        this.print(node.value);
        return;
      }
      this.print(node.key);
      if (
        node.shorthand &&
        isIdentifier(node.key) &&
        isIdentifier(node.value) &&
        node.key.name === node.value.name
      ) {
        return;
      }
    }
    this.tokenChar(58);
    this.space();
    this.print(node.value);
  }
  function ArrayExpression(node) {
    const elems = node.elements;
    const len = elems.length;
    this.tokenChar(91);
    const exit = this.enterDelimited();
    for (let i = 0; i < elems.length; i++) {
      const elem = elems[i];
      if (elem) {
        if (i > 0) this.space();
        this.print(elem);
        if (i < len - 1 || this.shouldPrintTrailingComma(']')) {
          this.token(',', false, i);
        }
      } else {
        this.token(',', false, i);
      }
    }
    exit();
    this.tokenChar(93);
  }
  function RecordExpression(node) {
    const props = node.properties;
    let startToken;
    let endToken;
    {
      if (this.format.recordAndTupleSyntaxType === 'bar') {
        startToken = '{|';
        endToken = '|}';
      } else if (
        this.format.recordAndTupleSyntaxType !== 'hash' &&
        this.format.recordAndTupleSyntaxType != null
      ) {
        throw new Error(
          `The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" (${JSON.stringify(this.format.recordAndTupleSyntaxType)} received).`
        );
      } else {
        startToken = '#{';
        endToken = '}';
      }
    }
    this.token(startToken);
    if (props.length) {
      this.space();
      this.printList(props, {
        indent: true,
        statement: true,
        printTrailingSeparator: this.shouldPrintTrailingComma(endToken),
      });
      this.space();
    }
    this.token(endToken);
  }
  function TupleExpression(node) {
    const elems = node.elements;
    const len = elems.length;
    let startToken;
    let endToken;
    {
      if (this.format.recordAndTupleSyntaxType === 'bar') {
        startToken = '[|';
        endToken = '|]';
      } else if (this.format.recordAndTupleSyntaxType === 'hash') {
        startToken = '#[';
        endToken = ']';
      } else {
        throw new Error(
          `${this.format.recordAndTupleSyntaxType} is not a valid recordAndTuple syntax type`
        );
      }
    }
    this.token(startToken);
    for (let i = 0; i < elems.length; i++) {
      const elem = elems[i];
      if (elem) {
        if (i > 0) this.space();
        this.print(elem);
        if (i < len - 1 || this.shouldPrintTrailingComma(endToken)) {
          this.token(',', false, i);
        }
      }
    }
    this.token(endToken);
  }
  function RegExpLiteral(node) {
    this.word(`/${node.pattern}/${node.flags}`);
  }
  function BooleanLiteral(node) {
    this.word(node.value ? 'true' : 'false');
  }
  function NullLiteral() {
    this.word('null');
  }
  function NumericLiteral(node) {
    const raw = this.getPossibleRaw(node);
    const opts = this.format.jsescOption;
    const value = node.value;
    const str = value + '';
    if (opts.numbers) {
      this.number(_jsesc(value, opts), value);
    } else if (raw == null) {
      this.number(str, value);
    } else if (this.format.minified) {
      this.number(raw.length < str.length ? raw : str, value);
    } else {
      this.number(raw, value);
    }
  }
  function StringLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.token(raw);
      return;
    }
    const val = _jsesc(node.value, this.format.jsescOption);
    this.token(val);
  }
  function BigIntLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.word(raw);
      return;
    }
    this.word(node.value + 'n');
  }
  function DecimalLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.word(raw);
      return;
    }
    this.word(node.value + 'm');
  }
  const validTopicTokenSet = new Set(['^^', '@@', '^', '%', '#']);
  function TopicReference() {
    const {topicToken: topicToken} = this.format;
    if (validTopicTokenSet.has(topicToken)) {
      this.token(topicToken);
    } else {
      const givenTopicTokenJSON = JSON.stringify(topicToken);
      const validTopics = Array.from(validTopicTokenSet, v =>
        JSON.stringify(v)
      );
      throw new Error(
        `The "topicToken" generator option must be one of ` +
          `${validTopics.join(', ')} (${givenTopicTokenJSON} received instead).`
      );
    }
  }
  function PipelineTopicExpression(node) {
    this.print(node.expression);
  }
  function PipelineBareFunction(node) {
    this.print(node.callee);
  }
  function PipelinePrimaryTopicReference() {
    this.tokenChar(35);
  }
  return types$1;
}
var flow$1 = {};
var hasRequiredFlow;
function requireFlow() {
  if (hasRequiredFlow) return flow$1;
  hasRequiredFlow = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.AnyTypeAnnotation = AnyTypeAnnotation;
    exports.ArrayTypeAnnotation = ArrayTypeAnnotation;
    exports.BooleanLiteralTypeAnnotation = BooleanLiteralTypeAnnotation;
    exports.BooleanTypeAnnotation = BooleanTypeAnnotation;
    exports.DeclareClass = DeclareClass;
    exports.DeclareExportAllDeclaration = DeclareExportAllDeclaration;
    exports.DeclareExportDeclaration = DeclareExportDeclaration;
    exports.DeclareFunction = DeclareFunction;
    exports.DeclareInterface = DeclareInterface;
    exports.DeclareModule = DeclareModule;
    exports.DeclareModuleExports = DeclareModuleExports;
    exports.DeclareOpaqueType = DeclareOpaqueType;
    exports.DeclareTypeAlias = DeclareTypeAlias;
    exports.DeclareVariable = DeclareVariable;
    exports.DeclaredPredicate = DeclaredPredicate;
    exports.EmptyTypeAnnotation = EmptyTypeAnnotation;
    exports.EnumBooleanBody = EnumBooleanBody;
    exports.EnumBooleanMember = EnumBooleanMember;
    exports.EnumDeclaration = EnumDeclaration;
    exports.EnumDefaultedMember = EnumDefaultedMember;
    exports.EnumNumberBody = EnumNumberBody;
    exports.EnumNumberMember = EnumNumberMember;
    exports.EnumStringBody = EnumStringBody;
    exports.EnumStringMember = EnumStringMember;
    exports.EnumSymbolBody = EnumSymbolBody;
    exports.ExistsTypeAnnotation = ExistsTypeAnnotation;
    exports.FunctionTypeAnnotation = FunctionTypeAnnotation;
    exports.FunctionTypeParam = FunctionTypeParam;
    exports.IndexedAccessType = IndexedAccessType;
    exports.InferredPredicate = InferredPredicate;
    exports.InterfaceDeclaration = InterfaceDeclaration;
    exports.GenericTypeAnnotation =
      exports.ClassImplements =
      exports.InterfaceExtends =
        InterfaceExtends;
    exports.InterfaceTypeAnnotation = InterfaceTypeAnnotation;
    exports.IntersectionTypeAnnotation = IntersectionTypeAnnotation;
    exports.MixedTypeAnnotation = MixedTypeAnnotation;
    exports.NullLiteralTypeAnnotation = NullLiteralTypeAnnotation;
    exports.NullableTypeAnnotation = NullableTypeAnnotation;
    Object.defineProperty(exports, 'NumberLiteralTypeAnnotation', {
      enumerable: true,
      get: function () {
        return _types2.NumericLiteral;
      },
    });
    exports.NumberTypeAnnotation = NumberTypeAnnotation;
    exports.ObjectTypeAnnotation = ObjectTypeAnnotation;
    exports.ObjectTypeCallProperty = ObjectTypeCallProperty;
    exports.ObjectTypeIndexer = ObjectTypeIndexer;
    exports.ObjectTypeInternalSlot = ObjectTypeInternalSlot;
    exports.ObjectTypeProperty = ObjectTypeProperty;
    exports.ObjectTypeSpreadProperty = ObjectTypeSpreadProperty;
    exports.OpaqueType = OpaqueType;
    exports.OptionalIndexedAccessType = OptionalIndexedAccessType;
    exports.QualifiedTypeIdentifier = QualifiedTypeIdentifier;
    Object.defineProperty(exports, 'StringLiteralTypeAnnotation', {
      enumerable: true,
      get: function () {
        return _types2.StringLiteral;
      },
    });
    exports.StringTypeAnnotation = StringTypeAnnotation;
    exports.SymbolTypeAnnotation = SymbolTypeAnnotation;
    exports.ThisTypeAnnotation = ThisTypeAnnotation;
    exports.TupleTypeAnnotation = TupleTypeAnnotation;
    exports.TypeAlias = TypeAlias;
    exports.TypeAnnotation = TypeAnnotation;
    exports.TypeCastExpression = TypeCastExpression;
    exports.TypeParameter = TypeParameter;
    exports.TypeParameterDeclaration = exports.TypeParameterInstantiation =
      TypeParameterInstantiation;
    exports.TypeofTypeAnnotation = TypeofTypeAnnotation;
    exports.UnionTypeAnnotation = UnionTypeAnnotation;
    exports.Variance = Variance;
    exports.VoidTypeAnnotation = VoidTypeAnnotation;
    exports._interfaceish = _interfaceish;
    exports._variance = _variance;
    var _t = t$d;
    var _modules = requireModules();
    var _index = requireNode();
    var _types2 = requireTypes();
    const {
      isDeclareExportDeclaration: isDeclareExportDeclaration,
      isStatement: isStatement,
    } = _t;
    function AnyTypeAnnotation() {
      this.word('any');
    }
    function ArrayTypeAnnotation(node) {
      this.print(node.elementType, true);
      this.tokenChar(91);
      this.tokenChar(93);
    }
    function BooleanTypeAnnotation() {
      this.word('boolean');
    }
    function BooleanLiteralTypeAnnotation(node) {
      this.word(node.value ? 'true' : 'false');
    }
    function NullLiteralTypeAnnotation() {
      this.word('null');
    }
    function DeclareClass(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.word('class');
      this.space();
      this._interfaceish(node);
    }
    function DeclareFunction(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.word('function');
      this.space();
      this.print(node.id);
      this.print(node.id.typeAnnotation.typeAnnotation);
      if (node.predicate) {
        this.space();
        this.print(node.predicate);
      }
      this.semicolon();
    }
    function InferredPredicate() {
      this.tokenChar(37);
      this.word('checks');
    }
    function DeclaredPredicate(node) {
      this.tokenChar(37);
      this.word('checks');
      this.tokenChar(40);
      this.print(node.value);
      this.tokenChar(41);
    }
    function DeclareInterface(node) {
      this.word('declare');
      this.space();
      this.InterfaceDeclaration(node);
    }
    function DeclareModule(node) {
      this.word('declare');
      this.space();
      this.word('module');
      this.space();
      this.print(node.id);
      this.space();
      this.print(node.body);
    }
    function DeclareModuleExports(node) {
      this.word('declare');
      this.space();
      this.word('module');
      this.tokenChar(46);
      this.word('exports');
      this.print(node.typeAnnotation);
    }
    function DeclareTypeAlias(node) {
      this.word('declare');
      this.space();
      this.TypeAlias(node);
    }
    function DeclareOpaqueType(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.OpaqueType(node);
    }
    function DeclareVariable(node, parent) {
      if (!isDeclareExportDeclaration(parent)) {
        this.word('declare');
        this.space();
      }
      this.word('var');
      this.space();
      this.print(node.id);
      this.print(node.id.typeAnnotation);
      this.semicolon();
    }
    function DeclareExportDeclaration(node) {
      this.word('declare');
      this.space();
      this.word('export');
      this.space();
      if (node.default) {
        this.word('default');
        this.space();
      }
      FlowExportDeclaration.call(this, node);
    }
    function DeclareExportAllDeclaration(node) {
      this.word('declare');
      this.space();
      _modules.ExportAllDeclaration.call(this, node);
    }
    function EnumDeclaration(node) {
      const {id: id, body: body} = node;
      this.word('enum');
      this.space();
      this.print(id);
      this.print(body);
    }
    function enumExplicitType(context, name, hasExplicitType) {
      if (hasExplicitType) {
        context.space();
        context.word('of');
        context.space();
        context.word(name);
      }
      context.space();
    }
    function enumBody(context, node) {
      const {members: members} = node;
      context.token('{');
      context.indent();
      context.newline();
      for (const member of members) {
        context.print(member);
        context.newline();
      }
      if (node.hasUnknownMembers) {
        context.token('...');
        context.newline();
      }
      context.dedent();
      context.token('}');
    }
    function EnumBooleanBody(node) {
      const {explicitType: explicitType} = node;
      enumExplicitType(this, 'boolean', explicitType);
      enumBody(this, node);
    }
    function EnumNumberBody(node) {
      const {explicitType: explicitType} = node;
      enumExplicitType(this, 'number', explicitType);
      enumBody(this, node);
    }
    function EnumStringBody(node) {
      const {explicitType: explicitType} = node;
      enumExplicitType(this, 'string', explicitType);
      enumBody(this, node);
    }
    function EnumSymbolBody(node) {
      enumExplicitType(this, 'symbol', true);
      enumBody(this, node);
    }
    function EnumDefaultedMember(node) {
      const {id: id} = node;
      this.print(id);
      this.tokenChar(44);
    }
    function enumInitializedMember(context, node) {
      context.print(node.id);
      context.space();
      context.token('=');
      context.space();
      context.print(node.init);
      context.token(',');
    }
    function EnumBooleanMember(node) {
      enumInitializedMember(this, node);
    }
    function EnumNumberMember(node) {
      enumInitializedMember(this, node);
    }
    function EnumStringMember(node) {
      enumInitializedMember(this, node);
    }
    function FlowExportDeclaration(node) {
      if (node.declaration) {
        const declar = node.declaration;
        this.print(declar);
        if (!isStatement(declar)) this.semicolon();
      } else {
        this.tokenChar(123);
        if (node.specifiers.length) {
          this.space();
          this.printList(node.specifiers);
          this.space();
        }
        this.tokenChar(125);
        if (node.source) {
          this.space();
          this.word('from');
          this.space();
          this.print(node.source);
        }
        this.semicolon();
      }
    }
    function ExistsTypeAnnotation() {
      this.tokenChar(42);
    }
    function FunctionTypeAnnotation(node, parent) {
      this.print(node.typeParameters);
      this.tokenChar(40);
      if (node.this) {
        this.word('this');
        this.tokenChar(58);
        this.space();
        this.print(node.this.typeAnnotation);
        if (node.params.length || node.rest) {
          this.tokenChar(44);
          this.space();
        }
      }
      this.printList(node.params);
      if (node.rest) {
        if (node.params.length) {
          this.tokenChar(44);
          this.space();
        }
        this.token('...');
        this.print(node.rest);
      }
      this.tokenChar(41);
      const type = parent == null ? void 0 : parent.type;
      if (
        type != null &&
        (type === 'ObjectTypeCallProperty' ||
          type === 'ObjectTypeInternalSlot' ||
          type === 'DeclareFunction' ||
          (type === 'ObjectTypeProperty' && parent.method))
      ) {
        this.tokenChar(58);
      } else {
        this.space();
        this.token('=>');
      }
      this.space();
      this.print(node.returnType);
    }
    function FunctionTypeParam(node) {
      this.print(node.name);
      if (node.optional) this.tokenChar(63);
      if (node.name) {
        this.tokenChar(58);
        this.space();
      }
      this.print(node.typeAnnotation);
    }
    function InterfaceExtends(node) {
      this.print(node.id);
      this.print(node.typeParameters, true);
    }
    function _interfaceish(node) {
      var _node$extends;
      this.print(node.id);
      this.print(node.typeParameters);
      if ((_node$extends = node.extends) != null && _node$extends.length) {
        this.space();
        this.word('extends');
        this.space();
        this.printList(node.extends);
      }
      if (node.type === 'DeclareClass') {
        var _node$mixins, _node$implements;
        if ((_node$mixins = node.mixins) != null && _node$mixins.length) {
          this.space();
          this.word('mixins');
          this.space();
          this.printList(node.mixins);
        }
        if (
          (_node$implements = node.implements) != null &&
          _node$implements.length
        ) {
          this.space();
          this.word('implements');
          this.space();
          this.printList(node.implements);
        }
      }
      this.space();
      this.print(node.body);
    }
    function _variance(node) {
      var _node$variance;
      const kind =
        (_node$variance = node.variance) == null ? void 0 : _node$variance.kind;
      if (kind != null) {
        if (kind === 'plus') {
          this.tokenChar(43);
        } else if (kind === 'minus') {
          this.tokenChar(45);
        }
      }
    }
    function InterfaceDeclaration(node) {
      this.word('interface');
      this.space();
      this._interfaceish(node);
    }
    function andSeparator(occurrenceCount) {
      this.space();
      this.token('&', false, occurrenceCount);
      this.space();
    }
    function InterfaceTypeAnnotation(node) {
      var _node$extends2;
      this.word('interface');
      if ((_node$extends2 = node.extends) != null && _node$extends2.length) {
        this.space();
        this.word('extends');
        this.space();
        this.printList(node.extends);
      }
      this.space();
      this.print(node.body);
    }
    function IntersectionTypeAnnotation(node) {
      this.printJoin(node.types, {separator: andSeparator});
    }
    function MixedTypeAnnotation() {
      this.word('mixed');
    }
    function EmptyTypeAnnotation() {
      this.word('empty');
    }
    function NullableTypeAnnotation(node) {
      this.tokenChar(63);
      this.print(node.typeAnnotation);
    }
    function NumberTypeAnnotation() {
      this.word('number');
    }
    function StringTypeAnnotation() {
      this.word('string');
    }
    function ThisTypeAnnotation() {
      this.word('this');
    }
    function TupleTypeAnnotation(node) {
      this.tokenChar(91);
      this.printList(node.types);
      this.tokenChar(93);
    }
    function TypeofTypeAnnotation(node) {
      this.word('typeof');
      this.space();
      this.print(node.argument);
    }
    function TypeAlias(node) {
      this.word('type');
      this.space();
      this.print(node.id);
      this.print(node.typeParameters);
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.right);
      this.semicolon();
    }
    function TypeAnnotation(node, parent) {
      this.tokenChar(58);
      this.space();
      if (parent.type === 'ArrowFunctionExpression') {
        this.tokenContext |= _index.TokenContext.arrowFlowReturnType;
      } else if (node.optional) {
        this.tokenChar(63);
      }
      this.print(node.typeAnnotation);
    }
    function TypeParameterInstantiation(node) {
      this.tokenChar(60);
      this.printList(node.params, {});
      this.tokenChar(62);
    }
    function TypeParameter(node) {
      this._variance(node);
      this.word(node.name);
      if (node.bound) {
        this.print(node.bound);
      }
      if (node.default) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.default);
      }
    }
    function OpaqueType(node) {
      this.word('opaque');
      this.space();
      this.word('type');
      this.space();
      this.print(node.id);
      this.print(node.typeParameters);
      if (node.supertype) {
        this.tokenChar(58);
        this.space();
        this.print(node.supertype);
      }
      if (node.impltype) {
        this.space();
        this.tokenChar(61);
        this.space();
        this.print(node.impltype);
      }
      this.semicolon();
    }
    function ObjectTypeAnnotation(node) {
      if (node.exact) {
        this.token('{|');
      } else {
        this.tokenChar(123);
      }
      const props = [
        ...node.properties,
        ...(node.callProperties || []),
        ...(node.indexers || []),
        ...(node.internalSlots || []),
      ];
      if (props.length) {
        this.newline();
        this.space();
        this.printJoin(props, {
          addNewlines(leading) {
            if (leading && !props[0]) return 1;
          },
          indent: true,
          statement: true,
          iterator: () => {
            if (props.length !== 1 || node.inexact) {
              this.tokenChar(44);
              this.space();
            }
          },
        });
        this.space();
      }
      if (node.inexact) {
        this.indent();
        this.token('...');
        if (props.length) {
          this.newline();
        }
        this.dedent();
      }
      if (node.exact) {
        this.token('|}');
      } else {
        this.tokenChar(125);
      }
    }
    function ObjectTypeInternalSlot(node) {
      if (node.static) {
        this.word('static');
        this.space();
      }
      this.tokenChar(91);
      this.tokenChar(91);
      this.print(node.id);
      this.tokenChar(93);
      this.tokenChar(93);
      if (node.optional) this.tokenChar(63);
      if (!node.method) {
        this.tokenChar(58);
        this.space();
      }
      this.print(node.value);
    }
    function ObjectTypeCallProperty(node) {
      if (node.static) {
        this.word('static');
        this.space();
      }
      this.print(node.value);
    }
    function ObjectTypeIndexer(node) {
      if (node.static) {
        this.word('static');
        this.space();
      }
      this._variance(node);
      this.tokenChar(91);
      if (node.id) {
        this.print(node.id);
        this.tokenChar(58);
        this.space();
      }
      this.print(node.key);
      this.tokenChar(93);
      this.tokenChar(58);
      this.space();
      this.print(node.value);
    }
    function ObjectTypeProperty(node) {
      if (node.proto) {
        this.word('proto');
        this.space();
      }
      if (node.static) {
        this.word('static');
        this.space();
      }
      if (node.kind === 'get' || node.kind === 'set') {
        this.word(node.kind);
        this.space();
      }
      this._variance(node);
      this.print(node.key);
      if (node.optional) this.tokenChar(63);
      if (!node.method) {
        this.tokenChar(58);
        this.space();
      }
      this.print(node.value);
    }
    function ObjectTypeSpreadProperty(node) {
      this.token('...');
      this.print(node.argument);
    }
    function QualifiedTypeIdentifier(node) {
      this.print(node.qualification);
      this.tokenChar(46);
      this.print(node.id);
    }
    function SymbolTypeAnnotation() {
      this.word('symbol');
    }
    function orSeparator(occurrenceCount) {
      this.space();
      this.token('|', false, occurrenceCount);
      this.space();
    }
    function UnionTypeAnnotation(node) {
      this.printJoin(node.types, {separator: orSeparator});
    }
    function TypeCastExpression(node) {
      this.tokenChar(40);
      this.print(node.expression);
      this.print(node.typeAnnotation);
      this.tokenChar(41);
    }
    function Variance(node) {
      if (node.kind === 'plus') {
        this.tokenChar(43);
      } else {
        this.tokenChar(45);
      }
    }
    function VoidTypeAnnotation() {
      this.word('void');
    }
    function IndexedAccessType(node) {
      this.print(node.objectType, true);
      this.tokenChar(91);
      this.print(node.indexType);
      this.tokenChar(93);
    }
    function OptionalIndexedAccessType(node) {
      this.print(node.objectType);
      if (node.optional) {
        this.token('?.');
      }
      this.tokenChar(91);
      this.print(node.indexType);
      this.tokenChar(93);
    }
  })(flow$1);
  return flow$1;
}
var base$1 = {};
var hasRequiredBase;
function requireBase() {
  if (hasRequiredBase) return base$1;
  hasRequiredBase = 1;
  Object.defineProperty(base$1, '__esModule', {value: true});
  base$1.BlockStatement = BlockStatement;
  base$1.Directive = Directive;
  base$1.DirectiveLiteral = DirectiveLiteral;
  base$1.File = File;
  base$1.InterpreterDirective = InterpreterDirective;
  base$1.Placeholder = Placeholder;
  base$1.Program = Program;
  function File(node) {
    if (node.program) {
      this.print(node.program.interpreter);
    }
    this.print(node.program);
  }
  function Program(node) {
    var _node$directives;
    this.noIndentInnerCommentsHere();
    this.printInnerComments();
    const directivesLen =
      (_node$directives = node.directives) == null
        ? void 0
        : _node$directives.length;
    if (directivesLen) {
      var _node$directives$trai;
      const newline = node.body.length ? 2 : 1;
      this.printSequence(node.directives, {
        trailingCommentsLineOffset: newline,
      });
      if (
        !(
          (_node$directives$trai =
            node.directives[directivesLen - 1].trailingComments) != null &&
          _node$directives$trai.length
        )
      ) {
        this.newline(newline);
      }
    }
    this.printSequence(node.body);
  }
  function BlockStatement(node) {
    var _node$directives2;
    this.tokenChar(123);
    const exit = this.enterDelimited();
    const directivesLen =
      (_node$directives2 = node.directives) == null
        ? void 0
        : _node$directives2.length;
    if (directivesLen) {
      var _node$directives$trai2;
      const newline = node.body.length ? 2 : 1;
      this.printSequence(node.directives, {
        indent: true,
        trailingCommentsLineOffset: newline,
      });
      if (
        !(
          (_node$directives$trai2 =
            node.directives[directivesLen - 1].trailingComments) != null &&
          _node$directives$trai2.length
        )
      ) {
        this.newline(newline);
      }
    }
    this.printSequence(node.body, {indent: true});
    exit();
    this.rightBrace(node);
  }
  function Directive(node) {
    this.print(node.value);
    this.semicolon();
  }
  const unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
  const unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
  function DirectiveLiteral(node) {
    const raw = this.getPossibleRaw(node);
    if (!this.format.minified && raw !== undefined) {
      this.token(raw);
      return;
    }
    const {value: value} = node;
    if (!unescapedDoubleQuoteRE.test(value)) {
      this.token(`"${value}"`);
    } else if (!unescapedSingleQuoteRE.test(value)) {
      this.token(`'${value}'`);
    } else {
      throw new Error(
        'Malformed AST: it is not possible to print a directive containing' +
          ' both unescaped single and double quotes.'
      );
    }
  }
  function InterpreterDirective(node) {
    this.token(`#!${node.value}`);
    this.newline(1, true);
  }
  function Placeholder(node) {
    this.token('%%');
    this.print(node.name);
    this.token('%%');
    if (node.expectedNode === 'Statement') {
      this.semicolon();
    }
  }
  return base$1;
}
var jsx$1 = {};
var hasRequiredJsx;
function requireJsx() {
  if (hasRequiredJsx) return jsx$1;
  hasRequiredJsx = 1;
  Object.defineProperty(jsx$1, '__esModule', {value: true});
  jsx$1.JSXAttribute = JSXAttribute;
  jsx$1.JSXClosingElement = JSXClosingElement;
  jsx$1.JSXClosingFragment = JSXClosingFragment;
  jsx$1.JSXElement = JSXElement;
  jsx$1.JSXEmptyExpression = JSXEmptyExpression;
  jsx$1.JSXExpressionContainer = JSXExpressionContainer;
  jsx$1.JSXFragment = JSXFragment;
  jsx$1.JSXIdentifier = JSXIdentifier;
  jsx$1.JSXMemberExpression = JSXMemberExpression;
  jsx$1.JSXNamespacedName = JSXNamespacedName;
  jsx$1.JSXOpeningElement = JSXOpeningElement;
  jsx$1.JSXOpeningFragment = JSXOpeningFragment;
  jsx$1.JSXSpreadAttribute = JSXSpreadAttribute;
  jsx$1.JSXSpreadChild = JSXSpreadChild;
  jsx$1.JSXText = JSXText;
  function JSXAttribute(node) {
    this.print(node.name);
    if (node.value) {
      this.tokenChar(61);
      this.print(node.value);
    }
  }
  function JSXIdentifier(node) {
    this.word(node.name);
  }
  function JSXNamespacedName(node) {
    this.print(node.namespace);
    this.tokenChar(58);
    this.print(node.name);
  }
  function JSXMemberExpression(node) {
    this.print(node.object);
    this.tokenChar(46);
    this.print(node.property);
  }
  function JSXSpreadAttribute(node) {
    this.tokenChar(123);
    this.token('...');
    this.print(node.argument);
    this.rightBrace(node);
  }
  function JSXExpressionContainer(node) {
    this.tokenChar(123);
    this.print(node.expression);
    this.rightBrace(node);
  }
  function JSXSpreadChild(node) {
    this.tokenChar(123);
    this.token('...');
    this.print(node.expression);
    this.rightBrace(node);
  }
  function JSXText(node) {
    const raw = this.getPossibleRaw(node);
    if (raw !== undefined) {
      this.token(raw, true);
    } else {
      this.token(node.value, true);
    }
  }
  function JSXElement(node) {
    const open = node.openingElement;
    this.print(open);
    if (open.selfClosing) return;
    this.indent();
    for (const child of node.children) {
      this.print(child);
    }
    this.dedent();
    this.print(node.closingElement);
  }
  function spaceSeparator() {
    this.space();
  }
  function JSXOpeningElement(node) {
    this.tokenChar(60);
    this.print(node.name);
    this.print(node.typeParameters);
    if (node.attributes.length > 0) {
      this.space();
      this.printJoin(node.attributes, {separator: spaceSeparator});
    }
    if (node.selfClosing) {
      this.space();
      this.tokenChar(47);
    }
    this.tokenChar(62);
  }
  function JSXClosingElement(node) {
    this.tokenChar(60);
    this.tokenChar(47);
    this.print(node.name);
    this.tokenChar(62);
  }
  function JSXEmptyExpression() {
    this.printInnerComments();
  }
  function JSXFragment(node) {
    this.print(node.openingFragment);
    this.indent();
    for (const child of node.children) {
      this.print(child);
    }
    this.dedent();
    this.print(node.closingFragment);
  }
  function JSXOpeningFragment() {
    this.tokenChar(60);
    this.tokenChar(62);
  }
  function JSXClosingFragment() {
    this.token('</');
    this.tokenChar(62);
  }
  return jsx$1;
}
var typescript$1 = {};
var hasRequiredTypescript;
function requireTypescript() {
  if (hasRequiredTypescript) return typescript$1;
  hasRequiredTypescript = 1;
  Object.defineProperty(typescript$1, '__esModule', {value: true});
  typescript$1.TSAnyKeyword = TSAnyKeyword;
  typescript$1.TSArrayType = TSArrayType;
  typescript$1.TSSatisfiesExpression = typescript$1.TSAsExpression =
    TSTypeExpression;
  typescript$1.TSBigIntKeyword = TSBigIntKeyword;
  typescript$1.TSBooleanKeyword = TSBooleanKeyword;
  typescript$1.TSCallSignatureDeclaration = TSCallSignatureDeclaration;
  typescript$1.TSInterfaceHeritage =
    typescript$1.TSExpressionWithTypeArguments =
    typescript$1.TSClassImplements =
      TSClassImplements;
  typescript$1.TSConditionalType = TSConditionalType;
  typescript$1.TSConstructSignatureDeclaration =
    TSConstructSignatureDeclaration;
  typescript$1.TSConstructorType = TSConstructorType;
  typescript$1.TSDeclareFunction = TSDeclareFunction;
  typescript$1.TSDeclareMethod = TSDeclareMethod;
  typescript$1.TSEnumDeclaration = TSEnumDeclaration;
  typescript$1.TSEnumMember = TSEnumMember;
  typescript$1.TSExportAssignment = TSExportAssignment;
  typescript$1.TSExternalModuleReference = TSExternalModuleReference;
  typescript$1.TSFunctionType = TSFunctionType;
  typescript$1.TSImportEqualsDeclaration = TSImportEqualsDeclaration;
  typescript$1.TSImportType = TSImportType;
  typescript$1.TSIndexSignature = TSIndexSignature;
  typescript$1.TSIndexedAccessType = TSIndexedAccessType;
  typescript$1.TSInferType = TSInferType;
  typescript$1.TSInstantiationExpression = TSInstantiationExpression;
  typescript$1.TSInterfaceBody = TSInterfaceBody;
  typescript$1.TSInterfaceDeclaration = TSInterfaceDeclaration;
  typescript$1.TSIntersectionType = TSIntersectionType;
  typescript$1.TSIntrinsicKeyword = TSIntrinsicKeyword;
  typescript$1.TSLiteralType = TSLiteralType;
  typescript$1.TSMappedType = TSMappedType;
  typescript$1.TSMethodSignature = TSMethodSignature;
  typescript$1.TSModuleBlock = TSModuleBlock;
  typescript$1.TSModuleDeclaration = TSModuleDeclaration;
  typescript$1.TSNamedTupleMember = TSNamedTupleMember;
  typescript$1.TSNamespaceExportDeclaration = TSNamespaceExportDeclaration;
  typescript$1.TSNeverKeyword = TSNeverKeyword;
  typescript$1.TSNonNullExpression = TSNonNullExpression;
  typescript$1.TSNullKeyword = TSNullKeyword;
  typescript$1.TSNumberKeyword = TSNumberKeyword;
  typescript$1.TSObjectKeyword = TSObjectKeyword;
  typescript$1.TSOptionalType = TSOptionalType;
  typescript$1.TSParameterProperty = TSParameterProperty;
  typescript$1.TSParenthesizedType = TSParenthesizedType;
  typescript$1.TSPropertySignature = TSPropertySignature;
  typescript$1.TSQualifiedName = TSQualifiedName;
  typescript$1.TSRestType = TSRestType;
  typescript$1.TSStringKeyword = TSStringKeyword;
  typescript$1.TSSymbolKeyword = TSSymbolKeyword;
  typescript$1.TSThisType = TSThisType;
  typescript$1.TSTupleType = TSTupleType;
  typescript$1.TSTypeAliasDeclaration = TSTypeAliasDeclaration;
  typescript$1.TSTypeAnnotation = TSTypeAnnotation;
  typescript$1.TSTypeAssertion = TSTypeAssertion;
  typescript$1.TSTypeLiteral = TSTypeLiteral;
  typescript$1.TSTypeOperator = TSTypeOperator;
  typescript$1.TSTypeParameter = TSTypeParameter;
  typescript$1.TSTypeParameterDeclaration =
    typescript$1.TSTypeParameterInstantiation = TSTypeParameterInstantiation;
  typescript$1.TSTypePredicate = TSTypePredicate;
  typescript$1.TSTypeQuery = TSTypeQuery;
  typescript$1.TSTypeReference = TSTypeReference;
  typescript$1.TSUndefinedKeyword = TSUndefinedKeyword;
  typescript$1.TSUnionType = TSUnionType;
  typescript$1.TSUnknownKeyword = TSUnknownKeyword;
  typescript$1.TSVoidKeyword = TSVoidKeyword;
  typescript$1.tsPrintClassMemberModifiers = tsPrintClassMemberModifiers;
  typescript$1.tsPrintFunctionOrConstructorType =
    tsPrintFunctionOrConstructorType;
  typescript$1.tsPrintPropertyOrMethodName = tsPrintPropertyOrMethodName;
  typescript$1.tsPrintSignatureDeclarationBase =
    tsPrintSignatureDeclarationBase;
  function TSTypeAnnotation(node, parent) {
    this.token(
      (parent.type === 'TSFunctionType' ||
        parent.type === 'TSConstructorType') &&
        parent.typeAnnotation === node
        ? '=>'
        : ':'
    );
    this.space();
    if (node.optional) this.tokenChar(63);
    this.print(node.typeAnnotation);
  }
  function TSTypeParameterInstantiation(node, parent) {
    this.tokenChar(60);
    let printTrailingSeparator =
      parent.type === 'ArrowFunctionExpression' && node.params.length === 1;
    if (this.tokenMap && node.start != null && node.end != null) {
      printTrailingSeparator &&
        (printTrailingSeparator = !!this.tokenMap.find(node, t =>
          this.tokenMap.matchesOriginal(t, ',')
        ));
      printTrailingSeparator ||
        (printTrailingSeparator = this.shouldPrintTrailingComma('>'));
    }
    this.printList(node.params, {
      printTrailingSeparator: printTrailingSeparator,
    });
    this.tokenChar(62);
  }
  function TSTypeParameter(node) {
    if (node.in) {
      this.word('in');
      this.space();
    }
    if (node.out) {
      this.word('out');
      this.space();
    }
    this.word(node.name);
    if (node.constraint) {
      this.space();
      this.word('extends');
      this.space();
      this.print(node.constraint);
    }
    if (node.default) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(node.default);
    }
  }
  function TSParameterProperty(node) {
    if (node.accessibility) {
      this.word(node.accessibility);
      this.space();
    }
    if (node.readonly) {
      this.word('readonly');
      this.space();
    }
    this._param(node.parameter);
  }
  function TSDeclareFunction(node, parent) {
    if (node.declare) {
      this.word('declare');
      this.space();
    }
    this._functionHead(node, parent);
    this.semicolon();
  }
  function TSDeclareMethod(node) {
    this._classMethodHead(node);
    this.semicolon();
  }
  function TSQualifiedName(node) {
    this.print(node.left);
    this.tokenChar(46);
    this.print(node.right);
  }
  function TSCallSignatureDeclaration(node) {
    this.tsPrintSignatureDeclarationBase(node);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function maybePrintTrailingCommaOrSemicolon(printer, node) {
    if (!printer.tokenMap || !node.start || !node.end) {
      printer.semicolon();
      return;
    }
    if (printer.tokenMap.endMatches(node, ',')) {
      printer.token(',');
    } else if (printer.tokenMap.endMatches(node, ';')) {
      printer.semicolon();
    }
  }
  function TSConstructSignatureDeclaration(node) {
    this.word('new');
    this.space();
    this.tsPrintSignatureDeclarationBase(node);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function TSPropertySignature(node) {
    const {readonly: readonly} = node;
    if (readonly) {
      this.word('readonly');
      this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.print(node.typeAnnotation);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function tsPrintPropertyOrMethodName(node) {
    if (node.computed) {
      this.tokenChar(91);
    }
    this.print(node.key);
    if (node.computed) {
      this.tokenChar(93);
    }
    if (node.optional) {
      this.tokenChar(63);
    }
  }
  function TSMethodSignature(node) {
    const {kind: kind} = node;
    if (kind === 'set' || kind === 'get') {
      this.word(kind);
      this.space();
    }
    this.tsPrintPropertyOrMethodName(node);
    this.tsPrintSignatureDeclarationBase(node);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function TSIndexSignature(node) {
    const {readonly: readonly, static: isStatic} = node;
    if (isStatic) {
      this.word('static');
      this.space();
    }
    if (readonly) {
      this.word('readonly');
      this.space();
    }
    this.tokenChar(91);
    this._parameters(node.parameters, ']');
    this.print(node.typeAnnotation);
    maybePrintTrailingCommaOrSemicolon(this, node);
  }
  function TSAnyKeyword() {
    this.word('any');
  }
  function TSBigIntKeyword() {
    this.word('bigint');
  }
  function TSUnknownKeyword() {
    this.word('unknown');
  }
  function TSNumberKeyword() {
    this.word('number');
  }
  function TSObjectKeyword() {
    this.word('object');
  }
  function TSBooleanKeyword() {
    this.word('boolean');
  }
  function TSStringKeyword() {
    this.word('string');
  }
  function TSSymbolKeyword() {
    this.word('symbol');
  }
  function TSVoidKeyword() {
    this.word('void');
  }
  function TSUndefinedKeyword() {
    this.word('undefined');
  }
  function TSNullKeyword() {
    this.word('null');
  }
  function TSNeverKeyword() {
    this.word('never');
  }
  function TSIntrinsicKeyword() {
    this.word('intrinsic');
  }
  function TSThisType() {
    this.word('this');
  }
  function TSFunctionType(node) {
    this.tsPrintFunctionOrConstructorType(node);
  }
  function TSConstructorType(node) {
    if (node.abstract) {
      this.word('abstract');
      this.space();
    }
    this.word('new');
    this.space();
    this.tsPrintFunctionOrConstructorType(node);
  }
  function tsPrintFunctionOrConstructorType(node) {
    const {typeParameters: typeParameters} = node;
    const parameters = node.parameters;
    this.print(typeParameters);
    this.tokenChar(40);
    this._parameters(parameters, ')');
    this.space();
    const returnType = node.typeAnnotation;
    this.print(returnType);
  }
  function TSTypeReference(node) {
    this.print(node.typeName, !!node.typeParameters);
    this.print(node.typeParameters);
  }
  function TSTypePredicate(node) {
    if (node.asserts) {
      this.word('asserts');
      this.space();
    }
    this.print(node.parameterName);
    if (node.typeAnnotation) {
      this.space();
      this.word('is');
      this.space();
      this.print(node.typeAnnotation.typeAnnotation);
    }
  }
  function TSTypeQuery(node) {
    this.word('typeof');
    this.space();
    this.print(node.exprName);
    if (node.typeParameters) {
      this.print(node.typeParameters);
    }
  }
  function TSTypeLiteral(node) {
    printBraced(this, node, () =>
      this.printJoin(node.members, {indent: true, statement: true})
    );
  }
  function TSArrayType(node) {
    this.print(node.elementType, true);
    this.tokenChar(91);
    this.tokenChar(93);
  }
  function TSTupleType(node) {
    this.tokenChar(91);
    this.printList(node.elementTypes, {
      printTrailingSeparator: this.shouldPrintTrailingComma(']'),
    });
    this.tokenChar(93);
  }
  function TSOptionalType(node) {
    this.print(node.typeAnnotation);
    this.tokenChar(63);
  }
  function TSRestType(node) {
    this.token('...');
    this.print(node.typeAnnotation);
  }
  function TSNamedTupleMember(node) {
    this.print(node.label);
    if (node.optional) this.tokenChar(63);
    this.tokenChar(58);
    this.space();
    this.print(node.elementType);
  }
  function TSUnionType(node) {
    tsPrintUnionOrIntersectionType(this, node, '|');
  }
  function TSIntersectionType(node) {
    tsPrintUnionOrIntersectionType(this, node, '&');
  }
  function tsPrintUnionOrIntersectionType(printer, node, sep) {
    var _printer$tokenMap;
    let hasLeadingToken = 0;
    if (
      (_printer$tokenMap = printer.tokenMap) != null &&
      _printer$tokenMap.startMatches(node, sep)
    ) {
      hasLeadingToken = 1;
      printer.token(sep);
    }
    printer.printJoin(node.types, {
      separator(i) {
        this.space();
        this.token(sep, null, i + hasLeadingToken);
        this.space();
      },
    });
  }
  function TSConditionalType(node) {
    this.print(node.checkType);
    this.space();
    this.word('extends');
    this.space();
    this.print(node.extendsType);
    this.space();
    this.tokenChar(63);
    this.space();
    this.print(node.trueType);
    this.space();
    this.tokenChar(58);
    this.space();
    this.print(node.falseType);
  }
  function TSInferType(node) {
    this.word('infer');
    this.print(node.typeParameter);
  }
  function TSParenthesizedType(node) {
    this.tokenChar(40);
    this.print(node.typeAnnotation);
    this.tokenChar(41);
  }
  function TSTypeOperator(node) {
    this.word(node.operator);
    this.space();
    this.print(node.typeAnnotation);
  }
  function TSIndexedAccessType(node) {
    this.print(node.objectType, true);
    this.tokenChar(91);
    this.print(node.indexType);
    this.tokenChar(93);
  }
  function TSMappedType(node) {
    const {
      nameType: nameType,
      optional: optional,
      readonly: readonly,
      typeAnnotation: typeAnnotation,
    } = node;
    this.tokenChar(123);
    const exit = this.enterDelimited();
    this.space();
    if (readonly) {
      tokenIfPlusMinus(this, readonly);
      this.word('readonly');
      this.space();
    }
    this.tokenChar(91);
    {
      this.word(node.typeParameter.name);
    }
    this.space();
    this.word('in');
    this.space();
    {
      this.print(node.typeParameter.constraint);
    }
    if (nameType) {
      this.space();
      this.word('as');
      this.space();
      this.print(nameType);
    }
    this.tokenChar(93);
    if (optional) {
      tokenIfPlusMinus(this, optional);
      this.tokenChar(63);
    }
    if (typeAnnotation) {
      this.tokenChar(58);
      this.space();
      this.print(typeAnnotation);
    }
    this.space();
    exit();
    this.tokenChar(125);
  }
  function tokenIfPlusMinus(self, tok) {
    if (tok !== true) {
      self.token(tok);
    }
  }
  function TSLiteralType(node) {
    this.print(node.literal);
  }
  function TSClassImplements(node) {
    this.print(node.expression);
    this.print(node.typeParameters);
  }
  function TSInterfaceDeclaration(node) {
    const {
      declare: declare,
      id: id,
      typeParameters: typeParameters,
      extends: extendz,
      body: body,
    } = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    this.word('interface');
    this.space();
    this.print(id);
    this.print(typeParameters);
    if (extendz != null && extendz.length) {
      this.space();
      this.word('extends');
      this.space();
      this.printList(extendz);
    }
    this.space();
    this.print(body);
  }
  function TSInterfaceBody(node) {
    printBraced(this, node, () =>
      this.printJoin(node.body, {indent: true, statement: true})
    );
  }
  function TSTypeAliasDeclaration(node) {
    const {
      declare: declare,
      id: id,
      typeParameters: typeParameters,
      typeAnnotation: typeAnnotation,
    } = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    this.word('type');
    this.space();
    this.print(id);
    this.print(typeParameters);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(typeAnnotation);
    this.semicolon();
  }
  function TSTypeExpression(node) {
    const {
      type: type,
      expression: expression,
      typeAnnotation: typeAnnotation,
    } = node;
    this.print(expression, true);
    this.space();
    this.word(type === 'TSAsExpression' ? 'as' : 'satisfies');
    this.space();
    this.print(typeAnnotation);
  }
  function TSTypeAssertion(node) {
    const {typeAnnotation: typeAnnotation, expression: expression} = node;
    this.tokenChar(60);
    this.print(typeAnnotation);
    this.tokenChar(62);
    this.space();
    this.print(expression);
  }
  function TSInstantiationExpression(node) {
    this.print(node.expression);
    this.print(node.typeParameters);
  }
  function TSEnumDeclaration(node) {
    const {declare: declare, const: isConst, id: id, members: members} = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    if (isConst) {
      this.word('const');
      this.space();
    }
    this.word('enum');
    this.space();
    this.print(id);
    this.space();
    printBraced(this, node, () => {
      var _this$shouldPrintTrai;
      return this.printList(members, {
        indent: true,
        statement: true,
        printTrailingSeparator:
          (_this$shouldPrintTrai = this.shouldPrintTrailingComma('}')) != null
            ? _this$shouldPrintTrai
            : true,
      });
    });
  }
  function TSEnumMember(node) {
    const {id: id, initializer: initializer} = node;
    this.print(id);
    if (initializer) {
      this.space();
      this.tokenChar(61);
      this.space();
      this.print(initializer);
    }
  }
  function TSModuleDeclaration(node) {
    const {declare: declare, id: id, kind: kind} = node;
    if (declare) {
      this.word('declare');
      this.space();
    }
    if (!node.global) {
      this.word(
        kind != null ? kind : id.type === 'Identifier' ? 'namespace' : 'module'
      );
      this.space();
    }
    this.print(id);
    if (!node.body) {
      this.semicolon();
      return;
    }
    let body = node.body;
    while (body.type === 'TSModuleDeclaration') {
      this.tokenChar(46);
      this.print(body.id);
      body = body.body;
    }
    this.space();
    this.print(body);
  }
  function TSModuleBlock(node) {
    printBraced(this, node, () =>
      this.printSequence(node.body, {indent: true})
    );
  }
  function TSImportType(node) {
    const {
      argument: argument,
      qualifier: qualifier,
      typeParameters: typeParameters,
    } = node;
    this.word('import');
    this.tokenChar(40);
    this.print(argument);
    this.tokenChar(41);
    if (qualifier) {
      this.tokenChar(46);
      this.print(qualifier);
    }
    if (typeParameters) {
      this.print(typeParameters);
    }
  }
  function TSImportEqualsDeclaration(node) {
    const {isExport: isExport, id: id, moduleReference: moduleReference} = node;
    if (isExport) {
      this.word('export');
      this.space();
    }
    this.word('import');
    this.space();
    this.print(id);
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(moduleReference);
    this.semicolon();
  }
  function TSExternalModuleReference(node) {
    this.token('require(');
    this.print(node.expression);
    this.tokenChar(41);
  }
  function TSNonNullExpression(node) {
    this.print(node.expression);
    this.tokenChar(33);
  }
  function TSExportAssignment(node) {
    this.word('export');
    this.space();
    this.tokenChar(61);
    this.space();
    this.print(node.expression);
    this.semicolon();
  }
  function TSNamespaceExportDeclaration(node) {
    this.word('export');
    this.space();
    this.word('as');
    this.space();
    this.word('namespace');
    this.space();
    this.print(node.id);
    this.semicolon();
  }
  function tsPrintSignatureDeclarationBase(node) {
    const {typeParameters: typeParameters} = node;
    const parameters = node.parameters;
    this.print(typeParameters);
    this.tokenChar(40);
    this._parameters(parameters, ')');
    const returnType = node.typeAnnotation;
    this.print(returnType);
  }
  function tsPrintClassMemberModifiers(node) {
    const isField =
      node.type === 'ClassAccessorProperty' || node.type === 'ClassProperty';
    printModifiersList(this, node, [
      isField && node.declare && 'declare',
      node.accessibility,
    ]);
    if (node.static) {
      this.word('static');
      this.space();
    }
    printModifiersList(this, node, [
      node.override && 'override',
      node.abstract && 'abstract',
      isField && node.readonly && 'readonly',
    ]);
  }
  function printBraced(printer, node, cb) {
    printer.token('{');
    const exit = printer.enterDelimited();
    cb();
    exit();
    printer.rightBrace(node);
  }
  function printModifiersList(printer, node, modifiers) {
    var _printer$tokenMap2;
    const modifiersSet = new Set();
    for (const modifier of modifiers) {
      if (modifier) modifiersSet.add(modifier);
    }
    (_printer$tokenMap2 = printer.tokenMap) == null ||
      _printer$tokenMap2.find(node, tok => {
        if (modifiersSet.has(tok.value)) {
          printer.token(tok.value);
          printer.space();
          modifiersSet.delete(tok.value);
          return modifiersSet.size === 0;
        }
      });
    for (const modifier of modifiersSet) {
      printer.word(modifier);
      printer.space();
    }
  }
  return typescript$1;
}
var hasRequiredGenerators;
function requireGenerators() {
  if (hasRequiredGenerators) return generators$1;
  hasRequiredGenerators = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    var _templateLiterals = requireTemplateLiterals();
    Object.keys(_templateLiterals).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _templateLiterals[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _templateLiterals[key];
        },
      });
    });
    var _expressions = requireExpressions();
    Object.keys(_expressions).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _expressions[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _expressions[key];
        },
      });
    });
    var _statements = requireStatements();
    Object.keys(_statements).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _statements[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _statements[key];
        },
      });
    });
    var _classes = requireClasses();
    Object.keys(_classes).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _classes[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _classes[key];
        },
      });
    });
    var _methods = requireMethods();
    Object.keys(_methods).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _methods[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _methods[key];
        },
      });
    });
    var _modules = requireModules();
    Object.keys(_modules).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _modules[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _modules[key];
        },
      });
    });
    var _types = requireTypes();
    Object.keys(_types).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _types[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _types[key];
        },
      });
    });
    var _flow = requireFlow();
    Object.keys(_flow).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _flow[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _flow[key];
        },
      });
    });
    var _base = requireBase();
    Object.keys(_base).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _base[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _base[key];
        },
      });
    });
    var _jsx = requireJsx();
    Object.keys(_jsx).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _jsx[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _jsx[key];
        },
      });
    });
    var _typescript = requireTypescript();
    Object.keys(_typescript).forEach(function (key) {
      if (key === 'default' || key === '__esModule') return;
      if (key in exports && exports[key] === _typescript[key]) return;
      Object.defineProperty(exports, key, {
        enumerable: true,
        get: function () {
          return _typescript[key];
        },
      });
    });
  })(generators$1);
  return generators$1;
}
var hasRequiredPrinter;
function requirePrinter() {
  if (hasRequiredPrinter) return printer$2;
  hasRequiredPrinter = 1;
  Object.defineProperty(printer$2, '__esModule', {value: true});
  printer$2.default = void 0;
  var _buffer = requireBuffer();
  var n = requireNode();
  var _t = t$d;
  var _tokenMap = requireTokenMap();
  var generatorFunctions = requireGenerators();
  const {
    isExpression: isExpression,
    isFunction: isFunction,
    isStatement: isStatement,
    isClassBody: isClassBody,
    isTSInterfaceBody: isTSInterfaceBody,
    isTSEnumDeclaration: isTSEnumDeclaration,
  } = _t;
  const SCIENTIFIC_NOTATION = /e/i;
  const ZERO_DECIMAL_INTEGER = /\.0+$/;
  const HAS_NEWLINE = /[\n\r\u2028\u2029]/;
  const HAS_NEWLINE_OR_BlOCK_COMMENT_END = /[\n\r\u2028\u2029]|\*\//;
  function commentIsNewline(c) {
    return c.type === 'CommentLine' || HAS_NEWLINE.test(c.value);
  }
  const {needsParens: needsParens} = n;
  class Printer {
    constructor(format, map, tokens, originalCode) {
      this.inForStatementInit = false;
      this.tokenContext = 0;
      this._tokens = null;
      this._originalCode = null;
      this._currentNode = null;
      this._indent = 0;
      this._indentRepeat = 0;
      this._insideAux = false;
      this._noLineTerminator = false;
      this._noLineTerminatorAfterNode = null;
      this._printAuxAfterOnNextUserNode = false;
      this._printedComments = new Set();
      this._endsWithInteger = false;
      this._endsWithWord = false;
      this._endsWithDiv = false;
      this._lastCommentLine = 0;
      this._endsWithInnerRaw = false;
      this._indentInnerComments = true;
      this.tokenMap = null;
      this._boundGetRawIdentifier = this._getRawIdentifier.bind(this);
      this.format = format;
      this._tokens = tokens;
      this._originalCode = originalCode;
      this._indentRepeat = format.indent.style.length;
      this._inputMap = map == null ? void 0 : map._inputMap;
      this._buf = new _buffer.default(map, format.indent.style[0]);
    }
    enterForStatementInit() {
      if (this.inForStatementInit) return () => {};
      this.inForStatementInit = true;
      return () => {
        this.inForStatementInit = false;
      };
    }
    enterDelimited() {
      const oldInForStatementInit = this.inForStatementInit;
      const oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
      if (
        oldInForStatementInit === false &&
        oldNoLineTerminatorAfterNode === null
      ) {
        return () => {};
      }
      this.inForStatementInit = false;
      this._noLineTerminatorAfterNode = null;
      return () => {
        this.inForStatementInit = oldInForStatementInit;
        this._noLineTerminatorAfterNode = oldNoLineTerminatorAfterNode;
      };
    }
    generate(ast) {
      if (this.format.preserveFormat) {
        this.tokenMap = new _tokenMap.TokenMap(
          ast,
          this._tokens,
          this._originalCode
        );
      }
      this.print(ast);
      this._maybeAddAuxComment();
      return this._buf.get();
    }
    indent() {
      const {format: format} = this;
      if (format.preserveFormat || format.compact || format.concise) {
        return;
      }
      this._indent++;
    }
    dedent() {
      const {format: format} = this;
      if (format.preserveFormat || format.compact || format.concise) {
        return;
      }
      this._indent--;
    }
    semicolon(force = false) {
      this._maybeAddAuxComment();
      if (force) {
        this._appendChar(59);
        this._noLineTerminator = false;
        return;
      }
      if (this.tokenMap) {
        const node = this._currentNode;
        if (node.start != null && node.end != null) {
          if (!this.tokenMap.endMatches(node, ';')) {
            return;
          }
          const indexes = this.tokenMap.getIndexes(this._currentNode);
          this._catchUpTo(this._tokens[indexes[indexes.length - 1]].loc.start);
        }
      }
      this._queue(59);
      this._noLineTerminator = false;
    }
    rightBrace(node) {
      if (this.format.minified) {
        this._buf.removeLastSemicolon();
      }
      this.sourceWithOffset('end', node.loc, -1);
      this.tokenChar(125);
    }
    rightParens(node) {
      this.sourceWithOffset('end', node.loc, -1);
      this.tokenChar(41);
    }
    space(force = false) {
      const {format: format} = this;
      if (format.compact || format.preserveFormat) return;
      if (force) {
        this._space();
      } else if (this._buf.hasContent()) {
        const lastCp = this.getLastChar();
        if (lastCp !== 32 && lastCp !== 10) {
          this._space();
        }
      }
    }
    word(str, noLineTerminatorAfter = false) {
      this.tokenContext = 0;
      this._maybePrintInnerComments(str);
      if (
        this._endsWithWord ||
        (this._endsWithDiv && str.charCodeAt(0) === 47)
      ) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._append(str, false);
      this._endsWithWord = true;
      this._noLineTerminator = noLineTerminatorAfter;
    }
    number(str, number) {
      function isNonDecimalLiteral(str) {
        if (str.length > 2 && str.charCodeAt(0) === 48) {
          const secondChar = str.charCodeAt(1);
          return secondChar === 98 || secondChar === 111 || secondChar === 120;
        }
        return false;
      }
      this.word(str);
      this._endsWithInteger =
        Number.isInteger(number) &&
        !isNonDecimalLiteral(str) &&
        !SCIENTIFIC_NOTATION.test(str) &&
        !ZERO_DECIMAL_INTEGER.test(str) &&
        str.charCodeAt(str.length - 1) !== 46;
    }
    token(str, maybeNewline = false, occurrenceCount = 0) {
      this.tokenContext = 0;
      this._maybePrintInnerComments(str, occurrenceCount);
      const lastChar = this.getLastChar();
      const strFirst = str.charCodeAt(0);
      if (
        (lastChar === 33 && (str === '--' || strFirst === 61)) ||
        (strFirst === 43 && lastChar === 43) ||
        (strFirst === 45 && lastChar === 45) ||
        (strFirst === 46 && this._endsWithInteger)
      ) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._append(str, maybeNewline, occurrenceCount);
      this._noLineTerminator = false;
    }
    tokenChar(char) {
      this.tokenContext = 0;
      this._maybePrintInnerComments(String.fromCharCode(char));
      const lastChar = this.getLastChar();
      if (
        (char === 43 && lastChar === 43) ||
        (char === 45 && lastChar === 45) ||
        (char === 46 && this._endsWithInteger)
      ) {
        this._space();
      }
      this._maybeAddAuxComment();
      this._appendChar(char);
      this._noLineTerminator = false;
    }
    newline(i = 1, force) {
      if (i <= 0) return;
      if (!force) {
        if (this.format.retainLines || this.format.compact) return;
        if (this.format.concise) {
          this.space();
          return;
        }
      }
      if (i > 2) i = 2;
      i -= this._buf.getNewlineCount();
      for (let j = 0; j < i; j++) {
        this._newline();
      }
      return;
    }
    endsWith(char) {
      return this.getLastChar() === char;
    }
    getLastChar() {
      return this._buf.getLastChar();
    }
    endsWithCharAndNewline() {
      return this._buf.endsWithCharAndNewline();
    }
    removeTrailingNewline() {
      this._buf.removeTrailingNewline();
    }
    exactSource(loc, cb) {
      if (!loc) {
        cb();
        return;
      }
      this._catchUp('start', loc);
      this._buf.exactSource(loc, cb);
    }
    source(prop, loc) {
      if (!loc) return;
      this._catchUp(prop, loc);
      this._buf.source(prop, loc);
    }
    sourceWithOffset(prop, loc, columnOffset) {
      if (!loc || this.format.preserveFormat) return;
      this._catchUp(prop, loc);
      this._buf.sourceWithOffset(prop, loc, columnOffset);
    }
    sourceIdentifierName(identifierName, pos) {
      if (!this._buf._canMarkIdName) return;
      const sourcePosition = this._buf._sourcePosition;
      sourcePosition.identifierNamePos = pos;
      sourcePosition.identifierName = identifierName;
    }
    _space() {
      this._queue(32);
    }
    _newline() {
      this._queue(10);
    }
    _append(str, maybeNewline, occurrenceCount = 0) {
      if (this.tokenMap) {
        const token = this.tokenMap.findMatching(
          this._currentNode,
          str,
          occurrenceCount
        );
        if (token) this._catchUpTo(token.loc.start);
      }
      this._maybeIndent(str.charCodeAt(0));
      this._buf.append(str, maybeNewline);
      this._endsWithWord = false;
      this._endsWithInteger = false;
      this._endsWithDiv = false;
    }
    _appendChar(char) {
      if (this.tokenMap) {
        const token = this.tokenMap.findMatching(
          this._currentNode,
          String.fromCharCode(char)
        );
        if (token) this._catchUpTo(token.loc.start);
      }
      this._maybeIndent(char);
      this._buf.appendChar(char);
      this._endsWithWord = false;
      this._endsWithInteger = false;
      this._endsWithDiv = false;
    }
    _queue(char) {
      this._maybeIndent(char);
      this._buf.queue(char);
      this._endsWithWord = false;
      this._endsWithInteger = false;
    }
    _maybeIndent(firstChar) {
      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
        this._buf.queueIndentation(this._getIndent());
      }
    }
    _shouldIndent(firstChar) {
      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
        return true;
      }
    }
    catchUp(line) {
      if (!this.format.retainLines) return;
      const count = line - this._buf.getCurrentLine();
      for (let i = 0; i < count; i++) {
        this._newline();
      }
    }
    _catchUp(prop, loc) {
      const {format: format} = this;
      if (!format.preserveFormat) {
        if (format.retainLines && loc != null && loc[prop]) {
          this.catchUp(loc[prop].line);
        }
        return;
      }
      const pos = loc == null ? void 0 : loc[prop];
      if (pos != null) this._catchUpTo(pos);
    }
    _catchUpTo({line: line, column: column, index: index}) {
      const count = line - this._buf.getCurrentLine();
      if (count > 0 && this._noLineTerminator) {
        return;
      }
      for (let i = 0; i < count; i++) {
        this._newline();
      }
      const spacesCount =
        count > 0 ? column : column - this._buf.getCurrentColumn();
      if (spacesCount > 0) {
        const spaces = this._originalCode
          ? this._originalCode
              .slice(index - spacesCount, index)
              .replace(
                /[^\t\x0B\f \xA0\u1680\u2000-\u200A\u202F\u205F\u3000\uFEFF]/gu,
                ' '
              )
          : ' '.repeat(spacesCount);
        this._append(spaces, false);
      }
    }
    _getIndent() {
      return this._indentRepeat * this._indent;
    }
    printTerminatorless(node) {
      this._noLineTerminator = true;
      this.print(node);
    }
    print(node, noLineTerminatorAfter, trailingCommentsLineOffset) {
      var _node$extra, _node$leadingComments, _node$leadingComments2;
      if (!node) return;
      this._endsWithInnerRaw = false;
      const nodeType = node.type;
      const format = this.format;
      const oldConcise = format.concise;
      if (node._compact) {
        format.concise = true;
      }
      const printMethod = this[nodeType];
      if (printMethod === undefined) {
        throw new ReferenceError(
          `unknown node of type ${JSON.stringify(nodeType)} with constructor ${JSON.stringify(node.constructor.name)}`
        );
      }
      const parent = this._currentNode;
      this._currentNode = node;
      const oldInAux = this._insideAux;
      this._insideAux = node.loc == null;
      this._maybeAddAuxComment(this._insideAux && !oldInAux);
      const parenthesized =
        (_node$extra = node.extra) == null ? void 0 : _node$extra.parenthesized;
      let shouldPrintParens =
        (parenthesized && format.preserveFormat) ||
        (parenthesized &&
          format.retainFunctionParens &&
          nodeType === 'FunctionExpression') ||
        needsParens(
          node,
          parent,
          this.tokenContext,
          this.inForStatementInit,
          format.preserveFormat ? this._boundGetRawIdentifier : undefined
        );
      if (
        !shouldPrintParens &&
        parenthesized &&
        (_node$leadingComments = node.leadingComments) != null &&
        _node$leadingComments.length &&
        node.leadingComments[0].type === 'CommentBlock'
      ) {
        const parentType = parent == null ? void 0 : parent.type;
        switch (parentType) {
          case 'ExpressionStatement':
          case 'VariableDeclarator':
          case 'AssignmentExpression':
          case 'ReturnStatement':
            break;
          case 'CallExpression':
          case 'OptionalCallExpression':
          case 'NewExpression':
            if (parent.callee !== node) break;
          default:
            shouldPrintParens = true;
        }
      }
      let indentParenthesized = false;
      if (
        !shouldPrintParens &&
        this._noLineTerminator &&
        (((_node$leadingComments2 = node.leadingComments) != null &&
          _node$leadingComments2.some(commentIsNewline)) ||
          (this.format.retainLines &&
            node.loc &&
            node.loc.start.line > this._buf.getCurrentLine()))
      ) {
        shouldPrintParens = true;
        indentParenthesized = true;
      }
      let oldNoLineTerminatorAfterNode;
      let oldInForStatementInitWasTrue;
      if (!shouldPrintParens) {
        noLineTerminatorAfter ||
          (noLineTerminatorAfter =
            parent &&
            this._noLineTerminatorAfterNode === parent &&
            n.isLastChild(parent, node));
        if (noLineTerminatorAfter) {
          var _node$trailingComment;
          if (
            (_node$trailingComment = node.trailingComments) != null &&
            _node$trailingComment.some(commentIsNewline)
          ) {
            if (isExpression(node)) shouldPrintParens = true;
          } else {
            oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
            this._noLineTerminatorAfterNode = node;
          }
        }
      }
      if (shouldPrintParens) {
        this.tokenChar(40);
        if (indentParenthesized) this.indent();
        this._endsWithInnerRaw = false;
        if (this.inForStatementInit) {
          oldInForStatementInitWasTrue = true;
          this.inForStatementInit = false;
        }
        oldNoLineTerminatorAfterNode = this._noLineTerminatorAfterNode;
        this._noLineTerminatorAfterNode = null;
      }
      this._lastCommentLine = 0;
      this._printLeadingComments(node, parent);
      const loc =
        nodeType === 'Program' || nodeType === 'File' ? null : node.loc;
      this.exactSource(loc, printMethod.bind(this, node, parent));
      if (shouldPrintParens) {
        this._printTrailingComments(node, parent);
        if (indentParenthesized) {
          this.dedent();
          this.newline();
        }
        this.tokenChar(41);
        this._noLineTerminator = noLineTerminatorAfter;
        if (oldInForStatementInitWasTrue) this.inForStatementInit = true;
      } else if (noLineTerminatorAfter && !this._noLineTerminator) {
        this._noLineTerminator = true;
        this._printTrailingComments(node, parent);
      } else {
        this._printTrailingComments(node, parent, trailingCommentsLineOffset);
      }
      this._currentNode = parent;
      format.concise = oldConcise;
      this._insideAux = oldInAux;
      if (oldNoLineTerminatorAfterNode !== undefined) {
        this._noLineTerminatorAfterNode = oldNoLineTerminatorAfterNode;
      }
      this._endsWithInnerRaw = false;
    }
    _maybeAddAuxComment(enteredPositionlessNode) {
      if (enteredPositionlessNode) this._printAuxBeforeComment();
      if (!this._insideAux) this._printAuxAfterComment();
    }
    _printAuxBeforeComment() {
      if (this._printAuxAfterOnNextUserNode) return;
      this._printAuxAfterOnNextUserNode = true;
      const comment = this.format.auxiliaryCommentBefore;
      if (comment) {
        this._printComment({type: 'CommentBlock', value: comment}, 0);
      }
    }
    _printAuxAfterComment() {
      if (!this._printAuxAfterOnNextUserNode) return;
      this._printAuxAfterOnNextUserNode = false;
      const comment = this.format.auxiliaryCommentAfter;
      if (comment) {
        this._printComment({type: 'CommentBlock', value: comment}, 0);
      }
    }
    getPossibleRaw(node) {
      const extra = node.extra;
      if (
        (extra == null ? void 0 : extra.raw) != null &&
        extra.rawValue != null &&
        node.value === extra.rawValue
      ) {
        return extra.raw;
      }
    }
    printJoin(nodes, opts = {}) {
      if (!(nodes != null && nodes.length)) return;
      let {indent: indent} = opts;
      if (indent == null && this.format.retainLines) {
        var _nodes$0$loc;
        const startLine =
          (_nodes$0$loc = nodes[0].loc) == null
            ? void 0
            : _nodes$0$loc.start.line;
        if (startLine != null && startLine !== this._buf.getCurrentLine()) {
          indent = true;
        }
      }
      if (indent) this.indent();
      const newlineOpts = {addNewlines: opts.addNewlines, nextNodeStartLine: 0};
      const separator = opts.separator ? opts.separator.bind(this) : null;
      const len = nodes.length;
      for (let i = 0; i < len; i++) {
        const node = nodes[i];
        if (!node) continue;
        if (opts.statement) this._printNewline(i === 0, newlineOpts);
        this.print(node, undefined, opts.trailingCommentsLineOffset || 0);
        opts.iterator == null || opts.iterator(node, i);
        if (separator != null) {
          if (i < len - 1) separator(i, false);
          else if (opts.printTrailingSeparator) separator(i, true);
        }
        if (opts.statement) {
          var _node$trailingComment2;
          if (
            !(
              (_node$trailingComment2 = node.trailingComments) != null &&
              _node$trailingComment2.length
            )
          ) {
            this._lastCommentLine = 0;
          }
          if (i + 1 === len) {
            this.newline(1);
          } else {
            var _nextNode$loc;
            const nextNode = nodes[i + 1];
            newlineOpts.nextNodeStartLine =
              ((_nextNode$loc = nextNode.loc) == null
                ? void 0
                : _nextNode$loc.start.line) || 0;
            this._printNewline(true, newlineOpts);
          }
        }
      }
      if (indent) this.dedent();
    }
    printAndIndentOnComments(node) {
      const indent = node.leadingComments && node.leadingComments.length > 0;
      if (indent) this.indent();
      this.print(node);
      if (indent) this.dedent();
    }
    printBlock(parent) {
      const node = parent.body;
      if (node.type !== 'EmptyStatement') {
        this.space();
      }
      this.print(node);
    }
    _printTrailingComments(node, parent, lineOffset) {
      const {innerComments: innerComments, trailingComments: trailingComments} =
        node;
      if (innerComments != null && innerComments.length) {
        this._printComments(2, innerComments, node, parent, lineOffset);
      }
      if (trailingComments != null && trailingComments.length) {
        this._printComments(2, trailingComments, node, parent, lineOffset);
      }
    }
    _printLeadingComments(node, parent) {
      const comments = node.leadingComments;
      if (!(comments != null && comments.length)) return;
      this._printComments(0, comments, node, parent);
    }
    _maybePrintInnerComments(nextTokenStr, nextTokenOccurrenceCount) {
      if (this._endsWithInnerRaw) {
        var _this$tokenMap;
        this.printInnerComments(
          (_this$tokenMap = this.tokenMap) == null
            ? void 0
            : _this$tokenMap.findMatching(
                this._currentNode,
                nextTokenStr,
                nextTokenOccurrenceCount
              )
        );
      }
      this._endsWithInnerRaw = true;
      this._indentInnerComments = true;
    }
    printInnerComments(nextToken) {
      const node = this._currentNode;
      const comments = node.innerComments;
      if (!(comments != null && comments.length)) return;
      const hasSpace = this.endsWith(32);
      const indent = this._indentInnerComments;
      const printedCommentsCount = this._printedComments.size;
      if (indent) this.indent();
      this._printComments(1, comments, node, undefined, undefined, nextToken);
      if (hasSpace && printedCommentsCount !== this._printedComments.size) {
        this.space();
      }
      if (indent) this.dedent();
    }
    noIndentInnerCommentsHere() {
      this._indentInnerComments = false;
    }
    printSequence(nodes, opts = {}) {
      var _opts$indent;
      opts.statement = true;
      (_opts$indent = opts.indent) != null
        ? _opts$indent
        : (opts.indent = false);
      this.printJoin(nodes, opts);
    }
    printList(items, opts = {}) {
      if (opts.separator == null) {
        opts.separator = commaSeparator;
      }
      this.printJoin(items, opts);
    }
    shouldPrintTrailingComma(listEnd) {
      if (!this.tokenMap) return null;
      const listEndIndex = this.tokenMap.findLastIndex(
        this._currentNode,
        token => this.tokenMap.matchesOriginal(token, listEnd)
      );
      if (listEndIndex <= 0) return null;
      return this.tokenMap.matchesOriginal(this._tokens[listEndIndex - 1], ',');
    }
    _printNewline(newLine, opts) {
      const format = this.format;
      if (format.retainLines || format.compact) return;
      if (format.concise) {
        this.space();
        return;
      }
      if (!newLine) {
        return;
      }
      const startLine = opts.nextNodeStartLine;
      const lastCommentLine = this._lastCommentLine;
      if (startLine > 0 && lastCommentLine > 0) {
        const offset = startLine - lastCommentLine;
        if (offset >= 0) {
          this.newline(offset || 1);
          return;
        }
      }
      if (this._buf.hasContent()) {
        this.newline(1);
      }
    }
    _shouldPrintComment(comment, nextToken) {
      if (comment.ignore) return 0;
      if (this._printedComments.has(comment)) return 0;
      if (
        this._noLineTerminator &&
        HAS_NEWLINE_OR_BlOCK_COMMENT_END.test(comment.value)
      ) {
        return 2;
      }
      if (nextToken && this.tokenMap) {
        const commentTok = this.tokenMap.find(
          this._currentNode,
          token => token.value === comment.value
        );
        if (commentTok && commentTok.start > nextToken.start) {
          return 2;
        }
      }
      this._printedComments.add(comment);
      if (!this.format.shouldPrintComment(comment.value)) {
        return 0;
      }
      return 1;
    }
    _printComment(comment, skipNewLines) {
      const noLineTerminator = this._noLineTerminator;
      const isBlockComment = comment.type === 'CommentBlock';
      const printNewLines =
        isBlockComment && skipNewLines !== 1 && !this._noLineTerminator;
      if (printNewLines && this._buf.hasContent() && skipNewLines !== 2) {
        this.newline(1);
      }
      const lastCharCode = this.getLastChar();
      if (lastCharCode !== 91 && lastCharCode !== 123 && lastCharCode !== 40) {
        this.space();
      }
      let val;
      if (isBlockComment) {
        val = `/*${comment.value}*/`;
        if (this.format.indent.adjustMultilineComment) {
          var _comment$loc;
          const offset =
            (_comment$loc = comment.loc) == null
              ? void 0
              : _comment$loc.start.column;
          if (offset) {
            const newlineRegex = new RegExp('\\n\\s{1,' + offset + '}', 'g');
            val = val.replace(newlineRegex, '\n');
          }
          if (this.format.concise) {
            val = val.replace(/\n(?!$)/g, `\n`);
          } else {
            let indentSize = this.format.retainLines
              ? 0
              : this._buf.getCurrentColumn();
            if (this._shouldIndent(47) || this.format.retainLines) {
              indentSize += this._getIndent();
            }
            val = val.replace(/\n(?!$)/g, `\n${' '.repeat(indentSize)}`);
          }
        }
      } else if (!noLineTerminator) {
        val = `//${comment.value}`;
      } else {
        val = `/*${comment.value}*/`;
      }
      if (this._endsWithDiv) this._space();
      this.source('start', comment.loc);
      this._append(val, isBlockComment);
      if (!isBlockComment && !noLineTerminator) {
        this.newline(1, true);
      }
      if (printNewLines && skipNewLines !== 3) {
        this.newline(1);
      }
    }
    _printComments(type, comments, node, parent, lineOffset = 0, nextToken) {
      const nodeLoc = node.loc;
      const len = comments.length;
      let hasLoc = !!nodeLoc;
      const nodeStartLine = hasLoc ? nodeLoc.start.line : 0;
      const nodeEndLine = hasLoc ? nodeLoc.end.line : 0;
      let lastLine = 0;
      let leadingCommentNewline = 0;
      const maybeNewline = this._noLineTerminator
        ? function () {}
        : this.newline.bind(this);
      for (let i = 0; i < len; i++) {
        const comment = comments[i];
        const shouldPrint = this._shouldPrintComment(comment, nextToken);
        if (shouldPrint === 2) {
          hasLoc = false;
          break;
        }
        if (hasLoc && comment.loc && shouldPrint === 1) {
          const commentStartLine = comment.loc.start.line;
          const commentEndLine = comment.loc.end.line;
          if (type === 0) {
            let offset = 0;
            if (i === 0) {
              if (
                this._buf.hasContent() &&
                (comment.type === 'CommentLine' ||
                  commentStartLine !== commentEndLine)
              ) {
                offset = leadingCommentNewline = 1;
              }
            } else {
              offset = commentStartLine - lastLine;
            }
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
            if (i + 1 === len) {
              maybeNewline(
                Math.max(nodeStartLine - lastLine, leadingCommentNewline)
              );
              lastLine = nodeStartLine;
            }
          } else if (type === 1) {
            const offset =
              commentStartLine - (i === 0 ? nodeStartLine : lastLine);
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
            if (i + 1 === len) {
              maybeNewline(Math.min(1, nodeEndLine - lastLine));
              lastLine = nodeEndLine;
            }
          } else {
            const offset =
              commentStartLine -
              (i === 0 ? nodeEndLine - lineOffset : lastLine);
            lastLine = commentEndLine;
            maybeNewline(offset);
            this._printComment(comment, 1);
          }
        } else {
          hasLoc = false;
          if (shouldPrint !== 1) {
            continue;
          }
          if (len === 1) {
            const singleLine = comment.loc
              ? comment.loc.start.line === comment.loc.end.line
              : !HAS_NEWLINE.test(comment.value);
            const shouldSkipNewline =
              singleLine &&
              !isStatement(node) &&
              !isClassBody(parent) &&
              !isTSInterfaceBody(parent) &&
              !isTSEnumDeclaration(parent);
            if (type === 0) {
              this._printComment(
                comment,
                (shouldSkipNewline && node.type !== 'ObjectExpression') ||
                  (singleLine && isFunction(parent, {body: node}))
                  ? 1
                  : 0
              );
            } else if (shouldSkipNewline && type === 2) {
              this._printComment(comment, 1);
            } else {
              this._printComment(comment, 0);
            }
          } else if (
            type === 1 &&
            !(node.type === 'ObjectExpression' && node.properties.length > 1) &&
            node.type !== 'ClassBody' &&
            node.type !== 'TSInterfaceBody'
          ) {
            this._printComment(comment, i === 0 ? 2 : i === len - 1 ? 3 : 0);
          } else {
            this._printComment(comment, 0);
          }
        }
      }
      if (type === 2 && hasLoc && lastLine) {
        this._lastCommentLine = lastLine;
      }
    }
  }
  Object.assign(Printer.prototype, generatorFunctions);
  {
    Printer.prototype.Noop = function Noop() {};
  }
  printer$2.default = Printer;
  function commaSeparator(occurrenceCount, last) {
    this.token(',', false, occurrenceCount);
    if (!last) this.space();
  }
  return printer$2;
}
var hasRequiredLib$a;
function requireLib$a() {
  if (hasRequiredLib$a) return lib$a;
  hasRequiredLib$a = 1;
  Object.defineProperty(lib$a, '__esModule', {value: true});
  lib$a.default = generate;
  var _sourceMap = requireSourceMap$1();
  var _printer = requirePrinter();
  function normalizeOptions(code, opts, ast) {
    if (opts.experimental_preserveFormat) {
      if (typeof code !== 'string') {
        throw new Error(
          '`experimental_preserveFormat` requires the original `code` to be passed to @babel/generator as a string'
        );
      }
      if (!opts.retainLines) {
        throw new Error(
          '`experimental_preserveFormat` requires `retainLines` to be set to `true`'
        );
      }
      if (opts.compact && opts.compact !== 'auto') {
        throw new Error(
          '`experimental_preserveFormat` is not compatible with the `compact` option'
        );
      }
      if (opts.minified) {
        throw new Error(
          '`experimental_preserveFormat` is not compatible with the `minified` option'
        );
      }
      if (opts.jsescOption) {
        throw new Error(
          '`experimental_preserveFormat` is not compatible with the `jsescOption` option'
        );
      }
      if (!Array.isArray(ast.tokens)) {
        throw new Error(
          '`experimental_preserveFormat` requires the AST to have attatched the token of the input code. Make sure to enable the `tokens: true` parser option.'
        );
      }
    }
    const format = {
      auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
      auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
      shouldPrintComment: opts.shouldPrintComment,
      preserveFormat: opts.experimental_preserveFormat,
      retainLines: opts.retainLines,
      retainFunctionParens: opts.retainFunctionParens,
      comments: opts.comments == null || opts.comments,
      compact: opts.compact,
      minified: opts.minified,
      concise: opts.concise,
      indent: {adjustMultilineComment: true, style: '  '},
      jsescOption: Object.assign(
        {quotes: 'double', wrap: true, minimal: false},
        opts.jsescOption
      ),
      topicToken: opts.topicToken,
      importAttributesKeyword: opts.importAttributesKeyword,
    };
    {
      var _opts$recordAndTupleS;
      format.decoratorsBeforeExport = opts.decoratorsBeforeExport;
      format.jsescOption.json = opts.jsonCompatibleStrings;
      format.recordAndTupleSyntaxType =
        (_opts$recordAndTupleS = opts.recordAndTupleSyntaxType) != null
          ? _opts$recordAndTupleS
          : 'hash';
    }
    if (format.minified) {
      format.compact = true;
      format.shouldPrintComment =
        format.shouldPrintComment || (() => format.comments);
    } else {
      format.shouldPrintComment =
        format.shouldPrintComment ||
        (value =>
          format.comments ||
          value.includes('@license') ||
          value.includes('@preserve'));
    }
    if (format.compact === 'auto') {
      format.compact = typeof code === 'string' && code.length > 5e5;
      if (format.compact) {
        console.error(
          '[BABEL] Note: The code generator has deoptimised the styling of ' +
            `${opts.filename} as it exceeds the max of ${'500KB'}.`
        );
      }
    }
    if (format.compact || format.preserveFormat) {
      format.indent.adjustMultilineComment = false;
    }
    const {
      auxiliaryCommentBefore: auxiliaryCommentBefore,
      auxiliaryCommentAfter: auxiliaryCommentAfter,
      shouldPrintComment: shouldPrintComment,
    } = format;
    if (auxiliaryCommentBefore && !shouldPrintComment(auxiliaryCommentBefore)) {
      format.auxiliaryCommentBefore = undefined;
    }
    if (auxiliaryCommentAfter && !shouldPrintComment(auxiliaryCommentAfter)) {
      format.auxiliaryCommentAfter = undefined;
    }
    return format;
  }
  {
    lib$a.CodeGenerator = class CodeGenerator {
      constructor(ast, opts = {}, code) {
        this._ast = void 0;
        this._format = void 0;
        this._map = void 0;
        this._ast = ast;
        this._format = normalizeOptions(code, opts, ast);
        this._map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
      }
      generate() {
        const printer = new _printer.default(this._format, this._map);
        return printer.generate(this._ast);
      }
    };
  }
  function generate(ast, opts = {}, code) {
    const format = normalizeOptions(code, opts, ast);
    const map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
    const printer = new _printer.default(
      format,
      map,
      ast.tokens,
      typeof code === 'string' ? code : null
    );
    return printer.generate(ast);
  }
  return lib$a;
}
var ancestry = {};
var hasRequiredAncestry;
function requireAncestry() {
  if (hasRequiredAncestry) return ancestry;
  hasRequiredAncestry = 1;
  Object.defineProperty(ancestry, '__esModule', {value: true});
  ancestry.findParent = findParent;
  ancestry.find = find;
  ancestry.getFunctionParent = getFunctionParent;
  ancestry.getStatementParent = getStatementParent;
  ancestry.getEarliestCommonAncestorFrom = getEarliestCommonAncestorFrom;
  ancestry.getDeepestCommonAncestorFrom = getDeepestCommonAncestorFrom;
  ancestry.getAncestry = getAncestry;
  ancestry.isAncestor = isAncestor;
  ancestry.isDescendant = isDescendant;
  ancestry.inType = inType;
  var t = _interopRequireWildcard(t$d);
  _interopRequireDefault(requirePath());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function findParent(callback) {
    let path = this;
    while ((path = path.parentPath)) {
      if (callback(path)) return path;
    }
    return null;
  }
  function find(callback) {
    let path = this;
    do {
      if (callback(path)) return path;
    } while ((path = path.parentPath));
    return null;
  }
  function getFunctionParent() {
    return this.findParent(p => p.isFunction());
  }
  function getStatementParent() {
    let path = this;
    do {
      if (
        !path.parentPath ||
        (Array.isArray(path.container) && path.isStatement())
      ) {
        break;
      } else {
        path = path.parentPath;
      }
    } while (path);
    if (path && (path.isProgram() || path.isFile())) {
      throw new Error(
        "File/Program node, we can't possibly find a statement parent to this"
      );
    }
    return path;
  }
  function getEarliestCommonAncestorFrom(paths) {
    return this.getDeepestCommonAncestorFrom(
      paths,
      function (deepest, i, ancestries) {
        let earliest;
        const keys = t.VISITOR_KEYS[deepest.type];
        for (const ancestry of ancestries) {
          const path = ancestry[i + 1];
          if (!earliest) {
            earliest = path;
            continue;
          }
          if (path.listKey && earliest.listKey === path.listKey) {
            if (path.key < earliest.key) {
              earliest = path;
              continue;
            }
          }
          const earliestKeyIndex = keys.indexOf(earliest.parentKey);
          const currentKeyIndex = keys.indexOf(path.parentKey);
          if (earliestKeyIndex > currentKeyIndex) {
            earliest = path;
          }
        }
        return earliest;
      }
    );
  }
  function getDeepestCommonAncestorFrom(paths, filter) {
    if (!paths.length) {
      return this;
    }
    if (paths.length === 1) {
      return paths[0];
    }
    let minDepth = Infinity;
    let lastCommonIndex, lastCommon;
    const ancestries = paths.map(path => {
      const ancestry = [];
      do {
        ancestry.unshift(path);
      } while ((path = path.parentPath) && path !== this);
      if (ancestry.length < minDepth) {
        minDepth = ancestry.length;
      }
      return ancestry;
    });
    const first = ancestries[0];
    depthLoop: for (let i = 0; i < minDepth; i++) {
      const shouldMatch = first[i];
      for (const ancestry of ancestries) {
        if (ancestry[i] !== shouldMatch) {
          break depthLoop;
        }
      }
      lastCommonIndex = i;
      lastCommon = shouldMatch;
    }
    if (lastCommon) {
      if (filter) {
        return filter(lastCommon, lastCommonIndex, ancestries);
      } else {
        return lastCommon;
      }
    } else {
      throw new Error("Couldn't find intersection");
    }
  }
  function getAncestry() {
    let path = this;
    const paths = [];
    do {
      paths.push(path);
    } while ((path = path.parentPath));
    return paths;
  }
  function isAncestor(maybeDescendant) {
    return maybeDescendant.isDescendant(this);
  }
  function isDescendant(maybeAncestor) {
    return !!this.findParent(parent => parent === maybeAncestor);
  }
  function inType() {
    let path = this;
    while (path) {
      for (const type of arguments) {
        if (path.node.type === type) return true;
      }
      path = path.parentPath;
    }
    return false;
  }
  return ancestry;
}
var inference = {};
var inferers = {};
var infererReference = {};
var hasRequiredInfererReference;
function requireInfererReference() {
  if (hasRequiredInfererReference) return infererReference;
  hasRequiredInfererReference = 1;
  Object.defineProperty(infererReference, '__esModule', {value: true});
  infererReference.default = _default;
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _default(node) {
    if (!this.isReferenced()) return;
    const binding = this.scope.getBinding(node.name);
    if (binding) {
      if (binding.identifier.typeAnnotation) {
        return binding.identifier.typeAnnotation;
      } else {
        return getTypeAnnotationBindingConstantViolations(
          binding,
          this,
          node.name
        );
      }
    }
    if (node.name === 'undefined') {
      return t.voidTypeAnnotation();
    } else if (node.name === 'NaN' || node.name === 'Infinity') {
      return t.numberTypeAnnotation();
    } else if (node.name === 'arguments');
  }
  function getTypeAnnotationBindingConstantViolations(binding, path, name) {
    const types = [];
    const functionConstantViolations = [];
    let constantViolations = getConstantViolationsBefore(
      binding,
      path,
      functionConstantViolations
    );
    const testType = getConditionalAnnotation(binding, path, name);
    if (testType) {
      const testConstantViolations = getConstantViolationsBefore(
        binding,
        testType.ifStatement
      );
      constantViolations = constantViolations.filter(
        path => testConstantViolations.indexOf(path) < 0
      );
      types.push(testType.typeAnnotation);
    }
    if (constantViolations.length) {
      constantViolations = constantViolations.concat(
        functionConstantViolations
      );
      for (const violation of constantViolations) {
        types.push(violation.getTypeAnnotation());
      }
    }
    if (types.length) {
      return t.createUnionTypeAnnotation(types);
    }
  }
  function getConstantViolationsBefore(binding, path, functions) {
    const violations = binding.constantViolations.slice();
    violations.unshift(binding.path);
    return violations.filter(violation => {
      violation = violation.resolve();
      const status = violation._guessExecutionStatusRelativeTo(path);
      if (functions && status === 'unknown') functions.push(violation);
      return status === 'before';
    });
  }
  function inferAnnotationFromBinaryExpression(name, path) {
    const operator = path.node.operator;
    const right = path.get('right').resolve();
    const left = path.get('left').resolve();
    let target;
    if (left.isIdentifier({name: name})) {
      target = right;
    } else if (right.isIdentifier({name: name})) {
      target = left;
    }
    if (target) {
      if (operator === '===') {
        return target.getTypeAnnotation();
      }
      if (t.BOOLEAN_NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
        return t.numberTypeAnnotation();
      }
      return;
    }
    if (operator !== '===' && operator !== '==') return;
    let typeofPath;
    let typePath;
    if (left.isUnaryExpression({operator: 'typeof'})) {
      typeofPath = left;
      typePath = right;
    } else if (right.isUnaryExpression({operator: 'typeof'})) {
      typeofPath = right;
      typePath = left;
    }
    if (!typeofPath) return;
    if (!typeofPath.get('argument').isIdentifier({name: name})) return;
    typePath = typePath.resolve();
    if (!typePath.isLiteral()) return;
    const typeValue = typePath.node.value;
    if (typeof typeValue !== 'string') return;
    return t.createTypeAnnotationBasedOnTypeof(typeValue);
  }
  function getParentConditionalPath(binding, path, name) {
    let parentPath;
    while ((parentPath = path.parentPath)) {
      if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
        if (path.key === 'test') {
          return;
        }
        return parentPath;
      }
      if (parentPath.isFunction()) {
        if (parentPath.parentPath.scope.getBinding(name) !== binding) return;
      }
      path = parentPath;
    }
  }
  function getConditionalAnnotation(binding, path, name) {
    const ifStatement = getParentConditionalPath(binding, path, name);
    if (!ifStatement) return;
    const test = ifStatement.get('test');
    const paths = [test];
    const types = [];
    for (let i = 0; i < paths.length; i++) {
      const path = paths[i];
      if (path.isLogicalExpression()) {
        if (path.node.operator === '&&') {
          paths.push(path.get('left'));
          paths.push(path.get('right'));
        }
      } else if (path.isBinaryExpression()) {
        const type = inferAnnotationFromBinaryExpression(name, path);
        if (type) types.push(type);
      }
    }
    if (types.length) {
      return {
        typeAnnotation: t.createUnionTypeAnnotation(types),
        ifStatement: ifStatement,
      };
    }
    return getConditionalAnnotation(ifStatement, name);
  }
  return infererReference;
}
var hasRequiredInferers;
function requireInferers() {
  if (hasRequiredInferers) return inferers;
  hasRequiredInferers = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.VariableDeclarator = VariableDeclarator;
    exports.TypeCastExpression = TypeCastExpression;
    exports.NewExpression = NewExpression;
    exports.TemplateLiteral = TemplateLiteral;
    exports.UnaryExpression = UnaryExpression;
    exports.BinaryExpression = BinaryExpression;
    exports.LogicalExpression = LogicalExpression;
    exports.ConditionalExpression = ConditionalExpression;
    exports.SequenceExpression = SequenceExpression;
    exports.ParenthesizedExpression = ParenthesizedExpression;
    exports.AssignmentExpression = AssignmentExpression;
    exports.UpdateExpression = UpdateExpression;
    exports.StringLiteral = StringLiteral;
    exports.NumericLiteral = NumericLiteral;
    exports.BooleanLiteral = BooleanLiteral;
    exports.NullLiteral = NullLiteral;
    exports.RegExpLiteral = RegExpLiteral;
    exports.ObjectExpression = ObjectExpression;
    exports.ArrayExpression = ArrayExpression;
    exports.RestElement = RestElement;
    exports.ClassDeclaration =
      exports.ClassExpression =
      exports.FunctionDeclaration =
      exports.ArrowFunctionExpression =
      exports.FunctionExpression =
        Func;
    exports.CallExpression = CallExpression;
    exports.TaggedTemplateExpression = TaggedTemplateExpression;
    Object.defineProperty(exports, 'Identifier', {
      enumerable: true,
      get: function () {
        return _infererReference.default;
      },
    });
    var t = _interopRequireWildcard(t$d);
    var _infererReference = _interopRequireDefault(requireInfererReference());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {default: obj};
    }
    function _getRequireWildcardCache() {
      if (typeof WeakMap !== 'function') return null;
      var cache = new WeakMap();
      _getRequireWildcardCache = function () {
        return cache;
      };
      return cache;
    }
    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }
      if (
        obj === null ||
        (typeof obj !== 'object' && typeof obj !== 'function')
      ) {
        return {default: obj};
      }
      var cache = _getRequireWildcardCache();
      if (cache && cache.has(obj)) {
        return cache.get(obj);
      }
      var newObj = {};
      var hasPropertyDescriptor =
        Object.defineProperty && Object.getOwnPropertyDescriptor;
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor
            ? Object.getOwnPropertyDescriptor(obj, key)
            : null;
          if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
      newObj.default = obj;
      if (cache) {
        cache.set(obj, newObj);
      }
      return newObj;
    }
    function VariableDeclarator() {
      const id = this.get('id');
      if (!id.isIdentifier()) return;
      const init = this.get('init');
      let type = init.getTypeAnnotation();
      if (type && type.type === 'AnyTypeAnnotation') {
        if (
          init.isCallExpression() &&
          init.get('callee').isIdentifier({name: 'Array'}) &&
          !init.scope.hasBinding('Array', true)
        ) {
          type = ArrayExpression();
        }
      }
      return type;
    }
    function TypeCastExpression(node) {
      return node.typeAnnotation;
    }
    TypeCastExpression.validParent = true;
    function NewExpression(node) {
      if (this.get('callee').isIdentifier()) {
        return t.genericTypeAnnotation(node.callee);
      }
    }
    function TemplateLiteral() {
      return t.stringTypeAnnotation();
    }
    function UnaryExpression(node) {
      const operator = node.operator;
      if (operator === 'void') {
        return t.voidTypeAnnotation();
      } else if (t.NUMBER_UNARY_OPERATORS.indexOf(operator) >= 0) {
        return t.numberTypeAnnotation();
      } else if (t.STRING_UNARY_OPERATORS.indexOf(operator) >= 0) {
        return t.stringTypeAnnotation();
      } else if (t.BOOLEAN_UNARY_OPERATORS.indexOf(operator) >= 0) {
        return t.booleanTypeAnnotation();
      }
    }
    function BinaryExpression(node) {
      const operator = node.operator;
      if (t.NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
        return t.numberTypeAnnotation();
      } else if (t.BOOLEAN_BINARY_OPERATORS.indexOf(operator) >= 0) {
        return t.booleanTypeAnnotation();
      } else if (operator === '+') {
        const right = this.get('right');
        const left = this.get('left');
        if (left.isBaseType('number') && right.isBaseType('number')) {
          return t.numberTypeAnnotation();
        } else if (left.isBaseType('string') || right.isBaseType('string')) {
          return t.stringTypeAnnotation();
        }
        return t.unionTypeAnnotation([
          t.stringTypeAnnotation(),
          t.numberTypeAnnotation(),
        ]);
      }
    }
    function LogicalExpression() {
      return t.createUnionTypeAnnotation([
        this.get('left').getTypeAnnotation(),
        this.get('right').getTypeAnnotation(),
      ]);
    }
    function ConditionalExpression() {
      return t.createUnionTypeAnnotation([
        this.get('consequent').getTypeAnnotation(),
        this.get('alternate').getTypeAnnotation(),
      ]);
    }
    function SequenceExpression() {
      return this.get('expressions').pop().getTypeAnnotation();
    }
    function ParenthesizedExpression() {
      return this.get('expression').getTypeAnnotation();
    }
    function AssignmentExpression() {
      return this.get('right').getTypeAnnotation();
    }
    function UpdateExpression(node) {
      const operator = node.operator;
      if (operator === '++' || operator === '--') {
        return t.numberTypeAnnotation();
      }
    }
    function StringLiteral() {
      return t.stringTypeAnnotation();
    }
    function NumericLiteral() {
      return t.numberTypeAnnotation();
    }
    function BooleanLiteral() {
      return t.booleanTypeAnnotation();
    }
    function NullLiteral() {
      return t.nullLiteralTypeAnnotation();
    }
    function RegExpLiteral() {
      return t.genericTypeAnnotation(t.identifier('RegExp'));
    }
    function ObjectExpression() {
      return t.genericTypeAnnotation(t.identifier('Object'));
    }
    function ArrayExpression() {
      return t.genericTypeAnnotation(t.identifier('Array'));
    }
    function RestElement() {
      return ArrayExpression();
    }
    RestElement.validParent = true;
    function Func() {
      return t.genericTypeAnnotation(t.identifier('Function'));
    }
    const isArrayFrom = t.buildMatchMemberExpression('Array.from');
    const isObjectKeys = t.buildMatchMemberExpression('Object.keys');
    const isObjectValues = t.buildMatchMemberExpression('Object.values');
    const isObjectEntries = t.buildMatchMemberExpression('Object.entries');
    function CallExpression() {
      const {callee: callee} = this.node;
      if (isObjectKeys(callee)) {
        return t.arrayTypeAnnotation(t.stringTypeAnnotation());
      } else if (isArrayFrom(callee) || isObjectValues(callee)) {
        return t.arrayTypeAnnotation(t.anyTypeAnnotation());
      } else if (isObjectEntries(callee)) {
        return t.arrayTypeAnnotation(
          t.tupleTypeAnnotation([
            t.stringTypeAnnotation(),
            t.anyTypeAnnotation(),
          ])
        );
      }
      return resolveCall(this.get('callee'));
    }
    function TaggedTemplateExpression() {
      return resolveCall(this.get('tag'));
    }
    function resolveCall(callee) {
      callee = callee.resolve();
      if (callee.isFunction()) {
        if (callee.is('async')) {
          if (callee.is('generator')) {
            return t.genericTypeAnnotation(t.identifier('AsyncIterator'));
          } else {
            return t.genericTypeAnnotation(t.identifier('Promise'));
          }
        } else {
          if (callee.node.returnType) {
            return callee.node.returnType;
          }
        }
      }
    }
  })(inferers);
  return inferers;
}
var hasRequiredInference;
function requireInference() {
  if (hasRequiredInference) return inference;
  hasRequiredInference = 1;
  Object.defineProperty(inference, '__esModule', {value: true});
  inference.getTypeAnnotation = getTypeAnnotation;
  inference._getTypeAnnotation = _getTypeAnnotation;
  inference.isBaseType = isBaseType;
  inference.couldBeBaseType = couldBeBaseType;
  inference.baseTypeStrictlyMatches = baseTypeStrictlyMatches;
  inference.isGenericType = isGenericType;
  var inferers = _interopRequireWildcard(requireInferers());
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function getTypeAnnotation() {
    if (this.typeAnnotation) return this.typeAnnotation;
    let type = this._getTypeAnnotation() || t.anyTypeAnnotation();
    if (t.isTypeAnnotation(type)) type = type.typeAnnotation;
    return (this.typeAnnotation = type);
  }
  function _getTypeAnnotation() {
    const node = this.node;
    if (!node) {
      if (this.key === 'init' && this.parentPath.isVariableDeclarator()) {
        const declar = this.parentPath.parentPath;
        const declarParent = declar.parentPath;
        if (declar.key === 'left' && declarParent.isForInStatement()) {
          return t.stringTypeAnnotation();
        }
        if (declar.key === 'left' && declarParent.isForOfStatement()) {
          return t.anyTypeAnnotation();
        }
        return t.voidTypeAnnotation();
      } else {
        return;
      }
    }
    if (node.typeAnnotation) {
      return node.typeAnnotation;
    }
    let inferer = inferers[node.type];
    if (inferer) {
      return inferer.call(this, node);
    }
    inferer = inferers[this.parentPath.type];
    if (inferer && inferer.validParent) {
      return this.parentPath.getTypeAnnotation();
    }
  }
  function isBaseType(baseName, soft) {
    return _isBaseType(baseName, this.getTypeAnnotation(), soft);
  }
  function _isBaseType(baseName, type, soft) {
    if (baseName === 'string') {
      return t.isStringTypeAnnotation(type);
    } else if (baseName === 'number') {
      return t.isNumberTypeAnnotation(type);
    } else if (baseName === 'boolean') {
      return t.isBooleanTypeAnnotation(type);
    } else if (baseName === 'any') {
      return t.isAnyTypeAnnotation(type);
    } else if (baseName === 'mixed') {
      return t.isMixedTypeAnnotation(type);
    } else if (baseName === 'empty') {
      return t.isEmptyTypeAnnotation(type);
    } else if (baseName === 'void') {
      return t.isVoidTypeAnnotation(type);
    } else {
      if (soft) {
        return false;
      } else {
        throw new Error(`Unknown base type ${baseName}`);
      }
    }
  }
  function couldBeBaseType(name) {
    const type = this.getTypeAnnotation();
    if (t.isAnyTypeAnnotation(type)) return true;
    if (t.isUnionTypeAnnotation(type)) {
      for (const type2 of type.types) {
        if (t.isAnyTypeAnnotation(type2) || _isBaseType(name, type2, true)) {
          return true;
        }
      }
      return false;
    } else {
      return _isBaseType(name, type, true);
    }
  }
  function baseTypeStrictlyMatches(right) {
    const left = this.getTypeAnnotation();
    right = right.getTypeAnnotation();
    if (!t.isAnyTypeAnnotation(left) && t.isFlowBaseAnnotation(left)) {
      return right.type === left.type;
    }
  }
  function isGenericType(genericName) {
    const type = this.getTypeAnnotation();
    return (
      t.isGenericTypeAnnotation(type) &&
      t.isIdentifier(type.id, {name: genericName})
    );
  }
  return inference;
}
var replacement = {};
var lib$9 = {};
var lib$8 = {};
var lib$7 = {};
var identifier = {};
var hasRequiredIdentifier;
function requireIdentifier() {
  if (hasRequiredIdentifier) return identifier;
  hasRequiredIdentifier = 1;
  Object.defineProperty(identifier, '__esModule', {value: true});
  identifier.isIdentifierChar = isIdentifierChar;
  identifier.isIdentifierName = isIdentifierName;
  identifier.isIdentifierStart = isIdentifierStart;
  let nonASCIIidentifierStartChars =
    'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
  let nonASCIIidentifierChars =
    '‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･';
  const nonASCIIidentifierStart = new RegExp(
    '[' + nonASCIIidentifierStartChars + ']'
  );
  const nonASCIIidentifier = new RegExp(
    '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
  );
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  const astralIdentifierStartCodes = [
    0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48,
    48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5,
    39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10,
    21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11,
    22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2,
    2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72,
    56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20,
    28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4,
    0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2,
    14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4,
    159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0,
    60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2,
    23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12,
    45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0,
    26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921,
    103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30,
    18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67,
    12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16,
    0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2,
    70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2,
    27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2,
    24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11,
    6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60,
    67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5,
    0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0,
    3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719,
    33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6,
    4191,
  ];
  const astralIdentifierCodes = [
    509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1,
    574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1,
    11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13,
    9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3,
    2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3,
    8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5,
    2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0,
    10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2,
    6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4,
    14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54,
    8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31,
    3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2,
    16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983,
    6, 110, 6, 6, 9, 4759, 9, 787719, 239,
  ];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length; i < length; i += 2) {
      pos += set[i];
      if (pos > code) return false;
      pos += set[i + 1];
      if (pos >= code) return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65) return code === 36;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return (
        code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
      );
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48) return code === 36;
    if (code < 58) return true;
    if (code < 65) return false;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return (
      isInAstralSet(code, astralIdentifierStartCodes) ||
      isInAstralSet(code, astralIdentifierCodes)
    );
  }
  function isIdentifierName(name) {
    let isFirst = true;
    for (let i = 0; i < name.length; i++) {
      let cp = name.charCodeAt(i);
      if ((cp & 64512) === 55296 && i + 1 < name.length) {
        const trail = name.charCodeAt(++i);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      if (isFirst) {
        isFirst = false;
        if (!isIdentifierStart(cp)) {
          return false;
        }
      } else if (!isIdentifierChar(cp)) {
        return false;
      }
    }
    return !isFirst;
  }
  return identifier;
}
var keyword = {};
var hasRequiredKeyword;
function requireKeyword() {
  if (hasRequiredKeyword) return keyword;
  hasRequiredKeyword = 1;
  Object.defineProperty(keyword, '__esModule', {value: true});
  keyword.isKeyword = isKeyword;
  keyword.isReservedWord = isReservedWord;
  keyword.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
  keyword.isStrictBindReservedWord = isStrictBindReservedWord;
  keyword.isStrictReservedWord = isStrictReservedWord;
  const reservedWords = {
    keyword: [
      'break',
      'case',
      'catch',
      'continue',
      'debugger',
      'default',
      'do',
      'else',
      'finally',
      'for',
      'function',
      'if',
      'return',
      'switch',
      'throw',
      'try',
      'var',
      'const',
      'while',
      'with',
      'new',
      'this',
      'super',
      'class',
      'extends',
      'export',
      'import',
      'null',
      'true',
      'false',
      'in',
      'instanceof',
      'typeof',
      'void',
      'delete',
    ],
    strict: [
      'implements',
      'interface',
      'let',
      'package',
      'private',
      'protected',
      'public',
      'static',
      'yield',
    ],
    strictBind: ['eval', 'arguments'],
  };
  const keywords = new Set(reservedWords.keyword);
  const reservedWordsStrictSet = new Set(reservedWords.strict);
  const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return (inModule && word === 'await') || word === 'enum';
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return (
      isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
    );
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  return keyword;
}
var hasRequiredLib$9;
function requireLib$9() {
  if (hasRequiredLib$9) return lib$7;
  hasRequiredLib$9 = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    Object.defineProperty(exports, 'isIdentifierChar', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierChar;
      },
    });
    Object.defineProperty(exports, 'isIdentifierName', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierName;
      },
    });
    Object.defineProperty(exports, 'isIdentifierStart', {
      enumerable: true,
      get: function () {
        return _identifier.isIdentifierStart;
      },
    });
    Object.defineProperty(exports, 'isKeyword', {
      enumerable: true,
      get: function () {
        return _keyword.isKeyword;
      },
    });
    Object.defineProperty(exports, 'isReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictBindOnlyReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictBindOnlyReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictBindReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictBindReservedWord;
      },
    });
    Object.defineProperty(exports, 'isStrictReservedWord', {
      enumerable: true,
      get: function () {
        return _keyword.isStrictReservedWord;
      },
    });
    var _identifier = requireIdentifier();
    var _keyword = requireKeyword();
  })(lib$7);
  return lib$7;
}
var chalk$1 = {exports: {}};
var escapeStringRegexp;
var hasRequiredEscapeStringRegexp;
function requireEscapeStringRegexp() {
  if (hasRequiredEscapeStringRegexp) return escapeStringRegexp;
  hasRequiredEscapeStringRegexp = 1;
  var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
  escapeStringRegexp = function (str) {
    if (typeof str !== 'string') {
      throw new TypeError('Expected a string');
    }
    return str.replace(matchOperatorsRe, '\\$&');
  };
  return escapeStringRegexp;
}
var ansiStyles$2 = {exports: {}};
var conversions$3 = {exports: {}};
var colorName$1 = {
  aliceblue: [240, 248, 255],
  antiquewhite: [250, 235, 215],
  aqua: [0, 255, 255],
  aquamarine: [127, 255, 212],
  azure: [240, 255, 255],
  beige: [245, 245, 220],
  bisque: [255, 228, 196],
  black: [0, 0, 0],
  blanchedalmond: [255, 235, 205],
  blue: [0, 0, 255],
  blueviolet: [138, 43, 226],
  brown: [165, 42, 42],
  burlywood: [222, 184, 135],
  cadetblue: [95, 158, 160],
  chartreuse: [127, 255, 0],
  chocolate: [210, 105, 30],
  coral: [255, 127, 80],
  cornflowerblue: [100, 149, 237],
  cornsilk: [255, 248, 220],
  crimson: [220, 20, 60],
  cyan: [0, 255, 255],
  darkblue: [0, 0, 139],
  darkcyan: [0, 139, 139],
  darkgoldenrod: [184, 134, 11],
  darkgray: [169, 169, 169],
  darkgreen: [0, 100, 0],
  darkgrey: [169, 169, 169],
  darkkhaki: [189, 183, 107],
  darkmagenta: [139, 0, 139],
  darkolivegreen: [85, 107, 47],
  darkorange: [255, 140, 0],
  darkorchid: [153, 50, 204],
  darkred: [139, 0, 0],
  darksalmon: [233, 150, 122],
  darkseagreen: [143, 188, 143],
  darkslateblue: [72, 61, 139],
  darkslategray: [47, 79, 79],
  darkslategrey: [47, 79, 79],
  darkturquoise: [0, 206, 209],
  darkviolet: [148, 0, 211],
  deeppink: [255, 20, 147],
  deepskyblue: [0, 191, 255],
  dimgray: [105, 105, 105],
  dimgrey: [105, 105, 105],
  dodgerblue: [30, 144, 255],
  firebrick: [178, 34, 34],
  floralwhite: [255, 250, 240],
  forestgreen: [34, 139, 34],
  fuchsia: [255, 0, 255],
  gainsboro: [220, 220, 220],
  ghostwhite: [248, 248, 255],
  gold: [255, 215, 0],
  goldenrod: [218, 165, 32],
  gray: [128, 128, 128],
  green: [0, 128, 0],
  greenyellow: [173, 255, 47],
  grey: [128, 128, 128],
  honeydew: [240, 255, 240],
  hotpink: [255, 105, 180],
  indianred: [205, 92, 92],
  indigo: [75, 0, 130],
  ivory: [255, 255, 240],
  khaki: [240, 230, 140],
  lavender: [230, 230, 250],
  lavenderblush: [255, 240, 245],
  lawngreen: [124, 252, 0],
  lemonchiffon: [255, 250, 205],
  lightblue: [173, 216, 230],
  lightcoral: [240, 128, 128],
  lightcyan: [224, 255, 255],
  lightgoldenrodyellow: [250, 250, 210],
  lightgray: [211, 211, 211],
  lightgreen: [144, 238, 144],
  lightgrey: [211, 211, 211],
  lightpink: [255, 182, 193],
  lightsalmon: [255, 160, 122],
  lightseagreen: [32, 178, 170],
  lightskyblue: [135, 206, 250],
  lightslategray: [119, 136, 153],
  lightslategrey: [119, 136, 153],
  lightsteelblue: [176, 196, 222],
  lightyellow: [255, 255, 224],
  lime: [0, 255, 0],
  limegreen: [50, 205, 50],
  linen: [250, 240, 230],
  magenta: [255, 0, 255],
  maroon: [128, 0, 0],
  mediumaquamarine: [102, 205, 170],
  mediumblue: [0, 0, 205],
  mediumorchid: [186, 85, 211],
  mediumpurple: [147, 112, 219],
  mediumseagreen: [60, 179, 113],
  mediumslateblue: [123, 104, 238],
  mediumspringgreen: [0, 250, 154],
  mediumturquoise: [72, 209, 204],
  mediumvioletred: [199, 21, 133],
  midnightblue: [25, 25, 112],
  mintcream: [245, 255, 250],
  mistyrose: [255, 228, 225],
  moccasin: [255, 228, 181],
  navajowhite: [255, 222, 173],
  navy: [0, 0, 128],
  oldlace: [253, 245, 230],
  olive: [128, 128, 0],
  olivedrab: [107, 142, 35],
  orange: [255, 165, 0],
  orangered: [255, 69, 0],
  orchid: [218, 112, 214],
  palegoldenrod: [238, 232, 170],
  palegreen: [152, 251, 152],
  paleturquoise: [175, 238, 238],
  palevioletred: [219, 112, 147],
  papayawhip: [255, 239, 213],
  peachpuff: [255, 218, 185],
  peru: [205, 133, 63],
  pink: [255, 192, 203],
  plum: [221, 160, 221],
  powderblue: [176, 224, 230],
  purple: [128, 0, 128],
  rebeccapurple: [102, 51, 153],
  red: [255, 0, 0],
  rosybrown: [188, 143, 143],
  royalblue: [65, 105, 225],
  saddlebrown: [139, 69, 19],
  salmon: [250, 128, 114],
  sandybrown: [244, 164, 96],
  seagreen: [46, 139, 87],
  seashell: [255, 245, 238],
  sienna: [160, 82, 45],
  silver: [192, 192, 192],
  skyblue: [135, 206, 235],
  slateblue: [106, 90, 205],
  slategray: [112, 128, 144],
  slategrey: [112, 128, 144],
  snow: [255, 250, 250],
  springgreen: [0, 255, 127],
  steelblue: [70, 130, 180],
  tan: [210, 180, 140],
  teal: [0, 128, 128],
  thistle: [216, 191, 216],
  tomato: [255, 99, 71],
  turquoise: [64, 224, 208],
  violet: [238, 130, 238],
  wheat: [245, 222, 179],
  white: [255, 255, 255],
  whitesmoke: [245, 245, 245],
  yellow: [255, 255, 0],
  yellowgreen: [154, 205, 50],
};
var cssKeywords = colorName$1;
var reverseKeywords = {};
for (var key$1 in cssKeywords) {
  if (cssKeywords.hasOwnProperty(key$1)) {
    reverseKeywords[cssKeywords[key$1]] = key$1;
  }
}
var convert$1 = (conversions$3.exports = {
  rgb: {channels: 3, labels: 'rgb'},
  hsl: {channels: 3, labels: 'hsl'},
  hsv: {channels: 3, labels: 'hsv'},
  hwb: {channels: 3, labels: 'hwb'},
  cmyk: {channels: 4, labels: 'cmyk'},
  xyz: {channels: 3, labels: 'xyz'},
  lab: {channels: 3, labels: 'lab'},
  lch: {channels: 3, labels: 'lch'},
  hex: {channels: 1, labels: ['hex']},
  keyword: {channels: 1, labels: ['keyword']},
  ansi16: {channels: 1, labels: ['ansi16']},
  ansi256: {channels: 1, labels: ['ansi256']},
  hcg: {channels: 3, labels: ['h', 'c', 'g']},
  apple: {channels: 3, labels: ['r16', 'g16', 'b16']},
  gray: {channels: 1, labels: ['gray']},
});
for (var model in convert$1) {
  if (convert$1.hasOwnProperty(model)) {
    if (!('channels' in convert$1[model])) {
      throw new Error('missing channels property: ' + model);
    }
    if (!('labels' in convert$1[model])) {
      throw new Error('missing channel labels property: ' + model);
    }
    if (convert$1[model].labels.length !== convert$1[model].channels) {
      throw new Error('channel and label counts mismatch: ' + model);
    }
    var channels = convert$1[model].channels;
    var labels = convert$1[model].labels;
    delete convert$1[model].channels;
    delete convert$1[model].labels;
    Object.defineProperty(convert$1[model], 'channels', {value: channels});
    Object.defineProperty(convert$1[model], 'labels', {value: labels});
  }
}
convert$1.rgb.hsl = function (rgb) {
  var r = rgb[0] / 255;
  var g = rgb[1] / 255;
  var b = rgb[2] / 255;
  var min = Math.min(r, g, b);
  var max = Math.max(r, g, b);
  var delta = max - min;
  var h;
  var s;
  var l;
  if (max === min) {
    h = 0;
  } else if (r === max) {
    h = (g - b) / delta;
  } else if (g === max) {
    h = 2 + (b - r) / delta;
  } else if (b === max) {
    h = 4 + (r - g) / delta;
  }
  h = Math.min(h * 60, 360);
  if (h < 0) {
    h += 360;
  }
  l = (min + max) / 2;
  if (max === min) {
    s = 0;
  } else if (l <= 0.5) {
    s = delta / (max + min);
  } else {
    s = delta / (2 - max - min);
  }
  return [h, s * 100, l * 100];
};
convert$1.rgb.hsv = function (rgb) {
  var rdif;
  var gdif;
  var bdif;
  var h;
  var s;
  var r = rgb[0] / 255;
  var g = rgb[1] / 255;
  var b = rgb[2] / 255;
  var v = Math.max(r, g, b);
  var diff = v - Math.min(r, g, b);
  var diffc = function (c) {
    return (v - c) / 6 / diff + 1 / 2;
  };
  if (diff === 0) {
    h = s = 0;
  } else {
    s = diff / v;
    rdif = diffc(r);
    gdif = diffc(g);
    bdif = diffc(b);
    if (r === v) {
      h = bdif - gdif;
    } else if (g === v) {
      h = 1 / 3 + rdif - bdif;
    } else if (b === v) {
      h = 2 / 3 + gdif - rdif;
    }
    if (h < 0) {
      h += 1;
    } else if (h > 1) {
      h -= 1;
    }
  }
  return [h * 360, s * 100, v * 100];
};
convert$1.rgb.hwb = function (rgb) {
  var r = rgb[0];
  var g = rgb[1];
  var b = rgb[2];
  var h = convert$1.rgb.hsl(rgb)[0];
  var w = (1 / 255) * Math.min(r, Math.min(g, b));
  b = 1 - (1 / 255) * Math.max(r, Math.max(g, b));
  return [h, w * 100, b * 100];
};
convert$1.rgb.cmyk = function (rgb) {
  var r = rgb[0] / 255;
  var g = rgb[1] / 255;
  var b = rgb[2] / 255;
  var c;
  var m;
  var y;
  var k;
  k = Math.min(1 - r, 1 - g, 1 - b);
  c = (1 - r - k) / (1 - k) || 0;
  m = (1 - g - k) / (1 - k) || 0;
  y = (1 - b - k) / (1 - k) || 0;
  return [c * 100, m * 100, y * 100, k * 100];
};
function comparativeDistance(x, y) {
  return (
    Math.pow(x[0] - y[0], 2) +
    Math.pow(x[1] - y[1], 2) +
    Math.pow(x[2] - y[2], 2)
  );
}
convert$1.rgb.keyword = function (rgb) {
  var reversed = reverseKeywords[rgb];
  if (reversed) {
    return reversed;
  }
  var currentClosestDistance = Infinity;
  var currentClosestKeyword;
  for (var keyword in cssKeywords) {
    if (cssKeywords.hasOwnProperty(keyword)) {
      var value = cssKeywords[keyword];
      var distance = comparativeDistance(rgb, value);
      if (distance < currentClosestDistance) {
        currentClosestDistance = distance;
        currentClosestKeyword = keyword;
      }
    }
  }
  return currentClosestKeyword;
};
convert$1.keyword.rgb = function (keyword) {
  return cssKeywords[keyword];
};
convert$1.rgb.xyz = function (rgb) {
  var r = rgb[0] / 255;
  var g = rgb[1] / 255;
  var b = rgb[2] / 255;
  r = r > 0.04045 ? Math.pow((r + 0.055) / 1.055, 2.4) : r / 12.92;
  g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
  b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
  var x = r * 0.4124 + g * 0.3576 + b * 0.1805;
  var y = r * 0.2126 + g * 0.7152 + b * 0.0722;
  var z = r * 0.0193 + g * 0.1192 + b * 0.9505;
  return [x * 100, y * 100, z * 100];
};
convert$1.rgb.lab = function (rgb) {
  var xyz = convert$1.rgb.xyz(rgb);
  var x = xyz[0];
  var y = xyz[1];
  var z = xyz[2];
  var l;
  var a;
  var b;
  x /= 95.047;
  y /= 100;
  z /= 108.883;
  x = x > 0.008856 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
  y = y > 0.008856 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
  z = z > 0.008856 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
  l = 116 * y - 16;
  a = 500 * (x - y);
  b = 200 * (y - z);
  return [l, a, b];
};
convert$1.hsl.rgb = function (hsl) {
  var h = hsl[0] / 360;
  var s = hsl[1] / 100;
  var l = hsl[2] / 100;
  var t1;
  var t2;
  var t3;
  var rgb;
  var val;
  if (s === 0) {
    val = l * 255;
    return [val, val, val];
  }
  if (l < 0.5) {
    t2 = l * (1 + s);
  } else {
    t2 = l + s - l * s;
  }
  t1 = 2 * l - t2;
  rgb = [0, 0, 0];
  for (var i = 0; i < 3; i++) {
    t3 = h + (1 / 3) * -(i - 1);
    if (t3 < 0) {
      t3++;
    }
    if (t3 > 1) {
      t3--;
    }
    if (6 * t3 < 1) {
      val = t1 + (t2 - t1) * 6 * t3;
    } else if (2 * t3 < 1) {
      val = t2;
    } else if (3 * t3 < 2) {
      val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
    } else {
      val = t1;
    }
    rgb[i] = val * 255;
  }
  return rgb;
};
convert$1.hsl.hsv = function (hsl) {
  var h = hsl[0];
  var s = hsl[1] / 100;
  var l = hsl[2] / 100;
  var smin = s;
  var lmin = Math.max(l, 0.01);
  var sv;
  var v;
  l *= 2;
  s *= l <= 1 ? l : 2 - l;
  smin *= lmin <= 1 ? lmin : 2 - lmin;
  v = (l + s) / 2;
  sv = l === 0 ? (2 * smin) / (lmin + smin) : (2 * s) / (l + s);
  return [h, sv * 100, v * 100];
};
convert$1.hsv.rgb = function (hsv) {
  var h = hsv[0] / 60;
  var s = hsv[1] / 100;
  var v = hsv[2] / 100;
  var hi = Math.floor(h) % 6;
  var f = h - Math.floor(h);
  var p = 255 * v * (1 - s);
  var q = 255 * v * (1 - s * f);
  var t = 255 * v * (1 - s * (1 - f));
  v *= 255;
  switch (hi) {
    case 0:
      return [v, t, p];
    case 1:
      return [q, v, p];
    case 2:
      return [p, v, t];
    case 3:
      return [p, q, v];
    case 4:
      return [t, p, v];
    case 5:
      return [v, p, q];
  }
};
convert$1.hsv.hsl = function (hsv) {
  var h = hsv[0];
  var s = hsv[1] / 100;
  var v = hsv[2] / 100;
  var vmin = Math.max(v, 0.01);
  var lmin;
  var sl;
  var l;
  l = (2 - s) * v;
  lmin = (2 - s) * vmin;
  sl = s * vmin;
  sl /= lmin <= 1 ? lmin : 2 - lmin;
  sl = sl || 0;
  l /= 2;
  return [h, sl * 100, l * 100];
};
convert$1.hwb.rgb = function (hwb) {
  var h = hwb[0] / 360;
  var wh = hwb[1] / 100;
  var bl = hwb[2] / 100;
  var ratio = wh + bl;
  var i;
  var v;
  var f;
  var n;
  if (ratio > 1) {
    wh /= ratio;
    bl /= ratio;
  }
  i = Math.floor(6 * h);
  v = 1 - bl;
  f = 6 * h - i;
  if ((i & 1) !== 0) {
    f = 1 - f;
  }
  n = wh + f * (v - wh);
  var r;
  var g;
  var b;
  switch (i) {
    default:
    case 6:
    case 0:
      r = v;
      g = n;
      b = wh;
      break;
    case 1:
      r = n;
      g = v;
      b = wh;
      break;
    case 2:
      r = wh;
      g = v;
      b = n;
      break;
    case 3:
      r = wh;
      g = n;
      b = v;
      break;
    case 4:
      r = n;
      g = wh;
      b = v;
      break;
    case 5:
      r = v;
      g = wh;
      b = n;
      break;
  }
  return [r * 255, g * 255, b * 255];
};
convert$1.cmyk.rgb = function (cmyk) {
  var c = cmyk[0] / 100;
  var m = cmyk[1] / 100;
  var y = cmyk[2] / 100;
  var k = cmyk[3] / 100;
  var r;
  var g;
  var b;
  r = 1 - Math.min(1, c * (1 - k) + k);
  g = 1 - Math.min(1, m * (1 - k) + k);
  b = 1 - Math.min(1, y * (1 - k) + k);
  return [r * 255, g * 255, b * 255];
};
convert$1.xyz.rgb = function (xyz) {
  var x = xyz[0] / 100;
  var y = xyz[1] / 100;
  var z = xyz[2] / 100;
  var r;
  var g;
  var b;
  r = x * 3.2406 + y * -1.5372 + z * -0.4986;
  g = x * -0.9689 + y * 1.8758 + z * 0.0415;
  b = x * 0.0557 + y * -0.204 + z * 1.057;
  r = r > 0.0031308 ? 1.055 * Math.pow(r, 1 / 2.4) - 0.055 : r * 12.92;
  g = g > 0.0031308 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
  b = b > 0.0031308 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
  r = Math.min(Math.max(0, r), 1);
  g = Math.min(Math.max(0, g), 1);
  b = Math.min(Math.max(0, b), 1);
  return [r * 255, g * 255, b * 255];
};
convert$1.xyz.lab = function (xyz) {
  var x = xyz[0];
  var y = xyz[1];
  var z = xyz[2];
  var l;
  var a;
  var b;
  x /= 95.047;
  y /= 100;
  z /= 108.883;
  x = x > 0.008856 ? Math.pow(x, 1 / 3) : 7.787 * x + 16 / 116;
  y = y > 0.008856 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
  z = z > 0.008856 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
  l = 116 * y - 16;
  a = 500 * (x - y);
  b = 200 * (y - z);
  return [l, a, b];
};
convert$1.lab.xyz = function (lab) {
  var l = lab[0];
  var a = lab[1];
  var b = lab[2];
  var x;
  var y;
  var z;
  y = (l + 16) / 116;
  x = a / 500 + y;
  z = y - b / 200;
  var y2 = Math.pow(y, 3);
  var x2 = Math.pow(x, 3);
  var z2 = Math.pow(z, 3);
  y = y2 > 0.008856 ? y2 : (y - 16 / 116) / 7.787;
  x = x2 > 0.008856 ? x2 : (x - 16 / 116) / 7.787;
  z = z2 > 0.008856 ? z2 : (z - 16 / 116) / 7.787;
  x *= 95.047;
  y *= 100;
  z *= 108.883;
  return [x, y, z];
};
convert$1.lab.lch = function (lab) {
  var l = lab[0];
  var a = lab[1];
  var b = lab[2];
  var hr;
  var h;
  var c;
  hr = Math.atan2(b, a);
  h = (hr * 360) / 2 / Math.PI;
  if (h < 0) {
    h += 360;
  }
  c = Math.sqrt(a * a + b * b);
  return [l, c, h];
};
convert$1.lch.lab = function (lch) {
  var l = lch[0];
  var c = lch[1];
  var h = lch[2];
  var a;
  var b;
  var hr;
  hr = (h / 360) * 2 * Math.PI;
  a = c * Math.cos(hr);
  b = c * Math.sin(hr);
  return [l, a, b];
};
convert$1.rgb.ansi16 = function (args) {
  var r = args[0];
  var g = args[1];
  var b = args[2];
  var value = 1 in arguments ? arguments[1] : convert$1.rgb.hsv(args)[2];
  value = Math.round(value / 50);
  if (value === 0) {
    return 30;
  }
  var ansi =
    30 +
    ((Math.round(b / 255) << 2) |
      (Math.round(g / 255) << 1) |
      Math.round(r / 255));
  if (value === 2) {
    ansi += 60;
  }
  return ansi;
};
convert$1.hsv.ansi16 = function (args) {
  return convert$1.rgb.ansi16(convert$1.hsv.rgb(args), args[2]);
};
convert$1.rgb.ansi256 = function (args) {
  var r = args[0];
  var g = args[1];
  var b = args[2];
  if (r === g && g === b) {
    if (r < 8) {
      return 16;
    }
    if (r > 248) {
      return 231;
    }
    return Math.round(((r - 8) / 247) * 24) + 232;
  }
  var ansi =
    16 +
    36 * Math.round((r / 255) * 5) +
    6 * Math.round((g / 255) * 5) +
    Math.round((b / 255) * 5);
  return ansi;
};
convert$1.ansi16.rgb = function (args) {
  var color = args % 10;
  if (color === 0 || color === 7) {
    if (args > 50) {
      color += 3.5;
    }
    color = (color / 10.5) * 255;
    return [color, color, color];
  }
  var mult = (~~(args > 50) + 1) * 0.5;
  var r = (color & 1) * mult * 255;
  var g = ((color >> 1) & 1) * mult * 255;
  var b = ((color >> 2) & 1) * mult * 255;
  return [r, g, b];
};
convert$1.ansi256.rgb = function (args) {
  if (args >= 232) {
    var c = (args - 232) * 10 + 8;
    return [c, c, c];
  }
  args -= 16;
  var rem;
  var r = (Math.floor(args / 36) / 5) * 255;
  var g = (Math.floor((rem = args % 36) / 6) / 5) * 255;
  var b = ((rem % 6) / 5) * 255;
  return [r, g, b];
};
convert$1.rgb.hex = function (args) {
  var integer =
    ((Math.round(args[0]) & 255) << 16) +
    ((Math.round(args[1]) & 255) << 8) +
    (Math.round(args[2]) & 255);
  var string = integer.toString(16).toUpperCase();
  return '000000'.substring(string.length) + string;
};
convert$1.hex.rgb = function (args) {
  var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
  if (!match) {
    return [0, 0, 0];
  }
  var colorString = match[0];
  if (match[0].length === 3) {
    colorString = colorString
      .split('')
      .map(function (char) {
        return char + char;
      })
      .join('');
  }
  var integer = parseInt(colorString, 16);
  var r = (integer >> 16) & 255;
  var g = (integer >> 8) & 255;
  var b = integer & 255;
  return [r, g, b];
};
convert$1.rgb.hcg = function (rgb) {
  var r = rgb[0] / 255;
  var g = rgb[1] / 255;
  var b = rgb[2] / 255;
  var max = Math.max(Math.max(r, g), b);
  var min = Math.min(Math.min(r, g), b);
  var chroma = max - min;
  var grayscale;
  var hue;
  if (chroma < 1) {
    grayscale = min / (1 - chroma);
  } else {
    grayscale = 0;
  }
  if (chroma <= 0) {
    hue = 0;
  } else if (max === r) {
    hue = ((g - b) / chroma) % 6;
  } else if (max === g) {
    hue = 2 + (b - r) / chroma;
  } else {
    hue = 4 + (r - g) / chroma + 4;
  }
  hue /= 6;
  hue %= 1;
  return [hue * 360, chroma * 100, grayscale * 100];
};
convert$1.hsl.hcg = function (hsl) {
  var s = hsl[1] / 100;
  var l = hsl[2] / 100;
  var c = 1;
  var f = 0;
  if (l < 0.5) {
    c = 2 * s * l;
  } else {
    c = 2 * s * (1 - l);
  }
  if (c < 1) {
    f = (l - 0.5 * c) / (1 - c);
  }
  return [hsl[0], c * 100, f * 100];
};
convert$1.hsv.hcg = function (hsv) {
  var s = hsv[1] / 100;
  var v = hsv[2] / 100;
  var c = s * v;
  var f = 0;
  if (c < 1) {
    f = (v - c) / (1 - c);
  }
  return [hsv[0], c * 100, f * 100];
};
convert$1.hcg.rgb = function (hcg) {
  var h = hcg[0] / 360;
  var c = hcg[1] / 100;
  var g = hcg[2] / 100;
  if (c === 0) {
    return [g * 255, g * 255, g * 255];
  }
  var pure = [0, 0, 0];
  var hi = (h % 1) * 6;
  var v = hi % 1;
  var w = 1 - v;
  var mg = 0;
  switch (Math.floor(hi)) {
    case 0:
      pure[0] = 1;
      pure[1] = v;
      pure[2] = 0;
      break;
    case 1:
      pure[0] = w;
      pure[1] = 1;
      pure[2] = 0;
      break;
    case 2:
      pure[0] = 0;
      pure[1] = 1;
      pure[2] = v;
      break;
    case 3:
      pure[0] = 0;
      pure[1] = w;
      pure[2] = 1;
      break;
    case 4:
      pure[0] = v;
      pure[1] = 0;
      pure[2] = 1;
      break;
    default:
      pure[0] = 1;
      pure[1] = 0;
      pure[2] = w;
  }
  mg = (1 - c) * g;
  return [
    (c * pure[0] + mg) * 255,
    (c * pure[1] + mg) * 255,
    (c * pure[2] + mg) * 255,
  ];
};
convert$1.hcg.hsv = function (hcg) {
  var c = hcg[1] / 100;
  var g = hcg[2] / 100;
  var v = c + g * (1 - c);
  var f = 0;
  if (v > 0) {
    f = c / v;
  }
  return [hcg[0], f * 100, v * 100];
};
convert$1.hcg.hsl = function (hcg) {
  var c = hcg[1] / 100;
  var g = hcg[2] / 100;
  var l = g * (1 - c) + 0.5 * c;
  var s = 0;
  if (l > 0 && l < 0.5) {
    s = c / (2 * l);
  } else if (l >= 0.5 && l < 1) {
    s = c / (2 * (1 - l));
  }
  return [hcg[0], s * 100, l * 100];
};
convert$1.hcg.hwb = function (hcg) {
  var c = hcg[1] / 100;
  var g = hcg[2] / 100;
  var v = c + g * (1 - c);
  return [hcg[0], (v - c) * 100, (1 - v) * 100];
};
convert$1.hwb.hcg = function (hwb) {
  var w = hwb[1] / 100;
  var b = hwb[2] / 100;
  var v = 1 - b;
  var c = v - w;
  var g = 0;
  if (c < 1) {
    g = (v - c) / (1 - c);
  }
  return [hwb[0], c * 100, g * 100];
};
convert$1.apple.rgb = function (apple) {
  return [
    (apple[0] / 65535) * 255,
    (apple[1] / 65535) * 255,
    (apple[2] / 65535) * 255,
  ];
};
convert$1.rgb.apple = function (rgb) {
  return [
    (rgb[0] / 255) * 65535,
    (rgb[1] / 255) * 65535,
    (rgb[2] / 255) * 65535,
  ];
};
convert$1.gray.rgb = function (args) {
  return [(args[0] / 100) * 255, (args[0] / 100) * 255, (args[0] / 100) * 255];
};
convert$1.gray.hsl = convert$1.gray.hsv = function (args) {
  return [0, 0, args[0]];
};
convert$1.gray.hwb = function (gray) {
  return [0, 100, gray[0]];
};
convert$1.gray.cmyk = function (gray) {
  return [0, 0, 0, gray[0]];
};
convert$1.gray.lab = function (gray) {
  return [gray[0], 0, 0];
};
convert$1.gray.hex = function (gray) {
  var val = Math.round((gray[0] / 100) * 255) & 255;
  var integer = (val << 16) + (val << 8) + val;
  var string = integer.toString(16).toUpperCase();
  return '000000'.substring(string.length) + string;
};
convert$1.rgb.gray = function (rgb) {
  var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
  return [(val / 255) * 100];
};
var conversionsExports = conversions$3.exports;
var conversions$2 = conversionsExports;
function buildGraph() {
  var graph = {};
  var models = Object.keys(conversions$2);
  for (var len = models.length, i = 0; i < len; i++) {
    graph[models[i]] = {distance: -1, parent: null};
  }
  return graph;
}
function deriveBFS(fromModel) {
  var graph = buildGraph();
  var queue = [fromModel];
  graph[fromModel].distance = 0;
  while (queue.length) {
    var current = queue.pop();
    var adjacents = Object.keys(conversions$2[current]);
    for (var len = adjacents.length, i = 0; i < len; i++) {
      var adjacent = adjacents[i];
      var node = graph[adjacent];
      if (node.distance === -1) {
        node.distance = graph[current].distance + 1;
        node.parent = current;
        queue.unshift(adjacent);
      }
    }
  }
  return graph;
}
function link(from, to) {
  return function (args) {
    return to(from(args));
  };
}
function wrapConversion(toModel, graph) {
  var path = [graph[toModel].parent, toModel];
  var fn = conversions$2[graph[toModel].parent][toModel];
  var cur = graph[toModel].parent;
  while (graph[cur].parent) {
    path.unshift(graph[cur].parent);
    fn = link(conversions$2[graph[cur].parent][cur], fn);
    cur = graph[cur].parent;
  }
  fn.conversion = path;
  return fn;
}
var route$2 = function (fromModel) {
  var graph = deriveBFS(fromModel);
  var conversion = {};
  var models = Object.keys(graph);
  for (var len = models.length, i = 0; i < len; i++) {
    var toModel = models[i];
    var node = graph[toModel];
    if (node.parent === null) {
      continue;
    }
    conversion[toModel] = wrapConversion(toModel, graph);
  }
  return conversion;
};
var conversions$1 = conversionsExports;
var route$1 = route$2;
var convert = {};
var models = Object.keys(conversions$1);
function wrapRaw(fn) {
  var wrappedFn = function (args) {
    if (args === undefined || args === null) {
      return args;
    }
    if (arguments.length > 1) {
      args = Array.prototype.slice.call(arguments);
    }
    return fn(args);
  };
  if ('conversion' in fn) {
    wrappedFn.conversion = fn.conversion;
  }
  return wrappedFn;
}
function wrapRounded(fn) {
  var wrappedFn = function (args) {
    if (args === undefined || args === null) {
      return args;
    }
    if (arguments.length > 1) {
      args = Array.prototype.slice.call(arguments);
    }
    var result = fn(args);
    if (typeof result === 'object') {
      for (var len = result.length, i = 0; i < len; i++) {
        result[i] = Math.round(result[i]);
      }
    }
    return result;
  };
  if ('conversion' in fn) {
    wrappedFn.conversion = fn.conversion;
  }
  return wrappedFn;
}
models.forEach(function (fromModel) {
  convert[fromModel] = {};
  Object.defineProperty(convert[fromModel], 'channels', {
    value: conversions$1[fromModel].channels,
  });
  Object.defineProperty(convert[fromModel], 'labels', {
    value: conversions$1[fromModel].labels,
  });
  var routes = route$1(fromModel);
  var routeModels = Object.keys(routes);
  routeModels.forEach(function (toModel) {
    var fn = routes[toModel];
    convert[fromModel][toModel] = wrapRounded(fn);
    convert[fromModel][toModel].raw = wrapRaw(fn);
  });
});
var colorConvert$1 = convert;
ansiStyles$2.exports;
(function (module) {
  const colorConvert = colorConvert$1;
  const wrapAnsi16 = (fn, offset) =>
    function () {
      const code = fn.apply(colorConvert, arguments);
      return `[${code + offset}m`;
    };
  const wrapAnsi256 = (fn, offset) =>
    function () {
      const code = fn.apply(colorConvert, arguments);
      return `[${38 + offset};5;${code}m`;
    };
  const wrapAnsi16m = (fn, offset) =>
    function () {
      const rgb = fn.apply(colorConvert, arguments);
      return `[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
  function assembleStyles() {
    const codes = new Map();
    const styles = {
      modifier: {
        reset: [0, 0],
        bold: [1, 22],
        dim: [2, 22],
        italic: [3, 23],
        underline: [4, 24],
        inverse: [7, 27],
        hidden: [8, 28],
        strikethrough: [9, 29],
      },
      color: {
        black: [30, 39],
        red: [31, 39],
        green: [32, 39],
        yellow: [33, 39],
        blue: [34, 39],
        magenta: [35, 39],
        cyan: [36, 39],
        white: [37, 39],
        gray: [90, 39],
        redBright: [91, 39],
        greenBright: [92, 39],
        yellowBright: [93, 39],
        blueBright: [94, 39],
        magentaBright: [95, 39],
        cyanBright: [96, 39],
        whiteBright: [97, 39],
      },
      bgColor: {
        bgBlack: [40, 49],
        bgRed: [41, 49],
        bgGreen: [42, 49],
        bgYellow: [43, 49],
        bgBlue: [44, 49],
        bgMagenta: [45, 49],
        bgCyan: [46, 49],
        bgWhite: [47, 49],
        bgBlackBright: [100, 49],
        bgRedBright: [101, 49],
        bgGreenBright: [102, 49],
        bgYellowBright: [103, 49],
        bgBlueBright: [104, 49],
        bgMagentaBright: [105, 49],
        bgCyanBright: [106, 49],
        bgWhiteBright: [107, 49],
      },
    };
    styles.color.grey = styles.color.gray;
    for (const groupName of Object.keys(styles)) {
      const group = styles[groupName];
      for (const styleName of Object.keys(group)) {
        const style = group[styleName];
        styles[styleName] = {open: `[${style[0]}m`, close: `[${style[1]}m`};
        group[styleName] = styles[styleName];
        codes.set(style[0], style[1]);
      }
      Object.defineProperty(styles, groupName, {
        value: group,
        enumerable: false,
      });
      Object.defineProperty(styles, 'codes', {value: codes, enumerable: false});
    }
    const ansi2ansi = n => n;
    const rgb2rgb = (r, g, b) => [r, g, b];
    styles.color.close = '[39m';
    styles.bgColor.close = '[49m';
    styles.color.ansi = {ansi: wrapAnsi16(ansi2ansi, 0)};
    styles.color.ansi256 = {ansi256: wrapAnsi256(ansi2ansi, 0)};
    styles.color.ansi16m = {rgb: wrapAnsi16m(rgb2rgb, 0)};
    styles.bgColor.ansi = {ansi: wrapAnsi16(ansi2ansi, 10)};
    styles.bgColor.ansi256 = {ansi256: wrapAnsi256(ansi2ansi, 10)};
    styles.bgColor.ansi16m = {rgb: wrapAnsi16m(rgb2rgb, 10)};
    for (let key of Object.keys(colorConvert)) {
      if (typeof colorConvert[key] !== 'object') {
        continue;
      }
      const suite = colorConvert[key];
      if (key === 'ansi16') {
        key = 'ansi';
      }
      if ('ansi16' in suite) {
        styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
        styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
      }
      if ('ansi256' in suite) {
        styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
        styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
      }
      if ('rgb' in suite) {
        styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
        styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
      }
    }
    return styles;
  }
  Object.defineProperty(module, 'exports', {
    enumerable: true,
    get: assembleStyles,
  });
})(ansiStyles$2);
var ansiStylesExports$1 = ansiStyles$2.exports;
var hasFlag$2;
var hasRequiredHasFlag;
function requireHasFlag() {
  if (hasRequiredHasFlag) return hasFlag$2;
  hasRequiredHasFlag = 1;
  hasFlag$2 = (flag, argv) => {
    argv = argv || process.argv;
    const prefix = flag.startsWith('-') ? '' : flag.length === 1 ? '-' : '--';
    const pos = argv.indexOf(prefix + flag);
    const terminatorPos = argv.indexOf('--');
    return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
  };
  return hasFlag$2;
}
var supportsColor_1$1;
var hasRequiredSupportsColor;
function requireSupportsColor() {
  if (hasRequiredSupportsColor) return supportsColor_1$1;
  hasRequiredSupportsColor = 1;
  const os = require$$0$3;
  const hasFlag = requireHasFlag();
  const env = process.env;
  let forceColor;
  if (hasFlag('no-color') || hasFlag('no-colors') || hasFlag('color=false')) {
    forceColor = false;
  } else if (
    hasFlag('color') ||
    hasFlag('colors') ||
    hasFlag('color=true') ||
    hasFlag('color=always')
  ) {
    forceColor = true;
  }
  if ('FORCE_COLOR' in env) {
    forceColor =
      env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
  }
  function translateLevel(level) {
    if (level === 0) {
      return false;
    }
    return {
      level: level,
      hasBasic: true,
      has256: level >= 2,
      has16m: level >= 3,
    };
  }
  function supportsColor(stream) {
    if (forceColor === false) {
      return 0;
    }
    if (
      hasFlag('color=16m') ||
      hasFlag('color=full') ||
      hasFlag('color=truecolor')
    ) {
      return 3;
    }
    if (hasFlag('color=256')) {
      return 2;
    }
    if (stream && !stream.isTTY && forceColor !== true) {
      return 0;
    }
    const min = forceColor ? 1 : 0;
    if (process.platform === 'win32') {
      const osRelease = os.release().split('.');
      if (
        Number(process.versions.node.split('.')[0]) >= 8 &&
        Number(osRelease[0]) >= 10 &&
        Number(osRelease[2]) >= 10586
      ) {
        return Number(osRelease[2]) >= 14931 ? 3 : 2;
      }
      return 1;
    }
    if ('CI' in env) {
      if (
        ['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI'].some(
          sign => sign in env
        ) ||
        env.CI_NAME === 'codeship'
      ) {
        return 1;
      }
      return min;
    }
    if ('TEAMCITY_VERSION' in env) {
      return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
    }
    if (env.COLORTERM === 'truecolor') {
      return 3;
    }
    if ('TERM_PROGRAM' in env) {
      const version = parseInt(
        (env.TERM_PROGRAM_VERSION || '').split('.')[0],
        10
      );
      switch (env.TERM_PROGRAM) {
        case 'iTerm.app':
          return version >= 3 ? 3 : 2;
        case 'Apple_Terminal':
          return 2;
      }
    }
    if (/-256(color)?$/i.test(env.TERM)) {
      return 2;
    }
    if (
      /^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(
        env.TERM
      )
    ) {
      return 1;
    }
    if ('COLORTERM' in env) {
      return 1;
    }
    if (env.TERM === 'dumb') {
      return min;
    }
    return min;
  }
  function getSupportLevel(stream) {
    const level = supportsColor(stream);
    return translateLevel(level);
  }
  supportsColor_1$1 = {
    supportsColor: getSupportLevel,
    stdout: getSupportLevel(process.stdout),
    stderr: getSupportLevel(process.stderr),
  };
  return supportsColor_1$1;
}
var templates$1;
var hasRequiredTemplates$1;
function requireTemplates$1() {
  if (hasRequiredTemplates$1) return templates$1;
  hasRequiredTemplates$1 = 1;
  const TEMPLATE_REGEX =
    /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
  const STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
  const STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
  const ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
  const ESCAPES = new Map([
    ['n', '\n'],
    ['r', '\r'],
    ['t', '\t'],
    ['b', '\b'],
    ['f', '\f'],
    ['v', '\v'],
    ['0', '\0'],
    ['\\', '\\'],
    ['e', ''],
    ['a', ''],
  ]);
  function unescape(c) {
    if ((c[0] === 'u' && c.length === 5) || (c[0] === 'x' && c.length === 3)) {
      return String.fromCharCode(parseInt(c.slice(1), 16));
    }
    return ESCAPES.get(c) || c;
  }
  function parseArguments(name, args) {
    const results = [];
    const chunks = args.trim().split(/\s*,\s*/g);
    let matches;
    for (const chunk of chunks) {
      if (!isNaN(chunk)) {
        results.push(Number(chunk));
      } else if ((matches = chunk.match(STRING_REGEX))) {
        results.push(
          matches[2].replace(ESCAPE_REGEX, (m, escape, chr) =>
            escape ? unescape(escape) : chr
          )
        );
      } else {
        throw new Error(
          `Invalid Chalk template style argument: ${chunk} (in style '${name}')`
        );
      }
    }
    return results;
  }
  function parseStyle(style) {
    STYLE_REGEX.lastIndex = 0;
    const results = [];
    let matches;
    while ((matches = STYLE_REGEX.exec(style)) !== null) {
      const name = matches[1];
      if (matches[2]) {
        const args = parseArguments(name, matches[2]);
        results.push([name].concat(args));
      } else {
        results.push([name]);
      }
    }
    return results;
  }
  function buildStyle(chalk, styles) {
    const enabled = {};
    for (const layer of styles) {
      for (const style of layer.styles) {
        enabled[style[0]] = layer.inverse ? null : style.slice(1);
      }
    }
    let current = chalk;
    for (const styleName of Object.keys(enabled)) {
      if (Array.isArray(enabled[styleName])) {
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        if (enabled[styleName].length > 0) {
          current = current[styleName].apply(current, enabled[styleName]);
        } else {
          current = current[styleName];
        }
      }
    }
    return current;
  }
  templates$1 = (chalk, tmp) => {
    const styles = [];
    const chunks = [];
    let chunk = [];
    tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
      if (escapeChar) {
        chunk.push(unescape(escapeChar));
      } else if (style) {
        const str = chunk.join('');
        chunk = [];
        chunks.push(styles.length === 0 ? str : buildStyle(chalk, styles)(str));
        styles.push({inverse: inverse, styles: parseStyle(style)});
      } else if (close) {
        if (styles.length === 0) {
          throw new Error('Found extraneous } in Chalk template literal');
        }
        chunks.push(buildStyle(chalk, styles)(chunk.join('')));
        chunk = [];
        styles.pop();
      } else {
        chunk.push(chr);
      }
    });
    chunks.push(chunk.join(''));
    if (styles.length > 0) {
      const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? '' : 's'} (\`}\`)`;
      throw new Error(errMsg);
    }
    return chunks.join('');
  };
  return templates$1;
}
var hasRequiredChalk;
function requireChalk() {
  if (hasRequiredChalk) return chalk$1.exports;
  hasRequiredChalk = 1;
  (function (module) {
    const escapeStringRegexp = requireEscapeStringRegexp();
    const ansiStyles = ansiStylesExports$1;
    const stdoutColor = requireSupportsColor().stdout;
    const template = requireTemplates$1();
    const isSimpleWindowsTerm =
      process.platform === 'win32' &&
      !(process.env.TERM || '').toLowerCase().startsWith('xterm');
    const levelMapping = ['ansi', 'ansi', 'ansi256', 'ansi16m'];
    const skipModels = new Set(['gray']);
    const styles = Object.create(null);
    function applyOptions(obj, options) {
      options = options || {};
      const scLevel = stdoutColor ? stdoutColor.level : 0;
      obj.level = options.level === undefined ? scLevel : options.level;
      obj.enabled = 'enabled' in options ? options.enabled : obj.level > 0;
    }
    function Chalk(options) {
      if (!this || !(this instanceof Chalk) || this.template) {
        const chalk = {};
        applyOptions(chalk, options);
        chalk.template = function () {
          const args = [].slice.call(arguments);
          return chalkTag.apply(null, [chalk.template].concat(args));
        };
        Object.setPrototypeOf(chalk, Chalk.prototype);
        Object.setPrototypeOf(chalk.template, chalk);
        chalk.template.constructor = Chalk;
        return chalk.template;
      }
      applyOptions(this, options);
    }
    if (isSimpleWindowsTerm) {
      ansiStyles.blue.open = '[94m';
    }
    for (const key of Object.keys(ansiStyles)) {
      ansiStyles[key].closeRe = new RegExp(
        escapeStringRegexp(ansiStyles[key].close),
        'g'
      );
      styles[key] = {
        get() {
          const codes = ansiStyles[key];
          return build.call(
            this,
            this._styles ? this._styles.concat(codes) : [codes],
            this._empty,
            key
          );
        },
      };
    }
    styles.visible = {
      get() {
        return build.call(this, this._styles || [], true, 'visible');
      },
    };
    ansiStyles.color.closeRe = new RegExp(
      escapeStringRegexp(ansiStyles.color.close),
      'g'
    );
    for (const model of Object.keys(ansiStyles.color.ansi)) {
      if (skipModels.has(model)) {
        continue;
      }
      styles[model] = {
        get() {
          const level = this.level;
          return function () {
            const open = ansiStyles.color[levelMapping[level]][model].apply(
              null,
              arguments
            );
            const codes = {
              open: open,
              close: ansiStyles.color.close,
              closeRe: ansiStyles.color.closeRe,
            };
            return build.call(
              this,
              this._styles ? this._styles.concat(codes) : [codes],
              this._empty,
              model
            );
          };
        },
      };
    }
    ansiStyles.bgColor.closeRe = new RegExp(
      escapeStringRegexp(ansiStyles.bgColor.close),
      'g'
    );
    for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
      if (skipModels.has(model)) {
        continue;
      }
      const bgModel = 'bg' + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const level = this.level;
          return function () {
            const open = ansiStyles.bgColor[levelMapping[level]][model].apply(
              null,
              arguments
            );
            const codes = {
              open: open,
              close: ansiStyles.bgColor.close,
              closeRe: ansiStyles.bgColor.closeRe,
            };
            return build.call(
              this,
              this._styles ? this._styles.concat(codes) : [codes],
              this._empty,
              model
            );
          };
        },
      };
    }
    const proto = Object.defineProperties(() => {}, styles);
    function build(_styles, _empty, key) {
      const builder = function () {
        return applyStyle.apply(builder, arguments);
      };
      builder._styles = _styles;
      builder._empty = _empty;
      const self = this;
      Object.defineProperty(builder, 'level', {
        enumerable: true,
        get() {
          return self.level;
        },
        set(level) {
          self.level = level;
        },
      });
      Object.defineProperty(builder, 'enabled', {
        enumerable: true,
        get() {
          return self.enabled;
        },
        set(enabled) {
          self.enabled = enabled;
        },
      });
      builder.hasGrey = this.hasGrey || key === 'gray' || key === 'grey';
      builder.__proto__ = proto;
      return builder;
    }
    function applyStyle() {
      const args = arguments;
      const argsLen = args.length;
      let str = String(arguments[0]);
      if (argsLen === 0) {
        return '';
      }
      if (argsLen > 1) {
        for (let a = 1; a < argsLen; a++) {
          str += ' ' + args[a];
        }
      }
      if (!this.enabled || this.level <= 0 || !str) {
        return this._empty ? '' : str;
      }
      const originalDim = ansiStyles.dim.open;
      if (isSimpleWindowsTerm && this.hasGrey) {
        ansiStyles.dim.open = '';
      }
      for (const code of this._styles.slice().reverse()) {
        str = code.open + str.replace(code.closeRe, code.open) + code.close;
        str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
      }
      ansiStyles.dim.open = originalDim;
      return str;
    }
    function chalkTag(chalk, strings) {
      if (!Array.isArray(strings)) {
        return [].slice.call(arguments, 1).join(' ');
      }
      const args = [].slice.call(arguments, 2);
      const parts = [strings.raw[0]];
      for (let i = 1; i < strings.length; i++) {
        parts.push(String(args[i - 1]).replace(/[{}\\]/g, '\\$&'));
        parts.push(String(strings.raw[i]));
      }
      return template(chalk, parts.join(''));
    }
    Object.defineProperties(Chalk.prototype, styles);
    module.exports = Chalk();
    module.exports.supportsColor = stdoutColor;
    module.exports.default = module.exports;
  })(chalk$1);
  return chalk$1.exports;
}
var hasRequiredLib$8;
function requireLib$8() {
  if (hasRequiredLib$8) return lib$8;
  hasRequiredLib$8 = 1;
  Object.defineProperty(lib$8, '__esModule', {value: true});
  lib$8.default = highlight;
  lib$8.shouldHighlight = shouldHighlight;
  var _jsTokens = requireJsTokens();
  var _helperValidatorIdentifier = requireLib$9();
  var _picocolors = _interopRequireWildcard(requirePicocolors(), true);
  function _getRequireWildcardCache(e) {
    if ('function' != typeof WeakMap) return null;
    var r = new WeakMap(),
      t = new WeakMap();
    return (_getRequireWildcardCache = function (e) {
      return e ? t : r;
    })(e);
  }
  function _interopRequireWildcard(e, r) {
    if (null === e || ('object' != typeof e && 'function' != typeof e))
      return {default: e};
    var t = _getRequireWildcardCache(r);
    if (t && t.has(e)) return t.get(e);
    var n = {__proto__: null},
      a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e)
      if ('default' !== u && {}.hasOwnProperty.call(e, u)) {
        var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
        i && (i.get || i.set) ? Object.defineProperty(n, u, i) : (n[u] = e[u]);
      }
    return (n.default = e), t && t.set(e, n), n;
  }
  const colors =
    typeof process === 'object' &&
    (process.env.FORCE_COLOR === '0' || process.env.FORCE_COLOR === 'false')
      ? (0, _picocolors.createColors)(false)
      : _picocolors.default;
  const compose = (f, g) => v => f(g(v));
  const sometimesKeywords = new Set([
    'as',
    'async',
    'from',
    'get',
    'of',
    'set',
  ]);
  function getDefs(colors) {
    return {
      keyword: colors.cyan,
      capitalized: colors.yellow,
      jsxIdentifier: colors.yellow,
      punctuator: colors.yellow,
      number: colors.magenta,
      string: colors.green,
      regex: colors.magenta,
      comment: colors.gray,
      invalid: compose(compose(colors.white, colors.bgRed), colors.bold),
    };
  }
  const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  const BRACKET = /^[()[\]{}]$/;
  let tokenize;
  {
    const JSX_TAG = /^[a-z][\w-]*$/i;
    const getTokenType = function (token, offset, text) {
      if (token.type === 'name') {
        if (
          (0, _helperValidatorIdentifier.isKeyword)(token.value) ||
          (0, _helperValidatorIdentifier.isStrictReservedWord)(
            token.value,
            true
          ) ||
          sometimesKeywords.has(token.value)
        ) {
          return 'keyword';
        }
        if (
          JSX_TAG.test(token.value) &&
          (text[offset - 1] === '<' || text.slice(offset - 2, offset) === '</')
        ) {
          return 'jsxIdentifier';
        }
        if (token.value[0] !== token.value[0].toLowerCase()) {
          return 'capitalized';
        }
      }
      if (token.type === 'punctuator' && BRACKET.test(token.value)) {
        return 'bracket';
      }
      if (
        token.type === 'invalid' &&
        (token.value === '@' || token.value === '#')
      ) {
        return 'punctuator';
      }
      return token.type;
    };
    tokenize = function* (text) {
      let match;
      while ((match = _jsTokens.default.exec(text))) {
        const token = _jsTokens.matchToToken(match);
        yield {
          type: getTokenType(token, match.index, text),
          value: token.value,
        };
      }
    };
  }
  function highlightTokens(defs, text) {
    let highlighted = '';
    for (const {type: type, value: value} of tokenize(text)) {
      const colorize = defs[type];
      if (colorize) {
        highlighted += value
          .split(NEWLINE)
          .map(str => colorize(str))
          .join('\n');
      } else {
        highlighted += value;
      }
    }
    return highlighted;
  }
  function shouldHighlight(options) {
    return colors.isColorSupported || options.forceColor;
  }
  let pcWithForcedColor = undefined;
  function getColors(forceColor) {
    if (forceColor) {
      var _pcWithForcedColor;
      (_pcWithForcedColor = pcWithForcedColor) != null
        ? _pcWithForcedColor
        : (pcWithForcedColor = (0, _picocolors.createColors)(true));
      return pcWithForcedColor;
    }
    return colors;
  }
  function highlight(code, options = {}) {
    if (code !== '' && shouldHighlight(options)) {
      const defs = getDefs(getColors(options.forceColor));
      return highlightTokens(defs, code);
    } else {
      return code;
    }
  }
  {
    let chalk, chalkWithForcedColor;
    lib$8.getChalk = ({forceColor: forceColor}) => {
      var _chalk;
      (_chalk = chalk) != null ? _chalk : (chalk = requireChalk());
      if (forceColor) {
        var _chalkWithForcedColor;
        (_chalkWithForcedColor = chalkWithForcedColor) != null
          ? _chalkWithForcedColor
          : (chalkWithForcedColor = new chalk.constructor({
              enabled: true,
              level: 1,
            }));
        return chalkWithForcedColor;
      }
      return chalk;
    };
  }
  return lib$8;
}
var hasRequiredLib$7;
function requireLib$7() {
  if (hasRequiredLib$7) return lib$9;
  hasRequiredLib$7 = 1;
  Object.defineProperty(lib$9, '__esModule', {value: true});
  lib$9.codeFrameColumns = codeFrameColumns;
  lib$9.default = _default;
  var _highlight = requireLib$8();
  var _picocolors = _interopRequireWildcard(requirePicocolors(), true);
  function _getRequireWildcardCache(e) {
    if ('function' != typeof WeakMap) return null;
    var r = new WeakMap(),
      t = new WeakMap();
    return (_getRequireWildcardCache = function (e) {
      return e ? t : r;
    })(e);
  }
  function _interopRequireWildcard(e, r) {
    if (null === e || ('object' != typeof e && 'function' != typeof e))
      return {default: e};
    var t = _getRequireWildcardCache(r);
    if (t && t.has(e)) return t.get(e);
    var n = {__proto__: null},
      a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e)
      if ('default' !== u && {}.hasOwnProperty.call(e, u)) {
        var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
        i && (i.get || i.set) ? Object.defineProperty(n, u, i) : (n[u] = e[u]);
      }
    return (n.default = e), t && t.set(e, n), n;
  }
  const colors =
    typeof process === 'object' &&
    (process.env.FORCE_COLOR === '0' || process.env.FORCE_COLOR === 'false')
      ? (0, _picocolors.createColors)(false)
      : _picocolors.default;
  const compose = (f, g) => v => f(g(v));
  let pcWithForcedColor = undefined;
  function getColors(forceColor) {
    if (forceColor) {
      var _pcWithForcedColor;
      (_pcWithForcedColor = pcWithForcedColor) != null
        ? _pcWithForcedColor
        : (pcWithForcedColor = (0, _picocolors.createColors)(true));
      return pcWithForcedColor;
    }
    return colors;
  }
  let deprecationWarningShown = false;
  function getDefs(colors) {
    return {
      gutter: colors.gray,
      marker: compose(colors.red, colors.bold),
      message: compose(colors.red, colors.bold),
    };
  }
  const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  function getMarkerLines(loc, source, opts) {
    const startLoc = Object.assign({column: 0, line: -1}, loc.start);
    const endLoc = Object.assign({}, startLoc, loc.end);
    const {linesAbove: linesAbove = 2, linesBelow: linesBelow = 3} = opts || {};
    const startLine = startLoc.line;
    const startColumn = startLoc.column;
    const endLine = endLoc.line;
    const endColumn = endLoc.column;
    let start = Math.max(startLine - (linesAbove + 1), 0);
    let end = Math.min(source.length, endLine + linesBelow);
    if (startLine === -1) {
      start = 0;
    }
    if (endLine === -1) {
      end = source.length;
    }
    const lineDiff = endLine - startLine;
    const markerLines = {};
    if (lineDiff) {
      for (let i = 0; i <= lineDiff; i++) {
        const lineNumber = i + startLine;
        if (!startColumn) {
          markerLines[lineNumber] = true;
        } else if (i === 0) {
          const sourceLength = source[lineNumber - 1].length;
          markerLines[lineNumber] = [
            startColumn,
            sourceLength - startColumn + 1,
          ];
        } else if (i === lineDiff) {
          markerLines[lineNumber] = [0, endColumn];
        } else {
          const sourceLength = source[lineNumber - i].length;
          markerLines[lineNumber] = [0, sourceLength];
        }
      }
    } else {
      if (startColumn === endColumn) {
        if (startColumn) {
          markerLines[startLine] = [startColumn, 0];
        } else {
          markerLines[startLine] = true;
        }
      } else {
        markerLines[startLine] = [startColumn, endColumn - startColumn];
      }
    }
    return {start: start, end: end, markerLines: markerLines};
  }
  function codeFrameColumns(rawLines, loc, opts = {}) {
    const highlighted =
      (opts.highlightCode || opts.forceColor) &&
      (0, _highlight.shouldHighlight)(opts);
    const colors = getColors(opts.forceColor);
    const defs = getDefs(colors);
    const maybeHighlight = (fmt, string) =>
      highlighted ? fmt(string) : string;
    const lines = rawLines.split(NEWLINE);
    const {
      start: start,
      end: end,
      markerLines: markerLines,
    } = getMarkerLines(loc, lines, opts);
    const hasColumns = loc.start && typeof loc.start.column === 'number';
    const numberMaxWidth = String(end).length;
    const highlightedLines = highlighted
      ? (0, _highlight.default)(rawLines, opts)
      : rawLines;
    let frame = highlightedLines
      .split(NEWLINE, end)
      .slice(start, end)
      .map((line, index) => {
        const number = start + 1 + index;
        const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
        const gutter = ` ${paddedNumber} |`;
        const hasMarker = markerLines[number];
        const lastMarkerLine = !markerLines[number + 1];
        if (hasMarker) {
          let markerLine = '';
          if (Array.isArray(hasMarker)) {
            const markerSpacing = line
              .slice(0, Math.max(hasMarker[0] - 1, 0))
              .replace(/[^\t]/g, ' ');
            const numberOfMarkers = hasMarker[1] || 1;
            markerLine = [
              '\n ',
              maybeHighlight(defs.gutter, gutter.replace(/\d/g, ' ')),
              ' ',
              markerSpacing,
              maybeHighlight(defs.marker, '^').repeat(numberOfMarkers),
            ].join('');
            if (lastMarkerLine && opts.message) {
              markerLine += ' ' + maybeHighlight(defs.message, opts.message);
            }
          }
          return [
            maybeHighlight(defs.marker, '>'),
            maybeHighlight(defs.gutter, gutter),
            line.length > 0 ? ` ${line}` : '',
            markerLine,
          ].join('');
        } else {
          return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ''}`;
        }
      })
      .join('\n');
    if (opts.message && !hasColumns) {
      frame = `${' '.repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
    }
    if (highlighted) {
      return colors.reset(frame);
    } else {
      return frame;
    }
  }
  function _default(rawLines, lineNumber, colNumber, opts = {}) {
    if (!deprecationWarningShown) {
      deprecationWarningShown = true;
      const message =
        'Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.';
      if (process.emitWarning) {
        process.emitWarning(message, 'DeprecationWarning');
      } else {
        const deprecationError = new Error(message);
        deprecationError.name = 'DeprecationWarning';
        console.warn(new Error(message));
      }
    }
    colNumber = Math.max(colNumber, 0);
    const location = {start: {column: colNumber, line: lineNumber}};
    return codeFrameColumns(rawLines, location, opts);
  }
  return lib$9;
}
var lib$6 = {};
var hasRequiredLib$6;
function requireLib$6() {
  if (hasRequiredLib$6) return lib$6;
  hasRequiredLib$6 = 1;
  Object.defineProperty(lib$6, '__esModule', {value: true});
  const defaultOptions = {
    sourceType: 'script',
    sourceFilename: undefined,
    startColumn: 0,
    startLine: 1,
    allowAwaitOutsideFunction: false,
    allowReturnOutsideFunction: false,
    allowNewTargetOutsideFunction: false,
    allowImportExportEverywhere: false,
    allowSuperOutsideMethod: false,
    allowUndeclaredExports: false,
    plugins: [],
    strictMode: null,
    ranges: false,
    tokens: false,
    createParenthesizedExpressions: false,
    errorRecovery: false,
    attachComment: true,
    annexB: true,
  };
  function getOptions(opts) {
    if (opts && opts.annexB != null && opts.annexB !== false) {
      throw new Error('The `annexB` option can only be set to `false`.');
    }
    const options = {};
    for (const key of Object.keys(defaultOptions)) {
      options[key] =
        opts && opts[key] != null ? opts[key] : defaultOptions[key];
    }
    return options;
  }
  class TokContext {
    constructor(token, preserveSpace) {
      this.token = void 0;
      this.preserveSpace = void 0;
      this.token = token;
      this.preserveSpace = !!preserveSpace;
    }
  }
  const types = {
    brace: new TokContext('{'),
    j_oTag: new TokContext('<tag'),
    j_cTag: new TokContext('</tag'),
    j_expr: new TokContext('<tag>...</tag>', true),
  };
  {
    types.template = new TokContext('`', true);
  }
  const beforeExpr = true;
  const startsExpr = true;
  const isLoop = true;
  const isAssign = true;
  const prefix = true;
  const postfix = true;
  class ExportedTokenType {
    constructor(label, conf = {}) {
      this.label = void 0;
      this.keyword = void 0;
      this.beforeExpr = void 0;
      this.startsExpr = void 0;
      this.rightAssociative = void 0;
      this.isLoop = void 0;
      this.isAssign = void 0;
      this.prefix = void 0;
      this.postfix = void 0;
      this.binop = void 0;
      this.label = label;
      this.keyword = conf.keyword;
      this.beforeExpr = !!conf.beforeExpr;
      this.startsExpr = !!conf.startsExpr;
      this.rightAssociative = !!conf.rightAssociative;
      this.isLoop = !!conf.isLoop;
      this.isAssign = !!conf.isAssign;
      this.prefix = !!conf.prefix;
      this.postfix = !!conf.postfix;
      this.binop = conf.binop != null ? conf.binop : null;
      {
        this.updateContext = null;
      }
    }
  }
  const keywords$1 = new Map();
  function createKeyword(name, options = {}) {
    options.keyword = name;
    const token = createToken(name, options);
    keywords$1.set(name, token);
    return token;
  }
  function createBinop(name, binop) {
    return createToken(name, {beforeExpr: beforeExpr, binop: binop});
  }
  let tokenTypeCounter = -1;
  const tokenTypes = [];
  const tokenLabels = [];
  const tokenBinops = [];
  const tokenBeforeExprs = [];
  const tokenStartsExprs = [];
  const tokenPrefixes = [];
  function createToken(name, options = {}) {
    var _options$binop,
      _options$beforeExpr,
      _options$startsExpr,
      _options$prefix;
    ++tokenTypeCounter;
    tokenLabels.push(name);
    tokenBinops.push(
      (_options$binop = options.binop) != null ? _options$binop : -1
    );
    tokenBeforeExprs.push(
      (_options$beforeExpr = options.beforeExpr) != null
        ? _options$beforeExpr
        : false
    );
    tokenStartsExprs.push(
      (_options$startsExpr = options.startsExpr) != null
        ? _options$startsExpr
        : false
    );
    tokenPrefixes.push(
      (_options$prefix = options.prefix) != null ? _options$prefix : false
    );
    tokenTypes.push(new ExportedTokenType(name, options));
    return tokenTypeCounter;
  }
  function createKeywordLike(name, options = {}) {
    var _options$binop2,
      _options$beforeExpr2,
      _options$startsExpr2,
      _options$prefix2;
    ++tokenTypeCounter;
    keywords$1.set(name, tokenTypeCounter);
    tokenLabels.push(name);
    tokenBinops.push(
      (_options$binop2 = options.binop) != null ? _options$binop2 : -1
    );
    tokenBeforeExprs.push(
      (_options$beforeExpr2 = options.beforeExpr) != null
        ? _options$beforeExpr2
        : false
    );
    tokenStartsExprs.push(
      (_options$startsExpr2 = options.startsExpr) != null
        ? _options$startsExpr2
        : false
    );
    tokenPrefixes.push(
      (_options$prefix2 = options.prefix) != null ? _options$prefix2 : false
    );
    tokenTypes.push(new ExportedTokenType('name', options));
    return tokenTypeCounter;
  }
  const tt = {
    bracketL: createToken('[', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketHashL: createToken('#[', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketBarL: createToken('[|', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketR: createToken(']'),
    bracketBarR: createToken('|]'),
    braceL: createToken('{', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
    braceBarL: createToken('{|', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    braceHashL: createToken('#{', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    braceR: createToken('}'),
    braceBarR: createToken('|}'),
    parenL: createToken('(', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
    parenR: createToken(')'),
    comma: createToken(',', {beforeExpr: beforeExpr}),
    semi: createToken(';', {beforeExpr: beforeExpr}),
    colon: createToken(':', {beforeExpr: beforeExpr}),
    doubleColon: createToken('::', {beforeExpr: beforeExpr}),
    dot: createToken('.'),
    question: createToken('?', {beforeExpr: beforeExpr}),
    questionDot: createToken('?.'),
    arrow: createToken('=>', {beforeExpr: beforeExpr}),
    template: createToken('template'),
    ellipsis: createToken('...', {beforeExpr: beforeExpr}),
    backQuote: createToken('`', {startsExpr: startsExpr}),
    dollarBraceL: createToken('${', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    templateTail: createToken('...`', {startsExpr: startsExpr}),
    templateNonTail: createToken('...${', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    at: createToken('@'),
    hash: createToken('#', {startsExpr: startsExpr}),
    interpreterDirective: createToken('#!...'),
    eq: createToken('=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    assign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    slashAssign: createToken('_=', {
      beforeExpr: beforeExpr,
      isAssign: isAssign,
    }),
    xorAssign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    moduloAssign: createToken('_=', {
      beforeExpr: beforeExpr,
      isAssign: isAssign,
    }),
    incDec: createToken('++/--', {
      prefix: prefix,
      postfix: postfix,
      startsExpr: startsExpr,
    }),
    bang: createToken('!', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    tilde: createToken('~', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    doubleCaret: createToken('^^', {startsExpr: startsExpr}),
    doubleAt: createToken('@@', {startsExpr: startsExpr}),
    pipeline: createBinop('|>', 0),
    nullishCoalescing: createBinop('??', 1),
    logicalOR: createBinop('||', 1),
    logicalAND: createBinop('&&', 2),
    bitwiseOR: createBinop('|', 3),
    bitwiseXOR: createBinop('^', 4),
    bitwiseAND: createBinop('&', 5),
    equality: createBinop('==/!=/===/!==', 6),
    lt: createBinop('</>/<=/>=', 7),
    gt: createBinop('</>/<=/>=', 7),
    relational: createBinop('</>/<=/>=', 7),
    bitShift: createBinop('<</>>/>>>', 8),
    bitShiftL: createBinop('<</>>/>>>', 8),
    bitShiftR: createBinop('<</>>/>>>', 8),
    plusMin: createToken('+/-', {
      beforeExpr: beforeExpr,
      binop: 9,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    modulo: createToken('%', {binop: 10, startsExpr: startsExpr}),
    star: createToken('*', {binop: 10}),
    slash: createBinop('/', 10),
    exponent: createToken('**', {
      beforeExpr: beforeExpr,
      binop: 11,
      rightAssociative: true,
    }),
    _in: createKeyword('in', {beforeExpr: beforeExpr, binop: 7}),
    _instanceof: createKeyword('instanceof', {
      beforeExpr: beforeExpr,
      binop: 7,
    }),
    _break: createKeyword('break'),
    _case: createKeyword('case', {beforeExpr: beforeExpr}),
    _catch: createKeyword('catch'),
    _continue: createKeyword('continue'),
    _debugger: createKeyword('debugger'),
    _default: createKeyword('default', {beforeExpr: beforeExpr}),
    _else: createKeyword('else', {beforeExpr: beforeExpr}),
    _finally: createKeyword('finally'),
    _function: createKeyword('function', {startsExpr: startsExpr}),
    _if: createKeyword('if'),
    _return: createKeyword('return', {beforeExpr: beforeExpr}),
    _switch: createKeyword('switch'),
    _throw: createKeyword('throw', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _try: createKeyword('try'),
    _var: createKeyword('var'),
    _const: createKeyword('const'),
    _with: createKeyword('with'),
    _new: createKeyword('new', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    _this: createKeyword('this', {startsExpr: startsExpr}),
    _super: createKeyword('super', {startsExpr: startsExpr}),
    _class: createKeyword('class', {startsExpr: startsExpr}),
    _extends: createKeyword('extends', {beforeExpr: beforeExpr}),
    _export: createKeyword('export'),
    _import: createKeyword('import', {startsExpr: startsExpr}),
    _null: createKeyword('null', {startsExpr: startsExpr}),
    _true: createKeyword('true', {startsExpr: startsExpr}),
    _false: createKeyword('false', {startsExpr: startsExpr}),
    _typeof: createKeyword('typeof', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _void: createKeyword('void', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _delete: createKeyword('delete', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _do: createKeyword('do', {isLoop: isLoop, beforeExpr: beforeExpr}),
    _for: createKeyword('for', {isLoop: isLoop}),
    _while: createKeyword('while', {isLoop: isLoop}),
    _as: createKeywordLike('as', {startsExpr: startsExpr}),
    _assert: createKeywordLike('assert', {startsExpr: startsExpr}),
    _async: createKeywordLike('async', {startsExpr: startsExpr}),
    _await: createKeywordLike('await', {startsExpr: startsExpr}),
    _from: createKeywordLike('from', {startsExpr: startsExpr}),
    _get: createKeywordLike('get', {startsExpr: startsExpr}),
    _let: createKeywordLike('let', {startsExpr: startsExpr}),
    _meta: createKeywordLike('meta', {startsExpr: startsExpr}),
    _of: createKeywordLike('of', {startsExpr: startsExpr}),
    _sent: createKeywordLike('sent', {startsExpr: startsExpr}),
    _set: createKeywordLike('set', {startsExpr: startsExpr}),
    _static: createKeywordLike('static', {startsExpr: startsExpr}),
    _using: createKeywordLike('using', {startsExpr: startsExpr}),
    _yield: createKeywordLike('yield', {startsExpr: startsExpr}),
    _asserts: createKeywordLike('asserts', {startsExpr: startsExpr}),
    _checks: createKeywordLike('checks', {startsExpr: startsExpr}),
    _exports: createKeywordLike('exports', {startsExpr: startsExpr}),
    _global: createKeywordLike('global', {startsExpr: startsExpr}),
    _implements: createKeywordLike('implements', {startsExpr: startsExpr}),
    _intrinsic: createKeywordLike('intrinsic', {startsExpr: startsExpr}),
    _infer: createKeywordLike('infer', {startsExpr: startsExpr}),
    _is: createKeywordLike('is', {startsExpr: startsExpr}),
    _mixins: createKeywordLike('mixins', {startsExpr: startsExpr}),
    _proto: createKeywordLike('proto', {startsExpr: startsExpr}),
    _require: createKeywordLike('require', {startsExpr: startsExpr}),
    _satisfies: createKeywordLike('satisfies', {startsExpr: startsExpr}),
    _keyof: createKeywordLike('keyof', {startsExpr: startsExpr}),
    _readonly: createKeywordLike('readonly', {startsExpr: startsExpr}),
    _unique: createKeywordLike('unique', {startsExpr: startsExpr}),
    _abstract: createKeywordLike('abstract', {startsExpr: startsExpr}),
    _declare: createKeywordLike('declare', {startsExpr: startsExpr}),
    _enum: createKeywordLike('enum', {startsExpr: startsExpr}),
    _module: createKeywordLike('module', {startsExpr: startsExpr}),
    _namespace: createKeywordLike('namespace', {startsExpr: startsExpr}),
    _interface: createKeywordLike('interface', {startsExpr: startsExpr}),
    _type: createKeywordLike('type', {startsExpr: startsExpr}),
    _opaque: createKeywordLike('opaque', {startsExpr: startsExpr}),
    name: createToken('name', {startsExpr: startsExpr}),
    string: createToken('string', {startsExpr: startsExpr}),
    num: createToken('num', {startsExpr: startsExpr}),
    bigint: createToken('bigint', {startsExpr: startsExpr}),
    decimal: createToken('decimal', {startsExpr: startsExpr}),
    regexp: createToken('regexp', {startsExpr: startsExpr}),
    privateName: createToken('#name', {startsExpr: startsExpr}),
    eof: createToken('eof'),
    jsxName: createToken('jsxName'),
    jsxText: createToken('jsxText', {beforeExpr: true}),
    jsxTagStart: createToken('jsxTagStart', {startsExpr: true}),
    jsxTagEnd: createToken('jsxTagEnd'),
    placeholder: createToken('%%', {startsExpr: true}),
  };
  function tokenIsIdentifier(token) {
    return token >= 93 && token <= 130;
  }
  function tokenKeywordOrIdentifierIsKeyword(token) {
    return token <= 92;
  }
  function tokenIsKeywordOrIdentifier(token) {
    return token >= 58 && token <= 130;
  }
  function tokenIsLiteralPropertyName(token) {
    return token >= 58 && token <= 134;
  }
  function tokenComesBeforeExpression(token) {
    return tokenBeforeExprs[token];
  }
  function tokenCanStartExpression(token) {
    return tokenStartsExprs[token];
  }
  function tokenIsAssignment(token) {
    return token >= 29 && token <= 33;
  }
  function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
    return token >= 127 && token <= 129;
  }
  function tokenIsLoop(token) {
    return token >= 90 && token <= 92;
  }
  function tokenIsKeyword(token) {
    return token >= 58 && token <= 92;
  }
  function tokenIsOperator(token) {
    return token >= 39 && token <= 59;
  }
  function tokenIsPostfix(token) {
    return token === 34;
  }
  function tokenIsPrefix(token) {
    return tokenPrefixes[token];
  }
  function tokenIsTSTypeOperator(token) {
    return token >= 119 && token <= 121;
  }
  function tokenIsTSDeclarationStart(token) {
    return token >= 122 && token <= 128;
  }
  function tokenLabelName(token) {
    return tokenLabels[token];
  }
  function tokenOperatorPrecedence(token) {
    return tokenBinops[token];
  }
  function tokenIsRightAssociative(token) {
    return token === 57;
  }
  function tokenIsTemplate(token) {
    return token >= 24 && token <= 25;
  }
  function getExportedToken(token) {
    return tokenTypes[token];
  }
  {
    tokenTypes[8].updateContext = context => {
      context.pop();
    };
    tokenTypes[5].updateContext =
      tokenTypes[7].updateContext =
      tokenTypes[23].updateContext =
        context => {
          context.push(types.brace);
        };
    tokenTypes[22].updateContext = context => {
      if (context[context.length - 1] === types.template) {
        context.pop();
      } else {
        context.push(types.template);
      }
    };
    tokenTypes[140].updateContext = context => {
      context.push(types.j_expr, types.j_oTag);
    };
  }
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }
  class Position {
    constructor(line, col, index) {
      this.line = void 0;
      this.column = void 0;
      this.index = void 0;
      this.line = line;
      this.column = col;
      this.index = index;
    }
  }
  class SourceLocation {
    constructor(start, end) {
      this.start = void 0;
      this.end = void 0;
      this.filename = void 0;
      this.identifierName = void 0;
      this.start = start;
      this.end = end;
    }
  }
  function createPositionWithColumnOffset(position, columnOffset) {
    const {line: line, column: column, index: index} = position;
    return new Position(line, column + columnOffset, index + columnOffset);
  }
  var ParseErrorCode = {
    SyntaxError: 'BABEL_PARSER_SYNTAX_ERROR',
    SourceTypeModuleError: 'BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED',
  };
  const reflect = (keys, last = keys.length - 1) => ({
    get() {
      return keys.reduce((object, key) => object[key], this);
    },
    set(value) {
      keys.reduce(
        (item, key, i) => (i === last ? (item[key] = value) : item[key]),
        this
      );
    },
  });
  const instantiate = (constructor, properties, descriptors) =>
    Object.keys(descriptors)
      .map(key => [key, descriptors[key]])
      .filter(([, descriptor]) => !!descriptor)
      .map(([key, descriptor]) => [
        key,
        typeof descriptor === 'function'
          ? {value: descriptor, enumerable: false}
          : typeof descriptor.reflect === 'string'
            ? Object.assign(
                {},
                descriptor,
                reflect(descriptor.reflect.split('.'))
              )
            : descriptor,
      ])
      .reduce(
        (instance, [key, descriptor]) =>
          Object.defineProperty(
            instance,
            key,
            Object.assign({configurable: true}, descriptor)
          ),
        Object.assign(new constructor(), properties)
      );
  var ModuleErrors = {
    ImportMetaOutsideModule: {
      message: `import.meta may appear only with 'sourceType: "module"'`,
      code: ParseErrorCode.SourceTypeModuleError,
    },
    ImportOutsideModule: {
      message: `'import' and 'export' may appear only with 'sourceType: "module"'`,
      code: ParseErrorCode.SourceTypeModuleError,
    },
  };
  const NodeDescriptions = {
    ArrayPattern: 'array destructuring pattern',
    AssignmentExpression: 'assignment expression',
    AssignmentPattern: 'assignment expression',
    ArrowFunctionExpression: 'arrow function expression',
    ConditionalExpression: 'conditional expression',
    CatchClause: 'catch clause',
    ForOfStatement: 'for-of statement',
    ForInStatement: 'for-in statement',
    ForStatement: 'for-loop',
    FormalParameters: 'function parameter list',
    Identifier: 'identifier',
    ImportSpecifier: 'import specifier',
    ImportDefaultSpecifier: 'import default specifier',
    ImportNamespaceSpecifier: 'import namespace specifier',
    ObjectPattern: 'object destructuring pattern',
    ParenthesizedExpression: 'parenthesized expression',
    RestElement: 'rest element',
    UpdateExpression: {true: 'prefix operation', false: 'postfix operation'},
    VariableDeclarator: 'variable declaration',
    YieldExpression: 'yield expression',
  };
  const toNodeDescription = ({type: type, prefix: prefix}) =>
    type === 'UpdateExpression'
      ? NodeDescriptions.UpdateExpression[String(prefix)]
      : NodeDescriptions[type];
  var StandardErrors = {
    AccessorIsGenerator: ({kind: kind}) =>
      `A ${kind}ter cannot be a generator.`,
    ArgumentsInClass:
      "'arguments' is only allowed in functions and class methods.",
    AsyncFunctionInSingleStatementContext:
      'Async functions can only be declared at the top level or inside a block.',
    AwaitBindingIdentifier:
      "Can not use 'await' as identifier inside an async function.",
    AwaitBindingIdentifierInStaticBlock:
      "Can not use 'await' as identifier inside a static block.",
    AwaitExpressionFormalParameter:
      "'await' is not allowed in async function parameters.",
    AwaitInUsingBinding:
      "'await' is not allowed to be used as a name in 'using' declarations.",
    AwaitNotInAsyncContext:
      "'await' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
    BadGetterArity: "A 'get' accessor must not have any formal parameters.",
    BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
    BadSetterRestParameter:
      "A 'set' accessor function argument must not be a rest parameter.",
    ConstructorClassField: "Classes may not have a field named 'constructor'.",
    ConstructorClassPrivateField:
      "Classes may not have a private field named '#constructor'.",
    ConstructorIsAccessor: 'Class constructor may not be an accessor.',
    ConstructorIsAsync: "Constructor can't be an async function.",
    ConstructorIsGenerator: "Constructor can't be a generator.",
    DeclarationMissingInitializer: ({kind: kind}) =>
      `Missing initializer in ${kind} declaration.`,
    DecoratorArgumentsOutsideParentheses:
      "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
    DecoratorBeforeExport:
      "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
    DecoratorsBeforeAfterExport:
      "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
    DecoratorConstructor:
      "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
    DecoratorExportClass:
      "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
    DecoratorSemicolon: 'Decorators must not be followed by a semicolon.',
    DecoratorStaticBlock: "Decorators can't be used with a static block.",
    DeletePrivateField: 'Deleting a private field is not allowed.',
    DestructureNamedImport:
      'ES2015 named imports do not destructure. Use another statement for destructuring after the import.',
    DuplicateConstructor: 'Duplicate constructor in the same class.',
    DuplicateDefaultExport: 'Only one default export allowed per module.',
    DuplicateExport: ({exportName: exportName}) =>
      `\`${exportName}\` has already been exported. Exported identifiers must be unique.`,
    DuplicateProto: 'Redefinition of __proto__ property.',
    DuplicateRegExpFlags: 'Duplicate regular expression flag.',
    ElementAfterRest: 'Rest element must be last element.',
    EscapedCharNotAnIdentifier: 'Invalid Unicode escape.',
    ExportBindingIsString: ({localName: localName, exportName: exportName}) =>
      `A string literal cannot be used as an exported binding without \`from\`.\n- Did you mean \`export { '${localName}' as '${exportName}' } from 'some-module'\`?`,
    ExportDefaultFromAsIdentifier:
      "'from' is not allowed as an identifier after 'export default'.",
    ForInOfLoopInitializer: ({type: type}) =>
      `'${type === 'ForInStatement' ? 'for-in' : 'for-of'}' loop variable declaration may not have an initializer.`,
    ForInUsing: "For-in loop may not start with 'using' declaration.",
    ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
    ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
    GeneratorInSingleStatementContext:
      'Generators can only be declared at the top level or inside a block.',
    IllegalBreakContinue: ({type: type}) =>
      `Unsyntactic ${type === 'BreakStatement' ? 'break' : 'continue'}.`,
    IllegalLanguageModeDirective:
      "Illegal 'use strict' directive in function with non-simple parameter list.",
    IllegalReturn: "'return' outside of function.",
    ImportBindingIsString: ({importName: importName}) =>
      `A string literal cannot be used as an imported binding.\n- Did you mean \`import { "${importName}" as foo }\`?`,
    ImportCallArgumentTrailingComma:
      'Trailing comma is disallowed inside import(...) arguments.',
    ImportCallArity: ({maxArgumentCount: maxArgumentCount}) =>
      `\`import()\` requires exactly ${maxArgumentCount === 1 ? 'one argument' : 'one or two arguments'}.`,
    ImportCallNotNewExpression: 'Cannot use new with import(...).',
    ImportCallSpreadArgument: '`...` is not allowed in `import()`.',
    ImportJSONBindingNotDefault:
      'A JSON module can only be imported with `default`.',
    ImportReflectionHasAssertion: '`import module x` cannot have assertions.',
    ImportReflectionNotBinding:
      'Only `import module x from "./module"` is valid.',
    IncompatibleRegExpUVFlags:
      "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
    InvalidBigIntLiteral: 'Invalid BigIntLiteral.',
    InvalidCodePoint: 'Code point out of bounds.',
    InvalidCoverInitializedName: 'Invalid shorthand property initializer.',
    InvalidDecimal: 'Invalid decimal.',
    InvalidDigit: ({radix: radix}) => `Expected number in radix ${radix}.`,
    InvalidEscapeSequence: 'Bad character escape sequence.',
    InvalidEscapeSequenceTemplate: 'Invalid escape sequence in template.',
    InvalidEscapedReservedWord: ({reservedWord: reservedWord}) =>
      `Escape sequence in keyword ${reservedWord}.`,
    InvalidIdentifier: ({identifierName: identifierName}) =>
      `Invalid identifier ${identifierName}.`,
    InvalidLhs: ({ancestor: ancestor}) =>
      `Invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsBinding: ({ancestor: ancestor}) =>
      `Binding invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidNumber: 'Invalid number.',
    InvalidOrMissingExponent:
      "Floating-point numbers require a valid exponent after the 'e'.",
    InvalidOrUnexpectedToken: ({unexpected: unexpected}) =>
      `Unexpected character '${unexpected}'.`,
    InvalidParenthesizedAssignment: 'Invalid parenthesized assignment pattern.',
    InvalidPrivateFieldResolution: ({identifierName: identifierName}) =>
      `Private name #${identifierName} is not defined.`,
    InvalidPropertyBindingPattern: 'Binding member expression.',
    InvalidRecordProperty:
      'Only properties and spread elements are allowed in record definitions.',
    InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
    LabelRedeclaration: ({labelName: labelName}) =>
      `Label '${labelName}' is already declared.`,
    LetInLexicalBinding:
      "'let' is not allowed to be used as a name in 'let' or 'const' declarations.",
    LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
    MalformedRegExpFlags: 'Invalid regular expression flag.',
    MissingClassName: 'A class name is required.',
    MissingEqInAssignment:
      "Only '=' operator can be used for specifying default value.",
    MissingSemicolon: 'Missing semicolon.',
    MissingPlugin: ({missingPlugin: missingPlugin}) =>
      `This experimental syntax requires enabling the parser plugin: ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
    MissingOneOfPlugins: ({missingPlugin: missingPlugin}) =>
      `This experimental syntax requires enabling one of the following parser plugin(s): ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
    MissingUnicodeEscape: 'Expecting Unicode escape sequence \\uXXXX.',
    MixingCoalesceWithLogical:
      'Nullish coalescing operator(??) requires parens when mixing with logical operators.',
    ModuleAttributeDifferentFromType:
      'The only accepted module attribute is `type`.',
    ModuleAttributeInvalidValue:
      'Only string literals are allowed as module attribute values.',
    ModuleAttributesWithDuplicateKeys: ({key: key}) =>
      `Duplicate key "${key}" is not allowed in module attributes.`,
    ModuleExportNameHasLoneSurrogate: ({
      surrogateCharCode: surrogateCharCode,
    }) =>
      `An export name cannot include a lone surrogate, found '\\u${surrogateCharCode.toString(16)}'.`,
    ModuleExportUndefined: ({localName: localName}) =>
      `Export '${localName}' is not defined.`,
    MultipleDefaultsInSwitch: 'Multiple default clauses.',
    NewlineAfterThrow: 'Illegal newline after throw.',
    NoCatchOrFinally: 'Missing catch or finally clause.',
    NumberIdentifier: 'Identifier directly after number.',
    NumericSeparatorInEscapeSequence:
      'Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.',
    ObsoleteAwaitStar:
      "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
    OptionalChainingNoNew:
      'Constructors in/after an Optional Chain are not allowed.',
    OptionalChainingNoTemplate:
      'Tagged Template Literals are not allowed in optionalChain.',
    OverrideOnConstructor:
      "'override' modifier cannot appear on a constructor declaration.",
    ParamDupe: 'Argument name clash.',
    PatternHasAccessor: "Object pattern can't contain getter or setter.",
    PatternHasMethod: "Object pattern can't contain methods.",
    PrivateInExpectedIn: ({identifierName: identifierName}) =>
      `Private names are only allowed in property accesses (\`obj.#${identifierName}\`) or in \`in\` expressions (\`#${identifierName} in obj\`).`,
    PrivateNameRedeclaration: ({identifierName: identifierName}) =>
      `Duplicate private name #${identifierName}.`,
    RecordExpressionBarIncorrectEndSyntaxType:
      "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionBarIncorrectStartSyntaxType:
      "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionHashIncorrectStartSyntaxType:
      "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    RecordNoProto: "'__proto__' is not allowed in Record expressions.",
    RestTrailingComma: 'Unexpected trailing comma after rest element.',
    SloppyFunction:
      'In non-strict mode code, functions can only be declared at top level or inside a block.',
    SloppyFunctionAnnexB:
      'In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.',
    StaticPrototype: 'Classes may not have static property named prototype.',
    SuperNotAllowed:
      "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
    SuperPrivateField: "Private fields can't be accessed on super.",
    TrailingDecorator: 'Decorators must be attached to a class element.',
    TupleExpressionBarIncorrectEndSyntaxType:
      "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionBarIncorrectStartSyntaxType:
      "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionHashIncorrectStartSyntaxType:
      "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    UnexpectedArgumentPlaceholder: 'Unexpected argument placeholder.',
    UnexpectedAwaitAfterPipelineBody:
      'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
    UnexpectedDigitAfterHash: 'Unexpected digit after hash token.',
    UnexpectedImportExport:
      "'import' and 'export' may only appear at the top level.",
    UnexpectedKeyword: ({keyword: keyword}) =>
      `Unexpected keyword '${keyword}'.`,
    UnexpectedLeadingDecorator:
      'Leading decorators must be attached to a class declaration.',
    UnexpectedLexicalDeclaration:
      'Lexical declaration cannot appear in a single-statement context.',
    UnexpectedNewTarget:
      '`new.target` can only be used in functions or class properties.',
    UnexpectedNumericSeparator:
      'A numeric separator is only allowed between two digits.',
    UnexpectedPrivateField: 'Unexpected private name.',
    UnexpectedReservedWord: ({reservedWord: reservedWord}) =>
      `Unexpected reserved word '${reservedWord}'.`,
    UnexpectedSuper: "'super' is only allowed in object methods and classes.",
    UnexpectedToken: ({expected: expected, unexpected: unexpected}) =>
      `Unexpected token${unexpected ? ` '${unexpected}'.` : ''}${expected ? `, expected "${expected}"` : ''}`,
    UnexpectedTokenUnaryExponentiation:
      'Illegal expression. Wrap left hand side or entire exponentiation in parentheses.',
    UnexpectedUsingDeclaration:
      'Using declaration cannot appear in the top level when source type is `script`.',
    UnsupportedBind: 'Binding should be performed on object property.',
    UnsupportedDecoratorExport:
      'A decorated export must export a class declaration.',
    UnsupportedDefaultExport:
      'Only expressions, functions or classes are allowed as the `default` export.',
    UnsupportedImport:
      '`import` can only be used in `import()` or `import.meta`.',
    UnsupportedMetaProperty: ({
      target: target,
      onlyValidPropertyName: onlyValidPropertyName,
    }) =>
      `The only valid meta property for ${target} is ${target}.${onlyValidPropertyName}.`,
    UnsupportedParameterDecorator:
      'Decorators cannot be used to decorate parameters.',
    UnsupportedPropertyDecorator:
      'Decorators cannot be used to decorate object literal properties.',
    UnsupportedSuper:
      "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
    UnterminatedComment: 'Unterminated comment.',
    UnterminatedRegExp: 'Unterminated regular expression.',
    UnterminatedString: 'Unterminated string constant.',
    UnterminatedTemplate: 'Unterminated template.',
    UsingDeclarationHasBindingPattern:
      'Using declaration cannot have destructuring patterns.',
    VarRedeclaration: ({identifierName: identifierName}) =>
      `Identifier '${identifierName}' has already been declared.`,
    YieldBindingIdentifier:
      "Can not use 'yield' as identifier inside a generator.",
    YieldInParameter: 'Yield expression is not allowed in formal parameters.',
    ZeroDigitNumericSeparator:
      'Numeric separator can not be used after leading 0.',
  };
  var StrictModeErrors = {
    StrictDelete: 'Deleting local variable in strict mode.',
    StrictEvalArguments: ({referenceName: referenceName}) =>
      `Assigning to '${referenceName}' in strict mode.`,
    StrictEvalArgumentsBinding: ({bindingName: bindingName}) =>
      `Binding '${bindingName}' in strict mode.`,
    StrictFunction:
      'In strict mode code, functions can only be declared at top level or inside a block.',
    StrictNumericEscape:
      "The only valid numeric escape in strict mode is '\\0'.",
    StrictOctalLiteral: 'Legacy octal literals are not allowed in strict mode.',
    StrictWith: "'with' in strict mode.",
  };
  const UnparenthesizedPipeBodyDescriptions = new Set([
    'ArrowFunctionExpression',
    'AssignmentExpression',
    'ConditionalExpression',
    'YieldExpression',
  ]);
  var PipelineOperatorErrors = {
    PipeBodyIsTighter:
      'Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.',
    PipeTopicRequiresHackPipes:
      'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
    PipeTopicUnbound:
      'Topic reference is unbound; it must be inside a pipe body.',
    PipeTopicUnconfiguredToken: ({token: token}) =>
      `Invalid topic token ${token}. In order to use ${token} as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "${token}" }.`,
    PipeTopicUnused:
      'Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.',
    PipeUnparenthesizedBody: ({type: type}) =>
      `Hack-style pipe body cannot be an unparenthesized ${toNodeDescription({type: type})}; please wrap it in parentheses.`,
    PipelineBodyNoArrow:
      'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
    PipelineBodySequenceExpression:
      'Pipeline body may not be a comma-separated sequence expression.',
    PipelineHeadSequenceExpression:
      'Pipeline head should not be a comma-separated sequence expression.',
    PipelineTopicUnused:
      'Pipeline is in topic style but does not use topic reference.',
    PrimaryTopicNotAllowed:
      'Topic reference was used in a lexical context without topic binding.',
    PrimaryTopicRequiresSmartPipeline:
      'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
  };
  const _excluded$1 = ['toMessage'],
    _excluded2$1 = ['message'];
  function toParseErrorConstructor(_ref) {
    let {toMessage: toMessage} = _ref,
      properties = _objectWithoutPropertiesLoose(_ref, _excluded$1);
    return function constructor({loc: loc, details: details}) {
      return instantiate(
        SyntaxError,
        Object.assign({}, properties, {loc: loc}),
        {
          clone(overrides = {}) {
            const loc = overrides.loc || {};
            return constructor({
              loc: new Position(
                'line' in loc ? loc.line : this.loc.line,
                'column' in loc ? loc.column : this.loc.column,
                'index' in loc ? loc.index : this.loc.index
              ),
              details: Object.assign({}, this.details, overrides.details),
            });
          },
          details: {value: details, enumerable: false},
          message: {
            get() {
              return `${toMessage(this.details)} (${this.loc.line}:${this.loc.column})`;
            },
            set(value) {
              Object.defineProperty(this, 'message', {value: value});
            },
          },
          pos: {reflect: 'loc.index', enumerable: true},
          missingPlugin: 'missingPlugin' in details && {
            reflect: 'details.missingPlugin',
            enumerable: true,
          },
        }
      );
    };
  }
  function ParseErrorEnum(argument, syntaxPlugin) {
    if (Array.isArray(argument)) {
      return parseErrorTemplates =>
        ParseErrorEnum(parseErrorTemplates, argument[0]);
    }
    const ParseErrorConstructors = {};
    for (const reasonCode of Object.keys(argument)) {
      const template = argument[reasonCode];
      const _ref2 =
          typeof template === 'string'
            ? {message: () => template}
            : typeof template === 'function'
              ? {message: template}
              : template,
        {message: message} = _ref2,
        rest = _objectWithoutPropertiesLoose(_ref2, _excluded2$1);
      const toMessage = typeof message === 'string' ? () => message : message;
      ParseErrorConstructors[reasonCode] = toParseErrorConstructor(
        Object.assign(
          {
            code: ParseErrorCode.SyntaxError,
            reasonCode: reasonCode,
            toMessage: toMessage,
          },
          syntaxPlugin ? {syntaxPlugin: syntaxPlugin} : {},
          rest
        )
      );
    }
    return ParseErrorConstructors;
  }
  const Errors = Object.assign(
    {},
    ParseErrorEnum(ModuleErrors),
    ParseErrorEnum(StandardErrors),
    ParseErrorEnum(StrictModeErrors),
    ParseErrorEnum`pipelineOperator`(PipelineOperatorErrors)
  );
  const {defineProperty: defineProperty} = Object;
  const toUnenumerable = (object, key) =>
    defineProperty(object, key, {enumerable: false, value: object[key]});
  function toESTreeLocation(node) {
    node.loc.start && toUnenumerable(node.loc.start, 'index');
    node.loc.end && toUnenumerable(node.loc.end, 'index');
    return node;
  }
  var estree = superClass =>
    class ESTreeParserMixin extends superClass {
      parse() {
        const file = toESTreeLocation(super.parse());
        if (this.options.tokens) {
          file.tokens = file.tokens.map(toESTreeLocation);
        }
        return file;
      }
      parseRegExpLiteral({pattern: pattern, flags: flags}) {
        let regex = null;
        try {
          regex = new RegExp(pattern, flags);
        } catch (e) {}
        const node = this.estreeParseLiteral(regex);
        node.regex = {pattern: pattern, flags: flags};
        return node;
      }
      parseBigIntLiteral(value) {
        let bigInt;
        try {
          bigInt = BigInt(value);
        } catch (_unused) {
          bigInt = null;
        }
        const node = this.estreeParseLiteral(bigInt);
        node.bigint = String(node.value || value);
        return node;
      }
      parseDecimalLiteral(value) {
        const decimal = null;
        const node = this.estreeParseLiteral(decimal);
        node.decimal = String(node.value || value);
        return node;
      }
      estreeParseLiteral(value) {
        return this.parseLiteral(value, 'Literal');
      }
      parseStringLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      parseNumericLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      parseNullLiteral() {
        return this.estreeParseLiteral(null);
      }
      parseBooleanLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      directiveToStmt(directive) {
        const expression = directive.value;
        delete directive.value;
        expression.type = 'Literal';
        expression.raw = expression.extra.raw;
        expression.value = expression.extra.expressionValue;
        const stmt = directive;
        stmt.type = 'ExpressionStatement';
        stmt.expression = expression;
        stmt.directive = expression.extra.rawValue;
        delete expression.extra;
        return stmt;
      }
      initFunction(node, isAsync) {
        super.initFunction(node, isAsync);
        node.expression = false;
      }
      checkDeclaration(node) {
        if (node != null && this.isObjectProperty(node)) {
          this.checkDeclaration(node.value);
        } else {
          super.checkDeclaration(node);
        }
      }
      getObjectOrClassMethodParams(method) {
        return method.value.params;
      }
      isValidDirective(stmt) {
        var _stmt$expression$extr;
        return (
          stmt.type === 'ExpressionStatement' &&
          stmt.expression.type === 'Literal' &&
          typeof stmt.expression.value === 'string' &&
          !(
            (_stmt$expression$extr = stmt.expression.extra) != null &&
            _stmt$expression$extr.parenthesized
          )
        );
      }
      parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
        super.parseBlockBody(
          node,
          allowDirectives,
          topLevel,
          end,
          afterBlockParse
        );
        const directiveStatements = node.directives.map(d =>
          this.directiveToStmt(d)
        );
        node.body = directiveStatements.concat(node.body);
        delete node.directives;
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        this.parseMethod(
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper,
          'ClassMethod',
          true
        );
        if (method.typeParameters) {
          method.value.typeParameters = method.typeParameters;
          delete method.typeParameters;
        }
        classBody.body.push(method);
      }
      parsePrivateName() {
        const node = super.parsePrivateName();
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return node;
          }
        }
        return this.convertPrivateNameToPrivateIdentifier(node);
      }
      convertPrivateNameToPrivateIdentifier(node) {
        const name = super.getPrivateNameSV(node);
        node = node;
        delete node.id;
        node.name = name;
        node.type = 'PrivateIdentifier';
        return node;
      }
      isPrivateName(node) {
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return super.isPrivateName(node);
          }
        }
        return node.type === 'PrivateIdentifier';
      }
      getPrivateNameSV(node) {
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return super.getPrivateNameSV(node);
          }
        }
        return node.name;
      }
      parseLiteral(value, type) {
        const node = super.parseLiteral(value, type);
        node.raw = node.extra.raw;
        delete node.extra;
        return node;
      }
      parseFunctionBody(node, allowExpression, isMethod = false) {
        super.parseFunctionBody(node, allowExpression, isMethod);
        node.expression = node.body.type !== 'BlockStatement';
      }
      parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope = false
      ) {
        let funcNode = this.startNode();
        funcNode.kind = node.kind;
        funcNode = super.parseMethod(
          funcNode,
          isGenerator,
          isAsync,
          isConstructor,
          allowDirectSuper,
          type,
          inClassScope
        );
        funcNode.type = 'FunctionExpression';
        delete funcNode.kind;
        node.value = funcNode;
        if (type === 'ClassPrivateMethod') {
          node.computed = false;
        }
        return this.finishNode(node, 'MethodDefinition');
      }
      parseClassProperty(...args) {
        const propertyNode = super.parseClassProperty(...args);
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return propertyNode;
          }
        }
        propertyNode.type = 'PropertyDefinition';
        return propertyNode;
      }
      parseClassPrivateProperty(...args) {
        const propertyNode = super.parseClassPrivateProperty(...args);
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return propertyNode;
          }
        }
        propertyNode.type = 'PropertyDefinition';
        propertyNode.computed = false;
        return propertyNode;
      }
      parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
        const node = super.parseObjectMethod(
          prop,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor
        );
        if (node) {
          node.type = 'Property';
          if (node.kind === 'method') {
            node.kind = 'init';
          }
          node.shorthand = false;
        }
        return node;
      }
      parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
        const node = super.parseObjectProperty(
          prop,
          startLoc,
          isPattern,
          refExpressionErrors
        );
        if (node) {
          node.kind = 'init';
          node.type = 'Property';
        }
        return node;
      }
      isValidLVal(type, isUnparenthesizedInAssign, binding) {
        return type === 'Property'
          ? 'value'
          : super.isValidLVal(type, isUnparenthesizedInAssign, binding);
      }
      isAssignable(node, isBinding) {
        if (node != null && this.isObjectProperty(node)) {
          return this.isAssignable(node.value, isBinding);
        }
        return super.isAssignable(node, isBinding);
      }
      toAssignable(node, isLHS = false) {
        if (node != null && this.isObjectProperty(node)) {
          const {key: key, value: value} = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(
              this.getPrivateNameSV(key),
              key.loc.start
            );
          }
          this.toAssignable(value, isLHS);
        } else {
          super.toAssignable(node, isLHS);
        }
      }
      toAssignableObjectExpressionProp(prop, isLast, isLHS) {
        if (prop.kind === 'get' || prop.kind === 'set') {
          this.raise(Errors.PatternHasAccessor, {at: prop.key});
        } else if (prop.method) {
          this.raise(Errors.PatternHasMethod, {at: prop.key});
        } else {
          super.toAssignableObjectExpressionProp(prop, isLast, isLHS);
        }
      }
      finishCallExpression(unfinished, optional) {
        const node = super.finishCallExpression(unfinished, optional);
        if (node.callee.type === 'Import') {
          node.type = 'ImportExpression';
          node.source = node.arguments[0];
          if (this.hasPlugin('importAssertions')) {
            var _node$arguments$;
            node.attributes =
              (_node$arguments$ = node.arguments[1]) != null
                ? _node$arguments$
                : null;
          }
          delete node.arguments;
          delete node.callee;
        }
        return node;
      }
      toReferencedArguments(node) {
        if (node.type === 'ImportExpression') {
          return;
        }
        super.toReferencedArguments(node);
      }
      parseExport(unfinished, decorators) {
        const exportStartLoc = this.state.lastTokStartLoc;
        const node = super.parseExport(unfinished, decorators);
        switch (node.type) {
          case 'ExportAllDeclaration':
            node.exported = null;
            break;
          case 'ExportNamedDeclaration':
            if (
              node.specifiers.length === 1 &&
              node.specifiers[0].type === 'ExportNamespaceSpecifier'
            ) {
              node.type = 'ExportAllDeclaration';
              node.exported = node.specifiers[0].exported;
              delete node.specifiers;
            }
          case 'ExportDefaultDeclaration':
            {
              var _declaration$decorato;
              const {declaration: declaration} = node;
              if (
                (declaration == null ? void 0 : declaration.type) ===
                  'ClassDeclaration' &&
                ((_declaration$decorato = declaration.decorators) == null
                  ? void 0
                  : _declaration$decorato.length) > 0 &&
                declaration.start === node.start
              ) {
                this.resetStartLocation(node, exportStartLoc);
              }
            }
            break;
        }
        return node;
      }
      parseSubscript(base, startLoc, noCalls, state) {
        const node = super.parseSubscript(base, startLoc, noCalls, state);
        if (state.optionalChainMember) {
          if (
            node.type === 'OptionalMemberExpression' ||
            node.type === 'OptionalCallExpression'
          ) {
            node.type = node.type.substring(8);
          }
          if (state.stop) {
            const chain = this.startNodeAtNode(node);
            chain.expression = node;
            return this.finishNode(chain, 'ChainExpression');
          }
        } else if (
          node.type === 'MemberExpression' ||
          node.type === 'CallExpression'
        ) {
          node.optional = false;
        }
        return node;
      }
      hasPropertyAsPrivateName(node) {
        if (node.type === 'ChainExpression') {
          node = node.expression;
        }
        return super.hasPropertyAsPrivateName(node);
      }
      isObjectProperty(node) {
        return node.type === 'Property' && node.kind === 'init' && !node.method;
      }
      isObjectMethod(node) {
        return node.method || node.kind === 'get' || node.kind === 'set';
      }
      finishNodeAt(node, type, endLoc) {
        return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
      }
      resetStartLocation(node, startLoc) {
        super.resetStartLocation(node, startLoc);
        toESTreeLocation(node);
      }
      resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
        super.resetEndLocation(node, endLoc);
        toESTreeLocation(node);
      }
    };
  let nonASCIIidentifierStartChars =
    'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
  let nonASCIIidentifierChars =
    '‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿';
  const nonASCIIidentifierStart = new RegExp(
    '[' + nonASCIIidentifierStartChars + ']'
  );
  const nonASCIIidentifier = new RegExp(
    '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
  );
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  const astralIdentifierStartCodes = [
    0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48,
    48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5,
    39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10,
    21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11,
    22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2,
    2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72,
    56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20,
    28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4,
    0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2,
    14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4,
    159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0,
    60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2,
    23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12,
    45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0,
    26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921,
    103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30,
    18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67,
    12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16,
    0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2,
    70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2,
    27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2,
    24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11,
    6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60,
    67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5,
    0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0,
    3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719,
    33, 4153, 7, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938, 6, 4191,
  ];
  const astralIdentifierCodes = [
    509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1,
    574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1,
    11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13,
    9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3,
    2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3,
    8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5,
    2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0,
    10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2,
    6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4,
    14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54,
    8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31,
    3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2,
    16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983,
    6, 110, 6, 6, 9, 4759, 9, 787719, 239,
  ];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length; i < length; i += 2) {
      pos += set[i];
      if (pos > code) return false;
      pos += set[i + 1];
      if (pos >= code) return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65) return code === 36;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return (
        code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
      );
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48) return code === 36;
    if (code < 58) return true;
    if (code < 65) return false;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return (
      isInAstralSet(code, astralIdentifierStartCodes) ||
      isInAstralSet(code, astralIdentifierCodes)
    );
  }
  const reservedWords = {
    keyword: [
      'break',
      'case',
      'catch',
      'continue',
      'debugger',
      'default',
      'do',
      'else',
      'finally',
      'for',
      'function',
      'if',
      'return',
      'switch',
      'throw',
      'try',
      'var',
      'const',
      'while',
      'with',
      'new',
      'this',
      'super',
      'class',
      'extends',
      'export',
      'import',
      'null',
      'true',
      'false',
      'in',
      'instanceof',
      'typeof',
      'void',
      'delete',
    ],
    strict: [
      'implements',
      'interface',
      'let',
      'package',
      'private',
      'protected',
      'public',
      'static',
      'yield',
    ],
    strictBind: ['eval', 'arguments'],
  };
  const keywords = new Set(reservedWords.keyword);
  const reservedWordsStrictSet = new Set(reservedWords.strict);
  const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return (inModule && word === 'await') || word === 'enum';
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return (
      isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
    );
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  function isIteratorStart(current, next, next2) {
    return current === 64 && next === 64 && isIdentifierStart(next2);
  }
  const reservedWordLikeSet = new Set([
    'break',
    'case',
    'catch',
    'continue',
    'debugger',
    'default',
    'do',
    'else',
    'finally',
    'for',
    'function',
    'if',
    'return',
    'switch',
    'throw',
    'try',
    'var',
    'const',
    'while',
    'with',
    'new',
    'this',
    'super',
    'class',
    'extends',
    'export',
    'import',
    'null',
    'true',
    'false',
    'in',
    'instanceof',
    'typeof',
    'void',
    'delete',
    'implements',
    'interface',
    'let',
    'package',
    'private',
    'protected',
    'public',
    'static',
    'yield',
    'eval',
    'arguments',
    'enum',
    'await',
  ]);
  function canBeReservedWord(word) {
    return reservedWordLikeSet.has(word);
  }
  const SCOPE_OTHER = 0,
    SCOPE_PROGRAM = 1,
    SCOPE_FUNCTION = 2,
    SCOPE_ARROW = 4,
    SCOPE_SIMPLE_CATCH = 8,
    SCOPE_SUPER = 16,
    SCOPE_DIRECT_SUPER = 32,
    SCOPE_CLASS = 64,
    SCOPE_STATIC_BLOCK = 128,
    SCOPE_TS_MODULE = 256,
    SCOPE_VAR =
      SCOPE_PROGRAM | SCOPE_FUNCTION | SCOPE_STATIC_BLOCK | SCOPE_TS_MODULE;
  const BIND_KIND_VALUE = 1,
    BIND_KIND_TYPE = 2,
    BIND_SCOPE_VAR = 4,
    BIND_SCOPE_LEXICAL = 8,
    BIND_SCOPE_FUNCTION = 16,
    BIND_FLAGS_NONE = 64,
    BIND_FLAGS_CLASS = 128,
    BIND_FLAGS_TS_ENUM = 256,
    BIND_FLAGS_TS_CONST_ENUM = 512,
    BIND_FLAGS_TS_EXPORT_ONLY = 1024,
    BIND_FLAGS_FLOW_DECLARE_FN = 2048,
    BIND_FLAGS_TS_IMPORT = 4096,
    BIND_FLAGS_NO_LET_IN_LEXICAL = 8192;
  const BIND_CLASS =
      BIND_KIND_VALUE |
      BIND_KIND_TYPE |
      BIND_SCOPE_LEXICAL |
      BIND_FLAGS_CLASS |
      BIND_FLAGS_NO_LET_IN_LEXICAL,
    BIND_LEXICAL =
      BIND_KIND_VALUE | 0 | BIND_SCOPE_LEXICAL | BIND_FLAGS_NO_LET_IN_LEXICAL,
    BIND_CATCH_PARAM = BIND_KIND_VALUE | 0 | BIND_SCOPE_LEXICAL | 0,
    BIND_VAR = BIND_KIND_VALUE | 0 | BIND_SCOPE_VAR | 0,
    BIND_FUNCTION = BIND_KIND_VALUE | 0 | BIND_SCOPE_FUNCTION | 0,
    BIND_TS_INTERFACE = 0 | BIND_KIND_TYPE | 0 | BIND_FLAGS_CLASS,
    BIND_TS_TYPE = 0 | BIND_KIND_TYPE | 0 | 0,
    BIND_TS_ENUM =
      BIND_KIND_VALUE |
      BIND_KIND_TYPE |
      BIND_SCOPE_LEXICAL |
      BIND_FLAGS_TS_ENUM |
      BIND_FLAGS_NO_LET_IN_LEXICAL,
    BIND_TS_AMBIENT = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY,
    BIND_NONE = 0 | 0 | 0 | BIND_FLAGS_NONE,
    BIND_OUTSIDE = BIND_KIND_VALUE | 0 | 0 | BIND_FLAGS_NONE,
    BIND_TS_CONST_ENUM = BIND_TS_ENUM | BIND_FLAGS_TS_CONST_ENUM,
    BIND_TS_NAMESPACE = 0 | 0 | 0 | BIND_FLAGS_TS_EXPORT_ONLY,
    BIND_TS_TYPE_IMPORT = 0 | BIND_KIND_TYPE | 0 | BIND_FLAGS_TS_IMPORT,
    BIND_FLOW_DECLARE_FN = BIND_FLAGS_FLOW_DECLARE_FN;
  const CLASS_ELEMENT_FLAG_STATIC = 4,
    CLASS_ELEMENT_KIND_GETTER = 2,
    CLASS_ELEMENT_KIND_SETTER = 1,
    CLASS_ELEMENT_KIND_ACCESSOR =
      CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_KIND_SETTER;
  const CLASS_ELEMENT_STATIC_GETTER =
      CLASS_ELEMENT_KIND_GETTER | CLASS_ELEMENT_FLAG_STATIC,
    CLASS_ELEMENT_STATIC_SETTER =
      CLASS_ELEMENT_KIND_SETTER | CLASS_ELEMENT_FLAG_STATIC,
    CLASS_ELEMENT_INSTANCE_GETTER = CLASS_ELEMENT_KIND_GETTER,
    CLASS_ELEMENT_INSTANCE_SETTER = CLASS_ELEMENT_KIND_SETTER,
    CLASS_ELEMENT_OTHER = 0;
  class Scope {
    constructor(flags) {
      this.var = new Set();
      this.lexical = new Set();
      this.functions = new Set();
      this.flags = flags;
    }
  }
  class ScopeHandler {
    constructor(parser, inModule) {
      this.parser = void 0;
      this.scopeStack = [];
      this.inModule = void 0;
      this.undefinedExports = new Map();
      this.parser = parser;
      this.inModule = inModule;
    }
    get inTopLevel() {
      return (this.currentScope().flags & SCOPE_PROGRAM) > 0;
    }
    get inFunction() {
      return (this.currentVarScopeFlags() & SCOPE_FUNCTION) > 0;
    }
    get allowSuper() {
      return (this.currentThisScopeFlags() & SCOPE_SUPER) > 0;
    }
    get allowDirectSuper() {
      return (this.currentThisScopeFlags() & SCOPE_DIRECT_SUPER) > 0;
    }
    get inClass() {
      return (this.currentThisScopeFlags() & SCOPE_CLASS) > 0;
    }
    get inClassAndNotInNonArrowFunction() {
      const flags = this.currentThisScopeFlags();
      return (flags & SCOPE_CLASS) > 0 && (flags & SCOPE_FUNCTION) === 0;
    }
    get inStaticBlock() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & SCOPE_STATIC_BLOCK) {
          return true;
        }
        if (flags & (SCOPE_VAR | SCOPE_CLASS)) {
          return false;
        }
      }
    }
    get inNonArrowFunction() {
      return (this.currentThisScopeFlags() & SCOPE_FUNCTION) > 0;
    }
    get treatFunctionsAsVar() {
      return this.treatFunctionsAsVarInScope(this.currentScope());
    }
    createScope(flags) {
      return new Scope(flags);
    }
    enter(flags) {
      this.scopeStack.push(this.createScope(flags));
    }
    exit() {
      const scope = this.scopeStack.pop();
      return scope.flags;
    }
    treatFunctionsAsVarInScope(scope) {
      return !!(
        scope.flags & (SCOPE_FUNCTION | SCOPE_STATIC_BLOCK) ||
        (!this.parser.inModule && scope.flags & SCOPE_PROGRAM)
      );
    }
    declareName(name, bindingType, loc) {
      let scope = this.currentScope();
      if (
        bindingType & BIND_SCOPE_LEXICAL ||
        bindingType & BIND_SCOPE_FUNCTION
      ) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        if (bindingType & BIND_SCOPE_FUNCTION) {
          scope.functions.add(name);
        } else {
          scope.lexical.add(name);
        }
        if (bindingType & BIND_SCOPE_LEXICAL) {
          this.maybeExportDefined(scope, name);
        }
      } else if (bindingType & BIND_SCOPE_VAR) {
        for (let i = this.scopeStack.length - 1; i >= 0; --i) {
          scope = this.scopeStack[i];
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          scope.var.add(name);
          this.maybeExportDefined(scope, name);
          if (scope.flags & SCOPE_VAR) break;
        }
      }
      if (this.parser.inModule && scope.flags & SCOPE_PROGRAM) {
        this.undefinedExports.delete(name);
      }
    }
    maybeExportDefined(scope, name) {
      if (this.parser.inModule && scope.flags & SCOPE_PROGRAM) {
        this.undefinedExports.delete(name);
      }
    }
    checkRedeclarationInScope(scope, name, bindingType, loc) {
      if (this.isRedeclaredInScope(scope, name, bindingType)) {
        this.parser.raise(Errors.VarRedeclaration, {
          at: loc,
          identifierName: name,
        });
      }
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (!(bindingType & BIND_KIND_VALUE)) return false;
      if (bindingType & BIND_SCOPE_LEXICAL) {
        return (
          scope.lexical.has(name) ||
          scope.functions.has(name) ||
          scope.var.has(name)
        );
      }
      if (bindingType & BIND_SCOPE_FUNCTION) {
        return (
          scope.lexical.has(name) ||
          (!this.treatFunctionsAsVarInScope(scope) && scope.var.has(name))
        );
      }
      return (
        (scope.lexical.has(name) &&
          !(
            scope.flags & SCOPE_SIMPLE_CATCH &&
            scope.lexical.values().next().value === name
          )) ||
        (!this.treatFunctionsAsVarInScope(scope) && scope.functions.has(name))
      );
    }
    checkLocalExport(id) {
      const {name: name} = id;
      const topLevelScope = this.scopeStack[0];
      if (
        !topLevelScope.lexical.has(name) &&
        !topLevelScope.var.has(name) &&
        !topLevelScope.functions.has(name)
      ) {
        this.undefinedExports.set(name, id.loc.start);
      }
    }
    currentScope() {
      return this.scopeStack[this.scopeStack.length - 1];
    }
    currentVarScopeFlags() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & SCOPE_VAR) {
          return flags;
        }
      }
    }
    currentThisScopeFlags() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & (SCOPE_VAR | SCOPE_CLASS) && !(flags & SCOPE_ARROW)) {
          return flags;
        }
      }
    }
  }
  class FlowScope extends Scope {
    constructor(...args) {
      super(...args);
      this.declareFunctions = new Set();
    }
  }
  class FlowScopeHandler extends ScopeHandler {
    createScope(flags) {
      return new FlowScope(flags);
    }
    declareName(name, bindingType, loc) {
      const scope = this.currentScope();
      if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        this.maybeExportDefined(scope, name);
        scope.declareFunctions.add(name);
        return;
      }
      super.declareName(name, bindingType, loc);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (super.isRedeclaredInScope(scope, name, bindingType)) return true;
      if (bindingType & BIND_FLAGS_FLOW_DECLARE_FN) {
        return (
          !scope.declareFunctions.has(name) &&
          (scope.lexical.has(name) || scope.functions.has(name))
        );
      }
      return false;
    }
    checkLocalExport(id) {
      if (!this.scopeStack[0].declareFunctions.has(id.name)) {
        super.checkLocalExport(id);
      }
    }
  }
  class BaseParser {
    constructor() {
      this.sawUnambiguousESM = false;
      this.ambiguousScriptDifferentAst = false;
    }
    hasPlugin(pluginConfig) {
      if (typeof pluginConfig === 'string') {
        return this.plugins.has(pluginConfig);
      } else {
        const [pluginName, pluginOptions] = pluginConfig;
        if (!this.hasPlugin(pluginName)) {
          return false;
        }
        const actualOptions = this.plugins.get(pluginName);
        for (const key of Object.keys(pluginOptions)) {
          if (
            (actualOptions == null ? void 0 : actualOptions[key]) !==
            pluginOptions[key]
          ) {
            return false;
          }
        }
        return true;
      }
    }
    getPluginOption(plugin, name) {
      var _this$plugins$get;
      return (_this$plugins$get = this.plugins.get(plugin)) == null
        ? void 0
        : _this$plugins$get[name];
    }
  }
  function setTrailingComments(node, comments) {
    if (node.trailingComments === undefined) {
      node.trailingComments = comments;
    } else {
      node.trailingComments.unshift(...comments);
    }
  }
  function setLeadingComments(node, comments) {
    if (node.leadingComments === undefined) {
      node.leadingComments = comments;
    } else {
      node.leadingComments.unshift(...comments);
    }
  }
  function setInnerComments(node, comments) {
    if (node.innerComments === undefined) {
      node.innerComments = comments;
    } else {
      node.innerComments.unshift(...comments);
    }
  }
  function adjustInnerComments(node, elements, commentWS) {
    let lastElement = null;
    let i = elements.length;
    while (lastElement === null && i > 0) {
      lastElement = elements[--i];
    }
    if (lastElement === null || lastElement.start > commentWS.start) {
      setInnerComments(node, commentWS.comments);
    } else {
      setTrailingComments(lastElement, commentWS.comments);
    }
  }
  class CommentsParser extends BaseParser {
    addComment(comment) {
      if (this.filename) comment.loc.filename = this.filename;
      this.state.comments.push(comment);
    }
    processComment(node) {
      const {commentStack: commentStack} = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0) return;
      let i = commentStackLength - 1;
      const lastCommentWS = commentStack[i];
      if (lastCommentWS.start === node.end) {
        lastCommentWS.leadingNode = node;
        i--;
      }
      const {start: nodeStart} = node;
      for (; i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        if (commentEnd > nodeStart) {
          commentWS.containingNode = node;
          this.finalizeComment(commentWS);
          commentStack.splice(i, 1);
        } else {
          if (commentEnd === nodeStart) {
            commentWS.trailingNode = node;
          }
          break;
        }
      }
    }
    finalizeComment(commentWS) {
      const {comments: comments} = commentWS;
      if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
        if (commentWS.leadingNode !== null) {
          setTrailingComments(commentWS.leadingNode, comments);
        }
        if (commentWS.trailingNode !== null) {
          setLeadingComments(commentWS.trailingNode, comments);
        }
      } else {
        const {containingNode: node, start: commentStart} = commentWS;
        if (this.input.charCodeAt(commentStart - 1) === 44) {
          switch (node.type) {
            case 'ObjectExpression':
            case 'ObjectPattern':
            case 'RecordExpression':
              adjustInnerComments(node, node.properties, commentWS);
              break;
            case 'CallExpression':
            case 'OptionalCallExpression':
              adjustInnerComments(node, node.arguments, commentWS);
              break;
            case 'FunctionDeclaration':
            case 'FunctionExpression':
            case 'ArrowFunctionExpression':
            case 'ObjectMethod':
            case 'ClassMethod':
            case 'ClassPrivateMethod':
              adjustInnerComments(node, node.params, commentWS);
              break;
            case 'ArrayExpression':
            case 'ArrayPattern':
            case 'TupleExpression':
              adjustInnerComments(node, node.elements, commentWS);
              break;
            case 'ExportNamedDeclaration':
            case 'ImportDeclaration':
              adjustInnerComments(node, node.specifiers, commentWS);
              break;
            default: {
              setInnerComments(node, comments);
            }
          }
        } else {
          setInnerComments(node, comments);
        }
      }
    }
    finalizeRemainingComments() {
      const {commentStack: commentStack} = this.state;
      for (let i = commentStack.length - 1; i >= 0; i--) {
        this.finalizeComment(commentStack[i]);
      }
      this.state.commentStack = [];
    }
    resetPreviousNodeTrailingComments(node) {
      const {commentStack: commentStack} = this.state;
      const {length: length} = commentStack;
      if (length === 0) return;
      const commentWS = commentStack[length - 1];
      if (commentWS.leadingNode === node) {
        commentWS.leadingNode = null;
      }
    }
    takeSurroundingComments(node, start, end) {
      const {commentStack: commentStack} = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0) return;
      let i = commentStackLength - 1;
      for (; i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        const commentStart = commentWS.start;
        if (commentStart === end) {
          commentWS.leadingNode = node;
        } else if (commentEnd === start) {
          commentWS.trailingNode = node;
        } else if (commentEnd < start) {
          break;
        }
      }
    }
  }
  const lineBreak = /\r\n?|[\n\u2028\u2029]/;
  const lineBreakG = new RegExp(lineBreak.source, 'g');
  function isNewLine(code) {
    switch (code) {
      case 10:
      case 13:
      case 8232:
      case 8233:
        return true;
      default:
        return false;
    }
  }
  const skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
  const skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
  const skipWhiteSpaceToLineBreak = new RegExp(
    '(?=(' +
      skipWhiteSpaceInLine.source +
      '))\\1' +
      /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source,
    'y'
  );
  function isWhitespace(code) {
    switch (code) {
      case 9:
      case 11:
      case 12:
      case 32:
      case 160:
      case 5760:
      case 8192:
      case 8193:
      case 8194:
      case 8195:
      case 8196:
      case 8197:
      case 8198:
      case 8199:
      case 8200:
      case 8201:
      case 8202:
      case 8239:
      case 8287:
      case 12288:
      case 65279:
        return true;
      default:
        return false;
    }
  }
  class State {
    constructor() {
      this.strict = void 0;
      this.curLine = void 0;
      this.lineStart = void 0;
      this.startLoc = void 0;
      this.endLoc = void 0;
      this.errors = [];
      this.potentialArrowAt = -1;
      this.noArrowAt = [];
      this.noArrowParamsConversionAt = [];
      this.maybeInArrowParameters = false;
      this.inType = false;
      this.noAnonFunctionType = false;
      this.hasFlowComment = false;
      this.isAmbientContext = false;
      this.inAbstractClass = false;
      this.inDisallowConditionalTypesContext = false;
      this.topicContext = {maxNumOfResolvableTopics: 0, maxTopicIndex: null};
      this.soloAwait = false;
      this.inFSharpPipelineDirectBody = false;
      this.labels = [];
      this.comments = [];
      this.commentStack = [];
      this.pos = 0;
      this.type = 137;
      this.value = null;
      this.start = 0;
      this.end = 0;
      this.lastTokEndLoc = null;
      this.lastTokStartLoc = null;
      this.lastTokStart = 0;
      this.context = [types.brace];
      this.canStartJSXElement = true;
      this.containsEsc = false;
      this.firstInvalidTemplateEscapePos = null;
      this.strictErrors = new Map();
      this.tokensLength = 0;
    }
    init({
      strictMode: strictMode,
      sourceType: sourceType,
      startLine: startLine,
      startColumn: startColumn,
    }) {
      this.strict =
        strictMode === false
          ? false
          : strictMode === true
            ? true
            : sourceType === 'module';
      this.curLine = startLine;
      this.lineStart = -startColumn;
      this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
    }
    curPosition() {
      return new Position(this.curLine, this.pos - this.lineStart, this.pos);
    }
    clone(skipArrays) {
      const state = new State();
      const keys = Object.keys(this);
      for (let i = 0, length = keys.length; i < length; i++) {
        const key = keys[i];
        let val = this[key];
        if (!skipArrays && Array.isArray(val)) {
          val = val.slice();
        }
        state[key] = val;
      }
      return state;
    }
  }
  var _isDigit = function isDigit(code) {
    return code >= 48 && code <= 57;
  };
  const forbiddenNumericSeparatorSiblings = {
    decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
    hex: new Set([46, 88, 95, 120]),
  };
  const isAllowedNumericSeparatorSibling = {
    bin: ch => ch === 48 || ch === 49,
    oct: ch => ch >= 48 && ch <= 55,
    dec: ch => ch >= 48 && ch <= 57,
    hex: ch =>
      (ch >= 48 && ch <= 57) ||
      (ch >= 65 && ch <= 70) ||
      (ch >= 97 && ch <= 102),
  };
  function readStringContents(type, input, pos, lineStart, curLine, errors) {
    const initialPos = pos;
    const initialLineStart = lineStart;
    const initialCurLine = curLine;
    let out = '';
    let firstInvalidLoc = null;
    let chunkStart = pos;
    const {length: length} = input;
    for (;;) {
      if (pos >= length) {
        errors.unterminated(initialPos, initialLineStart, initialCurLine);
        out += input.slice(chunkStart, pos);
        break;
      }
      const ch = input.charCodeAt(pos);
      if (isStringEnd(type, ch, input, pos)) {
        out += input.slice(chunkStart, pos);
        break;
      }
      if (ch === 92) {
        out += input.slice(chunkStart, pos);
        const res = readEscapedChar(
          input,
          pos,
          lineStart,
          curLine,
          type === 'template',
          errors
        );
        if (res.ch === null && !firstInvalidLoc) {
          firstInvalidLoc = {pos: pos, lineStart: lineStart, curLine: curLine};
        } else {
          out += res.ch;
        }
        ({pos: pos, lineStart: lineStart, curLine: curLine} = res);
        chunkStart = pos;
      } else if (ch === 8232 || ch === 8233) {
        ++pos;
        ++curLine;
        lineStart = pos;
      } else if (ch === 10 || ch === 13) {
        if (type === 'template') {
          out += input.slice(chunkStart, pos) + '\n';
          ++pos;
          if (ch === 13 && input.charCodeAt(pos) === 10) {
            ++pos;
          }
          ++curLine;
          chunkStart = lineStart = pos;
        } else {
          errors.unterminated(initialPos, initialLineStart, initialCurLine);
        }
      } else {
        ++pos;
      }
    }
    return {
      pos: pos,
      str: out,
      firstInvalidLoc: firstInvalidLoc,
      lineStart: lineStart,
      curLine: curLine,
      containsInvalid: !!firstInvalidLoc,
    };
  }
  function isStringEnd(type, ch, input, pos) {
    if (type === 'template') {
      return ch === 96 || (ch === 36 && input.charCodeAt(pos + 1) === 123);
    }
    return ch === (type === 'double' ? 34 : 39);
  }
  function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
    const throwOnInvalid = !inTemplate;
    pos++;
    const res = ch => ({
      pos: pos,
      ch: ch,
      lineStart: lineStart,
      curLine: curLine,
    });
    const ch = input.charCodeAt(pos++);
    switch (ch) {
      case 110:
        return res('\n');
      case 114:
        return res('\r');
      case 120: {
        let code;
        ({code: code, pos: pos} = readHexChar(
          input,
          pos,
          lineStart,
          curLine,
          2,
          false,
          throwOnInvalid,
          errors
        ));
        return res(code === null ? null : String.fromCharCode(code));
      }
      case 117: {
        let code;
        ({code: code, pos: pos} = readCodePoint(
          input,
          pos,
          lineStart,
          curLine,
          throwOnInvalid,
          errors
        ));
        return res(code === null ? null : String.fromCodePoint(code));
      }
      case 116:
        return res('\t');
      case 98:
        return res('\b');
      case 118:
        return res('\v');
      case 102:
        return res('\f');
      case 13:
        if (input.charCodeAt(pos) === 10) {
          ++pos;
        }
      case 10:
        lineStart = pos;
        ++curLine;
      case 8232:
      case 8233:
        return res('');
      case 56:
      case 57:
        if (inTemplate) {
          return res(null);
        } else {
          errors.strictNumericEscape(pos - 1, lineStart, curLine);
        }
      default:
        if (ch >= 48 && ch <= 55) {
          const startPos = pos - 1;
          const match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
          let octalStr = match[0];
          let octal = parseInt(octalStr, 8);
          if (octal > 255) {
            octalStr = octalStr.slice(0, -1);
            octal = parseInt(octalStr, 8);
          }
          pos += octalStr.length - 1;
          const next = input.charCodeAt(pos);
          if (octalStr !== '0' || next === 56 || next === 57) {
            if (inTemplate) {
              return res(null);
            } else {
              errors.strictNumericEscape(startPos, lineStart, curLine);
            }
          }
          return res(String.fromCharCode(octal));
        }
        return res(String.fromCharCode(ch));
    }
  }
  function readHexChar(
    input,
    pos,
    lineStart,
    curLine,
    len,
    forceLen,
    throwOnInvalid,
    errors
  ) {
    const initialPos = pos;
    let n;
    ({n: n, pos: pos} = readInt(
      input,
      pos,
      lineStart,
      curLine,
      16,
      len,
      forceLen,
      false,
      errors,
      !throwOnInvalid
    ));
    if (n === null) {
      if (throwOnInvalid) {
        errors.invalidEscapeSequence(initialPos, lineStart, curLine);
      } else {
        pos = initialPos - 1;
      }
    }
    return {code: n, pos: pos};
  }
  function readInt(
    input,
    pos,
    lineStart,
    curLine,
    radix,
    len,
    forceLen,
    allowNumSeparator,
    errors,
    bailOnError
  ) {
    const start = pos;
    const forbiddenSiblings =
      radix === 16
        ? forbiddenNumericSeparatorSiblings.hex
        : forbiddenNumericSeparatorSiblings.decBinOct;
    const isAllowedSibling =
      radix === 16
        ? isAllowedNumericSeparatorSibling.hex
        : radix === 10
          ? isAllowedNumericSeparatorSibling.dec
          : radix === 8
            ? isAllowedNumericSeparatorSibling.oct
            : isAllowedNumericSeparatorSibling.bin;
    let invalid = false;
    let total = 0;
    for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
      const code = input.charCodeAt(pos);
      let val;
      if (code === 95 && allowNumSeparator !== 'bail') {
        const prev = input.charCodeAt(pos - 1);
        const next = input.charCodeAt(pos + 1);
        if (!allowNumSeparator) {
          if (bailOnError) return {n: null, pos: pos};
          errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
        } else if (
          Number.isNaN(next) ||
          !isAllowedSibling(next) ||
          forbiddenSiblings.has(prev) ||
          forbiddenSiblings.has(next)
        ) {
          if (bailOnError) return {n: null, pos: pos};
          errors.unexpectedNumericSeparator(pos, lineStart, curLine);
        }
        ++pos;
        continue;
      }
      if (code >= 97) {
        val = code - 97 + 10;
      } else if (code >= 65) {
        val = code - 65 + 10;
      } else if (_isDigit(code)) {
        val = code - 48;
      } else {
        val = Infinity;
      }
      if (val >= radix) {
        if (val <= 9 && bailOnError) {
          return {n: null, pos: pos};
        } else if (
          val <= 9 &&
          errors.invalidDigit(pos, lineStart, curLine, radix)
        ) {
          val = 0;
        } else if (forceLen) {
          val = 0;
          invalid = true;
        } else {
          break;
        }
      }
      ++pos;
      total = total * radix + val;
    }
    if (pos === start || (len != null && pos - start !== len) || invalid) {
      return {n: null, pos: pos};
    }
    return {n: total, pos: pos};
  }
  function readCodePoint(
    input,
    pos,
    lineStart,
    curLine,
    throwOnInvalid,
    errors
  ) {
    const ch = input.charCodeAt(pos);
    let code;
    if (ch === 123) {
      ++pos;
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        input.indexOf('}', pos) - pos,
        true,
        throwOnInvalid,
        errors
      ));
      ++pos;
      if (code !== null && code > 1114111) {
        if (throwOnInvalid) {
          errors.invalidCodePoint(pos, lineStart, curLine);
        } else {
          return {code: null, pos: pos};
        }
      }
    } else {
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        4,
        false,
        throwOnInvalid,
        errors
      ));
    }
    return {code: code, pos: pos};
  }
  const _excluded = ['at'],
    _excluded2 = ['at'];
  function buildPosition(pos, lineStart, curLine) {
    return new Position(curLine, pos - lineStart, pos);
  }
  const VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
  class Token {
    constructor(state) {
      this.type = state.type;
      this.value = state.value;
      this.start = state.start;
      this.end = state.end;
      this.loc = new SourceLocation(state.startLoc, state.endLoc);
    }
  }
  class Tokenizer extends CommentsParser {
    constructor(options, input) {
      super();
      this.isLookahead = void 0;
      this.tokens = [];
      this.errorHandlers_readInt = {
        invalidDigit: (pos, lineStart, curLine, radix) => {
          if (!this.options.errorRecovery) return false;
          this.raise(Errors.InvalidDigit, {
            at: buildPosition(pos, lineStart, curLine),
            radix: radix,
          });
          return true;
        },
        numericSeparatorInEscapeSequence: this.errorBuilder(
          Errors.NumericSeparatorInEscapeSequence
        ),
        unexpectedNumericSeparator: this.errorBuilder(
          Errors.UnexpectedNumericSeparator
        ),
      };
      this.errorHandlers_readCodePoint = Object.assign(
        {},
        this.errorHandlers_readInt,
        {
          invalidEscapeSequence: this.errorBuilder(
            Errors.InvalidEscapeSequence
          ),
          invalidCodePoint: this.errorBuilder(Errors.InvalidCodePoint),
        }
      );
      this.errorHandlers_readStringContents_string = Object.assign(
        {},
        this.errorHandlers_readCodePoint,
        {
          strictNumericEscape: (pos, lineStart, curLine) => {
            this.recordStrictModeErrors(Errors.StrictNumericEscape, {
              at: buildPosition(pos, lineStart, curLine),
            });
          },
          unterminated: (pos, lineStart, curLine) => {
            throw this.raise(Errors.UnterminatedString, {
              at: buildPosition(pos - 1, lineStart, curLine),
            });
          },
        }
      );
      this.errorHandlers_readStringContents_template = Object.assign(
        {},
        this.errorHandlers_readCodePoint,
        {
          strictNumericEscape: this.errorBuilder(Errors.StrictNumericEscape),
          unterminated: (pos, lineStart, curLine) => {
            throw this.raise(Errors.UnterminatedTemplate, {
              at: buildPosition(pos, lineStart, curLine),
            });
          },
        }
      );
      this.state = new State();
      this.state.init(options);
      this.input = input;
      this.length = input.length;
      this.isLookahead = false;
    }
    pushToken(token) {
      this.tokens.length = this.state.tokensLength;
      this.tokens.push(token);
      ++this.state.tokensLength;
    }
    next() {
      this.checkKeywordEscapes();
      if (this.options.tokens) {
        this.pushToken(new Token(this.state));
      }
      this.state.lastTokStart = this.state.start;
      this.state.lastTokEndLoc = this.state.endLoc;
      this.state.lastTokStartLoc = this.state.startLoc;
      this.nextToken();
    }
    eat(type) {
      if (this.match(type)) {
        this.next();
        return true;
      } else {
        return false;
      }
    }
    match(type) {
      return this.state.type === type;
    }
    createLookaheadState(state) {
      return {
        pos: state.pos,
        value: null,
        type: state.type,
        start: state.start,
        end: state.end,
        context: [this.curContext()],
        inType: state.inType,
        startLoc: state.startLoc,
        lastTokEndLoc: state.lastTokEndLoc,
        curLine: state.curLine,
        lineStart: state.lineStart,
        curPosition: state.curPosition,
      };
    }
    lookahead() {
      const old = this.state;
      this.state = this.createLookaheadState(old);
      this.isLookahead = true;
      this.nextToken();
      this.isLookahead = false;
      const curr = this.state;
      this.state = old;
      return curr;
    }
    nextTokenStart() {
      return this.nextTokenStartSince(this.state.pos);
    }
    nextTokenStartSince(pos) {
      skipWhiteSpace.lastIndex = pos;
      return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
    }
    lookaheadCharCode() {
      return this.input.charCodeAt(this.nextTokenStart());
    }
    nextTokenInLineStart() {
      return this.nextTokenInLineStartSince(this.state.pos);
    }
    nextTokenInLineStartSince(pos) {
      skipWhiteSpaceInLine.lastIndex = pos;
      return skipWhiteSpaceInLine.test(this.input)
        ? skipWhiteSpaceInLine.lastIndex
        : pos;
    }
    lookaheadInLineCharCode() {
      return this.input.charCodeAt(this.nextTokenInLineStart());
    }
    codePointAtPos(pos) {
      let cp = this.input.charCodeAt(pos);
      if ((cp & 64512) === 55296 && ++pos < this.input.length) {
        const trail = this.input.charCodeAt(pos);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      return cp;
    }
    setStrict(strict) {
      this.state.strict = strict;
      if (strict) {
        this.state.strictErrors.forEach(([toParseError, at]) =>
          this.raise(toParseError, {at: at})
        );
        this.state.strictErrors.clear();
      }
    }
    curContext() {
      return this.state.context[this.state.context.length - 1];
    }
    nextToken() {
      this.skipSpace();
      this.state.start = this.state.pos;
      if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
      if (this.state.pos >= this.length) {
        this.finishToken(137);
        return;
      }
      this.getTokenFromCode(this.codePointAtPos(this.state.pos));
    }
    skipBlockComment(commentEnd) {
      let startLoc;
      if (!this.isLookahead) startLoc = this.state.curPosition();
      const start = this.state.pos;
      const end = this.input.indexOf(commentEnd, start + 2);
      if (end === -1) {
        throw this.raise(Errors.UnterminatedComment, {
          at: this.state.curPosition(),
        });
      }
      this.state.pos = end + commentEnd.length;
      lineBreakG.lastIndex = start + 2;
      while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
        ++this.state.curLine;
        this.state.lineStart = lineBreakG.lastIndex;
      }
      if (this.isLookahead) return;
      const comment = {
        type: 'CommentBlock',
        value: this.input.slice(start + 2, end),
        start: start,
        end: end + commentEnd.length,
        loc: new SourceLocation(startLoc, this.state.curPosition()),
      };
      if (this.options.tokens) this.pushToken(comment);
      return comment;
    }
    skipLineComment(startSkip) {
      const start = this.state.pos;
      let startLoc;
      if (!this.isLookahead) startLoc = this.state.curPosition();
      let ch = this.input.charCodeAt((this.state.pos += startSkip));
      if (this.state.pos < this.length) {
        while (!isNewLine(ch) && ++this.state.pos < this.length) {
          ch = this.input.charCodeAt(this.state.pos);
        }
      }
      if (this.isLookahead) return;
      const end = this.state.pos;
      const value = this.input.slice(start + startSkip, end);
      const comment = {
        type: 'CommentLine',
        value: value,
        start: start,
        end: end,
        loc: new SourceLocation(startLoc, this.state.curPosition()),
      };
      if (this.options.tokens) this.pushToken(comment);
      return comment;
    }
    skipSpace() {
      const spaceStart = this.state.pos;
      const comments = [];
      loop: while (this.state.pos < this.length) {
        const ch = this.input.charCodeAt(this.state.pos);
        switch (ch) {
          case 32:
          case 160:
          case 9:
            ++this.state.pos;
            break;
          case 13:
            if (this.input.charCodeAt(this.state.pos + 1) === 10) {
              ++this.state.pos;
            }
          case 10:
          case 8232:
          case 8233:
            ++this.state.pos;
            ++this.state.curLine;
            this.state.lineStart = this.state.pos;
            break;
          case 47:
            switch (this.input.charCodeAt(this.state.pos + 1)) {
              case 42: {
                const comment = this.skipBlockComment('*/');
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
                break;
              }
              case 47: {
                const comment = this.skipLineComment(2);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
                break;
              }
              default:
                break loop;
            }
            break;
          default:
            if (isWhitespace(ch)) {
              ++this.state.pos;
            } else if (ch === 45 && !this.inModule && this.options.annexB) {
              const pos = this.state.pos;
              if (
                this.input.charCodeAt(pos + 1) === 45 &&
                this.input.charCodeAt(pos + 2) === 62 &&
                (spaceStart === 0 || this.state.lineStart > spaceStart)
              ) {
                const comment = this.skipLineComment(3);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
              } else {
                break loop;
              }
            } else if (ch === 60 && !this.inModule && this.options.annexB) {
              const pos = this.state.pos;
              if (
                this.input.charCodeAt(pos + 1) === 33 &&
                this.input.charCodeAt(pos + 2) === 45 &&
                this.input.charCodeAt(pos + 3) === 45
              ) {
                const comment = this.skipLineComment(4);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
              } else {
                break loop;
              }
            } else {
              break loop;
            }
        }
      }
      if (comments.length > 0) {
        const end = this.state.pos;
        const commentWhitespace = {
          start: spaceStart,
          end: end,
          comments: comments,
          leadingNode: null,
          trailingNode: null,
          containingNode: null,
        };
        this.state.commentStack.push(commentWhitespace);
      }
    }
    finishToken(type, val) {
      this.state.end = this.state.pos;
      this.state.endLoc = this.state.curPosition();
      const prevType = this.state.type;
      this.state.type = type;
      this.state.value = val;
      if (!this.isLookahead) {
        this.updateContext(prevType);
      }
    }
    replaceToken(type) {
      this.state.type = type;
      this.updateContext();
    }
    readToken_numberSign() {
      if (this.state.pos === 0 && this.readToken_interpreter()) {
        return;
      }
      const nextPos = this.state.pos + 1;
      const next = this.codePointAtPos(nextPos);
      if (next >= 48 && next <= 57) {
        throw this.raise(Errors.UnexpectedDigitAfterHash, {
          at: this.state.curPosition(),
        });
      }
      if (next === 123 || (next === 91 && this.hasPlugin('recordAndTuple'))) {
        this.expectPlugin('recordAndTuple');
        if (this.getPluginOption('recordAndTuple', 'syntaxType') === 'bar') {
          throw this.raise(
            next === 123
              ? Errors.RecordExpressionHashIncorrectStartSyntaxType
              : Errors.TupleExpressionHashIncorrectStartSyntaxType,
            {at: this.state.curPosition()}
          );
        }
        this.state.pos += 2;
        if (next === 123) {
          this.finishToken(7);
        } else {
          this.finishToken(1);
        }
      } else if (isIdentifierStart(next)) {
        ++this.state.pos;
        this.finishToken(136, this.readWord1(next));
      } else if (next === 92) {
        ++this.state.pos;
        this.finishToken(136, this.readWord1());
      } else {
        this.finishOp(27, 1);
      }
    }
    readToken_dot() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next >= 48 && next <= 57) {
        this.readNumber(true);
        return;
      }
      if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
        this.state.pos += 3;
        this.finishToken(21);
      } else {
        ++this.state.pos;
        this.finishToken(16);
      }
    }
    readToken_slash() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(31, 2);
      } else {
        this.finishOp(56, 1);
      }
    }
    readToken_interpreter() {
      if (this.state.pos !== 0 || this.length < 2) return false;
      let ch = this.input.charCodeAt(this.state.pos + 1);
      if (ch !== 33) return false;
      const start = this.state.pos;
      this.state.pos += 1;
      while (!isNewLine(ch) && ++this.state.pos < this.length) {
        ch = this.input.charCodeAt(this.state.pos);
      }
      const value = this.input.slice(start + 2, this.state.pos);
      this.finishToken(28, value);
      return true;
    }
    readToken_mult_modulo(code) {
      let type = code === 42 ? 55 : 54;
      let width = 1;
      let next = this.input.charCodeAt(this.state.pos + 1);
      if (code === 42 && next === 42) {
        width++;
        next = this.input.charCodeAt(this.state.pos + 2);
        type = 57;
      }
      if (next === 61 && !this.state.inType) {
        width++;
        type = code === 37 ? 33 : 30;
      }
      this.finishOp(type, width);
    }
    readToken_pipe_amp(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code) {
        if (this.input.charCodeAt(this.state.pos + 2) === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(code === 124 ? 41 : 42, 2);
        }
        return;
      }
      if (code === 124) {
        if (next === 62) {
          this.finishOp(39, 2);
          return;
        }
        if (this.hasPlugin('recordAndTuple') && next === 125) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, {
              at: this.state.curPosition(),
            });
          }
          this.state.pos += 2;
          this.finishToken(9);
          return;
        }
        if (this.hasPlugin('recordAndTuple') && next === 93) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, {
              at: this.state.curPosition(),
            });
          }
          this.state.pos += 2;
          this.finishToken(4);
          return;
        }
      }
      if (next === 61) {
        this.finishOp(30, 2);
        return;
      }
      this.finishOp(code === 124 ? 43 : 45, 1);
    }
    readToken_caret() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61 && !this.state.inType) {
        this.finishOp(32, 2);
      } else if (
        next === 94 &&
        this.hasPlugin([
          'pipelineOperator',
          {proposal: 'hack', topicToken: '^^'},
        ])
      ) {
        this.finishOp(37, 2);
        const lookaheadCh = this.input.codePointAt(this.state.pos);
        if (lookaheadCh === 94) {
          this.unexpected();
        }
      } else {
        this.finishOp(44, 1);
      }
    }
    readToken_atSign() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (
        next === 64 &&
        this.hasPlugin([
          'pipelineOperator',
          {proposal: 'hack', topicToken: '@@'},
        ])
      ) {
        this.finishOp(38, 2);
      } else {
        this.finishOp(26, 1);
      }
    }
    readToken_plus_min(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code) {
        this.finishOp(34, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(30, 2);
      } else {
        this.finishOp(53, 1);
      }
    }
    readToken_lt() {
      const {pos: pos} = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 60) {
        if (this.input.charCodeAt(pos + 2) === 61) {
          this.finishOp(30, 3);
          return;
        }
        this.finishOp(51, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(47, 1);
    }
    readToken_gt() {
      const {pos: pos} = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 62) {
        const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
        if (this.input.charCodeAt(pos + size) === 61) {
          this.finishOp(30, size + 1);
          return;
        }
        this.finishOp(52, size);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(48, 1);
    }
    readToken_eq_excl(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(
          46,
          this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2
        );
        return;
      }
      if (code === 61 && next === 62) {
        this.state.pos += 2;
        this.finishToken(19);
        return;
      }
      this.finishOp(code === 61 ? 29 : 35, 1);
    }
    readToken_question() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      const next2 = this.input.charCodeAt(this.state.pos + 2);
      if (next === 63) {
        if (next2 === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(40, 2);
        }
      } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
        this.state.pos += 2;
        this.finishToken(18);
      } else {
        ++this.state.pos;
        this.finishToken(17);
      }
    }
    getTokenFromCode(code) {
      switch (code) {
        case 46:
          this.readToken_dot();
          return;
        case 40:
          ++this.state.pos;
          this.finishToken(10);
          return;
        case 41:
          ++this.state.pos;
          this.finishToken(11);
          return;
        case 59:
          ++this.state.pos;
          this.finishToken(13);
          return;
        case 44:
          ++this.state.pos;
          this.finishToken(12);
          return;
        case 91:
          if (
            this.hasPlugin('recordAndTuple') &&
            this.input.charCodeAt(this.state.pos + 1) === 124
          ) {
            if (
              this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar'
            ) {
              throw this.raise(
                Errors.TupleExpressionBarIncorrectStartSyntaxType,
                {at: this.state.curPosition()}
              );
            }
            this.state.pos += 2;
            this.finishToken(2);
          } else {
            ++this.state.pos;
            this.finishToken(0);
          }
          return;
        case 93:
          ++this.state.pos;
          this.finishToken(3);
          return;
        case 123:
          if (
            this.hasPlugin('recordAndTuple') &&
            this.input.charCodeAt(this.state.pos + 1) === 124
          ) {
            if (
              this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar'
            ) {
              throw this.raise(
                Errors.RecordExpressionBarIncorrectStartSyntaxType,
                {at: this.state.curPosition()}
              );
            }
            this.state.pos += 2;
            this.finishToken(6);
          } else {
            ++this.state.pos;
            this.finishToken(5);
          }
          return;
        case 125:
          ++this.state.pos;
          this.finishToken(8);
          return;
        case 58:
          if (
            this.hasPlugin('functionBind') &&
            this.input.charCodeAt(this.state.pos + 1) === 58
          ) {
            this.finishOp(15, 2);
          } else {
            ++this.state.pos;
            this.finishToken(14);
          }
          return;
        case 63:
          this.readToken_question();
          return;
        case 96:
          this.readTemplateToken();
          return;
        case 48: {
          const next = this.input.charCodeAt(this.state.pos + 1);
          if (next === 120 || next === 88) {
            this.readRadixNumber(16);
            return;
          }
          if (next === 111 || next === 79) {
            this.readRadixNumber(8);
            return;
          }
          if (next === 98 || next === 66) {
            this.readRadixNumber(2);
            return;
          }
        }
        case 49:
        case 50:
        case 51:
        case 52:
        case 53:
        case 54:
        case 55:
        case 56:
        case 57:
          this.readNumber(false);
          return;
        case 34:
        case 39:
          this.readString(code);
          return;
        case 47:
          this.readToken_slash();
          return;
        case 37:
        case 42:
          this.readToken_mult_modulo(code);
          return;
        case 124:
        case 38:
          this.readToken_pipe_amp(code);
          return;
        case 94:
          this.readToken_caret();
          return;
        case 43:
        case 45:
          this.readToken_plus_min(code);
          return;
        case 60:
          this.readToken_lt();
          return;
        case 62:
          this.readToken_gt();
          return;
        case 61:
        case 33:
          this.readToken_eq_excl(code);
          return;
        case 126:
          this.finishOp(36, 1);
          return;
        case 64:
          this.readToken_atSign();
          return;
        case 35:
          this.readToken_numberSign();
          return;
        case 92:
          this.readWord();
          return;
        default:
          if (isIdentifierStart(code)) {
            this.readWord(code);
            return;
          }
      }
      throw this.raise(Errors.InvalidOrUnexpectedToken, {
        at: this.state.curPosition(),
        unexpected: String.fromCodePoint(code),
      });
    }
    finishOp(type, size) {
      const str = this.input.slice(this.state.pos, this.state.pos + size);
      this.state.pos += size;
      this.finishToken(type, str);
    }
    readRegexp() {
      const startLoc = this.state.startLoc;
      const start = this.state.start + 1;
      let escaped, inClass;
      let {pos: pos} = this.state;
      for (; ; ++pos) {
        if (pos >= this.length) {
          throw this.raise(Errors.UnterminatedRegExp, {
            at: createPositionWithColumnOffset(startLoc, 1),
          });
        }
        const ch = this.input.charCodeAt(pos);
        if (isNewLine(ch)) {
          throw this.raise(Errors.UnterminatedRegExp, {
            at: createPositionWithColumnOffset(startLoc, 1),
          });
        }
        if (escaped) {
          escaped = false;
        } else {
          if (ch === 91) {
            inClass = true;
          } else if (ch === 93 && inClass) {
            inClass = false;
          } else if (ch === 47 && !inClass) {
            break;
          }
          escaped = ch === 92;
        }
      }
      const content = this.input.slice(start, pos);
      ++pos;
      let mods = '';
      const nextPos = () =>
        createPositionWithColumnOffset(startLoc, pos + 2 - start);
      while (pos < this.length) {
        const cp = this.codePointAtPos(pos);
        const char = String.fromCharCode(cp);
        if (VALID_REGEX_FLAGS.has(cp)) {
          if (cp === 118) {
            this.expectPlugin('regexpUnicodeSets', nextPos());
            if (mods.includes('u')) {
              this.raise(Errors.IncompatibleRegExpUVFlags, {at: nextPos()});
            }
          } else if (cp === 117) {
            if (mods.includes('v')) {
              this.raise(Errors.IncompatibleRegExpUVFlags, {at: nextPos()});
            }
          }
          if (mods.includes(char)) {
            this.raise(Errors.DuplicateRegExpFlags, {at: nextPos()});
          }
        } else if (isIdentifierChar(cp) || cp === 92) {
          this.raise(Errors.MalformedRegExpFlags, {at: nextPos()});
        } else {
          break;
        }
        ++pos;
        mods += char;
      }
      this.state.pos = pos;
      this.finishToken(135, {pattern: content, flags: mods});
    }
    readInt(radix, len, forceLen = false, allowNumSeparator = true) {
      const {n: n, pos: pos} = readInt(
        this.input,
        this.state.pos,
        this.state.lineStart,
        this.state.curLine,
        radix,
        len,
        forceLen,
        allowNumSeparator,
        this.errorHandlers_readInt,
        false
      );
      this.state.pos = pos;
      return n;
    }
    readRadixNumber(radix) {
      const startLoc = this.state.curPosition();
      let isBigInt = false;
      this.state.pos += 2;
      const val = this.readInt(radix);
      if (val == null) {
        this.raise(Errors.InvalidDigit, {
          at: createPositionWithColumnOffset(startLoc, 2),
          radix: radix,
        });
      }
      const next = this.input.charCodeAt(this.state.pos);
      if (next === 110) {
        ++this.state.pos;
        isBigInt = true;
      } else if (next === 109) {
        throw this.raise(Errors.InvalidDecimal, {at: startLoc});
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, {
          at: this.state.curPosition(),
        });
      }
      if (isBigInt) {
        const str = this.input
          .slice(startLoc.index, this.state.pos)
          .replace(/[_n]/g, '');
        this.finishToken(133, str);
        return;
      }
      this.finishToken(132, val);
    }
    readNumber(startsWithDot) {
      const start = this.state.pos;
      const startLoc = this.state.curPosition();
      let isFloat = false;
      let isBigInt = false;
      let isDecimal = false;
      let hasExponent = false;
      let isOctal = false;
      if (!startsWithDot && this.readInt(10) === null) {
        this.raise(Errors.InvalidNumber, {at: this.state.curPosition()});
      }
      const hasLeadingZero =
        this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
      if (hasLeadingZero) {
        const integer = this.input.slice(start, this.state.pos);
        this.recordStrictModeErrors(Errors.StrictOctalLiteral, {at: startLoc});
        if (!this.state.strict) {
          const underscorePos = integer.indexOf('_');
          if (underscorePos > 0) {
            this.raise(Errors.ZeroDigitNumericSeparator, {
              at: createPositionWithColumnOffset(startLoc, underscorePos),
            });
          }
        }
        isOctal = hasLeadingZero && !/[89]/.test(integer);
      }
      let next = this.input.charCodeAt(this.state.pos);
      if (next === 46 && !isOctal) {
        ++this.state.pos;
        this.readInt(10);
        isFloat = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if ((next === 69 || next === 101) && !isOctal) {
        next = this.input.charCodeAt(++this.state.pos);
        if (next === 43 || next === 45) {
          ++this.state.pos;
        }
        if (this.readInt(10) === null) {
          this.raise(Errors.InvalidOrMissingExponent, {at: startLoc});
        }
        isFloat = true;
        hasExponent = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if (next === 110) {
        if (isFloat || hasLeadingZero) {
          this.raise(Errors.InvalidBigIntLiteral, {at: startLoc});
        }
        ++this.state.pos;
        isBigInt = true;
      }
      if (next === 109) {
        this.expectPlugin('decimal', this.state.curPosition());
        if (hasExponent || hasLeadingZero) {
          this.raise(Errors.InvalidDecimal, {at: startLoc});
        }
        ++this.state.pos;
        isDecimal = true;
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, {
          at: this.state.curPosition(),
        });
      }
      const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, '');
      if (isBigInt) {
        this.finishToken(133, str);
        return;
      }
      if (isDecimal) {
        this.finishToken(134, str);
        return;
      }
      const val = isOctal ? parseInt(str, 8) : parseFloat(str);
      this.finishToken(132, val);
    }
    readCodePoint(throwOnInvalid) {
      const {code: code, pos: pos} = readCodePoint(
        this.input,
        this.state.pos,
        this.state.lineStart,
        this.state.curLine,
        throwOnInvalid,
        this.errorHandlers_readCodePoint
      );
      this.state.pos = pos;
      return code;
    }
    readString(quote) {
      const {
        str: str,
        pos: pos,
        curLine: curLine,
        lineStart: lineStart,
      } = readStringContents(
        quote === 34 ? 'double' : 'single',
        this.input,
        this.state.pos + 1,
        this.state.lineStart,
        this.state.curLine,
        this.errorHandlers_readStringContents_string
      );
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      this.finishToken(131, str);
    }
    readTemplateContinuation() {
      if (!this.match(8)) {
        this.unexpected(null, 8);
      }
      this.state.pos--;
      this.readTemplateToken();
    }
    readTemplateToken() {
      const opening = this.input[this.state.pos];
      const {
        str: str,
        firstInvalidLoc: firstInvalidLoc,
        pos: pos,
        curLine: curLine,
        lineStart: lineStart,
      } = readStringContents(
        'template',
        this.input,
        this.state.pos + 1,
        this.state.lineStart,
        this.state.curLine,
        this.errorHandlers_readStringContents_template
      );
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      if (firstInvalidLoc) {
        this.state.firstInvalidTemplateEscapePos = new Position(
          firstInvalidLoc.curLine,
          firstInvalidLoc.pos - firstInvalidLoc.lineStart,
          firstInvalidLoc.pos
        );
      }
      if (this.input.codePointAt(pos) === 96) {
        this.finishToken(24, firstInvalidLoc ? null : opening + str + '`');
      } else {
        this.state.pos++;
        this.finishToken(25, firstInvalidLoc ? null : opening + str + '${');
      }
    }
    recordStrictModeErrors(toParseError, {at: at}) {
      const index = at.index;
      if (this.state.strict && !this.state.strictErrors.has(index)) {
        this.raise(toParseError, {at: at});
      } else {
        this.state.strictErrors.set(index, [toParseError, at]);
      }
    }
    readWord1(firstCode) {
      this.state.containsEsc = false;
      let word = '';
      const start = this.state.pos;
      let chunkStart = this.state.pos;
      if (firstCode !== undefined) {
        this.state.pos += firstCode <= 65535 ? 1 : 2;
      }
      while (this.state.pos < this.length) {
        const ch = this.codePointAtPos(this.state.pos);
        if (isIdentifierChar(ch)) {
          this.state.pos += ch <= 65535 ? 1 : 2;
        } else if (ch === 92) {
          this.state.containsEsc = true;
          word += this.input.slice(chunkStart, this.state.pos);
          const escStart = this.state.curPosition();
          const identifierCheck =
            this.state.pos === start ? isIdentifierStart : isIdentifierChar;
          if (this.input.charCodeAt(++this.state.pos) !== 117) {
            this.raise(Errors.MissingUnicodeEscape, {
              at: this.state.curPosition(),
            });
            chunkStart = this.state.pos - 1;
            continue;
          }
          ++this.state.pos;
          const esc = this.readCodePoint(true);
          if (esc !== null) {
            if (!identifierCheck(esc)) {
              this.raise(Errors.EscapedCharNotAnIdentifier, {at: escStart});
            }
            word += String.fromCodePoint(esc);
          }
          chunkStart = this.state.pos;
        } else {
          break;
        }
      }
      return word + this.input.slice(chunkStart, this.state.pos);
    }
    readWord(firstCode) {
      const word = this.readWord1(firstCode);
      const type = keywords$1.get(word);
      if (type !== undefined) {
        this.finishToken(type, tokenLabelName(type));
      } else {
        this.finishToken(130, word);
      }
    }
    checkKeywordEscapes() {
      const {type: type} = this.state;
      if (tokenIsKeyword(type) && this.state.containsEsc) {
        this.raise(Errors.InvalidEscapedReservedWord, {
          at: this.state.startLoc,
          reservedWord: tokenLabelName(type),
        });
      }
    }
    raise(toParseError, raiseProperties) {
      const {at: at} = raiseProperties,
        details = _objectWithoutPropertiesLoose(raiseProperties, _excluded);
      const loc = at instanceof Position ? at : at.loc.start;
      const error = toParseError({loc: loc, details: details});
      if (!this.options.errorRecovery) throw error;
      if (!this.isLookahead) this.state.errors.push(error);
      return error;
    }
    raiseOverwrite(toParseError, raiseProperties) {
      const {at: at} = raiseProperties,
        details = _objectWithoutPropertiesLoose(raiseProperties, _excluded2);
      const loc = at instanceof Position ? at : at.loc.start;
      const pos = loc.index;
      const errors = this.state.errors;
      for (let i = errors.length - 1; i >= 0; i--) {
        const error = errors[i];
        if (error.loc.index === pos) {
          return (errors[i] = toParseError({loc: loc, details: details}));
        }
        if (error.loc.index < pos) break;
      }
      return this.raise(toParseError, raiseProperties);
    }
    updateContext(prevType) {}
    unexpected(loc, type) {
      throw this.raise(Errors.UnexpectedToken, {
        expected: type ? tokenLabelName(type) : null,
        at: loc != null ? loc : this.state.startLoc,
      });
    }
    expectPlugin(pluginName, loc) {
      if (this.hasPlugin(pluginName)) {
        return true;
      }
      throw this.raise(Errors.MissingPlugin, {
        at: loc != null ? loc : this.state.startLoc,
        missingPlugin: [pluginName],
      });
    }
    expectOnePlugin(pluginNames) {
      if (!pluginNames.some(name => this.hasPlugin(name))) {
        throw this.raise(Errors.MissingOneOfPlugins, {
          at: this.state.startLoc,
          missingPlugin: pluginNames,
        });
      }
    }
    errorBuilder(error) {
      return (pos, lineStart, curLine) => {
        this.raise(error, {at: buildPosition(pos, lineStart, curLine)});
      };
    }
  }
  class ClassScope {
    constructor() {
      this.privateNames = new Set();
      this.loneAccessors = new Map();
      this.undefinedPrivateNames = new Map();
    }
  }
  class ClassScopeHandler {
    constructor(parser) {
      this.parser = void 0;
      this.stack = [];
      this.undefinedPrivateNames = new Map();
      this.parser = parser;
    }
    current() {
      return this.stack[this.stack.length - 1];
    }
    enter() {
      this.stack.push(new ClassScope());
    }
    exit() {
      const oldClassScope = this.stack.pop();
      const current = this.current();
      for (const [name, loc] of Array.from(
        oldClassScope.undefinedPrivateNames
      )) {
        if (current) {
          if (!current.undefinedPrivateNames.has(name)) {
            current.undefinedPrivateNames.set(name, loc);
          }
        } else {
          this.parser.raise(Errors.InvalidPrivateFieldResolution, {
            at: loc,
            identifierName: name,
          });
        }
      }
    }
    declarePrivateName(name, elementType, loc) {
      const {
        privateNames: privateNames,
        loneAccessors: loneAccessors,
        undefinedPrivateNames: undefinedPrivateNames,
      } = this.current();
      let redefined = privateNames.has(name);
      if (elementType & CLASS_ELEMENT_KIND_ACCESSOR) {
        const accessor = redefined && loneAccessors.get(name);
        if (accessor) {
          const oldStatic = accessor & CLASS_ELEMENT_FLAG_STATIC;
          const newStatic = elementType & CLASS_ELEMENT_FLAG_STATIC;
          const oldKind = accessor & CLASS_ELEMENT_KIND_ACCESSOR;
          const newKind = elementType & CLASS_ELEMENT_KIND_ACCESSOR;
          redefined = oldKind === newKind || oldStatic !== newStatic;
          if (!redefined) loneAccessors.delete(name);
        } else if (!redefined) {
          loneAccessors.set(name, elementType);
        }
      }
      if (redefined) {
        this.parser.raise(Errors.PrivateNameRedeclaration, {
          at: loc,
          identifierName: name,
        });
      }
      privateNames.add(name);
      undefinedPrivateNames.delete(name);
    }
    usePrivateName(name, loc) {
      let classScope;
      for (classScope of this.stack) {
        if (classScope.privateNames.has(name)) return;
      }
      if (classScope) {
        classScope.undefinedPrivateNames.set(name, loc);
      } else {
        this.parser.raise(Errors.InvalidPrivateFieldResolution, {
          at: loc,
          identifierName: name,
        });
      }
    }
  }
  const kExpression = 0,
    kMaybeArrowParameterDeclaration = 1,
    kMaybeAsyncArrowParameterDeclaration = 2,
    kParameterDeclaration = 3;
  class ExpressionScope {
    constructor(type = kExpression) {
      this.type = void 0;
      this.type = type;
    }
    canBeArrowParameterDeclaration() {
      return (
        this.type === kMaybeAsyncArrowParameterDeclaration ||
        this.type === kMaybeArrowParameterDeclaration
      );
    }
    isCertainlyParameterDeclaration() {
      return this.type === kParameterDeclaration;
    }
  }
  class ArrowHeadParsingScope extends ExpressionScope {
    constructor(type) {
      super(type);
      this.declarationErrors = new Map();
    }
    recordDeclarationError(ParsingErrorClass, {at: at}) {
      const index = at.index;
      this.declarationErrors.set(index, [ParsingErrorClass, at]);
    }
    clearDeclarationError(index) {
      this.declarationErrors.delete(index);
    }
    iterateErrors(iterator) {
      this.declarationErrors.forEach(iterator);
    }
  }
  class ExpressionScopeHandler {
    constructor(parser) {
      this.parser = void 0;
      this.stack = [new ExpressionScope()];
      this.parser = parser;
    }
    enter(scope) {
      this.stack.push(scope);
    }
    exit() {
      this.stack.pop();
    }
    recordParameterInitializerError(toParseError, {at: node}) {
      const origin = {at: node.loc.start};
      const {stack: stack} = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (!scope.isCertainlyParameterDeclaration()) {
        if (scope.canBeArrowParameterDeclaration()) {
          scope.recordDeclarationError(toParseError, origin);
        } else {
          return;
        }
        scope = stack[--i];
      }
      this.parser.raise(toParseError, origin);
    }
    recordArrowParameterBindingError(error, {at: node}) {
      const {stack: stack} = this;
      const scope = stack[stack.length - 1];
      const origin = {at: node.loc.start};
      if (scope.isCertainlyParameterDeclaration()) {
        this.parser.raise(error, origin);
      } else if (scope.canBeArrowParameterDeclaration()) {
        scope.recordDeclarationError(error, origin);
      } else {
        return;
      }
    }
    recordAsyncArrowParametersError({at: at}) {
      const {stack: stack} = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (scope.canBeArrowParameterDeclaration()) {
        if (scope.type === kMaybeAsyncArrowParameterDeclaration) {
          scope.recordDeclarationError(Errors.AwaitBindingIdentifier, {at: at});
        }
        scope = stack[--i];
      }
    }
    validateAsPattern() {
      const {stack: stack} = this;
      const currentScope = stack[stack.length - 1];
      if (!currentScope.canBeArrowParameterDeclaration()) return;
      currentScope.iterateErrors(([toParseError, loc]) => {
        this.parser.raise(toParseError, {at: loc});
        let i = stack.length - 2;
        let scope = stack[i];
        while (scope.canBeArrowParameterDeclaration()) {
          scope.clearDeclarationError(loc.index);
          scope = stack[--i];
        }
      });
    }
  }
  function newParameterDeclarationScope() {
    return new ExpressionScope(kParameterDeclaration);
  }
  function newArrowHeadScope() {
    return new ArrowHeadParsingScope(kMaybeArrowParameterDeclaration);
  }
  function newAsyncArrowScope() {
    return new ArrowHeadParsingScope(kMaybeAsyncArrowParameterDeclaration);
  }
  function newExpressionScope() {
    return new ExpressionScope();
  }
  const PARAM = 0,
    PARAM_YIELD = 1,
    PARAM_AWAIT = 2,
    PARAM_RETURN = 4,
    PARAM_IN = 8;
  class ProductionParameterHandler {
    constructor() {
      this.stacks = [];
    }
    enter(flags) {
      this.stacks.push(flags);
    }
    exit() {
      this.stacks.pop();
    }
    currentFlags() {
      return this.stacks[this.stacks.length - 1];
    }
    get hasAwait() {
      return (this.currentFlags() & PARAM_AWAIT) > 0;
    }
    get hasYield() {
      return (this.currentFlags() & PARAM_YIELD) > 0;
    }
    get hasReturn() {
      return (this.currentFlags() & PARAM_RETURN) > 0;
    }
    get hasIn() {
      return (this.currentFlags() & PARAM_IN) > 0;
    }
  }
  function functionFlags(isAsync, isGenerator) {
    return (isAsync ? PARAM_AWAIT : 0) | (isGenerator ? PARAM_YIELD : 0);
  }
  class UtilParser extends Tokenizer {
    addExtra(node, key, value, enumerable = true) {
      if (!node) return;
      const extra = (node.extra = node.extra || {});
      if (enumerable) {
        extra[key] = value;
      } else {
        Object.defineProperty(extra, key, {
          enumerable: enumerable,
          value: value,
        });
      }
    }
    isContextual(token) {
      return this.state.type === token && !this.state.containsEsc;
    }
    isUnparsedContextual(nameStart, name) {
      const nameEnd = nameStart + name.length;
      if (this.input.slice(nameStart, nameEnd) === name) {
        const nextCh = this.input.charCodeAt(nameEnd);
        return !(isIdentifierChar(nextCh) || (nextCh & 64512) === 55296);
      }
      return false;
    }
    isLookaheadContextual(name) {
      const next = this.nextTokenStart();
      return this.isUnparsedContextual(next, name);
    }
    eatContextual(token) {
      if (this.isContextual(token)) {
        this.next();
        return true;
      }
      return false;
    }
    expectContextual(token, toParseError) {
      if (!this.eatContextual(token)) {
        if (toParseError != null) {
          throw this.raise(toParseError, {at: this.state.startLoc});
        }
        this.unexpected(null, token);
      }
    }
    canInsertSemicolon() {
      return this.match(137) || this.match(8) || this.hasPrecedingLineBreak();
    }
    hasPrecedingLineBreak() {
      return lineBreak.test(
        this.input.slice(this.state.lastTokEndLoc.index, this.state.start)
      );
    }
    hasFollowingLineBreak() {
      skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
      return skipWhiteSpaceToLineBreak.test(this.input);
    }
    isLineTerminator() {
      return this.eat(13) || this.canInsertSemicolon();
    }
    semicolon(allowAsi = true) {
      if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
      this.raise(Errors.MissingSemicolon, {at: this.state.lastTokEndLoc});
    }
    expect(type, loc) {
      this.eat(type) || this.unexpected(loc, type);
    }
    tryParse(fn, oldState = this.state.clone()) {
      const abortSignal = {node: null};
      try {
        const node = fn((node = null) => {
          abortSignal.node = node;
          throw abortSignal;
        });
        if (this.state.errors.length > oldState.errors.length) {
          const failState = this.state;
          this.state = oldState;
          this.state.tokensLength = failState.tokensLength;
          return {
            node: node,
            error: failState.errors[oldState.errors.length],
            thrown: false,
            aborted: false,
            failState: failState,
          };
        }
        return {
          node: node,
          error: null,
          thrown: false,
          aborted: false,
          failState: null,
        };
      } catch (error) {
        const failState = this.state;
        this.state = oldState;
        if (error instanceof SyntaxError) {
          return {
            node: null,
            error: error,
            thrown: true,
            aborted: false,
            failState: failState,
          };
        }
        if (error === abortSignal) {
          return {
            node: abortSignal.node,
            error: null,
            thrown: false,
            aborted: true,
            failState: failState,
          };
        }
        throw error;
      }
    }
    checkExpressionErrors(refExpressionErrors, andThrow) {
      if (!refExpressionErrors) return false;
      const {
        shorthandAssignLoc: shorthandAssignLoc,
        doubleProtoLoc: doubleProtoLoc,
        privateKeyLoc: privateKeyLoc,
        optionalParametersLoc: optionalParametersLoc,
      } = refExpressionErrors;
      const hasErrors =
        !!shorthandAssignLoc ||
        !!doubleProtoLoc ||
        !!optionalParametersLoc ||
        !!privateKeyLoc;
      if (!andThrow) {
        return hasErrors;
      }
      if (shorthandAssignLoc != null) {
        this.raise(Errors.InvalidCoverInitializedName, {
          at: shorthandAssignLoc,
        });
      }
      if (doubleProtoLoc != null) {
        this.raise(Errors.DuplicateProto, {at: doubleProtoLoc});
      }
      if (privateKeyLoc != null) {
        this.raise(Errors.UnexpectedPrivateField, {at: privateKeyLoc});
      }
      if (optionalParametersLoc != null) {
        this.unexpected(optionalParametersLoc);
      }
    }
    isLiteralPropertyName() {
      return tokenIsLiteralPropertyName(this.state.type);
    }
    isPrivateName(node) {
      return node.type === 'PrivateName';
    }
    getPrivateNameSV(node) {
      return node.id.name;
    }
    hasPropertyAsPrivateName(node) {
      return (
        (node.type === 'MemberExpression' ||
          node.type === 'OptionalMemberExpression') &&
        this.isPrivateName(node.property)
      );
    }
    isObjectProperty(node) {
      return node.type === 'ObjectProperty';
    }
    isObjectMethod(node) {
      return node.type === 'ObjectMethod';
    }
    initializeScopes(inModule = this.options.sourceType === 'module') {
      const oldLabels = this.state.labels;
      this.state.labels = [];
      const oldExportedIdentifiers = this.exportedIdentifiers;
      this.exportedIdentifiers = new Set();
      const oldInModule = this.inModule;
      this.inModule = inModule;
      const oldScope = this.scope;
      const ScopeHandler = this.getScopeHandler();
      this.scope = new ScopeHandler(this, inModule);
      const oldProdParam = this.prodParam;
      this.prodParam = new ProductionParameterHandler();
      const oldClassScope = this.classScope;
      this.classScope = new ClassScopeHandler(this);
      const oldExpressionScope = this.expressionScope;
      this.expressionScope = new ExpressionScopeHandler(this);
      return () => {
        this.state.labels = oldLabels;
        this.exportedIdentifiers = oldExportedIdentifiers;
        this.inModule = oldInModule;
        this.scope = oldScope;
        this.prodParam = oldProdParam;
        this.classScope = oldClassScope;
        this.expressionScope = oldExpressionScope;
      };
    }
    enterInitialScopes() {
      let paramFlags = PARAM;
      if (this.inModule) {
        paramFlags |= PARAM_AWAIT;
      }
      this.scope.enter(SCOPE_PROGRAM);
      this.prodParam.enter(paramFlags);
    }
    checkDestructuringPrivate(refExpressionErrors) {
      const {privateKeyLoc: privateKeyLoc} = refExpressionErrors;
      if (privateKeyLoc !== null) {
        this.expectPlugin('destructuringPrivate', privateKeyLoc);
      }
    }
  }
  class ExpressionErrors {
    constructor() {
      this.shorthandAssignLoc = null;
      this.doubleProtoLoc = null;
      this.privateKeyLoc = null;
      this.optionalParametersLoc = null;
    }
  }
  class Node {
    constructor(parser, pos, loc) {
      this.type = '';
      this.start = pos;
      this.end = 0;
      this.loc = new SourceLocation(loc);
      if (parser != null && parser.options.ranges) this.range = [pos, 0];
      if (parser != null && parser.filename)
        this.loc.filename = parser.filename;
    }
  }
  const NodePrototype = Node.prototype;
  {
    NodePrototype.__clone = function () {
      const newNode = new Node(undefined, this.start, this.loc.start);
      const keys = Object.keys(this);
      for (let i = 0, length = keys.length; i < length; i++) {
        const key = keys[i];
        if (
          key !== 'leadingComments' &&
          key !== 'trailingComments' &&
          key !== 'innerComments'
        ) {
          newNode[key] = this[key];
        }
      }
      return newNode;
    };
  }
  function clonePlaceholder(node) {
    return cloneIdentifier(node);
  }
  function cloneIdentifier(node) {
    const {
      type: type,
      start: start,
      end: end,
      loc: loc,
      range: range,
      extra: extra,
      name: name,
    } = node;
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    cloned.extra = extra;
    cloned.name = name;
    if (type === 'Placeholder') {
      cloned.expectedNode = node.expectedNode;
    }
    return cloned;
  }
  function cloneStringLiteral(node) {
    const {
      type: type,
      start: start,
      end: end,
      loc: loc,
      range: range,
      extra: extra,
    } = node;
    if (type === 'Placeholder') {
      return clonePlaceholder(node);
    }
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    if (node.raw !== undefined) {
      cloned.raw = node.raw;
    } else {
      cloned.extra = extra;
    }
    cloned.value = node.value;
    return cloned;
  }
  class NodeUtils extends UtilParser {
    startNode() {
      return new Node(this, this.state.start, this.state.startLoc);
    }
    startNodeAt(loc) {
      return new Node(this, loc.index, loc);
    }
    startNodeAtNode(type) {
      return this.startNodeAt(type.loc.start);
    }
    finishNode(node, type) {
      return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
    }
    finishNodeAt(node, type, endLoc) {
      node.type = type;
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges) node.range[1] = endLoc.index;
      if (this.options.attachComment) this.processComment(node);
      return node;
    }
    resetStartLocation(node, startLoc) {
      node.start = startLoc.index;
      node.loc.start = startLoc;
      if (this.options.ranges) node.range[0] = startLoc.index;
    }
    resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges) node.range[1] = endLoc.index;
    }
    resetStartLocationFromNode(node, locationNode) {
      this.resetStartLocation(node, locationNode.loc.start);
    }
  }
  const reservedTypes = new Set([
    '_',
    'any',
    'bool',
    'boolean',
    'empty',
    'extends',
    'false',
    'interface',
    'mixed',
    'null',
    'number',
    'static',
    'string',
    'true',
    'typeof',
    'void',
  ]);
  const FlowErrors = ParseErrorEnum`flow`({
    AmbiguousConditionalArrow:
      'Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.',
    AmbiguousDeclareModuleKind:
      'Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.',
    AssignReservedType: ({reservedType: reservedType}) =>
      `Cannot overwrite reserved type ${reservedType}.`,
    DeclareClassElement:
      'The `declare` modifier can only appear on class fields.',
    DeclareClassFieldInitializer:
      'Initializers are not allowed in fields with the `declare` modifier.',
    DuplicateDeclareModuleExports:
      'Duplicate `declare module.exports` statement.',
    EnumBooleanMemberNotInitialized: ({
      memberName: memberName,
      enumName: enumName,
    }) =>
      `Boolean enum members need to be initialized. Use either \`${memberName} = true,\` or \`${memberName} = false,\` in enum \`${enumName}\`.`,
    EnumDuplicateMemberName: ({memberName: memberName, enumName: enumName}) =>
      `Enum member names need to be unique, but the name \`${memberName}\` has already been used before in enum \`${enumName}\`.`,
    EnumInconsistentMemberValues: ({enumName: enumName}) =>
      `Enum \`${enumName}\` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.`,
    EnumInvalidExplicitType: ({
      invalidEnumType: invalidEnumType,
      enumName: enumName,
    }) =>
      `Enum type \`${invalidEnumType}\` is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidExplicitTypeUnknownSupplied: ({enumName: enumName}) =>
      `Supplied enum type is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerPrimaryType: ({
      enumName: enumName,
      memberName: memberName,
      explicitType: explicitType,
    }) =>
      `Enum \`${enumName}\` has type \`${explicitType}\`, so the initializer of \`${memberName}\` needs to be a ${explicitType} literal.`,
    EnumInvalidMemberInitializerSymbolType: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `Symbol enum members cannot be initialized. Use \`${memberName},\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerUnknownType: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `The enum member initializer for \`${memberName}\` needs to be a literal (either a boolean, number, or string) in enum \`${enumName}\`.`,
    EnumInvalidMemberName: ({
      enumName: enumName,
      memberName: memberName,
      suggestion: suggestion,
    }) =>
      `Enum member names cannot start with lowercase 'a' through 'z'. Instead of using \`${memberName}\`, consider using \`${suggestion}\`, in enum \`${enumName}\`.`,
    EnumNumberMemberNotInitialized: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `Number enum members need to be initialized, e.g. \`${memberName} = 1\` in enum \`${enumName}\`.`,
    EnumStringMemberInconsistentlyInitailized: ({enumName: enumName}) =>
      `String enum members need to consistently either all use initializers, or use no initializers, in enum \`${enumName}\`.`,
    GetterMayNotHaveThisParam: 'A getter cannot have a `this` parameter.',
    ImportReflectionHasImportType:
      'An `import module` declaration can not use `type` or `typeof` keyword.',
    ImportTypeShorthandOnlyInPureImport:
      'The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.',
    InexactInsideExact:
      'Explicit inexact syntax cannot appear inside an explicit exact object type.',
    InexactInsideNonObject:
      'Explicit inexact syntax cannot appear in class or interface definitions.',
    InexactVariance: 'Explicit inexact syntax cannot have variance.',
    InvalidNonTypeImportInDeclareModule:
      'Imports within a `declare module` body must always be `import type` or `import typeof`.',
    MissingTypeParamDefault:
      'Type parameter declaration needs a default, since a preceding type parameter declaration has a default.',
    NestedDeclareModule:
      '`declare module` cannot be used inside another `declare module`.',
    NestedFlowComment:
      'Cannot have a flow comment inside another flow comment.',
    PatternIsOptional: Object.assign(
      {
        message:
          'A binding pattern parameter cannot be optional in an implementation signature.',
      },
      {reasonCode: 'OptionalBindingPattern'}
    ),
    SetterMayNotHaveThisParam: 'A setter cannot have a `this` parameter.',
    SpreadVariance: 'Spread properties cannot have variance.',
    ThisParamAnnotationRequired:
      'A type annotation is required for the `this` parameter.',
    ThisParamBannedInConstructor:
      "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
    ThisParamMayNotBeOptional: 'The `this` parameter cannot be optional.',
    ThisParamMustBeFirst:
      'The `this` parameter must be the first function parameter.',
    ThisParamNoDefault: 'The `this` parameter may not have a default value.',
    TypeBeforeInitializer:
      'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
    TypeCastInPattern:
      'The type cast expression is expected to be wrapped with parenthesis.',
    UnexpectedExplicitInexactInObject:
      'Explicit inexact syntax must appear at the end of an inexact object.',
    UnexpectedReservedType: ({reservedType: reservedType}) =>
      `Unexpected reserved type ${reservedType}.`,
    UnexpectedReservedUnderscore:
      '`_` is only allowed as a type argument to call or new.',
    UnexpectedSpaceBetweenModuloChecks:
      'Spaces between `%` and `checks` are not allowed here.',
    UnexpectedSpreadType:
      'Spread operator cannot appear in class or interface definitions.',
    UnexpectedSubtractionOperand:
      'Unexpected token, expected "number" or "bigint".',
    UnexpectedTokenAfterTypeParameter:
      'Expected an arrow function after this type parameter declaration.',
    UnexpectedTypeParameterBeforeAsyncArrowFunction:
      'Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.',
    UnsupportedDeclareExportKind: ({
      unsupportedExportKind: unsupportedExportKind,
      suggestion: suggestion,
    }) =>
      `\`declare export ${unsupportedExportKind}\` is not supported. Use \`${suggestion}\` instead.`,
    UnsupportedStatementInDeclareModule:
      'Only declares and type imports are allowed inside declare module.',
    UnterminatedFlowComment: 'Unterminated flow-comment.',
  });
  function isEsModuleType(bodyElement) {
    return (
      bodyElement.type === 'DeclareExportAllDeclaration' ||
      (bodyElement.type === 'DeclareExportDeclaration' &&
        (!bodyElement.declaration ||
          (bodyElement.declaration.type !== 'TypeAlias' &&
            bodyElement.declaration.type !== 'InterfaceDeclaration')))
    );
  }
  function hasTypeImportKind(node) {
    return node.importKind === 'type' || node.importKind === 'typeof';
  }
  function isMaybeDefaultImport(type) {
    return tokenIsKeywordOrIdentifier(type) && type !== 97;
  }
  const exportSuggestions = {
    const: 'declare export var',
    let: 'declare export var',
    type: 'export type',
    interface: 'export interface',
  };
  function partition(list, test) {
    const list1 = [];
    const list2 = [];
    for (let i = 0; i < list.length; i++) {
      (test(list[i], i, list) ? list1 : list2).push(list[i]);
    }
    return [list1, list2];
  }
  const FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
  var flow = superClass =>
    class FlowParserMixin extends superClass {
      constructor(...args) {
        super(...args);
        this.flowPragma = undefined;
      }
      getScopeHandler() {
        return FlowScopeHandler;
      }
      shouldParseTypes() {
        return (
          this.getPluginOption('flow', 'all') || this.flowPragma === 'flow'
        );
      }
      shouldParseEnums() {
        return !!this.getPluginOption('flow', 'enums');
      }
      finishToken(type, val) {
        if (type !== 131 && type !== 13 && type !== 28) {
          if (this.flowPragma === undefined) {
            this.flowPragma = null;
          }
        }
        super.finishToken(type, val);
      }
      addComment(comment) {
        if (this.flowPragma === undefined) {
          const matches = FLOW_PRAGMA_REGEX.exec(comment.value);
          if (!matches);
          else if (matches[1] === 'flow') {
            this.flowPragma = 'flow';
          } else if (matches[1] === 'noflow') {
            this.flowPragma = 'noflow';
          } else {
            throw new Error('Unexpected flow pragma');
          }
        }
        super.addComment(comment);
      }
      flowParseTypeInitialiser(tok) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        this.expect(tok || 14);
        const type = this.flowParseType();
        this.state.inType = oldInType;
        return type;
      }
      flowParsePredicate() {
        const node = this.startNode();
        const moduloLoc = this.state.startLoc;
        this.next();
        this.expectContextual(108);
        if (this.state.lastTokStart > moduloLoc.index + 1) {
          this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, {
            at: moduloLoc,
          });
        }
        if (this.eat(10)) {
          node.value = super.parseExpression();
          this.expect(11);
          return this.finishNode(node, 'DeclaredPredicate');
        } else {
          return this.finishNode(node, 'InferredPredicate');
        }
      }
      flowParseTypeAndPredicateInitialiser() {
        const oldInType = this.state.inType;
        this.state.inType = true;
        this.expect(14);
        let type = null;
        let predicate = null;
        if (this.match(54)) {
          this.state.inType = oldInType;
          predicate = this.flowParsePredicate();
        } else {
          type = this.flowParseType();
          this.state.inType = oldInType;
          if (this.match(54)) {
            predicate = this.flowParsePredicate();
          }
        }
        return [type, predicate];
      }
      flowParseDeclareClass(node) {
        this.next();
        this.flowParseInterfaceish(node, true);
        return this.finishNode(node, 'DeclareClass');
      }
      flowParseDeclareFunction(node) {
        this.next();
        const id = (node.id = this.parseIdentifier());
        const typeNode = this.startNode();
        const typeContainer = this.startNode();
        if (this.match(47)) {
          typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          typeNode.typeParameters = null;
        }
        this.expect(10);
        const tmp = this.flowParseFunctionTypeParams();
        typeNode.params = tmp.params;
        typeNode.rest = tmp.rest;
        typeNode.this = tmp._this;
        this.expect(11);
        [typeNode.returnType, node.predicate] =
          this.flowParseTypeAndPredicateInitialiser();
        typeContainer.typeAnnotation = this.finishNode(
          typeNode,
          'FunctionTypeAnnotation'
        );
        id.typeAnnotation = this.finishNode(typeContainer, 'TypeAnnotation');
        this.resetEndLocation(id);
        this.semicolon();
        this.scope.declareName(
          node.id.name,
          BIND_FLOW_DECLARE_FN,
          node.id.loc.start
        );
        return this.finishNode(node, 'DeclareFunction');
      }
      flowParseDeclare(node, insideModule) {
        if (this.match(80)) {
          return this.flowParseDeclareClass(node);
        } else if (this.match(68)) {
          return this.flowParseDeclareFunction(node);
        } else if (this.match(74)) {
          return this.flowParseDeclareVariable(node);
        } else if (this.eatContextual(125)) {
          if (this.match(16)) {
            return this.flowParseDeclareModuleExports(node);
          } else {
            if (insideModule) {
              this.raise(FlowErrors.NestedDeclareModule, {
                at: this.state.lastTokStartLoc,
              });
            }
            return this.flowParseDeclareModule(node);
          }
        } else if (this.isContextual(128)) {
          return this.flowParseDeclareTypeAlias(node);
        } else if (this.isContextual(129)) {
          return this.flowParseDeclareOpaqueType(node);
        } else if (this.isContextual(127)) {
          return this.flowParseDeclareInterface(node);
        } else if (this.match(82)) {
          return this.flowParseDeclareExportDeclaration(node, insideModule);
        } else {
          this.unexpected();
        }
      }
      flowParseDeclareVariable(node) {
        this.next();
        node.id = this.flowParseTypeAnnotatableIdentifier(true);
        this.scope.declareName(node.id.name, BIND_VAR, node.id.loc.start);
        this.semicolon();
        return this.finishNode(node, 'DeclareVariable');
      }
      flowParseDeclareModule(node) {
        this.scope.enter(SCOPE_OTHER);
        if (this.match(131)) {
          node.id = super.parseExprAtom();
        } else {
          node.id = this.parseIdentifier();
        }
        const bodyNode = (node.body = this.startNode());
        const body = (bodyNode.body = []);
        this.expect(5);
        while (!this.match(8)) {
          let bodyNode = this.startNode();
          if (this.match(83)) {
            this.next();
            if (!this.isContextual(128) && !this.match(87)) {
              this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, {
                at: this.state.lastTokStartLoc,
              });
            }
            super.parseImport(bodyNode);
          } else {
            this.expectContextual(
              123,
              FlowErrors.UnsupportedStatementInDeclareModule
            );
            bodyNode = this.flowParseDeclare(bodyNode, true);
          }
          body.push(bodyNode);
        }
        this.scope.exit();
        this.expect(8);
        this.finishNode(bodyNode, 'BlockStatement');
        let kind = null;
        let hasModuleExport = false;
        body.forEach(bodyElement => {
          if (isEsModuleType(bodyElement)) {
            if (kind === 'CommonJS') {
              this.raise(FlowErrors.AmbiguousDeclareModuleKind, {
                at: bodyElement,
              });
            }
            kind = 'ES';
          } else if (bodyElement.type === 'DeclareModuleExports') {
            if (hasModuleExport) {
              this.raise(FlowErrors.DuplicateDeclareModuleExports, {
                at: bodyElement,
              });
            }
            if (kind === 'ES') {
              this.raise(FlowErrors.AmbiguousDeclareModuleKind, {
                at: bodyElement,
              });
            }
            kind = 'CommonJS';
            hasModuleExport = true;
          }
        });
        node.kind = kind || 'CommonJS';
        return this.finishNode(node, 'DeclareModule');
      }
      flowParseDeclareExportDeclaration(node, insideModule) {
        this.expect(82);
        if (this.eat(65)) {
          if (this.match(68) || this.match(80)) {
            node.declaration = this.flowParseDeclare(this.startNode());
          } else {
            node.declaration = this.flowParseType();
            this.semicolon();
          }
          node.default = true;
          return this.finishNode(node, 'DeclareExportDeclaration');
        } else {
          if (
            this.match(75) ||
            this.isLet() ||
            ((this.isContextual(128) || this.isContextual(127)) &&
              !insideModule)
          ) {
            const label = this.state.value;
            throw this.raise(FlowErrors.UnsupportedDeclareExportKind, {
              at: this.state.startLoc,
              unsupportedExportKind: label,
              suggestion: exportSuggestions[label],
            });
          }
          if (
            this.match(74) ||
            this.match(68) ||
            this.match(80) ||
            this.isContextual(129)
          ) {
            node.declaration = this.flowParseDeclare(this.startNode());
            node.default = false;
            return this.finishNode(node, 'DeclareExportDeclaration');
          } else if (
            this.match(55) ||
            this.match(5) ||
            this.isContextual(127) ||
            this.isContextual(128) ||
            this.isContextual(129)
          ) {
            node = this.parseExport(node, null);
            if (node.type === 'ExportNamedDeclaration') {
              node.type = 'ExportDeclaration';
              node.default = false;
              delete node.exportKind;
            }
            node.type = 'Declare' + node.type;
            return node;
          }
        }
        this.unexpected();
      }
      flowParseDeclareModuleExports(node) {
        this.next();
        this.expectContextual(109);
        node.typeAnnotation = this.flowParseTypeAnnotation();
        this.semicolon();
        return this.finishNode(node, 'DeclareModuleExports');
      }
      flowParseDeclareTypeAlias(node) {
        this.next();
        const finished = this.flowParseTypeAlias(node);
        finished.type = 'DeclareTypeAlias';
        return finished;
      }
      flowParseDeclareOpaqueType(node) {
        this.next();
        const finished = this.flowParseOpaqueType(node, true);
        finished.type = 'DeclareOpaqueType';
        return finished;
      }
      flowParseDeclareInterface(node) {
        this.next();
        this.flowParseInterfaceish(node, false);
        return this.finishNode(node, 'DeclareInterface');
      }
      flowParseInterfaceish(node, isClass) {
        node.id = this.flowParseRestrictedIdentifier(!isClass, true);
        this.scope.declareName(
          node.id.name,
          isClass ? BIND_FUNCTION : BIND_LEXICAL,
          node.id.loc.start
        );
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.extends = [];
        node.implements = [];
        node.mixins = [];
        if (this.eat(81)) {
          do {
            node.extends.push(this.flowParseInterfaceExtends());
          } while (!isClass && this.eat(12));
        }
        if (isClass) {
          if (this.eatContextual(115)) {
            do {
              node.mixins.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
          if (this.eatContextual(111)) {
            do {
              node.implements.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
        }
        node.body = this.flowParseObjectType({
          allowStatic: isClass,
          allowExact: false,
          allowSpread: false,
          allowProto: isClass,
          allowInexact: false,
        });
      }
      flowParseInterfaceExtends() {
        const node = this.startNode();
        node.id = this.flowParseQualifiedTypeIdentifier();
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterInstantiation();
        } else {
          node.typeParameters = null;
        }
        return this.finishNode(node, 'InterfaceExtends');
      }
      flowParseInterface(node) {
        this.flowParseInterfaceish(node, false);
        return this.finishNode(node, 'InterfaceDeclaration');
      }
      checkNotUnderscore(word) {
        if (word === '_') {
          this.raise(FlowErrors.UnexpectedReservedUnderscore, {
            at: this.state.startLoc,
          });
        }
      }
      checkReservedType(word, startLoc, declaration) {
        if (!reservedTypes.has(word)) return;
        this.raise(
          declaration
            ? FlowErrors.AssignReservedType
            : FlowErrors.UnexpectedReservedType,
          {at: startLoc, reservedType: word}
        );
      }
      flowParseRestrictedIdentifier(liberal, declaration) {
        this.checkReservedType(
          this.state.value,
          this.state.startLoc,
          declaration
        );
        return this.parseIdentifier(liberal);
      }
      flowParseTypeAlias(node) {
        node.id = this.flowParseRestrictedIdentifier(false, true);
        this.scope.declareName(node.id.name, BIND_LEXICAL, node.id.loc.start);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.right = this.flowParseTypeInitialiser(29);
        this.semicolon();
        return this.finishNode(node, 'TypeAlias');
      }
      flowParseOpaqueType(node, declare) {
        this.expectContextual(128);
        node.id = this.flowParseRestrictedIdentifier(true, true);
        this.scope.declareName(node.id.name, BIND_LEXICAL, node.id.loc.start);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.supertype = null;
        if (this.match(14)) {
          node.supertype = this.flowParseTypeInitialiser(14);
        }
        node.impltype = null;
        if (!declare) {
          node.impltype = this.flowParseTypeInitialiser(29);
        }
        this.semicolon();
        return this.finishNode(node, 'OpaqueType');
      }
      flowParseTypeParameter(requireDefault = false) {
        const nodeStartLoc = this.state.startLoc;
        const node = this.startNode();
        const variance = this.flowParseVariance();
        const ident = this.flowParseTypeAnnotatableIdentifier();
        node.name = ident.name;
        node.variance = variance;
        node.bound = ident.typeAnnotation;
        if (this.match(29)) {
          this.eat(29);
          node.default = this.flowParseType();
        } else {
          if (requireDefault) {
            this.raise(FlowErrors.MissingTypeParamDefault, {at: nodeStartLoc});
          }
        }
        return this.finishNode(node, 'TypeParameter');
      }
      flowParseTypeParameterDeclaration() {
        const oldInType = this.state.inType;
        const node = this.startNode();
        node.params = [];
        this.state.inType = true;
        if (this.match(47) || this.match(140)) {
          this.next();
        } else {
          this.unexpected();
        }
        let defaultRequired = false;
        do {
          const typeParameter = this.flowParseTypeParameter(defaultRequired);
          node.params.push(typeParameter);
          if (typeParameter.default) {
            defaultRequired = true;
          }
          if (!this.match(48)) {
            this.expect(12);
          }
        } while (!this.match(48));
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterDeclaration');
      }
      flowParseTypeParameterInstantiation() {
        const node = this.startNode();
        const oldInType = this.state.inType;
        node.params = [];
        this.state.inType = true;
        this.expect(47);
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        this.state.noAnonFunctionType = false;
        while (!this.match(48)) {
          node.params.push(this.flowParseType());
          if (!this.match(48)) {
            this.expect(12);
          }
        }
        this.state.noAnonFunctionType = oldNoAnonFunctionType;
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterInstantiation');
      }
      flowParseTypeParameterInstantiationCallOrNew() {
        const node = this.startNode();
        const oldInType = this.state.inType;
        node.params = [];
        this.state.inType = true;
        this.expect(47);
        while (!this.match(48)) {
          node.params.push(this.flowParseTypeOrImplicitInstantiation());
          if (!this.match(48)) {
            this.expect(12);
          }
        }
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterInstantiation');
      }
      flowParseInterfaceType() {
        const node = this.startNode();
        this.expectContextual(127);
        node.extends = [];
        if (this.eat(81)) {
          do {
            node.extends.push(this.flowParseInterfaceExtends());
          } while (this.eat(12));
        }
        node.body = this.flowParseObjectType({
          allowStatic: false,
          allowExact: false,
          allowSpread: false,
          allowProto: false,
          allowInexact: false,
        });
        return this.finishNode(node, 'InterfaceTypeAnnotation');
      }
      flowParseObjectPropertyKey() {
        return this.match(132) || this.match(131)
          ? super.parseExprAtom()
          : this.parseIdentifier(true);
      }
      flowParseObjectTypeIndexer(node, isStatic, variance) {
        node.static = isStatic;
        if (this.lookahead().type === 14) {
          node.id = this.flowParseObjectPropertyKey();
          node.key = this.flowParseTypeInitialiser();
        } else {
          node.id = null;
          node.key = this.flowParseType();
        }
        this.expect(3);
        node.value = this.flowParseTypeInitialiser();
        node.variance = variance;
        return this.finishNode(node, 'ObjectTypeIndexer');
      }
      flowParseObjectTypeInternalSlot(node, isStatic) {
        node.static = isStatic;
        node.id = this.flowParseObjectPropertyKey();
        this.expect(3);
        this.expect(3);
        if (this.match(47) || this.match(10)) {
          node.method = true;
          node.optional = false;
          node.value = this.flowParseObjectTypeMethodish(
            this.startNodeAt(node.loc.start)
          );
        } else {
          node.method = false;
          if (this.eat(17)) {
            node.optional = true;
          }
          node.value = this.flowParseTypeInitialiser();
        }
        return this.finishNode(node, 'ObjectTypeInternalSlot');
      }
      flowParseObjectTypeMethodish(node) {
        node.params = [];
        node.rest = null;
        node.typeParameters = null;
        node.this = null;
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        this.expect(10);
        if (this.match(78)) {
          node.this = this.flowParseFunctionTypeParam(true);
          node.this.name = null;
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        while (!this.match(11) && !this.match(21)) {
          node.params.push(this.flowParseFunctionTypeParam(false));
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        if (this.eat(21)) {
          node.rest = this.flowParseFunctionTypeParam(false);
        }
        this.expect(11);
        node.returnType = this.flowParseTypeInitialiser();
        return this.finishNode(node, 'FunctionTypeAnnotation');
      }
      flowParseObjectTypeCallProperty(node, isStatic) {
        const valueNode = this.startNode();
        node.static = isStatic;
        node.value = this.flowParseObjectTypeMethodish(valueNode);
        return this.finishNode(node, 'ObjectTypeCallProperty');
      }
      flowParseObjectType({
        allowStatic: allowStatic,
        allowExact: allowExact,
        allowSpread: allowSpread,
        allowProto: allowProto,
        allowInexact: allowInexact,
      }) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        const nodeStart = this.startNode();
        nodeStart.callProperties = [];
        nodeStart.properties = [];
        nodeStart.indexers = [];
        nodeStart.internalSlots = [];
        let endDelim;
        let exact;
        let inexact = false;
        if (allowExact && this.match(6)) {
          this.expect(6);
          endDelim = 9;
          exact = true;
        } else {
          this.expect(5);
          endDelim = 8;
          exact = false;
        }
        nodeStart.exact = exact;
        while (!this.match(endDelim)) {
          let isStatic = false;
          let protoStartLoc = null;
          let inexactStartLoc = null;
          const node = this.startNode();
          if (allowProto && this.isContextual(116)) {
            const lookahead = this.lookahead();
            if (lookahead.type !== 14 && lookahead.type !== 17) {
              this.next();
              protoStartLoc = this.state.startLoc;
              allowStatic = false;
            }
          }
          if (allowStatic && this.isContextual(104)) {
            const lookahead = this.lookahead();
            if (lookahead.type !== 14 && lookahead.type !== 17) {
              this.next();
              isStatic = true;
            }
          }
          const variance = this.flowParseVariance();
          if (this.eat(0)) {
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (this.eat(0)) {
              if (variance) {
                this.unexpected(variance.loc.start);
              }
              nodeStart.internalSlots.push(
                this.flowParseObjectTypeInternalSlot(node, isStatic)
              );
            } else {
              nodeStart.indexers.push(
                this.flowParseObjectTypeIndexer(node, isStatic, variance)
              );
            }
          } else if (this.match(10) || this.match(47)) {
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            nodeStart.callProperties.push(
              this.flowParseObjectTypeCallProperty(node, isStatic)
            );
          } else {
            let kind = 'init';
            if (this.isContextual(98) || this.isContextual(103)) {
              const lookahead = this.lookahead();
              if (tokenIsLiteralPropertyName(lookahead.type)) {
                kind = this.state.value;
                this.next();
              }
            }
            const propOrInexact = this.flowParseObjectTypeProperty(
              node,
              isStatic,
              protoStartLoc,
              variance,
              kind,
              allowSpread,
              allowInexact != null ? allowInexact : !exact
            );
            if (propOrInexact === null) {
              inexact = true;
              inexactStartLoc = this.state.lastTokStartLoc;
            } else {
              nodeStart.properties.push(propOrInexact);
            }
          }
          this.flowObjectTypeSemicolon();
          if (inexactStartLoc && !this.match(8) && !this.match(9)) {
            this.raise(FlowErrors.UnexpectedExplicitInexactInObject, {
              at: inexactStartLoc,
            });
          }
        }
        this.expect(endDelim);
        if (allowSpread) {
          nodeStart.inexact = inexact;
        }
        const out = this.finishNode(nodeStart, 'ObjectTypeAnnotation');
        this.state.inType = oldInType;
        return out;
      }
      flowParseObjectTypeProperty(
        node,
        isStatic,
        protoStartLoc,
        variance,
        kind,
        allowSpread,
        allowInexact
      ) {
        if (this.eat(21)) {
          const isInexactToken =
            this.match(12) || this.match(13) || this.match(8) || this.match(9);
          if (isInexactToken) {
            if (!allowSpread) {
              this.raise(FlowErrors.InexactInsideNonObject, {
                at: this.state.lastTokStartLoc,
              });
            } else if (!allowInexact) {
              this.raise(FlowErrors.InexactInsideExact, {
                at: this.state.lastTokStartLoc,
              });
            }
            if (variance) {
              this.raise(FlowErrors.InexactVariance, {at: variance});
            }
            return null;
          }
          if (!allowSpread) {
            this.raise(FlowErrors.UnexpectedSpreadType, {
              at: this.state.lastTokStartLoc,
            });
          }
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.raise(FlowErrors.SpreadVariance, {at: variance});
          }
          node.argument = this.flowParseType();
          return this.finishNode(node, 'ObjectTypeSpreadProperty');
        } else {
          node.key = this.flowParseObjectPropertyKey();
          node.static = isStatic;
          node.proto = protoStartLoc != null;
          node.kind = kind;
          let optional = false;
          if (this.match(47) || this.match(10)) {
            node.method = true;
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            node.value = this.flowParseObjectTypeMethodish(
              this.startNodeAt(node.loc.start)
            );
            if (kind === 'get' || kind === 'set') {
              this.flowCheckGetterSetterParams(node);
            }
            if (
              !allowSpread &&
              node.key.name === 'constructor' &&
              node.value.this
            ) {
              this.raise(FlowErrors.ThisParamBannedInConstructor, {
                at: node.value.this,
              });
            }
          } else {
            if (kind !== 'init') this.unexpected();
            node.method = false;
            if (this.eat(17)) {
              optional = true;
            }
            node.value = this.flowParseTypeInitialiser();
            node.variance = variance;
          }
          node.optional = optional;
          return this.finishNode(node, 'ObjectTypeProperty');
        }
      }
      flowCheckGetterSetterParams(property) {
        const paramCount = property.kind === 'get' ? 0 : 1;
        const length =
          property.value.params.length + (property.value.rest ? 1 : 0);
        if (property.value.this) {
          this.raise(
            property.kind === 'get'
              ? FlowErrors.GetterMayNotHaveThisParam
              : FlowErrors.SetterMayNotHaveThisParam,
            {at: property.value.this}
          );
        }
        if (length !== paramCount) {
          this.raise(
            property.kind === 'get'
              ? Errors.BadGetterArity
              : Errors.BadSetterArity,
            {at: property}
          );
        }
        if (property.kind === 'set' && property.value.rest) {
          this.raise(Errors.BadSetterRestParameter, {at: property});
        }
      }
      flowObjectTypeSemicolon() {
        if (
          !this.eat(13) &&
          !this.eat(12) &&
          !this.match(8) &&
          !this.match(9)
        ) {
          this.unexpected();
        }
      }
      flowParseQualifiedTypeIdentifier(startLoc, id) {
        var _startLoc;
        (_startLoc = startLoc) != null
          ? _startLoc
          : (startLoc = this.state.startLoc);
        let node = id || this.flowParseRestrictedIdentifier(true);
        while (this.eat(16)) {
          const node2 = this.startNodeAt(startLoc);
          node2.qualification = node;
          node2.id = this.flowParseRestrictedIdentifier(true);
          node = this.finishNode(node2, 'QualifiedTypeIdentifier');
        }
        return node;
      }
      flowParseGenericType(startLoc, id) {
        const node = this.startNodeAt(startLoc);
        node.typeParameters = null;
        node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterInstantiation();
        }
        return this.finishNode(node, 'GenericTypeAnnotation');
      }
      flowParseTypeofType() {
        const node = this.startNode();
        this.expect(87);
        node.argument = this.flowParsePrimaryType();
        return this.finishNode(node, 'TypeofTypeAnnotation');
      }
      flowParseTupleType() {
        const node = this.startNode();
        node.types = [];
        this.expect(0);
        while (this.state.pos < this.length && !this.match(3)) {
          node.types.push(this.flowParseType());
          if (this.match(3)) break;
          this.expect(12);
        }
        this.expect(3);
        return this.finishNode(node, 'TupleTypeAnnotation');
      }
      flowParseFunctionTypeParam(first) {
        let name = null;
        let optional = false;
        let typeAnnotation = null;
        const node = this.startNode();
        const lh = this.lookahead();
        const isThis = this.state.type === 78;
        if (lh.type === 14 || lh.type === 17) {
          if (isThis && !first) {
            this.raise(FlowErrors.ThisParamMustBeFirst, {at: node});
          }
          name = this.parseIdentifier(isThis);
          if (this.eat(17)) {
            optional = true;
            if (isThis) {
              this.raise(FlowErrors.ThisParamMayNotBeOptional, {at: node});
            }
          }
          typeAnnotation = this.flowParseTypeInitialiser();
        } else {
          typeAnnotation = this.flowParseType();
        }
        node.name = name;
        node.optional = optional;
        node.typeAnnotation = typeAnnotation;
        return this.finishNode(node, 'FunctionTypeParam');
      }
      reinterpretTypeAsFunctionTypeParam(type) {
        const node = this.startNodeAt(type.loc.start);
        node.name = null;
        node.optional = false;
        node.typeAnnotation = type;
        return this.finishNode(node, 'FunctionTypeParam');
      }
      flowParseFunctionTypeParams(params = []) {
        let rest = null;
        let _this = null;
        if (this.match(78)) {
          _this = this.flowParseFunctionTypeParam(true);
          _this.name = null;
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        while (!this.match(11) && !this.match(21)) {
          params.push(this.flowParseFunctionTypeParam(false));
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        if (this.eat(21)) {
          rest = this.flowParseFunctionTypeParam(false);
        }
        return {params: params, rest: rest, _this: _this};
      }
      flowIdentToTypeAnnotation(startLoc, node, id) {
        switch (id.name) {
          case 'any':
            return this.finishNode(node, 'AnyTypeAnnotation');
          case 'bool':
          case 'boolean':
            return this.finishNode(node, 'BooleanTypeAnnotation');
          case 'mixed':
            return this.finishNode(node, 'MixedTypeAnnotation');
          case 'empty':
            return this.finishNode(node, 'EmptyTypeAnnotation');
          case 'number':
            return this.finishNode(node, 'NumberTypeAnnotation');
          case 'string':
            return this.finishNode(node, 'StringTypeAnnotation');
          case 'symbol':
            return this.finishNode(node, 'SymbolTypeAnnotation');
          default:
            this.checkNotUnderscore(id.name);
            return this.flowParseGenericType(startLoc, id);
        }
      }
      flowParsePrimaryType() {
        const startLoc = this.state.startLoc;
        const node = this.startNode();
        let tmp;
        let type;
        let isGroupedType = false;
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        switch (this.state.type) {
          case 5:
            return this.flowParseObjectType({
              allowStatic: false,
              allowExact: false,
              allowSpread: true,
              allowProto: false,
              allowInexact: true,
            });
          case 6:
            return this.flowParseObjectType({
              allowStatic: false,
              allowExact: true,
              allowSpread: true,
              allowProto: false,
              allowInexact: false,
            });
          case 0:
            this.state.noAnonFunctionType = false;
            type = this.flowParseTupleType();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            return type;
          case 47:
            node.typeParameters = this.flowParseTypeParameterDeclaration();
            this.expect(10);
            tmp = this.flowParseFunctionTypeParams();
            node.params = tmp.params;
            node.rest = tmp.rest;
            node.this = tmp._this;
            this.expect(11);
            this.expect(19);
            node.returnType = this.flowParseType();
            return this.finishNode(node, 'FunctionTypeAnnotation');
          case 10:
            this.next();
            if (!this.match(11) && !this.match(21)) {
              if (tokenIsIdentifier(this.state.type) || this.match(78)) {
                const token = this.lookahead().type;
                isGroupedType = token !== 17 && token !== 14;
              } else {
                isGroupedType = true;
              }
            }
            if (isGroupedType) {
              this.state.noAnonFunctionType = false;
              type = this.flowParseType();
              this.state.noAnonFunctionType = oldNoAnonFunctionType;
              if (
                this.state.noAnonFunctionType ||
                !(
                  this.match(12) ||
                  (this.match(11) && this.lookahead().type === 19)
                )
              ) {
                this.expect(11);
                return type;
              } else {
                this.eat(12);
              }
            }
            if (type) {
              tmp = this.flowParseFunctionTypeParams([
                this.reinterpretTypeAsFunctionTypeParam(type),
              ]);
            } else {
              tmp = this.flowParseFunctionTypeParams();
            }
            node.params = tmp.params;
            node.rest = tmp.rest;
            node.this = tmp._this;
            this.expect(11);
            this.expect(19);
            node.returnType = this.flowParseType();
            node.typeParameters = null;
            return this.finishNode(node, 'FunctionTypeAnnotation');
          case 131:
            return this.parseLiteral(
              this.state.value,
              'StringLiteralTypeAnnotation'
            );
          case 85:
          case 86:
            node.value = this.match(85);
            this.next();
            return this.finishNode(node, 'BooleanLiteralTypeAnnotation');
          case 53:
            if (this.state.value === '-') {
              this.next();
              if (this.match(132)) {
                return this.parseLiteralAtNode(
                  -this.state.value,
                  'NumberLiteralTypeAnnotation',
                  node
                );
              }
              if (this.match(133)) {
                return this.parseLiteralAtNode(
                  -this.state.value,
                  'BigIntLiteralTypeAnnotation',
                  node
                );
              }
              throw this.raise(FlowErrors.UnexpectedSubtractionOperand, {
                at: this.state.startLoc,
              });
            }
            this.unexpected();
            return;
          case 132:
            return this.parseLiteral(
              this.state.value,
              'NumberLiteralTypeAnnotation'
            );
          case 133:
            return this.parseLiteral(
              this.state.value,
              'BigIntLiteralTypeAnnotation'
            );
          case 88:
            this.next();
            return this.finishNode(node, 'VoidTypeAnnotation');
          case 84:
            this.next();
            return this.finishNode(node, 'NullLiteralTypeAnnotation');
          case 78:
            this.next();
            return this.finishNode(node, 'ThisTypeAnnotation');
          case 55:
            this.next();
            return this.finishNode(node, 'ExistsTypeAnnotation');
          case 87:
            return this.flowParseTypeofType();
          default:
            if (tokenIsKeyword(this.state.type)) {
              const label = tokenLabelName(this.state.type);
              this.next();
              return super.createIdentifier(node, label);
            } else if (tokenIsIdentifier(this.state.type)) {
              if (this.isContextual(127)) {
                return this.flowParseInterfaceType();
              }
              return this.flowIdentToTypeAnnotation(
                startLoc,
                node,
                this.parseIdentifier()
              );
            }
        }
        this.unexpected();
      }
      flowParsePostfixType() {
        const startLoc = this.state.startLoc;
        let type = this.flowParsePrimaryType();
        let seenOptionalIndexedAccess = false;
        while (
          (this.match(0) || this.match(18)) &&
          !this.canInsertSemicolon()
        ) {
          const node = this.startNodeAt(startLoc);
          const optional = this.eat(18);
          seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
          this.expect(0);
          if (!optional && this.match(3)) {
            node.elementType = type;
            this.next();
            type = this.finishNode(node, 'ArrayTypeAnnotation');
          } else {
            node.objectType = type;
            node.indexType = this.flowParseType();
            this.expect(3);
            if (seenOptionalIndexedAccess) {
              node.optional = optional;
              type = this.finishNode(node, 'OptionalIndexedAccessType');
            } else {
              type = this.finishNode(node, 'IndexedAccessType');
            }
          }
        }
        return type;
      }
      flowParsePrefixType() {
        const node = this.startNode();
        if (this.eat(17)) {
          node.typeAnnotation = this.flowParsePrefixType();
          return this.finishNode(node, 'NullableTypeAnnotation');
        } else {
          return this.flowParsePostfixType();
        }
      }
      flowParseAnonFunctionWithoutParens() {
        const param = this.flowParsePrefixType();
        if (!this.state.noAnonFunctionType && this.eat(19)) {
          const node = this.startNodeAt(param.loc.start);
          node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
          node.rest = null;
          node.this = null;
          node.returnType = this.flowParseType();
          node.typeParameters = null;
          return this.finishNode(node, 'FunctionTypeAnnotation');
        }
        return param;
      }
      flowParseIntersectionType() {
        const node = this.startNode();
        this.eat(45);
        const type = this.flowParseAnonFunctionWithoutParens();
        node.types = [type];
        while (this.eat(45)) {
          node.types.push(this.flowParseAnonFunctionWithoutParens());
        }
        return node.types.length === 1
          ? type
          : this.finishNode(node, 'IntersectionTypeAnnotation');
      }
      flowParseUnionType() {
        const node = this.startNode();
        this.eat(43);
        const type = this.flowParseIntersectionType();
        node.types = [type];
        while (this.eat(43)) {
          node.types.push(this.flowParseIntersectionType());
        }
        return node.types.length === 1
          ? type
          : this.finishNode(node, 'UnionTypeAnnotation');
      }
      flowParseType() {
        const oldInType = this.state.inType;
        this.state.inType = true;
        const type = this.flowParseUnionType();
        this.state.inType = oldInType;
        return type;
      }
      flowParseTypeOrImplicitInstantiation() {
        if (this.state.type === 130 && this.state.value === '_') {
          const startLoc = this.state.startLoc;
          const node = this.parseIdentifier();
          return this.flowParseGenericType(startLoc, node);
        } else {
          return this.flowParseType();
        }
      }
      flowParseTypeAnnotation() {
        const node = this.startNode();
        node.typeAnnotation = this.flowParseTypeInitialiser();
        return this.finishNode(node, 'TypeAnnotation');
      }
      flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
        const ident = allowPrimitiveOverride
          ? this.parseIdentifier()
          : this.flowParseRestrictedIdentifier();
        if (this.match(14)) {
          ident.typeAnnotation = this.flowParseTypeAnnotation();
          this.resetEndLocation(ident);
        }
        return ident;
      }
      typeCastToParameter(node) {
        node.expression.typeAnnotation = node.typeAnnotation;
        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
        return node.expression;
      }
      flowParseVariance() {
        let variance = null;
        if (this.match(53)) {
          variance = this.startNode();
          if (this.state.value === '+') {
            variance.kind = 'plus';
          } else {
            variance.kind = 'minus';
          }
          this.next();
          return this.finishNode(variance, 'Variance');
        }
        return variance;
      }
      parseFunctionBody(node, allowExpressionBody, isMethod = false) {
        if (allowExpressionBody) {
          this.forwardNoArrowParamsConversionAt(node, () =>
            super.parseFunctionBody(node, true, isMethod)
          );
          return;
        }
        super.parseFunctionBody(node, false, isMethod);
      }
      parseFunctionBodyAndFinish(node, type, isMethod = false) {
        if (this.match(14)) {
          const typeNode = this.startNode();
          [typeNode.typeAnnotation, node.predicate] =
            this.flowParseTypeAndPredicateInitialiser();
          node.returnType = typeNode.typeAnnotation
            ? this.finishNode(typeNode, 'TypeAnnotation')
            : null;
        }
        return super.parseFunctionBodyAndFinish(node, type, isMethod);
      }
      parseStatementLike(flags) {
        if (this.state.strict && this.isContextual(127)) {
          const lookahead = this.lookahead();
          if (tokenIsKeywordOrIdentifier(lookahead.type)) {
            const node = this.startNode();
            this.next();
            return this.flowParseInterface(node);
          }
        } else if (this.shouldParseEnums() && this.isContextual(124)) {
          const node = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(node);
        }
        const stmt = super.parseStatementLike(flags);
        if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
          this.flowPragma = null;
        }
        return stmt;
      }
      parseExpressionStatement(node, expr, decorators) {
        if (expr.type === 'Identifier') {
          if (expr.name === 'declare') {
            if (
              this.match(80) ||
              tokenIsIdentifier(this.state.type) ||
              this.match(68) ||
              this.match(74) ||
              this.match(82)
            ) {
              return this.flowParseDeclare(node);
            }
          } else if (tokenIsIdentifier(this.state.type)) {
            if (expr.name === 'interface') {
              return this.flowParseInterface(node);
            } else if (expr.name === 'type') {
              return this.flowParseTypeAlias(node);
            } else if (expr.name === 'opaque') {
              return this.flowParseOpaqueType(node, false);
            }
          }
        }
        return super.parseExpressionStatement(node, expr, decorators);
      }
      shouldParseExportDeclaration() {
        const {type: type} = this.state;
        if (
          tokenIsFlowInterfaceOrTypeOrOpaque(type) ||
          (this.shouldParseEnums() && type === 124)
        ) {
          return !this.state.containsEsc;
        }
        return super.shouldParseExportDeclaration();
      }
      isExportDefaultSpecifier() {
        const {type: type} = this.state;
        if (
          tokenIsFlowInterfaceOrTypeOrOpaque(type) ||
          (this.shouldParseEnums() && type === 124)
        ) {
          return this.state.containsEsc;
        }
        return super.isExportDefaultSpecifier();
      }
      parseExportDefaultExpression() {
        if (this.shouldParseEnums() && this.isContextual(124)) {
          const node = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(node);
        }
        return super.parseExportDefaultExpression();
      }
      parseConditional(expr, startLoc, refExpressionErrors) {
        if (!this.match(17)) return expr;
        if (this.state.maybeInArrowParameters) {
          const nextCh = this.lookaheadCharCode();
          if (
            nextCh === 44 ||
            nextCh === 61 ||
            nextCh === 58 ||
            nextCh === 41
          ) {
            this.setOptionalParametersError(refExpressionErrors);
            return expr;
          }
        }
        this.expect(17);
        const state = this.state.clone();
        const originalNoArrowAt = this.state.noArrowAt;
        const node = this.startNodeAt(startLoc);
        let {consequent: consequent, failed: failed} =
          this.tryParseConditionalConsequent();
        let [valid, invalid] = this.getArrowLikeExpressions(consequent);
        if (failed || invalid.length > 0) {
          const noArrowAt = [...originalNoArrowAt];
          if (invalid.length > 0) {
            this.state = state;
            this.state.noArrowAt = noArrowAt;
            for (let i = 0; i < invalid.length; i++) {
              noArrowAt.push(invalid[i].start);
            }
            ({consequent: consequent, failed: failed} =
              this.tryParseConditionalConsequent());
            [valid, invalid] = this.getArrowLikeExpressions(consequent);
          }
          if (failed && valid.length > 1) {
            this.raise(FlowErrors.AmbiguousConditionalArrow, {
              at: state.startLoc,
            });
          }
          if (failed && valid.length === 1) {
            this.state = state;
            noArrowAt.push(valid[0].start);
            this.state.noArrowAt = noArrowAt;
            ({consequent: consequent, failed: failed} =
              this.tryParseConditionalConsequent());
          }
        }
        this.getArrowLikeExpressions(consequent, true);
        this.state.noArrowAt = originalNoArrowAt;
        this.expect(14);
        node.test = expr;
        node.consequent = consequent;
        node.alternate = this.forwardNoArrowParamsConversionAt(node, () =>
          this.parseMaybeAssign(undefined, undefined)
        );
        return this.finishNode(node, 'ConditionalExpression');
      }
      tryParseConditionalConsequent() {
        this.state.noArrowParamsConversionAt.push(this.state.start);
        const consequent = this.parseMaybeAssignAllowIn();
        const failed = !this.match(14);
        this.state.noArrowParamsConversionAt.pop();
        return {consequent: consequent, failed: failed};
      }
      getArrowLikeExpressions(node, disallowInvalid) {
        const stack = [node];
        const arrows = [];
        while (stack.length !== 0) {
          const node = stack.pop();
          if (node.type === 'ArrowFunctionExpression') {
            if (node.typeParameters || !node.returnType) {
              this.finishArrowValidation(node);
            } else {
              arrows.push(node);
            }
            stack.push(node.body);
          } else if (node.type === 'ConditionalExpression') {
            stack.push(node.consequent);
            stack.push(node.alternate);
          }
        }
        if (disallowInvalid) {
          arrows.forEach(node => this.finishArrowValidation(node));
          return [arrows, []];
        }
        return partition(arrows, node =>
          node.params.every(param => this.isAssignable(param, true))
        );
      }
      finishArrowValidation(node) {
        var _node$extra;
        this.toAssignableList(
          node.params,
          (_node$extra = node.extra) == null
            ? void 0
            : _node$extra.trailingCommaLoc,
          false
        );
        this.scope.enter(SCOPE_FUNCTION | SCOPE_ARROW);
        super.checkParams(node, false, true);
        this.scope.exit();
      }
      forwardNoArrowParamsConversionAt(node, parse) {
        let result;
        if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
          this.state.noArrowParamsConversionAt.push(this.state.start);
          result = parse();
          this.state.noArrowParamsConversionAt.pop();
        } else {
          result = parse();
        }
        return result;
      }
      parseParenItem(node, startLoc) {
        node = super.parseParenItem(node, startLoc);
        if (this.eat(17)) {
          node.optional = true;
          this.resetEndLocation(node);
        }
        if (this.match(14)) {
          const typeCastNode = this.startNodeAt(startLoc);
          typeCastNode.expression = node;
          typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
          return this.finishNode(typeCastNode, 'TypeCastExpression');
        }
        return node;
      }
      assertModuleNodeAllowed(node) {
        if (
          (node.type === 'ImportDeclaration' &&
            (node.importKind === 'type' || node.importKind === 'typeof')) ||
          (node.type === 'ExportNamedDeclaration' &&
            node.exportKind === 'type') ||
          (node.type === 'ExportAllDeclaration' && node.exportKind === 'type')
        ) {
          return;
        }
        super.assertModuleNodeAllowed(node);
      }
      parseExport(node, decorators) {
        const decl = super.parseExport(node, decorators);
        if (
          decl.type === 'ExportNamedDeclaration' ||
          decl.type === 'ExportAllDeclaration'
        ) {
          decl.exportKind = decl.exportKind || 'value';
        }
        return decl;
      }
      parseExportDeclaration(node) {
        if (this.isContextual(128)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          if (this.match(5)) {
            node.specifiers = this.parseExportSpecifiers(true);
            super.parseExportFrom(node);
            return null;
          } else {
            return this.flowParseTypeAlias(declarationNode);
          }
        } else if (this.isContextual(129)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseOpaqueType(declarationNode, false);
        } else if (this.isContextual(127)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseInterface(declarationNode);
        } else if (this.shouldParseEnums() && this.isContextual(124)) {
          node.exportKind = 'value';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(declarationNode);
        } else {
          return super.parseExportDeclaration(node);
        }
      }
      eatExportStar(node) {
        if (super.eatExportStar(node)) return true;
        if (this.isContextual(128) && this.lookahead().type === 55) {
          node.exportKind = 'type';
          this.next();
          this.next();
          return true;
        }
        return false;
      }
      maybeParseExportNamespaceSpecifier(node) {
        const {startLoc: startLoc} = this.state;
        const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);
        if (hasNamespace && node.exportKind === 'type') {
          this.unexpected(startLoc);
        }
        return hasNamespace;
      }
      parseClassId(node, isStatement, optionalId) {
        super.parseClassId(node, isStatement, optionalId);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
      }
      parseClassMember(classBody, member, state) {
        const {startLoc: startLoc} = this.state;
        if (this.isContextual(123)) {
          if (super.parseClassMemberFromModifier(classBody, member)) {
            return;
          }
          member.declare = true;
        }
        super.parseClassMember(classBody, member, state);
        if (member.declare) {
          if (
            member.type !== 'ClassProperty' &&
            member.type !== 'ClassPrivateProperty' &&
            member.type !== 'PropertyDefinition'
          ) {
            this.raise(FlowErrors.DeclareClassElement, {at: startLoc});
          } else if (member.value) {
            this.raise(FlowErrors.DeclareClassFieldInitializer, {
              at: member.value,
            });
          }
        }
      }
      isIterator(word) {
        return word === 'iterator' || word === 'asyncIterator';
      }
      readIterator() {
        const word = super.readWord1();
        const fullWord = '@@' + word;
        if (!this.isIterator(word) || !this.state.inType) {
          this.raise(Errors.InvalidIdentifier, {
            at: this.state.curPosition(),
            identifierName: fullWord,
          });
        }
        this.finishToken(130, fullWord);
      }
      getTokenFromCode(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 123 && next === 124) {
          this.finishOp(6, 2);
        } else if (this.state.inType && (code === 62 || code === 60)) {
          this.finishOp(code === 62 ? 48 : 47, 1);
        } else if (this.state.inType && code === 63) {
          if (next === 46) {
            this.finishOp(18, 2);
          } else {
            this.finishOp(17, 1);
          }
        } else if (
          isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))
        ) {
          this.state.pos += 2;
          this.readIterator();
        } else {
          super.getTokenFromCode(code);
        }
      }
      isAssignable(node, isBinding) {
        if (node.type === 'TypeCastExpression') {
          return this.isAssignable(node.expression, isBinding);
        } else {
          return super.isAssignable(node, isBinding);
        }
      }
      toAssignable(node, isLHS = false) {
        if (
          !isLHS &&
          node.type === 'AssignmentExpression' &&
          node.left.type === 'TypeCastExpression'
        ) {
          node.left = this.typeCastToParameter(node.left);
        }
        super.toAssignable(node, isLHS);
      }
      toAssignableList(exprList, trailingCommaLoc, isLHS) {
        for (let i = 0; i < exprList.length; i++) {
          const expr = exprList[i];
          if ((expr == null ? void 0 : expr.type) === 'TypeCastExpression') {
            exprList[i] = this.typeCastToParameter(expr);
          }
        }
        super.toAssignableList(exprList, trailingCommaLoc, isLHS);
      }
      toReferencedList(exprList, isParenthesizedExpr) {
        for (let i = 0; i < exprList.length; i++) {
          var _expr$extra;
          const expr = exprList[i];
          if (
            expr &&
            expr.type === 'TypeCastExpression' &&
            !(
              (_expr$extra = expr.extra) != null && _expr$extra.parenthesized
            ) &&
            (exprList.length > 1 || !isParenthesizedExpr)
          ) {
            this.raise(FlowErrors.TypeCastInPattern, {at: expr.typeAnnotation});
          }
        }
        return exprList;
      }
      parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        const node = super.parseArrayLike(
          close,
          canBePattern,
          isTuple,
          refExpressionErrors
        );
        if (canBePattern && !this.state.maybeInArrowParameters) {
          this.toReferencedList(node.elements);
        }
        return node;
      }
      isValidLVal(type, isParenthesized, binding) {
        return (
          type === 'TypeCastExpression' ||
          super.isValidLVal(type, isParenthesized, binding)
        );
      }
      parseClassProperty(node) {
        if (this.match(14)) {
          node.typeAnnotation = this.flowParseTypeAnnotation();
        }
        return super.parseClassProperty(node);
      }
      parseClassPrivateProperty(node) {
        if (this.match(14)) {
          node.typeAnnotation = this.flowParseTypeAnnotation();
        }
        return super.parseClassPrivateProperty(node);
      }
      isClassMethod() {
        return this.match(47) || super.isClassMethod();
      }
      isClassProperty() {
        return this.match(14) || super.isClassProperty();
      }
      isNonstaticConstructor(method) {
        return !this.match(14) && super.isNonstaticConstructor(method);
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        if (method.variance) {
          this.unexpected(method.variance.loc.start);
        }
        delete method.variance;
        if (this.match(47)) {
          method.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.pushClassMethod(
          classBody,
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper
        );
        if (method.params && isConstructor) {
          const params = method.params;
          if (params.length > 0 && this.isThisParam(params[0])) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, {at: method});
          }
        } else if (
          method.type === 'MethodDefinition' &&
          isConstructor &&
          method.value.params
        ) {
          const params = method.value.params;
          if (params.length > 0 && this.isThisParam(params[0])) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, {at: method});
          }
        }
      }
      pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
        if (method.variance) {
          this.unexpected(method.variance.loc.start);
        }
        delete method.variance;
        if (this.match(47)) {
          method.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
      }
      parseClassSuper(node) {
        super.parseClassSuper(node);
        if (node.superClass && this.match(47)) {
          node.superTypeParameters = this.flowParseTypeParameterInstantiation();
        }
        if (this.isContextual(111)) {
          this.next();
          const implemented = (node.implements = []);
          do {
            const node = this.startNode();
            node.id = this.flowParseRestrictedIdentifier(true);
            if (this.match(47)) {
              node.typeParameters = this.flowParseTypeParameterInstantiation();
            } else {
              node.typeParameters = null;
            }
            implemented.push(this.finishNode(node, 'ClassImplements'));
          } while (this.eat(12));
        }
      }
      checkGetterSetterParams(method) {
        super.checkGetterSetterParams(method);
        const params = this.getObjectOrClassMethodParams(method);
        if (params.length > 0) {
          const param = params[0];
          if (this.isThisParam(param) && method.kind === 'get') {
            this.raise(FlowErrors.GetterMayNotHaveThisParam, {at: param});
          } else if (this.isThisParam(param)) {
            this.raise(FlowErrors.SetterMayNotHaveThisParam, {at: param});
          }
        }
      }
      parsePropertyNamePrefixOperator(node) {
        node.variance = this.flowParseVariance();
      }
      parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      ) {
        if (prop.variance) {
          this.unexpected(prop.variance.loc.start);
        }
        delete prop.variance;
        let typeParameters;
        if (this.match(47) && !isAccessor) {
          typeParameters = this.flowParseTypeParameterDeclaration();
          if (!this.match(10)) this.unexpected();
        }
        const result = super.parseObjPropValue(
          prop,
          startLoc,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor,
          refExpressionErrors
        );
        if (typeParameters) {
          (result.value || result).typeParameters = typeParameters;
        }
        return result;
      }
      parseAssignableListItemTypes(param) {
        if (this.eat(17)) {
          if (param.type !== 'Identifier') {
            this.raise(FlowErrors.PatternIsOptional, {at: param});
          }
          if (this.isThisParam(param)) {
            this.raise(FlowErrors.ThisParamMayNotBeOptional, {at: param});
          }
          param.optional = true;
        }
        if (this.match(14)) {
          param.typeAnnotation = this.flowParseTypeAnnotation();
        } else if (this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamAnnotationRequired, {at: param});
        }
        if (this.match(29) && this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamNoDefault, {at: param});
        }
        this.resetEndLocation(param);
        return param;
      }
      parseMaybeDefault(startLoc, left) {
        const node = super.parseMaybeDefault(startLoc, left);
        if (
          node.type === 'AssignmentPattern' &&
          node.typeAnnotation &&
          node.right.start < node.typeAnnotation.start
        ) {
          this.raise(FlowErrors.TypeBeforeInitializer, {
            at: node.typeAnnotation,
          });
        }
        return node;
      }
      shouldParseDefaultImport(node) {
        if (!hasTypeImportKind(node)) {
          return super.shouldParseDefaultImport(node);
        }
        return isMaybeDefaultImport(this.state.type);
      }
      checkImportReflection(node) {
        super.checkImportReflection(node);
        if (node.module && node.importKind !== 'value') {
          this.raise(FlowErrors.ImportReflectionHasImportType, {
            at: node.specifiers[0].loc.start,
          });
        }
      }
      parseImportSpecifierLocal(node, specifier, type) {
        specifier.local = hasTypeImportKind(node)
          ? this.flowParseRestrictedIdentifier(true, true)
          : this.parseIdentifier();
        node.specifiers.push(this.finishImportSpecifier(specifier, type));
      }
      maybeParseDefaultImportSpecifier(node) {
        node.importKind = 'value';
        let kind = null;
        if (this.match(87)) {
          kind = 'typeof';
        } else if (this.isContextual(128)) {
          kind = 'type';
        }
        if (kind) {
          const lh = this.lookahead();
          const {type: type} = lh;
          if (kind === 'type' && type === 55) {
            this.unexpected(null, lh.type);
          }
          if (isMaybeDefaultImport(type) || type === 5 || type === 55) {
            this.next();
            node.importKind = kind;
          }
        }
        return super.maybeParseDefaultImportSpecifier(node);
      }
      parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        bindingType
      ) {
        const firstIdent = specifier.imported;
        let specifierTypeKind = null;
        if (firstIdent.type === 'Identifier') {
          if (firstIdent.name === 'type') {
            specifierTypeKind = 'type';
          } else if (firstIdent.name === 'typeof') {
            specifierTypeKind = 'typeof';
          }
        }
        let isBinding = false;
        if (this.isContextual(93) && !this.isLookaheadContextual('as')) {
          const as_ident = this.parseIdentifier(true);
          if (
            specifierTypeKind !== null &&
            !tokenIsKeywordOrIdentifier(this.state.type)
          ) {
            specifier.imported = as_ident;
            specifier.importKind = specifierTypeKind;
            specifier.local = cloneIdentifier(as_ident);
          } else {
            specifier.imported = firstIdent;
            specifier.importKind = null;
            specifier.local = this.parseIdentifier();
          }
        } else {
          if (
            specifierTypeKind !== null &&
            tokenIsKeywordOrIdentifier(this.state.type)
          ) {
            specifier.imported = this.parseIdentifier(true);
            specifier.importKind = specifierTypeKind;
          } else {
            if (importedIsString) {
              throw this.raise(Errors.ImportBindingIsString, {
                at: specifier,
                importName: firstIdent.value,
              });
            }
            specifier.imported = firstIdent;
            specifier.importKind = null;
          }
          if (this.eatContextual(93)) {
            specifier.local = this.parseIdentifier();
          } else {
            isBinding = true;
            specifier.local = cloneIdentifier(specifier.imported);
          }
        }
        const specifierIsTypeImport = hasTypeImportKind(specifier);
        if (isInTypeOnlyImport && specifierIsTypeImport) {
          this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, {
            at: specifier,
          });
        }
        if (isInTypeOnlyImport || specifierIsTypeImport) {
          this.checkReservedType(
            specifier.local.name,
            specifier.local.loc.start,
            true
          );
        }
        if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
          this.checkReservedWord(
            specifier.local.name,
            specifier.loc.start,
            true,
            true
          );
        }
        return this.finishImportSpecifier(specifier, 'ImportSpecifier');
      }
      parseBindingAtom() {
        switch (this.state.type) {
          case 78:
            return this.parseIdentifier(true);
          default:
            return super.parseBindingAtom();
        }
      }
      parseFunctionParams(node, isConstructor) {
        const kind = node.kind;
        if (kind !== 'get' && kind !== 'set' && this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.parseFunctionParams(node, isConstructor);
      }
      parseVarId(decl, kind) {
        super.parseVarId(decl, kind);
        if (this.match(14)) {
          decl.id.typeAnnotation = this.flowParseTypeAnnotation();
          this.resetEndLocation(decl.id);
        }
      }
      parseAsyncArrowFromCallExpression(node, call) {
        if (this.match(14)) {
          const oldNoAnonFunctionType = this.state.noAnonFunctionType;
          this.state.noAnonFunctionType = true;
          node.returnType = this.flowParseTypeAnnotation();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
        }
        return super.parseAsyncArrowFromCallExpression(node, call);
      }
      shouldParseAsyncArrow() {
        return this.match(14) || super.shouldParseAsyncArrow();
      }
      parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var _jsx;
        let state = null;
        let jsx;
        if (this.hasPlugin('jsx') && (this.match(140) || this.match(47))) {
          state = this.state.clone();
          jsx = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!jsx.error) return jsx.node;
          const {context: context} = this.state;
          const currentContext = context[context.length - 1];
          if (
            currentContext === types.j_oTag ||
            currentContext === types.j_expr
          ) {
            context.pop();
          }
        }
        if (((_jsx = jsx) != null && _jsx.error) || this.match(47)) {
          var _jsx2, _jsx3;
          state = state || this.state.clone();
          let typeParameters;
          const arrow = this.tryParse(abort => {
            var _arrowExpression$extr;
            typeParameters = this.flowParseTypeParameterDeclaration();
            const arrowExpression = this.forwardNoArrowParamsConversionAt(
              typeParameters,
              () => {
                const result = super.parseMaybeAssign(
                  refExpressionErrors,
                  afterLeftParse
                );
                this.resetStartLocationFromNode(result, typeParameters);
                return result;
              }
            );
            if (
              (_arrowExpression$extr = arrowExpression.extra) != null &&
              _arrowExpression$extr.parenthesized
            )
              abort();
            const expr = this.maybeUnwrapTypeCastExpression(arrowExpression);
            if (expr.type !== 'ArrowFunctionExpression') abort();
            expr.typeParameters = typeParameters;
            this.resetStartLocationFromNode(expr, typeParameters);
            return arrowExpression;
          }, state);
          let arrowExpression = null;
          if (
            arrow.node &&
            this.maybeUnwrapTypeCastExpression(arrow.node).type ===
              'ArrowFunctionExpression'
          ) {
            if (!arrow.error && !arrow.aborted) {
              if (arrow.node.async) {
                this.raise(
                  FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction,
                  {at: typeParameters}
                );
              }
              return arrow.node;
            }
            arrowExpression = arrow.node;
          }
          if ((_jsx2 = jsx) != null && _jsx2.node) {
            this.state = jsx.failState;
            return jsx.node;
          }
          if (arrowExpression) {
            this.state = arrow.failState;
            return arrowExpression;
          }
          if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
          if (arrow.thrown) throw arrow.error;
          throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, {
            at: typeParameters,
          });
        }
        return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
      }
      parseArrow(node) {
        if (this.match(14)) {
          const result = this.tryParse(() => {
            const oldNoAnonFunctionType = this.state.noAnonFunctionType;
            this.state.noAnonFunctionType = true;
            const typeNode = this.startNode();
            [typeNode.typeAnnotation, node.predicate] =
              this.flowParseTypeAndPredicateInitialiser();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            if (this.canInsertSemicolon()) this.unexpected();
            if (!this.match(19)) this.unexpected();
            return typeNode;
          });
          if (result.thrown) return null;
          if (result.error) this.state = result.failState;
          node.returnType = result.node.typeAnnotation
            ? this.finishNode(result.node, 'TypeAnnotation')
            : null;
        }
        return super.parseArrow(node);
      }
      shouldParseArrow(params) {
        return this.match(14) || super.shouldParseArrow(params);
      }
      setArrowFunctionParameters(node, params) {
        if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
          node.params = params;
        } else {
          super.setArrowFunctionParameters(node, params);
        }
      }
      checkParams(
        node,
        allowDuplicates,
        isArrowFunction,
        strictModeChanged = true
      ) {
        if (
          isArrowFunction &&
          this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1
        ) {
          return;
        }
        for (let i = 0; i < node.params.length; i++) {
          if (this.isThisParam(node.params[i]) && i > 0) {
            this.raise(FlowErrors.ThisParamMustBeFirst, {at: node.params[i]});
          }
        }
        super.checkParams(
          node,
          allowDuplicates,
          isArrowFunction,
          strictModeChanged
        );
      }
      parseParenAndDistinguishExpression(canBeArrow) {
        return super.parseParenAndDistinguishExpression(
          canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1
        );
      }
      parseSubscripts(base, startLoc, noCalls) {
        if (
          base.type === 'Identifier' &&
          base.name === 'async' &&
          this.state.noArrowAt.indexOf(startLoc.index) !== -1
        ) {
          this.next();
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          node.arguments = super.parseCallExpressionArguments(11, false);
          base = this.finishNode(node, 'CallExpression');
        } else if (
          base.type === 'Identifier' &&
          base.name === 'async' &&
          this.match(47)
        ) {
          const state = this.state.clone();
          const arrow = this.tryParse(
            abort =>
              this.parseAsyncArrowWithTypeParameters(startLoc) || abort(),
            state
          );
          if (!arrow.error && !arrow.aborted) return arrow.node;
          const result = this.tryParse(
            () => super.parseSubscripts(base, startLoc, noCalls),
            state
          );
          if (result.node && !result.error) return result.node;
          if (arrow.node) {
            this.state = arrow.failState;
            return arrow.node;
          }
          if (result.node) {
            this.state = result.failState;
            return result.node;
          }
          throw arrow.error || result.error;
        }
        return super.parseSubscripts(base, startLoc, noCalls);
      }
      parseSubscript(base, startLoc, noCalls, subscriptState) {
        if (this.match(18) && this.isLookaheadToken_lt()) {
          subscriptState.optionalChainMember = true;
          if (noCalls) {
            subscriptState.stop = true;
            return base;
          }
          this.next();
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          node.typeArguments = this.flowParseTypeParameterInstantiation();
          this.expect(10);
          node.arguments = this.parseCallExpressionArguments(11, false);
          node.optional = true;
          return this.finishCallExpression(node, true);
        } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          const result = this.tryParse(() => {
            node.typeArguments =
              this.flowParseTypeParameterInstantiationCallOrNew();
            this.expect(10);
            node.arguments = super.parseCallExpressionArguments(11, false);
            if (subscriptState.optionalChainMember) {
              node.optional = false;
            }
            return this.finishCallExpression(
              node,
              subscriptState.optionalChainMember
            );
          });
          if (result.node) {
            if (result.error) this.state = result.failState;
            return result.node;
          }
        }
        return super.parseSubscript(base, startLoc, noCalls, subscriptState);
      }
      parseNewCallee(node) {
        super.parseNewCallee(node);
        let targs = null;
        if (this.shouldParseTypes() && this.match(47)) {
          targs = this.tryParse(() =>
            this.flowParseTypeParameterInstantiationCallOrNew()
          ).node;
        }
        node.typeArguments = targs;
      }
      parseAsyncArrowWithTypeParameters(startLoc) {
        const node = this.startNodeAt(startLoc);
        this.parseFunctionParams(node, false);
        if (!this.parseArrow(node)) return;
        return super.parseArrowExpression(node, undefined, true);
      }
      readToken_mult_modulo(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 42 && next === 47 && this.state.hasFlowComment) {
          this.state.hasFlowComment = false;
          this.state.pos += 2;
          this.nextToken();
          return;
        }
        super.readToken_mult_modulo(code);
      }
      readToken_pipe_amp(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 124 && next === 125) {
          this.finishOp(9, 2);
          return;
        }
        super.readToken_pipe_amp(code);
      }
      parseTopLevel(file, program) {
        const fileNode = super.parseTopLevel(file, program);
        if (this.state.hasFlowComment) {
          this.raise(FlowErrors.UnterminatedFlowComment, {
            at: this.state.curPosition(),
          });
        }
        return fileNode;
      }
      skipBlockComment() {
        if (this.hasPlugin('flowComments') && this.skipFlowComment()) {
          if (this.state.hasFlowComment) {
            throw this.raise(FlowErrors.NestedFlowComment, {
              at: this.state.startLoc,
            });
          }
          this.hasFlowCommentCompletion();
          const commentSkip = this.skipFlowComment();
          if (commentSkip) {
            this.state.pos += commentSkip;
            this.state.hasFlowComment = true;
          }
          return;
        }
        return super.skipBlockComment(this.state.hasFlowComment ? '*-/' : '*/');
      }
      skipFlowComment() {
        const {pos: pos} = this.state;
        let shiftToFirstNonWhiteSpace = 2;
        while (
          [32, 9].includes(
            this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace)
          )
        ) {
          shiftToFirstNonWhiteSpace++;
        }
        const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
        const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
        if (ch2 === 58 && ch3 === 58) {
          return shiftToFirstNonWhiteSpace + 2;
        }
        if (
          this.input.slice(
            shiftToFirstNonWhiteSpace + pos,
            shiftToFirstNonWhiteSpace + pos + 12
          ) === 'flow-include'
        ) {
          return shiftToFirstNonWhiteSpace + 12;
        }
        if (ch2 === 58 && ch3 !== 58) {
          return shiftToFirstNonWhiteSpace;
        }
        return false;
      }
      hasFlowCommentCompletion() {
        const end = this.input.indexOf('*/', this.state.pos);
        if (end === -1) {
          throw this.raise(Errors.UnterminatedComment, {
            at: this.state.curPosition(),
          });
        }
      }
      flowEnumErrorBooleanMemberNotInitialized(
        loc,
        {enumName: enumName, memberName: memberName}
      ) {
        this.raise(FlowErrors.EnumBooleanMemberNotInitialized, {
          at: loc,
          memberName: memberName,
          enumName: enumName,
        });
      }
      flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
        return this.raise(
          !enumContext.explicitType
            ? FlowErrors.EnumInvalidMemberInitializerUnknownType
            : enumContext.explicitType === 'symbol'
              ? FlowErrors.EnumInvalidMemberInitializerSymbolType
              : FlowErrors.EnumInvalidMemberInitializerPrimaryType,
          Object.assign({at: loc}, enumContext)
        );
      }
      flowEnumErrorNumberMemberNotInitialized(
        loc,
        {enumName: enumName, memberName: memberName}
      ) {
        this.raise(FlowErrors.EnumNumberMemberNotInitialized, {
          at: loc,
          enumName: enumName,
          memberName: memberName,
        });
      }
      flowEnumErrorStringMemberInconsistentlyInitailized(
        node,
        {enumName: enumName}
      ) {
        this.raise(FlowErrors.EnumStringMemberInconsistentlyInitailized, {
          at: node,
          enumName: enumName,
        });
      }
      flowEnumMemberInit() {
        const startLoc = this.state.startLoc;
        const endOfInit = () => this.match(12) || this.match(8);
        switch (this.state.type) {
          case 132: {
            const literal = this.parseNumericLiteral(this.state.value);
            if (endOfInit()) {
              return {type: 'number', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          case 131: {
            const literal = this.parseStringLiteral(this.state.value);
            if (endOfInit()) {
              return {type: 'string', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          case 85:
          case 86: {
            const literal = this.parseBooleanLiteral(this.match(85));
            if (endOfInit()) {
              return {type: 'boolean', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          default:
            return {type: 'invalid', loc: startLoc};
        }
      }
      flowEnumMemberRaw() {
        const loc = this.state.startLoc;
        const id = this.parseIdentifier(true);
        const init = this.eat(29)
          ? this.flowEnumMemberInit()
          : {type: 'none', loc: loc};
        return {id: id, init: init};
      }
      flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
        const {explicitType: explicitType} = context;
        if (explicitType === null) {
          return;
        }
        if (explicitType !== expectedType) {
          this.flowEnumErrorInvalidMemberInitializer(loc, context);
        }
      }
      flowEnumMembers({enumName: enumName, explicitType: explicitType}) {
        const seenNames = new Set();
        const members = {
          booleanMembers: [],
          numberMembers: [],
          stringMembers: [],
          defaultedMembers: [],
        };
        let hasUnknownMembers = false;
        while (!this.match(8)) {
          if (this.eat(21)) {
            hasUnknownMembers = true;
            break;
          }
          const memberNode = this.startNode();
          const {id: id, init: init} = this.flowEnumMemberRaw();
          const memberName = id.name;
          if (memberName === '') {
            continue;
          }
          if (/^[a-z]/.test(memberName)) {
            this.raise(FlowErrors.EnumInvalidMemberName, {
              at: id,
              memberName: memberName,
              suggestion: memberName[0].toUpperCase() + memberName.slice(1),
              enumName: enumName,
            });
          }
          if (seenNames.has(memberName)) {
            this.raise(FlowErrors.EnumDuplicateMemberName, {
              at: id,
              memberName: memberName,
              enumName: enumName,
            });
          }
          seenNames.add(memberName);
          const context = {
            enumName: enumName,
            explicitType: explicitType,
            memberName: memberName,
          };
          memberNode.id = id;
          switch (init.type) {
            case 'boolean': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'boolean'
              );
              memberNode.init = init.value;
              members.booleanMembers.push(
                this.finishNode(memberNode, 'EnumBooleanMember')
              );
              break;
            }
            case 'number': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'number'
              );
              memberNode.init = init.value;
              members.numberMembers.push(
                this.finishNode(memberNode, 'EnumNumberMember')
              );
              break;
            }
            case 'string': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'string'
              );
              memberNode.init = init.value;
              members.stringMembers.push(
                this.finishNode(memberNode, 'EnumStringMember')
              );
              break;
            }
            case 'invalid': {
              throw this.flowEnumErrorInvalidMemberInitializer(
                init.loc,
                context
              );
            }
            case 'none': {
              switch (explicitType) {
                case 'boolean':
                  this.flowEnumErrorBooleanMemberNotInitialized(
                    init.loc,
                    context
                  );
                  break;
                case 'number':
                  this.flowEnumErrorNumberMemberNotInitialized(
                    init.loc,
                    context
                  );
                  break;
                default:
                  members.defaultedMembers.push(
                    this.finishNode(memberNode, 'EnumDefaultedMember')
                  );
              }
            }
          }
          if (!this.match(8)) {
            this.expect(12);
          }
        }
        return {members: members, hasUnknownMembers: hasUnknownMembers};
      }
      flowEnumStringMembers(
        initializedMembers,
        defaultedMembers,
        {enumName: enumName}
      ) {
        if (initializedMembers.length === 0) {
          return defaultedMembers;
        } else if (defaultedMembers.length === 0) {
          return initializedMembers;
        } else if (defaultedMembers.length > initializedMembers.length) {
          for (const member of initializedMembers) {
            this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
              enumName: enumName,
            });
          }
          return defaultedMembers;
        } else {
          for (const member of defaultedMembers) {
            this.flowEnumErrorStringMemberInconsistentlyInitailized(member, {
              enumName: enumName,
            });
          }
          return initializedMembers;
        }
      }
      flowEnumParseExplicitType({enumName: enumName}) {
        if (!this.eatContextual(101)) return null;
        if (!tokenIsIdentifier(this.state.type)) {
          throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, {
            at: this.state.startLoc,
            enumName: enumName,
          });
        }
        const {value: value} = this.state;
        this.next();
        if (
          value !== 'boolean' &&
          value !== 'number' &&
          value !== 'string' &&
          value !== 'symbol'
        ) {
          this.raise(FlowErrors.EnumInvalidExplicitType, {
            at: this.state.startLoc,
            enumName: enumName,
            invalidEnumType: value,
          });
        }
        return value;
      }
      flowEnumBody(node, id) {
        const enumName = id.name;
        const nameLoc = id.loc.start;
        const explicitType = this.flowEnumParseExplicitType({
          enumName: enumName,
        });
        this.expect(5);
        const {members: members, hasUnknownMembers: hasUnknownMembers} =
          this.flowEnumMembers({
            enumName: enumName,
            explicitType: explicitType,
          });
        node.hasUnknownMembers = hasUnknownMembers;
        switch (explicitType) {
          case 'boolean':
            node.explicitType = true;
            node.members = members.booleanMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumBooleanBody');
          case 'number':
            node.explicitType = true;
            node.members = members.numberMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumNumberBody');
          case 'string':
            node.explicitType = true;
            node.members = this.flowEnumStringMembers(
              members.stringMembers,
              members.defaultedMembers,
              {enumName: enumName}
            );
            this.expect(8);
            return this.finishNode(node, 'EnumStringBody');
          case 'symbol':
            node.members = members.defaultedMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumSymbolBody');
          default: {
            const empty = () => {
              node.members = [];
              this.expect(8);
              return this.finishNode(node, 'EnumStringBody');
            };
            node.explicitType = false;
            const boolsLen = members.booleanMembers.length;
            const numsLen = members.numberMembers.length;
            const strsLen = members.stringMembers.length;
            const defaultedLen = members.defaultedMembers.length;
            if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
              return empty();
            } else if (!boolsLen && !numsLen) {
              node.members = this.flowEnumStringMembers(
                members.stringMembers,
                members.defaultedMembers,
                {enumName: enumName}
              );
              this.expect(8);
              return this.finishNode(node, 'EnumStringBody');
            } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
              for (const member of members.defaultedMembers) {
                this.flowEnumErrorBooleanMemberNotInitialized(
                  member.loc.start,
                  {enumName: enumName, memberName: member.id.name}
                );
              }
              node.members = members.booleanMembers;
              this.expect(8);
              return this.finishNode(node, 'EnumBooleanBody');
            } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
              for (const member of members.defaultedMembers) {
                this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
                  enumName: enumName,
                  memberName: member.id.name,
                });
              }
              node.members = members.numberMembers;
              this.expect(8);
              return this.finishNode(node, 'EnumNumberBody');
            } else {
              this.raise(FlowErrors.EnumInconsistentMemberValues, {
                at: nameLoc,
                enumName: enumName,
              });
              return empty();
            }
          }
        }
      }
      flowParseEnumDeclaration(node) {
        const id = this.parseIdentifier();
        node.id = id;
        node.body = this.flowEnumBody(this.startNode(), id);
        return this.finishNode(node, 'EnumDeclaration');
      }
      isLookaheadToken_lt() {
        const next = this.nextTokenStart();
        if (this.input.charCodeAt(next) === 60) {
          const afterNext = this.input.charCodeAt(next + 1);
          return afterNext !== 60 && afterNext !== 61;
        }
        return false;
      }
      maybeUnwrapTypeCastExpression(node) {
        return node.type === 'TypeCastExpression' ? node.expression : node;
      }
    };
  const entities = {
    __proto__: null,
    quot: '"',
    amp: '&',
    apos: "'",
    lt: '<',
    gt: '>',
    nbsp: ' ',
    iexcl: '¡',
    cent: '¢',
    pound: '£',
    curren: '¤',
    yen: '¥',
    brvbar: '¦',
    sect: '§',
    uml: '¨',
    copy: '©',
    ordf: 'ª',
    laquo: '«',
    not: '¬',
    shy: '­',
    reg: '®',
    macr: '¯',
    deg: '°',
    plusmn: '±',
    sup2: '²',
    sup3: '³',
    acute: '´',
    micro: 'µ',
    para: '¶',
    middot: '·',
    cedil: '¸',
    sup1: '¹',
    ordm: 'º',
    raquo: '»',
    frac14: '¼',
    frac12: '½',
    frac34: '¾',
    iquest: '¿',
    Agrave: 'À',
    Aacute: 'Á',
    Acirc: 'Â',
    Atilde: 'Ã',
    Auml: 'Ä',
    Aring: 'Å',
    AElig: 'Æ',
    Ccedil: 'Ç',
    Egrave: 'È',
    Eacute: 'É',
    Ecirc: 'Ê',
    Euml: 'Ë',
    Igrave: 'Ì',
    Iacute: 'Í',
    Icirc: 'Î',
    Iuml: 'Ï',
    ETH: 'Ð',
    Ntilde: 'Ñ',
    Ograve: 'Ò',
    Oacute: 'Ó',
    Ocirc: 'Ô',
    Otilde: 'Õ',
    Ouml: 'Ö',
    times: '×',
    Oslash: 'Ø',
    Ugrave: 'Ù',
    Uacute: 'Ú',
    Ucirc: 'Û',
    Uuml: 'Ü',
    Yacute: 'Ý',
    THORN: 'Þ',
    szlig: 'ß',
    agrave: 'à',
    aacute: 'á',
    acirc: 'â',
    atilde: 'ã',
    auml: 'ä',
    aring: 'å',
    aelig: 'æ',
    ccedil: 'ç',
    egrave: 'è',
    eacute: 'é',
    ecirc: 'ê',
    euml: 'ë',
    igrave: 'ì',
    iacute: 'í',
    icirc: 'î',
    iuml: 'ï',
    eth: 'ð',
    ntilde: 'ñ',
    ograve: 'ò',
    oacute: 'ó',
    ocirc: 'ô',
    otilde: 'õ',
    ouml: 'ö',
    divide: '÷',
    oslash: 'ø',
    ugrave: 'ù',
    uacute: 'ú',
    ucirc: 'û',
    uuml: 'ü',
    yacute: 'ý',
    thorn: 'þ',
    yuml: 'ÿ',
    OElig: 'Œ',
    oelig: 'œ',
    Scaron: 'Š',
    scaron: 'š',
    Yuml: 'Ÿ',
    fnof: 'ƒ',
    circ: 'ˆ',
    tilde: '˜',
    Alpha: 'Α',
    Beta: 'Β',
    Gamma: 'Γ',
    Delta: 'Δ',
    Epsilon: 'Ε',
    Zeta: 'Ζ',
    Eta: 'Η',
    Theta: 'Θ',
    Iota: 'Ι',
    Kappa: 'Κ',
    Lambda: 'Λ',
    Mu: 'Μ',
    Nu: 'Ν',
    Xi: 'Ξ',
    Omicron: 'Ο',
    Pi: 'Π',
    Rho: 'Ρ',
    Sigma: 'Σ',
    Tau: 'Τ',
    Upsilon: 'Υ',
    Phi: 'Φ',
    Chi: 'Χ',
    Psi: 'Ψ',
    Omega: 'Ω',
    alpha: 'α',
    beta: 'β',
    gamma: 'γ',
    delta: 'δ',
    epsilon: 'ε',
    zeta: 'ζ',
    eta: 'η',
    theta: 'θ',
    iota: 'ι',
    kappa: 'κ',
    lambda: 'λ',
    mu: 'μ',
    nu: 'ν',
    xi: 'ξ',
    omicron: 'ο',
    pi: 'π',
    rho: 'ρ',
    sigmaf: 'ς',
    sigma: 'σ',
    tau: 'τ',
    upsilon: 'υ',
    phi: 'φ',
    chi: 'χ',
    psi: 'ψ',
    omega: 'ω',
    thetasym: 'ϑ',
    upsih: 'ϒ',
    piv: 'ϖ',
    ensp: ' ',
    emsp: ' ',
    thinsp: ' ',
    zwnj: '‌',
    zwj: '‍',
    lrm: '‎',
    rlm: '‏',
    ndash: '–',
    mdash: '—',
    lsquo: '‘',
    rsquo: '’',
    sbquo: '‚',
    ldquo: '“',
    rdquo: '”',
    bdquo: '„',
    dagger: '†',
    Dagger: '‡',
    bull: '•',
    hellip: '…',
    permil: '‰',
    prime: '′',
    Prime: '″',
    lsaquo: '‹',
    rsaquo: '›',
    oline: '‾',
    frasl: '⁄',
    euro: '€',
    image: 'ℑ',
    weierp: '℘',
    real: 'ℜ',
    trade: '™',
    alefsym: 'ℵ',
    larr: '←',
    uarr: '↑',
    rarr: '→',
    darr: '↓',
    harr: '↔',
    crarr: '↵',
    lArr: '⇐',
    uArr: '⇑',
    rArr: '⇒',
    dArr: '⇓',
    hArr: '⇔',
    forall: '∀',
    part: '∂',
    exist: '∃',
    empty: '∅',
    nabla: '∇',
    isin: '∈',
    notin: '∉',
    ni: '∋',
    prod: '∏',
    sum: '∑',
    minus: '−',
    lowast: '∗',
    radic: '√',
    prop: '∝',
    infin: '∞',
    ang: '∠',
    and: '∧',
    or: '∨',
    cap: '∩',
    cup: '∪',
    int: '∫',
    there4: '∴',
    sim: '∼',
    cong: '≅',
    asymp: '≈',
    ne: '≠',
    equiv: '≡',
    le: '≤',
    ge: '≥',
    sub: '⊂',
    sup: '⊃',
    nsub: '⊄',
    sube: '⊆',
    supe: '⊇',
    oplus: '⊕',
    otimes: '⊗',
    perp: '⊥',
    sdot: '⋅',
    lceil: '⌈',
    rceil: '⌉',
    lfloor: '⌊',
    rfloor: '⌋',
    lang: '〈',
    rang: '〉',
    loz: '◊',
    spades: '♠',
    clubs: '♣',
    hearts: '♥',
    diams: '♦',
  };
  const JsxErrors = ParseErrorEnum`jsx`({
    AttributeIsEmpty:
      'JSX attributes must only be assigned a non-empty expression.',
    MissingClosingTagElement: ({openingTagName: openingTagName}) =>
      `Expected corresponding JSX closing tag for <${openingTagName}>.`,
    MissingClosingTagFragment: 'Expected corresponding JSX closing tag for <>.',
    UnexpectedSequenceExpression:
      'Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?',
    UnexpectedToken: ({unexpected: unexpected, HTMLEntity: HTMLEntity}) =>
      `Unexpected token \`${unexpected}\`. Did you mean \`${HTMLEntity}\` or \`{'${unexpected}'}\`?`,
    UnsupportedJsxValue:
      'JSX value should be either an expression or a quoted JSX text.',
    UnterminatedJsxContent: 'Unterminated JSX contents.',
    UnwrappedAdjacentJSXElements:
      'Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?',
  });
  function isFragment(object) {
    return object
      ? object.type === 'JSXOpeningFragment' ||
          object.type === 'JSXClosingFragment'
      : false;
  }
  function getQualifiedJSXName(object) {
    if (object.type === 'JSXIdentifier') {
      return object.name;
    }
    if (object.type === 'JSXNamespacedName') {
      return object.namespace.name + ':' + object.name.name;
    }
    if (object.type === 'JSXMemberExpression') {
      return (
        getQualifiedJSXName(object.object) +
        '.' +
        getQualifiedJSXName(object.property)
      );
    }
    throw new Error('Node had unexpected type: ' + object.type);
  }
  var jsx = superClass =>
    class JSXParserMixin extends superClass {
      jsxReadToken() {
        let out = '';
        let chunkStart = this.state.pos;
        for (;;) {
          if (this.state.pos >= this.length) {
            throw this.raise(JsxErrors.UnterminatedJsxContent, {
              at: this.state.startLoc,
            });
          }
          const ch = this.input.charCodeAt(this.state.pos);
          switch (ch) {
            case 60:
            case 123:
              if (this.state.pos === this.state.start) {
                if (ch === 60 && this.state.canStartJSXElement) {
                  ++this.state.pos;
                  this.finishToken(140);
                } else {
                  super.getTokenFromCode(ch);
                }
                return;
              }
              out += this.input.slice(chunkStart, this.state.pos);
              this.finishToken(139, out);
              return;
            case 38:
              out += this.input.slice(chunkStart, this.state.pos);
              out += this.jsxReadEntity();
              chunkStart = this.state.pos;
              break;
            case 62:
            case 125:
            default:
              if (isNewLine(ch)) {
                out += this.input.slice(chunkStart, this.state.pos);
                out += this.jsxReadNewLine(true);
                chunkStart = this.state.pos;
              } else {
                ++this.state.pos;
              }
          }
        }
      }
      jsxReadNewLine(normalizeCRLF) {
        const ch = this.input.charCodeAt(this.state.pos);
        let out;
        ++this.state.pos;
        if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
          ++this.state.pos;
          out = normalizeCRLF ? '\n' : '\r\n';
        } else {
          out = String.fromCharCode(ch);
        }
        ++this.state.curLine;
        this.state.lineStart = this.state.pos;
        return out;
      }
      jsxReadString(quote) {
        let out = '';
        let chunkStart = ++this.state.pos;
        for (;;) {
          if (this.state.pos >= this.length) {
            throw this.raise(Errors.UnterminatedString, {
              at: this.state.startLoc,
            });
          }
          const ch = this.input.charCodeAt(this.state.pos);
          if (ch === quote) break;
          if (ch === 38) {
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadEntity();
            chunkStart = this.state.pos;
          } else if (isNewLine(ch)) {
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadNewLine(false);
            chunkStart = this.state.pos;
          } else {
            ++this.state.pos;
          }
        }
        out += this.input.slice(chunkStart, this.state.pos++);
        this.finishToken(131, out);
      }
      jsxReadEntity() {
        const startPos = ++this.state.pos;
        if (this.codePointAtPos(this.state.pos) === 35) {
          ++this.state.pos;
          let radix = 10;
          if (this.codePointAtPos(this.state.pos) === 120) {
            radix = 16;
            ++this.state.pos;
          }
          const codePoint = this.readInt(radix, undefined, false, 'bail');
          if (
            codePoint !== null &&
            this.codePointAtPos(this.state.pos) === 59
          ) {
            ++this.state.pos;
            return String.fromCodePoint(codePoint);
          }
        } else {
          let count = 0;
          let semi = false;
          while (
            count++ < 10 &&
            this.state.pos < this.length &&
            !(semi = this.codePointAtPos(this.state.pos) == 59)
          ) {
            ++this.state.pos;
          }
          if (semi) {
            const desc = this.input.slice(startPos, this.state.pos);
            const entity = entities[desc];
            ++this.state.pos;
            if (entity) {
              return entity;
            }
          }
        }
        this.state.pos = startPos;
        return '&';
      }
      jsxReadWord() {
        let ch;
        const start = this.state.pos;
        do {
          ch = this.input.charCodeAt(++this.state.pos);
        } while (isIdentifierChar(ch) || ch === 45);
        this.finishToken(138, this.input.slice(start, this.state.pos));
      }
      jsxParseIdentifier() {
        const node = this.startNode();
        if (this.match(138)) {
          node.name = this.state.value;
        } else if (tokenIsKeyword(this.state.type)) {
          node.name = tokenLabelName(this.state.type);
        } else {
          this.unexpected();
        }
        this.next();
        return this.finishNode(node, 'JSXIdentifier');
      }
      jsxParseNamespacedName() {
        const startLoc = this.state.startLoc;
        const name = this.jsxParseIdentifier();
        if (!this.eat(14)) return name;
        const node = this.startNodeAt(startLoc);
        node.namespace = name;
        node.name = this.jsxParseIdentifier();
        return this.finishNode(node, 'JSXNamespacedName');
      }
      jsxParseElementName() {
        const startLoc = this.state.startLoc;
        let node = this.jsxParseNamespacedName();
        if (node.type === 'JSXNamespacedName') {
          return node;
        }
        while (this.eat(16)) {
          const newNode = this.startNodeAt(startLoc);
          newNode.object = node;
          newNode.property = this.jsxParseIdentifier();
          node = this.finishNode(newNode, 'JSXMemberExpression');
        }
        return node;
      }
      jsxParseAttributeValue() {
        let node;
        switch (this.state.type) {
          case 5:
            node = this.startNode();
            this.setContext(types.brace);
            this.next();
            node = this.jsxParseExpressionContainer(node, types.j_oTag);
            if (node.expression.type === 'JSXEmptyExpression') {
              this.raise(JsxErrors.AttributeIsEmpty, {at: node});
            }
            return node;
          case 140:
          case 131:
            return this.parseExprAtom();
          default:
            throw this.raise(JsxErrors.UnsupportedJsxValue, {
              at: this.state.startLoc,
            });
        }
      }
      jsxParseEmptyExpression() {
        const node = this.startNodeAt(this.state.lastTokEndLoc);
        return this.finishNodeAt(
          node,
          'JSXEmptyExpression',
          this.state.startLoc
        );
      }
      jsxParseSpreadChild(node) {
        this.next();
        node.expression = this.parseExpression();
        this.setContext(types.j_expr);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXSpreadChild');
      }
      jsxParseExpressionContainer(node, previousContext) {
        if (this.match(8)) {
          node.expression = this.jsxParseEmptyExpression();
        } else {
          const expression = this.parseExpression();
          node.expression = expression;
        }
        this.setContext(previousContext);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXExpressionContainer');
      }
      jsxParseAttribute() {
        const node = this.startNode();
        if (this.match(5)) {
          this.setContext(types.brace);
          this.next();
          this.expect(21);
          node.argument = this.parseMaybeAssignAllowIn();
          this.setContext(types.j_oTag);
          this.state.canStartJSXElement = true;
          this.expect(8);
          return this.finishNode(node, 'JSXSpreadAttribute');
        }
        node.name = this.jsxParseNamespacedName();
        node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
        return this.finishNode(node, 'JSXAttribute');
      }
      jsxParseOpeningElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        if (this.eat(141)) {
          return this.finishNode(node, 'JSXOpeningFragment');
        }
        node.name = this.jsxParseElementName();
        return this.jsxParseOpeningElementAfterName(node);
      }
      jsxParseOpeningElementAfterName(node) {
        const attributes = [];
        while (!this.match(56) && !this.match(141)) {
          attributes.push(this.jsxParseAttribute());
        }
        node.attributes = attributes;
        node.selfClosing = this.eat(56);
        this.expect(141);
        return this.finishNode(node, 'JSXOpeningElement');
      }
      jsxParseClosingElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        if (this.eat(141)) {
          return this.finishNode(node, 'JSXClosingFragment');
        }
        node.name = this.jsxParseElementName();
        this.expect(141);
        return this.finishNode(node, 'JSXClosingElement');
      }
      jsxParseElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        const children = [];
        const openingElement = this.jsxParseOpeningElementAt(startLoc);
        let closingElement = null;
        if (!openingElement.selfClosing) {
          contents: for (;;) {
            switch (this.state.type) {
              case 140:
                startLoc = this.state.startLoc;
                this.next();
                if (this.eat(56)) {
                  closingElement = this.jsxParseClosingElementAt(startLoc);
                  break contents;
                }
                children.push(this.jsxParseElementAt(startLoc));
                break;
              case 139:
                children.push(this.parseExprAtom());
                break;
              case 5: {
                const node = this.startNode();
                this.setContext(types.brace);
                this.next();
                if (this.match(21)) {
                  children.push(this.jsxParseSpreadChild(node));
                } else {
                  children.push(
                    this.jsxParseExpressionContainer(node, types.j_expr)
                  );
                }
                break;
              }
              default:
                this.unexpected();
            }
          }
          if (
            isFragment(openingElement) &&
            !isFragment(closingElement) &&
            closingElement !== null
          ) {
            this.raise(JsxErrors.MissingClosingTagFragment, {
              at: closingElement,
            });
          } else if (
            !isFragment(openingElement) &&
            isFragment(closingElement)
          ) {
            this.raise(JsxErrors.MissingClosingTagElement, {
              at: closingElement,
              openingTagName: getQualifiedJSXName(openingElement.name),
            });
          } else if (
            !isFragment(openingElement) &&
            !isFragment(closingElement)
          ) {
            if (
              getQualifiedJSXName(closingElement.name) !==
              getQualifiedJSXName(openingElement.name)
            ) {
              this.raise(JsxErrors.MissingClosingTagElement, {
                at: closingElement,
                openingTagName: getQualifiedJSXName(openingElement.name),
              });
            }
          }
        }
        if (isFragment(openingElement)) {
          node.openingFragment = openingElement;
          node.closingFragment = closingElement;
        } else {
          node.openingElement = openingElement;
          node.closingElement = closingElement;
        }
        node.children = children;
        if (this.match(47)) {
          throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, {
            at: this.state.startLoc,
          });
        }
        return isFragment(openingElement)
          ? this.finishNode(node, 'JSXFragment')
          : this.finishNode(node, 'JSXElement');
      }
      jsxParseElement() {
        const startLoc = this.state.startLoc;
        this.next();
        return this.jsxParseElementAt(startLoc);
      }
      setContext(newContext) {
        const {context: context} = this.state;
        context[context.length - 1] = newContext;
      }
      parseExprAtom(refExpressionErrors) {
        if (this.match(139)) {
          return this.parseLiteral(this.state.value, 'JSXText');
        } else if (this.match(140)) {
          return this.jsxParseElement();
        } else if (
          this.match(47) &&
          this.input.charCodeAt(this.state.pos) !== 33
        ) {
          this.replaceToken(140);
          return this.jsxParseElement();
        } else {
          return super.parseExprAtom(refExpressionErrors);
        }
      }
      skipSpace() {
        const curContext = this.curContext();
        if (!curContext.preserveSpace) super.skipSpace();
      }
      getTokenFromCode(code) {
        const context = this.curContext();
        if (context === types.j_expr) {
          this.jsxReadToken();
          return;
        }
        if (context === types.j_oTag || context === types.j_cTag) {
          if (isIdentifierStart(code)) {
            this.jsxReadWord();
            return;
          }
          if (code === 62) {
            ++this.state.pos;
            this.finishToken(141);
            return;
          }
          if ((code === 34 || code === 39) && context === types.j_oTag) {
            this.jsxReadString(code);
            return;
          }
        }
        if (
          code === 60 &&
          this.state.canStartJSXElement &&
          this.input.charCodeAt(this.state.pos + 1) !== 33
        ) {
          ++this.state.pos;
          this.finishToken(140);
          return;
        }
        super.getTokenFromCode(code);
      }
      updateContext(prevType) {
        const {context: context, type: type} = this.state;
        if (type === 56 && prevType === 140) {
          context.splice(-2, 2, types.j_cTag);
          this.state.canStartJSXElement = false;
        } else if (type === 140) {
          context.push(types.j_oTag);
        } else if (type === 141) {
          const out = context[context.length - 1];
          if (
            (out === types.j_oTag && prevType === 56) ||
            out === types.j_cTag
          ) {
            context.pop();
            this.state.canStartJSXElement =
              context[context.length - 1] === types.j_expr;
          } else {
            this.setContext(types.j_expr);
            this.state.canStartJSXElement = true;
          }
        } else {
          this.state.canStartJSXElement = tokenComesBeforeExpression(type);
        }
      }
    };
  class TypeScriptScope extends Scope {
    constructor(...args) {
      super(...args);
      this.types = new Set();
      this.enums = new Set();
      this.constEnums = new Set();
      this.classes = new Set();
      this.exportOnlyBindings = new Set();
    }
  }
  class TypeScriptScopeHandler extends ScopeHandler {
    constructor(...args) {
      super(...args);
      this.importsStack = [];
    }
    createScope(flags) {
      this.importsStack.push(new Set());
      return new TypeScriptScope(flags);
    }
    enter(flags) {
      if (flags == SCOPE_TS_MODULE) {
        this.importsStack.push(new Set());
      }
      super.enter(flags);
    }
    exit() {
      const flags = super.exit();
      if (flags == SCOPE_TS_MODULE) {
        this.importsStack.pop();
      }
      return flags;
    }
    hasImport(name, allowShadow) {
      const len = this.importsStack.length;
      if (this.importsStack[len - 1].has(name)) {
        return true;
      }
      if (!allowShadow && len > 1) {
        for (let i = 0; i < len - 1; i++) {
          if (this.importsStack[i].has(name)) return true;
        }
      }
      return false;
    }
    declareName(name, bindingType, loc) {
      if (bindingType & BIND_FLAGS_TS_IMPORT) {
        if (this.hasImport(name, true)) {
          this.parser.raise(Errors.VarRedeclaration, {
            at: loc,
            identifierName: name,
          });
        }
        this.importsStack[this.importsStack.length - 1].add(name);
        return;
      }
      const scope = this.currentScope();
      if (bindingType & BIND_FLAGS_TS_EXPORT_ONLY) {
        this.maybeExportDefined(scope, name);
        scope.exportOnlyBindings.add(name);
        return;
      }
      super.declareName(name, bindingType, loc);
      if (bindingType & BIND_KIND_TYPE) {
        if (!(bindingType & BIND_KIND_VALUE)) {
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          this.maybeExportDefined(scope, name);
        }
        scope.types.add(name);
      }
      if (bindingType & BIND_FLAGS_TS_ENUM) scope.enums.add(name);
      if (bindingType & BIND_FLAGS_TS_CONST_ENUM) scope.constEnums.add(name);
      if (bindingType & BIND_FLAGS_CLASS) scope.classes.add(name);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (scope.enums.has(name)) {
        if (bindingType & BIND_FLAGS_TS_ENUM) {
          const isConst = !!(bindingType & BIND_FLAGS_TS_CONST_ENUM);
          const wasConst = scope.constEnums.has(name);
          return isConst !== wasConst;
        }
        return true;
      }
      if (bindingType & BIND_FLAGS_CLASS && scope.classes.has(name)) {
        if (scope.lexical.has(name)) {
          return !!(bindingType & BIND_KIND_VALUE);
        } else {
          return false;
        }
      }
      if (bindingType & BIND_KIND_TYPE && scope.types.has(name)) {
        return true;
      }
      return super.isRedeclaredInScope(scope, name, bindingType);
    }
    checkLocalExport(id) {
      const {name: name} = id;
      if (this.hasImport(name)) return;
      const len = this.scopeStack.length;
      for (let i = len - 1; i >= 0; i--) {
        const scope = this.scopeStack[i];
        if (scope.types.has(name) || scope.exportOnlyBindings.has(name)) return;
      }
      super.checkLocalExport(id);
    }
  }
  const getOwn$1 = (object, key) =>
    Object.hasOwnProperty.call(object, key) && object[key];
  const unwrapParenthesizedExpression = node =>
    node.type === 'ParenthesizedExpression'
      ? unwrapParenthesizedExpression(node.expression)
      : node;
  class LValParser extends NodeUtils {
    toAssignable(node, isLHS = false) {
      var _node$extra, _node$extra3;
      let parenthesized = undefined;
      if (
        node.type === 'ParenthesizedExpression' ||
        ((_node$extra = node.extra) != null && _node$extra.parenthesized)
      ) {
        parenthesized = unwrapParenthesizedExpression(node);
        if (isLHS) {
          if (parenthesized.type === 'Identifier') {
            this.expressionScope.recordArrowParameterBindingError(
              Errors.InvalidParenthesizedAssignment,
              {at: node}
            );
          } else if (parenthesized.type !== 'MemberExpression') {
            this.raise(Errors.InvalidParenthesizedAssignment, {at: node});
          }
        } else {
          this.raise(Errors.InvalidParenthesizedAssignment, {at: node});
        }
      }
      switch (node.type) {
        case 'Identifier':
        case 'ObjectPattern':
        case 'ArrayPattern':
        case 'AssignmentPattern':
        case 'RestElement':
          break;
        case 'ObjectExpression':
          node.type = 'ObjectPattern';
          for (
            let i = 0, length = node.properties.length, last = length - 1;
            i < length;
            i++
          ) {
            var _node$extra2;
            const prop = node.properties[i];
            const isLast = i === last;
            this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
            if (
              isLast &&
              prop.type === 'RestElement' &&
              (_node$extra2 = node.extra) != null &&
              _node$extra2.trailingCommaLoc
            ) {
              this.raise(Errors.RestTrailingComma, {
                at: node.extra.trailingCommaLoc,
              });
            }
          }
          break;
        case 'ObjectProperty': {
          const {key: key, value: value} = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(
              this.getPrivateNameSV(key),
              key.loc.start
            );
          }
          this.toAssignable(value, isLHS);
          break;
        }
        case 'SpreadElement': {
          throw new Error(
            'Internal @babel/parser error (this is a bug, please report it).' +
              " SpreadElement should be converted by .toAssignable's caller."
          );
        }
        case 'ArrayExpression':
          node.type = 'ArrayPattern';
          this.toAssignableList(
            node.elements,
            (_node$extra3 = node.extra) == null
              ? void 0
              : _node$extra3.trailingCommaLoc,
            isLHS
          );
          break;
        case 'AssignmentExpression':
          if (node.operator !== '=') {
            this.raise(Errors.MissingEqInAssignment, {at: node.left.loc.end});
          }
          node.type = 'AssignmentPattern';
          delete node.operator;
          this.toAssignable(node.left, isLHS);
          break;
        case 'ParenthesizedExpression':
          this.toAssignable(parenthesized, isLHS);
          break;
      }
    }
    toAssignableObjectExpressionProp(prop, isLast, isLHS) {
      if (prop.type === 'ObjectMethod') {
        this.raise(
          prop.kind === 'get' || prop.kind === 'set'
            ? Errors.PatternHasAccessor
            : Errors.PatternHasMethod,
          {at: prop.key}
        );
      } else if (prop.type === 'SpreadElement') {
        prop.type = 'RestElement';
        const arg = prop.argument;
        this.checkToRestConversion(arg, false);
        this.toAssignable(arg, isLHS);
        if (!isLast) {
          this.raise(Errors.RestTrailingComma, {at: prop});
        }
      } else {
        this.toAssignable(prop, isLHS);
      }
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      const end = exprList.length - 1;
      for (let i = 0; i <= end; i++) {
        const elt = exprList[i];
        if (!elt) continue;
        if (elt.type === 'SpreadElement') {
          elt.type = 'RestElement';
          const arg = elt.argument;
          this.checkToRestConversion(arg, true);
          this.toAssignable(arg, isLHS);
        } else {
          this.toAssignable(elt, isLHS);
        }
        if (elt.type === 'RestElement') {
          if (i < end) {
            this.raise(Errors.RestTrailingComma, {at: elt});
          } else if (trailingCommaLoc) {
            this.raise(Errors.RestTrailingComma, {at: trailingCommaLoc});
          }
        }
      }
    }
    isAssignable(node, isBinding) {
      switch (node.type) {
        case 'Identifier':
        case 'ObjectPattern':
        case 'ArrayPattern':
        case 'AssignmentPattern':
        case 'RestElement':
          return true;
        case 'ObjectExpression': {
          const last = node.properties.length - 1;
          return node.properties.every(
            (prop, i) =>
              prop.type !== 'ObjectMethod' &&
              (i === last || prop.type !== 'SpreadElement') &&
              this.isAssignable(prop)
          );
        }
        case 'ObjectProperty':
          return this.isAssignable(node.value);
        case 'SpreadElement':
          return this.isAssignable(node.argument);
        case 'ArrayExpression':
          return node.elements.every(
            element => element === null || this.isAssignable(element)
          );
        case 'AssignmentExpression':
          return node.operator === '=';
        case 'ParenthesizedExpression':
          return this.isAssignable(node.expression);
        case 'MemberExpression':
        case 'OptionalMemberExpression':
          return !isBinding;
        default:
          return false;
      }
    }
    toReferencedList(exprList, isParenthesizedExpr) {
      return exprList;
    }
    toReferencedListDeep(exprList, isParenthesizedExpr) {
      this.toReferencedList(exprList, isParenthesizedExpr);
      for (const expr of exprList) {
        if ((expr == null ? void 0 : expr.type) === 'ArrayExpression') {
          this.toReferencedListDeep(expr.elements);
        }
      }
    }
    parseSpread(refExpressionErrors) {
      const node = this.startNode();
      this.next();
      node.argument = this.parseMaybeAssignAllowIn(
        refExpressionErrors,
        undefined
      );
      return this.finishNode(node, 'SpreadElement');
    }
    parseRestBinding() {
      const node = this.startNode();
      this.next();
      node.argument = this.parseBindingAtom();
      return this.finishNode(node, 'RestElement');
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 0: {
          const node = this.startNode();
          this.next();
          node.elements = this.parseBindingList(3, 93, 1);
          return this.finishNode(node, 'ArrayPattern');
        }
        case 5:
          return this.parseObjectLike(8, true);
      }
      return this.parseIdentifier();
    }
    parseBindingList(close, closeCharCode, flags) {
      const allowEmpty = flags & 1;
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
        }
        if (allowEmpty && this.match(12)) {
          elts.push(null);
        } else if (this.eat(close)) {
          break;
        } else if (this.match(21)) {
          elts.push(
            this.parseAssignableListItemTypes(this.parseRestBinding(), flags)
          );
          if (!this.checkCommaAfterRest(closeCharCode)) {
            this.expect(close);
            break;
          }
        } else {
          const decorators = [];
          if (this.match(26) && this.hasPlugin('decorators')) {
            this.raise(Errors.UnsupportedParameterDecorator, {
              at: this.state.startLoc,
            });
          }
          while (this.match(26)) {
            decorators.push(this.parseDecorator());
          }
          elts.push(this.parseAssignableListItem(flags, decorators));
        }
      }
      return elts;
    }
    parseBindingRestProperty(prop) {
      this.next();
      prop.argument = this.parseIdentifier();
      this.checkCommaAfterRest(125);
      return this.finishNode(prop, 'RestElement');
    }
    parseBindingProperty() {
      const prop = this.startNode();
      const {type: type, startLoc: startLoc} = this.state;
      if (type === 21) {
        return this.parseBindingRestProperty(prop);
      } else if (type === 136) {
        this.expectPlugin('destructuringPrivate', startLoc);
        this.classScope.usePrivateName(this.state.value, startLoc);
        prop.key = this.parsePrivateName();
      } else {
        this.parsePropertyName(prop);
      }
      prop.method = false;
      return this.parseObjPropValue(prop, startLoc, false, false, true, false);
    }
    parseAssignableListItem(flags, decorators) {
      const left = this.parseMaybeDefault();
      this.parseAssignableListItemTypes(left, flags);
      const elt = this.parseMaybeDefault(left.loc.start, left);
      if (decorators.length) {
        left.decorators = decorators;
      }
      return elt;
    }
    parseAssignableListItemTypes(param, flags) {
      return param;
    }
    parseMaybeDefault(startLoc, left) {
      var _startLoc, _left;
      (_startLoc = startLoc) != null
        ? _startLoc
        : (startLoc = this.state.startLoc);
      left = (_left = left) != null ? _left : this.parseBindingAtom();
      if (!this.eat(29)) return left;
      const node = this.startNodeAt(startLoc);
      node.left = left;
      node.right = this.parseMaybeAssignAllowIn();
      return this.finishNode(node, 'AssignmentPattern');
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      return getOwn$1(
        {
          AssignmentPattern: 'left',
          RestElement: 'argument',
          ObjectProperty: 'value',
          ParenthesizedExpression: 'expression',
          ArrayPattern: 'elements',
          ObjectPattern: 'properties',
        },
        type
      );
    }
    checkLVal(
      expression,
      {
        in: ancestor,
        binding: binding = BIND_NONE,
        checkClashes: checkClashes = false,
        strictModeChanged: strictModeChanged = false,
        hasParenthesizedAncestor: hasParenthesizedAncestor = false,
      }
    ) {
      var _expression$extra;
      const type = expression.type;
      if (this.isObjectMethod(expression)) return;
      if (type === 'MemberExpression') {
        if (binding !== BIND_NONE) {
          this.raise(Errors.InvalidPropertyBindingPattern, {at: expression});
        }
        return;
      }
      if (type === 'Identifier') {
        this.checkIdentifier(expression, binding, strictModeChanged);
        const {name: name} = expression;
        if (checkClashes) {
          if (checkClashes.has(name)) {
            this.raise(Errors.ParamDupe, {at: expression});
          } else {
            checkClashes.add(name);
          }
        }
        return;
      }
      const validity = this.isValidLVal(
        type,
        !(
          hasParenthesizedAncestor ||
          ((_expression$extra = expression.extra) != null &&
            _expression$extra.parenthesized)
        ) && ancestor.type === 'AssignmentExpression',
        binding
      );
      if (validity === true) return;
      if (validity === false) {
        const ParseErrorClass =
          binding === BIND_NONE ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
        this.raise(ParseErrorClass, {at: expression, ancestor: ancestor});
        return;
      }
      const [key, isParenthesizedExpression] = Array.isArray(validity)
        ? validity
        : [validity, type === 'ParenthesizedExpression'];
      const nextAncestor =
        type === 'ArrayPattern' ||
        type === 'ObjectPattern' ||
        type === 'ParenthesizedExpression'
          ? {type: type}
          : ancestor;
      for (const child of [].concat(expression[key])) {
        if (child) {
          this.checkLVal(child, {
            in: nextAncestor,
            binding: binding,
            checkClashes: checkClashes,
            strictModeChanged: strictModeChanged,
            hasParenthesizedAncestor: isParenthesizedExpression,
          });
        }
      }
    }
    checkIdentifier(at, bindingType, strictModeChanged = false) {
      if (
        this.state.strict &&
        (strictModeChanged
          ? isStrictBindReservedWord(at.name, this.inModule)
          : isStrictBindOnlyReservedWord(at.name))
      ) {
        if (bindingType === BIND_NONE) {
          this.raise(Errors.StrictEvalArguments, {
            at: at,
            referenceName: at.name,
          });
        } else {
          this.raise(Errors.StrictEvalArgumentsBinding, {
            at: at,
            bindingName: at.name,
          });
        }
      }
      if (bindingType & BIND_FLAGS_NO_LET_IN_LEXICAL && at.name === 'let') {
        this.raise(Errors.LetInLexicalBinding, {at: at});
      }
      if (!(bindingType & BIND_NONE)) {
        this.declareNameFromIdentifier(at, bindingType);
      }
    }
    declareNameFromIdentifier(identifier, binding) {
      this.scope.declareName(identifier.name, binding, identifier.loc.start);
    }
    checkToRestConversion(node, allowPattern) {
      switch (node.type) {
        case 'ParenthesizedExpression':
          this.checkToRestConversion(node.expression, allowPattern);
          break;
        case 'Identifier':
        case 'MemberExpression':
          break;
        case 'ArrayExpression':
        case 'ObjectExpression':
          if (allowPattern) break;
        default:
          this.raise(Errors.InvalidRestAssignmentPattern, {at: node});
      }
    }
    checkCommaAfterRest(close) {
      if (!this.match(12)) {
        return false;
      }
      this.raise(
        this.lookaheadCharCode() === close
          ? Errors.RestTrailingComma
          : Errors.ElementAfterRest,
        {at: this.state.startLoc}
      );
      return true;
    }
  }
  const getOwn = (object, key) =>
    Object.hasOwnProperty.call(object, key) && object[key];
  function nonNull(x) {
    if (x == null) {
      throw new Error(`Unexpected ${x} value.`);
    }
    return x;
  }
  function assert(x) {
    if (!x) {
      throw new Error('Assert fail');
    }
  }
  const TSErrors = ParseErrorEnum`typescript`({
    AbstractMethodHasImplementation: ({methodName: methodName}) =>
      `Method '${methodName}' cannot have an implementation because it is marked abstract.`,
    AbstractPropertyHasInitializer: ({propertyName: propertyName}) =>
      `Property '${propertyName}' cannot have an initializer because it is marked abstract.`,
    AccesorCannotDeclareThisParameter:
      "'get' and 'set' accessors cannot declare 'this' parameters.",
    AccesorCannotHaveTypeParameters: 'An accessor cannot have type parameters.',
    AccessorCannotBeOptional:
      "An 'accessor' property cannot be declared optional.",
    ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
    ClassMethodHasReadonly:
      "Class methods cannot have the 'readonly' modifier.",
    ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference:
      "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
    ConstructorHasTypeParameters:
      'Type parameters cannot appear on a constructor declaration.',
    DeclareAccessor: ({kind: kind}) =>
      `'declare' is not allowed in ${kind}ters.`,
    DeclareClassFieldHasInitializer:
      'Initializers are not allowed in ambient contexts.',
    DeclareFunctionHasImplementation:
      'An implementation cannot be declared in ambient contexts.',
    DuplicateAccessibilityModifier: ({modifier: modifier}) =>
      `Accessibility modifier already seen.`,
    DuplicateModifier: ({modifier: modifier}) =>
      `Duplicate modifier: '${modifier}'.`,
    EmptyHeritageClauseType: ({token: token}) =>
      `'${token}' list cannot be empty.`,
    EmptyTypeArguments: 'Type argument list cannot be empty.',
    EmptyTypeParameters: 'Type parameter list cannot be empty.',
    ExpectedAmbientAfterExportDeclare:
      "'export declare' must be followed by an ambient declaration.",
    ImportAliasHasImportType: "An import alias can not use 'import type'.",
    ImportReflectionHasImportType:
      'An `import module` declaration can not use `type` modifier',
    IncompatibleModifiers: ({modifiers: modifiers}) =>
      `'${modifiers[0]}' modifier cannot be used with '${modifiers[1]}' modifier.`,
    IndexSignatureHasAbstract:
      "Index signatures cannot have the 'abstract' modifier.",
    IndexSignatureHasAccessibility: ({modifier: modifier}) =>
      `Index signatures cannot have an accessibility modifier ('${modifier}').`,
    IndexSignatureHasDeclare:
      "Index signatures cannot have the 'declare' modifier.",
    IndexSignatureHasOverride:
      "'override' modifier cannot appear on an index signature.",
    IndexSignatureHasStatic:
      "Index signatures cannot have the 'static' modifier.",
    InitializerNotAllowedInAmbientContext:
      'Initializers are not allowed in ambient contexts.',
    InvalidModifierOnTypeMember: ({modifier: modifier}) =>
      `'${modifier}' modifier cannot appear on a type member.`,
    InvalidModifierOnTypeParameter: ({modifier: modifier}) =>
      `'${modifier}' modifier cannot appear on a type parameter.`,
    InvalidModifierOnTypeParameterPositions: ({modifier: modifier}) =>
      `'${modifier}' modifier can only appear on a type parameter of a class, interface or type alias.`,
    InvalidModifiersOrder: ({orderedModifiers: orderedModifiers}) =>
      `'${orderedModifiers[0]}' modifier must precede '${orderedModifiers[1]}' modifier.`,
    InvalidPropertyAccessAfterInstantiationExpression:
      'Invalid property access after an instantiation expression. ' +
      'You can either wrap the instantiation expression in parentheses, or delete the type arguments.',
    InvalidTupleMemberLabel:
      'Tuple members must be labeled with a simple identifier.',
    MissingInterfaceName:
      "'interface' declarations must be followed by an identifier.",
    MixedLabeledAndUnlabeledElements:
      'Tuple members must all have names or all not have names.',
    NonAbstractClassHasAbstractMethod:
      'Abstract methods can only appear within an abstract class.',
    NonClassMethodPropertyHasAbstractModifer:
      "'abstract' modifier can only appear on a class, method, or property declaration.",
    OptionalTypeBeforeRequired:
      'A required element cannot follow an optional element.',
    OverrideNotInSubClass:
      "This member cannot have an 'override' modifier because its containing class does not extend another class.",
    PatternIsOptional:
      'A binding pattern parameter cannot be optional in an implementation signature.',
    PrivateElementHasAbstract:
      "Private elements cannot have the 'abstract' modifier.",
    PrivateElementHasAccessibility: ({modifier: modifier}) =>
      `Private elements cannot have an accessibility modifier ('${modifier}').`,
    ReadonlyForMethodSignature:
      "'readonly' modifier can only appear on a property declaration or index signature.",
    ReservedArrowTypeParam:
      'This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.',
    ReservedTypeAssertion:
      'This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.',
    SetAccesorCannotHaveOptionalParameter:
      "A 'set' accessor cannot have an optional parameter.",
    SetAccesorCannotHaveRestParameter:
      "A 'set' accessor cannot have rest parameter.",
    SetAccesorCannotHaveReturnType:
      "A 'set' accessor cannot have a return type annotation.",
    SingleTypeParameterWithoutTrailingComma: ({
      typeParameterName: typeParameterName,
    }) =>
      `Single type parameter ${typeParameterName} should have a trailing comma. Example usage: <${typeParameterName},>.`,
    StaticBlockCannotHaveModifier:
      'Static class blocks cannot have any modifier.',
    TupleOptionalAfterType:
      'A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).',
    TypeAnnotationAfterAssign:
      'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
    TypeImportCannotSpecifyDefaultAndNamed:
      'A type-only import can specify a default import or named bindings, but not both.',
    TypeModifierIsUsedInTypeExports:
      "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
    TypeModifierIsUsedInTypeImports:
      "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
    UnexpectedParameterModifier:
      'A parameter property is only allowed in a constructor implementation.',
    UnexpectedReadonly:
      "'readonly' type modifier is only permitted on array and tuple literal types.",
    UnexpectedTypeAnnotation: 'Did not expect a type annotation here.',
    UnexpectedTypeCastInParameter:
      'Unexpected type cast in parameter position.',
    UnsupportedImportTypeArgument:
      'Argument in a type import must be a string literal.',
    UnsupportedParameterPropertyKind:
      'A parameter property may not be declared using a binding pattern.',
    UnsupportedSignatureParameterKind: ({type: type}) =>
      `Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ${type}.`,
  });
  function keywordTypeFromName(value) {
    switch (value) {
      case 'any':
        return 'TSAnyKeyword';
      case 'boolean':
        return 'TSBooleanKeyword';
      case 'bigint':
        return 'TSBigIntKeyword';
      case 'never':
        return 'TSNeverKeyword';
      case 'number':
        return 'TSNumberKeyword';
      case 'object':
        return 'TSObjectKeyword';
      case 'string':
        return 'TSStringKeyword';
      case 'symbol':
        return 'TSSymbolKeyword';
      case 'undefined':
        return 'TSUndefinedKeyword';
      case 'unknown':
        return 'TSUnknownKeyword';
      default:
        return undefined;
    }
  }
  function tsIsAccessModifier(modifier) {
    return (
      modifier === 'private' ||
      modifier === 'public' ||
      modifier === 'protected'
    );
  }
  function tsIsVarianceAnnotations(modifier) {
    return modifier === 'in' || modifier === 'out';
  }
  var typescript = superClass =>
    class TypeScriptParserMixin extends superClass {
      constructor(...args) {
        super(...args);
        this.tsParseInOutModifiers = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['in', 'out'],
          disallowedModifiers: [
            'const',
            'public',
            'private',
            'protected',
            'readonly',
            'declare',
            'abstract',
            'override',
          ],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
        });
        this.tsParseConstModifier = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['const'],
          disallowedModifiers: ['in', 'out'],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
        });
        this.tsParseInOutConstModifiers = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['in', 'out', 'const'],
          disallowedModifiers: [
            'public',
            'private',
            'protected',
            'readonly',
            'declare',
            'abstract',
            'override',
          ],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
        });
      }
      getScopeHandler() {
        return TypeScriptScopeHandler;
      }
      tsIsIdentifier() {
        return tokenIsIdentifier(this.state.type);
      }
      tsTokenCanFollowModifier() {
        return (
          (this.match(0) ||
            this.match(5) ||
            this.match(55) ||
            this.match(21) ||
            this.match(136) ||
            this.isLiteralPropertyName()) &&
          !this.hasPrecedingLineBreak()
        );
      }
      tsNextTokenCanFollowModifier() {
        this.next();
        return this.tsTokenCanFollowModifier();
      }
      tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
        if (
          !tokenIsIdentifier(this.state.type) &&
          this.state.type !== 58 &&
          this.state.type !== 75
        ) {
          return undefined;
        }
        const modifier = this.state.value;
        if (allowedModifiers.indexOf(modifier) !== -1) {
          if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
            return undefined;
          }
          if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
            return modifier;
          }
        }
        return undefined;
      }
      tsParseModifiers(
        {
          allowedModifiers: allowedModifiers,
          disallowedModifiers: disallowedModifiers,
          stopOnStartOfClassStaticBlock: stopOnStartOfClassStaticBlock,
          errorTemplate: errorTemplate = TSErrors.InvalidModifierOnTypeMember,
        },
        modified
      ) {
        const enforceOrder = (loc, modifier, before, after) => {
          if (modifier === before && modified[after]) {
            this.raise(TSErrors.InvalidModifiersOrder, {
              at: loc,
              orderedModifiers: [before, after],
            });
          }
        };
        const incompatible = (loc, modifier, mod1, mod2) => {
          if (
            (modified[mod1] && modifier === mod2) ||
            (modified[mod2] && modifier === mod1)
          ) {
            this.raise(TSErrors.IncompatibleModifiers, {
              at: loc,
              modifiers: [mod1, mod2],
            });
          }
        };
        for (;;) {
          const {startLoc: startLoc} = this.state;
          const modifier = this.tsParseModifier(
            allowedModifiers.concat(
              disallowedModifiers != null ? disallowedModifiers : []
            ),
            stopOnStartOfClassStaticBlock
          );
          if (!modifier) break;
          if (tsIsAccessModifier(modifier)) {
            if (modified.accessibility) {
              this.raise(TSErrors.DuplicateAccessibilityModifier, {
                at: startLoc,
                modifier: modifier,
              });
            } else {
              enforceOrder(startLoc, modifier, modifier, 'override');
              enforceOrder(startLoc, modifier, modifier, 'static');
              enforceOrder(startLoc, modifier, modifier, 'readonly');
              modified.accessibility = modifier;
            }
          } else if (tsIsVarianceAnnotations(modifier)) {
            if (modified[modifier]) {
              this.raise(TSErrors.DuplicateModifier, {
                at: startLoc,
                modifier: modifier,
              });
            }
            modified[modifier] = true;
            enforceOrder(startLoc, modifier, 'in', 'out');
          } else {
            if (Object.hasOwnProperty.call(modified, modifier)) {
              this.raise(TSErrors.DuplicateModifier, {
                at: startLoc,
                modifier: modifier,
              });
            } else {
              enforceOrder(startLoc, modifier, 'static', 'readonly');
              enforceOrder(startLoc, modifier, 'static', 'override');
              enforceOrder(startLoc, modifier, 'override', 'readonly');
              enforceOrder(startLoc, modifier, 'abstract', 'override');
              incompatible(startLoc, modifier, 'declare', 'override');
              incompatible(startLoc, modifier, 'static', 'abstract');
            }
            modified[modifier] = true;
          }
          if (
            disallowedModifiers != null &&
            disallowedModifiers.includes(modifier)
          ) {
            this.raise(errorTemplate, {at: startLoc, modifier: modifier});
          }
        }
      }
      tsIsListTerminator(kind) {
        switch (kind) {
          case 'EnumMembers':
          case 'TypeMembers':
            return this.match(8);
          case 'HeritageClauseElement':
            return this.match(5);
          case 'TupleElementTypes':
            return this.match(3);
          case 'TypeParametersOrArguments':
            return this.match(48);
        }
      }
      tsParseList(kind, parseElement) {
        const result = [];
        while (!this.tsIsListTerminator(kind)) {
          result.push(parseElement());
        }
        return result;
      }
      tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
        return nonNull(
          this.tsParseDelimitedListWorker(
            kind,
            parseElement,
            true,
            refTrailingCommaPos
          )
        );
      }
      tsParseDelimitedListWorker(
        kind,
        parseElement,
        expectSuccess,
        refTrailingCommaPos
      ) {
        const result = [];
        let trailingCommaPos = -1;
        for (;;) {
          if (this.tsIsListTerminator(kind)) {
            break;
          }
          trailingCommaPos = -1;
          const element = parseElement();
          if (element == null) {
            return undefined;
          }
          result.push(element);
          if (this.eat(12)) {
            trailingCommaPos = this.state.lastTokStart;
            continue;
          }
          if (this.tsIsListTerminator(kind)) {
            break;
          }
          if (expectSuccess) {
            this.expect(12);
          }
          return undefined;
        }
        if (refTrailingCommaPos) {
          refTrailingCommaPos.value = trailingCommaPos;
        }
        return result;
      }
      tsParseBracketedList(
        kind,
        parseElement,
        bracket,
        skipFirstToken,
        refTrailingCommaPos
      ) {
        if (!skipFirstToken) {
          if (bracket) {
            this.expect(0);
          } else {
            this.expect(47);
          }
        }
        const result = this.tsParseDelimitedList(
          kind,
          parseElement,
          refTrailingCommaPos
        );
        if (bracket) {
          this.expect(3);
        } else {
          this.expect(48);
        }
        return result;
      }
      tsParseImportType() {
        const node = this.startNode();
        this.expect(83);
        this.expect(10);
        if (!this.match(131)) {
          this.raise(TSErrors.UnsupportedImportTypeArgument, {
            at: this.state.startLoc,
          });
        }
        node.argument = super.parseExprAtom();
        this.expect(11);
        if (this.eat(16)) {
          node.qualifier = this.tsParseEntityName();
        }
        if (this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSImportType');
      }
      tsParseEntityName(allowReservedWords = true) {
        let entity = this.parseIdentifier(allowReservedWords);
        while (this.eat(16)) {
          const node = this.startNodeAtNode(entity);
          node.left = entity;
          node.right = this.parseIdentifier(allowReservedWords);
          entity = this.finishNode(node, 'TSQualifiedName');
        }
        return entity;
      }
      tsParseTypeReference() {
        const node = this.startNode();
        node.typeName = this.tsParseEntityName();
        if (!this.hasPrecedingLineBreak() && this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSTypeReference');
      }
      tsParseThisTypePredicate(lhs) {
        this.next();
        const node = this.startNodeAtNode(lhs);
        node.parameterName = lhs;
        node.typeAnnotation = this.tsParseTypeAnnotation(false);
        node.asserts = false;
        return this.finishNode(node, 'TSTypePredicate');
      }
      tsParseThisTypeNode() {
        const node = this.startNode();
        this.next();
        return this.finishNode(node, 'TSThisType');
      }
      tsParseTypeQuery() {
        const node = this.startNode();
        this.expect(87);
        if (this.match(83)) {
          node.exprName = this.tsParseImportType();
        } else {
          node.exprName = this.tsParseEntityName();
        }
        if (!this.hasPrecedingLineBreak() && this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSTypeQuery');
      }
      tsParseTypeParameter(parseModifiers) {
        const node = this.startNode();
        parseModifiers(node);
        node.name = this.tsParseTypeParameterName();
        node.constraint = this.tsEatThenParseType(81);
        node.default = this.tsEatThenParseType(29);
        return this.finishNode(node, 'TSTypeParameter');
      }
      tsTryParseTypeParameters(parseModifiers) {
        if (this.match(47)) {
          return this.tsParseTypeParameters(parseModifiers);
        }
      }
      tsParseTypeParameters(parseModifiers) {
        const node = this.startNode();
        if (this.match(47) || this.match(140)) {
          this.next();
        } else {
          this.unexpected();
        }
        const refTrailingCommaPos = {value: -1};
        node.params = this.tsParseBracketedList(
          'TypeParametersOrArguments',
          this.tsParseTypeParameter.bind(this, parseModifiers),
          false,
          true,
          refTrailingCommaPos
        );
        if (node.params.length === 0) {
          this.raise(TSErrors.EmptyTypeParameters, {at: node});
        }
        if (refTrailingCommaPos.value !== -1) {
          this.addExtra(node, 'trailingComma', refTrailingCommaPos.value);
        }
        return this.finishNode(node, 'TSTypeParameterDeclaration');
      }
      tsFillSignature(returnToken, signature) {
        const returnTokenRequired = returnToken === 19;
        const paramsKey = 'parameters';
        const returnTypeKey = 'typeAnnotation';
        signature.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        this.expect(10);
        signature[paramsKey] = this.tsParseBindingListForSignature();
        if (returnTokenRequired) {
          signature[returnTypeKey] =
            this.tsParseTypeOrTypePredicateAnnotation(returnToken);
        } else if (this.match(returnToken)) {
          signature[returnTypeKey] =
            this.tsParseTypeOrTypePredicateAnnotation(returnToken);
        }
      }
      tsParseBindingListForSignature() {
        return super.parseBindingList(11, 41, 2).map(pattern => {
          if (
            pattern.type !== 'Identifier' &&
            pattern.type !== 'RestElement' &&
            pattern.type !== 'ObjectPattern' &&
            pattern.type !== 'ArrayPattern'
          ) {
            this.raise(TSErrors.UnsupportedSignatureParameterKind, {
              at: pattern,
              type: pattern.type,
            });
          }
          return pattern;
        });
      }
      tsParseTypeMemberSemicolon() {
        if (!this.eat(12) && !this.isLineTerminator()) {
          this.expect(13);
        }
      }
      tsParseSignatureMember(kind, node) {
        this.tsFillSignature(14, node);
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(node, kind);
      }
      tsIsUnambiguouslyIndexSignature() {
        this.next();
        if (tokenIsIdentifier(this.state.type)) {
          this.next();
          return this.match(14);
        }
        return false;
      }
      tsTryParseIndexSignature(node) {
        if (
          !(
            this.match(0) &&
            this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this))
          )
        ) {
          return undefined;
        }
        this.expect(0);
        const id = this.parseIdentifier();
        id.typeAnnotation = this.tsParseTypeAnnotation();
        this.resetEndLocation(id);
        this.expect(3);
        node.parameters = [id];
        const type = this.tsTryParseTypeAnnotation();
        if (type) node.typeAnnotation = type;
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(node, 'TSIndexSignature');
      }
      tsParsePropertyOrMethodSignature(node, readonly) {
        if (this.eat(17)) node.optional = true;
        const nodeAny = node;
        if (this.match(10) || this.match(47)) {
          if (readonly) {
            this.raise(TSErrors.ReadonlyForMethodSignature, {at: node});
          }
          const method = nodeAny;
          if (method.kind && this.match(47)) {
            this.raise(TSErrors.AccesorCannotHaveTypeParameters, {
              at: this.state.curPosition(),
            });
          }
          this.tsFillSignature(14, method);
          this.tsParseTypeMemberSemicolon();
          const paramsKey = 'parameters';
          const returnTypeKey = 'typeAnnotation';
          if (method.kind === 'get') {
            if (method[paramsKey].length > 0) {
              this.raise(Errors.BadGetterArity, {at: this.state.curPosition()});
              if (this.isThisParam(method[paramsKey][0])) {
                this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
                  at: this.state.curPosition(),
                });
              }
            }
          } else if (method.kind === 'set') {
            if (method[paramsKey].length !== 1) {
              this.raise(Errors.BadSetterArity, {at: this.state.curPosition()});
            } else {
              const firstParameter = method[paramsKey][0];
              if (this.isThisParam(firstParameter)) {
                this.raise(TSErrors.AccesorCannotDeclareThisParameter, {
                  at: this.state.curPosition(),
                });
              }
              if (
                firstParameter.type === 'Identifier' &&
                firstParameter.optional
              ) {
                this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, {
                  at: this.state.curPosition(),
                });
              }
              if (firstParameter.type === 'RestElement') {
                this.raise(TSErrors.SetAccesorCannotHaveRestParameter, {
                  at: this.state.curPosition(),
                });
              }
            }
            if (method[returnTypeKey]) {
              this.raise(TSErrors.SetAccesorCannotHaveReturnType, {
                at: method[returnTypeKey],
              });
            }
          } else {
            method.kind = 'method';
          }
          return this.finishNode(method, 'TSMethodSignature');
        } else {
          const property = nodeAny;
          if (readonly) property.readonly = true;
          const type = this.tsTryParseTypeAnnotation();
          if (type) property.typeAnnotation = type;
          this.tsParseTypeMemberSemicolon();
          return this.finishNode(property, 'TSPropertySignature');
        }
      }
      tsParseTypeMember() {
        const node = this.startNode();
        if (this.match(10) || this.match(47)) {
          return this.tsParseSignatureMember(
            'TSCallSignatureDeclaration',
            node
          );
        }
        if (this.match(77)) {
          const id = this.startNode();
          this.next();
          if (this.match(10) || this.match(47)) {
            return this.tsParseSignatureMember(
              'TSConstructSignatureDeclaration',
              node
            );
          } else {
            node.key = this.createIdentifier(id, 'new');
            return this.tsParsePropertyOrMethodSignature(node, false);
          }
        }
        this.tsParseModifiers(
          {
            allowedModifiers: ['readonly'],
            disallowedModifiers: [
              'declare',
              'abstract',
              'private',
              'protected',
              'public',
              'static',
              'override',
            ],
          },
          node
        );
        const idx = this.tsTryParseIndexSignature(node);
        if (idx) {
          return idx;
        }
        super.parsePropertyName(node);
        if (
          !node.computed &&
          node.key.type === 'Identifier' &&
          (node.key.name === 'get' || node.key.name === 'set') &&
          this.tsTokenCanFollowModifier()
        ) {
          node.kind = node.key.name;
          super.parsePropertyName(node);
        }
        return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
      }
      tsParseTypeLiteral() {
        const node = this.startNode();
        node.members = this.tsParseObjectTypeMembers();
        return this.finishNode(node, 'TSTypeLiteral');
      }
      tsParseObjectTypeMembers() {
        this.expect(5);
        const members = this.tsParseList(
          'TypeMembers',
          this.tsParseTypeMember.bind(this)
        );
        this.expect(8);
        return members;
      }
      tsIsStartOfMappedType() {
        this.next();
        if (this.eat(53)) {
          return this.isContextual(120);
        }
        if (this.isContextual(120)) {
          this.next();
        }
        if (!this.match(0)) {
          return false;
        }
        this.next();
        if (!this.tsIsIdentifier()) {
          return false;
        }
        this.next();
        return this.match(58);
      }
      tsParseMappedTypeParameter() {
        const node = this.startNode();
        node.name = this.tsParseTypeParameterName();
        node.constraint = this.tsExpectThenParseType(58);
        return this.finishNode(node, 'TSTypeParameter');
      }
      tsParseMappedType() {
        const node = this.startNode();
        this.expect(5);
        if (this.match(53)) {
          node.readonly = this.state.value;
          this.next();
          this.expectContextual(120);
        } else if (this.eatContextual(120)) {
          node.readonly = true;
        }
        this.expect(0);
        node.typeParameter = this.tsParseMappedTypeParameter();
        node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
        this.expect(3);
        if (this.match(53)) {
          node.optional = this.state.value;
          this.next();
          this.expect(17);
        } else if (this.eat(17)) {
          node.optional = true;
        }
        node.typeAnnotation = this.tsTryParseType();
        this.semicolon();
        this.expect(8);
        return this.finishNode(node, 'TSMappedType');
      }
      tsParseTupleType() {
        const node = this.startNode();
        node.elementTypes = this.tsParseBracketedList(
          'TupleElementTypes',
          this.tsParseTupleElementType.bind(this),
          true,
          false
        );
        let seenOptionalElement = false;
        let labeledElements = null;
        node.elementTypes.forEach(elementNode => {
          var _labeledElements;
          const {type: type} = elementNode;
          if (
            seenOptionalElement &&
            type !== 'TSRestType' &&
            type !== 'TSOptionalType' &&
            !(type === 'TSNamedTupleMember' && elementNode.optional)
          ) {
            this.raise(TSErrors.OptionalTypeBeforeRequired, {at: elementNode});
          }
          seenOptionalElement ||
            (seenOptionalElement =
              (type === 'TSNamedTupleMember' && elementNode.optional) ||
              type === 'TSOptionalType');
          let checkType = type;
          if (type === 'TSRestType') {
            elementNode = elementNode.typeAnnotation;
            checkType = elementNode.type;
          }
          const isLabeled = checkType === 'TSNamedTupleMember';
          (_labeledElements = labeledElements) != null
            ? _labeledElements
            : (labeledElements = isLabeled);
          if (labeledElements !== isLabeled) {
            this.raise(TSErrors.MixedLabeledAndUnlabeledElements, {
              at: elementNode,
            });
          }
        });
        return this.finishNode(node, 'TSTupleType');
      }
      tsParseTupleElementType() {
        const {startLoc: startLoc} = this.state;
        const rest = this.eat(21);
        let labeled;
        let label;
        let optional;
        let type;
        const isWord = tokenIsKeywordOrIdentifier(this.state.type);
        const chAfterWord = isWord ? this.lookaheadCharCode() : null;
        if (chAfterWord === 58) {
          labeled = true;
          optional = false;
          label = this.parseIdentifier(true);
          this.expect(14);
          type = this.tsParseType();
        } else if (chAfterWord === 63) {
          optional = true;
          const startLoc = this.state.startLoc;
          const wordName = this.state.value;
          const typeOrLabel = this.tsParseNonArrayType();
          if (this.lookaheadCharCode() === 58) {
            labeled = true;
            label = this.createIdentifier(this.startNodeAt(startLoc), wordName);
            this.expect(17);
            this.expect(14);
            type = this.tsParseType();
          } else {
            labeled = false;
            type = typeOrLabel;
            this.expect(17);
          }
        } else {
          type = this.tsParseType();
          optional = this.eat(17);
          labeled = this.eat(14);
        }
        if (labeled) {
          let labeledNode;
          if (label) {
            labeledNode = this.startNodeAtNode(label);
            labeledNode.optional = optional;
            labeledNode.label = label;
            labeledNode.elementType = type;
            if (this.eat(17)) {
              labeledNode.optional = true;
              this.raise(TSErrors.TupleOptionalAfterType, {
                at: this.state.lastTokStartLoc,
              });
            }
          } else {
            labeledNode = this.startNodeAtNode(type);
            labeledNode.optional = optional;
            this.raise(TSErrors.InvalidTupleMemberLabel, {at: type});
            labeledNode.label = type;
            labeledNode.elementType = this.tsParseType();
          }
          type = this.finishNode(labeledNode, 'TSNamedTupleMember');
        } else if (optional) {
          const optionalTypeNode = this.startNodeAtNode(type);
          optionalTypeNode.typeAnnotation = type;
          type = this.finishNode(optionalTypeNode, 'TSOptionalType');
        }
        if (rest) {
          const restNode = this.startNodeAt(startLoc);
          restNode.typeAnnotation = type;
          type = this.finishNode(restNode, 'TSRestType');
        }
        return type;
      }
      tsParseParenthesizedType() {
        const node = this.startNode();
        this.expect(10);
        node.typeAnnotation = this.tsParseType();
        this.expect(11);
        return this.finishNode(node, 'TSParenthesizedType');
      }
      tsParseFunctionOrConstructorType(type, abstract) {
        const node = this.startNode();
        if (type === 'TSConstructorType') {
          node.abstract = !!abstract;
          if (abstract) this.next();
          this.next();
        }
        this.tsInAllowConditionalTypesContext(() =>
          this.tsFillSignature(19, node)
        );
        return this.finishNode(node, type);
      }
      tsParseLiteralTypeNode() {
        const node = this.startNode();
        node.literal = (() => {
          switch (this.state.type) {
            case 132:
            case 133:
            case 131:
            case 85:
            case 86:
              return super.parseExprAtom();
            default:
              this.unexpected();
          }
        })();
        return this.finishNode(node, 'TSLiteralType');
      }
      tsParseTemplateLiteralType() {
        const node = this.startNode();
        node.literal = super.parseTemplate(false);
        return this.finishNode(node, 'TSLiteralType');
      }
      parseTemplateSubstitution() {
        if (this.state.inType) return this.tsParseType();
        return super.parseTemplateSubstitution();
      }
      tsParseThisTypeOrThisTypePredicate() {
        const thisKeyword = this.tsParseThisTypeNode();
        if (this.isContextual(114) && !this.hasPrecedingLineBreak()) {
          return this.tsParseThisTypePredicate(thisKeyword);
        } else {
          return thisKeyword;
        }
      }
      tsParseNonArrayType() {
        switch (this.state.type) {
          case 131:
          case 132:
          case 133:
          case 85:
          case 86:
            return this.tsParseLiteralTypeNode();
          case 53:
            if (this.state.value === '-') {
              const node = this.startNode();
              const nextToken = this.lookahead();
              if (nextToken.type !== 132 && nextToken.type !== 133) {
                this.unexpected();
              }
              node.literal = this.parseMaybeUnary();
              return this.finishNode(node, 'TSLiteralType');
            }
            break;
          case 78:
            return this.tsParseThisTypeOrThisTypePredicate();
          case 87:
            return this.tsParseTypeQuery();
          case 83:
            return this.tsParseImportType();
          case 5:
            return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this))
              ? this.tsParseMappedType()
              : this.tsParseTypeLiteral();
          case 0:
            return this.tsParseTupleType();
          case 10:
            return this.tsParseParenthesizedType();
          case 25:
          case 24:
            return this.tsParseTemplateLiteralType();
          default: {
            const {type: type} = this.state;
            if (tokenIsIdentifier(type) || type === 88 || type === 84) {
              const nodeType =
                type === 88
                  ? 'TSVoidKeyword'
                  : type === 84
                    ? 'TSNullKeyword'
                    : keywordTypeFromName(this.state.value);
              if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
                const node = this.startNode();
                this.next();
                return this.finishNode(node, nodeType);
              }
              return this.tsParseTypeReference();
            }
          }
        }
        this.unexpected();
      }
      tsParseArrayTypeOrHigher() {
        let type = this.tsParseNonArrayType();
        while (!this.hasPrecedingLineBreak() && this.eat(0)) {
          if (this.match(3)) {
            const node = this.startNodeAtNode(type);
            node.elementType = type;
            this.expect(3);
            type = this.finishNode(node, 'TSArrayType');
          } else {
            const node = this.startNodeAtNode(type);
            node.objectType = type;
            node.indexType = this.tsParseType();
            this.expect(3);
            type = this.finishNode(node, 'TSIndexedAccessType');
          }
        }
        return type;
      }
      tsParseTypeOperator() {
        const node = this.startNode();
        const operator = this.state.value;
        this.next();
        node.operator = operator;
        node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
        if (operator === 'readonly') {
          this.tsCheckTypeAnnotationForReadOnly(node);
        }
        return this.finishNode(node, 'TSTypeOperator');
      }
      tsCheckTypeAnnotationForReadOnly(node) {
        switch (node.typeAnnotation.type) {
          case 'TSTupleType':
          case 'TSArrayType':
            return;
          default:
            this.raise(TSErrors.UnexpectedReadonly, {at: node});
        }
      }
      tsParseInferType() {
        const node = this.startNode();
        this.expectContextual(113);
        const typeParameter = this.startNode();
        typeParameter.name = this.tsParseTypeParameterName();
        typeParameter.constraint = this.tsTryParse(() =>
          this.tsParseConstraintForInferType()
        );
        node.typeParameter = this.finishNode(typeParameter, 'TSTypeParameter');
        return this.finishNode(node, 'TSInferType');
      }
      tsParseConstraintForInferType() {
        if (this.eat(81)) {
          const constraint = this.tsInDisallowConditionalTypesContext(() =>
            this.tsParseType()
          );
          if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
            return constraint;
          }
        }
      }
      tsParseTypeOperatorOrHigher() {
        const isTypeOperator =
          tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
        return isTypeOperator
          ? this.tsParseTypeOperator()
          : this.isContextual(113)
            ? this.tsParseInferType()
            : this.tsInAllowConditionalTypesContext(() =>
                this.tsParseArrayTypeOrHigher()
              );
      }
      tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
        const node = this.startNode();
        const hasLeadingOperator = this.eat(operator);
        const types = [];
        do {
          types.push(parseConstituentType());
        } while (this.eat(operator));
        if (types.length === 1 && !hasLeadingOperator) {
          return types[0];
        }
        node.types = types;
        return this.finishNode(node, kind);
      }
      tsParseIntersectionTypeOrHigher() {
        return this.tsParseUnionOrIntersectionType(
          'TSIntersectionType',
          this.tsParseTypeOperatorOrHigher.bind(this),
          45
        );
      }
      tsParseUnionTypeOrHigher() {
        return this.tsParseUnionOrIntersectionType(
          'TSUnionType',
          this.tsParseIntersectionTypeOrHigher.bind(this),
          43
        );
      }
      tsIsStartOfFunctionType() {
        if (this.match(47)) {
          return true;
        }
        return (
          this.match(10) &&
          this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this))
        );
      }
      tsSkipParameterStart() {
        if (tokenIsIdentifier(this.state.type) || this.match(78)) {
          this.next();
          return true;
        }
        if (this.match(5)) {
          const {errors: errors} = this.state;
          const previousErrorCount = errors.length;
          try {
            this.parseObjectLike(8, true);
            return errors.length === previousErrorCount;
          } catch (_unused) {
            return false;
          }
        }
        if (this.match(0)) {
          this.next();
          const {errors: errors} = this.state;
          const previousErrorCount = errors.length;
          try {
            super.parseBindingList(3, 93, 1);
            return errors.length === previousErrorCount;
          } catch (_unused2) {
            return false;
          }
        }
        return false;
      }
      tsIsUnambiguouslyStartOfFunctionType() {
        this.next();
        if (this.match(11) || this.match(21)) {
          return true;
        }
        if (this.tsSkipParameterStart()) {
          if (
            this.match(14) ||
            this.match(12) ||
            this.match(17) ||
            this.match(29)
          ) {
            return true;
          }
          if (this.match(11)) {
            this.next();
            if (this.match(19)) {
              return true;
            }
          }
        }
        return false;
      }
      tsParseTypeOrTypePredicateAnnotation(returnToken) {
        return this.tsInType(() => {
          const t = this.startNode();
          this.expect(returnToken);
          const node = this.startNode();
          const asserts = !!this.tsTryParse(
            this.tsParseTypePredicateAsserts.bind(this)
          );
          if (asserts && this.match(78)) {
            let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();
            if (thisTypePredicate.type === 'TSThisType') {
              node.parameterName = thisTypePredicate;
              node.asserts = true;
              node.typeAnnotation = null;
              thisTypePredicate = this.finishNode(node, 'TSTypePredicate');
            } else {
              this.resetStartLocationFromNode(thisTypePredicate, node);
              thisTypePredicate.asserts = true;
            }
            t.typeAnnotation = thisTypePredicate;
            return this.finishNode(t, 'TSTypeAnnotation');
          }
          const typePredicateVariable =
            this.tsIsIdentifier() &&
            this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
          if (!typePredicateVariable) {
            if (!asserts) {
              return this.tsParseTypeAnnotation(false, t);
            }
            node.parameterName = this.parseIdentifier();
            node.asserts = asserts;
            node.typeAnnotation = null;
            t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
            return this.finishNode(t, 'TSTypeAnnotation');
          }
          const type = this.tsParseTypeAnnotation(false);
          node.parameterName = typePredicateVariable;
          node.typeAnnotation = type;
          node.asserts = asserts;
          t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
          return this.finishNode(t, 'TSTypeAnnotation');
        });
      }
      tsTryParseTypeOrTypePredicateAnnotation() {
        return this.match(14)
          ? this.tsParseTypeOrTypePredicateAnnotation(14)
          : undefined;
      }
      tsTryParseTypeAnnotation() {
        return this.match(14) ? this.tsParseTypeAnnotation() : undefined;
      }
      tsTryParseType() {
        return this.tsEatThenParseType(14);
      }
      tsParseTypePredicatePrefix() {
        const id = this.parseIdentifier();
        if (this.isContextual(114) && !this.hasPrecedingLineBreak()) {
          this.next();
          return id;
        }
      }
      tsParseTypePredicateAsserts() {
        if (this.state.type !== 107) {
          return false;
        }
        const containsEsc = this.state.containsEsc;
        this.next();
        if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
          return false;
        }
        if (containsEsc) {
          this.raise(Errors.InvalidEscapedReservedWord, {
            at: this.state.lastTokStartLoc,
            reservedWord: 'asserts',
          });
        }
        return true;
      }
      tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
        this.tsInType(() => {
          if (eatColon) this.expect(14);
          t.typeAnnotation = this.tsParseType();
        });
        return this.finishNode(t, 'TSTypeAnnotation');
      }
      tsParseType() {
        assert(this.state.inType);
        const type = this.tsParseNonConditionalType();
        if (
          this.state.inDisallowConditionalTypesContext ||
          this.hasPrecedingLineBreak() ||
          !this.eat(81)
        ) {
          return type;
        }
        const node = this.startNodeAtNode(type);
        node.checkType = type;
        node.extendsType = this.tsInDisallowConditionalTypesContext(() =>
          this.tsParseNonConditionalType()
        );
        this.expect(17);
        node.trueType = this.tsInAllowConditionalTypesContext(() =>
          this.tsParseType()
        );
        this.expect(14);
        node.falseType = this.tsInAllowConditionalTypesContext(() =>
          this.tsParseType()
        );
        return this.finishNode(node, 'TSConditionalType');
      }
      isAbstractConstructorSignature() {
        return this.isContextual(122) && this.lookahead().type === 77;
      }
      tsParseNonConditionalType() {
        if (this.tsIsStartOfFunctionType()) {
          return this.tsParseFunctionOrConstructorType('TSFunctionType');
        }
        if (this.match(77)) {
          return this.tsParseFunctionOrConstructorType('TSConstructorType');
        } else if (this.isAbstractConstructorSignature()) {
          return this.tsParseFunctionOrConstructorType(
            'TSConstructorType',
            true
          );
        }
        return this.tsParseUnionTypeOrHigher();
      }
      tsParseTypeAssertion() {
        if (this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')) {
          this.raise(TSErrors.ReservedTypeAssertion, {at: this.state.startLoc});
        }
        const node = this.startNode();
        node.typeAnnotation = this.tsInType(() => {
          this.next();
          return this.match(75)
            ? this.tsParseTypeReference()
            : this.tsParseType();
        });
        this.expect(48);
        node.expression = this.parseMaybeUnary();
        return this.finishNode(node, 'TSTypeAssertion');
      }
      tsParseHeritageClause(token) {
        const originalStartLoc = this.state.startLoc;
        const delimitedList = this.tsParseDelimitedList(
          'HeritageClauseElement',
          () => {
            const node = this.startNode();
            node.expression = this.tsParseEntityName();
            if (this.match(47)) {
              node.typeParameters = this.tsParseTypeArguments();
            }
            return this.finishNode(node, 'TSExpressionWithTypeArguments');
          }
        );
        if (!delimitedList.length) {
          this.raise(TSErrors.EmptyHeritageClauseType, {
            at: originalStartLoc,
            token: token,
          });
        }
        return delimitedList;
      }
      tsParseInterfaceDeclaration(node, properties = {}) {
        if (this.hasFollowingLineBreak()) return null;
        this.expectContextual(127);
        if (properties.declare) node.declare = true;
        if (tokenIsIdentifier(this.state.type)) {
          node.id = this.parseIdentifier();
          this.checkIdentifier(node.id, BIND_TS_INTERFACE);
        } else {
          node.id = null;
          this.raise(TSErrors.MissingInterfaceName, {at: this.state.startLoc});
        }
        node.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutConstModifiers
        );
        if (this.eat(81)) {
          node.extends = this.tsParseHeritageClause('extends');
        }
        const body = this.startNode();
        body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
        node.body = this.finishNode(body, 'TSInterfaceBody');
        return this.finishNode(node, 'TSInterfaceDeclaration');
      }
      tsParseTypeAliasDeclaration(node) {
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, BIND_TS_TYPE);
        node.typeAnnotation = this.tsInType(() => {
          node.typeParameters = this.tsTryParseTypeParameters(
            this.tsParseInOutModifiers
          );
          this.expect(29);
          if (this.isContextual(112) && this.lookahead().type !== 16) {
            const node = this.startNode();
            this.next();
            return this.finishNode(node, 'TSIntrinsicKeyword');
          }
          return this.tsParseType();
        });
        this.semicolon();
        return this.finishNode(node, 'TSTypeAliasDeclaration');
      }
      tsInNoContext(cb) {
        const oldContext = this.state.context;
        this.state.context = [oldContext[0]];
        try {
          return cb();
        } finally {
          this.state.context = oldContext;
        }
      }
      tsInType(cb) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        try {
          return cb();
        } finally {
          this.state.inType = oldInType;
        }
      }
      tsInDisallowConditionalTypesContext(cb) {
        const oldInDisallowConditionalTypesContext =
          this.state.inDisallowConditionalTypesContext;
        this.state.inDisallowConditionalTypesContext = true;
        try {
          return cb();
        } finally {
          this.state.inDisallowConditionalTypesContext =
            oldInDisallowConditionalTypesContext;
        }
      }
      tsInAllowConditionalTypesContext(cb) {
        const oldInDisallowConditionalTypesContext =
          this.state.inDisallowConditionalTypesContext;
        this.state.inDisallowConditionalTypesContext = false;
        try {
          return cb();
        } finally {
          this.state.inDisallowConditionalTypesContext =
            oldInDisallowConditionalTypesContext;
        }
      }
      tsEatThenParseType(token) {
        return !this.match(token) ? undefined : this.tsNextThenParseType();
      }
      tsExpectThenParseType(token) {
        return this.tsDoThenParseType(() => this.expect(token));
      }
      tsNextThenParseType() {
        return this.tsDoThenParseType(() => this.next());
      }
      tsDoThenParseType(cb) {
        return this.tsInType(() => {
          cb();
          return this.tsParseType();
        });
      }
      tsParseEnumMember() {
        const node = this.startNode();
        node.id = this.match(131)
          ? super.parseStringLiteral(this.state.value)
          : this.parseIdentifier(true);
        if (this.eat(29)) {
          node.initializer = super.parseMaybeAssignAllowIn();
        }
        return this.finishNode(node, 'TSEnumMember');
      }
      tsParseEnumDeclaration(node, properties = {}) {
        if (properties.const) node.const = true;
        if (properties.declare) node.declare = true;
        this.expectContextual(124);
        node.id = this.parseIdentifier();
        this.checkIdentifier(
          node.id,
          node.const ? BIND_TS_CONST_ENUM : BIND_TS_ENUM
        );
        this.expect(5);
        node.members = this.tsParseDelimitedList(
          'EnumMembers',
          this.tsParseEnumMember.bind(this)
        );
        this.expect(8);
        return this.finishNode(node, 'TSEnumDeclaration');
      }
      tsParseModuleBlock() {
        const node = this.startNode();
        this.scope.enter(SCOPE_OTHER);
        this.expect(5);
        super.parseBlockOrModuleBlockBody((node.body = []), undefined, true, 8);
        this.scope.exit();
        return this.finishNode(node, 'TSModuleBlock');
      }
      tsParseModuleOrNamespaceDeclaration(node, nested = false) {
        node.id = this.parseIdentifier();
        if (!nested) {
          this.checkIdentifier(node.id, BIND_TS_NAMESPACE);
        }
        if (this.eat(16)) {
          const inner = this.startNode();
          this.tsParseModuleOrNamespaceDeclaration(inner, true);
          node.body = inner;
        } else {
          this.scope.enter(SCOPE_TS_MODULE);
          this.prodParam.enter(PARAM);
          node.body = this.tsParseModuleBlock();
          this.prodParam.exit();
          this.scope.exit();
        }
        return this.finishNode(node, 'TSModuleDeclaration');
      }
      tsParseAmbientExternalModuleDeclaration(node) {
        if (this.isContextual(110)) {
          node.global = true;
          node.id = this.parseIdentifier();
        } else if (this.match(131)) {
          node.id = super.parseStringLiteral(this.state.value);
        } else {
          this.unexpected();
        }
        if (this.match(5)) {
          this.scope.enter(SCOPE_TS_MODULE);
          this.prodParam.enter(PARAM);
          node.body = this.tsParseModuleBlock();
          this.prodParam.exit();
          this.scope.exit();
        } else {
          this.semicolon();
        }
        return this.finishNode(node, 'TSModuleDeclaration');
      }
      tsParseImportEqualsDeclaration(node, isExport) {
        node.isExport = isExport || false;
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, BIND_FLAGS_TS_IMPORT);
        this.expect(29);
        const moduleReference = this.tsParseModuleReference();
        if (
          node.importKind === 'type' &&
          moduleReference.type !== 'TSExternalModuleReference'
        ) {
          this.raise(TSErrors.ImportAliasHasImportType, {at: moduleReference});
        }
        node.moduleReference = moduleReference;
        this.semicolon();
        return this.finishNode(node, 'TSImportEqualsDeclaration');
      }
      tsIsExternalModuleReference() {
        return this.isContextual(117) && this.lookaheadCharCode() === 40;
      }
      tsParseModuleReference() {
        return this.tsIsExternalModuleReference()
          ? this.tsParseExternalModuleReference()
          : this.tsParseEntityName(false);
      }
      tsParseExternalModuleReference() {
        const node = this.startNode();
        this.expectContextual(117);
        this.expect(10);
        if (!this.match(131)) {
          this.unexpected();
        }
        node.expression = super.parseExprAtom();
        this.expect(11);
        return this.finishNode(node, 'TSExternalModuleReference');
      }
      tsLookAhead(f) {
        const state = this.state.clone();
        const res = f();
        this.state = state;
        return res;
      }
      tsTryParseAndCatch(f) {
        const result = this.tryParse(abort => f() || abort());
        if (result.aborted || !result.node) return undefined;
        if (result.error) this.state = result.failState;
        return result.node;
      }
      tsTryParse(f) {
        const state = this.state.clone();
        const result = f();
        if (result !== undefined && result !== false) {
          return result;
        } else {
          this.state = state;
          return undefined;
        }
      }
      tsTryParseDeclare(nany) {
        if (this.isLineTerminator()) {
          return;
        }
        let starttype = this.state.type;
        let kind;
        if (this.isContextual(99)) {
          starttype = 74;
          kind = 'let';
        }
        return this.tsInAmbientContext(() => {
          if (starttype === 68) {
            nany.declare = true;
            return super.parseFunctionStatement(nany, false, false);
          }
          if (starttype === 80) {
            nany.declare = true;
            return this.parseClass(nany, true, false);
          }
          if (starttype === 124) {
            return this.tsParseEnumDeclaration(nany, {declare: true});
          }
          if (starttype === 110) {
            return this.tsParseAmbientExternalModuleDeclaration(nany);
          }
          if (starttype === 75 || starttype === 74) {
            if (!this.match(75) || !this.isLookaheadContextual('enum')) {
              nany.declare = true;
              return this.parseVarStatement(
                nany,
                kind || this.state.value,
                true
              );
            }
            this.expect(75);
            return this.tsParseEnumDeclaration(nany, {
              const: true,
              declare: true,
            });
          }
          if (starttype === 127) {
            const result = this.tsParseInterfaceDeclaration(nany, {
              declare: true,
            });
            if (result) return result;
          }
          if (tokenIsIdentifier(starttype)) {
            return this.tsParseDeclaration(nany, this.state.value, true, null);
          }
        });
      }
      tsTryParseExportDeclaration() {
        return this.tsParseDeclaration(
          this.startNode(),
          this.state.value,
          true,
          null
        );
      }
      tsParseExpressionStatement(node, expr, decorators) {
        switch (expr.name) {
          case 'declare': {
            const declaration = this.tsTryParseDeclare(node);
            if (declaration) {
              declaration.declare = true;
              return declaration;
            }
            break;
          }
          case 'global':
            if (this.match(5)) {
              this.scope.enter(SCOPE_TS_MODULE);
              this.prodParam.enter(PARAM);
              const mod = node;
              mod.global = true;
              mod.id = expr;
              mod.body = this.tsParseModuleBlock();
              this.scope.exit();
              this.prodParam.exit();
              return this.finishNode(mod, 'TSModuleDeclaration');
            }
            break;
          default:
            return this.tsParseDeclaration(node, expr.name, false, decorators);
        }
      }
      tsParseDeclaration(node, value, next, decorators) {
        switch (value) {
          case 'abstract':
            if (
              this.tsCheckLineTerminator(next) &&
              (this.match(80) || tokenIsIdentifier(this.state.type))
            ) {
              return this.tsParseAbstractDeclaration(node, decorators);
            }
            break;
          case 'module':
            if (this.tsCheckLineTerminator(next)) {
              if (this.match(131)) {
                return this.tsParseAmbientExternalModuleDeclaration(node);
              } else if (tokenIsIdentifier(this.state.type)) {
                return this.tsParseModuleOrNamespaceDeclaration(node);
              }
            }
            break;
          case 'namespace':
            if (
              this.tsCheckLineTerminator(next) &&
              tokenIsIdentifier(this.state.type)
            ) {
              return this.tsParseModuleOrNamespaceDeclaration(node);
            }
            break;
          case 'type':
            if (
              this.tsCheckLineTerminator(next) &&
              tokenIsIdentifier(this.state.type)
            ) {
              return this.tsParseTypeAliasDeclaration(node);
            }
            break;
        }
      }
      tsCheckLineTerminator(next) {
        if (next) {
          if (this.hasFollowingLineBreak()) return false;
          this.next();
          return true;
        }
        return !this.isLineTerminator();
      }
      tsTryParseGenericAsyncArrowFunction(startLoc) {
        if (!this.match(47)) {
          return undefined;
        }
        const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        this.state.maybeInArrowParameters = true;
        const res = this.tsTryParseAndCatch(() => {
          const node = this.startNodeAt(startLoc);
          node.typeParameters = this.tsParseTypeParameters(
            this.tsParseConstModifier
          );
          super.parseFunctionParams(node);
          node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
          this.expect(19);
          return node;
        });
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        if (!res) {
          return undefined;
        }
        return super.parseArrowExpression(res, null, true);
      }
      tsParseTypeArgumentsInExpression() {
        if (this.reScan_lt() !== 47) {
          return undefined;
        }
        return this.tsParseTypeArguments();
      }
      tsParseTypeArguments() {
        const node = this.startNode();
        node.params = this.tsInType(() =>
          this.tsInNoContext(() => {
            this.expect(47);
            return this.tsParseDelimitedList(
              'TypeParametersOrArguments',
              this.tsParseType.bind(this)
            );
          })
        );
        if (node.params.length === 0) {
          this.raise(TSErrors.EmptyTypeArguments, {at: node});
        }
        this.expect(48);
        return this.finishNode(node, 'TSTypeParameterInstantiation');
      }
      tsIsDeclarationStart() {
        return tokenIsTSDeclarationStart(this.state.type);
      }
      isExportDefaultSpecifier() {
        if (this.tsIsDeclarationStart()) return false;
        return super.isExportDefaultSpecifier();
      }
      parseAssignableListItem(flags, decorators) {
        const startLoc = this.state.startLoc;
        const modified = {};
        this.tsParseModifiers(
          {
            allowedModifiers: [
              'public',
              'private',
              'protected',
              'override',
              'readonly',
            ],
          },
          modified
        );
        const accessibility = modified.accessibility;
        const override = modified.override;
        const readonly = modified.readonly;
        if (!(flags & 4) && (accessibility || readonly || override)) {
          this.raise(TSErrors.UnexpectedParameterModifier, {at: startLoc});
        }
        const left = this.parseMaybeDefault();
        this.parseAssignableListItemTypes(left, flags);
        const elt = this.parseMaybeDefault(left.loc.start, left);
        if (accessibility || readonly || override) {
          const pp = this.startNodeAt(startLoc);
          if (decorators.length) {
            pp.decorators = decorators;
          }
          if (accessibility) pp.accessibility = accessibility;
          if (readonly) pp.readonly = readonly;
          if (override) pp.override = override;
          if (elt.type !== 'Identifier' && elt.type !== 'AssignmentPattern') {
            this.raise(TSErrors.UnsupportedParameterPropertyKind, {at: pp});
          }
          pp.parameter = elt;
          return this.finishNode(pp, 'TSParameterProperty');
        }
        if (decorators.length) {
          left.decorators = decorators;
        }
        return elt;
      }
      isSimpleParameter(node) {
        return (
          (node.type === 'TSParameterProperty' &&
            super.isSimpleParameter(node.parameter)) ||
          super.isSimpleParameter(node)
        );
      }
      tsDisallowOptionalPattern(node) {
        for (const param of node.params) {
          if (
            param.type !== 'Identifier' &&
            param.optional &&
            !this.state.isAmbientContext
          ) {
            this.raise(TSErrors.PatternIsOptional, {at: param});
          }
        }
      }
      setArrowFunctionParameters(node, params, trailingCommaLoc) {
        super.setArrowFunctionParameters(node, params, trailingCommaLoc);
        this.tsDisallowOptionalPattern(node);
      }
      parseFunctionBodyAndFinish(node, type, isMethod = false) {
        if (this.match(14)) {
          node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
        }
        const bodilessType =
          type === 'FunctionDeclaration'
            ? 'TSDeclareFunction'
            : type === 'ClassMethod' || type === 'ClassPrivateMethod'
              ? 'TSDeclareMethod'
              : undefined;
        if (bodilessType && !this.match(5) && this.isLineTerminator()) {
          return this.finishNode(node, bodilessType);
        }
        if (
          bodilessType === 'TSDeclareFunction' &&
          this.state.isAmbientContext
        ) {
          this.raise(TSErrors.DeclareFunctionHasImplementation, {at: node});
          if (node.declare) {
            return super.parseFunctionBodyAndFinish(
              node,
              bodilessType,
              isMethod
            );
          }
        }
        this.tsDisallowOptionalPattern(node);
        return super.parseFunctionBodyAndFinish(node, type, isMethod);
      }
      registerFunctionStatementId(node) {
        if (!node.body && node.id) {
          this.checkIdentifier(node.id, BIND_TS_AMBIENT);
        } else {
          super.registerFunctionStatementId(node);
        }
      }
      tsCheckForInvalidTypeCasts(items) {
        items.forEach(node => {
          if ((node == null ? void 0 : node.type) === 'TSTypeCastExpression') {
            this.raise(TSErrors.UnexpectedTypeAnnotation, {
              at: node.typeAnnotation,
            });
          }
        });
      }
      toReferencedList(exprList, isInParens) {
        this.tsCheckForInvalidTypeCasts(exprList);
        return exprList;
      }
      parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        const node = super.parseArrayLike(
          close,
          canBePattern,
          isTuple,
          refExpressionErrors
        );
        if (node.type === 'ArrayExpression') {
          this.tsCheckForInvalidTypeCasts(node.elements);
        }
        return node;
      }
      parseSubscript(base, startLoc, noCalls, state) {
        if (!this.hasPrecedingLineBreak() && this.match(35)) {
          this.state.canStartJSXElement = false;
          this.next();
          const nonNullExpression = this.startNodeAt(startLoc);
          nonNullExpression.expression = base;
          return this.finishNode(nonNullExpression, 'TSNonNullExpression');
        }
        let isOptionalCall = false;
        if (this.match(18) && this.lookaheadCharCode() === 60) {
          if (noCalls) {
            state.stop = true;
            return base;
          }
          state.optionalChainMember = isOptionalCall = true;
          this.next();
        }
        if (this.match(47) || this.match(51)) {
          let missingParenErrorLoc;
          const result = this.tsTryParseAndCatch(() => {
            if (!noCalls && this.atPossibleAsyncArrow(base)) {
              const asyncArrowFn =
                this.tsTryParseGenericAsyncArrowFunction(startLoc);
              if (asyncArrowFn) {
                return asyncArrowFn;
              }
            }
            const typeArguments = this.tsParseTypeArgumentsInExpression();
            if (!typeArguments) return;
            if (isOptionalCall && !this.match(10)) {
              missingParenErrorLoc = this.state.curPosition();
              return;
            }
            if (tokenIsTemplate(this.state.type)) {
              const result = super.parseTaggedTemplateExpression(
                base,
                startLoc,
                state
              );
              result.typeParameters = typeArguments;
              return result;
            }
            if (!noCalls && this.eat(10)) {
              const node = this.startNodeAt(startLoc);
              node.callee = base;
              node.arguments = this.parseCallExpressionArguments(11, false);
              this.tsCheckForInvalidTypeCasts(node.arguments);
              node.typeParameters = typeArguments;
              if (state.optionalChainMember) {
                node.optional = isOptionalCall;
              }
              return this.finishCallExpression(node, state.optionalChainMember);
            }
            const tokenType = this.state.type;
            if (
              tokenType === 48 ||
              tokenType === 52 ||
              (tokenType !== 10 &&
                tokenCanStartExpression(tokenType) &&
                !this.hasPrecedingLineBreak())
            ) {
              return;
            }
            const node = this.startNodeAt(startLoc);
            node.expression = base;
            node.typeParameters = typeArguments;
            return this.finishNode(node, 'TSInstantiationExpression');
          });
          if (missingParenErrorLoc) {
            this.unexpected(missingParenErrorLoc, 10);
          }
          if (result) {
            if (
              result.type === 'TSInstantiationExpression' &&
              (this.match(16) ||
                (this.match(18) && this.lookaheadCharCode() !== 40))
            ) {
              this.raise(
                TSErrors.InvalidPropertyAccessAfterInstantiationExpression,
                {at: this.state.startLoc}
              );
            }
            return result;
          }
        }
        return super.parseSubscript(base, startLoc, noCalls, state);
      }
      parseNewCallee(node) {
        var _callee$extra;
        super.parseNewCallee(node);
        const {callee: callee} = node;
        if (
          callee.type === 'TSInstantiationExpression' &&
          !(
            (_callee$extra = callee.extra) != null &&
            _callee$extra.parenthesized
          )
        ) {
          node.typeParameters = callee.typeParameters;
          node.callee = callee.expression;
        }
      }
      parseExprOp(left, leftStartLoc, minPrec) {
        let isSatisfies;
        if (
          tokenOperatorPrecedence(58) > minPrec &&
          !this.hasPrecedingLineBreak() &&
          (this.isContextual(93) || (isSatisfies = this.isContextual(118)))
        ) {
          const node = this.startNodeAt(leftStartLoc);
          node.expression = left;
          node.typeAnnotation = this.tsInType(() => {
            this.next();
            if (this.match(75)) {
              if (isSatisfies) {
                this.raise(Errors.UnexpectedKeyword, {
                  at: this.state.startLoc,
                  keyword: 'const',
                });
              }
              return this.tsParseTypeReference();
            }
            return this.tsParseType();
          });
          this.finishNode(
            node,
            isSatisfies ? 'TSSatisfiesExpression' : 'TSAsExpression'
          );
          this.reScan_lt_gt();
          return this.parseExprOp(node, leftStartLoc, minPrec);
        }
        return super.parseExprOp(left, leftStartLoc, minPrec);
      }
      checkReservedWord(word, startLoc, checkKeywords, isBinding) {
        if (!this.state.isAmbientContext) {
          super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
        }
      }
      checkImportReflection(node) {
        super.checkImportReflection(node);
        if (node.module && node.importKind !== 'value') {
          this.raise(TSErrors.ImportReflectionHasImportType, {
            at: node.specifiers[0].loc.start,
          });
        }
      }
      checkDuplicateExports() {}
      parseImport(node) {
        node.importKind = 'value';
        if (
          tokenIsIdentifier(this.state.type) ||
          this.match(55) ||
          this.match(5)
        ) {
          let ahead = this.lookahead();
          if (
            this.isContextual(128) &&
            ahead.type !== 12 &&
            ahead.type !== 97 &&
            ahead.type !== 29
          ) {
            node.importKind = 'type';
            this.next();
            ahead = this.lookahead();
          }
          if (tokenIsIdentifier(this.state.type) && ahead.type === 29) {
            return this.tsParseImportEqualsDeclaration(node);
          }
        }
        const importNode = super.parseImport(node);
        if (
          importNode.importKind === 'type' &&
          importNode.specifiers.length > 1 &&
          importNode.specifiers[0].type === 'ImportDefaultSpecifier'
        ) {
          this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, {
            at: importNode,
          });
        }
        return importNode;
      }
      parseExport(node, decorators) {
        if (this.match(83)) {
          this.next();
          if (this.isContextual(128) && this.lookaheadCharCode() !== 61) {
            node.importKind = 'type';
            this.next();
          } else {
            node.importKind = 'value';
          }
          return this.tsParseImportEqualsDeclaration(node, true);
        } else if (this.eat(29)) {
          const assign = node;
          assign.expression = super.parseExpression();
          this.semicolon();
          return this.finishNode(assign, 'TSExportAssignment');
        } else if (this.eatContextual(93)) {
          const decl = node;
          this.expectContextual(126);
          decl.id = this.parseIdentifier();
          this.semicolon();
          return this.finishNode(decl, 'TSNamespaceExportDeclaration');
        } else {
          node.exportKind = 'value';
          if (this.isContextual(128)) {
            const ch = this.lookaheadCharCode();
            if (ch === 123 || ch === 42) {
              this.next();
              node.exportKind = 'type';
            }
          }
          return super.parseExport(node, decorators);
        }
      }
      isAbstractClass() {
        return this.isContextual(122) && this.lookahead().type === 80;
      }
      parseExportDefaultExpression() {
        if (this.isAbstractClass()) {
          const cls = this.startNode();
          this.next();
          cls.abstract = true;
          return this.parseClass(cls, true, true);
        }
        if (this.match(127)) {
          const result = this.tsParseInterfaceDeclaration(this.startNode());
          if (result) return result;
        }
        return super.parseExportDefaultExpression();
      }
      parseVarStatement(node, kind, allowMissingInitializer = false) {
        const {isAmbientContext: isAmbientContext} = this.state;
        const declaration = super.parseVarStatement(
          node,
          kind,
          allowMissingInitializer || isAmbientContext
        );
        if (!isAmbientContext) return declaration;
        for (const {id: id, init: init} of declaration.declarations) {
          if (!init) continue;
          if (kind !== 'const' || !!id.typeAnnotation) {
            this.raise(TSErrors.InitializerNotAllowedInAmbientContext, {
              at: init,
            });
          } else if (
            !isValidAmbientConstInitializer(init, this.hasPlugin('estree'))
          ) {
            this.raise(
              TSErrors.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference,
              {at: init}
            );
          }
        }
        return declaration;
      }
      parseStatementContent(flags, decorators) {
        if (this.match(75) && this.isLookaheadContextual('enum')) {
          const node = this.startNode();
          this.expect(75);
          return this.tsParseEnumDeclaration(node, {const: true});
        }
        if (this.isContextual(124)) {
          return this.tsParseEnumDeclaration(this.startNode());
        }
        if (this.isContextual(127)) {
          const result = this.tsParseInterfaceDeclaration(this.startNode());
          if (result) return result;
        }
        return super.parseStatementContent(flags, decorators);
      }
      parseAccessModifier() {
        return this.tsParseModifier(['public', 'protected', 'private']);
      }
      tsHasSomeModifiers(member, modifiers) {
        return modifiers.some(modifier => {
          if (tsIsAccessModifier(modifier)) {
            return member.accessibility === modifier;
          }
          return !!member[modifier];
        });
      }
      tsIsStartOfStaticBlocks() {
        return this.isContextual(104) && this.lookaheadCharCode() === 123;
      }
      parseClassMember(classBody, member, state) {
        const modifiers = [
          'declare',
          'private',
          'public',
          'protected',
          'override',
          'abstract',
          'readonly',
          'static',
        ];
        this.tsParseModifiers(
          {
            allowedModifiers: modifiers,
            disallowedModifiers: ['in', 'out'],
            stopOnStartOfClassStaticBlock: true,
            errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
          },
          member
        );
        const callParseClassMemberWithIsStatic = () => {
          if (this.tsIsStartOfStaticBlocks()) {
            this.next();
            this.next();
            if (this.tsHasSomeModifiers(member, modifiers)) {
              this.raise(TSErrors.StaticBlockCannotHaveModifier, {
                at: this.state.curPosition(),
              });
            }
            super.parseClassStaticBlock(classBody, member);
          } else {
            this.parseClassMemberWithIsStatic(
              classBody,
              member,
              state,
              !!member.static
            );
          }
        };
        if (member.declare) {
          this.tsInAmbientContext(callParseClassMemberWithIsStatic);
        } else {
          callParseClassMemberWithIsStatic();
        }
      }
      parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
        const idx = this.tsTryParseIndexSignature(member);
        if (idx) {
          classBody.body.push(idx);
          if (member.abstract) {
            this.raise(TSErrors.IndexSignatureHasAbstract, {at: member});
          }
          if (member.accessibility) {
            this.raise(TSErrors.IndexSignatureHasAccessibility, {
              at: member,
              modifier: member.accessibility,
            });
          }
          if (member.declare) {
            this.raise(TSErrors.IndexSignatureHasDeclare, {at: member});
          }
          if (member.override) {
            this.raise(TSErrors.IndexSignatureHasOverride, {at: member});
          }
          return;
        }
        if (!this.state.inAbstractClass && member.abstract) {
          this.raise(TSErrors.NonAbstractClassHasAbstractMethod, {at: member});
        }
        if (member.override) {
          if (!state.hadSuperClass) {
            this.raise(TSErrors.OverrideNotInSubClass, {at: member});
          }
        }
        super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
      }
      parsePostMemberNameModifiers(methodOrProp) {
        const optional = this.eat(17);
        if (optional) methodOrProp.optional = true;
        if (methodOrProp.readonly && this.match(10)) {
          this.raise(TSErrors.ClassMethodHasReadonly, {at: methodOrProp});
        }
        if (methodOrProp.declare && this.match(10)) {
          this.raise(TSErrors.ClassMethodHasDeclare, {at: methodOrProp});
        }
      }
      parseExpressionStatement(node, expr, decorators) {
        const decl =
          expr.type === 'Identifier'
            ? this.tsParseExpressionStatement(node, expr, decorators)
            : undefined;
        return decl || super.parseExpressionStatement(node, expr, decorators);
      }
      shouldParseExportDeclaration() {
        if (this.tsIsDeclarationStart()) return true;
        return super.shouldParseExportDeclaration();
      }
      parseConditional(expr, startLoc, refExpressionErrors) {
        if (!this.state.maybeInArrowParameters || !this.match(17)) {
          return super.parseConditional(expr, startLoc, refExpressionErrors);
        }
        const result = this.tryParse(() =>
          super.parseConditional(expr, startLoc)
        );
        if (!result.node) {
          if (result.error) {
            super.setOptionalParametersError(refExpressionErrors, result.error);
          }
          return expr;
        }
        if (result.error) this.state = result.failState;
        return result.node;
      }
      parseParenItem(node, startLoc) {
        node = super.parseParenItem(node, startLoc);
        if (this.eat(17)) {
          node.optional = true;
          this.resetEndLocation(node);
        }
        if (this.match(14)) {
          const typeCastNode = this.startNodeAt(startLoc);
          typeCastNode.expression = node;
          typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
          return this.finishNode(typeCastNode, 'TSTypeCastExpression');
        }
        return node;
      }
      parseExportDeclaration(node) {
        if (!this.state.isAmbientContext && this.isContextual(123)) {
          return this.tsInAmbientContext(() =>
            this.parseExportDeclaration(node)
          );
        }
        const startLoc = this.state.startLoc;
        const isDeclare = this.eatContextual(123);
        if (
          isDeclare &&
          (this.isContextual(123) || !this.shouldParseExportDeclaration())
        ) {
          throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, {
            at: this.state.startLoc,
          });
        }
        const isIdentifier = tokenIsIdentifier(this.state.type);
        const declaration =
          (isIdentifier && this.tsTryParseExportDeclaration()) ||
          super.parseExportDeclaration(node);
        if (!declaration) return null;
        if (
          declaration.type === 'TSInterfaceDeclaration' ||
          declaration.type === 'TSTypeAliasDeclaration' ||
          isDeclare
        ) {
          node.exportKind = 'type';
        }
        if (isDeclare) {
          this.resetStartLocation(declaration, startLoc);
          declaration.declare = true;
        }
        return declaration;
      }
      parseClassId(node, isStatement, optionalId, bindingType) {
        if ((!isStatement || optionalId) && this.isContextual(111)) {
          return;
        }
        super.parseClassId(
          node,
          isStatement,
          optionalId,
          node.declare ? BIND_TS_AMBIENT : BIND_CLASS
        );
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutConstModifiers
        );
        if (typeParameters) node.typeParameters = typeParameters;
      }
      parseClassPropertyAnnotation(node) {
        if (!node.optional) {
          if (this.eat(35)) {
            node.definite = true;
          } else if (this.eat(17)) {
            node.optional = true;
          }
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) node.typeAnnotation = type;
      }
      parseClassProperty(node) {
        this.parseClassPropertyAnnotation(node);
        if (
          this.state.isAmbientContext &&
          !(node.readonly && !node.typeAnnotation) &&
          this.match(29)
        ) {
          this.raise(TSErrors.DeclareClassFieldHasInitializer, {
            at: this.state.startLoc,
          });
        }
        if (node.abstract && this.match(29)) {
          const {key: key} = node;
          this.raise(TSErrors.AbstractPropertyHasInitializer, {
            at: this.state.startLoc,
            propertyName:
              key.type === 'Identifier' && !node.computed
                ? key.name
                : `[${this.input.slice(key.start, key.end)}]`,
          });
        }
        return super.parseClassProperty(node);
      }
      parseClassPrivateProperty(node) {
        if (node.abstract) {
          this.raise(TSErrors.PrivateElementHasAbstract, {at: node});
        }
        if (node.accessibility) {
          this.raise(TSErrors.PrivateElementHasAccessibility, {
            at: node,
            modifier: node.accessibility,
          });
        }
        this.parseClassPropertyAnnotation(node);
        return super.parseClassPrivateProperty(node);
      }
      parseClassAccessorProperty(node) {
        this.parseClassPropertyAnnotation(node);
        if (node.optional) {
          this.raise(TSErrors.AccessorCannotBeOptional, {at: node});
        }
        return super.parseClassAccessorProperty(node);
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters && isConstructor) {
          this.raise(TSErrors.ConstructorHasTypeParameters, {
            at: typeParameters,
          });
        }
        const {declare: declare = false, kind: kind} = method;
        if (declare && (kind === 'get' || kind === 'set')) {
          this.raise(TSErrors.DeclareAccessor, {at: method, kind: kind});
        }
        if (typeParameters) method.typeParameters = typeParameters;
        super.pushClassMethod(
          classBody,
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper
        );
      }
      pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) method.typeParameters = typeParameters;
        super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
      }
      declareClassPrivateMethodInScope(node, kind) {
        if (node.type === 'TSDeclareMethod') return;
        if (node.type === 'MethodDefinition' && !node.value.body) return;
        super.declareClassPrivateMethodInScope(node, kind);
      }
      parseClassSuper(node) {
        super.parseClassSuper(node);
        if (node.superClass && (this.match(47) || this.match(51))) {
          node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
        }
        if (this.eatContextual(111)) {
          node.implements = this.tsParseHeritageClause('implements');
        }
      }
      parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      ) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) prop.typeParameters = typeParameters;
        return super.parseObjPropValue(
          prop,
          startLoc,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor,
          refExpressionErrors
        );
      }
      parseFunctionParams(node, isConstructor) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) node.typeParameters = typeParameters;
        super.parseFunctionParams(node, isConstructor);
      }
      parseVarId(decl, kind) {
        super.parseVarId(decl, kind);
        if (
          decl.id.type === 'Identifier' &&
          !this.hasPrecedingLineBreak() &&
          this.eat(35)
        ) {
          decl.definite = true;
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) {
          decl.id.typeAnnotation = type;
          this.resetEndLocation(decl.id);
        }
      }
      parseAsyncArrowFromCallExpression(node, call) {
        if (this.match(14)) {
          node.returnType = this.tsParseTypeAnnotation();
        }
        return super.parseAsyncArrowFromCallExpression(node, call);
      }
      parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var _jsx, _jsx2, _typeCast, _jsx3, _typeCast2, _jsx4, _typeCast3;
        let state;
        let jsx;
        let typeCast;
        if (this.hasPlugin('jsx') && (this.match(140) || this.match(47))) {
          state = this.state.clone();
          jsx = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!jsx.error) return jsx.node;
          const {context: context} = this.state;
          const currentContext = context[context.length - 1];
          if (
            currentContext === types.j_oTag ||
            currentContext === types.j_expr
          ) {
            context.pop();
          }
        }
        if (!((_jsx = jsx) != null && _jsx.error) && !this.match(47)) {
          return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
        }
        if (!state || state === this.state) state = this.state.clone();
        let typeParameters;
        const arrow = this.tryParse(abort => {
          var _expr$extra, _typeParameters;
          typeParameters = this.tsParseTypeParameters(
            this.tsParseConstModifier
          );
          const expr = super.parseMaybeAssign(
            refExpressionErrors,
            afterLeftParse
          );
          if (
            expr.type !== 'ArrowFunctionExpression' ||
            ((_expr$extra = expr.extra) != null && _expr$extra.parenthesized)
          ) {
            abort();
          }
          if (
            ((_typeParameters = typeParameters) == null
              ? void 0
              : _typeParameters.params.length) !== 0
          ) {
            this.resetStartLocationFromNode(expr, typeParameters);
          }
          expr.typeParameters = typeParameters;
          return expr;
        }, state);
        if (!arrow.error && !arrow.aborted) {
          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
          return arrow.node;
        }
        if (!jsx) {
          assert(!this.hasPlugin('jsx'));
          typeCast = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!typeCast.error) return typeCast.node;
        }
        if ((_jsx2 = jsx) != null && _jsx2.node) {
          this.state = jsx.failState;
          return jsx.node;
        }
        if (arrow.node) {
          this.state = arrow.failState;
          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
          return arrow.node;
        }
        if ((_typeCast = typeCast) != null && _typeCast.node) {
          this.state = typeCast.failState;
          return typeCast.node;
        }
        if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
        if (arrow.thrown) throw arrow.error;
        if ((_typeCast2 = typeCast) != null && _typeCast2.thrown)
          throw typeCast.error;
        throw (
          ((_jsx4 = jsx) == null ? void 0 : _jsx4.error) ||
          arrow.error ||
          ((_typeCast3 = typeCast) == null ? void 0 : _typeCast3.error)
        );
      }
      reportReservedArrowTypeParam(node) {
        var _node$extra;
        if (
          node.params.length === 1 &&
          !node.params[0].constraint &&
          !((_node$extra = node.extra) != null && _node$extra.trailingComma) &&
          this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')
        ) {
          this.raise(TSErrors.ReservedArrowTypeParam, {at: node});
        }
      }
      parseMaybeUnary(refExpressionErrors, sawUnary) {
        if (!this.hasPlugin('jsx') && this.match(47)) {
          return this.tsParseTypeAssertion();
        } else {
          return super.parseMaybeUnary(refExpressionErrors, sawUnary);
        }
      }
      parseArrow(node) {
        if (this.match(14)) {
          const result = this.tryParse(abort => {
            const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
            if (this.canInsertSemicolon() || !this.match(19)) abort();
            return returnType;
          });
          if (result.aborted) return;
          if (!result.thrown) {
            if (result.error) this.state = result.failState;
            node.returnType = result.node;
          }
        }
        return super.parseArrow(node);
      }
      parseAssignableListItemTypes(param, flags) {
        if (!(flags & 2)) return param;
        if (this.eat(17)) {
          param.optional = true;
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) param.typeAnnotation = type;
        this.resetEndLocation(param);
        return param;
      }
      isAssignable(node, isBinding) {
        switch (node.type) {
          case 'TSTypeCastExpression':
            return this.isAssignable(node.expression, isBinding);
          case 'TSParameterProperty':
            return true;
          default:
            return super.isAssignable(node, isBinding);
        }
      }
      toAssignable(node, isLHS = false) {
        switch (node.type) {
          case 'ParenthesizedExpression':
            this.toAssignableParenthesizedExpression(node, isLHS);
            break;
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSNonNullExpression':
          case 'TSTypeAssertion':
            if (isLHS) {
              this.expressionScope.recordArrowParameterBindingError(
                TSErrors.UnexpectedTypeCastInParameter,
                {at: node}
              );
            } else {
              this.raise(TSErrors.UnexpectedTypeCastInParameter, {at: node});
            }
            this.toAssignable(node.expression, isLHS);
            break;
          case 'AssignmentExpression':
            if (!isLHS && node.left.type === 'TSTypeCastExpression') {
              node.left = this.typeCastToParameter(node.left);
            }
          default:
            super.toAssignable(node, isLHS);
        }
      }
      toAssignableParenthesizedExpression(node, isLHS) {
        switch (node.expression.type) {
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSNonNullExpression':
          case 'TSTypeAssertion':
          case 'ParenthesizedExpression':
            this.toAssignable(node.expression, isLHS);
            break;
          default:
            super.toAssignable(node, isLHS);
        }
      }
      checkToRestConversion(node, allowPattern) {
        switch (node.type) {
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSTypeAssertion':
          case 'TSNonNullExpression':
            this.checkToRestConversion(node.expression, false);
            break;
          default:
            super.checkToRestConversion(node, allowPattern);
        }
      }
      isValidLVal(type, isUnparenthesizedInAssign, binding) {
        return (
          getOwn(
            {
              TSTypeCastExpression: true,
              TSParameterProperty: 'parameter',
              TSNonNullExpression: 'expression',
              TSAsExpression: (binding !== BIND_NONE ||
                !isUnparenthesizedInAssign) && ['expression', true],
              TSSatisfiesExpression: (binding !== BIND_NONE ||
                !isUnparenthesizedInAssign) && ['expression', true],
              TSTypeAssertion: (binding !== BIND_NONE ||
                !isUnparenthesizedInAssign) && ['expression', true],
            },
            type
          ) || super.isValidLVal(type, isUnparenthesizedInAssign, binding)
        );
      }
      parseBindingAtom() {
        switch (this.state.type) {
          case 78:
            return this.parseIdentifier(true);
          default:
            return super.parseBindingAtom();
        }
      }
      parseMaybeDecoratorArguments(expr) {
        if (this.match(47) || this.match(51)) {
          const typeArguments = this.tsParseTypeArgumentsInExpression();
          if (this.match(10)) {
            const call = super.parseMaybeDecoratorArguments(expr);
            call.typeParameters = typeArguments;
            return call;
          }
          this.unexpected(null, 10);
        }
        return super.parseMaybeDecoratorArguments(expr);
      }
      checkCommaAfterRest(close) {
        if (
          this.state.isAmbientContext &&
          this.match(12) &&
          this.lookaheadCharCode() === close
        ) {
          this.next();
          return false;
        } else {
          return super.checkCommaAfterRest(close);
        }
      }
      isClassMethod() {
        return this.match(47) || super.isClassMethod();
      }
      isClassProperty() {
        return this.match(35) || this.match(14) || super.isClassProperty();
      }
      parseMaybeDefault(startLoc, left) {
        const node = super.parseMaybeDefault(startLoc, left);
        if (
          node.type === 'AssignmentPattern' &&
          node.typeAnnotation &&
          node.right.start < node.typeAnnotation.start
        ) {
          this.raise(TSErrors.TypeAnnotationAfterAssign, {
            at: node.typeAnnotation,
          });
        }
        return node;
      }
      getTokenFromCode(code) {
        if (this.state.inType) {
          if (code === 62) {
            this.finishOp(48, 1);
            return;
          }
          if (code === 60) {
            this.finishOp(47, 1);
            return;
          }
        }
        super.getTokenFromCode(code);
      }
      reScan_lt_gt() {
        const {type: type} = this.state;
        if (type === 47) {
          this.state.pos -= 1;
          this.readToken_lt();
        } else if (type === 48) {
          this.state.pos -= 1;
          this.readToken_gt();
        }
      }
      reScan_lt() {
        const {type: type} = this.state;
        if (type === 51) {
          this.state.pos -= 2;
          this.finishOp(47, 1);
          return 47;
        }
        return type;
      }
      toAssignableList(exprList, trailingCommaLoc, isLHS) {
        for (let i = 0; i < exprList.length; i++) {
          const expr = exprList[i];
          if ((expr == null ? void 0 : expr.type) === 'TSTypeCastExpression') {
            exprList[i] = this.typeCastToParameter(expr);
          }
        }
        super.toAssignableList(exprList, trailingCommaLoc, isLHS);
      }
      typeCastToParameter(node) {
        node.expression.typeAnnotation = node.typeAnnotation;
        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
        return node.expression;
      }
      shouldParseArrow(params) {
        if (this.match(14)) {
          return params.every(expr => this.isAssignable(expr, true));
        }
        return super.shouldParseArrow(params);
      }
      shouldParseAsyncArrow() {
        return this.match(14) || super.shouldParseAsyncArrow();
      }
      canHaveLeadingDecorator() {
        return super.canHaveLeadingDecorator() || this.isAbstractClass();
      }
      jsxParseOpeningElementAfterName(node) {
        if (this.match(47) || this.match(51)) {
          const typeArguments = this.tsTryParseAndCatch(() =>
            this.tsParseTypeArgumentsInExpression()
          );
          if (typeArguments) node.typeParameters = typeArguments;
        }
        return super.jsxParseOpeningElementAfterName(node);
      }
      getGetterSetterExpectedParamCount(method) {
        const baseCount = super.getGetterSetterExpectedParamCount(method);
        const params = this.getObjectOrClassMethodParams(method);
        const firstParam = params[0];
        const hasContextParam = firstParam && this.isThisParam(firstParam);
        return hasContextParam ? baseCount + 1 : baseCount;
      }
      parseCatchClauseParam() {
        const param = super.parseCatchClauseParam();
        const type = this.tsTryParseTypeAnnotation();
        if (type) {
          param.typeAnnotation = type;
          this.resetEndLocation(param);
        }
        return param;
      }
      tsInAmbientContext(cb) {
        const oldIsAmbientContext = this.state.isAmbientContext;
        this.state.isAmbientContext = true;
        try {
          return cb();
        } finally {
          this.state.isAmbientContext = oldIsAmbientContext;
        }
      }
      parseClass(node, isStatement, optionalId) {
        const oldInAbstractClass = this.state.inAbstractClass;
        this.state.inAbstractClass = !!node.abstract;
        try {
          return super.parseClass(node, isStatement, optionalId);
        } finally {
          this.state.inAbstractClass = oldInAbstractClass;
        }
      }
      tsParseAbstractDeclaration(node, decorators) {
        if (this.match(80)) {
          node.abstract = true;
          return this.maybeTakeDecorators(
            decorators,
            this.parseClass(node, true, false)
          );
        } else if (this.isContextual(127)) {
          if (!this.hasFollowingLineBreak()) {
            node.abstract = true;
            this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, {
              at: node,
            });
            return this.tsParseInterfaceDeclaration(node);
          }
        } else {
          this.unexpected(null, 80);
        }
      }
      parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope
      ) {
        const method = super.parseMethod(
          node,
          isGenerator,
          isAsync,
          isConstructor,
          allowDirectSuper,
          type,
          inClassScope
        );
        if (method.abstract) {
          const hasBody = this.hasPlugin('estree')
            ? !!method.value.body
            : !!method.body;
          if (hasBody) {
            const {key: key} = method;
            this.raise(TSErrors.AbstractMethodHasImplementation, {
              at: method,
              methodName:
                key.type === 'Identifier' && !method.computed
                  ? key.name
                  : `[${this.input.slice(key.start, key.end)}]`,
            });
          }
        }
        return method;
      }
      tsParseTypeParameterName() {
        const typeName = this.parseIdentifier();
        return typeName.name;
      }
      shouldParseAsAmbientContext() {
        return !!this.getPluginOption('typescript', 'dts');
      }
      parse() {
        if (this.shouldParseAsAmbientContext()) {
          this.state.isAmbientContext = true;
        }
        return super.parse();
      }
      getExpression() {
        if (this.shouldParseAsAmbientContext()) {
          this.state.isAmbientContext = true;
        }
        return super.getExpression();
      }
      parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
        if (!isString && isMaybeTypeOnly) {
          this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
          return this.finishNode(node, 'ExportSpecifier');
        }
        node.exportKind = 'value';
        return super.parseExportSpecifier(
          node,
          isString,
          isInTypeExport,
          isMaybeTypeOnly
        );
      }
      parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        bindingType
      ) {
        if (!importedIsString && isMaybeTypeOnly) {
          this.parseTypeOnlyImportExportSpecifier(
            specifier,
            true,
            isInTypeOnlyImport
          );
          return this.finishNode(specifier, 'ImportSpecifier');
        }
        specifier.importKind = 'value';
        return super.parseImportSpecifier(
          specifier,
          importedIsString,
          isInTypeOnlyImport,
          isMaybeTypeOnly,
          isInTypeOnlyImport ? BIND_TS_TYPE_IMPORT : BIND_FLAGS_TS_IMPORT
        );
      }
      parseTypeOnlyImportExportSpecifier(
        node,
        isImport,
        isInTypeOnlyImportExport
      ) {
        const leftOfAsKey = isImport ? 'imported' : 'local';
        const rightOfAsKey = isImport ? 'local' : 'exported';
        let leftOfAs = node[leftOfAsKey];
        let rightOfAs;
        let hasTypeSpecifier = false;
        let canParseAsKeyword = true;
        const loc = leftOfAs.loc.start;
        if (this.isContextual(93)) {
          const firstAs = this.parseIdentifier();
          if (this.isContextual(93)) {
            const secondAs = this.parseIdentifier();
            if (tokenIsKeywordOrIdentifier(this.state.type)) {
              hasTypeSpecifier = true;
              leftOfAs = firstAs;
              rightOfAs = isImport
                ? this.parseIdentifier()
                : this.parseModuleExportName();
              canParseAsKeyword = false;
            } else {
              rightOfAs = secondAs;
              canParseAsKeyword = false;
            }
          } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
            canParseAsKeyword = false;
            rightOfAs = isImport
              ? this.parseIdentifier()
              : this.parseModuleExportName();
          } else {
            hasTypeSpecifier = true;
            leftOfAs = firstAs;
          }
        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
          hasTypeSpecifier = true;
          if (isImport) {
            leftOfAs = this.parseIdentifier(true);
            if (!this.isContextual(93)) {
              this.checkReservedWord(
                leftOfAs.name,
                leftOfAs.loc.start,
                true,
                true
              );
            }
          } else {
            leftOfAs = this.parseModuleExportName();
          }
        }
        if (hasTypeSpecifier && isInTypeOnlyImportExport) {
          this.raise(
            isImport
              ? TSErrors.TypeModifierIsUsedInTypeImports
              : TSErrors.TypeModifierIsUsedInTypeExports,
            {at: loc}
          );
        }
        node[leftOfAsKey] = leftOfAs;
        node[rightOfAsKey] = rightOfAs;
        const kindKey = isImport ? 'importKind' : 'exportKind';
        node[kindKey] = hasTypeSpecifier ? 'type' : 'value';
        if (canParseAsKeyword && this.eatContextual(93)) {
          node[rightOfAsKey] = isImport
            ? this.parseIdentifier()
            : this.parseModuleExportName();
        }
        if (!node[rightOfAsKey]) {
          node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
        }
        if (isImport) {
          this.checkIdentifier(
            node[rightOfAsKey],
            hasTypeSpecifier ? BIND_TS_TYPE_IMPORT : BIND_FLAGS_TS_IMPORT
          );
        }
      }
    };
  function isPossiblyLiteralEnum(expression) {
    if (expression.type !== 'MemberExpression') return false;
    const {computed: computed, property: property} = expression;
    if (
      computed &&
      property.type !== 'StringLiteral' &&
      (property.type !== 'TemplateLiteral' || property.expressions.length > 0)
    ) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  function isValidAmbientConstInitializer(expression, estree) {
    var _expression$extra;
    const {type: type} = expression;
    if (
      (_expression$extra = expression.extra) != null &&
      _expression$extra.parenthesized
    ) {
      return false;
    }
    if (estree) {
      if (type === 'Literal') {
        const {value: value} = expression;
        if (typeof value === 'string' || typeof value === 'boolean') {
          return true;
        }
      }
    } else {
      if (type === 'StringLiteral' || type === 'BooleanLiteral') {
        return true;
      }
    }
    if (isNumber(expression, estree) || isNegativeNumber(expression, estree)) {
      return true;
    }
    if (type === 'TemplateLiteral' && expression.expressions.length === 0) {
      return true;
    }
    if (isPossiblyLiteralEnum(expression)) {
      return true;
    }
    return false;
  }
  function isNumber(expression, estree) {
    if (estree) {
      return (
        expression.type === 'Literal' &&
        (typeof expression.value === 'number' || 'bigint' in expression)
      );
    } else {
      return (
        expression.type === 'NumericLiteral' ||
        expression.type === 'BigIntLiteral'
      );
    }
  }
  function isNegativeNumber(expression, estree) {
    if (expression.type === 'UnaryExpression') {
      const {operator: operator, argument: argument} = expression;
      if (operator === '-' && isNumber(argument, estree)) {
        return true;
      }
    }
    return false;
  }
  function isUncomputedMemberExpressionChain(expression) {
    if (expression.type === 'Identifier') return true;
    if (expression.type !== 'MemberExpression') return false;
    if (expression.computed) return false;
    return isUncomputedMemberExpressionChain(expression.object);
  }
  const PlaceholderErrors = ParseErrorEnum`placeholders`({
    ClassNameIsRequired: 'A class name is required.',
    UnexpectedSpace: 'Unexpected space in placeholder.',
  });
  var placeholders = superClass =>
    class PlaceholdersParserMixin extends superClass {
      parsePlaceholder(expectedNode) {
        if (this.match(142)) {
          const node = this.startNode();
          this.next();
          this.assertNoSpace();
          node.name = super.parseIdentifier(true);
          this.assertNoSpace();
          this.expect(142);
          return this.finishPlaceholder(node, expectedNode);
        }
      }
      finishPlaceholder(node, expectedNode) {
        const isFinished = !!(node.expectedNode && node.type === 'Placeholder');
        node.expectedNode = expectedNode;
        return isFinished ? node : this.finishNode(node, 'Placeholder');
      }
      getTokenFromCode(code) {
        if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
          this.finishOp(142, 2);
        } else {
          super.getTokenFromCode(code);
        }
      }
      parseExprAtom(refExpressionErrors) {
        return (
          this.parsePlaceholder('Expression') ||
          super.parseExprAtom(refExpressionErrors)
        );
      }
      parseIdentifier(liberal) {
        return (
          this.parsePlaceholder('Identifier') || super.parseIdentifier(liberal)
        );
      }
      checkReservedWord(word, startLoc, checkKeywords, isBinding) {
        if (word !== undefined) {
          super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
        }
      }
      parseBindingAtom() {
        return this.parsePlaceholder('Pattern') || super.parseBindingAtom();
      }
      isValidLVal(type, isParenthesized, binding) {
        return (
          type === 'Placeholder' ||
          super.isValidLVal(type, isParenthesized, binding)
        );
      }
      toAssignable(node, isLHS) {
        if (
          node &&
          node.type === 'Placeholder' &&
          node.expectedNode === 'Expression'
        ) {
          node.expectedNode = 'Pattern';
        } else {
          super.toAssignable(node, isLHS);
        }
      }
      chStartsBindingIdentifier(ch, pos) {
        if (super.chStartsBindingIdentifier(ch, pos)) {
          return true;
        }
        const nextToken = this.lookahead();
        if (nextToken.type === 142) {
          return true;
        }
        return false;
      }
      verifyBreakContinue(node, isBreak) {
        if (node.label && node.label.type === 'Placeholder') return;
        super.verifyBreakContinue(node, isBreak);
      }
      parseExpressionStatement(node, expr) {
        if (
          expr.type !== 'Placeholder' ||
          (expr.extra && expr.extra.parenthesized)
        ) {
          return super.parseExpressionStatement(node, expr);
        }
        if (this.match(14)) {
          const stmt = node;
          stmt.label = this.finishPlaceholder(expr, 'Identifier');
          this.next();
          stmt.body = super.parseStatementOrSloppyAnnexBFunctionDeclaration();
          return this.finishNode(stmt, 'LabeledStatement');
        }
        this.semicolon();
        node.name = expr.name;
        return this.finishPlaceholder(node, 'Statement');
      }
      parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
        return (
          this.parsePlaceholder('BlockStatement') ||
          super.parseBlock(
            allowDirectives,
            createNewLexicalScope,
            afterBlockParse
          )
        );
      }
      parseFunctionId(requireId) {
        return (
          this.parsePlaceholder('Identifier') ||
          super.parseFunctionId(requireId)
        );
      }
      parseClass(node, isStatement, optionalId) {
        const type = isStatement ? 'ClassDeclaration' : 'ClassExpression';
        this.next();
        const oldStrict = this.state.strict;
        const placeholder = this.parsePlaceholder('Identifier');
        if (placeholder) {
          if (this.match(81) || this.match(142) || this.match(5)) {
            node.id = placeholder;
          } else if (optionalId || !isStatement) {
            node.id = null;
            node.body = this.finishPlaceholder(placeholder, 'ClassBody');
            return this.finishNode(node, type);
          } else {
            throw this.raise(PlaceholderErrors.ClassNameIsRequired, {
              at: this.state.startLoc,
            });
          }
        } else {
          this.parseClassId(node, isStatement, optionalId);
        }
        super.parseClassSuper(node);
        node.body =
          this.parsePlaceholder('ClassBody') ||
          super.parseClassBody(!!node.superClass, oldStrict);
        return this.finishNode(node, type);
      }
      parseExport(node, decorators) {
        const placeholder = this.parsePlaceholder('Identifier');
        if (!placeholder) return super.parseExport(node, decorators);
        if (!this.isContextual(97) && !this.match(12)) {
          node.specifiers = [];
          node.source = null;
          node.declaration = this.finishPlaceholder(placeholder, 'Declaration');
          return this.finishNode(node, 'ExportNamedDeclaration');
        }
        this.expectPlugin('exportDefaultFrom');
        const specifier = this.startNode();
        specifier.exported = placeholder;
        node.specifiers = [
          this.finishNode(specifier, 'ExportDefaultSpecifier'),
        ];
        return super.parseExport(node, decorators);
      }
      isExportDefaultSpecifier() {
        if (this.match(65)) {
          const next = this.nextTokenStart();
          if (this.isUnparsedContextual(next, 'from')) {
            if (
              this.input.startsWith(
                tokenLabelName(142),
                this.nextTokenStartSince(next + 4)
              )
            ) {
              return true;
            }
          }
        }
        return super.isExportDefaultSpecifier();
      }
      maybeParseExportDefaultSpecifier(node) {
        if (node.specifiers && node.specifiers.length > 0) {
          return true;
        }
        return super.maybeParseExportDefaultSpecifier(node);
      }
      checkExport(node) {
        const {specifiers: specifiers} = node;
        if (specifiers != null && specifiers.length) {
          node.specifiers = specifiers.filter(
            node => node.exported.type === 'Placeholder'
          );
        }
        super.checkExport(node);
        node.specifiers = specifiers;
      }
      parseImport(node) {
        const placeholder = this.parsePlaceholder('Identifier');
        if (!placeholder) return super.parseImport(node);
        node.specifiers = [];
        if (!this.isContextual(97) && !this.match(12)) {
          node.source = this.finishPlaceholder(placeholder, 'StringLiteral');
          this.semicolon();
          return this.finishNode(node, 'ImportDeclaration');
        }
        const specifier = this.startNodeAtNode(placeholder);
        specifier.local = placeholder;
        node.specifiers.push(
          this.finishNode(specifier, 'ImportDefaultSpecifier')
        );
        if (this.eat(12)) {
          const hasStarImport = this.maybeParseStarImportSpecifier(node);
          if (!hasStarImport) this.parseNamedImportSpecifiers(node);
        }
        this.expectContextual(97);
        node.source = this.parseImportSource();
        this.semicolon();
        return this.finishNode(node, 'ImportDeclaration');
      }
      parseImportSource() {
        return (
          this.parsePlaceholder('StringLiteral') || super.parseImportSource()
        );
      }
      assertNoSpace() {
        if (this.state.start > this.state.lastTokEndLoc.index) {
          this.raise(PlaceholderErrors.UnexpectedSpace, {
            at: this.state.lastTokEndLoc,
          });
        }
      }
    };
  var v8intrinsic = superClass =>
    class V8IntrinsicMixin extends superClass {
      parseV8Intrinsic() {
        if (this.match(54)) {
          const v8IntrinsicStartLoc = this.state.startLoc;
          const node = this.startNode();
          this.next();
          if (tokenIsIdentifier(this.state.type)) {
            const name = this.parseIdentifierName();
            const identifier = this.createIdentifier(node, name);
            identifier.type = 'V8IntrinsicIdentifier';
            if (this.match(10)) {
              return identifier;
            }
          }
          this.unexpected(v8IntrinsicStartLoc);
        }
      }
      parseExprAtom(refExpressionErrors) {
        return (
          this.parseV8Intrinsic() || super.parseExprAtom(refExpressionErrors)
        );
      }
    };
  function hasPlugin(plugins, expectedConfig) {
    const [expectedName, expectedOptions] =
      typeof expectedConfig === 'string'
        ? [expectedConfig, {}]
        : expectedConfig;
    const expectedKeys = Object.keys(expectedOptions);
    const expectedOptionsIsEmpty = expectedKeys.length === 0;
    return plugins.some(p => {
      if (typeof p === 'string') {
        return expectedOptionsIsEmpty && p === expectedName;
      } else {
        const [pluginName, pluginOptions] = p;
        if (pluginName !== expectedName) {
          return false;
        }
        for (const key of expectedKeys) {
          if (pluginOptions[key] !== expectedOptions[key]) {
            return false;
          }
        }
        return true;
      }
    });
  }
  function getPluginOption(plugins, name, option) {
    const plugin = plugins.find(plugin => {
      if (Array.isArray(plugin)) {
        return plugin[0] === name;
      } else {
        return plugin === name;
      }
    });
    if (plugin && Array.isArray(plugin) && plugin.length > 1) {
      return plugin[1][option];
    }
    return null;
  }
  const PIPELINE_PROPOSALS = ['minimal', 'fsharp', 'hack', 'smart'];
  const TOPIC_TOKENS = ['^^', '@@', '^', '%', '#'];
  const RECORD_AND_TUPLE_SYNTAX_TYPES = ['hash', 'bar'];
  function validatePlugins(plugins) {
    if (hasPlugin(plugins, 'decorators')) {
      if (hasPlugin(plugins, 'decorators-legacy')) {
        throw new Error(
          'Cannot use the decorators and decorators-legacy plugin together'
        );
      }
      const decoratorsBeforeExport = getPluginOption(
        plugins,
        'decorators',
        'decoratorsBeforeExport'
      );
      if (
        decoratorsBeforeExport != null &&
        typeof decoratorsBeforeExport !== 'boolean'
      ) {
        throw new Error(
          "'decoratorsBeforeExport' must be a boolean, if specified."
        );
      }
      const allowCallParenthesized = getPluginOption(
        plugins,
        'decorators',
        'allowCallParenthesized'
      );
      if (
        allowCallParenthesized != null &&
        typeof allowCallParenthesized !== 'boolean'
      ) {
        throw new Error("'allowCallParenthesized' must be a boolean.");
      }
    }
    if (hasPlugin(plugins, 'flow') && hasPlugin(plugins, 'typescript')) {
      throw new Error('Cannot combine flow and typescript plugins.');
    }
    if (
      hasPlugin(plugins, 'placeholders') &&
      hasPlugin(plugins, 'v8intrinsic')
    ) {
      throw new Error('Cannot combine placeholders and v8intrinsic plugins.');
    }
    if (hasPlugin(plugins, 'pipelineOperator')) {
      const proposal = getPluginOption(plugins, 'pipelineOperator', 'proposal');
      if (!PIPELINE_PROPOSALS.includes(proposal)) {
        const proposalList = PIPELINE_PROPOSALS.map(p => `"${p}"`).join(', ');
        throw new Error(
          `"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`
        );
      }
      const tupleSyntaxIsHash = hasPlugin(plugins, [
        'recordAndTuple',
        {syntaxType: 'hash'},
      ]);
      if (proposal === 'hack') {
        if (hasPlugin(plugins, 'placeholders')) {
          throw new Error(
            'Cannot combine placeholders plugin and Hack-style pipes.'
          );
        }
        if (hasPlugin(plugins, 'v8intrinsic')) {
          throw new Error(
            'Cannot combine v8intrinsic plugin and Hack-style pipes.'
          );
        }
        const topicToken = getPluginOption(
          plugins,
          'pipelineOperator',
          'topicToken'
        );
        if (!TOPIC_TOKENS.includes(topicToken)) {
          const tokenList = TOPIC_TOKENS.map(t => `"${t}"`).join(', ');
          throw new Error(
            `"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`
          );
        }
        if (topicToken === '#' && tupleSyntaxIsHash) {
          throw new Error(
            'Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.'
          );
        }
      } else if (proposal === 'smart' && tupleSyntaxIsHash) {
        throw new Error(
          'Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.'
        );
      }
    }
    if (hasPlugin(plugins, 'moduleAttributes')) {
      {
        if (hasPlugin(plugins, 'importAssertions')) {
          throw new Error(
            'Cannot combine importAssertions and moduleAttributes plugins.'
          );
        }
        const moduleAttributesVersionPluginOption = getPluginOption(
          plugins,
          'moduleAttributes',
          'version'
        );
        if (moduleAttributesVersionPluginOption !== 'may-2020') {
          throw new Error(
            "The 'moduleAttributes' plugin requires a 'version' option," +
              ' representing the last proposal update. Currently, the' +
              " only supported value is 'may-2020'."
          );
        }
      }
    }
    if (
      hasPlugin(plugins, 'recordAndTuple') &&
      getPluginOption(plugins, 'recordAndTuple', 'syntaxType') != null &&
      !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(
        getPluginOption(plugins, 'recordAndTuple', 'syntaxType')
      )
    ) {
      throw new Error(
        "The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " +
          RECORD_AND_TUPLE_SYNTAX_TYPES.map(p => `'${p}'`).join(', ')
      );
    }
    if (
      hasPlugin(plugins, 'asyncDoExpressions') &&
      !hasPlugin(plugins, 'doExpressions')
    ) {
      const error = new Error(
        "'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins."
      );
      error.missingPlugins = 'doExpressions';
      throw error;
    }
  }
  const mixinPlugins = {
    estree: estree,
    jsx: jsx,
    flow: flow,
    typescript: typescript,
    v8intrinsic: v8intrinsic,
    placeholders: placeholders,
  };
  const mixinPluginNames = Object.keys(mixinPlugins);
  class ExpressionParser extends LValParser {
    checkProto(prop, isRecord, protoRef, refExpressionErrors) {
      if (
        prop.type === 'SpreadElement' ||
        this.isObjectMethod(prop) ||
        prop.computed ||
        prop.shorthand
      ) {
        return;
      }
      const key = prop.key;
      const name = key.type === 'Identifier' ? key.name : key.value;
      if (name === '__proto__') {
        if (isRecord) {
          this.raise(Errors.RecordNoProto, {at: key});
          return;
        }
        if (protoRef.used) {
          if (refExpressionErrors) {
            if (refExpressionErrors.doubleProtoLoc === null) {
              refExpressionErrors.doubleProtoLoc = key.loc.start;
            }
          } else {
            this.raise(Errors.DuplicateProto, {at: key});
          }
        }
        protoRef.used = true;
      }
    }
    shouldExitDescending(expr, potentialArrowAt) {
      return (
        expr.type === 'ArrowFunctionExpression' &&
        expr.start === potentialArrowAt
      );
    }
    getExpression() {
      this.enterInitialScopes();
      this.nextToken();
      const expr = this.parseExpression();
      if (!this.match(137)) {
        this.unexpected();
      }
      this.finalizeRemainingComments();
      expr.comments = this.state.comments;
      expr.errors = this.state.errors;
      if (this.options.tokens) {
        expr.tokens = this.tokens;
      }
      return expr;
    }
    parseExpression(disallowIn, refExpressionErrors) {
      if (disallowIn) {
        return this.disallowInAnd(() =>
          this.parseExpressionBase(refExpressionErrors)
        );
      }
      return this.allowInAnd(() =>
        this.parseExpressionBase(refExpressionErrors)
      );
    }
    parseExpressionBase(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const expr = this.parseMaybeAssign(refExpressionErrors);
      if (this.match(12)) {
        const node = this.startNodeAt(startLoc);
        node.expressions = [expr];
        while (this.eat(12)) {
          node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
        }
        this.toReferencedList(node.expressions);
        return this.finishNode(node, 'SequenceExpression');
      }
      return expr;
    }
    parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
      return this.disallowInAnd(() =>
        this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
      );
    }
    parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
      return this.allowInAnd(() =>
        this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
      );
    }
    setOptionalParametersError(refExpressionErrors, resultError) {
      var _resultError$loc;
      refExpressionErrors.optionalParametersLoc =
        (_resultError$loc = resultError == null ? void 0 : resultError.loc) !=
        null
          ? _resultError$loc
          : this.state.startLoc;
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      const startLoc = this.state.startLoc;
      if (this.isContextual(106)) {
        if (this.prodParam.hasYield) {
          let left = this.parseYield();
          if (afterLeftParse) {
            left = afterLeftParse.call(this, left, startLoc);
          }
          return left;
        }
      }
      let ownExpressionErrors;
      if (refExpressionErrors) {
        ownExpressionErrors = false;
      } else {
        refExpressionErrors = new ExpressionErrors();
        ownExpressionErrors = true;
      }
      const {type: type} = this.state;
      if (type === 10 || tokenIsIdentifier(type)) {
        this.state.potentialArrowAt = this.state.start;
      }
      let left = this.parseMaybeConditional(refExpressionErrors);
      if (afterLeftParse) {
        left = afterLeftParse.call(this, left, startLoc);
      }
      if (tokenIsAssignment(this.state.type)) {
        const node = this.startNodeAt(startLoc);
        const operator = this.state.value;
        node.operator = operator;
        if (this.match(29)) {
          this.toAssignable(left, true);
          node.left = left;
          const startIndex = startLoc.index;
          if (
            refExpressionErrors.doubleProtoLoc != null &&
            refExpressionErrors.doubleProtoLoc.index >= startIndex
          ) {
            refExpressionErrors.doubleProtoLoc = null;
          }
          if (
            refExpressionErrors.shorthandAssignLoc != null &&
            refExpressionErrors.shorthandAssignLoc.index >= startIndex
          ) {
            refExpressionErrors.shorthandAssignLoc = null;
          }
          if (
            refExpressionErrors.privateKeyLoc != null &&
            refExpressionErrors.privateKeyLoc.index >= startIndex
          ) {
            this.checkDestructuringPrivate(refExpressionErrors);
            refExpressionErrors.privateKeyLoc = null;
          }
        } else {
          node.left = left;
        }
        this.next();
        node.right = this.parseMaybeAssign();
        this.checkLVal(left, {
          in: this.finishNode(node, 'AssignmentExpression'),
        });
        return node;
      } else if (ownExpressionErrors) {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      return left;
    }
    parseMaybeConditional(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprOps(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseConditional(expr, startLoc, refExpressionErrors);
    }
    parseConditional(expr, startLoc, refExpressionErrors) {
      if (this.eat(17)) {
        const node = this.startNodeAt(startLoc);
        node.test = expr;
        node.consequent = this.parseMaybeAssignAllowIn();
        this.expect(14);
        node.alternate = this.parseMaybeAssign();
        return this.finishNode(node, 'ConditionalExpression');
      }
      return expr;
    }
    parseMaybeUnaryOrPrivate(refExpressionErrors) {
      return this.match(136)
        ? this.parsePrivateName()
        : this.parseMaybeUnary(refExpressionErrors);
    }
    parseExprOps(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseExprOp(expr, startLoc, -1);
    }
    parseExprOp(left, leftStartLoc, minPrec) {
      if (this.isPrivateName(left)) {
        const value = this.getPrivateNameSV(left);
        if (
          minPrec >= tokenOperatorPrecedence(58) ||
          !this.prodParam.hasIn ||
          !this.match(58)
        ) {
          this.raise(Errors.PrivateInExpectedIn, {
            at: left,
            identifierName: value,
          });
        }
        this.classScope.usePrivateName(value, left.loc.start);
      }
      const op = this.state.type;
      if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
        let prec = tokenOperatorPrecedence(op);
        if (prec > minPrec) {
          if (op === 39) {
            this.expectPlugin('pipelineOperator');
            if (this.state.inFSharpPipelineDirectBody) {
              return left;
            }
            this.checkPipelineAtInfixOperator(left, leftStartLoc);
          }
          const node = this.startNodeAt(leftStartLoc);
          node.left = left;
          node.operator = this.state.value;
          const logical = op === 41 || op === 42;
          const coalesce = op === 40;
          if (coalesce) {
            prec = tokenOperatorPrecedence(42);
          }
          this.next();
          if (
            op === 39 &&
            this.hasPlugin(['pipelineOperator', {proposal: 'minimal'}])
          ) {
            if (this.state.type === 96 && this.prodParam.hasAwait) {
              throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, {
                at: this.state.startLoc,
              });
            }
          }
          node.right = this.parseExprOpRightExpr(op, prec);
          const finishedNode = this.finishNode(
            node,
            logical || coalesce ? 'LogicalExpression' : 'BinaryExpression'
          );
          const nextOp = this.state.type;
          if (
            (coalesce && (nextOp === 41 || nextOp === 42)) ||
            (logical && nextOp === 40)
          ) {
            throw this.raise(Errors.MixingCoalesceWithLogical, {
              at: this.state.startLoc,
            });
          }
          return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
        }
      }
      return left;
    }
    parseExprOpRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      switch (op) {
        case 39:
          switch (this.getPluginOption('pipelineOperator', 'proposal')) {
            case 'hack':
              return this.withTopicBindingContext(() =>
                this.parseHackPipeBody()
              );
            case 'smart':
              return this.withTopicBindingContext(() => {
                if (this.prodParam.hasYield && this.isContextual(106)) {
                  throw this.raise(Errors.PipeBodyIsTighter, {
                    at: this.state.startLoc,
                  });
                }
                return this.parseSmartPipelineBodyInStyle(
                  this.parseExprOpBaseRightExpr(op, prec),
                  startLoc
                );
              });
            case 'fsharp':
              return this.withSoloAwaitPermittingContext(() =>
                this.parseFSharpPipelineBody(prec)
              );
          }
        default:
          return this.parseExprOpBaseRightExpr(op, prec);
      }
    }
    parseExprOpBaseRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      return this.parseExprOp(
        this.parseMaybeUnaryOrPrivate(),
        startLoc,
        tokenIsRightAssociative(op) ? prec - 1 : prec
      );
    }
    parseHackPipeBody() {
      var _body$extra;
      const {startLoc: startLoc} = this.state;
      const body = this.parseMaybeAssign();
      const requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(
        body.type
      );
      if (
        requiredParentheses &&
        !((_body$extra = body.extra) != null && _body$extra.parenthesized)
      ) {
        this.raise(Errors.PipeUnparenthesizedBody, {
          at: startLoc,
          type: body.type,
        });
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipeTopicUnused, {at: startLoc});
      }
      return body;
    }
    checkExponentialAfterUnary(node) {
      if (this.match(57)) {
        this.raise(Errors.UnexpectedTokenUnaryExponentiation, {
          at: node.argument,
        });
      }
    }
    parseMaybeUnary(refExpressionErrors, sawUnary) {
      const startLoc = this.state.startLoc;
      const isAwait = this.isContextual(96);
      if (isAwait && this.isAwaitAllowed()) {
        this.next();
        const expr = this.parseAwait(startLoc);
        if (!sawUnary) this.checkExponentialAfterUnary(expr);
        return expr;
      }
      const update = this.match(34);
      const node = this.startNode();
      if (tokenIsPrefix(this.state.type)) {
        node.operator = this.state.value;
        node.prefix = true;
        if (this.match(72)) {
          this.expectPlugin('throwExpressions');
        }
        const isDelete = this.match(89);
        this.next();
        node.argument = this.parseMaybeUnary(null, true);
        this.checkExpressionErrors(refExpressionErrors, true);
        if (this.state.strict && isDelete) {
          const arg = node.argument;
          if (arg.type === 'Identifier') {
            this.raise(Errors.StrictDelete, {at: node});
          } else if (this.hasPropertyAsPrivateName(arg)) {
            this.raise(Errors.DeletePrivateField, {at: node});
          }
        }
        if (!update) {
          if (!sawUnary) {
            this.checkExponentialAfterUnary(node);
          }
          return this.finishNode(node, 'UnaryExpression');
        }
      }
      const expr = this.parseUpdate(node, update, refExpressionErrors);
      if (isAwait) {
        const {type: type} = this.state;
        const startsExpr = this.hasPlugin('v8intrinsic')
          ? tokenCanStartExpression(type)
          : tokenCanStartExpression(type) && !this.match(54);
        if (startsExpr && !this.isAmbiguousAwait()) {
          this.raiseOverwrite(Errors.AwaitNotInAsyncContext, {at: startLoc});
          return this.parseAwait(startLoc);
        }
      }
      return expr;
    }
    parseUpdate(node, update, refExpressionErrors) {
      if (update) {
        const updateExpressionNode = node;
        this.checkLVal(updateExpressionNode.argument, {
          in: this.finishNode(updateExpressionNode, 'UpdateExpression'),
        });
        return node;
      }
      const startLoc = this.state.startLoc;
      let expr = this.parseExprSubscripts(refExpressionErrors);
      if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
      while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
        const node = this.startNodeAt(startLoc);
        node.operator = this.state.value;
        node.prefix = false;
        node.argument = expr;
        this.next();
        this.checkLVal(expr, {
          in: (expr = this.finishNode(node, 'UpdateExpression')),
        });
      }
      return expr;
    }
    parseExprSubscripts(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprAtom(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseSubscripts(expr, startLoc);
    }
    parseSubscripts(base, startLoc, noCalls) {
      const state = {
        optionalChainMember: false,
        maybeAsyncArrow: this.atPossibleAsyncArrow(base),
        stop: false,
      };
      do {
        base = this.parseSubscript(base, startLoc, noCalls, state);
        state.maybeAsyncArrow = false;
      } while (!state.stop);
      return base;
    }
    parseSubscript(base, startLoc, noCalls, state) {
      const {type: type} = this.state;
      if (!noCalls && type === 15) {
        return this.parseBind(base, startLoc, noCalls, state);
      } else if (tokenIsTemplate(type)) {
        return this.parseTaggedTemplateExpression(base, startLoc, state);
      }
      let optional = false;
      if (type === 18) {
        if (noCalls) {
          this.raise(Errors.OptionalChainingNoNew, {at: this.state.startLoc});
          if (this.lookaheadCharCode() === 40) {
            state.stop = true;
            return base;
          }
        }
        state.optionalChainMember = optional = true;
        this.next();
      }
      if (!noCalls && this.match(10)) {
        return this.parseCoverCallAndAsyncArrowHead(
          base,
          startLoc,
          state,
          optional
        );
      } else {
        const computed = this.eat(0);
        if (computed || optional || this.eat(16)) {
          return this.parseMember(base, startLoc, state, computed, optional);
        } else {
          state.stop = true;
          return base;
        }
      }
    }
    parseMember(base, startLoc, state, computed, optional) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      node.computed = computed;
      if (computed) {
        node.property = this.parseExpression();
        this.expect(3);
      } else if (this.match(136)) {
        if (base.type === 'Super') {
          this.raise(Errors.SuperPrivateField, {at: startLoc});
        }
        this.classScope.usePrivateName(this.state.value, this.state.startLoc);
        node.property = this.parsePrivateName();
      } else {
        node.property = this.parseIdentifier(true);
      }
      if (state.optionalChainMember) {
        node.optional = optional;
        return this.finishNode(node, 'OptionalMemberExpression');
      } else {
        return this.finishNode(node, 'MemberExpression');
      }
    }
    parseBind(base, startLoc, noCalls, state) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      this.next();
      node.callee = this.parseNoCallExpr();
      state.stop = true;
      return this.parseSubscripts(
        this.finishNode(node, 'BindExpression'),
        startLoc,
        noCalls
      );
    }
    parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      let refExpressionErrors = null;
      this.state.maybeInArrowParameters = true;
      this.next();
      const node = this.startNodeAt(startLoc);
      node.callee = base;
      const {
        maybeAsyncArrow: maybeAsyncArrow,
        optionalChainMember: optionalChainMember,
      } = state;
      if (maybeAsyncArrow) {
        this.expressionScope.enter(newAsyncArrowScope());
        refExpressionErrors = new ExpressionErrors();
      }
      if (optionalChainMember) {
        node.optional = optional;
      }
      if (optional) {
        node.arguments = this.parseCallExpressionArguments(11);
      } else {
        node.arguments = this.parseCallExpressionArguments(
          11,
          base.type === 'Import',
          base.type !== 'Super',
          node,
          refExpressionErrors
        );
      }
      let finishedNode = this.finishCallExpression(node, optionalChainMember);
      if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
        state.stop = true;
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        finishedNode = this.parseAsyncArrowFromCallExpression(
          this.startNodeAt(startLoc),
          finishedNode
        );
      } else {
        if (maybeAsyncArrow) {
          this.checkExpressionErrors(refExpressionErrors, true);
          this.expressionScope.exit();
        }
        this.toReferencedArguments(finishedNode);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return finishedNode;
    }
    toReferencedArguments(node, isParenthesizedExpr) {
      this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
    }
    parseTaggedTemplateExpression(base, startLoc, state) {
      const node = this.startNodeAt(startLoc);
      node.tag = base;
      node.quasi = this.parseTemplate(true);
      if (state.optionalChainMember) {
        this.raise(Errors.OptionalChainingNoTemplate, {at: startLoc});
      }
      return this.finishNode(node, 'TaggedTemplateExpression');
    }
    atPossibleAsyncArrow(base) {
      return (
        base.type === 'Identifier' &&
        base.name === 'async' &&
        this.state.lastTokEndLoc.index === base.end &&
        !this.canInsertSemicolon() &&
        base.end - base.start === 5 &&
        base.start === this.state.potentialArrowAt
      );
    }
    finishCallExpression(node, optional) {
      if (node.callee.type === 'Import') {
        if (node.arguments.length === 2) {
          {
            if (!this.hasPlugin('moduleAttributes')) {
              this.expectPlugin('importAssertions');
            }
          }
        }
        if (node.arguments.length === 0 || node.arguments.length > 2) {
          this.raise(Errors.ImportCallArity, {
            at: node,
            maxArgumentCount:
              this.hasPlugin('importAssertions') ||
              this.hasPlugin('moduleAttributes')
                ? 2
                : 1,
          });
        } else {
          for (const arg of node.arguments) {
            if (arg.type === 'SpreadElement') {
              this.raise(Errors.ImportCallSpreadArgument, {at: arg});
            }
          }
        }
      }
      return this.finishNode(
        node,
        optional ? 'OptionalCallExpression' : 'CallExpression'
      );
    }
    parseCallExpressionArguments(
      close,
      dynamicImport,
      allowPlaceholder,
      nodeForExtra,
      refExpressionErrors
    ) {
      const elts = [];
      let first = true;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (
              dynamicImport &&
              !this.hasPlugin('importAssertions') &&
              !this.hasPlugin('moduleAttributes')
            ) {
              this.raise(Errors.ImportCallArgumentTrailingComma, {
                at: this.state.lastTokStartLoc,
              });
            }
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(
          this.parseExprListItem(false, refExpressionErrors, allowPlaceholder)
        );
      }
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return elts;
    }
    shouldParseAsyncArrow() {
      return this.match(19) && !this.canInsertSemicolon();
    }
    parseAsyncArrowFromCallExpression(node, call) {
      var _call$extra;
      this.resetPreviousNodeTrailingComments(call);
      this.expect(19);
      this.parseArrowExpression(
        node,
        call.arguments,
        true,
        (_call$extra = call.extra) == null
          ? void 0
          : _call$extra.trailingCommaLoc
      );
      if (call.innerComments) {
        setInnerComments(node, call.innerComments);
      }
      if (call.callee.trailingComments) {
        setInnerComments(node, call.callee.trailingComments);
      }
      return node;
    }
    parseNoCallExpr() {
      const startLoc = this.state.startLoc;
      return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
    }
    parseExprAtom(refExpressionErrors) {
      let node;
      let decorators = null;
      const {type: type} = this.state;
      switch (type) {
        case 79:
          return this.parseSuper();
        case 83:
          node = this.startNode();
          this.next();
          if (this.match(16)) {
            return this.parseImportMetaProperty(node);
          }
          if (!this.match(10)) {
            this.raise(Errors.UnsupportedImport, {
              at: this.state.lastTokStartLoc,
            });
          }
          return this.finishNode(node, 'Import');
        case 78:
          node = this.startNode();
          this.next();
          return this.finishNode(node, 'ThisExpression');
        case 90: {
          return this.parseDo(this.startNode(), false);
        }
        case 56:
        case 31: {
          this.readRegexp();
          return this.parseRegExpLiteral(this.state.value);
        }
        case 132:
          return this.parseNumericLiteral(this.state.value);
        case 133:
          return this.parseBigIntLiteral(this.state.value);
        case 134:
          return this.parseDecimalLiteral(this.state.value);
        case 131:
          return this.parseStringLiteral(this.state.value);
        case 84:
          return this.parseNullLiteral();
        case 85:
          return this.parseBooleanLiteral(true);
        case 86:
          return this.parseBooleanLiteral(false);
        case 10: {
          const canBeArrow = this.state.potentialArrowAt === this.state.start;
          return this.parseParenAndDistinguishExpression(canBeArrow);
        }
        case 2:
        case 1: {
          return this.parseArrayLike(
            this.state.type === 2 ? 4 : 3,
            false,
            true
          );
        }
        case 0: {
          return this.parseArrayLike(3, true, false, refExpressionErrors);
        }
        case 6:
        case 7: {
          return this.parseObjectLike(
            this.state.type === 6 ? 9 : 8,
            false,
            true
          );
        }
        case 5: {
          return this.parseObjectLike(8, false, false, refExpressionErrors);
        }
        case 68:
          return this.parseFunctionOrFunctionSent();
        case 26:
          decorators = this.parseDecorators();
        case 80:
          return this.parseClass(
            this.maybeTakeDecorators(decorators, this.startNode()),
            false
          );
        case 77:
          return this.parseNewOrNewTarget();
        case 25:
        case 24:
          return this.parseTemplate(false);
        case 15: {
          node = this.startNode();
          this.next();
          node.object = null;
          const callee = (node.callee = this.parseNoCallExpr());
          if (callee.type === 'MemberExpression') {
            return this.finishNode(node, 'BindExpression');
          } else {
            throw this.raise(Errors.UnsupportedBind, {at: callee});
          }
        }
        case 136: {
          this.raise(Errors.PrivateInExpectedIn, {
            at: this.state.startLoc,
            identifierName: this.state.value,
          });
          return this.parsePrivateName();
        }
        case 33: {
          return this.parseTopicReferenceThenEqualsSign(54, '%');
        }
        case 32: {
          return this.parseTopicReferenceThenEqualsSign(44, '^');
        }
        case 37:
        case 38: {
          return this.parseTopicReference('hack');
        }
        case 44:
        case 54:
        case 27: {
          const pipeProposal = this.getPluginOption(
            'pipelineOperator',
            'proposal'
          );
          if (pipeProposal) {
            return this.parseTopicReference(pipeProposal);
          }
          this.unexpected();
          break;
        }
        case 47: {
          const lookaheadCh = this.input.codePointAt(this.nextTokenStart());
          if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
            this.expectOnePlugin(['jsx', 'flow', 'typescript']);
          } else {
            this.unexpected();
          }
          break;
        }
        default:
          if (tokenIsIdentifier(type)) {
            if (
              this.isContextual(125) &&
              this.lookaheadInLineCharCode() === 123
            ) {
              return this.parseModuleExpression();
            }
            const canBeArrow = this.state.potentialArrowAt === this.state.start;
            const containsEsc = this.state.containsEsc;
            const id = this.parseIdentifier();
            if (
              !containsEsc &&
              id.name === 'async' &&
              !this.canInsertSemicolon()
            ) {
              const {type: type} = this.state;
              if (type === 68) {
                this.resetPreviousNodeTrailingComments(id);
                this.next();
                return this.parseAsyncFunctionExpression(
                  this.startNodeAtNode(id)
                );
              } else if (tokenIsIdentifier(type)) {
                if (this.lookaheadCharCode() === 61) {
                  return this.parseAsyncArrowUnaryFunction(
                    this.startNodeAtNode(id)
                  );
                } else {
                  return id;
                }
              } else if (type === 90) {
                this.resetPreviousNodeTrailingComments(id);
                return this.parseDo(this.startNodeAtNode(id), true);
              }
            }
            if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
              this.next();
              return this.parseArrowExpression(
                this.startNodeAtNode(id),
                [id],
                false
              );
            }
            return id;
          } else {
            this.unexpected();
          }
      }
    }
    parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
      const pipeProposal = this.getPluginOption('pipelineOperator', 'proposal');
      if (pipeProposal) {
        this.state.type = topicTokenType;
        this.state.value = topicTokenValue;
        this.state.pos--;
        this.state.end--;
        this.state.endLoc = createPositionWithColumnOffset(
          this.state.endLoc,
          -1
        );
        return this.parseTopicReference(pipeProposal);
      } else {
        this.unexpected();
      }
    }
    parseTopicReference(pipeProposal) {
      const node = this.startNode();
      const startLoc = this.state.startLoc;
      const tokenType = this.state.type;
      this.next();
      return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
    }
    finishTopicReference(node, startLoc, pipeProposal, tokenType) {
      if (
        this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)
      ) {
        const nodeType =
          pipeProposal === 'smart'
            ? 'PipelinePrimaryTopicReference'
            : 'TopicReference';
        if (!this.topicReferenceIsAllowedInCurrentContext()) {
          this.raise(
            pipeProposal === 'smart'
              ? Errors.PrimaryTopicNotAllowed
              : Errors.PipeTopicUnbound,
            {at: startLoc}
          );
        }
        this.registerTopicReference();
        return this.finishNode(node, nodeType);
      } else {
        throw this.raise(Errors.PipeTopicUnconfiguredToken, {
          at: startLoc,
          token: tokenLabelName(tokenType),
        });
      }
    }
    testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
      switch (pipeProposal) {
        case 'hack': {
          return this.hasPlugin([
            'pipelineOperator',
            {topicToken: tokenLabelName(tokenType)},
          ]);
        }
        case 'smart':
          return tokenType === 27;
        default:
          throw this.raise(Errors.PipeTopicRequiresHackPipes, {at: startLoc});
      }
    }
    parseAsyncArrowUnaryFunction(node) {
      this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
      const params = [this.parseIdentifier()];
      this.prodParam.exit();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.LineTerminatorBeforeArrow, {
          at: this.state.curPosition(),
        });
      }
      this.expect(19);
      return this.parseArrowExpression(node, params, true);
    }
    parseDo(node, isAsync) {
      this.expectPlugin('doExpressions');
      if (isAsync) {
        this.expectPlugin('asyncDoExpressions');
      }
      node.async = isAsync;
      this.next();
      const oldLabels = this.state.labels;
      this.state.labels = [];
      if (isAsync) {
        this.prodParam.enter(PARAM_AWAIT);
        node.body = this.parseBlock();
        this.prodParam.exit();
      } else {
        node.body = this.parseBlock();
      }
      this.state.labels = oldLabels;
      return this.finishNode(node, 'DoExpression');
    }
    parseSuper() {
      const node = this.startNode();
      this.next();
      if (
        this.match(10) &&
        !this.scope.allowDirectSuper &&
        !this.options.allowSuperOutsideMethod
      ) {
        this.raise(Errors.SuperNotAllowed, {at: node});
      } else if (
        !this.scope.allowSuper &&
        !this.options.allowSuperOutsideMethod
      ) {
        this.raise(Errors.UnexpectedSuper, {at: node});
      }
      if (!this.match(10) && !this.match(0) && !this.match(16)) {
        this.raise(Errors.UnsupportedSuper, {at: node});
      }
      return this.finishNode(node, 'Super');
    }
    parsePrivateName() {
      const node = this.startNode();
      const id = this.startNodeAt(
        createPositionWithColumnOffset(this.state.startLoc, 1)
      );
      const name = this.state.value;
      this.next();
      node.id = this.createIdentifier(id, name);
      return this.finishNode(node, 'PrivateName');
    }
    parseFunctionOrFunctionSent() {
      const node = this.startNode();
      this.next();
      if (this.prodParam.hasYield && this.match(16)) {
        const meta = this.createIdentifier(
          this.startNodeAtNode(node),
          'function'
        );
        this.next();
        if (this.match(102)) {
          this.expectPlugin('functionSent');
        } else if (!this.hasPlugin('functionSent')) {
          this.unexpected();
        }
        return this.parseMetaProperty(node, meta, 'sent');
      }
      return this.parseFunction(node);
    }
    parseMetaProperty(node, meta, propertyName) {
      node.meta = meta;
      const containsEsc = this.state.containsEsc;
      node.property = this.parseIdentifier(true);
      if (node.property.name !== propertyName || containsEsc) {
        this.raise(Errors.UnsupportedMetaProperty, {
          at: node.property,
          target: meta.name,
          onlyValidPropertyName: propertyName,
        });
      }
      return this.finishNode(node, 'MetaProperty');
    }
    parseImportMetaProperty(node) {
      const id = this.createIdentifier(this.startNodeAtNode(node), 'import');
      this.next();
      if (this.isContextual(100)) {
        if (!this.inModule) {
          this.raise(Errors.ImportMetaOutsideModule, {at: id});
        }
        this.sawUnambiguousESM = true;
      }
      return this.parseMetaProperty(node, id, 'meta');
    }
    parseLiteralAtNode(value, type, node) {
      this.addExtra(node, 'rawValue', value);
      this.addExtra(node, 'raw', this.input.slice(node.start, this.state.end));
      node.value = value;
      this.next();
      return this.finishNode(node, type);
    }
    parseLiteral(value, type) {
      const node = this.startNode();
      return this.parseLiteralAtNode(value, type, node);
    }
    parseStringLiteral(value) {
      return this.parseLiteral(value, 'StringLiteral');
    }
    parseNumericLiteral(value) {
      return this.parseLiteral(value, 'NumericLiteral');
    }
    parseBigIntLiteral(value) {
      return this.parseLiteral(value, 'BigIntLiteral');
    }
    parseDecimalLiteral(value) {
      return this.parseLiteral(value, 'DecimalLiteral');
    }
    parseRegExpLiteral(value) {
      const node = this.parseLiteral(value.value, 'RegExpLiteral');
      node.pattern = value.pattern;
      node.flags = value.flags;
      return node;
    }
    parseBooleanLiteral(value) {
      const node = this.startNode();
      node.value = value;
      this.next();
      return this.finishNode(node, 'BooleanLiteral');
    }
    parseNullLiteral() {
      const node = this.startNode();
      this.next();
      return this.finishNode(node, 'NullLiteral');
    }
    parseParenAndDistinguishExpression(canBeArrow) {
      const startLoc = this.state.startLoc;
      let val;
      this.next();
      this.expressionScope.enter(newArrowHeadScope());
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.maybeInArrowParameters = true;
      this.state.inFSharpPipelineDirectBody = false;
      const innerStartLoc = this.state.startLoc;
      const exprList = [];
      const refExpressionErrors = new ExpressionErrors();
      let first = true;
      let spreadStartLoc;
      let optionalCommaStartLoc;
      while (!this.match(11)) {
        if (first) {
          first = false;
        } else {
          this.expect(
            12,
            refExpressionErrors.optionalParametersLoc === null
              ? null
              : refExpressionErrors.optionalParametersLoc
          );
          if (this.match(11)) {
            optionalCommaStartLoc = this.state.startLoc;
            break;
          }
        }
        if (this.match(21)) {
          const spreadNodeStartLoc = this.state.startLoc;
          spreadStartLoc = this.state.startLoc;
          exprList.push(
            this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc)
          );
          if (!this.checkCommaAfterRest(41)) {
            break;
          }
        } else {
          exprList.push(
            this.parseMaybeAssignAllowIn(
              refExpressionErrors,
              this.parseParenItem
            )
          );
        }
      }
      const innerEndLoc = this.state.lastTokEndLoc;
      this.expect(11);
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let arrowNode = this.startNodeAt(startLoc);
      if (
        canBeArrow &&
        this.shouldParseArrow(exprList) &&
        (arrowNode = this.parseArrow(arrowNode))
      ) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        this.parseArrowExpression(arrowNode, exprList, false);
        return arrowNode;
      }
      this.expressionScope.exit();
      if (!exprList.length) {
        this.unexpected(this.state.lastTokStartLoc);
      }
      if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
      if (spreadStartLoc) this.unexpected(spreadStartLoc);
      this.checkExpressionErrors(refExpressionErrors, true);
      this.toReferencedListDeep(exprList, true);
      if (exprList.length > 1) {
        val = this.startNodeAt(innerStartLoc);
        val.expressions = exprList;
        this.finishNode(val, 'SequenceExpression');
        this.resetEndLocation(val, innerEndLoc);
      } else {
        val = exprList[0];
      }
      return this.wrapParenthesis(startLoc, val);
    }
    wrapParenthesis(startLoc, expression) {
      if (!this.options.createParenthesizedExpressions) {
        this.addExtra(expression, 'parenthesized', true);
        this.addExtra(expression, 'parenStart', startLoc.index);
        this.takeSurroundingComments(
          expression,
          startLoc.index,
          this.state.lastTokEndLoc.index
        );
        return expression;
      }
      const parenExpression = this.startNodeAt(startLoc);
      parenExpression.expression = expression;
      return this.finishNode(parenExpression, 'ParenthesizedExpression');
    }
    shouldParseArrow(params) {
      return !this.canInsertSemicolon();
    }
    parseArrow(node) {
      if (this.eat(19)) {
        return node;
      }
    }
    parseParenItem(node, startLoc) {
      return node;
    }
    parseNewOrNewTarget() {
      const node = this.startNode();
      this.next();
      if (this.match(16)) {
        const meta = this.createIdentifier(this.startNodeAtNode(node), 'new');
        this.next();
        const metaProp = this.parseMetaProperty(node, meta, 'target');
        if (
          !this.scope.inNonArrowFunction &&
          !this.scope.inClass &&
          !this.options.allowNewTargetOutsideFunction
        ) {
          this.raise(Errors.UnexpectedNewTarget, {at: metaProp});
        }
        return metaProp;
      }
      return this.parseNew(node);
    }
    parseNew(node) {
      this.parseNewCallee(node);
      if (this.eat(10)) {
        const args = this.parseExprList(11);
        this.toReferencedList(args);
        node.arguments = args;
      } else {
        node.arguments = [];
      }
      return this.finishNode(node, 'NewExpression');
    }
    parseNewCallee(node) {
      node.callee = this.parseNoCallExpr();
      if (node.callee.type === 'Import') {
        this.raise(Errors.ImportCallNotNewExpression, {at: node.callee});
      }
    }
    parseTemplateElement(isTagged) {
      const {
        start: start,
        startLoc: startLoc,
        end: end,
        value: value,
      } = this.state;
      const elemStart = start + 1;
      const elem = this.startNodeAt(
        createPositionWithColumnOffset(startLoc, 1)
      );
      if (value === null) {
        if (!isTagged) {
          this.raise(Errors.InvalidEscapeSequenceTemplate, {
            at: createPositionWithColumnOffset(
              this.state.firstInvalidTemplateEscapePos,
              1
            ),
          });
        }
      }
      const isTail = this.match(24);
      const endOffset = isTail ? -1 : -2;
      const elemEnd = end + endOffset;
      elem.value = {
        raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, '\n'),
        cooked: value === null ? null : value.slice(1, endOffset),
      };
      elem.tail = isTail;
      this.next();
      const finishedNode = this.finishNode(elem, 'TemplateElement');
      this.resetEndLocation(
        finishedNode,
        createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset)
      );
      return finishedNode;
    }
    parseTemplate(isTagged) {
      const node = this.startNode();
      node.expressions = [];
      let curElt = this.parseTemplateElement(isTagged);
      node.quasis = [curElt];
      while (!curElt.tail) {
        node.expressions.push(this.parseTemplateSubstitution());
        this.readTemplateContinuation();
        node.quasis.push((curElt = this.parseTemplateElement(isTagged)));
      }
      return this.finishNode(node, 'TemplateLiteral');
    }
    parseTemplateSubstitution() {
      return this.parseExpression();
    }
    parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
      if (isRecord) {
        this.expectPlugin('recordAndTuple');
      }
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const propHash = Object.create(null);
      let first = true;
      const node = this.startNode();
      node.properties = [];
      this.next();
      while (!this.match(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            this.addTrailingCommaExtraToNode(node);
            break;
          }
        }
        let prop;
        if (isPattern) {
          prop = this.parseBindingProperty();
        } else {
          prop = this.parsePropertyDefinition(refExpressionErrors);
          this.checkProto(prop, isRecord, propHash, refExpressionErrors);
        }
        if (
          isRecord &&
          !this.isObjectProperty(prop) &&
          prop.type !== 'SpreadElement'
        ) {
          this.raise(Errors.InvalidRecordProperty, {at: prop});
        }
        if (prop.shorthand) {
          this.addExtra(prop, 'shorthand', true);
        }
        node.properties.push(prop);
      }
      this.next();
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let type = 'ObjectExpression';
      if (isPattern) {
        type = 'ObjectPattern';
      } else if (isRecord) {
        type = 'RecordExpression';
      }
      return this.finishNode(node, type);
    }
    addTrailingCommaExtraToNode(node) {
      this.addExtra(node, 'trailingComma', this.state.lastTokStart);
      this.addExtra(
        node,
        'trailingCommaLoc',
        this.state.lastTokStartLoc,
        false
      );
    }
    maybeAsyncOrAccessorProp(prop) {
      return (
        !prop.computed &&
        prop.key.type === 'Identifier' &&
        (this.isLiteralPropertyName() || this.match(0) || this.match(55))
      );
    }
    parsePropertyDefinition(refExpressionErrors) {
      let decorators = [];
      if (this.match(26)) {
        if (this.hasPlugin('decorators')) {
          this.raise(Errors.UnsupportedPropertyDecorator, {
            at: this.state.startLoc,
          });
        }
        while (this.match(26)) {
          decorators.push(this.parseDecorator());
        }
      }
      const prop = this.startNode();
      let isAsync = false;
      let isAccessor = false;
      let startLoc;
      if (this.match(21)) {
        if (decorators.length) this.unexpected();
        return this.parseSpread();
      }
      if (decorators.length) {
        prop.decorators = decorators;
        decorators = [];
      }
      prop.method = false;
      if (refExpressionErrors) {
        startLoc = this.state.startLoc;
      }
      let isGenerator = this.eat(55);
      this.parsePropertyNamePrefixOperator(prop);
      const containsEsc = this.state.containsEsc;
      const key = this.parsePropertyName(prop, refExpressionErrors);
      if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
        const keyName = key.name;
        if (keyName === 'async' && !this.hasPrecedingLineBreak()) {
          isAsync = true;
          this.resetPreviousNodeTrailingComments(key);
          isGenerator = this.eat(55);
          this.parsePropertyName(prop);
        }
        if (keyName === 'get' || keyName === 'set') {
          isAccessor = true;
          this.resetPreviousNodeTrailingComments(key);
          prop.kind = keyName;
          if (this.match(55)) {
            isGenerator = true;
            this.raise(Errors.AccessorIsGenerator, {
              at: this.state.curPosition(),
              kind: keyName,
            });
            this.next();
          }
          this.parsePropertyName(prop);
        }
      }
      return this.parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        false,
        isAccessor,
        refExpressionErrors
      );
    }
    getGetterSetterExpectedParamCount(method) {
      return method.kind === 'get' ? 0 : 1;
    }
    getObjectOrClassMethodParams(method) {
      return method.params;
    }
    checkGetterSetterParams(method) {
      var _params;
      const paramCount = this.getGetterSetterExpectedParamCount(method);
      const params = this.getObjectOrClassMethodParams(method);
      if (params.length !== paramCount) {
        this.raise(
          method.kind === 'get' ? Errors.BadGetterArity : Errors.BadSetterArity,
          {at: method}
        );
      }
      if (
        method.kind === 'set' &&
        ((_params = params[params.length - 1]) == null
          ? void 0
          : _params.type) === 'RestElement'
      ) {
        this.raise(Errors.BadSetterRestParameter, {at: method});
      }
    }
    parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
      if (isAccessor) {
        const finishedProp = this.parseMethod(
          prop,
          isGenerator,
          false,
          false,
          false,
          'ObjectMethod'
        );
        this.checkGetterSetterParams(finishedProp);
        return finishedProp;
      }
      if (isAsync || isGenerator || this.match(10)) {
        if (isPattern) this.unexpected();
        prop.kind = 'method';
        prop.method = true;
        return this.parseMethod(
          prop,
          isGenerator,
          isAsync,
          false,
          false,
          'ObjectMethod'
        );
      }
    }
    parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
      prop.shorthand = false;
      if (this.eat(14)) {
        prop.value = isPattern
          ? this.parseMaybeDefault(this.state.startLoc)
          : this.parseMaybeAssignAllowIn(refExpressionErrors);
        return this.finishNode(prop, 'ObjectProperty');
      }
      if (!prop.computed && prop.key.type === 'Identifier') {
        this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
        if (isPattern) {
          prop.value = this.parseMaybeDefault(
            startLoc,
            cloneIdentifier(prop.key)
          );
        } else if (this.match(29)) {
          const shorthandAssignLoc = this.state.startLoc;
          if (refExpressionErrors != null) {
            if (refExpressionErrors.shorthandAssignLoc === null) {
              refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
            }
          } else {
            this.raise(Errors.InvalidCoverInitializedName, {
              at: shorthandAssignLoc,
            });
          }
          prop.value = this.parseMaybeDefault(
            startLoc,
            cloneIdentifier(prop.key)
          );
        } else {
          prop.value = cloneIdentifier(prop.key);
        }
        prop.shorthand = true;
        return this.finishNode(prop, 'ObjectProperty');
      }
    }
    parseObjPropValue(
      prop,
      startLoc,
      isGenerator,
      isAsync,
      isPattern,
      isAccessor,
      refExpressionErrors
    ) {
      const node =
        this.parseObjectMethod(
          prop,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor
        ) ||
        this.parseObjectProperty(
          prop,
          startLoc,
          isPattern,
          refExpressionErrors
        );
      if (!node) this.unexpected();
      return node;
    }
    parsePropertyName(prop, refExpressionErrors) {
      if (this.eat(0)) {
        prop.computed = true;
        prop.key = this.parseMaybeAssignAllowIn();
        this.expect(3);
      } else {
        const {type: type, value: value} = this.state;
        let key;
        if (tokenIsKeywordOrIdentifier(type)) {
          key = this.parseIdentifier(true);
        } else {
          switch (type) {
            case 132:
              key = this.parseNumericLiteral(value);
              break;
            case 131:
              key = this.parseStringLiteral(value);
              break;
            case 133:
              key = this.parseBigIntLiteral(value);
              break;
            case 134:
              key = this.parseDecimalLiteral(value);
              break;
            case 136: {
              const privateKeyLoc = this.state.startLoc;
              if (refExpressionErrors != null) {
                if (refExpressionErrors.privateKeyLoc === null) {
                  refExpressionErrors.privateKeyLoc = privateKeyLoc;
                }
              } else {
                this.raise(Errors.UnexpectedPrivateField, {at: privateKeyLoc});
              }
              key = this.parsePrivateName();
              break;
            }
            default:
              this.unexpected();
          }
        }
        prop.key = key;
        if (type !== 136) {
          prop.computed = false;
        }
      }
      return prop.key;
    }
    initFunction(node, isAsync) {
      node.id = null;
      node.generator = false;
      node.async = isAsync;
    }
    parseMethod(
      node,
      isGenerator,
      isAsync,
      isConstructor,
      allowDirectSuper,
      type,
      inClassScope = false
    ) {
      this.initFunction(node, isAsync);
      node.generator = isGenerator;
      this.scope.enter(
        SCOPE_FUNCTION |
          SCOPE_SUPER |
          (inClassScope ? SCOPE_CLASS : 0) |
          (allowDirectSuper ? SCOPE_DIRECT_SUPER : 0)
      );
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      this.parseFunctionParams(node, isConstructor);
      const finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
      this.prodParam.exit();
      this.scope.exit();
      return finishedNode;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      if (isTuple) {
        this.expectPlugin('recordAndTuple');
      }
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const node = this.startNode();
      this.next();
      node.elements = this.parseExprList(
        close,
        !isTuple,
        refExpressionErrors,
        node
      );
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return this.finishNode(
        node,
        isTuple ? 'TupleExpression' : 'ArrayExpression'
      );
    }
    parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
      this.scope.enter(SCOPE_FUNCTION | SCOPE_ARROW);
      let flags = functionFlags(isAsync, false);
      if (!this.match(5) && this.prodParam.hasIn) {
        flags |= PARAM_IN;
      }
      this.prodParam.enter(flags);
      this.initFunction(node, isAsync);
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      if (params) {
        this.state.maybeInArrowParameters = true;
        this.setArrowFunctionParameters(node, params, trailingCommaLoc);
      }
      this.state.maybeInArrowParameters = false;
      this.parseFunctionBody(node, true);
      this.prodParam.exit();
      this.scope.exit();
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return this.finishNode(node, 'ArrowFunctionExpression');
    }
    setArrowFunctionParameters(node, params, trailingCommaLoc) {
      this.toAssignableList(params, trailingCommaLoc, false);
      node.params = params;
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      this.parseFunctionBody(node, false, isMethod);
      return this.finishNode(node, type);
    }
    parseFunctionBody(node, allowExpression, isMethod = false) {
      const isExpression = allowExpression && !this.match(5);
      this.expressionScope.enter(newExpressionScope());
      if (isExpression) {
        node.body = this.parseMaybeAssign();
        this.checkParams(node, false, allowExpression, false);
      } else {
        const oldStrict = this.state.strict;
        const oldLabels = this.state.labels;
        this.state.labels = [];
        this.prodParam.enter(this.prodParam.currentFlags() | PARAM_RETURN);
        node.body = this.parseBlock(true, false, hasStrictModeDirective => {
          const nonSimple = !this.isSimpleParamList(node.params);
          if (hasStrictModeDirective && nonSimple) {
            this.raise(Errors.IllegalLanguageModeDirective, {
              at:
                (node.kind === 'method' || node.kind === 'constructor') &&
                !!node.key
                  ? node.key.loc.end
                  : node,
            });
          }
          const strictModeChanged = !oldStrict && this.state.strict;
          this.checkParams(
            node,
            !this.state.strict && !allowExpression && !isMethod && !nonSimple,
            allowExpression,
            strictModeChanged
          );
          if (this.state.strict && node.id) {
            this.checkIdentifier(node.id, BIND_OUTSIDE, strictModeChanged);
          }
        });
        this.prodParam.exit();
        this.state.labels = oldLabels;
      }
      this.expressionScope.exit();
    }
    isSimpleParameter(node) {
      return node.type === 'Identifier';
    }
    isSimpleParamList(params) {
      for (let i = 0, len = params.length; i < len; i++) {
        if (!this.isSimpleParameter(params[i])) return false;
      }
      return true;
    }
    checkParams(
      node,
      allowDuplicates,
      isArrowFunction,
      strictModeChanged = true
    ) {
      const checkClashes = !allowDuplicates && new Set();
      const formalParameters = {type: 'FormalParameters'};
      for (const param of node.params) {
        this.checkLVal(param, {
          in: formalParameters,
          binding: BIND_VAR,
          checkClashes: checkClashes,
          strictModeChanged: strictModeChanged,
        });
      }
    }
    parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
      }
      return elts;
    }
    parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
      let elt;
      if (this.match(12)) {
        if (!allowEmpty) {
          this.raise(Errors.UnexpectedToken, {
            at: this.state.curPosition(),
            unexpected: ',',
          });
        }
        elt = null;
      } else if (this.match(21)) {
        const spreadNodeStartLoc = this.state.startLoc;
        elt = this.parseParenItem(
          this.parseSpread(refExpressionErrors),
          spreadNodeStartLoc
        );
      } else if (this.match(17)) {
        this.expectPlugin('partialApplication');
        if (!allowPlaceholder) {
          this.raise(Errors.UnexpectedArgumentPlaceholder, {
            at: this.state.startLoc,
          });
        }
        const node = this.startNode();
        this.next();
        elt = this.finishNode(node, 'ArgumentPlaceholder');
      } else {
        elt = this.parseMaybeAssignAllowIn(
          refExpressionErrors,
          this.parseParenItem
        );
      }
      return elt;
    }
    parseIdentifier(liberal) {
      const node = this.startNode();
      const name = this.parseIdentifierName(liberal);
      return this.createIdentifier(node, name);
    }
    createIdentifier(node, name) {
      node.name = name;
      node.loc.identifierName = name;
      return this.finishNode(node, 'Identifier');
    }
    parseIdentifierName(liberal) {
      let name;
      const {startLoc: startLoc, type: type} = this.state;
      if (tokenIsKeywordOrIdentifier(type)) {
        name = this.state.value;
      } else {
        this.unexpected();
      }
      const tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);
      if (liberal) {
        if (tokenIsKeyword) {
          this.replaceToken(130);
        }
      } else {
        this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
      }
      this.next();
      return name;
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (word.length > 10) {
        return;
      }
      if (!canBeReservedWord(word)) {
        return;
      }
      if (checkKeywords && isKeyword(word)) {
        this.raise(Errors.UnexpectedKeyword, {at: startLoc, keyword: word});
        return;
      }
      const reservedTest = !this.state.strict
        ? isReservedWord
        : isBinding
          ? isStrictBindReservedWord
          : isStrictReservedWord;
      if (reservedTest(word, this.inModule)) {
        this.raise(Errors.UnexpectedReservedWord, {
          at: startLoc,
          reservedWord: word,
        });
        return;
      } else if (word === 'yield') {
        if (this.prodParam.hasYield) {
          this.raise(Errors.YieldBindingIdentifier, {at: startLoc});
          return;
        }
      } else if (word === 'await') {
        if (this.prodParam.hasAwait) {
          this.raise(Errors.AwaitBindingIdentifier, {at: startLoc});
          return;
        }
        if (this.scope.inStaticBlock) {
          this.raise(Errors.AwaitBindingIdentifierInStaticBlock, {
            at: startLoc,
          });
          return;
        }
        this.expressionScope.recordAsyncArrowParametersError({at: startLoc});
      } else if (word === 'arguments') {
        if (this.scope.inClassAndNotInNonArrowFunction) {
          this.raise(Errors.ArgumentsInClass, {at: startLoc});
          return;
        }
      }
    }
    isAwaitAllowed() {
      if (this.prodParam.hasAwait) return true;
      if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
        return true;
      }
      return false;
    }
    parseAwait(startLoc) {
      const node = this.startNodeAt(startLoc);
      this.expressionScope.recordParameterInitializerError(
        Errors.AwaitExpressionFormalParameter,
        {at: node}
      );
      if (this.eat(55)) {
        this.raise(Errors.ObsoleteAwaitStar, {at: node});
      }
      if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
        if (this.isAmbiguousAwait()) {
          this.ambiguousScriptDifferentAst = true;
        } else {
          this.sawUnambiguousESM = true;
        }
      }
      if (!this.state.soloAwait) {
        node.argument = this.parseMaybeUnary(null, true);
      }
      return this.finishNode(node, 'AwaitExpression');
    }
    isAmbiguousAwait() {
      if (this.hasPrecedingLineBreak()) return true;
      const {type: type} = this.state;
      return (
        type === 53 ||
        type === 10 ||
        type === 0 ||
        tokenIsTemplate(type) ||
        (type === 101 && !this.state.containsEsc) ||
        type === 135 ||
        type === 56 ||
        (this.hasPlugin('v8intrinsic') && type === 54)
      );
    }
    parseYield() {
      const node = this.startNode();
      this.expressionScope.recordParameterInitializerError(
        Errors.YieldInParameter,
        {at: node}
      );
      this.next();
      let delegating = false;
      let argument = null;
      if (!this.hasPrecedingLineBreak()) {
        delegating = this.eat(55);
        switch (this.state.type) {
          case 13:
          case 137:
          case 8:
          case 11:
          case 3:
          case 9:
          case 14:
          case 12:
            if (!delegating) break;
          default:
            argument = this.parseMaybeAssign();
        }
      }
      node.delegate = delegating;
      node.argument = argument;
      return this.finishNode(node, 'YieldExpression');
    }
    checkPipelineAtInfixOperator(left, leftStartLoc) {
      if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
        if (left.type === 'SequenceExpression') {
          this.raise(Errors.PipelineHeadSequenceExpression, {at: leftStartLoc});
        }
      }
    }
    parseSmartPipelineBodyInStyle(childExpr, startLoc) {
      if (this.isSimpleReference(childExpr)) {
        const bodyNode = this.startNodeAt(startLoc);
        bodyNode.callee = childExpr;
        return this.finishNode(bodyNode, 'PipelineBareFunction');
      } else {
        const bodyNode = this.startNodeAt(startLoc);
        this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
        bodyNode.expression = childExpr;
        return this.finishNode(bodyNode, 'PipelineTopicExpression');
      }
    }
    isSimpleReference(expression) {
      switch (expression.type) {
        case 'MemberExpression':
          return (
            !expression.computed && this.isSimpleReference(expression.object)
          );
        case 'Identifier':
          return true;
        default:
          return false;
      }
    }
    checkSmartPipeTopicBodyEarlyErrors(startLoc) {
      if (this.match(19)) {
        throw this.raise(Errors.PipelineBodyNoArrow, {at: this.state.startLoc});
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipelineTopicUnused, {at: startLoc});
      }
    }
    withTopicBindingContext(callback) {
      const outerContextTopicState = this.state.topicContext;
      this.state.topicContext = {
        maxNumOfResolvableTopics: 1,
        maxTopicIndex: null,
      };
      try {
        return callback();
      } finally {
        this.state.topicContext = outerContextTopicState;
      }
    }
    withSmartMixTopicForbiddingContext(callback) {
      if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
        const outerContextTopicState = this.state.topicContext;
        this.state.topicContext = {
          maxNumOfResolvableTopics: 0,
          maxTopicIndex: null,
        };
        try {
          return callback();
        } finally {
          this.state.topicContext = outerContextTopicState;
        }
      } else {
        return callback();
      }
    }
    withSoloAwaitPermittingContext(callback) {
      const outerContextSoloAwaitState = this.state.soloAwait;
      this.state.soloAwait = true;
      try {
        return callback();
      } finally {
        this.state.soloAwait = outerContextSoloAwaitState;
      }
    }
    allowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToSet = PARAM_IN & ~flags;
      if (prodParamToSet) {
        this.prodParam.enter(flags | PARAM_IN);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    disallowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToClear = PARAM_IN & flags;
      if (prodParamToClear) {
        this.prodParam.enter(flags & ~PARAM_IN);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    registerTopicReference() {
      this.state.topicContext.maxTopicIndex = 0;
    }
    topicReferenceIsAllowedInCurrentContext() {
      return this.state.topicContext.maxNumOfResolvableTopics >= 1;
    }
    topicReferenceWasUsedInCurrentContext() {
      return (
        this.state.topicContext.maxTopicIndex != null &&
        this.state.topicContext.maxTopicIndex >= 0
      );
    }
    parseFSharpPipelineBody(prec) {
      const startLoc = this.state.startLoc;
      this.state.potentialArrowAt = this.state.start;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = true;
      const ret = this.parseExprOp(
        this.parseMaybeUnaryOrPrivate(),
        startLoc,
        prec
      );
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return ret;
    }
    parseModuleExpression() {
      this.expectPlugin('moduleBlocks');
      const node = this.startNode();
      this.next();
      if (!this.match(5)) {
        this.unexpected(null, 5);
      }
      const program = this.startNodeAt(this.state.endLoc);
      this.next();
      const revertScopes = this.initializeScopes(true);
      this.enterInitialScopes();
      try {
        node.body = this.parseProgram(program, 8, 'module');
      } finally {
        revertScopes();
      }
      return this.finishNode(node, 'ModuleExpression');
    }
    parsePropertyNamePrefixOperator(prop) {}
  }
  const loopLabel = {kind: 'loop'},
    switchLabel = {kind: 'switch'};
  const loneSurrogate = /[\uD800-\uDFFF]/u;
  const keywordRelationalOperator = /in(?:stanceof)?/y;
  function babel7CompatTokens(tokens, input) {
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      const {type: type} = token;
      if (typeof type === 'number') {
        {
          if (type === 136) {
            const {loc: loc, start: start, value: value, end: end} = token;
            const hashEndPos = start + 1;
            const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
            tokens.splice(
              i,
              1,
              new Token({
                type: getExportedToken(27),
                value: '#',
                start: start,
                end: hashEndPos,
                startLoc: loc.start,
                endLoc: hashEndLoc,
              }),
              new Token({
                type: getExportedToken(130),
                value: value,
                start: hashEndPos,
                end: end,
                startLoc: hashEndLoc,
                endLoc: loc.end,
              })
            );
            i++;
            continue;
          }
          if (tokenIsTemplate(type)) {
            const {loc: loc, start: start, value: value, end: end} = token;
            const backquoteEnd = start + 1;
            const backquoteEndLoc = createPositionWithColumnOffset(
              loc.start,
              1
            );
            let startToken;
            if (input.charCodeAt(start) === 96) {
              startToken = new Token({
                type: getExportedToken(22),
                value: '`',
                start: start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc,
              });
            } else {
              startToken = new Token({
                type: getExportedToken(8),
                value: '}',
                start: start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc,
              });
            }
            let templateValue,
              templateElementEnd,
              templateElementEndLoc,
              endToken;
            if (type === 24) {
              templateElementEnd = end - 1;
              templateElementEndLoc = createPositionWithColumnOffset(
                loc.end,
                -1
              );
              templateValue = value === null ? null : value.slice(1, -1);
              endToken = new Token({
                type: getExportedToken(22),
                value: '`',
                start: templateElementEnd,
                end: end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end,
              });
            } else {
              templateElementEnd = end - 2;
              templateElementEndLoc = createPositionWithColumnOffset(
                loc.end,
                -2
              );
              templateValue = value === null ? null : value.slice(1, -2);
              endToken = new Token({
                type: getExportedToken(23),
                value: '${',
                start: templateElementEnd,
                end: end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end,
              });
            }
            tokens.splice(
              i,
              1,
              startToken,
              new Token({
                type: getExportedToken(20),
                value: templateValue,
                start: backquoteEnd,
                end: templateElementEnd,
                startLoc: backquoteEndLoc,
                endLoc: templateElementEndLoc,
              }),
              endToken
            );
            i += 2;
            continue;
          }
        }
        token.type = getExportedToken(type);
      }
    }
    return tokens;
  }
  class StatementParser extends ExpressionParser {
    parseTopLevel(file, program) {
      file.program = this.parseProgram(program);
      file.comments = this.state.comments;
      if (this.options.tokens) {
        file.tokens = babel7CompatTokens(this.tokens, this.input);
      }
      return this.finishNode(file, 'File');
    }
    parseProgram(program, end = 137, sourceType = this.options.sourceType) {
      program.sourceType = sourceType;
      program.interpreter = this.parseInterpreterDirective();
      this.parseBlockBody(program, true, true, end);
      if (
        this.inModule &&
        !this.options.allowUndeclaredExports &&
        this.scope.undefinedExports.size > 0
      ) {
        for (const [localName, at] of Array.from(this.scope.undefinedExports)) {
          this.raise(Errors.ModuleExportUndefined, {
            at: at,
            localName: localName,
          });
        }
      }
      let finishedProgram;
      if (end === 137) {
        finishedProgram = this.finishNode(program, 'Program');
      } else {
        finishedProgram = this.finishNodeAt(
          program,
          'Program',
          createPositionWithColumnOffset(this.state.startLoc, -1)
        );
      }
      return finishedProgram;
    }
    stmtToDirective(stmt) {
      const directive = stmt;
      directive.type = 'Directive';
      directive.value = directive.expression;
      delete directive.expression;
      const directiveLiteral = directive.value;
      const expressionValue = directiveLiteral.value;
      const raw = this.input.slice(
        directiveLiteral.start,
        directiveLiteral.end
      );
      const val = (directiveLiteral.value = raw.slice(1, -1));
      this.addExtra(directiveLiteral, 'raw', raw);
      this.addExtra(directiveLiteral, 'rawValue', val);
      this.addExtra(directiveLiteral, 'expressionValue', expressionValue);
      directiveLiteral.type = 'DirectiveLiteral';
      return directive;
    }
    parseInterpreterDirective() {
      if (!this.match(28)) {
        return null;
      }
      const node = this.startNode();
      node.value = this.state.value;
      this.next();
      return this.finishNode(node, 'InterpreterDirective');
    }
    isLet() {
      if (!this.isContextual(99)) {
        return false;
      }
      return this.hasFollowingBindingAtom();
    }
    chStartsBindingIdentifier(ch, pos) {
      if (isIdentifierStart(ch)) {
        keywordRelationalOperator.lastIndex = pos;
        if (keywordRelationalOperator.test(this.input)) {
          const endCh = this.codePointAtPos(
            keywordRelationalOperator.lastIndex
          );
          if (!isIdentifierChar(endCh) && endCh !== 92) {
            return false;
          }
        }
        return true;
      } else if (ch === 92) {
        return true;
      } else {
        return false;
      }
    }
    chStartsBindingPattern(ch) {
      return ch === 91 || ch === 123;
    }
    hasFollowingBindingAtom() {
      const next = this.nextTokenStart();
      const nextCh = this.codePointAtPos(next);
      return (
        this.chStartsBindingPattern(nextCh) ||
        this.chStartsBindingIdentifier(nextCh, next)
      );
    }
    hasInLineFollowingBindingIdentifier() {
      const next = this.nextTokenInLineStart();
      const nextCh = this.codePointAtPos(next);
      return this.chStartsBindingIdentifier(nextCh, next);
    }
    startsUsingForOf() {
      const {type: type, containsEsc: containsEsc} = this.lookahead();
      if (type === 101 && !containsEsc) {
        return false;
      } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
        this.expectPlugin('explicitResourceManagement');
        return true;
      }
    }
    parseModuleItem() {
      return this.parseStatementLike(1 | 2 | 4 | 8);
    }
    parseStatementListItem() {
      return this.parseStatementLike(
        2 | 4 | (!this.options.annexB || this.state.strict ? 0 : 8)
      );
    }
    parseStatementOrSloppyAnnexBFunctionDeclaration(
      allowLabeledFunction = false
    ) {
      let flags = 0;
      if (this.options.annexB && !this.state.strict) {
        flags |= 4;
        if (allowLabeledFunction) {
          flags |= 8;
        }
      }
      return this.parseStatementLike(flags);
    }
    parseStatement() {
      return this.parseStatementLike(0);
    }
    parseStatementLike(flags) {
      let decorators = null;
      if (this.match(26)) {
        decorators = this.parseDecorators(true);
      }
      return this.parseStatementContent(flags, decorators);
    }
    parseStatementContent(flags, decorators) {
      const starttype = this.state.type;
      const node = this.startNode();
      const allowDeclaration = !!(flags & 2);
      const allowFunctionDeclaration = !!(flags & 4);
      const topLevel = flags & 1;
      switch (starttype) {
        case 60:
          return this.parseBreakContinueStatement(node, true);
        case 63:
          return this.parseBreakContinueStatement(node, false);
        case 64:
          return this.parseDebuggerStatement(node);
        case 90:
          return this.parseDoWhileStatement(node);
        case 91:
          return this.parseForStatement(node);
        case 68:
          if (this.lookaheadCharCode() === 46) break;
          if (!allowFunctionDeclaration) {
            this.raise(
              this.state.strict
                ? Errors.StrictFunction
                : this.options.annexB
                  ? Errors.SloppyFunctionAnnexB
                  : Errors.SloppyFunction,
              {at: this.state.startLoc}
            );
          }
          return this.parseFunctionStatement(
            node,
            false,
            !allowDeclaration && allowFunctionDeclaration
          );
        case 80:
          if (!allowDeclaration) this.unexpected();
          return this.parseClass(
            this.maybeTakeDecorators(decorators, node),
            true
          );
        case 69:
          return this.parseIfStatement(node);
        case 70:
          return this.parseReturnStatement(node);
        case 71:
          return this.parseSwitchStatement(node);
        case 72:
          return this.parseThrowStatement(node);
        case 73:
          return this.parseTryStatement(node);
        case 105:
          if (
            this.state.containsEsc ||
            !this.hasInLineFollowingBindingIdentifier()
          ) {
            break;
          }
          this.expectPlugin('explicitResourceManagement');
          if (!this.scope.inModule && this.scope.inTopLevel) {
            this.raise(Errors.UnexpectedUsingDeclaration, {
              at: this.state.startLoc,
            });
          } else if (!allowDeclaration) {
            this.raise(Errors.UnexpectedLexicalDeclaration, {
              at: this.state.startLoc,
            });
          }
          return this.parseVarStatement(node, 'using');
        case 99: {
          if (this.state.containsEsc) {
            break;
          }
          const next = this.nextTokenStart();
          const nextCh = this.codePointAtPos(next);
          if (nextCh !== 91) {
            if (!allowDeclaration && this.hasFollowingLineBreak()) break;
            if (
              !this.chStartsBindingIdentifier(nextCh, next) &&
              nextCh !== 123
            ) {
              break;
            }
          }
        }
        case 75: {
          if (!allowDeclaration) {
            this.raise(Errors.UnexpectedLexicalDeclaration, {
              at: this.state.startLoc,
            });
          }
        }
        case 74: {
          const kind = this.state.value;
          return this.parseVarStatement(node, kind);
        }
        case 92:
          return this.parseWhileStatement(node);
        case 76:
          return this.parseWithStatement(node);
        case 5:
          return this.parseBlock();
        case 13:
          return this.parseEmptyStatement(node);
        case 83: {
          const nextTokenCharCode = this.lookaheadCharCode();
          if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
            break;
          }
        }
        case 82: {
          if (!this.options.allowImportExportEverywhere && !topLevel) {
            this.raise(Errors.UnexpectedImportExport, {
              at: this.state.startLoc,
            });
          }
          this.next();
          let result;
          if (starttype === 83) {
            result = this.parseImport(node);
            if (
              result.type === 'ImportDeclaration' &&
              (!result.importKind || result.importKind === 'value')
            ) {
              this.sawUnambiguousESM = true;
            }
          } else {
            result = this.parseExport(node, decorators);
            if (
              (result.type === 'ExportNamedDeclaration' &&
                (!result.exportKind || result.exportKind === 'value')) ||
              (result.type === 'ExportAllDeclaration' &&
                (!result.exportKind || result.exportKind === 'value')) ||
              result.type === 'ExportDefaultDeclaration'
            ) {
              this.sawUnambiguousESM = true;
            }
          }
          this.assertModuleNodeAllowed(result);
          return result;
        }
        default: {
          if (this.isAsyncFunction()) {
            if (!allowDeclaration) {
              this.raise(Errors.AsyncFunctionInSingleStatementContext, {
                at: this.state.startLoc,
              });
            }
            this.next();
            return this.parseFunctionStatement(
              node,
              true,
              !allowDeclaration && allowFunctionDeclaration
            );
          }
        }
      }
      const maybeName = this.state.value;
      const expr = this.parseExpression();
      if (
        tokenIsIdentifier(starttype) &&
        expr.type === 'Identifier' &&
        this.eat(14)
      ) {
        return this.parseLabeledStatement(node, maybeName, expr, flags);
      } else {
        return this.parseExpressionStatement(node, expr, decorators);
      }
    }
    assertModuleNodeAllowed(node) {
      if (!this.options.allowImportExportEverywhere && !this.inModule) {
        this.raise(Errors.ImportOutsideModule, {at: node});
      }
    }
    decoratorsEnabledBeforeExport() {
      if (this.hasPlugin('decorators-legacy')) return true;
      return (
        this.hasPlugin('decorators') &&
        this.getPluginOption('decorators', 'decoratorsBeforeExport') !== false
      );
    }
    maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
      if (maybeDecorators) {
        if (classNode.decorators && classNode.decorators.length > 0) {
          if (
            typeof this.getPluginOption(
              'decorators',
              'decoratorsBeforeExport'
            ) !== 'boolean'
          ) {
            this.raise(Errors.DecoratorsBeforeAfterExport, {
              at: classNode.decorators[0],
            });
          }
          classNode.decorators.unshift(...maybeDecorators);
        } else {
          classNode.decorators = maybeDecorators;
        }
        this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
        if (exportNode) this.resetStartLocationFromNode(exportNode, classNode);
      }
      return classNode;
    }
    canHaveLeadingDecorator() {
      return this.match(80);
    }
    parseDecorators(allowExport) {
      const decorators = [];
      do {
        decorators.push(this.parseDecorator());
      } while (this.match(26));
      if (this.match(82)) {
        if (!allowExport) {
          this.unexpected();
        }
        if (!this.decoratorsEnabledBeforeExport()) {
          this.raise(Errors.DecoratorExportClass, {at: this.state.startLoc});
        }
      } else if (!this.canHaveLeadingDecorator()) {
        throw this.raise(Errors.UnexpectedLeadingDecorator, {
          at: this.state.startLoc,
        });
      }
      return decorators;
    }
    parseDecorator() {
      this.expectOnePlugin(['decorators', 'decorators-legacy']);
      const node = this.startNode();
      this.next();
      if (this.hasPlugin('decorators')) {
        const startLoc = this.state.startLoc;
        let expr;
        if (this.match(10)) {
          const startLoc = this.state.startLoc;
          this.next();
          expr = this.parseExpression();
          this.expect(11);
          expr = this.wrapParenthesis(startLoc, expr);
          const paramsStartLoc = this.state.startLoc;
          node.expression = this.parseMaybeDecoratorArguments(expr);
          if (
            this.getPluginOption('decorators', 'allowCallParenthesized') ===
              false &&
            node.expression !== expr
          ) {
            this.raise(Errors.DecoratorArgumentsOutsideParentheses, {
              at: paramsStartLoc,
            });
          }
        } else {
          expr = this.parseIdentifier(false);
          while (this.eat(16)) {
            const node = this.startNodeAt(startLoc);
            node.object = expr;
            if (this.match(136)) {
              this.classScope.usePrivateName(
                this.state.value,
                this.state.startLoc
              );
              node.property = this.parsePrivateName();
            } else {
              node.property = this.parseIdentifier(true);
            }
            node.computed = false;
            expr = this.finishNode(node, 'MemberExpression');
          }
          node.expression = this.parseMaybeDecoratorArguments(expr);
        }
      } else {
        node.expression = this.parseExprSubscripts();
      }
      return this.finishNode(node, 'Decorator');
    }
    parseMaybeDecoratorArguments(expr) {
      if (this.eat(10)) {
        const node = this.startNodeAtNode(expr);
        node.callee = expr;
        node.arguments = this.parseCallExpressionArguments(11, false);
        this.toReferencedList(node.arguments);
        return this.finishNode(node, 'CallExpression');
      }
      return expr;
    }
    parseBreakContinueStatement(node, isBreak) {
      this.next();
      if (this.isLineTerminator()) {
        node.label = null;
      } else {
        node.label = this.parseIdentifier();
        this.semicolon();
      }
      this.verifyBreakContinue(node, isBreak);
      return this.finishNode(
        node,
        isBreak ? 'BreakStatement' : 'ContinueStatement'
      );
    }
    verifyBreakContinue(node, isBreak) {
      let i;
      for (i = 0; i < this.state.labels.length; ++i) {
        const lab = this.state.labels[i];
        if (node.label == null || lab.name === node.label.name) {
          if (lab.kind != null && (isBreak || lab.kind === 'loop')) break;
          if (node.label && isBreak) break;
        }
      }
      if (i === this.state.labels.length) {
        const type = isBreak ? 'BreakStatement' : 'ContinueStatement';
        this.raise(Errors.IllegalBreakContinue, {at: node, type: type});
      }
    }
    parseDebuggerStatement(node) {
      this.next();
      this.semicolon();
      return this.finishNode(node, 'DebuggerStatement');
    }
    parseHeaderExpression() {
      this.expect(10);
      const val = this.parseExpression();
      this.expect(11);
      return val;
    }
    parseDoWhileStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.state.labels.pop();
      this.expect(92);
      node.test = this.parseHeaderExpression();
      this.eat(13);
      return this.finishNode(node, 'DoWhileStatement');
    }
    parseForStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      let awaitAt = null;
      if (this.isAwaitAllowed() && this.eatContextual(96)) {
        awaitAt = this.state.lastTokStartLoc;
      }
      this.scope.enter(SCOPE_OTHER);
      this.expect(10);
      if (this.match(13)) {
        if (awaitAt !== null) {
          this.unexpected(awaitAt);
        }
        return this.parseFor(node, null);
      }
      const startsWithLet = this.isContextual(99);
      const startsWithUsing = this.isContextual(105);
      const isLetOrUsing =
        (startsWithLet && this.hasFollowingBindingAtom()) ||
        (startsWithUsing && this.startsUsingForOf());
      if (this.match(74) || this.match(75) || isLetOrUsing) {
        const initNode = this.startNode();
        const kind = this.state.value;
        this.next();
        this.parseVar(initNode, true, kind);
        const init = this.finishNode(initNode, 'VariableDeclaration');
        const isForIn = this.match(58);
        if (isForIn && startsWithUsing) {
          this.raise(Errors.ForInUsing, {at: init});
        }
        if (
          (isForIn || this.isContextual(101)) &&
          init.declarations.length === 1
        ) {
          return this.parseForIn(node, init, awaitAt);
        }
        if (awaitAt !== null) {
          this.unexpected(awaitAt);
        }
        return this.parseFor(node, init);
      }
      const startsWithAsync = this.isContextual(95);
      const refExpressionErrors = new ExpressionErrors();
      const init = this.parseExpression(true, refExpressionErrors);
      const isForOf = this.isContextual(101);
      if (isForOf) {
        if (startsWithLet) {
          this.raise(Errors.ForOfLet, {at: init});
        }
        if (awaitAt === null && startsWithAsync && init.type === 'Identifier') {
          this.raise(Errors.ForOfAsync, {at: init});
        }
      }
      if (isForOf || this.match(58)) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.toAssignable(init, true);
        const type = isForOf ? 'ForOfStatement' : 'ForInStatement';
        this.checkLVal(init, {in: {type: type}});
        return this.parseForIn(node, init, awaitAt);
      } else {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      if (awaitAt !== null) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, init);
    }
    parseFunctionStatement(node, isAsync, isHangingDeclaration) {
      this.next();
      return this.parseFunction(
        node,
        1 | (isHangingDeclaration ? 2 : 0) | (isAsync ? 8 : 0)
      );
    }
    parseIfStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
      node.alternate = this.eat(66)
        ? this.parseStatementOrSloppyAnnexBFunctionDeclaration()
        : null;
      return this.finishNode(node, 'IfStatement');
    }
    parseReturnStatement(node) {
      if (
        !this.prodParam.hasReturn &&
        !this.options.allowReturnOutsideFunction
      ) {
        this.raise(Errors.IllegalReturn, {at: this.state.startLoc});
      }
      this.next();
      if (this.isLineTerminator()) {
        node.argument = null;
      } else {
        node.argument = this.parseExpression();
        this.semicolon();
      }
      return this.finishNode(node, 'ReturnStatement');
    }
    parseSwitchStatement(node) {
      this.next();
      node.discriminant = this.parseHeaderExpression();
      const cases = (node.cases = []);
      this.expect(5);
      this.state.labels.push(switchLabel);
      this.scope.enter(SCOPE_OTHER);
      let cur;
      for (let sawDefault; !this.match(8); ) {
        if (this.match(61) || this.match(65)) {
          const isCase = this.match(61);
          if (cur) this.finishNode(cur, 'SwitchCase');
          cases.push((cur = this.startNode()));
          cur.consequent = [];
          this.next();
          if (isCase) {
            cur.test = this.parseExpression();
          } else {
            if (sawDefault) {
              this.raise(Errors.MultipleDefaultsInSwitch, {
                at: this.state.lastTokStartLoc,
              });
            }
            sawDefault = true;
            cur.test = null;
          }
          this.expect(14);
        } else {
          if (cur) {
            cur.consequent.push(this.parseStatementListItem());
          } else {
            this.unexpected();
          }
        }
      }
      this.scope.exit();
      if (cur) this.finishNode(cur, 'SwitchCase');
      this.next();
      this.state.labels.pop();
      return this.finishNode(node, 'SwitchStatement');
    }
    parseThrowStatement(node) {
      this.next();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.NewlineAfterThrow, {at: this.state.lastTokEndLoc});
      }
      node.argument = this.parseExpression();
      this.semicolon();
      return this.finishNode(node, 'ThrowStatement');
    }
    parseCatchClauseParam() {
      const param = this.parseBindingAtom();
      this.scope.enter(
        this.options.annexB && param.type === 'Identifier'
          ? SCOPE_SIMPLE_CATCH
          : 0
      );
      this.checkLVal(param, {
        in: {type: 'CatchClause'},
        binding: BIND_CATCH_PARAM,
      });
      return param;
    }
    parseTryStatement(node) {
      this.next();
      node.block = this.parseBlock();
      node.handler = null;
      if (this.match(62)) {
        const clause = this.startNode();
        this.next();
        if (this.match(10)) {
          this.expect(10);
          clause.param = this.parseCatchClauseParam();
          this.expect(11);
        } else {
          clause.param = null;
          this.scope.enter(SCOPE_OTHER);
        }
        clause.body = this.withSmartMixTopicForbiddingContext(() =>
          this.parseBlock(false, false)
        );
        this.scope.exit();
        node.handler = this.finishNode(clause, 'CatchClause');
      }
      node.finalizer = this.eat(67) ? this.parseBlock() : null;
      if (!node.handler && !node.finalizer) {
        this.raise(Errors.NoCatchOrFinally, {at: node});
      }
      return this.finishNode(node, 'TryStatement');
    }
    parseVarStatement(node, kind, allowMissingInitializer = false) {
      this.next();
      this.parseVar(node, false, kind, allowMissingInitializer);
      this.semicolon();
      return this.finishNode(node, 'VariableDeclaration');
    }
    parseWhileStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.state.labels.pop();
      return this.finishNode(node, 'WhileStatement');
    }
    parseWithStatement(node) {
      if (this.state.strict) {
        this.raise(Errors.StrictWith, {at: this.state.startLoc});
      }
      this.next();
      node.object = this.parseHeaderExpression();
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      return this.finishNode(node, 'WithStatement');
    }
    parseEmptyStatement(node) {
      this.next();
      return this.finishNode(node, 'EmptyStatement');
    }
    parseLabeledStatement(node, maybeName, expr, flags) {
      for (const label of this.state.labels) {
        if (label.name === maybeName) {
          this.raise(Errors.LabelRedeclaration, {
            at: expr,
            labelName: maybeName,
          });
        }
      }
      const kind = tokenIsLoop(this.state.type)
        ? 'loop'
        : this.match(71)
          ? 'switch'
          : null;
      for (let i = this.state.labels.length - 1; i >= 0; i--) {
        const label = this.state.labels[i];
        if (label.statementStart === node.start) {
          label.statementStart = this.state.start;
          label.kind = kind;
        } else {
          break;
        }
      }
      this.state.labels.push({
        name: maybeName,
        kind: kind,
        statementStart: this.state.start,
      });
      node.body =
        flags & 8
          ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true)
          : this.parseStatement();
      this.state.labels.pop();
      node.label = expr;
      return this.finishNode(node, 'LabeledStatement');
    }
    parseExpressionStatement(node, expr, decorators) {
      node.expression = expr;
      this.semicolon();
      return this.finishNode(node, 'ExpressionStatement');
    }
    parseBlock(
      allowDirectives = false,
      createNewLexicalScope = true,
      afterBlockParse
    ) {
      const node = this.startNode();
      if (allowDirectives) {
        this.state.strictErrors.clear();
      }
      this.expect(5);
      if (createNewLexicalScope) {
        this.scope.enter(SCOPE_OTHER);
      }
      this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
      if (createNewLexicalScope) {
        this.scope.exit();
      }
      return this.finishNode(node, 'BlockStatement');
    }
    isValidDirective(stmt) {
      return (
        stmt.type === 'ExpressionStatement' &&
        stmt.expression.type === 'StringLiteral' &&
        !stmt.expression.extra.parenthesized
      );
    }
    parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
      const body = (node.body = []);
      const directives = (node.directives = []);
      this.parseBlockOrModuleBlockBody(
        body,
        allowDirectives ? directives : undefined,
        topLevel,
        end,
        afterBlockParse
      );
    }
    parseBlockOrModuleBlockBody(
      body,
      directives,
      topLevel,
      end,
      afterBlockParse
    ) {
      const oldStrict = this.state.strict;
      let hasStrictModeDirective = false;
      let parsedNonDirective = false;
      while (!this.match(end)) {
        const stmt = topLevel
          ? this.parseModuleItem()
          : this.parseStatementListItem();
        if (directives && !parsedNonDirective) {
          if (this.isValidDirective(stmt)) {
            const directive = this.stmtToDirective(stmt);
            directives.push(directive);
            if (
              !hasStrictModeDirective &&
              directive.value.value === 'use strict'
            ) {
              hasStrictModeDirective = true;
              this.setStrict(true);
            }
            continue;
          }
          parsedNonDirective = true;
          this.state.strictErrors.clear();
        }
        body.push(stmt);
      }
      if (afterBlockParse) {
        afterBlockParse.call(this, hasStrictModeDirective);
      }
      if (!oldStrict) {
        this.setStrict(false);
      }
      this.next();
    }
    parseFor(node, init) {
      node.init = init;
      this.semicolon(false);
      node.test = this.match(13) ? null : this.parseExpression();
      this.semicolon(false);
      node.update = this.match(11) ? null : this.parseExpression();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(node, 'ForStatement');
    }
    parseForIn(node, init, awaitAt) {
      const isForIn = this.match(58);
      this.next();
      if (isForIn) {
        if (awaitAt !== null) this.unexpected(awaitAt);
      } else {
        node.await = awaitAt !== null;
      }
      if (
        init.type === 'VariableDeclaration' &&
        init.declarations[0].init != null &&
        (!isForIn ||
          !this.options.annexB ||
          this.state.strict ||
          init.kind !== 'var' ||
          init.declarations[0].id.type !== 'Identifier')
      ) {
        this.raise(Errors.ForInOfLoopInitializer, {
          at: init,
          type: isForIn ? 'ForInStatement' : 'ForOfStatement',
        });
      }
      if (init.type === 'AssignmentPattern') {
        this.raise(Errors.InvalidLhs, {
          at: init,
          ancestor: {type: 'ForStatement'},
        });
      }
      node.left = init;
      node.right = isForIn
        ? this.parseExpression()
        : this.parseMaybeAssignAllowIn();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(
        node,
        isForIn ? 'ForInStatement' : 'ForOfStatement'
      );
    }
    parseVar(node, isFor, kind, allowMissingInitializer = false) {
      const declarations = (node.declarations = []);
      node.kind = kind;
      for (;;) {
        const decl = this.startNode();
        this.parseVarId(decl, kind);
        decl.init = !this.eat(29)
          ? null
          : isFor
            ? this.parseMaybeAssignDisallowIn()
            : this.parseMaybeAssignAllowIn();
        if (decl.init === null && !allowMissingInitializer) {
          if (
            decl.id.type !== 'Identifier' &&
            !(isFor && (this.match(58) || this.isContextual(101)))
          ) {
            this.raise(Errors.DeclarationMissingInitializer, {
              at: this.state.lastTokEndLoc,
              kind: 'destructuring',
            });
          } else if (
            kind === 'const' &&
            !(this.match(58) || this.isContextual(101))
          ) {
            this.raise(Errors.DeclarationMissingInitializer, {
              at: this.state.lastTokEndLoc,
              kind: 'const',
            });
          }
        }
        declarations.push(this.finishNode(decl, 'VariableDeclarator'));
        if (!this.eat(12)) break;
      }
      return node;
    }
    parseVarId(decl, kind) {
      if (kind === 'using' && !this.inModule && this.match(96)) {
        this.raise(Errors.AwaitInUsingBinding, {at: this.state.startLoc});
      }
      const id = this.parseBindingAtom();
      this.checkLVal(id, {
        in: {type: 'VariableDeclarator'},
        binding: kind === 'var' ? BIND_VAR : BIND_LEXICAL,
      });
      decl.id = id;
    }
    parseAsyncFunctionExpression(node) {
      return this.parseFunction(node, 8);
    }
    parseFunction(node, flags = 0) {
      const hangingDeclaration = flags & 2;
      const isDeclaration = !!(flags & 1);
      const requireId = isDeclaration && !(flags & 4);
      const isAsync = !!(flags & 8);
      this.initFunction(node, isAsync);
      if (this.match(55)) {
        if (hangingDeclaration) {
          this.raise(Errors.GeneratorInSingleStatementContext, {
            at: this.state.startLoc,
          });
        }
        this.next();
        node.generator = true;
      }
      if (isDeclaration) {
        node.id = this.parseFunctionId(requireId);
      }
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      this.state.maybeInArrowParameters = false;
      this.scope.enter(SCOPE_FUNCTION);
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      if (!isDeclaration) {
        node.id = this.parseFunctionId();
      }
      this.parseFunctionParams(node, false);
      this.withSmartMixTopicForbiddingContext(() => {
        this.parseFunctionBodyAndFinish(
          node,
          isDeclaration ? 'FunctionDeclaration' : 'FunctionExpression'
        );
      });
      this.prodParam.exit();
      this.scope.exit();
      if (isDeclaration && !hangingDeclaration) {
        this.registerFunctionStatementId(node);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return node;
    }
    parseFunctionId(requireId) {
      return requireId || tokenIsIdentifier(this.state.type)
        ? this.parseIdentifier()
        : null;
    }
    parseFunctionParams(node, isConstructor) {
      this.expect(10);
      this.expressionScope.enter(newParameterDeclarationScope());
      node.params = this.parseBindingList(11, 41, 2 | (isConstructor ? 4 : 0));
      this.expressionScope.exit();
    }
    registerFunctionStatementId(node) {
      if (!node.id) return;
      this.scope.declareName(
        node.id.name,
        !this.options.annexB ||
          this.state.strict ||
          node.generator ||
          node.async
          ? this.scope.treatFunctionsAsVar
            ? BIND_VAR
            : BIND_LEXICAL
          : BIND_FUNCTION,
        node.id.loc.start
      );
    }
    parseClass(node, isStatement, optionalId) {
      this.next();
      const oldStrict = this.state.strict;
      this.state.strict = true;
      this.parseClassId(node, isStatement, optionalId);
      this.parseClassSuper(node);
      node.body = this.parseClassBody(!!node.superClass, oldStrict);
      return this.finishNode(
        node,
        isStatement ? 'ClassDeclaration' : 'ClassExpression'
      );
    }
    isClassProperty() {
      return this.match(29) || this.match(13) || this.match(8);
    }
    isClassMethod() {
      return this.match(10);
    }
    isNonstaticConstructor(method) {
      return (
        !method.computed &&
        !method.static &&
        (method.key.name === 'constructor' ||
          method.key.value === 'constructor')
      );
    }
    parseClassBody(hadSuperClass, oldStrict) {
      this.classScope.enter();
      const state = {hadConstructor: false, hadSuperClass: hadSuperClass};
      let decorators = [];
      const classBody = this.startNode();
      classBody.body = [];
      this.expect(5);
      this.withSmartMixTopicForbiddingContext(() => {
        while (!this.match(8)) {
          if (this.eat(13)) {
            if (decorators.length > 0) {
              throw this.raise(Errors.DecoratorSemicolon, {
                at: this.state.lastTokEndLoc,
              });
            }
            continue;
          }
          if (this.match(26)) {
            decorators.push(this.parseDecorator());
            continue;
          }
          const member = this.startNode();
          if (decorators.length) {
            member.decorators = decorators;
            this.resetStartLocationFromNode(member, decorators[0]);
            decorators = [];
          }
          this.parseClassMember(classBody, member, state);
          if (
            member.kind === 'constructor' &&
            member.decorators &&
            member.decorators.length > 0
          ) {
            this.raise(Errors.DecoratorConstructor, {at: member});
          }
        }
      });
      this.state.strict = oldStrict;
      this.next();
      if (decorators.length) {
        throw this.raise(Errors.TrailingDecorator, {at: this.state.startLoc});
      }
      this.classScope.exit();
      return this.finishNode(classBody, 'ClassBody');
    }
    parseClassMemberFromModifier(classBody, member) {
      const key = this.parseIdentifier(true);
      if (this.isClassMethod()) {
        const method = member;
        method.kind = 'method';
        method.computed = false;
        method.key = key;
        method.static = false;
        this.pushClassMethod(classBody, method, false, false, false, false);
        return true;
      } else if (this.isClassProperty()) {
        const prop = member;
        prop.computed = false;
        prop.key = key;
        prop.static = false;
        classBody.body.push(this.parseClassProperty(prop));
        return true;
      }
      this.resetPreviousNodeTrailingComments(key);
      return false;
    }
    parseClassMember(classBody, member, state) {
      const isStatic = this.isContextual(104);
      if (isStatic) {
        if (this.parseClassMemberFromModifier(classBody, member)) {
          return;
        }
        if (this.eat(5)) {
          this.parseClassStaticBlock(classBody, member);
          return;
        }
      }
      this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
    }
    parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
      const publicMethod = member;
      const privateMethod = member;
      const publicProp = member;
      const privateProp = member;
      const accessorProp = member;
      const method = publicMethod;
      const publicMember = publicMethod;
      member.static = isStatic;
      this.parsePropertyNamePrefixOperator(member);
      if (this.eat(55)) {
        method.kind = 'method';
        const isPrivateName = this.match(136);
        this.parseClassElementName(method);
        if (isPrivateName) {
          this.pushClassPrivateMethod(classBody, privateMethod, true, false);
          return;
        }
        if (this.isNonstaticConstructor(publicMethod)) {
          this.raise(Errors.ConstructorIsGenerator, {at: publicMethod.key});
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          true,
          false,
          false,
          false
        );
        return;
      }
      const isContextual =
        tokenIsIdentifier(this.state.type) && !this.state.containsEsc;
      const isPrivate = this.match(136);
      const key = this.parseClassElementName(member);
      const maybeQuestionTokenStartLoc = this.state.startLoc;
      this.parsePostMemberNameModifiers(publicMember);
      if (this.isClassMethod()) {
        method.kind = 'method';
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
          return;
        }
        const isConstructor = this.isNonstaticConstructor(publicMethod);
        let allowsDirectSuper = false;
        if (isConstructor) {
          publicMethod.kind = 'constructor';
          if (state.hadConstructor && !this.hasPlugin('typescript')) {
            this.raise(Errors.DuplicateConstructor, {at: key});
          }
          if (
            isConstructor &&
            this.hasPlugin('typescript') &&
            member.override
          ) {
            this.raise(Errors.OverrideOnConstructor, {at: key});
          }
          state.hadConstructor = true;
          allowsDirectSuper = state.hadSuperClass;
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          false,
          false,
          isConstructor,
          allowsDirectSuper
        );
      } else if (this.isClassProperty()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else if (
        isContextual &&
        key.name === 'async' &&
        !this.isLineTerminator()
      ) {
        this.resetPreviousNodeTrailingComments(key);
        const isGenerator = this.eat(55);
        if (publicMember.optional) {
          this.unexpected(maybeQuestionTokenStartLoc);
        }
        method.kind = 'method';
        const isPrivate = this.match(136);
        this.parseClassElementName(method);
        this.parsePostMemberNameModifiers(publicMember);
        if (isPrivate) {
          this.pushClassPrivateMethod(
            classBody,
            privateMethod,
            isGenerator,
            true
          );
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAsync, {at: publicMethod.key});
          }
          this.pushClassMethod(
            classBody,
            publicMethod,
            isGenerator,
            true,
            false,
            false
          );
        }
      } else if (
        isContextual &&
        (key.name === 'get' || key.name === 'set') &&
        !(this.match(55) && this.isLineTerminator())
      ) {
        this.resetPreviousNodeTrailingComments(key);
        method.kind = key.name;
        const isPrivate = this.match(136);
        this.parseClassElementName(publicMethod);
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAccessor, {at: publicMethod.key});
          }
          this.pushClassMethod(
            classBody,
            publicMethod,
            false,
            false,
            false,
            false
          );
        }
        this.checkGetterSetterParams(publicMethod);
      } else if (
        isContextual &&
        key.name === 'accessor' &&
        !this.isLineTerminator()
      ) {
        this.expectPlugin('decoratorAutoAccessors');
        this.resetPreviousNodeTrailingComments(key);
        const isPrivate = this.match(136);
        this.parseClassElementName(publicProp);
        this.pushClassAccessorProperty(classBody, accessorProp, isPrivate);
      } else if (this.isLineTerminator()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else {
        this.unexpected();
      }
    }
    parseClassElementName(member) {
      const {type: type, value: value} = this.state;
      if (
        (type === 130 || type === 131) &&
        member.static &&
        value === 'prototype'
      ) {
        this.raise(Errors.StaticPrototype, {at: this.state.startLoc});
      }
      if (type === 136) {
        if (value === 'constructor') {
          this.raise(Errors.ConstructorClassPrivateField, {
            at: this.state.startLoc,
          });
        }
        const key = this.parsePrivateName();
        member.key = key;
        return key;
      }
      return this.parsePropertyName(member);
    }
    parseClassStaticBlock(classBody, member) {
      var _member$decorators;
      this.scope.enter(SCOPE_CLASS | SCOPE_STATIC_BLOCK | SCOPE_SUPER);
      const oldLabels = this.state.labels;
      this.state.labels = [];
      this.prodParam.enter(PARAM);
      const body = (member.body = []);
      this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
      this.prodParam.exit();
      this.scope.exit();
      this.state.labels = oldLabels;
      classBody.body.push(this.finishNode(member, 'StaticBlock'));
      if (
        (_member$decorators = member.decorators) != null &&
        _member$decorators.length
      ) {
        this.raise(Errors.DecoratorStaticBlock, {at: member});
      }
    }
    pushClassProperty(classBody, prop) {
      if (
        !prop.computed &&
        (prop.key.name === 'constructor' || prop.key.value === 'constructor')
      ) {
        this.raise(Errors.ConstructorClassField, {at: prop.key});
      }
      classBody.body.push(this.parseClassProperty(prop));
    }
    pushClassPrivateProperty(classBody, prop) {
      const node = this.parseClassPrivateProperty(prop);
      classBody.body.push(node);
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        CLASS_ELEMENT_OTHER,
        node.key.loc.start
      );
    }
    pushClassAccessorProperty(classBody, prop, isPrivate) {
      if (!isPrivate && !prop.computed) {
        const key = prop.key;
        if (key.name === 'constructor' || key.value === 'constructor') {
          this.raise(Errors.ConstructorClassField, {at: key});
        }
      }
      const node = this.parseClassAccessorProperty(prop);
      classBody.body.push(node);
      if (isPrivate) {
        this.classScope.declarePrivateName(
          this.getPrivateNameSV(node.key),
          CLASS_ELEMENT_OTHER,
          node.key.loc.start
        );
      }
    }
    pushClassMethod(
      classBody,
      method,
      isGenerator,
      isAsync,
      isConstructor,
      allowsDirectSuper
    ) {
      classBody.body.push(
        this.parseMethod(
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper,
          'ClassMethod',
          true
        )
      );
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      const node = this.parseMethod(
        method,
        isGenerator,
        isAsync,
        false,
        false,
        'ClassPrivateMethod',
        true
      );
      classBody.body.push(node);
      const kind =
        node.kind === 'get'
          ? node.static
            ? CLASS_ELEMENT_STATIC_GETTER
            : CLASS_ELEMENT_INSTANCE_GETTER
          : node.kind === 'set'
            ? node.static
              ? CLASS_ELEMENT_STATIC_SETTER
              : CLASS_ELEMENT_INSTANCE_SETTER
            : CLASS_ELEMENT_OTHER;
      this.declareClassPrivateMethodInScope(node, kind);
    }
    declareClassPrivateMethodInScope(node, kind) {
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        kind,
        node.key.loc.start
      );
    }
    parsePostMemberNameModifiers(methodOrProp) {}
    parseClassPrivateProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassPrivateProperty');
    }
    parseClassProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassProperty');
    }
    parseClassAccessorProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassAccessorProperty');
    }
    parseInitializer(node) {
      this.scope.enter(SCOPE_CLASS | SCOPE_SUPER);
      this.expressionScope.enter(newExpressionScope());
      this.prodParam.enter(PARAM);
      node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
      this.expressionScope.exit();
      this.prodParam.exit();
      this.scope.exit();
    }
    parseClassId(node, isStatement, optionalId, bindingType = BIND_CLASS) {
      if (tokenIsIdentifier(this.state.type)) {
        node.id = this.parseIdentifier();
        if (isStatement) {
          this.declareNameFromIdentifier(node.id, bindingType);
        }
      } else {
        if (optionalId || !isStatement) {
          node.id = null;
        } else {
          throw this.raise(Errors.MissingClassName, {at: this.state.startLoc});
        }
      }
    }
    parseClassSuper(node) {
      node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
    }
    parseExport(node, decorators) {
      const hasDefault = this.maybeParseExportDefaultSpecifier(node);
      const parseAfterDefault = !hasDefault || this.eat(12);
      const hasStar = parseAfterDefault && this.eatExportStar(node);
      const hasNamespace =
        hasStar && this.maybeParseExportNamespaceSpecifier(node);
      const parseAfterNamespace =
        parseAfterDefault && (!hasNamespace || this.eat(12));
      const isFromRequired = hasDefault || hasStar;
      if (hasStar && !hasNamespace) {
        if (hasDefault) this.unexpected();
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, {at: node});
        }
        this.parseExportFrom(node, true);
        return this.finishNode(node, 'ExportAllDeclaration');
      }
      const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
      if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
        this.unexpected(null, 5);
      }
      if (hasNamespace && parseAfterNamespace) {
        this.unexpected(null, 97);
      }
      let hasDeclaration;
      if (isFromRequired || hasSpecifiers) {
        hasDeclaration = false;
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, {at: node});
        }
        this.parseExportFrom(node, isFromRequired);
      } else {
        hasDeclaration = this.maybeParseExportDeclaration(node);
      }
      if (isFromRequired || hasSpecifiers || hasDeclaration) {
        var _node2$declaration;
        const node2 = node;
        this.checkExport(node2, true, false, !!node2.source);
        if (
          ((_node2$declaration = node2.declaration) == null
            ? void 0
            : _node2$declaration.type) === 'ClassDeclaration'
        ) {
          this.maybeTakeDecorators(decorators, node2.declaration, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, {at: node});
        }
        return this.finishNode(node2, 'ExportNamedDeclaration');
      }
      if (this.eat(65)) {
        const node2 = node;
        const decl = this.parseExportDefaultExpression();
        node2.declaration = decl;
        if (decl.type === 'ClassDeclaration') {
          this.maybeTakeDecorators(decorators, decl, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, {at: node});
        }
        this.checkExport(node2, true, true);
        return this.finishNode(node2, 'ExportDefaultDeclaration');
      }
      this.unexpected(null, 5);
    }
    eatExportStar(node) {
      return this.eat(55);
    }
    maybeParseExportDefaultSpecifier(node) {
      if (this.isExportDefaultSpecifier()) {
        this.expectPlugin('exportDefaultFrom');
        const specifier = this.startNode();
        specifier.exported = this.parseIdentifier(true);
        node.specifiers = [
          this.finishNode(specifier, 'ExportDefaultSpecifier'),
        ];
        return true;
      }
      return false;
    }
    maybeParseExportNamespaceSpecifier(node) {
      if (this.isContextual(93)) {
        if (!node.specifiers) node.specifiers = [];
        const specifier = this.startNodeAt(this.state.lastTokStartLoc);
        this.next();
        specifier.exported = this.parseModuleExportName();
        node.specifiers.push(
          this.finishNode(specifier, 'ExportNamespaceSpecifier')
        );
        return true;
      }
      return false;
    }
    maybeParseExportNamedSpecifiers(node) {
      if (this.match(5)) {
        if (!node.specifiers) node.specifiers = [];
        const isTypeExport = node.exportKind === 'type';
        node.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
        node.source = null;
        node.declaration = null;
        if (this.hasPlugin('importAssertions')) {
          node.assertions = [];
        }
        return true;
      }
      return false;
    }
    maybeParseExportDeclaration(node) {
      if (this.shouldParseExportDeclaration()) {
        node.specifiers = [];
        node.source = null;
        if (this.hasPlugin('importAssertions')) {
          node.assertions = [];
        }
        node.declaration = this.parseExportDeclaration(node);
        return true;
      }
      return false;
    }
    isAsyncFunction() {
      if (!this.isContextual(95)) return false;
      const next = this.nextTokenStart();
      return (
        !lineBreak.test(this.input.slice(this.state.pos, next)) &&
        this.isUnparsedContextual(next, 'function')
      );
    }
    parseExportDefaultExpression() {
      const expr = this.startNode();
      if (this.match(68)) {
        this.next();
        return this.parseFunction(expr, 1 | 4);
      } else if (this.isAsyncFunction()) {
        this.next();
        this.next();
        return this.parseFunction(expr, 1 | 4 | 8);
      }
      if (this.match(80)) {
        return this.parseClass(expr, true, true);
      }
      if (this.match(26)) {
        if (
          this.hasPlugin('decorators') &&
          this.getPluginOption('decorators', 'decoratorsBeforeExport') === true
        ) {
          this.raise(Errors.DecoratorBeforeExport, {at: this.state.startLoc});
        }
        return this.parseClass(
          this.maybeTakeDecorators(
            this.parseDecorators(false),
            this.startNode()
          ),
          true,
          true
        );
      }
      if (this.match(75) || this.match(74) || this.isLet()) {
        throw this.raise(Errors.UnsupportedDefaultExport, {
          at: this.state.startLoc,
        });
      }
      const res = this.parseMaybeAssignAllowIn();
      this.semicolon();
      return res;
    }
    parseExportDeclaration(node) {
      if (this.match(80)) {
        const node = this.parseClass(this.startNode(), true, false);
        return node;
      }
      return this.parseStatementListItem();
    }
    isExportDefaultSpecifier() {
      const {type: type} = this.state;
      if (tokenIsIdentifier(type)) {
        if ((type === 95 && !this.state.containsEsc) || type === 99) {
          return false;
        }
        if ((type === 128 || type === 127) && !this.state.containsEsc) {
          const {type: nextType} = this.lookahead();
          if (
            (tokenIsIdentifier(nextType) && nextType !== 97) ||
            nextType === 5
          ) {
            this.expectOnePlugin(['flow', 'typescript']);
            return false;
          }
        }
      } else if (!this.match(65)) {
        return false;
      }
      const next = this.nextTokenStart();
      const hasFrom = this.isUnparsedContextual(next, 'from');
      if (
        this.input.charCodeAt(next) === 44 ||
        (tokenIsIdentifier(this.state.type) && hasFrom)
      ) {
        return true;
      }
      if (this.match(65) && hasFrom) {
        const nextAfterFrom = this.input.charCodeAt(
          this.nextTokenStartSince(next + 4)
        );
        return nextAfterFrom === 34 || nextAfterFrom === 39;
      }
      return false;
    }
    parseExportFrom(node, expect) {
      if (this.eatContextual(97)) {
        node.source = this.parseImportSource();
        this.checkExport(node);
        const assertions = this.maybeParseImportAssertions();
        if (assertions) {
          node.assertions = assertions;
          this.checkJSONModuleImport(node);
        }
      } else if (expect) {
        this.unexpected();
      }
      this.semicolon();
    }
    shouldParseExportDeclaration() {
      const {type: type} = this.state;
      if (type === 26) {
        this.expectOnePlugin(['decorators', 'decorators-legacy']);
        if (this.hasPlugin('decorators')) {
          if (
            this.getPluginOption('decorators', 'decoratorsBeforeExport') ===
            true
          ) {
            this.raise(Errors.DecoratorBeforeExport, {at: this.state.startLoc});
          }
          return true;
        }
      }
      return (
        type === 74 ||
        type === 75 ||
        type === 68 ||
        type === 80 ||
        this.isLet() ||
        this.isAsyncFunction()
      );
    }
    checkExport(node, checkNames, isDefault, isFrom) {
      if (checkNames) {
        if (isDefault) {
          this.checkDuplicateExports(node, 'default');
          if (this.hasPlugin('exportDefaultFrom')) {
            var _declaration$extra;
            const declaration = node.declaration;
            if (
              declaration.type === 'Identifier' &&
              declaration.name === 'from' &&
              declaration.end - declaration.start === 4 &&
              !(
                (_declaration$extra = declaration.extra) != null &&
                _declaration$extra.parenthesized
              )
            ) {
              this.raise(Errors.ExportDefaultFromAsIdentifier, {
                at: declaration,
              });
            }
          }
        } else if (node.specifiers && node.specifiers.length) {
          for (const specifier of node.specifiers) {
            const {exported: exported} = specifier;
            const exportName =
              exported.type === 'Identifier' ? exported.name : exported.value;
            this.checkDuplicateExports(specifier, exportName);
            if (!isFrom && specifier.local) {
              const {local: local} = specifier;
              if (local.type !== 'Identifier') {
                this.raise(Errors.ExportBindingIsString, {
                  at: specifier,
                  localName: local.value,
                  exportName: exportName,
                });
              } else {
                this.checkReservedWord(
                  local.name,
                  local.loc.start,
                  true,
                  false
                );
                this.scope.checkLocalExport(local);
              }
            }
          }
        } else if (node.declaration) {
          if (
            node.declaration.type === 'FunctionDeclaration' ||
            node.declaration.type === 'ClassDeclaration'
          ) {
            const id = node.declaration.id;
            if (!id) throw new Error('Assertion failure');
            this.checkDuplicateExports(node, id.name);
          } else if (node.declaration.type === 'VariableDeclaration') {
            for (const declaration of node.declaration.declarations) {
              this.checkDeclaration(declaration.id);
            }
          }
        }
      }
    }
    checkDeclaration(node) {
      if (node.type === 'Identifier') {
        this.checkDuplicateExports(node, node.name);
      } else if (node.type === 'ObjectPattern') {
        for (const prop of node.properties) {
          this.checkDeclaration(prop);
        }
      } else if (node.type === 'ArrayPattern') {
        for (const elem of node.elements) {
          if (elem) {
            this.checkDeclaration(elem);
          }
        }
      } else if (node.type === 'ObjectProperty') {
        this.checkDeclaration(node.value);
      } else if (node.type === 'RestElement') {
        this.checkDeclaration(node.argument);
      } else if (node.type === 'AssignmentPattern') {
        this.checkDeclaration(node.left);
      }
    }
    checkDuplicateExports(node, exportName) {
      if (this.exportedIdentifiers.has(exportName)) {
        if (exportName === 'default') {
          this.raise(Errors.DuplicateDefaultExport, {at: node});
        } else {
          this.raise(Errors.DuplicateExport, {
            at: node,
            exportName: exportName,
          });
        }
      }
      this.exportedIdentifiers.add(exportName);
    }
    parseExportSpecifiers(isInTypeExport) {
      const nodes = [];
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.eat(8)) break;
        }
        const isMaybeTypeOnly = this.isContextual(128);
        const isString = this.match(131);
        const node = this.startNode();
        node.local = this.parseModuleExportName();
        nodes.push(
          this.parseExportSpecifier(
            node,
            isString,
            isInTypeExport,
            isMaybeTypeOnly
          )
        );
      }
      return nodes;
    }
    parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
      if (this.eatContextual(93)) {
        node.exported = this.parseModuleExportName();
      } else if (isString) {
        node.exported = cloneStringLiteral(node.local);
      } else if (!node.exported) {
        node.exported = cloneIdentifier(node.local);
      }
      return this.finishNode(node, 'ExportSpecifier');
    }
    parseModuleExportName() {
      if (this.match(131)) {
        const result = this.parseStringLiteral(this.state.value);
        const surrogate = result.value.match(loneSurrogate);
        if (surrogate) {
          this.raise(Errors.ModuleExportNameHasLoneSurrogate, {
            at: result,
            surrogateCharCode: surrogate[0].charCodeAt(0),
          });
        }
        return result;
      }
      return this.parseIdentifier(true);
    }
    isJSONModuleImport(node) {
      if (node.assertions != null) {
        return node.assertions.some(
          ({key: key, value: value}) =>
            value.value === 'json' &&
            (key.type === 'Identifier'
              ? key.name === 'type'
              : key.value === 'type')
        );
      }
      return false;
    }
    checkImportReflection(node) {
      if (node.module) {
        var _node$assertions;
        if (
          node.specifiers.length !== 1 ||
          node.specifiers[0].type !== 'ImportDefaultSpecifier'
        ) {
          this.raise(Errors.ImportReflectionNotBinding, {
            at: node.specifiers[0].loc.start,
          });
        }
        if (
          ((_node$assertions = node.assertions) == null
            ? void 0
            : _node$assertions.length) > 0
        ) {
          this.raise(Errors.ImportReflectionHasAssertion, {
            at: node.specifiers[0].loc.start,
          });
        }
      }
    }
    checkJSONModuleImport(node) {
      if (
        this.isJSONModuleImport(node) &&
        node.type !== 'ExportAllDeclaration'
      ) {
        const {specifiers: specifiers} = node;
        if (specifiers != null) {
          const nonDefaultNamedSpecifier = specifiers.find(specifier => {
            let imported;
            if (specifier.type === 'ExportSpecifier') {
              imported = specifier.local;
            } else if (specifier.type === 'ImportSpecifier') {
              imported = specifier.imported;
            }
            if (imported !== undefined) {
              return imported.type === 'Identifier'
                ? imported.name !== 'default'
                : imported.value !== 'default';
            }
          });
          if (nonDefaultNamedSpecifier !== undefined) {
            this.raise(Errors.ImportJSONBindingNotDefault, {
              at: nonDefaultNamedSpecifier.loc.start,
            });
          }
        }
      }
    }
    parseMaybeImportReflection(node) {
      let isImportReflection = false;
      if (this.isContextual(125)) {
        const lookahead = this.lookahead();
        const nextType = lookahead.type;
        if (tokenIsIdentifier(nextType)) {
          if (nextType !== 97) {
            isImportReflection = true;
          } else {
            const nextNextTokenFirstChar = this.input.charCodeAt(
              this.nextTokenStartSince(lookahead.end)
            );
            if (nextNextTokenFirstChar === 102) {
              isImportReflection = true;
            }
          }
        } else if (nextType !== 12) {
          isImportReflection = true;
        }
      }
      if (isImportReflection) {
        this.expectPlugin('importReflection');
        this.next();
        node.module = true;
      } else if (this.hasPlugin('importReflection')) {
        node.module = false;
      }
    }
    parseImport(node) {
      node.specifiers = [];
      if (!this.match(131)) {
        this.parseMaybeImportReflection(node);
        const hasDefault = this.maybeParseDefaultImportSpecifier(node);
        const parseNext = !hasDefault || this.eat(12);
        const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
        if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
        this.expectContextual(97);
      }
      node.source = this.parseImportSource();
      const assertions = this.maybeParseImportAssertions();
      if (assertions) {
        node.assertions = assertions;
      } else {
        const attributes = this.maybeParseModuleAttributes();
        if (attributes) {
          node.attributes = attributes;
        }
      }
      this.checkImportReflection(node);
      this.checkJSONModuleImport(node);
      this.semicolon();
      return this.finishNode(node, 'ImportDeclaration');
    }
    parseImportSource() {
      if (!this.match(131)) this.unexpected();
      return this.parseExprAtom();
    }
    shouldParseDefaultImport(node) {
      return tokenIsIdentifier(this.state.type);
    }
    parseImportSpecifierLocal(node, specifier, type) {
      specifier.local = this.parseIdentifier();
      node.specifiers.push(this.finishImportSpecifier(specifier, type));
    }
    finishImportSpecifier(specifier, type, bindingType = BIND_LEXICAL) {
      this.checkLVal(specifier.local, {in: {type: type}, binding: bindingType});
      return this.finishNode(specifier, type);
    }
    parseAssertEntries() {
      const attrs = [];
      const attrNames = new Set();
      do {
        if (this.match(8)) {
          break;
        }
        const node = this.startNode();
        const keyName = this.state.value;
        if (attrNames.has(keyName)) {
          this.raise(Errors.ModuleAttributesWithDuplicateKeys, {
            at: this.state.startLoc,
            key: keyName,
          });
        }
        attrNames.add(keyName);
        if (this.match(131)) {
          node.key = this.parseStringLiteral(keyName);
        } else {
          node.key = this.parseIdentifier(true);
        }
        this.expect(14);
        if (!this.match(131)) {
          throw this.raise(Errors.ModuleAttributeInvalidValue, {
            at: this.state.startLoc,
          });
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, 'ImportAttribute'));
      } while (this.eat(12));
      return attrs;
    }
    maybeParseModuleAttributes() {
      if (this.match(76) && !this.hasPrecedingLineBreak()) {
        this.expectPlugin('moduleAttributes');
        this.next();
      } else {
        if (this.hasPlugin('moduleAttributes')) return [];
        return null;
      }
      const attrs = [];
      const attributes = new Set();
      do {
        const node = this.startNode();
        node.key = this.parseIdentifier(true);
        if (node.key.name !== 'type') {
          this.raise(Errors.ModuleAttributeDifferentFromType, {at: node.key});
        }
        if (attributes.has(node.key.name)) {
          this.raise(Errors.ModuleAttributesWithDuplicateKeys, {
            at: node.key,
            key: node.key.name,
          });
        }
        attributes.add(node.key.name);
        this.expect(14);
        if (!this.match(131)) {
          throw this.raise(Errors.ModuleAttributeInvalidValue, {
            at: this.state.startLoc,
          });
        }
        node.value = this.parseStringLiteral(this.state.value);
        this.finishNode(node, 'ImportAttribute');
        attrs.push(node);
      } while (this.eat(12));
      return attrs;
    }
    maybeParseImportAssertions() {
      if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
        this.expectPlugin('importAssertions');
        this.next();
      } else {
        if (this.hasPlugin('importAssertions')) return [];
        return null;
      }
      this.eat(5);
      const attrs = this.parseAssertEntries();
      this.eat(8);
      return attrs;
    }
    maybeParseDefaultImportSpecifier(node) {
      if (this.shouldParseDefaultImport(node)) {
        this.parseImportSpecifierLocal(
          node,
          this.startNode(),
          'ImportDefaultSpecifier'
        );
        return true;
      }
      return false;
    }
    maybeParseStarImportSpecifier(node) {
      if (this.match(55)) {
        const specifier = this.startNode();
        this.next();
        this.expectContextual(93);
        this.parseImportSpecifierLocal(
          node,
          specifier,
          'ImportNamespaceSpecifier'
        );
        return true;
      }
      return false;
    }
    parseNamedImportSpecifiers(node) {
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          if (this.eat(14)) {
            throw this.raise(Errors.DestructureNamedImport, {
              at: this.state.startLoc,
            });
          }
          this.expect(12);
          if (this.eat(8)) break;
        }
        const specifier = this.startNode();
        const importedIsString = this.match(131);
        const isMaybeTypeOnly = this.isContextual(128);
        specifier.imported = this.parseModuleExportName();
        const importSpecifier = this.parseImportSpecifier(
          specifier,
          importedIsString,
          node.importKind === 'type' || node.importKind === 'typeof',
          isMaybeTypeOnly,
          undefined
        );
        node.specifiers.push(importSpecifier);
      }
    }
    parseImportSpecifier(
      specifier,
      importedIsString,
      isInTypeOnlyImport,
      isMaybeTypeOnly,
      bindingType
    ) {
      if (this.eatContextual(93)) {
        specifier.local = this.parseIdentifier();
      } else {
        const {imported: imported} = specifier;
        if (importedIsString) {
          throw this.raise(Errors.ImportBindingIsString, {
            at: specifier,
            importName: imported.value,
          });
        }
        this.checkReservedWord(imported.name, specifier.loc.start, true, true);
        if (!specifier.local) {
          specifier.local = cloneIdentifier(imported);
        }
      }
      return this.finishImportSpecifier(
        specifier,
        'ImportSpecifier',
        bindingType
      );
    }
    isThisParam(param) {
      return param.type === 'Identifier' && param.name === 'this';
    }
  }
  class Parser extends StatementParser {
    constructor(options, input) {
      options = getOptions(options);
      super(options, input);
      this.options = options;
      this.initializeScopes();
      this.plugins = pluginsMap(this.options.plugins);
      this.filename = options.sourceFilename;
    }
    getScopeHandler() {
      return ScopeHandler;
    }
    parse() {
      this.enterInitialScopes();
      const file = this.startNode();
      const program = this.startNode();
      this.nextToken();
      file.errors = null;
      this.parseTopLevel(file, program);
      file.errors = this.state.errors;
      return file;
    }
  }
  function pluginsMap(plugins) {
    const pluginMap = new Map();
    for (const plugin of plugins) {
      const [name, options] = Array.isArray(plugin) ? plugin : [plugin, {}];
      if (!pluginMap.has(name)) pluginMap.set(name, options || {});
    }
    return pluginMap;
  }
  function parse(input, options) {
    var _options;
    if (
      ((_options = options) == null ? void 0 : _options.sourceType) ===
      'unambiguous'
    ) {
      options = Object.assign({}, options);
      try {
        options.sourceType = 'module';
        const parser = getParser(options, input);
        const ast = parser.parse();
        if (parser.sawUnambiguousESM) {
          return ast;
        }
        if (parser.ambiguousScriptDifferentAst) {
          try {
            options.sourceType = 'script';
            return getParser(options, input).parse();
          } catch (_unused) {}
        } else {
          ast.program.sourceType = 'script';
        }
        return ast;
      } catch (moduleError) {
        try {
          options.sourceType = 'script';
          return getParser(options, input).parse();
        } catch (_unused2) {}
        throw moduleError;
      }
    } else {
      return getParser(options, input).parse();
    }
  }
  function parseExpression(input, options) {
    const parser = getParser(options, input);
    if (parser.options.strictMode) {
      parser.state.strict = true;
    }
    return parser.getExpression();
  }
  function generateExportedTokenTypes(internalTokenTypes) {
    const tokenTypes = {};
    for (const typeName of Object.keys(internalTokenTypes)) {
      tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
    }
    return tokenTypes;
  }
  const tokTypes = generateExportedTokenTypes(tt);
  function getParser(options, input) {
    let cls = Parser;
    if (options != null && options.plugins) {
      validatePlugins(options.plugins);
      cls = getParserClass(options.plugins);
    }
    return new cls(options, input);
  }
  const parserClassCache = {};
  function getParserClass(pluginsFromOptions) {
    const pluginList = mixinPluginNames.filter(name =>
      hasPlugin(pluginsFromOptions, name)
    );
    const key = pluginList.join('/');
    let cls = parserClassCache[key];
    if (!cls) {
      cls = Parser;
      for (const plugin of pluginList) {
        cls = mixinPlugins[plugin](cls);
      }
      parserClassCache[key] = cls;
    }
    return cls;
  }
  lib$6.parse = parse;
  lib$6.parseExpression = parseExpression;
  lib$6.tokTypes = tokTypes;
  return lib$6;
}
var hasRequiredReplacement;
function requireReplacement() {
  if (hasRequiredReplacement) return replacement;
  hasRequiredReplacement = 1;
  Object.defineProperty(replacement, '__esModule', {value: true});
  replacement.replaceWithMultiple = replaceWithMultiple;
  replacement.replaceWithSourceString = replaceWithSourceString;
  replacement.replaceWith = replaceWith;
  replacement._replaceWith = _replaceWith;
  replacement.replaceExpressionWithStatements = replaceExpressionWithStatements;
  replacement.replaceInline = replaceInline;
  var _codeFrame = requireLib$7();
  var _index = _interopRequireDefault(requireLib$1());
  var _index2 = _interopRequireDefault(requirePath());
  var _parser = requireLib$6();
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const hoistVariablesVisitor = {
    Function(path) {
      path.skip();
    },
    VariableDeclaration(path) {
      if (path.node.kind !== 'var') return;
      const bindings = path.getBindingIdentifiers();
      for (const key of Object.keys(bindings)) {
        path.scope.push({id: bindings[key]});
      }
      const exprs = [];
      for (const declar of path.node.declarations) {
        if (declar.init) {
          exprs.push(
            t.expressionStatement(
              t.assignmentExpression('=', declar.id, declar.init)
            )
          );
        }
      }
      path.replaceWithMultiple(exprs);
    },
  };
  function replaceWithMultiple(nodes) {
    this.resync();
    nodes = this._verifyNodeList(nodes);
    t.inheritLeadingComments(nodes[0], this.node);
    t.inheritTrailingComments(nodes[nodes.length - 1], this.node);
    this.node = this.container[this.key] = null;
    const paths = this.insertAfter(nodes);
    if (this.node) {
      this.requeue();
    } else {
      this.remove();
    }
    return paths;
  }
  function replaceWithSourceString(replacement) {
    this.resync();
    try {
      replacement = `(${replacement})`;
      replacement = (0, _parser.parse)(replacement);
    } catch (err) {
      const loc = err.loc;
      if (loc) {
        err.message +=
          ' - make sure this is an expression.\n' +
          (0, _codeFrame.codeFrameColumns)(replacement, {
            start: {line: loc.line, column: loc.column + 1},
          });
        err.code = 'BABEL_REPLACE_SOURCE_ERROR';
      }
      throw err;
    }
    replacement = replacement.program.body[0].expression;
    _index.default.removeProperties(replacement);
    return this.replaceWith(replacement);
  }
  function replaceWith(replacement) {
    this.resync();
    if (this.removed) {
      throw new Error("You can't replace this node, we've already removed it");
    }
    if (replacement instanceof _index2.default) {
      replacement = replacement.node;
    }
    if (!replacement) {
      throw new Error(
        'You passed `path.replaceWith()` a falsy node, use `path.remove()` instead'
      );
    }
    if (this.node === replacement) {
      return [this];
    }
    if (this.isProgram() && !t.isProgram(replacement)) {
      throw new Error(
        'You can only replace a Program root node with another Program node'
      );
    }
    if (Array.isArray(replacement)) {
      throw new Error(
        "Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`"
      );
    }
    if (typeof replacement === 'string') {
      throw new Error(
        "Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`"
      );
    }
    let nodePath = '';
    if (this.isNodeType('Statement') && t.isExpression(replacement)) {
      if (
        !this.canHaveVariableDeclarationOrExpression() &&
        !this.canSwapBetweenExpressionAndStatement(replacement) &&
        !this.parentPath.isExportDefaultDeclaration()
      ) {
        replacement = t.expressionStatement(replacement);
        nodePath = 'expression';
      }
    }
    if (this.isNodeType('Expression') && t.isStatement(replacement)) {
      if (
        !this.canHaveVariableDeclarationOrExpression() &&
        !this.canSwapBetweenExpressionAndStatement(replacement)
      ) {
        return this.replaceExpressionWithStatements([replacement]);
      }
    }
    const oldNode = this.node;
    if (oldNode) {
      t.inheritsComments(replacement, oldNode);
      t.removeComments(oldNode);
    }
    this._replaceWith(replacement);
    this.type = replacement.type;
    this.setScope();
    this.requeue();
    return [nodePath ? this.get(nodePath) : this];
  }
  function _replaceWith(node) {
    if (!this.container) {
      throw new ReferenceError('Container is falsy');
    }
    if (this.inList) {
      t.validate(this.parent, this.key, [node]);
    } else {
      t.validate(this.parent, this.key, node);
    }
    this.debug(`Replace with ${node && node.type}`);
    this.node = this.container[this.key] = node;
  }
  function replaceExpressionWithStatements(nodes) {
    this.resync();
    const toSequenceExpression = t.toSequenceExpression(nodes, this.scope);
    if (toSequenceExpression) {
      return this.replaceWith(toSequenceExpression)[0].get('expressions');
    }
    const functionParent = this.getFunctionParent();
    const isParentAsync = functionParent && functionParent.is('async');
    const container = t.arrowFunctionExpression([], t.blockStatement(nodes));
    this.replaceWith(t.callExpression(container, []));
    this.traverse(hoistVariablesVisitor);
    const completionRecords = this.get('callee').getCompletionRecords();
    for (const path of completionRecords) {
      if (!path.isExpressionStatement()) continue;
      const loop = path.findParent(path => path.isLoop());
      if (loop) {
        let uid = loop.getData('expressionReplacementReturnUid');
        if (!uid) {
          const callee = this.get('callee');
          uid = callee.scope.generateDeclaredUidIdentifier('ret');
          callee
            .get('body')
            .pushContainer('body', t.returnStatement(t.cloneNode(uid)));
          loop.setData('expressionReplacementReturnUid', uid);
        } else {
          uid = t.identifier(uid.name);
        }
        path
          .get('expression')
          .replaceWith(
            t.assignmentExpression('=', t.cloneNode(uid), path.node.expression)
          );
      } else {
        path.replaceWith(t.returnStatement(path.node.expression));
      }
    }
    const callee = this.get('callee');
    callee.arrowFunctionToExpression();
    if (
      isParentAsync &&
      _index.default.hasType(
        this.get('callee.body').node,
        'AwaitExpression',
        t.FUNCTION_TYPES
      )
    ) {
      callee.set('async', true);
      this.replaceWith(t.awaitExpression(this.node));
    }
    return callee.get('body.body');
  }
  function replaceInline(nodes) {
    this.resync();
    if (Array.isArray(nodes)) {
      if (Array.isArray(this.container)) {
        nodes = this._verifyNodeList(nodes);
        const paths = this._containerInsertAfter(nodes);
        this.remove();
        return paths;
      } else {
        return this.replaceWithMultiple(nodes);
      }
    } else {
      return this.replaceWith(nodes);
    }
  }
  return replacement;
}
var evaluation = {};
var hasRequiredEvaluation;
function requireEvaluation() {
  if (hasRequiredEvaluation) return evaluation;
  hasRequiredEvaluation = 1;
  Object.defineProperty(evaluation, '__esModule', {value: true});
  evaluation.evaluateTruthy = evaluateTruthy;
  evaluation.evaluate = evaluate;
  const VALID_CALLEES = ['String', 'Number', 'Math'];
  const INVALID_METHODS = ['random'];
  function evaluateTruthy() {
    const res = this.evaluate();
    if (res.confident) return !!res.value;
  }
  function deopt(path, state) {
    if (!state.confident) return;
    state.deoptPath = path;
    state.confident = false;
  }
  function evaluateCached(path, state) {
    const {node: node} = path;
    const {seen: seen} = state;
    if (seen.has(node)) {
      const existing = seen.get(node);
      if (existing.resolved) {
        return existing.value;
      } else {
        deopt(path, state);
        return;
      }
    } else {
      const item = {resolved: false};
      seen.set(node, item);
      const val = _evaluate(path, state);
      if (state.confident) {
        item.resolved = true;
        item.value = val;
      }
      return val;
    }
  }
  function _evaluate(path, state) {
    if (!state.confident) return;
    const {node: node} = path;
    if (path.isSequenceExpression()) {
      const exprs = path.get('expressions');
      return evaluateCached(exprs[exprs.length - 1], state);
    }
    if (
      path.isStringLiteral() ||
      path.isNumericLiteral() ||
      path.isBooleanLiteral()
    ) {
      return node.value;
    }
    if (path.isNullLiteral()) {
      return null;
    }
    if (path.isTemplateLiteral()) {
      return evaluateQuasis(path, node.quasis, state);
    }
    if (
      path.isTaggedTemplateExpression() &&
      path.get('tag').isMemberExpression()
    ) {
      const object = path.get('tag.object');
      const {
        node: {name: name},
      } = object;
      const property = path.get('tag.property');
      if (
        object.isIdentifier() &&
        name === 'String' &&
        !path.scope.getBinding(name, true) &&
        property.isIdentifier &&
        property.node.name === 'raw'
      ) {
        return evaluateQuasis(path, node.quasi.quasis, state, true);
      }
    }
    if (path.isConditionalExpression()) {
      const testResult = evaluateCached(path.get('test'), state);
      if (!state.confident) return;
      if (testResult) {
        return evaluateCached(path.get('consequent'), state);
      } else {
        return evaluateCached(path.get('alternate'), state);
      }
    }
    if (path.isExpressionWrapper()) {
      return evaluateCached(path.get('expression'), state);
    }
    if (
      path.isMemberExpression() &&
      !path.parentPath.isCallExpression({callee: node})
    ) {
      const property = path.get('property');
      const object = path.get('object');
      if (object.isLiteral() && property.isIdentifier()) {
        const value = object.node.value;
        const type = typeof value;
        if (type === 'number' || type === 'string') {
          return value[property.node.name];
        }
      }
    }
    if (path.isReferencedIdentifier()) {
      const binding = path.scope.getBinding(node.name);
      if (binding && binding.constantViolations.length > 0) {
        return deopt(binding.path, state);
      }
      if (binding && path.node.start < binding.path.node.end) {
        return deopt(binding.path, state);
      }
      if (binding && binding.hasValue) {
        return binding.value;
      } else {
        if (node.name === 'undefined') {
          return binding ? deopt(binding.path, state) : undefined;
        } else if (node.name === 'Infinity') {
          return binding ? deopt(binding.path, state) : Infinity;
        } else if (node.name === 'NaN') {
          return binding ? deopt(binding.path, state) : NaN;
        }
        const resolved = path.resolve();
        if (resolved === path) {
          return deopt(path, state);
        } else {
          return evaluateCached(resolved, state);
        }
      }
    }
    if (path.isUnaryExpression({prefix: true})) {
      if (node.operator === 'void') {
        return undefined;
      }
      const argument = path.get('argument');
      if (
        node.operator === 'typeof' &&
        (argument.isFunction() || argument.isClass())
      ) {
        return 'function';
      }
      const arg = evaluateCached(argument, state);
      if (!state.confident) return;
      switch (node.operator) {
        case '!':
          return !arg;
        case '+':
          return +arg;
        case '-':
          return -arg;
        case '~':
          return ~arg;
        case 'typeof':
          return typeof arg;
      }
    }
    if (path.isArrayExpression()) {
      const arr = [];
      const elems = path.get('elements');
      for (const elem of elems) {
        const elemValue = elem.evaluate();
        if (elemValue.confident) {
          arr.push(elemValue.value);
        } else {
          return deopt(elem, state);
        }
      }
      return arr;
    }
    if (path.isObjectExpression()) {
      const obj = {};
      const props = path.get('properties');
      for (const prop of props) {
        if (prop.isObjectMethod() || prop.isSpreadElement()) {
          return deopt(prop, state);
        }
        const keyPath = prop.get('key');
        let key = keyPath;
        if (prop.node.computed) {
          key = key.evaluate();
          if (!key.confident) {
            return deopt(keyPath, state);
          }
          key = key.value;
        } else if (key.isIdentifier()) {
          key = key.node.name;
        } else {
          key = key.node.value;
        }
        const valuePath = prop.get('value');
        let value = valuePath.evaluate();
        if (!value.confident) {
          return deopt(valuePath, state);
        }
        value = value.value;
        obj[key] = value;
      }
      return obj;
    }
    if (path.isLogicalExpression()) {
      const wasConfident = state.confident;
      const left = evaluateCached(path.get('left'), state);
      const leftConfident = state.confident;
      state.confident = wasConfident;
      const right = evaluateCached(path.get('right'), state);
      const rightConfident = state.confident;
      switch (node.operator) {
        case '||':
          state.confident = leftConfident && (!!left || rightConfident);
          if (!state.confident) return;
          return left || right;
        case '&&':
          state.confident = leftConfident && (!left || rightConfident);
          if (!state.confident) return;
          return left && right;
      }
    }
    if (path.isBinaryExpression()) {
      const left = evaluateCached(path.get('left'), state);
      if (!state.confident) return;
      const right = evaluateCached(path.get('right'), state);
      if (!state.confident) return;
      switch (node.operator) {
        case '-':
          return left - right;
        case '+':
          return left + right;
        case '/':
          return left / right;
        case '*':
          return left * right;
        case '%':
          return left % right;
        case '**':
          return Math.pow(left, right);
        case '<':
          return left < right;
        case '>':
          return left > right;
        case '<=':
          return left <= right;
        case '>=':
          return left >= right;
        case '==':
          return left == right;
        case '!=':
          return left != right;
        case '===':
          return left === right;
        case '!==':
          return left !== right;
        case '|':
          return left | right;
        case '&':
          return left & right;
        case '^':
          return left ^ right;
        case '<<':
          return left << right;
        case '>>':
          return left >> right;
        case '>>>':
          return left >>> right;
      }
    }
    if (path.isCallExpression()) {
      const callee = path.get('callee');
      let context;
      let func;
      if (
        callee.isIdentifier() &&
        !path.scope.getBinding(callee.node.name, true) &&
        VALID_CALLEES.indexOf(callee.node.name) >= 0
      ) {
        func = commonjsGlobal[node.callee.name];
      }
      if (callee.isMemberExpression()) {
        const object = callee.get('object');
        const property = callee.get('property');
        if (
          object.isIdentifier() &&
          property.isIdentifier() &&
          VALID_CALLEES.indexOf(object.node.name) >= 0 &&
          INVALID_METHODS.indexOf(property.node.name) < 0
        ) {
          context = commonjsGlobal[object.node.name];
          func = context[property.node.name];
        }
        if (object.isLiteral() && property.isIdentifier()) {
          const type = typeof object.node.value;
          if (type === 'string' || type === 'number') {
            context = object.node.value;
            func = context[property.node.name];
          }
        }
      }
      if (func) {
        const args = path
          .get('arguments')
          .map(arg => evaluateCached(arg, state));
        if (!state.confident) return;
        return func.apply(context, args);
      }
    }
    deopt(path, state);
  }
  function evaluateQuasis(path, quasis, state, raw = false) {
    let str = '';
    let i = 0;
    const exprs = path.get('expressions');
    for (const elem of quasis) {
      if (!state.confident) break;
      str += raw ? elem.value.raw : elem.value.cooked;
      const expr = exprs[i++];
      if (expr) str += String(evaluateCached(expr, state));
    }
    if (!state.confident) return;
    return str;
  }
  function evaluate() {
    const state = {confident: true, deoptPath: null, seen: new Map()};
    let value = evaluateCached(this, state);
    if (!state.confident) value = undefined;
    return {confident: state.confident, deopt: state.deoptPath, value: value};
  }
  return evaluation;
}
var conversion = {};
var lib$5 = {};
var lib$4 = {};
var formatters = {};
var hasRequiredFormatters;
function requireFormatters() {
  if (hasRequiredFormatters) return formatters;
  hasRequiredFormatters = 1;
  Object.defineProperty(formatters, '__esModule', {value: true});
  formatters.statements =
    formatters.statement =
    formatters.smart =
    formatters.program =
    formatters.expression =
      void 0;
  var _t = t$d;
  const {assertExpressionStatement: assertExpressionStatement} = _t;
  function makeStatementFormatter(fn) {
    return {
      code: str => `/* @babel/template */;\n${str}`,
      validate: () => {},
      unwrap: ast => fn(ast.program.body.slice(1)),
    };
  }
  formatters.smart = makeStatementFormatter(body => {
    if (body.length > 1) {
      return body;
    } else {
      return body[0];
    }
  });
  formatters.statements = makeStatementFormatter(body => body);
  formatters.statement = makeStatementFormatter(body => {
    if (body.length === 0) {
      throw new Error('Found nothing to return.');
    }
    if (body.length > 1) {
      throw new Error('Found multiple statements but wanted one');
    }
    return body[0];
  });
  const expression = (formatters.expression = {
    code: str => `(\n${str}\n)`,
    validate: ast => {
      if (ast.program.body.length > 1) {
        throw new Error('Found multiple statements but wanted one');
      }
      if (expression.unwrap(ast).start === 0) {
        throw new Error('Parse result included parens.');
      }
    },
    unwrap: ({program: program}) => {
      const [stmt] = program.body;
      assertExpressionStatement(stmt);
      return stmt.expression;
    },
  });
  formatters.program = {
    code: str => str,
    validate: () => {},
    unwrap: ast => ast.program,
  };
  return formatters;
}
var builder = {};
var options$1 = {};
var hasRequiredOptions;
function requireOptions() {
  if (hasRequiredOptions) return options$1;
  hasRequiredOptions = 1;
  Object.defineProperty(options$1, '__esModule', {value: true});
  options$1.merge = merge;
  options$1.normalizeReplacements = normalizeReplacements;
  options$1.validate = validate;
  const _excluded = [
    'placeholderWhitelist',
    'placeholderPattern',
    'preserveComments',
    'syntacticPlaceholders',
  ];
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }
  function merge(a, b) {
    const {
      placeholderWhitelist: placeholderWhitelist = a.placeholderWhitelist,
      placeholderPattern: placeholderPattern = a.placeholderPattern,
      preserveComments: preserveComments = a.preserveComments,
      syntacticPlaceholders: syntacticPlaceholders = a.syntacticPlaceholders,
    } = b;
    return {
      parser: Object.assign({}, a.parser, b.parser),
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      preserveComments: preserveComments,
      syntacticPlaceholders: syntacticPlaceholders,
    };
  }
  function validate(opts) {
    if (opts != null && typeof opts !== 'object') {
      throw new Error('Unknown template options.');
    }
    const _ref = opts || {},
      {
        placeholderWhitelist: placeholderWhitelist,
        placeholderPattern: placeholderPattern,
        preserveComments: preserveComments,
        syntacticPlaceholders: syntacticPlaceholders,
      } = _ref,
      parser = _objectWithoutPropertiesLoose(_ref, _excluded);
    if (
      placeholderWhitelist != null &&
      !(placeholderWhitelist instanceof Set)
    ) {
      throw new Error(
        "'.placeholderWhitelist' must be a Set, null, or undefined"
      );
    }
    if (
      placeholderPattern != null &&
      !(placeholderPattern instanceof RegExp) &&
      placeholderPattern !== false
    ) {
      throw new Error(
        "'.placeholderPattern' must be a RegExp, false, null, or undefined"
      );
    }
    if (preserveComments != null && typeof preserveComments !== 'boolean') {
      throw new Error(
        "'.preserveComments' must be a boolean, null, or undefined"
      );
    }
    if (
      syntacticPlaceholders != null &&
      typeof syntacticPlaceholders !== 'boolean'
    ) {
      throw new Error(
        "'.syntacticPlaceholders' must be a boolean, null, or undefined"
      );
    }
    if (
      syntacticPlaceholders === true &&
      (placeholderWhitelist != null || placeholderPattern != null)
    ) {
      throw new Error(
        "'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" +
          " with '.syntacticPlaceholders: true'"
      );
    }
    return {
      parser: parser,
      placeholderWhitelist: placeholderWhitelist || undefined,
      placeholderPattern:
        placeholderPattern == null ? undefined : placeholderPattern,
      preserveComments: preserveComments == null ? undefined : preserveComments,
      syntacticPlaceholders:
        syntacticPlaceholders == null ? undefined : syntacticPlaceholders,
    };
  }
  function normalizeReplacements(replacements) {
    if (Array.isArray(replacements)) {
      return replacements.reduce((acc, replacement, i) => {
        acc['$' + i] = replacement;
        return acc;
      }, {});
    } else if (typeof replacements === 'object' || replacements == null) {
      return replacements || undefined;
    }
    throw new Error(
      'Template replacements must be an array, object, null, or undefined'
    );
  }
  return options$1;
}
var string = {};
var parse$2 = {};
var lib$3 = {};
var hasRequiredLib$5;
function requireLib$5() {
  if (hasRequiredLib$5) return lib$3;
  hasRequiredLib$5 = 1;
  Object.defineProperty(lib$3, '__esModule', {value: true});
  function _objectWithoutPropertiesLoose(r, e) {
    if (null == r) return {};
    var t = {};
    for (var n in r)
      if ({}.hasOwnProperty.call(r, n)) {
        if (e.includes(n)) continue;
        t[n] = r[n];
      }
    return t;
  }
  class Position {
    constructor(line, col, index) {
      this.line = void 0;
      this.column = void 0;
      this.index = void 0;
      this.line = line;
      this.column = col;
      this.index = index;
    }
  }
  class SourceLocation {
    constructor(start, end) {
      this.start = void 0;
      this.end = void 0;
      this.filename = void 0;
      this.identifierName = void 0;
      this.start = start;
      this.end = end;
    }
  }
  function createPositionWithColumnOffset(position, columnOffset) {
    const {line: line, column: column, index: index} = position;
    return new Position(line, column + columnOffset, index + columnOffset);
  }
  const code = 'BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED';
  var ModuleErrors = {
    ImportMetaOutsideModule: {
      message: `import.meta may appear only with 'sourceType: "module"'`,
      code: code,
    },
    ImportOutsideModule: {
      message: `'import' and 'export' may appear only with 'sourceType: "module"'`,
      code: code,
    },
  };
  const NodeDescriptions = {
    ArrayPattern: 'array destructuring pattern',
    AssignmentExpression: 'assignment expression',
    AssignmentPattern: 'assignment expression',
    ArrowFunctionExpression: 'arrow function expression',
    ConditionalExpression: 'conditional expression',
    CatchClause: 'catch clause',
    ForOfStatement: 'for-of statement',
    ForInStatement: 'for-in statement',
    ForStatement: 'for-loop',
    FormalParameters: 'function parameter list',
    Identifier: 'identifier',
    ImportSpecifier: 'import specifier',
    ImportDefaultSpecifier: 'import default specifier',
    ImportNamespaceSpecifier: 'import namespace specifier',
    ObjectPattern: 'object destructuring pattern',
    ParenthesizedExpression: 'parenthesized expression',
    RestElement: 'rest element',
    UpdateExpression: {true: 'prefix operation', false: 'postfix operation'},
    VariableDeclarator: 'variable declaration',
    YieldExpression: 'yield expression',
  };
  const toNodeDescription = node =>
    node.type === 'UpdateExpression'
      ? NodeDescriptions.UpdateExpression[`${node.prefix}`]
      : NodeDescriptions[node.type];
  var StandardErrors = {
    AccessorIsGenerator: ({kind: kind}) =>
      `A ${kind}ter cannot be a generator.`,
    ArgumentsInClass:
      "'arguments' is only allowed in functions and class methods.",
    AsyncFunctionInSingleStatementContext:
      'Async functions can only be declared at the top level or inside a block.',
    AwaitBindingIdentifier:
      "Can not use 'await' as identifier inside an async function.",
    AwaitBindingIdentifierInStaticBlock:
      "Can not use 'await' as identifier inside a static block.",
    AwaitExpressionFormalParameter:
      "'await' is not allowed in async function parameters.",
    AwaitUsingNotInAsyncContext:
      "'await using' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncContext:
      "'await' is only allowed within async functions and at the top levels of modules.",
    AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
    BadGetterArity: "A 'get' accessor must not have any formal parameters.",
    BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
    BadSetterRestParameter:
      "A 'set' accessor function argument must not be a rest parameter.",
    ConstructorClassField: "Classes may not have a field named 'constructor'.",
    ConstructorClassPrivateField:
      "Classes may not have a private field named '#constructor'.",
    ConstructorIsAccessor: 'Class constructor may not be an accessor.',
    ConstructorIsAsync: "Constructor can't be an async function.",
    ConstructorIsGenerator: "Constructor can't be a generator.",
    DeclarationMissingInitializer: ({kind: kind}) =>
      `Missing initializer in ${kind} declaration.`,
    DecoratorArgumentsOutsideParentheses:
      "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
    DecoratorBeforeExport:
      "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
    DecoratorsBeforeAfterExport:
      "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
    DecoratorConstructor:
      "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
    DecoratorExportClass:
      "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
    DecoratorSemicolon: 'Decorators must not be followed by a semicolon.',
    DecoratorStaticBlock: "Decorators can't be used with a static block.",
    DeferImportRequiresNamespace:
      'Only `import defer * as x from "./module"` is valid.',
    DeletePrivateField: 'Deleting a private field is not allowed.',
    DestructureNamedImport:
      'ES2015 named imports do not destructure. Use another statement for destructuring after the import.',
    DuplicateConstructor: 'Duplicate constructor in the same class.',
    DuplicateDefaultExport: 'Only one default export allowed per module.',
    DuplicateExport: ({exportName: exportName}) =>
      `\`${exportName}\` has already been exported. Exported identifiers must be unique.`,
    DuplicateProto: 'Redefinition of __proto__ property.',
    DuplicateRegExpFlags: 'Duplicate regular expression flag.',
    DynamicImportPhaseRequiresImportExpressions: ({phase: phase}) =>
      `'import.${phase}(...)' can only be parsed when using the 'createImportExpressions' option.`,
    ElementAfterRest: 'Rest element must be last element.',
    EscapedCharNotAnIdentifier: 'Invalid Unicode escape.',
    ExportBindingIsString: ({localName: localName, exportName: exportName}) =>
      `A string literal cannot be used as an exported binding without \`from\`.\n- Did you mean \`export { '${localName}' as '${exportName}' } from 'some-module'\`?`,
    ExportDefaultFromAsIdentifier:
      "'from' is not allowed as an identifier after 'export default'.",
    ForInOfLoopInitializer: ({type: type}) =>
      `'${type === 'ForInStatement' ? 'for-in' : 'for-of'}' loop variable declaration may not have an initializer.`,
    ForInUsing: "For-in loop may not start with 'using' declaration.",
    ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
    ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
    GeneratorInSingleStatementContext:
      'Generators can only be declared at the top level or inside a block.',
    IllegalBreakContinue: ({type: type}) =>
      `Unsyntactic ${type === 'BreakStatement' ? 'break' : 'continue'}.`,
    IllegalLanguageModeDirective:
      "Illegal 'use strict' directive in function with non-simple parameter list.",
    IllegalReturn: "'return' outside of function.",
    ImportAttributesUseAssert:
      'The `assert` keyword in import attributes is deprecated and it has been replaced by the `with` keyword. You can enable the `deprecatedAssertSyntax: true` option in the import attributes plugin to suppress this error.',
    ImportBindingIsString: ({importName: importName}) =>
      `A string literal cannot be used as an imported binding.\n- Did you mean \`import { "${importName}" as foo }\`?`,
    ImportCallArgumentTrailingComma:
      'Trailing comma is disallowed inside import(...) arguments.',
    ImportCallArity: ({maxArgumentCount: maxArgumentCount}) =>
      `\`import()\` requires exactly ${maxArgumentCount === 1 ? 'one argument' : 'one or two arguments'}.`,
    ImportCallNotNewExpression: 'Cannot use new with import(...).',
    ImportCallSpreadArgument: '`...` is not allowed in `import()`.',
    ImportJSONBindingNotDefault:
      'A JSON module can only be imported with `default`.',
    ImportReflectionHasAssertion: '`import module x` cannot have assertions.',
    ImportReflectionNotBinding:
      'Only `import module x from "./module"` is valid.',
    IncompatibleRegExpUVFlags:
      "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
    InvalidBigIntLiteral: 'Invalid BigIntLiteral.',
    InvalidCodePoint: 'Code point out of bounds.',
    InvalidCoverInitializedName: 'Invalid shorthand property initializer.',
    InvalidDecimal: 'Invalid decimal.',
    InvalidDigit: ({radix: radix}) => `Expected number in radix ${radix}.`,
    InvalidEscapeSequence: 'Bad character escape sequence.',
    InvalidEscapeSequenceTemplate: 'Invalid escape sequence in template.',
    InvalidEscapedReservedWord: ({reservedWord: reservedWord}) =>
      `Escape sequence in keyword ${reservedWord}.`,
    InvalidIdentifier: ({identifierName: identifierName}) =>
      `Invalid identifier ${identifierName}.`,
    InvalidLhs: ({ancestor: ancestor}) =>
      `Invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsBinding: ({ancestor: ancestor}) =>
      `Binding invalid left-hand side in ${toNodeDescription(ancestor)}.`,
    InvalidLhsOptionalChaining: ({ancestor: ancestor}) =>
      `Invalid optional chaining in the left-hand side of ${toNodeDescription(ancestor)}.`,
    InvalidNumber: 'Invalid number.',
    InvalidOrMissingExponent:
      "Floating-point numbers require a valid exponent after the 'e'.",
    InvalidOrUnexpectedToken: ({unexpected: unexpected}) =>
      `Unexpected character '${unexpected}'.`,
    InvalidParenthesizedAssignment: 'Invalid parenthesized assignment pattern.',
    InvalidPrivateFieldResolution: ({identifierName: identifierName}) =>
      `Private name #${identifierName} is not defined.`,
    InvalidPropertyBindingPattern: 'Binding member expression.',
    InvalidRecordProperty:
      'Only properties and spread elements are allowed in record definitions.',
    InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
    LabelRedeclaration: ({labelName: labelName}) =>
      `Label '${labelName}' is already declared.`,
    LetInLexicalBinding: "'let' is disallowed as a lexically bound name.",
    LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
    MalformedRegExpFlags: 'Invalid regular expression flag.',
    MissingClassName: 'A class name is required.',
    MissingEqInAssignment:
      "Only '=' operator can be used for specifying default value.",
    MissingSemicolon: 'Missing semicolon.',
    MissingPlugin: ({missingPlugin: missingPlugin}) =>
      `This experimental syntax requires enabling the parser plugin: ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
    MissingOneOfPlugins: ({missingPlugin: missingPlugin}) =>
      `This experimental syntax requires enabling one of the following parser plugin(s): ${missingPlugin.map(name => JSON.stringify(name)).join(', ')}.`,
    MissingUnicodeEscape: 'Expecting Unicode escape sequence \\uXXXX.',
    MixingCoalesceWithLogical:
      'Nullish coalescing operator(??) requires parens when mixing with logical operators.',
    ModuleAttributeDifferentFromType:
      'The only accepted module attribute is `type`.',
    ModuleAttributeInvalidValue:
      'Only string literals are allowed as module attribute values.',
    ModuleAttributesWithDuplicateKeys: ({key: key}) =>
      `Duplicate key "${key}" is not allowed in module attributes.`,
    ModuleExportNameHasLoneSurrogate: ({
      surrogateCharCode: surrogateCharCode,
    }) =>
      `An export name cannot include a lone surrogate, found '\\u${surrogateCharCode.toString(16)}'.`,
    ModuleExportUndefined: ({localName: localName}) =>
      `Export '${localName}' is not defined.`,
    MultipleDefaultsInSwitch: 'Multiple default clauses.',
    NewlineAfterThrow: 'Illegal newline after throw.',
    NoCatchOrFinally: 'Missing catch or finally clause.',
    NumberIdentifier: 'Identifier directly after number.',
    NumericSeparatorInEscapeSequence:
      'Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.',
    ObsoleteAwaitStar:
      "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
    OptionalChainingNoNew:
      'Constructors in/after an Optional Chain are not allowed.',
    OptionalChainingNoTemplate:
      'Tagged Template Literals are not allowed in optionalChain.',
    OverrideOnConstructor:
      "'override' modifier cannot appear on a constructor declaration.",
    ParamDupe: 'Argument name clash.',
    PatternHasAccessor: "Object pattern can't contain getter or setter.",
    PatternHasMethod: "Object pattern can't contain methods.",
    PrivateInExpectedIn: ({identifierName: identifierName}) =>
      `Private names are only allowed in property accesses (\`obj.#${identifierName}\`) or in \`in\` expressions (\`#${identifierName} in obj\`).`,
    PrivateNameRedeclaration: ({identifierName: identifierName}) =>
      `Duplicate private name #${identifierName}.`,
    RecordExpressionBarIncorrectEndSyntaxType:
      "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionBarIncorrectStartSyntaxType:
      "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    RecordExpressionHashIncorrectStartSyntaxType:
      "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    RecordNoProto: "'__proto__' is not allowed in Record expressions.",
    RestTrailingComma: 'Unexpected trailing comma after rest element.',
    SloppyFunction:
      'In non-strict mode code, functions can only be declared at top level or inside a block.',
    SloppyFunctionAnnexB:
      'In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.',
    SourcePhaseImportRequiresDefault:
      'Only `import source x from "./module"` is valid.',
    StaticPrototype: 'Classes may not have static property named prototype.',
    SuperNotAllowed:
      "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
    SuperPrivateField: "Private fields can't be accessed on super.",
    TrailingDecorator: 'Decorators must be attached to a class element.',
    TupleExpressionBarIncorrectEndSyntaxType:
      "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionBarIncorrectStartSyntaxType:
      "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
    TupleExpressionHashIncorrectStartSyntaxType:
      "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
    UnexpectedArgumentPlaceholder: 'Unexpected argument placeholder.',
    UnexpectedAwaitAfterPipelineBody:
      'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
    UnexpectedDigitAfterHash: 'Unexpected digit after hash token.',
    UnexpectedImportExport:
      "'import' and 'export' may only appear at the top level.",
    UnexpectedKeyword: ({keyword: keyword}) =>
      `Unexpected keyword '${keyword}'.`,
    UnexpectedLeadingDecorator:
      'Leading decorators must be attached to a class declaration.',
    UnexpectedLexicalDeclaration:
      'Lexical declaration cannot appear in a single-statement context.',
    UnexpectedNewTarget:
      '`new.target` can only be used in functions or class properties.',
    UnexpectedNumericSeparator:
      'A numeric separator is only allowed between two digits.',
    UnexpectedPrivateField: 'Unexpected private name.',
    UnexpectedReservedWord: ({reservedWord: reservedWord}) =>
      `Unexpected reserved word '${reservedWord}'.`,
    UnexpectedSuper: "'super' is only allowed in object methods and classes.",
    UnexpectedToken: ({expected: expected, unexpected: unexpected}) =>
      `Unexpected token${unexpected ? ` '${unexpected}'.` : ''}${expected ? `, expected "${expected}"` : ''}`,
    UnexpectedTokenUnaryExponentiation:
      'Illegal expression. Wrap left hand side or entire exponentiation in parentheses.',
    UnexpectedUsingDeclaration:
      'Using declaration cannot appear in the top level when source type is `script`.',
    UnsupportedBind: 'Binding should be performed on object property.',
    UnsupportedDecoratorExport:
      'A decorated export must export a class declaration.',
    UnsupportedDefaultExport:
      'Only expressions, functions or classes are allowed as the `default` export.',
    UnsupportedImport:
      '`import` can only be used in `import()` or `import.meta`.',
    UnsupportedMetaProperty: ({
      target: target,
      onlyValidPropertyName: onlyValidPropertyName,
    }) =>
      `The only valid meta property for ${target} is ${target}.${onlyValidPropertyName}.`,
    UnsupportedParameterDecorator:
      'Decorators cannot be used to decorate parameters.',
    UnsupportedPropertyDecorator:
      'Decorators cannot be used to decorate object literal properties.',
    UnsupportedSuper:
      "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
    UnterminatedComment: 'Unterminated comment.',
    UnterminatedRegExp: 'Unterminated regular expression.',
    UnterminatedString: 'Unterminated string constant.',
    UnterminatedTemplate: 'Unterminated template.',
    UsingDeclarationExport: 'Using declaration cannot be exported.',
    UsingDeclarationHasBindingPattern:
      'Using declaration cannot have destructuring patterns.',
    VarRedeclaration: ({identifierName: identifierName}) =>
      `Identifier '${identifierName}' has already been declared.`,
    YieldBindingIdentifier:
      "Can not use 'yield' as identifier inside a generator.",
    YieldInParameter: 'Yield expression is not allowed in formal parameters.',
    ZeroDigitNumericSeparator:
      'Numeric separator can not be used after leading 0.',
  };
  var StrictModeErrors = {
    StrictDelete: 'Deleting local variable in strict mode.',
    StrictEvalArguments: ({referenceName: referenceName}) =>
      `Assigning to '${referenceName}' in strict mode.`,
    StrictEvalArgumentsBinding: ({bindingName: bindingName}) =>
      `Binding '${bindingName}' in strict mode.`,
    StrictFunction:
      'In strict mode code, functions can only be declared at top level or inside a block.',
    StrictNumericEscape:
      "The only valid numeric escape in strict mode is '\\0'.",
    StrictOctalLiteral: 'Legacy octal literals are not allowed in strict mode.',
    StrictWith: "'with' in strict mode.",
  };
  const UnparenthesizedPipeBodyDescriptions = new Set([
    'ArrowFunctionExpression',
    'AssignmentExpression',
    'ConditionalExpression',
    'YieldExpression',
  ]);
  var PipelineOperatorErrors = {
    PipeBodyIsTighter:
      'Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.',
    PipeTopicRequiresHackPipes:
      'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
    PipeTopicUnbound:
      'Topic reference is unbound; it must be inside a pipe body.',
    PipeTopicUnconfiguredToken: ({token: token}) =>
      `Invalid topic token ${token}. In order to use ${token} as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "${token}" }.`,
    PipeTopicUnused:
      'Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.',
    PipeUnparenthesizedBody: ({type: type}) =>
      `Hack-style pipe body cannot be an unparenthesized ${toNodeDescription({type: type})}; please wrap it in parentheses.`,
    PipelineBodyNoArrow:
      'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
    PipelineBodySequenceExpression:
      'Pipeline body may not be a comma-separated sequence expression.',
    PipelineHeadSequenceExpression:
      'Pipeline head should not be a comma-separated sequence expression.',
    PipelineTopicUnused:
      'Pipeline is in topic style but does not use topic reference.',
    PrimaryTopicNotAllowed:
      'Topic reference was used in a lexical context without topic binding.',
    PrimaryTopicRequiresSmartPipeline:
      'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
  };
  const _excluded = ['message'];
  function defineHidden(obj, key, value) {
    Object.defineProperty(obj, key, {
      enumerable: false,
      configurable: true,
      value: value,
    });
  }
  function toParseErrorConstructor({
    toMessage: toMessage,
    code: code,
    reasonCode: reasonCode,
    syntaxPlugin: syntaxPlugin,
  }) {
    const hasMissingPlugin =
      reasonCode === 'MissingPlugin' || reasonCode === 'MissingOneOfPlugins';
    {
      const oldReasonCodes = {
        AccessorCannotDeclareThisParameter: 'AccesorCannotDeclareThisParameter',
        AccessorCannotHaveTypeParameters: 'AccesorCannotHaveTypeParameters',
        ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference:
          'ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference',
        SetAccessorCannotHaveOptionalParameter:
          'SetAccesorCannotHaveOptionalParameter',
        SetAccessorCannotHaveRestParameter: 'SetAccesorCannotHaveRestParameter',
        SetAccessorCannotHaveReturnType: 'SetAccesorCannotHaveReturnType',
      };
      if (oldReasonCodes[reasonCode]) {
        reasonCode = oldReasonCodes[reasonCode];
      }
    }
    return function constructor(loc, details) {
      const error = new SyntaxError();
      error.code = code;
      error.reasonCode = reasonCode;
      error.loc = loc;
      error.pos = loc.index;
      error.syntaxPlugin = syntaxPlugin;
      if (hasMissingPlugin) {
        error.missingPlugin = details.missingPlugin;
      }
      defineHidden(error, 'clone', function clone(overrides = {}) {
        var _overrides$loc;
        const {
          line: line,
          column: column,
          index: index,
        } = (_overrides$loc = overrides.loc) != null ? _overrides$loc : loc;
        return constructor(
          new Position(line, column, index),
          Object.assign({}, details, overrides.details)
        );
      });
      defineHidden(error, 'details', details);
      Object.defineProperty(error, 'message', {
        configurable: true,
        get() {
          const message = `${toMessage(details)} (${loc.line}:${loc.column})`;
          this.message = message;
          return message;
        },
        set(value) {
          Object.defineProperty(this, 'message', {
            value: value,
            writable: true,
          });
        },
      });
      return error;
    };
  }
  function ParseErrorEnum(argument, syntaxPlugin) {
    if (Array.isArray(argument)) {
      return parseErrorTemplates =>
        ParseErrorEnum(parseErrorTemplates, argument[0]);
    }
    const ParseErrorConstructors = {};
    for (const reasonCode of Object.keys(argument)) {
      const template = argument[reasonCode];
      const _ref =
          typeof template === 'string'
            ? {message: () => template}
            : typeof template === 'function'
              ? {message: template}
              : template,
        {message: message} = _ref,
        rest = _objectWithoutPropertiesLoose(_ref, _excluded);
      const toMessage = typeof message === 'string' ? () => message : message;
      ParseErrorConstructors[reasonCode] = toParseErrorConstructor(
        Object.assign(
          {
            code: 'BABEL_PARSER_SYNTAX_ERROR',
            reasonCode: reasonCode,
            toMessage: toMessage,
          },
          syntaxPlugin ? {syntaxPlugin: syntaxPlugin} : {},
          rest
        )
      );
    }
    return ParseErrorConstructors;
  }
  const Errors = Object.assign(
    {},
    ParseErrorEnum(ModuleErrors),
    ParseErrorEnum(StandardErrors),
    ParseErrorEnum(StrictModeErrors),
    ParseErrorEnum`pipelineOperator`(PipelineOperatorErrors)
  );
  const {defineProperty: defineProperty} = Object;
  const toUnenumerable = (object, key) => {
    if (object) {
      defineProperty(object, key, {enumerable: false, value: object[key]});
    }
  };
  function toESTreeLocation(node) {
    toUnenumerable(node.loc.start, 'index');
    toUnenumerable(node.loc.end, 'index');
    return node;
  }
  var estree = superClass =>
    class ESTreeParserMixin extends superClass {
      parse() {
        const file = toESTreeLocation(super.parse());
        if (this.options.tokens) {
          file.tokens = file.tokens.map(toESTreeLocation);
        }
        return file;
      }
      parseRegExpLiteral({pattern: pattern, flags: flags}) {
        let regex = null;
        try {
          regex = new RegExp(pattern, flags);
        } catch (_) {}
        const node = this.estreeParseLiteral(regex);
        node.regex = {pattern: pattern, flags: flags};
        return node;
      }
      parseBigIntLiteral(value) {
        let bigInt;
        try {
          bigInt = BigInt(value);
        } catch (_unused) {
          bigInt = null;
        }
        const node = this.estreeParseLiteral(bigInt);
        node.bigint = String(node.value || value);
        return node;
      }
      parseDecimalLiteral(value) {
        const decimal = null;
        const node = this.estreeParseLiteral(decimal);
        node.decimal = String(node.value || value);
        return node;
      }
      estreeParseLiteral(value) {
        return this.parseLiteral(value, 'Literal');
      }
      parseStringLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      parseNumericLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      parseNullLiteral() {
        return this.estreeParseLiteral(null);
      }
      parseBooleanLiteral(value) {
        return this.estreeParseLiteral(value);
      }
      directiveToStmt(directive) {
        const expression = directive.value;
        delete directive.value;
        expression.type = 'Literal';
        expression.raw = expression.extra.raw;
        expression.value = expression.extra.expressionValue;
        const stmt = directive;
        stmt.type = 'ExpressionStatement';
        stmt.expression = expression;
        stmt.directive = expression.extra.rawValue;
        delete expression.extra;
        return stmt;
      }
      initFunction(node, isAsync) {
        super.initFunction(node, isAsync);
        node.expression = false;
      }
      checkDeclaration(node) {
        if (node != null && this.isObjectProperty(node)) {
          this.checkDeclaration(node.value);
        } else {
          super.checkDeclaration(node);
        }
      }
      getObjectOrClassMethodParams(method) {
        return method.value.params;
      }
      isValidDirective(stmt) {
        var _stmt$expression$extr;
        return (
          stmt.type === 'ExpressionStatement' &&
          stmt.expression.type === 'Literal' &&
          typeof stmt.expression.value === 'string' &&
          !(
            (_stmt$expression$extr = stmt.expression.extra) != null &&
            _stmt$expression$extr.parenthesized
          )
        );
      }
      parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
        super.parseBlockBody(
          node,
          allowDirectives,
          topLevel,
          end,
          afterBlockParse
        );
        const directiveStatements = node.directives.map(d =>
          this.directiveToStmt(d)
        );
        node.body = directiveStatements.concat(node.body);
        delete node.directives;
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        this.parseMethod(
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper,
          'ClassMethod',
          true
        );
        if (method.typeParameters) {
          method.value.typeParameters = method.typeParameters;
          delete method.typeParameters;
        }
        classBody.body.push(method);
      }
      parsePrivateName() {
        const node = super.parsePrivateName();
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return node;
          }
        }
        return this.convertPrivateNameToPrivateIdentifier(node);
      }
      convertPrivateNameToPrivateIdentifier(node) {
        const name = super.getPrivateNameSV(node);
        node = node;
        delete node.id;
        node.name = name;
        node.type = 'PrivateIdentifier';
        return node;
      }
      isPrivateName(node) {
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return super.isPrivateName(node);
          }
        }
        return node.type === 'PrivateIdentifier';
      }
      getPrivateNameSV(node) {
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return super.getPrivateNameSV(node);
          }
        }
        return node.name;
      }
      parseLiteral(value, type) {
        const node = super.parseLiteral(value, type);
        node.raw = node.extra.raw;
        delete node.extra;
        return node;
      }
      parseFunctionBody(node, allowExpression, isMethod = false) {
        super.parseFunctionBody(node, allowExpression, isMethod);
        node.expression = node.body.type !== 'BlockStatement';
      }
      parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope = false
      ) {
        let funcNode = this.startNode();
        funcNode.kind = node.kind;
        funcNode = super.parseMethod(
          funcNode,
          isGenerator,
          isAsync,
          isConstructor,
          allowDirectSuper,
          type,
          inClassScope
        );
        funcNode.type = 'FunctionExpression';
        delete funcNode.kind;
        node.value = funcNode;
        if (type === 'ClassPrivateMethod') {
          node.computed = false;
        }
        return this.finishNode(node, 'MethodDefinition');
      }
      nameIsConstructor(key) {
        if (key.type === 'Literal') return key.value === 'constructor';
        return super.nameIsConstructor(key);
      }
      parseClassProperty(...args) {
        const propertyNode = super.parseClassProperty(...args);
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return propertyNode;
          }
        }
        propertyNode.type = 'PropertyDefinition';
        return propertyNode;
      }
      parseClassPrivateProperty(...args) {
        const propertyNode = super.parseClassPrivateProperty(...args);
        {
          if (!this.getPluginOption('estree', 'classFeatures')) {
            return propertyNode;
          }
        }
        propertyNode.type = 'PropertyDefinition';
        propertyNode.computed = false;
        return propertyNode;
      }
      parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
        const node = super.parseObjectMethod(
          prop,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor
        );
        if (node) {
          node.type = 'Property';
          if (node.kind === 'method') {
            node.kind = 'init';
          }
          node.shorthand = false;
        }
        return node;
      }
      parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
        const node = super.parseObjectProperty(
          prop,
          startLoc,
          isPattern,
          refExpressionErrors
        );
        if (node) {
          node.kind = 'init';
          node.type = 'Property';
        }
        return node;
      }
      isValidLVal(type, isUnparenthesizedInAssign, binding) {
        return type === 'Property'
          ? 'value'
          : super.isValidLVal(type, isUnparenthesizedInAssign, binding);
      }
      isAssignable(node, isBinding) {
        if (node != null && this.isObjectProperty(node)) {
          return this.isAssignable(node.value, isBinding);
        }
        return super.isAssignable(node, isBinding);
      }
      toAssignable(node, isLHS = false) {
        if (node != null && this.isObjectProperty(node)) {
          const {key: key, value: value} = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(
              this.getPrivateNameSV(key),
              key.loc.start
            );
          }
          this.toAssignable(value, isLHS);
        } else {
          super.toAssignable(node, isLHS);
        }
      }
      toAssignableObjectExpressionProp(prop, isLast, isLHS) {
        if (
          prop.type === 'Property' &&
          (prop.kind === 'get' || prop.kind === 'set')
        ) {
          this.raise(Errors.PatternHasAccessor, prop.key);
        } else if (prop.type === 'Property' && prop.method) {
          this.raise(Errors.PatternHasMethod, prop.key);
        } else {
          super.toAssignableObjectExpressionProp(prop, isLast, isLHS);
        }
      }
      finishCallExpression(unfinished, optional) {
        const node = super.finishCallExpression(unfinished, optional);
        if (node.callee.type === 'Import') {
          node.type = 'ImportExpression';
          node.source = node.arguments[0];
          if (
            this.hasPlugin('importAttributes') ||
            this.hasPlugin('importAssertions')
          ) {
            var _ref, _ref2;
            node.options = (_ref = node.arguments[1]) != null ? _ref : null;
            node.attributes =
              (_ref2 = node.arguments[1]) != null ? _ref2 : null;
          }
          delete node.arguments;
          delete node.callee;
        }
        return node;
      }
      toReferencedArguments(node) {
        if (node.type === 'ImportExpression') {
          return;
        }
        super.toReferencedArguments(node);
      }
      parseExport(unfinished, decorators) {
        const exportStartLoc = this.state.lastTokStartLoc;
        const node = super.parseExport(unfinished, decorators);
        switch (node.type) {
          case 'ExportAllDeclaration':
            node.exported = null;
            break;
          case 'ExportNamedDeclaration':
            if (
              node.specifiers.length === 1 &&
              node.specifiers[0].type === 'ExportNamespaceSpecifier'
            ) {
              node.type = 'ExportAllDeclaration';
              node.exported = node.specifiers[0].exported;
              delete node.specifiers;
            }
          case 'ExportDefaultDeclaration':
            {
              var _declaration$decorato;
              const {declaration: declaration} = node;
              if (
                (declaration == null ? void 0 : declaration.type) ===
                  'ClassDeclaration' &&
                ((_declaration$decorato = declaration.decorators) == null
                  ? void 0
                  : _declaration$decorato.length) > 0 &&
                declaration.start === node.start
              ) {
                this.resetStartLocation(node, exportStartLoc);
              }
            }
            break;
        }
        return node;
      }
      parseSubscript(base, startLoc, noCalls, state) {
        const node = super.parseSubscript(base, startLoc, noCalls, state);
        if (state.optionalChainMember) {
          if (
            node.type === 'OptionalMemberExpression' ||
            node.type === 'OptionalCallExpression'
          ) {
            node.type = node.type.substring(8);
          }
          if (state.stop) {
            const chain = this.startNodeAtNode(node);
            chain.expression = node;
            return this.finishNode(chain, 'ChainExpression');
          }
        } else if (
          node.type === 'MemberExpression' ||
          node.type === 'CallExpression'
        ) {
          node.optional = false;
        }
        return node;
      }
      isOptionalMemberExpression(node) {
        if (node.type === 'ChainExpression') {
          return node.expression.type === 'MemberExpression';
        }
        return super.isOptionalMemberExpression(node);
      }
      hasPropertyAsPrivateName(node) {
        if (node.type === 'ChainExpression') {
          node = node.expression;
        }
        return super.hasPropertyAsPrivateName(node);
      }
      isObjectProperty(node) {
        return node.type === 'Property' && node.kind === 'init' && !node.method;
      }
      isObjectMethod(node) {
        return (
          node.type === 'Property' &&
          (node.method || node.kind === 'get' || node.kind === 'set')
        );
      }
      finishNodeAt(node, type, endLoc) {
        return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
      }
      resetStartLocation(node, startLoc) {
        super.resetStartLocation(node, startLoc);
        toESTreeLocation(node);
      }
      resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
        super.resetEndLocation(node, endLoc);
        toESTreeLocation(node);
      }
    };
  class TokContext {
    constructor(token, preserveSpace) {
      this.token = void 0;
      this.preserveSpace = void 0;
      this.token = token;
      this.preserveSpace = !!preserveSpace;
    }
  }
  const types = {
    brace: new TokContext('{'),
    j_oTag: new TokContext('<tag'),
    j_cTag: new TokContext('</tag'),
    j_expr: new TokContext('<tag>...</tag>', true),
  };
  {
    types.template = new TokContext('`', true);
  }
  const beforeExpr = true;
  const startsExpr = true;
  const isLoop = true;
  const isAssign = true;
  const prefix = true;
  const postfix = true;
  class ExportedTokenType {
    constructor(label, conf = {}) {
      this.label = void 0;
      this.keyword = void 0;
      this.beforeExpr = void 0;
      this.startsExpr = void 0;
      this.rightAssociative = void 0;
      this.isLoop = void 0;
      this.isAssign = void 0;
      this.prefix = void 0;
      this.postfix = void 0;
      this.binop = void 0;
      this.label = label;
      this.keyword = conf.keyword;
      this.beforeExpr = !!conf.beforeExpr;
      this.startsExpr = !!conf.startsExpr;
      this.rightAssociative = !!conf.rightAssociative;
      this.isLoop = !!conf.isLoop;
      this.isAssign = !!conf.isAssign;
      this.prefix = !!conf.prefix;
      this.postfix = !!conf.postfix;
      this.binop = conf.binop != null ? conf.binop : null;
      {
        this.updateContext = null;
      }
    }
  }
  const keywords$1 = new Map();
  function createKeyword(name, options = {}) {
    options.keyword = name;
    const token = createToken(name, options);
    keywords$1.set(name, token);
    return token;
  }
  function createBinop(name, binop) {
    return createToken(name, {beforeExpr: beforeExpr, binop: binop});
  }
  let tokenTypeCounter = -1;
  const tokenTypes = [];
  const tokenLabels = [];
  const tokenBinops = [];
  const tokenBeforeExprs = [];
  const tokenStartsExprs = [];
  const tokenPrefixes = [];
  function createToken(name, options = {}) {
    var _options$binop,
      _options$beforeExpr,
      _options$startsExpr,
      _options$prefix;
    ++tokenTypeCounter;
    tokenLabels.push(name);
    tokenBinops.push(
      (_options$binop = options.binop) != null ? _options$binop : -1
    );
    tokenBeforeExprs.push(
      (_options$beforeExpr = options.beforeExpr) != null
        ? _options$beforeExpr
        : false
    );
    tokenStartsExprs.push(
      (_options$startsExpr = options.startsExpr) != null
        ? _options$startsExpr
        : false
    );
    tokenPrefixes.push(
      (_options$prefix = options.prefix) != null ? _options$prefix : false
    );
    tokenTypes.push(new ExportedTokenType(name, options));
    return tokenTypeCounter;
  }
  function createKeywordLike(name, options = {}) {
    var _options$binop2,
      _options$beforeExpr2,
      _options$startsExpr2,
      _options$prefix2;
    ++tokenTypeCounter;
    keywords$1.set(name, tokenTypeCounter);
    tokenLabels.push(name);
    tokenBinops.push(
      (_options$binop2 = options.binop) != null ? _options$binop2 : -1
    );
    tokenBeforeExprs.push(
      (_options$beforeExpr2 = options.beforeExpr) != null
        ? _options$beforeExpr2
        : false
    );
    tokenStartsExprs.push(
      (_options$startsExpr2 = options.startsExpr) != null
        ? _options$startsExpr2
        : false
    );
    tokenPrefixes.push(
      (_options$prefix2 = options.prefix) != null ? _options$prefix2 : false
    );
    tokenTypes.push(new ExportedTokenType('name', options));
    return tokenTypeCounter;
  }
  const tt = {
    bracketL: createToken('[', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketHashL: createToken('#[', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketBarL: createToken('[|', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    bracketR: createToken(']'),
    bracketBarR: createToken('|]'),
    braceL: createToken('{', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
    braceBarL: createToken('{|', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    braceHashL: createToken('#{', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    braceR: createToken('}'),
    braceBarR: createToken('|}'),
    parenL: createToken('(', {beforeExpr: beforeExpr, startsExpr: startsExpr}),
    parenR: createToken(')'),
    comma: createToken(',', {beforeExpr: beforeExpr}),
    semi: createToken(';', {beforeExpr: beforeExpr}),
    colon: createToken(':', {beforeExpr: beforeExpr}),
    doubleColon: createToken('::', {beforeExpr: beforeExpr}),
    dot: createToken('.'),
    question: createToken('?', {beforeExpr: beforeExpr}),
    questionDot: createToken('?.'),
    arrow: createToken('=>', {beforeExpr: beforeExpr}),
    template: createToken('template'),
    ellipsis: createToken('...', {beforeExpr: beforeExpr}),
    backQuote: createToken('`', {startsExpr: startsExpr}),
    dollarBraceL: createToken('${', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    templateTail: createToken('...`', {startsExpr: startsExpr}),
    templateNonTail: createToken('...${', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    at: createToken('@'),
    hash: createToken('#', {startsExpr: startsExpr}),
    interpreterDirective: createToken('#!...'),
    eq: createToken('=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    assign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    slashAssign: createToken('_=', {
      beforeExpr: beforeExpr,
      isAssign: isAssign,
    }),
    xorAssign: createToken('_=', {beforeExpr: beforeExpr, isAssign: isAssign}),
    moduloAssign: createToken('_=', {
      beforeExpr: beforeExpr,
      isAssign: isAssign,
    }),
    incDec: createToken('++/--', {
      prefix: prefix,
      postfix: postfix,
      startsExpr: startsExpr,
    }),
    bang: createToken('!', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    tilde: createToken('~', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    doubleCaret: createToken('^^', {startsExpr: startsExpr}),
    doubleAt: createToken('@@', {startsExpr: startsExpr}),
    pipeline: createBinop('|>', 0),
    nullishCoalescing: createBinop('??', 1),
    logicalOR: createBinop('||', 1),
    logicalAND: createBinop('&&', 2),
    bitwiseOR: createBinop('|', 3),
    bitwiseXOR: createBinop('^', 4),
    bitwiseAND: createBinop('&', 5),
    equality: createBinop('==/!=/===/!==', 6),
    lt: createBinop('</>/<=/>=', 7),
    gt: createBinop('</>/<=/>=', 7),
    relational: createBinop('</>/<=/>=', 7),
    bitShift: createBinop('<</>>/>>>', 8),
    bitShiftL: createBinop('<</>>/>>>', 8),
    bitShiftR: createBinop('<</>>/>>>', 8),
    plusMin: createToken('+/-', {
      beforeExpr: beforeExpr,
      binop: 9,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    modulo: createToken('%', {binop: 10, startsExpr: startsExpr}),
    star: createToken('*', {binop: 10}),
    slash: createBinop('/', 10),
    exponent: createToken('**', {
      beforeExpr: beforeExpr,
      binop: 11,
      rightAssociative: true,
    }),
    _in: createKeyword('in', {beforeExpr: beforeExpr, binop: 7}),
    _instanceof: createKeyword('instanceof', {
      beforeExpr: beforeExpr,
      binop: 7,
    }),
    _break: createKeyword('break'),
    _case: createKeyword('case', {beforeExpr: beforeExpr}),
    _catch: createKeyword('catch'),
    _continue: createKeyword('continue'),
    _debugger: createKeyword('debugger'),
    _default: createKeyword('default', {beforeExpr: beforeExpr}),
    _else: createKeyword('else', {beforeExpr: beforeExpr}),
    _finally: createKeyword('finally'),
    _function: createKeyword('function', {startsExpr: startsExpr}),
    _if: createKeyword('if'),
    _return: createKeyword('return', {beforeExpr: beforeExpr}),
    _switch: createKeyword('switch'),
    _throw: createKeyword('throw', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _try: createKeyword('try'),
    _var: createKeyword('var'),
    _const: createKeyword('const'),
    _with: createKeyword('with'),
    _new: createKeyword('new', {
      beforeExpr: beforeExpr,
      startsExpr: startsExpr,
    }),
    _this: createKeyword('this', {startsExpr: startsExpr}),
    _super: createKeyword('super', {startsExpr: startsExpr}),
    _class: createKeyword('class', {startsExpr: startsExpr}),
    _extends: createKeyword('extends', {beforeExpr: beforeExpr}),
    _export: createKeyword('export'),
    _import: createKeyword('import', {startsExpr: startsExpr}),
    _null: createKeyword('null', {startsExpr: startsExpr}),
    _true: createKeyword('true', {startsExpr: startsExpr}),
    _false: createKeyword('false', {startsExpr: startsExpr}),
    _typeof: createKeyword('typeof', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _void: createKeyword('void', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _delete: createKeyword('delete', {
      beforeExpr: beforeExpr,
      prefix: prefix,
      startsExpr: startsExpr,
    }),
    _do: createKeyword('do', {isLoop: isLoop, beforeExpr: beforeExpr}),
    _for: createKeyword('for', {isLoop: isLoop}),
    _while: createKeyword('while', {isLoop: isLoop}),
    _as: createKeywordLike('as', {startsExpr: startsExpr}),
    _assert: createKeywordLike('assert', {startsExpr: startsExpr}),
    _async: createKeywordLike('async', {startsExpr: startsExpr}),
    _await: createKeywordLike('await', {startsExpr: startsExpr}),
    _defer: createKeywordLike('defer', {startsExpr: startsExpr}),
    _from: createKeywordLike('from', {startsExpr: startsExpr}),
    _get: createKeywordLike('get', {startsExpr: startsExpr}),
    _let: createKeywordLike('let', {startsExpr: startsExpr}),
    _meta: createKeywordLike('meta', {startsExpr: startsExpr}),
    _of: createKeywordLike('of', {startsExpr: startsExpr}),
    _sent: createKeywordLike('sent', {startsExpr: startsExpr}),
    _set: createKeywordLike('set', {startsExpr: startsExpr}),
    _source: createKeywordLike('source', {startsExpr: startsExpr}),
    _static: createKeywordLike('static', {startsExpr: startsExpr}),
    _using: createKeywordLike('using', {startsExpr: startsExpr}),
    _yield: createKeywordLike('yield', {startsExpr: startsExpr}),
    _asserts: createKeywordLike('asserts', {startsExpr: startsExpr}),
    _checks: createKeywordLike('checks', {startsExpr: startsExpr}),
    _exports: createKeywordLike('exports', {startsExpr: startsExpr}),
    _global: createKeywordLike('global', {startsExpr: startsExpr}),
    _implements: createKeywordLike('implements', {startsExpr: startsExpr}),
    _intrinsic: createKeywordLike('intrinsic', {startsExpr: startsExpr}),
    _infer: createKeywordLike('infer', {startsExpr: startsExpr}),
    _is: createKeywordLike('is', {startsExpr: startsExpr}),
    _mixins: createKeywordLike('mixins', {startsExpr: startsExpr}),
    _proto: createKeywordLike('proto', {startsExpr: startsExpr}),
    _require: createKeywordLike('require', {startsExpr: startsExpr}),
    _satisfies: createKeywordLike('satisfies', {startsExpr: startsExpr}),
    _keyof: createKeywordLike('keyof', {startsExpr: startsExpr}),
    _readonly: createKeywordLike('readonly', {startsExpr: startsExpr}),
    _unique: createKeywordLike('unique', {startsExpr: startsExpr}),
    _abstract: createKeywordLike('abstract', {startsExpr: startsExpr}),
    _declare: createKeywordLike('declare', {startsExpr: startsExpr}),
    _enum: createKeywordLike('enum', {startsExpr: startsExpr}),
    _module: createKeywordLike('module', {startsExpr: startsExpr}),
    _namespace: createKeywordLike('namespace', {startsExpr: startsExpr}),
    _interface: createKeywordLike('interface', {startsExpr: startsExpr}),
    _type: createKeywordLike('type', {startsExpr: startsExpr}),
    _opaque: createKeywordLike('opaque', {startsExpr: startsExpr}),
    name: createToken('name', {startsExpr: startsExpr}),
    string: createToken('string', {startsExpr: startsExpr}),
    num: createToken('num', {startsExpr: startsExpr}),
    bigint: createToken('bigint', {startsExpr: startsExpr}),
    decimal: createToken('decimal', {startsExpr: startsExpr}),
    regexp: createToken('regexp', {startsExpr: startsExpr}),
    privateName: createToken('#name', {startsExpr: startsExpr}),
    eof: createToken('eof'),
    jsxName: createToken('jsxName'),
    jsxText: createToken('jsxText', {beforeExpr: true}),
    jsxTagStart: createToken('jsxTagStart', {startsExpr: true}),
    jsxTagEnd: createToken('jsxTagEnd'),
    placeholder: createToken('%%', {startsExpr: true}),
  };
  function tokenIsIdentifier(token) {
    return token >= 93 && token <= 132;
  }
  function tokenKeywordOrIdentifierIsKeyword(token) {
    return token <= 92;
  }
  function tokenIsKeywordOrIdentifier(token) {
    return token >= 58 && token <= 132;
  }
  function tokenIsLiteralPropertyName(token) {
    return token >= 58 && token <= 136;
  }
  function tokenComesBeforeExpression(token) {
    return tokenBeforeExprs[token];
  }
  function tokenCanStartExpression(token) {
    return tokenStartsExprs[token];
  }
  function tokenIsAssignment(token) {
    return token >= 29 && token <= 33;
  }
  function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
    return token >= 129 && token <= 131;
  }
  function tokenIsLoop(token) {
    return token >= 90 && token <= 92;
  }
  function tokenIsKeyword(token) {
    return token >= 58 && token <= 92;
  }
  function tokenIsOperator(token) {
    return token >= 39 && token <= 59;
  }
  function tokenIsPostfix(token) {
    return token === 34;
  }
  function tokenIsPrefix(token) {
    return tokenPrefixes[token];
  }
  function tokenIsTSTypeOperator(token) {
    return token >= 121 && token <= 123;
  }
  function tokenIsTSDeclarationStart(token) {
    return token >= 124 && token <= 130;
  }
  function tokenLabelName(token) {
    return tokenLabels[token];
  }
  function tokenOperatorPrecedence(token) {
    return tokenBinops[token];
  }
  function tokenIsRightAssociative(token) {
    return token === 57;
  }
  function tokenIsTemplate(token) {
    return token >= 24 && token <= 25;
  }
  function getExportedToken(token) {
    return tokenTypes[token];
  }
  {
    tokenTypes[8].updateContext = context => {
      context.pop();
    };
    tokenTypes[5].updateContext =
      tokenTypes[7].updateContext =
      tokenTypes[23].updateContext =
        context => {
          context.push(types.brace);
        };
    tokenTypes[22].updateContext = context => {
      if (context[context.length - 1] === types.template) {
        context.pop();
      } else {
        context.push(types.template);
      }
    };
    tokenTypes[142].updateContext = context => {
      context.push(types.j_expr, types.j_oTag);
    };
  }
  let nonASCIIidentifierStartChars =
    'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲈᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟊꟐꟑꟓꟕ-ꟙꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
  let nonASCIIidentifierChars =
    '‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛࢘-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･';
  const nonASCIIidentifierStart = new RegExp(
    '[' + nonASCIIidentifierStartChars + ']'
  );
  const nonASCIIidentifier = new RegExp(
    '[' + nonASCIIidentifierStartChars + nonASCIIidentifierChars + ']'
  );
  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
  const astralIdentifierStartCodes = [
    0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48,
    48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5,
    39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10,
    21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11,
    22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2,
    2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72,
    56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20,
    28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4,
    0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2,
    14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4,
    159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0,
    60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2,
    23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12,
    45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0,
    26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921,
    103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30,
    18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67,
    12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16,
    0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2,
    70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2,
    27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2,
    24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11,
    6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60,
    67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5,
    0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0,
    3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719,
    33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6,
    4191,
  ];
  const astralIdentifierCodes = [
    509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1,
    574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1,
    11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13,
    9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3,
    2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3,
    8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5,
    2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0,
    10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2,
    6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4,
    14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54,
    8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31,
    3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2,
    16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983,
    6, 110, 6, 6, 9, 4759, 9, 787719, 239,
  ];
  function isInAstralSet(code, set) {
    let pos = 65536;
    for (let i = 0, length = set.length; i < length; i += 2) {
      pos += set[i];
      if (pos > code) return false;
      pos += set[i + 1];
      if (pos >= code) return true;
    }
    return false;
  }
  function isIdentifierStart(code) {
    if (code < 65) return code === 36;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return (
        code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code))
      );
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
  }
  function isIdentifierChar(code) {
    if (code < 48) return code === 36;
    if (code < 58) return true;
    if (code < 65) return false;
    if (code <= 90) return true;
    if (code < 97) return code === 95;
    if (code <= 122) return true;
    if (code <= 65535) {
      return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    return (
      isInAstralSet(code, astralIdentifierStartCodes) ||
      isInAstralSet(code, astralIdentifierCodes)
    );
  }
  const reservedWords = {
    keyword: [
      'break',
      'case',
      'catch',
      'continue',
      'debugger',
      'default',
      'do',
      'else',
      'finally',
      'for',
      'function',
      'if',
      'return',
      'switch',
      'throw',
      'try',
      'var',
      'const',
      'while',
      'with',
      'new',
      'this',
      'super',
      'class',
      'extends',
      'export',
      'import',
      'null',
      'true',
      'false',
      'in',
      'instanceof',
      'typeof',
      'void',
      'delete',
    ],
    strict: [
      'implements',
      'interface',
      'let',
      'package',
      'private',
      'protected',
      'public',
      'static',
      'yield',
    ],
    strictBind: ['eval', 'arguments'],
  };
  const keywords = new Set(reservedWords.keyword);
  const reservedWordsStrictSet = new Set(reservedWords.strict);
  const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
  function isReservedWord(word, inModule) {
    return (inModule && word === 'await') || word === 'enum';
  }
  function isStrictReservedWord(word, inModule) {
    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
  }
  function isStrictBindOnlyReservedWord(word) {
    return reservedWordsStrictBindSet.has(word);
  }
  function isStrictBindReservedWord(word, inModule) {
    return (
      isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word)
    );
  }
  function isKeyword(word) {
    return keywords.has(word);
  }
  function isIteratorStart(current, next, next2) {
    return current === 64 && next === 64 && isIdentifierStart(next2);
  }
  const reservedWordLikeSet = new Set([
    'break',
    'case',
    'catch',
    'continue',
    'debugger',
    'default',
    'do',
    'else',
    'finally',
    'for',
    'function',
    'if',
    'return',
    'switch',
    'throw',
    'try',
    'var',
    'const',
    'while',
    'with',
    'new',
    'this',
    'super',
    'class',
    'extends',
    'export',
    'import',
    'null',
    'true',
    'false',
    'in',
    'instanceof',
    'typeof',
    'void',
    'delete',
    'implements',
    'interface',
    'let',
    'package',
    'private',
    'protected',
    'public',
    'static',
    'yield',
    'eval',
    'arguments',
    'enum',
    'await',
  ]);
  function canBeReservedWord(word) {
    return reservedWordLikeSet.has(word);
  }
  class Scope {
    constructor(flags) {
      this.flags = 0;
      this.names = new Map();
      this.firstLexicalName = '';
      this.flags = flags;
    }
  }
  class ScopeHandler {
    constructor(parser, inModule) {
      this.parser = void 0;
      this.scopeStack = [];
      this.inModule = void 0;
      this.undefinedExports = new Map();
      this.parser = parser;
      this.inModule = inModule;
    }
    get inTopLevel() {
      return (this.currentScope().flags & 1) > 0;
    }
    get inFunction() {
      return (this.currentVarScopeFlags() & 2) > 0;
    }
    get allowSuper() {
      return (this.currentThisScopeFlags() & 16) > 0;
    }
    get allowDirectSuper() {
      return (this.currentThisScopeFlags() & 32) > 0;
    }
    get inClass() {
      return (this.currentThisScopeFlags() & 64) > 0;
    }
    get inClassAndNotInNonArrowFunction() {
      const flags = this.currentThisScopeFlags();
      return (flags & 64) > 0 && (flags & 2) === 0;
    }
    get inStaticBlock() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & 128) {
          return true;
        }
        if (flags & (387 | 64)) {
          return false;
        }
      }
    }
    get inNonArrowFunction() {
      return (this.currentThisScopeFlags() & 2) > 0;
    }
    get treatFunctionsAsVar() {
      return this.treatFunctionsAsVarInScope(this.currentScope());
    }
    createScope(flags) {
      return new Scope(flags);
    }
    enter(flags) {
      this.scopeStack.push(this.createScope(flags));
    }
    exit() {
      const scope = this.scopeStack.pop();
      return scope.flags;
    }
    treatFunctionsAsVarInScope(scope) {
      return !!(
        scope.flags & (2 | 128) ||
        (!this.parser.inModule && scope.flags & 1)
      );
    }
    declareName(name, bindingType, loc) {
      let scope = this.currentScope();
      if (bindingType & 8 || bindingType & 16) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        let type = scope.names.get(name) || 0;
        if (bindingType & 16) {
          type = type | 4;
        } else {
          if (!scope.firstLexicalName) {
            scope.firstLexicalName = name;
          }
          type = type | 2;
        }
        scope.names.set(name, type);
        if (bindingType & 8) {
          this.maybeExportDefined(scope, name);
        }
      } else if (bindingType & 4) {
        for (let i = this.scopeStack.length - 1; i >= 0; --i) {
          scope = this.scopeStack[i];
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          scope.names.set(name, (scope.names.get(name) || 0) | 1);
          this.maybeExportDefined(scope, name);
          if (scope.flags & 387) break;
        }
      }
      if (this.parser.inModule && scope.flags & 1) {
        this.undefinedExports.delete(name);
      }
    }
    maybeExportDefined(scope, name) {
      if (this.parser.inModule && scope.flags & 1) {
        this.undefinedExports.delete(name);
      }
    }
    checkRedeclarationInScope(scope, name, bindingType, loc) {
      if (this.isRedeclaredInScope(scope, name, bindingType)) {
        this.parser.raise(Errors.VarRedeclaration, loc, {identifierName: name});
      }
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (!(bindingType & 1)) return false;
      if (bindingType & 8) {
        return scope.names.has(name);
      }
      const type = scope.names.get(name);
      if (bindingType & 16) {
        return (
          (type & 2) > 0 ||
          (!this.treatFunctionsAsVarInScope(scope) && (type & 1) > 0)
        );
      }
      return (
        ((type & 2) > 0 &&
          !(scope.flags & 8 && scope.firstLexicalName === name)) ||
        (!this.treatFunctionsAsVarInScope(scope) && (type & 4) > 0)
      );
    }
    checkLocalExport(id) {
      const {name: name} = id;
      const topLevelScope = this.scopeStack[0];
      if (!topLevelScope.names.has(name)) {
        this.undefinedExports.set(name, id.loc.start);
      }
    }
    currentScope() {
      return this.scopeStack[this.scopeStack.length - 1];
    }
    currentVarScopeFlags() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & 387) {
          return flags;
        }
      }
    }
    currentThisScopeFlags() {
      for (let i = this.scopeStack.length - 1; ; i--) {
        const {flags: flags} = this.scopeStack[i];
        if (flags & (387 | 64) && !(flags & 4)) {
          return flags;
        }
      }
    }
  }
  class FlowScope extends Scope {
    constructor(...args) {
      super(...args);
      this.declareFunctions = new Set();
    }
  }
  class FlowScopeHandler extends ScopeHandler {
    createScope(flags) {
      return new FlowScope(flags);
    }
    declareName(name, bindingType, loc) {
      const scope = this.currentScope();
      if (bindingType & 2048) {
        this.checkRedeclarationInScope(scope, name, bindingType, loc);
        this.maybeExportDefined(scope, name);
        scope.declareFunctions.add(name);
        return;
      }
      super.declareName(name, bindingType, loc);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      if (super.isRedeclaredInScope(scope, name, bindingType)) return true;
      if (bindingType & 2048 && !scope.declareFunctions.has(name)) {
        const type = scope.names.get(name);
        return (type & 4) > 0 || (type & 2) > 0;
      }
      return false;
    }
    checkLocalExport(id) {
      if (!this.scopeStack[0].declareFunctions.has(id.name)) {
        super.checkLocalExport(id);
      }
    }
  }
  class BaseParser {
    constructor() {
      this.sawUnambiguousESM = false;
      this.ambiguousScriptDifferentAst = false;
    }
    hasPlugin(pluginConfig) {
      if (typeof pluginConfig === 'string') {
        return this.plugins.has(pluginConfig);
      } else {
        const [pluginName, pluginOptions] = pluginConfig;
        if (!this.hasPlugin(pluginName)) {
          return false;
        }
        const actualOptions = this.plugins.get(pluginName);
        for (const key of Object.keys(pluginOptions)) {
          if (
            (actualOptions == null ? void 0 : actualOptions[key]) !==
            pluginOptions[key]
          ) {
            return false;
          }
        }
        return true;
      }
    }
    getPluginOption(plugin, name) {
      var _this$plugins$get;
      return (_this$plugins$get = this.plugins.get(plugin)) == null
        ? void 0
        : _this$plugins$get[name];
    }
  }
  function setTrailingComments(node, comments) {
    if (node.trailingComments === undefined) {
      node.trailingComments = comments;
    } else {
      node.trailingComments.unshift(...comments);
    }
  }
  function setLeadingComments(node, comments) {
    if (node.leadingComments === undefined) {
      node.leadingComments = comments;
    } else {
      node.leadingComments.unshift(...comments);
    }
  }
  function setInnerComments(node, comments) {
    if (node.innerComments === undefined) {
      node.innerComments = comments;
    } else {
      node.innerComments.unshift(...comments);
    }
  }
  function adjustInnerComments(node, elements, commentWS) {
    let lastElement = null;
    let i = elements.length;
    while (lastElement === null && i > 0) {
      lastElement = elements[--i];
    }
    if (lastElement === null || lastElement.start > commentWS.start) {
      setInnerComments(node, commentWS.comments);
    } else {
      setTrailingComments(lastElement, commentWS.comments);
    }
  }
  class CommentsParser extends BaseParser {
    addComment(comment) {
      if (this.filename) comment.loc.filename = this.filename;
      const {commentsLen: commentsLen} = this.state;
      if (this.comments.length !== commentsLen) {
        this.comments.length = commentsLen;
      }
      this.comments.push(comment);
      this.state.commentsLen++;
    }
    processComment(node) {
      const {commentStack: commentStack} = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0) return;
      let i = commentStackLength - 1;
      const lastCommentWS = commentStack[i];
      if (lastCommentWS.start === node.end) {
        lastCommentWS.leadingNode = node;
        i--;
      }
      const {start: nodeStart} = node;
      for (; i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        if (commentEnd > nodeStart) {
          commentWS.containingNode = node;
          this.finalizeComment(commentWS);
          commentStack.splice(i, 1);
        } else {
          if (commentEnd === nodeStart) {
            commentWS.trailingNode = node;
          }
          break;
        }
      }
    }
    finalizeComment(commentWS) {
      const {comments: comments} = commentWS;
      if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
        if (commentWS.leadingNode !== null) {
          setTrailingComments(commentWS.leadingNode, comments);
        }
        if (commentWS.trailingNode !== null) {
          setLeadingComments(commentWS.trailingNode, comments);
        }
      } else {
        const {containingNode: node, start: commentStart} = commentWS;
        if (this.input.charCodeAt(commentStart - 1) === 44) {
          switch (node.type) {
            case 'ObjectExpression':
            case 'ObjectPattern':
            case 'RecordExpression':
              adjustInnerComments(node, node.properties, commentWS);
              break;
            case 'CallExpression':
            case 'OptionalCallExpression':
              adjustInnerComments(node, node.arguments, commentWS);
              break;
            case 'FunctionDeclaration':
            case 'FunctionExpression':
            case 'ArrowFunctionExpression':
            case 'ObjectMethod':
            case 'ClassMethod':
            case 'ClassPrivateMethod':
              adjustInnerComments(node, node.params, commentWS);
              break;
            case 'ArrayExpression':
            case 'ArrayPattern':
            case 'TupleExpression':
              adjustInnerComments(node, node.elements, commentWS);
              break;
            case 'ExportNamedDeclaration':
            case 'ImportDeclaration':
              adjustInnerComments(node, node.specifiers, commentWS);
              break;
            default: {
              setInnerComments(node, comments);
            }
          }
        } else {
          setInnerComments(node, comments);
        }
      }
    }
    finalizeRemainingComments() {
      const {commentStack: commentStack} = this.state;
      for (let i = commentStack.length - 1; i >= 0; i--) {
        this.finalizeComment(commentStack[i]);
      }
      this.state.commentStack = [];
    }
    resetPreviousNodeTrailingComments(node) {
      const {commentStack: commentStack} = this.state;
      const {length: length} = commentStack;
      if (length === 0) return;
      const commentWS = commentStack[length - 1];
      if (commentWS.leadingNode === node) {
        commentWS.leadingNode = null;
      }
    }
    resetPreviousIdentifierLeadingComments(node) {
      const {commentStack: commentStack} = this.state;
      const {length: length} = commentStack;
      if (length === 0) return;
      if (commentStack[length - 1].trailingNode === node) {
        commentStack[length - 1].trailingNode = null;
      } else if (
        length >= 2 &&
        commentStack[length - 2].trailingNode === node
      ) {
        commentStack[length - 2].trailingNode = null;
      }
    }
    takeSurroundingComments(node, start, end) {
      const {commentStack: commentStack} = this.state;
      const commentStackLength = commentStack.length;
      if (commentStackLength === 0) return;
      let i = commentStackLength - 1;
      for (; i >= 0; i--) {
        const commentWS = commentStack[i];
        const commentEnd = commentWS.end;
        const commentStart = commentWS.start;
        if (commentStart === end) {
          commentWS.leadingNode = node;
        } else if (commentEnd === start) {
          commentWS.trailingNode = node;
        } else if (commentEnd < start) {
          break;
        }
      }
    }
  }
  const lineBreak = /\r\n|[\r\n\u2028\u2029]/;
  const lineBreakG = new RegExp(lineBreak.source, 'g');
  function isNewLine(code) {
    switch (code) {
      case 10:
      case 13:
      case 8232:
      case 8233:
        return true;
      default:
        return false;
    }
  }
  function hasNewLine(input, start, end) {
    for (let i = start; i < end; i++) {
      if (isNewLine(input.charCodeAt(i))) {
        return true;
      }
    }
    return false;
  }
  const skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
  const skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
  function isWhitespace(code) {
    switch (code) {
      case 9:
      case 11:
      case 12:
      case 32:
      case 160:
      case 5760:
      case 8192:
      case 8193:
      case 8194:
      case 8195:
      case 8196:
      case 8197:
      case 8198:
      case 8199:
      case 8200:
      case 8201:
      case 8202:
      case 8239:
      case 8287:
      case 12288:
      case 65279:
        return true;
      default:
        return false;
    }
  }
  class State {
    constructor() {
      this.flags = 1024;
      this.curLine = void 0;
      this.lineStart = void 0;
      this.startLoc = void 0;
      this.endLoc = void 0;
      this.errors = [];
      this.potentialArrowAt = -1;
      this.noArrowAt = [];
      this.noArrowParamsConversionAt = [];
      this.topicContext = {maxNumOfResolvableTopics: 0, maxTopicIndex: null};
      this.labels = [];
      this.commentsLen = 0;
      this.commentStack = [];
      this.pos = 0;
      this.type = 139;
      this.value = null;
      this.start = 0;
      this.end = 0;
      this.lastTokEndLoc = null;
      this.lastTokStartLoc = null;
      this.context = [types.brace];
      this.firstInvalidTemplateEscapePos = null;
      this.strictErrors = new Map();
      this.tokensLength = 0;
    }
    get strict() {
      return (this.flags & 1) > 0;
    }
    set strict(v) {
      if (v) this.flags |= 1;
      else this.flags &= -2;
    }
    init({
      strictMode: strictMode,
      sourceType: sourceType,
      startLine: startLine,
      startColumn: startColumn,
    }) {
      this.strict =
        strictMode === false
          ? false
          : strictMode === true
            ? true
            : sourceType === 'module';
      this.curLine = startLine;
      this.lineStart = -startColumn;
      this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
    }
    get maybeInArrowParameters() {
      return (this.flags & 2) > 0;
    }
    set maybeInArrowParameters(v) {
      if (v) this.flags |= 2;
      else this.flags &= -3;
    }
    get inType() {
      return (this.flags & 4) > 0;
    }
    set inType(v) {
      if (v) this.flags |= 4;
      else this.flags &= -5;
    }
    get noAnonFunctionType() {
      return (this.flags & 8) > 0;
    }
    set noAnonFunctionType(v) {
      if (v) this.flags |= 8;
      else this.flags &= -9;
    }
    get hasFlowComment() {
      return (this.flags & 16) > 0;
    }
    set hasFlowComment(v) {
      if (v) this.flags |= 16;
      else this.flags &= -17;
    }
    get isAmbientContext() {
      return (this.flags & 32) > 0;
    }
    set isAmbientContext(v) {
      if (v) this.flags |= 32;
      else this.flags &= -33;
    }
    get inAbstractClass() {
      return (this.flags & 64) > 0;
    }
    set inAbstractClass(v) {
      if (v) this.flags |= 64;
      else this.flags &= -65;
    }
    get inDisallowConditionalTypesContext() {
      return (this.flags & 128) > 0;
    }
    set inDisallowConditionalTypesContext(v) {
      if (v) this.flags |= 128;
      else this.flags &= -129;
    }
    get soloAwait() {
      return (this.flags & 256) > 0;
    }
    set soloAwait(v) {
      if (v) this.flags |= 256;
      else this.flags &= -257;
    }
    get inFSharpPipelineDirectBody() {
      return (this.flags & 512) > 0;
    }
    set inFSharpPipelineDirectBody(v) {
      if (v) this.flags |= 512;
      else this.flags &= -513;
    }
    get canStartJSXElement() {
      return (this.flags & 1024) > 0;
    }
    set canStartJSXElement(v) {
      if (v) this.flags |= 1024;
      else this.flags &= -1025;
    }
    get containsEsc() {
      return (this.flags & 2048) > 0;
    }
    set containsEsc(v) {
      if (v) this.flags |= 2048;
      else this.flags &= -2049;
    }
    get hasTopLevelAwait() {
      return (this.flags & 4096) > 0;
    }
    set hasTopLevelAwait(v) {
      if (v) this.flags |= 4096;
      else this.flags &= -4097;
    }
    curPosition() {
      return new Position(this.curLine, this.pos - this.lineStart, this.pos);
    }
    clone() {
      const state = new State();
      state.flags = this.flags;
      state.curLine = this.curLine;
      state.lineStart = this.lineStart;
      state.startLoc = this.startLoc;
      state.endLoc = this.endLoc;
      state.errors = this.errors.slice();
      state.potentialArrowAt = this.potentialArrowAt;
      state.noArrowAt = this.noArrowAt.slice();
      state.noArrowParamsConversionAt = this.noArrowParamsConversionAt.slice();
      state.topicContext = this.topicContext;
      state.labels = this.labels.slice();
      state.commentsLen = this.commentsLen;
      state.commentStack = this.commentStack.slice();
      state.pos = this.pos;
      state.type = this.type;
      state.value = this.value;
      state.start = this.start;
      state.end = this.end;
      state.lastTokEndLoc = this.lastTokEndLoc;
      state.lastTokStartLoc = this.lastTokStartLoc;
      state.context = this.context.slice();
      state.firstInvalidTemplateEscapePos = this.firstInvalidTemplateEscapePos;
      state.strictErrors = this.strictErrors;
      state.tokensLength = this.tokensLength;
      return state;
    }
  }
  var _isDigit = function isDigit(code) {
    return code >= 48 && code <= 57;
  };
  const forbiddenNumericSeparatorSiblings = {
    decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
    hex: new Set([46, 88, 95, 120]),
  };
  const isAllowedNumericSeparatorSibling = {
    bin: ch => ch === 48 || ch === 49,
    oct: ch => ch >= 48 && ch <= 55,
    dec: ch => ch >= 48 && ch <= 57,
    hex: ch =>
      (ch >= 48 && ch <= 57) ||
      (ch >= 65 && ch <= 70) ||
      (ch >= 97 && ch <= 102),
  };
  function readStringContents(type, input, pos, lineStart, curLine, errors) {
    const initialPos = pos;
    const initialLineStart = lineStart;
    const initialCurLine = curLine;
    let out = '';
    let firstInvalidLoc = null;
    let chunkStart = pos;
    const {length: length} = input;
    for (;;) {
      if (pos >= length) {
        errors.unterminated(initialPos, initialLineStart, initialCurLine);
        out += input.slice(chunkStart, pos);
        break;
      }
      const ch = input.charCodeAt(pos);
      if (isStringEnd(type, ch, input, pos)) {
        out += input.slice(chunkStart, pos);
        break;
      }
      if (ch === 92) {
        out += input.slice(chunkStart, pos);
        const res = readEscapedChar(
          input,
          pos,
          lineStart,
          curLine,
          type === 'template',
          errors
        );
        if (res.ch === null && !firstInvalidLoc) {
          firstInvalidLoc = {pos: pos, lineStart: lineStart, curLine: curLine};
        } else {
          out += res.ch;
        }
        ({pos: pos, lineStart: lineStart, curLine: curLine} = res);
        chunkStart = pos;
      } else if (ch === 8232 || ch === 8233) {
        ++pos;
        ++curLine;
        lineStart = pos;
      } else if (ch === 10 || ch === 13) {
        if (type === 'template') {
          out += input.slice(chunkStart, pos) + '\n';
          ++pos;
          if (ch === 13 && input.charCodeAt(pos) === 10) {
            ++pos;
          }
          ++curLine;
          chunkStart = lineStart = pos;
        } else {
          errors.unterminated(initialPos, initialLineStart, initialCurLine);
        }
      } else {
        ++pos;
      }
    }
    return {
      pos: pos,
      str: out,
      firstInvalidLoc: firstInvalidLoc,
      lineStart: lineStart,
      curLine: curLine,
      containsInvalid: !!firstInvalidLoc,
    };
  }
  function isStringEnd(type, ch, input, pos) {
    if (type === 'template') {
      return ch === 96 || (ch === 36 && input.charCodeAt(pos + 1) === 123);
    }
    return ch === (type === 'double' ? 34 : 39);
  }
  function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
    const throwOnInvalid = !inTemplate;
    pos++;
    const res = ch => ({
      pos: pos,
      ch: ch,
      lineStart: lineStart,
      curLine: curLine,
    });
    const ch = input.charCodeAt(pos++);
    switch (ch) {
      case 110:
        return res('\n');
      case 114:
        return res('\r');
      case 120: {
        let code;
        ({code: code, pos: pos} = readHexChar(
          input,
          pos,
          lineStart,
          curLine,
          2,
          false,
          throwOnInvalid,
          errors
        ));
        return res(code === null ? null : String.fromCharCode(code));
      }
      case 117: {
        let code;
        ({code: code, pos: pos} = readCodePoint(
          input,
          pos,
          lineStart,
          curLine,
          throwOnInvalid,
          errors
        ));
        return res(code === null ? null : String.fromCodePoint(code));
      }
      case 116:
        return res('\t');
      case 98:
        return res('\b');
      case 118:
        return res('\v');
      case 102:
        return res('\f');
      case 13:
        if (input.charCodeAt(pos) === 10) {
          ++pos;
        }
      case 10:
        lineStart = pos;
        ++curLine;
      case 8232:
      case 8233:
        return res('');
      case 56:
      case 57:
        if (inTemplate) {
          return res(null);
        } else {
          errors.strictNumericEscape(pos - 1, lineStart, curLine);
        }
      default:
        if (ch >= 48 && ch <= 55) {
          const startPos = pos - 1;
          const match = /^[0-7]+/.exec(input.slice(startPos, pos + 2));
          let octalStr = match[0];
          let octal = parseInt(octalStr, 8);
          if (octal > 255) {
            octalStr = octalStr.slice(0, -1);
            octal = parseInt(octalStr, 8);
          }
          pos += octalStr.length - 1;
          const next = input.charCodeAt(pos);
          if (octalStr !== '0' || next === 56 || next === 57) {
            if (inTemplate) {
              return res(null);
            } else {
              errors.strictNumericEscape(startPos, lineStart, curLine);
            }
          }
          return res(String.fromCharCode(octal));
        }
        return res(String.fromCharCode(ch));
    }
  }
  function readHexChar(
    input,
    pos,
    lineStart,
    curLine,
    len,
    forceLen,
    throwOnInvalid,
    errors
  ) {
    const initialPos = pos;
    let n;
    ({n: n, pos: pos} = readInt(
      input,
      pos,
      lineStart,
      curLine,
      16,
      len,
      forceLen,
      false,
      errors,
      !throwOnInvalid
    ));
    if (n === null) {
      if (throwOnInvalid) {
        errors.invalidEscapeSequence(initialPos, lineStart, curLine);
      } else {
        pos = initialPos - 1;
      }
    }
    return {code: n, pos: pos};
  }
  function readInt(
    input,
    pos,
    lineStart,
    curLine,
    radix,
    len,
    forceLen,
    allowNumSeparator,
    errors,
    bailOnError
  ) {
    const start = pos;
    const forbiddenSiblings =
      radix === 16
        ? forbiddenNumericSeparatorSiblings.hex
        : forbiddenNumericSeparatorSiblings.decBinOct;
    const isAllowedSibling =
      radix === 16
        ? isAllowedNumericSeparatorSibling.hex
        : radix === 10
          ? isAllowedNumericSeparatorSibling.dec
          : radix === 8
            ? isAllowedNumericSeparatorSibling.oct
            : isAllowedNumericSeparatorSibling.bin;
    let invalid = false;
    let total = 0;
    for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
      const code = input.charCodeAt(pos);
      let val;
      if (code === 95 && allowNumSeparator !== 'bail') {
        const prev = input.charCodeAt(pos - 1);
        const next = input.charCodeAt(pos + 1);
        if (!allowNumSeparator) {
          if (bailOnError) return {n: null, pos: pos};
          errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
        } else if (
          Number.isNaN(next) ||
          !isAllowedSibling(next) ||
          forbiddenSiblings.has(prev) ||
          forbiddenSiblings.has(next)
        ) {
          if (bailOnError) return {n: null, pos: pos};
          errors.unexpectedNumericSeparator(pos, lineStart, curLine);
        }
        ++pos;
        continue;
      }
      if (code >= 97) {
        val = code - 97 + 10;
      } else if (code >= 65) {
        val = code - 65 + 10;
      } else if (_isDigit(code)) {
        val = code - 48;
      } else {
        val = Infinity;
      }
      if (val >= radix) {
        if (val <= 9 && bailOnError) {
          return {n: null, pos: pos};
        } else if (
          val <= 9 &&
          errors.invalidDigit(pos, lineStart, curLine, radix)
        ) {
          val = 0;
        } else if (forceLen) {
          val = 0;
          invalid = true;
        } else {
          break;
        }
      }
      ++pos;
      total = total * radix + val;
    }
    if (pos === start || (len != null && pos - start !== len) || invalid) {
      return {n: null, pos: pos};
    }
    return {n: total, pos: pos};
  }
  function readCodePoint(
    input,
    pos,
    lineStart,
    curLine,
    throwOnInvalid,
    errors
  ) {
    const ch = input.charCodeAt(pos);
    let code;
    if (ch === 123) {
      ++pos;
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        input.indexOf('}', pos) - pos,
        true,
        throwOnInvalid,
        errors
      ));
      ++pos;
      if (code !== null && code > 1114111) {
        if (throwOnInvalid) {
          errors.invalidCodePoint(pos, lineStart, curLine);
        } else {
          return {code: null, pos: pos};
        }
      }
    } else {
      ({code: code, pos: pos} = readHexChar(
        input,
        pos,
        lineStart,
        curLine,
        4,
        false,
        throwOnInvalid,
        errors
      ));
    }
    return {code: code, pos: pos};
  }
  function buildPosition(pos, lineStart, curLine) {
    return new Position(curLine, pos - lineStart, pos);
  }
  const VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
  class Token {
    constructor(state) {
      this.type = state.type;
      this.value = state.value;
      this.start = state.start;
      this.end = state.end;
      this.loc = new SourceLocation(state.startLoc, state.endLoc);
    }
  }
  class Tokenizer extends CommentsParser {
    constructor(options, input) {
      super();
      this.isLookahead = void 0;
      this.tokens = [];
      this.errorHandlers_readInt = {
        invalidDigit: (pos, lineStart, curLine, radix) => {
          if (!this.options.errorRecovery) return false;
          this.raise(
            Errors.InvalidDigit,
            buildPosition(pos, lineStart, curLine),
            {radix: radix}
          );
          return true;
        },
        numericSeparatorInEscapeSequence: this.errorBuilder(
          Errors.NumericSeparatorInEscapeSequence
        ),
        unexpectedNumericSeparator: this.errorBuilder(
          Errors.UnexpectedNumericSeparator
        ),
      };
      this.errorHandlers_readCodePoint = Object.assign(
        {},
        this.errorHandlers_readInt,
        {
          invalidEscapeSequence: this.errorBuilder(
            Errors.InvalidEscapeSequence
          ),
          invalidCodePoint: this.errorBuilder(Errors.InvalidCodePoint),
        }
      );
      this.errorHandlers_readStringContents_string = Object.assign(
        {},
        this.errorHandlers_readCodePoint,
        {
          strictNumericEscape: (pos, lineStart, curLine) => {
            this.recordStrictModeErrors(
              Errors.StrictNumericEscape,
              buildPosition(pos, lineStart, curLine)
            );
          },
          unterminated: (pos, lineStart, curLine) => {
            throw this.raise(
              Errors.UnterminatedString,
              buildPosition(pos - 1, lineStart, curLine)
            );
          },
        }
      );
      this.errorHandlers_readStringContents_template = Object.assign(
        {},
        this.errorHandlers_readCodePoint,
        {
          strictNumericEscape: this.errorBuilder(Errors.StrictNumericEscape),
          unterminated: (pos, lineStart, curLine) => {
            throw this.raise(
              Errors.UnterminatedTemplate,
              buildPosition(pos, lineStart, curLine)
            );
          },
        }
      );
      this.state = new State();
      this.state.init(options);
      this.input = input;
      this.length = input.length;
      this.comments = [];
      this.isLookahead = false;
    }
    pushToken(token) {
      this.tokens.length = this.state.tokensLength;
      this.tokens.push(token);
      ++this.state.tokensLength;
    }
    next() {
      this.checkKeywordEscapes();
      if (this.options.tokens) {
        this.pushToken(new Token(this.state));
      }
      this.state.lastTokEndLoc = this.state.endLoc;
      this.state.lastTokStartLoc = this.state.startLoc;
      this.nextToken();
    }
    eat(type) {
      if (this.match(type)) {
        this.next();
        return true;
      } else {
        return false;
      }
    }
    match(type) {
      return this.state.type === type;
    }
    createLookaheadState(state) {
      return {
        pos: state.pos,
        value: null,
        type: state.type,
        start: state.start,
        end: state.end,
        context: [this.curContext()],
        inType: state.inType,
        startLoc: state.startLoc,
        lastTokEndLoc: state.lastTokEndLoc,
        curLine: state.curLine,
        lineStart: state.lineStart,
        curPosition: state.curPosition,
      };
    }
    lookahead() {
      const old = this.state;
      this.state = this.createLookaheadState(old);
      this.isLookahead = true;
      this.nextToken();
      this.isLookahead = false;
      const curr = this.state;
      this.state = old;
      return curr;
    }
    nextTokenStart() {
      return this.nextTokenStartSince(this.state.pos);
    }
    nextTokenStartSince(pos) {
      skipWhiteSpace.lastIndex = pos;
      return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
    }
    lookaheadCharCode() {
      return this.input.charCodeAt(this.nextTokenStart());
    }
    nextTokenInLineStart() {
      return this.nextTokenInLineStartSince(this.state.pos);
    }
    nextTokenInLineStartSince(pos) {
      skipWhiteSpaceInLine.lastIndex = pos;
      return skipWhiteSpaceInLine.test(this.input)
        ? skipWhiteSpaceInLine.lastIndex
        : pos;
    }
    lookaheadInLineCharCode() {
      return this.input.charCodeAt(this.nextTokenInLineStart());
    }
    codePointAtPos(pos) {
      let cp = this.input.charCodeAt(pos);
      if ((cp & 64512) === 55296 && ++pos < this.input.length) {
        const trail = this.input.charCodeAt(pos);
        if ((trail & 64512) === 56320) {
          cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
        }
      }
      return cp;
    }
    setStrict(strict) {
      this.state.strict = strict;
      if (strict) {
        this.state.strictErrors.forEach(([toParseError, at]) =>
          this.raise(toParseError, at)
        );
        this.state.strictErrors.clear();
      }
    }
    curContext() {
      return this.state.context[this.state.context.length - 1];
    }
    nextToken() {
      this.skipSpace();
      this.state.start = this.state.pos;
      if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
      if (this.state.pos >= this.length) {
        this.finishToken(139);
        return;
      }
      this.getTokenFromCode(this.codePointAtPos(this.state.pos));
    }
    skipBlockComment(commentEnd) {
      let startLoc;
      if (!this.isLookahead) startLoc = this.state.curPosition();
      const start = this.state.pos;
      const end = this.input.indexOf(commentEnd, start + 2);
      if (end === -1) {
        throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
      }
      this.state.pos = end + commentEnd.length;
      lineBreakG.lastIndex = start + 2;
      while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
        ++this.state.curLine;
        this.state.lineStart = lineBreakG.lastIndex;
      }
      if (this.isLookahead) return;
      const comment = {
        type: 'CommentBlock',
        value: this.input.slice(start + 2, end),
        start: start,
        end: end + commentEnd.length,
        loc: new SourceLocation(startLoc, this.state.curPosition()),
      };
      if (this.options.tokens) this.pushToken(comment);
      return comment;
    }
    skipLineComment(startSkip) {
      const start = this.state.pos;
      let startLoc;
      if (!this.isLookahead) startLoc = this.state.curPosition();
      let ch = this.input.charCodeAt((this.state.pos += startSkip));
      if (this.state.pos < this.length) {
        while (!isNewLine(ch) && ++this.state.pos < this.length) {
          ch = this.input.charCodeAt(this.state.pos);
        }
      }
      if (this.isLookahead) return;
      const end = this.state.pos;
      const value = this.input.slice(start + startSkip, end);
      const comment = {
        type: 'CommentLine',
        value: value,
        start: start,
        end: end,
        loc: new SourceLocation(startLoc, this.state.curPosition()),
      };
      if (this.options.tokens) this.pushToken(comment);
      return comment;
    }
    skipSpace() {
      const spaceStart = this.state.pos;
      const comments = [];
      loop: while (this.state.pos < this.length) {
        const ch = this.input.charCodeAt(this.state.pos);
        switch (ch) {
          case 32:
          case 160:
          case 9:
            ++this.state.pos;
            break;
          case 13:
            if (this.input.charCodeAt(this.state.pos + 1) === 10) {
              ++this.state.pos;
            }
          case 10:
          case 8232:
          case 8233:
            ++this.state.pos;
            ++this.state.curLine;
            this.state.lineStart = this.state.pos;
            break;
          case 47:
            switch (this.input.charCodeAt(this.state.pos + 1)) {
              case 42: {
                const comment = this.skipBlockComment('*/');
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
                break;
              }
              case 47: {
                const comment = this.skipLineComment(2);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
                break;
              }
              default:
                break loop;
            }
            break;
          default:
            if (isWhitespace(ch)) {
              ++this.state.pos;
            } else if (ch === 45 && !this.inModule && this.options.annexB) {
              const pos = this.state.pos;
              if (
                this.input.charCodeAt(pos + 1) === 45 &&
                this.input.charCodeAt(pos + 2) === 62 &&
                (spaceStart === 0 || this.state.lineStart > spaceStart)
              ) {
                const comment = this.skipLineComment(3);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
              } else {
                break loop;
              }
            } else if (ch === 60 && !this.inModule && this.options.annexB) {
              const pos = this.state.pos;
              if (
                this.input.charCodeAt(pos + 1) === 33 &&
                this.input.charCodeAt(pos + 2) === 45 &&
                this.input.charCodeAt(pos + 3) === 45
              ) {
                const comment = this.skipLineComment(4);
                if (comment !== undefined) {
                  this.addComment(comment);
                  if (this.options.attachComment) comments.push(comment);
                }
              } else {
                break loop;
              }
            } else {
              break loop;
            }
        }
      }
      if (comments.length > 0) {
        const end = this.state.pos;
        const commentWhitespace = {
          start: spaceStart,
          end: end,
          comments: comments,
          leadingNode: null,
          trailingNode: null,
          containingNode: null,
        };
        this.state.commentStack.push(commentWhitespace);
      }
    }
    finishToken(type, val) {
      this.state.end = this.state.pos;
      this.state.endLoc = this.state.curPosition();
      const prevType = this.state.type;
      this.state.type = type;
      this.state.value = val;
      if (!this.isLookahead) {
        this.updateContext(prevType);
      }
    }
    replaceToken(type) {
      this.state.type = type;
      this.updateContext();
    }
    readToken_numberSign() {
      if (this.state.pos === 0 && this.readToken_interpreter()) {
        return;
      }
      const nextPos = this.state.pos + 1;
      const next = this.codePointAtPos(nextPos);
      if (next >= 48 && next <= 57) {
        throw this.raise(
          Errors.UnexpectedDigitAfterHash,
          this.state.curPosition()
        );
      }
      if (next === 123 || (next === 91 && this.hasPlugin('recordAndTuple'))) {
        this.expectPlugin('recordAndTuple');
        if (this.getPluginOption('recordAndTuple', 'syntaxType') === 'bar') {
          throw this.raise(
            next === 123
              ? Errors.RecordExpressionHashIncorrectStartSyntaxType
              : Errors.TupleExpressionHashIncorrectStartSyntaxType,
            this.state.curPosition()
          );
        }
        this.state.pos += 2;
        if (next === 123) {
          this.finishToken(7);
        } else {
          this.finishToken(1);
        }
      } else if (isIdentifierStart(next)) {
        ++this.state.pos;
        this.finishToken(138, this.readWord1(next));
      } else if (next === 92) {
        ++this.state.pos;
        this.finishToken(138, this.readWord1());
      } else {
        this.finishOp(27, 1);
      }
    }
    readToken_dot() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next >= 48 && next <= 57) {
        this.readNumber(true);
        return;
      }
      if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
        this.state.pos += 3;
        this.finishToken(21);
      } else {
        ++this.state.pos;
        this.finishToken(16);
      }
    }
    readToken_slash() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(31, 2);
      } else {
        this.finishOp(56, 1);
      }
    }
    readToken_interpreter() {
      if (this.state.pos !== 0 || this.length < 2) return false;
      let ch = this.input.charCodeAt(this.state.pos + 1);
      if (ch !== 33) return false;
      const start = this.state.pos;
      this.state.pos += 1;
      while (!isNewLine(ch) && ++this.state.pos < this.length) {
        ch = this.input.charCodeAt(this.state.pos);
      }
      const value = this.input.slice(start + 2, this.state.pos);
      this.finishToken(28, value);
      return true;
    }
    readToken_mult_modulo(code) {
      let type = code === 42 ? 55 : 54;
      let width = 1;
      let next = this.input.charCodeAt(this.state.pos + 1);
      if (code === 42 && next === 42) {
        width++;
        next = this.input.charCodeAt(this.state.pos + 2);
        type = 57;
      }
      if (next === 61 && !this.state.inType) {
        width++;
        type = code === 37 ? 33 : 30;
      }
      this.finishOp(type, width);
    }
    readToken_pipe_amp(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code) {
        if (this.input.charCodeAt(this.state.pos + 2) === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(code === 124 ? 41 : 42, 2);
        }
        return;
      }
      if (code === 124) {
        if (next === 62) {
          this.finishOp(39, 2);
          return;
        }
        if (this.hasPlugin('recordAndTuple') && next === 125) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(
              Errors.RecordExpressionBarIncorrectEndSyntaxType,
              this.state.curPosition()
            );
          }
          this.state.pos += 2;
          this.finishToken(9);
          return;
        }
        if (this.hasPlugin('recordAndTuple') && next === 93) {
          if (this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar') {
            throw this.raise(
              Errors.TupleExpressionBarIncorrectEndSyntaxType,
              this.state.curPosition()
            );
          }
          this.state.pos += 2;
          this.finishToken(4);
          return;
        }
      }
      if (next === 61) {
        this.finishOp(30, 2);
        return;
      }
      this.finishOp(code === 124 ? 43 : 45, 1);
    }
    readToken_caret() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61 && !this.state.inType) {
        this.finishOp(32, 2);
      } else if (
        next === 94 &&
        this.hasPlugin([
          'pipelineOperator',
          {proposal: 'hack', topicToken: '^^'},
        ])
      ) {
        this.finishOp(37, 2);
        const lookaheadCh = this.input.codePointAt(this.state.pos);
        if (lookaheadCh === 94) {
          this.unexpected();
        }
      } else {
        this.finishOp(44, 1);
      }
    }
    readToken_atSign() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (
        next === 64 &&
        this.hasPlugin([
          'pipelineOperator',
          {proposal: 'hack', topicToken: '@@'},
        ])
      ) {
        this.finishOp(38, 2);
      } else {
        this.finishOp(26, 1);
      }
    }
    readToken_plus_min(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === code) {
        this.finishOp(34, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(30, 2);
      } else {
        this.finishOp(53, 1);
      }
    }
    readToken_lt() {
      const {pos: pos} = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 60) {
        if (this.input.charCodeAt(pos + 2) === 61) {
          this.finishOp(30, 3);
          return;
        }
        this.finishOp(51, 2);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(47, 1);
    }
    readToken_gt() {
      const {pos: pos} = this.state;
      const next = this.input.charCodeAt(pos + 1);
      if (next === 62) {
        const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
        if (this.input.charCodeAt(pos + size) === 61) {
          this.finishOp(30, size + 1);
          return;
        }
        this.finishOp(52, size);
        return;
      }
      if (next === 61) {
        this.finishOp(49, 2);
        return;
      }
      this.finishOp(48, 1);
    }
    readToken_eq_excl(code) {
      const next = this.input.charCodeAt(this.state.pos + 1);
      if (next === 61) {
        this.finishOp(
          46,
          this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2
        );
        return;
      }
      if (code === 61 && next === 62) {
        this.state.pos += 2;
        this.finishToken(19);
        return;
      }
      this.finishOp(code === 61 ? 29 : 35, 1);
    }
    readToken_question() {
      const next = this.input.charCodeAt(this.state.pos + 1);
      const next2 = this.input.charCodeAt(this.state.pos + 2);
      if (next === 63) {
        if (next2 === 61) {
          this.finishOp(30, 3);
        } else {
          this.finishOp(40, 2);
        }
      } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
        this.state.pos += 2;
        this.finishToken(18);
      } else {
        ++this.state.pos;
        this.finishToken(17);
      }
    }
    getTokenFromCode(code) {
      switch (code) {
        case 46:
          this.readToken_dot();
          return;
        case 40:
          ++this.state.pos;
          this.finishToken(10);
          return;
        case 41:
          ++this.state.pos;
          this.finishToken(11);
          return;
        case 59:
          ++this.state.pos;
          this.finishToken(13);
          return;
        case 44:
          ++this.state.pos;
          this.finishToken(12);
          return;
        case 91:
          if (
            this.hasPlugin('recordAndTuple') &&
            this.input.charCodeAt(this.state.pos + 1) === 124
          ) {
            if (
              this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar'
            ) {
              throw this.raise(
                Errors.TupleExpressionBarIncorrectStartSyntaxType,
                this.state.curPosition()
              );
            }
            this.state.pos += 2;
            this.finishToken(2);
          } else {
            ++this.state.pos;
            this.finishToken(0);
          }
          return;
        case 93:
          ++this.state.pos;
          this.finishToken(3);
          return;
        case 123:
          if (
            this.hasPlugin('recordAndTuple') &&
            this.input.charCodeAt(this.state.pos + 1) === 124
          ) {
            if (
              this.getPluginOption('recordAndTuple', 'syntaxType') !== 'bar'
            ) {
              throw this.raise(
                Errors.RecordExpressionBarIncorrectStartSyntaxType,
                this.state.curPosition()
              );
            }
            this.state.pos += 2;
            this.finishToken(6);
          } else {
            ++this.state.pos;
            this.finishToken(5);
          }
          return;
        case 125:
          ++this.state.pos;
          this.finishToken(8);
          return;
        case 58:
          if (
            this.hasPlugin('functionBind') &&
            this.input.charCodeAt(this.state.pos + 1) === 58
          ) {
            this.finishOp(15, 2);
          } else {
            ++this.state.pos;
            this.finishToken(14);
          }
          return;
        case 63:
          this.readToken_question();
          return;
        case 96:
          this.readTemplateToken();
          return;
        case 48: {
          const next = this.input.charCodeAt(this.state.pos + 1);
          if (next === 120 || next === 88) {
            this.readRadixNumber(16);
            return;
          }
          if (next === 111 || next === 79) {
            this.readRadixNumber(8);
            return;
          }
          if (next === 98 || next === 66) {
            this.readRadixNumber(2);
            return;
          }
        }
        case 49:
        case 50:
        case 51:
        case 52:
        case 53:
        case 54:
        case 55:
        case 56:
        case 57:
          this.readNumber(false);
          return;
        case 34:
        case 39:
          this.readString(code);
          return;
        case 47:
          this.readToken_slash();
          return;
        case 37:
        case 42:
          this.readToken_mult_modulo(code);
          return;
        case 124:
        case 38:
          this.readToken_pipe_amp(code);
          return;
        case 94:
          this.readToken_caret();
          return;
        case 43:
        case 45:
          this.readToken_plus_min(code);
          return;
        case 60:
          this.readToken_lt();
          return;
        case 62:
          this.readToken_gt();
          return;
        case 61:
        case 33:
          this.readToken_eq_excl(code);
          return;
        case 126:
          this.finishOp(36, 1);
          return;
        case 64:
          this.readToken_atSign();
          return;
        case 35:
          this.readToken_numberSign();
          return;
        case 92:
          this.readWord();
          return;
        default:
          if (isIdentifierStart(code)) {
            this.readWord(code);
            return;
          }
      }
      throw this.raise(
        Errors.InvalidOrUnexpectedToken,
        this.state.curPosition(),
        {unexpected: String.fromCodePoint(code)}
      );
    }
    finishOp(type, size) {
      const str = this.input.slice(this.state.pos, this.state.pos + size);
      this.state.pos += size;
      this.finishToken(type, str);
    }
    readRegexp() {
      const startLoc = this.state.startLoc;
      const start = this.state.start + 1;
      let escaped, inClass;
      let {pos: pos} = this.state;
      for (; ; ++pos) {
        if (pos >= this.length) {
          throw this.raise(
            Errors.UnterminatedRegExp,
            createPositionWithColumnOffset(startLoc, 1)
          );
        }
        const ch = this.input.charCodeAt(pos);
        if (isNewLine(ch)) {
          throw this.raise(
            Errors.UnterminatedRegExp,
            createPositionWithColumnOffset(startLoc, 1)
          );
        }
        if (escaped) {
          escaped = false;
        } else {
          if (ch === 91) {
            inClass = true;
          } else if (ch === 93 && inClass) {
            inClass = false;
          } else if (ch === 47 && !inClass) {
            break;
          }
          escaped = ch === 92;
        }
      }
      const content = this.input.slice(start, pos);
      ++pos;
      let mods = '';
      const nextPos = () =>
        createPositionWithColumnOffset(startLoc, pos + 2 - start);
      while (pos < this.length) {
        const cp = this.codePointAtPos(pos);
        const char = String.fromCharCode(cp);
        if (VALID_REGEX_FLAGS.has(cp)) {
          if (cp === 118) {
            if (mods.includes('u')) {
              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
            }
          } else if (cp === 117) {
            if (mods.includes('v')) {
              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
            }
          }
          if (mods.includes(char)) {
            this.raise(Errors.DuplicateRegExpFlags, nextPos());
          }
        } else if (isIdentifierChar(cp) || cp === 92) {
          this.raise(Errors.MalformedRegExpFlags, nextPos());
        } else {
          break;
        }
        ++pos;
        mods += char;
      }
      this.state.pos = pos;
      this.finishToken(137, {pattern: content, flags: mods});
    }
    readInt(radix, len, forceLen = false, allowNumSeparator = true) {
      const {n: n, pos: pos} = readInt(
        this.input,
        this.state.pos,
        this.state.lineStart,
        this.state.curLine,
        radix,
        len,
        forceLen,
        allowNumSeparator,
        this.errorHandlers_readInt,
        false
      );
      this.state.pos = pos;
      return n;
    }
    readRadixNumber(radix) {
      const startLoc = this.state.curPosition();
      let isBigInt = false;
      this.state.pos += 2;
      const val = this.readInt(radix);
      if (val == null) {
        this.raise(
          Errors.InvalidDigit,
          createPositionWithColumnOffset(startLoc, 2),
          {radix: radix}
        );
      }
      const next = this.input.charCodeAt(this.state.pos);
      if (next === 110) {
        ++this.state.pos;
        isBigInt = true;
      } else if (next === 109) {
        throw this.raise(Errors.InvalidDecimal, startLoc);
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
      }
      if (isBigInt) {
        const str = this.input
          .slice(startLoc.index, this.state.pos)
          .replace(/[_n]/g, '');
        this.finishToken(135, str);
        return;
      }
      this.finishToken(134, val);
    }
    readNumber(startsWithDot) {
      const start = this.state.pos;
      const startLoc = this.state.curPosition();
      let isFloat = false;
      let isBigInt = false;
      let isDecimal = false;
      let hasExponent = false;
      let isOctal = false;
      if (!startsWithDot && this.readInt(10) === null) {
        this.raise(Errors.InvalidNumber, this.state.curPosition());
      }
      const hasLeadingZero =
        this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
      if (hasLeadingZero) {
        const integer = this.input.slice(start, this.state.pos);
        this.recordStrictModeErrors(Errors.StrictOctalLiteral, startLoc);
        if (!this.state.strict) {
          const underscorePos = integer.indexOf('_');
          if (underscorePos > 0) {
            this.raise(
              Errors.ZeroDigitNumericSeparator,
              createPositionWithColumnOffset(startLoc, underscorePos)
            );
          }
        }
        isOctal = hasLeadingZero && !/[89]/.test(integer);
      }
      let next = this.input.charCodeAt(this.state.pos);
      if (next === 46 && !isOctal) {
        ++this.state.pos;
        this.readInt(10);
        isFloat = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if ((next === 69 || next === 101) && !isOctal) {
        next = this.input.charCodeAt(++this.state.pos);
        if (next === 43 || next === 45) {
          ++this.state.pos;
        }
        if (this.readInt(10) === null) {
          this.raise(Errors.InvalidOrMissingExponent, startLoc);
        }
        isFloat = true;
        hasExponent = true;
        next = this.input.charCodeAt(this.state.pos);
      }
      if (next === 110) {
        if (isFloat || hasLeadingZero) {
          this.raise(Errors.InvalidBigIntLiteral, startLoc);
        }
        ++this.state.pos;
        isBigInt = true;
      }
      if (next === 109) {
        this.expectPlugin('decimal', this.state.curPosition());
        if (hasExponent || hasLeadingZero) {
          this.raise(Errors.InvalidDecimal, startLoc);
        }
        ++this.state.pos;
        isDecimal = true;
      }
      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
      }
      const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, '');
      if (isBigInt) {
        this.finishToken(135, str);
        return;
      }
      if (isDecimal) {
        this.finishToken(136, str);
        return;
      }
      const val = isOctal ? parseInt(str, 8) : parseFloat(str);
      this.finishToken(134, val);
    }
    readCodePoint(throwOnInvalid) {
      const {code: code, pos: pos} = readCodePoint(
        this.input,
        this.state.pos,
        this.state.lineStart,
        this.state.curLine,
        throwOnInvalid,
        this.errorHandlers_readCodePoint
      );
      this.state.pos = pos;
      return code;
    }
    readString(quote) {
      const {
        str: str,
        pos: pos,
        curLine: curLine,
        lineStart: lineStart,
      } = readStringContents(
        quote === 34 ? 'double' : 'single',
        this.input,
        this.state.pos + 1,
        this.state.lineStart,
        this.state.curLine,
        this.errorHandlers_readStringContents_string
      );
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      this.finishToken(133, str);
    }
    readTemplateContinuation() {
      if (!this.match(8)) {
        this.unexpected(null, 8);
      }
      this.state.pos--;
      this.readTemplateToken();
    }
    readTemplateToken() {
      const opening = this.input[this.state.pos];
      const {
        str: str,
        firstInvalidLoc: firstInvalidLoc,
        pos: pos,
        curLine: curLine,
        lineStart: lineStart,
      } = readStringContents(
        'template',
        this.input,
        this.state.pos + 1,
        this.state.lineStart,
        this.state.curLine,
        this.errorHandlers_readStringContents_template
      );
      this.state.pos = pos + 1;
      this.state.lineStart = lineStart;
      this.state.curLine = curLine;
      if (firstInvalidLoc) {
        this.state.firstInvalidTemplateEscapePos = new Position(
          firstInvalidLoc.curLine,
          firstInvalidLoc.pos - firstInvalidLoc.lineStart,
          firstInvalidLoc.pos
        );
      }
      if (this.input.codePointAt(pos) === 96) {
        this.finishToken(24, firstInvalidLoc ? null : opening + str + '`');
      } else {
        this.state.pos++;
        this.finishToken(25, firstInvalidLoc ? null : opening + str + '${');
      }
    }
    recordStrictModeErrors(toParseError, at) {
      const index = at.index;
      if (this.state.strict && !this.state.strictErrors.has(index)) {
        this.raise(toParseError, at);
      } else {
        this.state.strictErrors.set(index, [toParseError, at]);
      }
    }
    readWord1(firstCode) {
      this.state.containsEsc = false;
      let word = '';
      const start = this.state.pos;
      let chunkStart = this.state.pos;
      if (firstCode !== undefined) {
        this.state.pos += firstCode <= 65535 ? 1 : 2;
      }
      while (this.state.pos < this.length) {
        const ch = this.codePointAtPos(this.state.pos);
        if (isIdentifierChar(ch)) {
          this.state.pos += ch <= 65535 ? 1 : 2;
        } else if (ch === 92) {
          this.state.containsEsc = true;
          word += this.input.slice(chunkStart, this.state.pos);
          const escStart = this.state.curPosition();
          const identifierCheck =
            this.state.pos === start ? isIdentifierStart : isIdentifierChar;
          if (this.input.charCodeAt(++this.state.pos) !== 117) {
            this.raise(Errors.MissingUnicodeEscape, this.state.curPosition());
            chunkStart = this.state.pos - 1;
            continue;
          }
          ++this.state.pos;
          const esc = this.readCodePoint(true);
          if (esc !== null) {
            if (!identifierCheck(esc)) {
              this.raise(Errors.EscapedCharNotAnIdentifier, escStart);
            }
            word += String.fromCodePoint(esc);
          }
          chunkStart = this.state.pos;
        } else {
          break;
        }
      }
      return word + this.input.slice(chunkStart, this.state.pos);
    }
    readWord(firstCode) {
      const word = this.readWord1(firstCode);
      const type = keywords$1.get(word);
      if (type !== undefined) {
        this.finishToken(type, tokenLabelName(type));
      } else {
        this.finishToken(132, word);
      }
    }
    checkKeywordEscapes() {
      const {type: type} = this.state;
      if (tokenIsKeyword(type) && this.state.containsEsc) {
        this.raise(Errors.InvalidEscapedReservedWord, this.state.startLoc, {
          reservedWord: tokenLabelName(type),
        });
      }
    }
    raise(toParseError, at, details = {}) {
      const loc = at instanceof Position ? at : at.loc.start;
      const error = toParseError(loc, details);
      if (!this.options.errorRecovery) throw error;
      if (!this.isLookahead) this.state.errors.push(error);
      return error;
    }
    raiseOverwrite(toParseError, at, details = {}) {
      const loc = at instanceof Position ? at : at.loc.start;
      const pos = loc.index;
      const errors = this.state.errors;
      for (let i = errors.length - 1; i >= 0; i--) {
        const error = errors[i];
        if (error.loc.index === pos) {
          return (errors[i] = toParseError(loc, details));
        }
        if (error.loc.index < pos) break;
      }
      return this.raise(toParseError, at, details);
    }
    updateContext(prevType) {}
    unexpected(loc, type) {
      throw this.raise(
        Errors.UnexpectedToken,
        loc != null ? loc : this.state.startLoc,
        {expected: type ? tokenLabelName(type) : null}
      );
    }
    expectPlugin(pluginName, loc) {
      if (this.hasPlugin(pluginName)) {
        return true;
      }
      throw this.raise(
        Errors.MissingPlugin,
        loc != null ? loc : this.state.startLoc,
        {missingPlugin: [pluginName]}
      );
    }
    expectOnePlugin(pluginNames) {
      if (!pluginNames.some(name => this.hasPlugin(name))) {
        throw this.raise(Errors.MissingOneOfPlugins, this.state.startLoc, {
          missingPlugin: pluginNames,
        });
      }
    }
    errorBuilder(error) {
      return (pos, lineStart, curLine) => {
        this.raise(error, buildPosition(pos, lineStart, curLine));
      };
    }
  }
  class ClassScope {
    constructor() {
      this.privateNames = new Set();
      this.loneAccessors = new Map();
      this.undefinedPrivateNames = new Map();
    }
  }
  class ClassScopeHandler {
    constructor(parser) {
      this.parser = void 0;
      this.stack = [];
      this.undefinedPrivateNames = new Map();
      this.parser = parser;
    }
    current() {
      return this.stack[this.stack.length - 1];
    }
    enter() {
      this.stack.push(new ClassScope());
    }
    exit() {
      const oldClassScope = this.stack.pop();
      const current = this.current();
      for (const [name, loc] of Array.from(
        oldClassScope.undefinedPrivateNames
      )) {
        if (current) {
          if (!current.undefinedPrivateNames.has(name)) {
            current.undefinedPrivateNames.set(name, loc);
          }
        } else {
          this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
            identifierName: name,
          });
        }
      }
    }
    declarePrivateName(name, elementType, loc) {
      const {
        privateNames: privateNames,
        loneAccessors: loneAccessors,
        undefinedPrivateNames: undefinedPrivateNames,
      } = this.current();
      let redefined = privateNames.has(name);
      if (elementType & 3) {
        const accessor = redefined && loneAccessors.get(name);
        if (accessor) {
          const oldStatic = accessor & 4;
          const newStatic = elementType & 4;
          const oldKind = accessor & 3;
          const newKind = elementType & 3;
          redefined = oldKind === newKind || oldStatic !== newStatic;
          if (!redefined) loneAccessors.delete(name);
        } else if (!redefined) {
          loneAccessors.set(name, elementType);
        }
      }
      if (redefined) {
        this.parser.raise(Errors.PrivateNameRedeclaration, loc, {
          identifierName: name,
        });
      }
      privateNames.add(name);
      undefinedPrivateNames.delete(name);
    }
    usePrivateName(name, loc) {
      let classScope;
      for (classScope of this.stack) {
        if (classScope.privateNames.has(name)) return;
      }
      if (classScope) {
        classScope.undefinedPrivateNames.set(name, loc);
      } else {
        this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
          identifierName: name,
        });
      }
    }
  }
  class ExpressionScope {
    constructor(type = 0) {
      this.type = type;
    }
    canBeArrowParameterDeclaration() {
      return this.type === 2 || this.type === 1;
    }
    isCertainlyParameterDeclaration() {
      return this.type === 3;
    }
  }
  class ArrowHeadParsingScope extends ExpressionScope {
    constructor(type) {
      super(type);
      this.declarationErrors = new Map();
    }
    recordDeclarationError(ParsingErrorClass, at) {
      const index = at.index;
      this.declarationErrors.set(index, [ParsingErrorClass, at]);
    }
    clearDeclarationError(index) {
      this.declarationErrors.delete(index);
    }
    iterateErrors(iterator) {
      this.declarationErrors.forEach(iterator);
    }
  }
  class ExpressionScopeHandler {
    constructor(parser) {
      this.parser = void 0;
      this.stack = [new ExpressionScope()];
      this.parser = parser;
    }
    enter(scope) {
      this.stack.push(scope);
    }
    exit() {
      this.stack.pop();
    }
    recordParameterInitializerError(toParseError, node) {
      const origin = node.loc.start;
      const {stack: stack} = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (!scope.isCertainlyParameterDeclaration()) {
        if (scope.canBeArrowParameterDeclaration()) {
          scope.recordDeclarationError(toParseError, origin);
        } else {
          return;
        }
        scope = stack[--i];
      }
      this.parser.raise(toParseError, origin);
    }
    recordArrowParameterBindingError(error, node) {
      const {stack: stack} = this;
      const scope = stack[stack.length - 1];
      const origin = node.loc.start;
      if (scope.isCertainlyParameterDeclaration()) {
        this.parser.raise(error, origin);
      } else if (scope.canBeArrowParameterDeclaration()) {
        scope.recordDeclarationError(error, origin);
      } else {
        return;
      }
    }
    recordAsyncArrowParametersError(at) {
      const {stack: stack} = this;
      let i = stack.length - 1;
      let scope = stack[i];
      while (scope.canBeArrowParameterDeclaration()) {
        if (scope.type === 2) {
          scope.recordDeclarationError(Errors.AwaitBindingIdentifier, at);
        }
        scope = stack[--i];
      }
    }
    validateAsPattern() {
      const {stack: stack} = this;
      const currentScope = stack[stack.length - 1];
      if (!currentScope.canBeArrowParameterDeclaration()) return;
      currentScope.iterateErrors(([toParseError, loc]) => {
        this.parser.raise(toParseError, loc);
        let i = stack.length - 2;
        let scope = stack[i];
        while (scope.canBeArrowParameterDeclaration()) {
          scope.clearDeclarationError(loc.index);
          scope = stack[--i];
        }
      });
    }
  }
  function newParameterDeclarationScope() {
    return new ExpressionScope(3);
  }
  function newArrowHeadScope() {
    return new ArrowHeadParsingScope(1);
  }
  function newAsyncArrowScope() {
    return new ArrowHeadParsingScope(2);
  }
  function newExpressionScope() {
    return new ExpressionScope();
  }
  class ProductionParameterHandler {
    constructor() {
      this.stacks = [];
    }
    enter(flags) {
      this.stacks.push(flags);
    }
    exit() {
      this.stacks.pop();
    }
    currentFlags() {
      return this.stacks[this.stacks.length - 1];
    }
    get hasAwait() {
      return (this.currentFlags() & 2) > 0;
    }
    get hasYield() {
      return (this.currentFlags() & 1) > 0;
    }
    get hasReturn() {
      return (this.currentFlags() & 4) > 0;
    }
    get hasIn() {
      return (this.currentFlags() & 8) > 0;
    }
  }
  function functionFlags(isAsync, isGenerator) {
    return (isAsync ? 2 : 0) | (isGenerator ? 1 : 0);
  }
  class UtilParser extends Tokenizer {
    addExtra(node, key, value, enumerable = true) {
      if (!node) return;
      let {extra: extra} = node;
      if (extra == null) {
        extra = {};
        node.extra = extra;
      }
      if (enumerable) {
        extra[key] = value;
      } else {
        Object.defineProperty(extra, key, {
          enumerable: enumerable,
          value: value,
        });
      }
    }
    isContextual(token) {
      return this.state.type === token && !this.state.containsEsc;
    }
    isUnparsedContextual(nameStart, name) {
      const nameEnd = nameStart + name.length;
      if (this.input.slice(nameStart, nameEnd) === name) {
        const nextCh = this.input.charCodeAt(nameEnd);
        return !(isIdentifierChar(nextCh) || (nextCh & 64512) === 55296);
      }
      return false;
    }
    isLookaheadContextual(name) {
      const next = this.nextTokenStart();
      return this.isUnparsedContextual(next, name);
    }
    eatContextual(token) {
      if (this.isContextual(token)) {
        this.next();
        return true;
      }
      return false;
    }
    expectContextual(token, toParseError) {
      if (!this.eatContextual(token)) {
        if (toParseError != null) {
          throw this.raise(toParseError, this.state.startLoc);
        }
        this.unexpected(null, token);
      }
    }
    canInsertSemicolon() {
      return this.match(139) || this.match(8) || this.hasPrecedingLineBreak();
    }
    hasPrecedingLineBreak() {
      return hasNewLine(
        this.input,
        this.state.lastTokEndLoc.index,
        this.state.start
      );
    }
    hasFollowingLineBreak() {
      return hasNewLine(this.input, this.state.end, this.nextTokenStart());
    }
    isLineTerminator() {
      return this.eat(13) || this.canInsertSemicolon();
    }
    semicolon(allowAsi = true) {
      if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
      this.raise(Errors.MissingSemicolon, this.state.lastTokEndLoc);
    }
    expect(type, loc) {
      if (!this.eat(type)) {
        this.unexpected(loc, type);
      }
    }
    tryParse(fn, oldState = this.state.clone()) {
      const abortSignal = {node: null};
      try {
        const node = fn((node = null) => {
          abortSignal.node = node;
          throw abortSignal;
        });
        if (this.state.errors.length > oldState.errors.length) {
          const failState = this.state;
          this.state = oldState;
          this.state.tokensLength = failState.tokensLength;
          return {
            node: node,
            error: failState.errors[oldState.errors.length],
            thrown: false,
            aborted: false,
            failState: failState,
          };
        }
        return {
          node: node,
          error: null,
          thrown: false,
          aborted: false,
          failState: null,
        };
      } catch (error) {
        const failState = this.state;
        this.state = oldState;
        if (error instanceof SyntaxError) {
          return {
            node: null,
            error: error,
            thrown: true,
            aborted: false,
            failState: failState,
          };
        }
        if (error === abortSignal) {
          return {
            node: abortSignal.node,
            error: null,
            thrown: false,
            aborted: true,
            failState: failState,
          };
        }
        throw error;
      }
    }
    checkExpressionErrors(refExpressionErrors, andThrow) {
      if (!refExpressionErrors) return false;
      const {
        shorthandAssignLoc: shorthandAssignLoc,
        doubleProtoLoc: doubleProtoLoc,
        privateKeyLoc: privateKeyLoc,
        optionalParametersLoc: optionalParametersLoc,
      } = refExpressionErrors;
      const hasErrors =
        !!shorthandAssignLoc ||
        !!doubleProtoLoc ||
        !!optionalParametersLoc ||
        !!privateKeyLoc;
      if (!andThrow) {
        return hasErrors;
      }
      if (shorthandAssignLoc != null) {
        this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
      }
      if (doubleProtoLoc != null) {
        this.raise(Errors.DuplicateProto, doubleProtoLoc);
      }
      if (privateKeyLoc != null) {
        this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
      }
      if (optionalParametersLoc != null) {
        this.unexpected(optionalParametersLoc);
      }
    }
    isLiteralPropertyName() {
      return tokenIsLiteralPropertyName(this.state.type);
    }
    isPrivateName(node) {
      return node.type === 'PrivateName';
    }
    getPrivateNameSV(node) {
      return node.id.name;
    }
    hasPropertyAsPrivateName(node) {
      return (
        (node.type === 'MemberExpression' ||
          node.type === 'OptionalMemberExpression') &&
        this.isPrivateName(node.property)
      );
    }
    isObjectProperty(node) {
      return node.type === 'ObjectProperty';
    }
    isObjectMethod(node) {
      return node.type === 'ObjectMethod';
    }
    initializeScopes(inModule = this.options.sourceType === 'module') {
      const oldLabels = this.state.labels;
      this.state.labels = [];
      const oldExportedIdentifiers = this.exportedIdentifiers;
      this.exportedIdentifiers = new Set();
      const oldInModule = this.inModule;
      this.inModule = inModule;
      const oldScope = this.scope;
      const ScopeHandler = this.getScopeHandler();
      this.scope = new ScopeHandler(this, inModule);
      const oldProdParam = this.prodParam;
      this.prodParam = new ProductionParameterHandler();
      const oldClassScope = this.classScope;
      this.classScope = new ClassScopeHandler(this);
      const oldExpressionScope = this.expressionScope;
      this.expressionScope = new ExpressionScopeHandler(this);
      return () => {
        this.state.labels = oldLabels;
        this.exportedIdentifiers = oldExportedIdentifiers;
        this.inModule = oldInModule;
        this.scope = oldScope;
        this.prodParam = oldProdParam;
        this.classScope = oldClassScope;
        this.expressionScope = oldExpressionScope;
      };
    }
    enterInitialScopes() {
      let paramFlags = 0;
      if (this.inModule) {
        paramFlags |= 2;
      }
      this.scope.enter(1);
      this.prodParam.enter(paramFlags);
    }
    checkDestructuringPrivate(refExpressionErrors) {
      const {privateKeyLoc: privateKeyLoc} = refExpressionErrors;
      if (privateKeyLoc !== null) {
        this.expectPlugin('destructuringPrivate', privateKeyLoc);
      }
    }
  }
  class ExpressionErrors {
    constructor() {
      this.shorthandAssignLoc = null;
      this.doubleProtoLoc = null;
      this.privateKeyLoc = null;
      this.optionalParametersLoc = null;
    }
  }
  class Node {
    constructor(parser, pos, loc) {
      this.type = '';
      this.start = pos;
      this.end = 0;
      this.loc = new SourceLocation(loc);
      if (parser != null && parser.options.ranges) this.range = [pos, 0];
      if (parser != null && parser.filename)
        this.loc.filename = parser.filename;
    }
  }
  const NodePrototype = Node.prototype;
  {
    NodePrototype.__clone = function () {
      const newNode = new Node(undefined, this.start, this.loc.start);
      const keys = Object.keys(this);
      for (let i = 0, length = keys.length; i < length; i++) {
        const key = keys[i];
        if (
          key !== 'leadingComments' &&
          key !== 'trailingComments' &&
          key !== 'innerComments'
        ) {
          newNode[key] = this[key];
        }
      }
      return newNode;
    };
  }
  function clonePlaceholder(node) {
    return cloneIdentifier(node);
  }
  function cloneIdentifier(node) {
    const {
      type: type,
      start: start,
      end: end,
      loc: loc,
      range: range,
      extra: extra,
      name: name,
    } = node;
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    cloned.extra = extra;
    cloned.name = name;
    if (type === 'Placeholder') {
      cloned.expectedNode = node.expectedNode;
    }
    return cloned;
  }
  function cloneStringLiteral(node) {
    const {
      type: type,
      start: start,
      end: end,
      loc: loc,
      range: range,
      extra: extra,
    } = node;
    if (type === 'Placeholder') {
      return clonePlaceholder(node);
    }
    const cloned = Object.create(NodePrototype);
    cloned.type = type;
    cloned.start = start;
    cloned.end = end;
    cloned.loc = loc;
    cloned.range = range;
    if (node.raw !== undefined) {
      cloned.raw = node.raw;
    } else {
      cloned.extra = extra;
    }
    cloned.value = node.value;
    return cloned;
  }
  class NodeUtils extends UtilParser {
    startNode() {
      const loc = this.state.startLoc;
      return new Node(this, loc.index, loc);
    }
    startNodeAt(loc) {
      return new Node(this, loc.index, loc);
    }
    startNodeAtNode(type) {
      return this.startNodeAt(type.loc.start);
    }
    finishNode(node, type) {
      return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
    }
    finishNodeAt(node, type, endLoc) {
      node.type = type;
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges) node.range[1] = endLoc.index;
      if (this.options.attachComment) this.processComment(node);
      return node;
    }
    resetStartLocation(node, startLoc) {
      node.start = startLoc.index;
      node.loc.start = startLoc;
      if (this.options.ranges) node.range[0] = startLoc.index;
    }
    resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
      node.end = endLoc.index;
      node.loc.end = endLoc;
      if (this.options.ranges) node.range[1] = endLoc.index;
    }
    resetStartLocationFromNode(node, locationNode) {
      this.resetStartLocation(node, locationNode.loc.start);
    }
  }
  const reservedTypes = new Set([
    '_',
    'any',
    'bool',
    'boolean',
    'empty',
    'extends',
    'false',
    'interface',
    'mixed',
    'null',
    'number',
    'static',
    'string',
    'true',
    'typeof',
    'void',
  ]);
  const FlowErrors = ParseErrorEnum`flow`({
    AmbiguousConditionalArrow:
      'Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.',
    AmbiguousDeclareModuleKind:
      'Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.',
    AssignReservedType: ({reservedType: reservedType}) =>
      `Cannot overwrite reserved type ${reservedType}.`,
    DeclareClassElement:
      'The `declare` modifier can only appear on class fields.',
    DeclareClassFieldInitializer:
      'Initializers are not allowed in fields with the `declare` modifier.',
    DuplicateDeclareModuleExports:
      'Duplicate `declare module.exports` statement.',
    EnumBooleanMemberNotInitialized: ({
      memberName: memberName,
      enumName: enumName,
    }) =>
      `Boolean enum members need to be initialized. Use either \`${memberName} = true,\` or \`${memberName} = false,\` in enum \`${enumName}\`.`,
    EnumDuplicateMemberName: ({memberName: memberName, enumName: enumName}) =>
      `Enum member names need to be unique, but the name \`${memberName}\` has already been used before in enum \`${enumName}\`.`,
    EnumInconsistentMemberValues: ({enumName: enumName}) =>
      `Enum \`${enumName}\` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.`,
    EnumInvalidExplicitType: ({
      invalidEnumType: invalidEnumType,
      enumName: enumName,
    }) =>
      `Enum type \`${invalidEnumType}\` is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidExplicitTypeUnknownSupplied: ({enumName: enumName}) =>
      `Supplied enum type is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerPrimaryType: ({
      enumName: enumName,
      memberName: memberName,
      explicitType: explicitType,
    }) =>
      `Enum \`${enumName}\` has type \`${explicitType}\`, so the initializer of \`${memberName}\` needs to be a ${explicitType} literal.`,
    EnumInvalidMemberInitializerSymbolType: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `Symbol enum members cannot be initialized. Use \`${memberName},\` in enum \`${enumName}\`.`,
    EnumInvalidMemberInitializerUnknownType: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `The enum member initializer for \`${memberName}\` needs to be a literal (either a boolean, number, or string) in enum \`${enumName}\`.`,
    EnumInvalidMemberName: ({
      enumName: enumName,
      memberName: memberName,
      suggestion: suggestion,
    }) =>
      `Enum member names cannot start with lowercase 'a' through 'z'. Instead of using \`${memberName}\`, consider using \`${suggestion}\`, in enum \`${enumName}\`.`,
    EnumNumberMemberNotInitialized: ({
      enumName: enumName,
      memberName: memberName,
    }) =>
      `Number enum members need to be initialized, e.g. \`${memberName} = 1\` in enum \`${enumName}\`.`,
    EnumStringMemberInconsistentlyInitialized: ({enumName: enumName}) =>
      `String enum members need to consistently either all use initializers, or use no initializers, in enum \`${enumName}\`.`,
    GetterMayNotHaveThisParam: 'A getter cannot have a `this` parameter.',
    ImportReflectionHasImportType:
      'An `import module` declaration can not use `type` or `typeof` keyword.',
    ImportTypeShorthandOnlyInPureImport:
      'The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.',
    InexactInsideExact:
      'Explicit inexact syntax cannot appear inside an explicit exact object type.',
    InexactInsideNonObject:
      'Explicit inexact syntax cannot appear in class or interface definitions.',
    InexactVariance: 'Explicit inexact syntax cannot have variance.',
    InvalidNonTypeImportInDeclareModule:
      'Imports within a `declare module` body must always be `import type` or `import typeof`.',
    MissingTypeParamDefault:
      'Type parameter declaration needs a default, since a preceding type parameter declaration has a default.',
    NestedDeclareModule:
      '`declare module` cannot be used inside another `declare module`.',
    NestedFlowComment:
      'Cannot have a flow comment inside another flow comment.',
    PatternIsOptional: Object.assign(
      {
        message:
          'A binding pattern parameter cannot be optional in an implementation signature.',
      },
      {reasonCode: 'OptionalBindingPattern'}
    ),
    SetterMayNotHaveThisParam: 'A setter cannot have a `this` parameter.',
    SpreadVariance: 'Spread properties cannot have variance.',
    ThisParamAnnotationRequired:
      'A type annotation is required for the `this` parameter.',
    ThisParamBannedInConstructor:
      "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
    ThisParamMayNotBeOptional: 'The `this` parameter cannot be optional.',
    ThisParamMustBeFirst:
      'The `this` parameter must be the first function parameter.',
    ThisParamNoDefault: 'The `this` parameter may not have a default value.',
    TypeBeforeInitializer:
      'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
    TypeCastInPattern:
      'The type cast expression is expected to be wrapped with parenthesis.',
    UnexpectedExplicitInexactInObject:
      'Explicit inexact syntax must appear at the end of an inexact object.',
    UnexpectedReservedType: ({reservedType: reservedType}) =>
      `Unexpected reserved type ${reservedType}.`,
    UnexpectedReservedUnderscore:
      '`_` is only allowed as a type argument to call or new.',
    UnexpectedSpaceBetweenModuloChecks:
      'Spaces between `%` and `checks` are not allowed here.',
    UnexpectedSpreadType:
      'Spread operator cannot appear in class or interface definitions.',
    UnexpectedSubtractionOperand:
      'Unexpected token, expected "number" or "bigint".',
    UnexpectedTokenAfterTypeParameter:
      'Expected an arrow function after this type parameter declaration.',
    UnexpectedTypeParameterBeforeAsyncArrowFunction:
      'Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.',
    UnsupportedDeclareExportKind: ({
      unsupportedExportKind: unsupportedExportKind,
      suggestion: suggestion,
    }) =>
      `\`declare export ${unsupportedExportKind}\` is not supported. Use \`${suggestion}\` instead.`,
    UnsupportedStatementInDeclareModule:
      'Only declares and type imports are allowed inside declare module.',
    UnterminatedFlowComment: 'Unterminated flow-comment.',
  });
  function isEsModuleType(bodyElement) {
    return (
      bodyElement.type === 'DeclareExportAllDeclaration' ||
      (bodyElement.type === 'DeclareExportDeclaration' &&
        (!bodyElement.declaration ||
          (bodyElement.declaration.type !== 'TypeAlias' &&
            bodyElement.declaration.type !== 'InterfaceDeclaration')))
    );
  }
  function hasTypeImportKind(node) {
    return node.importKind === 'type' || node.importKind === 'typeof';
  }
  const exportSuggestions = {
    const: 'declare export var',
    let: 'declare export var',
    type: 'export type',
    interface: 'export interface',
  };
  function partition(list, test) {
    const list1 = [];
    const list2 = [];
    for (let i = 0; i < list.length; i++) {
      (test(list[i], i, list) ? list1 : list2).push(list[i]);
    }
    return [list1, list2];
  }
  const FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
  var flow = superClass =>
    class FlowParserMixin extends superClass {
      constructor(...args) {
        super(...args);
        this.flowPragma = undefined;
      }
      getScopeHandler() {
        return FlowScopeHandler;
      }
      shouldParseTypes() {
        return (
          this.getPluginOption('flow', 'all') || this.flowPragma === 'flow'
        );
      }
      shouldParseEnums() {
        return !!this.getPluginOption('flow', 'enums');
      }
      finishToken(type, val) {
        if (type !== 133 && type !== 13 && type !== 28) {
          if (this.flowPragma === undefined) {
            this.flowPragma = null;
          }
        }
        super.finishToken(type, val);
      }
      addComment(comment) {
        if (this.flowPragma === undefined) {
          const matches = FLOW_PRAGMA_REGEX.exec(comment.value);
          if (!matches);
          else if (matches[1] === 'flow') {
            this.flowPragma = 'flow';
          } else if (matches[1] === 'noflow') {
            this.flowPragma = 'noflow';
          } else {
            throw new Error('Unexpected flow pragma');
          }
        }
        super.addComment(comment);
      }
      flowParseTypeInitialiser(tok) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        this.expect(tok || 14);
        const type = this.flowParseType();
        this.state.inType = oldInType;
        return type;
      }
      flowParsePredicate() {
        const node = this.startNode();
        const moduloLoc = this.state.startLoc;
        this.next();
        this.expectContextual(110);
        if (this.state.lastTokStartLoc.index > moduloLoc.index + 1) {
          this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, moduloLoc);
        }
        if (this.eat(10)) {
          node.value = super.parseExpression();
          this.expect(11);
          return this.finishNode(node, 'DeclaredPredicate');
        } else {
          return this.finishNode(node, 'InferredPredicate');
        }
      }
      flowParseTypeAndPredicateInitialiser() {
        const oldInType = this.state.inType;
        this.state.inType = true;
        this.expect(14);
        let type = null;
        let predicate = null;
        if (this.match(54)) {
          this.state.inType = oldInType;
          predicate = this.flowParsePredicate();
        } else {
          type = this.flowParseType();
          this.state.inType = oldInType;
          if (this.match(54)) {
            predicate = this.flowParsePredicate();
          }
        }
        return [type, predicate];
      }
      flowParseDeclareClass(node) {
        this.next();
        this.flowParseInterfaceish(node, true);
        return this.finishNode(node, 'DeclareClass');
      }
      flowParseDeclareFunction(node) {
        this.next();
        const id = (node.id = this.parseIdentifier());
        const typeNode = this.startNode();
        const typeContainer = this.startNode();
        if (this.match(47)) {
          typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          typeNode.typeParameters = null;
        }
        this.expect(10);
        const tmp = this.flowParseFunctionTypeParams();
        typeNode.params = tmp.params;
        typeNode.rest = tmp.rest;
        typeNode.this = tmp._this;
        this.expect(11);
        [typeNode.returnType, node.predicate] =
          this.flowParseTypeAndPredicateInitialiser();
        typeContainer.typeAnnotation = this.finishNode(
          typeNode,
          'FunctionTypeAnnotation'
        );
        id.typeAnnotation = this.finishNode(typeContainer, 'TypeAnnotation');
        this.resetEndLocation(id);
        this.semicolon();
        this.scope.declareName(node.id.name, 2048, node.id.loc.start);
        return this.finishNode(node, 'DeclareFunction');
      }
      flowParseDeclare(node, insideModule) {
        if (this.match(80)) {
          return this.flowParseDeclareClass(node);
        } else if (this.match(68)) {
          return this.flowParseDeclareFunction(node);
        } else if (this.match(74)) {
          return this.flowParseDeclareVariable(node);
        } else if (this.eatContextual(127)) {
          if (this.match(16)) {
            return this.flowParseDeclareModuleExports(node);
          } else {
            if (insideModule) {
              this.raise(
                FlowErrors.NestedDeclareModule,
                this.state.lastTokStartLoc
              );
            }
            return this.flowParseDeclareModule(node);
          }
        } else if (this.isContextual(130)) {
          return this.flowParseDeclareTypeAlias(node);
        } else if (this.isContextual(131)) {
          return this.flowParseDeclareOpaqueType(node);
        } else if (this.isContextual(129)) {
          return this.flowParseDeclareInterface(node);
        } else if (this.match(82)) {
          return this.flowParseDeclareExportDeclaration(node, insideModule);
        } else {
          this.unexpected();
        }
      }
      flowParseDeclareVariable(node) {
        this.next();
        node.id = this.flowParseTypeAnnotatableIdentifier(true);
        this.scope.declareName(node.id.name, 5, node.id.loc.start);
        this.semicolon();
        return this.finishNode(node, 'DeclareVariable');
      }
      flowParseDeclareModule(node) {
        this.scope.enter(0);
        if (this.match(133)) {
          node.id = super.parseExprAtom();
        } else {
          node.id = this.parseIdentifier();
        }
        const bodyNode = (node.body = this.startNode());
        const body = (bodyNode.body = []);
        this.expect(5);
        while (!this.match(8)) {
          let bodyNode = this.startNode();
          if (this.match(83)) {
            this.next();
            if (!this.isContextual(130) && !this.match(87)) {
              this.raise(
                FlowErrors.InvalidNonTypeImportInDeclareModule,
                this.state.lastTokStartLoc
              );
            }
            super.parseImport(bodyNode);
          } else {
            this.expectContextual(
              125,
              FlowErrors.UnsupportedStatementInDeclareModule
            );
            bodyNode = this.flowParseDeclare(bodyNode, true);
          }
          body.push(bodyNode);
        }
        this.scope.exit();
        this.expect(8);
        this.finishNode(bodyNode, 'BlockStatement');
        let kind = null;
        let hasModuleExport = false;
        body.forEach(bodyElement => {
          if (isEsModuleType(bodyElement)) {
            if (kind === 'CommonJS') {
              this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
            }
            kind = 'ES';
          } else if (bodyElement.type === 'DeclareModuleExports') {
            if (hasModuleExport) {
              this.raise(FlowErrors.DuplicateDeclareModuleExports, bodyElement);
            }
            if (kind === 'ES') {
              this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
            }
            kind = 'CommonJS';
            hasModuleExport = true;
          }
        });
        node.kind = kind || 'CommonJS';
        return this.finishNode(node, 'DeclareModule');
      }
      flowParseDeclareExportDeclaration(node, insideModule) {
        this.expect(82);
        if (this.eat(65)) {
          if (this.match(68) || this.match(80)) {
            node.declaration = this.flowParseDeclare(this.startNode());
          } else {
            node.declaration = this.flowParseType();
            this.semicolon();
          }
          node.default = true;
          return this.finishNode(node, 'DeclareExportDeclaration');
        } else {
          if (
            this.match(75) ||
            this.isLet() ||
            ((this.isContextual(130) || this.isContextual(129)) &&
              !insideModule)
          ) {
            const label = this.state.value;
            throw this.raise(
              FlowErrors.UnsupportedDeclareExportKind,
              this.state.startLoc,
              {
                unsupportedExportKind: label,
                suggestion: exportSuggestions[label],
              }
            );
          }
          if (
            this.match(74) ||
            this.match(68) ||
            this.match(80) ||
            this.isContextual(131)
          ) {
            node.declaration = this.flowParseDeclare(this.startNode());
            node.default = false;
            return this.finishNode(node, 'DeclareExportDeclaration');
          } else if (
            this.match(55) ||
            this.match(5) ||
            this.isContextual(129) ||
            this.isContextual(130) ||
            this.isContextual(131)
          ) {
            node = this.parseExport(node, null);
            if (node.type === 'ExportNamedDeclaration') {
              node.type = 'ExportDeclaration';
              node.default = false;
              delete node.exportKind;
            }
            node.type = 'Declare' + node.type;
            return node;
          }
        }
        this.unexpected();
      }
      flowParseDeclareModuleExports(node) {
        this.next();
        this.expectContextual(111);
        node.typeAnnotation = this.flowParseTypeAnnotation();
        this.semicolon();
        return this.finishNode(node, 'DeclareModuleExports');
      }
      flowParseDeclareTypeAlias(node) {
        this.next();
        const finished = this.flowParseTypeAlias(node);
        finished.type = 'DeclareTypeAlias';
        return finished;
      }
      flowParseDeclareOpaqueType(node) {
        this.next();
        const finished = this.flowParseOpaqueType(node, true);
        finished.type = 'DeclareOpaqueType';
        return finished;
      }
      flowParseDeclareInterface(node) {
        this.next();
        this.flowParseInterfaceish(node, false);
        return this.finishNode(node, 'DeclareInterface');
      }
      flowParseInterfaceish(node, isClass) {
        node.id = this.flowParseRestrictedIdentifier(!isClass, true);
        this.scope.declareName(
          node.id.name,
          isClass ? 17 : 8201,
          node.id.loc.start
        );
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.extends = [];
        if (this.eat(81)) {
          do {
            node.extends.push(this.flowParseInterfaceExtends());
          } while (!isClass && this.eat(12));
        }
        if (isClass) {
          node.implements = [];
          node.mixins = [];
          if (this.eatContextual(117)) {
            do {
              node.mixins.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
          if (this.eatContextual(113)) {
            do {
              node.implements.push(this.flowParseInterfaceExtends());
            } while (this.eat(12));
          }
        }
        node.body = this.flowParseObjectType({
          allowStatic: isClass,
          allowExact: false,
          allowSpread: false,
          allowProto: isClass,
          allowInexact: false,
        });
      }
      flowParseInterfaceExtends() {
        const node = this.startNode();
        node.id = this.flowParseQualifiedTypeIdentifier();
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterInstantiation();
        } else {
          node.typeParameters = null;
        }
        return this.finishNode(node, 'InterfaceExtends');
      }
      flowParseInterface(node) {
        this.flowParseInterfaceish(node, false);
        return this.finishNode(node, 'InterfaceDeclaration');
      }
      checkNotUnderscore(word) {
        if (word === '_') {
          this.raise(
            FlowErrors.UnexpectedReservedUnderscore,
            this.state.startLoc
          );
        }
      }
      checkReservedType(word, startLoc, declaration) {
        if (!reservedTypes.has(word)) return;
        this.raise(
          declaration
            ? FlowErrors.AssignReservedType
            : FlowErrors.UnexpectedReservedType,
          startLoc,
          {reservedType: word}
        );
      }
      flowParseRestrictedIdentifier(liberal, declaration) {
        this.checkReservedType(
          this.state.value,
          this.state.startLoc,
          declaration
        );
        return this.parseIdentifier(liberal);
      }
      flowParseTypeAlias(node) {
        node.id = this.flowParseRestrictedIdentifier(false, true);
        this.scope.declareName(node.id.name, 8201, node.id.loc.start);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.right = this.flowParseTypeInitialiser(29);
        this.semicolon();
        return this.finishNode(node, 'TypeAlias');
      }
      flowParseOpaqueType(node, declare) {
        this.expectContextual(130);
        node.id = this.flowParseRestrictedIdentifier(true, true);
        this.scope.declareName(node.id.name, 8201, node.id.loc.start);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        } else {
          node.typeParameters = null;
        }
        node.supertype = null;
        if (this.match(14)) {
          node.supertype = this.flowParseTypeInitialiser(14);
        }
        node.impltype = null;
        if (!declare) {
          node.impltype = this.flowParseTypeInitialiser(29);
        }
        this.semicolon();
        return this.finishNode(node, 'OpaqueType');
      }
      flowParseTypeParameter(requireDefault = false) {
        const nodeStartLoc = this.state.startLoc;
        const node = this.startNode();
        const variance = this.flowParseVariance();
        const ident = this.flowParseTypeAnnotatableIdentifier();
        node.name = ident.name;
        node.variance = variance;
        node.bound = ident.typeAnnotation;
        if (this.match(29)) {
          this.eat(29);
          node.default = this.flowParseType();
        } else {
          if (requireDefault) {
            this.raise(FlowErrors.MissingTypeParamDefault, nodeStartLoc);
          }
        }
        return this.finishNode(node, 'TypeParameter');
      }
      flowParseTypeParameterDeclaration() {
        const oldInType = this.state.inType;
        const node = this.startNode();
        node.params = [];
        this.state.inType = true;
        if (this.match(47) || this.match(142)) {
          this.next();
        } else {
          this.unexpected();
        }
        let defaultRequired = false;
        do {
          const typeParameter = this.flowParseTypeParameter(defaultRequired);
          node.params.push(typeParameter);
          if (typeParameter.default) {
            defaultRequired = true;
          }
          if (!this.match(48)) {
            this.expect(12);
          }
        } while (!this.match(48));
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterDeclaration');
      }
      flowParseTypeParameterInstantiation() {
        const node = this.startNode();
        const oldInType = this.state.inType;
        node.params = [];
        this.state.inType = true;
        this.expect(47);
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        this.state.noAnonFunctionType = false;
        while (!this.match(48)) {
          node.params.push(this.flowParseType());
          if (!this.match(48)) {
            this.expect(12);
          }
        }
        this.state.noAnonFunctionType = oldNoAnonFunctionType;
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterInstantiation');
      }
      flowParseTypeParameterInstantiationCallOrNew() {
        const node = this.startNode();
        const oldInType = this.state.inType;
        node.params = [];
        this.state.inType = true;
        this.expect(47);
        while (!this.match(48)) {
          node.params.push(this.flowParseTypeOrImplicitInstantiation());
          if (!this.match(48)) {
            this.expect(12);
          }
        }
        this.expect(48);
        this.state.inType = oldInType;
        return this.finishNode(node, 'TypeParameterInstantiation');
      }
      flowParseInterfaceType() {
        const node = this.startNode();
        this.expectContextual(129);
        node.extends = [];
        if (this.eat(81)) {
          do {
            node.extends.push(this.flowParseInterfaceExtends());
          } while (this.eat(12));
        }
        node.body = this.flowParseObjectType({
          allowStatic: false,
          allowExact: false,
          allowSpread: false,
          allowProto: false,
          allowInexact: false,
        });
        return this.finishNode(node, 'InterfaceTypeAnnotation');
      }
      flowParseObjectPropertyKey() {
        return this.match(134) || this.match(133)
          ? super.parseExprAtom()
          : this.parseIdentifier(true);
      }
      flowParseObjectTypeIndexer(node, isStatic, variance) {
        node.static = isStatic;
        if (this.lookahead().type === 14) {
          node.id = this.flowParseObjectPropertyKey();
          node.key = this.flowParseTypeInitialiser();
        } else {
          node.id = null;
          node.key = this.flowParseType();
        }
        this.expect(3);
        node.value = this.flowParseTypeInitialiser();
        node.variance = variance;
        return this.finishNode(node, 'ObjectTypeIndexer');
      }
      flowParseObjectTypeInternalSlot(node, isStatic) {
        node.static = isStatic;
        node.id = this.flowParseObjectPropertyKey();
        this.expect(3);
        this.expect(3);
        if (this.match(47) || this.match(10)) {
          node.method = true;
          node.optional = false;
          node.value = this.flowParseObjectTypeMethodish(
            this.startNodeAt(node.loc.start)
          );
        } else {
          node.method = false;
          if (this.eat(17)) {
            node.optional = true;
          }
          node.value = this.flowParseTypeInitialiser();
        }
        return this.finishNode(node, 'ObjectTypeInternalSlot');
      }
      flowParseObjectTypeMethodish(node) {
        node.params = [];
        node.rest = null;
        node.typeParameters = null;
        node.this = null;
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        this.expect(10);
        if (this.match(78)) {
          node.this = this.flowParseFunctionTypeParam(true);
          node.this.name = null;
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        while (!this.match(11) && !this.match(21)) {
          node.params.push(this.flowParseFunctionTypeParam(false));
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        if (this.eat(21)) {
          node.rest = this.flowParseFunctionTypeParam(false);
        }
        this.expect(11);
        node.returnType = this.flowParseTypeInitialiser();
        return this.finishNode(node, 'FunctionTypeAnnotation');
      }
      flowParseObjectTypeCallProperty(node, isStatic) {
        const valueNode = this.startNode();
        node.static = isStatic;
        node.value = this.flowParseObjectTypeMethodish(valueNode);
        return this.finishNode(node, 'ObjectTypeCallProperty');
      }
      flowParseObjectType({
        allowStatic: allowStatic,
        allowExact: allowExact,
        allowSpread: allowSpread,
        allowProto: allowProto,
        allowInexact: allowInexact,
      }) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        const nodeStart = this.startNode();
        nodeStart.callProperties = [];
        nodeStart.properties = [];
        nodeStart.indexers = [];
        nodeStart.internalSlots = [];
        let endDelim;
        let exact;
        let inexact = false;
        if (allowExact && this.match(6)) {
          this.expect(6);
          endDelim = 9;
          exact = true;
        } else {
          this.expect(5);
          endDelim = 8;
          exact = false;
        }
        nodeStart.exact = exact;
        while (!this.match(endDelim)) {
          let isStatic = false;
          let protoStartLoc = null;
          let inexactStartLoc = null;
          const node = this.startNode();
          if (allowProto && this.isContextual(118)) {
            const lookahead = this.lookahead();
            if (lookahead.type !== 14 && lookahead.type !== 17) {
              this.next();
              protoStartLoc = this.state.startLoc;
              allowStatic = false;
            }
          }
          if (allowStatic && this.isContextual(106)) {
            const lookahead = this.lookahead();
            if (lookahead.type !== 14 && lookahead.type !== 17) {
              this.next();
              isStatic = true;
            }
          }
          const variance = this.flowParseVariance();
          if (this.eat(0)) {
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (this.eat(0)) {
              if (variance) {
                this.unexpected(variance.loc.start);
              }
              nodeStart.internalSlots.push(
                this.flowParseObjectTypeInternalSlot(node, isStatic)
              );
            } else {
              nodeStart.indexers.push(
                this.flowParseObjectTypeIndexer(node, isStatic, variance)
              );
            }
          } else if (this.match(10) || this.match(47)) {
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            nodeStart.callProperties.push(
              this.flowParseObjectTypeCallProperty(node, isStatic)
            );
          } else {
            let kind = 'init';
            if (this.isContextual(99) || this.isContextual(104)) {
              const lookahead = this.lookahead();
              if (tokenIsLiteralPropertyName(lookahead.type)) {
                kind = this.state.value;
                this.next();
              }
            }
            const propOrInexact = this.flowParseObjectTypeProperty(
              node,
              isStatic,
              protoStartLoc,
              variance,
              kind,
              allowSpread,
              allowInexact != null ? allowInexact : !exact
            );
            if (propOrInexact === null) {
              inexact = true;
              inexactStartLoc = this.state.lastTokStartLoc;
            } else {
              nodeStart.properties.push(propOrInexact);
            }
          }
          this.flowObjectTypeSemicolon();
          if (inexactStartLoc && !this.match(8) && !this.match(9)) {
            this.raise(
              FlowErrors.UnexpectedExplicitInexactInObject,
              inexactStartLoc
            );
          }
        }
        this.expect(endDelim);
        if (allowSpread) {
          nodeStart.inexact = inexact;
        }
        const out = this.finishNode(nodeStart, 'ObjectTypeAnnotation');
        this.state.inType = oldInType;
        return out;
      }
      flowParseObjectTypeProperty(
        node,
        isStatic,
        protoStartLoc,
        variance,
        kind,
        allowSpread,
        allowInexact
      ) {
        if (this.eat(21)) {
          const isInexactToken =
            this.match(12) || this.match(13) || this.match(8) || this.match(9);
          if (isInexactToken) {
            if (!allowSpread) {
              this.raise(
                FlowErrors.InexactInsideNonObject,
                this.state.lastTokStartLoc
              );
            } else if (!allowInexact) {
              this.raise(
                FlowErrors.InexactInsideExact,
                this.state.lastTokStartLoc
              );
            }
            if (variance) {
              this.raise(FlowErrors.InexactVariance, variance);
            }
            return null;
          }
          if (!allowSpread) {
            this.raise(
              FlowErrors.UnexpectedSpreadType,
              this.state.lastTokStartLoc
            );
          }
          if (protoStartLoc != null) {
            this.unexpected(protoStartLoc);
          }
          if (variance) {
            this.raise(FlowErrors.SpreadVariance, variance);
          }
          node.argument = this.flowParseType();
          return this.finishNode(node, 'ObjectTypeSpreadProperty');
        } else {
          node.key = this.flowParseObjectPropertyKey();
          node.static = isStatic;
          node.proto = protoStartLoc != null;
          node.kind = kind;
          let optional = false;
          if (this.match(47) || this.match(10)) {
            node.method = true;
            if (protoStartLoc != null) {
              this.unexpected(protoStartLoc);
            }
            if (variance) {
              this.unexpected(variance.loc.start);
            }
            node.value = this.flowParseObjectTypeMethodish(
              this.startNodeAt(node.loc.start)
            );
            if (kind === 'get' || kind === 'set') {
              this.flowCheckGetterSetterParams(node);
            }
            if (
              !allowSpread &&
              node.key.name === 'constructor' &&
              node.value.this
            ) {
              this.raise(
                FlowErrors.ThisParamBannedInConstructor,
                node.value.this
              );
            }
          } else {
            if (kind !== 'init') this.unexpected();
            node.method = false;
            if (this.eat(17)) {
              optional = true;
            }
            node.value = this.flowParseTypeInitialiser();
            node.variance = variance;
          }
          node.optional = optional;
          return this.finishNode(node, 'ObjectTypeProperty');
        }
      }
      flowCheckGetterSetterParams(property) {
        const paramCount = property.kind === 'get' ? 0 : 1;
        const length =
          property.value.params.length + (property.value.rest ? 1 : 0);
        if (property.value.this) {
          this.raise(
            property.kind === 'get'
              ? FlowErrors.GetterMayNotHaveThisParam
              : FlowErrors.SetterMayNotHaveThisParam,
            property.value.this
          );
        }
        if (length !== paramCount) {
          this.raise(
            property.kind === 'get'
              ? Errors.BadGetterArity
              : Errors.BadSetterArity,
            property
          );
        }
        if (property.kind === 'set' && property.value.rest) {
          this.raise(Errors.BadSetterRestParameter, property);
        }
      }
      flowObjectTypeSemicolon() {
        if (
          !this.eat(13) &&
          !this.eat(12) &&
          !this.match(8) &&
          !this.match(9)
        ) {
          this.unexpected();
        }
      }
      flowParseQualifiedTypeIdentifier(startLoc, id) {
        var _startLoc;
        (_startLoc = startLoc) != null
          ? _startLoc
          : (startLoc = this.state.startLoc);
        let node = id || this.flowParseRestrictedIdentifier(true);
        while (this.eat(16)) {
          const node2 = this.startNodeAt(startLoc);
          node2.qualification = node;
          node2.id = this.flowParseRestrictedIdentifier(true);
          node = this.finishNode(node2, 'QualifiedTypeIdentifier');
        }
        return node;
      }
      flowParseGenericType(startLoc, id) {
        const node = this.startNodeAt(startLoc);
        node.typeParameters = null;
        node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterInstantiation();
        }
        return this.finishNode(node, 'GenericTypeAnnotation');
      }
      flowParseTypeofType() {
        const node = this.startNode();
        this.expect(87);
        node.argument = this.flowParsePrimaryType();
        return this.finishNode(node, 'TypeofTypeAnnotation');
      }
      flowParseTupleType() {
        const node = this.startNode();
        node.types = [];
        this.expect(0);
        while (this.state.pos < this.length && !this.match(3)) {
          node.types.push(this.flowParseType());
          if (this.match(3)) break;
          this.expect(12);
        }
        this.expect(3);
        return this.finishNode(node, 'TupleTypeAnnotation');
      }
      flowParseFunctionTypeParam(first) {
        let name = null;
        let optional = false;
        let typeAnnotation = null;
        const node = this.startNode();
        const lh = this.lookahead();
        const isThis = this.state.type === 78;
        if (lh.type === 14 || lh.type === 17) {
          if (isThis && !first) {
            this.raise(FlowErrors.ThisParamMustBeFirst, node);
          }
          name = this.parseIdentifier(isThis);
          if (this.eat(17)) {
            optional = true;
            if (isThis) {
              this.raise(FlowErrors.ThisParamMayNotBeOptional, node);
            }
          }
          typeAnnotation = this.flowParseTypeInitialiser();
        } else {
          typeAnnotation = this.flowParseType();
        }
        node.name = name;
        node.optional = optional;
        node.typeAnnotation = typeAnnotation;
        return this.finishNode(node, 'FunctionTypeParam');
      }
      reinterpretTypeAsFunctionTypeParam(type) {
        const node = this.startNodeAt(type.loc.start);
        node.name = null;
        node.optional = false;
        node.typeAnnotation = type;
        return this.finishNode(node, 'FunctionTypeParam');
      }
      flowParseFunctionTypeParams(params = []) {
        let rest = null;
        let _this = null;
        if (this.match(78)) {
          _this = this.flowParseFunctionTypeParam(true);
          _this.name = null;
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        while (!this.match(11) && !this.match(21)) {
          params.push(this.flowParseFunctionTypeParam(false));
          if (!this.match(11)) {
            this.expect(12);
          }
        }
        if (this.eat(21)) {
          rest = this.flowParseFunctionTypeParam(false);
        }
        return {params: params, rest: rest, _this: _this};
      }
      flowIdentToTypeAnnotation(startLoc, node, id) {
        switch (id.name) {
          case 'any':
            return this.finishNode(node, 'AnyTypeAnnotation');
          case 'bool':
          case 'boolean':
            return this.finishNode(node, 'BooleanTypeAnnotation');
          case 'mixed':
            return this.finishNode(node, 'MixedTypeAnnotation');
          case 'empty':
            return this.finishNode(node, 'EmptyTypeAnnotation');
          case 'number':
            return this.finishNode(node, 'NumberTypeAnnotation');
          case 'string':
            return this.finishNode(node, 'StringTypeAnnotation');
          case 'symbol':
            return this.finishNode(node, 'SymbolTypeAnnotation');
          default:
            this.checkNotUnderscore(id.name);
            return this.flowParseGenericType(startLoc, id);
        }
      }
      flowParsePrimaryType() {
        const startLoc = this.state.startLoc;
        const node = this.startNode();
        let tmp;
        let type;
        let isGroupedType = false;
        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
        switch (this.state.type) {
          case 5:
            return this.flowParseObjectType({
              allowStatic: false,
              allowExact: false,
              allowSpread: true,
              allowProto: false,
              allowInexact: true,
            });
          case 6:
            return this.flowParseObjectType({
              allowStatic: false,
              allowExact: true,
              allowSpread: true,
              allowProto: false,
              allowInexact: false,
            });
          case 0:
            this.state.noAnonFunctionType = false;
            type = this.flowParseTupleType();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            return type;
          case 47: {
            const node = this.startNode();
            node.typeParameters = this.flowParseTypeParameterDeclaration();
            this.expect(10);
            tmp = this.flowParseFunctionTypeParams();
            node.params = tmp.params;
            node.rest = tmp.rest;
            node.this = tmp._this;
            this.expect(11);
            this.expect(19);
            node.returnType = this.flowParseType();
            return this.finishNode(node, 'FunctionTypeAnnotation');
          }
          case 10: {
            const node = this.startNode();
            this.next();
            if (!this.match(11) && !this.match(21)) {
              if (tokenIsIdentifier(this.state.type) || this.match(78)) {
                const token = this.lookahead().type;
                isGroupedType = token !== 17 && token !== 14;
              } else {
                isGroupedType = true;
              }
            }
            if (isGroupedType) {
              this.state.noAnonFunctionType = false;
              type = this.flowParseType();
              this.state.noAnonFunctionType = oldNoAnonFunctionType;
              if (
                this.state.noAnonFunctionType ||
                !(
                  this.match(12) ||
                  (this.match(11) && this.lookahead().type === 19)
                )
              ) {
                this.expect(11);
                return type;
              } else {
                this.eat(12);
              }
            }
            if (type) {
              tmp = this.flowParseFunctionTypeParams([
                this.reinterpretTypeAsFunctionTypeParam(type),
              ]);
            } else {
              tmp = this.flowParseFunctionTypeParams();
            }
            node.params = tmp.params;
            node.rest = tmp.rest;
            node.this = tmp._this;
            this.expect(11);
            this.expect(19);
            node.returnType = this.flowParseType();
            node.typeParameters = null;
            return this.finishNode(node, 'FunctionTypeAnnotation');
          }
          case 133:
            return this.parseLiteral(
              this.state.value,
              'StringLiteralTypeAnnotation'
            );
          case 85:
          case 86:
            node.value = this.match(85);
            this.next();
            return this.finishNode(node, 'BooleanLiteralTypeAnnotation');
          case 53:
            if (this.state.value === '-') {
              this.next();
              if (this.match(134)) {
                return this.parseLiteralAtNode(
                  -this.state.value,
                  'NumberLiteralTypeAnnotation',
                  node
                );
              }
              if (this.match(135)) {
                return this.parseLiteralAtNode(
                  -this.state.value,
                  'BigIntLiteralTypeAnnotation',
                  node
                );
              }
              throw this.raise(
                FlowErrors.UnexpectedSubtractionOperand,
                this.state.startLoc
              );
            }
            this.unexpected();
            return;
          case 134:
            return this.parseLiteral(
              this.state.value,
              'NumberLiteralTypeAnnotation'
            );
          case 135:
            return this.parseLiteral(
              this.state.value,
              'BigIntLiteralTypeAnnotation'
            );
          case 88:
            this.next();
            return this.finishNode(node, 'VoidTypeAnnotation');
          case 84:
            this.next();
            return this.finishNode(node, 'NullLiteralTypeAnnotation');
          case 78:
            this.next();
            return this.finishNode(node, 'ThisTypeAnnotation');
          case 55:
            this.next();
            return this.finishNode(node, 'ExistsTypeAnnotation');
          case 87:
            return this.flowParseTypeofType();
          default:
            if (tokenIsKeyword(this.state.type)) {
              const label = tokenLabelName(this.state.type);
              this.next();
              return super.createIdentifier(node, label);
            } else if (tokenIsIdentifier(this.state.type)) {
              if (this.isContextual(129)) {
                return this.flowParseInterfaceType();
              }
              return this.flowIdentToTypeAnnotation(
                startLoc,
                node,
                this.parseIdentifier()
              );
            }
        }
        this.unexpected();
      }
      flowParsePostfixType() {
        const startLoc = this.state.startLoc;
        let type = this.flowParsePrimaryType();
        let seenOptionalIndexedAccess = false;
        while (
          (this.match(0) || this.match(18)) &&
          !this.canInsertSemicolon()
        ) {
          const node = this.startNodeAt(startLoc);
          const optional = this.eat(18);
          seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
          this.expect(0);
          if (!optional && this.match(3)) {
            node.elementType = type;
            this.next();
            type = this.finishNode(node, 'ArrayTypeAnnotation');
          } else {
            node.objectType = type;
            node.indexType = this.flowParseType();
            this.expect(3);
            if (seenOptionalIndexedAccess) {
              node.optional = optional;
              type = this.finishNode(node, 'OptionalIndexedAccessType');
            } else {
              type = this.finishNode(node, 'IndexedAccessType');
            }
          }
        }
        return type;
      }
      flowParsePrefixType() {
        const node = this.startNode();
        if (this.eat(17)) {
          node.typeAnnotation = this.flowParsePrefixType();
          return this.finishNode(node, 'NullableTypeAnnotation');
        } else {
          return this.flowParsePostfixType();
        }
      }
      flowParseAnonFunctionWithoutParens() {
        const param = this.flowParsePrefixType();
        if (!this.state.noAnonFunctionType && this.eat(19)) {
          const node = this.startNodeAt(param.loc.start);
          node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
          node.rest = null;
          node.this = null;
          node.returnType = this.flowParseType();
          node.typeParameters = null;
          return this.finishNode(node, 'FunctionTypeAnnotation');
        }
        return param;
      }
      flowParseIntersectionType() {
        const node = this.startNode();
        this.eat(45);
        const type = this.flowParseAnonFunctionWithoutParens();
        node.types = [type];
        while (this.eat(45)) {
          node.types.push(this.flowParseAnonFunctionWithoutParens());
        }
        return node.types.length === 1
          ? type
          : this.finishNode(node, 'IntersectionTypeAnnotation');
      }
      flowParseUnionType() {
        const node = this.startNode();
        this.eat(43);
        const type = this.flowParseIntersectionType();
        node.types = [type];
        while (this.eat(43)) {
          node.types.push(this.flowParseIntersectionType());
        }
        return node.types.length === 1
          ? type
          : this.finishNode(node, 'UnionTypeAnnotation');
      }
      flowParseType() {
        const oldInType = this.state.inType;
        this.state.inType = true;
        const type = this.flowParseUnionType();
        this.state.inType = oldInType;
        return type;
      }
      flowParseTypeOrImplicitInstantiation() {
        if (this.state.type === 132 && this.state.value === '_') {
          const startLoc = this.state.startLoc;
          const node = this.parseIdentifier();
          return this.flowParseGenericType(startLoc, node);
        } else {
          return this.flowParseType();
        }
      }
      flowParseTypeAnnotation() {
        const node = this.startNode();
        node.typeAnnotation = this.flowParseTypeInitialiser();
        return this.finishNode(node, 'TypeAnnotation');
      }
      flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
        const ident = allowPrimitiveOverride
          ? this.parseIdentifier()
          : this.flowParseRestrictedIdentifier();
        if (this.match(14)) {
          ident.typeAnnotation = this.flowParseTypeAnnotation();
          this.resetEndLocation(ident);
        }
        return ident;
      }
      typeCastToParameter(node) {
        node.expression.typeAnnotation = node.typeAnnotation;
        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
        return node.expression;
      }
      flowParseVariance() {
        let variance = null;
        if (this.match(53)) {
          variance = this.startNode();
          if (this.state.value === '+') {
            variance.kind = 'plus';
          } else {
            variance.kind = 'minus';
          }
          this.next();
          return this.finishNode(variance, 'Variance');
        }
        return variance;
      }
      parseFunctionBody(node, allowExpressionBody, isMethod = false) {
        if (allowExpressionBody) {
          this.forwardNoArrowParamsConversionAt(node, () =>
            super.parseFunctionBody(node, true, isMethod)
          );
          return;
        }
        super.parseFunctionBody(node, false, isMethod);
      }
      parseFunctionBodyAndFinish(node, type, isMethod = false) {
        if (this.match(14)) {
          const typeNode = this.startNode();
          [typeNode.typeAnnotation, node.predicate] =
            this.flowParseTypeAndPredicateInitialiser();
          node.returnType = typeNode.typeAnnotation
            ? this.finishNode(typeNode, 'TypeAnnotation')
            : null;
        }
        return super.parseFunctionBodyAndFinish(node, type, isMethod);
      }
      parseStatementLike(flags) {
        if (this.state.strict && this.isContextual(129)) {
          const lookahead = this.lookahead();
          if (tokenIsKeywordOrIdentifier(lookahead.type)) {
            const node = this.startNode();
            this.next();
            return this.flowParseInterface(node);
          }
        } else if (this.shouldParseEnums() && this.isContextual(126)) {
          const node = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(node);
        }
        const stmt = super.parseStatementLike(flags);
        if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
          this.flowPragma = null;
        }
        return stmt;
      }
      parseExpressionStatement(node, expr, decorators) {
        if (expr.type === 'Identifier') {
          if (expr.name === 'declare') {
            if (
              this.match(80) ||
              tokenIsIdentifier(this.state.type) ||
              this.match(68) ||
              this.match(74) ||
              this.match(82)
            ) {
              return this.flowParseDeclare(node);
            }
          } else if (tokenIsIdentifier(this.state.type)) {
            if (expr.name === 'interface') {
              return this.flowParseInterface(node);
            } else if (expr.name === 'type') {
              return this.flowParseTypeAlias(node);
            } else if (expr.name === 'opaque') {
              return this.flowParseOpaqueType(node, false);
            }
          }
        }
        return super.parseExpressionStatement(node, expr, decorators);
      }
      shouldParseExportDeclaration() {
        const {type: type} = this.state;
        if (
          tokenIsFlowInterfaceOrTypeOrOpaque(type) ||
          (this.shouldParseEnums() && type === 126)
        ) {
          return !this.state.containsEsc;
        }
        return super.shouldParseExportDeclaration();
      }
      isExportDefaultSpecifier() {
        const {type: type} = this.state;
        if (
          tokenIsFlowInterfaceOrTypeOrOpaque(type) ||
          (this.shouldParseEnums() && type === 126)
        ) {
          return this.state.containsEsc;
        }
        return super.isExportDefaultSpecifier();
      }
      parseExportDefaultExpression() {
        if (this.shouldParseEnums() && this.isContextual(126)) {
          const node = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(node);
        }
        return super.parseExportDefaultExpression();
      }
      parseConditional(expr, startLoc, refExpressionErrors) {
        if (!this.match(17)) return expr;
        if (this.state.maybeInArrowParameters) {
          const nextCh = this.lookaheadCharCode();
          if (
            nextCh === 44 ||
            nextCh === 61 ||
            nextCh === 58 ||
            nextCh === 41
          ) {
            this.setOptionalParametersError(refExpressionErrors);
            return expr;
          }
        }
        this.expect(17);
        const state = this.state.clone();
        const originalNoArrowAt = this.state.noArrowAt;
        const node = this.startNodeAt(startLoc);
        let {consequent: consequent, failed: failed} =
          this.tryParseConditionalConsequent();
        let [valid, invalid] = this.getArrowLikeExpressions(consequent);
        if (failed || invalid.length > 0) {
          const noArrowAt = [...originalNoArrowAt];
          if (invalid.length > 0) {
            this.state = state;
            this.state.noArrowAt = noArrowAt;
            for (let i = 0; i < invalid.length; i++) {
              noArrowAt.push(invalid[i].start);
            }
            ({consequent: consequent, failed: failed} =
              this.tryParseConditionalConsequent());
            [valid, invalid] = this.getArrowLikeExpressions(consequent);
          }
          if (failed && valid.length > 1) {
            this.raise(FlowErrors.AmbiguousConditionalArrow, state.startLoc);
          }
          if (failed && valid.length === 1) {
            this.state = state;
            noArrowAt.push(valid[0].start);
            this.state.noArrowAt = noArrowAt;
            ({consequent: consequent, failed: failed} =
              this.tryParseConditionalConsequent());
          }
        }
        this.getArrowLikeExpressions(consequent, true);
        this.state.noArrowAt = originalNoArrowAt;
        this.expect(14);
        node.test = expr;
        node.consequent = consequent;
        node.alternate = this.forwardNoArrowParamsConversionAt(node, () =>
          this.parseMaybeAssign(undefined, undefined)
        );
        return this.finishNode(node, 'ConditionalExpression');
      }
      tryParseConditionalConsequent() {
        this.state.noArrowParamsConversionAt.push(this.state.start);
        const consequent = this.parseMaybeAssignAllowIn();
        const failed = !this.match(14);
        this.state.noArrowParamsConversionAt.pop();
        return {consequent: consequent, failed: failed};
      }
      getArrowLikeExpressions(node, disallowInvalid) {
        const stack = [node];
        const arrows = [];
        while (stack.length !== 0) {
          const node = stack.pop();
          if (
            node.type === 'ArrowFunctionExpression' &&
            node.body.type !== 'BlockStatement'
          ) {
            if (node.typeParameters || !node.returnType) {
              this.finishArrowValidation(node);
            } else {
              arrows.push(node);
            }
            stack.push(node.body);
          } else if (node.type === 'ConditionalExpression') {
            stack.push(node.consequent);
            stack.push(node.alternate);
          }
        }
        if (disallowInvalid) {
          arrows.forEach(node => this.finishArrowValidation(node));
          return [arrows, []];
        }
        return partition(arrows, node =>
          node.params.every(param => this.isAssignable(param, true))
        );
      }
      finishArrowValidation(node) {
        var _node$extra;
        this.toAssignableList(
          node.params,
          (_node$extra = node.extra) == null
            ? void 0
            : _node$extra.trailingCommaLoc,
          false
        );
        this.scope.enter(2 | 4);
        super.checkParams(node, false, true);
        this.scope.exit();
      }
      forwardNoArrowParamsConversionAt(node, parse) {
        let result;
        if (this.state.noArrowParamsConversionAt.includes(node.start)) {
          this.state.noArrowParamsConversionAt.push(this.state.start);
          result = parse();
          this.state.noArrowParamsConversionAt.pop();
        } else {
          result = parse();
        }
        return result;
      }
      parseParenItem(node, startLoc) {
        const newNode = super.parseParenItem(node, startLoc);
        if (this.eat(17)) {
          newNode.optional = true;
          this.resetEndLocation(node);
        }
        if (this.match(14)) {
          const typeCastNode = this.startNodeAt(startLoc);
          typeCastNode.expression = newNode;
          typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
          return this.finishNode(typeCastNode, 'TypeCastExpression');
        }
        return newNode;
      }
      assertModuleNodeAllowed(node) {
        if (
          (node.type === 'ImportDeclaration' &&
            (node.importKind === 'type' || node.importKind === 'typeof')) ||
          (node.type === 'ExportNamedDeclaration' &&
            node.exportKind === 'type') ||
          (node.type === 'ExportAllDeclaration' && node.exportKind === 'type')
        ) {
          return;
        }
        super.assertModuleNodeAllowed(node);
      }
      parseExportDeclaration(node) {
        if (this.isContextual(130)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          if (this.match(5)) {
            node.specifiers = this.parseExportSpecifiers(true);
            super.parseExportFrom(node);
            return null;
          } else {
            return this.flowParseTypeAlias(declarationNode);
          }
        } else if (this.isContextual(131)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseOpaqueType(declarationNode, false);
        } else if (this.isContextual(129)) {
          node.exportKind = 'type';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseInterface(declarationNode);
        } else if (this.shouldParseEnums() && this.isContextual(126)) {
          node.exportKind = 'value';
          const declarationNode = this.startNode();
          this.next();
          return this.flowParseEnumDeclaration(declarationNode);
        } else {
          return super.parseExportDeclaration(node);
        }
      }
      eatExportStar(node) {
        if (super.eatExportStar(node)) return true;
        if (this.isContextual(130) && this.lookahead().type === 55) {
          node.exportKind = 'type';
          this.next();
          this.next();
          return true;
        }
        return false;
      }
      maybeParseExportNamespaceSpecifier(node) {
        const {startLoc: startLoc} = this.state;
        const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);
        if (hasNamespace && node.exportKind === 'type') {
          this.unexpected(startLoc);
        }
        return hasNamespace;
      }
      parseClassId(node, isStatement, optionalId) {
        super.parseClassId(node, isStatement, optionalId);
        if (this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
      }
      parseClassMember(classBody, member, state) {
        const {startLoc: startLoc} = this.state;
        if (this.isContextual(125)) {
          if (super.parseClassMemberFromModifier(classBody, member)) {
            return;
          }
          member.declare = true;
        }
        super.parseClassMember(classBody, member, state);
        if (member.declare) {
          if (
            member.type !== 'ClassProperty' &&
            member.type !== 'ClassPrivateProperty' &&
            member.type !== 'PropertyDefinition'
          ) {
            this.raise(FlowErrors.DeclareClassElement, startLoc);
          } else if (member.value) {
            this.raise(FlowErrors.DeclareClassFieldInitializer, member.value);
          }
        }
      }
      isIterator(word) {
        return word === 'iterator' || word === 'asyncIterator';
      }
      readIterator() {
        const word = super.readWord1();
        const fullWord = '@@' + word;
        if (!this.isIterator(word) || !this.state.inType) {
          this.raise(Errors.InvalidIdentifier, this.state.curPosition(), {
            identifierName: fullWord,
          });
        }
        this.finishToken(132, fullWord);
      }
      getTokenFromCode(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 123 && next === 124) {
          this.finishOp(6, 2);
        } else if (this.state.inType && (code === 62 || code === 60)) {
          this.finishOp(code === 62 ? 48 : 47, 1);
        } else if (this.state.inType && code === 63) {
          if (next === 46) {
            this.finishOp(18, 2);
          } else {
            this.finishOp(17, 1);
          }
        } else if (
          isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))
        ) {
          this.state.pos += 2;
          this.readIterator();
        } else {
          super.getTokenFromCode(code);
        }
      }
      isAssignable(node, isBinding) {
        if (node.type === 'TypeCastExpression') {
          return this.isAssignable(node.expression, isBinding);
        } else {
          return super.isAssignable(node, isBinding);
        }
      }
      toAssignable(node, isLHS = false) {
        if (
          !isLHS &&
          node.type === 'AssignmentExpression' &&
          node.left.type === 'TypeCastExpression'
        ) {
          node.left = this.typeCastToParameter(node.left);
        }
        super.toAssignable(node, isLHS);
      }
      toAssignableList(exprList, trailingCommaLoc, isLHS) {
        for (let i = 0; i < exprList.length; i++) {
          const expr = exprList[i];
          if ((expr == null ? void 0 : expr.type) === 'TypeCastExpression') {
            exprList[i] = this.typeCastToParameter(expr);
          }
        }
        super.toAssignableList(exprList, trailingCommaLoc, isLHS);
      }
      toReferencedList(exprList, isParenthesizedExpr) {
        for (let i = 0; i < exprList.length; i++) {
          var _expr$extra;
          const expr = exprList[i];
          if (
            expr &&
            expr.type === 'TypeCastExpression' &&
            !(
              (_expr$extra = expr.extra) != null && _expr$extra.parenthesized
            ) &&
            (exprList.length > 1 || !isParenthesizedExpr)
          ) {
            this.raise(FlowErrors.TypeCastInPattern, expr.typeAnnotation);
          }
        }
        return exprList;
      }
      parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        const node = super.parseArrayLike(
          close,
          canBePattern,
          isTuple,
          refExpressionErrors
        );
        if (canBePattern && !this.state.maybeInArrowParameters) {
          this.toReferencedList(node.elements);
        }
        return node;
      }
      isValidLVal(type, isParenthesized, binding) {
        return (
          type === 'TypeCastExpression' ||
          super.isValidLVal(type, isParenthesized, binding)
        );
      }
      parseClassProperty(node) {
        if (this.match(14)) {
          node.typeAnnotation = this.flowParseTypeAnnotation();
        }
        return super.parseClassProperty(node);
      }
      parseClassPrivateProperty(node) {
        if (this.match(14)) {
          node.typeAnnotation = this.flowParseTypeAnnotation();
        }
        return super.parseClassPrivateProperty(node);
      }
      isClassMethod() {
        return this.match(47) || super.isClassMethod();
      }
      isClassProperty() {
        return this.match(14) || super.isClassProperty();
      }
      isNonstaticConstructor(method) {
        return !this.match(14) && super.isNonstaticConstructor(method);
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        if (method.variance) {
          this.unexpected(method.variance.loc.start);
        }
        delete method.variance;
        if (this.match(47)) {
          method.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.pushClassMethod(
          classBody,
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper
        );
        if (method.params && isConstructor) {
          const params = method.params;
          if (params.length > 0 && this.isThisParam(params[0])) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
          }
        } else if (
          method.type === 'MethodDefinition' &&
          isConstructor &&
          method.value.params
        ) {
          const params = method.value.params;
          if (params.length > 0 && this.isThisParam(params[0])) {
            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
          }
        }
      }
      pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
        if (method.variance) {
          this.unexpected(method.variance.loc.start);
        }
        delete method.variance;
        if (this.match(47)) {
          method.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
      }
      parseClassSuper(node) {
        super.parseClassSuper(node);
        if (node.superClass && this.match(47)) {
          node.superTypeParameters = this.flowParseTypeParameterInstantiation();
        }
        if (this.isContextual(113)) {
          this.next();
          const implemented = (node.implements = []);
          do {
            const node = this.startNode();
            node.id = this.flowParseRestrictedIdentifier(true);
            if (this.match(47)) {
              node.typeParameters = this.flowParseTypeParameterInstantiation();
            } else {
              node.typeParameters = null;
            }
            implemented.push(this.finishNode(node, 'ClassImplements'));
          } while (this.eat(12));
        }
      }
      checkGetterSetterParams(method) {
        super.checkGetterSetterParams(method);
        const params = this.getObjectOrClassMethodParams(method);
        if (params.length > 0) {
          const param = params[0];
          if (this.isThisParam(param) && method.kind === 'get') {
            this.raise(FlowErrors.GetterMayNotHaveThisParam, param);
          } else if (this.isThisParam(param)) {
            this.raise(FlowErrors.SetterMayNotHaveThisParam, param);
          }
        }
      }
      parsePropertyNamePrefixOperator(node) {
        node.variance = this.flowParseVariance();
      }
      parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      ) {
        if (prop.variance) {
          this.unexpected(prop.variance.loc.start);
        }
        delete prop.variance;
        let typeParameters;
        if (this.match(47) && !isAccessor) {
          typeParameters = this.flowParseTypeParameterDeclaration();
          if (!this.match(10)) this.unexpected();
        }
        const result = super.parseObjPropValue(
          prop,
          startLoc,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor,
          refExpressionErrors
        );
        if (typeParameters) {
          (result.value || result).typeParameters = typeParameters;
        }
        return result;
      }
      parseAssignableListItemTypes(param) {
        if (this.eat(17)) {
          if (param.type !== 'Identifier') {
            this.raise(FlowErrors.PatternIsOptional, param);
          }
          if (this.isThisParam(param)) {
            this.raise(FlowErrors.ThisParamMayNotBeOptional, param);
          }
          param.optional = true;
        }
        if (this.match(14)) {
          param.typeAnnotation = this.flowParseTypeAnnotation();
        } else if (this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamAnnotationRequired, param);
        }
        if (this.match(29) && this.isThisParam(param)) {
          this.raise(FlowErrors.ThisParamNoDefault, param);
        }
        this.resetEndLocation(param);
        return param;
      }
      parseMaybeDefault(startLoc, left) {
        const node = super.parseMaybeDefault(startLoc, left);
        if (
          node.type === 'AssignmentPattern' &&
          node.typeAnnotation &&
          node.right.start < node.typeAnnotation.start
        ) {
          this.raise(FlowErrors.TypeBeforeInitializer, node.typeAnnotation);
        }
        return node;
      }
      checkImportReflection(node) {
        super.checkImportReflection(node);
        if (node.module && node.importKind !== 'value') {
          this.raise(
            FlowErrors.ImportReflectionHasImportType,
            node.specifiers[0].loc.start
          );
        }
      }
      parseImportSpecifierLocal(node, specifier, type) {
        specifier.local = hasTypeImportKind(node)
          ? this.flowParseRestrictedIdentifier(true, true)
          : this.parseIdentifier();
        node.specifiers.push(this.finishImportSpecifier(specifier, type));
      }
      isPotentialImportPhase(isExport) {
        if (super.isPotentialImportPhase(isExport)) return true;
        if (this.isContextual(130)) {
          if (!isExport) return true;
          const ch = this.lookaheadCharCode();
          return ch === 123 || ch === 42;
        }
        return !isExport && this.isContextual(87);
      }
      applyImportPhase(node, isExport, phase, loc) {
        super.applyImportPhase(node, isExport, phase, loc);
        if (isExport) {
          if (!phase && this.match(65)) {
            return;
          }
          node.exportKind = phase === 'type' ? phase : 'value';
        } else {
          if (phase === 'type' && this.match(55)) this.unexpected();
          node.importKind =
            phase === 'type' || phase === 'typeof' ? phase : 'value';
        }
      }
      parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        bindingType
      ) {
        const firstIdent = specifier.imported;
        let specifierTypeKind = null;
        if (firstIdent.type === 'Identifier') {
          if (firstIdent.name === 'type') {
            specifierTypeKind = 'type';
          } else if (firstIdent.name === 'typeof') {
            specifierTypeKind = 'typeof';
          }
        }
        let isBinding = false;
        if (this.isContextual(93) && !this.isLookaheadContextual('as')) {
          const as_ident = this.parseIdentifier(true);
          if (
            specifierTypeKind !== null &&
            !tokenIsKeywordOrIdentifier(this.state.type)
          ) {
            specifier.imported = as_ident;
            specifier.importKind = specifierTypeKind;
            specifier.local = cloneIdentifier(as_ident);
          } else {
            specifier.imported = firstIdent;
            specifier.importKind = null;
            specifier.local = this.parseIdentifier();
          }
        } else {
          if (
            specifierTypeKind !== null &&
            tokenIsKeywordOrIdentifier(this.state.type)
          ) {
            specifier.imported = this.parseIdentifier(true);
            specifier.importKind = specifierTypeKind;
          } else {
            if (importedIsString) {
              throw this.raise(Errors.ImportBindingIsString, specifier, {
                importName: firstIdent.value,
              });
            }
            specifier.imported = firstIdent;
            specifier.importKind = null;
          }
          if (this.eatContextual(93)) {
            specifier.local = this.parseIdentifier();
          } else {
            isBinding = true;
            specifier.local = cloneIdentifier(specifier.imported);
          }
        }
        const specifierIsTypeImport = hasTypeImportKind(specifier);
        if (isInTypeOnlyImport && specifierIsTypeImport) {
          this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, specifier);
        }
        if (isInTypeOnlyImport || specifierIsTypeImport) {
          this.checkReservedType(
            specifier.local.name,
            specifier.local.loc.start,
            true
          );
        }
        if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
          this.checkReservedWord(
            specifier.local.name,
            specifier.loc.start,
            true,
            true
          );
        }
        return this.finishImportSpecifier(specifier, 'ImportSpecifier');
      }
      parseBindingAtom() {
        switch (this.state.type) {
          case 78:
            return this.parseIdentifier(true);
          default:
            return super.parseBindingAtom();
        }
      }
      parseFunctionParams(node, isConstructor) {
        const kind = node.kind;
        if (kind !== 'get' && kind !== 'set' && this.match(47)) {
          node.typeParameters = this.flowParseTypeParameterDeclaration();
        }
        super.parseFunctionParams(node, isConstructor);
      }
      parseVarId(decl, kind) {
        super.parseVarId(decl, kind);
        if (this.match(14)) {
          decl.id.typeAnnotation = this.flowParseTypeAnnotation();
          this.resetEndLocation(decl.id);
        }
      }
      parseAsyncArrowFromCallExpression(node, call) {
        if (this.match(14)) {
          const oldNoAnonFunctionType = this.state.noAnonFunctionType;
          this.state.noAnonFunctionType = true;
          node.returnType = this.flowParseTypeAnnotation();
          this.state.noAnonFunctionType = oldNoAnonFunctionType;
        }
        return super.parseAsyncArrowFromCallExpression(node, call);
      }
      shouldParseAsyncArrow() {
        return this.match(14) || super.shouldParseAsyncArrow();
      }
      parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var _jsx;
        let state = null;
        let jsx;
        if (this.hasPlugin('jsx') && (this.match(142) || this.match(47))) {
          state = this.state.clone();
          jsx = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!jsx.error) return jsx.node;
          const {context: context} = this.state;
          const currentContext = context[context.length - 1];
          if (
            currentContext === types.j_oTag ||
            currentContext === types.j_expr
          ) {
            context.pop();
          }
        }
        if (((_jsx = jsx) != null && _jsx.error) || this.match(47)) {
          var _jsx2, _jsx3;
          state = state || this.state.clone();
          let typeParameters;
          const arrow = this.tryParse(abort => {
            var _arrowExpression$extr;
            typeParameters = this.flowParseTypeParameterDeclaration();
            const arrowExpression = this.forwardNoArrowParamsConversionAt(
              typeParameters,
              () => {
                const result = super.parseMaybeAssign(
                  refExpressionErrors,
                  afterLeftParse
                );
                this.resetStartLocationFromNode(result, typeParameters);
                return result;
              }
            );
            if (
              (_arrowExpression$extr = arrowExpression.extra) != null &&
              _arrowExpression$extr.parenthesized
            )
              abort();
            const expr = this.maybeUnwrapTypeCastExpression(arrowExpression);
            if (expr.type !== 'ArrowFunctionExpression') abort();
            expr.typeParameters = typeParameters;
            this.resetStartLocationFromNode(expr, typeParameters);
            return arrowExpression;
          }, state);
          let arrowExpression = null;
          if (
            arrow.node &&
            this.maybeUnwrapTypeCastExpression(arrow.node).type ===
              'ArrowFunctionExpression'
          ) {
            if (!arrow.error && !arrow.aborted) {
              if (arrow.node.async) {
                this.raise(
                  FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction,
                  typeParameters
                );
              }
              return arrow.node;
            }
            arrowExpression = arrow.node;
          }
          if ((_jsx2 = jsx) != null && _jsx2.node) {
            this.state = jsx.failState;
            return jsx.node;
          }
          if (arrowExpression) {
            this.state = arrow.failState;
            return arrowExpression;
          }
          if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
          if (arrow.thrown) throw arrow.error;
          throw this.raise(
            FlowErrors.UnexpectedTokenAfterTypeParameter,
            typeParameters
          );
        }
        return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
      }
      parseArrow(node) {
        if (this.match(14)) {
          const result = this.tryParse(() => {
            const oldNoAnonFunctionType = this.state.noAnonFunctionType;
            this.state.noAnonFunctionType = true;
            const typeNode = this.startNode();
            [typeNode.typeAnnotation, node.predicate] =
              this.flowParseTypeAndPredicateInitialiser();
            this.state.noAnonFunctionType = oldNoAnonFunctionType;
            if (this.canInsertSemicolon()) this.unexpected();
            if (!this.match(19)) this.unexpected();
            return typeNode;
          });
          if (result.thrown) return null;
          if (result.error) this.state = result.failState;
          node.returnType = result.node.typeAnnotation
            ? this.finishNode(result.node, 'TypeAnnotation')
            : null;
        }
        return super.parseArrow(node);
      }
      shouldParseArrow(params) {
        return this.match(14) || super.shouldParseArrow(params);
      }
      setArrowFunctionParameters(node, params) {
        if (this.state.noArrowParamsConversionAt.includes(node.start)) {
          node.params = params;
        } else {
          super.setArrowFunctionParameters(node, params);
        }
      }
      checkParams(
        node,
        allowDuplicates,
        isArrowFunction,
        strictModeChanged = true
      ) {
        if (
          isArrowFunction &&
          this.state.noArrowParamsConversionAt.includes(node.start)
        ) {
          return;
        }
        for (let i = 0; i < node.params.length; i++) {
          if (this.isThisParam(node.params[i]) && i > 0) {
            this.raise(FlowErrors.ThisParamMustBeFirst, node.params[i]);
          }
        }
        super.checkParams(
          node,
          allowDuplicates,
          isArrowFunction,
          strictModeChanged
        );
      }
      parseParenAndDistinguishExpression(canBeArrow) {
        return super.parseParenAndDistinguishExpression(
          canBeArrow && !this.state.noArrowAt.includes(this.state.start)
        );
      }
      parseSubscripts(base, startLoc, noCalls) {
        if (
          base.type === 'Identifier' &&
          base.name === 'async' &&
          this.state.noArrowAt.includes(startLoc.index)
        ) {
          this.next();
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          node.arguments = super.parseCallExpressionArguments(11, false);
          base = this.finishNode(node, 'CallExpression');
        } else if (
          base.type === 'Identifier' &&
          base.name === 'async' &&
          this.match(47)
        ) {
          const state = this.state.clone();
          const arrow = this.tryParse(
            abort =>
              this.parseAsyncArrowWithTypeParameters(startLoc) || abort(),
            state
          );
          if (!arrow.error && !arrow.aborted) return arrow.node;
          const result = this.tryParse(
            () => super.parseSubscripts(base, startLoc, noCalls),
            state
          );
          if (result.node && !result.error) return result.node;
          if (arrow.node) {
            this.state = arrow.failState;
            return arrow.node;
          }
          if (result.node) {
            this.state = result.failState;
            return result.node;
          }
          throw arrow.error || result.error;
        }
        return super.parseSubscripts(base, startLoc, noCalls);
      }
      parseSubscript(base, startLoc, noCalls, subscriptState) {
        if (this.match(18) && this.isLookaheadToken_lt()) {
          subscriptState.optionalChainMember = true;
          if (noCalls) {
            subscriptState.stop = true;
            return base;
          }
          this.next();
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          node.typeArguments = this.flowParseTypeParameterInstantiation();
          this.expect(10);
          node.arguments = this.parseCallExpressionArguments(11, false);
          node.optional = true;
          return this.finishCallExpression(node, true);
        } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
          const node = this.startNodeAt(startLoc);
          node.callee = base;
          const result = this.tryParse(() => {
            node.typeArguments =
              this.flowParseTypeParameterInstantiationCallOrNew();
            this.expect(10);
            node.arguments = super.parseCallExpressionArguments(11, false);
            if (subscriptState.optionalChainMember) {
              node.optional = false;
            }
            return this.finishCallExpression(
              node,
              subscriptState.optionalChainMember
            );
          });
          if (result.node) {
            if (result.error) this.state = result.failState;
            return result.node;
          }
        }
        return super.parseSubscript(base, startLoc, noCalls, subscriptState);
      }
      parseNewCallee(node) {
        super.parseNewCallee(node);
        let targs = null;
        if (this.shouldParseTypes() && this.match(47)) {
          targs = this.tryParse(() =>
            this.flowParseTypeParameterInstantiationCallOrNew()
          ).node;
        }
        node.typeArguments = targs;
      }
      parseAsyncArrowWithTypeParameters(startLoc) {
        const node = this.startNodeAt(startLoc);
        this.parseFunctionParams(node, false);
        if (!this.parseArrow(node)) return;
        return super.parseArrowExpression(node, undefined, true);
      }
      readToken_mult_modulo(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 42 && next === 47 && this.state.hasFlowComment) {
          this.state.hasFlowComment = false;
          this.state.pos += 2;
          this.nextToken();
          return;
        }
        super.readToken_mult_modulo(code);
      }
      readToken_pipe_amp(code) {
        const next = this.input.charCodeAt(this.state.pos + 1);
        if (code === 124 && next === 125) {
          this.finishOp(9, 2);
          return;
        }
        super.readToken_pipe_amp(code);
      }
      parseTopLevel(file, program) {
        const fileNode = super.parseTopLevel(file, program);
        if (this.state.hasFlowComment) {
          this.raise(
            FlowErrors.UnterminatedFlowComment,
            this.state.curPosition()
          );
        }
        return fileNode;
      }
      skipBlockComment() {
        if (this.hasPlugin('flowComments') && this.skipFlowComment()) {
          if (this.state.hasFlowComment) {
            throw this.raise(FlowErrors.NestedFlowComment, this.state.startLoc);
          }
          this.hasFlowCommentCompletion();
          const commentSkip = this.skipFlowComment();
          if (commentSkip) {
            this.state.pos += commentSkip;
            this.state.hasFlowComment = true;
          }
          return;
        }
        return super.skipBlockComment(this.state.hasFlowComment ? '*-/' : '*/');
      }
      skipFlowComment() {
        const {pos: pos} = this.state;
        let shiftToFirstNonWhiteSpace = 2;
        while (
          [32, 9].includes(
            this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace)
          )
        ) {
          shiftToFirstNonWhiteSpace++;
        }
        const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
        const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
        if (ch2 === 58 && ch3 === 58) {
          return shiftToFirstNonWhiteSpace + 2;
        }
        if (
          this.input.slice(
            shiftToFirstNonWhiteSpace + pos,
            shiftToFirstNonWhiteSpace + pos + 12
          ) === 'flow-include'
        ) {
          return shiftToFirstNonWhiteSpace + 12;
        }
        if (ch2 === 58 && ch3 !== 58) {
          return shiftToFirstNonWhiteSpace;
        }
        return false;
      }
      hasFlowCommentCompletion() {
        const end = this.input.indexOf('*/', this.state.pos);
        if (end === -1) {
          throw this.raise(
            Errors.UnterminatedComment,
            this.state.curPosition()
          );
        }
      }
      flowEnumErrorBooleanMemberNotInitialized(
        loc,
        {enumName: enumName, memberName: memberName}
      ) {
        this.raise(FlowErrors.EnumBooleanMemberNotInitialized, loc, {
          memberName: memberName,
          enumName: enumName,
        });
      }
      flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
        return this.raise(
          !enumContext.explicitType
            ? FlowErrors.EnumInvalidMemberInitializerUnknownType
            : enumContext.explicitType === 'symbol'
              ? FlowErrors.EnumInvalidMemberInitializerSymbolType
              : FlowErrors.EnumInvalidMemberInitializerPrimaryType,
          loc,
          enumContext
        );
      }
      flowEnumErrorNumberMemberNotInitialized(loc, details) {
        this.raise(FlowErrors.EnumNumberMemberNotInitialized, loc, details);
      }
      flowEnumErrorStringMemberInconsistentlyInitialized(node, details) {
        this.raise(
          FlowErrors.EnumStringMemberInconsistentlyInitialized,
          node,
          details
        );
      }
      flowEnumMemberInit() {
        const startLoc = this.state.startLoc;
        const endOfInit = () => this.match(12) || this.match(8);
        switch (this.state.type) {
          case 134: {
            const literal = this.parseNumericLiteral(this.state.value);
            if (endOfInit()) {
              return {type: 'number', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          case 133: {
            const literal = this.parseStringLiteral(this.state.value);
            if (endOfInit()) {
              return {type: 'string', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          case 85:
          case 86: {
            const literal = this.parseBooleanLiteral(this.match(85));
            if (endOfInit()) {
              return {type: 'boolean', loc: literal.loc.start, value: literal};
            }
            return {type: 'invalid', loc: startLoc};
          }
          default:
            return {type: 'invalid', loc: startLoc};
        }
      }
      flowEnumMemberRaw() {
        const loc = this.state.startLoc;
        const id = this.parseIdentifier(true);
        const init = this.eat(29)
          ? this.flowEnumMemberInit()
          : {type: 'none', loc: loc};
        return {id: id, init: init};
      }
      flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
        const {explicitType: explicitType} = context;
        if (explicitType === null) {
          return;
        }
        if (explicitType !== expectedType) {
          this.flowEnumErrorInvalidMemberInitializer(loc, context);
        }
      }
      flowEnumMembers({enumName: enumName, explicitType: explicitType}) {
        const seenNames = new Set();
        const members = {
          booleanMembers: [],
          numberMembers: [],
          stringMembers: [],
          defaultedMembers: [],
        };
        let hasUnknownMembers = false;
        while (!this.match(8)) {
          if (this.eat(21)) {
            hasUnknownMembers = true;
            break;
          }
          const memberNode = this.startNode();
          const {id: id, init: init} = this.flowEnumMemberRaw();
          const memberName = id.name;
          if (memberName === '') {
            continue;
          }
          if (/^[a-z]/.test(memberName)) {
            this.raise(FlowErrors.EnumInvalidMemberName, id, {
              memberName: memberName,
              suggestion: memberName[0].toUpperCase() + memberName.slice(1),
              enumName: enumName,
            });
          }
          if (seenNames.has(memberName)) {
            this.raise(FlowErrors.EnumDuplicateMemberName, id, {
              memberName: memberName,
              enumName: enumName,
            });
          }
          seenNames.add(memberName);
          const context = {
            enumName: enumName,
            explicitType: explicitType,
            memberName: memberName,
          };
          memberNode.id = id;
          switch (init.type) {
            case 'boolean': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'boolean'
              );
              memberNode.init = init.value;
              members.booleanMembers.push(
                this.finishNode(memberNode, 'EnumBooleanMember')
              );
              break;
            }
            case 'number': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'number'
              );
              memberNode.init = init.value;
              members.numberMembers.push(
                this.finishNode(memberNode, 'EnumNumberMember')
              );
              break;
            }
            case 'string': {
              this.flowEnumCheckExplicitTypeMismatch(
                init.loc,
                context,
                'string'
              );
              memberNode.init = init.value;
              members.stringMembers.push(
                this.finishNode(memberNode, 'EnumStringMember')
              );
              break;
            }
            case 'invalid': {
              throw this.flowEnumErrorInvalidMemberInitializer(
                init.loc,
                context
              );
            }
            case 'none': {
              switch (explicitType) {
                case 'boolean':
                  this.flowEnumErrorBooleanMemberNotInitialized(
                    init.loc,
                    context
                  );
                  break;
                case 'number':
                  this.flowEnumErrorNumberMemberNotInitialized(
                    init.loc,
                    context
                  );
                  break;
                default:
                  members.defaultedMembers.push(
                    this.finishNode(memberNode, 'EnumDefaultedMember')
                  );
              }
            }
          }
          if (!this.match(8)) {
            this.expect(12);
          }
        }
        return {members: members, hasUnknownMembers: hasUnknownMembers};
      }
      flowEnumStringMembers(
        initializedMembers,
        defaultedMembers,
        {enumName: enumName}
      ) {
        if (initializedMembers.length === 0) {
          return defaultedMembers;
        } else if (defaultedMembers.length === 0) {
          return initializedMembers;
        } else if (defaultedMembers.length > initializedMembers.length) {
          for (const member of initializedMembers) {
            this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
              enumName: enumName,
            });
          }
          return defaultedMembers;
        } else {
          for (const member of defaultedMembers) {
            this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
              enumName: enumName,
            });
          }
          return initializedMembers;
        }
      }
      flowEnumParseExplicitType({enumName: enumName}) {
        if (!this.eatContextual(102)) return null;
        if (!tokenIsIdentifier(this.state.type)) {
          throw this.raise(
            FlowErrors.EnumInvalidExplicitTypeUnknownSupplied,
            this.state.startLoc,
            {enumName: enumName}
          );
        }
        const {value: value} = this.state;
        this.next();
        if (
          value !== 'boolean' &&
          value !== 'number' &&
          value !== 'string' &&
          value !== 'symbol'
        ) {
          this.raise(FlowErrors.EnumInvalidExplicitType, this.state.startLoc, {
            enumName: enumName,
            invalidEnumType: value,
          });
        }
        return value;
      }
      flowEnumBody(node, id) {
        const enumName = id.name;
        const nameLoc = id.loc.start;
        const explicitType = this.flowEnumParseExplicitType({
          enumName: enumName,
        });
        this.expect(5);
        const {members: members, hasUnknownMembers: hasUnknownMembers} =
          this.flowEnumMembers({
            enumName: enumName,
            explicitType: explicitType,
          });
        node.hasUnknownMembers = hasUnknownMembers;
        switch (explicitType) {
          case 'boolean':
            node.explicitType = true;
            node.members = members.booleanMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumBooleanBody');
          case 'number':
            node.explicitType = true;
            node.members = members.numberMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumNumberBody');
          case 'string':
            node.explicitType = true;
            node.members = this.flowEnumStringMembers(
              members.stringMembers,
              members.defaultedMembers,
              {enumName: enumName}
            );
            this.expect(8);
            return this.finishNode(node, 'EnumStringBody');
          case 'symbol':
            node.members = members.defaultedMembers;
            this.expect(8);
            return this.finishNode(node, 'EnumSymbolBody');
          default: {
            const empty = () => {
              node.members = [];
              this.expect(8);
              return this.finishNode(node, 'EnumStringBody');
            };
            node.explicitType = false;
            const boolsLen = members.booleanMembers.length;
            const numsLen = members.numberMembers.length;
            const strsLen = members.stringMembers.length;
            const defaultedLen = members.defaultedMembers.length;
            if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
              return empty();
            } else if (!boolsLen && !numsLen) {
              node.members = this.flowEnumStringMembers(
                members.stringMembers,
                members.defaultedMembers,
                {enumName: enumName}
              );
              this.expect(8);
              return this.finishNode(node, 'EnumStringBody');
            } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
              for (const member of members.defaultedMembers) {
                this.flowEnumErrorBooleanMemberNotInitialized(
                  member.loc.start,
                  {enumName: enumName, memberName: member.id.name}
                );
              }
              node.members = members.booleanMembers;
              this.expect(8);
              return this.finishNode(node, 'EnumBooleanBody');
            } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
              for (const member of members.defaultedMembers) {
                this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
                  enumName: enumName,
                  memberName: member.id.name,
                });
              }
              node.members = members.numberMembers;
              this.expect(8);
              return this.finishNode(node, 'EnumNumberBody');
            } else {
              this.raise(FlowErrors.EnumInconsistentMemberValues, nameLoc, {
                enumName: enumName,
              });
              return empty();
            }
          }
        }
      }
      flowParseEnumDeclaration(node) {
        const id = this.parseIdentifier();
        node.id = id;
        node.body = this.flowEnumBody(this.startNode(), id);
        return this.finishNode(node, 'EnumDeclaration');
      }
      isLookaheadToken_lt() {
        const next = this.nextTokenStart();
        if (this.input.charCodeAt(next) === 60) {
          const afterNext = this.input.charCodeAt(next + 1);
          return afterNext !== 60 && afterNext !== 61;
        }
        return false;
      }
      maybeUnwrapTypeCastExpression(node) {
        return node.type === 'TypeCastExpression' ? node.expression : node;
      }
    };
  const entities = {
    __proto__: null,
    quot: '"',
    amp: '&',
    apos: "'",
    lt: '<',
    gt: '>',
    nbsp: ' ',
    iexcl: '¡',
    cent: '¢',
    pound: '£',
    curren: '¤',
    yen: '¥',
    brvbar: '¦',
    sect: '§',
    uml: '¨',
    copy: '©',
    ordf: 'ª',
    laquo: '«',
    not: '¬',
    shy: '­',
    reg: '®',
    macr: '¯',
    deg: '°',
    plusmn: '±',
    sup2: '²',
    sup3: '³',
    acute: '´',
    micro: 'µ',
    para: '¶',
    middot: '·',
    cedil: '¸',
    sup1: '¹',
    ordm: 'º',
    raquo: '»',
    frac14: '¼',
    frac12: '½',
    frac34: '¾',
    iquest: '¿',
    Agrave: 'À',
    Aacute: 'Á',
    Acirc: 'Â',
    Atilde: 'Ã',
    Auml: 'Ä',
    Aring: 'Å',
    AElig: 'Æ',
    Ccedil: 'Ç',
    Egrave: 'È',
    Eacute: 'É',
    Ecirc: 'Ê',
    Euml: 'Ë',
    Igrave: 'Ì',
    Iacute: 'Í',
    Icirc: 'Î',
    Iuml: 'Ï',
    ETH: 'Ð',
    Ntilde: 'Ñ',
    Ograve: 'Ò',
    Oacute: 'Ó',
    Ocirc: 'Ô',
    Otilde: 'Õ',
    Ouml: 'Ö',
    times: '×',
    Oslash: 'Ø',
    Ugrave: 'Ù',
    Uacute: 'Ú',
    Ucirc: 'Û',
    Uuml: 'Ü',
    Yacute: 'Ý',
    THORN: 'Þ',
    szlig: 'ß',
    agrave: 'à',
    aacute: 'á',
    acirc: 'â',
    atilde: 'ã',
    auml: 'ä',
    aring: 'å',
    aelig: 'æ',
    ccedil: 'ç',
    egrave: 'è',
    eacute: 'é',
    ecirc: 'ê',
    euml: 'ë',
    igrave: 'ì',
    iacute: 'í',
    icirc: 'î',
    iuml: 'ï',
    eth: 'ð',
    ntilde: 'ñ',
    ograve: 'ò',
    oacute: 'ó',
    ocirc: 'ô',
    otilde: 'õ',
    ouml: 'ö',
    divide: '÷',
    oslash: 'ø',
    ugrave: 'ù',
    uacute: 'ú',
    ucirc: 'û',
    uuml: 'ü',
    yacute: 'ý',
    thorn: 'þ',
    yuml: 'ÿ',
    OElig: 'Œ',
    oelig: 'œ',
    Scaron: 'Š',
    scaron: 'š',
    Yuml: 'Ÿ',
    fnof: 'ƒ',
    circ: 'ˆ',
    tilde: '˜',
    Alpha: 'Α',
    Beta: 'Β',
    Gamma: 'Γ',
    Delta: 'Δ',
    Epsilon: 'Ε',
    Zeta: 'Ζ',
    Eta: 'Η',
    Theta: 'Θ',
    Iota: 'Ι',
    Kappa: 'Κ',
    Lambda: 'Λ',
    Mu: 'Μ',
    Nu: 'Ν',
    Xi: 'Ξ',
    Omicron: 'Ο',
    Pi: 'Π',
    Rho: 'Ρ',
    Sigma: 'Σ',
    Tau: 'Τ',
    Upsilon: 'Υ',
    Phi: 'Φ',
    Chi: 'Χ',
    Psi: 'Ψ',
    Omega: 'Ω',
    alpha: 'α',
    beta: 'β',
    gamma: 'γ',
    delta: 'δ',
    epsilon: 'ε',
    zeta: 'ζ',
    eta: 'η',
    theta: 'θ',
    iota: 'ι',
    kappa: 'κ',
    lambda: 'λ',
    mu: 'μ',
    nu: 'ν',
    xi: 'ξ',
    omicron: 'ο',
    pi: 'π',
    rho: 'ρ',
    sigmaf: 'ς',
    sigma: 'σ',
    tau: 'τ',
    upsilon: 'υ',
    phi: 'φ',
    chi: 'χ',
    psi: 'ψ',
    omega: 'ω',
    thetasym: 'ϑ',
    upsih: 'ϒ',
    piv: 'ϖ',
    ensp: ' ',
    emsp: ' ',
    thinsp: ' ',
    zwnj: '‌',
    zwj: '‍',
    lrm: '‎',
    rlm: '‏',
    ndash: '–',
    mdash: '—',
    lsquo: '‘',
    rsquo: '’',
    sbquo: '‚',
    ldquo: '“',
    rdquo: '”',
    bdquo: '„',
    dagger: '†',
    Dagger: '‡',
    bull: '•',
    hellip: '…',
    permil: '‰',
    prime: '′',
    Prime: '″',
    lsaquo: '‹',
    rsaquo: '›',
    oline: '‾',
    frasl: '⁄',
    euro: '€',
    image: 'ℑ',
    weierp: '℘',
    real: 'ℜ',
    trade: '™',
    alefsym: 'ℵ',
    larr: '←',
    uarr: '↑',
    rarr: '→',
    darr: '↓',
    harr: '↔',
    crarr: '↵',
    lArr: '⇐',
    uArr: '⇑',
    rArr: '⇒',
    dArr: '⇓',
    hArr: '⇔',
    forall: '∀',
    part: '∂',
    exist: '∃',
    empty: '∅',
    nabla: '∇',
    isin: '∈',
    notin: '∉',
    ni: '∋',
    prod: '∏',
    sum: '∑',
    minus: '−',
    lowast: '∗',
    radic: '√',
    prop: '∝',
    infin: '∞',
    ang: '∠',
    and: '∧',
    or: '∨',
    cap: '∩',
    cup: '∪',
    int: '∫',
    there4: '∴',
    sim: '∼',
    cong: '≅',
    asymp: '≈',
    ne: '≠',
    equiv: '≡',
    le: '≤',
    ge: '≥',
    sub: '⊂',
    sup: '⊃',
    nsub: '⊄',
    sube: '⊆',
    supe: '⊇',
    oplus: '⊕',
    otimes: '⊗',
    perp: '⊥',
    sdot: '⋅',
    lceil: '⌈',
    rceil: '⌉',
    lfloor: '⌊',
    rfloor: '⌋',
    lang: '〈',
    rang: '〉',
    loz: '◊',
    spades: '♠',
    clubs: '♣',
    hearts: '♥',
    diams: '♦',
  };
  const JsxErrors = ParseErrorEnum`jsx`({
    AttributeIsEmpty:
      'JSX attributes must only be assigned a non-empty expression.',
    MissingClosingTagElement: ({openingTagName: openingTagName}) =>
      `Expected corresponding JSX closing tag for <${openingTagName}>.`,
    MissingClosingTagFragment: 'Expected corresponding JSX closing tag for <>.',
    UnexpectedSequenceExpression:
      'Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?',
    UnexpectedToken: ({unexpected: unexpected, HTMLEntity: HTMLEntity}) =>
      `Unexpected token \`${unexpected}\`. Did you mean \`${HTMLEntity}\` or \`{'${unexpected}'}\`?`,
    UnsupportedJsxValue:
      'JSX value should be either an expression or a quoted JSX text.',
    UnterminatedJsxContent: 'Unterminated JSX contents.',
    UnwrappedAdjacentJSXElements:
      'Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?',
  });
  function isFragment(object) {
    return object
      ? object.type === 'JSXOpeningFragment' ||
          object.type === 'JSXClosingFragment'
      : false;
  }
  function getQualifiedJSXName(object) {
    if (object.type === 'JSXIdentifier') {
      return object.name;
    }
    if (object.type === 'JSXNamespacedName') {
      return object.namespace.name + ':' + object.name.name;
    }
    if (object.type === 'JSXMemberExpression') {
      return (
        getQualifiedJSXName(object.object) +
        '.' +
        getQualifiedJSXName(object.property)
      );
    }
    throw new Error('Node had unexpected type: ' + object.type);
  }
  var jsx = superClass =>
    class JSXParserMixin extends superClass {
      jsxReadToken() {
        let out = '';
        let chunkStart = this.state.pos;
        for (;;) {
          if (this.state.pos >= this.length) {
            throw this.raise(
              JsxErrors.UnterminatedJsxContent,
              this.state.startLoc
            );
          }
          const ch = this.input.charCodeAt(this.state.pos);
          switch (ch) {
            case 60:
            case 123:
              if (this.state.pos === this.state.start) {
                if (ch === 60 && this.state.canStartJSXElement) {
                  ++this.state.pos;
                  this.finishToken(142);
                } else {
                  super.getTokenFromCode(ch);
                }
                return;
              }
              out += this.input.slice(chunkStart, this.state.pos);
              this.finishToken(141, out);
              return;
            case 38:
              out += this.input.slice(chunkStart, this.state.pos);
              out += this.jsxReadEntity();
              chunkStart = this.state.pos;
              break;
            case 62:
            case 125:
            default:
              if (isNewLine(ch)) {
                out += this.input.slice(chunkStart, this.state.pos);
                out += this.jsxReadNewLine(true);
                chunkStart = this.state.pos;
              } else {
                ++this.state.pos;
              }
          }
        }
      }
      jsxReadNewLine(normalizeCRLF) {
        const ch = this.input.charCodeAt(this.state.pos);
        let out;
        ++this.state.pos;
        if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
          ++this.state.pos;
          out = normalizeCRLF ? '\n' : '\r\n';
        } else {
          out = String.fromCharCode(ch);
        }
        ++this.state.curLine;
        this.state.lineStart = this.state.pos;
        return out;
      }
      jsxReadString(quote) {
        let out = '';
        let chunkStart = ++this.state.pos;
        for (;;) {
          if (this.state.pos >= this.length) {
            throw this.raise(Errors.UnterminatedString, this.state.startLoc);
          }
          const ch = this.input.charCodeAt(this.state.pos);
          if (ch === quote) break;
          if (ch === 38) {
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadEntity();
            chunkStart = this.state.pos;
          } else if (isNewLine(ch)) {
            out += this.input.slice(chunkStart, this.state.pos);
            out += this.jsxReadNewLine(false);
            chunkStart = this.state.pos;
          } else {
            ++this.state.pos;
          }
        }
        out += this.input.slice(chunkStart, this.state.pos++);
        this.finishToken(133, out);
      }
      jsxReadEntity() {
        const startPos = ++this.state.pos;
        if (this.codePointAtPos(this.state.pos) === 35) {
          ++this.state.pos;
          let radix = 10;
          if (this.codePointAtPos(this.state.pos) === 120) {
            radix = 16;
            ++this.state.pos;
          }
          const codePoint = this.readInt(radix, undefined, false, 'bail');
          if (
            codePoint !== null &&
            this.codePointAtPos(this.state.pos) === 59
          ) {
            ++this.state.pos;
            return String.fromCodePoint(codePoint);
          }
        } else {
          let count = 0;
          let semi = false;
          while (
            count++ < 10 &&
            this.state.pos < this.length &&
            !(semi = this.codePointAtPos(this.state.pos) === 59)
          ) {
            ++this.state.pos;
          }
          if (semi) {
            const desc = this.input.slice(startPos, this.state.pos);
            const entity = entities[desc];
            ++this.state.pos;
            if (entity) {
              return entity;
            }
          }
        }
        this.state.pos = startPos;
        return '&';
      }
      jsxReadWord() {
        let ch;
        const start = this.state.pos;
        do {
          ch = this.input.charCodeAt(++this.state.pos);
        } while (isIdentifierChar(ch) || ch === 45);
        this.finishToken(140, this.input.slice(start, this.state.pos));
      }
      jsxParseIdentifier() {
        const node = this.startNode();
        if (this.match(140)) {
          node.name = this.state.value;
        } else if (tokenIsKeyword(this.state.type)) {
          node.name = tokenLabelName(this.state.type);
        } else {
          this.unexpected();
        }
        this.next();
        return this.finishNode(node, 'JSXIdentifier');
      }
      jsxParseNamespacedName() {
        const startLoc = this.state.startLoc;
        const name = this.jsxParseIdentifier();
        if (!this.eat(14)) return name;
        const node = this.startNodeAt(startLoc);
        node.namespace = name;
        node.name = this.jsxParseIdentifier();
        return this.finishNode(node, 'JSXNamespacedName');
      }
      jsxParseElementName() {
        const startLoc = this.state.startLoc;
        let node = this.jsxParseNamespacedName();
        if (node.type === 'JSXNamespacedName') {
          return node;
        }
        while (this.eat(16)) {
          const newNode = this.startNodeAt(startLoc);
          newNode.object = node;
          newNode.property = this.jsxParseIdentifier();
          node = this.finishNode(newNode, 'JSXMemberExpression');
        }
        return node;
      }
      jsxParseAttributeValue() {
        let node;
        switch (this.state.type) {
          case 5:
            node = this.startNode();
            this.setContext(types.brace);
            this.next();
            node = this.jsxParseExpressionContainer(node, types.j_oTag);
            if (node.expression.type === 'JSXEmptyExpression') {
              this.raise(JsxErrors.AttributeIsEmpty, node);
            }
            return node;
          case 142:
          case 133:
            return this.parseExprAtom();
          default:
            throw this.raise(
              JsxErrors.UnsupportedJsxValue,
              this.state.startLoc
            );
        }
      }
      jsxParseEmptyExpression() {
        const node = this.startNodeAt(this.state.lastTokEndLoc);
        return this.finishNodeAt(
          node,
          'JSXEmptyExpression',
          this.state.startLoc
        );
      }
      jsxParseSpreadChild(node) {
        this.next();
        node.expression = this.parseExpression();
        this.setContext(types.j_expr);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXSpreadChild');
      }
      jsxParseExpressionContainer(node, previousContext) {
        if (this.match(8)) {
          node.expression = this.jsxParseEmptyExpression();
        } else {
          const expression = this.parseExpression();
          node.expression = expression;
        }
        this.setContext(previousContext);
        this.state.canStartJSXElement = true;
        this.expect(8);
        return this.finishNode(node, 'JSXExpressionContainer');
      }
      jsxParseAttribute() {
        const node = this.startNode();
        if (this.match(5)) {
          this.setContext(types.brace);
          this.next();
          this.expect(21);
          node.argument = this.parseMaybeAssignAllowIn();
          this.setContext(types.j_oTag);
          this.state.canStartJSXElement = true;
          this.expect(8);
          return this.finishNode(node, 'JSXSpreadAttribute');
        }
        node.name = this.jsxParseNamespacedName();
        node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
        return this.finishNode(node, 'JSXAttribute');
      }
      jsxParseOpeningElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        if (this.eat(143)) {
          return this.finishNode(node, 'JSXOpeningFragment');
        }
        node.name = this.jsxParseElementName();
        return this.jsxParseOpeningElementAfterName(node);
      }
      jsxParseOpeningElementAfterName(node) {
        const attributes = [];
        while (!this.match(56) && !this.match(143)) {
          attributes.push(this.jsxParseAttribute());
        }
        node.attributes = attributes;
        node.selfClosing = this.eat(56);
        this.expect(143);
        return this.finishNode(node, 'JSXOpeningElement');
      }
      jsxParseClosingElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        if (this.eat(143)) {
          return this.finishNode(node, 'JSXClosingFragment');
        }
        node.name = this.jsxParseElementName();
        this.expect(143);
        return this.finishNode(node, 'JSXClosingElement');
      }
      jsxParseElementAt(startLoc) {
        const node = this.startNodeAt(startLoc);
        const children = [];
        const openingElement = this.jsxParseOpeningElementAt(startLoc);
        let closingElement = null;
        if (!openingElement.selfClosing) {
          contents: for (;;) {
            switch (this.state.type) {
              case 142:
                startLoc = this.state.startLoc;
                this.next();
                if (this.eat(56)) {
                  closingElement = this.jsxParseClosingElementAt(startLoc);
                  break contents;
                }
                children.push(this.jsxParseElementAt(startLoc));
                break;
              case 141:
                children.push(this.parseLiteral(this.state.value, 'JSXText'));
                break;
              case 5: {
                const node = this.startNode();
                this.setContext(types.brace);
                this.next();
                if (this.match(21)) {
                  children.push(this.jsxParseSpreadChild(node));
                } else {
                  children.push(
                    this.jsxParseExpressionContainer(node, types.j_expr)
                  );
                }
                break;
              }
              default:
                this.unexpected();
            }
          }
          if (
            isFragment(openingElement) &&
            !isFragment(closingElement) &&
            closingElement !== null
          ) {
            this.raise(JsxErrors.MissingClosingTagFragment, closingElement);
          } else if (
            !isFragment(openingElement) &&
            isFragment(closingElement)
          ) {
            this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
              openingTagName: getQualifiedJSXName(openingElement.name),
            });
          } else if (
            !isFragment(openingElement) &&
            !isFragment(closingElement)
          ) {
            if (
              getQualifiedJSXName(closingElement.name) !==
              getQualifiedJSXName(openingElement.name)
            ) {
              this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
                openingTagName: getQualifiedJSXName(openingElement.name),
              });
            }
          }
        }
        if (isFragment(openingElement)) {
          node.openingFragment = openingElement;
          node.closingFragment = closingElement;
        } else {
          node.openingElement = openingElement;
          node.closingElement = closingElement;
        }
        node.children = children;
        if (this.match(47)) {
          throw this.raise(
            JsxErrors.UnwrappedAdjacentJSXElements,
            this.state.startLoc
          );
        }
        return isFragment(openingElement)
          ? this.finishNode(node, 'JSXFragment')
          : this.finishNode(node, 'JSXElement');
      }
      jsxParseElement() {
        const startLoc = this.state.startLoc;
        this.next();
        return this.jsxParseElementAt(startLoc);
      }
      setContext(newContext) {
        const {context: context} = this.state;
        context[context.length - 1] = newContext;
      }
      parseExprAtom(refExpressionErrors) {
        if (this.match(142)) {
          return this.jsxParseElement();
        } else if (
          this.match(47) &&
          this.input.charCodeAt(this.state.pos) !== 33
        ) {
          this.replaceToken(142);
          return this.jsxParseElement();
        } else {
          return super.parseExprAtom(refExpressionErrors);
        }
      }
      skipSpace() {
        const curContext = this.curContext();
        if (!curContext.preserveSpace) super.skipSpace();
      }
      getTokenFromCode(code) {
        const context = this.curContext();
        if (context === types.j_expr) {
          this.jsxReadToken();
          return;
        }
        if (context === types.j_oTag || context === types.j_cTag) {
          if (isIdentifierStart(code)) {
            this.jsxReadWord();
            return;
          }
          if (code === 62) {
            ++this.state.pos;
            this.finishToken(143);
            return;
          }
          if ((code === 34 || code === 39) && context === types.j_oTag) {
            this.jsxReadString(code);
            return;
          }
        }
        if (
          code === 60 &&
          this.state.canStartJSXElement &&
          this.input.charCodeAt(this.state.pos + 1) !== 33
        ) {
          ++this.state.pos;
          this.finishToken(142);
          return;
        }
        super.getTokenFromCode(code);
      }
      updateContext(prevType) {
        const {context: context, type: type} = this.state;
        if (type === 56 && prevType === 142) {
          context.splice(-2, 2, types.j_cTag);
          this.state.canStartJSXElement = false;
        } else if (type === 142) {
          context.push(types.j_oTag);
        } else if (type === 143) {
          const out = context[context.length - 1];
          if (
            (out === types.j_oTag && prevType === 56) ||
            out === types.j_cTag
          ) {
            context.pop();
            this.state.canStartJSXElement =
              context[context.length - 1] === types.j_expr;
          } else {
            this.setContext(types.j_expr);
            this.state.canStartJSXElement = true;
          }
        } else {
          this.state.canStartJSXElement = tokenComesBeforeExpression(type);
        }
      }
    };
  class TypeScriptScope extends Scope {
    constructor(...args) {
      super(...args);
      this.tsNames = new Map();
    }
  }
  class TypeScriptScopeHandler extends ScopeHandler {
    constructor(...args) {
      super(...args);
      this.importsStack = [];
    }
    createScope(flags) {
      this.importsStack.push(new Set());
      return new TypeScriptScope(flags);
    }
    enter(flags) {
      if (flags === 256) {
        this.importsStack.push(new Set());
      }
      super.enter(flags);
    }
    exit() {
      const flags = super.exit();
      if (flags === 256) {
        this.importsStack.pop();
      }
      return flags;
    }
    hasImport(name, allowShadow) {
      const len = this.importsStack.length;
      if (this.importsStack[len - 1].has(name)) {
        return true;
      }
      if (!allowShadow && len > 1) {
        for (let i = 0; i < len - 1; i++) {
          if (this.importsStack[i].has(name)) return true;
        }
      }
      return false;
    }
    declareName(name, bindingType, loc) {
      if (bindingType & 4096) {
        if (this.hasImport(name, true)) {
          this.parser.raise(Errors.VarRedeclaration, loc, {
            identifierName: name,
          });
        }
        this.importsStack[this.importsStack.length - 1].add(name);
        return;
      }
      const scope = this.currentScope();
      let type = scope.tsNames.get(name) || 0;
      if (bindingType & 1024) {
        this.maybeExportDefined(scope, name);
        scope.tsNames.set(name, type | 16);
        return;
      }
      super.declareName(name, bindingType, loc);
      if (bindingType & 2) {
        if (!(bindingType & 1)) {
          this.checkRedeclarationInScope(scope, name, bindingType, loc);
          this.maybeExportDefined(scope, name);
        }
        type = type | 1;
      }
      if (bindingType & 256) {
        type = type | 2;
      }
      if (bindingType & 512) {
        type = type | 4;
      }
      if (bindingType & 128) {
        type = type | 8;
      }
      if (type) scope.tsNames.set(name, type);
    }
    isRedeclaredInScope(scope, name, bindingType) {
      const type = scope.tsNames.get(name);
      if ((type & 2) > 0) {
        if (bindingType & 256) {
          const isConst = !!(bindingType & 512);
          const wasConst = (type & 4) > 0;
          return isConst !== wasConst;
        }
        return true;
      }
      if (bindingType & 128 && (type & 8) > 0) {
        if (scope.names.get(name) & 2) {
          return !!(bindingType & 1);
        } else {
          return false;
        }
      }
      if (bindingType & 2 && (type & 1) > 0) {
        return true;
      }
      return super.isRedeclaredInScope(scope, name, bindingType);
    }
    checkLocalExport(id) {
      const {name: name} = id;
      if (this.hasImport(name)) return;
      const len = this.scopeStack.length;
      for (let i = len - 1; i >= 0; i--) {
        const scope = this.scopeStack[i];
        const type = scope.tsNames.get(name);
        if ((type & 1) > 0 || (type & 16) > 0) {
          return;
        }
      }
      super.checkLocalExport(id);
    }
  }
  const unwrapParenthesizedExpression = node =>
    node.type === 'ParenthesizedExpression'
      ? unwrapParenthesizedExpression(node.expression)
      : node;
  class LValParser extends NodeUtils {
    toAssignable(node, isLHS = false) {
      var _node$extra, _node$extra3;
      let parenthesized = undefined;
      if (
        node.type === 'ParenthesizedExpression' ||
        ((_node$extra = node.extra) != null && _node$extra.parenthesized)
      ) {
        parenthesized = unwrapParenthesizedExpression(node);
        if (isLHS) {
          if (parenthesized.type === 'Identifier') {
            this.expressionScope.recordArrowParameterBindingError(
              Errors.InvalidParenthesizedAssignment,
              node
            );
          } else if (
            parenthesized.type !== 'MemberExpression' &&
            !this.isOptionalMemberExpression(parenthesized)
          ) {
            this.raise(Errors.InvalidParenthesizedAssignment, node);
          }
        } else {
          this.raise(Errors.InvalidParenthesizedAssignment, node);
        }
      }
      switch (node.type) {
        case 'Identifier':
        case 'ObjectPattern':
        case 'ArrayPattern':
        case 'AssignmentPattern':
        case 'RestElement':
          break;
        case 'ObjectExpression':
          node.type = 'ObjectPattern';
          for (
            let i = 0, length = node.properties.length, last = length - 1;
            i < length;
            i++
          ) {
            var _node$extra2;
            const prop = node.properties[i];
            const isLast = i === last;
            this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
            if (
              isLast &&
              prop.type === 'RestElement' &&
              (_node$extra2 = node.extra) != null &&
              _node$extra2.trailingCommaLoc
            ) {
              this.raise(Errors.RestTrailingComma, node.extra.trailingCommaLoc);
            }
          }
          break;
        case 'ObjectProperty': {
          const {key: key, value: value} = node;
          if (this.isPrivateName(key)) {
            this.classScope.usePrivateName(
              this.getPrivateNameSV(key),
              key.loc.start
            );
          }
          this.toAssignable(value, isLHS);
          break;
        }
        case 'SpreadElement': {
          throw new Error(
            'Internal @babel/parser error (this is a bug, please report it).' +
              " SpreadElement should be converted by .toAssignable's caller."
          );
        }
        case 'ArrayExpression':
          node.type = 'ArrayPattern';
          this.toAssignableList(
            node.elements,
            (_node$extra3 = node.extra) == null
              ? void 0
              : _node$extra3.trailingCommaLoc,
            isLHS
          );
          break;
        case 'AssignmentExpression':
          if (node.operator !== '=') {
            this.raise(Errors.MissingEqInAssignment, node.left.loc.end);
          }
          node.type = 'AssignmentPattern';
          delete node.operator;
          this.toAssignable(node.left, isLHS);
          break;
        case 'ParenthesizedExpression':
          this.toAssignable(parenthesized, isLHS);
          break;
      }
    }
    toAssignableObjectExpressionProp(prop, isLast, isLHS) {
      if (prop.type === 'ObjectMethod') {
        this.raise(
          prop.kind === 'get' || prop.kind === 'set'
            ? Errors.PatternHasAccessor
            : Errors.PatternHasMethod,
          prop.key
        );
      } else if (prop.type === 'SpreadElement') {
        prop.type = 'RestElement';
        const arg = prop.argument;
        this.checkToRestConversion(arg, false);
        this.toAssignable(arg, isLHS);
        if (!isLast) {
          this.raise(Errors.RestTrailingComma, prop);
        }
      } else {
        this.toAssignable(prop, isLHS);
      }
    }
    toAssignableList(exprList, trailingCommaLoc, isLHS) {
      const end = exprList.length - 1;
      for (let i = 0; i <= end; i++) {
        const elt = exprList[i];
        if (!elt) continue;
        if (elt.type === 'SpreadElement') {
          elt.type = 'RestElement';
          const arg = elt.argument;
          this.checkToRestConversion(arg, true);
          this.toAssignable(arg, isLHS);
        } else {
          this.toAssignable(elt, isLHS);
        }
        if (elt.type === 'RestElement') {
          if (i < end) {
            this.raise(Errors.RestTrailingComma, elt);
          } else if (trailingCommaLoc) {
            this.raise(Errors.RestTrailingComma, trailingCommaLoc);
          }
        }
      }
    }
    isAssignable(node, isBinding) {
      switch (node.type) {
        case 'Identifier':
        case 'ObjectPattern':
        case 'ArrayPattern':
        case 'AssignmentPattern':
        case 'RestElement':
          return true;
        case 'ObjectExpression': {
          const last = node.properties.length - 1;
          return node.properties.every(
            (prop, i) =>
              prop.type !== 'ObjectMethod' &&
              (i === last || prop.type !== 'SpreadElement') &&
              this.isAssignable(prop)
          );
        }
        case 'ObjectProperty':
          return this.isAssignable(node.value);
        case 'SpreadElement':
          return this.isAssignable(node.argument);
        case 'ArrayExpression':
          return node.elements.every(
            element => element === null || this.isAssignable(element)
          );
        case 'AssignmentExpression':
          return node.operator === '=';
        case 'ParenthesizedExpression':
          return this.isAssignable(node.expression);
        case 'MemberExpression':
        case 'OptionalMemberExpression':
          return !isBinding;
        default:
          return false;
      }
    }
    toReferencedList(exprList, isParenthesizedExpr) {
      return exprList;
    }
    toReferencedListDeep(exprList, isParenthesizedExpr) {
      this.toReferencedList(exprList, isParenthesizedExpr);
      for (const expr of exprList) {
        if ((expr == null ? void 0 : expr.type) === 'ArrayExpression') {
          this.toReferencedListDeep(expr.elements);
        }
      }
    }
    parseSpread(refExpressionErrors) {
      const node = this.startNode();
      this.next();
      node.argument = this.parseMaybeAssignAllowIn(
        refExpressionErrors,
        undefined
      );
      return this.finishNode(node, 'SpreadElement');
    }
    parseRestBinding() {
      const node = this.startNode();
      this.next();
      node.argument = this.parseBindingAtom();
      return this.finishNode(node, 'RestElement');
    }
    parseBindingAtom() {
      switch (this.state.type) {
        case 0: {
          const node = this.startNode();
          this.next();
          node.elements = this.parseBindingList(3, 93, 1);
          return this.finishNode(node, 'ArrayPattern');
        }
        case 5:
          return this.parseObjectLike(8, true);
      }
      return this.parseIdentifier();
    }
    parseBindingList(close, closeCharCode, flags) {
      const allowEmpty = flags & 1;
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
        }
        if (allowEmpty && this.match(12)) {
          elts.push(null);
        } else if (this.eat(close)) {
          break;
        } else if (this.match(21)) {
          elts.push(
            this.parseAssignableListItemTypes(this.parseRestBinding(), flags)
          );
          if (!this.checkCommaAfterRest(closeCharCode)) {
            this.expect(close);
            break;
          }
        } else {
          const decorators = [];
          if (this.match(26) && this.hasPlugin('decorators')) {
            this.raise(
              Errors.UnsupportedParameterDecorator,
              this.state.startLoc
            );
          }
          while (this.match(26)) {
            decorators.push(this.parseDecorator());
          }
          elts.push(this.parseAssignableListItem(flags, decorators));
        }
      }
      return elts;
    }
    parseBindingRestProperty(prop) {
      this.next();
      prop.argument = this.parseIdentifier();
      this.checkCommaAfterRest(125);
      return this.finishNode(prop, 'RestElement');
    }
    parseBindingProperty() {
      const {type: type, startLoc: startLoc} = this.state;
      if (type === 21) {
        return this.parseBindingRestProperty(this.startNode());
      }
      const prop = this.startNode();
      if (type === 138) {
        this.expectPlugin('destructuringPrivate', startLoc);
        this.classScope.usePrivateName(this.state.value, startLoc);
        prop.key = this.parsePrivateName();
      } else {
        this.parsePropertyName(prop);
      }
      prop.method = false;
      return this.parseObjPropValue(prop, startLoc, false, false, true, false);
    }
    parseAssignableListItem(flags, decorators) {
      const left = this.parseMaybeDefault();
      this.parseAssignableListItemTypes(left, flags);
      const elt = this.parseMaybeDefault(left.loc.start, left);
      if (decorators.length) {
        left.decorators = decorators;
      }
      return elt;
    }
    parseAssignableListItemTypes(param, flags) {
      return param;
    }
    parseMaybeDefault(startLoc, left) {
      var _startLoc, _left;
      (_startLoc = startLoc) != null
        ? _startLoc
        : (startLoc = this.state.startLoc);
      left = (_left = left) != null ? _left : this.parseBindingAtom();
      if (!this.eat(29)) return left;
      const node = this.startNodeAt(startLoc);
      node.left = left;
      node.right = this.parseMaybeAssignAllowIn();
      return this.finishNode(node, 'AssignmentPattern');
    }
    isValidLVal(type, isUnparenthesizedInAssign, binding) {
      switch (type) {
        case 'AssignmentPattern':
          return 'left';
        case 'RestElement':
          return 'argument';
        case 'ObjectProperty':
          return 'value';
        case 'ParenthesizedExpression':
          return 'expression';
        case 'ArrayPattern':
          return 'elements';
        case 'ObjectPattern':
          return 'properties';
      }
      return false;
    }
    isOptionalMemberExpression(expression) {
      return expression.type === 'OptionalMemberExpression';
    }
    checkLVal(
      expression,
      ancestor,
      binding = 64,
      checkClashes = false,
      strictModeChanged = false,
      hasParenthesizedAncestor = false
    ) {
      var _expression$extra;
      const type = expression.type;
      if (this.isObjectMethod(expression)) return;
      const isOptionalMemberExpression =
        this.isOptionalMemberExpression(expression);
      if (isOptionalMemberExpression || type === 'MemberExpression') {
        if (isOptionalMemberExpression) {
          this.expectPlugin('optionalChainingAssign', expression.loc.start);
          if (ancestor.type !== 'AssignmentExpression') {
            this.raise(Errors.InvalidLhsOptionalChaining, expression, {
              ancestor: ancestor,
            });
          }
        }
        if (binding !== 64) {
          this.raise(Errors.InvalidPropertyBindingPattern, expression);
        }
        return;
      }
      if (type === 'Identifier') {
        this.checkIdentifier(expression, binding, strictModeChanged);
        const {name: name} = expression;
        if (checkClashes) {
          if (checkClashes.has(name)) {
            this.raise(Errors.ParamDupe, expression);
          } else {
            checkClashes.add(name);
          }
        }
        return;
      }
      const validity = this.isValidLVal(
        type,
        !(
          hasParenthesizedAncestor ||
          ((_expression$extra = expression.extra) != null &&
            _expression$extra.parenthesized)
        ) && ancestor.type === 'AssignmentExpression',
        binding
      );
      if (validity === true) return;
      if (validity === false) {
        const ParseErrorClass =
          binding === 64 ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
        this.raise(ParseErrorClass, expression, {ancestor: ancestor});
        return;
      }
      let key, isParenthesizedExpression;
      if (typeof validity === 'string') {
        key = validity;
        isParenthesizedExpression = type === 'ParenthesizedExpression';
      } else {
        [key, isParenthesizedExpression] = validity;
      }
      const nextAncestor =
        type === 'ArrayPattern' || type === 'ObjectPattern'
          ? {type: type}
          : ancestor;
      const val = expression[key];
      if (Array.isArray(val)) {
        for (const child of val) {
          if (child) {
            this.checkLVal(
              child,
              nextAncestor,
              binding,
              checkClashes,
              strictModeChanged,
              isParenthesizedExpression
            );
          }
        }
      } else if (val) {
        this.checkLVal(
          val,
          nextAncestor,
          binding,
          checkClashes,
          strictModeChanged,
          isParenthesizedExpression
        );
      }
    }
    checkIdentifier(at, bindingType, strictModeChanged = false) {
      if (
        this.state.strict &&
        (strictModeChanged
          ? isStrictBindReservedWord(at.name, this.inModule)
          : isStrictBindOnlyReservedWord(at.name))
      ) {
        if (bindingType === 64) {
          this.raise(Errors.StrictEvalArguments, at, {referenceName: at.name});
        } else {
          this.raise(Errors.StrictEvalArgumentsBinding, at, {
            bindingName: at.name,
          });
        }
      }
      if (bindingType & 8192 && at.name === 'let') {
        this.raise(Errors.LetInLexicalBinding, at);
      }
      if (!(bindingType & 64)) {
        this.declareNameFromIdentifier(at, bindingType);
      }
    }
    declareNameFromIdentifier(identifier, binding) {
      this.scope.declareName(identifier.name, binding, identifier.loc.start);
    }
    checkToRestConversion(node, allowPattern) {
      switch (node.type) {
        case 'ParenthesizedExpression':
          this.checkToRestConversion(node.expression, allowPattern);
          break;
        case 'Identifier':
        case 'MemberExpression':
          break;
        case 'ArrayExpression':
        case 'ObjectExpression':
          if (allowPattern) break;
        default:
          this.raise(Errors.InvalidRestAssignmentPattern, node);
      }
    }
    checkCommaAfterRest(close) {
      if (!this.match(12)) {
        return false;
      }
      this.raise(
        this.lookaheadCharCode() === close
          ? Errors.RestTrailingComma
          : Errors.ElementAfterRest,
        this.state.startLoc
      );
      return true;
    }
  }
  function nonNull(x) {
    if (x == null) {
      throw new Error(`Unexpected ${x} value.`);
    }
    return x;
  }
  function assert(x) {
    if (!x) {
      throw new Error('Assert fail');
    }
  }
  const TSErrors = ParseErrorEnum`typescript`({
    AbstractMethodHasImplementation: ({methodName: methodName}) =>
      `Method '${methodName}' cannot have an implementation because it is marked abstract.`,
    AbstractPropertyHasInitializer: ({propertyName: propertyName}) =>
      `Property '${propertyName}' cannot have an initializer because it is marked abstract.`,
    AccessorCannotBeOptional:
      "An 'accessor' property cannot be declared optional.",
    AccessorCannotDeclareThisParameter:
      "'get' and 'set' accessors cannot declare 'this' parameters.",
    AccessorCannotHaveTypeParameters:
      'An accessor cannot have type parameters.',
    ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
    ClassMethodHasReadonly:
      "Class methods cannot have the 'readonly' modifier.",
    ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference:
      "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
    ConstructorHasTypeParameters:
      'Type parameters cannot appear on a constructor declaration.',
    DeclareAccessor: ({kind: kind}) =>
      `'declare' is not allowed in ${kind}ters.`,
    DeclareClassFieldHasInitializer:
      'Initializers are not allowed in ambient contexts.',
    DeclareFunctionHasImplementation:
      'An implementation cannot be declared in ambient contexts.',
    DuplicateAccessibilityModifier: ({modifier: modifier}) =>
      `Accessibility modifier already seen.`,
    DuplicateModifier: ({modifier: modifier}) =>
      `Duplicate modifier: '${modifier}'.`,
    EmptyHeritageClauseType: ({token: token}) =>
      `'${token}' list cannot be empty.`,
    EmptyTypeArguments: 'Type argument list cannot be empty.',
    EmptyTypeParameters: 'Type parameter list cannot be empty.',
    ExpectedAmbientAfterExportDeclare:
      "'export declare' must be followed by an ambient declaration.",
    ImportAliasHasImportType: "An import alias can not use 'import type'.",
    ImportReflectionHasImportType:
      'An `import module` declaration can not use `type` modifier',
    IncompatibleModifiers: ({modifiers: modifiers}) =>
      `'${modifiers[0]}' modifier cannot be used with '${modifiers[1]}' modifier.`,
    IndexSignatureHasAbstract:
      "Index signatures cannot have the 'abstract' modifier.",
    IndexSignatureHasAccessibility: ({modifier: modifier}) =>
      `Index signatures cannot have an accessibility modifier ('${modifier}').`,
    IndexSignatureHasDeclare:
      "Index signatures cannot have the 'declare' modifier.",
    IndexSignatureHasOverride:
      "'override' modifier cannot appear on an index signature.",
    IndexSignatureHasStatic:
      "Index signatures cannot have the 'static' modifier.",
    InitializerNotAllowedInAmbientContext:
      'Initializers are not allowed in ambient contexts.',
    InvalidModifierOnTypeMember: ({modifier: modifier}) =>
      `'${modifier}' modifier cannot appear on a type member.`,
    InvalidModifierOnTypeParameter: ({modifier: modifier}) =>
      `'${modifier}' modifier cannot appear on a type parameter.`,
    InvalidModifierOnTypeParameterPositions: ({modifier: modifier}) =>
      `'${modifier}' modifier can only appear on a type parameter of a class, interface or type alias.`,
    InvalidModifiersOrder: ({orderedModifiers: orderedModifiers}) =>
      `'${orderedModifiers[0]}' modifier must precede '${orderedModifiers[1]}' modifier.`,
    InvalidPropertyAccessAfterInstantiationExpression:
      'Invalid property access after an instantiation expression. ' +
      'You can either wrap the instantiation expression in parentheses, or delete the type arguments.',
    InvalidTupleMemberLabel:
      'Tuple members must be labeled with a simple identifier.',
    MissingInterfaceName:
      "'interface' declarations must be followed by an identifier.",
    NonAbstractClassHasAbstractMethod:
      'Abstract methods can only appear within an abstract class.',
    NonClassMethodPropertyHasAbstractModifer:
      "'abstract' modifier can only appear on a class, method, or property declaration.",
    OptionalTypeBeforeRequired:
      'A required element cannot follow an optional element.',
    OverrideNotInSubClass:
      "This member cannot have an 'override' modifier because its containing class does not extend another class.",
    PatternIsOptional:
      'A binding pattern parameter cannot be optional in an implementation signature.',
    PrivateElementHasAbstract:
      "Private elements cannot have the 'abstract' modifier.",
    PrivateElementHasAccessibility: ({modifier: modifier}) =>
      `Private elements cannot have an accessibility modifier ('${modifier}').`,
    ReadonlyForMethodSignature:
      "'readonly' modifier can only appear on a property declaration or index signature.",
    ReservedArrowTypeParam:
      'This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.',
    ReservedTypeAssertion:
      'This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.',
    SetAccessorCannotHaveOptionalParameter:
      "A 'set' accessor cannot have an optional parameter.",
    SetAccessorCannotHaveRestParameter:
      "A 'set' accessor cannot have rest parameter.",
    SetAccessorCannotHaveReturnType:
      "A 'set' accessor cannot have a return type annotation.",
    SingleTypeParameterWithoutTrailingComma: ({
      typeParameterName: typeParameterName,
    }) =>
      `Single type parameter ${typeParameterName} should have a trailing comma. Example usage: <${typeParameterName},>.`,
    StaticBlockCannotHaveModifier:
      'Static class blocks cannot have any modifier.',
    TupleOptionalAfterType:
      'A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).',
    TypeAnnotationAfterAssign:
      'Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.',
    TypeImportCannotSpecifyDefaultAndNamed:
      'A type-only import can specify a default import or named bindings, but not both.',
    TypeModifierIsUsedInTypeExports:
      "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
    TypeModifierIsUsedInTypeImports:
      "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
    UnexpectedParameterModifier:
      'A parameter property is only allowed in a constructor implementation.',
    UnexpectedReadonly:
      "'readonly' type modifier is only permitted on array and tuple literal types.",
    UnexpectedTypeAnnotation: 'Did not expect a type annotation here.',
    UnexpectedTypeCastInParameter:
      'Unexpected type cast in parameter position.',
    UnsupportedImportTypeArgument:
      'Argument in a type import must be a string literal.',
    UnsupportedParameterPropertyKind:
      'A parameter property may not be declared using a binding pattern.',
    UnsupportedSignatureParameterKind: ({type: type}) =>
      `Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ${type}.`,
  });
  function keywordTypeFromName(value) {
    switch (value) {
      case 'any':
        return 'TSAnyKeyword';
      case 'boolean':
        return 'TSBooleanKeyword';
      case 'bigint':
        return 'TSBigIntKeyword';
      case 'never':
        return 'TSNeverKeyword';
      case 'number':
        return 'TSNumberKeyword';
      case 'object':
        return 'TSObjectKeyword';
      case 'string':
        return 'TSStringKeyword';
      case 'symbol':
        return 'TSSymbolKeyword';
      case 'undefined':
        return 'TSUndefinedKeyword';
      case 'unknown':
        return 'TSUnknownKeyword';
      default:
        return undefined;
    }
  }
  function tsIsAccessModifier(modifier) {
    return (
      modifier === 'private' ||
      modifier === 'public' ||
      modifier === 'protected'
    );
  }
  function tsIsVarianceAnnotations(modifier) {
    return modifier === 'in' || modifier === 'out';
  }
  var typescript = superClass =>
    class TypeScriptParserMixin extends superClass {
      constructor(...args) {
        super(...args);
        this.tsParseInOutModifiers = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['in', 'out'],
          disallowedModifiers: [
            'const',
            'public',
            'private',
            'protected',
            'readonly',
            'declare',
            'abstract',
            'override',
          ],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
        });
        this.tsParseConstModifier = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['const'],
          disallowedModifiers: ['in', 'out'],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
        });
        this.tsParseInOutConstModifiers = this.tsParseModifiers.bind(this, {
          allowedModifiers: ['in', 'out', 'const'],
          disallowedModifiers: [
            'public',
            'private',
            'protected',
            'readonly',
            'declare',
            'abstract',
            'override',
          ],
          errorTemplate: TSErrors.InvalidModifierOnTypeParameter,
        });
      }
      getScopeHandler() {
        return TypeScriptScopeHandler;
      }
      tsIsIdentifier() {
        return tokenIsIdentifier(this.state.type);
      }
      tsTokenCanFollowModifier() {
        return (
          this.match(0) ||
          this.match(5) ||
          this.match(55) ||
          this.match(21) ||
          this.match(138) ||
          this.isLiteralPropertyName()
        );
      }
      tsNextTokenOnSameLineAndCanFollowModifier() {
        this.next();
        if (this.hasPrecedingLineBreak()) {
          return false;
        }
        return this.tsTokenCanFollowModifier();
      }
      tsNextTokenCanFollowModifier() {
        if (this.match(106)) {
          this.next();
          return this.tsTokenCanFollowModifier();
        }
        return this.tsNextTokenOnSameLineAndCanFollowModifier();
      }
      tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
        if (
          !tokenIsIdentifier(this.state.type) &&
          this.state.type !== 58 &&
          this.state.type !== 75
        ) {
          return undefined;
        }
        const modifier = this.state.value;
        if (allowedModifiers.includes(modifier)) {
          if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
            return undefined;
          }
          if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
            return modifier;
          }
        }
        return undefined;
      }
      tsParseModifiers(
        {
          allowedModifiers: allowedModifiers,
          disallowedModifiers: disallowedModifiers,
          stopOnStartOfClassStaticBlock: stopOnStartOfClassStaticBlock,
          errorTemplate: errorTemplate = TSErrors.InvalidModifierOnTypeMember,
        },
        modified
      ) {
        const enforceOrder = (loc, modifier, before, after) => {
          if (modifier === before && modified[after]) {
            this.raise(TSErrors.InvalidModifiersOrder, loc, {
              orderedModifiers: [before, after],
            });
          }
        };
        const incompatible = (loc, modifier, mod1, mod2) => {
          if (
            (modified[mod1] && modifier === mod2) ||
            (modified[mod2] && modifier === mod1)
          ) {
            this.raise(TSErrors.IncompatibleModifiers, loc, {
              modifiers: [mod1, mod2],
            });
          }
        };
        for (;;) {
          const {startLoc: startLoc} = this.state;
          const modifier = this.tsParseModifier(
            allowedModifiers.concat(
              disallowedModifiers != null ? disallowedModifiers : []
            ),
            stopOnStartOfClassStaticBlock
          );
          if (!modifier) break;
          if (tsIsAccessModifier(modifier)) {
            if (modified.accessibility) {
              this.raise(TSErrors.DuplicateAccessibilityModifier, startLoc, {
                modifier: modifier,
              });
            } else {
              enforceOrder(startLoc, modifier, modifier, 'override');
              enforceOrder(startLoc, modifier, modifier, 'static');
              enforceOrder(startLoc, modifier, modifier, 'readonly');
              modified.accessibility = modifier;
            }
          } else if (tsIsVarianceAnnotations(modifier)) {
            if (modified[modifier]) {
              this.raise(TSErrors.DuplicateModifier, startLoc, {
                modifier: modifier,
              });
            }
            modified[modifier] = true;
            enforceOrder(startLoc, modifier, 'in', 'out');
          } else {
            if (hasOwnProperty.call(modified, modifier)) {
              this.raise(TSErrors.DuplicateModifier, startLoc, {
                modifier: modifier,
              });
            } else {
              enforceOrder(startLoc, modifier, 'static', 'readonly');
              enforceOrder(startLoc, modifier, 'static', 'override');
              enforceOrder(startLoc, modifier, 'override', 'readonly');
              enforceOrder(startLoc, modifier, 'abstract', 'override');
              incompatible(startLoc, modifier, 'declare', 'override');
              incompatible(startLoc, modifier, 'static', 'abstract');
            }
            modified[modifier] = true;
          }
          if (
            disallowedModifiers != null &&
            disallowedModifiers.includes(modifier)
          ) {
            this.raise(errorTemplate, startLoc, {modifier: modifier});
          }
        }
      }
      tsIsListTerminator(kind) {
        switch (kind) {
          case 'EnumMembers':
          case 'TypeMembers':
            return this.match(8);
          case 'HeritageClauseElement':
            return this.match(5);
          case 'TupleElementTypes':
            return this.match(3);
          case 'TypeParametersOrArguments':
            return this.match(48);
        }
      }
      tsParseList(kind, parseElement) {
        const result = [];
        while (!this.tsIsListTerminator(kind)) {
          result.push(parseElement());
        }
        return result;
      }
      tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
        return nonNull(
          this.tsParseDelimitedListWorker(
            kind,
            parseElement,
            true,
            refTrailingCommaPos
          )
        );
      }
      tsParseDelimitedListWorker(
        kind,
        parseElement,
        expectSuccess,
        refTrailingCommaPos
      ) {
        const result = [];
        let trailingCommaPos = -1;
        for (;;) {
          if (this.tsIsListTerminator(kind)) {
            break;
          }
          trailingCommaPos = -1;
          const element = parseElement();
          if (element == null) {
            return undefined;
          }
          result.push(element);
          if (this.eat(12)) {
            trailingCommaPos = this.state.lastTokStartLoc.index;
            continue;
          }
          if (this.tsIsListTerminator(kind)) {
            break;
          }
          if (expectSuccess) {
            this.expect(12);
          }
          return undefined;
        }
        if (refTrailingCommaPos) {
          refTrailingCommaPos.value = trailingCommaPos;
        }
        return result;
      }
      tsParseBracketedList(
        kind,
        parseElement,
        bracket,
        skipFirstToken,
        refTrailingCommaPos
      ) {
        if (!skipFirstToken) {
          if (bracket) {
            this.expect(0);
          } else {
            this.expect(47);
          }
        }
        const result = this.tsParseDelimitedList(
          kind,
          parseElement,
          refTrailingCommaPos
        );
        if (bracket) {
          this.expect(3);
        } else {
          this.expect(48);
        }
        return result;
      }
      tsParseImportType() {
        const node = this.startNode();
        this.expect(83);
        this.expect(10);
        if (!this.match(133)) {
          this.raise(
            TSErrors.UnsupportedImportTypeArgument,
            this.state.startLoc
          );
        }
        node.argument = super.parseExprAtom();
        if (
          this.hasPlugin('importAttributes') ||
          this.hasPlugin('importAssertions')
        ) {
          node.options = null;
        }
        if (this.eat(12)) {
          this.expectImportAttributesPlugin();
          if (!this.match(11)) {
            node.options = super.parseMaybeAssignAllowIn();
            this.eat(12);
          }
        }
        this.expect(11);
        if (this.eat(16)) {
          node.qualifier = this.tsParseEntityName();
        }
        if (this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSImportType');
      }
      tsParseEntityName(allowReservedWords = true) {
        let entity = this.parseIdentifier(allowReservedWords);
        while (this.eat(16)) {
          const node = this.startNodeAtNode(entity);
          node.left = entity;
          node.right = this.parseIdentifier(allowReservedWords);
          entity = this.finishNode(node, 'TSQualifiedName');
        }
        return entity;
      }
      tsParseTypeReference() {
        const node = this.startNode();
        node.typeName = this.tsParseEntityName();
        if (!this.hasPrecedingLineBreak() && this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSTypeReference');
      }
      tsParseThisTypePredicate(lhs) {
        this.next();
        const node = this.startNodeAtNode(lhs);
        node.parameterName = lhs;
        node.typeAnnotation = this.tsParseTypeAnnotation(false);
        node.asserts = false;
        return this.finishNode(node, 'TSTypePredicate');
      }
      tsParseThisTypeNode() {
        const node = this.startNode();
        this.next();
        return this.finishNode(node, 'TSThisType');
      }
      tsParseTypeQuery() {
        const node = this.startNode();
        this.expect(87);
        if (this.match(83)) {
          node.exprName = this.tsParseImportType();
        } else {
          node.exprName = this.tsParseEntityName();
        }
        if (!this.hasPrecedingLineBreak() && this.match(47)) {
          node.typeParameters = this.tsParseTypeArguments();
        }
        return this.finishNode(node, 'TSTypeQuery');
      }
      tsParseTypeParameter(parseModifiers) {
        const node = this.startNode();
        parseModifiers(node);
        node.name = this.tsParseTypeParameterName();
        node.constraint = this.tsEatThenParseType(81);
        node.default = this.tsEatThenParseType(29);
        return this.finishNode(node, 'TSTypeParameter');
      }
      tsTryParseTypeParameters(parseModifiers) {
        if (this.match(47)) {
          return this.tsParseTypeParameters(parseModifiers);
        }
      }
      tsParseTypeParameters(parseModifiers) {
        const node = this.startNode();
        if (this.match(47) || this.match(142)) {
          this.next();
        } else {
          this.unexpected();
        }
        const refTrailingCommaPos = {value: -1};
        node.params = this.tsParseBracketedList(
          'TypeParametersOrArguments',
          this.tsParseTypeParameter.bind(this, parseModifiers),
          false,
          true,
          refTrailingCommaPos
        );
        if (node.params.length === 0) {
          this.raise(TSErrors.EmptyTypeParameters, node);
        }
        if (refTrailingCommaPos.value !== -1) {
          this.addExtra(node, 'trailingComma', refTrailingCommaPos.value);
        }
        return this.finishNode(node, 'TSTypeParameterDeclaration');
      }
      tsFillSignature(returnToken, signature) {
        const returnTokenRequired = returnToken === 19;
        const paramsKey = 'parameters';
        const returnTypeKey = 'typeAnnotation';
        signature.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        this.expect(10);
        signature[paramsKey] = this.tsParseBindingListForSignature();
        if (returnTokenRequired) {
          signature[returnTypeKey] =
            this.tsParseTypeOrTypePredicateAnnotation(returnToken);
        } else if (this.match(returnToken)) {
          signature[returnTypeKey] =
            this.tsParseTypeOrTypePredicateAnnotation(returnToken);
        }
      }
      tsParseBindingListForSignature() {
        const list = super.parseBindingList(11, 41, 2);
        for (const pattern of list) {
          const {type: type} = pattern;
          if (type === 'AssignmentPattern' || type === 'TSParameterProperty') {
            this.raise(TSErrors.UnsupportedSignatureParameterKind, pattern, {
              type: type,
            });
          }
        }
        return list;
      }
      tsParseTypeMemberSemicolon() {
        if (!this.eat(12) && !this.isLineTerminator()) {
          this.expect(13);
        }
      }
      tsParseSignatureMember(kind, node) {
        this.tsFillSignature(14, node);
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(node, kind);
      }
      tsIsUnambiguouslyIndexSignature() {
        this.next();
        if (tokenIsIdentifier(this.state.type)) {
          this.next();
          return this.match(14);
        }
        return false;
      }
      tsTryParseIndexSignature(node) {
        if (
          !(
            this.match(0) &&
            this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this))
          )
        ) {
          return;
        }
        this.expect(0);
        const id = this.parseIdentifier();
        id.typeAnnotation = this.tsParseTypeAnnotation();
        this.resetEndLocation(id);
        this.expect(3);
        node.parameters = [id];
        const type = this.tsTryParseTypeAnnotation();
        if (type) node.typeAnnotation = type;
        this.tsParseTypeMemberSemicolon();
        return this.finishNode(node, 'TSIndexSignature');
      }
      tsParsePropertyOrMethodSignature(node, readonly) {
        if (this.eat(17)) node.optional = true;
        const nodeAny = node;
        if (this.match(10) || this.match(47)) {
          if (readonly) {
            this.raise(TSErrors.ReadonlyForMethodSignature, node);
          }
          const method = nodeAny;
          if (method.kind && this.match(47)) {
            this.raise(
              TSErrors.AccessorCannotHaveTypeParameters,
              this.state.curPosition()
            );
          }
          this.tsFillSignature(14, method);
          this.tsParseTypeMemberSemicolon();
          const paramsKey = 'parameters';
          const returnTypeKey = 'typeAnnotation';
          if (method.kind === 'get') {
            if (method[paramsKey].length > 0) {
              this.raise(Errors.BadGetterArity, this.state.curPosition());
              if (this.isThisParam(method[paramsKey][0])) {
                this.raise(
                  TSErrors.AccessorCannotDeclareThisParameter,
                  this.state.curPosition()
                );
              }
            }
          } else if (method.kind === 'set') {
            if (method[paramsKey].length !== 1) {
              this.raise(Errors.BadSetterArity, this.state.curPosition());
            } else {
              const firstParameter = method[paramsKey][0];
              if (this.isThisParam(firstParameter)) {
                this.raise(
                  TSErrors.AccessorCannotDeclareThisParameter,
                  this.state.curPosition()
                );
              }
              if (
                firstParameter.type === 'Identifier' &&
                firstParameter.optional
              ) {
                this.raise(
                  TSErrors.SetAccessorCannotHaveOptionalParameter,
                  this.state.curPosition()
                );
              }
              if (firstParameter.type === 'RestElement') {
                this.raise(
                  TSErrors.SetAccessorCannotHaveRestParameter,
                  this.state.curPosition()
                );
              }
            }
            if (method[returnTypeKey]) {
              this.raise(
                TSErrors.SetAccessorCannotHaveReturnType,
                method[returnTypeKey]
              );
            }
          } else {
            method.kind = 'method';
          }
          return this.finishNode(method, 'TSMethodSignature');
        } else {
          const property = nodeAny;
          if (readonly) property.readonly = true;
          const type = this.tsTryParseTypeAnnotation();
          if (type) property.typeAnnotation = type;
          this.tsParseTypeMemberSemicolon();
          return this.finishNode(property, 'TSPropertySignature');
        }
      }
      tsParseTypeMember() {
        const node = this.startNode();
        if (this.match(10) || this.match(47)) {
          return this.tsParseSignatureMember(
            'TSCallSignatureDeclaration',
            node
          );
        }
        if (this.match(77)) {
          const id = this.startNode();
          this.next();
          if (this.match(10) || this.match(47)) {
            return this.tsParseSignatureMember(
              'TSConstructSignatureDeclaration',
              node
            );
          } else {
            node.key = this.createIdentifier(id, 'new');
            return this.tsParsePropertyOrMethodSignature(node, false);
          }
        }
        this.tsParseModifiers(
          {
            allowedModifiers: ['readonly'],
            disallowedModifiers: [
              'declare',
              'abstract',
              'private',
              'protected',
              'public',
              'static',
              'override',
            ],
          },
          node
        );
        const idx = this.tsTryParseIndexSignature(node);
        if (idx) {
          return idx;
        }
        super.parsePropertyName(node);
        if (
          !node.computed &&
          node.key.type === 'Identifier' &&
          (node.key.name === 'get' || node.key.name === 'set') &&
          this.tsTokenCanFollowModifier()
        ) {
          node.kind = node.key.name;
          super.parsePropertyName(node);
        }
        return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
      }
      tsParseTypeLiteral() {
        const node = this.startNode();
        node.members = this.tsParseObjectTypeMembers();
        return this.finishNode(node, 'TSTypeLiteral');
      }
      tsParseObjectTypeMembers() {
        this.expect(5);
        const members = this.tsParseList(
          'TypeMembers',
          this.tsParseTypeMember.bind(this)
        );
        this.expect(8);
        return members;
      }
      tsIsStartOfMappedType() {
        this.next();
        if (this.eat(53)) {
          return this.isContextual(122);
        }
        if (this.isContextual(122)) {
          this.next();
        }
        if (!this.match(0)) {
          return false;
        }
        this.next();
        if (!this.tsIsIdentifier()) {
          return false;
        }
        this.next();
        return this.match(58);
      }
      tsParseMappedType() {
        const node = this.startNode();
        this.expect(5);
        if (this.match(53)) {
          node.readonly = this.state.value;
          this.next();
          this.expectContextual(122);
        } else if (this.eatContextual(122)) {
          node.readonly = true;
        }
        this.expect(0);
        {
          const typeParameter = this.startNode();
          typeParameter.name = this.tsParseTypeParameterName();
          typeParameter.constraint = this.tsExpectThenParseType(58);
          node.typeParameter = this.finishNode(
            typeParameter,
            'TSTypeParameter'
          );
        }
        node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
        this.expect(3);
        if (this.match(53)) {
          node.optional = this.state.value;
          this.next();
          this.expect(17);
        } else if (this.eat(17)) {
          node.optional = true;
        }
        node.typeAnnotation = this.tsTryParseType();
        this.semicolon();
        this.expect(8);
        return this.finishNode(node, 'TSMappedType');
      }
      tsParseTupleType() {
        const node = this.startNode();
        node.elementTypes = this.tsParseBracketedList(
          'TupleElementTypes',
          this.tsParseTupleElementType.bind(this),
          true,
          false
        );
        let seenOptionalElement = false;
        node.elementTypes.forEach(elementNode => {
          const {type: type} = elementNode;
          if (
            seenOptionalElement &&
            type !== 'TSRestType' &&
            type !== 'TSOptionalType' &&
            !(type === 'TSNamedTupleMember' && elementNode.optional)
          ) {
            this.raise(TSErrors.OptionalTypeBeforeRequired, elementNode);
          }
          seenOptionalElement ||
            (seenOptionalElement =
              (type === 'TSNamedTupleMember' && elementNode.optional) ||
              type === 'TSOptionalType');
        });
        return this.finishNode(node, 'TSTupleType');
      }
      tsParseTupleElementType() {
        const {startLoc: startLoc} = this.state;
        const rest = this.eat(21);
        let labeled;
        let label;
        let optional;
        let type;
        const isWord = tokenIsKeywordOrIdentifier(this.state.type);
        const chAfterWord = isWord ? this.lookaheadCharCode() : null;
        if (chAfterWord === 58) {
          labeled = true;
          optional = false;
          label = this.parseIdentifier(true);
          this.expect(14);
          type = this.tsParseType();
        } else if (chAfterWord === 63) {
          optional = true;
          const startLoc = this.state.startLoc;
          const wordName = this.state.value;
          const typeOrLabel = this.tsParseNonArrayType();
          if (this.lookaheadCharCode() === 58) {
            labeled = true;
            label = this.createIdentifier(this.startNodeAt(startLoc), wordName);
            this.expect(17);
            this.expect(14);
            type = this.tsParseType();
          } else {
            labeled = false;
            type = typeOrLabel;
            this.expect(17);
          }
        } else {
          type = this.tsParseType();
          optional = this.eat(17);
          labeled = this.eat(14);
        }
        if (labeled) {
          let labeledNode;
          if (label) {
            labeledNode = this.startNodeAtNode(label);
            labeledNode.optional = optional;
            labeledNode.label = label;
            labeledNode.elementType = type;
            if (this.eat(17)) {
              labeledNode.optional = true;
              this.raise(
                TSErrors.TupleOptionalAfterType,
                this.state.lastTokStartLoc
              );
            }
          } else {
            labeledNode = this.startNodeAtNode(type);
            labeledNode.optional = optional;
            this.raise(TSErrors.InvalidTupleMemberLabel, type);
            labeledNode.label = type;
            labeledNode.elementType = this.tsParseType();
          }
          type = this.finishNode(labeledNode, 'TSNamedTupleMember');
        } else if (optional) {
          const optionalTypeNode = this.startNodeAtNode(type);
          optionalTypeNode.typeAnnotation = type;
          type = this.finishNode(optionalTypeNode, 'TSOptionalType');
        }
        if (rest) {
          const restNode = this.startNodeAt(startLoc);
          restNode.typeAnnotation = type;
          type = this.finishNode(restNode, 'TSRestType');
        }
        return type;
      }
      tsParseParenthesizedType() {
        const node = this.startNode();
        this.expect(10);
        node.typeAnnotation = this.tsParseType();
        this.expect(11);
        return this.finishNode(node, 'TSParenthesizedType');
      }
      tsParseFunctionOrConstructorType(type, abstract) {
        const node = this.startNode();
        if (type === 'TSConstructorType') {
          node.abstract = !!abstract;
          if (abstract) this.next();
          this.next();
        }
        this.tsInAllowConditionalTypesContext(() =>
          this.tsFillSignature(19, node)
        );
        return this.finishNode(node, type);
      }
      tsParseLiteralTypeNode() {
        const node = this.startNode();
        switch (this.state.type) {
          case 134:
          case 135:
          case 133:
          case 85:
          case 86:
            node.literal = super.parseExprAtom();
            break;
          default:
            this.unexpected();
        }
        return this.finishNode(node, 'TSLiteralType');
      }
      tsParseTemplateLiteralType() {
        const node = this.startNode();
        node.literal = super.parseTemplate(false);
        return this.finishNode(node, 'TSLiteralType');
      }
      parseTemplateSubstitution() {
        if (this.state.inType) return this.tsParseType();
        return super.parseTemplateSubstitution();
      }
      tsParseThisTypeOrThisTypePredicate() {
        const thisKeyword = this.tsParseThisTypeNode();
        if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
          return this.tsParseThisTypePredicate(thisKeyword);
        } else {
          return thisKeyword;
        }
      }
      tsParseNonArrayType() {
        switch (this.state.type) {
          case 133:
          case 134:
          case 135:
          case 85:
          case 86:
            return this.tsParseLiteralTypeNode();
          case 53:
            if (this.state.value === '-') {
              const node = this.startNode();
              const nextToken = this.lookahead();
              if (nextToken.type !== 134 && nextToken.type !== 135) {
                this.unexpected();
              }
              node.literal = this.parseMaybeUnary();
              return this.finishNode(node, 'TSLiteralType');
            }
            break;
          case 78:
            return this.tsParseThisTypeOrThisTypePredicate();
          case 87:
            return this.tsParseTypeQuery();
          case 83:
            return this.tsParseImportType();
          case 5:
            return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this))
              ? this.tsParseMappedType()
              : this.tsParseTypeLiteral();
          case 0:
            return this.tsParseTupleType();
          case 10:
            return this.tsParseParenthesizedType();
          case 25:
          case 24:
            return this.tsParseTemplateLiteralType();
          default: {
            const {type: type} = this.state;
            if (tokenIsIdentifier(type) || type === 88 || type === 84) {
              const nodeType =
                type === 88
                  ? 'TSVoidKeyword'
                  : type === 84
                    ? 'TSNullKeyword'
                    : keywordTypeFromName(this.state.value);
              if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
                const node = this.startNode();
                this.next();
                return this.finishNode(node, nodeType);
              }
              return this.tsParseTypeReference();
            }
          }
        }
        this.unexpected();
      }
      tsParseArrayTypeOrHigher() {
        let type = this.tsParseNonArrayType();
        while (!this.hasPrecedingLineBreak() && this.eat(0)) {
          if (this.match(3)) {
            const node = this.startNodeAtNode(type);
            node.elementType = type;
            this.expect(3);
            type = this.finishNode(node, 'TSArrayType');
          } else {
            const node = this.startNodeAtNode(type);
            node.objectType = type;
            node.indexType = this.tsParseType();
            this.expect(3);
            type = this.finishNode(node, 'TSIndexedAccessType');
          }
        }
        return type;
      }
      tsParseTypeOperator() {
        const node = this.startNode();
        const operator = this.state.value;
        this.next();
        node.operator = operator;
        node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
        if (operator === 'readonly') {
          this.tsCheckTypeAnnotationForReadOnly(node);
        }
        return this.finishNode(node, 'TSTypeOperator');
      }
      tsCheckTypeAnnotationForReadOnly(node) {
        switch (node.typeAnnotation.type) {
          case 'TSTupleType':
          case 'TSArrayType':
            return;
          default:
            this.raise(TSErrors.UnexpectedReadonly, node);
        }
      }
      tsParseInferType() {
        const node = this.startNode();
        this.expectContextual(115);
        const typeParameter = this.startNode();
        typeParameter.name = this.tsParseTypeParameterName();
        typeParameter.constraint = this.tsTryParse(() =>
          this.tsParseConstraintForInferType()
        );
        node.typeParameter = this.finishNode(typeParameter, 'TSTypeParameter');
        return this.finishNode(node, 'TSInferType');
      }
      tsParseConstraintForInferType() {
        if (this.eat(81)) {
          const constraint = this.tsInDisallowConditionalTypesContext(() =>
            this.tsParseType()
          );
          if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
            return constraint;
          }
        }
      }
      tsParseTypeOperatorOrHigher() {
        const isTypeOperator =
          tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
        return isTypeOperator
          ? this.tsParseTypeOperator()
          : this.isContextual(115)
            ? this.tsParseInferType()
            : this.tsInAllowConditionalTypesContext(() =>
                this.tsParseArrayTypeOrHigher()
              );
      }
      tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
        const node = this.startNode();
        const hasLeadingOperator = this.eat(operator);
        const types = [];
        do {
          types.push(parseConstituentType());
        } while (this.eat(operator));
        if (types.length === 1 && !hasLeadingOperator) {
          return types[0];
        }
        node.types = types;
        return this.finishNode(node, kind);
      }
      tsParseIntersectionTypeOrHigher() {
        return this.tsParseUnionOrIntersectionType(
          'TSIntersectionType',
          this.tsParseTypeOperatorOrHigher.bind(this),
          45
        );
      }
      tsParseUnionTypeOrHigher() {
        return this.tsParseUnionOrIntersectionType(
          'TSUnionType',
          this.tsParseIntersectionTypeOrHigher.bind(this),
          43
        );
      }
      tsIsStartOfFunctionType() {
        if (this.match(47)) {
          return true;
        }
        return (
          this.match(10) &&
          this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this))
        );
      }
      tsSkipParameterStart() {
        if (tokenIsIdentifier(this.state.type) || this.match(78)) {
          this.next();
          return true;
        }
        if (this.match(5)) {
          const {errors: errors} = this.state;
          const previousErrorCount = errors.length;
          try {
            this.parseObjectLike(8, true);
            return errors.length === previousErrorCount;
          } catch (_unused) {
            return false;
          }
        }
        if (this.match(0)) {
          this.next();
          const {errors: errors} = this.state;
          const previousErrorCount = errors.length;
          try {
            super.parseBindingList(3, 93, 1);
            return errors.length === previousErrorCount;
          } catch (_unused2) {
            return false;
          }
        }
        return false;
      }
      tsIsUnambiguouslyStartOfFunctionType() {
        this.next();
        if (this.match(11) || this.match(21)) {
          return true;
        }
        if (this.tsSkipParameterStart()) {
          if (
            this.match(14) ||
            this.match(12) ||
            this.match(17) ||
            this.match(29)
          ) {
            return true;
          }
          if (this.match(11)) {
            this.next();
            if (this.match(19)) {
              return true;
            }
          }
        }
        return false;
      }
      tsParseTypeOrTypePredicateAnnotation(returnToken) {
        return this.tsInType(() => {
          const t = this.startNode();
          this.expect(returnToken);
          const node = this.startNode();
          const asserts = !!this.tsTryParse(
            this.tsParseTypePredicateAsserts.bind(this)
          );
          if (asserts && this.match(78)) {
            let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();
            if (thisTypePredicate.type === 'TSThisType') {
              node.parameterName = thisTypePredicate;
              node.asserts = true;
              node.typeAnnotation = null;
              thisTypePredicate = this.finishNode(node, 'TSTypePredicate');
            } else {
              this.resetStartLocationFromNode(thisTypePredicate, node);
              thisTypePredicate.asserts = true;
            }
            t.typeAnnotation = thisTypePredicate;
            return this.finishNode(t, 'TSTypeAnnotation');
          }
          const typePredicateVariable =
            this.tsIsIdentifier() &&
            this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
          if (!typePredicateVariable) {
            if (!asserts) {
              return this.tsParseTypeAnnotation(false, t);
            }
            node.parameterName = this.parseIdentifier();
            node.asserts = asserts;
            node.typeAnnotation = null;
            t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
            return this.finishNode(t, 'TSTypeAnnotation');
          }
          const type = this.tsParseTypeAnnotation(false);
          node.parameterName = typePredicateVariable;
          node.typeAnnotation = type;
          node.asserts = asserts;
          t.typeAnnotation = this.finishNode(node, 'TSTypePredicate');
          return this.finishNode(t, 'TSTypeAnnotation');
        });
      }
      tsTryParseTypeOrTypePredicateAnnotation() {
        if (this.match(14)) {
          return this.tsParseTypeOrTypePredicateAnnotation(14);
        }
      }
      tsTryParseTypeAnnotation() {
        if (this.match(14)) {
          return this.tsParseTypeAnnotation();
        }
      }
      tsTryParseType() {
        return this.tsEatThenParseType(14);
      }
      tsParseTypePredicatePrefix() {
        const id = this.parseIdentifier();
        if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
          this.next();
          return id;
        }
      }
      tsParseTypePredicateAsserts() {
        if (this.state.type !== 109) {
          return false;
        }
        const containsEsc = this.state.containsEsc;
        this.next();
        if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
          return false;
        }
        if (containsEsc) {
          this.raise(
            Errors.InvalidEscapedReservedWord,
            this.state.lastTokStartLoc,
            {reservedWord: 'asserts'}
          );
        }
        return true;
      }
      tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
        this.tsInType(() => {
          if (eatColon) this.expect(14);
          t.typeAnnotation = this.tsParseType();
        });
        return this.finishNode(t, 'TSTypeAnnotation');
      }
      tsParseType() {
        assert(this.state.inType);
        const type = this.tsParseNonConditionalType();
        if (
          this.state.inDisallowConditionalTypesContext ||
          this.hasPrecedingLineBreak() ||
          !this.eat(81)
        ) {
          return type;
        }
        const node = this.startNodeAtNode(type);
        node.checkType = type;
        node.extendsType = this.tsInDisallowConditionalTypesContext(() =>
          this.tsParseNonConditionalType()
        );
        this.expect(17);
        node.trueType = this.tsInAllowConditionalTypesContext(() =>
          this.tsParseType()
        );
        this.expect(14);
        node.falseType = this.tsInAllowConditionalTypesContext(() =>
          this.tsParseType()
        );
        return this.finishNode(node, 'TSConditionalType');
      }
      isAbstractConstructorSignature() {
        return this.isContextual(124) && this.lookahead().type === 77;
      }
      tsParseNonConditionalType() {
        if (this.tsIsStartOfFunctionType()) {
          return this.tsParseFunctionOrConstructorType('TSFunctionType');
        }
        if (this.match(77)) {
          return this.tsParseFunctionOrConstructorType('TSConstructorType');
        } else if (this.isAbstractConstructorSignature()) {
          return this.tsParseFunctionOrConstructorType(
            'TSConstructorType',
            true
          );
        }
        return this.tsParseUnionTypeOrHigher();
      }
      tsParseTypeAssertion() {
        if (this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')) {
          this.raise(TSErrors.ReservedTypeAssertion, this.state.startLoc);
        }
        const node = this.startNode();
        node.typeAnnotation = this.tsInType(() => {
          this.next();
          return this.match(75)
            ? this.tsParseTypeReference()
            : this.tsParseType();
        });
        this.expect(48);
        node.expression = this.parseMaybeUnary();
        return this.finishNode(node, 'TSTypeAssertion');
      }
      tsParseHeritageClause(token) {
        const originalStartLoc = this.state.startLoc;
        const delimitedList = this.tsParseDelimitedList(
          'HeritageClauseElement',
          () => {
            const node = this.startNode();
            node.expression = this.tsParseEntityName();
            if (this.match(47)) {
              node.typeParameters = this.tsParseTypeArguments();
            }
            return this.finishNode(node, 'TSExpressionWithTypeArguments');
          }
        );
        if (!delimitedList.length) {
          this.raise(TSErrors.EmptyHeritageClauseType, originalStartLoc, {
            token: token,
          });
        }
        return delimitedList;
      }
      tsParseInterfaceDeclaration(node, properties = {}) {
        if (this.hasFollowingLineBreak()) return null;
        this.expectContextual(129);
        if (properties.declare) node.declare = true;
        if (tokenIsIdentifier(this.state.type)) {
          node.id = this.parseIdentifier();
          this.checkIdentifier(node.id, 130);
        } else {
          node.id = null;
          this.raise(TSErrors.MissingInterfaceName, this.state.startLoc);
        }
        node.typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutConstModifiers
        );
        if (this.eat(81)) {
          node.extends = this.tsParseHeritageClause('extends');
        }
        const body = this.startNode();
        body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
        node.body = this.finishNode(body, 'TSInterfaceBody');
        return this.finishNode(node, 'TSInterfaceDeclaration');
      }
      tsParseTypeAliasDeclaration(node) {
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, 2);
        node.typeAnnotation = this.tsInType(() => {
          node.typeParameters = this.tsTryParseTypeParameters(
            this.tsParseInOutModifiers
          );
          this.expect(29);
          if (this.isContextual(114) && this.lookahead().type !== 16) {
            const node = this.startNode();
            this.next();
            return this.finishNode(node, 'TSIntrinsicKeyword');
          }
          return this.tsParseType();
        });
        this.semicolon();
        return this.finishNode(node, 'TSTypeAliasDeclaration');
      }
      tsInNoContext(cb) {
        const oldContext = this.state.context;
        this.state.context = [oldContext[0]];
        try {
          return cb();
        } finally {
          this.state.context = oldContext;
        }
      }
      tsInType(cb) {
        const oldInType = this.state.inType;
        this.state.inType = true;
        try {
          return cb();
        } finally {
          this.state.inType = oldInType;
        }
      }
      tsInDisallowConditionalTypesContext(cb) {
        const oldInDisallowConditionalTypesContext =
          this.state.inDisallowConditionalTypesContext;
        this.state.inDisallowConditionalTypesContext = true;
        try {
          return cb();
        } finally {
          this.state.inDisallowConditionalTypesContext =
            oldInDisallowConditionalTypesContext;
        }
      }
      tsInAllowConditionalTypesContext(cb) {
        const oldInDisallowConditionalTypesContext =
          this.state.inDisallowConditionalTypesContext;
        this.state.inDisallowConditionalTypesContext = false;
        try {
          return cb();
        } finally {
          this.state.inDisallowConditionalTypesContext =
            oldInDisallowConditionalTypesContext;
        }
      }
      tsEatThenParseType(token) {
        if (this.match(token)) {
          return this.tsNextThenParseType();
        }
      }
      tsExpectThenParseType(token) {
        return this.tsInType(() => {
          this.expect(token);
          return this.tsParseType();
        });
      }
      tsNextThenParseType() {
        return this.tsInType(() => {
          this.next();
          return this.tsParseType();
        });
      }
      tsParseEnumMember() {
        const node = this.startNode();
        node.id = this.match(133)
          ? super.parseStringLiteral(this.state.value)
          : this.parseIdentifier(true);
        if (this.eat(29)) {
          node.initializer = super.parseMaybeAssignAllowIn();
        }
        return this.finishNode(node, 'TSEnumMember');
      }
      tsParseEnumDeclaration(node, properties = {}) {
        if (properties.const) node.const = true;
        if (properties.declare) node.declare = true;
        this.expectContextual(126);
        node.id = this.parseIdentifier();
        this.checkIdentifier(node.id, node.const ? 8971 : 8459);
        this.expect(5);
        node.members = this.tsParseDelimitedList(
          'EnumMembers',
          this.tsParseEnumMember.bind(this)
        );
        this.expect(8);
        return this.finishNode(node, 'TSEnumDeclaration');
      }
      tsParseModuleBlock() {
        const node = this.startNode();
        this.scope.enter(0);
        this.expect(5);
        super.parseBlockOrModuleBlockBody((node.body = []), undefined, true, 8);
        this.scope.exit();
        return this.finishNode(node, 'TSModuleBlock');
      }
      tsParseModuleOrNamespaceDeclaration(node, nested = false) {
        node.id = this.parseIdentifier();
        if (!nested) {
          this.checkIdentifier(node.id, 1024);
        }
        if (this.eat(16)) {
          const inner = this.startNode();
          this.tsParseModuleOrNamespaceDeclaration(inner, true);
          node.body = inner;
        } else {
          this.scope.enter(256);
          this.prodParam.enter(0);
          node.body = this.tsParseModuleBlock();
          this.prodParam.exit();
          this.scope.exit();
        }
        return this.finishNode(node, 'TSModuleDeclaration');
      }
      tsParseAmbientExternalModuleDeclaration(node) {
        if (this.isContextual(112)) {
          node.global = true;
          node.id = this.parseIdentifier();
        } else if (this.match(133)) {
          node.id = super.parseStringLiteral(this.state.value);
        } else {
          this.unexpected();
        }
        if (this.match(5)) {
          this.scope.enter(256);
          this.prodParam.enter(0);
          node.body = this.tsParseModuleBlock();
          this.prodParam.exit();
          this.scope.exit();
        } else {
          this.semicolon();
        }
        return this.finishNode(node, 'TSModuleDeclaration');
      }
      tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, isExport) {
        node.isExport = isExport || false;
        node.id = maybeDefaultIdentifier || this.parseIdentifier();
        this.checkIdentifier(node.id, 4096);
        this.expect(29);
        const moduleReference = this.tsParseModuleReference();
        if (
          node.importKind === 'type' &&
          moduleReference.type !== 'TSExternalModuleReference'
        ) {
          this.raise(TSErrors.ImportAliasHasImportType, moduleReference);
        }
        node.moduleReference = moduleReference;
        this.semicolon();
        return this.finishNode(node, 'TSImportEqualsDeclaration');
      }
      tsIsExternalModuleReference() {
        return this.isContextual(119) && this.lookaheadCharCode() === 40;
      }
      tsParseModuleReference() {
        return this.tsIsExternalModuleReference()
          ? this.tsParseExternalModuleReference()
          : this.tsParseEntityName(false);
      }
      tsParseExternalModuleReference() {
        const node = this.startNode();
        this.expectContextual(119);
        this.expect(10);
        if (!this.match(133)) {
          this.unexpected();
        }
        node.expression = super.parseExprAtom();
        this.expect(11);
        this.sawUnambiguousESM = true;
        return this.finishNode(node, 'TSExternalModuleReference');
      }
      tsLookAhead(f) {
        const state = this.state.clone();
        const res = f();
        this.state = state;
        return res;
      }
      tsTryParseAndCatch(f) {
        const result = this.tryParse(abort => f() || abort());
        if (result.aborted || !result.node) return;
        if (result.error) this.state = result.failState;
        return result.node;
      }
      tsTryParse(f) {
        const state = this.state.clone();
        const result = f();
        if (result !== undefined && result !== false) {
          return result;
        }
        this.state = state;
      }
      tsTryParseDeclare(nany) {
        if (this.isLineTerminator()) {
          return;
        }
        let startType = this.state.type;
        let kind;
        if (this.isContextual(100)) {
          startType = 74;
          kind = 'let';
        }
        return this.tsInAmbientContext(() => {
          switch (startType) {
            case 68:
              nany.declare = true;
              return super.parseFunctionStatement(nany, false, false);
            case 80:
              nany.declare = true;
              return this.parseClass(nany, true, false);
            case 126:
              return this.tsParseEnumDeclaration(nany, {declare: true});
            case 112:
              return this.tsParseAmbientExternalModuleDeclaration(nany);
            case 75:
            case 74:
              if (!this.match(75) || !this.isLookaheadContextual('enum')) {
                nany.declare = true;
                return this.parseVarStatement(
                  nany,
                  kind || this.state.value,
                  true
                );
              }
              this.expect(75);
              return this.tsParseEnumDeclaration(nany, {
                const: true,
                declare: true,
              });
            case 129: {
              const result = this.tsParseInterfaceDeclaration(nany, {
                declare: true,
              });
              if (result) return result;
            }
            default:
              if (tokenIsIdentifier(startType)) {
                return this.tsParseDeclaration(
                  nany,
                  this.state.value,
                  true,
                  null
                );
              }
          }
        });
      }
      tsTryParseExportDeclaration() {
        return this.tsParseDeclaration(
          this.startNode(),
          this.state.value,
          true,
          null
        );
      }
      tsParseExpressionStatement(node, expr, decorators) {
        switch (expr.name) {
          case 'declare': {
            const declaration = this.tsTryParseDeclare(node);
            if (declaration) {
              declaration.declare = true;
            }
            return declaration;
          }
          case 'global':
            if (this.match(5)) {
              this.scope.enter(256);
              this.prodParam.enter(0);
              const mod = node;
              mod.global = true;
              mod.id = expr;
              mod.body = this.tsParseModuleBlock();
              this.scope.exit();
              this.prodParam.exit();
              return this.finishNode(mod, 'TSModuleDeclaration');
            }
            break;
          default:
            return this.tsParseDeclaration(node, expr.name, false, decorators);
        }
      }
      tsParseDeclaration(node, value, next, decorators) {
        switch (value) {
          case 'abstract':
            if (
              this.tsCheckLineTerminator(next) &&
              (this.match(80) || tokenIsIdentifier(this.state.type))
            ) {
              return this.tsParseAbstractDeclaration(node, decorators);
            }
            break;
          case 'module':
            if (this.tsCheckLineTerminator(next)) {
              if (this.match(133)) {
                return this.tsParseAmbientExternalModuleDeclaration(node);
              } else if (tokenIsIdentifier(this.state.type)) {
                return this.tsParseModuleOrNamespaceDeclaration(node);
              }
            }
            break;
          case 'namespace':
            if (
              this.tsCheckLineTerminator(next) &&
              tokenIsIdentifier(this.state.type)
            ) {
              return this.tsParseModuleOrNamespaceDeclaration(node);
            }
            break;
          case 'type':
            if (
              this.tsCheckLineTerminator(next) &&
              tokenIsIdentifier(this.state.type)
            ) {
              return this.tsParseTypeAliasDeclaration(node);
            }
            break;
        }
      }
      tsCheckLineTerminator(next) {
        if (next) {
          if (this.hasFollowingLineBreak()) return false;
          this.next();
          return true;
        }
        return !this.isLineTerminator();
      }
      tsTryParseGenericAsyncArrowFunction(startLoc) {
        if (!this.match(47)) return;
        const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
        this.state.maybeInArrowParameters = true;
        const res = this.tsTryParseAndCatch(() => {
          const node = this.startNodeAt(startLoc);
          node.typeParameters = this.tsParseTypeParameters(
            this.tsParseConstModifier
          );
          super.parseFunctionParams(node);
          node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
          this.expect(19);
          return node;
        });
        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
        if (!res) return;
        return super.parseArrowExpression(res, null, true);
      }
      tsParseTypeArgumentsInExpression() {
        if (this.reScan_lt() !== 47) return;
        return this.tsParseTypeArguments();
      }
      tsParseTypeArguments() {
        const node = this.startNode();
        node.params = this.tsInType(() =>
          this.tsInNoContext(() => {
            this.expect(47);
            return this.tsParseDelimitedList(
              'TypeParametersOrArguments',
              this.tsParseType.bind(this)
            );
          })
        );
        if (node.params.length === 0) {
          this.raise(TSErrors.EmptyTypeArguments, node);
        } else if (!this.state.inType && this.curContext() === types.brace) {
          this.reScan_lt_gt();
        }
        this.expect(48);
        return this.finishNode(node, 'TSTypeParameterInstantiation');
      }
      tsIsDeclarationStart() {
        return tokenIsTSDeclarationStart(this.state.type);
      }
      isExportDefaultSpecifier() {
        if (this.tsIsDeclarationStart()) return false;
        return super.isExportDefaultSpecifier();
      }
      parseAssignableListItem(flags, decorators) {
        const startLoc = this.state.startLoc;
        const modified = {};
        this.tsParseModifiers(
          {
            allowedModifiers: [
              'public',
              'private',
              'protected',
              'override',
              'readonly',
            ],
          },
          modified
        );
        const accessibility = modified.accessibility;
        const override = modified.override;
        const readonly = modified.readonly;
        if (!(flags & 4) && (accessibility || readonly || override)) {
          this.raise(TSErrors.UnexpectedParameterModifier, startLoc);
        }
        const left = this.parseMaybeDefault();
        this.parseAssignableListItemTypes(left, flags);
        const elt = this.parseMaybeDefault(left.loc.start, left);
        if (accessibility || readonly || override) {
          const pp = this.startNodeAt(startLoc);
          if (decorators.length) {
            pp.decorators = decorators;
          }
          if (accessibility) pp.accessibility = accessibility;
          if (readonly) pp.readonly = readonly;
          if (override) pp.override = override;
          if (elt.type !== 'Identifier' && elt.type !== 'AssignmentPattern') {
            this.raise(TSErrors.UnsupportedParameterPropertyKind, pp);
          }
          pp.parameter = elt;
          return this.finishNode(pp, 'TSParameterProperty');
        }
        if (decorators.length) {
          left.decorators = decorators;
        }
        return elt;
      }
      isSimpleParameter(node) {
        return (
          (node.type === 'TSParameterProperty' &&
            super.isSimpleParameter(node.parameter)) ||
          super.isSimpleParameter(node)
        );
      }
      tsDisallowOptionalPattern(node) {
        for (const param of node.params) {
          if (
            param.type !== 'Identifier' &&
            param.optional &&
            !this.state.isAmbientContext
          ) {
            this.raise(TSErrors.PatternIsOptional, param);
          }
        }
      }
      setArrowFunctionParameters(node, params, trailingCommaLoc) {
        super.setArrowFunctionParameters(node, params, trailingCommaLoc);
        this.tsDisallowOptionalPattern(node);
      }
      parseFunctionBodyAndFinish(node, type, isMethod = false) {
        if (this.match(14)) {
          node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
        }
        const bodilessType =
          type === 'FunctionDeclaration'
            ? 'TSDeclareFunction'
            : type === 'ClassMethod' || type === 'ClassPrivateMethod'
              ? 'TSDeclareMethod'
              : undefined;
        if (bodilessType && !this.match(5) && this.isLineTerminator()) {
          return this.finishNode(node, bodilessType);
        }
        if (
          bodilessType === 'TSDeclareFunction' &&
          this.state.isAmbientContext
        ) {
          this.raise(TSErrors.DeclareFunctionHasImplementation, node);
          if (node.declare) {
            return super.parseFunctionBodyAndFinish(
              node,
              bodilessType,
              isMethod
            );
          }
        }
        this.tsDisallowOptionalPattern(node);
        return super.parseFunctionBodyAndFinish(node, type, isMethod);
      }
      registerFunctionStatementId(node) {
        if (!node.body && node.id) {
          this.checkIdentifier(node.id, 1024);
        } else {
          super.registerFunctionStatementId(node);
        }
      }
      tsCheckForInvalidTypeCasts(items) {
        items.forEach(node => {
          if ((node == null ? void 0 : node.type) === 'TSTypeCastExpression') {
            this.raise(TSErrors.UnexpectedTypeAnnotation, node.typeAnnotation);
          }
        });
      }
      toReferencedList(exprList, isInParens) {
        this.tsCheckForInvalidTypeCasts(exprList);
        return exprList;
      }
      parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
        const node = super.parseArrayLike(
          close,
          canBePattern,
          isTuple,
          refExpressionErrors
        );
        if (node.type === 'ArrayExpression') {
          this.tsCheckForInvalidTypeCasts(node.elements);
        }
        return node;
      }
      parseSubscript(base, startLoc, noCalls, state) {
        if (!this.hasPrecedingLineBreak() && this.match(35)) {
          this.state.canStartJSXElement = false;
          this.next();
          const nonNullExpression = this.startNodeAt(startLoc);
          nonNullExpression.expression = base;
          return this.finishNode(nonNullExpression, 'TSNonNullExpression');
        }
        let isOptionalCall = false;
        if (this.match(18) && this.lookaheadCharCode() === 60) {
          if (noCalls) {
            state.stop = true;
            return base;
          }
          state.optionalChainMember = isOptionalCall = true;
          this.next();
        }
        if (this.match(47) || this.match(51)) {
          let missingParenErrorLoc;
          const result = this.tsTryParseAndCatch(() => {
            if (!noCalls && this.atPossibleAsyncArrow(base)) {
              const asyncArrowFn =
                this.tsTryParseGenericAsyncArrowFunction(startLoc);
              if (asyncArrowFn) {
                return asyncArrowFn;
              }
            }
            const typeArguments = this.tsParseTypeArgumentsInExpression();
            if (!typeArguments) return;
            if (isOptionalCall && !this.match(10)) {
              missingParenErrorLoc = this.state.curPosition();
              return;
            }
            if (tokenIsTemplate(this.state.type)) {
              const result = super.parseTaggedTemplateExpression(
                base,
                startLoc,
                state
              );
              result.typeParameters = typeArguments;
              return result;
            }
            if (!noCalls && this.eat(10)) {
              const node = this.startNodeAt(startLoc);
              node.callee = base;
              node.arguments = this.parseCallExpressionArguments(11, false);
              this.tsCheckForInvalidTypeCasts(node.arguments);
              node.typeParameters = typeArguments;
              if (state.optionalChainMember) {
                node.optional = isOptionalCall;
              }
              return this.finishCallExpression(node, state.optionalChainMember);
            }
            const tokenType = this.state.type;
            if (
              tokenType === 48 ||
              tokenType === 52 ||
              (tokenType !== 10 &&
                tokenCanStartExpression(tokenType) &&
                !this.hasPrecedingLineBreak())
            ) {
              return;
            }
            const node = this.startNodeAt(startLoc);
            node.expression = base;
            node.typeParameters = typeArguments;
            return this.finishNode(node, 'TSInstantiationExpression');
          });
          if (missingParenErrorLoc) {
            this.unexpected(missingParenErrorLoc, 10);
          }
          if (result) {
            if (
              result.type === 'TSInstantiationExpression' &&
              (this.match(16) ||
                (this.match(18) && this.lookaheadCharCode() !== 40))
            ) {
              this.raise(
                TSErrors.InvalidPropertyAccessAfterInstantiationExpression,
                this.state.startLoc
              );
            }
            return result;
          }
        }
        return super.parseSubscript(base, startLoc, noCalls, state);
      }
      parseNewCallee(node) {
        var _callee$extra;
        super.parseNewCallee(node);
        const {callee: callee} = node;
        if (
          callee.type === 'TSInstantiationExpression' &&
          !(
            (_callee$extra = callee.extra) != null &&
            _callee$extra.parenthesized
          )
        ) {
          node.typeParameters = callee.typeParameters;
          node.callee = callee.expression;
        }
      }
      parseExprOp(left, leftStartLoc, minPrec) {
        let isSatisfies;
        if (
          tokenOperatorPrecedence(58) > minPrec &&
          !this.hasPrecedingLineBreak() &&
          (this.isContextual(93) || (isSatisfies = this.isContextual(120)))
        ) {
          const node = this.startNodeAt(leftStartLoc);
          node.expression = left;
          node.typeAnnotation = this.tsInType(() => {
            this.next();
            if (this.match(75)) {
              if (isSatisfies) {
                this.raise(Errors.UnexpectedKeyword, this.state.startLoc, {
                  keyword: 'const',
                });
              }
              return this.tsParseTypeReference();
            }
            return this.tsParseType();
          });
          this.finishNode(
            node,
            isSatisfies ? 'TSSatisfiesExpression' : 'TSAsExpression'
          );
          this.reScan_lt_gt();
          return this.parseExprOp(node, leftStartLoc, minPrec);
        }
        return super.parseExprOp(left, leftStartLoc, minPrec);
      }
      checkReservedWord(word, startLoc, checkKeywords, isBinding) {
        if (!this.state.isAmbientContext) {
          super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
        }
      }
      checkImportReflection(node) {
        super.checkImportReflection(node);
        if (node.module && node.importKind !== 'value') {
          this.raise(
            TSErrors.ImportReflectionHasImportType,
            node.specifiers[0].loc.start
          );
        }
      }
      checkDuplicateExports() {}
      isPotentialImportPhase(isExport) {
        if (super.isPotentialImportPhase(isExport)) return true;
        if (this.isContextual(130)) {
          const ch = this.lookaheadCharCode();
          return isExport ? ch === 123 || ch === 42 : ch !== 61;
        }
        return !isExport && this.isContextual(87);
      }
      applyImportPhase(node, isExport, phase, loc) {
        super.applyImportPhase(node, isExport, phase, loc);
        if (isExport) {
          node.exportKind = phase === 'type' ? 'type' : 'value';
        } else {
          node.importKind =
            phase === 'type' || phase === 'typeof' ? phase : 'value';
        }
      }
      parseImport(node) {
        if (this.match(133)) {
          node.importKind = 'value';
          return super.parseImport(node);
        }
        let importNode;
        if (
          tokenIsIdentifier(this.state.type) &&
          this.lookaheadCharCode() === 61
        ) {
          node.importKind = 'value';
          return this.tsParseImportEqualsDeclaration(node);
        } else if (this.isContextual(130)) {
          const maybeDefaultIdentifier = this.parseMaybeImportPhase(
            node,
            false
          );
          if (this.lookaheadCharCode() === 61) {
            return this.tsParseImportEqualsDeclaration(
              node,
              maybeDefaultIdentifier
            );
          } else {
            importNode = super.parseImportSpecifiersAndAfter(
              node,
              maybeDefaultIdentifier
            );
          }
        } else {
          importNode = super.parseImport(node);
        }
        if (
          importNode.importKind === 'type' &&
          importNode.specifiers.length > 1 &&
          importNode.specifiers[0].type === 'ImportDefaultSpecifier'
        ) {
          this.raise(
            TSErrors.TypeImportCannotSpecifyDefaultAndNamed,
            importNode
          );
        }
        return importNode;
      }
      parseExport(node, decorators) {
        if (this.match(83)) {
          this.next();
          const nodeImportEquals = node;
          let maybeDefaultIdentifier = null;
          if (this.isContextual(130) && this.isPotentialImportPhase(false)) {
            maybeDefaultIdentifier = this.parseMaybeImportPhase(
              nodeImportEquals,
              false
            );
          } else {
            nodeImportEquals.importKind = 'value';
          }
          return this.tsParseImportEqualsDeclaration(
            nodeImportEquals,
            maybeDefaultIdentifier,
            true
          );
        } else if (this.eat(29)) {
          const assign = node;
          assign.expression = super.parseExpression();
          this.semicolon();
          this.sawUnambiguousESM = true;
          return this.finishNode(assign, 'TSExportAssignment');
        } else if (this.eatContextual(93)) {
          const decl = node;
          this.expectContextual(128);
          decl.id = this.parseIdentifier();
          this.semicolon();
          return this.finishNode(decl, 'TSNamespaceExportDeclaration');
        } else {
          return super.parseExport(node, decorators);
        }
      }
      isAbstractClass() {
        return this.isContextual(124) && this.lookahead().type === 80;
      }
      parseExportDefaultExpression() {
        if (this.isAbstractClass()) {
          const cls = this.startNode();
          this.next();
          cls.abstract = true;
          return this.parseClass(cls, true, true);
        }
        if (this.match(129)) {
          const result = this.tsParseInterfaceDeclaration(this.startNode());
          if (result) return result;
        }
        return super.parseExportDefaultExpression();
      }
      parseVarStatement(node, kind, allowMissingInitializer = false) {
        const {isAmbientContext: isAmbientContext} = this.state;
        const declaration = super.parseVarStatement(
          node,
          kind,
          allowMissingInitializer || isAmbientContext
        );
        if (!isAmbientContext) return declaration;
        for (const {id: id, init: init} of declaration.declarations) {
          if (!init) continue;
          if (kind !== 'const' || !!id.typeAnnotation) {
            this.raise(TSErrors.InitializerNotAllowedInAmbientContext, init);
          } else if (
            !isValidAmbientConstInitializer(init, this.hasPlugin('estree'))
          ) {
            this.raise(
              TSErrors.ConstInitializerMustBeStringOrNumericLiteralOrLiteralEnumReference,
              init
            );
          }
        }
        return declaration;
      }
      parseStatementContent(flags, decorators) {
        if (this.match(75) && this.isLookaheadContextual('enum')) {
          const node = this.startNode();
          this.expect(75);
          return this.tsParseEnumDeclaration(node, {const: true});
        }
        if (this.isContextual(126)) {
          return this.tsParseEnumDeclaration(this.startNode());
        }
        if (this.isContextual(129)) {
          const result = this.tsParseInterfaceDeclaration(this.startNode());
          if (result) return result;
        }
        return super.parseStatementContent(flags, decorators);
      }
      parseAccessModifier() {
        return this.tsParseModifier(['public', 'protected', 'private']);
      }
      tsHasSomeModifiers(member, modifiers) {
        return modifiers.some(modifier => {
          if (tsIsAccessModifier(modifier)) {
            return member.accessibility === modifier;
          }
          return !!member[modifier];
        });
      }
      tsIsStartOfStaticBlocks() {
        return this.isContextual(106) && this.lookaheadCharCode() === 123;
      }
      parseClassMember(classBody, member, state) {
        const modifiers = [
          'declare',
          'private',
          'public',
          'protected',
          'override',
          'abstract',
          'readonly',
          'static',
        ];
        this.tsParseModifiers(
          {
            allowedModifiers: modifiers,
            disallowedModifiers: ['in', 'out'],
            stopOnStartOfClassStaticBlock: true,
            errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions,
          },
          member
        );
        const callParseClassMemberWithIsStatic = () => {
          if (this.tsIsStartOfStaticBlocks()) {
            this.next();
            this.next();
            if (this.tsHasSomeModifiers(member, modifiers)) {
              this.raise(
                TSErrors.StaticBlockCannotHaveModifier,
                this.state.curPosition()
              );
            }
            super.parseClassStaticBlock(classBody, member);
          } else {
            this.parseClassMemberWithIsStatic(
              classBody,
              member,
              state,
              !!member.static
            );
          }
        };
        if (member.declare) {
          this.tsInAmbientContext(callParseClassMemberWithIsStatic);
        } else {
          callParseClassMemberWithIsStatic();
        }
      }
      parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
        const idx = this.tsTryParseIndexSignature(member);
        if (idx) {
          classBody.body.push(idx);
          if (member.abstract) {
            this.raise(TSErrors.IndexSignatureHasAbstract, member);
          }
          if (member.accessibility) {
            this.raise(TSErrors.IndexSignatureHasAccessibility, member, {
              modifier: member.accessibility,
            });
          }
          if (member.declare) {
            this.raise(TSErrors.IndexSignatureHasDeclare, member);
          }
          if (member.override) {
            this.raise(TSErrors.IndexSignatureHasOverride, member);
          }
          return;
        }
        if (!this.state.inAbstractClass && member.abstract) {
          this.raise(TSErrors.NonAbstractClassHasAbstractMethod, member);
        }
        if (member.override) {
          if (!state.hadSuperClass) {
            this.raise(TSErrors.OverrideNotInSubClass, member);
          }
        }
        super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
      }
      parsePostMemberNameModifiers(methodOrProp) {
        const optional = this.eat(17);
        if (optional) methodOrProp.optional = true;
        if (methodOrProp.readonly && this.match(10)) {
          this.raise(TSErrors.ClassMethodHasReadonly, methodOrProp);
        }
        if (methodOrProp.declare && this.match(10)) {
          this.raise(TSErrors.ClassMethodHasDeclare, methodOrProp);
        }
      }
      parseExpressionStatement(node, expr, decorators) {
        const decl =
          expr.type === 'Identifier'
            ? this.tsParseExpressionStatement(node, expr, decorators)
            : undefined;
        return decl || super.parseExpressionStatement(node, expr, decorators);
      }
      shouldParseExportDeclaration() {
        if (this.tsIsDeclarationStart()) return true;
        return super.shouldParseExportDeclaration();
      }
      parseConditional(expr, startLoc, refExpressionErrors) {
        if (!this.state.maybeInArrowParameters || !this.match(17)) {
          return super.parseConditional(expr, startLoc, refExpressionErrors);
        }
        const result = this.tryParse(() =>
          super.parseConditional(expr, startLoc)
        );
        if (!result.node) {
          if (result.error) {
            super.setOptionalParametersError(refExpressionErrors, result.error);
          }
          return expr;
        }
        if (result.error) this.state = result.failState;
        return result.node;
      }
      parseParenItem(node, startLoc) {
        const newNode = super.parseParenItem(node, startLoc);
        if (this.eat(17)) {
          newNode.optional = true;
          this.resetEndLocation(node);
        }
        if (this.match(14)) {
          const typeCastNode = this.startNodeAt(startLoc);
          typeCastNode.expression = node;
          typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
          return this.finishNode(typeCastNode, 'TSTypeCastExpression');
        }
        return node;
      }
      parseExportDeclaration(node) {
        if (!this.state.isAmbientContext && this.isContextual(125)) {
          return this.tsInAmbientContext(() =>
            this.parseExportDeclaration(node)
          );
        }
        const startLoc = this.state.startLoc;
        const isDeclare = this.eatContextual(125);
        if (
          isDeclare &&
          (this.isContextual(125) || !this.shouldParseExportDeclaration())
        ) {
          throw this.raise(
            TSErrors.ExpectedAmbientAfterExportDeclare,
            this.state.startLoc
          );
        }
        const isIdentifier = tokenIsIdentifier(this.state.type);
        const declaration =
          (isIdentifier && this.tsTryParseExportDeclaration()) ||
          super.parseExportDeclaration(node);
        if (!declaration) return null;
        if (
          declaration.type === 'TSInterfaceDeclaration' ||
          declaration.type === 'TSTypeAliasDeclaration' ||
          isDeclare
        ) {
          node.exportKind = 'type';
        }
        if (isDeclare) {
          this.resetStartLocation(declaration, startLoc);
          declaration.declare = true;
        }
        return declaration;
      }
      parseClassId(node, isStatement, optionalId, bindingType) {
        if ((!isStatement || optionalId) && this.isContextual(113)) {
          return;
        }
        super.parseClassId(
          node,
          isStatement,
          optionalId,
          node.declare ? 1024 : 8331
        );
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseInOutConstModifiers
        );
        if (typeParameters) node.typeParameters = typeParameters;
      }
      parseClassPropertyAnnotation(node) {
        if (!node.optional) {
          if (this.eat(35)) {
            node.definite = true;
          } else if (this.eat(17)) {
            node.optional = true;
          }
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) node.typeAnnotation = type;
      }
      parseClassProperty(node) {
        this.parseClassPropertyAnnotation(node);
        if (
          this.state.isAmbientContext &&
          !(node.readonly && !node.typeAnnotation) &&
          this.match(29)
        ) {
          this.raise(
            TSErrors.DeclareClassFieldHasInitializer,
            this.state.startLoc
          );
        }
        if (node.abstract && this.match(29)) {
          const {key: key} = node;
          this.raise(
            TSErrors.AbstractPropertyHasInitializer,
            this.state.startLoc,
            {
              propertyName:
                key.type === 'Identifier' && !node.computed
                  ? key.name
                  : `[${this.input.slice(key.start, key.end)}]`,
            }
          );
        }
        return super.parseClassProperty(node);
      }
      parseClassPrivateProperty(node) {
        if (node.abstract) {
          this.raise(TSErrors.PrivateElementHasAbstract, node);
        }
        if (node.accessibility) {
          this.raise(TSErrors.PrivateElementHasAccessibility, node, {
            modifier: node.accessibility,
          });
        }
        this.parseClassPropertyAnnotation(node);
        return super.parseClassPrivateProperty(node);
      }
      parseClassAccessorProperty(node) {
        this.parseClassPropertyAnnotation(node);
        if (node.optional) {
          this.raise(TSErrors.AccessorCannotBeOptional, node);
        }
        return super.parseClassAccessorProperty(node);
      }
      pushClassMethod(
        classBody,
        method,
        isGenerator,
        isAsync,
        isConstructor,
        allowsDirectSuper
      ) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters && isConstructor) {
          this.raise(TSErrors.ConstructorHasTypeParameters, typeParameters);
        }
        const {declare: declare = false, kind: kind} = method;
        if (declare && (kind === 'get' || kind === 'set')) {
          this.raise(TSErrors.DeclareAccessor, method, {kind: kind});
        }
        if (typeParameters) method.typeParameters = typeParameters;
        super.pushClassMethod(
          classBody,
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper
        );
      }
      pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) method.typeParameters = typeParameters;
        super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
      }
      declareClassPrivateMethodInScope(node, kind) {
        if (node.type === 'TSDeclareMethod') return;
        if (
          node.type === 'MethodDefinition' &&
          !hasOwnProperty.call(node.value, 'body')
        ) {
          return;
        }
        super.declareClassPrivateMethodInScope(node, kind);
      }
      parseClassSuper(node) {
        super.parseClassSuper(node);
        if (node.superClass && (this.match(47) || this.match(51))) {
          node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
        }
        if (this.eatContextual(113)) {
          node.implements = this.tsParseHeritageClause('implements');
        }
      }
      parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        isPattern,
        isAccessor,
        refExpressionErrors
      ) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) prop.typeParameters = typeParameters;
        return super.parseObjPropValue(
          prop,
          startLoc,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor,
          refExpressionErrors
        );
      }
      parseFunctionParams(node, isConstructor) {
        const typeParameters = this.tsTryParseTypeParameters(
          this.tsParseConstModifier
        );
        if (typeParameters) node.typeParameters = typeParameters;
        super.parseFunctionParams(node, isConstructor);
      }
      parseVarId(decl, kind) {
        super.parseVarId(decl, kind);
        if (
          decl.id.type === 'Identifier' &&
          !this.hasPrecedingLineBreak() &&
          this.eat(35)
        ) {
          decl.definite = true;
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) {
          decl.id.typeAnnotation = type;
          this.resetEndLocation(decl.id);
        }
      }
      parseAsyncArrowFromCallExpression(node, call) {
        if (this.match(14)) {
          node.returnType = this.tsParseTypeAnnotation();
        }
        return super.parseAsyncArrowFromCallExpression(node, call);
      }
      parseMaybeAssign(refExpressionErrors, afterLeftParse) {
        var _jsx, _jsx2, _typeCast, _jsx3, _typeCast2;
        let state;
        let jsx;
        let typeCast;
        if (this.hasPlugin('jsx') && (this.match(142) || this.match(47))) {
          state = this.state.clone();
          jsx = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!jsx.error) return jsx.node;
          const {context: context} = this.state;
          const currentContext = context[context.length - 1];
          if (
            currentContext === types.j_oTag ||
            currentContext === types.j_expr
          ) {
            context.pop();
          }
        }
        if (!((_jsx = jsx) != null && _jsx.error) && !this.match(47)) {
          return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
        }
        if (!state || state === this.state) state = this.state.clone();
        let typeParameters;
        const arrow = this.tryParse(abort => {
          var _expr$extra, _typeParameters;
          typeParameters = this.tsParseTypeParameters(
            this.tsParseConstModifier
          );
          const expr = super.parseMaybeAssign(
            refExpressionErrors,
            afterLeftParse
          );
          if (
            expr.type !== 'ArrowFunctionExpression' ||
            ((_expr$extra = expr.extra) != null && _expr$extra.parenthesized)
          ) {
            abort();
          }
          if (
            ((_typeParameters = typeParameters) == null
              ? void 0
              : _typeParameters.params.length) !== 0
          ) {
            this.resetStartLocationFromNode(expr, typeParameters);
          }
          expr.typeParameters = typeParameters;
          return expr;
        }, state);
        if (!arrow.error && !arrow.aborted) {
          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
          return arrow.node;
        }
        if (!jsx) {
          assert(!this.hasPlugin('jsx'));
          typeCast = this.tryParse(
            () => super.parseMaybeAssign(refExpressionErrors, afterLeftParse),
            state
          );
          if (!typeCast.error) return typeCast.node;
        }
        if ((_jsx2 = jsx) != null && _jsx2.node) {
          this.state = jsx.failState;
          return jsx.node;
        }
        if (arrow.node) {
          this.state = arrow.failState;
          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
          return arrow.node;
        }
        if ((_typeCast = typeCast) != null && _typeCast.node) {
          this.state = typeCast.failState;
          return typeCast.node;
        }
        throw (
          ((_jsx3 = jsx) == null ? void 0 : _jsx3.error) ||
          arrow.error ||
          ((_typeCast2 = typeCast) == null ? void 0 : _typeCast2.error)
        );
      }
      reportReservedArrowTypeParam(node) {
        var _node$extra;
        if (
          node.params.length === 1 &&
          !node.params[0].constraint &&
          !((_node$extra = node.extra) != null && _node$extra.trailingComma) &&
          this.getPluginOption('typescript', 'disallowAmbiguousJSXLike')
        ) {
          this.raise(TSErrors.ReservedArrowTypeParam, node);
        }
      }
      parseMaybeUnary(refExpressionErrors, sawUnary) {
        if (!this.hasPlugin('jsx') && this.match(47)) {
          return this.tsParseTypeAssertion();
        }
        return super.parseMaybeUnary(refExpressionErrors, sawUnary);
      }
      parseArrow(node) {
        if (this.match(14)) {
          const result = this.tryParse(abort => {
            const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
            if (this.canInsertSemicolon() || !this.match(19)) abort();
            return returnType;
          });
          if (result.aborted) return;
          if (!result.thrown) {
            if (result.error) this.state = result.failState;
            node.returnType = result.node;
          }
        }
        return super.parseArrow(node);
      }
      parseAssignableListItemTypes(param, flags) {
        if (!(flags & 2)) return param;
        if (this.eat(17)) {
          param.optional = true;
        }
        const type = this.tsTryParseTypeAnnotation();
        if (type) param.typeAnnotation = type;
        this.resetEndLocation(param);
        return param;
      }
      isAssignable(node, isBinding) {
        switch (node.type) {
          case 'TSTypeCastExpression':
            return this.isAssignable(node.expression, isBinding);
          case 'TSParameterProperty':
            return true;
          default:
            return super.isAssignable(node, isBinding);
        }
      }
      toAssignable(node, isLHS = false) {
        switch (node.type) {
          case 'ParenthesizedExpression':
            this.toAssignableParenthesizedExpression(node, isLHS);
            break;
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSNonNullExpression':
          case 'TSTypeAssertion':
            if (isLHS) {
              this.expressionScope.recordArrowParameterBindingError(
                TSErrors.UnexpectedTypeCastInParameter,
                node
              );
            } else {
              this.raise(TSErrors.UnexpectedTypeCastInParameter, node);
            }
            this.toAssignable(node.expression, isLHS);
            break;
          case 'AssignmentExpression':
            if (!isLHS && node.left.type === 'TSTypeCastExpression') {
              node.left = this.typeCastToParameter(node.left);
            }
          default:
            super.toAssignable(node, isLHS);
        }
      }
      toAssignableParenthesizedExpression(node, isLHS) {
        switch (node.expression.type) {
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSNonNullExpression':
          case 'TSTypeAssertion':
          case 'ParenthesizedExpression':
            this.toAssignable(node.expression, isLHS);
            break;
          default:
            super.toAssignable(node, isLHS);
        }
      }
      checkToRestConversion(node, allowPattern) {
        switch (node.type) {
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSTypeAssertion':
          case 'TSNonNullExpression':
            this.checkToRestConversion(node.expression, false);
            break;
          default:
            super.checkToRestConversion(node, allowPattern);
        }
      }
      isValidLVal(type, isUnparenthesizedInAssign, binding) {
        switch (type) {
          case 'TSTypeCastExpression':
            return true;
          case 'TSParameterProperty':
            return 'parameter';
          case 'TSNonNullExpression':
          case 'TSInstantiationExpression':
            return 'expression';
          case 'TSAsExpression':
          case 'TSSatisfiesExpression':
          case 'TSTypeAssertion':
            return (
              (binding !== 64 || !isUnparenthesizedInAssign) && [
                'expression',
                true,
              ]
            );
          default:
            return super.isValidLVal(type, isUnparenthesizedInAssign, binding);
        }
      }
      parseBindingAtom() {
        if (this.state.type === 78) {
          return this.parseIdentifier(true);
        }
        return super.parseBindingAtom();
      }
      parseMaybeDecoratorArguments(expr) {
        if (this.match(47) || this.match(51)) {
          const typeArguments = this.tsParseTypeArgumentsInExpression();
          if (this.match(10)) {
            const call = super.parseMaybeDecoratorArguments(expr);
            call.typeParameters = typeArguments;
            return call;
          }
          this.unexpected(null, 10);
        }
        return super.parseMaybeDecoratorArguments(expr);
      }
      checkCommaAfterRest(close) {
        if (
          this.state.isAmbientContext &&
          this.match(12) &&
          this.lookaheadCharCode() === close
        ) {
          this.next();
          return false;
        }
        return super.checkCommaAfterRest(close);
      }
      isClassMethod() {
        return this.match(47) || super.isClassMethod();
      }
      isClassProperty() {
        return this.match(35) || this.match(14) || super.isClassProperty();
      }
      parseMaybeDefault(startLoc, left) {
        const node = super.parseMaybeDefault(startLoc, left);
        if (
          node.type === 'AssignmentPattern' &&
          node.typeAnnotation &&
          node.right.start < node.typeAnnotation.start
        ) {
          this.raise(TSErrors.TypeAnnotationAfterAssign, node.typeAnnotation);
        }
        return node;
      }
      getTokenFromCode(code) {
        if (this.state.inType) {
          if (code === 62) {
            this.finishOp(48, 1);
            return;
          }
          if (code === 60) {
            this.finishOp(47, 1);
            return;
          }
        }
        super.getTokenFromCode(code);
      }
      reScan_lt_gt() {
        const {type: type} = this.state;
        if (type === 47) {
          this.state.pos -= 1;
          this.readToken_lt();
        } else if (type === 48) {
          this.state.pos -= 1;
          this.readToken_gt();
        }
      }
      reScan_lt() {
        const {type: type} = this.state;
        if (type === 51) {
          this.state.pos -= 2;
          this.finishOp(47, 1);
          return 47;
        }
        return type;
      }
      toAssignableList(exprList, trailingCommaLoc, isLHS) {
        for (let i = 0; i < exprList.length; i++) {
          const expr = exprList[i];
          if ((expr == null ? void 0 : expr.type) === 'TSTypeCastExpression') {
            exprList[i] = this.typeCastToParameter(expr);
          }
        }
        super.toAssignableList(exprList, trailingCommaLoc, isLHS);
      }
      typeCastToParameter(node) {
        node.expression.typeAnnotation = node.typeAnnotation;
        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
        return node.expression;
      }
      shouldParseArrow(params) {
        if (this.match(14)) {
          return params.every(expr => this.isAssignable(expr, true));
        }
        return super.shouldParseArrow(params);
      }
      shouldParseAsyncArrow() {
        return this.match(14) || super.shouldParseAsyncArrow();
      }
      canHaveLeadingDecorator() {
        return super.canHaveLeadingDecorator() || this.isAbstractClass();
      }
      jsxParseOpeningElementAfterName(node) {
        if (this.match(47) || this.match(51)) {
          const typeArguments = this.tsTryParseAndCatch(() =>
            this.tsParseTypeArgumentsInExpression()
          );
          if (typeArguments) node.typeParameters = typeArguments;
        }
        return super.jsxParseOpeningElementAfterName(node);
      }
      getGetterSetterExpectedParamCount(method) {
        const baseCount = super.getGetterSetterExpectedParamCount(method);
        const params = this.getObjectOrClassMethodParams(method);
        const firstParam = params[0];
        const hasContextParam = firstParam && this.isThisParam(firstParam);
        return hasContextParam ? baseCount + 1 : baseCount;
      }
      parseCatchClauseParam() {
        const param = super.parseCatchClauseParam();
        const type = this.tsTryParseTypeAnnotation();
        if (type) {
          param.typeAnnotation = type;
          this.resetEndLocation(param);
        }
        return param;
      }
      tsInAmbientContext(cb) {
        const {isAmbientContext: oldIsAmbientContext, strict: oldStrict} =
          this.state;
        this.state.isAmbientContext = true;
        this.state.strict = false;
        try {
          return cb();
        } finally {
          this.state.isAmbientContext = oldIsAmbientContext;
          this.state.strict = oldStrict;
        }
      }
      parseClass(node, isStatement, optionalId) {
        const oldInAbstractClass = this.state.inAbstractClass;
        this.state.inAbstractClass = !!node.abstract;
        try {
          return super.parseClass(node, isStatement, optionalId);
        } finally {
          this.state.inAbstractClass = oldInAbstractClass;
        }
      }
      tsParseAbstractDeclaration(node, decorators) {
        if (this.match(80)) {
          node.abstract = true;
          return this.maybeTakeDecorators(
            decorators,
            this.parseClass(node, true, false)
          );
        } else if (this.isContextual(129)) {
          if (!this.hasFollowingLineBreak()) {
            node.abstract = true;
            this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, node);
            return this.tsParseInterfaceDeclaration(node);
          }
        } else {
          this.unexpected(null, 80);
        }
      }
      parseMethod(
        node,
        isGenerator,
        isAsync,
        isConstructor,
        allowDirectSuper,
        type,
        inClassScope
      ) {
        const method = super.parseMethod(
          node,
          isGenerator,
          isAsync,
          isConstructor,
          allowDirectSuper,
          type,
          inClassScope
        );
        if (method.abstract) {
          const hasBody = this.hasPlugin('estree')
            ? !!method.value.body
            : !!method.body;
          if (hasBody) {
            const {key: key} = method;
            this.raise(TSErrors.AbstractMethodHasImplementation, method, {
              methodName:
                key.type === 'Identifier' && !method.computed
                  ? key.name
                  : `[${this.input.slice(key.start, key.end)}]`,
            });
          }
        }
        return method;
      }
      tsParseTypeParameterName() {
        const typeName = this.parseIdentifier();
        return typeName.name;
      }
      shouldParseAsAmbientContext() {
        return !!this.getPluginOption('typescript', 'dts');
      }
      parse() {
        if (this.shouldParseAsAmbientContext()) {
          this.state.isAmbientContext = true;
        }
        return super.parse();
      }
      getExpression() {
        if (this.shouldParseAsAmbientContext()) {
          this.state.isAmbientContext = true;
        }
        return super.getExpression();
      }
      parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
        if (!isString && isMaybeTypeOnly) {
          this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
          return this.finishNode(node, 'ExportSpecifier');
        }
        node.exportKind = 'value';
        return super.parseExportSpecifier(
          node,
          isString,
          isInTypeExport,
          isMaybeTypeOnly
        );
      }
      parseImportSpecifier(
        specifier,
        importedIsString,
        isInTypeOnlyImport,
        isMaybeTypeOnly,
        bindingType
      ) {
        if (!importedIsString && isMaybeTypeOnly) {
          this.parseTypeOnlyImportExportSpecifier(
            specifier,
            true,
            isInTypeOnlyImport
          );
          return this.finishNode(specifier, 'ImportSpecifier');
        }
        specifier.importKind = 'value';
        return super.parseImportSpecifier(
          specifier,
          importedIsString,
          isInTypeOnlyImport,
          isMaybeTypeOnly,
          isInTypeOnlyImport ? 4098 : 4096
        );
      }
      parseTypeOnlyImportExportSpecifier(
        node,
        isImport,
        isInTypeOnlyImportExport
      ) {
        const leftOfAsKey = isImport ? 'imported' : 'local';
        const rightOfAsKey = isImport ? 'local' : 'exported';
        let leftOfAs = node[leftOfAsKey];
        let rightOfAs;
        let hasTypeSpecifier = false;
        let canParseAsKeyword = true;
        const loc = leftOfAs.loc.start;
        if (this.isContextual(93)) {
          const firstAs = this.parseIdentifier();
          if (this.isContextual(93)) {
            const secondAs = this.parseIdentifier();
            if (tokenIsKeywordOrIdentifier(this.state.type)) {
              hasTypeSpecifier = true;
              leftOfAs = firstAs;
              rightOfAs = isImport
                ? this.parseIdentifier()
                : this.parseModuleExportName();
              canParseAsKeyword = false;
            } else {
              rightOfAs = secondAs;
              canParseAsKeyword = false;
            }
          } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
            canParseAsKeyword = false;
            rightOfAs = isImport
              ? this.parseIdentifier()
              : this.parseModuleExportName();
          } else {
            hasTypeSpecifier = true;
            leftOfAs = firstAs;
          }
        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
          hasTypeSpecifier = true;
          if (isImport) {
            leftOfAs = this.parseIdentifier(true);
            if (!this.isContextual(93)) {
              this.checkReservedWord(
                leftOfAs.name,
                leftOfAs.loc.start,
                true,
                true
              );
            }
          } else {
            leftOfAs = this.parseModuleExportName();
          }
        }
        if (hasTypeSpecifier && isInTypeOnlyImportExport) {
          this.raise(
            isImport
              ? TSErrors.TypeModifierIsUsedInTypeImports
              : TSErrors.TypeModifierIsUsedInTypeExports,
            loc
          );
        }
        node[leftOfAsKey] = leftOfAs;
        node[rightOfAsKey] = rightOfAs;
        const kindKey = isImport ? 'importKind' : 'exportKind';
        node[kindKey] = hasTypeSpecifier ? 'type' : 'value';
        if (canParseAsKeyword && this.eatContextual(93)) {
          node[rightOfAsKey] = isImport
            ? this.parseIdentifier()
            : this.parseModuleExportName();
        }
        if (!node[rightOfAsKey]) {
          node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
        }
        if (isImport) {
          this.checkIdentifier(
            node[rightOfAsKey],
            hasTypeSpecifier ? 4098 : 4096
          );
        }
      }
    };
  function isPossiblyLiteralEnum(expression) {
    if (expression.type !== 'MemberExpression') return false;
    const {computed: computed, property: property} = expression;
    if (
      computed &&
      property.type !== 'StringLiteral' &&
      (property.type !== 'TemplateLiteral' || property.expressions.length > 0)
    ) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  function isValidAmbientConstInitializer(expression, estree) {
    var _expression$extra;
    const {type: type} = expression;
    if (
      (_expression$extra = expression.extra) != null &&
      _expression$extra.parenthesized
    ) {
      return false;
    }
    if (estree) {
      if (type === 'Literal') {
        const {value: value} = expression;
        if (typeof value === 'string' || typeof value === 'boolean') {
          return true;
        }
      }
    } else {
      if (type === 'StringLiteral' || type === 'BooleanLiteral') {
        return true;
      }
    }
    if (isNumber(expression, estree) || isNegativeNumber(expression, estree)) {
      return true;
    }
    if (type === 'TemplateLiteral' && expression.expressions.length === 0) {
      return true;
    }
    if (isPossiblyLiteralEnum(expression)) {
      return true;
    }
    return false;
  }
  function isNumber(expression, estree) {
    if (estree) {
      return (
        expression.type === 'Literal' &&
        (typeof expression.value === 'number' || 'bigint' in expression)
      );
    }
    return (
      expression.type === 'NumericLiteral' ||
      expression.type === 'BigIntLiteral'
    );
  }
  function isNegativeNumber(expression, estree) {
    if (expression.type === 'UnaryExpression') {
      const {operator: operator, argument: argument} = expression;
      if (operator === '-' && isNumber(argument, estree)) {
        return true;
      }
    }
    return false;
  }
  function isUncomputedMemberExpressionChain(expression) {
    if (expression.type === 'Identifier') return true;
    if (expression.type !== 'MemberExpression' || expression.computed) {
      return false;
    }
    return isUncomputedMemberExpressionChain(expression.object);
  }
  const PlaceholderErrors = ParseErrorEnum`placeholders`({
    ClassNameIsRequired: 'A class name is required.',
    UnexpectedSpace: 'Unexpected space in placeholder.',
  });
  var placeholders = superClass =>
    class PlaceholdersParserMixin extends superClass {
      parsePlaceholder(expectedNode) {
        if (this.match(144)) {
          const node = this.startNode();
          this.next();
          this.assertNoSpace();
          node.name = super.parseIdentifier(true);
          this.assertNoSpace();
          this.expect(144);
          return this.finishPlaceholder(node, expectedNode);
        }
      }
      finishPlaceholder(node, expectedNode) {
        let placeholder = node;
        if (!placeholder.expectedNode || !placeholder.type) {
          placeholder = this.finishNode(placeholder, 'Placeholder');
        }
        placeholder.expectedNode = expectedNode;
        return placeholder;
      }
      getTokenFromCode(code) {
        if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
          this.finishOp(144, 2);
        } else {
          super.getTokenFromCode(code);
        }
      }
      parseExprAtom(refExpressionErrors) {
        return (
          this.parsePlaceholder('Expression') ||
          super.parseExprAtom(refExpressionErrors)
        );
      }
      parseIdentifier(liberal) {
        return (
          this.parsePlaceholder('Identifier') || super.parseIdentifier(liberal)
        );
      }
      checkReservedWord(word, startLoc, checkKeywords, isBinding) {
        if (word !== undefined) {
          super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
        }
      }
      parseBindingAtom() {
        return this.parsePlaceholder('Pattern') || super.parseBindingAtom();
      }
      isValidLVal(type, isParenthesized, binding) {
        return (
          type === 'Placeholder' ||
          super.isValidLVal(type, isParenthesized, binding)
        );
      }
      toAssignable(node, isLHS) {
        if (
          node &&
          node.type === 'Placeholder' &&
          node.expectedNode === 'Expression'
        ) {
          node.expectedNode = 'Pattern';
        } else {
          super.toAssignable(node, isLHS);
        }
      }
      chStartsBindingIdentifier(ch, pos) {
        if (super.chStartsBindingIdentifier(ch, pos)) {
          return true;
        }
        const nextToken = this.lookahead();
        if (nextToken.type === 144) {
          return true;
        }
        return false;
      }
      verifyBreakContinue(node, isBreak) {
        if (node.label && node.label.type === 'Placeholder') return;
        super.verifyBreakContinue(node, isBreak);
      }
      parseExpressionStatement(node, expr) {
        var _expr$extra;
        if (
          expr.type !== 'Placeholder' ||
          ((_expr$extra = expr.extra) != null && _expr$extra.parenthesized)
        ) {
          return super.parseExpressionStatement(node, expr);
        }
        if (this.match(14)) {
          const stmt = node;
          stmt.label = this.finishPlaceholder(expr, 'Identifier');
          this.next();
          stmt.body = super.parseStatementOrSloppyAnnexBFunctionDeclaration();
          return this.finishNode(stmt, 'LabeledStatement');
        }
        this.semicolon();
        const stmtPlaceholder = node;
        stmtPlaceholder.name = expr.name;
        return this.finishPlaceholder(stmtPlaceholder, 'Statement');
      }
      parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
        return (
          this.parsePlaceholder('BlockStatement') ||
          super.parseBlock(
            allowDirectives,
            createNewLexicalScope,
            afterBlockParse
          )
        );
      }
      parseFunctionId(requireId) {
        return (
          this.parsePlaceholder('Identifier') ||
          super.parseFunctionId(requireId)
        );
      }
      parseClass(node, isStatement, optionalId) {
        const type = isStatement ? 'ClassDeclaration' : 'ClassExpression';
        this.next();
        const oldStrict = this.state.strict;
        const placeholder = this.parsePlaceholder('Identifier');
        if (placeholder) {
          if (this.match(81) || this.match(144) || this.match(5)) {
            node.id = placeholder;
          } else if (optionalId || !isStatement) {
            node.id = null;
            node.body = this.finishPlaceholder(placeholder, 'ClassBody');
            return this.finishNode(node, type);
          } else {
            throw this.raise(
              PlaceholderErrors.ClassNameIsRequired,
              this.state.startLoc
            );
          }
        } else {
          this.parseClassId(node, isStatement, optionalId);
        }
        super.parseClassSuper(node);
        node.body =
          this.parsePlaceholder('ClassBody') ||
          super.parseClassBody(!!node.superClass, oldStrict);
        return this.finishNode(node, type);
      }
      parseExport(node, decorators) {
        const placeholder = this.parsePlaceholder('Identifier');
        if (!placeholder) return super.parseExport(node, decorators);
        const node2 = node;
        if (!this.isContextual(98) && !this.match(12)) {
          node2.specifiers = [];
          node2.source = null;
          node2.declaration = this.finishPlaceholder(
            placeholder,
            'Declaration'
          );
          return this.finishNode(node2, 'ExportNamedDeclaration');
        }
        this.expectPlugin('exportDefaultFrom');
        const specifier = this.startNode();
        specifier.exported = placeholder;
        node2.specifiers = [
          this.finishNode(specifier, 'ExportDefaultSpecifier'),
        ];
        return super.parseExport(node2, decorators);
      }
      isExportDefaultSpecifier() {
        if (this.match(65)) {
          const next = this.nextTokenStart();
          if (this.isUnparsedContextual(next, 'from')) {
            if (
              this.input.startsWith(
                tokenLabelName(144),
                this.nextTokenStartSince(next + 4)
              )
            ) {
              return true;
            }
          }
        }
        return super.isExportDefaultSpecifier();
      }
      maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
        var _specifiers;
        if ((_specifiers = node.specifiers) != null && _specifiers.length) {
          return true;
        }
        return super.maybeParseExportDefaultSpecifier(
          node,
          maybeDefaultIdentifier
        );
      }
      checkExport(node) {
        const {specifiers: specifiers} = node;
        if (specifiers != null && specifiers.length) {
          node.specifiers = specifiers.filter(
            node => node.exported.type === 'Placeholder'
          );
        }
        super.checkExport(node);
        node.specifiers = specifiers;
      }
      parseImport(node) {
        const placeholder = this.parsePlaceholder('Identifier');
        if (!placeholder) return super.parseImport(node);
        node.specifiers = [];
        if (!this.isContextual(98) && !this.match(12)) {
          node.source = this.finishPlaceholder(placeholder, 'StringLiteral');
          this.semicolon();
          return this.finishNode(node, 'ImportDeclaration');
        }
        const specifier = this.startNodeAtNode(placeholder);
        specifier.local = placeholder;
        node.specifiers.push(
          this.finishNode(specifier, 'ImportDefaultSpecifier')
        );
        if (this.eat(12)) {
          const hasStarImport = this.maybeParseStarImportSpecifier(node);
          if (!hasStarImport) this.parseNamedImportSpecifiers(node);
        }
        this.expectContextual(98);
        node.source = this.parseImportSource();
        this.semicolon();
        return this.finishNode(node, 'ImportDeclaration');
      }
      parseImportSource() {
        return (
          this.parsePlaceholder('StringLiteral') || super.parseImportSource()
        );
      }
      assertNoSpace() {
        if (this.state.start > this.state.lastTokEndLoc.index) {
          this.raise(
            PlaceholderErrors.UnexpectedSpace,
            this.state.lastTokEndLoc
          );
        }
      }
    };
  var v8intrinsic = superClass =>
    class V8IntrinsicMixin extends superClass {
      parseV8Intrinsic() {
        if (this.match(54)) {
          const v8IntrinsicStartLoc = this.state.startLoc;
          const node = this.startNode();
          this.next();
          if (tokenIsIdentifier(this.state.type)) {
            const name = this.parseIdentifierName();
            const identifier = this.createIdentifier(node, name);
            identifier.type = 'V8IntrinsicIdentifier';
            if (this.match(10)) {
              return identifier;
            }
          }
          this.unexpected(v8IntrinsicStartLoc);
        }
      }
      parseExprAtom(refExpressionErrors) {
        return (
          this.parseV8Intrinsic() || super.parseExprAtom(refExpressionErrors)
        );
      }
    };
  const PIPELINE_PROPOSALS = ['minimal', 'fsharp', 'hack', 'smart'];
  const TOPIC_TOKENS = ['^^', '@@', '^', '%', '#'];
  function validatePlugins(pluginsMap) {
    if (pluginsMap.has('decorators')) {
      if (pluginsMap.has('decorators-legacy')) {
        throw new Error(
          'Cannot use the decorators and decorators-legacy plugin together'
        );
      }
      const decoratorsBeforeExport =
        pluginsMap.get('decorators').decoratorsBeforeExport;
      if (
        decoratorsBeforeExport != null &&
        typeof decoratorsBeforeExport !== 'boolean'
      ) {
        throw new Error(
          "'decoratorsBeforeExport' must be a boolean, if specified."
        );
      }
      const allowCallParenthesized =
        pluginsMap.get('decorators').allowCallParenthesized;
      if (
        allowCallParenthesized != null &&
        typeof allowCallParenthesized !== 'boolean'
      ) {
        throw new Error("'allowCallParenthesized' must be a boolean.");
      }
    }
    if (pluginsMap.has('flow') && pluginsMap.has('typescript')) {
      throw new Error('Cannot combine flow and typescript plugins.');
    }
    if (pluginsMap.has('placeholders') && pluginsMap.has('v8intrinsic')) {
      throw new Error('Cannot combine placeholders and v8intrinsic plugins.');
    }
    if (pluginsMap.has('pipelineOperator')) {
      var _pluginsMap$get;
      const proposal = pluginsMap.get('pipelineOperator').proposal;
      if (!PIPELINE_PROPOSALS.includes(proposal)) {
        const proposalList = PIPELINE_PROPOSALS.map(p => `"${p}"`).join(', ');
        throw new Error(
          `"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`
        );
      }
      const tupleSyntaxIsHash =
        ((_pluginsMap$get = pluginsMap.get('recordAndTuple')) == null
          ? void 0
          : _pluginsMap$get.syntaxType) === 'hash';
      if (proposal === 'hack') {
        if (pluginsMap.has('placeholders')) {
          throw new Error(
            'Cannot combine placeholders plugin and Hack-style pipes.'
          );
        }
        if (pluginsMap.has('v8intrinsic')) {
          throw new Error(
            'Cannot combine v8intrinsic plugin and Hack-style pipes.'
          );
        }
        const topicToken = pluginsMap.get('pipelineOperator').topicToken;
        if (!TOPIC_TOKENS.includes(topicToken)) {
          const tokenList = TOPIC_TOKENS.map(t => `"${t}"`).join(', ');
          throw new Error(
            `"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`
          );
        }
        if (topicToken === '#' && tupleSyntaxIsHash) {
          throw new Error(
            `Plugin conflict between \`["pipelineOperator", { proposal: "hack", topicToken: "#" }]\` and \`${JSON.stringify(['recordAndTuple', pluginsMap.get('recordAndTuple')])}\`.`
          );
        }
      } else if (proposal === 'smart' && tupleSyntaxIsHash) {
        throw new Error(
          `Plugin conflict between \`["pipelineOperator", { proposal: "smart" }]\` and \`${JSON.stringify(['recordAndTuple', pluginsMap.get('recordAndTuple')])}\`.`
        );
      }
    }
    if (pluginsMap.has('moduleAttributes')) {
      {
        if (
          pluginsMap.has('importAttributes') ||
          pluginsMap.has('importAssertions')
        ) {
          throw new Error(
            'Cannot combine importAssertions, importAttributes and moduleAttributes plugins.'
          );
        }
        const moduleAttributesVersionPluginOption =
          pluginsMap.get('moduleAttributes').version;
        if (moduleAttributesVersionPluginOption !== 'may-2020') {
          throw new Error(
            "The 'moduleAttributes' plugin requires a 'version' option," +
              ' representing the last proposal update. Currently, the' +
              " only supported value is 'may-2020'."
          );
        }
      }
    }
    if (
      pluginsMap.has('importAttributes') &&
      pluginsMap.has('importAssertions')
    ) {
      throw new Error(
        'Cannot combine importAssertions and importAttributes plugins.'
      );
    }
    if (pluginsMap.has('recordAndTuple')) {
      const syntaxType = pluginsMap.get('recordAndTuple').syntaxType;
      if (syntaxType != null) {
        {
          const RECORD_AND_TUPLE_SYNTAX_TYPES = ['hash', 'bar'];
          if (!RECORD_AND_TUPLE_SYNTAX_TYPES.includes(syntaxType)) {
            throw new Error(
              "The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " +
                RECORD_AND_TUPLE_SYNTAX_TYPES.map(p => `'${p}'`).join(', ')
            );
          }
        }
      }
    }
    if (
      pluginsMap.has('asyncDoExpressions') &&
      !pluginsMap.has('doExpressions')
    ) {
      const error = new Error(
        "'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins."
      );
      error.missingPlugins = 'doExpressions';
      throw error;
    }
    if (
      pluginsMap.has('optionalChainingAssign') &&
      pluginsMap.get('optionalChainingAssign').version !== '2023-07'
    ) {
      throw new Error(
        "The 'optionalChainingAssign' plugin requires a 'version' option," +
          ' representing the last proposal update. Currently, the' +
          " only supported value is '2023-07'."
      );
    }
  }
  const mixinPlugins = {
    estree: estree,
    jsx: jsx,
    flow: flow,
    typescript: typescript,
    v8intrinsic: v8intrinsic,
    placeholders: placeholders,
  };
  const mixinPluginNames = Object.keys(mixinPlugins);
  const defaultOptions = {
    sourceType: 'script',
    sourceFilename: undefined,
    startColumn: 0,
    startLine: 1,
    allowAwaitOutsideFunction: false,
    allowReturnOutsideFunction: false,
    allowNewTargetOutsideFunction: false,
    allowImportExportEverywhere: false,
    allowSuperOutsideMethod: false,
    allowUndeclaredExports: false,
    plugins: [],
    strictMode: null,
    ranges: false,
    tokens: false,
    createImportExpressions: false,
    createParenthesizedExpressions: false,
    errorRecovery: false,
    attachComment: true,
    annexB: true,
  };
  function getOptions(opts) {
    if (opts == null) {
      return Object.assign({}, defaultOptions);
    }
    if (opts.annexB != null && opts.annexB !== false) {
      throw new Error('The `annexB` option can only be set to `false`.');
    }
    const options = {};
    for (const key of Object.keys(defaultOptions)) {
      var _opts$key;
      options[key] =
        (_opts$key = opts[key]) != null ? _opts$key : defaultOptions[key];
    }
    return options;
  }
  class ExpressionParser extends LValParser {
    checkProto(prop, isRecord, protoRef, refExpressionErrors) {
      if (
        prop.type === 'SpreadElement' ||
        this.isObjectMethod(prop) ||
        prop.computed ||
        prop.shorthand
      ) {
        return;
      }
      const key = prop.key;
      const name = key.type === 'Identifier' ? key.name : key.value;
      if (name === '__proto__') {
        if (isRecord) {
          this.raise(Errors.RecordNoProto, key);
          return;
        }
        if (protoRef.used) {
          if (refExpressionErrors) {
            if (refExpressionErrors.doubleProtoLoc === null) {
              refExpressionErrors.doubleProtoLoc = key.loc.start;
            }
          } else {
            this.raise(Errors.DuplicateProto, key);
          }
        }
        protoRef.used = true;
      }
    }
    shouldExitDescending(expr, potentialArrowAt) {
      return (
        expr.type === 'ArrowFunctionExpression' &&
        expr.start === potentialArrowAt
      );
    }
    getExpression() {
      this.enterInitialScopes();
      this.nextToken();
      const expr = this.parseExpression();
      if (!this.match(139)) {
        this.unexpected();
      }
      this.finalizeRemainingComments();
      expr.comments = this.comments;
      expr.errors = this.state.errors;
      if (this.options.tokens) {
        expr.tokens = this.tokens;
      }
      return expr;
    }
    parseExpression(disallowIn, refExpressionErrors) {
      if (disallowIn) {
        return this.disallowInAnd(() =>
          this.parseExpressionBase(refExpressionErrors)
        );
      }
      return this.allowInAnd(() =>
        this.parseExpressionBase(refExpressionErrors)
      );
    }
    parseExpressionBase(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const expr = this.parseMaybeAssign(refExpressionErrors);
      if (this.match(12)) {
        const node = this.startNodeAt(startLoc);
        node.expressions = [expr];
        while (this.eat(12)) {
          node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
        }
        this.toReferencedList(node.expressions);
        return this.finishNode(node, 'SequenceExpression');
      }
      return expr;
    }
    parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
      return this.disallowInAnd(() =>
        this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
      );
    }
    parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
      return this.allowInAnd(() =>
        this.parseMaybeAssign(refExpressionErrors, afterLeftParse)
      );
    }
    setOptionalParametersError(refExpressionErrors, resultError) {
      var _resultError$loc;
      refExpressionErrors.optionalParametersLoc =
        (_resultError$loc = resultError == null ? void 0 : resultError.loc) !=
        null
          ? _resultError$loc
          : this.state.startLoc;
    }
    parseMaybeAssign(refExpressionErrors, afterLeftParse) {
      const startLoc = this.state.startLoc;
      if (this.isContextual(108)) {
        if (this.prodParam.hasYield) {
          let left = this.parseYield();
          if (afterLeftParse) {
            left = afterLeftParse.call(this, left, startLoc);
          }
          return left;
        }
      }
      let ownExpressionErrors;
      if (refExpressionErrors) {
        ownExpressionErrors = false;
      } else {
        refExpressionErrors = new ExpressionErrors();
        ownExpressionErrors = true;
      }
      const {type: type} = this.state;
      if (type === 10 || tokenIsIdentifier(type)) {
        this.state.potentialArrowAt = this.state.start;
      }
      let left = this.parseMaybeConditional(refExpressionErrors);
      if (afterLeftParse) {
        left = afterLeftParse.call(this, left, startLoc);
      }
      if (tokenIsAssignment(this.state.type)) {
        const node = this.startNodeAt(startLoc);
        const operator = this.state.value;
        node.operator = operator;
        if (this.match(29)) {
          this.toAssignable(left, true);
          node.left = left;
          const startIndex = startLoc.index;
          if (
            refExpressionErrors.doubleProtoLoc != null &&
            refExpressionErrors.doubleProtoLoc.index >= startIndex
          ) {
            refExpressionErrors.doubleProtoLoc = null;
          }
          if (
            refExpressionErrors.shorthandAssignLoc != null &&
            refExpressionErrors.shorthandAssignLoc.index >= startIndex
          ) {
            refExpressionErrors.shorthandAssignLoc = null;
          }
          if (
            refExpressionErrors.privateKeyLoc != null &&
            refExpressionErrors.privateKeyLoc.index >= startIndex
          ) {
            this.checkDestructuringPrivate(refExpressionErrors);
            refExpressionErrors.privateKeyLoc = null;
          }
        } else {
          node.left = left;
        }
        this.next();
        node.right = this.parseMaybeAssign();
        this.checkLVal(left, this.finishNode(node, 'AssignmentExpression'));
        return node;
      } else if (ownExpressionErrors) {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      return left;
    }
    parseMaybeConditional(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprOps(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseConditional(expr, startLoc, refExpressionErrors);
    }
    parseConditional(expr, startLoc, refExpressionErrors) {
      if (this.eat(17)) {
        const node = this.startNodeAt(startLoc);
        node.test = expr;
        node.consequent = this.parseMaybeAssignAllowIn();
        this.expect(14);
        node.alternate = this.parseMaybeAssign();
        return this.finishNode(node, 'ConditionalExpression');
      }
      return expr;
    }
    parseMaybeUnaryOrPrivate(refExpressionErrors) {
      return this.match(138)
        ? this.parsePrivateName()
        : this.parseMaybeUnary(refExpressionErrors);
    }
    parseExprOps(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseExprOp(expr, startLoc, -1);
    }
    parseExprOp(left, leftStartLoc, minPrec) {
      if (this.isPrivateName(left)) {
        const value = this.getPrivateNameSV(left);
        if (
          minPrec >= tokenOperatorPrecedence(58) ||
          !this.prodParam.hasIn ||
          !this.match(58)
        ) {
          this.raise(Errors.PrivateInExpectedIn, left, {identifierName: value});
        }
        this.classScope.usePrivateName(value, left.loc.start);
      }
      const op = this.state.type;
      if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
        let prec = tokenOperatorPrecedence(op);
        if (prec > minPrec) {
          if (op === 39) {
            this.expectPlugin('pipelineOperator');
            if (this.state.inFSharpPipelineDirectBody) {
              return left;
            }
            this.checkPipelineAtInfixOperator(left, leftStartLoc);
          }
          const node = this.startNodeAt(leftStartLoc);
          node.left = left;
          node.operator = this.state.value;
          const logical = op === 41 || op === 42;
          const coalesce = op === 40;
          if (coalesce) {
            prec = tokenOperatorPrecedence(42);
          }
          this.next();
          if (
            op === 39 &&
            this.hasPlugin(['pipelineOperator', {proposal: 'minimal'}])
          ) {
            if (this.state.type === 96 && this.prodParam.hasAwait) {
              throw this.raise(
                Errors.UnexpectedAwaitAfterPipelineBody,
                this.state.startLoc
              );
            }
          }
          node.right = this.parseExprOpRightExpr(op, prec);
          const finishedNode = this.finishNode(
            node,
            logical || coalesce ? 'LogicalExpression' : 'BinaryExpression'
          );
          const nextOp = this.state.type;
          if (
            (coalesce && (nextOp === 41 || nextOp === 42)) ||
            (logical && nextOp === 40)
          ) {
            throw this.raise(
              Errors.MixingCoalesceWithLogical,
              this.state.startLoc
            );
          }
          return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
        }
      }
      return left;
    }
    parseExprOpRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      switch (op) {
        case 39:
          switch (this.getPluginOption('pipelineOperator', 'proposal')) {
            case 'hack':
              return this.withTopicBindingContext(() =>
                this.parseHackPipeBody()
              );
            case 'smart':
              return this.withTopicBindingContext(() => {
                if (this.prodParam.hasYield && this.isContextual(108)) {
                  throw this.raise(
                    Errors.PipeBodyIsTighter,
                    this.state.startLoc
                  );
                }
                return this.parseSmartPipelineBodyInStyle(
                  this.parseExprOpBaseRightExpr(op, prec),
                  startLoc
                );
              });
            case 'fsharp':
              return this.withSoloAwaitPermittingContext(() =>
                this.parseFSharpPipelineBody(prec)
              );
          }
        default:
          return this.parseExprOpBaseRightExpr(op, prec);
      }
    }
    parseExprOpBaseRightExpr(op, prec) {
      const startLoc = this.state.startLoc;
      return this.parseExprOp(
        this.parseMaybeUnaryOrPrivate(),
        startLoc,
        tokenIsRightAssociative(op) ? prec - 1 : prec
      );
    }
    parseHackPipeBody() {
      var _body$extra;
      const {startLoc: startLoc} = this.state;
      const body = this.parseMaybeAssign();
      const requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(
        body.type
      );
      if (
        requiredParentheses &&
        !((_body$extra = body.extra) != null && _body$extra.parenthesized)
      ) {
        this.raise(Errors.PipeUnparenthesizedBody, startLoc, {type: body.type});
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipeTopicUnused, startLoc);
      }
      return body;
    }
    checkExponentialAfterUnary(node) {
      if (this.match(57)) {
        this.raise(Errors.UnexpectedTokenUnaryExponentiation, node.argument);
      }
    }
    parseMaybeUnary(refExpressionErrors, sawUnary) {
      const startLoc = this.state.startLoc;
      const isAwait = this.isContextual(96);
      if (isAwait && this.recordAwaitIfAllowed()) {
        this.next();
        const expr = this.parseAwait(startLoc);
        if (!sawUnary) this.checkExponentialAfterUnary(expr);
        return expr;
      }
      const update = this.match(34);
      const node = this.startNode();
      if (tokenIsPrefix(this.state.type)) {
        node.operator = this.state.value;
        node.prefix = true;
        if (this.match(72)) {
          this.expectPlugin('throwExpressions');
        }
        const isDelete = this.match(89);
        this.next();
        node.argument = this.parseMaybeUnary(null, true);
        this.checkExpressionErrors(refExpressionErrors, true);
        if (this.state.strict && isDelete) {
          const arg = node.argument;
          if (arg.type === 'Identifier') {
            this.raise(Errors.StrictDelete, node);
          } else if (this.hasPropertyAsPrivateName(arg)) {
            this.raise(Errors.DeletePrivateField, node);
          }
        }
        if (!update) {
          if (!sawUnary) {
            this.checkExponentialAfterUnary(node);
          }
          return this.finishNode(node, 'UnaryExpression');
        }
      }
      const expr = this.parseUpdate(node, update, refExpressionErrors);
      if (isAwait) {
        const {type: type} = this.state;
        const startsExpr = this.hasPlugin('v8intrinsic')
          ? tokenCanStartExpression(type)
          : tokenCanStartExpression(type) && !this.match(54);
        if (startsExpr && !this.isAmbiguousAwait()) {
          this.raiseOverwrite(Errors.AwaitNotInAsyncContext, startLoc);
          return this.parseAwait(startLoc);
        }
      }
      return expr;
    }
    parseUpdate(node, update, refExpressionErrors) {
      if (update) {
        const updateExpressionNode = node;
        this.checkLVal(
          updateExpressionNode.argument,
          this.finishNode(updateExpressionNode, 'UpdateExpression')
        );
        return node;
      }
      const startLoc = this.state.startLoc;
      let expr = this.parseExprSubscripts(refExpressionErrors);
      if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
      while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
        const node = this.startNodeAt(startLoc);
        node.operator = this.state.value;
        node.prefix = false;
        node.argument = expr;
        this.next();
        this.checkLVal(
          expr,
          (expr = this.finishNode(node, 'UpdateExpression'))
        );
      }
      return expr;
    }
    parseExprSubscripts(refExpressionErrors) {
      const startLoc = this.state.startLoc;
      const potentialArrowAt = this.state.potentialArrowAt;
      const expr = this.parseExprAtom(refExpressionErrors);
      if (this.shouldExitDescending(expr, potentialArrowAt)) {
        return expr;
      }
      return this.parseSubscripts(expr, startLoc);
    }
    parseSubscripts(base, startLoc, noCalls) {
      const state = {
        optionalChainMember: false,
        maybeAsyncArrow: this.atPossibleAsyncArrow(base),
        stop: false,
      };
      do {
        base = this.parseSubscript(base, startLoc, noCalls, state);
        state.maybeAsyncArrow = false;
      } while (!state.stop);
      return base;
    }
    parseSubscript(base, startLoc, noCalls, state) {
      const {type: type} = this.state;
      if (!noCalls && type === 15) {
        return this.parseBind(base, startLoc, noCalls, state);
      } else if (tokenIsTemplate(type)) {
        return this.parseTaggedTemplateExpression(base, startLoc, state);
      }
      let optional = false;
      if (type === 18) {
        if (noCalls) {
          this.raise(Errors.OptionalChainingNoNew, this.state.startLoc);
          if (this.lookaheadCharCode() === 40) {
            state.stop = true;
            return base;
          }
        }
        state.optionalChainMember = optional = true;
        this.next();
      }
      if (!noCalls && this.match(10)) {
        return this.parseCoverCallAndAsyncArrowHead(
          base,
          startLoc,
          state,
          optional
        );
      } else {
        const computed = this.eat(0);
        if (computed || optional || this.eat(16)) {
          return this.parseMember(base, startLoc, state, computed, optional);
        } else {
          state.stop = true;
          return base;
        }
      }
    }
    parseMember(base, startLoc, state, computed, optional) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      node.computed = computed;
      if (computed) {
        node.property = this.parseExpression();
        this.expect(3);
      } else if (this.match(138)) {
        if (base.type === 'Super') {
          this.raise(Errors.SuperPrivateField, startLoc);
        }
        this.classScope.usePrivateName(this.state.value, this.state.startLoc);
        node.property = this.parsePrivateName();
      } else {
        node.property = this.parseIdentifier(true);
      }
      if (state.optionalChainMember) {
        node.optional = optional;
        return this.finishNode(node, 'OptionalMemberExpression');
      } else {
        return this.finishNode(node, 'MemberExpression');
      }
    }
    parseBind(base, startLoc, noCalls, state) {
      const node = this.startNodeAt(startLoc);
      node.object = base;
      this.next();
      node.callee = this.parseNoCallExpr();
      state.stop = true;
      return this.parseSubscripts(
        this.finishNode(node, 'BindExpression'),
        startLoc,
        noCalls
      );
    }
    parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      let refExpressionErrors = null;
      this.state.maybeInArrowParameters = true;
      this.next();
      const node = this.startNodeAt(startLoc);
      node.callee = base;
      const {
        maybeAsyncArrow: maybeAsyncArrow,
        optionalChainMember: optionalChainMember,
      } = state;
      if (maybeAsyncArrow) {
        this.expressionScope.enter(newAsyncArrowScope());
        refExpressionErrors = new ExpressionErrors();
      }
      if (optionalChainMember) {
        node.optional = optional;
      }
      if (optional) {
        node.arguments = this.parseCallExpressionArguments(11);
      } else {
        node.arguments = this.parseCallExpressionArguments(
          11,
          base.type === 'Import',
          base.type !== 'Super',
          node,
          refExpressionErrors
        );
      }
      let finishedNode = this.finishCallExpression(node, optionalChainMember);
      if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
        state.stop = true;
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        finishedNode = this.parseAsyncArrowFromCallExpression(
          this.startNodeAt(startLoc),
          finishedNode
        );
      } else {
        if (maybeAsyncArrow) {
          this.checkExpressionErrors(refExpressionErrors, true);
          this.expressionScope.exit();
        }
        this.toReferencedArguments(finishedNode);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return finishedNode;
    }
    toReferencedArguments(node, isParenthesizedExpr) {
      this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
    }
    parseTaggedTemplateExpression(base, startLoc, state) {
      const node = this.startNodeAt(startLoc);
      node.tag = base;
      node.quasi = this.parseTemplate(true);
      if (state.optionalChainMember) {
        this.raise(Errors.OptionalChainingNoTemplate, startLoc);
      }
      return this.finishNode(node, 'TaggedTemplateExpression');
    }
    atPossibleAsyncArrow(base) {
      return (
        base.type === 'Identifier' &&
        base.name === 'async' &&
        this.state.lastTokEndLoc.index === base.end &&
        !this.canInsertSemicolon() &&
        base.end - base.start === 5 &&
        base.start === this.state.potentialArrowAt
      );
    }
    expectImportAttributesPlugin() {
      if (!this.hasPlugin('importAssertions')) {
        this.expectPlugin('importAttributes');
      }
    }
    finishCallExpression(node, optional) {
      if (node.callee.type === 'Import') {
        if (node.arguments.length === 2) {
          {
            if (!this.hasPlugin('moduleAttributes')) {
              this.expectImportAttributesPlugin();
            }
          }
        }
        if (node.arguments.length === 0 || node.arguments.length > 2) {
          this.raise(Errors.ImportCallArity, node, {
            maxArgumentCount:
              this.hasPlugin('importAttributes') ||
              this.hasPlugin('importAssertions') ||
              this.hasPlugin('moduleAttributes')
                ? 2
                : 1,
          });
        } else {
          for (const arg of node.arguments) {
            if (arg.type === 'SpreadElement') {
              this.raise(Errors.ImportCallSpreadArgument, arg);
            }
          }
        }
      }
      return this.finishNode(
        node,
        optional ? 'OptionalCallExpression' : 'CallExpression'
      );
    }
    parseCallExpressionArguments(
      close,
      dynamicImport,
      allowPlaceholder,
      nodeForExtra,
      refExpressionErrors
    ) {
      const elts = [];
      let first = true;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (
              dynamicImport &&
              !this.hasPlugin('importAttributes') &&
              !this.hasPlugin('importAssertions') &&
              !this.hasPlugin('moduleAttributes')
            ) {
              this.raise(
                Errors.ImportCallArgumentTrailingComma,
                this.state.lastTokStartLoc
              );
            }
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(
          this.parseExprListItem(false, refExpressionErrors, allowPlaceholder)
        );
      }
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return elts;
    }
    shouldParseAsyncArrow() {
      return this.match(19) && !this.canInsertSemicolon();
    }
    parseAsyncArrowFromCallExpression(node, call) {
      var _call$extra;
      this.resetPreviousNodeTrailingComments(call);
      this.expect(19);
      this.parseArrowExpression(
        node,
        call.arguments,
        true,
        (_call$extra = call.extra) == null
          ? void 0
          : _call$extra.trailingCommaLoc
      );
      if (call.innerComments) {
        setInnerComments(node, call.innerComments);
      }
      if (call.callee.trailingComments) {
        setInnerComments(node, call.callee.trailingComments);
      }
      return node;
    }
    parseNoCallExpr() {
      const startLoc = this.state.startLoc;
      return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
    }
    parseExprAtom(refExpressionErrors) {
      let node;
      let decorators = null;
      const {type: type} = this.state;
      switch (type) {
        case 79:
          return this.parseSuper();
        case 83:
          node = this.startNode();
          this.next();
          if (this.match(16)) {
            return this.parseImportMetaProperty(node);
          }
          if (this.match(10)) {
            if (this.options.createImportExpressions) {
              return this.parseImportCall(node);
            } else {
              return this.finishNode(node, 'Import');
            }
          } else {
            this.raise(Errors.UnsupportedImport, this.state.lastTokStartLoc);
            return this.finishNode(node, 'Import');
          }
        case 78:
          node = this.startNode();
          this.next();
          return this.finishNode(node, 'ThisExpression');
        case 90: {
          return this.parseDo(this.startNode(), false);
        }
        case 56:
        case 31: {
          this.readRegexp();
          return this.parseRegExpLiteral(this.state.value);
        }
        case 134:
          return this.parseNumericLiteral(this.state.value);
        case 135:
          return this.parseBigIntLiteral(this.state.value);
        case 136:
          return this.parseDecimalLiteral(this.state.value);
        case 133:
          return this.parseStringLiteral(this.state.value);
        case 84:
          return this.parseNullLiteral();
        case 85:
          return this.parseBooleanLiteral(true);
        case 86:
          return this.parseBooleanLiteral(false);
        case 10: {
          const canBeArrow = this.state.potentialArrowAt === this.state.start;
          return this.parseParenAndDistinguishExpression(canBeArrow);
        }
        case 2:
        case 1: {
          return this.parseArrayLike(
            this.state.type === 2 ? 4 : 3,
            false,
            true
          );
        }
        case 0: {
          return this.parseArrayLike(3, true, false, refExpressionErrors);
        }
        case 6:
        case 7: {
          return this.parseObjectLike(
            this.state.type === 6 ? 9 : 8,
            false,
            true
          );
        }
        case 5: {
          return this.parseObjectLike(8, false, false, refExpressionErrors);
        }
        case 68:
          return this.parseFunctionOrFunctionSent();
        case 26:
          decorators = this.parseDecorators();
        case 80:
          return this.parseClass(
            this.maybeTakeDecorators(decorators, this.startNode()),
            false
          );
        case 77:
          return this.parseNewOrNewTarget();
        case 25:
        case 24:
          return this.parseTemplate(false);
        case 15: {
          node = this.startNode();
          this.next();
          node.object = null;
          const callee = (node.callee = this.parseNoCallExpr());
          if (callee.type === 'MemberExpression') {
            return this.finishNode(node, 'BindExpression');
          } else {
            throw this.raise(Errors.UnsupportedBind, callee);
          }
        }
        case 138: {
          this.raise(Errors.PrivateInExpectedIn, this.state.startLoc, {
            identifierName: this.state.value,
          });
          return this.parsePrivateName();
        }
        case 33: {
          return this.parseTopicReferenceThenEqualsSign(54, '%');
        }
        case 32: {
          return this.parseTopicReferenceThenEqualsSign(44, '^');
        }
        case 37:
        case 38: {
          return this.parseTopicReference('hack');
        }
        case 44:
        case 54:
        case 27: {
          const pipeProposal = this.getPluginOption(
            'pipelineOperator',
            'proposal'
          );
          if (pipeProposal) {
            return this.parseTopicReference(pipeProposal);
          }
          this.unexpected();
          break;
        }
        case 47: {
          const lookaheadCh = this.input.codePointAt(this.nextTokenStart());
          if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
            this.expectOnePlugin(['jsx', 'flow', 'typescript']);
          } else {
            this.unexpected();
          }
          break;
        }
        default:
          if (tokenIsIdentifier(type)) {
            if (
              this.isContextual(127) &&
              this.lookaheadInLineCharCode() === 123
            ) {
              return this.parseModuleExpression();
            }
            const canBeArrow = this.state.potentialArrowAt === this.state.start;
            const containsEsc = this.state.containsEsc;
            const id = this.parseIdentifier();
            if (
              !containsEsc &&
              id.name === 'async' &&
              !this.canInsertSemicolon()
            ) {
              const {type: type} = this.state;
              if (type === 68) {
                this.resetPreviousNodeTrailingComments(id);
                this.next();
                return this.parseAsyncFunctionExpression(
                  this.startNodeAtNode(id)
                );
              } else if (tokenIsIdentifier(type)) {
                if (this.lookaheadCharCode() === 61) {
                  return this.parseAsyncArrowUnaryFunction(
                    this.startNodeAtNode(id)
                  );
                } else {
                  return id;
                }
              } else if (type === 90) {
                this.resetPreviousNodeTrailingComments(id);
                return this.parseDo(this.startNodeAtNode(id), true);
              }
            }
            if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
              this.next();
              return this.parseArrowExpression(
                this.startNodeAtNode(id),
                [id],
                false
              );
            }
            return id;
          } else {
            this.unexpected();
          }
      }
    }
    parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
      const pipeProposal = this.getPluginOption('pipelineOperator', 'proposal');
      if (pipeProposal) {
        this.state.type = topicTokenType;
        this.state.value = topicTokenValue;
        this.state.pos--;
        this.state.end--;
        this.state.endLoc = createPositionWithColumnOffset(
          this.state.endLoc,
          -1
        );
        return this.parseTopicReference(pipeProposal);
      } else {
        this.unexpected();
      }
    }
    parseTopicReference(pipeProposal) {
      const node = this.startNode();
      const startLoc = this.state.startLoc;
      const tokenType = this.state.type;
      this.next();
      return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
    }
    finishTopicReference(node, startLoc, pipeProposal, tokenType) {
      if (
        this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)
      ) {
        const nodeType =
          pipeProposal === 'smart'
            ? 'PipelinePrimaryTopicReference'
            : 'TopicReference';
        if (!this.topicReferenceIsAllowedInCurrentContext()) {
          this.raise(
            pipeProposal === 'smart'
              ? Errors.PrimaryTopicNotAllowed
              : Errors.PipeTopicUnbound,
            startLoc
          );
        }
        this.registerTopicReference();
        return this.finishNode(node, nodeType);
      } else {
        throw this.raise(Errors.PipeTopicUnconfiguredToken, startLoc, {
          token: tokenLabelName(tokenType),
        });
      }
    }
    testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
      switch (pipeProposal) {
        case 'hack': {
          return this.hasPlugin([
            'pipelineOperator',
            {topicToken: tokenLabelName(tokenType)},
          ]);
        }
        case 'smart':
          return tokenType === 27;
        default:
          throw this.raise(Errors.PipeTopicRequiresHackPipes, startLoc);
      }
    }
    parseAsyncArrowUnaryFunction(node) {
      this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
      const params = [this.parseIdentifier()];
      this.prodParam.exit();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.LineTerminatorBeforeArrow, this.state.curPosition());
      }
      this.expect(19);
      return this.parseArrowExpression(node, params, true);
    }
    parseDo(node, isAsync) {
      this.expectPlugin('doExpressions');
      if (isAsync) {
        this.expectPlugin('asyncDoExpressions');
      }
      node.async = isAsync;
      this.next();
      const oldLabels = this.state.labels;
      this.state.labels = [];
      if (isAsync) {
        this.prodParam.enter(2);
        node.body = this.parseBlock();
        this.prodParam.exit();
      } else {
        node.body = this.parseBlock();
      }
      this.state.labels = oldLabels;
      return this.finishNode(node, 'DoExpression');
    }
    parseSuper() {
      const node = this.startNode();
      this.next();
      if (
        this.match(10) &&
        !this.scope.allowDirectSuper &&
        !this.options.allowSuperOutsideMethod
      ) {
        this.raise(Errors.SuperNotAllowed, node);
      } else if (
        !this.scope.allowSuper &&
        !this.options.allowSuperOutsideMethod
      ) {
        this.raise(Errors.UnexpectedSuper, node);
      }
      if (!this.match(10) && !this.match(0) && !this.match(16)) {
        this.raise(Errors.UnsupportedSuper, node);
      }
      return this.finishNode(node, 'Super');
    }
    parsePrivateName() {
      const node = this.startNode();
      const id = this.startNodeAt(
        createPositionWithColumnOffset(this.state.startLoc, 1)
      );
      const name = this.state.value;
      this.next();
      node.id = this.createIdentifier(id, name);
      return this.finishNode(node, 'PrivateName');
    }
    parseFunctionOrFunctionSent() {
      const node = this.startNode();
      this.next();
      if (this.prodParam.hasYield && this.match(16)) {
        const meta = this.createIdentifier(
          this.startNodeAtNode(node),
          'function'
        );
        this.next();
        if (this.match(103)) {
          this.expectPlugin('functionSent');
        } else if (!this.hasPlugin('functionSent')) {
          this.unexpected();
        }
        return this.parseMetaProperty(node, meta, 'sent');
      }
      return this.parseFunction(node);
    }
    parseMetaProperty(node, meta, propertyName) {
      node.meta = meta;
      const containsEsc = this.state.containsEsc;
      node.property = this.parseIdentifier(true);
      if (node.property.name !== propertyName || containsEsc) {
        this.raise(Errors.UnsupportedMetaProperty, node.property, {
          target: meta.name,
          onlyValidPropertyName: propertyName,
        });
      }
      return this.finishNode(node, 'MetaProperty');
    }
    parseImportMetaProperty(node) {
      const id = this.createIdentifier(this.startNodeAtNode(node), 'import');
      this.next();
      if (this.isContextual(101)) {
        if (!this.inModule) {
          this.raise(Errors.ImportMetaOutsideModule, id);
        }
        this.sawUnambiguousESM = true;
      } else if (this.isContextual(105) || this.isContextual(97)) {
        const isSource = this.isContextual(105);
        if (!isSource) this.unexpected();
        this.expectPlugin(
          isSource ? 'sourcePhaseImports' : 'deferredImportEvaluation'
        );
        if (!this.options.createImportExpressions) {
          throw this.raise(
            Errors.DynamicImportPhaseRequiresImportExpressions,
            this.state.startLoc,
            {phase: this.state.value}
          );
        }
        this.next();
        node.phase = isSource ? 'source' : 'defer';
        return this.parseImportCall(node);
      }
      return this.parseMetaProperty(node, id, 'meta');
    }
    parseLiteralAtNode(value, type, node) {
      this.addExtra(node, 'rawValue', value);
      this.addExtra(node, 'raw', this.input.slice(node.start, this.state.end));
      node.value = value;
      this.next();
      return this.finishNode(node, type);
    }
    parseLiteral(value, type) {
      const node = this.startNode();
      return this.parseLiteralAtNode(value, type, node);
    }
    parseStringLiteral(value) {
      return this.parseLiteral(value, 'StringLiteral');
    }
    parseNumericLiteral(value) {
      return this.parseLiteral(value, 'NumericLiteral');
    }
    parseBigIntLiteral(value) {
      return this.parseLiteral(value, 'BigIntLiteral');
    }
    parseDecimalLiteral(value) {
      return this.parseLiteral(value, 'DecimalLiteral');
    }
    parseRegExpLiteral(value) {
      const node = this.startNode();
      this.addExtra(node, 'raw', this.input.slice(node.start, this.state.end));
      node.pattern = value.pattern;
      node.flags = value.flags;
      this.next();
      return this.finishNode(node, 'RegExpLiteral');
    }
    parseBooleanLiteral(value) {
      const node = this.startNode();
      node.value = value;
      this.next();
      return this.finishNode(node, 'BooleanLiteral');
    }
    parseNullLiteral() {
      const node = this.startNode();
      this.next();
      return this.finishNode(node, 'NullLiteral');
    }
    parseParenAndDistinguishExpression(canBeArrow) {
      const startLoc = this.state.startLoc;
      let val;
      this.next();
      this.expressionScope.enter(newArrowHeadScope());
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.maybeInArrowParameters = true;
      this.state.inFSharpPipelineDirectBody = false;
      const innerStartLoc = this.state.startLoc;
      const exprList = [];
      const refExpressionErrors = new ExpressionErrors();
      let first = true;
      let spreadStartLoc;
      let optionalCommaStartLoc;
      while (!this.match(11)) {
        if (first) {
          first = false;
        } else {
          this.expect(
            12,
            refExpressionErrors.optionalParametersLoc === null
              ? null
              : refExpressionErrors.optionalParametersLoc
          );
          if (this.match(11)) {
            optionalCommaStartLoc = this.state.startLoc;
            break;
          }
        }
        if (this.match(21)) {
          const spreadNodeStartLoc = this.state.startLoc;
          spreadStartLoc = this.state.startLoc;
          exprList.push(
            this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc)
          );
          if (!this.checkCommaAfterRest(41)) {
            break;
          }
        } else {
          exprList.push(
            this.parseMaybeAssignAllowIn(
              refExpressionErrors,
              this.parseParenItem
            )
          );
        }
      }
      const innerEndLoc = this.state.lastTokEndLoc;
      this.expect(11);
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let arrowNode = this.startNodeAt(startLoc);
      if (
        canBeArrow &&
        this.shouldParseArrow(exprList) &&
        (arrowNode = this.parseArrow(arrowNode))
      ) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.expressionScope.validateAsPattern();
        this.expressionScope.exit();
        this.parseArrowExpression(arrowNode, exprList, false);
        return arrowNode;
      }
      this.expressionScope.exit();
      if (!exprList.length) {
        this.unexpected(this.state.lastTokStartLoc);
      }
      if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
      if (spreadStartLoc) this.unexpected(spreadStartLoc);
      this.checkExpressionErrors(refExpressionErrors, true);
      this.toReferencedListDeep(exprList, true);
      if (exprList.length > 1) {
        val = this.startNodeAt(innerStartLoc);
        val.expressions = exprList;
        this.finishNode(val, 'SequenceExpression');
        this.resetEndLocation(val, innerEndLoc);
      } else {
        val = exprList[0];
      }
      return this.wrapParenthesis(startLoc, val);
    }
    wrapParenthesis(startLoc, expression) {
      if (!this.options.createParenthesizedExpressions) {
        this.addExtra(expression, 'parenthesized', true);
        this.addExtra(expression, 'parenStart', startLoc.index);
        this.takeSurroundingComments(
          expression,
          startLoc.index,
          this.state.lastTokEndLoc.index
        );
        return expression;
      }
      const parenExpression = this.startNodeAt(startLoc);
      parenExpression.expression = expression;
      return this.finishNode(parenExpression, 'ParenthesizedExpression');
    }
    shouldParseArrow(params) {
      return !this.canInsertSemicolon();
    }
    parseArrow(node) {
      if (this.eat(19)) {
        return node;
      }
    }
    parseParenItem(node, startLoc) {
      return node;
    }
    parseNewOrNewTarget() {
      const node = this.startNode();
      this.next();
      if (this.match(16)) {
        const meta = this.createIdentifier(this.startNodeAtNode(node), 'new');
        this.next();
        const metaProp = this.parseMetaProperty(node, meta, 'target');
        if (
          !this.scope.inNonArrowFunction &&
          !this.scope.inClass &&
          !this.options.allowNewTargetOutsideFunction
        ) {
          this.raise(Errors.UnexpectedNewTarget, metaProp);
        }
        return metaProp;
      }
      return this.parseNew(node);
    }
    parseNew(node) {
      this.parseNewCallee(node);
      if (this.eat(10)) {
        const args = this.parseExprList(11);
        this.toReferencedList(args);
        node.arguments = args;
      } else {
        node.arguments = [];
      }
      return this.finishNode(node, 'NewExpression');
    }
    parseNewCallee(node) {
      const isImport = this.match(83);
      const callee = this.parseNoCallExpr();
      node.callee = callee;
      if (
        isImport &&
        (callee.type === 'Import' || callee.type === 'ImportExpression')
      ) {
        this.raise(Errors.ImportCallNotNewExpression, callee);
      }
    }
    parseTemplateElement(isTagged) {
      const {
        start: start,
        startLoc: startLoc,
        end: end,
        value: value,
      } = this.state;
      const elemStart = start + 1;
      const elem = this.startNodeAt(
        createPositionWithColumnOffset(startLoc, 1)
      );
      if (value === null) {
        if (!isTagged) {
          this.raise(
            Errors.InvalidEscapeSequenceTemplate,
            createPositionWithColumnOffset(
              this.state.firstInvalidTemplateEscapePos,
              1
            )
          );
        }
      }
      const isTail = this.match(24);
      const endOffset = isTail ? -1 : -2;
      const elemEnd = end + endOffset;
      elem.value = {
        raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, '\n'),
        cooked: value === null ? null : value.slice(1, endOffset),
      };
      elem.tail = isTail;
      this.next();
      const finishedNode = this.finishNode(elem, 'TemplateElement');
      this.resetEndLocation(
        finishedNode,
        createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset)
      );
      return finishedNode;
    }
    parseTemplate(isTagged) {
      const node = this.startNode();
      let curElt = this.parseTemplateElement(isTagged);
      const quasis = [curElt];
      const substitutions = [];
      while (!curElt.tail) {
        substitutions.push(this.parseTemplateSubstitution());
        this.readTemplateContinuation();
        quasis.push((curElt = this.parseTemplateElement(isTagged)));
      }
      node.expressions = substitutions;
      node.quasis = quasis;
      return this.finishNode(node, 'TemplateLiteral');
    }
    parseTemplateSubstitution() {
      return this.parseExpression();
    }
    parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
      if (isRecord) {
        this.expectPlugin('recordAndTuple');
      }
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const propHash = Object.create(null);
      let first = true;
      const node = this.startNode();
      node.properties = [];
      this.next();
      while (!this.match(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            this.addTrailingCommaExtraToNode(node);
            break;
          }
        }
        let prop;
        if (isPattern) {
          prop = this.parseBindingProperty();
        } else {
          prop = this.parsePropertyDefinition(refExpressionErrors);
          this.checkProto(prop, isRecord, propHash, refExpressionErrors);
        }
        if (
          isRecord &&
          !this.isObjectProperty(prop) &&
          prop.type !== 'SpreadElement'
        ) {
          this.raise(Errors.InvalidRecordProperty, prop);
        }
        {
          if (prop.shorthand) {
            this.addExtra(prop, 'shorthand', true);
          }
        }
        node.properties.push(prop);
      }
      this.next();
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      let type = 'ObjectExpression';
      if (isPattern) {
        type = 'ObjectPattern';
      } else if (isRecord) {
        type = 'RecordExpression';
      }
      return this.finishNode(node, type);
    }
    addTrailingCommaExtraToNode(node) {
      this.addExtra(node, 'trailingComma', this.state.lastTokStartLoc.index);
      this.addExtra(
        node,
        'trailingCommaLoc',
        this.state.lastTokStartLoc,
        false
      );
    }
    maybeAsyncOrAccessorProp(prop) {
      return (
        !prop.computed &&
        prop.key.type === 'Identifier' &&
        (this.isLiteralPropertyName() || this.match(0) || this.match(55))
      );
    }
    parsePropertyDefinition(refExpressionErrors) {
      let decorators = [];
      if (this.match(26)) {
        if (this.hasPlugin('decorators')) {
          this.raise(Errors.UnsupportedPropertyDecorator, this.state.startLoc);
        }
        while (this.match(26)) {
          decorators.push(this.parseDecorator());
        }
      }
      const prop = this.startNode();
      let isAsync = false;
      let isAccessor = false;
      let startLoc;
      if (this.match(21)) {
        if (decorators.length) this.unexpected();
        return this.parseSpread();
      }
      if (decorators.length) {
        prop.decorators = decorators;
        decorators = [];
      }
      prop.method = false;
      if (refExpressionErrors) {
        startLoc = this.state.startLoc;
      }
      let isGenerator = this.eat(55);
      this.parsePropertyNamePrefixOperator(prop);
      const containsEsc = this.state.containsEsc;
      this.parsePropertyName(prop, refExpressionErrors);
      if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
        const {key: key} = prop;
        const keyName = key.name;
        if (keyName === 'async' && !this.hasPrecedingLineBreak()) {
          isAsync = true;
          this.resetPreviousNodeTrailingComments(key);
          isGenerator = this.eat(55);
          this.parsePropertyName(prop);
        }
        if (keyName === 'get' || keyName === 'set') {
          isAccessor = true;
          this.resetPreviousNodeTrailingComments(key);
          prop.kind = keyName;
          if (this.match(55)) {
            isGenerator = true;
            this.raise(Errors.AccessorIsGenerator, this.state.curPosition(), {
              kind: keyName,
            });
            this.next();
          }
          this.parsePropertyName(prop);
        }
      }
      return this.parseObjPropValue(
        prop,
        startLoc,
        isGenerator,
        isAsync,
        false,
        isAccessor,
        refExpressionErrors
      );
    }
    getGetterSetterExpectedParamCount(method) {
      return method.kind === 'get' ? 0 : 1;
    }
    getObjectOrClassMethodParams(method) {
      return method.params;
    }
    checkGetterSetterParams(method) {
      var _params;
      const paramCount = this.getGetterSetterExpectedParamCount(method);
      const params = this.getObjectOrClassMethodParams(method);
      if (params.length !== paramCount) {
        this.raise(
          method.kind === 'get' ? Errors.BadGetterArity : Errors.BadSetterArity,
          method
        );
      }
      if (
        method.kind === 'set' &&
        ((_params = params[params.length - 1]) == null
          ? void 0
          : _params.type) === 'RestElement'
      ) {
        this.raise(Errors.BadSetterRestParameter, method);
      }
    }
    parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
      if (isAccessor) {
        const finishedProp = this.parseMethod(
          prop,
          isGenerator,
          false,
          false,
          false,
          'ObjectMethod'
        );
        this.checkGetterSetterParams(finishedProp);
        return finishedProp;
      }
      if (isAsync || isGenerator || this.match(10)) {
        if (isPattern) this.unexpected();
        prop.kind = 'method';
        prop.method = true;
        return this.parseMethod(
          prop,
          isGenerator,
          isAsync,
          false,
          false,
          'ObjectMethod'
        );
      }
    }
    parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
      prop.shorthand = false;
      if (this.eat(14)) {
        prop.value = isPattern
          ? this.parseMaybeDefault(this.state.startLoc)
          : this.parseMaybeAssignAllowIn(refExpressionErrors);
        return this.finishNode(prop, 'ObjectProperty');
      }
      if (!prop.computed && prop.key.type === 'Identifier') {
        this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
        if (isPattern) {
          prop.value = this.parseMaybeDefault(
            startLoc,
            cloneIdentifier(prop.key)
          );
        } else if (this.match(29)) {
          const shorthandAssignLoc = this.state.startLoc;
          if (refExpressionErrors != null) {
            if (refExpressionErrors.shorthandAssignLoc === null) {
              refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
            }
          } else {
            this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
          }
          prop.value = this.parseMaybeDefault(
            startLoc,
            cloneIdentifier(prop.key)
          );
        } else {
          prop.value = cloneIdentifier(prop.key);
        }
        prop.shorthand = true;
        return this.finishNode(prop, 'ObjectProperty');
      }
    }
    parseObjPropValue(
      prop,
      startLoc,
      isGenerator,
      isAsync,
      isPattern,
      isAccessor,
      refExpressionErrors
    ) {
      const node =
        this.parseObjectMethod(
          prop,
          isGenerator,
          isAsync,
          isPattern,
          isAccessor
        ) ||
        this.parseObjectProperty(
          prop,
          startLoc,
          isPattern,
          refExpressionErrors
        );
      if (!node) this.unexpected();
      return node;
    }
    parsePropertyName(prop, refExpressionErrors) {
      if (this.eat(0)) {
        prop.computed = true;
        prop.key = this.parseMaybeAssignAllowIn();
        this.expect(3);
      } else {
        const {type: type, value: value} = this.state;
        let key;
        if (tokenIsKeywordOrIdentifier(type)) {
          key = this.parseIdentifier(true);
        } else {
          switch (type) {
            case 134:
              key = this.parseNumericLiteral(value);
              break;
            case 133:
              key = this.parseStringLiteral(value);
              break;
            case 135:
              key = this.parseBigIntLiteral(value);
              break;
            case 136:
              key = this.parseDecimalLiteral(value);
              break;
            case 138: {
              const privateKeyLoc = this.state.startLoc;
              if (refExpressionErrors != null) {
                if (refExpressionErrors.privateKeyLoc === null) {
                  refExpressionErrors.privateKeyLoc = privateKeyLoc;
                }
              } else {
                this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
              }
              key = this.parsePrivateName();
              break;
            }
            default:
              this.unexpected();
          }
        }
        prop.key = key;
        if (type !== 138) {
          prop.computed = false;
        }
      }
    }
    initFunction(node, isAsync) {
      node.id = null;
      node.generator = false;
      node.async = isAsync;
    }
    parseMethod(
      node,
      isGenerator,
      isAsync,
      isConstructor,
      allowDirectSuper,
      type,
      inClassScope = false
    ) {
      this.initFunction(node, isAsync);
      node.generator = isGenerator;
      this.scope.enter(
        2 | 16 | (inClassScope ? 64 : 0) | (allowDirectSuper ? 32 : 0)
      );
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      this.parseFunctionParams(node, isConstructor);
      const finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
      this.prodParam.exit();
      this.scope.exit();
      return finishedNode;
    }
    parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
      if (isTuple) {
        this.expectPlugin('recordAndTuple');
      }
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = false;
      const node = this.startNode();
      this.next();
      node.elements = this.parseExprList(
        close,
        !isTuple,
        refExpressionErrors,
        node
      );
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return this.finishNode(
        node,
        isTuple ? 'TupleExpression' : 'ArrayExpression'
      );
    }
    parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
      this.scope.enter(2 | 4);
      let flags = functionFlags(isAsync, false);
      if (!this.match(5) && this.prodParam.hasIn) {
        flags |= 8;
      }
      this.prodParam.enter(flags);
      this.initFunction(node, isAsync);
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      if (params) {
        this.state.maybeInArrowParameters = true;
        this.setArrowFunctionParameters(node, params, trailingCommaLoc);
      }
      this.state.maybeInArrowParameters = false;
      this.parseFunctionBody(node, true);
      this.prodParam.exit();
      this.scope.exit();
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return this.finishNode(node, 'ArrowFunctionExpression');
    }
    setArrowFunctionParameters(node, params, trailingCommaLoc) {
      this.toAssignableList(params, trailingCommaLoc, false);
      node.params = params;
    }
    parseFunctionBodyAndFinish(node, type, isMethod = false) {
      this.parseFunctionBody(node, false, isMethod);
      return this.finishNode(node, type);
    }
    parseFunctionBody(node, allowExpression, isMethod = false) {
      const isExpression = allowExpression && !this.match(5);
      this.expressionScope.enter(newExpressionScope());
      if (isExpression) {
        node.body = this.parseMaybeAssign();
        this.checkParams(node, false, allowExpression, false);
      } else {
        const oldStrict = this.state.strict;
        const oldLabels = this.state.labels;
        this.state.labels = [];
        this.prodParam.enter(this.prodParam.currentFlags() | 4);
        node.body = this.parseBlock(true, false, hasStrictModeDirective => {
          const nonSimple = !this.isSimpleParamList(node.params);
          if (hasStrictModeDirective && nonSimple) {
            this.raise(
              Errors.IllegalLanguageModeDirective,
              (node.kind === 'method' || node.kind === 'constructor') &&
                !!node.key
                ? node.key.loc.end
                : node
            );
          }
          const strictModeChanged = !oldStrict && this.state.strict;
          this.checkParams(
            node,
            !this.state.strict && !allowExpression && !isMethod && !nonSimple,
            allowExpression,
            strictModeChanged
          );
          if (this.state.strict && node.id) {
            this.checkIdentifier(node.id, 65, strictModeChanged);
          }
        });
        this.prodParam.exit();
        this.state.labels = oldLabels;
      }
      this.expressionScope.exit();
    }
    isSimpleParameter(node) {
      return node.type === 'Identifier';
    }
    isSimpleParamList(params) {
      for (let i = 0, len = params.length; i < len; i++) {
        if (!this.isSimpleParameter(params[i])) return false;
      }
      return true;
    }
    checkParams(
      node,
      allowDuplicates,
      isArrowFunction,
      strictModeChanged = true
    ) {
      const checkClashes = !allowDuplicates && new Set();
      const formalParameters = {type: 'FormalParameters'};
      for (const param of node.params) {
        this.checkLVal(
          param,
          formalParameters,
          5,
          checkClashes,
          strictModeChanged
        );
      }
    }
    parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
      const elts = [];
      let first = true;
      while (!this.eat(close)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.match(close)) {
            if (nodeForExtra) {
              this.addTrailingCommaExtraToNode(nodeForExtra);
            }
            this.next();
            break;
          }
        }
        elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
      }
      return elts;
    }
    parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
      let elt;
      if (this.match(12)) {
        if (!allowEmpty) {
          this.raise(Errors.UnexpectedToken, this.state.curPosition(), {
            unexpected: ',',
          });
        }
        elt = null;
      } else if (this.match(21)) {
        const spreadNodeStartLoc = this.state.startLoc;
        elt = this.parseParenItem(
          this.parseSpread(refExpressionErrors),
          spreadNodeStartLoc
        );
      } else if (this.match(17)) {
        this.expectPlugin('partialApplication');
        if (!allowPlaceholder) {
          this.raise(Errors.UnexpectedArgumentPlaceholder, this.state.startLoc);
        }
        const node = this.startNode();
        this.next();
        elt = this.finishNode(node, 'ArgumentPlaceholder');
      } else {
        elt = this.parseMaybeAssignAllowIn(
          refExpressionErrors,
          this.parseParenItem
        );
      }
      return elt;
    }
    parseIdentifier(liberal) {
      const node = this.startNode();
      const name = this.parseIdentifierName(liberal);
      return this.createIdentifier(node, name);
    }
    createIdentifier(node, name) {
      node.name = name;
      node.loc.identifierName = name;
      return this.finishNode(node, 'Identifier');
    }
    parseIdentifierName(liberal) {
      let name;
      const {startLoc: startLoc, type: type} = this.state;
      if (tokenIsKeywordOrIdentifier(type)) {
        name = this.state.value;
      } else {
        this.unexpected();
      }
      const tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);
      if (liberal) {
        if (tokenIsKeyword) {
          this.replaceToken(132);
        }
      } else {
        this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
      }
      this.next();
      return name;
    }
    checkReservedWord(word, startLoc, checkKeywords, isBinding) {
      if (word.length > 10) {
        return;
      }
      if (!canBeReservedWord(word)) {
        return;
      }
      if (checkKeywords && isKeyword(word)) {
        this.raise(Errors.UnexpectedKeyword, startLoc, {keyword: word});
        return;
      }
      const reservedTest = !this.state.strict
        ? isReservedWord
        : isBinding
          ? isStrictBindReservedWord
          : isStrictReservedWord;
      if (reservedTest(word, this.inModule)) {
        this.raise(Errors.UnexpectedReservedWord, startLoc, {
          reservedWord: word,
        });
        return;
      } else if (word === 'yield') {
        if (this.prodParam.hasYield) {
          this.raise(Errors.YieldBindingIdentifier, startLoc);
          return;
        }
      } else if (word === 'await') {
        if (this.prodParam.hasAwait) {
          this.raise(Errors.AwaitBindingIdentifier, startLoc);
          return;
        }
        if (this.scope.inStaticBlock) {
          this.raise(Errors.AwaitBindingIdentifierInStaticBlock, startLoc);
          return;
        }
        this.expressionScope.recordAsyncArrowParametersError(startLoc);
      } else if (word === 'arguments') {
        if (this.scope.inClassAndNotInNonArrowFunction) {
          this.raise(Errors.ArgumentsInClass, startLoc);
          return;
        }
      }
    }
    recordAwaitIfAllowed() {
      const isAwaitAllowed =
        this.prodParam.hasAwait ||
        (this.options.allowAwaitOutsideFunction && !this.scope.inFunction);
      if (isAwaitAllowed && !this.scope.inFunction) {
        this.state.hasTopLevelAwait = true;
      }
      return isAwaitAllowed;
    }
    parseAwait(startLoc) {
      const node = this.startNodeAt(startLoc);
      this.expressionScope.recordParameterInitializerError(
        Errors.AwaitExpressionFormalParameter,
        node
      );
      if (this.eat(55)) {
        this.raise(Errors.ObsoleteAwaitStar, node);
      }
      if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
        if (this.isAmbiguousAwait()) {
          this.ambiguousScriptDifferentAst = true;
        } else {
          this.sawUnambiguousESM = true;
        }
      }
      if (!this.state.soloAwait) {
        node.argument = this.parseMaybeUnary(null, true);
      }
      return this.finishNode(node, 'AwaitExpression');
    }
    isAmbiguousAwait() {
      if (this.hasPrecedingLineBreak()) return true;
      const {type: type} = this.state;
      return (
        type === 53 ||
        type === 10 ||
        type === 0 ||
        tokenIsTemplate(type) ||
        (type === 102 && !this.state.containsEsc) ||
        type === 137 ||
        type === 56 ||
        (this.hasPlugin('v8intrinsic') && type === 54)
      );
    }
    parseYield() {
      const node = this.startNode();
      this.expressionScope.recordParameterInitializerError(
        Errors.YieldInParameter,
        node
      );
      this.next();
      let delegating = false;
      let argument = null;
      if (!this.hasPrecedingLineBreak()) {
        delegating = this.eat(55);
        switch (this.state.type) {
          case 13:
          case 139:
          case 8:
          case 11:
          case 3:
          case 9:
          case 14:
          case 12:
            if (!delegating) break;
          default:
            argument = this.parseMaybeAssign();
        }
      }
      node.delegate = delegating;
      node.argument = argument;
      return this.finishNode(node, 'YieldExpression');
    }
    parseImportCall(node) {
      this.next();
      node.source = this.parseMaybeAssignAllowIn();
      if (
        this.hasPlugin('importAttributes') ||
        this.hasPlugin('importAssertions')
      ) {
        node.options = null;
      }
      if (this.eat(12)) {
        this.expectImportAttributesPlugin();
        if (!this.match(11)) {
          node.options = this.parseMaybeAssignAllowIn();
          this.eat(12);
        }
      }
      this.expect(11);
      return this.finishNode(node, 'ImportExpression');
    }
    checkPipelineAtInfixOperator(left, leftStartLoc) {
      if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
        if (left.type === 'SequenceExpression') {
          this.raise(Errors.PipelineHeadSequenceExpression, leftStartLoc);
        }
      }
    }
    parseSmartPipelineBodyInStyle(childExpr, startLoc) {
      if (this.isSimpleReference(childExpr)) {
        const bodyNode = this.startNodeAt(startLoc);
        bodyNode.callee = childExpr;
        return this.finishNode(bodyNode, 'PipelineBareFunction');
      } else {
        const bodyNode = this.startNodeAt(startLoc);
        this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
        bodyNode.expression = childExpr;
        return this.finishNode(bodyNode, 'PipelineTopicExpression');
      }
    }
    isSimpleReference(expression) {
      switch (expression.type) {
        case 'MemberExpression':
          return (
            !expression.computed && this.isSimpleReference(expression.object)
          );
        case 'Identifier':
          return true;
        default:
          return false;
      }
    }
    checkSmartPipeTopicBodyEarlyErrors(startLoc) {
      if (this.match(19)) {
        throw this.raise(Errors.PipelineBodyNoArrow, this.state.startLoc);
      }
      if (!this.topicReferenceWasUsedInCurrentContext()) {
        this.raise(Errors.PipelineTopicUnused, startLoc);
      }
    }
    withTopicBindingContext(callback) {
      const outerContextTopicState = this.state.topicContext;
      this.state.topicContext = {
        maxNumOfResolvableTopics: 1,
        maxTopicIndex: null,
      };
      try {
        return callback();
      } finally {
        this.state.topicContext = outerContextTopicState;
      }
    }
    withSmartMixTopicForbiddingContext(callback) {
      if (this.hasPlugin(['pipelineOperator', {proposal: 'smart'}])) {
        const outerContextTopicState = this.state.topicContext;
        this.state.topicContext = {
          maxNumOfResolvableTopics: 0,
          maxTopicIndex: null,
        };
        try {
          return callback();
        } finally {
          this.state.topicContext = outerContextTopicState;
        }
      } else {
        return callback();
      }
    }
    withSoloAwaitPermittingContext(callback) {
      const outerContextSoloAwaitState = this.state.soloAwait;
      this.state.soloAwait = true;
      try {
        return callback();
      } finally {
        this.state.soloAwait = outerContextSoloAwaitState;
      }
    }
    allowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToSet = 8 & ~flags;
      if (prodParamToSet) {
        this.prodParam.enter(flags | 8);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    disallowInAnd(callback) {
      const flags = this.prodParam.currentFlags();
      const prodParamToClear = 8 & flags;
      if (prodParamToClear) {
        this.prodParam.enter(flags & ~8);
        try {
          return callback();
        } finally {
          this.prodParam.exit();
        }
      }
      return callback();
    }
    registerTopicReference() {
      this.state.topicContext.maxTopicIndex = 0;
    }
    topicReferenceIsAllowedInCurrentContext() {
      return this.state.topicContext.maxNumOfResolvableTopics >= 1;
    }
    topicReferenceWasUsedInCurrentContext() {
      return (
        this.state.topicContext.maxTopicIndex != null &&
        this.state.topicContext.maxTopicIndex >= 0
      );
    }
    parseFSharpPipelineBody(prec) {
      const startLoc = this.state.startLoc;
      this.state.potentialArrowAt = this.state.start;
      const oldInFSharpPipelineDirectBody =
        this.state.inFSharpPipelineDirectBody;
      this.state.inFSharpPipelineDirectBody = true;
      const ret = this.parseExprOp(
        this.parseMaybeUnaryOrPrivate(),
        startLoc,
        prec
      );
      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
      return ret;
    }
    parseModuleExpression() {
      this.expectPlugin('moduleBlocks');
      const node = this.startNode();
      this.next();
      if (!this.match(5)) {
        this.unexpected(null, 5);
      }
      const program = this.startNodeAt(this.state.endLoc);
      this.next();
      const revertScopes = this.initializeScopes(true);
      this.enterInitialScopes();
      try {
        node.body = this.parseProgram(program, 8, 'module');
      } finally {
        revertScopes();
      }
      return this.finishNode(node, 'ModuleExpression');
    }
    parsePropertyNamePrefixOperator(prop) {}
  }
  const loopLabel = {kind: 1},
    switchLabel = {kind: 2};
  const loneSurrogate = /[\uD800-\uDFFF]/u;
  const keywordRelationalOperator = /in(?:stanceof)?/y;
  function babel7CompatTokens(tokens, input) {
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      const {type: type} = token;
      if (typeof type === 'number') {
        {
          if (type === 138) {
            const {loc: loc, start: start, value: value, end: end} = token;
            const hashEndPos = start + 1;
            const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
            tokens.splice(
              i,
              1,
              new Token({
                type: getExportedToken(27),
                value: '#',
                start: start,
                end: hashEndPos,
                startLoc: loc.start,
                endLoc: hashEndLoc,
              }),
              new Token({
                type: getExportedToken(132),
                value: value,
                start: hashEndPos,
                end: end,
                startLoc: hashEndLoc,
                endLoc: loc.end,
              })
            );
            i++;
            continue;
          }
          if (tokenIsTemplate(type)) {
            const {loc: loc, start: start, value: value, end: end} = token;
            const backquoteEnd = start + 1;
            const backquoteEndLoc = createPositionWithColumnOffset(
              loc.start,
              1
            );
            let startToken;
            if (input.charCodeAt(start) === 96) {
              startToken = new Token({
                type: getExportedToken(22),
                value: '`',
                start: start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc,
              });
            } else {
              startToken = new Token({
                type: getExportedToken(8),
                value: '}',
                start: start,
                end: backquoteEnd,
                startLoc: loc.start,
                endLoc: backquoteEndLoc,
              });
            }
            let templateValue,
              templateElementEnd,
              templateElementEndLoc,
              endToken;
            if (type === 24) {
              templateElementEnd = end - 1;
              templateElementEndLoc = createPositionWithColumnOffset(
                loc.end,
                -1
              );
              templateValue = value === null ? null : value.slice(1, -1);
              endToken = new Token({
                type: getExportedToken(22),
                value: '`',
                start: templateElementEnd,
                end: end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end,
              });
            } else {
              templateElementEnd = end - 2;
              templateElementEndLoc = createPositionWithColumnOffset(
                loc.end,
                -2
              );
              templateValue = value === null ? null : value.slice(1, -2);
              endToken = new Token({
                type: getExportedToken(23),
                value: '${',
                start: templateElementEnd,
                end: end,
                startLoc: templateElementEndLoc,
                endLoc: loc.end,
              });
            }
            tokens.splice(
              i,
              1,
              startToken,
              new Token({
                type: getExportedToken(20),
                value: templateValue,
                start: backquoteEnd,
                end: templateElementEnd,
                startLoc: backquoteEndLoc,
                endLoc: templateElementEndLoc,
              }),
              endToken
            );
            i += 2;
            continue;
          }
        }
        token.type = getExportedToken(type);
      }
    }
    return tokens;
  }
  class StatementParser extends ExpressionParser {
    parseTopLevel(file, program) {
      file.program = this.parseProgram(program);
      file.comments = this.comments;
      if (this.options.tokens) {
        file.tokens = babel7CompatTokens(this.tokens, this.input);
      }
      return this.finishNode(file, 'File');
    }
    parseProgram(program, end = 139, sourceType = this.options.sourceType) {
      program.sourceType = sourceType;
      program.interpreter = this.parseInterpreterDirective();
      this.parseBlockBody(program, true, true, end);
      if (this.inModule) {
        if (
          !this.options.allowUndeclaredExports &&
          this.scope.undefinedExports.size > 0
        ) {
          for (const [localName, at] of Array.from(
            this.scope.undefinedExports
          )) {
            this.raise(Errors.ModuleExportUndefined, at, {
              localName: localName,
            });
          }
        }
        this.addExtra(program, 'topLevelAwait', this.state.hasTopLevelAwait);
      }
      let finishedProgram;
      if (end === 139) {
        finishedProgram = this.finishNode(program, 'Program');
      } else {
        finishedProgram = this.finishNodeAt(
          program,
          'Program',
          createPositionWithColumnOffset(this.state.startLoc, -1)
        );
      }
      return finishedProgram;
    }
    stmtToDirective(stmt) {
      const directive = stmt;
      directive.type = 'Directive';
      directive.value = directive.expression;
      delete directive.expression;
      const directiveLiteral = directive.value;
      const expressionValue = directiveLiteral.value;
      const raw = this.input.slice(
        directiveLiteral.start,
        directiveLiteral.end
      );
      const val = (directiveLiteral.value = raw.slice(1, -1));
      this.addExtra(directiveLiteral, 'raw', raw);
      this.addExtra(directiveLiteral, 'rawValue', val);
      this.addExtra(directiveLiteral, 'expressionValue', expressionValue);
      directiveLiteral.type = 'DirectiveLiteral';
      return directive;
    }
    parseInterpreterDirective() {
      if (!this.match(28)) {
        return null;
      }
      const node = this.startNode();
      node.value = this.state.value;
      this.next();
      return this.finishNode(node, 'InterpreterDirective');
    }
    isLet() {
      if (!this.isContextual(100)) {
        return false;
      }
      return this.hasFollowingBindingAtom();
    }
    chStartsBindingIdentifier(ch, pos) {
      if (isIdentifierStart(ch)) {
        keywordRelationalOperator.lastIndex = pos;
        if (keywordRelationalOperator.test(this.input)) {
          const endCh = this.codePointAtPos(
            keywordRelationalOperator.lastIndex
          );
          if (!isIdentifierChar(endCh) && endCh !== 92) {
            return false;
          }
        }
        return true;
      } else if (ch === 92) {
        return true;
      } else {
        return false;
      }
    }
    chStartsBindingPattern(ch) {
      return ch === 91 || ch === 123;
    }
    hasFollowingBindingAtom() {
      const next = this.nextTokenStart();
      const nextCh = this.codePointAtPos(next);
      return (
        this.chStartsBindingPattern(nextCh) ||
        this.chStartsBindingIdentifier(nextCh, next)
      );
    }
    hasInLineFollowingBindingIdentifierOrBrace() {
      const next = this.nextTokenInLineStart();
      const nextCh = this.codePointAtPos(next);
      return nextCh === 123 || this.chStartsBindingIdentifier(nextCh, next);
    }
    startsUsingForOf() {
      const {type: type, containsEsc: containsEsc} = this.lookahead();
      if (type === 102 && !containsEsc) {
        return false;
      } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
        this.expectPlugin('explicitResourceManagement');
        return true;
      }
    }
    startsAwaitUsing() {
      let next = this.nextTokenInLineStart();
      if (this.isUnparsedContextual(next, 'using')) {
        next = this.nextTokenInLineStartSince(next + 5);
        const nextCh = this.codePointAtPos(next);
        if (this.chStartsBindingIdentifier(nextCh, next)) {
          this.expectPlugin('explicitResourceManagement');
          return true;
        }
      }
      return false;
    }
    parseModuleItem() {
      return this.parseStatementLike(1 | 2 | 4 | 8);
    }
    parseStatementListItem() {
      return this.parseStatementLike(
        2 | 4 | (!this.options.annexB || this.state.strict ? 0 : 8)
      );
    }
    parseStatementOrSloppyAnnexBFunctionDeclaration(
      allowLabeledFunction = false
    ) {
      let flags = 0;
      if (this.options.annexB && !this.state.strict) {
        flags |= 4;
        if (allowLabeledFunction) {
          flags |= 8;
        }
      }
      return this.parseStatementLike(flags);
    }
    parseStatement() {
      return this.parseStatementLike(0);
    }
    parseStatementLike(flags) {
      let decorators = null;
      if (this.match(26)) {
        decorators = this.parseDecorators(true);
      }
      return this.parseStatementContent(flags, decorators);
    }
    parseStatementContent(flags, decorators) {
      const startType = this.state.type;
      const node = this.startNode();
      const allowDeclaration = !!(flags & 2);
      const allowFunctionDeclaration = !!(flags & 4);
      const topLevel = flags & 1;
      switch (startType) {
        case 60:
          return this.parseBreakContinueStatement(node, true);
        case 63:
          return this.parseBreakContinueStatement(node, false);
        case 64:
          return this.parseDebuggerStatement(node);
        case 90:
          return this.parseDoWhileStatement(node);
        case 91:
          return this.parseForStatement(node);
        case 68:
          if (this.lookaheadCharCode() === 46) break;
          if (!allowFunctionDeclaration) {
            this.raise(
              this.state.strict
                ? Errors.StrictFunction
                : this.options.annexB
                  ? Errors.SloppyFunctionAnnexB
                  : Errors.SloppyFunction,
              this.state.startLoc
            );
          }
          return this.parseFunctionStatement(
            node,
            false,
            !allowDeclaration && allowFunctionDeclaration
          );
        case 80:
          if (!allowDeclaration) this.unexpected();
          return this.parseClass(
            this.maybeTakeDecorators(decorators, node),
            true
          );
        case 69:
          return this.parseIfStatement(node);
        case 70:
          return this.parseReturnStatement(node);
        case 71:
          return this.parseSwitchStatement(node);
        case 72:
          return this.parseThrowStatement(node);
        case 73:
          return this.parseTryStatement(node);
        case 96:
          if (!this.state.containsEsc && this.startsAwaitUsing()) {
            if (!this.recordAwaitIfAllowed()) {
              this.raise(Errors.AwaitUsingNotInAsyncContext, node);
            } else if (!allowDeclaration) {
              this.raise(Errors.UnexpectedLexicalDeclaration, node);
            }
            this.next();
            return this.parseVarStatement(node, 'await using');
          }
          break;
        case 107:
          if (
            this.state.containsEsc ||
            !this.hasInLineFollowingBindingIdentifierOrBrace()
          ) {
            break;
          }
          this.expectPlugin('explicitResourceManagement');
          if (!this.scope.inModule && this.scope.inTopLevel) {
            this.raise(Errors.UnexpectedUsingDeclaration, this.state.startLoc);
          } else if (!allowDeclaration) {
            this.raise(
              Errors.UnexpectedLexicalDeclaration,
              this.state.startLoc
            );
          }
          return this.parseVarStatement(node, 'using');
        case 100: {
          if (this.state.containsEsc) {
            break;
          }
          const next = this.nextTokenStart();
          const nextCh = this.codePointAtPos(next);
          if (nextCh !== 91) {
            if (!allowDeclaration && this.hasFollowingLineBreak()) break;
            if (
              !this.chStartsBindingIdentifier(nextCh, next) &&
              nextCh !== 123
            ) {
              break;
            }
          }
        }
        case 75: {
          if (!allowDeclaration) {
            this.raise(
              Errors.UnexpectedLexicalDeclaration,
              this.state.startLoc
            );
          }
        }
        case 74: {
          const kind = this.state.value;
          return this.parseVarStatement(node, kind);
        }
        case 92:
          return this.parseWhileStatement(node);
        case 76:
          return this.parseWithStatement(node);
        case 5:
          return this.parseBlock();
        case 13:
          return this.parseEmptyStatement(node);
        case 83: {
          const nextTokenCharCode = this.lookaheadCharCode();
          if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
            break;
          }
        }
        case 82: {
          if (!this.options.allowImportExportEverywhere && !topLevel) {
            this.raise(Errors.UnexpectedImportExport, this.state.startLoc);
          }
          this.next();
          let result;
          if (startType === 83) {
            result = this.parseImport(node);
            if (
              result.type === 'ImportDeclaration' &&
              (!result.importKind || result.importKind === 'value')
            ) {
              this.sawUnambiguousESM = true;
            }
          } else {
            result = this.parseExport(node, decorators);
            if (
              (result.type === 'ExportNamedDeclaration' &&
                (!result.exportKind || result.exportKind === 'value')) ||
              (result.type === 'ExportAllDeclaration' &&
                (!result.exportKind || result.exportKind === 'value')) ||
              result.type === 'ExportDefaultDeclaration'
            ) {
              this.sawUnambiguousESM = true;
            }
          }
          this.assertModuleNodeAllowed(result);
          return result;
        }
        default: {
          if (this.isAsyncFunction()) {
            if (!allowDeclaration) {
              this.raise(
                Errors.AsyncFunctionInSingleStatementContext,
                this.state.startLoc
              );
            }
            this.next();
            return this.parseFunctionStatement(
              node,
              true,
              !allowDeclaration && allowFunctionDeclaration
            );
          }
        }
      }
      const maybeName = this.state.value;
      const expr = this.parseExpression();
      if (
        tokenIsIdentifier(startType) &&
        expr.type === 'Identifier' &&
        this.eat(14)
      ) {
        return this.parseLabeledStatement(node, maybeName, expr, flags);
      } else {
        return this.parseExpressionStatement(node, expr, decorators);
      }
    }
    assertModuleNodeAllowed(node) {
      if (!this.options.allowImportExportEverywhere && !this.inModule) {
        this.raise(Errors.ImportOutsideModule, node);
      }
    }
    decoratorsEnabledBeforeExport() {
      if (this.hasPlugin('decorators-legacy')) return true;
      return (
        this.hasPlugin('decorators') &&
        this.getPluginOption('decorators', 'decoratorsBeforeExport') !== false
      );
    }
    maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
      if (maybeDecorators) {
        if (classNode.decorators && classNode.decorators.length > 0) {
          if (
            typeof this.getPluginOption(
              'decorators',
              'decoratorsBeforeExport'
            ) !== 'boolean'
          ) {
            this.raise(
              Errors.DecoratorsBeforeAfterExport,
              classNode.decorators[0]
            );
          }
          classNode.decorators.unshift(...maybeDecorators);
        } else {
          classNode.decorators = maybeDecorators;
        }
        this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
        if (exportNode) this.resetStartLocationFromNode(exportNode, classNode);
      }
      return classNode;
    }
    canHaveLeadingDecorator() {
      return this.match(80);
    }
    parseDecorators(allowExport) {
      const decorators = [];
      do {
        decorators.push(this.parseDecorator());
      } while (this.match(26));
      if (this.match(82)) {
        if (!allowExport) {
          this.unexpected();
        }
        if (!this.decoratorsEnabledBeforeExport()) {
          this.raise(Errors.DecoratorExportClass, this.state.startLoc);
        }
      } else if (!this.canHaveLeadingDecorator()) {
        throw this.raise(
          Errors.UnexpectedLeadingDecorator,
          this.state.startLoc
        );
      }
      return decorators;
    }
    parseDecorator() {
      this.expectOnePlugin(['decorators', 'decorators-legacy']);
      const node = this.startNode();
      this.next();
      if (this.hasPlugin('decorators')) {
        const startLoc = this.state.startLoc;
        let expr;
        if (this.match(10)) {
          const startLoc = this.state.startLoc;
          this.next();
          expr = this.parseExpression();
          this.expect(11);
          expr = this.wrapParenthesis(startLoc, expr);
          const paramsStartLoc = this.state.startLoc;
          node.expression = this.parseMaybeDecoratorArguments(expr);
          if (
            this.getPluginOption('decorators', 'allowCallParenthesized') ===
              false &&
            node.expression !== expr
          ) {
            this.raise(
              Errors.DecoratorArgumentsOutsideParentheses,
              paramsStartLoc
            );
          }
        } else {
          expr = this.parseIdentifier(false);
          while (this.eat(16)) {
            const node = this.startNodeAt(startLoc);
            node.object = expr;
            if (this.match(138)) {
              this.classScope.usePrivateName(
                this.state.value,
                this.state.startLoc
              );
              node.property = this.parsePrivateName();
            } else {
              node.property = this.parseIdentifier(true);
            }
            node.computed = false;
            expr = this.finishNode(node, 'MemberExpression');
          }
          node.expression = this.parseMaybeDecoratorArguments(expr);
        }
      } else {
        node.expression = this.parseExprSubscripts();
      }
      return this.finishNode(node, 'Decorator');
    }
    parseMaybeDecoratorArguments(expr) {
      if (this.eat(10)) {
        const node = this.startNodeAtNode(expr);
        node.callee = expr;
        node.arguments = this.parseCallExpressionArguments(11, false);
        this.toReferencedList(node.arguments);
        return this.finishNode(node, 'CallExpression');
      }
      return expr;
    }
    parseBreakContinueStatement(node, isBreak) {
      this.next();
      if (this.isLineTerminator()) {
        node.label = null;
      } else {
        node.label = this.parseIdentifier();
        this.semicolon();
      }
      this.verifyBreakContinue(node, isBreak);
      return this.finishNode(
        node,
        isBreak ? 'BreakStatement' : 'ContinueStatement'
      );
    }
    verifyBreakContinue(node, isBreak) {
      let i;
      for (i = 0; i < this.state.labels.length; ++i) {
        const lab = this.state.labels[i];
        if (node.label == null || lab.name === node.label.name) {
          if (lab.kind != null && (isBreak || lab.kind === 1)) {
            break;
          }
          if (node.label && isBreak) break;
        }
      }
      if (i === this.state.labels.length) {
        const type = isBreak ? 'BreakStatement' : 'ContinueStatement';
        this.raise(Errors.IllegalBreakContinue, node, {type: type});
      }
    }
    parseDebuggerStatement(node) {
      this.next();
      this.semicolon();
      return this.finishNode(node, 'DebuggerStatement');
    }
    parseHeaderExpression() {
      this.expect(10);
      const val = this.parseExpression();
      this.expect(11);
      return val;
    }
    parseDoWhileStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.state.labels.pop();
      this.expect(92);
      node.test = this.parseHeaderExpression();
      this.eat(13);
      return this.finishNode(node, 'DoWhileStatement');
    }
    parseForStatement(node) {
      this.next();
      this.state.labels.push(loopLabel);
      let awaitAt = null;
      if (this.isContextual(96) && this.recordAwaitIfAllowed()) {
        awaitAt = this.state.startLoc;
        this.next();
      }
      this.scope.enter(0);
      this.expect(10);
      if (this.match(13)) {
        if (awaitAt !== null) {
          this.unexpected(awaitAt);
        }
        return this.parseFor(node, null);
      }
      const startsWithLet = this.isContextual(100);
      {
        const startsWithAwaitUsing =
          this.isContextual(96) && this.startsAwaitUsing();
        const starsWithUsingDeclaration =
          startsWithAwaitUsing ||
          (this.isContextual(107) && this.startsUsingForOf());
        const isLetOrUsing =
          (startsWithLet && this.hasFollowingBindingAtom()) ||
          starsWithUsingDeclaration;
        if (this.match(74) || this.match(75) || isLetOrUsing) {
          const initNode = this.startNode();
          let kind;
          if (startsWithAwaitUsing) {
            kind = 'await using';
            if (!this.recordAwaitIfAllowed()) {
              this.raise(
                Errors.AwaitUsingNotInAsyncContext,
                this.state.startLoc
              );
            }
            this.next();
          } else {
            kind = this.state.value;
          }
          this.next();
          this.parseVar(initNode, true, kind);
          const init = this.finishNode(initNode, 'VariableDeclaration');
          const isForIn = this.match(58);
          if (isForIn && starsWithUsingDeclaration) {
            this.raise(Errors.ForInUsing, init);
          }
          if (
            (isForIn || this.isContextual(102)) &&
            init.declarations.length === 1
          ) {
            return this.parseForIn(node, init, awaitAt);
          }
          if (awaitAt !== null) {
            this.unexpected(awaitAt);
          }
          return this.parseFor(node, init);
        }
      }
      const startsWithAsync = this.isContextual(95);
      const refExpressionErrors = new ExpressionErrors();
      const init = this.parseExpression(true, refExpressionErrors);
      const isForOf = this.isContextual(102);
      if (isForOf) {
        if (startsWithLet) {
          this.raise(Errors.ForOfLet, init);
        }
        if (awaitAt === null && startsWithAsync && init.type === 'Identifier') {
          this.raise(Errors.ForOfAsync, init);
        }
      }
      if (isForOf || this.match(58)) {
        this.checkDestructuringPrivate(refExpressionErrors);
        this.toAssignable(init, true);
        const type = isForOf ? 'ForOfStatement' : 'ForInStatement';
        this.checkLVal(init, {type: type});
        return this.parseForIn(node, init, awaitAt);
      } else {
        this.checkExpressionErrors(refExpressionErrors, true);
      }
      if (awaitAt !== null) {
        this.unexpected(awaitAt);
      }
      return this.parseFor(node, init);
    }
    parseFunctionStatement(node, isAsync, isHangingDeclaration) {
      this.next();
      return this.parseFunction(
        node,
        1 | (isHangingDeclaration ? 2 : 0) | (isAsync ? 8 : 0)
      );
    }
    parseIfStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
      node.alternate = this.eat(66)
        ? this.parseStatementOrSloppyAnnexBFunctionDeclaration()
        : null;
      return this.finishNode(node, 'IfStatement');
    }
    parseReturnStatement(node) {
      if (
        !this.prodParam.hasReturn &&
        !this.options.allowReturnOutsideFunction
      ) {
        this.raise(Errors.IllegalReturn, this.state.startLoc);
      }
      this.next();
      if (this.isLineTerminator()) {
        node.argument = null;
      } else {
        node.argument = this.parseExpression();
        this.semicolon();
      }
      return this.finishNode(node, 'ReturnStatement');
    }
    parseSwitchStatement(node) {
      this.next();
      node.discriminant = this.parseHeaderExpression();
      const cases = (node.cases = []);
      this.expect(5);
      this.state.labels.push(switchLabel);
      this.scope.enter(0);
      let cur;
      for (let sawDefault; !this.match(8); ) {
        if (this.match(61) || this.match(65)) {
          const isCase = this.match(61);
          if (cur) this.finishNode(cur, 'SwitchCase');
          cases.push((cur = this.startNode()));
          cur.consequent = [];
          this.next();
          if (isCase) {
            cur.test = this.parseExpression();
          } else {
            if (sawDefault) {
              this.raise(
                Errors.MultipleDefaultsInSwitch,
                this.state.lastTokStartLoc
              );
            }
            sawDefault = true;
            cur.test = null;
          }
          this.expect(14);
        } else {
          if (cur) {
            cur.consequent.push(this.parseStatementListItem());
          } else {
            this.unexpected();
          }
        }
      }
      this.scope.exit();
      if (cur) this.finishNode(cur, 'SwitchCase');
      this.next();
      this.state.labels.pop();
      return this.finishNode(node, 'SwitchStatement');
    }
    parseThrowStatement(node) {
      this.next();
      if (this.hasPrecedingLineBreak()) {
        this.raise(Errors.NewlineAfterThrow, this.state.lastTokEndLoc);
      }
      node.argument = this.parseExpression();
      this.semicolon();
      return this.finishNode(node, 'ThrowStatement');
    }
    parseCatchClauseParam() {
      const param = this.parseBindingAtom();
      this.scope.enter(
        this.options.annexB && param.type === 'Identifier' ? 8 : 0
      );
      this.checkLVal(param, {type: 'CatchClause'}, 9);
      return param;
    }
    parseTryStatement(node) {
      this.next();
      node.block = this.parseBlock();
      node.handler = null;
      if (this.match(62)) {
        const clause = this.startNode();
        this.next();
        if (this.match(10)) {
          this.expect(10);
          clause.param = this.parseCatchClauseParam();
          this.expect(11);
        } else {
          clause.param = null;
          this.scope.enter(0);
        }
        clause.body = this.withSmartMixTopicForbiddingContext(() =>
          this.parseBlock(false, false)
        );
        this.scope.exit();
        node.handler = this.finishNode(clause, 'CatchClause');
      }
      node.finalizer = this.eat(67) ? this.parseBlock() : null;
      if (!node.handler && !node.finalizer) {
        this.raise(Errors.NoCatchOrFinally, node);
      }
      return this.finishNode(node, 'TryStatement');
    }
    parseVarStatement(node, kind, allowMissingInitializer = false) {
      this.next();
      this.parseVar(node, false, kind, allowMissingInitializer);
      this.semicolon();
      return this.finishNode(node, 'VariableDeclaration');
    }
    parseWhileStatement(node) {
      this.next();
      node.test = this.parseHeaderExpression();
      this.state.labels.push(loopLabel);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.state.labels.pop();
      return this.finishNode(node, 'WhileStatement');
    }
    parseWithStatement(node) {
      if (this.state.strict) {
        this.raise(Errors.StrictWith, this.state.startLoc);
      }
      this.next();
      node.object = this.parseHeaderExpression();
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      return this.finishNode(node, 'WithStatement');
    }
    parseEmptyStatement(node) {
      this.next();
      return this.finishNode(node, 'EmptyStatement');
    }
    parseLabeledStatement(node, maybeName, expr, flags) {
      for (const label of this.state.labels) {
        if (label.name === maybeName) {
          this.raise(Errors.LabelRedeclaration, expr, {labelName: maybeName});
        }
      }
      const kind = tokenIsLoop(this.state.type) ? 1 : this.match(71) ? 2 : null;
      for (let i = this.state.labels.length - 1; i >= 0; i--) {
        const label = this.state.labels[i];
        if (label.statementStart === node.start) {
          label.statementStart = this.state.start;
          label.kind = kind;
        } else {
          break;
        }
      }
      this.state.labels.push({
        name: maybeName,
        kind: kind,
        statementStart: this.state.start,
      });
      node.body =
        flags & 8
          ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true)
          : this.parseStatement();
      this.state.labels.pop();
      node.label = expr;
      return this.finishNode(node, 'LabeledStatement');
    }
    parseExpressionStatement(node, expr, decorators) {
      node.expression = expr;
      this.semicolon();
      return this.finishNode(node, 'ExpressionStatement');
    }
    parseBlock(
      allowDirectives = false,
      createNewLexicalScope = true,
      afterBlockParse
    ) {
      const node = this.startNode();
      if (allowDirectives) {
        this.state.strictErrors.clear();
      }
      this.expect(5);
      if (createNewLexicalScope) {
        this.scope.enter(0);
      }
      this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
      if (createNewLexicalScope) {
        this.scope.exit();
      }
      return this.finishNode(node, 'BlockStatement');
    }
    isValidDirective(stmt) {
      return (
        stmt.type === 'ExpressionStatement' &&
        stmt.expression.type === 'StringLiteral' &&
        !stmt.expression.extra.parenthesized
      );
    }
    parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
      const body = (node.body = []);
      const directives = (node.directives = []);
      this.parseBlockOrModuleBlockBody(
        body,
        allowDirectives ? directives : undefined,
        topLevel,
        end,
        afterBlockParse
      );
    }
    parseBlockOrModuleBlockBody(
      body,
      directives,
      topLevel,
      end,
      afterBlockParse
    ) {
      const oldStrict = this.state.strict;
      let hasStrictModeDirective = false;
      let parsedNonDirective = false;
      while (!this.match(end)) {
        const stmt = topLevel
          ? this.parseModuleItem()
          : this.parseStatementListItem();
        if (directives && !parsedNonDirective) {
          if (this.isValidDirective(stmt)) {
            const directive = this.stmtToDirective(stmt);
            directives.push(directive);
            if (
              !hasStrictModeDirective &&
              directive.value.value === 'use strict'
            ) {
              hasStrictModeDirective = true;
              this.setStrict(true);
            }
            continue;
          }
          parsedNonDirective = true;
          this.state.strictErrors.clear();
        }
        body.push(stmt);
      }
      afterBlockParse == null ||
        afterBlockParse.call(this, hasStrictModeDirective);
      if (!oldStrict) {
        this.setStrict(false);
      }
      this.next();
    }
    parseFor(node, init) {
      node.init = init;
      this.semicolon(false);
      node.test = this.match(13) ? null : this.parseExpression();
      this.semicolon(false);
      node.update = this.match(11) ? null : this.parseExpression();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(node, 'ForStatement');
    }
    parseForIn(node, init, awaitAt) {
      const isForIn = this.match(58);
      this.next();
      if (isForIn) {
        if (awaitAt !== null) this.unexpected(awaitAt);
      } else {
        node.await = awaitAt !== null;
      }
      if (
        init.type === 'VariableDeclaration' &&
        init.declarations[0].init != null &&
        (!isForIn ||
          !this.options.annexB ||
          this.state.strict ||
          init.kind !== 'var' ||
          init.declarations[0].id.type !== 'Identifier')
      ) {
        this.raise(Errors.ForInOfLoopInitializer, init, {
          type: isForIn ? 'ForInStatement' : 'ForOfStatement',
        });
      }
      if (init.type === 'AssignmentPattern') {
        this.raise(Errors.InvalidLhs, init, {ancestor: {type: 'ForStatement'}});
      }
      node.left = init;
      node.right = isForIn
        ? this.parseExpression()
        : this.parseMaybeAssignAllowIn();
      this.expect(11);
      node.body = this.withSmartMixTopicForbiddingContext(() =>
        this.parseStatement()
      );
      this.scope.exit();
      this.state.labels.pop();
      return this.finishNode(
        node,
        isForIn ? 'ForInStatement' : 'ForOfStatement'
      );
    }
    parseVar(node, isFor, kind, allowMissingInitializer = false) {
      const declarations = (node.declarations = []);
      node.kind = kind;
      for (;;) {
        const decl = this.startNode();
        this.parseVarId(decl, kind);
        decl.init = !this.eat(29)
          ? null
          : isFor
            ? this.parseMaybeAssignDisallowIn()
            : this.parseMaybeAssignAllowIn();
        if (decl.init === null && !allowMissingInitializer) {
          if (
            decl.id.type !== 'Identifier' &&
            !(isFor && (this.match(58) || this.isContextual(102)))
          ) {
            this.raise(
              Errors.DeclarationMissingInitializer,
              this.state.lastTokEndLoc,
              {kind: 'destructuring'}
            );
          } else if (
            (kind === 'const' || kind === 'using' || kind === 'await using') &&
            !(this.match(58) || this.isContextual(102))
          ) {
            this.raise(
              Errors.DeclarationMissingInitializer,
              this.state.lastTokEndLoc,
              {kind: kind}
            );
          }
        }
        declarations.push(this.finishNode(decl, 'VariableDeclarator'));
        if (!this.eat(12)) break;
      }
      return node;
    }
    parseVarId(decl, kind) {
      const id = this.parseBindingAtom();
      if (kind === 'using' || kind === 'await using') {
        if (id.type === 'ArrayPattern' || id.type === 'ObjectPattern') {
          this.raise(Errors.UsingDeclarationHasBindingPattern, id.loc.start);
        }
      }
      this.checkLVal(
        id,
        {type: 'VariableDeclarator'},
        kind === 'var' ? 5 : 8201
      );
      decl.id = id;
    }
    parseAsyncFunctionExpression(node) {
      return this.parseFunction(node, 8);
    }
    parseFunction(node, flags = 0) {
      const hangingDeclaration = flags & 2;
      const isDeclaration = !!(flags & 1);
      const requireId = isDeclaration && !(flags & 4);
      const isAsync = !!(flags & 8);
      this.initFunction(node, isAsync);
      if (this.match(55)) {
        if (hangingDeclaration) {
          this.raise(
            Errors.GeneratorInSingleStatementContext,
            this.state.startLoc
          );
        }
        this.next();
        node.generator = true;
      }
      if (isDeclaration) {
        node.id = this.parseFunctionId(requireId);
      }
      const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
      this.state.maybeInArrowParameters = false;
      this.scope.enter(2);
      this.prodParam.enter(functionFlags(isAsync, node.generator));
      if (!isDeclaration) {
        node.id = this.parseFunctionId();
      }
      this.parseFunctionParams(node, false);
      this.withSmartMixTopicForbiddingContext(() => {
        this.parseFunctionBodyAndFinish(
          node,
          isDeclaration ? 'FunctionDeclaration' : 'FunctionExpression'
        );
      });
      this.prodParam.exit();
      this.scope.exit();
      if (isDeclaration && !hangingDeclaration) {
        this.registerFunctionStatementId(node);
      }
      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
      return node;
    }
    parseFunctionId(requireId) {
      return requireId || tokenIsIdentifier(this.state.type)
        ? this.parseIdentifier()
        : null;
    }
    parseFunctionParams(node, isConstructor) {
      this.expect(10);
      this.expressionScope.enter(newParameterDeclarationScope());
      node.params = this.parseBindingList(11, 41, 2 | (isConstructor ? 4 : 0));
      this.expressionScope.exit();
    }
    registerFunctionStatementId(node) {
      if (!node.id) return;
      this.scope.declareName(
        node.id.name,
        !this.options.annexB ||
          this.state.strict ||
          node.generator ||
          node.async
          ? this.scope.treatFunctionsAsVar
            ? 5
            : 8201
          : 17,
        node.id.loc.start
      );
    }
    parseClass(node, isStatement, optionalId) {
      this.next();
      const oldStrict = this.state.strict;
      this.state.strict = true;
      this.parseClassId(node, isStatement, optionalId);
      this.parseClassSuper(node);
      node.body = this.parseClassBody(!!node.superClass, oldStrict);
      return this.finishNode(
        node,
        isStatement ? 'ClassDeclaration' : 'ClassExpression'
      );
    }
    isClassProperty() {
      return this.match(29) || this.match(13) || this.match(8);
    }
    isClassMethod() {
      return this.match(10);
    }
    nameIsConstructor(key) {
      return (
        (key.type === 'Identifier' && key.name === 'constructor') ||
        (key.type === 'StringLiteral' && key.value === 'constructor')
      );
    }
    isNonstaticConstructor(method) {
      return (
        !method.computed && !method.static && this.nameIsConstructor(method.key)
      );
    }
    parseClassBody(hadSuperClass, oldStrict) {
      this.classScope.enter();
      const state = {hadConstructor: false, hadSuperClass: hadSuperClass};
      let decorators = [];
      const classBody = this.startNode();
      classBody.body = [];
      this.expect(5);
      this.withSmartMixTopicForbiddingContext(() => {
        while (!this.match(8)) {
          if (this.eat(13)) {
            if (decorators.length > 0) {
              throw this.raise(
                Errors.DecoratorSemicolon,
                this.state.lastTokEndLoc
              );
            }
            continue;
          }
          if (this.match(26)) {
            decorators.push(this.parseDecorator());
            continue;
          }
          const member = this.startNode();
          if (decorators.length) {
            member.decorators = decorators;
            this.resetStartLocationFromNode(member, decorators[0]);
            decorators = [];
          }
          this.parseClassMember(classBody, member, state);
          if (
            member.kind === 'constructor' &&
            member.decorators &&
            member.decorators.length > 0
          ) {
            this.raise(Errors.DecoratorConstructor, member);
          }
        }
      });
      this.state.strict = oldStrict;
      this.next();
      if (decorators.length) {
        throw this.raise(Errors.TrailingDecorator, this.state.startLoc);
      }
      this.classScope.exit();
      return this.finishNode(classBody, 'ClassBody');
    }
    parseClassMemberFromModifier(classBody, member) {
      const key = this.parseIdentifier(true);
      if (this.isClassMethod()) {
        const method = member;
        method.kind = 'method';
        method.computed = false;
        method.key = key;
        method.static = false;
        this.pushClassMethod(classBody, method, false, false, false, false);
        return true;
      } else if (this.isClassProperty()) {
        const prop = member;
        prop.computed = false;
        prop.key = key;
        prop.static = false;
        classBody.body.push(this.parseClassProperty(prop));
        return true;
      }
      this.resetPreviousNodeTrailingComments(key);
      return false;
    }
    parseClassMember(classBody, member, state) {
      const isStatic = this.isContextual(106);
      if (isStatic) {
        if (this.parseClassMemberFromModifier(classBody, member)) {
          return;
        }
        if (this.eat(5)) {
          this.parseClassStaticBlock(classBody, member);
          return;
        }
      }
      this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
    }
    parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
      const publicMethod = member;
      const privateMethod = member;
      const publicProp = member;
      const privateProp = member;
      const accessorProp = member;
      const method = publicMethod;
      const publicMember = publicMethod;
      member.static = isStatic;
      this.parsePropertyNamePrefixOperator(member);
      if (this.eat(55)) {
        method.kind = 'method';
        const isPrivateName = this.match(138);
        this.parseClassElementName(method);
        if (isPrivateName) {
          this.pushClassPrivateMethod(classBody, privateMethod, true, false);
          return;
        }
        if (this.isNonstaticConstructor(publicMethod)) {
          this.raise(Errors.ConstructorIsGenerator, publicMethod.key);
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          true,
          false,
          false,
          false
        );
        return;
      }
      const isContextual =
        !this.state.containsEsc && tokenIsIdentifier(this.state.type);
      const key = this.parseClassElementName(member);
      const maybeContextualKw = isContextual ? key.name : null;
      const isPrivate = this.isPrivateName(key);
      const maybeQuestionTokenStartLoc = this.state.startLoc;
      this.parsePostMemberNameModifiers(publicMember);
      if (this.isClassMethod()) {
        method.kind = 'method';
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
          return;
        }
        const isConstructor = this.isNonstaticConstructor(publicMethod);
        let allowsDirectSuper = false;
        if (isConstructor) {
          publicMethod.kind = 'constructor';
          if (state.hadConstructor && !this.hasPlugin('typescript')) {
            this.raise(Errors.DuplicateConstructor, key);
          }
          if (
            isConstructor &&
            this.hasPlugin('typescript') &&
            member.override
          ) {
            this.raise(Errors.OverrideOnConstructor, key);
          }
          state.hadConstructor = true;
          allowsDirectSuper = state.hadSuperClass;
        }
        this.pushClassMethod(
          classBody,
          publicMethod,
          false,
          false,
          isConstructor,
          allowsDirectSuper
        );
      } else if (this.isClassProperty()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else if (maybeContextualKw === 'async' && !this.isLineTerminator()) {
        this.resetPreviousNodeTrailingComments(key);
        const isGenerator = this.eat(55);
        if (publicMember.optional) {
          this.unexpected(maybeQuestionTokenStartLoc);
        }
        method.kind = 'method';
        const isPrivate = this.match(138);
        this.parseClassElementName(method);
        this.parsePostMemberNameModifiers(publicMember);
        if (isPrivate) {
          this.pushClassPrivateMethod(
            classBody,
            privateMethod,
            isGenerator,
            true
          );
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAsync, publicMethod.key);
          }
          this.pushClassMethod(
            classBody,
            publicMethod,
            isGenerator,
            true,
            false,
            false
          );
        }
      } else if (
        (maybeContextualKw === 'get' || maybeContextualKw === 'set') &&
        !(this.match(55) && this.isLineTerminator())
      ) {
        this.resetPreviousNodeTrailingComments(key);
        method.kind = maybeContextualKw;
        const isPrivate = this.match(138);
        this.parseClassElementName(publicMethod);
        if (isPrivate) {
          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
        } else {
          if (this.isNonstaticConstructor(publicMethod)) {
            this.raise(Errors.ConstructorIsAccessor, publicMethod.key);
          }
          this.pushClassMethod(
            classBody,
            publicMethod,
            false,
            false,
            false,
            false
          );
        }
        this.checkGetterSetterParams(publicMethod);
      } else if (maybeContextualKw === 'accessor' && !this.isLineTerminator()) {
        this.expectPlugin('decoratorAutoAccessors');
        this.resetPreviousNodeTrailingComments(key);
        const isPrivate = this.match(138);
        this.parseClassElementName(publicProp);
        this.pushClassAccessorProperty(classBody, accessorProp, isPrivate);
      } else if (this.isLineTerminator()) {
        if (isPrivate) {
          this.pushClassPrivateProperty(classBody, privateProp);
        } else {
          this.pushClassProperty(classBody, publicProp);
        }
      } else {
        this.unexpected();
      }
    }
    parseClassElementName(member) {
      const {type: type, value: value} = this.state;
      if (
        (type === 132 || type === 133) &&
        member.static &&
        value === 'prototype'
      ) {
        this.raise(Errors.StaticPrototype, this.state.startLoc);
      }
      if (type === 138) {
        if (value === 'constructor') {
          this.raise(Errors.ConstructorClassPrivateField, this.state.startLoc);
        }
        const key = this.parsePrivateName();
        member.key = key;
        return key;
      }
      this.parsePropertyName(member);
      return member.key;
    }
    parseClassStaticBlock(classBody, member) {
      var _member$decorators;
      this.scope.enter(64 | 128 | 16);
      const oldLabels = this.state.labels;
      this.state.labels = [];
      this.prodParam.enter(0);
      const body = (member.body = []);
      this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
      this.prodParam.exit();
      this.scope.exit();
      this.state.labels = oldLabels;
      classBody.body.push(this.finishNode(member, 'StaticBlock'));
      if (
        (_member$decorators = member.decorators) != null &&
        _member$decorators.length
      ) {
        this.raise(Errors.DecoratorStaticBlock, member);
      }
    }
    pushClassProperty(classBody, prop) {
      if (!prop.computed && this.nameIsConstructor(prop.key)) {
        this.raise(Errors.ConstructorClassField, prop.key);
      }
      classBody.body.push(this.parseClassProperty(prop));
    }
    pushClassPrivateProperty(classBody, prop) {
      const node = this.parseClassPrivateProperty(prop);
      classBody.body.push(node);
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        0,
        node.key.loc.start
      );
    }
    pushClassAccessorProperty(classBody, prop, isPrivate) {
      if (!isPrivate && !prop.computed && this.nameIsConstructor(prop.key)) {
        this.raise(Errors.ConstructorClassField, prop.key);
      }
      const node = this.parseClassAccessorProperty(prop);
      classBody.body.push(node);
      if (isPrivate) {
        this.classScope.declarePrivateName(
          this.getPrivateNameSV(node.key),
          0,
          node.key.loc.start
        );
      }
    }
    pushClassMethod(
      classBody,
      method,
      isGenerator,
      isAsync,
      isConstructor,
      allowsDirectSuper
    ) {
      classBody.body.push(
        this.parseMethod(
          method,
          isGenerator,
          isAsync,
          isConstructor,
          allowsDirectSuper,
          'ClassMethod',
          true
        )
      );
    }
    pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
      const node = this.parseMethod(
        method,
        isGenerator,
        isAsync,
        false,
        false,
        'ClassPrivateMethod',
        true
      );
      classBody.body.push(node);
      const kind =
        node.kind === 'get'
          ? node.static
            ? 6
            : 2
          : node.kind === 'set'
            ? node.static
              ? 5
              : 1
            : 0;
      this.declareClassPrivateMethodInScope(node, kind);
    }
    declareClassPrivateMethodInScope(node, kind) {
      this.classScope.declarePrivateName(
        this.getPrivateNameSV(node.key),
        kind,
        node.key.loc.start
      );
    }
    parsePostMemberNameModifiers(methodOrProp) {}
    parseClassPrivateProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassPrivateProperty');
    }
    parseClassProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassProperty');
    }
    parseClassAccessorProperty(node) {
      this.parseInitializer(node);
      this.semicolon();
      return this.finishNode(node, 'ClassAccessorProperty');
    }
    parseInitializer(node) {
      this.scope.enter(64 | 16);
      this.expressionScope.enter(newExpressionScope());
      this.prodParam.enter(0);
      node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
      this.expressionScope.exit();
      this.prodParam.exit();
      this.scope.exit();
    }
    parseClassId(node, isStatement, optionalId, bindingType = 8331) {
      if (tokenIsIdentifier(this.state.type)) {
        node.id = this.parseIdentifier();
        if (isStatement) {
          this.declareNameFromIdentifier(node.id, bindingType);
        }
      } else {
        if (optionalId || !isStatement) {
          node.id = null;
        } else {
          throw this.raise(Errors.MissingClassName, this.state.startLoc);
        }
      }
    }
    parseClassSuper(node) {
      node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
    }
    parseExport(node, decorators) {
      const maybeDefaultIdentifier = this.parseMaybeImportPhase(node, true);
      const hasDefault = this.maybeParseExportDefaultSpecifier(
        node,
        maybeDefaultIdentifier
      );
      const parseAfterDefault = !hasDefault || this.eat(12);
      const hasStar = parseAfterDefault && this.eatExportStar(node);
      const hasNamespace =
        hasStar && this.maybeParseExportNamespaceSpecifier(node);
      const parseAfterNamespace =
        parseAfterDefault && (!hasNamespace || this.eat(12));
      const isFromRequired = hasDefault || hasStar;
      if (hasStar && !hasNamespace) {
        if (hasDefault) this.unexpected();
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.parseExportFrom(node, true);
        return this.finishNode(node, 'ExportAllDeclaration');
      }
      const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
      if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
        this.unexpected(null, 5);
      }
      if (hasNamespace && parseAfterNamespace) {
        this.unexpected(null, 98);
      }
      let hasDeclaration;
      if (isFromRequired || hasSpecifiers) {
        hasDeclaration = false;
        if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.parseExportFrom(node, isFromRequired);
      } else {
        hasDeclaration = this.maybeParseExportDeclaration(node);
      }
      if (isFromRequired || hasSpecifiers || hasDeclaration) {
        var _node2$declaration;
        const node2 = node;
        this.checkExport(node2, true, false, !!node2.source);
        if (
          ((_node2$declaration = node2.declaration) == null
            ? void 0
            : _node2$declaration.type) === 'ClassDeclaration'
        ) {
          this.maybeTakeDecorators(decorators, node2.declaration, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        return this.finishNode(node2, 'ExportNamedDeclaration');
      }
      if (this.eat(65)) {
        const node2 = node;
        const decl = this.parseExportDefaultExpression();
        node2.declaration = decl;
        if (decl.type === 'ClassDeclaration') {
          this.maybeTakeDecorators(decorators, decl, node2);
        } else if (decorators) {
          throw this.raise(Errors.UnsupportedDecoratorExport, node);
        }
        this.checkExport(node2, true, true);
        return this.finishNode(node2, 'ExportDefaultDeclaration');
      }
      this.unexpected(null, 5);
    }
    eatExportStar(node) {
      return this.eat(55);
    }
    maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
      if (maybeDefaultIdentifier || this.isExportDefaultSpecifier()) {
        this.expectPlugin(
          'exportDefaultFrom',
          maybeDefaultIdentifier == null
            ? void 0
            : maybeDefaultIdentifier.loc.start
        );
        const id = maybeDefaultIdentifier || this.parseIdentifier(true);
        const specifier = this.startNodeAtNode(id);
        specifier.exported = id;
        node.specifiers = [
          this.finishNode(specifier, 'ExportDefaultSpecifier'),
        ];
        return true;
      }
      return false;
    }
    maybeParseExportNamespaceSpecifier(node) {
      if (this.isContextual(93)) {
        var _ref, _ref$specifiers;
        (_ref$specifiers = (_ref = node).specifiers) != null
          ? _ref$specifiers
          : (_ref.specifiers = []);
        const specifier = this.startNodeAt(this.state.lastTokStartLoc);
        this.next();
        specifier.exported = this.parseModuleExportName();
        node.specifiers.push(
          this.finishNode(specifier, 'ExportNamespaceSpecifier')
        );
        return true;
      }
      return false;
    }
    maybeParseExportNamedSpecifiers(node) {
      if (this.match(5)) {
        const node2 = node;
        if (!node2.specifiers) node2.specifiers = [];
        const isTypeExport = node2.exportKind === 'type';
        node2.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
        node2.source = null;
        node2.declaration = null;
        if (this.hasPlugin('importAssertions')) {
          node2.assertions = [];
        }
        return true;
      }
      return false;
    }
    maybeParseExportDeclaration(node) {
      if (this.shouldParseExportDeclaration()) {
        node.specifiers = [];
        node.source = null;
        if (this.hasPlugin('importAssertions')) {
          node.assertions = [];
        }
        node.declaration = this.parseExportDeclaration(node);
        return true;
      }
      return false;
    }
    isAsyncFunction() {
      if (!this.isContextual(95)) return false;
      const next = this.nextTokenInLineStart();
      return this.isUnparsedContextual(next, 'function');
    }
    parseExportDefaultExpression() {
      const expr = this.startNode();
      if (this.match(68)) {
        this.next();
        return this.parseFunction(expr, 1 | 4);
      } else if (this.isAsyncFunction()) {
        this.next();
        this.next();
        return this.parseFunction(expr, 1 | 4 | 8);
      }
      if (this.match(80)) {
        return this.parseClass(expr, true, true);
      }
      if (this.match(26)) {
        if (
          this.hasPlugin('decorators') &&
          this.getPluginOption('decorators', 'decoratorsBeforeExport') === true
        ) {
          this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
        }
        return this.parseClass(
          this.maybeTakeDecorators(
            this.parseDecorators(false),
            this.startNode()
          ),
          true,
          true
        );
      }
      if (this.match(75) || this.match(74) || this.isLet()) {
        throw this.raise(Errors.UnsupportedDefaultExport, this.state.startLoc);
      }
      const res = this.parseMaybeAssignAllowIn();
      this.semicolon();
      return res;
    }
    parseExportDeclaration(node) {
      if (this.match(80)) {
        const node = this.parseClass(this.startNode(), true, false);
        return node;
      }
      return this.parseStatementListItem();
    }
    isExportDefaultSpecifier() {
      const {type: type} = this.state;
      if (tokenIsIdentifier(type)) {
        if ((type === 95 && !this.state.containsEsc) || type === 100) {
          return false;
        }
        if ((type === 130 || type === 129) && !this.state.containsEsc) {
          const {type: nextType} = this.lookahead();
          if (
            (tokenIsIdentifier(nextType) && nextType !== 98) ||
            nextType === 5
          ) {
            this.expectOnePlugin(['flow', 'typescript']);
            return false;
          }
        }
      } else if (!this.match(65)) {
        return false;
      }
      const next = this.nextTokenStart();
      const hasFrom = this.isUnparsedContextual(next, 'from');
      if (
        this.input.charCodeAt(next) === 44 ||
        (tokenIsIdentifier(this.state.type) && hasFrom)
      ) {
        return true;
      }
      if (this.match(65) && hasFrom) {
        const nextAfterFrom = this.input.charCodeAt(
          this.nextTokenStartSince(next + 4)
        );
        return nextAfterFrom === 34 || nextAfterFrom === 39;
      }
      return false;
    }
    parseExportFrom(node, expect) {
      if (this.eatContextual(98)) {
        node.source = this.parseImportSource();
        this.checkExport(node);
        this.maybeParseImportAttributes(node);
        this.checkJSONModuleImport(node);
      } else if (expect) {
        this.unexpected();
      }
      this.semicolon();
    }
    shouldParseExportDeclaration() {
      const {type: type} = this.state;
      if (type === 26) {
        this.expectOnePlugin(['decorators', 'decorators-legacy']);
        if (this.hasPlugin('decorators')) {
          if (
            this.getPluginOption('decorators', 'decoratorsBeforeExport') ===
            true
          ) {
            this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
          }
          return true;
        }
      }
      if (this.isContextual(107)) {
        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
        return true;
      }
      if (this.isContextual(96) && this.startsAwaitUsing()) {
        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
        return true;
      }
      return (
        type === 74 ||
        type === 75 ||
        type === 68 ||
        type === 80 ||
        this.isLet() ||
        this.isAsyncFunction()
      );
    }
    checkExport(node, checkNames, isDefault, isFrom) {
      if (checkNames) {
        var _node$specifiers;
        if (isDefault) {
          this.checkDuplicateExports(node, 'default');
          if (this.hasPlugin('exportDefaultFrom')) {
            var _declaration$extra;
            const declaration = node.declaration;
            if (
              declaration.type === 'Identifier' &&
              declaration.name === 'from' &&
              declaration.end - declaration.start === 4 &&
              !(
                (_declaration$extra = declaration.extra) != null &&
                _declaration$extra.parenthesized
              )
            ) {
              this.raise(Errors.ExportDefaultFromAsIdentifier, declaration);
            }
          }
        } else if (
          (_node$specifiers = node.specifiers) != null &&
          _node$specifiers.length
        ) {
          for (const specifier of node.specifiers) {
            const {exported: exported} = specifier;
            const exportName =
              exported.type === 'Identifier' ? exported.name : exported.value;
            this.checkDuplicateExports(specifier, exportName);
            if (!isFrom && specifier.local) {
              const {local: local} = specifier;
              if (local.type !== 'Identifier') {
                this.raise(Errors.ExportBindingIsString, specifier, {
                  localName: local.value,
                  exportName: exportName,
                });
              } else {
                this.checkReservedWord(
                  local.name,
                  local.loc.start,
                  true,
                  false
                );
                this.scope.checkLocalExport(local);
              }
            }
          }
        } else if (node.declaration) {
          const decl = node.declaration;
          if (
            decl.type === 'FunctionDeclaration' ||
            decl.type === 'ClassDeclaration'
          ) {
            const {id: id} = decl;
            if (!id) throw new Error('Assertion failure');
            this.checkDuplicateExports(node, id.name);
          } else if (decl.type === 'VariableDeclaration') {
            for (const declaration of decl.declarations) {
              this.checkDeclaration(declaration.id);
            }
          }
        }
      }
    }
    checkDeclaration(node) {
      if (node.type === 'Identifier') {
        this.checkDuplicateExports(node, node.name);
      } else if (node.type === 'ObjectPattern') {
        for (const prop of node.properties) {
          this.checkDeclaration(prop);
        }
      } else if (node.type === 'ArrayPattern') {
        for (const elem of node.elements) {
          if (elem) {
            this.checkDeclaration(elem);
          }
        }
      } else if (node.type === 'ObjectProperty') {
        this.checkDeclaration(node.value);
      } else if (node.type === 'RestElement') {
        this.checkDeclaration(node.argument);
      } else if (node.type === 'AssignmentPattern') {
        this.checkDeclaration(node.left);
      }
    }
    checkDuplicateExports(node, exportName) {
      if (this.exportedIdentifiers.has(exportName)) {
        if (exportName === 'default') {
          this.raise(Errors.DuplicateDefaultExport, node);
        } else {
          this.raise(Errors.DuplicateExport, node, {exportName: exportName});
        }
      }
      this.exportedIdentifiers.add(exportName);
    }
    parseExportSpecifiers(isInTypeExport) {
      const nodes = [];
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          this.expect(12);
          if (this.eat(8)) break;
        }
        const isMaybeTypeOnly = this.isContextual(130);
        const isString = this.match(133);
        const node = this.startNode();
        node.local = this.parseModuleExportName();
        nodes.push(
          this.parseExportSpecifier(
            node,
            isString,
            isInTypeExport,
            isMaybeTypeOnly
          )
        );
      }
      return nodes;
    }
    parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
      if (this.eatContextual(93)) {
        node.exported = this.parseModuleExportName();
      } else if (isString) {
        node.exported = cloneStringLiteral(node.local);
      } else if (!node.exported) {
        node.exported = cloneIdentifier(node.local);
      }
      return this.finishNode(node, 'ExportSpecifier');
    }
    parseModuleExportName() {
      if (this.match(133)) {
        const result = this.parseStringLiteral(this.state.value);
        const surrogate = loneSurrogate.exec(result.value);
        if (surrogate) {
          this.raise(Errors.ModuleExportNameHasLoneSurrogate, result, {
            surrogateCharCode: surrogate[0].charCodeAt(0),
          });
        }
        return result;
      }
      return this.parseIdentifier(true);
    }
    isJSONModuleImport(node) {
      if (node.assertions != null) {
        return node.assertions.some(
          ({key: key, value: value}) =>
            value.value === 'json' &&
            (key.type === 'Identifier'
              ? key.name === 'type'
              : key.value === 'type')
        );
      }
      return false;
    }
    checkImportReflection(node) {
      const {specifiers: specifiers} = node;
      const singleBindingType =
        specifiers.length === 1 ? specifiers[0].type : null;
      if (node.phase === 'source') {
        if (singleBindingType !== 'ImportDefaultSpecifier') {
          this.raise(
            Errors.SourcePhaseImportRequiresDefault,
            specifiers[0].loc.start
          );
        }
      } else if (node.phase === 'defer') {
        if (singleBindingType !== 'ImportNamespaceSpecifier') {
          this.raise(
            Errors.DeferImportRequiresNamespace,
            specifiers[0].loc.start
          );
        }
      } else if (node.module) {
        var _node$assertions;
        if (singleBindingType !== 'ImportDefaultSpecifier') {
          this.raise(
            Errors.ImportReflectionNotBinding,
            specifiers[0].loc.start
          );
        }
        if (
          ((_node$assertions = node.assertions) == null
            ? void 0
            : _node$assertions.length) > 0
        ) {
          this.raise(
            Errors.ImportReflectionHasAssertion,
            specifiers[0].loc.start
          );
        }
      }
    }
    checkJSONModuleImport(node) {
      if (
        this.isJSONModuleImport(node) &&
        node.type !== 'ExportAllDeclaration'
      ) {
        const {specifiers: specifiers} = node;
        if (specifiers != null) {
          const nonDefaultNamedSpecifier = specifiers.find(specifier => {
            let imported;
            if (specifier.type === 'ExportSpecifier') {
              imported = specifier.local;
            } else if (specifier.type === 'ImportSpecifier') {
              imported = specifier.imported;
            }
            if (imported !== undefined) {
              return imported.type === 'Identifier'
                ? imported.name !== 'default'
                : imported.value !== 'default';
            }
          });
          if (nonDefaultNamedSpecifier !== undefined) {
            this.raise(
              Errors.ImportJSONBindingNotDefault,
              nonDefaultNamedSpecifier.loc.start
            );
          }
        }
      }
    }
    isPotentialImportPhase(isExport) {
      if (isExport) return false;
      return (
        this.isContextual(105) ||
        this.isContextual(97) ||
        this.isContextual(127)
      );
    }
    applyImportPhase(node, isExport, phase, loc) {
      if (isExport) {
        return;
      }
      if (phase === 'module') {
        this.expectPlugin('importReflection', loc);
        node.module = true;
      } else if (this.hasPlugin('importReflection')) {
        node.module = false;
      }
      if (phase === 'source') {
        this.expectPlugin('sourcePhaseImports', loc);
        node.phase = 'source';
      } else if (phase === 'defer') {
        this.expectPlugin('deferredImportEvaluation', loc);
        node.phase = 'defer';
      } else if (this.hasPlugin('sourcePhaseImports')) {
        node.phase = null;
      }
    }
    parseMaybeImportPhase(node, isExport) {
      if (!this.isPotentialImportPhase(isExport)) {
        this.applyImportPhase(node, isExport, null);
        return null;
      }
      const phaseIdentifier = this.parseIdentifier(true);
      const {type: type} = this.state;
      const isImportPhase = tokenIsKeywordOrIdentifier(type)
        ? type !== 98 || this.lookaheadCharCode() === 102
        : type !== 12;
      if (isImportPhase) {
        this.resetPreviousIdentifierLeadingComments(phaseIdentifier);
        this.applyImportPhase(
          node,
          isExport,
          phaseIdentifier.name,
          phaseIdentifier.loc.start
        );
        return null;
      } else {
        this.applyImportPhase(node, isExport, null);
        return phaseIdentifier;
      }
    }
    isPrecedingIdImportPhase(phase) {
      const {type: type} = this.state;
      return tokenIsIdentifier(type)
        ? type !== 98 || this.lookaheadCharCode() === 102
        : type !== 12;
    }
    parseImport(node) {
      if (this.match(133)) {
        return this.parseImportSourceAndAttributes(node);
      }
      return this.parseImportSpecifiersAndAfter(
        node,
        this.parseMaybeImportPhase(node, false)
      );
    }
    parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier) {
      node.specifiers = [];
      const hasDefault = this.maybeParseDefaultImportSpecifier(
        node,
        maybeDefaultIdentifier
      );
      const parseNext = !hasDefault || this.eat(12);
      const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
      if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
      this.expectContextual(98);
      return this.parseImportSourceAndAttributes(node);
    }
    parseImportSourceAndAttributes(node) {
      var _node$specifiers2;
      (_node$specifiers2 = node.specifiers) != null
        ? _node$specifiers2
        : (node.specifiers = []);
      node.source = this.parseImportSource();
      this.maybeParseImportAttributes(node);
      this.checkImportReflection(node);
      this.checkJSONModuleImport(node);
      this.semicolon();
      return this.finishNode(node, 'ImportDeclaration');
    }
    parseImportSource() {
      if (!this.match(133)) this.unexpected();
      return this.parseExprAtom();
    }
    parseImportSpecifierLocal(node, specifier, type) {
      specifier.local = this.parseIdentifier();
      node.specifiers.push(this.finishImportSpecifier(specifier, type));
    }
    finishImportSpecifier(specifier, type, bindingType = 8201) {
      this.checkLVal(specifier.local, {type: type}, bindingType);
      return this.finishNode(specifier, type);
    }
    parseImportAttributes() {
      this.expect(5);
      const attrs = [];
      const attrNames = new Set();
      do {
        if (this.match(8)) {
          break;
        }
        const node = this.startNode();
        const keyName = this.state.value;
        if (attrNames.has(keyName)) {
          this.raise(
            Errors.ModuleAttributesWithDuplicateKeys,
            this.state.startLoc,
            {key: keyName}
          );
        }
        attrNames.add(keyName);
        if (this.match(133)) {
          node.key = this.parseStringLiteral(keyName);
        } else {
          node.key = this.parseIdentifier(true);
        }
        this.expect(14);
        if (!this.match(133)) {
          throw this.raise(
            Errors.ModuleAttributeInvalidValue,
            this.state.startLoc
          );
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, 'ImportAttribute'));
      } while (this.eat(12));
      this.expect(8);
      return attrs;
    }
    parseModuleAttributes() {
      const attrs = [];
      const attributes = new Set();
      do {
        const node = this.startNode();
        node.key = this.parseIdentifier(true);
        if (node.key.name !== 'type') {
          this.raise(Errors.ModuleAttributeDifferentFromType, node.key);
        }
        if (attributes.has(node.key.name)) {
          this.raise(Errors.ModuleAttributesWithDuplicateKeys, node.key, {
            key: node.key.name,
          });
        }
        attributes.add(node.key.name);
        this.expect(14);
        if (!this.match(133)) {
          throw this.raise(
            Errors.ModuleAttributeInvalidValue,
            this.state.startLoc
          );
        }
        node.value = this.parseStringLiteral(this.state.value);
        attrs.push(this.finishNode(node, 'ImportAttribute'));
      } while (this.eat(12));
      return attrs;
    }
    maybeParseImportAttributes(node) {
      let attributes;
      let useWith = false;
      if (this.match(76)) {
        if (this.hasPrecedingLineBreak() && this.lookaheadCharCode() === 40) {
          return;
        }
        this.next();
        {
          if (this.hasPlugin('moduleAttributes')) {
            attributes = this.parseModuleAttributes();
          } else {
            this.expectImportAttributesPlugin();
            attributes = this.parseImportAttributes();
          }
        }
        useWith = true;
      } else if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
        if (this.hasPlugin('importAttributes')) {
          if (
            this.getPluginOption(
              'importAttributes',
              'deprecatedAssertSyntax'
            ) !== true
          ) {
            this.raise(Errors.ImportAttributesUseAssert, this.state.startLoc);
          }
          this.addExtra(node, 'deprecatedAssertSyntax', true);
        } else {
          this.expectOnePlugin(['importAttributes', 'importAssertions']);
        }
        this.next();
        attributes = this.parseImportAttributes();
      } else if (
        this.hasPlugin('importAttributes') ||
        this.hasPlugin('importAssertions')
      ) {
        attributes = [];
      } else {
        if (this.hasPlugin('moduleAttributes')) {
          attributes = [];
        } else return;
      }
      if (!useWith && this.hasPlugin('importAssertions')) {
        node.assertions = attributes;
      } else {
        node.attributes = attributes;
      }
    }
    maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier) {
      if (maybeDefaultIdentifier) {
        const specifier = this.startNodeAtNode(maybeDefaultIdentifier);
        specifier.local = maybeDefaultIdentifier;
        node.specifiers.push(
          this.finishImportSpecifier(specifier, 'ImportDefaultSpecifier')
        );
        return true;
      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
        this.parseImportSpecifierLocal(
          node,
          this.startNode(),
          'ImportDefaultSpecifier'
        );
        return true;
      }
      return false;
    }
    maybeParseStarImportSpecifier(node) {
      if (this.match(55)) {
        const specifier = this.startNode();
        this.next();
        this.expectContextual(93);
        this.parseImportSpecifierLocal(
          node,
          specifier,
          'ImportNamespaceSpecifier'
        );
        return true;
      }
      return false;
    }
    parseNamedImportSpecifiers(node) {
      let first = true;
      this.expect(5);
      while (!this.eat(8)) {
        if (first) {
          first = false;
        } else {
          if (this.eat(14)) {
            throw this.raise(
              Errors.DestructureNamedImport,
              this.state.startLoc
            );
          }
          this.expect(12);
          if (this.eat(8)) break;
        }
        const specifier = this.startNode();
        const importedIsString = this.match(133);
        const isMaybeTypeOnly = this.isContextual(130);
        specifier.imported = this.parseModuleExportName();
        const importSpecifier = this.parseImportSpecifier(
          specifier,
          importedIsString,
          node.importKind === 'type' || node.importKind === 'typeof',
          isMaybeTypeOnly,
          undefined
        );
        node.specifiers.push(importSpecifier);
      }
    }
    parseImportSpecifier(
      specifier,
      importedIsString,
      isInTypeOnlyImport,
      isMaybeTypeOnly,
      bindingType
    ) {
      if (this.eatContextual(93)) {
        specifier.local = this.parseIdentifier();
      } else {
        const {imported: imported} = specifier;
        if (importedIsString) {
          throw this.raise(Errors.ImportBindingIsString, specifier, {
            importName: imported.value,
          });
        }
        this.checkReservedWord(imported.name, specifier.loc.start, true, true);
        if (!specifier.local) {
          specifier.local = cloneIdentifier(imported);
        }
      }
      return this.finishImportSpecifier(
        specifier,
        'ImportSpecifier',
        bindingType
      );
    }
    isThisParam(param) {
      return param.type === 'Identifier' && param.name === 'this';
    }
  }
  class Parser extends StatementParser {
    constructor(options, input, pluginsMap) {
      options = getOptions(options);
      super(options, input);
      this.options = options;
      this.initializeScopes();
      this.plugins = pluginsMap;
      this.filename = options.sourceFilename;
    }
    getScopeHandler() {
      return ScopeHandler;
    }
    parse() {
      this.enterInitialScopes();
      const file = this.startNode();
      const program = this.startNode();
      this.nextToken();
      file.errors = null;
      this.parseTopLevel(file, program);
      file.errors = this.state.errors;
      file.comments.length = this.state.commentsLen;
      return file;
    }
  }
  function parse(input, options) {
    var _options;
    if (
      ((_options = options) == null ? void 0 : _options.sourceType) ===
      'unambiguous'
    ) {
      options = Object.assign({}, options);
      try {
        options.sourceType = 'module';
        const parser = getParser(options, input);
        const ast = parser.parse();
        if (parser.sawUnambiguousESM) {
          return ast;
        }
        if (parser.ambiguousScriptDifferentAst) {
          try {
            options.sourceType = 'script';
            return getParser(options, input).parse();
          } catch (_unused) {}
        } else {
          ast.program.sourceType = 'script';
        }
        return ast;
      } catch (moduleError) {
        try {
          options.sourceType = 'script';
          return getParser(options, input).parse();
        } catch (_unused2) {}
        throw moduleError;
      }
    } else {
      return getParser(options, input).parse();
    }
  }
  function parseExpression(input, options) {
    const parser = getParser(options, input);
    if (parser.options.strictMode) {
      parser.state.strict = true;
    }
    return parser.getExpression();
  }
  function generateExportedTokenTypes(internalTokenTypes) {
    const tokenTypes = {};
    for (const typeName of Object.keys(internalTokenTypes)) {
      tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
    }
    return tokenTypes;
  }
  const tokTypes = generateExportedTokenTypes(tt);
  function getParser(options, input) {
    let cls = Parser;
    const pluginsMap = new Map();
    if (options != null && options.plugins) {
      for (const plugin of options.plugins) {
        let name, opts;
        if (typeof plugin === 'string') {
          name = plugin;
        } else {
          [name, opts] = plugin;
        }
        if (!pluginsMap.has(name)) {
          pluginsMap.set(name, opts || {});
        }
      }
      validatePlugins(pluginsMap);
      cls = getParserClass(pluginsMap);
    }
    return new cls(options, input, pluginsMap);
  }
  const parserClassCache = new Map();
  function getParserClass(pluginsMap) {
    const pluginList = [];
    for (const name of mixinPluginNames) {
      if (pluginsMap.has(name)) {
        pluginList.push(name);
      }
    }
    const key = pluginList.join('|');
    let cls = parserClassCache.get(key);
    if (!cls) {
      cls = Parser;
      for (const plugin of pluginList) {
        cls = mixinPlugins[plugin](cls);
      }
      parserClassCache.set(key, cls);
    }
    return cls;
  }
  lib$3.parse = parse;
  lib$3.parseExpression = parseExpression;
  lib$3.tokTypes = tokTypes;
  return lib$3;
}
var lib$2 = {};
var hasRequiredLib$4;
function requireLib$4() {
  if (hasRequiredLib$4) return lib$2;
  hasRequiredLib$4 = 1;
  Object.defineProperty(lib$2, '__esModule', {value: true});
  lib$2.codeFrameColumns = codeFrameColumns;
  lib$2.default = _default;
  var _highlight = requireLib$8();
  var _picocolors = _interopRequireWildcard(requirePicocolors(), true);
  function _getRequireWildcardCache(e) {
    if ('function' != typeof WeakMap) return null;
    var r = new WeakMap(),
      t = new WeakMap();
    return (_getRequireWildcardCache = function (e) {
      return e ? t : r;
    })(e);
  }
  function _interopRequireWildcard(e, r) {
    if (null === e || ('object' != typeof e && 'function' != typeof e))
      return {default: e};
    var t = _getRequireWildcardCache(r);
    if (t && t.has(e)) return t.get(e);
    var n = {__proto__: null},
      a = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var u in e)
      if ('default' !== u && {}.hasOwnProperty.call(e, u)) {
        var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
        i && (i.get || i.set) ? Object.defineProperty(n, u, i) : (n[u] = e[u]);
      }
    return (n.default = e), t && t.set(e, n), n;
  }
  const colors =
    typeof process === 'object' &&
    (process.env.FORCE_COLOR === '0' || process.env.FORCE_COLOR === 'false')
      ? (0, _picocolors.createColors)(false)
      : _picocolors.default;
  const compose = (f, g) => v => f(g(v));
  let pcWithForcedColor = undefined;
  function getColors(forceColor) {
    if (forceColor) {
      var _pcWithForcedColor;
      (_pcWithForcedColor = pcWithForcedColor) != null
        ? _pcWithForcedColor
        : (pcWithForcedColor = (0, _picocolors.createColors)(true));
      return pcWithForcedColor;
    }
    return colors;
  }
  let deprecationWarningShown = false;
  function getDefs(colors) {
    return {
      gutter: colors.gray,
      marker: compose(colors.red, colors.bold),
      message: compose(colors.red, colors.bold),
    };
  }
  const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
  function getMarkerLines(loc, source, opts) {
    const startLoc = Object.assign({column: 0, line: -1}, loc.start);
    const endLoc = Object.assign({}, startLoc, loc.end);
    const {linesAbove: linesAbove = 2, linesBelow: linesBelow = 3} = opts || {};
    const startLine = startLoc.line;
    const startColumn = startLoc.column;
    const endLine = endLoc.line;
    const endColumn = endLoc.column;
    let start = Math.max(startLine - (linesAbove + 1), 0);
    let end = Math.min(source.length, endLine + linesBelow);
    if (startLine === -1) {
      start = 0;
    }
    if (endLine === -1) {
      end = source.length;
    }
    const lineDiff = endLine - startLine;
    const markerLines = {};
    if (lineDiff) {
      for (let i = 0; i <= lineDiff; i++) {
        const lineNumber = i + startLine;
        if (!startColumn) {
          markerLines[lineNumber] = true;
        } else if (i === 0) {
          const sourceLength = source[lineNumber - 1].length;
          markerLines[lineNumber] = [
            startColumn,
            sourceLength - startColumn + 1,
          ];
        } else if (i === lineDiff) {
          markerLines[lineNumber] = [0, endColumn];
        } else {
          const sourceLength = source[lineNumber - i].length;
          markerLines[lineNumber] = [0, sourceLength];
        }
      }
    } else {
      if (startColumn === endColumn) {
        if (startColumn) {
          markerLines[startLine] = [startColumn, 0];
        } else {
          markerLines[startLine] = true;
        }
      } else {
        markerLines[startLine] = [startColumn, endColumn - startColumn];
      }
    }
    return {start: start, end: end, markerLines: markerLines};
  }
  function codeFrameColumns(rawLines, loc, opts = {}) {
    const highlighted =
      (opts.highlightCode || opts.forceColor) &&
      (0, _highlight.shouldHighlight)(opts);
    const colors = getColors(opts.forceColor);
    const defs = getDefs(colors);
    const maybeHighlight = (fmt, string) =>
      highlighted ? fmt(string) : string;
    const lines = rawLines.split(NEWLINE);
    const {
      start: start,
      end: end,
      markerLines: markerLines,
    } = getMarkerLines(loc, lines, opts);
    const hasColumns = loc.start && typeof loc.start.column === 'number';
    const numberMaxWidth = String(end).length;
    const highlightedLines = highlighted
      ? (0, _highlight.default)(rawLines, opts)
      : rawLines;
    let frame = highlightedLines
      .split(NEWLINE, end)
      .slice(start, end)
      .map((line, index) => {
        const number = start + 1 + index;
        const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
        const gutter = ` ${paddedNumber} |`;
        const hasMarker = markerLines[number];
        const lastMarkerLine = !markerLines[number + 1];
        if (hasMarker) {
          let markerLine = '';
          if (Array.isArray(hasMarker)) {
            const markerSpacing = line
              .slice(0, Math.max(hasMarker[0] - 1, 0))
              .replace(/[^\t]/g, ' ');
            const numberOfMarkers = hasMarker[1] || 1;
            markerLine = [
              '\n ',
              maybeHighlight(defs.gutter, gutter.replace(/\d/g, ' ')),
              ' ',
              markerSpacing,
              maybeHighlight(defs.marker, '^').repeat(numberOfMarkers),
            ].join('');
            if (lastMarkerLine && opts.message) {
              markerLine += ' ' + maybeHighlight(defs.message, opts.message);
            }
          }
          return [
            maybeHighlight(defs.marker, '>'),
            maybeHighlight(defs.gutter, gutter),
            line.length > 0 ? ` ${line}` : '',
            markerLine,
          ].join('');
        } else {
          return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ''}`;
        }
      })
      .join('\n');
    if (opts.message && !hasColumns) {
      frame = `${' '.repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
    }
    if (highlighted) {
      return colors.reset(frame);
    } else {
      return frame;
    }
  }
  function _default(rawLines, lineNumber, colNumber, opts = {}) {
    if (!deprecationWarningShown) {
      deprecationWarningShown = true;
      const message =
        'Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.';
      if (process.emitWarning) {
        process.emitWarning(message, 'DeprecationWarning');
      } else {
        const deprecationError = new Error(message);
        deprecationError.name = 'DeprecationWarning';
        console.warn(new Error(message));
      }
    }
    colNumber = Math.max(colNumber, 0);
    const location = {start: {column: colNumber, line: lineNumber}};
    return codeFrameColumns(rawLines, location, opts);
  }
  return lib$2;
}
var hasRequiredParse$1;
function requireParse$1() {
  if (hasRequiredParse$1) return parse$2;
  hasRequiredParse$1 = 1;
  Object.defineProperty(parse$2, '__esModule', {value: true});
  parse$2.default = parseAndBuildMetadata;
  var _t = t$d;
  var _parser = requireLib$5();
  var _codeFrame = requireLib$4();
  const {
    isCallExpression: isCallExpression,
    isExpressionStatement: isExpressionStatement,
    isFunction: isFunction,
    isIdentifier: isIdentifier,
    isJSXIdentifier: isJSXIdentifier,
    isNewExpression: isNewExpression,
    isPlaceholder: isPlaceholder,
    isStatement: isStatement,
    isStringLiteral: isStringLiteral,
    removePropertiesDeep: removePropertiesDeep,
    traverse: traverse,
  } = _t;
  const PATTERN = /^[_$A-Z0-9]+$/;
  function parseAndBuildMetadata(formatter, code, opts) {
    const {
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      preserveComments: preserveComments,
      syntacticPlaceholders: syntacticPlaceholders,
    } = opts;
    const ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
    removePropertiesDeep(ast, {preserveComments: preserveComments});
    formatter.validate(ast);
    const state = {
      syntactic: {placeholders: [], placeholderNames: new Set()},
      legacy: {placeholders: [], placeholderNames: new Set()},
      placeholderWhitelist: placeholderWhitelist,
      placeholderPattern: placeholderPattern,
      syntacticPlaceholders: syntacticPlaceholders,
    };
    traverse(ast, placeholderVisitorHandler, state);
    return Object.assign(
      {ast: ast},
      state.syntactic.placeholders.length ? state.syntactic : state.legacy
    );
  }
  function placeholderVisitorHandler(node, ancestors, state) {
    var _state$placeholderWhi;
    let name;
    let hasSyntacticPlaceholders = state.syntactic.placeholders.length > 0;
    if (isPlaceholder(node)) {
      if (state.syntacticPlaceholders === false) {
        throw new Error(
          "%%foo%%-style placeholders can't be used when " +
            "'.syntacticPlaceholders' is false."
        );
      }
      name = node.name.name;
      hasSyntacticPlaceholders = true;
    } else if (hasSyntacticPlaceholders || state.syntacticPlaceholders) {
      return;
    } else if (isIdentifier(node) || isJSXIdentifier(node)) {
      name = node.name;
    } else if (isStringLiteral(node)) {
      name = node.value;
    } else {
      return;
    }
    if (
      hasSyntacticPlaceholders &&
      (state.placeholderPattern != null || state.placeholderWhitelist != null)
    ) {
      throw new Error(
        "'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" +
          " with '.syntacticPlaceholders: true'"
      );
    }
    if (
      !hasSyntacticPlaceholders &&
      (state.placeholderPattern === false ||
        !(state.placeholderPattern || PATTERN).test(name)) &&
      !(
        (_state$placeholderWhi = state.placeholderWhitelist) != null &&
        _state$placeholderWhi.has(name)
      )
    ) {
      return;
    }
    ancestors = ancestors.slice();
    const {node: parent, key: key} = ancestors[ancestors.length - 1];
    let type;
    if (
      isStringLiteral(node) ||
      isPlaceholder(node, {expectedNode: 'StringLiteral'})
    ) {
      type = 'string';
    } else if (
      (isNewExpression(parent) && key === 'arguments') ||
      (isCallExpression(parent) && key === 'arguments') ||
      (isFunction(parent) && key === 'params')
    ) {
      type = 'param';
    } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
      type = 'statement';
      ancestors = ancestors.slice(0, -1);
    } else if (isStatement(node) && isPlaceholder(node)) {
      type = 'statement';
    } else {
      type = 'other';
    }
    const {placeholders: placeholders, placeholderNames: placeholderNames} =
      !hasSyntacticPlaceholders ? state.legacy : state.syntactic;
    placeholders.push({
      name: name,
      type: type,
      resolve: ast => resolveAncestors(ast, ancestors),
      isDuplicate: placeholderNames.has(name),
    });
    placeholderNames.add(name);
  }
  function resolveAncestors(ast, ancestors) {
    let parent = ast;
    for (let i = 0; i < ancestors.length - 1; i++) {
      const {key: key, index: index} = ancestors[i];
      if (index === undefined) {
        parent = parent[key];
      } else {
        parent = parent[key][index];
      }
    }
    const {key: key, index: index} = ancestors[ancestors.length - 1];
    return {parent: parent, key: key, index: index};
  }
  function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
    const plugins = (parserOpts.plugins || []).slice();
    if (syntacticPlaceholders !== false) {
      plugins.push('placeholders');
    }
    parserOpts = Object.assign(
      {
        allowReturnOutsideFunction: true,
        allowSuperOutsideMethod: true,
        sourceType: 'module',
      },
      parserOpts,
      {plugins: plugins}
    );
    try {
      return (0, _parser.parse)(code, parserOpts);
    } catch (err) {
      const loc = err.loc;
      if (loc) {
        err.message +=
          '\n' + (0, _codeFrame.codeFrameColumns)(code, {start: loc});
        err.code = 'BABEL_TEMPLATE_PARSE_ERROR';
      }
      throw err;
    }
  }
  return parse$2;
}
var populate = {};
var hasRequiredPopulate;
function requirePopulate() {
  if (hasRequiredPopulate) return populate;
  hasRequiredPopulate = 1;
  Object.defineProperty(populate, '__esModule', {value: true});
  populate.default = populatePlaceholders;
  var _t = t$d;
  const {
    blockStatement: blockStatement,
    cloneNode: cloneNode,
    emptyStatement: emptyStatement,
    expressionStatement: expressionStatement,
    identifier: identifier,
    isStatement: isStatement,
    isStringLiteral: isStringLiteral,
    stringLiteral: stringLiteral,
    validate: validate,
  } = _t;
  function populatePlaceholders(metadata, replacements) {
    const ast = cloneNode(metadata.ast);
    if (replacements) {
      metadata.placeholders.forEach(placeholder => {
        if (!hasOwnProperty.call(replacements, placeholder.name)) {
          const placeholderName = placeholder.name;
          throw new Error(
            `Error: No substitution given for "${placeholderName}". If this is not meant to be a\n            placeholder you may want to consider passing one of the following options to @babel/template:\n            - { placeholderPattern: false, placeholderWhitelist: new Set(['${placeholderName}'])}\n            - { placeholderPattern: /^${placeholderName}$/ }`
          );
        }
      });
      Object.keys(replacements).forEach(key => {
        if (!metadata.placeholderNames.has(key)) {
          throw new Error(`Unknown substitution "${key}" given`);
        }
      });
    }
    metadata.placeholders
      .slice()
      .reverse()
      .forEach(placeholder => {
        try {
          applyReplacement(
            placeholder,
            ast,
            (replacements && replacements[placeholder.name]) || null
          );
        } catch (e) {
          e.message = `@babel/template placeholder "${placeholder.name}": ${e.message}`;
          throw e;
        }
      });
    return ast;
  }
  function applyReplacement(placeholder, ast, replacement) {
    if (placeholder.isDuplicate) {
      if (Array.isArray(replacement)) {
        replacement = replacement.map(node => cloneNode(node));
      } else if (typeof replacement === 'object') {
        replacement = cloneNode(replacement);
      }
    }
    const {parent: parent, key: key, index: index} = placeholder.resolve(ast);
    if (placeholder.type === 'string') {
      if (typeof replacement === 'string') {
        replacement = stringLiteral(replacement);
      }
      if (!replacement || !isStringLiteral(replacement)) {
        throw new Error('Expected string substitution');
      }
    } else if (placeholder.type === 'statement') {
      if (index === undefined) {
        if (!replacement) {
          replacement = emptyStatement();
        } else if (Array.isArray(replacement)) {
          replacement = blockStatement(replacement);
        } else if (typeof replacement === 'string') {
          replacement = expressionStatement(identifier(replacement));
        } else if (!isStatement(replacement)) {
          replacement = expressionStatement(replacement);
        }
      } else {
        if (replacement && !Array.isArray(replacement)) {
          if (typeof replacement === 'string') {
            replacement = identifier(replacement);
          }
          if (!isStatement(replacement)) {
            replacement = expressionStatement(replacement);
          }
        }
      }
    } else if (placeholder.type === 'param') {
      if (typeof replacement === 'string') {
        replacement = identifier(replacement);
      }
      if (index === undefined) throw new Error('Assertion failure.');
    } else {
      if (typeof replacement === 'string') {
        replacement = identifier(replacement);
      }
      if (Array.isArray(replacement)) {
        throw new Error('Cannot replace single expression with an array.');
      }
    }
    function set(parent, key, value) {
      const node = parent[key];
      parent[key] = value;
      if (node.type === 'Identifier') {
        if (node.typeAnnotation) {
          value.typeAnnotation = node.typeAnnotation;
        }
        if (node.optional) {
          value.optional = node.optional;
        }
        if (node.decorators) {
          value.decorators = node.decorators;
        }
      }
    }
    if (index === undefined) {
      validate(parent, key, replacement);
      set(parent, key, replacement);
    } else {
      const items = parent[key].slice();
      if (placeholder.type === 'statement' || placeholder.type === 'param') {
        if (replacement == null) {
          items.splice(index, 1);
        } else if (Array.isArray(replacement)) {
          items.splice(index, 1, ...replacement);
        } else {
          set(items, index, replacement);
        }
      } else {
        set(items, index, replacement);
      }
      validate(parent, key, items);
      parent[key] = items;
    }
  }
  return populate;
}
var hasRequiredString;
function requireString() {
  if (hasRequiredString) return string;
  hasRequiredString = 1;
  Object.defineProperty(string, '__esModule', {value: true});
  string.default = stringTemplate;
  var _options = requireOptions();
  var _parse = requireParse$1();
  var _populate = requirePopulate();
  function stringTemplate(formatter, code, opts) {
    code = formatter.code(code);
    let metadata;
    return arg => {
      const replacements = (0, _options.normalizeReplacements)(arg);
      if (!metadata) metadata = (0, _parse.default)(formatter, code, opts);
      return formatter.unwrap((0, _populate.default)(metadata, replacements));
    };
  }
  return string;
}
var literal$1 = {};
var hasRequiredLiteral;
function requireLiteral() {
  if (hasRequiredLiteral) return literal$1;
  hasRequiredLiteral = 1;
  Object.defineProperty(literal$1, '__esModule', {value: true});
  literal$1.default = literalTemplate;
  var _options = requireOptions();
  var _parse = requireParse$1();
  var _populate = requirePopulate();
  function literalTemplate(formatter, tpl, opts) {
    const {metadata: metadata, names: names} = buildLiteralData(
      formatter,
      tpl,
      opts
    );
    return arg => {
      const defaultReplacements = {};
      arg.forEach((replacement, i) => {
        defaultReplacements[names[i]] = replacement;
      });
      return arg => {
        const replacements = (0, _options.normalizeReplacements)(arg);
        if (replacements) {
          Object.keys(replacements).forEach(key => {
            if (hasOwnProperty.call(defaultReplacements, key)) {
              throw new Error('Unexpected replacement overlap.');
            }
          });
        }
        return formatter.unwrap(
          (0, _populate.default)(
            metadata,
            replacements
              ? Object.assign(replacements, defaultReplacements)
              : defaultReplacements
          )
        );
      };
    };
  }
  function buildLiteralData(formatter, tpl, opts) {
    let prefix = 'BABEL_TPL$';
    const raw = tpl.join('');
    do {
      prefix = '$$' + prefix;
    } while (raw.includes(prefix));
    const {names: names, code: code} = buildTemplateCode(tpl, prefix);
    const metadata = (0, _parse.default)(formatter, formatter.code(code), {
      parser: opts.parser,
      placeholderWhitelist: new Set(
        names.concat(
          opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : []
        )
      ),
      placeholderPattern: opts.placeholderPattern,
      preserveComments: opts.preserveComments,
      syntacticPlaceholders: opts.syntacticPlaceholders,
    });
    return {metadata: metadata, names: names};
  }
  function buildTemplateCode(tpl, prefix) {
    const names = [];
    let code = tpl[0];
    for (let i = 1; i < tpl.length; i++) {
      const value = `${prefix}${i - 1}`;
      names.push(value);
      code += value + tpl[i];
    }
    return {names: names, code: code};
  }
  return literal$1;
}
var hasRequiredBuilder;
function requireBuilder() {
  if (hasRequiredBuilder) return builder;
  hasRequiredBuilder = 1;
  Object.defineProperty(builder, '__esModule', {value: true});
  builder.default = createTemplateBuilder;
  var _options = requireOptions();
  var _string = requireString();
  var _literal = requireLiteral();
  const NO_PLACEHOLDER = (0, _options.validate)({placeholderPattern: false});
  function createTemplateBuilder(formatter, defaultOpts) {
    const templateFnCache = new WeakMap();
    const templateAstCache = new WeakMap();
    const cachedOpts = defaultOpts || (0, _options.validate)(null);
    return Object.assign(
      (tpl, ...args) => {
        if (typeof tpl === 'string') {
          if (args.length > 1) throw new Error('Unexpected extra params.');
          return extendedTrace(
            (0, _string.default)(
              formatter,
              tpl,
              (0, _options.merge)(cachedOpts, (0, _options.validate)(args[0]))
            )
          );
        } else if (Array.isArray(tpl)) {
          let builder = templateFnCache.get(tpl);
          if (!builder) {
            builder = (0, _literal.default)(formatter, tpl, cachedOpts);
            templateFnCache.set(tpl, builder);
          }
          return extendedTrace(builder(args));
        } else if (typeof tpl === 'object' && tpl) {
          if (args.length > 0) throw new Error('Unexpected extra params.');
          return createTemplateBuilder(
            formatter,
            (0, _options.merge)(cachedOpts, (0, _options.validate)(tpl))
          );
        }
        throw new Error(`Unexpected template param ${typeof tpl}`);
      },
      {
        ast: (tpl, ...args) => {
          if (typeof tpl === 'string') {
            if (args.length > 1) throw new Error('Unexpected extra params.');
            return (0, _string.default)(
              formatter,
              tpl,
              (0, _options.merge)(
                (0, _options.merge)(
                  cachedOpts,
                  (0, _options.validate)(args[0])
                ),
                NO_PLACEHOLDER
              )
            )();
          } else if (Array.isArray(tpl)) {
            let builder = templateAstCache.get(tpl);
            if (!builder) {
              builder = (0, _literal.default)(
                formatter,
                tpl,
                (0, _options.merge)(cachedOpts, NO_PLACEHOLDER)
              );
              templateAstCache.set(tpl, builder);
            }
            return builder(args)();
          }
          throw new Error(`Unexpected template param ${typeof tpl}`);
        },
      }
    );
  }
  function extendedTrace(fn) {
    let rootStack = '';
    try {
      throw new Error();
    } catch (error) {
      if (error.stack) {
        rootStack = error.stack.split('\n').slice(3).join('\n');
      }
    }
    return arg => {
      try {
        return fn(arg);
      } catch (err) {
        err.stack += `\n    =============\n${rootStack}`;
        throw err;
      }
    };
  }
  return builder;
}
var hasRequiredLib$3;
function requireLib$3() {
  if (hasRequiredLib$3) return lib$4;
  hasRequiredLib$3 = 1;
  Object.defineProperty(lib$4, '__esModule', {value: true});
  lib$4.statements =
    lib$4.statement =
    lib$4.smart =
    lib$4.program =
    lib$4.expression =
    lib$4.default =
      void 0;
  var formatters = requireFormatters();
  var _builder = requireBuilder();
  const smart = (lib$4.smart = (0, _builder.default)(formatters.smart));
  const statement = (lib$4.statement = (0, _builder.default)(
    formatters.statement
  ));
  const statements = (lib$4.statements = (0, _builder.default)(
    formatters.statements
  ));
  const expression = (lib$4.expression = (0, _builder.default)(
    formatters.expression
  ));
  const program = (lib$4.program = (0, _builder.default)(formatters.program));
  lib$4.default = Object.assign(smart.bind(undefined), {
    smart: smart,
    statement: statement,
    statements: statements,
    expression: expression,
    program: program,
    ast: smart.ast,
  });
  return lib$4;
}
var hasRequiredLib$2;
function requireLib$2() {
  if (hasRequiredLib$2) return lib$5;
  hasRequiredLib$2 = 1;
  Object.defineProperty(lib$5, '__esModule', {value: true});
  lib$5.default = _default;
  var _template = requireLib$3();
  var _t = t$d;
  const {
    NOT_LOCAL_BINDING: NOT_LOCAL_BINDING,
    cloneNode: cloneNode,
    identifier: identifier,
    isAssignmentExpression: isAssignmentExpression,
    isAssignmentPattern: isAssignmentPattern,
    isFunction: isFunction,
    isIdentifier: isIdentifier,
    isLiteral: isLiteral,
    isNullLiteral: isNullLiteral,
    isObjectMethod: isObjectMethod,
    isObjectProperty: isObjectProperty,
    isRegExpLiteral: isRegExpLiteral,
    isRestElement: isRestElement,
    isTemplateLiteral: isTemplateLiteral,
    isVariableDeclarator: isVariableDeclarator,
    toBindingIdentifierName: toBindingIdentifierName,
  } = _t;
  function getFunctionArity(node) {
    const count = node.params.findIndex(
      param => isAssignmentPattern(param) || isRestElement(param)
    );
    return count === -1 ? node.params.length : count;
  }
  const buildPropertyMethodAssignmentWrapper = _template.default.statement(
    `\n  (function (FUNCTION_KEY) {\n    function FUNCTION_ID() {\n      return FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    }\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n`
  );
  const buildGeneratorPropertyMethodAssignmentWrapper =
    _template.default.statement(
      `\n  (function (FUNCTION_KEY) {\n    function* FUNCTION_ID() {\n      return yield* FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    };\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n`
    );
  const visitor = {
    'ReferencedIdentifier|BindingIdentifier'(path, state) {
      if (path.node.name !== state.name) return;
      const localDeclar = path.scope.getBindingIdentifier(state.name);
      if (localDeclar !== state.outerDeclar) return;
      state.selfReference = true;
      path.stop();
    },
  };
  function getNameFromLiteralId(id) {
    if (isNullLiteral(id)) {
      return 'null';
    }
    if (isRegExpLiteral(id)) {
      return `_${id.pattern}_${id.flags}`;
    }
    if (isTemplateLiteral(id)) {
      return id.quasis.map(quasi => quasi.value.raw).join('');
    }
    if (id.value !== undefined) {
      return id.value + '';
    }
    return '';
  }
  function wrap(state, method, id, scope) {
    if (state.selfReference) {
      if (scope.hasBinding(id.name) && !scope.hasGlobal(id.name)) {
        scope.rename(id.name);
      } else {
        if (!isFunction(method)) return;
        let build = buildPropertyMethodAssignmentWrapper;
        if (method.generator) {
          build = buildGeneratorPropertyMethodAssignmentWrapper;
        }
        const template = build({
          FUNCTION: method,
          FUNCTION_ID: id,
          FUNCTION_KEY: scope.generateUidIdentifier(id.name),
        }).expression;
        const params = template.callee.body.body[0].params;
        for (let i = 0, len = getFunctionArity(method); i < len; i++) {
          params.push(scope.generateUidIdentifier('x'));
        }
        return template;
      }
    }
    method.id = id;
    scope.getProgramParent().references[id.name] = true;
  }
  function visit(node, name, scope) {
    const state = {
      selfAssignment: false,
      selfReference: false,
      outerDeclar: scope.getBindingIdentifier(name),
      name: name,
    };
    const binding = scope.getOwnBinding(name);
    if (binding) {
      if (binding.kind === 'param') {
        state.selfReference = true;
      }
    } else if (state.outerDeclar || scope.hasGlobal(name)) {
      scope.traverse(node, visitor, state);
    }
    return state;
  }
  function _default(
    {node: node, parent: parent, scope: scope, id: id},
    localBinding = false,
    supportUnicodeId = false
  ) {
    if (node.id) return;
    if (
      (isObjectProperty(parent) || isObjectMethod(parent, {kind: 'method'})) &&
      (!parent.computed || isLiteral(parent.key))
    ) {
      id = parent.key;
    } else if (isVariableDeclarator(parent)) {
      id = parent.id;
      if (isIdentifier(id) && !localBinding) {
        const binding = scope.parent.getBinding(id.name);
        if (
          binding &&
          binding.constant &&
          scope.getBinding(id.name) === binding
        ) {
          node.id = cloneNode(id);
          node.id[NOT_LOCAL_BINDING] = true;
          return;
        }
      }
    } else if (isAssignmentExpression(parent, {operator: '='})) {
      id = parent.left;
    } else if (!id) {
      return;
    }
    let name;
    if (id && isLiteral(id)) {
      name = getNameFromLiteralId(id);
    } else if (id && isIdentifier(id)) {
      name = id.name;
    }
    if (name === undefined) {
      return;
    }
    if (!supportUnicodeId && isFunction(node) && /[\uD800-\uDFFF]/.test(name)) {
      return;
    }
    name = toBindingIdentifierName(name);
    const newId = identifier(name);
    newId[NOT_LOCAL_BINDING] = true;
    const state = visit(node, name, scope);
    return wrap(state, node, newId, scope) || node;
  }
  return lib$5;
}
var hasRequiredConversion;
function requireConversion() {
  if (hasRequiredConversion) return conversion;
  hasRequiredConversion = 1;
  Object.defineProperty(conversion, '__esModule', {value: true});
  conversion.toComputedKey = toComputedKey;
  conversion.ensureBlock = ensureBlock;
  conversion.arrowFunctionToShadowed = arrowFunctionToShadowed;
  conversion.unwrapFunctionEnvironment = unwrapFunctionEnvironment;
  conversion.arrowFunctionToExpression = arrowFunctionToExpression;
  var t = _interopRequireWildcard(t$d);
  var _helperFunctionName = _interopRequireDefault(requireLib$2());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function toComputedKey() {
    const node = this.node;
    let key;
    if (this.isMemberExpression()) {
      key = node.property;
    } else if (this.isProperty() || this.isMethod()) {
      key = node.key;
    } else {
      throw new ReferenceError('todo');
    }
    if (!node.computed) {
      if (t.isIdentifier(key)) key = t.stringLiteral(key.name);
    }
    return key;
  }
  function ensureBlock() {
    const body = this.get('body');
    const bodyNode = body.node;
    if (Array.isArray(body)) {
      throw new Error("Can't convert array path to a block statement");
    }
    if (!bodyNode) {
      throw new Error("Can't convert node without a body");
    }
    if (body.isBlockStatement()) {
      return bodyNode;
    }
    const statements = [];
    let stringPath = 'body';
    let key;
    let listKey;
    if (body.isStatement()) {
      listKey = 'body';
      key = 0;
      statements.push(body.node);
    } else {
      stringPath += '.body.0';
      if (this.isFunction()) {
        key = 'argument';
        statements.push(t.returnStatement(body.node));
      } else {
        key = 'expression';
        statements.push(t.expressionStatement(body.node));
      }
    }
    this.node.body = t.blockStatement(statements);
    const parentPath = this.get(stringPath);
    body.setup(
      parentPath,
      listKey ? parentPath.node[listKey] : parentPath.node,
      listKey,
      key
    );
    return this.node;
  }
  function arrowFunctionToShadowed() {
    if (!this.isArrowFunctionExpression()) return;
    this.arrowFunctionToExpression();
  }
  function unwrapFunctionEnvironment() {
    if (
      !this.isArrowFunctionExpression() &&
      !this.isFunctionExpression() &&
      !this.isFunctionDeclaration()
    ) {
      throw this.buildCodeFrameError(
        'Can only unwrap the environment of a function.'
      );
    }
    hoistFunctionEnvironment(this);
  }
  function arrowFunctionToExpression({
    allowInsertArrow: allowInsertArrow = true,
    specCompliant: specCompliant = false,
  } = {}) {
    if (!this.isArrowFunctionExpression()) {
      throw this.buildCodeFrameError(
        'Cannot convert non-arrow function to a function expression.'
      );
    }
    const thisBinding = hoistFunctionEnvironment(
      this,
      specCompliant,
      allowInsertArrow
    );
    this.ensureBlock();
    this.node.type = 'FunctionExpression';
    if (specCompliant) {
      const checkBinding = thisBinding
        ? null
        : this.parentPath.scope.generateUidIdentifier('arrowCheckId');
      if (checkBinding) {
        this.parentPath.scope.push({
          id: checkBinding,
          init: t.objectExpression([]),
        });
      }
      this.get('body').unshiftContainer(
        'body',
        t.expressionStatement(
          t.callExpression(this.hub.addHelper('newArrowCheck'), [
            t.thisExpression(),
            checkBinding
              ? t.identifier(checkBinding.name)
              : t.identifier(thisBinding),
          ])
        )
      );
      this.replaceWith(
        t.callExpression(
          t.memberExpression(
            (0, _helperFunctionName.default)(this, true) || this.node,
            t.identifier('bind')
          ),
          [checkBinding ? t.identifier(checkBinding.name) : t.thisExpression()]
        )
      );
    }
  }
  function hoistFunctionEnvironment(
    fnPath,
    specCompliant = false,
    allowInsertArrow = true
  ) {
    const thisEnvFn = fnPath.findParent(
      p =>
        (p.isFunction() && !p.isArrowFunctionExpression()) ||
        p.isProgram() ||
        p.isClassProperty({static: false})
    );
    const inConstructor = thisEnvFn && thisEnvFn.node.kind === 'constructor';
    if (thisEnvFn.isClassProperty()) {
      throw fnPath.buildCodeFrameError(
        'Unable to transform arrow inside class property'
      );
    }
    const {
      thisPaths: thisPaths,
      argumentsPaths: argumentsPaths,
      newTargetPaths: newTargetPaths,
      superProps: superProps,
      superCalls: superCalls,
    } = getScopeInformation(fnPath);
    if (inConstructor && superCalls.length > 0) {
      if (!allowInsertArrow) {
        throw superCalls[0].buildCodeFrameError(
          'Unable to handle nested super() usage in arrow'
        );
      }
      const allSuperCalls = [];
      thisEnvFn.traverse({
        Function(child) {
          if (child.isArrowFunctionExpression()) return;
          child.skip();
        },
        ClassProperty(child) {
          child.skip();
        },
        CallExpression(child) {
          if (!child.get('callee').isSuper()) return;
          allSuperCalls.push(child);
        },
      });
      const superBinding = getSuperBinding(thisEnvFn);
      allSuperCalls.forEach(superCall => {
        const callee = t.identifier(superBinding);
        callee.loc = superCall.node.callee.loc;
        superCall.get('callee').replaceWith(callee);
      });
    }
    if (argumentsPaths.length > 0) {
      const argumentsBinding = getBinding(thisEnvFn, 'arguments', () =>
        t.identifier('arguments')
      );
      argumentsPaths.forEach(argumentsChild => {
        const argsRef = t.identifier(argumentsBinding);
        argsRef.loc = argumentsChild.node.loc;
        argumentsChild.replaceWith(argsRef);
      });
    }
    if (newTargetPaths.length > 0) {
      const newTargetBinding = getBinding(thisEnvFn, 'newtarget', () =>
        t.metaProperty(t.identifier('new'), t.identifier('target'))
      );
      newTargetPaths.forEach(targetChild => {
        const targetRef = t.identifier(newTargetBinding);
        targetRef.loc = targetChild.node.loc;
        targetChild.replaceWith(targetRef);
      });
    }
    if (superProps.length > 0) {
      if (!allowInsertArrow) {
        throw superProps[0].buildCodeFrameError(
          'Unable to handle nested super.prop usage'
        );
      }
      const flatSuperProps = superProps.reduce(
        (acc, superProp) => acc.concat(standardizeSuperProperty(superProp)),
        []
      );
      flatSuperProps.forEach(superProp => {
        const key = superProp.node.computed
          ? ''
          : superProp.get('property').node.name;
        const isAssignment = superProp.parentPath.isAssignmentExpression({
          left: superProp.node,
        });
        const isCall = superProp.parentPath.isCallExpression({
          callee: superProp.node,
        });
        const superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
        const args = [];
        if (superProp.node.computed) {
          args.push(superProp.get('property').node);
        }
        if (isAssignment) {
          const value = superProp.parentPath.node.right;
          args.push(value);
        }
        const call = t.callExpression(t.identifier(superBinding), args);
        if (isCall) {
          superProp.parentPath.unshiftContainer(
            'arguments',
            t.thisExpression()
          );
          superProp.replaceWith(t.memberExpression(call, t.identifier('call')));
          thisPaths.push(superProp.parentPath.get('arguments.0'));
        } else if (isAssignment) {
          superProp.parentPath.replaceWith(call);
        } else {
          superProp.replaceWith(call);
        }
      });
    }
    let thisBinding;
    if (thisPaths.length > 0 || specCompliant) {
      thisBinding = getThisBinding(thisEnvFn, inConstructor);
      if (!specCompliant || (inConstructor && hasSuperClass(thisEnvFn))) {
        thisPaths.forEach(thisChild => {
          const thisRef = thisChild.isJSX()
            ? t.jsxIdentifier(thisBinding)
            : t.identifier(thisBinding);
          thisRef.loc = thisChild.node.loc;
          thisChild.replaceWith(thisRef);
        });
        if (specCompliant) thisBinding = null;
      }
    }
    return thisBinding;
  }
  function standardizeSuperProperty(superProp) {
    if (
      superProp.parentPath.isAssignmentExpression() &&
      superProp.parentPath.node.operator !== '='
    ) {
      const assignmentPath = superProp.parentPath;
      const op = assignmentPath.node.operator.slice(0, -1);
      const value = assignmentPath.node.right;
      assignmentPath.node.operator = '=';
      if (superProp.node.computed) {
        const tmp = superProp.scope.generateDeclaredUidIdentifier('tmp');
        assignmentPath
          .get('left')
          .replaceWith(
            t.memberExpression(
              superProp.node.object,
              t.assignmentExpression('=', tmp, superProp.node.property),
              true
            )
          );
        assignmentPath
          .get('right')
          .replaceWith(
            t.binaryExpression(
              op,
              t.memberExpression(
                superProp.node.object,
                t.identifier(tmp.name),
                true
              ),
              value
            )
          );
      } else {
        assignmentPath
          .get('left')
          .replaceWith(
            t.memberExpression(superProp.node.object, superProp.node.property)
          );
        assignmentPath
          .get('right')
          .replaceWith(
            t.binaryExpression(
              op,
              t.memberExpression(
                superProp.node.object,
                t.identifier(superProp.node.property.name)
              ),
              value
            )
          );
      }
      return [
        assignmentPath.get('left'),
        assignmentPath.get('right').get('left'),
      ];
    } else if (superProp.parentPath.isUpdateExpression()) {
      const updateExpr = superProp.parentPath;
      const tmp = superProp.scope.generateDeclaredUidIdentifier('tmp');
      const computedKey = superProp.node.computed
        ? superProp.scope.generateDeclaredUidIdentifier('prop')
        : null;
      const parts = [
        t.assignmentExpression(
          '=',
          tmp,
          t.memberExpression(
            superProp.node.object,
            computedKey
              ? t.assignmentExpression(
                  '=',
                  computedKey,
                  superProp.node.property
                )
              : superProp.node.property,
            superProp.node.computed
          )
        ),
        t.assignmentExpression(
          '=',
          t.memberExpression(
            superProp.node.object,
            computedKey
              ? t.identifier(computedKey.name)
              : superProp.node.property,
            superProp.node.computed
          ),
          t.binaryExpression('+', t.identifier(tmp.name), t.numericLiteral(1))
        ),
      ];
      if (!superProp.parentPath.node.prefix) {
        parts.push(t.identifier(tmp.name));
      }
      updateExpr.replaceWith(t.sequenceExpression(parts));
      const left = updateExpr.get('expressions.0.right');
      const right = updateExpr.get('expressions.1.left');
      return [left, right];
    }
    return [superProp];
  }
  function hasSuperClass(thisEnvFn) {
    return (
      thisEnvFn.isClassMethod() &&
      !!thisEnvFn.parentPath.parentPath.node.superClass
    );
  }
  function getThisBinding(thisEnvFn, inConstructor) {
    return getBinding(thisEnvFn, 'this', thisBinding => {
      if (!inConstructor || !hasSuperClass(thisEnvFn))
        return t.thisExpression();
      const supers = new WeakSet();
      thisEnvFn.traverse({
        Function(child) {
          if (child.isArrowFunctionExpression()) return;
          child.skip();
        },
        ClassProperty(child) {
          child.skip();
        },
        CallExpression(child) {
          if (!child.get('callee').isSuper()) return;
          if (supers.has(child.node)) return;
          supers.add(child.node);
          child.replaceWithMultiple([
            child.node,
            t.assignmentExpression(
              '=',
              t.identifier(thisBinding),
              t.identifier('this')
            ),
          ]);
        },
      });
    });
  }
  function getSuperBinding(thisEnvFn) {
    return getBinding(thisEnvFn, 'supercall', () => {
      const argsBinding = thisEnvFn.scope.generateUidIdentifier('args');
      return t.arrowFunctionExpression(
        [t.restElement(argsBinding)],
        t.callExpression(t.super(), [
          t.spreadElement(t.identifier(argsBinding.name)),
        ])
      );
    });
  }
  function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
    const op = isAssignment ? 'set' : 'get';
    return getBinding(thisEnvFn, `superprop_${op}:${propName || ''}`, () => {
      const argsList = [];
      let fnBody;
      if (propName) {
        fnBody = t.memberExpression(t.super(), t.identifier(propName));
      } else {
        const method = thisEnvFn.scope.generateUidIdentifier('prop');
        argsList.unshift(method);
        fnBody = t.memberExpression(t.super(), t.identifier(method.name), true);
      }
      if (isAssignment) {
        const valueIdent = thisEnvFn.scope.generateUidIdentifier('value');
        argsList.push(valueIdent);
        fnBody = t.assignmentExpression(
          '=',
          fnBody,
          t.identifier(valueIdent.name)
        );
      }
      return t.arrowFunctionExpression(argsList, fnBody);
    });
  }
  function getBinding(thisEnvFn, key, init) {
    const cacheKey = 'binding:' + key;
    let data = thisEnvFn.getData(cacheKey);
    if (!data) {
      const id = thisEnvFn.scope.generateUidIdentifier(key);
      data = id.name;
      thisEnvFn.setData(cacheKey, data);
      thisEnvFn.scope.push({id: id, init: init(data)});
    }
    return data;
  }
  function getScopeInformation(fnPath) {
    const thisPaths = [];
    const argumentsPaths = [];
    const newTargetPaths = [];
    const superProps = [];
    const superCalls = [];
    fnPath.traverse({
      ClassProperty(child) {
        child.skip();
      },
      Function(child) {
        if (child.isArrowFunctionExpression()) return;
        child.skip();
      },
      ThisExpression(child) {
        thisPaths.push(child);
      },
      JSXIdentifier(child) {
        if (child.node.name !== 'this') return;
        if (
          !child.parentPath.isJSXMemberExpression({object: child.node}) &&
          !child.parentPath.isJSXOpeningElement({name: child.node})
        ) {
          return;
        }
        thisPaths.push(child);
      },
      CallExpression(child) {
        if (child.get('callee').isSuper()) superCalls.push(child);
      },
      MemberExpression(child) {
        if (child.get('object').isSuper()) superProps.push(child);
      },
      ReferencedIdentifier(child) {
        if (child.node.name !== 'arguments') return;
        argumentsPaths.push(child);
      },
      MetaProperty(child) {
        if (!child.get('meta').isIdentifier({name: 'new'})) return;
        if (!child.get('property').isIdentifier({name: 'target'})) return;
        newTargetPaths.push(child);
      },
    });
    return {
      thisPaths: thisPaths,
      argumentsPaths: argumentsPaths,
      newTargetPaths: newTargetPaths,
      superProps: superProps,
      superCalls: superCalls,
    };
  }
  return conversion;
}
var introspection = {};
var hasRequiredIntrospection;
function requireIntrospection() {
  if (hasRequiredIntrospection) return introspection;
  hasRequiredIntrospection = 1;
  Object.defineProperty(introspection, '__esModule', {value: true});
  introspection.matchesPattern = matchesPattern;
  introspection.has = has;
  introspection.isStatic = isStatic;
  introspection.isnt = isnt;
  introspection.equals = equals;
  introspection.isNodeType = isNodeType;
  introspection.canHaveVariableDeclarationOrExpression =
    canHaveVariableDeclarationOrExpression;
  introspection.canSwapBetweenExpressionAndStatement =
    canSwapBetweenExpressionAndStatement;
  introspection.isCompletionRecord = isCompletionRecord;
  introspection.isStatementOrBlock = isStatementOrBlock;
  introspection.referencesImport = referencesImport;
  introspection.getSource = getSource;
  introspection.willIMaybeExecuteBefore = willIMaybeExecuteBefore;
  introspection._guessExecutionStatusRelativeTo =
    _guessExecutionStatusRelativeTo;
  introspection._guessExecutionStatusRelativeToDifferentFunctions =
    _guessExecutionStatusRelativeToDifferentFunctions;
  introspection.resolve = resolve;
  introspection._resolve = _resolve;
  introspection.isConstantExpression = isConstantExpression;
  introspection.isInStrictMode = isInStrictMode;
  introspection.is = void 0;
  var _includes = _interopRequireDefault(requireIncludes());
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function matchesPattern(pattern, allowPartial) {
    return t.matchesPattern(this.node, pattern, allowPartial);
  }
  function has(key) {
    const val = this.node && this.node[key];
    if (val && Array.isArray(val)) {
      return !!val.length;
    } else {
      return !!val;
    }
  }
  function isStatic() {
    return this.scope.isStatic(this.node);
  }
  const is = has;
  introspection.is = is;
  function isnt(key) {
    return !this.has(key);
  }
  function equals(key, value) {
    return this.node[key] === value;
  }
  function isNodeType(type) {
    return t.isType(this.type, type);
  }
  function canHaveVariableDeclarationOrExpression() {
    return (
      (this.key === 'init' || this.key === 'left') && this.parentPath.isFor()
    );
  }
  function canSwapBetweenExpressionAndStatement(replacement) {
    if (this.key !== 'body' || !this.parentPath.isArrowFunctionExpression()) {
      return false;
    }
    if (this.isExpression()) {
      return t.isBlockStatement(replacement);
    } else if (this.isBlockStatement()) {
      return t.isExpression(replacement);
    }
    return false;
  }
  function isCompletionRecord(allowInsideFunction) {
    let path = this;
    let first = true;
    do {
      const container = path.container;
      if (path.isFunction() && !first) {
        return !!allowInsideFunction;
      }
      first = false;
      if (Array.isArray(container) && path.key !== container.length - 1) {
        return false;
      }
    } while ((path = path.parentPath) && !path.isProgram());
    return true;
  }
  function isStatementOrBlock() {
    if (
      this.parentPath.isLabeledStatement() ||
      t.isBlockStatement(this.container)
    ) {
      return false;
    } else {
      return (0, _includes.default)(t.STATEMENT_OR_BLOCK_KEYS, this.key);
    }
  }
  function referencesImport(moduleSource, importName) {
    if (!this.isReferencedIdentifier()) return false;
    const binding = this.scope.getBinding(this.node.name);
    if (!binding || binding.kind !== 'module') return false;
    const path = binding.path;
    const parent = path.parentPath;
    if (!parent.isImportDeclaration()) return false;
    if (parent.node.source.value === moduleSource) {
      if (!importName) return true;
    } else {
      return false;
    }
    if (path.isImportDefaultSpecifier() && importName === 'default') {
      return true;
    }
    if (path.isImportNamespaceSpecifier() && importName === '*') {
      return true;
    }
    if (path.isImportSpecifier() && path.node.imported.name === importName) {
      return true;
    }
    return false;
  }
  function getSource() {
    const node = this.node;
    if (node.end) {
      const code = this.hub.getCode();
      if (code) return code.slice(node.start, node.end);
    }
    return '';
  }
  function willIMaybeExecuteBefore(target) {
    return this._guessExecutionStatusRelativeTo(target) !== 'after';
  }
  function getOuterFunction(path) {
    return (path.scope.getFunctionParent() || path.scope.getProgramParent())
      .path;
  }
  function isExecutionUncertain(type, key) {
    switch (type) {
      case 'LogicalExpression':
        return key === 'right';
      case 'ConditionalExpression':
      case 'IfStatement':
        return key === 'consequent' || key === 'alternate';
      case 'WhileStatement':
      case 'DoWhileStatement':
      case 'ForInStatement':
      case 'ForOfStatement':
        return key === 'body';
      case 'ForStatement':
        return key === 'body' || key === 'update';
      case 'SwitchStatement':
        return key === 'cases';
      case 'TryStatement':
        return key === 'handler';
      case 'AssignmentPattern':
        return key === 'right';
      case 'OptionalMemberExpression':
        return key === 'property';
      case 'OptionalCallExpression':
        return key === 'arguments';
      default:
        return false;
    }
  }
  function isExecutionUncertainInList(paths, maxIndex) {
    for (let i = 0; i < maxIndex; i++) {
      const path = paths[i];
      if (isExecutionUncertain(path.parent.type, path.parentKey)) {
        return true;
      }
    }
    return false;
  }
  function _guessExecutionStatusRelativeTo(target) {
    const funcParent = {
      this: getOuterFunction(this),
      target: getOuterFunction(target),
    };
    if (funcParent.target.node !== funcParent.this.node) {
      return this._guessExecutionStatusRelativeToDifferentFunctions(
        funcParent.target
      );
    }
    const paths = {target: target.getAncestry(), this: this.getAncestry()};
    if (paths.target.indexOf(this) >= 0) return 'after';
    if (paths.this.indexOf(target) >= 0) return 'before';
    let commonPath;
    const commonIndex = {target: 0, this: 0};
    while (!commonPath && commonIndex.this < paths.this.length) {
      const path = paths.this[commonIndex.this];
      commonIndex.target = paths.target.indexOf(path);
      if (commonIndex.target >= 0) {
        commonPath = path;
      } else {
        commonIndex.this++;
      }
    }
    if (!commonPath) {
      throw new Error(
        'Internal Babel error - The two compared nodes' +
          " don't appear to belong to the same program."
      );
    }
    if (
      isExecutionUncertainInList(paths.this, commonIndex.this - 1) ||
      isExecutionUncertainInList(paths.target, commonIndex.target - 1)
    ) {
      return 'unknown';
    }
    const divergence = {
      this: paths.this[commonIndex.this - 1],
      target: paths.target[commonIndex.target - 1],
    };
    if (
      divergence.target.listKey &&
      divergence.this.listKey &&
      divergence.target.container === divergence.this.container
    ) {
      return divergence.target.key > divergence.this.key ? 'before' : 'after';
    }
    const keys = t.VISITOR_KEYS[commonPath.type];
    const keyPosition = {
      this: keys.indexOf(divergence.this.parentKey),
      target: keys.indexOf(divergence.target.parentKey),
    };
    return keyPosition.target > keyPosition.this ? 'before' : 'after';
  }
  const executionOrderCheckedNodes = new WeakSet();
  function _guessExecutionStatusRelativeToDifferentFunctions(target) {
    if (
      !target.isFunctionDeclaration() ||
      target.parentPath.isExportDeclaration()
    ) {
      return 'unknown';
    }
    const binding = target.scope.getBinding(target.node.id.name);
    if (!binding.references) return 'before';
    const referencePaths = binding.referencePaths;
    let allStatus;
    for (const path of referencePaths) {
      const childOfFunction = !!path.find(path => path.node === target.node);
      if (childOfFunction) continue;
      if (path.key !== 'callee' || !path.parentPath.isCallExpression()) {
        return 'unknown';
      }
      if (executionOrderCheckedNodes.has(path.node)) continue;
      executionOrderCheckedNodes.add(path.node);
      const status = this._guessExecutionStatusRelativeTo(path);
      executionOrderCheckedNodes.delete(path.node);
      if (allStatus && allStatus !== status) {
        return 'unknown';
      } else {
        allStatus = status;
      }
    }
    return allStatus;
  }
  function resolve(dangerous, resolved) {
    return this._resolve(dangerous, resolved) || this;
  }
  function _resolve(dangerous, resolved) {
    if (resolved && resolved.indexOf(this) >= 0) return;
    resolved = resolved || [];
    resolved.push(this);
    if (this.isVariableDeclarator()) {
      if (this.get('id').isIdentifier()) {
        return this.get('init').resolve(dangerous, resolved);
      }
    } else if (this.isReferencedIdentifier()) {
      const binding = this.scope.getBinding(this.node.name);
      if (!binding) return;
      if (!binding.constant) return;
      if (binding.kind === 'module') return;
      if (binding.path !== this) {
        const ret = binding.path.resolve(dangerous, resolved);
        if (this.find(parent => parent.node === ret.node)) return;
        return ret;
      }
    } else if (this.isTypeCastExpression()) {
      return this.get('expression').resolve(dangerous, resolved);
    } else if (dangerous && this.isMemberExpression()) {
      const targetKey = this.toComputedKey();
      if (!t.isLiteral(targetKey)) return;
      const targetName = targetKey.value;
      const target = this.get('object').resolve(dangerous, resolved);
      if (target.isObjectExpression()) {
        const props = target.get('properties');
        for (const prop of props) {
          if (!prop.isProperty()) continue;
          const key = prop.get('key');
          let match =
            prop.isnt('computed') && key.isIdentifier({name: targetName});
          match = match || key.isLiteral({value: targetName});
          if (match) return prop.get('value').resolve(dangerous, resolved);
        }
      } else if (target.isArrayExpression() && !isNaN(+targetName)) {
        const elems = target.get('elements');
        const elem = elems[targetName];
        if (elem) return elem.resolve(dangerous, resolved);
      }
    }
  }
  function isConstantExpression() {
    if (this.isIdentifier()) {
      const binding = this.scope.getBinding(this.node.name);
      if (!binding) return false;
      return binding.constant;
    }
    if (this.isLiteral()) {
      if (this.isRegExpLiteral()) {
        return false;
      }
      if (this.isTemplateLiteral()) {
        return this.get('expressions').every(expression =>
          expression.isConstantExpression()
        );
      }
      return true;
    }
    if (this.isUnaryExpression()) {
      if (this.get('operator').node !== 'void') {
        return false;
      }
      return this.get('argument').isConstantExpression();
    }
    if (this.isBinaryExpression()) {
      return (
        this.get('left').isConstantExpression() &&
        this.get('right').isConstantExpression()
      );
    }
    return false;
  }
  function isInStrictMode() {
    const start = this.isProgram() ? this : this.parentPath;
    const strictParent = start.find(path => {
      if (path.isProgram({sourceType: 'module'})) return true;
      if (path.isClass()) return true;
      if (!path.isProgram() && !path.isFunction()) return false;
      if (
        path.isArrowFunctionExpression() &&
        !path.get('body').isBlockStatement()
      ) {
        return false;
      }
      let {node: node} = path;
      if (path.isFunction()) node = node.body;
      for (const directive of node.directives) {
        if (directive.value.value === 'use strict') {
          return true;
        }
      }
    });
    return !!strictParent;
  }
  return introspection;
}
var context = {};
var hasRequiredContext$1;
function requireContext$1() {
  if (hasRequiredContext$1) return context;
  hasRequiredContext$1 = 1;
  Object.defineProperty(context, '__esModule', {value: true});
  context.call = call;
  context._call = _call;
  context.isBlacklisted = isBlacklisted;
  context.visit = visit;
  context.skip = skip;
  context.skipKey = skipKey;
  context.stop = stop;
  context.setScope = setScope;
  context.setContext = setContext;
  context.resync = resync;
  context._resyncParent = _resyncParent;
  context._resyncKey = _resyncKey;
  context._resyncList = _resyncList;
  context._resyncRemoved = _resyncRemoved;
  context.popContext = popContext;
  context.pushContext = pushContext;
  context.setup = setup;
  context.setKey = setKey;
  context.requeue = requeue;
  context._getQueueContexts = _getQueueContexts;
  var _index = _interopRequireDefault(requireLib$1());
  var _index2 = requirePath();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function call(key) {
    const opts = this.opts;
    this.debug(key);
    if (this.node) {
      if (this._call(opts[key])) return true;
    }
    if (this.node) {
      return this._call(opts[this.node.type] && opts[this.node.type][key]);
    }
    return false;
  }
  function _call(fns) {
    if (!fns) return false;
    for (const fn of fns) {
      if (!fn) continue;
      const node = this.node;
      if (!node) return true;
      const ret = fn.call(this.state, this, this.state);
      if (ret && typeof ret === 'object' && typeof ret.then === 'function') {
        throw new Error(
          `You appear to be using a plugin with an async traversal visitor, ` +
            `which your current version of Babel does not support. ` +
            `If you're using a published plugin, you may need to upgrade ` +
            `your @babel/core version.`
        );
      }
      if (ret) {
        throw new Error(`Unexpected return value from visitor method ${fn}`);
      }
      if (this.node !== node) return true;
      if (this._traverseFlags > 0) return true;
    }
    return false;
  }
  function isBlacklisted() {
    const blacklist = this.opts.blacklist;
    return blacklist && blacklist.indexOf(this.node.type) > -1;
  }
  function visit() {
    if (!this.node) {
      return false;
    }
    if (this.isBlacklisted()) {
      return false;
    }
    if (this.opts.shouldSkip && this.opts.shouldSkip(this)) {
      return false;
    }
    if (this.shouldSkip || this.call('enter') || this.shouldSkip) {
      this.debug('Skip...');
      return this.shouldStop;
    }
    this.debug('Recursing into...');
    _index.default.node(
      this.node,
      this.opts,
      this.scope,
      this.state,
      this,
      this.skipKeys
    );
    this.call('exit');
    return this.shouldStop;
  }
  function skip() {
    this.shouldSkip = true;
  }
  function skipKey(key) {
    if (this.skipKeys == null) {
      this.skipKeys = {};
    }
    this.skipKeys[key] = true;
  }
  function stop() {
    this._traverseFlags |= _index2.SHOULD_SKIP | _index2.SHOULD_STOP;
  }
  function setScope() {
    if (this.opts && this.opts.noScope) return;
    let path = this.parentPath;
    let target;
    while (path && !target) {
      if (path.opts && path.opts.noScope) return;
      target = path.scope;
      path = path.parentPath;
    }
    this.scope = this.getScope(target);
    if (this.scope) this.scope.init();
  }
  function setContext(context) {
    if (this.skipKeys != null) {
      this.skipKeys = {};
    }
    this._traverseFlags = 0;
    if (context) {
      this.context = context;
      this.state = context.state;
      this.opts = context.opts;
    }
    this.setScope();
    return this;
  }
  function resync() {
    if (this.removed) return;
    this._resyncParent();
    this._resyncList();
    this._resyncKey();
  }
  function _resyncParent() {
    if (this.parentPath) {
      this.parent = this.parentPath.node;
    }
  }
  function _resyncKey() {
    if (!this.container) return;
    if (this.node === this.container[this.key]) return;
    if (Array.isArray(this.container)) {
      for (let i = 0; i < this.container.length; i++) {
        if (this.container[i] === this.node) {
          return this.setKey(i);
        }
      }
    } else {
      for (const key of Object.keys(this.container)) {
        if (this.container[key] === this.node) {
          return this.setKey(key);
        }
      }
    }
    this.key = null;
  }
  function _resyncList() {
    if (!this.parent || !this.inList) return;
    const newContainer = this.parent[this.listKey];
    if (this.container === newContainer) return;
    this.container = newContainer || null;
  }
  function _resyncRemoved() {
    if (
      this.key == null ||
      !this.container ||
      this.container[this.key] !== this.node
    ) {
      this._markRemoved();
    }
  }
  function popContext() {
    this.contexts.pop();
    if (this.contexts.length > 0) {
      this.setContext(this.contexts[this.contexts.length - 1]);
    } else {
      this.setContext(undefined);
    }
  }
  function pushContext(context) {
    this.contexts.push(context);
    this.setContext(context);
  }
  function setup(parentPath, container, listKey, key) {
    this.listKey = listKey;
    this.container = container;
    this.parentPath = parentPath || this.parentPath;
    this.setKey(key);
  }
  function setKey(key) {
    this.key = key;
    this.node = this.container[this.key];
    this.type = this.node && this.node.type;
  }
  function requeue(pathToQueue = this) {
    if (pathToQueue.removed) return;
    const contexts = this.contexts;
    for (const context of contexts) {
      context.maybeQueue(pathToQueue);
    }
  }
  function _getQueueContexts() {
    let path = this;
    let contexts = this.contexts;
    while (!contexts.length) {
      path = path.parentPath;
      if (!path) break;
      contexts = path.contexts;
    }
    return contexts;
  }
  return context;
}
var removal = {};
var removalHooks = {};
var hasRequiredRemovalHooks;
function requireRemovalHooks() {
  if (hasRequiredRemovalHooks) return removalHooks;
  hasRequiredRemovalHooks = 1;
  Object.defineProperty(removalHooks, '__esModule', {value: true});
  removalHooks.hooks = void 0;
  const hooks = [
    function (self, parent) {
      const removeParent =
        (self.key === 'test' && (parent.isWhile() || parent.isSwitchCase())) ||
        (self.key === 'declaration' && parent.isExportDeclaration()) ||
        (self.key === 'body' && parent.isLabeledStatement()) ||
        (self.listKey === 'declarations' &&
          parent.isVariableDeclaration() &&
          parent.node.declarations.length === 1) ||
        (self.key === 'expression' && parent.isExpressionStatement());
      if (removeParent) {
        parent.remove();
        return true;
      }
    },
    function (self, parent) {
      if (
        parent.isSequenceExpression() &&
        parent.node.expressions.length === 1
      ) {
        parent.replaceWith(parent.node.expressions[0]);
        return true;
      }
    },
    function (self, parent) {
      if (parent.isBinary()) {
        if (self.key === 'left') {
          parent.replaceWith(parent.node.right);
        } else {
          parent.replaceWith(parent.node.left);
        }
        return true;
      }
    },
    function (self, parent) {
      if (
        (parent.isIfStatement() &&
          (self.key === 'consequent' || self.key === 'alternate')) ||
        (self.key === 'body' &&
          (parent.isLoop() || parent.isArrowFunctionExpression()))
      ) {
        self.replaceWith({type: 'BlockStatement', body: []});
        return true;
      }
    },
  ];
  removalHooks.hooks = hooks;
  return removalHooks;
}
var hasRequiredRemoval;
function requireRemoval() {
  if (hasRequiredRemoval) return removal;
  hasRequiredRemoval = 1;
  Object.defineProperty(removal, '__esModule', {value: true});
  removal.remove = remove;
  removal._removeFromScope = _removeFromScope;
  removal._callRemovalHooks = _callRemovalHooks;
  removal._remove = _remove;
  removal._markRemoved = _markRemoved;
  removal._assertUnremoved = _assertUnremoved;
  var _removalHooks = requireRemovalHooks();
  var _index = requirePath();
  function remove() {
    this._assertUnremoved();
    this.resync();
    this._removeFromScope();
    if (this._callRemovalHooks()) {
      this._markRemoved();
      return;
    }
    this.shareCommentsWithSiblings();
    this._remove();
    this._markRemoved();
  }
  function _removeFromScope() {
    const bindings = this.getBindingIdentifiers();
    Object.keys(bindings).forEach(name => this.scope.removeBinding(name));
  }
  function _callRemovalHooks() {
    for (const fn of _removalHooks.hooks) {
      if (fn(this, this.parentPath)) return true;
    }
  }
  function _remove() {
    if (Array.isArray(this.container)) {
      this.container.splice(this.key, 1);
      this.updateSiblingKeys(this.key, -1);
    } else {
      this._replaceWith(null);
    }
  }
  function _markRemoved() {
    this._traverseFlags |= _index.SHOULD_SKIP | _index.REMOVED;
    this.node = null;
  }
  function _assertUnremoved() {
    if (this.removed) {
      throw this.buildCodeFrameError(
        'NodePath has been removed so is read-only.'
      );
    }
  }
  return removal;
}
var modification = {};
var hoister = {};
var hasRequiredHoister;
function requireHoister() {
  if (hasRequiredHoister) return hoister;
  hasRequiredHoister = 1;
  Object.defineProperty(hoister, '__esModule', {value: true});
  hoister.default = void 0;
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  const referenceVisitor = {
    ReferencedIdentifier(path, state) {
      if (
        path.isJSXIdentifier() &&
        t.react.isCompatTag(path.node.name) &&
        !path.parentPath.isJSXMemberExpression()
      ) {
        return;
      }
      if (path.node.name === 'this') {
        let scope = path.scope;
        do {
          if (
            scope.path.isFunction() &&
            !scope.path.isArrowFunctionExpression()
          ) {
            break;
          }
        } while ((scope = scope.parent));
        if (scope) state.breakOnScopePaths.push(scope.path);
      }
      const binding = path.scope.getBinding(path.node.name);
      if (!binding) return;
      for (const violation of binding.constantViolations) {
        if (violation.scope !== binding.path.scope) {
          state.mutableBinding = true;
          path.stop();
          return;
        }
      }
      if (binding !== state.scope.getBinding(path.node.name)) return;
      state.bindings[path.node.name] = binding;
    },
  };
  class PathHoister {
    constructor(path, scope) {
      this.breakOnScopePaths = [];
      this.bindings = {};
      this.mutableBinding = false;
      this.scopes = [];
      this.scope = scope;
      this.path = path;
      this.attachAfter = false;
    }
    isCompatibleScope(scope) {
      for (const key of Object.keys(this.bindings)) {
        const binding = this.bindings[key];
        if (!scope.bindingIdentifierEquals(key, binding.identifier)) {
          return false;
        }
      }
      return true;
    }
    getCompatibleScopes() {
      let scope = this.path.scope;
      do {
        if (this.isCompatibleScope(scope)) {
          this.scopes.push(scope);
        } else {
          break;
        }
        if (this.breakOnScopePaths.indexOf(scope.path) >= 0) {
          break;
        }
      } while ((scope = scope.parent));
    }
    getAttachmentPath() {
      let path = this._getAttachmentPath();
      if (!path) return;
      let targetScope = path.scope;
      if (targetScope.path === path) {
        targetScope = path.scope.parent;
      }
      if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
        for (const name of Object.keys(this.bindings)) {
          if (!targetScope.hasOwnBinding(name)) continue;
          const binding = this.bindings[name];
          if (binding.kind === 'param' || binding.path.parentKey === 'params') {
            continue;
          }
          const bindingParentPath = this.getAttachmentParentForPath(
            binding.path
          );
          if (bindingParentPath.key >= path.key) {
            this.attachAfter = true;
            path = binding.path;
            for (const violationPath of binding.constantViolations) {
              if (
                this.getAttachmentParentForPath(violationPath).key > path.key
              ) {
                path = violationPath;
              }
            }
          }
        }
      }
      return path;
    }
    _getAttachmentPath() {
      const scopes = this.scopes;
      const scope = scopes.pop();
      if (!scope) return;
      if (scope.path.isFunction()) {
        if (this.hasOwnParamBindings(scope)) {
          if (this.scope === scope) return;
          const bodies = scope.path.get('body').get('body');
          for (let i = 0; i < bodies.length; i++) {
            if (bodies[i].node._blockHoist) continue;
            return bodies[i];
          }
        } else {
          return this.getNextScopeAttachmentParent();
        }
      } else if (scope.path.isProgram()) {
        return this.getNextScopeAttachmentParent();
      }
    }
    getNextScopeAttachmentParent() {
      const scope = this.scopes.pop();
      if (scope) return this.getAttachmentParentForPath(scope.path);
    }
    getAttachmentParentForPath(path) {
      do {
        if (
          !path.parentPath ||
          (Array.isArray(path.container) && path.isStatement())
        ) {
          return path;
        }
      } while ((path = path.parentPath));
    }
    hasOwnParamBindings(scope) {
      for (const name of Object.keys(this.bindings)) {
        if (!scope.hasOwnBinding(name)) continue;
        const binding = this.bindings[name];
        if (binding.kind === 'param' && binding.constant) return true;
      }
      return false;
    }
    run() {
      this.path.traverse(referenceVisitor, this);
      if (this.mutableBinding) return;
      this.getCompatibleScopes();
      const attachTo = this.getAttachmentPath();
      if (!attachTo) return;
      if (attachTo.getFunctionParent() === this.path.getFunctionParent())
        return;
      let uid = attachTo.scope.generateUidIdentifier('ref');
      const declarator = t.variableDeclarator(uid, this.path.node);
      const insertFn = this.attachAfter ? 'insertAfter' : 'insertBefore';
      const [attached] = attachTo[insertFn]([
        attachTo.isVariableDeclarator()
          ? declarator
          : t.variableDeclaration('var', [declarator]),
      ]);
      const parent = this.path.parentPath;
      if (
        parent.isJSXElement() &&
        this.path.container === parent.node.children
      ) {
        uid = t.JSXExpressionContainer(uid);
      }
      this.path.replaceWith(t.cloneNode(uid));
      return attachTo.isVariableDeclarator()
        ? attached.get('init')
        : attached.get('declarations.0.init');
    }
  }
  hoister.default = PathHoister;
  return hoister;
}
var hasRequiredModification;
function requireModification() {
  if (hasRequiredModification) return modification;
  hasRequiredModification = 1;
  Object.defineProperty(modification, '__esModule', {value: true});
  modification.insertBefore = insertBefore;
  modification._containerInsert = _containerInsert;
  modification._containerInsertBefore = _containerInsertBefore;
  modification._containerInsertAfter = _containerInsertAfter;
  modification.insertAfter = insertAfter;
  modification.updateSiblingKeys = updateSiblingKeys;
  modification._verifyNodeList = _verifyNodeList;
  modification.unshiftContainer = unshiftContainer;
  modification.pushContainer = pushContainer;
  modification.hoist = hoist;
  var _cache = requireCache();
  var _hoister = _interopRequireDefault(requireHoister());
  var _index = _interopRequireDefault(requirePath());
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function insertBefore(nodes) {
    this._assertUnremoved();
    nodes = this._verifyNodeList(nodes);
    const {parentPath: parentPath} = this;
    if (
      parentPath.isExpressionStatement() ||
      parentPath.isLabeledStatement() ||
      parentPath.isExportNamedDeclaration() ||
      (parentPath.isExportDefaultDeclaration() && this.isDeclaration())
    ) {
      return parentPath.insertBefore(nodes);
    } else if (
      (this.isNodeType('Expression') && !this.isJSXElement()) ||
      (parentPath.isForStatement() && this.key === 'init')
    ) {
      if (this.node) nodes.push(this.node);
      return this.replaceExpressionWithStatements(nodes);
    } else if (Array.isArray(this.container)) {
      return this._containerInsertBefore(nodes);
    } else if (this.isStatementOrBlock()) {
      const shouldInsertCurrentNode =
        this.node &&
        (!this.isExpressionStatement() || this.node.expression != null);
      this.replaceWith(
        t.blockStatement(shouldInsertCurrentNode ? [this.node] : [])
      );
      return this.unshiftContainer('body', nodes);
    } else {
      throw new Error(
        "We don't know what to do with this node type. " +
          "We were previously a Statement but we can't fit in here?"
      );
    }
  }
  function _containerInsert(from, nodes) {
    this.updateSiblingKeys(from, nodes.length);
    const paths = [];
    this.container.splice(from, 0, ...nodes);
    for (let i = 0; i < nodes.length; i++) {
      const to = from + i;
      const path = this.getSibling(to);
      paths.push(path);
      if (this.context && this.context.queue) {
        path.pushContext(this.context);
      }
    }
    const contexts = this._getQueueContexts();
    for (const path of paths) {
      path.setScope();
      path.debug('Inserted.');
      for (const context of contexts) {
        context.maybeQueue(path, true);
      }
    }
    return paths;
  }
  function _containerInsertBefore(nodes) {
    return this._containerInsert(this.key, nodes);
  }
  function _containerInsertAfter(nodes) {
    return this._containerInsert(this.key + 1, nodes);
  }
  function insertAfter(nodes) {
    this._assertUnremoved();
    nodes = this._verifyNodeList(nodes);
    const {parentPath: parentPath} = this;
    if (
      parentPath.isExpressionStatement() ||
      parentPath.isLabeledStatement() ||
      parentPath.isExportNamedDeclaration() ||
      (parentPath.isExportDefaultDeclaration() && this.isDeclaration())
    ) {
      return parentPath.insertAfter(
        nodes.map(node =>
          t.isExpression(node) ? t.expressionStatement(node) : node
        )
      );
    } else if (
      (this.isNodeType('Expression') &&
        !this.isJSXElement() &&
        !parentPath.isJSXElement()) ||
      (parentPath.isForStatement() && this.key === 'init')
    ) {
      if (this.node) {
        let {scope: scope} = this;
        if (parentPath.isMethod({computed: true, key: this.node})) {
          scope = scope.parent;
        }
        const temp = scope.generateDeclaredUidIdentifier();
        nodes.unshift(
          t.expressionStatement(
            t.assignmentExpression('=', t.cloneNode(temp), this.node)
          )
        );
        nodes.push(t.expressionStatement(t.cloneNode(temp)));
      }
      return this.replaceExpressionWithStatements(nodes);
    } else if (Array.isArray(this.container)) {
      return this._containerInsertAfter(nodes);
    } else if (this.isStatementOrBlock()) {
      const shouldInsertCurrentNode =
        this.node &&
        (!this.isExpressionStatement() || this.node.expression != null);
      this.replaceWith(
        t.blockStatement(shouldInsertCurrentNode ? [this.node] : [])
      );
      return this.pushContainer('body', nodes);
    } else {
      throw new Error(
        "We don't know what to do with this node type. " +
          "We were previously a Statement but we can't fit in here?"
      );
    }
  }
  function updateSiblingKeys(fromIndex, incrementBy) {
    if (!this.parent) return;
    const paths = _cache.path.get(this.parent);
    for (let i = 0; i < paths.length; i++) {
      const path = paths[i];
      if (path.key >= fromIndex) {
        path.key += incrementBy;
      }
    }
  }
  function _verifyNodeList(nodes) {
    if (!nodes) {
      return [];
    }
    if (nodes.constructor !== Array) {
      nodes = [nodes];
    }
    for (let i = 0; i < nodes.length; i++) {
      const node = nodes[i];
      let msg;
      if (!node) {
        msg = 'has falsy node';
      } else if (typeof node !== 'object') {
        msg = 'contains a non-object node';
      } else if (!node.type) {
        msg = 'without a type';
      } else if (node instanceof _index.default) {
        msg = 'has a NodePath when it expected a raw object';
      }
      if (msg) {
        const type = Array.isArray(node) ? 'array' : typeof node;
        throw new Error(
          `Node list ${msg} with the index of ${i} and type of ${type}`
        );
      }
    }
    return nodes;
  }
  function unshiftContainer(listKey, nodes) {
    this._assertUnremoved();
    nodes = this._verifyNodeList(nodes);
    const path = _index.default.get({
      parentPath: this,
      parent: this.node,
      container: this.node[listKey],
      listKey: listKey,
      key: 0,
    });
    return path._containerInsertBefore(nodes);
  }
  function pushContainer(listKey, nodes) {
    this._assertUnremoved();
    nodes = this._verifyNodeList(nodes);
    const container = this.node[listKey];
    const path = _index.default.get({
      parentPath: this,
      parent: this.node,
      container: container,
      listKey: listKey,
      key: container.length,
    });
    return path.replaceWithMultiple(nodes);
  }
  function hoist(scope = this.scope) {
    const hoister = new _hoister.default(this, scope);
    return hoister.run();
  }
  return modification;
}
var family = {};
var hasRequiredFamily;
function requireFamily() {
  if (hasRequiredFamily) return family;
  hasRequiredFamily = 1;
  Object.defineProperty(family, '__esModule', {value: true});
  family.getOpposite = getOpposite;
  family.getCompletionRecords = getCompletionRecords;
  family.getSibling = getSibling;
  family.getPrevSibling = getPrevSibling;
  family.getNextSibling = getNextSibling;
  family.getAllNextSiblings = getAllNextSiblings;
  family.getAllPrevSiblings = getAllPrevSiblings;
  family.get = get;
  family._getKey = _getKey;
  family._getPattern = _getPattern;
  family.getBindingIdentifiers = getBindingIdentifiers;
  family.getOuterBindingIdentifiers = getOuterBindingIdentifiers;
  family.getBindingIdentifierPaths = getBindingIdentifierPaths;
  family.getOuterBindingIdentifierPaths = getOuterBindingIdentifierPaths;
  var _index = _interopRequireDefault(requirePath());
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function getOpposite() {
    if (this.key === 'left') {
      return this.getSibling('right');
    } else if (this.key === 'right') {
      return this.getSibling('left');
    }
  }
  function addCompletionRecords(path, paths) {
    if (path) return paths.concat(path.getCompletionRecords());
    return paths;
  }
  function completionRecordForSwitch(cases, paths) {
    let isLastCaseWithConsequent = true;
    for (let i = cases.length - 1; i >= 0; i--) {
      const switchCase = cases[i];
      const consequent = switchCase.get('consequent');
      let breakStatement;
      findBreak: for (const statement of consequent) {
        if (statement.isBlockStatement()) {
          for (const statementInBlock of statement.get('body')) {
            if (statementInBlock.isBreakStatement()) {
              breakStatement = statementInBlock;
              break findBreak;
            }
          }
        } else if (statement.isBreakStatement()) {
          breakStatement = statement;
          break;
        }
      }
      if (breakStatement) {
        while (
          breakStatement.key === 0 &&
          breakStatement.parentPath.isBlockStatement()
        ) {
          breakStatement = breakStatement.parentPath;
        }
        const prevSibling = breakStatement.getPrevSibling();
        if (
          breakStatement.key > 0 &&
          (prevSibling.isExpressionStatement() ||
            prevSibling.isBlockStatement())
        ) {
          paths = addCompletionRecords(prevSibling, paths);
          breakStatement.remove();
        } else {
          breakStatement.replaceWith(breakStatement.scope.buildUndefinedNode());
          paths = addCompletionRecords(breakStatement, paths);
        }
      } else if (isLastCaseWithConsequent) {
        const statementFinder = statement =>
          !statement.isBlockStatement() ||
          statement.get('body').some(statementFinder);
        const hasConsequent = consequent.some(statementFinder);
        if (hasConsequent) {
          paths = addCompletionRecords(
            consequent[consequent.length - 1],
            paths
          );
          isLastCaseWithConsequent = false;
        }
      }
    }
    return paths;
  }
  function getCompletionRecords() {
    let paths = [];
    if (this.isIfStatement()) {
      paths = addCompletionRecords(this.get('consequent'), paths);
      paths = addCompletionRecords(this.get('alternate'), paths);
    } else if (this.isDoExpression() || this.isFor() || this.isWhile()) {
      paths = addCompletionRecords(this.get('body'), paths);
    } else if (this.isProgram() || this.isBlockStatement()) {
      paths = addCompletionRecords(this.get('body').pop(), paths);
    } else if (this.isFunction()) {
      return this.get('body').getCompletionRecords();
    } else if (this.isTryStatement()) {
      paths = addCompletionRecords(this.get('block'), paths);
      paths = addCompletionRecords(this.get('handler'), paths);
    } else if (this.isCatchClause()) {
      paths = addCompletionRecords(this.get('body'), paths);
    } else if (this.isSwitchStatement()) {
      paths = completionRecordForSwitch(this.get('cases'), paths);
    } else {
      paths.push(this);
    }
    return paths;
  }
  function getSibling(key) {
    return _index.default.get({
      parentPath: this.parentPath,
      parent: this.parent,
      container: this.container,
      listKey: this.listKey,
      key: key,
    });
  }
  function getPrevSibling() {
    return this.getSibling(this.key - 1);
  }
  function getNextSibling() {
    return this.getSibling(this.key + 1);
  }
  function getAllNextSiblings() {
    let _key = this.key;
    let sibling = this.getSibling(++_key);
    const siblings = [];
    while (sibling.node) {
      siblings.push(sibling);
      sibling = this.getSibling(++_key);
    }
    return siblings;
  }
  function getAllPrevSiblings() {
    let _key = this.key;
    let sibling = this.getSibling(--_key);
    const siblings = [];
    while (sibling.node) {
      siblings.push(sibling);
      sibling = this.getSibling(--_key);
    }
    return siblings;
  }
  function get(key, context) {
    if (context === true) context = this.context;
    const parts = key.split('.');
    if (parts.length === 1) {
      return this._getKey(key, context);
    } else {
      return this._getPattern(parts, context);
    }
  }
  function _getKey(key, context) {
    const node = this.node;
    const container = node[key];
    if (Array.isArray(container)) {
      return container.map((_, i) =>
        _index.default
          .get({
            listKey: key,
            parentPath: this,
            parent: node,
            container: container,
            key: i,
          })
          .setContext(context)
      );
    } else {
      return _index.default
        .get({parentPath: this, parent: node, container: node, key: key})
        .setContext(context);
    }
  }
  function _getPattern(parts, context) {
    let path = this;
    for (const part of parts) {
      if (part === '.') {
        path = path.parentPath;
      } else {
        if (Array.isArray(path)) {
          path = path[part];
        } else {
          path = path.get(part, context);
        }
      }
    }
    return path;
  }
  function getBindingIdentifiers(duplicates) {
    return t.getBindingIdentifiers(this.node, duplicates);
  }
  function getOuterBindingIdentifiers(duplicates) {
    return t.getOuterBindingIdentifiers(this.node, duplicates);
  }
  function getBindingIdentifierPaths(duplicates = false, outerOnly = false) {
    const path = this;
    let search = [].concat(path);
    const ids = Object.create(null);
    while (search.length) {
      const id = search.shift();
      if (!id) continue;
      if (!id.node) continue;
      const keys = t.getBindingIdentifiers.keys[id.node.type];
      if (id.isIdentifier()) {
        if (duplicates) {
          const _ids = (ids[id.node.name] = ids[id.node.name] || []);
          _ids.push(id);
        } else {
          ids[id.node.name] = id;
        }
        continue;
      }
      if (id.isExportDeclaration()) {
        const declaration = id.get('declaration');
        if (declaration.isDeclaration()) {
          search.push(declaration);
        }
        continue;
      }
      if (outerOnly) {
        if (id.isFunctionDeclaration()) {
          search.push(id.get('id'));
          continue;
        }
        if (id.isFunctionExpression()) {
          continue;
        }
      }
      if (keys) {
        for (let i = 0; i < keys.length; i++) {
          const key = keys[i];
          const child = id.get(key);
          if (Array.isArray(child) || child.node) {
            search = search.concat(child);
          }
        }
      }
    }
    return ids;
  }
  function getOuterBindingIdentifierPaths(duplicates) {
    return this.getBindingIdentifierPaths(duplicates, true);
  }
  return family;
}
var comments = {};
var hasRequiredComments;
function requireComments() {
  if (hasRequiredComments) return comments;
  hasRequiredComments = 1;
  Object.defineProperty(comments, '__esModule', {value: true});
  comments.shareCommentsWithSiblings = shareCommentsWithSiblings;
  comments.addComment = addComment;
  comments.addComments = addComments;
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function shareCommentsWithSiblings() {
    if (typeof this.key === 'string') return;
    const node = this.node;
    if (!node) return;
    const trailing = node.trailingComments;
    const leading = node.leadingComments;
    if (!trailing && !leading) return;
    const prev = this.getSibling(this.key - 1);
    const next = this.getSibling(this.key + 1);
    const hasPrev = Boolean(prev.node);
    const hasNext = Boolean(next.node);
    if (hasPrev && hasNext);
    else if (hasPrev) {
      prev.addComments('trailing', trailing);
    } else if (hasNext) {
      next.addComments('leading', leading);
    }
  }
  function addComment(type, content, line) {
    t.addComment(this.node, type, content, line);
  }
  function addComments(type, comments) {
    t.addComments(this.node, type, comments);
  }
  return comments;
}
var hasRequiredPath;
function requirePath() {
  if (hasRequiredPath) return path$2;
  hasRequiredPath = 1;
  Object.defineProperty(path$2, '__esModule', {value: true});
  path$2.default =
    path$2.SHOULD_SKIP =
    path$2.SHOULD_STOP =
    path$2.REMOVED =
      void 0;
  var virtualTypes = _interopRequireWildcard(requireVirtualTypes());
  var _debug = _interopRequireDefault(requireSrc$1());
  var _index = _interopRequireDefault(requireLib$1());
  var _scope = _interopRequireDefault(requireScope());
  var t = _interopRequireWildcard(t$d);
  var _cache = requireCache();
  var _generator = _interopRequireDefault(requireLib$a());
  var NodePath_ancestry = _interopRequireWildcard(requireAncestry());
  var NodePath_inference = _interopRequireWildcard(requireInference());
  var NodePath_replacement = _interopRequireWildcard(requireReplacement());
  var NodePath_evaluation = _interopRequireWildcard(requireEvaluation());
  var NodePath_conversion = _interopRequireWildcard(requireConversion());
  var NodePath_introspection = _interopRequireWildcard(requireIntrospection());
  var NodePath_context = _interopRequireWildcard(requireContext$1());
  var NodePath_removal = _interopRequireWildcard(requireRemoval());
  var NodePath_modification = _interopRequireWildcard(requireModification());
  var NodePath_family = _interopRequireWildcard(requireFamily());
  var NodePath_comments = _interopRequireWildcard(requireComments());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  const debug = (0, _debug.default)('babel');
  const REMOVED = 1 << 0;
  path$2.REMOVED = REMOVED;
  const SHOULD_STOP = 1 << 1;
  path$2.SHOULD_STOP = SHOULD_STOP;
  const SHOULD_SKIP = 1 << 2;
  path$2.SHOULD_SKIP = SHOULD_SKIP;
  class NodePath {
    constructor(hub, parent) {
      this.parent = parent;
      this.hub = hub;
      this.contexts = [];
      this.data = null;
      this._traverseFlags = 0;
      this.state = null;
      this.opts = null;
      this.skipKeys = null;
      this.parentPath = null;
      this.context = null;
      this.container = null;
      this.listKey = null;
      this.key = null;
      this.node = null;
      this.scope = null;
      this.type = null;
    }
    static get({
      hub: hub,
      parentPath: parentPath,
      parent: parent,
      container: container,
      listKey: listKey,
      key: key,
    }) {
      if (!hub && parentPath) {
        hub = parentPath.hub;
      }
      if (!parent) {
        throw new Error('To get a node path the parent needs to exist');
      }
      const targetNode = container[key];
      const paths = _cache.path.get(parent) || [];
      if (!_cache.path.has(parent)) {
        _cache.path.set(parent, paths);
      }
      let path;
      for (let i = 0; i < paths.length; i++) {
        const pathCheck = paths[i];
        if (pathCheck.node === targetNode) {
          path = pathCheck;
          break;
        }
      }
      if (!path) {
        path = new NodePath(hub, parent);
        paths.push(path);
      }
      path.setup(parentPath, container, listKey, key);
      return path;
    }
    getScope(scope) {
      return this.isScope() ? new _scope.default(this) : scope;
    }
    setData(key, val) {
      if (this.data == null) {
        this.data = Object.create(null);
      }
      return (this.data[key] = val);
    }
    getData(key, def) {
      if (this.data == null) {
        this.data = Object.create(null);
      }
      let val = this.data[key];
      if (val === undefined && def !== undefined) val = this.data[key] = def;
      return val;
    }
    buildCodeFrameError(msg, Error = SyntaxError) {
      return this.hub.buildError(this.node, msg, Error);
    }
    traverse(visitor, state) {
      (0, _index.default)(this.node, visitor, this.scope, state, this);
    }
    set(key, node) {
      t.validate(this.node, key, node);
      this.node[key] = node;
    }
    getPathLocation() {
      const parts = [];
      let path = this;
      do {
        let key = path.key;
        if (path.inList) key = `${path.listKey}[${key}]`;
        parts.unshift(key);
      } while ((path = path.parentPath));
      return parts.join('.');
    }
    debug(message) {
      if (!debug.enabled) return;
      debug(`${this.getPathLocation()} ${this.type}: ${message}`);
    }
    toString() {
      return (0, _generator.default)(this.node).code;
    }
    get inList() {
      return !!this.listKey;
    }
    set inList(inList) {
      if (!inList) {
        this.listKey = null;
      }
    }
    get parentKey() {
      return this.listKey || this.key;
    }
    get shouldSkip() {
      return !!(this._traverseFlags & SHOULD_SKIP);
    }
    set shouldSkip(v) {
      if (v) {
        this._traverseFlags |= SHOULD_SKIP;
      } else {
        this._traverseFlags &= ~SHOULD_SKIP;
      }
    }
    get shouldStop() {
      return !!(this._traverseFlags & SHOULD_STOP);
    }
    set shouldStop(v) {
      if (v) {
        this._traverseFlags |= SHOULD_STOP;
      } else {
        this._traverseFlags &= ~SHOULD_STOP;
      }
    }
    get removed() {
      return !!(this._traverseFlags & REMOVED);
    }
    set removed(v) {
      if (v) {
        this._traverseFlags |= REMOVED;
      } else {
        this._traverseFlags &= ~REMOVED;
      }
    }
  }
  path$2.default = NodePath;
  Object.assign(
    NodePath.prototype,
    NodePath_ancestry,
    NodePath_inference,
    NodePath_replacement,
    NodePath_evaluation,
    NodePath_conversion,
    NodePath_introspection,
    NodePath_context,
    NodePath_removal,
    NodePath_modification,
    NodePath_family,
    NodePath_comments
  );
  for (const type of t.TYPES) {
    const typeKey = `is${type}`;
    const fn = t[typeKey];
    NodePath.prototype[typeKey] = function (opts) {
      return fn(this.node, opts);
    };
    NodePath.prototype[`assert${type}`] = function (opts) {
      if (!fn(this.node, opts)) {
        throw new TypeError(`Expected node path of type ${type}`);
      }
    };
  }
  for (const type of Object.keys(virtualTypes)) {
    if (type[0] === '_') continue;
    if (t.TYPES.indexOf(type) < 0) t.TYPES.push(type);
    const virtualType = virtualTypes[type];
    NodePath.prototype[`is${type}`] = function (opts) {
      return virtualType.checkPath(this, opts);
    };
  }
  return path$2;
}
var hasRequiredContext;
function requireContext() {
  if (hasRequiredContext) return context$1;
  hasRequiredContext = 1;
  Object.defineProperty(context$1, '__esModule', {value: true});
  context$1.default = void 0;
  var _path = _interopRequireDefault(requirePath());
  var t = _interopRequireWildcard(t$d);
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const testing = process.env.NODE_ENV === 'test';
  class TraversalContext {
    constructor(scope, opts, state, parentPath) {
      this.queue = null;
      this.parentPath = parentPath;
      this.scope = scope;
      this.state = state;
      this.opts = opts;
    }
    shouldVisit(node) {
      const opts = this.opts;
      if (opts.enter || opts.exit) return true;
      if (opts[node.type]) return true;
      const keys = t.VISITOR_KEYS[node.type];
      if (!keys || !keys.length) return false;
      for (const key of keys) {
        if (node[key]) return true;
      }
      return false;
    }
    create(node, obj, key, listKey) {
      return _path.default.get({
        parentPath: this.parentPath,
        parent: node,
        container: obj,
        key: key,
        listKey: listKey,
      });
    }
    maybeQueue(path, notPriority) {
      if (this.trap) {
        throw new Error('Infinite cycle detected');
      }
      if (this.queue) {
        if (notPriority) {
          this.queue.push(path);
        } else {
          this.priorityQueue.push(path);
        }
      }
    }
    visitMultiple(container, parent, listKey) {
      if (container.length === 0) return false;
      const queue = [];
      for (let key = 0; key < container.length; key++) {
        const node = container[key];
        if (node && this.shouldVisit(node)) {
          queue.push(this.create(parent, container, key, listKey));
        }
      }
      return this.visitQueue(queue);
    }
    visitSingle(node, key) {
      if (this.shouldVisit(node[key])) {
        return this.visitQueue([this.create(node, node, key)]);
      } else {
        return false;
      }
    }
    visitQueue(queue) {
      this.queue = queue;
      this.priorityQueue = [];
      const visited = [];
      let stop = false;
      for (const path of queue) {
        path.resync();
        if (
          path.contexts.length === 0 ||
          path.contexts[path.contexts.length - 1] !== this
        ) {
          path.pushContext(this);
        }
        if (path.key === null) continue;
        if (testing && queue.length >= 1e4) {
          this.trap = true;
        }
        if (visited.indexOf(path.node) >= 0) continue;
        visited.push(path.node);
        if (path.visit()) {
          stop = true;
          break;
        }
        if (this.priorityQueue.length) {
          stop = this.visitQueue(this.priorityQueue);
          this.priorityQueue = [];
          this.queue = queue;
          if (stop) break;
        }
      }
      for (const path of queue) {
        path.popContext();
      }
      this.queue = null;
      return stop;
    }
    visit(node, key) {
      const nodes = node[key];
      if (!nodes) return false;
      if (Array.isArray(nodes)) {
        return this.visitMultiple(nodes, node, key);
      } else {
        return this.visitSingle(node, key);
      }
    }
  }
  context$1.default = TraversalContext;
  return context$1;
}
var visitors = {};
var _listCacheClear;
var hasRequired_listCacheClear;
function require_listCacheClear() {
  if (hasRequired_listCacheClear) return _listCacheClear;
  hasRequired_listCacheClear = 1;
  function listCacheClear() {
    this.__data__ = [];
    this.size = 0;
  }
  _listCacheClear = listCacheClear;
  return _listCacheClear;
}
var _assocIndexOf;
var hasRequired_assocIndexOf;
function require_assocIndexOf() {
  if (hasRequired_assocIndexOf) return _assocIndexOf;
  hasRequired_assocIndexOf = 1;
  var eq = requireEq();
  function assocIndexOf(array, key) {
    var length = array.length;
    while (length--) {
      if (eq(array[length][0], key)) {
        return length;
      }
    }
    return -1;
  }
  _assocIndexOf = assocIndexOf;
  return _assocIndexOf;
}
var _listCacheDelete;
var hasRequired_listCacheDelete;
function require_listCacheDelete() {
  if (hasRequired_listCacheDelete) return _listCacheDelete;
  hasRequired_listCacheDelete = 1;
  var assocIndexOf = require_assocIndexOf();
  var arrayProto = Array.prototype;
  var splice = arrayProto.splice;
  function listCacheDelete(key) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    if (index < 0) {
      return false;
    }
    var lastIndex = data.length - 1;
    if (index == lastIndex) {
      data.pop();
    } else {
      splice.call(data, index, 1);
    }
    --this.size;
    return true;
  }
  _listCacheDelete = listCacheDelete;
  return _listCacheDelete;
}
var _listCacheGet;
var hasRequired_listCacheGet;
function require_listCacheGet() {
  if (hasRequired_listCacheGet) return _listCacheGet;
  hasRequired_listCacheGet = 1;
  var assocIndexOf = require_assocIndexOf();
  function listCacheGet(key) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    return index < 0 ? undefined : data[index][1];
  }
  _listCacheGet = listCacheGet;
  return _listCacheGet;
}
var _listCacheHas;
var hasRequired_listCacheHas;
function require_listCacheHas() {
  if (hasRequired_listCacheHas) return _listCacheHas;
  hasRequired_listCacheHas = 1;
  var assocIndexOf = require_assocIndexOf();
  function listCacheHas(key) {
    return assocIndexOf(this.__data__, key) > -1;
  }
  _listCacheHas = listCacheHas;
  return _listCacheHas;
}
var _listCacheSet;
var hasRequired_listCacheSet;
function require_listCacheSet() {
  if (hasRequired_listCacheSet) return _listCacheSet;
  hasRequired_listCacheSet = 1;
  var assocIndexOf = require_assocIndexOf();
  function listCacheSet(key, value) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    if (index < 0) {
      ++this.size;
      data.push([key, value]);
    } else {
      data[index][1] = value;
    }
    return this;
  }
  _listCacheSet = listCacheSet;
  return _listCacheSet;
}
var _ListCache;
var hasRequired_ListCache;
function require_ListCache() {
  if (hasRequired_ListCache) return _ListCache;
  hasRequired_ListCache = 1;
  var listCacheClear = require_listCacheClear(),
    listCacheDelete = require_listCacheDelete(),
    listCacheGet = require_listCacheGet(),
    listCacheHas = require_listCacheHas(),
    listCacheSet = require_listCacheSet();
  function ListCache(entries) {
    var index = -1,
      length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  ListCache.prototype.clear = listCacheClear;
  ListCache.prototype['delete'] = listCacheDelete;
  ListCache.prototype.get = listCacheGet;
  ListCache.prototype.has = listCacheHas;
  ListCache.prototype.set = listCacheSet;
  _ListCache = ListCache;
  return _ListCache;
}
var _stackClear;
var hasRequired_stackClear;
function require_stackClear() {
  if (hasRequired_stackClear) return _stackClear;
  hasRequired_stackClear = 1;
  var ListCache = require_ListCache();
  function stackClear() {
    this.__data__ = new ListCache();
    this.size = 0;
  }
  _stackClear = stackClear;
  return _stackClear;
}
var _stackDelete;
var hasRequired_stackDelete;
function require_stackDelete() {
  if (hasRequired_stackDelete) return _stackDelete;
  hasRequired_stackDelete = 1;
  function stackDelete(key) {
    var data = this.__data__,
      result = data['delete'](key);
    this.size = data.size;
    return result;
  }
  _stackDelete = stackDelete;
  return _stackDelete;
}
var _stackGet;
var hasRequired_stackGet;
function require_stackGet() {
  if (hasRequired_stackGet) return _stackGet;
  hasRequired_stackGet = 1;
  function stackGet(key) {
    return this.__data__.get(key);
  }
  _stackGet = stackGet;
  return _stackGet;
}
var _stackHas;
var hasRequired_stackHas;
function require_stackHas() {
  if (hasRequired_stackHas) return _stackHas;
  hasRequired_stackHas = 1;
  function stackHas(key) {
    return this.__data__.has(key);
  }
  _stackHas = stackHas;
  return _stackHas;
}
var _Map;
var hasRequired_Map;
function require_Map() {
  if (hasRequired_Map) return _Map;
  hasRequired_Map = 1;
  var getNative = require_getNative(),
    root = require_root();
  var Map = getNative(root, 'Map');
  _Map = Map;
  return _Map;
}
var _nativeCreate;
var hasRequired_nativeCreate;
function require_nativeCreate() {
  if (hasRequired_nativeCreate) return _nativeCreate;
  hasRequired_nativeCreate = 1;
  var getNative = require_getNative();
  var nativeCreate = getNative(Object, 'create');
  _nativeCreate = nativeCreate;
  return _nativeCreate;
}
var _hashClear;
var hasRequired_hashClear;
function require_hashClear() {
  if (hasRequired_hashClear) return _hashClear;
  hasRequired_hashClear = 1;
  var nativeCreate = require_nativeCreate();
  function hashClear() {
    this.__data__ = nativeCreate ? nativeCreate(null) : {};
    this.size = 0;
  }
  _hashClear = hashClear;
  return _hashClear;
}
var _hashDelete;
var hasRequired_hashDelete;
function require_hashDelete() {
  if (hasRequired_hashDelete) return _hashDelete;
  hasRequired_hashDelete = 1;
  function hashDelete(key) {
    var result = this.has(key) && delete this.__data__[key];
    this.size -= result ? 1 : 0;
    return result;
  }
  _hashDelete = hashDelete;
  return _hashDelete;
}
var _hashGet;
var hasRequired_hashGet;
function require_hashGet() {
  if (hasRequired_hashGet) return _hashGet;
  hasRequired_hashGet = 1;
  var nativeCreate = require_nativeCreate();
  var HASH_UNDEFINED = '__lodash_hash_undefined__';
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function hashGet(key) {
    var data = this.__data__;
    if (nativeCreate) {
      var result = data[key];
      return result === HASH_UNDEFINED ? undefined : result;
    }
    return hasOwnProperty.call(data, key) ? data[key] : undefined;
  }
  _hashGet = hashGet;
  return _hashGet;
}
var _hashHas;
var hasRequired_hashHas;
function require_hashHas() {
  if (hasRequired_hashHas) return _hashHas;
  hasRequired_hashHas = 1;
  var nativeCreate = require_nativeCreate();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function hashHas(key) {
    var data = this.__data__;
    return nativeCreate
      ? data[key] !== undefined
      : hasOwnProperty.call(data, key);
  }
  _hashHas = hashHas;
  return _hashHas;
}
var _hashSet;
var hasRequired_hashSet;
function require_hashSet() {
  if (hasRequired_hashSet) return _hashSet;
  hasRequired_hashSet = 1;
  var nativeCreate = require_nativeCreate();
  var HASH_UNDEFINED = '__lodash_hash_undefined__';
  function hashSet(key, value) {
    var data = this.__data__;
    this.size += this.has(key) ? 0 : 1;
    data[key] = nativeCreate && value === undefined ? HASH_UNDEFINED : value;
    return this;
  }
  _hashSet = hashSet;
  return _hashSet;
}
var _Hash;
var hasRequired_Hash;
function require_Hash() {
  if (hasRequired_Hash) return _Hash;
  hasRequired_Hash = 1;
  var hashClear = require_hashClear(),
    hashDelete = require_hashDelete(),
    hashGet = require_hashGet(),
    hashHas = require_hashHas(),
    hashSet = require_hashSet();
  function Hash(entries) {
    var index = -1,
      length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  Hash.prototype.clear = hashClear;
  Hash.prototype['delete'] = hashDelete;
  Hash.prototype.get = hashGet;
  Hash.prototype.has = hashHas;
  Hash.prototype.set = hashSet;
  _Hash = Hash;
  return _Hash;
}
var _mapCacheClear;
var hasRequired_mapCacheClear;
function require_mapCacheClear() {
  if (hasRequired_mapCacheClear) return _mapCacheClear;
  hasRequired_mapCacheClear = 1;
  var Hash = require_Hash(),
    ListCache = require_ListCache(),
    Map = require_Map();
  function mapCacheClear() {
    this.size = 0;
    this.__data__ = {
      hash: new Hash(),
      map: new (Map || ListCache)(),
      string: new Hash(),
    };
  }
  _mapCacheClear = mapCacheClear;
  return _mapCacheClear;
}
var _isKeyable;
var hasRequired_isKeyable;
function require_isKeyable() {
  if (hasRequired_isKeyable) return _isKeyable;
  hasRequired_isKeyable = 1;
  function isKeyable(value) {
    var type = typeof value;
    return type == 'string' ||
      type == 'number' ||
      type == 'symbol' ||
      type == 'boolean'
      ? value !== '__proto__'
      : value === null;
  }
  _isKeyable = isKeyable;
  return _isKeyable;
}
var _getMapData;
var hasRequired_getMapData;
function require_getMapData() {
  if (hasRequired_getMapData) return _getMapData;
  hasRequired_getMapData = 1;
  var isKeyable = require_isKeyable();
  function getMapData(map, key) {
    var data = map.__data__;
    return isKeyable(key)
      ? data[typeof key == 'string' ? 'string' : 'hash']
      : data.map;
  }
  _getMapData = getMapData;
  return _getMapData;
}
var _mapCacheDelete;
var hasRequired_mapCacheDelete;
function require_mapCacheDelete() {
  if (hasRequired_mapCacheDelete) return _mapCacheDelete;
  hasRequired_mapCacheDelete = 1;
  var getMapData = require_getMapData();
  function mapCacheDelete(key) {
    var result = getMapData(this, key)['delete'](key);
    this.size -= result ? 1 : 0;
    return result;
  }
  _mapCacheDelete = mapCacheDelete;
  return _mapCacheDelete;
}
var _mapCacheGet;
var hasRequired_mapCacheGet;
function require_mapCacheGet() {
  if (hasRequired_mapCacheGet) return _mapCacheGet;
  hasRequired_mapCacheGet = 1;
  var getMapData = require_getMapData();
  function mapCacheGet(key) {
    return getMapData(this, key).get(key);
  }
  _mapCacheGet = mapCacheGet;
  return _mapCacheGet;
}
var _mapCacheHas;
var hasRequired_mapCacheHas;
function require_mapCacheHas() {
  if (hasRequired_mapCacheHas) return _mapCacheHas;
  hasRequired_mapCacheHas = 1;
  var getMapData = require_getMapData();
  function mapCacheHas(key) {
    return getMapData(this, key).has(key);
  }
  _mapCacheHas = mapCacheHas;
  return _mapCacheHas;
}
var _mapCacheSet;
var hasRequired_mapCacheSet;
function require_mapCacheSet() {
  if (hasRequired_mapCacheSet) return _mapCacheSet;
  hasRequired_mapCacheSet = 1;
  var getMapData = require_getMapData();
  function mapCacheSet(key, value) {
    var data = getMapData(this, key),
      size = data.size;
    data.set(key, value);
    this.size += data.size == size ? 0 : 1;
    return this;
  }
  _mapCacheSet = mapCacheSet;
  return _mapCacheSet;
}
var _MapCache;
var hasRequired_MapCache;
function require_MapCache() {
  if (hasRequired_MapCache) return _MapCache;
  hasRequired_MapCache = 1;
  var mapCacheClear = require_mapCacheClear(),
    mapCacheDelete = require_mapCacheDelete(),
    mapCacheGet = require_mapCacheGet(),
    mapCacheHas = require_mapCacheHas(),
    mapCacheSet = require_mapCacheSet();
  function MapCache(entries) {
    var index = -1,
      length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  MapCache.prototype.clear = mapCacheClear;
  MapCache.prototype['delete'] = mapCacheDelete;
  MapCache.prototype.get = mapCacheGet;
  MapCache.prototype.has = mapCacheHas;
  MapCache.prototype.set = mapCacheSet;
  _MapCache = MapCache;
  return _MapCache;
}
var _stackSet;
var hasRequired_stackSet;
function require_stackSet() {
  if (hasRequired_stackSet) return _stackSet;
  hasRequired_stackSet = 1;
  var ListCache = require_ListCache(),
    Map = require_Map(),
    MapCache = require_MapCache();
  var LARGE_ARRAY_SIZE = 200;
  function stackSet(key, value) {
    var data = this.__data__;
    if (data instanceof ListCache) {
      var pairs = data.__data__;
      if (!Map || pairs.length < LARGE_ARRAY_SIZE - 1) {
        pairs.push([key, value]);
        this.size = ++data.size;
        return this;
      }
      data = this.__data__ = new MapCache(pairs);
    }
    data.set(key, value);
    this.size = data.size;
    return this;
  }
  _stackSet = stackSet;
  return _stackSet;
}
var _Stack;
var hasRequired_Stack;
function require_Stack() {
  if (hasRequired_Stack) return _Stack;
  hasRequired_Stack = 1;
  var ListCache = require_ListCache(),
    stackClear = require_stackClear(),
    stackDelete = require_stackDelete(),
    stackGet = require_stackGet(),
    stackHas = require_stackHas(),
    stackSet = require_stackSet();
  function Stack(entries) {
    var data = (this.__data__ = new ListCache(entries));
    this.size = data.size;
  }
  Stack.prototype.clear = stackClear;
  Stack.prototype['delete'] = stackDelete;
  Stack.prototype.get = stackGet;
  Stack.prototype.has = stackHas;
  Stack.prototype.set = stackSet;
  _Stack = Stack;
  return _Stack;
}
var _arrayEach;
var hasRequired_arrayEach;
function require_arrayEach() {
  if (hasRequired_arrayEach) return _arrayEach;
  hasRequired_arrayEach = 1;
  function arrayEach(array, iteratee) {
    var index = -1,
      length = array == null ? 0 : array.length;
    while (++index < length) {
      if (iteratee(array[index], index, array) === false) {
        break;
      }
    }
    return array;
  }
  _arrayEach = arrayEach;
  return _arrayEach;
}
var _baseAssignValue;
var hasRequired_baseAssignValue;
function require_baseAssignValue() {
  if (hasRequired_baseAssignValue) return _baseAssignValue;
  hasRequired_baseAssignValue = 1;
  var defineProperty = require_defineProperty();
  function baseAssignValue(object, key, value) {
    if (key == '__proto__' && defineProperty) {
      defineProperty(object, key, {
        configurable: true,
        enumerable: true,
        value: value,
        writable: true,
      });
    } else {
      object[key] = value;
    }
  }
  _baseAssignValue = baseAssignValue;
  return _baseAssignValue;
}
var _assignValue;
var hasRequired_assignValue;
function require_assignValue() {
  if (hasRequired_assignValue) return _assignValue;
  hasRequired_assignValue = 1;
  var baseAssignValue = require_baseAssignValue(),
    eq = requireEq();
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function assignValue(object, key, value) {
    var objValue = object[key];
    if (
      !(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))
    ) {
      baseAssignValue(object, key, value);
    }
  }
  _assignValue = assignValue;
  return _assignValue;
}
var _copyObject;
var hasRequired_copyObject;
function require_copyObject() {
  if (hasRequired_copyObject) return _copyObject;
  hasRequired_copyObject = 1;
  var assignValue = require_assignValue(),
    baseAssignValue = require_baseAssignValue();
  function copyObject(source, props, object, customizer) {
    var isNew = !object;
    object || (object = {});
    var index = -1,
      length = props.length;
    while (++index < length) {
      var key = props[index];
      var newValue = customizer
        ? customizer(object[key], source[key], key, object, source)
        : undefined;
      if (newValue === undefined) {
        newValue = source[key];
      }
      if (isNew) {
        baseAssignValue(object, key, newValue);
      } else {
        assignValue(object, key, newValue);
      }
    }
    return object;
  }
  _copyObject = copyObject;
  return _copyObject;
}
var _baseAssign;
var hasRequired_baseAssign;
function require_baseAssign() {
  if (hasRequired_baseAssign) return _baseAssign;
  hasRequired_baseAssign = 1;
  var copyObject = require_copyObject(),
    keys = requireKeys();
  function baseAssign(object, source) {
    return object && copyObject(source, keys(source), object);
  }
  _baseAssign = baseAssign;
  return _baseAssign;
}
var _baseAssignIn;
var hasRequired_baseAssignIn;
function require_baseAssignIn() {
  if (hasRequired_baseAssignIn) return _baseAssignIn;
  hasRequired_baseAssignIn = 1;
  var copyObject = require_copyObject(),
    keysIn = requireKeysIn();
  function baseAssignIn(object, source) {
    return object && copyObject(source, keysIn(source), object);
  }
  _baseAssignIn = baseAssignIn;
  return _baseAssignIn;
}
var _cloneBuffer = {exports: {}};
_cloneBuffer.exports;
var hasRequired_cloneBuffer;
function require_cloneBuffer() {
  if (hasRequired_cloneBuffer) return _cloneBuffer.exports;
  hasRequired_cloneBuffer = 1;
  (function (module, exports) {
    var root = require_root();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule =
      freeExports &&
      'object' == 'object' &&
      module &&
      !module.nodeType &&
      module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var Buffer = moduleExports ? root.Buffer : undefined,
      allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;
    function cloneBuffer(buffer, isDeep) {
      if (isDeep) {
        return buffer.slice();
      }
      var length = buffer.length,
        result = allocUnsafe
          ? allocUnsafe(length)
          : new buffer.constructor(length);
      buffer.copy(result);
      return result;
    }
    module.exports = cloneBuffer;
  })(_cloneBuffer, _cloneBuffer.exports);
  return _cloneBuffer.exports;
}
var _copyArray;
var hasRequired_copyArray;
function require_copyArray() {
  if (hasRequired_copyArray) return _copyArray;
  hasRequired_copyArray = 1;
  function copyArray(source, array) {
    var index = -1,
      length = source.length;
    array || (array = Array(length));
    while (++index < length) {
      array[index] = source[index];
    }
    return array;
  }
  _copyArray = copyArray;
  return _copyArray;
}
var _arrayFilter;
var hasRequired_arrayFilter;
function require_arrayFilter() {
  if (hasRequired_arrayFilter) return _arrayFilter;
  hasRequired_arrayFilter = 1;
  function arrayFilter(array, predicate) {
    var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];
    while (++index < length) {
      var value = array[index];
      if (predicate(value, index, array)) {
        result[resIndex++] = value;
      }
    }
    return result;
  }
  _arrayFilter = arrayFilter;
  return _arrayFilter;
}
var stubArray_1;
var hasRequiredStubArray;
function requireStubArray() {
  if (hasRequiredStubArray) return stubArray_1;
  hasRequiredStubArray = 1;
  function stubArray() {
    return [];
  }
  stubArray_1 = stubArray;
  return stubArray_1;
}
var _getSymbols;
var hasRequired_getSymbols;
function require_getSymbols() {
  if (hasRequired_getSymbols) return _getSymbols;
  hasRequired_getSymbols = 1;
  var arrayFilter = require_arrayFilter(),
    stubArray = requireStubArray();
  var objectProto = Object.prototype;
  var propertyIsEnumerable = objectProto.propertyIsEnumerable;
  var nativeGetSymbols = Object.getOwnPropertySymbols;
  var getSymbols = !nativeGetSymbols
    ? stubArray
    : function (object) {
        if (object == null) {
          return [];
        }
        object = Object(object);
        return arrayFilter(nativeGetSymbols(object), function (symbol) {
          return propertyIsEnumerable.call(object, symbol);
        });
      };
  _getSymbols = getSymbols;
  return _getSymbols;
}
var _copySymbols;
var hasRequired_copySymbols;
function require_copySymbols() {
  if (hasRequired_copySymbols) return _copySymbols;
  hasRequired_copySymbols = 1;
  var copyObject = require_copyObject(),
    getSymbols = require_getSymbols();
  function copySymbols(source, object) {
    return copyObject(source, getSymbols(source), object);
  }
  _copySymbols = copySymbols;
  return _copySymbols;
}
var _arrayPush;
var hasRequired_arrayPush;
function require_arrayPush() {
  if (hasRequired_arrayPush) return _arrayPush;
  hasRequired_arrayPush = 1;
  function arrayPush(array, values) {
    var index = -1,
      length = values.length,
      offset = array.length;
    while (++index < length) {
      array[offset + index] = values[index];
    }
    return array;
  }
  _arrayPush = arrayPush;
  return _arrayPush;
}
var _getPrototype;
var hasRequired_getPrototype;
function require_getPrototype() {
  if (hasRequired_getPrototype) return _getPrototype;
  hasRequired_getPrototype = 1;
  var overArg = require_overArg();
  var getPrototype = overArg(Object.getPrototypeOf, Object);
  _getPrototype = getPrototype;
  return _getPrototype;
}
var _getSymbolsIn;
var hasRequired_getSymbolsIn;
function require_getSymbolsIn() {
  if (hasRequired_getSymbolsIn) return _getSymbolsIn;
  hasRequired_getSymbolsIn = 1;
  var arrayPush = require_arrayPush(),
    getPrototype = require_getPrototype(),
    getSymbols = require_getSymbols(),
    stubArray = requireStubArray();
  var nativeGetSymbols = Object.getOwnPropertySymbols;
  var getSymbolsIn = !nativeGetSymbols
    ? stubArray
    : function (object) {
        var result = [];
        while (object) {
          arrayPush(result, getSymbols(object));
          object = getPrototype(object);
        }
        return result;
      };
  _getSymbolsIn = getSymbolsIn;
  return _getSymbolsIn;
}
var _copySymbolsIn;
var hasRequired_copySymbolsIn;
function require_copySymbolsIn() {
  if (hasRequired_copySymbolsIn) return _copySymbolsIn;
  hasRequired_copySymbolsIn = 1;
  var copyObject = require_copyObject(),
    getSymbolsIn = require_getSymbolsIn();
  function copySymbolsIn(source, object) {
    return copyObject(source, getSymbolsIn(source), object);
  }
  _copySymbolsIn = copySymbolsIn;
  return _copySymbolsIn;
}
var _baseGetAllKeys;
var hasRequired_baseGetAllKeys;
function require_baseGetAllKeys() {
  if (hasRequired_baseGetAllKeys) return _baseGetAllKeys;
  hasRequired_baseGetAllKeys = 1;
  var arrayPush = require_arrayPush(),
    isArray = requireIsArray();
  function baseGetAllKeys(object, keysFunc, symbolsFunc) {
    var result = keysFunc(object);
    return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
  }
  _baseGetAllKeys = baseGetAllKeys;
  return _baseGetAllKeys;
}
var _getAllKeys;
var hasRequired_getAllKeys;
function require_getAllKeys() {
  if (hasRequired_getAllKeys) return _getAllKeys;
  hasRequired_getAllKeys = 1;
  var baseGetAllKeys = require_baseGetAllKeys(),
    getSymbols = require_getSymbols(),
    keys = requireKeys();
  function getAllKeys(object) {
    return baseGetAllKeys(object, keys, getSymbols);
  }
  _getAllKeys = getAllKeys;
  return _getAllKeys;
}
var _getAllKeysIn;
var hasRequired_getAllKeysIn;
function require_getAllKeysIn() {
  if (hasRequired_getAllKeysIn) return _getAllKeysIn;
  hasRequired_getAllKeysIn = 1;
  var baseGetAllKeys = require_baseGetAllKeys(),
    getSymbolsIn = require_getSymbolsIn(),
    keysIn = requireKeysIn();
  function getAllKeysIn(object) {
    return baseGetAllKeys(object, keysIn, getSymbolsIn);
  }
  _getAllKeysIn = getAllKeysIn;
  return _getAllKeysIn;
}
var _DataView;
var hasRequired_DataView;
function require_DataView() {
  if (hasRequired_DataView) return _DataView;
  hasRequired_DataView = 1;
  var getNative = require_getNative(),
    root = require_root();
  var DataView = getNative(root, 'DataView');
  _DataView = DataView;
  return _DataView;
}
var _Promise;
var hasRequired_Promise;
function require_Promise() {
  if (hasRequired_Promise) return _Promise;
  hasRequired_Promise = 1;
  var getNative = require_getNative(),
    root = require_root();
  var Promise = getNative(root, 'Promise');
  _Promise = Promise;
  return _Promise;
}
var _Set;
var hasRequired_Set;
function require_Set() {
  if (hasRequired_Set) return _Set;
  hasRequired_Set = 1;
  var getNative = require_getNative(),
    root = require_root();
  var Set = getNative(root, 'Set');
  _Set = Set;
  return _Set;
}
var _WeakMap;
var hasRequired_WeakMap;
function require_WeakMap() {
  if (hasRequired_WeakMap) return _WeakMap;
  hasRequired_WeakMap = 1;
  var getNative = require_getNative(),
    root = require_root();
  var WeakMap = getNative(root, 'WeakMap');
  _WeakMap = WeakMap;
  return _WeakMap;
}
var _getTag;
var hasRequired_getTag;
function require_getTag() {
  if (hasRequired_getTag) return _getTag;
  hasRequired_getTag = 1;
  var DataView = require_DataView(),
    Map = require_Map(),
    Promise = require_Promise(),
    Set = require_Set(),
    WeakMap = require_WeakMap(),
    baseGetTag = require_baseGetTag(),
    toSource = require_toSource();
  var mapTag = '[object Map]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';
  var dataViewTag = '[object DataView]';
  var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);
  var getTag = baseGetTag;
  if (
    (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map()) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set()) != setTag) ||
    (WeakMap && getTag(new WeakMap()) != weakMapTag)
  ) {
    getTag = function (value) {
      var result = baseGetTag(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';
      if (ctorString) {
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag;
          case mapCtorString:
            return mapTag;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag;
          case weakMapCtorString:
            return weakMapTag;
        }
      }
      return result;
    };
  }
  _getTag = getTag;
  return _getTag;
}
var _initCloneArray;
var hasRequired_initCloneArray;
function require_initCloneArray() {
  if (hasRequired_initCloneArray) return _initCloneArray;
  hasRequired_initCloneArray = 1;
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function initCloneArray(array) {
    var length = array.length,
      result = new array.constructor(length);
    if (
      length &&
      typeof array[0] == 'string' &&
      hasOwnProperty.call(array, 'index')
    ) {
      result.index = array.index;
      result.input = array.input;
    }
    return result;
  }
  _initCloneArray = initCloneArray;
  return _initCloneArray;
}
var _Uint8Array;
var hasRequired_Uint8Array;
function require_Uint8Array() {
  if (hasRequired_Uint8Array) return _Uint8Array;
  hasRequired_Uint8Array = 1;
  var root = require_root();
  var Uint8Array = root.Uint8Array;
  _Uint8Array = Uint8Array;
  return _Uint8Array;
}
var _cloneArrayBuffer;
var hasRequired_cloneArrayBuffer;
function require_cloneArrayBuffer() {
  if (hasRequired_cloneArrayBuffer) return _cloneArrayBuffer;
  hasRequired_cloneArrayBuffer = 1;
  var Uint8Array = require_Uint8Array();
  function cloneArrayBuffer(arrayBuffer) {
    var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
    new Uint8Array(result).set(new Uint8Array(arrayBuffer));
    return result;
  }
  _cloneArrayBuffer = cloneArrayBuffer;
  return _cloneArrayBuffer;
}
var _cloneDataView;
var hasRequired_cloneDataView;
function require_cloneDataView() {
  if (hasRequired_cloneDataView) return _cloneDataView;
  hasRequired_cloneDataView = 1;
  var cloneArrayBuffer = require_cloneArrayBuffer();
  function cloneDataView(dataView, isDeep) {
    var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
    return new dataView.constructor(
      buffer,
      dataView.byteOffset,
      dataView.byteLength
    );
  }
  _cloneDataView = cloneDataView;
  return _cloneDataView;
}
var _cloneRegExp;
var hasRequired_cloneRegExp;
function require_cloneRegExp() {
  if (hasRequired_cloneRegExp) return _cloneRegExp;
  hasRequired_cloneRegExp = 1;
  var reFlags = /\w*$/;
  function cloneRegExp(regexp) {
    var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
    result.lastIndex = regexp.lastIndex;
    return result;
  }
  _cloneRegExp = cloneRegExp;
  return _cloneRegExp;
}
var _cloneSymbol;
var hasRequired_cloneSymbol;
function require_cloneSymbol() {
  if (hasRequired_cloneSymbol) return _cloneSymbol;
  hasRequired_cloneSymbol = 1;
  var Symbol = require_Symbol();
  var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;
  function cloneSymbol(symbol) {
    return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
  }
  _cloneSymbol = cloneSymbol;
  return _cloneSymbol;
}
var _cloneTypedArray;
var hasRequired_cloneTypedArray;
function require_cloneTypedArray() {
  if (hasRequired_cloneTypedArray) return _cloneTypedArray;
  hasRequired_cloneTypedArray = 1;
  var cloneArrayBuffer = require_cloneArrayBuffer();
  function cloneTypedArray(typedArray, isDeep) {
    var buffer = isDeep
      ? cloneArrayBuffer(typedArray.buffer)
      : typedArray.buffer;
    return new typedArray.constructor(
      buffer,
      typedArray.byteOffset,
      typedArray.length
    );
  }
  _cloneTypedArray = cloneTypedArray;
  return _cloneTypedArray;
}
var _initCloneByTag;
var hasRequired_initCloneByTag;
function require_initCloneByTag() {
  if (hasRequired_initCloneByTag) return _initCloneByTag;
  hasRequired_initCloneByTag = 1;
  var cloneArrayBuffer = require_cloneArrayBuffer(),
    cloneDataView = require_cloneDataView(),
    cloneRegExp = require_cloneRegExp(),
    cloneSymbol = require_cloneSymbol(),
    cloneTypedArray = require_cloneTypedArray();
  var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';
  var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';
  function initCloneByTag(object, tag, isDeep) {
    var Ctor = object.constructor;
    switch (tag) {
      case arrayBufferTag:
        return cloneArrayBuffer(object);
      case boolTag:
      case dateTag:
        return new Ctor(+object);
      case dataViewTag:
        return cloneDataView(object, isDeep);
      case float32Tag:
      case float64Tag:
      case int8Tag:
      case int16Tag:
      case int32Tag:
      case uint8Tag:
      case uint8ClampedTag:
      case uint16Tag:
      case uint32Tag:
        return cloneTypedArray(object, isDeep);
      case mapTag:
        return new Ctor();
      case numberTag:
      case stringTag:
        return new Ctor(object);
      case regexpTag:
        return cloneRegExp(object);
      case setTag:
        return new Ctor();
      case symbolTag:
        return cloneSymbol(object);
    }
  }
  _initCloneByTag = initCloneByTag;
  return _initCloneByTag;
}
var _baseCreate;
var hasRequired_baseCreate;
function require_baseCreate() {
  if (hasRequired_baseCreate) return _baseCreate;
  hasRequired_baseCreate = 1;
  var isObject = requireIsObject();
  var objectCreate = Object.create;
  var baseCreate = (function () {
    function object() {}
    return function (proto) {
      if (!isObject(proto)) {
        return {};
      }
      if (objectCreate) {
        return objectCreate(proto);
      }
      object.prototype = proto;
      var result = new object();
      object.prototype = undefined;
      return result;
    };
  })();
  _baseCreate = baseCreate;
  return _baseCreate;
}
var _initCloneObject;
var hasRequired_initCloneObject;
function require_initCloneObject() {
  if (hasRequired_initCloneObject) return _initCloneObject;
  hasRequired_initCloneObject = 1;
  var baseCreate = require_baseCreate(),
    getPrototype = require_getPrototype(),
    isPrototype = require_isPrototype();
  function initCloneObject(object) {
    return typeof object.constructor == 'function' && !isPrototype(object)
      ? baseCreate(getPrototype(object))
      : {};
  }
  _initCloneObject = initCloneObject;
  return _initCloneObject;
}
var _baseIsMap;
var hasRequired_baseIsMap;
function require_baseIsMap() {
  if (hasRequired_baseIsMap) return _baseIsMap;
  hasRequired_baseIsMap = 1;
  var getTag = require_getTag(),
    isObjectLike = requireIsObjectLike();
  var mapTag = '[object Map]';
  function baseIsMap(value) {
    return isObjectLike(value) && getTag(value) == mapTag;
  }
  _baseIsMap = baseIsMap;
  return _baseIsMap;
}
var isMap_1;
var hasRequiredIsMap;
function requireIsMap() {
  if (hasRequiredIsMap) return isMap_1;
  hasRequiredIsMap = 1;
  var baseIsMap = require_baseIsMap(),
    baseUnary = require_baseUnary(),
    nodeUtil = require_nodeUtil();
  var nodeIsMap = nodeUtil && nodeUtil.isMap;
  var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
  isMap_1 = isMap;
  return isMap_1;
}
var _baseIsSet;
var hasRequired_baseIsSet;
function require_baseIsSet() {
  if (hasRequired_baseIsSet) return _baseIsSet;
  hasRequired_baseIsSet = 1;
  var getTag = require_getTag(),
    isObjectLike = requireIsObjectLike();
  var setTag = '[object Set]';
  function baseIsSet(value) {
    return isObjectLike(value) && getTag(value) == setTag;
  }
  _baseIsSet = baseIsSet;
  return _baseIsSet;
}
var isSet_1;
var hasRequiredIsSet;
function requireIsSet() {
  if (hasRequiredIsSet) return isSet_1;
  hasRequiredIsSet = 1;
  var baseIsSet = require_baseIsSet(),
    baseUnary = require_baseUnary(),
    nodeUtil = require_nodeUtil();
  var nodeIsSet = nodeUtil && nodeUtil.isSet;
  var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
  isSet_1 = isSet;
  return isSet_1;
}
var _baseClone;
var hasRequired_baseClone;
function require_baseClone() {
  if (hasRequired_baseClone) return _baseClone;
  hasRequired_baseClone = 1;
  var Stack = require_Stack(),
    arrayEach = require_arrayEach(),
    assignValue = require_assignValue(),
    baseAssign = require_baseAssign(),
    baseAssignIn = require_baseAssignIn(),
    cloneBuffer = require_cloneBuffer(),
    copyArray = require_copyArray(),
    copySymbols = require_copySymbols(),
    copySymbolsIn = require_copySymbolsIn(),
    getAllKeys = require_getAllKeys(),
    getAllKeysIn = require_getAllKeysIn(),
    getTag = require_getTag(),
    initCloneArray = require_initCloneArray(),
    initCloneByTag = require_initCloneByTag(),
    initCloneObject = require_initCloneObject(),
    isArray = requireIsArray(),
    isBuffer = requireIsBuffer(),
    isMap = requireIsMap(),
    isObject = requireIsObject(),
    isSet = requireIsSet(),
    keys = requireKeys(),
    keysIn = requireKeysIn();
  var CLONE_DEEP_FLAG = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG = 4;
  var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]',
    weakMapTag = '[object WeakMap]';
  var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';
  var cloneableTags = {};
  cloneableTags[argsTag] =
    cloneableTags[arrayTag] =
    cloneableTags[arrayBufferTag] =
    cloneableTags[dataViewTag] =
    cloneableTags[boolTag] =
    cloneableTags[dateTag] =
    cloneableTags[float32Tag] =
    cloneableTags[float64Tag] =
    cloneableTags[int8Tag] =
    cloneableTags[int16Tag] =
    cloneableTags[int32Tag] =
    cloneableTags[mapTag] =
    cloneableTags[numberTag] =
    cloneableTags[objectTag] =
    cloneableTags[regexpTag] =
    cloneableTags[setTag] =
    cloneableTags[stringTag] =
    cloneableTags[symbolTag] =
    cloneableTags[uint8Tag] =
    cloneableTags[uint8ClampedTag] =
    cloneableTags[uint16Tag] =
    cloneableTags[uint32Tag] =
      true;
  cloneableTags[errorTag] =
    cloneableTags[funcTag] =
    cloneableTags[weakMapTag] =
      false;
  function baseClone(value, bitmask, customizer, key, object, stack) {
    var result,
      isDeep = bitmask & CLONE_DEEP_FLAG,
      isFlat = bitmask & CLONE_FLAT_FLAG,
      isFull = bitmask & CLONE_SYMBOLS_FLAG;
    if (customizer) {
      result = object
        ? customizer(value, key, object, stack)
        : customizer(value);
    }
    if (result !== undefined) {
      return result;
    }
    if (!isObject(value)) {
      return value;
    }
    var isArr = isArray(value);
    if (isArr) {
      result = initCloneArray(value);
      if (!isDeep) {
        return copyArray(value, result);
      }
    } else {
      var tag = getTag(value),
        isFunc = tag == funcTag || tag == genTag;
      if (isBuffer(value)) {
        return cloneBuffer(value, isDeep);
      }
      if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
        result = isFlat || isFunc ? {} : initCloneObject(value);
        if (!isDeep) {
          return isFlat
            ? copySymbolsIn(value, baseAssignIn(result, value))
            : copySymbols(value, baseAssign(result, value));
        }
      } else {
        if (!cloneableTags[tag]) {
          return object ? value : {};
        }
        result = initCloneByTag(value, tag, isDeep);
      }
    }
    stack || (stack = new Stack());
    var stacked = stack.get(value);
    if (stacked) {
      return stacked;
    }
    stack.set(value, result);
    if (isSet(value)) {
      value.forEach(function (subValue) {
        result.add(
          baseClone(subValue, bitmask, customizer, subValue, value, stack)
        );
      });
    } else if (isMap(value)) {
      value.forEach(function (subValue, key) {
        result.set(
          key,
          baseClone(subValue, bitmask, customizer, key, value, stack)
        );
      });
    }
    var keysFunc = isFull
      ? isFlat
        ? getAllKeysIn
        : getAllKeys
      : isFlat
        ? keysIn
        : keys;
    var props = isArr ? undefined : keysFunc(value);
    arrayEach(props || value, function (subValue, key) {
      if (props) {
        key = subValue;
        subValue = value[key];
      }
      assignValue(
        result,
        key,
        baseClone(subValue, bitmask, customizer, key, value, stack)
      );
    });
    return result;
  }
  _baseClone = baseClone;
  return _baseClone;
}
var clone_1;
var hasRequiredClone;
function requireClone() {
  if (hasRequiredClone) return clone_1;
  hasRequiredClone = 1;
  var baseClone = require_baseClone();
  var CLONE_SYMBOLS_FLAG = 4;
  function clone(value) {
    return baseClone(value, CLONE_SYMBOLS_FLAG);
  }
  clone_1 = clone;
  return clone_1;
}
var hasRequiredVisitors;
function requireVisitors() {
  if (hasRequiredVisitors) return visitors;
  hasRequiredVisitors = 1;
  Object.defineProperty(visitors, '__esModule', {value: true});
  visitors.explode = explode;
  visitors.verify = verify;
  visitors.merge = merge;
  var virtualTypes = _interopRequireWildcard(requireVirtualTypes());
  var t = _interopRequireWildcard(t$d);
  var _clone = _interopRequireDefault(requireClone());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function _getRequireWildcardCache() {
    if (typeof WeakMap !== 'function') return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function () {
      return cache;
    };
    return cache;
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }
    if (
      obj === null ||
      (typeof obj !== 'object' && typeof obj !== 'function')
    ) {
      return {default: obj};
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor =
      Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor
          ? Object.getOwnPropertyDescriptor(obj, key)
          : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj.default = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function explode(visitor) {
    if (visitor._exploded) return visitor;
    visitor._exploded = true;
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      const parts = nodeType.split('|');
      if (parts.length === 1) continue;
      const fns = visitor[nodeType];
      delete visitor[nodeType];
      for (const part of parts) {
        visitor[part] = fns;
      }
    }
    verify(visitor);
    delete visitor.__esModule;
    ensureEntranceObjects(visitor);
    ensureCallbackArrays(visitor);
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      const wrapper = virtualTypes[nodeType];
      if (!wrapper) continue;
      const fns = visitor[nodeType];
      for (const type of Object.keys(fns)) {
        fns[type] = wrapCheck(wrapper, fns[type]);
      }
      delete visitor[nodeType];
      if (wrapper.types) {
        for (const type of wrapper.types) {
          if (visitor[type]) {
            mergePair(visitor[type], fns);
          } else {
            visitor[type] = fns;
          }
        }
      } else {
        mergePair(visitor, fns);
      }
    }
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      const fns = visitor[nodeType];
      let aliases = t.FLIPPED_ALIAS_KEYS[nodeType];
      const deprecratedKey = t.DEPRECATED_KEYS[nodeType];
      if (deprecratedKey) {
        console.trace(
          `Visitor defined for ${nodeType} but it has been renamed to ${deprecratedKey}`
        );
        aliases = [deprecratedKey];
      }
      if (!aliases) continue;
      delete visitor[nodeType];
      for (const alias of aliases) {
        const existing = visitor[alias];
        if (existing) {
          mergePair(existing, fns);
        } else {
          visitor[alias] = (0, _clone.default)(fns);
        }
      }
    }
    for (const nodeType of Object.keys(visitor)) {
      if (shouldIgnoreKey(nodeType)) continue;
      ensureCallbackArrays(visitor[nodeType]);
    }
    return visitor;
  }
  function verify(visitor) {
    if (visitor._verified) return;
    if (typeof visitor === 'function') {
      throw new Error(
        'You passed `traverse()` a function when it expected a visitor object, ' +
          "are you sure you didn't mean `{ enter: Function }`?"
      );
    }
    for (const nodeType of Object.keys(visitor)) {
      if (nodeType === 'enter' || nodeType === 'exit') {
        validateVisitorMethods(nodeType, visitor[nodeType]);
      }
      if (shouldIgnoreKey(nodeType)) continue;
      if (t.TYPES.indexOf(nodeType) < 0) {
        throw new Error(
          `You gave us a visitor for the node type ${nodeType} but it's not a valid type`
        );
      }
      const visitors = visitor[nodeType];
      if (typeof visitors === 'object') {
        for (const visitorKey of Object.keys(visitors)) {
          if (visitorKey === 'enter' || visitorKey === 'exit') {
            validateVisitorMethods(
              `${nodeType}.${visitorKey}`,
              visitors[visitorKey]
            );
          } else {
            throw new Error(
              'You passed `traverse()` a visitor object with the property ' +
                `${nodeType} that has the invalid property ${visitorKey}`
            );
          }
        }
      }
    }
    visitor._verified = true;
  }
  function validateVisitorMethods(path, val) {
    const fns = [].concat(val);
    for (const fn of fns) {
      if (typeof fn !== 'function') {
        throw new TypeError(
          `Non-function found defined in ${path} with type ${typeof fn}`
        );
      }
    }
  }
  function merge(visitors, states = [], wrapper) {
    const rootVisitor = {};
    for (let i = 0; i < visitors.length; i++) {
      const visitor = visitors[i];
      const state = states[i];
      explode(visitor);
      for (const type of Object.keys(visitor)) {
        let visitorType = visitor[type];
        if (state || wrapper) {
          visitorType = wrapWithStateOrWrapper(visitorType, state, wrapper);
        }
        const nodeVisitor = (rootVisitor[type] = rootVisitor[type] || {});
        mergePair(nodeVisitor, visitorType);
      }
    }
    return rootVisitor;
  }
  function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
    const newVisitor = {};
    for (const key of Object.keys(oldVisitor)) {
      let fns = oldVisitor[key];
      if (!Array.isArray(fns)) continue;
      fns = fns.map(function (fn) {
        let newFn = fn;
        if (state) {
          newFn = function (path) {
            return fn.call(state, path, state);
          };
        }
        if (wrapper) {
          newFn = wrapper(state.key, key, newFn);
        }
        return newFn;
      });
      newVisitor[key] = fns;
    }
    return newVisitor;
  }
  function ensureEntranceObjects(obj) {
    for (const key of Object.keys(obj)) {
      if (shouldIgnoreKey(key)) continue;
      const fns = obj[key];
      if (typeof fns === 'function') {
        obj[key] = {enter: fns};
      }
    }
  }
  function ensureCallbackArrays(obj) {
    if (obj.enter && !Array.isArray(obj.enter)) obj.enter = [obj.enter];
    if (obj.exit && !Array.isArray(obj.exit)) obj.exit = [obj.exit];
  }
  function wrapCheck(wrapper, fn) {
    const newFn = function (path) {
      if (wrapper.checkPath(path)) {
        return fn.apply(this, arguments);
      }
    };
    newFn.toString = () => fn.toString();
    return newFn;
  }
  function shouldIgnoreKey(key) {
    if (key[0] === '_') return true;
    if (key === 'enter' || key === 'exit' || key === 'shouldSkip') return true;
    if (key === 'blacklist' || key === 'noScope' || key === 'skipKeys') {
      return true;
    }
    return false;
  }
  function mergePair(dest, src) {
    for (const key of Object.keys(src)) {
      dest[key] = [].concat(dest[key] || [], src[key]);
    }
  }
  return visitors;
}
var hub = {};
var hasRequiredHub;
function requireHub() {
  if (hasRequiredHub) return hub;
  hasRequiredHub = 1;
  Object.defineProperty(hub, '__esModule', {value: true});
  hub.default = void 0;
  class Hub {
    getCode() {}
    getScope() {}
    addHelper() {
      throw new Error('Helpers are not supported by the default hub.');
    }
    buildError(node, msg, Error = TypeError) {
      return new Error(msg);
    }
  }
  hub.default = Hub;
  return hub;
}
var hasRequiredLib$1;
function requireLib$1() {
  if (hasRequiredLib$1) return lib$c;
  hasRequiredLib$1 = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.default = traverse;
    Object.defineProperty(exports, 'NodePath', {
      enumerable: true,
      get: function () {
        return _path.default;
      },
    });
    Object.defineProperty(exports, 'Scope', {
      enumerable: true,
      get: function () {
        return _scope.default;
      },
    });
    Object.defineProperty(exports, 'Hub', {
      enumerable: true,
      get: function () {
        return _hub.default;
      },
    });
    exports.visitors = void 0;
    var _context = _interopRequireDefault(requireContext());
    var visitors = _interopRequireWildcard(requireVisitors());
    exports.visitors = visitors;
    var _includes = _interopRequireDefault(requireIncludes());
    var t = _interopRequireWildcard(t$d);
    var cache = _interopRequireWildcard(requireCache());
    var _path = _interopRequireDefault(requirePath());
    var _scope = _interopRequireDefault(requireScope());
    var _hub = _interopRequireDefault(requireHub());
    function _getRequireWildcardCache() {
      if (typeof WeakMap !== 'function') return null;
      var cache = new WeakMap();
      _getRequireWildcardCache = function () {
        return cache;
      };
      return cache;
    }
    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }
      if (
        obj === null ||
        (typeof obj !== 'object' && typeof obj !== 'function')
      ) {
        return {default: obj};
      }
      var cache = _getRequireWildcardCache();
      if (cache && cache.has(obj)) {
        return cache.get(obj);
      }
      var newObj = {};
      var hasPropertyDescriptor =
        Object.defineProperty && Object.getOwnPropertyDescriptor;
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor
            ? Object.getOwnPropertyDescriptor(obj, key)
            : null;
          if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
      newObj.default = obj;
      if (cache) {
        cache.set(obj, newObj);
      }
      return newObj;
    }
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {default: obj};
    }
    function traverse(parent, opts, scope, state, parentPath) {
      if (!parent) return;
      if (!opts) opts = {};
      if (!opts.noScope && !scope) {
        if (parent.type !== 'Program' && parent.type !== 'File') {
          throw new Error(
            'You must pass a scope and parentPath unless traversing a Program/File. ' +
              `Instead of that you tried to traverse a ${parent.type} node without ` +
              'passing scope and parentPath.'
          );
        }
      }
      if (!t.VISITOR_KEYS[parent.type]) {
        return;
      }
      visitors.explode(opts);
      traverse.node(parent, opts, scope, state, parentPath);
    }
    traverse.visitors = visitors;
    traverse.verify = visitors.verify;
    traverse.explode = visitors.explode;
    traverse.cheap = function (node, enter) {
      return t.traverseFast(node, enter);
    };
    traverse.node = function (node, opts, scope, state, parentPath, skipKeys) {
      const keys = t.VISITOR_KEYS[node.type];
      if (!keys) return;
      const context = new _context.default(scope, opts, state, parentPath);
      for (const key of keys) {
        if (skipKeys && skipKeys[key]) continue;
        if (context.visit(node, key)) return;
      }
    };
    traverse.clearNode = function (node, opts) {
      t.removeProperties(node, opts);
      cache.path.delete(node);
    };
    traverse.removeProperties = function (tree, opts) {
      t.traverseFast(tree, traverse.clearNode, opts);
      return tree;
    };
    function hasBlacklistedType(path, state) {
      if (path.node.type === state.type) {
        state.has = true;
        path.stop();
      }
    }
    traverse.hasType = function (tree, type, blacklistTypes) {
      if ((0, _includes.default)(blacklistTypes, tree.type)) return false;
      if (tree.type === type) return true;
      const state = {has: false, type: type};
      traverse(
        tree,
        {noScope: true, blacklist: blacklistTypes, enter: hasBlacklistedType},
        null,
        state
      );
      return state.has;
    };
    traverse.cache = cache;
  })(lib$c);
  return lib$c;
}
var semver = {exports: {}};
var hasRequiredSemver;
function requireSemver() {
  if (hasRequiredSemver) return semver.exports;
  hasRequiredSemver = 1;
  (function (module, exports) {
    exports = module.exports = SemVer;
    var debug;
    if (
      typeof process === 'object' &&
      process.env &&
      process.env.NODE_DEBUG &&
      /\bsemver\b/i.test(process.env.NODE_DEBUG)
    ) {
      debug = function () {
        var args = Array.prototype.slice.call(arguments, 0);
        args.unshift('SEMVER');
        console.log.apply(console, args);
      };
    } else {
      debug = function () {};
    }
    exports.SEMVER_SPEC_VERSION = '2.0.0';
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var re = (exports.re = []);
    var src = (exports.src = []);
    var R = 0;
    var NUMERICIDENTIFIER = R++;
    src[NUMERICIDENTIFIER] = '0|[1-9]\\d*';
    var NUMERICIDENTIFIERLOOSE = R++;
    src[NUMERICIDENTIFIERLOOSE] = '[0-9]+';
    var NONNUMERICIDENTIFIER = R++;
    src[NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-][a-zA-Z0-9-]*';
    var MAINVERSION = R++;
    src[MAINVERSION] =
      '(' +
      src[NUMERICIDENTIFIER] +
      ')\\.' +
      '(' +
      src[NUMERICIDENTIFIER] +
      ')\\.' +
      '(' +
      src[NUMERICIDENTIFIER] +
      ')';
    var MAINVERSIONLOOSE = R++;
    src[MAINVERSIONLOOSE] =
      '(' +
      src[NUMERICIDENTIFIERLOOSE] +
      ')\\.' +
      '(' +
      src[NUMERICIDENTIFIERLOOSE] +
      ')\\.' +
      '(' +
      src[NUMERICIDENTIFIERLOOSE] +
      ')';
    var PRERELEASEIDENTIFIER = R++;
    src[PRERELEASEIDENTIFIER] =
      '(?:' + src[NUMERICIDENTIFIER] + '|' + src[NONNUMERICIDENTIFIER] + ')';
    var PRERELEASEIDENTIFIERLOOSE = R++;
    src[PRERELEASEIDENTIFIERLOOSE] =
      '(?:' +
      src[NUMERICIDENTIFIERLOOSE] +
      '|' +
      src[NONNUMERICIDENTIFIER] +
      ')';
    var PRERELEASE = R++;
    src[PRERELEASE] =
      '(?:-(' +
      src[PRERELEASEIDENTIFIER] +
      '(?:\\.' +
      src[PRERELEASEIDENTIFIER] +
      ')*))';
    var PRERELEASELOOSE = R++;
    src[PRERELEASELOOSE] =
      '(?:-?(' +
      src[PRERELEASEIDENTIFIERLOOSE] +
      '(?:\\.' +
      src[PRERELEASEIDENTIFIERLOOSE] +
      ')*))';
    var BUILDIDENTIFIER = R++;
    src[BUILDIDENTIFIER] = '[0-9A-Za-z-]+';
    var BUILD = R++;
    src[BUILD] =
      '(?:\\+(' +
      src[BUILDIDENTIFIER] +
      '(?:\\.' +
      src[BUILDIDENTIFIER] +
      ')*))';
    var FULL = R++;
    var FULLPLAIN =
      'v?' + src[MAINVERSION] + src[PRERELEASE] + '?' + src[BUILD] + '?';
    src[FULL] = '^' + FULLPLAIN + '$';
    var LOOSEPLAIN =
      '[v=\\s]*' +
      src[MAINVERSIONLOOSE] +
      src[PRERELEASELOOSE] +
      '?' +
      src[BUILD] +
      '?';
    var LOOSE = R++;
    src[LOOSE] = '^' + LOOSEPLAIN + '$';
    var GTLT = R++;
    src[GTLT] = '((?:<|>)?=?)';
    var XRANGEIDENTIFIERLOOSE = R++;
    src[XRANGEIDENTIFIERLOOSE] = src[NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
    var XRANGEIDENTIFIER = R++;
    src[XRANGEIDENTIFIER] = src[NUMERICIDENTIFIER] + '|x|X|\\*';
    var XRANGEPLAIN = R++;
    src[XRANGEPLAIN] =
      '[v=\\s]*(' +
      src[XRANGEIDENTIFIER] +
      ')' +
      '(?:\\.(' +
      src[XRANGEIDENTIFIER] +
      ')' +
      '(?:\\.(' +
      src[XRANGEIDENTIFIER] +
      ')' +
      '(?:' +
      src[PRERELEASE] +
      ')?' +
      src[BUILD] +
      '?' +
      ')?)?';
    var XRANGEPLAINLOOSE = R++;
    src[XRANGEPLAINLOOSE] =
      '[v=\\s]*(' +
      src[XRANGEIDENTIFIERLOOSE] +
      ')' +
      '(?:\\.(' +
      src[XRANGEIDENTIFIERLOOSE] +
      ')' +
      '(?:\\.(' +
      src[XRANGEIDENTIFIERLOOSE] +
      ')' +
      '(?:' +
      src[PRERELEASELOOSE] +
      ')?' +
      src[BUILD] +
      '?' +
      ')?)?';
    var XRANGE = R++;
    src[XRANGE] = '^' + src[GTLT] + '\\s*' + src[XRANGEPLAIN] + '$';
    var XRANGELOOSE = R++;
    src[XRANGELOOSE] = '^' + src[GTLT] + '\\s*' + src[XRANGEPLAINLOOSE] + '$';
    var COERCE = R++;
    src[COERCE] =
      '(?:^|[^\\d])' +
      '(\\d{1,' +
      MAX_SAFE_COMPONENT_LENGTH +
      '})' +
      '(?:\\.(\\d{1,' +
      MAX_SAFE_COMPONENT_LENGTH +
      '}))?' +
      '(?:\\.(\\d{1,' +
      MAX_SAFE_COMPONENT_LENGTH +
      '}))?' +
      '(?:$|[^\\d])';
    var LONETILDE = R++;
    src[LONETILDE] = '(?:~>?)';
    var TILDETRIM = R++;
    src[TILDETRIM] = '(\\s*)' + src[LONETILDE] + '\\s+';
    re[TILDETRIM] = new RegExp(src[TILDETRIM], 'g');
    var tildeTrimReplace = '$1~';
    var TILDE = R++;
    src[TILDE] = '^' + src[LONETILDE] + src[XRANGEPLAIN] + '$';
    var TILDELOOSE = R++;
    src[TILDELOOSE] = '^' + src[LONETILDE] + src[XRANGEPLAINLOOSE] + '$';
    var LONECARET = R++;
    src[LONECARET] = '(?:\\^)';
    var CARETTRIM = R++;
    src[CARETTRIM] = '(\\s*)' + src[LONECARET] + '\\s+';
    re[CARETTRIM] = new RegExp(src[CARETTRIM], 'g');
    var caretTrimReplace = '$1^';
    var CARET = R++;
    src[CARET] = '^' + src[LONECARET] + src[XRANGEPLAIN] + '$';
    var CARETLOOSE = R++;
    src[CARETLOOSE] = '^' + src[LONECARET] + src[XRANGEPLAINLOOSE] + '$';
    var COMPARATORLOOSE = R++;
    src[COMPARATORLOOSE] = '^' + src[GTLT] + '\\s*(' + LOOSEPLAIN + ')$|^$';
    var COMPARATOR = R++;
    src[COMPARATOR] = '^' + src[GTLT] + '\\s*(' + FULLPLAIN + ')$|^$';
    var COMPARATORTRIM = R++;
    src[COMPARATORTRIM] =
      '(\\s*)' +
      src[GTLT] +
      '\\s*(' +
      LOOSEPLAIN +
      '|' +
      src[XRANGEPLAIN] +
      ')';
    re[COMPARATORTRIM] = new RegExp(src[COMPARATORTRIM], 'g');
    var comparatorTrimReplace = '$1$2$3';
    var HYPHENRANGE = R++;
    src[HYPHENRANGE] =
      '^\\s*(' +
      src[XRANGEPLAIN] +
      ')' +
      '\\s+-\\s+' +
      '(' +
      src[XRANGEPLAIN] +
      ')' +
      '\\s*$';
    var HYPHENRANGELOOSE = R++;
    src[HYPHENRANGELOOSE] =
      '^\\s*(' +
      src[XRANGEPLAINLOOSE] +
      ')' +
      '\\s+-\\s+' +
      '(' +
      src[XRANGEPLAINLOOSE] +
      ')' +
      '\\s*$';
    var STAR = R++;
    src[STAR] = '(<|>)?=?\\s*\\*';
    for (var i = 0; i < R; i++) {
      debug(i, src[i]);
      if (!re[i]) {
        re[i] = new RegExp(src[i]);
      }
    }
    exports.parse = parse;
    function parse(version, options) {
      if (!options || typeof options !== 'object') {
        options = {loose: !!options, includePrerelease: false};
      }
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== 'string') {
        return null;
      }
      if (version.length > MAX_LENGTH) {
        return null;
      }
      var r = options.loose ? re[LOOSE] : re[FULL];
      if (!r.test(version)) {
        return null;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        return null;
      }
    }
    exports.valid = valid;
    function valid(version, options) {
      var v = parse(version, options);
      return v ? v.version : null;
    }
    exports.clean = clean;
    function clean(version, options) {
      var s = parse(version.trim().replace(/^[=v]+/, ''), options);
      return s ? s.version : null;
    }
    exports.SemVer = SemVer;
    function SemVer(version, options) {
      if (!options || typeof options !== 'object') {
        options = {loose: !!options, includePrerelease: false};
      }
      if (version instanceof SemVer) {
        if (version.loose === options.loose) {
          return version;
        } else {
          version = version.version;
        }
      } else if (typeof version !== 'string') {
        throw new TypeError('Invalid Version: ' + version);
      }
      if (version.length > MAX_LENGTH) {
        throw new TypeError(
          'version is longer than ' + MAX_LENGTH + ' characters'
        );
      }
      if (!(this instanceof SemVer)) {
        return new SemVer(version, options);
      }
      debug('SemVer', version, options);
      this.options = options;
      this.loose = !!options.loose;
      var m = version.trim().match(options.loose ? re[LOOSE] : re[FULL]);
      if (!m) {
        throw new TypeError('Invalid Version: ' + version);
      }
      this.raw = version;
      this.major = +m[1];
      this.minor = +m[2];
      this.patch = +m[3];
      if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
        throw new TypeError('Invalid major version');
      }
      if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
        throw new TypeError('Invalid minor version');
      }
      if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
        throw new TypeError('Invalid patch version');
      }
      if (!m[4]) {
        this.prerelease = [];
      } else {
        this.prerelease = m[4].split('.').map(function (id) {
          if (/^[0-9]+$/.test(id)) {
            var num = +id;
            if (num >= 0 && num < MAX_SAFE_INTEGER) {
              return num;
            }
          }
          return id;
        });
      }
      this.build = m[5] ? m[5].split('.') : [];
      this.format();
    }
    SemVer.prototype.format = function () {
      this.version = this.major + '.' + this.minor + '.' + this.patch;
      if (this.prerelease.length) {
        this.version += '-' + this.prerelease.join('.');
      }
      return this.version;
    };
    SemVer.prototype.toString = function () {
      return this.version;
    };
    SemVer.prototype.compare = function (other) {
      debug('SemVer.compare', this.version, this.options, other);
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return this.compareMain(other) || this.comparePre(other);
    };
    SemVer.prototype.compareMain = function (other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return (
        compareIdentifiers(this.major, other.major) ||
        compareIdentifiers(this.minor, other.minor) ||
        compareIdentifiers(this.patch, other.patch)
      );
    };
    SemVer.prototype.comparePre = function (other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      if (this.prerelease.length && !other.prerelease.length) {
        return -1;
      } else if (!this.prerelease.length && other.prerelease.length) {
        return 1;
      } else if (!this.prerelease.length && !other.prerelease.length) {
        return 0;
      }
      var i = 0;
      do {
        var a = this.prerelease[i];
        var b = other.prerelease[i];
        debug('prerelease compare', i, a, b);
        if (a === undefined && b === undefined) {
          return 0;
        } else if (b === undefined) {
          return 1;
        } else if (a === undefined) {
          return -1;
        } else if (a === b) {
          continue;
        } else {
          return compareIdentifiers(a, b);
        }
      } while (++i);
    };
    SemVer.prototype.inc = function (release, identifier) {
      switch (release) {
        case 'premajor':
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor = 0;
          this.major++;
          this.inc('pre', identifier);
          break;
        case 'preminor':
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor++;
          this.inc('pre', identifier);
          break;
        case 'prepatch':
          this.prerelease.length = 0;
          this.inc('patch', identifier);
          this.inc('pre', identifier);
          break;
        case 'prerelease':
          if (this.prerelease.length === 0) {
            this.inc('patch', identifier);
          }
          this.inc('pre', identifier);
          break;
        case 'major':
          if (
            this.minor !== 0 ||
            this.patch !== 0 ||
            this.prerelease.length === 0
          ) {
            this.major++;
          }
          this.minor = 0;
          this.patch = 0;
          this.prerelease = [];
          break;
        case 'minor':
          if (this.patch !== 0 || this.prerelease.length === 0) {
            this.minor++;
          }
          this.patch = 0;
          this.prerelease = [];
          break;
        case 'patch':
          if (this.prerelease.length === 0) {
            this.patch++;
          }
          this.prerelease = [];
          break;
        case 'pre':
          if (this.prerelease.length === 0) {
            this.prerelease = [0];
          } else {
            var i = this.prerelease.length;
            while (--i >= 0) {
              if (typeof this.prerelease[i] === 'number') {
                this.prerelease[i]++;
                i = -2;
              }
            }
            if (i === -1) {
              this.prerelease.push(0);
            }
          }
          if (identifier) {
            if (this.prerelease[0] === identifier) {
              if (isNaN(this.prerelease[1])) {
                this.prerelease = [identifier, 0];
              }
            } else {
              this.prerelease = [identifier, 0];
            }
          }
          break;
        default:
          throw new Error('invalid increment argument: ' + release);
      }
      this.format();
      this.raw = this.version;
      return this;
    };
    exports.inc = inc;
    function inc(version, release, loose, identifier) {
      if (typeof loose === 'string') {
        identifier = loose;
        loose = undefined;
      }
      try {
        return new SemVer(version, loose).inc(release, identifier).version;
      } catch (er) {
        return null;
      }
    }
    exports.diff = diff;
    function diff(version1, version2) {
      if (eq(version1, version2)) {
        return null;
      } else {
        var v1 = parse(version1);
        var v2 = parse(version2);
        var prefix = '';
        if (v1.prerelease.length || v2.prerelease.length) {
          prefix = 'pre';
          var defaultResult = 'prerelease';
        }
        for (var key in v1) {
          if (key === 'major' || key === 'minor' || key === 'patch') {
            if (v1[key] !== v2[key]) {
              return prefix + key;
            }
          }
        }
        return defaultResult;
      }
    }
    exports.compareIdentifiers = compareIdentifiers;
    var numeric = /^[0-9]+$/;
    function compareIdentifiers(a, b) {
      var anum = numeric.test(a);
      var bnum = numeric.test(b);
      if (anum && bnum) {
        a = +a;
        b = +b;
      }
      return a === b
        ? 0
        : anum && !bnum
          ? -1
          : bnum && !anum
            ? 1
            : a < b
              ? -1
              : 1;
    }
    exports.rcompareIdentifiers = rcompareIdentifiers;
    function rcompareIdentifiers(a, b) {
      return compareIdentifiers(b, a);
    }
    exports.major = major;
    function major(a, loose) {
      return new SemVer(a, loose).major;
    }
    exports.minor = minor;
    function minor(a, loose) {
      return new SemVer(a, loose).minor;
    }
    exports.patch = patch;
    function patch(a, loose) {
      return new SemVer(a, loose).patch;
    }
    exports.compare = compare;
    function compare(a, b, loose) {
      return new SemVer(a, loose).compare(new SemVer(b, loose));
    }
    exports.compareLoose = compareLoose;
    function compareLoose(a, b) {
      return compare(a, b, true);
    }
    exports.rcompare = rcompare;
    function rcompare(a, b, loose) {
      return compare(b, a, loose);
    }
    exports.sort = sort;
    function sort(list, loose) {
      return list.sort(function (a, b) {
        return exports.compare(a, b, loose);
      });
    }
    exports.rsort = rsort;
    function rsort(list, loose) {
      return list.sort(function (a, b) {
        return exports.rcompare(a, b, loose);
      });
    }
    exports.gt = gt;
    function gt(a, b, loose) {
      return compare(a, b, loose) > 0;
    }
    exports.lt = lt;
    function lt(a, b, loose) {
      return compare(a, b, loose) < 0;
    }
    exports.eq = eq;
    function eq(a, b, loose) {
      return compare(a, b, loose) === 0;
    }
    exports.neq = neq;
    function neq(a, b, loose) {
      return compare(a, b, loose) !== 0;
    }
    exports.gte = gte;
    function gte(a, b, loose) {
      return compare(a, b, loose) >= 0;
    }
    exports.lte = lte;
    function lte(a, b, loose) {
      return compare(a, b, loose) <= 0;
    }
    exports.cmp = cmp;
    function cmp(a, op, b, loose) {
      switch (op) {
        case '===':
          if (typeof a === 'object') a = a.version;
          if (typeof b === 'object') b = b.version;
          return a === b;
        case '!==':
          if (typeof a === 'object') a = a.version;
          if (typeof b === 'object') b = b.version;
          return a !== b;
        case '':
        case '=':
        case '==':
          return eq(a, b, loose);
        case '!=':
          return neq(a, b, loose);
        case '>':
          return gt(a, b, loose);
        case '>=':
          return gte(a, b, loose);
        case '<':
          return lt(a, b, loose);
        case '<=':
          return lte(a, b, loose);
        default:
          throw new TypeError('Invalid operator: ' + op);
      }
    }
    exports.Comparator = Comparator;
    function Comparator(comp, options) {
      if (!options || typeof options !== 'object') {
        options = {loose: !!options, includePrerelease: false};
      }
      if (comp instanceof Comparator) {
        if (comp.loose === !!options.loose) {
          return comp;
        } else {
          comp = comp.value;
        }
      }
      if (!(this instanceof Comparator)) {
        return new Comparator(comp, options);
      }
      debug('comparator', comp, options);
      this.options = options;
      this.loose = !!options.loose;
      this.parse(comp);
      if (this.semver === ANY) {
        this.value = '';
      } else {
        this.value = this.operator + this.semver.version;
      }
      debug('comp', this);
    }
    var ANY = {};
    Comparator.prototype.parse = function (comp) {
      var r = this.options.loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
      var m = comp.match(r);
      if (!m) {
        throw new TypeError('Invalid comparator: ' + comp);
      }
      this.operator = m[1];
      if (this.operator === '=') {
        this.operator = '';
      }
      if (!m[2]) {
        this.semver = ANY;
      } else {
        this.semver = new SemVer(m[2], this.options.loose);
      }
    };
    Comparator.prototype.toString = function () {
      return this.value;
    };
    Comparator.prototype.test = function (version) {
      debug('Comparator.test', version, this.options.loose);
      if (this.semver === ANY) {
        return true;
      }
      if (typeof version === 'string') {
        version = new SemVer(version, this.options);
      }
      return cmp(version, this.operator, this.semver, this.options);
    };
    Comparator.prototype.intersects = function (comp, options) {
      if (!(comp instanceof Comparator)) {
        throw new TypeError('a Comparator is required');
      }
      if (!options || typeof options !== 'object') {
        options = {loose: !!options, includePrerelease: false};
      }
      var rangeTmp;
      if (this.operator === '') {
        rangeTmp = new Range(comp.value, options);
        return satisfies(this.value, rangeTmp, options);
      } else if (comp.operator === '') {
        rangeTmp = new Range(this.value, options);
        return satisfies(comp.semver, rangeTmp, options);
      }
      var sameDirectionIncreasing =
        (this.operator === '>=' || this.operator === '>') &&
        (comp.operator === '>=' || comp.operator === '>');
      var sameDirectionDecreasing =
        (this.operator === '<=' || this.operator === '<') &&
        (comp.operator === '<=' || comp.operator === '<');
      var sameSemVer = this.semver.version === comp.semver.version;
      var differentDirectionsInclusive =
        (this.operator === '>=' || this.operator === '<=') &&
        (comp.operator === '>=' || comp.operator === '<=');
      var oppositeDirectionsLessThan =
        cmp(this.semver, '<', comp.semver, options) &&
        (this.operator === '>=' || this.operator === '>') &&
          (comp.operator === '<=' || comp.operator === '<');
      var oppositeDirectionsGreaterThan =
        cmp(this.semver, '>', comp.semver, options) &&
        (this.operator === '<=' || this.operator === '<') &&
          (comp.operator === '>=' || comp.operator === '>');
      return (
        sameDirectionIncreasing ||
        sameDirectionDecreasing ||
        (sameSemVer && differentDirectionsInclusive) ||
        oppositeDirectionsLessThan ||
        oppositeDirectionsGreaterThan
      );
    };
    exports.Range = Range;
    function Range(range, options) {
      if (!options || typeof options !== 'object') {
        options = {loose: !!options, includePrerelease: false};
      }
      if (range instanceof Range) {
        if (
          range.loose === !!options.loose &&
          range.includePrerelease === !!options.includePrerelease
        ) {
          return range;
        } else {
          return new Range(range.raw, options);
        }
      }
      if (range instanceof Comparator) {
        return new Range(range.value, options);
      }
      if (!(this instanceof Range)) {
        return new Range(range, options);
      }
      this.options = options;
      this.loose = !!options.loose;
      this.includePrerelease = !!options.includePrerelease;
      this.raw = range;
      this.set = range
        .split(/\s*\|\|\s*/)
        .map(function (range) {
          return this.parseRange(range.trim());
        }, this)
        .filter(function (c) {
          return c.length;
        });
      if (!this.set.length) {
        throw new TypeError('Invalid SemVer Range: ' + range);
      }
      this.format();
    }
    Range.prototype.format = function () {
      this.range = this.set
        .map(function (comps) {
          return comps.join(' ').trim();
        })
        .join('||')
        .trim();
      return this.range;
    };
    Range.prototype.toString = function () {
      return this.range;
    };
    Range.prototype.parseRange = function (range) {
      var loose = this.options.loose;
      range = range.trim();
      var hr = loose ? re[HYPHENRANGELOOSE] : re[HYPHENRANGE];
      range = range.replace(hr, hyphenReplace);
      debug('hyphen replace', range);
      range = range.replace(re[COMPARATORTRIM], comparatorTrimReplace);
      debug('comparator trim', range, re[COMPARATORTRIM]);
      range = range.replace(re[TILDETRIM], tildeTrimReplace);
      range = range.replace(re[CARETTRIM], caretTrimReplace);
      range = range.split(/\s+/).join(' ');
      var compRe = loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
      var set = range
        .split(' ')
        .map(function (comp) {
          return parseComparator(comp, this.options);
        }, this)
        .join(' ')
        .split(/\s+/);
      if (this.options.loose) {
        set = set.filter(function (comp) {
          return !!comp.match(compRe);
        });
      }
      set = set.map(function (comp) {
        return new Comparator(comp, this.options);
      }, this);
      return set;
    };
    Range.prototype.intersects = function (range, options) {
      if (!(range instanceof Range)) {
        throw new TypeError('a Range is required');
      }
      return this.set.some(function (thisComparators) {
        return thisComparators.every(function (thisComparator) {
          return range.set.some(function (rangeComparators) {
            return rangeComparators.every(function (rangeComparator) {
              return thisComparator.intersects(rangeComparator, options);
            });
          });
        });
      });
    };
    exports.toComparators = toComparators;
    function toComparators(range, options) {
      return new Range(range, options).set.map(function (comp) {
        return comp
          .map(function (c) {
            return c.value;
          })
          .join(' ')
          .trim()
          .split(' ');
      });
    }
    function parseComparator(comp, options) {
      debug('comp', comp, options);
      comp = replaceCarets(comp, options);
      debug('caret', comp);
      comp = replaceTildes(comp, options);
      debug('tildes', comp);
      comp = replaceXRanges(comp, options);
      debug('xrange', comp);
      comp = replaceStars(comp, options);
      debug('stars', comp);
      return comp;
    }
    function isX(id) {
      return !id || id.toLowerCase() === 'x' || id === '*';
    }
    function replaceTildes(comp, options) {
      return comp
        .trim()
        .split(/\s+/)
        .map(function (comp) {
          return replaceTilde(comp, options);
        })
        .join(' ');
    }
    function replaceTilde(comp, options) {
      var r = options.loose ? re[TILDELOOSE] : re[TILDE];
      return comp.replace(r, function (_, M, m, p, pr) {
        debug('tilde', comp, _, M, m, p, pr);
        var ret;
        if (isX(M)) {
          ret = '';
        } else if (isX(m)) {
          ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
        } else if (isX(p)) {
          ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
        } else if (pr) {
          debug('replaceTilde pr', pr);
          ret =
            '>=' +
            M +
            '.' +
            m +
            '.' +
            p +
            '-' +
            pr +
            ' <' +
            M +
            '.' +
            (+m + 1) +
            '.0';
        } else {
          ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
        }
        debug('tilde return', ret);
        return ret;
      });
    }
    function replaceCarets(comp, options) {
      return comp
        .trim()
        .split(/\s+/)
        .map(function (comp) {
          return replaceCaret(comp, options);
        })
        .join(' ');
    }
    function replaceCaret(comp, options) {
      debug('caret', comp, options);
      var r = options.loose ? re[CARETLOOSE] : re[CARET];
      return comp.replace(r, function (_, M, m, p, pr) {
        debug('caret', comp, _, M, m, p, pr);
        var ret;
        if (isX(M)) {
          ret = '';
        } else if (isX(m)) {
          ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
        } else if (isX(p)) {
          if (M === '0') {
            ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
          } else {
            ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
          }
        } else if (pr) {
          debug('replaceCaret pr', pr);
          if (M === '0') {
            if (m === '0') {
              ret =
                '>=' +
                M +
                '.' +
                m +
                '.' +
                p +
                '-' +
                pr +
                ' <' +
                M +
                '.' +
                m +
                '.' +
                (+p + 1);
            } else {
              ret =
                '>=' +
                M +
                '.' +
                m +
                '.' +
                p +
                '-' +
                pr +
                ' <' +
                M +
                '.' +
                (+m + 1) +
                '.0';
            }
          } else {
            ret =
              '>=' +
              M +
              '.' +
              m +
              '.' +
              p +
              '-' +
              pr +
              ' <' +
              (+M + 1) +
              '.0.0';
          }
        } else {
          debug('no pr');
          if (M === '0') {
            if (m === '0') {
              ret =
                '>=' +
                M +
                '.' +
                m +
                '.' +
                p +
                ' <' +
                M +
                '.' +
                m +
                '.' +
                (+p + 1);
            } else {
              ret =
                '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
            }
          } else {
            ret = '>=' + M + '.' + m + '.' + p + ' <' + (+M + 1) + '.0.0';
          }
        }
        debug('caret return', ret);
        return ret;
      });
    }
    function replaceXRanges(comp, options) {
      debug('replaceXRanges', comp, options);
      return comp
        .split(/\s+/)
        .map(function (comp) {
          return replaceXRange(comp, options);
        })
        .join(' ');
    }
    function replaceXRange(comp, options) {
      comp = comp.trim();
      var r = options.loose ? re[XRANGELOOSE] : re[XRANGE];
      return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
        debug('xRange', comp, ret, gtlt, M, m, p, pr);
        var xM = isX(M);
        var xm = xM || isX(m);
        var xp = xm || isX(p);
        var anyX = xp;
        if (gtlt === '=' && anyX) {
          gtlt = '';
        }
        if (xM) {
          if (gtlt === '>' || gtlt === '<') {
            ret = '<0.0.0';
          } else {
            ret = '*';
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m = 0;
          }
          p = 0;
          if (gtlt === '>') {
            gtlt = '>=';
            if (xm) {
              M = +M + 1;
              m = 0;
              p = 0;
            } else {
              m = +m + 1;
              p = 0;
            }
          } else if (gtlt === '<=') {
            gtlt = '<';
            if (xm) {
              M = +M + 1;
            } else {
              m = +m + 1;
            }
          }
          ret = gtlt + M + '.' + m + '.' + p;
        } else if (xm) {
          ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
        } else if (xp) {
          ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
        }
        debug('xRange return', ret);
        return ret;
      });
    }
    function replaceStars(comp, options) {
      debug('replaceStars', comp, options);
      return comp.trim().replace(re[STAR], '');
    }
    function hyphenReplace(
      $0,
      from,
      fM,
      fm,
      fp,
      fpr,
      fb,
      to,
      tM,
      tm,
      tp,
      tpr,
      tb
    ) {
      if (isX(fM)) {
        from = '';
      } else if (isX(fm)) {
        from = '>=' + fM + '.0.0';
      } else if (isX(fp)) {
        from = '>=' + fM + '.' + fm + '.0';
      } else {
        from = '>=' + from;
      }
      if (isX(tM)) {
        to = '';
      } else if (isX(tm)) {
        to = '<' + (+tM + 1) + '.0.0';
      } else if (isX(tp)) {
        to = '<' + tM + '.' + (+tm + 1) + '.0';
      } else if (tpr) {
        to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
      } else {
        to = '<=' + to;
      }
      return (from + ' ' + to).trim();
    }
    Range.prototype.test = function (version) {
      if (!version) {
        return false;
      }
      if (typeof version === 'string') {
        version = new SemVer(version, this.options);
      }
      for (var i = 0; i < this.set.length; i++) {
        if (testSet(this.set[i], version, this.options)) {
          return true;
        }
      }
      return false;
    };
    function testSet(set, version, options) {
      for (var i = 0; i < set.length; i++) {
        if (!set[i].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (i = 0; i < set.length; i++) {
          debug(set[i].semver);
          if (set[i].semver === ANY) {
            continue;
          }
          if (set[i].semver.prerelease.length > 0) {
            var allowed = set[i].semver;
            if (
              allowed.major === version.major &&
              allowed.minor === version.minor &&
              allowed.patch === version.patch
            ) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    }
    exports.satisfies = satisfies;
    function satisfies(version, range, options) {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    }
    exports.maxSatisfying = maxSatisfying;
    function maxSatisfying(versions, range, options) {
      var max = null;
      var maxSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function (v) {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    }
    exports.minSatisfying = minSatisfying;
    function minSatisfying(versions, range, options) {
      var min = null;
      var minSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function (v) {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    }
    exports.minVersion = minVersion;
    function minVersion(range, loose) {
      range = new Range(range, loose);
      var minver = new SemVer('0.0.0');
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer('0.0.0-0');
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (var i = 0; i < range.set.length; ++i) {
        var comparators = range.set[i];
        comparators.forEach(function (comparator) {
          var compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case '>':
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case '':
            case '>=':
              if (!minver || gt(minver, compver)) {
                minver = compver;
              }
              break;
            case '<':
            case '<=':
              break;
            default:
              throw new Error('Unexpected operation: ' + comparator.operator);
          }
        });
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    }
    exports.validRange = validRange;
    function validRange(range, options) {
      try {
        return new Range(range, options).range || '*';
      } catch (er) {
        return null;
      }
    }
    exports.ltr = ltr;
    function ltr(version, range, options) {
      return outside(version, range, '<', options);
    }
    exports.gtr = gtr;
    function gtr(version, range, options) {
      return outside(version, range, '>', options);
    }
    exports.outside = outside;
    function outside(version, range, hilo, options) {
      version = new SemVer(version, options);
      range = new Range(range, options);
      var gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case '>':
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = '>';
          ecomp = '>=';
          break;
        case '<':
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = '<';
          ecomp = '<=';
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (var i = 0; i < range.set.length; ++i) {
        var comparators = range.set[i];
        var high = null;
        var low = null;
        comparators.forEach(function (comparator) {
          if (comparator.semver === ANY) {
            comparator = new Comparator('>=0.0.0');
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if (
          (!low.operator || low.operator === comp) &&
          ltefn(version, low.semver)
        ) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    }
    exports.prerelease = prerelease;
    function prerelease(version, options) {
      var parsed = parse(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    }
    exports.intersects = intersects;
    function intersects(r1, r2, options) {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2);
    }
    exports.coerce = coerce;
    function coerce(version) {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== 'string') {
        return null;
      }
      var match = version.match(re[COERCE]);
      if (match == null) {
        return null;
      }
      return parse(
        match[1] + '.' + (match[2] || '0') + '.' + (match[3] || '0')
      );
    }
  })(semver, semver.exports);
  return semver.exports;
}
Object.defineProperty(file, '__esModule', {value: true});
file.default = void 0;
function helpers$1() {
  const data = _interopRequireWildcard$d(requireLib$c());
  helpers$1 = function () {
    return data;
  };
  return data;
}
function _traverse() {
  const data = _interopRequireWildcard$d(requireLib$1());
  _traverse = function () {
    return data;
  };
  return data;
}
function _codeFrame$1() {
  const data = requireLib$e();
  _codeFrame$1 = function () {
    return data;
  };
  return data;
}
function t$c() {
  const data = _interopRequireWildcard$d(t$d);
  t$c = function () {
    return data;
  };
  return data;
}
function _semver() {
  const data = _interopRequireDefault$i(requireSemver());
  _semver = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$i(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function _interopRequireWildcard$d(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
const errorVisitor = {
  enter(path, state) {
    const loc = path.node.loc;
    if (loc) {
      state.loc = loc;
      path.stop();
    }
  },
};
class File {
  constructor(options, {code: code, ast: ast, inputMap: inputMap}) {
    this._map = new Map();
    this.declarations = {};
    this.path = null;
    this.ast = {};
    this.metadata = {};
    this.code = '';
    this.inputMap = null;
    this.hub = {
      file: this,
      getCode: () => this.code,
      getScope: () => this.scope,
      addHelper: this.addHelper.bind(this),
      buildError: this.buildCodeFrameError.bind(this),
    };
    this.opts = options;
    this.code = code;
    this.ast = ast;
    this.inputMap = inputMap;
    this.path = _traverse()
      .NodePath.get({
        hub: this.hub,
        parentPath: null,
        parent: this.ast,
        container: this.ast,
        key: 'program',
      })
      .setContext();
    this.scope = this.path.scope;
  }
  get shebang() {
    const {interpreter: interpreter} = this.path.node;
    return interpreter ? interpreter.value : '';
  }
  set shebang(value) {
    if (value) {
      this.path
        .get('interpreter')
        .replaceWith(t$c().interpreterDirective(value));
    } else {
      this.path.get('interpreter').remove();
    }
  }
  set(key, val) {
    if (key === 'helpersNamespace') {
      throw new Error(
        "Babel 7.0.0-beta.56 has dropped support for the 'helpersNamespace' utility." +
          'If you are using @babel/plugin-external-helpers you will need to use a newer ' +
          'version than the one you currently have installed. ' +
          "If you have your own implementation, you'll want to explore using 'helperGenerator' " +
          "alongside 'file.availableHelper()'."
      );
    }
    this._map.set(key, val);
  }
  get(key) {
    return this._map.get(key);
  }
  has(key) {
    return this._map.has(key);
  }
  getModuleName() {
    const {
      filename: filename,
      filenameRelative: filenameRelative = filename,
      moduleId: moduleId,
      moduleIds: moduleIds = !!moduleId,
      getModuleId: getModuleId,
      sourceRoot: sourceRootTmp,
      moduleRoot: moduleRoot = sourceRootTmp,
      sourceRoot: sourceRoot = moduleRoot,
    } = this.opts;
    if (!moduleIds) return null;
    if (moduleId != null && !getModuleId) {
      return moduleId;
    }
    let moduleName = moduleRoot != null ? moduleRoot + '/' : '';
    if (filenameRelative) {
      const sourceRootReplacer =
        sourceRoot != null ? new RegExp('^' + sourceRoot + '/?') : '';
      moduleName += filenameRelative
        .replace(sourceRootReplacer, '')
        .replace(/\.(\w*?)$/, '');
    }
    moduleName = moduleName.replace(/\\/g, '/');
    if (getModuleId) {
      return getModuleId(moduleName) || moduleName;
    } else {
      return moduleName;
    }
  }
  addImport() {
    throw new Error(
      "This API has been removed. If you're looking for this " +
        'functionality in Babel 7, you should import the ' +
        "'@babel/helper-module-imports' module and use the functions exposed " +
        " from that module, such as 'addNamed' or 'addDefault'."
    );
  }
  availableHelper(name, versionRange) {
    let minVersion;
    try {
      minVersion = helpers$1().minVersion(name);
    } catch (err) {
      if (err.code !== 'BABEL_HELPER_UNKNOWN') throw err;
      return false;
    }
    if (typeof versionRange !== 'string') return true;
    if (_semver().default.valid(versionRange))
      versionRange = `^${versionRange}`;
    return (
      !_semver().default.intersects(`<${minVersion}`, versionRange) &&
      !_semver().default.intersects(`>=8.0.0`, versionRange)
    );
  }
  addHelper(name) {
    const declar = this.declarations[name];
    if (declar) return t$c().cloneNode(declar);
    const generator = this.get('helperGenerator');
    if (generator) {
      const res = generator(name);
      if (res) return res;
    }
    const uid = (this.declarations[name] =
      this.scope.generateUidIdentifier(name));
    const dependencies = {};
    for (const dep of helpers$1().getDependencies(name)) {
      dependencies[dep] = this.addHelper(dep);
    }
    const {nodes: nodes, globals: globals} = helpers$1().get(
      name,
      dep => dependencies[dep],
      uid,
      Object.keys(this.scope.getAllBindings())
    );
    globals.forEach(name => {
      if (this.path.scope.hasBinding(name, true)) {
        this.path.scope.rename(name);
      }
    });
    nodes.forEach(node => {
      node._compact = true;
    });
    this.path.unshiftContainer('body', nodes);
    this.path.get('body').forEach(path => {
      if (nodes.indexOf(path.node) === -1) return;
      if (path.isVariableDeclaration()) this.scope.registerDeclaration(path);
    });
    return uid;
  }
  addTemplateObject() {
    throw new Error(
      'This function has been moved into the template literal transform itself.'
    );
  }
  buildCodeFrameError(node, msg, Error = SyntaxError) {
    let loc = node && (node.loc || node._loc);
    msg = `${this.opts.filename}: ${msg}`;
    if (!loc && node) {
      const state = {loc: null};
      (0, _traverse().default)(node, errorVisitor, this.scope, state);
      loc = state.loc;
      let txt =
        'This is an error on an internal node. Probably an internal error.';
      if (loc) txt += ' Location has been estimated.';
      msg += ` (${txt})`;
    }
    if (loc) {
      const {highlightCode: highlightCode = true} = this.opts;
      msg +=
        '\n' +
        (0, _codeFrame$1().codeFrameColumns)(
          this.code,
          {start: {line: loc.start.line, column: loc.start.column + 1}},
          {highlightCode: highlightCode}
        );
    }
    return new Error(msg);
  }
}
file.default = File;
var buildExternalHelpers = {};
var lib$1 = {};
var sourceMap$1 = {};
var sourceMap = {};
var sourceMapGenerator = {};
var base64Vlq = {};
var base64 = {};
var hasRequiredBase64;
function requireBase64() {
  if (hasRequiredBase64) return base64;
  hasRequiredBase64 = 1;
  var intToCharMap =
    'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split(
      ''
    );
  base64.encode = function (number) {
    if (0 <= number && number < intToCharMap.length) {
      return intToCharMap[number];
    }
    throw new TypeError('Must be between 0 and 63: ' + number);
  };
  base64.decode = function (charCode) {
    var bigA = 65;
    var bigZ = 90;
    var littleA = 97;
    var littleZ = 122;
    var zero = 48;
    var nine = 57;
    var plus = 43;
    var slash = 47;
    var littleOffset = 26;
    var numberOffset = 52;
    if (bigA <= charCode && charCode <= bigZ) {
      return charCode - bigA;
    }
    if (littleA <= charCode && charCode <= littleZ) {
      return charCode - littleA + littleOffset;
    }
    if (zero <= charCode && charCode <= nine) {
      return charCode - zero + numberOffset;
    }
    if (charCode == plus) {
      return 62;
    }
    if (charCode == slash) {
      return 63;
    }
    return -1;
  };
  return base64;
}
var hasRequiredBase64Vlq;
function requireBase64Vlq() {
  if (hasRequiredBase64Vlq) return base64Vlq;
  hasRequiredBase64Vlq = 1;
  var base64 = requireBase64();
  var VLQ_BASE_SHIFT = 5;
  var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
  var VLQ_BASE_MASK = VLQ_BASE - 1;
  var VLQ_CONTINUATION_BIT = VLQ_BASE;
  function toVLQSigned(aValue) {
    return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
  }
  function fromVLQSigned(aValue) {
    var isNegative = (aValue & 1) === 1;
    var shifted = aValue >> 1;
    return isNegative ? -shifted : shifted;
  }
  base64Vlq.encode = function base64VLQ_encode(aValue) {
    var encoded = '';
    var digit;
    var vlq = toVLQSigned(aValue);
    do {
      digit = vlq & VLQ_BASE_MASK;
      vlq >>>= VLQ_BASE_SHIFT;
      if (vlq > 0) {
        digit |= VLQ_CONTINUATION_BIT;
      }
      encoded += base64.encode(digit);
    } while (vlq > 0);
    return encoded;
  };
  base64Vlq.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
    var strLen = aStr.length;
    var result = 0;
    var shift = 0;
    var continuation, digit;
    do {
      if (aIndex >= strLen) {
        throw new Error('Expected more digits in base 64 VLQ value.');
      }
      digit = base64.decode(aStr.charCodeAt(aIndex++));
      if (digit === -1) {
        throw new Error('Invalid base64 digit: ' + aStr.charAt(aIndex - 1));
      }
      continuation = !!(digit & VLQ_CONTINUATION_BIT);
      digit &= VLQ_BASE_MASK;
      result = result + (digit << shift);
      shift += VLQ_BASE_SHIFT;
    } while (continuation);
    aOutParam.value = fromVLQSigned(result);
    aOutParam.rest = aIndex;
  };
  return base64Vlq;
}
var util$6 = {};
var hasRequiredUtil;
function requireUtil() {
  if (hasRequiredUtil) return util$6;
  hasRequiredUtil = 1;
  (function (exports) {
    function getArg(aArgs, aName, aDefaultValue) {
      if (aName in aArgs) {
        return aArgs[aName];
      } else if (arguments.length === 3) {
        return aDefaultValue;
      } else {
        throw new Error('"' + aName + '" is a required argument.');
      }
    }
    exports.getArg = getArg;
    var urlRegexp =
      /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;
    var dataUrlRegexp = /^data:.+\,.+$/;
    function urlParse(aUrl) {
      var match = aUrl.match(urlRegexp);
      if (!match) {
        return null;
      }
      return {
        scheme: match[1],
        auth: match[2],
        host: match[3],
        port: match[4],
        path: match[5],
      };
    }
    exports.urlParse = urlParse;
    function urlGenerate(aParsedUrl) {
      var url = '';
      if (aParsedUrl.scheme) {
        url += aParsedUrl.scheme + ':';
      }
      url += '//';
      if (aParsedUrl.auth) {
        url += aParsedUrl.auth + '@';
      }
      if (aParsedUrl.host) {
        url += aParsedUrl.host;
      }
      if (aParsedUrl.port) {
        url += ':' + aParsedUrl.port;
      }
      if (aParsedUrl.path) {
        url += aParsedUrl.path;
      }
      return url;
    }
    exports.urlGenerate = urlGenerate;
    function normalize(aPath) {
      var path = aPath;
      var url = urlParse(aPath);
      if (url) {
        if (!url.path) {
          return aPath;
        }
        path = url.path;
      }
      var isAbsolute = exports.isAbsolute(path);
      var parts = path.split(/\/+/);
      for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
        part = parts[i];
        if (part === '.') {
          parts.splice(i, 1);
        } else if (part === '..') {
          up++;
        } else if (up > 0) {
          if (part === '') {
            parts.splice(i + 1, up);
            up = 0;
          } else {
            parts.splice(i, 2);
            up--;
          }
        }
      }
      path = parts.join('/');
      if (path === '') {
        path = isAbsolute ? '/' : '.';
      }
      if (url) {
        url.path = path;
        return urlGenerate(url);
      }
      return path;
    }
    exports.normalize = normalize;
    function join(aRoot, aPath) {
      if (aRoot === '') {
        aRoot = '.';
      }
      if (aPath === '') {
        aPath = '.';
      }
      var aPathUrl = urlParse(aPath);
      var aRootUrl = urlParse(aRoot);
      if (aRootUrl) {
        aRoot = aRootUrl.path || '/';
      }
      if (aPathUrl && !aPathUrl.scheme) {
        if (aRootUrl) {
          aPathUrl.scheme = aRootUrl.scheme;
        }
        return urlGenerate(aPathUrl);
      }
      if (aPathUrl || aPath.match(dataUrlRegexp)) {
        return aPath;
      }
      if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
        aRootUrl.host = aPath;
        return urlGenerate(aRootUrl);
      }
      var joined =
        aPath.charAt(0) === '/'
          ? aPath
          : normalize(aRoot.replace(/\/+$/, '') + '/' + aPath);
      if (aRootUrl) {
        aRootUrl.path = joined;
        return urlGenerate(aRootUrl);
      }
      return joined;
    }
    exports.join = join;
    exports.isAbsolute = function (aPath) {
      return aPath.charAt(0) === '/' || !!aPath.match(urlRegexp);
    };
    function relative(aRoot, aPath) {
      if (aRoot === '') {
        aRoot = '.';
      }
      aRoot = aRoot.replace(/\/$/, '');
      var level = 0;
      while (aPath.indexOf(aRoot + '/') !== 0) {
        var index = aRoot.lastIndexOf('/');
        if (index < 0) {
          return aPath;
        }
        aRoot = aRoot.slice(0, index);
        if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
          return aPath;
        }
        ++level;
      }
      return Array(level + 1).join('../') + aPath.substr(aRoot.length + 1);
    }
    exports.relative = relative;
    var supportsNullProto = (function () {
      var obj = Object.create(null);
      return !('__proto__' in obj);
    })();
    function identity(s) {
      return s;
    }
    function toSetString(aStr) {
      if (isProtoString(aStr)) {
        return '$' + aStr;
      }
      return aStr;
    }
    exports.toSetString = supportsNullProto ? identity : toSetString;
    function fromSetString(aStr) {
      if (isProtoString(aStr)) {
        return aStr.slice(1);
      }
      return aStr;
    }
    exports.fromSetString = supportsNullProto ? identity : fromSetString;
    function isProtoString(s) {
      if (!s) {
        return false;
      }
      var length = s.length;
      if (length < 9) {
        return false;
      }
      if (
        s.charCodeAt(length - 1) !== 95 ||
        s.charCodeAt(length - 2) !== 95 ||
        s.charCodeAt(length - 3) !== 111 ||
        s.charCodeAt(length - 4) !== 116 ||
        s.charCodeAt(length - 5) !== 111 ||
        s.charCodeAt(length - 6) !== 114 ||
        s.charCodeAt(length - 7) !== 112 ||
        s.charCodeAt(length - 8) !== 95 ||
        s.charCodeAt(length - 9) !== 95
      ) {
        return false;
      }
      for (var i = length - 10; i >= 0; i--) {
        if (s.charCodeAt(i) !== 36) {
          return false;
        }
      }
      return true;
    }
    function compareByOriginalPositions(
      mappingA,
      mappingB,
      onlyCompareOriginal
    ) {
      var cmp = mappingA.source - mappingB.source;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0 || onlyCompareOriginal) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      return mappingA.name - mappingB.name;
    }
    exports.compareByOriginalPositions = compareByOriginalPositions;
    function compareByGeneratedPositionsDeflated(
      mappingA,
      mappingB,
      onlyCompareGenerated
    ) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0 || onlyCompareGenerated) {
        return cmp;
      }
      cmp = mappingA.source - mappingB.source;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return mappingA.name - mappingB.name;
    }
    exports.compareByGeneratedPositionsDeflated =
      compareByGeneratedPositionsDeflated;
    function strcmp(aStr1, aStr2) {
      if (aStr1 === aStr2) {
        return 0;
      }
      if (aStr1 > aStr2) {
        return 1;
      }
      return -1;
    }
    function compareByGeneratedPositionsInflated(mappingA, mappingB) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByGeneratedPositionsInflated =
      compareByGeneratedPositionsInflated;
  })(util$6);
  return util$6;
}
var arraySet = {};
var hasRequiredArraySet;
function requireArraySet() {
  if (hasRequiredArraySet) return arraySet;
  hasRequiredArraySet = 1;
  var util = requireUtil();
  var has = Object.prototype.hasOwnProperty;
  var hasNativeMap = typeof Map !== 'undefined';
  function ArraySet() {
    this._array = [];
    this._set = hasNativeMap ? new Map() : Object.create(null);
  }
  ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
    var set = new ArraySet();
    for (var i = 0, len = aArray.length; i < len; i++) {
      set.add(aArray[i], aAllowDuplicates);
    }
    return set;
  };
  ArraySet.prototype.size = function ArraySet_size() {
    return hasNativeMap
      ? this._set.size
      : Object.getOwnPropertyNames(this._set).length;
  };
  ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
    var sStr = hasNativeMap ? aStr : util.toSetString(aStr);
    var isDuplicate = hasNativeMap ? this.has(aStr) : has.call(this._set, sStr);
    var idx = this._array.length;
    if (!isDuplicate || aAllowDuplicates) {
      this._array.push(aStr);
    }
    if (!isDuplicate) {
      if (hasNativeMap) {
        this._set.set(aStr, idx);
      } else {
        this._set[sStr] = idx;
      }
    }
  };
  ArraySet.prototype.has = function ArraySet_has(aStr) {
    if (hasNativeMap) {
      return this._set.has(aStr);
    } else {
      var sStr = util.toSetString(aStr);
      return has.call(this._set, sStr);
    }
  };
  ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
    if (hasNativeMap) {
      var idx = this._set.get(aStr);
      if (idx >= 0) {
        return idx;
      }
    } else {
      var sStr = util.toSetString(aStr);
      if (has.call(this._set, sStr)) {
        return this._set[sStr];
      }
    }
    throw new Error('"' + aStr + '" is not in the set.');
  };
  ArraySet.prototype.at = function ArraySet_at(aIdx) {
    if (aIdx >= 0 && aIdx < this._array.length) {
      return this._array[aIdx];
    }
    throw new Error('No element indexed by ' + aIdx);
  };
  ArraySet.prototype.toArray = function ArraySet_toArray() {
    return this._array.slice();
  };
  arraySet.ArraySet = ArraySet;
  return arraySet;
}
var mappingList = {};
var hasRequiredMappingList;
function requireMappingList() {
  if (hasRequiredMappingList) return mappingList;
  hasRequiredMappingList = 1;
  var util = requireUtil();
  function generatedPositionAfter(mappingA, mappingB) {
    var lineA = mappingA.generatedLine;
    var lineB = mappingB.generatedLine;
    var columnA = mappingA.generatedColumn;
    var columnB = mappingB.generatedColumn;
    return (
      lineB > lineA ||
      (lineB == lineA && columnB >= columnA) ||
      util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0
    );
  }
  function MappingList() {
    this._array = [];
    this._sorted = true;
    this._last = {generatedLine: -1, generatedColumn: 0};
  }
  MappingList.prototype.unsortedForEach = function MappingList_forEach(
    aCallback,
    aThisArg
  ) {
    this._array.forEach(aCallback, aThisArg);
  };
  MappingList.prototype.add = function MappingList_add(aMapping) {
    if (generatedPositionAfter(this._last, aMapping)) {
      this._last = aMapping;
      this._array.push(aMapping);
    } else {
      this._sorted = false;
      this._array.push(aMapping);
    }
  };
  MappingList.prototype.toArray = function MappingList_toArray() {
    if (!this._sorted) {
      this._array.sort(util.compareByGeneratedPositionsInflated);
      this._sorted = true;
    }
    return this._array;
  };
  mappingList.MappingList = MappingList;
  return mappingList;
}
var hasRequiredSourceMapGenerator;
function requireSourceMapGenerator() {
  if (hasRequiredSourceMapGenerator) return sourceMapGenerator;
  hasRequiredSourceMapGenerator = 1;
  var base64VLQ = requireBase64Vlq();
  var util = requireUtil();
  var ArraySet = requireArraySet().ArraySet;
  var MappingList = requireMappingList().MappingList;
  function SourceMapGenerator(aArgs) {
    if (!aArgs) {
      aArgs = {};
    }
    this._file = util.getArg(aArgs, 'file', null);
    this._sourceRoot = util.getArg(aArgs, 'sourceRoot', null);
    this._skipValidation = util.getArg(aArgs, 'skipValidation', false);
    this._sources = new ArraySet();
    this._names = new ArraySet();
    this._mappings = new MappingList();
    this._sourcesContents = null;
  }
  SourceMapGenerator.prototype._version = 3;
  SourceMapGenerator.fromSourceMap = function SourceMapGenerator_fromSourceMap(
    aSourceMapConsumer
  ) {
    var sourceRoot = aSourceMapConsumer.sourceRoot;
    var generator = new SourceMapGenerator({
      file: aSourceMapConsumer.file,
      sourceRoot: sourceRoot,
    });
    aSourceMapConsumer.eachMapping(function (mapping) {
      var newMapping = {
        generated: {
          line: mapping.generatedLine,
          column: mapping.generatedColumn,
        },
      };
      if (mapping.source != null) {
        newMapping.source = mapping.source;
        if (sourceRoot != null) {
          newMapping.source = util.relative(sourceRoot, newMapping.source);
        }
        newMapping.original = {
          line: mapping.originalLine,
          column: mapping.originalColumn,
        };
        if (mapping.name != null) {
          newMapping.name = mapping.name;
        }
      }
      generator.addMapping(newMapping);
    });
    aSourceMapConsumer.sources.forEach(function (sourceFile) {
      var content = aSourceMapConsumer.sourceContentFor(sourceFile);
      if (content != null) {
        generator.setSourceContent(sourceFile, content);
      }
    });
    return generator;
  };
  SourceMapGenerator.prototype.addMapping =
    function SourceMapGenerator_addMapping(aArgs) {
      var generated = util.getArg(aArgs, 'generated');
      var original = util.getArg(aArgs, 'original', null);
      var source = util.getArg(aArgs, 'source', null);
      var name = util.getArg(aArgs, 'name', null);
      if (!this._skipValidation) {
        this._validateMapping(generated, original, source, name);
      }
      if (source != null) {
        source = String(source);
        if (!this._sources.has(source)) {
          this._sources.add(source);
        }
      }
      if (name != null) {
        name = String(name);
        if (!this._names.has(name)) {
          this._names.add(name);
        }
      }
      this._mappings.add({
        generatedLine: generated.line,
        generatedColumn: generated.column,
        originalLine: original != null && original.line,
        originalColumn: original != null && original.column,
        source: source,
        name: name,
      });
    };
  SourceMapGenerator.prototype.setSourceContent =
    function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
      var source = aSourceFile;
      if (this._sourceRoot != null) {
        source = util.relative(this._sourceRoot, source);
      }
      if (aSourceContent != null) {
        if (!this._sourcesContents) {
          this._sourcesContents = Object.create(null);
        }
        this._sourcesContents[util.toSetString(source)] = aSourceContent;
      } else if (this._sourcesContents) {
        delete this._sourcesContents[util.toSetString(source)];
        if (Object.keys(this._sourcesContents).length === 0) {
          this._sourcesContents = null;
        }
      }
    };
  SourceMapGenerator.prototype.applySourceMap =
    function SourceMapGenerator_applySourceMap(
      aSourceMapConsumer,
      aSourceFile,
      aSourceMapPath
    ) {
      var sourceFile = aSourceFile;
      if (aSourceFile == null) {
        if (aSourceMapConsumer.file == null) {
          throw new Error(
            'SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, ' +
              'or the source map\'s "file" property. Both were omitted.'
          );
        }
        sourceFile = aSourceMapConsumer.file;
      }
      var sourceRoot = this._sourceRoot;
      if (sourceRoot != null) {
        sourceFile = util.relative(sourceRoot, sourceFile);
      }
      var newSources = new ArraySet();
      var newNames = new ArraySet();
      this._mappings.unsortedForEach(function (mapping) {
        if (mapping.source === sourceFile && mapping.originalLine != null) {
          var original = aSourceMapConsumer.originalPositionFor({
            line: mapping.originalLine,
            column: mapping.originalColumn,
          });
          if (original.source != null) {
            mapping.source = original.source;
            if (aSourceMapPath != null) {
              mapping.source = util.join(aSourceMapPath, mapping.source);
            }
            if (sourceRoot != null) {
              mapping.source = util.relative(sourceRoot, mapping.source);
            }
            mapping.originalLine = original.line;
            mapping.originalColumn = original.column;
            if (original.name != null) {
              mapping.name = original.name;
            }
          }
        }
        var source = mapping.source;
        if (source != null && !newSources.has(source)) {
          newSources.add(source);
        }
        var name = mapping.name;
        if (name != null && !newNames.has(name)) {
          newNames.add(name);
        }
      }, this);
      this._sources = newSources;
      this._names = newNames;
      aSourceMapConsumer.sources.forEach(function (sourceFile) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          if (aSourceMapPath != null) {
            sourceFile = util.join(aSourceMapPath, sourceFile);
          }
          if (sourceRoot != null) {
            sourceFile = util.relative(sourceRoot, sourceFile);
          }
          this.setSourceContent(sourceFile, content);
        }
      }, this);
    };
  SourceMapGenerator.prototype._validateMapping =
    function SourceMapGenerator_validateMapping(
      aGenerated,
      aOriginal,
      aSource,
      aName
    ) {
      if (
        aOriginal &&
        typeof aOriginal.line !== 'number' &&
        typeof aOriginal.column !== 'number'
      ) {
        throw new Error(
          'original.line and original.column are not numbers -- you probably meant to omit ' +
            'the original mapping entirely and only map the generated position. If so, pass ' +
            'null for the original mapping instead of an object with empty or null values.'
        );
      }
      if (
        aGenerated &&
        'line' in aGenerated &&
        'column' in aGenerated &&
        aGenerated.line > 0 &&
        aGenerated.column >= 0 &&
        !aOriginal &&
        !aSource &&
        !aName
      ) {
        return;
      } else if (
        aGenerated &&
        'line' in aGenerated &&
        'column' in aGenerated &&
        aOriginal &&
        'line' in aOriginal &&
        'column' in aOriginal &&
        aGenerated.line > 0 &&
        aGenerated.column >= 0 &&
        aOriginal.line > 0 &&
        aOriginal.column >= 0 &&
        aSource
      ) {
        return;
      } else {
        throw new Error(
          'Invalid mapping: ' +
            JSON.stringify({
              generated: aGenerated,
              source: aSource,
              original: aOriginal,
              name: aName,
            })
        );
      }
    };
  SourceMapGenerator.prototype._serializeMappings =
    function SourceMapGenerator_serializeMappings() {
      var previousGeneratedColumn = 0;
      var previousGeneratedLine = 1;
      var previousOriginalColumn = 0;
      var previousOriginalLine = 0;
      var previousName = 0;
      var previousSource = 0;
      var result = '';
      var next;
      var mapping;
      var nameIdx;
      var sourceIdx;
      var mappings = this._mappings.toArray();
      for (var i = 0, len = mappings.length; i < len; i++) {
        mapping = mappings[i];
        next = '';
        if (mapping.generatedLine !== previousGeneratedLine) {
          previousGeneratedColumn = 0;
          while (mapping.generatedLine !== previousGeneratedLine) {
            next += ';';
            previousGeneratedLine++;
          }
        } else {
          if (i > 0) {
            if (
              !util.compareByGeneratedPositionsInflated(
                mapping,
                mappings[i - 1]
              )
            ) {
              continue;
            }
            next += ',';
          }
        }
        next += base64VLQ.encode(
          mapping.generatedColumn - previousGeneratedColumn
        );
        previousGeneratedColumn = mapping.generatedColumn;
        if (mapping.source != null) {
          sourceIdx = this._sources.indexOf(mapping.source);
          next += base64VLQ.encode(sourceIdx - previousSource);
          previousSource = sourceIdx;
          next += base64VLQ.encode(
            mapping.originalLine - 1 - previousOriginalLine
          );
          previousOriginalLine = mapping.originalLine - 1;
          next += base64VLQ.encode(
            mapping.originalColumn - previousOriginalColumn
          );
          previousOriginalColumn = mapping.originalColumn;
          if (mapping.name != null) {
            nameIdx = this._names.indexOf(mapping.name);
            next += base64VLQ.encode(nameIdx - previousName);
            previousName = nameIdx;
          }
        }
        result += next;
      }
      return result;
    };
  SourceMapGenerator.prototype._generateSourcesContent =
    function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
      return aSources.map(function (source) {
        if (!this._sourcesContents) {
          return null;
        }
        if (aSourceRoot != null) {
          source = util.relative(aSourceRoot, source);
        }
        var key = util.toSetString(source);
        return Object.prototype.hasOwnProperty.call(this._sourcesContents, key)
          ? this._sourcesContents[key]
          : null;
      }, this);
    };
  SourceMapGenerator.prototype.toJSON = function SourceMapGenerator_toJSON() {
    var map = {
      version: this._version,
      sources: this._sources.toArray(),
      names: this._names.toArray(),
      mappings: this._serializeMappings(),
    };
    if (this._file != null) {
      map.file = this._file;
    }
    if (this._sourceRoot != null) {
      map.sourceRoot = this._sourceRoot;
    }
    if (this._sourcesContents) {
      map.sourcesContent = this._generateSourcesContent(
        map.sources,
        map.sourceRoot
      );
    }
    return map;
  };
  SourceMapGenerator.prototype.toString =
    function SourceMapGenerator_toString() {
      return JSON.stringify(this.toJSON());
    };
  sourceMapGenerator.SourceMapGenerator = SourceMapGenerator;
  return sourceMapGenerator;
}
var sourceMapConsumer = {};
var binarySearch = {};
var hasRequiredBinarySearch;
function requireBinarySearch() {
  if (hasRequiredBinarySearch) return binarySearch;
  hasRequiredBinarySearch = 1;
  (function (exports) {
    exports.GREATEST_LOWER_BOUND = 1;
    exports.LEAST_UPPER_BOUND = 2;
    function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
      var mid = Math.floor((aHigh - aLow) / 2) + aLow;
      var cmp = aCompare(aNeedle, aHaystack[mid], true);
      if (cmp === 0) {
        return mid;
      } else if (cmp > 0) {
        if (aHigh - mid > 1) {
          return recursiveSearch(
            mid,
            aHigh,
            aNeedle,
            aHaystack,
            aCompare,
            aBias
          );
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return aHigh < aHaystack.length ? aHigh : -1;
        } else {
          return mid;
        }
      } else {
        if (mid - aLow > 1) {
          return recursiveSearch(
            aLow,
            mid,
            aNeedle,
            aHaystack,
            aCompare,
            aBias
          );
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return mid;
        } else {
          return aLow < 0 ? -1 : aLow;
        }
      }
    }
    exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
      if (aHaystack.length === 0) {
        return -1;
      }
      var index = recursiveSearch(
        -1,
        aHaystack.length,
        aNeedle,
        aHaystack,
        aCompare,
        aBias || exports.GREATEST_LOWER_BOUND
      );
      if (index < 0) {
        return -1;
      }
      while (index - 1 >= 0) {
        if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
          break;
        }
        --index;
      }
      return index;
    };
  })(binarySearch);
  return binarySearch;
}
var quickSort = {};
var hasRequiredQuickSort;
function requireQuickSort() {
  if (hasRequiredQuickSort) return quickSort;
  hasRequiredQuickSort = 1;
  function swap(ary, x, y) {
    var temp = ary[x];
    ary[x] = ary[y];
    ary[y] = temp;
  }
  function randomIntInRange(low, high) {
    return Math.round(low + Math.random() * (high - low));
  }
  function doQuickSort(ary, comparator, p, r) {
    if (p < r) {
      var pivotIndex = randomIntInRange(p, r);
      var i = p - 1;
      swap(ary, pivotIndex, r);
      var pivot = ary[r];
      for (var j = p; j < r; j++) {
        if (comparator(ary[j], pivot) <= 0) {
          i += 1;
          swap(ary, i, j);
        }
      }
      swap(ary, i + 1, j);
      var q = i + 1;
      doQuickSort(ary, comparator, p, q - 1);
      doQuickSort(ary, comparator, q + 1, r);
    }
  }
  quickSort.quickSort = function (ary, comparator) {
    doQuickSort(ary, comparator, 0, ary.length - 1);
  };
  return quickSort;
}
var hasRequiredSourceMapConsumer;
function requireSourceMapConsumer() {
  if (hasRequiredSourceMapConsumer) return sourceMapConsumer;
  hasRequiredSourceMapConsumer = 1;
  var util = requireUtil();
  var binarySearch = requireBinarySearch();
  var ArraySet = requireArraySet().ArraySet;
  var base64VLQ = requireBase64Vlq();
  var quickSort = requireQuickSort().quickSort;
  function SourceMapConsumer(aSourceMap) {
    var sourceMap = aSourceMap;
    if (typeof aSourceMap === 'string') {
      sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
    }
    return sourceMap.sections != null
      ? new IndexedSourceMapConsumer(sourceMap)
      : new BasicSourceMapConsumer(sourceMap);
  }
  SourceMapConsumer.fromSourceMap = function (aSourceMap) {
    return BasicSourceMapConsumer.fromSourceMap(aSourceMap);
  };
  SourceMapConsumer.prototype._version = 3;
  SourceMapConsumer.prototype.__generatedMappings = null;
  Object.defineProperty(SourceMapConsumer.prototype, '_generatedMappings', {
    get: function () {
      if (!this.__generatedMappings) {
        this._parseMappings(this._mappings, this.sourceRoot);
      }
      return this.__generatedMappings;
    },
  });
  SourceMapConsumer.prototype.__originalMappings = null;
  Object.defineProperty(SourceMapConsumer.prototype, '_originalMappings', {
    get: function () {
      if (!this.__originalMappings) {
        this._parseMappings(this._mappings, this.sourceRoot);
      }
      return this.__originalMappings;
    },
  });
  SourceMapConsumer.prototype._charIsMappingSeparator =
    function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
      var c = aStr.charAt(index);
      return c === ';' || c === ',';
    };
  SourceMapConsumer.prototype._parseMappings =
    function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      throw new Error('Subclasses must implement _parseMappings');
    };
  SourceMapConsumer.GENERATED_ORDER = 1;
  SourceMapConsumer.ORIGINAL_ORDER = 2;
  SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
  SourceMapConsumer.LEAST_UPPER_BOUND = 2;
  SourceMapConsumer.prototype.eachMapping =
    function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
      var context = aContext || null;
      var order = aOrder || SourceMapConsumer.GENERATED_ORDER;
      var mappings;
      switch (order) {
        case SourceMapConsumer.GENERATED_ORDER:
          mappings = this._generatedMappings;
          break;
        case SourceMapConsumer.ORIGINAL_ORDER:
          mappings = this._originalMappings;
          break;
        default:
          throw new Error('Unknown order of iteration.');
      }
      var sourceRoot = this.sourceRoot;
      mappings
        .map(function (mapping) {
          var source =
            mapping.source === null ? null : this._sources.at(mapping.source);
          if (source != null && sourceRoot != null) {
            source = util.join(sourceRoot, source);
          }
          return {
            source: source,
            generatedLine: mapping.generatedLine,
            generatedColumn: mapping.generatedColumn,
            originalLine: mapping.originalLine,
            originalColumn: mapping.originalColumn,
            name: mapping.name === null ? null : this._names.at(mapping.name),
          };
        }, this)
        .forEach(aCallback, context);
    };
  SourceMapConsumer.prototype.allGeneratedPositionsFor =
    function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
      var line = util.getArg(aArgs, 'line');
      var needle = {
        source: util.getArg(aArgs, 'source'),
        originalLine: line,
        originalColumn: util.getArg(aArgs, 'column', 0),
      };
      if (this.sourceRoot != null) {
        needle.source = util.relative(this.sourceRoot, needle.source);
      }
      if (!this._sources.has(needle.source)) {
        return [];
      }
      needle.source = this._sources.indexOf(needle.source);
      var mappings = [];
      var index = this._findMapping(
        needle,
        this._originalMappings,
        'originalLine',
        'originalColumn',
        util.compareByOriginalPositions,
        binarySearch.LEAST_UPPER_BOUND
      );
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (aArgs.column === undefined) {
          var originalLine = mapping.originalLine;
          while (mapping && mapping.originalLine === originalLine) {
            mappings.push({
              line: util.getArg(mapping, 'generatedLine', null),
              column: util.getArg(mapping, 'generatedColumn', null),
              lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null),
            });
            mapping = this._originalMappings[++index];
          }
        } else {
          var originalColumn = mapping.originalColumn;
          while (
            mapping &&
            mapping.originalLine === line &&
            mapping.originalColumn == originalColumn
          ) {
            mappings.push({
              line: util.getArg(mapping, 'generatedLine', null),
              column: util.getArg(mapping, 'generatedColumn', null),
              lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null),
            });
            mapping = this._originalMappings[++index];
          }
        }
      }
      return mappings;
    };
  sourceMapConsumer.SourceMapConsumer = SourceMapConsumer;
  function BasicSourceMapConsumer(aSourceMap) {
    var sourceMap = aSourceMap;
    if (typeof aSourceMap === 'string') {
      sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
    }
    var version = util.getArg(sourceMap, 'version');
    var sources = util.getArg(sourceMap, 'sources');
    var names = util.getArg(sourceMap, 'names', []);
    var sourceRoot = util.getArg(sourceMap, 'sourceRoot', null);
    var sourcesContent = util.getArg(sourceMap, 'sourcesContent', null);
    var mappings = util.getArg(sourceMap, 'mappings');
    var file = util.getArg(sourceMap, 'file', null);
    if (version != this._version) {
      throw new Error('Unsupported version: ' + version);
    }
    sources = sources
      .map(String)
      .map(util.normalize)
      .map(function (source) {
        return sourceRoot &&
          util.isAbsolute(sourceRoot) &&
          util.isAbsolute(source)
          ? util.relative(sourceRoot, source)
          : source;
      });
    this._names = ArraySet.fromArray(names.map(String), true);
    this._sources = ArraySet.fromArray(sources, true);
    this.sourceRoot = sourceRoot;
    this.sourcesContent = sourcesContent;
    this._mappings = mappings;
    this.file = file;
  }
  BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
  BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
  BasicSourceMapConsumer.fromSourceMap =
    function SourceMapConsumer_fromSourceMap(aSourceMap) {
      var smc = Object.create(BasicSourceMapConsumer.prototype);
      var names = (smc._names = ArraySet.fromArray(
        aSourceMap._names.toArray(),
        true
      ));
      var sources = (smc._sources = ArraySet.fromArray(
        aSourceMap._sources.toArray(),
        true
      ));
      smc.sourceRoot = aSourceMap._sourceRoot;
      smc.sourcesContent = aSourceMap._generateSourcesContent(
        smc._sources.toArray(),
        smc.sourceRoot
      );
      smc.file = aSourceMap._file;
      var generatedMappings = aSourceMap._mappings.toArray().slice();
      var destGeneratedMappings = (smc.__generatedMappings = []);
      var destOriginalMappings = (smc.__originalMappings = []);
      for (var i = 0, length = generatedMappings.length; i < length; i++) {
        var srcMapping = generatedMappings[i];
        var destMapping = new Mapping();
        destMapping.generatedLine = srcMapping.generatedLine;
        destMapping.generatedColumn = srcMapping.generatedColumn;
        if (srcMapping.source) {
          destMapping.source = sources.indexOf(srcMapping.source);
          destMapping.originalLine = srcMapping.originalLine;
          destMapping.originalColumn = srcMapping.originalColumn;
          if (srcMapping.name) {
            destMapping.name = names.indexOf(srcMapping.name);
          }
          destOriginalMappings.push(destMapping);
        }
        destGeneratedMappings.push(destMapping);
      }
      quickSort(smc.__originalMappings, util.compareByOriginalPositions);
      return smc;
    };
  BasicSourceMapConsumer.prototype._version = 3;
  Object.defineProperty(BasicSourceMapConsumer.prototype, 'sources', {
    get: function () {
      return this._sources.toArray().map(function (s) {
        return this.sourceRoot != null ? util.join(this.sourceRoot, s) : s;
      }, this);
    },
  });
  function Mapping() {
    this.generatedLine = 0;
    this.generatedColumn = 0;
    this.source = null;
    this.originalLine = null;
    this.originalColumn = null;
    this.name = null;
  }
  BasicSourceMapConsumer.prototype._parseMappings =
    function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      var generatedLine = 1;
      var previousGeneratedColumn = 0;
      var previousOriginalLine = 0;
      var previousOriginalColumn = 0;
      var previousSource = 0;
      var previousName = 0;
      var length = aStr.length;
      var index = 0;
      var cachedSegments = {};
      var temp = {};
      var originalMappings = [];
      var generatedMappings = [];
      var mapping, str, segment, end, value;
      while (index < length) {
        if (aStr.charAt(index) === ';') {
          generatedLine++;
          index++;
          previousGeneratedColumn = 0;
        } else if (aStr.charAt(index) === ',') {
          index++;
        } else {
          mapping = new Mapping();
          mapping.generatedLine = generatedLine;
          for (end = index; end < length; end++) {
            if (this._charIsMappingSeparator(aStr, end)) {
              break;
            }
          }
          str = aStr.slice(index, end);
          segment = cachedSegments[str];
          if (segment) {
            index += str.length;
          } else {
            segment = [];
            while (index < end) {
              base64VLQ.decode(aStr, index, temp);
              value = temp.value;
              index = temp.rest;
              segment.push(value);
            }
            if (segment.length === 2) {
              throw new Error('Found a source, but no line and column');
            }
            if (segment.length === 3) {
              throw new Error('Found a source and line, but no column');
            }
            cachedSegments[str] = segment;
          }
          mapping.generatedColumn = previousGeneratedColumn + segment[0];
          previousGeneratedColumn = mapping.generatedColumn;
          if (segment.length > 1) {
            mapping.source = previousSource + segment[1];
            previousSource += segment[1];
            mapping.originalLine = previousOriginalLine + segment[2];
            previousOriginalLine = mapping.originalLine;
            mapping.originalLine += 1;
            mapping.originalColumn = previousOriginalColumn + segment[3];
            previousOriginalColumn = mapping.originalColumn;
            if (segment.length > 4) {
              mapping.name = previousName + segment[4];
              previousName += segment[4];
            }
          }
          generatedMappings.push(mapping);
          if (typeof mapping.originalLine === 'number') {
            originalMappings.push(mapping);
          }
        }
      }
      quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
      this.__generatedMappings = generatedMappings;
      quickSort(originalMappings, util.compareByOriginalPositions);
      this.__originalMappings = originalMappings;
    };
  BasicSourceMapConsumer.prototype._findMapping =
    function SourceMapConsumer_findMapping(
      aNeedle,
      aMappings,
      aLineName,
      aColumnName,
      aComparator,
      aBias
    ) {
      if (aNeedle[aLineName] <= 0) {
        throw new TypeError(
          'Line must be greater than or equal to 1, got ' + aNeedle[aLineName]
        );
      }
      if (aNeedle[aColumnName] < 0) {
        throw new TypeError(
          'Column must be greater than or equal to 0, got ' +
            aNeedle[aColumnName]
        );
      }
      return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
    };
  BasicSourceMapConsumer.prototype.computeColumnSpans =
    function SourceMapConsumer_computeColumnSpans() {
      for (var index = 0; index < this._generatedMappings.length; ++index) {
        var mapping = this._generatedMappings[index];
        if (index + 1 < this._generatedMappings.length) {
          var nextMapping = this._generatedMappings[index + 1];
          if (mapping.generatedLine === nextMapping.generatedLine) {
            mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
            continue;
          }
        }
        mapping.lastGeneratedColumn = Infinity;
      }
    };
  BasicSourceMapConsumer.prototype.originalPositionFor =
    function SourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, 'line'),
        generatedColumn: util.getArg(aArgs, 'column'),
      };
      var index = this._findMapping(
        needle,
        this._generatedMappings,
        'generatedLine',
        'generatedColumn',
        util.compareByGeneratedPositionsDeflated,
        util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
      );
      if (index >= 0) {
        var mapping = this._generatedMappings[index];
        if (mapping.generatedLine === needle.generatedLine) {
          var source = util.getArg(mapping, 'source', null);
          if (source !== null) {
            source = this._sources.at(source);
            if (this.sourceRoot != null) {
              source = util.join(this.sourceRoot, source);
            }
          }
          var name = util.getArg(mapping, 'name', null);
          if (name !== null) {
            name = this._names.at(name);
          }
          return {
            source: source,
            line: util.getArg(mapping, 'originalLine', null),
            column: util.getArg(mapping, 'originalColumn', null),
            name: name,
          };
        }
      }
      return {source: null, line: null, column: null, name: null};
    };
  BasicSourceMapConsumer.prototype.hasContentsOfAllSources =
    function BasicSourceMapConsumer_hasContentsOfAllSources() {
      if (!this.sourcesContent) {
        return false;
      }
      return (
        this.sourcesContent.length >= this._sources.size() &&
        !this.sourcesContent.some(function (sc) {
          return sc == null;
        })
      );
    };
  BasicSourceMapConsumer.prototype.sourceContentFor =
    function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      if (!this.sourcesContent) {
        return null;
      }
      if (this.sourceRoot != null) {
        aSource = util.relative(this.sourceRoot, aSource);
      }
      if (this._sources.has(aSource)) {
        return this.sourcesContent[this._sources.indexOf(aSource)];
      }
      var url;
      if (this.sourceRoot != null && (url = util.urlParse(this.sourceRoot))) {
        var fileUriAbsPath = aSource.replace(/^file:\/\//, '');
        if (url.scheme == 'file' && this._sources.has(fileUriAbsPath)) {
          return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
        }
        if (
          (!url.path || url.path == '/') &&
          this._sources.has('/' + aSource)
        ) {
          return this.sourcesContent[this._sources.indexOf('/' + aSource)];
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
  BasicSourceMapConsumer.prototype.generatedPositionFor =
    function SourceMapConsumer_generatedPositionFor(aArgs) {
      var source = util.getArg(aArgs, 'source');
      if (this.sourceRoot != null) {
        source = util.relative(this.sourceRoot, source);
      }
      if (!this._sources.has(source)) {
        return {line: null, column: null, lastColumn: null};
      }
      source = this._sources.indexOf(source);
      var needle = {
        source: source,
        originalLine: util.getArg(aArgs, 'line'),
        originalColumn: util.getArg(aArgs, 'column'),
      };
      var index = this._findMapping(
        needle,
        this._originalMappings,
        'originalLine',
        'originalColumn',
        util.compareByOriginalPositions,
        util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
      );
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (mapping.source === needle.source) {
          return {
            line: util.getArg(mapping, 'generatedLine', null),
            column: util.getArg(mapping, 'generatedColumn', null),
            lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null),
          };
        }
      }
      return {line: null, column: null, lastColumn: null};
    };
  sourceMapConsumer.BasicSourceMapConsumer = BasicSourceMapConsumer;
  function IndexedSourceMapConsumer(aSourceMap) {
    var sourceMap = aSourceMap;
    if (typeof aSourceMap === 'string') {
      sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
    }
    var version = util.getArg(sourceMap, 'version');
    var sections = util.getArg(sourceMap, 'sections');
    if (version != this._version) {
      throw new Error('Unsupported version: ' + version);
    }
    this._sources = new ArraySet();
    this._names = new ArraySet();
    var lastOffset = {line: -1, column: 0};
    this._sections = sections.map(function (s) {
      if (s.url) {
        throw new Error('Support for url field in sections not implemented.');
      }
      var offset = util.getArg(s, 'offset');
      var offsetLine = util.getArg(offset, 'line');
      var offsetColumn = util.getArg(offset, 'column');
      if (
        offsetLine < lastOffset.line ||
        (offsetLine === lastOffset.line && offsetColumn < lastOffset.column)
      ) {
        throw new Error('Section offsets must be ordered and non-overlapping.');
      }
      lastOffset = offset;
      return {
        generatedOffset: {
          generatedLine: offsetLine + 1,
          generatedColumn: offsetColumn + 1,
        },
        consumer: new SourceMapConsumer(util.getArg(s, 'map')),
      };
    });
  }
  IndexedSourceMapConsumer.prototype = Object.create(
    SourceMapConsumer.prototype
  );
  IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;
  IndexedSourceMapConsumer.prototype._version = 3;
  Object.defineProperty(IndexedSourceMapConsumer.prototype, 'sources', {
    get: function () {
      var sources = [];
      for (var i = 0; i < this._sections.length; i++) {
        for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
          sources.push(this._sections[i].consumer.sources[j]);
        }
      }
      return sources;
    },
  });
  IndexedSourceMapConsumer.prototype.originalPositionFor =
    function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, 'line'),
        generatedColumn: util.getArg(aArgs, 'column'),
      };
      var sectionIndex = binarySearch.search(
        needle,
        this._sections,
        function (needle, section) {
          var cmp =
            needle.generatedLine - section.generatedOffset.generatedLine;
          if (cmp) {
            return cmp;
          }
          return (
            needle.generatedColumn - section.generatedOffset.generatedColumn
          );
        }
      );
      var section = this._sections[sectionIndex];
      if (!section) {
        return {source: null, line: null, column: null, name: null};
      }
      return section.consumer.originalPositionFor({
        line:
          needle.generatedLine - (section.generatedOffset.generatedLine - 1),
        column:
          needle.generatedColumn -
          (section.generatedOffset.generatedLine === needle.generatedLine
            ? section.generatedOffset.generatedColumn - 1
            : 0),
        bias: aArgs.bias,
      });
    };
  IndexedSourceMapConsumer.prototype.hasContentsOfAllSources =
    function IndexedSourceMapConsumer_hasContentsOfAllSources() {
      return this._sections.every(function (s) {
        return s.consumer.hasContentsOfAllSources();
      });
    };
  IndexedSourceMapConsumer.prototype.sourceContentFor =
    function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var content = section.consumer.sourceContentFor(aSource, true);
        if (content) {
          return content;
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
  IndexedSourceMapConsumer.prototype.generatedPositionFor =
    function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        if (
          section.consumer.sources.indexOf(util.getArg(aArgs, 'source')) === -1
        ) {
          continue;
        }
        var generatedPosition = section.consumer.generatedPositionFor(aArgs);
        if (generatedPosition) {
          var ret = {
            line:
              generatedPosition.line +
              (section.generatedOffset.generatedLine - 1),
            column:
              generatedPosition.column +
              (section.generatedOffset.generatedLine === generatedPosition.line
                ? section.generatedOffset.generatedColumn - 1
                : 0),
          };
          return ret;
        }
      }
      return {line: null, column: null};
    };
  IndexedSourceMapConsumer.prototype._parseMappings =
    function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      this.__generatedMappings = [];
      this.__originalMappings = [];
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var sectionMappings = section.consumer._generatedMappings;
        for (var j = 0; j < sectionMappings.length; j++) {
          var mapping = sectionMappings[j];
          var source = section.consumer._sources.at(mapping.source);
          if (section.consumer.sourceRoot !== null) {
            source = util.join(section.consumer.sourceRoot, source);
          }
          this._sources.add(source);
          source = this._sources.indexOf(source);
          var name = section.consumer._names.at(mapping.name);
          this._names.add(name);
          name = this._names.indexOf(name);
          var adjustedMapping = {
            source: source,
            generatedLine:
              mapping.generatedLine +
              (section.generatedOffset.generatedLine - 1),
            generatedColumn:
              mapping.generatedColumn +
              (section.generatedOffset.generatedLine === mapping.generatedLine
                ? section.generatedOffset.generatedColumn - 1
                : 0),
            originalLine: mapping.originalLine,
            originalColumn: mapping.originalColumn,
            name: name,
          };
          this.__generatedMappings.push(adjustedMapping);
          if (typeof adjustedMapping.originalLine === 'number') {
            this.__originalMappings.push(adjustedMapping);
          }
        }
      }
      quickSort(
        this.__generatedMappings,
        util.compareByGeneratedPositionsDeflated
      );
      quickSort(this.__originalMappings, util.compareByOriginalPositions);
    };
  sourceMapConsumer.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
  return sourceMapConsumer;
}
var sourceNode = {};
var hasRequiredSourceNode;
function requireSourceNode() {
  if (hasRequiredSourceNode) return sourceNode;
  hasRequiredSourceNode = 1;
  var SourceMapGenerator = requireSourceMapGenerator().SourceMapGenerator;
  var util = requireUtil();
  var REGEX_NEWLINE = /(\r?\n)/;
  var NEWLINE_CODE = 10;
  var isSourceNode = '$$$isSourceNode$$$';
  function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
    this.children = [];
    this.sourceContents = {};
    this.line = aLine == null ? null : aLine;
    this.column = aColumn == null ? null : aColumn;
    this.source = aSource == null ? null : aSource;
    this.name = aName == null ? null : aName;
    this[isSourceNode] = true;
    if (aChunks != null) this.add(aChunks);
  }
  SourceNode.fromStringWithSourceMap =
    function SourceNode_fromStringWithSourceMap(
      aGeneratedCode,
      aSourceMapConsumer,
      aRelativePath
    ) {
      var node = new SourceNode();
      var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
      var remainingLinesIndex = 0;
      var shiftNextLine = function () {
        var lineContents = getNextLine();
        var newLine = getNextLine() || '';
        return lineContents + newLine;
        function getNextLine() {
          return remainingLinesIndex < remainingLines.length
            ? remainingLines[remainingLinesIndex++]
            : undefined;
        }
      };
      var lastGeneratedLine = 1,
        lastGeneratedColumn = 0;
      var lastMapping = null;
      aSourceMapConsumer.eachMapping(function (mapping) {
        if (lastMapping !== null) {
          if (lastGeneratedLine < mapping.generatedLine) {
            addMappingWithCode(lastMapping, shiftNextLine());
            lastGeneratedLine++;
            lastGeneratedColumn = 0;
          } else {
            var nextLine = remainingLines[remainingLinesIndex];
            var code = nextLine.substr(
              0,
              mapping.generatedColumn - lastGeneratedColumn
            );
            remainingLines[remainingLinesIndex] = nextLine.substr(
              mapping.generatedColumn - lastGeneratedColumn
            );
            lastGeneratedColumn = mapping.generatedColumn;
            addMappingWithCode(lastMapping, code);
            lastMapping = mapping;
            return;
          }
        }
        while (lastGeneratedLine < mapping.generatedLine) {
          node.add(shiftNextLine());
          lastGeneratedLine++;
        }
        if (lastGeneratedColumn < mapping.generatedColumn) {
          var nextLine = remainingLines[remainingLinesIndex];
          node.add(nextLine.substr(0, mapping.generatedColumn));
          remainingLines[remainingLinesIndex] = nextLine.substr(
            mapping.generatedColumn
          );
          lastGeneratedColumn = mapping.generatedColumn;
        }
        lastMapping = mapping;
      }, this);
      if (remainingLinesIndex < remainingLines.length) {
        if (lastMapping) {
          addMappingWithCode(lastMapping, shiftNextLine());
        }
        node.add(remainingLines.splice(remainingLinesIndex).join(''));
      }
      aSourceMapConsumer.sources.forEach(function (sourceFile) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          if (aRelativePath != null) {
            sourceFile = util.join(aRelativePath, sourceFile);
          }
          node.setSourceContent(sourceFile, content);
        }
      });
      return node;
      function addMappingWithCode(mapping, code) {
        if (mapping === null || mapping.source === undefined) {
          node.add(code);
        } else {
          var source = aRelativePath
            ? util.join(aRelativePath, mapping.source)
            : mapping.source;
          node.add(
            new SourceNode(
              mapping.originalLine,
              mapping.originalColumn,
              source,
              code,
              mapping.name
            )
          );
        }
      }
    };
  SourceNode.prototype.add = function SourceNode_add(aChunk) {
    if (Array.isArray(aChunk)) {
      aChunk.forEach(function (chunk) {
        this.add(chunk);
      }, this);
    } else if (aChunk[isSourceNode] || typeof aChunk === 'string') {
      if (aChunk) {
        this.children.push(aChunk);
      }
    } else {
      throw new TypeError(
        'Expected a SourceNode, string, or an array of SourceNodes and strings. Got ' +
          aChunk
      );
    }
    return this;
  };
  SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
    if (Array.isArray(aChunk)) {
      for (var i = aChunk.length - 1; i >= 0; i--) {
        this.prepend(aChunk[i]);
      }
    } else if (aChunk[isSourceNode] || typeof aChunk === 'string') {
      this.children.unshift(aChunk);
    } else {
      throw new TypeError(
        'Expected a SourceNode, string, or an array of SourceNodes and strings. Got ' +
          aChunk
      );
    }
    return this;
  };
  SourceNode.prototype.walk = function SourceNode_walk(aFn) {
    var chunk;
    for (var i = 0, len = this.children.length; i < len; i++) {
      chunk = this.children[i];
      if (chunk[isSourceNode]) {
        chunk.walk(aFn);
      } else {
        if (chunk !== '') {
          aFn(chunk, {
            source: this.source,
            line: this.line,
            column: this.column,
            name: this.name,
          });
        }
      }
    }
  };
  SourceNode.prototype.join = function SourceNode_join(aSep) {
    var newChildren;
    var i;
    var len = this.children.length;
    if (len > 0) {
      newChildren = [];
      for (i = 0; i < len - 1; i++) {
        newChildren.push(this.children[i]);
        newChildren.push(aSep);
      }
      newChildren.push(this.children[i]);
      this.children = newChildren;
    }
    return this;
  };
  SourceNode.prototype.replaceRight = function SourceNode_replaceRight(
    aPattern,
    aReplacement
  ) {
    var lastChild = this.children[this.children.length - 1];
    if (lastChild[isSourceNode]) {
      lastChild.replaceRight(aPattern, aReplacement);
    } else if (typeof lastChild === 'string') {
      this.children[this.children.length - 1] = lastChild.replace(
        aPattern,
        aReplacement
      );
    } else {
      this.children.push(''.replace(aPattern, aReplacement));
    }
    return this;
  };
  SourceNode.prototype.setSourceContent = function SourceNode_setSourceContent(
    aSourceFile,
    aSourceContent
  ) {
    this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
  };
  SourceNode.prototype.walkSourceContents =
    function SourceNode_walkSourceContents(aFn) {
      for (var i = 0, len = this.children.length; i < len; i++) {
        if (this.children[i][isSourceNode]) {
          this.children[i].walkSourceContents(aFn);
        }
      }
      var sources = Object.keys(this.sourceContents);
      for (var i = 0, len = sources.length; i < len; i++) {
        aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
      }
    };
  SourceNode.prototype.toString = function SourceNode_toString() {
    var str = '';
    this.walk(function (chunk) {
      str += chunk;
    });
    return str;
  };
  SourceNode.prototype.toStringWithSourceMap =
    function SourceNode_toStringWithSourceMap(aArgs) {
      var generated = {code: '', line: 1, column: 0};
      var map = new SourceMapGenerator(aArgs);
      var sourceMappingActive = false;
      var lastOriginalSource = null;
      var lastOriginalLine = null;
      var lastOriginalColumn = null;
      var lastOriginalName = null;
      this.walk(function (chunk, original) {
        generated.code += chunk;
        if (
          original.source !== null &&
          original.line !== null &&
          original.column !== null
        ) {
          if (
            lastOriginalSource !== original.source ||
            lastOriginalLine !== original.line ||
            lastOriginalColumn !== original.column ||
            lastOriginalName !== original.name
          ) {
            map.addMapping({
              source: original.source,
              original: {line: original.line, column: original.column},
              generated: {line: generated.line, column: generated.column},
              name: original.name,
            });
          }
          lastOriginalSource = original.source;
          lastOriginalLine = original.line;
          lastOriginalColumn = original.column;
          lastOriginalName = original.name;
          sourceMappingActive = true;
        } else if (sourceMappingActive) {
          map.addMapping({
            generated: {line: generated.line, column: generated.column},
          });
          lastOriginalSource = null;
          sourceMappingActive = false;
        }
        for (var idx = 0, length = chunk.length; idx < length; idx++) {
          if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
            generated.line++;
            generated.column = 0;
            if (idx + 1 === length) {
              lastOriginalSource = null;
              sourceMappingActive = false;
            } else if (sourceMappingActive) {
              map.addMapping({
                source: original.source,
                original: {line: original.line, column: original.column},
                generated: {line: generated.line, column: generated.column},
                name: original.name,
              });
            }
          } else {
            generated.column++;
          }
        }
      });
      this.walkSourceContents(function (sourceFile, sourceContent) {
        map.setSourceContent(sourceFile, sourceContent);
      });
      return {code: generated.code, map: map};
    };
  sourceNode.SourceNode = SourceNode;
  return sourceNode;
}
var hasRequiredSourceMap;
function requireSourceMap() {
  if (hasRequiredSourceMap) return sourceMap;
  hasRequiredSourceMap = 1;
  sourceMap.SourceMapGenerator = requireSourceMapGenerator().SourceMapGenerator;
  sourceMap.SourceMapConsumer = requireSourceMapConsumer().SourceMapConsumer;
  sourceMap.SourceNode = requireSourceNode().SourceNode;
  return sourceMap;
}
Object.defineProperty(sourceMap$1, '__esModule', {value: true});
sourceMap$1.default = void 0;
function _sourceMap$2() {
  const data = _interopRequireDefault$h(requireSourceMap());
  _sourceMap$2 = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$h(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
class SourceMap {
  constructor(opts, code) {
    this._cachedMap = null;
    this._code = code;
    this._opts = opts;
    this._rawMappings = [];
  }
  get() {
    if (!this._cachedMap) {
      const map = (this._cachedMap =
        new (_sourceMap$2().default.SourceMapGenerator)({
          sourceRoot: this._opts.sourceRoot,
        }));
      const code = this._code;
      if (typeof code === 'string') {
        map.setSourceContent(this._opts.sourceFileName, code);
      } else if (typeof code === 'object') {
        Object.keys(code).forEach(sourceFileName => {
          map.setSourceContent(sourceFileName, code[sourceFileName]);
        });
      }
      this._rawMappings.forEach(map.addMapping, map);
    }
    return this._cachedMap.toJSON();
  }
  getRawMappings() {
    return this._rawMappings.slice();
  }
  mark(
    generatedLine,
    generatedColumn,
    line,
    column,
    identifierName,
    filename,
    force
  ) {
    if (this._lastGenLine !== generatedLine && line === null) return;
    if (
      !force &&
      this._lastGenLine === generatedLine &&
      this._lastSourceLine === line &&
      this._lastSourceColumn === column
    ) {
      return;
    }
    this._cachedMap = null;
    this._lastGenLine = generatedLine;
    this._lastSourceLine = line;
    this._lastSourceColumn = column;
    this._rawMappings.push({
      name: identifierName || undefined,
      generated: {line: generatedLine, column: generatedColumn},
      source: line == null ? undefined : filename || this._opts.sourceFileName,
      original: line == null ? undefined : {line: line, column: column},
    });
  }
}
sourceMap$1.default = SourceMap;
var printer$1 = {};
var isInteger_1;
var hasRequiredIsInteger;
function requireIsInteger() {
  if (hasRequiredIsInteger) return isInteger_1;
  hasRequiredIsInteger = 1;
  var toInteger = requireToInteger();
  function isInteger(value) {
    return typeof value == 'number' && value == toInteger(value);
  }
  isInteger_1 = isInteger;
  return isInteger_1;
}
var buffer$3 = {};
var trimRight;
var hasRequiredTrimRight;
function requireTrimRight() {
  if (hasRequiredTrimRight) return trimRight;
  hasRequiredTrimRight = 1;
  trimRight = function (str) {
    var tail = str.length;
    while (/[\s\uFEFF\u00A0]/.test(str[tail - 1])) {
      tail--;
    }
    return str.slice(0, tail);
  };
  return trimRight;
}
Object.defineProperty(buffer$3, '__esModule', {value: true});
buffer$3.default = void 0;
function _trimRight() {
  const data = _interopRequireDefault$g(requireTrimRight());
  _trimRight = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$g(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const SPACES_RE = /^[ \t]+$/;
let Buffer$1 = class Buffer {
  constructor(map) {
    this._map = null;
    this._buf = [];
    this._last = '';
    this._queue = [];
    this._position = {line: 1, column: 0};
    this._sourcePosition = {
      identifierName: null,
      line: null,
      column: null,
      filename: null,
    };
    this._disallowedPop = null;
    this._map = map;
  }
  get() {
    this._flush();
    const map = this._map;
    const result = {
      code: (0, _trimRight().default)(this._buf.join('')),
      map: null,
      rawMappings: map && map.getRawMappings(),
    };
    if (map) {
      Object.defineProperty(result, 'map', {
        configurable: true,
        enumerable: true,
        get() {
          return (this.map = map.get());
        },
        set(value) {
          Object.defineProperty(this, 'map', {value: value, writable: true});
        },
      });
    }
    return result;
  }
  append(str) {
    this._flush();
    const {
      line: line,
      column: column,
      filename: filename,
      identifierName: identifierName,
      force: force,
    } = this._sourcePosition;
    this._append(str, line, column, identifierName, filename, force);
  }
  queue(str) {
    if (str === '\n') {
      while (this._queue.length > 0 && SPACES_RE.test(this._queue[0][0])) {
        this._queue.shift();
      }
    }
    const {
      line: line,
      column: column,
      filename: filename,
      identifierName: identifierName,
      force: force,
    } = this._sourcePosition;
    this._queue.unshift([str, line, column, identifierName, filename, force]);
  }
  _flush() {
    let item;
    while ((item = this._queue.pop())) this._append(...item);
  }
  _append(str, line, column, identifierName, filename, force) {
    if (this._map && str[0] !== '\n') {
      this._map.mark(
        this._position.line,
        this._position.column,
        line,
        column,
        identifierName,
        filename,
        force
      );
    }
    this._buf.push(str);
    this._last = str[str.length - 1];
    for (let i = 0; i < str.length; i++) {
      if (str[i] === '\n') {
        this._position.line++;
        this._position.column = 0;
      } else {
        this._position.column++;
      }
    }
  }
  removeTrailingNewline() {
    if (this._queue.length > 0 && this._queue[0][0] === '\n') {
      this._queue.shift();
    }
  }
  removeLastSemicolon() {
    if (this._queue.length > 0 && this._queue[0][0] === ';') {
      this._queue.shift();
    }
  }
  endsWith(suffix) {
    if (suffix.length === 1) {
      let last;
      if (this._queue.length > 0) {
        const str = this._queue[0][0];
        last = str[str.length - 1];
      } else {
        last = this._last;
      }
      return last === suffix;
    }
    const end =
      this._last + this._queue.reduce((acc, item) => item[0] + acc, '');
    if (suffix.length <= end.length) {
      return end.slice(-suffix.length) === suffix;
    }
    return false;
  }
  hasContent() {
    return this._queue.length > 0 || !!this._last;
  }
  exactSource(loc, cb) {
    this.source('start', loc, true);
    cb();
    this.source('end', loc);
    this._disallowPop('start', loc);
  }
  source(prop, loc, force) {
    if (prop && !loc) return;
    this._normalizePosition(prop, loc, this._sourcePosition, force);
  }
  withSource(prop, loc, cb) {
    if (!this._map) return cb();
    const originalLine = this._sourcePosition.line;
    const originalColumn = this._sourcePosition.column;
    const originalFilename = this._sourcePosition.filename;
    const originalIdentifierName = this._sourcePosition.identifierName;
    this.source(prop, loc);
    cb();
    if (
      (!this._sourcePosition.force ||
        this._sourcePosition.line !== originalLine ||
        this._sourcePosition.column !== originalColumn ||
        this._sourcePosition.filename !== originalFilename) &&
      (!this._disallowedPop ||
        this._disallowedPop.line !== originalLine ||
        this._disallowedPop.column !== originalColumn ||
        this._disallowedPop.filename !== originalFilename)
    ) {
      this._sourcePosition.line = originalLine;
      this._sourcePosition.column = originalColumn;
      this._sourcePosition.filename = originalFilename;
      this._sourcePosition.identifierName = originalIdentifierName;
      this._sourcePosition.force = false;
      this._disallowedPop = null;
    }
  }
  _disallowPop(prop, loc) {
    if (prop && !loc) return;
    this._disallowedPop = this._normalizePosition(prop, loc);
  }
  _normalizePosition(prop, loc, targetObj, force) {
    const pos = loc ? loc[prop] : null;
    if (targetObj === undefined) {
      targetObj = {
        identifierName: null,
        line: null,
        column: null,
        filename: null,
        force: false,
      };
    }
    const origLine = targetObj.line;
    const origColumn = targetObj.column;
    const origFilename = targetObj.filename;
    targetObj.identifierName =
      (prop === 'start' && loc && loc.identifierName) || null;
    targetObj.line = pos ? pos.line : null;
    targetObj.column = pos ? pos.column : null;
    targetObj.filename = (loc && loc.filename) || null;
    if (
      force ||
      targetObj.line !== origLine ||
      targetObj.column !== origColumn ||
      targetObj.filename !== origFilename
    ) {
      targetObj.force = force;
    }
    return targetObj;
  }
  getCurrentColumn() {
    const extra = this._queue.reduce((acc, item) => item[0] + acc, '');
    const lastIndex = extra.lastIndexOf('\n');
    return lastIndex === -1
      ? this._position.column + extra.length
      : extra.length - 1 - lastIndex;
  }
  getCurrentLine() {
    const extra = this._queue.reduce((acc, item) => item[0] + acc, '');
    let count = 0;
    for (let i = 0; i < extra.length; i++) {
      if (extra[i] === '\n') count++;
    }
    return this._position.line + count;
  }
};
buffer$3.default = Buffer$1;
var node = {};
var whitespace$1 = {};
Object.defineProperty(whitespace$1, '__esModule', {value: true});
whitespace$1.list = whitespace$1.nodes = void 0;
function t$b() {
  const data = _interopRequireWildcard$c(t$d);
  t$b = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$c(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function crawl(node, state = {}) {
  if (t$b().isMemberExpression(node)) {
    crawl(node.object, state);
    if (node.computed) crawl(node.property, state);
  } else if (t$b().isBinary(node) || t$b().isAssignmentExpression(node)) {
    crawl(node.left, state);
    crawl(node.right, state);
  } else if (t$b().isCallExpression(node)) {
    state.hasCall = true;
    crawl(node.callee, state);
  } else if (t$b().isFunction(node)) {
    state.hasFunction = true;
  } else if (t$b().isIdentifier(node)) {
    state.hasHelper = state.hasHelper || isHelper(node.callee);
  }
  return state;
}
function isHelper(node) {
  if (t$b().isMemberExpression(node)) {
    return isHelper(node.object) || isHelper(node.property);
  } else if (t$b().isIdentifier(node)) {
    return node.name === 'require' || node.name[0] === '_';
  } else if (t$b().isCallExpression(node)) {
    return isHelper(node.callee);
  } else if (t$b().isBinary(node) || t$b().isAssignmentExpression(node)) {
    return (
      (t$b().isIdentifier(node.left) && isHelper(node.left)) ||
      isHelper(node.right)
    );
  } else {
    return false;
  }
}
function isType(node) {
  return (
    t$b().isLiteral(node) ||
    t$b().isObjectExpression(node) ||
    t$b().isArrayExpression(node) ||
    t$b().isIdentifier(node) ||
    t$b().isMemberExpression(node)
  );
}
const nodes = {
  AssignmentExpression(node) {
    const state = crawl(node.right);
    if ((state.hasCall && state.hasHelper) || state.hasFunction) {
      return {before: state.hasFunction, after: true};
    }
  },
  SwitchCase(node, parent) {
    return {
      before: node.consequent.length || parent.cases[0] === node,
      after:
        !node.consequent.length &&
        parent.cases[parent.cases.length - 1] === node,
    };
  },
  LogicalExpression(node) {
    if (t$b().isFunction(node.left) || t$b().isFunction(node.right)) {
      return {after: true};
    }
  },
  Literal(node) {
    if (node.value === 'use strict') {
      return {after: true};
    }
  },
  CallExpression(node) {
    if (t$b().isFunction(node.callee) || isHelper(node)) {
      return {before: true, after: true};
    }
  },
  VariableDeclaration(node) {
    for (let i = 0; i < node.declarations.length; i++) {
      const declar = node.declarations[i];
      let enabled = isHelper(declar.id) && !isType(declar.init);
      if (!enabled) {
        const state = crawl(declar.init);
        enabled = (isHelper(declar.init) && state.hasCall) || state.hasFunction;
      }
      if (enabled) {
        return {before: true, after: true};
      }
    }
  },
  IfStatement(node) {
    if (t$b().isBlockStatement(node.consequent)) {
      return {before: true, after: true};
    }
  },
};
whitespace$1.nodes = nodes;
nodes.ObjectProperty =
  nodes.ObjectTypeProperty =
  nodes.ObjectMethod =
    function (node, parent) {
      if (parent.properties[0] === node) {
        return {before: true};
      }
    };
nodes.ObjectTypeCallProperty = function (node, parent) {
  if (
    parent.callProperties[0] === node &&
    (!parent.properties || !parent.properties.length)
  ) {
    return {before: true};
  }
};
nodes.ObjectTypeIndexer = function (node, parent) {
  if (
    parent.indexers[0] === node &&
    (!parent.properties || !parent.properties.length) &&
    (!parent.callProperties || !parent.callProperties.length)
  ) {
    return {before: true};
  }
};
nodes.ObjectTypeInternalSlot = function (node, parent) {
  if (
    parent.internalSlots[0] === node &&
    (!parent.properties || !parent.properties.length) &&
    (!parent.callProperties || !parent.callProperties.length) &&
    (!parent.indexers || !parent.indexers.length)
  ) {
    return {before: true};
  }
};
const list = {
  VariableDeclaration(node) {
    return node.declarations.map(decl => decl.init);
  },
  ArrayExpression(node) {
    return node.elements;
  },
  ObjectExpression(node) {
    return node.properties;
  },
};
whitespace$1.list = list;
[
  ['Function', true],
  ['Class', true],
  ['Loop', true],
  ['LabeledStatement', true],
  ['SwitchStatement', true],
  ['TryStatement', true],
].forEach(function ([type, amounts]) {
  if (typeof amounts === 'boolean') {
    amounts = {after: amounts, before: amounts};
  }
  [type].concat(t$b().FLIPPED_ALIAS_KEYS[type] || []).forEach(function (type) {
    nodes[type] = function () {
      return amounts;
    };
  });
});
var parentheses = {};
Object.defineProperty(parentheses, '__esModule', {value: true});
parentheses.FunctionTypeAnnotation = parentheses.NullableTypeAnnotation =
  NullableTypeAnnotation;
parentheses.UpdateExpression = UpdateExpression$1;
parentheses.ObjectExpression = ObjectExpression$1;
parentheses.DoExpression = DoExpression$1;
parentheses.Binary = Binary;
parentheses.IntersectionTypeAnnotation = parentheses.UnionTypeAnnotation =
  UnionTypeAnnotation;
parentheses.TSAsExpression = TSAsExpression$1;
parentheses.TSTypeAssertion = TSTypeAssertion$1;
parentheses.BinaryExpression = BinaryExpression;
parentheses.SequenceExpression = SequenceExpression$1;
parentheses.AwaitExpression = parentheses.YieldExpression = YieldExpression$1;
parentheses.ClassExpression = ClassExpression;
parentheses.UnaryLike = UnaryLike;
parentheses.FunctionExpression = FunctionExpression$1;
parentheses.ArrowFunctionExpression = ArrowFunctionExpression$1;
parentheses.ConditionalExpression = ConditionalExpression$1;
parentheses.OptionalMemberExpression = OptionalMemberExpression$1;
parentheses.AssignmentExpression = AssignmentExpression$1;
parentheses.NewExpression = NewExpression$1;
function t$a() {
  const data = _interopRequireWildcard$b(t$d);
  t$a = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$b(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
const PRECEDENCE = {
  '||': 0,
  '&&': 1,
  '|': 2,
  '^': 3,
  '&': 4,
  '==': 5,
  '===': 5,
  '!=': 5,
  '!==': 5,
  '<': 6,
  '>': 6,
  '<=': 6,
  '>=': 6,
  in: 6,
  instanceof: 6,
  '>>': 7,
  '<<': 7,
  '>>>': 7,
  '+': 8,
  '-': 8,
  '*': 9,
  '/': 9,
  '%': 9,
  '**': 10,
};
const isClassExtendsClause = (node, parent) =>
  (t$a().isClassDeclaration(parent) || t$a().isClassExpression(parent)) &&
  parent.superClass === node;
function NullableTypeAnnotation(node, parent) {
  return t$a().isArrayTypeAnnotation(parent);
}
function UpdateExpression$1(node, parent) {
  return (
    t$a().isMemberExpression(parent, {object: node}) ||
    t$a().isCallExpression(parent, {callee: node}) ||
    t$a().isNewExpression(parent, {callee: node}) ||
    isClassExtendsClause(node, parent)
  );
}
function ObjectExpression$1(node, parent, printStack) {
  return isFirstInStatement(printStack, {considerArrow: true});
}
function DoExpression$1(node, parent, printStack) {
  return isFirstInStatement(printStack);
}
function Binary(node, parent) {
  if (
    node.operator === '**' &&
    t$a().isBinaryExpression(parent, {operator: '**'})
  ) {
    return parent.left === node;
  }
  if (isClassExtendsClause(node, parent)) {
    return true;
  }
  if (
    ((t$a().isCallExpression(parent) || t$a().isNewExpression(parent)) &&
      parent.callee === node) ||
    t$a().isUnaryLike(parent) ||
    (t$a().isMemberExpression(parent) && parent.object === node) ||
    t$a().isAwaitExpression(parent)
  ) {
    return true;
  }
  if (t$a().isBinary(parent)) {
    const parentOp = parent.operator;
    const parentPos = PRECEDENCE[parentOp];
    const nodeOp = node.operator;
    const nodePos = PRECEDENCE[nodeOp];
    if (
      (parentPos === nodePos &&
        parent.right === node &&
        !t$a().isLogicalExpression(parent)) ||
      parentPos > nodePos
    ) {
      return true;
    }
  }
  return false;
}
function UnionTypeAnnotation(node, parent) {
  return (
    t$a().isArrayTypeAnnotation(parent) ||
    t$a().isNullableTypeAnnotation(parent) ||
    t$a().isIntersectionTypeAnnotation(parent) ||
    t$a().isUnionTypeAnnotation(parent)
  );
}
function TSAsExpression$1() {
  return true;
}
function TSTypeAssertion$1() {
  return true;
}
function BinaryExpression(node, parent) {
  return (
    node.operator === 'in' &&
    (t$a().isVariableDeclarator(parent) || t$a().isFor(parent))
  );
}
function SequenceExpression$1(node, parent) {
  if (
    t$a().isForStatement(parent) ||
    t$a().isThrowStatement(parent) ||
    t$a().isReturnStatement(parent) ||
    (t$a().isIfStatement(parent) && parent.test === node) ||
    (t$a().isWhileStatement(parent) && parent.test === node) ||
    (t$a().isForInStatement(parent) && parent.right === node) ||
    (t$a().isSwitchStatement(parent) && parent.discriminant === node) ||
    (t$a().isExpressionStatement(parent) && parent.expression === node)
  ) {
    return false;
  }
  return true;
}
function YieldExpression$1(node, parent) {
  return (
    t$a().isBinary(parent) ||
    t$a().isUnaryLike(parent) ||
    t$a().isCallExpression(parent) ||
    t$a().isMemberExpression(parent) ||
    t$a().isNewExpression(parent) ||
    (t$a().isAwaitExpression(parent) && t$a().isYieldExpression(node)) ||
    (t$a().isConditionalExpression(parent) && node === parent.test) ||
    isClassExtendsClause(node, parent)
  );
}
function ClassExpression(node, parent, printStack) {
  return isFirstInStatement(printStack, {considerDefaultExports: true});
}
function UnaryLike(node, parent) {
  return (
    t$a().isMemberExpression(parent, {object: node}) ||
    t$a().isCallExpression(parent, {callee: node}) ||
    t$a().isNewExpression(parent, {callee: node}) ||
    t$a().isBinaryExpression(parent, {operator: '**', left: node}) ||
    isClassExtendsClause(node, parent)
  );
}
function FunctionExpression$1(node, parent, printStack) {
  return isFirstInStatement(printStack, {considerDefaultExports: true});
}
function ArrowFunctionExpression$1(node, parent) {
  return (
    t$a().isExportDeclaration(parent) || ConditionalExpression$1(node, parent)
  );
}
function ConditionalExpression$1(node, parent) {
  if (
    t$a().isUnaryLike(parent) ||
    t$a().isBinary(parent) ||
    t$a().isConditionalExpression(parent, {test: node}) ||
    t$a().isAwaitExpression(parent) ||
    t$a().isOptionalMemberExpression(parent) ||
    t$a().isTaggedTemplateExpression(parent) ||
    t$a().isTSTypeAssertion(parent) ||
    t$a().isTSAsExpression(parent)
  ) {
    return true;
  }
  return UnaryLike(node, parent);
}
function OptionalMemberExpression$1(node, parent) {
  return t$a().isCallExpression(parent) || t$a().isMemberExpression(parent);
}
function AssignmentExpression$1(node) {
  if (t$a().isObjectPattern(node.left)) {
    return true;
  } else {
    return ConditionalExpression$1(...arguments);
  }
}
function NewExpression$1(node, parent) {
  return isClassExtendsClause(node, parent);
}
function isFirstInStatement(
  printStack,
  {
    considerArrow: considerArrow = false,
    considerDefaultExports: considerDefaultExports = false,
  } = {}
) {
  let i = printStack.length - 1;
  let node = printStack[i];
  i--;
  let parent = printStack[i];
  while (i > 0) {
    if (
      t$a().isExpressionStatement(parent, {expression: node}) ||
      t$a().isTaggedTemplateExpression(parent) ||
      (considerDefaultExports &&
        t$a().isExportDefaultDeclaration(parent, {declaration: node})) ||
      (considerArrow && t$a().isArrowFunctionExpression(parent, {body: node}))
    ) {
      return true;
    }
    if (
      t$a().isCallExpression(parent, {callee: node}) ||
      (t$a().isSequenceExpression(parent) && parent.expressions[0] === node) ||
      t$a().isMemberExpression(parent, {object: node}) ||
      t$a().isConditional(parent, {test: node}) ||
      t$a().isBinary(parent, {left: node}) ||
      t$a().isAssignmentExpression(parent, {left: node})
    ) {
      node = parent;
      i--;
      parent = printStack[i];
    } else {
      return false;
    }
  }
  return false;
}
Object.defineProperty(node, '__esModule', {value: true});
node.needsWhitespace = needsWhitespace;
node.needsWhitespaceBefore = needsWhitespaceBefore;
node.needsWhitespaceAfter = needsWhitespaceAfter;
node.needsParens = needsParens;
var whitespace = _interopRequireWildcard$a(whitespace$1);
var parens = _interopRequireWildcard$a(parentheses);
function t$9() {
  const data = _interopRequireWildcard$a(t$d);
  t$9 = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$a(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function expandAliases(obj) {
  const newObj = {};
  function add(type, func) {
    const fn = newObj[type];
    newObj[type] = fn
      ? function (node, parent, stack) {
          const result = fn(node, parent, stack);
          return result == null ? func(node, parent, stack) : result;
        }
      : func;
  }
  for (const type of Object.keys(obj)) {
    const aliases = t$9().FLIPPED_ALIAS_KEYS[type];
    if (aliases) {
      for (const alias of aliases) {
        add(alias, obj[type]);
      }
    } else {
      add(type, obj[type]);
    }
  }
  return newObj;
}
const expandedParens = expandAliases(parens);
const expandedWhitespaceNodes = expandAliases(whitespace.nodes);
const expandedWhitespaceList = expandAliases(whitespace.list);
function find(obj, node, parent, printStack) {
  const fn = obj[node.type];
  return fn ? fn(node, parent, printStack) : null;
}
function isOrHasCallExpression(node) {
  if (t$9().isCallExpression(node)) {
    return true;
  }
  if (t$9().isMemberExpression(node)) {
    return (
      isOrHasCallExpression(node.object) ||
      (!node.computed && isOrHasCallExpression(node.property))
    );
  } else {
    return false;
  }
}
function needsWhitespace(node, parent, type) {
  if (!node) return 0;
  if (t$9().isExpressionStatement(node)) {
    node = node.expression;
  }
  let linesInfo = find(expandedWhitespaceNodes, node, parent);
  if (!linesInfo) {
    const items = find(expandedWhitespaceList, node, parent);
    if (items) {
      for (let i = 0; i < items.length; i++) {
        linesInfo = needsWhitespace(items[i], node, type);
        if (linesInfo) break;
      }
    }
  }
  if (typeof linesInfo === 'object' && linesInfo !== null) {
    return linesInfo[type] || 0;
  }
  return 0;
}
function needsWhitespaceBefore(node, parent) {
  return needsWhitespace(node, parent, 'before');
}
function needsWhitespaceAfter(node, parent) {
  return needsWhitespace(node, parent, 'after');
}
function needsParens(node, parent, printStack) {
  if (!parent) return false;
  if (t$9().isNewExpression(parent) && parent.callee === node) {
    if (isOrHasCallExpression(node)) return true;
  }
  return find(expandedParens, node, parent, printStack);
}
var generators = {};
var templateLiterals = {};
Object.defineProperty(templateLiterals, '__esModule', {value: true});
templateLiterals.TaggedTemplateExpression = TaggedTemplateExpression;
templateLiterals.TemplateElement = TemplateElement;
templateLiterals.TemplateLiteral = TemplateLiteral;
function TaggedTemplateExpression(node) {
  this.print(node.tag, node);
  this.print(node.typeParameters, node);
  this.print(node.quasi, node);
}
function TemplateElement(node, parent) {
  const isFirst = parent.quasis[0] === node;
  const isLast = parent.quasis[parent.quasis.length - 1] === node;
  const value = (isFirst ? '`' : '}') + node.value.raw + (isLast ? '`' : '${');
  this.token(value);
}
function TemplateLiteral(node) {
  const quasis = node.quasis;
  for (let i = 0; i < quasis.length; i++) {
    this.print(quasis[i], node);
    if (i + 1 < quasis.length) {
      this.print(node.expressions[i], node);
    }
  }
}
var expressions = {};
Object.defineProperty(expressions, '__esModule', {value: true});
expressions.UnaryExpression = UnaryExpression;
expressions.DoExpression = DoExpression;
expressions.ParenthesizedExpression = ParenthesizedExpression;
expressions.UpdateExpression = UpdateExpression;
expressions.ConditionalExpression = ConditionalExpression;
expressions.NewExpression = NewExpression;
expressions.SequenceExpression = SequenceExpression;
expressions.ThisExpression = ThisExpression;
expressions.Super = Super;
expressions.Decorator = Decorator;
expressions.OptionalMemberExpression = OptionalMemberExpression;
expressions.OptionalCallExpression = OptionalCallExpression;
expressions.CallExpression = CallExpression;
expressions.Import = Import;
expressions.EmptyStatement = EmptyStatement;
expressions.ExpressionStatement = ExpressionStatement;
expressions.AssignmentPattern = AssignmentPattern;
expressions.LogicalExpression =
  expressions.BinaryExpression =
  expressions.AssignmentExpression =
    AssignmentExpression;
expressions.BindExpression = BindExpression;
expressions.MemberExpression = MemberExpression;
expressions.MetaProperty = MetaProperty;
expressions.PrivateName = PrivateName;
expressions.AwaitExpression = expressions.YieldExpression = void 0;
function t$8() {
  const data = _interopRequireWildcard$9(t$d);
  t$8 = function () {
    return data;
  };
  return data;
}
var n$1 = _interopRequireWildcard$9(node);
function _interopRequireWildcard$9(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function UnaryExpression(node) {
  if (
    node.operator === 'void' ||
    node.operator === 'delete' ||
    node.operator === 'typeof' ||
    node.operator === 'throw'
  ) {
    this.word(node.operator);
    this.space();
  } else {
    this.token(node.operator);
  }
  this.print(node.argument, node);
}
function DoExpression(node) {
  this.word('do');
  this.space();
  this.print(node.body, node);
}
function ParenthesizedExpression(node) {
  this.token('(');
  this.print(node.expression, node);
  this.token(')');
}
function UpdateExpression(node) {
  if (node.prefix) {
    this.token(node.operator);
    this.print(node.argument, node);
  } else {
    this.startTerminatorless(true);
    this.print(node.argument, node);
    this.endTerminatorless();
    this.token(node.operator);
  }
}
function ConditionalExpression(node) {
  this.print(node.test, node);
  this.space();
  this.token('?');
  this.space();
  this.print(node.consequent, node);
  this.space();
  this.token(':');
  this.space();
  this.print(node.alternate, node);
}
function NewExpression(node, parent) {
  this.word('new');
  this.space();
  this.print(node.callee, node);
  if (
    this.format.minified &&
    node.arguments.length === 0 &&
    !node.optional &&
    !t$8().isCallExpression(parent, {callee: node}) &&
    !t$8().isMemberExpression(parent) &&
    !t$8().isNewExpression(parent)
  ) {
    return;
  }
  this.print(node.typeArguments, node);
  this.print(node.typeParameters, node);
  if (node.optional) {
    this.token('?.');
  }
  this.token('(');
  this.printList(node.arguments, node);
  this.token(')');
}
function SequenceExpression(node) {
  this.printList(node.expressions, node);
}
function ThisExpression() {
  this.word('this');
}
function Super() {
  this.word('super');
}
function Decorator(node) {
  this.token('@');
  this.print(node.expression, node);
  this.newline();
}
function OptionalMemberExpression(node) {
  this.print(node.object, node);
  if (!node.computed && t$8().isMemberExpression(node.property)) {
    throw new TypeError('Got a MemberExpression for MemberExpression property');
  }
  let computed = node.computed;
  if (
    t$8().isLiteral(node.property) &&
    typeof node.property.value === 'number'
  ) {
    computed = true;
  }
  if (node.optional) {
    this.token('?.');
  }
  if (computed) {
    this.token('[');
    this.print(node.property, node);
    this.token(']');
  } else {
    if (!node.optional) {
      this.token('.');
    }
    this.print(node.property, node);
  }
}
function OptionalCallExpression(node) {
  this.print(node.callee, node);
  this.print(node.typeArguments, node);
  this.print(node.typeParameters, node);
  if (node.optional) {
    this.token('?.');
  }
  this.token('(');
  this.printList(node.arguments, node);
  this.token(')');
}
function CallExpression(node) {
  this.print(node.callee, node);
  this.print(node.typeArguments, node);
  this.print(node.typeParameters, node);
  this.token('(');
  this.printList(node.arguments, node);
  this.token(')');
}
function Import() {
  this.word('import');
}
function buildYieldAwait(keyword) {
  return function (node) {
    this.word(keyword);
    if (node.delegate) {
      this.token('*');
    }
    if (node.argument) {
      this.space();
      const terminatorState = this.startTerminatorless();
      this.print(node.argument, node);
      this.endTerminatorless(terminatorState);
    }
  };
}
const YieldExpression = buildYieldAwait('yield');
expressions.YieldExpression = YieldExpression;
const AwaitExpression = buildYieldAwait('await');
expressions.AwaitExpression = AwaitExpression;
function EmptyStatement() {
  this.semicolon(true);
}
function ExpressionStatement(node) {
  this.print(node.expression, node);
  this.semicolon();
}
function AssignmentPattern(node) {
  this.print(node.left, node);
  if (node.left.optional) this.token('?');
  this.print(node.left.typeAnnotation, node);
  this.space();
  this.token('=');
  this.space();
  this.print(node.right, node);
}
function AssignmentExpression(node, parent) {
  const parens =
    this.inForStatementInitCounter &&
    node.operator === 'in' &&
    !n$1.needsParens(node, parent);
  if (parens) {
    this.token('(');
  }
  this.print(node.left, node);
  this.space();
  if (node.operator === 'in' || node.operator === 'instanceof') {
    this.word(node.operator);
  } else {
    this.token(node.operator);
  }
  this.space();
  this.print(node.right, node);
  if (parens) {
    this.token(')');
  }
}
function BindExpression(node) {
  this.print(node.object, node);
  this.token('::');
  this.print(node.callee, node);
}
function MemberExpression(node) {
  this.print(node.object, node);
  if (!node.computed && t$8().isMemberExpression(node.property)) {
    throw new TypeError('Got a MemberExpression for MemberExpression property');
  }
  let computed = node.computed;
  if (
    t$8().isLiteral(node.property) &&
    typeof node.property.value === 'number'
  ) {
    computed = true;
  }
  if (computed) {
    this.token('[');
    this.print(node.property, node);
    this.token(']');
  } else {
    this.token('.');
    this.print(node.property, node);
  }
}
function MetaProperty(node) {
  this.print(node.meta, node);
  this.token('.');
  this.print(node.property, node);
}
function PrivateName(node) {
  this.token('#');
  this.print(node.id, node);
}
var statements = {};
Object.defineProperty(statements, '__esModule', {value: true});
statements.WithStatement = WithStatement;
statements.IfStatement = IfStatement;
statements.ForStatement = ForStatement;
statements.WhileStatement = WhileStatement;
statements.DoWhileStatement = DoWhileStatement;
statements.LabeledStatement = LabeledStatement;
statements.TryStatement = TryStatement;
statements.CatchClause = CatchClause;
statements.SwitchStatement = SwitchStatement;
statements.SwitchCase = SwitchCase;
statements.DebuggerStatement = DebuggerStatement;
statements.VariableDeclaration = VariableDeclaration;
statements.VariableDeclarator = VariableDeclarator;
statements.ThrowStatement =
  statements.BreakStatement =
  statements.ReturnStatement =
  statements.ContinueStatement =
  statements.ForOfStatement =
  statements.ForInStatement =
    void 0;
function t$7() {
  const data = _interopRequireWildcard$8(t$d);
  t$7 = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$8(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function WithStatement(node) {
  this.word('with');
  this.space();
  this.token('(');
  this.print(node.object, node);
  this.token(')');
  this.printBlock(node);
}
function IfStatement(node) {
  this.word('if');
  this.space();
  this.token('(');
  this.print(node.test, node);
  this.token(')');
  this.space();
  const needsBlock =
    node.alternate && t$7().isIfStatement(getLastStatement(node.consequent));
  if (needsBlock) {
    this.token('{');
    this.newline();
    this.indent();
  }
  this.printAndIndentOnComments(node.consequent, node);
  if (needsBlock) {
    this.dedent();
    this.newline();
    this.token('}');
  }
  if (node.alternate) {
    if (this.endsWith('}')) this.space();
    this.word('else');
    this.space();
    this.printAndIndentOnComments(node.alternate, node);
  }
}
function getLastStatement(statement) {
  if (!t$7().isStatement(statement.body)) return statement;
  return getLastStatement(statement.body);
}
function ForStatement(node) {
  this.word('for');
  this.space();
  this.token('(');
  this.inForStatementInitCounter++;
  this.print(node.init, node);
  this.inForStatementInitCounter--;
  this.token(';');
  if (node.test) {
    this.space();
    this.print(node.test, node);
  }
  this.token(';');
  if (node.update) {
    this.space();
    this.print(node.update, node);
  }
  this.token(')');
  this.printBlock(node);
}
function WhileStatement(node) {
  this.word('while');
  this.space();
  this.token('(');
  this.print(node.test, node);
  this.token(')');
  this.printBlock(node);
}
const buildForXStatement = function (op) {
  return function (node) {
    this.word('for');
    this.space();
    if (op === 'of' && node.await) {
      this.word('await');
      this.space();
    }
    this.token('(');
    this.print(node.left, node);
    this.space();
    this.word(op);
    this.space();
    this.print(node.right, node);
    this.token(')');
    this.printBlock(node);
  };
};
const ForInStatement = buildForXStatement('in');
statements.ForInStatement = ForInStatement;
const ForOfStatement = buildForXStatement('of');
statements.ForOfStatement = ForOfStatement;
function DoWhileStatement(node) {
  this.word('do');
  this.space();
  this.print(node.body, node);
  this.space();
  this.word('while');
  this.space();
  this.token('(');
  this.print(node.test, node);
  this.token(')');
  this.semicolon();
}
function buildLabelStatement(prefix, key = 'label') {
  return function (node) {
    this.word(prefix);
    const label = node[key];
    if (label) {
      this.space();
      const isLabel = key == 'label';
      const terminatorState = this.startTerminatorless(isLabel);
      this.print(label, node);
      this.endTerminatorless(terminatorState);
    }
    this.semicolon();
  };
}
const ContinueStatement = buildLabelStatement('continue');
statements.ContinueStatement = ContinueStatement;
const ReturnStatement = buildLabelStatement('return', 'argument');
statements.ReturnStatement = ReturnStatement;
const BreakStatement = buildLabelStatement('break');
statements.BreakStatement = BreakStatement;
const ThrowStatement = buildLabelStatement('throw', 'argument');
statements.ThrowStatement = ThrowStatement;
function LabeledStatement(node) {
  this.print(node.label, node);
  this.token(':');
  this.space();
  this.print(node.body, node);
}
function TryStatement(node) {
  this.word('try');
  this.space();
  this.print(node.block, node);
  this.space();
  if (node.handlers) {
    this.print(node.handlers[0], node);
  } else {
    this.print(node.handler, node);
  }
  if (node.finalizer) {
    this.space();
    this.word('finally');
    this.space();
    this.print(node.finalizer, node);
  }
}
function CatchClause(node) {
  this.word('catch');
  this.space();
  if (node.param) {
    this.token('(');
    this.print(node.param, node);
    this.token(')');
    this.space();
  }
  this.print(node.body, node);
}
function SwitchStatement(node) {
  this.word('switch');
  this.space();
  this.token('(');
  this.print(node.discriminant, node);
  this.token(')');
  this.space();
  this.token('{');
  this.printSequence(node.cases, node, {
    indent: true,
    addNewlines(leading, cas) {
      if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
    },
  });
  this.token('}');
}
function SwitchCase(node) {
  if (node.test) {
    this.word('case');
    this.space();
    this.print(node.test, node);
    this.token(':');
  } else {
    this.word('default');
    this.token(':');
  }
  if (node.consequent.length) {
    this.newline();
    this.printSequence(node.consequent, node, {indent: true});
  }
}
function DebuggerStatement() {
  this.word('debugger');
  this.semicolon();
}
function variableDeclarationIndent() {
  this.token(',');
  this.newline();
  if (this.endsWith('\n')) for (let i = 0; i < 4; i++) this.space(true);
}
function constDeclarationIndent() {
  this.token(',');
  this.newline();
  if (this.endsWith('\n')) for (let i = 0; i < 6; i++) this.space(true);
}
function VariableDeclaration(node, parent) {
  if (node.declare) {
    this.word('declare');
    this.space();
  }
  this.word(node.kind);
  this.space();
  let hasInits = false;
  if (!t$7().isFor(parent)) {
    for (const declar of node.declarations) {
      if (declar.init) {
        hasInits = true;
      }
    }
  }
  let separator;
  if (hasInits) {
    separator =
      node.kind === 'const'
        ? constDeclarationIndent
        : variableDeclarationIndent;
  }
  this.printList(node.declarations, node, {separator: separator});
  if (t$7().isFor(parent)) {
    if (parent.left === node || parent.init === node) return;
  }
  this.semicolon();
}
function VariableDeclarator(node) {
  this.print(node.id, node);
  if (node.definite) this.token('!');
  this.print(node.id.typeAnnotation, node);
  if (node.init) {
    this.space();
    this.token('=');
    this.space();
    this.print(node.init, node);
  }
}
var classes = {};
Object.defineProperty(classes, '__esModule', {value: true});
classes.ClassExpression = classes.ClassDeclaration = ClassDeclaration;
classes.ClassBody = ClassBody;
classes.ClassProperty = ClassProperty;
classes.ClassPrivateProperty = ClassPrivateProperty;
classes.ClassMethod = ClassMethod;
classes.ClassPrivateMethod = ClassPrivateMethod;
classes._classMethodHead = _classMethodHead;
function t$6() {
  const data = _interopRequireWildcard$7(t$d);
  t$6 = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$7(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function ClassDeclaration(node, parent) {
  if (
    !this.format.decoratorsBeforeExport ||
    (!t$6().isExportDefaultDeclaration(parent) &&
      !t$6().isExportNamedDeclaration(parent))
  ) {
    this.printJoin(node.decorators, node);
  }
  if (node.declare) {
    this.word('declare');
    this.space();
  }
  if (node.abstract) {
    this.word('abstract');
    this.space();
  }
  this.word('class');
  if (node.id) {
    this.space();
    this.print(node.id, node);
  }
  this.print(node.typeParameters, node);
  if (node.superClass) {
    this.space();
    this.word('extends');
    this.space();
    this.print(node.superClass, node);
    this.print(node.superTypeParameters, node);
  }
  if (node.implements) {
    this.space();
    this.word('implements');
    this.space();
    this.printList(node.implements, node);
  }
  this.space();
  this.print(node.body, node);
}
function ClassBody(node) {
  this.token('{');
  this.printInnerComments(node);
  if (node.body.length === 0) {
    this.token('}');
  } else {
    this.newline();
    this.indent();
    this.printSequence(node.body, node);
    this.dedent();
    if (!this.endsWith('\n')) this.newline();
    this.rightBrace();
  }
}
function ClassProperty(node) {
  this.printJoin(node.decorators, node);
  if (node.accessibility) {
    this.word(node.accessibility);
    this.space();
  }
  if (node.static) {
    this.word('static');
    this.space();
  }
  if (node.abstract) {
    this.word('abstract');
    this.space();
  }
  if (node.readonly) {
    this.word('readonly');
    this.space();
  }
  if (node.computed) {
    this.token('[');
    this.print(node.key, node);
    this.token(']');
  } else {
    this._variance(node);
    this.print(node.key, node);
  }
  if (node.optional) {
    this.token('?');
  }
  if (node.definite) {
    this.token('!');
  }
  this.print(node.typeAnnotation, node);
  if (node.value) {
    this.space();
    this.token('=');
    this.space();
    this.print(node.value, node);
  }
  this.semicolon();
}
function ClassPrivateProperty(node) {
  if (node.static) {
    this.word('static');
    this.space();
  }
  this.print(node.key, node);
  this.print(node.typeAnnotation, node);
  if (node.value) {
    this.space();
    this.token('=');
    this.space();
    this.print(node.value, node);
  }
  this.semicolon();
}
function ClassMethod(node) {
  this._classMethodHead(node);
  this.space();
  this.print(node.body, node);
}
function ClassPrivateMethod(node) {
  this._classMethodHead(node);
  this.space();
  this.print(node.body, node);
}
function _classMethodHead(node) {
  this.printJoin(node.decorators, node);
  if (node.accessibility) {
    this.word(node.accessibility);
    this.space();
  }
  if (node.abstract) {
    this.word('abstract');
    this.space();
  }
  if (node.static) {
    this.word('static');
    this.space();
  }
  this._methodHead(node);
}
var methods = {};
Object.defineProperty(methods, '__esModule', {value: true});
methods._params = _params;
methods._parameters = _parameters;
methods._param = _param;
methods._methodHead = _methodHead;
methods._predicate = _predicate;
methods._functionHead = _functionHead;
methods.FunctionDeclaration = methods.FunctionExpression = FunctionExpression;
methods.ArrowFunctionExpression = ArrowFunctionExpression;
function t$5() {
  const data = _interopRequireWildcard$6(t$d);
  t$5 = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$6(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function _params(node) {
  this.print(node.typeParameters, node);
  this.token('(');
  this._parameters(node.params, node);
  this.token(')');
  this.print(node.returnType, node);
}
function _parameters(parameters, parent) {
  for (let i = 0; i < parameters.length; i++) {
    this._param(parameters[i], parent);
    if (i < parameters.length - 1) {
      this.token(',');
      this.space();
    }
  }
}
function _param(parameter, parent) {
  this.printJoin(parameter.decorators, parameter);
  this.print(parameter, parent);
  if (parameter.optional) this.token('?');
  this.print(parameter.typeAnnotation, parameter);
}
function _methodHead(node) {
  const kind = node.kind;
  const key = node.key;
  if (kind === 'get' || kind === 'set') {
    this.word(kind);
    this.space();
  }
  if (node.async) {
    this.word('async');
    this.space();
  }
  if (kind === 'method' || kind === 'init') {
    if (node.generator) {
      this.token('*');
    }
  }
  if (node.computed) {
    this.token('[');
    this.print(key, node);
    this.token(']');
  } else {
    this.print(key, node);
  }
  if (node.optional) {
    this.token('?');
  }
  this._params(node);
}
function _predicate(node) {
  if (node.predicate) {
    if (!node.returnType) {
      this.token(':');
    }
    this.space();
    this.print(node.predicate, node);
  }
}
function _functionHead(node) {
  if (node.async) {
    this.word('async');
    this.space();
  }
  this.word('function');
  if (node.generator) this.token('*');
  this.space();
  if (node.id) {
    this.print(node.id, node);
  }
  this._params(node);
  this._predicate(node);
}
function FunctionExpression(node) {
  this._functionHead(node);
  this.space();
  this.print(node.body, node);
}
function ArrowFunctionExpression(node) {
  if (node.async) {
    this.word('async');
    this.space();
  }
  const firstParam = node.params[0];
  if (
    node.params.length === 1 &&
    t$5().isIdentifier(firstParam) &&
    !hasTypes(node, firstParam)
  ) {
    if (
      this.format.retainLines &&
      node.loc &&
      node.body.loc &&
      node.loc.start.line < node.body.loc.start.line
    ) {
      this.token('(');
      if (firstParam.loc && firstParam.loc.start.line > node.loc.start.line) {
        this.indent();
        this.print(firstParam, node);
        this.dedent();
        this._catchUp('start', node.body.loc);
      } else {
        this.print(firstParam, node);
      }
      this.token(')');
    } else {
      this.print(firstParam, node);
    }
  } else {
    this._params(node);
  }
  this._predicate(node);
  this.space();
  this.token('=>');
  this.space();
  this.print(node.body, node);
}
function hasTypes(node, param) {
  return (
    node.typeParameters ||
    node.returnType ||
    param.typeAnnotation ||
    param.optional ||
    param.trailingComments
  );
}
var modules = {};
Object.defineProperty(modules, '__esModule', {value: true});
modules.ImportSpecifier = ImportSpecifier;
modules.ImportDefaultSpecifier = ImportDefaultSpecifier;
modules.ExportDefaultSpecifier = ExportDefaultSpecifier;
modules.ExportSpecifier = ExportSpecifier;
modules.ExportNamespaceSpecifier = ExportNamespaceSpecifier;
modules.ExportAllDeclaration = ExportAllDeclaration;
modules.ExportNamedDeclaration = ExportNamedDeclaration;
modules.ExportDefaultDeclaration = ExportDefaultDeclaration;
modules.ImportDeclaration = ImportDeclaration;
modules.ImportNamespaceSpecifier = ImportNamespaceSpecifier;
function t$4() {
  const data = _interopRequireWildcard$5(t$d);
  t$4 = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard$5(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function ImportSpecifier(node) {
  if (node.importKind === 'type' || node.importKind === 'typeof') {
    this.word(node.importKind);
    this.space();
  }
  this.print(node.imported, node);
  if (node.local && node.local.name !== node.imported.name) {
    this.space();
    this.word('as');
    this.space();
    this.print(node.local, node);
  }
}
function ImportDefaultSpecifier(node) {
  this.print(node.local, node);
}
function ExportDefaultSpecifier(node) {
  this.print(node.exported, node);
}
function ExportSpecifier(node) {
  this.print(node.local, node);
  if (node.exported && node.local.name !== node.exported.name) {
    this.space();
    this.word('as');
    this.space();
    this.print(node.exported, node);
  }
}
function ExportNamespaceSpecifier(node) {
  this.token('*');
  this.space();
  this.word('as');
  this.space();
  this.print(node.exported, node);
}
function ExportAllDeclaration(node) {
  this.word('export');
  this.space();
  if (node.exportKind === 'type') {
    this.word('type');
    this.space();
  }
  this.token('*');
  this.space();
  this.word('from');
  this.space();
  this.print(node.source, node);
  this.semicolon();
}
function ExportNamedDeclaration(node) {
  if (
    this.format.decoratorsBeforeExport &&
    t$4().isClassDeclaration(node.declaration)
  ) {
    this.printJoin(node.declaration.decorators, node);
  }
  this.word('export');
  this.space();
  ExportDeclaration.apply(this, arguments);
}
function ExportDefaultDeclaration(node) {
  if (
    this.format.decoratorsBeforeExport &&
    t$4().isClassDeclaration(node.declaration)
  ) {
    this.printJoin(node.declaration.decorators, node);
  }
  this.word('export');
  this.space();
  this.word('default');
  this.space();
  ExportDeclaration.apply(this, arguments);
}
function ExportDeclaration(node) {
  if (node.declaration) {
    const declar = node.declaration;
    this.print(declar, node);
    if (!t$4().isStatement(declar)) this.semicolon();
  } else {
    if (node.exportKind === 'type') {
      this.word('type');
      this.space();
    }
    const specifiers = node.specifiers.slice(0);
    let hasSpecial = false;
    while (true) {
      const first = specifiers[0];
      if (
        t$4().isExportDefaultSpecifier(first) ||
        t$4().isExportNamespaceSpecifier(first)
      ) {
        hasSpecial = true;
        this.print(specifiers.shift(), node);
        if (specifiers.length) {
          this.token(',');
          this.space();
        }
      } else {
        break;
      }
    }
    if (specifiers.length || (!specifiers.length && !hasSpecial)) {
      this.token('{');
      if (specifiers.length) {
        this.space();
        this.printList(specifiers, node);
        this.space();
      }
      this.token('}');
    }
    if (node.source) {
      this.space();
      this.word('from');
      this.space();
      this.print(node.source, node);
    }
    this.semicolon();
  }
}
function ImportDeclaration(node) {
  this.word('import');
  this.space();
  if (node.importKind === 'type' || node.importKind === 'typeof') {
    this.word(node.importKind);
    this.space();
  }
  const specifiers = node.specifiers.slice(0);
  if (specifiers && specifiers.length) {
    while (true) {
      const first = specifiers[0];
      if (
        t$4().isImportDefaultSpecifier(first) ||
        t$4().isImportNamespaceSpecifier(first)
      ) {
        this.print(specifiers.shift(), node);
        if (specifiers.length) {
          this.token(',');
          this.space();
        }
      } else {
        break;
      }
    }
    if (specifiers.length) {
      this.token('{');
      this.space();
      this.printList(specifiers, node);
      this.space();
      this.token('}');
    }
    this.space();
    this.word('from');
    this.space();
  }
  this.print(node.source, node);
  this.semicolon();
}
function ImportNamespaceSpecifier(node) {
  this.token('*');
  this.space();
  this.word('as');
  this.space();
  this.print(node.local, node);
}
var types = {};
var jsesc_1;
var hasRequiredJsesc;
function requireJsesc() {
  if (hasRequiredJsesc) return jsesc_1;
  hasRequiredJsesc = 1;
  const object = {};
  const hasOwnProperty = object.hasOwnProperty;
  const forOwn = (object, callback) => {
    for (const key in object) {
      if (hasOwnProperty.call(object, key)) {
        callback(key, object[key]);
      }
    }
  };
  const extend = (destination, source) => {
    if (!source) {
      return destination;
    }
    forOwn(source, (key, value) => {
      destination[key] = value;
    });
    return destination;
  };
  const forEach = (array, callback) => {
    const length = array.length;
    let index = -1;
    while (++index < length) {
      callback(array[index]);
    }
  };
  const toString = object.toString;
  const isArray = Array.isArray;
  const isBuffer = Buffer.isBuffer;
  const isObject = value => toString.call(value) == '[object Object]';
  const isString = value =>
    typeof value == 'string' || toString.call(value) == '[object String]';
  const isNumber = value =>
    typeof value == 'number' || toString.call(value) == '[object Number]';
  const isFunction = value => typeof value == 'function';
  const isMap = value => toString.call(value) == '[object Map]';
  const isSet = value => toString.call(value) == '[object Set]';
  const singleEscapes = {
    '"': '\\"',
    "'": "\\'",
    '\\': '\\\\',
    '\b': '\\b',
    '\f': '\\f',
    '\n': '\\n',
    '\r': '\\r',
    '\t': '\\t',
  };
  const regexSingleEscape = /["'\\\b\f\n\r\t]/;
  const regexDigit = /[0-9]/;
  const regexWhitelist = /[ !#-&\(-\[\]-_a-~]/;
  const jsesc = (argument, options) => {
    const increaseIndentation = () => {
      oldIndent = indent;
      ++options.indentLevel;
      indent = options.indent.repeat(options.indentLevel);
    };
    const defaults = {
      escapeEverything: false,
      minimal: false,
      isScriptContext: false,
      quotes: 'single',
      wrap: false,
      es6: false,
      json: false,
      compact: true,
      lowercaseHex: false,
      numbers: 'decimal',
      indent: '\t',
      indentLevel: 0,
      __inline1__: false,
      __inline2__: false,
    };
    const json = options && options.json;
    if (json) {
      defaults.quotes = 'double';
      defaults.wrap = true;
    }
    options = extend(defaults, options);
    if (
      options.quotes != 'single' &&
      options.quotes != 'double' &&
      options.quotes != 'backtick'
    ) {
      options.quotes = 'single';
    }
    const quote =
      options.quotes == 'double'
        ? '"'
        : options.quotes == 'backtick'
          ? '`'
          : "'";
    const compact = options.compact;
    const lowercaseHex = options.lowercaseHex;
    let indent = options.indent.repeat(options.indentLevel);
    let oldIndent = '';
    const inline1 = options.__inline1__;
    const inline2 = options.__inline2__;
    const newLine = compact ? '' : '\n';
    let result;
    let isEmpty = true;
    const useBinNumbers = options.numbers == 'binary';
    const useOctNumbers = options.numbers == 'octal';
    const useDecNumbers = options.numbers == 'decimal';
    const useHexNumbers = options.numbers == 'hexadecimal';
    if (json && argument && isFunction(argument.toJSON)) {
      argument = argument.toJSON();
    }
    if (!isString(argument)) {
      if (isMap(argument)) {
        if (argument.size == 0) {
          return 'new Map()';
        }
        if (!compact) {
          options.__inline1__ = true;
          options.__inline2__ = false;
        }
        return 'new Map(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isSet(argument)) {
        if (argument.size == 0) {
          return 'new Set()';
        }
        return 'new Set(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isBuffer(argument)) {
        if (argument.length == 0) {
          return 'Buffer.from([])';
        }
        return 'Buffer.from(' + jsesc(Array.from(argument), options) + ')';
      }
      if (isArray(argument)) {
        result = [];
        options.wrap = true;
        if (inline1) {
          options.__inline1__ = false;
          options.__inline2__ = true;
        }
        if (!inline2) {
          increaseIndentation();
        }
        forEach(argument, value => {
          isEmpty = false;
          if (inline2) {
            options.__inline2__ = false;
          }
          result.push(
            (compact || inline2 ? '' : indent) + jsesc(value, options)
          );
        });
        if (isEmpty) {
          return '[]';
        }
        if (inline2) {
          return '[' + result.join(', ') + ']';
        }
        return (
          '[' +
          newLine +
          result.join(',' + newLine) +
          newLine +
          (compact ? '' : oldIndent) +
          ']'
        );
      } else if (isNumber(argument)) {
        if (json) {
          return JSON.stringify(argument);
        }
        if (useDecNumbers) {
          return String(argument);
        }
        if (useHexNumbers) {
          let hexadecimal = argument.toString(16);
          if (!lowercaseHex) {
            hexadecimal = hexadecimal.toUpperCase();
          }
          return '0x' + hexadecimal;
        }
        if (useBinNumbers) {
          return '0b' + argument.toString(2);
        }
        if (useOctNumbers) {
          return '0o' + argument.toString(8);
        }
      } else if (!isObject(argument)) {
        if (json) {
          return JSON.stringify(argument) || 'null';
        }
        return String(argument);
      } else {
        result = [];
        options.wrap = true;
        increaseIndentation();
        forOwn(argument, (key, value) => {
          isEmpty = false;
          result.push(
            (compact ? '' : indent) +
              jsesc(key, options) +
              ':' +
              (compact ? '' : ' ') +
              jsesc(value, options)
          );
        });
        if (isEmpty) {
          return '{}';
        }
        return (
          '{' +
          newLine +
          result.join(',' + newLine) +
          newLine +
          (compact ? '' : oldIndent) +
          '}'
        );
      }
    }
    const string = argument;
    let index = -1;
    const length = string.length;
    result = '';
    while (++index < length) {
      const character = string.charAt(index);
      if (options.es6) {
        const first = string.charCodeAt(index);
        if (first >= 55296 && first <= 56319 && length > index + 1) {
          const second = string.charCodeAt(index + 1);
          if (second >= 56320 && second <= 57343) {
            const codePoint = (first - 55296) * 1024 + second - 56320 + 65536;
            let hexadecimal = codePoint.toString(16);
            if (!lowercaseHex) {
              hexadecimal = hexadecimal.toUpperCase();
            }
            result += '\\u{' + hexadecimal + '}';
            ++index;
            continue;
          }
        }
      }
      if (!options.escapeEverything) {
        if (regexWhitelist.test(character)) {
          result += character;
          continue;
        }
        if (character == '"') {
          result += quote == character ? '\\"' : character;
          continue;
        }
        if (character == '`') {
          result += quote == character ? '\\`' : character;
          continue;
        }
        if (character == "'") {
          result += quote == character ? "\\'" : character;
          continue;
        }
      }
      if (
        character == '\0' &&
        !json &&
        !regexDigit.test(string.charAt(index + 1))
      ) {
        result += '\\0';
        continue;
      }
      if (regexSingleEscape.test(character)) {
        result += singleEscapes[character];
        continue;
      }
      const charCode = character.charCodeAt(0);
      if (options.minimal && charCode != 8232 && charCode != 8233) {
        result += character;
        continue;
      }
      let hexadecimal = charCode.toString(16);
      if (!lowercaseHex) {
        hexadecimal = hexadecimal.toUpperCase();
      }
      const longhand = hexadecimal.length > 2 || json;
      const escaped =
        '\\' +
        (longhand ? 'u' : 'x') +
        ('0000' + hexadecimal).slice(longhand ? -4 : -2);
      result += escaped;
      continue;
    }
    if (options.wrap) {
      result = quote + result + quote;
    }
    if (quote == '`') {
      result = result.replace(/\$\{/g, '\\${');
    }
    if (options.isScriptContext) {
      return result
        .replace(/<\/(script|style)/gi, '<\\/$1')
        .replace(/<!--/g, json ? '\\u003C!--' : '\\x3C!--');
    }
    return result;
  };
  jsesc.version = '2.5.2';
  jsesc_1 = jsesc;
  return jsesc_1;
}
Object.defineProperty(types, '__esModule', {value: true});
types.Identifier = Identifier;
types.SpreadElement = types.RestElement = RestElement;
types.ObjectPattern = types.ObjectExpression = ObjectExpression;
types.ObjectMethod = ObjectMethod;
types.ObjectProperty = ObjectProperty;
types.ArrayPattern = types.ArrayExpression = ArrayExpression;
types.RegExpLiteral = RegExpLiteral;
types.BooleanLiteral = BooleanLiteral;
types.NullLiteral = NullLiteral;
types.NumericLiteral = NumericLiteral;
types.StringLiteral = StringLiteral;
types.BigIntLiteral = BigIntLiteral;
function t$3() {
  const data = _interopRequireWildcard$4(t$d);
  t$3 = function () {
    return data;
  };
  return data;
}
function _jsesc() {
  const data = _interopRequireDefault$f(requireJsesc());
  _jsesc = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$f(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function _interopRequireWildcard$4(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function Identifier(node) {
  this.exactSource(node.loc, () => {
    this.word(node.name);
  });
}
function RestElement(node) {
  this.token('...');
  this.print(node.argument, node);
}
function ObjectExpression(node) {
  const props = node.properties;
  this.token('{');
  this.printInnerComments(node);
  if (props.length) {
    this.space();
    this.printList(props, node, {indent: true, statement: true});
    this.space();
  }
  this.token('}');
}
function ObjectMethod(node) {
  this.printJoin(node.decorators, node);
  this._methodHead(node);
  this.space();
  this.print(node.body, node);
}
function ObjectProperty(node) {
  this.printJoin(node.decorators, node);
  if (node.computed) {
    this.token('[');
    this.print(node.key, node);
    this.token(']');
  } else {
    if (
      t$3().isAssignmentPattern(node.value) &&
      t$3().isIdentifier(node.key) &&
      node.key.name === node.value.left.name
    ) {
      this.print(node.value, node);
      return;
    }
    this.print(node.key, node);
    if (
      node.shorthand &&
      t$3().isIdentifier(node.key) &&
      t$3().isIdentifier(node.value) &&
      node.key.name === node.value.name
    ) {
      return;
    }
  }
  this.token(':');
  this.space();
  this.print(node.value, node);
}
function ArrayExpression(node) {
  const elems = node.elements;
  const len = elems.length;
  this.token('[');
  this.printInnerComments(node);
  for (let i = 0; i < elems.length; i++) {
    const elem = elems[i];
    if (elem) {
      if (i > 0) this.space();
      this.print(elem, node);
      if (i < len - 1) this.token(',');
    } else {
      this.token(',');
    }
  }
  this.token(']');
}
function RegExpLiteral(node) {
  this.word(`/${node.pattern}/${node.flags}`);
}
function BooleanLiteral(node) {
  this.word(node.value ? 'true' : 'false');
}
function NullLiteral() {
  this.word('null');
}
function NumericLiteral(node) {
  const raw = this.getPossibleRaw(node);
  const value = node.value + '';
  if (raw == null) {
    this.number(value);
  } else if (this.format.minified) {
    this.number(raw.length < value.length ? raw : value);
  } else {
    this.number(raw);
  }
}
function StringLiteral(node) {
  const raw = this.getPossibleRaw(node);
  if (!this.format.minified && raw != null) {
    this.token(raw);
    return;
  }
  const opts = this.format.jsescOption;
  if (this.format.jsonCompatibleStrings) {
    opts.json = true;
  }
  const val = (0, _jsesc().default)(node.value, opts);
  return this.token(val);
}
function BigIntLiteral(node) {
  const raw = this.getPossibleRaw(node);
  if (!this.format.minified && raw != null) {
    this.token(raw);
    return;
  }
  this.token(node.value);
}
var flow = {};
(function (exports) {
  Object.defineProperty(exports, '__esModule', {value: true});
  exports.AnyTypeAnnotation = AnyTypeAnnotation;
  exports.ArrayTypeAnnotation = ArrayTypeAnnotation;
  exports.BooleanTypeAnnotation = BooleanTypeAnnotation;
  exports.BooleanLiteralTypeAnnotation = BooleanLiteralTypeAnnotation;
  exports.NullLiteralTypeAnnotation = NullLiteralTypeAnnotation;
  exports.DeclareClass = DeclareClass;
  exports.DeclareFunction = DeclareFunction;
  exports.InferredPredicate = InferredPredicate;
  exports.DeclaredPredicate = DeclaredPredicate;
  exports.DeclareInterface = DeclareInterface;
  exports.DeclareModule = DeclareModule;
  exports.DeclareModuleExports = DeclareModuleExports;
  exports.DeclareTypeAlias = DeclareTypeAlias;
  exports.DeclareOpaqueType = DeclareOpaqueType;
  exports.DeclareVariable = DeclareVariable;
  exports.DeclareExportDeclaration = DeclareExportDeclaration;
  exports.DeclareExportAllDeclaration = DeclareExportAllDeclaration;
  exports.ExistsTypeAnnotation = ExistsTypeAnnotation;
  exports.FunctionTypeAnnotation = FunctionTypeAnnotation;
  exports.FunctionTypeParam = FunctionTypeParam;
  exports.GenericTypeAnnotation =
    exports.ClassImplements =
    exports.InterfaceExtends =
      InterfaceExtends;
  exports._interfaceish = _interfaceish;
  exports._variance = _variance;
  exports.InterfaceDeclaration = InterfaceDeclaration;
  exports.InterfaceTypeAnnotation = InterfaceTypeAnnotation;
  exports.IntersectionTypeAnnotation = IntersectionTypeAnnotation;
  exports.MixedTypeAnnotation = MixedTypeAnnotation;
  exports.EmptyTypeAnnotation = EmptyTypeAnnotation;
  exports.NullableTypeAnnotation = NullableTypeAnnotation;
  exports.NumberTypeAnnotation = NumberTypeAnnotation;
  exports.StringTypeAnnotation = StringTypeAnnotation;
  exports.ThisTypeAnnotation = ThisTypeAnnotation;
  exports.TupleTypeAnnotation = TupleTypeAnnotation;
  exports.TypeofTypeAnnotation = TypeofTypeAnnotation;
  exports.TypeAlias = TypeAlias;
  exports.TypeAnnotation = TypeAnnotation;
  exports.TypeParameterDeclaration = exports.TypeParameterInstantiation =
    TypeParameterInstantiation;
  exports.TypeParameter = TypeParameter;
  exports.OpaqueType = OpaqueType;
  exports.ObjectTypeAnnotation = ObjectTypeAnnotation;
  exports.ObjectTypeInternalSlot = ObjectTypeInternalSlot;
  exports.ObjectTypeCallProperty = ObjectTypeCallProperty;
  exports.ObjectTypeIndexer = ObjectTypeIndexer;
  exports.ObjectTypeProperty = ObjectTypeProperty;
  exports.ObjectTypeSpreadProperty = ObjectTypeSpreadProperty;
  exports.QualifiedTypeIdentifier = QualifiedTypeIdentifier;
  exports.UnionTypeAnnotation = UnionTypeAnnotation;
  exports.TypeCastExpression = TypeCastExpression;
  exports.Variance = Variance;
  exports.VoidTypeAnnotation = VoidTypeAnnotation;
  Object.defineProperty(exports, 'NumberLiteralTypeAnnotation', {
    enumerable: true,
    get: function () {
      return _types2.NumericLiteral;
    },
  });
  Object.defineProperty(exports, 'StringLiteralTypeAnnotation', {
    enumerable: true,
    get: function () {
      return _types2.StringLiteral;
    },
  });
  function t() {
    const data = _interopRequireWildcard(t$d);
    t = function () {
      return data;
    };
    return data;
  }
  var _modules = modules;
  var _types2 = types;
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};
      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc =
              Object.defineProperty && Object.getOwnPropertyDescriptor
                ? Object.getOwnPropertyDescriptor(obj, key)
                : {};
            if (desc.get || desc.set) {
              Object.defineProperty(newObj, key, desc);
            } else {
              newObj[key] = obj[key];
            }
          }
        }
      }
      newObj.default = obj;
      return newObj;
    }
  }
  function AnyTypeAnnotation() {
    this.word('any');
  }
  function ArrayTypeAnnotation(node) {
    this.print(node.elementType, node);
    this.token('[');
    this.token(']');
  }
  function BooleanTypeAnnotation() {
    this.word('boolean');
  }
  function BooleanLiteralTypeAnnotation(node) {
    this.word(node.value ? 'true' : 'false');
  }
  function NullLiteralTypeAnnotation() {
    this.word('null');
  }
  function DeclareClass(node, parent) {
    if (!t().isDeclareExportDeclaration(parent)) {
      this.word('declare');
      this.space();
    }
    this.word('class');
    this.space();
    this._interfaceish(node);
  }
  function DeclareFunction(node, parent) {
    if (!t().isDeclareExportDeclaration(parent)) {
      this.word('declare');
      this.space();
    }
    this.word('function');
    this.space();
    this.print(node.id, node);
    this.print(node.id.typeAnnotation.typeAnnotation, node);
    if (node.predicate) {
      this.space();
      this.print(node.predicate, node);
    }
    this.semicolon();
  }
  function InferredPredicate() {
    this.token('%');
    this.word('checks');
  }
  function DeclaredPredicate(node) {
    this.token('%');
    this.word('checks');
    this.token('(');
    this.print(node.value, node);
    this.token(')');
  }
  function DeclareInterface(node) {
    this.word('declare');
    this.space();
    this.InterfaceDeclaration(node);
  }
  function DeclareModule(node) {
    this.word('declare');
    this.space();
    this.word('module');
    this.space();
    this.print(node.id, node);
    this.space();
    this.print(node.body, node);
  }
  function DeclareModuleExports(node) {
    this.word('declare');
    this.space();
    this.word('module');
    this.token('.');
    this.word('exports');
    this.print(node.typeAnnotation, node);
  }
  function DeclareTypeAlias(node) {
    this.word('declare');
    this.space();
    this.TypeAlias(node);
  }
  function DeclareOpaqueType(node, parent) {
    if (!t().isDeclareExportDeclaration(parent)) {
      this.word('declare');
      this.space();
    }
    this.OpaqueType(node);
  }
  function DeclareVariable(node, parent) {
    if (!t().isDeclareExportDeclaration(parent)) {
      this.word('declare');
      this.space();
    }
    this.word('var');
    this.space();
    this.print(node.id, node);
    this.print(node.id.typeAnnotation, node);
    this.semicolon();
  }
  function DeclareExportDeclaration(node) {
    this.word('declare');
    this.space();
    this.word('export');
    this.space();
    if (node.default) {
      this.word('default');
      this.space();
    }
    FlowExportDeclaration.apply(this, arguments);
  }
  function DeclareExportAllDeclaration() {
    this.word('declare');
    this.space();
    _modules.ExportAllDeclaration.apply(this, arguments);
  }
  function FlowExportDeclaration(node) {
    if (node.declaration) {
      const declar = node.declaration;
      this.print(declar, node);
      if (!t().isStatement(declar)) this.semicolon();
    } else {
      this.token('{');
      if (node.specifiers.length) {
        this.space();
        this.printList(node.specifiers, node);
        this.space();
      }
      this.token('}');
      if (node.source) {
        this.space();
        this.word('from');
        this.space();
        this.print(node.source, node);
      }
      this.semicolon();
    }
  }
  function ExistsTypeAnnotation() {
    this.token('*');
  }
  function FunctionTypeAnnotation(node, parent) {
    this.print(node.typeParameters, node);
    this.token('(');
    this.printList(node.params, node);
    if (node.rest) {
      if (node.params.length) {
        this.token(',');
        this.space();
      }
      this.token('...');
      this.print(node.rest, node);
    }
    this.token(')');
    if (
      parent.type === 'ObjectTypeCallProperty' ||
      parent.type === 'DeclareFunction' ||
      (parent.type === 'ObjectTypeProperty' && parent.method)
    ) {
      this.token(':');
    } else {
      this.space();
      this.token('=>');
    }
    this.space();
    this.print(node.returnType, node);
  }
  function FunctionTypeParam(node) {
    this.print(node.name, node);
    if (node.optional) this.token('?');
    if (node.name) {
      this.token(':');
      this.space();
    }
    this.print(node.typeAnnotation, node);
  }
  function InterfaceExtends(node) {
    this.print(node.id, node);
    this.print(node.typeParameters, node);
  }
  function _interfaceish(node) {
    this.print(node.id, node);
    this.print(node.typeParameters, node);
    if (node.extends.length) {
      this.space();
      this.word('extends');
      this.space();
      this.printList(node.extends, node);
    }
    if (node.mixins && node.mixins.length) {
      this.space();
      this.word('mixins');
      this.space();
      this.printList(node.mixins, node);
    }
    if (node.implements && node.implements.length) {
      this.space();
      this.word('implements');
      this.space();
      this.printList(node.implements, node);
    }
    this.space();
    this.print(node.body, node);
  }
  function _variance(node) {
    if (node.variance) {
      if (node.variance.kind === 'plus') {
        this.token('+');
      } else if (node.variance.kind === 'minus') {
        this.token('-');
      }
    }
  }
  function InterfaceDeclaration(node) {
    this.word('interface');
    this.space();
    this._interfaceish(node);
  }
  function andSeparator() {
    this.space();
    this.token('&');
    this.space();
  }
  function InterfaceTypeAnnotation(node) {
    this.word('interface');
    if (node.extends && node.extends.length) {
      this.space();
      this.word('extends');
      this.space();
      this.printList(node.extends, node);
    }
    this.space();
    this.print(node.body, node);
  }
  function IntersectionTypeAnnotation(node) {
    this.printJoin(node.types, node, {separator: andSeparator});
  }
  function MixedTypeAnnotation() {
    this.word('mixed');
  }
  function EmptyTypeAnnotation() {
    this.word('empty');
  }
  function NullableTypeAnnotation(node) {
    this.token('?');
    this.print(node.typeAnnotation, node);
  }
  function NumberTypeAnnotation() {
    this.word('number');
  }
  function StringTypeAnnotation() {
    this.word('string');
  }
  function ThisTypeAnnotation() {
    this.word('this');
  }
  function TupleTypeAnnotation(node) {
    this.token('[');
    this.printList(node.types, node);
    this.token(']');
  }
  function TypeofTypeAnnotation(node) {
    this.word('typeof');
    this.space();
    this.print(node.argument, node);
  }
  function TypeAlias(node) {
    this.word('type');
    this.space();
    this.print(node.id, node);
    this.print(node.typeParameters, node);
    this.space();
    this.token('=');
    this.space();
    this.print(node.right, node);
    this.semicolon();
  }
  function TypeAnnotation(node) {
    this.token(':');
    this.space();
    if (node.optional) this.token('?');
    this.print(node.typeAnnotation, node);
  }
  function TypeParameterInstantiation(node) {
    this.token('<');
    this.printList(node.params, node, {});
    this.token('>');
  }
  function TypeParameter(node) {
    this._variance(node);
    this.word(node.name);
    if (node.bound) {
      this.print(node.bound, node);
    }
    if (node.default) {
      this.space();
      this.token('=');
      this.space();
      this.print(node.default, node);
    }
  }
  function OpaqueType(node) {
    this.word('opaque');
    this.space();
    this.word('type');
    this.space();
    this.print(node.id, node);
    this.print(node.typeParameters, node);
    if (node.supertype) {
      this.token(':');
      this.space();
      this.print(node.supertype, node);
    }
    if (node.impltype) {
      this.space();
      this.token('=');
      this.space();
      this.print(node.impltype, node);
    }
    this.semicolon();
  }
  function ObjectTypeAnnotation(node) {
    if (node.exact) {
      this.token('{|');
    } else {
      this.token('{');
    }
    const props = node.properties.concat(
      node.callProperties || [],
      node.indexers || [],
      node.internalSlots || []
    );
    if (props.length) {
      this.space();
      this.printJoin(props, node, {
        addNewlines(leading) {
          if (leading && !props[0]) return 1;
        },
        indent: true,
        statement: true,
        iterator: () => {
          if (props.length !== 1) {
            this.token(',');
            this.space();
          }
        },
      });
      this.space();
    }
    if (node.exact) {
      this.token('|}');
    } else {
      this.token('}');
    }
  }
  function ObjectTypeInternalSlot(node) {
    if (node.static) {
      this.word('static');
      this.space();
    }
    this.token('[');
    this.token('[');
    this.print(node.id, node);
    this.token(']');
    this.token(']');
    if (node.optional) this.token('?');
    if (!node.method) {
      this.token(':');
      this.space();
    }
    this.print(node.value, node);
  }
  function ObjectTypeCallProperty(node) {
    if (node.static) {
      this.word('static');
      this.space();
    }
    this.print(node.value, node);
  }
  function ObjectTypeIndexer(node) {
    if (node.static) {
      this.word('static');
      this.space();
    }
    this._variance(node);
    this.token('[');
    if (node.id) {
      this.print(node.id, node);
      this.token(':');
      this.space();
    }
    this.print(node.key, node);
    this.token(']');
    this.token(':');
    this.space();
    this.print(node.value, node);
  }
  function ObjectTypeProperty(node) {
    if (node.proto) {
      this.word('proto');
      this.space();
    }
    if (node.static) {
      this.word('static');
      this.space();
    }
    this._variance(node);
    this.print(node.key, node);
    if (node.optional) this.token('?');
    if (!node.method) {
      this.token(':');
      this.space();
    }
    this.print(node.value, node);
  }
  function ObjectTypeSpreadProperty(node) {
    this.token('...');
    this.print(node.argument, node);
  }
  function QualifiedTypeIdentifier(node) {
    this.print(node.qualification, node);
    this.token('.');
    this.print(node.id, node);
  }
  function orSeparator() {
    this.space();
    this.token('|');
    this.space();
  }
  function UnionTypeAnnotation(node) {
    this.printJoin(node.types, node, {separator: orSeparator});
  }
  function TypeCastExpression(node) {
    this.token('(');
    this.print(node.expression, node);
    this.print(node.typeAnnotation, node);
    this.token(')');
  }
  function Variance(node) {
    if (node.kind === 'plus') {
      this.token('+');
    } else {
      this.token('-');
    }
  }
  function VoidTypeAnnotation() {
    this.word('void');
  }
})(flow);
var base = {};
(function (exports) {
  Object.defineProperty(exports, '__esModule', {value: true});
  exports.File = File;
  exports.Program = Program;
  exports.BlockStatement = BlockStatement;
  exports.Noop = Noop;
  exports.Directive = Directive;
  exports.InterpreterDirective = InterpreterDirective;
  Object.defineProperty(exports, 'DirectiveLiteral', {
    enumerable: true,
    get: function () {
      return _types.StringLiteral;
    },
  });
  var _types = types;
  function File(node) {
    if (node.program) {
      this.print(node.program.interpreter, node);
    }
    this.print(node.program, node);
  }
  function Program(node) {
    this.printInnerComments(node, false);
    this.printSequence(node.directives, node);
    if (node.directives && node.directives.length) this.newline();
    this.printSequence(node.body, node);
  }
  function BlockStatement(node) {
    this.token('{');
    this.printInnerComments(node);
    const hasDirectives = node.directives && node.directives.length;
    if (node.body.length || hasDirectives) {
      this.newline();
      this.printSequence(node.directives, node, {indent: true});
      if (hasDirectives) this.newline();
      this.printSequence(node.body, node, {indent: true});
      this.removeTrailingNewline();
      this.source('end', node.loc);
      if (!this.endsWith('\n')) this.newline();
      this.rightBrace();
    } else {
      this.source('end', node.loc);
      this.token('}');
    }
  }
  function Noop() {}
  function Directive(node) {
    this.print(node.value, node);
    this.semicolon();
  }
  function InterpreterDirective(node) {
    this.token(`#!${node.value}\n`);
  }
})(base);
var jsx = {};
Object.defineProperty(jsx, '__esModule', {value: true});
jsx.JSXAttribute = JSXAttribute;
jsx.JSXIdentifier = JSXIdentifier;
jsx.JSXNamespacedName = JSXNamespacedName;
jsx.JSXMemberExpression = JSXMemberExpression;
jsx.JSXSpreadAttribute = JSXSpreadAttribute;
jsx.JSXExpressionContainer = JSXExpressionContainer;
jsx.JSXSpreadChild = JSXSpreadChild;
jsx.JSXText = JSXText;
jsx.JSXElement = JSXElement;
jsx.JSXOpeningElement = JSXOpeningElement;
jsx.JSXClosingElement = JSXClosingElement;
jsx.JSXEmptyExpression = JSXEmptyExpression;
jsx.JSXFragment = JSXFragment;
jsx.JSXOpeningFragment = JSXOpeningFragment;
jsx.JSXClosingFragment = JSXClosingFragment;
function JSXAttribute(node) {
  this.print(node.name, node);
  if (node.value) {
    this.token('=');
    this.print(node.value, node);
  }
}
function JSXIdentifier(node) {
  this.word(node.name);
}
function JSXNamespacedName(node) {
  this.print(node.namespace, node);
  this.token(':');
  this.print(node.name, node);
}
function JSXMemberExpression(node) {
  this.print(node.object, node);
  this.token('.');
  this.print(node.property, node);
}
function JSXSpreadAttribute(node) {
  this.token('{');
  this.token('...');
  this.print(node.argument, node);
  this.token('}');
}
function JSXExpressionContainer(node) {
  this.token('{');
  this.print(node.expression, node);
  this.token('}');
}
function JSXSpreadChild(node) {
  this.token('{');
  this.token('...');
  this.print(node.expression, node);
  this.token('}');
}
function JSXText(node) {
  const raw = this.getPossibleRaw(node);
  if (raw != null) {
    this.token(raw);
  } else {
    this.token(node.value);
  }
}
function JSXElement(node) {
  const open = node.openingElement;
  this.print(open, node);
  if (open.selfClosing) return;
  this.indent();
  for (const child of node.children) {
    this.print(child, node);
  }
  this.dedent();
  this.print(node.closingElement, node);
}
function spaceSeparator() {
  this.space();
}
function JSXOpeningElement(node) {
  this.token('<');
  this.print(node.name, node);
  this.print(node.typeParameters, node);
  if (node.attributes.length > 0) {
    this.space();
    this.printJoin(node.attributes, node, {separator: spaceSeparator});
  }
  if (node.selfClosing) {
    this.space();
    this.token('/>');
  } else {
    this.token('>');
  }
}
function JSXClosingElement(node) {
  this.token('</');
  this.print(node.name, node);
  this.token('>');
}
function JSXEmptyExpression(node) {
  this.printInnerComments(node);
}
function JSXFragment(node) {
  this.print(node.openingFragment, node);
  this.indent();
  for (const child of node.children) {
    this.print(child, node);
  }
  this.dedent();
  this.print(node.closingFragment, node);
}
function JSXOpeningFragment() {
  this.token('<');
  this.token('>');
}
function JSXClosingFragment() {
  this.token('</');
  this.token('>');
}
var typescript = {};
Object.defineProperty(typescript, '__esModule', {value: true});
typescript.TSTypeAnnotation = TSTypeAnnotation;
typescript.TSTypeParameterDeclaration =
  typescript.TSTypeParameterInstantiation = TSTypeParameterInstantiation;
typescript.TSTypeParameter = TSTypeParameter;
typescript.TSParameterProperty = TSParameterProperty;
typescript.TSDeclareFunction = TSDeclareFunction;
typescript.TSDeclareMethod = TSDeclareMethod;
typescript.TSQualifiedName = TSQualifiedName;
typescript.TSCallSignatureDeclaration = TSCallSignatureDeclaration;
typescript.TSConstructSignatureDeclaration = TSConstructSignatureDeclaration;
typescript.TSPropertySignature = TSPropertySignature;
typescript.tsPrintPropertyOrMethodName = tsPrintPropertyOrMethodName;
typescript.TSMethodSignature = TSMethodSignature;
typescript.TSIndexSignature = TSIndexSignature;
typescript.TSAnyKeyword = TSAnyKeyword;
typescript.TSUnknownKeyword = TSUnknownKeyword;
typescript.TSNumberKeyword = TSNumberKeyword;
typescript.TSObjectKeyword = TSObjectKeyword;
typescript.TSBooleanKeyword = TSBooleanKeyword;
typescript.TSStringKeyword = TSStringKeyword;
typescript.TSSymbolKeyword = TSSymbolKeyword;
typescript.TSVoidKeyword = TSVoidKeyword;
typescript.TSUndefinedKeyword = TSUndefinedKeyword;
typescript.TSNullKeyword = TSNullKeyword;
typescript.TSNeverKeyword = TSNeverKeyword;
typescript.TSThisType = TSThisType;
typescript.TSFunctionType = TSFunctionType;
typescript.TSConstructorType = TSConstructorType;
typescript.tsPrintFunctionOrConstructorType = tsPrintFunctionOrConstructorType;
typescript.TSTypeReference = TSTypeReference;
typescript.TSTypePredicate = TSTypePredicate;
typescript.TSTypeQuery = TSTypeQuery;
typescript.TSTypeLiteral = TSTypeLiteral;
typescript.tsPrintTypeLiteralOrInterfaceBody =
  tsPrintTypeLiteralOrInterfaceBody;
typescript.tsPrintBraced = tsPrintBraced;
typescript.TSArrayType = TSArrayType;
typescript.TSTupleType = TSTupleType;
typescript.TSOptionalType = TSOptionalType;
typescript.TSRestType = TSRestType;
typescript.TSUnionType = TSUnionType;
typescript.TSIntersectionType = TSIntersectionType;
typescript.tsPrintUnionOrIntersectionType = tsPrintUnionOrIntersectionType;
typescript.TSConditionalType = TSConditionalType;
typescript.TSInferType = TSInferType;
typescript.TSParenthesizedType = TSParenthesizedType;
typescript.TSTypeOperator = TSTypeOperator;
typescript.TSIndexedAccessType = TSIndexedAccessType;
typescript.TSMappedType = TSMappedType;
typescript.TSLiteralType = TSLiteralType;
typescript.TSExpressionWithTypeArguments = TSExpressionWithTypeArguments;
typescript.TSInterfaceDeclaration = TSInterfaceDeclaration;
typescript.TSInterfaceBody = TSInterfaceBody;
typescript.TSTypeAliasDeclaration = TSTypeAliasDeclaration;
typescript.TSAsExpression = TSAsExpression;
typescript.TSTypeAssertion = TSTypeAssertion;
typescript.TSEnumDeclaration = TSEnumDeclaration;
typescript.TSEnumMember = TSEnumMember;
typescript.TSModuleDeclaration = TSModuleDeclaration;
typescript.TSModuleBlock = TSModuleBlock;
typescript.TSImportEqualsDeclaration = TSImportEqualsDeclaration;
typescript.TSExternalModuleReference = TSExternalModuleReference;
typescript.TSNonNullExpression = TSNonNullExpression;
typescript.TSExportAssignment = TSExportAssignment;
typescript.TSNamespaceExportDeclaration = TSNamespaceExportDeclaration;
typescript.tsPrintSignatureDeclarationBase = tsPrintSignatureDeclarationBase;
function TSTypeAnnotation(node) {
  this.token(':');
  this.space();
  if (node.optional) this.token('?');
  this.print(node.typeAnnotation, node);
}
function TSTypeParameterInstantiation(node) {
  this.token('<');
  this.printList(node.params, node, {});
  this.token('>');
}
function TSTypeParameter(node) {
  this.word(node.name);
  if (node.constraint) {
    this.space();
    this.word('extends');
    this.space();
    this.print(node.constraint, node);
  }
  if (node.default) {
    this.space();
    this.token('=');
    this.space();
    this.print(node.default, node);
  }
}
function TSParameterProperty(node) {
  if (node.accessibility) {
    this.word(node.accessibility);
    this.space();
  }
  if (node.readonly) {
    this.word('readonly');
    this.space();
  }
  this._param(node.parameter);
}
function TSDeclareFunction(node) {
  if (node.declare) {
    this.word('declare');
    this.space();
  }
  this._functionHead(node);
  this.token(';');
}
function TSDeclareMethod(node) {
  this._classMethodHead(node);
  this.token(';');
}
function TSQualifiedName(node) {
  this.print(node.left, node);
  this.token('.');
  this.print(node.right, node);
}
function TSCallSignatureDeclaration(node) {
  this.tsPrintSignatureDeclarationBase(node);
}
function TSConstructSignatureDeclaration(node) {
  this.word('new');
  this.space();
  this.tsPrintSignatureDeclarationBase(node);
}
function TSPropertySignature(node) {
  const {readonly: readonly, initializer: initializer} = node;
  if (readonly) {
    this.word('readonly');
    this.space();
  }
  this.tsPrintPropertyOrMethodName(node);
  this.print(node.typeAnnotation, node);
  if (initializer) {
    this.space();
    this.token('=');
    this.space();
    this.print(initializer, node);
  }
  this.token(';');
}
function tsPrintPropertyOrMethodName(node) {
  if (node.computed) {
    this.token('[');
  }
  this.print(node.key, node);
  if (node.computed) {
    this.token(']');
  }
  if (node.optional) {
    this.token('?');
  }
}
function TSMethodSignature(node) {
  this.tsPrintPropertyOrMethodName(node);
  this.tsPrintSignatureDeclarationBase(node);
  this.token(';');
}
function TSIndexSignature(node) {
  const {readonly: readonly} = node;
  if (readonly) {
    this.word('readonly');
    this.space();
  }
  this.token('[');
  this._parameters(node.parameters, node);
  this.token(']');
  this.print(node.typeAnnotation, node);
  this.token(';');
}
function TSAnyKeyword() {
  this.word('any');
}
function TSUnknownKeyword() {
  this.word('unknown');
}
function TSNumberKeyword() {
  this.word('number');
}
function TSObjectKeyword() {
  this.word('object');
}
function TSBooleanKeyword() {
  this.word('boolean');
}
function TSStringKeyword() {
  this.word('string');
}
function TSSymbolKeyword() {
  this.word('symbol');
}
function TSVoidKeyword() {
  this.word('void');
}
function TSUndefinedKeyword() {
  this.word('undefined');
}
function TSNullKeyword() {
  this.word('null');
}
function TSNeverKeyword() {
  this.word('never');
}
function TSThisType() {
  this.word('this');
}
function TSFunctionType(node) {
  this.tsPrintFunctionOrConstructorType(node);
}
function TSConstructorType(node) {
  this.word('new');
  this.space();
  this.tsPrintFunctionOrConstructorType(node);
}
function tsPrintFunctionOrConstructorType(node) {
  const {typeParameters: typeParameters, parameters: parameters} = node;
  this.print(typeParameters, node);
  this.token('(');
  this._parameters(parameters, node);
  this.token(')');
  this.space();
  this.token('=>');
  this.space();
  this.print(node.typeAnnotation.typeAnnotation, node);
}
function TSTypeReference(node) {
  this.print(node.typeName, node);
  this.print(node.typeParameters, node);
}
function TSTypePredicate(node) {
  this.print(node.parameterName);
  this.space();
  this.word('is');
  this.space();
  this.print(node.typeAnnotation.typeAnnotation);
}
function TSTypeQuery(node) {
  this.word('typeof');
  this.space();
  this.print(node.exprName);
}
function TSTypeLiteral(node) {
  this.tsPrintTypeLiteralOrInterfaceBody(node.members, node);
}
function tsPrintTypeLiteralOrInterfaceBody(members, node) {
  this.tsPrintBraced(members, node);
}
function tsPrintBraced(members, node) {
  this.token('{');
  if (members.length) {
    this.indent();
    this.newline();
    for (const member of members) {
      this.print(member, node);
      this.newline();
    }
    this.dedent();
    this.rightBrace();
  } else {
    this.token('}');
  }
}
function TSArrayType(node) {
  this.print(node.elementType);
  this.token('[]');
}
function TSTupleType(node) {
  this.token('[');
  this.printList(node.elementTypes, node);
  this.token(']');
}
function TSOptionalType(node) {
  this.print(node.typeAnnotation, node);
  this.token('?');
}
function TSRestType(node) {
  this.token('...');
  this.print(node.typeAnnotation, node);
}
function TSUnionType(node) {
  this.tsPrintUnionOrIntersectionType(node, '|');
}
function TSIntersectionType(node) {
  this.tsPrintUnionOrIntersectionType(node, '&');
}
function tsPrintUnionOrIntersectionType(node, sep) {
  this.printJoin(node.types, node, {
    separator() {
      this.space();
      this.token(sep);
      this.space();
    },
  });
}
function TSConditionalType(node) {
  this.print(node.checkType);
  this.space();
  this.word('extends');
  this.space();
  this.print(node.extendsType);
  this.space();
  this.token('?');
  this.space();
  this.print(node.trueType);
  this.space();
  this.token(':');
  this.space();
  this.print(node.falseType);
}
function TSInferType(node) {
  this.token('infer');
  this.space();
  this.print(node.typeParameter);
}
function TSParenthesizedType(node) {
  this.token('(');
  this.print(node.typeAnnotation, node);
  this.token(')');
}
function TSTypeOperator(node) {
  this.token(node.operator);
  this.space();
  this.print(node.typeAnnotation, node);
}
function TSIndexedAccessType(node) {
  this.print(node.objectType, node);
  this.token('[');
  this.print(node.indexType, node);
  this.token(']');
}
function TSMappedType(node) {
  const {
    readonly: readonly,
    typeParameter: typeParameter,
    optional: optional,
  } = node;
  this.token('{');
  this.space();
  if (readonly) {
    tokenIfPlusMinus(this, readonly);
    this.word('readonly');
    this.space();
  }
  this.token('[');
  this.word(typeParameter.name);
  this.space();
  this.word('in');
  this.space();
  this.print(typeParameter.constraint, typeParameter);
  this.token(']');
  if (optional) {
    tokenIfPlusMinus(this, optional);
    this.token('?');
  }
  this.token(':');
  this.space();
  this.print(node.typeAnnotation, node);
  this.space();
  this.token('}');
}
function tokenIfPlusMinus(self, tok) {
  if (tok !== true) {
    self.token(tok);
  }
}
function TSLiteralType(node) {
  this.print(node.literal, node);
}
function TSExpressionWithTypeArguments(node) {
  this.print(node.expression, node);
  this.print(node.typeParameters, node);
}
function TSInterfaceDeclaration(node) {
  const {
    declare: declare,
    id: id,
    typeParameters: typeParameters,
    extends: extendz,
    body: body,
  } = node;
  if (declare) {
    this.word('declare');
    this.space();
  }
  this.word('interface');
  this.space();
  this.print(id, node);
  this.print(typeParameters, node);
  if (extendz) {
    this.space();
    this.word('extends');
    this.space();
    this.printList(extendz, node);
  }
  this.space();
  this.print(body, node);
}
function TSInterfaceBody(node) {
  this.tsPrintTypeLiteralOrInterfaceBody(node.body, node);
}
function TSTypeAliasDeclaration(node) {
  const {
    declare: declare,
    id: id,
    typeParameters: typeParameters,
    typeAnnotation: typeAnnotation,
  } = node;
  if (declare) {
    this.word('declare');
    this.space();
  }
  this.word('type');
  this.space();
  this.print(id, node);
  this.print(typeParameters, node);
  this.space();
  this.token('=');
  this.space();
  this.print(typeAnnotation, node);
  this.token(';');
}
function TSAsExpression(node) {
  const {expression: expression, typeAnnotation: typeAnnotation} = node;
  this.print(expression, node);
  this.space();
  this.word('as');
  this.space();
  this.print(typeAnnotation, node);
}
function TSTypeAssertion(node) {
  const {typeAnnotation: typeAnnotation, expression: expression} = node;
  this.token('<');
  this.print(typeAnnotation, node);
  this.token('>');
  this.space();
  this.print(expression, node);
}
function TSEnumDeclaration(node) {
  const {declare: declare, const: isConst, id: id, members: members} = node;
  if (declare) {
    this.word('declare');
    this.space();
  }
  if (isConst) {
    this.word('const');
    this.space();
  }
  this.word('enum');
  this.space();
  this.print(id, node);
  this.space();
  this.tsPrintBraced(members, node);
}
function TSEnumMember(node) {
  const {id: id, initializer: initializer} = node;
  this.print(id, node);
  if (initializer) {
    this.space();
    this.token('=');
    this.space();
    this.print(initializer, node);
  }
  this.token(',');
}
function TSModuleDeclaration(node) {
  const {declare: declare, id: id} = node;
  if (declare) {
    this.word('declare');
    this.space();
  }
  if (!node.global) {
    this.word(id.type === 'Identifier' ? 'namespace' : 'module');
    this.space();
  }
  this.print(id, node);
  if (!node.body) {
    this.token(';');
    return;
  }
  let body = node.body;
  while (body.type === 'TSModuleDeclaration') {
    this.token('.');
    this.print(body.id, body);
    body = body.body;
  }
  this.space();
  this.print(body, node);
}
function TSModuleBlock(node) {
  this.tsPrintBraced(node.body, node);
}
function TSImportEqualsDeclaration(node) {
  const {isExport: isExport, id: id, moduleReference: moduleReference} = node;
  if (isExport) {
    this.word('export');
    this.space();
  }
  this.word('import');
  this.space();
  this.print(id, node);
  this.space();
  this.token('=');
  this.space();
  this.print(moduleReference, node);
  this.token(';');
}
function TSExternalModuleReference(node) {
  this.token('require(');
  this.print(node.expression, node);
  this.token(')');
}
function TSNonNullExpression(node) {
  this.print(node.expression, node);
  this.token('!');
}
function TSExportAssignment(node) {
  this.word('export');
  this.space();
  this.token('=');
  this.space();
  this.print(node.expression, node);
  this.token(';');
}
function TSNamespaceExportDeclaration(node) {
  this.word('export');
  this.space();
  this.word('as');
  this.space();
  this.word('namespace');
  this.space();
  this.print(node.id, node);
}
function tsPrintSignatureDeclarationBase(node) {
  const {typeParameters: typeParameters, parameters: parameters} = node;
  this.print(typeParameters, node);
  this.token('(');
  this._parameters(parameters, node);
  this.token(')');
  this.print(node.typeAnnotation, node);
}
(function (exports) {
  Object.defineProperty(exports, '__esModule', {value: true});
  var _templateLiterals = templateLiterals;
  Object.keys(_templateLiterals).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _templateLiterals[key];
      },
    });
  });
  var _expressions = expressions;
  Object.keys(_expressions).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _expressions[key];
      },
    });
  });
  var _statements = statements;
  Object.keys(_statements).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _statements[key];
      },
    });
  });
  var _classes = classes;
  Object.keys(_classes).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _classes[key];
      },
    });
  });
  var _methods = methods;
  Object.keys(_methods).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _methods[key];
      },
    });
  });
  var _modules = modules;
  Object.keys(_modules).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _modules[key];
      },
    });
  });
  var _types = types;
  Object.keys(_types).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _types[key];
      },
    });
  });
  var _flow = flow;
  Object.keys(_flow).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _flow[key];
      },
    });
  });
  var _base = base;
  Object.keys(_base).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _base[key];
      },
    });
  });
  var _jsx = jsx;
  Object.keys(_jsx).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _jsx[key];
      },
    });
  });
  var _typescript = typescript;
  Object.keys(_typescript).forEach(function (key) {
    if (key === 'default' || key === '__esModule') return;
    Object.defineProperty(exports, key, {
      enumerable: true,
      get: function () {
        return _typescript[key];
      },
    });
  });
})(generators);
Object.defineProperty(printer$1, '__esModule', {value: true});
printer$1.default = void 0;
function _isInteger() {
  const data = _interopRequireDefault$e(requireIsInteger());
  _isInteger = function () {
    return data;
  };
  return data;
}
function _repeat() {
  const data = _interopRequireDefault$e(requireRepeat());
  _repeat = function () {
    return data;
  };
  return data;
}
var _buffer = _interopRequireDefault$e(buffer$3);
var n = _interopRequireWildcard$3(node);
function t$2() {
  const data = _interopRequireWildcard$3(t$d);
  t$2 = function () {
    return data;
  };
  return data;
}
var generatorFunctions = _interopRequireWildcard$3(generators);
function _interopRequireWildcard$3(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function _interopRequireDefault$e(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const SCIENTIFIC_NOTATION = /e/i;
const ZERO_DECIMAL_INTEGER = /\.0+$/;
const NON_DECIMAL_LITERAL = /^0[box]/;
class Printer {
  constructor(format, map) {
    this.inForStatementInitCounter = 0;
    this._printStack = [];
    this._indent = 0;
    this._insideAux = false;
    this._printedCommentStarts = {};
    this._parenPushNewlineState = null;
    this._noLineTerminator = false;
    this._printAuxAfterOnNextUserNode = false;
    this._printedComments = new WeakSet();
    this._endsWithInteger = false;
    this._endsWithWord = false;
    this.format = format || {};
    this._buf = new _buffer.default(map);
  }
  generate(ast) {
    this.print(ast);
    this._maybeAddAuxComment();
    return this._buf.get();
  }
  indent() {
    if (this.format.compact || this.format.concise) return;
    this._indent++;
  }
  dedent() {
    if (this.format.compact || this.format.concise) return;
    this._indent--;
  }
  semicolon(force = false) {
    this._maybeAddAuxComment();
    this._append(';', !force);
  }
  rightBrace() {
    if (this.format.minified) {
      this._buf.removeLastSemicolon();
    }
    this.token('}');
  }
  space(force = false) {
    if (this.format.compact) return;
    if (
      (this._buf.hasContent() && !this.endsWith(' ') && !this.endsWith('\n')) ||
      force
    ) {
      this._space();
    }
  }
  word(str) {
    if (this._endsWithWord || (this.endsWith('/') && str.indexOf('/') === 0)) {
      this._space();
    }
    this._maybeAddAuxComment();
    this._append(str);
    this._endsWithWord = true;
  }
  number(str) {
    this.word(str);
    this._endsWithInteger =
      (0, _isInteger().default)(+str) &&
      !NON_DECIMAL_LITERAL.test(str) &&
      !SCIENTIFIC_NOTATION.test(str) &&
      !ZERO_DECIMAL_INTEGER.test(str) &&
      str[str.length - 1] !== '.';
  }
  token(str) {
    if (
      (str === '--' && this.endsWith('!')) ||
      (str[0] === '+' && this.endsWith('+')) ||
      (str[0] === '-' && this.endsWith('-')) ||
      (str[0] === '.' && this._endsWithInteger)
    ) {
      this._space();
    }
    this._maybeAddAuxComment();
    this._append(str);
  }
  newline(i) {
    if (this.format.retainLines || this.format.compact) return;
    if (this.format.concise) {
      this.space();
      return;
    }
    if (this.endsWith('\n\n')) return;
    if (typeof i !== 'number') i = 1;
    i = Math.min(2, i);
    if (this.endsWith('{\n') || this.endsWith(':\n')) i--;
    if (i <= 0) return;
    for (let j = 0; j < i; j++) {
      this._newline();
    }
  }
  endsWith(str) {
    return this._buf.endsWith(str);
  }
  removeTrailingNewline() {
    this._buf.removeTrailingNewline();
  }
  exactSource(loc, cb) {
    this._catchUp('start', loc);
    this._buf.exactSource(loc, cb);
  }
  source(prop, loc) {
    this._catchUp(prop, loc);
    this._buf.source(prop, loc);
  }
  withSource(prop, loc, cb) {
    this._catchUp(prop, loc);
    this._buf.withSource(prop, loc, cb);
  }
  _space() {
    this._append(' ', true);
  }
  _newline() {
    this._append('\n', true);
  }
  _append(str, queue = false) {
    this._maybeAddParen(str);
    this._maybeIndent(str);
    if (queue) this._buf.queue(str);
    else this._buf.append(str);
    this._endsWithWord = false;
    this._endsWithInteger = false;
  }
  _maybeIndent(str) {
    if (this._indent && this.endsWith('\n') && str[0] !== '\n') {
      this._buf.queue(this._getIndent());
    }
  }
  _maybeAddParen(str) {
    const parenPushNewlineState = this._parenPushNewlineState;
    if (!parenPushNewlineState) return;
    this._parenPushNewlineState = null;
    let i;
    for (i = 0; i < str.length && str[i] === ' '; i++) continue;
    if (i === str.length) return;
    const cha = str[i];
    if (cha !== '\n') {
      if (cha !== '/') return;
      if (i + 1 === str.length) return;
      const chaPost = str[i + 1];
      if (chaPost !== '/' && chaPost !== '*') return;
    }
    this.token('(');
    this.indent();
    parenPushNewlineState.printed = true;
  }
  _catchUp(prop, loc) {
    if (!this.format.retainLines) return;
    const pos = loc ? loc[prop] : null;
    if (pos && pos.line !== null) {
      const count = pos.line - this._buf.getCurrentLine();
      for (let i = 0; i < count; i++) {
        this._newline();
      }
    }
  }
  _getIndent() {
    return (0, _repeat().default)(this.format.indent.style, this._indent);
  }
  startTerminatorless(isLabel = false) {
    if (isLabel) {
      this._noLineTerminator = true;
      return null;
    } else {
      return (this._parenPushNewlineState = {printed: false});
    }
  }
  endTerminatorless(state) {
    this._noLineTerminator = false;
    if (state && state.printed) {
      this.dedent();
      this.newline();
      this.token(')');
    }
  }
  print(node, parent) {
    if (!node) return;
    const oldConcise = this.format.concise;
    if (node._compact) {
      this.format.concise = true;
    }
    const printMethod = this[node.type];
    if (!printMethod) {
      throw new ReferenceError(
        `unknown node of type ${JSON.stringify(node.type)} with constructor ${JSON.stringify(node && node.constructor.name)}`
      );
    }
    this._printStack.push(node);
    const oldInAux = this._insideAux;
    this._insideAux = !node.loc;
    this._maybeAddAuxComment(this._insideAux && !oldInAux);
    let needsParens = n.needsParens(node, parent, this._printStack);
    if (
      this.format.retainFunctionParens &&
      node.type === 'FunctionExpression' &&
      node.extra &&
      node.extra.parenthesized
    ) {
      needsParens = true;
    }
    if (needsParens) this.token('(');
    this._printLeadingComments(node);
    const loc = t$2().isProgram(node) || t$2().isFile(node) ? null : node.loc;
    this.withSource('start', loc, () => {
      this[node.type](node, parent);
    });
    this._printTrailingComments(node);
    if (needsParens) this.token(')');
    this._printStack.pop();
    this.format.concise = oldConcise;
    this._insideAux = oldInAux;
  }
  _maybeAddAuxComment(enteredPositionlessNode) {
    if (enteredPositionlessNode) this._printAuxBeforeComment();
    if (!this._insideAux) this._printAuxAfterComment();
  }
  _printAuxBeforeComment() {
    if (this._printAuxAfterOnNextUserNode) return;
    this._printAuxAfterOnNextUserNode = true;
    const comment = this.format.auxiliaryCommentBefore;
    if (comment) {
      this._printComment({type: 'CommentBlock', value: comment});
    }
  }
  _printAuxAfterComment() {
    if (!this._printAuxAfterOnNextUserNode) return;
    this._printAuxAfterOnNextUserNode = false;
    const comment = this.format.auxiliaryCommentAfter;
    if (comment) {
      this._printComment({type: 'CommentBlock', value: comment});
    }
  }
  getPossibleRaw(node) {
    const extra = node.extra;
    if (
      extra &&
      extra.raw != null &&
      extra.rawValue != null &&
      node.value === extra.rawValue
    ) {
      return extra.raw;
    }
  }
  printJoin(nodes, parent, opts = {}) {
    if (!nodes || !nodes.length) return;
    if (opts.indent) this.indent();
    const newlineOpts = {addNewlines: opts.addNewlines};
    for (let i = 0; i < nodes.length; i++) {
      const node = nodes[i];
      if (!node) continue;
      if (opts.statement) this._printNewline(true, node, parent, newlineOpts);
      this.print(node, parent);
      if (opts.iterator) {
        opts.iterator(node, i);
      }
      if (opts.separator && i < nodes.length - 1) {
        opts.separator.call(this);
      }
      if (opts.statement) this._printNewline(false, node, parent, newlineOpts);
    }
    if (opts.indent) this.dedent();
  }
  printAndIndentOnComments(node, parent) {
    const indent = node.leadingComments && node.leadingComments.length > 0;
    if (indent) this.indent();
    this.print(node, parent);
    if (indent) this.dedent();
  }
  printBlock(parent) {
    const node = parent.body;
    if (!t$2().isEmptyStatement(node)) {
      this.space();
    }
    this.print(node, parent);
  }
  _printTrailingComments(node) {
    this._printComments(this._getComments(false, node));
  }
  _printLeadingComments(node) {
    this._printComments(this._getComments(true, node));
  }
  printInnerComments(node, indent = true) {
    if (!node.innerComments || !node.innerComments.length) return;
    if (indent) this.indent();
    this._printComments(node.innerComments);
    if (indent) this.dedent();
  }
  printSequence(nodes, parent, opts = {}) {
    opts.statement = true;
    return this.printJoin(nodes, parent, opts);
  }
  printList(items, parent, opts = {}) {
    if (opts.separator == null) {
      opts.separator = commaSeparator;
    }
    return this.printJoin(items, parent, opts);
  }
  _printNewline(leading, node, parent, opts) {
    if (this.format.retainLines || this.format.compact) return;
    if (this.format.concise) {
      this.space();
      return;
    }
    let lines = 0;
    if (this._buf.hasContent()) {
      if (!leading) lines++;
      if (opts.addNewlines) lines += opts.addNewlines(leading, node) || 0;
      const needs = leading ? n.needsWhitespaceBefore : n.needsWhitespaceAfter;
      if (needs(node, parent)) lines++;
    }
    this.newline(lines);
  }
  _getComments(leading, node) {
    return (
      (node && (leading ? node.leadingComments : node.trailingComments)) || []
    );
  }
  _printComment(comment) {
    if (!this.format.shouldPrintComment(comment.value)) return;
    if (comment.ignore) return;
    if (this._printedComments.has(comment)) return;
    this._printedComments.add(comment);
    if (comment.start != null) {
      if (this._printedCommentStarts[comment.start]) return;
      this._printedCommentStarts[comment.start] = true;
    }
    const isBlockComment = comment.type === 'CommentBlock';
    this.newline(
      this._buf.hasContent() && !this._noLineTerminator && isBlockComment
        ? 1
        : 0
    );
    if (!this.endsWith('[') && !this.endsWith('{')) this.space();
    let val =
      !isBlockComment && !this._noLineTerminator
        ? `//${comment.value}\n`
        : `/*${comment.value}*/`;
    if (isBlockComment && this.format.indent.adjustMultilineComment) {
      const offset = comment.loc && comment.loc.start.column;
      if (offset) {
        const newlineRegex = new RegExp('\\n\\s{1,' + offset + '}', 'g');
        val = val.replace(newlineRegex, '\n');
      }
      const indentSize = Math.max(
        this._getIndent().length,
        this._buf.getCurrentColumn()
      );
      val = val.replace(
        /\n(?!$)/g,
        `\n${(0, _repeat().default)(' ', indentSize)}`
      );
    }
    if (this.endsWith('/')) this._space();
    this.withSource('start', comment.loc, () => {
      this._append(val);
    });
    this.newline(isBlockComment && !this._noLineTerminator ? 1 : 0);
  }
  _printComments(comments) {
    if (!comments || !comments.length) return;
    for (const comment of comments) {
      this._printComment(comment);
    }
  }
}
printer$1.default = Printer;
Object.assign(Printer.prototype, generatorFunctions);
function commaSeparator() {
  this.token(',');
  this.space();
}
Object.defineProperty(lib$1, '__esModule', {value: true});
var default_1 = (lib$1.default = _default$9);
lib$1.CodeGenerator = void 0;
var _sourceMap$1 = _interopRequireDefault$d(sourceMap$1);
var _printer = _interopRequireDefault$d(printer$1);
function _interopRequireDefault$d(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
class Generator extends _printer.default {
  constructor(ast, opts = {}, code) {
    const format = normalizeOptions$2(code, opts);
    const map = opts.sourceMaps ? new _sourceMap$1.default(opts, code) : null;
    super(format, map);
    this.ast = ast;
  }
  generate() {
    return super.generate(this.ast);
  }
}
function normalizeOptions$2(code, opts) {
  const format = {
    auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
    auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
    shouldPrintComment: opts.shouldPrintComment,
    retainLines: opts.retainLines,
    retainFunctionParens: opts.retainFunctionParens,
    comments: opts.comments == null || opts.comments,
    compact: opts.compact,
    minified: opts.minified,
    concise: opts.concise,
    jsonCompatibleStrings: opts.jsonCompatibleStrings,
    indent: {adjustMultilineComment: true, style: '  ', base: 0},
    decoratorsBeforeExport: !!opts.decoratorsBeforeExport,
    jsescOption: Object.assign(
      {quotes: 'double', wrap: true},
      opts.jsescOption
    ),
  };
  if (format.minified) {
    format.compact = true;
    format.shouldPrintComment =
      format.shouldPrintComment || (() => format.comments);
  } else {
    format.shouldPrintComment =
      format.shouldPrintComment ||
      (value =>
        format.comments ||
        value.indexOf('@license') >= 0 ||
        value.indexOf('@preserve') >= 0);
  }
  if (format.compact === 'auto') {
    format.compact = code.length > 5e5;
    if (format.compact) {
      console.error(
        '[BABEL] Note: The code generator has deoptimised the styling of ' +
          `${opts.filename} as it exceeds the max of ${'500KB'}.`
      );
    }
  }
  if (format.compact) {
    format.indent.adjustMultilineComment = false;
  }
  return format;
}
class CodeGenerator {
  constructor(ast, opts, code) {
    this._generator = new Generator(ast, opts, code);
  }
  generate() {
    return this._generator.generate();
  }
}
lib$1.CodeGenerator = CodeGenerator;
function _default$9(ast, opts, code) {
  const gen = new Generator(ast, opts, code);
  return gen.generate();
}
Object.defineProperty(buildExternalHelpers, '__esModule', {value: true});
buildExternalHelpers.default = _default$8;
function helpers() {
  const data = _interopRequireWildcard$2(requireLib$c());
  helpers = function () {
    return data;
  };
  return data;
}
function _generator$1() {
  const data = _interopRequireDefault$c(lib$1);
  _generator$1 = function () {
    return data;
  };
  return data;
}
function _template() {
  const data = _interopRequireDefault$c(requireLib$d());
  _template = function () {
    return data;
  };
  return data;
}
function t$1() {
  const data = _interopRequireWildcard$2(t$d);
  t$1 = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$c(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function _interopRequireWildcard$2(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
const buildUmdWrapper = replacements =>
  _template().default`
    (function (root, factory) {
      if (typeof define === "function" && define.amd) {
        define(AMD_ARGUMENTS, factory);
      } else if (typeof exports === "object") {
        factory(COMMON_ARGUMENTS);
      } else {
        factory(BROWSER_ARGUMENTS);
      }
    })(UMD_ROOT, function (FACTORY_PARAMETERS) {
      FACTORY_BODY
    });
  `(replacements);
function buildGlobal(whitelist) {
  const namespace = t$1().identifier('babelHelpers');
  const body = [];
  const container = t$1().functionExpression(
    null,
    [t$1().identifier('global')],
    t$1().blockStatement(body)
  );
  const tree = t$1().program([
    t$1().expressionStatement(
      t$1().callExpression(container, [
        t$1().conditionalExpression(
          t$1().binaryExpression(
            '===',
            t$1().unaryExpression('typeof', t$1().identifier('global')),
            t$1().stringLiteral('undefined')
          ),
          t$1().identifier('self'),
          t$1().identifier('global')
        ),
      ])
    ),
  ]);
  body.push(
    t$1().variableDeclaration('var', [
      t$1().variableDeclarator(
        namespace,
        t$1().assignmentExpression(
          '=',
          t$1().memberExpression(t$1().identifier('global'), namespace),
          t$1().objectExpression([])
        )
      ),
    ])
  );
  buildHelpers(body, namespace, whitelist);
  return tree;
}
function buildModule(whitelist) {
  const body = [];
  const refs = buildHelpers(body, null, whitelist);
  body.unshift(
    t$1().exportNamedDeclaration(
      null,
      Object.keys(refs).map(name =>
        t$1().exportSpecifier(
          t$1().cloneNode(refs[name]),
          t$1().identifier(name)
        )
      )
    )
  );
  return t$1().program(body, [], 'module');
}
function buildUmd(whitelist) {
  const namespace = t$1().identifier('babelHelpers');
  const body = [];
  body.push(
    t$1().variableDeclaration('var', [
      t$1().variableDeclarator(namespace, t$1().identifier('global')),
    ])
  );
  buildHelpers(body, namespace, whitelist);
  return t$1().program([
    buildUmdWrapper({
      FACTORY_PARAMETERS: t$1().identifier('global'),
      BROWSER_ARGUMENTS: t$1().assignmentExpression(
        '=',
        t$1().memberExpression(t$1().identifier('root'), namespace),
        t$1().objectExpression([])
      ),
      COMMON_ARGUMENTS: t$1().identifier('exports'),
      AMD_ARGUMENTS: t$1().arrayExpression([t$1().stringLiteral('exports')]),
      FACTORY_BODY: body,
      UMD_ROOT: t$1().identifier('this'),
    }),
  ]);
}
function buildVar(whitelist) {
  const namespace = t$1().identifier('babelHelpers');
  const body = [];
  body.push(
    t$1().variableDeclaration('var', [
      t$1().variableDeclarator(namespace, t$1().objectExpression([])),
    ])
  );
  const tree = t$1().program(body);
  buildHelpers(body, namespace, whitelist);
  body.push(t$1().expressionStatement(namespace));
  return tree;
}
function buildHelpers(body, namespace, whitelist) {
  const getHelperReference = name =>
    namespace
      ? t$1().memberExpression(namespace, t$1().identifier(name))
      : t$1().identifier(`_${name}`);
  const refs = {};
  helpers().list.forEach(function (name) {
    if (whitelist && whitelist.indexOf(name) < 0) return;
    const ref = (refs[name] = getHelperReference(name));
    const {nodes: nodes} = helpers().get(name, getHelperReference, ref);
    body.push(...nodes);
  });
  return refs;
}
function _default$8(whitelist, outputType = 'global') {
  let tree;
  const build = {
    global: buildGlobal,
    module: buildModule,
    umd: buildUmd,
    var: buildVar,
  }[outputType];
  if (build) {
    tree = build(whitelist);
  } else {
    throw new Error(`Unsupported output type ${outputType}`);
  }
  return (0, _generator$1().default)(tree).code;
}
var files = {};
var _package = {};
var utils = {};
var caching = {};
Object.defineProperty(caching, '__esModule', {value: true});
caching.makeStrongCache = makeStrongCache;
caching.makeWeakCache = makeWeakCache;
caching.assertSimpleType = assertSimpleType;
function makeStrongCache(handler) {
  return makeCachedFunction(new Map(), handler);
}
function makeWeakCache(handler) {
  return makeCachedFunction(new WeakMap(), handler);
}
function makeCachedFunction(callCache, handler) {
  return function cachedFunction(arg, data) {
    let cachedValue = callCache.get(arg);
    if (cachedValue) {
      for (const _ref of cachedValue) {
        const {value: value, valid: valid} = _ref;
        if (valid(data)) return value;
      }
    }
    const cache = new CacheConfigurator(data);
    const value = handler(arg, cache);
    if (!cache.configured()) cache.forever();
    cache.deactivate();
    switch (cache.mode()) {
      case 'forever':
        cachedValue = [{value: value, valid: () => true}];
        callCache.set(arg, cachedValue);
        break;
      case 'invalidate':
        cachedValue = [{value: value, valid: cache.validator()}];
        callCache.set(arg, cachedValue);
        break;
      case 'valid':
        if (cachedValue) {
          cachedValue.push({value: value, valid: cache.validator()});
        } else {
          cachedValue = [{value: value, valid: cache.validator()}];
          callCache.set(arg, cachedValue);
        }
    }
    return value;
  };
}
class CacheConfigurator {
  constructor(data) {
    this._active = true;
    this._never = false;
    this._forever = false;
    this._invalidate = false;
    this._configured = false;
    this._pairs = [];
    this._data = data;
  }
  simple() {
    return makeSimpleConfigurator(this);
  }
  mode() {
    if (this._never) return 'never';
    if (this._forever) return 'forever';
    if (this._invalidate) return 'invalidate';
    return 'valid';
  }
  forever() {
    if (!this._active) {
      throw new Error('Cannot change caching after evaluation has completed.');
    }
    if (this._never) {
      throw new Error('Caching has already been configured with .never()');
    }
    this._forever = true;
    this._configured = true;
  }
  never() {
    if (!this._active) {
      throw new Error('Cannot change caching after evaluation has completed.');
    }
    if (this._forever) {
      throw new Error('Caching has already been configured with .forever()');
    }
    this._never = true;
    this._configured = true;
  }
  using(handler) {
    if (!this._active) {
      throw new Error('Cannot change caching after evaluation has completed.');
    }
    if (this._never || this._forever) {
      throw new Error(
        'Caching has already been configured with .never or .forever()'
      );
    }
    this._configured = true;
    const key = handler(this._data);
    this._pairs.push([key, handler]);
    return key;
  }
  invalidate(handler) {
    if (!this._active) {
      throw new Error('Cannot change caching after evaluation has completed.');
    }
    if (this._never || this._forever) {
      throw new Error(
        'Caching has already been configured with .never or .forever()'
      );
    }
    this._invalidate = true;
    this._configured = true;
    const key = handler(this._data);
    this._pairs.push([key, handler]);
    return key;
  }
  validator() {
    const pairs = this._pairs;
    return data => pairs.every(([key, fn]) => key === fn(data));
  }
  deactivate() {
    this._active = false;
  }
  configured() {
    return this._configured;
  }
}
function makeSimpleConfigurator(cache) {
  function cacheFn(val) {
    if (typeof val === 'boolean') {
      if (val) cache.forever();
      else cache.never();
      return;
    }
    return cache.using(() => assertSimpleType(val()));
  }
  cacheFn.forever = () => cache.forever();
  cacheFn.never = () => cache.never();
  cacheFn.using = cb => cache.using(() => assertSimpleType(cb()));
  cacheFn.invalidate = cb => cache.invalidate(() => assertSimpleType(cb()));
  return cacheFn;
}
function assertSimpleType(value) {
  if (
    value != null &&
    typeof value !== 'string' &&
    typeof value !== 'boolean' &&
    typeof value !== 'number'
  ) {
    throw new Error(
      'Cache keys must be either string, boolean, number, null, or undefined.'
    );
  }
  return value;
}
Object.defineProperty(utils, '__esModule', {value: true});
utils.makeStaticFileCache = makeStaticFileCache;
function _fs() {
  const data = _interopRequireDefault$b(require$$0$4);
  _fs = function () {
    return data;
  };
  return data;
}
var _caching = caching;
function _interopRequireDefault$b(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function makeStaticFileCache(fn) {
  return (0, _caching.makeStrongCache)((filepath, cache) => {
    if (cache.invalidate(() => fileMtime(filepath)) === null) {
      cache.forever();
      return null;
    }
    return fn(filepath, _fs().default.readFileSync(filepath, 'utf8'));
  });
}
function fileMtime(filepath) {
  try {
    return +_fs().default.statSync(filepath).mtime;
  } catch (e) {
    if (e.code !== 'ENOENT' && e.code !== 'ENOTDIR') throw e;
  }
  return null;
}
Object.defineProperty(_package, '__esModule', {value: true});
_package.findPackageData = findPackageData;
function _path$4() {
  const data = _interopRequireDefault$a(require$$0$5);
  _path$4 = function () {
    return data;
  };
  return data;
}
var _utils = utils;
function _interopRequireDefault$a(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const PACKAGE_FILENAME = 'package.json';
function findPackageData(filepath) {
  let pkg = null;
  const directories = [];
  let isPackage = true;
  let dirname = _path$4().default.dirname(filepath);
  while (!pkg && _path$4().default.basename(dirname) !== 'node_modules') {
    directories.push(dirname);
    pkg = readConfigPackage(_path$4().default.join(dirname, PACKAGE_FILENAME));
    const nextLoc = _path$4().default.dirname(dirname);
    if (dirname === nextLoc) {
      isPackage = false;
      break;
    }
    dirname = nextLoc;
  }
  return {
    filepath: filepath,
    directories: directories,
    pkg: pkg,
    isPackage: isPackage,
  };
}
const readConfigPackage = (0, _utils.makeStaticFileCache)(
  (filepath, content) => {
    let options;
    try {
      options = JSON.parse(content);
    } catch (err) {
      err.message = `${filepath}: Error while parsing JSON - ${err.message}`;
      throw err;
    }
    if (typeof options !== 'object') {
      throw new Error(`${filepath}: Config returned typeof ${typeof options}`);
    }
    if (Array.isArray(options)) {
      throw new Error(`${filepath}: Expected config object but found array`);
    }
    return {
      filepath: filepath,
      dirname: _path$4().default.dirname(filepath),
      options: options,
    };
  }
);
function commonjsRequire(path) {
  throw new Error(
    'Could not dynamically require "' +
      path +
      '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.'
  );
}
var configuration = {};
var Space_Separator = /[\u1680\u2000-\u200A\u202F\u205F\u3000]/;
var ID_Start =
  /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
var ID_Continue =
  /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u09FC\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9-\u0AFF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D00-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF9\u1D00-\u1DF9\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDE00-\uDE3E\uDE47\uDE50-\uDE83\uDE86-\uDE99\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD47\uDD50-\uDD59]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/;
var unicode = {
  Space_Separator: Space_Separator,
  ID_Start: ID_Start,
  ID_Continue: ID_Continue,
};
var util$5 = {
  isSpaceSeparator(c) {
    return typeof c === 'string' && unicode.Space_Separator.test(c);
  },
  isIdStartChar(c) {
    return (
      typeof c === 'string' &&
      ((c >= 'a' && c <= 'z') ||
        (c >= 'A' && c <= 'Z') ||
        c === '$' ||
        c === '_' ||
        unicode.ID_Start.test(c))
    );
  },
  isIdContinueChar(c) {
    return (
      typeof c === 'string' &&
      ((c >= 'a' && c <= 'z') ||
        (c >= 'A' && c <= 'Z') ||
        (c >= '0' && c <= '9') ||
        c === '$' ||
        c === '_' ||
        c === '‌' ||
        c === '‍' ||
        unicode.ID_Continue.test(c))
    );
  },
  isDigit(c) {
    return typeof c === 'string' && /[0-9]/.test(c);
  },
  isHexDigit(c) {
    return typeof c === 'string' && /[0-9A-Fa-f]/.test(c);
  },
};
let source;
let parseState;
let stack;
let pos;
let line;
let column;
let token;
let key;
let root;
var parse$1 = function parse(text, reviver) {
  source = String(text);
  parseState = 'start';
  stack = [];
  pos = 0;
  line = 1;
  column = 0;
  token = undefined;
  key = undefined;
  root = undefined;
  do {
    token = lex();
    parseStates[parseState]();
  } while (token.type !== 'eof');
  if (typeof reviver === 'function') {
    return internalize({'': root}, '', reviver);
  }
  return root;
};
function internalize(holder, name, reviver) {
  const value = holder[name];
  if (value != null && typeof value === 'object') {
    if (Array.isArray(value)) {
      for (let i = 0; i < value.length; i++) {
        const key = String(i);
        const replacement = internalize(value, key, reviver);
        if (replacement === undefined) {
          delete value[key];
        } else {
          Object.defineProperty(value, key, {
            value: replacement,
            writable: true,
            enumerable: true,
            configurable: true,
          });
        }
      }
    } else {
      for (const key in value) {
        const replacement = internalize(value, key, reviver);
        if (replacement === undefined) {
          delete value[key];
        } else {
          Object.defineProperty(value, key, {
            value: replacement,
            writable: true,
            enumerable: true,
            configurable: true,
          });
        }
      }
    }
  }
  return reviver.call(holder, name, value);
}
let lexState;
let buffer$2;
let doubleQuote;
let sign;
let c;
function lex() {
  lexState = 'default';
  buffer$2 = '';
  doubleQuote = false;
  sign = 1;
  for (;;) {
    c = peek();
    const token = lexStates[lexState]();
    if (token) {
      return token;
    }
  }
}
function peek() {
  if (source[pos]) {
    return String.fromCodePoint(source.codePointAt(pos));
  }
}
function read$1() {
  const c = peek();
  if (c === '\n') {
    line++;
    column = 0;
  } else if (c) {
    column += c.length;
  } else {
    column++;
  }
  if (c) {
    pos += c.length;
  }
  return c;
}
const lexStates = {
  default() {
    switch (c) {
      case '\t':
      case '\v':
      case '\f':
      case ' ':
      case ' ':
      case '\ufeff':
      case '\n':
      case '\r':
      case '\u2028':
      case '\u2029':
        read$1();
        return;
      case '/':
        read$1();
        lexState = 'comment';
        return;
      case undefined:
        read$1();
        return newToken('eof');
    }
    if (util$5.isSpaceSeparator(c)) {
      read$1();
      return;
    }
    return lexStates[parseState]();
  },
  comment() {
    switch (c) {
      case '*':
        read$1();
        lexState = 'multiLineComment';
        return;
      case '/':
        read$1();
        lexState = 'singleLineComment';
        return;
    }
    throw invalidChar(read$1());
  },
  multiLineComment() {
    switch (c) {
      case '*':
        read$1();
        lexState = 'multiLineCommentAsterisk';
        return;
      case undefined:
        throw invalidChar(read$1());
    }
    read$1();
  },
  multiLineCommentAsterisk() {
    switch (c) {
      case '*':
        read$1();
        return;
      case '/':
        read$1();
        lexState = 'default';
        return;
      case undefined:
        throw invalidChar(read$1());
    }
    read$1();
    lexState = 'multiLineComment';
  },
  singleLineComment() {
    switch (c) {
      case '\n':
      case '\r':
      case '\u2028':
      case '\u2029':
        read$1();
        lexState = 'default';
        return;
      case undefined:
        read$1();
        return newToken('eof');
    }
    read$1();
  },
  value() {
    switch (c) {
      case '{':
      case '[':
        return newToken('punctuator', read$1());
      case 'n':
        read$1();
        literal('ull');
        return newToken('null', null);
      case 't':
        read$1();
        literal('rue');
        return newToken('boolean', true);
      case 'f':
        read$1();
        literal('alse');
        return newToken('boolean', false);
      case '-':
      case '+':
        if (read$1() === '-') {
          sign = -1;
        }
        lexState = 'sign';
        return;
      case '.':
        buffer$2 = read$1();
        lexState = 'decimalPointLeading';
        return;
      case '0':
        buffer$2 = read$1();
        lexState = 'zero';
        return;
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        buffer$2 = read$1();
        lexState = 'decimalInteger';
        return;
      case 'I':
        read$1();
        literal('nfinity');
        return newToken('numeric', Infinity);
      case 'N':
        read$1();
        literal('aN');
        return newToken('numeric', NaN);
      case '"':
      case "'":
        doubleQuote = read$1() === '"';
        buffer$2 = '';
        lexState = 'string';
        return;
    }
    throw invalidChar(read$1());
  },
  identifierNameStartEscape() {
    if (c !== 'u') {
      throw invalidChar(read$1());
    }
    read$1();
    const u = unicodeEscape();
    switch (u) {
      case '$':
      case '_':
        break;
      default:
        if (!util$5.isIdStartChar(u)) {
          throw invalidIdentifier();
        }
        break;
    }
    buffer$2 += u;
    lexState = 'identifierName';
  },
  identifierName() {
    switch (c) {
      case '$':
      case '_':
      case '‌':
      case '‍':
        buffer$2 += read$1();
        return;
      case '\\':
        read$1();
        lexState = 'identifierNameEscape';
        return;
    }
    if (util$5.isIdContinueChar(c)) {
      buffer$2 += read$1();
      return;
    }
    return newToken('identifier', buffer$2);
  },
  identifierNameEscape() {
    if (c !== 'u') {
      throw invalidChar(read$1());
    }
    read$1();
    const u = unicodeEscape();
    switch (u) {
      case '$':
      case '_':
      case '‌':
      case '‍':
        break;
      default:
        if (!util$5.isIdContinueChar(u)) {
          throw invalidIdentifier();
        }
        break;
    }
    buffer$2 += u;
    lexState = 'identifierName';
  },
  sign() {
    switch (c) {
      case '.':
        buffer$2 = read$1();
        lexState = 'decimalPointLeading';
        return;
      case '0':
        buffer$2 = read$1();
        lexState = 'zero';
        return;
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        buffer$2 = read$1();
        lexState = 'decimalInteger';
        return;
      case 'I':
        read$1();
        literal('nfinity');
        return newToken('numeric', sign * Infinity);
      case 'N':
        read$1();
        literal('aN');
        return newToken('numeric', NaN);
    }
    throw invalidChar(read$1());
  },
  zero() {
    switch (c) {
      case '.':
        buffer$2 += read$1();
        lexState = 'decimalPoint';
        return;
      case 'e':
      case 'E':
        buffer$2 += read$1();
        lexState = 'decimalExponent';
        return;
      case 'x':
      case 'X':
        buffer$2 += read$1();
        lexState = 'hexadecimal';
        return;
    }
    return newToken('numeric', sign * 0);
  },
  decimalInteger() {
    switch (c) {
      case '.':
        buffer$2 += read$1();
        lexState = 'decimalPoint';
        return;
      case 'e':
      case 'E':
        buffer$2 += read$1();
        lexState = 'decimalExponent';
        return;
    }
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      return;
    }
    return newToken('numeric', sign * Number(buffer$2));
  },
  decimalPointLeading() {
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      lexState = 'decimalFraction';
      return;
    }
    throw invalidChar(read$1());
  },
  decimalPoint() {
    switch (c) {
      case 'e':
      case 'E':
        buffer$2 += read$1();
        lexState = 'decimalExponent';
        return;
    }
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      lexState = 'decimalFraction';
      return;
    }
    return newToken('numeric', sign * Number(buffer$2));
  },
  decimalFraction() {
    switch (c) {
      case 'e':
      case 'E':
        buffer$2 += read$1();
        lexState = 'decimalExponent';
        return;
    }
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      return;
    }
    return newToken('numeric', sign * Number(buffer$2));
  },
  decimalExponent() {
    switch (c) {
      case '+':
      case '-':
        buffer$2 += read$1();
        lexState = 'decimalExponentSign';
        return;
    }
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      lexState = 'decimalExponentInteger';
      return;
    }
    throw invalidChar(read$1());
  },
  decimalExponentSign() {
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      lexState = 'decimalExponentInteger';
      return;
    }
    throw invalidChar(read$1());
  },
  decimalExponentInteger() {
    if (util$5.isDigit(c)) {
      buffer$2 += read$1();
      return;
    }
    return newToken('numeric', sign * Number(buffer$2));
  },
  hexadecimal() {
    if (util$5.isHexDigit(c)) {
      buffer$2 += read$1();
      lexState = 'hexadecimalInteger';
      return;
    }
    throw invalidChar(read$1());
  },
  hexadecimalInteger() {
    if (util$5.isHexDigit(c)) {
      buffer$2 += read$1();
      return;
    }
    return newToken('numeric', sign * Number(buffer$2));
  },
  string() {
    switch (c) {
      case '\\':
        read$1();
        buffer$2 += escape();
        return;
      case '"':
        if (doubleQuote) {
          read$1();
          return newToken('string', buffer$2);
        }
        buffer$2 += read$1();
        return;
      case "'":
        if (!doubleQuote) {
          read$1();
          return newToken('string', buffer$2);
        }
        buffer$2 += read$1();
        return;
      case '\n':
      case '\r':
        throw invalidChar(read$1());
      case '\u2028':
      case '\u2029':
        separatorChar(c);
        break;
      case undefined:
        throw invalidChar(read$1());
    }
    buffer$2 += read$1();
  },
  start() {
    switch (c) {
      case '{':
      case '[':
        return newToken('punctuator', read$1());
    }
    lexState = 'value';
  },
  beforePropertyName() {
    switch (c) {
      case '$':
      case '_':
        buffer$2 = read$1();
        lexState = 'identifierName';
        return;
      case '\\':
        read$1();
        lexState = 'identifierNameStartEscape';
        return;
      case '}':
        return newToken('punctuator', read$1());
      case '"':
      case "'":
        doubleQuote = read$1() === '"';
        lexState = 'string';
        return;
    }
    if (util$5.isIdStartChar(c)) {
      buffer$2 += read$1();
      lexState = 'identifierName';
      return;
    }
    throw invalidChar(read$1());
  },
  afterPropertyName() {
    if (c === ':') {
      return newToken('punctuator', read$1());
    }
    throw invalidChar(read$1());
  },
  beforePropertyValue() {
    lexState = 'value';
  },
  afterPropertyValue() {
    switch (c) {
      case ',':
      case '}':
        return newToken('punctuator', read$1());
    }
    throw invalidChar(read$1());
  },
  beforeArrayValue() {
    if (c === ']') {
      return newToken('punctuator', read$1());
    }
    lexState = 'value';
  },
  afterArrayValue() {
    switch (c) {
      case ',':
      case ']':
        return newToken('punctuator', read$1());
    }
    throw invalidChar(read$1());
  },
  end() {
    throw invalidChar(read$1());
  },
};
function newToken(type, value) {
  return {type: type, value: value, line: line, column: column};
}
function literal(s) {
  for (const c of s) {
    const p = peek();
    if (p !== c) {
      throw invalidChar(read$1());
    }
    read$1();
  }
}
function escape() {
  const c = peek();
  switch (c) {
    case 'b':
      read$1();
      return '\b';
    case 'f':
      read$1();
      return '\f';
    case 'n':
      read$1();
      return '\n';
    case 'r':
      read$1();
      return '\r';
    case 't':
      read$1();
      return '\t';
    case 'v':
      read$1();
      return '\v';
    case '0':
      read$1();
      if (util$5.isDigit(peek())) {
        throw invalidChar(read$1());
      }
      return '\0';
    case 'x':
      read$1();
      return hexEscape();
    case 'u':
      read$1();
      return unicodeEscape();
    case '\n':
    case '\u2028':
    case '\u2029':
      read$1();
      return '';
    case '\r':
      read$1();
      if (peek() === '\n') {
        read$1();
      }
      return '';
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      throw invalidChar(read$1());
    case undefined:
      throw invalidChar(read$1());
  }
  return read$1();
}
function hexEscape() {
  let buffer = '';
  let c = peek();
  if (!util$5.isHexDigit(c)) {
    throw invalidChar(read$1());
  }
  buffer += read$1();
  c = peek();
  if (!util$5.isHexDigit(c)) {
    throw invalidChar(read$1());
  }
  buffer += read$1();
  return String.fromCodePoint(parseInt(buffer, 16));
}
function unicodeEscape() {
  let buffer = '';
  let count = 4;
  while (count-- > 0) {
    const c = peek();
    if (!util$5.isHexDigit(c)) {
      throw invalidChar(read$1());
    }
    buffer += read$1();
  }
  return String.fromCodePoint(parseInt(buffer, 16));
}
const parseStates = {
  start() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    push();
  },
  beforePropertyName() {
    switch (token.type) {
      case 'identifier':
      case 'string':
        key = token.value;
        parseState = 'afterPropertyName';
        return;
      case 'punctuator':
        pop();
        return;
      case 'eof':
        throw invalidEOF();
    }
  },
  afterPropertyName() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    parseState = 'beforePropertyValue';
  },
  beforePropertyValue() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    push();
  },
  beforeArrayValue() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    if (token.type === 'punctuator' && token.value === ']') {
      pop();
      return;
    }
    push();
  },
  afterPropertyValue() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    switch (token.value) {
      case ',':
        parseState = 'beforePropertyName';
        return;
      case '}':
        pop();
    }
  },
  afterArrayValue() {
    if (token.type === 'eof') {
      throw invalidEOF();
    }
    switch (token.value) {
      case ',':
        parseState = 'beforeArrayValue';
        return;
      case ']':
        pop();
    }
  },
  end() {},
};
function push() {
  let value;
  switch (token.type) {
    case 'punctuator':
      switch (token.value) {
        case '{':
          value = {};
          break;
        case '[':
          value = [];
          break;
      }
      break;
    case 'null':
    case 'boolean':
    case 'numeric':
    case 'string':
      value = token.value;
      break;
  }
  if (root === undefined) {
    root = value;
  } else {
    const parent = stack[stack.length - 1];
    if (Array.isArray(parent)) {
      parent.push(value);
    } else {
      Object.defineProperty(parent, key, {
        value: value,
        writable: true,
        enumerable: true,
        configurable: true,
      });
    }
  }
  if (value !== null && typeof value === 'object') {
    stack.push(value);
    if (Array.isArray(value)) {
      parseState = 'beforeArrayValue';
    } else {
      parseState = 'beforePropertyName';
    }
  } else {
    const current = stack[stack.length - 1];
    if (current == null) {
      parseState = 'end';
    } else if (Array.isArray(current)) {
      parseState = 'afterArrayValue';
    } else {
      parseState = 'afterPropertyValue';
    }
  }
}
function pop() {
  stack.pop();
  const current = stack[stack.length - 1];
  if (current == null) {
    parseState = 'end';
  } else if (Array.isArray(current)) {
    parseState = 'afterArrayValue';
  } else {
    parseState = 'afterPropertyValue';
  }
}
function invalidChar(c) {
  if (c === undefined) {
    return syntaxError(`JSON5: invalid end of input at ${line}:${column}`);
  }
  return syntaxError(
    `JSON5: invalid character '${formatChar(c)}' at ${line}:${column}`
  );
}
function invalidEOF() {
  return syntaxError(`JSON5: invalid end of input at ${line}:${column}`);
}
function invalidIdentifier() {
  column -= 5;
  return syntaxError(
    `JSON5: invalid identifier character at ${line}:${column}`
  );
}
function separatorChar(c) {
  console.warn(
    `JSON5: '${formatChar(c)}' in strings is not valid ECMAScript; consider escaping`
  );
}
function formatChar(c) {
  const replacements = {
    "'": "\\'",
    '"': '\\"',
    '\\': '\\\\',
    '\b': '\\b',
    '\f': '\\f',
    '\n': '\\n',
    '\r': '\\r',
    '\t': '\\t',
    '\v': '\\v',
    '\0': '\\0',
    '\u2028': '\\u2028',
    '\u2029': '\\u2029',
  };
  if (replacements[c]) {
    return replacements[c];
  }
  if (c < ' ') {
    const hexString = c.charCodeAt(0).toString(16);
    return '\\x' + ('00' + hexString).substring(hexString.length);
  }
  return c;
}
function syntaxError(message) {
  const err = new SyntaxError(message);
  err.lineNumber = line;
  err.columnNumber = column;
  return err;
}
var stringify = function stringify(value, replacer, space) {
  const stack = [];
  let indent = '';
  let propertyList;
  let replacerFunc;
  let gap = '';
  let quote;
  if (
    replacer != null &&
    typeof replacer === 'object' &&
    !Array.isArray(replacer)
  ) {
    space = replacer.space;
    quote = replacer.quote;
    replacer = replacer.replacer;
  }
  if (typeof replacer === 'function') {
    replacerFunc = replacer;
  } else if (Array.isArray(replacer)) {
    propertyList = [];
    for (const v of replacer) {
      let item;
      if (typeof v === 'string') {
        item = v;
      } else if (
        typeof v === 'number' ||
        v instanceof String ||
        v instanceof Number
      ) {
        item = String(v);
      }
      if (item !== undefined && propertyList.indexOf(item) < 0) {
        propertyList.push(item);
      }
    }
  }
  if (space instanceof Number) {
    space = Number(space);
  } else if (space instanceof String) {
    space = String(space);
  }
  if (typeof space === 'number') {
    if (space > 0) {
      space = Math.min(10, Math.floor(space));
      gap = '          '.substr(0, space);
    }
  } else if (typeof space === 'string') {
    gap = space.substr(0, 10);
  }
  return serializeProperty('', {'': value});
  function serializeProperty(key, holder) {
    let value = holder[key];
    if (value != null) {
      if (typeof value.toJSON5 === 'function') {
        value = value.toJSON5(key);
      } else if (typeof value.toJSON === 'function') {
        value = value.toJSON(key);
      }
    }
    if (replacerFunc) {
      value = replacerFunc.call(holder, key, value);
    }
    if (value instanceof Number) {
      value = Number(value);
    } else if (value instanceof String) {
      value = String(value);
    } else if (value instanceof Boolean) {
      value = value.valueOf();
    }
    switch (value) {
      case null:
        return 'null';
      case true:
        return 'true';
      case false:
        return 'false';
    }
    if (typeof value === 'string') {
      return quoteString(value);
    }
    if (typeof value === 'number') {
      return String(value);
    }
    if (typeof value === 'object') {
      return Array.isArray(value)
        ? serializeArray(value)
        : serializeObject(value);
    }
    return undefined;
  }
  function quoteString(value) {
    const quotes = {"'": 0.1, '"': 0.2};
    const replacements = {
      "'": "\\'",
      '"': '\\"',
      '\\': '\\\\',
      '\b': '\\b',
      '\f': '\\f',
      '\n': '\\n',
      '\r': '\\r',
      '\t': '\\t',
      '\v': '\\v',
      '\0': '\\0',
      '\u2028': '\\u2028',
      '\u2029': '\\u2029',
    };
    let product = '';
    for (let i = 0; i < value.length; i++) {
      const c = value[i];
      switch (c) {
        case "'":
        case '"':
          quotes[c]++;
          product += c;
          continue;
        case '\0':
          if (util$5.isDigit(value[i + 1])) {
            product += '\\x00';
            continue;
          }
      }
      if (replacements[c]) {
        product += replacements[c];
        continue;
      }
      if (c < ' ') {
        let hexString = c.charCodeAt(0).toString(16);
        product += '\\x' + ('00' + hexString).substring(hexString.length);
        continue;
      }
      product += c;
    }
    const quoteChar =
      quote ||
      Object.keys(quotes).reduce((a, b) => (quotes[a] < quotes[b] ? a : b));
    product = product.replace(
      new RegExp(quoteChar, 'g'),
      replacements[quoteChar]
    );
    return quoteChar + product + quoteChar;
  }
  function serializeObject(value) {
    if (stack.indexOf(value) >= 0) {
      throw TypeError('Converting circular structure to JSON5');
    }
    stack.push(value);
    let stepback = indent;
    indent = indent + gap;
    let keys = propertyList || Object.keys(value);
    let partial = [];
    for (const key of keys) {
      const propertyString = serializeProperty(key, value);
      if (propertyString !== undefined) {
        let member = serializeKey(key) + ':';
        if (gap !== '') {
          member += ' ';
        }
        member += propertyString;
        partial.push(member);
      }
    }
    let final;
    if (partial.length === 0) {
      final = '{}';
    } else {
      let properties;
      if (gap === '') {
        properties = partial.join(',');
        final = '{' + properties + '}';
      } else {
        let separator = ',\n' + indent;
        properties = partial.join(separator);
        final = '{\n' + indent + properties + ',\n' + stepback + '}';
      }
    }
    stack.pop();
    indent = stepback;
    return final;
  }
  function serializeKey(key) {
    if (key.length === 0) {
      return quoteString(key);
    }
    const firstChar = String.fromCodePoint(key.codePointAt(0));
    if (!util$5.isIdStartChar(firstChar)) {
      return quoteString(key);
    }
    for (let i = firstChar.length; i < key.length; i++) {
      if (!util$5.isIdContinueChar(String.fromCodePoint(key.codePointAt(i)))) {
        return quoteString(key);
      }
    }
    return key;
  }
  function serializeArray(value) {
    if (stack.indexOf(value) >= 0) {
      throw TypeError('Converting circular structure to JSON5');
    }
    stack.push(value);
    let stepback = indent;
    indent = indent + gap;
    let partial = [];
    for (let i = 0; i < value.length; i++) {
      const propertyString = serializeProperty(String(i), value);
      partial.push(propertyString !== undefined ? propertyString : 'null');
    }
    let final;
    if (partial.length === 0) {
      final = '[]';
    } else {
      if (gap === '') {
        let properties = partial.join(',');
        final = '[' + properties + ']';
      } else {
        let separator = ',\n' + indent;
        let properties = partial.join(separator);
        final = '[\n' + indent + properties + ',\n' + stepback + ']';
      }
    }
    stack.pop();
    indent = stepback;
    return final;
  }
};
const JSON5 = {parse: parse$1, stringify: stringify};
var lib = JSON5;
var dist = Object.freeze({__proto__: null, default: lib});
var require$$3$1 = getAugmentedNamespace(dist);
var homedir;
var hasRequiredHomedir;
function requireHomedir() {
  if (hasRequiredHomedir) return homedir;
  hasRequiredHomedir = 1;
  var os = require$$0$3;
  homedir =
    os.homedir ||
    function homedir() {
      var home = process.env.HOME;
      var user =
        process.env.LOGNAME ||
        process.env.USER ||
        process.env.LNAME ||
        process.env.USERNAME;
      if (process.platform === 'win32') {
        return (
          process.env.USERPROFILE ||
          process.env.HOMEDRIVE + process.env.HOMEPATH ||
          home ||
          null
        );
      }
      if (process.platform === 'darwin') {
        return home || (user ? '/Users/' + user : null);
      }
      if (process.platform === 'linux') {
        return (
          home ||
          (process.getuid() === 0 ? '/root' : user ? '/home/' + user : null)
        );
      }
      return home || null;
    };
  return homedir;
}
var caller;
var hasRequiredCaller;
function requireCaller() {
  if (hasRequiredCaller) return caller;
  hasRequiredCaller = 1;
  caller = function () {
    var origPrepareStackTrace = Error.prepareStackTrace;
    Error.prepareStackTrace = function (_, stack) {
      return stack;
    };
    var stack = new Error().stack;
    Error.prepareStackTrace = origPrepareStackTrace;
    return stack[2].getFileName();
  };
  return caller;
}
var pathParse = {exports: {}};
var hasRequiredPathParse;
function requirePathParse() {
  if (hasRequiredPathParse) return pathParse.exports;
  hasRequiredPathParse = 1;
  var isWindows = process.platform === 'win32';
  var splitWindowsRe =
    /^(((?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?[\\\/]?)(?:[^\\\/]*[\\\/])*)((\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))[\\\/]*$/;
  var win32 = {};
  function win32SplitPath(filename) {
    return splitWindowsRe.exec(filename).slice(1);
  }
  win32.parse = function (pathString) {
    if (typeof pathString !== 'string') {
      throw new TypeError(
        "Parameter 'pathString' must be a string, not " + typeof pathString
      );
    }
    var allParts = win32SplitPath(pathString);
    if (!allParts || allParts.length !== 5) {
      throw new TypeError("Invalid path '" + pathString + "'");
    }
    return {
      root: allParts[1],
      dir: allParts[0] === allParts[1] ? allParts[0] : allParts[0].slice(0, -1),
      base: allParts[2],
      ext: allParts[4],
      name: allParts[3],
    };
  };
  var splitPathRe =
    /^((\/?)(?:[^\/]*\/)*)((\.{1,2}|[^\/]+?|)(\.[^.\/]*|))[\/]*$/;
  var posix = {};
  function posixSplitPath(filename) {
    return splitPathRe.exec(filename).slice(1);
  }
  posix.parse = function (pathString) {
    if (typeof pathString !== 'string') {
      throw new TypeError(
        "Parameter 'pathString' must be a string, not " + typeof pathString
      );
    }
    var allParts = posixSplitPath(pathString);
    if (!allParts || allParts.length !== 5) {
      throw new TypeError("Invalid path '" + pathString + "'");
    }
    return {
      root: allParts[1],
      dir: allParts[0].slice(0, -1),
      base: allParts[2],
      ext: allParts[4],
      name: allParts[3],
    };
  };
  if (isWindows) pathParse.exports = win32.parse;
  else pathParse.exports = posix.parse;
  pathParse.exports.posix = posix.parse;
  pathParse.exports.win32 = win32.parse;
  return pathParse.exports;
}
var nodeModulesPaths;
var hasRequiredNodeModulesPaths;
function requireNodeModulesPaths() {
  if (hasRequiredNodeModulesPaths) return nodeModulesPaths;
  hasRequiredNodeModulesPaths = 1;
  var path = require$$0$5;
  var parse = path.parse || requirePathParse();
  var getNodeModulesDirs = function getNodeModulesDirs(absoluteStart, modules) {
    var prefix = '/';
    if (/^([A-Za-z]:)/.test(absoluteStart)) {
      prefix = '';
    } else if (/^\\\\/.test(absoluteStart)) {
      prefix = '\\\\';
    }
    var paths = [absoluteStart];
    var parsed = parse(absoluteStart);
    while (parsed.dir !== paths[paths.length - 1]) {
      paths.push(parsed.dir);
      parsed = parse(parsed.dir);
    }
    return paths.reduce(function (dirs, aPath) {
      return dirs.concat(
        modules.map(function (moduleDir) {
          return path.resolve(prefix, aPath, moduleDir);
        })
      );
    }, []);
  };
  nodeModulesPaths = function nodeModulesPaths(start, opts, request) {
    var modules =
      opts && opts.moduleDirectory
        ? [].concat(opts.moduleDirectory)
        : ['node_modules'];
    if (opts && typeof opts.paths === 'function') {
      return opts.paths(
        request,
        start,
        function () {
          return getNodeModulesDirs(start, modules);
        },
        opts
      );
    }
    var dirs = getNodeModulesDirs(start, modules);
    return opts && opts.paths ? dirs.concat(opts.paths) : dirs;
  };
  return nodeModulesPaths;
}
var normalizeOptions$1;
var hasRequiredNormalizeOptions;
function requireNormalizeOptions() {
  if (hasRequiredNormalizeOptions) return normalizeOptions$1;
  hasRequiredNormalizeOptions = 1;
  normalizeOptions$1 = function (x, opts) {
    return opts || {};
  };
  return normalizeOptions$1;
}
var implementation;
var hasRequiredImplementation;
function requireImplementation() {
  if (hasRequiredImplementation) return implementation;
  hasRequiredImplementation = 1;
  var ERROR_MESSAGE = 'Function.prototype.bind called on incompatible ';
  var slice = Array.prototype.slice;
  var toStr = Object.prototype.toString;
  var funcType = '[object Function]';
  implementation = function bind(that) {
    var target = this;
    if (typeof target !== 'function' || toStr.call(target) !== funcType) {
      throw new TypeError(ERROR_MESSAGE + target);
    }
    var args = slice.call(arguments, 1);
    var bound;
    var binder = function () {
      if (this instanceof bound) {
        var result = target.apply(this, args.concat(slice.call(arguments)));
        if (Object(result) === result) {
          return result;
        }
        return this;
      } else {
        return target.apply(that, args.concat(slice.call(arguments)));
      }
    };
    var boundLength = Math.max(0, target.length - args.length);
    var boundArgs = [];
    for (var i = 0; i < boundLength; i++) {
      boundArgs.push('$' + i);
    }
    bound = Function(
      'binder',
      'return function (' +
        boundArgs.join(',') +
        '){ return binder.apply(this,arguments); }'
    )(binder);
    if (target.prototype) {
      var Empty = function Empty() {};
      Empty.prototype = target.prototype;
      bound.prototype = new Empty();
      Empty.prototype = null;
    }
    return bound;
  };
  return implementation;
}
var functionBind;
var hasRequiredFunctionBind;
function requireFunctionBind() {
  if (hasRequiredFunctionBind) return functionBind;
  hasRequiredFunctionBind = 1;
  var implementation = requireImplementation();
  functionBind = Function.prototype.bind || implementation;
  return functionBind;
}
var src;
var hasRequiredSrc;
function requireSrc() {
  if (hasRequiredSrc) return src;
  hasRequiredSrc = 1;
  var bind = requireFunctionBind();
  src = bind.call(Function.call, Object.prototype.hasOwnProperty);
  return src;
}
var assert$1 = true;
var async_hooks$1 = '>= 8';
var buffer_ieee754$1 = '>= 0.5 && < 0.9.7';
var buffer$1 = true;
var child_process$1 = true;
var cluster$1 = '>= 0.5';
var console$2 = true;
var constants$1 = true;
var crypto$1 = true;
var _debug_agent$1 = '>= 1 && < 8';
var _debugger$1 = '< 8';
var dgram$1 = true;
var diagnostics_channel$1 = ['>= 14.17 && < 15', '>= 15.1'];
var dns$1 = true;
var domain$1 = '>= 0.7.12';
var events$1 = true;
var freelist$1 = '< 6';
var fs$1 = true;
var _http_agent$1 = '>= 0.11.1';
var _http_client$1 = '>= 0.11.1';
var _http_common$1 = '>= 0.11.1';
var _http_incoming$1 = '>= 0.11.1';
var _http_outgoing$1 = '>= 0.11.1';
var _http_server$1 = '>= 0.11.1';
var http$1 = true;
var http2$1 = '>= 8.8';
var https$1 = true;
var inspector$1 = '>= 8';
var _linklist$1 = '< 8';
var module$2 = true;
var net$1 = true;
var os$2 = true;
var path$1 = true;
var perf_hooks$1 = '>= 8.5';
var process$3 = '>= 1';
var punycode$1 = '>= 0.5';
var querystring$1 = true;
var readline$1 = true;
var repl$1 = true;
var smalloc$1 = '>= 0.11.5 && < 3';
var _stream_duplex$1 = '>= 0.9.4';
var _stream_transform$1 = '>= 0.9.4';
var _stream_wrap$1 = '>= 1.4.1';
var _stream_passthrough$1 = '>= 0.9.4';
var _stream_readable$1 = '>= 0.9.4';
var _stream_writable$1 = '>= 0.9.4';
var stream$1 = true;
var string_decoder$1 = true;
var sys$1 = ['>= 0.4 && < 0.7', '>= 0.8'];
var timers$1 = true;
var _tls_common$1 = '>= 0.11.13';
var _tls_legacy$1 = '>= 0.11.3 && < 10';
var _tls_wrap$1 = '>= 0.11.3';
var tls$1 = true;
var trace_events$1 = '>= 10';
var tty$2 = true;
var url$1 = true;
var util$4 = true;
var v8$1 = '>= 1';
var vm$1 = true;
var wasi$1 = '>= 13.4 && < 13.5';
var worker_threads$1 = '>= 11.7';
var zlib$1 = '>= 0.5';
var require$$1 = {
  assert: assert$1,
  'node:assert': ['>= 14.18 && < 15', '>= 16'],
  'assert/strict': '>= 15',
  'node:assert/strict': '>= 16',
  async_hooks: async_hooks$1,
  'node:async_hooks': ['>= 14.18 && < 15', '>= 16'],
  buffer_ieee754: buffer_ieee754$1,
  buffer: buffer$1,
  'node:buffer': ['>= 14.18 && < 15', '>= 16'],
  child_process: child_process$1,
  'node:child_process': ['>= 14.18 && < 15', '>= 16'],
  cluster: cluster$1,
  'node:cluster': ['>= 14.18 && < 15', '>= 16'],
  console: console$2,
  'node:console': ['>= 14.18 && < 15', '>= 16'],
  constants: constants$1,
  'node:constants': ['>= 14.18 && < 15', '>= 16'],
  crypto: crypto$1,
  'node:crypto': ['>= 14.18 && < 15', '>= 16'],
  _debug_agent: _debug_agent$1,
  _debugger: _debugger$1,
  dgram: dgram$1,
  'node:dgram': ['>= 14.18 && < 15', '>= 16'],
  diagnostics_channel: diagnostics_channel$1,
  'node:diagnostics_channel': ['>= 14.18 && < 15', '>= 16'],
  dns: dns$1,
  'node:dns': ['>= 14.18 && < 15', '>= 16'],
  'dns/promises': '>= 15',
  'node:dns/promises': '>= 16',
  domain: domain$1,
  'node:domain': ['>= 14.18 && < 15', '>= 16'],
  events: events$1,
  'node:events': ['>= 14.18 && < 15', '>= 16'],
  freelist: freelist$1,
  fs: fs$1,
  'node:fs': ['>= 14.18 && < 15', '>= 16'],
  'fs/promises': ['>= 10 && < 10.1', '>= 14'],
  'node:fs/promises': ['>= 14.18 && < 15', '>= 16'],
  _http_agent: _http_agent$1,
  'node:_http_agent': ['>= 14.18 && < 15', '>= 16'],
  _http_client: _http_client$1,
  'node:_http_client': ['>= 14.18 && < 15', '>= 16'],
  _http_common: _http_common$1,
  'node:_http_common': ['>= 14.18 && < 15', '>= 16'],
  _http_incoming: _http_incoming$1,
  'node:_http_incoming': ['>= 14.18 && < 15', '>= 16'],
  _http_outgoing: _http_outgoing$1,
  'node:_http_outgoing': ['>= 14.18 && < 15', '>= 16'],
  _http_server: _http_server$1,
  'node:_http_server': ['>= 14.18 && < 15', '>= 16'],
  http: http$1,
  'node:http': ['>= 14.18 && < 15', '>= 16'],
  http2: http2$1,
  'node:http2': ['>= 14.18 && < 15', '>= 16'],
  https: https$1,
  'node:https': ['>= 14.18 && < 15', '>= 16'],
  inspector: inspector$1,
  'node:inspector': ['>= 14.18 && < 15', '>= 16'],
  _linklist: _linklist$1,
  module: module$2,
  'node:module': ['>= 14.18 && < 15', '>= 16'],
  net: net$1,
  'node:net': ['>= 14.18 && < 15', '>= 16'],
  'node-inspect/lib/_inspect': '>= 7.6 && < 12',
  'node-inspect/lib/internal/inspect_client': '>= 7.6 && < 12',
  'node-inspect/lib/internal/inspect_repl': '>= 7.6 && < 12',
  os: os$2,
  'node:os': ['>= 14.18 && < 15', '>= 16'],
  path: path$1,
  'node:path': ['>= 14.18 && < 15', '>= 16'],
  'path/posix': '>= 15.3',
  'node:path/posix': '>= 16',
  'path/win32': '>= 15.3',
  'node:path/win32': '>= 16',
  perf_hooks: perf_hooks$1,
  'node:perf_hooks': ['>= 14.18 && < 15', '>= 16'],
  process: process$3,
  'node:process': ['>= 14.18 && < 15', '>= 16'],
  punycode: punycode$1,
  'node:punycode': ['>= 14.18 && < 15', '>= 16'],
  querystring: querystring$1,
  'node:querystring': ['>= 14.18 && < 15', '>= 16'],
  readline: readline$1,
  'node:readline': ['>= 14.18 && < 15', '>= 16'],
  'readline/promises': '>= 17',
  'node:readline/promises': '>= 17',
  repl: repl$1,
  'node:repl': ['>= 14.18 && < 15', '>= 16'],
  smalloc: smalloc$1,
  _stream_duplex: _stream_duplex$1,
  'node:_stream_duplex': ['>= 14.18 && < 15', '>= 16'],
  _stream_transform: _stream_transform$1,
  'node:_stream_transform': ['>= 14.18 && < 15', '>= 16'],
  _stream_wrap: _stream_wrap$1,
  'node:_stream_wrap': ['>= 14.18 && < 15', '>= 16'],
  _stream_passthrough: _stream_passthrough$1,
  'node:_stream_passthrough': ['>= 14.18 && < 15', '>= 16'],
  _stream_readable: _stream_readable$1,
  'node:_stream_readable': ['>= 14.18 && < 15', '>= 16'],
  _stream_writable: _stream_writable$1,
  'node:_stream_writable': ['>= 14.18 && < 15', '>= 16'],
  stream: stream$1,
  'node:stream': ['>= 14.18 && < 15', '>= 16'],
  'stream/consumers': '>= 16.7',
  'node:stream/consumers': '>= 16.7',
  'stream/promises': '>= 15',
  'node:stream/promises': '>= 16',
  'stream/web': '>= 16.5',
  'node:stream/web': '>= 16.5',
  string_decoder: string_decoder$1,
  'node:string_decoder': ['>= 14.18 && < 15', '>= 16'],
  sys: sys$1,
  'node:sys': ['>= 14.18 && < 15', '>= 16'],
  'node:test': ['>= 16.17 && < 17', '>= 18'],
  timers: timers$1,
  'node:timers': ['>= 14.18 && < 15', '>= 16'],
  'timers/promises': '>= 15',
  'node:timers/promises': '>= 16',
  _tls_common: _tls_common$1,
  'node:_tls_common': ['>= 14.18 && < 15', '>= 16'],
  _tls_legacy: _tls_legacy$1,
  _tls_wrap: _tls_wrap$1,
  'node:_tls_wrap': ['>= 14.18 && < 15', '>= 16'],
  tls: tls$1,
  'node:tls': ['>= 14.18 && < 15', '>= 16'],
  trace_events: trace_events$1,
  'node:trace_events': ['>= 14.18 && < 15', '>= 16'],
  tty: tty$2,
  'node:tty': ['>= 14.18 && < 15', '>= 16'],
  url: url$1,
  'node:url': ['>= 14.18 && < 15', '>= 16'],
  util: util$4,
  'node:util': ['>= 14.18 && < 15', '>= 16'],
  'util/types': '>= 15.3',
  'node:util/types': '>= 16',
  'v8/tools/arguments': '>= 10 && < 12',
  'v8/tools/codemap': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/consarray': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/csvparser': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/logreader': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/profile_view': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/splaytree': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  v8: v8$1,
  'node:v8': ['>= 14.18 && < 15', '>= 16'],
  vm: vm$1,
  'node:vm': ['>= 14.18 && < 15', '>= 16'],
  wasi: wasi$1,
  worker_threads: worker_threads$1,
  'node:worker_threads': ['>= 14.18 && < 15', '>= 16'],
  zlib: zlib$1,
  'node:zlib': ['>= 14.18 && < 15', '>= 16'],
};
var isCoreModule;
var hasRequiredIsCoreModule;
function requireIsCoreModule() {
  if (hasRequiredIsCoreModule) return isCoreModule;
  hasRequiredIsCoreModule = 1;
  var has = requireSrc();
  function specifierIncluded(current, specifier) {
    var nodeParts = current.split('.');
    var parts = specifier.split(' ');
    var op = parts.length > 1 ? parts[0] : '=';
    var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split('.');
    for (var i = 0; i < 3; ++i) {
      var cur = parseInt(nodeParts[i] || 0, 10);
      var ver = parseInt(versionParts[i] || 0, 10);
      if (cur === ver) {
        continue;
      }
      if (op === '<') {
        return cur < ver;
      }
      if (op === '>=') {
        return cur >= ver;
      }
      return false;
    }
    return op === '>=';
  }
  function matchesRange(current, range) {
    var specifiers = range.split(/ ?&& ?/);
    if (specifiers.length === 0) {
      return false;
    }
    for (var i = 0; i < specifiers.length; ++i) {
      if (!specifierIncluded(current, specifiers[i])) {
        return false;
      }
    }
    return true;
  }
  function versionIncluded(nodeVersion, specifierValue) {
    if (typeof specifierValue === 'boolean') {
      return specifierValue;
    }
    var current =
      typeof nodeVersion === 'undefined'
        ? process.versions && process.versions.node
        : nodeVersion;
    if (typeof current !== 'string') {
      throw new TypeError(
        typeof nodeVersion === 'undefined'
          ? 'Unable to determine current node version'
          : 'If provided, a valid node version is required'
      );
    }
    if (specifierValue && typeof specifierValue === 'object') {
      for (var i = 0; i < specifierValue.length; ++i) {
        if (matchesRange(current, specifierValue[i])) {
          return true;
        }
      }
      return false;
    }
    return matchesRange(current, specifierValue);
  }
  var data = require$$1;
  isCoreModule = function isCore(x, nodeVersion) {
    return has(data, x) && versionIncluded(nodeVersion, data[x]);
  };
  return isCoreModule;
}
var async;
var hasRequiredAsync;
function requireAsync() {
  if (hasRequiredAsync) return async;
  hasRequiredAsync = 1;
  var fs = require$$0$4;
  var getHomedir = requireHomedir();
  var path = require$$0$5;
  var caller = requireCaller();
  var nodeModulesPaths = requireNodeModulesPaths();
  var normalizeOptions = requireNormalizeOptions();
  var isCore = requireIsCoreModule();
  var realpathFS =
    process.platform !== 'win32' &&
    fs.realpath &&
    typeof fs.realpath.native === 'function'
      ? fs.realpath.native
      : fs.realpath;
  var homedir = getHomedir();
  var defaultPaths = function () {
    return [
      path.join(homedir, '.node_modules'),
      path.join(homedir, '.node_libraries'),
    ];
  };
  var defaultIsFile = function isFile(file, cb) {
    fs.stat(file, function (err, stat) {
      if (!err) {
        return cb(null, stat.isFile() || stat.isFIFO());
      }
      if (err.code === 'ENOENT' || err.code === 'ENOTDIR')
        return cb(null, false);
      return cb(err);
    });
  };
  var defaultIsDir = function isDirectory(dir, cb) {
    fs.stat(dir, function (err, stat) {
      if (!err) {
        return cb(null, stat.isDirectory());
      }
      if (err.code === 'ENOENT' || err.code === 'ENOTDIR')
        return cb(null, false);
      return cb(err);
    });
  };
  var defaultRealpath = function realpath(x, cb) {
    realpathFS(x, function (realpathErr, realPath) {
      if (realpathErr && realpathErr.code !== 'ENOENT') cb(realpathErr);
      else cb(null, realpathErr ? x : realPath);
    });
  };
  var maybeRealpath = function maybeRealpath(realpath, x, opts, cb) {
    if (opts && opts.preserveSymlinks === false) {
      realpath(x, cb);
    } else {
      cb(null, x);
    }
  };
  var defaultReadPackage = function defaultReadPackage(readFile, pkgfile, cb) {
    readFile(pkgfile, function (readFileErr, body) {
      if (readFileErr) cb(readFileErr);
      else {
        try {
          var pkg = JSON.parse(body);
          cb(null, pkg);
        } catch (jsonErr) {
          cb(null);
        }
      }
    });
  };
  var getPackageCandidates = function getPackageCandidates(x, start, opts) {
    var dirs = nodeModulesPaths(start, opts, x);
    for (var i = 0; i < dirs.length; i++) {
      dirs[i] = path.join(dirs[i], x);
    }
    return dirs;
  };
  async = function resolve(x, options, callback) {
    var cb = callback;
    var opts = options;
    if (typeof options === 'function') {
      cb = opts;
      opts = {};
    }
    if (typeof x !== 'string') {
      var err = new TypeError('Path must be a string.');
      return process.nextTick(function () {
        cb(err);
      });
    }
    opts = normalizeOptions(x, opts);
    var isFile = opts.isFile || defaultIsFile;
    var isDirectory = opts.isDirectory || defaultIsDir;
    var readFile = opts.readFile || fs.readFile;
    var realpath = opts.realpath || defaultRealpath;
    var readPackage = opts.readPackage || defaultReadPackage;
    if (opts.readFile && opts.readPackage) {
      var conflictErr = new TypeError(
        '`readFile` and `readPackage` are mutually exclusive.'
      );
      return process.nextTick(function () {
        cb(conflictErr);
      });
    }
    var packageIterator = opts.packageIterator;
    var extensions = opts.extensions || ['.js'];
    var includeCoreModules = opts.includeCoreModules !== false;
    var basedir = opts.basedir || path.dirname(caller());
    var parent = opts.filename || basedir;
    opts.paths = opts.paths || defaultPaths();
    var absoluteStart = path.resolve(basedir);
    maybeRealpath(realpath, absoluteStart, opts, function (err, realStart) {
      if (err) cb(err);
      else init(realStart);
    });
    var res;
    function init(basedir) {
      if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x)) {
        res = path.resolve(basedir, x);
        if (x === '.' || x === '..' || x.slice(-1) === '/') res += '/';
        if (/\/$/.test(x) && res === basedir) {
          loadAsDirectory(res, opts.package, onfile);
        } else loadAsFile(res, opts.package, onfile);
      } else if (includeCoreModules && isCore(x)) {
        return cb(null, x);
      } else
        loadNodeModules(x, basedir, function (err, n, pkg) {
          if (err) cb(err);
          else if (n) {
            return maybeRealpath(realpath, n, opts, function (err, realN) {
              if (err) {
                cb(err);
              } else {
                cb(null, realN, pkg);
              }
            });
          } else {
            var moduleError = new Error(
              "Cannot find module '" + x + "' from '" + parent + "'"
            );
            moduleError.code = 'MODULE_NOT_FOUND';
            cb(moduleError);
          }
        });
    }
    function onfile(err, m, pkg) {
      if (err) cb(err);
      else if (m) cb(null, m, pkg);
      else
        loadAsDirectory(res, function (err, d, pkg) {
          if (err) cb(err);
          else if (d) {
            maybeRealpath(realpath, d, opts, function (err, realD) {
              if (err) {
                cb(err);
              } else {
                cb(null, realD, pkg);
              }
            });
          } else {
            var moduleError = new Error(
              "Cannot find module '" + x + "' from '" + parent + "'"
            );
            moduleError.code = 'MODULE_NOT_FOUND';
            cb(moduleError);
          }
        });
    }
    function loadAsFile(x, thePackage, callback) {
      var loadAsFilePackage = thePackage;
      var cb = callback;
      if (typeof loadAsFilePackage === 'function') {
        cb = loadAsFilePackage;
        loadAsFilePackage = undefined;
      }
      var exts = [''].concat(extensions);
      load(exts, x, loadAsFilePackage);
      function load(exts, x, loadPackage) {
        if (exts.length === 0) return cb(null, undefined, loadPackage);
        var file = x + exts[0];
        var pkg = loadPackage;
        if (pkg) onpkg(null, pkg);
        else loadpkg(path.dirname(file), onpkg);
        function onpkg(err, pkg_, dir) {
          pkg = pkg_;
          if (err) return cb(err);
          if (dir && pkg && opts.pathFilter) {
            var rfile = path.relative(dir, file);
            var rel = rfile.slice(0, rfile.length - exts[0].length);
            var r = opts.pathFilter(pkg, x, rel);
            if (r)
              return load(
                [''].concat(extensions.slice()),
                path.resolve(dir, r),
                pkg
              );
          }
          isFile(file, onex);
        }
        function onex(err, ex) {
          if (err) return cb(err);
          if (ex) return cb(null, file, pkg);
          load(exts.slice(1), x, pkg);
        }
      }
    }
    function loadpkg(dir, cb) {
      if (dir === '' || dir === '/') return cb(null);
      if (process.platform === 'win32' && /^\w:[/\\]*$/.test(dir)) {
        return cb(null);
      }
      if (/[/\\]node_modules[/\\]*$/.test(dir)) return cb(null);
      maybeRealpath(realpath, dir, opts, function (unwrapErr, pkgdir) {
        if (unwrapErr) return loadpkg(path.dirname(dir), cb);
        var pkgfile = path.join(pkgdir, 'package.json');
        isFile(pkgfile, function (err, ex) {
          if (!ex) return loadpkg(path.dirname(dir), cb);
          readPackage(readFile, pkgfile, function (err, pkgParam) {
            if (err) cb(err);
            var pkg = pkgParam;
            if (pkg && opts.packageFilter) {
              pkg = opts.packageFilter(pkg, pkgfile);
            }
            cb(null, pkg, dir);
          });
        });
      });
    }
    function loadAsDirectory(x, loadAsDirectoryPackage, callback) {
      var cb = callback;
      var fpkg = loadAsDirectoryPackage;
      if (typeof fpkg === 'function') {
        cb = fpkg;
        fpkg = opts.package;
      }
      maybeRealpath(realpath, x, opts, function (unwrapErr, pkgdir) {
        if (unwrapErr) return cb(unwrapErr);
        var pkgfile = path.join(pkgdir, 'package.json');
        isFile(pkgfile, function (err, ex) {
          if (err) return cb(err);
          if (!ex) return loadAsFile(path.join(x, 'index'), fpkg, cb);
          readPackage(readFile, pkgfile, function (err, pkgParam) {
            if (err) return cb(err);
            var pkg = pkgParam;
            if (pkg && opts.packageFilter) {
              pkg = opts.packageFilter(pkg, pkgfile);
            }
            if (pkg && pkg.main) {
              if (typeof pkg.main !== 'string') {
                var mainError = new TypeError(
                  'package “' + pkg.name + '” `main` must be a string'
                );
                mainError.code = 'INVALID_PACKAGE_MAIN';
                return cb(mainError);
              }
              if (pkg.main === '.' || pkg.main === './') {
                pkg.main = 'index';
              }
              loadAsFile(
                path.resolve(x, pkg.main),
                pkg,
                function (err, m, pkg) {
                  if (err) return cb(err);
                  if (m) return cb(null, m, pkg);
                  if (!pkg) return loadAsFile(path.join(x, 'index'), pkg, cb);
                  var dir = path.resolve(x, pkg.main);
                  loadAsDirectory(dir, pkg, function (err, n, pkg) {
                    if (err) return cb(err);
                    if (n) return cb(null, n, pkg);
                    loadAsFile(path.join(x, 'index'), pkg, cb);
                  });
                }
              );
              return;
            }
            loadAsFile(path.join(x, '/index'), pkg, cb);
          });
        });
      });
    }
    function processDirs(cb, dirs) {
      if (dirs.length === 0) return cb(null, undefined);
      var dir = dirs[0];
      isDirectory(path.dirname(dir), isdir);
      function isdir(err, isdir) {
        if (err) return cb(err);
        if (!isdir) return processDirs(cb, dirs.slice(1));
        loadAsFile(dir, opts.package, onfile);
      }
      function onfile(err, m, pkg) {
        if (err) return cb(err);
        if (m) return cb(null, m, pkg);
        loadAsDirectory(dir, opts.package, ondir);
      }
      function ondir(err, n, pkg) {
        if (err) return cb(err);
        if (n) return cb(null, n, pkg);
        processDirs(cb, dirs.slice(1));
      }
    }
    function loadNodeModules(x, start, cb) {
      var thunk = function () {
        return getPackageCandidates(x, start, opts);
      };
      processDirs(
        cb,
        packageIterator ? packageIterator(x, start, thunk, opts) : thunk()
      );
    }
  };
  return async;
}
var assert = true;
var async_hooks = '>= 8';
var buffer_ieee754 = '>= 0.5 && < 0.9.7';
var buffer = true;
var child_process = true;
var cluster = '>= 0.5';
var console$1 = true;
var constants = true;
var crypto = true;
var _debug_agent = '>= 1 && < 8';
var _debugger = '< 8';
var dgram = true;
var diagnostics_channel = ['>= 14.17 && < 15', '>= 15.1'];
var dns = true;
var domain = '>= 0.7.12';
var events = true;
var freelist = '< 6';
var fs = true;
var _http_agent = '>= 0.11.1';
var _http_client = '>= 0.11.1';
var _http_common = '>= 0.11.1';
var _http_incoming = '>= 0.11.1';
var _http_outgoing = '>= 0.11.1';
var _http_server = '>= 0.11.1';
var http = true;
var http2 = '>= 8.8';
var https = true;
var inspector = '>= 8';
var _linklist = '< 8';
var module$1 = true;
var net = true;
var os$1 = true;
var path = true;
var perf_hooks = '>= 8.5';
var process$2 = '>= 1';
var punycode = '>= 0.5';
var querystring = true;
var readline = true;
var repl = true;
var smalloc = '>= 0.11.5 && < 3';
var _stream_duplex = '>= 0.9.4';
var _stream_transform = '>= 0.9.4';
var _stream_wrap = '>= 1.4.1';
var _stream_passthrough = '>= 0.9.4';
var _stream_readable = '>= 0.9.4';
var _stream_writable = '>= 0.9.4';
var stream = true;
var string_decoder = true;
var sys = ['>= 0.4 && < 0.7', '>= 0.8'];
var timers = true;
var _tls_common = '>= 0.11.13';
var _tls_legacy = '>= 0.11.3 && < 10';
var _tls_wrap = '>= 0.11.3';
var tls = true;
var trace_events = '>= 10';
var tty$1 = true;
var url = true;
var util$3 = true;
var v8 = '>= 1';
var vm = true;
var wasi = '>= 13.4 && < 13.5';
var worker_threads = '>= 11.7';
var zlib = '>= 0.5';
var require$$0 = {
  assert: assert,
  'node:assert': ['>= 14.18 && < 15', '>= 16'],
  'assert/strict': '>= 15',
  'node:assert/strict': '>= 16',
  async_hooks: async_hooks,
  'node:async_hooks': ['>= 14.18 && < 15', '>= 16'],
  buffer_ieee754: buffer_ieee754,
  buffer: buffer,
  'node:buffer': ['>= 14.18 && < 15', '>= 16'],
  child_process: child_process,
  'node:child_process': ['>= 14.18 && < 15', '>= 16'],
  cluster: cluster,
  'node:cluster': ['>= 14.18 && < 15', '>= 16'],
  console: console$1,
  'node:console': ['>= 14.18 && < 15', '>= 16'],
  constants: constants,
  'node:constants': ['>= 14.18 && < 15', '>= 16'],
  crypto: crypto,
  'node:crypto': ['>= 14.18 && < 15', '>= 16'],
  _debug_agent: _debug_agent,
  _debugger: _debugger,
  dgram: dgram,
  'node:dgram': ['>= 14.18 && < 15', '>= 16'],
  diagnostics_channel: diagnostics_channel,
  'node:diagnostics_channel': ['>= 14.18 && < 15', '>= 16'],
  dns: dns,
  'node:dns': ['>= 14.18 && < 15', '>= 16'],
  'dns/promises': '>= 15',
  'node:dns/promises': '>= 16',
  domain: domain,
  'node:domain': ['>= 14.18 && < 15', '>= 16'],
  events: events,
  'node:events': ['>= 14.18 && < 15', '>= 16'],
  freelist: freelist,
  fs: fs,
  'node:fs': ['>= 14.18 && < 15', '>= 16'],
  'fs/promises': ['>= 10 && < 10.1', '>= 14'],
  'node:fs/promises': ['>= 14.18 && < 15', '>= 16'],
  _http_agent: _http_agent,
  'node:_http_agent': ['>= 14.18 && < 15', '>= 16'],
  _http_client: _http_client,
  'node:_http_client': ['>= 14.18 && < 15', '>= 16'],
  _http_common: _http_common,
  'node:_http_common': ['>= 14.18 && < 15', '>= 16'],
  _http_incoming: _http_incoming,
  'node:_http_incoming': ['>= 14.18 && < 15', '>= 16'],
  _http_outgoing: _http_outgoing,
  'node:_http_outgoing': ['>= 14.18 && < 15', '>= 16'],
  _http_server: _http_server,
  'node:_http_server': ['>= 14.18 && < 15', '>= 16'],
  http: http,
  'node:http': ['>= 14.18 && < 15', '>= 16'],
  http2: http2,
  'node:http2': ['>= 14.18 && < 15', '>= 16'],
  https: https,
  'node:https': ['>= 14.18 && < 15', '>= 16'],
  inspector: inspector,
  'node:inspector': ['>= 14.18 && < 15', '>= 16'],
  _linklist: _linklist,
  module: module$1,
  'node:module': ['>= 14.18 && < 15', '>= 16'],
  net: net,
  'node:net': ['>= 14.18 && < 15', '>= 16'],
  'node-inspect/lib/_inspect': '>= 7.6 && < 12',
  'node-inspect/lib/internal/inspect_client': '>= 7.6 && < 12',
  'node-inspect/lib/internal/inspect_repl': '>= 7.6 && < 12',
  os: os$1,
  'node:os': ['>= 14.18 && < 15', '>= 16'],
  path: path,
  'node:path': ['>= 14.18 && < 15', '>= 16'],
  'path/posix': '>= 15.3',
  'node:path/posix': '>= 16',
  'path/win32': '>= 15.3',
  'node:path/win32': '>= 16',
  perf_hooks: perf_hooks,
  'node:perf_hooks': ['>= 14.18 && < 15', '>= 16'],
  process: process$2,
  'node:process': ['>= 14.18 && < 15', '>= 16'],
  punycode: punycode,
  'node:punycode': ['>= 14.18 && < 15', '>= 16'],
  querystring: querystring,
  'node:querystring': ['>= 14.18 && < 15', '>= 16'],
  readline: readline,
  'node:readline': ['>= 14.18 && < 15', '>= 16'],
  'readline/promises': '>= 17',
  'node:readline/promises': '>= 17',
  repl: repl,
  'node:repl': ['>= 14.18 && < 15', '>= 16'],
  smalloc: smalloc,
  _stream_duplex: _stream_duplex,
  'node:_stream_duplex': ['>= 14.18 && < 15', '>= 16'],
  _stream_transform: _stream_transform,
  'node:_stream_transform': ['>= 14.18 && < 15', '>= 16'],
  _stream_wrap: _stream_wrap,
  'node:_stream_wrap': ['>= 14.18 && < 15', '>= 16'],
  _stream_passthrough: _stream_passthrough,
  'node:_stream_passthrough': ['>= 14.18 && < 15', '>= 16'],
  _stream_readable: _stream_readable,
  'node:_stream_readable': ['>= 14.18 && < 15', '>= 16'],
  _stream_writable: _stream_writable,
  'node:_stream_writable': ['>= 14.18 && < 15', '>= 16'],
  stream: stream,
  'node:stream': ['>= 14.18 && < 15', '>= 16'],
  'stream/consumers': '>= 16.7',
  'node:stream/consumers': '>= 16.7',
  'stream/promises': '>= 15',
  'node:stream/promises': '>= 16',
  'stream/web': '>= 16.5',
  'node:stream/web': '>= 16.5',
  string_decoder: string_decoder,
  'node:string_decoder': ['>= 14.18 && < 15', '>= 16'],
  sys: sys,
  'node:sys': ['>= 14.18 && < 15', '>= 16'],
  'node:test': '>= 18',
  timers: timers,
  'node:timers': ['>= 14.18 && < 15', '>= 16'],
  'timers/promises': '>= 15',
  'node:timers/promises': '>= 16',
  _tls_common: _tls_common,
  'node:_tls_common': ['>= 14.18 && < 15', '>= 16'],
  _tls_legacy: _tls_legacy,
  _tls_wrap: _tls_wrap,
  'node:_tls_wrap': ['>= 14.18 && < 15', '>= 16'],
  tls: tls,
  'node:tls': ['>= 14.18 && < 15', '>= 16'],
  trace_events: trace_events,
  'node:trace_events': ['>= 14.18 && < 15', '>= 16'],
  tty: tty$1,
  'node:tty': ['>= 14.18 && < 15', '>= 16'],
  url: url,
  'node:url': ['>= 14.18 && < 15', '>= 16'],
  util: util$3,
  'node:util': ['>= 14.18 && < 15', '>= 16'],
  'util/types': '>= 15.3',
  'node:util/types': '>= 16',
  'v8/tools/arguments': '>= 10 && < 12',
  'v8/tools/codemap': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/consarray': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/csvparser': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/logreader': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/profile_view': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  'v8/tools/splaytree': ['>= 4.4 && < 5', '>= 5.2 && < 12'],
  v8: v8,
  'node:v8': ['>= 14.18 && < 15', '>= 16'],
  vm: vm,
  'node:vm': ['>= 14.18 && < 15', '>= 16'],
  wasi: wasi,
  worker_threads: worker_threads,
  'node:worker_threads': ['>= 14.18 && < 15', '>= 16'],
  zlib: zlib,
  'node:zlib': ['>= 14.18 && < 15', '>= 16'],
};
var core_1;
var hasRequiredCore;
function requireCore() {
  if (hasRequiredCore) return core_1;
  hasRequiredCore = 1;
  var current =
    (process.versions &&
      process.versions.node &&
      process.versions.node.split('.')) ||
    [];
  function specifierIncluded(specifier) {
    var parts = specifier.split(' ');
    var op = parts.length > 1 ? parts[0] : '=';
    var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split('.');
    for (var i = 0; i < 3; ++i) {
      var cur = parseInt(current[i] || 0, 10);
      var ver = parseInt(versionParts[i] || 0, 10);
      if (cur === ver) {
        continue;
      }
      if (op === '<') {
        return cur < ver;
      } else if (op === '>=') {
        return cur >= ver;
      }
      return false;
    }
    return op === '>=';
  }
  function matchesRange(range) {
    var specifiers = range.split(/ ?&& ?/);
    if (specifiers.length === 0) {
      return false;
    }
    for (var i = 0; i < specifiers.length; ++i) {
      if (!specifierIncluded(specifiers[i])) {
        return false;
      }
    }
    return true;
  }
  function versionIncluded(specifierValue) {
    if (typeof specifierValue === 'boolean') {
      return specifierValue;
    }
    if (specifierValue && typeof specifierValue === 'object') {
      for (var i = 0; i < specifierValue.length; ++i) {
        if (matchesRange(specifierValue[i])) {
          return true;
        }
      }
      return false;
    }
    return matchesRange(specifierValue);
  }
  var data = require$$0;
  var core = {};
  for (var mod in data) {
    if (Object.prototype.hasOwnProperty.call(data, mod)) {
      core[mod] = versionIncluded(data[mod]);
    }
  }
  core_1 = core;
  return core_1;
}
var isCore;
var hasRequiredIsCore;
function requireIsCore() {
  if (hasRequiredIsCore) return isCore;
  hasRequiredIsCore = 1;
  var isCoreModule = requireIsCoreModule();
  isCore = function isCore(x) {
    return isCoreModule(x);
  };
  return isCore;
}
var sync;
var hasRequiredSync;
function requireSync() {
  if (hasRequiredSync) return sync;
  hasRequiredSync = 1;
  var isCore = requireIsCoreModule();
  var fs = require$$0$4;
  var path = require$$0$5;
  var getHomedir = requireHomedir();
  var caller = requireCaller();
  var nodeModulesPaths = requireNodeModulesPaths();
  var normalizeOptions = requireNormalizeOptions();
  var realpathFS =
    process.platform !== 'win32' &&
    fs.realpathSync &&
    typeof fs.realpathSync.native === 'function'
      ? fs.realpathSync.native
      : fs.realpathSync;
  var homedir = getHomedir();
  var defaultPaths = function () {
    return [
      path.join(homedir, '.node_modules'),
      path.join(homedir, '.node_libraries'),
    ];
  };
  var defaultIsFile = function isFile(file) {
    try {
      var stat = fs.statSync(file, {throwIfNoEntry: false});
    } catch (e) {
      if (e && (e.code === 'ENOENT' || e.code === 'ENOTDIR')) return false;
      throw e;
    }
    return !!stat && (stat.isFile() || stat.isFIFO());
  };
  var defaultIsDir = function isDirectory(dir) {
    try {
      var stat = fs.statSync(dir, {throwIfNoEntry: false});
    } catch (e) {
      if (e && (e.code === 'ENOENT' || e.code === 'ENOTDIR')) return false;
      throw e;
    }
    return !!stat && stat.isDirectory();
  };
  var defaultRealpathSync = function realpathSync(x) {
    try {
      return realpathFS(x);
    } catch (realpathErr) {
      if (realpathErr.code !== 'ENOENT') {
        throw realpathErr;
      }
    }
    return x;
  };
  var maybeRealpathSync = function maybeRealpathSync(realpathSync, x, opts) {
    if (opts && opts.preserveSymlinks === false) {
      return realpathSync(x);
    }
    return x;
  };
  var defaultReadPackageSync = function defaultReadPackageSync(
    readFileSync,
    pkgfile
  ) {
    var body = readFileSync(pkgfile);
    try {
      var pkg = JSON.parse(body);
      return pkg;
    } catch (jsonErr) {}
  };
  var getPackageCandidates = function getPackageCandidates(x, start, opts) {
    var dirs = nodeModulesPaths(start, opts, x);
    for (var i = 0; i < dirs.length; i++) {
      dirs[i] = path.join(dirs[i], x);
    }
    return dirs;
  };
  sync = function resolveSync(x, options) {
    if (typeof x !== 'string') {
      throw new TypeError('Path must be a string.');
    }
    var opts = normalizeOptions(x, options);
    var isFile = opts.isFile || defaultIsFile;
    var readFileSync = opts.readFileSync || fs.readFileSync;
    var isDirectory = opts.isDirectory || defaultIsDir;
    var realpathSync = opts.realpathSync || defaultRealpathSync;
    var readPackageSync = opts.readPackageSync || defaultReadPackageSync;
    if (opts.readFileSync && opts.readPackageSync) {
      throw new TypeError(
        '`readFileSync` and `readPackageSync` are mutually exclusive.'
      );
    }
    var packageIterator = opts.packageIterator;
    var extensions = opts.extensions || ['.js'];
    var includeCoreModules = opts.includeCoreModules !== false;
    var basedir = opts.basedir || path.dirname(caller());
    var parent = opts.filename || basedir;
    opts.paths = opts.paths || defaultPaths();
    var absoluteStart = maybeRealpathSync(
      realpathSync,
      path.resolve(basedir),
      opts
    );
    if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x)) {
      var res = path.resolve(absoluteStart, x);
      if (x === '.' || x === '..' || x.slice(-1) === '/') res += '/';
      var m = loadAsFileSync(res) || loadAsDirectorySync(res);
      if (m) return maybeRealpathSync(realpathSync, m, opts);
    } else if (includeCoreModules && isCore(x)) {
      return x;
    } else {
      var n = loadNodeModulesSync(x, absoluteStart);
      if (n) return maybeRealpathSync(realpathSync, n, opts);
    }
    var err = new Error("Cannot find module '" + x + "' from '" + parent + "'");
    err.code = 'MODULE_NOT_FOUND';
    throw err;
    function loadAsFileSync(x) {
      var pkg = loadpkg(path.dirname(x));
      if (pkg && pkg.dir && pkg.pkg && opts.pathFilter) {
        var rfile = path.relative(pkg.dir, x);
        var r = opts.pathFilter(pkg.pkg, x, rfile);
        if (r) {
          x = path.resolve(pkg.dir, r);
        }
      }
      if (isFile(x)) {
        return x;
      }
      for (var i = 0; i < extensions.length; i++) {
        var file = x + extensions[i];
        if (isFile(file)) {
          return file;
        }
      }
    }
    function loadpkg(dir) {
      if (dir === '' || dir === '/') return;
      if (process.platform === 'win32' && /^\w:[/\\]*$/.test(dir)) {
        return;
      }
      if (/[/\\]node_modules[/\\]*$/.test(dir)) return;
      var pkgfile = path.join(
        maybeRealpathSync(realpathSync, dir, opts),
        'package.json'
      );
      if (!isFile(pkgfile)) {
        return loadpkg(path.dirname(dir));
      }
      var pkg = readPackageSync(readFileSync, pkgfile);
      if (pkg && opts.packageFilter) {
        pkg = opts.packageFilter(pkg, dir);
      }
      return {pkg: pkg, dir: dir};
    }
    function loadAsDirectorySync(x) {
      var pkgfile = path.join(
        maybeRealpathSync(realpathSync, x, opts),
        '/package.json'
      );
      if (isFile(pkgfile)) {
        try {
          var pkg = readPackageSync(readFileSync, pkgfile);
        } catch (e) {}
        if (pkg && opts.packageFilter) {
          pkg = opts.packageFilter(pkg, x);
        }
        if (pkg && pkg.main) {
          if (typeof pkg.main !== 'string') {
            var mainError = new TypeError(
              'package “' + pkg.name + '” `main` must be a string'
            );
            mainError.code = 'INVALID_PACKAGE_MAIN';
            throw mainError;
          }
          if (pkg.main === '.' || pkg.main === './') {
            pkg.main = 'index';
          }
          try {
            var m = loadAsFileSync(path.resolve(x, pkg.main));
            if (m) return m;
            var n = loadAsDirectorySync(path.resolve(x, pkg.main));
            if (n) return n;
          } catch (e) {}
        }
      }
      return loadAsFileSync(path.join(x, '/index'));
    }
    function loadNodeModulesSync(x, start) {
      var thunk = function () {
        return getPackageCandidates(x, start, opts);
      };
      var dirs = packageIterator
        ? packageIterator(x, start, thunk, opts)
        : thunk();
      for (var i = 0; i < dirs.length; i++) {
        var dir = dirs[i];
        if (isDirectory(path.dirname(dir))) {
          var m = loadAsFileSync(dir);
          if (m) return m;
          var n = loadAsDirectorySync(dir);
          if (n) return n;
        }
      }
    }
  };
  return sync;
}
var resolve;
var hasRequiredResolve;
function requireResolve() {
  if (hasRequiredResolve) return resolve;
  hasRequiredResolve = 1;
  var async = requireAsync();
  async.core = requireCore();
  async.isCore = requireIsCore();
  async.sync = requireSync();
  resolve = async;
  return resolve;
}
var configApi = {};
var hasRequiredConfigApi;
function requireConfigApi() {
  if (hasRequiredConfigApi) return configApi;
  hasRequiredConfigApi = 1;
  Object.defineProperty(configApi, '__esModule', {value: true});
  configApi.default = makeAPI;
  function _semver() {
    const data = _interopRequireDefault(requireSemver());
    _semver = function () {
      return data;
    };
    return data;
  }
  var _ = requireLib();
  var _caching = caching;
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function makeAPI(cache) {
    const env = value =>
      cache.using(data => {
        if (typeof value === 'undefined') return data.envName;
        if (typeof value === 'function') {
          return (0, _caching.assertSimpleType)(value(data.envName));
        }
        if (!Array.isArray(value)) value = [value];
        return value.some(entry => {
          if (typeof entry !== 'string') {
            throw new Error('Unexpected non-string value');
          }
          return entry === data.envName;
        });
      });
    const caller = cb =>
      cache.using(data => (0, _caching.assertSimpleType)(cb(data.caller)));
    return {
      version: _.version,
      cache: cache.simple(),
      env: env,
      async: () => false,
      caller: caller,
      assertVersion: assertVersion,
      tokTypes: undefined,
    };
  }
  function assertVersion(range) {
    if (typeof range === 'number') {
      if (!Number.isInteger(range)) {
        throw new Error('Expected string or integer value.');
      }
      range = `^${range}.0.0-0`;
    }
    if (typeof range !== 'string') {
      throw new Error('Expected string or integer value.');
    }
    if (_semver().default.satisfies(_.version, range)) return;
    const limit = Error.stackTraceLimit;
    if (typeof limit === 'number' && limit < 25) {
      Error.stackTraceLimit = 25;
    }
    const err = new Error(
      `Requires Babel "${range}", but was loaded with "${_.version}". ` +
        `If you are sure you have a compatible version of @babel/core, ` +
        `it is likely that something in your build process is loading the ` +
        `wrong version. Inspect the stack trace of this error to look for ` +
        `the first entry that doesn't mention "@babel/core" or "babel-core" ` +
        `to see what is calling Babel.`
    );
    if (typeof limit === 'number') {
      Error.stackTraceLimit = limit;
    }
    throw Object.assign(err, {
      code: 'BABEL_VERSION_UNSUPPORTED',
      version: _.version,
      range: range,
    });
  }
  return configApi;
}
var patternToRegex = {};
var escapeRegExp_1;
var hasRequiredEscapeRegExp;
function requireEscapeRegExp() {
  if (hasRequiredEscapeRegExp) return escapeRegExp_1;
  hasRequiredEscapeRegExp = 1;
  var toString = requireToString();
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g,
    reHasRegExpChar = RegExp(reRegExpChar.source);
  function escapeRegExp(string) {
    string = toString(string);
    return string && reHasRegExpChar.test(string)
      ? string.replace(reRegExpChar, '\\$&')
      : string;
  }
  escapeRegExp_1 = escapeRegExp;
  return escapeRegExp_1;
}
Object.defineProperty(patternToRegex, '__esModule', {value: true});
patternToRegex.default = pathToPattern;
function _path$3() {
  const data = _interopRequireDefault$9(require$$0$5);
  _path$3 = function () {
    return data;
  };
  return data;
}
function _escapeRegExp() {
  const data = _interopRequireDefault$9(requireEscapeRegExp());
  _escapeRegExp = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$9(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const sep = `\\${_path$3().default.sep}`;
const endSep = `(?:${sep}|$)`;
const substitution = `[^${sep}]+`;
const starPat = `(?:${substitution}${sep})`;
const starPatLast = `(?:${substitution}${endSep})`;
const starStarPat = `${starPat}*?`;
const starStarPatLast = `${starPat}*?${starPatLast}?`;
function pathToPattern(pattern, dirname) {
  const parts = _path$3()
    .default.resolve(dirname, pattern)
    .split(_path$3().default.sep);
  return new RegExp(
    [
      '^',
      ...parts.map((part, i) => {
        const last = i === parts.length - 1;
        if (part === '**') return last ? starStarPatLast : starStarPat;
        if (part === '*') return last ? starPatLast : starPat;
        if (part.indexOf('*.') === 0) {
          return (
            substitution +
            (0, _escapeRegExp().default)(part.slice(1)) +
            (last ? endSep : sep)
          );
        }
        return (0, _escapeRegExp().default)(part) + (last ? endSep : sep);
      }),
    ].join('')
  );
}
var hasRequiredConfiguration;
function requireConfiguration() {
  if (hasRequiredConfiguration) return configuration;
  hasRequiredConfiguration = 1;
  Object.defineProperty(configuration, '__esModule', {value: true});
  configuration.findConfigUpwards = findConfigUpwards;
  configuration.findRelativeConfig = findRelativeConfig;
  configuration.findRootConfig = findRootConfig;
  configuration.loadConfig = loadConfig;
  function _debug() {
    const data = _interopRequireDefault(requireSrc$1());
    _debug = function () {
      return data;
    };
    return data;
  }
  function _path() {
    const data = _interopRequireDefault(require$$0$5);
    _path = function () {
      return data;
    };
    return data;
  }
  function _fs() {
    const data = _interopRequireDefault(require$$0$4);
    _fs = function () {
      return data;
    };
    return data;
  }
  function _json() {
    const data = _interopRequireDefault(require$$3$1);
    _json = function () {
      return data;
    };
    return data;
  }
  function _resolve() {
    const data = _interopRequireDefault(requireResolve());
    _resolve = function () {
      return data;
    };
    return data;
  }
  var _caching = caching;
  var _configApi = _interopRequireDefault(requireConfigApi());
  var _utils = utils;
  var _patternToRegex = _interopRequireDefault(patternToRegex);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const debug = (0, _debug().default)(
    'babel:config:loading:files:configuration'
  );
  const BABEL_CONFIG_JS_FILENAME = 'babel.config.js';
  const BABELRC_FILENAME = '.babelrc';
  const BABELRC_JS_FILENAME = '.babelrc.js';
  const BABELIGNORE_FILENAME = '.babelignore';
  function findConfigUpwards(rootDir) {
    let dirname = rootDir;
    while (true) {
      if (
        _fs().default.existsSync(
          _path().default.join(dirname, BABEL_CONFIG_JS_FILENAME)
        )
      ) {
        return dirname;
      }
      const nextDir = _path().default.dirname(dirname);
      if (dirname === nextDir) break;
      dirname = nextDir;
    }
    return null;
  }
  function findRelativeConfig(packageData, envName, caller) {
    let config = null;
    let ignore = null;
    const dirname = _path().default.dirname(packageData.filepath);
    for (const loc of packageData.directories) {
      if (!config) {
        config = [BABELRC_FILENAME, BABELRC_JS_FILENAME].reduce(
          (previousConfig, name) => {
            const filepath = _path().default.join(loc, name);
            const config = readConfig(filepath, envName, caller);
            if (config && previousConfig) {
              throw new Error(
                `Multiple configuration files found. Please remove one:\n` +
                  ` - ${_path().default.basename(previousConfig.filepath)}\n` +
                  ` - ${name}\n` +
                  `from ${loc}`
              );
            }
            return config || previousConfig;
          },
          null
        );
        const pkgConfig =
          packageData.pkg && packageData.pkg.dirname === loc
            ? packageToBabelConfig(packageData.pkg)
            : null;
        if (pkgConfig) {
          if (config) {
            throw new Error(
              `Multiple configuration files found. Please remove one:\n` +
                ` - ${_path().default.basename(pkgConfig.filepath)}#babel\n` +
                ` - ${_path().default.basename(config.filepath)}\n` +
                `from ${loc}`
            );
          }
          config = pkgConfig;
        }
        if (config) {
          debug('Found configuration %o from %o.', config.filepath, dirname);
        }
      }
      if (!ignore) {
        const ignoreLoc = _path().default.join(loc, BABELIGNORE_FILENAME);
        ignore = readIgnoreConfig(ignoreLoc);
        if (ignore) {
          debug('Found ignore %o from %o.', ignore.filepath, dirname);
        }
      }
    }
    return {config: config, ignore: ignore};
  }
  function findRootConfig(dirname, envName, caller) {
    const filepath = _path().default.resolve(dirname, BABEL_CONFIG_JS_FILENAME);
    const conf = readConfig(filepath, envName, caller);
    if (conf) {
      debug('Found root config %o in $o.', BABEL_CONFIG_JS_FILENAME, dirname);
    }
    return conf;
  }
  function loadConfig(name, dirname, envName, caller) {
    const filepath = _resolve().default.sync(name, {basedir: dirname});
    const conf = readConfig(filepath, envName, caller);
    if (!conf) {
      throw new Error(`Config file ${filepath} contains no configuration data`);
    }
    debug('Loaded config %o from $o.', name, dirname);
    return conf;
  }
  function readConfig(filepath, envName, caller) {
    return _path().default.extname(filepath) === '.js'
      ? readConfigJS(filepath, {envName: envName, caller: caller})
      : readConfigJSON5(filepath);
  }
  const LOADING_CONFIGS = new Set();
  const readConfigJS = (0, _caching.makeStrongCache)((filepath, cache) => {
    if (!_fs().default.existsSync(filepath)) {
      cache.forever();
      return null;
    }
    if (LOADING_CONFIGS.has(filepath)) {
      cache.never();
      debug('Auto-ignoring usage of config %o.', filepath);
      return {
        filepath: filepath,
        dirname: _path().default.dirname(filepath),
        options: {},
      };
    }
    let options;
    try {
      LOADING_CONFIGS.add(filepath);
      const configModule = commonjsRequire(filepath);
      options =
        configModule && configModule.__esModule
          ? configModule.default || undefined
          : configModule;
    } catch (err) {
      err.message = `${filepath}: Error while loading config - ${err.message}`;
      throw err;
    } finally {
      LOADING_CONFIGS.delete(filepath);
    }
    if (typeof options === 'function') {
      options = options((0, _configApi.default)(cache));
      if (!cache.configured()) throwConfigError();
    }
    if (!options || typeof options !== 'object' || Array.isArray(options)) {
      throw new Error(
        `${filepath}: Configuration should be an exported JavaScript object.`
      );
    }
    if (typeof options.then === 'function') {
      throw new Error(
        `You appear to be using an async configuration, ` +
          `which your current version of Babel does not support. ` +
          `We may add support for this in the future, ` +
          `but if you're on the most recent version of @babel/core and still ` +
          `seeing this error, then you'll need to synchronously return your config.`
      );
    }
    return {
      filepath: filepath,
      dirname: _path().default.dirname(filepath),
      options: options,
    };
  });
  const packageToBabelConfig = (0, _caching.makeWeakCache)(file => {
    const babel = file.options['babel'];
    if (typeof babel === 'undefined') return null;
    if (typeof babel !== 'object' || Array.isArray(babel) || babel === null) {
      throw new Error(`${file.filepath}: .babel property must be an object`);
    }
    return {filepath: file.filepath, dirname: file.dirname, options: babel};
  });
  const readConfigJSON5 = (0, _utils.makeStaticFileCache)(
    (filepath, content) => {
      let options;
      try {
        options = _json().default.parse(content);
      } catch (err) {
        err.message = `${filepath}: Error while parsing config - ${err.message}`;
        throw err;
      }
      if (!options) throw new Error(`${filepath}: No config detected`);
      if (typeof options !== 'object') {
        throw new Error(
          `${filepath}: Config returned typeof ${typeof options}`
        );
      }
      if (Array.isArray(options)) {
        throw new Error(`${filepath}: Expected config object but found array`);
      }
      return {
        filepath: filepath,
        dirname: _path().default.dirname(filepath),
        options: options,
      };
    }
  );
  const readIgnoreConfig = (0, _utils.makeStaticFileCache)(
    (filepath, content) => {
      const ignoreDir = _path().default.dirname(filepath);
      const ignorePatterns = content
        .split('\n')
        .map(line => line.replace(/#(.*?)$/, '').trim())
        .filter(line => !!line);
      for (const pattern of ignorePatterns) {
        if (pattern[0] === '!') {
          throw new Error(`Negation of file paths is not supported.`);
        }
      }
      return {
        filepath: filepath,
        dirname: _path().default.dirname(filepath),
        ignore: ignorePatterns.map(pattern =>
          (0, _patternToRegex.default)(pattern, ignoreDir)
        ),
      };
    }
  );
  function throwConfigError() {
    throw new Error(
      `Caching was left unconfigured. Babel's plugins, presets, and .babelrc.js files can be configured\nfor various types of caching, using the first param of their handler functions:\n\nmodule.exports = function(api) {\n  // The API exposes the following:\n\n  // Cache the returned value forever and don't call this function again.\n  api.cache(true);\n\n  // Don't cache at all. Not recommended because it will be very slow.\n  api.cache(false);\n\n  // Cached based on the value of some function. If this function returns a value different from\n  // a previously-encountered value, the plugins will re-evaluate.\n  var env = api.cache(() => process.env.NODE_ENV);\n\n  // If testing for a specific env, we recommend specifics to avoid instantiating a plugin for\n  // any possible NODE_ENV value that might come up during plugin execution.\n  var isProd = api.cache(() => process.env.NODE_ENV === "production");\n\n  // .cache(fn) will perform a linear search though instances to find the matching plugin based\n  // based on previous instantiated plugins. If you want to recreate the plugin and discard the\n  // previous instance whenever something changes, you may use:\n  var isProd = api.cache.invalidate(() => process.env.NODE_ENV === "production");\n\n  // Note, we also expose the following more-verbose versions of the above examples:\n  api.cache.forever(); // api.cache(true)\n  api.cache.never();   // api.cache(false)\n  api.cache.using(fn); // api.cache(fn)\n\n  // Return the value that will be cached.\n  return { };\n};`
    );
  }
  return configuration;
}
var plugins$1 = {};
Object.defineProperty(plugins$1, '__esModule', {value: true});
plugins$1.resolvePlugin = resolvePlugin;
plugins$1.resolvePreset = resolvePreset;
plugins$1.loadPlugin = loadPlugin;
plugins$1.loadPreset = loadPreset;
function _debug$1() {
  const data = _interopRequireDefault$8(requireSrc$1());
  _debug$1 = function () {
    return data;
  };
  return data;
}
function _resolve() {
  const data = _interopRequireDefault$8(requireResolve());
  _resolve = function () {
    return data;
  };
  return data;
}
function _path$2() {
  const data = _interopRequireDefault$8(require$$0$5);
  _path$2 = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$8(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const debug$1 = (0, _debug$1().default)('babel:config:loading:files:plugins');
const EXACT_RE = /^module:/;
const BABEL_PLUGIN_PREFIX_RE = /^(?!@|module:|[^/]+\/|babel-plugin-)/;
const BABEL_PRESET_PREFIX_RE = /^(?!@|module:|[^/]+\/|babel-preset-)/;
const BABEL_PLUGIN_ORG_RE = /^(@babel\/)(?!plugin-|[^/]+\/)/;
const BABEL_PRESET_ORG_RE = /^(@babel\/)(?!preset-|[^/]+\/)/;
const OTHER_PLUGIN_ORG_RE =
  /^(@(?!babel\/)[^/]+\/)(?![^/]*babel-plugin(?:-|\/|$)|[^/]+\/)/;
const OTHER_PRESET_ORG_RE =
  /^(@(?!babel\/)[^/]+\/)(?![^/]*babel-preset(?:-|\/|$)|[^/]+\/)/;
const OTHER_ORG_DEFAULT_RE = /^(@(?!babel$)[^/]+)$/;
function resolvePlugin(name, dirname) {
  return resolveStandardizedName('plugin', name, dirname);
}
function resolvePreset(name, dirname) {
  return resolveStandardizedName('preset', name, dirname);
}
function loadPlugin(name, dirname) {
  const filepath = resolvePlugin(name, dirname);
  if (!filepath) {
    throw new Error(`Plugin ${name} not found relative to ${dirname}`);
  }
  const value = requireModule('plugin', filepath);
  debug$1('Loaded plugin %o from %o.', name, dirname);
  return {filepath: filepath, value: value};
}
function loadPreset(name, dirname) {
  const filepath = resolvePreset(name, dirname);
  if (!filepath) {
    throw new Error(`Preset ${name} not found relative to ${dirname}`);
  }
  const value = requireModule('preset', filepath);
  debug$1('Loaded preset %o from %o.', name, dirname);
  return {filepath: filepath, value: value};
}
function standardizeName(type, name) {
  if (_path$2().default.isAbsolute(name)) return name;
  const isPreset = type === 'preset';
  return name
    .replace(
      isPreset ? BABEL_PRESET_PREFIX_RE : BABEL_PLUGIN_PREFIX_RE,
      `babel-${type}-`
    )
    .replace(isPreset ? BABEL_PRESET_ORG_RE : BABEL_PLUGIN_ORG_RE, `$1${type}-`)
    .replace(
      isPreset ? OTHER_PRESET_ORG_RE : OTHER_PLUGIN_ORG_RE,
      `$1babel-${type}-`
    )
    .replace(OTHER_ORG_DEFAULT_RE, `$1/babel-${type}`)
    .replace(EXACT_RE, '');
}
function resolveStandardizedName(type, name, dirname = process.cwd()) {
  const standardizedName = standardizeName(type, name);
  try {
    return _resolve().default.sync(standardizedName, {basedir: dirname});
  } catch (e) {
    if (e.code !== 'MODULE_NOT_FOUND') throw e;
    if (standardizedName !== name) {
      let resolvedOriginal = false;
      try {
        _resolve().default.sync(name, {basedir: dirname});
        resolvedOriginal = true;
      } catch (e2) {}
      if (resolvedOriginal) {
        e.message += `\n- If you want to resolve "${name}", use "module:${name}"`;
      }
    }
    let resolvedBabel = false;
    try {
      _resolve().default.sync(standardizeName(type, '@babel/' + name), {
        basedir: dirname,
      });
      resolvedBabel = true;
    } catch (e2) {}
    if (resolvedBabel) {
      e.message += `\n- Did you mean "@babel/${name}"?`;
    }
    let resolvedOppositeType = false;
    const oppositeType = type === 'preset' ? 'plugin' : 'preset';
    try {
      _resolve().default.sync(standardizeName(oppositeType, name), {
        basedir: dirname,
      });
      resolvedOppositeType = true;
    } catch (e2) {}
    if (resolvedOppositeType) {
      e.message += `\n- Did you accidentally pass a ${oppositeType} as a ${type}?`;
    }
    throw e;
  }
}
const LOADING_MODULES = new Set();
function requireModule(type, name) {
  if (LOADING_MODULES.has(name)) {
    throw new Error(
      `Reentrant ${type} detected trying to load "${name}". This module is not ignored ` +
        'and is trying to load itself while compiling itself, leading to a dependency cycle. ' +
        'We recommend adding it to your "ignore" list in your babelrc, or to a .babelignore.'
    );
  }
  try {
    LOADING_MODULES.add(name);
    return commonjsRequire(name);
  } finally {
    LOADING_MODULES.delete(name);
  }
}
var hasRequiredFiles;
function requireFiles() {
  if (hasRequiredFiles) return files;
  hasRequiredFiles = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    Object.defineProperty(exports, 'findPackageData', {
      enumerable: true,
      get: function () {
        return _package$1.findPackageData;
      },
    });
    Object.defineProperty(exports, 'findConfigUpwards', {
      enumerable: true,
      get: function () {
        return _configuration.findConfigUpwards;
      },
    });
    Object.defineProperty(exports, 'findRelativeConfig', {
      enumerable: true,
      get: function () {
        return _configuration.findRelativeConfig;
      },
    });
    Object.defineProperty(exports, 'findRootConfig', {
      enumerable: true,
      get: function () {
        return _configuration.findRootConfig;
      },
    });
    Object.defineProperty(exports, 'loadConfig', {
      enumerable: true,
      get: function () {
        return _configuration.loadConfig;
      },
    });
    Object.defineProperty(exports, 'resolvePlugin', {
      enumerable: true,
      get: function () {
        return _plugins.resolvePlugin;
      },
    });
    Object.defineProperty(exports, 'resolvePreset', {
      enumerable: true,
      get: function () {
        return _plugins.resolvePreset;
      },
    });
    Object.defineProperty(exports, 'loadPlugin', {
      enumerable: true,
      get: function () {
        return _plugins.loadPlugin;
      },
    });
    Object.defineProperty(exports, 'loadPreset', {
      enumerable: true,
      get: function () {
        return _plugins.loadPreset;
      },
    });
    var _package$1 = _package;
    var _configuration = requireConfiguration();
    var _plugins = plugins$1;
  })(files);
  return files;
}
var name$1 = '@babel/core';
var version = '7.2.0';
var description = 'Babel compiler core.';
var main = 'lib/index.js';
var author = 'Sebastian McKenzie <sebmck@gmail.com>';
var homepage = 'https://babeljs.io/';
var license = 'MIT';
var publishConfig = {access: 'public'};
var repository =
  'https://github.com/babel/babel/tree/master/packages/babel-core';
var keywords = [
  '6to5',
  'babel',
  'classes',
  'const',
  'es6',
  'harmony',
  'let',
  'modules',
  'transpile',
  'transpiler',
  'var',
  'babel-core',
  'compiler',
];
var engines = {node: '>=6.9.0'};
var browser = {
  './lib/config/files/index.js': './lib/config/files/index-browser.js',
  './lib/transform-file.js': './lib/transform-file-browser.js',
};
var dependencies = {
  '@babel/code-frame': '^7.0.0',
  '@babel/generator': '^7.2.0',
  '@babel/helpers': '^7.2.0',
  '@babel/parser': '^7.2.0',
  '@babel/template': '^7.1.2',
  '@babel/traverse': '^7.1.6',
  '@babel/types': '^7.2.0',
  'convert-source-map': '^1.1.0',
  debug: '^4.1.0',
  json5: '^2.1.0',
  lodash: '^4.17.10',
  resolve: '^1.3.2',
  semver: '^5.4.1',
  'source-map': '^0.5.0',
};
var devDependencies = {
  '@babel/helper-transform-fixture-test-runner': '^7.0.0',
  '@babel/register': '^7.0.0',
};
var require$$3 = {
  name: name$1,
  version: version,
  description: description,
  main: main,
  author: author,
  homepage: homepage,
  license: license,
  publishConfig: publishConfig,
  repository: repository,
  keywords: keywords,
  engines: engines,
  browser: browser,
  dependencies: dependencies,
  devDependencies: devDependencies,
};
var environment = {};
Object.defineProperty(environment, '__esModule', {value: true});
environment.getEnv = getEnv;
function getEnv(defaultValue = 'development') {
  return process.env.BABEL_ENV || process.env.NODE_ENV || defaultValue;
}
var item = {};
var configDescriptors = {};
var hasRequiredConfigDescriptors;
function requireConfigDescriptors() {
  if (hasRequiredConfigDescriptors) return configDescriptors;
  hasRequiredConfigDescriptors = 1;
  Object.defineProperty(configDescriptors, '__esModule', {value: true});
  configDescriptors.createCachedDescriptors = createCachedDescriptors;
  configDescriptors.createUncachedDescriptors = createUncachedDescriptors;
  configDescriptors.createDescriptor = createDescriptor;
  var _files = requireFiles();
  var _item = requireItem();
  var _caching = caching;
  function isEqualDescriptor(a, b) {
    return (
      a.name === b.name &&
      a.value === b.value &&
      a.options === b.options &&
      a.dirname === b.dirname &&
      a.alias === b.alias &&
      a.ownPass === b.ownPass &&
      (a.file && a.file.request) === (b.file && b.file.request) &&
      (a.file && a.file.resolved) === (b.file && b.file.resolved)
    );
  }
  function createCachedDescriptors(dirname, options, alias) {
    const {
      plugins: plugins,
      presets: presets,
      passPerPreset: passPerPreset,
    } = options;
    return {
      options: options,
      plugins: plugins
        ? () => createCachedPluginDescriptors(plugins, dirname)(alias)
        : () => [],
      presets: presets
        ? () =>
            createCachedPresetDescriptors(presets, dirname)(alias)(
              !!passPerPreset
            )
        : () => [],
    };
  }
  function createUncachedDescriptors(dirname, options, alias) {
    let plugins;
    let presets;
    return {
      options: options,
      plugins: () => {
        if (!plugins) {
          plugins = createPluginDescriptors(
            options.plugins || [],
            dirname,
            alias
          );
        }
        return plugins;
      },
      presets: () => {
        if (!presets) {
          presets = createPresetDescriptors(
            options.presets || [],
            dirname,
            alias,
            !!options.passPerPreset
          );
        }
        return presets;
      },
    };
  }
  const PRESET_DESCRIPTOR_CACHE = new WeakMap();
  const createCachedPresetDescriptors = (0, _caching.makeWeakCache)(
    (items, cache) => {
      const dirname = cache.using(dir => dir);
      return (0, _caching.makeStrongCache)(alias =>
        (0, _caching.makeStrongCache)(passPerPreset =>
          createPresetDescriptors(items, dirname, alias, passPerPreset).map(
            desc => loadCachedDescriptor(PRESET_DESCRIPTOR_CACHE, desc)
          )
        )
      );
    }
  );
  const PLUGIN_DESCRIPTOR_CACHE = new WeakMap();
  const createCachedPluginDescriptors = (0, _caching.makeWeakCache)(
    (items, cache) => {
      const dirname = cache.using(dir => dir);
      return (0, _caching.makeStrongCache)(alias =>
        createPluginDescriptors(items, dirname, alias).map(desc =>
          loadCachedDescriptor(PLUGIN_DESCRIPTOR_CACHE, desc)
        )
      );
    }
  );
  const DEFAULT_OPTIONS = {};
  function loadCachedDescriptor(cache, desc) {
    const {value: value, options: options = DEFAULT_OPTIONS} = desc;
    if (options === false) return desc;
    let cacheByOptions = cache.get(value);
    if (!cacheByOptions) {
      cacheByOptions = new WeakMap();
      cache.set(value, cacheByOptions);
    }
    let possibilities = cacheByOptions.get(options);
    if (!possibilities) {
      possibilities = [];
      cacheByOptions.set(options, possibilities);
    }
    if (possibilities.indexOf(desc) === -1) {
      const matches = possibilities.filter(possibility =>
        isEqualDescriptor(possibility, desc)
      );
      if (matches.length > 0) {
        return matches[0];
      }
      possibilities.push(desc);
    }
    return desc;
  }
  function createPresetDescriptors(items, dirname, alias, passPerPreset) {
    return createDescriptors('preset', items, dirname, alias, passPerPreset);
  }
  function createPluginDescriptors(items, dirname, alias) {
    return createDescriptors('plugin', items, dirname, alias);
  }
  function createDescriptors(type, items, dirname, alias, ownPass) {
    const descriptors = items.map((item, index) =>
      createDescriptor(item, dirname, {
        type: type,
        alias: `${alias}$${index}`,
        ownPass: !!ownPass,
      })
    );
    assertNoDuplicates(descriptors);
    return descriptors;
  }
  function createDescriptor(
    pair,
    dirname,
    {type: type, alias: alias, ownPass: ownPass}
  ) {
    const desc = (0, _item.getItemDescriptor)(pair);
    if (desc) {
      return desc;
    }
    let name;
    let options;
    let value = pair;
    if (Array.isArray(value)) {
      if (value.length === 3) {
        [value, options, name] = value;
      } else {
        [value, options] = value;
      }
    }
    let file = undefined;
    let filepath = null;
    if (typeof value === 'string') {
      if (typeof type !== 'string') {
        throw new Error(
          'To resolve a string-based item, the type of item must be given'
        );
      }
      const resolver =
        type === 'plugin' ? _files.loadPlugin : _files.loadPreset;
      const request = value;
      ({filepath: filepath, value: value} = resolver(value, dirname));
      file = {request: request, resolved: filepath};
    }
    if (!value) {
      throw new Error(`Unexpected falsy value: ${String(value)}`);
    }
    if (typeof value === 'object' && value.__esModule) {
      if (value.default) {
        value = value.default;
      } else {
        throw new Error('Must export a default export when using ES6 modules.');
      }
    }
    if (typeof value !== 'object' && typeof value !== 'function') {
      throw new Error(
        `Unsupported format: ${typeof value}. Expected an object or a function.`
      );
    }
    if (filepath !== null && typeof value === 'object' && value) {
      throw new Error(
        `Plugin/Preset files are not allowed to export objects, only functions. In ${filepath}`
      );
    }
    return {
      name: name,
      alias: filepath || alias,
      value: value,
      options: options,
      dirname: dirname,
      ownPass: ownPass,
      file: file,
    };
  }
  function assertNoDuplicates(items) {
    const map = new Map();
    for (const item of items) {
      if (typeof item.value !== 'function') continue;
      let nameMap = map.get(item.value);
      if (!nameMap) {
        nameMap = new Set();
        map.set(item.value, nameMap);
      }
      if (nameMap.has(item.name)) {
        throw new Error(
          [
            `Duplicate plugin/preset detected.`,
            `If you'd like to use two separate instances of a plugin,`,
            `they need separate names, e.g.`,
            ``,
            `  plugins: [`,
            `    ['some-plugin', {}],`,
            `    ['some-plugin', {}, 'some unique name'],`,
            `  ]`,
          ].join('\n')
        );
      }
      nameMap.add(item.name);
    }
  }
  return configDescriptors;
}
var hasRequiredItem;
function requireItem() {
  if (hasRequiredItem) return item;
  hasRequiredItem = 1;
  Object.defineProperty(item, '__esModule', {value: true});
  item.createItemFromDescriptor = createItemFromDescriptor;
  item.createConfigItem = createConfigItem;
  item.getItemDescriptor = getItemDescriptor;
  function _path() {
    const data = _interopRequireDefault(require$$0$5);
    _path = function () {
      return data;
    };
    return data;
  }
  var _configDescriptors = requireConfigDescriptors();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function createItemFromDescriptor(desc) {
    return new ConfigItem(desc);
  }
  function createConfigItem(value, {dirname: dirname = '.', type: type} = {}) {
    const descriptor = (0, _configDescriptors.createDescriptor)(
      value,
      _path().default.resolve(dirname),
      {type: type, alias: 'programmatic item'}
    );
    return createItemFromDescriptor(descriptor);
  }
  function getItemDescriptor(item) {
    if (item instanceof ConfigItem) {
      return item._descriptor;
    }
    return undefined;
  }
  class ConfigItem {
    constructor(descriptor) {
      this._descriptor = descriptor;
      Object.defineProperty(this, '_descriptor', {enumerable: false});
      this.value = this._descriptor.value;
      this.options = this._descriptor.options;
      this.dirname = this._descriptor.dirname;
      this.name = this._descriptor.name;
      this.file = this._descriptor.file
        ? {
            request: this._descriptor.file.request,
            resolved: this._descriptor.file.resolved,
          }
        : undefined;
      Object.freeze(this);
    }
  }
  Object.freeze(ConfigItem.prototype);
  return item;
}
var config = {};
var full = {};
var util$2 = {};
Object.defineProperty(util$2, '__esModule', {value: true});
util$2.mergeOptions = mergeOptions;
function mergeOptions(target, source) {
  for (const k of Object.keys(source)) {
    if (k === 'parserOpts' && source.parserOpts) {
      const parserOpts = source.parserOpts;
      const targetObj = (target.parserOpts = target.parserOpts || {});
      mergeDefaultFields(targetObj, parserOpts);
    } else if (k === 'generatorOpts' && source.generatorOpts) {
      const generatorOpts = source.generatorOpts;
      const targetObj = (target.generatorOpts = target.generatorOpts || {});
      mergeDefaultFields(targetObj, generatorOpts);
    } else {
      const val = source[k];
      if (val !== undefined) target[k] = val;
    }
  }
}
function mergeDefaultFields(target, source) {
  for (const k of Object.keys(source)) {
    const val = source[k];
    if (val !== undefined) target[k] = val;
  }
}
var plugin$7 = {};
Object.defineProperty(plugin$7, '__esModule', {value: true});
plugin$7.default = void 0;
class Plugin {
  constructor(plugin, options, key) {
    this.key = plugin.name || key;
    this.manipulateOptions = plugin.manipulateOptions;
    this.post = plugin.post;
    this.pre = plugin.pre;
    this.visitor = plugin.visitor || {};
    this.parserOverride = plugin.parserOverride;
    this.generatorOverride = plugin.generatorOverride;
    this.options = options;
  }
}
plugin$7.default = Plugin;
var configChain = {};
var options = {};
var removed = {};
Object.defineProperty(removed, '__esModule', {value: true});
removed.default = void 0;
var _default$7 = {
  auxiliaryComment: {
    message: 'Use `auxiliaryCommentBefore` or `auxiliaryCommentAfter`',
  },
  blacklist: {
    message: 'Put the specific transforms you want in the `plugins` option',
  },
  breakConfig: {message: 'This is not a necessary option in Babel 6'},
  experimental: {
    message: 'Put the specific transforms you want in the `plugins` option',
  },
  externalHelpers: {
    message:
      'Use the `external-helpers` plugin instead. ' +
      'Check out http://babeljs.io/docs/plugins/external-helpers/',
  },
  extra: {message: ''},
  jsxPragma: {
    message:
      'use the `pragma` option in the `react-jsx` plugin. ' +
      'Check out http://babeljs.io/docs/plugins/transform-react-jsx/',
  },
  loose: {
    message:
      'Specify the `loose` option for the relevant plugin you are using ' +
      'or use a preset that sets the option.',
  },
  metadataUsedHelpers: {
    message: 'Not required anymore as this is enabled by default',
  },
  modules: {
    message:
      'Use the corresponding module transform plugin in the `plugins` option. ' +
      'Check out http://babeljs.io/docs/plugins/#modules',
  },
  nonStandard: {
    message:
      'Use the `react-jsx` and `flow-strip-types` plugins to support JSX and Flow. ' +
      'Also check out the react preset http://babeljs.io/docs/plugins/preset-react/',
  },
  optional: {
    message: 'Put the specific transforms you want in the `plugins` option',
  },
  sourceMapName: {
    message:
      'The `sourceMapName` option has been removed because it makes more sense for the ' +
      'tooling that calls Babel to assign `map.file` themselves.',
  },
  stage: {
    message:
      'Check out the corresponding stage-x presets http://babeljs.io/docs/plugins/#presets',
  },
  whitelist: {
    message: 'Put the specific transforms you want in the `plugins` option',
  },
  resolveModuleSource: {
    version: 6,
    message: "Use `babel-plugin-module-resolver@3`'s 'resolvePath' options",
  },
  metadata: {
    version: 6,
    message:
      'Generated plugin metadata is always included in the output result',
  },
  sourceMapTarget: {
    version: 6,
    message:
      'The `sourceMapTarget` option has been removed because it makes more sense for the tooling ' +
      'that calls Babel to assign `map.file` themselves.',
  },
};
removed.default = _default$7;
var optionAssertions = {};
Object.defineProperty(optionAssertions, '__esModule', {value: true});
optionAssertions.msg = msg;
optionAssertions.access = access;
optionAssertions.assertRootMode = assertRootMode;
optionAssertions.assertSourceMaps = assertSourceMaps;
optionAssertions.assertCompact = assertCompact;
optionAssertions.assertSourceType = assertSourceType;
optionAssertions.assertCallerMetadata = assertCallerMetadata;
optionAssertions.assertInputSourceMap = assertInputSourceMap;
optionAssertions.assertString = assertString;
optionAssertions.assertFunction = assertFunction;
optionAssertions.assertBoolean = assertBoolean;
optionAssertions.assertObject = assertObject;
optionAssertions.assertArray = assertArray;
optionAssertions.assertIgnoreList = assertIgnoreList;
optionAssertions.assertConfigApplicableTest = assertConfigApplicableTest;
optionAssertions.assertConfigFileSearch = assertConfigFileSearch;
optionAssertions.assertBabelrcSearch = assertBabelrcSearch;
optionAssertions.assertPluginList = assertPluginList;
function msg(loc) {
  switch (loc.type) {
    case 'root':
      return ``;
    case 'env':
      return `${msg(loc.parent)}.env["${loc.name}"]`;
    case 'overrides':
      return `${msg(loc.parent)}.overrides[${loc.index}]`;
    case 'option':
      return `${msg(loc.parent)}.${loc.name}`;
    case 'access':
      return `${msg(loc.parent)}[${JSON.stringify(loc.name)}]`;
    default:
      throw new Error(`Assertion failure: Unknown type ${loc.type}`);
  }
}
function access(loc, name) {
  return {type: 'access', name: name, parent: loc};
}
function assertRootMode(loc, value) {
  if (
    value !== undefined &&
    value !== 'root' &&
    value !== 'upward' &&
    value !== 'upward-optional'
  ) {
    throw new Error(
      `${msg(loc)} must be a "root", "upward", "upward-optional" or undefined`
    );
  }
  return value;
}
function assertSourceMaps(loc, value) {
  if (
    value !== undefined &&
    typeof value !== 'boolean' &&
    value !== 'inline' &&
    value !== 'both'
  ) {
    throw new Error(
      `${msg(loc)} must be a boolean, "inline", "both", or undefined`
    );
  }
  return value;
}
function assertCompact(loc, value) {
  if (value !== undefined && typeof value !== 'boolean' && value !== 'auto') {
    throw new Error(`${msg(loc)} must be a boolean, "auto", or undefined`);
  }
  return value;
}
function assertSourceType(loc, value) {
  if (
    value !== undefined &&
    value !== 'module' &&
    value !== 'script' &&
    value !== 'unambiguous'
  ) {
    throw new Error(
      `${msg(loc)} must be "module", "script", "unambiguous", or undefined`
    );
  }
  return value;
}
function assertCallerMetadata(loc, value) {
  const obj = assertObject(loc, value);
  if (obj) {
    if (typeof obj['name'] !== 'string') {
      throw new Error(
        `${msg(loc)} set but does not contain "name" property string`
      );
    }
    for (const prop of Object.keys(obj)) {
      const propLoc = access(loc, prop);
      const value = obj[prop];
      if (
        value != null &&
        typeof value !== 'boolean' &&
        typeof value !== 'string' &&
        typeof value !== 'number'
      ) {
        throw new Error(
          `${msg(propLoc)} must be null, undefined, a boolean, a string, or a number.`
        );
      }
    }
  }
  return value;
}
function assertInputSourceMap(loc, value) {
  if (
    value !== undefined &&
    typeof value !== 'boolean' &&
    (typeof value !== 'object' || !value)
  ) {
    throw new Error(`${msg(loc)} must be a boolean, object, or undefined`);
  }
  return value;
}
function assertString(loc, value) {
  if (value !== undefined && typeof value !== 'string') {
    throw new Error(`${msg(loc)} must be a string, or undefined`);
  }
  return value;
}
function assertFunction(loc, value) {
  if (value !== undefined && typeof value !== 'function') {
    throw new Error(`${msg(loc)} must be a function, or undefined`);
  }
  return value;
}
function assertBoolean(loc, value) {
  if (value !== undefined && typeof value !== 'boolean') {
    throw new Error(`${msg(loc)} must be a boolean, or undefined`);
  }
  return value;
}
function assertObject(loc, value) {
  if (
    value !== undefined &&
    (typeof value !== 'object' || Array.isArray(value) || !value)
  ) {
    throw new Error(`${msg(loc)} must be an object, or undefined`);
  }
  return value;
}
function assertArray(loc, value) {
  if (value != null && !Array.isArray(value)) {
    throw new Error(`${msg(loc)} must be an array, or undefined`);
  }
  return value;
}
function assertIgnoreList(loc, value) {
  const arr = assertArray(loc, value);
  if (arr) {
    arr.forEach((item, i) => assertIgnoreItem(access(loc, i), item));
  }
  return arr;
}
function assertIgnoreItem(loc, value) {
  if (
    typeof value !== 'string' &&
    typeof value !== 'function' &&
    !(value instanceof RegExp)
  ) {
    throw new Error(
      `${msg(loc)} must be an array of string/Funtion/RegExp values, or undefined`
    );
  }
  return value;
}
function assertConfigApplicableTest(loc, value) {
  if (value === undefined) return value;
  if (Array.isArray(value)) {
    value.forEach((item, i) => {
      if (!checkValidTest(item)) {
        throw new Error(
          `${msg(access(loc, i))} must be a string/Function/RegExp.`
        );
      }
    });
  } else if (!checkValidTest(value)) {
    throw new Error(
      `${msg(loc)} must be a string/Function/RegExp, or an array of those`
    );
  }
  return value;
}
function checkValidTest(value) {
  return (
    typeof value === 'string' ||
    typeof value === 'function' ||
    value instanceof RegExp
  );
}
function assertConfigFileSearch(loc, value) {
  if (
    value !== undefined &&
    typeof value !== 'boolean' &&
    typeof value !== 'string'
  ) {
    throw new Error(
      `${msg(loc)} must be a undefined, a boolean, a string, ` +
        `got ${JSON.stringify(value)}`
    );
  }
  return value;
}
function assertBabelrcSearch(loc, value) {
  if (value === undefined || typeof value === 'boolean') return value;
  if (Array.isArray(value)) {
    value.forEach((item, i) => {
      if (!checkValidTest(item)) {
        throw new Error(
          `${msg(access(loc, i))} must be a string/Function/RegExp.`
        );
      }
    });
  } else if (!checkValidTest(value)) {
    throw new Error(
      `${msg(loc)} must be a undefined, a boolean, a string/Function/RegExp ` +
        `or an array of those, got ${JSON.stringify(value)}`
    );
  }
  return value;
}
function assertPluginList(loc, value) {
  const arr = assertArray(loc, value);
  if (arr) {
    arr.forEach((item, i) => assertPluginItem(access(loc, i), item));
  }
  return arr;
}
function assertPluginItem(loc, value) {
  if (Array.isArray(value)) {
    if (value.length === 0) {
      throw new Error(`${msg(loc)} must include an object`);
    }
    if (value.length > 3) {
      throw new Error(`${msg(loc)} may only be a two-tuple or three-tuple`);
    }
    assertPluginTarget(access(loc, 0), value[0]);
    if (value.length > 1) {
      const opts = value[1];
      if (
        opts !== undefined &&
        opts !== false &&
        (typeof opts !== 'object' || Array.isArray(opts))
      ) {
        throw new Error(
          `${msg(access(loc, 1))} must be an object, false, or undefined`
        );
      }
    }
    if (value.length === 3) {
      const name = value[2];
      if (name !== undefined && typeof name !== 'string') {
        throw new Error(
          `${msg(access(loc, 2))} must be a string, or undefined`
        );
      }
    }
  } else {
    assertPluginTarget(loc, value);
  }
  return value;
}
function assertPluginTarget(loc, value) {
  if (
    (typeof value !== 'object' || !value) &&
    typeof value !== 'string' &&
    typeof value !== 'function'
  ) {
    throw new Error(`${msg(loc)} must be a string, object, function`);
  }
  return value;
}
Object.defineProperty(options, '__esModule', {value: true});
options.validate = validate$1;
_interopRequireDefault$7(plugin$7);
var _removed = _interopRequireDefault$7(removed);
var _optionAssertions$1 = optionAssertions;
function _interopRequireDefault$7(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const ROOT_VALIDATORS = {
  cwd: _optionAssertions$1.assertString,
  root: _optionAssertions$1.assertString,
  rootMode: _optionAssertions$1.assertRootMode,
  configFile: _optionAssertions$1.assertConfigFileSearch,
  caller: _optionAssertions$1.assertCallerMetadata,
  filename: _optionAssertions$1.assertString,
  filenameRelative: _optionAssertions$1.assertString,
  code: _optionAssertions$1.assertBoolean,
  ast: _optionAssertions$1.assertBoolean,
  envName: _optionAssertions$1.assertString,
};
const BABELRC_VALIDATORS = {
  babelrc: _optionAssertions$1.assertBoolean,
  babelrcRoots: _optionAssertions$1.assertBabelrcSearch,
};
const NONPRESET_VALIDATORS = {
  extends: _optionAssertions$1.assertString,
  ignore: _optionAssertions$1.assertIgnoreList,
  only: _optionAssertions$1.assertIgnoreList,
};
const COMMON_VALIDATORS = {
  inputSourceMap: _optionAssertions$1.assertInputSourceMap,
  presets: _optionAssertions$1.assertPluginList,
  plugins: _optionAssertions$1.assertPluginList,
  passPerPreset: _optionAssertions$1.assertBoolean,
  env: assertEnvSet,
  overrides: assertOverridesList,
  test: _optionAssertions$1.assertConfigApplicableTest,
  include: _optionAssertions$1.assertConfigApplicableTest,
  exclude: _optionAssertions$1.assertConfigApplicableTest,
  retainLines: _optionAssertions$1.assertBoolean,
  comments: _optionAssertions$1.assertBoolean,
  shouldPrintComment: _optionAssertions$1.assertFunction,
  compact: _optionAssertions$1.assertCompact,
  minified: _optionAssertions$1.assertBoolean,
  auxiliaryCommentBefore: _optionAssertions$1.assertString,
  auxiliaryCommentAfter: _optionAssertions$1.assertString,
  sourceType: _optionAssertions$1.assertSourceType,
  wrapPluginVisitorMethod: _optionAssertions$1.assertFunction,
  highlightCode: _optionAssertions$1.assertBoolean,
  sourceMaps: _optionAssertions$1.assertSourceMaps,
  sourceMap: _optionAssertions$1.assertSourceMaps,
  sourceFileName: _optionAssertions$1.assertString,
  sourceRoot: _optionAssertions$1.assertString,
  getModuleId: _optionAssertions$1.assertFunction,
  moduleRoot: _optionAssertions$1.assertString,
  moduleIds: _optionAssertions$1.assertBoolean,
  moduleId: _optionAssertions$1.assertString,
  parserOpts: _optionAssertions$1.assertObject,
  generatorOpts: _optionAssertions$1.assertObject,
};
function getSource(loc) {
  return loc.type === 'root' ? loc.source : getSource(loc.parent);
}
function validate$1(type, opts) {
  return validateNested({type: 'root', source: type}, opts);
}
function validateNested(loc, opts) {
  const type = getSource(loc);
  assertNoDuplicateSourcemap(opts);
  Object.keys(opts).forEach(key => {
    const optLoc = {type: 'option', name: key, parent: loc};
    if (type === 'preset' && NONPRESET_VALIDATORS[key]) {
      throw new Error(
        `${(0, _optionAssertions$1.msg)(optLoc)} is not allowed in preset options`
      );
    }
    if (type !== 'arguments' && ROOT_VALIDATORS[key]) {
      throw new Error(
        `${(0, _optionAssertions$1.msg)(optLoc)} is only allowed in root programmatic options`
      );
    }
    if (
      type !== 'arguments' &&
      type !== 'configfile' &&
      BABELRC_VALIDATORS[key]
    ) {
      if (type === 'babelrcfile' || type === 'extendsfile') {
        throw new Error(
          `${(0, _optionAssertions$1.msg)(optLoc)} is not allowed in .babelrc or "extends"ed files, only in root programmatic options, ` +
            `or babel.config.js/config file options`
        );
      }
      throw new Error(
        `${(0, _optionAssertions$1.msg)(optLoc)} is only allowed in root programmatic options, or babel.config.js/config file options`
      );
    }
    const validator =
      COMMON_VALIDATORS[key] ||
      NONPRESET_VALIDATORS[key] ||
      BABELRC_VALIDATORS[key] ||
      ROOT_VALIDATORS[key] ||
      throwUnknownError;
    validator(optLoc, opts[key]);
  });
  return opts;
}
function throwUnknownError(loc) {
  const key = loc.name;
  if (_removed.default[key]) {
    const {message: message, version: version = 5} = _removed.default[key];
    throw new ReferenceError(
      `Using removed Babel ${version} option: ${(0, _optionAssertions$1.msg)(loc)} - ${message}`
    );
  } else {
    const unknownOptErr = `Unknown option: ${(0, _optionAssertions$1.msg)(loc)}. Check out https://babeljs.io/docs/en/babel-core/#options for more information about options.`;
    throw new ReferenceError(unknownOptErr);
  }
}
function has(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
}
function assertNoDuplicateSourcemap(opts) {
  if (has(opts, 'sourceMap') && has(opts, 'sourceMaps')) {
    throw new Error('.sourceMap is an alias for .sourceMaps, cannot use both');
  }
}
function assertEnvSet(loc, value) {
  if (loc.parent.type === 'env') {
    throw new Error(
      `${(0, _optionAssertions$1.msg)(loc)} is not allowed inside of another .env block`
    );
  }
  const parent = loc.parent;
  const obj = (0, _optionAssertions$1.assertObject)(loc, value);
  if (obj) {
    for (const envName of Object.keys(obj)) {
      const env = (0, _optionAssertions$1.assertObject)(
        (0, _optionAssertions$1.access)(loc, envName),
        obj[envName]
      );
      if (!env) continue;
      const envLoc = {type: 'env', name: envName, parent: parent};
      validateNested(envLoc, env);
    }
  }
  return obj;
}
function assertOverridesList(loc, value) {
  if (loc.parent.type === 'env') {
    throw new Error(
      `${(0, _optionAssertions$1.msg)(loc)} is not allowed inside an .env block`
    );
  }
  if (loc.parent.type === 'overrides') {
    throw new Error(
      `${(0, _optionAssertions$1.msg)(loc)} is not allowed inside an .overrides block`
    );
  }
  const parent = loc.parent;
  const arr = (0, _optionAssertions$1.assertArray)(loc, value);
  if (arr) {
    for (const [index, item] of arr.entries()) {
      const objLoc = (0, _optionAssertions$1.access)(loc, index);
      const env = (0, _optionAssertions$1.assertObject)(objLoc, item);
      if (!env)
        throw new Error(
          `${(0, _optionAssertions$1.msg)(objLoc)} must be an object`
        );
      const overridesLoc = {type: 'overrides', index: index, parent: parent};
      validateNested(overridesLoc, env);
    }
  }
  return arr;
}
var hasRequiredConfigChain;
function requireConfigChain() {
  if (hasRequiredConfigChain) return configChain;
  hasRequiredConfigChain = 1;
  Object.defineProperty(configChain, '__esModule', {value: true});
  configChain.buildPresetChain = buildPresetChain;
  configChain.buildRootChain = buildRootChain;
  configChain.buildPresetChainWalker = void 0;
  function _path() {
    const data = _interopRequireDefault(require$$0$5);
    _path = function () {
      return data;
    };
    return data;
  }
  function _debug() {
    const data = _interopRequireDefault(requireSrc$1());
    _debug = function () {
      return data;
    };
    return data;
  }
  var _options = options;
  var _patternToRegex = _interopRequireDefault(patternToRegex);
  var _files = requireFiles();
  var _caching = caching;
  var _configDescriptors = requireConfigDescriptors();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const debug = (0, _debug().default)('babel:config:config-chain');
  function buildPresetChain(arg, context) {
    const chain = buildPresetChainWalker(arg, context);
    if (!chain) return null;
    return {
      plugins: dedupDescriptors(chain.plugins),
      presets: dedupDescriptors(chain.presets),
      options: chain.options.map(o => normalizeOptions(o)),
    };
  }
  const buildPresetChainWalker = makeChainWalker({
    init: arg => arg,
    root: preset => loadPresetDescriptors(preset),
    env: (preset, envName) => loadPresetEnvDescriptors(preset)(envName),
    overrides: (preset, index) => loadPresetOverridesDescriptors(preset)(index),
    overridesEnv: (preset, index, envName) =>
      loadPresetOverridesEnvDescriptors(preset)(index)(envName),
  });
  configChain.buildPresetChainWalker = buildPresetChainWalker;
  const loadPresetDescriptors = (0, _caching.makeWeakCache)(preset =>
    buildRootDescriptors(
      preset,
      preset.alias,
      _configDescriptors.createUncachedDescriptors
    )
  );
  const loadPresetEnvDescriptors = (0, _caching.makeWeakCache)(preset =>
    (0, _caching.makeStrongCache)(envName =>
      buildEnvDescriptors(
        preset,
        preset.alias,
        _configDescriptors.createUncachedDescriptors,
        envName
      )
    )
  );
  const loadPresetOverridesDescriptors = (0, _caching.makeWeakCache)(preset =>
    (0, _caching.makeStrongCache)(index =>
      buildOverrideDescriptors(
        preset,
        preset.alias,
        _configDescriptors.createUncachedDescriptors,
        index
      )
    )
  );
  const loadPresetOverridesEnvDescriptors = (0, _caching.makeWeakCache)(
    preset =>
      (0, _caching.makeStrongCache)(index =>
        (0, _caching.makeStrongCache)(envName =>
          buildOverrideEnvDescriptors(
            preset,
            preset.alias,
            _configDescriptors.createUncachedDescriptors,
            index,
            envName
          )
        )
      )
  );
  function buildRootChain(opts, context) {
    const programmaticChain = loadProgrammaticChain(
      {options: opts, dirname: context.cwd},
      context
    );
    if (!programmaticChain) return null;
    let configFile;
    if (typeof opts.configFile === 'string') {
      configFile = (0, _files.loadConfig)(
        opts.configFile,
        context.cwd,
        context.envName,
        context.caller
      );
    } else if (opts.configFile !== false) {
      configFile = (0, _files.findRootConfig)(
        context.root,
        context.envName,
        context.caller
      );
    }
    let {babelrc: babelrc, babelrcRoots: babelrcRoots} = opts;
    let babelrcRootsDirectory = context.cwd;
    const configFileChain = emptyChain();
    if (configFile) {
      const validatedFile = validateConfigFile(configFile);
      const result = loadFileChain(validatedFile, context);
      if (!result) return null;
      if (babelrc === undefined) {
        babelrc = validatedFile.options.babelrc;
      }
      if (babelrcRoots === undefined) {
        babelrcRootsDirectory = validatedFile.dirname;
        babelrcRoots = validatedFile.options.babelrcRoots;
      }
      mergeChain(configFileChain, result);
    }
    const pkgData =
      typeof context.filename === 'string'
        ? (0, _files.findPackageData)(context.filename)
        : null;
    let ignoreFile, babelrcFile;
    const fileChain = emptyChain();
    if (
      (babelrc === true || babelrc === undefined) &&
      pkgData &&
      babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory)
    ) {
      ({ignore: ignoreFile, config: babelrcFile} = (0,
      _files.findRelativeConfig)(pkgData, context.envName, context.caller));
      if (
        ignoreFile &&
        shouldIgnore(context, ignoreFile.ignore, null, ignoreFile.dirname)
      ) {
        return null;
      }
      if (babelrcFile) {
        const result = loadFileChain(validateBabelrcFile(babelrcFile), context);
        if (!result) return null;
        mergeChain(fileChain, result);
      }
    }
    const chain = mergeChain(
      mergeChain(mergeChain(emptyChain(), configFileChain), fileChain),
      programmaticChain
    );
    return {
      plugins: dedupDescriptors(chain.plugins),
      presets: dedupDescriptors(chain.presets),
      options: chain.options.map(o => normalizeOptions(o)),
      ignore: ignoreFile || undefined,
      babelrc: babelrcFile || undefined,
      config: configFile || undefined,
    };
  }
  function babelrcLoadEnabled(
    context,
    pkgData,
    babelrcRoots,
    babelrcRootsDirectory
  ) {
    if (typeof babelrcRoots === 'boolean') return babelrcRoots;
    const absoluteRoot = context.root;
    if (babelrcRoots === undefined) {
      return pkgData.directories.indexOf(absoluteRoot) !== -1;
    }
    let babelrcPatterns = babelrcRoots;
    if (!Array.isArray(babelrcPatterns)) babelrcPatterns = [babelrcPatterns];
    babelrcPatterns = babelrcPatterns.map(pat =>
      typeof pat === 'string'
        ? _path().default.resolve(babelrcRootsDirectory, pat)
        : pat
    );
    if (babelrcPatterns.length === 1 && babelrcPatterns[0] === absoluteRoot) {
      return pkgData.directories.indexOf(absoluteRoot) !== -1;
    }
    return babelrcPatterns.some(pat => {
      if (typeof pat === 'string') {
        pat = (0, _patternToRegex.default)(pat, babelrcRootsDirectory);
      }
      return pkgData.directories.some(directory =>
        matchPattern(pat, babelrcRootsDirectory, directory, context)
      );
    });
  }
  const validateConfigFile = (0, _caching.makeWeakCache)(file => ({
    filepath: file.filepath,
    dirname: file.dirname,
    options: (0, _options.validate)('configfile', file.options),
  }));
  const validateBabelrcFile = (0, _caching.makeWeakCache)(file => ({
    filepath: file.filepath,
    dirname: file.dirname,
    options: (0, _options.validate)('babelrcfile', file.options),
  }));
  const validateExtendFile = (0, _caching.makeWeakCache)(file => ({
    filepath: file.filepath,
    dirname: file.dirname,
    options: (0, _options.validate)('extendsfile', file.options),
  }));
  const loadProgrammaticChain = makeChainWalker({
    root: input =>
      buildRootDescriptors(
        input,
        'base',
        _configDescriptors.createCachedDescriptors
      ),
    env: (input, envName) =>
      buildEnvDescriptors(
        input,
        'base',
        _configDescriptors.createCachedDescriptors,
        envName
      ),
    overrides: (input, index) =>
      buildOverrideDescriptors(
        input,
        'base',
        _configDescriptors.createCachedDescriptors,
        index
      ),
    overridesEnv: (input, index, envName) =>
      buildOverrideEnvDescriptors(
        input,
        'base',
        _configDescriptors.createCachedDescriptors,
        index,
        envName
      ),
  });
  const loadFileChain = makeChainWalker({
    root: file => loadFileDescriptors(file),
    env: (file, envName) => loadFileEnvDescriptors(file)(envName),
    overrides: (file, index) => loadFileOverridesDescriptors(file)(index),
    overridesEnv: (file, index, envName) =>
      loadFileOverridesEnvDescriptors(file)(index)(envName),
  });
  const loadFileDescriptors = (0, _caching.makeWeakCache)(file =>
    buildRootDescriptors(
      file,
      file.filepath,
      _configDescriptors.createUncachedDescriptors
    )
  );
  const loadFileEnvDescriptors = (0, _caching.makeWeakCache)(file =>
    (0, _caching.makeStrongCache)(envName =>
      buildEnvDescriptors(
        file,
        file.filepath,
        _configDescriptors.createUncachedDescriptors,
        envName
      )
    )
  );
  const loadFileOverridesDescriptors = (0, _caching.makeWeakCache)(file =>
    (0, _caching.makeStrongCache)(index =>
      buildOverrideDescriptors(
        file,
        file.filepath,
        _configDescriptors.createUncachedDescriptors,
        index
      )
    )
  );
  const loadFileOverridesEnvDescriptors = (0, _caching.makeWeakCache)(file =>
    (0, _caching.makeStrongCache)(index =>
      (0, _caching.makeStrongCache)(envName =>
        buildOverrideEnvDescriptors(
          file,
          file.filepath,
          _configDescriptors.createUncachedDescriptors,
          index,
          envName
        )
      )
    )
  );
  function buildRootDescriptors(
    {dirname: dirname, options: options},
    alias,
    descriptors
  ) {
    return descriptors(dirname, options, alias);
  }
  function buildEnvDescriptors(
    {dirname: dirname, options: options},
    alias,
    descriptors,
    envName
  ) {
    const opts = options.env && options.env[envName];
    return opts
      ? descriptors(dirname, opts, `${alias}.env["${envName}"]`)
      : null;
  }
  function buildOverrideDescriptors(
    {dirname: dirname, options: options},
    alias,
    descriptors,
    index
  ) {
    const opts = options.overrides && options.overrides[index];
    if (!opts) throw new Error('Assertion failure - missing override');
    return descriptors(dirname, opts, `${alias}.overrides[${index}]`);
  }
  function buildOverrideEnvDescriptors(
    {dirname: dirname, options: options},
    alias,
    descriptors,
    index,
    envName
  ) {
    const override = options.overrides && options.overrides[index];
    if (!override) throw new Error('Assertion failure - missing override');
    const opts = override.env && override.env[envName];
    return opts
      ? descriptors(
          dirname,
          opts,
          `${alias}.overrides[${index}].env["${envName}"]`
        )
      : null;
  }
  function makeChainWalker({
    root: root,
    env: env,
    overrides: overrides,
    overridesEnv: overridesEnv,
  }) {
    return (input, context, files = new Set()) => {
      const {dirname: dirname} = input;
      const flattenedConfigs = [];
      const rootOpts = root(input);
      if (configIsApplicable(rootOpts, dirname, context)) {
        flattenedConfigs.push(rootOpts);
        const envOpts = env(input, context.envName);
        if (envOpts && configIsApplicable(envOpts, dirname, context)) {
          flattenedConfigs.push(envOpts);
        }
        (rootOpts.options.overrides || []).forEach((_, index) => {
          const overrideOps = overrides(input, index);
          if (configIsApplicable(overrideOps, dirname, context)) {
            flattenedConfigs.push(overrideOps);
            const overrideEnvOpts = overridesEnv(input, index, context.envName);
            if (
              overrideEnvOpts &&
              configIsApplicable(overrideEnvOpts, dirname, context)
            ) {
              flattenedConfigs.push(overrideEnvOpts);
            }
          }
        });
      }
      if (
        flattenedConfigs.some(({options: {ignore: ignore, only: only}}) =>
          shouldIgnore(context, ignore, only, dirname)
        )
      ) {
        return null;
      }
      const chain = emptyChain();
      for (const op of flattenedConfigs) {
        if (!mergeExtendsChain(chain, op.options, dirname, context, files)) {
          return null;
        }
        mergeChainOpts(chain, op);
      }
      return chain;
    };
  }
  function mergeExtendsChain(chain, opts, dirname, context, files) {
    if (opts.extends === undefined) return true;
    const file = (0, _files.loadConfig)(
      opts.extends,
      dirname,
      context.envName,
      context.caller
    );
    if (files.has(file)) {
      throw new Error(
        `Configuration cycle detected loading ${file.filepath}.\n` +
          `File already loaded following the config chain:\n` +
          Array.from(files, file => ` - ${file.filepath}`).join('\n')
      );
    }
    files.add(file);
    const fileChain = loadFileChain(validateExtendFile(file), context, files);
    files.delete(file);
    if (!fileChain) return false;
    mergeChain(chain, fileChain);
    return true;
  }
  function mergeChain(target, source) {
    target.options.push(...source.options);
    target.plugins.push(...source.plugins);
    target.presets.push(...source.presets);
    return target;
  }
  function mergeChainOpts(
    target,
    {options: options, plugins: plugins, presets: presets}
  ) {
    target.options.push(options);
    target.plugins.push(...plugins());
    target.presets.push(...presets());
    return target;
  }
  function emptyChain() {
    return {options: [], presets: [], plugins: []};
  }
  function normalizeOptions(opts) {
    const options = Object.assign({}, opts);
    delete options.extends;
    delete options.env;
    delete options.overrides;
    delete options.plugins;
    delete options.presets;
    delete options.passPerPreset;
    delete options.ignore;
    delete options.only;
    delete options.test;
    delete options.include;
    delete options.exclude;
    if (options.hasOwnProperty('sourceMap')) {
      options.sourceMaps = options.sourceMap;
      delete options.sourceMap;
    }
    return options;
  }
  function dedupDescriptors(items) {
    const map = new Map();
    const descriptors = [];
    for (const item of items) {
      if (typeof item.value === 'function') {
        const fnKey = item.value;
        let nameMap = map.get(fnKey);
        if (!nameMap) {
          nameMap = new Map();
          map.set(fnKey, nameMap);
        }
        let desc = nameMap.get(item.name);
        if (!desc) {
          desc = {value: item};
          descriptors.push(desc);
          if (!item.ownPass) nameMap.set(item.name, desc);
        } else {
          desc.value = item;
        }
      } else {
        descriptors.push({value: item});
      }
    }
    return descriptors.reduce((acc, desc) => {
      acc.push(desc.value);
      return acc;
    }, []);
  }
  function configIsApplicable({options: options}, dirname, context) {
    return (
      (options.test === undefined ||
        configFieldIsApplicable(context, options.test, dirname)) &&
      (options.include === undefined ||
        configFieldIsApplicable(context, options.include, dirname)) &&
      (options.exclude === undefined ||
        !configFieldIsApplicable(context, options.exclude, dirname))
    );
  }
  function configFieldIsApplicable(context, test, dirname) {
    const patterns = Array.isArray(test) ? test : [test];
    return matchesPatterns(context, patterns, dirname);
  }
  function shouldIgnore(context, ignore, only, dirname) {
    if (ignore && matchesPatterns(context, ignore, dirname)) {
      debug(
        'Ignored %o because it matched one of %O from %o',
        context.filename,
        ignore,
        dirname
      );
      return true;
    }
    if (only && !matchesPatterns(context, only, dirname)) {
      debug(
        'Ignored %o because it failed to match one of %O from %o',
        context.filename,
        only,
        dirname
      );
      return true;
    }
    return false;
  }
  function matchesPatterns(context, patterns, dirname) {
    return patterns.some(pattern =>
      matchPattern(pattern, dirname, context.filename, context)
    );
  }
  function matchPattern(pattern, dirname, pathToTest, context) {
    if (typeof pattern === 'function') {
      return !!pattern(pathToTest, {
        dirname: dirname,
        envName: context.envName,
        caller: context.caller,
      });
    }
    if (typeof pathToTest !== 'string') {
      throw new Error(
        `Configuration contains string/RegExp pattern, but no filename was passed to Babel`
      );
    }
    if (typeof pattern === 'string') {
      pattern = (0, _patternToRegex.default)(pattern, dirname);
    }
    return pattern.test(pathToTest);
  }
  return configChain;
}
var plugins = {};
Object.defineProperty(plugins, '__esModule', {value: true});
plugins.validatePluginObject = validatePluginObject;
var _optionAssertions = optionAssertions;
const VALIDATORS = {
  name: _optionAssertions.assertString,
  manipulateOptions: _optionAssertions.assertFunction,
  pre: _optionAssertions.assertFunction,
  post: _optionAssertions.assertFunction,
  inherits: _optionAssertions.assertFunction,
  visitor: assertVisitorMap,
  parserOverride: _optionAssertions.assertFunction,
  generatorOverride: _optionAssertions.assertFunction,
};
function assertVisitorMap(key, value) {
  const obj = (0, _optionAssertions.assertObject)(key, value);
  if (obj) {
    Object.keys(obj).forEach(prop => assertVisitorHandler(prop, obj[prop]));
    if (obj.enter || obj.exit) {
      throw new Error(
        `.${key} cannot contain catch-all "enter" or "exit" handlers. Please target individual nodes.`
      );
    }
  }
  return obj;
}
function assertVisitorHandler(key, value) {
  if (value && typeof value === 'object') {
    Object.keys(value).forEach(handler => {
      if (handler !== 'enter' && handler !== 'exit') {
        throw new Error(
          `.visitor["${key}"] may only have .enter and/or .exit handlers.`
        );
      }
    });
  } else if (typeof value !== 'function') {
    throw new Error(`.visitor["${key}"] must be a function`);
  }
  return value;
}
function validatePluginObject(obj) {
  Object.keys(obj).forEach(key => {
    const validator = VALIDATORS[key];
    if (validator) validator(key, obj[key]);
    else throw new Error(`.${key} is not a valid Plugin property`);
  });
  return obj;
}
var partial = {};
var hasRequiredPartial;
function requirePartial() {
  if (hasRequiredPartial) return partial;
  hasRequiredPartial = 1;
  Object.defineProperty(partial, '__esModule', {value: true});
  partial.default = loadPrivatePartialConfig;
  partial.loadPartialConfig = loadPartialConfig;
  function _path() {
    const data = _interopRequireDefault(require$$0$5);
    _path = function () {
      return data;
    };
    return data;
  }
  var _plugin = _interopRequireDefault(plugin$7);
  var _util = util$2;
  var _item = requireItem();
  var _configChain = requireConfigChain();
  var _environment = environment;
  var _options = options;
  var _files = requireFiles();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function resolveRootMode(rootDir, rootMode) {
    switch (rootMode) {
      case 'root':
        return rootDir;
      case 'upward-optional': {
        const upwardRootDir = (0, _files.findConfigUpwards)(rootDir);
        return upwardRootDir === null ? rootDir : upwardRootDir;
      }
      case 'upward': {
        const upwardRootDir = (0, _files.findConfigUpwards)(rootDir);
        if (upwardRootDir !== null) return upwardRootDir;
        throw Object.assign(
          new Error(
            `Babel was run with rootMode:"upward" but a root could not ` +
              `be found when searching upward from "${rootDir}"`
          ),
          {code: 'BABEL_ROOT_NOT_FOUND', dirname: rootDir}
        );
      }
      default:
        throw new Error(`Assertion failure - unknown rootMode value`);
    }
  }
  function loadPrivatePartialConfig(inputOpts) {
    if (
      inputOpts != null &&
      (typeof inputOpts !== 'object' || Array.isArray(inputOpts))
    ) {
      throw new Error('Babel options must be an object, null, or undefined');
    }
    const args = inputOpts
      ? (0, _options.validate)('arguments', inputOpts)
      : {};
    const {
      envName: envName = (0, _environment.getEnv)(),
      cwd: cwd = '.',
      root: rootDir = '.',
      rootMode: rootMode = 'root',
      caller: caller,
    } = args;
    const absoluteCwd = _path().default.resolve(cwd);
    const absoluteRootDir = resolveRootMode(
      _path().default.resolve(absoluteCwd, rootDir),
      rootMode
    );
    const context = {
      filename:
        typeof args.filename === 'string'
          ? _path().default.resolve(cwd, args.filename)
          : undefined,
      cwd: absoluteCwd,
      root: absoluteRootDir,
      envName: envName,
      caller: caller,
    };
    const configChain = (0, _configChain.buildRootChain)(args, context);
    if (!configChain) return null;
    const options = {};
    configChain.options.forEach(opts => {
      (0, _util.mergeOptions)(options, opts);
    });
    options.babelrc = false;
    options.configFile = false;
    options.passPerPreset = false;
    options.envName = context.envName;
    options.cwd = context.cwd;
    options.root = context.root;
    options.filename =
      typeof context.filename === 'string' ? context.filename : undefined;
    options.plugins = configChain.plugins.map(descriptor =>
      (0, _item.createItemFromDescriptor)(descriptor)
    );
    options.presets = configChain.presets.map(descriptor =>
      (0, _item.createItemFromDescriptor)(descriptor)
    );
    return {
      options: options,
      context: context,
      ignore: configChain.ignore,
      babelrc: configChain.babelrc,
      config: configChain.config,
    };
  }
  function loadPartialConfig(inputOpts) {
    const result = loadPrivatePartialConfig(inputOpts);
    if (!result) return null;
    const {
      options: options,
      babelrc: babelrc,
      ignore: ignore,
      config: config,
    } = result;
    (options.plugins || []).forEach(item => {
      if (item.value instanceof _plugin.default) {
        throw new Error(
          'Passing cached plugin instances is not supported in ' +
            'babel.loadPartialConfig()'
        );
      }
    });
    return new PartialConfig(
      options,
      babelrc ? babelrc.filepath : undefined,
      ignore ? ignore.filepath : undefined,
      config ? config.filepath : undefined
    );
  }
  class PartialConfig {
    constructor(options, babelrc, ignore, config) {
      this.options = options;
      this.babelignore = ignore;
      this.babelrc = babelrc;
      this.config = config;
      Object.freeze(this);
    }
    hasFilesystemConfig() {
      return this.babelrc !== undefined || this.config !== undefined;
    }
  }
  Object.freeze(PartialConfig.prototype);
  return partial;
}
var hasRequiredFull;
function requireFull() {
  if (hasRequiredFull) return full;
  hasRequiredFull = 1;
  Object.defineProperty(full, '__esModule', {value: true});
  full.default = loadFullConfig;
  var _util = util$2;
  var context = _interopRequireWildcard(requireLib());
  var _plugin = _interopRequireDefault(plugin$7);
  var _item = requireItem();
  var _configChain = requireConfigChain();
  function _traverse() {
    const data = _interopRequireDefault(requireLib$1());
    _traverse = function () {
      return data;
    };
    return data;
  }
  var _caching = caching;
  var _options = options;
  var _plugins = plugins;
  var _configApi = _interopRequireDefault(requireConfigApi());
  var _partial = _interopRequireDefault(requirePartial());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    } else {
      var newObj = {};
      if (obj != null) {
        for (var key in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc =
              Object.defineProperty && Object.getOwnPropertyDescriptor
                ? Object.getOwnPropertyDescriptor(obj, key)
                : {};
            if (desc.get || desc.set) {
              Object.defineProperty(newObj, key, desc);
            } else {
              newObj[key] = obj[key];
            }
          }
        }
      }
      newObj.default = obj;
      return newObj;
    }
  }
  function loadFullConfig(inputOpts) {
    const result = (0, _partial.default)(inputOpts);
    if (!result) {
      return null;
    }
    const {options: options, context: context} = result;
    const optionDefaults = {};
    const passes = [[]];
    try {
      const {plugins: plugins, presets: presets} = options;
      if (!plugins || !presets) {
        throw new Error('Assertion failure - plugins and presets exist');
      }
      const ignored = (function recurseDescriptors(config, pass) {
        const plugins = config.plugins.reduce((acc, descriptor) => {
          if (descriptor.options !== false) {
            acc.push(loadPluginDescriptor(descriptor, context));
          }
          return acc;
        }, []);
        const presets = config.presets.reduce((acc, descriptor) => {
          if (descriptor.options !== false) {
            acc.push({
              preset: loadPresetDescriptor(descriptor, context),
              pass: descriptor.ownPass ? [] : pass,
            });
          }
          return acc;
        }, []);
        if (presets.length > 0) {
          passes.splice(
            1,
            0,
            ...presets.map(o => o.pass).filter(p => p !== pass)
          );
          for (const _ref of presets) {
            const {preset: preset, pass: pass} = _ref;
            if (!preset) return true;
            const ignored = recurseDescriptors(
              {plugins: preset.plugins, presets: preset.presets},
              pass
            );
            if (ignored) return true;
            preset.options.forEach(opts => {
              (0, _util.mergeOptions)(optionDefaults, opts);
            });
          }
        }
        if (plugins.length > 0) {
          pass.unshift(...plugins);
        }
      })(
        {
          plugins: plugins.map(item => {
            const desc = (0, _item.getItemDescriptor)(item);
            if (!desc) {
              throw new Error('Assertion failure - must be config item');
            }
            return desc;
          }),
          presets: presets.map(item => {
            const desc = (0, _item.getItemDescriptor)(item);
            if (!desc) {
              throw new Error('Assertion failure - must be config item');
            }
            return desc;
          }),
        },
        passes[0]
      );
      if (ignored) return null;
    } catch (e) {
      if (!/^\[BABEL\]/.test(e.message)) {
        e.message = `[BABEL] ${context.filename || 'unknown'}: ${e.message}`;
      }
      throw e;
    }
    const opts = optionDefaults;
    (0, _util.mergeOptions)(opts, options);
    opts.plugins = passes[0];
    opts.presets = passes
      .slice(1)
      .filter(plugins => plugins.length > 0)
      .map(plugins => ({plugins: plugins}));
    opts.passPerPreset = opts.presets.length > 0;
    return {options: opts, passes: passes};
  }
  const loadDescriptor = (0, _caching.makeWeakCache)(
    (
      {value: value, options: options, dirname: dirname, alias: alias},
      cache
    ) => {
      if (options === false) throw new Error('Assertion failure');
      options = options || {};
      let item = value;
      if (typeof value === 'function') {
        const api = Object.assign({}, context, (0, _configApi.default)(cache));
        try {
          item = value(api, options, dirname);
        } catch (e) {
          if (alias) {
            e.message += ` (While processing: ${JSON.stringify(alias)})`;
          }
          throw e;
        }
      }
      if (!item || typeof item !== 'object') {
        throw new Error('Plugin/Preset did not return an object.');
      }
      if (typeof item.then === 'function') {
        throw new Error(
          `You appear to be using an async plugin, ` +
            `which your current version of Babel does not support.` +
            `If you're using a published plugin, ` +
            `you may need to upgrade your @babel/core version.`
        );
      }
      return {value: item, options: options, dirname: dirname, alias: alias};
    }
  );
  function loadPluginDescriptor(descriptor, context) {
    if (descriptor.value instanceof _plugin.default) {
      if (descriptor.options) {
        throw new Error(
          'Passed options to an existing Plugin instance will not work.'
        );
      }
      return descriptor.value;
    }
    return instantiatePlugin(loadDescriptor(descriptor, context), context);
  }
  const instantiatePlugin = (0, _caching.makeWeakCache)(
    (
      {value: value, options: options, dirname: dirname, alias: alias},
      cache
    ) => {
      const pluginObj = (0, _plugins.validatePluginObject)(value);
      const plugin = Object.assign({}, pluginObj);
      if (plugin.visitor) {
        plugin.visitor = _traverse().default.explode(
          Object.assign({}, plugin.visitor)
        );
      }
      if (plugin.inherits) {
        const inheritsDescriptor = {
          name: undefined,
          alias: `${alias}$inherits`,
          value: plugin.inherits,
          options: options,
          dirname: dirname,
        };
        const inherits = cache.invalidate(data =>
          loadPluginDescriptor(inheritsDescriptor, data)
        );
        plugin.pre = chain(inherits.pre, plugin.pre);
        plugin.post = chain(inherits.post, plugin.post);
        plugin.manipulateOptions = chain(
          inherits.manipulateOptions,
          plugin.manipulateOptions
        );
        plugin.visitor = _traverse().default.visitors.merge([
          inherits.visitor || {},
          plugin.visitor || {},
        ]);
      }
      return new _plugin.default(plugin, options, alias);
    }
  );
  const loadPresetDescriptor = (descriptor, context) =>
    (0, _configChain.buildPresetChain)(
      instantiatePreset(loadDescriptor(descriptor, context)),
      context
    );
  const instantiatePreset = (0, _caching.makeWeakCache)(
    ({value: value, dirname: dirname, alias: alias}) => ({
      options: (0, _options.validate)('preset', value),
      alias: alias,
      dirname: dirname,
    })
  );
  function chain(a, b) {
    const fns = [a, b].filter(Boolean);
    if (fns.length <= 1) return fns[0];
    return function (...args) {
      for (const fn of fns) {
        fn.apply(this, args);
      }
    };
  }
  return full;
}
var hasRequiredConfig;
function requireConfig() {
  if (hasRequiredConfig) return config;
  hasRequiredConfig = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.loadOptions = loadOptions;
    Object.defineProperty(exports, 'default', {
      enumerable: true,
      get: function () {
        return _full.default;
      },
    });
    Object.defineProperty(exports, 'loadPartialConfig', {
      enumerable: true,
      get: function () {
        return _partial.loadPartialConfig;
      },
    });
    var _full = _interopRequireDefault(requireFull());
    var _partial = requirePartial();
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {default: obj};
    }
    function loadOptions(opts) {
      const config = (0, _full.default)(opts);
      return config ? config.options : null;
    }
  })(config);
  return config;
}
var transform = {};
var transformation = {};
var pluginPass = {};
Object.defineProperty(pluginPass, '__esModule', {value: true});
pluginPass.default = void 0;
class PluginPass {
  constructor(file, key, options) {
    this._map = new Map();
    this.key = key;
    this.file = file;
    this.opts = options || {};
    this.cwd = file.opts.cwd;
    this.filename = file.opts.filename;
  }
  set(key, val) {
    this._map.set(key, val);
  }
  get(key) {
    return this._map.get(key);
  }
  availableHelper(name, versionRange) {
    return this.file.availableHelper(name, versionRange);
  }
  addHelper(name) {
    return this.file.addHelper(name);
  }
  addImport() {
    return this.file.addImport();
  }
  getModuleName() {
    return this.file.getModuleName();
  }
  buildCodeFrameError(node, msg, Error) {
    return this.file.buildCodeFrameError(node, msg, Error);
  }
}
pluginPass.default = PluginPass;
var blockHoistPlugin = {};
var _isFlattenable;
var hasRequired_isFlattenable;
function require_isFlattenable() {
  if (hasRequired_isFlattenable) return _isFlattenable;
  hasRequired_isFlattenable = 1;
  var Symbol = require_Symbol(),
    isArguments = requireIsArguments(),
    isArray = requireIsArray();
  var spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined;
  function isFlattenable(value) {
    return (
      isArray(value) ||
      isArguments(value) ||
      !!(spreadableSymbol && value && value[spreadableSymbol])
    );
  }
  _isFlattenable = isFlattenable;
  return _isFlattenable;
}
var _baseFlatten;
var hasRequired_baseFlatten;
function require_baseFlatten() {
  if (hasRequired_baseFlatten) return _baseFlatten;
  hasRequired_baseFlatten = 1;
  var arrayPush = require_arrayPush(),
    isFlattenable = require_isFlattenable();
  function baseFlatten(array, depth, predicate, isStrict, result) {
    var index = -1,
      length = array.length;
    predicate || (predicate = isFlattenable);
    result || (result = []);
    while (++index < length) {
      var value = array[index];
      if (depth > 0 && predicate(value)) {
        if (depth > 1) {
          baseFlatten(value, depth - 1, predicate, isStrict, result);
        } else {
          arrayPush(result, value);
        }
      } else if (!isStrict) {
        result[result.length] = value;
      }
    }
    return result;
  }
  _baseFlatten = baseFlatten;
  return _baseFlatten;
}
var _isKey;
var hasRequired_isKey;
function require_isKey() {
  if (hasRequired_isKey) return _isKey;
  hasRequired_isKey = 1;
  var isArray = requireIsArray(),
    isSymbol = requireIsSymbol();
  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;
  function isKey(value, object) {
    if (isArray(value)) {
      return false;
    }
    var type = typeof value;
    if (
      type == 'number' ||
      type == 'symbol' ||
      type == 'boolean' ||
      value == null ||
      isSymbol(value)
    ) {
      return true;
    }
    return (
      reIsPlainProp.test(value) ||
      !reIsDeepProp.test(value) ||
      (object != null && value in Object(object))
    );
  }
  _isKey = isKey;
  return _isKey;
}
var memoize_1;
var hasRequiredMemoize;
function requireMemoize() {
  if (hasRequiredMemoize) return memoize_1;
  hasRequiredMemoize = 1;
  var MapCache = require_MapCache();
  var FUNC_ERROR_TEXT = 'Expected a function';
  function memoize(func, resolver) {
    if (
      typeof func != 'function' ||
      (resolver != null && typeof resolver != 'function')
    ) {
      throw new TypeError(FUNC_ERROR_TEXT);
    }
    var memoized = function () {
      var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;
      if (cache.has(key)) {
        return cache.get(key);
      }
      var result = func.apply(this, args);
      memoized.cache = cache.set(key, result) || cache;
      return result;
    };
    memoized.cache = new (memoize.Cache || MapCache)();
    return memoized;
  }
  memoize.Cache = MapCache;
  memoize_1 = memoize;
  return memoize_1;
}
var _memoizeCapped;
var hasRequired_memoizeCapped;
function require_memoizeCapped() {
  if (hasRequired_memoizeCapped) return _memoizeCapped;
  hasRequired_memoizeCapped = 1;
  var memoize = requireMemoize();
  var MAX_MEMOIZE_SIZE = 500;
  function memoizeCapped(func) {
    var result = memoize(func, function (key) {
      if (cache.size === MAX_MEMOIZE_SIZE) {
        cache.clear();
      }
      return key;
    });
    var cache = result.cache;
    return result;
  }
  _memoizeCapped = memoizeCapped;
  return _memoizeCapped;
}
var _stringToPath;
var hasRequired_stringToPath;
function require_stringToPath() {
  if (hasRequired_stringToPath) return _stringToPath;
  hasRequired_stringToPath = 1;
  var memoizeCapped = require_memoizeCapped();
  var rePropName =
    /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
  var reEscapeChar = /\\(\\)?/g;
  var stringToPath = memoizeCapped(function (string) {
    var result = [];
    if (string.charCodeAt(0) === 46) {
      result.push('');
    }
    string.replace(rePropName, function (match, number, quote, subString) {
      result.push(
        quote ? subString.replace(reEscapeChar, '$1') : number || match
      );
    });
    return result;
  });
  _stringToPath = stringToPath;
  return _stringToPath;
}
var _castPath;
var hasRequired_castPath;
function require_castPath() {
  if (hasRequired_castPath) return _castPath;
  hasRequired_castPath = 1;
  var isArray = requireIsArray(),
    isKey = require_isKey(),
    stringToPath = require_stringToPath(),
    toString = requireToString();
  function castPath(value, object) {
    if (isArray(value)) {
      return value;
    }
    return isKey(value, object) ? [value] : stringToPath(toString(value));
  }
  _castPath = castPath;
  return _castPath;
}
var _toKey;
var hasRequired_toKey;
function require_toKey() {
  if (hasRequired_toKey) return _toKey;
  hasRequired_toKey = 1;
  var isSymbol = requireIsSymbol();
  var INFINITY = 1 / 0;
  function toKey(value) {
    if (typeof value == 'string' || isSymbol(value)) {
      return value;
    }
    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
  }
  _toKey = toKey;
  return _toKey;
}
var _baseGet;
var hasRequired_baseGet;
function require_baseGet() {
  if (hasRequired_baseGet) return _baseGet;
  hasRequired_baseGet = 1;
  var castPath = require_castPath(),
    toKey = require_toKey();
  function baseGet(object, path) {
    path = castPath(path, object);
    var index = 0,
      length = path.length;
    while (object != null && index < length) {
      object = object[toKey(path[index++])];
    }
    return index && index == length ? object : undefined;
  }
  _baseGet = baseGet;
  return _baseGet;
}
var _setCacheAdd;
var hasRequired_setCacheAdd;
function require_setCacheAdd() {
  if (hasRequired_setCacheAdd) return _setCacheAdd;
  hasRequired_setCacheAdd = 1;
  var HASH_UNDEFINED = '__lodash_hash_undefined__';
  function setCacheAdd(value) {
    this.__data__.set(value, HASH_UNDEFINED);
    return this;
  }
  _setCacheAdd = setCacheAdd;
  return _setCacheAdd;
}
var _setCacheHas;
var hasRequired_setCacheHas;
function require_setCacheHas() {
  if (hasRequired_setCacheHas) return _setCacheHas;
  hasRequired_setCacheHas = 1;
  function setCacheHas(value) {
    return this.__data__.has(value);
  }
  _setCacheHas = setCacheHas;
  return _setCacheHas;
}
var _SetCache;
var hasRequired_SetCache;
function require_SetCache() {
  if (hasRequired_SetCache) return _SetCache;
  hasRequired_SetCache = 1;
  var MapCache = require_MapCache(),
    setCacheAdd = require_setCacheAdd(),
    setCacheHas = require_setCacheHas();
  function SetCache(values) {
    var index = -1,
      length = values == null ? 0 : values.length;
    this.__data__ = new MapCache();
    while (++index < length) {
      this.add(values[index]);
    }
  }
  SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
  SetCache.prototype.has = setCacheHas;
  _SetCache = SetCache;
  return _SetCache;
}
var _arraySome;
var hasRequired_arraySome;
function require_arraySome() {
  if (hasRequired_arraySome) return _arraySome;
  hasRequired_arraySome = 1;
  function arraySome(array, predicate) {
    var index = -1,
      length = array == null ? 0 : array.length;
    while (++index < length) {
      if (predicate(array[index], index, array)) {
        return true;
      }
    }
    return false;
  }
  _arraySome = arraySome;
  return _arraySome;
}
var _cacheHas;
var hasRequired_cacheHas;
function require_cacheHas() {
  if (hasRequired_cacheHas) return _cacheHas;
  hasRequired_cacheHas = 1;
  function cacheHas(cache, key) {
    return cache.has(key);
  }
  _cacheHas = cacheHas;
  return _cacheHas;
}
var _equalArrays;
var hasRequired_equalArrays;
function require_equalArrays() {
  if (hasRequired_equalArrays) return _equalArrays;
  hasRequired_equalArrays = 1;
  var SetCache = require_SetCache(),
    arraySome = require_arraySome(),
    cacheHas = require_cacheHas();
  var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;
  function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
    var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      arrLength = array.length,
      othLength = other.length;
    if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
      return false;
    }
    var arrStacked = stack.get(array);
    var othStacked = stack.get(other);
    if (arrStacked && othStacked) {
      return arrStacked == other && othStacked == array;
    }
    var index = -1,
      result = true,
      seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined;
    stack.set(array, other);
    stack.set(other, array);
    while (++index < arrLength) {
      var arrValue = array[index],
        othValue = other[index];
      if (customizer) {
        var compared = isPartial
          ? customizer(othValue, arrValue, index, other, array, stack)
          : customizer(arrValue, othValue, index, array, other, stack);
      }
      if (compared !== undefined) {
        if (compared) {
          continue;
        }
        result = false;
        break;
      }
      if (seen) {
        if (
          !arraySome(other, function (othValue, othIndex) {
            if (
              !cacheHas(seen, othIndex) &&
              (arrValue === othValue ||
                equalFunc(arrValue, othValue, bitmask, customizer, stack))
            ) {
              return seen.push(othIndex);
            }
          })
        ) {
          result = false;
          break;
        }
      } else if (
        !(
          arrValue === othValue ||
          equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )
      ) {
        result = false;
        break;
      }
    }
    stack['delete'](array);
    stack['delete'](other);
    return result;
  }
  _equalArrays = equalArrays;
  return _equalArrays;
}
var _mapToArray;
var hasRequired_mapToArray;
function require_mapToArray() {
  if (hasRequired_mapToArray) return _mapToArray;
  hasRequired_mapToArray = 1;
  function mapToArray(map) {
    var index = -1,
      result = Array(map.size);
    map.forEach(function (value, key) {
      result[++index] = [key, value];
    });
    return result;
  }
  _mapToArray = mapToArray;
  return _mapToArray;
}
var _setToArray;
var hasRequired_setToArray;
function require_setToArray() {
  if (hasRequired_setToArray) return _setToArray;
  hasRequired_setToArray = 1;
  function setToArray(set) {
    var index = -1,
      result = Array(set.size);
    set.forEach(function (value) {
      result[++index] = value;
    });
    return result;
  }
  _setToArray = setToArray;
  return _setToArray;
}
var _equalByTag;
var hasRequired_equalByTag;
function require_equalByTag() {
  if (hasRequired_equalByTag) return _equalByTag;
  hasRequired_equalByTag = 1;
  var Symbol = require_Symbol(),
    Uint8Array = require_Uint8Array(),
    eq = requireEq(),
    equalArrays = require_equalArrays(),
    mapToArray = require_mapToArray(),
    setToArray = require_setToArray();
  var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;
  var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';
  var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';
  var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;
  function equalByTag(
    object,
    other,
    tag,
    bitmask,
    customizer,
    equalFunc,
    stack
  ) {
    switch (tag) {
      case dataViewTag:
        if (
          object.byteLength != other.byteLength ||
          object.byteOffset != other.byteOffset
        ) {
          return false;
        }
        object = object.buffer;
        other = other.buffer;
      case arrayBufferTag:
        if (
          object.byteLength != other.byteLength ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))
        ) {
          return false;
        }
        return true;
      case boolTag:
      case dateTag:
      case numberTag:
        return eq(+object, +other);
      case errorTag:
        return object.name == other.name && object.message == other.message;
      case regexpTag:
      case stringTag:
        return object == other + '';
      case mapTag:
        var convert = mapToArray;
      case setTag:
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
        convert || (convert = setToArray);
        if (object.size != other.size && !isPartial) {
          return false;
        }
        var stacked = stack.get(object);
        if (stacked) {
          return stacked == other;
        }
        bitmask |= COMPARE_UNORDERED_FLAG;
        stack.set(object, other);
        var result = equalArrays(
          convert(object),
          convert(other),
          bitmask,
          customizer,
          equalFunc,
          stack
        );
        stack['delete'](object);
        return result;
      case symbolTag:
        if (symbolValueOf) {
          return symbolValueOf.call(object) == symbolValueOf.call(other);
        }
    }
    return false;
  }
  _equalByTag = equalByTag;
  return _equalByTag;
}
var _equalObjects;
var hasRequired_equalObjects;
function require_equalObjects() {
  if (hasRequired_equalObjects) return _equalObjects;
  hasRequired_equalObjects = 1;
  var getAllKeys = require_getAllKeys();
  var COMPARE_PARTIAL_FLAG = 1;
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
    var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;
    if (objLength != othLength && !isPartial) {
      return false;
    }
    var index = objLength;
    while (index--) {
      var key = objProps[index];
      if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
        return false;
      }
    }
    var objStacked = stack.get(object);
    var othStacked = stack.get(other);
    if (objStacked && othStacked) {
      return objStacked == other && othStacked == object;
    }
    var result = true;
    stack.set(object, other);
    stack.set(other, object);
    var skipCtor = isPartial;
    while (++index < objLength) {
      key = objProps[index];
      var objValue = object[key],
        othValue = other[key];
      if (customizer) {
        var compared = isPartial
          ? customizer(othValue, objValue, key, other, object, stack)
          : customizer(objValue, othValue, key, object, other, stack);
      }
      if (
        !(compared === undefined
          ? objValue === othValue ||
            equalFunc(objValue, othValue, bitmask, customizer, stack)
          : compared)
      ) {
        result = false;
        break;
      }
      skipCtor || (skipCtor = key == 'constructor');
    }
    if (result && !skipCtor) {
      var objCtor = object.constructor,
        othCtor = other.constructor;
      if (
        objCtor != othCtor &&
        'constructor' in object && 'constructor' in other &&
        !(
          typeof objCtor == 'function' &&
          objCtor instanceof objCtor &&
          typeof othCtor == 'function' &&
          othCtor instanceof othCtor
        )
      ) {
        result = false;
      }
    }
    stack['delete'](object);
    stack['delete'](other);
    return result;
  }
  _equalObjects = equalObjects;
  return _equalObjects;
}
var _baseIsEqualDeep;
var hasRequired_baseIsEqualDeep;
function require_baseIsEqualDeep() {
  if (hasRequired_baseIsEqualDeep) return _baseIsEqualDeep;
  hasRequired_baseIsEqualDeep = 1;
  var Stack = require_Stack(),
    equalArrays = require_equalArrays(),
    equalByTag = require_equalByTag(),
    equalObjects = require_equalObjects(),
    getTag = require_getTag(),
    isArray = requireIsArray(),
    isBuffer = requireIsBuffer(),
    isTypedArray = requireIsTypedArray();
  var COMPARE_PARTIAL_FLAG = 1;
  var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function baseIsEqualDeep(
    object,
    other,
    bitmask,
    customizer,
    equalFunc,
    stack
  ) {
    var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);
    objTag = objTag == argsTag ? objectTag : objTag;
    othTag = othTag == argsTag ? objectTag : othTag;
    var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;
    if (isSameTag && isBuffer(object)) {
      if (!isBuffer(other)) {
        return false;
      }
      objIsArr = true;
      objIsObj = false;
    }
    if (isSameTag && !objIsObj) {
      stack || (stack = new Stack());
      return objIsArr || isTypedArray(object)
        ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
        : equalByTag(
            object,
            other,
            objTag,
            bitmask,
            customizer,
            equalFunc,
            stack
          );
    }
    if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
      var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');
      if (objIsWrapped || othIsWrapped) {
        var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;
        stack || (stack = new Stack());
        return equalFunc(
          objUnwrapped,
          othUnwrapped,
          bitmask,
          customizer,
          stack
        );
      }
    }
    if (!isSameTag) {
      return false;
    }
    stack || (stack = new Stack());
    return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
  }
  _baseIsEqualDeep = baseIsEqualDeep;
  return _baseIsEqualDeep;
}
var _baseIsEqual;
var hasRequired_baseIsEqual;
function require_baseIsEqual() {
  if (hasRequired_baseIsEqual) return _baseIsEqual;
  hasRequired_baseIsEqual = 1;
  var baseIsEqualDeep = require_baseIsEqualDeep(),
    isObjectLike = requireIsObjectLike();
  function baseIsEqual(value, other, bitmask, customizer, stack) {
    if (value === other) {
      return true;
    }
    if (
      value == null ||
      other == null ||
      (!isObjectLike(value) && !isObjectLike(other))
    ) {
      return value !== value && other !== other;
    }
    return baseIsEqualDeep(
      value,
      other,
      bitmask,
      customizer,
      baseIsEqual,
      stack
    );
  }
  _baseIsEqual = baseIsEqual;
  return _baseIsEqual;
}
var _baseIsMatch;
var hasRequired_baseIsMatch;
function require_baseIsMatch() {
  if (hasRequired_baseIsMatch) return _baseIsMatch;
  hasRequired_baseIsMatch = 1;
  var Stack = require_Stack(),
    baseIsEqual = require_baseIsEqual();
  var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;
  function baseIsMatch(object, source, matchData, customizer) {
    var index = matchData.length,
      length = index,
      noCustomizer = !customizer;
    if (object == null) {
      return !length;
    }
    object = Object(object);
    while (index--) {
      var data = matchData[index];
      if (
        noCustomizer && data[2]
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
      ) {
        return false;
      }
    }
    while (++index < length) {
      data = matchData[index];
      var key = data[0],
        objValue = object[key],
        srcValue = data[1];
      if (noCustomizer && data[2]) {
        if (objValue === undefined && !(key in object)) {
          return false;
        }
      } else {
        var stack = new Stack();
        if (customizer) {
          var result = customizer(
            objValue,
            srcValue,
            key,
            object,
            source,
            stack
          );
        }
        if (
          !(result === undefined
            ? baseIsEqual(
                srcValue,
                objValue,
                COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG,
                customizer,
                stack
              )
            : result)
        ) {
          return false;
        }
      }
    }
    return true;
  }
  _baseIsMatch = baseIsMatch;
  return _baseIsMatch;
}
var _isStrictComparable;
var hasRequired_isStrictComparable;
function require_isStrictComparable() {
  if (hasRequired_isStrictComparable) return _isStrictComparable;
  hasRequired_isStrictComparable = 1;
  var isObject = requireIsObject();
  function isStrictComparable(value) {
    return value === value && !isObject(value);
  }
  _isStrictComparable = isStrictComparable;
  return _isStrictComparable;
}
var _getMatchData;
var hasRequired_getMatchData;
function require_getMatchData() {
  if (hasRequired_getMatchData) return _getMatchData;
  hasRequired_getMatchData = 1;
  var isStrictComparable = require_isStrictComparable(),
    keys = requireKeys();
  function getMatchData(object) {
    var result = keys(object),
      length = result.length;
    while (length--) {
      var key = result[length],
        value = object[key];
      result[length] = [key, value, isStrictComparable(value)];
    }
    return result;
  }
  _getMatchData = getMatchData;
  return _getMatchData;
}
var _matchesStrictComparable;
var hasRequired_matchesStrictComparable;
function require_matchesStrictComparable() {
  if (hasRequired_matchesStrictComparable) return _matchesStrictComparable;
  hasRequired_matchesStrictComparable = 1;
  function matchesStrictComparable(key, srcValue) {
    return function (object) {
      if (object == null) {
        return false;
      }
      return (
        object[key] === srcValue &&
        (srcValue !== undefined || key in Object(object))
      );
    };
  }
  _matchesStrictComparable = matchesStrictComparable;
  return _matchesStrictComparable;
}
var _baseMatches;
var hasRequired_baseMatches;
function require_baseMatches() {
  if (hasRequired_baseMatches) return _baseMatches;
  hasRequired_baseMatches = 1;
  var baseIsMatch = require_baseIsMatch(),
    getMatchData = require_getMatchData(),
    matchesStrictComparable = require_matchesStrictComparable();
  function baseMatches(source) {
    var matchData = getMatchData(source);
    if (matchData.length == 1 && matchData[0][2]) {
      return matchesStrictComparable(matchData[0][0], matchData[0][1]);
    }
    return function (object) {
      return object === source || baseIsMatch(object, source, matchData);
    };
  }
  _baseMatches = baseMatches;
  return _baseMatches;
}
var get_1;
var hasRequiredGet;
function requireGet() {
  if (hasRequiredGet) return get_1;
  hasRequiredGet = 1;
  var baseGet = require_baseGet();
  function get(object, path, defaultValue) {
    var result = object == null ? undefined : baseGet(object, path);
    return result === undefined ? defaultValue : result;
  }
  get_1 = get;
  return get_1;
}
var _baseHasIn;
var hasRequired_baseHasIn;
function require_baseHasIn() {
  if (hasRequired_baseHasIn) return _baseHasIn;
  hasRequired_baseHasIn = 1;
  function baseHasIn(object, key) {
    return object != null && key in Object(object);
  }
  _baseHasIn = baseHasIn;
  return _baseHasIn;
}
var _hasPath;
var hasRequired_hasPath;
function require_hasPath() {
  if (hasRequired_hasPath) return _hasPath;
  hasRequired_hasPath = 1;
  var castPath = require_castPath(),
    isArguments = requireIsArguments(),
    isArray = requireIsArray(),
    isIndex = require_isIndex(),
    isLength = requireIsLength(),
    toKey = require_toKey();
  function hasPath(object, path, hasFunc) {
    path = castPath(path, object);
    var index = -1,
      length = path.length,
      result = false;
    while (++index < length) {
      var key = toKey(path[index]);
      if (!(result = object != null && hasFunc(object, key))) {
        break;
      }
      object = object[key];
    }
    if (result || ++index != length) {
      return result;
    }
    length = object == null ? 0 : object.length;
    return (
      !!length &&
      isLength(length) &&
      isIndex(key, length) &&
      (isArray(object) || isArguments(object))
    );
  }
  _hasPath = hasPath;
  return _hasPath;
}
var hasIn_1;
var hasRequiredHasIn;
function requireHasIn() {
  if (hasRequiredHasIn) return hasIn_1;
  hasRequiredHasIn = 1;
  var baseHasIn = require_baseHasIn(),
    hasPath = require_hasPath();
  function hasIn(object, path) {
    return object != null && hasPath(object, path, baseHasIn);
  }
  hasIn_1 = hasIn;
  return hasIn_1;
}
var _baseMatchesProperty;
var hasRequired_baseMatchesProperty;
function require_baseMatchesProperty() {
  if (hasRequired_baseMatchesProperty) return _baseMatchesProperty;
  hasRequired_baseMatchesProperty = 1;
  var baseIsEqual = require_baseIsEqual(),
    get = requireGet(),
    hasIn = requireHasIn(),
    isKey = require_isKey(),
    isStrictComparable = require_isStrictComparable(),
    matchesStrictComparable = require_matchesStrictComparable(),
    toKey = require_toKey();
  var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;
  function baseMatchesProperty(path, srcValue) {
    if (isKey(path) && isStrictComparable(srcValue)) {
      return matchesStrictComparable(toKey(path), srcValue);
    }
    return function (object) {
      var objValue = get(object, path);
      return objValue === undefined && objValue === srcValue
        ? hasIn(object, path)
        : baseIsEqual(
            srcValue,
            objValue,
            COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG
          );
    };
  }
  _baseMatchesProperty = baseMatchesProperty;
  return _baseMatchesProperty;
}
var _baseProperty;
var hasRequired_baseProperty;
function require_baseProperty() {
  if (hasRequired_baseProperty) return _baseProperty;
  hasRequired_baseProperty = 1;
  function baseProperty(key) {
    return function (object) {
      return object == null ? undefined : object[key];
    };
  }
  _baseProperty = baseProperty;
  return _baseProperty;
}
var _basePropertyDeep;
var hasRequired_basePropertyDeep;
function require_basePropertyDeep() {
  if (hasRequired_basePropertyDeep) return _basePropertyDeep;
  hasRequired_basePropertyDeep = 1;
  var baseGet = require_baseGet();
  function basePropertyDeep(path) {
    return function (object) {
      return baseGet(object, path);
    };
  }
  _basePropertyDeep = basePropertyDeep;
  return _basePropertyDeep;
}
var property_1;
var hasRequiredProperty;
function requireProperty() {
  if (hasRequiredProperty) return property_1;
  hasRequiredProperty = 1;
  var baseProperty = require_baseProperty(),
    basePropertyDeep = require_basePropertyDeep(),
    isKey = require_isKey(),
    toKey = require_toKey();
  function property(path) {
    return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
  }
  property_1 = property;
  return property_1;
}
var _baseIteratee;
var hasRequired_baseIteratee;
function require_baseIteratee() {
  if (hasRequired_baseIteratee) return _baseIteratee;
  hasRequired_baseIteratee = 1;
  var baseMatches = require_baseMatches(),
    baseMatchesProperty = require_baseMatchesProperty(),
    identity = requireIdentity(),
    isArray = requireIsArray(),
    property = requireProperty();
  function baseIteratee(value) {
    if (typeof value == 'function') {
      return value;
    }
    if (value == null) {
      return identity;
    }
    if (typeof value == 'object') {
      return isArray(value)
        ? baseMatchesProperty(value[0], value[1])
        : baseMatches(value);
    }
    return property(value);
  }
  _baseIteratee = baseIteratee;
  return _baseIteratee;
}
var _createBaseFor;
var hasRequired_createBaseFor;
function require_createBaseFor() {
  if (hasRequired_createBaseFor) return _createBaseFor;
  hasRequired_createBaseFor = 1;
  function createBaseFor(fromRight) {
    return function (object, iteratee, keysFunc) {
      var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;
      while (length--) {
        var key = props[fromRight ? length : ++index];
        if (iteratee(iterable[key], key, iterable) === false) {
          break;
        }
      }
      return object;
    };
  }
  _createBaseFor = createBaseFor;
  return _createBaseFor;
}
var _baseFor;
var hasRequired_baseFor;
function require_baseFor() {
  if (hasRequired_baseFor) return _baseFor;
  hasRequired_baseFor = 1;
  var createBaseFor = require_createBaseFor();
  var baseFor = createBaseFor();
  _baseFor = baseFor;
  return _baseFor;
}
var _baseForOwn;
var hasRequired_baseForOwn;
function require_baseForOwn() {
  if (hasRequired_baseForOwn) return _baseForOwn;
  hasRequired_baseForOwn = 1;
  var baseFor = require_baseFor(),
    keys = requireKeys();
  function baseForOwn(object, iteratee) {
    return object && baseFor(object, iteratee, keys);
  }
  _baseForOwn = baseForOwn;
  return _baseForOwn;
}
var _createBaseEach;
var hasRequired_createBaseEach;
function require_createBaseEach() {
  if (hasRequired_createBaseEach) return _createBaseEach;
  hasRequired_createBaseEach = 1;
  var isArrayLike = requireIsArrayLike();
  function createBaseEach(eachFunc, fromRight) {
    return function (collection, iteratee) {
      if (collection == null) {
        return collection;
      }
      if (!isArrayLike(collection)) {
        return eachFunc(collection, iteratee);
      }
      var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);
      while (fromRight ? index-- : ++index < length) {
        if (iteratee(iterable[index], index, iterable) === false) {
          break;
        }
      }
      return collection;
    };
  }
  _createBaseEach = createBaseEach;
  return _createBaseEach;
}
var _baseEach;
var hasRequired_baseEach;
function require_baseEach() {
  if (hasRequired_baseEach) return _baseEach;
  hasRequired_baseEach = 1;
  var baseForOwn = require_baseForOwn(),
    createBaseEach = require_createBaseEach();
  var baseEach = createBaseEach(baseForOwn);
  _baseEach = baseEach;
  return _baseEach;
}
var _baseMap;
var hasRequired_baseMap;
function require_baseMap() {
  if (hasRequired_baseMap) return _baseMap;
  hasRequired_baseMap = 1;
  var baseEach = require_baseEach(),
    isArrayLike = requireIsArrayLike();
  function baseMap(collection, iteratee) {
    var index = -1,
      result = isArrayLike(collection) ? Array(collection.length) : [];
    baseEach(collection, function (value, key, collection) {
      result[++index] = iteratee(value, key, collection);
    });
    return result;
  }
  _baseMap = baseMap;
  return _baseMap;
}
var _baseSortBy;
var hasRequired_baseSortBy;
function require_baseSortBy() {
  if (hasRequired_baseSortBy) return _baseSortBy;
  hasRequired_baseSortBy = 1;
  function baseSortBy(array, comparer) {
    var length = array.length;
    array.sort(comparer);
    while (length--) {
      array[length] = array[length].value;
    }
    return array;
  }
  _baseSortBy = baseSortBy;
  return _baseSortBy;
}
var _compareAscending;
var hasRequired_compareAscending;
function require_compareAscending() {
  if (hasRequired_compareAscending) return _compareAscending;
  hasRequired_compareAscending = 1;
  var isSymbol = requireIsSymbol();
  function compareAscending(value, other) {
    if (value !== other) {
      var valIsDefined = value !== undefined,
        valIsNull = value === null,
        valIsReflexive = value === value,
        valIsSymbol = isSymbol(value);
      var othIsDefined = other !== undefined,
        othIsNull = other === null,
        othIsReflexive = other === other,
        othIsSymbol = isSymbol(other);
      if (
        (!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||
        (valIsSymbol &&
          othIsDefined &&
          othIsReflexive &&
          !othIsNull &&
          !othIsSymbol) ||
        (valIsNull && othIsDefined && othIsReflexive) ||
        (!valIsDefined && othIsReflexive) ||
        !valIsReflexive
      ) {
        return 1;
      }
      if (
        (!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||
        (othIsSymbol &&
          valIsDefined &&
          valIsReflexive &&
          !valIsNull &&
          !valIsSymbol) ||
        (othIsNull && valIsDefined && valIsReflexive) ||
        (!othIsDefined && valIsReflexive) ||
        !othIsReflexive
      ) {
        return -1;
      }
    }
    return 0;
  }
  _compareAscending = compareAscending;
  return _compareAscending;
}
var _compareMultiple;
var hasRequired_compareMultiple;
function require_compareMultiple() {
  if (hasRequired_compareMultiple) return _compareMultiple;
  hasRequired_compareMultiple = 1;
  var compareAscending = require_compareAscending();
  function compareMultiple(object, other, orders) {
    var index = -1,
      objCriteria = object.criteria,
      othCriteria = other.criteria,
      length = objCriteria.length,
      ordersLength = orders.length;
    while (++index < length) {
      var result = compareAscending(objCriteria[index], othCriteria[index]);
      if (result) {
        if (index >= ordersLength) {
          return result;
        }
        var order = orders[index];
        return result * (order == 'desc' ? -1 : 1);
      }
    }
    return object.index - other.index;
  }
  _compareMultiple = compareMultiple;
  return _compareMultiple;
}
var _baseOrderBy;
var hasRequired_baseOrderBy;
function require_baseOrderBy() {
  if (hasRequired_baseOrderBy) return _baseOrderBy;
  hasRequired_baseOrderBy = 1;
  var arrayMap = require_arrayMap(),
    baseGet = require_baseGet(),
    baseIteratee = require_baseIteratee(),
    baseMap = require_baseMap(),
    baseSortBy = require_baseSortBy(),
    baseUnary = require_baseUnary(),
    compareMultiple = require_compareMultiple(),
    identity = requireIdentity(),
    isArray = requireIsArray();
  function baseOrderBy(collection, iteratees, orders) {
    if (iteratees.length) {
      iteratees = arrayMap(iteratees, function (iteratee) {
        if (isArray(iteratee)) {
          return function (value) {
            return baseGet(
              value,
              iteratee.length === 1 ? iteratee[0] : iteratee
            );
          };
        }
        return iteratee;
      });
    } else {
      iteratees = [identity];
    }
    var index = -1;
    iteratees = arrayMap(iteratees, baseUnary(baseIteratee));
    var result = baseMap(collection, function (value, key, collection) {
      var criteria = arrayMap(iteratees, function (iteratee) {
        return iteratee(value);
      });
      return {criteria: criteria, index: ++index, value: value};
    });
    return baseSortBy(result, function (object, other) {
      return compareMultiple(object, other, orders);
    });
  }
  _baseOrderBy = baseOrderBy;
  return _baseOrderBy;
}
var sortBy_1;
var hasRequiredSortBy;
function requireSortBy() {
  if (hasRequiredSortBy) return sortBy_1;
  hasRequiredSortBy = 1;
  var baseFlatten = require_baseFlatten(),
    baseOrderBy = require_baseOrderBy(),
    baseRest = require_baseRest(),
    isIterateeCall = require_isIterateeCall();
  var sortBy = baseRest(function (collection, iteratees) {
    if (collection == null) {
      return [];
    }
    var length = iteratees.length;
    if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
      iteratees = [];
    } else if (
      length > 2 &&
      isIterateeCall(iteratees[0], iteratees[1], iteratees[2])
    ) {
      iteratees = [iteratees[0]];
    }
    return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
  });
  sortBy_1 = sortBy;
  return sortBy_1;
}
var hasRequiredBlockHoistPlugin;
function requireBlockHoistPlugin() {
  if (hasRequiredBlockHoistPlugin) return blockHoistPlugin;
  hasRequiredBlockHoistPlugin = 1;
  Object.defineProperty(blockHoistPlugin, '__esModule', {value: true});
  blockHoistPlugin.default = loadBlockHoistPlugin;
  function _sortBy() {
    const data = _interopRequireDefault(requireSortBy());
    _sortBy = function () {
      return data;
    };
    return data;
  }
  var _config = _interopRequireDefault(requireConfig());
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  let LOADED_PLUGIN;
  function loadBlockHoistPlugin() {
    if (!LOADED_PLUGIN) {
      const config = (0, _config.default)({
        babelrc: false,
        configFile: false,
        plugins: [blockHoistPlugin$1],
      });
      LOADED_PLUGIN = config ? config.passes[0][0] : undefined;
      if (!LOADED_PLUGIN) throw new Error('Assertion failure');
    }
    return LOADED_PLUGIN;
  }
  const blockHoistPlugin$1 = {
    name: 'internal.blockHoist',
    visitor: {
      Block: {
        exit({node: node}) {
          let hasChange = false;
          for (let i = 0; i < node.body.length; i++) {
            const bodyNode = node.body[i];
            if (bodyNode && bodyNode._blockHoist != null) {
              hasChange = true;
              break;
            }
          }
          if (!hasChange) return;
          node.body = (0, _sortBy().default)(node.body, function (bodyNode) {
            let priority = bodyNode && bodyNode._blockHoist;
            if (priority == null) priority = 1;
            if (priority === true) priority = 2;
            return -1 * priority;
          });
        },
      },
    },
  };
  return blockHoistPlugin;
}
var normalizeOpts = {};
Object.defineProperty(normalizeOpts, '__esModule', {value: true});
normalizeOpts.default = normalizeOptions;
function _path$1() {
  const data = _interopRequireDefault$6(require$$0$5);
  _path$1 = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$6(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function normalizeOptions(config) {
  const {
    filename: filename,
    cwd: cwd,
    filenameRelative: filenameRelative = typeof filename === 'string'
      ? _path$1().default.relative(cwd, filename)
      : 'unknown',
    sourceType: sourceType = 'module',
    inputSourceMap: inputSourceMap,
    sourceMaps: sourceMaps = !!inputSourceMap,
    moduleRoot: moduleRoot,
    sourceRoot: sourceRoot = moduleRoot,
    sourceFileName: sourceFileName = _path$1().default.basename(
      filenameRelative
    ),
    comments: comments = true,
    compact: compact = 'auto',
  } = config.options;
  const opts = config.options;
  const options = Object.assign({}, opts, {
    parserOpts: Object.assign(
      {
        sourceType:
          _path$1().default.extname(filenameRelative) === '.mjs'
            ? 'module'
            : sourceType,
        sourceFileName: filename,
        plugins: [],
      },
      opts.parserOpts
    ),
    generatorOpts: Object.assign(
      {
        filename: filename,
        auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
        auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
        retainLines: opts.retainLines,
        comments: comments,
        shouldPrintComment: opts.shouldPrintComment,
        compact: compact,
        minified: opts.minified,
        sourceMaps: sourceMaps,
        sourceRoot: sourceRoot,
        sourceFileName: sourceFileName,
      },
      opts.generatorOpts
    ),
  });
  for (const plugins of config.passes) {
    for (const plugin of plugins) {
      if (plugin.manipulateOptions) {
        plugin.manipulateOptions(options, options.parserOpts);
      }
    }
  }
  return options;
}
var normalizeFile$1 = {};
var cloneDeep_1;
var hasRequiredCloneDeep;
function requireCloneDeep() {
  if (hasRequiredCloneDeep) return cloneDeep_1;
  hasRequiredCloneDeep = 1;
  var baseClone = require_baseClone();
  var CLONE_DEEP_FLAG = 1,
    CLONE_SYMBOLS_FLAG = 4;
  function cloneDeep(value) {
    return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
  }
  cloneDeep_1 = cloneDeep;
  return cloneDeep_1;
}
var convertSourceMap = {};
var safeBuffer = {exports: {}};
var hasRequiredSafeBuffer;
function requireSafeBuffer() {
  if (hasRequiredSafeBuffer) return safeBuffer.exports;
  hasRequiredSafeBuffer = 1;
  (function (module, exports) {
    var buffer = require$$0$6;
    var Buffer = buffer.Buffer;
    function copyProps(src, dst) {
      for (var key in src) {
        dst[key] = src[key];
      }
    }
    if (
      Buffer.from &&
      Buffer.alloc &&
      Buffer.allocUnsafe &&
      Buffer.allocUnsafeSlow
    ) {
      module.exports = buffer;
    } else {
      copyProps(buffer, exports);
      exports.Buffer = SafeBuffer;
    }
    function SafeBuffer(arg, encodingOrOffset, length) {
      return Buffer(arg, encodingOrOffset, length);
    }
    copyProps(Buffer, SafeBuffer);
    SafeBuffer.from = function (arg, encodingOrOffset, length) {
      if (typeof arg === 'number') {
        throw new TypeError('Argument must not be a number');
      }
      return Buffer(arg, encodingOrOffset, length);
    };
    SafeBuffer.alloc = function (size, fill, encoding) {
      if (typeof size !== 'number') {
        throw new TypeError('Argument must be a number');
      }
      var buf = Buffer(size);
      if (fill !== undefined) {
        if (typeof encoding === 'string') {
          buf.fill(fill, encoding);
        } else {
          buf.fill(fill);
        }
      } else {
        buf.fill(0);
      }
      return buf;
    };
    SafeBuffer.allocUnsafe = function (size) {
      if (typeof size !== 'number') {
        throw new TypeError('Argument must be a number');
      }
      return Buffer(size);
    };
    SafeBuffer.allocUnsafeSlow = function (size) {
      if (typeof size !== 'number') {
        throw new TypeError('Argument must be a number');
      }
      return buffer.SlowBuffer(size);
    };
  })(safeBuffer, safeBuffer.exports);
  return safeBuffer.exports;
}
var hasRequiredConvertSourceMap;
function requireConvertSourceMap() {
  if (hasRequiredConvertSourceMap) return convertSourceMap;
  hasRequiredConvertSourceMap = 1;
  (function (exports) {
    var fs = require$$0$4;
    var path = require$$0$5;
    var SafeBuffer = requireSafeBuffer();
    Object.defineProperty(exports, 'commentRegex', {
      get: function getCommentRegex() {
        return /^\s*\/(?:\/|\*)[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/gm;
      },
    });
    Object.defineProperty(exports, 'mapFileCommentRegex', {
      get: function getMapFileCommentRegex() {
        return /(?:\/\/[@#][ \t]+sourceMappingURL=([^\s'"`]+?)[ \t]*$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^\*]+?)[ \t]*(?:\*\/){1}[ \t]*$)/gm;
      },
    });
    function decodeBase64(base64) {
      return (SafeBuffer.Buffer.from(base64, 'base64') || '').toString();
    }
    function stripComment(sm) {
      return sm.split(',').pop();
    }
    function readFromFileMap(sm, dir) {
      var r = exports.mapFileCommentRegex.exec(sm);
      var filename = r[1] || r[2];
      var filepath = path.resolve(dir, filename);
      try {
        return fs.readFileSync(filepath, 'utf8');
      } catch (e) {
        throw new Error(
          'An error occurred while trying to read the map file at ' +
            filepath +
            '\n' +
            e
        );
      }
    }
    function Converter(sm, opts) {
      opts = opts || {};
      if (opts.isFileComment) sm = readFromFileMap(sm, opts.commentFileDir);
      if (opts.hasComment) sm = stripComment(sm);
      if (opts.isEncoded) sm = decodeBase64(sm);
      if (opts.isJSON || opts.isEncoded) sm = JSON.parse(sm);
      this.sourcemap = sm;
    }
    Converter.prototype.toJSON = function (space) {
      return JSON.stringify(this.sourcemap, null, space);
    };
    Converter.prototype.toBase64 = function () {
      var json = this.toJSON();
      return (SafeBuffer.Buffer.from(json, 'utf8') || '').toString('base64');
    };
    Converter.prototype.toComment = function (options) {
      var base64 = this.toBase64();
      var data =
        'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;
      return options && options.multiline
        ? '/*# ' + data + ' */'
        : '//# ' + data;
    };
    Converter.prototype.toObject = function () {
      return JSON.parse(this.toJSON());
    };
    Converter.prototype.addProperty = function (key, value) {
      if (this.sourcemap.hasOwnProperty(key))
        throw new Error(
          'property "' +
            key +
            '" already exists on the sourcemap, use set property instead'
        );
      return this.setProperty(key, value);
    };
    Converter.prototype.setProperty = function (key, value) {
      this.sourcemap[key] = value;
      return this;
    };
    Converter.prototype.getProperty = function (key) {
      return this.sourcemap[key];
    };
    exports.fromObject = function (obj) {
      return new Converter(obj);
    };
    exports.fromJSON = function (json) {
      return new Converter(json, {isJSON: true});
    };
    exports.fromBase64 = function (base64) {
      return new Converter(base64, {isEncoded: true});
    };
    exports.fromComment = function (comment) {
      comment = comment.replace(/^\/\*/g, '//').replace(/\*\/$/g, '');
      return new Converter(comment, {isEncoded: true, hasComment: true});
    };
    exports.fromMapFileComment = function (comment, dir) {
      return new Converter(comment, {
        commentFileDir: dir,
        isFileComment: true,
        isJSON: true,
      });
    };
    exports.fromSource = function (content) {
      var m = content.match(exports.commentRegex);
      return m ? exports.fromComment(m.pop()) : null;
    };
    exports.fromMapFileSource = function (content, dir) {
      var m = content.match(exports.mapFileCommentRegex);
      return m ? exports.fromMapFileComment(m.pop(), dir) : null;
    };
    exports.removeComments = function (src) {
      return src.replace(exports.commentRegex, '');
    };
    exports.removeMapFileComments = function (src) {
      return src.replace(exports.mapFileCommentRegex, '');
    };
    exports.generateMapFileComment = function (file, options) {
      var data = 'sourceMappingURL=' + file;
      return options && options.multiline
        ? '/*# ' + data + ' */'
        : '//# ' + data;
    };
  })(convertSourceMap);
  return convertSourceMap;
}
var missingPluginHelper = {};
Object.defineProperty(missingPluginHelper, '__esModule', {value: true});
missingPluginHelper.default = generateMissingPluginMessage;
const pluginNameMap = {
  classProperties: {
    syntax: {
      name: '@babel/plugin-syntax-class-properties',
      url: 'https://git.io/vb4yQ',
    },
    transform: {
      name: '@babel/plugin-proposal-class-properties',
      url: 'https://git.io/vb4SL',
    },
  },
  decorators: {
    syntax: {
      name: '@babel/plugin-syntax-decorators',
      url: 'https://git.io/vb4y9',
    },
    transform: {
      name: '@babel/plugin-proposal-decorators',
      url: 'https://git.io/vb4ST',
    },
  },
  doExpressions: {
    syntax: {
      name: '@babel/plugin-syntax-do-expressions',
      url: 'https://git.io/vb4yh',
    },
    transform: {
      name: '@babel/plugin-proposal-do-expressions',
      url: 'https://git.io/vb4S3',
    },
  },
  dynamicImport: {
    syntax: {
      name: '@babel/plugin-syntax-dynamic-import',
      url: 'https://git.io/vb4Sv',
    },
  },
  exportDefaultFrom: {
    syntax: {
      name: '@babel/plugin-syntax-export-default-from',
      url: 'https://git.io/vb4SO',
    },
    transform: {
      name: '@babel/plugin-proposal-export-default-from',
      url: 'https://git.io/vb4yH',
    },
  },
  exportNamespaceFrom: {
    syntax: {
      name: '@babel/plugin-syntax-export-namespace-from',
      url: 'https://git.io/vb4Sf',
    },
    transform: {
      name: '@babel/plugin-proposal-export-namespace-from',
      url: 'https://git.io/vb4SG',
    },
  },
  flow: {
    syntax: {name: '@babel/plugin-syntax-flow', url: 'https://git.io/vb4yb'},
    transform: {
      name: '@babel/plugin-transform-flow-strip-types',
      url: 'https://git.io/vb49g',
    },
  },
  functionBind: {
    syntax: {
      name: '@babel/plugin-syntax-function-bind',
      url: 'https://git.io/vb4y7',
    },
    transform: {
      name: '@babel/plugin-proposal-function-bind',
      url: 'https://git.io/vb4St',
    },
  },
  functionSent: {
    syntax: {
      name: '@babel/plugin-syntax-function-sent',
      url: 'https://git.io/vb4yN',
    },
    transform: {
      name: '@babel/plugin-proposal-function-sent',
      url: 'https://git.io/vb4SZ',
    },
  },
  importMeta: {
    syntax: {
      name: '@babel/plugin-syntax-import-meta',
      url: 'https://git.io/vbKK6',
    },
  },
  jsx: {
    syntax: {name: '@babel/plugin-syntax-jsx', url: 'https://git.io/vb4yA'},
    transform: {
      name: '@babel/plugin-transform-react-jsx',
      url: 'https://git.io/vb4yd',
    },
  },
  logicalAssignment: {
    syntax: {
      name: '@babel/plugin-syntax-logical-assignment-operators',
      url: 'https://git.io/vAlBp',
    },
    transform: {
      name: '@babel/plugin-proposal-logical-assignment-operators',
      url: 'https://git.io/vAlRe',
    },
  },
  nullishCoalescingOperator: {
    syntax: {
      name: '@babel/plugin-syntax-nullish-coalescing-operator',
      url: 'https://git.io/vb4yx',
    },
    transform: {
      name: '@babel/plugin-proposal-nullish-coalescing-operator',
      url: 'https://git.io/vb4Se',
    },
  },
  numericSeparator: {
    syntax: {
      name: '@babel/plugin-syntax-numeric-separator',
      url: 'https://git.io/vb4Sq',
    },
    transform: {
      name: '@babel/plugin-proposal-numeric-separator',
      url: 'https://git.io/vb4yS',
    },
  },
  optionalChaining: {
    syntax: {
      name: '@babel/plugin-syntax-optional-chaining',
      url: 'https://git.io/vb4Sc',
    },
    transform: {
      name: '@babel/plugin-proposal-optional-chaining',
      url: 'https://git.io/vb4Sk',
    },
  },
  pipelineOperator: {
    syntax: {
      name: '@babel/plugin-syntax-pipeline-operator',
      url: 'https://git.io/vb4yj',
    },
    transform: {
      name: '@babel/plugin-proposal-pipeline-operator',
      url: 'https://git.io/vb4SU',
    },
  },
  throwExpressions: {
    syntax: {
      name: '@babel/plugin-syntax-throw-expressions',
      url: 'https://git.io/vb4SJ',
    },
    transform: {
      name: '@babel/plugin-proposal-throw-expressions',
      url: 'https://git.io/vb4yF',
    },
  },
  typescript: {
    syntax: {
      name: '@babel/plugin-syntax-typescript',
      url: 'https://git.io/vb4SC',
    },
    transform: {
      name: '@babel/plugin-transform-typescript',
      url: 'https://git.io/vb4Sm',
    },
  },
  asyncGenerators: {
    syntax: {
      name: '@babel/plugin-syntax-async-generators',
      url: 'https://git.io/vb4SY',
    },
    transform: {
      name: '@babel/plugin-proposal-async-generator-functions',
      url: 'https://git.io/vb4yp',
    },
  },
  objectRestSpread: {
    syntax: {
      name: '@babel/plugin-syntax-object-rest-spread',
      url: 'https://git.io/vb4y5',
    },
    transform: {
      name: '@babel/plugin-proposal-object-rest-spread',
      url: 'https://git.io/vb4Ss',
    },
  },
  optionalCatchBinding: {
    syntax: {
      name: '@babel/plugin-syntax-optional-catch-binding',
      url: 'https://git.io/vb4Sn',
    },
    transform: {
      name: '@babel/plugin-proposal-optional-catch-binding',
      url: 'https://git.io/vb4SI',
    },
  },
};
const getNameURLCombination = ({name: name, url: url}) => `${name} (${url})`;
function generateMissingPluginMessage(missingPluginName, loc, codeFrame) {
  let helpMessage =
    `Support for the experimental syntax '${missingPluginName}' isn't currently enabled ` +
    `(${loc.line}:${loc.column + 1}):\n\n` +
    codeFrame;
  const pluginInfo = pluginNameMap[missingPluginName];
  if (pluginInfo) {
    const {syntax: syntaxPlugin, transform: transformPlugin} = pluginInfo;
    if (syntaxPlugin) {
      if (transformPlugin) {
        const transformPluginInfo = getNameURLCombination(transformPlugin);
        helpMessage +=
          `\n\nAdd ${transformPluginInfo} to the 'plugins' section of your Babel config ` +
          `to enable transformation.`;
      } else {
        const syntaxPluginInfo = getNameURLCombination(syntaxPlugin);
        helpMessage +=
          `\n\nAdd ${syntaxPluginInfo} to the 'plugins' section of your Babel config ` +
          `to enable parsing.`;
      }
    }
  }
  return helpMessage;
}
Object.defineProperty(normalizeFile$1, '__esModule', {value: true});
normalizeFile$1.default = normalizeFile;
function _path() {
  const data = _interopRequireDefault$5(require$$0$5);
  _path = function () {
    return data;
  };
  return data;
}
function _debug() {
  const data = _interopRequireDefault$5(requireSrc$1());
  _debug = function () {
    return data;
  };
  return data;
}
function _cloneDeep() {
  const data = _interopRequireDefault$5(requireCloneDeep());
  _cloneDeep = function () {
    return data;
  };
  return data;
}
function t() {
  const data = _interopRequireWildcard$1(t$d);
  t = function () {
    return data;
  };
  return data;
}
function _convertSourceMap$1() {
  const data = _interopRequireDefault$5(requireConvertSourceMap());
  _convertSourceMap$1 = function () {
    return data;
  };
  return data;
}
function _parser() {
  const data = lib$g;
  _parser = function () {
    return data;
  };
  return data;
}
function _codeFrame() {
  const data = requireLib$e();
  _codeFrame = function () {
    return data;
  };
  return data;
}
var _file = _interopRequireDefault$5(file);
var _missingPluginHelper = _interopRequireDefault$5(missingPluginHelper);
function _interopRequireWildcard$1(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
function _interopRequireDefault$5(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const debug = (0, _debug().default)('babel:transform:file');
function normalizeFile(pluginPasses, options, code, ast) {
  code = `${code || ''}`;
  let inputMap = null;
  if (options.inputSourceMap !== false) {
    if (typeof options.inputSourceMap === 'object') {
      inputMap = _convertSourceMap$1().default.fromObject(
        options.inputSourceMap
      );
    }
    if (!inputMap) {
      try {
        inputMap = _convertSourceMap$1().default.fromSource(code);
        if (inputMap) {
          code = _convertSourceMap$1().default.removeComments(code);
        }
      } catch (err) {
        debug('discarding unknown inline input sourcemap', err);
        code = _convertSourceMap$1().default.removeComments(code);
      }
    }
    if (!inputMap) {
      if (typeof options.filename === 'string') {
        try {
          inputMap = _convertSourceMap$1().default.fromMapFileSource(
            code,
            _path().default.dirname(options.filename)
          );
          if (inputMap) {
            code = _convertSourceMap$1().default.removeMapFileComments(code);
          }
        } catch (err) {
          debug('discarding unknown file input sourcemap', err);
          code = _convertSourceMap$1().default.removeMapFileComments(code);
        }
      } else {
        debug('discarding un-loadable file input sourcemap');
        code = _convertSourceMap$1().default.removeMapFileComments(code);
      }
    }
  }
  if (ast) {
    if (ast.type === 'Program') {
      ast = t().file(ast, [], []);
    } else if (ast.type !== 'File') {
      throw new Error('AST root must be a Program or File node');
    }
    ast = (0, _cloneDeep().default)(ast);
  } else {
    ast = parser(pluginPasses, options, code);
  }
  return new _file.default(options, {code: code, ast: ast, inputMap: inputMap});
}
function parser(
  pluginPasses,
  {
    parserOpts: parserOpts,
    highlightCode: highlightCode = true,
    filename: filename = 'unknown',
  },
  code
) {
  try {
    const results = [];
    for (const plugins of pluginPasses) {
      for (const plugin of plugins) {
        const {parserOverride: parserOverride} = plugin;
        if (parserOverride) {
          const ast = parserOverride(code, parserOpts, _parser().parse);
          if (ast !== undefined) results.push(ast);
        }
      }
    }
    if (results.length === 0) {
      return (0, _parser().parse)(code, parserOpts);
    } else if (results.length === 1) {
      if (typeof results[0].then === 'function') {
        throw new Error(
          `You appear to be using an async codegen plugin, ` +
            `which your current version of Babel does not support. ` +
            `If you're using a published plugin, you may need to upgrade ` +
            `your @babel/core version.`
        );
      }
      return results[0];
    }
    throw new Error('More than one plugin attempted to override parsing.');
  } catch (err) {
    if (err.code === 'BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED') {
      err.message +=
        "\nConsider renaming the file to '.mjs', or setting sourceType:module " +
        'or sourceType:unambiguous in your Babel config for this file.';
    }
    const {loc: loc, missingPlugin: missingPlugin} = err;
    if (loc) {
      const codeFrame = (0, _codeFrame().codeFrameColumns)(
        code,
        {start: {line: loc.line, column: loc.column + 1}},
        {highlightCode: highlightCode}
      );
      if (missingPlugin) {
        err.message =
          `${filename}: ` +
          (0, _missingPluginHelper.default)(missingPlugin[0], loc, codeFrame);
      } else {
        err.message = `${filename}: ${err.message}\n\n` + codeFrame;
      }
      err.code = 'BABEL_PARSE_ERROR';
    }
    throw err;
  }
}
var generate$1 = {};
var mergeMap = {};
Object.defineProperty(mergeMap, '__esModule', {value: true});
mergeMap.default = mergeSourceMap;
function _sourceMap() {
  const data = _interopRequireDefault$4(requireSourceMap());
  _sourceMap = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault$4(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function mergeSourceMap(inputMap, map) {
  const input = buildMappingData(inputMap);
  const output = buildMappingData(map);
  const mergedGenerator = new (_sourceMap().default.SourceMapGenerator)();
  for (const _ref of input.sources) {
    const {source: source} = _ref;
    if (typeof source.content === 'string') {
      mergedGenerator.setSourceContent(source.path, source.content);
    }
  }
  if (output.sources.length === 1) {
    const defaultSource = output.sources[0];
    const insertedMappings = new Map();
    eachInputGeneratedRange(input, (generated, original, source) => {
      eachOverlappingGeneratedOutputRange(defaultSource, generated, item => {
        const key = makeMappingKey(item);
        if (insertedMappings.has(key)) return;
        insertedMappings.set(key, item);
        mergedGenerator.addMapping({
          source: source.path,
          original: {line: original.line, column: original.columnStart},
          generated: {line: item.line, column: item.columnStart},
          name: original.name,
        });
      });
    });
    for (const item of insertedMappings.values()) {
      if (item.columnEnd === Infinity) {
        continue;
      }
      const clearItem = {line: item.line, columnStart: item.columnEnd};
      const key = makeMappingKey(clearItem);
      if (insertedMappings.has(key)) {
        continue;
      }
      mergedGenerator.addMapping({
        generated: {line: clearItem.line, column: clearItem.columnStart},
      });
    }
  }
  const result = mergedGenerator.toJSON();
  if (typeof input.sourceRoot === 'string') {
    result.sourceRoot = input.sourceRoot;
  }
  return result;
}
function makeMappingKey(item) {
  return `${item.line}/${item.columnStart}`;
}
function eachOverlappingGeneratedOutputRange(
  outputFile,
  inputGeneratedRange,
  callback
) {
  const overlappingOriginal = filterApplicableOriginalRanges(
    outputFile,
    inputGeneratedRange
  );
  for (const _ref2 of overlappingOriginal) {
    const {generated: generated} = _ref2;
    for (const item of generated) {
      callback(item);
    }
  }
}
function filterApplicableOriginalRanges(
  {mappings: mappings},
  {line: line, columnStart: columnStart, columnEnd: columnEnd}
) {
  return filterSortedArray(mappings, ({original: outOriginal}) => {
    if (line > outOriginal.line) return -1;
    if (line < outOriginal.line) return 1;
    if (columnStart >= outOriginal.columnEnd) return -1;
    if (columnEnd <= outOriginal.columnStart) return 1;
    return 0;
  });
}
function eachInputGeneratedRange(map, callback) {
  for (const _ref3 of map.sources) {
    const {source: source, mappings: mappings} = _ref3;
    for (const _ref4 of mappings) {
      const {original: original, generated: generated} = _ref4;
      for (const item of generated) {
        callback(item, original, source);
      }
    }
  }
}
function buildMappingData(map) {
  const consumer = new (_sourceMap().default.SourceMapConsumer)(
    Object.assign({}, map, {sourceRoot: null})
  );
  const sources = new Map();
  const mappings = new Map();
  let last = null;
  consumer.computeColumnSpans();
  consumer.eachMapping(
    m => {
      if (m.originalLine === null) return;
      let source = sources.get(m.source);
      if (!source) {
        source = {
          path: m.source,
          content: consumer.sourceContentFor(m.source, true),
        };
        sources.set(m.source, source);
      }
      let sourceData = mappings.get(source);
      if (!sourceData) {
        sourceData = {source: source, mappings: []};
        mappings.set(source, sourceData);
      }
      const obj = {
        line: m.originalLine,
        columnStart: m.originalColumn,
        columnEnd: Infinity,
        name: m.name,
      };
      if (
        last &&
        last.source === source &&
        last.mapping.line === m.originalLine
      ) {
        last.mapping.columnEnd = m.originalColumn;
      }
      last = {source: source, mapping: obj};
      sourceData.mappings.push({
        original: obj,
        generated: consumer
          .allGeneratedPositionsFor({
            source: m.source,
            line: m.originalLine,
            column: m.originalColumn,
          })
          .map(item => ({
            line: item.line,
            columnStart: item.column,
            columnEnd: item.lastColumn + 1,
          })),
      });
    },
    null,
    _sourceMap().default.SourceMapConsumer.ORIGINAL_ORDER
  );
  return {
    file: map.file,
    sourceRoot: map.sourceRoot,
    sources: Array.from(mappings.values()),
  };
}
function findInsertionLocation(array, callback) {
  let left = 0;
  let right = array.length;
  while (left < right) {
    const mid = Math.floor((left + right) / 2);
    const item = array[mid];
    const result = callback(item);
    if (result === 0) {
      left = mid;
      break;
    }
    if (result >= 0) {
      right = mid;
    } else {
      left = mid + 1;
    }
  }
  let i = left;
  if (i < array.length) {
    while (i >= 0 && callback(array[i]) >= 0) {
      i--;
    }
    return i + 1;
  }
  return i;
}
function filterSortedArray(array, callback) {
  const start = findInsertionLocation(array, callback);
  const results = [];
  for (let i = start; i < array.length && callback(array[i]) === 0; i++) {
    results.push(array[i]);
  }
  return results;
}
Object.defineProperty(generate$1, '__esModule', {value: true});
generate$1.default = generateCode;
function _convertSourceMap() {
  const data = _interopRequireDefault$3(requireConvertSourceMap());
  _convertSourceMap = function () {
    return data;
  };
  return data;
}
function _generator() {
  const data = _interopRequireDefault$3(lib$1);
  _generator = function () {
    return data;
  };
  return data;
}
var _mergeMap = _interopRequireDefault$3(mergeMap);
function _interopRequireDefault$3(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
function generateCode(pluginPasses, file) {
  const {opts: opts, ast: ast, code: code, inputMap: inputMap} = file;
  const results = [];
  for (const plugins of pluginPasses) {
    for (const plugin of plugins) {
      const {generatorOverride: generatorOverride} = plugin;
      if (generatorOverride) {
        const result = generatorOverride(
          ast,
          opts.generatorOpts,
          code,
          _generator().default
        );
        if (result !== undefined) results.push(result);
      }
    }
  }
  let result;
  if (results.length === 0) {
    result = (0, _generator().default)(ast, opts.generatorOpts, code);
  } else if (results.length === 1) {
    result = results[0];
    if (typeof result.then === 'function') {
      throw new Error(
        `You appear to be using an async parser plugin, ` +
          `which your current version of Babel does not support. ` +
          `If you're using a published plugin, ` +
          `you may need to upgrade your @babel/core version.`
      );
    }
  } else {
    throw new Error('More than one plugin attempted to override codegen.');
  }
  let {code: outputCode, map: outputMap} = result;
  if (outputMap && inputMap) {
    outputMap = (0, _mergeMap.default)(inputMap.toObject(), outputMap);
  }
  if (opts.sourceMaps === 'inline' || opts.sourceMaps === 'both') {
    outputCode +=
      '\n' + _convertSourceMap().default.fromObject(outputMap).toComment();
  }
  if (opts.sourceMaps === 'inline') {
    outputMap = null;
  }
  return {outputCode: outputCode, outputMap: outputMap};
}
var hasRequiredTransformation;
function requireTransformation() {
  if (hasRequiredTransformation) return transformation;
  hasRequiredTransformation = 1;
  Object.defineProperty(transformation, '__esModule', {value: true});
  transformation.runAsync = runAsync;
  transformation.runSync = runSync;
  function _traverse() {
    const data = _interopRequireDefault(requireLib$1());
    _traverse = function () {
      return data;
    };
    return data;
  }
  var _pluginPass = _interopRequireDefault(pluginPass);
  var _blockHoistPlugin = _interopRequireDefault(requireBlockHoistPlugin());
  var _normalizeOpts = _interopRequireDefault(normalizeOpts);
  var _normalizeFile = _interopRequireDefault(normalizeFile$1);
  var _generate = _interopRequireDefault(generate$1);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  function runAsync(config, code, ast, callback) {
    let result;
    try {
      result = runSync(config, code, ast);
    } catch (err) {
      return callback(err);
    }
    return callback(null, result);
  }
  function runSync(config, code, ast) {
    const file = (0, _normalizeFile.default)(
      config.passes,
      (0, _normalizeOpts.default)(config),
      code,
      ast
    );
    transformFile(file, config.passes);
    const opts = file.opts;
    const {outputCode: outputCode, outputMap: outputMap} =
      opts.code !== false ? (0, _generate.default)(config.passes, file) : {};
    return {
      metadata: file.metadata,
      options: opts,
      ast: opts.ast === true ? file.ast : null,
      code: outputCode === undefined ? null : outputCode,
      map: outputMap === undefined ? null : outputMap,
      sourceType: file.ast.program.sourceType,
    };
  }
  function transformFile(file, pluginPasses) {
    for (const pluginPairs of pluginPasses) {
      const passPairs = [];
      const passes = [];
      const visitors = [];
      for (const plugin of pluginPairs.concat([
        (0, _blockHoistPlugin.default)(),
      ])) {
        const pass = new _pluginPass.default(file, plugin.key, plugin.options);
        passPairs.push([plugin, pass]);
        passes.push(pass);
        visitors.push(plugin.visitor);
      }
      for (const [plugin, pass] of passPairs) {
        const fn = plugin.pre;
        if (fn) {
          const result = fn.call(pass, file);
          if (isThenable(result)) {
            throw new Error(
              `You appear to be using an plugin with an async .pre, ` +
                `which your current version of Babel does not support.` +
                `If you're using a published plugin, you may need to upgrade ` +
                `your @babel/core version.`
            );
          }
        }
      }
      const visitor = _traverse().default.visitors.merge(
        visitors,
        passes,
        file.opts.wrapPluginVisitorMethod
      );
      (0, _traverse().default)(file.ast, visitor, file.scope);
      for (const [plugin, pass] of passPairs) {
        const fn = plugin.post;
        if (fn) {
          const result = fn.call(pass, file);
          if (isThenable(result)) {
            throw new Error(
              `You appear to be using an plugin with an async .post, ` +
                `which your current version of Babel does not support.` +
                `If you're using a published plugin, you may need to upgrade ` +
                `your @babel/core version.`
            );
          }
        }
      }
    }
  }
  function isThenable(val) {
    return (
      !!val &&
      (typeof val === 'object' || typeof val === 'function') &&
      typeof val.then === 'function'
    );
  }
  return transformation;
}
var hasRequiredTransform;
function requireTransform() {
  if (hasRequiredTransform) return transform;
  hasRequiredTransform = 1;
  Object.defineProperty(transform, '__esModule', {value: true});
  transform.transformSync = transformSync;
  transform.transformAsync = transformAsync;
  transform.transform = void 0;
  var _config = _interopRequireDefault(requireConfig());
  var _transformation = requireTransformation();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const transform$1 = function transform(code, opts, callback) {
    if (typeof opts === 'function') {
      callback = opts;
      opts = undefined;
    }
    if (callback === undefined) return transformSync(code, opts);
    const cb = callback;
    process.nextTick(() => {
      let cfg;
      try {
        cfg = (0, _config.default)(opts);
        if (cfg === null) return cb(null, null);
      } catch (err) {
        return cb(err);
      }
      (0, _transformation.runAsync)(cfg, code, null, cb);
    });
  };
  transform.transform = transform$1;
  function transformSync(code, opts) {
    const config = (0, _config.default)(opts);
    if (config === null) return null;
    return (0, _transformation.runSync)(config, code);
  }
  function transformAsync(code, opts) {
    return new Promise((res, rej) => {
      transform$1(code, opts, (err, result) => {
        if (err == null) res(result);
        else rej(err);
      });
    });
  }
  return transform;
}
var transformFile = {};
var hasRequiredTransformFile;
function requireTransformFile() {
  if (hasRequiredTransformFile) return transformFile;
  hasRequiredTransformFile = 1;
  Object.defineProperty(transformFile, '__esModule', {value: true});
  transformFile.transformFileSync = transformFileSync;
  transformFile.transformFileAsync = transformFileAsync;
  transformFile.transformFile = void 0;
  function _fs() {
    const data = _interopRequireDefault(require$$0$4);
    _fs = function () {
      return data;
    };
    return data;
  }
  var _config = _interopRequireDefault(requireConfig());
  var _transformation = requireTransformation();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const transformFile$1 = function transformFile(filename, opts, callback) {
    let options;
    if (typeof opts === 'function') {
      callback = opts;
      opts = undefined;
    }
    if (opts == null) {
      options = {filename: filename};
    } else if (opts && typeof opts === 'object') {
      options = Object.assign({}, opts, {filename: filename});
    }
    process.nextTick(() => {
      let cfg;
      try {
        cfg = (0, _config.default)(options);
        if (cfg === null) return callback(null, null);
      } catch (err) {
        return callback(err);
      }
      const config = cfg;
      _fs().default.readFile(filename, 'utf8', function (err, code) {
        if (err) return callback(err, null);
        (0, _transformation.runAsync)(config, code, null, callback);
      });
    });
  };
  transformFile.transformFile = transformFile$1;
  function transformFileSync(filename, opts) {
    let options;
    if (opts == null) {
      options = {filename: filename};
    } else if (opts && typeof opts === 'object') {
      options = Object.assign({}, opts, {filename: filename});
    }
    const config = (0, _config.default)(options);
    if (config === null) return null;
    return (0, _transformation.runSync)(
      config,
      _fs().default.readFileSync(filename, 'utf8')
    );
  }
  function transformFileAsync(filename, opts) {
    return new Promise((res, rej) => {
      transformFile$1(filename, opts, (err, result) => {
        if (err == null) res(result);
        else rej(err);
      });
    });
  }
  return transformFile;
}
var transformAst = {};
var hasRequiredTransformAst;
function requireTransformAst() {
  if (hasRequiredTransformAst) return transformAst;
  hasRequiredTransformAst = 1;
  Object.defineProperty(transformAst, '__esModule', {value: true});
  transformAst.transformFromAstSync = transformFromAstSync;
  transformAst.transformFromAstAsync = transformFromAstAsync;
  transformAst.transformFromAst = void 0;
  var _config = _interopRequireDefault(requireConfig());
  var _transformation = requireTransformation();
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const transformFromAst = function transformFromAst(
    ast,
    code,
    opts,
    callback
  ) {
    if (typeof opts === 'function') {
      callback = opts;
      opts = undefined;
    }
    if (callback === undefined) return transformFromAstSync(ast, code, opts);
    const cb = callback;
    process.nextTick(() => {
      let cfg;
      try {
        cfg = (0, _config.default)(opts);
        if (cfg === null) return cb(null, null);
      } catch (err) {
        return cb(err);
      }
      if (!ast) return cb(new Error('No AST given'));
      (0, _transformation.runAsync)(cfg, code, ast, cb);
    });
  };
  transformAst.transformFromAst = transformFromAst;
  function transformFromAstSync(ast, code, opts) {
    const config = (0, _config.default)(opts);
    if (config === null) return null;
    if (!ast) throw new Error('No AST given');
    return (0, _transformation.runSync)(config, code, ast);
  }
  function transformFromAstAsync(ast, code, opts) {
    return new Promise((res, rej) => {
      transformFromAst(ast, code, opts, (err, result) => {
        if (err == null) res(result);
        else rej(err);
      });
    });
  }
  return transformAst;
}
var parse = {};
var hasRequiredParse;
function requireParse() {
  if (hasRequiredParse) return parse;
  hasRequiredParse = 1;
  Object.defineProperty(parse, '__esModule', {value: true});
  parse.parseSync = parseSync;
  parse.parseAsync = parseAsync;
  parse.parse = void 0;
  var _config = _interopRequireDefault(requireConfig());
  var _normalizeFile = _interopRequireDefault(normalizeFile$1);
  var _normalizeOpts = _interopRequireDefault(normalizeOpts);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {default: obj};
  }
  const parse$1 = function parse(code, opts, callback) {
    if (typeof opts === 'function') {
      callback = opts;
      opts = undefined;
    }
    if (callback === undefined) return parseSync(code, opts);
    const config = (0, _config.default)(opts);
    if (config === null) {
      return null;
    }
    const cb = callback;
    process.nextTick(() => {
      let ast = null;
      try {
        const cfg = (0, _config.default)(opts);
        if (cfg === null) return cb(null, null);
        ast = (0, _normalizeFile.default)(
          cfg.passes,
          (0, _normalizeOpts.default)(cfg),
          code
        ).ast;
      } catch (err) {
        return cb(err);
      }
      cb(null, ast);
    });
  };
  parse.parse = parse$1;
  function parseSync(code, opts) {
    const config = (0, _config.default)(opts);
    if (config === null) {
      return null;
    }
    return (0, _normalizeFile.default)(
      config.passes,
      (0, _normalizeOpts.default)(config),
      code
    ).ast;
  }
  function parseAsync(code, opts) {
    return new Promise((res, rej) => {
      parse$1(code, opts, (err, result) => {
        if (err == null) res(result);
        else rej(err);
      });
    });
  }
  return parse;
}
var hasRequiredLib;
function requireLib() {
  if (hasRequiredLib) return lib$p;
  hasRequiredLib = 1;
  (function (exports) {
    Object.defineProperty(exports, '__esModule', {value: true});
    exports.Plugin = Plugin;
    Object.defineProperty(exports, 'File', {
      enumerable: true,
      get: function () {
        return _file.default;
      },
    });
    Object.defineProperty(exports, 'buildExternalHelpers', {
      enumerable: true,
      get: function () {
        return _buildExternalHelpers.default;
      },
    });
    Object.defineProperty(exports, 'resolvePlugin', {
      enumerable: true,
      get: function () {
        return _files.resolvePlugin;
      },
    });
    Object.defineProperty(exports, 'resolvePreset', {
      enumerable: true,
      get: function () {
        return _files.resolvePreset;
      },
    });
    Object.defineProperty(exports, 'version', {
      enumerable: true,
      get: function () {
        return _package.version;
      },
    });
    Object.defineProperty(exports, 'getEnv', {
      enumerable: true,
      get: function () {
        return _environment.getEnv;
      },
    });
    Object.defineProperty(exports, 'tokTypes', {
      enumerable: true,
      get: function () {
        return _parser().tokTypes;
      },
    });
    Object.defineProperty(exports, 'traverse', {
      enumerable: true,
      get: function () {
        return _traverse().default;
      },
    });
    Object.defineProperty(exports, 'template', {
      enumerable: true,
      get: function () {
        return _template().default;
      },
    });
    Object.defineProperty(exports, 'createConfigItem', {
      enumerable: true,
      get: function () {
        return _item.createConfigItem;
      },
    });
    Object.defineProperty(exports, 'loadPartialConfig', {
      enumerable: true,
      get: function () {
        return _config.loadPartialConfig;
      },
    });
    Object.defineProperty(exports, 'loadOptions', {
      enumerable: true,
      get: function () {
        return _config.loadOptions;
      },
    });
    Object.defineProperty(exports, 'transform', {
      enumerable: true,
      get: function () {
        return _transform.transform;
      },
    });
    Object.defineProperty(exports, 'transformSync', {
      enumerable: true,
      get: function () {
        return _transform.transformSync;
      },
    });
    Object.defineProperty(exports, 'transformAsync', {
      enumerable: true,
      get: function () {
        return _transform.transformAsync;
      },
    });
    Object.defineProperty(exports, 'transformFile', {
      enumerable: true,
      get: function () {
        return _transformFile.transformFile;
      },
    });
    Object.defineProperty(exports, 'transformFileSync', {
      enumerable: true,
      get: function () {
        return _transformFile.transformFileSync;
      },
    });
    Object.defineProperty(exports, 'transformFileAsync', {
      enumerable: true,
      get: function () {
        return _transformFile.transformFileAsync;
      },
    });
    Object.defineProperty(exports, 'transformFromAst', {
      enumerable: true,
      get: function () {
        return _transformAst.transformFromAst;
      },
    });
    Object.defineProperty(exports, 'transformFromAstSync', {
      enumerable: true,
      get: function () {
        return _transformAst.transformFromAstSync;
      },
    });
    Object.defineProperty(exports, 'transformFromAstAsync', {
      enumerable: true,
      get: function () {
        return _transformAst.transformFromAstAsync;
      },
    });
    Object.defineProperty(exports, 'parse', {
      enumerable: true,
      get: function () {
        return _parse.parse;
      },
    });
    Object.defineProperty(exports, 'parseSync', {
      enumerable: true,
      get: function () {
        return _parse.parseSync;
      },
    });
    Object.defineProperty(exports, 'parseAsync', {
      enumerable: true,
      get: function () {
        return _parse.parseAsync;
      },
    });
    exports.types = exports.OptionManager = exports.DEFAULT_EXTENSIONS = void 0;
    var _file = _interopRequireDefault(file);
    var _buildExternalHelpers = _interopRequireDefault(buildExternalHelpers);
    var _files = requireFiles();
    var _package = require$$3;
    var _environment = environment;
    function _types() {
      const data = _interopRequireWildcard(t$d);
      _types = function () {
        return data;
      };
      return data;
    }
    Object.defineProperty(exports, 'types', {
      enumerable: true,
      get: function () {
        return _types();
      },
    });
    function _parser() {
      const data = lib$g;
      _parser = function () {
        return data;
      };
      return data;
    }
    function _traverse() {
      const data = _interopRequireDefault(requireLib$1());
      _traverse = function () {
        return data;
      };
      return data;
    }
    function _template() {
      const data = _interopRequireDefault(requireLib$d());
      _template = function () {
        return data;
      };
      return data;
    }
    var _item = requireItem();
    var _config = requireConfig();
    var _transform = requireTransform();
    var _transformFile = requireTransformFile();
    var _transformAst = requireTransformAst();
    var _parse = requireParse();
    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      } else {
        var newObj = {};
        if (obj != null) {
          for (var key in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, key)) {
              var desc =
                Object.defineProperty && Object.getOwnPropertyDescriptor
                  ? Object.getOwnPropertyDescriptor(obj, key)
                  : {};
              if (desc.get || desc.set) {
                Object.defineProperty(newObj, key, desc);
              } else {
                newObj[key] = obj[key];
              }
            }
          }
        }
        newObj.default = obj;
        return newObj;
      }
    }
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {default: obj};
    }
    const DEFAULT_EXTENSIONS = Object.freeze([
      '.js',
      '.jsx',
      '.es6',
      '.es',
      '.mjs',
    ]);
    exports.DEFAULT_EXTENSIONS = DEFAULT_EXTENSIONS;
    class OptionManager {
      init(opts) {
        return (0, _config.loadOptions)(opts);
      }
    }
    exports.OptionManager = OptionManager;
    function Plugin(alias) {
      throw new Error(
        `The (${alias}) Babel 5 plugin is being run with an unsupported Babel version.`
      );
    }
  })(lib$p);
  return lib$p;
}
var libExports = requireLib();
var NODE_ENV = process.env.NODE_ENV;
var invariant = function (condition, format, a, b, c, d, e, f) {
  if (NODE_ENV !== 'production') {
    if (format === undefined) {
      throw new Error('invariant requires an error message argument');
    }
  }
  if (!condition) {
    var error;
    if (format === undefined) {
      error = new Error(
        'Minified exception occurred; use the non-minified dev environment ' +
          'for the full error message and additional helpful warnings.'
      );
    } else {
      var args = [a, b, c, d, e, f];
      var argIndex = 0;
      error = new Error(
        format.replace(/%s/g, function () {
          return args[argIndex++];
        })
      );
      error.name = 'Invariant Violation';
    }
    error.framesToPop = 1;
    throw error;
  }
};
var invariant_1 = invariant;
var invariant$1 = getDefaultExportFromCjs(invariant_1);
function insertGatedFunctionDeclaration(fnPath, compiled, gating) {
  const gatingExpression = t__namespace.conditionalExpression(
    t__namespace.callExpression(
      t__namespace.identifier(gating.importSpecifierName),
      []
    ),
    buildFunctionExpression(compiled),
    buildFunctionExpression(fnPath.node)
  );
  if (
    fnPath.parentPath.node.type !== 'ExportDefaultDeclaration' &&
    fnPath.node.type === 'FunctionDeclaration' &&
    fnPath.node.id != null
  ) {
    fnPath.replaceWith(
      t__namespace.variableDeclaration('const', [
        t__namespace.variableDeclarator(fnPath.node.id, gatingExpression),
      ])
    );
  } else if (
    fnPath.parentPath.node.type === 'ExportDefaultDeclaration' &&
    fnPath.node.type !== 'ArrowFunctionExpression' &&
    fnPath.node.id != null
  ) {
    fnPath.insertAfter(
      t__namespace.exportDefaultDeclaration(
        t__namespace.identifier(fnPath.node.id.name)
      )
    );
    fnPath.parentPath.replaceWith(
      t__namespace.variableDeclaration('const', [
        t__namespace.variableDeclarator(
          t__namespace.identifier(fnPath.node.id.name),
          gatingExpression
        ),
      ])
    );
  } else {
    fnPath.replaceWith(gatingExpression);
  }
}
function buildFunctionExpression(node) {
  var _a, _b;
  if (
    node.type === 'ArrowFunctionExpression' ||
    node.type === 'FunctionExpression'
  ) {
    return node;
  } else {
    const fn = {
      type: 'FunctionExpression',
      async: node.async,
      generator: node.generator,
      loc: (_a = node.loc) !== null && _a !== void 0 ? _a : null,
      id: (_b = node.id) !== null && _b !== void 0 ? _b : null,
      params: node.params,
      body: node.body,
    };
    return fn;
  }
}
function assertExhaustive(_, errorMsg) {
  throw new Error(errorMsg);
}
function retainWhere(array, predicate) {
  let writeIndex = 0;
  for (let readIndex = 0; readIndex < array.length; readIndex++) {
    const item = array[readIndex];
    if (predicate(item) === true) {
      array[writeIndex++] = item;
    }
  }
  array.length = writeIndex;
}
function retainWhere_Set(items, predicate) {
  for (const item of items) {
    if (!predicate(item)) {
      items.delete(item);
    }
  }
}
function getOrInsertWith(m, key, makeDefault) {
  if (m.has(key)) {
    return m.get(key);
  } else {
    const defaultValue = makeDefault();
    m.set(key, defaultValue);
    return defaultValue;
  }
}
function getOrInsertDefault(m, key, defaultValue) {
  if (m.has(key)) {
    return m.get(key);
  } else {
    m.set(key, defaultValue);
    return defaultValue;
  }
}
function Set_equal(a, b) {
  if (a.size !== b.size) {
    return false;
  }
  for (const item of a) {
    if (!b.has(item)) {
      return false;
    }
  }
  return true;
}
function Set_union(a, b) {
  const union = new Set(a);
  for (const item of b) {
    union.add(item);
  }
  return union;
}
function Set_intersect(sets) {
  if (sets.length === 0 || sets.some(s => s.size === 0)) {
    return new Set();
  } else if (sets.length === 1) {
    return new Set(sets[0]);
  }
  const result = new Set();
  const first = sets[0];
  outer: for (const e of first) {
    for (let i = 1; i < sets.length; i++) {
      if (!sets[i].has(e)) {
        continue outer;
      }
    }
    result.add(e);
  }
  return result;
}
function Iterable_some(iter, pred) {
  for (const item of iter) {
    if (pred(item)) {
      return true;
    }
  }
  return false;
}
function Set_filter(source, fn) {
  const result = new Set();
  for (const entry of source) {
    if (fn(entry)) {
      result.add(entry);
    }
  }
  return result;
}
function hasNode(input) {
  return input.node != null;
}
function hasOwnProperty$1(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
}
exports.ErrorSeverity = void 0;
(function (ErrorSeverity) {
  ErrorSeverity['InvalidJS'] = 'InvalidJS';
  ErrorSeverity['InvalidReact'] = 'InvalidReact';
  ErrorSeverity['InvalidConfig'] = 'InvalidConfig';
  ErrorSeverity['CannotPreserveMemoization'] = 'CannotPreserveMemoization';
  ErrorSeverity['Todo'] = 'Todo';
  ErrorSeverity['Invariant'] = 'Invariant';
})(exports.ErrorSeverity || (exports.ErrorSeverity = {}));
exports.CompilerSuggestionOperation = void 0;
(function (CompilerSuggestionOperation) {
  CompilerSuggestionOperation[
    (CompilerSuggestionOperation['InsertBefore'] = 0)
  ] = 'InsertBefore';
  CompilerSuggestionOperation[
    (CompilerSuggestionOperation['InsertAfter'] = 1)
  ] = 'InsertAfter';
  CompilerSuggestionOperation[(CompilerSuggestionOperation['Remove'] = 2)] =
    'Remove';
  CompilerSuggestionOperation[(CompilerSuggestionOperation['Replace'] = 3)] =
    'Replace';
})(
  exports.CompilerSuggestionOperation ||
    (exports.CompilerSuggestionOperation = {})
);
class CompilerErrorDetail {
  constructor(options) {
    this.options = options;
  }
  get reason() {
    return this.options.reason;
  }
  get description() {
    return this.options.description;
  }
  get severity() {
    return this.options.severity;
  }
  get loc() {
    return this.options.loc;
  }
  get suggestions() {
    return this.options.suggestions;
  }
  printErrorMessage() {
    const buffer = [`${this.severity}: ${this.reason}`];
    if (this.description != null) {
      buffer.push(`. ${this.description}`);
    }
    if (this.loc != null && typeof this.loc !== 'symbol') {
      buffer.push(` (${this.loc.start.line}:${this.loc.end.line})`);
    }
    return buffer.join('');
  }
  toString() {
    return this.printErrorMessage();
  }
}
class CompilerError extends Error {
  static invariant(condition, options) {
    if (!condition) {
      const errors = new CompilerError();
      errors.pushErrorDetail(
        new CompilerErrorDetail(
          Object.assign(Object.assign({}, options), {
            severity: exports.ErrorSeverity.Invariant,
          })
        )
      );
      throw errors;
    }
  }
  static throwTodo(options) {
    const errors = new CompilerError();
    errors.pushErrorDetail(
      new CompilerErrorDetail(
        Object.assign(Object.assign({}, options), {
          severity: exports.ErrorSeverity.Todo,
        })
      )
    );
    throw errors;
  }
  static throwInvalidJS(options) {
    const errors = new CompilerError();
    errors.pushErrorDetail(
      new CompilerErrorDetail(
        Object.assign(Object.assign({}, options), {
          severity: exports.ErrorSeverity.InvalidJS,
        })
      )
    );
    throw errors;
  }
  static throwInvalidReact(options) {
    const errors = new CompilerError();
    errors.pushErrorDetail(
      new CompilerErrorDetail(
        Object.assign(Object.assign({}, options), {
          severity: exports.ErrorSeverity.InvalidReact,
        })
      )
    );
    throw errors;
  }
  static throwInvalidConfig(options) {
    const errors = new CompilerError();
    errors.pushErrorDetail(
      new CompilerErrorDetail(
        Object.assign(Object.assign({}, options), {
          severity: exports.ErrorSeverity.InvalidConfig,
        })
      )
    );
    throw errors;
  }
  static throw(options) {
    const errors = new CompilerError();
    errors.pushErrorDetail(new CompilerErrorDetail(options));
    throw errors;
  }
  constructor(...args) {
    super(...args);
    this.details = [];
    this.name = 'ReactCompilerError';
  }
  get message() {
    return this.toString();
  }
  set message(_message) {}
  toString() {
    return this.details.map(detail => detail.toString()).join('\n\n');
  }
  push(options) {
    var _a;
    const detail = new CompilerErrorDetail({
      reason: options.reason,
      description:
        (_a = options.description) !== null && _a !== void 0 ? _a : null,
      severity: options.severity,
      suggestions: options.suggestions,
      loc: typeof options.loc === 'symbol' ? null : options.loc,
    });
    return this.pushErrorDetail(detail);
  }
  pushErrorDetail(detail) {
    this.details.push(detail);
    return detail;
  }
  hasErrors() {
    return this.details.length > 0;
  }
  isCritical() {
    return this.details.some(detail => {
      switch (detail.severity) {
        case exports.ErrorSeverity.Invariant:
        case exports.ErrorSeverity.InvalidJS:
        case exports.ErrorSeverity.InvalidReact:
        case exports.ErrorSeverity.InvalidConfig:
          return true;
        case exports.ErrorSeverity.CannotPreserveMemoization:
        case exports.ErrorSeverity.Todo:
          return false;
        default:
          assertExhaustive(detail.severity, 'Unhandled error severity');
      }
    });
  }
}
function makeTypeId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected instruction id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
let typeCounter = 0;
function makeType() {
  return {kind: 'Type', id: makeTypeId(typeCounter++)};
}
function typeEquals(tA, tB) {
  if (tA.kind !== tB.kind) return false;
  return (
    typeVarEquals(tA, tB) ||
    funcTypeEquals(tA, tB) ||
    objectTypeEquals(tA, tB) ||
    primitiveTypeEquals(tA, tB) ||
    polyTypeEquals(tA, tB) ||
    phiTypeEquals(tA, tB) ||
    propTypeEquals(tA, tB) ||
    objectMethodTypeEquals(tA, tB)
  );
}
function typeVarEquals(tA, tB) {
  if (tA.kind === 'Type' && tB.kind === 'Type') {
    return tA.id === tB.id;
  }
  return false;
}
function typeKindCheck(tA, tb, type) {
  return tA.kind === type && tb.kind === type;
}
function objectMethodTypeEquals(tA, tB) {
  return typeKindCheck(tA, tB, 'ObjectMethod');
}
function propTypeEquals(tA, tB) {
  if (tA.kind === 'Property' && tB.kind === 'Property') {
    if (!typeEquals(tA.objectType, tB.objectType)) {
      return false;
    }
    return (
      tA.propertyName === tB.propertyName && tA.objectName === tB.objectName
    );
  }
  return false;
}
function primitiveTypeEquals(tA, tB) {
  return typeKindCheck(tA, tB, 'Primitive');
}
function polyTypeEquals(tA, tB) {
  return typeKindCheck(tA, tB, 'Poly');
}
function objectTypeEquals(tA, tB) {
  if (tA.kind === 'Object' && tB.kind == 'Object') {
    return tA.shapeId === tB.shapeId;
  }
  return false;
}
function funcTypeEquals(tA, tB) {
  if (tA.kind !== 'Function' || tB.kind !== 'Function') {
    return false;
  }
  return typeEquals(tA.return, tB.return);
}
function phiTypeEquals(tA, tB) {
  if (tA.kind === 'Phi' && tB.kind === 'Phi') {
    if (tA.operands.length !== tB.operands.length) {
      return false;
    }
    let operands = new Set(tA.operands);
    for (let i = 0; i < tB.operands.length; i++) {
      if (!operands.has(tB.operands[i])) {
        return false;
      }
    }
  }
  return false;
}
var util$1;
(function (util) {
  util.assertEqual = val => val;
  function assertIs(_arg) {}
  util.assertIs = assertIs;
  function assertNever(_x) {
    throw new Error();
  }
  util.assertNever = assertNever;
  util.arrayToEnum = items => {
    const obj = {};
    for (const item of items) {
      obj[item] = item;
    }
    return obj;
  };
  util.getValidEnumValues = obj => {
    const validKeys = util
      .objectKeys(obj)
      .filter(k => typeof obj[obj[k]] !== 'number');
    const filtered = {};
    for (const k of validKeys) {
      filtered[k] = obj[k];
    }
    return util.objectValues(filtered);
  };
  util.objectValues = obj =>
    util.objectKeys(obj).map(function (e) {
      return obj[e];
    });
  util.objectKeys =
    typeof Object.keys === 'function'
      ? obj => Object.keys(obj)
      : object => {
          const keys = [];
          for (const key in object) {
            if (Object.prototype.hasOwnProperty.call(object, key)) {
              keys.push(key);
            }
          }
          return keys;
        };
  util.find = (arr, checker) => {
    for (const item of arr) {
      if (checker(item)) return item;
    }
    return undefined;
  };
  util.isInteger =
    typeof Number.isInteger === 'function'
      ? val => Number.isInteger(val)
      : val =>
          typeof val === 'number' && isFinite(val) && Math.floor(val) === val;
  function joinValues(array, separator = ' | ') {
    return array
      .map(val => (typeof val === 'string' ? `'${val}'` : val))
      .join(separator);
  }
  util.joinValues = joinValues;
  util.jsonStringifyReplacer = (_, value) => {
    if (typeof value === 'bigint') {
      return value.toString();
    }
    return value;
  };
})(util$1 || (util$1 = {}));
var objectUtil;
(function (objectUtil) {
  objectUtil.mergeShapes = (first, second) => ({...first, ...second});
})(objectUtil || (objectUtil = {}));
const ZodParsedType = util$1.arrayToEnum([
  'string',
  'nan',
  'number',
  'integer',
  'float',
  'boolean',
  'date',
  'bigint',
  'symbol',
  'function',
  'undefined',
  'null',
  'array',
  'object',
  'unknown',
  'promise',
  'void',
  'never',
  'map',
  'set',
]);
const getParsedType = data => {
  const t = typeof data;
  switch (t) {
    case 'undefined':
      return ZodParsedType.undefined;
    case 'string':
      return ZodParsedType.string;
    case 'number':
      return isNaN(data) ? ZodParsedType.nan : ZodParsedType.number;
    case 'boolean':
      return ZodParsedType.boolean;
    case 'function':
      return ZodParsedType.function;
    case 'bigint':
      return ZodParsedType.bigint;
    case 'symbol':
      return ZodParsedType.symbol;
    case 'object':
      if (Array.isArray(data)) {
        return ZodParsedType.array;
      }
      if (data === null) {
        return ZodParsedType.null;
      }
      if (
        data.then &&
        typeof data.then === 'function' &&
        data.catch &&
        typeof data.catch === 'function'
      ) {
        return ZodParsedType.promise;
      }
      if (typeof Map !== 'undefined' && data instanceof Map) {
        return ZodParsedType.map;
      }
      if (typeof Set !== 'undefined' && data instanceof Set) {
        return ZodParsedType.set;
      }
      if (typeof Date !== 'undefined' && data instanceof Date) {
        return ZodParsedType.date;
      }
      return ZodParsedType.object;
    default:
      return ZodParsedType.unknown;
  }
};
const ZodIssueCode = util$1.arrayToEnum([
  'invalid_type',
  'invalid_literal',
  'custom',
  'invalid_union',
  'invalid_union_discriminator',
  'invalid_enum_value',
  'unrecognized_keys',
  'invalid_arguments',
  'invalid_return_type',
  'invalid_date',
  'invalid_string',
  'too_small',
  'too_big',
  'invalid_intersection_types',
  'not_multiple_of',
  'not_finite',
]);
const quotelessJson = obj => {
  const json = JSON.stringify(obj, null, 2);
  return json.replace(/"([^"]+)":/g, '$1:');
};
class ZodError extends Error {
  constructor(issues) {
    super();
    this.issues = [];
    this.addIssue = sub => {
      this.issues = [...this.issues, sub];
    };
    this.addIssues = (subs = []) => {
      this.issues = [...this.issues, ...subs];
    };
    const actualProto = new.target.prototype;
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(this, actualProto);
    } else {
      this.__proto__ = actualProto;
    }
    this.name = 'ZodError';
    this.issues = issues;
  }
  get errors() {
    return this.issues;
  }
  format(_mapper) {
    const mapper =
      _mapper ||
      function (issue) {
        return issue.message;
      };
    const fieldErrors = {_errors: []};
    const processError = error => {
      for (const issue of error.issues) {
        if (issue.code === 'invalid_union') {
          issue.unionErrors.map(processError);
        } else if (issue.code === 'invalid_return_type') {
          processError(issue.returnTypeError);
        } else if (issue.code === 'invalid_arguments') {
          processError(issue.argumentsError);
        } else if (issue.path.length === 0) {
          fieldErrors._errors.push(mapper(issue));
        } else {
          let curr = fieldErrors;
          let i = 0;
          while (i < issue.path.length) {
            const el = issue.path[i];
            const terminal = i === issue.path.length - 1;
            if (!terminal) {
              curr[el] = curr[el] || {_errors: []};
            } else {
              curr[el] = curr[el] || {_errors: []};
              curr[el]._errors.push(mapper(issue));
            }
            curr = curr[el];
            i++;
          }
        }
      }
    };
    processError(this);
    return fieldErrors;
  }
  toString() {
    return this.message;
  }
  get message() {
    return JSON.stringify(this.issues, util$1.jsonStringifyReplacer, 2);
  }
  get isEmpty() {
    return this.issues.length === 0;
  }
  flatten(mapper = issue => issue.message) {
    const fieldErrors = {};
    const formErrors = [];
    for (const sub of this.issues) {
      if (sub.path.length > 0) {
        fieldErrors[sub.path[0]] = fieldErrors[sub.path[0]] || [];
        fieldErrors[sub.path[0]].push(mapper(sub));
      } else {
        formErrors.push(mapper(sub));
      }
    }
    return {formErrors: formErrors, fieldErrors: fieldErrors};
  }
  get formErrors() {
    return this.flatten();
  }
}
ZodError.create = issues => {
  const error = new ZodError(issues);
  return error;
};
const errorMap = (issue, _ctx) => {
  let message;
  switch (issue.code) {
    case ZodIssueCode.invalid_type:
      if (issue.received === ZodParsedType.undefined) {
        message = 'Required';
      } else {
        message = `Expected ${issue.expected}, received ${issue.received}`;
      }
      break;
    case ZodIssueCode.invalid_literal:
      message = `Invalid literal value, expected ${JSON.stringify(issue.expected, util$1.jsonStringifyReplacer)}`;
      break;
    case ZodIssueCode.unrecognized_keys:
      message = `Unrecognized key(s) in object: ${util$1.joinValues(issue.keys, ', ')}`;
      break;
    case ZodIssueCode.invalid_union:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_union_discriminator:
      message = `Invalid discriminator value. Expected ${util$1.joinValues(issue.options)}`;
      break;
    case ZodIssueCode.invalid_enum_value:
      message = `Invalid enum value. Expected ${util$1.joinValues(issue.options)}, received '${issue.received}'`;
      break;
    case ZodIssueCode.invalid_arguments:
      message = `Invalid function arguments`;
      break;
    case ZodIssueCode.invalid_return_type:
      message = `Invalid function return type`;
      break;
    case ZodIssueCode.invalid_date:
      message = `Invalid date`;
      break;
    case ZodIssueCode.invalid_string:
      if (typeof issue.validation === 'object') {
        if ('includes' in issue.validation) {
          message = `Invalid input: must include "${issue.validation.includes}"`;
          if (typeof issue.validation.position === 'number') {
            message = `${message} at one or more positions greater than or equal to ${issue.validation.position}`;
          }
        } else if ('startsWith' in issue.validation) {
          message = `Invalid input: must start with "${issue.validation.startsWith}"`;
        } else if ('endsWith' in issue.validation) {
          message = `Invalid input: must end with "${issue.validation.endsWith}"`;
        } else {
          util$1.assertNever(issue.validation);
        }
      } else if (issue.validation !== 'regex') {
        message = `Invalid ${issue.validation}`;
      } else {
        message = 'Invalid';
      }
      break;
    case ZodIssueCode.too_small:
      if (issue.type === 'array')
        message = `Array must contain ${issue.exact ? 'exactly' : issue.inclusive ? `at least` : `more than`} ${issue.minimum} element(s)`;
      else if (issue.type === 'string')
        message = `String must contain ${issue.exact ? 'exactly' : issue.inclusive ? `at least` : `over`} ${issue.minimum} character(s)`;
      else if (issue.type === 'number')
        message = `Number must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${issue.minimum}`;
      else if (issue.type === 'date')
        message = `Date must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${new Date(Number(issue.minimum))}`;
      else message = 'Invalid input';
      break;
    case ZodIssueCode.too_big:
      if (issue.type === 'array')
        message = `Array must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `less than`} ${issue.maximum} element(s)`;
      else if (issue.type === 'string')
        message = `String must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `under`} ${issue.maximum} character(s)`;
      else if (issue.type === 'number')
        message = `Number must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === 'bigint')
        message = `BigInt must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === 'date')
        message = `Date must be ${issue.exact ? `exactly` : issue.inclusive ? `smaller than or equal to` : `smaller than`} ${new Date(Number(issue.maximum))}`;
      else message = 'Invalid input';
      break;
    case ZodIssueCode.custom:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_intersection_types:
      message = `Intersection results could not be merged`;
      break;
    case ZodIssueCode.not_multiple_of:
      message = `Number must be a multiple of ${issue.multipleOf}`;
      break;
    case ZodIssueCode.not_finite:
      message = 'Number must be finite';
      break;
    default:
      message = _ctx.defaultError;
      util$1.assertNever(issue);
  }
  return {message: message};
};
let overrideErrorMap = errorMap;
function setErrorMap(map) {
  overrideErrorMap = map;
}
function getErrorMap() {
  return overrideErrorMap;
}
const makeIssue = params => {
  const {
    data: data,
    path: path,
    errorMaps: errorMaps,
    issueData: issueData,
  } = params;
  const fullPath = [...path, ...(issueData.path || [])];
  const fullIssue = {...issueData, path: fullPath};
  let errorMessage = '';
  const maps = errorMaps
    .filter(m => !!m)
    .slice()
    .reverse();
  for (const map of maps) {
    errorMessage = map(fullIssue, {
      data: data,
      defaultError: errorMessage,
    }).message;
  }
  return {
    ...issueData,
    path: fullPath,
    message: issueData.message || errorMessage,
  };
};
const EMPTY_PATH = [];
function addIssueToContext(ctx, issueData) {
  const issue = makeIssue({
    issueData: issueData,
    data: ctx.data,
    path: ctx.path,
    errorMaps: [
      ctx.common.contextualErrorMap,
      ctx.schemaErrorMap,
      getErrorMap(),
      errorMap,
    ].filter(x => !!x),
  });
  ctx.common.issues.push(issue);
}
class ParseStatus {
  constructor() {
    this.value = 'valid';
  }
  dirty() {
    if (this.value === 'valid') this.value = 'dirty';
  }
  abort() {
    if (this.value !== 'aborted') this.value = 'aborted';
  }
  static mergeArray(status, results) {
    const arrayValue = [];
    for (const s of results) {
      if (s.status === 'aborted') return INVALID;
      if (s.status === 'dirty') status.dirty();
      arrayValue.push(s.value);
    }
    return {status: status.value, value: arrayValue};
  }
  static async mergeObjectAsync(status, pairs) {
    const syncPairs = [];
    for (const pair of pairs) {
      syncPairs.push({key: await pair.key, value: await pair.value});
    }
    return ParseStatus.mergeObjectSync(status, syncPairs);
  }
  static mergeObjectSync(status, pairs) {
    const finalObject = {};
    for (const pair of pairs) {
      const {key: key, value: value} = pair;
      if (key.status === 'aborted') return INVALID;
      if (value.status === 'aborted') return INVALID;
      if (key.status === 'dirty') status.dirty();
      if (value.status === 'dirty') status.dirty();
      if (
        key.value !== '__proto__' &&
        (typeof value.value !== 'undefined' || pair.alwaysSet)
      ) {
        finalObject[key.value] = value.value;
      }
    }
    return {status: status.value, value: finalObject};
  }
}
const INVALID = Object.freeze({status: 'aborted'});
const DIRTY = value => ({status: 'dirty', value: value});
const OK = value => ({status: 'valid', value: value});
const isAborted = x => x.status === 'aborted';
const isDirty = x => x.status === 'dirty';
const isValid = x => x.status === 'valid';
const isAsync = x => typeof Promise !== 'undefined' && x instanceof Promise;
var errorUtil;
(function (errorUtil) {
  errorUtil.errToObj = message =>
    typeof message === 'string' ? {message: message} : message || {};
  errorUtil.toString = message =>
    typeof message === 'string'
      ? message
      : message === null || message === void 0
        ? void 0
        : message.message;
})(errorUtil || (errorUtil = {}));
class ParseInputLazyPath {
  constructor(parent, value, path, key) {
    this._cachedPath = [];
    this.parent = parent;
    this.data = value;
    this._path = path;
    this._key = key;
  }
  get path() {
    if (!this._cachedPath.length) {
      if (this._key instanceof Array) {
        this._cachedPath.push(...this._path, ...this._key);
      } else {
        this._cachedPath.push(...this._path, this._key);
      }
    }
    return this._cachedPath;
  }
}
const handleResult = (ctx, result) => {
  if (isValid(result)) {
    return {success: true, data: result.value};
  } else {
    if (!ctx.common.issues.length) {
      throw new Error('Validation failed but no issues detected.');
    }
    return {
      success: false,
      get error() {
        if (this._error) return this._error;
        const error = new ZodError(ctx.common.issues);
        this._error = error;
        return this._error;
      },
    };
  }
};
function processCreateParams(params) {
  if (!params) return {};
  const {
    errorMap: errorMap,
    invalid_type_error: invalid_type_error,
    required_error: required_error,
    description: description,
  } = params;
  if (errorMap && (invalid_type_error || required_error)) {
    throw new Error(
      `Can't use "invalid_type_error" or "required_error" in conjunction with custom error map.`
    );
  }
  if (errorMap) return {errorMap: errorMap, description: description};
  const customMap = (iss, ctx) => {
    if (iss.code !== 'invalid_type') return {message: ctx.defaultError};
    if (typeof ctx.data === 'undefined') {
      return {
        message:
          required_error !== null && required_error !== void 0
            ? required_error
            : ctx.defaultError,
      };
    }
    return {
      message:
        invalid_type_error !== null && invalid_type_error !== void 0
          ? invalid_type_error
          : ctx.defaultError,
    };
  };
  return {errorMap: customMap, description: description};
}
class ZodType {
  constructor(def) {
    this.spa = this.safeParseAsync;
    this._def = def;
    this.parse = this.parse.bind(this);
    this.safeParse = this.safeParse.bind(this);
    this.parseAsync = this.parseAsync.bind(this);
    this.safeParseAsync = this.safeParseAsync.bind(this);
    this.spa = this.spa.bind(this);
    this.refine = this.refine.bind(this);
    this.refinement = this.refinement.bind(this);
    this.superRefine = this.superRefine.bind(this);
    this.optional = this.optional.bind(this);
    this.nullable = this.nullable.bind(this);
    this.nullish = this.nullish.bind(this);
    this.array = this.array.bind(this);
    this.promise = this.promise.bind(this);
    this.or = this.or.bind(this);
    this.and = this.and.bind(this);
    this.transform = this.transform.bind(this);
    this.brand = this.brand.bind(this);
    this.default = this.default.bind(this);
    this.catch = this.catch.bind(this);
    this.describe = this.describe.bind(this);
    this.pipe = this.pipe.bind(this);
    this.readonly = this.readonly.bind(this);
    this.isNullable = this.isNullable.bind(this);
    this.isOptional = this.isOptional.bind(this);
  }
  get description() {
    return this._def.description;
  }
  _getType(input) {
    return getParsedType(input.data);
  }
  _getOrReturnCtx(input, ctx) {
    return (
      ctx || {
        common: input.parent.common,
        data: input.data,
        parsedType: getParsedType(input.data),
        schemaErrorMap: this._def.errorMap,
        path: input.path,
        parent: input.parent,
      }
    );
  }
  _processInputParams(input) {
    return {
      status: new ParseStatus(),
      ctx: {
        common: input.parent.common,
        data: input.data,
        parsedType: getParsedType(input.data),
        schemaErrorMap: this._def.errorMap,
        path: input.path,
        parent: input.parent,
      },
    };
  }
  _parseSync(input) {
    const result = this._parse(input);
    if (isAsync(result)) {
      throw new Error('Synchronous parse encountered promise.');
    }
    return result;
  }
  _parseAsync(input) {
    const result = this._parse(input);
    return Promise.resolve(result);
  }
  parse(data, params) {
    const result = this.safeParse(data, params);
    if (result.success) return result.data;
    throw result.error;
  }
  safeParse(data, params) {
    var _a;
    const ctx = {
      common: {
        issues: [],
        async:
          (_a =
            params === null || params === void 0 ? void 0 : params.async) !==
            null && _a !== void 0
            ? _a
            : false,
        contextualErrorMap:
          params === null || params === void 0 ? void 0 : params.errorMap,
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data: data,
      parsedType: getParsedType(data),
    };
    const result = this._parseSync({data: data, path: ctx.path, parent: ctx});
    return handleResult(ctx, result);
  }
  async parseAsync(data, params) {
    const result = await this.safeParseAsync(data, params);
    if (result.success) return result.data;
    throw result.error;
  }
  async safeParseAsync(data, params) {
    const ctx = {
      common: {
        issues: [],
        contextualErrorMap:
          params === null || params === void 0 ? void 0 : params.errorMap,
        async: true,
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data: data,
      parsedType: getParsedType(data),
    };
    const maybeAsyncResult = this._parse({
      data: data,
      path: ctx.path,
      parent: ctx,
    });
    const result = await (isAsync(maybeAsyncResult)
      ? maybeAsyncResult
      : Promise.resolve(maybeAsyncResult));
    return handleResult(ctx, result);
  }
  refine(check, message) {
    const getIssueProperties = val => {
      if (typeof message === 'string' || typeof message === 'undefined') {
        return {message: message};
      } else if (typeof message === 'function') {
        return message(val);
      } else {
        return message;
      }
    };
    return this._refinement((val, ctx) => {
      const result = check(val);
      const setError = () =>
        ctx.addIssue({code: ZodIssueCode.custom, ...getIssueProperties(val)});
      if (typeof Promise !== 'undefined' && result instanceof Promise) {
        return result.then(data => {
          if (!data) {
            setError();
            return false;
          } else {
            return true;
          }
        });
      }
      if (!result) {
        setError();
        return false;
      } else {
        return true;
      }
    });
  }
  refinement(check, refinementData) {
    return this._refinement((val, ctx) => {
      if (!check(val)) {
        ctx.addIssue(
          typeof refinementData === 'function'
            ? refinementData(val, ctx)
            : refinementData
        );
        return false;
      } else {
        return true;
      }
    });
  }
  _refinement(refinement) {
    return new ZodEffects({
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: {type: 'refinement', refinement: refinement},
    });
  }
  superRefine(refinement) {
    return this._refinement(refinement);
  }
  optional() {
    return ZodOptional.create(this, this._def);
  }
  nullable() {
    return ZodNullable.create(this, this._def);
  }
  nullish() {
    return this.nullable().optional();
  }
  array() {
    return ZodArray.create(this, this._def);
  }
  promise() {
    return ZodPromise.create(this, this._def);
  }
  or(option) {
    return ZodUnion.create([this, option], this._def);
  }
  and(incoming) {
    return ZodIntersection.create(this, incoming, this._def);
  }
  transform(transform) {
    return new ZodEffects({
      ...processCreateParams(this._def),
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: {type: 'transform', transform: transform},
    });
  }
  default(def) {
    const defaultValueFunc = typeof def === 'function' ? def : () => def;
    return new ZodDefault({
      ...processCreateParams(this._def),
      innerType: this,
      defaultValue: defaultValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodDefault,
    });
  }
  brand() {
    return new ZodBranded({
      typeName: ZodFirstPartyTypeKind.ZodBranded,
      type: this,
      ...processCreateParams(this._def),
    });
  }
  catch(def) {
    const catchValueFunc = typeof def === 'function' ? def : () => def;
    return new ZodCatch({
      ...processCreateParams(this._def),
      innerType: this,
      catchValue: catchValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodCatch,
    });
  }
  describe(description) {
    const This = this.constructor;
    return new This({...this._def, description: description});
  }
  pipe(target) {
    return ZodPipeline.create(this, target);
  }
  readonly() {
    return ZodReadonly.create(this);
  }
  isOptional() {
    return this.safeParse(undefined).success;
  }
  isNullable() {
    return this.safeParse(null).success;
  }
}
const cuidRegex = /^c[^\s-]{8,}$/i;
const cuid2Regex = /^[a-z][a-z0-9]*$/;
const ulidRegex = /^[0-9A-HJKMNP-TV-Z]{26}$/;
const uuidRegex =
  /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/i;
const emailRegex =
  /^(?!\.)(?!.*\.\.)([A-Z0-9_+-\.]*)[A-Z0-9_+-]@([A-Z0-9][A-Z0-9\-]*\.)+[A-Z]{2,}$/i;
const _emojiRegex = `^(\\p{Extended_Pictographic}|\\p{Emoji_Component})+$`;
let emojiRegex;
const ipv4Regex =
  /^(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))$/;
const ipv6Regex =
  /^(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))$/;
const datetimeRegex = args => {
  if (args.precision) {
    if (args.offset) {
      return new RegExp(
        `^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}\\.\\d{${args.precision}}(([+-]\\d{2}(:?\\d{2})?)|Z)$`
      );
    } else {
      return new RegExp(
        `^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}\\.\\d{${args.precision}}Z$`
      );
    }
  } else if (args.precision === 0) {
    if (args.offset) {
      return new RegExp(
        `^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(([+-]\\d{2}(:?\\d{2})?)|Z)$`
      );
    } else {
      return new RegExp(`^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}Z$`);
    }
  } else {
    if (args.offset) {
      return new RegExp(
        `^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?(([+-]\\d{2}(:?\\d{2})?)|Z)$`
      );
    } else {
      return new RegExp(
        `^\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?Z$`
      );
    }
  }
};
function isValidIP(ip, version) {
  if ((version === 'v4' || !version) && ipv4Regex.test(ip)) {
    return true;
  }
  if ((version === 'v6' || !version) && ipv6Regex.test(ip)) {
    return true;
  }
  return false;
}
class ZodString extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = String(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.string) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.string,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = undefined;
    for (const check of this._def.checks) {
      if (check.kind === 'min') {
        if (input.data.length < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: 'string',
            inclusive: true,
            exact: false,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'max') {
        if (input.data.length > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: 'string',
            inclusive: true,
            exact: false,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'length') {
        const tooBig = input.data.length > check.value;
        const tooSmall = input.data.length < check.value;
        if (tooBig || tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          if (tooBig) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_big,
              maximum: check.value,
              type: 'string',
              inclusive: true,
              exact: true,
              message: check.message,
            });
          } else if (tooSmall) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_small,
              minimum: check.value,
              type: 'string',
              inclusive: true,
              exact: true,
              message: check.message,
            });
          }
          status.dirty();
        }
      } else if (check.kind === 'email') {
        if (!emailRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'email',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'emoji') {
        if (!emojiRegex) {
          emojiRegex = new RegExp(_emojiRegex, 'u');
        }
        if (!emojiRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'emoji',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'uuid') {
        if (!uuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'uuid',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'cuid') {
        if (!cuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'cuid',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'cuid2') {
        if (!cuid2Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'cuid2',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'ulid') {
        if (!ulidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'ulid',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'url') {
        try {
          new URL(input.data);
        } catch (_a) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'url',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'regex') {
        check.regex.lastIndex = 0;
        const testResult = check.regex.test(input.data);
        if (!testResult) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'regex',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'trim') {
        input.data = input.data.trim();
      } else if (check.kind === 'includes') {
        if (!input.data.includes(check.value, check.position)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: {includes: check.value, position: check.position},
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'toLowerCase') {
        input.data = input.data.toLowerCase();
      } else if (check.kind === 'toUpperCase') {
        input.data = input.data.toUpperCase();
      } else if (check.kind === 'startsWith') {
        if (!input.data.startsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: {startsWith: check.value},
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'endsWith') {
        if (!input.data.endsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: {endsWith: check.value},
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'datetime') {
        const regex = datetimeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: 'datetime',
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'ip') {
        if (!isValidIP(input.data, check.version)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: 'ip',
            code: ZodIssueCode.invalid_string,
            message: check.message,
          });
          status.dirty();
        }
      } else {
        util$1.assertNever(check);
      }
    }
    return {status: status.value, value: input.data};
  }
  _regex(regex, validation, message) {
    return this.refinement(data => regex.test(data), {
      validation: validation,
      code: ZodIssueCode.invalid_string,
      ...errorUtil.errToObj(message),
    });
  }
  _addCheck(check) {
    return new ZodString({...this._def, checks: [...this._def.checks, check]});
  }
  email(message) {
    return this._addCheck({kind: 'email', ...errorUtil.errToObj(message)});
  }
  url(message) {
    return this._addCheck({kind: 'url', ...errorUtil.errToObj(message)});
  }
  emoji(message) {
    return this._addCheck({kind: 'emoji', ...errorUtil.errToObj(message)});
  }
  uuid(message) {
    return this._addCheck({kind: 'uuid', ...errorUtil.errToObj(message)});
  }
  cuid(message) {
    return this._addCheck({kind: 'cuid', ...errorUtil.errToObj(message)});
  }
  cuid2(message) {
    return this._addCheck({kind: 'cuid2', ...errorUtil.errToObj(message)});
  }
  ulid(message) {
    return this._addCheck({kind: 'ulid', ...errorUtil.errToObj(message)});
  }
  ip(options) {
    return this._addCheck({kind: 'ip', ...errorUtil.errToObj(options)});
  }
  datetime(options) {
    var _a;
    if (typeof options === 'string') {
      return this._addCheck({
        kind: 'datetime',
        precision: null,
        offset: false,
        message: options,
      });
    }
    return this._addCheck({
      kind: 'datetime',
      precision:
        typeof (options === null || options === void 0
          ? void 0
          : options.precision) === 'undefined'
          ? null
          : options === null || options === void 0
            ? void 0
            : options.precision,
      offset:
        (_a =
          options === null || options === void 0 ? void 0 : options.offset) !==
          null && _a !== void 0
          ? _a
          : false,
      ...errorUtil.errToObj(
        options === null || options === void 0 ? void 0 : options.message
      ),
    });
  }
  regex(regex, message) {
    return this._addCheck({
      kind: 'regex',
      regex: regex,
      ...errorUtil.errToObj(message),
    });
  }
  includes(value, options) {
    return this._addCheck({
      kind: 'includes',
      value: value,
      position:
        options === null || options === void 0 ? void 0 : options.position,
      ...errorUtil.errToObj(
        options === null || options === void 0 ? void 0 : options.message
      ),
    });
  }
  startsWith(value, message) {
    return this._addCheck({
      kind: 'startsWith',
      value: value,
      ...errorUtil.errToObj(message),
    });
  }
  endsWith(value, message) {
    return this._addCheck({
      kind: 'endsWith',
      value: value,
      ...errorUtil.errToObj(message),
    });
  }
  min(minLength, message) {
    return this._addCheck({
      kind: 'min',
      value: minLength,
      ...errorUtil.errToObj(message),
    });
  }
  max(maxLength, message) {
    return this._addCheck({
      kind: 'max',
      value: maxLength,
      ...errorUtil.errToObj(message),
    });
  }
  length(len, message) {
    return this._addCheck({
      kind: 'length',
      value: len,
      ...errorUtil.errToObj(message),
    });
  }
  nonempty(message) {
    return this.min(1, errorUtil.errToObj(message));
  }
  trim() {
    return new ZodString({
      ...this._def,
      checks: [...this._def.checks, {kind: 'trim'}],
    });
  }
  toLowerCase() {
    return new ZodString({
      ...this._def,
      checks: [...this._def.checks, {kind: 'toLowerCase'}],
    });
  }
  toUpperCase() {
    return new ZodString({
      ...this._def,
      checks: [...this._def.checks, {kind: 'toUpperCase'}],
    });
  }
  get isDatetime() {
    return !!this._def.checks.find(ch => ch.kind === 'datetime');
  }
  get isEmail() {
    return !!this._def.checks.find(ch => ch.kind === 'email');
  }
  get isURL() {
    return !!this._def.checks.find(ch => ch.kind === 'url');
  }
  get isEmoji() {
    return !!this._def.checks.find(ch => ch.kind === 'emoji');
  }
  get isUUID() {
    return !!this._def.checks.find(ch => ch.kind === 'uuid');
  }
  get isCUID() {
    return !!this._def.checks.find(ch => ch.kind === 'cuid');
  }
  get isCUID2() {
    return !!this._def.checks.find(ch => ch.kind === 'cuid2');
  }
  get isULID() {
    return !!this._def.checks.find(ch => ch.kind === 'ulid');
  }
  get isIP() {
    return !!this._def.checks.find(ch => ch.kind === 'ip');
  }
  get minLength() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'min') {
        if (min === null || ch.value > min) min = ch.value;
      }
    }
    return min;
  }
  get maxLength() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'max') {
        if (max === null || ch.value < max) max = ch.value;
      }
    }
    return max;
  }
}
ZodString.create = params => {
  var _a;
  return new ZodString({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodString,
    coerce:
      (_a = params === null || params === void 0 ? void 0 : params.coerce) !==
        null && _a !== void 0
        ? _a
        : false,
    ...processCreateParams(params),
  });
};
function floatSafeRemainder(val, step) {
  const valDecCount = (val.toString().split('.')[1] || '').length;
  const stepDecCount = (step.toString().split('.')[1] || '').length;
  const decCount = valDecCount > stepDecCount ? valDecCount : stepDecCount;
  const valInt = parseInt(val.toFixed(decCount).replace('.', ''));
  const stepInt = parseInt(step.toFixed(decCount).replace('.', ''));
  return (valInt % stepInt) / Math.pow(10, decCount);
}
class ZodNumber extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
    this.step = this.multipleOf;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = Number(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.number) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.number,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    let ctx = undefined;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === 'int') {
        if (!util$1.isInteger(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_type,
            expected: 'integer',
            received: 'float',
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'min') {
        const tooSmall = check.inclusive
          ? input.data < check.value
          : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: 'number',
            inclusive: check.inclusive,
            exact: false,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'max') {
        const tooBig = check.inclusive
          ? input.data > check.value
          : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: 'number',
            inclusive: check.inclusive,
            exact: false,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'multipleOf') {
        if (floatSafeRemainder(input.data, check.value) !== 0) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'finite') {
        if (!Number.isFinite(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_finite,
            message: check.message,
          });
          status.dirty();
        }
      } else {
        util$1.assertNever(check);
      }
    }
    return {status: status.value, value: input.data};
  }
  gte(value, message) {
    return this.setLimit('min', value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit('min', value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit('max', value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit('max', value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new ZodNumber({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind: kind,
          value: value,
          inclusive: inclusive,
          message: errorUtil.toString(message),
        },
      ],
    });
  }
  _addCheck(check) {
    return new ZodNumber({...this._def, checks: [...this._def.checks, check]});
  }
  int(message) {
    return this._addCheck({kind: 'int', message: errorUtil.toString(message)});
  }
  positive(message) {
    return this._addCheck({
      kind: 'min',
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message),
    });
  }
  negative(message) {
    return this._addCheck({
      kind: 'max',
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message),
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: 'max',
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message),
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: 'min',
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message),
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: 'multipleOf',
      value: value,
      message: errorUtil.toString(message),
    });
  }
  finite(message) {
    return this._addCheck({
      kind: 'finite',
      message: errorUtil.toString(message),
    });
  }
  safe(message) {
    return this._addCheck({
      kind: 'min',
      inclusive: true,
      value: Number.MIN_SAFE_INTEGER,
      message: errorUtil.toString(message),
    })._addCheck({
      kind: 'max',
      inclusive: true,
      value: Number.MAX_SAFE_INTEGER,
      message: errorUtil.toString(message),
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'min') {
        if (min === null || ch.value > min) min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'max') {
        if (max === null || ch.value < max) max = ch.value;
      }
    }
    return max;
  }
  get isInt() {
    return !!this._def.checks.find(
      ch =>
        ch.kind === 'int' ||
        (ch.kind === 'multipleOf' && util$1.isInteger(ch.value))
    );
  }
  get isFinite() {
    let max = null,
      min = null;
    for (const ch of this._def.checks) {
      if (
        ch.kind === 'finite' ||
        ch.kind === 'int' ||
        ch.kind === 'multipleOf'
      ) {
        return true;
      } else if (ch.kind === 'min') {
        if (min === null || ch.value > min) min = ch.value;
      } else if (ch.kind === 'max') {
        if (max === null || ch.value < max) max = ch.value;
      }
    }
    return Number.isFinite(min) && Number.isFinite(max);
  }
}
ZodNumber.create = params =>
  new ZodNumber({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodNumber,
    coerce:
      (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params),
  });
class ZodBigInt extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = BigInt(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.bigint) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.bigint,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    let ctx = undefined;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === 'min') {
        const tooSmall = check.inclusive
          ? input.data < check.value
          : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            type: 'bigint',
            minimum: check.value,
            inclusive: check.inclusive,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'max') {
        const tooBig = check.inclusive
          ? input.data > check.value
          : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            type: 'bigint',
            maximum: check.value,
            inclusive: check.inclusive,
            message: check.message,
          });
          status.dirty();
        }
      } else if (check.kind === 'multipleOf') {
        if (input.data % check.value !== BigInt(0)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message,
          });
          status.dirty();
        }
      } else {
        util$1.assertNever(check);
      }
    }
    return {status: status.value, value: input.data};
  }
  gte(value, message) {
    return this.setLimit('min', value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit('min', value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit('max', value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit('max', value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new ZodBigInt({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind: kind,
          value: value,
          inclusive: inclusive,
          message: errorUtil.toString(message),
        },
      ],
    });
  }
  _addCheck(check) {
    return new ZodBigInt({...this._def, checks: [...this._def.checks, check]});
  }
  positive(message) {
    return this._addCheck({
      kind: 'min',
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message),
    });
  }
  negative(message) {
    return this._addCheck({
      kind: 'max',
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message),
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: 'max',
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message),
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: 'min',
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message),
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: 'multipleOf',
      value: value,
      message: errorUtil.toString(message),
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'min') {
        if (min === null || ch.value > min) min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'max') {
        if (max === null || ch.value < max) max = ch.value;
      }
    }
    return max;
  }
}
ZodBigInt.create = params => {
  var _a;
  return new ZodBigInt({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodBigInt,
    coerce:
      (_a = params === null || params === void 0 ? void 0 : params.coerce) !==
        null && _a !== void 0
        ? _a
        : false,
    ...processCreateParams(params),
  });
};
class ZodBoolean extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = Boolean(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.boolean) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.boolean,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    return OK(input.data);
  }
}
ZodBoolean.create = params =>
  new ZodBoolean({
    typeName: ZodFirstPartyTypeKind.ZodBoolean,
    coerce:
      (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params),
  });
class ZodDate extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = new Date(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.date) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.date,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    if (isNaN(input.data.getTime())) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {code: ZodIssueCode.invalid_date});
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = undefined;
    for (const check of this._def.checks) {
      if (check.kind === 'min') {
        if (input.data.getTime() < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            message: check.message,
            inclusive: true,
            exact: false,
            minimum: check.value,
            type: 'date',
          });
          status.dirty();
        }
      } else if (check.kind === 'max') {
        if (input.data.getTime() > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            message: check.message,
            inclusive: true,
            exact: false,
            maximum: check.value,
            type: 'date',
          });
          status.dirty();
        }
      } else {
        util$1.assertNever(check);
      }
    }
    return {status: status.value, value: new Date(input.data.getTime())};
  }
  _addCheck(check) {
    return new ZodDate({...this._def, checks: [...this._def.checks, check]});
  }
  min(minDate, message) {
    return this._addCheck({
      kind: 'min',
      value: minDate.getTime(),
      message: errorUtil.toString(message),
    });
  }
  max(maxDate, message) {
    return this._addCheck({
      kind: 'max',
      value: maxDate.getTime(),
      message: errorUtil.toString(message),
    });
  }
  get minDate() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'min') {
        if (min === null || ch.value > min) min = ch.value;
      }
    }
    return min != null ? new Date(min) : null;
  }
  get maxDate() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === 'max') {
        if (max === null || ch.value < max) max = ch.value;
      }
    }
    return max != null ? new Date(max) : null;
  }
}
ZodDate.create = params =>
  new ZodDate({
    checks: [],
    coerce:
      (params === null || params === void 0 ? void 0 : params.coerce) || false,
    typeName: ZodFirstPartyTypeKind.ZodDate,
    ...processCreateParams(params),
  });
class ZodSymbol extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.symbol) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.symbol,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    return OK(input.data);
  }
}
ZodSymbol.create = params =>
  new ZodSymbol({
    typeName: ZodFirstPartyTypeKind.ZodSymbol,
    ...processCreateParams(params),
  });
class ZodUndefined extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.undefined,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    return OK(input.data);
  }
}
ZodUndefined.create = params =>
  new ZodUndefined({
    typeName: ZodFirstPartyTypeKind.ZodUndefined,
    ...processCreateParams(params),
  });
class ZodNull extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.null) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.null,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    return OK(input.data);
  }
}
ZodNull.create = params =>
  new ZodNull({
    typeName: ZodFirstPartyTypeKind.ZodNull,
    ...processCreateParams(params),
  });
class ZodAny extends ZodType {
  constructor() {
    super(...arguments);
    this._any = true;
  }
  _parse(input) {
    return OK(input.data);
  }
}
ZodAny.create = params =>
  new ZodAny({
    typeName: ZodFirstPartyTypeKind.ZodAny,
    ...processCreateParams(params),
  });
class ZodUnknown extends ZodType {
  constructor() {
    super(...arguments);
    this._unknown = true;
  }
  _parse(input) {
    return OK(input.data);
  }
}
ZodUnknown.create = params =>
  new ZodUnknown({
    typeName: ZodFirstPartyTypeKind.ZodUnknown,
    ...processCreateParams(params),
  });
class ZodNever extends ZodType {
  _parse(input) {
    const ctx = this._getOrReturnCtx(input);
    addIssueToContext(ctx, {
      code: ZodIssueCode.invalid_type,
      expected: ZodParsedType.never,
      received: ctx.parsedType,
    });
    return INVALID;
  }
}
ZodNever.create = params =>
  new ZodNever({
    typeName: ZodFirstPartyTypeKind.ZodNever,
    ...processCreateParams(params),
  });
class ZodVoid extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.void,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    return OK(input.data);
  }
}
ZodVoid.create = params =>
  new ZodVoid({
    typeName: ZodFirstPartyTypeKind.ZodVoid,
    ...processCreateParams(params),
  });
class ZodArray extends ZodType {
  _parse(input) {
    const {ctx: ctx, status: status} = this._processInputParams(input);
    const def = this._def;
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    if (def.exactLength !== null) {
      const tooBig = ctx.data.length > def.exactLength.value;
      const tooSmall = ctx.data.length < def.exactLength.value;
      if (tooBig || tooSmall) {
        addIssueToContext(ctx, {
          code: tooBig ? ZodIssueCode.too_big : ZodIssueCode.too_small,
          minimum: tooSmall ? def.exactLength.value : undefined,
          maximum: tooBig ? def.exactLength.value : undefined,
          type: 'array',
          inclusive: true,
          exact: true,
          message: def.exactLength.message,
        });
        status.dirty();
      }
    }
    if (def.minLength !== null) {
      if (ctx.data.length < def.minLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minLength.value,
          type: 'array',
          inclusive: true,
          exact: false,
          message: def.minLength.message,
        });
        status.dirty();
      }
    }
    if (def.maxLength !== null) {
      if (ctx.data.length > def.maxLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxLength.value,
          type: 'array',
          inclusive: true,
          exact: false,
          message: def.maxLength.message,
        });
        status.dirty();
      }
    }
    if (ctx.common.async) {
      return Promise.all(
        [...ctx.data].map((item, i) =>
          def.type._parseAsync(new ParseInputLazyPath(ctx, item, ctx.path, i))
        )
      ).then(result => ParseStatus.mergeArray(status, result));
    }
    const result = [...ctx.data].map((item, i) =>
      def.type._parseSync(new ParseInputLazyPath(ctx, item, ctx.path, i))
    );
    return ParseStatus.mergeArray(status, result);
  }
  get element() {
    return this._def.type;
  }
  min(minLength, message) {
    return new ZodArray({
      ...this._def,
      minLength: {value: minLength, message: errorUtil.toString(message)},
    });
  }
  max(maxLength, message) {
    return new ZodArray({
      ...this._def,
      maxLength: {value: maxLength, message: errorUtil.toString(message)},
    });
  }
  length(len, message) {
    return new ZodArray({
      ...this._def,
      exactLength: {value: len, message: errorUtil.toString(message)},
    });
  }
  nonempty(message) {
    return this.min(1, message);
  }
}
ZodArray.create = (schema, params) =>
  new ZodArray({
    type: schema,
    minLength: null,
    maxLength: null,
    exactLength: null,
    typeName: ZodFirstPartyTypeKind.ZodArray,
    ...processCreateParams(params),
  });
function deepPartialify(schema) {
  if (schema instanceof ZodObject) {
    const newShape = {};
    for (const key in schema.shape) {
      const fieldSchema = schema.shape[key];
      newShape[key] = ZodOptional.create(deepPartialify(fieldSchema));
    }
    return new ZodObject({...schema._def, shape: () => newShape});
  } else if (schema instanceof ZodArray) {
    return new ZodArray({...schema._def, type: deepPartialify(schema.element)});
  } else if (schema instanceof ZodOptional) {
    return ZodOptional.create(deepPartialify(schema.unwrap()));
  } else if (schema instanceof ZodNullable) {
    return ZodNullable.create(deepPartialify(schema.unwrap()));
  } else if (schema instanceof ZodTuple) {
    return ZodTuple.create(schema.items.map(item => deepPartialify(item)));
  } else {
    return schema;
  }
}
class ZodObject extends ZodType {
  constructor() {
    super(...arguments);
    this._cached = null;
    this.nonstrict = this.passthrough;
    this.augment = this.extend;
  }
  _getCached() {
    if (this._cached !== null) return this._cached;
    const shape = this._def.shape();
    const keys = util$1.objectKeys(shape);
    return (this._cached = {shape: shape, keys: keys});
  }
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.object) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const {status: status, ctx: ctx} = this._processInputParams(input);
    const {shape: shape, keys: shapeKeys} = this._getCached();
    const extraKeys = [];
    if (
      !(
        this._def.catchall instanceof ZodNever &&
        this._def.unknownKeys === 'strip'
      )
    ) {
      for (const key in ctx.data) {
        if (!shapeKeys.includes(key)) {
          extraKeys.push(key);
        }
      }
    }
    const pairs = [];
    for (const key of shapeKeys) {
      const keyValidator = shape[key];
      const value = ctx.data[key];
      pairs.push({
        key: {status: 'valid', value: key},
        value: keyValidator._parse(
          new ParseInputLazyPath(ctx, value, ctx.path, key)
        ),
        alwaysSet: key in ctx.data,
      });
    }
    if (this._def.catchall instanceof ZodNever) {
      const unknownKeys = this._def.unknownKeys;
      if (unknownKeys === 'passthrough') {
        for (const key of extraKeys) {
          pairs.push({
            key: {status: 'valid', value: key},
            value: {status: 'valid', value: ctx.data[key]},
          });
        }
      } else if (unknownKeys === 'strict') {
        if (extraKeys.length > 0) {
          addIssueToContext(ctx, {
            code: ZodIssueCode.unrecognized_keys,
            keys: extraKeys,
          });
          status.dirty();
        }
      } else if (unknownKeys === 'strip');
      else {
        throw new Error(`Internal ZodObject error: invalid unknownKeys value.`);
      }
    } else {
      const catchall = this._def.catchall;
      for (const key of extraKeys) {
        const value = ctx.data[key];
        pairs.push({
          key: {status: 'valid', value: key},
          value: catchall._parse(
            new ParseInputLazyPath(ctx, value, ctx.path, key)
          ),
          alwaysSet: key in ctx.data,
        });
      }
    }
    if (ctx.common.async) {
      return Promise.resolve()
        .then(async () => {
          const syncPairs = [];
          for (const pair of pairs) {
            const key = await pair.key;
            syncPairs.push({
              key: key,
              value: await pair.value,
              alwaysSet: pair.alwaysSet,
            });
          }
          return syncPairs;
        })
        .then(syncPairs => ParseStatus.mergeObjectSync(status, syncPairs));
    } else {
      return ParseStatus.mergeObjectSync(status, pairs);
    }
  }
  get shape() {
    return this._def.shape();
  }
  strict(message) {
    errorUtil.errToObj;
    return new ZodObject({
      ...this._def,
      unknownKeys: 'strict',
      ...(message !== undefined
        ? {
            errorMap: (issue, ctx) => {
              var _a, _b, _c, _d;
              const defaultError =
                (_c =
                  (_b = (_a = this._def).errorMap) === null || _b === void 0
                    ? void 0
                    : _b.call(_a, issue, ctx).message) !== null && _c !== void 0
                  ? _c
                  : ctx.defaultError;
              if (issue.code === 'unrecognized_keys')
                return {
                  message:
                    (_d = errorUtil.errToObj(message).message) !== null &&
                    _d !== void 0
                      ? _d
                      : defaultError,
                };
              return {message: defaultError};
            },
          }
        : {}),
    });
  }
  strip() {
    return new ZodObject({...this._def, unknownKeys: 'strip'});
  }
  passthrough() {
    return new ZodObject({...this._def, unknownKeys: 'passthrough'});
  }
  extend(augmentation) {
    return new ZodObject({
      ...this._def,
      shape: () => ({...this._def.shape(), ...augmentation}),
    });
  }
  merge(merging) {
    const merged = new ZodObject({
      unknownKeys: merging._def.unknownKeys,
      catchall: merging._def.catchall,
      shape: () => ({...this._def.shape(), ...merging._def.shape()}),
      typeName: ZodFirstPartyTypeKind.ZodObject,
    });
    return merged;
  }
  setKey(key, schema) {
    return this.augment({[key]: schema});
  }
  catchall(index) {
    return new ZodObject({...this._def, catchall: index});
  }
  pick(mask) {
    const shape = {};
    util$1.objectKeys(mask).forEach(key => {
      if (mask[key] && this.shape[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new ZodObject({...this._def, shape: () => shape});
  }
  omit(mask) {
    const shape = {};
    util$1.objectKeys(this.shape).forEach(key => {
      if (!mask[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new ZodObject({...this._def, shape: () => shape});
  }
  deepPartial() {
    return deepPartialify(this);
  }
  partial(mask) {
    const newShape = {};
    util$1.objectKeys(this.shape).forEach(key => {
      const fieldSchema = this.shape[key];
      if (mask && !mask[key]) {
        newShape[key] = fieldSchema;
      } else {
        newShape[key] = fieldSchema.optional();
      }
    });
    return new ZodObject({...this._def, shape: () => newShape});
  }
  required(mask) {
    const newShape = {};
    util$1.objectKeys(this.shape).forEach(key => {
      if (mask && !mask[key]) {
        newShape[key] = this.shape[key];
      } else {
        const fieldSchema = this.shape[key];
        let newField = fieldSchema;
        while (newField instanceof ZodOptional) {
          newField = newField._def.innerType;
        }
        newShape[key] = newField;
      }
    });
    return new ZodObject({...this._def, shape: () => newShape});
  }
  keyof() {
    return createZodEnum(util$1.objectKeys(this.shape));
  }
}
ZodObject.create = (shape, params) =>
  new ZodObject({
    shape: () => shape,
    unknownKeys: 'strip',
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params),
  });
ZodObject.strictCreate = (shape, params) =>
  new ZodObject({
    shape: () => shape,
    unknownKeys: 'strict',
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params),
  });
ZodObject.lazycreate = (shape, params) =>
  new ZodObject({
    shape: shape,
    unknownKeys: 'strip',
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params),
  });
class ZodUnion extends ZodType {
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    const options = this._def.options;
    function handleResults(results) {
      for (const result of results) {
        if (result.result.status === 'valid') {
          return result.result;
        }
      }
      for (const result of results) {
        if (result.result.status === 'dirty') {
          ctx.common.issues.push(...result.ctx.common.issues);
          return result.result;
        }
      }
      const unionErrors = results.map(
        result => new ZodError(result.ctx.common.issues)
      );
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors: unionErrors,
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return Promise.all(
        options.map(async option => {
          const childCtx = {
            ...ctx,
            common: {...ctx.common, issues: []},
            parent: null,
          };
          return {
            result: await option._parseAsync({
              data: ctx.data,
              path: ctx.path,
              parent: childCtx,
            }),
            ctx: childCtx,
          };
        })
      ).then(handleResults);
    } else {
      let dirty = undefined;
      const issues = [];
      for (const option of options) {
        const childCtx = {
          ...ctx,
          common: {...ctx.common, issues: []},
          parent: null,
        };
        const result = option._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: childCtx,
        });
        if (result.status === 'valid') {
          return result;
        } else if (result.status === 'dirty' && !dirty) {
          dirty = {result: result, ctx: childCtx};
        }
        if (childCtx.common.issues.length) {
          issues.push(childCtx.common.issues);
        }
      }
      if (dirty) {
        ctx.common.issues.push(...dirty.ctx.common.issues);
        return dirty.result;
      }
      const unionErrors = issues.map(issues => new ZodError(issues));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors: unionErrors,
      });
      return INVALID;
    }
  }
  get options() {
    return this._def.options;
  }
}
ZodUnion.create = (types, params) =>
  new ZodUnion({
    options: types,
    typeName: ZodFirstPartyTypeKind.ZodUnion,
    ...processCreateParams(params),
  });
const getDiscriminator = type => {
  if (type instanceof ZodLazy) {
    return getDiscriminator(type.schema);
  } else if (type instanceof ZodEffects) {
    return getDiscriminator(type.innerType());
  } else if (type instanceof ZodLiteral) {
    return [type.value];
  } else if (type instanceof ZodEnum) {
    return type.options;
  } else if (type instanceof ZodNativeEnum) {
    return Object.keys(type.enum);
  } else if (type instanceof ZodDefault) {
    return getDiscriminator(type._def.innerType);
  } else if (type instanceof ZodUndefined) {
    return [undefined];
  } else if (type instanceof ZodNull) {
    return [null];
  } else {
    return null;
  }
};
class ZodDiscriminatedUnion extends ZodType {
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const discriminator = this.discriminator;
    const discriminatorValue = ctx.data[discriminator];
    const option = this.optionsMap.get(discriminatorValue);
    if (!option) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union_discriminator,
        options: Array.from(this.optionsMap.keys()),
        path: [discriminator],
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return option._parseAsync({data: ctx.data, path: ctx.path, parent: ctx});
    } else {
      return option._parseSync({data: ctx.data, path: ctx.path, parent: ctx});
    }
  }
  get discriminator() {
    return this._def.discriminator;
  }
  get options() {
    return this._def.options;
  }
  get optionsMap() {
    return this._def.optionsMap;
  }
  static create(discriminator, options, params) {
    const optionsMap = new Map();
    for (const type of options) {
      const discriminatorValues = getDiscriminator(type.shape[discriminator]);
      if (!discriminatorValues) {
        throw new Error(
          `A discriminator value for key \`${discriminator}\` could not be extracted from all schema options`
        );
      }
      for (const value of discriminatorValues) {
        if (optionsMap.has(value)) {
          throw new Error(
            `Discriminator property ${String(discriminator)} has duplicate value ${String(value)}`
          );
        }
        optionsMap.set(value, type);
      }
    }
    return new ZodDiscriminatedUnion({
      typeName: ZodFirstPartyTypeKind.ZodDiscriminatedUnion,
      discriminator: discriminator,
      options: options,
      optionsMap: optionsMap,
      ...processCreateParams(params),
    });
  }
}
function mergeValues$1(a, b) {
  const aType = getParsedType(a);
  const bType = getParsedType(b);
  if (a === b) {
    return {valid: true, data: a};
  } else if (aType === ZodParsedType.object && bType === ZodParsedType.object) {
    const bKeys = util$1.objectKeys(b);
    const sharedKeys = util$1
      .objectKeys(a)
      .filter(key => bKeys.indexOf(key) !== -1);
    const newObj = {...a, ...b};
    for (const key of sharedKeys) {
      const sharedValue = mergeValues$1(a[key], b[key]);
      if (!sharedValue.valid) {
        return {valid: false};
      }
      newObj[key] = sharedValue.data;
    }
    return {valid: true, data: newObj};
  } else if (aType === ZodParsedType.array && bType === ZodParsedType.array) {
    if (a.length !== b.length) {
      return {valid: false};
    }
    const newArray = [];
    for (let index = 0; index < a.length; index++) {
      const itemA = a[index];
      const itemB = b[index];
      const sharedValue = mergeValues$1(itemA, itemB);
      if (!sharedValue.valid) {
        return {valid: false};
      }
      newArray.push(sharedValue.data);
    }
    return {valid: true, data: newArray};
  } else if (
    aType === ZodParsedType.date &&
    bType === ZodParsedType.date &&
    +a === +b
  ) {
    return {valid: true, data: a};
  } else {
    return {valid: false};
  }
}
class ZodIntersection extends ZodType {
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    const handleParsed = (parsedLeft, parsedRight) => {
      if (isAborted(parsedLeft) || isAborted(parsedRight)) {
        return INVALID;
      }
      const merged = mergeValues$1(parsedLeft.value, parsedRight.value);
      if (!merged.valid) {
        addIssueToContext(ctx, {code: ZodIssueCode.invalid_intersection_types});
        return INVALID;
      }
      if (isDirty(parsedLeft) || isDirty(parsedRight)) {
        status.dirty();
      }
      return {status: status.value, value: merged.data};
    };
    if (ctx.common.async) {
      return Promise.all([
        this._def.left._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        }),
        this._def.right._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        }),
      ]).then(([left, right]) => handleParsed(left, right));
    } else {
      return handleParsed(
        this._def.left._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        }),
        this._def.right._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        })
      );
    }
  }
}
ZodIntersection.create = (left, right, params) =>
  new ZodIntersection({
    left: left,
    right: right,
    typeName: ZodFirstPartyTypeKind.ZodIntersection,
    ...processCreateParams(params),
  });
class ZodTuple extends ZodType {
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    if (ctx.data.length < this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_small,
        minimum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: 'array',
      });
      return INVALID;
    }
    const rest = this._def.rest;
    if (!rest && ctx.data.length > this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_big,
        maximum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: 'array',
      });
      status.dirty();
    }
    const items = [...ctx.data]
      .map((item, itemIndex) => {
        const schema = this._def.items[itemIndex] || this._def.rest;
        if (!schema) return null;
        return schema._parse(
          new ParseInputLazyPath(ctx, item, ctx.path, itemIndex)
        );
      })
      .filter(x => !!x);
    if (ctx.common.async) {
      return Promise.all(items).then(results =>
        ParseStatus.mergeArray(status, results)
      );
    } else {
      return ParseStatus.mergeArray(status, items);
    }
  }
  get items() {
    return this._def.items;
  }
  rest(rest) {
    return new ZodTuple({...this._def, rest: rest});
  }
}
ZodTuple.create = (schemas, params) => {
  if (!Array.isArray(schemas)) {
    throw new Error('You must pass an array of schemas to z.tuple([ ... ])');
  }
  return new ZodTuple({
    items: schemas,
    typeName: ZodFirstPartyTypeKind.ZodTuple,
    rest: null,
    ...processCreateParams(params),
  });
};
class ZodRecord extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const pairs = [];
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    for (const key in ctx.data) {
      pairs.push({
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, key)),
        value: valueType._parse(
          new ParseInputLazyPath(ctx, ctx.data[key], ctx.path, key)
        ),
      });
    }
    if (ctx.common.async) {
      return ParseStatus.mergeObjectAsync(status, pairs);
    } else {
      return ParseStatus.mergeObjectSync(status, pairs);
    }
  }
  get element() {
    return this._def.valueType;
  }
  static create(first, second, third) {
    if (second instanceof ZodType) {
      return new ZodRecord({
        keyType: first,
        valueType: second,
        typeName: ZodFirstPartyTypeKind.ZodRecord,
        ...processCreateParams(third),
      });
    }
    return new ZodRecord({
      keyType: ZodString.create(),
      valueType: first,
      typeName: ZodFirstPartyTypeKind.ZodRecord,
      ...processCreateParams(second),
    });
  }
}
class ZodMap extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.map) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.map,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    const pairs = [...ctx.data.entries()].map(([key, value], index) => ({
      key: keyType._parse(
        new ParseInputLazyPath(ctx, key, ctx.path, [index, 'key'])
      ),
      value: valueType._parse(
        new ParseInputLazyPath(ctx, value, ctx.path, [index, 'value'])
      ),
    }));
    if (ctx.common.async) {
      const finalMap = new Map();
      return Promise.resolve().then(async () => {
        for (const pair of pairs) {
          const key = await pair.key;
          const value = await pair.value;
          if (key.status === 'aborted' || value.status === 'aborted') {
            return INVALID;
          }
          if (key.status === 'dirty' || value.status === 'dirty') {
            status.dirty();
          }
          finalMap.set(key.value, value.value);
        }
        return {status: status.value, value: finalMap};
      });
    } else {
      const finalMap = new Map();
      for (const pair of pairs) {
        const key = pair.key;
        const value = pair.value;
        if (key.status === 'aborted' || value.status === 'aborted') {
          return INVALID;
        }
        if (key.status === 'dirty' || value.status === 'dirty') {
          status.dirty();
        }
        finalMap.set(key.value, value.value);
      }
      return {status: status.value, value: finalMap};
    }
  }
}
ZodMap.create = (keyType, valueType, params) =>
  new ZodMap({
    valueType: valueType,
    keyType: keyType,
    typeName: ZodFirstPartyTypeKind.ZodMap,
    ...processCreateParams(params),
  });
class ZodSet extends ZodType {
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.set) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.set,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const def = this._def;
    if (def.minSize !== null) {
      if (ctx.data.size < def.minSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minSize.value,
          type: 'set',
          inclusive: true,
          exact: false,
          message: def.minSize.message,
        });
        status.dirty();
      }
    }
    if (def.maxSize !== null) {
      if (ctx.data.size > def.maxSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxSize.value,
          type: 'set',
          inclusive: true,
          exact: false,
          message: def.maxSize.message,
        });
        status.dirty();
      }
    }
    const valueType = this._def.valueType;
    function finalizeSet(elements) {
      const parsedSet = new Set();
      for (const element of elements) {
        if (element.status === 'aborted') return INVALID;
        if (element.status === 'dirty') status.dirty();
        parsedSet.add(element.value);
      }
      return {status: status.value, value: parsedSet};
    }
    const elements = [...ctx.data.values()].map((item, i) =>
      valueType._parse(new ParseInputLazyPath(ctx, item, ctx.path, i))
    );
    if (ctx.common.async) {
      return Promise.all(elements).then(elements => finalizeSet(elements));
    } else {
      return finalizeSet(elements);
    }
  }
  min(minSize, message) {
    return new ZodSet({
      ...this._def,
      minSize: {value: minSize, message: errorUtil.toString(message)},
    });
  }
  max(maxSize, message) {
    return new ZodSet({
      ...this._def,
      maxSize: {value: maxSize, message: errorUtil.toString(message)},
    });
  }
  size(size, message) {
    return this.min(size, message).max(size, message);
  }
  nonempty(message) {
    return this.min(1, message);
  }
}
ZodSet.create = (valueType, params) =>
  new ZodSet({
    valueType: valueType,
    minSize: null,
    maxSize: null,
    typeName: ZodFirstPartyTypeKind.ZodSet,
    ...processCreateParams(params),
  });
class ZodFunction extends ZodType {
  constructor() {
    super(...arguments);
    this.validate = this.implement;
  }
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.function) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.function,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    function makeArgsIssue(args, error) {
      return makeIssue({
        data: args,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap,
        ].filter(x => !!x),
        issueData: {
          code: ZodIssueCode.invalid_arguments,
          argumentsError: error,
        },
      });
    }
    function makeReturnsIssue(returns, error) {
      return makeIssue({
        data: returns,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap,
        ].filter(x => !!x),
        issueData: {
          code: ZodIssueCode.invalid_return_type,
          returnTypeError: error,
        },
      });
    }
    const params = {errorMap: ctx.common.contextualErrorMap};
    const fn = ctx.data;
    if (this._def.returns instanceof ZodPromise) {
      const me = this;
      return OK(async function (...args) {
        const error = new ZodError([]);
        const parsedArgs = await me._def.args
          .parseAsync(args, params)
          .catch(e => {
            error.addIssue(makeArgsIssue(args, e));
            throw error;
          });
        const result = await Reflect.apply(fn, this, parsedArgs);
        const parsedReturns = await me._def.returns._def.type
          .parseAsync(result, params)
          .catch(e => {
            error.addIssue(makeReturnsIssue(result, e));
            throw error;
          });
        return parsedReturns;
      });
    } else {
      const me = this;
      return OK(function (...args) {
        const parsedArgs = me._def.args.safeParse(args, params);
        if (!parsedArgs.success) {
          throw new ZodError([makeArgsIssue(args, parsedArgs.error)]);
        }
        const result = Reflect.apply(fn, this, parsedArgs.data);
        const parsedReturns = me._def.returns.safeParse(result, params);
        if (!parsedReturns.success) {
          throw new ZodError([makeReturnsIssue(result, parsedReturns.error)]);
        }
        return parsedReturns.data;
      });
    }
  }
  parameters() {
    return this._def.args;
  }
  returnType() {
    return this._def.returns;
  }
  args(...items) {
    return new ZodFunction({
      ...this._def,
      args: ZodTuple.create(items).rest(ZodUnknown.create()),
    });
  }
  returns(returnType) {
    return new ZodFunction({...this._def, returns: returnType});
  }
  implement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  strictImplement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  static create(args, returns, params) {
    return new ZodFunction({
      args: args ? args : ZodTuple.create([]).rest(ZodUnknown.create()),
      returns: returns || ZodUnknown.create(),
      typeName: ZodFirstPartyTypeKind.ZodFunction,
      ...processCreateParams(params),
    });
  }
}
class ZodLazy extends ZodType {
  get schema() {
    return this._def.getter();
  }
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    const lazySchema = this._def.getter();
    return lazySchema._parse({data: ctx.data, path: ctx.path, parent: ctx});
  }
}
ZodLazy.create = (getter, params) =>
  new ZodLazy({
    getter: getter,
    typeName: ZodFirstPartyTypeKind.ZodLazy,
    ...processCreateParams(params),
  });
class ZodLiteral extends ZodType {
  _parse(input) {
    if (input.data !== this._def.value) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_literal,
        expected: this._def.value,
      });
      return INVALID;
    }
    return {status: 'valid', value: input.data};
  }
  get value() {
    return this._def.value;
  }
}
ZodLiteral.create = (value, params) =>
  new ZodLiteral({
    value: value,
    typeName: ZodFirstPartyTypeKind.ZodLiteral,
    ...processCreateParams(params),
  });
function createZodEnum(values, params) {
  return new ZodEnum({
    values: values,
    typeName: ZodFirstPartyTypeKind.ZodEnum,
    ...processCreateParams(params),
  });
}
class ZodEnum extends ZodType {
  _parse(input) {
    if (typeof input.data !== 'string') {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        expected: util$1.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type,
      });
      return INVALID;
    }
    if (this._def.values.indexOf(input.data) === -1) {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues,
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get options() {
    return this._def.values;
  }
  get enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Values() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  extract(values) {
    return ZodEnum.create(values);
  }
  exclude(values) {
    return ZodEnum.create(this.options.filter(opt => !values.includes(opt)));
  }
}
ZodEnum.create = createZodEnum;
class ZodNativeEnum extends ZodType {
  _parse(input) {
    const nativeEnumValues = util$1.getValidEnumValues(this._def.values);
    const ctx = this._getOrReturnCtx(input);
    if (
      ctx.parsedType !== ZodParsedType.string &&
      ctx.parsedType !== ZodParsedType.number
    ) {
      const expectedValues = util$1.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        expected: util$1.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type,
      });
      return INVALID;
    }
    if (nativeEnumValues.indexOf(input.data) === -1) {
      const expectedValues = util$1.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues,
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get enum() {
    return this._def.values;
  }
}
ZodNativeEnum.create = (values, params) =>
  new ZodNativeEnum({
    values: values,
    typeName: ZodFirstPartyTypeKind.ZodNativeEnum,
    ...processCreateParams(params),
  });
class ZodPromise extends ZodType {
  unwrap() {
    return this._def.type;
  }
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    if (
      ctx.parsedType !== ZodParsedType.promise &&
      ctx.common.async === false
    ) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.promise,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    const promisified =
      ctx.parsedType === ZodParsedType.promise
        ? ctx.data
        : Promise.resolve(ctx.data);
    return OK(
      promisified.then(data =>
        this._def.type.parseAsync(data, {
          path: ctx.path,
          errorMap: ctx.common.contextualErrorMap,
        })
      )
    );
  }
}
ZodPromise.create = (schema, params) =>
  new ZodPromise({
    type: schema,
    typeName: ZodFirstPartyTypeKind.ZodPromise,
    ...processCreateParams(params),
  });
class ZodEffects extends ZodType {
  innerType() {
    return this._def.schema;
  }
  sourceType() {
    return this._def.schema._def.typeName === ZodFirstPartyTypeKind.ZodEffects
      ? this._def.schema.sourceType()
      : this._def.schema;
  }
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    const effect = this._def.effect || null;
    const checkCtx = {
      addIssue: arg => {
        addIssueToContext(ctx, arg);
        if (arg.fatal) {
          status.abort();
        } else {
          status.dirty();
        }
      },
      get path() {
        return ctx.path;
      },
    };
    checkCtx.addIssue = checkCtx.addIssue.bind(checkCtx);
    if (effect.type === 'preprocess') {
      const processed = effect.transform(ctx.data, checkCtx);
      if (ctx.common.issues.length) {
        return {status: 'dirty', value: ctx.data};
      }
      if (ctx.common.async) {
        return Promise.resolve(processed).then(processed =>
          this._def.schema._parseAsync({
            data: processed,
            path: ctx.path,
            parent: ctx,
          })
        );
      } else {
        return this._def.schema._parseSync({
          data: processed,
          path: ctx.path,
          parent: ctx,
        });
      }
    }
    if (effect.type === 'refinement') {
      const executeRefinement = acc => {
        const result = effect.refinement(acc, checkCtx);
        if (ctx.common.async) {
          return Promise.resolve(result);
        }
        if (result instanceof Promise) {
          throw new Error(
            'Async refinement encountered during synchronous parse operation. Use .parseAsync instead.'
          );
        }
        return acc;
      };
      if (ctx.common.async === false) {
        const inner = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        });
        if (inner.status === 'aborted') return INVALID;
        if (inner.status === 'dirty') status.dirty();
        executeRefinement(inner.value);
        return {status: status.value, value: inner.value};
      } else {
        return this._def.schema
          ._parseAsync({data: ctx.data, path: ctx.path, parent: ctx})
          .then(inner => {
            if (inner.status === 'aborted') return INVALID;
            if (inner.status === 'dirty') status.dirty();
            return executeRefinement(inner.value).then(() => ({
              status: status.value,
              value: inner.value,
            }));
          });
      }
    }
    if (effect.type === 'transform') {
      if (ctx.common.async === false) {
        const base = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        });
        if (!isValid(base)) return base;
        const result = effect.transform(base.value, checkCtx);
        if (result instanceof Promise) {
          throw new Error(
            `Asynchronous transform encountered during synchronous parse operation. Use .parseAsync instead.`
          );
        }
        return {status: status.value, value: result};
      } else {
        return this._def.schema
          ._parseAsync({data: ctx.data, path: ctx.path, parent: ctx})
          .then(base => {
            if (!isValid(base)) return base;
            return Promise.resolve(effect.transform(base.value, checkCtx)).then(
              result => ({status: status.value, value: result})
            );
          });
      }
    }
    util$1.assertNever(effect);
  }
}
ZodEffects.create = (schema, effect, params) =>
  new ZodEffects({
    schema: schema,
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    effect: effect,
    ...processCreateParams(params),
  });
ZodEffects.createWithPreprocess = (preprocess, schema, params) =>
  new ZodEffects({
    schema: schema,
    effect: {type: 'preprocess', transform: preprocess},
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    ...processCreateParams(params),
  });
class ZodOptional extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.undefined) {
      return OK(undefined);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
}
ZodOptional.create = (type, params) =>
  new ZodOptional({
    innerType: type,
    typeName: ZodFirstPartyTypeKind.ZodOptional,
    ...processCreateParams(params),
  });
class ZodNullable extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.null) {
      return OK(null);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
}
ZodNullable.create = (type, params) =>
  new ZodNullable({
    innerType: type,
    typeName: ZodFirstPartyTypeKind.ZodNullable,
    ...processCreateParams(params),
  });
class ZodDefault extends ZodType {
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    let data = ctx.data;
    if (ctx.parsedType === ZodParsedType.undefined) {
      data = this._def.defaultValue();
    }
    return this._def.innerType._parse({
      data: data,
      path: ctx.path,
      parent: ctx,
    });
  }
  removeDefault() {
    return this._def.innerType;
  }
}
ZodDefault.create = (type, params) =>
  new ZodDefault({
    innerType: type,
    typeName: ZodFirstPartyTypeKind.ZodDefault,
    defaultValue:
      typeof params.default === 'function'
        ? params.default
        : () => params.default,
    ...processCreateParams(params),
  });
class ZodCatch extends ZodType {
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    const newCtx = {...ctx, common: {...ctx.common, issues: []}};
    const result = this._def.innerType._parse({
      data: newCtx.data,
      path: newCtx.path,
      parent: {...newCtx},
    });
    if (isAsync(result)) {
      return result.then(result => ({
        status: 'valid',
        value:
          result.status === 'valid'
            ? result.value
            : this._def.catchValue({
                get error() {
                  return new ZodError(newCtx.common.issues);
                },
                input: newCtx.data,
              }),
      }));
    } else {
      return {
        status: 'valid',
        value:
          result.status === 'valid'
            ? result.value
            : this._def.catchValue({
                get error() {
                  return new ZodError(newCtx.common.issues);
                },
                input: newCtx.data,
              }),
      };
    }
  }
  removeCatch() {
    return this._def.innerType;
  }
}
ZodCatch.create = (type, params) =>
  new ZodCatch({
    innerType: type,
    typeName: ZodFirstPartyTypeKind.ZodCatch,
    catchValue:
      typeof params.catch === 'function' ? params.catch : () => params.catch,
    ...processCreateParams(params),
  });
class ZodNaN extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.nan) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.nan,
        received: ctx.parsedType,
      });
      return INVALID;
    }
    return {status: 'valid', value: input.data};
  }
}
ZodNaN.create = params =>
  new ZodNaN({
    typeName: ZodFirstPartyTypeKind.ZodNaN,
    ...processCreateParams(params),
  });
const BRAND = Symbol('zod_brand');
class ZodBranded extends ZodType {
  _parse(input) {
    const {ctx: ctx} = this._processInputParams(input);
    const data = ctx.data;
    return this._def.type._parse({data: data, path: ctx.path, parent: ctx});
  }
  unwrap() {
    return this._def.type;
  }
}
class ZodPipeline extends ZodType {
  _parse(input) {
    const {status: status, ctx: ctx} = this._processInputParams(input);
    if (ctx.common.async) {
      const handleAsync = async () => {
        const inResult = await this._def.in._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx,
        });
        if (inResult.status === 'aborted') return INVALID;
        if (inResult.status === 'dirty') {
          status.dirty();
          return DIRTY(inResult.value);
        } else {
          return this._def.out._parseAsync({
            data: inResult.value,
            path: ctx.path,
            parent: ctx,
          });
        }
      };
      return handleAsync();
    } else {
      const inResult = this._def.in._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx,
      });
      if (inResult.status === 'aborted') return INVALID;
      if (inResult.status === 'dirty') {
        status.dirty();
        return {status: 'dirty', value: inResult.value};
      } else {
        return this._def.out._parseSync({
          data: inResult.value,
          path: ctx.path,
          parent: ctx,
        });
      }
    }
  }
  static create(a, b) {
    return new ZodPipeline({
      in: a,
      out: b,
      typeName: ZodFirstPartyTypeKind.ZodPipeline,
    });
  }
}
class ZodReadonly extends ZodType {
  _parse(input) {
    const result = this._def.innerType._parse(input);
    if (isValid(result)) {
      result.value = Object.freeze(result.value);
    }
    return result;
  }
}
ZodReadonly.create = (type, params) =>
  new ZodReadonly({
    innerType: type,
    typeName: ZodFirstPartyTypeKind.ZodReadonly,
    ...processCreateParams(params),
  });
const custom = (check, params = {}, fatal) => {
  if (check)
    return ZodAny.create().superRefine((data, ctx) => {
      var _a, _b;
      if (!check(data)) {
        const p =
          typeof params === 'function'
            ? params(data)
            : typeof params === 'string'
              ? {message: params}
              : params;
        const _fatal =
          (_b = (_a = p.fatal) !== null && _a !== void 0 ? _a : fatal) !==
            null && _b !== void 0
            ? _b
            : true;
        const p2 = typeof p === 'string' ? {message: p} : p;
        ctx.addIssue({code: 'custom', ...p2, fatal: _fatal});
      }
    });
  return ZodAny.create();
};
const late = {object: ZodObject.lazycreate};
var ZodFirstPartyTypeKind;
(function (ZodFirstPartyTypeKind) {
  ZodFirstPartyTypeKind['ZodString'] = 'ZodString';
  ZodFirstPartyTypeKind['ZodNumber'] = 'ZodNumber';
  ZodFirstPartyTypeKind['ZodNaN'] = 'ZodNaN';
  ZodFirstPartyTypeKind['ZodBigInt'] = 'ZodBigInt';
  ZodFirstPartyTypeKind['ZodBoolean'] = 'ZodBoolean';
  ZodFirstPartyTypeKind['ZodDate'] = 'ZodDate';
  ZodFirstPartyTypeKind['ZodSymbol'] = 'ZodSymbol';
  ZodFirstPartyTypeKind['ZodUndefined'] = 'ZodUndefined';
  ZodFirstPartyTypeKind['ZodNull'] = 'ZodNull';
  ZodFirstPartyTypeKind['ZodAny'] = 'ZodAny';
  ZodFirstPartyTypeKind['ZodUnknown'] = 'ZodUnknown';
  ZodFirstPartyTypeKind['ZodNever'] = 'ZodNever';
  ZodFirstPartyTypeKind['ZodVoid'] = 'ZodVoid';
  ZodFirstPartyTypeKind['ZodArray'] = 'ZodArray';
  ZodFirstPartyTypeKind['ZodObject'] = 'ZodObject';
  ZodFirstPartyTypeKind['ZodUnion'] = 'ZodUnion';
  ZodFirstPartyTypeKind['ZodDiscriminatedUnion'] = 'ZodDiscriminatedUnion';
  ZodFirstPartyTypeKind['ZodIntersection'] = 'ZodIntersection';
  ZodFirstPartyTypeKind['ZodTuple'] = 'ZodTuple';
  ZodFirstPartyTypeKind['ZodRecord'] = 'ZodRecord';
  ZodFirstPartyTypeKind['ZodMap'] = 'ZodMap';
  ZodFirstPartyTypeKind['ZodSet'] = 'ZodSet';
  ZodFirstPartyTypeKind['ZodFunction'] = 'ZodFunction';
  ZodFirstPartyTypeKind['ZodLazy'] = 'ZodLazy';
  ZodFirstPartyTypeKind['ZodLiteral'] = 'ZodLiteral';
  ZodFirstPartyTypeKind['ZodEnum'] = 'ZodEnum';
  ZodFirstPartyTypeKind['ZodEffects'] = 'ZodEffects';
  ZodFirstPartyTypeKind['ZodNativeEnum'] = 'ZodNativeEnum';
  ZodFirstPartyTypeKind['ZodOptional'] = 'ZodOptional';
  ZodFirstPartyTypeKind['ZodNullable'] = 'ZodNullable';
  ZodFirstPartyTypeKind['ZodDefault'] = 'ZodDefault';
  ZodFirstPartyTypeKind['ZodCatch'] = 'ZodCatch';
  ZodFirstPartyTypeKind['ZodPromise'] = 'ZodPromise';
  ZodFirstPartyTypeKind['ZodBranded'] = 'ZodBranded';
  ZodFirstPartyTypeKind['ZodPipeline'] = 'ZodPipeline';
  ZodFirstPartyTypeKind['ZodReadonly'] = 'ZodReadonly';
})(ZodFirstPartyTypeKind || (ZodFirstPartyTypeKind = {}));
const instanceOfType = (
  cls,
  params = {message: `Input not instance of ${cls.name}`}
) => custom(data => data instanceof cls, params);
const stringType = ZodString.create;
const numberType = ZodNumber.create;
const nanType = ZodNaN.create;
const bigIntType = ZodBigInt.create;
const booleanType = ZodBoolean.create;
const dateType = ZodDate.create;
const symbolType = ZodSymbol.create;
const undefinedType = ZodUndefined.create;
const nullType = ZodNull.create;
const anyType = ZodAny.create;
const unknownType = ZodUnknown.create;
const neverType = ZodNever.create;
const voidType = ZodVoid.create;
const arrayType = ZodArray.create;
const objectType = ZodObject.create;
const strictObjectType = ZodObject.strictCreate;
const unionType = ZodUnion.create;
const discriminatedUnionType = ZodDiscriminatedUnion.create;
const intersectionType = ZodIntersection.create;
const tupleType = ZodTuple.create;
const recordType = ZodRecord.create;
const mapType = ZodMap.create;
const setType = ZodSet.create;
const functionType = ZodFunction.create;
const lazyType = ZodLazy.create;
const literalType = ZodLiteral.create;
const enumType = ZodEnum.create;
const nativeEnumType = ZodNativeEnum.create;
const promiseType = ZodPromise.create;
const effectsType = ZodEffects.create;
const optionalType = ZodOptional.create;
const nullableType = ZodNullable.create;
const preprocessType = ZodEffects.createWithPreprocess;
const pipelineType = ZodPipeline.create;
const ostring = () => stringType().optional();
const onumber = () => numberType().optional();
const oboolean = () => booleanType().optional();
const coerce = {
  string: arg => ZodString.create({...arg, coerce: true}),
  number: arg => ZodNumber.create({...arg, coerce: true}),
  boolean: arg => ZodBoolean.create({...arg, coerce: true}),
  bigint: arg => ZodBigInt.create({...arg, coerce: true}),
  date: arg => ZodDate.create({...arg, coerce: true}),
};
const NEVER = INVALID;
var z = Object.freeze({
  __proto__: null,
  defaultErrorMap: errorMap,
  setErrorMap: setErrorMap,
  getErrorMap: getErrorMap,
  makeIssue: makeIssue,
  EMPTY_PATH: EMPTY_PATH,
  addIssueToContext: addIssueToContext,
  ParseStatus: ParseStatus,
  INVALID: INVALID,
  DIRTY: DIRTY,
  OK: OK,
  isAborted: isAborted,
  isDirty: isDirty,
  isValid: isValid,
  isAsync: isAsync,
  get util() {
    return util$1;
  },
  get objectUtil() {
    return objectUtil;
  },
  ZodParsedType: ZodParsedType,
  getParsedType: getParsedType,
  ZodType: ZodType,
  ZodString: ZodString,
  ZodNumber: ZodNumber,
  ZodBigInt: ZodBigInt,
  ZodBoolean: ZodBoolean,
  ZodDate: ZodDate,
  ZodSymbol: ZodSymbol,
  ZodUndefined: ZodUndefined,
  ZodNull: ZodNull,
  ZodAny: ZodAny,
  ZodUnknown: ZodUnknown,
  ZodNever: ZodNever,
  ZodVoid: ZodVoid,
  ZodArray: ZodArray,
  ZodObject: ZodObject,
  ZodUnion: ZodUnion,
  ZodDiscriminatedUnion: ZodDiscriminatedUnion,
  ZodIntersection: ZodIntersection,
  ZodTuple: ZodTuple,
  ZodRecord: ZodRecord,
  ZodMap: ZodMap,
  ZodSet: ZodSet,
  ZodFunction: ZodFunction,
  ZodLazy: ZodLazy,
  ZodLiteral: ZodLiteral,
  ZodEnum: ZodEnum,
  ZodNativeEnum: ZodNativeEnum,
  ZodPromise: ZodPromise,
  ZodEffects: ZodEffects,
  ZodTransformer: ZodEffects,
  ZodOptional: ZodOptional,
  ZodNullable: ZodNullable,
  ZodDefault: ZodDefault,
  ZodCatch: ZodCatch,
  ZodNaN: ZodNaN,
  BRAND: BRAND,
  ZodBranded: ZodBranded,
  ZodPipeline: ZodPipeline,
  ZodReadonly: ZodReadonly,
  custom: custom,
  Schema: ZodType,
  ZodSchema: ZodType,
  late: late,
  get ZodFirstPartyTypeKind() {
    return ZodFirstPartyTypeKind;
  },
  coerce: coerce,
  any: anyType,
  array: arrayType,
  bigint: bigIntType,
  boolean: booleanType,
  date: dateType,
  discriminatedUnion: discriminatedUnionType,
  effect: effectsType,
  enum: enumType,
  function: functionType,
  instanceof: instanceOfType,
  intersection: intersectionType,
  lazy: lazyType,
  literal: literalType,
  map: mapType,
  nan: nanType,
  nativeEnum: nativeEnumType,
  never: neverType,
  null: nullType,
  nullable: nullableType,
  number: numberType,
  object: objectType,
  oboolean: oboolean,
  onumber: onumber,
  optional: optionalType,
  ostring: ostring,
  pipeline: pipelineType,
  preprocess: preprocessType,
  promise: promiseType,
  record: recordType,
  set: setType,
  strictObject: strictObjectType,
  string: stringType,
  symbol: symbolType,
  transformer: effectsType,
  tuple: tupleType,
  undefined: undefinedType,
  union: unionType,
  unknown: unknownType,
  void: voidType,
  NEVER: NEVER,
  ZodIssueCode: ZodIssueCode,
  quotelessJson: quotelessJson,
  ZodError: ZodError,
});
const GeneratedSource = Symbol();
function isStatementBlockKind(kind) {
  return kind === 'block' || kind === 'catch';
}
function isExpressionBlockKind(kind) {
  return !isStatementBlockKind(kind);
}
var GotoVariant;
(function (GotoVariant) {
  GotoVariant['Break'] = 'Break';
  GotoVariant['Continue'] = 'Continue';
  GotoVariant['Try'] = 'Try';
})(GotoVariant || (GotoVariant = {}));
var InstructionKind;
(function (InstructionKind) {
  InstructionKind['Const'] = 'Const';
  InstructionKind['Let'] = 'Let';
  InstructionKind['Reassign'] = 'Reassign';
  InstructionKind['Catch'] = 'Catch';
  InstructionKind['HoistedConst'] = 'HoistedConst';
  InstructionKind['HoistedLet'] = 'HoistedLet';
  InstructionKind['HoistedFunction'] = 'HoistedFunction';
  InstructionKind['Function'] = 'Function';
})(InstructionKind || (InstructionKind = {}));
function makeTemporaryIdentifier(id, loc) {
  return {
    id: id,
    name: null,
    declarationId: makeDeclarationId(id),
    mutableRange: {start: makeInstructionId(0), end: makeInstructionId(0)},
    scope: null,
    type: makeType(),
    loc: loc,
  };
}
function forkTemporaryIdentifier(id, source) {
  return Object.assign(Object.assign({}, source), {
    mutableRange: {start: makeInstructionId(0), end: makeInstructionId(0)},
    id: id,
  });
}
function makeIdentifierName(name) {
  CompilerError.invariant(t__namespace.isValidIdentifier(name), {
    reason: `Expected a valid identifier name`,
    loc: GeneratedSource,
    description: `\`${name}\` is not a valid JavaScript identifier`,
    suggestions: null,
  });
  return {kind: 'named', value: name};
}
function promoteTemporary(identifier) {
  CompilerError.invariant(identifier.name === null, {
    reason: `Expected a temporary (unnamed) identifier`,
    loc: GeneratedSource,
    description: `Identifier already has a name, \`${identifier.name}\``,
    suggestions: null,
  });
  identifier.name = {kind: 'promoted', value: `#t${identifier.declarationId}`};
}
function isPromotedTemporary(name) {
  return name.startsWith('#t');
}
function promoteTemporaryJsxTag(identifier) {
  CompilerError.invariant(identifier.name === null, {
    reason: `Expected a temporary (unnamed) identifier`,
    loc: GeneratedSource,
    description: `Identifier already has a name, \`${identifier.name}\``,
    suggestions: null,
  });
  identifier.name = {kind: 'promoted', value: `#T${identifier.declarationId}`};
}
function isPromotedJsxTemporary(name) {
  return name.startsWith('#T');
}
var ValueReason;
(function (ValueReason) {
  ValueReason['Global'] = 'global';
  ValueReason['JsxCaptured'] = 'jsx-captured';
  ValueReason['KnownReturnSignature'] = 'known-return-signature';
  ValueReason['Context'] = 'context';
  ValueReason['State'] = 'state';
  ValueReason['ReducerState'] = 'reducer-state';
  ValueReason['ReactiveFunctionArgument'] = 'reactive-function-argument';
  ValueReason['Other'] = 'other';
})(ValueReason || (ValueReason = {}));
exports.ValueKind = void 0;
(function (ValueKind) {
  ValueKind['MaybeFrozen'] = 'maybefrozen';
  ValueKind['Frozen'] = 'frozen';
  ValueKind['Primitive'] = 'primitive';
  ValueKind['Global'] = 'global';
  ValueKind['Mutable'] = 'mutable';
  ValueKind['Context'] = 'context';
})(exports.ValueKind || (exports.ValueKind = {}));
const ValueKindSchema = z.enum([
  exports.ValueKind.MaybeFrozen,
  exports.ValueKind.Frozen,
  exports.ValueKind.Primitive,
  exports.ValueKind.Global,
  exports.ValueKind.Mutable,
  exports.ValueKind.Context,
]);
exports.Effect = void 0;
(function (Effect) {
  Effect['Unknown'] = '<unknown>';
  Effect['Freeze'] = 'freeze';
  Effect['Read'] = 'read';
  Effect['Capture'] = 'capture';
  Effect['ConditionallyMutate'] = 'mutate?';
  Effect['Mutate'] = 'mutate';
  Effect['Store'] = 'store';
})(exports.Effect || (exports.Effect = {}));
const EffectSchema = z.enum([
  exports.Effect.Read,
  exports.Effect.Mutate,
  exports.Effect.ConditionallyMutate,
  exports.Effect.Capture,
  exports.Effect.Store,
  exports.Effect.Freeze,
]);
function isMutableEffect(effect, location) {
  switch (effect) {
    case exports.Effect.Capture:
    case exports.Effect.Store:
    case exports.Effect.ConditionallyMutate:
    case exports.Effect.Mutate: {
      return true;
    }
    case exports.Effect.Unknown: {
      CompilerError.invariant(false, {
        reason: 'Unexpected unknown effect',
        description: null,
        loc: location,
        suggestions: null,
      });
    }
    case exports.Effect.Read:
    case exports.Effect.Freeze: {
      return false;
    }
    default: {
      assertExhaustive(effect, `Unexpected effect \`${effect}\``);
    }
  }
}
function areEqualPaths(a, b) {
  return (
    a.length === b.length &&
    a.every(
      (item, ix) =>
        item.property === b[ix].property && item.optional === b[ix].optional
    )
  );
}
function getPlaceScope(id, place) {
  const scope = place.identifier.scope;
  if (scope !== null && isScopeActive(scope, id)) {
    return scope;
  }
  return null;
}
function isScopeActive(scope, id) {
  return id >= scope.range.start && id < scope.range.end;
}
function makeBlockId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected block id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
function makeScopeId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected block id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
function makeIdentifierId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected identifier id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
function makeDeclarationId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected declaration id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
function makeInstructionId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected instruction id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
function isObjectMethodType(id) {
  return id.type.kind == 'ObjectMethod';
}
function isObjectType(id) {
  return id.type.kind === 'Object';
}
function isPrimitiveType(id) {
  return id.type.kind === 'Primitive';
}
function isArrayType(id) {
  return id.type.kind === 'Object' && id.type.shapeId === 'BuiltInArray';
}
function isRefValueType(id) {
  return id.type.kind === 'Object' && id.type.shapeId === 'BuiltInRefValue';
}
function isUseRefType(id) {
  return id.type.kind === 'Object' && id.type.shapeId === 'BuiltInUseRefId';
}
function isUseStateType(id) {
  return id.type.kind === 'Object' && id.type.shapeId === 'BuiltInUseState';
}
function isRefOrRefValue(id) {
  return isUseRefType(id) || isRefValueType(id);
}
function isSetStateType(id) {
  return id.type.kind === 'Function' && id.type.shapeId === 'BuiltInSetState';
}
function isStartTransitionType(id) {
  return (
    id.type.kind === 'Function' && id.type.shapeId === 'BuiltInStartTransition'
  );
}
function isSetActionStateType(id) {
  return (
    id.type.kind === 'Function' && id.type.shapeId === 'BuiltInSetActionState'
  );
}
function isDispatcherType(id) {
  return id.type.kind === 'Function' && id.type.shapeId === 'BuiltInDispatch';
}
function isStableType(id) {
  return (
    isSetStateType(id) ||
    isSetActionStateType(id) ||
    isDispatcherType(id) ||
    isUseRefType(id) ||
    isStartTransitionType(id)
  );
}
function isUseEffectHookType(id) {
  return (
    id.type.kind === 'Function' && id.type.shapeId === 'BuiltInUseEffectHook'
  );
}
function isUseLayoutEffectHookType(id) {
  return (
    id.type.kind === 'Function' &&
    id.type.shapeId === 'BuiltInUseLayoutEffectHook'
  );
}
function isUseInsertionEffectHookType(id) {
  return (
    id.type.kind === 'Function' &&
    id.type.shapeId === 'BuiltInUseInsertionEffectHook'
  );
}
function isUseContextHookType(id) {
  return (
    id.type.kind === 'Function' && id.type.shapeId === 'BuiltInUseContextHook'
  );
}
function getHookKind(env, id) {
  return getHookKindForType(env, id.type);
}
function isUseOperator(id) {
  return (
    id.type.kind === 'Function' && id.type.shapeId === 'BuiltInUseOperator'
  );
}
function getHookKindForType(env, type) {
  var _a;
  if (type.kind === 'Function') {
    const signature = env.getFunctionSignature(type);
    return (_a =
      signature === null || signature === void 0
        ? void 0
        : signature.hookKind) !== null && _a !== void 0
      ? _a
      : null;
  }
  return null;
}
function __classPrivateFieldGet(receiver, state, kind, f) {
  if (kind === 'a' && !f)
    throw new TypeError('Private accessor was defined without a getter');
  if (
    typeof state === 'function'
      ? receiver !== state || !f
      : !state.has(receiver)
  )
    throw new TypeError(
      'Cannot read private member from an object whose class did not declare it'
    );
  return kind === 'm'
    ? f
    : kind === 'a'
      ? f.call(receiver)
      : f
        ? f.value
        : state.get(receiver);
}
function __classPrivateFieldSet(receiver, state, value, kind, f) {
  if (kind === 'm') throw new TypeError('Private method is not writable');
  if (kind === 'a' && !f)
    throw new TypeError('Private accessor was defined without a setter');
  if (
    typeof state === 'function'
      ? receiver !== state || !f
      : !state.has(receiver)
  )
    throw new TypeError(
      'Cannot write private member to an object whose class did not declare it'
    );
  return (
    kind === 'a'
      ? f.call(receiver, value)
      : f
        ? (f.value = value)
        : state.set(receiver, value),
    value
  );
}
var _Writer_out, _Writer_line, _Writer_depth;
function printReactiveFunction(fn) {
  const writer = new Writer();
  writeReactiveFunction(fn, writer);
  return writer.complete();
}
function writeReactiveFunction(fn, writer) {
  writer.writeLine(`function ${fn.id !== null ? fn.id : '<unknown>'}(`);
  writer.indented(() => {
    for (const param of fn.params) {
      if (param.kind === 'Identifier') {
        writer.writeLine(`${printPlace(param)},`);
      } else {
        writer.writeLine(`...${printPlace(param.place)},`);
      }
    }
  });
  writer.writeLine(') {');
  writeReactiveInstructions(writer, fn.body);
  writer.writeLine('}');
}
function printReactiveScopeSummary(scope) {
  const items = [];
  items.push('scope');
  items.push(`@${scope.id}`);
  items.push(`[${scope.range.start}:${scope.range.end}]`);
  items.push(
    `dependencies=[${Array.from(scope.dependencies)
      .map(dep => printDependency(dep))
      .join(', ')}]`
  );
  items.push(
    `declarations=[${Array.from(scope.declarations)
      .map(([, decl]) =>
        printIdentifier(
          Object.assign(Object.assign({}, decl.identifier), {scope: decl.scope})
        )
      )
      .join(', ')}]`
  );
  items.push(
    `reassignments=[${Array.from(scope.reassignments).map(reassign => printIdentifier(reassign))}]`
  );
  if (scope.earlyReturnValue !== null) {
    items.push(
      `earlyReturn={id: ${printIdentifier(scope.earlyReturnValue.value)}, label: ${scope.earlyReturnValue.label}}}`
    );
  }
  return items.join(' ');
}
function writeReactiveBlock(writer, block) {
  writer.writeLine(`${printReactiveScopeSummary(block.scope)} {`);
  writeReactiveInstructions(writer, block.instructions);
  writer.writeLine('}');
}
function writePrunedScope(writer, block) {
  writer.writeLine(`<pruned> ${printReactiveScopeSummary(block.scope)} {`);
  writeReactiveInstructions(writer, block.instructions);
  writer.writeLine('}');
}
function printDependency(dependency) {
  const identifier =
    printIdentifier(dependency.identifier) +
    printType(dependency.identifier.type);
  return `${identifier}${dependency.path.map(token => `${token.optional ? '?.' : '.'}${token.property}`).join('')}`;
}
function writeReactiveInstructions(writer, instructions) {
  writer.indented(() => {
    for (const instr of instructions) {
      writeReactiveInstruction(writer, instr);
    }
  });
}
function writeReactiveInstruction(writer, instr) {
  switch (instr.kind) {
    case 'instruction': {
      const {instruction: instruction} = instr;
      const id = `[${instruction.id}]`;
      if (instruction.lvalue !== null) {
        writer.write(`${id} ${printPlace(instruction.lvalue)} = `);
        writeReactiveValue(writer, instruction.value);
        writer.newline();
      } else {
        writer.write(`${id} `);
        writeReactiveValue(writer, instruction.value);
        writer.newline();
      }
      break;
    }
    case 'scope': {
      writeReactiveBlock(writer, instr);
      break;
    }
    case 'pruned-scope': {
      writePrunedScope(writer, instr);
      break;
    }
    case 'terminal': {
      if (instr.label !== null) {
        writer.write(`bb${instr.label.id}: `);
      }
      writeTerminal(writer, instr.terminal);
      break;
    }
    default: {
      assertExhaustive(instr, `Unexpected terminal kind \`${instr.kind}\``);
    }
  }
}
function writeReactiveValue(writer, value) {
  switch (value.kind) {
    case 'ConditionalExpression': {
      writer.writeLine(`Ternary `);
      writer.indented(() => {
        writeReactiveValue(writer, value.test);
        writer.writeLine(`? `);
        writer.indented(() => {
          writeReactiveValue(writer, value.consequent);
        });
        writer.writeLine(`: `);
        writer.indented(() => {
          writeReactiveValue(writer, value.alternate);
        });
      });
      writer.newline();
      break;
    }
    case 'LogicalExpression': {
      writer.writeLine(`Logical`);
      writer.indented(() => {
        writeReactiveValue(writer, value.left);
        writer.write(`${value.operator} `);
        writeReactiveValue(writer, value.right);
      });
      writer.newline();
      break;
    }
    case 'SequenceExpression': {
      writer.writeLine(`Sequence`);
      writer.indented(() => {
        writer.indented(() => {
          value.instructions.forEach(instr =>
            writeReactiveInstruction(writer, {
              kind: 'instruction',
              instruction: instr,
            })
          );
          writer.write(`[${value.id}] `);
          writeReactiveValue(writer, value.value);
        });
      });
      writer.newline();
      break;
    }
    case 'OptionalExpression': {
      writer.append(`OptionalExpression optional=${value.optional}`);
      writer.newline();
      writer.indented(() => {
        writeReactiveValue(writer, value.value);
      });
      writer.newline();
      break;
    }
    default: {
      const printed = printInstructionValue(value);
      const lines = printed.split('\n');
      if (lines.length === 1) {
        writer.writeLine(printed);
      } else {
        writer.indented(() => {
          for (const line of lines) {
            writer.writeLine(line);
          }
        });
      }
    }
  }
}
function writeTerminal(writer, terminal) {
  switch (terminal.kind) {
    case 'break': {
      const id = terminal.id !== null ? `[${terminal.id}]` : [];
      writer.writeLine(
        `${id} break bb${terminal.target} (${terminal.targetKind})`
      );
      break;
    }
    case 'continue': {
      const id = `[${terminal.id}]`;
      writer.writeLine(
        `${id} continue bb${terminal.target} (${terminal.targetKind})`
      );
      break;
    }
    case 'do-while': {
      writer.writeLine(`[${terminal.id}] do-while {`);
      writeReactiveInstructions(writer, terminal.loop);
      writer.writeLine('} (');
      writer.indented(() => {
        writeReactiveValue(writer, terminal.test);
      });
      writer.writeLine(')');
      break;
    }
    case 'while': {
      writer.writeLine(`[${terminal.id}] while (`);
      writer.indented(() => {
        writeReactiveValue(writer, terminal.test);
      });
      writer.writeLine(') {');
      writeReactiveInstructions(writer, terminal.loop);
      writer.writeLine('}');
      break;
    }
    case 'if': {
      const {
        test: test,
        consequent: consequent,
        alternate: alternate,
      } = terminal;
      writer.writeLine(`[${terminal.id}] if (${printPlace(test)}) {`);
      writeReactiveInstructions(writer, consequent);
      if (alternate !== null) {
        writer.writeLine('} else {');
        writeReactiveInstructions(writer, alternate);
      }
      writer.writeLine('}');
      break;
    }
    case 'switch': {
      writer.writeLine(
        `[${terminal.id}] switch (${printPlace(terminal.test)}) {`
      );
      writer.indented(() => {
        for (const case_ of terminal.cases) {
          let prefix =
            case_.test !== null ? `case ${printPlace(case_.test)}` : 'default';
          writer.writeLine(`${prefix}: {`);
          writer.indented(() => {
            var _a, _b;
            const block = case_.block;
            CompilerError.invariant(block != null, {
              reason: 'Expected case to have a block',
              description: null,
              loc:
                (_b =
                  (_a = case_.test) === null || _a === void 0
                    ? void 0
                    : _a.loc) !== null && _b !== void 0
                  ? _b
                  : null,
              suggestions: null,
            });
            writeReactiveInstructions(writer, block);
          });
          writer.writeLine('}');
        }
      });
      writer.writeLine('}');
      break;
    }
    case 'for': {
      writer.writeLine(`[${terminal.id}] for (`);
      writer.indented(() => {
        writeReactiveValue(writer, terminal.init);
        writer.writeLine(';');
        writeReactiveValue(writer, terminal.test);
        writer.writeLine(';');
        if (terminal.update !== null) {
          writeReactiveValue(writer, terminal.update);
        }
      });
      writer.writeLine(') {');
      writeReactiveInstructions(writer, terminal.loop);
      writer.writeLine('}');
      break;
    }
    case 'for-of': {
      writer.writeLine(`[${terminal.id}] for-of (`);
      writer.indented(() => {
        writeReactiveValue(writer, terminal.init);
        writer.writeLine(';');
        writeReactiveValue(writer, terminal.test);
      });
      writer.writeLine(') {');
      writeReactiveInstructions(writer, terminal.loop);
      writer.writeLine('}');
      break;
    }
    case 'for-in': {
      writer.writeLine(`[${terminal.id}] for-in (`);
      writer.indented(() => {
        writeReactiveValue(writer, terminal.init);
      });
      writer.writeLine(') {');
      writeReactiveInstructions(writer, terminal.loop);
      writer.writeLine('}');
      break;
    }
    case 'throw': {
      writer.writeLine(`[${terminal.id}] throw ${printPlace(terminal.value)}`);
      break;
    }
    case 'return': {
      writer.writeLine(`[${terminal.id}] return ${printPlace(terminal.value)}`);
      break;
    }
    case 'label': {
      writer.writeLine('{');
      writeReactiveInstructions(writer, terminal.block);
      writer.writeLine('}');
      break;
    }
    case 'try': {
      writer.writeLine(`[${terminal.id}] try {`);
      writeReactiveInstructions(writer, terminal.block);
      writer.write(`} catch `);
      if (terminal.handlerBinding !== null) {
        writer.writeLine(`(${printPlace(terminal.handlerBinding)}) {`);
      } else {
        writer.writeLine(`{`);
      }
      writeReactiveInstructions(writer, terminal.handler);
      writer.writeLine('}');
      break;
    }
    default:
      assertExhaustive(terminal, `Unhandled terminal ${terminal}`);
  }
}
class Writer {
  constructor({depth: depth} = {depth: 0}) {
    _Writer_out.set(this, []);
    _Writer_line.set(this, void 0);
    _Writer_depth.set(this, void 0);
    __classPrivateFieldSet(this, _Writer_depth, Math.max(depth, 0), 'f');
    __classPrivateFieldSet(this, _Writer_line, '', 'f');
  }
  complete() {
    const line = __classPrivateFieldGet(this, _Writer_line, 'f').trimEnd();
    if (line.length > 0) {
      __classPrivateFieldGet(this, _Writer_out, 'f').push(line);
    }
    return __classPrivateFieldGet(this, _Writer_out, 'f').join('\n');
  }
  append(s) {
    this.write(s);
  }
  newline() {
    const line = __classPrivateFieldGet(this, _Writer_line, 'f').trimEnd();
    if (line.length > 0) {
      __classPrivateFieldGet(this, _Writer_out, 'f').push(line);
    }
    __classPrivateFieldSet(this, _Writer_line, '', 'f');
  }
  write(s) {
    if (
      __classPrivateFieldGet(this, _Writer_line, 'f').length === 0 &&
      __classPrivateFieldGet(this, _Writer_depth, 'f') > 0
    ) {
      __classPrivateFieldSet(
        this,
        _Writer_line,
        '  '.repeat(__classPrivateFieldGet(this, _Writer_depth, 'f')),
        'f'
      );
    }
    __classPrivateFieldSet(
      this,
      _Writer_line,
      __classPrivateFieldGet(this, _Writer_line, 'f') + s,
      'f'
    );
  }
  writeLine(s) {
    this.write(s);
    this.newline();
  }
  indented(f) {
    var _a, _b;
    __classPrivateFieldSet(
      this,
      _Writer_depth,
      ((_a = __classPrivateFieldGet(this, _Writer_depth, 'f')), _a++, _a),
      'f'
    );
    f();
    __classPrivateFieldSet(
      this,
      _Writer_depth,
      ((_b = __classPrivateFieldGet(this, _Writer_depth, 'f')), _b--, _b),
      'f'
    );
  }
}
(_Writer_out = new WeakMap()),
  (_Writer_line = new WeakMap()),
  (_Writer_depth = new WeakMap());
function printFunction$1(fn) {
  const output = [];
  let definition = '';
  if (fn.id !== null) {
    definition += fn.id;
  }
  if (fn.params.length !== 0) {
    definition +=
      '(' +
      fn.params
        .map(param => {
          if (param.kind === 'Identifier') {
            return printPlace(param);
          } else {
            return `...${printPlace(param.place)}`;
          }
        })
        .join(', ') +
      ')';
  }
  if (definition.length !== 0) {
    output.push(definition);
  }
  output.push(printType(fn.returnType));
  output.push(printHIR(fn.body));
  output.push(...fn.directives);
  return output.join('\n');
}
function printHIR(ir, options = null) {
  var _a;
  let output = [];
  let indent = ' '.repeat(
    (_a = options === null || options === void 0 ? void 0 : options.indent) !==
      null && _a !== void 0
      ? _a
      : 0
  );
  const push = (text, indent = '  ') => {
    output.push(`${indent}${text}`);
  };
  for (const [blockId, block] of ir.blocks) {
    output.push(`bb${blockId} (${block.kind}):`);
    if (block.preds.size > 0) {
      const preds = ['predecessor blocks:'];
      for (const pred of block.preds) {
        preds.push(`bb${pred}`);
      }
      push(preds.join(' '));
    }
    for (const phi of block.phis) {
      push(printPhi(phi));
    }
    for (const instr of block.instructions) {
      push(printInstruction(instr));
    }
    const terminal = printTerminal(block.terminal);
    if (Array.isArray(terminal)) {
      terminal.forEach(line => push(line));
    } else {
      push(terminal);
    }
  }
  return output.map(line => indent + line).join('\n');
}
function printMixedHIR(value) {
  if (!('kind' in value)) {
    return printInstruction(value);
  }
  switch (value.kind) {
    case 'try':
    case 'maybe-throw':
    case 'sequence':
    case 'label':
    case 'optional':
    case 'branch':
    case 'if':
    case 'logical':
    case 'ternary':
    case 'return':
    case 'switch':
    case 'throw':
    case 'while':
    case 'for':
    case 'unreachable':
    case 'unsupported':
    case 'goto':
    case 'do-while':
    case 'for-in':
    case 'for-of':
    case 'scope':
    case 'pruned-scope': {
      const terminal = printTerminal(value);
      if (Array.isArray(terminal)) {
        return terminal.join('; ');
      }
      return terminal;
    }
    default: {
      return printInstructionValue(value);
    }
  }
}
function printInstruction(instr) {
  const id = `[${instr.id}]`;
  const value = printInstructionValue(instr.value);
  if (instr.lvalue !== null) {
    return `${id} ${printPlace(instr.lvalue)} = ${value}`;
  } else {
    return `${id} ${value}`;
  }
}
function printPhi(phi) {
  const items = [];
  items.push(printPlace(phi.place));
  items.push(printMutableRange(phi.place.identifier));
  items.push(printType(phi.place.identifier.type));
  items.push(': phi(');
  const phis = [];
  for (const [blockId, place] of phi.operands) {
    phis.push(`bb${blockId}: ${printPlace(place)}`);
  }
  items.push(phis.join(', '));
  items.push(')');
  return items.join('');
}
function printTerminal(terminal) {
  let value;
  switch (terminal.kind) {
    case 'if': {
      value = `[${terminal.id}] If (${printPlace(terminal.test)}) then:bb${terminal.consequent} else:bb${terminal.alternate}${terminal.fallthrough ? ` fallthrough=bb${terminal.fallthrough}` : ''}`;
      break;
    }
    case 'branch': {
      value = `[${terminal.id}] Branch (${printPlace(terminal.test)}) then:bb${terminal.consequent} else:bb${terminal.alternate} fallthrough:bb${terminal.fallthrough}`;
      break;
    }
    case 'logical': {
      value = `[${terminal.id}] Logical ${terminal.operator} test:bb${terminal.test} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'ternary': {
      value = `[${terminal.id}] Ternary test:bb${terminal.test} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'optional': {
      value = `[${terminal.id}] Optional (optional=${terminal.optional}) test:bb${terminal.test} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'throw': {
      value = `[${terminal.id}] Throw ${printPlace(terminal.value)}`;
      break;
    }
    case 'return': {
      value = `[${terminal.id}] Return${terminal.value != null ? ' ' + printPlace(terminal.value) : ''}`;
      break;
    }
    case 'goto': {
      value = `[${terminal.id}] Goto${terminal.variant === GotoVariant.Continue ? '(Continue)' : ''} bb${terminal.block}`;
      break;
    }
    case 'switch': {
      const output = [];
      output.push(`[${terminal.id}] Switch (${printPlace(terminal.test)})`);
      terminal.cases.forEach(case_ => {
        if (case_.test !== null) {
          output.push(`  Case ${printPlace(case_.test)}: bb${case_.block}`);
        } else {
          output.push(`  Default: bb${case_.block}`);
        }
      });
      if (terminal.fallthrough) {
        output.push(`  Fallthrough: bb${terminal.fallthrough}`);
      }
      value = output;
      break;
    }
    case 'do-while': {
      value = `[${terminal.id}] DoWhile loop=${`bb${terminal.loop}`} test=bb${terminal.test} fallthrough=${`bb${terminal.fallthrough}`}`;
      break;
    }
    case 'while': {
      value = `[${terminal.id}] While test=bb${terminal.test} loop=${terminal.loop !== null ? `bb${terminal.loop}` : ''} fallthrough=${terminal.fallthrough ? `bb${terminal.fallthrough}` : ''}`;
      break;
    }
    case 'for': {
      value = `[${terminal.id}] For init=bb${terminal.init} test=bb${terminal.test} loop=bb${terminal.loop} update=bb${terminal.update} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'for-of': {
      value = `[${terminal.id}] ForOf init=bb${terminal.init} test=bb${terminal.test} loop=bb${terminal.loop} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'for-in': {
      value = `[${terminal.id}] ForIn init=bb${terminal.init} loop=bb${terminal.loop} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'label': {
      value = `[${terminal.id}] Label block=bb${terminal.block} fallthrough=${terminal.fallthrough ? `bb${terminal.fallthrough}` : ''}`;
      break;
    }
    case 'sequence': {
      value = `[${terminal.id}] Sequence block=bb${terminal.block} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'unreachable': {
      value = `[${terminal.id}] Unreachable`;
      break;
    }
    case 'unsupported': {
      value = `[${terminal.id}] Unsupported`;
      break;
    }
    case 'maybe-throw': {
      value = `[${terminal.id}] MaybeThrow continuation=bb${terminal.continuation} handler=bb${terminal.handler}`;
      break;
    }
    case 'scope': {
      value = `[${terminal.id}] Scope ${printReactiveScopeSummary(terminal.scope)} block=bb${terminal.block} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'pruned-scope': {
      value = `[${terminal.id}] <pruned> Scope ${printReactiveScopeSummary(terminal.scope)} block=bb${terminal.block} fallthrough=bb${terminal.fallthrough}`;
      break;
    }
    case 'try': {
      value = `[${terminal.id}] Try block=bb${terminal.block} handler=bb${terminal.handler}${terminal.handlerBinding !== null ? ` handlerBinding=(${printPlace(terminal.handlerBinding)})` : ''} fallthrough=${terminal.fallthrough != null ? `bb${terminal.fallthrough}` : ''}`;
      break;
    }
    default: {
      assertExhaustive(terminal, `Unexpected terminal kind \`${terminal}\``);
    }
  }
  return value;
}
function printHole() {
  return '<hole>';
}
function printObjectPropertyKey(key) {
  switch (key.kind) {
    case 'identifier':
      return key.name;
    case 'string':
      return `"${key.name}"`;
    case 'computed': {
      return `[${printPlace(key.name)}]`;
    }
  }
}
function printInstructionValue(instrValue) {
  var _a, _b, _c, _d;
  let value = '';
  switch (instrValue.kind) {
    case 'ArrayExpression': {
      value = `Array [${instrValue.elements
        .map(element => {
          if (element.kind === 'Identifier') {
            return printPlace(element);
          } else if (element.kind === 'Hole') {
            return printHole();
          } else {
            return `...${printPlace(element.place)}`;
          }
        })
        .join(', ')}]`;
      break;
    }
    case 'ObjectExpression': {
      const properties = [];
      if (instrValue.properties !== null) {
        for (const property of instrValue.properties) {
          if (property.kind === 'ObjectProperty') {
            properties.push(
              `${printObjectPropertyKey(property.key)}: ${printPlace(property.place)}`
            );
          } else {
            properties.push(`...${printPlace(property.place)}`);
          }
        }
      }
      value = `Object { ${properties.join(', ')} }`;
      break;
    }
    case 'UnaryExpression': {
      value = `Unary ${printPlace(instrValue.value)}`;
      break;
    }
    case 'BinaryExpression': {
      value = `Binary ${printPlace(instrValue.left)} ${instrValue.operator} ${printPlace(instrValue.right)}`;
      break;
    }
    case 'NewExpression': {
      value = `New ${printPlace(instrValue.callee)}(${instrValue.args.map(arg => printPattern(arg)).join(', ')})`;
      break;
    }
    case 'CallExpression': {
      value = `Call ${printPlace(instrValue.callee)}(${instrValue.args.map(arg => printPattern(arg)).join(', ')})`;
      break;
    }
    case 'MethodCall': {
      value = `MethodCall ${printPlace(instrValue.receiver)}.${printPlace(instrValue.property)}(${instrValue.args.map(arg => printPattern(arg)).join(', ')})`;
      break;
    }
    case 'JSXText': {
      value = `JSXText ${JSON.stringify(instrValue.value)}`;
      break;
    }
    case 'Primitive': {
      if (instrValue.value === undefined) {
        value = '<undefined>';
      } else {
        value = JSON.stringify(instrValue.value);
      }
      break;
    }
    case 'TypeCastExpression': {
      value = `TypeCast ${printPlace(instrValue.value)}: ${printType(instrValue.type)}`;
      break;
    }
    case 'JsxExpression': {
      const propItems = [];
      for (const attribute of instrValue.props) {
        if (attribute.kind === 'JsxAttribute') {
          propItems.push(
            `${attribute.name}={${attribute.place !== null ? printPlace(attribute.place) : '<empty>'}}`
          );
        } else {
          propItems.push(`...${printPlace(attribute.argument)}`);
        }
      }
      const tag =
        instrValue.tag.kind === 'Identifier'
          ? printPlace(instrValue.tag)
          : instrValue.tag.name;
      const props = propItems.length !== 0 ? ' ' + propItems.join(' ') : '';
      if (instrValue.children !== null) {
        const children = instrValue.children.map(
          child => `{${printPlace(child)}}`
        );
        value = `JSX <${tag}${props}${props.length > 0 ? ' ' : ''}>${children.join('')}</${tag}>`;
      } else {
        value = `JSX <${tag}${props}${props.length > 0 ? ' ' : ''}/>`;
      }
      break;
    }
    case 'JsxFragment': {
      value = `JsxFragment [${instrValue.children.map(child => printPlace(child)).join(', ')}]`;
      break;
    }
    case 'UnsupportedNode': {
      value = `UnsupportedNode(${default_1(instrValue.node).code})`;
      break;
    }
    case 'LoadLocal': {
      value = `LoadLocal ${printPlace(instrValue.place)}`;
      break;
    }
    case 'DeclareLocal': {
      value = `DeclareLocal ${instrValue.lvalue.kind} ${printPlace(instrValue.lvalue.place)}`;
      break;
    }
    case 'DeclareContext': {
      value = `DeclareContext ${instrValue.lvalue.kind} ${printPlace(instrValue.lvalue.place)}`;
      break;
    }
    case 'StoreLocal': {
      value = `StoreLocal ${instrValue.lvalue.kind} ${printPlace(instrValue.lvalue.place)} = ${printPlace(instrValue.value)}`;
      break;
    }
    case 'LoadContext': {
      value = `LoadContext ${printPlace(instrValue.place)}`;
      break;
    }
    case 'StoreContext': {
      value = `StoreContext ${instrValue.lvalue.kind} ${printPlace(instrValue.lvalue.place)} = ${printPlace(instrValue.value)}`;
      break;
    }
    case 'Destructure': {
      value = `Destructure ${instrValue.lvalue.kind} ${printPattern(instrValue.lvalue.pattern)} = ${printPlace(instrValue.value)}`;
      break;
    }
    case 'PropertyLoad': {
      value = `PropertyLoad ${printPlace(instrValue.object)}.${instrValue.property}`;
      break;
    }
    case 'PropertyStore': {
      value = `PropertyStore ${printPlace(instrValue.object)}.${instrValue.property} = ${printPlace(instrValue.value)}`;
      break;
    }
    case 'PropertyDelete': {
      value = `PropertyDelete ${printPlace(instrValue.object)}.${instrValue.property}`;
      break;
    }
    case 'ComputedLoad': {
      value = `ComputedLoad ${printPlace(instrValue.object)}[${printPlace(instrValue.property)}]`;
      break;
    }
    case 'ComputedStore': {
      value = `ComputedStore ${printPlace(instrValue.object)}[${printPlace(instrValue.property)}] = ${printPlace(instrValue.value)}`;
      break;
    }
    case 'ComputedDelete': {
      value = `ComputedDelete ${printPlace(instrValue.object)}[${printPlace(instrValue.property)}]`;
      break;
    }
    case 'ObjectMethod':
    case 'FunctionExpression': {
      const kind =
        instrValue.kind === 'FunctionExpression' ? 'Function' : 'ObjectMethod';
      const name = getFunctionName$1(instrValue, '');
      const fn = printFunction$1(instrValue.loweredFunc.func)
        .split('\n')
        .map(line => `      ${line}`)
        .join('\n');
      const deps = instrValue.loweredFunc.dependencies
        .map(dep => printPlace(dep))
        .join(',');
      const context = instrValue.loweredFunc.func.context
        .map(dep => printPlace(dep))
        .join(',');
      const effects =
        (_b =
          (_a = instrValue.loweredFunc.func.effects) === null || _a === void 0
            ? void 0
            : _a
                .map(effect => {
                  if (effect.kind === 'ContextMutation') {
                    return `ContextMutation places=[${[...effect.places].map(place => printPlace(place)).join(', ')}] effect=${effect.effect}`;
                  } else {
                    return `GlobalMutation`;
                  }
                })
                .join(', ')) !== null && _b !== void 0
          ? _b
          : '';
      const type = printType(instrValue.loweredFunc.func.returnType).trim();
      value = `${kind} ${name} @deps[${deps}] @context[${context}] @effects[${effects}]${type !== '' ? ` return${type}` : ''}:\n${fn}`;
      break;
    }
    case 'TaggedTemplateExpression': {
      value = `${printPlace(instrValue.tag)}\`${instrValue.value.raw}\``;
      break;
    }
    case 'LogicalExpression': {
      value = `Logical ${printInstructionValue(instrValue.left)} ${instrValue.operator} ${printInstructionValue(instrValue.right)}`;
      break;
    }
    case 'SequenceExpression': {
      value = [
        `Sequence`,
        ...instrValue.instructions.map(
          instr => `    ${printInstruction(instr)}`
        ),
        `    ${printInstructionValue(instrValue.value)}`,
      ].join('\n');
      break;
    }
    case 'ConditionalExpression': {
      value = `Ternary ${printInstructionValue(instrValue.test)} ? ${printInstructionValue(instrValue.consequent)} : ${printInstructionValue(instrValue.alternate)}`;
      break;
    }
    case 'TemplateLiteral': {
      value = '`';
      CompilerError.invariant(
        instrValue.subexprs.length === instrValue.quasis.length - 1,
        {
          reason: 'Bad assumption about quasi length.',
          description: null,
          loc: instrValue.loc,
          suggestions: null,
        }
      );
      for (let i = 0; i < instrValue.subexprs.length; i++) {
        value += instrValue.quasis[i].raw;
        value += `\${${printPlace(instrValue.subexprs[i])}}`;
      }
      value += instrValue.quasis.at(-1).raw + '`';
      break;
    }
    case 'LoadGlobal': {
      switch (instrValue.binding.kind) {
        case 'Global': {
          value = `LoadGlobal(global) ${instrValue.binding.name}`;
          break;
        }
        case 'ModuleLocal': {
          value = `LoadGlobal(module) ${instrValue.binding.name}`;
          break;
        }
        case 'ImportDefault': {
          value = `LoadGlobal import ${instrValue.binding.name} from '${instrValue.binding.module}'`;
          break;
        }
        case 'ImportNamespace': {
          value = `LoadGlobal import * as ${instrValue.binding.name} from '${instrValue.binding.module}'`;
          break;
        }
        case 'ImportSpecifier': {
          if (instrValue.binding.imported !== instrValue.binding.name) {
            value = `LoadGlobal import { ${instrValue.binding.imported} as ${instrValue.binding.name} } from '${instrValue.binding.module}'`;
          } else {
            value = `LoadGlobal import { ${instrValue.binding.name} } from '${instrValue.binding.module}'`;
          }
          break;
        }
        default: {
          assertExhaustive(
            instrValue.binding,
            `Unexpected binding kind \`${instrValue.binding.kind}\``
          );
        }
      }
      break;
    }
    case 'StoreGlobal': {
      value = `StoreGlobal ${instrValue.name} = ${printPlace(instrValue.value)}`;
      break;
    }
    case 'OptionalExpression': {
      value = `OptionalExpression ${printInstructionValue(instrValue.value)}`;
      break;
    }
    case 'RegExpLiteral': {
      value = `RegExp /${instrValue.pattern}/${instrValue.flags}`;
      break;
    }
    case 'MetaProperty': {
      value = `MetaProperty ${instrValue.meta}.${instrValue.property}`;
      break;
    }
    case 'Await': {
      value = `Await ${printPlace(instrValue.value)}`;
      break;
    }
    case 'GetIterator': {
      value = `GetIterator collection=${printPlace(instrValue.collection)}`;
      break;
    }
    case 'IteratorNext': {
      value = `IteratorNext iterator=${printPlace(instrValue.iterator)} collection=${printPlace(instrValue.collection)}`;
      break;
    }
    case 'NextPropertyOf': {
      value = `NextPropertyOf ${printPlace(instrValue.value)}`;
      break;
    }
    case 'Debugger': {
      value = `Debugger`;
      break;
    }
    case 'PostfixUpdate': {
      value = `PostfixUpdate ${printPlace(instrValue.lvalue)} = ${printPlace(instrValue.value)} ${instrValue.operation}`;
      break;
    }
    case 'PrefixUpdate': {
      value = `PrefixUpdate ${printPlace(instrValue.lvalue)} = ${instrValue.operation} ${printPlace(instrValue.value)}`;
      break;
    }
    case 'StartMemoize': {
      value = `StartMemoize deps=${(_d = (_c = instrValue.deps) === null || _c === void 0 ? void 0 : _c.map(dep => printManualMemoDependency(dep))) !== null && _d !== void 0 ? _d : '(none)'}`;
      break;
    }
    case 'FinishMemoize': {
      value = `FinishMemoize decl=${printPlace(instrValue.decl)}`;
      break;
    }
    case 'ReactiveFunctionValue': {
      value = `FunctionValue ${printReactiveFunction(instrValue.fn)}`;
      break;
    }
    default: {
      assertExhaustive(
        instrValue,
        `Unexpected instruction kind '${instrValue.kind}'`
      );
    }
  }
  return value;
}
function isMutable$1(range) {
  return range.end > range.start + 1;
}
function printMutableRange(identifier) {
  var _b, _c;
  const range =
    (_c =
      (_b = identifier.scope) === null || _b === void 0 ? void 0 : _b.range) !==
      null && _c !== void 0
      ? _c
      : identifier.mutableRange;
  return isMutable$1(range) ? `[${range.start}:${range.end}]` : '';
}
function printPattern(pattern) {
  switch (pattern.kind) {
    case 'ArrayPattern': {
      return (
        '[ ' +
        pattern.items
          .map(item => {
            if (item.kind === 'Hole') {
              return '<hole>';
            }
            return printPattern(item);
          })
          .join(', ') +
        ' ]'
      );
    }
    case 'ObjectPattern': {
      return (
        '{ ' +
        pattern.properties
          .map(item => {
            switch (item.kind) {
              case 'ObjectProperty': {
                return `${printObjectPropertyKey(item.key)}: ${printPattern(item.place)}`;
              }
              case 'Spread': {
                return printPattern(item);
              }
              default: {
                assertExhaustive(item, 'Unexpected object property kind');
              }
            }
          })
          .join(', ') +
        ' }'
      );
    }
    case 'Spread': {
      return `...${printPlace(pattern.place)}`;
    }
    case 'Identifier': {
      return printPlace(pattern);
    }
    default: {
      assertExhaustive(pattern, `Unexpected pattern kind \`${pattern.kind}\``);
    }
  }
}
function printPlace(place) {
  const items = [
    place.effect,
    ' ',
    printIdentifier(place.identifier),
    printMutableRange(place.identifier),
    printType(place.identifier.type),
    place.reactive ? '{reactive}' : null,
  ];
  return items.filter(x => x != null).join('');
}
function printIdentifier(id) {
  return `${printName(id.name)}$${id.id}${printScope(id.scope)}`;
}
function printName(name) {
  if (name === null) {
    return '';
  }
  return name.value;
}
function printScope(scope) {
  return `${scope !== null ? `_@${scope.id}` : ''}`;
}
function printManualMemoDependency(val, nameOnly) {
  var _a;
  let rootStr;
  if (val.root.kind === 'Global') {
    rootStr = val.root.identifierName;
  } else {
    CompilerError.invariant(
      ((_a = val.root.value.identifier.name) === null || _a === void 0
        ? void 0
        : _a.kind) === 'named',
      {
        reason: 'DepsValidation: expected named local variable in depslist',
        suggestions: null,
        loc: val.root.value.loc,
      }
    );
    rootStr = printIdentifier(val.root.value.identifier);
  }
  return `${rootStr}${val.path.map(v => `${v.optional ? '?.' : '.'}${v.property}`).join('')}`;
}
function printType(type) {
  if (type.kind === 'Type') return '';
  if (type.kind === 'Object' && type.shapeId != null) {
    return `:T${type.kind}<${type.shapeId}>`;
  } else if (type.kind === 'Function' && type.shapeId != null) {
    return `:T${type.kind}<${type.shapeId}>`;
  } else {
    return `:T${type.kind}`;
  }
}
function printSourceLocation(loc) {
  if (typeof loc === 'symbol') {
    return 'generated';
  } else {
    return `${loc.start.line}:${loc.start.column}:${loc.end.line}:${loc.end.column}`;
  }
}
function getFunctionName$1(instrValue, defaultValue) {
  var _a;
  switch (instrValue.kind) {
    case 'FunctionExpression':
      return (_a = instrValue.name) !== null && _a !== void 0
        ? _a
        : defaultValue;
    case 'ObjectMethod':
      return defaultValue;
  }
}
var _ScopeBlockTraversal_activeScopes;
function* eachInstructionLValue(instr) {
  if (instr.lvalue !== null) {
    yield instr.lvalue;
  }
  yield* eachInstructionValueLValue(instr.value);
}
function* eachInstructionValueLValue(value) {
  switch (value.kind) {
    case 'DeclareContext':
    case 'StoreContext':
    case 'DeclareLocal':
    case 'StoreLocal': {
      yield value.lvalue.place;
      break;
    }
    case 'Destructure': {
      yield* eachPatternOperand(value.lvalue.pattern);
      break;
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate': {
      yield value.lvalue;
      break;
    }
  }
}
function* eachInstructionOperand(instr) {
  yield* eachInstructionValueOperand(instr.value);
}
function* eachInstructionValueOperand(instrValue) {
  switch (instrValue.kind) {
    case 'NewExpression':
    case 'CallExpression': {
      yield instrValue.callee;
      yield* eachCallArgument(instrValue.args);
      break;
    }
    case 'BinaryExpression': {
      yield instrValue.left;
      yield instrValue.right;
      break;
    }
    case 'MethodCall': {
      yield instrValue.receiver;
      yield instrValue.property;
      yield* eachCallArgument(instrValue.args);
      break;
    }
    case 'DeclareContext':
    case 'DeclareLocal': {
      break;
    }
    case 'LoadLocal':
    case 'LoadContext': {
      yield instrValue.place;
      break;
    }
    case 'StoreLocal': {
      yield instrValue.value;
      break;
    }
    case 'StoreContext': {
      yield instrValue.lvalue.place;
      yield instrValue.value;
      break;
    }
    case 'StoreGlobal': {
      yield instrValue.value;
      break;
    }
    case 'Destructure': {
      yield instrValue.value;
      break;
    }
    case 'PropertyLoad': {
      yield instrValue.object;
      break;
    }
    case 'PropertyDelete': {
      yield instrValue.object;
      break;
    }
    case 'PropertyStore': {
      yield instrValue.object;
      yield instrValue.value;
      break;
    }
    case 'ComputedLoad': {
      yield instrValue.object;
      yield instrValue.property;
      break;
    }
    case 'ComputedDelete': {
      yield instrValue.object;
      yield instrValue.property;
      break;
    }
    case 'ComputedStore': {
      yield instrValue.object;
      yield instrValue.property;
      yield instrValue.value;
      break;
    }
    case 'UnaryExpression': {
      yield instrValue.value;
      break;
    }
    case 'JsxExpression': {
      if (instrValue.tag.kind === 'Identifier') {
        yield instrValue.tag;
      }
      for (const attribute of instrValue.props) {
        switch (attribute.kind) {
          case 'JsxAttribute': {
            yield attribute.place;
            break;
          }
          case 'JsxSpreadAttribute': {
            yield attribute.argument;
            break;
          }
          default: {
            assertExhaustive(
              attribute,
              `Unexpected attribute kind \`${attribute.kind}\``
            );
          }
        }
      }
      if (instrValue.children) {
        yield* instrValue.children;
      }
      break;
    }
    case 'JsxFragment': {
      yield* instrValue.children;
      break;
    }
    case 'ObjectExpression': {
      for (const property of instrValue.properties) {
        if (
          property.kind === 'ObjectProperty' &&
          property.key.kind === 'computed'
        ) {
          yield property.key.name;
        }
        yield property.place;
      }
      break;
    }
    case 'ArrayExpression': {
      for (const element of instrValue.elements) {
        if (element.kind === 'Identifier') {
          yield element;
        } else if (element.kind === 'Spread') {
          yield element.place;
        }
      }
      break;
    }
    case 'ObjectMethod':
    case 'FunctionExpression': {
      yield* instrValue.loweredFunc.dependencies;
      break;
    }
    case 'TaggedTemplateExpression': {
      yield instrValue.tag;
      break;
    }
    case 'TypeCastExpression': {
      yield instrValue.value;
      break;
    }
    case 'TemplateLiteral': {
      yield* instrValue.subexprs;
      break;
    }
    case 'Await': {
      yield instrValue.value;
      break;
    }
    case 'GetIterator': {
      yield instrValue.collection;
      break;
    }
    case 'IteratorNext': {
      yield instrValue.iterator;
      yield instrValue.collection;
      break;
    }
    case 'NextPropertyOf': {
      yield instrValue.value;
      break;
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate': {
      yield instrValue.value;
      break;
    }
    case 'StartMemoize': {
      if (instrValue.deps != null) {
        for (const dep of instrValue.deps) {
          if (dep.root.kind === 'NamedLocal') {
            yield dep.root.value;
          }
        }
      }
      break;
    }
    case 'FinishMemoize': {
      yield instrValue.decl;
      break;
    }
    case 'Debugger':
    case 'RegExpLiteral':
    case 'MetaProperty':
    case 'LoadGlobal':
    case 'UnsupportedNode':
    case 'Primitive':
    case 'JSXText': {
      break;
    }
    default: {
      assertExhaustive(
        instrValue,
        `Unexpected instruction kind \`${instrValue.kind}\``
      );
    }
  }
}
function* eachCallArgument(args) {
  for (const arg of args) {
    if (arg.kind === 'Identifier') {
      yield arg;
    } else {
      yield arg.place;
    }
  }
}
function doesPatternContainSpreadElement(pattern) {
  switch (pattern.kind) {
    case 'ArrayPattern': {
      for (const item of pattern.items) {
        if (item.kind === 'Spread') {
          return true;
        }
      }
      break;
    }
    case 'ObjectPattern': {
      for (const property of pattern.properties) {
        if (property.kind === 'Spread') {
          return true;
        }
      }
      break;
    }
    default: {
      assertExhaustive(pattern, `Unexpected pattern kind \`${pattern.kind}\``);
    }
  }
  return false;
}
function* eachPatternOperand(pattern) {
  switch (pattern.kind) {
    case 'ArrayPattern': {
      for (const item of pattern.items) {
        if (item.kind === 'Identifier') {
          yield item;
        } else if (item.kind === 'Spread') {
          yield item.place;
        } else if (item.kind === 'Hole') {
          continue;
        } else {
          assertExhaustive(item, `Unexpected item kind \`${item.kind}\``);
        }
      }
      break;
    }
    case 'ObjectPattern': {
      for (const property of pattern.properties) {
        if (property.kind === 'ObjectProperty') {
          yield property.place;
        } else if (property.kind === 'Spread') {
          yield property.place;
        } else {
          assertExhaustive(
            property,
            `Unexpected item kind \`${property.kind}\``
          );
        }
      }
      break;
    }
    default: {
      assertExhaustive(pattern, `Unexpected pattern kind \`${pattern.kind}\``);
    }
  }
}
function mapInstructionLValues(instr, fn) {
  switch (instr.value.kind) {
    case 'DeclareLocal':
    case 'StoreLocal': {
      const lvalue = instr.value.lvalue;
      lvalue.place = fn(lvalue.place);
      break;
    }
    case 'Destructure': {
      mapPatternOperands(instr.value.lvalue.pattern, fn);
      break;
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate': {
      instr.value.lvalue = fn(instr.value.lvalue);
      break;
    }
  }
  if (instr.lvalue !== null) {
    instr.lvalue = fn(instr.lvalue);
  }
}
function mapInstructionOperands(instr, fn) {
  mapInstructionValueOperands(instr.value, fn);
}
function mapInstructionValueOperands(instrValue, fn) {
  switch (instrValue.kind) {
    case 'BinaryExpression': {
      instrValue.left = fn(instrValue.left);
      instrValue.right = fn(instrValue.right);
      break;
    }
    case 'PropertyLoad': {
      instrValue.object = fn(instrValue.object);
      break;
    }
    case 'PropertyDelete': {
      instrValue.object = fn(instrValue.object);
      break;
    }
    case 'PropertyStore': {
      instrValue.object = fn(instrValue.object);
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'ComputedLoad': {
      instrValue.object = fn(instrValue.object);
      instrValue.property = fn(instrValue.property);
      break;
    }
    case 'ComputedDelete': {
      instrValue.object = fn(instrValue.object);
      instrValue.property = fn(instrValue.property);
      break;
    }
    case 'ComputedStore': {
      instrValue.object = fn(instrValue.object);
      instrValue.property = fn(instrValue.property);
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'DeclareContext':
    case 'DeclareLocal': {
      break;
    }
    case 'LoadLocal':
    case 'LoadContext': {
      instrValue.place = fn(instrValue.place);
      break;
    }
    case 'StoreLocal': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'StoreContext': {
      instrValue.lvalue.place = fn(instrValue.lvalue.place);
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'StoreGlobal': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'Destructure': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'NewExpression':
    case 'CallExpression': {
      instrValue.callee = fn(instrValue.callee);
      instrValue.args = mapCallArguments(instrValue.args, fn);
      break;
    }
    case 'MethodCall': {
      instrValue.receiver = fn(instrValue.receiver);
      instrValue.property = fn(instrValue.property);
      instrValue.args = mapCallArguments(instrValue.args, fn);
      break;
    }
    case 'UnaryExpression': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'JsxExpression': {
      if (instrValue.tag.kind === 'Identifier') {
        instrValue.tag = fn(instrValue.tag);
      }
      for (const attribute of instrValue.props) {
        switch (attribute.kind) {
          case 'JsxAttribute': {
            attribute.place = fn(attribute.place);
            break;
          }
          case 'JsxSpreadAttribute': {
            attribute.argument = fn(attribute.argument);
            break;
          }
          default: {
            assertExhaustive(
              attribute,
              `Unexpected attribute kind \`${attribute.kind}\``
            );
          }
        }
      }
      if (instrValue.children) {
        instrValue.children = instrValue.children.map(p => fn(p));
      }
      break;
    }
    case 'ObjectExpression': {
      for (const property of instrValue.properties) {
        if (
          property.kind === 'ObjectProperty' &&
          property.key.kind === 'computed'
        ) {
          property.key.name = fn(property.key.name);
        }
        property.place = fn(property.place);
      }
      break;
    }
    case 'ArrayExpression': {
      instrValue.elements = instrValue.elements.map(element => {
        if (element.kind === 'Identifier') {
          return fn(element);
        } else if (element.kind === 'Spread') {
          element.place = fn(element.place);
          return element;
        } else {
          return element;
        }
      });
      break;
    }
    case 'JsxFragment': {
      instrValue.children = instrValue.children.map(e => fn(e));
      break;
    }
    case 'ObjectMethod':
    case 'FunctionExpression': {
      instrValue.loweredFunc.dependencies =
        instrValue.loweredFunc.dependencies.map(d => fn(d));
      break;
    }
    case 'TaggedTemplateExpression': {
      instrValue.tag = fn(instrValue.tag);
      break;
    }
    case 'TypeCastExpression': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'TemplateLiteral': {
      instrValue.subexprs = instrValue.subexprs.map(fn);
      break;
    }
    case 'Await': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'GetIterator': {
      instrValue.collection = fn(instrValue.collection);
      break;
    }
    case 'IteratorNext': {
      instrValue.iterator = fn(instrValue.iterator);
      instrValue.collection = fn(instrValue.collection);
      break;
    }
    case 'NextPropertyOf': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate': {
      instrValue.value = fn(instrValue.value);
      break;
    }
    case 'StartMemoize': {
      if (instrValue.deps != null) {
        for (const dep of instrValue.deps) {
          if (dep.root.kind === 'NamedLocal') {
            dep.root.value = fn(dep.root.value);
          }
        }
      }
      break;
    }
    case 'FinishMemoize': {
      instrValue.decl = fn(instrValue.decl);
      break;
    }
    case 'Debugger':
    case 'RegExpLiteral':
    case 'MetaProperty':
    case 'LoadGlobal':
    case 'UnsupportedNode':
    case 'Primitive':
    case 'JSXText': {
      break;
    }
    default: {
      assertExhaustive(instrValue, 'Unexpected instruction kind');
    }
  }
}
function mapCallArguments(args, fn) {
  return args.map(arg => {
    if (arg.kind === 'Identifier') {
      return fn(arg);
    } else {
      arg.place = fn(arg.place);
      return arg;
    }
  });
}
function mapPatternOperands(pattern, fn) {
  switch (pattern.kind) {
    case 'ArrayPattern': {
      pattern.items = pattern.items.map(item => {
        if (item.kind === 'Identifier') {
          return fn(item);
        } else if (item.kind === 'Spread') {
          item.place = fn(item.place);
          return item;
        } else {
          return item;
        }
      });
      break;
    }
    case 'ObjectPattern': {
      for (const property of pattern.properties) {
        property.place = fn(property.place);
      }
      break;
    }
    default: {
      assertExhaustive(pattern, `Unexpected pattern kind \`${pattern.kind}\``);
    }
  }
}
function mapTerminalSuccessors(terminal, fn) {
  switch (terminal.kind) {
    case 'goto': {
      const target = fn(terminal.block);
      return {
        kind: 'goto',
        block: target,
        variant: terminal.variant,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'if': {
      const consequent = fn(terminal.consequent);
      const alternate = fn(terminal.alternate);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'if',
        test: terminal.test,
        consequent: consequent,
        alternate: alternate,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'branch': {
      const consequent = fn(terminal.consequent);
      const alternate = fn(terminal.alternate);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'branch',
        test: terminal.test,
        consequent: consequent,
        alternate: alternate,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'switch': {
      const cases = terminal.cases.map(case_ => {
        const target = fn(case_.block);
        return {test: case_.test, block: target};
      });
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'switch',
        test: terminal.test,
        cases: cases,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'logical': {
      const test = fn(terminal.test);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'logical',
        test: test,
        fallthrough: fallthrough,
        operator: terminal.operator,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'ternary': {
      const test = fn(terminal.test);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'ternary',
        test: test,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'optional': {
      const test = fn(terminal.test);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'optional',
        optional: terminal.optional,
        test: test,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'return': {
      return {
        kind: 'return',
        loc: terminal.loc,
        value: terminal.value,
        id: makeInstructionId(0),
      };
    }
    case 'throw': {
      return terminal;
    }
    case 'do-while': {
      const loop = fn(terminal.loop);
      const test = fn(terminal.test);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'do-while',
        loc: terminal.loc,
        test: test,
        loop: loop,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
      };
    }
    case 'while': {
      const test = fn(terminal.test);
      const loop = fn(terminal.loop);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'while',
        loc: terminal.loc,
        test: test,
        loop: loop,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
      };
    }
    case 'for': {
      const init = fn(terminal.init);
      const test = fn(terminal.test);
      const update = terminal.update !== null ? fn(terminal.update) : null;
      const loop = fn(terminal.loop);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'for',
        loc: terminal.loc,
        init: init,
        test: test,
        update: update,
        loop: loop,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
      };
    }
    case 'for-of': {
      const init = fn(terminal.init);
      const loop = fn(terminal.loop);
      const test = fn(terminal.test);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'for-of',
        loc: terminal.loc,
        init: init,
        test: test,
        loop: loop,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
      };
    }
    case 'for-in': {
      const init = fn(terminal.init);
      const loop = fn(terminal.loop);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'for-in',
        loc: terminal.loc,
        init: init,
        loop: loop,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
      };
    }
    case 'label': {
      const block = fn(terminal.block);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'label',
        block: block,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'sequence': {
      const block = fn(terminal.block);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'sequence',
        block: block,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'maybe-throw': {
      const continuation = fn(terminal.continuation);
      const handler = fn(terminal.handler);
      return {
        kind: 'maybe-throw',
        continuation: continuation,
        handler: handler,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'try': {
      const block = fn(terminal.block);
      const handler = fn(terminal.handler);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: 'try',
        block: block,
        handlerBinding: terminal.handlerBinding,
        handler: handler,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'scope':
    case 'pruned-scope': {
      const block = fn(terminal.block);
      const fallthrough = fn(terminal.fallthrough);
      return {
        kind: terminal.kind,
        scope: terminal.scope,
        block: block,
        fallthrough: fallthrough,
        id: makeInstructionId(0),
        loc: terminal.loc,
      };
    }
    case 'unreachable':
    case 'unsupported': {
      return terminal;
    }
    default: {
      assertExhaustive(
        terminal,
        `Unexpected terminal kind \`${terminal.kind}\``
      );
    }
  }
}
function terminalHasFallthrough(terminal) {
  switch (terminal.kind) {
    case 'maybe-throw':
    case 'goto':
    case 'return':
    case 'throw':
    case 'unreachable':
    case 'unsupported': {
      terminal.fallthrough;
      return false;
    }
    case 'branch':
    case 'try':
    case 'do-while':
    case 'for-of':
    case 'for-in':
    case 'for':
    case 'if':
    case 'label':
    case 'logical':
    case 'optional':
    case 'sequence':
    case 'switch':
    case 'ternary':
    case 'while':
    case 'scope':
    case 'pruned-scope': {
      terminal.fallthrough;
      return true;
    }
    default: {
      assertExhaustive(
        terminal,
        `Unexpected terminal kind \`${terminal.kind}\``
      );
    }
  }
}
function terminalFallthrough(terminal) {
  if (terminalHasFallthrough(terminal)) {
    return terminal.fallthrough;
  } else {
    return null;
  }
}
function* eachTerminalSuccessor(terminal) {
  switch (terminal.kind) {
    case 'goto': {
      yield terminal.block;
      break;
    }
    case 'if': {
      yield terminal.consequent;
      yield terminal.alternate;
      break;
    }
    case 'branch': {
      yield terminal.consequent;
      yield terminal.alternate;
      break;
    }
    case 'switch': {
      for (const case_ of terminal.cases) {
        yield case_.block;
      }
      break;
    }
    case 'optional':
    case 'ternary':
    case 'logical': {
      yield terminal.test;
      break;
    }
    case 'return': {
      break;
    }
    case 'throw': {
      break;
    }
    case 'do-while': {
      yield terminal.loop;
      break;
    }
    case 'while': {
      yield terminal.test;
      break;
    }
    case 'for': {
      yield terminal.init;
      break;
    }
    case 'for-of': {
      yield terminal.init;
      break;
    }
    case 'for-in': {
      yield terminal.init;
      break;
    }
    case 'label': {
      yield terminal.block;
      break;
    }
    case 'sequence': {
      yield terminal.block;
      break;
    }
    case 'maybe-throw': {
      yield terminal.continuation;
      yield terminal.handler;
      break;
    }
    case 'try': {
      yield terminal.block;
      break;
    }
    case 'scope':
    case 'pruned-scope': {
      yield terminal.block;
      break;
    }
    case 'unreachable':
    case 'unsupported':
      break;
    default: {
      assertExhaustive(
        terminal,
        `Unexpected terminal kind \`${terminal.kind}\``
      );
    }
  }
}
function mapTerminalOperands(terminal, fn) {
  switch (terminal.kind) {
    case 'if': {
      terminal.test = fn(terminal.test);
      break;
    }
    case 'branch': {
      terminal.test = fn(terminal.test);
      break;
    }
    case 'switch': {
      terminal.test = fn(terminal.test);
      for (const case_ of terminal.cases) {
        if (case_.test === null) {
          continue;
        }
        case_.test = fn(case_.test);
      }
      break;
    }
    case 'return':
    case 'throw': {
      terminal.value = fn(terminal.value);
      break;
    }
    case 'try': {
      if (terminal.handlerBinding !== null) {
        terminal.handlerBinding = fn(terminal.handlerBinding);
      } else {
        terminal.handlerBinding = null;
      }
      break;
    }
    case 'maybe-throw':
    case 'sequence':
    case 'label':
    case 'optional':
    case 'ternary':
    case 'logical':
    case 'do-while':
    case 'while':
    case 'for':
    case 'for-of':
    case 'for-in':
    case 'goto':
    case 'unreachable':
    case 'unsupported':
    case 'scope':
    case 'pruned-scope': {
      break;
    }
    default: {
      assertExhaustive(
        terminal,
        `Unexpected terminal kind \`${terminal.kind}\``
      );
    }
  }
}
function* eachTerminalOperand(terminal) {
  switch (terminal.kind) {
    case 'if': {
      yield terminal.test;
      break;
    }
    case 'branch': {
      yield terminal.test;
      break;
    }
    case 'switch': {
      yield terminal.test;
      for (const case_ of terminal.cases) {
        if (case_.test === null) {
          continue;
        }
        yield case_.test;
      }
      break;
    }
    case 'return':
    case 'throw': {
      yield terminal.value;
      break;
    }
    case 'try': {
      if (terminal.handlerBinding !== null) {
        yield terminal.handlerBinding;
      }
      break;
    }
    case 'maybe-throw':
    case 'sequence':
    case 'label':
    case 'optional':
    case 'ternary':
    case 'logical':
    case 'do-while':
    case 'while':
    case 'for':
    case 'for-of':
    case 'for-in':
    case 'goto':
    case 'unreachable':
    case 'unsupported':
    case 'scope':
    case 'pruned-scope': {
      break;
    }
    default: {
      assertExhaustive(
        terminal,
        `Unexpected terminal kind \`${terminal.kind}\``
      );
    }
  }
}
class ScopeBlockTraversal {
  constructor() {
    _ScopeBlockTraversal_activeScopes.set(this, []);
    this.blockInfos = new Map();
  }
  recordScopes(block) {
    var _a, _b;
    const blockInfo = this.blockInfos.get(block.id);
    if (
      (blockInfo === null || blockInfo === void 0 ? void 0 : blockInfo.kind) ===
      'begin'
    ) {
      __classPrivateFieldGet(this, _ScopeBlockTraversal_activeScopes, 'f').push(
        blockInfo.scope.id
      );
    } else if (
      (blockInfo === null || blockInfo === void 0 ? void 0 : blockInfo.kind) ===
      'end'
    ) {
      const top = __classPrivateFieldGet(
        this,
        _ScopeBlockTraversal_activeScopes,
        'f'
      ).at(-1);
      CompilerError.invariant(blockInfo.scope.id === top, {
        reason:
          'Expected traversed block fallthrough to match top-most active scope',
        loc:
          (_b =
            (_a = block.instructions[0]) === null || _a === void 0
              ? void 0
              : _a.loc) !== null && _b !== void 0
            ? _b
            : block.terminal.id,
      });
      __classPrivateFieldGet(
        this,
        _ScopeBlockTraversal_activeScopes,
        'f'
      ).pop();
    }
    if (
      block.terminal.kind === 'scope' ||
      block.terminal.kind === 'pruned-scope'
    ) {
      CompilerError.invariant(
        !this.blockInfos.has(block.terminal.block) &&
          !this.blockInfos.has(block.terminal.fallthrough),
        {
          reason: 'Expected unique scope blocks and fallthroughs',
          loc: block.terminal.loc,
        }
      );
      this.blockInfos.set(block.terminal.block, {
        kind: 'begin',
        scope: block.terminal.scope,
        pruned: block.terminal.kind === 'pruned-scope',
        fallthrough: block.terminal.fallthrough,
      });
      this.blockInfos.set(block.terminal.fallthrough, {
        kind: 'end',
        scope: block.terminal.scope,
        pruned: block.terminal.kind === 'pruned-scope',
      });
    }
  }
  isScopeActive(scopeId) {
    return (
      __classPrivateFieldGet(
        this,
        _ScopeBlockTraversal_activeScopes,
        'f'
      ).indexOf(scopeId) !== -1
    );
  }
  get currentScope() {
    var _a;
    return (_a = __classPrivateFieldGet(
      this,
      _ScopeBlockTraversal_activeScopes,
      'f'
    ).at(-1)) !== null && _a !== void 0
      ? _a
      : null;
  }
}
_ScopeBlockTraversal_activeScopes = new WeakMap();
function assertConsistentIdentifiers(fn) {
  const identifiers = new Map();
  const assignments = new Set();
  for (const [, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      validate(identifiers, phi.place.identifier);
      for (const [, operand] of phi.operands) {
        validate(identifiers, operand.identifier);
      }
    }
    for (const instr of block.instructions) {
      CompilerError.invariant(instr.lvalue.identifier.name === null, {
        reason: `Expected all lvalues to be temporaries`,
        description: `Found named lvalue \`${instr.lvalue.identifier.name}\``,
        loc: instr.lvalue.loc,
        suggestions: null,
      });
      CompilerError.invariant(!assignments.has(instr.lvalue.identifier.id), {
        reason: `Expected lvalues to be assigned exactly once`,
        description: `Found duplicate assignment of '${printPlace(instr.lvalue)}'`,
        loc: instr.lvalue.loc,
        suggestions: null,
      });
      assignments.add(instr.lvalue.identifier.id);
      for (const operand of eachInstructionLValue(instr)) {
        validate(identifiers, operand.identifier, operand.loc);
      }
      for (const operand of eachInstructionValueOperand(instr.value)) {
        validate(identifiers, operand.identifier, operand.loc);
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      validate(identifiers, operand.identifier, operand.loc);
    }
  }
}
function validate(identifiers, identifier, loc = null) {
  const previous = identifiers.get(identifier.id);
  if (previous === undefined) {
    identifiers.set(identifier.id, identifier);
  } else {
    CompilerError.invariant(identifier === previous, {
      reason: `Duplicate identifier object`,
      description: `Found duplicate identifier object for id ${identifier.id}`,
      loc: loc !== null && loc !== void 0 ? loc : GeneratedSource,
      suggestions: null,
    });
  }
}
function assertTerminalSuccessorsExist(fn) {
  for (const [, block] of fn.body.blocks) {
    mapTerminalSuccessors(block.terminal, successor => {
      var _a;
      CompilerError.invariant(fn.body.blocks.has(successor), {
        reason: `Terminal successor references unknown block`,
        description: `Block bb${successor} does not exist for terminal '${printTerminal(block.terminal)}'`,
        loc:
          (_a = block.terminal.loc) !== null && _a !== void 0
            ? _a
            : GeneratedSource,
        suggestions: null,
      });
      return successor;
    });
  }
}
function assertTerminalPredsExist(fn) {
  for (const [, block] of fn.body.blocks) {
    for (const pred of block.preds) {
      const predBlock = fn.body.blocks.get(pred);
      CompilerError.invariant(predBlock != null, {
        reason: 'Expected predecessor block to exist',
        description: `Block ${block.id} references non-existent ${pred}`,
        loc: GeneratedSource,
      });
      CompilerError.invariant(
        [...eachTerminalSuccessor(predBlock.terminal)].includes(block.id),
        {
          reason: 'Terminal successor does not reference correct predecessor',
          description: `Block bb${block.id} has bb${predBlock.id} as a predecessor, but bb${predBlock.id}'s successors do not include bb${block.id}`,
          loc: GeneratedSource,
        }
      );
    }
  }
}
function getScopes(fn) {
  const scopes = new Set();
  function visitPlace(place) {
    const scope = place.identifier.scope;
    if (scope != null) {
      if (scope.range.start !== scope.range.end) {
        scopes.add(scope);
      }
    }
  }
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      for (const operand of eachInstructionLValue(instr)) {
        visitPlace(operand);
      }
      for (const operand of eachInstructionOperand(instr)) {
        visitPlace(operand);
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      visitPlace(operand);
    }
  }
  return scopes;
}
function rangePreOrderComparator(a, b) {
  const startDiff = a.start - b.start;
  if (startDiff !== 0) return startDiff;
  return b.end - a.end;
}
function recursivelyTraverseItems(items, getRange, context, enter, exit) {
  items.sort((a, b) => rangePreOrderComparator(getRange(a), getRange(b)));
  let activeItems = [];
  const ranges = items.map(getRange);
  for (let i = 0; i < items.length; i++) {
    const curr = items[i];
    const currRange = ranges[i];
    for (let i = activeItems.length - 1; i >= 0; i--) {
      const maybeParent = activeItems[i];
      const maybeParentRange = getRange(maybeParent);
      const disjoint = currRange.start >= maybeParentRange.end;
      const nested = currRange.end <= maybeParentRange.end;
      CompilerError.invariant(disjoint || nested, {
        reason: 'Invalid nesting in program blocks or scopes',
        description: `Items overlap but are not nested: ${maybeParentRange.start}:${maybeParentRange.end}(${currRange.start}:${currRange.end})`,
        loc: GeneratedSource,
      });
      if (disjoint) {
        exit(maybeParent, context);
        activeItems.length = i;
      } else {
        break;
      }
    }
    enter(curr, context);
    activeItems.push(curr);
  }
  let curr = activeItems.pop();
  while (curr != null) {
    exit(curr, context);
    curr = activeItems.pop();
  }
}
const no_op = () => {};
function assertValidBlockNesting(fn) {
  var _a, _b;
  const scopes = getScopes(fn);
  const blocks = [...scopes].map(scope =>
    Object.assign({kind: 'Scope', id: scope.id}, scope.range)
  );
  for (const [, block] of fn.body.blocks) {
    const fallthroughId = terminalFallthrough(block.terminal);
    if (fallthroughId != null) {
      const fallthrough = fn.body.blocks.get(fallthroughId);
      const end =
        (_b =
          (_a = fallthrough.instructions[0]) === null || _a === void 0
            ? void 0
            : _a.id) !== null && _b !== void 0
          ? _b
          : fallthrough.terminal.id;
      blocks.push({
        kind: 'ProgramBlockSubtree',
        id: block.id,
        start: block.terminal.id,
        end: end,
      });
    }
  }
  recursivelyTraverseItems(blocks, block => block, null, no_op, no_op);
}
function assertValidMutableRanges(fn) {
  for (const [, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      visitIdentifier(phi.place.identifier);
      for (const [, operand] of phi.operands) {
        visitIdentifier(operand.identifier);
      }
    }
    for (const instr of block.instructions) {
      for (const operand of eachInstructionLValue(instr)) {
        visitIdentifier(operand.identifier);
      }
      for (const operand of eachInstructionOperand(instr)) {
        visitIdentifier(operand.identifier);
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      visitIdentifier(operand.identifier);
    }
  }
}
function visitIdentifier(identifier) {
  validateMutableRange(identifier.mutableRange);
  if (identifier.scope !== null) {
    validateMutableRange(identifier.scope.range);
  }
}
function validateMutableRange(mutableRange) {
  invariant$1(
    (mutableRange.start === 0 && mutableRange.end === 0) ||
      mutableRange.end > mutableRange.start,
    'Identifier scope mutableRange was invalid: [%s:%s]',
    mutableRange.start,
    mutableRange.end
  );
}
function Ok(val) {
  return new OkImpl(val);
}
class OkImpl {
  constructor(val) {
    this.val = val;
  }
  map(fn) {
    return new OkImpl(fn(this.val));
  }
  mapErr(_fn) {
    return this;
  }
  mapOr(_fallback, fn) {
    return fn(this.val);
  }
  mapOrElse(_fallback, fn) {
    return fn(this.val);
  }
  andThen(fn) {
    return fn(this.val);
  }
  and(res) {
    return res;
  }
  or(_res) {
    return this;
  }
  orElse(_fn) {
    return this;
  }
  isOk() {
    return true;
  }
  isErr() {
    return false;
  }
  expect(_msg) {
    return this.val;
  }
  expectErr(msg) {
    throw new Error(`${msg}: ${this.val}`);
  }
  unwrap() {
    return this.val;
  }
  unwrapOr(_fallback) {
    return this.val;
  }
  unwrapOrElse(_fallback) {
    return this.val;
  }
  unwrapErr() {
    if (this.val instanceof Error) {
      throw this.val;
    }
    throw new Error(`Can't unwrap \`Ok\` to \`Err\`: ${this.val}`);
  }
}
function Err(val) {
  return new ErrImpl(val);
}
class ErrImpl {
  constructor(val) {
    this.val = val;
  }
  map(_fn) {
    return this;
  }
  mapErr(fn) {
    return new ErrImpl(fn(this.val));
  }
  mapOr(fallback, _fn) {
    return fallback;
  }
  mapOrElse(fallback, _fn) {
    return fallback();
  }
  andThen(_fn) {
    return this;
  }
  and(_res) {
    return this;
  }
  or(res) {
    return res;
  }
  orElse(fn) {
    return fn(this.val);
  }
  isOk() {
    return false;
  }
  isErr() {
    return true;
  }
  expect(msg) {
    throw new Error(`${msg}: ${this.val}`);
  }
  expectErr(_msg) {
    return this.val;
  }
  unwrap() {
    if (this.val instanceof Error) {
      throw this.val;
    }
    throw new Error(`Can't unwrap \`Err\` to \`Ok\`: ${this.val}`);
  }
  unwrapOr(fallback) {
    return fallback;
  }
  unwrapOrElse(fallback) {
    return fallback(this.val);
  }
  unwrapErr() {
    return this.val;
  }
}
var _HIRBuilder_instances,
  _HIRBuilder_completed,
  _HIRBuilder_current,
  _HIRBuilder_entry,
  _HIRBuilder_scopes,
  _HIRBuilder_context,
  _HIRBuilder_bindings,
  _HIRBuilder_env,
  _HIRBuilder_exceptionHandlerStack,
  _HIRBuilder_resolveBabelBinding;
function newBlock(id, kind) {
  return {id: id, kind: kind, instructions: []};
}
class HIRBuilder {
  get nextIdentifierId() {
    return __classPrivateFieldGet(this, _HIRBuilder_env, 'f').nextIdentifierId;
  }
  get context() {
    return __classPrivateFieldGet(this, _HIRBuilder_context, 'f');
  }
  get bindings() {
    return __classPrivateFieldGet(this, _HIRBuilder_bindings, 'f');
  }
  get environment() {
    return __classPrivateFieldGet(this, _HIRBuilder_env, 'f');
  }
  constructor(env, parentFunction, bindings = null, context = null) {
    _HIRBuilder_instances.add(this);
    _HIRBuilder_completed.set(this, new Map());
    _HIRBuilder_current.set(this, void 0);
    _HIRBuilder_entry.set(this, void 0);
    _HIRBuilder_scopes.set(this, []);
    _HIRBuilder_context.set(this, void 0);
    _HIRBuilder_bindings.set(this, void 0);
    _HIRBuilder_env.set(this, void 0);
    _HIRBuilder_exceptionHandlerStack.set(this, []);
    this.errors = new CompilerError();
    this.fbtDepth = 0;
    __classPrivateFieldSet(this, _HIRBuilder_env, env, 'f');
    __classPrivateFieldSet(
      this,
      _HIRBuilder_bindings,
      bindings !== null && bindings !== void 0 ? bindings : new Map(),
      'f'
    );
    this.parentFunction = parentFunction;
    __classPrivateFieldSet(
      this,
      _HIRBuilder_context,
      context !== null && context !== void 0 ? context : [],
      'f'
    );
    __classPrivateFieldSet(
      this,
      _HIRBuilder_entry,
      makeBlockId(env.nextBlockId),
      'f'
    );
    __classPrivateFieldSet(
      this,
      _HIRBuilder_current,
      newBlock(__classPrivateFieldGet(this, _HIRBuilder_entry, 'f'), 'block'),
      'f'
    );
  }
  currentBlockKind() {
    return __classPrivateFieldGet(this, _HIRBuilder_current, 'f').kind;
  }
  push(instruction) {
    __classPrivateFieldGet(this, _HIRBuilder_current, 'f').instructions.push(
      instruction
    );
    const exceptionHandler = __classPrivateFieldGet(
      this,
      _HIRBuilder_exceptionHandlerStack,
      'f'
    ).at(-1);
    if (exceptionHandler !== undefined) {
      const continuationBlock = this.reserve(this.currentBlockKind());
      this.terminateWithContinuation(
        {
          kind: 'maybe-throw',
          continuation: continuationBlock.id,
          handler: exceptionHandler,
          id: makeInstructionId(0),
          loc: instruction.loc,
        },
        continuationBlock
      );
    }
  }
  enterTryCatch(handler, fn) {
    __classPrivateFieldGet(this, _HIRBuilder_exceptionHandlerStack, 'f').push(
      handler
    );
    fn();
    __classPrivateFieldGet(this, _HIRBuilder_exceptionHandlerStack, 'f').pop();
  }
  resolveThrowHandler() {
    const handler = __classPrivateFieldGet(
      this,
      _HIRBuilder_exceptionHandlerStack,
      'f'
    ).at(-1);
    return handler !== null && handler !== void 0 ? handler : null;
  }
  makeTemporary(loc) {
    const id = this.nextIdentifierId;
    return makeTemporaryIdentifier(id, loc);
  }
  resolveIdentifier(path) {
    const originalName = path.node.name;
    const babelBinding = __classPrivateFieldGet(
      this,
      _HIRBuilder_instances,
      'm',
      _HIRBuilder_resolveBabelBinding
    ).call(this, path);
    if (babelBinding == null) {
      return {kind: 'Global', name: originalName};
    }
    const outerBinding =
      this.parentFunction.scope.parent.getBinding(originalName);
    if (babelBinding === outerBinding) {
      const path = babelBinding.path;
      if (path.isImportDefaultSpecifier()) {
        const importDeclaration = path.parentPath;
        return {
          kind: 'ImportDefault',
          name: originalName,
          module: importDeclaration.node.source.value,
        };
      } else if (path.isImportSpecifier()) {
        const importDeclaration = path.parentPath;
        return {
          kind: 'ImportSpecifier',
          name: originalName,
          module: importDeclaration.node.source.value,
          imported:
            path.node.imported.type === 'Identifier'
              ? path.node.imported.name
              : path.node.imported.value,
        };
      } else if (path.isImportNamespaceSpecifier()) {
        const importDeclaration = path.parentPath;
        return {
          kind: 'ImportNamespace',
          name: originalName,
          module: importDeclaration.node.source.value,
        };
      } else {
        return {kind: 'ModuleLocal', name: originalName};
      }
    }
    const resolvedBinding = this.resolveBinding(babelBinding.identifier);
    if (resolvedBinding.name && resolvedBinding.name.value !== originalName) {
      babelBinding.scope.rename(originalName, resolvedBinding.name.value);
    }
    return {
      kind: 'Identifier',
      identifier: resolvedBinding,
      bindingKind: babelBinding.kind,
    };
  }
  isContextIdentifier(path) {
    const binding = __classPrivateFieldGet(
      this,
      _HIRBuilder_instances,
      'm',
      _HIRBuilder_resolveBabelBinding
    ).call(this, path);
    if (binding) {
      const outerBinding = this.parentFunction.scope.parent.getBinding(
        path.node.name
      );
      if (binding === outerBinding) {
        return false;
      }
      return __classPrivateFieldGet(
        this,
        _HIRBuilder_env,
        'f'
      ).isContextIdentifier(binding.identifier);
    } else {
      return false;
    }
  }
  resolveBinding(node) {
    var _a, _b;
    if (node.name === 'fbt') {
      CompilerError.throwTodo({
        reason: 'Support local variables named "fbt"',
        loc: (_a = node.loc) !== null && _a !== void 0 ? _a : null,
      });
    }
    const originalName = node.name;
    let name = originalName;
    let index = 0;
    while (true) {
      const mapping = __classPrivateFieldGet(
        this,
        _HIRBuilder_bindings,
        'f'
      ).get(name);
      if (mapping === undefined) {
        const id = this.nextIdentifierId;
        const identifier = {
          id: id,
          declarationId: makeDeclarationId(id),
          name: makeIdentifierName(name),
          mutableRange: {
            start: makeInstructionId(0),
            end: makeInstructionId(0),
          },
          scope: null,
          type: makeType(),
          loc: (_b = node.loc) !== null && _b !== void 0 ? _b : GeneratedSource,
        };
        __classPrivateFieldGet(this, _HIRBuilder_bindings, 'f').set(name, {
          node: node,
          identifier: identifier,
        });
        return identifier;
      } else if (mapping.node === node) {
        return mapping.identifier;
      } else {
        name = `${originalName}_${index++}`;
      }
    }
  }
  build() {
    var _a, _b;
    let ir = {
      blocks: __classPrivateFieldGet(this, _HIRBuilder_completed, 'f'),
      entry: __classPrivateFieldGet(this, _HIRBuilder_entry, 'f'),
    };
    const rpoBlocks = getReversePostorderedBlocks(ir);
    for (const [id, block] of ir.blocks) {
      if (
        !rpoBlocks.has(id) &&
        block.instructions.some(
          instr => instr.value.kind === 'FunctionExpression'
        )
      ) {
        CompilerError.throwTodo({
          reason: `Support functions with unreachable code that may contain hoisted declarations`,
          loc:
            (_b =
              (_a = block.instructions[0]) === null || _a === void 0
                ? void 0
                : _a.loc) !== null && _b !== void 0
              ? _b
              : block.terminal.loc,
          description: null,
          suggestions: null,
        });
      }
    }
    ir.blocks = rpoBlocks;
    removeUnreachableForUpdates(ir);
    removeDeadDoWhileStatements(ir);
    removeUnnecessaryTryCatch(ir);
    markInstructionIds(ir);
    markPredecessors(ir);
    return ir;
  }
  terminate(terminal, nextBlockKind) {
    const {
      id: blockId,
      kind: kind,
      instructions: instructions,
    } = __classPrivateFieldGet(this, _HIRBuilder_current, 'f');
    __classPrivateFieldGet(this, _HIRBuilder_completed, 'f').set(blockId, {
      kind: kind,
      id: blockId,
      instructions: instructions,
      terminal: terminal,
      preds: new Set(),
      phis: new Set(),
    });
    if (nextBlockKind) {
      const nextId = __classPrivateFieldGet(
        this,
        _HIRBuilder_env,
        'f'
      ).nextBlockId;
      __classPrivateFieldSet(
        this,
        _HIRBuilder_current,
        newBlock(nextId, nextBlockKind),
        'f'
      );
    }
  }
  terminateWithContinuation(terminal, continuation) {
    const {
      id: blockId,
      kind: kind,
      instructions: instructions,
    } = __classPrivateFieldGet(this, _HIRBuilder_current, 'f');
    __classPrivateFieldGet(this, _HIRBuilder_completed, 'f').set(blockId, {
      kind: kind,
      id: blockId,
      instructions: instructions,
      terminal: terminal,
      preds: new Set(),
      phis: new Set(),
    });
    __classPrivateFieldSet(this, _HIRBuilder_current, continuation, 'f');
  }
  reserve(kind) {
    return newBlock(
      makeBlockId(
        __classPrivateFieldGet(this, _HIRBuilder_env, 'f').nextBlockId
      ),
      kind
    );
  }
  complete(block, terminal) {
    const {id: blockId, kind: kind, instructions: instructions} = block;
    __classPrivateFieldGet(this, _HIRBuilder_completed, 'f').set(blockId, {
      kind: kind,
      id: blockId,
      instructions: instructions,
      terminal: terminal,
      preds: new Set(),
      phis: new Set(),
    });
  }
  enterReserved(wip, fn) {
    const current = __classPrivateFieldGet(this, _HIRBuilder_current, 'f');
    __classPrivateFieldSet(this, _HIRBuilder_current, wip, 'f');
    const terminal = fn();
    const {
      id: blockId,
      kind: kind,
      instructions: instructions,
    } = __classPrivateFieldGet(this, _HIRBuilder_current, 'f');
    __classPrivateFieldGet(this, _HIRBuilder_completed, 'f').set(blockId, {
      kind: kind,
      id: blockId,
      instructions: instructions,
      terminal: terminal,
      preds: new Set(),
      phis: new Set(),
    });
    __classPrivateFieldSet(this, _HIRBuilder_current, current, 'f');
  }
  enter(nextBlockKind, fn) {
    const wip = this.reserve(nextBlockKind);
    this.enterReserved(wip, () => fn(wip.id));
    return wip.id;
  }
  label(label, breakBlock, fn) {
    __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').push({
      kind: 'label',
      breakBlock: breakBlock,
      label: label,
    });
    const value = fn();
    const last = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').pop();
    CompilerError.invariant(
      last != null &&
        last.kind === 'label' &&
        last.label === label &&
        last.breakBlock === breakBlock,
      {
        reason: 'Mismatched label',
        description: null,
        loc: null,
        suggestions: null,
      }
    );
    return value;
  }
  switch(label, breakBlock, fn) {
    __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').push({
      kind: 'switch',
      breakBlock: breakBlock,
      label: label,
    });
    const value = fn();
    const last = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').pop();
    CompilerError.invariant(
      last != null &&
        last.kind === 'switch' &&
        last.label === label &&
        last.breakBlock === breakBlock,
      {
        reason: 'Mismatched label',
        description: null,
        loc: null,
        suggestions: null,
      }
    );
    return value;
  }
  loop(label, continueBlock, breakBlock, fn) {
    __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').push({
      kind: 'loop',
      label: label,
      continueBlock: continueBlock,
      breakBlock: breakBlock,
    });
    const value = fn();
    const last = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').pop();
    CompilerError.invariant(
      last != null &&
        last.kind === 'loop' &&
        last.label === label &&
        last.continueBlock === continueBlock &&
        last.breakBlock === breakBlock,
      {
        reason: 'Mismatched loops',
        description: null,
        loc: null,
        suggestions: null,
      }
    );
    return value;
  }
  lookupBreak(label) {
    for (
      let ii = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').length - 1;
      ii >= 0;
      ii--
    ) {
      const scope = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f')[ii];
      if (
        (label === null &&
          (scope.kind === 'loop' || scope.kind === 'switch')) ||
        label === scope.label
      ) {
        return scope.breakBlock;
      }
    }
    CompilerError.invariant(false, {
      reason: 'Expected a loop or switch to be in scope',
      description: null,
      loc: null,
      suggestions: null,
    });
  }
  lookupContinue(label) {
    for (
      let ii = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f').length - 1;
      ii >= 0;
      ii--
    ) {
      const scope = __classPrivateFieldGet(this, _HIRBuilder_scopes, 'f')[ii];
      if (scope.kind === 'loop') {
        if (label === null || label === scope.label) {
          return scope.continueBlock;
        }
      } else if (label !== null && scope.label === label) {
        CompilerError.invariant(false, {
          reason: 'Continue may only refer to a labeled loop',
          description: null,
          loc: null,
          suggestions: null,
        });
      }
    }
    CompilerError.invariant(false, {
      reason: 'Expected a loop to be in scope',
      description: null,
      loc: null,
      suggestions: null,
    });
  }
}
(_HIRBuilder_completed = new WeakMap()),
  (_HIRBuilder_current = new WeakMap()),
  (_HIRBuilder_entry = new WeakMap()),
  (_HIRBuilder_scopes = new WeakMap()),
  (_HIRBuilder_context = new WeakMap()),
  (_HIRBuilder_bindings = new WeakMap()),
  (_HIRBuilder_env = new WeakMap()),
  (_HIRBuilder_exceptionHandlerStack = new WeakMap()),
  (_HIRBuilder_instances = new WeakSet()),
  (_HIRBuilder_resolveBabelBinding = function _HIRBuilder_resolveBabelBinding(
    path
  ) {
    const originalName = path.node.name;
    const binding = path.scope.getBinding(originalName);
    if (binding == null) {
      return null;
    }
    return binding;
  });
function removeUnreachableForUpdates(fn) {
  for (const [, block] of fn.blocks) {
    if (
      block.terminal.kind === 'for' &&
      block.terminal.update !== null &&
      !fn.blocks.has(block.terminal.update)
    ) {
      block.terminal.update = null;
    }
  }
}
function removeDeadDoWhileStatements(func) {
  const visited = new Set();
  for (const [_, block] of func.blocks) {
    visited.add(block.id);
  }
  for (const [_, block] of func.blocks) {
    if (block.terminal.kind === 'do-while') {
      if (!visited.has(block.terminal.test)) {
        block.terminal = {
          kind: 'goto',
          block: block.terminal.loop,
          variant: GotoVariant.Break,
          id: block.terminal.id,
          loc: block.terminal.loc,
        };
      }
    }
  }
}
function reversePostorderBlocks(func) {
  const rpoBlocks = getReversePostorderedBlocks(func);
  func.blocks = rpoBlocks;
}
function getReversePostorderedBlocks(func) {
  const visited = new Set();
  const used = new Set();
  const usedFallthroughs = new Set();
  const postorder = [];
  function visit(blockId, isUsed) {
    const wasUsed = used.has(blockId);
    const wasVisited = visited.has(blockId);
    visited.add(blockId);
    if (isUsed) {
      used.add(blockId);
    }
    if (wasVisited && (wasUsed || !isUsed)) {
      return;
    }
    const block = func.blocks.get(blockId);
    const successors = [...eachTerminalSuccessor(block.terminal)].reverse();
    const fallthrough = terminalFallthrough(block.terminal);
    if (fallthrough != null) {
      if (isUsed) {
        usedFallthroughs.add(fallthrough);
      }
      visit(fallthrough, false);
    }
    for (const successor of successors) {
      visit(successor, isUsed);
    }
    if (!wasVisited) {
      postorder.push(blockId);
    }
  }
  visit(func.entry, true);
  const blocks = new Map();
  for (const blockId of postorder.reverse()) {
    const block = func.blocks.get(blockId);
    if (used.has(blockId)) {
      blocks.set(blockId, func.blocks.get(blockId));
    } else if (usedFallthroughs.has(blockId)) {
      blocks.set(
        blockId,
        Object.assign(Object.assign({}, block), {
          instructions: [],
          terminal: {
            kind: 'unreachable',
            id: block.terminal.id,
            loc: block.terminal.loc,
          },
        })
      );
    }
  }
  return blocks;
}
function markInstructionIds(func) {
  let id = 0;
  const visited = new Set();
  for (const [_, block] of func.blocks) {
    for (const instr of block.instructions) {
      CompilerError.invariant(!visited.has(instr), {
        reason: `${printInstruction(instr)} already visited!`,
        description: null,
        loc: instr.loc,
        suggestions: null,
      });
      visited.add(instr);
      instr.id = makeInstructionId(++id);
    }
    block.terminal.id = makeInstructionId(++id);
  }
}
function markPredecessors(func) {
  for (const [, block] of func.blocks) {
    block.preds.clear();
  }
  const visited = new Set();
  function visit(blockId, prevBlock) {
    const block = func.blocks.get(blockId);
    if (block == null) {
      return;
    }
    CompilerError.invariant(block != null, {
      reason: 'unexpected missing block',
      description: `block ${blockId}`,
      loc: GeneratedSource,
    });
    if (prevBlock) {
      block.preds.add(prevBlock.id);
    }
    if (visited.has(blockId)) {
      return;
    }
    visited.add(blockId);
    const {terminal: terminal} = block;
    for (const successor of eachTerminalSuccessor(terminal)) {
      visit(successor, block);
    }
  }
  visit(func.entry, null);
}
function removeUnnecessaryTryCatch(fn) {
  for (const [, block] of fn.blocks) {
    if (
      block.terminal.kind === 'try' &&
      !fn.blocks.has(block.terminal.handler)
    ) {
      const handlerId = block.terminal.handler;
      const fallthroughId = block.terminal.fallthrough;
      const fallthrough = fn.blocks.get(fallthroughId);
      block.terminal = {
        kind: 'goto',
        block: block.terminal.block,
        id: makeInstructionId(0),
        loc: block.terminal.loc,
        variant: GotoVariant.Break,
      };
      if (fallthrough != null) {
        if (fallthrough.preds.size === 1 && fallthrough.preds.has(handlerId)) {
          fn.blocks.delete(fallthroughId);
        } else {
          fallthrough.preds.delete(handlerId);
        }
      }
    }
  }
}
function createTemporaryPlace(env, loc) {
  return {
    kind: 'Identifier',
    identifier: makeTemporaryIdentifier(env.nextIdentifierId, loc),
    reactive: false,
    effect: exports.Effect.Unknown,
    loc: GeneratedSource,
  };
}
function clonePlaceToTemporary(env, place) {
  const temp = createTemporaryPlace(env, place.loc);
  temp.effect = place.effect;
  temp.identifier.type = place.identifier.type;
  temp.reactive = place.reactive;
  return temp;
}
function fixScopeAndIdentifierRanges(func) {
  var _a, _b;
  for (const [, block] of func.blocks) {
    const terminal = block.terminal;
    if (terminal.kind === 'scope' || terminal.kind === 'pruned-scope') {
      const fallthroughBlock = func.blocks.get(terminal.fallthrough);
      const firstId =
        (_b =
          (_a = fallthroughBlock.instructions[0]) === null || _a === void 0
            ? void 0
            : _a.id) !== null && _b !== void 0
          ? _b
          : fallthroughBlock.terminal.id;
      terminal.scope.range.start = terminal.id;
      terminal.scope.range.end = firstId;
    }
  }
}
const PRIMITIVE_TYPE = {kind: 'Primitive'};
let nextAnonId = 0;
function createAnonId() {
  return `<generated_${nextAnonId++}>`;
}
function addFunction(registry, properties, fn, id = null) {
  const shapeId = id !== null && id !== void 0 ? id : createAnonId();
  addShape(
    registry,
    shapeId,
    properties,
    Object.assign(Object.assign({}, fn), {hookKind: null})
  );
  return {kind: 'Function', return: fn.returnType, shapeId: shapeId};
}
function addHook(registry, fn, id = null) {
  const shapeId = id !== null && id !== void 0 ? id : createAnonId();
  addShape(registry, shapeId, [], fn);
  return {kind: 'Function', return: fn.returnType, shapeId: shapeId};
}
function addObject(registry, id, properties) {
  const shapeId = id !== null && id !== void 0 ? id : createAnonId();
  addShape(registry, shapeId, properties, null);
  return {kind: 'Object', shapeId: shapeId};
}
function addShape(registry, id, properties, functionType) {
  const shape = {properties: new Map(properties), functionType: functionType};
  CompilerError.invariant(!registry.has(id), {
    reason: `[ObjectShape] Could not add shape to registry: name ${id} already exists.`,
    description: null,
    loc: null,
    suggestions: null,
  });
  registry.set(id, shape);
  return shape;
}
const BuiltInPropsId = 'BuiltInProps';
const BuiltInArrayId = 'BuiltInArray';
const BuiltInFunctionId = 'BuiltInFunction';
const BuiltInJsxId = 'BuiltInJsx';
const BuiltInObjectId = 'BuiltInObject';
const BuiltInUseStateId = 'BuiltInUseState';
const BuiltInSetStateId = 'BuiltInSetState';
const BuiltInUseActionStateId = 'BuiltInUseActionState';
const BuiltInSetActionStateId = 'BuiltInSetActionState';
const BuiltInUseRefId = 'BuiltInUseRefId';
const BuiltInRefValueId = 'BuiltInRefValue';
const BuiltInMixedReadonlyId = 'BuiltInMixedReadonly';
const BuiltInUseEffectHookId = 'BuiltInUseEffectHook';
const BuiltInUseLayoutEffectHookId = 'BuiltInUseLayoutEffectHook';
const BuiltInUseInsertionEffectHookId = 'BuiltInUseInsertionEffectHook';
const BuiltInUseOperatorId = 'BuiltInUseOperator';
const BuiltInUseReducerId = 'BuiltInUseReducer';
const BuiltInDispatchId = 'BuiltInDispatch';
const BuiltInUseContextHookId = 'BuiltInUseContextHook';
const BuiltInUseTransitionId = 'BuiltInUseTransition';
const BuiltInStartTransitionId = 'BuiltInStartTransition';
const BUILTIN_SHAPES = new Map();
addObject(BUILTIN_SHAPES, BuiltInPropsId, [
  ['ref', {kind: 'Object', shapeId: BuiltInUseRefId}],
]);
addObject(BUILTIN_SHAPES, BuiltInArrayId, [
  [
    'indexOf',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  [
    'includes',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  [
    'pop',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: null,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.Store,
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  [
    'at',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [exports.Effect.Read],
      restParam: null,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.Capture,
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  [
    'concat',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Capture,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.Capture,
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  ['length', PRIMITIVE_TYPE],
  [
    'push',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Capture,
      returnType: PRIMITIVE_TYPE,
      calleeEffect: exports.Effect.Store,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  [
    'slice',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.Capture,
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  [
    'map',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'flatMap',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'filter',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'every',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Primitive,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'some',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Primitive,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'find',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'findIndex',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Primitive,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'join',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: PRIMITIVE_TYPE,
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
]);
addObject(BUILTIN_SHAPES, BuiltInObjectId, [
  [
    'toString',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: null,
      returnType: PRIMITIVE_TYPE,
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
]);
addObject(BUILTIN_SHAPES, BuiltInUseStateId, [
  ['0', {kind: 'Poly'}],
  [
    '1',
    addFunction(
      BUILTIN_SHAPES,
      [],
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: PRIMITIVE_TYPE,
        calleeEffect: exports.Effect.Read,
        returnValueKind: exports.ValueKind.Primitive,
      },
      BuiltInSetStateId
    ),
  ],
]);
addObject(BUILTIN_SHAPES, BuiltInUseTransitionId, [
  ['0', {kind: 'Primitive'}],
  [
    '1',
    addFunction(
      BUILTIN_SHAPES,
      [],
      {
        positionalParams: [],
        restParam: null,
        returnType: PRIMITIVE_TYPE,
        calleeEffect: exports.Effect.Read,
        returnValueKind: exports.ValueKind.Primitive,
      },
      BuiltInStartTransitionId
    ),
  ],
]);
addObject(BUILTIN_SHAPES, BuiltInUseActionStateId, [
  ['0', {kind: 'Poly'}],
  [
    '1',
    addFunction(
      BUILTIN_SHAPES,
      [],
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: PRIMITIVE_TYPE,
        calleeEffect: exports.Effect.Read,
        returnValueKind: exports.ValueKind.Primitive,
      },
      BuiltInSetActionStateId
    ),
  ],
]);
addObject(BUILTIN_SHAPES, BuiltInUseReducerId, [
  ['0', {kind: 'Poly'}],
  [
    '1',
    addFunction(
      BUILTIN_SHAPES,
      [],
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: PRIMITIVE_TYPE,
        calleeEffect: exports.Effect.Read,
        returnValueKind: exports.ValueKind.Primitive,
      },
      BuiltInDispatchId
    ),
  ],
]);
addObject(BUILTIN_SHAPES, BuiltInUseRefId, [
  ['current', {kind: 'Object', shapeId: BuiltInRefValueId}],
]);
addObject(BUILTIN_SHAPES, BuiltInRefValueId, [
  ['*', {kind: 'Object', shapeId: BuiltInRefValueId}],
]);
addObject(BUILTIN_SHAPES, BuiltInMixedReadonlyId, [
  [
    'toString',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: PRIMITIVE_TYPE,
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  [
    'map',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
    }),
  ],
  [
    'flatMap',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
    }),
  ],
  [
    'filter',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
    }),
  ],
  [
    'concat',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Capture,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.Capture,
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  [
    'slice',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Object', shapeId: BuiltInArrayId},
      calleeEffect: exports.Effect.Capture,
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  [
    'every',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Primitive,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'some',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Primitive,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'find',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Mutable,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'findIndex',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.ConditionallyMutate,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.ConditionallyMutate,
      returnValueKind: exports.ValueKind.Primitive,
      noAlias: true,
      mutableOnlyIfOperandsAreMutable: true,
    }),
  ],
  [
    'join',
    addFunction(BUILTIN_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: PRIMITIVE_TYPE,
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  ['*', {kind: 'Object', shapeId: BuiltInMixedReadonlyId}],
]);
addObject(BUILTIN_SHAPES, BuiltInJsxId, []);
addObject(BUILTIN_SHAPES, BuiltInFunctionId, []);
const DefaultMutatingHook = addHook(
  BUILTIN_SHAPES,
  {
    positionalParams: [],
    restParam: exports.Effect.ConditionallyMutate,
    returnType: {kind: 'Poly'},
    calleeEffect: exports.Effect.Read,
    hookKind: 'Custom',
    returnValueKind: exports.ValueKind.Mutable,
  },
  'DefaultMutatingHook'
);
const DefaultNonmutatingHook = addHook(
  BUILTIN_SHAPES,
  {
    positionalParams: [],
    restParam: exports.Effect.Freeze,
    returnType: {kind: 'Poly'},
    calleeEffect: exports.Effect.Read,
    hookKind: 'Custom',
    returnValueKind: exports.ValueKind.Frozen,
  },
  'DefaultNonmutatingHook'
);
function lower$1(func, env, bindings = null, capturedRefs = [], parent = null) {
  var _a, _b, _c;
  const builder = new HIRBuilder(
    env,
    parent !== null && parent !== void 0 ? parent : func,
    bindings,
    capturedRefs
  );
  const context = [];
  for (const ref of capturedRefs !== null && capturedRefs !== void 0
    ? capturedRefs
    : []) {
    context.push({
      kind: 'Identifier',
      identifier: builder.resolveBinding(ref),
      effect: exports.Effect.Unknown,
      reactive: false,
      loc: (_a = ref.loc) !== null && _a !== void 0 ? _a : GeneratedSource,
    });
  }
  let id = null;
  if (func.isFunctionDeclaration() || func.isFunctionExpression()) {
    const idNode = func.get('id');
    if (hasNode(idNode)) {
      id = idNode.node.name;
    }
  }
  const params = [];
  func.get('params').forEach(param => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    if (param.isIdentifier()) {
      const binding = builder.resolveIdentifier(param);
      if (binding.kind !== 'Identifier') {
        builder.errors.push({
          reason: `(BuildHIR::lower) Could not find binding for param \`${param.node.name}\``,
          severity: exports.ErrorSeverity.Invariant,
          loc: (_a = param.node.loc) !== null && _a !== void 0 ? _a : null,
          suggestions: null,
        });
        return;
      }
      const place = {
        kind: 'Identifier',
        identifier: binding.identifier,
        effect: exports.Effect.Unknown,
        reactive: false,
        loc:
          (_b = param.node.loc) !== null && _b !== void 0
            ? _b
            : GeneratedSource,
      };
      params.push(place);
    } else if (
      param.isObjectPattern() ||
      param.isArrayPattern() ||
      param.isAssignmentPattern()
    ) {
      const place = {
        kind: 'Identifier',
        identifier: builder.makeTemporary(
          (_c = param.node.loc) !== null && _c !== void 0 ? _c : GeneratedSource
        ),
        effect: exports.Effect.Unknown,
        reactive: false,
        loc:
          (_d = param.node.loc) !== null && _d !== void 0
            ? _d
            : GeneratedSource,
      };
      promoteTemporary(place.identifier);
      params.push(place);
      lowerAssignment(
        builder,
        (_e = param.node.loc) !== null && _e !== void 0 ? _e : GeneratedSource,
        InstructionKind.Let,
        param,
        place,
        'Assignment'
      );
    } else if (param.isRestElement()) {
      const place = {
        kind: 'Identifier',
        identifier: builder.makeTemporary(
          (_f = param.node.loc) !== null && _f !== void 0 ? _f : GeneratedSource
        ),
        effect: exports.Effect.Unknown,
        reactive: false,
        loc:
          (_g = param.node.loc) !== null && _g !== void 0
            ? _g
            : GeneratedSource,
      };
      params.push({kind: 'Spread', place: place});
      lowerAssignment(
        builder,
        (_h = param.node.loc) !== null && _h !== void 0 ? _h : GeneratedSource,
        InstructionKind.Let,
        param.get('argument'),
        place,
        'Assignment'
      );
    } else {
      builder.errors.push({
        reason: `(BuildHIR::lower) Handle ${param.node.type} params`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_j = param.node.loc) !== null && _j !== void 0 ? _j : null,
        suggestions: null,
      });
    }
  });
  let directives = [];
  const body = func.get('body');
  if (body.isExpression()) {
    const fallthrough = builder.reserve('block');
    const terminal = {
      kind: 'return',
      loc: GeneratedSource,
      value: lowerExpressionToTemporary(builder, body),
      id: makeInstructionId(0),
    };
    builder.terminateWithContinuation(terminal, fallthrough);
  } else if (body.isBlockStatement()) {
    lowerStatement(builder, body);
    directives = body.get('directives').map(d => d.node.value.value);
  } else {
    builder.errors.push({
      severity: exports.ErrorSeverity.InvalidJS,
      reason: `Unexpected function body kind`,
      description: `Expected function body to be an expression or a block statement, got \`${body.type}\``,
      loc: (_b = body.node.loc) !== null && _b !== void 0 ? _b : null,
      suggestions: null,
    });
  }
  if (builder.errors.hasErrors()) {
    return Err(builder.errors);
  }
  builder.terminate(
    {
      kind: 'return',
      loc: GeneratedSource,
      value: lowerValueToTemporary(builder, {
        kind: 'Primitive',
        value: undefined,
        loc: GeneratedSource,
      }),
      id: makeInstructionId(0),
    },
    null
  );
  return Ok({
    id: id,
    params: params,
    fnType: parent == null ? env.fnType : 'Other',
    returnTypeAnnotation: null,
    returnType: makeType(),
    body: builder.build(),
    context: context,
    generator: func.node.generator === true,
    async: func.node.async === true,
    loc: (_c = func.node.loc) !== null && _c !== void 0 ? _c : GeneratedSource,
    env: env,
    effects: null,
    directives: directives,
  });
}
function lowerStatement(builder, stmtPath, label = null) {
  var _a,
    _b,
    _c,
    _d,
    _e,
    _f,
    _g,
    _h,
    _j,
    _k,
    _l,
    _m,
    _o,
    _p,
    _q,
    _r,
    _s,
    _t,
    _u,
    _v,
    _w,
    _x,
    _y,
    _z,
    _0,
    _1,
    _2,
    _3,
    _4,
    _5,
    _6,
    _7,
    _8,
    _9,
    _10,
    _11,
    _12,
    _13,
    _14,
    _15,
    _16,
    _17,
    _18,
    _19,
    _20,
    _21,
    _22,
    _23,
    _24,
    _25,
    _26,
    _27,
    _28,
    _29,
    _30,
    _31;
  const stmtNode = stmtPath.node;
  switch (stmtNode.type) {
    case 'ThrowStatement': {
      const stmt = stmtPath;
      const value = lowerExpressionToTemporary(builder, stmt.get('argument'));
      const handler = builder.resolveThrowHandler();
      if (handler != null) {
        builder.errors.push({
          reason:
            '(BuildHIR::lowerStatement) Support ThrowStatement inside of try/catch',
          severity: exports.ErrorSeverity.Todo,
          loc: (_a = stmt.node.loc) !== null && _a !== void 0 ? _a : null,
          suggestions: null,
        });
      }
      const terminal = {
        kind: 'throw',
        value: value,
        id: makeInstructionId(0),
        loc:
          (_b = stmt.node.loc) !== null && _b !== void 0 ? _b : GeneratedSource,
      };
      builder.terminate(terminal, 'block');
      return;
    }
    case 'ReturnStatement': {
      const stmt = stmtPath;
      const argument = stmt.get('argument');
      let value;
      if (argument.node === null) {
        value = lowerValueToTemporary(builder, {
          kind: 'Primitive',
          value: undefined,
          loc: GeneratedSource,
        });
      } else {
        value = lowerExpressionToTemporary(builder, argument);
      }
      const terminal = {
        kind: 'return',
        loc:
          (_c = stmt.node.loc) !== null && _c !== void 0 ? _c : GeneratedSource,
        value: value,
        id: makeInstructionId(0),
      };
      builder.terminate(terminal, 'block');
      return;
    }
    case 'IfStatement': {
      const stmt = stmtPath;
      const continuationBlock = builder.reserve('block');
      const consequentBlock = builder.enter('block', _blockId => {
        var _a;
        const consequent = stmt.get('consequent');
        lowerStatement(builder, consequent);
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc:
            (_a = consequent.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
        };
      });
      let alternateBlock;
      const alternate = stmt.get('alternate');
      if (hasNode(alternate)) {
        alternateBlock = builder.enter('block', _blockId => {
          var _a, _b;
          lowerStatement(builder, alternate);
          return {
            kind: 'goto',
            block: continuationBlock.id,
            variant: GotoVariant.Break,
            id: makeInstructionId(0),
            loc:
              (_b =
                (_a = alternate.node) === null || _a === void 0
                  ? void 0
                  : _a.loc) !== null && _b !== void 0
                ? _b
                : GeneratedSource,
          };
        });
      } else {
        alternateBlock = continuationBlock.id;
      }
      const test = lowerExpressionToTemporary(builder, stmt.get('test'));
      const terminal = {
        kind: 'if',
        test: test,
        consequent: consequentBlock,
        alternate: alternateBlock,
        fallthrough: continuationBlock.id,
        id: makeInstructionId(0),
        loc:
          (_d = stmt.node.loc) !== null && _d !== void 0 ? _d : GeneratedSource,
      };
      builder.terminateWithContinuation(terminal, continuationBlock);
      return;
    }
    case 'BlockStatement': {
      const stmt = stmtPath;
      const statements = stmt.get('body');
      const hoistableIdentifiers = new Set();
      for (const [, binding] of Object.entries(stmt.scope.bindings)) {
        if (binding.kind !== 'param') {
          hoistableIdentifiers.add(binding.identifier);
        }
      }
      for (const s of statements) {
        const willHoist = new Set();
        let fnDepth = s.isFunctionDeclaration() ? 1 : 0;
        const withFunctionContext = {
          enter: () => {
            fnDepth++;
          },
          exit: () => {
            fnDepth--;
          },
        };
        s.traverse({
          FunctionExpression: withFunctionContext,
          FunctionDeclaration: withFunctionContext,
          ArrowFunctionExpression: withFunctionContext,
          ObjectMethod: withFunctionContext,
          Identifier(id) {
            const id2 = id;
            if (
              !id2.isReferencedIdentifier() &&
              id.parent.type !== 'AssignmentExpression'
            ) {
              return;
            }
            const binding = id.scope.getBinding(id.node.name);
            if (
              binding != null &&
              hoistableIdentifiers.has(binding.identifier) &&
              (fnDepth > 0 || binding.kind === 'hoisted')
            ) {
              willHoist.add(id);
            }
          },
        });
        s.traverse({
          Identifier(path) {
            if (hoistableIdentifiers.has(path.node)) {
              hoistableIdentifiers.delete(path.node);
            }
          },
        });
        for (const id of willHoist) {
          const binding = stmt.scope.getBinding(id.node.name);
          CompilerError.invariant(binding != null, {
            reason: 'Expected to find binding for hoisted identifier',
            description: `Could not find a binding for ${id.node.name}`,
            suggestions: null,
            loc:
              (_e = id.node.loc) !== null && _e !== void 0
                ? _e
                : GeneratedSource,
          });
          if (builder.environment.isHoistedIdentifier(binding.identifier)) {
            continue;
          }
          let kind;
          if (binding.kind === 'const' || binding.kind === 'var') {
            kind = InstructionKind.HoistedConst;
          } else if (binding.kind === 'let') {
            kind = InstructionKind.HoistedLet;
          } else if (binding.path.isFunctionDeclaration()) {
            kind = InstructionKind.HoistedFunction;
          } else if (!binding.path.isVariableDeclarator()) {
            builder.errors.push({
              severity: exports.ErrorSeverity.Todo,
              reason: 'Unsupported declaration type for hoisting',
              description: `variable "${binding.identifier.name}" declared with ${binding.path.type}`,
              suggestions: null,
              loc:
                (_f = id.parentPath.node.loc) !== null && _f !== void 0
                  ? _f
                  : GeneratedSource,
            });
            continue;
          } else {
            builder.errors.push({
              severity: exports.ErrorSeverity.Todo,
              reason: 'Handle non-const declarations for hoisting',
              description: `variable "${binding.identifier.name}" declared with ${binding.kind}`,
              suggestions: null,
              loc:
                (_g = id.parentPath.node.loc) !== null && _g !== void 0
                  ? _g
                  : GeneratedSource,
            });
            continue;
          }
          const identifier = builder.resolveIdentifier(id);
          CompilerError.invariant(identifier.kind === 'Identifier', {
            reason:
              'Expected hoisted binding to be a local identifier, not a global',
            loc:
              (_h = id.node.loc) !== null && _h !== void 0
                ? _h
                : GeneratedSource,
          });
          const place = {
            effect: exports.Effect.Unknown,
            identifier: identifier.identifier,
            kind: 'Identifier',
            reactive: false,
            loc:
              (_j = id.node.loc) !== null && _j !== void 0
                ? _j
                : GeneratedSource,
          };
          lowerValueToTemporary(builder, {
            kind: 'DeclareContext',
            lvalue: {kind: kind, place: place},
            loc:
              (_k = id.node.loc) !== null && _k !== void 0
                ? _k
                : GeneratedSource,
          });
          builder.environment.addHoistedIdentifier(binding.identifier);
        }
        lowerStatement(builder, s);
      }
      return;
    }
    case 'BreakStatement': {
      const stmt = stmtPath;
      const block = builder.lookupBreak(
        (_m =
          (_l = stmt.node.label) === null || _l === void 0
            ? void 0
            : _l.name) !== null && _m !== void 0
          ? _m
          : null
      );
      builder.terminate(
        {
          kind: 'goto',
          block: block,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc:
            (_o = stmt.node.loc) !== null && _o !== void 0
              ? _o
              : GeneratedSource,
        },
        'block'
      );
      return;
    }
    case 'ContinueStatement': {
      const stmt = stmtPath;
      const block = builder.lookupContinue(
        (_q =
          (_p = stmt.node.label) === null || _p === void 0
            ? void 0
            : _p.name) !== null && _q !== void 0
          ? _q
          : null
      );
      builder.terminate(
        {
          kind: 'goto',
          block: block,
          variant: GotoVariant.Continue,
          id: makeInstructionId(0),
          loc:
            (_r = stmt.node.loc) !== null && _r !== void 0
              ? _r
              : GeneratedSource,
        },
        'block'
      );
      return;
    }
    case 'ForStatement': {
      const stmt = stmtPath;
      const testBlock = builder.reserve('loop');
      const continuationBlock = builder.reserve('block');
      const initBlock = builder.enter('loop', _blockId => {
        var _a, _b, _c, _d;
        const init = stmt.get('init');
        if (!init.isVariableDeclaration()) {
          builder.errors.push({
            reason:
              '(BuildHIR::lowerStatement) Handle non-variable initialization in ForStatement',
            severity: exports.ErrorSeverity.Todo,
            loc: (_a = stmt.node.loc) !== null && _a !== void 0 ? _a : null,
            suggestions: null,
          });
          return {
            kind: 'unsupported',
            id: makeInstructionId(0),
            loc:
              (_c =
                (_b = init.node) === null || _b === void 0
                  ? void 0
                  : _b.loc) !== null && _c !== void 0
                ? _c
                : GeneratedSource,
          };
        }
        lowerStatement(builder, init);
        return {
          kind: 'goto',
          block: testBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc:
            (_d = init.node.loc) !== null && _d !== void 0
              ? _d
              : GeneratedSource,
        };
      });
      let updateBlock = null;
      const update = stmt.get('update');
      if (hasNode(update)) {
        updateBlock = builder.enter('loop', _blockId => {
          var _a, _b;
          lowerExpressionToTemporary(builder, update);
          return {
            kind: 'goto',
            block: testBlock.id,
            variant: GotoVariant.Break,
            id: makeInstructionId(0),
            loc:
              (_b =
                (_a = update.node) === null || _a === void 0
                  ? void 0
                  : _a.loc) !== null && _b !== void 0
                ? _b
                : GeneratedSource,
          };
        });
      }
      const bodyBlock = builder.enter('block', _blockId =>
        builder.loop(
          label,
          updateBlock !== null && updateBlock !== void 0
            ? updateBlock
            : testBlock.id,
          continuationBlock.id,
          () => {
            var _a;
            const body = stmt.get('body');
            lowerStatement(builder, body);
            return {
              kind: 'goto',
              block:
                updateBlock !== null && updateBlock !== void 0
                  ? updateBlock
                  : testBlock.id,
              variant: GotoVariant.Continue,
              id: makeInstructionId(0),
              loc:
                (_a = body.node.loc) !== null && _a !== void 0
                  ? _a
                  : GeneratedSource,
            };
          }
        )
      );
      builder.terminateWithContinuation(
        {
          kind: 'for',
          loc:
            (_s = stmtNode.loc) !== null && _s !== void 0
              ? _s
              : GeneratedSource,
          init: initBlock,
          test: testBlock.id,
          update: updateBlock,
          loop: bodyBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
        },
        testBlock
      );
      const test = stmt.get('test');
      if (test.node == null) {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle empty test in ForStatement`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_t = stmt.node.loc) !== null && _t !== void 0 ? _t : null,
          suggestions: null,
        });
      } else {
        builder.terminateWithContinuation(
          {
            kind: 'branch',
            test: lowerExpressionToTemporary(builder, test),
            consequent: bodyBlock,
            alternate: continuationBlock.id,
            fallthrough: continuationBlock.id,
            id: makeInstructionId(0),
            loc:
              (_u = stmt.node.loc) !== null && _u !== void 0
                ? _u
                : GeneratedSource,
          },
          continuationBlock
        );
      }
      return;
    }
    case 'WhileStatement': {
      const stmt = stmtPath;
      const conditionalBlock = builder.reserve('loop');
      const continuationBlock = builder.reserve('block');
      const loopBlock = builder.enter('block', _blockId =>
        builder.loop(label, conditionalBlock.id, continuationBlock.id, () => {
          var _a;
          const body = stmt.get('body');
          lowerStatement(builder, body);
          return {
            kind: 'goto',
            block: conditionalBlock.id,
            variant: GotoVariant.Continue,
            id: makeInstructionId(0),
            loc:
              (_a = body.node.loc) !== null && _a !== void 0
                ? _a
                : GeneratedSource,
          };
        })
      );
      const loc =
        (_v = stmt.node.loc) !== null && _v !== void 0 ? _v : GeneratedSource;
      builder.terminateWithContinuation(
        {
          kind: 'while',
          loc: loc,
          test: conditionalBlock.id,
          loop: loopBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
        },
        conditionalBlock
      );
      const test = lowerExpressionToTemporary(builder, stmt.get('test'));
      const terminal = {
        kind: 'branch',
        test: test,
        consequent: loopBlock,
        alternate: continuationBlock.id,
        fallthrough: conditionalBlock.id,
        id: makeInstructionId(0),
        loc:
          (_w = stmt.node.loc) !== null && _w !== void 0 ? _w : GeneratedSource,
      };
      builder.terminateWithContinuation(terminal, continuationBlock);
      return;
    }
    case 'LabeledStatement': {
      const stmt = stmtPath;
      const label = stmt.node.label.name;
      const body = stmt.get('body');
      switch (body.node.type) {
        case 'ForInStatement':
        case 'ForOfStatement':
        case 'ForStatement':
        case 'WhileStatement':
        case 'DoWhileStatement': {
          lowerStatement(builder, stmt.get('body'), label);
          break;
        }
        default: {
          const continuationBlock = builder.reserve('block');
          const block = builder.enter('block', () => {
            var _a;
            const body = stmt.get('body');
            builder.label(label, continuationBlock.id, () => {
              lowerStatement(builder, body);
            });
            return {
              kind: 'goto',
              block: continuationBlock.id,
              variant: GotoVariant.Break,
              id: makeInstructionId(0),
              loc:
                (_a = body.node.loc) !== null && _a !== void 0
                  ? _a
                  : GeneratedSource,
            };
          });
          builder.terminateWithContinuation(
            {
              kind: 'label',
              block: block,
              fallthrough: continuationBlock.id,
              id: makeInstructionId(0),
              loc:
                (_x = stmt.node.loc) !== null && _x !== void 0
                  ? _x
                  : GeneratedSource,
            },
            continuationBlock
          );
        }
      }
      return;
    }
    case 'SwitchStatement': {
      const stmt = stmtPath;
      const continuationBlock = builder.reserve('block');
      let fallthrough = continuationBlock.id;
      const cases = [];
      let hasDefault = false;
      for (let ii = stmt.get('cases').length - 1; ii >= 0; ii--) {
        const case_ = stmt.get('cases')[ii];
        const testExpr = case_.get('test');
        if (testExpr.node == null) {
          if (hasDefault) {
            builder.errors.push({
              reason: `Expected at most one \`default\` branch in a switch statement, this code should have failed to parse`,
              severity: exports.ErrorSeverity.InvalidJS,
              loc: (_y = case_.node.loc) !== null && _y !== void 0 ? _y : null,
              suggestions: null,
            });
            break;
          }
          hasDefault = true;
        }
        const block = builder.enter('block', _blockId =>
          builder.switch(label, continuationBlock.id, () => {
            var _a;
            case_
              .get('consequent')
              .forEach(consequent => lowerStatement(builder, consequent));
            return {
              kind: 'goto',
              block: fallthrough,
              variant: GotoVariant.Break,
              id: makeInstructionId(0),
              loc:
                (_a = case_.node.loc) !== null && _a !== void 0
                  ? _a
                  : GeneratedSource,
            };
          })
        );
        let test = null;
        if (hasNode(testExpr)) {
          test = lowerReorderableExpression(builder, testExpr);
        }
        cases.push({test: test, block: block});
        fallthrough = block;
      }
      cases.reverse();
      if (!hasDefault) {
        cases.push({test: null, block: continuationBlock.id});
      }
      const test = lowerExpressionToTemporary(
        builder,
        stmt.get('discriminant')
      );
      builder.terminateWithContinuation(
        {
          kind: 'switch',
          test: test,
          cases: cases,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc:
            (_z = stmt.node.loc) !== null && _z !== void 0
              ? _z
              : GeneratedSource,
        },
        continuationBlock
      );
      return;
    }
    case 'VariableDeclaration': {
      const stmt = stmtPath;
      const nodeKind = stmt.node.kind;
      if (nodeKind === 'var') {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle ${nodeKind} kinds in VariableDeclaration`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_0 = stmt.node.loc) !== null && _0 !== void 0 ? _0 : null,
          suggestions: null,
        });
        return;
      }
      const kind =
        nodeKind === 'let' ? InstructionKind.Let : InstructionKind.Const;
      for (const declaration of stmt.get('declarations')) {
        const id = declaration.get('id');
        const init = declaration.get('init');
        if (hasNode(init)) {
          const value = lowerExpressionToTemporary(builder, init);
          lowerAssignment(
            builder,
            (_1 = stmt.node.loc) !== null && _1 !== void 0
              ? _1
              : GeneratedSource,
            kind,
            id,
            value,
            id.isObjectPattern() || id.isArrayPattern()
              ? 'Destructure'
              : 'Assignment'
          );
        } else if (id.isIdentifier()) {
          const binding = builder.resolveIdentifier(id);
          if (binding.kind !== 'Identifier') {
            builder.errors.push({
              reason: `(BuildHIR::lowerAssignment) Could not find binding for declaration.`,
              severity: exports.ErrorSeverity.Invariant,
              loc: (_2 = id.node.loc) !== null && _2 !== void 0 ? _2 : null,
              suggestions: null,
            });
          } else {
            const place = {
              effect: exports.Effect.Unknown,
              identifier: binding.identifier,
              kind: 'Identifier',
              reactive: false,
              loc:
                (_3 = id.node.loc) !== null && _3 !== void 0
                  ? _3
                  : GeneratedSource,
            };
            if (builder.isContextIdentifier(id)) {
              if (kind === InstructionKind.Const) {
                const declRangeStart = declaration.parentPath.node.start;
                builder.errors.push({
                  reason: `Expect \`const\` declaration not to be reassigned`,
                  severity: exports.ErrorSeverity.InvalidJS,
                  loc: (_4 = id.node.loc) !== null && _4 !== void 0 ? _4 : null,
                  suggestions: [
                    {
                      description: 'Change to a `let` declaration',
                      op: exports.CompilerSuggestionOperation.Replace,
                      range: [declRangeStart, declRangeStart + 5],
                      text: 'let',
                    },
                  ],
                });
              }
              lowerValueToTemporary(builder, {
                kind: 'DeclareContext',
                lvalue: {kind: InstructionKind.Let, place: place},
                loc:
                  (_5 = id.node.loc) !== null && _5 !== void 0
                    ? _5
                    : GeneratedSource,
              });
            } else {
              const typeAnnotation = id.get('typeAnnotation');
              let type;
              if (typeAnnotation.isTSTypeAnnotation()) {
                const typePath = typeAnnotation.get('typeAnnotation');
                type = typePath.node;
              } else if (typeAnnotation.isTypeAnnotation()) {
                const typePath = typeAnnotation.get('typeAnnotation');
                type = typePath.node;
              } else {
                type = null;
              }
              lowerValueToTemporary(builder, {
                kind: 'DeclareLocal',
                lvalue: {kind: kind, place: place},
                type: type,
                loc:
                  (_6 = id.node.loc) !== null && _6 !== void 0
                    ? _6
                    : GeneratedSource,
              });
            }
          }
        } else {
          builder.errors.push({
            reason: `Expected variable declaration to be an identifier if no initializer was provided`,
            description: `Got a \`${id.type}\``,
            severity: exports.ErrorSeverity.InvalidJS,
            loc: (_7 = stmt.node.loc) !== null && _7 !== void 0 ? _7 : null,
            suggestions: null,
          });
        }
      }
      return;
    }
    case 'ExpressionStatement': {
      const stmt = stmtPath;
      const expression = stmt.get('expression');
      lowerExpressionToTemporary(builder, expression);
      return;
    }
    case 'DoWhileStatement': {
      const stmt = stmtPath;
      const conditionalBlock = builder.reserve('loop');
      const continuationBlock = builder.reserve('block');
      const loopBlock = builder.enter('block', _loopBlockId =>
        builder.loop(label, conditionalBlock.id, continuationBlock.id, () => {
          var _a;
          const body = stmt.get('body');
          lowerStatement(builder, body);
          return {
            kind: 'goto',
            block: conditionalBlock.id,
            variant: GotoVariant.Continue,
            id: makeInstructionId(0),
            loc:
              (_a = body.node.loc) !== null && _a !== void 0
                ? _a
                : GeneratedSource,
          };
        })
      );
      const loc =
        (_8 = stmt.node.loc) !== null && _8 !== void 0 ? _8 : GeneratedSource;
      builder.terminateWithContinuation(
        {
          kind: 'do-while',
          loc: loc,
          test: conditionalBlock.id,
          loop: loopBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
        },
        conditionalBlock
      );
      const test = lowerExpressionToTemporary(builder, stmt.get('test'));
      const terminal = {
        kind: 'branch',
        test: test,
        consequent: loopBlock,
        alternate: continuationBlock.id,
        fallthrough: conditionalBlock.id,
        id: makeInstructionId(0),
        loc: loc,
      };
      builder.terminateWithContinuation(terminal, continuationBlock);
      return;
    }
    case 'FunctionDeclaration': {
      const stmt = stmtPath;
      stmt.skip();
      CompilerError.invariant(stmt.get('id').type === 'Identifier', {
        reason: 'function declarations must have a name',
        description: null,
        loc: (_9 = stmt.node.loc) !== null && _9 !== void 0 ? _9 : null,
        suggestions: null,
      });
      const id = stmt.get('id');
      const fn = lowerValueToTemporary(
        builder,
        lowerFunctionToValue(builder, stmt)
      );
      lowerAssignment(
        builder,
        (_10 = stmt.node.loc) !== null && _10 !== void 0
          ? _10
          : GeneratedSource,
        InstructionKind.Function,
        id,
        fn,
        'Assignment'
      );
      return;
    }
    case 'ForOfStatement': {
      const stmt = stmtPath;
      const continuationBlock = builder.reserve('block');
      const initBlock = builder.reserve('loop');
      const testBlock = builder.reserve('loop');
      if (stmt.node.await) {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle for-await loops`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_11 = stmt.node.loc) !== null && _11 !== void 0 ? _11 : null,
          suggestions: null,
        });
        return;
      }
      const loopBlock = builder.enter('block', _blockId =>
        builder.loop(label, initBlock.id, continuationBlock.id, () => {
          var _a;
          const body = stmt.get('body');
          lowerStatement(builder, body);
          return {
            kind: 'goto',
            block: initBlock.id,
            variant: GotoVariant.Continue,
            id: makeInstructionId(0),
            loc:
              (_a = body.node.loc) !== null && _a !== void 0
                ? _a
                : GeneratedSource,
          };
        })
      );
      const loc =
        (_12 = stmt.node.loc) !== null && _12 !== void 0
          ? _12
          : GeneratedSource;
      const value = lowerExpressionToTemporary(builder, stmt.get('right'));
      builder.terminateWithContinuation(
        {
          kind: 'for-of',
          loc: loc,
          init: initBlock.id,
          test: testBlock.id,
          loop: loopBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
        },
        initBlock
      );
      const iterator = lowerValueToTemporary(builder, {
        kind: 'GetIterator',
        loc: value.loc,
        collection: Object.assign({}, value),
      });
      builder.terminateWithContinuation(
        {
          id: makeInstructionId(0),
          kind: 'goto',
          block: testBlock.id,
          variant: GotoVariant.Break,
          loc:
            (_13 = stmt.node.loc) !== null && _13 !== void 0
              ? _13
              : GeneratedSource,
        },
        testBlock
      );
      const left = stmt.get('left');
      const leftLoc =
        (_14 = left.node.loc) !== null && _14 !== void 0
          ? _14
          : GeneratedSource;
      let test;
      if (left.isVariableDeclaration()) {
        const declarations = left.get('declarations');
        CompilerError.invariant(declarations.length === 1, {
          reason: `Expected only one declaration in the init of a ForOfStatement, got ${declarations.length}`,
          description: null,
          loc: (_15 = left.node.loc) !== null && _15 !== void 0 ? _15 : null,
          suggestions: null,
        });
        const id = declarations[0].get('id');
        const advanceIterator = lowerValueToTemporary(builder, {
          kind: 'IteratorNext',
          loc: leftLoc,
          iterator: Object.assign({}, iterator),
          collection: Object.assign({}, value),
        });
        const assign = lowerAssignment(
          builder,
          leftLoc,
          InstructionKind.Let,
          id,
          advanceIterator,
          'Assignment'
        );
        test = lowerValueToTemporary(builder, assign);
      } else {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle ${left.type} inits in ForOfStatement`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_16 = left.node.loc) !== null && _16 !== void 0 ? _16 : null,
          suggestions: null,
        });
        return;
      }
      builder.terminateWithContinuation(
        {
          id: makeInstructionId(0),
          kind: 'branch',
          test: test,
          consequent: loopBlock,
          alternate: continuationBlock.id,
          loc:
            (_17 = stmt.node.loc) !== null && _17 !== void 0
              ? _17
              : GeneratedSource,
          fallthrough: continuationBlock.id,
        },
        continuationBlock
      );
      return;
    }
    case 'ForInStatement': {
      const stmt = stmtPath;
      const continuationBlock = builder.reserve('block');
      const initBlock = builder.reserve('loop');
      const loopBlock = builder.enter('block', _blockId =>
        builder.loop(label, initBlock.id, continuationBlock.id, () => {
          var _a;
          const body = stmt.get('body');
          lowerStatement(builder, body);
          return {
            kind: 'goto',
            block: initBlock.id,
            variant: GotoVariant.Continue,
            id: makeInstructionId(0),
            loc:
              (_a = body.node.loc) !== null && _a !== void 0
                ? _a
                : GeneratedSource,
          };
        })
      );
      const loc =
        (_18 = stmt.node.loc) !== null && _18 !== void 0
          ? _18
          : GeneratedSource;
      const value = lowerExpressionToTemporary(builder, stmt.get('right'));
      builder.terminateWithContinuation(
        {
          kind: 'for-in',
          loc: loc,
          init: initBlock.id,
          loop: loopBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
        },
        initBlock
      );
      const left = stmt.get('left');
      const leftLoc =
        (_19 = left.node.loc) !== null && _19 !== void 0
          ? _19
          : GeneratedSource;
      let test;
      if (left.isVariableDeclaration()) {
        const declarations = left.get('declarations');
        CompilerError.invariant(declarations.length === 1, {
          reason: `Expected only one declaration in the init of a ForInStatement, got ${declarations.length}`,
          description: null,
          loc: (_20 = left.node.loc) !== null && _20 !== void 0 ? _20 : null,
          suggestions: null,
        });
        const id = declarations[0].get('id');
        const nextPropertyTemp = lowerValueToTemporary(builder, {
          kind: 'NextPropertyOf',
          loc: leftLoc,
          value: value,
        });
        const assign = lowerAssignment(
          builder,
          leftLoc,
          InstructionKind.Let,
          id,
          nextPropertyTemp,
          'Assignment'
        );
        test = lowerValueToTemporary(builder, assign);
      } else {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle ${left.type} inits in ForInStatement`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_21 = left.node.loc) !== null && _21 !== void 0 ? _21 : null,
          suggestions: null,
        });
        return;
      }
      builder.terminateWithContinuation(
        {
          id: makeInstructionId(0),
          kind: 'branch',
          test: test,
          consequent: loopBlock,
          alternate: continuationBlock.id,
          fallthrough: continuationBlock.id,
          loc:
            (_22 = stmt.node.loc) !== null && _22 !== void 0
              ? _22
              : GeneratedSource,
        },
        continuationBlock
      );
      return;
    }
    case 'DebuggerStatement': {
      const stmt = stmtPath;
      const loc =
        (_23 = stmt.node.loc) !== null && _23 !== void 0
          ? _23
          : GeneratedSource;
      builder.push({
        id: makeInstructionId(0),
        lvalue: buildTemporaryPlace(builder, loc),
        value: {kind: 'Debugger', loc: loc},
        loc: loc,
      });
      return;
    }
    case 'EmptyStatement': {
      return;
    }
    case 'TryStatement': {
      const stmt = stmtPath;
      const continuationBlock = builder.reserve('block');
      const handlerPath = stmt.get('handler');
      if (!hasNode(handlerPath)) {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle TryStatement without a catch clause`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_24 = stmt.node.loc) !== null && _24 !== void 0 ? _24 : null,
          suggestions: null,
        });
        return;
      }
      if (hasNode(stmt.get('finalizer'))) {
        builder.errors.push({
          reason: `(BuildHIR::lowerStatement) Handle TryStatement with a finalizer ('finally') clause`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_25 = stmt.node.loc) !== null && _25 !== void 0 ? _25 : null,
          suggestions: null,
        });
      }
      const handlerBindingPath = handlerPath.get('param');
      let handlerBinding = null;
      if (hasNode(handlerBindingPath)) {
        const place = {
          kind: 'Identifier',
          identifier: builder.makeTemporary(
            (_26 = handlerBindingPath.node.loc) !== null && _26 !== void 0
              ? _26
              : GeneratedSource
          ),
          effect: exports.Effect.Unknown,
          reactive: false,
          loc:
            (_27 = handlerBindingPath.node.loc) !== null && _27 !== void 0
              ? _27
              : GeneratedSource,
        };
        promoteTemporary(place.identifier);
        lowerValueToTemporary(builder, {
          kind: 'DeclareLocal',
          lvalue: {
            kind: InstructionKind.Catch,
            place: Object.assign({}, place),
          },
          type: null,
          loc:
            (_28 = handlerBindingPath.node.loc) !== null && _28 !== void 0
              ? _28
              : GeneratedSource,
        });
        handlerBinding = {path: handlerBindingPath, place: place};
      }
      const handler = builder.enter('catch', _blockId => {
        var _a, _b;
        if (handlerBinding !== null) {
          lowerAssignment(
            builder,
            (_a = handlerBinding.path.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
            InstructionKind.Catch,
            handlerBinding.path,
            Object.assign({}, handlerBinding.place),
            'Assignment'
          );
        }
        lowerStatement(builder, handlerPath.get('body'));
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc:
            (_b = handlerPath.node.loc) !== null && _b !== void 0
              ? _b
              : GeneratedSource,
        };
      });
      const block = builder.enter('block', _blockId => {
        var _a;
        const block = stmt.get('block');
        builder.enterTryCatch(handler, () => {
          lowerStatement(builder, block);
        });
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Try,
          id: makeInstructionId(0),
          loc:
            (_a = block.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
        };
      });
      builder.terminateWithContinuation(
        {
          kind: 'try',
          block: block,
          handlerBinding:
            handlerBinding !== null
              ? Object.assign({}, handlerBinding.place)
              : null,
          handler: handler,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc:
            (_29 = stmt.node.loc) !== null && _29 !== void 0
              ? _29
              : GeneratedSource,
        },
        continuationBlock
      );
      return;
    }
    case 'TypeAlias':
    case 'TSInterfaceDeclaration':
    case 'TSTypeAliasDeclaration': {
      return;
    }
    case 'ClassDeclaration':
    case 'DeclareClass':
    case 'DeclareExportAllDeclaration':
    case 'DeclareExportDeclaration':
    case 'DeclareFunction':
    case 'DeclareInterface':
    case 'DeclareModule':
    case 'DeclareModuleExports':
    case 'DeclareOpaqueType':
    case 'DeclareTypeAlias':
    case 'DeclareVariable':
    case 'EnumDeclaration':
    case 'ExportAllDeclaration':
    case 'ExportDefaultDeclaration':
    case 'ExportNamedDeclaration':
    case 'ImportDeclaration':
    case 'InterfaceDeclaration':
    case 'OpaqueType':
    case 'TSDeclareFunction':
    case 'TSEnumDeclaration':
    case 'TSExportAssignment':
    case 'TSImportEqualsDeclaration':
    case 'TSModuleDeclaration':
    case 'TSNamespaceExportDeclaration':
    case 'WithStatement': {
      builder.errors.push({
        reason: `(BuildHIR::lowerStatement) Handle ${stmtPath.type} statements`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_30 = stmtPath.node.loc) !== null && _30 !== void 0 ? _30 : null,
        suggestions: null,
      });
      lowerValueToTemporary(builder, {
        kind: 'UnsupportedNode',
        loc:
          (_31 = stmtPath.node.loc) !== null && _31 !== void 0
            ? _31
            : GeneratedSource,
        node: stmtPath.node,
      });
      return;
    }
    default: {
      return assertExhaustive(
        stmtNode,
        `Unsupported statement kind '${stmtNode.type}'`
      );
    }
  }
}
function lowerObjectMethod(builder, property) {
  var _a;
  const loc =
    (_a = property.node.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  const loweredFunc = lowerFunction(builder, property);
  if (!loweredFunc) {
    return {kind: 'UnsupportedNode', node: property.node, loc: loc};
  }
  return {kind: 'ObjectMethod', loc: loc, loweredFunc: loweredFunc};
}
function lowerObjectPropertyKey(builder, property) {
  var _a, _b;
  const key = property.get('key');
  if (key.isStringLiteral()) {
    return {kind: 'string', name: key.node.value};
  } else if (property.node.computed && key.isExpression()) {
    if (!key.isIdentifier() && !key.isMemberExpression()) {
      builder.errors.push({
        reason: `(BuildHIR::lowerExpression) Expected Identifier, got ${key.type} key in ObjectExpression`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_a = key.node.loc) !== null && _a !== void 0 ? _a : null,
        suggestions: null,
      });
      return null;
    }
    const place = lowerExpressionToTemporary(builder, key);
    return {kind: 'computed', name: place};
  } else if (key.isIdentifier()) {
    return {kind: 'identifier', name: key.node.name};
  }
  builder.errors.push({
    reason: `(BuildHIR::lowerExpression) Expected Identifier, got ${key.type} key in ObjectExpression`,
    severity: exports.ErrorSeverity.Todo,
    loc: (_b = key.node.loc) !== null && _b !== void 0 ? _b : null,
    suggestions: null,
  });
  return null;
}
function lowerExpression(builder, exprPath) {
  var _a,
    _b,
    _c,
    _d,
    _e,
    _f,
    _g,
    _h,
    _j,
    _k,
    _l,
    _m,
    _o,
    _p,
    _q,
    _r,
    _s,
    _t,
    _u,
    _v,
    _w,
    _x,
    _y,
    _z,
    _0,
    _1,
    _2,
    _3,
    _4,
    _5,
    _6,
    _7,
    _8,
    _9,
    _10,
    _11,
    _12,
    _13,
    _14,
    _15,
    _16,
    _17,
    _18,
    _19,
    _20,
    _21,
    _22,
    _23;
  const exprNode = exprPath.node;
  const exprLoc =
    (_a = exprNode.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  switch (exprNode.type) {
    case 'Identifier': {
      const expr = exprPath;
      const place = lowerIdentifier(builder, expr);
      return {kind: getLoadKind(builder, expr), place: place, loc: exprLoc};
    }
    case 'NullLiteral': {
      return {kind: 'Primitive', value: null, loc: exprLoc};
    }
    case 'BooleanLiteral':
    case 'NumericLiteral':
    case 'StringLiteral': {
      const expr = exprPath;
      const value = expr.node.value;
      return {kind: 'Primitive', value: value, loc: exprLoc};
    }
    case 'ObjectExpression': {
      const expr = exprPath;
      const propertyPaths = expr.get('properties');
      const properties = [];
      for (const propertyPath of propertyPaths) {
        if (propertyPath.isObjectProperty()) {
          const loweredKey = lowerObjectPropertyKey(builder, propertyPath);
          if (!loweredKey) {
            continue;
          }
          const valuePath = propertyPath.get('value');
          if (!valuePath.isExpression()) {
            builder.errors.push({
              reason: `(BuildHIR::lowerExpression) Handle ${valuePath.type} values in ObjectExpression`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_b = valuePath.node.loc) !== null && _b !== void 0 ? _b : null,
              suggestions: null,
            });
            continue;
          }
          const value = lowerExpressionToTemporary(builder, valuePath);
          properties.push({
            kind: 'ObjectProperty',
            type: 'property',
            place: value,
            key: loweredKey,
          });
        } else if (propertyPath.isSpreadElement()) {
          const place = lowerExpressionToTemporary(
            builder,
            propertyPath.get('argument')
          );
          properties.push({kind: 'Spread', place: place});
        } else if (propertyPath.isObjectMethod()) {
          if (propertyPath.node.kind !== 'method') {
            builder.errors.push({
              reason: `(BuildHIR::lowerExpression) Handle ${propertyPath.node.kind} functions in ObjectExpression`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_c = propertyPath.node.loc) !== null && _c !== void 0
                  ? _c
                  : null,
              suggestions: null,
            });
            continue;
          }
          const method = lowerObjectMethod(builder, propertyPath);
          const place = lowerValueToTemporary(builder, method);
          const loweredKey = lowerObjectPropertyKey(builder, propertyPath);
          if (!loweredKey) {
            continue;
          }
          properties.push({
            kind: 'ObjectProperty',
            type: 'method',
            place: place,
            key: loweredKey,
          });
        } else {
          builder.errors.push({
            reason: `(BuildHIR::lowerExpression) Handle ${propertyPath.type} properties in ObjectExpression`,
            severity: exports.ErrorSeverity.Todo,
            loc:
              (_d = propertyPath.node.loc) !== null && _d !== void 0
                ? _d
                : null,
            suggestions: null,
          });
          continue;
        }
      }
      return {kind: 'ObjectExpression', properties: properties, loc: exprLoc};
    }
    case 'ArrayExpression': {
      const expr = exprPath;
      let elements = [];
      for (const element of expr.get('elements')) {
        if (element.node == null) {
          elements.push({kind: 'Hole'});
          continue;
        } else if (element.isExpression()) {
          elements.push(lowerExpressionToTemporary(builder, element));
        } else if (element.isSpreadElement()) {
          const place = lowerExpressionToTemporary(
            builder,
            element.get('argument')
          );
          elements.push({kind: 'Spread', place: place});
        } else {
          builder.errors.push({
            reason: `(BuildHIR::lowerExpression) Handle ${element.type} elements in ArrayExpression`,
            severity: exports.ErrorSeverity.Todo,
            loc: (_e = element.node.loc) !== null && _e !== void 0 ? _e : null,
            suggestions: null,
          });
          continue;
        }
      }
      return {kind: 'ArrayExpression', elements: elements, loc: exprLoc};
    }
    case 'NewExpression': {
      const expr = exprPath;
      const calleePath = expr.get('callee');
      if (!calleePath.isExpression()) {
        builder.errors.push({
          reason: `Expected an expression as the \`new\` expression receiver (v8 intrinsics are not supported)`,
          description: `Got a \`${calleePath.node.type}\``,
          severity: exports.ErrorSeverity.InvalidJS,
          loc: (_f = calleePath.node.loc) !== null && _f !== void 0 ? _f : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      const callee = lowerExpressionToTemporary(builder, calleePath);
      const args = lowerArguments(builder, expr.get('arguments'));
      return {kind: 'NewExpression', callee: callee, args: args, loc: exprLoc};
    }
    case 'OptionalCallExpression': {
      const expr = exprPath;
      return lowerOptionalCallExpression(builder, expr, null);
    }
    case 'CallExpression': {
      const expr = exprPath;
      const calleePath = expr.get('callee');
      if (!calleePath.isExpression()) {
        builder.errors.push({
          reason: `Expected Expression, got ${calleePath.type} in CallExpression (v8 intrinsics not supported). This error is likely caused by a bug in React Compiler. Please file an issue`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_g = calleePath.node.loc) !== null && _g !== void 0 ? _g : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      if (calleePath.isMemberExpression()) {
        const memberExpr = lowerMemberExpression(builder, calleePath);
        const propertyPlace = lowerValueToTemporary(builder, memberExpr.value);
        const args = lowerArguments(builder, expr.get('arguments'));
        return {
          kind: 'MethodCall',
          receiver: memberExpr.object,
          property: Object.assign({}, propertyPlace),
          args: args,
          loc: exprLoc,
        };
      } else {
        const callee = lowerExpressionToTemporary(builder, calleePath);
        const args = lowerArguments(builder, expr.get('arguments'));
        return {
          kind: 'CallExpression',
          callee: callee,
          args: args,
          loc: exprLoc,
        };
      }
    }
    case 'BinaryExpression': {
      const expr = exprPath;
      const leftPath = expr.get('left');
      if (!leftPath.isExpression()) {
        builder.errors.push({
          reason: `(BuildHIR::lowerExpression) Expected Expression, got ${leftPath.type} lval in BinaryExpression`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_h = leftPath.node.loc) !== null && _h !== void 0 ? _h : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      const left = lowerExpressionToTemporary(builder, leftPath);
      const right = lowerExpressionToTemporary(builder, expr.get('right'));
      const operator = expr.node.operator;
      if (operator === '|>') {
        builder.errors.push({
          reason: `(BuildHIR::lowerExpression) Pipe operator not supported`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_j = leftPath.node.loc) !== null && _j !== void 0 ? _j : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      return {
        kind: 'BinaryExpression',
        operator: operator,
        left: left,
        right: right,
        loc: exprLoc,
      };
    }
    case 'SequenceExpression': {
      const expr = exprPath;
      const exprLoc =
        (_k = expr.node.loc) !== null && _k !== void 0 ? _k : GeneratedSource;
      const continuationBlock = builder.reserve(builder.currentBlockKind());
      const place = buildTemporaryPlace(builder, exprLoc);
      const sequenceBlock = builder.enter('sequence', _ => {
        var _a;
        let last = null;
        for (const item of expr.get('expressions')) {
          last = lowerExpressionToTemporary(builder, item);
        }
        if (last === null) {
          builder.errors.push({
            reason: `Expected sequence expression to have at least one expression`,
            severity: exports.ErrorSeverity.InvalidJS,
            loc: (_a = expr.node.loc) !== null && _a !== void 0 ? _a : null,
            suggestions: null,
          });
        } else {
          lowerValueToTemporary(builder, {
            kind: 'StoreLocal',
            lvalue: {
              kind: InstructionKind.Const,
              place: Object.assign({}, place),
            },
            value: last,
            type: null,
            loc: exprLoc,
          });
        }
        return {
          kind: 'goto',
          id: makeInstructionId(0),
          block: continuationBlock.id,
          loc: exprLoc,
          variant: GotoVariant.Break,
        };
      });
      builder.terminateWithContinuation(
        {
          kind: 'sequence',
          block: sequenceBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc: exprLoc,
        },
        continuationBlock
      );
      return {kind: 'LoadLocal', place: place, loc: place.loc};
    }
    case 'ConditionalExpression': {
      const expr = exprPath;
      const exprLoc =
        (_l = expr.node.loc) !== null && _l !== void 0 ? _l : GeneratedSource;
      const continuationBlock = builder.reserve(builder.currentBlockKind());
      const testBlock = builder.reserve('value');
      const place = buildTemporaryPlace(builder, exprLoc);
      const consequentBlock = builder.enter('value', _blockId => {
        var _a;
        const consequentPath = expr.get('consequent');
        const consequent = lowerExpressionToTemporary(builder, consequentPath);
        lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {
            kind: InstructionKind.Const,
            place: Object.assign({}, place),
          },
          value: consequent,
          type: null,
          loc: exprLoc,
        });
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc:
            (_a = consequentPath.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
        };
      });
      const alternateBlock = builder.enter('value', _blockId => {
        var _a;
        const alternatePath = expr.get('alternate');
        const alternate = lowerExpressionToTemporary(builder, alternatePath);
        lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {
            kind: InstructionKind.Const,
            place: Object.assign({}, place),
          },
          value: alternate,
          type: null,
          loc: exprLoc,
        });
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc:
            (_a = alternatePath.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
        };
      });
      builder.terminateWithContinuation(
        {
          kind: 'ternary',
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          test: testBlock.id,
          loc: exprLoc,
        },
        testBlock
      );
      const testPlace = lowerExpressionToTemporary(builder, expr.get('test'));
      builder.terminateWithContinuation(
        {
          kind: 'branch',
          test: Object.assign({}, testPlace),
          consequent: consequentBlock,
          alternate: alternateBlock,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc: exprLoc,
        },
        continuationBlock
      );
      return {kind: 'LoadLocal', place: place, loc: place.loc};
    }
    case 'LogicalExpression': {
      const expr = exprPath;
      const exprLoc =
        (_m = expr.node.loc) !== null && _m !== void 0 ? _m : GeneratedSource;
      const continuationBlock = builder.reserve(builder.currentBlockKind());
      const testBlock = builder.reserve('value');
      const place = buildTemporaryPlace(builder, exprLoc);
      const leftPlace = buildTemporaryPlace(
        builder,
        (_o = expr.get('left').node.loc) !== null && _o !== void 0
          ? _o
          : GeneratedSource
      );
      const consequent = builder.enter('value', () => {
        lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {
            kind: InstructionKind.Const,
            place: Object.assign({}, place),
          },
          value: Object.assign({}, leftPlace),
          type: null,
          loc: leftPlace.loc,
        });
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc: leftPlace.loc,
        };
      });
      const alternate = builder.enter('value', () => {
        const right = lowerExpressionToTemporary(builder, expr.get('right'));
        lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {
            kind: InstructionKind.Const,
            place: Object.assign({}, place),
          },
          value: Object.assign({}, right),
          type: null,
          loc: right.loc,
        });
        return {
          kind: 'goto',
          block: continuationBlock.id,
          variant: GotoVariant.Break,
          id: makeInstructionId(0),
          loc: right.loc,
        };
      });
      builder.terminateWithContinuation(
        {
          kind: 'logical',
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          test: testBlock.id,
          operator: expr.node.operator,
          loc: exprLoc,
        },
        testBlock
      );
      const leftValue = lowerExpressionToTemporary(builder, expr.get('left'));
      builder.push({
        id: makeInstructionId(0),
        lvalue: Object.assign({}, leftPlace),
        value: {kind: 'LoadLocal', place: leftValue, loc: exprLoc},
        loc: exprLoc,
      });
      builder.terminateWithContinuation(
        {
          kind: 'branch',
          test: Object.assign({}, leftPlace),
          consequent: consequent,
          alternate: alternate,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc: exprLoc,
        },
        continuationBlock
      );
      return {kind: 'LoadLocal', place: place, loc: place.loc};
    }
    case 'AssignmentExpression': {
      const expr = exprPath;
      const operator = expr.node.operator;
      if (operator === '=') {
        const left = expr.get('left');
        return lowerAssignment(
          builder,
          (_p = left.node.loc) !== null && _p !== void 0 ? _p : GeneratedSource,
          InstructionKind.Reassign,
          left,
          lowerExpressionToTemporary(builder, expr.get('right')),
          left.isArrayPattern() || left.isObjectPattern()
            ? 'Destructure'
            : 'Assignment'
        );
      }
      const operators = {
        '+=': '+',
        '-=': '-',
        '/=': '/',
        '%=': '%',
        '*=': '*',
        '**=': '**',
        '&=': '&',
        '|=': '|',
        '>>=': '>>',
        '>>>=': '>>>',
        '<<=': '<<',
        '^=': '^',
      };
      const binaryOperator = operators[operator];
      if (binaryOperator == null) {
        builder.errors.push({
          reason: `(BuildHIR::lowerExpression) Handle ${operator} operators in AssignmentExpression`,
          severity: exports.ErrorSeverity.Todo,
          loc: (_q = expr.node.loc) !== null && _q !== void 0 ? _q : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      const left = expr.get('left');
      const leftNode = left.node;
      switch (leftNode.type) {
        case 'Identifier': {
          const leftExpr = left;
          const leftPlace = lowerExpressionToTemporary(builder, leftExpr);
          const right = lowerExpressionToTemporary(builder, expr.get('right'));
          const binaryPlace = lowerValueToTemporary(builder, {
            kind: 'BinaryExpression',
            operator: binaryOperator,
            left: leftPlace,
            right: right,
            loc: exprLoc,
          });
          const binding = builder.resolveIdentifier(leftExpr);
          if (binding.kind === 'Identifier') {
            const identifier = lowerIdentifier(builder, leftExpr);
            const kind = getStoreKind(builder, leftExpr);
            if (kind === 'StoreLocal') {
              lowerValueToTemporary(builder, {
                kind: 'StoreLocal',
                lvalue: {
                  place: Object.assign({}, identifier),
                  kind: InstructionKind.Reassign,
                },
                value: Object.assign({}, binaryPlace),
                type: null,
                loc: exprLoc,
              });
              return {kind: 'LoadLocal', place: identifier, loc: exprLoc};
            } else {
              lowerValueToTemporary(builder, {
                kind: 'StoreContext',
                lvalue: {
                  place: Object.assign({}, identifier),
                  kind: InstructionKind.Reassign,
                },
                value: Object.assign({}, binaryPlace),
                loc: exprLoc,
              });
              return {kind: 'LoadContext', place: identifier, loc: exprLoc};
            }
          } else {
            const temporary = lowerValueToTemporary(builder, {
              kind: 'StoreGlobal',
              name: leftExpr.node.name,
              value: Object.assign({}, binaryPlace),
              loc: exprLoc,
            });
            return {kind: 'LoadLocal', place: temporary, loc: temporary.loc};
          }
        }
        case 'MemberExpression': {
          const leftExpr = left;
          const {
            object: object,
            property: property,
            value: value,
          } = lowerMemberExpression(builder, leftExpr);
          const previousValuePlace = lowerValueToTemporary(builder, value);
          const newValuePlace = lowerValueToTemporary(builder, {
            kind: 'BinaryExpression',
            operator: binaryOperator,
            left: Object.assign({}, previousValuePlace),
            right: lowerExpressionToTemporary(builder, expr.get('right')),
            loc:
              (_r = leftExpr.node.loc) !== null && _r !== void 0
                ? _r
                : GeneratedSource,
          });
          if (typeof property === 'string') {
            return {
              kind: 'PropertyStore',
              object: Object.assign({}, object),
              property: property,
              value: Object.assign({}, newValuePlace),
              loc:
                (_s = leftExpr.node.loc) !== null && _s !== void 0
                  ? _s
                  : GeneratedSource,
            };
          } else {
            return {
              kind: 'ComputedStore',
              object: Object.assign({}, object),
              property: Object.assign({}, property),
              value: Object.assign({}, newValuePlace),
              loc:
                (_t = leftExpr.node.loc) !== null && _t !== void 0
                  ? _t
                  : GeneratedSource,
            };
          }
        }
        default: {
          builder.errors.push({
            reason: `(BuildHIR::lowerExpression) Expected Identifier or MemberExpression, got ${expr.type} lval in AssignmentExpression`,
            severity: exports.ErrorSeverity.Todo,
            loc: (_u = expr.node.loc) !== null && _u !== void 0 ? _u : null,
            suggestions: null,
          });
          return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
        }
      }
    }
    case 'OptionalMemberExpression': {
      const expr = exprPath;
      const {value: value} = lowerOptionalMemberExpression(builder, expr, null);
      return {kind: 'LoadLocal', place: value, loc: value.loc};
    }
    case 'MemberExpression': {
      const expr = exprPath;
      const {value: value} = lowerMemberExpression(builder, expr);
      const place = lowerValueToTemporary(builder, value);
      return {kind: 'LoadLocal', place: place, loc: place.loc};
    }
    case 'JSXElement': {
      const expr = exprPath;
      const opening = expr.get('openingElement');
      const openingLoc =
        (_v = opening.node.loc) !== null && _v !== void 0
          ? _v
          : GeneratedSource;
      const tag = lowerJsxElementName(builder, opening.get('name'));
      const props = [];
      for (const attribute of opening.get('attributes')) {
        if (attribute.isJSXSpreadAttribute()) {
          const argument = lowerExpressionToTemporary(
            builder,
            attribute.get('argument')
          );
          props.push({kind: 'JsxSpreadAttribute', argument: argument});
          continue;
        }
        if (!attribute.isJSXAttribute()) {
          builder.errors.push({
            reason: `(BuildHIR::lowerExpression) Handle ${attribute.type} attributes in JSXElement`,
            severity: exports.ErrorSeverity.Todo,
            loc:
              (_w = attribute.node.loc) !== null && _w !== void 0 ? _w : null,
            suggestions: null,
          });
          continue;
        }
        const namePath = attribute.get('name');
        let propName;
        if (namePath.isJSXIdentifier()) {
          propName = namePath.node.name;
          if (propName.indexOf(':') !== -1) {
            builder.errors.push({
              reason: `(BuildHIR::lowerExpression) Unexpected colon in attribute name \`${name}\``,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_x = namePath.node.loc) !== null && _x !== void 0 ? _x : null,
              suggestions: null,
            });
          }
        } else {
          CompilerError.invariant(namePath.isJSXNamespacedName(), {
            reason: 'Refinement',
            description: null,
            loc: (_y = namePath.node.loc) !== null && _y !== void 0 ? _y : null,
            suggestions: null,
          });
          const namespace = namePath.node.namespace.name;
          const name = namePath.node.name.name;
          propName = `${namespace}:${name}`;
        }
        const valueExpr = attribute.get('value');
        let value;
        if (valueExpr.isJSXElement() || valueExpr.isStringLiteral()) {
          value = lowerExpressionToTemporary(builder, valueExpr);
        } else if (valueExpr.type == null) {
          value = lowerValueToTemporary(builder, {
            kind: 'Primitive',
            value: true,
            loc:
              (_z = attribute.node.loc) !== null && _z !== void 0
                ? _z
                : GeneratedSource,
          });
        } else {
          if (!valueExpr.isJSXExpressionContainer()) {
            builder.errors.push({
              reason: `(BuildHIR::lowerExpression) Handle ${valueExpr.type} attribute values in JSXElement`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_1 =
                  (_0 = valueExpr.node) === null || _0 === void 0
                    ? void 0
                    : _0.loc) !== null && _1 !== void 0
                  ? _1
                  : null,
              suggestions: null,
            });
            continue;
          }
          const expression = valueExpr.get('expression');
          if (!expression.isExpression()) {
            builder.errors.push({
              reason: `(BuildHIR::lowerExpression) Handle ${expression.type} expressions in JSXExpressionContainer within JSXElement`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_2 = valueExpr.node.loc) !== null && _2 !== void 0 ? _2 : null,
              suggestions: null,
            });
            continue;
          }
          value = lowerExpressionToTemporary(builder, expression);
        }
        props.push({kind: 'JsxAttribute', name: propName, place: value});
      }
      const isFbt =
        tag.kind === 'BuiltinTag' && (tag.name === 'fbt' || tag.name === 'fbs');
      if (isFbt) {
        const tagName = tag.name;
        const openingIdentifier = opening.get('name');
        const tagIdentifier = openingIdentifier.isJSXIdentifier()
          ? builder.resolveIdentifier(openingIdentifier)
          : null;
        if (tagIdentifier != null) {
          CompilerError.invariant(tagIdentifier.kind !== 'Identifier', {
            reason: `<${tagName}> tags should be module-level imports`,
            loc:
              (_3 = openingIdentifier.node.loc) !== null && _3 !== void 0
                ? _3
                : GeneratedSource,
            description: null,
            suggestions: null,
          });
        }
        const fbtLocations = {
          enum: new Array(),
          plural: new Array(),
          pronoun: new Array(),
        };
        expr.traverse({
          JSXClosingElement(path) {
            path.skip();
          },
          JSXNamespacedName(path) {
            var _a, _b, _c;
            if (path.node.namespace.name === tagName) {
              switch (path.node.name.name) {
                case 'enum':
                  fbtLocations.enum.push(
                    (_a = path.node.loc) !== null && _a !== void 0
                      ? _a
                      : GeneratedSource
                  );
                  break;
                case 'plural':
                  fbtLocations.plural.push(
                    (_b = path.node.loc) !== null && _b !== void 0
                      ? _b
                      : GeneratedSource
                  );
                  break;
                case 'pronoun':
                  fbtLocations.pronoun.push(
                    (_c = path.node.loc) !== null && _c !== void 0
                      ? _c
                      : GeneratedSource
                  );
                  break;
              }
            }
          },
        });
        for (const [name, locations] of Object.entries(fbtLocations)) {
          if (locations.length > 1) {
            CompilerError.throwTodo({
              reason: `Support <${tagName}> tags with multiple <${tagName}:${name}> values`,
              loc:
                (_4 = locations.at(-1)) !== null && _4 !== void 0
                  ? _4
                  : GeneratedSource,
              description: null,
              suggestions: null,
            });
          }
        }
      }
      isFbt && builder.fbtDepth++;
      const children = expr
        .get('children')
        .map(child => lowerJsxElement(builder, child))
        .filter(notNull);
      isFbt && builder.fbtDepth--;
      return {
        kind: 'JsxExpression',
        tag: tag,
        props: props,
        children: children.length === 0 ? null : children,
        loc: exprLoc,
        openingLoc: openingLoc,
        closingLoc:
          (_6 =
            (_5 = expr.get('closingElement').node) === null || _5 === void 0
              ? void 0
              : _5.loc) !== null && _6 !== void 0
            ? _6
            : GeneratedSource,
      };
    }
    case 'JSXFragment': {
      const expr = exprPath;
      const children = expr
        .get('children')
        .map(child => lowerJsxElement(builder, child))
        .filter(notNull);
      return {kind: 'JsxFragment', children: children, loc: exprLoc};
    }
    case 'ArrowFunctionExpression':
    case 'FunctionExpression': {
      const expr = exprPath;
      return lowerFunctionToValue(builder, expr);
    }
    case 'TaggedTemplateExpression': {
      const expr = exprPath;
      if (expr.get('quasi').get('expressions').length !== 0) {
        builder.errors.push({
          reason:
            '(BuildHIR::lowerExpression) Handle tagged template with interpolations',
          severity: exports.ErrorSeverity.Todo,
          loc: (_7 = exprPath.node.loc) !== null && _7 !== void 0 ? _7 : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      CompilerError.invariant(expr.get('quasi').get('quasis').length == 1, {
        reason:
          "there should be only one quasi as we don't support interpolations yet",
        description: null,
        loc: (_8 = expr.node.loc) !== null && _8 !== void 0 ? _8 : null,
        suggestions: null,
      });
      const value = expr.get('quasi').get('quasis').at(0).node.value;
      if (value.raw !== value.cooked) {
        builder.errors.push({
          reason:
            '(BuildHIR::lowerExpression) Handle tagged template where cooked value is different from raw value',
          severity: exports.ErrorSeverity.Todo,
          loc: (_9 = exprPath.node.loc) !== null && _9 !== void 0 ? _9 : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      return {
        kind: 'TaggedTemplateExpression',
        tag: lowerExpressionToTemporary(builder, expr.get('tag')),
        value: value,
        loc: exprLoc,
      };
    }
    case 'TemplateLiteral': {
      const expr = exprPath;
      const subexprs = expr.get('expressions');
      const quasis = expr.get('quasis');
      if (subexprs.length !== quasis.length - 1) {
        builder.errors.push({
          reason: `Unexpected quasi and subexpression lengths in template literal`,
          severity: exports.ErrorSeverity.InvalidJS,
          loc:
            (_10 = exprPath.node.loc) !== null && _10 !== void 0 ? _10 : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      if (subexprs.some(e => !e.isExpression())) {
        builder.errors.push({
          reason: `(BuildHIR::lowerAssignment) Handle TSType in TemplateLiteral.`,
          severity: exports.ErrorSeverity.Todo,
          loc:
            (_11 = exprPath.node.loc) !== null && _11 !== void 0 ? _11 : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      const subexprPlaces = subexprs.map(e =>
        lowerExpressionToTemporary(builder, e)
      );
      return {
        kind: 'TemplateLiteral',
        subexprs: subexprPlaces,
        quasis: expr.get('quasis').map(q => q.node.value),
        loc: exprLoc,
      };
    }
    case 'UnaryExpression': {
      let expr = exprPath;
      if (expr.node.operator === 'delete') {
        const argument = expr.get('argument');
        if (argument.isMemberExpression()) {
          const {object: object, property: property} = lowerMemberExpression(
            builder,
            argument
          );
          if (typeof property === 'string') {
            return {
              kind: 'PropertyDelete',
              object: object,
              property: property,
              loc: exprLoc,
            };
          } else {
            return {
              kind: 'ComputedDelete',
              object: object,
              property: property,
              loc: exprLoc,
            };
          }
        } else {
          builder.errors.push({
            reason: `Only object properties can be deleted`,
            severity: exports.ErrorSeverity.InvalidJS,
            loc: (_12 = expr.node.loc) !== null && _12 !== void 0 ? _12 : null,
            suggestions: [
              {
                description: 'Remove this line',
                range: [expr.node.start, expr.node.end],
                op: exports.CompilerSuggestionOperation.Remove,
              },
            ],
          });
          return {kind: 'UnsupportedNode', node: expr.node, loc: exprLoc};
        }
      } else if (expr.node.operator === 'throw') {
        builder.errors.push({
          reason: `Throw expressions are not supported`,
          severity: exports.ErrorSeverity.InvalidJS,
          loc: (_13 = expr.node.loc) !== null && _13 !== void 0 ? _13 : null,
          suggestions: [
            {
              description: 'Remove this line',
              range: [expr.node.start, expr.node.end],
              op: exports.CompilerSuggestionOperation.Remove,
            },
          ],
        });
        return {kind: 'UnsupportedNode', node: expr.node, loc: exprLoc};
      } else {
        return {
          kind: 'UnaryExpression',
          operator: expr.node.operator,
          value: lowerExpressionToTemporary(builder, expr.get('argument')),
          loc: exprLoc,
        };
      }
    }
    case 'AwaitExpression': {
      let expr = exprPath;
      return {
        kind: 'Await',
        value: lowerExpressionToTemporary(builder, expr.get('argument')),
        loc: exprLoc,
      };
    }
    case 'TypeCastExpression': {
      let expr = exprPath;
      const typeAnnotation = expr.get('typeAnnotation').get('typeAnnotation');
      return {
        kind: 'TypeCastExpression',
        value: lowerExpressionToTemporary(builder, expr.get('expression')),
        typeAnnotation: typeAnnotation.node,
        type: lowerType(typeAnnotation.node),
        loc: exprLoc,
      };
    }
    case 'TSAsExpression': {
      let expr = exprPath;
      const typeAnnotation = expr.get('typeAnnotation');
      return {
        kind: 'TypeCastExpression',
        value: lowerExpressionToTemporary(builder, expr.get('expression')),
        typeAnnotation: typeAnnotation.node,
        type: lowerType(typeAnnotation.node),
        loc: exprLoc,
      };
    }
    case 'UpdateExpression': {
      let expr = exprPath;
      const argument = expr.get('argument');
      if (argument.isMemberExpression()) {
        const binaryOperator = expr.node.operator === '++' ? '+' : '-';
        const leftExpr = argument;
        const {
          object: object,
          property: property,
          value: value,
        } = lowerMemberExpression(builder, leftExpr);
        const previousValuePlace = lowerValueToTemporary(builder, value);
        const updatedValue = lowerValueToTemporary(builder, {
          kind: 'BinaryExpression',
          operator: binaryOperator,
          left: Object.assign({}, previousValuePlace),
          right: lowerValueToTemporary(builder, {
            kind: 'Primitive',
            value: 1,
            loc: GeneratedSource,
          }),
          loc:
            (_14 = leftExpr.node.loc) !== null && _14 !== void 0
              ? _14
              : GeneratedSource,
        });
        let newValuePlace;
        if (typeof property === 'string') {
          newValuePlace = lowerValueToTemporary(builder, {
            kind: 'PropertyStore',
            object: Object.assign({}, object),
            property: property,
            value: Object.assign({}, updatedValue),
            loc:
              (_15 = leftExpr.node.loc) !== null && _15 !== void 0
                ? _15
                : GeneratedSource,
          });
        } else {
          newValuePlace = lowerValueToTemporary(builder, {
            kind: 'ComputedStore',
            object: Object.assign({}, object),
            property: Object.assign({}, property),
            value: Object.assign({}, updatedValue),
            loc:
              (_16 = leftExpr.node.loc) !== null && _16 !== void 0
                ? _16
                : GeneratedSource,
          });
        }
        return {
          kind: 'LoadLocal',
          place: expr.node.prefix
            ? Object.assign({}, newValuePlace)
            : Object.assign({}, previousValuePlace),
          loc: exprLoc,
        };
      }
      if (!argument.isIdentifier()) {
        builder.errors.push({
          reason: `(BuildHIR::lowerExpression) Handle UpdateExpression with ${argument.type} argument`,
          severity: exports.ErrorSeverity.Todo,
          loc:
            (_17 = exprPath.node.loc) !== null && _17 !== void 0 ? _17 : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      } else if (builder.isContextIdentifier(argument)) {
        builder.errors.push({
          reason: `(BuildHIR::lowerExpression) Handle UpdateExpression to variables captured within lambdas.`,
          severity: exports.ErrorSeverity.Todo,
          loc:
            (_18 = exprPath.node.loc) !== null && _18 !== void 0 ? _18 : null,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      const lvalue = lowerIdentifierForAssignment(
        builder,
        (_19 = argument.node.loc) !== null && _19 !== void 0
          ? _19
          : GeneratedSource,
        InstructionKind.Reassign,
        argument
      );
      if (lvalue === null) {
        if (!builder.errors.hasErrors()) {
          builder.errors.push({
            reason: `(BuildHIR::lowerExpression) Found an invalid UpdateExpression without a previously reported error`,
            severity: exports.ErrorSeverity.Invariant,
            loc: exprLoc,
            suggestions: null,
          });
        }
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      } else if (lvalue.kind === 'Global') {
        builder.errors.push({
          reason: `(BuildHIR::lowerExpression) Support UpdateExpression where argument is a global`,
          severity: exports.ErrorSeverity.Todo,
          loc: exprLoc,
          suggestions: null,
        });
        return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
      }
      const value = lowerIdentifier(builder, argument);
      if (expr.node.prefix) {
        return {
          kind: 'PrefixUpdate',
          lvalue: lvalue,
          operation: expr.node.operator,
          value: value,
          loc: exprLoc,
        };
      } else {
        return {
          kind: 'PostfixUpdate',
          lvalue: lvalue,
          operation: expr.node.operator,
          value: value,
          loc: exprLoc,
        };
      }
    }
    case 'RegExpLiteral': {
      let expr = exprPath;
      return {
        kind: 'RegExpLiteral',
        pattern: expr.node.pattern,
        flags: expr.node.flags,
        loc:
          (_20 = expr.node.loc) !== null && _20 !== void 0
            ? _20
            : GeneratedSource,
      };
    }
    case 'TSNonNullExpression': {
      let expr = exprPath;
      return lowerExpression(builder, expr.get('expression'));
    }
    case 'MetaProperty': {
      let expr = exprPath;
      if (
        expr.node.meta.name === 'import' &&
        expr.node.property.name === 'meta'
      ) {
        return {
          kind: 'MetaProperty',
          meta: expr.node.meta.name,
          property: expr.node.property.name,
          loc:
            (_21 = expr.node.loc) !== null && _21 !== void 0
              ? _21
              : GeneratedSource,
        };
      }
      builder.errors.push({
        reason: `(BuildHIR::lowerExpression) Handle MetaProperty expressions other than import.meta`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_22 = exprPath.node.loc) !== null && _22 !== void 0 ? _22 : null,
        suggestions: null,
      });
      return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
    }
    default: {
      builder.errors.push({
        reason: `(BuildHIR::lowerExpression) Handle ${exprPath.type} expressions`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_23 = exprPath.node.loc) !== null && _23 !== void 0 ? _23 : null,
        suggestions: null,
      });
      return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
    }
  }
}
function lowerOptionalMemberExpression(builder, expr, parentAlternate) {
  var _a;
  const optional = expr.node.optional;
  const loc =
    (_a = expr.node.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  const place = buildTemporaryPlace(builder, loc);
  const continuationBlock = builder.reserve(builder.currentBlockKind());
  const consequent = builder.reserve('value');
  const alternate =
    parentAlternate !== null
      ? parentAlternate
      : builder.enter('value', () => {
          const temp = lowerValueToTemporary(builder, {
            kind: 'Primitive',
            value: undefined,
            loc: loc,
          });
          lowerValueToTemporary(builder, {
            kind: 'StoreLocal',
            lvalue: {
              kind: InstructionKind.Const,
              place: Object.assign({}, place),
            },
            value: Object.assign({}, temp),
            type: null,
            loc: loc,
          });
          return {
            kind: 'goto',
            variant: GotoVariant.Break,
            block: continuationBlock.id,
            id: makeInstructionId(0),
            loc: loc,
          };
        });
  let object = null;
  const testBlock = builder.enter('value', () => {
    const objectPath = expr.get('object');
    if (objectPath.isOptionalMemberExpression()) {
      const {value: value} = lowerOptionalMemberExpression(
        builder,
        objectPath,
        alternate
      );
      object = value;
    } else if (objectPath.isOptionalCallExpression()) {
      const value = lowerOptionalCallExpression(builder, objectPath, alternate);
      object = lowerValueToTemporary(builder, value);
    } else {
      object = lowerExpressionToTemporary(builder, objectPath);
    }
    return {
      kind: 'branch',
      test: Object.assign({}, object),
      consequent: consequent.id,
      alternate: alternate,
      fallthrough: continuationBlock.id,
      id: makeInstructionId(0),
      loc: loc,
    };
  });
  CompilerError.invariant(object !== null, {
    reason: 'Satisfy type checker',
    description: null,
    loc: null,
    suggestions: null,
  });
  builder.enterReserved(consequent, () => {
    const {value: value} = lowerMemberExpression(builder, expr, object);
    const temp = lowerValueToTemporary(builder, value);
    lowerValueToTemporary(builder, {
      kind: 'StoreLocal',
      lvalue: {kind: InstructionKind.Const, place: Object.assign({}, place)},
      value: Object.assign({}, temp),
      type: null,
      loc: loc,
    });
    return {
      kind: 'goto',
      variant: GotoVariant.Break,
      block: continuationBlock.id,
      id: makeInstructionId(0),
      loc: loc,
    };
  });
  builder.terminateWithContinuation(
    {
      kind: 'optional',
      optional: optional,
      test: testBlock,
      fallthrough: continuationBlock.id,
      id: makeInstructionId(0),
      loc: loc,
    },
    continuationBlock
  );
  return {object: object, value: place};
}
function lowerOptionalCallExpression(builder, expr, parentAlternate) {
  var _a;
  const optional = expr.node.optional;
  const calleePath = expr.get('callee');
  const loc =
    (_a = expr.node.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  const place = buildTemporaryPlace(builder, loc);
  const continuationBlock = builder.reserve(builder.currentBlockKind());
  const consequent = builder.reserve('value');
  const alternate =
    parentAlternate !== null
      ? parentAlternate
      : builder.enter('value', () => {
          const temp = lowerValueToTemporary(builder, {
            kind: 'Primitive',
            value: undefined,
            loc: loc,
          });
          lowerValueToTemporary(builder, {
            kind: 'StoreLocal',
            lvalue: {
              kind: InstructionKind.Const,
              place: Object.assign({}, place),
            },
            value: Object.assign({}, temp),
            type: null,
            loc: loc,
          });
          return {
            kind: 'goto',
            variant: GotoVariant.Break,
            block: continuationBlock.id,
            id: makeInstructionId(0),
            loc: loc,
          };
        });
  let callee;
  const testBlock = builder.enter('value', () => {
    if (calleePath.isOptionalCallExpression()) {
      const value = lowerOptionalCallExpression(builder, calleePath, alternate);
      const valuePlace = lowerValueToTemporary(builder, value);
      callee = {kind: 'CallExpression', callee: valuePlace};
    } else if (calleePath.isOptionalMemberExpression()) {
      const {object: object, value: value} = lowerOptionalMemberExpression(
        builder,
        calleePath,
        alternate
      );
      callee = {kind: 'MethodCall', receiver: object, property: value};
    } else if (calleePath.isMemberExpression()) {
      const memberExpr = lowerMemberExpression(builder, calleePath);
      const propertyPlace = lowerValueToTemporary(builder, memberExpr.value);
      callee = {
        kind: 'MethodCall',
        receiver: memberExpr.object,
        property: propertyPlace,
      };
    } else {
      callee = {
        kind: 'CallExpression',
        callee: lowerExpressionToTemporary(builder, calleePath),
      };
    }
    const testPlace =
      callee.kind === 'CallExpression' ? callee.callee : callee.property;
    return {
      kind: 'branch',
      test: Object.assign({}, testPlace),
      consequent: consequent.id,
      alternate: alternate,
      fallthrough: continuationBlock.id,
      id: makeInstructionId(0),
      loc: loc,
    };
  });
  builder.enterReserved(consequent, () => {
    const args = lowerArguments(builder, expr.get('arguments'));
    const temp = buildTemporaryPlace(builder, loc);
    if (callee.kind === 'CallExpression') {
      builder.push({
        id: makeInstructionId(0),
        lvalue: Object.assign({}, temp),
        value: {
          kind: 'CallExpression',
          callee: Object.assign({}, callee.callee),
          args: args,
          loc: loc,
        },
        loc: loc,
      });
    } else {
      builder.push({
        id: makeInstructionId(0),
        lvalue: Object.assign({}, temp),
        value: {
          kind: 'MethodCall',
          receiver: Object.assign({}, callee.receiver),
          property: Object.assign({}, callee.property),
          args: args,
          loc: loc,
        },
        loc: loc,
      });
    }
    lowerValueToTemporary(builder, {
      kind: 'StoreLocal',
      lvalue: {kind: InstructionKind.Const, place: Object.assign({}, place)},
      value: Object.assign({}, temp),
      type: null,
      loc: loc,
    });
    return {
      kind: 'goto',
      variant: GotoVariant.Break,
      block: continuationBlock.id,
      id: makeInstructionId(0),
      loc: loc,
    };
  });
  builder.terminateWithContinuation(
    {
      kind: 'optional',
      optional: optional,
      test: testBlock,
      fallthrough: continuationBlock.id,
      id: makeInstructionId(0),
      loc: loc,
    },
    continuationBlock
  );
  return {kind: 'LoadLocal', place: place, loc: place.loc};
}
function lowerReorderableExpression(builder, expr) {
  var _a;
  if (!isReorderableExpression(builder, expr, true)) {
    builder.errors.push({
      reason: `(BuildHIR::node.lowerReorderableExpression) Expression type \`${expr.type}\` cannot be safely reordered`,
      severity: exports.ErrorSeverity.Todo,
      loc: (_a = expr.node.loc) !== null && _a !== void 0 ? _a : null,
      suggestions: null,
    });
  }
  return lowerExpressionToTemporary(builder, expr);
}
function isReorderableExpression(builder, expr, allowLocalIdentifiers) {
  switch (expr.node.type) {
    case 'Identifier': {
      const binding = builder.resolveIdentifier(expr);
      if (binding.kind === 'Identifier') {
        return allowLocalIdentifiers;
      } else {
        return true;
      }
    }
    case 'RegExpLiteral':
    case 'StringLiteral':
    case 'NumericLiteral':
    case 'NullLiteral':
    case 'BooleanLiteral':
    case 'BigIntLiteral': {
      return true;
    }
    case 'UnaryExpression': {
      const unary = expr;
      switch (expr.node.operator) {
        case '!':
        case '+':
        case '-': {
          return isReorderableExpression(
            builder,
            unary.get('argument'),
            allowLocalIdentifiers
          );
        }
        default: {
          return false;
        }
      }
    }
    case 'TypeCastExpression': {
      return isReorderableExpression(
        builder,
        expr.get('expression'),
        allowLocalIdentifiers
      );
    }
    case 'LogicalExpression': {
      const logical = expr;
      return (
        isReorderableExpression(
          builder,
          logical.get('left'),
          allowLocalIdentifiers
        ) &&
        isReorderableExpression(
          builder,
          logical.get('right'),
          allowLocalIdentifiers
        )
      );
    }
    case 'ConditionalExpression': {
      const conditional = expr;
      return (
        isReorderableExpression(
          builder,
          conditional.get('test'),
          allowLocalIdentifiers
        ) &&
        isReorderableExpression(
          builder,
          conditional.get('consequent'),
          allowLocalIdentifiers
        ) &&
        isReorderableExpression(
          builder,
          conditional.get('alternate'),
          allowLocalIdentifiers
        )
      );
    }
    case 'ArrayExpression': {
      return expr
        .get('elements')
        .every(
          element =>
            element.isExpression() &&
            isReorderableExpression(builder, element, allowLocalIdentifiers)
        );
    }
    case 'ObjectExpression': {
      return expr.get('properties').every(property => {
        if (!property.isObjectProperty() || property.node.computed) {
          return false;
        }
        const value = property.get('value');
        return (
          value.isExpression() &&
          isReorderableExpression(builder, value, allowLocalIdentifiers)
        );
      });
    }
    case 'MemberExpression': {
      const test = expr;
      let innerObject = test;
      while (innerObject.isMemberExpression()) {
        innerObject = innerObject.get('object');
      }
      if (
        innerObject.isIdentifier() &&
        builder.resolveIdentifier(innerObject).kind !== 'Identifier'
      ) {
        return true;
      } else {
        return false;
      }
    }
    case 'ArrowFunctionExpression': {
      const fn = expr;
      const body = fn.get('body');
      if (body.node.type === 'BlockStatement') {
        return body.node.body.length === 0;
      } else {
        invariant$1(body.isExpression(), 'Expected an expression');
        return isReorderableExpression(builder, body, false);
      }
    }
    case 'CallExpression': {
      const call = expr;
      const callee = call.get('callee');
      return (
        callee.isExpression() &&
        isReorderableExpression(builder, callee, allowLocalIdentifiers) &&
        call
          .get('arguments')
          .every(
            arg =>
              arg.isExpression() &&
              isReorderableExpression(builder, arg, allowLocalIdentifiers)
          )
      );
    }
    default: {
      return false;
    }
  }
}
function lowerArguments(builder, expr) {
  var _a;
  let args = [];
  for (const argPath of expr) {
    if (argPath.isSpreadElement()) {
      args.push({
        kind: 'Spread',
        place: lowerExpressionToTemporary(builder, argPath.get('argument')),
      });
    } else if (argPath.isExpression()) {
      args.push(lowerExpressionToTemporary(builder, argPath));
    } else {
      builder.errors.push({
        reason: `(BuildHIR::lowerExpression) Handle ${argPath.type} arguments in CallExpression`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_a = argPath.node.loc) !== null && _a !== void 0 ? _a : null,
        suggestions: null,
      });
    }
  }
  return args;
}
function lowerMemberExpression(builder, expr, loweredObject = null) {
  var _a, _b, _c;
  const exprNode = expr.node;
  const exprLoc =
    (_a = exprNode.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  const objectNode = expr.get('object');
  const propertyNode = expr.get('property');
  const object =
    loweredObject !== null && loweredObject !== void 0
      ? loweredObject
      : lowerExpressionToTemporary(builder, objectNode);
  if (!expr.node.computed) {
    if (!propertyNode.isIdentifier()) {
      builder.errors.push({
        reason: `(BuildHIR::lowerMemberExpression) Handle ${propertyNode.type} property`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_b = propertyNode.node.loc) !== null && _b !== void 0 ? _b : null,
        suggestions: null,
      });
      return {
        object: object,
        property: propertyNode.toString(),
        value: {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc},
      };
    }
    const value = {
      kind: 'PropertyLoad',
      object: Object.assign({}, object),
      property: propertyNode.node.name,
      loc: exprLoc,
    };
    return {object: object, property: propertyNode.node.name, value: value};
  } else {
    if (!propertyNode.isExpression()) {
      builder.errors.push({
        reason: `(BuildHIR::lowerMemberExpression) Expected Expression, got ${propertyNode.type} property`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_c = propertyNode.node.loc) !== null && _c !== void 0 ? _c : null,
        suggestions: null,
      });
      return {
        object: object,
        property: propertyNode.toString(),
        value: {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc},
      };
    }
    const property = lowerExpressionToTemporary(builder, propertyNode);
    const value = {
      kind: 'ComputedLoad',
      object: Object.assign({}, object),
      property: Object.assign({}, property),
      loc: exprLoc,
    };
    return {object: object, property: property, value: value};
  }
}
function lowerJsxElementName(builder, exprPath) {
  var _a, _b, _c;
  const exprNode = exprPath.node;
  const exprLoc =
    (_a = exprNode.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  if (exprPath.isJSXIdentifier()) {
    const tag = exprPath.node.name;
    if (tag.match(/^[A-Z]/)) {
      const kind = getLoadKind(builder, exprPath);
      return lowerValueToTemporary(builder, {
        kind: kind,
        place: lowerIdentifier(builder, exprPath),
        loc: exprLoc,
      });
    } else {
      return {kind: 'BuiltinTag', name: tag, loc: exprLoc};
    }
  } else if (exprPath.isJSXMemberExpression()) {
    return lowerJsxMemberExpression(builder, exprPath);
  } else if (exprPath.isJSXNamespacedName()) {
    const namespace = exprPath.node.namespace.name;
    const name = exprPath.node.name.name;
    const tag = `${namespace}:${name}`;
    if (namespace.indexOf(':') !== -1 || name.indexOf(':') !== -1) {
      builder.errors.push({
        reason: `Expected JSXNamespacedName to have no colons in the namespace or name`,
        description: `Got \`${namespace}\` : \`${name}\``,
        severity: exports.ErrorSeverity.InvalidJS,
        loc: (_b = exprPath.node.loc) !== null && _b !== void 0 ? _b : null,
        suggestions: null,
      });
    }
    const place = lowerValueToTemporary(builder, {
      kind: 'Primitive',
      value: tag,
      loc: exprLoc,
    });
    return place;
  } else {
    builder.errors.push({
      reason: `(BuildHIR::lowerJsxElementName) Handle ${exprPath.type} tags`,
      severity: exports.ErrorSeverity.Todo,
      loc: (_c = exprPath.node.loc) !== null && _c !== void 0 ? _c : null,
      suggestions: null,
    });
    return lowerValueToTemporary(builder, {
      kind: 'UnsupportedNode',
      node: exprNode,
      loc: exprLoc,
    });
  }
}
function lowerJsxMemberExpression(builder, exprPath) {
  var _a, _b, _c;
  const loc =
    (_a = exprPath.node.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  const object = exprPath.get('object');
  let objectPlace;
  if (object.isJSXMemberExpression()) {
    objectPlace = lowerJsxMemberExpression(builder, object);
  } else {
    CompilerError.invariant(object.isJSXIdentifier(), {
      reason: `TypeScript refinement fail: expected 'JsxIdentifier', got \`${object.node.type}\``,
      description: null,
      loc: (_b = object.node.loc) !== null && _b !== void 0 ? _b : null,
      suggestions: null,
    });
    const kind = getLoadKind(builder, object);
    objectPlace = lowerValueToTemporary(builder, {
      kind: kind,
      place: lowerIdentifier(builder, object),
      loc:
        (_c = exprPath.node.loc) !== null && _c !== void 0
          ? _c
          : GeneratedSource,
    });
  }
  const property = exprPath.get('property').node.name;
  return lowerValueToTemporary(builder, {
    kind: 'PropertyLoad',
    object: objectPlace,
    property: property,
    loc: loc,
  });
}
function lowerJsxElement(builder, exprPath) {
  var _a, _b, _c;
  const exprNode = exprPath.node;
  const exprLoc =
    (_a = exprNode.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  if (exprPath.isJSXElement() || exprPath.isJSXFragment()) {
    return lowerExpressionToTemporary(builder, exprPath);
  } else if (exprPath.isJSXExpressionContainer()) {
    const expression = exprPath.get('expression');
    if (expression.isJSXEmptyExpression()) {
      return null;
    } else {
      CompilerError.invariant(expression.isExpression(), {
        reason: `(BuildHIR::lowerJsxElement) Expected Expression but found ${expression.type}!`,
        description: null,
        loc: (_b = expression.node.loc) !== null && _b !== void 0 ? _b : null,
        suggestions: null,
      });
      return lowerExpressionToTemporary(builder, expression);
    }
  } else if (exprPath.isJSXText()) {
    let text;
    if (builder.fbtDepth > 0) {
      text = exprPath.node.value;
    } else {
      text = trimJsxText(exprPath.node.value);
    }
    if (text === null) {
      return null;
    }
    const place = lowerValueToTemporary(builder, {
      kind: 'JSXText',
      value: text,
      loc: exprLoc,
    });
    return place;
  } else {
    builder.errors.push({
      reason: `(BuildHIR::lowerJsxElement) Unhandled JsxElement, got: ${exprPath.type}`,
      severity: exports.ErrorSeverity.Todo,
      loc: (_c = exprPath.node.loc) !== null && _c !== void 0 ? _c : null,
      suggestions: null,
    });
    const place = lowerValueToTemporary(builder, {
      kind: 'UnsupportedNode',
      node: exprNode,
      loc: exprLoc,
    });
    return place;
  }
}
function trimJsxText(original) {
  const lines = original.split(/\r\n|\n|\r/);
  let lastNonEmptyLine = 0;
  for (let i = 0; i < lines.length; i++) {
    if (lines[i].match(/[^ \t]/)) {
      lastNonEmptyLine = i;
    }
  }
  let str = '';
  for (let i = 0; i < lines.length; i++) {
    const line = lines[i];
    const isFirstLine = i === 0;
    const isLastLine = i === lines.length - 1;
    const isLastNonEmptyLine = i === lastNonEmptyLine;
    let trimmedLine = line.replace(/\t/g, ' ');
    if (!isFirstLine) {
      trimmedLine = trimmedLine.replace(/^[ ]+/, '');
    }
    if (!isLastLine) {
      trimmedLine = trimmedLine.replace(/[ ]+$/, '');
    }
    if (trimmedLine) {
      if (!isLastNonEmptyLine) {
        trimmedLine += ' ';
      }
      str += trimmedLine;
    }
  }
  if (str.length !== 0) {
    return str;
  } else {
    return null;
  }
}
function lowerFunctionToValue(builder, expr) {
  var _a, _b, _c, _d;
  const exprNode = expr.node;
  const exprLoc =
    (_a = exprNode.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  let name = null;
  if (expr.isFunctionExpression()) {
    name =
      (_d =
        (_c =
          (_b = expr.get('id')) === null || _b === void 0
            ? void 0
            : _b.node) === null || _c === void 0
          ? void 0
          : _c.name) !== null && _d !== void 0
        ? _d
        : null;
  }
  const loweredFunc = lowerFunction(builder, expr);
  if (!loweredFunc) {
    return {kind: 'UnsupportedNode', node: exprNode, loc: exprLoc};
  }
  return {
    kind: 'FunctionExpression',
    name: name,
    type: expr.node.type,
    loc: exprLoc,
    loweredFunc: loweredFunc,
  };
}
function lowerFunction(builder, expr) {
  const componentScope = builder.parentFunction.scope;
  const captured = gatherCapturedDeps(builder, expr, componentScope);
  const lowering = lower$1(
    expr,
    builder.environment,
    builder.bindings,
    [...builder.context, ...captured.identifiers],
    builder.parentFunction
  );
  let loweredFunc;
  if (lowering.isErr()) {
    lowering
      .unwrapErr()
      .details.forEach(detail => builder.errors.pushErrorDetail(detail));
    return null;
  }
  loweredFunc = lowering.unwrap();
  return {func: loweredFunc, dependencies: captured.refs};
}
function lowerExpressionToTemporary(builder, exprPath) {
  const value = lowerExpression(builder, exprPath);
  return lowerValueToTemporary(builder, value);
}
function lowerValueToTemporary(builder, value) {
  if (value.kind === 'LoadLocal' && value.place.identifier.name === null) {
    return value.place;
  }
  const place = buildTemporaryPlace(builder, value.loc);
  builder.push({
    id: makeInstructionId(0),
    value: value,
    loc: value.loc,
    lvalue: Object.assign({}, place),
  });
  return place;
}
function lowerIdentifier(builder, exprPath) {
  var _a;
  const exprNode = exprPath.node;
  const exprLoc =
    (_a = exprNode.loc) !== null && _a !== void 0 ? _a : GeneratedSource;
  const binding = builder.resolveIdentifier(exprPath);
  switch (binding.kind) {
    case 'Identifier': {
      const place = {
        kind: 'Identifier',
        identifier: binding.identifier,
        effect: exports.Effect.Unknown,
        reactive: false,
        loc: exprLoc,
      };
      return place;
    }
    default: {
      return lowerValueToTemporary(builder, {
        kind: 'LoadGlobal',
        binding: binding,
        loc: exprLoc,
      });
    }
  }
}
function buildTemporaryPlace(builder, loc) {
  const place = {
    kind: 'Identifier',
    identifier: builder.makeTemporary(loc),
    effect: exports.Effect.Unknown,
    reactive: false,
    loc: loc,
  };
  return place;
}
function getStoreKind(builder, identifier) {
  const isContext = builder.isContextIdentifier(identifier);
  return isContext ? 'StoreContext' : 'StoreLocal';
}
function getLoadKind(builder, identifier) {
  const isContext = builder.isContextIdentifier(identifier);
  return isContext ? 'LoadContext' : 'LoadLocal';
}
function lowerIdentifierForAssignment(builder, loc, kind, path) {
  var _a, _b;
  const binding = builder.resolveIdentifier(path);
  if (binding.kind !== 'Identifier') {
    if (kind === InstructionKind.Reassign) {
      return {kind: 'Global', name: path.node.name};
    } else {
      builder.errors.push({
        reason: `(BuildHIR::lowerAssignment) Could not find binding for declaration.`,
        severity: exports.ErrorSeverity.Invariant,
        loc: (_a = path.node.loc) !== null && _a !== void 0 ? _a : null,
        suggestions: null,
      });
      return null;
    }
  } else if (
    binding.bindingKind === 'const' &&
    kind === InstructionKind.Reassign
  ) {
    builder.errors.push({
      reason: `Cannot reassign a \`const\` variable`,
      severity: exports.ErrorSeverity.InvalidJS,
      loc: (_b = path.node.loc) !== null && _b !== void 0 ? _b : null,
      description:
        binding.identifier.name != null
          ? `\`${binding.identifier.name.value}\` is declared as const`
          : null,
    });
    return null;
  }
  const place = {
    kind: 'Identifier',
    identifier: binding.identifier,
    effect: exports.Effect.Unknown,
    reactive: false,
    loc: loc,
  };
  return place;
}
function lowerAssignment(
  builder,
  loc,
  kind,
  lvaluePath,
  value,
  assignmentKind
) {
  var _a,
    _b,
    _c,
    _d,
    _e,
    _f,
    _g,
    _h,
    _j,
    _k,
    _l,
    _m,
    _o,
    _p,
    _q,
    _r,
    _s,
    _t,
    _u,
    _v,
    _w,
    _x,
    _y,
    _z,
    _0;
  const lvalueNode = lvaluePath.node;
  switch (lvalueNode.type) {
    case 'Identifier': {
      const lvalue = lvaluePath;
      const place = lowerIdentifierForAssignment(builder, loc, kind, lvalue);
      if (place === null) {
        return {
          kind: 'UnsupportedNode',
          loc:
            (_a = lvalue.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
          node: lvalue.node,
        };
      } else if (place.kind === 'Global') {
        const temporary = lowerValueToTemporary(builder, {
          kind: 'StoreGlobal',
          name: place.name,
          value: value,
          loc: loc,
        });
        return {kind: 'LoadLocal', place: temporary, loc: temporary.loc};
      }
      const isHoistedIdentifier = builder.environment.isHoistedIdentifier(
        lvalue.node
      );
      let temporary;
      if (builder.isContextIdentifier(lvalue)) {
        if (kind !== InstructionKind.Reassign && !isHoistedIdentifier) {
          if (kind === InstructionKind.Const) {
            builder.errors.push({
              reason: `Expected \`const\` declaration not to be reassigned`,
              severity: exports.ErrorSeverity.InvalidJS,
              loc: (_b = lvalue.node.loc) !== null && _b !== void 0 ? _b : null,
              suggestions: null,
            });
          }
          lowerValueToTemporary(builder, {
            kind: 'DeclareContext',
            lvalue: {
              kind: InstructionKind.Let,
              place: Object.assign({}, place),
            },
            loc: place.loc,
          });
        }
        temporary = lowerValueToTemporary(builder, {
          kind: 'StoreContext',
          lvalue: {
            place: Object.assign({}, place),
            kind: InstructionKind.Reassign,
          },
          value: value,
          loc: loc,
        });
      } else {
        const typeAnnotation = lvalue.get('typeAnnotation');
        let type;
        if (typeAnnotation.isTSTypeAnnotation()) {
          const typePath = typeAnnotation.get('typeAnnotation');
          type = typePath.node;
        } else if (typeAnnotation.isTypeAnnotation()) {
          const typePath = typeAnnotation.get('typeAnnotation');
          type = typePath.node;
        } else {
          type = null;
        }
        temporary = lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {place: Object.assign({}, place), kind: kind},
          value: value,
          type: type,
          loc: loc,
        });
      }
      return {kind: 'LoadLocal', place: temporary, loc: temporary.loc};
    }
    case 'MemberExpression': {
      CompilerError.invariant(kind === InstructionKind.Reassign, {
        reason: 'MemberExpression may only appear in an assignment expression',
        description: null,
        loc: (_c = lvaluePath.node.loc) !== null && _c !== void 0 ? _c : null,
        suggestions: null,
      });
      const lvalue = lvaluePath;
      const property = lvalue.get('property');
      const object = lowerExpressionToTemporary(builder, lvalue.get('object'));
      if (!lvalue.node.computed) {
        if (!property.isIdentifier()) {
          builder.errors.push({
            reason: `(BuildHIR::lowerAssignment) Handle ${property.type} properties in MemberExpression`,
            severity: exports.ErrorSeverity.Todo,
            loc: (_d = property.node.loc) !== null && _d !== void 0 ? _d : null,
            suggestions: null,
          });
          return {kind: 'UnsupportedNode', node: lvalueNode, loc: loc};
        }
        const temporary = lowerValueToTemporary(builder, {
          kind: 'PropertyStore',
          object: object,
          property: property.node.name,
          value: value,
          loc: loc,
        });
        return {kind: 'LoadLocal', place: temporary, loc: temporary.loc};
      } else {
        if (!property.isExpression()) {
          builder.errors.push({
            reason:
              '(BuildHIR::lowerAssignment) Expected private name to appear as a non-computed property',
            severity: exports.ErrorSeverity.Todo,
            loc: (_e = property.node.loc) !== null && _e !== void 0 ? _e : null,
            suggestions: null,
          });
          return {kind: 'UnsupportedNode', node: lvalueNode, loc: loc};
        }
        const propertyPlace = lowerExpressionToTemporary(builder, property);
        const temporary = lowerValueToTemporary(builder, {
          kind: 'ComputedStore',
          object: object,
          property: propertyPlace,
          value: value,
          loc: loc,
        });
        return {kind: 'LoadLocal', place: temporary, loc: temporary.loc};
      }
    }
    case 'ArrayPattern': {
      const lvalue = lvaluePath;
      const elements = lvalue.get('elements');
      const items = [];
      const followups = [];
      const forceTemporaries =
        kind === InstructionKind.Reassign &&
        (elements.some(element => !element.isIdentifier()) ||
          elements.some(
            element =>
              element.isIdentifier() &&
              (getStoreKind(builder, element) !== 'StoreLocal' ||
                builder.resolveIdentifier(element).kind !== 'Identifier')
          ));
      for (let i = 0; i < elements.length; i++) {
        const element = elements[i];
        if (element.node == null) {
          items.push({kind: 'Hole'});
          continue;
        }
        if (element.isRestElement()) {
          const argument = element.get('argument');
          if (
            argument.isIdentifier() &&
            !forceTemporaries &&
            (assignmentKind === 'Assignment' ||
              getStoreKind(builder, argument) === 'StoreLocal')
          ) {
            const identifier = lowerIdentifierForAssignment(
              builder,
              (_f = element.node.loc) !== null && _f !== void 0
                ? _f
                : GeneratedSource,
              kind,
              argument
            );
            if (identifier === null) {
              continue;
            } else if (identifier.kind === 'Global') {
              builder.errors.push({
                severity: exports.ErrorSeverity.Todo,
                reason:
                  'Expected reassignment of globals to enable forceTemporaries',
                loc:
                  (_g = element.node.loc) !== null && _g !== void 0
                    ? _g
                    : GeneratedSource,
              });
              continue;
            }
            items.push({kind: 'Spread', place: identifier});
          } else {
            const temp = buildTemporaryPlace(
              builder,
              (_h = element.node.loc) !== null && _h !== void 0
                ? _h
                : GeneratedSource
            );
            promoteTemporary(temp.identifier);
            items.push({kind: 'Spread', place: Object.assign({}, temp)});
            followups.push({place: temp, path: argument});
          }
        } else if (
          element.isIdentifier() &&
          !forceTemporaries &&
          (assignmentKind === 'Assignment' ||
            getStoreKind(builder, element) === 'StoreLocal')
        ) {
          const identifier = lowerIdentifierForAssignment(
            builder,
            (_j = element.node.loc) !== null && _j !== void 0
              ? _j
              : GeneratedSource,
            kind,
            element
          );
          if (identifier === null) {
            continue;
          } else if (identifier.kind === 'Global') {
            builder.errors.push({
              severity: exports.ErrorSeverity.Todo,
              reason:
                'Expected reassignment of globals to enable forceTemporaries',
              loc:
                (_k = element.node.loc) !== null && _k !== void 0
                  ? _k
                  : GeneratedSource,
            });
            continue;
          }
          items.push(identifier);
        } else {
          const temp = buildTemporaryPlace(
            builder,
            (_l = element.node.loc) !== null && _l !== void 0
              ? _l
              : GeneratedSource
          );
          promoteTemporary(temp.identifier);
          items.push(Object.assign({}, temp));
          followups.push({place: temp, path: element});
        }
      }
      const temporary = lowerValueToTemporary(builder, {
        kind: 'Destructure',
        lvalue: {kind: kind, pattern: {kind: 'ArrayPattern', items: items}},
        value: value,
        loc: loc,
      });
      for (const {place: place, path: path} of followups) {
        lowerAssignment(
          builder,
          (_m = path.node.loc) !== null && _m !== void 0 ? _m : loc,
          kind,
          path,
          place,
          assignmentKind
        );
      }
      return {kind: 'LoadLocal', place: temporary, loc: value.loc};
    }
    case 'ObjectPattern': {
      const lvalue = lvaluePath;
      const propertiesPaths = lvalue.get('properties');
      const properties = [];
      const followups = [];
      const forceTemporaries =
        kind === InstructionKind.Reassign &&
        propertiesPaths.some(
          property =>
            property.isRestElement() ||
            (property.isObjectProperty() &&
              (!property.get('value').isIdentifier() ||
                builder.resolveIdentifier(property.get('value')).kind !==
                  'Identifier'))
        );
      for (let i = 0; i < propertiesPaths.length; i++) {
        const property = propertiesPaths[i];
        if (property.isRestElement()) {
          const argument = property.get('argument');
          if (!argument.isIdentifier()) {
            builder.errors.push({
              reason: `(BuildHIR::lowerAssignment) Handle ${argument.node.type} rest element in ObjectPattern`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_o = argument.node.loc) !== null && _o !== void 0 ? _o : null,
              suggestions: null,
            });
            continue;
          }
          if (
            forceTemporaries ||
            getStoreKind(builder, argument) === 'StoreContext'
          ) {
            const temp = buildTemporaryPlace(
              builder,
              (_p = property.node.loc) !== null && _p !== void 0
                ? _p
                : GeneratedSource
            );
            promoteTemporary(temp.identifier);
            properties.push({kind: 'Spread', place: Object.assign({}, temp)});
            followups.push({place: temp, path: argument});
          } else {
            const identifier = lowerIdentifierForAssignment(
              builder,
              (_q = property.node.loc) !== null && _q !== void 0
                ? _q
                : GeneratedSource,
              kind,
              argument
            );
            if (identifier === null) {
              continue;
            } else if (identifier.kind === 'Global') {
              builder.errors.push({
                severity: exports.ErrorSeverity.Todo,
                reason:
                  'Expected reassignment of globals to enable forceTemporaries',
                loc:
                  (_r = property.node.loc) !== null && _r !== void 0
                    ? _r
                    : GeneratedSource,
              });
              continue;
            }
            properties.push({kind: 'Spread', place: identifier});
          }
        } else {
          if (!property.isObjectProperty()) {
            builder.errors.push({
              reason: `(BuildHIR::lowerAssignment) Handle ${property.type} properties in ObjectPattern`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_s = property.node.loc) !== null && _s !== void 0 ? _s : null,
              suggestions: null,
            });
            continue;
          }
          if (property.node.computed) {
            builder.errors.push({
              reason: `(BuildHIR::lowerAssignment) Handle computed properties in ObjectPattern`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_t = property.node.loc) !== null && _t !== void 0 ? _t : null,
              suggestions: null,
            });
            continue;
          }
          const loweredKey = lowerObjectPropertyKey(builder, property);
          if (!loweredKey) {
            continue;
          }
          const element = property.get('value');
          if (!element.isLVal()) {
            builder.errors.push({
              reason: `(BuildHIR::lowerAssignment) Expected object property value to be an LVal, got: ${element.type}`,
              severity: exports.ErrorSeverity.Todo,
              loc:
                (_u = element.node.loc) !== null && _u !== void 0 ? _u : null,
              suggestions: null,
            });
            continue;
          }
          if (
            element.isIdentifier() &&
            !forceTemporaries &&
            (assignmentKind === 'Assignment' ||
              getStoreKind(builder, element) === 'StoreLocal')
          ) {
            const identifier = lowerIdentifierForAssignment(
              builder,
              (_v = element.node.loc) !== null && _v !== void 0
                ? _v
                : GeneratedSource,
              kind,
              element
            );
            if (identifier === null) {
              continue;
            } else if (identifier.kind === 'Global') {
              builder.errors.push({
                severity: exports.ErrorSeverity.Todo,
                reason:
                  'Expected reassignment of globals to enable forceTemporaries',
                loc:
                  (_w = element.node.loc) !== null && _w !== void 0
                    ? _w
                    : GeneratedSource,
              });
              continue;
            }
            properties.push({
              kind: 'ObjectProperty',
              type: 'property',
              place: identifier,
              key: loweredKey,
            });
          } else {
            const temp = buildTemporaryPlace(
              builder,
              (_x = element.node.loc) !== null && _x !== void 0
                ? _x
                : GeneratedSource
            );
            promoteTemporary(temp.identifier);
            properties.push({
              kind: 'ObjectProperty',
              type: 'property',
              place: Object.assign({}, temp),
              key: loweredKey,
            });
            followups.push({place: temp, path: element});
          }
        }
      }
      const temporary = lowerValueToTemporary(builder, {
        kind: 'Destructure',
        lvalue: {
          kind: kind,
          pattern: {kind: 'ObjectPattern', properties: properties},
        },
        value: value,
        loc: loc,
      });
      for (const {place: place, path: path} of followups) {
        lowerAssignment(
          builder,
          (_y = path.node.loc) !== null && _y !== void 0 ? _y : loc,
          kind,
          path,
          place,
          assignmentKind
        );
      }
      return {kind: 'LoadLocal', place: temporary, loc: value.loc};
    }
    case 'AssignmentPattern': {
      const lvalue = lvaluePath;
      const loc =
        (_z = lvalue.node.loc) !== null && _z !== void 0 ? _z : GeneratedSource;
      const temp = buildTemporaryPlace(builder, loc);
      const testBlock = builder.reserve('value');
      const continuationBlock = builder.reserve(builder.currentBlockKind());
      const consequent = builder.enter('value', () => {
        const defaultValue = lowerReorderableExpression(
          builder,
          lvalue.get('right')
        );
        lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {kind: InstructionKind.Const, place: Object.assign({}, temp)},
          value: Object.assign({}, defaultValue),
          type: null,
          loc: loc,
        });
        return {
          kind: 'goto',
          variant: GotoVariant.Break,
          block: continuationBlock.id,
          id: makeInstructionId(0),
          loc: loc,
        };
      });
      const alternate = builder.enter('value', () => {
        lowerValueToTemporary(builder, {
          kind: 'StoreLocal',
          lvalue: {kind: InstructionKind.Const, place: Object.assign({}, temp)},
          value: Object.assign({}, value),
          type: null,
          loc: loc,
        });
        return {
          kind: 'goto',
          variant: GotoVariant.Break,
          block: continuationBlock.id,
          id: makeInstructionId(0),
          loc: loc,
        };
      });
      builder.terminateWithContinuation(
        {
          kind: 'ternary',
          test: testBlock.id,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc: loc,
        },
        testBlock
      );
      const undef = lowerValueToTemporary(builder, {
        kind: 'Primitive',
        value: undefined,
        loc: loc,
      });
      const test = lowerValueToTemporary(builder, {
        kind: 'BinaryExpression',
        left: Object.assign({}, value),
        operator: '===',
        right: Object.assign({}, undef),
        loc: loc,
      });
      builder.terminateWithContinuation(
        {
          kind: 'branch',
          test: Object.assign({}, test),
          consequent: consequent,
          alternate: alternate,
          fallthrough: continuationBlock.id,
          id: makeInstructionId(0),
          loc: loc,
        },
        continuationBlock
      );
      return lowerAssignment(
        builder,
        loc,
        kind,
        lvalue.get('left'),
        temp,
        assignmentKind
      );
    }
    default: {
      builder.errors.push({
        reason: `(BuildHIR::lowerAssignment) Handle ${lvaluePath.type} assignments`,
        severity: exports.ErrorSeverity.Todo,
        loc: (_0 = lvaluePath.node.loc) !== null && _0 !== void 0 ? _0 : null,
        suggestions: null,
      });
      return {kind: 'UnsupportedNode', node: lvalueNode, loc: loc};
    }
  }
}
function isValidDependency(path) {
  const parent = path.parentPath;
  return (
    !path.node.computed &&
    !(parent.isCallExpression() && parent.get('callee') === path)
  );
}
function captureScopes({from: from, to: to}) {
  let scopes = new Set();
  while (from) {
    scopes.add(from);
    if (from === to) {
      break;
    }
    from = from.parent;
  }
  return scopes;
}
function gatherCapturedDeps(builder, fn, componentScope) {
  const capturedIds = new Map();
  const capturedRefs = new Set();
  const seenPaths = new Set();
  const pureScopes = captureScopes({from: fn.scope.parent, to: componentScope});
  function addCapturedId(bindingIdentifier) {
    if (!capturedIds.has(bindingIdentifier)) {
      const index = capturedIds.size;
      capturedIds.set(bindingIdentifier, index);
      return index;
    } else {
      return capturedIds.get(bindingIdentifier);
    }
  }
  function handleMaybeDependency(path) {
    var _a;
    let baseIdentifier;
    let dependency;
    if (path.isJSXOpeningElement()) {
      const name = path.get('name');
      if (!(name.isJSXMemberExpression() || name.isJSXIdentifier())) {
        return;
      }
      let current = name;
      while (current.isJSXMemberExpression()) {
        current = current.get('object');
      }
      invariant$1(
        current.isJSXIdentifier(),
        'Invalid logic in gatherCapturedDeps'
      );
      baseIdentifier = current;
      let currentDep = baseIdentifier;
      while (true) {
        const nextDep = currentDep.parentPath;
        if (nextDep && nextDep.isJSXMemberExpression()) {
          currentDep = nextDep;
        } else {
          break;
        }
      }
      dependency = currentDep;
    } else if (path.isMemberExpression()) {
      let currentId = path;
      while (currentId.isMemberExpression()) {
        currentId = currentId.get('object');
      }
      if (!currentId.isIdentifier()) {
        return;
      }
      baseIdentifier = currentId;
      let currentDep = baseIdentifier;
      while (true) {
        const nextDep = currentDep.parentPath;
        if (
          nextDep &&
          nextDep.isMemberExpression() &&
          isValidDependency(nextDep)
        ) {
          currentDep = nextDep;
        } else {
          break;
        }
      }
      dependency = currentDep;
    } else {
      baseIdentifier = path;
      dependency = path;
    }
    dependency.skip();
    const binding = baseIdentifier.scope.getBinding(baseIdentifier.node.name);
    if (binding === undefined || !pureScopes.has(binding.scope)) {
      return;
    }
    const idKey = String(addCapturedId(binding.identifier));
    let exprKey = idKey;
    if (dependency.isMemberExpression()) {
      let pathTokens = [];
      let current = dependency;
      while (current.isMemberExpression()) {
        const property = current.get('property');
        pathTokens.push(property.node.name);
        current = current.get('object');
      }
      exprKey += '.' + pathTokens.reverse().join('.');
    } else if (dependency.isJSXMemberExpression()) {
      let pathTokens = [];
      let current = dependency;
      while (current.isJSXMemberExpression()) {
        const property = current.get('property');
        pathTokens.push(property.node.name);
        current = current.get('object');
      }
    }
    if (!seenPaths.has(exprKey)) {
      let loweredDep;
      if (dependency.isJSXIdentifier()) {
        loweredDep = lowerValueToTemporary(builder, {
          kind: 'LoadLocal',
          place: lowerIdentifier(builder, dependency),
          loc:
            (_a = path.node.loc) !== null && _a !== void 0
              ? _a
              : GeneratedSource,
        });
      } else if (dependency.isJSXMemberExpression()) {
        loweredDep = lowerJsxMemberExpression(builder, dependency);
      } else {
        loweredDep = lowerExpressionToTemporary(builder, dependency);
      }
      capturedRefs.add(loweredDep);
      seenPaths.add(exprKey);
    }
  }
  fn.traverse({
    TypeAnnotation(path) {
      path.skip();
    },
    TSTypeAnnotation(path) {
      path.skip();
    },
    TypeAlias(path) {
      path.skip();
    },
    TSTypeAliasDeclaration(path) {
      path.skip();
    },
    Expression(path) {
      if (path.isAssignmentExpression()) {
        const left = path.get('left');
        if (left.isIdentifier()) {
          handleMaybeDependency(left);
        }
        return;
      } else if (path.isJSXElement()) {
        handleMaybeDependency(path.get('openingElement'));
      } else if (path.isMemberExpression() || path.isIdentifier()) {
        handleMaybeDependency(path);
      }
    },
  });
  return {identifiers: [...capturedIds.keys()], refs: [...capturedRefs]};
}
function notNull(value) {
  return value !== null;
}
function lowerType(node) {
  switch (node.type) {
    case 'GenericTypeAnnotation': {
      const id = node.id;
      if (id.type === 'Identifier' && id.name === 'Array') {
        return {kind: 'Object', shapeId: BuiltInArrayId};
      }
      return makeType();
    }
    case 'TSTypeReference': {
      const typeName = node.typeName;
      if (typeName.type === 'Identifier' && typeName.name === 'Array') {
        return {kind: 'Object', shapeId: BuiltInArrayId};
      }
      return makeType();
    }
    case 'ArrayTypeAnnotation':
    case 'TSArrayType': {
      return {kind: 'Object', shapeId: BuiltInArrayId};
    }
    case 'BooleanLiteralTypeAnnotation':
    case 'BooleanTypeAnnotation':
    case 'NullLiteralTypeAnnotation':
    case 'NumberLiteralTypeAnnotation':
    case 'NumberTypeAnnotation':
    case 'StringLiteralTypeAnnotation':
    case 'StringTypeAnnotation':
    case 'TSBooleanKeyword':
    case 'TSNullKeyword':
    case 'TSNumberKeyword':
    case 'TSStringKeyword':
    case 'TSSymbolKeyword':
    case 'TSUndefinedKeyword':
    case 'TSVoidKeyword':
    case 'VoidTypeAnnotation': {
      return {kind: 'Primitive'};
    }
    default: {
      return makeType();
    }
  }
}
function buildReactiveScopeTerminalsHIR(fn) {
  const queuedRewrites = [];
  recursivelyTraverseItems(
    [...getScopes(fn)],
    scope => scope.range,
    {fallthroughs: new Map(), rewrites: queuedRewrites, env: fn.env},
    pushStartScopeTerminal,
    pushEndScopeTerminal
  );
  const rewrittenFinalBlocks = new Map();
  const nextBlocks = new Map();
  queuedRewrites.reverse();
  for (const [, block] of fn.body.blocks) {
    const context = {
      nextBlockId: block.id,
      rewrites: [],
      nextPreds: block.preds,
      instrSliceIdx: 0,
      source: block,
    };
    for (let i = 0; i < block.instructions.length + 1; i++) {
      const instrId =
        i < block.instructions.length
          ? block.instructions[i].id
          : block.terminal.id;
      let rewrite = queuedRewrites.at(-1);
      while (rewrite != null && rewrite.instrId <= instrId) {
        handleRewrite(rewrite, i, context);
        queuedRewrites.pop();
        rewrite = queuedRewrites.at(-1);
      }
    }
    if (context.rewrites.length > 0) {
      const finalBlock = {
        id: context.nextBlockId,
        kind: block.kind,
        preds: context.nextPreds,
        terminal: block.terminal,
        instructions: block.instructions.slice(context.instrSliceIdx),
        phis: new Set(),
      };
      context.rewrites.push(finalBlock);
      for (const b of context.rewrites) {
        nextBlocks.set(b.id, b);
      }
      rewrittenFinalBlocks.set(block.id, finalBlock.id);
    } else {
      nextBlocks.set(block.id, block);
    }
  }
  const originalBlocks = fn.body.blocks;
  fn.body.blocks = nextBlocks;
  for (const [, block] of originalBlocks) {
    for (const phi of block.phis) {
      for (const [originalId, value] of phi.operands) {
        const newId = rewrittenFinalBlocks.get(originalId);
        if (newId != null) {
          phi.operands.delete(originalId);
          phi.operands.set(newId, value);
        }
      }
    }
  }
  reversePostorderBlocks(fn.body);
  markPredecessors(fn.body);
  markInstructionIds(fn.body);
  fixScopeAndIdentifierRanges(fn.body);
}
function pushStartScopeTerminal(scope, context) {
  const blockId = context.env.nextBlockId;
  const fallthroughId = context.env.nextBlockId;
  context.rewrites.push({
    kind: 'StartScope',
    blockId: blockId,
    fallthroughId: fallthroughId,
    instrId: scope.range.start,
    scope: scope,
  });
  context.fallthroughs.set(scope.id, fallthroughId);
}
function pushEndScopeTerminal(scope, context) {
  const fallthroughId = context.fallthroughs.get(scope.id);
  CompilerError.invariant(fallthroughId != null, {
    reason: 'Expected scope to exist',
    loc: GeneratedSource,
  });
  context.rewrites.push({
    kind: 'EndScope',
    fallthroughId: fallthroughId,
    instrId: scope.range.end,
  });
}
function handleRewrite(terminalInfo, idx, context) {
  const terminal =
    terminalInfo.kind === 'StartScope'
      ? {
          kind: 'scope',
          fallthrough: terminalInfo.fallthroughId,
          block: terminalInfo.blockId,
          scope: terminalInfo.scope,
          id: terminalInfo.instrId,
          loc: GeneratedSource,
        }
      : {
          kind: 'goto',
          variant: GotoVariant.Break,
          block: terminalInfo.fallthroughId,
          id: terminalInfo.instrId,
          loc: GeneratedSource,
        };
  const currBlockId = context.nextBlockId;
  context.rewrites.push({
    kind: context.source.kind,
    id: currBlockId,
    instructions: context.source.instructions.slice(context.instrSliceIdx, idx),
    preds: context.nextPreds,
    phis: context.rewrites.length === 0 ? context.source.phis : new Set(),
    terminal: terminal,
  });
  context.nextPreds = new Set([currBlockId]);
  context.nextBlockId =
    terminalInfo.kind === 'StartScope'
      ? terminalInfo.blockId
      : terminalInfo.fallthroughId;
  context.instrSliceIdx = idx;
}
var collections = {};
Object.defineProperty(collections, '__esModule', {value: true});
collections.printIteratorEntries = printIteratorEntries;
collections.printIteratorValues = printIteratorValues;
collections.printListItems = printListItems;
collections.printObjectProperties = printObjectProperties;
const getKeysOfEnumerableProperties = object => {
  const keys = Object.keys(object).sort();
  if (Object.getOwnPropertySymbols) {
    Object.getOwnPropertySymbols(object).forEach(symbol => {
      if (Object.getOwnPropertyDescriptor(object, symbol).enumerable) {
        keys.push(symbol);
      }
    });
  }
  return keys;
};
function printIteratorEntries(
  iterator,
  config,
  indentation,
  depth,
  refs,
  printer,
  separator = ': '
) {
  let result = '';
  let current = iterator.next();
  if (!current.done) {
    result += config.spacingOuter;
    const indentationNext = indentation + config.indent;
    while (!current.done) {
      const name = printer(
        current.value[0],
        config,
        indentationNext,
        depth,
        refs
      );
      const value = printer(
        current.value[1],
        config,
        indentationNext,
        depth,
        refs
      );
      result += indentationNext + name + separator + value;
      current = iterator.next();
      if (!current.done) {
        result += ',' + config.spacingInner;
      } else if (!config.min) {
        result += ',';
      }
    }
    result += config.spacingOuter + indentation;
  }
  return result;
}
function printIteratorValues(
  iterator,
  config,
  indentation,
  depth,
  refs,
  printer
) {
  let result = '';
  let current = iterator.next();
  if (!current.done) {
    result += config.spacingOuter;
    const indentationNext = indentation + config.indent;
    while (!current.done) {
      result +=
        indentationNext +
        printer(current.value, config, indentationNext, depth, refs);
      current = iterator.next();
      if (!current.done) {
        result += ',' + config.spacingInner;
      } else if (!config.min) {
        result += ',';
      }
    }
    result += config.spacingOuter + indentation;
  }
  return result;
}
function printListItems(list, config, indentation, depth, refs, printer) {
  let result = '';
  if (list.length) {
    result += config.spacingOuter;
    const indentationNext = indentation + config.indent;
    for (let i = 0; i < list.length; i++) {
      result +=
        indentationNext +
        printer(list[i], config, indentationNext, depth, refs);
      if (i < list.length - 1) {
        result += ',' + config.spacingInner;
      } else if (!config.min) {
        result += ',';
      }
    }
    result += config.spacingOuter + indentation;
  }
  return result;
}
function printObjectProperties(val, config, indentation, depth, refs, printer) {
  let result = '';
  const keys = getKeysOfEnumerableProperties(val);
  if (keys.length) {
    result += config.spacingOuter;
    const indentationNext = indentation + config.indent;
    for (let i = 0; i < keys.length; i++) {
      const key = keys[i];
      const name = printer(key, config, indentationNext, depth, refs);
      const value = printer(val[key], config, indentationNext, depth, refs);
      result += indentationNext + name + ': ' + value;
      if (i < keys.length - 1) {
        result += ',' + config.spacingInner;
      } else if (!config.min) {
        result += ',';
      }
    }
    result += config.spacingOuter + indentation;
  }
  return result;
}
var AsymmetricMatcher = {};
Object.defineProperty(AsymmetricMatcher, '__esModule', {value: true});
AsymmetricMatcher.default =
  AsymmetricMatcher.test =
  AsymmetricMatcher.serialize =
    void 0;
var _collections$3 = collections;
var Symbol$3 =
  commonjsGlobal['jest-symbol-do-not-touch'] || commonjsGlobal.Symbol;
const asymmetricMatcher = Symbol$3.for('jest.asymmetricMatcher');
const SPACE$2 = ' ';
const serialize$6 = (val, config, indentation, depth, refs, printer) => {
  const stringedValue = val.toString();
  if (
    stringedValue === 'ArrayContaining' ||
    stringedValue === 'ArrayNotContaining'
  ) {
    if (++depth > config.maxDepth) {
      return '[' + stringedValue + ']';
    }
    return (
      stringedValue +
      SPACE$2 +
      '[' +
      (0, _collections$3.printListItems)(
        val.sample,
        config,
        indentation,
        depth,
        refs,
        printer
      ) +
      ']'
    );
  }
  if (
    stringedValue === 'ObjectContaining' ||
    stringedValue === 'ObjectNotContaining'
  ) {
    if (++depth > config.maxDepth) {
      return '[' + stringedValue + ']';
    }
    return (
      stringedValue +
      SPACE$2 +
      '{' +
      (0, _collections$3.printObjectProperties)(
        val.sample,
        config,
        indentation,
        depth,
        refs,
        printer
      ) +
      '}'
    );
  }
  if (
    stringedValue === 'StringMatching' ||
    stringedValue === 'StringNotMatching'
  ) {
    return (
      stringedValue +
      SPACE$2 +
      printer(val.sample, config, indentation, depth, refs)
    );
  }
  if (
    stringedValue === 'StringContaining' ||
    stringedValue === 'StringNotContaining'
  ) {
    return (
      stringedValue +
      SPACE$2 +
      printer(val.sample, config, indentation, depth, refs)
    );
  }
  return val.toAsymmetricMatcher();
};
AsymmetricMatcher.serialize = serialize$6;
const test$6 = val => val && val.$$typeof === asymmetricMatcher;
AsymmetricMatcher.test = test$6;
const plugin$6 = {serialize: serialize$6, test: test$6};
var _default$6 = plugin$6;
AsymmetricMatcher.default = _default$6;
var ConvertAnsi = {};
var ansiRegex = options => {
  options = Object.assign({onlyFirst: false}, options);
  const pattern = [
    '[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)',
    '(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))',
  ].join('|');
  return new RegExp(pattern, options.onlyFirst ? undefined : 'g');
};
Object.defineProperty(ConvertAnsi, '__esModule', {value: true});
ConvertAnsi.default = ConvertAnsi.serialize = ConvertAnsi.test = void 0;
var _ansiRegex = _interopRequireDefault$2(ansiRegex);
var _ansiStyles$1 = _interopRequireDefault$2(ansiStylesExports$1);
function _interopRequireDefault$2(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const toHumanReadableAnsi = text =>
  text.replace((0, _ansiRegex.default)(), match => {
    switch (match) {
      case _ansiStyles$1.default.red.close:
      case _ansiStyles$1.default.green.close:
      case _ansiStyles$1.default.cyan.close:
      case _ansiStyles$1.default.gray.close:
      case _ansiStyles$1.default.white.close:
      case _ansiStyles$1.default.yellow.close:
      case _ansiStyles$1.default.bgRed.close:
      case _ansiStyles$1.default.bgGreen.close:
      case _ansiStyles$1.default.bgYellow.close:
      case _ansiStyles$1.default.inverse.close:
      case _ansiStyles$1.default.dim.close:
      case _ansiStyles$1.default.bold.close:
      case _ansiStyles$1.default.reset.open:
      case _ansiStyles$1.default.reset.close:
        return '</>';
      case _ansiStyles$1.default.red.open:
        return '<red>';
      case _ansiStyles$1.default.green.open:
        return '<green>';
      case _ansiStyles$1.default.cyan.open:
        return '<cyan>';
      case _ansiStyles$1.default.gray.open:
        return '<gray>';
      case _ansiStyles$1.default.white.open:
        return '<white>';
      case _ansiStyles$1.default.yellow.open:
        return '<yellow>';
      case _ansiStyles$1.default.bgRed.open:
        return '<bgRed>';
      case _ansiStyles$1.default.bgGreen.open:
        return '<bgGreen>';
      case _ansiStyles$1.default.bgYellow.open:
        return '<bgYellow>';
      case _ansiStyles$1.default.inverse.open:
        return '<inverse>';
      case _ansiStyles$1.default.dim.open:
        return '<dim>';
      case _ansiStyles$1.default.bold.open:
        return '<bold>';
      default:
        return '';
    }
  });
const test$5 = val =>
  typeof val === 'string' && !!val.match((0, _ansiRegex.default)());
ConvertAnsi.test = test$5;
const serialize$5 = (val, config, indentation, depth, refs, printer) =>
  printer(toHumanReadableAnsi(val), config, indentation, depth, refs);
ConvertAnsi.serialize = serialize$5;
const plugin$5 = {serialize: serialize$5, test: test$5};
var _default$5 = plugin$5;
ConvertAnsi.default = _default$5;
var DOMCollection = {};
Object.defineProperty(DOMCollection, '__esModule', {value: true});
DOMCollection.default = DOMCollection.serialize = DOMCollection.test = void 0;
var _collections$2 = collections;
function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);
    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(
        Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        })
      );
    }
    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }
  return target;
}
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true,
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
const SPACE$1 = ' ';
const OBJECT_NAMES = ['DOMStringMap', 'NamedNodeMap'];
const ARRAY_REGEXP = /^(HTML\w*Collection|NodeList)$/;
const testName = name =>
  OBJECT_NAMES.indexOf(name) !== -1 || ARRAY_REGEXP.test(name);
const test$4 = val =>
  val &&
  val.constructor &&
  val.constructor.name &&
  testName(val.constructor.name);
DOMCollection.test = test$4;
const propsReducer = (props, attribute) => {
  props[attribute.name] = attribute.value;
  return props;
};
const serialize$4 = (collection, config, indentation, depth, refs, printer) => {
  const name = collection.constructor.name;
  if (++depth > config.maxDepth) {
    return '[' + name + ']';
  }
  return (
    (config.min ? '' : name + SPACE$1) +
    (OBJECT_NAMES.indexOf(name) !== -1
      ? '{' +
        (0, _collections$2.printObjectProperties)(
          name === 'NamedNodeMap'
            ? Array.prototype.reduce.call(collection, propsReducer, {})
            : _objectSpread({}, collection),
          config,
          indentation,
          depth,
          refs,
          printer
        ) +
        '}'
      : '[' +
        (0, _collections$2.printListItems)(
          Array.from(collection),
          config,
          indentation,
          depth,
          refs,
          printer
        ) +
        ']')
  );
};
DOMCollection.serialize = serialize$4;
const plugin$4 = {serialize: serialize$4, test: test$4};
var _default$4 = plugin$4;
DOMCollection.default = _default$4;
var DOMElement = {};
var markup = {};
var escapeHTML$1 = {};
Object.defineProperty(escapeHTML$1, '__esModule', {value: true});
escapeHTML$1.default = escapeHTML;
function escapeHTML(str) {
  return str.replace(/</g, '&lt;').replace(/>/g, '&gt;');
}
Object.defineProperty(markup, '__esModule', {value: true});
markup.printElementAsLeaf =
  markup.printElement =
  markup.printComment =
  markup.printText =
  markup.printChildren =
  markup.printProps =
    void 0;
var _escapeHTML = _interopRequireDefault$1(escapeHTML$1);
function _interopRequireDefault$1(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
const printProps = (keys, props, config, indentation, depth, refs, printer) => {
  const indentationNext = indentation + config.indent;
  const colors = config.colors;
  return keys
    .map(key => {
      const value = props[key];
      let printed = printer(value, config, indentationNext, depth, refs);
      if (typeof value !== 'string') {
        if (printed.indexOf('\n') !== -1) {
          printed =
            config.spacingOuter +
            indentationNext +
            printed +
            config.spacingOuter +
            indentation;
        }
        printed = '{' + printed + '}';
      }
      return (
        config.spacingInner +
        indentation +
        colors.prop.open +
        key +
        colors.prop.close +
        '=' +
        colors.value.open +
        printed +
        colors.value.close
      );
    })
    .join('');
};
markup.printProps = printProps;
const printChildren = (children, config, indentation, depth, refs, printer) =>
  children
    .map(
      child =>
        config.spacingOuter +
        indentation +
        (typeof child === 'string'
          ? printText(child, config)
          : printer(child, config, indentation, depth, refs))
    )
    .join('');
markup.printChildren = printChildren;
const printText = (text, config) => {
  const contentColor = config.colors.content;
  return (
    contentColor.open + (0, _escapeHTML.default)(text) + contentColor.close
  );
};
markup.printText = printText;
const printComment = (comment, config) => {
  const commentColor = config.colors.comment;
  return (
    commentColor.open +
    '\x3c!--' +
    (0, _escapeHTML.default)(comment) +
    '--\x3e' +
    commentColor.close
  );
};
markup.printComment = printComment;
const printElement = (
  type,
  printedProps,
  printedChildren,
  config,
  indentation
) => {
  const tagColor = config.colors.tag;
  return (
    tagColor.open +
    '<' +
    type +
    (printedProps &&
      tagColor.close +
        printedProps +
        config.spacingOuter +
        indentation +
        tagColor.open) +
    (printedChildren
      ? '>' +
        tagColor.close +
        printedChildren +
        config.spacingOuter +
        indentation +
        tagColor.open +
        '</' +
        type
      : (printedProps && !config.min ? '' : ' ') + '/') +
    '>' +
    tagColor.close
  );
};
markup.printElement = printElement;
const printElementAsLeaf = (type, config) => {
  const tagColor = config.colors.tag;
  return (
    tagColor.open +
    '<' +
    type +
    tagColor.close +
    ' …' +
    tagColor.open +
    ' />' +
    tagColor.close
  );
};
markup.printElementAsLeaf = printElementAsLeaf;
Object.defineProperty(DOMElement, '__esModule', {value: true});
DOMElement.default = DOMElement.serialize = DOMElement.test = void 0;
var _markup$2 = markup;
const ELEMENT_NODE = 1;
const TEXT_NODE = 3;
const COMMENT_NODE = 8;
const FRAGMENT_NODE = 11;
const ELEMENT_REGEXP = /^((HTML|SVG)\w*)?Element$/;
const testNode = (nodeType, name) =>
  (nodeType === ELEMENT_NODE && ELEMENT_REGEXP.test(name)) ||
  (nodeType === TEXT_NODE && name === 'Text') ||
  (nodeType === COMMENT_NODE && name === 'Comment') ||
  (nodeType === FRAGMENT_NODE && name === 'DocumentFragment');
const test$3 = val =>
  val &&
  val.constructor &&
  val.constructor.name &&
  testNode(val.nodeType, val.constructor.name);
DOMElement.test = test$3;
function nodeIsText(node) {
  return node.nodeType === TEXT_NODE;
}
function nodeIsComment(node) {
  return node.nodeType === COMMENT_NODE;
}
function nodeIsFragment(node) {
  return node.nodeType === FRAGMENT_NODE;
}
const serialize$3 = (node, config, indentation, depth, refs, printer) => {
  if (nodeIsText(node)) {
    return (0, _markup$2.printText)(node.data, config);
  }
  if (nodeIsComment(node)) {
    return (0, _markup$2.printComment)(node.data, config);
  }
  const type = nodeIsFragment(node)
    ? `DocumentFragment`
    : node.tagName.toLowerCase();
  if (++depth > config.maxDepth) {
    return (0, _markup$2.printElementAsLeaf)(type, config);
  }
  return (0, _markup$2.printElement)(
    type,
    (0, _markup$2.printProps)(
      nodeIsFragment(node)
        ? []
        : Array.from(node.attributes)
            .map(attr => attr.name)
            .sort(),
      nodeIsFragment(node)
        ? []
        : Array.from(node.attributes).reduce((props, attribute) => {
            props[attribute.name] = attribute.value;
            return props;
          }, {}),
      config,
      indentation + config.indent,
      depth,
      refs,
      printer
    ),
    (0, _markup$2.printChildren)(
      Array.prototype.slice.call(node.childNodes || node.children),
      config,
      indentation + config.indent,
      depth,
      refs,
      printer
    ),
    config,
    indentation
  );
};
DOMElement.serialize = serialize$3;
const plugin$3 = {serialize: serialize$3, test: test$3};
var _default$3 = plugin$3;
DOMElement.default = _default$3;
var Immutable = {};
Object.defineProperty(Immutable, '__esModule', {value: true});
Immutable.default = Immutable.test = Immutable.serialize = void 0;
var _collections$1 = collections;
const IS_ITERABLE_SENTINEL = '@@__IMMUTABLE_ITERABLE__@@';
const IS_LIST_SENTINEL = '@@__IMMUTABLE_LIST__@@';
const IS_KEYED_SENTINEL = '@@__IMMUTABLE_KEYED__@@';
const IS_MAP_SENTINEL = '@@__IMMUTABLE_MAP__@@';
const IS_ORDERED_SENTINEL = '@@__IMMUTABLE_ORDERED__@@';
const IS_RECORD_SENTINEL = '@@__IMMUTABLE_RECORD__@@';
const IS_SEQ_SENTINEL = '@@__IMMUTABLE_SEQ__@@';
const IS_SET_SENTINEL = '@@__IMMUTABLE_SET__@@';
const IS_STACK_SENTINEL = '@@__IMMUTABLE_STACK__@@';
const getImmutableName = name => 'Immutable.' + name;
const printAsLeaf = name => '[' + name + ']';
const SPACE = ' ';
const LAZY = '…';
const printImmutableEntries = (
  val,
  config,
  indentation,
  depth,
  refs,
  printer,
  type
) =>
  ++depth > config.maxDepth
    ? printAsLeaf(getImmutableName(type))
    : getImmutableName(type) +
      SPACE +
      '{' +
      (0, _collections$1.printIteratorEntries)(
        val.entries(),
        config,
        indentation,
        depth,
        refs,
        printer
      ) +
      '}';
const getRecordEntries = val => {
  let i = 0;
  return {
    next() {
      if (i < val._keys.length) {
        const key = val._keys[i++];
        return {done: false, value: [key, val.get(key)]};
      }
      return {done: true};
    },
  };
};
const printImmutableRecord = (
  val,
  config,
  indentation,
  depth,
  refs,
  printer
) => {
  const name = getImmutableName(val._name || 'Record');
  return ++depth > config.maxDepth
    ? printAsLeaf(name)
    : name +
        SPACE +
        '{' +
        (0, _collections$1.printIteratorEntries)(
          getRecordEntries(val),
          config,
          indentation,
          depth,
          refs,
          printer
        ) +
        '}';
};
const printImmutableSeq = (val, config, indentation, depth, refs, printer) => {
  const name = getImmutableName('Seq');
  if (++depth > config.maxDepth) {
    return printAsLeaf(name);
  }
  if (val[IS_KEYED_SENTINEL]) {
    return (
      name +
      SPACE +
      '{' +
      (val._iter || val._object
        ? (0, _collections$1.printIteratorEntries)(
            val.entries(),
            config,
            indentation,
            depth,
            refs,
            printer
          )
        : LAZY) +
      '}'
    );
  }
  return (
    name +
    SPACE +
    '[' +
    (val._iter || val._array || val._collection || val._iterable
      ? (0, _collections$1.printIteratorValues)(
          val.values(),
          config,
          indentation,
          depth,
          refs,
          printer
        )
      : LAZY) +
    ']'
  );
};
const printImmutableValues = (
  val,
  config,
  indentation,
  depth,
  refs,
  printer,
  type
) =>
  ++depth > config.maxDepth
    ? printAsLeaf(getImmutableName(type))
    : getImmutableName(type) +
      SPACE +
      '[' +
      (0, _collections$1.printIteratorValues)(
        val.values(),
        config,
        indentation,
        depth,
        refs,
        printer
      ) +
      ']';
const serialize$2 = (val, config, indentation, depth, refs, printer) => {
  if (val[IS_MAP_SENTINEL]) {
    return printImmutableEntries(
      val,
      config,
      indentation,
      depth,
      refs,
      printer,
      val[IS_ORDERED_SENTINEL] ? 'OrderedMap' : 'Map'
    );
  }
  if (val[IS_LIST_SENTINEL]) {
    return printImmutableValues(
      val,
      config,
      indentation,
      depth,
      refs,
      printer,
      'List'
    );
  }
  if (val[IS_SET_SENTINEL]) {
    return printImmutableValues(
      val,
      config,
      indentation,
      depth,
      refs,
      printer,
      val[IS_ORDERED_SENTINEL] ? 'OrderedSet' : 'Set'
    );
  }
  if (val[IS_STACK_SENTINEL]) {
    return printImmutableValues(
      val,
      config,
      indentation,
      depth,
      refs,
      printer,
      'Stack'
    );
  }
  if (val[IS_SEQ_SENTINEL]) {
    return printImmutableSeq(val, config, indentation, depth, refs, printer);
  }
  return printImmutableRecord(val, config, indentation, depth, refs, printer);
};
Immutable.serialize = serialize$2;
const test$2 = val =>
  val &&
  (val[IS_ITERABLE_SENTINEL] === true || val[IS_RECORD_SENTINEL] === true);
Immutable.test = test$2;
const plugin$2 = {serialize: serialize$2, test: test$2};
var _default$2 = plugin$2;
Immutable.default = _default$2;
var ReactElement = {};
var reactIs = {exports: {}};
var reactIs_production_min = {};
var hasRequiredReactIs_production_min;
function requireReactIs_production_min() {
  if (hasRequiredReactIs_production_min) return reactIs_production_min;
  hasRequiredReactIs_production_min = 1;
  var b = 'function' === typeof Symbol && Symbol.for,
    c = b ? Symbol.for('react.element') : 60103,
    d = b ? Symbol.for('react.portal') : 60106,
    e = b ? Symbol.for('react.fragment') : 60107,
    f = b ? Symbol.for('react.strict_mode') : 60108,
    g = b ? Symbol.for('react.profiler') : 60114,
    h = b ? Symbol.for('react.provider') : 60109,
    k = b ? Symbol.for('react.context') : 60110,
    l = b ? Symbol.for('react.async_mode') : 60111,
    m = b ? Symbol.for('react.concurrent_mode') : 60111,
    n = b ? Symbol.for('react.forward_ref') : 60112,
    p = b ? Symbol.for('react.suspense') : 60113,
    q = b ? Symbol.for('react.suspense_list') : 60120,
    r = b ? Symbol.for('react.memo') : 60115,
    t = b ? Symbol.for('react.lazy') : 60116,
    v = b ? Symbol.for('react.block') : 60121,
    w = b ? Symbol.for('react.fundamental') : 60117,
    x = b ? Symbol.for('react.responder') : 60118,
    y = b ? Symbol.for('react.scope') : 60119;
  function z(a) {
    if ('object' === typeof a && null !== a) {
      var u = a.$$typeof;
      switch (u) {
        case c:
          switch (((a = a.type), a)) {
            case l:
            case m:
            case e:
            case g:
            case f:
            case p:
              return a;
            default:
              switch (((a = a && a.$$typeof), a)) {
                case k:
                case n:
                case t:
                case r:
                case h:
                  return a;
                default:
                  return u;
              }
          }
        case d:
          return u;
      }
    }
  }
  function A(a) {
    return z(a) === m;
  }
  reactIs_production_min.AsyncMode = l;
  reactIs_production_min.ConcurrentMode = m;
  reactIs_production_min.ContextConsumer = k;
  reactIs_production_min.ContextProvider = h;
  reactIs_production_min.Element = c;
  reactIs_production_min.ForwardRef = n;
  reactIs_production_min.Fragment = e;
  reactIs_production_min.Lazy = t;
  reactIs_production_min.Memo = r;
  reactIs_production_min.Portal = d;
  reactIs_production_min.Profiler = g;
  reactIs_production_min.StrictMode = f;
  reactIs_production_min.Suspense = p;
  reactIs_production_min.isAsyncMode = function (a) {
    return A(a) || z(a) === l;
  };
  reactIs_production_min.isConcurrentMode = A;
  reactIs_production_min.isContextConsumer = function (a) {
    return z(a) === k;
  };
  reactIs_production_min.isContextProvider = function (a) {
    return z(a) === h;
  };
  reactIs_production_min.isElement = function (a) {
    return 'object' === typeof a && null !== a && a.$$typeof === c;
  };
  reactIs_production_min.isForwardRef = function (a) {
    return z(a) === n;
  };
  reactIs_production_min.isFragment = function (a) {
    return z(a) === e;
  };
  reactIs_production_min.isLazy = function (a) {
    return z(a) === t;
  };
  reactIs_production_min.isMemo = function (a) {
    return z(a) === r;
  };
  reactIs_production_min.isPortal = function (a) {
    return z(a) === d;
  };
  reactIs_production_min.isProfiler = function (a) {
    return z(a) === g;
  };
  reactIs_production_min.isStrictMode = function (a) {
    return z(a) === f;
  };
  reactIs_production_min.isSuspense = function (a) {
    return z(a) === p;
  };
  reactIs_production_min.isValidElementType = function (a) {
    return (
      'string' === typeof a ||
      'function' === typeof a ||
      a === e ||
      a === m ||
      a === g ||
      a === f ||
      a === p ||
      a === q ||
      ('object' === typeof a &&
        null !== a &&
        (a.$$typeof === t ||
          a.$$typeof === r ||
          a.$$typeof === h ||
          a.$$typeof === k ||
          a.$$typeof === n ||
          a.$$typeof === w ||
          a.$$typeof === x ||
          a.$$typeof === y ||
          a.$$typeof === v))
    );
  };
  reactIs_production_min.typeOf = z;
  return reactIs_production_min;
}
var reactIs_development = {};
var hasRequiredReactIs_development;
function requireReactIs_development() {
  if (hasRequiredReactIs_development) return reactIs_development;
  hasRequiredReactIs_development = 1;
  if (process.env.NODE_ENV !== 'production') {
    (function () {
      var hasSymbol = typeof Symbol === 'function' && Symbol.for;
      var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 60103;
      var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 60106;
      var REACT_FRAGMENT_TYPE = hasSymbol
        ? Symbol.for('react.fragment')
        : 60107;
      var REACT_STRICT_MODE_TYPE = hasSymbol
        ? Symbol.for('react.strict_mode')
        : 60108;
      var REACT_PROFILER_TYPE = hasSymbol
        ? Symbol.for('react.profiler')
        : 60114;
      var REACT_PROVIDER_TYPE = hasSymbol
        ? Symbol.for('react.provider')
        : 60109;
      var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 60110;
      var REACT_ASYNC_MODE_TYPE = hasSymbol
        ? Symbol.for('react.async_mode')
        : 60111;
      var REACT_CONCURRENT_MODE_TYPE = hasSymbol
        ? Symbol.for('react.concurrent_mode')
        : 60111;
      var REACT_FORWARD_REF_TYPE = hasSymbol
        ? Symbol.for('react.forward_ref')
        : 60112;
      var REACT_SUSPENSE_TYPE = hasSymbol
        ? Symbol.for('react.suspense')
        : 60113;
      var REACT_SUSPENSE_LIST_TYPE = hasSymbol
        ? Symbol.for('react.suspense_list')
        : 60120;
      var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 60115;
      var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 60116;
      var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 60121;
      var REACT_FUNDAMENTAL_TYPE = hasSymbol
        ? Symbol.for('react.fundamental')
        : 60117;
      var REACT_RESPONDER_TYPE = hasSymbol
        ? Symbol.for('react.responder')
        : 60118;
      var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 60119;
      function isValidElementType(type) {
        return (
          typeof type === 'string' ||
          typeof type === 'function' ||
          type === REACT_FRAGMENT_TYPE ||
          type === REACT_CONCURRENT_MODE_TYPE ||
          type === REACT_PROFILER_TYPE ||
          type === REACT_STRICT_MODE_TYPE ||
          type === REACT_SUSPENSE_TYPE ||
          type === REACT_SUSPENSE_LIST_TYPE ||
          (typeof type === 'object' &&
            type !== null &&
            (type.$$typeof === REACT_LAZY_TYPE ||
              type.$$typeof === REACT_MEMO_TYPE ||
              type.$$typeof === REACT_PROVIDER_TYPE ||
              type.$$typeof === REACT_CONTEXT_TYPE ||
              type.$$typeof === REACT_FORWARD_REF_TYPE ||
              type.$$typeof === REACT_FUNDAMENTAL_TYPE ||
              type.$$typeof === REACT_RESPONDER_TYPE ||
              type.$$typeof === REACT_SCOPE_TYPE ||
              type.$$typeof === REACT_BLOCK_TYPE))
        );
      }
      function typeOf(object) {
        if (typeof object === 'object' && object !== null) {
          var $$typeof = object.$$typeof;
          switch ($$typeof) {
            case REACT_ELEMENT_TYPE:
              var type = object.type;
              switch (type) {
                case REACT_ASYNC_MODE_TYPE:
                case REACT_CONCURRENT_MODE_TYPE:
                case REACT_FRAGMENT_TYPE:
                case REACT_PROFILER_TYPE:
                case REACT_STRICT_MODE_TYPE:
                case REACT_SUSPENSE_TYPE:
                  return type;
                default:
                  var $$typeofType = type && type.$$typeof;
                  switch ($$typeofType) {
                    case REACT_CONTEXT_TYPE:
                    case REACT_FORWARD_REF_TYPE:
                    case REACT_LAZY_TYPE:
                    case REACT_MEMO_TYPE:
                    case REACT_PROVIDER_TYPE:
                      return $$typeofType;
                    default:
                      return $$typeof;
                  }
              }
            case REACT_PORTAL_TYPE:
              return $$typeof;
          }
        }
        return undefined;
      }
      var AsyncMode = REACT_ASYNC_MODE_TYPE;
      var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
      var ContextConsumer = REACT_CONTEXT_TYPE;
      var ContextProvider = REACT_PROVIDER_TYPE;
      var Element = REACT_ELEMENT_TYPE;
      var ForwardRef = REACT_FORWARD_REF_TYPE;
      var Fragment = REACT_FRAGMENT_TYPE;
      var Lazy = REACT_LAZY_TYPE;
      var Memo = REACT_MEMO_TYPE;
      var Portal = REACT_PORTAL_TYPE;
      var Profiler = REACT_PROFILER_TYPE;
      var StrictMode = REACT_STRICT_MODE_TYPE;
      var Suspense = REACT_SUSPENSE_TYPE;
      var hasWarnedAboutDeprecatedIsAsyncMode = false;
      function isAsyncMode(object) {
        {
          if (!hasWarnedAboutDeprecatedIsAsyncMode) {
            hasWarnedAboutDeprecatedIsAsyncMode = true;
            console['warn'](
              'The ReactIs.isAsyncMode() alias has been deprecated, ' +
                'and will be removed in React 17+. Update your code to use ' +
                'ReactIs.isConcurrentMode() instead. It has the exact same API.'
            );
          }
        }
        return (
          isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE
        );
      }
      function isConcurrentMode(object) {
        return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
      }
      function isContextConsumer(object) {
        return typeOf(object) === REACT_CONTEXT_TYPE;
      }
      function isContextProvider(object) {
        return typeOf(object) === REACT_PROVIDER_TYPE;
      }
      function isElement(object) {
        return (
          typeof object === 'object' &&
          object !== null &&
          object.$$typeof === REACT_ELEMENT_TYPE
        );
      }
      function isForwardRef(object) {
        return typeOf(object) === REACT_FORWARD_REF_TYPE;
      }
      function isFragment(object) {
        return typeOf(object) === REACT_FRAGMENT_TYPE;
      }
      function isLazy(object) {
        return typeOf(object) === REACT_LAZY_TYPE;
      }
      function isMemo(object) {
        return typeOf(object) === REACT_MEMO_TYPE;
      }
      function isPortal(object) {
        return typeOf(object) === REACT_PORTAL_TYPE;
      }
      function isProfiler(object) {
        return typeOf(object) === REACT_PROFILER_TYPE;
      }
      function isStrictMode(object) {
        return typeOf(object) === REACT_STRICT_MODE_TYPE;
      }
      function isSuspense(object) {
        return typeOf(object) === REACT_SUSPENSE_TYPE;
      }
      reactIs_development.AsyncMode = AsyncMode;
      reactIs_development.ConcurrentMode = ConcurrentMode;
      reactIs_development.ContextConsumer = ContextConsumer;
      reactIs_development.ContextProvider = ContextProvider;
      reactIs_development.Element = Element;
      reactIs_development.ForwardRef = ForwardRef;
      reactIs_development.Fragment = Fragment;
      reactIs_development.Lazy = Lazy;
      reactIs_development.Memo = Memo;
      reactIs_development.Portal = Portal;
      reactIs_development.Profiler = Profiler;
      reactIs_development.StrictMode = StrictMode;
      reactIs_development.Suspense = Suspense;
      reactIs_development.isAsyncMode = isAsyncMode;
      reactIs_development.isConcurrentMode = isConcurrentMode;
      reactIs_development.isContextConsumer = isContextConsumer;
      reactIs_development.isContextProvider = isContextProvider;
      reactIs_development.isElement = isElement;
      reactIs_development.isForwardRef = isForwardRef;
      reactIs_development.isFragment = isFragment;
      reactIs_development.isLazy = isLazy;
      reactIs_development.isMemo = isMemo;
      reactIs_development.isPortal = isPortal;
      reactIs_development.isProfiler = isProfiler;
      reactIs_development.isStrictMode = isStrictMode;
      reactIs_development.isSuspense = isSuspense;
      reactIs_development.isValidElementType = isValidElementType;
      reactIs_development.typeOf = typeOf;
    })();
  }
  return reactIs_development;
}
if (process.env.NODE_ENV === 'production') {
  reactIs.exports = requireReactIs_production_min();
} else {
  reactIs.exports = requireReactIs_development();
}
var reactIsExports = reactIs.exports;
Object.defineProperty(ReactElement, '__esModule', {value: true});
ReactElement.default = ReactElement.test = ReactElement.serialize = void 0;
var ReactIs = _interopRequireWildcard(reactIsExports);
var _markup$1 = markup;
function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  } else {
    var newObj = {};
    if (obj != null) {
      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc =
            Object.defineProperty && Object.getOwnPropertyDescriptor
              ? Object.getOwnPropertyDescriptor(obj, key)
              : {};
          if (desc.get || desc.set) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }
    newObj.default = obj;
    return newObj;
  }
}
const getChildren = (arg, children = []) => {
  if (Array.isArray(arg)) {
    arg.forEach(item => {
      getChildren(item, children);
    });
  } else if (arg != null && arg !== false) {
    children.push(arg);
  }
  return children;
};
const getType = element => {
  const type = element.type;
  if (typeof type === 'string') {
    return type;
  }
  if (typeof type === 'function') {
    return type.displayName || type.name || 'Unknown';
  }
  if (ReactIs.isFragment(element)) {
    return 'React.Fragment';
  }
  if (ReactIs.isSuspense(element)) {
    return 'React.Suspense';
  }
  if (typeof type === 'object' && type !== null) {
    if (ReactIs.isContextProvider(element)) {
      return 'Context.Provider';
    }
    if (ReactIs.isContextConsumer(element)) {
      return 'Context.Consumer';
    }
    if (ReactIs.isForwardRef(element)) {
      const functionName = type.render.displayName || type.render.name || '';
      return functionName !== ''
        ? 'ForwardRef(' + functionName + ')'
        : 'ForwardRef';
    }
    if (ReactIs.isMemo(type)) {
      const functionName =
        type.displayName || type.type.displayName || type.type.name || '';
      return functionName !== '' ? 'Memo(' + functionName + ')' : 'Memo';
    }
  }
  return 'UNDEFINED';
};
const getPropKeys$1 = element => {
  const props = element.props;
  return Object.keys(props)
    .filter(key => key !== 'children' && props[key] !== undefined)
    .sort();
};
const serialize$1 = (element, config, indentation, depth, refs, printer) =>
  ++depth > config.maxDepth
    ? (0, _markup$1.printElementAsLeaf)(getType(element), config)
    : (0, _markup$1.printElement)(
        getType(element),
        (0, _markup$1.printProps)(
          getPropKeys$1(element),
          element.props,
          config,
          indentation + config.indent,
          depth,
          refs,
          printer
        ),
        (0, _markup$1.printChildren)(
          getChildren(element.props.children),
          config,
          indentation + config.indent,
          depth,
          refs,
          printer
        ),
        config,
        indentation
      );
ReactElement.serialize = serialize$1;
const test$1 = val => val && ReactIs.isElement(val);
ReactElement.test = test$1;
const plugin$1 = {serialize: serialize$1, test: test$1};
var _default$1 = plugin$1;
ReactElement.default = _default$1;
var ReactTestComponent = {};
Object.defineProperty(ReactTestComponent, '__esModule', {value: true});
ReactTestComponent.default =
  ReactTestComponent.test =
  ReactTestComponent.serialize =
    void 0;
var _markup = markup;
var Symbol$2 =
  commonjsGlobal['jest-symbol-do-not-touch'] || commonjsGlobal.Symbol;
const testSymbol = Symbol$2.for('react.test.json');
const getPropKeys = object => {
  const props = object.props;
  return props
    ? Object.keys(props)
        .filter(key => props[key] !== undefined)
        .sort()
    : [];
};
const serialize = (object, config, indentation, depth, refs, printer) =>
  ++depth > config.maxDepth
    ? (0, _markup.printElementAsLeaf)(object.type, config)
    : (0, _markup.printElement)(
        object.type,
        object.props
          ? (0, _markup.printProps)(
              getPropKeys(object),
              object.props,
              config,
              indentation + config.indent,
              depth,
              refs,
              printer
            )
          : '',
        object.children
          ? (0, _markup.printChildren)(
              object.children,
              config,
              indentation + config.indent,
              depth,
              refs,
              printer
            )
          : '',
        config,
        indentation
      );
ReactTestComponent.serialize = serialize;
const test = val => val && val.$$typeof === testSymbol;
ReactTestComponent.test = test;
const plugin = {serialize: serialize, test: test};
var _default = plugin;
ReactTestComponent.default = _default;
var _ansiStyles = _interopRequireDefault(ansiStylesExports$1);
var _collections = collections;
var _AsymmetricMatcher = _interopRequireDefault(AsymmetricMatcher);
var _ConvertAnsi = _interopRequireDefault(ConvertAnsi);
var _DOMCollection = _interopRequireDefault(DOMCollection);
var _DOMElement = _interopRequireDefault(DOMElement);
var _Immutable = _interopRequireDefault(Immutable);
var _ReactElement = _interopRequireDefault(ReactElement);
var _ReactTestComponent = _interopRequireDefault(ReactTestComponent);
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}
var Symbol$1 =
  commonjsGlobal['jest-symbol-do-not-touch'] || commonjsGlobal.Symbol;
const toString = Object.prototype.toString;
const toISOString = Date.prototype.toISOString;
const errorToString = Error.prototype.toString;
const regExpToString = RegExp.prototype.toString;
const symbolToString = Symbol$1.prototype.toString;
const getConstructorName = val =>
  (typeof val.constructor === 'function' && val.constructor.name) || 'Object';
const isWindow = val => typeof window !== 'undefined' && val === window;
const SYMBOL_REGEXP = /^Symbol\((.*)\)(.*)$/;
const NEWLINE_REGEXP = /\n/gi;
class PrettyFormatPluginError extends Error {
  constructor(message, stack) {
    super(message);
    this.stack = stack;
    this.name = this.constructor.name;
  }
}
function isToStringedArrayType(toStringed) {
  return (
    toStringed === '[object Array]' ||
    toStringed === '[object ArrayBuffer]' ||
    toStringed === '[object DataView]' ||
    toStringed === '[object Float32Array]' ||
    toStringed === '[object Float64Array]' ||
    toStringed === '[object Int8Array]' ||
    toStringed === '[object Int16Array]' ||
    toStringed === '[object Int32Array]' ||
    toStringed === '[object Uint8Array]' ||
    toStringed === '[object Uint8ClampedArray]' ||
    toStringed === '[object Uint16Array]' ||
    toStringed === '[object Uint32Array]'
  );
}
function printNumber(val) {
  return Object.is(val, -0) ? '-0' : String(val);
}
function printBigInt(val) {
  return String(`${val}n`);
}
function printFunction(val, printFunctionName) {
  if (!printFunctionName) {
    return '[Function]';
  }
  return '[Function ' + (val.name || 'anonymous') + ']';
}
function printSymbol(val) {
  return symbolToString.call(val).replace(SYMBOL_REGEXP, 'Symbol($1)');
}
function printError(val) {
  return '[' + errorToString.call(val) + ']';
}
function printBasicValue(val, printFunctionName, escapeRegex, escapeString) {
  if (val === true || val === false) {
    return '' + val;
  }
  if (val === undefined) {
    return 'undefined';
  }
  if (val === null) {
    return 'null';
  }
  const typeOf = typeof val;
  if (typeOf === 'number') {
    return printNumber(val);
  }
  if (typeOf === 'bigint') {
    return printBigInt(val);
  }
  if (typeOf === 'string') {
    if (escapeString) {
      return '"' + val.replace(/"|\\/g, '\\$&') + '"';
    }
    return '"' + val + '"';
  }
  if (typeOf === 'function') {
    return printFunction(val, printFunctionName);
  }
  if (typeOf === 'symbol') {
    return printSymbol(val);
  }
  const toStringed = toString.call(val);
  if (toStringed === '[object WeakMap]') {
    return 'WeakMap {}';
  }
  if (toStringed === '[object WeakSet]') {
    return 'WeakSet {}';
  }
  if (
    toStringed === '[object Function]' ||
    toStringed === '[object GeneratorFunction]'
  ) {
    return printFunction(val, printFunctionName);
  }
  if (toStringed === '[object Symbol]') {
    return printSymbol(val);
  }
  if (toStringed === '[object Date]') {
    return isNaN(+val) ? 'Date { NaN }' : toISOString.call(val);
  }
  if (toStringed === '[object Error]') {
    return printError(val);
  }
  if (toStringed === '[object RegExp]') {
    if (escapeRegex) {
      return regExpToString.call(val).replace(/[\\^$*+?.()|[\]{}]/g, '\\$&');
    }
    return regExpToString.call(val);
  }
  if (val instanceof Error) {
    return printError(val);
  }
  return null;
}
function printComplexValue(
  val,
  config,
  indentation,
  depth,
  refs,
  hasCalledToJSON
) {
  if (refs.indexOf(val) !== -1) {
    return '[Circular]';
  }
  refs = refs.slice();
  refs.push(val);
  const hitMaxDepth = ++depth > config.maxDepth;
  const min = config.min;
  if (
    config.callToJSON &&
    !hitMaxDepth &&
    val.toJSON &&
    typeof val.toJSON === 'function' &&
    !hasCalledToJSON
  ) {
    return printer(val.toJSON(), config, indentation, depth, refs, true);
  }
  const toStringed = toString.call(val);
  if (toStringed === '[object Arguments]') {
    return hitMaxDepth
      ? '[Arguments]'
      : (min ? '' : 'Arguments ') +
          '[' +
          (0, _collections.printListItems)(
            val,
            config,
            indentation,
            depth,
            refs,
            printer
          ) +
          ']';
  }
  if (isToStringedArrayType(toStringed)) {
    return hitMaxDepth
      ? '[' + val.constructor.name + ']'
      : (min ? '' : val.constructor.name + ' ') +
          '[' +
          (0, _collections.printListItems)(
            val,
            config,
            indentation,
            depth,
            refs,
            printer
          ) +
          ']';
  }
  if (toStringed === '[object Map]') {
    return hitMaxDepth
      ? '[Map]'
      : 'Map {' +
          (0, _collections.printIteratorEntries)(
            val.entries(),
            config,
            indentation,
            depth,
            refs,
            printer,
            ' => '
          ) +
          '}';
  }
  if (toStringed === '[object Set]') {
    return hitMaxDepth
      ? '[Set]'
      : 'Set {' +
          (0, _collections.printIteratorValues)(
            val.values(),
            config,
            indentation,
            depth,
            refs,
            printer
          ) +
          '}';
  }
  return hitMaxDepth || isWindow(val)
    ? '[' + getConstructorName(val) + ']'
    : (min ? '' : getConstructorName(val) + ' ') +
        '{' +
        (0, _collections.printObjectProperties)(
          val,
          config,
          indentation,
          depth,
          refs,
          printer
        ) +
        '}';
}
function isNewPlugin(plugin) {
  return plugin.serialize != null;
}
function printPlugin(plugin, val, config, indentation, depth, refs) {
  let printed;
  try {
    printed = isNewPlugin(plugin)
      ? plugin.serialize(val, config, indentation, depth, refs, printer)
      : plugin.print(
          val,
          valChild => printer(valChild, config, indentation, depth, refs),
          str => {
            const indentationNext = indentation + config.indent;
            return (
              indentationNext +
              str.replace(NEWLINE_REGEXP, '\n' + indentationNext)
            );
          },
          {
            edgeSpacing: config.spacingOuter,
            min: config.min,
            spacing: config.spacingInner,
          },
          config.colors
        );
  } catch (error) {
    throw new PrettyFormatPluginError(error.message, error.stack);
  }
  if (typeof printed !== 'string') {
    throw new Error(
      `pretty-format: Plugin must return type "string" but instead returned "${typeof printed}".`
    );
  }
  return printed;
}
function findPlugin(plugins, val) {
  for (let p = 0; p < plugins.length; p++) {
    try {
      if (plugins[p].test(val)) {
        return plugins[p];
      }
    } catch (error) {
      throw new PrettyFormatPluginError(error.message, error.stack);
    }
  }
  return null;
}
function printer(val, config, indentation, depth, refs, hasCalledToJSON) {
  const plugin = findPlugin(config.plugins, val);
  if (plugin !== null) {
    return printPlugin(plugin, val, config, indentation, depth, refs);
  }
  const basicResult = printBasicValue(
    val,
    config.printFunctionName,
    config.escapeRegex,
    config.escapeString
  );
  if (basicResult !== null) {
    return basicResult;
  }
  return printComplexValue(
    val,
    config,
    indentation,
    depth,
    refs,
    hasCalledToJSON
  );
}
const DEFAULT_THEME = {
  comment: 'gray',
  content: 'reset',
  prop: 'yellow',
  tag: 'cyan',
  value: 'green',
};
const DEFAULT_THEME_KEYS = Object.keys(DEFAULT_THEME);
const DEFAULT_OPTIONS = {
  callToJSON: true,
  escapeRegex: false,
  escapeString: true,
  highlight: false,
  indent: 2,
  maxDepth: Infinity,
  min: false,
  plugins: [],
  printFunctionName: true,
  theme: DEFAULT_THEME,
};
function validateOptions(options) {
  Object.keys(options).forEach(key => {
    if (!DEFAULT_OPTIONS.hasOwnProperty(key)) {
      throw new Error(`pretty-format: Unknown option "${key}".`);
    }
  });
  if (options.min && options.indent !== undefined && options.indent !== 0) {
    throw new Error(
      'pretty-format: Options "min" and "indent" cannot be used together.'
    );
  }
  if (options.theme !== undefined) {
    if (options.theme === null) {
      throw new Error(`pretty-format: Option "theme" must not be null.`);
    }
    if (typeof options.theme !== 'object') {
      throw new Error(
        `pretty-format: Option "theme" must be of type "object" but instead received "${typeof options.theme}".`
      );
    }
  }
}
const getColorsHighlight = options =>
  DEFAULT_THEME_KEYS.reduce((colors, key) => {
    const value =
      options.theme && options.theme[key] !== undefined
        ? options.theme[key]
        : DEFAULT_THEME[key];
    const color = value && _ansiStyles.default[value];
    if (
      color &&
      typeof color.close === 'string' &&
      typeof color.open === 'string'
    ) {
      colors[key] = color;
    } else {
      throw new Error(
        `pretty-format: Option "theme" has a key "${key}" whose value "${value}" is undefined in ansi-styles.`
      );
    }
    return colors;
  }, Object.create(null));
const getColorsEmpty = () =>
  DEFAULT_THEME_KEYS.reduce((colors, key) => {
    colors[key] = {close: '', open: ''};
    return colors;
  }, Object.create(null));
const getPrintFunctionName = options =>
  options && options.printFunctionName !== undefined
    ? options.printFunctionName
    : DEFAULT_OPTIONS.printFunctionName;
const getEscapeRegex = options =>
  options && options.escapeRegex !== undefined
    ? options.escapeRegex
    : DEFAULT_OPTIONS.escapeRegex;
const getEscapeString = options =>
  options && options.escapeString !== undefined
    ? options.escapeString
    : DEFAULT_OPTIONS.escapeString;
const getConfig = options => ({
  callToJSON:
    options && options.callToJSON !== undefined
      ? options.callToJSON
      : DEFAULT_OPTIONS.callToJSON,
  colors:
    options && options.highlight
      ? getColorsHighlight(options)
      : getColorsEmpty(),
  escapeRegex: getEscapeRegex(options),
  escapeString: getEscapeString(options),
  indent:
    options && options.min
      ? ''
      : createIndent(
          options && options.indent !== undefined
            ? options.indent
            : DEFAULT_OPTIONS.indent
        ),
  maxDepth:
    options && options.maxDepth !== undefined
      ? options.maxDepth
      : DEFAULT_OPTIONS.maxDepth,
  min: options && options.min !== undefined ? options.min : DEFAULT_OPTIONS.min,
  plugins:
    options && options.plugins !== undefined
      ? options.plugins
      : DEFAULT_OPTIONS.plugins,
  printFunctionName: getPrintFunctionName(options),
  spacingInner: options && options.min ? ' ' : '\n',
  spacingOuter: options && options.min ? '' : '\n',
});
function createIndent(indent) {
  return new Array(indent + 1).join(' ');
}
function prettyFormat(val, options) {
  if (options) {
    validateOptions(options);
    if (options.plugins) {
      const plugin = findPlugin(options.plugins, val);
      if (plugin !== null) {
        return printPlugin(plugin, val, getConfig(options), '', 0, []);
      }
    }
  }
  const basicResult = printBasicValue(
    val,
    getPrintFunctionName(options),
    getEscapeRegex(options),
    getEscapeString(options)
  );
  if (basicResult !== null) {
    return basicResult;
  }
  return printComplexValue(val, getConfig(options), '', 0, []);
}
prettyFormat.plugins = {
  AsymmetricMatcher: _AsymmetricMatcher.default,
  ConvertAnsi: _ConvertAnsi.default,
  DOMCollection: _DOMCollection.default,
  DOMElement: _DOMElement.default,
  Immutable: _Immutable.default,
  ReactElement: _ReactElement.default,
  ReactTestComponent: _ReactTestComponent.default,
};
var build = prettyFormat;
var prettyFormat$1 = getDefaultExportFromCjs(build);
var _PostDominator_exit, _PostDominator_nodes;
function computePostDominatorTree(fn, options) {
  const graph = buildReverseGraph(fn, options.includeThrowsAsExitNode);
  const nodes = computeImmediateDominators(graph);
  if (!options.includeThrowsAsExitNode) {
    for (const [id] of fn.body.blocks) {
      if (!nodes.has(id)) {
        nodes.set(id, id);
      }
    }
  }
  return new PostDominator(graph.entry, nodes);
}
class PostDominator {
  constructor(exit, nodes) {
    _PostDominator_exit.set(this, void 0);
    _PostDominator_nodes.set(this, void 0);
    __classPrivateFieldSet(this, _PostDominator_exit, exit, 'f');
    __classPrivateFieldSet(this, _PostDominator_nodes, nodes, 'f');
  }
  get exit() {
    return __classPrivateFieldGet(this, _PostDominator_exit, 'f');
  }
  get(id) {
    const dominator = __classPrivateFieldGet(
      this,
      _PostDominator_nodes,
      'f'
    ).get(id);
    CompilerError.invariant(dominator !== undefined, {
      reason: 'Unknown node',
      description: null,
      loc: null,
      suggestions: null,
    });
    return dominator === id ? null : dominator;
  }
  debug() {
    const postDominators = new Map();
    for (const [key, value] of __classPrivateFieldGet(
      this,
      _PostDominator_nodes,
      'f'
    )) {
      postDominators.set(`bb${key}`, `bb${value}`);
    }
    return prettyFormat$1({
      exit: `bb${this.exit}`,
      postDominators: postDominators,
    });
  }
}
(_PostDominator_exit = new WeakMap()), (_PostDominator_nodes = new WeakMap());
function computeImmediateDominators(graph) {
  const nodes = new Map();
  nodes.set(graph.entry, graph.entry);
  let changed = true;
  while (changed) {
    changed = false;
    for (const [id, node] of graph.nodes) {
      if (node.id === graph.entry) {
        continue;
      }
      let newIdom = null;
      for (const pred of node.preds) {
        if (nodes.has(pred)) {
          newIdom = pred;
          break;
        }
      }
      CompilerError.invariant(newIdom !== null, {
        reason: `At least one predecessor must have been visited for block ${id}`,
        description: null,
        loc: null,
        suggestions: null,
      });
      for (const pred of node.preds) {
        if (pred === newIdom) {
          continue;
        }
        const predDom = nodes.get(pred);
        if (predDom !== undefined) {
          newIdom = intersect(pred, newIdom, graph, nodes);
        }
      }
      if (nodes.get(id) !== newIdom) {
        nodes.set(id, newIdom);
        changed = true;
      }
    }
  }
  return nodes;
}
function intersect(a, b, graph, nodes) {
  let block1 = graph.nodes.get(a);
  let block2 = graph.nodes.get(b);
  while (block1 !== block2) {
    while (block1.index > block2.index) {
      const dom = nodes.get(block1.id);
      block1 = graph.nodes.get(dom);
    }
    while (block2.index > block1.index) {
      const dom = nodes.get(block2.id);
      block2 = graph.nodes.get(dom);
    }
  }
  return block1.id;
}
function buildReverseGraph(fn, includeThrowsAsExitNode) {
  const nodes = new Map();
  const exitId = fn.env.nextBlockId;
  const exit = {id: exitId, index: 0, preds: new Set(), succs: new Set()};
  nodes.set(exitId, exit);
  for (const [id, block] of fn.body.blocks) {
    const node = {
      id: id,
      index: 0,
      preds: new Set(eachTerminalSuccessor(block.terminal)),
      succs: new Set(block.preds),
    };
    if (block.terminal.kind === 'return') {
      node.preds.add(exitId);
      exit.succs.add(id);
    } else if (block.terminal.kind === 'throw' && includeThrowsAsExitNode) {
      node.preds.add(exitId);
      exit.succs.add(id);
    }
    nodes.set(id, node);
  }
  const visited = new Set();
  const postorder = [];
  function visit(id) {
    if (visited.has(id)) {
      return;
    }
    visited.add(id);
    const node = nodes.get(id);
    for (const successor of node.succs) {
      visit(successor);
    }
    postorder.push(id);
  }
  visit(exitId);
  const rpo = {entry: exitId, nodes: new Map()};
  let index = 0;
  for (const id of postorder.reverse()) {
    const node = nodes.get(id);
    node.index = index++;
    rpo.nodes.set(id, node);
  }
  return rpo;
}
const identifierRegex = /[$_\p{ID_Start}][$\u200c\u200d\p{ID_Continue}]*/u;
function joinPath(path) {
  if (path.length === 1) {
    return path[0].toString();
  }
  return path.reduce((acc, item) => {
    if (typeof item === 'number') {
      return acc + '[' + item.toString() + ']';
    }
    if (item.includes('"')) {
      return acc + '["' + escapeQuotes(item) + '"]';
    }
    if (!identifierRegex.test(item)) {
      return acc + '["' + item + '"]';
    }
    const separator = acc.length === 0 ? '' : '.';
    return acc + separator + item;
  }, '');
}
function escapeQuotes(str) {
  return str.replace(/"/g, '\\"');
}
function isNonEmptyArray(value) {
  return value.length !== 0;
}
const MAX_ISSUES_IN_MESSAGE = 99;
const ISSUE_SEPARATOR = '; ';
const UNION_SEPARATOR = ', or ';
const PREFIX = 'Validation error';
const PREFIX_SEPARATOR = ': ';
class ValidationError extends Error {
  details;
  name;
  constructor(message, details = []) {
    super(message);
    this.details = details;
    this.name = 'ZodValidationError';
  }
  toString() {
    return this.message;
  }
}
function getMessageFromZodIssue(props) {
  const {
    issue: issue,
    issueSeparator: issueSeparator,
    unionSeparator: unionSeparator,
    includePath: includePath,
  } = props;
  if (issue.code === 'invalid_union') {
    return issue.unionErrors
      .reduce((acc, zodError) => {
        const newIssues = zodError.issues
          .map(issue =>
            getMessageFromZodIssue({
              issue: issue,
              issueSeparator: issueSeparator,
              unionSeparator: unionSeparator,
              includePath: includePath,
            })
          )
          .join(issueSeparator);
        if (!acc.includes(newIssues)) {
          acc.push(newIssues);
        }
        return acc;
      }, [])
      .join(unionSeparator);
  }
  if (includePath && isNonEmptyArray(issue.path)) {
    if (issue.path.length === 1) {
      const identifier = issue.path[0];
      if (typeof identifier === 'number') {
        return `${issue.message} at index ${identifier}`;
      }
    }
    return `${issue.message} at "${joinPath(issue.path)}"`;
  }
  return issue.message;
}
function conditionallyPrefixMessage(reason, prefix, prefixSeparator) {
  if (prefix !== null) {
    if (reason.length > 0) {
      return [prefix, reason].join(prefixSeparator);
    }
    return prefix;
  }
  if (reason.length > 0) {
    return reason;
  }
  return PREFIX;
}
function fromZodError(zodError, options = {}) {
  const {
    maxIssuesInMessage: maxIssuesInMessage = MAX_ISSUES_IN_MESSAGE,
    issueSeparator: issueSeparator = ISSUE_SEPARATOR,
    unionSeparator: unionSeparator = UNION_SEPARATOR,
    prefixSeparator: prefixSeparator = PREFIX_SEPARATOR,
    prefix: prefix = PREFIX,
    includePath: includePath = true,
  } = options;
  const reason = zodError.errors
    .slice(0, maxIssuesInMessage)
    .map(issue =>
      getMessageFromZodIssue({
        issue: issue,
        issueSeparator: issueSeparator,
        unionSeparator: unionSeparator,
        includePath: includePath,
      })
    )
    .join(issueSeparator);
  const message = conditionallyPrefixMessage(reason, prefix, prefixSeparator);
  return new ValidationError(message, zodError.errors);
}
const DEFAULT_SHAPES = new Map(BUILTIN_SHAPES);
const UNTYPED_GLOBALS = new Set([
  'String',
  'Object',
  'Function',
  'Number',
  'RegExp',
  'Date',
  'Error',
  'Function',
  'TypeError',
  'RangeError',
  'ReferenceError',
  'SyntaxError',
  'URIError',
  'EvalError',
  'Boolean',
  'DataView',
  'Float32Array',
  'Float64Array',
  'Int8Array',
  'Int16Array',
  'Int32Array',
  'Map',
  'Set',
  'WeakMap',
  'Uint8Array',
  'Uint8ClampedArray',
  'Uint16Array',
  'Uint32Array',
  'ArrayBuffer',
  'JSON',
  'parseFloat',
  'parseInt',
  'console',
  'isNaN',
  'eval',
  'isFinite',
  'encodeURI',
  'decodeURI',
  'encodeURIComponent',
  'decodeURIComponent',
]);
const TYPED_GLOBALS = [
  [
    'Array',
    addObject(DEFAULT_SHAPES, 'Array', [
      [
        'isArray',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [exports.Effect.Read],
          restParam: null,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'of',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Object', shapeId: BuiltInArrayId},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Mutable,
        }),
      ],
    ]),
  ],
  [
    'Math',
    addObject(DEFAULT_SHAPES, 'Math', [
      ['PI', {kind: 'Primitive'}],
      [
        'max',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'min',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'trunc',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'ceil',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'floor',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'pow',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
    ]),
  ],
  ['Infinity', {kind: 'Primitive'}],
  ['NaN', {kind: 'Primitive'}],
  [
    'console',
    addObject(DEFAULT_SHAPES, 'console', [
      [
        'error',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'info',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'log',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'table',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'trace',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
      [
        'warn',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Read,
          returnType: {kind: 'Primitive'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Primitive,
        }),
      ],
    ]),
  ],
  [
    'Boolean',
    addFunction(DEFAULT_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  [
    'Number',
    addFunction(DEFAULT_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
  [
    'String',
    addFunction(DEFAULT_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Read,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Primitive,
    }),
  ],
];
const REACT_APIS = [
  [
    'useContext',
    addHook(
      DEFAULT_SHAPES,
      {
        positionalParams: [],
        restParam: exports.Effect.Read,
        returnType: {kind: 'Poly'},
        calleeEffect: exports.Effect.Read,
        hookKind: 'useContext',
        returnValueKind: exports.ValueKind.Frozen,
        returnValueReason: ValueReason.Context,
      },
      BuiltInUseContextHookId
    ),
  ],
  [
    'useState',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Object', shapeId: BuiltInUseStateId},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useState',
      returnValueKind: exports.ValueKind.Frozen,
      returnValueReason: ValueReason.State,
    }),
  ],
  [
    'useActionState',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Object', shapeId: BuiltInUseActionStateId},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useActionState',
      returnValueKind: exports.ValueKind.Frozen,
      returnValueReason: ValueReason.State,
    }),
  ],
  [
    'useReducer',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Object', shapeId: BuiltInUseReducerId},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useReducer',
      returnValueKind: exports.ValueKind.Frozen,
      returnValueReason: ValueReason.ReducerState,
    }),
  ],
  [
    'useRef',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Capture,
      returnType: {kind: 'Object', shapeId: BuiltInUseRefId},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useRef',
      returnValueKind: exports.ValueKind.Mutable,
    }),
  ],
  [
    'useImperativeHandle',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Primitive'},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useImperativeHandle',
      returnValueKind: exports.ValueKind.Frozen,
    }),
  ],
  [
    'useMemo',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useMemo',
      returnValueKind: exports.ValueKind.Frozen,
    }),
  ],
  [
    'useCallback',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useCallback',
      returnValueKind: exports.ValueKind.Frozen,
    }),
  ],
  [
    'useEffect',
    addHook(
      DEFAULT_SHAPES,
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: {kind: 'Primitive'},
        calleeEffect: exports.Effect.Read,
        hookKind: 'useEffect',
        returnValueKind: exports.ValueKind.Frozen,
      },
      BuiltInUseEffectHookId
    ),
  ],
  [
    'useLayoutEffect',
    addHook(
      DEFAULT_SHAPES,
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: {kind: 'Poly'},
        calleeEffect: exports.Effect.Read,
        hookKind: 'useLayoutEffect',
        returnValueKind: exports.ValueKind.Frozen,
      },
      BuiltInUseLayoutEffectHookId
    ),
  ],
  [
    'useInsertionEffect',
    addHook(
      DEFAULT_SHAPES,
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: {kind: 'Poly'},
        calleeEffect: exports.Effect.Read,
        hookKind: 'useInsertionEffect',
        returnValueKind: exports.ValueKind.Frozen,
      },
      BuiltInUseInsertionEffectHookId
    ),
  ],
  [
    'useTransition',
    addHook(DEFAULT_SHAPES, {
      positionalParams: [],
      restParam: null,
      returnType: {kind: 'Object', shapeId: BuiltInUseTransitionId},
      calleeEffect: exports.Effect.Read,
      hookKind: 'useTransition',
      returnValueKind: exports.ValueKind.Frozen,
    }),
  ],
  [
    'use',
    addFunction(
      DEFAULT_SHAPES,
      [],
      {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: {kind: 'Poly'},
        calleeEffect: exports.Effect.Read,
        returnValueKind: exports.ValueKind.Frozen,
      },
      BuiltInUseOperatorId
    ),
  ],
];
TYPED_GLOBALS.push(
  [
    'React',
    addObject(DEFAULT_SHAPES, null, [
      ...REACT_APIS,
      [
        'createElement',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Freeze,
          returnType: {kind: 'Poly'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Frozen,
        }),
      ],
      [
        'cloneElement',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Freeze,
          returnType: {kind: 'Poly'},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Frozen,
        }),
      ],
      [
        'createRef',
        addFunction(DEFAULT_SHAPES, [], {
          positionalParams: [],
          restParam: exports.Effect.Capture,
          returnType: {kind: 'Object', shapeId: BuiltInUseRefId},
          calleeEffect: exports.Effect.Read,
          returnValueKind: exports.ValueKind.Mutable,
        }),
      ],
    ]),
  ],
  [
    '_jsx',
    addFunction(DEFAULT_SHAPES, [], {
      positionalParams: [],
      restParam: exports.Effect.Freeze,
      returnType: {kind: 'Poly'},
      calleeEffect: exports.Effect.Read,
      returnValueKind: exports.ValueKind.Frozen,
    }),
  ]
);
const DEFAULT_GLOBALS = new Map(REACT_APIS);
for (const name of UNTYPED_GLOBALS) {
  DEFAULT_GLOBALS.set(name, {kind: 'Poly'});
}
for (const [name, type_] of TYPED_GLOBALS) {
  DEFAULT_GLOBALS.set(name, type_);
}
DEFAULT_GLOBALS.set(
  'globalThis',
  addObject(DEFAULT_SHAPES, 'globalThis', TYPED_GLOBALS)
);
DEFAULT_GLOBALS.set(
  'global',
  addObject(DEFAULT_SHAPES, 'global', TYPED_GLOBALS)
);
function installTypeConfig(globals, shapes, typeConfig, moduleName, loc) {
  var _a, _b, _c, _d;
  switch (typeConfig.kind) {
    case 'type': {
      switch (typeConfig.name) {
        case 'Array': {
          return {kind: 'Object', shapeId: BuiltInArrayId};
        }
        case 'MixedReadonly': {
          return {kind: 'Object', shapeId: BuiltInMixedReadonlyId};
        }
        case 'Primitive': {
          return {kind: 'Primitive'};
        }
        case 'Ref': {
          return {kind: 'Object', shapeId: BuiltInUseRefId};
        }
        case 'Any': {
          return {kind: 'Poly'};
        }
        default: {
          assertExhaustive(
            typeConfig.name,
            `Unexpected type '${typeConfig.name}'`
          );
        }
      }
    }
    case 'function': {
      return addFunction(shapes, [], {
        positionalParams: typeConfig.positionalParams,
        restParam: typeConfig.restParam,
        calleeEffect: typeConfig.calleeEffect,
        returnType: installTypeConfig(
          globals,
          shapes,
          typeConfig.returnType,
          moduleName,
          loc
        ),
        returnValueKind: typeConfig.returnValueKind,
        noAlias: typeConfig.noAlias === true,
        mutableOnlyIfOperandsAreMutable:
          typeConfig.mutableOnlyIfOperandsAreMutable === true,
      });
    }
    case 'hook': {
      return addHook(shapes, {
        hookKind: 'Custom',
        positionalParams:
          (_a = typeConfig.positionalParams) !== null && _a !== void 0
            ? _a
            : [],
        restParam:
          (_b = typeConfig.restParam) !== null && _b !== void 0
            ? _b
            : exports.Effect.Freeze,
        calleeEffect: exports.Effect.Read,
        returnType: installTypeConfig(
          globals,
          shapes,
          typeConfig.returnType,
          moduleName,
          loc
        ),
        returnValueKind:
          (_c = typeConfig.returnValueKind) !== null && _c !== void 0
            ? _c
            : exports.ValueKind.Frozen,
        noAlias: typeConfig.noAlias === true,
      });
    }
    case 'object': {
      return addObject(
        shapes,
        null,
        Object.entries(
          (_d = typeConfig.properties) !== null && _d !== void 0 ? _d : {}
        ).map(([key, value]) => {
          var _a;
          const type = installTypeConfig(
            globals,
            shapes,
            value,
            moduleName,
            loc
          );
          const expectHook = isHookName$1(key);
          let isHook = false;
          if (type.kind === 'Function' && type.shapeId !== null) {
            const functionType = shapes.get(type.shapeId);
            if (
              ((_a =
                functionType === null || functionType === void 0
                  ? void 0
                  : functionType.functionType) === null || _a === void 0
                ? void 0
                : _a.hookKind) !== null
            ) {
              isHook = true;
            }
          }
          if (expectHook !== isHook) {
            CompilerError.throwInvalidConfig({
              reason: `Invalid type configuration for module`,
              description: `Expected type for object property '${key}' from module '${moduleName}' ${expectHook ? 'to be a hook' : 'not to be a hook'} based on the property name`,
              loc: loc,
            });
          }
          return [key, type];
        })
      );
    }
    default: {
      assertExhaustive(typeConfig, `Unexpected type kind '${typeConfig.kind}'`);
    }
  }
}
function getReanimatedModuleType(registry) {
  const frozenHooks = [
    'useFrameCallback',
    'useAnimatedStyle',
    'useAnimatedProps',
    'useAnimatedScrollHandler',
    'useAnimatedReaction',
    'useWorkletCallback',
  ];
  const reanimatedType = [];
  for (const hook of frozenHooks) {
    reanimatedType.push([
      hook,
      addHook(registry, {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: {kind: 'Poly'},
        returnValueKind: exports.ValueKind.Frozen,
        noAlias: true,
        calleeEffect: exports.Effect.Read,
        hookKind: 'Custom',
      }),
    ]);
  }
  const mutableHooks = ['useSharedValue', 'useDerivedValue'];
  for (const hook of mutableHooks) {
    reanimatedType.push([
      hook,
      addHook(registry, {
        positionalParams: [],
        restParam: exports.Effect.Freeze,
        returnType: {kind: 'Poly'},
        returnValueKind: exports.ValueKind.Mutable,
        noAlias: true,
        calleeEffect: exports.Effect.Read,
        hookKind: 'Custom',
      }),
    ]);
  }
  const funcs = [
    'withTiming',
    'withSpring',
    'createAnimatedPropAdapter',
    'withDecay',
    'withRepeat',
    'runOnUI',
    'executeOnUIRuntimeSync',
  ];
  for (const fn of funcs) {
    reanimatedType.push([
      fn,
      addFunction(registry, [], {
        positionalParams: [],
        restParam: exports.Effect.Read,
        returnType: {kind: 'Poly'},
        calleeEffect: exports.Effect.Read,
        returnValueKind: exports.ValueKind.Mutable,
        noAlias: true,
      }),
    ]);
  }
  return addObject(registry, null, reanimatedType);
}
const ObjectPropertiesSchema = z
  .record(
    z.string(),
    z.lazy(() => TypeSchema)
  )
  .refine(
    record =>
      Object.keys(record).every(
        key => key === '*' || key === 'default' || t$d.isValidIdentifier(key)
      ),
    'Expected all "object" property names to be valid identifier, `*` to match any property, of `default` to define a module default export'
  );
const ObjectTypeSchema = z.object({
  kind: z.literal('object'),
  properties: ObjectPropertiesSchema.nullable(),
});
const FunctionTypeSchema = z.object({
  kind: z.literal('function'),
  positionalParams: z.array(EffectSchema),
  restParam: EffectSchema.nullable(),
  calleeEffect: EffectSchema,
  returnType: z.lazy(() => TypeSchema),
  returnValueKind: ValueKindSchema,
  noAlias: z.boolean().nullable().optional(),
  mutableOnlyIfOperandsAreMutable: z.boolean().nullable().optional(),
});
const HookTypeSchema = z.object({
  kind: z.literal('hook'),
  positionalParams: z.array(EffectSchema).nullable().optional(),
  restParam: EffectSchema.nullable().optional(),
  returnType: z.lazy(() => TypeSchema),
  returnValueKind: ValueKindSchema.nullable().optional(),
  noAlias: z.boolean().nullable().optional(),
});
const BuiltInTypeSchema = z.union([
  z.literal('Any'),
  z.literal('Ref'),
  z.literal('Array'),
  z.literal('Primitive'),
  z.literal('MixedReadonly'),
]);
const TypeReferenceSchema = z.object({
  kind: z.literal('type'),
  name: BuiltInTypeSchema,
});
const TypeSchema = z.union([
  ObjectTypeSchema,
  FunctionTypeSchema,
  HookTypeSchema,
  TypeReferenceSchema,
]);
var _Environment_instances,
  _Environment_globals,
  _Environment_shapes,
  _Environment_moduleTypes,
  _Environment_nextIdentifer,
  _Environment_nextBlock,
  _Environment_nextScope,
  _Environment_scope,
  _Environment_outlinedFunctions,
  _Environment_contextIdentifiers,
  _Environment_hoistedIdentifiers,
  _Environment_resolveModuleType,
  _Environment_isKnownReactModule,
  _Environment_getCustomHookType;
const ReactElementSymbolSchema = z.object({
  elementSymbol: z.union([
    z.literal('react.element'),
    z.literal('react.transitional.element'),
  ]),
  globalDevVar: z.string(),
});
const ExternalFunctionSchema = z.object({
  source: z.string(),
  importSpecifierName: z.string(),
});
const InstrumentationSchema = z
  .object({
    fn: ExternalFunctionSchema,
    gating: ExternalFunctionSchema.nullable(),
    globalGating: z.string().nullable(),
  })
  .refine(
    opts => opts.gating != null || opts.globalGating != null,
    'Expected at least one of gating or globalGating'
  );
const MacroMethodSchema = z.union([
  z.object({type: z.literal('wildcard')}),
  z.object({type: z.literal('name'), name: z.string()}),
]);
const MacroSchema = z.union([
  z.string(),
  z.tuple([z.string(), z.array(MacroMethodSchema)]),
]);
const HookSchema = z.object({
  effectKind: z.nativeEnum(exports.Effect),
  valueKind: z.nativeEnum(exports.ValueKind),
  noAlias: z.boolean().default(false),
  transitiveMixedData: z.boolean().default(false),
});
const EnvironmentConfigSchema = z.object({
  customHooks: z.map(z.string(), HookSchema).default(new Map()),
  moduleTypeProvider: z.nullable(z.function().args(z.string())).default(null),
  customMacros: z.nullable(z.array(MacroSchema)).default(null),
  enableResetCacheOnSourceFileChanges: z.boolean().default(false),
  enablePreserveExistingMemoizationGuarantees: z.boolean().default(false),
  validatePreserveExistingMemoizationGuarantees: z.boolean().default(true),
  enablePreserveExistingManualUseMemo: z.boolean().default(false),
  enableForest: z.boolean().default(false),
  enableUseTypeAnnotations: z.boolean().default(false),
  enableFunctionDependencyRewrite: z.boolean().default(true),
  enableOptionalDependencies: z.boolean().default(true),
  inferEffectDependencies: z
    .nullable(
      z.array(
        z.object({
          function: ExternalFunctionSchema,
          numRequiredArgs: z.number(),
        })
      )
    )
    .default(null),
  inlineJsxTransform: ReactElementSymbolSchema.nullable().default(null),
  validateHooksUsage: z.boolean().default(true),
  validateRefAccessDuringRender: z.boolean().default(true),
  validateNoSetStateInRender: z.boolean().default(true),
  validateNoSetStateInPassiveEffects: z.boolean().default(false),
  validateNoJSXInTryStatements: z.boolean().default(false),
  validateMemoizedEffectDependencies: z.boolean().default(false),
  validateNoCapitalizedCalls: z.nullable(z.array(z.string())).default(null),
  validateBlocklistedImports: z.nullable(z.array(z.string())).default(null),
  enableAssumeHooksFollowRulesOfReact: z.boolean().default(true),
  enableTransitivelyFreezeFunctionExpressions: z.boolean().default(true),
  enableEmitFreeze: ExternalFunctionSchema.nullable().default(null),
  enableEmitHookGuards: ExternalFunctionSchema.nullable().default(null),
  enableInstructionReordering: z.boolean().default(false),
  enableFunctionOutlining: z.boolean().default(true),
  enableJsxOutlining: z.boolean().default(false),
  enableEmitInstrumentForget: InstrumentationSchema.nullable().default(null),
  assertValidMutableRanges: z.boolean().default(false),
  enableChangeVariableCodegen: z.boolean().default(false),
  enableMemoizationComments: z.boolean().default(false),
  throwUnknownException__testonly: z.boolean().default(false),
  enableTreatFunctionDepsAsConditional: z.boolean().default(false),
  disableMemoizationForDebugging: z.boolean().default(false),
  enableChangeDetectionForDebugging:
    ExternalFunctionSchema.nullable().default(null),
  enableCustomTypeDefinitionForReanimated: z.boolean().default(false),
  hookPattern: z.string().nullable().default(null),
  enableTreatRefLikeIdentifiersAsRefs: z.boolean().default(false),
  lowerContextAccess: ExternalFunctionSchema.nullable().default(null),
});
const testComplexConfigDefaults = {
  validateNoCapitalizedCalls: [],
  enableChangeDetectionForDebugging: {
    source: 'react-compiler-runtime',
    importSpecifierName: '$structuralCheck',
  },
  enableEmitFreeze: {
    source: 'react-compiler-runtime',
    importSpecifierName: 'makeReadOnly',
  },
  enableEmitInstrumentForget: {
    fn: {
      source: 'react-compiler-runtime',
      importSpecifierName: 'useRenderCounter',
    },
    gating: {
      source: 'react-compiler-runtime',
      importSpecifierName: 'shouldInstrument',
    },
    globalGating: '__DEV__',
  },
  enableEmitHookGuards: {
    source: 'react-compiler-runtime',
    importSpecifierName: '$dispatcherGuard',
  },
  inlineJsxTransform: {
    elementSymbol: 'react.transitional.element',
    globalDevVar: 'DEV',
  },
  lowerContextAccess: {
    source: 'react-compiler-runtime',
    importSpecifierName: 'useContext_withSelector',
  },
  inferEffectDependencies: [
    {
      function: {source: 'react', importSpecifierName: 'useEffect'},
      numRequiredArgs: 1,
    },
    {
      function: {
        source: 'shared-runtime',
        importSpecifierName: 'useSpecialEffect',
      },
      numRequiredArgs: 2,
    },
  ],
};
function parseConfigPragmaForTests(pragma) {
  const maybeConfig = {};
  const defaultConfig = EnvironmentConfigSchema.parse({});
  for (const token of pragma.split(' ')) {
    if (!token.startsWith('@')) {
      continue;
    }
    const keyVal = token.slice(1);
    let [key, val = undefined] = keyVal.split(':');
    const isSet = val === undefined || val === 'true';
    if (isSet && key in testComplexConfigDefaults) {
      maybeConfig[key] = testComplexConfigDefaults[key];
      continue;
    }
    if (key === 'customMacros' && val) {
      const valSplit = val.split('.');
      if (valSplit.length > 0) {
        const props = [];
        for (const elt of valSplit.slice(1)) {
          if (elt === '*') {
            props.push({type: 'wildcard'});
          } else if (elt.length > 0) {
            props.push({type: 'name', name: elt});
          }
        }
        maybeConfig[key] = [[valSplit[0], props]];
      }
      continue;
    }
    if (typeof defaultConfig[key] !== 'boolean') {
      continue;
    }
    if (val === undefined || val === 'true') {
      maybeConfig[key] = true;
    } else {
      maybeConfig[key] = false;
    }
  }
  const config = EnvironmentConfigSchema.safeParse(maybeConfig);
  if (config.success) {
    return config.data;
  }
  CompilerError.invariant(false, {
    reason: 'Internal error, could not parse config from pragma string',
    description: `${fromZodError(config.error)}`,
    loc: null,
    suggestions: null,
  });
}
class Environment {
  constructor(
    scope,
    fnType,
    config,
    contextIdentifiers,
    logger,
    filename,
    code,
    useMemoCacheIdentifier
  ) {
    _Environment_instances.add(this);
    _Environment_globals.set(this, void 0);
    _Environment_shapes.set(this, void 0);
    _Environment_moduleTypes.set(this, new Map());
    _Environment_nextIdentifer.set(this, 0);
    _Environment_nextBlock.set(this, 0);
    _Environment_nextScope.set(this, 0);
    _Environment_scope.set(this, void 0);
    _Environment_outlinedFunctions.set(this, []);
    _Environment_contextIdentifiers.set(this, void 0);
    _Environment_hoistedIdentifiers.set(this, void 0);
    __classPrivateFieldSet(this, _Environment_scope, scope, 'f');
    this.fnType = fnType;
    this.config = config;
    this.filename = filename;
    this.code = code;
    this.logger = logger;
    this.useMemoCacheIdentifier = useMemoCacheIdentifier;
    __classPrivateFieldSet(
      this,
      _Environment_shapes,
      new Map(DEFAULT_SHAPES),
      'f'
    );
    __classPrivateFieldSet(
      this,
      _Environment_globals,
      new Map(DEFAULT_GLOBALS),
      'f'
    );
    this.hasLoweredContextAccess = false;
    if (
      config.disableMemoizationForDebugging &&
      config.enableChangeDetectionForDebugging != null
    ) {
      CompilerError.throwInvalidConfig({
        reason: `Invalid environment config: the 'disableMemoizationForDebugging' and 'enableChangeDetectionForDebugging' options cannot be used together`,
        description: null,
        loc: null,
        suggestions: null,
      });
    }
    for (const [hookName, hook] of this.config.customHooks) {
      CompilerError.invariant(
        !__classPrivateFieldGet(this, _Environment_globals, 'f').has(hookName),
        {
          reason: `[Globals] Found existing definition in global registry for custom hook ${hookName}`,
          description: null,
          loc: null,
          suggestions: null,
        }
      );
      __classPrivateFieldGet(this, _Environment_globals, 'f').set(
        hookName,
        addHook(__classPrivateFieldGet(this, _Environment_shapes, 'f'), {
          positionalParams: [],
          restParam: hook.effectKind,
          returnType: hook.transitiveMixedData
            ? {kind: 'Object', shapeId: BuiltInMixedReadonlyId}
            : {kind: 'Poly'},
          returnValueKind: hook.valueKind,
          calleeEffect: exports.Effect.Read,
          hookKind: 'Custom',
          noAlias: hook.noAlias,
        })
      );
    }
    if (config.enableCustomTypeDefinitionForReanimated) {
      const reanimatedModuleType = getReanimatedModuleType(
        __classPrivateFieldGet(this, _Environment_shapes, 'f')
      );
      __classPrivateFieldGet(this, _Environment_moduleTypes, 'f').set(
        REANIMATED_MODULE_NAME,
        reanimatedModuleType
      );
    }
    __classPrivateFieldSet(
      this,
      _Environment_contextIdentifiers,
      contextIdentifiers,
      'f'
    );
    __classPrivateFieldSet(
      this,
      _Environment_hoistedIdentifiers,
      new Set(),
      'f'
    );
  }
  get nextIdentifierId() {
    var _a, _b;
    return makeIdentifierId(
      (__classPrivateFieldSet(
        this,
        _Environment_nextIdentifer,
        ((_b = __classPrivateFieldGet(this, _Environment_nextIdentifer, 'f')),
        (_a = _b++),
        _b),
        'f'
      ),
      _a)
    );
  }
  get nextBlockId() {
    var _a, _b;
    return makeBlockId(
      (__classPrivateFieldSet(
        this,
        _Environment_nextBlock,
        ((_b = __classPrivateFieldGet(this, _Environment_nextBlock, 'f')),
        (_a = _b++),
        _b),
        'f'
      ),
      _a)
    );
  }
  get nextScopeId() {
    var _a, _b;
    return makeScopeId(
      (__classPrivateFieldSet(
        this,
        _Environment_nextScope,
        ((_b = __classPrivateFieldGet(this, _Environment_nextScope, 'f')),
        (_a = _b++),
        _b),
        'f'
      ),
      _a)
    );
  }
  isContextIdentifier(node) {
    return __classPrivateFieldGet(
      this,
      _Environment_contextIdentifiers,
      'f'
    ).has(node);
  }
  isHoistedIdentifier(node) {
    return __classPrivateFieldGet(
      this,
      _Environment_hoistedIdentifiers,
      'f'
    ).has(node);
  }
  generateGloballyUniqueIdentifierName(name) {
    const identifierNode = __classPrivateFieldGet(
      this,
      _Environment_scope,
      'f'
    ).generateUidIdentifier(
      name !== null && name !== void 0 ? name : undefined
    );
    return makeIdentifierName(identifierNode.name);
  }
  outlineFunction(fn, type) {
    __classPrivateFieldGet(this, _Environment_outlinedFunctions, 'f').push({
      fn: fn,
      type: type,
    });
  }
  getOutlinedFunctions() {
    return __classPrivateFieldGet(this, _Environment_outlinedFunctions, 'f');
  }
  getGlobalDeclaration(binding, loc) {
    var _a, _b, _c, _d;
    if (this.config.hookPattern != null) {
      const match = new RegExp(this.config.hookPattern).exec(binding.name);
      if (
        match != null &&
        typeof match[1] === 'string' &&
        isHookName$1(match[1])
      ) {
        const resolvedName = match[1];
        return (_a = __classPrivateFieldGet(
          this,
          _Environment_globals,
          'f'
        ).get(resolvedName)) !== null && _a !== void 0
          ? _a
          : __classPrivateFieldGet(
              this,
              _Environment_instances,
              'm',
              _Environment_getCustomHookType
            ).call(this);
      }
    }
    switch (binding.kind) {
      case 'ModuleLocal': {
        return isHookName$1(binding.name)
          ? __classPrivateFieldGet(
              this,
              _Environment_instances,
              'm',
              _Environment_getCustomHookType
            ).call(this)
          : null;
      }
      case 'Global': {
        return (_b = __classPrivateFieldGet(
          this,
          _Environment_globals,
          'f'
        ).get(binding.name)) !== null && _b !== void 0
          ? _b
          : isHookName$1(binding.name)
            ? __classPrivateFieldGet(
                this,
                _Environment_instances,
                'm',
                _Environment_getCustomHookType
              ).call(this)
            : null;
      }
      case 'ImportSpecifier': {
        if (
          __classPrivateFieldGet(
            this,
            _Environment_instances,
            'm',
            _Environment_isKnownReactModule
          ).call(this, binding.module)
        ) {
          return (_c = __classPrivateFieldGet(
            this,
            _Environment_globals,
            'f'
          ).get(binding.imported)) !== null && _c !== void 0
            ? _c
            : isHookName$1(binding.imported) || isHookName$1(binding.name)
              ? __classPrivateFieldGet(
                  this,
                  _Environment_instances,
                  'm',
                  _Environment_getCustomHookType
                ).call(this)
              : null;
        } else {
          const moduleType = __classPrivateFieldGet(
            this,
            _Environment_instances,
            'm',
            _Environment_resolveModuleType
          ).call(this, binding.module, loc);
          if (moduleType !== null) {
            const importedType = this.getPropertyType(
              moduleType,
              binding.imported
            );
            if (importedType != null) {
              const expectHook = isHookName$1(binding.imported);
              const isHook = getHookKindForType(this, importedType) != null;
              if (expectHook !== isHook) {
                CompilerError.throwInvalidConfig({
                  reason: `Invalid type configuration for module`,
                  description: `Expected type for \`import {${binding.imported}} from '${binding.module}'\` ${expectHook ? 'to be a hook' : 'not to be a hook'} based on the exported name`,
                  loc: loc,
                });
              }
              return importedType;
            }
          }
          return isHookName$1(binding.imported) || isHookName$1(binding.name)
            ? __classPrivateFieldGet(
                this,
                _Environment_instances,
                'm',
                _Environment_getCustomHookType
              ).call(this)
            : null;
        }
      }
      case 'ImportDefault':
      case 'ImportNamespace': {
        if (
          __classPrivateFieldGet(
            this,
            _Environment_instances,
            'm',
            _Environment_isKnownReactModule
          ).call(this, binding.module)
        ) {
          return (_d = __classPrivateFieldGet(
            this,
            _Environment_globals,
            'f'
          ).get(binding.name)) !== null && _d !== void 0
            ? _d
            : isHookName$1(binding.name)
              ? __classPrivateFieldGet(
                  this,
                  _Environment_instances,
                  'm',
                  _Environment_getCustomHookType
                ).call(this)
              : null;
        } else {
          const moduleType = __classPrivateFieldGet(
            this,
            _Environment_instances,
            'm',
            _Environment_resolveModuleType
          ).call(this, binding.module, loc);
          if (moduleType !== null) {
            let importedType = null;
            if (binding.kind === 'ImportDefault') {
              const defaultType = this.getPropertyType(moduleType, 'default');
              if (defaultType !== null) {
                importedType = defaultType;
              }
            } else {
              importedType = moduleType;
            }
            if (importedType !== null) {
              const expectHook = isHookName$1(binding.module);
              const isHook = getHookKindForType(this, importedType) != null;
              if (expectHook !== isHook) {
                CompilerError.throwInvalidConfig({
                  reason: `Invalid type configuration for module`,
                  description: `Expected type for \`import ... from '${binding.module}'\` ${expectHook ? 'to be a hook' : 'not to be a hook'} based on the module name`,
                  loc: loc,
                });
              }
              return importedType;
            }
          }
          return isHookName$1(binding.name)
            ? __classPrivateFieldGet(
                this,
                _Environment_instances,
                'm',
                _Environment_getCustomHookType
              ).call(this)
            : null;
        }
      }
    }
  }
  getPropertyType(receiver, property) {
    var _a, _b;
    let shapeId = null;
    if (receiver.kind === 'Object' || receiver.kind === 'Function') {
      shapeId = receiver.shapeId;
    }
    if (shapeId !== null) {
      const shape = __classPrivateFieldGet(this, _Environment_shapes, 'f').get(
        shapeId
      );
      CompilerError.invariant(shape !== undefined, {
        reason: `[HIR] Forget internal error: cannot resolve shape ${shapeId}`,
        description: null,
        loc: null,
        suggestions: null,
      });
      let value =
        (_b =
          (_a = shape.properties.get(property)) !== null && _a !== void 0
            ? _a
            : shape.properties.get('*')) !== null && _b !== void 0
          ? _b
          : null;
      if (value === null && isHookName$1(property)) {
        value = __classPrivateFieldGet(
          this,
          _Environment_instances,
          'm',
          _Environment_getCustomHookType
        ).call(this);
      }
      return value;
    } else if (isHookName$1(property)) {
      return __classPrivateFieldGet(
        this,
        _Environment_instances,
        'm',
        _Environment_getCustomHookType
      ).call(this);
    } else {
      return null;
    }
  }
  getFunctionSignature(type) {
    const {shapeId: shapeId} = type;
    if (shapeId !== null) {
      const shape = __classPrivateFieldGet(this, _Environment_shapes, 'f').get(
        shapeId
      );
      CompilerError.invariant(shape !== undefined, {
        reason: `[HIR] Forget internal error: cannot resolve shape ${shapeId}`,
        description: null,
        loc: null,
        suggestions: null,
      });
      return shape.functionType;
    }
    return null;
  }
  addHoistedIdentifier(node) {
    __classPrivateFieldGet(this, _Environment_contextIdentifiers, 'f').add(
      node
    );
    __classPrivateFieldGet(this, _Environment_hoistedIdentifiers, 'f').add(
      node
    );
  }
}
(_Environment_globals = new WeakMap()),
  (_Environment_shapes = new WeakMap()),
  (_Environment_moduleTypes = new WeakMap()),
  (_Environment_nextIdentifer = new WeakMap()),
  (_Environment_nextBlock = new WeakMap()),
  (_Environment_nextScope = new WeakMap()),
  (_Environment_scope = new WeakMap()),
  (_Environment_outlinedFunctions = new WeakMap()),
  (_Environment_contextIdentifiers = new WeakMap()),
  (_Environment_hoistedIdentifiers = new WeakMap()),
  (_Environment_instances = new WeakSet()),
  (_Environment_resolveModuleType = function _Environment_resolveModuleType(
    moduleName,
    loc
  ) {
    let moduleType = __classPrivateFieldGet(
      this,
      _Environment_moduleTypes,
      'f'
    ).get(moduleName);
    if (moduleType === undefined) {
      if (this.config.moduleTypeProvider == null) {
        return null;
      }
      const unparsedModuleConfig = this.config.moduleTypeProvider(moduleName);
      if (unparsedModuleConfig != null) {
        const parsedModuleConfig = TypeSchema.safeParse(unparsedModuleConfig);
        if (!parsedModuleConfig.success) {
          CompilerError.throwInvalidConfig({
            reason: `Could not parse module type, the configured \`moduleTypeProvider\` function returned an invalid module description`,
            description: parsedModuleConfig.error.toString(),
            loc: loc,
          });
        }
        const moduleConfig = parsedModuleConfig.data;
        moduleType = installTypeConfig(
          __classPrivateFieldGet(this, _Environment_globals, 'f'),
          __classPrivateFieldGet(this, _Environment_shapes, 'f'),
          moduleConfig,
          moduleName,
          loc
        );
      } else {
        moduleType = null;
      }
      __classPrivateFieldGet(this, _Environment_moduleTypes, 'f').set(
        moduleName,
        moduleType
      );
    }
    return moduleType;
  }),
  (_Environment_isKnownReactModule = function _Environment_isKnownReactModule(
    moduleName
  ) {
    return (
      moduleName.toLowerCase() === 'react' ||
      moduleName.toLowerCase() === 'react-dom'
    );
  }),
  (_Environment_getCustomHookType = function _Environment_getCustomHookType() {
    if (this.config.enableAssumeHooksFollowRulesOfReact) {
      return DefaultNonmutatingHook;
    } else {
      return DefaultMutatingHook;
    }
  });
const REANIMATED_MODULE_NAME = 'react-native-reanimated';
function isHookName$1(name) {
  return /^use[A-Z0-9]/.test(name);
}
function parseEnvironmentConfig(partialConfig) {
  const config = EnvironmentConfigSchema.safeParse(partialConfig);
  if (config.success) {
    return Ok(config.data);
  } else {
    return Err(config.error);
  }
}
function validateEnvironmentConfig(partialConfig) {
  const config = EnvironmentConfigSchema.safeParse(partialConfig);
  if (config.success) {
    return config.data;
  }
  CompilerError.throwInvalidConfig({
    reason:
      'Could not validate environment config. Update React Compiler config to fix the error',
    description: `${fromZodError(config.error)}`,
    loc: null,
    suggestions: null,
  });
}
function tryParseExternalFunction(maybeExternalFunction) {
  const externalFunction = ExternalFunctionSchema.safeParse(
    maybeExternalFunction
  );
  if (externalFunction.success) {
    return externalFunction.data;
  }
  CompilerError.throwInvalidConfig({
    reason:
      'Could not parse external function. Update React Compiler config to fix the error',
    description: `${fromZodError(externalFunction.error)}`,
    loc: null,
    suggestions: null,
  });
}
var _MergedBlocks_map;
function mergeConsecutiveBlocks(fn) {
  const merged = new MergedBlocks();
  const fallthroughBlocks = new Set();
  for (const [, block] of fn.body.blocks) {
    const fallthrough = terminalFallthrough(block.terminal);
    if (fallthrough !== null) {
      fallthroughBlocks.add(fallthrough);
    }
    for (const instr of block.instructions) {
      if (
        instr.value.kind === 'FunctionExpression' ||
        instr.value.kind === 'ObjectMethod'
      ) {
        mergeConsecutiveBlocks(instr.value.loweredFunc.func);
      }
    }
    if (
      block.preds.size !== 1 ||
      block.kind !== 'block' ||
      fallthroughBlocks.has(block.id)
    ) {
      continue;
    }
    const originalPredecessorId = Array.from(block.preds)[0];
    const predecessorId = merged.get(originalPredecessorId);
    const predecessor = fn.body.blocks.get(predecessorId);
    CompilerError.invariant(predecessor !== undefined, {
      reason: `Expected predecessor ${predecessorId} to exist`,
      description: null,
      loc: null,
      suggestions: null,
    });
    if (predecessor.terminal.kind !== 'goto' || predecessor.kind !== 'block') {
      continue;
    }
    for (const phi of block.phis) {
      CompilerError.invariant(phi.operands.size === 1, {
        reason: `Found a block with a single predecessor but where a phi has multiple (${phi.operands.size}) operands`,
        description: null,
        loc: null,
        suggestions: null,
      });
      const operand = Array.from(phi.operands.values())[0];
      const instr = {
        id: predecessor.terminal.id,
        lvalue: {
          kind: 'Identifier',
          identifier: phi.place.identifier,
          effect: exports.Effect.ConditionallyMutate,
          reactive: false,
          loc: GeneratedSource,
        },
        value: {
          kind: 'LoadLocal',
          place: Object.assign({}, operand),
          loc: GeneratedSource,
        },
        loc: GeneratedSource,
      };
      predecessor.instructions.push(instr);
    }
    predecessor.instructions.push(...block.instructions);
    predecessor.terminal = block.terminal;
    merged.merge(block.id, predecessorId);
    fn.body.blocks.delete(block.id);
  }
  markPredecessors(fn.body);
  for (const [, {terminal: terminal}] of fn.body.blocks) {
    if (terminalHasFallthrough(terminal)) {
      terminal.fallthrough = merged.get(terminal.fallthrough);
    }
  }
}
class MergedBlocks {
  constructor() {
    _MergedBlocks_map.set(this, new Map());
  }
  merge(block, into) {
    const target = this.get(into);
    __classPrivateFieldGet(this, _MergedBlocks_map, 'f').set(block, target);
  }
  get(block) {
    var _a;
    let current = block;
    while (__classPrivateFieldGet(this, _MergedBlocks_map, 'f').has(current)) {
      current =
        (_a = __classPrivateFieldGet(this, _MergedBlocks_map, 'f').get(
          current
        )) !== null && _a !== void 0
          ? _a
          : current;
    }
    return current;
  }
}
_MergedBlocks_map = new WeakMap();
var _DisjointSet_entries;
class DisjointSet {
  constructor() {
    _DisjointSet_entries.set(this, new Map());
  }
  union(items) {
    const first = items.shift();
    CompilerError.invariant(first != null, {
      reason: 'Expected set to be non-empty',
      description: null,
      loc: null,
      suggestions: null,
    });
    let root = this.find(first);
    if (root == null) {
      root = first;
      __classPrivateFieldGet(this, _DisjointSet_entries, 'f').set(first, first);
    }
    for (const item of items) {
      let itemParent = __classPrivateFieldGet(
        this,
        _DisjointSet_entries,
        'f'
      ).get(item);
      if (itemParent == null) {
        __classPrivateFieldGet(this, _DisjointSet_entries, 'f').set(item, root);
        continue;
      } else if (itemParent === root) {
        continue;
      } else {
        let current = item;
        while (itemParent !== root) {
          __classPrivateFieldGet(this, _DisjointSet_entries, 'f').set(
            current,
            root
          );
          current = itemParent;
          itemParent = __classPrivateFieldGet(
            this,
            _DisjointSet_entries,
            'f'
          ).get(current);
        }
      }
    }
  }
  find(item) {
    if (!__classPrivateFieldGet(this, _DisjointSet_entries, 'f').has(item)) {
      return null;
    }
    const parent = __classPrivateFieldGet(this, _DisjointSet_entries, 'f').get(
      item
    );
    if (parent === item) {
      return item;
    }
    const root = this.find(parent);
    __classPrivateFieldGet(this, _DisjointSet_entries, 'f').set(item, root);
    return root;
  }
  canonicalize() {
    const entries = new Map();
    for (const item of __classPrivateFieldGet(
      this,
      _DisjointSet_entries,
      'f'
    ).keys()) {
      const root = this.find(item);
      entries.set(item, root);
    }
    return entries;
  }
  forEach(fn) {
    for (const item of __classPrivateFieldGet(
      this,
      _DisjointSet_entries,
      'f'
    ).keys()) {
      const group = this.find(item);
      fn(item, group);
    }
  }
  buildSets() {
    const ids = new Map();
    const sets = new Map();
    this.forEach((identifier, groupIdentifier) => {
      let id = ids.get(groupIdentifier);
      if (id == null) {
        id = ids.size;
        ids.set(groupIdentifier, id);
      }
      let set = sets.get(id);
      if (set === undefined) {
        set = new Set();
        sets.set(id, set);
      }
      set.add(identifier);
    });
    return [...sets.values()];
  }
  get size() {
    return __classPrivateFieldGet(this, _DisjointSet_entries, 'f').size;
  }
}
_DisjointSet_entries = new WeakMap();
var ansiStyles$1 = {exports: {}};
var colorName;
var hasRequiredColorName;
function requireColorName() {
  if (hasRequiredColorName) return colorName;
  hasRequiredColorName = 1;
  colorName = {
    aliceblue: [240, 248, 255],
    antiquewhite: [250, 235, 215],
    aqua: [0, 255, 255],
    aquamarine: [127, 255, 212],
    azure: [240, 255, 255],
    beige: [245, 245, 220],
    bisque: [255, 228, 196],
    black: [0, 0, 0],
    blanchedalmond: [255, 235, 205],
    blue: [0, 0, 255],
    blueviolet: [138, 43, 226],
    brown: [165, 42, 42],
    burlywood: [222, 184, 135],
    cadetblue: [95, 158, 160],
    chartreuse: [127, 255, 0],
    chocolate: [210, 105, 30],
    coral: [255, 127, 80],
    cornflowerblue: [100, 149, 237],
    cornsilk: [255, 248, 220],
    crimson: [220, 20, 60],
    cyan: [0, 255, 255],
    darkblue: [0, 0, 139],
    darkcyan: [0, 139, 139],
    darkgoldenrod: [184, 134, 11],
    darkgray: [169, 169, 169],
    darkgreen: [0, 100, 0],
    darkgrey: [169, 169, 169],
    darkkhaki: [189, 183, 107],
    darkmagenta: [139, 0, 139],
    darkolivegreen: [85, 107, 47],
    darkorange: [255, 140, 0],
    darkorchid: [153, 50, 204],
    darkred: [139, 0, 0],
    darksalmon: [233, 150, 122],
    darkseagreen: [143, 188, 143],
    darkslateblue: [72, 61, 139],
    darkslategray: [47, 79, 79],
    darkslategrey: [47, 79, 79],
    darkturquoise: [0, 206, 209],
    darkviolet: [148, 0, 211],
    deeppink: [255, 20, 147],
    deepskyblue: [0, 191, 255],
    dimgray: [105, 105, 105],
    dimgrey: [105, 105, 105],
    dodgerblue: [30, 144, 255],
    firebrick: [178, 34, 34],
    floralwhite: [255, 250, 240],
    forestgreen: [34, 139, 34],
    fuchsia: [255, 0, 255],
    gainsboro: [220, 220, 220],
    ghostwhite: [248, 248, 255],
    gold: [255, 215, 0],
    goldenrod: [218, 165, 32],
    gray: [128, 128, 128],
    green: [0, 128, 0],
    greenyellow: [173, 255, 47],
    grey: [128, 128, 128],
    honeydew: [240, 255, 240],
    hotpink: [255, 105, 180],
    indianred: [205, 92, 92],
    indigo: [75, 0, 130],
    ivory: [255, 255, 240],
    khaki: [240, 230, 140],
    lavender: [230, 230, 250],
    lavenderblush: [255, 240, 245],
    lawngreen: [124, 252, 0],
    lemonchiffon: [255, 250, 205],
    lightblue: [173, 216, 230],
    lightcoral: [240, 128, 128],
    lightcyan: [224, 255, 255],
    lightgoldenrodyellow: [250, 250, 210],
    lightgray: [211, 211, 211],
    lightgreen: [144, 238, 144],
    lightgrey: [211, 211, 211],
    lightpink: [255, 182, 193],
    lightsalmon: [255, 160, 122],
    lightseagreen: [32, 178, 170],
    lightskyblue: [135, 206, 250],
    lightslategray: [119, 136, 153],
    lightslategrey: [119, 136, 153],
    lightsteelblue: [176, 196, 222],
    lightyellow: [255, 255, 224],
    lime: [0, 255, 0],
    limegreen: [50, 205, 50],
    linen: [250, 240, 230],
    magenta: [255, 0, 255],
    maroon: [128, 0, 0],
    mediumaquamarine: [102, 205, 170],
    mediumblue: [0, 0, 205],
    mediumorchid: [186, 85, 211],
    mediumpurple: [147, 112, 219],
    mediumseagreen: [60, 179, 113],
    mediumslateblue: [123, 104, 238],
    mediumspringgreen: [0, 250, 154],
    mediumturquoise: [72, 209, 204],
    mediumvioletred: [199, 21, 133],
    midnightblue: [25, 25, 112],
    mintcream: [245, 255, 250],
    mistyrose: [255, 228, 225],
    moccasin: [255, 228, 181],
    navajowhite: [255, 222, 173],
    navy: [0, 0, 128],
    oldlace: [253, 245, 230],
    olive: [128, 128, 0],
    olivedrab: [107, 142, 35],
    orange: [255, 165, 0],
    orangered: [255, 69, 0],
    orchid: [218, 112, 214],
    palegoldenrod: [238, 232, 170],
    palegreen: [152, 251, 152],
    paleturquoise: [175, 238, 238],
    palevioletred: [219, 112, 147],
    papayawhip: [255, 239, 213],
    peachpuff: [255, 218, 185],
    peru: [205, 133, 63],
    pink: [255, 192, 203],
    plum: [221, 160, 221],
    powderblue: [176, 224, 230],
    purple: [128, 0, 128],
    rebeccapurple: [102, 51, 153],
    red: [255, 0, 0],
    rosybrown: [188, 143, 143],
    royalblue: [65, 105, 225],
    saddlebrown: [139, 69, 19],
    salmon: [250, 128, 114],
    sandybrown: [244, 164, 96],
    seagreen: [46, 139, 87],
    seashell: [255, 245, 238],
    sienna: [160, 82, 45],
    silver: [192, 192, 192],
    skyblue: [135, 206, 235],
    slateblue: [106, 90, 205],
    slategray: [112, 128, 144],
    slategrey: [112, 128, 144],
    snow: [255, 250, 250],
    springgreen: [0, 255, 127],
    steelblue: [70, 130, 180],
    tan: [210, 180, 140],
    teal: [0, 128, 128],
    thistle: [216, 191, 216],
    tomato: [255, 99, 71],
    turquoise: [64, 224, 208],
    violet: [238, 130, 238],
    wheat: [245, 222, 179],
    white: [255, 255, 255],
    whitesmoke: [245, 245, 245],
    yellow: [255, 255, 0],
    yellowgreen: [154, 205, 50],
  };
  return colorName;
}
var conversions;
var hasRequiredConversions;
function requireConversions() {
  if (hasRequiredConversions) return conversions;
  hasRequiredConversions = 1;
  const cssKeywords = requireColorName();
  const reverseKeywords = {};
  for (const key of Object.keys(cssKeywords)) {
    reverseKeywords[cssKeywords[key]] = key;
  }
  const convert = {
    rgb: {channels: 3, labels: 'rgb'},
    hsl: {channels: 3, labels: 'hsl'},
    hsv: {channels: 3, labels: 'hsv'},
    hwb: {channels: 3, labels: 'hwb'},
    cmyk: {channels: 4, labels: 'cmyk'},
    xyz: {channels: 3, labels: 'xyz'},
    lab: {channels: 3, labels: 'lab'},
    lch: {channels: 3, labels: 'lch'},
    hex: {channels: 1, labels: ['hex']},
    keyword: {channels: 1, labels: ['keyword']},
    ansi16: {channels: 1, labels: ['ansi16']},
    ansi256: {channels: 1, labels: ['ansi256']},
    hcg: {channels: 3, labels: ['h', 'c', 'g']},
    apple: {channels: 3, labels: ['r16', 'g16', 'b16']},
    gray: {channels: 1, labels: ['gray']},
  };
  conversions = convert;
  for (const model of Object.keys(convert)) {
    if (!('channels' in convert[model])) {
      throw new Error('missing channels property: ' + model);
    }
    if (!('labels' in convert[model])) {
      throw new Error('missing channel labels property: ' + model);
    }
    if (convert[model].labels.length !== convert[model].channels) {
      throw new Error('channel and label counts mismatch: ' + model);
    }
    const {channels: channels, labels: labels} = convert[model];
    delete convert[model].channels;
    delete convert[model].labels;
    Object.defineProperty(convert[model], 'channels', {value: channels});
    Object.defineProperty(convert[model], 'labels', {value: labels});
  }
  convert.rgb.hsl = function (rgb) {
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const min = Math.min(r, g, b);
    const max = Math.max(r, g, b);
    const delta = max - min;
    let h;
    let s;
    if (max === min) {
      h = 0;
    } else if (r === max) {
      h = (g - b) / delta;
    } else if (g === max) {
      h = 2 + (b - r) / delta;
    } else if (b === max) {
      h = 4 + (r - g) / delta;
    }
    h = Math.min(h * 60, 360);
    if (h < 0) {
      h += 360;
    }
    const l = (min + max) / 2;
    if (max === min) {
      s = 0;
    } else if (l <= 0.5) {
      s = delta / (max + min);
    } else {
      s = delta / (2 - max - min);
    }
    return [h, s * 100, l * 100];
  };
  convert.rgb.hsv = function (rgb) {
    let rdif;
    let gdif;
    let bdif;
    let h;
    let s;
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const v = Math.max(r, g, b);
    const diff = v - Math.min(r, g, b);
    const diffc = function (c) {
      return (v - c) / 6 / diff + 1 / 2;
    };
    if (diff === 0) {
      h = 0;
      s = 0;
    } else {
      s = diff / v;
      rdif = diffc(r);
      gdif = diffc(g);
      bdif = diffc(b);
      if (r === v) {
        h = bdif - gdif;
      } else if (g === v) {
        h = 1 / 3 + rdif - bdif;
      } else if (b === v) {
        h = 2 / 3 + gdif - rdif;
      }
      if (h < 0) {
        h += 1;
      } else if (h > 1) {
        h -= 1;
      }
    }
    return [h * 360, s * 100, v * 100];
  };
  convert.rgb.hwb = function (rgb) {
    const r = rgb[0];
    const g = rgb[1];
    let b = rgb[2];
    const h = convert.rgb.hsl(rgb)[0];
    const w = (1 / 255) * Math.min(r, Math.min(g, b));
    b = 1 - (1 / 255) * Math.max(r, Math.max(g, b));
    return [h, w * 100, b * 100];
  };
  convert.rgb.cmyk = function (rgb) {
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const k = Math.min(1 - r, 1 - g, 1 - b);
    const c = (1 - r - k) / (1 - k) || 0;
    const m = (1 - g - k) / (1 - k) || 0;
    const y = (1 - b - k) / (1 - k) || 0;
    return [c * 100, m * 100, y * 100, k * 100];
  };
  function comparativeDistance(x, y) {
    return (x[0] - y[0]) ** 2 + (x[1] - y[1]) ** 2 + (x[2] - y[2]) ** 2;
  }
  convert.rgb.keyword = function (rgb) {
    const reversed = reverseKeywords[rgb];
    if (reversed) {
      return reversed;
    }
    let currentClosestDistance = Infinity;
    let currentClosestKeyword;
    for (const keyword of Object.keys(cssKeywords)) {
      const value = cssKeywords[keyword];
      const distance = comparativeDistance(rgb, value);
      if (distance < currentClosestDistance) {
        currentClosestDistance = distance;
        currentClosestKeyword = keyword;
      }
    }
    return currentClosestKeyword;
  };
  convert.keyword.rgb = function (keyword) {
    return cssKeywords[keyword];
  };
  convert.rgb.xyz = function (rgb) {
    let r = rgb[0] / 255;
    let g = rgb[1] / 255;
    let b = rgb[2] / 255;
    r = r > 0.04045 ? ((r + 0.055) / 1.055) ** 2.4 : r / 12.92;
    g = g > 0.04045 ? ((g + 0.055) / 1.055) ** 2.4 : g / 12.92;
    b = b > 0.04045 ? ((b + 0.055) / 1.055) ** 2.4 : b / 12.92;
    const x = r * 0.4124 + g * 0.3576 + b * 0.1805;
    const y = r * 0.2126 + g * 0.7152 + b * 0.0722;
    const z = r * 0.0193 + g * 0.1192 + b * 0.9505;
    return [x * 100, y * 100, z * 100];
  };
  convert.rgb.lab = function (rgb) {
    const xyz = convert.rgb.xyz(rgb);
    let x = xyz[0];
    let y = xyz[1];
    let z = xyz[2];
    x /= 95.047;
    y /= 100;
    z /= 108.883;
    x = x > 0.008856 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
    y = y > 0.008856 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
    z = z > 0.008856 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
    const l = 116 * y - 16;
    const a = 500 * (x - y);
    const b = 200 * (y - z);
    return [l, a, b];
  };
  convert.hsl.rgb = function (hsl) {
    const h = hsl[0] / 360;
    const s = hsl[1] / 100;
    const l = hsl[2] / 100;
    let t2;
    let t3;
    let val;
    if (s === 0) {
      val = l * 255;
      return [val, val, val];
    }
    if (l < 0.5) {
      t2 = l * (1 + s);
    } else {
      t2 = l + s - l * s;
    }
    const t1 = 2 * l - t2;
    const rgb = [0, 0, 0];
    for (let i = 0; i < 3; i++) {
      t3 = h + (1 / 3) * -(i - 1);
      if (t3 < 0) {
        t3++;
      }
      if (t3 > 1) {
        t3--;
      }
      if (6 * t3 < 1) {
        val = t1 + (t2 - t1) * 6 * t3;
      } else if (2 * t3 < 1) {
        val = t2;
      } else if (3 * t3 < 2) {
        val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
      } else {
        val = t1;
      }
      rgb[i] = val * 255;
    }
    return rgb;
  };
  convert.hsl.hsv = function (hsl) {
    const h = hsl[0];
    let s = hsl[1] / 100;
    let l = hsl[2] / 100;
    let smin = s;
    const lmin = Math.max(l, 0.01);
    l *= 2;
    s *= l <= 1 ? l : 2 - l;
    smin *= lmin <= 1 ? lmin : 2 - lmin;
    const v = (l + s) / 2;
    const sv = l === 0 ? (2 * smin) / (lmin + smin) : (2 * s) / (l + s);
    return [h, sv * 100, v * 100];
  };
  convert.hsv.rgb = function (hsv) {
    const h = hsv[0] / 60;
    const s = hsv[1] / 100;
    let v = hsv[2] / 100;
    const hi = Math.floor(h) % 6;
    const f = h - Math.floor(h);
    const p = 255 * v * (1 - s);
    const q = 255 * v * (1 - s * f);
    const t = 255 * v * (1 - s * (1 - f));
    v *= 255;
    switch (hi) {
      case 0:
        return [v, t, p];
      case 1:
        return [q, v, p];
      case 2:
        return [p, v, t];
      case 3:
        return [p, q, v];
      case 4:
        return [t, p, v];
      case 5:
        return [v, p, q];
    }
  };
  convert.hsv.hsl = function (hsv) {
    const h = hsv[0];
    const s = hsv[1] / 100;
    const v = hsv[2] / 100;
    const vmin = Math.max(v, 0.01);
    let sl;
    let l;
    l = (2 - s) * v;
    const lmin = (2 - s) * vmin;
    sl = s * vmin;
    sl /= lmin <= 1 ? lmin : 2 - lmin;
    sl = sl || 0;
    l /= 2;
    return [h, sl * 100, l * 100];
  };
  convert.hwb.rgb = function (hwb) {
    const h = hwb[0] / 360;
    let wh = hwb[1] / 100;
    let bl = hwb[2] / 100;
    const ratio = wh + bl;
    let f;
    if (ratio > 1) {
      wh /= ratio;
      bl /= ratio;
    }
    const i = Math.floor(6 * h);
    const v = 1 - bl;
    f = 6 * h - i;
    if ((i & 1) !== 0) {
      f = 1 - f;
    }
    const n = wh + f * (v - wh);
    let r;
    let g;
    let b;
    switch (i) {
      default:
      case 6:
      case 0:
        r = v;
        g = n;
        b = wh;
        break;
      case 1:
        r = n;
        g = v;
        b = wh;
        break;
      case 2:
        r = wh;
        g = v;
        b = n;
        break;
      case 3:
        r = wh;
        g = n;
        b = v;
        break;
      case 4:
        r = n;
        g = wh;
        b = v;
        break;
      case 5:
        r = v;
        g = wh;
        b = n;
        break;
    }
    return [r * 255, g * 255, b * 255];
  };
  convert.cmyk.rgb = function (cmyk) {
    const c = cmyk[0] / 100;
    const m = cmyk[1] / 100;
    const y = cmyk[2] / 100;
    const k = cmyk[3] / 100;
    const r = 1 - Math.min(1, c * (1 - k) + k);
    const g = 1 - Math.min(1, m * (1 - k) + k);
    const b = 1 - Math.min(1, y * (1 - k) + k);
    return [r * 255, g * 255, b * 255];
  };
  convert.xyz.rgb = function (xyz) {
    const x = xyz[0] / 100;
    const y = xyz[1] / 100;
    const z = xyz[2] / 100;
    let r;
    let g;
    let b;
    r = x * 3.2406 + y * -1.5372 + z * -0.4986;
    g = x * -0.9689 + y * 1.8758 + z * 0.0415;
    b = x * 0.0557 + y * -0.204 + z * 1.057;
    r = r > 0.0031308 ? 1.055 * r ** (1 / 2.4) - 0.055 : r * 12.92;
    g = g > 0.0031308 ? 1.055 * g ** (1 / 2.4) - 0.055 : g * 12.92;
    b = b > 0.0031308 ? 1.055 * b ** (1 / 2.4) - 0.055 : b * 12.92;
    r = Math.min(Math.max(0, r), 1);
    g = Math.min(Math.max(0, g), 1);
    b = Math.min(Math.max(0, b), 1);
    return [r * 255, g * 255, b * 255];
  };
  convert.xyz.lab = function (xyz) {
    let x = xyz[0];
    let y = xyz[1];
    let z = xyz[2];
    x /= 95.047;
    y /= 100;
    z /= 108.883;
    x = x > 0.008856 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
    y = y > 0.008856 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
    z = z > 0.008856 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
    const l = 116 * y - 16;
    const a = 500 * (x - y);
    const b = 200 * (y - z);
    return [l, a, b];
  };
  convert.lab.xyz = function (lab) {
    const l = lab[0];
    const a = lab[1];
    const b = lab[2];
    let x;
    let y;
    let z;
    y = (l + 16) / 116;
    x = a / 500 + y;
    z = y - b / 200;
    const y2 = y ** 3;
    const x2 = x ** 3;
    const z2 = z ** 3;
    y = y2 > 0.008856 ? y2 : (y - 16 / 116) / 7.787;
    x = x2 > 0.008856 ? x2 : (x - 16 / 116) / 7.787;
    z = z2 > 0.008856 ? z2 : (z - 16 / 116) / 7.787;
    x *= 95.047;
    y *= 100;
    z *= 108.883;
    return [x, y, z];
  };
  convert.lab.lch = function (lab) {
    const l = lab[0];
    const a = lab[1];
    const b = lab[2];
    let h;
    const hr = Math.atan2(b, a);
    h = (hr * 360) / 2 / Math.PI;
    if (h < 0) {
      h += 360;
    }
    const c = Math.sqrt(a * a + b * b);
    return [l, c, h];
  };
  convert.lch.lab = function (lch) {
    const l = lch[0];
    const c = lch[1];
    const h = lch[2];
    const hr = (h / 360) * 2 * Math.PI;
    const a = c * Math.cos(hr);
    const b = c * Math.sin(hr);
    return [l, a, b];
  };
  convert.rgb.ansi16 = function (args, saturation = null) {
    const [r, g, b] = args;
    let value = saturation === null ? convert.rgb.hsv(args)[2] : saturation;
    value = Math.round(value / 50);
    if (value === 0) {
      return 30;
    }
    let ansi =
      30 +
      ((Math.round(b / 255) << 2) |
        (Math.round(g / 255) << 1) |
        Math.round(r / 255));
    if (value === 2) {
      ansi += 60;
    }
    return ansi;
  };
  convert.hsv.ansi16 = function (args) {
    return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
  };
  convert.rgb.ansi256 = function (args) {
    const r = args[0];
    const g = args[1];
    const b = args[2];
    if (r === g && g === b) {
      if (r < 8) {
        return 16;
      }
      if (r > 248) {
        return 231;
      }
      return Math.round(((r - 8) / 247) * 24) + 232;
    }
    const ansi =
      16 +
      36 * Math.round((r / 255) * 5) +
      6 * Math.round((g / 255) * 5) +
      Math.round((b / 255) * 5);
    return ansi;
  };
  convert.ansi16.rgb = function (args) {
    let color = args % 10;
    if (color === 0 || color === 7) {
      if (args > 50) {
        color += 3.5;
      }
      color = (color / 10.5) * 255;
      return [color, color, color];
    }
    const mult = (~~(args > 50) + 1) * 0.5;
    const r = (color & 1) * mult * 255;
    const g = ((color >> 1) & 1) * mult * 255;
    const b = ((color >> 2) & 1) * mult * 255;
    return [r, g, b];
  };
  convert.ansi256.rgb = function (args) {
    if (args >= 232) {
      const c = (args - 232) * 10 + 8;
      return [c, c, c];
    }
    args -= 16;
    let rem;
    const r = (Math.floor(args / 36) / 5) * 255;
    const g = (Math.floor((rem = args % 36) / 6) / 5) * 255;
    const b = ((rem % 6) / 5) * 255;
    return [r, g, b];
  };
  convert.rgb.hex = function (args) {
    const integer =
      ((Math.round(args[0]) & 255) << 16) +
      ((Math.round(args[1]) & 255) << 8) +
      (Math.round(args[2]) & 255);
    const string = integer.toString(16).toUpperCase();
    return '000000'.substring(string.length) + string;
  };
  convert.hex.rgb = function (args) {
    const match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
    if (!match) {
      return [0, 0, 0];
    }
    let colorString = match[0];
    if (match[0].length === 3) {
      colorString = colorString
        .split('')
        .map(char => char + char)
        .join('');
    }
    const integer = parseInt(colorString, 16);
    const r = (integer >> 16) & 255;
    const g = (integer >> 8) & 255;
    const b = integer & 255;
    return [r, g, b];
  };
  convert.rgb.hcg = function (rgb) {
    const r = rgb[0] / 255;
    const g = rgb[1] / 255;
    const b = rgb[2] / 255;
    const max = Math.max(Math.max(r, g), b);
    const min = Math.min(Math.min(r, g), b);
    const chroma = max - min;
    let grayscale;
    let hue;
    if (chroma < 1) {
      grayscale = min / (1 - chroma);
    } else {
      grayscale = 0;
    }
    if (chroma <= 0) {
      hue = 0;
    } else if (max === r) {
      hue = ((g - b) / chroma) % 6;
    } else if (max === g) {
      hue = 2 + (b - r) / chroma;
    } else {
      hue = 4 + (r - g) / chroma;
    }
    hue /= 6;
    hue %= 1;
    return [hue * 360, chroma * 100, grayscale * 100];
  };
  convert.hsl.hcg = function (hsl) {
    const s = hsl[1] / 100;
    const l = hsl[2] / 100;
    const c = l < 0.5 ? 2 * s * l : 2 * s * (1 - l);
    let f = 0;
    if (c < 1) {
      f = (l - 0.5 * c) / (1 - c);
    }
    return [hsl[0], c * 100, f * 100];
  };
  convert.hsv.hcg = function (hsv) {
    const s = hsv[1] / 100;
    const v = hsv[2] / 100;
    const c = s * v;
    let f = 0;
    if (c < 1) {
      f = (v - c) / (1 - c);
    }
    return [hsv[0], c * 100, f * 100];
  };
  convert.hcg.rgb = function (hcg) {
    const h = hcg[0] / 360;
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    if (c === 0) {
      return [g * 255, g * 255, g * 255];
    }
    const pure = [0, 0, 0];
    const hi = (h % 1) * 6;
    const v = hi % 1;
    const w = 1 - v;
    let mg = 0;
    switch (Math.floor(hi)) {
      case 0:
        pure[0] = 1;
        pure[1] = v;
        pure[2] = 0;
        break;
      case 1:
        pure[0] = w;
        pure[1] = 1;
        pure[2] = 0;
        break;
      case 2:
        pure[0] = 0;
        pure[1] = 1;
        pure[2] = v;
        break;
      case 3:
        pure[0] = 0;
        pure[1] = w;
        pure[2] = 1;
        break;
      case 4:
        pure[0] = v;
        pure[1] = 0;
        pure[2] = 1;
        break;
      default:
        pure[0] = 1;
        pure[1] = 0;
        pure[2] = w;
    }
    mg = (1 - c) * g;
    return [
      (c * pure[0] + mg) * 255,
      (c * pure[1] + mg) * 255,
      (c * pure[2] + mg) * 255,
    ];
  };
  convert.hcg.hsv = function (hcg) {
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    const v = c + g * (1 - c);
    let f = 0;
    if (v > 0) {
      f = c / v;
    }
    return [hcg[0], f * 100, v * 100];
  };
  convert.hcg.hsl = function (hcg) {
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    const l = g * (1 - c) + 0.5 * c;
    let s = 0;
    if (l > 0 && l < 0.5) {
      s = c / (2 * l);
    } else if (l >= 0.5 && l < 1) {
      s = c / (2 * (1 - l));
    }
    return [hcg[0], s * 100, l * 100];
  };
  convert.hcg.hwb = function (hcg) {
    const c = hcg[1] / 100;
    const g = hcg[2] / 100;
    const v = c + g * (1 - c);
    return [hcg[0], (v - c) * 100, (1 - v) * 100];
  };
  convert.hwb.hcg = function (hwb) {
    const w = hwb[1] / 100;
    const b = hwb[2] / 100;
    const v = 1 - b;
    const c = v - w;
    let g = 0;
    if (c < 1) {
      g = (v - c) / (1 - c);
    }
    return [hwb[0], c * 100, g * 100];
  };
  convert.apple.rgb = function (apple) {
    return [
      (apple[0] / 65535) * 255,
      (apple[1] / 65535) * 255,
      (apple[2] / 65535) * 255,
    ];
  };
  convert.rgb.apple = function (rgb) {
    return [
      (rgb[0] / 255) * 65535,
      (rgb[1] / 255) * 65535,
      (rgb[2] / 255) * 65535,
    ];
  };
  convert.gray.rgb = function (args) {
    return [
      (args[0] / 100) * 255,
      (args[0] / 100) * 255,
      (args[0] / 100) * 255,
    ];
  };
  convert.gray.hsl = function (args) {
    return [0, 0, args[0]];
  };
  convert.gray.hsv = convert.gray.hsl;
  convert.gray.hwb = function (gray) {
    return [0, 100, gray[0]];
  };
  convert.gray.cmyk = function (gray) {
    return [0, 0, 0, gray[0]];
  };
  convert.gray.lab = function (gray) {
    return [gray[0], 0, 0];
  };
  convert.gray.hex = function (gray) {
    const val = Math.round((gray[0] / 100) * 255) & 255;
    const integer = (val << 16) + (val << 8) + val;
    const string = integer.toString(16).toUpperCase();
    return '000000'.substring(string.length) + string;
  };
  convert.rgb.gray = function (rgb) {
    const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
    return [(val / 255) * 100];
  };
  return conversions;
}
var route;
var hasRequiredRoute;
function requireRoute() {
  if (hasRequiredRoute) return route;
  hasRequiredRoute = 1;
  const conversions = requireConversions();
  function buildGraph() {
    const graph = {};
    const models = Object.keys(conversions);
    for (let len = models.length, i = 0; i < len; i++) {
      graph[models[i]] = {distance: -1, parent: null};
    }
    return graph;
  }
  function deriveBFS(fromModel) {
    const graph = buildGraph();
    const queue = [fromModel];
    graph[fromModel].distance = 0;
    while (queue.length) {
      const current = queue.pop();
      const adjacents = Object.keys(conversions[current]);
      for (let len = adjacents.length, i = 0; i < len; i++) {
        const adjacent = adjacents[i];
        const node = graph[adjacent];
        if (node.distance === -1) {
          node.distance = graph[current].distance + 1;
          node.parent = current;
          queue.unshift(adjacent);
        }
      }
    }
    return graph;
  }
  function link(from, to) {
    return function (args) {
      return to(from(args));
    };
  }
  function wrapConversion(toModel, graph) {
    const path = [graph[toModel].parent, toModel];
    let fn = conversions[graph[toModel].parent][toModel];
    let cur = graph[toModel].parent;
    while (graph[cur].parent) {
      path.unshift(graph[cur].parent);
      fn = link(conversions[graph[cur].parent][cur], fn);
      cur = graph[cur].parent;
    }
    fn.conversion = path;
    return fn;
  }
  route = function (fromModel) {
    const graph = deriveBFS(fromModel);
    const conversion = {};
    const models = Object.keys(graph);
    for (let len = models.length, i = 0; i < len; i++) {
      const toModel = models[i];
      const node = graph[toModel];
      if (node.parent === null) {
        continue;
      }
      conversion[toModel] = wrapConversion(toModel, graph);
    }
    return conversion;
  };
  return route;
}
var colorConvert;
var hasRequiredColorConvert;
function requireColorConvert() {
  if (hasRequiredColorConvert) return colorConvert;
  hasRequiredColorConvert = 1;
  const conversions = requireConversions();
  const route = requireRoute();
  const convert = {};
  const models = Object.keys(conversions);
  function wrapRaw(fn) {
    const wrappedFn = function (...args) {
      const arg0 = args[0];
      if (arg0 === undefined || arg0 === null) {
        return arg0;
      }
      if (arg0.length > 1) {
        args = arg0;
      }
      return fn(args);
    };
    if ('conversion' in fn) {
      wrappedFn.conversion = fn.conversion;
    }
    return wrappedFn;
  }
  function wrapRounded(fn) {
    const wrappedFn = function (...args) {
      const arg0 = args[0];
      if (arg0 === undefined || arg0 === null) {
        return arg0;
      }
      if (arg0.length > 1) {
        args = arg0;
      }
      const result = fn(args);
      if (typeof result === 'object') {
        for (let len = result.length, i = 0; i < len; i++) {
          result[i] = Math.round(result[i]);
        }
      }
      return result;
    };
    if ('conversion' in fn) {
      wrappedFn.conversion = fn.conversion;
    }
    return wrappedFn;
  }
  models.forEach(fromModel => {
    convert[fromModel] = {};
    Object.defineProperty(convert[fromModel], 'channels', {
      value: conversions[fromModel].channels,
    });
    Object.defineProperty(convert[fromModel], 'labels', {
      value: conversions[fromModel].labels,
    });
    const routes = route(fromModel);
    const routeModels = Object.keys(routes);
    routeModels.forEach(toModel => {
      const fn = routes[toModel];
      convert[fromModel][toModel] = wrapRounded(fn);
      convert[fromModel][toModel].raw = wrapRaw(fn);
    });
  });
  colorConvert = convert;
  return colorConvert;
}
ansiStyles$1.exports;
(function (module) {
  const wrapAnsi16 =
    (fn, offset) =>
    (...args) => {
      const code = fn(...args);
      return `[${code + offset}m`;
    };
  const wrapAnsi256 =
    (fn, offset) =>
    (...args) => {
      const code = fn(...args);
      return `[${38 + offset};5;${code}m`;
    };
  const wrapAnsi16m =
    (fn, offset) =>
    (...args) => {
      const rgb = fn(...args);
      return `[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
  const ansi2ansi = n => n;
  const rgb2rgb = (r, g, b) => [r, g, b];
  const setLazyProperty = (object, property, get) => {
    Object.defineProperty(object, property, {
      get: () => {
        const value = get();
        Object.defineProperty(object, property, {
          value: value,
          enumerable: true,
          configurable: true,
        });
        return value;
      },
      enumerable: true,
      configurable: true,
    });
  };
  let colorConvert;
  const makeDynamicStyles = (wrap, targetSpace, identity, isBackground) => {
    if (colorConvert === undefined) {
      colorConvert = requireColorConvert();
    }
    const offset = isBackground ? 10 : 0;
    const styles = {};
    for (const [sourceSpace, suite] of Object.entries(colorConvert)) {
      const name = sourceSpace === 'ansi16' ? 'ansi' : sourceSpace;
      if (sourceSpace === targetSpace) {
        styles[name] = wrap(identity, offset);
      } else if (typeof suite === 'object') {
        styles[name] = wrap(suite[targetSpace], offset);
      }
    }
    return styles;
  };
  function assembleStyles() {
    const codes = new Map();
    const styles = {
      modifier: {
        reset: [0, 0],
        bold: [1, 22],
        dim: [2, 22],
        italic: [3, 23],
        underline: [4, 24],
        inverse: [7, 27],
        hidden: [8, 28],
        strikethrough: [9, 29],
      },
      color: {
        black: [30, 39],
        red: [31, 39],
        green: [32, 39],
        yellow: [33, 39],
        blue: [34, 39],
        magenta: [35, 39],
        cyan: [36, 39],
        white: [37, 39],
        blackBright: [90, 39],
        redBright: [91, 39],
        greenBright: [92, 39],
        yellowBright: [93, 39],
        blueBright: [94, 39],
        magentaBright: [95, 39],
        cyanBright: [96, 39],
        whiteBright: [97, 39],
      },
      bgColor: {
        bgBlack: [40, 49],
        bgRed: [41, 49],
        bgGreen: [42, 49],
        bgYellow: [43, 49],
        bgBlue: [44, 49],
        bgMagenta: [45, 49],
        bgCyan: [46, 49],
        bgWhite: [47, 49],
        bgBlackBright: [100, 49],
        bgRedBright: [101, 49],
        bgGreenBright: [102, 49],
        bgYellowBright: [103, 49],
        bgBlueBright: [104, 49],
        bgMagentaBright: [105, 49],
        bgCyanBright: [106, 49],
        bgWhiteBright: [107, 49],
      },
    };
    styles.color.gray = styles.color.blackBright;
    styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
    styles.color.grey = styles.color.blackBright;
    styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;
    for (const [groupName, group] of Object.entries(styles)) {
      for (const [styleName, style] of Object.entries(group)) {
        styles[styleName] = {open: `[${style[0]}m`, close: `[${style[1]}m`};
        group[styleName] = styles[styleName];
        codes.set(style[0], style[1]);
      }
      Object.defineProperty(styles, groupName, {
        value: group,
        enumerable: false,
      });
    }
    Object.defineProperty(styles, 'codes', {value: codes, enumerable: false});
    styles.color.close = '[39m';
    styles.bgColor.close = '[49m';
    setLazyProperty(styles.color, 'ansi', () =>
      makeDynamicStyles(wrapAnsi16, 'ansi16', ansi2ansi, false)
    );
    setLazyProperty(styles.color, 'ansi256', () =>
      makeDynamicStyles(wrapAnsi256, 'ansi256', ansi2ansi, false)
    );
    setLazyProperty(styles.color, 'ansi16m', () =>
      makeDynamicStyles(wrapAnsi16m, 'rgb', rgb2rgb, false)
    );
    setLazyProperty(styles.bgColor, 'ansi', () =>
      makeDynamicStyles(wrapAnsi16, 'ansi16', ansi2ansi, true)
    );
    setLazyProperty(styles.bgColor, 'ansi256', () =>
      makeDynamicStyles(wrapAnsi256, 'ansi256', ansi2ansi, true)
    );
    setLazyProperty(styles.bgColor, 'ansi16m', () =>
      makeDynamicStyles(wrapAnsi16m, 'rgb', rgb2rgb, true)
    );
    return styles;
  }
  Object.defineProperty(module, 'exports', {
    enumerable: true,
    get: assembleStyles,
  });
})(ansiStyles$1);
var ansiStylesExports = ansiStyles$1.exports;
var hasFlag$1 = (flag, argv = process.argv) => {
  const prefix = flag.startsWith('-') ? '' : flag.length === 1 ? '-' : '--';
  const position = argv.indexOf(prefix + flag);
  const terminatorPosition = argv.indexOf('--');
  return (
    position !== -1 &&
    (terminatorPosition === -1 || position < terminatorPosition)
  );
};
const os = require$$0$3;
const tty = require$$0$2;
const hasFlag = hasFlag$1;
const {env: env} = process;
let forceColor;
if (
  hasFlag('no-color') ||
  hasFlag('no-colors') ||
  hasFlag('color=false') ||
  hasFlag('color=never')
) {
  forceColor = 0;
} else if (
  hasFlag('color') ||
  hasFlag('colors') ||
  hasFlag('color=true') ||
  hasFlag('color=always')
) {
  forceColor = 1;
}
if ('FORCE_COLOR' in env) {
  if (env.FORCE_COLOR === 'true') {
    forceColor = 1;
  } else if (env.FORCE_COLOR === 'false') {
    forceColor = 0;
  } else {
    forceColor =
      env.FORCE_COLOR.length === 0
        ? 1
        : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
  }
}
function translateLevel(level) {
  if (level === 0) {
    return false;
  }
  return {level: level, hasBasic: true, has256: level >= 2, has16m: level >= 3};
}
function supportsColor(haveStream, streamIsTTY) {
  if (forceColor === 0) {
    return 0;
  }
  if (
    hasFlag('color=16m') ||
    hasFlag('color=full') ||
    hasFlag('color=truecolor')
  ) {
    return 3;
  }
  if (hasFlag('color=256')) {
    return 2;
  }
  if (haveStream && !streamIsTTY && forceColor === undefined) {
    return 0;
  }
  const min = forceColor || 0;
  if (env.TERM === 'dumb') {
    return min;
  }
  if (process.platform === 'win32') {
    const osRelease = os.release().split('.');
    if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
      return Number(osRelease[2]) >= 14931 ? 3 : 2;
    }
    return 1;
  }
  if ('CI' in env) {
    if (
      [
        'TRAVIS',
        'CIRCLECI',
        'APPVEYOR',
        'GITLAB_CI',
        'GITHUB_ACTIONS',
        'BUILDKITE',
      ].some(sign => sign in env) ||
      env.CI_NAME === 'codeship'
    ) {
      return 1;
    }
    return min;
  }
  if ('TEAMCITY_VERSION' in env) {
    return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
  }
  if (env.COLORTERM === 'truecolor') {
    return 3;
  }
  if ('TERM_PROGRAM' in env) {
    const version = parseInt(
      (env.TERM_PROGRAM_VERSION || '').split('.')[0],
      10
    );
    switch (env.TERM_PROGRAM) {
      case 'iTerm.app':
        return version >= 3 ? 3 : 2;
      case 'Apple_Terminal':
        return 2;
    }
  }
  if (/-256(color)?$/i.test(env.TERM)) {
    return 2;
  }
  if (
    /^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)
  ) {
    return 1;
  }
  if ('COLORTERM' in env) {
    return 1;
  }
  return min;
}
function getSupportLevel(stream) {
  const level = supportsColor(stream, stream && stream.isTTY);
  return translateLevel(level);
}
var supportsColor_1 = {
  supportsColor: getSupportLevel,
  stdout: translateLevel(supportsColor(true, tty.isatty(1))),
  stderr: translateLevel(supportsColor(true, tty.isatty(2))),
};
const stringReplaceAll$1 = (string, substring, replacer) => {
  let index = string.indexOf(substring);
  if (index === -1) {
    return string;
  }
  const substringLength = substring.length;
  let endIndex = 0;
  let returnValue = '';
  do {
    returnValue +=
      string.substr(endIndex, index - endIndex) + substring + replacer;
    endIndex = index + substringLength;
    index = string.indexOf(substring, endIndex);
  } while (index !== -1);
  returnValue += string.substr(endIndex);
  return returnValue;
};
const stringEncaseCRLFWithFirstIndex$1 = (string, prefix, postfix, index) => {
  let endIndex = 0;
  let returnValue = '';
  do {
    const gotCR = string[index - 1] === '\r';
    returnValue +=
      string.substr(endIndex, (gotCR ? index - 1 : index) - endIndex) +
      prefix +
      (gotCR ? '\r\n' : '\n') +
      postfix;
    endIndex = index + 1;
    index = string.indexOf('\n', endIndex);
  } while (index !== -1);
  returnValue += string.substr(endIndex);
  return returnValue;
};
var util = {
  stringReplaceAll: stringReplaceAll$1,
  stringEncaseCRLFWithFirstIndex: stringEncaseCRLFWithFirstIndex$1,
};
var templates;
var hasRequiredTemplates;
function requireTemplates() {
  if (hasRequiredTemplates) return templates;
  hasRequiredTemplates = 1;
  const TEMPLATE_REGEX =
    /(?:\\(u(?:[a-f\d]{4}|\{[a-f\d]{1,6}\})|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
  const STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
  const STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
  const ESCAPE_REGEX =
    /\\(u(?:[a-f\d]{4}|{[a-f\d]{1,6}})|x[a-f\d]{2}|.)|([^\\])/gi;
  const ESCAPES = new Map([
    ['n', '\n'],
    ['r', '\r'],
    ['t', '\t'],
    ['b', '\b'],
    ['f', '\f'],
    ['v', '\v'],
    ['0', '\0'],
    ['\\', '\\'],
    ['e', ''],
    ['a', ''],
  ]);
  function unescape(c) {
    const u = c[0] === 'u';
    const bracket = c[1] === '{';
    if ((u && !bracket && c.length === 5) || (c[0] === 'x' && c.length === 3)) {
      return String.fromCharCode(parseInt(c.slice(1), 16));
    }
    if (u && bracket) {
      return String.fromCodePoint(parseInt(c.slice(2, -1), 16));
    }
    return ESCAPES.get(c) || c;
  }
  function parseArguments(name, arguments_) {
    const results = [];
    const chunks = arguments_.trim().split(/\s*,\s*/g);
    let matches;
    for (const chunk of chunks) {
      const number = Number(chunk);
      if (!Number.isNaN(number)) {
        results.push(number);
      } else if ((matches = chunk.match(STRING_REGEX))) {
        results.push(
          matches[2].replace(ESCAPE_REGEX, (m, escape, character) =>
            escape ? unescape(escape) : character
          )
        );
      } else {
        throw new Error(
          `Invalid Chalk template style argument: ${chunk} (in style '${name}')`
        );
      }
    }
    return results;
  }
  function parseStyle(style) {
    STYLE_REGEX.lastIndex = 0;
    const results = [];
    let matches;
    while ((matches = STYLE_REGEX.exec(style)) !== null) {
      const name = matches[1];
      if (matches[2]) {
        const args = parseArguments(name, matches[2]);
        results.push([name].concat(args));
      } else {
        results.push([name]);
      }
    }
    return results;
  }
  function buildStyle(chalk, styles) {
    const enabled = {};
    for (const layer of styles) {
      for (const style of layer.styles) {
        enabled[style[0]] = layer.inverse ? null : style.slice(1);
      }
    }
    let current = chalk;
    for (const [styleName, styles] of Object.entries(enabled)) {
      if (!Array.isArray(styles)) {
        continue;
      }
      if (!(styleName in current)) {
        throw new Error(`Unknown Chalk style: ${styleName}`);
      }
      current =
        styles.length > 0 ? current[styleName](...styles) : current[styleName];
    }
    return current;
  }
  templates = (chalk, temporary) => {
    const styles = [];
    const chunks = [];
    let chunk = [];
    temporary.replace(
      TEMPLATE_REGEX,
      (m, escapeCharacter, inverse, style, close, character) => {
        if (escapeCharacter) {
          chunk.push(unescape(escapeCharacter));
        } else if (style) {
          const string = chunk.join('');
          chunk = [];
          chunks.push(
            styles.length === 0 ? string : buildStyle(chalk, styles)(string)
          );
          styles.push({inverse: inverse, styles: parseStyle(style)});
        } else if (close) {
          if (styles.length === 0) {
            throw new Error('Found extraneous } in Chalk template literal');
          }
          chunks.push(buildStyle(chalk, styles)(chunk.join('')));
          chunk = [];
          styles.pop();
        } else {
          chunk.push(character);
        }
      }
    );
    chunks.push(chunk.join(''));
    if (styles.length > 0) {
      const errMessage = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? '' : 's'} (\`}\`)`;
      throw new Error(errMessage);
    }
    return chunks.join('');
  };
  return templates;
}
const ansiStyles = ansiStylesExports;
const {stdout: stdoutColor, stderr: stderrColor} = supportsColor_1;
const {
  stringReplaceAll: stringReplaceAll,
  stringEncaseCRLFWithFirstIndex: stringEncaseCRLFWithFirstIndex,
} = util;
const {isArray: isArray} = Array;
const levelMapping = ['ansi', 'ansi', 'ansi256', 'ansi16m'];
const styles = Object.create(null);
const applyOptions = (object, options = {}) => {
  if (
    options.level &&
    !(
      Number.isInteger(options.level) &&
      options.level >= 0 &&
      options.level <= 3
    )
  ) {
    throw new Error('The `level` option should be an integer from 0 to 3');
  }
  const colorLevel = stdoutColor ? stdoutColor.level : 0;
  object.level = options.level === undefined ? colorLevel : options.level;
};
class ChalkClass {
  constructor(options) {
    return chalkFactory(options);
  }
}
const chalkFactory = options => {
  const chalk = {};
  applyOptions(chalk, options);
  chalk.template = (...arguments_) => chalkTag(chalk.template, ...arguments_);
  Object.setPrototypeOf(chalk, Chalk.prototype);
  Object.setPrototypeOf(chalk.template, chalk);
  chalk.template.constructor = () => {
    throw new Error(
      '`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.'
    );
  };
  chalk.template.Instance = ChalkClass;
  return chalk.template;
};
function Chalk(options) {
  return chalkFactory(options);
}
for (const [styleName, style] of Object.entries(ansiStyles)) {
  styles[styleName] = {
    get() {
      const builder = createBuilder(
        this,
        createStyler(style.open, style.close, this._styler),
        this._isEmpty
      );
      Object.defineProperty(this, styleName, {value: builder});
      return builder;
    },
  };
}
styles.visible = {
  get() {
    const builder = createBuilder(this, this._styler, true);
    Object.defineProperty(this, 'visible', {value: builder});
    return builder;
  },
};
const usedModels = [
  'rgb',
  'hex',
  'keyword',
  'hsl',
  'hsv',
  'hwb',
  'ansi',
  'ansi256',
];
for (const model of usedModels) {
  styles[model] = {
    get() {
      const {level: level} = this;
      return function (...arguments_) {
        const styler = createStyler(
          ansiStyles.color[levelMapping[level]][model](...arguments_),
          ansiStyles.color.close,
          this._styler
        );
        return createBuilder(this, styler, this._isEmpty);
      };
    },
  };
}
for (const model of usedModels) {
  const bgModel = 'bg' + model[0].toUpperCase() + model.slice(1);
  styles[bgModel] = {
    get() {
      const {level: level} = this;
      return function (...arguments_) {
        const styler = createStyler(
          ansiStyles.bgColor[levelMapping[level]][model](...arguments_),
          ansiStyles.bgColor.close,
          this._styler
        );
        return createBuilder(this, styler, this._isEmpty);
      };
    },
  };
}
const proto = Object.defineProperties(() => {}, {
  ...styles,
  level: {
    enumerable: true,
    get() {
      return this._generator.level;
    },
    set(level) {
      this._generator.level = level;
    },
  },
});
const createStyler = (open, close, parent) => {
  let openAll;
  let closeAll;
  if (parent === undefined) {
    openAll = open;
    closeAll = close;
  } else {
    openAll = parent.openAll + open;
    closeAll = close + parent.closeAll;
  }
  return {
    open: open,
    close: close,
    openAll: openAll,
    closeAll: closeAll,
    parent: parent,
  };
};
const createBuilder = (self, _styler, _isEmpty) => {
  const builder = (...arguments_) => {
    if (isArray(arguments_[0]) && isArray(arguments_[0].raw)) {
      return applyStyle(builder, chalkTag(builder, ...arguments_));
    }
    return applyStyle(
      builder,
      arguments_.length === 1 ? '' + arguments_[0] : arguments_.join(' ')
    );
  };
  Object.setPrototypeOf(builder, proto);
  builder._generator = self;
  builder._styler = _styler;
  builder._isEmpty = _isEmpty;
  return builder;
};
const applyStyle = (self, string) => {
  if (self.level <= 0 || !string) {
    return self._isEmpty ? '' : string;
  }
  let styler = self._styler;
  if (styler === undefined) {
    return string;
  }
  const {openAll: openAll, closeAll: closeAll} = styler;
  if (string.indexOf('') !== -1) {
    while (styler !== undefined) {
      string = stringReplaceAll(string, styler.close, styler.open);
      styler = styler.parent;
    }
  }
  const lfIndex = string.indexOf('\n');
  if (lfIndex !== -1) {
    string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
  }
  return openAll + string + closeAll;
};
let template;
const chalkTag = (chalk, ...strings) => {
  const [firstString] = strings;
  if (!isArray(firstString) || !isArray(firstString.raw)) {
    return strings.join(' ');
  }
  const arguments_ = strings.slice(1);
  const parts = [firstString.raw[0]];
  for (let i = 1; i < firstString.length; i++) {
    parts.push(
      String(arguments_[i - 1]).replace(/[{}\\]/g, '\\$&'),
      String(firstString.raw[i])
    );
  }
  if (template === undefined) {
    template = requireTemplates();
  }
  return template(chalk, parts.join(''));
};
Object.defineProperties(Chalk.prototype, styles);
const chalk = Chalk();
chalk.supportsColor = stdoutColor;
chalk.stderr = Chalk({level: stderrColor ? stderrColor.level : 0});
chalk.stderr.supportsColor = stderrColor;
function logDebug(step, value) {}
function logCodegenFunction(step, fn) {}
function logHIRFunction(step, fn) {}
function logReactiveFunction(step, fn) {}
function inferReactiveScopeVariables(fn) {
  const scopeIdentifiers = findDisjointMutableValues(fn);
  const scopes = new Map();
  scopeIdentifiers.forEach((identifier, groupIdentifier) => {
    let scope = scopes.get(groupIdentifier);
    if (scope === undefined) {
      scope = {
        id: fn.env.nextScopeId,
        range: identifier.mutableRange,
        dependencies: new Set(),
        declarations: new Map(),
        reassignments: new Set(),
        earlyReturnValue: null,
        merged: new Set(),
        loc: identifier.loc,
      };
      scopes.set(groupIdentifier, scope);
    } else {
      if (scope.range.start === 0) {
        scope.range.start = identifier.mutableRange.start;
      } else if (identifier.mutableRange.start !== 0) {
        scope.range.start = makeInstructionId(
          Math.min(scope.range.start, identifier.mutableRange.start)
        );
      }
      scope.range.end = makeInstructionId(
        Math.max(scope.range.end, identifier.mutableRange.end)
      );
      scope.loc = mergeLocation(scope.loc, identifier.loc);
    }
    identifier.scope = scope;
    identifier.mutableRange = scope.range;
  });
  let maxInstruction = 0;
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      maxInstruction = makeInstructionId(Math.max(maxInstruction, instr.id));
    }
    maxInstruction = makeInstructionId(
      Math.max(maxInstruction, block.terminal.id)
    );
  }
  for (const [, scope] of scopes) {
    if (
      scope.range.start === 0 ||
      scope.range.end === 0 ||
      maxInstruction === 0 ||
      scope.range.end > maxInstruction + 1
    ) {
      CompilerError.invariant(false, {
        reason: `Invalid mutable range for scope`,
        loc: GeneratedSource,
        description: `Scope @${scope.id} has range [${scope.range.start}:${scope.range.end}] but the valid range is [1:${maxInstruction + 1}]`,
      });
    }
  }
}
function mergeLocation(l, r) {
  if (l === GeneratedSource) {
    return r;
  } else if (r === GeneratedSource) {
    return l;
  } else {
    return {
      start: {
        line: Math.min(l.start.line, r.start.line),
        column: Math.min(l.start.column, r.start.column),
      },
      end: {
        line: Math.max(l.end.line, r.end.line),
        column: Math.max(l.end.column, r.end.column),
      },
    };
  }
}
function isMutable(instr, place) {
  return inRange(instr, place.identifier.mutableRange);
}
function inRange({id: id}, range) {
  return id >= range.start && id < range.end;
}
function mayAllocate(env, instruction) {
  const {value: value} = instruction;
  switch (value.kind) {
    case 'Destructure': {
      return doesPatternContainSpreadElement(value.lvalue.pattern);
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate':
    case 'Await':
    case 'DeclareLocal':
    case 'DeclareContext':
    case 'StoreLocal':
    case 'LoadGlobal':
    case 'MetaProperty':
    case 'TypeCastExpression':
    case 'LoadLocal':
    case 'LoadContext':
    case 'StoreContext':
    case 'PropertyDelete':
    case 'ComputedLoad':
    case 'ComputedDelete':
    case 'JSXText':
    case 'TemplateLiteral':
    case 'Primitive':
    case 'GetIterator':
    case 'IteratorNext':
    case 'NextPropertyOf':
    case 'Debugger':
    case 'StartMemoize':
    case 'FinishMemoize':
    case 'UnaryExpression':
    case 'BinaryExpression':
    case 'PropertyLoad':
    case 'StoreGlobal': {
      return false;
    }
    case 'TaggedTemplateExpression':
    case 'CallExpression':
    case 'MethodCall': {
      return instruction.lvalue.identifier.type.kind !== 'Primitive';
    }
    case 'RegExpLiteral':
    case 'PropertyStore':
    case 'ComputedStore':
    case 'ArrayExpression':
    case 'JsxExpression':
    case 'JsxFragment':
    case 'NewExpression':
    case 'ObjectExpression':
    case 'UnsupportedNode':
    case 'ObjectMethod':
    case 'FunctionExpression': {
      return true;
    }
    default: {
      assertExhaustive(value, `Unexpected value kind \`${value.kind}\``);
    }
  }
}
function findDisjointMutableValues(fn) {
  var _a, _b;
  const scopeIdentifiers = new DisjointSet();
  const declarations = new Map();
  function declareIdentifier(lvalue) {
    if (!declarations.has(lvalue.identifier.declarationId)) {
      declarations.set(lvalue.identifier.declarationId, lvalue.identifier);
    }
  }
  for (const [_, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      if (
        phi.place.identifier.mutableRange.start + 1 !==
          phi.place.identifier.mutableRange.end &&
        phi.place.identifier.mutableRange.end >
          ((_b =
            (_a = block.instructions.at(0)) === null || _a === void 0
              ? void 0
              : _a.id) !== null && _b !== void 0
            ? _b
            : block.terminal.id)
      ) {
        const operands = [phi.place.identifier];
        const declaration = declarations.get(
          phi.place.identifier.declarationId
        );
        if (declaration !== undefined) {
          operands.push(declaration);
        }
        for (const [_, phiId] of phi.operands) {
          operands.push(phiId.identifier);
        }
        scopeIdentifiers.union(operands);
      } else if (fn.env.config.enableForest) {
        for (const [, phiId] of phi.operands) {
          scopeIdentifiers.union([phi.place.identifier, phiId.identifier]);
        }
      }
    }
    for (const instr of block.instructions) {
      const operands = [];
      const range = instr.lvalue.identifier.mutableRange;
      if (range.end > range.start + 1 || mayAllocate(fn.env, instr)) {
        operands.push(instr.lvalue.identifier);
      }
      if (
        instr.value.kind === 'DeclareLocal' ||
        instr.value.kind === 'DeclareContext'
      ) {
        declareIdentifier(instr.value.lvalue.place);
      } else if (
        instr.value.kind === 'StoreLocal' ||
        instr.value.kind === 'StoreContext'
      ) {
        declareIdentifier(instr.value.lvalue.place);
        if (
          instr.value.lvalue.place.identifier.mutableRange.end >
          instr.value.lvalue.place.identifier.mutableRange.start + 1
        ) {
          operands.push(instr.value.lvalue.place.identifier);
        }
        if (
          isMutable(instr, instr.value.value) &&
          instr.value.value.identifier.mutableRange.start > 0
        ) {
          operands.push(instr.value.value.identifier);
        }
      } else if (instr.value.kind === 'Destructure') {
        for (const place of eachPatternOperand(instr.value.lvalue.pattern)) {
          declareIdentifier(place);
          if (
            place.identifier.mutableRange.end >
            place.identifier.mutableRange.start + 1
          ) {
            operands.push(place.identifier);
          }
        }
        if (
          isMutable(instr, instr.value.value) &&
          instr.value.value.identifier.mutableRange.start > 0
        ) {
          operands.push(instr.value.value.identifier);
        }
      } else if (instr.value.kind === 'MethodCall') {
        for (const operand of eachInstructionOperand(instr)) {
          if (
            isMutable(instr, operand) &&
            operand.identifier.mutableRange.start > 0
          ) {
            operands.push(operand.identifier);
          }
        }
        operands.push(instr.value.property.identifier);
      } else {
        for (const operand of eachInstructionOperand(instr)) {
          if (
            isMutable(instr, operand) &&
            operand.identifier.mutableRange.start > 0
          ) {
            operands.push(operand.identifier);
          }
        }
      }
      if (operands.length !== 0) {
        scopeIdentifiers.union(operands);
      }
    }
  }
  return scopeIdentifiers;
}
function mergeOverlappingReactiveScopesHIR(fn) {
  const scopesInfo = collectScopeInfo(fn);
  const joinedScopes = getOverlappingReactiveScopes(fn, scopesInfo);
  joinedScopes.forEach((scope, groupScope) => {
    if (scope !== groupScope) {
      groupScope.range.start = makeInstructionId(
        Math.min(groupScope.range.start, scope.range.start)
      );
      groupScope.range.end = makeInstructionId(
        Math.max(groupScope.range.end, scope.range.end)
      );
    }
  });
  for (const [place, originalScope] of scopesInfo.placeScopes) {
    const nextScope = joinedScopes.find(originalScope);
    if (nextScope !== null && nextScope !== originalScope) {
      place.identifier.scope = nextScope;
    }
  }
}
function collectScopeInfo(fn) {
  const scopeStarts = new Map();
  const scopeEnds = new Map();
  const placeScopes = new Map();
  function collectPlaceScope(place) {
    const scope = place.identifier.scope;
    if (scope != null) {
      placeScopes.set(place, scope);
      if (scope.range.start !== scope.range.end) {
        getOrInsertDefault(scopeStarts, scope.range.start, new Set()).add(
          scope
        );
        getOrInsertDefault(scopeEnds, scope.range.end, new Set()).add(scope);
      }
    }
  }
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      for (const operand of eachInstructionLValue(instr)) {
        collectPlaceScope(operand);
      }
      for (const operand of eachInstructionOperand(instr)) {
        collectPlaceScope(operand);
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      collectPlaceScope(operand);
    }
  }
  return {
    scopeStarts: [...scopeStarts.entries()]
      .map(([id, scopes]) => ({id: id, scopes: scopes}))
      .sort((a, b) => b.id - a.id),
    scopeEnds: [...scopeEnds.entries()]
      .map(([id, scopes]) => ({id: id, scopes: scopes}))
      .sort((a, b) => b.id - a.id),
    placeScopes: placeScopes,
  };
}
function visitInstructionId(
  id,
  {scopeEnds: scopeEnds, scopeStarts: scopeStarts},
  {activeScopes: activeScopes, joined: joined}
) {
  const scopeEndTop = scopeEnds.at(-1);
  if (scopeEndTop != null && scopeEndTop.id <= id) {
    scopeEnds.pop();
    const scopesSortedStartDescending = [...scopeEndTop.scopes].sort(
      (a, b) => b.range.start - a.range.start
    );
    for (const scope of scopesSortedStartDescending) {
      const idx = activeScopes.indexOf(scope);
      if (idx !== -1) {
        if (idx !== activeScopes.length - 1) {
          joined.union([scope, ...activeScopes.slice(idx + 1)]);
        }
        activeScopes.splice(idx, 1);
      }
    }
  }
  const scopeStartTop = scopeStarts.at(-1);
  if (scopeStartTop != null && scopeStartTop.id <= id) {
    scopeStarts.pop();
    const scopesSortedEndDescending = [...scopeStartTop.scopes].sort(
      (a, b) => b.range.end - a.range.end
    );
    activeScopes.push(...scopesSortedEndDescending);
    for (let i = 1; i < scopesSortedEndDescending.length; i++) {
      const prev = scopesSortedEndDescending[i - 1];
      const curr = scopesSortedEndDescending[i];
      if (prev.range.end === curr.range.end) {
        joined.union([prev, curr]);
      }
    }
  }
}
function visitPlace(id, place, {activeScopes: activeScopes, joined: joined}) {
  const placeScope = getPlaceScope(id, place);
  if (placeScope != null && isMutable({id: id}, place)) {
    const placeScopeIdx = activeScopes.indexOf(placeScope);
    if (placeScopeIdx !== -1 && placeScopeIdx !== activeScopes.length - 1) {
      joined.union([placeScope, ...activeScopes.slice(placeScopeIdx + 1)]);
    }
  }
}
function getOverlappingReactiveScopes(fn, context) {
  const state = {joined: new DisjointSet(), activeScopes: []};
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      visitInstructionId(instr.id, context, state);
      for (const place of eachInstructionOperand(instr)) {
        visitPlace(instr.id, place, state);
      }
      for (const place of eachInstructionLValue(instr)) {
        visitPlace(instr.id, place, state);
      }
    }
    visitInstructionId(block.terminal.id, context, state);
    for (const place of eachTerminalOperand(block.terminal)) {
      visitPlace(block.terminal.id, place, state);
    }
  }
  return state.joined;
}
function pruneUnusedLabelsHIR(fn) {
  var _a;
  const merged = [];
  const rewrites = new Map();
  for (const [blockId, block] of fn.body.blocks) {
    const terminal = block.terminal;
    if (terminal.kind === 'label') {
      const {block: nextId, fallthrough: fallthroughId} = terminal;
      const next = fn.body.blocks.get(nextId);
      const fallthrough = fn.body.blocks.get(fallthroughId);
      if (
        next.terminal.kind === 'goto' &&
        next.terminal.variant === GotoVariant.Break &&
        next.terminal.block === fallthroughId
      ) {
        if (next.kind === 'block' && fallthrough.kind === 'block') {
          merged.push({
            label: blockId,
            next: nextId,
            fallthrough: fallthroughId,
          });
        }
      }
    }
  }
  for (const {
    label: originalLabelId,
    next: nextId,
    fallthrough: fallthroughId,
  } of merged) {
    const labelId =
      (_a = rewrites.get(originalLabelId)) !== null && _a !== void 0
        ? _a
        : originalLabelId;
    const label = fn.body.blocks.get(labelId);
    const next = fn.body.blocks.get(nextId);
    const fallthrough = fn.body.blocks.get(fallthroughId);
    CompilerError.invariant(
      next.phis.size === 0 && fallthrough.phis.size === 0,
      {
        reason: 'Unexpected phis when merging label blocks',
        loc: label.terminal.loc,
      }
    );
    CompilerError.invariant(
      next.preds.size === 1 &&
        fallthrough.preds.size === 1 &&
        next.preds.has(originalLabelId) &&
        fallthrough.preds.has(nextId),
      {
        reason: 'Unexpected block predecessors when merging label blocks',
        loc: label.terminal.loc,
      }
    );
    label.instructions.push(...next.instructions, ...fallthrough.instructions);
    label.terminal = fallthrough.terminal;
    fn.body.blocks.delete(nextId);
    fn.body.blocks.delete(fallthroughId);
    rewrites.set(fallthroughId, labelId);
  }
  for (const [_, block] of fn.body.blocks) {
    for (const pred of block.preds) {
      const rewritten = rewrites.get(pred);
      if (rewritten != null) {
        block.preds.delete(pred);
        block.preds.add(rewritten);
      }
    }
  }
}
function validateRestrictedImports(
  path,
  {validateBlocklistedImports: validateBlocklistedImports}
) {
  if (
    validateBlocklistedImports == null ||
    validateBlocklistedImports.length === 0
  ) {
    return null;
  }
  const error = new CompilerError();
  const restrictedImports = new Set(validateBlocklistedImports);
  path.traverse({
    ImportDeclaration(importDeclPath) {
      var _a;
      if (restrictedImports.has(importDeclPath.node.source.value)) {
        error.push({
          severity: exports.ErrorSeverity.Todo,
          reason: 'Bailing out due to blocklisted import',
          description: `Import from module ${importDeclPath.node.source.value}`,
          loc:
            (_a = importDeclPath.node.loc) !== null && _a !== void 0
              ? _a
              : null,
        });
      }
    },
  });
  if (error.hasErrors()) {
    return error;
  } else {
    return null;
  }
}
function addImportsToProgram(path, importList) {
  const identifiers = new Set();
  const sortedImports = new Map();
  for (const {
    importSpecifierName: importSpecifierName,
    source: source,
  } of importList) {
    CompilerError.invariant(identifiers.has(importSpecifierName) === false, {
      reason: `Encountered conflicting import specifier for ${importSpecifierName} in Forget config.`,
      description: null,
      loc: GeneratedSource,
      suggestions: null,
    });
    CompilerError.invariant(
      path.scope.hasBinding(importSpecifierName) === false,
      {
        reason: `Encountered conflicting import specifiers for ${importSpecifierName} in generated program.`,
        description: null,
        loc: GeneratedSource,
        suggestions: null,
      }
    );
    identifiers.add(importSpecifierName);
    const importSpecifierNameList = getOrInsertDefault(
      sortedImports,
      source,
      []
    );
    importSpecifierNameList.push(importSpecifierName);
  }
  const stmts = [];
  for (const [source, importSpecifierNameList] of sortedImports) {
    const importSpecifiers = importSpecifierNameList.map(name => {
      const id = t__namespace.identifier(name);
      return t__namespace.importSpecifier(id, id);
    });
    stmts.push(
      t__namespace.importDeclaration(
        importSpecifiers,
        t__namespace.stringLiteral(source)
      )
    );
  }
  path.unshiftContainer('body', stmts);
}
function isNonNamespacedImport(importDeclPath, moduleName) {
  return (
    importDeclPath.get('source').node.value === moduleName &&
    importDeclPath
      .get('specifiers')
      .every(specifier => specifier.isImportSpecifier()) &&
    importDeclPath.node.importKind !== 'type' &&
    importDeclPath.node.importKind !== 'typeof'
  );
}
function hasExistingNonNamespacedImportOfModule(program, moduleName) {
  let hasExistingImport = false;
  program.traverse({
    ImportDeclaration(importDeclPath) {
      if (isNonNamespacedImport(importDeclPath, moduleName)) {
        hasExistingImport = true;
      }
    },
  });
  return hasExistingImport;
}
function addMemoCacheFunctionSpecifierToExistingImport(
  program,
  moduleName,
  identifierName
) {
  let didInsertUseMemoCache = false;
  program.traverse({
    ImportDeclaration(importDeclPath) {
      if (
        !didInsertUseMemoCache &&
        isNonNamespacedImport(importDeclPath, moduleName)
      ) {
        importDeclPath.pushContainer(
          'specifiers',
          t__namespace.importSpecifier(
            t__namespace.identifier(identifierName),
            t__namespace.identifier('c')
          )
        );
        didInsertUseMemoCache = true;
      }
    },
  });
  return didInsertUseMemoCache;
}
function updateMemoCacheFunctionImport(
  program,
  moduleName,
  useMemoCacheIdentifier
) {
  const hasExistingImport = hasExistingNonNamespacedImportOfModule(
    program,
    moduleName
  );
  if (hasExistingImport) {
    const didUpdateImport = addMemoCacheFunctionSpecifierToExistingImport(
      program,
      moduleName,
      useMemoCacheIdentifier
    );
    if (!didUpdateImport) {
      throw new Error(
        `Expected an ImportDeclaration of \`${moduleName}\` in order to update ImportSpecifiers with useMemoCache`
      );
    }
  } else {
    addMemoCacheFunctionImportDeclaration(
      program,
      moduleName,
      useMemoCacheIdentifier
    );
  }
}
function addMemoCacheFunctionImportDeclaration(program, moduleName, localName) {
  program.unshiftContainer(
    'body',
    t__namespace.importDeclaration(
      [
        t__namespace.importSpecifier(
          t__namespace.identifier(localName),
          t__namespace.identifier('c')
        ),
      ],
      t__namespace.stringLiteral(moduleName)
    )
  );
}
z.enum(['all_errors', 'critical_errors', 'none']);
const CompilerReactTargetSchema = z.enum(['17', '18', '19']);
z.enum(['infer', 'syntax', 'annotation', 'all']);
const defaultOptions = {
  compilationMode: 'infer',
  panicThreshold: 'none',
  environment: parseEnvironmentConfig({}).unwrap(),
  logger: null,
  gating: null,
  noEmit: false,
  eslintSuppressionRules: null,
  flowSuppressions: true,
  ignoreUseNoForget: false,
  sources: filename => filename.indexOf('node_modules') === -1,
  enableReanimatedCheck: true,
  target: '19',
};
function parsePluginOptions(obj) {
  if (obj == null || typeof obj !== 'object') {
    return defaultOptions;
  }
  const parsedOptions = Object.create(null);
  for (let [key, value] of Object.entries(obj)) {
    if (typeof value === 'string') {
      value = value.toLowerCase();
    }
    if (isCompilerFlag(key)) {
      switch (key) {
        case 'environment': {
          const environmentResult = parseEnvironmentConfig(value);
          if (environmentResult.isErr()) {
            CompilerError.throwInvalidConfig({
              reason:
                'Error in validating environment config. This is an advanced setting and not meant to be used directly',
              description: environmentResult.unwrapErr().toString(),
              suggestions: null,
              loc: null,
            });
          }
          parsedOptions[key] = environmentResult.unwrap();
          break;
        }
        case 'target': {
          parsedOptions[key] = parseTargetConfig(value);
          break;
        }
        default: {
          parsedOptions[key] = value;
        }
      }
    }
  }
  return Object.assign(Object.assign({}, defaultOptions), parsedOptions);
}
function parseTargetConfig(value) {
  const parsed = CompilerReactTargetSchema.safeParse(value);
  if (parsed.success) {
    return parsed.data;
  } else {
    CompilerError.throwInvalidConfig({
      reason: 'Not a valid target',
      description: `${fromZodError(parsed.error)}`,
      suggestions: null,
      loc: null,
    });
  }
}
function isCompilerFlag(s) {
  return hasOwnProperty$1(defaultOptions, s);
}
const DEFAULT_IDENTIFIER_INFO = {
  reassigned: false,
  reassignedByInnerFn: false,
  referencedByInnerFn: false,
};
const withFunctionScope = {
  enter: function (path, state) {
    state.currentFn.push(path);
  },
  exit: function (_, state) {
    state.currentFn.pop();
  },
};
function findContextIdentifiers(func) {
  const state = {currentFn: [], identifiers: new Map()};
  func.traverse(
    {
      FunctionDeclaration: withFunctionScope,
      FunctionExpression: withFunctionScope,
      ArrowFunctionExpression: withFunctionScope,
      ObjectMethod: withFunctionScope,
      AssignmentExpression(path, state) {
        var _a;
        const left = path.get('left');
        const currentFn =
          (_a = state.currentFn.at(-1)) !== null && _a !== void 0 ? _a : null;
        handleAssignment(currentFn, state.identifiers, left);
      },
      UpdateExpression(path, state) {
        var _a;
        const argument = path.get('argument');
        const currentFn =
          (_a = state.currentFn.at(-1)) !== null && _a !== void 0 ? _a : null;
        if (argument.isLVal()) {
          handleAssignment(currentFn, state.identifiers, argument);
        }
      },
      Identifier(path, state) {
        var _a;
        const currentFn =
          (_a = state.currentFn.at(-1)) !== null && _a !== void 0 ? _a : null;
        if (path.isReferencedIdentifier()) {
          handleIdentifier$1(currentFn, state.identifiers, path);
        }
      },
    },
    state
  );
  const result = new Set();
  for (const [id, info] of state.identifiers.entries()) {
    if (info.reassignedByInnerFn) {
      result.add(id);
    } else if (info.reassigned && info.referencedByInnerFn) {
      result.add(id);
    }
  }
  return result;
}
function handleIdentifier$1(currentFn, identifiers, path) {
  const name = path.node.name;
  const binding = path.scope.getBinding(name);
  if (binding == null) {
    return;
  }
  const identifier = getOrInsertDefault(
    identifiers,
    binding.identifier,
    Object.assign({}, DEFAULT_IDENTIFIER_INFO)
  );
  if (currentFn != null) {
    const bindingAboveLambdaScope = currentFn.scope.parent.getBinding(name);
    if (binding === bindingAboveLambdaScope) {
      identifier.referencedByInnerFn = true;
    }
  }
}
function handleAssignment(currentFn, identifiers, lvalPath) {
  var _a, _b, _c;
  const lvalNode = lvalPath.node;
  switch (lvalNode.type) {
    case 'Identifier': {
      const path = lvalPath;
      const name = path.node.name;
      const binding = path.scope.getBinding(name);
      if (binding == null) {
        break;
      }
      const state = getOrInsertDefault(
        identifiers,
        binding.identifier,
        Object.assign({}, DEFAULT_IDENTIFIER_INFO)
      );
      state.reassigned = true;
      if (currentFn != null) {
        const bindingAboveLambdaScope = currentFn.scope.parent.getBinding(name);
        if (binding === bindingAboveLambdaScope) {
          state.reassignedByInnerFn = true;
        }
      }
      break;
    }
    case 'ArrayPattern': {
      const path = lvalPath;
      for (const element of path.get('elements')) {
        if (nonNull(element)) {
          handleAssignment(currentFn, identifiers, element);
        }
      }
      break;
    }
    case 'ObjectPattern': {
      const path = lvalPath;
      for (const property of path.get('properties')) {
        if (property.isObjectProperty()) {
          const valuePath = property.get('value');
          CompilerError.invariant(valuePath.isLVal(), {
            reason: `[FindContextIdentifiers] Expected object property value to be an LVal, got: ${valuePath.type}`,
            description: null,
            loc:
              (_a = valuePath.node.loc) !== null && _a !== void 0
                ? _a
                : GeneratedSource,
            suggestions: null,
          });
          handleAssignment(currentFn, identifiers, valuePath);
        } else {
          CompilerError.invariant(property.isRestElement(), {
            reason: `[FindContextIdentifiers] Invalid assumptions for babel types.`,
            description: null,
            loc:
              (_b = property.node.loc) !== null && _b !== void 0
                ? _b
                : GeneratedSource,
            suggestions: null,
          });
          handleAssignment(currentFn, identifiers, property);
        }
      }
      break;
    }
    case 'AssignmentPattern': {
      const path = lvalPath;
      const left = path.get('left');
      handleAssignment(currentFn, identifiers, left);
      break;
    }
    case 'RestElement': {
      const path = lvalPath;
      handleAssignment(currentFn, identifiers, path.get('argument'));
      break;
    }
    case 'MemberExpression': {
      break;
    }
    default: {
      CompilerError.throwTodo({
        reason: `[FindContextIdentifiers] Cannot handle Object destructuring assignment target ${lvalNode.type}`,
        description: null,
        loc:
          (_c = lvalNode.loc) !== null && _c !== void 0 ? _c : GeneratedSource,
        suggestions: null,
      });
    }
  }
}
function nonNull(t) {
  return t.node != null;
}
function eliminateRedundantPhi(fn, sharedRewrites) {
  const ir = fn.body;
  const rewrites = sharedRewrites != null ? sharedRewrites : new Map();
  let hasBackEdge = false;
  const visited = new Set();
  let size = rewrites.size;
  do {
    size = rewrites.size;
    for (const [blockId, block] of ir.blocks) {
      if (!hasBackEdge) {
        for (const predId of block.preds) {
          if (!visited.has(predId)) {
            hasBackEdge = true;
          }
        }
      }
      visited.add(blockId);
      phis: for (const phi of block.phis) {
        phi.operands.forEach((place, _) => rewritePlace(place, rewrites));
        let same = null;
        for (const [_, operand] of phi.operands) {
          if (
            (same !== null && operand.identifier.id === same.id) ||
            operand.identifier.id === phi.place.identifier.id
          ) {
            continue;
          } else if (same !== null) {
            continue phis;
          } else {
            same = operand.identifier;
          }
        }
        CompilerError.invariant(same !== null, {
          reason: 'Expected phis to be non-empty',
          description: null,
          loc: null,
          suggestions: null,
        });
        rewrites.set(phi.place.identifier, same);
        block.phis.delete(phi);
      }
      for (const instr of block.instructions) {
        for (const place of eachInstructionLValue(instr)) {
          rewritePlace(place, rewrites);
        }
        for (const place of eachInstructionOperand(instr)) {
          rewritePlace(place, rewrites);
        }
        if (
          instr.value.kind === 'FunctionExpression' ||
          instr.value.kind === 'ObjectMethod'
        ) {
          const {context: context} = instr.value.loweredFunc.func;
          for (const place of context) {
            rewritePlace(place, rewrites);
          }
          eliminateRedundantPhi(instr.value.loweredFunc.func, rewrites);
        }
      }
      const {terminal: terminal} = block;
      for (const place of eachTerminalOperand(terminal)) {
        rewritePlace(place, rewrites);
      }
    }
  } while (rewrites.size > size && hasBackEdge);
}
function rewritePlace(place, rewrites) {
  const rewrite = rewrites.get(place.identifier);
  if (rewrite != null) {
    place.identifier = rewrite;
  }
}
var _SSABuilder_states,
  _SSABuilder_current,
  _SSABuilder_blocks,
  _SSABuilder_env,
  _SSABuilder_unknown,
  _SSABuilder_context;
class SSABuilder {
  constructor(env, blocks) {
    _SSABuilder_states.set(this, new Map());
    _SSABuilder_current.set(this, null);
    this.unsealedPreds = new Map();
    _SSABuilder_blocks.set(this, void 0);
    _SSABuilder_env.set(this, void 0);
    _SSABuilder_unknown.set(this, new Set());
    _SSABuilder_context.set(this, new Set());
    __classPrivateFieldSet(this, _SSABuilder_blocks, new Map(blocks), 'f');
    __classPrivateFieldSet(this, _SSABuilder_env, env, 'f');
  }
  get nextSsaId() {
    return __classPrivateFieldGet(this, _SSABuilder_env, 'f').nextIdentifierId;
  }
  defineFunction(func) {
    for (const [id, block] of func.body.blocks) {
      __classPrivateFieldGet(this, _SSABuilder_blocks, 'f').set(id, block);
    }
  }
  enter(fn) {
    const current = __classPrivateFieldGet(this, _SSABuilder_current, 'f');
    fn();
    __classPrivateFieldSet(this, _SSABuilder_current, current, 'f');
  }
  state() {
    CompilerError.invariant(
      __classPrivateFieldGet(this, _SSABuilder_current, 'f') !== null,
      {
        reason: 'we need to be in a block to access state!',
        description: null,
        loc: null,
        suggestions: null,
      }
    );
    return __classPrivateFieldGet(this, _SSABuilder_states, 'f').get(
      __classPrivateFieldGet(this, _SSABuilder_current, 'f')
    );
  }
  makeId(oldId) {
    return {
      id: this.nextSsaId,
      declarationId: oldId.declarationId,
      name: oldId.name,
      mutableRange: {start: makeInstructionId(0), end: makeInstructionId(0)},
      scope: null,
      type: makeType(),
      loc: oldId.loc,
    };
  }
  defineContext(oldPlace) {
    const newPlace = this.definePlace(oldPlace);
    __classPrivateFieldGet(this, _SSABuilder_context, 'f').add(
      oldPlace.identifier
    );
    return newPlace;
  }
  definePlace(oldPlace) {
    const oldId = oldPlace.identifier;
    if (__classPrivateFieldGet(this, _SSABuilder_unknown, 'f').has(oldId)) {
      CompilerError.throwTodo({
        reason: `[hoisting] EnterSSA: Expected identifier to be defined before being used`,
        description: `Identifier ${printIdentifier(oldId)} is undefined`,
        loc: oldPlace.loc,
        suggestions: null,
      });
    }
    if (__classPrivateFieldGet(this, _SSABuilder_context, 'f').has(oldId)) {
      return this.getPlace(oldPlace);
    }
    const newId = this.makeId(oldId);
    this.state().defs.set(oldId, newId);
    return Object.assign(Object.assign({}, oldPlace), {identifier: newId});
  }
  getPlace(oldPlace) {
    const newId = this.getIdAt(
      oldPlace,
      __classPrivateFieldGet(this, _SSABuilder_current, 'f').id
    );
    return Object.assign(Object.assign({}, oldPlace), {identifier: newId});
  }
  getIdAt(oldPlace, blockId) {
    const block = __classPrivateFieldGet(this, _SSABuilder_blocks, 'f').get(
      blockId
    );
    const state = __classPrivateFieldGet(this, _SSABuilder_states, 'f').get(
      block
    );
    if (state.defs.has(oldPlace.identifier)) {
      return state.defs.get(oldPlace.identifier);
    }
    if (block.preds.size == 0) {
      __classPrivateFieldGet(this, _SSABuilder_unknown, 'f').add(
        oldPlace.identifier
      );
      return oldPlace.identifier;
    }
    if (this.unsealedPreds.get(block) > 0) {
      const newId = this.makeId(oldPlace.identifier);
      state.incompletePhis.push({
        oldPlace: oldPlace,
        newPlace: Object.assign(Object.assign({}, oldPlace), {
          identifier: newId,
        }),
      });
      state.defs.set(oldPlace.identifier, newId);
      return newId;
    }
    if (block.preds.size == 1) {
      const [pred] = block.preds;
      const newId = this.getIdAt(oldPlace, pred);
      state.defs.set(oldPlace.identifier, newId);
      return newId;
    }
    const newId = this.makeId(oldPlace.identifier);
    state.defs.set(oldPlace.identifier, newId);
    return this.addPhi(
      block,
      oldPlace,
      Object.assign(Object.assign({}, oldPlace), {identifier: newId})
    );
  }
  addPhi(block, oldPlace, newPlace) {
    const predDefs = new Map();
    for (const predBlockId of block.preds) {
      const predId = this.getIdAt(oldPlace, predBlockId);
      predDefs.set(
        predBlockId,
        Object.assign(Object.assign({}, oldPlace), {identifier: predId})
      );
    }
    const phi = {kind: 'Phi', place: newPlace, operands: predDefs};
    block.phis.add(phi);
    return newPlace.identifier;
  }
  fixIncompletePhis(block) {
    const state = __classPrivateFieldGet(this, _SSABuilder_states, 'f').get(
      block
    );
    for (const phi of state.incompletePhis) {
      this.addPhi(block, phi.oldPlace, phi.newPlace);
    }
  }
  startBlock(block) {
    __classPrivateFieldSet(this, _SSABuilder_current, block, 'f');
    __classPrivateFieldGet(this, _SSABuilder_states, 'f').set(block, {
      defs: new Map(),
      incompletePhis: [],
    });
  }
  print() {
    var _a;
    const text = [];
    for (const [block, state] of __classPrivateFieldGet(
      this,
      _SSABuilder_states,
      'f'
    )) {
      text.push(`bb${block.id}:`);
      for (const [oldId, newId] of state.defs) {
        text.push(`  $${printIdentifier(oldId)}: $${printIdentifier(newId)}`);
      }
      for (const incompletePhi of state.incompletePhis) {
        text.push(
          `  iphi $${printPlace(incompletePhi.newPlace)} = $${printPlace(incompletePhi.oldPlace)}`
        );
      }
    }
    text.push(
      `current block: bb${(_a = __classPrivateFieldGet(this, _SSABuilder_current, 'f')) === null || _a === void 0 ? void 0 : _a.id}`
    );
    console.log(text.join('\n'));
  }
}
(_SSABuilder_states = new WeakMap()),
  (_SSABuilder_current = new WeakMap()),
  (_SSABuilder_blocks = new WeakMap()),
  (_SSABuilder_env = new WeakMap()),
  (_SSABuilder_unknown = new WeakMap()),
  (_SSABuilder_context = new WeakMap());
function enterSSA(func) {
  const builder = new SSABuilder(func.env, func.body.blocks);
  enterSSAImpl(func, builder, func.body.entry);
}
function enterSSAImpl(func, builder, rootEntry) {
  const visitedBlocks = new Set();
  for (const [blockId, block] of func.body.blocks) {
    CompilerError.invariant(!visitedBlocks.has(block), {
      reason: `found a cycle! visiting bb${block.id} again`,
      description: null,
      loc: null,
      suggestions: null,
    });
    visitedBlocks.add(block);
    builder.startBlock(block);
    if (blockId === rootEntry) {
      CompilerError.invariant(func.context.length === 0, {
        reason: `Expected function context to be empty for outer function declarations`,
        description: null,
        loc: func.loc,
        suggestions: null,
      });
      func.params = func.params.map(param => {
        if (param.kind === 'Identifier') {
          return builder.definePlace(param);
        } else {
          return {kind: 'Spread', place: builder.definePlace(param.place)};
        }
      });
    }
    for (const instr of block.instructions) {
      mapInstructionOperands(instr, place => builder.getPlace(place));
      mapInstructionLValues(instr, lvalue => builder.definePlace(lvalue));
      if (
        instr.value.kind === 'FunctionExpression' ||
        instr.value.kind === 'ObjectMethod'
      ) {
        const loweredFunc = instr.value.loweredFunc.func;
        const entry = loweredFunc.body.blocks.get(loweredFunc.body.entry);
        CompilerError.invariant(entry.preds.size === 0, {
          reason:
            'Expected function expression entry block to have zero predecessors',
          description: null,
          loc: null,
          suggestions: null,
        });
        entry.preds.add(blockId);
        builder.defineFunction(loweredFunc);
        builder.enter(() => {
          loweredFunc.context = loweredFunc.context.map(p =>
            builder.getPlace(p)
          );
          loweredFunc.params = loweredFunc.params.map(param => {
            if (param.kind === 'Identifier') {
              return builder.definePlace(param);
            } else {
              return {kind: 'Spread', place: builder.definePlace(param.place)};
            }
          });
          enterSSAImpl(loweredFunc, builder, rootEntry);
        });
        entry.preds.clear();
      }
    }
    mapTerminalOperands(block.terminal, place => builder.getPlace(place));
    for (const outputId of eachTerminalSuccessor(block.terminal)) {
      const output = func.body.blocks.get(outputId);
      let count;
      if (builder.unsealedPreds.has(output)) {
        count = builder.unsealedPreds.get(output) - 1;
      } else {
        count = output.preds.size - 1;
      }
      builder.unsealedPreds.set(output, count);
      if (count === 0 && visitedBlocks.has(output)) {
        builder.fixIncompletePhis(output);
      }
    }
  }
}
function rewriteInstructionKindsBasedOnReassignment(fn) {
  const declarations = new Map();
  for (const param of fn.params) {
    let place = param.kind === 'Identifier' ? param : param.place;
    if (place.identifier.name !== null) {
      declarations.set(place.identifier.declarationId, {
        kind: InstructionKind.Let,
        place: place,
      });
    }
  }
  for (const place of fn.context) {
    if (place.identifier.name !== null) {
      declarations.set(place.identifier.declarationId, {
        kind: InstructionKind.Let,
        place: place,
      });
    }
  }
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {value: value} = instr;
      switch (value.kind) {
        case 'DeclareLocal': {
          const lvalue = value.lvalue;
          CompilerError.invariant(
            !declarations.has(lvalue.place.identifier.declarationId),
            {
              reason: `Expected variable not to be defined prior to declaration`,
              description: `${printPlace(lvalue.place)} was already defined`,
              loc: lvalue.place.loc,
            }
          );
          declarations.set(lvalue.place.identifier.declarationId, lvalue);
          break;
        }
        case 'StoreLocal': {
          const lvalue = value.lvalue;
          if (lvalue.place.identifier.name !== null) {
            const declaration = declarations.get(
              lvalue.place.identifier.declarationId
            );
            if (declaration === undefined) {
              CompilerError.invariant(
                !declarations.has(lvalue.place.identifier.declarationId),
                {
                  reason: `Expected variable not to be defined prior to declaration`,
                  description: `${printPlace(lvalue.place)} was already defined`,
                  loc: lvalue.place.loc,
                }
              );
              declarations.set(lvalue.place.identifier.declarationId, lvalue);
              lvalue.kind = InstructionKind.Const;
            } else {
              declaration.kind = InstructionKind.Let;
              lvalue.kind = InstructionKind.Reassign;
            }
          }
          break;
        }
        case 'Destructure': {
          const lvalue = value.lvalue;
          let kind = null;
          for (const place of eachPatternOperand(lvalue.pattern)) {
            if (place.identifier.name === null) {
              CompilerError.invariant(
                kind === null || kind === InstructionKind.Const,
                {
                  reason: `Expected consistent kind for destructuring`,
                  description: `other places were \`${kind}\` but '${printPlace(place)}' is const`,
                  loc: place.loc,
                  suggestions: null,
                }
              );
              kind = InstructionKind.Const;
            } else {
              const declaration = declarations.get(
                place.identifier.declarationId
              );
              if (declaration === undefined) {
                CompilerError.invariant(block.kind !== 'value', {
                  reason: `TODO: Handle reassignment in a value block where the original declaration was removed by dead code elimination (DCE)`,
                  description: null,
                  loc: place.loc,
                  suggestions: null,
                });
                declarations.set(place.identifier.declarationId, lvalue);
                CompilerError.invariant(
                  kind === null || kind === InstructionKind.Const,
                  {
                    reason: `Expected consistent kind for destructuring`,
                    description: `Other places were \`${kind}\` but '${printPlace(place)}' is const`,
                    loc: place.loc,
                    suggestions: null,
                  }
                );
                kind = InstructionKind.Const;
              } else {
                CompilerError.invariant(
                  kind === null || kind === InstructionKind.Reassign,
                  {
                    reason: `Expected consistent kind for destructuring`,
                    description: `Other places were \`${kind}\` but '${printPlace(place)}' is reassigned`,
                    loc: place.loc,
                    suggestions: null,
                  }
                );
                kind = InstructionKind.Reassign;
                declaration.kind = InstructionKind.Let;
              }
            }
          }
          CompilerError.invariant(kind !== null, {
            reason: 'Expected at least one operand',
            description: null,
            loc: null,
            suggestions: null,
          });
          lvalue.kind = kind;
          break;
        }
        case 'PostfixUpdate':
        case 'PrefixUpdate': {
          const lvalue = value.lvalue;
          const declaration = declarations.get(lvalue.identifier.declarationId);
          CompilerError.invariant(declaration !== undefined, {
            reason: `Expected variable to have been defined`,
            description: `No declaration for ${printPlace(lvalue)}`,
            loc: lvalue.loc,
          });
          declaration.kind = InstructionKind.Let;
          break;
        }
      }
    }
  }
}
function constantPropagation(fn) {
  const constants = new Map();
  constantPropagationImpl(fn, constants);
}
function constantPropagationImpl(fn, constants) {
  while (true) {
    const haveTerminalsChanged = applyConstantPropagation(fn, constants);
    if (!haveTerminalsChanged) {
      break;
    }
    reversePostorderBlocks(fn.body);
    removeUnreachableForUpdates(fn.body);
    removeDeadDoWhileStatements(fn.body);
    removeUnnecessaryTryCatch(fn.body);
    markInstructionIds(fn.body);
    markPredecessors(fn.body);
    for (const [, block] of fn.body.blocks) {
      for (const phi of block.phis) {
        for (const [predecessor] of phi.operands) {
          if (!block.preds.has(predecessor)) {
            phi.operands.delete(predecessor);
          }
        }
      }
    }
    eliminateRedundantPhi(fn);
    mergeConsecutiveBlocks(fn);
    assertConsistentIdentifiers(fn);
    assertTerminalSuccessorsExist(fn);
  }
}
function applyConstantPropagation(fn, constants) {
  let hasChanges = false;
  for (const [, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      let value = evaluatePhi(phi, constants);
      if (value !== null) {
        constants.set(phi.place.identifier.id, value);
      }
    }
    for (let i = 0; i < block.instructions.length; i++) {
      if (block.kind === 'sequence' && i === block.instructions.length - 1) {
        continue;
      }
      const instr = block.instructions[i];
      const value = evaluateInstruction(constants, instr);
      if (value !== null) {
        constants.set(instr.lvalue.identifier.id, value);
      }
    }
    const terminal = block.terminal;
    switch (terminal.kind) {
      case 'if': {
        const testValue = read(constants, terminal.test);
        if (testValue !== null && testValue.kind === 'Primitive') {
          hasChanges = true;
          const targetBlockId = testValue.value
            ? terminal.consequent
            : terminal.alternate;
          block.terminal = {
            kind: 'goto',
            variant: GotoVariant.Break,
            block: targetBlockId,
            id: terminal.id,
            loc: terminal.loc,
          };
        }
        break;
      }
    }
  }
  return hasChanges;
}
function evaluatePhi(phi, constants) {
  var _a;
  let value = null;
  for (const [, operand] of phi.operands) {
    const operandValue =
      (_a = constants.get(operand.identifier.id)) !== null && _a !== void 0
        ? _a
        : null;
    if (operandValue === null) {
      return null;
    }
    if (value === null) {
      value = operandValue;
      continue;
    }
    if (operandValue.kind !== value.kind) {
      return null;
    }
    switch (operandValue.kind) {
      case 'Primitive': {
        CompilerError.invariant(value.kind === 'Primitive', {
          reason: 'value kind expected to be Primitive',
          loc: null,
          suggestions: null,
        });
        if (operandValue.value !== value.value) {
          return null;
        }
        break;
      }
      case 'LoadGlobal': {
        CompilerError.invariant(value.kind === 'LoadGlobal', {
          reason: 'value kind expected to be LoadGlobal',
          loc: null,
          suggestions: null,
        });
        if (operandValue.binding.name !== value.binding.name) {
          return null;
        }
        break;
      }
      default:
        return null;
    }
  }
  return value;
}
function evaluateInstruction(constants, instr) {
  const value = instr.value;
  switch (value.kind) {
    case 'Primitive': {
      return value;
    }
    case 'LoadGlobal': {
      return value;
    }
    case 'ComputedLoad': {
      const property = read(constants, value.property);
      if (
        property !== null &&
        property.kind === 'Primitive' &&
        typeof property.value === 'string' &&
        t$d.isValidIdentifier(property.value)
      ) {
        const nextValue = {
          kind: 'PropertyLoad',
          loc: value.loc,
          property: property.value,
          object: value.object,
        };
        instr.value = nextValue;
      }
      return null;
    }
    case 'ComputedStore': {
      const property = read(constants, value.property);
      if (
        property !== null &&
        property.kind === 'Primitive' &&
        typeof property.value === 'string' &&
        t$d.isValidIdentifier(property.value)
      ) {
        const nextValue = {
          kind: 'PropertyStore',
          loc: value.loc,
          property: property.value,
          object: value.object,
          value: value.value,
        };
        instr.value = nextValue;
      }
      return null;
    }
    case 'PostfixUpdate': {
      const previous = read(constants, value.value);
      if (
        previous !== null &&
        previous.kind === 'Primitive' &&
        typeof previous.value === 'number'
      ) {
        const next =
          value.operation === '++' ? previous.value + 1 : previous.value - 1;
        constants.set(value.lvalue.identifier.id, {
          kind: 'Primitive',
          value: next,
          loc: value.loc,
        });
        return previous;
      }
      return null;
    }
    case 'PrefixUpdate': {
      const previous = read(constants, value.value);
      if (
        previous !== null &&
        previous.kind === 'Primitive' &&
        typeof previous.value === 'number'
      ) {
        const next = {
          kind: 'Primitive',
          value:
            value.operation === '++' ? previous.value + 1 : previous.value - 1,
          loc: value.loc,
        };
        constants.set(value.lvalue.identifier.id, next);
        return next;
      }
      return null;
    }
    case 'UnaryExpression': {
      switch (value.operator) {
        case '!': {
          const operand = read(constants, value.value);
          if (operand !== null && operand.kind === 'Primitive') {
            const result = {
              kind: 'Primitive',
              value: !operand.value,
              loc: value.loc,
            };
            instr.value = result;
            return result;
          }
          return null;
        }
        default:
          return null;
      }
    }
    case 'BinaryExpression': {
      const lhsValue = read(constants, value.left);
      const rhsValue = read(constants, value.right);
      if (
        lhsValue !== null &&
        rhsValue !== null &&
        lhsValue.kind === 'Primitive' &&
        rhsValue.kind === 'Primitive'
      ) {
        const lhs = lhsValue.value;
        const rhs = rhsValue.value;
        let result = null;
        switch (value.operator) {
          case '+': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs + rhs, loc: value.loc};
            } else if (typeof lhs === 'string' && typeof rhs === 'string') {
              result = {kind: 'Primitive', value: lhs + rhs, loc: value.loc};
            }
            break;
          }
          case '-': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs - rhs, loc: value.loc};
            }
            break;
          }
          case '*': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs * rhs, loc: value.loc};
            }
            break;
          }
          case '/': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs / rhs, loc: value.loc};
            }
            break;
          }
          case '|': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs | rhs, loc: value.loc};
            }
            break;
          }
          case '&': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs & rhs, loc: value.loc};
            }
            break;
          }
          case '^': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs ^ rhs, loc: value.loc};
            }
            break;
          }
          case '<<': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs << rhs, loc: value.loc};
            }
            break;
          }
          case '>>': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs >> rhs, loc: value.loc};
            }
            break;
          }
          case '>>>': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs >>> rhs, loc: value.loc};
            }
            break;
          }
          case '%': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs % rhs, loc: value.loc};
            }
            break;
          }
          case '**': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {
                kind: 'Primitive',
                value: Math.pow(lhs, rhs),
                loc: value.loc,
              };
            }
            break;
          }
          case '<': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs < rhs, loc: value.loc};
            }
            break;
          }
          case '<=': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs <= rhs, loc: value.loc};
            }
            break;
          }
          case '>': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs > rhs, loc: value.loc};
            }
            break;
          }
          case '>=': {
            if (typeof lhs === 'number' && typeof rhs === 'number') {
              result = {kind: 'Primitive', value: lhs >= rhs, loc: value.loc};
            }
            break;
          }
          case '==': {
            result = {kind: 'Primitive', value: lhs == rhs, loc: value.loc};
            break;
          }
          case '===': {
            result = {kind: 'Primitive', value: lhs === rhs, loc: value.loc};
            break;
          }
          case '!=': {
            result = {kind: 'Primitive', value: lhs != rhs, loc: value.loc};
            break;
          }
          case '!==': {
            result = {kind: 'Primitive', value: lhs !== rhs, loc: value.loc};
            break;
          }
        }
        if (result !== null) {
          instr.value = result;
          return result;
        }
      }
      return null;
    }
    case 'PropertyLoad': {
      const objectValue = read(constants, value.object);
      if (objectValue !== null) {
        if (
          objectValue.kind === 'Primitive' &&
          typeof objectValue.value === 'string' &&
          value.property === 'length'
        ) {
          const result = {
            kind: 'Primitive',
            value: objectValue.value.length,
            loc: value.loc,
          };
          instr.value = result;
          return result;
        }
      }
      return null;
    }
    case 'LoadLocal': {
      const placeValue = read(constants, value.place);
      if (placeValue !== null) {
        instr.value = placeValue;
      }
      return placeValue;
    }
    case 'StoreLocal': {
      const placeValue = read(constants, value.value);
      if (placeValue !== null) {
        constants.set(value.lvalue.place.identifier.id, placeValue);
      }
      return placeValue;
    }
    case 'ObjectMethod':
    case 'FunctionExpression': {
      constantPropagationImpl(value.loweredFunc.func, constants);
      return null;
    }
    default: {
      return null;
    }
  }
}
function read(constants, place) {
  var _a;
  return (_a = constants.get(place.identifier.id)) !== null && _a !== void 0
    ? _a
    : null;
}
function deadCodeElimination(fn) {
  const state = findReferencedIdentifiers(fn);
  for (const [, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      if (!state.isIdOrNameUsed(phi.place.identifier)) {
        block.phis.delete(phi);
      }
    }
    retainWhere(block.instructions, instr =>
      state.isIdOrNameUsed(instr.lvalue.identifier)
    );
    for (let i = 0; i < block.instructions.length; i++) {
      const isBlockValue =
        block.kind !== 'block' && i === block.instructions.length - 1;
      if (!isBlockValue) {
        rewriteInstruction(block.instructions[i], state);
      }
    }
  }
  retainWhere(fn.context, contextVar =>
    state.isIdOrNameUsed(contextVar.identifier)
  );
}
let State$2 = class State {
  constructor() {
    this.named = new Set();
    this.identifiers = new Set();
  }
  reference(identifier) {
    this.identifiers.add(identifier.id);
    if (identifier.name !== null) {
      this.named.add(identifier.name.value);
    }
  }
  isIdOrNameUsed(identifier) {
    return (
      this.identifiers.has(identifier.id) ||
      (identifier.name !== null && this.named.has(identifier.name.value))
    );
  }
  isIdUsed(identifier) {
    return this.identifiers.has(identifier.id);
  }
  get count() {
    return this.identifiers.size;
  }
};
function findReferencedIdentifiers(fn) {
  const hasLoop = hasBackEdge(fn);
  const reversedBlocks = [...fn.body.blocks.values()].reverse();
  const state = new State$2();
  let size = state.count;
  do {
    size = state.count;
    for (const block of reversedBlocks) {
      for (const operand of eachTerminalOperand(block.terminal)) {
        state.reference(operand.identifier);
      }
      for (let i = block.instructions.length - 1; i >= 0; i--) {
        const instr = block.instructions[i];
        const isBlockValue =
          block.kind !== 'block' && i === block.instructions.length - 1;
        if (isBlockValue) {
          state.reference(instr.lvalue.identifier);
          for (const place of eachInstructionValueOperand(instr.value)) {
            state.reference(place.identifier);
          }
        } else if (
          state.isIdOrNameUsed(instr.lvalue.identifier) ||
          !pruneableValue(instr.value, state)
        ) {
          state.reference(instr.lvalue.identifier);
          if (instr.value.kind === 'StoreLocal') {
            if (
              instr.value.lvalue.kind === InstructionKind.Reassign ||
              state.isIdUsed(instr.value.lvalue.place.identifier)
            ) {
              state.reference(instr.value.value.identifier);
            }
          } else {
            for (const operand of eachInstructionValueOperand(instr.value)) {
              state.reference(operand.identifier);
            }
          }
        }
      }
      for (const phi of block.phis) {
        if (state.isIdOrNameUsed(phi.place.identifier)) {
          for (const [_pred, operand] of phi.operands) {
            state.reference(operand.identifier);
          }
        }
      }
    }
  } while (state.count > size && hasLoop);
  return state;
}
function rewriteInstruction(instr, state) {
  if (instr.value.kind === 'Destructure') {
    switch (instr.value.lvalue.pattern.kind) {
      case 'ArrayPattern': {
        let lastEntryIndex = 0;
        const items = instr.value.lvalue.pattern.items;
        for (let i = 0; i < items.length; i++) {
          const item = items[i];
          if (item.kind === 'Identifier') {
            if (!state.isIdOrNameUsed(item.identifier)) {
              items[i] = {kind: 'Hole'};
            } else {
              lastEntryIndex = i;
            }
          } else if (item.kind === 'Spread') {
            if (!state.isIdOrNameUsed(item.place.identifier)) {
              items[i] = {kind: 'Hole'};
            } else {
              lastEntryIndex = i;
            }
          }
        }
        items.length = lastEntryIndex + 1;
        break;
      }
      case 'ObjectPattern': {
        let nextProperties = null;
        for (const property of instr.value.lvalue.pattern.properties) {
          if (property.kind === 'ObjectProperty') {
            if (state.isIdOrNameUsed(property.place.identifier)) {
              nextProperties !== null && nextProperties !== void 0
                ? nextProperties
                : (nextProperties = []);
              nextProperties.push(property);
            }
          } else {
            if (state.isIdOrNameUsed(property.place.identifier)) {
              nextProperties = null;
              break;
            }
          }
        }
        if (nextProperties !== null) {
          instr.value.lvalue.pattern.properties = nextProperties;
        }
        break;
      }
      default: {
        assertExhaustive(
          instr.value.lvalue.pattern,
          `Unexpected pattern kind '${instr.value.lvalue.pattern.kind}'`
        );
      }
    }
  } else if (instr.value.kind === 'StoreLocal') {
    if (
      instr.value.lvalue.kind !== InstructionKind.Reassign &&
      !state.isIdUsed(instr.value.lvalue.place.identifier)
    ) {
      instr.value = {
        kind: 'DeclareLocal',
        lvalue: instr.value.lvalue,
        type: instr.value.type,
        loc: instr.value.loc,
      };
    }
  }
}
function pruneableValue(value, state) {
  switch (value.kind) {
    case 'DeclareLocal': {
      return !state.isIdOrNameUsed(value.lvalue.place.identifier);
    }
    case 'StoreLocal': {
      if (value.lvalue.kind === InstructionKind.Reassign) {
        return !state.isIdUsed(value.lvalue.place.identifier);
      }
      return !state.isIdOrNameUsed(value.lvalue.place.identifier);
    }
    case 'Destructure': {
      let isIdOrNameUsed = false;
      let isIdUsed = false;
      for (const place of eachPatternOperand(value.lvalue.pattern)) {
        if (state.isIdUsed(place.identifier)) {
          isIdOrNameUsed = true;
          isIdUsed = true;
        } else if (state.isIdOrNameUsed(place.identifier)) {
          isIdOrNameUsed = true;
        }
      }
      if (value.lvalue.kind === InstructionKind.Reassign) {
        return !isIdUsed;
      } else {
        return !isIdOrNameUsed;
      }
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate': {
      return !state.isIdUsed(value.lvalue.identifier);
    }
    case 'Debugger': {
      return false;
    }
    case 'Await':
    case 'CallExpression':
    case 'ComputedDelete':
    case 'ComputedStore':
    case 'PropertyDelete':
    case 'MethodCall':
    case 'PropertyStore':
    case 'StoreGlobal': {
      return false;
    }
    case 'NewExpression':
    case 'UnsupportedNode':
    case 'TaggedTemplateExpression': {
      return false;
    }
    case 'GetIterator':
    case 'NextPropertyOf':
    case 'IteratorNext': {
      return false;
    }
    case 'LoadContext':
    case 'DeclareContext':
    case 'StoreContext': {
      return false;
    }
    case 'StartMemoize':
    case 'FinishMemoize': {
      return false;
    }
    case 'RegExpLiteral':
    case 'MetaProperty':
    case 'LoadGlobal':
    case 'ArrayExpression':
    case 'BinaryExpression':
    case 'ComputedLoad':
    case 'ObjectMethod':
    case 'FunctionExpression':
    case 'LoadLocal':
    case 'JsxExpression':
    case 'JsxFragment':
    case 'JSXText':
    case 'ObjectExpression':
    case 'Primitive':
    case 'PropertyLoad':
    case 'TemplateLiteral':
    case 'TypeCastExpression':
    case 'UnaryExpression': {
      return true;
    }
    default: {
      assertExhaustive(value, `Unexepcted value kind \`${value.kind}\``);
    }
  }
}
function hasBackEdge(fn) {
  return findBlocksWithBackEdges(fn).size > 0;
}
function findBlocksWithBackEdges(fn) {
  const visited = new Set();
  const blocks = new Set();
  for (const [blockId, block] of fn.body.blocks) {
    for (const predId of block.preds) {
      if (!visited.has(predId)) {
        blocks.add(blockId);
      }
    }
    visited.add(blockId);
  }
  return blocks;
}
function pruneMaybeThrows(fn) {
  const terminalMapping = pruneMaybeThrowsImpl(fn);
  if (terminalMapping) {
    reversePostorderBlocks(fn.body);
    removeUnreachableForUpdates(fn.body);
    removeDeadDoWhileStatements(fn.body);
    removeUnnecessaryTryCatch(fn.body);
    markInstructionIds(fn.body);
    mergeConsecutiveBlocks(fn);
    for (const [, block] of fn.body.blocks) {
      for (const phi of block.phis) {
        for (const [predecessor, operand] of phi.operands) {
          if (!block.preds.has(predecessor)) {
            const mappedTerminal = terminalMapping.get(predecessor);
            CompilerError.invariant(mappedTerminal != null, {
              reason: `Expected non-existing phi operand's predecessor to have been mapped to a new terminal`,
              loc: GeneratedSource,
              description: `Could not find mapping for predecessor bb${predecessor} in block bb${block.id} for phi ${printPlace(phi.place)}`,
              suggestions: null,
            });
            phi.operands.delete(predecessor);
            phi.operands.set(mappedTerminal, operand);
          }
        }
      }
    }
    assertConsistentIdentifiers(fn);
    assertTerminalSuccessorsExist(fn);
  }
}
function pruneMaybeThrowsImpl(fn) {
  var _a;
  const terminalMapping = new Map();
  for (const [_, block] of fn.body.blocks) {
    const terminal = block.terminal;
    if (terminal.kind !== 'maybe-throw') {
      continue;
    }
    const canThrow = block.instructions.some(instr =>
      instructionMayThrow(instr)
    );
    if (!canThrow) {
      const source =
        (_a = terminalMapping.get(block.id)) !== null && _a !== void 0
          ? _a
          : block.id;
      terminalMapping.set(terminal.continuation, source);
      block.terminal = {
        kind: 'goto',
        block: terminal.continuation,
        variant: GotoVariant.Break,
        id: terminal.id,
        loc: terminal.loc,
      };
    }
  }
  return terminalMapping.size > 0 ? terminalMapping : null;
}
function instructionMayThrow(instr) {
  switch (instr.value.kind) {
    case 'Primitive':
    case 'ArrayExpression':
    case 'ObjectExpression': {
      return false;
    }
    default: {
      return true;
    }
  }
}
function inlineJsxTransform(fn, inlineJsxTransformConfig) {
  var _a;
  const inlinedJsxDeclarations = new Map();
  for (const [_, currentBlock] of [...fn.body.blocks]) {
    let fallthroughBlockInstructions = null;
    const instructionCount = currentBlock.instructions.length;
    for (let i = 0; i < instructionCount; i++) {
      const instr = currentBlock.instructions[i];
      if (currentBlock.kind === 'value') {
        (_a = fn.env.logger) === null || _a === void 0
          ? void 0
          : _a.logEvent(fn.env.filename, {
              kind: 'CompileDiagnostic',
              fnLoc: null,
              detail: {
                reason: 'JSX Inlining is not supported on value blocks',
                loc: instr.loc,
              },
            });
        continue;
      }
      switch (instr.value.kind) {
        case 'JsxExpression':
        case 'JsxFragment': {
          const currentBlockInstructions = currentBlock.instructions.slice(
            0,
            i
          );
          const thenBlockInstructions = currentBlock.instructions.slice(
            i,
            i + 1
          );
          const elseBlockInstructions = [];
          fallthroughBlockInstructions !== null &&
          fallthroughBlockInstructions !== void 0
            ? fallthroughBlockInstructions
            : (fallthroughBlockInstructions = currentBlock.instructions.slice(
                i + 1
              ));
          const fallthroughBlockId = fn.env.nextBlockId;
          const fallthroughBlock = {
            kind: currentBlock.kind,
            id: fallthroughBlockId,
            instructions: fallthroughBlockInstructions,
            terminal: currentBlock.terminal,
            preds: new Set(),
            phis: new Set(),
          };
          const varPlace = createTemporaryPlace(fn.env, instr.value.loc);
          promoteTemporary(varPlace.identifier);
          const varLValuePlace = createTemporaryPlace(fn.env, instr.value.loc);
          const thenVarPlace = Object.assign(Object.assign({}, varPlace), {
            identifier: forkTemporaryIdentifier(
              fn.env.nextIdentifierId,
              varPlace.identifier
            ),
          });
          const elseVarPlace = Object.assign(Object.assign({}, varPlace), {
            identifier: forkTemporaryIdentifier(
              fn.env.nextIdentifierId,
              varPlace.identifier
            ),
          });
          const varInstruction = {
            id: makeInstructionId(0),
            lvalue: Object.assign({}, varLValuePlace),
            value: {
              kind: 'DeclareLocal',
              lvalue: {
                place: Object.assign({}, varPlace),
                kind: InstructionKind.Let,
              },
              type: null,
              loc: instr.value.loc,
            },
            loc: instr.loc,
          };
          currentBlockInstructions.push(varInstruction);
          const devGlobalPlace = createTemporaryPlace(fn.env, instr.value.loc);
          const devGlobalInstruction = {
            id: makeInstructionId(0),
            lvalue: Object.assign(Object.assign({}, devGlobalPlace), {
              effect: exports.Effect.Mutate,
            }),
            value: {
              kind: 'LoadGlobal',
              binding: {
                kind: 'Global',
                name: inlineJsxTransformConfig.globalDevVar,
              },
              loc: instr.value.loc,
            },
            loc: instr.loc,
          };
          currentBlockInstructions.push(devGlobalInstruction);
          const thenBlockId = fn.env.nextBlockId;
          const elseBlockId = fn.env.nextBlockId;
          const ifTerminal = {
            kind: 'if',
            test: Object.assign(Object.assign({}, devGlobalPlace), {
              effect: exports.Effect.Read,
            }),
            consequent: thenBlockId,
            alternate: elseBlockId,
            fallthrough: fallthroughBlockId,
            loc: instr.loc,
            id: makeInstructionId(0),
          };
          currentBlock.instructions = currentBlockInstructions;
          currentBlock.terminal = ifTerminal;
          const thenBlock = {
            id: thenBlockId,
            instructions: thenBlockInstructions,
            kind: 'block',
            phis: new Set(),
            preds: new Set(),
            terminal: {
              kind: 'goto',
              block: fallthroughBlockId,
              variant: GotoVariant.Break,
              id: makeInstructionId(0),
              loc: instr.loc,
            },
          };
          fn.body.blocks.set(thenBlockId, thenBlock);
          const resassignElsePlace = createTemporaryPlace(
            fn.env,
            instr.value.loc
          );
          const reassignElseInstruction = {
            id: makeInstructionId(0),
            lvalue: Object.assign({}, resassignElsePlace),
            value: {
              kind: 'StoreLocal',
              lvalue: {place: elseVarPlace, kind: InstructionKind.Reassign},
              value: Object.assign({}, instr.lvalue),
              type: null,
              loc: instr.value.loc,
            },
            loc: instr.loc,
          };
          thenBlockInstructions.push(reassignElseInstruction);
          const elseBlockTerminal = {
            kind: 'goto',
            block: fallthroughBlockId,
            variant: GotoVariant.Break,
            id: makeInstructionId(0),
            loc: instr.loc,
          };
          const elseBlock = {
            id: elseBlockId,
            instructions: elseBlockInstructions,
            kind: 'block',
            phis: new Set(),
            preds: new Set(),
            terminal: elseBlockTerminal,
          };
          fn.body.blocks.set(elseBlockId, elseBlock);
          const {
            refProperty: refProperty,
            keyProperty: keyProperty,
            propsProperty: propsProperty,
          } = createPropsProperties(
            fn,
            instr,
            elseBlockInstructions,
            instr.value.kind === 'JsxExpression' ? instr.value.props : [],
            instr.value.children
          );
          const reactElementInstructionPlace = createTemporaryPlace(
            fn.env,
            instr.value.loc
          );
          const reactElementInstruction = {
            id: makeInstructionId(0),
            lvalue: Object.assign(
              Object.assign({}, reactElementInstructionPlace),
              {effect: exports.Effect.Store}
            ),
            value: {
              kind: 'ObjectExpression',
              properties: [
                createSymbolProperty(
                  fn,
                  instr,
                  elseBlockInstructions,
                  '$$typeof',
                  inlineJsxTransformConfig.elementSymbol
                ),
                instr.value.kind === 'JsxExpression'
                  ? createTagProperty(
                      fn,
                      instr,
                      elseBlockInstructions,
                      instr.value.tag
                    )
                  : createSymbolProperty(
                      fn,
                      instr,
                      elseBlockInstructions,
                      'type',
                      'react.fragment'
                    ),
                refProperty,
                keyProperty,
                propsProperty,
              ],
              loc: instr.value.loc,
            },
            loc: instr.loc,
          };
          elseBlockInstructions.push(reactElementInstruction);
          const reassignConditionalInstruction = {
            id: makeInstructionId(0),
            lvalue: Object.assign(
              {},
              createTemporaryPlace(fn.env, instr.value.loc)
            ),
            value: {
              kind: 'StoreLocal',
              lvalue: {
                place: Object.assign({}, elseVarPlace),
                kind: InstructionKind.Reassign,
              },
              value: Object.assign({}, reactElementInstruction.lvalue),
              type: null,
              loc: instr.value.loc,
            },
            loc: instr.loc,
          };
          elseBlockInstructions.push(reassignConditionalInstruction);
          const operands = new Map();
          operands.set(thenBlockId, Object.assign({}, elseVarPlace));
          operands.set(elseBlockId, Object.assign({}, thenVarPlace));
          const phiIdentifier = forkTemporaryIdentifier(
            fn.env.nextIdentifierId,
            varPlace.identifier
          );
          const phiPlace = Object.assign(
            Object.assign({}, createTemporaryPlace(fn.env, instr.value.loc)),
            {identifier: phiIdentifier}
          );
          const phis = new Set([
            {kind: 'Phi', operands: operands, place: phiPlace},
          ]);
          fallthroughBlock.phis = phis;
          fn.body.blocks.set(fallthroughBlockId, fallthroughBlock);
          inlinedJsxDeclarations.set(instr.lvalue.identifier.declarationId, {
            identifier: phiIdentifier,
            blockIdsToIgnore: new Set([thenBlockId, elseBlockId]),
          });
          break;
        }
        case 'FunctionExpression':
        case 'ObjectMethod': {
          inlineJsxTransform(
            instr.value.loweredFunc.func,
            inlineJsxTransformConfig
          );
          break;
        }
      }
    }
  }
  for (const [blockId, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      mapInstructionOperands(instr, place =>
        handlePlace(place, blockId, inlinedJsxDeclarations)
      );
      mapInstructionLValues(instr, lvalue =>
        handlelValue(lvalue, blockId, inlinedJsxDeclarations)
      );
      mapInstructionValueOperands(instr.value, place =>
        handlePlace(place, blockId, inlinedJsxDeclarations)
      );
    }
    mapTerminalOperands(block.terminal, place =>
      handlePlace(place, blockId, inlinedJsxDeclarations)
    );
    if (block.terminal.kind === 'scope') {
      const scope = block.terminal.scope;
      for (const dep of scope.dependencies) {
        dep.identifier = handleIdentifier(
          dep.identifier,
          inlinedJsxDeclarations
        );
      }
      for (const [origId, decl] of [...scope.declarations]) {
        const newDecl = handleIdentifier(
          decl.identifier,
          inlinedJsxDeclarations
        );
        if (newDecl.id !== origId) {
          scope.declarations.delete(origId);
          scope.declarations.set(decl.identifier.id, {
            identifier: newDecl,
            scope: decl.scope,
          });
        }
      }
    }
  }
  reversePostorderBlocks(fn.body);
  markPredecessors(fn.body);
  markInstructionIds(fn.body);
  fixScopeAndIdentifierRanges(fn.body);
}
function createSymbolProperty(
  fn,
  instr,
  nextInstructions,
  propertyName,
  symbolName
) {
  const symbolPlace = createTemporaryPlace(fn.env, instr.value.loc);
  const symbolInstruction = {
    id: makeInstructionId(0),
    lvalue: Object.assign(Object.assign({}, symbolPlace), {
      effect: exports.Effect.Mutate,
    }),
    value: {
      kind: 'LoadGlobal',
      binding: {kind: 'Global', name: 'Symbol'},
      loc: instr.value.loc,
    },
    loc: instr.loc,
  };
  nextInstructions.push(symbolInstruction);
  const symbolForPlace = createTemporaryPlace(fn.env, instr.value.loc);
  const symbolForInstruction = {
    id: makeInstructionId(0),
    lvalue: Object.assign(Object.assign({}, symbolForPlace), {
      effect: exports.Effect.Read,
    }),
    value: {
      kind: 'PropertyLoad',
      object: Object.assign({}, symbolInstruction.lvalue),
      property: 'for',
      loc: instr.value.loc,
    },
    loc: instr.loc,
  };
  nextInstructions.push(symbolForInstruction);
  const symbolValuePlace = createTemporaryPlace(fn.env, instr.value.loc);
  const symbolValueInstruction = {
    id: makeInstructionId(0),
    lvalue: Object.assign(Object.assign({}, symbolValuePlace), {
      effect: exports.Effect.Mutate,
    }),
    value: {kind: 'Primitive', value: symbolName, loc: instr.value.loc},
    loc: instr.loc,
  };
  nextInstructions.push(symbolValueInstruction);
  const $$typeofPlace = createTemporaryPlace(fn.env, instr.value.loc);
  const $$typeofInstruction = {
    id: makeInstructionId(0),
    lvalue: Object.assign(Object.assign({}, $$typeofPlace), {
      effect: exports.Effect.Mutate,
    }),
    value: {
      kind: 'MethodCall',
      receiver: symbolInstruction.lvalue,
      property: symbolForInstruction.lvalue,
      args: [symbolValueInstruction.lvalue],
      loc: instr.value.loc,
    },
    loc: instr.loc,
  };
  const $$typeofProperty = {
    kind: 'ObjectProperty',
    key: {name: propertyName, kind: 'string'},
    type: 'property',
    place: Object.assign(Object.assign({}, $$typeofPlace), {
      effect: exports.Effect.Capture,
    }),
  };
  nextInstructions.push($$typeofInstruction);
  return $$typeofProperty;
}
function createTagProperty(fn, instr, nextInstructions, componentTag) {
  let tagProperty;
  switch (componentTag.kind) {
    case 'BuiltinTag': {
      const tagPropertyPlace = createTemporaryPlace(fn.env, instr.value.loc);
      const tagInstruction = {
        id: makeInstructionId(0),
        lvalue: Object.assign(Object.assign({}, tagPropertyPlace), {
          effect: exports.Effect.Mutate,
        }),
        value: {
          kind: 'Primitive',
          value: componentTag.name,
          loc: instr.value.loc,
        },
        loc: instr.loc,
      };
      tagProperty = {
        kind: 'ObjectProperty',
        key: {name: 'type', kind: 'string'},
        type: 'property',
        place: Object.assign(Object.assign({}, tagPropertyPlace), {
          effect: exports.Effect.Capture,
        }),
      };
      nextInstructions.push(tagInstruction);
      break;
    }
    case 'Identifier': {
      tagProperty = {
        kind: 'ObjectProperty',
        key: {name: 'type', kind: 'string'},
        type: 'property',
        place: Object.assign(Object.assign({}, componentTag), {
          effect: exports.Effect.Capture,
        }),
      };
      break;
    }
  }
  return tagProperty;
}
function createPropsProperties(
  fn,
  instr,
  nextInstructions,
  propAttributes,
  children
) {
  let refProperty;
  let keyProperty;
  const props = [];
  const jsxAttributesWithoutKeyAndRef = propAttributes.filter(
    p => p.kind === 'JsxAttribute' && p.name !== 'key' && p.name !== 'ref'
  );
  const jsxSpreadAttributes = propAttributes.filter(
    p => p.kind === 'JsxSpreadAttribute'
  );
  const spreadPropsOnly =
    jsxAttributesWithoutKeyAndRef.length === 0 &&
    jsxSpreadAttributes.length === 1;
  propAttributes.forEach(prop => {
    switch (prop.kind) {
      case 'JsxAttribute': {
        switch (prop.name) {
          case 'key': {
            keyProperty = {
              kind: 'ObjectProperty',
              key: {name: 'key', kind: 'string'},
              type: 'property',
              place: Object.assign({}, prop.place),
            };
            break;
          }
          case 'ref': {
            refProperty = {
              kind: 'ObjectProperty',
              key: {name: 'ref', kind: 'string'},
              type: 'property',
              place: Object.assign({}, prop.place),
            };
            const refPropProperty = {
              kind: 'ObjectProperty',
              key: {name: 'ref', kind: 'string'},
              type: 'property',
              place: Object.assign({}, prop.place),
            };
            props.push(refPropProperty);
            break;
          }
          default: {
            const attributeProperty = {
              kind: 'ObjectProperty',
              key: {name: prop.name, kind: 'string'},
              type: 'property',
              place: Object.assign({}, prop.place),
            };
            props.push(attributeProperty);
          }
        }
        break;
      }
      case 'JsxSpreadAttribute': {
        props.push({kind: 'Spread', place: Object.assign({}, prop.argument)});
        break;
      }
    }
  });
  const propsPropertyPlace = createTemporaryPlace(fn.env, instr.value.loc);
  if (children) {
    let childrenPropProperty;
    if (children.length === 1) {
      childrenPropProperty = {
        kind: 'ObjectProperty',
        key: {name: 'children', kind: 'string'},
        type: 'property',
        place: Object.assign(Object.assign({}, children[0]), {
          effect: exports.Effect.Capture,
        }),
      };
    } else {
      const childrenPropPropertyPlace = createTemporaryPlace(
        fn.env,
        instr.value.loc
      );
      const childrenPropInstruction = {
        id: makeInstructionId(0),
        lvalue: Object.assign(Object.assign({}, childrenPropPropertyPlace), {
          effect: exports.Effect.Mutate,
        }),
        value: {
          kind: 'ArrayExpression',
          elements: [...children],
          loc: instr.value.loc,
        },
        loc: instr.loc,
      };
      nextInstructions.push(childrenPropInstruction);
      childrenPropProperty = {
        kind: 'ObjectProperty',
        key: {name: 'children', kind: 'string'},
        type: 'property',
        place: Object.assign(Object.assign({}, childrenPropPropertyPlace), {
          effect: exports.Effect.Capture,
        }),
      };
    }
    props.push(childrenPropProperty);
  }
  if (refProperty == null) {
    const refPropertyPlace = createTemporaryPlace(fn.env, instr.value.loc);
    const refInstruction = {
      id: makeInstructionId(0),
      lvalue: Object.assign(Object.assign({}, refPropertyPlace), {
        effect: exports.Effect.Mutate,
      }),
      value: {kind: 'Primitive', value: null, loc: instr.value.loc},
      loc: instr.loc,
    };
    refProperty = {
      kind: 'ObjectProperty',
      key: {name: 'ref', kind: 'string'},
      type: 'property',
      place: Object.assign(Object.assign({}, refPropertyPlace), {
        effect: exports.Effect.Capture,
      }),
    };
    nextInstructions.push(refInstruction);
  }
  if (keyProperty == null) {
    const keyPropertyPlace = createTemporaryPlace(fn.env, instr.value.loc);
    const keyInstruction = {
      id: makeInstructionId(0),
      lvalue: Object.assign(Object.assign({}, keyPropertyPlace), {
        effect: exports.Effect.Mutate,
      }),
      value: {kind: 'Primitive', value: null, loc: instr.value.loc},
      loc: instr.loc,
    };
    keyProperty = {
      kind: 'ObjectProperty',
      key: {name: 'key', kind: 'string'},
      type: 'property',
      place: Object.assign(Object.assign({}, keyPropertyPlace), {
        effect: exports.Effect.Capture,
      }),
    };
    nextInstructions.push(keyInstruction);
  }
  let propsProperty;
  if (spreadPropsOnly) {
    const spreadProp = jsxSpreadAttributes[0];
    CompilerError.invariant(spreadProp.kind === 'JsxSpreadAttribute', {
      reason: 'Spread prop attribute must be of kind JSXSpreadAttribute',
      loc: instr.loc,
    });
    propsProperty = {
      kind: 'ObjectProperty',
      key: {name: 'props', kind: 'string'},
      type: 'property',
      place: Object.assign(Object.assign({}, spreadProp.argument), {
        effect: exports.Effect.Mutate,
      }),
    };
  } else {
    const propsInstruction = {
      id: makeInstructionId(0),
      lvalue: Object.assign(Object.assign({}, propsPropertyPlace), {
        effect: exports.Effect.Mutate,
      }),
      value: {
        kind: 'ObjectExpression',
        properties: props,
        loc: instr.value.loc,
      },
      loc: instr.loc,
    };
    propsProperty = {
      kind: 'ObjectProperty',
      key: {name: 'props', kind: 'string'},
      type: 'property',
      place: Object.assign(Object.assign({}, propsPropertyPlace), {
        effect: exports.Effect.Capture,
      }),
    };
    nextInstructions.push(propsInstruction);
  }
  return {
    refProperty: refProperty,
    keyProperty: keyProperty,
    propsProperty: propsProperty,
  };
}
function handlePlace(place, blockId, inlinedJsxDeclarations) {
  const inlinedJsxDeclaration = inlinedJsxDeclarations.get(
    place.identifier.declarationId
  );
  if (
    inlinedJsxDeclaration == null ||
    inlinedJsxDeclaration.blockIdsToIgnore.has(blockId)
  ) {
    return place;
  }
  return Object.assign(Object.assign({}, place), {
    identifier: inlinedJsxDeclaration.identifier,
  });
}
function handlelValue(lvalue, blockId, inlinedJsxDeclarations) {
  const inlinedJsxDeclaration = inlinedJsxDeclarations.get(
    lvalue.identifier.declarationId
  );
  if (
    inlinedJsxDeclaration == null ||
    inlinedJsxDeclaration.blockIdsToIgnore.has(blockId)
  ) {
    return lvalue;
  }
  return Object.assign(Object.assign({}, lvalue), {
    identifier: inlinedJsxDeclaration.identifier,
  });
}
function handleIdentifier(identifier, inlinedJsxDeclarations) {
  const inlinedJsxDeclaration = inlinedJsxDeclarations.get(
    identifier.declarationId
  );
  return inlinedJsxDeclaration == null
    ? identifier
    : inlinedJsxDeclaration.identifier;
}
function findScopesToMerge(fn) {
  const objectMethodDecls = new Set();
  const mergeScopesBuilder = new DisjointSet();
  for (const [_, block] of fn.body.blocks) {
    for (const {lvalue: lvalue, value: value} of block.instructions) {
      if (value.kind === 'ObjectMethod') {
        objectMethodDecls.add(lvalue.identifier);
      } else if (value.kind === 'ObjectExpression') {
        for (const operand of eachInstructionValueOperand(value)) {
          if (objectMethodDecls.has(operand.identifier)) {
            const operandScope = operand.identifier.scope;
            const lvalueScope = lvalue.identifier.scope;
            CompilerError.invariant(
              operandScope != null && lvalueScope != null,
              {
                reason:
                  'Internal error: Expected all ObjectExpressions and ObjectMethods to have non-null scope.',
                suggestions: null,
                loc: GeneratedSource,
              }
            );
            mergeScopesBuilder.union([operandScope, lvalueScope]);
          }
        }
      }
    }
  }
  return mergeScopesBuilder;
}
function alignObjectMethodScopes(fn) {
  for (const [_, block] of fn.body.blocks) {
    for (const {value: value} of block.instructions) {
      if (
        value.kind === 'ObjectMethod' ||
        value.kind === 'FunctionExpression'
      ) {
        alignObjectMethodScopes(value.loweredFunc.func);
      }
    }
  }
  const scopeGroupsMap = findScopesToMerge(fn).canonicalize();
  for (const [scope, root] of scopeGroupsMap) {
    if (scope !== root) {
      root.range.start = makeInstructionId(
        Math.min(scope.range.start, root.range.start)
      );
      root.range.end = makeInstructionId(
        Math.max(scope.range.end, root.range.end)
      );
    }
  }
  for (const [_, block] of fn.body.blocks) {
    for (const {
      lvalue: {identifier: identifier},
    } of block.instructions) {
      if (identifier.scope != null) {
        const root = scopeGroupsMap.get(identifier.scope);
        if (root != null) {
          identifier.scope = root;
        }
      }
    }
  }
}
function visitReactiveFunction(fn, visitor, state) {
  visitor.visitBlock(fn.body, state);
}
class ReactiveFunctionVisitor {
  visitID(_id, _state) {}
  visitParam(_place, _state) {}
  visitLValue(_id, _lvalue, _state) {}
  visitPlace(_id, _place, _state) {}
  visitReactiveFunctionValue(_id, _dependencies, _fn, _state) {}
  visitValue(id, value, state) {
    this.traverseValue(id, value, state);
  }
  traverseValue(id, value, state) {
    switch (value.kind) {
      case 'OptionalExpression': {
        this.visitValue(id, value.value, state);
        break;
      }
      case 'LogicalExpression': {
        this.visitValue(id, value.left, state);
        this.visitValue(id, value.right, state);
        break;
      }
      case 'ConditionalExpression': {
        this.visitValue(id, value.test, state);
        this.visitValue(id, value.consequent, state);
        this.visitValue(id, value.alternate, state);
        break;
      }
      case 'SequenceExpression': {
        for (const instr of value.instructions) {
          this.visitInstruction(instr, state);
        }
        this.visitValue(value.id, value.value, state);
        break;
      }
      case 'ReactiveFunctionValue': {
        this.visitReactiveFunctionValue(
          id,
          value.dependencies,
          value.fn,
          state
        );
        break;
      }
      default: {
        for (const place of eachInstructionValueOperand(value)) {
          this.visitPlace(id, place, state);
        }
      }
    }
  }
  visitInstruction(instruction, state) {
    this.traverseInstruction(instruction, state);
  }
  traverseInstruction(instruction, state) {
    this.visitID(instruction.id, state);
    for (const operand of eachInstructionLValue(instruction)) {
      this.visitLValue(instruction.id, operand, state);
    }
    this.visitValue(instruction.id, instruction.value, state);
  }
  visitTerminal(stmt, state) {
    this.traverseTerminal(stmt, state);
  }
  traverseTerminal(stmt, state) {
    const {terminal: terminal} = stmt;
    if (terminal.id !== null) {
      this.visitID(terminal.id, state);
    }
    switch (terminal.kind) {
      case 'break':
      case 'continue': {
        break;
      }
      case 'return': {
        this.visitPlace(terminal.id, terminal.value, state);
        break;
      }
      case 'throw': {
        this.visitPlace(terminal.id, terminal.value, state);
        break;
      }
      case 'for': {
        this.visitValue(terminal.id, terminal.init, state);
        this.visitValue(terminal.id, terminal.test, state);
        this.visitBlock(terminal.loop, state);
        if (terminal.update !== null) {
          this.visitValue(terminal.id, terminal.update, state);
        }
        break;
      }
      case 'for-of': {
        this.visitValue(terminal.id, terminal.init, state);
        this.visitValue(terminal.id, terminal.test, state);
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'for-in': {
        this.visitValue(terminal.id, terminal.init, state);
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'do-while': {
        this.visitBlock(terminal.loop, state);
        this.visitValue(terminal.id, terminal.test, state);
        break;
      }
      case 'while': {
        this.visitValue(terminal.id, terminal.test, state);
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'if': {
        this.visitPlace(terminal.id, terminal.test, state);
        this.visitBlock(terminal.consequent, state);
        if (terminal.alternate !== null) {
          this.visitBlock(terminal.alternate, state);
        }
        break;
      }
      case 'switch': {
        this.visitPlace(terminal.id, terminal.test, state);
        for (const case_ of terminal.cases) {
          if (case_.test !== null) {
            this.visitPlace(terminal.id, case_.test, state);
          }
          if (case_.block !== undefined) {
            this.visitBlock(case_.block, state);
          }
        }
        break;
      }
      case 'label': {
        this.visitBlock(terminal.block, state);
        break;
      }
      case 'try': {
        this.visitBlock(terminal.block, state);
        this.visitBlock(terminal.handler, state);
        break;
      }
      default: {
        assertExhaustive(
          terminal,
          `Unexpected terminal kind \`${terminal.kind}\``
        );
      }
    }
  }
  visitScope(scope, state) {
    this.traverseScope(scope, state);
  }
  traverseScope(scope, state) {
    this.visitBlock(scope.instructions, state);
  }
  visitPrunedScope(scopeBlock, state) {
    this.traversePrunedScope(scopeBlock, state);
  }
  traversePrunedScope(scopeBlock, state) {
    this.visitBlock(scopeBlock.instructions, state);
  }
  visitBlock(block, state) {
    this.traverseBlock(block, state);
  }
  traverseBlock(block, state) {
    for (const instr of block) {
      switch (instr.kind) {
        case 'instruction': {
          this.visitInstruction(instr.instruction, state);
          break;
        }
        case 'scope': {
          this.visitScope(instr, state);
          break;
        }
        case 'pruned-scope': {
          this.visitPrunedScope(instr, state);
          break;
        }
        case 'terminal': {
          this.visitTerminal(instr, state);
          break;
        }
        default: {
          assertExhaustive(
            instr,
            `Unexpected instruction kind \`${instr.kind}\``
          );
        }
      }
    }
  }
  visitHirFunction(fn, state) {
    for (const param of fn.params) {
      const place = param.kind === 'Identifier' ? param : param.place;
      this.visitParam(place, state);
    }
    for (const [, block] of fn.body.blocks) {
      for (const instr of block.instructions) {
        this.visitInstruction(instr, state);
        if (
          instr.value.kind === 'FunctionExpression' ||
          instr.value.kind === 'ObjectMethod'
        ) {
          this.visitHirFunction(instr.value.loweredFunc.func, state);
        }
      }
      for (const operand of eachTerminalOperand(block.terminal)) {
        this.visitPlace(block.terminal.id, operand, state);
      }
    }
  }
}
class ReactiveFunctionTransform extends ReactiveFunctionVisitor {
  traverseBlock(block, state) {
    let nextBlock = null;
    for (let i = 0; i < block.length; i++) {
      const instr = block[i];
      let transformed;
      switch (instr.kind) {
        case 'instruction': {
          transformed = this.transformInstruction(instr.instruction, state);
          break;
        }
        case 'scope': {
          transformed = this.transformScope(instr, state);
          break;
        }
        case 'pruned-scope': {
          transformed = this.transformPrunedScope(instr, state);
          break;
        }
        case 'terminal': {
          transformed = this.transformTerminal(instr, state);
          break;
        }
        default: {
          assertExhaustive(
            instr,
            `Unexpected instruction kind \`${instr.kind}\``
          );
        }
      }
      switch (transformed.kind) {
        case 'keep': {
          if (nextBlock !== null) {
            nextBlock.push(instr);
          }
          break;
        }
        case 'remove': {
          if (nextBlock === null) {
            nextBlock = block.slice(0, i);
          }
          break;
        }
        case 'replace': {
          nextBlock !== null && nextBlock !== void 0
            ? nextBlock
            : (nextBlock = block.slice(0, i));
          nextBlock.push(transformed.value);
          break;
        }
        case 'replace-many': {
          nextBlock !== null && nextBlock !== void 0
            ? nextBlock
            : (nextBlock = block.slice(0, i));
          nextBlock.push(...transformed.value);
          break;
        }
      }
    }
    if (nextBlock !== null) {
      block.length = 0;
      block.push(...nextBlock);
    }
  }
  transformInstruction(instruction, state) {
    this.visitInstruction(instruction, state);
    return {kind: 'keep'};
  }
  transformTerminal(stmt, state) {
    this.visitTerminal(stmt, state);
    return {kind: 'keep'};
  }
  transformScope(scope, state) {
    this.visitScope(scope, state);
    return {kind: 'keep'};
  }
  transformPrunedScope(scope, state) {
    this.visitPrunedScope(scope, state);
    return {kind: 'keep'};
  }
  transformValue(id, value, state) {
    this.visitValue(id, value, state);
    return {kind: 'keep'};
  }
  transformReactiveFunctionValue(id, dependencies, fn, state) {
    this.visitReactiveFunctionValue(id, dependencies, fn, state);
    return {kind: 'keep'};
  }
  traverseValue(id, value, state) {
    switch (value.kind) {
      case 'OptionalExpression': {
        const nextValue = this.transformValue(id, value.value, state);
        if (nextValue.kind === 'replace') {
          value.value = nextValue.value;
        }
        break;
      }
      case 'LogicalExpression': {
        const left = this.transformValue(id, value.left, state);
        if (left.kind === 'replace') {
          value.left = left.value;
        }
        const right = this.transformValue(id, value.right, state);
        if (right.kind === 'replace') {
          value.right = right.value;
        }
        break;
      }
      case 'ConditionalExpression': {
        const test = this.transformValue(id, value.test, state);
        if (test.kind === 'replace') {
          value.test = test.value;
        }
        const consequent = this.transformValue(id, value.consequent, state);
        if (consequent.kind === 'replace') {
          value.consequent = consequent.value;
        }
        const alternate = this.transformValue(id, value.alternate, state);
        if (alternate.kind === 'replace') {
          value.alternate = alternate.value;
        }
        break;
      }
      case 'SequenceExpression': {
        for (const instr of value.instructions) {
          this.visitInstruction(instr, state);
        }
        const nextValue = this.transformValue(value.id, value.value, state);
        if (nextValue.kind === 'replace') {
          value.value = nextValue.value;
        }
        break;
      }
      case 'ReactiveFunctionValue': {
        const nextValue = this.transformReactiveFunctionValue(
          id,
          value.dependencies,
          value.fn,
          state
        );
        if (nextValue.kind === 'replace') {
          value.fn = nextValue.value;
        }
        break;
      }
      default: {
        for (const place of eachInstructionValueOperand(value)) {
          this.visitPlace(id, place, state);
        }
      }
    }
  }
  traverseInstruction(instruction, state) {
    this.visitID(instruction.id, state);
    for (const operand of eachInstructionLValue(instruction)) {
      this.visitLValue(instruction.id, operand, state);
    }
    const nextValue = this.transformValue(
      instruction.id,
      instruction.value,
      state
    );
    if (nextValue.kind === 'replace') {
      instruction.value = nextValue.value;
    }
  }
  traverseTerminal(stmt, state) {
    const {terminal: terminal} = stmt;
    if (terminal.id !== null) {
      this.visitID(terminal.id, state);
    }
    switch (terminal.kind) {
      case 'break':
      case 'continue': {
        break;
      }
      case 'return': {
        this.visitPlace(terminal.id, terminal.value, state);
        break;
      }
      case 'throw': {
        this.visitPlace(terminal.id, terminal.value, state);
        break;
      }
      case 'for': {
        const init = this.transformValue(terminal.id, terminal.init, state);
        if (init.kind === 'replace') {
          terminal.init = init.value;
        }
        const test = this.transformValue(terminal.id, terminal.test, state);
        if (test.kind === 'replace') {
          terminal.test = test.value;
        }
        if (terminal.update !== null) {
          const update = this.transformValue(
            terminal.id,
            terminal.update,
            state
          );
          if (update.kind === 'replace') {
            terminal.update = update.value;
          }
        }
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'for-of': {
        const init = this.transformValue(terminal.id, terminal.init, state);
        if (init.kind === 'replace') {
          terminal.init = init.value;
        }
        const test = this.transformValue(terminal.id, terminal.test, state);
        if (test.kind === 'replace') {
          terminal.test = test.value;
        }
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'for-in': {
        const init = this.transformValue(terminal.id, terminal.init, state);
        if (init.kind === 'replace') {
          terminal.init = init.value;
        }
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'do-while': {
        this.visitBlock(terminal.loop, state);
        const test = this.transformValue(terminal.id, terminal.test, state);
        if (test.kind === 'replace') {
          terminal.test = test.value;
        }
        break;
      }
      case 'while': {
        const test = this.transformValue(terminal.id, terminal.test, state);
        if (test.kind === 'replace') {
          terminal.test = test.value;
        }
        this.visitBlock(terminal.loop, state);
        break;
      }
      case 'if': {
        this.visitPlace(terminal.id, terminal.test, state);
        this.visitBlock(terminal.consequent, state);
        if (terminal.alternate !== null) {
          this.visitBlock(terminal.alternate, state);
        }
        break;
      }
      case 'switch': {
        this.visitPlace(terminal.id, terminal.test, state);
        for (const case_ of terminal.cases) {
          if (case_.test !== null) {
            this.visitPlace(terminal.id, case_.test, state);
          }
          if (case_.block !== undefined) {
            this.visitBlock(case_.block, state);
          }
        }
        break;
      }
      case 'label': {
        this.visitBlock(terminal.block, state);
        break;
      }
      case 'try': {
        this.visitBlock(terminal.block, state);
        if (terminal.handlerBinding !== null) {
          this.visitPlace(terminal.id, terminal.handlerBinding, state);
        }
        this.visitBlock(terminal.handler, state);
        break;
      }
      default: {
        assertExhaustive(
          terminal,
          `Unexpected terminal kind \`${terminal.kind}\``
        );
      }
    }
  }
}
function* eachReactiveValueOperand(instrValue) {
  switch (instrValue.kind) {
    case 'OptionalExpression': {
      yield* eachReactiveValueOperand(instrValue.value);
      break;
    }
    case 'LogicalExpression': {
      yield* eachReactiveValueOperand(instrValue.left);
      yield* eachReactiveValueOperand(instrValue.right);
      break;
    }
    case 'SequenceExpression': {
      for (const instr of instrValue.instructions) {
        yield* eachReactiveValueOperand(instr.value);
      }
      yield* eachReactiveValueOperand(instrValue.value);
      break;
    }
    case 'ConditionalExpression': {
      yield* eachReactiveValueOperand(instrValue.test);
      yield* eachReactiveValueOperand(instrValue.consequent);
      yield* eachReactiveValueOperand(instrValue.alternate);
      break;
    }
    case 'ReactiveFunctionValue': {
      yield* instrValue.dependencies;
      break;
    }
    default: {
      yield* eachInstructionValueOperand(instrValue);
    }
  }
}
function assertScopeInstructionsWithinScopes(fn) {
  const existingScopes = new Set();
  visitReactiveFunction(fn, new FindAllScopesVisitor(), existingScopes);
  visitReactiveFunction(
    fn,
    new CheckInstructionsAgainstScopesVisitor(),
    existingScopes
  );
}
class FindAllScopesVisitor extends ReactiveFunctionVisitor {
  visitScope(block, state) {
    this.traverseScope(block, state);
    state.add(block.scope.id);
  }
}
class CheckInstructionsAgainstScopesVisitor extends ReactiveFunctionVisitor {
  constructor() {
    super(...arguments);
    this.activeScopes = new Set();
  }
  visitPlace(id, place, state) {
    const scope = getPlaceScope(id, place);
    if (
      scope !== null &&
      state.has(scope.id) &&
      !this.activeScopes.has(scope.id)
    ) {
      CompilerError.invariant(false, {
        description: `Instruction [${id}] is part of scope @${scope.id}, but that scope has already completed.`,
        loc: place.loc,
        reason:
          'Encountered an instruction that should be part of a scope, but where that scope has already completed',
        suggestions: null,
      });
    }
  }
  visitScope(block, state) {
    this.activeScopes.add(block.scope.id);
    this.traverseScope(block, state);
    this.activeScopes.delete(block.scope.id);
  }
}
function assertWellFormedBreakTargets(fn) {
  visitReactiveFunction(fn, new Visitor$a(), new Set());
}
let Visitor$a = class Visitor extends ReactiveFunctionVisitor {
  visitTerminal(stmt, seenLabels) {
    if (stmt.label != null) {
      seenLabels.add(stmt.label.id);
    }
    const terminal = stmt.terminal;
    if (terminal.kind === 'break' || terminal.kind === 'continue') {
      CompilerError.invariant(seenLabels.has(terminal.target), {
        reason: 'Unexpected break to invalid label',
        loc: stmt.terminal.loc,
      });
    }
  }
};
var _Context_nextScheduleId,
  _Context_scheduled,
  _Context_catchHandlers,
  _Context_controlFlowStack;
function buildReactiveFunction(fn) {
  const cx = new Context$2(fn.body);
  const driver = new Driver(cx);
  const body = driver.traverseBlock(cx.block(fn.body.entry));
  return {
    loc: fn.loc,
    id: fn.id,
    params: fn.params,
    generator: fn.generator,
    async: fn.async,
    body: body,
    env: fn.env,
    directives: fn.directives,
  };
}
class Driver {
  constructor(cx) {
    this.cx = cx;
  }
  traverseBlock(block) {
    const blockValue = [];
    this.visitBlock(block, blockValue);
    return blockValue;
  }
  visitBlock(block, blockValue) {
    var _a;
    CompilerError.invariant(!this.cx.emitted.has(block.id), {
      reason: `Cannot emit the same block twice: bb${block.id}`,
      description: null,
      loc: null,
      suggestions: null,
    });
    this.cx.emitted.add(block.id);
    for (const instruction of block.instructions) {
      blockValue.push({kind: 'instruction', instruction: instruction});
    }
    const terminal = block.terminal;
    const scheduleIds = [];
    switch (terminal.kind) {
      case 'return': {
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'return',
            loc: terminal.loc,
            value: terminal.value,
            id: terminal.id,
          },
          label: null,
        });
        break;
      }
      case 'throw': {
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'throw',
            loc: terminal.loc,
            value: terminal.value,
            id: terminal.id,
          },
          label: null,
        });
        break;
      }
      case 'if': {
        const fallthroughId =
          this.cx.reachable(terminal.fallthrough) &&
          !this.cx.isScheduled(terminal.fallthrough)
            ? terminal.fallthrough
            : null;
        const alternateId =
          terminal.alternate !== terminal.fallthrough
            ? terminal.alternate
            : null;
        if (fallthroughId !== null) {
          const scheduleId = this.cx.schedule(fallthroughId, 'if');
          scheduleIds.push(scheduleId);
        }
        let consequent = null;
        if (this.cx.isScheduled(terminal.consequent)) {
          CompilerError.invariant(false, {
            reason: `Unexpected 'if' where the consequent is already scheduled`,
            loc: terminal.loc,
          });
        } else {
          consequent = this.traverseBlock(
            this.cx.ir.blocks.get(terminal.consequent)
          );
        }
        let alternate = null;
        if (alternateId !== null) {
          if (this.cx.isScheduled(alternateId)) {
            CompilerError.invariant(false, {
              reason: `Unexpected 'if' where the alternate is already scheduled`,
              loc: terminal.loc,
            });
          } else {
            alternate = this.traverseBlock(this.cx.ir.blocks.get(alternateId));
          }
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'if',
            loc: terminal.loc,
            test: terminal.test,
            consequent:
              consequent !== null && consequent !== void 0
                ? consequent
                : this.emptyBlock(),
            alternate: alternate,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'switch': {
        const fallthroughId =
          this.cx.reachable(terminal.fallthrough) &&
          !this.cx.isScheduled(terminal.fallthrough)
            ? terminal.fallthrough
            : null;
        if (fallthroughId !== null) {
          const scheduleId = this.cx.schedule(fallthroughId, 'switch');
          scheduleIds.push(scheduleId);
        }
        const cases = [];
        [...terminal.cases].reverse().forEach((case_, _index) => {
          const test = case_.test;
          let consequent;
          if (this.cx.isScheduled(case_.block)) {
            CompilerError.invariant(case_.block === terminal.fallthrough, {
              reason: `Unexpected 'switch' where a case is already scheduled and block is not the fallthrough`,
              loc: terminal.loc,
            });
            return;
          } else {
            consequent = this.traverseBlock(this.cx.ir.blocks.get(case_.block));
            const scheduleId = this.cx.schedule(case_.block, 'case');
            scheduleIds.push(scheduleId);
          }
          cases.push({test: test, block: consequent});
        });
        cases.reverse();
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'switch',
            loc: terminal.loc,
            test: terminal.test,
            cases: cases,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'do-while': {
        const fallthroughId = !this.cx.isScheduled(terminal.fallthrough)
          ? terminal.fallthrough
          : null;
        const loopId =
          !this.cx.isScheduled(terminal.loop) &&
          terminal.loop !== terminal.fallthrough
            ? terminal.loop
            : null;
        const scheduleId = this.cx.scheduleLoop(
          terminal.fallthrough,
          terminal.test,
          terminal.loop
        );
        scheduleIds.push(scheduleId);
        let loopBody;
        if (loopId) {
          loopBody = this.traverseBlock(this.cx.ir.blocks.get(loopId));
        } else {
          CompilerError.invariant(false, {
            reason: `Unexpected 'do-while' where the loop is already scheduled`,
            loc: terminal.loc,
          });
        }
        const testValue = this.visitValueBlock(
          terminal.test,
          terminal.loc
        ).value;
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'do-while',
            loc: terminal.loc,
            test: testValue,
            loop: loopBody,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'while': {
        const fallthroughId =
          this.cx.reachable(terminal.fallthrough) &&
          !this.cx.isScheduled(terminal.fallthrough)
            ? terminal.fallthrough
            : null;
        const loopId =
          !this.cx.isScheduled(terminal.loop) &&
          terminal.loop !== terminal.fallthrough
            ? terminal.loop
            : null;
        const scheduleId = this.cx.scheduleLoop(
          terminal.fallthrough,
          terminal.test,
          terminal.loop
        );
        scheduleIds.push(scheduleId);
        const testValue = this.visitValueBlock(
          terminal.test,
          terminal.loc
        ).value;
        let loopBody;
        if (loopId) {
          loopBody = this.traverseBlock(this.cx.ir.blocks.get(loopId));
        } else {
          CompilerError.invariant(false, {
            reason: `Unexpected 'while' where the loop is already scheduled`,
            loc: terminal.loc,
          });
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'while',
            loc: terminal.loc,
            test: testValue,
            loop: loopBody,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'for': {
        const loopId =
          !this.cx.isScheduled(terminal.loop) &&
          terminal.loop !== terminal.fallthrough
            ? terminal.loop
            : null;
        const fallthroughId = !this.cx.isScheduled(terminal.fallthrough)
          ? terminal.fallthrough
          : null;
        const scheduleId = this.cx.scheduleLoop(
          terminal.fallthrough,
          (_a = terminal.update) !== null && _a !== void 0 ? _a : terminal.test,
          terminal.loop
        );
        scheduleIds.push(scheduleId);
        const init = this.visitValueBlock(terminal.init, terminal.loc);
        const initBlock = this.cx.ir.blocks.get(init.block);
        let initValue = init.value;
        if (initValue.kind === 'SequenceExpression') {
          const last = initBlock.instructions.at(-1);
          initValue.instructions.push(last);
          initValue.value = {
            kind: 'Primitive',
            value: undefined,
            loc: terminal.loc,
          };
        } else {
          initValue = {
            kind: 'SequenceExpression',
            instructions: [initBlock.instructions.at(-1)],
            id: terminal.id,
            loc: terminal.loc,
            value: {kind: 'Primitive', value: undefined, loc: terminal.loc},
          };
        }
        const testValue = this.visitValueBlock(
          terminal.test,
          terminal.loc
        ).value;
        const updateValue =
          terminal.update !== null
            ? this.visitValueBlock(terminal.update, terminal.loc).value
            : null;
        let loopBody;
        if (loopId) {
          loopBody = this.traverseBlock(this.cx.ir.blocks.get(loopId));
        } else {
          CompilerError.invariant(false, {
            reason: `Unexpected 'for' where the loop is already scheduled`,
            loc: terminal.loc,
          });
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'for',
            loc: terminal.loc,
            init: initValue,
            test: testValue,
            update: updateValue,
            loop: loopBody,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'for-of': {
        const loopId =
          !this.cx.isScheduled(terminal.loop) &&
          terminal.loop !== terminal.fallthrough
            ? terminal.loop
            : null;
        const fallthroughId = !this.cx.isScheduled(terminal.fallthrough)
          ? terminal.fallthrough
          : null;
        const scheduleId = this.cx.scheduleLoop(
          terminal.fallthrough,
          terminal.init,
          terminal.loop
        );
        scheduleIds.push(scheduleId);
        const init = this.visitValueBlock(terminal.init, terminal.loc);
        const initBlock = this.cx.ir.blocks.get(init.block);
        let initValue = init.value;
        if (initValue.kind === 'SequenceExpression') {
          const last = initBlock.instructions.at(-1);
          initValue.instructions.push(last);
          initValue.value = {
            kind: 'Primitive',
            value: undefined,
            loc: terminal.loc,
          };
        } else {
          initValue = {
            kind: 'SequenceExpression',
            instructions: [initBlock.instructions.at(-1)],
            id: terminal.id,
            loc: terminal.loc,
            value: {kind: 'Primitive', value: undefined, loc: terminal.loc},
          };
        }
        const test = this.visitValueBlock(terminal.test, terminal.loc);
        const testBlock = this.cx.ir.blocks.get(test.block);
        let testValue = test.value;
        if (testValue.kind === 'SequenceExpression') {
          const last = testBlock.instructions.at(-1);
          testValue.instructions.push(last);
          testValue.value = {
            kind: 'Primitive',
            value: undefined,
            loc: terminal.loc,
          };
        } else {
          testValue = {
            kind: 'SequenceExpression',
            instructions: [testBlock.instructions.at(-1)],
            id: terminal.id,
            loc: terminal.loc,
            value: {kind: 'Primitive', value: undefined, loc: terminal.loc},
          };
        }
        let loopBody;
        if (loopId) {
          loopBody = this.traverseBlock(this.cx.ir.blocks.get(loopId));
        } else {
          CompilerError.invariant(false, {
            reason: `Unexpected 'for-of' where the loop is already scheduled`,
            loc: terminal.loc,
          });
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'for-of',
            loc: terminal.loc,
            init: initValue,
            test: testValue,
            loop: loopBody,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'for-in': {
        const loopId =
          !this.cx.isScheduled(terminal.loop) &&
          terminal.loop !== terminal.fallthrough
            ? terminal.loop
            : null;
        const fallthroughId = !this.cx.isScheduled(terminal.fallthrough)
          ? terminal.fallthrough
          : null;
        const scheduleId = this.cx.scheduleLoop(
          terminal.fallthrough,
          terminal.init,
          terminal.loop
        );
        scheduleIds.push(scheduleId);
        const init = this.visitValueBlock(terminal.init, terminal.loc);
        const initBlock = this.cx.ir.blocks.get(init.block);
        let initValue = init.value;
        if (initValue.kind === 'SequenceExpression') {
          const last = initBlock.instructions.at(-1);
          initValue.instructions.push(last);
          initValue.value = {
            kind: 'Primitive',
            value: undefined,
            loc: terminal.loc,
          };
        } else {
          initValue = {
            kind: 'SequenceExpression',
            instructions: [initBlock.instructions.at(-1)],
            id: terminal.id,
            loc: terminal.loc,
            value: {kind: 'Primitive', value: undefined, loc: terminal.loc},
          };
        }
        let loopBody;
        if (loopId) {
          loopBody = this.traverseBlock(this.cx.ir.blocks.get(loopId));
        } else {
          CompilerError.invariant(false, {
            reason: `Unexpected 'for-in' where the loop is already scheduled`,
            loc: terminal.loc,
          });
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'for-in',
            loc: terminal.loc,
            init: initValue,
            loop: loopBody,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'branch': {
        let consequent = null;
        if (this.cx.isScheduled(terminal.consequent)) {
          const break_ = this.visitBreak(
            terminal.consequent,
            terminal.id,
            terminal.loc
          );
          if (break_ !== null) {
            consequent = [break_];
          }
        } else {
          consequent = this.traverseBlock(
            this.cx.ir.blocks.get(terminal.consequent)
          );
        }
        let alternate = null;
        if (this.cx.isScheduled(terminal.alternate)) {
          CompilerError.invariant(false, {
            reason: `Unexpected 'branch' where the alternate is already scheduled`,
            loc: terminal.loc,
          });
        } else {
          alternate = this.traverseBlock(
            this.cx.ir.blocks.get(terminal.alternate)
          );
        }
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'if',
            loc: terminal.loc,
            test: terminal.test,
            consequent:
              consequent !== null && consequent !== void 0
                ? consequent
                : this.emptyBlock(),
            alternate: alternate,
            id: terminal.id,
          },
          label: null,
        });
        break;
      }
      case 'label': {
        const fallthroughId =
          this.cx.reachable(terminal.fallthrough) &&
          !this.cx.isScheduled(terminal.fallthrough)
            ? terminal.fallthrough
            : null;
        if (fallthroughId !== null) {
          const scheduleId = this.cx.schedule(fallthroughId, 'if');
          scheduleIds.push(scheduleId);
        }
        let block;
        if (this.cx.isScheduled(terminal.block)) {
          CompilerError.invariant(false, {
            reason: `Unexpected 'label' where the block is already scheduled`,
            loc: terminal.loc,
          });
        } else {
          block = this.traverseBlock(this.cx.ir.blocks.get(terminal.block));
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          terminal: {
            kind: 'label',
            loc: terminal.loc,
            block: block,
            id: terminal.id,
          },
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'sequence':
      case 'optional':
      case 'ternary':
      case 'logical': {
        const fallthroughId =
          terminal.fallthrough !== null &&
          !this.cx.isScheduled(terminal.fallthrough)
            ? terminal.fallthrough
            : null;
        if (fallthroughId !== null) {
          const scheduleId = this.cx.schedule(fallthroughId, 'if');
          scheduleIds.push(scheduleId);
        }
        const {place: place, value: value} =
          this.visitValueBlockTerminal(terminal);
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'instruction',
          instruction: {
            id: terminal.id,
            lvalue: place,
            value: value,
            loc: terminal.loc,
          },
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'goto': {
        switch (terminal.variant) {
          case GotoVariant.Break: {
            const break_ = this.visitBreak(
              terminal.block,
              terminal.id,
              terminal.loc
            );
            if (break_ !== null) {
              blockValue.push(break_);
            }
            break;
          }
          case GotoVariant.Continue: {
            const continue_ = this.visitContinue(
              terminal.block,
              terminal.id,
              terminal.loc
            );
            if (continue_ !== null) {
              blockValue.push(continue_);
            }
            break;
          }
          case GotoVariant.Try: {
            break;
          }
          default: {
            assertExhaustive(
              terminal.variant,
              `Unexpected goto variant \`${terminal.variant}\``
            );
          }
        }
        break;
      }
      case 'maybe-throw': {
        if (!this.cx.isScheduled(terminal.continuation)) {
          this.visitBlock(
            this.cx.ir.blocks.get(terminal.continuation),
            blockValue
          );
        }
        break;
      }
      case 'try': {
        const fallthroughId =
          this.cx.reachable(terminal.fallthrough) &&
          !this.cx.isScheduled(terminal.fallthrough)
            ? terminal.fallthrough
            : null;
        if (fallthroughId !== null) {
          const scheduleId = this.cx.schedule(fallthroughId, 'if');
          scheduleIds.push(scheduleId);
        }
        this.cx.scheduleCatchHandler(terminal.handler);
        const block = this.traverseBlock(this.cx.ir.blocks.get(terminal.block));
        const handler = this.traverseBlock(
          this.cx.ir.blocks.get(terminal.handler)
        );
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: 'terminal',
          label:
            fallthroughId == null ? null : {id: fallthroughId, implicit: false},
          terminal: {
            kind: 'try',
            loc: terminal.loc,
            block: block,
            handlerBinding: terminal.handlerBinding,
            handler: handler,
            id: terminal.id,
          },
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'pruned-scope':
      case 'scope': {
        const fallthroughId = !this.cx.isScheduled(terminal.fallthrough)
          ? terminal.fallthrough
          : null;
        if (fallthroughId !== null) {
          const scheduleId = this.cx.schedule(fallthroughId, 'if');
          scheduleIds.push(scheduleId);
          this.cx.scopeFallthroughs.add(fallthroughId);
        }
        let block;
        if (this.cx.isScheduled(terminal.block)) {
          CompilerError.invariant(false, {
            reason: `Unexpected 'scope' where the block is already scheduled`,
            loc: terminal.loc,
          });
        } else {
          block = this.traverseBlock(this.cx.ir.blocks.get(terminal.block));
        }
        this.cx.unscheduleAll(scheduleIds);
        blockValue.push({
          kind: terminal.kind,
          instructions: block,
          scope: terminal.scope,
        });
        if (fallthroughId !== null) {
          this.visitBlock(this.cx.ir.blocks.get(fallthroughId), blockValue);
        }
        break;
      }
      case 'unreachable': {
        break;
      }
      case 'unsupported': {
        CompilerError.invariant(false, {
          reason: 'Unexpected unsupported terminal',
          description: null,
          loc: terminal.loc,
          suggestions: null,
        });
      }
      default: {
        assertExhaustive(terminal, 'Unexpected terminal');
      }
    }
  }
  visitValueBlock(id, loc) {
    const defaultBlock = this.cx.ir.blocks.get(id);
    if (defaultBlock.terminal.kind === 'branch') {
      const instructions = defaultBlock.instructions;
      if (instructions.length === 0) {
        return {
          block: defaultBlock.id,
          place: defaultBlock.terminal.test,
          value: {
            kind: 'LoadLocal',
            place: defaultBlock.terminal.test,
            loc: defaultBlock.terminal.test.loc,
          },
          id: defaultBlock.terminal.id,
        };
      } else if (defaultBlock.instructions.length === 1) {
        const instr = defaultBlock.instructions[0];
        CompilerError.invariant(
          instr.lvalue.identifier.id ===
            defaultBlock.terminal.test.identifier.id,
          {
            reason:
              'Expected branch block to end in an instruction that sets the test value',
            description: null,
            loc: instr.lvalue.loc,
            suggestions: null,
          }
        );
        return {
          block: defaultBlock.id,
          place: instr.lvalue,
          value: instr.value,
          id: instr.id,
        };
      } else {
        const instr = defaultBlock.instructions.at(-1);
        const sequence = {
          kind: 'SequenceExpression',
          instructions: defaultBlock.instructions.slice(0, -1),
          id: instr.id,
          value: instr.value,
          loc: loc,
        };
        return {
          block: defaultBlock.id,
          place: defaultBlock.terminal.test,
          value: sequence,
          id: defaultBlock.terminal.id,
        };
      }
    } else if (defaultBlock.terminal.kind === 'goto') {
      const instructions = defaultBlock.instructions;
      if (instructions.length === 0) {
        CompilerError.invariant(false, {
          reason: 'Expected goto value block to have at least one instruction',
          description: null,
          loc: null,
          suggestions: null,
        });
      } else if (defaultBlock.instructions.length === 1) {
        const instr = defaultBlock.instructions[0];
        let place = instr.lvalue;
        let value = instr.value;
        if (
          value.kind === 'StoreLocal' &&
          value.lvalue.place.identifier.name === null
        ) {
          place = value.lvalue.place;
          value = {kind: 'LoadLocal', place: value.value, loc: value.value.loc};
        }
        return {
          block: defaultBlock.id,
          place: place,
          value: value,
          id: instr.id,
        };
      } else {
        const instr = defaultBlock.instructions.at(-1);
        let place = instr.lvalue;
        let value = instr.value;
        if (
          value.kind === 'StoreLocal' &&
          value.lvalue.place.identifier.name === null
        ) {
          place = value.lvalue.place;
          value = {kind: 'LoadLocal', place: value.value, loc: value.value.loc};
        }
        const sequence = {
          kind: 'SequenceExpression',
          instructions: defaultBlock.instructions.slice(0, -1),
          id: instr.id,
          value: value,
          loc: loc,
        };
        return {
          block: defaultBlock.id,
          place: place,
          value: sequence,
          id: instr.id,
        };
      }
    } else {
      const init = this.visitValueBlockTerminal(defaultBlock.terminal);
      const final = this.visitValueBlock(init.fallthrough, loc);
      const sequence = {
        kind: 'SequenceExpression',
        instructions: [
          ...defaultBlock.instructions,
          {id: init.id, loc: loc, lvalue: init.place, value: init.value},
        ],
        id: final.id,
        value: final.value,
        loc: loc,
      };
      return {
        block: init.fallthrough,
        value: sequence,
        place: final.place,
        id: final.id,
      };
    }
  }
  visitValueBlockTerminal(terminal) {
    switch (terminal.kind) {
      case 'sequence': {
        const block = this.visitValueBlock(terminal.block, terminal.loc);
        return {
          value: block.value,
          place: block.place,
          fallthrough: terminal.fallthrough,
          id: terminal.id,
        };
      }
      case 'optional': {
        const test = this.visitValueBlock(terminal.test, terminal.loc);
        const testBlock = this.cx.ir.blocks.get(test.block);
        if (testBlock.terminal.kind !== 'branch') {
          CompilerError.throwTodo({
            reason: `Unexpected terminal kind \`${testBlock.terminal.kind}\` for optional test block`,
            description: null,
            loc: testBlock.terminal.loc,
            suggestions: null,
          });
        }
        const consequent = this.visitValueBlock(
          testBlock.terminal.consequent,
          terminal.loc
        );
        const call = {
          kind: 'SequenceExpression',
          instructions: [
            {
              id: test.id,
              loc: testBlock.terminal.loc,
              lvalue: test.place,
              value: test.value,
            },
          ],
          id: consequent.id,
          value: consequent.value,
          loc: terminal.loc,
        };
        return {
          place: Object.assign({}, consequent.place),
          value: {
            kind: 'OptionalExpression',
            optional: terminal.optional,
            value: call,
            id: terminal.id,
            loc: terminal.loc,
          },
          fallthrough: terminal.fallthrough,
          id: terminal.id,
        };
      }
      case 'logical': {
        const test = this.visitValueBlock(terminal.test, terminal.loc);
        const testBlock = this.cx.ir.blocks.get(test.block);
        if (testBlock.terminal.kind !== 'branch') {
          CompilerError.throwTodo({
            reason: `Unexpected terminal kind \`${testBlock.terminal.kind}\` for logical test block`,
            description: null,
            loc: testBlock.terminal.loc,
            suggestions: null,
          });
        }
        const leftFinal = this.visitValueBlock(
          testBlock.terminal.consequent,
          terminal.loc
        );
        const left = {
          kind: 'SequenceExpression',
          instructions: [
            {
              id: test.id,
              loc: terminal.loc,
              lvalue: test.place,
              value: test.value,
            },
          ],
          id: leftFinal.id,
          value: leftFinal.value,
          loc: terminal.loc,
        };
        const right = this.visitValueBlock(
          testBlock.terminal.alternate,
          terminal.loc
        );
        const value = {
          kind: 'LogicalExpression',
          operator: terminal.operator,
          left: left,
          right: right.value,
          loc: terminal.loc,
        };
        return {
          place: Object.assign({}, leftFinal.place),
          value: value,
          fallthrough: terminal.fallthrough,
          id: terminal.id,
        };
      }
      case 'ternary': {
        const test = this.visitValueBlock(terminal.test, terminal.loc);
        const testBlock = this.cx.ir.blocks.get(test.block);
        if (testBlock.terminal.kind !== 'branch') {
          CompilerError.throwTodo({
            reason: `Unexpected terminal kind \`${testBlock.terminal.kind}\` for ternary test block`,
            description: null,
            loc: testBlock.terminal.loc,
            suggestions: null,
          });
        }
        const consequent = this.visitValueBlock(
          testBlock.terminal.consequent,
          terminal.loc
        );
        const alternate = this.visitValueBlock(
          testBlock.terminal.alternate,
          terminal.loc
        );
        const value = {
          kind: 'ConditionalExpression',
          test: test.value,
          consequent: consequent.value,
          alternate: alternate.value,
          loc: terminal.loc,
        };
        return {
          place: Object.assign({}, consequent.place),
          value: value,
          fallthrough: terminal.fallthrough,
          id: terminal.id,
        };
      }
      case 'maybe-throw': {
        CompilerError.throwTodo({
          reason: `Support value blocks (conditional, logical, optional chaining, etc) within a try/catch statement`,
          description: null,
          loc: terminal.loc,
          suggestions: null,
        });
      }
      case 'label': {
        CompilerError.throwTodo({
          reason: `Support labeled statements combined with value blocks (conditional, logical, optional chaining, etc)`,
          description: null,
          loc: terminal.loc,
          suggestions: null,
        });
      }
      default: {
        CompilerError.throwTodo({
          reason: `Support \`${terminal.kind}\` as a value block terminal (conditional, logical, optional chaining, etc)`,
          description: null,
          loc: terminal.loc,
          suggestions: null,
        });
      }
    }
  }
  emptyBlock() {
    return [];
  }
  visitBreak(block, id, loc) {
    const target = this.cx.getBreakTarget(block);
    if (target === null) {
      CompilerError.invariant(false, {
        reason: 'Expected a break target',
        description: null,
        loc: null,
        suggestions: null,
      });
    }
    if (this.cx.scopeFallthroughs.has(target.block)) {
      CompilerError.invariant(target.type === 'implicit', {
        reason: 'Expected reactive scope to implicitly break to fallthrough',
        loc: loc,
      });
      return null;
    }
    return {
      kind: 'terminal',
      terminal: {
        kind: 'break',
        loc: loc,
        target: target.block,
        id: id,
        targetKind: target.type,
      },
      label: null,
    };
  }
  visitContinue(block, id, loc) {
    const target = this.cx.getContinueTarget(block);
    CompilerError.invariant(target !== null, {
      reason: `Expected continue target to be scheduled for bb${block}`,
      description: null,
      loc: null,
      suggestions: null,
    });
    return {
      kind: 'terminal',
      terminal: {
        kind: 'continue',
        loc: loc,
        target: target.block,
        id: id,
        targetKind: target.type,
      },
      label: null,
    };
  }
}
let Context$2 = class Context {
  constructor(ir) {
    _Context_nextScheduleId.set(this, 0);
    this.emitted = new Set();
    this.scopeFallthroughs = new Set();
    _Context_scheduled.set(this, new Set());
    _Context_catchHandlers.set(this, new Set());
    _Context_controlFlowStack.set(this, []);
    this.ir = ir;
  }
  block(id) {
    return this.ir.blocks.get(id);
  }
  scheduleCatchHandler(block) {
    __classPrivateFieldGet(this, _Context_catchHandlers, 'f').add(block);
  }
  reachable(id) {
    const block = this.ir.blocks.get(id);
    return block.terminal.kind !== 'unreachable';
  }
  schedule(block, type) {
    var _a, _b;
    const id =
      (__classPrivateFieldSet(
        this,
        _Context_nextScheduleId,
        ((_b = __classPrivateFieldGet(this, _Context_nextScheduleId, 'f')),
        (_a = _b++),
        _b),
        'f'
      ),
      _a);
    CompilerError.invariant(
      !__classPrivateFieldGet(this, _Context_scheduled, 'f').has(block),
      {
        reason: `Break block is already scheduled: bb${block}`,
        description: null,
        loc: null,
        suggestions: null,
      }
    );
    __classPrivateFieldGet(this, _Context_scheduled, 'f').add(block);
    __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').push({
      block: block,
      id: id,
      type: type,
    });
    return id;
  }
  scheduleLoop(fallthroughBlock, continueBlock, loopBlock) {
    var _a, _b;
    const id =
      (__classPrivateFieldSet(
        this,
        _Context_nextScheduleId,
        ((_b = __classPrivateFieldGet(this, _Context_nextScheduleId, 'f')),
        (_a = _b++),
        _b),
        'f'
      ),
      _a);
    const ownsBlock = !__classPrivateFieldGet(
      this,
      _Context_scheduled,
      'f'
    ).has(fallthroughBlock);
    __classPrivateFieldGet(this, _Context_scheduled, 'f').add(fallthroughBlock);
    CompilerError.invariant(
      !__classPrivateFieldGet(this, _Context_scheduled, 'f').has(continueBlock),
      {
        reason: `Continue block is already scheduled: bb${continueBlock}`,
        description: null,
        loc: null,
        suggestions: null,
      }
    );
    __classPrivateFieldGet(this, _Context_scheduled, 'f').add(continueBlock);
    let ownsLoop = false;
    if (loopBlock !== null) {
      ownsLoop = !__classPrivateFieldGet(this, _Context_scheduled, 'f').has(
        loopBlock
      );
      __classPrivateFieldGet(this, _Context_scheduled, 'f').add(loopBlock);
    }
    __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').push({
      block: fallthroughBlock,
      ownsBlock: ownsBlock,
      id: id,
      type: 'loop',
      continueBlock: continueBlock,
      loopBlock: loopBlock,
      ownsLoop: ownsLoop,
    });
    return id;
  }
  unschedule(scheduleId) {
    const last = __classPrivateFieldGet(
      this,
      _Context_controlFlowStack,
      'f'
    ).pop();
    CompilerError.invariant(last !== undefined && last.id === scheduleId, {
      reason: 'Can only unschedule the last target',
      description: null,
      loc: null,
      suggestions: null,
    });
    if (last.type !== 'loop' || last.ownsBlock !== null) {
      __classPrivateFieldGet(this, _Context_scheduled, 'f').delete(last.block);
    }
    if (last.type === 'loop') {
      __classPrivateFieldGet(this, _Context_scheduled, 'f').delete(
        last.continueBlock
      );
      if (last.ownsLoop && last.loopBlock !== null) {
        __classPrivateFieldGet(this, _Context_scheduled, 'f').delete(
          last.loopBlock
        );
      }
    }
  }
  unscheduleAll(scheduleIds) {
    for (let i = scheduleIds.length - 1; i >= 0; i--) {
      this.unschedule(scheduleIds[i]);
    }
  }
  isScheduled(block) {
    return (
      __classPrivateFieldGet(this, _Context_scheduled, 'f').has(block) ||
      __classPrivateFieldGet(this, _Context_catchHandlers, 'f').has(block)
    );
  }
  getBreakTarget(block) {
    let hasPrecedingLoop = false;
    for (
      let i =
        __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').length - 1;
      i >= 0;
      i--
    ) {
      const target = __classPrivateFieldGet(
        this,
        _Context_controlFlowStack,
        'f'
      )[i];
      if (target.block === block) {
        let type;
        if (target.type === 'loop') {
          type = hasPrecedingLoop ? 'labeled' : 'unlabeled';
        } else if (
          i ===
          __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').length -
            1
        ) {
          type = 'implicit';
        } else {
          type = 'labeled';
        }
        return {block: target.block, type: type};
      }
      hasPrecedingLoop || (hasPrecedingLoop = target.type === 'loop');
    }
    CompilerError.invariant(false, {
      reason: 'Expected a break target',
      description: null,
      loc: null,
      suggestions: null,
    });
  }
  getContinueTarget(block) {
    let hasPrecedingLoop = false;
    for (
      let i =
        __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').length - 1;
      i >= 0;
      i--
    ) {
      const target = __classPrivateFieldGet(
        this,
        _Context_controlFlowStack,
        'f'
      )[i];
      if (target.type == 'loop' && target.continueBlock === block) {
        let type;
        if (hasPrecedingLoop) {
          type = 'labeled';
        } else if (
          i ===
          __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').length -
            1
        ) {
          type = 'implicit';
        } else {
          type = 'unlabeled';
        }
        return {block: target.block, type: type};
      }
      hasPrecedingLoop || (hasPrecedingLoop = target.type === 'loop');
    }
    return null;
  }
  debugBreakTargets() {
    return __classPrivateFieldGet(this, _Context_controlFlowStack, 'f').map(
      target => Object.assign({}, target)
    );
  }
};
(_Context_nextScheduleId = new WeakMap()),
  (_Context_scheduled = new WeakMap()),
  (_Context_catchHandlers = new WeakMap()),
  (_Context_controlFlowStack = new WeakMap());
var GuardKind;
(function (GuardKind) {
  GuardKind[(GuardKind['PushHookGuard'] = 0)] = 'PushHookGuard';
  GuardKind[(GuardKind['PopHookGuard'] = 1)] = 'PopHookGuard';
  GuardKind[(GuardKind['AllowHook'] = 2)] = 'AllowHook';
  GuardKind[(GuardKind['DisallowHook'] = 3)] = 'DisallowHook';
})(GuardKind || (GuardKind = {}));
function memoizeFbtAndMacroOperandsInSameScope(fn) {
  var _a;
  const fbtMacroTags = new Set([
    ...Array.from(FBT_TAGS).map(tag => [tag, []]),
    ...((_a = fn.env.config.customMacros) !== null && _a !== void 0 ? _a : []),
  ]);
  const fbtValues = new Set();
  const macroMethods = new Map();
  while (true) {
    let vsize = fbtValues.size;
    let msize = macroMethods.size;
    visit$1(fn, fbtMacroTags, fbtValues, macroMethods);
    if (vsize === fbtValues.size && msize === macroMethods.size) {
      break;
    }
  }
  return fbtValues;
}
const FBT_TAGS = new Set(['fbt', 'fbt:param', 'fbs', 'fbs:param']);
const SINGLE_CHILD_FBT_TAGS = new Set(['fbt:param', 'fbs:param']);
function visit$1(fn, fbtMacroTags, fbtValues, macroMethods) {
  for (const [, block] of fn.body.blocks) {
    for (const instruction of block.instructions) {
      const {lvalue: lvalue, value: value} = instruction;
      if (lvalue === null) {
        continue;
      }
      if (
        value.kind === 'Primitive' &&
        typeof value.value === 'string' &&
        matchesExactTag(value.value, fbtMacroTags)
      ) {
        fbtValues.add(lvalue.identifier.id);
      } else if (
        value.kind === 'LoadGlobal' &&
        matchesExactTag(value.binding.name, fbtMacroTags)
      ) {
        fbtValues.add(lvalue.identifier.id);
      } else if (
        value.kind === 'LoadGlobal' &&
        matchTagRoot(value.binding.name, fbtMacroTags) !== null
      ) {
        const methods = matchTagRoot(value.binding.name, fbtMacroTags);
        macroMethods.set(lvalue.identifier.id, methods);
      } else if (
        value.kind === 'PropertyLoad' &&
        macroMethods.has(value.object.identifier.id)
      ) {
        const methods = macroMethods.get(value.object.identifier.id);
        const newMethods = [];
        for (const method of methods) {
          if (
            method.length > 0 &&
            (method[0].type === 'wildcard' ||
              (method[0].type === 'name' && method[0].name === value.property))
          ) {
            if (method.length > 1) {
              newMethods.push(method.slice(1));
            } else {
              fbtValues.add(lvalue.identifier.id);
            }
          }
        }
        if (newMethods.length > 0) {
          macroMethods.set(lvalue.identifier.id, newMethods);
        }
      } else if (isFbtCallExpression(fbtValues, value)) {
        const fbtScope = lvalue.identifier.scope;
        if (fbtScope === null) {
          continue;
        }
        for (const operand of eachReactiveValueOperand(value)) {
          operand.identifier.scope = fbtScope;
          expandFbtScopeRange(fbtScope.range, operand.identifier.mutableRange);
          fbtValues.add(operand.identifier.id);
        }
      } else if (
        isFbtJsxExpression(fbtMacroTags, fbtValues, value) ||
        isFbtJsxChild(fbtValues, lvalue, value)
      ) {
        const fbtScope = lvalue.identifier.scope;
        if (fbtScope === null) {
          continue;
        }
        for (const operand of eachReactiveValueOperand(value)) {
          operand.identifier.scope = fbtScope;
          expandFbtScopeRange(fbtScope.range, operand.identifier.mutableRange);
          fbtValues.add(operand.identifier.id);
        }
      } else if (fbtValues.has(lvalue.identifier.id)) {
        const fbtScope = lvalue.identifier.scope;
        if (fbtScope === null) {
          return;
        }
        for (const operand of eachReactiveValueOperand(value)) {
          if (
            operand.identifier.name !== null &&
            operand.identifier.name.kind === 'named'
          ) {
            continue;
          }
          operand.identifier.scope = fbtScope;
          expandFbtScopeRange(fbtScope.range, operand.identifier.mutableRange);
        }
      }
    }
  }
}
function matchesExactTag(s, tags) {
  return Array.from(tags).some(macro =>
    typeof macro === 'string'
      ? s === macro
      : macro[1].length === 0 && macro[0] === s
  );
}
function matchTagRoot(s, tags) {
  const methods = [];
  for (const macro of tags) {
    if (typeof macro === 'string') {
      continue;
    }
    const [tag, rest] = macro;
    if (tag === s && rest.length > 0) {
      methods.push(rest);
    }
  }
  if (methods.length > 0) {
    return methods;
  } else {
    return null;
  }
}
function isFbtCallExpression(fbtValues, value) {
  return (
    (value.kind === 'CallExpression' &&
      fbtValues.has(value.callee.identifier.id)) ||
    (value.kind === 'MethodCall' && fbtValues.has(value.property.identifier.id))
  );
}
function isFbtJsxExpression(fbtMacroTags, fbtValues, value) {
  return (
    value.kind === 'JsxExpression' &&
    ((value.tag.kind === 'Identifier' &&
      fbtValues.has(value.tag.identifier.id)) ||
      (value.tag.kind === 'BuiltinTag' &&
        matchesExactTag(value.tag.name, fbtMacroTags)))
  );
}
function isFbtJsxChild(fbtValues, lvalue, value) {
  return (
    (value.kind === 'JsxExpression' || value.kind === 'JsxFragment') &&
    lvalue !== null &&
    fbtValues.has(lvalue.identifier.id)
  );
}
function expandFbtScopeRange(fbtRange, extendWith) {
  if (extendWith.start !== 0) {
    fbtRange.start = makeInstructionId(
      Math.min(fbtRange.start, extendWith.start)
    );
  }
}
var _Context_nextCacheIndex, _Context_declarations$1;
const MEMO_CACHE_SENTINEL = 'react.memo_cache_sentinel';
const EARLY_RETURN_SENTINEL = 'react.early_return_sentinel';
function codegenFunction(
  fn,
  {uniqueIdentifiers: uniqueIdentifiers, fbtOperands: fbtOperands}
) {
  var _a, _b, _c;
  const cx = new Context$1(
    fn.env,
    (_a = fn.id) !== null && _a !== void 0 ? _a : '[[ anonymous ]]',
    uniqueIdentifiers,
    fbtOperands,
    null
  );
  let fastRefreshState = null;
  if (
    fn.env.config.enableResetCacheOnSourceFileChanges &&
    fn.env.code !== null
  ) {
    const hash = crypto$2.createHmac('sha256', fn.env.code).digest('hex');
    fastRefreshState = {cacheIndex: cx.nextCacheIndex, hash: hash};
  }
  const compileResult = codegenReactiveFunction(cx, fn);
  if (compileResult.isErr()) {
    return compileResult;
  }
  const compiled = compileResult.unwrap();
  const hookGuard = fn.env.config.enableEmitHookGuards;
  if (hookGuard != null) {
    compiled.body = t__namespace.blockStatement([
      createHookGuard(
        hookGuard,
        compiled.body.body,
        GuardKind.PushHookGuard,
        GuardKind.PopHookGuard
      ),
    ]);
  }
  const cacheCount = compiled.memoSlotsUsed;
  if (cacheCount !== 0) {
    const preface = [];
    preface.push(
      t__namespace.variableDeclaration('const', [
        t__namespace.variableDeclarator(
          t__namespace.identifier(cx.synthesizeName('$')),
          t__namespace.callExpression(
            t__namespace.identifier(fn.env.useMemoCacheIdentifier),
            [t__namespace.numericLiteral(cacheCount)]
          )
        ),
      ])
    );
    if (fastRefreshState !== null) {
      const index = cx.synthesizeName('$i');
      preface.push(
        t__namespace.ifStatement(
          t__namespace.binaryExpression(
            '!==',
            t__namespace.memberExpression(
              t__namespace.identifier(cx.synthesizeName('$')),
              t__namespace.numericLiteral(fastRefreshState.cacheIndex),
              true
            ),
            t__namespace.stringLiteral(fastRefreshState.hash)
          ),
          t__namespace.blockStatement([
            t__namespace.forStatement(
              t__namespace.variableDeclaration('let', [
                t__namespace.variableDeclarator(
                  t__namespace.identifier(index),
                  t__namespace.numericLiteral(0)
                ),
              ]),
              t__namespace.binaryExpression(
                '<',
                t__namespace.identifier(index),
                t__namespace.numericLiteral(cacheCount)
              ),
              t__namespace.assignmentExpression(
                '+=',
                t__namespace.identifier(index),
                t__namespace.numericLiteral(1)
              ),
              t__namespace.blockStatement([
                t__namespace.expressionStatement(
                  t__namespace.assignmentExpression(
                    '=',
                    t__namespace.memberExpression(
                      t__namespace.identifier(cx.synthesizeName('$')),
                      t__namespace.identifier(index),
                      true
                    ),
                    t__namespace.callExpression(
                      t__namespace.memberExpression(
                        t__namespace.identifier('Symbol'),
                        t__namespace.identifier('for')
                      ),
                      [t__namespace.stringLiteral(MEMO_CACHE_SENTINEL)]
                    )
                  )
                ),
              ])
            ),
            t__namespace.expressionStatement(
              t__namespace.assignmentExpression(
                '=',
                t__namespace.memberExpression(
                  t__namespace.identifier(cx.synthesizeName('$')),
                  t__namespace.numericLiteral(fastRefreshState.cacheIndex),
                  true
                ),
                t__namespace.stringLiteral(fastRefreshState.hash)
              )
            ),
          ])
        )
      );
    }
    compiled.body.body.unshift(...preface);
  }
  const emitInstrumentForget = fn.env.config.enableEmitInstrumentForget;
  if (emitInstrumentForget != null && fn.id != null) {
    let gating;
    if (
      emitInstrumentForget.gating != null &&
      emitInstrumentForget.globalGating != null
    ) {
      gating = t__namespace.logicalExpression(
        '&&',
        t__namespace.identifier(emitInstrumentForget.globalGating),
        t__namespace.identifier(emitInstrumentForget.gating.importSpecifierName)
      );
    } else if (emitInstrumentForget.gating != null) {
      gating = t__namespace.identifier(
        emitInstrumentForget.gating.importSpecifierName
      );
    } else {
      CompilerError.invariant(emitInstrumentForget.globalGating != null, {
        reason:
          'Bad config not caught! Expected at least one of gating or globalGating',
        loc: null,
        suggestions: null,
      });
      gating = t__namespace.identifier(emitInstrumentForget.globalGating);
    }
    const test = t__namespace.ifStatement(
      gating,
      t__namespace.expressionStatement(
        t__namespace.callExpression(
          t__namespace.identifier(emitInstrumentForget.fn.importSpecifierName),
          [
            t__namespace.stringLiteral(fn.id),
            t__namespace.stringLiteral(
              (_b = fn.env.filename) !== null && _b !== void 0 ? _b : ''
            ),
          ]
        )
      )
    );
    compiled.body.body.unshift(test);
  }
  const outlined = [];
  for (const {
    fn: outlinedFunction,
    type: type,
  } of cx.env.getOutlinedFunctions()) {
    const reactiveFunction = buildReactiveFunction(outlinedFunction);
    pruneUnusedLabels(reactiveFunction);
    pruneUnusedLValues(reactiveFunction);
    pruneHoistedContexts(reactiveFunction);
    const identifiers = renameVariables(reactiveFunction);
    const codegen = codegenReactiveFunction(
      new Context$1(
        cx.env,
        (_c = reactiveFunction.id) !== null && _c !== void 0
          ? _c
          : '[[ anonymous ]]',
        identifiers,
        cx.fbtOperands
      ),
      reactiveFunction
    );
    if (codegen.isErr()) {
      return codegen;
    }
    outlined.push({fn: codegen.unwrap(), type: type});
  }
  compiled.outlined = outlined;
  return compileResult;
}
function codegenReactiveFunction(cx, fn) {
  for (const param of fn.params) {
    if (param.kind === 'Identifier') {
      cx.temp.set(param.identifier.declarationId, null);
    } else {
      cx.temp.set(param.place.identifier.declarationId, null);
    }
  }
  const params = fn.params.map(param => convertParameter(param));
  const body = codegenBlock(cx, fn.body);
  body.directives = fn.directives.map(d =>
    t__namespace.directive(t__namespace.directiveLiteral(d))
  );
  const statements = body.body;
  if (statements.length !== 0) {
    const last = statements[statements.length - 1];
    if (last.type === 'ReturnStatement' && last.argument == null) {
      statements.pop();
    }
  }
  if (cx.errors.hasErrors()) {
    return Err(cx.errors);
  }
  const countMemoBlockVisitor = new CountMemoBlockVisitor(fn.env);
  visitReactiveFunction(fn, countMemoBlockVisitor, undefined);
  return Ok({
    type: 'CodegenFunction',
    loc: fn.loc,
    id: fn.id !== null ? t__namespace.identifier(fn.id) : null,
    params: params,
    body: body,
    generator: fn.generator,
    async: fn.async,
    memoSlotsUsed: cx.nextCacheIndex,
    memoBlocks: countMemoBlockVisitor.memoBlocks,
    memoValues: countMemoBlockVisitor.memoValues,
    prunedMemoBlocks: countMemoBlockVisitor.prunedMemoBlocks,
    prunedMemoValues: countMemoBlockVisitor.prunedMemoValues,
    outlined: [],
    hasLoweredContextAccess: fn.env.hasLoweredContextAccess,
  });
}
class CountMemoBlockVisitor extends ReactiveFunctionVisitor {
  constructor(env) {
    super();
    this.memoBlocks = 0;
    this.memoValues = 0;
    this.prunedMemoBlocks = 0;
    this.prunedMemoValues = 0;
    this.env = env;
  }
  visitScope(scopeBlock, state) {
    this.memoBlocks += 1;
    this.memoValues += scopeBlock.scope.declarations.size;
    this.traverseScope(scopeBlock, state);
  }
  visitPrunedScope(scopeBlock, state) {
    this.prunedMemoBlocks += 1;
    this.prunedMemoValues += scopeBlock.scope.declarations.size;
    this.traversePrunedScope(scopeBlock, state);
  }
}
function convertParameter(param) {
  if (param.kind === 'Identifier') {
    return convertIdentifier(param.identifier);
  } else {
    return t__namespace.restElement(convertIdentifier(param.place.identifier));
  }
}
let Context$1 = class Context {
  constructor(env, fnName, uniqueIdentifiers, fbtOperands, temporaries = null) {
    _Context_nextCacheIndex.set(this, 0);
    _Context_declarations$1.set(this, new Set());
    this.errors = new CompilerError();
    this.objectMethods = new Map();
    this.synthesizedNames = new Map();
    this.env = env;
    this.fnName = fnName;
    this.uniqueIdentifiers = uniqueIdentifiers;
    this.fbtOperands = fbtOperands;
    this.temp = temporaries !== null ? new Map(temporaries) : new Map();
  }
  get nextCacheIndex() {
    var _a, _b;
    return (
      __classPrivateFieldSet(
        this,
        _Context_nextCacheIndex,
        ((_b = __classPrivateFieldGet(this, _Context_nextCacheIndex, 'f')),
        (_a = _b++),
        _b),
        'f'
      ),
      _a
    );
  }
  declare(identifier) {
    __classPrivateFieldGet(this, _Context_declarations$1, 'f').add(
      identifier.declarationId
    );
  }
  hasDeclared(identifier) {
    return __classPrivateFieldGet(this, _Context_declarations$1, 'f').has(
      identifier.declarationId
    );
  }
  synthesizeName(name) {
    const previous = this.synthesizedNames.get(name);
    if (previous !== undefined) {
      return previous;
    }
    let validated = makeIdentifierName(name).value;
    let index = 0;
    while (this.uniqueIdentifiers.has(validated)) {
      validated = makeIdentifierName(`${name}${index++}`).value;
    }
    this.uniqueIdentifiers.add(validated);
    this.synthesizedNames.set(name, validated);
    return validated;
  }
};
(_Context_nextCacheIndex = new WeakMap()),
  (_Context_declarations$1 = new WeakMap());
function codegenBlock(cx, block) {
  const temp = new Map(cx.temp);
  const result = codegenBlockNoReset(cx, block);
  for (const [key, value] of cx.temp) {
    if (!temp.has(key)) {
      continue;
    }
    CompilerError.invariant(temp.get(key) === value, {
      loc: null,
      reason: 'Expected temporary value to be unchanged',
      description: null,
      suggestions: null,
    });
  }
  cx.temp = temp;
  return result;
}
function codegenBlockNoReset(cx, block) {
  const statements = [];
  for (const item of block) {
    switch (item.kind) {
      case 'instruction': {
        const statement = codegenInstructionNullable(cx, item.instruction);
        if (statement !== null) {
          statements.push(statement);
        }
        break;
      }
      case 'pruned-scope': {
        const scopeBlock = codegenBlockNoReset(cx, item.instructions);
        statements.push(...scopeBlock.body);
        break;
      }
      case 'scope': {
        const temp = new Map(cx.temp);
        codegenReactiveScope(cx, statements, item.scope, item.instructions);
        cx.temp = temp;
        break;
      }
      case 'terminal': {
        const statement = codegenTerminal(cx, item.terminal);
        if (statement === null) {
          break;
        }
        if (item.label !== null && !item.label.implicit) {
          const block =
            statement.type === 'BlockStatement' && statement.body.length === 1
              ? statement.body[0]
              : statement;
          statements.push(
            t__namespace.labeledStatement(
              t__namespace.identifier(codegenLabel(item.label.id)),
              block
            )
          );
        } else if (statement.type === 'BlockStatement') {
          statements.push(...statement.body);
        } else {
          statements.push(statement);
        }
        break;
      }
      default: {
        assertExhaustive(item, `Unexpected item kind \`${item.kind}\``);
      }
    }
  }
  return t__namespace.blockStatement(statements);
}
function wrapCacheDep(cx, value) {
  if (cx.env.config.enableEmitFreeze != null) {
    return t__namespace.conditionalExpression(
      t__namespace.identifier('__DEV__'),
      t__namespace.callExpression(
        t__namespace.identifier(
          cx.env.config.enableEmitFreeze.importSpecifierName
        ),
        [value, t__namespace.stringLiteral(cx.fnName)]
      ),
      value
    );
  } else {
    return value;
  }
}
function codegenReactiveScope(cx, statements, scope, block) {
  const cacheStoreStatements = [];
  const cacheLoadStatements = [];
  const cacheLoads = [];
  const changeExpressions = [];
  const changeExpressionComments = [];
  const outputComments = [];
  for (const dep of [...scope.dependencies].sort(compareScopeDependency)) {
    const index = cx.nextCacheIndex;
    changeExpressionComments.push(printDependencyComment(dep));
    const comparison = t__namespace.binaryExpression(
      '!==',
      t__namespace.memberExpression(
        t__namespace.identifier(cx.synthesizeName('$')),
        t__namespace.numericLiteral(index),
        true
      ),
      codegenDependency(cx, dep)
    );
    if (cx.env.config.enableChangeVariableCodegen) {
      const changeIdentifier = t__namespace.identifier(
        cx.synthesizeName(`c_${index}`)
      );
      statements.push(
        t__namespace.variableDeclaration('const', [
          t__namespace.variableDeclarator(changeIdentifier, comparison),
        ])
      );
      changeExpressions.push(changeIdentifier);
    } else {
      changeExpressions.push(comparison);
    }
    cacheStoreStatements.push(
      t__namespace.expressionStatement(
        t__namespace.assignmentExpression(
          '=',
          t__namespace.memberExpression(
            t__namespace.identifier(cx.synthesizeName('$')),
            t__namespace.numericLiteral(index),
            true
          ),
          codegenDependency(cx, dep)
        )
      )
    );
  }
  let firstOutputIndex = null;
  for (const [, {identifier: identifier}] of [...scope.declarations].sort(
    ([, a], [, b]) => compareScopeDeclaration(a, b)
  )) {
    const index = cx.nextCacheIndex;
    if (firstOutputIndex === null) {
      firstOutputIndex = index;
    }
    CompilerError.invariant(identifier.name != null, {
      reason: `Expected scope declaration identifier to be named`,
      description: `Declaration \`${printIdentifier(identifier)}\` is unnamed in scope @${scope.id}`,
      loc: null,
      suggestions: null,
    });
    const name = convertIdentifier(identifier);
    outputComments.push(name.name);
    if (!cx.hasDeclared(identifier)) {
      statements.push(
        t__namespace.variableDeclaration('let', [
          t__namespace.variableDeclarator(name),
        ])
      );
    }
    cacheLoads.push({name: name, index: index, value: wrapCacheDep(cx, name)});
    cx.declare(identifier);
  }
  for (const reassignment of scope.reassignments) {
    const index = cx.nextCacheIndex;
    if (firstOutputIndex === null) {
      firstOutputIndex = index;
    }
    const name = convertIdentifier(reassignment);
    outputComments.push(name.name);
    cacheLoads.push({name: name, index: index, value: wrapCacheDep(cx, name)});
  }
  let testCondition = changeExpressions.reduce((acc, ident) => {
    if (acc == null) {
      return ident;
    }
    return t__namespace.logicalExpression('||', acc, ident);
  }, null);
  if (testCondition === null) {
    CompilerError.invariant(firstOutputIndex !== null, {
      reason: `Expected scope to have at least one declaration`,
      description: `Scope '@${scope.id}' has no declarations`,
      loc: null,
      suggestions: null,
    });
    testCondition = t__namespace.binaryExpression(
      '===',
      t__namespace.memberExpression(
        t__namespace.identifier(cx.synthesizeName('$')),
        t__namespace.numericLiteral(firstOutputIndex),
        true
      ),
      t__namespace.callExpression(
        t__namespace.memberExpression(
          t__namespace.identifier('Symbol'),
          t__namespace.identifier('for')
        ),
        [t__namespace.stringLiteral(MEMO_CACHE_SENTINEL)]
      )
    );
  }
  if (cx.env.config.disableMemoizationForDebugging) {
    CompilerError.invariant(
      cx.env.config.enableChangeDetectionForDebugging == null,
      {
        reason: `Expected to not have both change detection enabled and memoization disabled`,
        description: `Incompatible config options`,
        loc: null,
      }
    );
    testCondition = t__namespace.logicalExpression(
      '||',
      testCondition,
      t__namespace.booleanLiteral(true)
    );
  }
  let computationBlock = codegenBlock(cx, block);
  let memoStatement;
  if (
    cx.env.config.enableChangeDetectionForDebugging != null &&
    changeExpressions.length > 0
  ) {
    const loc =
      typeof scope.loc === 'symbol'
        ? 'unknown location'
        : `(${scope.loc.start.line}:${scope.loc.end.line})`;
    const detectionFunction =
      cx.env.config.enableChangeDetectionForDebugging.importSpecifierName;
    const cacheLoadOldValueStatements = [];
    const changeDetectionStatements = [];
    const idempotenceDetectionStatements = [];
    for (const {name: name, index: index, value: value} of cacheLoads) {
      const loadName = cx.synthesizeName(`old$${name.name}`);
      const slot = t__namespace.memberExpression(
        t__namespace.identifier(cx.synthesizeName('$')),
        t__namespace.numericLiteral(index),
        true
      );
      cacheStoreStatements.push(
        t__namespace.expressionStatement(
          t__namespace.assignmentExpression('=', slot, value)
        )
      );
      cacheLoadOldValueStatements.push(
        t__namespace.variableDeclaration('let', [
          t__namespace.variableDeclarator(
            t__namespace.identifier(loadName),
            slot
          ),
        ])
      );
      changeDetectionStatements.push(
        t__namespace.expressionStatement(
          t__namespace.callExpression(
            t__namespace.identifier(detectionFunction),
            [
              t__namespace.identifier(loadName),
              t__namespace.cloneNode(name, true),
              t__namespace.stringLiteral(name.name),
              t__namespace.stringLiteral(cx.fnName),
              t__namespace.stringLiteral('cached'),
              t__namespace.stringLiteral(loc),
            ]
          )
        )
      );
      idempotenceDetectionStatements.push(
        t__namespace.expressionStatement(
          t__namespace.callExpression(
            t__namespace.identifier(detectionFunction),
            [
              t__namespace.cloneNode(slot, true),
              t__namespace.cloneNode(name, true),
              t__namespace.stringLiteral(name.name),
              t__namespace.stringLiteral(cx.fnName),
              t__namespace.stringLiteral('recomputed'),
              t__namespace.stringLiteral(loc),
            ]
          )
        )
      );
      idempotenceDetectionStatements.push(
        t__namespace.expressionStatement(
          t__namespace.assignmentExpression('=', name, slot)
        )
      );
    }
    const condition = cx.synthesizeName('condition');
    const recomputationBlock = t__namespace.cloneNode(computationBlock, true);
    memoStatement = t__namespace.blockStatement([
      ...computationBlock.body,
      t__namespace.variableDeclaration('let', [
        t__namespace.variableDeclarator(
          t__namespace.identifier(condition),
          testCondition
        ),
      ]),
      t__namespace.ifStatement(
        t__namespace.unaryExpression('!', t__namespace.identifier(condition)),
        t__namespace.blockStatement([
          ...cacheLoadOldValueStatements,
          ...changeDetectionStatements,
        ])
      ),
      ...cacheStoreStatements,
      t__namespace.ifStatement(
        t__namespace.identifier(condition),
        t__namespace.blockStatement([
          ...recomputationBlock.body,
          ...idempotenceDetectionStatements,
        ])
      ),
    ]);
  } else {
    for (const {name: name, index: index, value: value} of cacheLoads) {
      cacheStoreStatements.push(
        t__namespace.expressionStatement(
          t__namespace.assignmentExpression(
            '=',
            t__namespace.memberExpression(
              t__namespace.identifier(cx.synthesizeName('$')),
              t__namespace.numericLiteral(index),
              true
            ),
            value
          )
        )
      );
      cacheLoadStatements.push(
        t__namespace.expressionStatement(
          t__namespace.assignmentExpression(
            '=',
            name,
            t__namespace.memberExpression(
              t__namespace.identifier(cx.synthesizeName('$')),
              t__namespace.numericLiteral(index),
              true
            )
          )
        )
      );
    }
    computationBlock.body.push(...cacheStoreStatements);
    memoStatement = t__namespace.ifStatement(
      testCondition,
      computationBlock,
      t__namespace.blockStatement(cacheLoadStatements)
    );
  }
  if (cx.env.config.enableMemoizationComments) {
    if (changeExpressionComments.length) {
      t__namespace.addComment(
        memoStatement,
        'leading',
        ` check if ${printDelimitedCommentList(changeExpressionComments, 'or')} changed`,
        true
      );
      t__namespace.addComment(
        memoStatement,
        'leading',
        ` "useMemo" for ${printDelimitedCommentList(outputComments, 'and')}:`,
        true
      );
    } else {
      t__namespace.addComment(
        memoStatement,
        'leading',
        ' cache value with no dependencies',
        true
      );
      t__namespace.addComment(
        memoStatement,
        'leading',
        ` "useMemo" for ${printDelimitedCommentList(outputComments, 'and')}:`,
        true
      );
    }
    if (computationBlock.body.length > 0) {
      t__namespace.addComment(
        computationBlock.body[0],
        'leading',
        ` Inputs changed, recompute`,
        true
      );
    }
    if (cacheLoadStatements.length > 0) {
      t__namespace.addComment(
        cacheLoadStatements[0],
        'leading',
        ` Inputs did not change, use cached value`,
        true
      );
    }
  }
  statements.push(memoStatement);
  const earlyReturnValue = scope.earlyReturnValue;
  if (earlyReturnValue !== null) {
    CompilerError.invariant(
      earlyReturnValue.value.name !== null &&
        earlyReturnValue.value.name.kind === 'named',
      {
        reason: `Expected early return value to be promoted to a named variable`,
        loc: earlyReturnValue.loc,
        description: null,
        suggestions: null,
      }
    );
    const name = earlyReturnValue.value.name.value;
    statements.push(
      t__namespace.ifStatement(
        t__namespace.binaryExpression(
          '!==',
          t__namespace.identifier(name),
          t__namespace.callExpression(
            t__namespace.memberExpression(
              t__namespace.identifier('Symbol'),
              t__namespace.identifier('for')
            ),
            [t__namespace.stringLiteral(EARLY_RETURN_SENTINEL)]
          )
        ),
        t__namespace.blockStatement([
          t__namespace.returnStatement(t__namespace.identifier(name)),
        ])
      )
    );
  }
}
function codegenTerminal(cx, terminal) {
  switch (terminal.kind) {
    case 'break': {
      if (terminal.targetKind === 'implicit') {
        return null;
      }
      return t__namespace.breakStatement(
        terminal.targetKind === 'labeled'
          ? t__namespace.identifier(codegenLabel(terminal.target))
          : null
      );
    }
    case 'continue': {
      if (terminal.targetKind === 'implicit') {
        return null;
      }
      return t__namespace.continueStatement(
        terminal.targetKind === 'labeled'
          ? t__namespace.identifier(codegenLabel(terminal.target))
          : null
      );
    }
    case 'for': {
      return t__namespace.forStatement(
        codegenForInit(cx, terminal.init),
        codegenInstructionValueToExpression(cx, terminal.test),
        terminal.update !== null
          ? codegenInstructionValueToExpression(cx, terminal.update)
          : null,
        codegenBlock(cx, terminal.loop)
      );
    }
    case 'for-in': {
      CompilerError.invariant(terminal.init.kind === 'SequenceExpression', {
        reason: `Expected a sequence expression init for for..in`,
        description: `Got \`${terminal.init.kind}\` expression instead`,
        loc: terminal.init.loc,
        suggestions: null,
      });
      if (terminal.init.instructions.length !== 2) {
        CompilerError.throwTodo({
          reason: 'Support non-trivial for..in inits',
          description: null,
          loc: terminal.init.loc,
          suggestions: null,
        });
      }
      const iterableCollection = terminal.init.instructions[0];
      const iterableItem = terminal.init.instructions[1];
      let lval;
      switch (iterableItem.value.kind) {
        case 'StoreLocal': {
          lval = codegenLValue(cx, iterableItem.value.lvalue.place);
          break;
        }
        case 'Destructure': {
          lval = codegenLValue(cx, iterableItem.value.lvalue.pattern);
          break;
        }
        default:
          CompilerError.invariant(false, {
            reason: `Expected a StoreLocal or Destructure to be assigned to the collection`,
            description: `Found ${iterableItem.value.kind}`,
            loc: iterableItem.value.loc,
            suggestions: null,
          });
      }
      let varDeclKind;
      switch (iterableItem.value.lvalue.kind) {
        case InstructionKind.Const:
          varDeclKind = 'const';
          break;
        case InstructionKind.Let:
          varDeclKind = 'let';
          break;
        case InstructionKind.Reassign:
          CompilerError.invariant(false, {
            reason:
              'Destructure should never be Reassign as it would be an Object/ArrayPattern',
            description: null,
            loc: iterableItem.loc,
            suggestions: null,
          });
        case InstructionKind.Catch:
        case InstructionKind.HoistedConst:
        case InstructionKind.HoistedLet:
        case InstructionKind.HoistedFunction:
        case InstructionKind.Function:
          CompilerError.invariant(false, {
            reason: `Unexpected ${iterableItem.value.lvalue.kind} variable in for..in collection`,
            description: null,
            loc: iterableItem.loc,
            suggestions: null,
          });
        default:
          assertExhaustive(
            iterableItem.value.lvalue.kind,
            `Unhandled lvalue kind: ${iterableItem.value.lvalue.kind}`
          );
      }
      return t__namespace.forInStatement(
        createVariableDeclaration(iterableItem.value.loc, varDeclKind, [
          t__namespace.variableDeclarator(lval, null),
        ]),
        codegenInstructionValueToExpression(cx, iterableCollection.value),
        codegenBlock(cx, terminal.loop)
      );
    }
    case 'for-of': {
      CompilerError.invariant(
        terminal.init.kind === 'SequenceExpression' &&
          terminal.init.instructions.length === 1 &&
          terminal.init.instructions[0].value.kind === 'GetIterator',
        {
          reason: `Expected a single-expression sequence expression init for for..of`,
          description: `Got \`${terminal.init.kind}\` expression instead`,
          loc: terminal.init.loc,
          suggestions: null,
        }
      );
      const iterableCollection = terminal.init.instructions[0].value;
      CompilerError.invariant(terminal.test.kind === 'SequenceExpression', {
        reason: `Expected a sequence expression test for for..of`,
        description: `Got \`${terminal.init.kind}\` expression instead`,
        loc: terminal.test.loc,
        suggestions: null,
      });
      if (terminal.test.instructions.length !== 2) {
        CompilerError.throwTodo({
          reason: 'Support non-trivial for..of inits',
          description: null,
          loc: terminal.init.loc,
          suggestions: null,
        });
      }
      const iterableItem = terminal.test.instructions[1];
      let lval;
      switch (iterableItem.value.kind) {
        case 'StoreLocal': {
          lval = codegenLValue(cx, iterableItem.value.lvalue.place);
          break;
        }
        case 'Destructure': {
          lval = codegenLValue(cx, iterableItem.value.lvalue.pattern);
          break;
        }
        default:
          CompilerError.invariant(false, {
            reason: `Expected a StoreLocal or Destructure to be assigned to the collection`,
            description: `Found ${iterableItem.value.kind}`,
            loc: iterableItem.value.loc,
            suggestions: null,
          });
      }
      let varDeclKind;
      switch (iterableItem.value.lvalue.kind) {
        case InstructionKind.Const:
          varDeclKind = 'const';
          break;
        case InstructionKind.Let:
          varDeclKind = 'let';
          break;
        case InstructionKind.Reassign:
        case InstructionKind.Catch:
        case InstructionKind.HoistedConst:
        case InstructionKind.HoistedLet:
        case InstructionKind.HoistedFunction:
        case InstructionKind.Function:
          CompilerError.invariant(false, {
            reason: `Unexpected ${iterableItem.value.lvalue.kind} variable in for..of collection`,
            description: null,
            loc: iterableItem.loc,
            suggestions: null,
          });
        default:
          assertExhaustive(
            iterableItem.value.lvalue.kind,
            `Unhandled lvalue kind: ${iterableItem.value.lvalue.kind}`
          );
      }
      return t__namespace.forOfStatement(
        createVariableDeclaration(iterableItem.value.loc, varDeclKind, [
          t__namespace.variableDeclarator(lval, null),
        ]),
        codegenInstructionValueToExpression(cx, iterableCollection),
        codegenBlock(cx, terminal.loop)
      );
    }
    case 'if': {
      const test = codegenPlaceToExpression(cx, terminal.test);
      const consequent = codegenBlock(cx, terminal.consequent);
      let alternate = null;
      if (terminal.alternate !== null) {
        const block = codegenBlock(cx, terminal.alternate);
        if (block.body.length !== 0) {
          alternate = block;
        }
      }
      return t__namespace.ifStatement(test, consequent, alternate);
    }
    case 'return': {
      const value = codegenPlaceToExpression(cx, terminal.value);
      if (value.type === 'Identifier' && value.name === 'undefined') {
        return t__namespace.returnStatement();
      }
      return t__namespace.returnStatement(value);
    }
    case 'switch': {
      return t__namespace.switchStatement(
        codegenPlaceToExpression(cx, terminal.test),
        terminal.cases.map(case_ => {
          const test =
            case_.test !== null
              ? codegenPlaceToExpression(cx, case_.test)
              : null;
          const block = codegenBlock(cx, case_.block);
          return t__namespace.switchCase(test, [block]);
        })
      );
    }
    case 'throw': {
      return t__namespace.throwStatement(
        codegenPlaceToExpression(cx, terminal.value)
      );
    }
    case 'do-while': {
      const test = codegenInstructionValueToExpression(cx, terminal.test);
      return t__namespace.doWhileStatement(
        test,
        codegenBlock(cx, terminal.loop)
      );
    }
    case 'while': {
      const test = codegenInstructionValueToExpression(cx, terminal.test);
      return t__namespace.whileStatement(test, codegenBlock(cx, terminal.loop));
    }
    case 'label': {
      return codegenBlock(cx, terminal.block);
    }
    case 'try': {
      let catchParam = null;
      if (terminal.handlerBinding !== null) {
        catchParam = convertIdentifier(terminal.handlerBinding.identifier);
        cx.temp.set(terminal.handlerBinding.identifier.declarationId, null);
      }
      return t__namespace.tryStatement(
        codegenBlock(cx, terminal.block),
        t__namespace.catchClause(catchParam, codegenBlock(cx, terminal.handler))
      );
    }
    default: {
      assertExhaustive(
        terminal,
        `Unexpected terminal kind \`${terminal.kind}\``
      );
    }
  }
}
function codegenInstructionNullable(cx, instr) {
  if (
    instr.value.kind === 'StoreLocal' ||
    instr.value.kind === 'StoreContext' ||
    instr.value.kind === 'Destructure' ||
    instr.value.kind === 'DeclareLocal' ||
    instr.value.kind === 'DeclareContext'
  ) {
    let kind = instr.value.lvalue.kind;
    let lvalue;
    let value;
    if (instr.value.kind === 'StoreLocal') {
      kind = cx.hasDeclared(instr.value.lvalue.place.identifier)
        ? InstructionKind.Reassign
        : kind;
      lvalue = instr.value.lvalue.place;
      value = codegenPlaceToExpression(cx, instr.value.value);
    } else if (instr.value.kind === 'StoreContext') {
      lvalue = instr.value.lvalue.place;
      value = codegenPlaceToExpression(cx, instr.value.value);
    } else if (
      instr.value.kind === 'DeclareLocal' ||
      instr.value.kind === 'DeclareContext'
    ) {
      if (cx.hasDeclared(instr.value.lvalue.place.identifier)) {
        return null;
      }
      kind = instr.value.lvalue.kind;
      lvalue = instr.value.lvalue.place;
      value = null;
    } else {
      lvalue = instr.value.lvalue.pattern;
      let hasReassign = false;
      let hasDeclaration = false;
      for (const place of eachPatternOperand(lvalue)) {
        if (
          kind !== InstructionKind.Reassign &&
          place.identifier.name === null
        ) {
          cx.temp.set(place.identifier.declarationId, null);
        }
        const isDeclared = cx.hasDeclared(place.identifier);
        hasReassign || (hasReassign = isDeclared);
        hasDeclaration || (hasDeclaration = !isDeclared);
      }
      if (hasReassign && hasDeclaration) {
        CompilerError.invariant(false, {
          reason:
            'Encountered a destructuring operation where some identifiers are already declared (reassignments) but others are not (declarations)',
          description: null,
          loc: instr.loc,
          suggestions: null,
        });
      } else if (hasReassign) {
        kind = InstructionKind.Reassign;
      }
      value = codegenPlaceToExpression(cx, instr.value.value);
    }
    switch (kind) {
      case InstructionKind.Const: {
        CompilerError.invariant(instr.lvalue === null, {
          reason: `Const declaration cannot be referenced as an expression`,
          description: null,
          loc: instr.value.loc,
          suggestions: null,
        });
        return createVariableDeclaration(instr.loc, 'const', [
          t__namespace.variableDeclarator(codegenLValue(cx, lvalue), value),
        ]);
      }
      case InstructionKind.Function: {
        CompilerError.invariant(instr.lvalue === null, {
          reason: `Function declaration cannot be referenced as an expression`,
          description: null,
          loc: instr.value.loc,
          suggestions: null,
        });
        const genLvalue = codegenLValue(cx, lvalue);
        CompilerError.invariant(genLvalue.type === 'Identifier', {
          reason: 'Expected an identifier as a function declaration lvalue',
          description: null,
          loc: instr.value.loc,
          suggestions: null,
        });
        CompilerError.invariant(
          (value === null || value === void 0 ? void 0 : value.type) ===
            'FunctionExpression',
          {
            reason: 'Expected a function as a function declaration value',
            description: null,
            loc: instr.value.loc,
            suggestions: null,
          }
        );
        return createFunctionDeclaration(
          instr.loc,
          genLvalue,
          value.params,
          value.body,
          value.generator,
          value.async
        );
      }
      case InstructionKind.Let: {
        CompilerError.invariant(instr.lvalue === null, {
          reason: `Const declaration cannot be referenced as an expression`,
          description: null,
          loc: instr.value.loc,
          suggestions: null,
        });
        return createVariableDeclaration(instr.loc, 'let', [
          t__namespace.variableDeclarator(codegenLValue(cx, lvalue), value),
        ]);
      }
      case InstructionKind.Reassign: {
        CompilerError.invariant(value !== null, {
          reason: 'Expected a value for reassignment',
          description: null,
          loc: instr.value.loc,
          suggestions: null,
        });
        const expr = t__namespace.assignmentExpression(
          '=',
          codegenLValue(cx, lvalue),
          value
        );
        if (instr.lvalue !== null) {
          if (instr.value.kind !== 'StoreContext') {
            cx.temp.set(instr.lvalue.identifier.declarationId, expr);
            return null;
          } else {
            const statement = codegenInstruction(cx, instr, expr);
            if (statement.type === 'EmptyStatement') {
              return null;
            }
            return statement;
          }
        } else {
          return createExpressionStatement(instr.loc, expr);
        }
      }
      case InstructionKind.Catch: {
        return t__namespace.emptyStatement();
      }
      case InstructionKind.HoistedLet:
      case InstructionKind.HoistedConst:
      case InstructionKind.HoistedFunction: {
        CompilerError.invariant(false, {
          reason: `Expected ${kind} to have been pruned in PruneHoistedContexts`,
          description: null,
          loc: instr.loc,
          suggestions: null,
        });
      }
      default: {
        assertExhaustive(kind, `Unexpected instruction kind \`${kind}\``);
      }
    }
  } else if (
    instr.value.kind === 'StartMemoize' ||
    instr.value.kind === 'FinishMemoize'
  ) {
    return null;
  } else if (instr.value.kind === 'Debugger') {
    return t__namespace.debuggerStatement();
  } else if (instr.value.kind === 'ObjectMethod') {
    CompilerError.invariant(instr.lvalue, {
      reason: 'Expected object methods to have a temp lvalue',
      loc: null,
      suggestions: null,
    });
    cx.objectMethods.set(instr.lvalue.identifier.id, instr.value);
    return null;
  } else {
    const value = codegenInstructionValue(cx, instr.value);
    const statement = codegenInstruction(cx, instr, value);
    if (statement.type === 'EmptyStatement') {
      return null;
    }
    return statement;
  }
}
function codegenForInit(cx, init) {
  if (init.kind === 'SequenceExpression') {
    for (const instr of init.instructions) {
      if (instr.value.kind === 'DeclareContext') {
        CompilerError.throwTodo({
          reason: `Support for loops where the index variable is a context variable`,
          loc: instr.loc,
          description:
            instr.value.lvalue.place.identifier.name != null
              ? `\`${instr.value.lvalue.place.identifier.name.value}\` is a context variable`
              : null,
          suggestions: null,
        });
      }
    }
    const body = codegenBlock(
      cx,
      init.instructions.map(instruction => ({
        kind: 'instruction',
        instruction: instruction,
      }))
    ).body;
    const declarators = [];
    let kind = 'const';
    body.forEach(instr => {
      CompilerError.invariant(
        instr.type === 'VariableDeclaration' &&
          (instr.kind === 'let' || instr.kind === 'const'),
        {
          reason: 'Expected a variable declaration',
          loc: init.loc,
          description: `Got ${instr.type}`,
          suggestions: null,
        }
      );
      if (instr.kind === 'let') {
        kind = 'let';
      }
      declarators.push(...instr.declarations);
    });
    CompilerError.invariant(declarators.length > 0, {
      reason: 'Expected a variable declaration',
      loc: init.loc,
      description: null,
      suggestions: null,
    });
    return t__namespace.variableDeclaration(kind, declarators);
  } else {
    return codegenInstructionValueToExpression(cx, init);
  }
}
function printDependencyComment(dependency) {
  const identifier = convertIdentifier(dependency.identifier);
  let name = identifier.name;
  if (dependency.path !== null) {
    for (const path of dependency.path) {
      name += `.${path.property}`;
    }
  }
  return name;
}
function printDelimitedCommentList(items, finalCompletion) {
  if (items.length === 2) {
    return items.join(` ${finalCompletion} `);
  } else if (items.length <= 1) {
    return items.join('');
  }
  let output = [];
  for (let i = 0; i < items.length; i++) {
    const item = items[i];
    if (i < items.length - 2) {
      output.push(`${item}, `);
    } else if (i === items.length - 2) {
      output.push(`${item}, ${finalCompletion} `);
    } else {
      output.push(item);
    }
  }
  return output.join('');
}
function codegenDependency(cx, dependency) {
  let object = convertIdentifier(dependency.identifier);
  if (dependency.path.length !== 0) {
    const hasOptional = dependency.path.some(path => path.optional);
    for (const path of dependency.path) {
      if (hasOptional) {
        object = t__namespace.optionalMemberExpression(
          object,
          t__namespace.identifier(path.property),
          false,
          path.optional
        );
      } else {
        object = t__namespace.memberExpression(
          object,
          t__namespace.identifier(path.property)
        );
      }
    }
  }
  return object;
}
function withLoc(fn) {
  return (loc, ...args) => {
    const node = fn(...args);
    if (loc != null && loc != GeneratedSource) {
      node.loc = loc;
    }
    return node;
  };
}
const createBinaryExpression = withLoc(t__namespace.binaryExpression);
const createExpressionStatement = withLoc(t__namespace.expressionStatement);
const createVariableDeclaration = withLoc(t__namespace.variableDeclaration);
const createFunctionDeclaration = withLoc(t__namespace.functionDeclaration);
const createTaggedTemplateExpression = withLoc(
  t__namespace.taggedTemplateExpression
);
const createLogicalExpression = withLoc(t__namespace.logicalExpression);
const createSequenceExpression = withLoc(t__namespace.sequenceExpression);
const createConditionalExpression = withLoc(t__namespace.conditionalExpression);
const createTemplateLiteral = withLoc(t__namespace.templateLiteral);
const createJsxNamespacedName = withLoc(t__namespace.jsxNamespacedName);
const createJsxElement = withLoc(t__namespace.jsxElement);
const createJsxAttribute = withLoc(t__namespace.jsxAttribute);
const createJsxIdentifier = withLoc(t__namespace.jsxIdentifier);
const createJsxExpressionContainer = withLoc(
  t__namespace.jsxExpressionContainer
);
const createJsxText = withLoc(t__namespace.jsxText);
const createJsxClosingElement = withLoc(t__namespace.jsxClosingElement);
const createJsxOpeningElement = withLoc(t__namespace.jsxOpeningElement);
const createStringLiteral = withLoc(t__namespace.stringLiteral);
function createHookGuard(guard, stmts, before, after) {
  function createHookGuardImpl(kind) {
    return t__namespace.expressionStatement(
      t__namespace.callExpression(
        t__namespace.identifier(guard.importSpecifierName),
        [t__namespace.numericLiteral(kind)]
      )
    );
  }
  return t__namespace.tryStatement(
    t__namespace.blockStatement([createHookGuardImpl(before), ...stmts]),
    null,
    t__namespace.blockStatement([createHookGuardImpl(after)])
  );
}
function createCallExpression(config, callee, args, loc, isHook) {
  const callExpr = t__namespace.callExpression(callee, args);
  if (loc != null && loc != GeneratedSource) {
    callExpr.loc = loc;
  }
  const hookGuard = config.enableEmitHookGuards;
  if (hookGuard != null && isHook) {
    const iife = t__namespace.functionExpression(
      null,
      [],
      t__namespace.blockStatement([
        createHookGuard(
          hookGuard,
          [t__namespace.returnStatement(callExpr)],
          GuardKind.AllowHook,
          GuardKind.DisallowHook
        ),
      ])
    );
    return t__namespace.callExpression(iife, []);
  } else {
    return callExpr;
  }
}
function codegenLabel(id) {
  return `bb${id}`;
}
function codegenInstruction(cx, instr, value) {
  if (t__namespace.isStatement(value)) {
    return value;
  }
  if (instr.lvalue === null) {
    return t__namespace.expressionStatement(convertValueToExpression(value));
  }
  if (instr.lvalue.identifier.name === null) {
    cx.temp.set(instr.lvalue.identifier.declarationId, value);
    return t__namespace.emptyStatement();
  } else {
    const expressionValue = convertValueToExpression(value);
    if (cx.hasDeclared(instr.lvalue.identifier)) {
      return createExpressionStatement(
        instr.loc,
        t__namespace.assignmentExpression(
          '=',
          convertIdentifier(instr.lvalue.identifier),
          expressionValue
        )
      );
    } else {
      return createVariableDeclaration(instr.loc, 'const', [
        t__namespace.variableDeclarator(
          convertIdentifier(instr.lvalue.identifier),
          expressionValue
        ),
      ]);
    }
  }
}
function convertValueToExpression(value) {
  if (value.type === 'JSXText') {
    return createStringLiteral(value.loc, value.value);
  }
  return value;
}
function codegenInstructionValueToExpression(cx, instrValue) {
  const value = codegenInstructionValue(cx, instrValue);
  return convertValueToExpression(value);
}
function codegenInstructionValue(cx, instrValue) {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  let value;
  switch (instrValue.kind) {
    case 'ArrayExpression': {
      const elements = instrValue.elements.map(element => {
        if (element.kind === 'Identifier') {
          return codegenPlaceToExpression(cx, element);
        } else if (element.kind === 'Spread') {
          return t__namespace.spreadElement(
            codegenPlaceToExpression(cx, element.place)
          );
        } else {
          return null;
        }
      });
      value = t__namespace.arrayExpression(elements);
      break;
    }
    case 'BinaryExpression': {
      const left = codegenPlaceToExpression(cx, instrValue.left);
      const right = codegenPlaceToExpression(cx, instrValue.right);
      value = createBinaryExpression(
        instrValue.loc,
        instrValue.operator,
        left,
        right
      );
      break;
    }
    case 'UnaryExpression': {
      value = t__namespace.unaryExpression(
        instrValue.operator,
        codegenPlaceToExpression(cx, instrValue.value)
      );
      break;
    }
    case 'Primitive': {
      value = codegenValue(cx, instrValue.loc, instrValue.value);
      break;
    }
    case 'CallExpression': {
      if (cx.env.config.enableForest) {
        const callee = codegenPlaceToExpression(cx, instrValue.callee);
        const args = instrValue.args.map(arg => codegenArgument(cx, arg));
        value = t__namespace.callExpression(callee, args);
        if (instrValue.typeArguments != null) {
          value.typeArguments = t__namespace.typeParameterInstantiation(
            instrValue.typeArguments
          );
        }
        break;
      }
      const isHook = getHookKind(cx.env, instrValue.callee.identifier) != null;
      const callee = codegenPlaceToExpression(cx, instrValue.callee);
      const args = instrValue.args.map(arg => codegenArgument(cx, arg));
      value = createCallExpression(
        cx.env.config,
        callee,
        args,
        instrValue.loc,
        isHook
      );
      break;
    }
    case 'OptionalExpression': {
      const optionalValue = codegenInstructionValueToExpression(
        cx,
        instrValue.value
      );
      switch (optionalValue.type) {
        case 'OptionalCallExpression':
        case 'CallExpression': {
          CompilerError.invariant(
            t__namespace.isExpression(optionalValue.callee),
            {
              reason: 'v8 intrinsics are validated during lowering',
              description: null,
              loc:
                (_a = optionalValue.callee.loc) !== null && _a !== void 0
                  ? _a
                  : null,
              suggestions: null,
            }
          );
          value = t__namespace.optionalCallExpression(
            optionalValue.callee,
            optionalValue.arguments,
            instrValue.optional
          );
          break;
        }
        case 'OptionalMemberExpression':
        case 'MemberExpression': {
          const property = optionalValue.property;
          CompilerError.invariant(t__namespace.isExpression(property), {
            reason: 'Private names are validated during lowering',
            description: null,
            loc: (_b = property.loc) !== null && _b !== void 0 ? _b : null,
            suggestions: null,
          });
          value = t__namespace.optionalMemberExpression(
            optionalValue.object,
            property,
            optionalValue.computed,
            instrValue.optional
          );
          break;
        }
        default: {
          CompilerError.invariant(false, {
            reason:
              'Expected an optional value to resolve to a call expression or member expression',
            description: `Got a \`${optionalValue.type}\``,
            loc: instrValue.loc,
            suggestions: null,
          });
        }
      }
      break;
    }
    case 'MethodCall': {
      const isHook =
        getHookKind(cx.env, instrValue.property.identifier) != null;
      const memberExpr = codegenPlaceToExpression(cx, instrValue.property);
      CompilerError.invariant(
        t__namespace.isMemberExpression(memberExpr) ||
          t__namespace.isOptionalMemberExpression(memberExpr),
        {
          reason:
            '[Codegen] Internal error: MethodCall::property must be an unpromoted + unmemoized MemberExpression. ' +
            `Got a \`${memberExpr.type}\``,
          description: null,
          loc: (_c = memberExpr.loc) !== null && _c !== void 0 ? _c : null,
          suggestions: null,
        }
      );
      CompilerError.invariant(
        t__namespace.isNodesEquivalent(
          memberExpr.object,
          codegenPlaceToExpression(cx, instrValue.receiver)
        ),
        {
          reason:
            '[Codegen] Internal error: Forget should always generate MethodCall::property ' +
            'as a MemberExpression of MethodCall::receiver',
          description: null,
          loc: (_d = memberExpr.loc) !== null && _d !== void 0 ? _d : null,
          suggestions: null,
        }
      );
      const args = instrValue.args.map(arg => codegenArgument(cx, arg));
      value = createCallExpression(
        cx.env.config,
        memberExpr,
        args,
        instrValue.loc,
        isHook
      );
      break;
    }
    case 'NewExpression': {
      const callee = codegenPlaceToExpression(cx, instrValue.callee);
      const args = instrValue.args.map(arg => codegenArgument(cx, arg));
      value = t__namespace.newExpression(callee, args);
      break;
    }
    case 'ObjectExpression': {
      const properties = [];
      for (const property of instrValue.properties) {
        if (property.kind === 'ObjectProperty') {
          const key = codegenObjectPropertyKey(cx, property.key);
          switch (property.type) {
            case 'property': {
              const value = codegenPlaceToExpression(cx, property.place);
              properties.push(
                t__namespace.objectProperty(
                  key,
                  value,
                  property.key.kind === 'computed',
                  key.type === 'Identifier' &&
                    value.type === 'Identifier' &&
                    value.name === key.name
                )
              );
              break;
            }
            case 'method': {
              const method = cx.objectMethods.get(property.place.identifier.id);
              CompilerError.invariant(method, {
                reason: 'Expected ObjectMethod instruction',
                loc: null,
                suggestions: null,
              });
              const loweredFunc = method.loweredFunc;
              const reactiveFunction = buildReactiveFunction(loweredFunc.func);
              pruneUnusedLabels(reactiveFunction);
              pruneUnusedLValues(reactiveFunction);
              const fn = codegenReactiveFunction(
                new Context$1(
                  cx.env,
                  (_e = reactiveFunction.id) !== null && _e !== void 0
                    ? _e
                    : '[[ anonymous ]]',
                  cx.uniqueIdentifiers,
                  cx.fbtOperands,
                  cx.temp
                ),
                reactiveFunction
              ).unwrap();
              const babelNode = t__namespace.objectMethod(
                'method',
                key,
                fn.params,
                fn.body,
                false
              );
              babelNode.async = fn.async;
              babelNode.generator = fn.generator;
              properties.push(babelNode);
              break;
            }
            default:
              assertExhaustive(
                property.type,
                `Unexpected property type: ${property.type}`
              );
          }
        } else {
          properties.push(
            t__namespace.spreadElement(
              codegenPlaceToExpression(cx, property.place)
            )
          );
        }
      }
      value = t__namespace.objectExpression(properties);
      break;
    }
    case 'JSXText': {
      value = createJsxText(instrValue.loc, instrValue.value);
      break;
    }
    case 'JsxExpression': {
      const attributes = [];
      for (const attribute of instrValue.props) {
        attributes.push(codegenJsxAttribute(cx, attribute));
      }
      let tagValue =
        instrValue.tag.kind === 'Identifier'
          ? codegenPlaceToExpression(cx, instrValue.tag)
          : t__namespace.stringLiteral(instrValue.tag.name);
      let tag;
      if (tagValue.type === 'Identifier') {
        tag = createJsxIdentifier(instrValue.tag.loc, tagValue.name);
      } else if (tagValue.type === 'MemberExpression') {
        tag = convertMemberExpressionToJsx(tagValue);
      } else {
        CompilerError.invariant(tagValue.type === 'StringLiteral', {
          reason: `Expected JSX tag to be an identifier or string, got \`${tagValue.type}\``,
          description: null,
          loc: (_f = tagValue.loc) !== null && _f !== void 0 ? _f : null,
          suggestions: null,
        });
        if (tagValue.value.indexOf(':') >= 0) {
          const [namespace, name] = tagValue.value.split(':', 2);
          tag = createJsxNamespacedName(
            instrValue.tag.loc,
            createJsxIdentifier(instrValue.tag.loc, namespace),
            createJsxIdentifier(instrValue.tag.loc, name)
          );
        } else {
          tag = createJsxIdentifier(instrValue.loc, tagValue.value);
        }
      }
      let children;
      if (
        tagValue.type === 'StringLiteral' &&
        SINGLE_CHILD_FBT_TAGS.has(tagValue.value)
      ) {
        CompilerError.invariant(instrValue.children != null, {
          loc: instrValue.loc,
          reason: 'Expected fbt element to have children',
          suggestions: null,
          description: null,
        });
        children = instrValue.children.map(child =>
          codegenJsxFbtChildElement(cx, child)
        );
      } else {
        children =
          instrValue.children !== null
            ? instrValue.children.map(child => codegenJsxElement(cx, child))
            : [];
      }
      value = createJsxElement(
        instrValue.loc,
        createJsxOpeningElement(
          instrValue.openingLoc,
          tag,
          attributes,
          instrValue.children === null
        ),
        instrValue.children !== null
          ? createJsxClosingElement(instrValue.closingLoc, tag)
          : null,
        children,
        instrValue.children === null
      );
      break;
    }
    case 'JsxFragment': {
      value = t__namespace.jsxFragment(
        t__namespace.jsxOpeningFragment(),
        t__namespace.jsxClosingFragment(),
        instrValue.children.map(child => codegenJsxElement(cx, child))
      );
      break;
    }
    case 'UnsupportedNode': {
      const node = instrValue.node;
      if (!t__namespace.isExpression(node)) {
        return node;
      }
      value = node;
      break;
    }
    case 'PropertyStore': {
      value = t__namespace.assignmentExpression(
        '=',
        t__namespace.memberExpression(
          codegenPlaceToExpression(cx, instrValue.object),
          t__namespace.identifier(instrValue.property)
        ),
        codegenPlaceToExpression(cx, instrValue.value)
      );
      break;
    }
    case 'PropertyLoad': {
      const object = codegenPlaceToExpression(cx, instrValue.object);
      value = t__namespace.memberExpression(
        object,
        t__namespace.identifier(instrValue.property),
        undefined
      );
      break;
    }
    case 'PropertyDelete': {
      value = t__namespace.unaryExpression(
        'delete',
        t__namespace.memberExpression(
          codegenPlaceToExpression(cx, instrValue.object),
          t__namespace.identifier(instrValue.property)
        )
      );
      break;
    }
    case 'ComputedStore': {
      value = t__namespace.assignmentExpression(
        '=',
        t__namespace.memberExpression(
          codegenPlaceToExpression(cx, instrValue.object),
          codegenPlaceToExpression(cx, instrValue.property),
          true
        ),
        codegenPlaceToExpression(cx, instrValue.value)
      );
      break;
    }
    case 'ComputedLoad': {
      const object = codegenPlaceToExpression(cx, instrValue.object);
      const property = codegenPlaceToExpression(cx, instrValue.property);
      value = t__namespace.memberExpression(object, property, true);
      break;
    }
    case 'ComputedDelete': {
      value = t__namespace.unaryExpression(
        'delete',
        t__namespace.memberExpression(
          codegenPlaceToExpression(cx, instrValue.object),
          codegenPlaceToExpression(cx, instrValue.property),
          true
        )
      );
      break;
    }
    case 'LoadLocal':
    case 'LoadContext': {
      value = codegenPlaceToExpression(cx, instrValue.place);
      break;
    }
    case 'FunctionExpression': {
      const loweredFunc = instrValue.loweredFunc.func;
      const reactiveFunction = buildReactiveFunction(loweredFunc);
      pruneUnusedLabels(reactiveFunction);
      pruneUnusedLValues(reactiveFunction);
      pruneHoistedContexts(reactiveFunction);
      const fn = codegenReactiveFunction(
        new Context$1(
          cx.env,
          (_g = reactiveFunction.id) !== null && _g !== void 0
            ? _g
            : '[[ anonymous ]]',
          cx.uniqueIdentifiers,
          cx.fbtOperands,
          cx.temp
        ),
        reactiveFunction
      ).unwrap();
      if (instrValue.type === 'ArrowFunctionExpression') {
        let body = fn.body;
        if (body.body.length === 1 && loweredFunc.directives.length == 0) {
          const stmt = body.body[0];
          if (stmt.type === 'ReturnStatement' && stmt.argument != null) {
            body = stmt.argument;
          }
        }
        value = t__namespace.arrowFunctionExpression(fn.params, body, fn.async);
      } else {
        value = t__namespace.functionExpression(
          (_h = fn.id) !== null && _h !== void 0
            ? _h
            : instrValue.name != null
              ? t__namespace.identifier(instrValue.name)
              : null,
          fn.params,
          fn.body,
          fn.generator,
          fn.async
        );
      }
      break;
    }
    case 'TaggedTemplateExpression': {
      value = createTaggedTemplateExpression(
        instrValue.loc,
        codegenPlaceToExpression(cx, instrValue.tag),
        t__namespace.templateLiteral(
          [t__namespace.templateElement(instrValue.value)],
          []
        )
      );
      break;
    }
    case 'TypeCastExpression': {
      if (t__namespace.isTSType(instrValue.typeAnnotation)) {
        value = t__namespace.tsAsExpression(
          codegenPlaceToExpression(cx, instrValue.value),
          instrValue.typeAnnotation
        );
      } else {
        value = t__namespace.typeCastExpression(
          codegenPlaceToExpression(cx, instrValue.value),
          t__namespace.typeAnnotation(instrValue.typeAnnotation)
        );
      }
      break;
    }
    case 'LogicalExpression': {
      value = createLogicalExpression(
        instrValue.loc,
        instrValue.operator,
        codegenInstructionValueToExpression(cx, instrValue.left),
        codegenInstructionValueToExpression(cx, instrValue.right)
      );
      break;
    }
    case 'ConditionalExpression': {
      value = createConditionalExpression(
        instrValue.loc,
        codegenInstructionValueToExpression(cx, instrValue.test),
        codegenInstructionValueToExpression(cx, instrValue.consequent),
        codegenInstructionValueToExpression(cx, instrValue.alternate)
      );
      break;
    }
    case 'SequenceExpression': {
      const body = codegenBlockNoReset(
        cx,
        instrValue.instructions.map(instruction => ({
          kind: 'instruction',
          instruction: instruction,
        }))
      ).body;
      const expressions = body.map(stmt => {
        var _a, _b;
        if (stmt.type === 'ExpressionStatement') {
          return stmt.expression;
        } else {
          if (t__namespace.isVariableDeclaration(stmt)) {
            const declarator = stmt.declarations[0];
            cx.errors.push({
              reason: `(CodegenReactiveFunction::codegenInstructionValue) Cannot declare variables in a value block, tried to declare '${declarator.id.name}'`,
              severity: exports.ErrorSeverity.Todo,
              loc: (_a = declarator.loc) !== null && _a !== void 0 ? _a : null,
              suggestions: null,
            });
            return t__namespace.stringLiteral(`TODO handle ${declarator.id}`);
          } else {
            cx.errors.push({
              reason: `(CodegenReactiveFunction::codegenInstructionValue) Handle conversion of ${stmt.type} to expression`,
              severity: exports.ErrorSeverity.Todo,
              loc: (_b = stmt.loc) !== null && _b !== void 0 ? _b : null,
              suggestions: null,
            });
            return t__namespace.stringLiteral(`TODO handle ${stmt.type}`);
          }
        }
      });
      if (expressions.length === 0) {
        value = codegenInstructionValueToExpression(cx, instrValue.value);
      } else {
        value = createSequenceExpression(instrValue.loc, [
          ...expressions,
          codegenInstructionValueToExpression(cx, instrValue.value),
        ]);
      }
      break;
    }
    case 'TemplateLiteral': {
      value = createTemplateLiteral(
        instrValue.loc,
        instrValue.quasis.map(q => t__namespace.templateElement(q)),
        instrValue.subexprs.map(p => codegenPlaceToExpression(cx, p))
      );
      break;
    }
    case 'LoadGlobal': {
      value = t__namespace.identifier(instrValue.binding.name);
      break;
    }
    case 'RegExpLiteral': {
      value = t__namespace.regExpLiteral(instrValue.pattern, instrValue.flags);
      break;
    }
    case 'MetaProperty': {
      value = t__namespace.metaProperty(
        t__namespace.identifier(instrValue.meta),
        t__namespace.identifier(instrValue.property)
      );
      break;
    }
    case 'Await': {
      value = t__namespace.awaitExpression(
        codegenPlaceToExpression(cx, instrValue.value)
      );
      break;
    }
    case 'GetIterator': {
      value = codegenPlaceToExpression(cx, instrValue.collection);
      break;
    }
    case 'IteratorNext': {
      value = codegenPlaceToExpression(cx, instrValue.iterator);
      break;
    }
    case 'NextPropertyOf': {
      value = codegenPlaceToExpression(cx, instrValue.value);
      break;
    }
    case 'PostfixUpdate': {
      value = t__namespace.updateExpression(
        instrValue.operation,
        codegenPlaceToExpression(cx, instrValue.lvalue),
        false
      );
      break;
    }
    case 'PrefixUpdate': {
      value = t__namespace.updateExpression(
        instrValue.operation,
        codegenPlaceToExpression(cx, instrValue.lvalue),
        true
      );
      break;
    }
    case 'StoreLocal': {
      CompilerError.invariant(
        instrValue.lvalue.kind === InstructionKind.Reassign,
        {
          reason: `Unexpected StoreLocal in codegenInstructionValue`,
          description: null,
          loc: instrValue.loc,
          suggestions: null,
        }
      );
      value = t__namespace.assignmentExpression(
        '=',
        codegenLValue(cx, instrValue.lvalue.place),
        codegenPlaceToExpression(cx, instrValue.value)
      );
      break;
    }
    case 'StoreGlobal': {
      value = t__namespace.assignmentExpression(
        '=',
        t__namespace.identifier(instrValue.name),
        codegenPlaceToExpression(cx, instrValue.value)
      );
      break;
    }
    case 'ReactiveFunctionValue':
    case 'StartMemoize':
    case 'FinishMemoize':
    case 'Debugger':
    case 'DeclareLocal':
    case 'DeclareContext':
    case 'Destructure':
    case 'ObjectMethod':
    case 'StoreContext': {
      CompilerError.invariant(false, {
        reason: `Unexpected ${instrValue.kind} in codegenInstructionValue`,
        description: null,
        loc: instrValue.loc,
        suggestions: null,
      });
    }
    default: {
      assertExhaustive(
        instrValue,
        `Unexpected instruction value kind \`${instrValue.kind}\``
      );
    }
  }
  return value;
}
const STRING_REQUIRES_EXPR_CONTAINER_PATTERN =
  /[\u{0000}-\u{001F}\u{007F}\u{0080}-\u{FFFF}]|"/u;
function codegenJsxAttribute(cx, attribute) {
  switch (attribute.kind) {
    case 'JsxAttribute': {
      let propName;
      if (attribute.name.indexOf(':') === -1) {
        propName = createJsxIdentifier(attribute.place.loc, attribute.name);
      } else {
        const [namespace, name] = attribute.name.split(':', 2);
        propName = createJsxNamespacedName(
          attribute.place.loc,
          createJsxIdentifier(attribute.place.loc, namespace),
          createJsxIdentifier(attribute.place.loc, name)
        );
      }
      const innerValue = codegenPlaceToExpression(cx, attribute.place);
      let value;
      switch (innerValue.type) {
        case 'StringLiteral': {
          value = innerValue;
          if (
            STRING_REQUIRES_EXPR_CONTAINER_PATTERN.test(value.value) &&
            !cx.fbtOperands.has(attribute.place.identifier.id)
          ) {
            value = createJsxExpressionContainer(value.loc, value);
          }
          break;
        }
        default: {
          value = createJsxExpressionContainer(attribute.place.loc, innerValue);
          break;
        }
      }
      return createJsxAttribute(attribute.place.loc, propName, value);
    }
    case 'JsxSpreadAttribute': {
      return t__namespace.jsxSpreadAttribute(
        codegenPlaceToExpression(cx, attribute.argument)
      );
    }
    default: {
      assertExhaustive(
        attribute,
        `Unexpected attribute kind \`${attribute.kind}\``
      );
    }
  }
}
const JSX_TEXT_CHILD_REQUIRES_EXPR_CONTAINER_PATTERN = /[<>&]/;
function codegenJsxElement(cx, place) {
  const value = codegenPlace(cx, place);
  switch (value.type) {
    case 'JSXText': {
      if (JSX_TEXT_CHILD_REQUIRES_EXPR_CONTAINER_PATTERN.test(value.value)) {
        return createJsxExpressionContainer(
          place.loc,
          createStringLiteral(place.loc, value.value)
        );
      }
      return createJsxText(place.loc, value.value);
    }
    case 'JSXElement':
    case 'JSXFragment': {
      return value;
    }
    default: {
      return createJsxExpressionContainer(place.loc, value);
    }
  }
}
function codegenJsxFbtChildElement(cx, place) {
  const value = codegenPlace(cx, place);
  switch (value.type) {
    case 'JSXText':
    case 'JSXElement': {
      return value;
    }
    default: {
      return createJsxExpressionContainer(place.loc, value);
    }
  }
}
function convertMemberExpressionToJsx(expr) {
  var _a, _b;
  CompilerError.invariant(expr.property.type === 'Identifier', {
    reason: 'Expected JSX member expression property to be a string',
    description: null,
    loc: (_a = expr.loc) !== null && _a !== void 0 ? _a : null,
    suggestions: null,
  });
  const property = t__namespace.jsxIdentifier(expr.property.name);
  if (expr.object.type === 'Identifier') {
    return t__namespace.jsxMemberExpression(
      t__namespace.jsxIdentifier(expr.object.name),
      property
    );
  } else {
    CompilerError.invariant(expr.object.type === 'MemberExpression', {
      reason:
        'Expected JSX member expression to be an identifier or nested member expression',
      description: null,
      loc: (_b = expr.object.loc) !== null && _b !== void 0 ? _b : null,
      suggestions: null,
    });
    const object = convertMemberExpressionToJsx(expr.object);
    return t__namespace.jsxMemberExpression(object, property);
  }
}
function codegenObjectPropertyKey(cx, key) {
  switch (key.kind) {
    case 'string': {
      return t__namespace.stringLiteral(key.name);
    }
    case 'identifier': {
      return t__namespace.identifier(key.name);
    }
    case 'computed': {
      const expr = codegenPlace(cx, key.name);
      CompilerError.invariant(t__namespace.isExpression(expr), {
        reason: 'Expected object property key to be an expression',
        description: null,
        loc: key.name.loc,
        suggestions: null,
      });
      return expr;
    }
  }
}
function codegenArrayPattern(cx, pattern) {
  const hasHoles = !pattern.items.every(e => e.kind !== 'Hole');
  if (hasHoles) {
    const result = t__namespace.arrayPattern([]);
    for (const item of pattern.items) {
      if (item.kind === 'Hole') {
        result.elements.push(null);
      } else {
        result.elements.push(codegenLValue(cx, item));
      }
    }
    return result;
  } else {
    return t__namespace.arrayPattern(
      pattern.items.map(item => {
        if (item.kind === 'Hole') {
          return null;
        }
        return codegenLValue(cx, item);
      })
    );
  }
}
function codegenLValue(cx, pattern) {
  switch (pattern.kind) {
    case 'ArrayPattern': {
      return codegenArrayPattern(cx, pattern);
    }
    case 'ObjectPattern': {
      return t__namespace.objectPattern(
        pattern.properties.map(property => {
          if (property.kind === 'ObjectProperty') {
            const key = codegenObjectPropertyKey(cx, property.key);
            const value = codegenLValue(cx, property.place);
            return t__namespace.objectProperty(
              key,
              value,
              property.key.kind === 'computed',
              key.type === 'Identifier' &&
                value.type === 'Identifier' &&
                value.name === key.name
            );
          } else {
            return t__namespace.restElement(codegenLValue(cx, property.place));
          }
        })
      );
    }
    case 'Spread': {
      return t__namespace.restElement(codegenLValue(cx, pattern.place));
    }
    case 'Identifier': {
      return convertIdentifier(pattern.identifier);
    }
    default: {
      assertExhaustive(pattern, `Unexpected pattern kind \`${pattern.kind}\``);
    }
  }
}
function codegenValue(cx, loc, value) {
  if (typeof value === 'number') {
    return t__namespace.numericLiteral(value);
  } else if (typeof value === 'boolean') {
    return t__namespace.booleanLiteral(value);
  } else if (typeof value === 'string') {
    return createStringLiteral(loc, value);
  } else if (value === null) {
    return t__namespace.nullLiteral();
  } else if (value === undefined) {
    return t__namespace.identifier('undefined');
  } else {
    assertExhaustive(value, 'Unexpected primitive value kind');
  }
}
function codegenArgument(cx, arg) {
  if (arg.kind === 'Identifier') {
    return codegenPlaceToExpression(cx, arg);
  } else {
    return t__namespace.spreadElement(codegenPlaceToExpression(cx, arg.place));
  }
}
function codegenPlaceToExpression(cx, place) {
  const value = codegenPlace(cx, place);
  return convertValueToExpression(value);
}
function codegenPlace(cx, place) {
  let tmp = cx.temp.get(place.identifier.declarationId);
  if (tmp != null) {
    return tmp;
  }
  CompilerError.invariant(place.identifier.name !== null || tmp !== undefined, {
    reason: `[Codegen] No value found for temporary`,
    description: `Value for '${printPlace(place)}' was not set in the codegen context`,
    loc: place.loc,
    suggestions: null,
  });
  const identifier = convertIdentifier(place.identifier);
  identifier.loc = place.loc;
  return identifier;
}
function convertIdentifier(identifier) {
  CompilerError.invariant(
    identifier.name !== null && identifier.name.kind === 'named',
    {
      reason: `Expected temporaries to be promoted to named identifiers in an earlier pass`,
      loc: GeneratedSource,
      description: `identifier ${identifier.id} is unnamed`,
      suggestions: null,
    }
  );
  return t__namespace.identifier(identifier.name.value);
}
function compareScopeDependency(a, b) {
  var _a, _b;
  CompilerError.invariant(
    ((_a = a.identifier.name) === null || _a === void 0 ? void 0 : _a.kind) ===
      'named' &&
      ((_b = b.identifier.name) === null || _b === void 0
        ? void 0
        : _b.kind) === 'named',
    {
      reason: '[Codegen] Expected named identifier for dependency',
      loc: a.identifier.loc,
    }
  );
  const aName = [
    a.identifier.name.value,
    ...a.path.map(entry => `${entry.optional ? '?' : ''}${entry.property}`),
  ].join('.');
  const bName = [
    b.identifier.name.value,
    ...b.path.map(entry => `${entry.optional ? '?' : ''}${entry.property}`),
  ].join('.');
  if (aName < bName) return -1;
  else if (aName > bName) return 1;
  else return 0;
}
function compareScopeDeclaration(a, b) {
  var _a, _b;
  CompilerError.invariant(
    ((_a = a.identifier.name) === null || _a === void 0 ? void 0 : _a.kind) ===
      'named' &&
      ((_b = b.identifier.name) === null || _b === void 0
        ? void 0
        : _b.kind) === 'named',
    {
      reason: '[Codegen] Expected named identifier for declaration',
      loc: a.identifier.loc,
    }
  );
  const aName = a.identifier.name.value;
  const bName = b.identifier.name.value;
  if (aName < bName) return -1;
  else if (aName > bName) return 1;
  else return 0;
}
function extractScopeDeclarationsFromDestructuring(fn) {
  const state = new State$1(fn.env);
  visitReactiveFunction(fn, new Visitor$9(), state);
}
let State$1 = class State {
  constructor(env) {
    this.declared = new Set();
    this.env = env;
  }
};
let Visitor$9 = class Visitor extends ReactiveFunctionTransform {
  visitScope(scope, state) {
    for (const [, declaration] of scope.scope.declarations) {
      state.declared.add(declaration.identifier.declarationId);
    }
    this.traverseScope(scope, state);
  }
  transformInstruction(instruction, state) {
    this.visitInstruction(instruction, state);
    if (instruction.value.kind === 'Destructure') {
      const transformed = transformDestructuring(
        state,
        instruction,
        instruction.value
      );
      if (transformed) {
        return {
          kind: 'replace-many',
          value: transformed.map(instruction => ({
            kind: 'instruction',
            instruction: instruction,
          })),
        };
      }
    }
    return {kind: 'keep'};
  }
};
function transformDestructuring(state, instr, destructure) {
  let reassigned = new Set();
  let hasDeclaration = false;
  for (const place of eachPatternOperand(destructure.lvalue.pattern)) {
    const isDeclared = state.declared.has(place.identifier.declarationId);
    if (isDeclared) {
      reassigned.add(place.identifier.id);
    }
    hasDeclaration || (hasDeclaration = !isDeclared);
  }
  if (reassigned.size === 0 || !hasDeclaration) {
    return null;
  }
  const instructions = [];
  const renamed = new Map();
  mapPatternOperands(destructure.lvalue.pattern, place => {
    if (!reassigned.has(place.identifier.id)) {
      return place;
    }
    const temporary = clonePlaceToTemporary(state.env, place);
    promoteTemporary(temporary.identifier);
    renamed.set(place, temporary);
    return temporary;
  });
  instructions.push(instr);
  for (const [original, temporary] of renamed) {
    instructions.push({
      id: instr.id,
      lvalue: null,
      value: {
        kind: 'StoreLocal',
        lvalue: {kind: InstructionKind.Reassign, place: original},
        value: temporary,
        type: null,
        loc: destructure.loc,
      },
      loc: instr.loc,
    });
  }
  return instructions;
}
function mergeReactiveScopesThatInvalidateTogether(fn) {
  const lastUsageVisitor = new FindLastUsageVisitor();
  visitReactiveFunction(fn, lastUsageVisitor, undefined);
  visitReactiveFunction(fn, new Transform$4(lastUsageVisitor.lastUsage), null);
}
function log$1(msg) {}
class FindLastUsageVisitor extends ReactiveFunctionVisitor {
  constructor() {
    super(...arguments);
    this.lastUsage = new Map();
  }
  visitPlace(id, place, _state) {
    const previousUsage = this.lastUsage.get(place.identifier.declarationId);
    const lastUsage =
      previousUsage !== undefined
        ? makeInstructionId(Math.max(previousUsage, id))
        : id;
    this.lastUsage.set(place.identifier.declarationId, lastUsage);
  }
}
let Transform$4 = class Transform extends ReactiveFunctionTransform {
  constructor(lastUsage) {
    super();
    this.lastUsage = lastUsage;
  }
  transformScope(scopeBlock, state) {
    this.visitScope(scopeBlock, scopeBlock.scope.dependencies);
    if (
      state !== null &&
      areEqualDependencies(state, scopeBlock.scope.dependencies)
    ) {
      return {kind: 'replace-many', value: scopeBlock.instructions};
    } else {
      return {kind: 'keep'};
    }
  }
  visitBlock(block, state) {
    this.traverseBlock(block, state);
    let current = null;
    const merged = [];
    function reset() {
      CompilerError.invariant(current !== null, {
        loc: null,
        reason:
          'MergeConsecutiveScopes: expected current scope to be non-null if reset()',
        suggestions: null,
        description: null,
      });
      if (current.to > current.from + 1) {
        merged.push(current);
      }
      current = null;
    }
    for (let i = 0; i < block.length; i++) {
      const instr = block[i];
      switch (instr.kind) {
        case 'terminal': {
          if (current !== null) {
            log$1(
              `Reset scope @${current.block.scope.id} from terminal [${instr.terminal.id}]`
            );
            reset();
          }
          break;
        }
        case 'pruned-scope': {
          if (current !== null) {
            log$1(
              `Reset scope @${current.block.scope.id} from pruned scope @${instr.scope.id}`
            );
            reset();
          }
          break;
        }
        case 'instruction': {
          switch (instr.instruction.value.kind) {
            case 'BinaryExpression':
            case 'ComputedLoad':
            case 'JSXText':
            case 'LoadGlobal':
            case 'LoadLocal':
            case 'Primitive':
            case 'PropertyLoad':
            case 'TemplateLiteral':
            case 'UnaryExpression': {
              if (current !== null && instr.instruction.lvalue !== null) {
                current.lvalues.add(
                  instr.instruction.lvalue.identifier.declarationId
                );
              }
              break;
            }
            case 'StoreLocal': {
              if (current !== null) {
                if (
                  instr.instruction.value.lvalue.kind === InstructionKind.Const
                ) {
                  for (const lvalue of eachInstructionLValue(
                    instr.instruction
                  )) {
                    current.lvalues.add(lvalue.identifier.declarationId);
                  }
                } else {
                  log$1(
                    `Reset scope @${current.block.scope.id} from StoreLocal in [${instr.instruction.id}]`
                  );
                  reset();
                }
              }
              break;
            }
            default: {
              if (current !== null) {
                log$1(
                  `Reset scope @${current.block.scope.id} from instruction [${instr.instruction.id}]`
                );
                reset();
              }
            }
          }
          break;
        }
        case 'scope': {
          if (
            current !== null &&
            canMergeScopes(current.block, instr) &&
            areLValuesLastUsedByScope(
              instr.scope,
              current.lvalues,
              this.lastUsage
            )
          ) {
            log$1(
              `Can merge scope @${current.block.scope.id} with @${instr.scope.id}`
            );
            current.block.scope.range.end = makeInstructionId(
              Math.max(current.block.scope.range.end, instr.scope.range.end)
            );
            for (const [key, value] of instr.scope.declarations) {
              current.block.scope.declarations.set(key, value);
            }
            updateScopeDeclarations(current.block.scope, this.lastUsage);
            current.to = i + 1;
            current.lvalues.clear();
            if (!scopeIsEligibleForMerging(instr)) {
              log$1(
                `  but scope @${instr.scope.id} doesnt guaranteed invalidate so it cannot merge further`
              );
              reset();
            }
          } else {
            if (current !== null) {
              log$1(
                `Reset scope @${current.block.scope.id}, not mergeable with subsequent scope @${instr.scope.id}`
              );
              reset();
            }
            if (scopeIsEligibleForMerging(instr)) {
              current = {block: instr, from: i, to: i + 1, lvalues: new Set()};
            } else {
              log$1(
                `scope @${instr.scope.id} doesnt guaranteed invalidate so it cannot merge further`
              );
            }
          }
          break;
        }
        default: {
          assertExhaustive(
            instr,
            `Unexpected instruction kind \`${instr.kind}\``
          );
        }
      }
    }
    if (current !== null) {
      reset();
    }
    if (merged.length) {
      log$1(`merged ${merged.length} scopes:`);
      for (const entry of merged) {
        log$1(
          printReactiveScopeSummary(entry.block.scope) +
            ` from=${entry.from} to=${entry.to}`
        );
      }
    }
    if (merged.length === 0) {
      return;
    }
    const nextInstructions = [];
    let index = 0;
    for (const entry of merged) {
      if (index < entry.from) {
        nextInstructions.push(...block.slice(index, entry.from));
        index = entry.from;
      }
      const mergedScope = block[entry.from];
      CompilerError.invariant(mergedScope.kind === 'scope', {
        loc: null,
        reason:
          'MergeConsecutiveScopes: Expected scope starting index to be a scope',
        description: null,
        suggestions: null,
      });
      nextInstructions.push(mergedScope);
      index++;
      while (index < entry.to) {
        const instr = block[index++];
        if (instr.kind === 'scope') {
          mergedScope.instructions.push(...instr.instructions);
          mergedScope.scope.merged.add(instr.scope.id);
        } else {
          mergedScope.instructions.push(instr);
        }
      }
    }
    while (index < block.length) {
      nextInstructions.push(block[index++]);
    }
    block.length = 0;
    block.push(...nextInstructions);
  }
};
function updateScopeDeclarations(scope, lastUsage) {
  for (const [id, decl] of scope.declarations) {
    const lastUsedAt = lastUsage.get(decl.identifier.declarationId);
    if (lastUsedAt < scope.range.end) {
      scope.declarations.delete(id);
    }
  }
}
function areLValuesLastUsedByScope(scope, lvalues, lastUsage) {
  for (const lvalue of lvalues) {
    const lastUsedAt = lastUsage.get(lvalue);
    if (lastUsedAt >= scope.range.end) {
      log$1(`  lvalue ${lvalue} used after scope @${scope.id}, cannot merge`);
      return false;
    }
  }
  return true;
}
function canMergeScopes(current, next) {
  if (
    current.scope.reassignments.size !== 0 ||
    next.scope.reassignments.size !== 0
  ) {
    return false;
  }
  if (
    areEqualDependencies(current.scope.dependencies, next.scope.dependencies)
  ) {
    return true;
  }
  if (
    areEqualDependencies(
      new Set(
        [...current.scope.declarations.values()].map(declaration => ({
          identifier: declaration.identifier,
          path: [],
        }))
      ),
      next.scope.dependencies
    ) ||
    (next.scope.dependencies.size !== 0 &&
      [...next.scope.dependencies].every(
        dep =>
          isAlwaysInvalidatingType(dep.identifier.type) &&
          Iterable_some(
            current.scope.declarations.values(),
            decl =>
              decl.identifier.declarationId === dep.identifier.declarationId
          )
      ))
  ) {
    return true;
  }
  log$1(`  ${printReactiveScopeSummary(current.scope)}`);
  log$1(`  ${printReactiveScopeSummary(next.scope)}`);
  return false;
}
function isAlwaysInvalidatingType(type) {
  switch (type.kind) {
    case 'Object': {
      switch (type.shapeId) {
        case BuiltInArrayId:
        case BuiltInObjectId:
        case BuiltInFunctionId:
        case BuiltInJsxId: {
          return true;
        }
      }
      break;
    }
    case 'Function': {
      return true;
    }
  }
  return false;
}
function areEqualDependencies(a, b) {
  if (a.size !== b.size) {
    return false;
  }
  for (const aValue of a) {
    let found = false;
    for (const bValue of b) {
      if (
        aValue.identifier.declarationId === bValue.identifier.declarationId &&
        areEqualPaths(aValue.path, bValue.path)
      ) {
        found = true;
        break;
      }
    }
    if (!found) {
      return false;
    }
  }
  return true;
}
function scopeIsEligibleForMerging(scopeBlock) {
  if (scopeBlock.scope.dependencies.size === 0) {
    return true;
  }
  return [...scopeBlock.scope.declarations].some(([, decl]) =>
    isAlwaysInvalidatingType(decl.identifier.type)
  );
}
var _PromoteInterposedTemporaries_promotable,
  _PromoteInterposedTemporaries_consts,
  _PromoteInterposedTemporaries_globals;
class PromoteTemporaries extends ReactiveFunctionVisitor {
  visitScope(scopeBlock, state) {
    for (const dep of scopeBlock.scope.dependencies) {
      const {identifier: identifier} = dep;
      if (identifier.name == null) {
        promoteIdentifier(identifier, state);
      }
    }
    for (const [, declaration] of scopeBlock.scope.declarations) {
      if (declaration.identifier.name == null) {
        promoteIdentifier(declaration.identifier, state);
      }
    }
    this.traverseScope(scopeBlock, state);
  }
  visitPrunedScope(scopeBlock, state) {
    var _a;
    for (const [, declaration] of scopeBlock.scope.declarations) {
      if (
        declaration.identifier.name == null &&
        ((_a = state.pruned.get(declaration.identifier.declarationId)) ===
          null || _a === void 0
          ? void 0
          : _a.usedOutsideScope) === true
      ) {
        promoteIdentifier(declaration.identifier, state);
      }
    }
    this.traversePrunedScope(scopeBlock, state);
  }
  visitParam(place, state) {
    if (place.identifier.name === null) {
      promoteIdentifier(place.identifier, state);
    }
  }
  visitValue(id, value, state) {
    this.traverseValue(id, value, state);
    if (value.kind === 'FunctionExpression' || value.kind === 'ObjectMethod') {
      this.visitHirFunction(value.loweredFunc.func, state);
    }
  }
  visitReactiveFunctionValue(_id, _dependencies, fn, state) {
    for (const operand of fn.params) {
      const place = operand.kind === 'Identifier' ? operand : operand.place;
      if (place.identifier.name === null) {
        promoteIdentifier(place.identifier, state);
      }
    }
    visitReactiveFunction(fn, this, state);
  }
}
class PromoteAllInstancedOfPromotedTemporaries extends ReactiveFunctionVisitor {
  visitPlace(_id, place, state) {
    if (
      place.identifier.name === null &&
      state.promoted.has(place.identifier.declarationId)
    ) {
      promoteIdentifier(place.identifier, state);
    }
  }
  visitLValue(_id, _lvalue, _state) {
    this.visitPlace(_id, _lvalue, _state);
  }
  traverseScopeIdentifiers(scope, state) {
    for (const [, decl] of scope.declarations) {
      if (
        decl.identifier.name === null &&
        state.promoted.has(decl.identifier.declarationId)
      ) {
        promoteIdentifier(decl.identifier, state);
      }
    }
    for (const dep of scope.dependencies) {
      if (
        dep.identifier.name === null &&
        state.promoted.has(dep.identifier.declarationId)
      ) {
        promoteIdentifier(dep.identifier, state);
      }
    }
    for (const reassignment of scope.reassignments) {
      if (
        reassignment.name === null &&
        state.promoted.has(reassignment.declarationId)
      ) {
        promoteIdentifier(reassignment, state);
      }
    }
  }
  visitScope(scope, state) {
    this.traverseScope(scope, state);
    this.traverseScopeIdentifiers(scope.scope, state);
  }
  visitPrunedScope(scopeBlock, state) {
    this.traversePrunedScope(scopeBlock, state);
    this.traverseScopeIdentifiers(scopeBlock.scope, state);
  }
  visitReactiveFunctionValue(_id, _dependencies, fn, state) {
    visitReactiveFunction(fn, this, state);
  }
}
class CollectPromotableTemporaries extends ReactiveFunctionVisitor {
  constructor() {
    super(...arguments);
    this.activeScopes = [];
  }
  visitPlace(_id, place, state) {
    if (
      this.activeScopes.length !== 0 &&
      state.pruned.has(place.identifier.declarationId)
    ) {
      const prunedPlace = state.pruned.get(place.identifier.declarationId);
      if (prunedPlace.activeScopes.indexOf(this.activeScopes.at(-1)) === -1) {
        prunedPlace.usedOutsideScope = true;
      }
    }
  }
  visitValue(id, value, state) {
    this.traverseValue(id, value, state);
    if (value.kind === 'JsxExpression' && value.tag.kind === 'Identifier') {
      state.tags.add(value.tag.identifier.declarationId);
    }
  }
  visitPrunedScope(scopeBlock, state) {
    for (const [_id, decl] of scopeBlock.scope.declarations) {
      state.pruned.set(decl.identifier.declarationId, {
        activeScopes: [...this.activeScopes],
        usedOutsideScope: false,
      });
    }
    this.visitBlock(scopeBlock.instructions, state);
  }
  visitScope(scopeBlock, state) {
    this.activeScopes.push(scopeBlock.scope.id);
    this.traverseScope(scopeBlock, state);
    this.activeScopes.pop();
  }
}
class PromoteInterposedTemporaries extends ReactiveFunctionVisitor {
  constructor(promotable, params) {
    super();
    _PromoteInterposedTemporaries_promotable.set(this, void 0);
    _PromoteInterposedTemporaries_consts.set(this, new Set());
    _PromoteInterposedTemporaries_globals.set(this, new Set());
    params.forEach(param => {
      switch (param.kind) {
        case 'Identifier':
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_consts,
            'f'
          ).add(param.identifier.id);
          break;
        case 'Spread':
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_consts,
            'f'
          ).add(param.place.identifier.id);
          break;
      }
    });
    __classPrivateFieldSet(
      this,
      _PromoteInterposedTemporaries_promotable,
      promotable,
      'f'
    );
  }
  visitPlace(_id, place, state) {
    const promo = state.get(place.identifier.id);
    if (promo) {
      const [identifier, needsPromotion] = promo;
      if (
        needsPromotion &&
        identifier.name === null &&
        !__classPrivateFieldGet(
          this,
          _PromoteInterposedTemporaries_consts,
          'f'
        ).has(identifier.id)
      ) {
        promoteIdentifier(
          identifier,
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_promotable,
            'f'
          )
        );
      }
    }
  }
  visitInstruction(instruction, state) {
    for (const lval of eachInstructionValueLValue(instruction.value)) {
      CompilerError.invariant(lval.identifier.name != null, {
        reason:
          'PromoteInterposedTemporaries: Assignment targets not expected to be temporaries',
        loc: instruction.loc,
      });
    }
    switch (instruction.value.kind) {
      case 'CallExpression':
      case 'MethodCall':
      case 'Await':
      case 'PropertyStore':
      case 'PropertyDelete':
      case 'ComputedStore':
      case 'ComputedDelete':
      case 'PostfixUpdate':
      case 'PrefixUpdate':
      case 'StoreLocal':
      case 'StoreContext':
      case 'StoreGlobal':
      case 'Destructure': {
        let constStore = false;
        if (
          (instruction.value.kind === 'StoreContext' ||
            instruction.value.kind === 'StoreLocal') &&
          (instruction.value.lvalue.kind === 'Const' ||
            instruction.value.lvalue.kind === 'HoistedConst')
        ) {
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_consts,
            'f'
          ).add(instruction.value.lvalue.place.identifier.id);
          constStore = true;
        }
        if (
          instruction.value.kind === 'Destructure' &&
          (instruction.value.lvalue.kind === 'Const' ||
            instruction.value.lvalue.kind === 'HoistedConst')
        ) {
          [...eachPatternOperand(instruction.value.lvalue.pattern)].forEach(
            ident =>
              __classPrivateFieldGet(
                this,
                _PromoteInterposedTemporaries_consts,
                'f'
              ).add(ident.identifier.id)
          );
          constStore = true;
        }
        if (instruction.value.kind === 'MethodCall') {
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_consts,
            'f'
          ).add(instruction.value.property.identifier.id);
        }
        super.visitInstruction(instruction, state);
        if (
          !constStore &&
          (instruction.lvalue == null ||
            instruction.lvalue.identifier.name != null)
        ) {
          for (const [key, [ident, _]] of state.entries()) {
            state.set(key, [ident, true]);
          }
        }
        if (instruction.lvalue && instruction.lvalue.identifier.name === null) {
          state.set(instruction.lvalue.identifier.id, [
            instruction.lvalue.identifier,
            false,
          ]);
        }
        break;
      }
      case 'DeclareContext':
      case 'DeclareLocal': {
        if (
          instruction.value.lvalue.kind === 'Const' ||
          instruction.value.lvalue.kind === 'HoistedConst'
        ) {
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_consts,
            'f'
          ).add(instruction.value.lvalue.place.identifier.id);
        }
        super.visitInstruction(instruction, state);
        break;
      }
      case 'LoadContext':
      case 'LoadLocal': {
        if (instruction.lvalue && instruction.lvalue.identifier.name === null) {
          if (
            __classPrivateFieldGet(
              this,
              _PromoteInterposedTemporaries_consts,
              'f'
            ).has(instruction.value.place.identifier.id)
          ) {
            __classPrivateFieldGet(
              this,
              _PromoteInterposedTemporaries_consts,
              'f'
            ).add(instruction.lvalue.identifier.id);
          }
          state.set(instruction.lvalue.identifier.id, [
            instruction.lvalue.identifier,
            false,
          ]);
        }
        super.visitInstruction(instruction, state);
        break;
      }
      case 'PropertyLoad':
      case 'ComputedLoad': {
        if (instruction.lvalue) {
          if (
            __classPrivateFieldGet(
              this,
              _PromoteInterposedTemporaries_globals,
              'f'
            ).has(instruction.value.object.identifier.id)
          ) {
            __classPrivateFieldGet(
              this,
              _PromoteInterposedTemporaries_globals,
              'f'
            ).add(instruction.lvalue.identifier.id);
            __classPrivateFieldGet(
              this,
              _PromoteInterposedTemporaries_consts,
              'f'
            ).add(instruction.lvalue.identifier.id);
          }
          if (instruction.lvalue.identifier.name === null) {
            state.set(instruction.lvalue.identifier.id, [
              instruction.lvalue.identifier,
              false,
            ]);
          }
        }
        super.visitInstruction(instruction, state);
        break;
      }
      case 'LoadGlobal': {
        instruction.lvalue &&
          __classPrivateFieldGet(
            this,
            _PromoteInterposedTemporaries_globals,
            'f'
          ).add(instruction.lvalue.identifier.id);
        super.visitInstruction(instruction, state);
        break;
      }
      default: {
        super.visitInstruction(instruction, state);
      }
    }
  }
}
(_PromoteInterposedTemporaries_promotable = new WeakMap()),
  (_PromoteInterposedTemporaries_consts = new WeakMap()),
  (_PromoteInterposedTemporaries_globals = new WeakMap());
function promoteUsedTemporaries(fn) {
  const state = {tags: new Set(), promoted: new Set(), pruned: new Map()};
  visitReactiveFunction(fn, new CollectPromotableTemporaries(), state);
  for (const operand of fn.params) {
    const place = operand.kind === 'Identifier' ? operand : operand.place;
    if (place.identifier.name === null) {
      promoteIdentifier(place.identifier, state);
    }
  }
  visitReactiveFunction(fn, new PromoteTemporaries(), state);
  visitReactiveFunction(
    fn,
    new PromoteInterposedTemporaries(state, fn.params),
    new Map()
  );
  visitReactiveFunction(
    fn,
    new PromoteAllInstancedOfPromotedTemporaries(),
    state
  );
}
function promoteIdentifier(identifier, state) {
  CompilerError.invariant(identifier.name === null, {
    reason:
      'promoteTemporary: Expected to be called only for temporary variables',
    description: null,
    loc: GeneratedSource,
    suggestions: null,
  });
  if (state.tags.has(identifier.declarationId)) {
    promoteTemporaryJsxTag(identifier);
  } else {
    promoteTemporary(identifier);
  }
  state.promoted.add(identifier.declarationId);
}
function propagateEarlyReturns(fn) {
  visitReactiveFunction(fn, new Transform$3(fn.env), {
    withinReactiveScope: false,
    earlyReturnValue: null,
  });
}
let Transform$3 = class Transform extends ReactiveFunctionTransform {
  constructor(env) {
    super();
    this.env = env;
  }
  visitScope(scopeBlock, parentState) {
    if (scopeBlock.scope.earlyReturnValue !== null) {
      return;
    }
    const innerState = {
      withinReactiveScope: true,
      earlyReturnValue: parentState.earlyReturnValue,
    };
    this.traverseScope(scopeBlock, innerState);
    const earlyReturnValue = innerState.earlyReturnValue;
    if (earlyReturnValue !== null) {
      if (!parentState.withinReactiveScope) {
        scopeBlock.scope.earlyReturnValue = earlyReturnValue;
        scopeBlock.scope.declarations.set(earlyReturnValue.value.id, {
          identifier: earlyReturnValue.value,
          scope: scopeBlock.scope,
        });
        const instructions = scopeBlock.instructions;
        const loc = earlyReturnValue.loc;
        const sentinelTemp = createTemporaryPlace(this.env, loc);
        const symbolTemp = createTemporaryPlace(this.env, loc);
        const forTemp = createTemporaryPlace(this.env, loc);
        const argTemp = createTemporaryPlace(this.env, loc);
        scopeBlock.instructions = [
          {
            kind: 'instruction',
            instruction: {
              id: makeInstructionId(0),
              loc: loc,
              lvalue: Object.assign({}, symbolTemp),
              value: {
                kind: 'LoadGlobal',
                binding: {kind: 'Global', name: 'Symbol'},
                loc: loc,
              },
            },
          },
          {
            kind: 'instruction',
            instruction: {
              id: makeInstructionId(0),
              loc: loc,
              lvalue: Object.assign({}, forTemp),
              value: {
                kind: 'PropertyLoad',
                object: Object.assign({}, symbolTemp),
                property: 'for',
                loc: loc,
              },
            },
          },
          {
            kind: 'instruction',
            instruction: {
              id: makeInstructionId(0),
              loc: loc,
              lvalue: Object.assign({}, argTemp),
              value: {
                kind: 'Primitive',
                value: EARLY_RETURN_SENTINEL,
                loc: loc,
              },
            },
          },
          {
            kind: 'instruction',
            instruction: {
              id: makeInstructionId(0),
              loc: loc,
              lvalue: Object.assign({}, sentinelTemp),
              value: {
                kind: 'MethodCall',
                receiver: symbolTemp,
                property: forTemp,
                args: [argTemp],
                loc: loc,
              },
            },
          },
          {
            kind: 'instruction',
            instruction: {
              id: makeInstructionId(0),
              loc: loc,
              lvalue: null,
              value: {
                kind: 'StoreLocal',
                loc: loc,
                type: null,
                lvalue: {
                  kind: InstructionKind.Let,
                  place: {
                    kind: 'Identifier',
                    effect: exports.Effect.ConditionallyMutate,
                    loc: loc,
                    reactive: true,
                    identifier: earlyReturnValue.value,
                  },
                },
                value: Object.assign({}, sentinelTemp),
              },
            },
          },
          {
            kind: 'terminal',
            label: {id: earlyReturnValue.label, implicit: false},
            terminal: {
              kind: 'label',
              id: makeInstructionId(0),
              loc: GeneratedSource,
              block: instructions,
            },
          },
        ];
      } else {
        parentState.earlyReturnValue = earlyReturnValue;
      }
    }
  }
  transformTerminal(stmt, state) {
    if (state.withinReactiveScope && stmt.terminal.kind === 'return') {
      const loc = stmt.terminal.value.loc;
      let earlyReturnValue;
      if (state.earlyReturnValue !== null) {
        earlyReturnValue = state.earlyReturnValue;
      } else {
        const identifier = createTemporaryPlace(this.env, loc).identifier;
        promoteTemporary(identifier);
        earlyReturnValue = {
          label: this.env.nextBlockId,
          loc: loc,
          value: identifier,
        };
      }
      state.earlyReturnValue = earlyReturnValue;
      return {
        kind: 'replace-many',
        value: [
          {
            kind: 'instruction',
            instruction: {
              id: makeInstructionId(0),
              loc: loc,
              lvalue: null,
              value: {
                kind: 'StoreLocal',
                loc: loc,
                type: null,
                lvalue: {
                  kind: InstructionKind.Reassign,
                  place: {
                    kind: 'Identifier',
                    identifier: earlyReturnValue.value,
                    effect: exports.Effect.Capture,
                    loc: loc,
                    reactive: true,
                  },
                },
                value: stmt.terminal.value,
              },
            },
          },
          {
            kind: 'terminal',
            label: null,
            terminal: {
              kind: 'break',
              id: makeInstructionId(0),
              loc: loc,
              targetKind: 'labeled',
              target: earlyReturnValue.label,
            },
          },
        ],
      };
    }
    this.traverseTerminal(stmt, state);
    return {kind: 'keep'};
  }
};
function pruneHoistedContexts(fn) {
  const hoistedIdentifiers = new Map();
  visitReactiveFunction(fn, new Visitor$8(), hoistedIdentifiers);
}
let Visitor$8 = class Visitor extends ReactiveFunctionTransform {
  transformInstruction(instruction, state) {
    this.visitInstruction(instruction, state);
    if (
      instruction.value.kind === 'DeclareContext' &&
      instruction.value.lvalue.kind === 'HoistedConst'
    ) {
      state.set(
        instruction.value.lvalue.place.identifier.declarationId,
        InstructionKind.Const
      );
      return {kind: 'remove'};
    }
    if (
      instruction.value.kind === 'DeclareContext' &&
      instruction.value.lvalue.kind === 'HoistedLet'
    ) {
      state.set(
        instruction.value.lvalue.place.identifier.declarationId,
        InstructionKind.Let
      );
      return {kind: 'remove'};
    }
    if (
      instruction.value.kind === 'DeclareContext' &&
      instruction.value.lvalue.kind === 'HoistedFunction'
    ) {
      state.set(
        instruction.value.lvalue.place.identifier.declarationId,
        InstructionKind.Function
      );
      return {kind: 'remove'};
    }
    if (
      instruction.value.kind === 'StoreContext' &&
      state.has(instruction.value.lvalue.place.identifier.declarationId)
    ) {
      const kind = state.get(
        instruction.value.lvalue.place.identifier.declarationId
      );
      return {
        kind: 'replace',
        value: {
          kind: 'instruction',
          instruction: Object.assign(Object.assign({}, instruction), {
            value: Object.assign(Object.assign({}, instruction.value), {
              lvalue: Object.assign(
                Object.assign({}, instruction.value.lvalue),
                {kind: kind}
              ),
              type: null,
              kind: 'StoreLocal',
            }),
          }),
        },
      };
    }
    return {kind: 'keep'};
  }
};
function inferOperandEffect(state, place) {
  const value = state.kind(place);
  CompilerError.invariant(value != null, {
    reason: 'Expected operand to have a kind',
    loc: null,
  });
  switch (place.effect) {
    case exports.Effect.Store:
    case exports.Effect.Mutate: {
      if (isRefOrRefValue(place.identifier)) {
        break;
      } else if (value.kind === exports.ValueKind.Context) {
        return {
          kind: 'ContextMutation',
          loc: place.loc,
          effect: place.effect,
          places: value.context.size === 0 ? new Set([place]) : value.context,
        };
      } else if (
        value.kind !== exports.ValueKind.Mutable &&
        value.kind !== exports.ValueKind.Primitive
      ) {
        let reason = getWriteErrorReason(value);
        return {
          kind:
            value.reason.size === 1 && value.reason.has(ValueReason.Global)
              ? 'GlobalMutation'
              : 'ReactMutation',
          error: {
            reason: reason,
            description:
              place.identifier.name !== null &&
              place.identifier.name.kind === 'named'
                ? `Found mutation of \`${place.identifier.name.value}\``
                : null,
            loc: place.loc,
            suggestions: null,
            severity: exports.ErrorSeverity.InvalidReact,
          },
        };
      }
      break;
    }
  }
  return null;
}
function inheritFunctionEffects(state, place) {
  const effects = inferFunctionInstrEffects(state, place);
  return effects
    .flatMap(effect => {
      if (effect.kind === 'GlobalMutation' || effect.kind === 'ReactMutation') {
        return [effect];
      } else {
        const effects = [];
        CompilerError.invariant(effect.kind === 'ContextMutation', {
          reason: 'Expected ContextMutation',
          loc: null,
        });
        for (const place of effect.places) {
          if (state.isDefined(place)) {
            const replayedEffect = inferOperandEffect(
              state,
              Object.assign(Object.assign({}, place), {
                loc: effect.loc,
                effect: effect.effect,
              })
            );
            if (replayedEffect != null) {
              if (replayedEffect.kind === 'ContextMutation') {
                effects.push(effect);
              } else {
                effects.push(replayedEffect);
              }
            }
          }
        }
        return effects;
      }
    })
    .filter(effect => effect != null);
}
function inferFunctionInstrEffects(state, place) {
  const effects = [];
  const instrs = state.values(place);
  CompilerError.invariant(instrs != null, {
    reason: 'Expected operand to have instructions',
    loc: null,
  });
  for (const instr of instrs) {
    if (
      (instr.kind === 'FunctionExpression' || instr.kind === 'ObjectMethod') &&
      instr.loweredFunc.func.effects != null
    ) {
      effects.push(...instr.loweredFunc.func.effects);
    }
  }
  return effects;
}
function operandEffects(state, place, filterRenderSafe) {
  const functionEffects = [];
  const effect = inferOperandEffect(state, place);
  effect && functionEffects.push(effect);
  functionEffects.push(...inheritFunctionEffects(state, place));
  if (filterRenderSafe) {
    return functionEffects.filter(effect => !isEffectSafeOutsideRender(effect));
  } else {
    return functionEffects;
  }
}
function inferInstructionFunctionEffects(env, state, instr) {
  var _a, _b;
  var _c;
  const functionEffects = [];
  switch (instr.value.kind) {
    case 'JsxExpression': {
      if (instr.value.tag.kind === 'Identifier') {
        functionEffects.push(...operandEffects(state, instr.value.tag, false));
      }
      (_a = instr.value.children) === null || _a === void 0
        ? void 0
        : _a.forEach(child =>
            functionEffects.push(...operandEffects(state, child, false))
          );
      for (const attr of instr.value.props) {
        if (attr.kind === 'JsxSpreadAttribute') {
          functionEffects.push(...operandEffects(state, attr.argument, false));
        } else {
          functionEffects.push(...operandEffects(state, attr.place, true));
        }
      }
      break;
    }
    case 'ObjectMethod':
    case 'FunctionExpression': {
      for (const operand of eachInstructionOperand(instr)) {
        (_b = (_c = instr.value.loweredFunc.func).effects) !== null &&
        _b !== void 0
          ? _b
          : (_c.effects = []);
        instr.value.loweredFunc.func.effects.push(
          ...inferFunctionInstrEffects(state, operand)
        );
      }
      break;
    }
    case 'MethodCall':
    case 'CallExpression': {
      let callee;
      if (instr.value.kind === 'MethodCall') {
        callee = instr.value.property;
        functionEffects.push(
          ...operandEffects(state, instr.value.receiver, false)
        );
      } else {
        callee = instr.value.callee;
      }
      functionEffects.push(...operandEffects(state, callee, false));
      let isHook = getHookKind(env, callee.identifier) != null;
      for (const arg of instr.value.args) {
        const place = arg.kind === 'Identifier' ? arg : arg.place;
        functionEffects.push(...operandEffects(state, place, isHook));
      }
      break;
    }
    case 'StartMemoize':
    case 'FinishMemoize':
    case 'LoadLocal':
    case 'StoreLocal': {
      break;
    }
    case 'StoreGlobal': {
      functionEffects.push({
        kind: 'GlobalMutation',
        error: {
          reason:
            'Unexpected reassignment of a variable which was defined outside of the component. Components and hooks should be pure and side-effect free, but variable reassignment is a form of side-effect. If this variable is used in rendering, use useState instead. (https://react.dev/reference/rules/components-and-hooks-must-be-pure#side-effects-must-run-outside-of-render)',
          loc: instr.loc,
          suggestions: null,
          severity: exports.ErrorSeverity.InvalidReact,
        },
      });
      break;
    }
    default: {
      for (const operand of eachInstructionOperand(instr)) {
        functionEffects.push(...operandEffects(state, operand, false));
      }
    }
  }
  return functionEffects;
}
function inferTerminalFunctionEffects(state, block) {
  const functionEffects = [];
  for (const operand of eachTerminalOperand(block.terminal)) {
    functionEffects.push(...operandEffects(state, operand, true));
  }
  return functionEffects;
}
function raiseFunctionEffectErrors(functionEffects) {
  functionEffects.forEach(eff => {
    switch (eff.kind) {
      case 'ReactMutation':
      case 'GlobalMutation': {
        CompilerError.throw(eff.error);
      }
      case 'ContextMutation': {
        CompilerError.throw({
          severity: exports.ErrorSeverity.Invariant,
          reason: `Unexpected ContextMutation in top-level function effects`,
          loc: eff.loc,
        });
      }
      default:
        assertExhaustive(
          eff,
          `Unexpected function effect kind \`${eff.kind}\``
        );
    }
  });
}
function isEffectSafeOutsideRender(effect) {
  return effect.kind === 'GlobalMutation';
}
function getWriteErrorReason(abstractValue) {
  if (abstractValue.reason.has(ValueReason.Global)) {
    return 'Writing to a variable defined outside a component or hook is not allowed. Consider using an effect';
  } else if (abstractValue.reason.has(ValueReason.JsxCaptured)) {
    return 'Updating a value used previously in JSX is not allowed. Consider moving the mutation before the JSX';
  } else if (abstractValue.reason.has(ValueReason.Context)) {
    return `Mutating a value returned from 'useContext()', which should not be mutated`;
  } else if (abstractValue.reason.has(ValueReason.KnownReturnSignature)) {
    return 'Mutating a value returned from a function whose return value should not be mutated';
  } else if (abstractValue.reason.has(ValueReason.ReactiveFunctionArgument)) {
    return 'Mutating component props or hook arguments is not allowed. Consider using a local variable instead';
  } else if (abstractValue.reason.has(ValueReason.State)) {
    return "Mutating a value returned from 'useState()', which should not be mutated. Use the setter function to update instead";
  } else if (abstractValue.reason.has(ValueReason.ReducerState)) {
    return "Mutating a value returned from 'useReducer()', which should not be mutated. Use the dispatch function to update instead";
  } else {
    return 'This mutates a variable that React considers immutable';
  }
}
var _InferenceState_env, _InferenceState_values, _InferenceState_variables;
const UndefinedValue = {
  kind: 'Primitive',
  loc: GeneratedSource,
  value: undefined,
};
function inferReferenceEffects(fn, options = {isFunctionExpression: false}) {
  var _a;
  const initialState = InferenceState.empty(fn.env);
  const value = {kind: 'Primitive', loc: fn.loc, value: undefined};
  initialState.initialize(value, {
    kind: exports.ValueKind.Frozen,
    reason: new Set([ValueReason.Other]),
    context: new Set(),
  });
  for (const ref of fn.context) {
    const value = {kind: 'ObjectExpression', properties: [], loc: ref.loc};
    initialState.initialize(value, {
      kind: exports.ValueKind.Context,
      reason: new Set([ValueReason.Other]),
      context: new Set([ref]),
    });
    initialState.define(ref, value);
  }
  const paramKind = options.isFunctionExpression
    ? {
        kind: exports.ValueKind.Mutable,
        reason: new Set([ValueReason.Other]),
        context: new Set(),
      }
    : {
        kind: exports.ValueKind.Frozen,
        reason: new Set([ValueReason.ReactiveFunctionArgument]),
        context: new Set(),
      };
  if (fn.fnType === 'Component') {
    CompilerError.invariant(fn.params.length <= 2, {
      reason:
        'Expected React component to have not more than two parameters: one for props and for ref',
      description: null,
      loc: fn.loc,
      suggestions: null,
    });
    const [props, ref] = fn.params;
    let value;
    let place;
    if (props) {
      inferParam(props, initialState, paramKind);
    }
    if (ref) {
      if (ref.kind === 'Identifier') {
        place = ref;
        value = {kind: 'ObjectExpression', properties: [], loc: ref.loc};
      } else {
        place = ref.place;
        value = {kind: 'ObjectExpression', properties: [], loc: ref.place.loc};
      }
      initialState.initialize(value, {
        kind: exports.ValueKind.Mutable,
        reason: new Set([ValueReason.Other]),
        context: new Set(),
      });
      initialState.define(place, value);
    }
  } else {
    for (const param of fn.params) {
      inferParam(param, initialState, paramKind);
    }
  }
  const statesByBlock = new Map();
  const queuedStates = new Map();
  function queue(blockId, state) {
    var _a;
    let queuedState = queuedStates.get(blockId);
    if (queuedState != null) {
      state =
        (_a = queuedState.merge(state)) !== null && _a !== void 0
          ? _a
          : queuedState;
      queuedStates.set(blockId, state);
    } else {
      const prevState = statesByBlock.get(blockId);
      const nextState = prevState != null ? prevState.merge(state) : state;
      if (nextState != null) {
        queuedStates.set(blockId, nextState);
      }
    }
  }
  queue(fn.body.entry, initialState);
  const functionEffects = (_a = fn.effects) !== null && _a !== void 0 ? _a : [];
  while (queuedStates.size !== 0) {
    for (const [blockId, block] of fn.body.blocks) {
      const incomingState = queuedStates.get(blockId);
      queuedStates.delete(blockId);
      if (incomingState == null) {
        continue;
      }
      statesByBlock.set(blockId, incomingState);
      const state = incomingState.clone();
      inferBlock(fn.env, state, block, functionEffects);
      for (const nextBlockId of eachTerminalSuccessor(block.terminal)) {
        queue(nextBlockId, state);
      }
    }
  }
  if (options.isFunctionExpression) {
    fn.effects = functionEffects;
  } else {
    raiseFunctionEffectErrors(functionEffects);
  }
}
class InferenceState {
  constructor(env, values, variables) {
    _InferenceState_env.set(this, void 0);
    _InferenceState_values.set(this, void 0);
    _InferenceState_variables.set(this, void 0);
    __classPrivateFieldSet(this, _InferenceState_env, env, 'f');
    __classPrivateFieldSet(this, _InferenceState_values, values, 'f');
    __classPrivateFieldSet(this, _InferenceState_variables, variables, 'f');
  }
  static empty(env) {
    return new InferenceState(env, new Map(), new Map());
  }
  initialize(value, kind) {
    CompilerError.invariant(value.kind !== 'LoadLocal', {
      reason:
        'Expected all top-level identifiers to be defined as variables, not values',
      description: null,
      loc: value.loc,
      suggestions: null,
    });
    __classPrivateFieldGet(this, _InferenceState_values, 'f').set(value, kind);
  }
  values(place) {
    const values = __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    ).get(place.identifier.id);
    CompilerError.invariant(values != null, {
      reason: `[hoisting] Expected value kind to be initialized`,
      description: `${printPlace(place)}`,
      loc: place.loc,
      suggestions: null,
    });
    return Array.from(values);
  }
  kind(place) {
    const values = __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    ).get(place.identifier.id);
    CompilerError.invariant(values != null, {
      reason: `[hoisting] Expected value kind to be initialized`,
      description: `${printPlace(place)}`,
      loc: place.loc,
      suggestions: null,
    });
    let mergedKind = null;
    for (const value of values) {
      const kind = __classPrivateFieldGet(
        this,
        _InferenceState_values,
        'f'
      ).get(value);
      mergedKind =
        mergedKind !== null ? mergeAbstractValues(mergedKind, kind) : kind;
    }
    CompilerError.invariant(mergedKind !== null, {
      reason: `InferReferenceEffects::kind: Expected at least one value`,
      description: `No value found at \`${printPlace(place)}\``,
      loc: place.loc,
      suggestions: null,
    });
    return mergedKind;
  }
  alias(place, value) {
    const values = __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    ).get(value.identifier.id);
    CompilerError.invariant(values != null, {
      reason: `[hoisting] Expected value for identifier to be initialized`,
      description: `${printIdentifier(value.identifier)}`,
      loc: value.loc,
      suggestions: null,
    });
    __classPrivateFieldGet(this, _InferenceState_variables, 'f').set(
      place.identifier.id,
      new Set(values)
    );
  }
  define(place, value) {
    CompilerError.invariant(
      __classPrivateFieldGet(this, _InferenceState_values, 'f').has(value),
      {
        reason: `Expected value to be initialized at '${printSourceLocation(value.loc)}'`,
        description: null,
        loc: value.loc,
        suggestions: null,
      }
    );
    __classPrivateFieldGet(this, _InferenceState_variables, 'f').set(
      place.identifier.id,
      new Set([value])
    );
  }
  isDefined(place) {
    return __classPrivateFieldGet(this, _InferenceState_variables, 'f').has(
      place.identifier.id
    );
  }
  referenceAndRecordEffects(freezeActions, place, effectKind, reason) {
    const values = __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    ).get(place.identifier.id);
    if (values === undefined) {
      CompilerError.invariant(effectKind !== exports.Effect.Store, {
        reason: '[InferReferenceEffects] Unhandled store reference effect',
        description: null,
        loc: place.loc,
        suggestions: null,
      });
      place.effect =
        effectKind === exports.Effect.ConditionallyMutate
          ? exports.Effect.ConditionallyMutate
          : exports.Effect.Read;
      return;
    }
    const action = this.reference(place, effectKind, reason);
    action && freezeActions.push(action);
  }
  freezeValues(values, reason) {
    for (const value of values) {
      __classPrivateFieldGet(this, _InferenceState_values, 'f').set(value, {
        kind: exports.ValueKind.Frozen,
        reason: reason,
        context: new Set(),
      });
      if (value.kind === 'FunctionExpression') {
        if (
          __classPrivateFieldGet(this, _InferenceState_env, 'f').config
            .enablePreserveExistingMemoizationGuarantees ||
          __classPrivateFieldGet(this, _InferenceState_env, 'f').config
            .enableTransitivelyFreezeFunctionExpressions
        ) {
          if (value.kind === 'FunctionExpression') {
            for (const operand of eachInstructionValueOperand(value)) {
              const operandValues = __classPrivateFieldGet(
                this,
                _InferenceState_variables,
                'f'
              ).get(operand.identifier.id);
              if (operandValues !== undefined) {
                this.freezeValues(operandValues, reason);
              }
            }
          }
        }
      }
    }
  }
  reference(place, effectKind, reason) {
    const values = __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    ).get(place.identifier.id);
    CompilerError.invariant(values !== undefined, {
      reason: '[InferReferenceEffects] Expected value to be initialized',
      description: null,
      loc: place.loc,
      suggestions: null,
    });
    let valueKind = this.kind(place);
    let effect = null;
    let freeze = null;
    switch (effectKind) {
      case exports.Effect.Freeze: {
        if (
          valueKind.kind === exports.ValueKind.Mutable ||
          valueKind.kind === exports.ValueKind.Context ||
          valueKind.kind === exports.ValueKind.MaybeFrozen
        ) {
          const reasonSet = new Set([reason]);
          effect = exports.Effect.Freeze;
          valueKind = {
            kind: exports.ValueKind.Frozen,
            reason: reasonSet,
            context: new Set(),
          };
          freeze = {values: values, reason: reasonSet};
        } else {
          effect = exports.Effect.Read;
        }
        break;
      }
      case exports.Effect.ConditionallyMutate: {
        if (
          valueKind.kind === exports.ValueKind.Mutable ||
          valueKind.kind === exports.ValueKind.Context
        ) {
          effect = exports.Effect.ConditionallyMutate;
        } else {
          effect = exports.Effect.Read;
        }
        break;
      }
      case exports.Effect.Mutate: {
        effect = exports.Effect.Mutate;
        break;
      }
      case exports.Effect.Store: {
        effect = isObjectType(place.identifier)
          ? exports.Effect.Store
          : exports.Effect.Mutate;
        break;
      }
      case exports.Effect.Capture: {
        if (
          valueKind.kind === exports.ValueKind.Primitive ||
          valueKind.kind === exports.ValueKind.Global ||
          valueKind.kind === exports.ValueKind.Frozen ||
          valueKind.kind === exports.ValueKind.MaybeFrozen
        ) {
          effect = exports.Effect.Read;
        } else {
          effect = exports.Effect.Capture;
        }
        break;
      }
      case exports.Effect.Read: {
        effect = exports.Effect.Read;
        break;
      }
      case exports.Effect.Unknown: {
        CompilerError.invariant(false, {
          reason:
            'Unexpected unknown effect, expected to infer a precise effect kind',
          description: null,
          loc: place.loc,
          suggestions: null,
        });
      }
      default: {
        assertExhaustive(
          effectKind,
          `Unexpected reference kind \`${effectKind}\``
        );
      }
    }
    CompilerError.invariant(effect !== null, {
      reason: 'Expected effect to be set',
      description: null,
      loc: place.loc,
      suggestions: null,
    });
    place.effect = effect;
    return freeze;
  }
  merge(other) {
    let nextValues = null;
    let nextVariables = null;
    for (const [id, thisValue] of __classPrivateFieldGet(
      this,
      _InferenceState_values,
      'f'
    )) {
      const otherValue = __classPrivateFieldGet(
        other,
        _InferenceState_values,
        'f'
      ).get(id);
      if (otherValue !== undefined) {
        const mergedValue = mergeAbstractValues(thisValue, otherValue);
        if (mergedValue !== thisValue) {
          nextValues =
            nextValues !== null && nextValues !== void 0
              ? nextValues
              : new Map(
                  __classPrivateFieldGet(this, _InferenceState_values, 'f')
                );
          nextValues.set(id, mergedValue);
        }
      }
    }
    for (const [id, otherValue] of __classPrivateFieldGet(
      other,
      _InferenceState_values,
      'f'
    )) {
      if (__classPrivateFieldGet(this, _InferenceState_values, 'f').has(id)) {
        continue;
      }
      nextValues =
        nextValues !== null && nextValues !== void 0
          ? nextValues
          : new Map(__classPrivateFieldGet(this, _InferenceState_values, 'f'));
      nextValues.set(id, otherValue);
    }
    for (const [id, thisValues] of __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    )) {
      const otherValues = __classPrivateFieldGet(
        other,
        _InferenceState_variables,
        'f'
      ).get(id);
      if (otherValues !== undefined) {
        let mergedValues = null;
        for (const otherValue of otherValues) {
          if (!thisValues.has(otherValue)) {
            mergedValues =
              mergedValues !== null && mergedValues !== void 0
                ? mergedValues
                : new Set(thisValues);
            mergedValues.add(otherValue);
          }
        }
        if (mergedValues !== null) {
          nextVariables =
            nextVariables !== null && nextVariables !== void 0
              ? nextVariables
              : new Map(
                  __classPrivateFieldGet(this, _InferenceState_variables, 'f')
                );
          nextVariables.set(id, mergedValues);
        }
      }
    }
    for (const [id, otherValues] of __classPrivateFieldGet(
      other,
      _InferenceState_variables,
      'f'
    )) {
      if (
        __classPrivateFieldGet(this, _InferenceState_variables, 'f').has(id)
      ) {
        continue;
      }
      nextVariables =
        nextVariables !== null && nextVariables !== void 0
          ? nextVariables
          : new Map(
              __classPrivateFieldGet(this, _InferenceState_variables, 'f')
            );
      nextVariables.set(id, new Set(otherValues));
    }
    if (nextVariables === null && nextValues === null) {
      return null;
    } else {
      return new InferenceState(
        __classPrivateFieldGet(this, _InferenceState_env, 'f'),
        nextValues !== null && nextValues !== void 0
          ? nextValues
          : new Map(__classPrivateFieldGet(this, _InferenceState_values, 'f')),
        nextVariables !== null && nextVariables !== void 0
          ? nextVariables
          : new Map(
              __classPrivateFieldGet(this, _InferenceState_variables, 'f')
            )
      );
    }
  }
  clone() {
    return new InferenceState(
      __classPrivateFieldGet(this, _InferenceState_env, 'f'),
      new Map(__classPrivateFieldGet(this, _InferenceState_values, 'f')),
      new Map(__classPrivateFieldGet(this, _InferenceState_variables, 'f'))
    );
  }
  debug() {
    const result = {values: {}, variables: {}};
    const objects = new Map();
    function identify(value) {
      let id = objects.get(value);
      if (id == null) {
        id = objects.size;
        objects.set(value, id);
      }
      return id;
    }
    for (const [value, kind] of __classPrivateFieldGet(
      this,
      _InferenceState_values,
      'f'
    )) {
      const id = identify(value);
      result.values[id] = {kind: kind, value: printMixedHIR(value)};
    }
    for (const [variable, values] of __classPrivateFieldGet(
      this,
      _InferenceState_variables,
      'f'
    )) {
      result.variables[`$${variable}`] = [...values].map(identify);
    }
    return result;
  }
  inferPhi(phi) {
    const values = new Set();
    for (const [_, operand] of phi.operands) {
      const operandValues = __classPrivateFieldGet(
        this,
        _InferenceState_variables,
        'f'
      ).get(operand.identifier.id);
      if (operandValues === undefined) continue;
      for (const v of operandValues) {
        values.add(v);
      }
    }
    if (values.size > 0) {
      __classPrivateFieldGet(this, _InferenceState_variables, 'f').set(
        phi.place.identifier.id,
        values
      );
    }
  }
}
(_InferenceState_env = new WeakMap()),
  (_InferenceState_values = new WeakMap()),
  (_InferenceState_variables = new WeakMap());
function inferParam(param, initialState, paramKind) {
  let value;
  let place;
  if (param.kind === 'Identifier') {
    place = param;
    value = {kind: 'Primitive', loc: param.loc, value: undefined};
  } else {
    place = param.place;
    value = {kind: 'Primitive', loc: param.place.loc, value: undefined};
  }
  initialState.initialize(value, paramKind);
  initialState.define(place, value);
}
function mergeValues(a, b) {
  if (a === b) {
    return a;
  } else if (
    a === exports.ValueKind.MaybeFrozen ||
    b === exports.ValueKind.MaybeFrozen
  ) {
    return exports.ValueKind.MaybeFrozen;
  } else if (
    a === exports.ValueKind.Mutable ||
    b === exports.ValueKind.Mutable
  ) {
    if (a === exports.ValueKind.Frozen || b === exports.ValueKind.Frozen) {
      return exports.ValueKind.MaybeFrozen;
    } else if (
      a === exports.ValueKind.Context ||
      b === exports.ValueKind.Context
    ) {
      return exports.ValueKind.Context;
    } else {
      return exports.ValueKind.Mutable;
    }
  } else if (
    a === exports.ValueKind.Context ||
    b === exports.ValueKind.Context
  ) {
    if (a === exports.ValueKind.Frozen || b === exports.ValueKind.Frozen) {
      return exports.ValueKind.MaybeFrozen;
    } else {
      return exports.ValueKind.Context;
    }
  } else if (a === exports.ValueKind.Frozen || b === exports.ValueKind.Frozen) {
    return exports.ValueKind.Frozen;
  } else if (a === exports.ValueKind.Global || b === exports.ValueKind.Global) {
    return exports.ValueKind.Global;
  } else {
    CompilerError.invariant(
      a === exports.ValueKind.Primitive && b == exports.ValueKind.Primitive,
      {
        reason: `Unexpected value kind in mergeValues()`,
        description: `Found kinds ${a} and ${b}`,
        loc: GeneratedSource,
      }
    );
    return exports.ValueKind.Primitive;
  }
}
function isSuperset(a, b) {
  for (const v of b) {
    if (!a.has(v)) {
      return false;
    }
  }
  return true;
}
function mergeAbstractValues(a, b) {
  const kind = mergeValues(a.kind, b.kind);
  if (
    kind === a.kind &&
    kind === b.kind &&
    isSuperset(a.reason, b.reason) &&
    isSuperset(a.context, b.context)
  ) {
    return a;
  }
  const reason = new Set(a.reason);
  for (const r of b.reason) {
    reason.add(r);
  }
  const context = new Set(a.context);
  for (const c of b.context) {
    context.add(c);
  }
  return {kind: kind, reason: reason, context: context};
}
function inferBlock(env, state, block, functionEffects) {
  var _a, _b, _c, _d;
  for (const phi of block.phis) {
    state.inferPhi(phi);
  }
  for (const instr of block.instructions) {
    const instrValue = instr.value;
    const defaultLvalueEffect = exports.Effect.ConditionallyMutate;
    let continuation;
    const freezeActions = [];
    switch (instrValue.kind) {
      case 'BinaryExpression': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Primitive,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: {kind: exports.Effect.Read, reason: ValueReason.Other},
        };
        break;
      }
      case 'ArrayExpression': {
        const valueKind = hasContextRefOperand(state, instrValue)
          ? {
              kind: exports.ValueKind.Context,
              reason: new Set([ValueReason.Other]),
              context: new Set(),
            }
          : {
              kind: exports.ValueKind.Mutable,
              reason: new Set([ValueReason.Other]),
              context: new Set(),
            };
        continuation = {
          kind: 'initialize',
          valueKind: valueKind,
          effect: {kind: exports.Effect.Capture, reason: ValueReason.Other},
          lvalueEffect: exports.Effect.Store,
        };
        break;
      }
      case 'NewExpression': {
        const valueKind = {
          kind: exports.ValueKind.Mutable,
          reason: new Set([ValueReason.Other]),
          context: new Set(),
        };
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.callee,
          exports.Effect.Read,
          ValueReason.Other
        );
        for (const operand of eachCallArgument(instrValue.args)) {
          state.referenceAndRecordEffects(
            freezeActions,
            operand,
            exports.Effect.ConditionallyMutate,
            ValueReason.Other
          );
        }
        state.initialize(instrValue, valueKind);
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.ConditionallyMutate;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'ObjectExpression': {
        const valueKind = hasContextRefOperand(state, instrValue)
          ? {
              kind: exports.ValueKind.Context,
              reason: new Set([ValueReason.Other]),
              context: new Set(),
            }
          : {
              kind: exports.ValueKind.Mutable,
              reason: new Set([ValueReason.Other]),
              context: new Set(),
            };
        for (const property of instrValue.properties) {
          switch (property.kind) {
            case 'ObjectProperty': {
              if (property.key.kind === 'computed') {
                state.referenceAndRecordEffects(
                  freezeActions,
                  property.key.name,
                  exports.Effect.Freeze,
                  ValueReason.Other
                );
              }
              state.referenceAndRecordEffects(
                freezeActions,
                property.place,
                exports.Effect.Capture,
                ValueReason.Other
              );
              break;
            }
            case 'Spread': {
              state.referenceAndRecordEffects(
                freezeActions,
                property.place,
                exports.Effect.Capture,
                ValueReason.Other
              );
              break;
            }
            default: {
              assertExhaustive(
                property,
                `Unexpected property kind \`${property.kind}\``
              );
            }
          }
        }
        state.initialize(instrValue, valueKind);
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'UnaryExpression': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Primitive,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: {kind: exports.Effect.Read, reason: ValueReason.Other},
        };
        break;
      }
      case 'UnsupportedNode': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Mutable,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: null,
        };
        break;
      }
      case 'JsxExpression': {
        if (instrValue.tag.kind === 'Identifier') {
          state.referenceAndRecordEffects(
            freezeActions,
            instrValue.tag,
            exports.Effect.Freeze,
            ValueReason.JsxCaptured
          );
        }
        if (instrValue.children !== null) {
          for (const child of instrValue.children) {
            state.referenceAndRecordEffects(
              freezeActions,
              child,
              exports.Effect.Freeze,
              ValueReason.JsxCaptured
            );
          }
        }
        for (const attr of instrValue.props) {
          if (attr.kind === 'JsxSpreadAttribute') {
            state.referenceAndRecordEffects(
              freezeActions,
              attr.argument,
              exports.Effect.Freeze,
              ValueReason.JsxCaptured
            );
          } else {
            state.referenceAndRecordEffects(
              freezeActions,
              attr.place,
              exports.Effect.Freeze,
              ValueReason.JsxCaptured
            );
          }
        }
        state.initialize(instrValue, {
          kind: exports.ValueKind.Frozen,
          reason: new Set([ValueReason.Other]),
          context: new Set(),
        });
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.ConditionallyMutate;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'JsxFragment': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Frozen,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: {kind: exports.Effect.Freeze, reason: ValueReason.Other},
        };
        break;
      }
      case 'TemplateLiteral': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Primitive,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: {kind: exports.Effect.Read, reason: ValueReason.Other},
        };
        break;
      }
      case 'RegExpLiteral': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Mutable,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: {
            kind: exports.Effect.ConditionallyMutate,
            reason: ValueReason.Other,
          },
        };
        break;
      }
      case 'MetaProperty': {
        if (instrValue.meta !== 'import' || instrValue.property !== 'meta') {
          continuation = {kind: 'funeffects'};
          break;
        }
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Global,
            reason: new Set([ValueReason.Global]),
            context: new Set(),
          },
          effect: null,
        };
        break;
      }
      case 'LoadGlobal':
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Global,
            reason: new Set([ValueReason.Global]),
            context: new Set(),
          },
          effect: null,
        };
        break;
      case 'Debugger':
      case 'JSXText':
      case 'Primitive': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Primitive,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: null,
        };
        break;
      }
      case 'ObjectMethod':
      case 'FunctionExpression': {
        let hasMutableOperand = false;
        for (const operand of eachInstructionOperand(instr)) {
          state.referenceAndRecordEffects(
            freezeActions,
            operand,
            operand.effect === exports.Effect.Unknown
              ? exports.Effect.Read
              : operand.effect,
            ValueReason.Other
          );
          if (isMutableEffect(operand.effect, operand.loc));
          hasMutableOperand ||
            (hasMutableOperand = isMutableEffect(operand.effect, operand.loc));
        }
        state.initialize(instrValue, {
          kind: hasMutableOperand
            ? exports.ValueKind.Mutable
            : exports.ValueKind.Frozen,
          reason: new Set([ValueReason.Other]),
          context: new Set(),
        });
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'TaggedTemplateExpression': {
        const operands = [...eachInstructionValueOperand(instrValue)];
        if (operands.length !== 1) {
          CompilerError.throwTodo({
            reason: 'Support tagged template expressions with interpolations',
            loc: instrValue.loc,
          });
        }
        const signature = getFunctionCallSignature(
          env,
          instrValue.tag.identifier.type
        );
        let calleeEffect =
          (_a =
            signature === null || signature === void 0
              ? void 0
              : signature.calleeEffect) !== null && _a !== void 0
            ? _a
            : exports.Effect.ConditionallyMutate;
        const returnValueKind =
          signature !== null
            ? {
                kind: signature.returnValueKind,
                reason: new Set([
                  (_b = signature.returnValueReason) !== null && _b !== void 0
                    ? _b
                    : ValueReason.KnownReturnSignature,
                ]),
                context: new Set(),
              }
            : {
                kind: exports.ValueKind.Mutable,
                reason: new Set([ValueReason.Other]),
                context: new Set(),
              };
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.tag,
          calleeEffect,
          ValueReason.Other
        );
        state.initialize(instrValue, returnValueKind);
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.ConditionallyMutate;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'CallExpression': {
        const signature = getFunctionCallSignature(
          env,
          instrValue.callee.identifier.type
        );
        const effects =
          signature !== null ? getFunctionEffects(instrValue, signature) : null;
        const returnValueKind =
          signature !== null
            ? {
                kind: signature.returnValueKind,
                reason: new Set([
                  (_c = signature.returnValueReason) !== null && _c !== void 0
                    ? _c
                    : ValueReason.KnownReturnSignature,
                ]),
                context: new Set(),
              }
            : {
                kind: exports.ValueKind.Mutable,
                reason: new Set([ValueReason.Other]),
                context: new Set(),
              };
        let hasCaptureArgument = false;
        for (let i = 0; i < instrValue.args.length; i++) {
          const arg = instrValue.args[i];
          const place = arg.kind === 'Identifier' ? arg : arg.place;
          if (effects !== null) {
            state.referenceAndRecordEffects(
              freezeActions,
              place,
              effects[i],
              ValueReason.Other
            );
          } else {
            state.referenceAndRecordEffects(
              freezeActions,
              place,
              exports.Effect.ConditionallyMutate,
              ValueReason.Other
            );
          }
          hasCaptureArgument ||
            (hasCaptureArgument = place.effect === exports.Effect.Capture);
        }
        if (signature !== null) {
          state.referenceAndRecordEffects(
            freezeActions,
            instrValue.callee,
            signature.calleeEffect,
            ValueReason.Other
          );
        } else {
          state.referenceAndRecordEffects(
            freezeActions,
            instrValue.callee,
            exports.Effect.ConditionallyMutate,
            ValueReason.Other
          );
        }
        hasCaptureArgument ||
          (hasCaptureArgument =
            instrValue.callee.effect === exports.Effect.Capture);
        state.initialize(instrValue, returnValueKind);
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = hasCaptureArgument
          ? exports.Effect.Store
          : exports.Effect.ConditionallyMutate;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'MethodCall': {
        CompilerError.invariant(state.isDefined(instrValue.receiver), {
          reason:
            '[InferReferenceEffects] Internal error: receiver of PropertyCall should have been defined by corresponding PropertyLoad',
          description: null,
          loc: instrValue.loc,
          suggestions: null,
        });
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.property,
          exports.Effect.Read,
          ValueReason.Other
        );
        const signature = getFunctionCallSignature(
          env,
          instrValue.property.identifier.type
        );
        const returnValueKind =
          signature !== null
            ? {
                kind: signature.returnValueKind,
                reason: new Set([ValueReason.Other]),
                context: new Set(),
              }
            : {
                kind: exports.ValueKind.Mutable,
                reason: new Set([ValueReason.Other]),
                context: new Set(),
              };
        if (
          signature !== null &&
          signature.mutableOnlyIfOperandsAreMutable &&
          areArgumentsImmutableAndNonMutating(state, instrValue.args)
        ) {
          for (const arg of instrValue.args) {
            const place = arg.kind === 'Identifier' ? arg : arg.place;
            state.referenceAndRecordEffects(
              freezeActions,
              place,
              exports.Effect.Read,
              ValueReason.Other
            );
          }
          state.referenceAndRecordEffects(
            freezeActions,
            instrValue.receiver,
            exports.Effect.Capture,
            ValueReason.Other
          );
          state.initialize(instrValue, returnValueKind);
          state.define(instr.lvalue, instrValue);
          instr.lvalue.effect =
            instrValue.receiver.effect === exports.Effect.Capture
              ? exports.Effect.Store
              : exports.Effect.ConditionallyMutate;
          continuation = {kind: 'funeffects'};
          break;
        }
        const effects =
          signature !== null ? getFunctionEffects(instrValue, signature) : null;
        let hasCaptureArgument = false;
        for (let i = 0; i < instrValue.args.length; i++) {
          const arg = instrValue.args[i];
          const place = arg.kind === 'Identifier' ? arg : arg.place;
          if (effects !== null) {
            state.referenceAndRecordEffects(
              freezeActions,
              place,
              effects[i],
              ValueReason.Other
            );
          } else {
            state.referenceAndRecordEffects(
              freezeActions,
              place,
              exports.Effect.ConditionallyMutate,
              ValueReason.Other
            );
          }
          hasCaptureArgument ||
            (hasCaptureArgument = place.effect === exports.Effect.Capture);
        }
        if (signature !== null) {
          state.referenceAndRecordEffects(
            freezeActions,
            instrValue.receiver,
            signature.calleeEffect,
            ValueReason.Other
          );
        } else {
          state.referenceAndRecordEffects(
            freezeActions,
            instrValue.receiver,
            exports.Effect.ConditionallyMutate,
            ValueReason.Other
          );
        }
        hasCaptureArgument ||
          (hasCaptureArgument =
            instrValue.receiver.effect === exports.Effect.Capture);
        state.initialize(instrValue, returnValueKind);
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = hasCaptureArgument
          ? exports.Effect.Store
          : exports.Effect.ConditionallyMutate;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'PropertyStore': {
        const effect =
          state.kind(instrValue.object).kind === exports.ValueKind.Context
            ? exports.Effect.ConditionallyMutate
            : exports.Effect.Capture;
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          effect,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.object,
          exports.Effect.Store,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        state.alias(lvalue, instrValue.value);
        lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'PropertyDelete': {
        continuation = {
          kind: 'initialize',
          valueKind: {
            kind: exports.ValueKind.Primitive,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
          effect: {kind: exports.Effect.Mutate, reason: ValueReason.Other},
        };
        break;
      }
      case 'PropertyLoad': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.object,
          exports.Effect.Read,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.ConditionallyMutate;
        state.initialize(instrValue, state.kind(instrValue.object));
        state.define(lvalue, instrValue);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'ComputedStore': {
        const effect =
          state.kind(instrValue.object).kind === exports.ValueKind.Context
            ? exports.Effect.ConditionallyMutate
            : exports.Effect.Capture;
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          effect,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.property,
          exports.Effect.Capture,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.object,
          exports.Effect.Store,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        state.alias(lvalue, instrValue.value);
        lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'ComputedDelete': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.object,
          exports.Effect.Mutate,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.property,
          exports.Effect.Read,
          ValueReason.Other
        );
        state.initialize(instrValue, {
          kind: exports.ValueKind.Primitive,
          reason: new Set([ValueReason.Other]),
          context: new Set(),
        });
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.Mutate;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'ComputedLoad': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.object,
          exports.Effect.Read,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.property,
          exports.Effect.Read,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.ConditionallyMutate;
        state.initialize(instrValue, state.kind(instrValue.object));
        state.define(lvalue, instrValue);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'Await': {
        state.initialize(instrValue, state.kind(instrValue.value));
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          exports.Effect.ConditionallyMutate,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.ConditionallyMutate;
        state.alias(lvalue, instrValue.value);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'TypeCastExpression': {
        state.initialize(instrValue, state.kind(instrValue.value));
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          exports.Effect.Read,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.ConditionallyMutate;
        state.alias(lvalue, instrValue.value);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'StartMemoize':
      case 'FinishMemoize': {
        for (const val of eachInstructionValueOperand(instrValue)) {
          if (env.config.enablePreserveExistingMemoizationGuarantees) {
            state.referenceAndRecordEffects(
              freezeActions,
              val,
              exports.Effect.Freeze,
              ValueReason.Other
            );
          } else {
            state.referenceAndRecordEffects(
              freezeActions,
              val,
              exports.Effect.Read,
              ValueReason.Other
            );
          }
        }
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.ConditionallyMutate;
        state.initialize(instrValue, {
          kind: exports.ValueKind.Frozen,
          reason: new Set([ValueReason.Other]),
          context: new Set(),
        });
        state.define(lvalue, instrValue);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'LoadLocal': {
        const lvalue = instr.lvalue;
        const effect =
          state.isDefined(lvalue) &&
          state.kind(lvalue).kind === exports.ValueKind.Context
            ? exports.Effect.ConditionallyMutate
            : exports.Effect.Capture;
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.place,
          effect,
          ValueReason.Other
        );
        lvalue.effect = exports.Effect.ConditionallyMutate;
        state.alias(lvalue, instrValue.place);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'LoadContext': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.place,
          exports.Effect.Capture,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.ConditionallyMutate;
        const valueKind = state.kind(instrValue.place);
        state.initialize(instrValue, valueKind);
        state.define(lvalue, instrValue);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'DeclareLocal': {
        const value = UndefinedValue;
        state.initialize(
          value,
          instrValue.lvalue.kind === InstructionKind.Catch
            ? {
                kind: exports.ValueKind.Mutable,
                reason: new Set([ValueReason.Other]),
                context: new Set(),
              }
            : {
                kind: exports.ValueKind.Primitive,
                reason: new Set([ValueReason.Other]),
                context: new Set(),
              }
        );
        state.define(instrValue.lvalue.place, value);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'DeclareContext': {
        state.initialize(instrValue, {
          kind: exports.ValueKind.Mutable,
          reason: new Set([ValueReason.Other]),
          context: new Set(),
        });
        state.define(instrValue.lvalue.place, instrValue);
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'PostfixUpdate':
      case 'PrefixUpdate': {
        const effect =
          state.isDefined(instrValue.lvalue) &&
          state.kind(instrValue.lvalue).kind === exports.ValueKind.Context
            ? exports.Effect.ConditionallyMutate
            : exports.Effect.Capture;
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          effect,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        state.alias(lvalue, instrValue.value);
        lvalue.effect = exports.Effect.Store;
        state.alias(instrValue.lvalue, instrValue.value);
        instrValue.lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'StoreLocal': {
        const effect =
          state.isDefined(instrValue.lvalue.place) &&
          state.kind(instrValue.lvalue.place).kind === exports.ValueKind.Context
            ? exports.Effect.ConditionallyMutate
            : exports.Effect.Capture;
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          effect,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        state.alias(lvalue, instrValue.value);
        lvalue.effect = exports.Effect.Store;
        state.alias(instrValue.lvalue.place, instrValue.value);
        instrValue.lvalue.place.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'StoreContext': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          exports.Effect.ConditionallyMutate,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.lvalue.place,
          exports.Effect.Mutate,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        state.alias(lvalue, instrValue.value);
        lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'StoreGlobal': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          exports.Effect.Capture,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'Destructure': {
        let effect = exports.Effect.Capture;
        for (const place of eachPatternOperand(instrValue.lvalue.pattern)) {
          if (
            state.isDefined(place) &&
            state.kind(place).kind === exports.ValueKind.Context
          ) {
            effect = exports.Effect.ConditionallyMutate;
            break;
          }
        }
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.value,
          effect,
          ValueReason.Other
        );
        const lvalue = instr.lvalue;
        state.alias(lvalue, instrValue.value);
        lvalue.effect = exports.Effect.Store;
        for (const place of eachPatternOperand(instrValue.lvalue.pattern)) {
          state.alias(place, instrValue.value);
          place.effect = exports.Effect.Store;
        }
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'GetIterator': {
        const kind = state.kind(instrValue.collection).kind;
        const isMutable =
          kind === exports.ValueKind.Mutable ||
          kind === exports.ValueKind.Context;
        let effect;
        let valueKind;
        if (!isMutable || isArrayType(instrValue.collection.identifier)) {
          effect = {kind: exports.Effect.Read, reason: ValueReason.Other};
          valueKind = {
            kind: exports.ValueKind.Mutable,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          };
        } else {
          effect = {kind: exports.Effect.Capture, reason: ValueReason.Other};
          valueKind = state.kind(instrValue.collection);
        }
        continuation = {
          kind: 'initialize',
          effect: effect,
          valueKind: valueKind,
          lvalueEffect: exports.Effect.Store,
        };
        break;
      }
      case 'IteratorNext': {
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.iterator,
          exports.Effect.ConditionallyMutate,
          ValueReason.Other
        );
        state.referenceAndRecordEffects(
          freezeActions,
          instrValue.collection,
          exports.Effect.Capture,
          ValueReason.Other
        );
        state.initialize(instrValue, state.kind(instrValue.collection));
        state.define(instr.lvalue, instrValue);
        instr.lvalue.effect = exports.Effect.Store;
        continuation = {kind: 'funeffects'};
        break;
      }
      case 'NextPropertyOf': {
        continuation = {
          kind: 'initialize',
          effect: {kind: exports.Effect.Read, reason: ValueReason.Other},
          lvalueEffect: exports.Effect.Store,
          valueKind: {
            kind: exports.ValueKind.Primitive,
            reason: new Set([ValueReason.Other]),
            context: new Set(),
          },
        };
        break;
      }
      default: {
        assertExhaustive(instrValue, 'Unexpected instruction kind');
      }
    }
    if (continuation.kind === 'initialize') {
      for (const operand of eachInstructionOperand(instr)) {
        CompilerError.invariant(continuation.effect != null, {
          reason: `effectKind must be set for instruction value \`${instrValue.kind}\``,
          description: null,
          loc: instrValue.loc,
          suggestions: null,
        });
        state.referenceAndRecordEffects(
          freezeActions,
          operand,
          continuation.effect.kind,
          continuation.effect.reason
        );
      }
      state.initialize(instrValue, continuation.valueKind);
      state.define(instr.lvalue, instrValue);
      instr.lvalue.effect =
        (_d = continuation.lvalueEffect) !== null && _d !== void 0
          ? _d
          : defaultLvalueEffect;
    }
    functionEffects.push(...inferInstructionFunctionEffects(env, state, instr));
    freezeActions.forEach(({values: values, reason: reason}) =>
      state.freezeValues(values, reason)
    );
  }
  const terminalFreezeActions = [];
  for (const operand of eachTerminalOperand(block.terminal)) {
    let effect;
    if (block.terminal.kind === 'return' || block.terminal.kind === 'throw') {
      if (
        state.isDefined(operand) &&
        state.kind(operand).kind === exports.ValueKind.Context
      ) {
        effect = exports.Effect.ConditionallyMutate;
      } else {
        effect = exports.Effect.Freeze;
      }
    } else {
      effect = exports.Effect.Read;
    }
    state.referenceAndRecordEffects(
      terminalFreezeActions,
      operand,
      effect,
      ValueReason.Other
    );
  }
  functionEffects.push(...inferTerminalFunctionEffects(state, block));
  terminalFreezeActions.forEach(({values: values, reason: reason}) =>
    state.freezeValues(values, reason)
  );
}
function hasContextRefOperand(state, instrValue) {
  for (const place of eachInstructionValueOperand(instrValue)) {
    if (
      state.isDefined(place) &&
      state.kind(place).kind === exports.ValueKind.Context
    ) {
      return true;
    }
  }
  return false;
}
function getFunctionCallSignature(env, type) {
  if (type.kind !== 'Function') {
    return null;
  }
  return env.getFunctionSignature(type);
}
function getFunctionEffects(fn, sig) {
  const results = [];
  for (let i = 0; i < fn.args.length; i++) {
    const arg = fn.args[i];
    if (i < sig.positionalParams.length) {
      if (arg.kind === 'Identifier') {
        results.push(sig.positionalParams[i]);
      } else {
        return null;
      }
    } else if (sig.restParam !== null) {
      results.push(sig.restParam);
    } else {
      return null;
    }
  }
  return results;
}
function areArgumentsImmutableAndNonMutating(state, args) {
  for (const arg of args) {
    const place = arg.kind === 'Identifier' ? arg : arg.place;
    const kind = state.kind(place).kind;
    switch (kind) {
      case exports.ValueKind.Global:
      case exports.ValueKind.Primitive:
      case exports.ValueKind.Frozen: {
        break;
      }
      default: {
        return false;
      }
    }
    const values = state.values(place);
    for (const value of values) {
      if (
        value.kind === 'FunctionExpression' &&
        value.loweredFunc.func.params.some(param => {
          const place = param.kind === 'Identifier' ? param : param.place;
          const range = place.identifier.mutableRange;
          return range.end > range.start + 1;
        })
      ) {
        return false;
      }
    }
  }
  return true;
}
function pruneNonEscapingScopes(fn) {
  const state = new State(fn.env);
  for (const param of fn.params) {
    if (param.kind === 'Identifier') {
      state.declare(param.identifier.declarationId);
    } else {
      state.declare(param.place.identifier.declarationId);
    }
  }
  visitReactiveFunction(fn, new CollectDependenciesVisitor(fn.env), state);
  const memoized = computeMemoizedIdentifiers(state);
  visitReactiveFunction(fn, new PruneScopesTransform(), memoized);
}
var MemoizationLevel;
(function (MemoizationLevel) {
  MemoizationLevel['Memoized'] = 'Memoized';
  MemoizationLevel['Conditional'] = 'Conditional';
  MemoizationLevel['Unmemoized'] = 'Unmemoized';
  MemoizationLevel['Never'] = 'Never';
})(MemoizationLevel || (MemoizationLevel = {}));
function joinAliases(kind1, kind2) {
  if (
    kind1 === MemoizationLevel.Memoized ||
    kind2 === MemoizationLevel.Memoized
  ) {
    return MemoizationLevel.Memoized;
  } else if (
    kind1 === MemoizationLevel.Conditional ||
    kind2 === MemoizationLevel.Conditional
  ) {
    return MemoizationLevel.Conditional;
  } else if (
    kind1 === MemoizationLevel.Unmemoized ||
    kind2 === MemoizationLevel.Unmemoized
  ) {
    return MemoizationLevel.Unmemoized;
  } else {
    return MemoizationLevel.Never;
  }
}
class State {
  constructor(env) {
    this.definitions = new Map();
    this.identifiers = new Map();
    this.scopes = new Map();
    this.escapingValues = new Set();
    this.env = env;
  }
  declare(id) {
    this.identifiers.set(id, {
      level: MemoizationLevel.Never,
      memoized: false,
      dependencies: new Set(),
      scopes: new Set(),
      seen: false,
    });
  }
  visitOperand(id, place, identifier) {
    const scope = getPlaceScope(id, place);
    if (scope !== null) {
      let node = this.scopes.get(scope.id);
      if (node === undefined) {
        node = {
          dependencies: [...scope.dependencies].map(
            dep => dep.identifier.declarationId
          ),
          seen: false,
        };
        this.scopes.set(scope.id, node);
      }
      const identifierNode = this.identifiers.get(identifier);
      CompilerError.invariant(identifierNode !== undefined, {
        reason: 'Expected identifier to be initialized',
        description: null,
        loc: place.loc,
        suggestions: null,
      });
      identifierNode.scopes.add(scope.id);
    }
  }
}
function computeMemoizedIdentifiers(state) {
  const memoized = new Set();
  function visit(id, forceMemoize = false) {
    const node = state.identifiers.get(id);
    CompilerError.invariant(node !== undefined, {
      reason: `Expected a node for all identifiers, none found for \`${id}\``,
      description: null,
      loc: null,
      suggestions: null,
    });
    if (node.seen) {
      return node.memoized;
    }
    node.seen = true;
    node.memoized = false;
    let hasMemoizedDependency = false;
    for (const dep of node.dependencies) {
      const isDepMemoized = visit(dep);
      hasMemoizedDependency || (hasMemoizedDependency = isDepMemoized);
    }
    if (
      node.level === MemoizationLevel.Memoized ||
      (node.level === MemoizationLevel.Conditional &&
        (hasMemoizedDependency || forceMemoize)) ||
      (node.level === MemoizationLevel.Unmemoized && forceMemoize)
    ) {
      node.memoized = true;
      memoized.add(id);
      for (const scope of node.scopes) {
        forceMemoizeScopeDependencies(scope);
      }
    }
    return node.memoized;
  }
  function forceMemoizeScopeDependencies(id) {
    const node = state.scopes.get(id);
    CompilerError.invariant(node !== undefined, {
      reason: 'Expected a node for all scopes',
      description: null,
      loc: null,
      suggestions: null,
    });
    if (node.seen) {
      return;
    }
    node.seen = true;
    for (const dep of node.dependencies) {
      visit(dep, true);
    }
    return;
  }
  for (const value of state.escapingValues) {
    visit(value);
  }
  return memoized;
}
function computeMemoizationInputs(env, value, lvalue, options) {
  switch (value.kind) {
    case 'ConditionalExpression': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [
          ...computeMemoizationInputs(env, value.consequent, null, options)
            .rvalues,
          ...computeMemoizationInputs(env, value.alternate, null, options)
            .rvalues,
        ],
      };
    }
    case 'LogicalExpression': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [
          ...computeMemoizationInputs(env, value.left, null, options).rvalues,
          ...computeMemoizationInputs(env, value.right, null, options).rvalues,
        ],
      };
    }
    case 'SequenceExpression': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: computeMemoizationInputs(env, value.value, null, options)
          .rvalues,
      };
    }
    case 'JsxExpression': {
      const operands = [];
      if (value.tag.kind === 'Identifier') {
        operands.push(value.tag);
      }
      for (const prop of value.props) {
        if (prop.kind === 'JsxAttribute') {
          operands.push(prop.place);
        } else {
          operands.push(prop.argument);
        }
      }
      if (value.children !== null) {
        for (const child of value.children) {
          operands.push(child);
        }
      }
      const level = options.memoizeJsxElements
        ? MemoizationLevel.Memoized
        : MemoizationLevel.Unmemoized;
      return {
        lvalues: lvalue !== null ? [{place: lvalue, level: level}] : [],
        rvalues: operands,
      };
    }
    case 'JsxFragment': {
      const level = options.memoizeJsxElements
        ? MemoizationLevel.Memoized
        : MemoizationLevel.Unmemoized;
      return {
        lvalues: lvalue !== null ? [{place: lvalue, level: level}] : [],
        rvalues: value.children,
      };
    }
    case 'NextPropertyOf':
    case 'StartMemoize':
    case 'FinishMemoize':
    case 'Debugger':
    case 'ComputedDelete':
    case 'PropertyDelete':
    case 'LoadGlobal':
    case 'MetaProperty':
    case 'TemplateLiteral':
    case 'Primitive':
    case 'JSXText':
    case 'BinaryExpression':
    case 'UnaryExpression': {
      const level = options.forceMemoizePrimitives
        ? MemoizationLevel.Memoized
        : MemoizationLevel.Never;
      return {
        lvalues: lvalue !== null ? [{place: lvalue, level: level}] : [],
        rvalues: [],
      };
    }
    case 'Await':
    case 'TypeCastExpression': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [value.value],
      };
    }
    case 'IteratorNext': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [value.iterator, value.collection],
      };
    }
    case 'GetIterator': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [value.collection],
      };
    }
    case 'LoadLocal': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [value.place],
      };
    }
    case 'LoadContext': {
      return {
        lvalues:
          lvalue !== null
            ? [{place: lvalue, level: MemoizationLevel.Conditional}]
            : [],
        rvalues: [value.place],
      };
    }
    case 'DeclareContext': {
      const lvalues = [
        {place: value.lvalue.place, level: MemoizationLevel.Memoized},
      ];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Unmemoized});
      }
      return {lvalues: lvalues, rvalues: []};
    }
    case 'DeclareLocal': {
      const lvalues = [
        {place: value.lvalue.place, level: MemoizationLevel.Unmemoized},
      ];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Unmemoized});
      }
      return {lvalues: lvalues, rvalues: []};
    }
    case 'PrefixUpdate':
    case 'PostfixUpdate': {
      const lvalues = [
        {place: value.lvalue, level: MemoizationLevel.Conditional},
      ];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Conditional});
      }
      return {lvalues: lvalues, rvalues: [value.value]};
    }
    case 'StoreLocal': {
      const lvalues = [
        {place: value.lvalue.place, level: MemoizationLevel.Conditional},
      ];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Conditional});
      }
      return {lvalues: lvalues, rvalues: [value.value]};
    }
    case 'StoreContext': {
      const lvalues = [
        {place: value.lvalue.place, level: MemoizationLevel.Memoized},
      ];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Conditional});
      }
      return {lvalues: lvalues, rvalues: [value.value]};
    }
    case 'StoreGlobal': {
      const lvalues = [];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Unmemoized});
      }
      return {lvalues: lvalues, rvalues: [value.value]};
    }
    case 'Destructure': {
      const lvalues = [];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Conditional});
      }
      lvalues.push(...computePatternLValues(value.lvalue.pattern));
      return {lvalues: lvalues, rvalues: [value.value]};
    }
    case 'ComputedLoad':
    case 'PropertyLoad': {
      const level = options.forceMemoizePrimitives
        ? MemoizationLevel.Memoized
        : MemoizationLevel.Conditional;
      return {
        lvalues: lvalue !== null ? [{place: lvalue, level: level}] : [],
        rvalues: [value.object],
      };
    }
    case 'ComputedStore': {
      const lvalues = [
        {place: value.object, level: MemoizationLevel.Conditional},
      ];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Conditional});
      }
      return {lvalues: lvalues, rvalues: [value.value]};
    }
    case 'OptionalExpression': {
      const lvalues = [];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Conditional});
      }
      return {
        lvalues: lvalues,
        rvalues: [
          ...computeMemoizationInputs(env, value.value, null, options).rvalues,
        ],
      };
    }
    case 'TaggedTemplateExpression': {
      const signature = getFunctionCallSignature(
        env,
        value.tag.identifier.type
      );
      let lvalues = [];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Memoized});
      }
      if (
        (signature === null || signature === void 0
          ? void 0
          : signature.noAlias) === true
      ) {
        return {lvalues: lvalues, rvalues: []};
      }
      const operands = [...eachReactiveValueOperand(value)];
      lvalues.push(
        ...operands
          .filter(operand => isMutableEffect(operand.effect, operand.loc))
          .map(place => ({place: place, level: MemoizationLevel.Memoized}))
      );
      return {lvalues: lvalues, rvalues: operands};
    }
    case 'CallExpression': {
      const signature = getFunctionCallSignature(
        env,
        value.callee.identifier.type
      );
      let lvalues = [];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Memoized});
      }
      if (
        (signature === null || signature === void 0
          ? void 0
          : signature.noAlias) === true
      ) {
        return {lvalues: lvalues, rvalues: []};
      }
      const operands = [...eachReactiveValueOperand(value)];
      lvalues.push(
        ...operands
          .filter(operand => isMutableEffect(operand.effect, operand.loc))
          .map(place => ({place: place, level: MemoizationLevel.Memoized}))
      );
      return {lvalues: lvalues, rvalues: operands};
    }
    case 'MethodCall': {
      const signature = getFunctionCallSignature(
        env,
        value.property.identifier.type
      );
      let lvalues = [];
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Memoized});
      }
      if (
        (signature === null || signature === void 0
          ? void 0
          : signature.noAlias) === true
      ) {
        return {lvalues: lvalues, rvalues: []};
      }
      const operands = [...eachReactiveValueOperand(value)];
      lvalues.push(
        ...operands
          .filter(operand => isMutableEffect(operand.effect, operand.loc))
          .map(place => ({place: place, level: MemoizationLevel.Memoized}))
      );
      return {lvalues: lvalues, rvalues: operands};
    }
    case 'RegExpLiteral':
    case 'ObjectMethod':
    case 'FunctionExpression':
    case 'ArrayExpression':
    case 'NewExpression':
    case 'ObjectExpression':
    case 'PropertyStore': {
      const operands = [...eachReactiveValueOperand(value)];
      const lvalues = operands
        .filter(operand => isMutableEffect(operand.effect, operand.loc))
        .map(place => ({place: place, level: MemoizationLevel.Memoized}));
      if (lvalue !== null) {
        lvalues.push({place: lvalue, level: MemoizationLevel.Memoized});
      }
      return {lvalues: lvalues, rvalues: operands};
    }
    case 'ReactiveFunctionValue': {
      CompilerError.invariant(false, {
        reason: `Unexpected ReactiveFunctionValue node`,
        description: null,
        loc: value.loc,
        suggestions: null,
      });
    }
    case 'UnsupportedNode': {
      CompilerError.invariant(false, {
        reason: `Unexpected unsupported node`,
        description: null,
        loc: value.loc,
        suggestions: null,
      });
    }
    default: {
      assertExhaustive(value, `Unexpected value kind \`${value.kind}\``);
    }
  }
}
function computePatternLValues(pattern) {
  const lvalues = [];
  switch (pattern.kind) {
    case 'ArrayPattern': {
      for (const item of pattern.items) {
        if (item.kind === 'Identifier') {
          lvalues.push({place: item, level: MemoizationLevel.Conditional});
        } else if (item.kind === 'Spread') {
          lvalues.push({place: item.place, level: MemoizationLevel.Memoized});
        }
      }
      break;
    }
    case 'ObjectPattern': {
      for (const property of pattern.properties) {
        if (property.kind === 'ObjectProperty') {
          lvalues.push({
            place: property.place,
            level: MemoizationLevel.Conditional,
          });
        } else {
          lvalues.push({
            place: property.place,
            level: MemoizationLevel.Memoized,
          });
        }
      }
      break;
    }
    default: {
      assertExhaustive(pattern, `Unexpected pattern kind \`${pattern.kind}\``);
    }
  }
  return lvalues;
}
class CollectDependenciesVisitor extends ReactiveFunctionVisitor {
  constructor(env) {
    super();
    this.env = env;
    this.options = {
      memoizeJsxElements: !this.env.config.enableForest,
      forceMemoizePrimitives: this.env.config.enableForest,
    };
  }
  visitInstruction(instruction, state) {
    var _a, _b, _c;
    this.traverseInstruction(instruction, state);
    const aliasing = computeMemoizationInputs(
      this.env,
      instruction.value,
      instruction.lvalue,
      this.options
    );
    for (const operand of aliasing.rvalues) {
      const operandId =
        (_a = state.definitions.get(operand.identifier.declarationId)) !==
          null && _a !== void 0
          ? _a
          : operand.identifier.declarationId;
      state.visitOperand(instruction.id, operand, operandId);
    }
    for (const {place: lvalue, level: level} of aliasing.lvalues) {
      const lvalueId =
        (_b = state.definitions.get(lvalue.identifier.declarationId)) !==
          null && _b !== void 0
          ? _b
          : lvalue.identifier.declarationId;
      let node = state.identifiers.get(lvalueId);
      if (node === undefined) {
        node = {
          level: MemoizationLevel.Never,
          memoized: false,
          dependencies: new Set(),
          scopes: new Set(),
          seen: false,
        };
        state.identifiers.set(lvalueId, node);
      }
      node.level = joinAliases(node.level, level);
      for (const operand of aliasing.rvalues) {
        const operandId =
          (_c = state.definitions.get(operand.identifier.declarationId)) !==
            null && _c !== void 0
            ? _c
            : operand.identifier.declarationId;
        if (operandId === lvalueId) {
          continue;
        }
        node.dependencies.add(operandId);
      }
      state.visitOperand(instruction.id, lvalue, lvalueId);
    }
    if (instruction.value.kind === 'LoadLocal' && instruction.lvalue !== null) {
      state.definitions.set(
        instruction.lvalue.identifier.declarationId,
        instruction.value.place.identifier.declarationId
      );
    } else if (
      instruction.value.kind === 'CallExpression' ||
      instruction.value.kind === 'MethodCall'
    ) {
      let callee =
        instruction.value.kind === 'CallExpression'
          ? instruction.value.callee
          : instruction.value.property;
      if (getHookKind(state.env, callee.identifier) != null) {
        const signature = getFunctionCallSignature(
          this.env,
          callee.identifier.type
        );
        if (signature && signature.noAlias === true) {
          return;
        }
        for (const operand of instruction.value.args) {
          const place = operand.kind === 'Spread' ? operand.place : operand;
          state.escapingValues.add(place.identifier.declarationId);
        }
      }
    }
  }
  visitTerminal(stmt, state) {
    this.traverseTerminal(stmt, state);
    if (stmt.terminal.kind === 'return') {
      state.escapingValues.add(stmt.terminal.value.identifier.declarationId);
    }
  }
}
class PruneScopesTransform extends ReactiveFunctionTransform {
  constructor() {
    super(...arguments);
    this.prunedScopes = new Set();
    this.reassignments = new Map();
  }
  transformScope(scopeBlock, state) {
    this.visitScope(scopeBlock, state);
    if (
      (scopeBlock.scope.declarations.size === 0 &&
        scopeBlock.scope.reassignments.size === 0) ||
      scopeBlock.scope.earlyReturnValue !== null
    ) {
      return {kind: 'keep'};
    }
    const hasMemoizedOutput =
      Array.from(scopeBlock.scope.declarations.values()).some(decl =>
        state.has(decl.identifier.declarationId)
      ) ||
      Array.from(scopeBlock.scope.reassignments).some(identifier =>
        state.has(identifier.declarationId)
      );
    if (hasMemoizedOutput) {
      return {kind: 'keep'};
    } else {
      this.prunedScopes.add(scopeBlock.scope.id);
      return {kind: 'replace-many', value: scopeBlock.instructions};
    }
  }
  transformInstruction(instruction, state) {
    var _a;
    this.traverseInstruction(instruction, state);
    const value = instruction.value;
    if (value.kind === 'StoreLocal' && value.lvalue.kind === 'Reassign') {
      const ids = getOrInsertDefault(
        this.reassignments,
        value.lvalue.place.identifier.declarationId,
        new Set()
      );
      ids.add(value.value.identifier);
    } else if (value.kind === 'FinishMemoize') {
      let decls;
      if (value.decl.identifier.scope == null) {
        decls =
          (_a = this.reassignments.get(value.decl.identifier.declarationId)) !==
            null && _a !== void 0
            ? _a
            : [value.decl.identifier];
      } else {
        decls = [value.decl.identifier];
      }
      if (
        [...decls].every(
          decl => decl.scope == null || this.prunedScopes.has(decl.scope.id)
        )
      ) {
        value.pruned = true;
      }
    }
    return {kind: 'keep'};
  }
}
let Visitor$7 = class Visitor extends ReactiveFunctionVisitor {
  visitLValue(id, lvalue, state) {
    this.visitPlace(id, lvalue, state);
  }
  visitPlace(_id, place, state) {
    if (place.reactive) {
      state.add(place.identifier.id);
    }
  }
  visitPrunedScope(scopeBlock, state) {
    this.traversePrunedScope(scopeBlock, state);
    for (const [id, decl] of scopeBlock.scope.declarations) {
      if (
        !isPrimitiveType(decl.identifier) &&
        !isStableRefType(decl.identifier, state)
      ) {
        state.add(id);
      }
    }
  }
};
function isStableRefType(identifier, reactiveIdentifiers) {
  return isUseRefType(identifier) && !reactiveIdentifiers.has(identifier.id);
}
function collectReactiveIdentifiers(fn) {
  const visitor = new Visitor$7();
  const state = new Set();
  visitReactiveFunction(fn, visitor, state);
  return state;
}
function pruneNonReactiveDependencies(fn) {
  const reactiveIdentifiers = collectReactiveIdentifiers(fn);
  visitReactiveFunction(fn, new Visitor$6(), reactiveIdentifiers);
}
let Visitor$6 = class Visitor extends ReactiveFunctionVisitor {
  visitInstruction(instruction, state) {
    this.traverseInstruction(instruction, state);
    const {lvalue: lvalue, value: value} = instruction;
    switch (value.kind) {
      case 'LoadLocal': {
        if (lvalue !== null && state.has(value.place.identifier.id)) {
          state.add(lvalue.identifier.id);
        }
        break;
      }
      case 'StoreLocal': {
        if (state.has(value.value.identifier.id)) {
          state.add(value.lvalue.place.identifier.id);
          if (lvalue !== null) {
            state.add(lvalue.identifier.id);
          }
        }
        break;
      }
      case 'Destructure': {
        if (state.has(value.value.identifier.id)) {
          for (const lvalue of eachPatternOperand(value.lvalue.pattern)) {
            if (isStableType(lvalue.identifier)) {
              continue;
            }
            state.add(lvalue.identifier.id);
          }
          if (lvalue !== null) {
            state.add(lvalue.identifier.id);
          }
        }
        break;
      }
      case 'PropertyLoad': {
        if (
          lvalue !== null &&
          state.has(value.object.identifier.id) &&
          !isStableType(lvalue.identifier)
        ) {
          state.add(lvalue.identifier.id);
        }
        break;
      }
      case 'ComputedLoad': {
        if (
          lvalue !== null &&
          (state.has(value.object.identifier.id) ||
            state.has(value.property.identifier.id))
        ) {
          state.add(lvalue.identifier.id);
        }
        break;
      }
    }
  }
  visitScope(scopeBlock, state) {
    this.traverseScope(scopeBlock, state);
    for (const dep of scopeBlock.scope.dependencies) {
      const isReactive = state.has(dep.identifier.id);
      if (!isReactive) {
        scopeBlock.scope.dependencies.delete(dep);
      }
    }
    if (scopeBlock.scope.dependencies.size !== 0) {
      for (const [, declaration] of scopeBlock.scope.declarations) {
        state.add(declaration.identifier.id);
      }
      for (const reassignment of scopeBlock.scope.reassignments) {
        state.add(reassignment.id);
      }
    }
  }
};
function pruneUnusedLValues(fn) {
  const lvalues = new Map();
  visitReactiveFunction(fn, new Visitor$5(), lvalues);
  for (const [, instr] of lvalues) {
    instr.lvalue = null;
  }
}
let Visitor$5 = class Visitor extends ReactiveFunctionVisitor {
  visitPlace(id, place, state) {
    state.delete(place.identifier.declarationId);
  }
  visitInstruction(instruction, state) {
    this.traverseInstruction(instruction, state);
    if (
      instruction.lvalue !== null &&
      instruction.lvalue.identifier.name === null
    ) {
      state.set(instruction.lvalue.identifier.declarationId, instruction);
    }
  }
};
function pruneUnusedLabels(fn) {
  const labels = new Set();
  visitReactiveFunction(fn, new Transform$2(), labels);
}
let Transform$2 = class Transform extends ReactiveFunctionTransform {
  transformTerminal(stmt, state) {
    this.traverseTerminal(stmt, state);
    const {terminal: terminal} = stmt;
    if (
      (terminal.kind === 'break' || terminal.kind === 'continue') &&
      terminal.targetKind === 'labeled'
    ) {
      state.add(terminal.target);
    }
    const isReachableLabel = stmt.label !== null && state.has(stmt.label.id);
    if (stmt.terminal.kind === 'label' && !isReachableLabel) {
      const block = [...stmt.terminal.block];
      const last = block.at(-1);
      if (
        last !== undefined &&
        last.kind === 'terminal' &&
        last.terminal.kind === 'break' &&
        last.terminal.target === null
      ) {
        block.pop();
      }
      return {kind: 'replace-many', value: block};
    } else {
      if (!isReachableLabel && stmt.label != null) {
        stmt.label.implicit = true;
      }
      return {kind: 'keep'};
    }
  }
};
function pruneUnusedScopes(fn) {
  visitReactiveFunction(fn, new Transform$1(), {hasReturnStatement: false});
}
let Transform$1 = class Transform extends ReactiveFunctionTransform {
  visitTerminal(stmt, state) {
    this.traverseTerminal(stmt, state);
    if (stmt.terminal.kind === 'return') {
      state.hasReturnStatement = true;
    }
  }
  transformScope(scopeBlock, _state) {
    const scopeState = {hasReturnStatement: false};
    this.visitScope(scopeBlock, scopeState);
    if (
      !scopeState.hasReturnStatement &&
      scopeBlock.scope.reassignments.size === 0 &&
      (scopeBlock.scope.declarations.size === 0 ||
        !hasOwnDeclaration(scopeBlock))
    ) {
      return {
        kind: 'replace',
        value: {
          kind: 'pruned-scope',
          scope: scopeBlock.scope,
          instructions: scopeBlock.instructions,
        },
      };
    } else {
      return {kind: 'keep'};
    }
  }
};
function hasOwnDeclaration(block) {
  for (const declaration of block.scope.declarations.values()) {
    if (declaration.scope.id === block.scope.id) {
      return true;
    }
  }
  return false;
}
function collectReferencedGlobals(fn) {
  const identifiers = new Set();
  visitReactiveFunction(fn, new Visitor$4(), identifiers);
  return identifiers;
}
let Visitor$4 = class Visitor extends ReactiveFunctionVisitor {
  visitValue(id, value, state) {
    this.traverseValue(id, value, state);
    if (value.kind === 'FunctionExpression' || value.kind === 'ObjectMethod') {
      this.visitHirFunction(value.loweredFunc.func, state);
    } else if (value.kind === 'LoadGlobal') {
      state.add(value.binding.name);
    }
  }
  visitReactiveFunctionValue(_id, _dependencies, fn, state) {
    visitReactiveFunction(fn, this, state);
  }
};
var _Scopes_instances,
  _Scopes_seen,
  _Scopes_stack,
  _Scopes_globals,
  _Scopes_lookup;
function renameVariables(fn) {
  const globals = collectReferencedGlobals(fn);
  const scopes = new Scopes(globals);
  renameVariablesImpl(fn, new Visitor$3(), scopes);
  return new Set([...scopes.names, ...globals]);
}
function renameVariablesImpl(fn, visitor, scopes) {
  scopes.enter(() => {
    for (const param of fn.params) {
      if (param.kind === 'Identifier') {
        scopes.visit(param.identifier);
      } else {
        scopes.visit(param.place.identifier);
      }
    }
    visitReactiveFunction(fn, visitor, scopes);
  });
}
let Visitor$3 = class Visitor extends ReactiveFunctionVisitor {
  visitParam(place, state) {
    state.visit(place.identifier);
  }
  visitLValue(_id, lvalue, state) {
    state.visit(lvalue.identifier);
  }
  visitPlace(id, place, state) {
    state.visit(place.identifier);
  }
  visitBlock(block, state) {
    state.enter(() => {
      this.traverseBlock(block, state);
    });
  }
  visitPrunedScope(scopeBlock, state) {
    this.traverseBlock(scopeBlock.instructions, state);
  }
  visitScope(scope, state) {
    for (const [_, declaration] of scope.scope.declarations) {
      state.visit(declaration.identifier);
    }
    this.traverseScope(scope, state);
  }
  visitValue(id, value, state) {
    this.traverseValue(id, value, state);
    if (value.kind === 'FunctionExpression' || value.kind === 'ObjectMethod') {
      this.visitHirFunction(value.loweredFunc.func, state);
    }
  }
  visitReactiveFunctionValue(_id, _dependencies, _fn, _state) {
    renameVariablesImpl(_fn, this, _state);
  }
};
class Scopes {
  constructor(globals) {
    _Scopes_instances.add(this);
    _Scopes_seen.set(this, new Map());
    _Scopes_stack.set(this, [new Map()]);
    _Scopes_globals.set(this, void 0);
    this.names = new Set();
    __classPrivateFieldSet(this, _Scopes_globals, globals, 'f');
  }
  visit(identifier) {
    const originalName = identifier.name;
    if (originalName === null) {
      return;
    }
    const mappedName = __classPrivateFieldGet(this, _Scopes_seen, 'f').get(
      identifier.declarationId
    );
    if (mappedName !== undefined) {
      identifier.name = mappedName;
      return;
    }
    let name = originalName.value;
    let id = 0;
    if (isPromotedTemporary(originalName.value)) {
      name = `t${id++}`;
    } else if (isPromotedJsxTemporary(originalName.value)) {
      name = `T${id++}`;
    }
    while (
      __classPrivateFieldGet(this, _Scopes_instances, 'm', _Scopes_lookup).call(
        this,
        name
      ) !== null ||
      __classPrivateFieldGet(this, _Scopes_globals, 'f').has(name)
    ) {
      if (isPromotedTemporary(originalName.value)) {
        name = `t${id++}`;
      } else if (isPromotedJsxTemporary(originalName.value)) {
        name = `T${id++}`;
      } else {
        name = `${originalName.value}$${id++}`;
      }
    }
    const identifierName = makeIdentifierName(name);
    identifier.name = identifierName;
    __classPrivateFieldGet(this, _Scopes_seen, 'f').set(
      identifier.declarationId,
      identifierName
    );
    __classPrivateFieldGet(this, _Scopes_stack, 'f')
      .at(-1)
      .set(identifierName.value, identifier.declarationId);
    this.names.add(identifierName.value);
  }
  enter(fn) {
    const next = new Map();
    __classPrivateFieldGet(this, _Scopes_stack, 'f').push(next);
    fn();
    const last = __classPrivateFieldGet(this, _Scopes_stack, 'f').pop();
    CompilerError.invariant(last === next, {
      reason: 'Mismatch push/pop calls',
      description: null,
      loc: null,
      suggestions: null,
    });
  }
}
(_Scopes_seen = new WeakMap()),
  (_Scopes_stack = new WeakMap()),
  (_Scopes_globals = new WeakMap()),
  (_Scopes_instances = new WeakSet()),
  (_Scopes_lookup = function _Scopes_lookup(name) {
    for (
      let i = __classPrivateFieldGet(this, _Scopes_stack, 'f').length - 1;
      i >= 0;
      i--
    ) {
      const scope = __classPrivateFieldGet(this, _Scopes_stack, 'f')[i];
      const entry = scope.get(name);
      if (entry !== undefined) {
        return entry;
      }
    }
    return null;
  });
function stabilizeBlockIds(fn) {
  const referenced = new Set();
  visitReactiveFunction(fn, new CollectReferencedLabels(), referenced);
  const mappings = new Map();
  for (const blockId of referenced) {
    mappings.set(blockId, makeBlockId(mappings.size));
  }
  visitReactiveFunction(fn, new RewriteBlockIds(), mappings);
}
class CollectReferencedLabels extends ReactiveFunctionVisitor {
  visitScope(scope, state) {
    const {earlyReturnValue: earlyReturnValue} = scope.scope;
    if (earlyReturnValue != null) {
      state.add(earlyReturnValue.label);
    }
    this.traverseScope(scope, state);
  }
  visitTerminal(stmt, state) {
    if (stmt.label != null) {
      if (!stmt.label.implicit) {
        state.add(stmt.label.id);
      }
    }
    this.traverseTerminal(stmt, state);
  }
}
class RewriteBlockIds extends ReactiveFunctionVisitor {
  visitScope(scope, state) {
    const {earlyReturnValue: earlyReturnValue} = scope.scope;
    if (earlyReturnValue != null) {
      const rewrittenId = getOrInsertDefault(
        state,
        earlyReturnValue.label,
        state.size
      );
      earlyReturnValue.label = makeBlockId(rewrittenId);
    }
    this.traverseScope(scope, state);
  }
  visitTerminal(stmt, state) {
    if (stmt.label != null) {
      const rewrittenId = getOrInsertDefault(state, stmt.label.id, state.size);
      stmt.label.id = makeBlockId(rewrittenId);
    }
    const terminal = stmt.terminal;
    if (terminal.kind === 'break' || terminal.kind === 'continue') {
      const rewrittenId = getOrInsertDefault(
        state,
        terminal.target,
        state.size
      );
      terminal.target = makeBlockId(rewrittenId);
    }
    this.traverseTerminal(stmt, state);
  }
}
function inferMutableContextVariables(fn) {
  const state = new IdentifierState();
  const knownMutatedIdentifiers = new Set();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'PropertyLoad': {
          state.declareProperty(
            instr.lvalue,
            instr.value.object,
            instr.value.property
          );
          break;
        }
        case 'ComputedLoad': {
          state.declareProperty(instr.lvalue, instr.value.object, '');
          break;
        }
        case 'LoadLocal':
        case 'LoadContext': {
          if (instr.lvalue.identifier.name === null) {
            state.declareTemporary(instr.lvalue, instr.value.place);
          }
          break;
        }
        default: {
          for (const operand of eachInstructionValueOperand(instr.value)) {
            visitOperand(state, knownMutatedIdentifiers, operand);
          }
        }
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      visitOperand(state, knownMutatedIdentifiers, operand);
    }
  }
  for (const operand of fn.context) {
    if (knownMutatedIdentifiers.has(operand.identifier)) {
      operand.effect = exports.Effect.Mutate;
    }
  }
}
function visitOperand(state, knownMutatedIdentifiers, operand) {
  const resolved = state.resolve(operand.identifier);
  if (
    operand.effect === exports.Effect.Mutate ||
    operand.effect === exports.Effect.Store
  ) {
    knownMutatedIdentifiers.add(resolved);
  }
}
function inferAliases(func) {
  const aliases = new DisjointSet();
  for (const [_, block] of func.body.blocks) {
    for (const instr of block.instructions) {
      inferInstr(instr, aliases);
    }
  }
  return aliases;
}
function inferInstr(instr, aliases) {
  const {lvalue: lvalue, value: instrValue} = instr;
  let alias = null;
  switch (instrValue.kind) {
    case 'LoadLocal':
    case 'LoadContext': {
      if (isPrimitiveType(instrValue.place.identifier)) {
        return;
      }
      alias = instrValue.place;
      break;
    }
    case 'StoreLocal':
    case 'StoreContext': {
      alias = instrValue.value;
      break;
    }
    case 'Destructure': {
      alias = instrValue.value;
      break;
    }
    case 'ComputedLoad':
    case 'PropertyLoad': {
      alias = instrValue.object;
      break;
    }
    case 'TypeCastExpression': {
      alias = instrValue.value;
      break;
    }
    default:
      return;
  }
  aliases.union([lvalue.identifier, alias.identifier]);
}
function inferAliasForPhis(func, aliases) {
  var _a, _b;
  for (const [_, block] of func.body.blocks) {
    for (const phi of block.phis) {
      const isPhiMutatedAfterCreation =
        phi.place.identifier.mutableRange.end >
        ((_b =
          (_a = block.instructions.at(0)) === null || _a === void 0
            ? void 0
            : _a.id) !== null && _b !== void 0
          ? _b
          : block.terminal.id);
      if (isPhiMutatedAfterCreation) {
        for (const [, operand] of phi.operands) {
          aliases.union([phi.place.identifier, operand.identifier]);
        }
      }
    }
  }
}
function inferAliasForStores(func, aliases) {
  for (const [_, block] of func.body.blocks) {
    for (const instr of block.instructions) {
      const {value: value, lvalue: lvalue} = instr;
      const isStore =
        lvalue.effect === exports.Effect.Store ||
        ![...eachInstructionValueOperand(value)].every(
          operand => operand.effect !== exports.Effect.Store
        );
      if (!isStore) {
        continue;
      }
      for (const operand of eachInstructionLValue(instr)) {
        maybeAlias(aliases, lvalue, operand, instr.id);
      }
      for (const operand of eachInstructionValueOperand(value)) {
        if (
          operand.effect === exports.Effect.Capture ||
          operand.effect === exports.Effect.Store
        ) {
          maybeAlias(aliases, lvalue, operand, instr.id);
        }
      }
    }
  }
}
function maybeAlias(aliases, lvalue, rvalue, id) {
  if (
    lvalue.identifier.mutableRange.end > id + 1 ||
    rvalue.identifier.mutableRange.end > id
  ) {
    aliases.union([lvalue.identifier, rvalue.identifier]);
  }
}
function infer$1(place, instrId) {
  if (!isRefOrRefValue(place.identifier)) {
    place.identifier.mutableRange.end = makeInstructionId(instrId + 1);
  }
}
function inferPlace(place, instrId, inferMutableRangeForStores) {
  switch (place.effect) {
    case exports.Effect.Unknown: {
      throw new Error(`Found an unknown place ${printPlace(place)}}!`);
    }
    case exports.Effect.Capture:
    case exports.Effect.Read:
    case exports.Effect.Freeze:
      return;
    case exports.Effect.Store:
      if (inferMutableRangeForStores) {
        infer$1(place, instrId);
      }
      return;
    case exports.Effect.ConditionallyMutate:
    case exports.Effect.Mutate: {
      infer$1(place, instrId);
      return;
    }
    default:
      assertExhaustive(place.effect, `Unexpected ${printPlace(place)} effect`);
  }
}
function inferMutableLifetimes(func, inferMutableRangeForStores) {
  var _a, _b;
  const contextVariableDeclarationInstructions = new Map();
  for (const [_, block] of func.body.blocks) {
    for (const phi of block.phis) {
      const isPhiMutatedAfterCreation =
        phi.place.identifier.mutableRange.end >
        ((_b =
          (_a = block.instructions.at(0)) === null || _a === void 0
            ? void 0
            : _a.id) !== null && _b !== void 0
          ? _b
          : block.terminal.id);
      if (
        inferMutableRangeForStores &&
        isPhiMutatedAfterCreation &&
        phi.place.identifier.mutableRange.start === 0
      ) {
        for (const [, operand] of phi.operands) {
          if (phi.place.identifier.mutableRange.start === 0) {
            phi.place.identifier.mutableRange.start =
              operand.identifier.mutableRange.start;
          } else {
            phi.place.identifier.mutableRange.start = makeInstructionId(
              Math.min(
                phi.place.identifier.mutableRange.start,
                operand.identifier.mutableRange.start
              )
            );
          }
        }
      }
    }
    for (const instr of block.instructions) {
      for (const operand of eachInstructionLValue(instr)) {
        const lvalueId = operand.identifier;
        lvalueId.mutableRange.start = instr.id;
        lvalueId.mutableRange.end = makeInstructionId(instr.id + 1);
      }
      for (const operand of eachInstructionOperand(instr)) {
        inferPlace(operand, instr.id, inferMutableRangeForStores);
      }
      if (
        instr.value.kind === 'DeclareContext' ||
        (instr.value.kind === 'StoreContext' &&
          instr.value.lvalue.kind !== InstructionKind.Reassign)
      ) {
        contextVariableDeclarationInstructions.set(
          instr.value.lvalue.place.identifier,
          instr.id
        );
      } else if (instr.value.kind === 'StoreContext') {
        const declaration = contextVariableDeclarationInstructions.get(
          instr.value.lvalue.place.identifier
        );
        if (
          declaration != null &&
          !isRefOrRefValue(instr.value.lvalue.place.identifier)
        ) {
          const range = instr.value.lvalue.place.identifier.mutableRange;
          if (range.start === 0) {
            range.start = declaration;
          } else {
            range.start = makeInstructionId(Math.min(range.start, declaration));
          }
        }
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      inferPlace(operand, block.terminal.id, inferMutableRangeForStores);
    }
  }
}
function inferMutableRangesForAlias(_fn, aliases) {
  const aliasSets = aliases.buildSets();
  for (const aliasSet of aliasSets) {
    const mutatingIdentifiers = [...aliasSet].filter(
      id =>
        id.mutableRange.end - id.mutableRange.start > 1 && !isRefOrRefValue(id)
    );
    if (mutatingIdentifiers.length > 0) {
      let lastMutatingInstructionId = 0;
      for (const id of mutatingIdentifiers) {
        if (id.mutableRange.end > lastMutatingInstructionId) {
          lastMutatingInstructionId = id.mutableRange.end;
        }
      }
      for (const alias of aliasSet) {
        if (
          alias.mutableRange.end < lastMutatingInstructionId &&
          !isRefOrRefValue(alias)
        ) {
          alias.mutableRange.end = lastMutatingInstructionId;
        }
      }
    }
  }
}
function inferTryCatchAliases(fn, aliases) {
  const handlerParams = new Map();
  for (const [_, block] of fn.body.blocks) {
    if (
      block.terminal.kind === 'try' &&
      block.terminal.handlerBinding !== null
    ) {
      handlerParams.set(
        block.terminal.handler,
        block.terminal.handlerBinding.identifier
      );
    } else if (block.terminal.kind === 'maybe-throw') {
      const handlerParam = handlerParams.get(block.terminal.handler);
      if (handlerParam === undefined) {
        continue;
      }
      for (const instr of block.instructions) {
        aliases.union([handlerParam, instr.lvalue.identifier]);
      }
    }
  }
}
function inferMutableRanges(ir) {
  inferMutableLifetimes(ir, false);
  const aliases = inferAliases(ir);
  inferTryCatchAliases(ir, aliases);
  let prevAliases = aliases.canonicalize();
  while (true) {
    inferMutableRangesForAlias(ir, aliases);
    inferAliasForStores(ir, aliases);
    inferAliasForPhis(ir, aliases);
    const nextAliases = aliases.canonicalize();
    if (areEqualMaps(prevAliases, nextAliases)) {
      break;
    }
    prevAliases = nextAliases;
  }
  inferMutableLifetimes(ir, true);
  prevAliases = aliases.canonicalize();
  while (true) {
    inferMutableRangesForAlias(ir, aliases);
    inferAliasForPhis(ir, aliases);
    const nextAliases = aliases.canonicalize();
    if (areEqualMaps(prevAliases, nextAliases)) {
      break;
    }
    prevAliases = nextAliases;
  }
}
function areEqualMaps(a, b) {
  if (a.size !== b.size) {
    return false;
  }
  for (const [key, value] of a) {
    if (!b.has(key)) {
      return false;
    }
    if (b.get(key) !== value) {
      return false;
    }
  }
  return true;
}
class IdentifierState {
  constructor() {
    this.properties = new Map();
  }
  resolve(identifier) {
    const resolved = this.properties.get(identifier);
    if (resolved !== undefined) {
      return resolved.identifier;
    }
    return identifier;
  }
  declareProperty(lvalue, object, property) {
    const objectDependency = this.properties.get(object.identifier);
    let nextDependency;
    if (objectDependency === undefined) {
      nextDependency = {identifier: object.identifier, path: [property]};
    } else {
      nextDependency = {
        identifier: objectDependency.identifier,
        path: [...objectDependency.path, property],
      };
    }
    this.properties.set(lvalue.identifier, nextDependency);
  }
  declareTemporary(lvalue, value) {
    var _a;
    const resolved =
      (_a = this.properties.get(value.identifier)) !== null && _a !== void 0
        ? _a
        : {identifier: value.identifier, path: []};
    this.properties.set(lvalue.identifier, resolved);
  }
}
function analyseFunctions(func) {
  const state = new IdentifierState();
  for (const [_, block] of func.body.blocks) {
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'ObjectMethod':
        case 'FunctionExpression': {
          lower(instr.value.loweredFunc.func);
          infer(instr.value.loweredFunc, state, func.context);
          break;
        }
        case 'PropertyLoad': {
          state.declareProperty(
            instr.lvalue,
            instr.value.object,
            instr.value.property
          );
          break;
        }
        case 'ComputedLoad': {
          state.declareProperty(instr.lvalue, instr.value.object, '');
          break;
        }
        case 'LoadLocal':
        case 'LoadContext': {
          if (instr.lvalue.identifier.name === null) {
            state.declareTemporary(instr.lvalue, instr.value.place);
          }
          break;
        }
      }
    }
  }
}
function lower(func) {
  analyseFunctions(func);
  inferReferenceEffects(func, {isFunctionExpression: true});
  deadCodeElimination(func);
  inferMutableRanges(func);
  rewriteInstructionKindsBasedOnReassignment(func);
  inferReactiveScopeVariables(func);
  inferMutableContextVariables(func);
}
function infer(loweredFunc, state, context) {
  const mutations = new Map();
  for (const operand of loweredFunc.func.context) {
    if (
      isMutatedOrReassigned(operand.identifier) &&
      operand.identifier.name !== null
    ) {
      mutations.set(operand.identifier.name.value, operand.effect);
    }
  }
  for (const dep of loweredFunc.dependencies) {
    let name = null;
    if (state.properties.has(dep.identifier)) {
      const receiver = state.properties.get(dep.identifier);
      name = receiver.identifier.name;
    } else {
      name = dep.identifier.name;
    }
    if (isRefOrRefValue(dep.identifier)) {
      dep.effect = exports.Effect.Capture;
    } else if (name !== null) {
      const effect = mutations.get(name.value);
      if (effect !== undefined) {
        dep.effect =
          effect === exports.Effect.Unknown ? exports.Effect.Capture : effect;
      }
    }
  }
  for (const place of context) {
    CompilerError.invariant(place.identifier.name !== null, {
      reason: 'context refs should always have a name',
      description: null,
      loc: place.loc,
      suggestions: null,
    });
    const effect = mutations.get(place.identifier.name.value);
    if (effect !== undefined) {
      place.effect =
        effect === exports.Effect.Unknown ? exports.Effect.Capture : effect;
      loweredFunc.dependencies.push(place);
    }
  }
  for (const operand of loweredFunc.func.context) {
    operand.identifier.mutableRange.start = makeInstructionId(0);
    operand.identifier.mutableRange.end = makeInstructionId(0);
    operand.identifier.scope = null;
  }
}
function isMutatedOrReassigned(id) {
  return id.mutableRange.end > id.mutableRange.start;
}
function collectMaybeMemoDependencies(value, maybeDeps, optional) {
  var _a;
  switch (value.kind) {
    case 'LoadGlobal': {
      return {
        root: {kind: 'Global', identifierName: value.binding.name},
        path: [],
      };
    }
    case 'PropertyLoad': {
      const object = maybeDeps.get(value.object.identifier.id);
      if (object != null) {
        return {
          root: object.root,
          path: [
            ...object.path,
            {property: value.property, optional: optional},
          ],
        };
      }
      break;
    }
    case 'LoadLocal':
    case 'LoadContext': {
      const source = maybeDeps.get(value.place.identifier.id);
      if (source != null) {
        return source;
      } else if (
        value.place.identifier.name != null &&
        value.place.identifier.name.kind === 'named'
      ) {
        return {
          root: {kind: 'NamedLocal', value: Object.assign({}, value.place)},
          path: [],
        };
      }
      break;
    }
    case 'StoreLocal': {
      const lvalue = value.lvalue.place.identifier;
      const rvalue = value.value.identifier.id;
      const aliased = maybeDeps.get(rvalue);
      if (
        aliased != null &&
        ((_a = lvalue.name) === null || _a === void 0 ? void 0 : _a.kind) !==
          'named'
      ) {
        maybeDeps.set(lvalue.id, aliased);
        return aliased;
      }
      break;
    }
  }
  return null;
}
function collectTemporaries(instr, env, sidemap) {
  const {value: value, lvalue: lvalue} = instr;
  switch (value.kind) {
    case 'FunctionExpression': {
      sidemap.functions.set(instr.lvalue.identifier.id, instr);
      break;
    }
    case 'LoadGlobal': {
      const global = env.getGlobalDeclaration(value.binding, value.loc);
      const hookKind = global !== null ? getHookKindForType(env, global) : null;
      const lvalId = instr.lvalue.identifier.id;
      if (hookKind === 'useMemo' || hookKind === 'useCallback') {
        sidemap.manualMemos.set(lvalId, {kind: hookKind, loadInstr: instr});
      } else if (value.binding.name === 'React') {
        sidemap.react.add(lvalId);
      }
      break;
    }
    case 'PropertyLoad': {
      if (sidemap.react.has(value.object.identifier.id)) {
        if (value.property === 'useMemo' || value.property === 'useCallback') {
          sidemap.manualMemos.set(instr.lvalue.identifier.id, {
            kind: value.property,
            loadInstr: instr,
          });
        }
      }
      break;
    }
    case 'ArrayExpression': {
      if (value.elements.every(e => e.kind === 'Identifier')) {
        sidemap.maybeDepsLists.set(instr.lvalue.identifier.id, value.elements);
      }
      break;
    }
  }
  const maybeDep = collectMaybeMemoDependencies(
    value,
    sidemap.maybeDeps,
    sidemap.optionals.has(lvalue.identifier.id)
  );
  if (maybeDep != null) {
    sidemap.maybeDeps.set(lvalue.identifier.id, maybeDep);
  }
}
function makeManualMemoizationMarkers(
  fnExpr,
  env,
  depsList,
  memoDecl,
  manualMemoId
) {
  return [
    {
      id: makeInstructionId(0),
      lvalue: createTemporaryPlace(env, fnExpr.loc),
      value: {
        kind: 'StartMemoize',
        manualMemoId: manualMemoId,
        deps: depsList,
        loc: fnExpr.loc,
      },
      loc: fnExpr.loc,
    },
    {
      id: makeInstructionId(0),
      lvalue: createTemporaryPlace(env, fnExpr.loc),
      value: {
        kind: 'FinishMemoize',
        manualMemoId: manualMemoId,
        decl: Object.assign({}, memoDecl),
        loc: fnExpr.loc,
      },
      loc: fnExpr.loc,
    },
  ];
}
function getManualMemoizationReplacement(fn, loc, kind) {
  if (kind === 'useMemo') {
    return {kind: 'CallExpression', callee: fn, args: [], loc: loc};
  } else {
    return {
      kind: 'LoadLocal',
      place: {
        kind: 'Identifier',
        identifier: fn.identifier,
        effect: exports.Effect.Unknown,
        reactive: false,
        loc: loc,
      },
      loc: loc,
    };
  }
}
function extractManualMemoizationArgs(instr, kind, sidemap) {
  const [fnPlace, depsListPlace] = instr.value.args;
  if (fnPlace == null) {
    CompilerError.throwInvalidReact({
      reason: `Expected a callback function to be passed to ${kind}`,
      loc: instr.value.loc,
      suggestions: null,
    });
  }
  if (
    fnPlace.kind === 'Spread' ||
    (depsListPlace === null || depsListPlace === void 0
      ? void 0
      : depsListPlace.kind) === 'Spread'
  ) {
    CompilerError.throwInvalidReact({
      reason: `Unexpected spread argument to ${kind}`,
      loc: instr.value.loc,
      suggestions: null,
    });
  }
  let depsList = null;
  if (depsListPlace != null) {
    const maybeDepsList = sidemap.maybeDepsLists.get(
      depsListPlace.identifier.id
    );
    if (maybeDepsList == null) {
      CompilerError.throwInvalidReact({
        reason: `Expected the dependency list for ${kind} to be an array literal`,
        suggestions: null,
        loc: depsListPlace.loc,
      });
    }
    depsList = maybeDepsList.map(dep => {
      const maybeDep = sidemap.maybeDeps.get(dep.identifier.id);
      if (maybeDep == null) {
        CompilerError.throwInvalidReact({
          reason: `Expected the dependency list to be an array of simple expressions (e.g. \`x\`, \`x.y.z\`, \`x?.y?.z\`)`,
          suggestions: null,
          loc: dep.loc,
        });
      }
      return maybeDep;
    });
  }
  return {fnPlace: fnPlace, depsList: depsList};
}
function dropManualMemoization(func) {
  const isValidationEnabled =
    func.env.config.validatePreserveExistingMemoizationGuarantees ||
    func.env.config.validateNoSetStateInRender ||
    func.env.config.enablePreserveExistingMemoizationGuarantees;
  const optionals = findOptionalPlaces(func);
  const sidemap = {
    functions: new Map(),
    manualMemos: new Map(),
    react: new Set(),
    maybeDeps: new Map(),
    maybeDepsLists: new Map(),
    optionals: optionals,
  };
  let nextManualMemoId = 0;
  const queuedInserts = new Map();
  for (const [_, block] of func.body.blocks) {
    for (let i = 0; i < block.instructions.length; i++) {
      const instr = block.instructions[i];
      if (
        instr.value.kind === 'CallExpression' ||
        instr.value.kind === 'MethodCall'
      ) {
        const id =
          instr.value.kind === 'CallExpression'
            ? instr.value.callee.identifier.id
            : instr.value.property.identifier.id;
        const manualMemo = sidemap.manualMemos.get(id);
        if (manualMemo != null) {
          const {fnPlace: fnPlace, depsList: depsList} =
            extractManualMemoizationArgs(instr, manualMemo.kind, sidemap);
          instr.value = getManualMemoizationReplacement(
            fnPlace,
            instr.value.loc,
            manualMemo.kind
          );
          if (isValidationEnabled) {
            if (!sidemap.functions.has(fnPlace.identifier.id)) {
              CompilerError.throwInvalidReact({
                reason: `Expected the first argument to be an inline function expression`,
                suggestions: [],
                loc: fnPlace.loc,
              });
            }
            const memoDecl =
              manualMemo.kind === 'useMemo'
                ? instr.lvalue
                : {
                    kind: 'Identifier',
                    identifier: fnPlace.identifier,
                    effect: exports.Effect.Unknown,
                    reactive: false,
                    loc: fnPlace.loc,
                  };
            const [startMarker, finishMarker] = makeManualMemoizationMarkers(
              fnPlace,
              func.env,
              depsList,
              memoDecl,
              nextManualMemoId++
            );
            queuedInserts.set(manualMemo.loadInstr.id, startMarker);
            queuedInserts.set(instr.id, finishMarker);
          }
        }
      } else {
        collectTemporaries(instr, func.env, sidemap);
      }
    }
  }
  if (queuedInserts.size > 0) {
    let hasChanges = false;
    for (const [_, block] of func.body.blocks) {
      let nextInstructions = null;
      for (let i = 0; i < block.instructions.length; i++) {
        const instr = block.instructions[i];
        const insertInstr = queuedInserts.get(instr.id);
        if (insertInstr != null) {
          nextInstructions =
            nextInstructions !== null && nextInstructions !== void 0
              ? nextInstructions
              : block.instructions.slice(0, i);
          nextInstructions.push(instr);
          nextInstructions.push(insertInstr);
        } else if (nextInstructions != null) {
          nextInstructions.push(instr);
        }
      }
      if (nextInstructions !== null) {
        block.instructions = nextInstructions;
        hasChanges = true;
      }
    }
    if (hasChanges) {
      markInstructionIds(func.body);
    }
  }
}
function findOptionalPlaces(fn) {
  const optionals = new Set();
  for (const [, block] of fn.body.blocks) {
    if (block.terminal.kind === 'optional' && block.terminal.optional) {
      const optionalTerminal = block.terminal;
      let testBlock = fn.body.blocks.get(block.terminal.test);
      loop: while (true) {
        const terminal = testBlock.terminal;
        switch (terminal.kind) {
          case 'branch': {
            if (terminal.fallthrough === optionalTerminal.fallthrough) {
              const consequent = fn.body.blocks.get(terminal.consequent);
              const last = consequent.instructions.at(-1);
              if (last !== undefined && last.value.kind === 'StoreLocal') {
                optionals.add(last.value.value.identifier.id);
              }
              break loop;
            } else {
              testBlock = fn.body.blocks.get(terminal.fallthrough);
            }
            break;
          }
          case 'optional':
          case 'logical':
          case 'sequence':
          case 'ternary': {
            testBlock = fn.body.blocks.get(terminal.fallthrough);
            break;
          }
          default: {
            CompilerError.invariant(false, {
              reason: `Unexpected terminal in optional`,
              loc: terminal.loc,
            });
          }
        }
      }
    }
  }
  return optionals;
}
function inferReactivePlaces(fn) {
  const reactiveIdentifiers = new ReactivityMap(findDisjointMutableValues(fn));
  for (const param of fn.params) {
    const place = param.kind === 'Identifier' ? param : param.place;
    reactiveIdentifiers.markReactive(place);
  }
  const postDominators = computePostDominatorTree(fn, {
    includeThrowsAsExitNode: false,
  });
  const postDominatorFrontierCache = new Map();
  function isReactiveControlledBlock(id) {
    let controlBlocks = postDominatorFrontierCache.get(id);
    if (controlBlocks === undefined) {
      controlBlocks = postDominatorFrontier(fn, postDominators, id);
      postDominatorFrontierCache.set(id, controlBlocks);
    }
    for (const blockId of controlBlocks) {
      const controlBlock = fn.body.blocks.get(blockId);
      switch (controlBlock.terminal.kind) {
        case 'if':
        case 'branch': {
          if (reactiveIdentifiers.isReactive(controlBlock.terminal.test)) {
            return true;
          }
          break;
        }
        case 'switch': {
          if (reactiveIdentifiers.isReactive(controlBlock.terminal.test)) {
            return true;
          }
          for (const case_ of controlBlock.terminal.cases) {
            if (
              case_.test !== null &&
              reactiveIdentifiers.isReactive(case_.test)
            ) {
              return true;
            }
          }
          break;
        }
      }
    }
    return false;
  }
  do {
    for (const [, block] of fn.body.blocks) {
      let hasReactiveControl = isReactiveControlledBlock(block.id);
      for (const phi of block.phis) {
        if (reactiveIdentifiers.isReactive(phi.place)) {
          continue;
        }
        let isPhiReactive = false;
        for (const [, operand] of phi.operands) {
          if (reactiveIdentifiers.isReactive(operand)) {
            isPhiReactive = true;
            break;
          }
        }
        if (isPhiReactive) {
          reactiveIdentifiers.markReactive(phi.place);
        } else {
          for (const [pred] of phi.operands) {
            if (isReactiveControlledBlock(pred)) {
              reactiveIdentifiers.markReactive(phi.place);
              break;
            }
          }
        }
      }
      for (const instruction of block.instructions) {
        const {value: value} = instruction;
        let hasReactiveInput = false;
        for (const operand of eachInstructionValueOperand(value)) {
          const reactive = reactiveIdentifiers.isReactive(operand);
          hasReactiveInput || (hasReactiveInput = reactive);
        }
        if (
          value.kind === 'CallExpression' &&
          (getHookKind(fn.env, value.callee.identifier) != null ||
            isUseOperator(value.callee.identifier))
        ) {
          hasReactiveInput = true;
        } else if (
          value.kind === 'MethodCall' &&
          (getHookKind(fn.env, value.property.identifier) != null ||
            isUseOperator(value.property.identifier))
        ) {
          hasReactiveInput = true;
        }
        if (hasReactiveInput) {
          for (const lvalue of eachInstructionLValue(instruction)) {
            if (isStableType(lvalue.identifier)) {
              continue;
            }
            reactiveIdentifiers.markReactive(lvalue);
          }
        }
        if (hasReactiveInput || hasReactiveControl) {
          for (const operand of eachInstructionValueOperand(value)) {
            switch (operand.effect) {
              case exports.Effect.Capture:
              case exports.Effect.Store:
              case exports.Effect.ConditionallyMutate:
              case exports.Effect.Mutate: {
                if (isMutable(instruction, operand)) {
                  reactiveIdentifiers.markReactive(operand);
                }
                break;
              }
              case exports.Effect.Freeze:
              case exports.Effect.Read: {
                break;
              }
              case exports.Effect.Unknown: {
                CompilerError.invariant(false, {
                  reason: 'Unexpected unknown effect',
                  description: null,
                  loc: operand.loc,
                  suggestions: null,
                });
              }
              default: {
                assertExhaustive(
                  operand.effect,
                  `Unexpected effect kind \`${operand.effect}\``
                );
              }
            }
          }
        }
      }
      for (const operand of eachTerminalOperand(block.terminal)) {
        reactiveIdentifiers.isReactive(operand);
      }
    }
  } while (reactiveIdentifiers.snapshot());
}
function postDominatorFrontier(fn, postDominators, targetId) {
  const visited = new Set();
  const frontier = new Set();
  const targetPostDominators = postDominatorsOf(fn, postDominators, targetId);
  for (const blockId of [...targetPostDominators, targetId]) {
    if (visited.has(blockId)) {
      continue;
    }
    visited.add(blockId);
    const block = fn.body.blocks.get(blockId);
    for (const pred of block.preds) {
      if (!targetPostDominators.has(pred)) {
        frontier.add(pred);
      }
    }
  }
  return frontier;
}
function postDominatorsOf(fn, postDominators, targetId) {
  var _a;
  const result = new Set();
  const visited = new Set();
  const queue = [targetId];
  while (queue.length) {
    const currentId = queue.shift();
    if (visited.has(currentId)) {
      continue;
    }
    visited.add(currentId);
    const current = fn.body.blocks.get(currentId);
    for (const pred of current.preds) {
      const predPostDominator =
        (_a = postDominators.get(pred)) !== null && _a !== void 0 ? _a : pred;
      if (predPostDominator === targetId || result.has(predPostDominator)) {
        result.add(pred);
      }
      queue.push(pred);
    }
  }
  return result;
}
class ReactivityMap {
  constructor(aliasedIdentifiers) {
    this.hasChanges = false;
    this.reactive = new Set();
    this.aliasedIdentifiers = aliasedIdentifiers;
  }
  isReactive(place) {
    var _a;
    const identifier =
      (_a = this.aliasedIdentifiers.find(place.identifier)) !== null &&
      _a !== void 0
        ? _a
        : place.identifier;
    const reactive = this.reactive.has(identifier.id);
    if (reactive) {
      place.reactive = true;
    }
    return reactive;
  }
  markReactive(place) {
    var _a;
    place.reactive = true;
    const identifier =
      (_a = this.aliasedIdentifiers.find(place.identifier)) !== null &&
      _a !== void 0
        ? _a
        : place.identifier;
    if (!this.reactive.has(identifier.id)) {
      this.hasChanges = true;
      this.reactive.add(identifier.id);
    }
  }
  snapshot() {
    const hasChanges = this.hasChanges;
    this.hasChanges = false;
    return hasChanges;
  }
}
function inlineImmediatelyInvokedFunctionExpressions(fn) {
  const functions = new Map();
  const inlinedFunctions = new Set();
  const queue = Array.from(fn.body.blocks.values());
  queue: for (const block of queue) {
    for (let ii = 0; ii < block.instructions.length; ii++) {
      const instr = block.instructions[ii];
      switch (instr.value.kind) {
        case 'FunctionExpression': {
          if (instr.lvalue.identifier.name === null) {
            functions.set(instr.lvalue.identifier.id, instr.value);
          }
          break;
        }
        case 'CallExpression': {
          if (instr.value.args.length !== 0) {
            continue;
          }
          const body = functions.get(instr.value.callee.identifier.id);
          if (body === undefined) {
            continue;
          }
          if (
            body.loweredFunc.func.params.length > 0 ||
            body.loweredFunc.func.async ||
            body.loweredFunc.func.generator
          ) {
            continue;
          }
          inlinedFunctions.add(instr.value.callee.identifier.id);
          const continuationBlockId = fn.env.nextBlockId;
          const continuationBlock = {
            id: continuationBlockId,
            instructions: block.instructions.slice(ii + 1),
            kind: block.kind,
            phis: new Set(),
            preds: new Set(),
            terminal: block.terminal,
          };
          fn.body.blocks.set(continuationBlockId, continuationBlock);
          block.instructions.length = ii;
          const newTerminal = {
            block: body.loweredFunc.func.body.entry,
            id: makeInstructionId(0),
            kind: 'label',
            fallthrough: continuationBlockId,
            loc: block.terminal.loc,
          };
          block.terminal = newTerminal;
          const result = instr.lvalue;
          declareTemporary(fn.env, block, result);
          promoteTemporary(result.identifier);
          for (const [id, block] of body.loweredFunc.func.body.blocks) {
            block.preds.clear();
            rewriteBlock(fn.env, block, continuationBlockId, result);
            fn.body.blocks.set(id, block);
          }
          queue.push(continuationBlock);
          continue queue;
        }
        default: {
          for (const place of eachInstructionValueOperand(instr.value)) {
            functions.delete(place.identifier.id);
          }
        }
      }
    }
  }
  if (inlinedFunctions.size !== 0) {
    for (const [, block] of fn.body.blocks) {
      retainWhere(
        block.instructions,
        instr => !inlinedFunctions.has(instr.lvalue.identifier.id)
      );
    }
    reversePostorderBlocks(fn.body);
    markInstructionIds(fn.body);
    markPredecessors(fn.body);
  }
}
function rewriteBlock(env, block, returnTarget, returnValue) {
  const {terminal: terminal} = block;
  if (terminal.kind !== 'return') {
    return;
  }
  block.instructions.push({
    id: makeInstructionId(0),
    loc: terminal.loc,
    lvalue: createTemporaryPlace(env, terminal.loc),
    value: {
      kind: 'StoreLocal',
      lvalue: {
        kind: InstructionKind.Reassign,
        place: Object.assign({}, returnValue),
      },
      value: terminal.value,
      type: null,
      loc: terminal.loc,
    },
  });
  block.terminal = {
    kind: 'goto',
    block: returnTarget,
    id: makeInstructionId(0),
    variant: GotoVariant.Break,
    loc: block.terminal.loc,
  };
}
function declareTemporary(env, block, result) {
  block.instructions.push({
    id: makeInstructionId(0),
    loc: GeneratedSource,
    lvalue: createTemporaryPlace(env, result.loc),
    value: {
      kind: 'DeclareLocal',
      lvalue: {place: result, kind: InstructionKind.Let},
      type: null,
      loc: result.loc,
    },
  });
}
function inferEffectDependencies(fn) {
  let hasRewrite = false;
  const fnExpressions = new Map();
  const autodepFnConfigs = new Map();
  for (const effectTarget of fn.env.config.inferEffectDependencies) {
    const moduleTargets = getOrInsertWith(
      autodepFnConfigs,
      effectTarget.function.source,
      () => new Map()
    );
    moduleTargets.set(
      effectTarget.function.importSpecifierName,
      effectTarget.numRequiredArgs
    );
  }
  const autodepFnLoads = new Map();
  const scopeInfos = new Map();
  const reactiveIds = inferReactiveIdentifiers(fn);
  for (const [, block] of fn.body.blocks) {
    if (
      block.terminal.kind === 'scope' ||
      block.terminal.kind === 'pruned-scope'
    ) {
      const scopeBlock = fn.body.blocks.get(block.terminal.block);
      scopeInfos.set(block.terminal.scope.id, {
        pruned: block.terminal.kind === 'pruned-scope',
        deps: block.terminal.scope.dependencies,
        hasSingleInstr:
          scopeBlock.instructions.length === 1 &&
          scopeBlock.terminal.kind === 'goto' &&
          scopeBlock.terminal.block === block.terminal.fallthrough,
      });
    }
    const rewriteInstrs = new Map();
    for (const instr of block.instructions) {
      const {value: value, lvalue: lvalue} = instr;
      if (value.kind === 'FunctionExpression') {
        fnExpressions.set(lvalue.identifier.id, instr);
      } else if (
        value.kind === 'LoadGlobal' &&
        value.binding.kind === 'ImportSpecifier'
      ) {
        const moduleTargets = autodepFnConfigs.get(value.binding.module);
        if (moduleTargets != null) {
          const numRequiredArgs = moduleTargets.get(value.binding.imported);
          if (numRequiredArgs != null) {
            autodepFnLoads.set(lvalue.identifier.id, numRequiredArgs);
          }
        }
      } else if (
        value.kind === 'CallExpression' &&
        autodepFnLoads.get(value.callee.identifier.id) === value.args.length &&
        value.args[0].kind === 'Identifier'
      ) {
        const fnExpr = fnExpressions.get(value.args[0].identifier.id);
        if (fnExpr != null) {
          const scopeInfo =
            fnExpr.lvalue.identifier.scope != null
              ? scopeInfos.get(fnExpr.lvalue.identifier.scope.id)
              : null;
          CompilerError.invariant(scopeInfo != null, {
            reason: 'Expected function expression scope to exist',
            loc: value.loc,
          });
          if (scopeInfo.pruned || !scopeInfo.hasSingleInstr) {
            CompilerError.throwTodo({
              reason:
                '[InferEffectDependencies] Expected effect function to have non-pruned scope and its scope to have exactly one instruction',
              loc: fnExpr.loc,
            });
          }
          const effectDeps = [];
          const newInstructions = [];
          for (const dep of scopeInfo.deps) {
            const {place: place, instructions: instructions} =
              writeDependencyToInstructions(
                dep,
                reactiveIds.has(dep.identifier.id),
                fn.env,
                fnExpr.loc
              );
            newInstructions.push(...instructions);
            effectDeps.push(place);
          }
          const deps = {
            kind: 'ArrayExpression',
            elements: effectDeps,
            loc: GeneratedSource,
          };
          const depsPlace = createTemporaryPlace(fn.env, GeneratedSource);
          depsPlace.effect = exports.Effect.Read;
          newInstructions.push({
            id: makeInstructionId(0),
            loc: GeneratedSource,
            lvalue: Object.assign(Object.assign({}, depsPlace), {
              effect: exports.Effect.Mutate,
            }),
            value: deps,
          });
          value.args.push(
            Object.assign(Object.assign({}, depsPlace), {
              effect: exports.Effect.Freeze,
            })
          );
          rewriteInstrs.set(instr.id, newInstructions);
        }
      }
    }
    if (rewriteInstrs.size > 0) {
      hasRewrite = true;
      const newInstrs = [];
      for (const instr of block.instructions) {
        const newInstr = rewriteInstrs.get(instr.id);
        if (newInstr != null) {
          newInstrs.push(...newInstr, instr);
        } else {
          newInstrs.push(instr);
        }
      }
      block.instructions = newInstrs;
    }
  }
  if (hasRewrite) {
    markInstructionIds(fn.body);
    fixScopeAndIdentifierRanges(fn.body);
  }
}
function writeDependencyToInstructions(dep, reactive, env, loc) {
  const instructions = [];
  let currValue = createTemporaryPlace(env, GeneratedSource);
  currValue.reactive = reactive;
  instructions.push({
    id: makeInstructionId(0),
    loc: GeneratedSource,
    lvalue: Object.assign(Object.assign({}, currValue), {
      effect: exports.Effect.Mutate,
    }),
    value: {
      kind: 'LoadLocal',
      place: {
        kind: 'Identifier',
        identifier: dep.identifier,
        effect: exports.Effect.Capture,
        reactive: reactive,
        loc: loc,
      },
      loc: loc,
    },
  });
  for (const path of dep.path) {
    if (path.optional) {
      break;
    }
    const nextValue = createTemporaryPlace(env, GeneratedSource);
    nextValue.reactive = reactive;
    instructions.push({
      id: makeInstructionId(0),
      loc: GeneratedSource,
      lvalue: Object.assign(Object.assign({}, nextValue), {
        effect: exports.Effect.Mutate,
      }),
      value: {
        kind: 'PropertyLoad',
        object: Object.assign(Object.assign({}, currValue), {
          effect: exports.Effect.Capture,
        }),
        property: path.property,
        loc: loc,
      },
    });
    currValue = nextValue;
  }
  currValue.effect = exports.Effect.Freeze;
  return {place: currValue, instructions: instructions};
}
function inferReactiveIdentifiers(fn) {
  const reactiveIds = new Set();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      for (const place of eachInstructionOperand(instr)) {
        if (place.reactive) {
          reactiveIds.add(place.identifier.id);
        }
      }
    }
    for (const place of eachTerminalOperand(block.terminal)) {
      if (place.reactive) {
        reactiveIds.add(place.identifier.id);
      }
    }
  }
  return reactiveIds;
}
function instructionReordering(fn) {
  var _a;
  const shared = new Map();
  const references = findReferencedRangeOfTemporaries(fn);
  for (const [, block] of fn.body.blocks) {
    reorderBlock(fn.env, block, shared, references);
  }
  CompilerError.invariant(shared.size === 0, {
    reason: `InstructionReordering: expected all reorderable nodes to have been emitted`,
    loc:
      (_a = [...shared.values()]
        .map(node => {
          var _a;
          return (_a = node.instruction) === null || _a === void 0
            ? void 0
            : _a.loc;
        })
        .filter(loc => loc != null)[0]) !== null && _a !== void 0
        ? _a
        : GeneratedSource,
  });
  markInstructionIds(fn.body);
}
var ReferenceKind;
(function (ReferenceKind) {
  ReferenceKind[(ReferenceKind['Read'] = 0)] = 'Read';
  ReferenceKind[(ReferenceKind['Write'] = 1)] = 'Write';
})(ReferenceKind || (ReferenceKind = {}));
function findReferencedRangeOfTemporaries(fn) {
  const singleUseIdentifiers = new Map();
  const lastAssignments = new Map();
  function reference(instr, place, kind) {
    var _a;
    if (
      place.identifier.name !== null &&
      place.identifier.name.kind === 'named'
    ) {
      if (kind === ReferenceKind.Write) {
        const name = place.identifier.name.value;
        const previous = lastAssignments.get(name);
        if (previous === undefined) {
          lastAssignments.set(name, instr);
        } else {
          lastAssignments.set(
            name,
            makeInstructionId(Math.max(previous, instr))
          );
        }
      }
      return;
    } else if (kind === ReferenceKind.Read) {
      const previousCount =
        (_a = singleUseIdentifiers.get(place.identifier.id)) !== null &&
        _a !== void 0
          ? _a
          : 0;
      singleUseIdentifiers.set(place.identifier.id, previousCount + 1);
    }
  }
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      for (const operand of eachInstructionValueLValue(instr.value)) {
        reference(instr.id, operand, ReferenceKind.Read);
      }
      for (const lvalue of eachInstructionLValue(instr)) {
        reference(instr.id, lvalue, ReferenceKind.Write);
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      reference(block.terminal.id, operand, ReferenceKind.Read);
    }
  }
  return {
    singleUseIdentifiers: new Set(
      [...singleUseIdentifiers]
        .filter(([, count]) => count === 1)
        .map(([id]) => id)
    ),
    lastAssignments: lastAssignments,
  };
}
function reorderBlock(env, block, shared, references) {
  var _a, _b;
  const locals = new Map();
  const named = new Map();
  let previous = null;
  for (const instr of block.instructions) {
    const {lvalue: lvalue, value: value} = instr;
    const reorderability = getReorderability(instr, references);
    const node = getOrInsertWith(locals, lvalue.identifier.id, () => ({
      instruction: instr,
      dependencies: new Set(),
      reorderability: reorderability,
      depth: null,
    }));
    if (reorderability === Reorderability.Nonreorderable) {
      if (previous !== null) {
        node.dependencies.add(previous);
      }
      previous = lvalue.identifier.id;
    }
    for (const operand of eachInstructionValueOperand(value)) {
      const {name: name, id: id} = operand.identifier;
      if (name !== null && name.kind === 'named') {
        const previous = named.get(name.value);
        if (previous !== undefined) {
          node.dependencies.add(previous);
        }
        named.set(name.value, lvalue.identifier.id);
      } else if (locals.has(id) || shared.has(id)) {
        node.dependencies.add(id);
      }
    }
    for (const lvalueOperand of eachInstructionValueLValue(value)) {
      const lvalueNode = getOrInsertWith(
        locals,
        lvalueOperand.identifier.id,
        () => ({instruction: null, dependencies: new Set(), depth: null})
      );
      lvalueNode.dependencies.add(lvalue.identifier.id);
      const name = lvalueOperand.identifier.name;
      if (name !== null && name.kind === 'named') {
        const previous = named.get(name.value);
        if (previous !== undefined) {
          node.dependencies.add(previous);
        }
        named.set(name.value, lvalue.identifier.id);
      }
    }
  }
  const nextInstructions = [];
  if (isExpressionBlockKind(block.kind)) {
    if (previous !== null) {
      emit(env, locals, shared, nextInstructions, previous);
    }
    if (block.instructions.length !== 0) {
      emit(
        env,
        locals,
        shared,
        nextInstructions,
        block.instructions.at(-1).lvalue.identifier.id
      );
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      emit(env, locals, shared, nextInstructions, operand.identifier.id);
    }
    for (const [id, node] of locals) {
      if (node.instruction == null) {
        continue;
      }
      CompilerError.invariant(
        node.reorderability === Reorderability.Reorderable,
        {
          reason: `Expected all remaining instructions to be reorderable`,
          loc:
            (_b =
              (_a = node.instruction) === null || _a === void 0
                ? void 0
                : _a.loc) !== null && _b !== void 0
              ? _b
              : block.terminal.loc,
          description:
            node.instruction != null
              ? `Instruction [${node.instruction.id}] was not emitted yet but is not reorderable`
              : `Lvalue $${id} was not emitted yet but is not reorderable`,
        }
      );
      shared.set(id, node);
    }
  } else {
    for (const operand of eachTerminalOperand(block.terminal)) {
      emit(env, locals, shared, nextInstructions, operand.identifier.id);
    }
    for (const id of Array.from(locals.keys()).reverse()) {
      const node = locals.get(id);
      if (node === undefined) {
        continue;
      }
      if (node.reorderability === Reorderability.Reorderable) {
        shared.set(id, node);
      } else {
        emit(env, locals, shared, nextInstructions, id);
      }
    }
  }
  block.instructions = nextInstructions;
}
function getDepth(env, nodes, id) {
  const node = nodes.get(id);
  if (node == null) {
    return 0;
  }
  if (node.depth != null) {
    return node.depth;
  }
  node.depth = 0;
  let depth = node.reorderability === Reorderability.Reorderable ? 1 : 10;
  for (const dep of node.dependencies) {
    depth += getDepth(env, nodes, dep);
  }
  node.depth = depth;
  return depth;
}
function emit(env, locals, shared, instructions, id) {
  var _a;
  const node =
    (_a = locals.get(id)) !== null && _a !== void 0 ? _a : shared.get(id);
  if (node == null) {
    return;
  }
  locals.delete(id);
  shared.delete(id);
  const deps = [...node.dependencies];
  deps.sort((a, b) => {
    const aDepth = getDepth(env, locals, a);
    const bDepth = getDepth(env, locals, b);
    return bDepth - aDepth;
  });
  for (const dep of deps) {
    emit(env, locals, shared, instructions, dep);
  }
  if (node.instruction !== null) {
    instructions.push(node.instruction);
  }
}
var Reorderability;
(function (Reorderability) {
  Reorderability[(Reorderability['Reorderable'] = 0)] = 'Reorderable';
  Reorderability[(Reorderability['Nonreorderable'] = 1)] = 'Nonreorderable';
})(Reorderability || (Reorderability = {}));
function getReorderability(instr, references) {
  switch (instr.value.kind) {
    case 'JsxExpression':
    case 'JsxFragment':
    case 'JSXText':
    case 'LoadGlobal':
    case 'Primitive':
    case 'TemplateLiteral':
    case 'BinaryExpression':
    case 'UnaryExpression': {
      return Reorderability.Reorderable;
    }
    case 'LoadLocal': {
      const name = instr.value.place.identifier.name;
      if (name !== null && name.kind === 'named') {
        const lastAssignment = references.lastAssignments.get(name.value);
        if (
          lastAssignment !== undefined &&
          lastAssignment < instr.id &&
          references.singleUseIdentifiers.has(instr.lvalue.identifier.id)
        ) {
          return Reorderability.Reorderable;
        }
      }
      return Reorderability.Nonreorderable;
    }
    default: {
      return Reorderability.Nonreorderable;
    }
  }
}
function alignMethodCallScopes(fn) {
  const scopeMapping = new Map();
  const mergedScopes = new DisjointSet();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {lvalue: lvalue, value: value} = instr;
      if (value.kind === 'MethodCall') {
        const lvalueScope = lvalue.identifier.scope;
        const propertyScope = value.property.identifier.scope;
        if (lvalueScope !== null) {
          if (propertyScope !== null) {
            mergedScopes.union([lvalueScope, propertyScope]);
          } else {
            scopeMapping.set(value.property.identifier.id, lvalueScope);
          }
        } else if (propertyScope !== null) {
          scopeMapping.set(value.property.identifier.id, null);
        }
      } else if (
        value.kind === 'FunctionExpression' ||
        value.kind === 'ObjectMethod'
      ) {
        alignMethodCallScopes(value.loweredFunc.func);
      }
    }
  }
  mergedScopes.forEach((scope, root) => {
    if (scope === root) {
      return;
    }
    root.range.start = makeInstructionId(
      Math.min(scope.range.start, root.range.start)
    );
    root.range.end = makeInstructionId(
      Math.max(scope.range.end, root.range.end)
    );
  });
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const mappedScope = scopeMapping.get(instr.lvalue.identifier.id);
      if (mappedScope !== undefined) {
        instr.lvalue.identifier.scope = mappedScope;
      } else if (instr.lvalue.identifier.scope !== null) {
        const mergedScope = mergedScopes.find(instr.lvalue.identifier.scope);
        if (mergedScope != null) {
          instr.lvalue.identifier.scope = mergedScope;
        }
      }
    }
  }
}
function alignReactiveScopesToBlockScopesHIR(fn) {
  var _a, _b, _c, _d, _e;
  const activeBlockFallthroughRanges = [];
  const activeScopes = new Set();
  const seen = new Set();
  const valueBlockNodes = new Map();
  const placeScopes = new Map();
  function recordPlace(id, place, node) {
    if (place.identifier.scope !== null) {
      placeScopes.set(place, place.identifier.scope);
    }
    const scope = getPlaceScope(id, place);
    if (scope == null) {
      return;
    }
    activeScopes.add(scope);
    node === null || node === void 0
      ? void 0
      : node.children.push({kind: 'scope', scope: scope, id: id});
    if (seen.has(scope)) {
      return;
    }
    seen.add(scope);
    if (node != null && node.valueRange !== null) {
      scope.range.start = makeInstructionId(
        Math.min(node.valueRange.start, scope.range.start)
      );
      scope.range.end = makeInstructionId(
        Math.max(node.valueRange.end, scope.range.end)
      );
    }
  }
  for (const [, block] of fn.body.blocks) {
    const startingId =
      (_b =
        (_a = block.instructions[0]) === null || _a === void 0
          ? void 0
          : _a.id) !== null && _b !== void 0
        ? _b
        : block.terminal.id;
    retainWhere_Set(activeScopes, scope => scope.range.end > startingId);
    const top = activeBlockFallthroughRanges.at(-1);
    if (
      (top === null || top === void 0 ? void 0 : top.fallthrough) === block.id
    ) {
      activeBlockFallthroughRanges.pop();
      for (const scope of activeScopes) {
        scope.range.start = makeInstructionId(
          Math.min(scope.range.start, top.range.start)
        );
      }
    }
    const {instructions: instructions, terminal: terminal} = block;
    const node =
      (_c = valueBlockNodes.get(block.id)) !== null && _c !== void 0
        ? _c
        : null;
    for (const instr of instructions) {
      for (const lvalue of eachInstructionLValue(instr)) {
        recordPlace(instr.id, lvalue, node);
      }
      for (const operand of eachInstructionValueOperand(instr.value)) {
        recordPlace(instr.id, operand, node);
      }
    }
    for (const operand of eachTerminalOperand(terminal)) {
      recordPlace(terminal.id, operand, node);
    }
    const fallthrough = terminalFallthrough(terminal);
    if (fallthrough !== null && terminal.kind !== 'branch') {
      const fallthroughBlock = fn.body.blocks.get(fallthrough);
      const nextId =
        (_e =
          (_d = fallthroughBlock.instructions[0]) === null || _d === void 0
            ? void 0
            : _d.id) !== null && _e !== void 0
          ? _e
          : fallthroughBlock.terminal.id;
      for (const scope of activeScopes) {
        if (scope.range.end > terminal.id) {
          scope.range.end = makeInstructionId(
            Math.max(scope.range.end, nextId)
          );
        }
      }
      activeBlockFallthroughRanges.push({
        fallthrough: fallthrough,
        range: {start: terminal.id, end: nextId},
      });
      CompilerError.invariant(!valueBlockNodes.has(fallthrough), {
        reason: 'Expect hir blocks to have unique fallthroughs',
        loc: terminal.loc,
      });
      if (node != null) {
        valueBlockNodes.set(fallthrough, node);
      }
    }
    mapTerminalSuccessors(terminal, successor => {
      var _a, _b;
      if (valueBlockNodes.has(successor)) {
        return successor;
      }
      const successorBlock = fn.body.blocks.get(successor);
      if (successorBlock.kind === 'block' || successorBlock.kind === 'catch');
      else if (
        node == null ||
        terminal.kind === 'ternary' ||
        terminal.kind === 'logical' ||
        terminal.kind === 'optional'
      ) {
        let valueRange;
        if (node == null) {
          CompilerError.invariant(fallthrough !== null, {
            reason: `Expected a fallthrough for value block`,
            loc: terminal.loc,
          });
          const fallthroughBlock = fn.body.blocks.get(fallthrough);
          const nextId =
            (_b =
              (_a = fallthroughBlock.instructions[0]) === null || _a === void 0
                ? void 0
                : _a.id) !== null && _b !== void 0
              ? _b
              : fallthroughBlock.terminal.id;
          valueRange = {start: terminal.id, end: nextId};
        } else {
          valueRange = node.valueRange;
        }
        const childNode = {
          kind: 'node',
          id: terminal.id,
          children: [],
          valueRange: valueRange,
        };
        node === null || node === void 0
          ? void 0
          : node.children.push(childNode);
        valueBlockNodes.set(successor, childNode);
      } else {
        valueBlockNodes.set(successor, node);
      }
      return successor;
    });
  }
}
function flattenReactiveLoopsHIR(fn) {
  const activeLoops = Array();
  for (const [, block] of fn.body.blocks) {
    retainWhere(activeLoops, id => id !== block.id);
    const {terminal: terminal} = block;
    switch (terminal.kind) {
      case 'do-while':
      case 'for':
      case 'for-in':
      case 'for-of':
      case 'while': {
        activeLoops.push(terminal.fallthrough);
        break;
      }
      case 'scope': {
        if (activeLoops.length !== 0) {
          block.terminal = {
            kind: 'pruned-scope',
            block: terminal.block,
            fallthrough: terminal.fallthrough,
            id: terminal.id,
            loc: terminal.loc,
            scope: terminal.scope,
          };
        }
        break;
      }
      case 'branch':
      case 'goto':
      case 'if':
      case 'label':
      case 'logical':
      case 'maybe-throw':
      case 'optional':
      case 'pruned-scope':
      case 'return':
      case 'sequence':
      case 'switch':
      case 'ternary':
      case 'throw':
      case 'try':
      case 'unreachable':
      case 'unsupported': {
        break;
      }
      default: {
        assertExhaustive(
          terminal,
          `Unexpected terminal kind \`${terminal.kind}\``
        );
      }
    }
  }
}
function flattenScopesWithHooksOrUseHIR(fn) {
  const activeScopes = [];
  const prune = [];
  for (const [, block] of fn.body.blocks) {
    retainWhere(activeScopes, current => current.fallthrough !== block.id);
    for (const instr of block.instructions) {
      const {value: value} = instr;
      switch (value.kind) {
        case 'MethodCall':
        case 'CallExpression': {
          const callee =
            value.kind === 'MethodCall' ? value.property : value.callee;
          if (
            getHookKind(fn.env, callee.identifier) != null ||
            isUseOperator(callee.identifier)
          ) {
            prune.push(...activeScopes.map(entry => entry.block));
            activeScopes.length = 0;
          }
        }
      }
    }
    if (block.terminal.kind === 'scope') {
      activeScopes.push({
        block: block.id,
        fallthrough: block.terminal.fallthrough,
      });
    }
  }
  for (const id of prune) {
    const block = fn.body.blocks.get(id);
    const terminal = block.terminal;
    CompilerError.invariant(terminal.kind === 'scope', {
      reason: `Expected block to have a scope terminal`,
      description: `Expected block bb${block.id} to end in a scope terminal`,
      loc: terminal.loc,
    });
    const body = fn.body.blocks.get(terminal.block);
    if (
      body.instructions.length === 1 &&
      body.terminal.kind === 'goto' &&
      body.terminal.block === terminal.fallthrough
    ) {
      block.terminal = {
        kind: 'label',
        block: terminal.block,
        fallthrough: terminal.fallthrough,
        id: terminal.id,
        loc: terminal.loc,
      };
      continue;
    }
    block.terminal = {
      kind: 'pruned-scope',
      block: terminal.block,
      fallthrough: terminal.fallthrough,
      id: terminal.id,
      loc: terminal.loc,
      scope: terminal.scope,
    };
  }
}
function pruneAlwaysInvalidatingScopes(fn) {
  visitReactiveFunction(fn, new Transform(), false);
}
class Transform extends ReactiveFunctionTransform {
  constructor() {
    super(...arguments);
    this.alwaysInvalidatingValues = new Set();
    this.unmemoizedValues = new Set();
  }
  transformInstruction(instruction, withinScope) {
    this.visitInstruction(instruction, withinScope);
    const {lvalue: lvalue, value: value} = instruction;
    switch (value.kind) {
      case 'ArrayExpression':
      case 'ObjectExpression':
      case 'JsxExpression':
      case 'JsxFragment':
      case 'NewExpression': {
        if (lvalue !== null) {
          this.alwaysInvalidatingValues.add(lvalue.identifier);
          if (!withinScope) {
            this.unmemoizedValues.add(lvalue.identifier);
          }
        }
        break;
      }
      case 'StoreLocal': {
        if (this.alwaysInvalidatingValues.has(value.value.identifier)) {
          this.alwaysInvalidatingValues.add(value.lvalue.place.identifier);
        }
        if (this.unmemoizedValues.has(value.value.identifier)) {
          this.unmemoizedValues.add(value.lvalue.place.identifier);
        }
        break;
      }
      case 'LoadLocal': {
        if (
          lvalue !== null &&
          this.alwaysInvalidatingValues.has(value.place.identifier)
        ) {
          this.alwaysInvalidatingValues.add(lvalue.identifier);
        }
        if (
          lvalue !== null &&
          this.unmemoizedValues.has(value.place.identifier)
        ) {
          this.unmemoizedValues.add(lvalue.identifier);
        }
        break;
      }
    }
    return {kind: 'keep'};
  }
  transformScope(scopeBlock, _withinScope) {
    this.visitScope(scopeBlock, true);
    for (const dep of scopeBlock.scope.dependencies) {
      if (this.unmemoizedValues.has(dep.identifier)) {
        for (const [_, decl] of scopeBlock.scope.declarations) {
          if (this.alwaysInvalidatingValues.has(decl.identifier)) {
            this.unmemoizedValues.add(decl.identifier);
          }
        }
        for (const identifier of scopeBlock.scope.reassignments) {
          if (this.alwaysInvalidatingValues.has(identifier)) {
            this.unmemoizedValues.add(identifier);
          }
        }
        return {
          kind: 'replace',
          value: {
            kind: 'pruned-scope',
            scope: scopeBlock.scope,
            instructions: scopeBlock.instructions,
          },
        };
      }
    }
    return {kind: 'keep'};
  }
}
let Visitor$2 = class Visitor extends ReactiveFunctionVisitor {
  constructor(env, aliases, paths) {
    super();
    this.map = new Map();
    this.aliases = aliases;
    this.paths = paths;
    this.env = env;
  }
  join(values) {
    function join2(l, r) {
      if (l === 'Update' || r === 'Update') {
        return 'Update';
      } else if (l === 'Create' || r === 'Create') {
        return 'Create';
      } else if (l === 'Unknown' || r === 'Unknown') {
        return 'Unknown';
      }
      assertExhaustive(r, `Unhandled variable kind ${r}`);
    }
    return values.reduce(join2, 'Unknown');
  }
  isCreateOnlyHook(id) {
    return isUseStateType(id) || isUseRefType(id);
  }
  visitPlace(_, place, state) {
    var _a;
    this.map.set(
      place.identifier.id,
      this.join([
        state,
        (_a = this.map.get(place.identifier.id)) !== null && _a !== void 0
          ? _a
          : 'Unknown',
      ])
    );
  }
  visitBlock(block, state) {
    super.visitBlock([...block].reverse(), state);
  }
  visitInstruction(instruction) {
    const state = this.join(
      [...eachInstructionLValue(instruction)].map(operand => {
        var _a;
        return (_a = this.map.get(operand.identifier.id)) !== null &&
          _a !== void 0
          ? _a
          : 'Unknown';
      })
    );
    const visitCallOrMethodNonArgs = () => {
      switch (instruction.value.kind) {
        case 'CallExpression': {
          this.visitPlace(instruction.id, instruction.value.callee, state);
          break;
        }
        case 'MethodCall': {
          this.visitPlace(instruction.id, instruction.value.property, state);
          this.visitPlace(instruction.id, instruction.value.receiver, state);
          break;
        }
      }
    };
    const isHook = () => {
      let callee = null;
      switch (instruction.value.kind) {
        case 'CallExpression': {
          callee = instruction.value.callee.identifier;
          break;
        }
        case 'MethodCall': {
          callee = instruction.value.property.identifier;
          break;
        }
      }
      return callee != null && getHookKind(this.env, callee) != null;
    };
    switch (instruction.value.kind) {
      case 'CallExpression':
      case 'MethodCall': {
        if (
          instruction.lvalue &&
          this.isCreateOnlyHook(instruction.lvalue.identifier)
        ) {
          [...eachCallArgument(instruction.value.args)].forEach(operand =>
            this.visitPlace(instruction.id, operand, 'Create')
          );
          visitCallOrMethodNonArgs();
        } else {
          this.traverseInstruction(instruction, isHook() ? 'Update' : state);
        }
        break;
      }
      default: {
        this.traverseInstruction(instruction, state);
      }
    }
  }
  visitScope(scope) {
    const state = this.join(
      [
        ...scope.scope.declarations.keys(),
        ...[...scope.scope.reassignments.values()].map(ident => ident.id),
      ].map(id => {
        var _a;
        return (_a = this.map.get(id)) !== null && _a !== void 0
          ? _a
          : 'Unknown';
      })
    );
    super.visitScope(scope, state);
    [...scope.scope.dependencies].forEach(ident => {
      var _a;
      let target =
        (_a = this.aliases.find(ident.identifier.id)) !== null && _a !== void 0
          ? _a
          : ident.identifier.id;
      ident.path.forEach(token => {
        var _a;
        target &&
          (target =
            (_a = this.paths.get(target)) === null || _a === void 0
              ? void 0
              : _a.get(token.property));
      });
      if (target && this.map.get(target) === 'Create') {
        scope.scope.dependencies.delete(ident);
      }
    });
  }
  visitTerminal(stmt, state) {
    CompilerError.invariant(state !== 'Create', {
      reason: "Visiting a terminal statement with state 'Create'",
      loc: stmt.terminal.loc,
    });
    super.visitTerminal(stmt, state);
  }
  visitReactiveFunctionValue(_id, _dependencies, fn, state) {
    visitReactiveFunction(fn, this, state);
  }
};
function pruneInitializationDependencies(fn) {
  const [aliases, paths] = getAliases(fn);
  visitReactiveFunction(fn, new Visitor$2(fn.env, aliases, paths), 'Update');
}
function update(map, key, path, value) {
  var _a;
  const inner = (_a = map.get(key)) !== null && _a !== void 0 ? _a : new Map();
  inner.set(path, value);
  map.set(key, inner);
}
class AliasVisitor extends ReactiveFunctionVisitor {
  constructor() {
    super(...arguments);
    this.scopeIdentifiers = new DisjointSet();
    this.scopePaths = new Map();
  }
  visitInstruction(instr) {
    if (
      instr.value.kind === 'StoreLocal' ||
      instr.value.kind === 'StoreContext'
    ) {
      this.scopeIdentifiers.union([
        instr.value.lvalue.place.identifier.id,
        instr.value.value.identifier.id,
      ]);
    } else if (
      instr.value.kind === 'LoadLocal' ||
      instr.value.kind === 'LoadContext'
    ) {
      instr.lvalue &&
        this.scopeIdentifiers.union([
          instr.lvalue.identifier.id,
          instr.value.place.identifier.id,
        ]);
    } else if (instr.value.kind === 'PropertyLoad') {
      instr.lvalue &&
        update(
          this.scopePaths,
          instr.value.object.identifier.id,
          instr.value.property,
          instr.lvalue.identifier.id
        );
    } else if (instr.value.kind === 'PropertyStore') {
      update(
        this.scopePaths,
        instr.value.object.identifier.id,
        instr.value.property,
        instr.value.value.identifier.id
      );
    }
  }
}
function getAliases(fn) {
  var _a, _b;
  const visitor = new AliasVisitor();
  visitReactiveFunction(fn, visitor, null);
  let disjoint = visitor.scopeIdentifiers;
  let scopePaths = new Map();
  for (const [key, value] of visitor.scopePaths) {
    for (const [path, id] of value) {
      update(
        scopePaths,
        (_a = disjoint.find(key)) !== null && _a !== void 0 ? _a : key,
        path,
        (_b = disjoint.find(id)) !== null && _b !== void 0 ? _b : id
      );
    }
  }
  return [disjoint, scopePaths];
}
function isPrimitiveBinaryOp(op) {
  switch (op) {
    case '+':
    case '-':
    case '/':
    case '%':
    case '*':
    case '**':
    case '&':
    case '|':
    case '>>':
    case '<<':
    case '^':
    case '>':
    case '<':
    case '>=':
    case '<=':
    case '|>':
      return true;
    default:
      return false;
  }
}
function inferTypes(func) {
  const unifier = new Unifier(func.env);
  for (const e of generate(func)) {
    unifier.unify(e.left, e.right);
  }
  apply(func, unifier);
}
function apply(func, unifier) {
  for (const [_, block] of func.body.blocks) {
    for (const phi of block.phis) {
      phi.place.identifier.type = unifier.get(phi.place.identifier.type);
    }
    for (const instr of block.instructions) {
      for (const operand of eachInstructionLValue(instr)) {
        operand.identifier.type = unifier.get(operand.identifier.type);
      }
      for (const place of eachInstructionOperand(instr)) {
        place.identifier.type = unifier.get(place.identifier.type);
      }
      const {lvalue: lvalue, value: value} = instr;
      lvalue.identifier.type = unifier.get(lvalue.identifier.type);
      if (
        value.kind === 'FunctionExpression' ||
        value.kind === 'ObjectMethod'
      ) {
        apply(value.loweredFunc.func, unifier);
      }
    }
  }
  func.returnType = unifier.get(func.returnType);
}
function equation(left, right) {
  return {left: left, right: right};
}
function* generate(func) {
  if (func.fnType === 'Component') {
    const [props, ref] = func.params;
    if (props && props.kind === 'Identifier') {
      yield equation(props.identifier.type, {
        kind: 'Object',
        shapeId: BuiltInPropsId,
      });
    }
    if (ref && ref.kind === 'Identifier') {
      yield equation(ref.identifier.type, {
        kind: 'Object',
        shapeId: BuiltInUseRefId,
      });
    }
  }
  const names = new Map();
  const returnTypes = [];
  for (const [_, block] of func.body.blocks) {
    for (const phi of block.phis) {
      yield equation(phi.place.identifier.type, {
        kind: 'Phi',
        operands: [...phi.operands.values()].map(id => id.identifier.type),
      });
    }
    for (const instr of block.instructions) {
      yield* generateInstructionTypes(func.env, names, instr);
    }
    const terminal = block.terminal;
    if (terminal.kind === 'return') {
      returnTypes.push(terminal.value.identifier.type);
    }
  }
  if (returnTypes.length > 1) {
    yield equation(func.returnType, {kind: 'Phi', operands: returnTypes});
  } else if (returnTypes.length === 1) {
    yield equation(func.returnType, returnTypes[0]);
  }
}
function setName(names, id, name) {
  var _a;
  if (
    ((_a = name.name) === null || _a === void 0 ? void 0 : _a.kind) === 'named'
  ) {
    names.set(id, name.name.value);
  }
}
function getName(names, id) {
  var _a;
  return (_a = names.get(id)) !== null && _a !== void 0 ? _a : '';
}
function* generateInstructionTypes(env, names, instr) {
  const {lvalue: lvalue, value: value} = instr;
  const left = lvalue.identifier.type;
  switch (value.kind) {
    case 'TemplateLiteral':
    case 'JSXText':
    case 'Primitive': {
      yield equation(left, {kind: 'Primitive'});
      break;
    }
    case 'UnaryExpression': {
      yield equation(left, {kind: 'Primitive'});
      break;
    }
    case 'LoadLocal': {
      setName(names, lvalue.identifier.id, value.place.identifier);
      yield equation(left, value.place.identifier.type);
      break;
    }
    case 'DeclareContext':
    case 'StoreContext':
    case 'LoadContext': {
      break;
    }
    case 'StoreLocal': {
      if (env.config.enableUseTypeAnnotations) {
        yield equation(
          value.lvalue.place.identifier.type,
          value.value.identifier.type
        );
        const valueType =
          value.type === null ? makeType() : lowerType(value.type);
        yield equation(valueType, value.lvalue.place.identifier.type);
        yield equation(left, valueType);
      } else {
        yield equation(left, value.value.identifier.type);
        yield equation(
          value.lvalue.place.identifier.type,
          value.value.identifier.type
        );
      }
      break;
    }
    case 'StoreGlobal': {
      yield equation(left, value.value.identifier.type);
      break;
    }
    case 'BinaryExpression': {
      if (isPrimitiveBinaryOp(value.operator)) {
        yield equation(value.left.identifier.type, {kind: 'Primitive'});
        yield equation(value.right.identifier.type, {kind: 'Primitive'});
      }
      yield equation(left, {kind: 'Primitive'});
      break;
    }
    case 'PostfixUpdate':
    case 'PrefixUpdate': {
      yield equation(value.value.identifier.type, {kind: 'Primitive'});
      yield equation(value.lvalue.identifier.type, {kind: 'Primitive'});
      yield equation(left, {kind: 'Primitive'});
      break;
    }
    case 'LoadGlobal': {
      const globalType = env.getGlobalDeclaration(value.binding, value.loc);
      if (globalType) {
        yield equation(left, globalType);
      }
      break;
    }
    case 'CallExpression': {
      const returnType = makeType();
      yield equation(value.callee.identifier.type, {
        kind: 'Function',
        shapeId: null,
        return: returnType,
      });
      yield equation(left, returnType);
      break;
    }
    case 'TaggedTemplateExpression': {
      const returnType = makeType();
      yield equation(value.tag.identifier.type, {
        kind: 'Function',
        shapeId: null,
        return: returnType,
      });
      yield equation(left, returnType);
      break;
    }
    case 'ObjectExpression': {
      for (const property of value.properties) {
        if (
          property.kind === 'ObjectProperty' &&
          property.key.kind === 'computed'
        ) {
          yield equation(property.key.name.identifier.type, {
            kind: 'Primitive',
          });
        }
      }
      yield equation(left, {kind: 'Object', shapeId: BuiltInObjectId});
      break;
    }
    case 'ArrayExpression': {
      yield equation(left, {kind: 'Object', shapeId: BuiltInArrayId});
      break;
    }
    case 'PropertyLoad': {
      yield equation(left, {
        kind: 'Property',
        objectType: value.object.identifier.type,
        objectName: getName(names, value.object.identifier.id),
        propertyName: value.property,
      });
      break;
    }
    case 'MethodCall': {
      const returnType = makeType();
      yield equation(value.property.identifier.type, {
        kind: 'Function',
        return: returnType,
        shapeId: null,
      });
      yield equation(left, returnType);
      break;
    }
    case 'Destructure': {
      const pattern = value.lvalue.pattern;
      if (pattern.kind === 'ArrayPattern') {
        for (let i = 0; i < pattern.items.length; i++) {
          const item = pattern.items[i];
          if (item.kind === 'Identifier') {
            const propertyName = String(i);
            yield equation(item.identifier.type, {
              kind: 'Property',
              objectType: value.value.identifier.type,
              objectName: getName(names, value.value.identifier.id),
              propertyName: propertyName,
            });
          } else {
            break;
          }
        }
      } else {
        for (const property of pattern.properties) {
          if (property.kind === 'ObjectProperty') {
            if (
              property.key.kind === 'identifier' ||
              property.key.kind === 'string'
            ) {
              yield equation(property.place.identifier.type, {
                kind: 'Property',
                objectType: value.value.identifier.type,
                objectName: getName(names, value.value.identifier.id),
                propertyName: property.key.name,
              });
            }
          }
        }
      }
      break;
    }
    case 'TypeCastExpression': {
      if (env.config.enableUseTypeAnnotations) {
        yield equation(value.type, value.value.identifier.type);
        yield equation(left, value.type);
      } else {
        yield equation(left, value.value.identifier.type);
      }
      break;
    }
    case 'PropertyDelete':
    case 'ComputedDelete': {
      yield equation(left, {kind: 'Primitive'});
      break;
    }
    case 'FunctionExpression': {
      yield* generate(value.loweredFunc.func);
      yield equation(left, {
        kind: 'Function',
        shapeId: BuiltInFunctionId,
        return: value.loweredFunc.func.returnType,
      });
      break;
    }
    case 'NextPropertyOf': {
      yield equation(left, {kind: 'Primitive'});
      break;
    }
    case 'ObjectMethod': {
      yield* generate(value.loweredFunc.func);
      yield equation(left, {kind: 'ObjectMethod'});
      break;
    }
    case 'JsxExpression':
    case 'JsxFragment': {
      yield equation(left, {kind: 'Object', shapeId: BuiltInJsxId});
      break;
    }
    case 'PropertyStore':
    case 'DeclareLocal':
    case 'NewExpression':
    case 'RegExpLiteral':
    case 'MetaProperty':
    case 'ComputedStore':
    case 'ComputedLoad':
    case 'Await':
    case 'GetIterator':
    case 'IteratorNext':
    case 'UnsupportedNode':
    case 'Debugger':
    case 'FinishMemoize':
    case 'StartMemoize': {
      break;
    }
    default:
      assertExhaustive(value, `Unhandled instruction value kind: ${value}`);
  }
}
class Unifier {
  constructor(env) {
    this.substitutions = new Map();
    this.env = env;
  }
  unify(tA, tB) {
    if (tB.kind === 'Property') {
      if (
        this.env.config.enableTreatRefLikeIdentifiersAsRefs &&
        isRefLikeName(tB)
      ) {
        this.unify(tB.objectType, {kind: 'Object', shapeId: BuiltInUseRefId});
        this.unify(tA, {kind: 'Object', shapeId: BuiltInRefValueId});
        return;
      }
      const objectType = this.get(tB.objectType);
      const propertyType = this.env.getPropertyType(
        objectType,
        tB.propertyName
      );
      if (propertyType !== null) {
        this.unify(tA, propertyType);
      }
      return;
    }
    if (typeEquals(tA, tB)) {
      return;
    }
    if (tA.kind === 'Type') {
      this.bindVariableTo(tA, tB);
      return;
    }
    if (tB.kind === 'Type') {
      this.bindVariableTo(tB, tA);
      return;
    }
    if (tB.kind === 'Function' && tA.kind === 'Function') {
      this.unify(tA.return, tB.return);
      return;
    }
  }
  bindVariableTo(v, type) {
    if (type.kind === 'Poly') {
      return;
    }
    if (this.substitutions.has(v.id)) {
      this.unify(this.substitutions.get(v.id), type);
      return;
    }
    if (type.kind === 'Type' && this.substitutions.has(type.id)) {
      this.unify(v, this.substitutions.get(type.id));
      return;
    }
    if (type.kind === 'Phi') {
      CompilerError.invariant(type.operands.length > 0, {
        reason: 'there should be at least one operand',
        description: null,
        loc: null,
        suggestions: null,
      });
      let candidateType = null;
      for (const operand of type.operands) {
        const resolved = this.get(operand);
        if (candidateType === null) {
          candidateType = resolved;
        } else if (!typeEquals(resolved, candidateType)) {
          const unionType = tryUnionTypes(resolved, candidateType);
          if (unionType === null) {
            candidateType = null;
            break;
          } else {
            candidateType = unionType;
          }
        }
      }
      if (candidateType !== null) {
        this.unify(v, candidateType);
        return;
      }
    }
    if (this.occursCheck(v, type)) {
      const resolvedType = this.tryResolveType(v, type);
      if (resolvedType !== null) {
        this.substitutions.set(v.id, resolvedType);
        return;
      }
      throw new Error('cycle detected');
    }
    this.substitutions.set(v.id, type);
  }
  tryResolveType(v, type) {
    switch (type.kind) {
      case 'Phi': {
        const operands = [];
        for (const operand of type.operands) {
          if (operand.kind === 'Type' && operand.id === v.id) {
            continue;
          }
          const resolved = this.tryResolveType(v, operand);
          if (resolved === null) {
            return null;
          }
          operands.push(resolved);
        }
        return {kind: 'Phi', operands: operands};
      }
      case 'Type': {
        const substitution = this.get(type);
        if (substitution !== type) {
          const resolved = this.tryResolveType(v, substitution);
          if (resolved !== null) {
            this.substitutions.set(type.id, resolved);
          }
          return resolved;
        }
        return type;
      }
      case 'Property': {
        const objectType = this.tryResolveType(v, this.get(type.objectType));
        if (objectType === null) {
          return null;
        }
        return {
          kind: 'Property',
          objectName: type.objectName,
          objectType: objectType,
          propertyName: type.propertyName,
        };
      }
      case 'Function': {
        const returnType = this.tryResolveType(v, this.get(type.return));
        if (returnType === null) {
          return null;
        }
        return {kind: 'Function', return: returnType, shapeId: type.shapeId};
      }
      case 'ObjectMethod':
      case 'Object':
      case 'Primitive':
      case 'Poly': {
        return type;
      }
      default: {
        assertExhaustive(type, `Unexpected type kind '${type.kind}'`);
      }
    }
  }
  occursCheck(v, type) {
    if (typeEquals(v, type)) return true;
    if (type.kind === 'Type' && this.substitutions.has(type.id)) {
      return this.occursCheck(v, this.substitutions.get(type.id));
    }
    if (type.kind === 'Phi') {
      return type.operands.some(o => this.occursCheck(v, o));
    }
    if (type.kind === 'Function') {
      return this.occursCheck(v, type.return);
    }
    return false;
  }
  get(type) {
    if (type.kind === 'Type') {
      if (this.substitutions.has(type.id)) {
        return this.get(this.substitutions.get(type.id));
      }
    }
    if (type.kind === 'Phi') {
      return {kind: 'Phi', operands: type.operands.map(o => this.get(o))};
    }
    return type;
  }
}
const RefLikeNameRE = /^(?:[a-zA-Z$_][a-zA-Z$_0-9]*)Ref$|^ref$/;
function isRefLikeName(t) {
  return RefLikeNameRE.test(t.objectName) && t.propertyName === 'current';
}
function tryUnionTypes(ty1, ty2) {
  let readonlyType;
  let otherType;
  if (ty1.kind === 'Object' && ty1.shapeId === BuiltInMixedReadonlyId) {
    readonlyType = ty1;
    otherType = ty2;
  } else if (ty2.kind === 'Object' && ty2.shapeId === BuiltInMixedReadonlyId) {
    readonlyType = ty2;
    otherType = ty1;
  } else {
    return null;
  }
  if (otherType.kind === 'Primitive') {
    return readonlyType;
  } else if (
    otherType.kind === 'Object' &&
    otherType.shapeId === BuiltInArrayId
  ) {
    return otherType;
  }
  return null;
}
function validateContextVariableLValues(fn) {
  const identifierKinds = new Map();
  validateContextVariableLValuesImpl(fn, identifierKinds);
}
function validateContextVariableLValuesImpl(fn, identifierKinds) {
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {value: value} = instr;
      switch (value.kind) {
        case 'DeclareContext':
        case 'StoreContext': {
          visit(identifierKinds, value.lvalue.place, 'context');
          break;
        }
        case 'LoadContext': {
          visit(identifierKinds, value.place, 'context');
          break;
        }
        case 'StoreLocal':
        case 'DeclareLocal': {
          visit(identifierKinds, value.lvalue.place, 'local');
          break;
        }
        case 'LoadLocal': {
          visit(identifierKinds, value.place, 'local');
          break;
        }
        case 'PostfixUpdate':
        case 'PrefixUpdate': {
          visit(identifierKinds, value.lvalue, 'local');
          break;
        }
        case 'Destructure': {
          for (const lvalue of eachPatternOperand(value.lvalue.pattern)) {
            visit(identifierKinds, lvalue, 'destructure');
          }
          break;
        }
        case 'ObjectMethod':
        case 'FunctionExpression': {
          validateContextVariableLValuesImpl(
            value.loweredFunc.func,
            identifierKinds
          );
          break;
        }
        default: {
          for (const _ of eachInstructionValueLValue(value)) {
            CompilerError.throwTodo({
              reason:
                'ValidateContextVariableLValues: unhandled instruction variant',
              loc: value.loc,
              description: `Handle '${value.kind} lvalues`,
              suggestions: null,
            });
          }
        }
      }
    }
  }
}
function visit(identifiers, place, kind) {
  const prev = identifiers.get(place.identifier.id);
  if (prev !== undefined) {
    const wasContext = prev.kind === 'context';
    const isContext = kind === 'context';
    if (wasContext !== isContext) {
      if (prev.kind === 'destructure' || kind === 'destructure') {
        CompilerError.throwTodo({
          reason: `Support destructuring of context variables`,
          loc: kind === 'destructure' ? place.loc : prev.place.loc,
          description: null,
          suggestions: null,
        });
      }
      CompilerError.invariant(false, {
        reason: `Expected all references to a variable to be consistently local or context references`,
        loc: place.loc,
        description: `Identifier ${printPlace(place)} is referenced as a ${kind} variable, but was previously referenced as a ${prev} variable`,
        suggestions: null,
      });
    }
  }
  identifiers.set(place.identifier.id, {place: place, kind: kind});
}
function computeUnconditionalBlocks(fn) {
  const unconditionalBlocks = new Set();
  const dominators = computePostDominatorTree(fn, {
    includeThrowsAsExitNode: false,
  });
  const exit = dominators.exit;
  let current = fn.body.entry;
  while (current !== null && current !== exit) {
    CompilerError.invariant(!unconditionalBlocks.has(current), {
      reason:
        'Internal error: non-terminating loop in ComputeUnconditionalBlocks',
      loc: null,
      suggestions: null,
    });
    unconditionalBlocks.add(current);
    current = dominators.get(current);
  }
  return unconditionalBlocks;
}
var Kind;
(function (Kind) {
  Kind['Error'] = 'Error';
  Kind['KnownHook'] = 'KnownHook';
  Kind['PotentialHook'] = 'PotentialHook';
  Kind['Global'] = 'Global';
  Kind['Local'] = 'Local';
})(Kind || (Kind = {}));
function joinKinds(a, b) {
  if (a === Kind.Error || b === Kind.Error) {
    return Kind.Error;
  } else if (a === Kind.KnownHook || b === Kind.KnownHook) {
    return Kind.KnownHook;
  } else if (a === Kind.PotentialHook || b === Kind.PotentialHook) {
    return Kind.PotentialHook;
  } else if (a === Kind.Global || b === Kind.Global) {
    return Kind.Global;
  } else {
    return Kind.Local;
  }
}
function validateHooksUsage(fn) {
  const unconditionalBlocks = computeUnconditionalBlocks(fn);
  const errors = new CompilerError();
  const errorsByPlace = new Map();
  function recordError(loc, errorDetail) {
    if (typeof loc === 'symbol') {
      errors.pushErrorDetail(errorDetail);
    } else {
      errorsByPlace.set(loc, errorDetail);
    }
  }
  function recordConditionalHookError(place) {
    setKind(place, Kind.Error);
    const reason =
      'Hooks must always be called in a consistent order, and may not be called conditionally. See the Rules of Hooks (https://react.dev/warnings/invalid-hook-call-warning)';
    const previousError =
      typeof place.loc !== 'symbol' ? errorsByPlace.get(place.loc) : undefined;
    if (previousError === undefined || previousError.reason !== reason) {
      recordError(
        place.loc,
        new CompilerErrorDetail({
          description: null,
          reason: reason,
          loc: place.loc,
          severity: exports.ErrorSeverity.InvalidReact,
          suggestions: null,
        })
      );
    }
  }
  function recordInvalidHookUsageError(place) {
    const previousError =
      typeof place.loc !== 'symbol' ? errorsByPlace.get(place.loc) : undefined;
    if (previousError === undefined) {
      recordError(
        place.loc,
        new CompilerErrorDetail({
          description: null,
          reason:
            'Hooks may not be referenced as normal values, they must be called. See https://react.dev/reference/rules/react-calls-components-and-hooks#never-pass-around-hooks-as-regular-values',
          loc: place.loc,
          severity: exports.ErrorSeverity.InvalidReact,
          suggestions: null,
        })
      );
    }
  }
  function recordDynamicHookUsageError(place) {
    const previousError =
      typeof place.loc !== 'symbol' ? errorsByPlace.get(place.loc) : undefined;
    if (previousError === undefined) {
      recordError(
        place.loc,
        new CompilerErrorDetail({
          description: null,
          reason:
            'Hooks must be the same function on every render, but this value may change over time to a different function. See https://react.dev/reference/rules/react-calls-components-and-hooks#dont-dynamically-use-hooks',
          loc: place.loc,
          severity: exports.ErrorSeverity.InvalidReact,
          suggestions: null,
        })
      );
    }
  }
  const valueKinds = new Map();
  function getKindForPlace(place) {
    const knownKind = valueKinds.get(place.identifier.id);
    if (
      place.identifier.name !== null &&
      isHookName$1(place.identifier.name.value)
    ) {
      return joinKinds(
        knownKind !== null && knownKind !== void 0 ? knownKind : Kind.Local,
        Kind.PotentialHook
      );
    } else {
      return knownKind !== null && knownKind !== void 0
        ? knownKind
        : Kind.Local;
    }
  }
  function visitPlace(place) {
    const kind = valueKinds.get(place.identifier.id);
    if (kind === Kind.KnownHook) {
      recordInvalidHookUsageError(place);
    }
  }
  function setKind(place, kind) {
    valueKinds.set(place.identifier.id, kind);
  }
  for (const param of fn.params) {
    const place = param.kind === 'Identifier' ? param : param.place;
    const kind = getKindForPlace(place);
    setKind(place, kind);
  }
  for (const [, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      let kind =
        phi.place.identifier.name !== null &&
        isHookName$1(phi.place.identifier.name.value)
          ? Kind.PotentialHook
          : Kind.Local;
      for (const [, operand] of phi.operands) {
        const operandKind = valueKinds.get(operand.identifier.id);
        if (operandKind !== undefined) {
          kind = joinKinds(kind, operandKind);
        }
      }
      valueKinds.set(phi.place.identifier.id, kind);
    }
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'LoadGlobal': {
          if (getHookKind(fn.env, instr.lvalue.identifier) != null) {
            setKind(instr.lvalue, Kind.KnownHook);
          } else {
            setKind(instr.lvalue, Kind.Global);
          }
          break;
        }
        case 'LoadContext':
        case 'LoadLocal': {
          visitPlace(instr.value.place);
          const kind = getKindForPlace(instr.value.place);
          setKind(instr.lvalue, kind);
          break;
        }
        case 'StoreLocal':
        case 'StoreContext': {
          visitPlace(instr.value.value);
          const kind = joinKinds(
            getKindForPlace(instr.value.value),
            getKindForPlace(instr.value.lvalue.place)
          );
          setKind(instr.value.lvalue.place, kind);
          setKind(instr.lvalue, kind);
          break;
        }
        case 'ComputedLoad': {
          visitPlace(instr.value.object);
          const kind = getKindForPlace(instr.value.object);
          setKind(instr.lvalue, joinKinds(getKindForPlace(instr.lvalue), kind));
          break;
        }
        case 'PropertyLoad': {
          const objectKind = getKindForPlace(instr.value.object);
          const isHookProperty = isHookName$1(instr.value.property);
          let kind;
          switch (objectKind) {
            case Kind.Error: {
              kind = Kind.Error;
              break;
            }
            case Kind.KnownHook: {
              kind = isHookProperty ? Kind.KnownHook : Kind.Local;
              break;
            }
            case Kind.PotentialHook: {
              kind = Kind.PotentialHook;
              break;
            }
            case Kind.Global: {
              kind = isHookProperty ? Kind.KnownHook : Kind.Global;
              break;
            }
            case Kind.Local: {
              kind = isHookProperty ? Kind.PotentialHook : Kind.Local;
              break;
            }
            default: {
              assertExhaustive(objectKind, `Unexpected kind \`${objectKind}\``);
            }
          }
          setKind(instr.lvalue, kind);
          break;
        }
        case 'CallExpression': {
          const calleeKind = getKindForPlace(instr.value.callee);
          const isHookCallee =
            calleeKind === Kind.KnownHook || calleeKind === Kind.PotentialHook;
          if (isHookCallee && !unconditionalBlocks.has(block.id)) {
            recordConditionalHookError(instr.value.callee);
          } else if (calleeKind === Kind.PotentialHook) {
            recordDynamicHookUsageError(instr.value.callee);
          }
          for (const operand of eachInstructionOperand(instr)) {
            if (operand === instr.value.callee) {
              continue;
            }
            visitPlace(operand);
          }
          break;
        }
        case 'MethodCall': {
          const calleeKind = getKindForPlace(instr.value.property);
          const isHookCallee =
            calleeKind === Kind.KnownHook || calleeKind === Kind.PotentialHook;
          if (isHookCallee && !unconditionalBlocks.has(block.id)) {
            recordConditionalHookError(instr.value.property);
          } else if (calleeKind === Kind.PotentialHook) {
            recordDynamicHookUsageError(instr.value.property);
          }
          for (const operand of eachInstructionOperand(instr)) {
            if (operand === instr.value.property) {
              continue;
            }
            visitPlace(operand);
          }
          break;
        }
        case 'Destructure': {
          visitPlace(instr.value.value);
          const objectKind = getKindForPlace(instr.value.value);
          for (const lvalue of eachInstructionLValue(instr)) {
            const isHookProperty =
              lvalue.identifier.name !== null &&
              isHookName$1(lvalue.identifier.name.value);
            let kind;
            switch (objectKind) {
              case Kind.Error: {
                kind = Kind.Error;
                break;
              }
              case Kind.KnownHook: {
                kind = Kind.KnownHook;
                break;
              }
              case Kind.PotentialHook: {
                kind = Kind.PotentialHook;
                break;
              }
              case Kind.Global: {
                kind = isHookProperty ? Kind.KnownHook : Kind.Global;
                break;
              }
              case Kind.Local: {
                kind = isHookProperty ? Kind.PotentialHook : Kind.Local;
                break;
              }
              default: {
                assertExhaustive(
                  objectKind,
                  `Unexpected kind \`${objectKind}\``
                );
              }
            }
            setKind(lvalue, kind);
          }
          break;
        }
        case 'ObjectMethod':
        case 'FunctionExpression': {
          visitFunctionExpression(errors, instr.value.loweredFunc.func);
          break;
        }
        default: {
          for (const operand of eachInstructionOperand(instr)) {
            visitPlace(operand);
          }
          for (const lvalue of eachInstructionLValue(instr)) {
            const kind = getKindForPlace(lvalue);
            setKind(lvalue, kind);
          }
        }
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      visitPlace(operand);
    }
  }
  for (const [, error] of errorsByPlace) {
    errors.push(error);
  }
  if (errors.hasErrors()) {
    throw errors;
  }
}
function visitFunctionExpression(errors, fn) {
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'ObjectMethod':
        case 'FunctionExpression': {
          visitFunctionExpression(errors, instr.value.loweredFunc.func);
          break;
        }
        case 'MethodCall':
        case 'CallExpression': {
          const callee =
            instr.value.kind === 'CallExpression'
              ? instr.value.callee
              : instr.value.property;
          const hookKind = getHookKind(fn.env, callee.identifier);
          if (hookKind != null) {
            errors.pushErrorDetail(
              new CompilerErrorDetail({
                severity: exports.ErrorSeverity.InvalidReact,
                reason:
                  'Hooks must be called at the top level in the body of a function component or custom hook, and may not be called within function expressions. See the Rules of Hooks (https://react.dev/warnings/invalid-hook-call-warning)',
                loc: callee.loc,
                description: `Cannot call ${hookKind} within a function component`,
                suggestions: null,
              })
            );
          }
          break;
        }
      }
    }
  }
}
function validateMemoizedEffectDependencies(fn) {
  const errors = new CompilerError();
  visitReactiveFunction(fn, new Visitor$1(), errors);
  if (errors.hasErrors()) {
    throw errors;
  }
}
let Visitor$1 = class Visitor extends ReactiveFunctionVisitor {
  constructor() {
    super(...arguments);
    this.scopes = new Set();
  }
  visitScope(scopeBlock, state) {
    this.traverseScope(scopeBlock, state);
    let areDependenciesMemoized = true;
    for (const dep of scopeBlock.scope.dependencies) {
      if (isUnmemoized$1(dep.identifier, this.scopes)) {
        areDependenciesMemoized = false;
        break;
      }
    }
    if (areDependenciesMemoized) {
      this.scopes.add(scopeBlock.scope.id);
      for (const id of scopeBlock.scope.merged) {
        this.scopes.add(id);
      }
    }
  }
  visitInstruction(instruction, state) {
    this.traverseInstruction(instruction, state);
    if (
      instruction.value.kind === 'CallExpression' &&
      isEffectHook(instruction.value.callee.identifier) &&
      instruction.value.args.length >= 2
    ) {
      const deps = instruction.value.args[1];
      if (
        deps.kind === 'Identifier' &&
        (isMutable(instruction, deps) ||
          isUnmemoized$1(deps.identifier, this.scopes))
      ) {
        state.push({
          reason:
            'React Compiler has skipped optimizing this component because the effect dependencies could not be memoized. Unmemoized effect dependencies can trigger an infinite loop or other unexpected behavior',
          description: null,
          severity: exports.ErrorSeverity.CannotPreserveMemoization,
          loc: typeof instruction.loc !== 'symbol' ? instruction.loc : null,
          suggestions: null,
        });
      }
    }
  }
};
function isUnmemoized$1(operand, scopes) {
  return operand.scope != null && !scopes.has(operand.scope.id);
}
function isEffectHook(identifier) {
  return (
    isUseEffectHookType(identifier) ||
    isUseLayoutEffectHookType(identifier) ||
    isUseInsertionEffectHookType(identifier)
  );
}
function validateNoCapitalizedCalls(fn) {
  var _a;
  const envConfig = fn.env.config;
  const ALLOW_LIST = new Set([
    ...DEFAULT_GLOBALS.keys(),
    ...((_a = envConfig.validateNoCapitalizedCalls) !== null && _a !== void 0
      ? _a
      : []),
  ]);
  const hookPattern =
    envConfig.hookPattern != null ? new RegExp(envConfig.hookPattern) : null;
  const isAllowed = name =>
    ALLOW_LIST.has(name) || (hookPattern != null && hookPattern.test(name));
  const capitalLoadGlobals = new Map();
  const capitalizedProperties = new Map();
  const reason =
    'Capitalized functions are reserved for components, which must be invoked with JSX. If this is a component, render it with JSX. Otherwise, ensure that it has no hook calls and rename it to begin with a lowercase letter. Alternatively, if you know for a fact that this function is not a component, you can allowlist it via the compiler config';
  for (const [, block] of fn.body.blocks) {
    for (const {lvalue: lvalue, value: value} of block.instructions) {
      switch (value.kind) {
        case 'LoadGlobal': {
          if (
            value.binding.name != '' &&
            /^[A-Z]/.test(value.binding.name) &&
            !(value.binding.name.toUpperCase() === value.binding.name) &&
            !isAllowed(value.binding.name)
          ) {
            capitalLoadGlobals.set(lvalue.identifier.id, value.binding.name);
          }
          break;
        }
        case 'CallExpression': {
          const calleeIdentifier = value.callee.identifier.id;
          const calleeName = capitalLoadGlobals.get(calleeIdentifier);
          if (calleeName != null) {
            CompilerError.throwInvalidReact({
              reason: reason,
              description: `${calleeName} may be a component.`,
              loc: value.loc,
              suggestions: null,
            });
          }
          break;
        }
        case 'PropertyLoad': {
          if (/^[A-Z]/.test(value.property)) {
            capitalizedProperties.set(lvalue.identifier.id, value.property);
          }
          break;
        }
        case 'MethodCall': {
          const propertyIdentifier = value.property.identifier.id;
          const propertyName = capitalizedProperties.get(propertyIdentifier);
          if (propertyName != null) {
            CompilerError.throwInvalidReact({
              reason: reason,
              description: `${propertyName} may be a component.`,
              loc: value.loc,
              suggestions: null,
            });
          }
          break;
        }
      }
    }
  }
}
var _Env_changed;
function makeRefId(id) {
  CompilerError.invariant(id >= 0 && Number.isInteger(id), {
    reason: 'Expected identifier id to be a non-negative integer',
    description: null,
    loc: null,
    suggestions: null,
  });
  return id;
}
let _refId = 0;
function nextRefId() {
  return makeRefId(_refId++);
}
class Env extends Map {
  constructor() {
    super(...arguments);
    _Env_changed.set(this, false);
  }
  resetChanged() {
    __classPrivateFieldSet(this, _Env_changed, false, 'f');
  }
  hasChanged() {
    return __classPrivateFieldGet(this, _Env_changed, 'f');
  }
  set(key, value) {
    const cur = this.get(key);
    const widenedValue = joinRefAccessTypes(
      value,
      cur !== null && cur !== void 0 ? cur : {kind: 'None'}
    );
    if (
      !(cur == null && widenedValue.kind === 'None') &&
      (cur == null || !tyEqual(cur, widenedValue))
    ) {
      __classPrivateFieldSet(this, _Env_changed, true, 'f');
    }
    return super.set(key, widenedValue);
  }
}
_Env_changed = new WeakMap();
function validateNoRefAccessInRender(fn) {
  const env = new Env();
  validateNoRefAccessInRenderImpl(fn, env).unwrap();
}
function refTypeOfType(place) {
  if (isRefValueType(place.identifier)) {
    return {kind: 'RefValue'};
  } else if (isUseRefType(place.identifier)) {
    return {kind: 'Ref', refId: nextRefId()};
  } else {
    return {kind: 'None'};
  }
}
function tyEqual(a, b) {
  if (a.kind !== b.kind) {
    return false;
  }
  switch (a.kind) {
    case 'None':
      return true;
    case 'Ref':
      return true;
    case 'Nullable':
      return true;
    case 'Guard':
      CompilerError.invariant(b.kind === 'Guard', {
        reason: 'Expected ref value',
        loc: null,
      });
      return a.refId === b.refId;
    case 'RefValue':
      CompilerError.invariant(b.kind === 'RefValue', {
        reason: 'Expected ref value',
        loc: null,
      });
      return a.loc == b.loc;
    case 'Structure': {
      CompilerError.invariant(b.kind === 'Structure', {
        reason: 'Expected structure',
        loc: null,
      });
      const fnTypesEqual =
        (a.fn === null && b.fn === null) ||
        (a.fn !== null &&
          b.fn !== null &&
          a.fn.readRefEffect === b.fn.readRefEffect &&
          tyEqual(a.fn.returnType, b.fn.returnType));
      return (
        fnTypesEqual &&
        (a.value === b.value ||
          (a.value !== null && b.value !== null && tyEqual(a.value, b.value)))
      );
    }
  }
}
function joinRefAccessTypes(...types) {
  function joinRefAccessRefTypes(a, b) {
    if (a.kind === 'RefValue') {
      if (b.kind === 'RefValue' && a.refId === b.refId) {
        return a;
      }
      return {kind: 'RefValue'};
    } else if (b.kind === 'RefValue') {
      return b;
    } else if (a.kind === 'Ref' || b.kind === 'Ref') {
      if (a.kind === 'Ref' && b.kind === 'Ref' && a.refId === b.refId) {
        return a;
      }
      return {kind: 'Ref', refId: nextRefId()};
    } else {
      CompilerError.invariant(
        a.kind === 'Structure' && b.kind === 'Structure',
        {reason: 'Expected structure', loc: null}
      );
      const fn =
        a.fn === null
          ? b.fn
          : b.fn === null
            ? a.fn
            : {
                readRefEffect: a.fn.readRefEffect || b.fn.readRefEffect,
                returnType: joinRefAccessTypes(
                  a.fn.returnType,
                  b.fn.returnType
                ),
              };
      const value =
        a.value === null
          ? b.value
          : b.value === null
            ? a.value
            : joinRefAccessRefTypes(a.value, b.value);
      return {kind: 'Structure', fn: fn, value: value};
    }
  }
  return types.reduce(
    (a, b) => {
      if (a.kind === 'None') {
        return b;
      } else if (b.kind === 'None') {
        return a;
      } else if (a.kind === 'Guard') {
        if (b.kind === 'Guard' && a.refId === b.refId) {
          return a;
        } else if (b.kind === 'Nullable' || b.kind === 'Guard') {
          return {kind: 'None'};
        } else {
          return b;
        }
      } else if (b.kind === 'Guard') {
        if (a.kind === 'Nullable') {
          return {kind: 'None'};
        } else {
          return b;
        }
      } else if (a.kind === 'Nullable') {
        return b;
      } else if (b.kind === 'Nullable') {
        return a;
      } else {
        return joinRefAccessRefTypes(a, b);
      }
    },
    {kind: 'None'}
  );
}
function validateNoRefAccessInRenderImpl(fn, env) {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  let returnValues = [];
  let place;
  for (const param of fn.params) {
    if (param.kind === 'Identifier') {
      place = param;
    } else {
      place = param.place;
    }
    const type = refTypeOfType(place);
    env.set(place.identifier.id, type);
  }
  for (let i = 0; (i == 0 || env.hasChanged()) && i < 10; i++) {
    env.resetChanged();
    returnValues = [];
    const safeBlocks = new Map();
    const errors = new CompilerError();
    for (const [, block] of fn.body.blocks) {
      for (const phi of block.phis) {
        env.set(
          phi.place.identifier.id,
          joinRefAccessTypes(
            ...Array(...phi.operands.values()).map(operand => {
              var _a;
              return (_a = env.get(operand.identifier.id)) !== null &&
                _a !== void 0
                ? _a
                : {kind: 'None'};
            })
          )
        );
      }
      for (const instr of block.instructions) {
        switch (instr.value.kind) {
          case 'JsxExpression':
          case 'JsxFragment': {
            for (const operand of eachInstructionValueOperand(instr.value)) {
              validateNoDirectRefValueAccess(errors, operand, env);
            }
            break;
          }
          case 'ComputedLoad':
          case 'PropertyLoad': {
            if (typeof instr.value.property !== 'string') {
              validateNoDirectRefValueAccess(errors, instr.value.property, env);
            }
            const objType = env.get(instr.value.object.identifier.id);
            let lookupType = null;
            if (
              (objType === null || objType === void 0
                ? void 0
                : objType.kind) === 'Structure'
            ) {
              lookupType = objType.value;
            } else if (
              (objType === null || objType === void 0
                ? void 0
                : objType.kind) === 'Ref'
            ) {
              lookupType = {
                kind: 'RefValue',
                loc: instr.loc,
                refId: objType.refId,
              };
            }
            env.set(
              instr.lvalue.identifier.id,
              lookupType !== null && lookupType !== void 0
                ? lookupType
                : refTypeOfType(instr.lvalue)
            );
            break;
          }
          case 'LoadContext':
          case 'LoadLocal': {
            env.set(
              instr.lvalue.identifier.id,
              (_a = env.get(instr.value.place.identifier.id)) !== null &&
                _a !== void 0
                ? _a
                : refTypeOfType(instr.lvalue)
            );
            break;
          }
          case 'StoreContext':
          case 'StoreLocal': {
            env.set(
              instr.value.lvalue.place.identifier.id,
              (_b = env.get(instr.value.value.identifier.id)) !== null &&
                _b !== void 0
                ? _b
                : refTypeOfType(instr.value.lvalue.place)
            );
            env.set(
              instr.lvalue.identifier.id,
              (_c = env.get(instr.value.value.identifier.id)) !== null &&
                _c !== void 0
                ? _c
                : refTypeOfType(instr.lvalue)
            );
            break;
          }
          case 'Destructure': {
            const objType = env.get(instr.value.value.identifier.id);
            let lookupType = null;
            if (
              (objType === null || objType === void 0
                ? void 0
                : objType.kind) === 'Structure'
            ) {
              lookupType = objType.value;
            }
            env.set(
              instr.lvalue.identifier.id,
              lookupType !== null && lookupType !== void 0
                ? lookupType
                : refTypeOfType(instr.lvalue)
            );
            for (const lval of eachPatternOperand(instr.value.lvalue.pattern)) {
              env.set(
                lval.identifier.id,
                lookupType !== null && lookupType !== void 0
                  ? lookupType
                  : refTypeOfType(lval)
              );
            }
            break;
          }
          case 'ObjectMethod':
          case 'FunctionExpression': {
            let returnType = {kind: 'None'};
            let readRefEffect = false;
            const result = validateNoRefAccessInRenderImpl(
              instr.value.loweredFunc.func,
              env
            );
            if (result.isOk()) {
              returnType = result.unwrap();
            } else if (result.isErr()) {
              readRefEffect = true;
            }
            env.set(instr.lvalue.identifier.id, {
              kind: 'Structure',
              fn: {readRefEffect: readRefEffect, returnType: returnType},
              value: null,
            });
            break;
          }
          case 'MethodCall':
          case 'CallExpression': {
            const callee =
              instr.value.kind === 'CallExpression'
                ? instr.value.callee
                : instr.value.property;
            const hookKind = getHookKindForType(fn.env, callee.identifier.type);
            let returnType = {kind: 'None'};
            const fnType = env.get(callee.identifier.id);
            if (
              (fnType === null || fnType === void 0 ? void 0 : fnType.kind) ===
                'Structure' &&
              fnType.fn !== null
            ) {
              returnType = fnType.fn.returnType;
              if (fnType.fn.readRefEffect) {
                errors.push({
                  severity: exports.ErrorSeverity.InvalidReact,
                  reason:
                    'This function accesses a ref value (the `current` property), which may not be accessed during render. (https://react.dev/reference/react/useRef)',
                  loc: callee.loc,
                  description:
                    callee.identifier.name !== null &&
                    callee.identifier.name.kind === 'named'
                      ? `Function \`${callee.identifier.name.value}\` accesses a ref`
                      : null,
                  suggestions: null,
                });
              }
            }
            for (const operand of eachInstructionValueOperand(instr.value)) {
              if (hookKind != null) {
                validateNoDirectRefValueAccess(errors, operand, env);
              } else {
                validateNoRefAccess(errors, env, operand, operand.loc);
              }
            }
            env.set(instr.lvalue.identifier.id, returnType);
            break;
          }
          case 'ObjectExpression':
          case 'ArrayExpression': {
            const types = [];
            for (const operand of eachInstructionValueOperand(instr.value)) {
              validateNoDirectRefValueAccess(errors, operand, env);
              types.push(
                (_d = env.get(operand.identifier.id)) !== null && _d !== void 0
                  ? _d
                  : {kind: 'None'}
              );
            }
            const value = joinRefAccessTypes(...types);
            if (
              value.kind === 'None' ||
              value.kind === 'Guard' ||
              value.kind === 'Nullable'
            ) {
              env.set(instr.lvalue.identifier.id, {kind: 'None'});
            } else {
              env.set(instr.lvalue.identifier.id, {
                kind: 'Structure',
                value: value,
                fn: null,
              });
            }
            break;
          }
          case 'PropertyDelete':
          case 'PropertyStore':
          case 'ComputedDelete':
          case 'ComputedStore': {
            const safe = safeBlocks.get(block.id);
            const target = env.get(instr.value.object.identifier.id);
            if (
              instr.value.kind === 'PropertyStore' &&
              safe != null &&
              (target === null || target === void 0 ? void 0 : target.kind) ===
                'Ref' &&
              target.refId === safe
            ) {
              safeBlocks.delete(block.id);
            } else {
              validateNoRefAccess(errors, env, instr.value.object, instr.loc);
            }
            for (const operand of eachInstructionValueOperand(instr.value)) {
              if (operand === instr.value.object) {
                continue;
              }
              validateNoRefValueAccess(errors, env, operand);
            }
            break;
          }
          case 'StartMemoize':
          case 'FinishMemoize':
            break;
          case 'Primitive': {
            if (instr.value.value == null) {
              env.set(instr.lvalue.identifier.id, {kind: 'Nullable'});
            }
            break;
          }
          case 'BinaryExpression': {
            const left = env.get(instr.value.left.identifier.id);
            const right = env.get(instr.value.right.identifier.id);
            let nullish = false;
            let refId = null;
            if (
              (left === null || left === void 0 ? void 0 : left.kind) ===
                'RefValue' &&
              left.refId != null
            ) {
              refId = left.refId;
            } else if (
              (right === null || right === void 0 ? void 0 : right.kind) ===
                'RefValue' &&
              right.refId != null
            ) {
              refId = right.refId;
            }
            if (
              (left === null || left === void 0 ? void 0 : left.kind) ===
              'Nullable'
            ) {
              nullish = true;
            } else if (
              (right === null || right === void 0 ? void 0 : right.kind) ===
              'Nullable'
            ) {
              nullish = true;
            }
            if (refId !== null && nullish) {
              env.set(instr.lvalue.identifier.id, {
                kind: 'Guard',
                refId: refId,
              });
            } else {
              for (const operand of eachInstructionValueOperand(instr.value)) {
                validateNoRefValueAccess(errors, env, operand);
              }
            }
            break;
          }
          default: {
            for (const operand of eachInstructionValueOperand(instr.value)) {
              validateNoRefValueAccess(errors, env, operand);
            }
            break;
          }
        }
        for (const operand of eachInstructionOperand(instr)) {
          guardCheck(errors, operand, env);
        }
        if (
          isUseRefType(instr.lvalue.identifier) &&
          ((_e = env.get(instr.lvalue.identifier.id)) === null || _e === void 0
            ? void 0
            : _e.kind) !== 'Ref'
        ) {
          env.set(
            instr.lvalue.identifier.id,
            joinRefAccessTypes(
              (_f = env.get(instr.lvalue.identifier.id)) !== null &&
                _f !== void 0
                ? _f
                : {kind: 'None'},
              {kind: 'Ref', refId: nextRefId()}
            )
          );
        }
        if (
          isRefValueType(instr.lvalue.identifier) &&
          ((_g = env.get(instr.lvalue.identifier.id)) === null || _g === void 0
            ? void 0
            : _g.kind) !== 'RefValue'
        ) {
          env.set(
            instr.lvalue.identifier.id,
            joinRefAccessTypes(
              (_h = env.get(instr.lvalue.identifier.id)) !== null &&
                _h !== void 0
                ? _h
                : {kind: 'None'},
              {kind: 'RefValue', loc: instr.loc}
            )
          );
        }
      }
      if (block.terminal.kind === 'if') {
        const test = env.get(block.terminal.test.identifier.id);
        if (
          (test === null || test === void 0 ? void 0 : test.kind) === 'Guard'
        ) {
          safeBlocks.set(block.terminal.consequent, test.refId);
        }
      }
      for (const operand of eachTerminalOperand(block.terminal)) {
        if (block.terminal.kind !== 'return') {
          validateNoRefValueAccess(errors, env, operand);
          if (block.terminal.kind !== 'if') {
            guardCheck(errors, operand, env);
          }
        } else {
          validateNoDirectRefValueAccess(errors, operand, env);
          guardCheck(errors, operand, env);
          returnValues.push(env.get(operand.identifier.id));
        }
      }
    }
    if (errors.hasErrors()) {
      return Err(errors);
    }
  }
  CompilerError.invariant(!env.hasChanged(), {
    reason: 'Ref type environment did not converge',
    loc: null,
  });
  return Ok(
    joinRefAccessTypes(...returnValues.filter(env => env !== undefined))
  );
}
function destructure(type) {
  if (
    (type === null || type === void 0 ? void 0 : type.kind) === 'Structure' &&
    type.value !== null
  ) {
    return destructure(type.value);
  }
  return type;
}
function guardCheck(errors, operand, env) {
  var _a;
  if (
    ((_a = env.get(operand.identifier.id)) === null || _a === void 0
      ? void 0
      : _a.kind) === 'Guard'
  ) {
    errors.push({
      severity: exports.ErrorSeverity.InvalidReact,
      reason:
        'Ref values (the `current` property) may not be accessed during render. (https://react.dev/reference/react/useRef)',
      loc: operand.loc,
      description:
        operand.identifier.name !== null &&
        operand.identifier.name.kind === 'named'
          ? `Cannot access ref value \`${operand.identifier.name.value}\``
          : null,
      suggestions: null,
    });
  }
}
function validateNoRefValueAccess(errors, env, operand) {
  var _a;
  const type = destructure(env.get(operand.identifier.id));
  if (
    (type === null || type === void 0 ? void 0 : type.kind) === 'RefValue' ||
    ((type === null || type === void 0 ? void 0 : type.kind) === 'Structure' &&
      ((_a = type.fn) === null || _a === void 0 ? void 0 : _a.readRefEffect))
  ) {
    errors.push({
      severity: exports.ErrorSeverity.InvalidReact,
      reason:
        'Ref values (the `current` property) may not be accessed during render. (https://react.dev/reference/react/useRef)',
      loc: (type.kind === 'RefValue' && type.loc) || operand.loc,
      description:
        operand.identifier.name !== null &&
        operand.identifier.name.kind === 'named'
          ? `Cannot access ref value \`${operand.identifier.name.value}\``
          : null,
      suggestions: null,
    });
  }
}
function validateNoRefAccess(errors, env, operand, loc) {
  var _a;
  const type = destructure(env.get(operand.identifier.id));
  if (
    (type === null || type === void 0 ? void 0 : type.kind) === 'Ref' ||
    (type === null || type === void 0 ? void 0 : type.kind) === 'RefValue' ||
    ((type === null || type === void 0 ? void 0 : type.kind) === 'Structure' &&
      ((_a = type.fn) === null || _a === void 0 ? void 0 : _a.readRefEffect))
  ) {
    errors.push({
      severity: exports.ErrorSeverity.InvalidReact,
      reason:
        'Ref values (the `current` property) may not be accessed during render. (https://react.dev/reference/react/useRef)',
      loc: (type.kind === 'RefValue' && type.loc) || loc,
      description:
        operand.identifier.name !== null &&
        operand.identifier.name.kind === 'named'
          ? `Cannot access ref value \`${operand.identifier.name.value}\``
          : null,
      suggestions: null,
    });
  }
}
function validateNoDirectRefValueAccess(errors, operand, env) {
  var _a;
  const type = destructure(env.get(operand.identifier.id));
  if ((type === null || type === void 0 ? void 0 : type.kind) === 'RefValue') {
    errors.push({
      severity: exports.ErrorSeverity.InvalidReact,
      reason:
        'Ref values (the `current` property) may not be accessed during render. (https://react.dev/reference/react/useRef)',
      loc: (_a = type.loc) !== null && _a !== void 0 ? _a : operand.loc,
      description:
        operand.identifier.name !== null &&
        operand.identifier.name.kind === 'named'
          ? `Cannot access ref value \`${operand.identifier.name.value}\``
          : null,
      suggestions: null,
    });
  }
}
function validateNoSetStateInRender(fn) {
  const unconditionalSetStateFunctions = new Set();
  validateNoSetStateInRenderImpl(fn, unconditionalSetStateFunctions).unwrap();
}
function validateNoSetStateInRenderImpl(fn, unconditionalSetStateFunctions) {
  const unconditionalBlocks = computeUnconditionalBlocks(fn);
  let activeManualMemoId = null;
  const errors = new CompilerError();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'LoadLocal': {
          if (
            unconditionalSetStateFunctions.has(instr.value.place.identifier.id)
          ) {
            unconditionalSetStateFunctions.add(instr.lvalue.identifier.id);
          }
          break;
        }
        case 'StoreLocal': {
          if (
            unconditionalSetStateFunctions.has(instr.value.value.identifier.id)
          ) {
            unconditionalSetStateFunctions.add(
              instr.value.lvalue.place.identifier.id
            );
            unconditionalSetStateFunctions.add(instr.lvalue.identifier.id);
          }
          break;
        }
        case 'ObjectMethod':
        case 'FunctionExpression': {
          if (
            [...eachInstructionValueOperand(instr.value)].some(
              operand =>
                isSetStateType(operand.identifier) ||
                unconditionalSetStateFunctions.has(operand.identifier.id)
            ) &&
            validateNoSetStateInRenderImpl(
              instr.value.loweredFunc.func,
              unconditionalSetStateFunctions
            ).isErr()
          ) {
            unconditionalSetStateFunctions.add(instr.lvalue.identifier.id);
          }
          break;
        }
        case 'StartMemoize': {
          CompilerError.invariant(activeManualMemoId === null, {
            reason: 'Unexpected nested StartMemoize instructions',
            loc: instr.value.loc,
          });
          activeManualMemoId = instr.value.manualMemoId;
          break;
        }
        case 'FinishMemoize': {
          CompilerError.invariant(
            activeManualMemoId === instr.value.manualMemoId,
            {
              reason:
                'Expected FinishMemoize to align with previous StartMemoize instruction',
              loc: instr.value.loc,
            }
          );
          activeManualMemoId = null;
          break;
        }
        case 'CallExpression': {
          const callee = instr.value.callee;
          if (
            isSetStateType(callee.identifier) ||
            unconditionalSetStateFunctions.has(callee.identifier.id)
          ) {
            if (activeManualMemoId !== null) {
              errors.push({
                reason:
                  'Calling setState from useMemo may trigger an infinite loop. (https://react.dev/reference/react/useState)',
                description: null,
                severity: exports.ErrorSeverity.InvalidReact,
                loc: callee.loc,
                suggestions: null,
              });
            } else if (unconditionalBlocks.has(block.id)) {
              errors.push({
                reason:
                  'This is an unconditional set state during render, which will trigger an infinite loop. (https://react.dev/reference/react/useState)',
                description: null,
                severity: exports.ErrorSeverity.InvalidReact,
                loc: callee.loc,
                suggestions: null,
              });
            }
          }
          break;
        }
      }
    }
  }
  if (errors.hasErrors()) {
    return Err(errors);
  } else {
    return Ok(undefined);
  }
}
function validatePreservedManualMemoization(fn) {
  const state = {errors: new CompilerError(), manualMemoState: null};
  visitReactiveFunction(fn, new Visitor(), state);
  if (state.errors.hasErrors()) {
    throw state.errors;
  }
}
var CompareDependencyResult;
(function (CompareDependencyResult) {
  CompareDependencyResult[(CompareDependencyResult['Ok'] = 0)] = 'Ok';
  CompareDependencyResult[(CompareDependencyResult['RootDifference'] = 1)] =
    'RootDifference';
  CompareDependencyResult[(CompareDependencyResult['PathDifference'] = 2)] =
    'PathDifference';
  CompareDependencyResult[(CompareDependencyResult['Subpath'] = 3)] = 'Subpath';
  CompareDependencyResult[
    (CompareDependencyResult['RefAccessDifference'] = 4)
  ] = 'RefAccessDifference';
})(CompareDependencyResult || (CompareDependencyResult = {}));
function compareDeps(inferred, source) {
  const rootsEqual =
    (inferred.root.kind === 'Global' &&
      source.root.kind === 'Global' &&
      inferred.root.identifierName === source.root.identifierName) ||
    (inferred.root.kind === 'NamedLocal' &&
      source.root.kind === 'NamedLocal' &&
      inferred.root.value.identifier.id === source.root.value.identifier.id);
  if (!rootsEqual) {
    return CompareDependencyResult.RootDifference;
  }
  let isSubpath = true;
  for (let i = 0; i < Math.min(inferred.path.length, source.path.length); i++) {
    if (inferred.path[i].property !== source.path[i].property) {
      isSubpath = false;
      break;
    } else if (inferred.path[i].optional !== source.path[i].optional) {
      return CompareDependencyResult.PathDifference;
    }
  }
  if (
    isSubpath &&
    (source.path.length === inferred.path.length ||
      (inferred.path.length >= source.path.length &&
        !inferred.path.some(token => token.property === 'current')))
  ) {
    return CompareDependencyResult.Ok;
  } else {
    if (isSubpath) {
      if (
        source.path.some(token => token.property === 'current') ||
        inferred.path.some(token => token.property === 'current')
      ) {
        return CompareDependencyResult.RefAccessDifference;
      } else {
        return CompareDependencyResult.Subpath;
      }
    } else {
      return CompareDependencyResult.PathDifference;
    }
  }
}
function validateInferredDep(
  dep,
  temporaries,
  declsWithinMemoBlock,
  validDepsInMemoBlock,
  errorState,
  memoLocation
) {
  var _a;
  let normalizedDep;
  const maybeNormalizedRoot = temporaries.get(dep.identifier.id);
  if (maybeNormalizedRoot != null) {
    normalizedDep = {
      root: maybeNormalizedRoot.root,
      path: [...maybeNormalizedRoot.path, ...dep.path],
    };
  } else {
    CompilerError.invariant(
      ((_a = dep.identifier.name) === null || _a === void 0
        ? void 0
        : _a.kind) === 'named',
      {
        reason:
          'ValidatePreservedManualMemoization: expected scope dependency to be named',
        loc: GeneratedSource,
        suggestions: null,
      }
    );
    normalizedDep = {
      root: {
        kind: 'NamedLocal',
        value: {
          kind: 'Identifier',
          identifier: dep.identifier,
          loc: GeneratedSource,
          effect: exports.Effect.Read,
          reactive: false,
        },
      },
      path: [...dep.path],
    };
  }
  for (const decl of declsWithinMemoBlock) {
    if (
      normalizedDep.root.kind === 'NamedLocal' &&
      decl === normalizedDep.root.value.identifier.declarationId
    ) {
      return;
    }
  }
  for (const originalDep of validDepsInMemoBlock) {
    const compareResult = compareDeps(normalizedDep, originalDep);
    if (compareResult === CompareDependencyResult.Ok) {
      return;
    }
  }
  errorState.push({
    severity: exports.ErrorSeverity.CannotPreserveMemoization,
    reason:
      'React Compiler has skipped optimizing this component because the existing manual memoization could not be preserved. The inferred dependencies did not match the manually specified dependencies, which could cause the value to change more or less frequently than expected',
    description: null,
    loc: memoLocation,
    suggestions: null,
  });
}
class Visitor extends ReactiveFunctionVisitor {
  constructor() {
    super(...arguments);
    this.scopes = new Set();
    this.prunedScopes = new Set();
    this.temporaries = new Map();
  }
  recordDepsInValue(value, state) {
    var _a, _b;
    switch (value.kind) {
      case 'SequenceExpression': {
        for (const instr of value.instructions) {
          this.visitInstruction(instr, state);
        }
        const result = this.recordDepsInValue(value.value, state);
        return result;
      }
      case 'OptionalExpression': {
        return this.recordDepsInValue(value.value, state);
      }
      case 'ReactiveFunctionValue': {
        CompilerError.throwTodo({
          reason:
            'Handle ReactiveFunctionValue in ValidatePreserveManualMemoization',
          loc: value.loc,
        });
      }
      case 'ConditionalExpression': {
        this.recordDepsInValue(value.test, state);
        this.recordDepsInValue(value.consequent, state);
        this.recordDepsInValue(value.alternate, state);
        return null;
      }
      case 'LogicalExpression': {
        this.recordDepsInValue(value.left, state);
        this.recordDepsInValue(value.right, state);
        return null;
      }
      default: {
        const dep = collectMaybeMemoDependencies(
          value,
          this.temporaries,
          false
        );
        if (value.kind === 'StoreLocal' || value.kind === 'StoreContext') {
          const storeTarget = value.lvalue.place;
          (_a = state.manualMemoState) === null || _a === void 0
            ? void 0
            : _a.decls.add(storeTarget.identifier.declarationId);
          if (
            ((_b = storeTarget.identifier.name) === null || _b === void 0
              ? void 0
              : _b.kind) === 'named' &&
            dep == null
          ) {
            const dep = {
              root: {kind: 'NamedLocal', value: storeTarget},
              path: [],
            };
            this.temporaries.set(storeTarget.identifier.id, dep);
            return dep;
          }
        }
        return dep;
      }
    }
  }
  recordTemporaries(instr, state) {
    var _a;
    const temporaries = this.temporaries;
    const {lvalue: lvalue, value: value} = instr;
    const lvalId =
      lvalue === null || lvalue === void 0 ? void 0 : lvalue.identifier.id;
    if (lvalId != null && temporaries.has(lvalId)) {
      return;
    }
    const isNamedLocal =
      ((_a =
        lvalue === null || lvalue === void 0
          ? void 0
          : lvalue.identifier.name) === null || _a === void 0
        ? void 0
        : _a.kind) === 'named';
    if (lvalue !== null && isNamedLocal && state.manualMemoState != null) {
      state.manualMemoState.decls.add(lvalue.identifier.declarationId);
    }
    const maybeDep = this.recordDepsInValue(value, state);
    if (lvalId != null) {
      if (maybeDep != null) {
        temporaries.set(lvalId, maybeDep);
      } else if (isNamedLocal) {
        temporaries.set(lvalId, {
          root: {kind: 'NamedLocal', value: Object.assign({}, instr.lvalue)},
          path: [],
        });
      }
    }
  }
  visitScope(scopeBlock, state) {
    this.traverseScope(scopeBlock, state);
    if (
      state.manualMemoState != null &&
      state.manualMemoState.depsFromSource != null
    ) {
      for (const dep of scopeBlock.scope.dependencies) {
        validateInferredDep(
          dep,
          this.temporaries,
          state.manualMemoState.decls,
          state.manualMemoState.depsFromSource,
          state.errors,
          state.manualMemoState.loc
        );
      }
    }
    this.scopes.add(scopeBlock.scope.id);
    for (const id of scopeBlock.scope.merged) {
      this.scopes.add(id);
    }
  }
  visitPrunedScope(scopeBlock, state) {
    this.traversePrunedScope(scopeBlock, state);
    this.prunedScopes.add(scopeBlock.scope.id);
  }
  visitInstruction(instruction, state) {
    var _a, _b, _c;
    this.recordTemporaries(instruction, state);
    const value = instruction.value;
    if (
      value.kind === 'StoreLocal' &&
      value.lvalue.kind === 'Reassign' &&
      state.manualMemoState != null
    ) {
      const ids = getOrInsertDefault(
        state.manualMemoState.reassignments,
        value.lvalue.place.identifier.declarationId,
        new Set()
      );
      ids.add(value.value.identifier);
    }
    if (value.kind === 'StartMemoize') {
      let depsFromSource = null;
      if (value.deps != null) {
        depsFromSource = value.deps;
      }
      CompilerError.invariant(state.manualMemoState == null, {
        reason: 'Unexpected nested StartMemoize instructions',
        description: `Bad manual memoization ids: ${(_a = state.manualMemoState) === null || _a === void 0 ? void 0 : _a.manualMemoId}, ${value.manualMemoId}`,
        loc: value.loc,
        suggestions: null,
      });
      state.manualMemoState = {
        loc: instruction.loc,
        decls: new Set(),
        depsFromSource: depsFromSource,
        manualMemoId: value.manualMemoId,
        reassignments: new Map(),
      };
      for (const {
        identifier: identifier,
        loc: loc,
      } of eachInstructionValueOperand(value)) {
        if (
          identifier.scope != null &&
          !this.scopes.has(identifier.scope.id) &&
          !this.prunedScopes.has(identifier.scope.id)
        ) {
          state.errors.push({
            reason:
              'React Compiler has skipped optimizing this component because the existing manual memoization could not be preserved. This dependency may be mutated later, which could cause the value to change unexpectedly',
            description: null,
            severity: exports.ErrorSeverity.CannotPreserveMemoization,
            loc: loc,
            suggestions: null,
          });
        }
      }
    }
    if (value.kind === 'FinishMemoize') {
      CompilerError.invariant(
        state.manualMemoState != null &&
          state.manualMemoState.manualMemoId === value.manualMemoId,
        {
          reason: 'Unexpected mismatch between StartMemoize and FinishMemoize',
          description: `Encountered StartMemoize id=${(_b = state.manualMemoState) === null || _b === void 0 ? void 0 : _b.manualMemoId} followed by FinishMemoize id=${value.manualMemoId}`,
          loc: value.loc,
          suggestions: null,
        }
      );
      const reassignments = state.manualMemoState.reassignments;
      state.manualMemoState = null;
      if (!value.pruned) {
        for (const {
          identifier: identifier,
          loc: loc,
        } of eachInstructionValueOperand(value)) {
          let decls;
          if (identifier.scope == null) {
            decls =
              (_c = reassignments.get(identifier.declarationId)) !== null &&
              _c !== void 0
                ? _c
                : [identifier];
          } else {
            decls = [identifier];
          }
          for (const identifier of decls) {
            if (isUnmemoized(identifier, this.scopes)) {
              state.errors.push({
                reason:
                  'React Compiler has skipped optimizing this component because the existing manual memoization could not be preserved. This value was memoized in source but not in compilation output.',
                description: null,
                severity: exports.ErrorSeverity.CannotPreserveMemoization,
                loc: loc,
                suggestions: null,
              });
            }
          }
        }
      }
    }
  }
}
function isUnmemoized(operand, scopes) {
  return operand.scope != null && !scopes.has(operand.scope.id);
}
function validateUseMemo(fn) {
  const useMemos = new Set();
  const react = new Set();
  const functions = new Map();
  for (const [, block] of fn.body.blocks) {
    for (const {lvalue: lvalue, value: value} of block.instructions) {
      switch (value.kind) {
        case 'LoadGlobal': {
          if (value.binding.name === 'useMemo') {
            useMemos.add(lvalue.identifier.id);
          } else if (value.binding.name === 'React') {
            react.add(lvalue.identifier.id);
          }
          break;
        }
        case 'PropertyLoad': {
          if (react.has(value.object.identifier.id)) {
            if (value.property === 'useMemo') {
              useMemos.add(lvalue.identifier.id);
            }
          }
          break;
        }
        case 'FunctionExpression': {
          functions.set(lvalue.identifier.id, value);
          break;
        }
        case 'MethodCall':
        case 'CallExpression': {
          const callee =
            value.kind === 'CallExpression'
              ? value.callee.identifier.id
              : value.property.identifier.id;
          const isUseMemo = useMemos.has(callee);
          if (!isUseMemo || value.args.length === 0) {
            continue;
          }
          const [arg] = value.args;
          if (arg.kind !== 'Identifier') {
            continue;
          }
          const body = functions.get(arg.identifier.id);
          if (body === undefined) {
            continue;
          }
          if (body.loweredFunc.func.params.length > 0) {
            CompilerError.throwInvalidReact({
              reason: 'useMemo callbacks may not accept any arguments',
              description: null,
              loc: body.loc,
              suggestions: null,
            });
          }
          if (body.loweredFunc.func.async || body.loweredFunc.func.generator) {
            CompilerError.throwInvalidReact({
              reason:
                'useMemo callbacks may not be async or generator functions',
              description: null,
              loc: body.loc,
              suggestions: null,
            });
          }
          break;
        }
      }
    }
  }
}
function validateLocalsNotReassignedAfterRender(fn) {
  const contextVariables = new Set();
  const reassignment = getContextReassignment(
    fn,
    contextVariables,
    false,
    false
  );
  if (reassignment !== null) {
    CompilerError.throwInvalidReact({
      reason:
        'Reassigning a variable after render has completed can cause inconsistent behavior on subsequent renders. Consider using state instead',
      description:
        reassignment.identifier.name !== null &&
        reassignment.identifier.name.kind === 'named'
          ? `Variable \`${reassignment.identifier.name.value}\` cannot be reassigned after render`
          : '',
      loc: reassignment.loc,
    });
  }
}
function getContextReassignment(
  fn,
  contextVariables,
  isFunctionExpression,
  isAsync
) {
  const reassigningFunctions = new Map();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {lvalue: lvalue, value: value} = instr;
      switch (value.kind) {
        case 'FunctionExpression':
        case 'ObjectMethod': {
          let reassignment = getContextReassignment(
            value.loweredFunc.func,
            contextVariables,
            true,
            isAsync || value.loweredFunc.func.async
          );
          if (reassignment === null) {
            for (const operand of eachInstructionValueOperand(value)) {
              const reassignmentFromOperand = reassigningFunctions.get(
                operand.identifier.id
              );
              if (reassignmentFromOperand !== undefined) {
                reassignment = reassignmentFromOperand;
                break;
              }
            }
          }
          if (reassignment !== null) {
            if (isAsync || value.loweredFunc.func.async) {
              CompilerError.throwInvalidReact({
                reason:
                  'Reassigning a variable in an async function can cause inconsistent behavior on subsequent renders. Consider using state instead',
                description:
                  reassignment.identifier.name !== null &&
                  reassignment.identifier.name.kind === 'named'
                    ? `Variable \`${reassignment.identifier.name.value}\` cannot be reassigned after render`
                    : '',
                loc: reassignment.loc,
              });
            }
            reassigningFunctions.set(lvalue.identifier.id, reassignment);
          }
          break;
        }
        case 'StoreLocal': {
          const reassignment = reassigningFunctions.get(
            value.value.identifier.id
          );
          if (reassignment !== undefined) {
            reassigningFunctions.set(
              value.lvalue.place.identifier.id,
              reassignment
            );
            reassigningFunctions.set(lvalue.identifier.id, reassignment);
          }
          break;
        }
        case 'LoadLocal': {
          const reassignment = reassigningFunctions.get(
            value.place.identifier.id
          );
          if (reassignment !== undefined) {
            reassigningFunctions.set(lvalue.identifier.id, reassignment);
          }
          break;
        }
        case 'DeclareContext': {
          if (!isFunctionExpression) {
            contextVariables.add(value.lvalue.place.identifier.id);
          }
          break;
        }
        case 'StoreContext': {
          if (isFunctionExpression) {
            if (contextVariables.has(value.lvalue.place.identifier.id)) {
              return value.lvalue.place;
            }
          } else {
            contextVariables.add(value.lvalue.place.identifier.id);
          }
          const reassignment = reassigningFunctions.get(
            value.value.identifier.id
          );
          if (reassignment !== undefined) {
            reassigningFunctions.set(
              value.lvalue.place.identifier.id,
              reassignment
            );
            reassigningFunctions.set(lvalue.identifier.id, reassignment);
          }
          break;
        }
        default: {
          let operands = eachInstructionValueOperand(value);
          if (value.kind === 'CallExpression') {
            const signature = getFunctionCallSignature(
              fn.env,
              value.callee.identifier.type
            );
            if (
              signature === null || signature === void 0
                ? void 0
                : signature.noAlias
            ) {
              operands = [value.callee];
            }
          } else if (value.kind === 'MethodCall') {
            const signature = getFunctionCallSignature(
              fn.env,
              value.property.identifier.type
            );
            if (
              signature === null || signature === void 0
                ? void 0
                : signature.noAlias
            ) {
              operands = [value.receiver, value.property];
            }
          } else if (value.kind === 'TaggedTemplateExpression') {
            const signature = getFunctionCallSignature(
              fn.env,
              value.tag.identifier.type
            );
            if (
              signature === null || signature === void 0
                ? void 0
                : signature.noAlias
            ) {
              operands = [value.tag];
            }
          }
          for (const operand of operands) {
            CompilerError.invariant(operand.effect !== exports.Effect.Unknown, {
              reason: `Expected effects to be inferred prior to ValidateLocalsNotReassignedAfterRender`,
              loc: operand.loc,
            });
            const reassignment = reassigningFunctions.get(
              operand.identifier.id
            );
            if (reassignment !== undefined) {
              if (operand.effect === exports.Effect.Freeze) {
                return reassignment;
              } else {
                for (const lval of eachInstructionLValue(instr)) {
                  reassigningFunctions.set(lval.identifier.id, reassignment);
                }
              }
            }
          }
          break;
        }
      }
    }
    for (const operand of eachTerminalOperand(block.terminal)) {
      const reassignment = reassigningFunctions.get(operand.identifier.id);
      if (reassignment !== undefined) {
        return reassignment;
      }
    }
  }
  return null;
}
function outlineFunctions(fn, fbtOperands) {
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {value: value, lvalue: lvalue} = instr;
      if (
        value.kind === 'FunctionExpression' ||
        value.kind === 'ObjectMethod'
      ) {
        outlineFunctions(value.loweredFunc.func, fbtOperands);
      }
      if (
        value.kind === 'FunctionExpression' &&
        value.loweredFunc.dependencies.length === 0 &&
        value.loweredFunc.func.context.length === 0 &&
        value.loweredFunc.func.id === null &&
        !fbtOperands.has(lvalue.identifier.id)
      ) {
        const loweredFunc = value.loweredFunc.func;
        const id = fn.env.generateGloballyUniqueIdentifierName(loweredFunc.id);
        loweredFunc.id = id.value;
        fn.env.outlineFunction(loweredFunc, null);
        instr.value = {
          kind: 'LoadGlobal',
          binding: {kind: 'Global', name: id.value},
          loc: value.loc,
        };
      }
    }
  }
}
function propagatePhiTypes(fn) {
  const propagated = new Set();
  for (const [, block] of fn.body.blocks) {
    for (const phi of block.phis) {
      if (
        phi.place.identifier.type.kind !== 'Type' ||
        phi.place.identifier.name !== null
      ) {
        continue;
      }
      let type = null;
      for (const [, operand] of phi.operands) {
        if (type === null) {
          type = operand.identifier.type;
        } else if (!typeEquals(type, operand.identifier.type)) {
          type = null;
          break;
        }
      }
      if (type !== null) {
        phi.place.identifier.type = type;
        propagated.add(phi.place.identifier.id);
      }
    }
    for (const instr of block.instructions) {
      const {value: value} = instr;
      switch (value.kind) {
        case 'StoreLocal': {
          const lvalue = value.lvalue.place;
          if (
            propagated.has(value.value.identifier.id) &&
            lvalue.identifier.type.kind === 'Type' &&
            lvalue.identifier.name === null
          ) {
            lvalue.identifier.type = value.value.identifier.type;
            propagated.add(lvalue.identifier.id);
          }
        }
      }
    }
  }
}
function lowerContextAccess(fn, loweredContextCallee) {
  const contextAccess = new Map();
  const contextKeys = new Map();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {value: value, lvalue: lvalue} = instr;
      if (
        value.kind === 'CallExpression' &&
        isUseContextHookType(value.callee.identifier)
      ) {
        contextAccess.set(lvalue.identifier.id, value);
        continue;
      }
      if (value.kind !== 'Destructure') {
        continue;
      }
      const destructureId = value.value.identifier.id;
      if (!contextAccess.has(destructureId)) {
        continue;
      }
      const keys = getContextKeys(value);
      if (keys === null) {
        return;
      }
      if (contextKeys.has(destructureId)) {
        return;
      } else {
        contextKeys.set(destructureId, keys);
      }
    }
  }
  if (contextAccess.size > 0 && contextKeys.size > 0) {
    for (const [, block] of fn.body.blocks) {
      let nextInstructions = null;
      for (let i = 0; i < block.instructions.length; i++) {
        const instr = block.instructions[i];
        const {lvalue: lvalue, value: value} = instr;
        if (
          value.kind === 'CallExpression' &&
          isUseContextHookType(value.callee.identifier) &&
          contextKeys.has(lvalue.identifier.id)
        ) {
          const loweredContextCalleeInstr = emitLoadLoweredContextCallee(
            fn.env,
            loweredContextCallee
          );
          if (nextInstructions === null) {
            nextInstructions = block.instructions.slice(0, i);
          }
          nextInstructions.push(loweredContextCalleeInstr);
          const keys = contextKeys.get(lvalue.identifier.id);
          const selectorFnInstr = emitSelectorFn(fn.env, keys);
          nextInstructions.push(selectorFnInstr);
          const lowerContextCallId = loweredContextCalleeInstr.lvalue;
          value.callee = lowerContextCallId;
          const selectorFn = selectorFnInstr.lvalue;
          value.args.push(selectorFn);
        }
        if (nextInstructions) {
          nextInstructions.push(instr);
        }
      }
      if (nextInstructions) {
        block.instructions = nextInstructions;
      }
    }
    markInstructionIds(fn.body);
    inferTypes(fn);
    fn.env.hasLoweredContextAccess = true;
  }
}
function emitLoadLoweredContextCallee(env, loweredContextCallee) {
  const loadGlobal = {
    kind: 'LoadGlobal',
    binding: {
      kind: 'ImportNamespace',
      module: loweredContextCallee.source,
      name: loweredContextCallee.importSpecifierName,
    },
    loc: GeneratedSource,
  };
  return {
    id: makeInstructionId(0),
    loc: GeneratedSource,
    lvalue: createTemporaryPlace(env, GeneratedSource),
    value: loadGlobal,
  };
}
function getContextKeys(value) {
  const keys = [];
  const pattern = value.lvalue.pattern;
  switch (pattern.kind) {
    case 'ArrayPattern': {
      return null;
    }
    case 'ObjectPattern': {
      for (const place of pattern.properties) {
        if (
          place.kind !== 'ObjectProperty' ||
          place.type !== 'property' ||
          place.key.kind !== 'identifier' ||
          place.place.identifier.name === null ||
          place.place.identifier.name.kind !== 'named'
        ) {
          return null;
        }
        keys.push(place.key.name);
      }
      return keys;
    }
  }
}
function emitPropertyLoad(env, obj, property) {
  const loadObj = {kind: 'LoadLocal', place: obj, loc: GeneratedSource};
  const object = createTemporaryPlace(env, GeneratedSource);
  const loadLocalInstr = {
    lvalue: object,
    value: loadObj,
    id: makeInstructionId(0),
    loc: GeneratedSource,
  };
  const loadProp = {
    kind: 'PropertyLoad',
    object: object,
    property: property,
    loc: GeneratedSource,
  };
  const element = createTemporaryPlace(env, GeneratedSource);
  const loadPropInstr = {
    lvalue: element,
    value: loadProp,
    id: makeInstructionId(0),
    loc: GeneratedSource,
  };
  return {instructions: [loadLocalInstr, loadPropInstr], element: element};
}
function emitSelectorFn(env, keys) {
  const obj = createTemporaryPlace(env, GeneratedSource);
  promoteTemporary(obj.identifier);
  const instr = [];
  const elements = [];
  for (const key of keys) {
    const {instructions: instructions, element: prop} = emitPropertyLoad(
      env,
      obj,
      key
    );
    instr.push(...instructions);
    elements.push(prop);
  }
  const arrayInstr = emitArrayInstr(elements, env);
  instr.push(arrayInstr);
  const block = {
    kind: 'block',
    id: makeBlockId(0),
    instructions: instr,
    terminal: {
      id: makeInstructionId(0),
      kind: 'return',
      loc: GeneratedSource,
      value: arrayInstr.lvalue,
    },
    preds: new Set(),
    phis: new Set(),
  };
  const fn = {
    loc: GeneratedSource,
    id: null,
    fnType: 'Other',
    env: env,
    params: [obj],
    returnTypeAnnotation: null,
    returnType: makeType(),
    context: [],
    effects: null,
    body: {entry: block.id, blocks: new Map([[block.id, block]])},
    generator: false,
    async: false,
    directives: [],
  };
  reversePostorderBlocks(fn.body);
  markInstructionIds(fn.body);
  enterSSA(fn);
  inferTypes(fn);
  const fnInstr = {
    id: makeInstructionId(0),
    value: {
      kind: 'FunctionExpression',
      name: null,
      loweredFunc: {func: fn, dependencies: []},
      type: 'ArrowFunctionExpression',
      loc: GeneratedSource,
    },
    lvalue: createTemporaryPlace(env, GeneratedSource),
    loc: GeneratedSource,
  };
  return fnInstr;
}
function emitArrayInstr(elements, env) {
  const array = {
    kind: 'ArrayExpression',
    elements: elements,
    loc: GeneratedSource,
  };
  const arrayLvalue = createTemporaryPlace(env, GeneratedSource);
  const arrayInstr = {
    id: makeInstructionId(0),
    value: array,
    lvalue: arrayLvalue,
    loc: GeneratedSource,
  };
  return arrayInstr;
}
function validateNoSetStateInPassiveEffects(fn) {
  const setStateFunctions = new Map();
  const errors = new CompilerError();
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'LoadLocal': {
          if (setStateFunctions.has(instr.value.place.identifier.id)) {
            setStateFunctions.set(
              instr.lvalue.identifier.id,
              instr.value.place
            );
          }
          break;
        }
        case 'StoreLocal': {
          if (setStateFunctions.has(instr.value.value.identifier.id)) {
            setStateFunctions.set(
              instr.value.lvalue.place.identifier.id,
              instr.value.value
            );
            setStateFunctions.set(
              instr.lvalue.identifier.id,
              instr.value.value
            );
          }
          break;
        }
        case 'FunctionExpression': {
          if (
            [...eachInstructionValueOperand(instr.value)].some(
              operand =>
                isSetStateType(operand.identifier) ||
                setStateFunctions.has(operand.identifier.id)
            )
          ) {
            const callee = getSetStateCall(
              instr.value.loweredFunc.func,
              setStateFunctions
            );
            if (callee !== null) {
              setStateFunctions.set(instr.lvalue.identifier.id, callee);
            }
          }
          break;
        }
        case 'MethodCall':
        case 'CallExpression': {
          const callee =
            instr.value.kind === 'MethodCall'
              ? instr.value.receiver
              : instr.value.callee;
          if (isUseEffectHookType(callee.identifier)) {
            const arg = instr.value.args[0];
            if (arg !== undefined && arg.kind === 'Identifier') {
              const setState = setStateFunctions.get(arg.identifier.id);
              if (setState !== undefined) {
                errors.push({
                  reason:
                    'Calling setState directly within a useEffect causes cascading renders and is not recommended. Consider alternatives to useEffect. (https://react.dev/learn/you-might-not-need-an-effect)',
                  description: null,
                  severity: exports.ErrorSeverity.InvalidReact,
                  loc: setState.loc,
                  suggestions: null,
                });
              }
            }
          }
          break;
        }
      }
    }
  }
  if (errors.hasErrors()) {
    throw errors;
  }
}
function getSetStateCall(fn, setStateFunctions) {
  for (const [, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      switch (instr.value.kind) {
        case 'LoadLocal': {
          if (setStateFunctions.has(instr.value.place.identifier.id)) {
            setStateFunctions.set(
              instr.lvalue.identifier.id,
              instr.value.place
            );
          }
          break;
        }
        case 'StoreLocal': {
          if (setStateFunctions.has(instr.value.value.identifier.id)) {
            setStateFunctions.set(
              instr.value.lvalue.place.identifier.id,
              instr.value.value
            );
            setStateFunctions.set(
              instr.lvalue.identifier.id,
              instr.value.value
            );
          }
          break;
        }
        case 'CallExpression': {
          const callee = instr.value.callee;
          if (
            isSetStateType(callee.identifier) ||
            setStateFunctions.has(callee.identifier.id)
          ) {
            return callee;
          }
        }
      }
    }
  }
  return null;
}
function validateNoJSXInTryStatement(fn) {
  const activeTryBlocks = [];
  const errors = new CompilerError();
  for (const [, block] of fn.body.blocks) {
    retainWhere(activeTryBlocks, id => id !== block.id);
    if (activeTryBlocks.length !== 0) {
      for (const instr of block.instructions) {
        const {value: value} = instr;
        switch (value.kind) {
          case 'JsxExpression':
          case 'JsxFragment': {
            errors.push({
              severity: exports.ErrorSeverity.InvalidReact,
              reason: `Unexpected JSX element within a try statement. To catch errors in rendering a given component, wrap that component in an error boundary. (https://react.dev/reference/react/Component#catching-rendering-errors-with-an-error-boundary)`,
              loc: value.loc,
            });
            break;
          }
        }
      }
    }
    if (block.terminal.kind === 'try') {
      activeTryBlocks.push(block.terminal.handler);
    }
  }
  if (errors.hasErrors()) {
    throw errors;
  }
}
function collectHoistablePropertyLoads(
  fn,
  temporaries,
  hoistableFromOptionals
) {
  const registry = new PropertyPathRegistry();
  const knownImmutableIdentifiers = new Set();
  if (fn.fnType === 'Component' || fn.fnType === 'Hook') {
    for (const p of fn.params) {
      if (p.kind === 'Identifier') {
        knownImmutableIdentifiers.add(p.identifier.id);
      }
    }
  }
  return collectHoistablePropertyLoadsImpl(fn, {
    temporaries: temporaries,
    knownImmutableIdentifiers: knownImmutableIdentifiers,
    hoistableFromOptionals: hoistableFromOptionals,
    registry: registry,
    nestedFnImmutableContext: null,
  });
}
function collectHoistablePropertyLoadsImpl(fn, context) {
  const functionExpressionLoads = collectFunctionExpressionFakeLoads(fn);
  const actuallyEvaluatedTemporaries = new Map(
    [...context.temporaries].filter(([id]) => !functionExpressionLoads.has(id))
  );
  const nodes = collectNonNullsInBlocks(
    fn,
    Object.assign(Object.assign({}, context), {
      temporaries: actuallyEvaluatedTemporaries,
    })
  );
  propagateNonNull(fn, nodes, context.registry);
  return nodes;
}
function keyByScopeId(fn, source) {
  const keyedByScopeId = new Map();
  for (const [_, block] of fn.body.blocks) {
    if (block.terminal.kind === 'scope') {
      keyedByScopeId.set(
        block.terminal.scope.id,
        source.get(block.terminal.block)
      );
    }
  }
  return keyedByScopeId;
}
class PropertyPathRegistry {
  constructor() {
    this.roots = new Map();
  }
  getOrCreateIdentifier(identifier) {
    let rootNode = this.roots.get(identifier.id);
    if (rootNode === undefined) {
      rootNode = {
        root: identifier.id,
        properties: new Map(),
        optionalProperties: new Map(),
        fullPath: {identifier: identifier, path: []},
        hasOptional: false,
        parent: null,
      };
      this.roots.set(identifier.id, rootNode);
    }
    return rootNode;
  }
  static getOrCreatePropertyEntry(parent, entry) {
    const map = entry.optional ? parent.optionalProperties : parent.properties;
    let child = map.get(entry.property);
    if (child == null) {
      child = {
        properties: new Map(),
        optionalProperties: new Map(),
        parent: parent,
        fullPath: {
          identifier: parent.fullPath.identifier,
          path: parent.fullPath.path.concat(entry),
        },
        hasOptional: parent.hasOptional || entry.optional,
      };
      map.set(entry.property, child);
    }
    return child;
  }
  getOrCreateProperty(n) {
    let currNode = this.getOrCreateIdentifier(n.identifier);
    if (n.path.length === 0) {
      return currNode;
    }
    for (let i = 0; i < n.path.length - 1; i++) {
      currNode = PropertyPathRegistry.getOrCreatePropertyEntry(
        currNode,
        n.path[i]
      );
    }
    return PropertyPathRegistry.getOrCreatePropertyEntry(
      currNode,
      n.path.at(-1)
    );
  }
}
function getMaybeNonNullInInstruction(instr, context) {
  var _a, _b, _c;
  let path = null;
  if (instr.kind === 'PropertyLoad') {
    path =
      (_a = context.temporaries.get(instr.object.identifier.id)) !== null &&
      _a !== void 0
        ? _a
        : {identifier: instr.object.identifier, path: []};
  } else if (instr.kind === 'Destructure') {
    path =
      (_b = context.temporaries.get(instr.value.identifier.id)) !== null &&
      _b !== void 0
        ? _b
        : null;
  } else if (instr.kind === 'ComputedLoad') {
    path =
      (_c = context.temporaries.get(instr.object.identifier.id)) !== null &&
      _c !== void 0
        ? _c
        : null;
  }
  return path != null ? context.registry.getOrCreateProperty(path) : null;
}
function isImmutableAtInstr(identifier, instr, context) {
  if (context.nestedFnImmutableContext != null) {
    return context.nestedFnImmutableContext.has(identifier.id);
  } else {
    const mutableAtInstr =
      identifier.mutableRange.end > identifier.mutableRange.start + 1 &&
      identifier.scope != null &&
      inRange({id: instr}, identifier.scope.range);
    return (
      !mutableAtInstr || context.knownImmutableIdentifiers.has(identifier.id)
    );
  }
}
function collectNonNullsInBlocks(fn, context) {
  var _a;
  const knownNonNullIdentifiers = new Set();
  if (
    fn.fnType === 'Component' &&
    fn.params.length > 0 &&
    fn.params[0].kind === 'Identifier'
  ) {
    const identifier = fn.params[0].identifier;
    knownNonNullIdentifiers.add(
      context.registry.getOrCreateIdentifier(identifier)
    );
  }
  const nodes = new Map();
  for (const [_, block] of fn.body.blocks) {
    const assumedNonNullObjects = new Set(knownNonNullIdentifiers);
    const maybeOptionalChain = context.hoistableFromOptionals.get(block.id);
    if (maybeOptionalChain != null) {
      assumedNonNullObjects.add(
        context.registry.getOrCreateProperty(maybeOptionalChain)
      );
    }
    for (const instr of block.instructions) {
      const maybeNonNull = getMaybeNonNullInInstruction(instr.value, context);
      if (
        maybeNonNull != null &&
        isImmutableAtInstr(maybeNonNull.fullPath.identifier, instr.id, context)
      ) {
        assumedNonNullObjects.add(maybeNonNull);
      }
      if (
        (instr.value.kind === 'FunctionExpression' ||
          instr.value.kind === 'ObjectMethod') &&
        !fn.env.config.enableTreatFunctionDepsAsConditional
      ) {
        const innerFn = instr.value.loweredFunc;
        const innerHoistableMap = collectHoistablePropertyLoadsImpl(
          innerFn.func,
          Object.assign(Object.assign({}, context), {
            nestedFnImmutableContext:
              (_a = context.nestedFnImmutableContext) !== null && _a !== void 0
                ? _a
                : new Set(
                    innerFn.func.context
                      .filter(place =>
                        isImmutableAtInstr(place.identifier, instr.id, context)
                      )
                      .map(place => place.identifier.id)
                  ),
          })
        );
        const innerHoistables = assertNonNull(
          innerHoistableMap.get(innerFn.func.body.entry)
        );
        for (const entry of innerHoistables.assumedNonNullObjects) {
          assumedNonNullObjects.add(entry);
        }
      }
    }
    nodes.set(block.id, {
      block: block,
      assumedNonNullObjects: assumedNonNullObjects,
    });
  }
  return nodes;
}
function propagateNonNull(fn, nodes, registry) {
  const blockSuccessors = new Map();
  const terminalPreds = new Set();
  for (const [blockId, block] of fn.body.blocks) {
    for (const pred of block.preds) {
      getOrInsertDefault(blockSuccessors, pred, new Set()).add(blockId);
    }
    if (block.terminal.kind === 'throw' || block.terminal.kind === 'return') {
      terminalPreds.add(blockId);
    }
  }
  function recursivelyPropagateNonNull(nodeId, direction, traversalState) {
    var _a;
    if (traversalState.has(nodeId)) {
      return false;
    }
    traversalState.set(nodeId, 'active');
    const node = nodes.get(nodeId);
    if (node == null) {
      CompilerError.invariant(false, {
        reason: `Bad node ${nodeId}, kind: ${direction}`,
        loc: GeneratedSource,
      });
    }
    const neighbors = Array.from(
      direction === 'backward'
        ? (_a = blockSuccessors.get(nodeId)) !== null && _a !== void 0
          ? _a
          : []
        : node.block.preds
    );
    let changed = false;
    for (const pred of neighbors) {
      if (!traversalState.has(pred)) {
        const neighborChanged = recursivelyPropagateNonNull(
          pred,
          direction,
          traversalState
        );
        changed || (changed = neighborChanged);
      }
    }
    const neighborAccesses = Set_intersect(
      Array.from(neighbors)
        .filter(n => traversalState.get(n) === 'done')
        .map(n => assertNonNull(nodes.get(n)).assumedNonNullObjects)
    );
    const prevObjects = assertNonNull(nodes.get(nodeId)).assumedNonNullObjects;
    const mergedObjects = Set_union(prevObjects, neighborAccesses);
    reduceMaybeOptionalChains(mergedObjects, registry);
    assertNonNull(nodes.get(nodeId)).assumedNonNullObjects = mergedObjects;
    traversalState.set(nodeId, 'done');
    changed || (changed = !Set_equal(prevObjects, mergedObjects));
    return changed;
  }
  const traversalState = new Map();
  const reversedBlocks = [...fn.body.blocks];
  reversedBlocks.reverse();
  let changed;
  let i = 0;
  do {
    CompilerError.invariant(i++ < 100, {
      reason:
        '[CollectHoistablePropertyLoads] fixed point iteration did not terminate after 100 loops',
      loc: GeneratedSource,
    });
    changed = false;
    for (const [blockId] of fn.body.blocks) {
      const forwardChanged = recursivelyPropagateNonNull(
        blockId,
        'forward',
        traversalState
      );
      changed || (changed = forwardChanged);
    }
    traversalState.clear();
    for (const [blockId] of reversedBlocks) {
      const backwardChanged = recursivelyPropagateNonNull(
        blockId,
        'backward',
        traversalState
      );
      changed || (changed = backwardChanged);
    }
    traversalState.clear();
  } while (changed);
}
function assertNonNull(value, source) {
  CompilerError.invariant(value != null, {
    reason: 'Unexpected null',
    description: null,
    loc: GeneratedSource,
  });
  return value;
}
function reduceMaybeOptionalChains(nodes, registry) {
  let optionalChainNodes = Set_filter(nodes, n => n.hasOptional);
  if (optionalChainNodes.size === 0) {
    return;
  }
  let changed;
  do {
    changed = false;
    for (const original of optionalChainNodes) {
      let {identifier: identifier, path: origPath} = original.fullPath;
      let currNode = registry.getOrCreateIdentifier(identifier);
      for (let i = 0; i < origPath.length; i++) {
        const entry = origPath[i];
        const nextEntry =
          entry.optional && nodes.has(currNode)
            ? {property: entry.property, optional: false}
            : entry;
        currNode = PropertyPathRegistry.getOrCreatePropertyEntry(
          currNode,
          nextEntry
        );
      }
      if (currNode !== original) {
        changed = true;
        optionalChainNodes.delete(original);
        optionalChainNodes.add(currNode);
        nodes.delete(original);
        nodes.add(currNode);
      }
    }
  } while (changed);
}
function collectFunctionExpressionFakeLoads(fn) {
  const sources = new Map();
  const functionExpressionReferences = new Set();
  for (const [_, block] of fn.body.blocks) {
    for (const {lvalue: lvalue, value: value} of block.instructions) {
      if (
        value.kind === 'FunctionExpression' ||
        value.kind === 'ObjectMethod'
      ) {
        for (const reference of value.loweredFunc.dependencies) {
          let curr = reference.identifier.id;
          while (curr != null) {
            functionExpressionReferences.add(curr);
            curr = sources.get(curr);
          }
        }
      } else if (value.kind === 'PropertyLoad') {
        sources.set(lvalue.identifier.id, value.object.identifier.id);
      }
    }
  }
  return functionExpressionReferences;
}
var _Node_value, _Node_next;
function empty() {
  return EMPTY;
}
class Node {
  constructor(value, next = EMPTY) {
    _Node_value.set(this, void 0);
    _Node_next.set(this, void 0);
    __classPrivateFieldSet(this, _Node_value, value, 'f');
    __classPrivateFieldSet(this, _Node_next, next, 'f');
  }
  push(value) {
    return new Node(value, this);
  }
  pop() {
    return __classPrivateFieldGet(this, _Node_next, 'f');
  }
  find(fn) {
    return fn(__classPrivateFieldGet(this, _Node_value, 'f'))
      ? true
      : __classPrivateFieldGet(this, _Node_next, 'f').find(fn);
  }
  contains(value) {
    return (
      value === __classPrivateFieldGet(this, _Node_value, 'f') ||
      (__classPrivateFieldGet(this, _Node_next, 'f') !== null &&
        __classPrivateFieldGet(this, _Node_next, 'f').contains(value))
    );
  }
  each(fn) {
    fn(__classPrivateFieldGet(this, _Node_value, 'f'));
    __classPrivateFieldGet(this, _Node_next, 'f').each(fn);
  }
  get value() {
    return __classPrivateFieldGet(this, _Node_value, 'f');
  }
  print(fn) {
    return (
      fn(__classPrivateFieldGet(this, _Node_value, 'f')) +
      __classPrivateFieldGet(this, _Node_next, 'f').print(fn)
    );
  }
}
(_Node_value = new WeakMap()), (_Node_next = new WeakMap());
class Empty {
  push(value) {
    return new Node(value, this);
  }
  pop() {
    return this;
  }
  find(_fn) {
    return false;
  }
  contains(_value) {
    return false;
  }
  each(_fn) {
    return;
  }
  get value() {
    return null;
  }
  print(_) {
    return '';
  }
}
const EMPTY = new Empty();
var _a,
  _ReactiveScopeDependencyTreeHIR_hoistableObjects,
  _ReactiveScopeDependencyTreeHIR_deps,
  _ReactiveScopeDependencyTreeHIR_getOrCreateRoot,
  _ReactiveScopeDependencyTreeHIR_debugImpl;
class ReactiveScopeDependencyTreeHIR {
  constructor(hoistableObjects) {
    var _b;
    _ReactiveScopeDependencyTreeHIR_hoistableObjects.set(this, new Map());
    _ReactiveScopeDependencyTreeHIR_deps.set(this, new Map());
    for (const {path: path, identifier: identifier} of hoistableObjects) {
      let currNode = __classPrivateFieldGet(
        _a,
        _a,
        'm',
        _ReactiveScopeDependencyTreeHIR_getOrCreateRoot
      ).call(
        _a,
        identifier,
        __classPrivateFieldGet(
          this,
          _ReactiveScopeDependencyTreeHIR_hoistableObjects,
          'f'
        ),
        path.length > 0 && path[0].optional ? 'Optional' : 'NonNull'
      );
      for (let i = 0; i < path.length; i++) {
        const prevAccessType =
          (_b = currNode.properties.get(path[i].property)) === null ||
          _b === void 0
            ? void 0
            : _b.accessType;
        const accessType =
          i + 1 < path.length && path[i + 1].optional ? 'Optional' : 'NonNull';
        CompilerError.invariant(
          prevAccessType == null || prevAccessType === accessType,
          {reason: 'Conflicting access types', loc: GeneratedSource}
        );
        let nextNode = currNode.properties.get(path[i].property);
        if (nextNode == null) {
          nextNode = {properties: new Map(), accessType: accessType};
          currNode.properties.set(path[i].property, nextNode);
        }
        currNode = nextNode;
      }
    }
  }
  addDependency(dep) {
    const {identifier: identifier, path: path} = dep;
    let depCursor = __classPrivateFieldGet(
      _a,
      _a,
      'm',
      _ReactiveScopeDependencyTreeHIR_getOrCreateRoot
    ).call(
      _a,
      identifier,
      __classPrivateFieldGet(this, _ReactiveScopeDependencyTreeHIR_deps, 'f'),
      PropertyAccessType.UnconditionalAccess
    );
    let hoistableCursor = __classPrivateFieldGet(
      this,
      _ReactiveScopeDependencyTreeHIR_hoistableObjects,
      'f'
    ).get(identifier);
    for (const entry of path) {
      let nextHoistableCursor;
      let nextDepCursor;
      if (entry.optional) {
        if (hoistableCursor != null) {
          nextHoistableCursor =
            hoistableCursor === null || hoistableCursor === void 0
              ? void 0
              : hoistableCursor.properties.get(entry.property);
        }
        let accessType;
        if (
          hoistableCursor != null &&
          hoistableCursor.accessType === 'NonNull'
        ) {
          accessType = PropertyAccessType.UnconditionalAccess;
        } else {
          accessType = PropertyAccessType.OptionalAccess;
        }
        nextDepCursor = makeOrMergeProperty(
          depCursor,
          entry.property,
          accessType
        );
      } else if (
        hoistableCursor != null &&
        hoistableCursor.accessType === 'NonNull'
      ) {
        nextHoistableCursor = hoistableCursor.properties.get(entry.property);
        nextDepCursor = makeOrMergeProperty(
          depCursor,
          entry.property,
          PropertyAccessType.UnconditionalAccess
        );
      } else {
        break;
      }
      depCursor = nextDepCursor;
      hoistableCursor = nextHoistableCursor;
    }
    depCursor.accessType = merge(
      depCursor.accessType,
      PropertyAccessType.OptionalDependency
    );
  }
  deriveMinimalDependencies() {
    const results = new Set();
    for (const [rootId, rootNode] of __classPrivateFieldGet(
      this,
      _ReactiveScopeDependencyTreeHIR_deps,
      'f'
    ).entries()) {
      collectMinimalDependenciesInSubtree(rootNode, rootId, [], results);
    }
    return results;
  }
  printDeps(includeAccesses) {
    let res = [];
    for (const [rootId, rootNode] of __classPrivateFieldGet(
      this,
      _ReactiveScopeDependencyTreeHIR_deps,
      'f'
    ).entries()) {
      const rootResults = printSubtree(rootNode, includeAccesses).map(
        result => `${printIdentifier(rootId)}.${result}`
      );
      res.push(rootResults);
    }
    return res.flat().join('\n');
  }
  static debug(roots) {
    const buf = [`tree() [`];
    for (const [rootId, rootNode] of roots) {
      buf.push(`${printIdentifier(rootId)} (${rootNode.accessType}):`);
      __classPrivateFieldGet(
        this,
        _a,
        'm',
        _ReactiveScopeDependencyTreeHIR_debugImpl
      ).call(this, buf, rootNode, 1);
    }
    buf.push(']');
    return buf.length > 2 ? buf.join('\n') : buf.join('');
  }
}
(_a = ReactiveScopeDependencyTreeHIR),
  (_ReactiveScopeDependencyTreeHIR_hoistableObjects = new WeakMap()),
  (_ReactiveScopeDependencyTreeHIR_deps = new WeakMap()),
  (_ReactiveScopeDependencyTreeHIR_getOrCreateRoot =
    function _ReactiveScopeDependencyTreeHIR_getOrCreateRoot(
      identifier,
      roots,
      defaultAccessType
    ) {
      let rootNode = roots.get(identifier);
      if (rootNode === undefined) {
        rootNode = {properties: new Map(), accessType: defaultAccessType};
        roots.set(identifier, rootNode);
      }
      return rootNode;
    }),
  (_ReactiveScopeDependencyTreeHIR_debugImpl =
    function _ReactiveScopeDependencyTreeHIR_debugImpl(buf, node, depth = 0) {
      for (const [property, childNode] of node.properties) {
        buf.push(
          `${'  '.repeat(depth)}.${property} (${childNode.accessType}):`
        );
        __classPrivateFieldGet(
          this,
          _a,
          'm',
          _ReactiveScopeDependencyTreeHIR_debugImpl
        ).call(this, buf, childNode, depth + 1);
      }
    });
var PropertyAccessType;
(function (PropertyAccessType) {
  PropertyAccessType['OptionalAccess'] = 'OptionalAccess';
  PropertyAccessType['UnconditionalAccess'] = 'UnconditionalAccess';
  PropertyAccessType['OptionalDependency'] = 'OptionalDependency';
  PropertyAccessType['UnconditionalDependency'] = 'UnconditionalDependency';
})(PropertyAccessType || (PropertyAccessType = {}));
function isOptional(access) {
  return (
    access === PropertyAccessType.OptionalAccess ||
    access === PropertyAccessType.OptionalDependency
  );
}
function isDependency(access) {
  return (
    access === PropertyAccessType.OptionalDependency ||
    access === PropertyAccessType.UnconditionalDependency
  );
}
function merge(access1, access2) {
  const resultIsUnconditional = !(isOptional(access1) && isOptional(access2));
  const resultIsDependency = isDependency(access1) || isDependency(access2);
  if (resultIsUnconditional) {
    if (resultIsDependency) {
      return PropertyAccessType.UnconditionalDependency;
    } else {
      return PropertyAccessType.UnconditionalAccess;
    }
  } else {
    if (resultIsDependency) {
      return PropertyAccessType.OptionalDependency;
    } else {
      return PropertyAccessType.OptionalAccess;
    }
  }
}
function collectMinimalDependenciesInSubtree(
  node,
  rootIdentifier,
  path,
  results
) {
  if (isDependency(node.accessType)) {
    results.add({identifier: rootIdentifier, path: path});
  } else {
    for (const [childName, childNode] of node.properties) {
      collectMinimalDependenciesInSubtree(
        childNode,
        rootIdentifier,
        [
          ...path,
          {property: childName, optional: isOptional(childNode.accessType)},
        ],
        results
      );
    }
  }
}
function printSubtree(node, includeAccesses) {
  const results = [];
  for (const [propertyName, propertyNode] of node.properties) {
    if (includeAccesses || isDependency(propertyNode.accessType)) {
      results.push(`${propertyName} (${propertyNode.accessType})`);
    }
    const propertyResults = printSubtree(propertyNode, includeAccesses);
    results.push(...propertyResults.map(result => `${propertyName}.${result}`));
  }
  return results;
}
function makeOrMergeProperty(node, property, accessType) {
  let child = node.properties.get(property);
  if (child == null) {
    child = {properties: new Map(), accessType: accessType};
    node.properties.set(property, child);
  } else {
    child.accessType = merge(child.accessType, accessType);
  }
  return child;
}
function collectOptionalChainSidemap(fn) {
  const context = {
    currFn: fn,
    blocks: fn.body.blocks,
    seenOptionals: new Set(),
    processedInstrsInOptional: new Set(),
    temporariesReadInOptional: new Map(),
    hoistableObjects: new Map(),
  };
  traverseFunction(fn, context);
  return {
    temporariesReadInOptional: context.temporariesReadInOptional,
    processedInstrsInOptional: context.processedInstrsInOptional,
    hoistableObjects: context.hoistableObjects,
  };
}
function traverseFunction(fn, context) {
  for (const [_, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      if (
        instr.value.kind === 'FunctionExpression' ||
        instr.value.kind === 'ObjectMethod'
      ) {
        traverseFunction(
          instr.value.loweredFunc.func,
          Object.assign(Object.assign({}, context), {
            currFn: instr.value.loweredFunc.func,
            blocks: instr.value.loweredFunc.func.body.blocks,
          })
        );
      }
    }
    if (
      block.terminal.kind === 'optional' &&
      !context.seenOptionals.has(block.id)
    ) {
      traverseOptionalBlock(block, context, null);
    }
  }
}
function matchOptionalTestBlock(terminal, blocks) {
  const consequentBlock = assertNonNull(blocks.get(terminal.consequent));
  if (
    consequentBlock.instructions.length === 2 &&
    consequentBlock.instructions[0].value.kind === 'PropertyLoad' &&
    consequentBlock.instructions[1].value.kind === 'StoreLocal'
  ) {
    const propertyLoad = consequentBlock.instructions[0];
    const storeLocal = consequentBlock.instructions[1].value;
    const storeLocalInstr = consequentBlock.instructions[1];
    CompilerError.invariant(
      propertyLoad.value.object.identifier.id === terminal.test.identifier.id,
      {
        reason:
          '[OptionalChainDeps] Inconsistent optional chaining property load',
        description: `Test=${printIdentifier(terminal.test.identifier)} PropertyLoad base=${printIdentifier(propertyLoad.value.object.identifier)}`,
        loc: propertyLoad.loc,
      }
    );
    CompilerError.invariant(
      storeLocal.value.identifier.id === propertyLoad.lvalue.identifier.id,
      {
        reason: '[OptionalChainDeps] Unexpected storeLocal',
        loc: propertyLoad.loc,
      }
    );
    if (
      consequentBlock.terminal.kind !== 'goto' ||
      consequentBlock.terminal.variant !== GotoVariant.Break
    ) {
      return null;
    }
    const alternate = assertNonNull(blocks.get(terminal.alternate));
    CompilerError.invariant(
      alternate.instructions.length === 2 &&
        alternate.instructions[0].value.kind === 'Primitive' &&
        alternate.instructions[1].value.kind === 'StoreLocal',
      {reason: 'Unexpected alternate structure', loc: terminal.loc}
    );
    return {
      consequentId: storeLocal.lvalue.place.identifier.id,
      property: propertyLoad.value.property,
      propertyId: propertyLoad.lvalue.identifier.id,
      storeLocalInstr: storeLocalInstr,
      consequentGoto: consequentBlock.terminal.block,
    };
  }
  return null;
}
function traverseOptionalBlock(optional, context, outerAlternate) {
  context.seenOptionals.add(optional.id);
  const maybeTest = context.blocks.get(optional.terminal.test);
  let test;
  let baseObject;
  if (maybeTest.terminal.kind === 'branch') {
    CompilerError.invariant(optional.terminal.optional, {
      reason: '[OptionalChainDeps] Expect base case to be always optional',
      loc: optional.terminal.loc,
    });
    if (
      maybeTest.instructions.length === 0 ||
      maybeTest.instructions[0].value.kind !== 'LoadLocal'
    ) {
      return null;
    }
    const path = [];
    for (let i = 1; i < maybeTest.instructions.length; i++) {
      const instrVal = maybeTest.instructions[i].value;
      const prevInstr = maybeTest.instructions[i - 1];
      if (
        instrVal.kind === 'PropertyLoad' &&
        instrVal.object.identifier.id === prevInstr.lvalue.identifier.id
      ) {
        path.push({property: instrVal.property, optional: false});
      } else {
        return null;
      }
    }
    CompilerError.invariant(
      maybeTest.terminal.test.identifier.id ===
        maybeTest.instructions.at(-1).lvalue.identifier.id,
      {
        reason: '[OptionalChainDeps] Unexpected test expression',
        loc: maybeTest.terminal.loc,
      }
    );
    baseObject = {
      identifier: maybeTest.instructions[0].value.place.identifier,
      path: path,
    };
    test = maybeTest.terminal;
  } else if (maybeTest.terminal.kind === 'optional') {
    const testBlock = context.blocks.get(maybeTest.terminal.fallthrough);
    if (testBlock.terminal.kind !== 'branch') {
      CompilerError.throwTodo({
        reason: `Unexpected terminal kind \`${testBlock.terminal.kind}\` for optional fallthrough block`,
        loc: maybeTest.terminal.loc,
      });
    }
    const innerOptional = traverseOptionalBlock(
      maybeTest,
      context,
      testBlock.terminal.alternate
    );
    if (innerOptional == null) {
      return null;
    }
    if (testBlock.terminal.test.identifier.id !== innerOptional) {
      return null;
    }
    if (!optional.terminal.optional) {
      context.hoistableObjects.set(
        optional.id,
        assertNonNull(context.temporariesReadInOptional.get(innerOptional))
      );
    }
    baseObject = assertNonNull(
      context.temporariesReadInOptional.get(innerOptional)
    );
    test = testBlock.terminal;
  } else {
    return null;
  }
  if (test.alternate === outerAlternate) {
    CompilerError.invariant(optional.instructions.length === 0, {
      reason:
        '[OptionalChainDeps] Unexpected instructions an inner optional block. ' +
        'This indicates that the compiler may be incorrectly concatenating two unrelated optional chains',
      loc: optional.terminal.loc,
    });
  }
  const matchConsequentResult = matchOptionalTestBlock(test, context.blocks);
  if (!matchConsequentResult) {
    return null;
  }
  CompilerError.invariant(
    matchConsequentResult.consequentGoto === optional.terminal.fallthrough,
    {
      reason: '[OptionalChainDeps] Unexpected optional goto-fallthrough',
      description: `${matchConsequentResult.consequentGoto} != ${optional.terminal.fallthrough}`,
      loc: optional.terminal.loc,
    }
  );
  const load = {
    identifier: baseObject.identifier,
    path: [
      ...baseObject.path,
      {
        property: matchConsequentResult.property,
        optional: optional.terminal.optional,
      },
    ],
  };
  context.processedInstrsInOptional.add(matchConsequentResult.storeLocalInstr);
  context.processedInstrsInOptional.add(test);
  context.temporariesReadInOptional.set(
    matchConsequentResult.consequentId,
    load
  );
  context.temporariesReadInOptional.set(matchConsequentResult.propertyId, load);
  return matchConsequentResult.consequentId;
}
var _Context_instances,
  _Context_declarations,
  _Context_reassignments,
  _Context_scopes,
  _Context_dependencies,
  _Context_temporaries,
  _Context_temporariesUsedOutsideScope,
  _Context_checkValidDependency,
  _Context_isScopeActive;
function propagateScopeDependenciesHIR(fn) {
  const usedOutsideDeclaringScope =
    findTemporariesUsedOutsideDeclaringScope(fn);
  const temporaries = collectTemporariesSidemap(fn, usedOutsideDeclaringScope);
  const {
    temporariesReadInOptional: temporariesReadInOptional,
    processedInstrsInOptional: processedInstrsInOptional,
    hoistableObjects: hoistableObjects,
  } = collectOptionalChainSidemap(fn);
  const hoistablePropertyLoads = keyByScopeId(
    fn,
    collectHoistablePropertyLoads(fn, temporaries, hoistableObjects)
  );
  const scopeDeps = collectDependencies(
    fn,
    usedOutsideDeclaringScope,
    new Map([...temporaries, ...temporariesReadInOptional]),
    processedInstrsInOptional
  );
  for (const [scope, deps] of scopeDeps) {
    if (deps.length === 0) {
      continue;
    }
    const hoistables = hoistablePropertyLoads.get(scope.id);
    CompilerError.invariant(hoistables != null, {
      reason: '[PropagateScopeDependencies] Scope not found in tracked blocks',
      loc: GeneratedSource,
    });
    const tree = new ReactiveScopeDependencyTreeHIR(
      [...hoistables.assumedNonNullObjects].map(o => o.fullPath)
    );
    for (const dep of deps) {
      tree.addDependency(Object.assign({}, dep));
    }
    const candidates = tree.deriveMinimalDependencies();
    for (const candidateDep of candidates) {
      if (
        !Iterable_some(
          scope.dependencies,
          existingDep =>
            existingDep.identifier.declarationId ===
              candidateDep.identifier.declarationId &&
            areEqualPaths(existingDep.path, candidateDep.path)
        )
      )
        scope.dependencies.add(candidateDep);
    }
  }
}
function findTemporariesUsedOutsideDeclaringScope(fn) {
  const declarations = new Map();
  const prunedScopes = new Set();
  const scopeTraversal = new ScopeBlockTraversal();
  const usedOutsideDeclaringScope = new Set();
  function handlePlace(place) {
    const declaringScope = declarations.get(place.identifier.declarationId);
    if (
      declaringScope != null &&
      !scopeTraversal.isScopeActive(declaringScope) &&
      !prunedScopes.has(declaringScope)
    ) {
      usedOutsideDeclaringScope.add(place.identifier.declarationId);
    }
  }
  function handleInstruction(instr) {
    const scope = scopeTraversal.currentScope;
    if (scope == null || prunedScopes.has(scope)) {
      return;
    }
    switch (instr.value.kind) {
      case 'LoadLocal':
      case 'LoadContext':
      case 'PropertyLoad': {
        declarations.set(instr.lvalue.identifier.declarationId, scope);
        break;
      }
    }
  }
  for (const [blockId, block] of fn.body.blocks) {
    scopeTraversal.recordScopes(block);
    const scopeStartInfo = scopeTraversal.blockInfos.get(blockId);
    if (
      (scopeStartInfo === null || scopeStartInfo === void 0
        ? void 0
        : scopeStartInfo.kind) === 'begin' &&
      scopeStartInfo.pruned
    ) {
      prunedScopes.add(scopeStartInfo.scope.id);
    }
    for (const instr of block.instructions) {
      for (const place of eachInstructionOperand(instr)) {
        handlePlace(place);
      }
      handleInstruction(instr);
    }
    for (const place of eachTerminalOperand(block.terminal)) {
      handlePlace(place);
    }
  }
  return usedOutsideDeclaringScope;
}
function collectTemporariesSidemap(fn, usedOutsideDeclaringScope) {
  const temporaries = new Map();
  collectTemporariesSidemapImpl(
    fn,
    usedOutsideDeclaringScope,
    temporaries,
    false
  );
  return temporaries;
}
function collectTemporariesSidemapImpl(
  fn,
  usedOutsideDeclaringScope,
  temporaries,
  isInnerFn
) {
  for (const [_, block] of fn.body.blocks) {
    for (const instr of block.instructions) {
      const {value: value, lvalue: lvalue} = instr;
      const usedOutside = usedOutsideDeclaringScope.has(
        lvalue.identifier.declarationId
      );
      if (value.kind === 'PropertyLoad' && !usedOutside) {
        if (!isInnerFn || temporaries.has(value.object.identifier.id)) {
          const property = getProperty(
            value.object,
            value.property,
            false,
            temporaries
          );
          temporaries.set(lvalue.identifier.id, property);
        }
      } else if (
        value.kind === 'LoadLocal' &&
        lvalue.identifier.name == null &&
        value.place.identifier.name !== null &&
        !usedOutside
      ) {
        if (
          !isInnerFn ||
          fn.context.some(
            context => context.identifier.id === value.place.identifier.id
          )
        ) {
          temporaries.set(lvalue.identifier.id, {
            identifier: value.place.identifier,
            path: [],
          });
        }
      } else if (
        value.kind === 'FunctionExpression' ||
        value.kind === 'ObjectMethod'
      ) {
        collectTemporariesSidemapImpl(
          value.loweredFunc.func,
          usedOutsideDeclaringScope,
          temporaries,
          true
        );
      }
    }
  }
}
function getProperty(object, propertyName, optional, temporaries) {
  const resolvedDependency = temporaries.get(object.identifier.id);
  let property;
  if (resolvedDependency == null) {
    property = {
      identifier: object.identifier,
      path: [{property: propertyName, optional: optional}],
    };
  } else {
    property = {
      identifier: resolvedDependency.identifier,
      path: [
        ...resolvedDependency.path,
        {property: propertyName, optional: optional},
      ],
    };
  }
  return property;
}
class Context {
  constructor(temporariesUsedOutsideScope, temporaries) {
    _Context_instances.add(this);
    _Context_declarations.set(this, new Map());
    _Context_reassignments.set(this, new Map());
    _Context_scopes.set(this, empty());
    _Context_dependencies.set(this, empty());
    this.deps = new Map();
    _Context_temporaries.set(this, void 0);
    _Context_temporariesUsedOutsideScope.set(this, void 0);
    this.inInnerFn = false;
    __classPrivateFieldSet(
      this,
      _Context_temporariesUsedOutsideScope,
      temporariesUsedOutsideScope,
      'f'
    );
    __classPrivateFieldSet(this, _Context_temporaries, temporaries, 'f');
  }
  enterScope(scope) {
    __classPrivateFieldSet(
      this,
      _Context_dependencies,
      __classPrivateFieldGet(this, _Context_dependencies, 'f').push([]),
      'f'
    );
    __classPrivateFieldSet(
      this,
      _Context_scopes,
      __classPrivateFieldGet(this, _Context_scopes, 'f').push(scope),
      'f'
    );
  }
  exitScope(scope, pruned) {
    var _a;
    const scopedDependencies = __classPrivateFieldGet(
      this,
      _Context_dependencies,
      'f'
    ).value;
    CompilerError.invariant(scopedDependencies != null, {
      reason: '[PropagateScopeDeps]: Unexpected scope mismatch',
      loc: scope.loc,
    });
    __classPrivateFieldSet(
      this,
      _Context_scopes,
      __classPrivateFieldGet(this, _Context_scopes, 'f').pop(),
      'f'
    );
    __classPrivateFieldSet(
      this,
      _Context_dependencies,
      __classPrivateFieldGet(this, _Context_dependencies, 'f').pop(),
      'f'
    );
    for (const dep of scopedDependencies) {
      if (
        __classPrivateFieldGet(
          this,
          _Context_instances,
          'm',
          _Context_checkValidDependency
        ).call(this, dep)
      ) {
        (_a = __classPrivateFieldGet(
          this,
          _Context_dependencies,
          'f'
        ).value) === null || _a === void 0
          ? void 0
          : _a.push(dep);
      }
    }
    if (!pruned) {
      this.deps.set(scope, scopedDependencies);
    }
  }
  isUsedOutsideDeclaringScope(place) {
    return __classPrivateFieldGet(
      this,
      _Context_temporariesUsedOutsideScope,
      'f'
    ).has(place.identifier.declarationId);
  }
  declare(identifier, decl) {
    if (this.inInnerFn) return;
    if (
      !__classPrivateFieldGet(this, _Context_declarations, 'f').has(
        identifier.declarationId
      )
    ) {
      __classPrivateFieldGet(this, _Context_declarations, 'f').set(
        identifier.declarationId,
        decl
      );
    }
    __classPrivateFieldGet(this, _Context_reassignments, 'f').set(
      identifier,
      decl
    );
  }
  get currentScope() {
    return __classPrivateFieldGet(this, _Context_scopes, 'f');
  }
  visitOperand(place) {
    var _a;
    this.visitDependency(
      (_a = __classPrivateFieldGet(this, _Context_temporaries, 'f').get(
        place.identifier.id
      )) !== null && _a !== void 0
        ? _a
        : {identifier: place.identifier, path: []}
    );
  }
  visitProperty(object, property, optional) {
    const nextDependency = getProperty(
      object,
      property,
      optional,
      __classPrivateFieldGet(this, _Context_temporaries, 'f')
    );
    this.visitDependency(nextDependency);
  }
  visitDependency(maybeDependency) {
    var _a;
    const originalDeclaration = __classPrivateFieldGet(
      this,
      _Context_declarations,
      'f'
    ).get(maybeDependency.identifier.declarationId);
    if (
      originalDeclaration !== undefined &&
      originalDeclaration.scope.value !== null
    ) {
      originalDeclaration.scope.each(scope => {
        if (
          !__classPrivateFieldGet(
            this,
            _Context_instances,
            'm',
            _Context_isScopeActive
          ).call(this, scope) &&
          !Iterable_some(
            scope.declarations.values(),
            decl =>
              decl.identifier.declarationId ===
              maybeDependency.identifier.declarationId
          )
        ) {
          scope.declarations.set(maybeDependency.identifier.id, {
            identifier: maybeDependency.identifier,
            scope: originalDeclaration.scope.value,
          });
        }
      });
    }
    if (
      isUseRefType(maybeDependency.identifier) &&
      ((_a = maybeDependency.path.at(0)) === null || _a === void 0
        ? void 0
        : _a.property) === 'current'
    ) {
      maybeDependency = {identifier: maybeDependency.identifier, path: []};
    }
    if (
      __classPrivateFieldGet(
        this,
        _Context_instances,
        'm',
        _Context_checkValidDependency
      ).call(this, maybeDependency)
    ) {
      __classPrivateFieldGet(this, _Context_dependencies, 'f').value.push(
        maybeDependency
      );
    }
  }
  visitReassignment(place) {
    const currentScope = this.currentScope.value;
    if (
      currentScope != null &&
      !Iterable_some(
        currentScope.reassignments,
        identifier =>
          identifier.declarationId === place.identifier.declarationId
      ) &&
      __classPrivateFieldGet(
        this,
        _Context_instances,
        'm',
        _Context_checkValidDependency
      ).call(this, {identifier: place.identifier, path: []})
    ) {
      currentScope.reassignments.add(place.identifier);
    }
  }
}
(_Context_declarations = new WeakMap()),
  (_Context_reassignments = new WeakMap()),
  (_Context_scopes = new WeakMap()),
  (_Context_dependencies = new WeakMap()),
  (_Context_temporaries = new WeakMap()),
  (_Context_temporariesUsedOutsideScope = new WeakMap()),
  (_Context_instances = new WeakSet()),
  (_Context_checkValidDependency = function _Context_checkValidDependency(
    maybeDependency
  ) {
    var _a;
    if (isRefValueType(maybeDependency.identifier)) {
      return false;
    }
    if (isObjectMethodType(maybeDependency.identifier)) {
      return false;
    }
    const identifier = maybeDependency.identifier;
    const currentDeclaration =
      (_a = __classPrivateFieldGet(this, _Context_reassignments, 'f').get(
        identifier
      )) !== null && _a !== void 0
        ? _a
        : __classPrivateFieldGet(this, _Context_declarations, 'f').get(
            identifier.declarationId
          );
    const currentScope = this.currentScope.value;
    return (
      currentScope != null &&
      currentDeclaration !== undefined &&
      currentDeclaration.id < currentScope.range.start
    );
  }),
  (_Context_isScopeActive = function _Context_isScopeActive(scope) {
    if (__classPrivateFieldGet(this, _Context_scopes, 'f') === null) {
      return false;
    }
    return __classPrivateFieldGet(this, _Context_scopes, 'f').find(
      state => state === scope
    );
  });
function handleInstruction(instr, context) {
  const {id: id, value: value, lvalue: lvalue} = instr;
  if (value.kind === 'LoadLocal') {
    if (
      value.place.identifier.name === null ||
      lvalue.identifier.name !== null ||
      context.isUsedOutsideDeclaringScope(lvalue)
    ) {
      context.visitOperand(value.place);
    }
  } else if (value.kind === 'PropertyLoad') {
    if (context.isUsedOutsideDeclaringScope(lvalue)) {
      context.visitProperty(value.object, value.property, false);
    }
  } else if (value.kind === 'StoreLocal') {
    context.visitOperand(value.value);
    if (value.lvalue.kind === InstructionKind.Reassign) {
      context.visitReassignment(value.lvalue.place);
    }
    context.declare(value.lvalue.place.identifier, {
      id: id,
      scope: context.currentScope,
    });
  } else if (value.kind === 'DeclareLocal' || value.kind === 'DeclareContext') {
    context.declare(value.lvalue.place.identifier, {
      id: id,
      scope: context.currentScope,
    });
  } else if (value.kind === 'Destructure') {
    context.visitOperand(value.value);
    for (const place of eachPatternOperand(value.lvalue.pattern)) {
      if (value.lvalue.kind === InstructionKind.Reassign) {
        context.visitReassignment(place);
      }
      context.declare(place.identifier, {id: id, scope: context.currentScope});
    }
  } else {
    for (const operand of eachInstructionValueOperand(value)) {
      context.visitOperand(operand);
    }
  }
  context.declare(lvalue.identifier, {id: id, scope: context.currentScope});
}
function collectDependencies(
  fn,
  usedOutsideDeclaringScope,
  temporaries,
  processedInstrsInOptional
) {
  const context = new Context(usedOutsideDeclaringScope, temporaries);
  for (const param of fn.params) {
    if (param.kind === 'Identifier') {
      context.declare(param.identifier, {
        id: makeInstructionId(0),
        scope: empty(),
      });
    } else {
      context.declare(param.place.identifier, {
        id: makeInstructionId(0),
        scope: empty(),
      });
    }
  }
  const scopeTraversal = new ScopeBlockTraversal();
  const handleFunction = fn => {
    for (const [blockId, block] of fn.body.blocks) {
      scopeTraversal.recordScopes(block);
      const scopeBlockInfo = scopeTraversal.blockInfos.get(blockId);
      if (
        (scopeBlockInfo === null || scopeBlockInfo === void 0
          ? void 0
          : scopeBlockInfo.kind) === 'begin'
      ) {
        context.enterScope(scopeBlockInfo.scope);
      } else if (
        (scopeBlockInfo === null || scopeBlockInfo === void 0
          ? void 0
          : scopeBlockInfo.kind) === 'end'
      ) {
        context.exitScope(scopeBlockInfo.scope, scopeBlockInfo.pruned);
      }
      for (const phi of block.phis) {
        for (const operand of phi.operands) {
          const maybeOptionalChain = temporaries.get(operand[1].identifier.id);
          if (maybeOptionalChain) {
            context.visitDependency(maybeOptionalChain);
          }
        }
      }
      for (const instr of block.instructions) {
        if (
          fn.env.config.enableFunctionDependencyRewrite &&
          (instr.value.kind === 'FunctionExpression' ||
            instr.value.kind === 'ObjectMethod')
        ) {
          context.declare(instr.lvalue.identifier, {
            id: instr.id,
            scope: context.currentScope,
          });
          const wasInInnerFn = context.inInnerFn;
          context.inInnerFn = true;
          handleFunction(instr.value.loweredFunc.func);
          context.inInnerFn = wasInInnerFn;
        } else if (!processedInstrsInOptional.has(instr)) {
          handleInstruction(instr, context);
        }
      }
      if (!processedInstrsInOptional.has(block.terminal)) {
        for (const place of eachTerminalOperand(block.terminal)) {
          context.visitOperand(place);
        }
      }
    }
  };
  handleFunction(fn);
  return context.deps;
}
function outlineJSX(fn) {
  const outlinedFns = [];
  outlineJsxImpl(fn, outlinedFns);
  for (const outlinedFn of outlinedFns) {
    fn.env.outlineFunction(outlinedFn, 'Component');
  }
}
function outlineJsxImpl(fn, outlinedFns) {
  const globals = new Map();
  function processAndOutlineJSX(state, rewriteInstr) {
    if (state.jsx.length <= 1) {
      return;
    }
    const result = process$1(
      fn,
      [...state.jsx].sort((a, b) => a.id - b.id),
      globals
    );
    if (result) {
      outlinedFns.push(result.fn);
      rewriteInstr.set(state.jsx.at(0).id, result.instrs);
    }
  }
  for (const [, block] of fn.body.blocks) {
    const rewriteInstr = new Map();
    let state = {jsx: [], children: new Set()};
    for (let i = block.instructions.length - 1; i >= 0; i--) {
      const instr = block.instructions[i];
      const {value: value, lvalue: lvalue} = instr;
      switch (value.kind) {
        case 'LoadGlobal': {
          globals.set(lvalue.identifier.id, instr);
          break;
        }
        case 'FunctionExpression': {
          outlineJsxImpl(value.loweredFunc.func, outlinedFns);
          break;
        }
        case 'JsxExpression': {
          if (!state.children.has(lvalue.identifier.id)) {
            processAndOutlineJSX(state, rewriteInstr);
            state = {jsx: [], children: new Set()};
          }
          state.jsx.push(instr);
          if (value.children) {
            for (const child of value.children) {
              state.children.add(child.identifier.id);
            }
          }
          break;
        }
        case 'ArrayExpression':
        case 'Await':
        case 'BinaryExpression':
        case 'CallExpression':
        case 'ComputedDelete':
        case 'ComputedLoad':
        case 'ComputedStore':
        case 'Debugger':
        case 'DeclareContext':
        case 'DeclareLocal':
        case 'Destructure':
        case 'FinishMemoize':
        case 'GetIterator':
        case 'IteratorNext':
        case 'JSXText':
        case 'JsxFragment':
        case 'LoadContext':
        case 'LoadLocal':
        case 'MetaProperty':
        case 'MethodCall':
        case 'NewExpression':
        case 'NextPropertyOf':
        case 'ObjectExpression':
        case 'ObjectMethod':
        case 'PostfixUpdate':
        case 'PrefixUpdate':
        case 'Primitive':
        case 'PropertyDelete':
        case 'PropertyLoad':
        case 'PropertyStore':
        case 'RegExpLiteral':
        case 'StartMemoize':
        case 'StoreContext':
        case 'StoreGlobal':
        case 'StoreLocal':
        case 'TaggedTemplateExpression':
        case 'TemplateLiteral':
        case 'TypeCastExpression':
        case 'UnsupportedNode':
        case 'UnaryExpression': {
          break;
        }
        default: {
          assertExhaustive(value, `Unexpected instruction: ${value}`);
        }
      }
    }
    processAndOutlineJSX(state, rewriteInstr);
    if (rewriteInstr.size > 0) {
      const newInstrs = [];
      for (let i = 0; i < block.instructions.length; i++) {
        const id = i + 1;
        if (rewriteInstr.has(id)) {
          const instrs = rewriteInstr.get(id);
          newInstrs.push(...instrs);
        } else {
          newInstrs.push(block.instructions[i]);
        }
      }
      block.instructions = newInstrs;
    }
    deadCodeElimination(fn);
  }
}
function process$1(fn, jsx, globals) {
  if (fn.fnType === 'Component') {
    return null;
  }
  const props = collectProps(jsx);
  if (!props) return null;
  const outlinedTag = fn.env.generateGloballyUniqueIdentifierName(null).value;
  const newInstrs = emitOutlinedJsx(fn.env, jsx, props, outlinedTag);
  if (!newInstrs) return null;
  const outlinedFn = emitOutlinedFn(fn.env, jsx, props, globals);
  if (!outlinedFn) return null;
  outlinedFn.id = outlinedTag;
  return {instrs: newInstrs, fn: outlinedFn};
}
function collectProps(instructions) {
  let id = 1;
  function generateName(oldName) {
    let newName = oldName;
    while (seen.has(newName)) {
      newName = `${oldName}${id++}`;
    }
    seen.add(newName);
    return newName;
  }
  const attributes = [];
  const jsxIds = new Set(instructions.map(i => i.lvalue.identifier.id));
  const seen = new Set();
  for (const instr of instructions) {
    const {value: value} = instr;
    for (const at of value.props) {
      if (at.kind === 'JsxSpreadAttribute') {
        return null;
      }
      if (at.kind === 'JsxAttribute') {
        const newName = generateName(at.name);
        attributes.push({
          originalName: at.name,
          newName: newName,
          place: at.place,
        });
      }
    }
    if (value.children) {
      for (const child of value.children) {
        if (jsxIds.has(child.identifier.id)) {
          continue;
        }
        promoteTemporary(child.identifier);
        const newName = generateName('t');
        attributes.push({
          originalName: child.identifier.name.value,
          newName: newName,
          place: child,
        });
      }
    }
  }
  return attributes;
}
function emitOutlinedJsx(env, instructions, outlinedProps, outlinedTag) {
  const props = outlinedProps.map(p => ({
    kind: 'JsxAttribute',
    name: p.newName,
    place: p.place,
  }));
  const loadJsx = {
    id: makeInstructionId(0),
    loc: GeneratedSource,
    lvalue: createTemporaryPlace(env, GeneratedSource),
    value: {
      kind: 'LoadGlobal',
      binding: {kind: 'ModuleLocal', name: outlinedTag},
      loc: GeneratedSource,
    },
  };
  promoteTemporaryJsxTag(loadJsx.lvalue.identifier);
  const jsxExpr = {
    id: makeInstructionId(0),
    loc: GeneratedSource,
    lvalue: instructions.at(-1).lvalue,
    value: {
      kind: 'JsxExpression',
      tag: Object.assign({}, loadJsx.lvalue),
      props: props,
      children: null,
      loc: GeneratedSource,
      openingLoc: GeneratedSource,
      closingLoc: GeneratedSource,
    },
  };
  return [loadJsx, jsxExpr];
}
function emitOutlinedFn(env, jsx, oldProps, globals) {
  const instructions = [];
  const oldToNewProps = createOldToNewPropsMapping(env, oldProps);
  const propsObj = createTemporaryPlace(env, GeneratedSource);
  promoteTemporary(propsObj.identifier);
  const destructurePropsInstr = emitDestructureProps(
    env,
    propsObj,
    oldToNewProps
  );
  instructions.push(destructurePropsInstr);
  const updatedJsxInstructions = emitUpdatedJsx(jsx, oldToNewProps);
  const loadGlobalInstrs = emitLoadGlobals(jsx, globals);
  if (!loadGlobalInstrs) {
    return null;
  }
  instructions.push(...loadGlobalInstrs);
  instructions.push(...updatedJsxInstructions);
  const block = {
    kind: 'block',
    id: makeBlockId(0),
    instructions: instructions,
    terminal: {
      id: makeInstructionId(0),
      kind: 'return',
      loc: GeneratedSource,
      value: instructions.at(-1).lvalue,
    },
    preds: new Set(),
    phis: new Set(),
  };
  const fn = {
    loc: GeneratedSource,
    id: null,
    fnType: 'Other',
    env: env,
    params: [propsObj],
    returnTypeAnnotation: null,
    returnType: makeType(),
    context: [],
    effects: null,
    body: {entry: block.id, blocks: new Map([[block.id, block]])},
    generator: false,
    async: false,
    directives: [],
  };
  return fn;
}
function emitLoadGlobals(jsx, globals) {
  const instructions = [];
  for (const {value: value} of jsx) {
    if (value.tag.kind === 'Identifier') {
      const loadGlobalInstr = globals.get(value.tag.identifier.id);
      if (!loadGlobalInstr) {
        return null;
      }
      instructions.push(loadGlobalInstr);
    }
  }
  return instructions;
}
function emitUpdatedJsx(jsx, oldToNewProps) {
  const newInstrs = [];
  const jsxIds = new Set(jsx.map(i => i.lvalue.identifier.id));
  for (const instr of jsx) {
    const {value: value} = instr;
    const newProps = [];
    for (const prop of value.props) {
      invariant$1(
        prop.kind === 'JsxAttribute',
        `Expected only attributes but found ${prop.kind}`
      );
      if (prop.name === 'key') {
        continue;
      }
      const newProp = oldToNewProps.get(prop.place.identifier.id);
      invariant$1(
        newProp !== undefined,
        `Expected a new property for ${printIdentifier(prop.place.identifier)}`
      );
      newProps.push({
        kind: 'JsxAttribute',
        name: newProp.originalName,
        place: newProp.place,
      });
    }
    let newChildren = null;
    if (value.children) {
      newChildren = [];
      for (const child of value.children) {
        if (jsxIds.has(child.identifier.id)) {
          newChildren.push(Object.assign({}, child));
          continue;
        }
        const newChild = oldToNewProps.get(child.identifier.id);
        invariant$1(
          newChild !== undefined,
          `Expected a new prop for ${printIdentifier(child.identifier)}`
        );
        newChildren.push(Object.assign({}, newChild.place));
      }
    }
    newInstrs.push(
      Object.assign(Object.assign({}, instr), {
        value: Object.assign(Object.assign({}, value), {
          props: newProps,
          children: newChildren,
        }),
      })
    );
  }
  return newInstrs;
}
function createOldToNewPropsMapping(env, oldProps) {
  const oldToNewProps = new Map();
  for (const oldProp of oldProps) {
    if (oldProp.originalName === 'key') {
      continue;
    }
    const newProp = Object.assign(Object.assign({}, oldProp), {
      place: createTemporaryPlace(env, GeneratedSource),
    });
    newProp.place.identifier.name = makeIdentifierName(oldProp.newName);
    oldToNewProps.set(oldProp.place.identifier.id, newProp);
  }
  return oldToNewProps;
}
function emitDestructureProps(env, propsObj, oldToNewProps) {
  const properties = [];
  for (const [_, prop] of oldToNewProps) {
    properties.push({
      kind: 'ObjectProperty',
      key: {kind: 'string', name: prop.newName},
      type: 'property',
      place: prop.place,
    });
  }
  const destructurePropsInstr = {
    id: makeInstructionId(0),
    lvalue: createTemporaryPlace(env, GeneratedSource),
    loc: GeneratedSource,
    value: {
      kind: 'Destructure',
      lvalue: {
        pattern: {kind: 'ObjectPattern', properties: properties},
        kind: InstructionKind.Let,
      },
      loc: GeneratedSource,
      value: propsObj,
    },
  };
  return destructurePropsInstr;
}
function* run(
  func,
  config,
  fnType,
  useMemoCacheIdentifier,
  logger,
  filename,
  code
) {
  const contextIdentifiers = findContextIdentifiers(func);
  const env = new Environment(
    func.scope,
    fnType,
    config,
    contextIdentifiers,
    logger,
    filename,
    code,
    useMemoCacheIdentifier
  );
  yield log({
    kind: 'debug',
    name: 'EnvironmentConfig',
    value: prettyFormat$1(env.config),
  });
  const ast = yield* runWithEnvironment(func, env);
  return ast;
}
function* runWithEnvironment(func, env) {
  const hir = lower$1(func, env).unwrap();
  yield log({kind: 'hir', name: 'HIR', value: hir});
  pruneMaybeThrows(hir);
  yield log({kind: 'hir', name: 'PruneMaybeThrows', value: hir});
  validateContextVariableLValues(hir);
  validateUseMemo(hir);
  if (
    !env.config.enablePreserveExistingManualUseMemo &&
    !env.config.disableMemoizationForDebugging &&
    !env.config.enableChangeDetectionForDebugging
  ) {
    dropManualMemoization(hir);
    yield log({kind: 'hir', name: 'DropManualMemoization', value: hir});
  }
  inlineImmediatelyInvokedFunctionExpressions(hir);
  yield log({
    kind: 'hir',
    name: 'InlineImmediatelyInvokedFunctionExpressions',
    value: hir,
  });
  mergeConsecutiveBlocks(hir);
  yield log({kind: 'hir', name: 'MergeConsecutiveBlocks', value: hir});
  assertConsistentIdentifiers(hir);
  assertTerminalSuccessorsExist(hir);
  enterSSA(hir);
  yield log({kind: 'hir', name: 'SSA', value: hir});
  eliminateRedundantPhi(hir);
  yield log({kind: 'hir', name: 'EliminateRedundantPhi', value: hir});
  assertConsistentIdentifiers(hir);
  constantPropagation(hir);
  yield log({kind: 'hir', name: 'ConstantPropagation', value: hir});
  inferTypes(hir);
  yield log({kind: 'hir', name: 'InferTypes', value: hir});
  if (env.config.validateHooksUsage) {
    validateHooksUsage(hir);
  }
  if (env.config.validateNoCapitalizedCalls) {
    validateNoCapitalizedCalls(hir);
  }
  if (env.config.lowerContextAccess) {
    lowerContextAccess(hir, env.config.lowerContextAccess);
  }
  analyseFunctions(hir);
  yield log({kind: 'hir', name: 'AnalyseFunctions', value: hir});
  inferReferenceEffects(hir);
  yield log({kind: 'hir', name: 'InferReferenceEffects', value: hir});
  validateLocalsNotReassignedAfterRender(hir);
  deadCodeElimination(hir);
  yield log({kind: 'hir', name: 'DeadCodeElimination', value: hir});
  if (env.config.enableInstructionReordering) {
    instructionReordering(hir);
    yield log({kind: 'hir', name: 'InstructionReordering', value: hir});
  }
  pruneMaybeThrows(hir);
  yield log({kind: 'hir', name: 'PruneMaybeThrows', value: hir});
  inferMutableRanges(hir);
  yield log({kind: 'hir', name: 'InferMutableRanges', value: hir});
  if (env.config.assertValidMutableRanges) {
    assertValidMutableRanges(hir);
  }
  if (env.config.validateRefAccessDuringRender) {
    validateNoRefAccessInRender(hir);
  }
  if (env.config.validateNoSetStateInRender) {
    validateNoSetStateInRender(hir);
  }
  if (env.config.validateNoSetStateInPassiveEffects) {
    validateNoSetStateInPassiveEffects(hir);
  }
  if (env.config.validateNoJSXInTryStatements) {
    validateNoJSXInTryStatement(hir);
  }
  inferReactivePlaces(hir);
  yield log({kind: 'hir', name: 'InferReactivePlaces', value: hir});
  rewriteInstructionKindsBasedOnReassignment(hir);
  yield log({
    kind: 'hir',
    name: 'RewriteInstructionKindsBasedOnReassignment',
    value: hir,
  });
  propagatePhiTypes(hir);
  yield log({kind: 'hir', name: 'PropagatePhiTypes', value: hir});
  inferReactiveScopeVariables(hir);
  yield log({kind: 'hir', name: 'InferReactiveScopeVariables', value: hir});
  const fbtOperands = memoizeFbtAndMacroOperandsInSameScope(hir);
  yield log({
    kind: 'hir',
    name: 'MemoizeFbtAndMacroOperandsInSameScope',
    value: hir,
  });
  if (env.config.enableJsxOutlining) {
    outlineJSX(hir);
  }
  if (env.config.enableFunctionOutlining) {
    outlineFunctions(hir, fbtOperands);
    yield log({kind: 'hir', name: 'OutlineFunctions', value: hir});
  }
  alignMethodCallScopes(hir);
  yield log({kind: 'hir', name: 'AlignMethodCallScopes', value: hir});
  alignObjectMethodScopes(hir);
  yield log({kind: 'hir', name: 'AlignObjectMethodScopes', value: hir});
  pruneUnusedLabelsHIR(hir);
  yield log({kind: 'hir', name: 'PruneUnusedLabelsHIR', value: hir});
  alignReactiveScopesToBlockScopesHIR(hir);
  yield log({
    kind: 'hir',
    name: 'AlignReactiveScopesToBlockScopesHIR',
    value: hir,
  });
  mergeOverlappingReactiveScopesHIR(hir);
  yield log({
    kind: 'hir',
    name: 'MergeOverlappingReactiveScopesHIR',
    value: hir,
  });
  assertValidBlockNesting(hir);
  buildReactiveScopeTerminalsHIR(hir);
  yield log({kind: 'hir', name: 'BuildReactiveScopeTerminalsHIR', value: hir});
  assertValidBlockNesting(hir);
  flattenReactiveLoopsHIR(hir);
  yield log({kind: 'hir', name: 'FlattenReactiveLoopsHIR', value: hir});
  flattenScopesWithHooksOrUseHIR(hir);
  yield log({kind: 'hir', name: 'FlattenScopesWithHooksOrUseHIR', value: hir});
  assertTerminalSuccessorsExist(hir);
  assertTerminalPredsExist(hir);
  propagateScopeDependenciesHIR(hir);
  yield log({kind: 'hir', name: 'PropagateScopeDependenciesHIR', value: hir});
  if (env.config.inferEffectDependencies) {
    inferEffectDependencies(hir);
  }
  if (env.config.inlineJsxTransform) {
    inlineJsxTransform(hir, env.config.inlineJsxTransform);
    yield log({kind: 'hir', name: 'inlineJsxTransform', value: hir});
  }
  const reactiveFunction = buildReactiveFunction(hir);
  yield log({
    kind: 'reactive',
    name: 'BuildReactiveFunction',
    value: reactiveFunction,
  });
  assertWellFormedBreakTargets(reactiveFunction);
  pruneUnusedLabels(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneUnusedLabels',
    value: reactiveFunction,
  });
  assertScopeInstructionsWithinScopes(reactiveFunction);
  pruneNonEscapingScopes(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneNonEscapingScopes',
    value: reactiveFunction,
  });
  pruneNonReactiveDependencies(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneNonReactiveDependencies',
    value: reactiveFunction,
  });
  pruneUnusedScopes(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneUnusedScopes',
    value: reactiveFunction,
  });
  mergeReactiveScopesThatInvalidateTogether(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'MergeReactiveScopesThatInvalidateTogether',
    value: reactiveFunction,
  });
  pruneAlwaysInvalidatingScopes(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneAlwaysInvalidatingScopes',
    value: reactiveFunction,
  });
  if (env.config.enableChangeDetectionForDebugging != null) {
    pruneInitializationDependencies(reactiveFunction);
    yield log({
      kind: 'reactive',
      name: 'PruneInitializationDependencies',
      value: reactiveFunction,
    });
  }
  propagateEarlyReturns(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PropagateEarlyReturns',
    value: reactiveFunction,
  });
  pruneUnusedLValues(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneUnusedLValues',
    value: reactiveFunction,
  });
  promoteUsedTemporaries(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PromoteUsedTemporaries',
    value: reactiveFunction,
  });
  extractScopeDeclarationsFromDestructuring(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'ExtractScopeDeclarationsFromDestructuring',
    value: reactiveFunction,
  });
  stabilizeBlockIds(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'StabilizeBlockIds',
    value: reactiveFunction,
  });
  const uniqueIdentifiers = renameVariables(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'RenameVariables',
    value: reactiveFunction,
  });
  pruneHoistedContexts(reactiveFunction);
  yield log({
    kind: 'reactive',
    name: 'PruneHoistedContexts',
    value: reactiveFunction,
  });
  if (env.config.validateMemoizedEffectDependencies) {
    validateMemoizedEffectDependencies(reactiveFunction);
  }
  if (
    env.config.enablePreserveExistingMemoizationGuarantees ||
    env.config.validatePreserveExistingMemoizationGuarantees
  ) {
    validatePreservedManualMemoization(reactiveFunction);
  }
  const ast = codegenFunction(reactiveFunction, {
    uniqueIdentifiers: uniqueIdentifiers,
    fbtOperands: fbtOperands,
  }).unwrap();
  yield log({kind: 'ast', name: 'Codegen', value: ast});
  for (const outlined of ast.outlined) {
    yield log({kind: 'ast', name: 'Codegen (outlined)', value: outlined.fn});
  }
  if (env.config.throwUnknownException__testonly) {
    throw new Error('unexpected error');
  }
  return ast;
}
function compileFn(
  func,
  config,
  fnType,
  useMemoCacheIdentifier,
  logger,
  filename,
  code
) {
  let generator = run(
    func,
    config,
    fnType,
    useMemoCacheIdentifier,
    logger,
    filename,
    code
  );
  while (true) {
    const next = generator.next();
    if (next.done) {
      return next.value;
    }
  }
}
function log(value) {
  switch (value.kind) {
    case 'ast': {
      logCodegenFunction(value.name, value.value);
      break;
    }
    case 'hir': {
      logHIRFunction(value.name, value.value);
      break;
    }
    case 'reactive': {
      logReactiveFunction(value.name, value.value);
      break;
    }
    case 'debug': {
      logDebug(value.name, value.value);
      break;
    }
    default: {
      assertExhaustive(value, 'Unexpected compilation kind');
    }
  }
  return value;
}
function* runPlayground(func, config, fnType) {
  const ast = yield* run(func, config, fnType, '_c', null, null, null);
  return ast;
}
function isComponentDeclaration(node) {
  return Object.prototype.hasOwnProperty.call(node, '__componentDeclaration');
}
function isHookDeclaration(node) {
  return Object.prototype.hasOwnProperty.call(node, '__hookDeclaration');
}
function filterSuppressionsThatAffectFunction(suppressionRanges, fn) {
  const suppressionsInScope = [];
  const fnNode = fn.node;
  for (const suppressionRange of suppressionRanges) {
    if (
      suppressionRange.disableComment.start == null ||
      fnNode.start == null ||
      fnNode.end == null
    ) {
      continue;
    }
    if (
      suppressionRange.disableComment.start > fnNode.start &&
      (suppressionRange.enableComment === null ||
        (suppressionRange.enableComment.end != null &&
          suppressionRange.enableComment.end < fnNode.end))
    ) {
      suppressionsInScope.push(suppressionRange);
    }
    if (
      suppressionRange.disableComment.start < fnNode.start &&
      (suppressionRange.enableComment === null ||
        (suppressionRange.enableComment.end != null &&
          suppressionRange.enableComment.end > fnNode.end))
    ) {
      suppressionsInScope.push(suppressionRange);
    }
  }
  return suppressionsInScope;
}
function findProgramSuppressions(programComments, ruleNames, flowSuppressions) {
  const suppressionRanges = [];
  let disableComment = null;
  let enableComment = null;
  let source = null;
  const rulePattern = `(${ruleNames.join('|')})`;
  const disableNextLinePattern = new RegExp(
    `eslint-disable-next-line ${rulePattern}`
  );
  const disablePattern = new RegExp(`eslint-disable ${rulePattern}`);
  const enablePattern = new RegExp(`eslint-enable ${rulePattern}`);
  const flowSuppressionPattern = new RegExp(
    '\\$(FlowFixMe\\w*|FlowExpectedError|FlowIssue)\\[react\\-rule'
  );
  for (const comment of programComments) {
    if (comment.start == null || comment.end == null) {
      continue;
    }
    if (disableComment == null && disableNextLinePattern.test(comment.value)) {
      disableComment = comment;
      enableComment = comment;
      source = 'Eslint';
    }
    if (
      flowSuppressions &&
      disableComment == null &&
      flowSuppressionPattern.test(comment.value)
    ) {
      disableComment = comment;
      enableComment = comment;
      source = 'Flow';
    }
    if (disablePattern.test(comment.value)) {
      disableComment = comment;
      source = 'Eslint';
    }
    if (enablePattern.test(comment.value) && source === 'Eslint') {
      enableComment = comment;
    }
    if (disableComment != null && source != null) {
      suppressionRanges.push({
        disableComment: disableComment,
        enableComment: enableComment,
        source: source,
      });
      disableComment = null;
      enableComment = null;
      source = null;
    }
  }
  return suppressionRanges;
}
function suppressionsToCompilerError(suppressionRanges) {
  var _a;
  CompilerError.invariant(suppressionRanges.length !== 0, {
    reason: `Expected at least suppression comment source range`,
    loc: GeneratedSource,
  });
  const error = new CompilerError();
  for (const suppressionRange of suppressionRanges) {
    if (
      suppressionRange.disableComment.start == null ||
      suppressionRange.disableComment.end == null
    ) {
      continue;
    }
    let reason, suggestion;
    switch (suppressionRange.source) {
      case 'Eslint':
        reason =
          'React Compiler has skipped optimizing this component because one or more React ESLint rules were disabled';
        suggestion =
          'Remove the ESLint suppression and address the React error';
        break;
      case 'Flow':
        reason =
          'React Compiler has skipped optimizing this component because one or more React rule violations were reported by Flow';
        suggestion = 'Remove the Flow suppression and address the React error';
        break;
      default:
        assertExhaustive(
          suppressionRange.source,
          'Unhandled suppression source'
        );
    }
    error.pushErrorDetail(
      new CompilerErrorDetail({
        reason: `${reason}. React Compiler only works when your components follow all the rules of React, disabling them may result in unexpected or incorrect behavior`,
        description: suppressionRange.disableComment.value.trim(),
        severity: exports.ErrorSeverity.InvalidReact,
        loc:
          (_a = suppressionRange.disableComment.loc) !== null && _a !== void 0
            ? _a
            : null,
        suggestions: [
          {
            description: suggestion,
            range: [
              suppressionRange.disableComment.start,
              suppressionRange.disableComment.end,
            ],
            op: exports.CompilerSuggestionOperation.Remove,
          },
        ],
      })
    );
  }
  return error;
}
const OPT_IN_DIRECTIVES = new Set(['use forget', 'use memo']);
const OPT_OUT_DIRECTIVES = new Set(['use no forget', 'use no memo']);
function findDirectiveEnablingMemoization(directives) {
  return directives.filter(directive =>
    OPT_IN_DIRECTIVES.has(directive.value.value)
  );
}
function findDirectiveDisablingMemoization(directives) {
  return directives.filter(directive =>
    OPT_OUT_DIRECTIVES.has(directive.value.value)
  );
}
function isCriticalError(err) {
  return !(err instanceof CompilerError) || err.isCritical();
}
function isConfigError(err) {
  if (err instanceof CompilerError) {
    return err.details.some(
      detail => detail.severity === exports.ErrorSeverity.InvalidConfig
    );
  }
  return false;
}
function logError(err, pass, fnLoc) {
  var _a, _b;
  if (pass.opts.logger) {
    if (err instanceof CompilerError) {
      for (const detail of err.details) {
        pass.opts.logger.logEvent(pass.filename, {
          kind: 'CompileError',
          fnLoc: fnLoc,
          detail: detail.options,
        });
      }
    } else {
      let stringifiedError;
      if (err instanceof Error) {
        stringifiedError =
          (_a = err.stack) !== null && _a !== void 0 ? _a : err.message;
      } else {
        stringifiedError =
          (_b = err === null || err === void 0 ? void 0 : err.toString()) !==
            null && _b !== void 0
            ? _b
            : '[ null ]';
      }
      pass.opts.logger.logEvent(pass.filename, {
        kind: 'PipelineError',
        fnLoc: fnLoc,
        data: stringifiedError,
      });
    }
  }
}
function handleError(err, pass, fnLoc) {
  logError(err, pass, fnLoc);
  if (
    pass.opts.panicThreshold === 'all_errors' ||
    (pass.opts.panicThreshold === 'critical_errors' && isCriticalError(err)) ||
    isConfigError(err)
  ) {
    throw err;
  }
}
function createNewFunctionNode(originalFn, compiledFn) {
  var _a, _b, _c;
  let transformedFn;
  switch (originalFn.node.type) {
    case 'FunctionDeclaration': {
      const fn = {
        type: 'FunctionDeclaration',
        id: compiledFn.id,
        loc: (_a = originalFn.node.loc) !== null && _a !== void 0 ? _a : null,
        async: compiledFn.async,
        generator: compiledFn.generator,
        params: compiledFn.params,
        body: compiledFn.body,
      };
      transformedFn = fn;
      break;
    }
    case 'ArrowFunctionExpression': {
      const fn = {
        type: 'ArrowFunctionExpression',
        loc: (_b = originalFn.node.loc) !== null && _b !== void 0 ? _b : null,
        async: compiledFn.async,
        generator: compiledFn.generator,
        params: compiledFn.params,
        expression: originalFn.node.expression,
        body: compiledFn.body,
      };
      transformedFn = fn;
      break;
    }
    case 'FunctionExpression': {
      const fn = {
        type: 'FunctionExpression',
        id: compiledFn.id,
        loc: (_c = originalFn.node.loc) !== null && _c !== void 0 ? _c : null,
        async: compiledFn.async,
        generator: compiledFn.generator,
        params: compiledFn.params,
        body: compiledFn.body,
      };
      transformedFn = fn;
      break;
    }
    default: {
      assertExhaustive(
        originalFn.node,
        `Creating unhandled function: ${originalFn.node}`
      );
    }
  }
  ALREADY_COMPILED.add(transformedFn);
  return transformedFn;
}
function insertNewOutlinedFunctionNode(program, originalFn, compiledFn) {
  var _a, _b, _c;
  switch (originalFn.type) {
    case 'FunctionDeclaration': {
      return originalFn.insertAfter(
        createNewFunctionNode(originalFn, compiledFn)
      )[0];
    }
    case 'ArrowFunctionExpression':
    case 'FunctionExpression': {
      const fn = {
        type: 'FunctionDeclaration',
        id: compiledFn.id,
        loc: (_a = originalFn.node.loc) !== null && _a !== void 0 ? _a : null,
        async: compiledFn.async,
        generator: compiledFn.generator,
        params: compiledFn.params,
        body: compiledFn.body,
      };
      const insertedFuncDecl = program.pushContainer('body', [fn])[0];
      CompilerError.invariant(insertedFuncDecl.isFunctionDeclaration(), {
        reason: 'Expected inserted function declaration',
        description: `Got: ${insertedFuncDecl}`,
        loc:
          (_c =
            (_b = insertedFuncDecl.node) === null || _b === void 0
              ? void 0
              : _b.loc) !== null && _c !== void 0
            ? _c
            : null,
      });
      return insertedFuncDecl;
    }
    default: {
      assertExhaustive(
        originalFn,
        `Inserting unhandled function: ${originalFn}`
      );
    }
  }
}
const ALREADY_COMPILED = new (
  WeakSet !== null && WeakSet !== void 0 ? WeakSet : Set
)();
const DEFAULT_ESLINT_SUPPRESSIONS = [
  'react-hooks/exhaustive-deps',
  'react-hooks/rules-of-hooks',
];
function isFilePartOfSources(sources, filename) {
  if (typeof sources === 'function') {
    return sources(filename);
  }
  for (const prefix of sources) {
    if (filename.indexOf(prefix) !== -1) {
      return true;
    }
  }
  return false;
}
function compileProgram(program, pass) {
  var _a, _b;
  if (shouldSkipCompilation(program, pass)) {
    return;
  }
  const environment = pass.opts.environment;
  const restrictedImportsErr = validateRestrictedImports(program, environment);
  if (restrictedImportsErr) {
    handleError(restrictedImportsErr, pass, null);
    return;
  }
  const useMemoCacheIdentifier = program.scope.generateUidIdentifier('c');
  const suppressions = findProgramSuppressions(
    pass.comments,
    (_a = pass.opts.eslintSuppressionRules) !== null && _a !== void 0
      ? _a
      : DEFAULT_ESLINT_SUPPRESSIONS,
    pass.opts.flowSuppressions
  );
  const queue = [];
  const compiledFns = [];
  const traverseFunction = (fn, pass) => {
    const fnType = getReactFunctionType(fn, pass, environment);
    if (fnType === null || ALREADY_COMPILED.has(fn.node)) {
      return;
    }
    ALREADY_COMPILED.add(fn.node);
    fn.skip();
    queue.push({kind: 'original', fn: fn, fnType: fnType});
  };
  program.traverse(
    {
      ClassDeclaration(node) {
        node.skip();
        return;
      },
      ClassExpression(node) {
        node.skip();
        return;
      },
      FunctionDeclaration: traverseFunction,
      FunctionExpression: traverseFunction,
      ArrowFunctionExpression: traverseFunction,
    },
    Object.assign(Object.assign({}, pass), {
      opts: Object.assign(Object.assign({}, pass.opts), pass.opts),
      filename: (_b = pass.filename) !== null && _b !== void 0 ? _b : null,
    })
  );
  const processFn = (fn, fnType) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    let optInDirectives = [];
    let optOutDirectives = [];
    if (fn.node.body.type === 'BlockStatement') {
      optInDirectives = findDirectiveEnablingMemoization(
        fn.node.body.directives
      );
      optOutDirectives = findDirectiveDisablingMemoization(
        fn.node.body.directives
      );
    }
    let compiledFn;
    try {
      const suppressionsInFunction = filterSuppressionsThatAffectFunction(
        suppressions,
        fn
      );
      if (suppressionsInFunction.length > 0) {
        const lintError = suppressionsToCompilerError(suppressionsInFunction);
        if (optOutDirectives.length > 0) {
          logError(
            lintError,
            pass,
            (_a = fn.node.loc) !== null && _a !== void 0 ? _a : null
          );
        } else {
          handleError(
            lintError,
            pass,
            (_b = fn.node.loc) !== null && _b !== void 0 ? _b : null
          );
        }
        return null;
      }
      compiledFn = compileFn(
        fn,
        environment,
        fnType,
        useMemoCacheIdentifier.name,
        pass.opts.logger,
        pass.filename,
        pass.code
      );
      (_c = pass.opts.logger) === null || _c === void 0
        ? void 0
        : _c.logEvent(pass.filename, {
            kind: 'CompileSuccess',
            fnLoc: (_d = fn.node.loc) !== null && _d !== void 0 ? _d : null,
            fnName:
              (_f =
                (_e = compiledFn.id) === null || _e === void 0
                  ? void 0
                  : _e.name) !== null && _f !== void 0
                ? _f
                : null,
            memoSlots: compiledFn.memoSlotsUsed,
            memoBlocks: compiledFn.memoBlocks,
            memoValues: compiledFn.memoValues,
            prunedMemoBlocks: compiledFn.prunedMemoBlocks,
            prunedMemoValues: compiledFn.prunedMemoValues,
          });
    } catch (err) {
      if (fn.node.body.type === 'BlockStatement') {
        if (optOutDirectives.length > 0) {
          logError(
            err,
            pass,
            (_g = fn.node.loc) !== null && _g !== void 0 ? _g : null
          );
          return null;
        }
      }
      handleError(
        err,
        pass,
        (_h = fn.node.loc) !== null && _h !== void 0 ? _h : null
      );
      return null;
    }
    if (optInDirectives.length > 0) {
      return compiledFn;
    } else if (pass.opts.compilationMode === 'annotation') {
      return null;
    }
    if (pass.opts.ignoreUseNoForget === false && optOutDirectives.length > 0) {
      for (const directive of optOutDirectives) {
        (_j = pass.opts.logger) === null || _j === void 0
          ? void 0
          : _j.logEvent(pass.filename, {
              kind: 'CompileSkip',
              fnLoc:
                (_k = fn.node.body.loc) !== null && _k !== void 0 ? _k : null,
              reason: `Skipped due to '${directive.value.value}' directive.`,
              loc: (_l = directive.loc) !== null && _l !== void 0 ? _l : null,
            });
      }
      return null;
    }
    if (!pass.opts.noEmit) {
      return compiledFn;
    }
    return null;
  };
  while (queue.length !== 0) {
    const current = queue.shift();
    const compiled = processFn(current.fn, current.fnType);
    if (compiled === null) {
      continue;
    }
    for (const outlined of compiled.outlined) {
      CompilerError.invariant(outlined.fn.outlined.length === 0, {
        reason: 'Unexpected nested outlined functions',
        loc: outlined.fn.loc,
      });
      const fn = insertNewOutlinedFunctionNode(
        program,
        current.fn,
        outlined.fn
      );
      fn.skip();
      ALREADY_COMPILED.add(fn.node);
      if (outlined.type !== null) {
        queue.push({kind: 'outlined', fn: fn, fnType: outlined.type});
      }
    }
    compiledFns.push({
      kind: current.kind,
      compiledFn: compiled,
      originalFn: current.fn,
    });
  }
  const moduleScopeOptOutDirectives = findDirectiveDisablingMemoization(
    program.node.directives
  );
  if (moduleScopeOptOutDirectives.length > 0) {
    return;
  }
  if (pass.opts.gating != null) {
    const error = checkFunctionReferencedBeforeDeclarationAtTopLevel(
      program,
      compiledFns.map(result => result.originalFn)
    );
    if (error) {
      handleError(error, pass, null);
      return;
    }
  }
  const hasLoweredContextAccess = compiledFns.some(
    c => c.compiledFn.hasLoweredContextAccess
  );
  const externalFunctions = [];
  let gating = null;
  try {
    if (pass.opts.gating != null) {
      gating = tryParseExternalFunction(pass.opts.gating);
      externalFunctions.push(gating);
    }
    const lowerContextAccess = environment.lowerContextAccess;
    if (lowerContextAccess && hasLoweredContextAccess) {
      externalFunctions.push(lowerContextAccess);
    }
    const enableEmitInstrumentForget = environment.enableEmitInstrumentForget;
    if (enableEmitInstrumentForget != null) {
      externalFunctions.push(enableEmitInstrumentForget.fn);
      if (enableEmitInstrumentForget.gating != null) {
        externalFunctions.push(enableEmitInstrumentForget.gating);
      }
    }
    if (environment.enableEmitFreeze != null) {
      externalFunctions.push(environment.enableEmitFreeze);
    }
    if (environment.enableEmitHookGuards != null) {
      externalFunctions.push(environment.enableEmitHookGuards);
    }
    if (environment.enableChangeDetectionForDebugging != null) {
      externalFunctions.push(environment.enableChangeDetectionForDebugging);
    }
  } catch (err) {
    handleError(err, pass, null);
    return;
  }
  for (const result of compiledFns) {
    const {kind: kind, originalFn: originalFn, compiledFn: compiledFn} = result;
    const transformedFn = createNewFunctionNode(originalFn, compiledFn);
    if (gating != null && kind === 'original') {
      insertGatedFunctionDeclaration(originalFn, transformedFn, gating);
    } else {
      originalFn.replaceWith(transformedFn);
    }
  }
  if (compiledFns.length > 0) {
    let needsMemoCacheFunctionImport = false;
    for (const fn of compiledFns) {
      if (fn.compiledFn.memoSlotsUsed > 0) {
        needsMemoCacheFunctionImport = true;
        break;
      }
    }
    if (needsMemoCacheFunctionImport) {
      updateMemoCacheFunctionImport(
        program,
        getReactCompilerRuntimeModule(pass.opts),
        useMemoCacheIdentifier.name
      );
    }
    addImportsToProgram(program, externalFunctions);
  }
}
function shouldSkipCompilation(program, pass) {
  if (pass.opts.sources) {
    if (pass.filename === null) {
      const error = new CompilerError();
      error.pushErrorDetail(
        new CompilerErrorDetail({
          reason: `Expected a filename but found none.`,
          description:
            "When the 'sources' config options is specified, the React compiler will only compile files with a name",
          severity: exports.ErrorSeverity.InvalidConfig,
          loc: null,
        })
      );
      handleError(error, pass, null);
      return true;
    }
    if (!isFilePartOfSources(pass.opts.sources, pass.filename)) {
      return true;
    }
  }
  if (
    hasMemoCacheFunctionImport(
      program,
      getReactCompilerRuntimeModule(pass.opts)
    )
  ) {
    return true;
  }
  return false;
}
function getReactFunctionType(fn, pass, environment) {
  var _a, _b;
  const hookPattern = environment.hookPattern;
  if (fn.node.body.type === 'BlockStatement') {
    if (findDirectiveEnablingMemoization(fn.node.body.directives).length > 0)
      return (_a = getComponentOrHookLike(fn, hookPattern)) !== null &&
        _a !== void 0
        ? _a
        : 'Other';
  }
  let componentSyntaxType = null;
  if (fn.isFunctionDeclaration()) {
    if (isComponentDeclaration(fn.node)) {
      componentSyntaxType = 'Component';
    } else if (isHookDeclaration(fn.node)) {
      componentSyntaxType = 'Hook';
    }
  }
  switch (pass.opts.compilationMode) {
    case 'annotation': {
      return null;
    }
    case 'infer': {
      return componentSyntaxType !== null && componentSyntaxType !== void 0
        ? componentSyntaxType
        : getComponentOrHookLike(fn, hookPattern);
    }
    case 'syntax': {
      return componentSyntaxType;
    }
    case 'all': {
      if (fn.scope.getProgramParent() !== fn.scope.parent) {
        return null;
      }
      return (_b = getComponentOrHookLike(fn, hookPattern)) !== null &&
        _b !== void 0
        ? _b
        : 'Other';
    }
    default: {
      assertExhaustive(
        pass.opts.compilationMode,
        `Unexpected compilationMode \`${pass.opts.compilationMode}\``
      );
    }
  }
}
function hasMemoCacheFunctionImport(program, moduleName) {
  let hasUseMemoCache = false;
  program.traverse({
    ImportSpecifier(path) {
      const imported = path.get('imported');
      let importedName = null;
      if (imported.isIdentifier()) {
        importedName = imported.node.name;
      } else if (imported.isStringLiteral()) {
        importedName = imported.node.value;
      }
      if (
        importedName === 'c' &&
        path.parentPath.isImportDeclaration() &&
        path.parentPath.get('source').node.value === moduleName
      ) {
        hasUseMemoCache = true;
      }
    },
  });
  return hasUseMemoCache;
}
function isHookName(s, hookPattern) {
  if (hookPattern !== null) {
    return new RegExp(hookPattern).test(s);
  }
  return /^use[A-Z0-9]/.test(s);
}
function isHook(path, hookPattern) {
  if (path.isIdentifier()) {
    return isHookName(path.node.name, hookPattern);
  } else if (
    path.isMemberExpression() &&
    !path.node.computed &&
    isHook(path.get('property'), hookPattern)
  ) {
    const obj = path.get('object').node;
    const isPascalCaseNameSpace = /^[A-Z].*/;
    return obj.type === 'Identifier' && isPascalCaseNameSpace.test(obj.name);
  } else {
    return false;
  }
}
function isComponentName(path) {
  return path.isIdentifier() && /^[A-Z]/.test(path.node.name);
}
function isReactAPI(path, functionName) {
  const node = path.node;
  return (
    (node.type === 'Identifier' && node.name === functionName) ||
    (node.type === 'MemberExpression' &&
      node.object.type === 'Identifier' &&
      node.object.name === 'React' &&
      node.property.type === 'Identifier' &&
      node.property.name === functionName)
  );
}
function isForwardRefCallback(path) {
  return !!(
    path.parentPath.isCallExpression() &&
    path.parentPath.get('callee').isExpression() &&
    isReactAPI(path.parentPath.get('callee'), 'forwardRef')
  );
}
function isMemoCallback(path) {
  return (
    path.parentPath.isCallExpression() &&
    path.parentPath.get('callee').isExpression() &&
    isReactAPI(path.parentPath.get('callee'), 'memo')
  );
}
function isValidPropsAnnotation(annot) {
  if (annot == null) {
    return true;
  } else if (annot.type === 'TSTypeAnnotation') {
    switch (annot.typeAnnotation.type) {
      case 'TSArrayType':
      case 'TSBigIntKeyword':
      case 'TSBooleanKeyword':
      case 'TSConstructorType':
      case 'TSFunctionType':
      case 'TSLiteralType':
      case 'TSNeverKeyword':
      case 'TSNumberKeyword':
      case 'TSStringKeyword':
      case 'TSSymbolKeyword':
      case 'TSTupleType':
        return false;
    }
    return true;
  } else if (annot.type === 'TypeAnnotation') {
    switch (annot.typeAnnotation.type) {
      case 'ArrayTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'EmptyTypeAnnotation':
      case 'FunctionTypeAnnotation':
      case 'NumberLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'SymbolTypeAnnotation':
      case 'ThisTypeAnnotation':
      case 'TupleTypeAnnotation':
        return false;
    }
    return true;
  } else if (annot.type === 'Noop') {
    return true;
  } else {
    assertExhaustive(annot, `Unexpected annotation node \`${annot}\``);
  }
}
function isValidComponentParams(params) {
  if (params.length === 0) {
    return true;
  } else if (params.length > 0 && params.length <= 2) {
    if (!isValidPropsAnnotation(params[0].node.typeAnnotation)) {
      return false;
    }
    if (params.length === 1) {
      return !params[0].isRestElement();
    } else if (params[1].isIdentifier()) {
      const {name: name} = params[1].node;
      return name.includes('ref') || name.includes('Ref');
    } else {
      return false;
    }
  }
  return false;
}
function getComponentOrHookLike(node, hookPattern) {
  const functionName = getFunctionName(node);
  if (functionName !== null && isComponentName(functionName)) {
    let isComponent =
      callsHooksOrCreatesJsx(node, hookPattern) &&
      isValidComponentParams(node.get('params')) &&
      !returnsNonNode(node);
    return isComponent ? 'Component' : null;
  } else if (functionName !== null && isHook(functionName, hookPattern)) {
    return callsHooksOrCreatesJsx(node, hookPattern) ? 'Hook' : null;
  }
  if (node.isFunctionExpression() || node.isArrowFunctionExpression()) {
    if (isForwardRefCallback(node) || isMemoCallback(node)) {
      return callsHooksOrCreatesJsx(node, hookPattern) ? 'Component' : null;
    }
  }
  return null;
}
function skipNestedFunctions(node) {
  return fn => {
    if (fn.node !== node.node) {
      fn.skip();
    }
  };
}
function callsHooksOrCreatesJsx(node, hookPattern) {
  let invokesHooks = false;
  let createsJsx = false;
  node.traverse({
    JSX() {
      createsJsx = true;
    },
    CallExpression(call) {
      const callee = call.get('callee');
      if (callee.isExpression() && isHook(callee, hookPattern)) {
        invokesHooks = true;
      }
    },
    ArrowFunctionExpression: skipNestedFunctions(node),
    FunctionExpression: skipNestedFunctions(node),
    FunctionDeclaration: skipNestedFunctions(node),
  });
  return invokesHooks || createsJsx;
}
function returnsNonNode(node) {
  let hasReturn = false;
  let returnsNonNode = false;
  node.traverse({
    ReturnStatement(ret) {
      hasReturn = true;
      const argument = ret.node.argument;
      if (argument == null) {
        returnsNonNode = true;
      } else {
        switch (argument.type) {
          case 'ObjectExpression':
          case 'ArrowFunctionExpression':
          case 'FunctionExpression':
          case 'BigIntLiteral':
          case 'ClassExpression':
          case 'NewExpression':
            returnsNonNode = true;
        }
      }
    },
    ArrowFunctionExpression: skipNestedFunctions(node),
    FunctionExpression: skipNestedFunctions(node),
    FunctionDeclaration: skipNestedFunctions(node),
  });
  return !hasReturn || returnsNonNode;
}
function getFunctionName(path) {
  if (path.isFunctionDeclaration()) {
    const id = path.get('id');
    if (id.isIdentifier()) {
      return id;
    }
    return null;
  }
  let id = null;
  const parent = path.parentPath;
  if (parent.isVariableDeclarator() && parent.get('init').node === path.node) {
    id = parent.get('id');
  } else if (
    parent.isAssignmentExpression() &&
    parent.get('right').node === path.node &&
    parent.get('operator') === '='
  ) {
    id = parent.get('left');
  } else if (
    parent.isProperty() &&
    parent.get('value').node === path.node &&
    !parent.get('computed') &&
    parent.get('key').isLVal()
  ) {
    id = parent.get('key');
  } else if (
    parent.isAssignmentPattern() &&
    parent.get('right').node === path.node &&
    !parent.get('computed')
  ) {
    id = parent.get('left');
  }
  if (id !== null && (id.isIdentifier() || id.isMemberExpression())) {
    return id;
  } else {
    return null;
  }
}
function checkFunctionReferencedBeforeDeclarationAtTopLevel(program, fns) {
  const fnIds = new Set(
    fns
      .map(fn => getFunctionName(fn))
      .filter(name => !!name && name.isIdentifier())
      .map(name => name.node)
  );
  const fnNames = new Map([...fnIds].map(id => [id.name, id]));
  const errors = new CompilerError();
  program.traverse({
    TypeAnnotation(path) {
      path.skip();
    },
    TSTypeAnnotation(path) {
      path.skip();
    },
    TypeAlias(path) {
      path.skip();
    },
    TSTypeAliasDeclaration(path) {
      path.skip();
    },
    Identifier(id) {
      var _a;
      const fn = fnNames.get(id.node.name);
      if (!fn) {
        return;
      }
      if (fnIds.has(id.node)) {
        fnIds.delete(id.node);
        fnNames.delete(id.node.name);
        return;
      }
      const scope = id.scope.getFunctionParent();
      if (scope === null) {
        errors.pushErrorDetail(
          new CompilerErrorDetail({
            reason: `Encountered a function used before its declaration, which breaks Forget's gating codegen due to hoisting`,
            description: `Rewrite the reference to ${fn.name} to not rely on hoisting to fix this issue`,
            loc: (_a = fn.loc) !== null && _a !== void 0 ? _a : null,
            suggestions: null,
            severity: exports.ErrorSeverity.Invariant,
          })
        );
      }
    },
  });
  return errors.details.length > 0 ? errors : null;
}
function getReactCompilerRuntimeModule(opts) {
  let moduleName = null;
  switch (opts.target) {
    case '17':
    case '18': {
      moduleName = 'react-compiler-runtime';
      break;
    }
    case '19': {
      moduleName = 'react/compiler-runtime';
      break;
    }
    default:
      CompilerError.invariant(moduleName != null, {
        reason: 'Expected target to already be validated',
        description: null,
        loc: null,
        suggestions: null,
      });
  }
  return moduleName;
}
function hasModule(name) {
  try {
    return !!require.resolve(name);
  } catch (error) {
    if (
      error.code === 'MODULE_NOT_FOUND' &&
      error.message.indexOf(name) !== -1
    ) {
      return false;
    }
    throw error;
  }
}
function pipelineUsesReanimatedPlugin(plugins) {
  if (Array.isArray(plugins)) {
    for (const plugin of plugins) {
      if (hasOwnProperty$1(plugin, 'key')) {
        const key = plugin.key;
        if (
          typeof key === 'string' &&
          key.indexOf('react-native-reanimated') !== -1
        ) {
          return true;
        }
      }
    }
  }
  return hasModule('react-native-reanimated');
}
function injectReanimatedFlag(options) {
  return Object.assign(Object.assign({}, options), {
    environment: Object.assign(Object.assign({}, options.environment), {
      enableCustomTypeDefinitionForReanimated: true,
    }),
  });
}
function BabelPluginReactCompiler(_babel) {
  return {
    name: 'react-forget',
    visitor: {
      Program(prog, pass) {
        var _a, _b;
        let opts = parsePluginOptions(pass.opts);
        const isDev =
          (typeof __DEV__ !== 'undefined' && __DEV__ === true) ||
          process.env['NODE_ENV'] === 'development';
        if (
          opts.enableReanimatedCheck === true &&
          pipelineUsesReanimatedPlugin(pass.file.opts.plugins)
        ) {
          opts = injectReanimatedFlag(opts);
        }
        if (isDev) {
          opts = Object.assign(Object.assign({}, opts), {
            environment: Object.assign(Object.assign({}, opts.environment), {
              enableResetCacheOnSourceFileChanges: true,
            }),
          });
        }
        compileProgram(prog, {
          opts: opts,
          filename: (_a = pass.filename) !== null && _a !== void 0 ? _a : null,
          comments:
            (_b = pass.file.ast.comments) !== null && _b !== void 0 ? _b : [],
          code: pass.file.code,
        });
      },
    },
  };
}
function runBabelPluginReactCompiler(
  text,
  file,
  language,
  options,
  includeAst = false
) {
  const ast = parse_1(text, {
    sourceFilename: file,
    plugins: [language, 'jsx'],
    sourceType: 'module',
  });
  const result = libExports.transformFromAstSync(ast, text, {
    ast: includeAst,
    filename: file,
    highlightCode: false,
    retainLines: true,
    plugins: [
      [BabelPluginReactCompiler, options],
      'babel-plugin-fbt',
      'babel-plugin-fbt-runtime',
    ],
    sourceType: 'module',
    configFile: false,
    babelrc: false,
  });
  invariant$1(
    (result === null || result === void 0 ? void 0 : result.code) != null,
    `Expected BabelPluginReactForget to codegen successfully, got: ${result}`
  );
  return result;
}
exports.CompilerError = CompilerError;
exports.CompilerErrorDetail = CompilerErrorDetail;
exports.OPT_IN_DIRECTIVES = OPT_IN_DIRECTIVES;
exports.OPT_OUT_DIRECTIVES = OPT_OUT_DIRECTIVES;
exports.compile = compileFn;
exports.compileProgram = compileProgram;
exports.default = BabelPluginReactCompiler;
exports.findDirectiveDisablingMemoization = findDirectiveDisablingMemoization;
exports.findDirectiveEnablingMemoization = findDirectiveEnablingMemoization;
exports.parseConfigPragmaForTests = parseConfigPragmaForTests;
exports.parsePluginOptions = parsePluginOptions;
exports.printHIR = printHIR;
exports.printReactiveFunction = printReactiveFunction;
exports.run = run;
exports.runBabelPluginReactCompiler = runBabelPluginReactCompiler;
exports.runPlayground = runPlayground;
exports.validateEnvironmentConfig = validateEnvironmentConfig;
